﻿/*!@license
* Infragistics.Web.ClientUI Combo 14.1.20141.2249
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends on:
* jquery-1.4.4.js
* jquery.ui.core.js
* jquery.ui.widget.js
* infragistics.util.js
* infragistics.dataSource.js
*
* Example to use:
*	<script type="text/javascript">
*	$(function () {
*		$('#combo1').igCombo();
*	});
*	</script>
*	<input id="combo1" />
*/

/*global jQuery, setTimeout, setInterval, clearInterval, alert, document, window*/
(function ($) {
	var _aNull = function (v, nan) {
		return v === null || v === undefined || (nan && typeof v === 'number' && isNaN(v));
	}, _toPx = function (val) {
		if (!val) {
			return 0;
		}
		if (typeof val === 'number') {
			return val;
		}
		val = val.toString();
		// test for %, em, mm, pt, in, cm
		val = val.match(/[e%mitc]/i) ? 0 : parseFloat(val);
		return isNaN(val) ? 0 : Math.floor(val + 0.5);
	}, _px = function (elem, css) {
		// returns px value of style attribute
		return _toPx(elem.css(css));
	}, _notab = function (elem) {
		return elem.attr('tabIndex', -1).css('outline', 0).attr('unselectable', 'on');
	}, _stop = function (e) {
		try {
			e.preventDefault();
			e.stopPropagation();
		} catch (ex) { }
	}, _equals = function (o1, o2) {
		return o1 === o2 || (o1 && o2 && o1.getTime && o2.getTime && o1.getTime() === o2.getTime());
	}, _now = function () {
		return new Date().getTime();
	}, _offset = function (e, xy) {
		return $.ig.util ? $.ig.util.offset(e, xy) : (xy || (e ? e.offset() : null));
	}, _listIDShift = 100, _cascWait;
	/*
		igCombo is a widget based on jQuery UI that provides ability to edit text and show drop-down list.
		Drop-down list supports multiple selection, filtering, templating, rendering matching items, active item, etc.
		Editing of field supports auto-complete, editing multiple items, synchronization with selection in drop-down list, clear button, etc.
	*/
	$.widget('ui.igCombo', {
		options: {
			/* type="string" Gets sets height of combo. The numeric and string values (valid html units for size) are supported. It includes %, px, em and other units. */
			height: null,
			/* type="string" Gets sets width of combo. The numeric and string values (valid html units for size) are supported. It includes %, px, em and other units. */
			width: null,
			/* type="number" Gets sets tabIndex for field of combo. */
			tabIndex: null,
			/* type="number" Gets sets duration of show drop-down list animation in milliseconds. */
			animationShowDuration: 100,
			/* type="number" Gets sets duration of hide drop-down list animation in milliseconds. */
			animationHideDuration: 50,
			/* type="bool" Gets sets style.display "block" or "inline-block" applied to main/outer html element. */
			enableDisplayBlock: false,
			/* type="editable|dropdown|readonlylist|readonly|0|1|2|3" Sets gets functionality mode.
				editable type="string" Allows to modify value by edit field and drop-down list.
				dropdown type="string" Allows to modify value by drop-down list only.
				readonlylist type="string" Allows to open list, but does not allow any changes in field or selection in drop-down list. If selection is not set, then first item in dataSource is automatically selected.
				readonly type="string" Does not allow to open list or change value in field. If selection is not set, then first item in dataSource is automatically selected.
				0 type="number" Same as editable.
				1 type="number" Same as dropdown.
				2 type="number" Same as readonlylist.
				3 type="number" Same as readonly.
			*/
			mode: 'editable',
			/* type="bool" Sets gets ability to show drop-down list when combo gets focus. */
			dropDownOnFocus: false,
			/* type="multi|contains|startsWith|full|null" Gets sets condition used for rendering of matching parts in items of drop-down list.
				Note: that option is not related to "filteringType" and "filteringCondition" options.
				multi type="string" multiple matches in a single item are rendered
				contains type="string" match at any position in item is rendered
				startsWith type="string" only match which starts from the beginning of text is rendered
				full type="string" only fully matched items are rendered
				null type="object" matches are not rendered
			*/
			renderMatchItems: 'multi',
			/* type="bool" Gets sets ability to use case sensitive or ignore case searching for matches defined by "renderMatchItems" and "filteringCondition" options */
			caseSensitive: false,
			/* type="string" Gets sets condition used for filtering.
				Notes:
				If the "autoComplete" option is enabled, then the "startsWith" is used regardless of value for this option.
				If "parentComboKey" option is set, then data is filtered internally, therefore, filtering while changing text in editor is not available.
			*/
			filteringCondition: 'contains',
			/* type="remote|local|none|null" Gets sets type of filtering.
				Notes:
				If "parentComboKey" option is set, then data is filtered internally, therefore, filtering while changing text in editor is not available; though, that option will still define type of filtering used by cascading functionality.
				If this option is set to "remote", then the "css.waitFiltering" is applied to combo and its drop-down list.
				remote type="string" filtering is performed by server
				local type="string" filtering is performed by $.ig.DataSource
				none type="string" filtering is disabled
				null type="object" filtering is disabled
			*/
			filteringType: null,
			/* type="string" Gets sets url key name that specifies how the remote filtering expressions will be encoded for remote requests, e.g. &filter('col') = startsWith. Default is OData */
			filterExprUrlKey: null,
			/* type="bool" Gets sets ability to autocomplete field from matching item in list.
				Note: if "autoComplete" option is enabled, then the "startsWith" is used for "filteringCondition" option */
			autoComplete: false,
			/* type="string" Gets sets format which is applied to items in list. Values null or false will disable format.
				Value "auto" or true will use automatic format for Date and number objects.
				Value null or false will disable automatic format.
				Custom values can be something like "currency", "percent", "dateLong", "time", "MMM-dd-yyyy H:mm tt", etc.
				However, custom format should be valid for a specific data type in "textKey" column.
			*/
			format: true,
			/* type="array" Gets sets list of selected items. It should contain array of objects.
				Each object should contain the member "index" equals to the index of selected item or the member "value" equals to value of item in dataSource in "valueKey" column.
				The member "text" contains value of item in "textKey" column.
				Missing values are filled automatically while rendering list items and on other actions. If application set more than one member, then it is responsible for match.
				Note: that option is supported only for currently available list of items. When load-on-demand or filtering is enabled, then attempt to select not loaded item will fail.
			*/
			selectedItems: [ {
				/* type="number" optional="true" Index of item in list. Value should be larger than -1 and less than number of items in list (rows in  dataSource)  */
				index: -1,
				/* type="object" optional="true" Value of cell in valueKey column for index. */
				value: null,
				/* type="string" optional="true" Value of cell in textKey column for index. */
				text: null
			} ],
			/* type="null|false|0|off|true|1|on|2|onWithCheckboxes" Gets sets ability to select multiple items in list and enter multiple items in field which are separated by the 'itemSeparator'.
				null type="object" multiselection is disabled
				false type="bool" multiselection is disabled
				0 type="number" multiselection is disabled
				off type="string" multiselection is disabled
				true type="bool" multiselection is enabled
				1 type="number" multiselection is enabled
				on type="string" multiselection is enabled
				2 type="number" multiselection is enabled and checkboxes are used for list items. Those checkboxes allow to add/remove selection without pressing Ctrl key on mouse click.
				onWithCheckboxes type="string" multiselection is enabled and checkboxes are used for list items. Those checkboxes allow to add/remove selection without pressing Ctrl key on mouse click.
			*/
			multiSelection: "off",
			/* type="bool" Gets sets ability to render focus/active item in drop-down list.
				Notes: If list had active item and it was closed and opened again, then active item is reset to the first selected item.
				It there is no selected items, then active item is not reset.
				If that option is disabled, then functionality becomes similar to the SELECT html element.
				For example, if list is opened then action keys like up/down arrows/page, home and end will change selected item instead of active item.
				If list is closed, then up/down arrow keys will change selected item and update text field for it.
				If list is opened, then text-changes in field will select matching item in list instead of activating it.
			*/
			enableActiveItem: true,
			/* type="bool" Gets sets ability to enter and keep custom value in field.
				Notes for enabled:
				1. The matching item in list becomes active, but not selected.
				2. If load on demand or dataBindOnOpen is enabled, then after the load, the matching item can be selected.
				3. If text option was not set, the selectedItems contain only one item and that item was not found in dataSource, then the "value" member of that selected item will be used as the custom text.
			*/
			allowCustomValue: false,
			/* type="bool" Preserves the selected items, even the text in the input is not available in the drop down items.
				This options is useful, when we have the 'allowCustomValue' option enabled. Then we can have a text in the input that is not related to the selected item or items.
				E.g. We select 2 drop down items, then we put custom text in the input "2 items selected", replacing existing text - both values separated with comma.
				If you don't want to loose the selected items on blur, 'clearSelectionOnBlur' should be set to false.
				If you want to clear the selected items when none of them is matching the text in the input, then set 'clearSelectionOnBlur' to true.
			*/
			clearSelectionOnBlur: false,
			/* type="bool" Gets sets ability to select active item in list by Space key.
				Note: if that options is enabled, then it will be not possible to type-in the Space character when list is opened.
			*/
			selectItemBySpaceKey: false,
			/* type="string" Gets sets separator between items in field. Note: that option has effect only when "multiSelection" option is enabled */
			itemSeparator: ', ',
			/* type="number" Gets sets width of drop-down list in pixels. If it is 0, then width of combo is used. */
			dropDownWidth: 0,
			/* type="number" Gets sets maximum height of drop-down list in pixels. */
			dropDownMaxHeight: 300,
			/* type="number" Gets sets minimum height of drop-down list in pixels. */
			dropDownMinHeight: 0,
			/* type="bool" Gets sets ability to append container of drop-down list to the body or to the parent of combo. */
			dropDownAsChild: false,
			/* type="bool" Gets sets ability to use virtual rendering for drop-down list.
				If that option is enabled, then only visible items are created and top edge of first visible item in list is alligned to the top edge of list.  */
			virtualization: false,
			/* type="bool" Gets sets visibility of drop-down button.  */
			showDropDownButton: true,
			/* type="bool" Gets sets ability to show a button which allows to clear field.
				Button is automatically hidden when field is empty and it automatically appears when field is not empty. */
			enableClearButton: true,
			/* type="string" Gets sets text of list item for condition when "filteringType" option is enabled and no match was found. That is an override for the $.ig.Combo.locale.noMatchFoundText. */
			noMatchFoundText: null,
			/* type="string" Gets sets title for html element which represend drop-down button. That is an override for the $.ig.Combo.locale.dropDownButtonTitle. */
			dropDownButtonTitle: null,
			/* type="string" Gets sets title for html element which represend clear button. That is an override for the $.ig.Combo.locale.clearButtonTitle. */
			clearButtonTitle: null,
			/* type="string" Gets sets text which appears in combo on initialization. If it is not set, then the value from target html element is used automatically.
				If selectedItems option is not set and allowCustomValue option is enabled, then first matching item in list will be selected.
				Notes: After initialization that option is reset to null. To get text in field, the text() method can be used.
			*/
			text: null,
			/* type="string" Gets sets template used to render an item in list. Notes:
				1. The jquery.tmpl.js of Microsoft is used and application should provide supported syntax for content.
				2. Template is rendered inside of LI html element.
				So, application should consider restriction for layout: do not use "block" html elements and in case of absolutely positioned elements,
				they should not overlap with checkbox icons.
			*/
			itemTemplate: null,
			/* type="string" Gets sets template used to render header in drop-down list. Template is rendered inside of DIV html element. */
			headerTemplate: null,
			/* type="string" Gets sets template used to render footer in drop-down list. Note: template is rendered inside of DIV html element. */
			footerTemplate: null,
			/* type="string" Sets gets text which appears in field in no-focus state and there is no value.  */
			nullText: null,
			/* type="object" Gets sets a valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself.
				Note: if it is set to string and "dataSourceType" option is not set, then $.ig.JSONPDataSource is used.
			*/
			dataSource: null,
			/* type="string" Gets sets data source type (such as "json", "xml", etc). Please refer to the documentation of $.ig.DataSource and its type property */
			dataSourceType: null,
			/* type="string" Gets sets url which is used for sending JSON on request for remote filtering (MVC for example). That option is required when load on demand is enabled and its type is remote. */
			dataSourceUrl: null,
			/* type="string" see $.ig.DataSource. property in the response specifying the total number of records on the server. */
			responseTotalRecCountKey: null,
			/* type="string" see $.ig.DataSource. This is basically the property in the responses where data records are held, if the response is wrapped. */
			responseDataKey: null,
			/* type="string" content type of the response. See http://api.jquery.com/jQuery.ajax/ => contentType */
			responseContentType: null,
			/* type="string" specifies the HTTP verb to be used to issue the request */
			requestType: 'GET',
			/* type="object" Gets or sets object which contains options supported by igValidator.
				Notes: in order for validator to work, application should ensure that igValidator is loaded (ig.ui.validator.js/css files).
				Example:
				$('#combo1').igCombo({ validatorOptions: { required: true } }); */
			validatorOptions: null,
			/* type="string" Gets sets name of (hidden) INPUT element, which value will be set to values of selected items separated by "," character on any change in igCombo. */
			inputName: null,
			/* type="object" Gets sets container of variables which define load on demand functionality.
				Notes:
				That option has effect only when data is loaded remotely using dataSourceUrl.
				If the parentComboKey is set, then that option is not supported.
				Selection is supported only for already loaded items.
			*/
			loadOnDemandSettings: {
				/* type="bool" Gets sets option to enable load on demand.  */
				enabled: false,
				/* type="number" Gets sets number of records loaded on each request.  */
				pageSize: null
			},
			/* type="bool" Gets sets ability to load data (bind dataSource) at the time when drop-down list is opened.
				Notes:
				1. Before data is loaded the selectedItems, value, text and other options/methods will fail.
				2. Initial selection, text and value will have no effect.
				3. If on first drop-down the dataSource does not contain selectedItems (for example, enabled load on demand), then selection will be destroyed.
				4. To get around with values, an application may enable "allowCustomValue" option and use the "text" option instead of "selectedItems".
			*/
			dataBindOnOpen: false,
			/* type="bool" Sets gets ability to close drop-down list when item is the list is selected. */
			closeDropDownOnSelect: true,
			/* type="bool" Sets gets ability to close drop-down list when control loses focus. Note: if application disables that option, then it is responsible for closing drop-down list. */
			closeDropDownOnBlur: true,
			/* type="string|number|bool|date|auto|null" Gets sets type of values used for data cell/items with valueKey. That value is assign to schema of $.ig.DataSource.
				string type="string" data source uses strings objects
				number type="string" data source uses numbers objects
				bool type="string" data source uses booleans objects
				date type="string" data source uses Date objects
				auto type="string" data source uses type defined by cell/items located in first row
				null type="object" data source uses type defined by cell/items located in first row
			*/
			valueKeyType: null,
			/* type="string|number|bool|date|auto|null" Gets sets type of values used for data cells/items with textKey. That value is assign to schema of $.ig.DataSource.
				string type="string" data source uses strings objects
				number type="string" data source uses numbers objects
				bool type="string" data source uses booleans objects
				date type="string" data source uses Date objects
				auto type="string" data source uses type defined by cell/items located in first row
				null type="object" data source uses type defined by cell/items located in first row
			*/
			textKeyType: null,
			/* type="string" Gets sets name of column which contains the "value". If it is missing, then name of first column will be used. */
			valueKey: null,
			/* type="string" Gets sets name of column which contains the displayed text. If it is missing, then "valueKey" option will be used. */
			textKey: null,
			/* type="string|object" Gets sets selector/id of parent igCombo or reference to parent igCombo object, which is used for cascading functionality.
				Notes:
				The selected value in parent igCombo will be used as key to adjust dataSource in this igCombo.
				Multiselection in parentCombo has no effect on items in child combo: only first selected item of parentCombo is used.
			*/
			parentCombo: null,
			/* type="object" Gets sets collection (array or dictonary) of javascript objects which allows to configure dataSource and other properties of this igCombo.
				The key in dictionary should represent selected value in parent igCombo. If value in parent igCombo is integer, then array can be used instead of dictionary.
				Each item in collection may contain dataSource, or an object, which should have following members.
					dataSource: reference to dataSource,
					valueKey: optional override for valueKey of this igCombo,
					textKey: optional override for textKey of this igCombo,
					dataSourceUrl: optional dataSourceUrl when dataSource is not set.
				Note: that option has effect only when "parentCombo" option is set and it has priority over "parentComboKey".
			*/
			cascadingDataSources: null,
			/* type="string" Gets sets column key in dataSource, which will be used by cascading functionality in order to get records matching with selected value in parent igCombo.
				Notes:
				That option has effect only when "parentCombo" option is set and it has no effect if "cascadingDataSources" is set.
				If that option is set, then data is filtered internally, therefore, filtering while changing text in editor is not available.
				If that option is set, then loadOnDemand is not supported.
			*/
			parentComboKey: null
		},
		events: {
			/* cancel="true" Event which is raised before drop-down list is opened.
				Return false in order to cancel drop-down action.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igCombo.
				Use ui.element to obtain reference to jquery DOM element which represents container of list.
				Note: on the very first opening or option-change that member is null and application should
				check that before using that member.
			*/
			dropDownOpening: null,
			/* cancel="false" Event which is raised after drop-down list was opened.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igCombo.
				Use ui.element to obtain reference to jquery DOM element which represents container of list.
			*/
			dropDownOpened: null,
			/* cancel="true" Event which is raised before drop-down list is closed.
				Return false in order to cancel hide action.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igCombo.
				Use ui.element to obtain reference to jquery DOM element which represents container of list.
			*/
			dropDownClosing: null,
			/* cancel="false" Event which is raised after drop-down list was closed.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igCombo.
				Use ui.element to obtain reference to jquery DOM element which represents container of list.
			*/
			dropDownClosed: null,
			/* cancel="true" Event which is raised before data binding.
				Function takes first argument null and second argument ui.
				Use ui.owner to obtain reference to igCombo.
				Use ui.dataSource to obtain reference to instance of $.ig.DataSource used by combo. */
			dataBinding: null,
			/* cancel="false" Event which is raised after data binding.
				Function takes first argument null and second argument ui.
				Use ui.owner to obtain reference to igCombo.
				Use ui.dataSource to obtain reference to instance of $.ig.DataSource used by combo. */
			dataBound: null,
			/* cancel="false" Event which is raised after value in field was modified by user.
				It is not raised when value of field was modified internally, for example, after filling-up from matching item while autoComplete.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igCombo.
				Use ui.text to obtain new text in field.
				Use ui.oldText to obtain old text in field.
			*/
			textChanged: null,
			/* cancel="true" Event which is raised before selection change.
				Return false in order to cancel change.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser. That can be null.
				Use ui.owner to obtain reference to igCombo.
				Use ui.items to obtain reference to array of new selected items. That can be null.
				Use ui.oldItems to obtain reference to array of old selected items. That can be null.
			*/
			selectionChanging: null,
			/* cancel="false" Event which is raised after selection change.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser. That can be null.
				Use ui.owner to obtain reference to igCombo.
				Use ui.items to obtain reference to array of new selected items. That can be null.
				Use ui.oldItems to obtain reference to array of old selected items. That can be null.
			*/
			selectionChanged: null,
			/* cancel="true" Event which is raised before change of active item in list.
				Return false in order to cancel change.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser. That can be null.
				Use ui.owner to obtain reference to igCombo.
				Use ui.index to obtain index of new active item.
				Use ui.oldIndex to obtain index of old active item.
			*/
			activeItemChanging: null,
			/* cancel="false" Event which is raised after change of active item in list.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser. That can be null.
				Use ui.owner to obtain reference to igCombo.
				Use ui.index to obtain index of new active item.
				Use ui.oldIndex to obtain index of old active item.
			*/
			activeItemChanged: null,
			/* cancel="false" Event which is raised after field was modified by end user and autoComplete was not able to find matching item in list.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser. That can be null.
				Use ui.owner to obtain reference to igCombo.
				Use ui.text to obtain text in field.
			*/
			noMatchFound: null,
			/* cancel="true" Event which is raised before filtering.
				Return false in order to cancel filtering.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser. That can be null.
				Use ui.owner to obtain reference to igCombo.
				Use ui.expression to obtain reference to array which contains expressions supported by $.ig.DataSource.
				Each expression-item contains following members: fieldName (textKey), cond (filteringCondition), expr (value/string to filter).
			*/
			filtering: null,
			/* cancel="false" Event which is raised after filtering.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser. That can be null.
				Use ui.owner to obtain reference to igCombo.
				Use ui.expression to obtain reference to array which contains expressions supported by $.ig.DataSource.
				Each expression-item contains following members: fieldName (textKey), cond (filteringCondition), expr (value/string to filter).
			*/
			filtered: null
		},
		css: {
			/* Class applied to the main/top element. Default value is 'ui-igcombo ui-state-default ui-widget ui-corner-all' */
			combo: 'ui-igcombo ui-state-default ui-widget ui-corner-all',
			/* Class applied to the editing element. Default value is 'ui-igcombo-field ui-corner-all' */
			field: 'ui-igcombo-field ui-corner-all',
			/* Class applied to the holder of editing element. Default value is 'ui-igcombo-fieldholder' */
			fieldHolder: 'ui-igcombo-fieldholder',
			/* Class applied to the holder of editing element when direction is rtl. Default value is 'ui-igcombo-fieldholder-rtl ui-corner-right' */
			fieldHolderRTL: 'ui-igcombo-fieldholder-rtl ui-corner-right',
			/* Class applied to the holder of editing element when direction is ltr. Default value is 'ui-igcombo-fieldholder-ltr ui-corner-left' */
			fieldHolderLTR: 'ui-igcombo-fieldholder-ltr ui-corner-left',
			/* Class applied to the main/top element in mouse-over state. Default value is 'ui-igcombo-hover ui-state-hover' */
			hover: 'ui-igcombo-hover ui-state-hover',
			/* Class applied to the main/top element in focus state. Default value is 'ui-igcombo-focus ui-state-focus' */
			focus: 'ui-igcombo-focus ui-state-focus',
			/* Class applied to the editing element in mouse-over state. Default value is 'ui-igcombo-field-hover' */
			fieldHover: 'ui-igcombo-field-hover',
			/* Class applied to the editing element in focus state. Default value is 'ui-igcombo-focus' */
			fieldFocus: 'ui-igcombo-field-focus',
			/* Classes applied to the main/top element in disabled state. Default value is 'ui-igcombo-disabled ui-state-disabled' */
			disabled: 'ui-igcombo-disabled ui-state-disabled',
			/* Class applied to the element while editor waits for response from server on request to filter data. That has effect only when option "filteringType" is set to "remote". Default value is 'ui-igcombo-waitfiltering' */
			waitFiltering: 'ui-igcombo-waitfiltering',
			/* Class applied to the editing element when it has no value. Default value is 'ui-igedit-nullvalue' */
			nullText: 'ui-igcombo-nulltext',
			/* Class applied to the SPAN element which represents dropdown button. Default value is 'ui-igcombo-button ui-state-default' */
			button: 'ui-igcombo-button ui-state-default',
			/* Class applied to the SPAN element which represents dropdown button when direction is rtl. Default value is 'ui-igcombo-button-rtl ui-corner-left' */
			buttonRTL: 'ui-igcombo-button-rtl ui-corner-left',
			/* Class applied to the SPAN element which represents dropdown button when direction is ltr. Default value is 'ui-igcombo-button-ltr ui-corner-right' */
			buttonLTR: 'ui-igcombo-button-ltr ui-corner-right',
			/* Classes applied to the SPAN element of dropdown button when editor has focus. Default value is 'ui-igcombo-button-focus' */
			buttonFocus: 'ui-igcombo-button-focus',
			/* Classes applied to the SPAN element of dropdown button in mouse-over state. Default value is 'ui-igcombo-button-hover ui-state-hover' */
			buttonHover: 'ui-igcombo-button-hover ui-state-hover',
			/* Classes applied to the SPAN element of dropdown button in pressed state. Default value is 'ui-igcombo-button-pressed ui-state-highlight' */
			buttonPressed: 'ui-igcombo-button-pressed ui-state-highlight',
			/* Classes applied to the SPAN element which represents image on dropdown button. Default value is 'ui-igcombo-button-icon ui-icon-triangle-1-s ui-icon' */
			buttonIcon: 'ui-igcombo-buttonicon ui-icon-triangle-1-s ui-icon',
			/* Class applied to the SPAN element which represents clear button. Default value is 'ui-igcombo-clear' */
			clear: 'ui-igcombo-clear',
			/* Classes applied to the SPAN element of clear button in mouse-over state. Default value is 'ui-igcombo-clear-hover ui-state-hover' */
			clearHover: 'ui-igcombo-clear-hover ui-state-hover',
			/* Classes applied to the SPAN element of clear button in pressed state. Default value is 'ui-igcombo-clear-pressed ui-state-highlight' */
			clearPressed: 'ui-igcombo-clear-pressed ui-state-highlight',
			/* Classes applied to the SPAN element of clear button when editor has focus. Default value is 'ui-igcombo-clear-focus' */
			clearFocus: 'ui-igcombo-clear-focus',
			/* Class applied to the SPAN element which represents image on clear button. Default value is 'ui-igcombo-clearicon ui-icon-circle-close ui-icon' */
			clearIcon: 'ui-igcombo-clearicon ui-icon-circle-close ui-icon',
			/* Class applied to the SPAN element which represents checkbox in list item. Default value is 'ui-state-default ui-corner-all ui-igcombo-checkbox ui-igcheckbox-small' */
			checkbox: 'ui-state-default ui-corner-all ui-igcombo-checkbox ui-igcheckbox-small',
			/* Class applied to the SPAN element which represents checkbox in mouser over state. Default value is 'ui-state-hover ui-igcombo-checkbox-hover' */
			checkboxHover: 'ui-state-hover ui-igcombo-checkbox-hover',
			/* Class applied to the SPAN element which represents icon of checkbox in mouser over state. Default value is 'ui-state-hover ui-igcombo-checkboxicon-hover' */
			checkboxIconHover: 'ui-state-hover ui-igcombo-checkboxicon-hover',
			/* Class applied to the SPAN element which represents icon in unchecked checkbox. Default value is 'ui-icon ui-igcombo-checkbox-off ui-igcheckbox-small-off' */
			checkboxOff: 'ui-icon ui-igcombo-checkbox-off ui-igcheckbox-small-off',
			/* Class applied to the SPAN element which represents icon in unchecked checkbox. Default value is 'ui-icon ui-icon-check ui-igcombo-checkbox-on ui-igcheckbox-small-on' */
			checkboxOn: 'ui-icon ui-icon-check ui-igcombo-checkbox-on ui-igcheckbox-small-on',
			/* Class applied to the DIV element which is used as container for dropdown list. Default value is 'ui-igcombo-list ui-widget ui-widget-content ui-corner-all' */
			list: 'ui-igcombo-list ui-widget ui-widget-content ui-corner-all',
			/* Class applied to the UL element which is used as container for list items. Default value is 'ui-igcombo-listitemholder' */
			listItemHolder: 'ui-igcombo-listitemholder',
			/* Class applied to the LI element which represents item in dropdown list. Default value is 'ui-igcombo-listitem ui-state-default' */
			listItem: 'ui-igcombo-listitem ui-state-default',
			/* Class applied to the LI element which represents item in dropdown list with mouse-over state. Default value is 'ui-igcombo-listitem-hover ui-state-hover' */
			listItemHover: 'ui-igcombo-listitem-hover ui-state-hover',
			/* Class applied to the LI element which represents active item in dropdown list. Default value is 'ui-igcombo-listitem-active ui-state-active' */
			listItemActive: 'ui-igcombo-listitem-active ui-state-active',
			/* Class applied to the LI element which represents selected item in dropdown list. Default value is 'ui-igcombo-listitem-selected ui-state-highlight' */
			listItemSelected: 'ui-igcombo-listitem-selected ui-state-highlight',
			/* Class applied to the text in item which matches with current value in field. Default value is 'ui-igcombo-listitem-match' */
			listItemMatch: 'ui-igcombo-listitem-match',
			/* Class applied to the SPAN element which represents text of item in dropdown list when checkboxes are enabled. Default value is 'ui-igcombo-listitemtextwithcheckbox' */
			listItemTextWithCheckbox: 'ui-igcombo-listitemtextwithcheckbox',
			/* Class applied to the main element when list is above editor and to list when list is below editor. Default value is 'ui-igcombo-no-top-corners' */
			noTopCorners: 'ui-igcombo-no-top-corners',
			/* Class applied to the main element when list is below editor and to list when list is above editor. Default value is 'ui-igcombo-no-bottom-corners' */
			noBottomCorners: 'ui-igcombo-no-bottom-corners'
		},
		/* Number of records in igCombo (view of dataSource) */
		RECORDS_VIEW: '{0}',
		/* Number of records in dataSource */
		RECORDS_DATA: '{1}',
		/* Number of (filtered) records on server */
		RECORDS_SERVER: '{2}',
		/* Number of all records on server */
		RECORDS_SERVER_TOTAL: '{3}',
		_create: function () {
			var name, evts, inp, i, len, clear, but, sel, txt, fieldHolder, touch,
				me = this,
				o = me.options,
				css = me.css,
				elem = me.element,
				selItems = o.selectedItems,
				fl = 'float',
				field = elem,
				rtl = elem.css('direction') === 'rtl',
				oldC = { display: 0, visibility: 0, position: 0 },
				oldA = { title: 0 };
			me._data = [];
			me._rtl = rtl;
			me._lastScroll = me._virtualTop = me._topID = 0;
			me._changeID = me._activeID = me._scrollTo = -1;
			i = me._noMouse() ? null : o.renderMatchItems;
			me._matchFlag = (i && i !== 'none') ? i : null;
			// N.A. 10/28/2013 Bug #155235: Add "id" attribute, if the combo is not initialized over DOM element with existing ID (applies for combos used as editors in grid updating feature).
			if (o.id !== undefined && o.id !== null && o.id !== "" && (elem.attr("id") === undefined || elem.attr("id").toString() === "")) {
				elem.attr("id", o.id);
			}
			if (selItems && selItems.length === 1 && selItems[0].index === -1 && selItems[0].value === null) {
				o.selectedItems = selItems = null;
			}
			name = elem[0].nodeName;
			if (name) {
				name = name.toUpperCase();
			}
			inp = name === 'INPUT';
			me._SELECT = sel = name === 'SELECT';
			// old attributes which can be modified and used in destroy (no MVC)
			if (!o.inputName) {
				me._oldCss = oldC;
				me._oldAttr = oldA;
			}
			if (inp) {
				// extra old attributes of INPUT
				oldA.value = oldA.disabled = oldA.readOnly = oldA.alt = oldA.tabIndex = oldC.textAlign = oldC.position = oldC.overflow = oldC[fl] = 0;
			} else if (sel) {
				if (!o.dataSource) {
					sel = elem[0].options;
					len = sel.length;
					if (!selItems || selItems.length === 0) {
						clear = selItems = o.selectedItems = [];
					}
					o.dataSource = [];
					o.valueKey = 'value';
					o.textKey = 'text';
					for (i = 0; i < len; i += 1) {
						txt = sel[i].text || sel[i].innerHTML;
						o.dataSource[i] = { value: sel[i].value || txt, text: txt };
						// fill selected items
						if (clear && (i === elem[0].selectedIndex || sel[i].selected)) {
							selItems.push({ index: i });
						}
					}
				}
			} else {
				if (name !== 'DIV' && name !== 'SPAN') {
					throw new Error(name + ' is not supported as base element');
				}
				// extra old attributes of SPAN/DIV/etc.
				oldA.innerHTML = 0;
			}
			for (i in oldC) {
				if (oldC.hasOwnProperty(i)) {
					oldC[i] = elem.css(i);
				}
			}
			for (i in oldA) {
				if (oldA.hasOwnProperty(i)) {
					oldA[i] = elem[0][i];
				}
			}
			// Note: do not use css('width/height')
			oldC.width = elem[0].style.width;
			o.width = o.width || oldC.width;
			oldC.height = elem[0].style.height;
			o.height = o.height || oldC.height;
			if (selItems && selItems.length > 0) {
				txt = '';
			} else if (_aNull(txt = o.text)) {
				// backup if options.value is not set
				if (!elem[0].multiple) {
					// o.inputName: MVC
					txt = o.inputName ? '' : (inp ? oldA.value : (sel ? elem.val() : oldA.innerHTML));
				}
				txt = txt ? txt.replace(/[\x09\x0a]/g, '') : '';
				i = txt.length;
				while ((i -= 1) >= 0) {
					if (txt.charCodeAt(i) === 32) {
						txt = txt.substring(0, i);
					} else {
						break;
					}
				}
			}
			if (inp || sel) {
				me._swap = true;
				elem = $('<span />').css({ position: field.css('position'), left: field.css('left'), top: field.css('top') }).insertBefore(field);
				if (rtl) {
					elem.css('direction', 'rtl');
				}
				if (sel) {
					field.css('display', 'none');
					field = $('<input />');
				}
			} else {
				field = $('<input />');
				// not MVC
				if (!o.inputName) {
					elem.html('');
				}
			}
			me._oldTxt = '';
			me.mainElem = elem;
			i = elem.css('position');
			me._static = !i || i === 'static';
			elem.css('overflow', 'hidden');
			me._fieldHolder = fieldHolder = $('<span />').addClass(css.fieldHolder).addClass(rtl ? css.fieldHolderRTL : css.fieldHolderLTR).css('float', rtl ? 'right' : 'left').appendTo(elem);
			me.fieldElem = field.appendTo(fieldHolder).addClass(css.field).css('float', rtl ? 'right' : 'left').bind(me._evts = {
				keydown: function (e) { me._onKey(e, 0); },
				keypress: function (e) { me._onKey(e, 1); },
				keyup: function (e) { me._onKey(e, 2); },
				focus: function (e) { me._onEvt(this, 8, e); },
				blur: function (e) { me._onEvt(this, 9, e); },
				paste: function (e) { me._onChange(e); },
				beforecut: function (e) { me._onChange(e); },
				cut: function (e) { me._onChange(e); },
				drop: function (e) { me._onChange(e); }
			});
			if (!_aNull(i = o.tabIndex)) {
				field.attr('tabIndex', i);
			}
			field[0].disabled = o.disabled;
			field[0].readOnly = (this._mode(o) > 0) ? 'readonly' : '';
			elem.addClass(css.combo).css('display', 'inline-block').bind(me._elemEvts = {
				MSPointerOver: function (e) { me._onEvt(this, 26, e); },
				// N.A. 11/18/2013 Task #157749: Add support for IE11, becasue it doesn't support events with MS prefix.
				pointerover: function (e) { me._onEvt(this, 26, e); },
				mouseover: function (e) { me._onEvt(null, 6, e); },
				mouseleave: function (e) { me._onEvt(null, 7, e); }
			});
			me._mEvts = evts = {
				mousedown: function (e) { me._onEvt(this, 3, e); },
				mouseup: function (e) { me._onEvt(this, 4, e); },
				MSPointerOver: function (e) { me._onEvt(this, 26, e); },
				pointerover: function (e) { me._onEvt(this, 26, e); },
				mouseover: function (e) { me._onEvt(this, 6, e); },
				mouseleave: function (e) { me._onEvt(this, 7, e); }
			};
			// get around bugs in Android: process and stop all touch events over buttons, checkboxes and their icons
			me._tEvts = touch = {
				touchstart: function (e) { _stop(e); },
				touchmove: function (e) { _stop(e); },
				touchend: function (e) {
					_stop(e);
					// get around bugs in Android 4.1.2+ related to focus: list opened and at once closed
					// assume that 350ms delay is enough to finish (mess with automatic) focus actions
					var el = $(this);
					setTimeout(function () { el.trigger('mousedown').trigger('mouseup'); }, 350);
				}
			};
			// create buttons
			me.buttonElem = but = _notab($('<span />').addClass(css.button)
				.addClass(rtl ? css.buttonRTL : css.buttonLTR).css('float', rtl ? 'left' : 'right')
				.attr('data-id', 1).appendTo(elem).bind(evts).bind(touch));
			_notab($('<span />').addClass(css.buttonIcon).appendTo(but).bind(touch));
			me.clearElem = clear = _notab($('<span />').addClass(css.clear).css('float', rtl ? 'left' : 'right')
				.attr('data-id', 2).appendTo(fieldHolder).bind(evts).bind(touch));
			_notab($('<span />').addClass(css.clearIcon).appendTo(clear).bind(touch));
			me._titles();
			me.validator();
			me._clearOn = false;
			me._doSize();
			i = me._cascade();
			if (i) {
				// failure to find cascading parent combo or parent did not have data
				if (i !== true) {
					if (typeof i === 'string') {
						i = i.replace('#', '');
					}
					// set request to call this._cascade() when parent combo is ready
					_cascWait = _cascWait || {};
					// note: same parentCombo may have multiple slave combos: use array
					if (_cascWait[i]) {
						_cascWait[i].push(me);
					} else {
						_cascWait[i] = [me];
					}
				}
			} else if (!o.dataBindOnOpen) {
				me.dataBind();
			}
			if (txt) {
				me.text(txt);
			}
			me._canFire = true;
		},
		dropDownVisible: function (showHide, fire) {
			/* Gets sets visibility of drop-down list.
				paramType="bool" optional="true" Value true will show dropdown, false - hide dropdown.
				paramType="bool" optional="true" Value of true will trigger possible events (such as dropDownOpening, dropDownClosed, etc.)
				returnType="bool|object" If parameter is defined, then returns reference to this igCombo, otherwise, returns true if drop down is visible and false if drop down is hidden.
			*/
			if (!arguments.length) {
				return !!this._ddOn;
			}
			this._canFire = fire;
			this._doDrop(showHide ? 2 : 0);
			this._canFire = true;
			return this;
		},
		remove: function () {
			/* Removes combo from its parent element, but keeps the rest of functionality.
				returnType="object" Returns reference to this igCombo.
			*/
			var p, v = this._validator, e = this.mainElem;
			if (!e || !e[0]) {
				return;
			}
			if (v) {
				v.hide();
			}
			if (this._fcs) {
				// fake blur event
				this._onEvt(null, 9);
			}
			this.fieldElem.removeClass(this.css.fieldHover);
			e.removeClass(this.css.hover);
			p = e[0].parentNode;
			if (p && p.tagName) {
				this._doDrop(0);
				this._fcs = 0;
				p.removeChild(e[0]);
			}
			return this;
		},
		validator: function (destroy) {
			/* Gets reference to igValidator used by igCombo.
				paramType="bool" optional="true" Request to destroy validator.
				returnType="object" Returns reference to igValidator or null.
			*/
			var o = this.options.validatorOptions, field = this.fieldElem, v = this._validator;
			if (v && (destroy || !o)) {
				v.destroy();
				delete this._validator;
			} else if (!v && !destroy && o && field.igValidator) {
				o.combo = o.element = this.mainElem;
				this._validator = field.igValidator(o).data('igValidator');
			}
			return this._validator;
		},
		validate: function () {
			/* Trigger validation.
				returnType="number|object" Possible values:
				1 - application canceled error message.
				2 - error message is displayed.
				Any other value or undefined means that target is valid or validation is not enabled.
			*/
			return this._validator ? this._validator.validate() : null;
		},
		setFocus: function (delay) {
			/* Set focus to combo with possible delay.
				paramType="number" optional="true" Delay in milliseconds. If parameter is missing, then 0 is used. If parameter is -1, then focus is set without delay.
				returnType="object" Returns reference to this igCombo.
			*/
			var me = this;
			if (me.fieldElem && !me._fcs) {
				// called from setTimeout
				if (delay === -1) {
					try {
						me.fieldElem[0].focus();
					} catch (ex) { }
				} else {
					setTimeout(function () {
						me.setFocus(-1);
					}, delay || 0);
				}
			}
			return this;
		},
		hasFocus: function () {
			/* Checks if combo has focus.
				returnType="bool" Returns true if combo has focus.
			*/
			return this._fcs === 1;
		},
		isSelected: function (index) {
			/* Checks if list item at index is selected.
				paramType="number" Index of item.
				returnType="bool" Returns true if item is selected, otherwise, false.
			*/
			var selItems = this.options.selectedItems, len = selItems ? selItems.length : 0;
			while ((len -= 1) >= 0) {
				if (selItems[len].index === index) {
					return true;
				}
			}
			return false;
		},
		selectedIndex: function (index, fire) {
			/* Gets sets index of selected item in list.
				Note: it is supported only for items, which are available on client at the time when method is called. When load-on-demand or filtering is enabled, then attempt to select not loaded item will fail.
				paramType="number" optional="true" New selected index for combo. In order to clear selection, use -1.
				paramType="bool" optional="true" Value of true will trigger possible events (such as selectionChanging, selectionChanged, filtering, etc.). When cascading features are enabled, then value of false will suspend firing events
				returnType="number|object" Returns index of first selected item in list or -1, if parameter is undefined. Otherwise, it returns reference to this igCombo.
			*/
			if (index === undefined) {
				var i, selItems = this.options.selectedItems, len = selItems ? selItems.length : 0;
				index = -1;
				while ((len -= 1) >= 0) {
					i = selItems[len].index;
					index = (index < 0) ? i : Math.min(i, index);
				}
				return index;
			}
			this._canFire = fire !== false && (fire || this._cascFire);
			this._select(index);
			this._updateFromList(null, 1);
			this._fixNull();
			this._canFire = true;
			return this;
		},
		activeIndex: function (index, fire) {
			/* Gets sets index of active item in list.
				Note: it is supported only for items, which are available on client at the time when method is called. When load-on-demand or filtering is enabled, then attempt to activate not loaded item will fail.
				paramType="number" optional="true" New active index for list. In order to clear active item, use -1.
				paramType="bool" optional="true" Value of true will trigger possible events (such as activeItemChanging and activeItemChanged).
				returnType="number|object" Returns index of active item in list or -1, if parameter is undefined. Otherwise, it returns reference to this igCombo.
			*/
			if (index === undefined) {
				return this._activeID;
			}
			this._canFire = fire;
			this._activate(index);
			this._canFire = true;
			return this;
		},
		value: function (val, fire) {
			/* Gets sets value of first selected item in list (item for valueKey column).
				paramType="object" optional="true" New selected value. In case of enabled multiselection, that parameter may optionally contain multiple formatted string-items separated by itemSeparator.
				paramType="bool" optional="true" Value of true will trigger possible events (such as selectionChanging, selectionChanged, filtering, etc.). When cascading features are enabled, then value of false will suspend firing events
				returnType="string|object" Returns value of first selected item in list if parameter is undefined. Otherwise, it returns reference to this igCombo.
			*/
			if (this._noMouse()) {
				return this.text(val, fire);
			}
			if (val === undefined) {
				val = this.options.selectedItems;
				return (val && val[0]) ? val[0].value : null;
			}
			this._canFire = fire !== false && (fire || this._cascFire);
			// Time/Last are used by cascading combo, when value of child is set before value of parent
			this._valTime = _now();
			this._valLast = val;
			this._select(null, val);
			this._updateFromList(null, 1);
			this._canFire = true;
			return this;
		},
		text: function (text, fire) {
			/* Gets sets text text in field.
				paramType="string" optional="true" New text for combo. In case of enabled multiselection, that parameter may optionally contain multiple items separated by itemSeparator.
				paramType="bool" optional="true" Value of true will trigger possible events (such as selectionChanging, selectionChanged, filtering, etc.). When cascading features are enabled, then value of false will suspend firing events
				returnType="string|object" If parameter is undefined, then current text in field is returned. Otherwise, it returns reference to this igCombo.
			*/
			if (text === undefined) {
				text = this.fieldElem.val();
				return (this._nullT && (!text || text === this.options.nullText)) ? '' : text;
			}
			this._canFire = fire !== false && (fire || this._cascFire);
			this._select(null, text, 2);
			this._updateFromList(null, 1);
			if (this._custom()) {
				this._onChange(null, null, text);
			}
			this._canFire = true;
			return this;
		},
		values: function (vals) {
			/* Gets sets array of selected values in list (items for valueKey column).
				paramType="array" optional="true" New selected values. Note: change selection events are not raised.
				returnType="array|object" If parameter is undefined, then array of selected values is returned. Otherwise, it returns reference to this igCombo.
			*/
			var o = this.options, selItems = o.selectedItems, i = selItems ? selItems.length : 0;
			if (vals === undefined) {
				vals = [];
				while ((i -= 1) >= 0) {
					vals[i] = selItems[i].value;
				}
				return vals;
			}
			i = vals ? vals.length : 0;
			selItems = [];
			while ((i -= 1) >= 0) {
				selItems[i] = { value: vals[i] };
			}
			o.selectedItems = selItems;
			this._initSel(o);
			return this;
		},
		itemByIndex: function (id) {
			/* Gets object which contains members relative to list-item.
				paramType="number" Index of item within drop-down list.
				returnType="object" The null or object, which contains following members: element- the reference to jquery li or null, index- the id, value- the value of item, text- the text of item.
			*/
			return id < 0 ? null : { element: this._findItem(id), index: id, value: this._item(id), text: this._item(id, 2) };
		},
		itemByValue: function (val) {
			/* Finds index of item by value and returns this.itemByIndex(indexOfItem).
				paramType="object" Value of item in drop-down list.
				returnType="object" The null or object, which contains following members: element- the reference to jquery li or null, index- the id, value- the value of item, text- the text of item.
			*/
			var id = -1;
			while (++id < this._count) {
				if (_equals(val, this._item(id))) {
					return this.itemByIndex(id);
				}
			}
		},
		getFooter: function () {
			/* Gets reference to footer.
				returnType="dom" Return null or jquery object which represents footer.
			*/
			return this.listElem ? this.listElem.find('[data-footer]') : null;
		},
		getDataSource: function () {
			/* Returns current data source used by igCombo.
				returnType="object" Returns reference to $.ig.DataSource.
			*/
			return this._dataSource;
		},
		getData: function () {
			/* Returns array of current records used by igCombo. If filtering is enabled, then that represents filtered data.
				Note: In order to get all records available in DataSource, the igCombo.getDataSource().data() can be used.
				returnType="array" Returns array of records.
			*/
			return this._data;
		},
		getRecordsCount: function (flag) {
			/* Gets number of records in view, dataSource, filtered server data, or total server data.
				paramType="string" Flag RECORD_xx or a number.
				returnType="number" Return number of records according to.
			*/
			var count = this._count, ds = this._dataSource;
			if (flag === this.RECORDS_VIEW || flag === 0) {
				return count;
			}
			if (ds) {
				count = ds._data.length;
				if (flag === this.RECORDS_DATA || flag === 1) {
					return count;
				}
				count = Math.max(ds.totalRecordsCount(), count);
				if (flag === this.RECORDS_SERVER || flag === 2) {
					return count;
				}
				if (flag === this.RECORDS_SERVER_TOTAL || flag === 3) {
					count = Math.max(Math.max(count, this._totalAll || 0), parseInt(this.options._totalAll || 0, 10));
				}
			}
			return count;
		},
		listScrollTop: function (val) {
			/* Gets sets scrollTop attribute of html element, which scrolls drop-down list of items.
				paramType="number" optional="true" New value for scroll top in list. Note: if list is closed and new value is provided, then dropDownVisible(true) is called automatically.
				returnType="number|object" If parameter is undefined, then scrollTop is returned. Otherwise, it returns reference to this igCombo.
			*/
			if (val !== undefined && !this._ddOn) {
				this.dropDownVisible(true);
			}
			var dd = this._ddScroll || this._ddCont;
			if (val === undefined) {
				return dd ? dd[0].scrollTop : 0;
			}
			if (dd) {
				dd[0].scrollTop = val || 0;
			}
			return this;
		},
		// connect/disconnect cascading combo, process selection of parent combo
		_cascade: function (evt, destroy, combo) {
			var key, i, url,
				me = this,
				val = me._parentCombo,
				o = me.options,
				ds = o.cascadingDataSources,
				old = me._cascOpt,
				parent = combo || o.parentCombo;
			combo = evt ? val : parent;
			if (val && !evt) {
				// remove request to raise events by parent
				key = val._cascFire;
				i = key ? key.length : 0;
				while (i-- > 0) {
					if (key[i] === me) {
						key.splice(i, 1);
						if (key.length === 0) {
							delete val._cascFire;
						}
						break;
					}
				}
				delete me._parentCombo;
				delete me._cascFilter;
				if (destroy) {
					return;
				}
				if (old) {
					o.valueKey = old.value;
					o.textKey = old.text;
					o.dataSource = old.ds;
					o.dataSourceUrl = old.url;
					if (!combo) {
						me.dataBind();
					}
				}
			}
			if (!combo || destroy) {
				return;
			}
			if (evt) {
				delete me._cascSel;
				me.selectedIndex(-1);
				me.activeIndex(-1);
			} else {
				if (!ds) {
					key = o.parentComboKey;
					if (!key) {
						return;
					}
					if (o.filteringType === 'remote') {
						me._cascFilter = -1;
					} else {
						o.filteringType = 'local';
						me._cascFilter = 1;
					}
					me._cascKey = key;
					// request to skip _dataChange triggered by explicit dataBind()
					url = o.dataSource ? null : o.dataSourceUrl;
				}
				if (typeof combo === 'string' || combo.nodeName) {
					combo = $(parent);
					if (combo.length !== 1) {
						combo = $('#' + parent);
						if (combo.length !== 1) {
							return parent;
						}
					}
				}
				if (combo && combo[0] && typeof combo.data === 'function') {
					parent = combo[0];
					combo = combo.data('igCombo');
				}
				if (!combo || combo.widgetName !== 'igCombo' || combo === me) {
					return parent;
				}
				// _cascFire request to raise events by parent, when its value/text/selectedIndex is modified from codes
				// that is array of cascading combos which should get selectionChanged
				key = combo._cascFire;
				i = key ? key.length : 0;
				while (i-- > 0) {
					if (key[i] === me) {
						break;
					}
				}
				if (i < 0) {
					combo._cascFire = key = key || [];
					key.push(me);
				}
				me._parentCombo = combo;
				if (!old && ds) {
					old = me._cascOpt = {
						value: o.valueKey,
						text: o.textKey,
						ds: o.dataSource,
						url: o.dataSourceUrl
					};
				}
				// N.A. 6/26/2014 Bug #174212 When there is multiple cascading combos with remote data source, _hasData is undefined and the combo is not marked as cascading
				if (!combo._hasData) {
					return parent;
				}
			}
			val = combo.options.selectedItems;
			val = (val && val.length > 0) ? val[0].value : null;
			// check if value was set before dataSource and set flag (_valTime=1), which will trigger set-value again after data is ready
			if (me._valTime && _now() - me._valTime < 200) {
				me._valTime = 1;
			}
			if (ds) {
				ds = val === null ? null : ds[val];
				// reconfigure all data-related options for a cascading dataSource
				val = ds ? ds.valueKey : null;
				o.valueKey = val || old.value;
				val = ds ? ds.textKey : null;
				o.textKey = val || old.text;
				o.dataSourceUrl = url = ds ? ds.dataSourceUrl : null;
				// if ds is array, then assume that is already dataSource
				o.dataSource = ds ? (ds.dataSource || (ds.length && !url ? ds : null)) : null;
				me._hasData = false;
				me._urlBind = me._lod = me._totalAll = o._totalAll = me._count = 0;
				// request to skip _dataChange triggered by explicit dataBind(): helps to keep server-selection
				me._cascUrl = url;
				// _cascSel: save selected value and use it to reinit selectedItems when data comes from dataSourceUrl
				if (url) {
					val = o.selectedItems;
					me._cascSel = val ? (val[0] ? val[0].value : null) : null;
				}
				me.dataBind();
				// remove request to skip _dataChange
				delete me._cascUrl;
			} else {
				me._cascVal = val;
				if (me._hasData) {
					if (_aNull(val, true) || val === '') {
						me._dataChange();
					} else {
						me.filter();
					}
				} else {
					// request to skip _dataChange triggered by explicit dataBind(): helps to keep server-selection
					me._cascUrl = url;
					me.dataBind();
					// remove request to skip _dataChange
					delete me._cascUrl;
				}
			}
			return true;
		},
		_noMouse: function () {
			var o = this.options, ds = o.dataSource;
			o = o.itemTemplate;
			return o && ds && ds.length === 1 && o.indexOf('{') < 0 && o.indexOf('}') < 0;
		},
		_custom: function () {
			return this.options.allowCustomValue || this._noMouse();
		},
		_multi: function (o) {
			o = o.multiSelection;
			return o && o !== 'off';
		},
		_checkBox: function (o) {
			o = o.multiSelection;
			return (o === 2) || (o && o.toLowerCase && o.toLowerCase() === 'onwithcheckboxes');
		},
		// editable:0, dropdown:1, readonlylist:2, readonly:3
		_mode: function (o) {
			o = o.mode;
			return (o === 1 || o === 'dropdown') ? 1 : ((o === 2 || o === 'readonlylist') ? 2 : ((o === 3 || o === 'readonly') ? 3 : 0));
		},
		_fixSelElem: function (elem, sel) {
			var css = this.css, icon = css.listItemSelected, iconOut = css.checkboxOff;
			if (sel) {
				elem.addClass(icon);
			} else {
				elem.removeClass(icon);
			}
			if (elem.attr('data-check')) {
				elem[0]._check = sel;
				icon = css.checkboxOn;
				elem.find('[data-icon]').removeClass(sel ? iconOut : icon).addClass(sel ? icon : iconOut);
			}
		},
		_copyA: function (a) {
			var len = a ? a.length : 0, a1 = len ? [] : null;
			while ((len -= 1) >= 0) {
				a1[len] = a[len];
			}
			return a1;
		},
		_clearSel: function () {
			var elems = this._selElems, i = elems ? elems.length : 0;
			while ((i -= 1) >= 0) {
				this._fixSelElem(elems[i]);
			}
			this._selElems = null;
		},
		_selChanged: function (e) {
			if (this._selArg) {
				// notify cascading combos before raising public event
				var elem, o, selItems,
					key = this._cascFire,
					i = key ? key.length : 0;
				while (i-- > 0) {
					key[i]._cascade(true);
				}
				this._fire('selectionChanged', e, this._selArg);
				if (this._SELECT) {
					elem = this.element[0];
					o = elem.options;
					selItems = this.options.selectedItems;
					i = selItems ? selItems[0] : null;
					i = i ? i.index : -1;
					elem.selectedIndex = i;
					if (o && i >= 0 && i < o.length) {
						o[i].selected = true;
					}
					if (elem.onchange) {
						elem.onchange();
					}
				}
				delete this._selArg;
			}
		},
		_selChange: function (selItems, e, clear, noReturn) {
			var i,
				old = this.options.selectedItems,
				i0 = old ? old.length : 0,
				i1 = selItems ? selItems.length : 0;
			if (!i1) {
				selItems = null;
			}
			// check if selection was modified: old and new selection may have different order, but same items
			if (i0 === i1) {
				while (i0-- > 0) {
					for (i = 0; i < i1; i += 1) {
						if (noReturn) {
							if (old[i0].value === selItems[i].value && old[i0].text === selItems[i].text) {
								break;
							}
						} else if (old[i0].index === selItems[i].index) {
							break;
						}
					}
					// no match found: flag to raise selectionChanging
					if (i === i1) {
						break;
					}
				}
			}
			// if (i0 < 0) then selectedItems were not modified
			// if no data or waiting for first remote filtering, then do not raise events
			old = (i0 >= 0 && this._hasData && !this._waitFilter) ? { owner: this, oldItems: old, items: selItems } : null;
			delete this._selArg;
			if (old && !this._fire('selectionChanging', e, old) && !noReturn) {
				return;
			}
			this._selTime = (e && this.options.focusOnSelect === false) ? _now() : 0;
			this._selArg = old;
			if (clear || !i1) {
				this._clearSel();
			}
			this.options.selectedItems = selItems;
			this._noFilter = selItems && selItems.length;
			return 1;
		},
		_addSel: function (id, e) {
			if (id >= 0 && !this.isSelected(id)) {
				var selItems = this._copyA(this.options.selectedItems);
				id = this._createSelItem(id);
				if (!selItems) {
					selItems = [id];
				} else {
					selItems.push(id);
				}
				if (this._selChange(selItems, e)) {
					this._selChanged(e);
				}
			}
			return this.options.selectedItems;
		},
		_sepEnd: function (txt) {
			var sep = this._sep(), len = txt.length;
			return len > 1 && txt.lastIndexOf(sep) === len - sep.length;
		},
		// id: new selected index (can be null)
		// val: new value (can be null)
		// flag==2: flag to set text in field
		// part: field was changed by user (request for partial match)
		_select: function (id, val, flag, part, e) {
			var vals, lenVals, txt, j, cond, ds, selItems = null,
				scrollID = -1,
				actID = -1,
				i = -1,
				o = this.options, more = 1,
				count = this._count,
				act = part ? (o.allowCustomValue ? 2 : 1) : null,// && !o.autoComplete,
				sep = false,
				lower = !o.caseSensitive && typeof val === 'string';
			if (e && part && !this._ddOn && e.type !== 'mouseup') {
				this._doDrop(1, e);
			}
			if (this._noMouse()) {
				return;
			}
			if (act) {
				this._changeID = -1;
			}
			if (!_aNull(val) && val !== '') {
				if (flag === 2) {
					val = val.toString();
				}
				vals = (typeof val === 'string') ? this._texts(val) : (val.length ? val : [val]);
				if ((lenVals = vals.length) > 0) {
					j = vals[lenVals - 1];
					if (!j && (flag === 2 || _aNull(j))) {
						if (act === 1) {
							sep = this._sepEnd(val);
						}
						vals.splice(lenVals -= 1, 1);
					}
				}
				if (lenVals === 0) {
					this._selChange(selItems, e, 1, 1);
					this._selChanged(e);
					return;
				}
				// containers of items with .id and .done members which correspond to vals
				while ((i += 1) < lenVals) {
					vals[i] = { val: vals[i], id: -1, done: null };
				}
				if (!this._isStrCond(cond = this._cond(o))) {
					cond = 'startsWith';
				}
				ds = this._dataSource;
				id = -1;
				while ((id += 1) < count && more) {
					if (_aNull(txt = this._item(id, flag))) {
						continue;
					}
					if (lower) {
						txt = txt.toString().toLowerCase();
					}
					more = null;
					for (i = 0; i < lenVals; i += 1) {
						if (!vals[i].done) {
							more = 1;
							val = vals[i].val;
							if (val === txt || (part && ds._findMatch(txt, val, 'string', false, cond))) {
								// check if item is already selected
								j = i;
								while ((j -= 1) >= 0) {
									if (vals[j].id === id) {
										break;
									}
								}
								// activate only unselected item
								if (act && j >= 0) {
									continue;
								}
								if (act && i + 1 === lenVals && !sep) {
									if (actID < 0) {
										this._changeID = scrollID = actID = id;
										if (act === 1 && !o.enableActiveItem) {
											vals[i].id = id;
										}
									}
								} else if (vals[i].id < 0) {
									vals[i].id = id;
								}
								if (act !== 1 && (val === txt || !part)) {
									vals[i].id = id;
									vals[i].done = 1;
								}
							}
						}
					}
				}
				selItems = [];
				for (i = 0; i < lenVals; i += 1) {
					if ((id = vals[i].id) >= 0 && act !== 2) {
						if (scrollID < 0) {
							scrollID = id;
						}
						j = selItems.length;
						while ((j -= 1) >= 0) {
							if (selItems[j].index === id) {
								break;
							}
						}
						if (j < 0 && (this._multi(o) || selItems.length === 0)) {
							selItems.push(this._createSelItem(id));
						}
					}
				}
			} else if (typeof id === 'number' && id >= 0 && id < count) {
				selItems = [this._createSelItem(scrollID = id)];
			}
			if (this._selChange(selItems, e, 1)) {
				if (scrollID >= 0) {
					this._fixSelScroll(this._scrollTo = scrollID);
					if (sep) {
						this._updateFromList(e, 1, 1);
					}
				}
				this._selChanged(e);
			}
			if (act) {
				this._activate(actID, e);
			}
		},
		_createSelItem: function (id, txt, val) {
			return { index: id, value: val || this._item(id), text: txt || this._item(id, 2) };
		},
		// id: index of item
		// valHtmlText: flag, 0/null-value, 1-text/html for rendering, 2-value of textKey
		_item: function (id, valHtmlText) {
			var val, textValue, i, txtVal, format, tags, j,
				o = this.options,
				key = this._keyVal,
				row = this._data[id],
				mf = this._matchFlag;
			if (valHtmlText) {
				key = this._key;
			}
			if (!row) {
				return valHtmlText ? '' : null;
			}
			val = row[key];
			if (!valHtmlText) {
				return val;
			}
			format = format || o.format;
			if (format) {
				if (_aNull(txtVal = row[i = key + '_'])) {
					if (_aNull(val)) {
						val = '';
					} else if ($.ig && $.ig.formatter && (typeof val === 'number' || (val && val.getMonth))) {
						val = $.ig.formatter(val, null, (format === 'auto' || format === true) ? null : format);
					} else {
						val = val.toString();
					}
					row[i] = val;
				} else {
					val = txtVal;
				}
			} else {
				val = _aNull(val) ? '' : val.toString();
			}
			if (valHtmlText !== 1) {
				return val;
			}
			textValue = val;
			i = o.itemTemplate;
			if (i && $.ig.tmpl) {
				if (!this._it) {
					if ($.ig.util.isIE && i.indexOf('unselectable') < 0) {
						tags = ['<div', '<span', '<img', '<a', '<td', '<li'];
						j = tags.length;
						while (j-- > 0) {
							i = i.replace(new RegExp(tags[j], 'gi'), tags[j] + ' unselectable="on"');
						}
					}
					this._it = i;
				}
				// N.A. 02/18/2014 Bug #164392 Add match highlighting for the text value when there is item tempalte.
				val = $.ig.tmpl(this._it, row);
				if (mf) {
					val = this._replaceTextInTemplate(val, textValue, this._renderMatches(textValue, o, mf));
				}
				return val;
			}
			if (val === '') {
				return '&nbsp;';
			}
			return mf ? this._renderMatches(val, o, mf) : val;
		},
		// N.A. 03/17/2014 Bug #166839 Highlight the code in template, but only the part that is text.
		_replaceTextInTemplate: function (template, text, highlightedText) {
			var parsedNode, resultNode, parsedTemplate, parent, children, i;

			if (text !== highlightedText) {
				parsedTemplate = "";
				parsedNode = $(template);
				// N.A. 06/05/2014 Bug #171621 Iterate over parent nodes
				for (i = 0; i < parsedNode.length; i++) {
					resultNode = this._replaceTextInNode($(parsedNode[i]), text, highlightedText);
					resultNode = $('<div>').append(resultNode);
					parsedTemplate += resultNode.html();
				}
				return parsedTemplate;
			}
			return template;
		},
		_replaceTextInNode: function (node, text, highlightedText) {
			var children = node.children(),
				parent = node.clone().children().remove().end(),
				i;
			parent.html(parent.text().replace(text, highlightedText));

			for (i = 0; i < children.length; i++) {
				parent = parent.append(this._replaceTextInNode($(children[i]), text, highlightedText));
			}
			return parent;
		},
		// find matches of txt inside of html
		// and render those matches with css.listItemMatch class
		// html: text of list item
		// o: options
		// match: o.renderMatchItems
		_renderMatches: function (html, o, match) {
			var index, i, lenMatch, len, lenIndex,
				val = o.caseSensitive ? html : html.toLowerCase(),
				minIndex = 0,
				shift = 0,
				matches = [],
				txts = this._textsTemp || this._texts(1),
				lenTxt = txts.length;
			// fill-up matches by items with members .index(indexOfMatch) and .len(lengthOfMatch)
			while (minIndex < 99999) {
				i = -1;
				minIndex = 99999;
				len = val.length;
				// find which text has first match (smallest value of indexOf)
				while ((i += 1) < lenTxt) {
					index = val.indexOf(txts[i]);
					lenMatch = txts[i].length;
					if (index >= 0 && index < minIndex && (index === 0 || match !== 'startsWith') && !(match === 'full' && len !== lenMatch) && lenMatch) {
						// index of match
						minIndex = index;
						// length of match
						lenIndex = lenMatch;
					}
				}
				if (minIndex < 99999) {
					// fill array with match
					matches.push({ index: shift += minIndex, len: lenIndex });
					// remove text of match and all in front of it from val
					val = val.substring(minIndex + lenIndex);
					// adjustment for position of next match in old html
					shift += lenIndex;
				}
				if (match !== 'multi' || shift >= len) {
					break;
				}
			}
			// insert SPANs with listItemMatch css for found matches
			for (i = matches.length - 1; i >= 0; i -= 1) {
				index = matches[i].index;
				len = matches[i].len;
				html = html.substring(0, index) + '<span unselectable="on" class="' + this.css.listItemMatch + '">' + html.substring(index, index + len) + '</span>' + html.substring(index + len);
			}
			return html;
		},
		_renderRow: function (id, repaint) {
			var txt, elem, box, i, top, cell,
				me = this,
				itemWidth = me._itemWidth,
				o = me.options,
				checkBoxes = me._checkBox(o),
				cbWidth = me._cbWidth || 0,
				html = me._html,
				lod = me._lodWait && !html;
			if (lod) {
				if (me._findItem(id + me._virtualTop)) {
					return;
				}
				repaint = false;
			}
			if (html) {
				repaint = false;
				if (!me._data[id]) {
					return;
				}
				html += '<li tabIndex="-1" class="' + me.css.listItem + '" style="width:';
				html += itemWidth + 'px;height:' + me._itemHeight + 'px" unselectable="on" data-id="' + (id + _listIDShift) + '"';
			} else if (!repaint) {
				elem = $('<li />').addClass(me.css.listItem)
					.css({ width: itemWidth, height: me._itemHeight })
					.attr('data-id', id + _listIDShift)
					.attr('tabIndex', -1)
					.attr('unselectable', 'on')
					.appendTo(me._itemsHolder);
				if (checkBoxes) {
					box = $('<span />').attr('data-box', 'x').attr('unselectable', 'on')
						.css('top', (me._cbTop || 0) + 'px')
						.addClass(me.css.checkbox)
						.appendTo(elem.attr('data-check', 'x'));
					$('<span />').attr('data-icon', 'x').attr('unselectable', 'on').addClass(me.css.checkboxOff).appendTo(box);
					if (!cbWidth) {
						me._cbWidth = cbWidth = box[0].offsetWidth;
					}
					cell = $('<span />').attr('data-txt', 'x').attr('unselectable', 'on')
						.addClass(me.css.listItemTextWithCheckbox)
						.css(me._rtl ? 'marginRight' : 'marginLeft', (Math.max(cbWidth, 14) + 3) + 'px')
						.prependTo(elem);
				} else {
					elem.attr('data-txt', 'x');
				}
			}
			id += me._virtualTop;
			if (repaint) {
				elem = this._findItem(id);
				if (!elem) {
					return;
				}
				if (!o.virtualization && !me._matchFlag) {
					return elem;
				}
			}
			txt = me._item(id, 1);
			if (html) {
				if (checkBoxes) {
					html += ' data-check="x"><span unselectable="on" data-txt="x" style="' + (me._rtl ? 'margin-right:' : 'margin-left:') +
						(Math.max(cbWidth, 14) + 3) + 'px;" class="' + me.css.listItemTextWithCheckbox + '">' + txt + '</span>';
					html += '<span unselectable="on" data-box="x" style="top:' + (me._cbTop || 0) + 'px" class="' + me.css.checkbox;
					html += '"><span unselectable="on" data-icon="x" class="' + me.css.checkboxOff + '"></span></span>';
				} else {
					html += ' data-txt="x">' + txt;
				}
				me._html = html + '</li>';
			} else if (!me._data[id]) {
				elem.hide();
				// possible trailing item under virtualization
				cell = me._findItem(id + 1);
				if (cell) {
					cell.hide();
				}
			} else if (elem[0]._old !== txt) {
				elem[0]._old = txt;
				// container of item-text
				cell = elem.find('[data-txt]');
				if (cell.length === 0) {
					cell = elem;
				}
				if (txt !== cell[0].innerHTML) {
					cell.html(txt);
				}
				// calculate top position of checkbox: align to middle
				if (checkBoxes && _aNull(me._cbTop)) {
					// checkbox
					box = elem.find('[data-box]');
					if (box[0] && (top = elem[0].clientHeight) > 0 && (i = box[0].offsetHeight) > 0) {
						if (i >= top) {
							elem.css('height', top = i + 1);
						}
						me._cbTop = Math.max((top - i - 1) / 2, 0);
					}
				}
				elem.show();
			}
			if (lod) {
				me._bindLIs(o, elem);
			}
			return elem;
		},
		_isCheckBox: function (elem) {
			return elem && (elem.getAttribute('data-box') || elem.parentNode.getAttribute('data-box'));
		},
		// sets nullText if control has no focus and adjusts nullTextCss
		_fixNull: function (clear) {
			var txt, nullTxt = this.options.nullText;
			if (!nullTxt && !this._nullT) {
				return;
			}
			txt = this.text();
			if (!clear && txt === '' && nullTxt && !this._fcs) {
				this._nullT = true;
				this.fieldElem.addClass(this.css.nullText).val(nullTxt);
			} else if (this._nullT) {
				this._nullT = null;
				this.fieldElem.removeClass(this.css.nullText).val(txt || '');
			}
		},
		// fill up visible rows in drop-down
		_onScroll: function (e) {
			var elem, selItems, selID, selLen, id, top, ds,
				me = this,
				count = me._count,
				itemHeight = me._itemHeightOuter,
				dd = me._ddScroll || me._ddCont;
			if (!dd || !me._ddOn || count < 2 || me._lodWait) {
				return;
			}
			// first visible item
			id = Math.floor((top = dd[0].scrollTop) / itemHeight);
			if (e) {
				me._lastScroll = top;
			}
			// index of top item
			top = Math.floor(me._lastScroll / itemHeight + 0.4);
			if (me._lod && top > count - me._page * 1.5) {
				ds = me._dataSource;
				top = ds.pageIndex();
				if (top + 1 < ds.pageCount()) {
					me._wait(me._lodWait = true);
					ds.pageIndex(top + 1);
					return;
				} else {
					top = id;
				}
			}
			// verify that (virtual) scroll did not go too far:
			// number of remaining items is not less than numbers of items which fit in visible area
			me._topID = top = Math.max(0, Math.min(top, count - Math.floor(dd[0].offsetHeight / itemHeight)));
			// repaint all items in list
			if (me._ddScroll) {
				// remove active css from current active item
				me._fixActive(me._activeID);
				count = me._page + 1;
				me._virtualTop = top;
				// update text/innerHtml of list items
				selItems = me.options.selectedItems;
				selLen = selItems ? selItems.length : 0;
				me._selElems = [];
				while ((count -= 1) >= 0) {
					elem = me._renderRow(count, 1);
					// update css of selected list items
					if (elem) {
						for (selID = 0; selID < selLen; selID += 1) {
							if (selItems[selID].index === count + top) {
								me._selElems.push(elem);
								me._fixSelElem(elem, 1);
								break;
							}
						}
						if (selID >= selLen) {
							me._fixSelElem(elem);
						}
					}
				}
				// restore active css for current active item
				me._fixActive(me._activeID, 1);
			}
			// N.A. 02/17/2014 Bug #164393 - (Code Removed) Re-render (re-paint) the visible elements, only when virtualization is enabled.
		},
		_lodLbl: function () {
			var i = -1, dd = this.listElem;
			while (i++ < 3 && this._lodFoot && dd) {
				dd.find('[data-lod' + i + ']').html(this.getRecordsCount(i));
			}
		},
		_touch: function (act) {
			var scroll, dd = this._ddCont;
			if (dd && dd.igScroll) {
				scroll = dd.data('igScroll');
				if (!act) {
					// get around bugs in Android: diminish functionality of igScroll: do not use [cancelStart:true]
					return scroll ? scroll.barY : dd.igScroll({ direction: 'y', yThumb: 'draggable', yScroller: this._ddScroll, cancelStart: 'ms' }).attr('data-scroll', 'y');
				}
				if (scroll) {
					scroll[act](true);
				}
			}
		},
		// if element was moved, then close drop-down list
		_xyCheck: function (stop) {
			var xy = this._xy, xyE = this.mainElem;
			if (!xy) {
				return;
			}
			if (xyE) {
				xyE = _offset(xyE);
				if (Math.abs(xyE.left - xy.x) > 2 || Math.abs(xyE.top - xy.y) > 2) {
					stop = true;
				}
			}
			if (stop || !xyE) {
				delete this._xy;
				clearInterval(xy.i);
				this._doDrop();
			}
		},
		// focus/dropdown interactions with igValidator
		// act: 'drop'-show dropdown, 'hide'-hide dropdown, true-focus, undefined/false-blur/remove
		// return: true-cancel action
		_vAct: function (act) {
			return $.ui.igValidator && $.ui.igValidator._act(this, act);
		},
		// show/hide/create drop-down list
		// show: 0-hide, 1-toggle, 2-show
		_doDrop: function (show, e, repaint) {
			var height, needScroll, winHeight, y, bodyElem, row1st, rowLast, max, end, step, docElem,
				xy, effect, width, body, i, duration, arg, listWidth, footer, callback,
				me = this,
				lod = me._lod,
				lodWait = me._lodWait,
				up = me._listUp,
				extraHeight = me._extraHeight || 0,
				ddCont = me._ddCont,
				o = me.options,
				rtl = me._rtl,
				virtual = o.virtualization,
				dd = me.listElem,
				itemsHolder = me._itemsHolder,
				ddScroll = me._ddScroll,
				elem = me.mainElem,
				dif = me._ddItemBorderFix,
				on = me._ddOn,
				count = me._count,
				itemHeightOuter = me._itemHeightOuter;
			repaint = repaint || me._listChanged;
			// editable:0, dropdown:1, readonlylist:2, readonly:3
			if (me._mode(o) > 2) {
				show = 0;
			}
			if (!elem || (!show && !on) || (show === 2 && on)) {
				return;
			}
			if (!repaint && on && show && _now() - on < 100) {
				return;
			}
			show = show ? (repaint || !on) : false;
			// check for failed validation of igEditor
			if (me._vAct(show ? 'drop' : 'hide')) {
				return;
			}
			if (!itemHeightOuter && count && show) {
				repaint = true;
			}
			if (!me._hasData) {
				if (show && o.dataBindOnOpen && !me._dataSource) {
					// N.A. 6/5/2014 Bug #172021 Add laoding indicator and also show drop down window after data is bound
					me._wait(true);
					callback = function () {
						this._dataChange();
						this._doDrop(2);
						this._wait(false);
					}
					me.dataBind(callback);
				}
				return;
			}
			// row1st: reference to _noResults (noMatchFoundText) element
			if (count < 1 && me._filtering) {
				row1st = me._noResults;
				if (!row1st) {
					me._noResults = row1st = _notab($('<li />').css({ width: '100%', textAlign: 'center' }).addClass(me.css.listItem).html(me._locale('noMatchFoundText') || '&nbsp;'));
				}
			}
			if ((!show || (show && !on)) && !me._fire(show ? 'dropDownOpening' : 'dropDownClosing', e, arg = { owner: me, element: dd || $('<div/>') })) {
				return;
			}
			if (!lodWait && show && me._activeID >= 0 && !me.isSelected(me._activeID) && (i = me.selectedIndex()) >= 0) {
				me._activate(me._scrollTo = i, e, 1);
			}
			body = !o.dropDownAsChild;
			if (!dd) {
				repaint = false;
			}
			// create ensure drop-down list, and recalculate all required members
			if (!dd || repaint) {
				delete me._listChanged;
				if ((width = parseInt(o.dropDownWidth, 10)) < 5 || isNaN(width)) {
					if ((width = elem[0].offsetWidth) < 5) {
						width = 100;
					}
				}
				// create list all its child-containers
				// data-id: _listIDShift-1:drop-down
				if (!dd) {
					dd = me.listElem = ddScroll = ddCont = _notab(arg.element.attr('data-id', _listIDShift - 1).css('position', 'absolute').addClass(me.css.list)
						.bind(me._mEvts).bind({
							DOMMouseScroll: function (e) { me._onEvt(this, 10, e); },
							mousewheel: function (e) { me._onEvt(this, 10, e); }
						}));
					footer = o.footerTemplate;
					if (o.headerTemplate || footer) {
						// get around bugs in Android
						dd.css('overflow', 'hidden');
						if (o.headerTemplate) {
							_notab($('<div/>').attr('data-id', _listIDShift - 1).css({ overflow: 'hidden', position: 'relative' }).html(o.headerTemplate).appendTo(dd));
						}
						ddScroll = ddCont = _notab($('<div/>').attr('data-id', _listIDShift - 1).css('position', 'relative').appendTo(dd));
						if (footer) {
							i = footer;
							footer = footer.replace(this.RECORDS_VIEW, '<span data-lod0="x"></span>')
								.replace(this.RECORDS_DATA, '<span data-lod1="x"></span>')
								.replace(this.RECORDS_SERVER, '<span data-lod2="x"></span>')
								.replace(this.RECORDS_SERVER_TOTAL, '<span data-lod3="x"></span>');
							me._lodFoot = i !== footer;
							_notab($('<div/>').attr('data-footer', 'x').attr('data-id', _listIDShift - 1).css({ overflow: 'hidden', position: 'relative' }).html(footer).appendTo(dd));
						}
						// set flag to calculate offsetHeights of footer and header
						extraHeight = 1;
					}
					me._ddCont = ddCont;
					me._itemsHolder = itemsHolder = _notab($('<ul/>').attr('data-id', _listIDShift - 1).addClass(me.css.listItemHolder).appendTo(ddCont));
					if (virtual) {
						ddCont.css({ overflow: 'hidden' });
						me._ddScroll = ddScroll = _notab($('<div/>').attr('data-id', _listIDShift - 1).css({ width: '30px', height: '100%', overflowY: 'scroll', overflowX: 'hidden', 'float': rtl ? 'left' : 'right' }).appendTo(ddCont));
						me._ddScrollChild = _notab($('<div/>').attr('data-id', _listIDShift - 1).css({ width: '1px', height: '1px' }).appendTo(ddScroll));
					}
					// process scroll events
					ddScroll.scroll(function (e) {
						me._onScroll(e);
					});
					if (me._rtl) {
						dd.css('direction', 'rtl');
					}
					if (body) {
						dd.css({ left: '0px', top: '0px' }).appendTo($('body'));
					} else {
						dd.prependTo(elem);
					}
					me._ddBorderFix = dd.outerWidth() - dd.width();
					if (extraHeight) {
						ddCont.hide();
						dd.css('width', width - me._ddBorderFix);
						me._extraHeight = extraHeight = dd[0].clientHeight;
						dd.css('width', 'auto');
						ddCont.show();
					}
				}
				// show drop-down for calculation of offsets
				dd.css({ display: 'block' });
				listWidth = (width -= me._ddBorderFix);
				// if row1st is not null, then it is reference to _noResults (noMatchFoundText) element
				if (row1st) {
					if (itemsHolder.has(row1st).length === 0) {
						row1st.appendTo(itemsHolder);
					}
					itemHeightOuter = Math.max(10, row1st.outerHeight());
					dif = 0;
				} else if (!lodWait) {
					if (virtual) {
						ddScroll.hide();
						itemsHolder.css({ width: 'auto', height: 'auto', overflow: 'visible', 'float': 'left' });
					} else {
						// missing _keyFixed: request to fill up _key_ column before filtering
						// all list items will be created and filled up
						me._keyFixed = 1;
					}
				}
				// first rendering: calculate borders of cell and its height/outerHeight
				if (!itemHeightOuter && count > 0) {
					me._itemWidth = width = Math.ceil(width - 1);
					me._itemHeight = 'auto';
					// create first item to calculate width/height/heightOuter
					row1st = me._renderRow(0);
					if ((height = row1st.height()) < 5) {
						height = 16;
					}
					//me._liIE7Bug = Math.max(0, itemsHolder[0].offsetHeight - row1st[0].offsetHeight);
					row1st.css({ height: me._itemHeight = height });
					me._ddItemBorderFix = dif = Math.max(0, Math.floor(row1st.outerWidth() - row1st.width() + 0.4));
					if (dif > 0) {
						me._itemWidth = (width -= dif);
					}
					// get around IE7/6 bugs: when checkboxes are enabled, then IE may create 3px padding between LIs
					me._itemHeightOuter = itemHeightOuter = row1st.outerHeight() + Math.max(0, itemsHolder[0].offsetHeight - row1st[0].offsetHeight);
					// ensure that dd-container has same backgroundColor as row1st-item
					me._sameBC(row1st, dd);
				}
				itemHeightOuter = itemHeightOuter || 0;
				// width/height of drop-down container
				me._listHeight = Math.max(10, Math.max((max = o.dropDownMinHeight) - extraHeight, itemHeightOuter * (count || 1)));
				max = Math.min(Math.max(0, Math.max(max, o.dropDownMaxHeight) - extraHeight), me._listHeight);
				if (lod) {
					max = Math.min((lod - 1) * itemHeightOuter, max);
				}
				height = ddCont.css('height');
				height = (repaint && height && height.indexOf('px') > 0) ? parseFloat(height) : max;
				dd.css('width', listWidth);
				// flag for large list: use vertical scrollbar
				needScroll = me._listHeight > max;
				if (virtual) {
					me._ddScrollChild.css('height', me._listHeight + itemHeightOuter);
					ddCont.css('height', me._listHeight = max);
					dd.css('height', max + extraHeight);
					// scrollbar is required
					if (needScroll) {
						ddScroll.show();
						ddScroll.css('width', width = ddScroll[0].offsetWidth - ddScroll[0].clientWidth + 1);
						width = listWidth - width;
						itemsHolder.css({ width: width, height: '100%', overflow: 'hidden', 'float': rtl ? 'right' : 'left' });
						width -= dif;
						count = Math.ceil(max / itemHeightOuter + 1);
					} else {
						ddScroll.hide();
						itemsHolder.css('width', '100%');
					}
				} else {
					// if calcultaions for some reason failed, then hidden overflowX should cover that
					ddCont.css({ overflow: needScroll ? 'auto' : 'hidden', width:  listWidth, height: me._listHeight = max }).css('overflowX', 'hidden');
					dd.css('height', max + extraHeight);
					// scrollbar is required
					if (needScroll) {
						// ensure/force scrollbar by temporary inserting absolute html-element far down
						rowLast = $('<div/>').css({ position: 'absolute', top: (max + 100) + 'px', width: 9, height: 9 }).appendTo(ddCont);
						// get around bug in scrollbars of IE7: double dummy call to ddCont[0].clientWidth
						width = ddCont[0].clientWidth;
						width = ddCont[0].clientWidth - dif;
						rowLast.remove();
					}
				}
				// no scrollbar
				if (!needScroll) {
					width = listWidth - dif;
				}
				me._itemWidth = width;
				// create all rows besides row1st is it was already created
				this._repaintList(0, count);
				me._page = itemHeightOuter ? Math.max(2, Math.floor(max / itemHeightOuter)) : 1;
				if (repaint && on) {
					if (me._needsSel) {
						me._fixSelScroll(-1);
						delete me._needsSel;
					}
					// animate changed height
					i = me._listHeightLast;
					height = me._listHeight + extraHeight;
					dif = i - height;
					if (up) {
						end = me._listTop;
						me._listTop += dif;
					}
					me._listHeightLast = height;
					if (dif) {
						if ((duration = (dif < 0) ? o.animationShowDuration : o.animationHideDuration) > 5) {
							dd.css('height', i).animate({ height: height },
								{
									duration: duration,
									// synchronize location of list with height if it is above field
									step: function (now) {
										if (up) {
											dd.css(body ? 'top' : 'marginTop', end + dif * (i - now) / (i - height));
										}
									}
								});
						} else if (up) {
							dd.css(body ? 'top' : 'marginTop', end + dif);
						}
					}
					return;
				}
			}
			// actual height of drop-down list
			height = me._listHeightLast = me._listHeight + extraHeight;
			// save time when drop-down was displayed
			me._ddOn = show ? _now() : null;
			duration = show ? o.animationShowDuration : o.animationHideDuration;
			if (!duration || (typeof duration === 'number' && duration < 5)) {
				duration = null;
			} else {
				effect = show ? o.animationShowEffect : o.animationHideEffect;
				if (!$.effects || !$.effects[effect]) {
					if (!show && typeof duration !== 'number') {
						duration = 450;
					}
					effect = null;
				}
			}
			// starting height for show-animation, ending height for hide-animation
			me._listHeightEnd = (duration && !effect) ? 0 : height;
			end = function () {
				if (show) {
					dd.css('filter', '');
					// ensure that selected items have selected css and scroll is correct
					me._fixSelScroll(me._scrollTo);
					me._touch();
				} else {
					dd.css({ display: 'none' });
					me._touch('_hide');
				}
				me._fire(show ? 'dropDownOpened' : 'dropDownClosed', e, arg);
			};
			step = function (now, fx) {
				if (me._listUp && fx && fx.prop === 'height') {
					dd.css(body ? 'top' : 'marginTop', me._listTop + height - now);
				}
			};
			// show list
			if (show) {
				me._lodLbl();
				me.setFocus();
				if (me._needsPaint) {
					me._repaintList();
				}
				if (!body && (!me._static || me._relative)) {
					elem.css('overflow', 'visible');
				}
				if (me._needsSel) {
					me._fixSelScroll(-1);
					delete me._needsSel;
				}
				// validate if drop-down fits in window
				// winHeight: client height of window
				winHeight = 999;
				bodyElem = document.body;
				docElem = document.documentElement;
				// process window (not IE)
				if ((i = window.innerHeight) > 50 && i) {
					winHeight = i;
				} else if ((i = docElem.clientHeight) > 50 && i) {
					winHeight = i;
				} else if ((i = bodyElem.clientHeight) > 50 && i) {
					winHeight = i;
				}
				// y: scrollTop of window
				y = Math.max(window.pageYOffset || 0, Math.max(bodyElem.scrollTop, docElem.scrollTop));
				xy = _offset(elem);
				me._xy = body ? { x: xy.left, y: xy.top } : null;
				xy.height = elem[0].offsetHeight;
				me._listUp = null;
				// if enough space for drop-down below editor
				if ((up = xy.top + xy.height + height - y - winHeight) > 0 && y - xy.top + height < up) {
					me._listUp = up;
					// shift drop-down above editor
					// do not adjust for 0 under filtering: height/top can be changed without hide/show (repaint flag)
					if (xy.top - (up = height + 2) < y && !me._filtering) {
						// do not allow drop-down go above top edge of window
						up = Math.max(xy.top - y, 2);
					}
					// xy.height is used for "marginTop", when drop-down is local to editor
					// xy.top is used for "top", when drop-down belongs to body
					xy.top += (xy.height = -up) + _px(elem, 'borderTopWidth');
					elem.addClass(me.css.noTopCorners);
					dd.addClass(me.css.noBottomCorners);
				} else {
					// show drop-down below editor
					// xy.top is used for "top", when drop-down belongs to body
					xy.top += xy.height - _px(elem, 'borderBottomWidth');
					elem.addClass(me.css.noBottomCorners);
					dd.addClass(me.css.noTopCorners);
				}
				// initial styles before show-animation
				dd.css({ opacity: (duration && !effect) ? 0 : 1, height: me._listHeightEnd, display: '' });
				if (body) {
					dd.css({ left: xy.left, top: me._listTop = xy.top });
					me._xy.i = setInterval(function () {
						me._xyCheck();
					}, 300);
				} else {
					i = me._rtl ? 'Right' : 'Left';
					dd.css('margin' + i, -_px(elem, 'border' + i + 'Width') + 'px');
					up = me._listUp ? 0 : _px(elem, 'borderTopWidth') + _px(elem, 'borderBottomWidth');
					dd.css('marginTop', me._listTop = xy.height - up);
					// IE in quirks mode shifts drop-down to the right edge
					up = _offset(dd);
					if ((up = up.left - xy.left) > 30 && up < elem[0].offsetWidth + 10) {
						dd.css('marginLeft', -up + 'px');
					}
				}
				if (!duration) {
					end();
				} else if (effect) {
					dd.show(effect, {}, duration, end);
				} else {
					dd.animate({ opacity: 1, height: height }, {
						duration: duration,
						complete: function () { end(); },
						// synchronize location of list with height if it is above field
						step: function (now, fx) { step(now, fx); }
					});
				}
			// hide list
			} else {
				if (!body && (!me._static || me._relative)) {
					elem.css('overflow', 'hidden');
				}
				me._xyCheck(true);
				elem.removeClass(me.css.noTopCorners).removeClass(me.css.noBottomCorners);
				dd.removeClass(me.css.noBottomCorners).removeClass(me.css.noTopCorners);
				if (!duration) {
					end();
				} else if (effect) {
					dd.hide(effect, {}, duration, end);
				} else {
					dd.animate({ opacity: 0, height: me._listHeightEnd }, {
						duration: duration,
						complete: function () { end(); },
						// synchronize location of list with height if it is above field
						step: function (now, fx) { step(now, fx); }
					});
				}
			}
			return true;
		},
		// repaint only visible items in drop-down list
		_repaintList: function (id, count) {
			if (this._noMouse()) {
				return;
			}
			var me = this, repaint = !count;
			// repaint only visible items in drop-down list
			if (repaint) {
				id = Math.max(0, this._topID - 1);
				// if no virtual scroll and no matching items, then nothing to repaint
				count = id + ((this._page && (this._ddScroll || this._matchFlag)) ? this._page + 3 : -1);
			}
			count = Math.min(count, this._count);
			delete this._needsPaint;
			// short cut used by _renderMatches
			this._textsTemp = this._texts(1);
			if (!repaint && (!this._lodWait || (this._lod && this._filtering === -1))) {
				this._html = ' ';
			}
			while (id < count) {
				this._renderRow(id, repaint);
				id += 1;
			}
			if (this._html) {
				// this._bindLI: flag to bind events for LIs and checkboxes (jquery does it very slow)
				this._itemsHolder.html(this._html.substring(this._bindLI = 1));
				delete this._html;
				// backup to attach events for touch devices
				setTimeout(function () { me._bindLIs(); }, 600);
			}
			if (this._paintAct) {
				this._fixActive(this._activeID, 1);
			}
			delete this._textsTemp;
		},
		_startOfSelTrail: function (field, txt, len) {
			var range, sep, end = 0, start = 0, tr = this._tr();
			// not IE
			if (tr === 1) {
				start = field.selectionStart;
				end = field.selectionEnd;
			} else if (tr) {
				// IE
				try {
					// IE8 may raise exception on next line
					range = document.selection.createRange();
					tr = range.duplicate();
					tr.move('textedit', -1);
					try {
						while (tr.compareEndPoints('StartToStart', range) < 0) {
							tr.moveStart('character', 1);
							if ((start += 1) > len) {
								break;
							}
						}
					} catch (ex) { }
					end = start + range.text.length;
				} catch (e2) { }
			}
			// check if backspace is about to remove item 2-character-separator
			if (start === len && len > 2) {
				sep = this._sep();
				if (sep.length > 1 && txt.charAt(len - 1) === sep.charAt(1) && txt.charAt(len - 2) === sep.charAt(0)) {
					// request to remove 2 characters in front of caret
					return start - 1;
				}
			}
			return (start < end && end === len) ? start : 0;
		},
		// for IE return createTextRange
		// for not IE return 1
		// return null for unknown browser or error
		_tr: function () {
			var field = this.fieldElem[0], tr = this._trVar;
			if (!tr) {
				try {
					// not IE
					// N.A. 12/18/2013 Bug #160069: Include IE11, because it deprecates document.selection
					if ((!$.ig.util.isIE || $.ig.util.isIE11) && !_aNull(field.selectionStart)) {
						tr = 1;
					}
				} catch (ex) { }
				if (tr !== 1) {
					try {
						// IE
						tr = field.createTextRange ? field.createTextRange() : null;
					} catch (e2) { }
				}
				this._trVar = tr;
			}
			return tr;
		},
		// set start/end selection in field
		_setCaret: function (start, end) {
			var tr = this._tr();
			end = end || start;
			if (tr) {
				try {
					// not IE
					if (tr === 1) {
						tr = this.fieldElem[0];
						tr.selectionStart = start;
						tr.selectionEnd = end;
						return;
					}
					// do not set focus after selection
					if (this._selTime && _now() - this._selTime < 50) {
						return;
					}
					// IE
					end -= start;
					tr.move('textedit', -1);
					tr.move('character', start);
					if (end > 0) {
						tr.moveEnd('character', end);
					}
					// IE8 may raise exception on next line
					tr.select();
				} catch (ex) { }
			}
		},
		// fill-up and select text in field from not entered part of text defined by 1st matching list item
		// at this point selectedItems should contain all possible values in field
		// In case of local filtering, that method can be called from setTimeout.
		// In case of remote filtering, that method can be called after dataBind.
		_autoComplete: function (filter) {
			var len, txt, selStart, e, backKey, item, tr, txts, ii, last,
				i = -1,
				id = this._filtering ? this._activeID : this._changeID,
				field = this.fieldElem,
				args = this._acArgs,
				sel = '',
				selEnd = 0,
				o = this.options,
				selItems = o.selectedItems,
				itemsLen = selItems ? selItems.length : 0,
				sep = this._sep();
			// containers of values to perform autoComplete
			if (!args || this._noMouse()) {
				return;
			}
			delete this._acArgs;
			txt = args.txt;
			selStart = args.len;
			e = args.e;
			if (e && e.keyCode === $.ui.keyCode.DELETE && this._custom()) {
				return;
			}
			backKey = args.backKey;
			len = txt.length;
			// list has selected item(s)
			if (itemsLen > 0) {
				if (filter) {
					id = -1;
				}
				// identify which items in list correspond to items in field
				// and synchronize order of items in list with order of items in field
				txts = txt.split(sep);
				tr = selItems;
				selItems = [];
				filter = field.val();
				while ((i += 1) < itemsLen) {
					item = tr[i].text;
					for (ii = 0; ii < txts.length; ii += 1) {
						// item in list matches with item in field
						if (txts[ii] === (o.caseSensitive ? item : item.toLowerCase())) {
							selItems[ii] = item;
							if (filter === txts[ii] && filter !== item) {
								field.val(item);
							}
							break;
						}
					}
					// no match found: use item in list for partial match to fill up the rest of field
					if (ii === txts.length && !last) {
						last = item;
					}
				}
				// build final text in field from matches
				// and append last item (assume partial match) to the end
				while (i >= 0) {
					item = (i < itemsLen) ? selItems[i] : last;
					if (item) {
						if (sel.length > 0) {
							sel = sep + sel;
						}
						sel = item + sel;
					}
					i -= 1;
				}
			}
			filter = null;
			item = (id >= 0) ? this._item(id, 2) : null;
			if (item && (!sel || sel !== item)) {
				if (sel) {
					sel += sep;
				}
				sel += item;
			}
			// if multiselection and caret at the end of text
			// if not backspace and text ends with 1st char of separator,
			// then append separator to final text
			if (sel && len > 1 && selStart === len && this._multi(o) && !backKey && txt.charAt(len - 1) === sep.charAt(0)) {
				if (id >= 0) {
					this._addSel(id, e);
					this._fixSelScroll(-1);
				}
				txt = (sel += sep);
				// set request for filtering: recreate list items
				filter = selStart = i = sel.length;
			}
			this._userTxt = txt;
			// no matches: show error message
			if (!sel) {
				if (len > 0 && !this._filtering) {
					this._fire('noMatchFound', e, { owner: this, text: txt });
				}
				if (!backKey) {
					// no need to adjust caret/selection
					return;
				}
			} else if (selStart < (selEnd = sel.length) || i > 0) {
				// fill-up end of text in field from item in list
				field.val(this._oldTxt = sel);
			} else if (backKey) {
				// back-key at the end of text
				selEnd = selStart = len;
			} else {
				// no need to adjust caret/selection
				return;
			}
			this._setCaret(selStart, selEnd);
			this._userTxt = txt.substring(0, selStart);
			// flag used by _onChange to check if user autoCompleted last key-entry by same char as in displayed text
			this._selLen = selEnd - selStart;
			if (filter && this._multi(o) && this._filtering) {
				this.filter(e, null, this._noFilter);
			}
		},
		// flag:
		//   null-key/text/focus event: update selected list items
		//   1-call from its own setTimeout or recursive call
		//   2-call from list-selection: do not update selected list items
		// text: possible new text for field (clear button, Esc, set-currentText, select from list, etc.)
		// backKey: true means that event is coming from BACK key-event
		_onChange: function (e, flag, text, backKey) {
			var selStart, len, txt, autoComplete,
				me = this,
				field = me.fieldElem,
				old = me._oldTxt,
				o = me.options;
			if (!field || !field[0]) {
				return;
			}
			txt = e ? e.type : null;
			// check source of change (not Enter, not mouse, not blur)
			if (txt && e.keyCode !== 13 && txt.indexOf('blur') < 0 && txt.indexOf('mouse') < 0 && me._userTxt !== text) {
				delete me._noFilter;
			}
			if (me._hasData && me._nullT && flag === undefined && !me._fcs) {
				me._fixNull(1);
			}
			if (!_aNull(text)) {
				field.val(me._userTxt = text);
				// in case of empty text
				text = 1;
			}
			txt = me.text();
			len = txt.length;
			if (e && e.type !== 'blur' && (text || flag === 2)) {
				me._setCaret(len);
			}
			// this._expr - object/flag for remote filtering waiting: waiting response from server
			// if there is backKey and trailing selection (from previous call to _autoComplete), then erase character before caret
			if (!me._expr && backKey === true && o.autoComplete && len > 0 && (selStart = me._startOfSelTrail(field[0], txt, len)) > 0) {
				// erase character before caret and prevent default processing of back-key
				_stop(e);
				return me._onChange(e, 1, txt.substring(0, selStart - 1), 2);
			}
			// If user autoCompleted highlighted last-char entry by same-last key, then old and new texts will be the same.
			// In this case use length of selection set by _autoComplete.
			if (txt !== old || (me._selLen === 1 && !flag && me._userTxt && old.length - me._userTxt.length === 1)) {
				if (txt === old) {
					// update this._userTxt for _autoComplete
					me._userTxt = old;
				}
				delete me._filterTxt;
				me._oldTxt = txt;
				// adjust _clearOn and call _doSize() if needed: show/hide clear button
				me._fixClear();
				me._needsPaint = 1;
				if (e) {
					me._fire('textChanged', e, { owner: me, oldText: old, text: txt });
					// notify igValidator about change
					if (me._validator) {
						me._validator._evt(e);
					}
				}
				autoComplete = o.autoComplete && (len > 0 || backKey);
				if (me._filtering) {
					// if change is coming from selection in list, then do not filter
					if (flag === 2 && me._multi(o)) {
						me._repaintList();
						return;
					}
					// update this._userTxt for _autoComplete
					me._userTxt = txt;
					me.filter(e, null, me._noFilter);
				} else {
					// not from list-selection
					if (flag !== 2) {
						me._select(null, txt, 2, 1, e);
					}
					if (!autoComplete) {
						// update this._userTxt
						me._userTxt = txt;
						me._repaintList();
					}
				}
				// fill-up and select missing text from matching list item
				if (autoComplete) {
					// settings for _autoComplete: that can be called by _dataChange after remote filtering
					me._acArgs = { txt: txt, len: len, e: e, backKey: backKey };
					// not remote filtering
					if (me._filtering >= 0) {
						setTimeout(function () {
							if (!me._jpn) {
								me._autoComplete();
							}
							me._repaintList();
						}, 0);
					}
				}
			}
			if (!flag) {
				setTimeout(function () { me._onChange(e, 1); }, 10);
			} else {
				me._save(o);
				if (e && !me._ddOn && me._fcs) {
					me._doDrop(1, e);
				}
			}
		},
		// save selection, values and current text into server-view-state field
		_save: function (o) {
			var item, input, select, sel, i = -1, str = '', name = o.inputName;
			if (!name || !this._hasData || this._waitFilter) {
				return;
			}
			input = $('input[name="' + name + '"]');
			if (input[0] === this.element[0]) {
				return;
			}
			if (input.length === 0) {
				input = $('select[name="' + name + '"]');
				select = input.length;
				if (select) {
					input.empty();
				} else {
					input = $('<input type="hidden" name="' + name + '" />').appendTo(this.element.parent());
				}
			}
			sel = o.selectedItems;
			while (sel && (i += 1) < sel.length) {
				item = this._item(sel[i].index);
				if (item && item.getTime) {
					item = item.getFullYear() + '-' + (item.getMonth() + 1) + '-' + item.getDate() + ' ' + item.getHours() + ':' + item.getMinutes() + ':' + item.getSeconds() + '.' + item.getMilliseconds();
				}
				if (select) {
					$('<option value="' + item + '" selected="selected" >').appendTo(input);
				} else {
					if (i > 0) {
						str += ',';
					}
					str += item;
				}
			}
			if (i < 1 && this._custom()) {
				str = this.text();
				if (select) {
					$('<option value="' + str + '" selected="selected" >').appendTo(input);
				}
			}
			if (!select) {
				input.val(str);
			}
		},
		_onKey: function (e, type) {
			var k = e ? (e.keyCode || e.which) : null,
				me = this,
				on = me._ddOn,
				id = me._activeID,
				o = me.options,
				kc = $.ui.keyCode,
				selItems = o.selectedItems,
				back = k === kc.BACKSPACE,
				count = me._count - 1,
				mode = me._mode(o);
			if (type < 2 && !me._fire((type === 0) ? 'keydown' : 'keypress', e, { owner: me, keyCode: k })) {
				return _stop(e);
			}
			// select active item
			// mode: editable:0, dropdown:1, readonlylist:2, readonly:3
			if (type < 2 && k === kc.SPACE && (mode > 0 || (o.selectItemBySpaceKey && id >= 0 && o.enableActiveItem && on))) {
				_stop(e);
				if (mode < 2 && id >= 0 && type === 0) {
					me._fixSelScroll(id, e, null, null, 1);
				}
				return;
			}
			// S.S. April 23, 2013 Bug #140481. If combo is focused DELETE key should be intercepted so that it doesn't reach
			// the Updating handler which will delete the currently selected row.
			if (k === 46) {
				e.stopPropagation();
			}
			// assume that change will not happen on action keys and keyup
			if (type < 2 && (back || k > 40 || k === kc.SPACE) && mode === 0) {
				// 229-japanese keyboard
				me._jpn = k === 229;
				me._onChange(e, null, null, back);
			}
			// keydown: process only action keys
			if (type === 0) {
				if (e.shiftKey) {
					return;
				}
				if (k === kc.ESCAPE) {//27
					if (!on) {
						setTimeout(function () { me._onChange(e, null, me._focTxt); }, 0);
					} else {
						_stop(e);
						me._doDrop(0, e);
					}
				}
				if ((on || id >= 0) && (k === kc.ENTER || k === kc.NUMPAD_ENTER)) {//13,108
					_stop(e);
					// editable:0, dropdown:1, readonlylist:2, readonly:3
					if (mode < 2) {
						if (id >= 0 && o.enableActiveItem && !me.isSelected(id)) {
							me._fixSelScroll(id, e, null, null, 1);
						}
						me._updateFromList(e);
					}
					me._doDrop(0, e);
				}
				// process only action keys
				if (k < 33 || k > 40) {
					return;
				}
				if (e.ctrlKey) {
					return;
				}
				if (!e.altKey && !e.metaKey) {
					if (me._count < 1) {
						return;
					}
					// find id of last/min selected item
					if (id < 0) {
						if (!on && k !== kc.DOWN && k !== kc.UP) {
							return;
						}
						id = count + 1;
						back = selItems ? selItems.length : 0;
						while ((back -= 1) >= 0) {
							id = Math.min(selItems[back].index, id);
						}
						if (id > count) {
							id = 0;
						}
					} else if (k === kc.DOWN) {
						id += 1;
					} else if (k === kc.UP) {
						id -= 1;
					} else if (k === kc.HOME && on) {
						id = 0;
					} else if (k === kc.END && on) {
						id = count;
					} else if (k === kc.PAGE_DOWN && on) {
						id += me._page;
					} else if (k === kc.PAGE_UP && on) {
						id -= me._page;
					} else {
						return;
					}
					_stop(e);
					if ((id = Math.max(Math.min(id, count), 0)) !== me._activeID) {
						if (me._activate(id, e)) {
							if (on) {
								me._fixSelScroll(id, e, null, 1);
							} else {
								me.selectedIndex(id, true);
							}
						}
					}
				// check for short-cut to show/hide list
				} else if ((k === kc.DOWN && !on) || (k === kc.UP && on)) {
					return me._doDrop(on ? 0 : 1, e);
				}
			}
		},
		_sep: function () {
			var sep = this.options.itemSeparator || ',';
			return (sep.length > 2) ? sep.substring(0, 2) : sep;
		},
		// update field from selected items in list
		_updateFromList: function (e, zero, addSep) {
			var id = this._changeID,
				txt = '',
				o = this.options,
				i = -1,
				sep = this._sep(),
				selItems = this._addSel((id === this._activeID) ? id : -1, e),
				len = selItems ? selItems.length : 0;
			delete this._jpn;
			if (this._noMouse()) {
				return;
			}
			// remove active/change cell set by keyboard: do not autoComplete, etc.
			this._changeID = -1;
			if (!this._multi(o) && len > 1) {
				len = 1;
			}
			while ((i += 1) < len) {
				txt += this._item(selItems[i].index, 2);
				if (i + 1 < len || addSep) {
					txt += sep;
				}
			}
			if (txt.length > 0 || zero) {
				this._onChange(e, 2, txt);
			}
		},
		// find reference to list-item for row at index id
		_findItem: function (id) {
			var dd = this._itemsHolder;
			if (dd) {
				// adjust for virtual scroll: 'data-id' contains only visible indexes starting from 0
				id -= this._virtualTop;
				dd = dd.find('[data-id="' + (id + _listIDShift) + '"]');
				if (dd.length === 1) {
					return dd;
				}
			}
		},
		// add/remove selected items in list, update field, scroll list
		_fixSelScroll: function (id, e, elem, key, ctrl) {
			if (this._fixSel(id, e, elem, key, ctrl)) {
				return;
			}
			if (e) {
				this._updateFromList(e, ctrl);
				if (!ctrl && !key && this.options.closeDropDownOnSelect) {
					this._doDrop(0, e);
				}
			}
			if (key || !e) {
				this._fixScroll(id);
			}
		},
		_fixActive: function (id, on) {
			var css = this.css.listItemActive, elem = (id >= 0 && this.options.enableActiveItem) ? this._findItem(id) : null;
			if (elem) {
				if (on) {
					elem.addClass(css);
				} else {
					elem.removeClass(css);
				}
				delete this._paintAct;
			} else if (on) {
				this._paintAct = 1;
			}
		},
		// change active item in list and raise events
		// return 1 if active-item behavior is not enabled
		_activate: function (id, e, noScroll) {
			if (!this.options.enableActiveItem || this._noMouse()) {
				this._activeID = id;
				return 1;
			}
			var arg, old = this._activeID;
			if (old !== id && this._fire('activeItemChanging', e, arg = { owner: this, oldIndex: old, index: id })) {
				this._fixActive(old);
				this._fixActive(this._activeID = id = arg.index, 1);
				if (id >= 0 && !noScroll && (!e || e.type !== 'mousedown')) {
					this._fixScroll(id);
				}
				this._fire('activeItemChanged', e, arg);
			}
		},
		// if(id >= 0) then add/remove selected items in list
		// if(id < 0) then ensure that selected items have selected css
		// if(!e), then only repaint and adjust html-elements: do not modify selectedItems
		// ctrl: flag for Ctrl key action: toggle selected item
		// key: flag from key-action (arrows, page, home, end)
		_fixSel: function (id, e, elem, key, ctrl) {
			var item,
				next = 0,
				i = id,
				o = this.options,
				selItems = this._copyA(o.selectedItems),
				len = selItems ? selItems.length : 0,
				oldSelElems = this._selElems,
				virtual = this._ddScroll,
				old = (virtual && id < 0) ? null : this._selElems;
			if (!this._ddOn || this._noMouse()) {
				return 1;
			}
			if (id >= 0 && !elem) {
				elem = this._findItem(id);
				if (!elem) {
					old = null;
					while (virtual && !elem && i >= 0 && i <= this._count && (next += 1) < 4) {
						this._fixScroll(i);
						this._onScroll(e);
						elem = this._findItem(id);
						i -= 1;
					}
				}
				if (!elem) {
					return 1;
				}
			}
			for (i = 0; i < len; i += 1) {
				item = old ? old[i] : null;
				if (!item) {
					item = this._findItem(selItems[i].index);
					if (item) {
						if (!old) {
							this._selElems = old = [];
						}
						this._fixSelElem(old[i] = item, 1);
					}
				}
				if (id < 0 || !item || !e) {
					continue;
				}
				if (item[0] === elem[0]) {
					if (!ctrl) {
						if (len === 1) {
							return;
						}
					} else {
						selItems.splice(i, 1);
						if (this._selChange(selItems, e)) {
							this._fixSelElem(elem);
							old.splice(i, 1);
							this._selChanged(e);
						} else {
							this._selElems = oldSelElems;
						}
						return;
					}
				} else if (!ctrl) {
					this._fixSelElem(item);
				}
			}
			// if !e, then it is request to repaint only
			if (!elem || !e) {
				return;
			}
			// i: flag to clear selection
			i = null;
			if (!ctrl || !selItems || !this._multi(o)) {
				// clear selection
				i = selItems = [];
				old = [];
			}
			selItems.push(this._createSelItem(id));
			if (this._selChange(selItems, e, i)) {
				this._activate(id, e);
				old = old || [];
				old.push(elem);
				this._selElems = old;
				this._fixSelElem(elem, 1);
				this._selChanged(e);
			} else {
				this._selElems = oldSelElems;
				for (i = 0; i < this._selElems.length; i++) {
					this._fixSelElem(this._selElems[i], true);
				}
				return 1;
			}
		},
		// adjust scroll to keep selected item visible
		// id: -1: show list, otherwise it is index of visible item
		_fixScroll: function (id) {
			var scroll, top,
				last = this._lastScroll,
				dd = this._ddScroll || this._ddCont,
				height = this._itemHeightOuter;
			if (!dd || this._lodWait) {
				return;
			}
			top = scroll = dd[0].scrollTop;
			this._scrollTo = -1;
			// show list
			if (id < 0) {
				if (last && last !== top) {
					dd[0].scrollTop = last;
					top = dd[0].scrollTop;
				}
				// get around scroll-bug in Safari after animation
				if ($.ig.util.isSafari && top > 20) {
					dd[0].scrollTop = top - 1;
				}
			} else if ((top = id * height) > scroll) {
				if ((top += height - this._listHeight) < scroll) {
					return;
				}
			}
			// if it is virtual mode and scroll-down is too small, then ensure value larger than height of item in list
			if (top !== last) {
				if (this._ddScroll && top > last) {
					top += height - 1;
				}
				dd[0].scrollTop = top;
			}
		},
		_bindLIs: function (o, li) {
			var me = this,
				holder = me._itemsHolder,
				elem = li;
			if (!me.mainElem) {
				return;
			}
			if (!li) {
				if (!this._bindLI || !holder) {
					return;
				}
				delete this._bindLI;
				elem = holder.find('li[data-id]');
			}
			elem.bind(me._mEvts);
			if (me._checkBox(o || this.options)) {
				if (!me._evtHov) {
					me._evtHov = {
						MSPointerOver: function (e) { me._onEvt(this, 26, e); },
						pointerover: function (e) { me._onEvt(this, 26, e); },
						mouseover: function (e) { me._onEvt(this, 16, e); },
						mouseleave: function (e) { me._onEvt(this, 17, e); }
					};
				}
				elem = li || holder;
				// get around bugs in Android: process and stop all touch events over checkboxes and icons
				elem.find('span[data-box]').bind(me._evtHov).bind(me._tEvts).find('span[data-icon]').bind(me._tEvts);
			}
		},
		// type: 3-mousedown, 4-mouseup, 6-mousedover, 7-mouseleave, 8-focus, 9-blur,
		// 10-wheel, 16-mouseoverCheckbox, 17-mouseleaveCheckbox, 26-MSPointerOver
		_onEvt: function (el, type, e) {
			var i, hovCss, pressCss,
				me = this,
				msOver = me._msOver,
				o = me.options,
				css = me.css,
				field = me.fieldElem,
				el$ = (!el || el === field[0] || (e && e.target === field[0])) ? field : $(el),
				id = el$.attr('data-id'),
				elem = me.mainElem,
				mode = me._mode(o);
			if (o.disabled) {
				return;
			}
			// focus
			if (type === 8) {
				me._focTxt = me.text();
				me._fcs = 1;
				elem.addClass(css.focus);
				field.addClass(css.fieldFocus);
				me._fixNull();
				// editable:0, dropdown:1, readonlylist:2, readonly:3
				if (mode < 3) {
					me.buttonElem.addClass(css.buttonFocus);
					me.clearElem.addClass(css.clearFocus);
				}
				if (!me._ddOn && o.dropDownOnFocus) {
					setTimeout(function () {
						if (me._fcs) {
							me._doDrop(1, e);
						}
					}, 50);
				}
				return;
			}
			// blur
			if (type === 9) {
				// get around Firefox-failure to raise japanese key events
				i = me.text();
				if (e && me._jpn && $.ig.util.isFF && me._userTxt !== i) {
					me._onChange(e, null, i);
				}
				me._jpn = me._fcs = 0;
				elem.removeClass(css.focus);
				field.removeClass(css.fieldFocus);
				me.buttonElem.removeClass(css.buttonFocus);
				me.clearElem.removeClass(css.clearFocus);
				if (!e) {
					return;
				}
				if (o.closeDropDownOnBlur) {
					me._doDrop(0, e);
				}
				if (!me._custom()) {
					me._updateFromList(e, 1);
				}
				// N.A. 03/17/2014 Bug #164390: Allow preserving the selected items when clearSelectionOnBlur is false.
				if (o.clearSelectionOnBlur || !o.allowCustomValue) {
					me._changeID = -1;
					me._onChange(e, null);
				}
				me._fixNull();
				// notify igValidator about blur event
				if (me._validator) {
					me._validator._evt(e, null, 1);
				}
				return;
			}
			// mouse wheel
			if (type === 10) {
				elem = me._ddScroll || me._ddCont;
				o = e.originalEvent || e;
				i = e.wheelDelta || o.wheelDelta || -(e.detail || o.detail);
				if (!_aNull(i, true) && elem) {
					_stop(e);
					elem[0].scrollTop += (i > 0) ? -me._itemHeightOuter : me._itemHeightOuter;
				}
				return;
			}
			if ($.ig.util && $.ig.util.evtButton(e)) {
				return;
			}
			// MSPointerOver: flag to skip mouseover for touch event (if pointerType=2)
			if (type === 26) {
				me._msOver = e.originalEvent.pointerType;
				return;
			}
			// that is continuation of MSPointerOver (2-touch event)
			if (msOver === 2 && (type === 6 || type === 16)) {
				delete me._msOver;
				return;
			}
			// mouseover/leave for checkbox
			if (!id && type > 15) {
				id = el$.parent().attr('data-id');
			}
			// id of element:
			// null=0: field
			// '1'=1: drop-down button
			// '2'=2: clear button
			// '_listIDShift'=99: container of drop-down
			// '_listIDShift'=100, '101'=101, etc: list items at index 0, 1, etc.
			id = (el$ === field) ? 0 : isNaN(id = id ? parseInt(id, 10) : -1) ? -1 : id;
			// request to bind events for LIs in list
			if (id > 90) {
				me._bindLIs(o);
			}
			if (id < 0 || (id > 98 && me._noMouse())) {
				return;
			}
			// mousedown
			if (type === 3) {
				_stop(e);
			}
			// mode: editable:0, dropdown:1, readonlylist:2, readonly:3
			if (mode > 1 && (type > 7 || id > 3)) {
				return;
			}
			// mouseover checkbox
			if (type === 16) {
				return el$.addClass(css.checkboxHover);
			}
			// mouseleave checkbox
			if (type === 17) {
				return el$.removeClass(css.checkboxHover);
			}
			hovCss = (id >= _listIDShift) ? (me._touch() && !(msOver && msOver !== 2) ? '' : css.listItemHover) : ((id === 1) ? css.buttonHover : css.clearHover);
			pressCss = (id >= _listIDShift) ? '' : ((id === 1) ? css.buttonPressed : css.clearPressed);
			// mousedown for button or drop-down list
			if (type === 3) {
				// clear and dropdown button
				if (id < 3) {
					el$.addClass(pressCss);
				}
				return;
			}
			// container of drop-down list
			if (id === _listIDShift - 1) {
				return;
			}
			// mouseup
			if (type === 4) {
				// list-item
				if (id >= _listIDShift) {
					delete me._jpn;
					// if target is checkbox, then fake Ctrl key
					me._fixSelScroll(id - _listIDShift + me._virtualTop, e, el$, null, e.ctrlKey || e.metaKey || me._isCheckBox(e.target));
				} else if (el$.hasClass(pressCss)) {
					// drop-down button
					if (id === 1) {
						// check for failed validation of igEditor
						if (me._vAct('drop')) {
							return;
						}
						me.setFocus();
						me._doDrop(1, e);
					}
					// clear button
					if (id === 2) {
						if (me._filtering) {
							me._select(-1);
						}
						me._onChange(e, null, '');
					}
					el$.removeClass(pressCss);
				}
				return;
			}
			// mouseover
			if (type === 6) {
				// field
				if (id === 0) {
					field.addClass(css.fieldHover);
					elem.addClass(css.hover);
				// buttons or list items
				} else {
					el$.addClass(hovCss);
				}
			}
			// mouseleave
			if (type === 7) {
				// field
				if (id === 0) {
					elem.removeClass(css.hover);
					field.removeClass(css.fieldHover);
					if (me._fcs === 1) {
						elem.addClass(css.focus);
					}
				// buttons or list items
				} else {
					el$.removeClass(hovCss).removeClass(pressCss);
				}
			}
		},
		// show/hide clear button
		_fixClear: function (size) {
			var o = this.options,
				show = o.enableClearButton && this._oldTxt.length > 0 && this._mode(o) < 2 && !o.disabled;
			// while japanese keyboard entry, size-change corrupts next key in Firefox
			if (this._jpn && $.ig.util.isFF) {
				return;
			}
			if (this._clearOn !== show) {
				this._clearOn = show;
				size = 1;
			}
			if (size) {
				this._doSize();
			}
		},
		// handle first paint and trigger adjustments for % width/height
		// flag=2: destroy timer
		// flag=1: create/ensure timer
		_doTimer: function (flag) {
			var me = this, timer = me._timer;
			if (flag === 2) {
				if (timer) {
					clearInterval(timer);
					delete me._timer;
				}
				return;
			}
			if (!timer) {
				me._timer = setInterval(function () { me._doTimer(); }, 200);
			}
			if (flag === 1) {
				return;
			}
			if (me._doSize(1) && !me._percWidth && !me._percHeight) {
				me._doTimer(2);
			}
		},
		// adjust heights of buttons
		_doButHeight: function (height, perc) {
			var img, imgHeight,
				min = this._butMinHeight,
				offsetHeight = height,
				minHolder = this._minHolderHeight;
			this.clearElem.css('height', perc ? '100%' : height - minHolder);
			height = Math.max(height - min, 0);
			this.buttonElem.css('height', perc ? height / offsetHeight * 100 + '%' : height);
			// adjust images
			img = this.buttonElem.children(0);
			// img[0].offsetHeight can be 0
			imgHeight = img[0].offsetHeight || 16;
			img.css('marginTop', Math.floor((offsetHeight - (min || 0) - imgHeight) / 2 + 0.5) + 'px');
			img = this.clearElem.children(0);
			// img[0].offsetHeight can be 0
			img.css('marginTop', Math.floor((offsetHeight - minHolder - (img[0].offsetHeight || imgHeight)) / 2 + 0.5) + 'px');
		},
		_outerWidth: function (elem) {
			return elem[0].offsetWidth + _px(elem, 'marginLeft') + _px(elem, 'marginRight');
		},
		_outerHeight: function (elem) {
			return elem[0].offsetHeight + _px(elem, 'marginTop') + _px(elem, 'marginBottom');
		},
		// set background color from src to targ
		_sameBC: function (src, targ) {
			// ensure that dd-container has same backgroundColor as row1st-item
			var clr = src.css('backgroundColor');
			targ.css('background', (!clr || clr === 'transparent' || clr.replace(/ /g, '').indexOf('(0,0,0,0') > 0) ? 'white' : clr);
		},
		// adjust heights and widths of all elements
		_doSize: function (timer) {
			if (!this.mainElem) {
				return;
			}
			var fieldWidth, fix, percWidth, percHeight, butHeight, holderHeight, holderWidth,
				me = this,
				o = me.options,
				width = o.width,
				height = o.height,
				relative = me._relative,
				but = me.buttonElem,
				css = me.css,
				elem = me.mainElem,
				elem0 = elem[0],
				field = me.fieldElem,
				fieldHolder = me._fieldHolder,
				clearOn = me._clearOn,
				minFieldHeight = me._minFieldHeight,
				minFieldWidth = me._minFieldWidth,
				minHolderWidth = me._minHolderWidth,
				minHolderHeight = me._minHolderHeight,
				butWidth = me._butWidth,
				clearWidth = me._clearWidth,
				lastHeight = me._lastHeight,
				clear = me.clearElem,
				offsetWidth = elem0.offsetWidth,
				offsetHeight = elem0.offsetHeight;
			// try to get width/height from css
			if (offsetWidth && !me._offsetWidth && (!width || !height)) {
				fix = $('<span />').css({ display: 'inline-block', position: 'absolute' }).addClass('ui-igcombo').appendTo(me.element.parent());
				if (!width) {
					width = fix[0].offsetWidth;
					if (width > 10) {
						o.width = width;
					} else {
						width = 0;
					}
				}
				if (!height) {
					height = fix[0].offsetHeight;
					// IE7 may have some messy height
					if (height > 10 && height !== fix.removeClass('ui-igcombo')[0].offsetHeight) {
						o.height = height;
					} else {
						height = 0;
					}
				}
				fix.remove();
			}
			width = width || 150;
			height = height || 'auto';
			fix = me._offsetWidth !== offsetWidth || width !== me._lastWidth || me._offsetHeight !== offsetHeight || height !== lastHeight;
			if (!offsetWidth || (timer && !fix)) {
				if (!offsetWidth) {
					me._doTimer(1);
				}
				return;
			}
			if (fix) {
				me._listRemove();
			}
			me._lastWidth = width;
			me._lastHeight = height;
			me._percWidth = percWidth = typeof width === 'string' && width.indexOf('%') > 0;
			me._percHeight = percHeight = typeof height === 'string' && height.indexOf('%') > 0;
			if (percWidth || percHeight) {
				me._doTimer(1);
			}
			// check if field may have absolute position
			if (!lastHeight) {
				// ensure that fieldHolder has same backgroundColor as field
				me._sameBC(field, fieldHolder);
				relative = elem.css('position') !== 'static';
				// no support for static position when width is %
				if (!relative && (percWidth || percHeight)) {
					elem.css('position', 'relative');
					relative = true;
				}
				me._relative = relative;
				field.css('position', relative ? 'absolute' : 'static');
			}
			// measure offsetWidth/Height of element
			fieldHolder.css({ position: 'absolute', width: 'auto', height: 'auto' });
			// temporary hide field
			clear.hide();
			field.css({ width: 0, height: 0 });
			// first time calculations
			// measure minimum widths and heights
			if (!lastHeight) {
				// adjust css according to visibility of button
				fix = me._rtl ? css.fieldHolderRTL : css.fieldHolderLTR;
				if (o.showDropDownButton) {
					fieldHolder.addClass(fix);
				} else {
					fieldHolder.removeClass(fix);
				}
				fix = me._rtl ? css.buttonRTL : css.buttonLTR;
				if (o.showDropDownButton) {
					but.addClass(fix);
				} else {
					but.removeClass(fix);
				}
				butWidth = 0;
				// notes: under IE7 width:auto for elem triggers stretch of combo to size of browser!!
				// also when both clear and field are visible, then fieldHolder[0].offsetWidth can be 1..18 px larger
				// so, use css and _outerWidth (offsetWidth and margins) for each element without children
				if (o.showDropDownButton) {
					but.show();
					butWidth = me._outerWidth(but);
					// measure min height of button
					fix = but.css('height');
					but.css('height', 0);
					me._butMinHeight = me._outerHeight(but);
					but.css('height', fix);
				} else {
					but.hide();
				}
				me._butWidth = butWidth;
				me._minFieldWidth = minFieldWidth = me._outerWidth(field);
				me._minFieldHeight = minFieldHeight = me._outerHeight(field);
				// _minWidth: width without clear button
				// note: under Safari/Chrome fieldHolder[0].offsetWidth is huge: use _outerWidth(field)
				me._minWidth = butWidth + me._outerWidth(field);
				if (o.enableClearButton) {
					clear.show();
					// _minWidth1: width with clear button
					me._clearWidth = clearWidth = me._outerWidth(clear);
					clear.hide();
				}
				field.hide();
				me._minHolderHeight = minHolderHeight = fieldHolder[0].offsetHeight;
				me._minHolderWidth = minHolderWidth = fieldHolder[0].offsetWidth;
				field.show();
			}
			fix = _toPx(width);
			if (fix) {
				width = fix - _px(elem, 'borderLeftWidth') - _px(elem, 'borderRightWidth');
				if (width < 1) {
					width = 1;
				}
			}
			fix = _toPx(height);
			if (fix) {
				height = fix - _px(elem, 'borderTopWidth') - _px(elem, 'borderBottomWidth');
				if (height < 1) {
					height = 1;
				}
			}
			elem.css({ width: width, height: height, display: 'inline-block', minWidth: 0, minHeight: 0 });
			offsetWidth = elem0.clientWidth;
			offsetHeight = elem0.clientHeight;
			fieldHolder.css('height', 'auto');
			// height of drop-down button
			butHeight = o.showDropDownButton ? me._outerHeight(but) : 0;
			if (!relative) {
				fieldHolder.css('position', 'static');
			}
			// adjust height of field, buttons and top element
			// measure default height of field/fieldHolder
			field.css({ height: 'auto', position: 'static' });
			holderHeight = me._outerHeight(fieldHolder);
			if (relative) {
				field.css('position', 'absolute');
			}
			if (clearOn) {
				clear.show();
			}
			// use hard coded custom height
			if (o.height) {
				holderHeight = Math.max(offsetHeight - minHolderHeight, 0);
				fieldHolder.css('height', percHeight ? holderHeight / offsetHeight * 100 + '%' : holderHeight);
				field.css('height', percHeight ? (holderHeight - minFieldHeight) / holderHeight * 100 + '%' : holderHeight - minHolderHeight - minFieldHeight);
				me._doButHeight(offsetHeight, percHeight);
			// adjust height of field/fieldHolder to height of button
			} else if (holderHeight < butHeight) {
				fieldHolder.css('height', butHeight - minHolderHeight);
				field.css('height', butHeight - minHolderHeight - minFieldHeight);
			// adjust height of button to height of field/fieldHolder
			} else {
				me._doButHeight(holderHeight, percHeight);
				field.css('height', holderHeight - minHolderHeight - minFieldHeight);
				if (relative) {
					fieldHolder.css('height', holderHeight - minHolderHeight);
				}
				elem.css('height', height = holderHeight);
			}
			// adjust width of fieldHolder
			elem.css({ display: o.enableDisplayBlock ? 'block' : 'inline-block', minWidth: me._minWidth + clearWidth + 2 });
			width = Math.max(offsetWidth - butWidth - minHolderWidth, 0);
			fieldHolder.css('width', percWidth ? width / offsetWidth * 100 + '%' : width);
			// verify that widths of button and fieldHolder fill whole space of elem
			offsetWidth = elem0.clientWidth;
			holderWidth = fieldHolder[0].offsetWidth;
			// difference between space available for fieldHolder and its actual width (bugs in Safari)
			if ((fix = offsetWidth - holderWidth - butWidth) !== 0) {
				width += fix;
				fieldHolder.css('width', percWidth ? width / offsetWidth * 100 + '%' : width);
			}
			// adjust width of field
			// verify that widths of clear and field fill whole space of fieldHolder
			fieldWidth = width - minFieldWidth - 1;
			if (clearOn) {
				fieldWidth -= clearWidth;
			}
			field.css('width', percWidth ? fieldWidth / width * 100 + '%' : fieldWidth);
			// difference between space available for field and its actual width (bugs in Firefox/Opera)
			if ((fix = fieldHolder[0].clientWidth - me._outerWidth(field) - (clearOn ? clearWidth : 0) - 1) !== 0) {
				fieldWidth += fix;
				field.css('width', percWidth ? fieldWidth / width * 100 + '%' : fieldWidth);
			}
			// verify that buttons or field did not jump on next line
			if (!relative) {
				holderHeight = fieldHolder[0].offsetHeight + 5;
				elem.css('height', 'auto');
				for (fix = 0; fix < 4 && width > 0; fix += 1) {
					if (elem0.offsetHeight < holderHeight) {
						break;
					}
					// reduce width of field
					width -= 0.5;
					fieldHolder.css('width', percWidth ? width / offsetWidth * 100 + '%' : width);
				}
				// get around zoom
				fieldHolder.css('width', percWidth ? --width / offsetWidth * 100 + '%' : --width);
				elem.css('height', height);
			}
			// memorize final width/height of top element
			me._offsetWidth = elem0.offsetWidth;
			me._offsetHeight = elem0.offsetHeight;
			return 1;
		},
		_listRemove: function () {
			var me = this;
			if (!me.listElem) {
				return;
			}
			me._touch('destroy');
			me.mainElem.removeClass(me.css.noTopCorners).removeClass(me.css.noBottomCorners);
			me.listElem.remove();
			// reset short-cut variables
			me._selElems = me.listElem = me._itemsHolder = me._ddCont = me._ddScroll = me._noResults = me._q =
				me._ddOn = me._extraHeight = me._listChanged = me._ddItemBorderFix = me._itemHeightOuter = me._bindLI = null;
			me._lastScroll = me._virtualTop = me._topID = 0;
			me._activeID = me._scrollTo = -1;
		},
		destroy: function () {
			/* Destroys widget.
				returnType="object" Returns reference to this igCombo.
			*/
			var i, e, elem = this.mainElem, css = this.css, old = this._oldCss, field = this.fieldElem, elem0 = this.element;
			e = elem ? elem[0] : null;
			if (!e) {
				return this;
			}
			if (this._loadInd) {
				this._loadInd.destroy();
			}
			// stop timer, remove drop-downs, unbind events
			this._doTimer(2);
			this._listRemove();
			this.validator(1);
			// restore layout
			if (this._SELECT) {
				elem.remove();
				elem0.css('display', old.display);
			} else {
				// remove classes, unbind events
				field.removeClass(css.nullText).removeClass(css.fieldFocus).removeClass(css.fieldHolder).unbind(this._evts);
				if (this._swap) {
					field.removeClass(css.field);
					field.insertBefore(elem);
					elem.remove();
				} else {
					this.buttonElem.remove();
					this.clearElem.remove();
					elem.unbind(this._elemEvts).removeClass(css.combo).removeClass(css.hover).removeClass(css.focus).removeClass(css.disabled);
					field.remove();
				}
				// restore old attributes
				for (i in old) {
					if (old.hasOwnProperty(i)) {
						elem0.css(i, old[i]);
					}
				}
				old = this._oldAttr;
				for (i in old) {
					if (old.hasOwnProperty(i)) {
						elem0[0][i] = old[i];
					}
				}
			}
			this._cascade(false, true);
			delete this.mainElem;
			$.Widget.prototype.destroy.apply(this, arguments);
			return this;
		},
		_getType: function (v) {
			return (v === true || v === false) ? 'bool' : ((v && v.getTime) ? 'date' : (typeof v === 'number' ? 'number' : 'string'));
		},
		dataBind: function (callback) {
			/* Trigger data binding. */
			var field, ds0, dataOptions, setting, binded,
				o = this.options,
				url = o.dataSourceUrl,
				lod = o.parentComboKey && o.parentCombo ? null : o.loadOnDemandSettings,
				key = o.responseDataKey,
				txtKey = o.textKey || o.valueKey,
				type = o.dataSourceType,
				vt = o.valueKeyType,
				tt = o.textKeyType,
				verb = o.requestType,
				contentType = o.responseContentType,
				schema = { fields: [] },
				ds = o.dataSource,
				dsStr = typeof ds === 'string',
				// assume key is something like "key1.key2.key3" and ds={key1:{key2:{key3:[actualData]}}}
				keys = key ? key.split('.') : null,
				len = keys ? keys.length - 1 : -1,
				i = -1;
			vt = (vt === 'auto') ? null : vt;
			if (dsStr && !type) {
				if ($.ig.util.isJsonpUrl(ds)) {
					ds = new $.ig.JSONPDataSource({ dataSource: ds });
				} else {
					ds = new $.ig.DataSource({ dataSource: ds });
				}
			}
			ds0 = ds;
			// find actualData within ds={key1:{key2:{key3:[actualData]}}}
			while (ds0 && i++ < len) {
				ds0 = ds0[keys[i]];
			}
			if (!ds0) {
				ds0 = ds;
				keys = null;
			} else if (keys) {
				schema.searchField = key;
			}
			field = ds0 ? ds0[0] : null;
			// convert simple array to array of objects
			if (typeof field === 'string' || typeof field === 'number' || (field && field.getTime)) {
				i = ds0.length;
				field = ds0;
				ds0 = [];
				txtKey = txtKey || 'x';
				while (i-- > 0) {
					ds0[i] = {};
					ds0[i][txtKey] = field[i];
				}
				// process ds={key1:{key2:{key3:[actualData]}}}
				if (keys) {
					field = ds;
					i = -1;
					// find container of last/container object of real data within ds (key2)
					while (++i < len) {
						field = field[keys[i]];
					}
					// update actualData within ds={key1:{key2:{key3:[actualData]}}}
					field[keys[len]] = ds0;
				} else {
					ds = ds0;
				}
			}
			dataOptions = {
				callback: callback ? callback : this._dataChange,
				// note: IE7/8 may fail properly to perform extend(...) with "this". Set callee later.
				//callee: this,
				dataSource: ds,
				requestType: verb,
				responseContentType: contentType,
				type: type || undefined,
				responseDataKey: key,
				responseTotalRecCountKey: o.responseTotalRecCountKey
			};
			field = this._noMouse() || this._cascFilter ? null : o.filteringType;
			this._filtering = (field === 'local') ? 1 : (field === 'remote' ? -1 : 0);
			// fill fields of schema from first record
			if (ds0) {
				ds0 = ds0[0];
				for (field in ds0) {
					if (ds0.hasOwnProperty(field)) {
						// varify that value/textKey are defined
						if (!txtKey) {
							txtKey = o.valueKey = o.textKey = field;
						}
						i = this._getType(ds0[field]);
						if (!vt && field === o.valueKey) {
							o.valueKeyType = vt = i;
						}
						schema.fields.push({ name: field, type: i });
						// set flag for Mvc that data source is not compact
						if (txtKey !== field && o.valueKey !== field) {
							o._all = 1;
						}
					}
				}
			}
			// configure data source options
			if ((ds instanceof $.ig.DataSource && !ds.settings.schema) || !(ds instanceof $.ig.DataSource)) {
				dataOptions = $.extend(dataOptions, { schema: schema });
			}
			// configure data source
			if (ds instanceof $.ig.DataSource) {
				binded = ds._data && ds._data.length;
				dataOptions.dataSource = ds.settings.dataSource;
				ds.settings = $.extend(true, {}, ds.settings, dataOptions);
				// set callee after extend()
				ds.settings.callee = this;
				if (dataOptions.schema) {
					ds._initSchema();
				}
			} else {
				// set callee after extend()
				// K.D. August 16th, 2012 Bug #118180 igCombo throws error in Ie8.
				ds = new $.ig.DataSource(dataOptions);
				ds.settings.callee = this;
			}
			tt = (tt === 'auto') ? null : tt;
			schema = (vt || tt) ? ds.schema() : null;
			schema = schema ? schema.fields() : null;
			i = schema ? schema.length : 0;
			while ((i -= 1) >= 0) {
				field = schema[i];
				if (vt && field.name === o.valueKey) {
					field.type = vt;
				}
				if (tt && field.name === o.textKey) {
					field.type = tt;
				}
			}
			// support for loadOnDemand coming from Mvc
			ds._response_data = function (data) {
				var len = data ? data.length : 0, count = (len > 0) ? data[len - 1][':totals:'] : null;
				if (count) {
					data.pop();
					count = count.split(':');
					ds.totalRecordsCount(_aNull(len = parseInt(count[0], 10), true) ? 0 : len);
					len = _aNull(len = parseInt(count[1], 10), true) ? 0 : len;
					if (len) {
						o._totalAll = len;
					}
				}
			};
			// configure load on demand
			delete this._lod;
			if (lod && lod.enabled && (url || dsStr)) {
				setting = ds.settings.paging;
				setting.type = 'remote';
				setting.appendPage = setting.enabled = true;
				setting.pageSizeUrlKey = lod.pageSizeUrlKey || null;
				setting.pageIndexUrlKey = lod.pageIndexUrlKey || null;
				if (!_aNull(i = parseInt(o._total, 10), true)) {
					ds.totalRecordsCount(i);
				}
				lod = parseInt(lod.pageSize || 30, 10);
				setting.pageSize = this._lod = _aNull(lod, true) ? 30 : Math.max(lod, 5);
				setting.pageIndex = 0;
			}
			if (this._fire('dataBinding', null, { owner: this, dataSource: ds }, 1)) {
				this._dataSource = ds;
				this._keyVal = this._hasData = this._key_ = null;
				this._listRemove();
				if (binded) {
					this._dataChange();
				} else {
					ds.dataBind();
				}
			}
			// configure request of remote filtering
			if (url && !this._urlBind) {
				setting = ds.settings;
				setting.dataSource = url;
				setting.type = 'remoteUrl';
				ds._runtimeType = ds.analyzeDataSource();
				setting.urlParamsEncoded = $.proxy(function (data, params) {
					params = params ? params.filteringParams : null;
					// set flag used by Mvc remote filtering
					if (params) {
						params.textKey = o.textKey || o.valueKey;
						params.valueKey = o.valueKey;
						if (!o.caseSensitive) {
							params.toLower = "1";
						}
						// K.D. June 10th, 2014 Bug #171369 The compact data option is set through the MVC wrapper.
						if (o.compactData) {
							params.compact = "1";
						}
						if (o.parentComboKey) {
							params.cascade = o.parentComboKey;
						}
					}
				}, this);
				this._urlBind = 1;
				if (!o.dataSource) {
					ds.dataBind();
				}
			}
		},
		_cond: function (o, paint) {
			return o.autoComplete ? 'startsWith' : ((paint || !this._filtering) ? o.renderMatchItems : o.filteringCondition);
		},
		_isStrCond: function (cond) {
			return cond === 'startsWith' || cond === 'endsWith' || cond === 'contains' || cond === 'doesNotContain' || cond === 'empty' || cond === 'notEmpty';
		},
		// returns array of string-items for filtering and rendering matches in list
		// txt: 1- flag for list-matches, null- use current text for filtering, not-null- value from _select
		_texts: function (txt) {
			var i, len, sepLen,
				render = txt === 1,
				o = this.options,
				sep = this._multi(o) ? this._sep() : null;
			if (render || _aNull(txt)) {
				txt = this._userTxt || this._oldTxt;
			} else if (typeof txt !== 'string') {
				return [txt];
			}
			if (!o.caseSensitive) {
				txt = txt.toLowerCase();
			}
			if (!sep) {
				return txt ? [txt] : [];
			}
			// remove empty items
			while (txt.indexOf(sep + sep) > 0) {
				txt = txt.replace(sep + sep, sep);
			}
			// remove possible last dummy item
			sepLen = sep.length;
			len = txt.length;
			// get text for rendering matches in list
			if (render) {
				// remove trailing separator
				if ((i = txt.lastIndexOf(sep.charAt(0))) > 0 && i === len - 1) {
					txt = txt.substring(0, len -= 1);
				}
				if ((i = txt.lastIndexOf(sep)) > 0 && i === (len -= sepLen)) {
					txt = txt.substring(0, len);
				}
			// get text for filtering: ensuse trailing separator
			} else if ((i = txt.lastIndexOf(sep.charAt(0))) > 0 && i === len - 1 && sepLen > 1) {
				// if text ends with first char of separator, then add 2nd char of separator
				txt += sep.charAt(1);
			}
			if (txt.indexOf(sep) === 0) {
				txt = txt.substring(sepLen);
			}
			return txt ? txt.split(sep) : [];
		},
		// ensure/fill data for _key_ column which is used for rendering and filtering
		_fillKeys: function (fix) {
			if ((fix || !this._keyFixed) && this._key !== this._key_) {
				var count = this._count;
				while ((count -= 1) >= 0) {
					this._item(count, 2);
				}
			}
			this._keyFixed = 1;
		},
		// show/hide wait-for-remote-filtering css
		_wait: function (on) {
			var css = this.css.waitFiltering,
				load = this._loadInd,
				elem = this.mainElem,
				holder = this._itemsHolder;
			if (on) {
				elem.addClass(css);
				if (holder) {
					holder.addClass(css);
				}
				if (!load && elem.igLoading) {
					load = elem.igLoading().data('igLoading');
					if (load) {
						this._loadInd = load = load.indicator();
					}
				}
				if (load) {
					load.show();
				}
			} else if (elem) {
				elem.removeClass(css);
				if (holder) {
					holder.removeClass(css);
				}
				if (load) {
					load.hide();
				}
			}
		},
		filter: function (e, txtNew, noFilter) {
			/* Trigger filtering.
				paramType="object" optional="true" Reference to browser event. 
				paramType="string|array" optional="true" Filter by string, or array of strings. 
				paramType="bool" optional="true" Skip filtering.
			*/
			var filter, key,
				i = -1,
				casc = this._cascFilter,
				// N.A. 10/7/2013 Fix for Bug #153277:  Allow filtering to use string (text).
				txt = casc ? this._cascVal : typeof txtNew === 'string' ? [txtNew] : txtNew instanceof Array ? txtNew : this._texts(),
				len = casc ? 0 : txt.length,
				cond = len ? txt.toString() : null,
				ds = this._dataSource,
				o = this.options,
				expr = [],
				remote = casc === -1 || this._filtering < 0;
			// _filterTxt: get around remoteFiltering+LOD+dataSourceUrl
			// dataSource in this situation may accumulate same responces and doublicate same data
			if (noFilter || (this._hasData && cond && this._filterTxt === cond)) {
				return;
			}
			// this._expr - object/flag for remote filtering waiting: waiting response from server
			if (this._expr) {
				// container of variables to raise filtering when text was modified while waiting response after remote-filtering
				this._filterNew = { txt: txt, e: e };
				return;
			}
			this._filterTxt = cond;
			delete this._filterNew;
			// remote filtering may not support empty condition (if remote multi-filter is supported, haha)
			if (remote && len > 1 && !txt[len - 1]) {
				len = 0;
			}
			if (casc) {
				cond = 'equals';
				key = this._cascKey;
				expr.push({ fieldName: key, cond: cond, expr: txt });
			} else {
				cond = this._cond(o);
				key = (remote || !this._isStrCond(cond)) ? this._key : this._key_;
				while ((i += 1) < len) {
					expr.push({ fieldName: key, cond: cond, expr: txt[i] });
				}
			}
			if (expr.length === 0 && !e) {
				return;
			}
			// this._expr - object/flag used to raise event after filtering
			if (!this._fire('filtering', e, this._expr = { owner: this, expression: expr }, 1)) {
				delete this._expr;
				return;
			}
			if (remote && this._hasData && !this._fire('dataBinding', null, { owner: this, dataSource: ds }, 1)) {
				delete this._expr;
				return;
			}
			if (!casc) {
				this._needsSel = txt;
				this._needsSelEnd = this._multi(o) && this._sepEnd(this.text());
			}
			filter = ds.settings.filtering;
			filter.caseSensitive = o.caseSensitive;
			filter.type = o.filteringType;
			if (remote) {
				this._wait(true);
				key = o.filterExprUrlKey;
				if (key) {
					filter.filterExprUrlKey = key;
				}
				filter.expressions = expr;
				// suspend raising selection-change events
				this._waitFilter = !this._hasData;
				if (this._lod) {
					// N.A. 10/7/2013 Fix for Bug #153277:  Allow filtering to use string (text). Additional fix when filtering is cleared.
					txt = (txtNew !== null && txtNew !== undefined) ? txtNew : this.text();
					// N.A. 5/20/2013 Fix for Bug #171736 Clear data source before getting data on demand.
					if (this._lodTxt !== txt) {
						this._lodTxt = txt;
					}
					ds._data = [];
					ds._dataView = [];
					ds._filteredDataView = [];
					ds._cachedDataView = null;
					ds.settings.paging.pageIndex = 0;
					ds.pageSizeDirty(true);
					
				}
				ds.dataBind();
				return;
			}
			// N.A. 7/26/2013 Bug #147059 Don't filter combo on initialization, when we have selected items by default.
			if (expr.length === 0 || (!this._hasData && !casc)) {
				ds.clearLocalFilter();
			} else {
				// ensure that data for _key_ column was filled
				this._fillKeys();
				ds.filter(expr, 'OR', this._noFilter);
			}
			this._dataChange(e, true);
		},
		// check if filter expression was modified while waiting for response from remote filtering
		// return 1, expression was changed while request to server: trigger filter from new text
		// return null/undefined, if no filter request or if expression was not changed
		_checkExpr: function () {
			// this._expr - object/flag used for filtering
			// this._filterNew - container of variables to raise filtering when text was modified while waiting response after remote-filtering
			var change,
				filterNew = this._filterNew,
				expr = this._expr,
				len = filterNew && filterNew.txt ? (filterNew.txt.length || 0) : 0;
			if (!filterNew) {
				return;
			}
			if (expr) {
				expr = expr.expression;
			}
			if (len !== (expr ? expr.length : 0)) {
				change = 1;
			}
			while (!change && (len -= 1) >= 0) {
				change = filterNew.txt[len] !== expr[len].expr;
			}
			// filter expression was modified
			if (change) {
				delete this._expr;
				this.filter(filterNew.e, filterNew.txt, this._noFilter);
				return 1;
			}
			// filter expression was not modified
			delete this._filterNew;
		},
		_fixType: function (val) {
			var fields, type = this.options.valueKeyType;
			if (!_aNull(val)) {
				if (type === 'number') {
					return (typeof val === 'number') ? val : parseFloat(val);
				}
				if (type === 'bool') {
					return val === 'true' || val === true;
				}
				if (type === 'date' && !val.getTime) {
					val = val.toString();
					fields = val.replace(/[\. :]/g, '-').split('-');
					return (fields.length === 7) ? new Date(parseInt(fields[0], 10), parseInt(fields[1], 10) - 1,
						parseInt(fields[2], 10),	parseInt(fields[3], 10), parseInt(fields[4], 10),
						parseInt(fields[5], 10), parseInt(fields[6], 10)) : Date.parse(val);
				}
			}
			return val;
		},
		// verify that selectedItems[i].index/value/text are defined
		_initSel: function (o) {
			var item, val, id, ii, custom,
				more = 1,
				selItems = o.selectedItems,
				len = selItems ? selItems.length : 0,
				i = -1;
			while (!this._multi(o) && len > 1) {
				selItems.splice(len -= 1, 1);
			}
			id = len;
			while (id-- > 0) {
				item = selItems[id];
				item.value = this._fixType(val = item.value);
			}
			custom = o.text || ((len === 1 && this._custom(o)) ? val : null);
			o.text = null;
			while ((i += 1) < this._count && more) {
				val = this._item(i);
				more = null;
				id = len;
				while ((id -= 1) >= 0) {
					item = selItems[id];
					if (_aNull(ii = item.index) || ii < 0) {
						if (_equals(item.value, val)) {
							if (this.isSelected(i)) {
								selItems.splice(id, 1);
								len -= 1;
							} else {
								item.index = i;
								item.text = this._item(i, 2);
							}
						} else {
							more = 1;
							if (i === this._count - 1) {
								selItems.splice(id, 1);
							}
						}
					} else {
						item.value = item.value || this._item(ii);
						item.text = item.text || this._item(ii, 2);
					}
				}
			}
			if (custom && (!selItems || !selItems.length)) {
				this.text(custom);
			} else if (!this.text() || !this._custom(o)) {
				// update field from selectedItems
				this._updateFromList(null, 1);
			}
		},
		_dataChange: function (e, local) {
			var count, txt, selLen, selItems, data, top, firstMatch, fullMatch, firstFullMatch, item, cond,
				lod = this._lodWait,
				casc = this._cascFilter,
				more = !casc,
				i = -1,
				actID = -1,
				sel = this._needsSel,
				id = -1,
				keyVal = this._keyVal,
				key = this._key,
				dd = this._itemsHolder,
				ds = this._dataSource,
				filter = casc || this._filtering,
				o = this.options,
				trimmedSep,
				txtTmp;
			// check for error while remote filtering
			// if this._cascUrl is set, then that is instant call from dataSource: skip it because we need to get data from dataSourceUrl
			if (!o || !this._multi || this._cascUrl) {
				return;
			}
			selItems = o.selectedItems;
			if (casc && (_aNull(this._cascVal, true) || this._cascVal === '')) {
				filter = false;
			} else {
				data = ds.dataView();
			}
			this._data = data = data || [];
			this._count = count = top = data.length;
			// _urlSel: flag to preserve selection after submit when data (+/-filtering) is remote
			// 1-no data, 2-has data
			if (!this._hasData && !count && o.dataSourceUrl && o.selectedItems) {
				this._urlSel = 1;
			}
			if (!keyVal) {
				keyVal = o.valueKey;
				if (!keyVal && data[0]) {
					// back up for first key in data
					for (keyVal in data[0]) {
						if (data[0].hasOwnProperty(keyVal)) {
							break;
						}
					}
				}
				this._keyVal = keyVal;
				key = o.textKey || keyVal;
				this._key_ = this._key = key;
				// missing _keyFixed: request to fill up _key_ column before filtering
				this._keyFixed = !o.format;
				if (!this._keyFixed) {
					this._key_ += '_';
				}
			}
			// verify that selection has correct valueType
			if (count && !o.valueKeyType) {
				while (++i < count) {
					if (!_aNull(item = this._item(i))) {
						o.valueKeyType = item === true || item === false ? 'bool' : (typeof item === 'number' ? 'number' : (item.getTime ? 'date' : 'string'));
						break;
					}
				}
				i = selItems ? selItems.length : 0;
				while (i-- > 0) {
					selItems[i].value = this._fixType(selItems[i].value);
				}
				this._cascSel = this._fixType(this._cascSel);
			}
			if (this._hasData) {
				if (this._checkExpr()) {
					return;
				}
				// _urlSel: flag to preserve selection after submit when data (+/-filtering) is remote
				// 1-no data, 2-has data
				if (this._urlSel === 1) {
					this._initSel(o);
					this._urlSel = 2;
				} else {
					// get current text which represents selection
					// at this point selectedItems can be empty
					// K.D. June 2nd, 2014 Bug #157984 The combo needs to select by text when an item separator is the last character, even
					// when the space is not being input yet.
					txtTmp = this.text();
					trimmedSep = $.trim(o.itemSeparator);
					if (this._urlSel || (lod && this.selectedIndex() < 0 && !o.autoComplete) || (e && e.type === "keydown" && this._multi(o) && o.itemSeparator.lastIndexOf(' ') > -1 && txtTmp.lastIndexOf(trimmedSep) === txtTmp.length - trimmedSep.length)) {
						txt = txtTmp;
					}
					if (!lod) {
						this._activate(-1, e);
						this._clearSel();
						this._lastScroll = this._virtualTop = this._topID = 0;
						this._scrollTo = -1;
					}
					if (dd) {
						if (!lod) {
							dd.empty();
						}
						this._listChanged = 1;
					}
					// set selection from text
					if (txt) {
						this._select(null, txt, 2);
					}
				}
			}
			// this._expr - object/flag used to raise event after filtering
			// initialize selected items after filtering
			// sel is array of strings entered in field and matching list-items should be selected
			if (this._expr) {
				// if remote filtering, then fire dataBound
				if (filter < 0) {
					this._fire('dataBound', null, { owner: this, dataSource: ds }, 1);
				}
				if (!this._isStrCond(cond = this._cond(o))) {
					cond = 'startsWith';
				}
				if (!this._multi(o)) {
					cond = 'equals';
				}
				if (this._ddOn || (e && e.type === 'keydown')) {
					this._doDrop(1, e);
				}
				// fill data for _key_ column
				this._fillKeys(1);
				selLen = sel && !casc ? sel.length : 0;
				// ensure that selected item has correct index
				if (casc) {
					this._initSel(o);
					item = selItems ? selItems[0] : null;
					if (item) {
						while (++id < count) {
							if (item.value === this._item(id)) {
								item.index = id;
								break;
							}
						}
						if (id === count) {
							o.selectedItems = null;
							this.fieldElem.val('');
						}
					}
				}
				// note: indexes of selectedItems will match with indexes of texts in field
				selItems = [];
				// loop through all items in data
				while ((id += 1) < count && more) {
					txt = this._item(id, 2);
					i = -1;
					// assume end of search
					more = null;
					// multiple search strings (multiselection)
					while ((i += 1) < selLen) {
						// if full match was found, then sel[i] was set to null
						if (sel[i]) {
							// continue search
							more = 1;
							// K.D. June 4th, 2014 Bug #173034 Selection changes even when there are multiple matching items.
							if (txt && ds._findMatch(txt, sel[i], 'string', !o.caseSensitive, cond)) {
								item = null;
								// first-backup-match
								if (!selItems[i]) {
									selItems[i] = item = this._createSelItem(id, txt);
								}
								// try to find exact-match
								fullMatch = txt.length === sel[i].length;
								if (!firstMatch || fullMatch) {
									// set flag that first match was found
									firstMatch = 1;
									// find lowest scroll-index
									top = Math.min(top, id);
									if (fullMatch) {
										if (!firstFullMatch) {
											top = id;
										}
										// set flag that first full match was found
										firstFullMatch = 1;
										// update first-backup-match with exact-match
										selItems[i] = item || this._createSelItem(id, txt);
										// remove item from search
										sel[i] = null;
										if (!this._multi(o)) {
											// exit outer loop: only one match is required
											id = count + 1;
										}
										break;
									}
								}
							}
						}
					}
				}
				// N.A. 03/13/2014 Bug #166015 Select the text to be the first selected item text.
				// This ensures that on filtering the first item that matches is selected.
				if (selItems[0]) {
					txt = selItems[0].text;
				}
				// remove selectedItems, which corresponding texts in field, were not found
				while ((selLen -= 1) >= 0) {
					item = selItems[selLen];
					if (!item || (actID < 0 && !this._needsSelEnd)) {
						if (item) {
							actID = item.index;
						}
						if (!item || item.text !== txt) {
							selItems.splice(selLen, 1);
						}
					}
				}
				if (!casc) {
					if (this._selChange(selItems, e)) {
						this._selChanged(e);
						if (this._needsSelEnd) {
							this._updateFromList(e, 1, 1);
						}
					}
				}
				// ensure that after remote filtering (initially closed list) active item is set
				if (actID < 0 && count) {
					item = this._item(0, 2);
					txt = this.text();
					if (item && txt) {
						if (!o.caseSensitive) {
							item = item.toLowerCase();
							txt = txt.toLowerCase();
						}
						if (item.indexOf(txt) === 0) {
							actID = 0;
						}
					}
				}
				if (actID >= 0) {
					this._activate(top = actID, e, 1);
				}
				this._fixSelScroll(this._scrollTo = (top === count) ? 0 : top);
				// this._expr - object/flag used to raise event after filtering
				this._fire('filtered', e, this._expr, 1);
				this._autoComplete(1);
				this._wait();
				// enable raising selection events
				delete this._waitFilter;
				delete this._expr;
			} else {
				// _urlSel: flag to preserve selection after submit when data (+/-filtering) is remote
				// 1-no data, 2-has data
				if (this._urlSel !== 2) {
					txt = this.text();
					sel = this.selectedIndex();
					if (txt && !this._custom(o) && sel < 0) {
						if (!this._hasData || !o.autoComplete) {
							this._select(null, txt, 2);
						}
					} else {
						// condition when data from dataSourceUrl of cascadingDataSources is ready: restore selectedItems from _cascSel
						if (e === true && !_aNull(sel = (sel < 0) ? this._cascSel : null)) {
							selItems = null;
							while (!selItems && ++id < count) {
								if (this._item(id) === sel) {
									selItems = [this._createSelItem(id, null, sel)];
								}
							}
							o.selectedItems = selItems;
							if (!selItems) {
								this.fieldElem.val('');
							}
							delete this._cascSel;
						}
						// wait until cascading combo gets its filtered data
						if (!casc) {
							this._initSel(o);
						}
					}
				}
				this._fire('dataBound', null, { owner: this, dataSource: ds }, 1);
				// _urlSel: flag to preserve selection after submit when data (+/-filtering) is remote
				// 1-no data, 2-has data
				if (this._urlSel === 2 && !casc) {
					this._noFilter = 1;
					this._updateFromList(null, 1);
					delete this._noFilter;
					delete this._urlSel;
				} else if (filter) {
					this.filter(null, null, this._noFilter);
				}
				if (this._ddOn) {
					this._doDrop(1, e, 1);
				}
			}
			// N.A. 2 April 2013 Fix for bug #138205
			if (this._mode(o) > 1 && this.selectedIndex() < 0 && this.value() === null) {
				this.selectedIndex(0);
			}
			if (data.length < 1) {
				this._fire('noMatchFound', e, { owner: this, text: this.text() });
			}
			// enable raising selection events and drop-down
			this._hasData = 1;
			this._fixClear();
			this._fixNull();
			this._save(o);
			if (this._lodWait && !local) {
				this._wait();
				this._fixSel();
				delete this._lodWait;
			}
			this._lodLbl();
			// cascade: check if parent combo was created before child or parent did not have data
			if (_cascWait) {
				// item: reference to child combo which waits for initializing its parent or data
				more = _cascWait[id = e = this.element[0]];
				if (!more) {
					more = _cascWait[id = e.id];
				}
				count = more ? more.length : 0;
				while (count-- > 0) {
					item = more[count];
					// check if this is parentCombo of cascading combo
					i = casc = item.options.parentCombo;
					if (i === id || i === '#' + id) {
						casc = e;
					} else {
						if (casc && typeof casc === 'string') {
							casc = $(casc);
							if (casc.length !== 1) {
								casc = $('#' + i);
							}
						}
						if (casc && casc.element) {
							casc = casc.element[0];
						} else if (casc && casc.length === 1) {
							casc = casc[0];
						}
					}
					if (casc === e) {
						// that is correct parentCombo
						if (_cascWait) {
							// remove request to call _cascade for slave igCombo
							delete _cascWait[id];
							// check if _cascWait should be removed
							for (key in _cascWait) {
								if (_cascWait.hasOwnProperty(key)) {
									casc = null;
									break;
								}
							}
							if (casc) {
								_cascWait = undefined;
							}
						}
						item._cascade(false, false, this);
					}
				}
			}
			// cascade: flag to set last value after data is ready
			if (this._valTime === 1) {
				delete this._valTime;
				this.value(this._valLast, true);
			}
		},
		_locale: function (key) {
			var val = this.options[key];
			if (_aNull(val)) {
				val = $.ig.Combo && $.ig.Combo.locale ? $.ig.Combo.locale[key] : null;
			}
			return val || '';
		},
		_titles: function () {
			var val = this._locale('clearButtonTitle');
			this.clearElem.attr('title', val).attr('longdesc', val);
			val = this._locale('dropDownButtonTitle');
			this.buttonElem.attr('title', val).attr('longdesc', val);
		},
		_fire: function (t, e, a, fire) {
			return (this._canFire || fire) ? this._trigger(t, e, a) : true;
		},
		// If igCombo is created by Mvc and it is located in dialog, then same options will be called twice.
		// If selectedItems come before dataSource, then selection/value will be destroyed by changed dataSource.
		// To prevent that, validate if dataSource has same content and skip "set".
		_same: function (old, val) {
			if (old === val) {
				return true;
			}
			if (!old || !val || typeof val === 'string') {
				return;
			}
			var p1, p2, item, key, i = val.length;
			if (i !== old.length || _aNull(i)) {
				return;
			}
			while (i-- > 0) {
				item = val[i];
				if ((item && !old[i]) || (!item && old[i])) {
					return;
				}
				for (key in item) {
					if (item.hasOwnProperty(key)) {
						p1 = item[key];
						p2 = old[i][key];
						if (p1 !== p2 && ((p1 && !p2) || (!p1 && p2) || !p1.getTime || !p2.getTime || p1.getTime() !== p2.getTime())) {
							return;
						}
					}
				}
			}
			return true;
		},
		_setOption: function (key, val) {
			var o = this.options, field = this.fieldElem, elem = this.mainElem;
			if (this._same(o[key], val)) {
				return this;
			}
			if (key === 'selectedItems') {
				this._clearSel();
			}
			if (key.indexOf('virt') === 0 || key.indexOf('Match') > 0 || key.indexOf('empl') > 0 ||
					key.indexOf('drop') === 0 || key === 'caseSensitive' ||
					key === 'format' || key === 'enableActiveItem') {
				o = null;
				delete this._it;
			}
			if (key === 'multiSelection' || !o) {
				this._listRemove();
			}
			$.Widget.prototype._setOption.apply(this, arguments);
			// parentCombo, cascadingDataSources, parentComboKey, useTopParentDataSource
			if (key.indexOf('par') === 0 || key.indexOf('casc') === 0 || key.indexOf('useT') === 0) {
				this._cascade();
				return this;
			}
			if (typeof val === 'function' || !o) {
				return this;
			}
			if (key === 'width' || key === 'height' || key === 'showDropDownButton') {
				this._lastHeight = null;
				this._doSize();
			} else if (key === 'selectedItems' || key === 'multiSelection') {
				this._initSel(o);
				this._updateFromList(null, 1);
				this._fixNull();
			} else if (key.indexOf('Title') > 0) {
				this._titles();
			} else if (key.indexOf('dataS') === 0 || key.indexOf('fil') === 0 || key.indexOf('Key') > 0 || key.indexOf('OnDem') > 0) {
				this._hasData = false;
				this._lod = this._totalAll = o._totalAll = this._count = 0;
				this.selectedIndex(-1);
				this.activeIndex(-1);
				this.dataBind();
			} else if (key === 'enableClearButton') {
				this._fixClear(1);
			} else if (key === 'tabIndex' || key === 'disabled') {
				field.attr(key, val);
				this._fixClear();
			} else if (key === 'mode') {
				field.attr('readOnly', this._mode(o) > 0);
				this._fixClear();
			} else if (key === 'enableDisplayBlock') {
				elem.css('display', val ? 'block' : 'inline-block');
			} else if (key === 'itemSeparator') {
				this._updateFromList();
			} else if (key === 'text') {
				this.text(val);
			} else if (key === 'nullText') {
				this._fixNull();
			} else if (key === 'validatorOptions') {
				this.validator();
			}
			return this;
		}
	});
	$.extend($.ui.igCombo, { version: '14.1.20141.2249' });
}(jQuery));

/*!@license
* Infragistics.Web.ClientUI Dialog 14.1.20141.2249
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends on:
* jquery-1.6.1.js
* jqueryui/1.8.11/jquery-ui.js
* Example to use:
*	<script type="text/javascript">
*	$(function () {
*		$("#dialog1").igDialog();
*	});
*	</script>
*	<div id="dialog1"></div>
*/

/*global jQuery, setTimeout, alert, document, window*/
(function ($) {
	var _lastTop, _iframe,
		_visCount = 0,
		_modals = [],
		_lastZ = 0,
		_maxZ = 0,
		CLOSE = 0,
		OPEN = 1,
		MIN = 2,
		MAX = 3,
		PIN = 4,
		UNPIN = 5,
		RESTORE = 6,
		_pos = {
			// default position of dialog
			my: "center",
			at: "center",
			collision: "fit",
			of: window,
			using: function (pos) {
				if (pos.top < 0) {
					pos.top = 0;
				}
				if (pos.left < 0) {
					pos.left = 0;
				}
				var p = $(this).css(pos).offset();
				if (p.top < 0) {
					$(this).css("top", pos.top - p.top);
				}
				if (p.left < 0) {
					$(this).css("left", pos.left - p.left);
				}
			}
		},
		_isSrc = function (elem, src) {
			return elem && src && (elem.has(src).length > 0 || elem[0] === src);
		},
		_notab = function (elem) {
			return elem.attr("zIndex", -1).css("outline", 0).attr("unselectable", "on");
		},
		_toPx = function (elem, css) {
			// returns px value of style attribute
			var val = elem.css(css);
			if (!val) {
				return 0;
			}
			css = parseFloat(val);
			if (val.indexOf("px") > 0) {
				css += 0.7;
			} else if (val.indexOf("em") > 0) {
				css *= 12;
			} else {
				return 0;
			}
			return Math.floor(css);
		},
		_getPadding = function (elem, vert, margin) {
			// returns px value of vertical/horizontal padding and border style attributes
			return _toPx(elem, (margin || "padding") + (vert ? "Top" : "Left")) +
				_toPx(elem, (margin || "padding") + (vert ? "Bottom" : "Right")) +
				_toPx(elem, "border" + (vert ? "Top" : "Left") + "Width") +
				_toPx(elem, "border" + (vert ? "Bottom" : "Right") + "Width");
		},
		_stopEvt = function (e) {
			try {
				e.preventDefault();
				e.stopPropagation();
			} catch (ex) { }
		};
	/*
		igDialog is a widget based on jQuery UI that provides ability to show target element as the content of a dialog.
		Dialog provides common functionality such as ability to hide, show, minimize, maximize, pin and their combinations using
		buttons located in the header of dialog. It also supports modal state and may track focus.
		When igDialog is created, then target element is removed from its original parent and inserted into dynamically created html elements.
		The parent element of dialog can be form element (if target element is a child of that form) or body.
		When igDialog is destroyed, then original target html element is moved back into its original parent including position within original siblings.
		Note: if application uses tabIndex attributes for child elements of dialog-content, then it is not recommended to have mixed values of tabIndexes for
		elements located inside and outside of dialog.
	*/
	$.widget("ui.igDialog", {
		options: {
			/* type="dom" Sets gets jquery DIV object which is used as main container for dialog.
				Notes:
				1. That object is optional and it should not contain any children.
				2. It should not have parent.
				3. It should not contain attributes which might destroy laout or appearance of dialog.
				4. Change of that option is not supported.
			*/
			mainElement: null,
			/* type="opened|closed|minimized|maximized" Sets gets state of dialog.
				Note: when dialog is modal, then pinned and minimized states are not supported, because that will trigger misbehavior.
				opened type="string" Dialog is opened.
				minimized type="string" Dialog is minimized.
				maximized type="string" Dialog is maximized.
				closed type="string" Dialog is closed.
			*/
			state: "opened",
			/* type="bool" Sets gets pinned state of dialog.
				When dialog is pinned, then the html element of dialog is moved to the original container where target element was located and position:absolute is removed.
				Pinned dialog does not support modal state, maximized state and it can not be moved.
				Notes:
				1. If parent element of original target-element is invisible, then pinned dialog becomes invisible as well.
				2. Pinned state is not supported for modal dialog.
			*/
			pinned: false,
			/* type="bool" Sets gets ability to close dialog on Esc key. */
			closeOnEscape: true,
			/* type="bool" Sets gets visibility of close button in header. */
			showCloseButton: true,
			/* type="bool" Sets gets visibility of maximize button in header. */
			showMaximizeButton: false,
			/* type="bool" Sets gets visibility of minimize button in header. */
			showMinimizeButton: false,
			/* type="bool" Sets gets visibility of pin button in header. */
			showPinButton: false,
			/* type="bool" Sets gets ability to automatically pin dialog when dialog was minimized. */
			pinOnMinimized: false,
			/* type="string" Sets gets name of css class which is applied to the SPAN element located on the left side of header. */
			imageClass: null,
			/* type="string" Sets gets text which appears in header of dialog. */
			headerText: null,
			/* type="bool" Sets gets visibility of header. */
			showHeader: true,
			/* type="bool" Sets gets visibility of footer. */
			showFooter: false,
			/* type="string" Sets gets text which appears in footer of dialog. */
			footerText: null,
			/* type="string" Sets gets name of css class which is applied to the main DIV element of dialog. */
			dialogClass: null,
			/* type="object" Sets gets container html element for dialog.
				That can be reference to html element, jquery selector or jquery object.
				By default the parent form of original target element is used. If form is not found, then body is used.
				Note: If the "position" of container is not set or it is "static", then position is set to "relative".
			*/
			container: null,
			/* type="number" Sets gets initial height of dialog in pixels for normal state.
				Besides numeric values, following units are supported: "px", "em" and "%".
				In case of "%", the size of browser window is used and it has effect only on open action. */
			height: null,
			/* type="number" Sets gets initial width of dialog in pixels for normal state.
				Besides numeric values, following units are supported: "px", "em" and "%".
				In case of "%", the size of browser window is used and it has effect only on open action. */
			width: 300,
			/* type="number" Sets gets minimal height of dialog in normal state. */
			minHeight: 100,
			/* type="number" Sets gets minimal width of dialog in normal state. */
			minWidth: 150,
			/* type="number" Sets gets maximal height of dialog in normal state. Note: that option has effect only while resizing dialog by end user. */
			maxHeight: null,
			/* type="number" Sets gets maximal width of dialog in normal state. Note: that option has effect only while resizing dialog by end user. */
			maxWidth: null,
			/* type="bool" Sets gets ability to drag dialog by end user. */
			draggable: true,
			/* type="object" Sets gets initial position of dialog. That should be object, which contains "top" and "left" members or object
				supported by jquery.position(param) method. Examples: { left: 100, top: 200 }, { my: "left top", at: "left top", offset: "100 200" } */
			position: null,
			/* type="bool" Sets gets ability to resize dialog by end user. */
			resizable: true,
			/* type="number" Sets gets value for tabIndex attribute applied to main html element of dialog. */
			tabIndex: 0,
			/* type="object" Sets gets animation applied to dialog when it is opened. That can be any object supported by jquery show(param) method. */
			openAnimation: null,
			/* type="object" Sets gets animation applied to dialog when it is closed. That can be any object supported by jquery hide(param) method. */
			closeAnimation: null,
			/* type="number" Sets gets value of zIndex applied to the main html element of dialog. If value is not set, then 1000 is used. */
			zIndex: null,
			/* type="bool" Sets gets modal state of dialog.
				If there are more than 1 modal igDialog, then last opened dialog wins and becomes on the top.
				Note: modal functionality is not supported when dialog is minimized or pinned, because that will trigger misbehavior.
			*/
			modal: false,
			/* type="bool" Sets gets ability to process focus and blur events of child elements located in dialog in order to maintain focused state.
				Notes:
				If that option is enabled, then focus and blur event handlers are added to all child elements of dialog.
				If dialog is modal or it can be maximized, then it is not recommended to disable that option.
				If that option is modified after igDialog was already created, then depending on current state of dialog, it will be temporary closed-opened or opened-closed.
			*/
			trackFocus: true,
			/* type="string" Sets gets title/tooltip for close button in dialog. That is override for $.ig.Dialog.locale.closeButtonTitle. */
			closeButtonTitle: null,
			/* type="string" Sets gets title/tooltip for minimize button in dialog. That is override for $.ig.Dialog.locale.minimizeButtonTitle. */
			minimizeButtonTitle: null,
			/* type="string" Sets gets title/tooltip for maximize button in dialog. That is override for $.ig.Dialog.locale.maximizeButtonTitle. */
			maximizeButtonTitle: null,
			/* type="string" Sets gets title/tooltip for pin button in dialog. That is override for $.ig.Dialog.locale.pinButtonTitle. */
			pinButtonTitle: null,
			/* type="string" Sets gets title/tooltip for unpin button in dialog. That is override for $.ig.Dialog.locale.unpinButtonTitle. */
			unpinButtonTitle: null,
			/* type="string" Sets gets title/tooltip for restore button in dialog. That is override for $.ig.Dialog.locale.restoreButtonTitle. */
			restoreButtonTitle: null,
			/* type="string" Sets gets temporary value for src, which is used while changing parent of base element if it is instance of IFRAME. That is allows to get around possible javascript exceptions under IE. */
			temporaryUrl: null,
			/* type="bool" Sets gets ability to adjust state of header depending on focused and not-focused states. Note: the "trackFocus" option should be enabled. */
			enableHeaderFocus: true,
			/* type="auto|true|false" Sets gets processing dblclick on dialog-header.
				If option is not false and dialog was minimized, then its state will be set to normal.
				If option is set to "auto" and showMaximizeButton is enabled or if option is set to true, then dialog will be maximized when it was in normal state,
				and dialog-state will be set to normal if it was maximized. */
			enableDblclick: "auto"
		},
		events: {
			/* cancel="true" Event which is raised before state of dialog was changed.
				Return false in order to cancel action.
				Function takes arguments "evt" and "ui".
				Use evt to obtain browser event. That parameter can be null if state was modified from codes.
				Use ui.owner to obtain reference to igDialog.
				Use ui.button to obtain name of button, which triggered event. Note: if state was modified from codes, then "button" is undefined.
				Use ui.oldState to obtain old state of dialog, which can be one of following: "opened", "minimized", "maximized", "closed".
				Use ui.oldPinned to obtain boolean value of old pin state of dialog.
				Use ui.action to obtain name of action. That can be one of the following:
				"open" - request to open dialog
				"close" - request to close dialog
				"minimize" - request to minimize dialog
				"maximize" - request to maximize dialog
				"restore" - request to restore dialog from minimized or maximized state
				"pin" - request to pin dialog
				"unpin" - request to unpin dialog
			*/
			stateChanging: null,
			/* cancel="false" Event which is raised after state of dialog was changed.
				Function takes arguments "evt" and "ui".
				Use evt to obtain browser event. That parameter can be null if state was modified from codes.
				Use ui.owner to obtain reference to igDialog.
				Use ui.button to obtain name of button, which triggered event. Note: if state was modified from codes, then "button" is undefined.
				Use ui.oldState to obtain old state of dialog, which can be one of following: "opened", "minimized", "maximized", "closed".
				Use ui.oldPinned to obtain boolean value of old pin state of dialog.
				Use ui.action to obtain name of action. That can be one of the following:
				"open" - dialog was opened. Note: event is raised before possible "openAnimation" started.
				"close" - dialog was closed. Note: event is raised before possible "closeAnimation" started.
				"minimize" - dialog was minimized
				"maximize" - dialog was maximized
				"restore" - dialog was restored from minimized or maximized state
				"pin" - dialog was pinned
				"unpin" - dialog was unpinned
			*/
			stateChanged: null,
			/* cancel="false" Event which is raised after end animation when dialod was closed or opened.
				Function takes arguments "evt" and "ui".
				Use ui.owner to obtain reference to igDialog.
				Use ui.action to obtain name of action, which triggered animation.
				"open" - dialog was opened
				"close" - dialog was closed
			*/
			animationEnded: null,
			/* cancel="false" Event which is raised when dialog or its content gets focus.
				Function takes arguments "evt" and "ui".
				Use evt to obtain browser event.
				Use ui.owner to obtain reference to igDialog.
			*/
			focus: null,
			/* cancel="false" Event which is raised when dialog or its content loses focus.
				Function takes arguments "evt" and "ui".
				Use evt to obtain browser event.
				Use ui.owner to obtain reference to igDialog.
			*/
			blur: null
		},
		css: {
			/* Classes applied to the main/top element. */
			dialog: "ui-igdialog ui-dialog ui-widget ui-widget-content ui-corner-all",
			/* Classes applied to the header. */
			header: "ui-igdialog-header ui-dialog-titlebar ui-widget-header ui-corner-top ui-helper-clearfix",
			/* Classes applied to the header in focused state. */
			headerFocus: "ui-igdialog-header-focus ui-state-focus",
			/* Classes applied to the header in minimized state. */
			headerMinimized: "ui-corner-bottom",
			/* Classes applied to the header text. */
			headerText: "ui-igdialog-headertext ui-dialog-title",
			/* Extra class applied to SPAN which represents image in header, when "image" option is set. */
			headerImage: "ui-igdialog-headerimage",
			/* Classes applied to the header text when dialog is in minimized state. */
			headerTextMinimized: "ui-igdialog-headertext-minimized",
			/* Classes applied to the buttons located in header. */
			headerButton: "ui-igdialog-headerbutton ui-corner-all ui-state-default",
			/* Classes applied to the buttons located in header when mouse is moved over them. */
			headerButtonHover: "ui-igdialog-headerbutton-hover ui-state-hover",
			/* Classes applied to the close button located in header. */
			close: "ui-igdialog-buttonclose",
			/* Classes applied to the minimize button located in header. */
			minimize: "ui-igdialog-buttonminimize",
			/* Classes applied to the maximize button located in header. */
			maximize: "ui-igdialog-buttonmaximize",
			/* Classes applied to the pin button located in header. */
			pin: "ui-igdialog-buttonpin",
			/* Classes applied to the icon of close button. */
			closeIcon: "ui-igdialog-close-icon ui-icon ui-icon-close",
			/* Classes applied to the icon of minimize button. */
			minimizeIcon: "ui-igdialog-minimize-icon ui-icon ui-icon-minus",
			/* Classes applied to the icon of maximize button. */
			maximizeIcon: "ui-igdialog-maximize-icon ui-icon ui-icon-extlink",
			/* Classes applied to the icon of restore button. */
			restoreIcon: "ui-igdialog-restore-icon ui-icon ui-icon-copy",
			/* Classes applied to the icon of pin button. */
			pinIcon: "ui-igdialog-pin-icon ui-icon ui-icon-pin-s",
			/* Classes applied to the icon of unpin button. */
			unpinIcon: "ui-igdialog-unpin-icon ui-icon ui-icon-pin-w",
			/* Classes applied to the footer. */
			footer: "ui-igdialog-footer ui-widget-header ui-corner-bottom ui-helper-clearfix",
			/* Classes applied to dialog while resizing. */
			resizing: "ui-igdialog-resizing",
			/* Classes applied to dialog while dragging. */
			dragging: "ui-igdialog-dragging",
			/* Classes applied to header when dialog is in unmovable state such as maximized of pinned. */
			unmovable: "ui-igdialog-unmovable",
			/* Classes applied to the shell element when dialog is in modal state. */
			overlay: "ui-igdialog-overlay ui-widget-overlay",
			/* Classes applied to the content area of dialog when target element is IFRAME. */
			contentIframe: "ui-igdialog-content-iframe",
			/* Classes applied to the content area of dialog. */
			content: "ui-igdialog-content ui-widget-content ui-dialog-content"
		},
		_create: function () {
			var elem,
				self = this,
				elem0 = self.element,
				el = elem0[0],
				url = (el && el.nodeName === "IFRAME") ? el.src : null,
				o = self.options,
				state = o.state,
				parent,
				css = self.css;
			// K.D. December 20th, 2013 Bug #159961 We're no longer attaching the dialog to the body by default
			o.container = o.container || this.element.parent();
			parent = o.container;
			self._fixIE(elem0);
			self._old = {
				position: elem0.css("position"),
				left: elem0.css("left"),
				top: elem0.css("top"),
				display: elem0.css("display"),
				visibility: elem0.css("visibility"),
				width: el.style.width,
				height: el.style.height
			};
			if (url) {
				el.src = o.temporaryUrl || "";
			}
			self._min = state === "minimized" || state === MIN;
			self._max = state === "maximized" || state === MAX;
			self._opened = state && state !== "closed";
			self._oldDad = el.parentNode;
			// Note: elem0.next() fails to return #text object
			self._next = self._oldDad ? el.nextSibling : null;
			self._dad = parent;
			// K.D. January 14th, 2014 The dialog does not preserve attributes or properties for the top-most element
			elem0 = $('<div />');
			this.element.contents().appendTo(elem0);
			self._elem = el = elem = this.element;
			elem.css({ zIndex: o.zIndex || 1000, outline: 0 }).attr("tabIndex", o.tabIndex)
				.keydown(function (e) {
					if (o.closeOnEscape && e.keyCode === $.ui.keyCode.ESCAPE) {
						self.close(e);
						e.preventDefault();
					}
					if (e.keyCode !== $.ui.keyCode.TAB) {
						return;
					}
					self._tabTime = new Date().getTime();
					if (!self._modal && !self._max) {
						return;
					}
					var min, max, ti, next,
						iNext = -1,
						big = 999999,
						iMin = big,
						iMax = -1,
						targ = e.target,
						ti0 = self._getTabIndex(targ),
						shift = e.shiftKey,
						tabs = $(":tabbable", elem[0]),
						len = tabs.length,
						i = len;
					// find first/min and last/max tabbable child elements
					while (i-- > 0) {
						ti = self._getTabIndex(el = tabs[i]);
						if (ti > iMax) {
							iMax = ti;
							max = el;
						}
						if (ti <= iMin) {
							iMin = ti;
							min = el;
						}
						// find next tabbable elem with same tabIndex as targ
						if (ti === ti0) {
							if (!next) {
								next = el === targ;
								if (!next) {
									iNext = i;
								}
							} else if (iNext < 0) {
								iNext = i;
							}
						}
					}
					// find next tabbable elem with closest tabIndex to targ
					if (iNext < 0) {
						i = len;
					}
					iMin = shift ? -1 : big;
					while (i-- > 0) {
						ti = self._getTabIndex(tabs[i]);
						if ((ti > ti0 && ti < iMin && !shift) || (ti < ti0 && ti > iMin && shift)) {
							iMin = ti;
							iNext = i;
						}
					}
					max = max || elem[0];
					min = min || max;
					// it used if page has mixed tabIndexes of elements on dialog and outside of it
					self._nextTabElem = (iNext >= 0) ? tabs[iNext] : (shift ? max : min);
					if (targ === elem[0] || (targ === min && shift) || (targ === max && !shift)) {
						_stopEvt(e);
						el = shift ? max : min;
						try { el.focus(); } catch (ex) { }
					}
				})
				.mousedown(function (e) { self.moveToTop(e); });
			el.addClass(css.dialog);
			if (o.dialogClass) {
				el.addClass(o.dialogClass);
			}
			elem0.show().addClass(css.content).appendTo(el);
			if (url !== null) {
				elem0[0].src = url;
				elem0.addClass(css.contentIframe);
			}
			self._modal = self._hasFocus = false;
			self._lastFoc = "blur";
			self._doHeader();
			self._doFooter();
			self._doDraggable();
			self._doResizable();
			if (self._min) {
				self._onMin(true, true, true);
			}
			if (self._max) {
				o.pinned = false;
				self._onMax(true, true, true);
			}
			if (o.pinned) {
				self._onPin(true, true, true);
			}
			if (self._opened) {
				self._open();
			} else {
				elem.hide();
			}
			self._created = true;
			self._save();
		},
		// get around combination of jQuery with IE7 and other versions of IE
		// IE may generate 2 nodes for <input></input>
		// node with tag </input> kills focus functionality
		// since jQuery raises exception for selectors like "/INPUT", there is no choice but remove elements manually
		_fixIE: function (elem) {
			elem = elem.find("*");
			var n, e, i = elem.length;
			while (i-- > 0) {
				e = elem[i];
				n = e.nodeName;
				if (n === "/INPUT" || n === "/IMG") {
					e.parentNode.removeChild(e);
				}
			}
		},
		destroy: function () {
			/* Destroys igDialog and moves target element to its original parent.
				returnType="object" Returns reference to this igDialog.
			*/
			// K.D. January 14th, 2014 The dialog does not preserve attributes or properties for the top-most element
			// Changing the destructor to accommodate for this.element being the top-most element
			var self = this,
				elem0 = this.element.children('.ui-igdialog-content');
			this._doClose(null, true);
			delete this._elem;
			if (self._winResize) {
				$(window).unbind("resize", self._winResize);
			}
			this.element.children('.ui-igdialog-header').remove();
			this.element.children('.ui-igdialog-footer').remove();
			//elem0.parentNode.removeChild(elem0);
			elem0.contents().unwrap();
			//elem.remove();
			this.element.removeClass(self.css.dialog).css(self._old);
			if (this.options.draggable) {
				this.element.draggable('destroy');
			}
			if (this.options.resizable) {
				this.element.resizable('destroy');
			}
			this.element.unbind();
			// if (next && next.parentNode === dad) {
				// dad.insertBefore(elem0, next);
			// } else {
				// dad.appendChild(elem0);
			// }
			$.Widget.prototype.destroy.apply(this, arguments);
			return this;
		},
		state: function (state) {
			/* Gets sets state of editor.
				Note: If state of dialog changes, then stateChanging and stateChanged events are raised.
				paramType="string" optional="true" New state.
				returnType="string" Returns state.
			*/
			if (!arguments.length) {
				return this.options.state;
			}
			if ((state === "minimized" || state === MIN) && (!this._min || !this._opened)) {
				if (!this._min) {
					this._minimize();
				} else {
					this._open(null, 1);
				}
			}
			if ((state === "maximized" || state === MAX) && (!this._max || !this._opened)) {
				if (!this._max) {
					this._maximize();
				} else {
					this._open(null, 1);
				}
			}
			if ((state === "opened" || state === OPEN) && (this._min || this._max || !this._opened)) {
				this._onMin();
				this._onMax();
				this._open();
				this.options.state = state;
			}
			if ((state === "closed" || !state) && (this._min || this._max || this._opened)) {
				this._onMin();
				this._onMax();
				this.close();
			}
			return this;
		},
		mainElement: function () {
			/* Gets reference to dynamically created DIV element which represents dialog.
				returnType="dom" Returns reference jQuery object.
			*/
			return this._elem;
		},
		close: function (e) {
			/* Closes dialog if it is opened.
				Notes:
				1. If state of dialog changes, then stateChanging and stateChanged events are raised.
				2. That method does not change minimized or maximized state of dialog.
				It means that method "open" will open dialog and keep previous minimized or maximized state.
				paramType="object" optional="true" Browser event: internal use only.
				returnType="object" Returns reference to this igDialog.
			*/
			if (this._opened) {
				this._doClose(e);
			}
			return this;
		},
		open: function () {
			/* Opens dialog if it is closed. Notes:
				1. If state of dialog changes, then stateChanging and stateChanged events are raised.
				2. That method does not change minimized or maximized state of dialog. It means that if dialog was closed by "close" method, then dialog and keep previous minimized or maximized state.
				returnType="object" Returns reference to this igDialog.
			*/
			return this._open(null, 1);
		},
		minimize: function () {
			/* Minimizes dialog if it is not minimized.
				Note: If state of dialog changes, then stateChanging and stateChanged events are raised.
				returnType="object" Returns reference to this igDialog.
			*/
			if (!this._min) {
				this._minimize();
			}
			return this;
		},
		maximize: function () {
			/* Maximizes dialog if it is not maximized.
				Note: If state of dialog changes, then stateChanging and stateChanged events are raised.
				returnType="object" Returns reference to this igDialog.
			*/
			if (!this._max) {
				this._maximize();
			}
			return this;
		},
		restore: function () {
			/* Sets normal state for dialog which was maximized or minimized.
				Note: If state of dialog changes, then stateChanging and stateChanged events are raised.
				returnType="object" Returns reference to this igDialog.
			*/
			if (this._max) {
				this._onMax();
			}
			if (this._min) {
				this._onMin();
			}
			return this;
		},
		pin: function () {
			/* Pins dialog if it is not pinned.
				When dialog is pinned, then the html element of dialog is moved to the original container where target element was located and position:absolute is removed.
				Pinned dialog does not support modal state, maximized state and it can not be moved.
				Notes:
				1. If parent element of original target-element is invisible, then pinned dialog becomes invisible as well.
				2. If state of dialog changes, then stateChanging and stateChanged events are raised.
				returnType="object" Returns reference to this igDialog.
			*/
			if (!this.options.pinned) {
				this._pin();
			}
			return this;
		},
		unpin: function () {
			/* Unpins dialog if it is pinned.
				Note: If state of dialog changes, then stateChanging and stateChanged events are raised.
				returnType="object" Returns reference to this igDialog.
			*/
			if (this.options.pinned) {
				this._pin();
			}
			return this;
		},
		getTopModal: function () {
			/* Gets reference to the top modal dialog.
				returnType="object" reference to igDialog or null.
			*/
			return _modals[_modals.length - 1];
		},
		isTopModal: function () {
			/* Checks if dialog is modal and it is currently active.
				returnType="bool" true: dialog is on top.
			*/
			return this.getTopModal() === this;
		},
		moveToTop: function (e) {
			/* Moves not modal dialog to the top.
				paramType="object" optional="true" Original event of browser.
				returnType="object" Returns reference to this igDialog.
			*/
			var src, name,
				self = this,
				o = self.options,
				zi = o.zIndex,
				elem = self._elem,
				zi0 = self._created ? null : zi,
				modal = o.modal,
				elem0 = this.element[0],
				scrollTop = elem0.scrollTop,
				scrollLeft = elem0.scrollLeft;
			if ($.ig && $.ig.util && $.ig.util.evtButton(e)) {
				return;
			}
			zi = zi || 1000;
			// cancel mousedown for header and footer
			src = e ? e.target : null;
			if (_isSrc(self._header, src) || _isSrc(self._footer, src)) {
				name = src.nodeName;
				if (name !== "INPUT" && name !== "BUTTON") {
					_stopEvt(e);
					// ensure focus
					self._setFocus();
				}
			} else if (e && !this._hasFocus) {
				// ensure focus
				self._setFocus();
			}
			_maxZ = Math.max(zi0 || zi, _maxZ);
			if (o.pinned) {
				return self;
			}
			if (modal && self._lastZ) {
				// if it is modal dialog with hidden shell, then adjust shells
				elem = self._modalDiv;
				if (elem && elem[0].offsetWidth < 10) {
					self._onResize();
				}
				return self;
			}
			if (_lastTop === self && (zi0 || zi) >= _maxZ) {
				return self;
			}
			if (_lastTop && !zi0) {
				_lastTop._elem.css("zIndex", _lastTop._lastZ || -1);
				_lastTop._save();
			}
			if (_lastZ >= _maxZ) {
				_maxZ++;
			}
			if (modal && !zi0) {
				_maxZ++;
				_maxZ++;
			}
			// bug:120224
			//if ((zi0 || zi) >= _lastZ) {
			_lastTop = self;
			//}
			self._lastZ = _lastZ = zi0 || ((modal || _modals.length > 0) ? _maxZ : zi);
			if (!zi0) {
				elem.css("zIndex", zi0 || _maxZ);
				self._save();
			}
			elem0.scrollTop = scrollTop;
			elem0.scrollLeft = scrollLeft;
			if (modal) {
				self._doModal(_maxZ);
			}
			return self;
		},
		content: function (newContent) {
			/* Retrieves the igDialog content container or sets its content to be the new content provided.
				paramType="string" optional="true" The new html content provided as a string. If the parameter is provided then the method acts as a setter.
				returnType="object" If no parameter is provided then the method returns the container carrying the igDialog content. This is the inner container of the dialog window excluding headers, resizing handlers, etc.
			*/
			if (arguments.length === 0) {
				return this.element.children(".ui-igdialog-content");
			}
			this.element.children(".ui-igdialog-content").html(newContent);
		},
		_save: function () {
			var str, input, pos, o = this.options, name = o.inputName;
			if (!name) {
				return;
			}
			input = $('input[name="' + name + '"]');
			if (input.length === 0) {
				input = input.parents("form")[0] || document.forms[0];
				if (!input) {
					return;
				}
				input = $('<input type="hidden" name="' + name + '" />').appendTo(input);
			}
			str = "s" + (o.pinned ? "1" : "") + (this._opened ? (this._min ? 2 : (this._max ? 3 : 1)) : 0) +
				(o.width ? ":w" + o.width : "") + (o.height ? ":h" + o.height : "") + (":z" + this._elem.css("zIndex") || o.zIndex);
			pos = o.position;
			if (pos && pos.length === 2) {
				str += ":p" + pos[0] + "," + pos[1];
			}
			input.val(str);
		},
		_open: function (e, raiseEvt) {
			var self = this,
				o = self.options,
				elem = self._elem,
				anim = self._min ? null : o.openAnimation,
				arg = { action: "open", owner: this };
			if ((self._opened && self._vis) || (raiseEvt && !self._fireState(e, true, arg))) {
				return self;
			}
			if (!o.pinned) {
				elem.css("position", "absolute");
			}
			//A.T. 9 July - Fix for bug #142753
			if (o.width !== null) {
				elem.show();
			}
			// adjust opened before _doSize, because _onResize may fail
			self._opened = true;
			self._doSize(1);
			if (anim) {
				elem.hide().show(anim, function () {
					self._trigger("animationEnded", e, arg);
				});
			}
			self._vis = true;
			_visCount++;
			// enable focus/blur processing
			self._trackFocus(elem);
			self.moveToTop(true);
			self._fixState();
			if (raiseEvt) {
				self._fireState(e, false, arg);
			}
			self._save();
			return self;
		},
		_initContainer: function (container, change) {
			if (container) {
				if (typeof container === "string") {
					container = $(container);
				}
				if (container && container[0]) {
					container = container[0];
				}
			}
			if (!container || !container.parentNode) {
				container = this.element.parents("form")[0] || document.body;
			} else if (container.nodeName !== "BODY") {
				var style = container.style, pos = style ? style.position : null;
				if (style && (!pos || pos === "static")) {
					style.position = "relative";
				}
			}
			if (change) {
				this._elem.appendTo(container);
			}
			return container;
		},
		_fixState: function () {
			this.options.state = this._opened ? (this._min ? "minimized" : (this._max ? "maximized" : "opened")) : "closed";
		},
		_minimize: function (e) {
			return this._doState(e, { action: this._min ? "restore" : "minimize" }, e ? "minimize" : null, "_onMin", true);
		},
		_maximize: function (e) {
			return this._doState(e, { action: this._max ? "restore" : "maximize" }, e ? "maximize" : null, "_onMax", true);
		},
		_pin: function (e) {
			return this._doState(e, { action: this.options.pinned ? "unpin" : "pin" }, e ? "pin" : null, "_onPin");
		},
		_close: function (e) {
			return this._opened ? this.close(e) : this._open(e);
		},
		_getTabIndex: function (e) {
			return (isNaN(e = parseInt(e.tabIndex, 10)) || e < 1) ? 0 : e;
		},
		_doHeader: function () {
			var button, id, evts,
				i = 4,
				self = this,
				header = self._header,
				o = self.options,
				txt = o.headerText,
				css = self.css;
			if (header) {
				header.remove();
			}
			delete self._minHW;
			header = self._header = _notab($("<div />").addClass(css.header).css("display", "block").prependTo(self._elem)).dblclick(function (e) {
				var dbl = o.enableDblclick;
				if (!dbl) {
					return;
				}
				if (self._min) {
					self._doState(e, { action: "restore" }, null, "_onMin", true);
				} else if (dbl === true || (dbl === "auto" && o.showMaximizeButton)) {
					self._doState(e, { action: self._max ? "restore" : "maximize" }, null, "_onMax", true);
				}
			});
			//
			if (o.imageClass) {
				self._img = $("<span />").addClass(css.headerImage).addClass(o.imageClass).html("&nbsp;").appendTo(header);
			}
			self._headerText = $("<span />").addClass(css.headerText).html(txt || "&nbsp;").appendTo(header);
			//
			evts = {
				mouseover: function () { $(this).addClass(css.headerButtonHover); },
				mouseleave: function () { $(this).removeClass(css.headerButtonHover); },
				mousedown: function (e) { this._mdb = $.ig && $.ig.util && $.ig.util.evtButton(e); },
				click: function (e) {
					if (!e || this._mdb) {
						return;
					}
					try {
						self["_" + $(this).attr("data-id")](e);
					} catch (ex) {}
					_stopEvt(e);
				},
				touchstart: function (e) { this._drag = null; _stopEvt(e); },
				touchmove: function (e) { this._drag = 1; _stopEvt(e); },
				touchend: function (e) { if (!this._drag) { $(this).trigger("click"); } }
			};
			// i=order of buttons in header:pin,min,max,close
			while (i-- >= 0) {
				if (i === 3 && o.showCloseButton) {
					id = "close";
				} else if (i === 2 && o.showMaximizeButton) {
					id = "maximize";
				} else if (i === 1 && o.showMinimizeButton) {
					id = "minimize";
				} else {
					id = (i === 0 && o.showPinButton) ? "pin" : null;
				}
				if (id) {
					button = $("<a />").addClass(css.headerButton + " " + css[id]).attr("data-id", id)
						.attr("href", "#").attr("role", "button").bind(evts).appendTo(header);
					$("<span />").addClass(css[id + "Icon"]).appendTo(button);
					// i=order of buttons in header:pin,min,max,close
					self._loc(button, i === 3 ? CLOSE : (i === 2 ? MAX : (i === 1 ? MIN : PIN)));
				}
			}
			if (!o.showHeader) {
				header.hide();
			}
		},
		_doFooter: function () {
			var self = this,
				o = self.options,
				txt = o.footerText,
				css = self.css;
			if (self._footer) {
				self._footer.remove();
				delete self._footer;
			}
			if (o.showFooter) {
				self._footer = _notab($("<div />").addClass(css.footer).css("display", "block").html(txt || "&nbsp").appendTo(self._elem));
			}
		},
		_onMin: function (e, noSize, noFocus) {
			var but,
				o = this.options,
				bar = this._footer,
				css = this.css,
				header = this._header,
				min = (e && e.type) ? !this._min : !!e;
			if (min === this._min && this._created) {
				return;
			}
			this._min = min;
			if (min && o.pinOnMinimized) {
				this._onPin(min, true, true);
			}
			but = header.find("." + css.minimize);
			but.find("*").removeClass(min ? css.minimizeIcon : css.restoreIcon).addClass(min ? css.restoreIcon : css.minimizeIcon);
			if (e && e.type && min && this._max) {
				this._onMax(false, true, true);
			}
			this._loc(but, min ? RESTORE : MIN);
			if (min) {
				header.addClass(css.headerMinimized);
				if (bar) {
					bar.hide();
				}
			} else {
				header.removeClass(css.headerMinimized);
				if (bar) {
					bar.show();
				}
			}
			if (!noSize && this._vis) {
				this._doSize();
			}
			if (!noFocus && this._vis) {
				this._setFocus();
			}
			this._save();
		},
		_onMax: function (e, noSize, noFocus) {
			var but,
				o = this.options,
				header = this._header,
				css = this.css,
				max = (e && e.type) ? !this._max : !!e;
			if (max === this._max && this._created) {
				return;
			}
			this._max = max;
			if (!max) {
				this._restoreHtml();
			} else {
				// K.D. July 3rd, 2014 Bug #166685 Attaching the dialog to the body before maximize and restoring its
				// position in the DOM on minimize.
				this._originalParent = this.element.parent();
				this.element.appendTo(document.body);
			}
			but = header.find("." + css.maximize);
			but.find("*").removeClass(max ? css.maximizeIcon : css.restoreIcon).addClass(max ? css.restoreIcon : css.maximizeIcon);
			this._loc(but, max ? RESTORE : MAX);
			if (max) {
				if (this._min) {
					this._onMin(false, true, true);
				}
				if (o.pinned) {
					this._onPin(false, true, true);
				}
			}
			if (max) {
				header.addClass(css.unmovable);
			} else {
				header.removeClass(css.unmovable);
			}
			if (!noSize && this._vis) {
				this._doSize();
			}
			if (!noFocus && this._vis) {
				this._setFocus();
			}
			this._save();
		},
		_onPin: function (e, noSize, noFocus) {
			var but, elem, parent, dad, pos,
				old = this._old,
				next = this._next,
				css = this.css,
				header = this._header,
				o = this.options,
				pin = (e && e.type) ? !o.pinned : !!e;
			if (pin === o.pinned && this._created) {
				return;
			}
			o.pinned = pin;
			// fix icon on pin-button
			but = header.find("." + css.pin);
			but.find("*").removeClass(pin ? css.pinIcon : css.unpinIcon).addClass(pin ? css.unpinIcon : css.pinIcon);
			if (this._max && pin) {
				this._onMax(false, false, true);
			}
			this._loc(but, pin ? UNPIN : PIN);
			if (pin) {
				header.addClass(css.unmovable);
			} else {
				header.removeClass(css.unmovable);
			}
			// fix position of dialog
			elem = this._elem;
			if (pin) {
				pos = old.position;
				if (this._resize && (pos === "static" || !pos)) {
					pos = "relative";
				}
				this._pinPos = pos = { position: pos, left: old.left, top: old.top };
			} else {
				pos = { position: "absolute" };
			}
			elem.css(pos);
			// fix parent
			parent = elem.parent()[0];
			dad = pin ? this._oldDad : this._dad;
			if (dad && dad !== parent) {
				if (pin && next && next.parentNode === dad) {
					elem.insertBefore(next);
				} else {
					elem.appendTo(dad);
				}
			}
			if (!noFocus && this._vis) {
				this._setFocus();
			}
			if (!noSize && this._vis) {
				if (!pin) {
					this._doSize(1);
				} else {
					this._doModal();
				}
			}
			this._save();
		},
		_doClose: function (e, destroy) {
			var i,
				self = this,
				elem = self._elem,
				arg = { action: "close" },
				o = self.options,
				anim = (self._min || destroy) ? null : o.closeAnimation;
			if (!self._opened || (!destroy && !self._fireState(e, true, arg, e ? "close" : null))) {
				return;
			}
			// disable focus/blur processing
			self._trackFocus(elem, 1);
			self._restoreHtml();
			if (_lastTop === self) {
				_lastTop = null;
			}
			self._fireFoc(false);
			self._hasFocus = false;
			delete self._lastZ;
			self._vis = self._opened = false;
			if (destroy) {
				o.modal = false;
			}
			self._doModal();
			if (anim) {
				elem.hide(anim, function () {
					self._trigger("animationEnded", e, arg);
				});
			} else if (!destroy) {
				elem.hide();
			}
			if (!destroy) {
				self._fixState();
				self._fireState(e, false, arg);
			}
			if (--_visCount < 1) {
				_visCount = _lastZ = _maxZ = 0;
			} else if (_visCount === (i = _modals.length)) {
				_modals[i - 1]._setFocus();
			}
			self._save();
		},
		// fire stateChanging/ed event
		// e-browser event
		// before-cancelable before event (suffix ing or ed)
		// arg-ui argument
		// but-name of button or null
		_fireState: function (e, before, arg, but) {
			if (before) {
				var o = this.options;
				arg.oldState = o.state;
				arg.oldPinned = o.pinned;
				arg.owner = this;
				if (but) {
					arg.button = but;
				}
			}
			return this._created ? this._trigger("stateChang" + (before ? "ing" : "ed"), e, arg) : true;
		},
		// fire both stateChanging/ed events and call fnName function
		// e-browser event
		// arg-ui argument
		// but-name of button or null
		// fnName-name of function to call if before-event was not canceled
		// show-ensure that dialog is opened
		_doState: function (e, arg, but, fnName, show) {
			if (this._fireState(e, true, arg, but)) {
				this[fnName](e || { type: 1 });
				if (show && !this._opened) {
					this._open(null, true);
				}
				this._fixState();
				if (this._created) {
					this._trigger("stateChanged", e, arg);
				}
			}
			return this;
		},
		_fireFoc: function (foc, e) {
			var name = foc ? "focus" : "blur";
			if (name !== this._lastFoc) {
				// memorize last focus/blur state
				this._trigger(this._lastFoc = name, e, { owner: this });
				if (this.options.enableHeaderFocus) {
					name = this.css.headerFocus;
					if (foc) {
						this._header.addClass(name);
					} else {
						this._header.removeClass(name);
					}
				}
			}
		},
		// attach focus/blur event listeners to elem and all its children
		// remove: request to remove event listeners
		_trackFocus: function (elem, remove) {
			var self = this, focusEvt = self._focusEvt, track = self.options.trackFocus;
			if (!focusEvt && !track) {
				return;
			}
			if (remove) {
				if (self._focBind) {
					self._focBind.unbind(focusEvt);
					delete self._focBind;
				}
				return;
			}
			if (!focusEvt) {
				focusEvt = function (e) {
					var elems, old = self._focBind, foc = e.type === "focus";
					if (!foc && old && elem) {
						// add focus listeners to new children (like editors in grid)
						elems = elem.find("*").not(old);
						if (elems.length) {
							self._focBind = old.add(elems);
							elems.bind(focusEvt);
						}
					}
					self._hasFocus = foc;
					// fire focus/blur events with delay with validation for last state
					setTimeout(function () {
						var focusTo = self.getTopModal(), elem = self._elem;
						// do not allow lost focus for modal dialog
						if (elem && focusTo && !self._hasFocus && !foc && _lastTop === self) {
							// modal or maximized dialog lost focus
							if (self._max || focusTo === self) {
								focusTo = self._nextTabElem || elem[0];
							// not-modal-child-dialog of modal-dialog lost focus on tab
							} else {
								focusTo = (self._tabTime && (new Date().getTime() - self._tabTime) < 200) ? elem[0] : null;
							}
							if (focusTo) {
								self._setFocus(focusTo);
							}
						}
						// raise focus/blur events
						self._fireFoc(self._hasFocus, e);
					}, 50);
				};
				focusEvt = self._focusEvt = { focus: focusEvt, blur: focusEvt };
			}
			if (track && elem) {
				self._focBind = elem.find("*").add(elem).bind(focusEvt);
			}
		},
		_setFocus: function (elem) {
			var self = this;
			setTimeout(function () {
				try {
					if (!self._hasFocus) {
						if (!self.options.trackFocus) {
							self._hasFocus = true;
						}
						elem = elem || self._elem[0];
						elem.focus();
					}
				} catch (ex) {}
			}, 100);
		},
		// used after maximized off
		_restoreHtml: function () {
			var html, old = this._oldHtml, parent = this._originalParent;
			if (parent) {
				this.element.appendTo(parent);
				this._originalParent = null;
			}
			if (old) {
				html = old.html;
				if (html.style) {
					html.style.overflow = old.overflow;
				}
				html.scrollLeft = old.scrollLeft;
				html.scrollTop = old.scrollTop;
				delete this._oldHtml;
			}
		},
		_touch: function (elem, name) {
			var start, self = this, evt = function (evt, type) {
				var act, e = evt.originalEvent,
					touches = e ? e.touches : null,
					one = touches && touches.length === 1;
				// type: null-end
				if (one && type) {
					_stopEvt(evt);
				}
				// !one: scrolling should be ended
				one = one && type === "move";
				if (start) {
					start = one ? start : null;
					act = one ? "Drag" : "Stop";
				} else if (one) {
					start = true;
					elem.trigger("mouseover");
					act = "Start";
				}
				if (act) {
					e = self._elem.data(name);
					act = "_mouse" + act;
					// explicitly call _mouseStart/Drag/Stop methods of draggable or resizable
					if (e && e[act]) {
						evt.pageX = one ? touches[0].pageX : 0;
						evt.pageY = one ? touches[0].pageY : 0;
						e[act](evt);
					}
				}
			};
			elem.bind({
				touchstart: function (e) { evt(e, "start"); },
				touchmove: function (e) { evt(e, "move"); },
				touchend: function (e) { evt(e); }
			});
		},
		_doDraggable: function () {
			var self = this, o = self.options, elem = self._elem;
			if (elem.draggable && o.draggable) {
				self._touch(self._header, "draggable");
				elem.draggable({
					cancel: ".ui-igdialog-content, .ui-igdialog-headerbutton",
					handle: ".ui-igdialog-header",
					containment: "document",
					start: function () {
						if (o.pinned || self._max) {
							return false;
						}
						$(this).addClass(self.css.dragging);
					},
					stop: function (e, ui) {
						var doc = $(document);
						o.position = [ui.position.left - doc.scrollLeft(), ui.position.top - doc.scrollTop()];
						$(this).removeClass(self.css.dragging);
						self._save();
					}
				});
			}
		},
		_doResizable: function () {
			var elems, r, i = 0, self = this, o = self.options, elem = self._elem, pos;
			if (!elem.resizable) {
				return;
			}
			self._resize = o.resizable;
			if (!self._resize) {
				return;
			}
			elem.css("position", elem.css("position")).resizable({
				cancel: "." + self.css.content,
				containment: "document",
				alsoResize: self.element.children('.ui-igdialog-content'),
				maxWidth: o.maxWidth,
				maxHeight: o.maxHeight,
				minWidth: self._minWidth(),
				minHeight: o.minHeight,
				handles: (typeof o.resizable === "string") ? o.resizable : "n,e,s,w,se,sw,ne,nw",
				start: function (event, ui) {
					// Note: cancel has no effect
					$(this).addClass(self.css.resizing);
					// restore position, left and top, which were modified by resizing
					pos = ui.originalPosition;
					if (o.pinned && self._pinPos) {
						elem.css(self._pinPos);
					}
				},
				resize: function () {
					// Note: cancel has no effect
					self._fixCaption();
					// K.D. December 20th, 2013 Bug #159961 Keeping the position because 
					// resizable messes it if inside absolute or relative element.
					elem.css(pos);
					// restore position, left and top, which were modified by resizing
					if (o.pinned && self._pinPos) {
						elem.css(self._pinPos);
					}
				},
				stop: function () {
					$(this).removeClass(self.css.resizing);
					o.height = $(this).height();
					o.width = $(this).width();
					self._save();
				}
			}).find(".ui-resizable-se").addClass("ui-icon ui-icon-grip-diagonal-se");
			r = elem.data("resizable") || elem.data("ui-resizable");
			if (r) {
				// get around bug in resizable related to bounds of container
				if (!r._dragFix) {
					r._dragFix = r._mouseDrag;
					r._mouseDrag = function (e) {
						var x, y, d = r.parentData;
						if (d && e) {
							x = e.pageX;
							y = e.pageY;
							if (x <= d.left || y <= d.top || x >= d.left + d.width || y >= d.top + d.height) {
								return false;
							}
						}
						return r._dragFix(e);
					};
				}
				elems = r._handles;
				i = elems.length;
			}
			while (i-- > 0) {
				self._touch($(elems[i]), "resizable");
			}
		},
		_toPx: function (val, height) {
			if (typeof val === "number") {
				return val;
			}
			if (!val) {
				return height ? val : 0;
			}
			val = val.toString();
			var elem, num = parseInt(val, 10);
			if (isNaN(num)) {
				return 0;
			}
			// check for em, ex, in, cm, mm, pt units
			if (val.indexOf("m") > 0 || val.indexOf("e") > 0 || val.indexOf("i") > 0 || val.indexOf("t") > 0) {
				elem = $("<div />").css({ visibility: "hidden", width: val }).appendTo(this._dad);
				num = elem.width();
				elem.remove();
			} else if (val.indexOf("%") > 0) {
				val = this._winRect(1);
				val = height ? val.height : val.width;
				return Math.floor(num * val / 100);
			}
			return num;
		},
		// fixPos: force adjust position
		// note: dialog should be already opened
		_doSize: function (fixPos) {
			// fix size
			var self = this,
				o = self.options,
				max = self._max,
				pos = max ? [0, 0] : o.position,
				resize = self._resize ? ".ui-resizable-handle" : null,
				elem0 = self.element.children('.ui-igdialog-content'),
				elem = self._elem;
			if (resize) {
				// show/hide resizing handles
				if (self._min || max) {
					$(resize, elem).hide();
				} else {
					$(resize, elem).show();
				}
			}
			// temporary hide headerText, it will be adjusted by _fixCaption
			self._headerText.css("width", 0);
			if (self._min) {
				elem0.hide();
				self._fixCaption(elem);
			} else if (max) {
				elem0.show().css({ width: "auto", height: "auto" });
				// temporary collapse dialog: to correctly set position (any reasonable values)
				elem.css({ width: 100, height: 50 });
			//A.T. 9 July - Fix for bug #142753
			} else if (o.width !== null) {
				this._doSizePX(elem0,
					elem,
					Math.max(self._minWidth(), self._toPx(o.width)),
					self._toPx(o.height, true),
					o.minHeight);
				if (resize) {
					elem.resizable("option", "minHeight", o.minHeight);
				}
			}
			if (o.width === null) {
				this._fixCaption(elem);
				elem.show();
			}
			// fix position
			if (!o.pinned && (fixPos || max || self._oldMax)) {
				self._oldMax = max;
				if (max) {
					self._onResize();
				}
				if (elem.position) {
					if (pos) {
						if (pos.left !== undefined && pos.top !== undefined) {
							pos = [ pos.left, pos.top ];
						}
						if (pos && pos.length > 1) {
							if (typeof pos[0] !== "number") {
								pos[0] = parseInt(pos[0]);
							}
							if (typeof pos[1] !== "number") {
								pos[1] = parseInt(pos[1]);
							}
							if (isNaN(pos[0]) || isNaN(pos[1])) {
								pos = {};
							} else {
								// N.A. 10/17/2013 - Bug #155039: The property "offset" is deprecated in 1.9.
								if ($.ig.util.jQueryUIMainVersion <= 1 && $.ig.util.jQueryUISubVersion < 9) {
									pos = { my: "left top", at: "left top", offset: pos[0] + " " + pos[1] };
								} else {
									pos = { my: "left+" + pos[0] + " top+" + pos[1], at: "left top" };
								}
							}
						}
						pos = $.extend({}, _pos, pos);
					}
					elem.css({ top: 0, left: 0 }).position(pos || _pos);
				}
			}
			self._doModal();
			self._save();
		},
		// adjust px width and height of dialog (not minimized)
		_doSizePX: function (elem0, elem, width, height, minHeight) {
			// temporary collapse content in order to calculate height (minHeight) of header text and border/padding of content
			elem0.show().css({ width: "auto", height: 0, minHeight: 0 });
			var ie7, zeroHeight = elem.css({ width: width, height: "auto", display: "block" }).height(),
				nodeName = elem0[0].nodeName;
			this._fixCaption(elem);
			if (typeof height === "string") {
				if (height.indexOf("px") > 0) {
					height = parseInt(height, 10);
				}
			}
			// auto size for height
			if (typeof height !== "number") {
				height = elem0.css("height", "auto").height() + zeroHeight;
			}
			if (nodeName !== "DIV") {
				if (nodeName === "IFRAME") {
					// Note: experimental/test adjustments
					width -= _getPadding(elem0);
					ie7 = $.ig.util.isIE7;
					if (!ie7 || isNaN(ie7) || ie7 > 7) {
						height += 5;
					}
				}
				elem0.width(width - _getPadding(elem0, false, "margin"));
			}
			height = Math.max(minHeight, height);
			elem0.height(Math.max(height - zeroHeight, 0));
			minHeight = height - elem[0].offsetHeight;
			if (minHeight > 0) {
				elem0.height(Math.max(height - zeroHeight + minHeight, 0));
			}
		},
		_onResize: function () {
			var rect, self = this, div = self.isTopModal() ? self._modalDiv : null;
			if (!self._winResize) {
				$(window).bind("resize", self._winResize = function () {
					setTimeout(function () {
						self._onResize();
					}, 50);
				});
			}
			if (!self._opened || self.options.pinned) {
				return;
			}
			// collapse modal DIV/IFRAME-shells
			if (div) {
				div.hide();
				self._doIframe(div, 1);
			}
			// adjust maximized dialog
			if (self._max) {
				self._doMaxSize(self._elem);
			}
			// adjust modal DIV/IFRAME-shells
			if (div) {
				rect = self._winRect();
				div.css({ width: rect.maxWidth - 1, height: rect.maxHeight - 1 }).show();
				self._doIframe(div);
			}
		},
		_minHeaderWidth: function () {
			var outerWidth, elem,
				width = this._minHW,
				elems = this._header.children().not(this._headerText),
				i = elems.length;
			if (!width) {
				width = 3 + _getPadding(this._header);
				while (--i >= 0) {
					elem = elems[i];
					// get around bugs in jquery-1.4.4 (exception in Opera or huge elem.outerWidth in IE)
					try {
						outerWidth = $(elem).outerWidth(true);
					} catch (ex) {}
					width += 1 + ((outerWidth && outerWidth > 2 && outerWidth < 100) ? outerWidth : elem.offsetWidth);
				}
				this._minHW = width;
			}
			return width;
		},
		// minimal width of dialog in normal (not mimimized) state
		_minWidth: function () {
			if (!this._minW) {
				this._minW = this._minHeaderWidth();
			}
			return Math.max(this.options.minWidth, this._minW);
		},
		// adjust width of header text to fit into available width of header
		_fixCaption: function (elem) {
			var width, widths, top, len, topi,
				j = 0,
				i = -1,
				header = this._header,
				cap = this._headerText,
				minCss = this.css.headerTextMinimized;
			if (this._min) {
				cap.css("width", "").addClass(minCss);
				if (!elem) {
					return;
				}
				elem.css({ height: "auto", width: "auto", display: "inline-block" });
				// get around IE6/7 and draggable beyond right edge: check if width of header/dialog is not larger than widths of children
				widths = _getPadding(header) + 3;
				cap = header.children();
				len = cap.length;
				while (++i < len) {
					widths += cap[i].offsetWidth + _toPx($(cap[i]), "marginLeft") + _toPx($(cap[i]), "marginRight");
				}
				while (j++ < 2) {
					elem.css("width", widths);
					// verify that buttons did not jump on 2nd line
					widths += 2;
					i = len;
					while (i-- > 0) {
						topi = cap[i].offsetTop;
						if (i > 0 && i < len - 1 && Math.abs(top - topi) > 4) {
							break;
						}
						top = topi;
					}
					if (i < 0) {
						j = 4;
					}
				}
				return;
			}
			cap.removeClass(minCss);
			// get around bugs in jquery-1.4.4 (exception in Opera or huge elem.innerWidth in IE)
			try {
				width = header.innerWidth() - 3;
			} catch (ex) { }
			if (!width || width > 1000) {
				width = header[0].clientWidth - 4;
			}
			width = Math.max(1, width - this._minHeaderWidth());
			cap.css("width", "auto");
			// if themeroller is used, then fonts can change without notification:
			// assume jump from smallest to largest (very ~, but at least something)
			if (cap[0].offsetWidth * 1.3 > width) {
				cap.css("width", width);
			}
		},
		// stretch dialog to size of window
		_doMaxSize: function (elem) {
			var html,
				old = this._oldHtml,
				elem0 = this.element,
				rect = this._winRect(),
				paddingX = _getPadding(elem),
				paddingY = _getPadding(elem, 1);
			html = rect.html;
			if (!old) {
				// save old attributes of window before maximize
				this._oldHtml = old = {
					html: html,
					scrollLeft: html.scrollLeft,
					scrollTop: html.scrollTop
				};
				html.scrollLeft = html.scrollTop = 0;
				if (html.style) {
					old.overflow = html.style.overflow;
					html.style.overflow = "hidden";
					// if window had scrollbars, then recalculate size
					if (rect.maxWidth > rect.width || rect.maxHeight > rect.height) {
						rect = this._winRect(1);
					}
				}
			}
			this._doSizePX(elem0, elem, rect.width - paddingX - 1, rect.height - paddingY - 1, 0);
		},
		// returns properties of window/HTML { width, height, maxWidth, maxHeight, html }
		_winRect: function (sizeOnly) {
			var size, docElem, width, height, widthOk, heightOk,
				container = this.options.container,
				maxWidth = 0,
				maxHeight = 0,
				big = 999999,
				win = window,
				doc = win.document,
				body = doc.body,
				html = body;
			// K.D. December 20th, 2013 Bug #159961 We're no longer attaching the dialog to the body by default
			// if (container) {
				// width = container.offsetWidth;
				// height = container.offsetHeight;
				// return { width: width, height: height, maxWidth: width, maxHeight: height, html: container };
			// }
			// find HTML
			while (html && html.nodeName !== "HTML") {
				html = html.parentNode;
			}
			if (!html) {
				html = body;
			}
			docElem = doc.documentElement || html;
			// check for quirks of IE
			size = ((doc.compatMode !== "CSS1Compat") && $.ig.util.isIE) ? body : html;
			width = size.clientWidth;
			height = size.clientHeight;
			if (sizeOnly) {
				return { width: width, height: height };
			}
			// any reasonable valid value
			if (width && width > 50) {
				maxWidth = width;
				maxHeight = height;
			} else {
				width = height = big;
			}
			widthOk = html.scrollWidth;
			heightOk = html.scrollHeight;
			if (widthOk && heightOk) {
				maxWidth = Math.max(maxWidth, widthOk);
				maxHeight = Math.max(maxHeight, heightOk);
			}
			maxWidth = Math.max(maxWidth, body.scrollWidth);
			maxHeight = Math.max(maxHeight, body.scrollHeight);
			widthOk = body.offsetWidth;
			heightOk = body.offsetHeight;
			maxWidth = Math.max(maxWidth, widthOk);
			maxHeight = Math.max(maxHeight, heightOk);
			return { width: (width === big) ? widthOk : width, height: (height === big) ? heightOk : height, maxWidth: maxWidth, maxHeight: maxHeight, html: html };
		},
		// create _iframe, adjust its parent and size
		// hide: request to temporary hide iframe (width/height:1px)
		_doIframe: function (div, hide) {
			// trick jslint validation for illegal "JavaScript URL" by hiding part in var
			var src = "javascript";
			if (!_iframe) {
				_iframe = _notab($("<iframe />").attr("frameBorder", 0).attr("scrolling", "no")
					.attr("src", src + ":''")
					.css({ position: "absolute", filter: "alpha(opacity=50)", opacity: 0 }));
			}
			if (_iframe.parent()[0] !== div.parent()[0]) {
				_iframe.css({ width: "1px", height: "1px", marginLeft: div.css("marginLeft"), marginTop: div.css("marginTop"),
					left: div.css("left"), top: div.css("top"), zIndex: div.attr("zIndex") - 1 }).insertBefore(div);
			}
			_iframe.css({ width: hide ? "1px" : div.css("width"), height: hide ? "1px" : div.css("height") });
		},
		// zi: zIndex used when modal shell is visible
		// implement all actions related to modal functionality: start/end modal depending on visibility/pin/minimized
		_doModal: function (zi) {
			var i, pos, on, obj,
				len = _modals.length,
				self = this, o = self.options,
				elem = self._elem,
				div = self._modalDiv;
			on = o.modal && !o.pinned && !self._min && self._opened;
			i = $.inArray(self, _modals);
			if (self._modal === on) {
				if (zi && div) {
					div.css("zIndex", zi - 1);
					self._onResize();
				}
				// if that dialog is not modal, then ensure that last modal dialog in array is on top
				if (!on && !_lastTop && len > 0) {
					_modals[len - 1].moveToTop();
				}
				return;
			}
			// add new dialog to array
			if (i < 0 && on) {
				// hide shell of previous top dialog
				if (len > 0) {
					_modals[len - 1]._modalDiv.hide();
				}
				_modals.push(self);
			}
			// remove this dialog from array
			if (i >= 0 && !on) {
				// find last dialog in array, which will be moved on top
				if (i > 0 && i + 1 === len) {
					obj = _modals[i - 1];
				}
				_modals.splice(i, 1);
			}
			self._modal = on;
			if (on) {
				self._modalDiv = div = _notab($("<div />").css({ position: "absolute", left: 0, top: 0, zIndex: _maxZ - 1 })
					.addClass(self.css.overlay).mousedown(function (e) {
						self._setFocus();
						_stopEvt(e);
					})
					.insertBefore(elem));
				pos = div.offset();
				div.css({ marginLeft: -pos.left + "px", marginTop: -pos.top + "px" });
				self._onResize();
			} else {
				div.remove();
				_iframe.remove();
				delete self._modalDiv;
				if (obj) {
					obj.moveToTop();
				}
			}
		},
		_loc: function (but, state) {
			state = ((state === MIN) ? "minimize" : ((state === MAX) ? "maximize" : ((state === RESTORE) ?
					"restore" : ((state === CLOSE) ? "close" : ((state === PIN) ?
					"pin" : ((state === UNPIN) ? "unpin" : "open")))))) + "ButtonTitle";
			var val = this.options[state] || ($.ig && $.ig.Dialog && $.ig.Dialog.locale ? $.ig.Dialog.locale[state] : null) || "";
			but.attr("title", val).attr("longdesc", val);
		},
		_setOption: function (key, val) {
			var pos, size, drag, resize,
				elem = this._elem, o = this.options, container = key === "container";
			if (!elem || !key || o[key] === val || key === "mainElement") {
				return this;
			}
			if (key === "state") {
				return this.state(val);
			}
			if (key === "pinned") {
				return this._pin();
			}
			if (container) {
				if (o.draggable && elem.draggable) {
					elem.draggable("destroy");
					drag = true;
				}
				if (o.resizable && elem.resizable) {
					elem.resizable("destroy");
					resize = true;
				}
			}
			$.Widget.prototype._setOption.apply(this, arguments);
			if (typeof val === "function") {
				return this;
			}
			if (container) {
				this._initContainer(val, 1);
				if (drag) {
					this._doDraggable();
				}
				if (resize) {
					this._doResizable();
				}
			}
			if (key === "draggable") {
				if (val) {
					this._doDraggable();
				} else if (elem.draggable) {
					elem.draggable("destroy");
				}
			}
			if (key === "resizable") {
				if (val) {
					this._doResizable();
				} else if (this._resize) {
					this._resize = val;
					elem.resizable("destroy");
				}
			}
			if (key === "modal") {
				this._doModal();
			}
			if (key.indexOf("Button") > 0 || key === "image" || key === "headerText" || key === "showHeader") {
				this._doHeader();
				size = true;
			}
			// check for showFooter and footerText
			if (key.indexOf("ooter") > 0) {
				this._doFooter();
				size = true;
			}
			if (key === "tabIndex") {
				elem.attr("tabIndex", val);
			}
			if (key === "zIndex") {
				elem.css("zIndex", val);
				this._save();
			}
			if (this._vis) {
				pos = key === "position";
				// check for height, width, minHeight, minWidth, maxHeight, maxWidth
				if (container || size || pos || key.indexOf("idth") > 0 || key.indexOf("eight") > 0) {
					this._doSize(pos || container);
				}
			}
			// check for trackFocus, enableHeaderFocus
			if (key.indexOf("Foc") > 0) {
				this._header.removeClass(this.css.headerFocus);
				var isFocBind = (this._focBind ? true : false);
				if (key === "trackFocus" && val !== isFocBind) {
					if (this._opened) {
						this._doClose();
						this._open();
					} else {
						this._open();
						this._doClose();
					}
				}
			}
			return this;
		}
	});
	$.extend($.ui.igDialog, { version: "14.1.20141.2249" });
}(jQuery));

/*!@license
* Infragistics.Web.ClientUI Editors localization resources 14.1.20141.301
/*!@license
* Infragistics.Web.ClientUI Editors 14.1.20141.2249
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends on:
* jquery-1.4.4.js
* jquery.ui.core.js
* jquery.ui.widget.js
* jquery.ui.datepicker.js
* infragistics.util.js
*
* Example to use:
*	<script type="text/javascript">
*	$(function () {
*		$('#editor1').igEditor();
*	});
*	</script>
*	<input id="editor1" type="text" />
*/

/*global jQuery, setTimeout, setInterval, clearInterval, document, window, MSApp*/
(function ($) {
	var _aNull = function (v, nan) {
		return v === null || v === undefined || (nan && typeof v === 'number' && isNaN(v));
	}, _int = function (val, nan) {
		val = parseInt(val, 10);
		if (isNaN(val)) {
			val = nan || 0;
		}
		return val;
	}, _pad_bdr = function (elem, horiz) {
		var v1 = horiz ? 'Left' : 'Top', v2 = horiz ? 'Right' : 'Bottom';
		return _int(elem.css('padding' + v1)) + _int(elem.css('padding' + v2)) +
			_int(elem.css('border' + v1 + 'Width')) + _int(elem.css('border' + v2 + 'Width'));
	}, _str = function (v) {
		return _aNull(v) ? '' : v.toString();
	}, _now = function () {
		return new Date().getTime();
	}, _offset = function (e, xy) {
		return $.ig.util ? $.ig.util.offset(e, xy) : (xy || (e ? e.offset() : null));
	}, _stop = function (e) {
		try {
			e.preventDefault();
			e.stopPropagation();
		} catch (ignore) { }
	};
	$.ig = $.ig || {};
	/*
		igEditor is a widget based on jQuery UI that provides ability to edit text and show drop-down list.
		It is the base class for igTextEditor, igMaskEditor, igNumericEditor, igCurrencyEditor, igDateEditor and igDatePicker.
		Any extended editor can be created as igEditor with appropriate value of the "type" option, and any option of extended editor can be set within igEditor.
	*/
	$.widget('ui.igEditor', {
		options: {
			/* type="object" Gets sets value in editor. The effect of setting/getting that option depends on type of editor and on dataMode options. That can be string, number or Date depending on type of editor. If it is used on initialization and the type option is missing, then if 'value' is Number, then 'numeric' editor is created automatically and if 'value' is Date, then the 'date' editor is created. */
			value: null,
			/* type="number" Gets sets value in tabIndex for editor.  */
			tabIndex: null,
			/* type="string" Sets gets text which appears in editor when editor has no focus and "value" in editor is null or empty string.  */
			nullText: null,
			/* type="dropdown|clear|spin" Sets gets visibility of spin and drop-down button. That option can be set only on initialization. Combinations like 'dropdown,spin' or 'spinclear' are supported too.
				dropdown type="string" button to open list is located on the right side of input-field (or left side if base html element has direction:rtl);
				clear type="string" button to clear value is located on the right side of input-field (or left side if base html element has direction:rtl);
				spin type="string" spin buttons are located on the right side of input-field (or left side if base html element has direction:rtl).
			*/
			button: 'none',
			/* type="null|left|right|center" Sets gets horizontal alignment of text in editor. If that option is not set, then 'right' is used for 'numeric', 'currency' and 'percent' editors and the 'left' is used for all other types of editor.
				null type="object"
				left type="string"
				right type="string"
				center type="string"
			*/
			textAlign: null,
			/* type="array" Sets gets list of items which are used for drop-down list, spin, validation and auto-complete functionality.
				Items in list can be strings, numbers, dates or objects in any combination.
				If type of editor is date or datepicker and item is string, then igEditor will try to convert it to Date object and show item in display format.
				If type of editor is numeric, currency or percent and item is string, then igEditor will try to convert it to number and show item in display format.
				If item is object and it has member "text", then that member is used.
				If item is object and besides "text" has function getHtml(), then that function is used to render item in list.
				The item or item.text is used to set "value" of particular editor when list-item is selected. */
			listItems: null,
			/* type="string" Sets gets selector for css classes used by editor.
				That option allows replacing all default css styles of editor by custom values.
				Application should provide css classes for all members defined in the css options with "theme" selector.
				For example, if that property is set to "mytheme", then application should provide following css classes:
				.mytheme .ui-igedit-field{...};
				.mytheme .ui-igedit-focus{...};
				etc.
				Note: changing theme is not supported when base element is INPUT or TEXTAREA and renderInContainer or button are not enabled. */
			theme: null,
			/* type="text|0|mask|1|date|2|datepicker|3|numeric|4|currency|5|percent|6" Sets type of editor. If that option is not set, but the 'value' option is defined, then if type of 'value' is Number, then the 'numeric' type is used, if type of 'value' is Date, then the 'date' type is used. For all other types of 'value' the 'text' type is used. Note: if that option is set to 'datepicker', then application should ensure that css and js files used by jquery.ui.datepicker are available.
				text type="string" Text editor is created
				0 type="number" Text editor is created (same as 'text')
				mask type="string" Mask editor is created
				1 type="number" Mask editor is created (same as 'mask')
				date type="string" Date-time editor is created
				2 type="number" Date-time editor is created (same as 'date')
				datepicker type="string" Date-picker is created
				3 type="number" Date-picker is created (same as 'datepicker')
				numeric type="string" Numeric editor is created
				4 type="number" Numeric editor is created (same as 'numeric')
				currency type="string" Currency editor is created
				5 type="number" Currency editor is created (same as 'currency')
				percent type="string" Percent editor is created
				6 type="number" Percent editor is created (same as 'percent')
			*/
			type: null,
			/* type="object" Sets gets strings used for title of buttons. Value of object should contain pairs or key:value members. Note: any sub-option of locale can appear within the main option of igEditor. In this case those values within main options will have highest priority and override corresponding value in locale. */
			locale: null,
			/* type="number" Sets gets width of editor in pixels.
				Only positive values have effect. If that option is not set, then value of style.width of base html element will be used automatically. However, that value should be in the px units. */
			width: null,
			/* type="number" Sets gets height of editor in pixels.
				Only positive values have effect.
				If that option is not set, then value of style.height of base html element will be used automatically. However, that value should be in the px units. */
			height: null,
			/* type="object" Sets gets options supported by igValidator.
				In order to enable validation and use defaults, an empty object can be used.
				Note: validation rules of igValidator, such as min, max, minLength, required are not supported, but similar properties of igEditor should be used. */
			validatorOptions: null,
			/* type="bool" Set gets validation for empty value in editor.  */
			required: false,
			/* type="string" Sets gets style.display for outer html element.
				The value of "" will disable changing style.display.
				If the base html element is not INPUT, TEXTAREA, SPAN or DIV, then it is recommended to set this option to an empty string,
				because, some browsers may fail to handle display other than default value of browser.
				For example, if base element for editor is TD, then behavior in Chrome can be problematic.
			*/
			display: 'inline-block',
			/* type="bool" Sets gets option to wrap input field into SPAN..
				That option can be set only on initialization and it is available only when base element is INPUT or TEXTAREA.
				If drop-down button or spin-buttons are enabled or the theme is set, then that option has no effect.
				The reason for that property is to allow vertical alignment of several igEditor controls when they are located in html inline and some of them have enabled buttons.
				If all editors are created within SPAN wrapper, then they will appear on the same line. Otherwise, editors in SPANs will be shifted 3-6 pixels above INPUT editors. */
			renderInContainer: false,
			/* type="select|-1|start|0|end|1|default|2" Sets gets behavior of selection/caret in input-field when editor gets focus.
				select type="string" Select all text
				-1 type="number" Select all text
				start type="string" Set caret at the beginning of text
				0 type="number" Set caret at the beginning of text
				end type="string" Set caret at the end of text
				1 type="number" Set caret at the end of text
				default type="string" Use default behavior of browser (in case of mask, numeric and date editors it may be unreliable)
				2 type="number" Use default behavior of browser (in case of mask, numeric and date editors it may be unreliable). */
			selectionOnFocus: -1,
			/* type="bool" Set gets ability to modify editor from keyboard (false) or disables keyboard (true).
				Notes:
				If the "spinOnReadOnly" is enabled, then value will be modified on spin regardless of the "readOnly".
				If the "listItems" has items and "dropDownTriggers" is defined, then value will be modified from drop-down list regardless of the "readOnly". */
			readOnly: false,
			/* type="bool" Sets gets ability to override the "readOnly" option and allow changes "value" of editor on spin events. Value false does not allow spin when "readOnly" is true. */
			spinOnReadOnly: false,
			/* type="bool" If that option is disabled and the editor is not focused, then a mouse click on the spin button will keep the text in the editor in display (not focus) format and perform spin actions.
			*/
			focusOnSpin: false,
			/* type="bool" Sets gets ability to automatically set value in editor to opposite limit, when spin action reached minimum or maximum limit.
				In case of listItems, the first and the last items in list are used as minimum and maximum values.
			*/
			spinWrapAround: false,
			/* type="bool" Sets gets ability to hide the Enter key from browser.
			*/
			hideEnterKey: true,
			/* type="bool" Sets gets ability to override the "readOnly" option and allow showing the drop-down list and changing the value in the editor from a list. Value false does not allow drop-down when "readOnly" is true. */
			dropDownOnReadOnly: false,
			/* type="arrow|button|focus|A-Z" Sets gets list of actions which trigger display of drop-down list or calendar.
				The list should include flags separated by the "," character. Flags may include optional "ctrl+", "shift+" or "alt+" prefix.
				If prefix is defined, then action is triggered for combination of flag-action with Ctrl, Shift or Alt key.
				Empty string disables drop-down functionality.
				arrow type="string" Down-arrow shows drop-down and up-arrow hides drop-down;
				button type="string" Shows and hides drop-down;
				focus type="string" Shows drop-down on focus.
				A-Z type="string" Any upper case characters show drop-down. */
			dropDownTriggers: 'button,ctrl+arrow,alt+arrow',
			/* type="bool" Sets gets location of drop-down list.
				Value true will create html element for list as a child of main html element.
				Value false creates list as a child of body.
				Notes:
				That option has effect only for drop-down defined by listItems.
				The value of true is supported only when main (outer) html element of editor is container such as SPAN or DIV, or buttons are enabled, or renderInContainer is enabled, the theme is set.
				The value of true allows a better positioning and can be useful when editor is located in complex layout and containers with "position:fixed". */
			listDropDownAsChild: false,
			/* type="number" Sets gets custom width of drop-down list in pixels. If value is equal to 0 or negative, then the width of editor is used. */
			listWidth: 0,
			/* type="number" Sets gets maximum height of drop-down list in pixels. If value is equal to 0 or negative, then the height of list is defined by number of items in list. */
			listMaxHeight: 300,
			/* type="number" Sets gets number of columns in drop-down list.*/
			listColumns: 1,
			/* type="number" Sets gets duration of animation in milliseconds when drop-down list or calendar is displayed. Default is 200. If value is less than 5, then animation is disabled. */
			animationShowDuration: 200,
			/* type="number" Sets gets duration of animation in milliseconds when drop-down list is hidden. That option is not supported when "type" is set to "datepicker", because the jquery.ui.datepicker does not have similar feature. Default is 200. If value is less than 5, then animation is disabled. */
			animationHideDuration: 200,
			/* type="string" Gets sets name of (hidden) INPUT element, which value will be set to current value of editor on any change. */
			inputName: null
		},
		events: {
			/* cancel="true" Event which is raised on keydown event.
				Return false in order to cancel key action.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igEditor.
				Use ui.key to obtain value of keyCode. */
			keydown: 0,
			/* cancel="true" Event which is raised on keypress event.
				Return false in order to cancel key action.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igEditor.
				Use ui.key to obtain value of keyCode.
				Set ui.key to another character which will replace original entry. */
			keypress: 1,
			/* Event which is raised on keyup event.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igEditor.
				Use ui.key to obtain value of keyCode. */
			keyup: 2,
			/* Event which is raised on mousedown at any part of editor including drop-down list.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igEditor.
				Use ui.elementType to obtain type of html element under mouse, such as field, button, spinUpper, spinLower or item#.
				Use ui.id and ui.elementType to obtain flag which represents html element under mouse. */
			mousedown: 3,
			/* Event which is raised on mouseup at any part of editor including drop-down list.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igEditor.
				Use ui.elementType to obtain type of html element under mouse, such as field, button, spinUpper, spinLower or item#.
				Use ui.id and ui.elementType to obtain flag which represents html element under mouse. */
			mouseup: 4,
			/* Event which is raised on mousemove at any part of editor including drop-down list.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igEditor.
				Use ui.elementType to obtain type of html element under mouse, such as field, button, spinUpper, spinLower or item#.
				Use ui.id and ui.elementType to obtain flag which represents html element under mouse. */
			mousemove: 5,
			/* Event which is raised on mouseover at any part of editor including drop-down list.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igEditor.
				Use ui.elementType to obtain type of html element under mouse, such as field, button, spinUpper, spinLower or item#.
				Use ui.id and ui.elementType to obtain flag which represents html element under mouse. */
			mouseover: 6,
			/* Event which is raised on mouseleave at any part of editor including drop-down list.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igEditor.
				Use ui.elementType to obtain type of html element under mouse, such as field, button, spinUpper, spinLower or item#.
				Use ui.id and ui.elementType to obtain flag which represents html element under mouse. */
			mouseleave: 7,
			/* Event which is raised when input field of editor gets focus.
				Function takes argument evt.
				Use ui.owner to obtain reference to igEditor.
				Use evt.originalEvent to obtain reference to event of browser. */
			focus: 8,
			/* Event which is raised when input field of editor loses focus.
				Function takes argument evt.
				Use ui.owner to obtain reference to igEditor.
				Use evt.originalEvent to obtain reference to event of browser. */
			blur: 9,
			/* cancel="true" Event which is raised before value in editor was changed.
				Return false in order to cancel change.
				It can be raised on lost focus or on spin events.
				Function takes arguments evt and ui.
				Use ui.owner to obtain reference to igEditor.
				Use ui.value to obtain new value and ui.oldValue to obtain old value. */
			valueChanging: 10,
			/* Event which is raised after value in editor was changed. It can be raised on lost focus or on spin events.
				Function takes arguments evt and ui.
				Use ui.owner to obtain reference to igEditor.
				Use ui.value to obtain new value and ui.oldValue to obtain old value. */
			valueChanged: 11,
			/* Event which is raised after text in editor was changed.
				Function takes arguments evt and ui.
				Use ui.owner to obtain reference to igEditor.
				Use ui.value to obtain new value and ui.oldValue to obtain old value. */
			textChanged: 12,
			/* Event which is raised on lost focus when editor contains invalid value. That event is available for all editors besides default "text" type editor.
				Function takes arguments evt and ui.
				Use ui.owner to obtain reference to igEditor.
				Use ui.value to obtain suggested value.
				Set ui.value to change suggested value.
				If type of editor is numeric, currency, percent, date or datepicker, then ui.text contains actual text entered by user.
				If type of editor is numeric, currency or percent, then the ui.reason may have following flags: "null", "format" or "limit".
				If type of editor is date or datepicker, then ui contains following additional members:
				ui.reason may have following flags: "null", "dayOfMonth", "numberOfFields", "limit" or "invalid";
				ui.year - year of entered date;
				ui.month - month of entered date;
				ui.day - day of entered date;
				ui.hours - hours of entered date;
				ui.minutes - minutes of entered date;
				ui.seconds - seconds of entered date;
				ui.milliseconds - milliseconds of entered date. */
			invalidValue: 13,
			/* cancel="true" Event which is raised on spin event.
				Return false in order to cancel spin.
				Function takes arguments evt and ui.
				Use ui.owner to obtain reference to igEditor.
				Use ui.delta to obtain delta for increment or decrement.
				Use ui.value to obtain the "value" of editor before spin action. */
			spin: 14,
			/* Event which is raised when button was clicked by mouse.
				Function takes argument evt.
				Use ui.owner to obtain reference to igEditor.
				Use evt.originalEvent to obtain reference to event of browser. */
			buttonClick: 15,
			/* cancel="true" Event which is raised before drop-down list or calendar is opened.
				Return false in order to cancel drop-down action.
				Function takes argument evt.
				Use ui.owner to obtain reference to igEditor.
				Use evt.originalEvent to obtain reference to event of browser. */
			showDropDown: 16,
			/* cancel="true" Event which is raised before drop-down list or calendar is opened.
				Function takes argument evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igEditor.
				Use ui.value to obtain reference to the selected item in list or Date in calendar.
				If ui.value is not null and not undefined, that it means that drop-down was closed due to selection from drop-down list or from calendar.
				Otherwise, drop-down was closed due to lost focus or Esc key press.
				Return false in order to cancel hide action and keep drop-down visible.
				It is not recommended to cancel that action on blur event.
				Note: In case of calendar of datepicker, the evt or evt.originalEvent can be null. That happens if calendar was closed on blur or by Esc key.
				Returning the false in this situation will not prevent closing drop-down calendar. */
			hideDropDown: 17,
			/* cancel="true" Event which is raised before list item is selected.
				Return false in order to cancel select action.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igEditor.
				Use ui.index to get new selected index.
				Use ui.oldIndex to get old selected index.
				Use ui.item to get reference to new selected item. */
			listSelecting: 18,
			/* Event which is raised after list item was selected.
				Function takes arguments evt and ui.
				Use evt.originalEvent to obtain reference to event of browser.
				Use ui.owner to obtain reference to igEditor.
				Use ui.index to get new selected index.
				Use ui.oldIndex to get old selected index.
				Use ui.item to get reference to new selected item. */
			listSelected: 19
		},
		css: {
			/* Class applied to the main/top element. Default value is 'ui-igedit ui-state-default ui-widget ui-corner-all' */
			editor: 'ui-igedit ui-state-default ui-widget ui-corner-all',
			/* Class applied to the top element when editor is rendered in container. Default value is 'ui-igedit-container' */
			container: 'ui-igedit-container',
			/* Class applied to the editing element. Default value is 'ui-igedit-field' */
			field: 'ui-igedit-field',
			/* Class applied to the field when direction is rtl. Default value is 'ui-igedit-rtl' */
			fieldRtl: 'ui-igedit-rtl',
			/* Class applied to the TEXTAREA element. Default value is 'ui-igedit-textarea' */
			textArea: 'ui-igedit-textarea',
			/* Class applied to the editing element in mouse-over state. Default value is 'ui-igedit-hover ui-state-hover' */
			hover: 'ui-igedit-hover ui-state-hover',
			/* Class applied to the editing element in focus state. Default value is 'ui-igedit-focus ui-state-focus' */
			focus: 'ui-igedit-focus ui-state-focus',
			/* Class applied to the images of buttons when editor has focus or mouse-over, but mouse-over does not belong to a particular button. Default value is 'ui-igedit-buttonsimagestateoverride' */
			buttonsImageStateOverride: 'ui-igedit-buttonsimagestateoverride',
			/* Classes applied to the editing element in disabled state. Default value is 'ui-igedit-disabled ui-state-disabled' */
			disabled: 'ui-igedit-disabled ui-state-disabled',
			/* Class applied to the editing element of numeric editor when value is negative. Default value is 'ui-igedit-negative' */
			negative: 'ui-igedit-negative',
			/* Class applied to the editing element when it has no value. Default value is 'ui-igedit-nullvalue' */
			nullValue: 'ui-igedit-nullvalue',
			/* Class applied to the SPAN element which represents button. Default value is 'ui-igedit-button' */
			button: 'ui-igedit-button',
			/* Class applied to the SPAN element which represents button when direction is rtl. Default value is 'ui-igedit-button-rtl' */
			buttonRtl: 'ui-igedit-button-rtl',
			/* Classes applied to the SPAN element of button when editor has focus. Default value is 'ui-igedit-buttonfocus' */
			buttonFocus: 'ui-igedit-buttonfocus',
			/* Classes applied to the the SPAN element of button in default state (no focus, no mouse, no press). Default value is 'ui-igedit-buttondefault ui-state-default' */
			buttonDefault: 'ui-igedit-buttondefault ui-state-default',
			/* Classes applied to the SPAN element of button in mouse-over state. Default value is 'ui-igedit-buttonhover ui-state-hover' */
			buttonHover: 'ui-igedit-buttonhover ui-state-hover',
			/* Classes applied to the SPAN element of button in pressed state. Default value is 'ui-igedit-buttonpressed ui-state-highlight' */
			buttonPressed: 'ui-igedit-buttonpressed ui-state-highlight',
			/* Classes applied to the SPAN element of button in disabled state. Default value is 'ui-igedit-buttondisabled ui-state-disabled' */
			buttonDisabled: 'ui-igedit-buttondisabled ui-state-disabled',
			/* Classes applied to the SPAN element which represents image on dropdown/clear button. Default value is 'ui-igedit-buttonimage ui-icon-triangle-1-s ui-icon' */
			buttonImage: 'ui-igedit-buttonimage ui-icon-triangle-1-s ui-icon',
			/* Class applied to the SPAN element which represents clear button. Default value is 'ui-igedit-buttonclear' */
			buttonClear: 'ui-igedit-buttonclear',
			/* Class applied to the SPAN element which represents image on clear button. Default value is 'ui-igedit-buttonimage ui-icon-circle-close ui-icon' */
			buttonClearImage: 'ui-igedit-buttonimage ui-icon-circle-close ui-icon',
			/* Class applied to the SPAN element which represents image on button in mouse-over state. Default value is 'ui-igedit-buttonimagehover' */
			buttonImageHover: 'ui-igedit-buttonimagehover',
			/* Class applied to the SPAN element which represents image on button in pressed state. Default value is 'ui-igedit-buttonimagepressed' */
			buttonImagePressed: 'ui-igedit-buttonimagepressed',
			/* Class applied to the SPAN element which represents image on button in disabled state. Default value is 'ui-igedit-buttonimagedisabled' */
			buttonImageDisabled: 'ui-igedit-buttonimagedisabled',
			/* Class applied to the SPAN element which represents spin button. Default value is 'ui-igedit-spinbutton' */
			spinButton: 'ui-igedit-spinbutton',
			/* Class applied to the SPAN element which represents image on spin button. Default value is 'ui-igedit-spinbuttonimage ui-igedit-spinbuttonimage' */
			spinButtonImage: 'ui-igedit-buttonimage ui-igedit-spinbuttonimage',
			/* Class applied to the SPAN element which represents image on lower spin button. Default value is 'ui-igedit-spinlowerimage ui-icon-carat-1-s ui-icon' */
			spinLowerImage: 'ui-igedit-spinlowerimage ui-icon-carat-1-s ui-icon',
			/* Class applied to the SPAN element which represents image on lower spin button in mouse-over state. Default value is 'ui-igedit-spinlowerimagehover' */
			spinLowerImageHover: 'ui-igedit-spinlowerimagehover',
			/* Class applied to the SPAN element which represents image on lower spin button in pressed state. Default value is 'ui-igedit-spinlowerimagepressed' */
			spinLowerImagePressed: 'ui-igedit-spinlowerimagepressed',
			/* Class applied to the SPAN element which represents image on lower spin button in disabled state. Default value is 'ui-igedit-spinlowerimagedisabled' */
			spinLowerImageDisabled: 'ui-igedit-spinlowerimagedisabled',
			/* Class applied to the SPAN element which represents image on upper spin button. Default value is 'ui-igedit-spinupperimage ui-icon-carat-1-n ui-icon' */
			spinUpperImage: 'ui-igedit-spinupperimage ui-icon-carat-1-n ui-icon',
			/* Class applied to the SPAN element which represents image on upper spin button in mouse-over state. Default value is 'ui-igedit-spinupperimagehover' */
			spinUpperImageHover: 'ui-igedit-spinupperimagehover',
			/* Class applied to the SPAN element which represents image on upper spin button in pressed state. Default value is 'ui-igedit-spinupperimagepressed' */
			spinUpperImagePressed: 'ui-igedit-spinupperimagepressed',
			/* Class applied to the SPAN element which represents image on upper spin button in disabled state. Default value is 'ui-igedit-spinupperimagedisabled' */
			spinUpperImageDisabled: 'ui-igedit-spinupperimagedisabled',
			/* Class applied to the drop-down element which contains list of items or datepicker-calendar. Default value is 'ui-igedit-dropdown' */
			dropDown: 'ui-igedit-dropdown',
			/* Class applied to the DIV element which is used as container for dropdown list. Default value is 'ui-igedit-list ui-widget ui-widget-content ui-corner-all' */
			list: 'ui-igedit-list ui-widget ui-widget-content ui-corner-all',
			/* Class applied to the SPAN element which represents item in dropdown list. Default value is 'ui-igedit-listitem ui-state-default' */
			listItem: 'ui-igedit-listitem ui-state-default',
			/* Class applied to the Class applied to the SPAN element which represents item in dropdown list with mouse-over state. Default value is 'ui-igedit-listitemhover ui-state-hover' */
			listItemHover: 'ui-igedit-listitemhover ui-state-hover',
			/* Class applied to the Class applied to the SPAN element which represents selected item in dropdown list. Default value is 'ui-igedit-listitemselected ui-state-highlight' */
			listItemSelected: 'ui-igedit-listitemselected ui-state-highlight',
			/* Class applied to the SPAN elements located in columns on the right in dropdown list. That has effect only when multiple columns in list are enabled. Default value is 'ui-igedit-listitemcolumnborder' */
			listItemColumnBorder: 'ui-igedit-listitemcolumnborder',
			/* Class applied to the main element when list is above editor and to list when list is below editor. Default value is 'ui-igedit-no-top-corners' */
			noTopCorners: 'ui-igedit-no-top-corners',
			/* Class applied to the main element when list is below editor and to list when list is above editor. Default value is 'ui-igedit-no-bottom-corners' */
			noBottomCorners: 'ui-igedit-no-bottom-corners'
		},
		regional: $.ig._regional || {},
		_create: function (type) {
			var v, css = this.css, elem, field, align, oldCss, o = this.options, me = this, val = o.value;
			type = this._doType(_aNull(type) ? o.type : type, val);
			if (typeof o.maxLength !== 'number') {
				o.maxLength = 0;
			}
			if (typeof o.spinDelta !== 'number') {
				o.spinDelta = 1;
			}
			o.nullable = o.nullable !== false;
			// selected index of item in listItems (used fro spin and drop-down list)
			this._listID = -1;
			// css for normal-state of field
			this._css = css.field;
			elem = this._element = this._render(this.element, o, css);
			if (o.display) {
				elem.css('display', o.display);
			}
			if (type === 3 && (!$.datepicker || this._ta)) {
				throw new Error('The ui.igDatePicker depends on jquery.ui.datepicker and TEXTAREA/multiline is not supported');
			}
			// textarea
			if (this._ta) {
				this._css += ' ' + css.textArea;
			}
			field = this._field;
			this._box = field[0].type === 'checkbox';
			// flag that editor has single element: no buttons and no extra span wrapper
			this._1e = field === elem;
			if (o.readOnly) {
				field[0].readOnly = 'readonly';
			}
			align = o.textAlign;
			if (!align && type > 3) {
				align = 'right';
			}
			if (align) {
				field.css('textAlign', align);
			}
			// _id: -1:field
			field[0]._id = -1;
			field[0].disabled = o.disabled;
			// id of element which owns mouse-over and mouse-down: -1:field, 0:none, 1:button, 2:upper-spin, 3:lower-spin
			this._hover = this._mouseDown = 0;
			// conditional flag to modify logic of set value/text
			this._fix = 1;
			// focus: -1:before create, 0:no focus, 1:focus read only, 2:focus
			this._fcs = -1;
			// (this._bad!=0) means failure to process keyboard
			this._bad = 0;
			// currently pressed key, start selection
			this._k0 = this._sel0 = 0;
			// (this._noPaste==1) no paste flag
			this._noPaste = 0;
			this._fixMode(1);
			this._clearHide = false;
			// events used by control: required to support destroy
			me._evts = v = {
				keydown: function (e) { me._onEvt(e, 0); },
				keypress: function (e) { me._onEvt(e, 1); },
				keyup: function (e) { me._onEvt(e, 2); },
				paste: function (e) { me._onEvt(e, 11); },
				beforecut: function (e) { me._onEvt(e, 11); },
				cut: function (e) { me._onEvt(e, 11); },
				drop: function (e) { me._onEvt(e, 11); },
				focus: function (e) { me._onEvt(e, 8); },
				blur: function (e) { me._onEvt(e, 9); }
			};
			field.bind(v);
			me._mEvts = v = {
				mousedown: function (e) { me._onEvt(e, 3); },
				mouseup: function (e) { me._onEvt(e, 4); },
				mousemove: function (e) { me._onEvt(e, 5); },
				MSPointerOver: function (e) { me._onEvt(e, 26); },
				// N.A. 11/18/2013 Task #157749: Add support for IE11, becasue it doesn't support events with MS prefix.
				pointerover: function (e) { me._onEvt(e, 26); },
				mouseover: function (e) { me._onEvt(e, 6); },
				mouseleave: function (e) { me._onEvt(e, 7); }
			};
			if (this._buttons && this._buttons[1]) {
				v.DOMMouseScroll = function (e) { me._onEvt(e, 10); };
				v.mousewheel = function (e) { me._onEvt(e, 10); };
			}
			elem.bind(v);
			//
			this._fcs = 0;
			v = o.maxLength;
			if (v && v > 0) {
				field[0].maxLength = v;
			}
			v = o.tabIndex;
			if (!_aNull(v)) {
				field[0].tabIndex = v;
			}
			// Mvc helpers
			v = o._vsFormat;
			if (v && val && type > 3 && (typeof val !== 'number')) {
				val = parseFloat(this._txtAsNum(val.toString(), v, '-'));
			}
			// _value is coming from _render
			this._setVal(_aNull(val) ? this._value : val);
			if (this._val() === '') {
				this._text = this._field[0].value = this._focTxt('', false, '');
			}
			this._fixCss();
			oldCss = this._oldCss;
			// set width/height after _fixCss
			val = o.height;
			if (!val && !this._1e) {
				val = oldCss.height;
				if (val) {
					val = (val.indexOf('px') > 0) ? _int(val) : this.element.height();
				}
			}
			this._height(val);
			if (this._box) {
				this._fixBC(field, field);
			}
			val = o.width;
			if (!val && !this._1e) {
				val = oldCss.width;
				if (val) {
					val = (val.indexOf('px') > 0) ? _int(val) : this.element.width();
				}
			}
			if (this._selElem) {
				delete oldCss.width;
				delete oldCss.height;
			}
			this._width(val);
			this._lastText = this._val();
			this._initValidator();
			this._doClear(o.value);
		},
		_doType: function (type, val) {
			if (type === 'text') {
				type = 0;
			}
			if (type === 'mask') {
				type = 1;
			}
			if (type === 'date') {
				type = 2;
			}
			if (type === 'datepicker') {
				type = 3;
			}
			if (type === 'numeric') {
				type = 4;
			}
			if (type === 'currency') {
				type = 5;
			}
			if (type === 'percent') {
				type = 6;
			}
			if (typeof type !== 'number' || type < 0 || type > 6) {
				if (typeof val === 'number') {
					type = 4;
				} else if (val && val.getMonth) {
					type = 2;
				} else {
					type = 0;
				}
			}
			this._type = type;
			return type;
		},
		_render: function (elem, o, css) {
			var spin, name, par, csso, inp, cont, oldC, oldA, i, obj, img, clear, buts, butCss,
				left = elem.css('direction') === 'rtl',
				but = o.button,
				field = elem,
				sel = null;
			name = elem[0].nodeName;
			par = elem[0].parentNode;
			if (name) {
				name = name.toUpperCase();
			}
			this._ta = name === 'TEXTAREA';
			this._td = name === 'TD';
			this._left = left;
			inp = name === 'INPUT';
			sel = this._selElem = name === 'SELECT';
			spin = but && but.indexOf('spin') >= 0;
			clear = but && but.indexOf('clear') >= 0;
			but = (but && but.indexOf('dropdown') >= 0) || (sel && !spin);
			if (clear || but || spin) {
				buts = this._buttons = [];
			}
			cont = buts || o.renderInContainer || o.theme;
			// old attributes which can be modified (used in destroy)
			oldC = this._oldCss = { display: 0 };
			oldA = this._oldAttr = { className: 0, title: 0 };
			if (inp) {
				// extra old attributes of INPUT
				oldA.value = 0;
				inp = elem[0].type || 'text';
				if (inp === 'date' || inp === 'number') {
					elem[0].type = 'text';
					oldA.type = inp;
				}
			} else if (sel) {
				sel = o.listItems;
				if (!sel) {
					o.listItems = [];
					sel = elem[0].options;
					i = sel ? sel.length : 0;
					if (i > 0) {
						while (i-- > 0) {
							obj = sel[i].value;
							img = sel[i].text;
							o.listItems[i] = {value: obj, text: _aNull(img) ? obj : img};
						}
						this._listID = elem[0].selectedIndex;
					}
					sel = 1;
				}
			} else {
				// extra old attributes of TEXTAREA/SPAN/DIV/etc.
				oldA.innerHTML = 0;
			}
			if (inp || this._ta) {
				// extra old attributes/css of INPUT/TEXTAREA
				oldA.disabled = oldA.readOnly = oldA.alt = oldC.textAlign = 0;
			}
			for (i in oldC) {
				if (oldC.hasOwnProperty(i)) {
					oldC[i] = elem.css(i);
				}
			}
			for (i in oldA) {
				if (oldA.hasOwnProperty(i)) {
					oldA[i] = elem[0][i];
				}
			}
			// Note: do not use css('width/height'), because it messy and depends on jquery version
			oldC.width = elem[0].style.width;
			oldC.height = elem[0].style.height;
			// backup if options.value is not set
			i = inp ? oldA.value : (sel ? elem.val() : oldA.innerHTML);
			if (i === o.nullText) {
				i = '';
			}
			if (!this._ta && i) {
				i = i.replace(/[\x09\x0a]/g, '');
			}
			this._value = i;
			if (inp || this._ta || sel) {
				// className
				if (oldA.className) {
					this._css += ' ' + oldA.className;
				}
				if (cont) {
					this._swap = true;
					elem.css('display', sel ? 'none' : '');
					elem = $('<span />');
					par.insertBefore(elem[0], field[0]);
					if (sel) {
						field = $('<input />');
					} else {
						par.removeChild(field[0]);
					}
					elem.css('display', oldC.display);
				} else {
					this._css += ' ' + css.editor;
					this._field = elem;
					return this._field;
				}
			} else {
				if (o.textMode === 'textarea' || o.textMode === 'multiline') {
					field = $('<textarea />');
					this._ta = 1;
				} else {
					field = $(o.textMode ? '<input type="' + o.textMode + '"/>' : '<input />');
				}
				elem[0].innerHTML = '';
			}
			elem.addClass(css.editor + ' ' + css.container);
			if (o.theme) {
				elem.addClass(o.theme);
			}
			this._field = field;
			butCss = css.button + ' ' + css.buttonDefault;
			if (left) {
				butCss += ' ' + css.buttonRtl;
				this._css += ' ' + css.fieldRtl;
			}
			i = buts ? -1 : 6;
			inp = this;
			// N.A. 24 October 2012 - Fixing bug #125484 - Create touch events to be igEditors property.
			this._touchEvts = {
				touchstart: function (e) { inp.__touch = 1; this._drag = null; _stop(e); },
				touchmove: function (e) { this._drag = 1; _stop(e); },
				touchend: function () { if (!this._drag) { $(this).trigger('mousedown').trigger('mouseup'); } }
			};
			// create buttons
			while (i++ < 4) {
				if ((but && i === 0) || (clear && i === 3) || (spin && (i === 1 || i === 2))) {
					// 0:default, 1:local-hover, 2:pressed, 3:disabled, 4:image-default, 5:image-hover, 6:image-pressed, 7:image-disabled
					if (i === 0) {
						csso = [butCss, css.buttonHover, css.buttonPressed, css.buttonDisabled, css.buttonImage, css.buttonImageHover, css.buttonImagePressed, css.buttonImageDisabled];
						sel = 'button';
					} else if (i === 1) {
						csso = [butCss + ' ' + css.spinButton, css.buttonHover, css.buttonPressed, css.buttonDisabled, css.spinButtonImage + ' ' + css.spinUpperImage, css.spinUpperImageHover, css.spinUpperImagePressed, css.spinUpperImageDisabled];
						sel = 'spinUpper';
					} else if (i === 2) {
						csso = [butCss + ' ' + css.spinButton, css.buttonHover, css.buttonPressed, css.buttonDisabled, css.spinButtonImage + ' ' + css.spinLowerImage, css.spinLowerImageHover, css.spinLowerImagePressed, css.spinLowerImageDisabled];
						sel = 'spinLower';
					} else {
						csso = [butCss + ' ' + this.css.buttonClear, css.buttonHover, css.buttonPressed, css.buttonDisabled, css.buttonClearImage, css.buttonImageHover, css.buttonImagePressed, css.buttonImageDisabled];
						sel = 'clear';
					}
					obj = buts[i] = $('<span />').addClass(csso[0]).appendTo(elem).bind(this._touchEvts);
					obj[0]._css = csso;
					obj[0].longdesc = obj[0].title = this._optVal(sel + 'Title', 1);
					img = $('<span />').addClass(csso[4]).appendTo(obj);
					// _id: 1:button, 5:button-image
					// _id: 2:upper-spin, 6:upper-spin-image
					// _id: 3:lower-spin, 7:lower-spin-image
					// _id: 4:clear, 8:clear-image
					img[0]._id = i + 5;
					obj[0]._id = i + 1;
				}
			}
			field.appendTo(elem);
			return elem;
		},
		_leftShift: function () {
			var left = 0, buts = this._buttons, i = (this._left && buts) ? 4 : 0;
			while (i-- > 0) {
				if (buts[i]) {
					left += buts[i][0].offsetWidth;
				}
			}
			return left;
		},
		_val: function () {
			var field = this._field;
			return field ? (this._box ? field[0].checked : (this._nullT ? '' : field[0].value)) : '';
		},
		// sets nullText if control has no focus and adjusts nullTextCss and negativeCss
		_fixNull: function () {
			var txt, nullTxt = this.options.nullText;
			if (!this._field || (!nullTxt && !this._nullT)) {
				return;
			}
			txt = this._val();
			this._nullT = null;
			if (txt === '' && typeof(nullTxt) === "string" && this._fcs < 2) {
				this._nullT = true;
				this._field[0].value = nullTxt;
			}
			this._fixCss();
		},
		// return NullText or txt and adjust NullText flag
		_focTxt: function (txt, foc, e) {
			var nt = this.options.nullText;
			this._nullT = null;
			if (!foc && txt === '' && nt && (!_aNull(e) || this.options.readOnly)) {
				txt = nt;
				this._nullT = true;
			}
			return txt;
		},
		validate: function (noLabel) {
			/* Triggers validation of editor and show error message. That method has effect only when validation is enabled.
				paramType="bool" optional="true" Value of true will allow to skip error message if validation failed.
				returnType="bool" Returns true if value is valid, false - if value is invalid and error message was displayed.
			*/
			return !this.options.validatorOptions || !this._doInvalid(null, noLabel ? 2 : 1);
		},
		isValid: function () {
			/* Checks if value in editor is value. Note: that method may fail if editor has focus (in edit mode).
				returnType="bool" Returns true if value is valid, false - value is invalid.
			*/
			return !this._doInvalid(null, 9);
		},
		// e - null or ''
		// flag: 1-show error message, 2-do not show error, 9-check only:return error message
		// return true: invalid, or error message (if flag=9)
		_doInvalid: function (e, flag) {
			if (!this._field) {
				return;
			}
			var ch, i, old, fixVal,
				val = this._val(),
				cancel = false,
				fac = 1,
				// external flag set by igValidator when special-rules-validation failed (regExp, minLength)
				inv = this._invPlus,
				o = this.options,
				type = this._type;
			// reset value for argument of invalid event
			this._inv = null;
			// custom validator
			if (inv) {
				i = 0;
				fixVal = type;
			// required entry
			} else if (o.required && (!val || (type === 1 && !this.getValueByMode(0, '', 1)))) {
				// temporary flag for required entry
				inv = 1;
				fixVal = type;
			// text editor
			} else if (type === 0) {
				if (!o.nullable && !val) {
					// temporary flag for required entry
					inv = 1;
				}
			// mask editor
			} else if (type === 1) {
				val = this._txt;
				i = val.length;
				while (i-- > 0 && !inv) {
					ch = val.charCodeAt(i);
					// flag==21==# optional and allows digits and +/-, it should be replaced by Space
					// skip 21 for validatorOptions of required character
					if (ch < 21 && (ch % 2) === 1) {
						val = this._getVal();
						inv = { value: val, message: this._optVal('mask', 2) };
					}
				}
			// date editors
			} else if (type < 4) {
				val = this._toDate(val, e === '', true, true);
				// value for argument of invalid event
				inv = this._inv;
			// numeric editors
			} else {
				val = this._toNum(val, true, true);
				// value for argument of invalid event
				inv = this._inv;
				// 7-numeric display factor (1-100)
				fac = this._prop(7);
				if (inv && val && fac > 1) {
					old = val;
					val /= fac;
					inv.value = val;
				}
			}
			// ensure that val has correct type of object
			if (fixVal === 1) {
				val = this._txt;
			} else if (fixVal) {
				val = fixVal < 4 ? this._toDate(val, e === '', true, true) : this._toNum(val, true, true);
			}
			// fix temporary flag for required entry
			if (inv === 1) {
				val = null;
				inv = { value: val, message: this._optVal('required', 2) };
			}
			if (typeof inv === 'string') {
				inv = { value: val, message: inv };
			}
			// request for error-message
			if (flag === 9) {
				return inv;
			}
			if (inv) {
				// 13-invalidValue
				cancel = this._fire(13, null, inv);
				// value was fixed by application
				if (val !== inv.value) {
					val = inv.value;
					inv = null;
				}
				if (old) {
					if (inv) {
						val = old;
					} else {
						if (_aNull(val, 1)) {
							val = null;
						} else if (val) {
							val *= fac;
						}
					}
				}
				if (type <= 1 && !inv) {
					this._setVal(val);
					return;
				}
			}
			if (type > 1 && type < 4) {
				this._isNull = _aNull(val);
				if (!this._isNull) {
					this._date = val;
				}
				if (val && o.useLastGoodDate) {
					this._goodD = val;
				}
			}
			// set _value to Number or Date for _focusTxt
			this._value = val;
			// used by this.validate
			if (flag && !cancel && !this._setOpt) {
				// show/hide error message
				return this._doError(flag, null, inv ? inv.message : null);
			}
		},
		_focusTxt: function (foc, e, txt0) {
			var e0 = e, txt = '', o = this.options, type = this._type, d = null, prompt = '';
			// mask editor
			if (type === 1) {
				txt0 = null;
				if (!_aNull(e) && !foc) {
					e = e !== '';
					if (e && this._bad !== 0) {
						this._txt = this._setTxt(this._val(), 5, true);
					}
					txt0 = this._txt;
					if (!e) {
						this._doInvalid(e0);
					}
				}
				txt = this._getTxt(foc ? 5 : 4, foc ? o.promptChar : o.padChar, txt0);
			// date editors
			} else if (type === 2 || type === 3) {
				if (_aNull(txt0)) {
					prompt = o.promptChar;
					// key-press
					if (_aNull(e) && foc) {
						return this._getTxt(5, prompt);
					}
					// ""-from _update=lostFocus
					if (!_aNull(e) && !foc) {
						this._doInvalid(e);
						// this._value was set by _doInvalid within call _toDate
						d = this._value;
					} else if (!this._isNull) {
						d = this._date;
					}
				} else {
					d = this._toDate(txt0, foc, true);
				}
				txt = this._toTxt(d, foc, prompt, !_aNull(e));
			// numeric editors
			} else if (type > 3) {
				if (!_aNull(e) && !foc) {
					this._doInvalid();
				}
				// this._value could be set by _doInvalid within call _toNum
				txt = this._toTxtNum(this._value, foc);
			// text editor
			} else {
				txt = this._val();
				if (!_aNull(e) && !foc) {
					this._doInvalid(e);
				}
			}
			return this._focTxt(txt, foc, e);
		},
		_repaint: function () {
			if (this._field && this._val() !== this._text) {
				this._field[0].value = this._text;
			}
		},
		_instant: function (p1, limit, f) {
			var val, type = this._type, mode = this._dataMode;
			if (this._box) {
				return this._val();
			}
			// mask editor
			// p1-prompt
			if (type === 1) {
				return this.getValueByMode(mode, p1, limit);
			}
			// date editors
			// p1-mode
			if (type === 2 || type === 3) {
				return this.getValueByMode(p1 ? 0 : mode, limit);
			}
			// numeric editors
			// p1-get number
			if (type > 3) {
				val = this._toNum(this._val(), limit);
				if (val && (limit || f) && !isNaN(val) && mode > 0) {
					// 7-numeric display factor (1-100)
					val /= this._prop(7);
				}
				// -1:text, 0:editModeText, 1:double, etc.
				return (p1 || mode > 0) ? val : this._toTxtNum(val, mode === 0);
			}
			// text editor
			return this._val();
		},
		// flag: 1-button title, 3-spin-button titles
		_optVal: function (key, flag) {
			var val = this._validator, o = this.options;
			// validation message
			if (flag === 2) {
				return val ? val._loc(key) : '';
			}
			val = o[key];
			if (!_aNull(val)) {
				return val;
			}
			// locale (titles of buttons)
			if (flag === 3 || flag === 1) {
				if (flag === 1 && this._type === 3) {
					key = 'datePickerButtonTitle';
				}
				val = o.locale ? o.locale[key] : null;
				return val || ($.ig && $.ig.Editor && $.ig.Editor.locale ? $.ig.Editor.locale[key] : null) || '';
			}
			// regional
			o = o.regional;
			if (typeof o === 'string') {
				o = $.ig.regional[o];
			}
			if (o) {
				val = o[key];
			}
			if (!o || _aNull(val)) {
				val = $.ig.regional.defaults[key];
			}
			return _aNull(val) ? this.regional[key] : val;
		},
		_setOption: function (key, val) {
			var v, old = val, dp = null, o = this.options, loc = key === 'locale', reg = key === 'regional', buts = this._buttons, field = this._field;
			if (o[key] === val || key === 'textMode' || !field) {
				return this;
			}
			if (key === 'buttonHidden') {
				this._butVis(null, val);
				return this;
			}
			if (key === 'theme') {
				// editor has only 1 element
				if (this._1e) {
					return this;
				}
				for (v = 0; v < 3; v++) {
					if (buts && buts[v]) {
						buts[v].css('height', '');
					}
				}
				if (o.theme) {
					this._element.removeClass(o.theme);
				}
				if (val) {
					this._element.addClass(val);
				}
				this._listRemove();
				this._height(o.height);
				this._width(o.width);
			}
			if (key === 'inputMask' && this._type === 1) {
				old = this.getValueByMode(0, ' ', 1);
				this._setMask(val);
				this._setTxt(old, 0);
			}
			o[key] = val;
			if (typeof val === 'function') {
				return this;
			}
			if (reg && this._dp) {
				dp = this._dpRegion();
				if (dp) {
					v = o.datepickerOptions = $.extend(o.datepickerOptions, dp);
					this._dpOption(v);
				}
			}
			v = 'buttonTitle';
			if ((loc || key === v) && buts && buts[0]) {
				buts[0][0].title = this._optVal(v, 1);
			}
			v = 'spinUpperTitle';
			if ((loc || key === v) && buts && buts[1]) {
				buts[1][0].title = this._optVal(v, 3);
			}
			v = 'spinLowerTitle';
			if ((loc || key === v) && buts && buts[2]) {
				buts[2][0].title = this._optVal(v, 3);
			}
			v = 'clearTitle';
			if ((loc || key === v) && buts && buts[3]) {
				buts[3][0].title = this._optVal(v, 3);
			}
			if (key === 'disabled') {
				field[0].disabled = val;
				this._fixCss();
			}
			if (key === 'display') {
				this._element.css(key, val);
			}
			if (key === 'textAlign') {
				field.css(key, val);
			}
			if (key === 'readOnly') {
				field[0].readOnly = val ? 'readonly' : '';
			}
			if (key === 'maxLength' || key === 'tabIndex') {
				field[0][key] = val;
			}
			if (key === 'value') {
				this.value(val);
			}
			if (key === 'width') {
				this._width(val);
			}
			if (key === 'height') {
				this._height(val);
			}
			v = key === 'required';
			if (key === 'validatorOptions' || v) {
				this._initValidator(false, v);
			}
			if (key === 'nullText') {
				this._fixNull();
			}
			if (key === 'type') {
				this._doType(val);
				// request to reset value
				reg = 3;
			}
			key = key.toLowerCase();
			v = key.indexOf('minv') === 0 ? 1 : (key.indexOf('maxv') === 0 ? 2 : (key.indexOf('maxd') >= 0 || key.indexOf('mind') >= 0 ? -1 : 0));
			if (key.indexOf('list') === 0) {
				this._listRemove();
			} else if (key.indexOf('an') === 0) {
				if (this._dp && key.indexOf('show') > 7) {
					this._dpOption((key.indexOf('eff') > 7) ? 'showAnim' : 'duration', val);
				}
			} else if (key.indexOf('kero') > 0) {
				if (this._dp) {
					this._dpOption(val);
				}
			} else if (key.indexOf('data') >= 0 || v || reg || !_aNull(this.regional[key]) || key.indexOf('date') === 0 || key.indexOf('pat') >= 0 || key.indexOf('roup') > 0 || key.indexOf('sep') >= 0 || key.indexOf('ymb') > 0) {
				if (v > 0 && this._dp) {
					dp = $.data(field[0], 'datepicker');
					if (dp) {
						dp.settings[v === 1 ? 'minDate' : 'maxDate'] = null;
					}
				}
				this._setOpt = true;
				this._listRemove();
				// reg=3 flag set by key=='type': request to reset value
				this._fixMode((reg === 3) ? 3 : 0);
				this._repaint();
				// last-value-string may change
				this._lastText = this._val();
				this._setOpt = null;
			}
			return this;
		},
		_dpRegion: function () {
			var reg = this.options.regional;
			return ($.datepicker && typeof reg === 'string') ? $.datepicker.regional[(reg === 'defaults' || reg === 'en-US') ? '' : reg] : null;
		},
		// fix datepicker options, if it already exists
		_dpOption: function (val, p) {
			var old = this._getVal(1);
			if (val && val.changeYear && $.ig.util.isOpera) {
				val.changeYear = false;
			}
			this._field.datepicker('option', val, p);
			// restore date which was 'friendly' destoyed when option of datepicker was modified
			this._setVal(old);
		},
		getRegionalOption: function (name) {
			/* Gets calculated value of regional option used by numeric and date editors.
				paramType="string" Name of regional option, such as "monthNames", "dateLongPattern", "currencySymbol", etc.
				returnType="string" Returns value of option used by editor.
			*/
			return this._optVal(name);
		},
		field: function () {
			/* Gets reference to jquery object which is used as edit field.
				returnType="$" Returns reference to jquery object. That can be INPUT or TEXTAREA.
			*/
			return this._field;
		},
		mainElement: function () {
			/* Gets reference to jquery object which is used as top/outer element of igEditor.
				returnType="$" Returns reference to jquery object.
			*/
			return this._element;
		},
		dropDownElement: function () {
			/* Gets reference to jquery object which is used as container of drop-down.
				returnType="$" Returns reference to jquery object or null. That can be container of list items or in case of igDatePicker it can be calendar of jquery.datepicker.
			*/
			var el = this._ddList;
			// datepicker
			if (this._type === 3) {
				el = $.datepicker;
				if (el) {
					el = (el._ig_dp === this) ? el.dpDiv : null;
				}
			}
			return el || null;
		},
		show: function () {
			/* Shows editor (if it was hidden).
				returnType="object" Returns reference to this igEditor.
			*/
			return this._vis(true);
		},
		hide: function () {
			/* Hides editor.
				returnType="object" Returns reference to this igEditor.
			*/
			return this._vis();
		},
		remove: function () {
			/* Removes editor from its parent element, but keeps the rest of functionality.
				returnType="object" Returns reference to this igEditor.
			*/
			var p, e = this._element;
			p = (e && e[0]) ? e[0].parentNode : null;
			if (p && p.tagName) {
				this._doError();
				this._doDrop();
				this._stopTimer();
				this._hadFocus = null;
				this._vAct();
				this._noPaste = this._fcs = this._k0 = this._hover = this._mouseDown = 0;
				this._fixCss();
				p.removeChild(e[0]);
			}
			return this;
		},
		dropDownVisible: function (showHide) {
			/* Gets sets visibility of drop-down list.
				paramType="bool" optional="true" Value true will show dropdown, false - hide dropdown. 
				returnType="bool|object" If parameter is defined, then returns reference to this igCombo, otherwise, returns true if drop down is visible and false if drop down is hidden.
			*/
			if (!arguments.length) {
				return !!this._ddOn;
			}
			if (!showHide) {
				this._doDrop();
			} else if (!this._ddOn) {
				this._doDrop(1);
			}
			return this;
		},
		findListItemIndex: function (text, ignoreCase, partial, contains) {
			/* Finds index of list item by text.
				paramType="string" Text to search.
				paramType="bool" optional="true" Value true sets request to ignore case
				paramType="bool" optional="true" Value true will perform partial search rather than full match
				paramType="bool" optional="true" Value true will perform search anywhere within text of item, otherwise starts-with search is used.
				returnType="number" Returns index of item or -1.
			*/
			var item = this._find(_str(text), 0, 1, ignoreCase, partial, contains);
			return item ? item.id : -1;
		},
		addListItems: function (items, index) {
			/* Adds several items to list.
				paramType="object" Array of items.
				paramType="number" optional="true" Index within current list where items are inserted. If parameter is missing or too large or negative, then items are appended to list.
				returnType="object" Returns reference to this igEditor.
			*/
			return this._listChange(items, index, 2);
		},
		addListItem: function (item, index) {
			/* Adds item to list.
				paramType="object" Item for list. It can be string, number or Date object.
				paramType="number" optional="true" Index within current list where item is inserted. If parameter is missing or too large or negative, then item is appended to list.
				returnType="object" Returns reference to this igEditor.
			*/
			return this._listChange([item], index, 2);
		},
		removeListItem: function (item) {
			/* Removes item from list.
				paramType="object" Current item in list. It can be string, number or Date object.
				returnType="object" Returns reference to this igEditor.
			*/
			return this._listChange(item, -1, 1);
		},
		removeListItemAt: function (index) {
			/* Removes item from list at index.
				paramType="number" Index of item. If it is negative number, then last item in list is removed.
				returnType="object" Returns reference to this igEditor.
			*/
			return this._listChange(null, index, 1);
		},
		clearListItems: function () {
			/* Removes all items from list.
				returnType="object" Returns reference to this igEditor.
			*/
			return this._listChange(null, -1, 0);
		},
		selectedListIndex: function (index) {
			/* Gets sets selected index of list item.
				paramType="number" optional="true" Index of item.
				returnType="number" Returns index of selected item if parameter is undefined.
			*/
			if (!arguments.length) {
				return this._listID;
			}
			this._listSelect(index);
		},
		getSelectedListItem: function () {
			/* Gets reference to selected item in list.
				returnType="string|number|date|object" Returns reference to selected item or null.
			*/
			var list = this.options.listItems, id = this._listID;
			return (list && id >= 0) ? list[id] : null;
		},
		hasInvalidMessage: function () {
			/* Checks if invalid message is displayed.
				returnType="bool" Returns true if message is displayed.
			*/
			return this._validator ? this._validator.isMessageDisplayed() : false;
		},
		validator: function () {
			/* Gets reference to igValidator used by igEditor.
				returnType="object" Returns reference to igValidator or null.
			*/
			return this._validator || null;
		},
		text: function (val, flag) {
			/* Gets sets text in editor.
				paramType="string" optional="true" New text for editor.
				paramType="number" optional="true" Internal use only.
				returnType="string|object" Returns text in editor if parameter is undefined. Otherwise, it returns reference to this igEditor.
			*/
			if (val === undefined) {
				return this._val();
			}
			// mask/date/numeric editors
			if (this._type > 0) {
				this._sTxt = 1;
				// mask
				if (this._type === 1) {
					this._setTxt(val, _aNull(flag) ? 5 : (1000 + flag));
				} else {
					this._setVal(val, true);
				}
				this._sTxt = 0;
			} else {
				if (val) {
					this._nullT = null;
				}
				this._text = val;
				this._repaint();
			}
			if (this._fix === 1) {
				this._old = this._instant(1, null, 1);
			}
			return this;
		},
		// gets/sets date-field, or creates Date from 7 fields, or creates now, or adjusts Date for datepicker
		// date-reference to Date or null.
		//  Note: if that is missing, then return now
		//  Note: if h is defined, then that is year
		// f-flag to get/set specific date field (0-year, 1-month, 2-day, 3-hours, 4-minutes, 5-seconds, 6-milliseconds)
		//  Note: if f=-1, then that is adjustements for datepicker while date-parse: return date
		//  Note: if h is defined, then that is month
		// val-new value to set date-field (if h is not used). If it is not set, then method returns date-field
		//  Note: if h is defined, then that is day
		// h-hours
		// m-minutes
		// s-seconds
		// ms-miliseconds
		_df: function (date, f, val, h, m, s, ms) {
			var utc = this.options.enableUTCDates;
			// set into datepicker
			if (f === -1) {
				return (date && utc) ? new Date(date.getTime() + date.getTimezoneOffset() * 60000) : date;
			}
			// now
			if (!date) {
				date = new Date();
				if (utc) {
					date.setUTCMinutes(date.getUTCMinutes() - date.getTimezoneOffset());
				}
				return date;
			}
			// new date from fields
			if (!_aNull(h)) {
				return utc ? new Date(Date.UTC(date, f, val, h, m, s, ms)) : new Date(date, f, val, h, m, s, ms);
			}
			// get display values
			if (_aNull(val)) {
				if (f === 0) {
					return utc ? date.getUTCFullYear() : date.getFullYear();
				}
				if (f === 1) {
					return utc ? date.getUTCMonth() : date.getMonth();
				}
				if (f === 2) {
					return utc ? date.getUTCDate() : date.getDate();
				}
				if (f === 3) {
					return utc ? date.getUTCHours() : date.getHours();
				}
				if (f === 4) {
					return utc ? date.getUTCMinutes() : date.getMinutes();
				}
				if (f === 5) {
					return utc ? date.getUTCSeconds() : date.getSeconds();
				}
				return utc ? date.getUTCMilliseconds() : date.getMilliseconds();
			}
			// set from display values
			if (f === 0) {
				if (utc) {
					date.setUTCFullYear(val);
				} else {
					date.setFullYear(val);
				}
			}
			if (f === 1) {
				if (utc) {
					date.setUTCMonth(val);
				} else {
					date.setMonth(val);
				}
			}
			if (f === 2) {
				if (utc) {
					date.setUTCDate(val);
				} else {
					date.setDate(val);
				}
			}
			if (f === 3) {
				if (utc) {
					date.setUTCHours(val);
				} else {
					date.setHours(val);
				}
			}
			if (f === 4) {
				if (utc) {
					date.setUTCMinutes(val);
				} else {
					date.setMinutes(val);
				}
			}
			if (f === 5) {
				if (utc) {
					date.setUTCSeconds(val);
				} else {
					date.setSeconds(val);
				}
			}
			if (f === 6) {
				if (utc) {
					date.setUTCMilliseconds(val);
				} else {
					date.setMilliseconds(val);
				}
			}
		},
		value: function (val) {
			/* Gets sets value in editor.
				paramType="object" optional="true" New value for editor. It can be string, number or Date object.
				returnType="string|number|date|object" Returns value in editor if parameter is undefined. Otherwise, it returns reference to this igEditor.
			*/
			if (val === undefined) {
				val = this._getVal();
				return (val === undefined) ? null : val;
			}
			this._setVal(val, true);
			this._lastText = this._val();
			return this;
		},
		_getVal: function (numDate) {
			// date editors: numDate-request Date
			// numeric editors: numDate-request Number
			var o = this.options, val = this._instant(numDate, 1);
			// numeric editors
			if (this._type > 3) {
				if (_aNull(val)) {
					val = o.nullValue;
					// -1:text, 0:editModeText, 1:double, etc.
					if (this._dataMode <= 0) {
						return _str(val);
					}
					return (o.nullable || !_aNull(val)) ? val : NaN;
				}
			}
			return val;
		},
		// set value and keep old value as a flag to raise value-change events
		// obj==2: flag that it is spin+noFocus in numeric editor
		_set_val: function (val, obj) {
			this._fix = 0;
			this._setVal(val, obj);
			this._fix = 1;
		},
		// obj==2: flag that it is spin+noFocus in numeric editor
		_setVal: function (val, obj) {
			var txt, max, type = this._type;
			if (!this._field) {
				return;
			}
			if (this._box) {
				if (val !== true) {
					val = val === 'true';
				}
				this._field[0].checked = val;
			// mask editor
			// obj-mode
			} else if (type === 1) {
				this._setTxt(_str(val), this._dataMode);
			// date editors
			// obj=true-flag from set text(..)
			} else if (type === 2 || type === 3) {
				if (!_aNull(val) && !val.getTime) {
					val = val.toString();
					val = obj = this._toDate(val, this._dataMode < 2) || this._toDate(val, true);
				}
				obj = val;
				val = this._limits(val);
				if (_aNull(val)) {
					val = obj;
				}
				this._txt = this._mask;
				this._isNull = _aNull(val);
				if (!this._isNull) {
					this._toTxt(val, true, '', true);
				} else {
					val = this._df();
				}
				this._date = val;
				if (this.options.useLastGoodDate) {
					this._goodD = val;
				}
				this._text = this._focusTxt(this._fcs > 1);
				this._repaint();
			// numeric editors
			} else if (type > 3) {
				if (_aNull(val, 1)) {
					val = null;
				}
				if (val && typeof val === 'number' && this._fix !== 0) {
					// 7-numeric display factor (1-100)
					val *= this._prop(7);
				}
				// 12-maxLength
				val = this._toNum(val, true);
				txt = this._toTxtNum(val, this._fcs === 2);
				max = this._prop(12);
				// obj=2: value change on spin + focus
				// check if new number which larger than maxLength
				if (obj === 2 && max > 0 && txt.length > max) {
					return;
				}
				// adjust _nullT flag
				this._focTxt(txt);
				this._text = txt;
				this._value = val;
				this._repaint();
				this._fixCss();
			// text editor
			} else {
				this.text(_str(val));
			}
			// memorize old value. Note: set text(..) (line above) does it already
			if (this._fix === 1 && type > 0) {
				this._old = this._instant(1, null, 1);
			}
			txt = this.options.value = this._getVal();
			this._doClear(txt);
			this._fixNull();
			this._dtt();
			this._fixList(txt);
		},
		_fixList: function (val) {
			var i = -1, list = this.options.listItems, len = list ? list.length : 0;
			if (len < 1 || !this._fix || _aNull(this._lastText)) {
				return;
			}
			if (!_aNull(val)) {
				while (++i < len) {
					if (list[i] === val) {
						break;
					}
				}
				if (i >= len) {
					list = this._findItem(this._val(), -1);
					i = list ? list.id : -1;
				}
			}
			this._listSelect(i);
		},
		// show/hide clear-button depending on value
		_doClear: function (val) {
			if (this._buttons && this._buttons[3]) {
				this._butVis(!val || (this._type < 4 && !this.getValueByMode(0, val)));
			}
		},
		_vis: function (show) {
			var e = this._element;
			e.css('display', show ? this.options.display : 'none');
			this._fixHeight();
			this._doError();
			return this;
		},
		_elemWidth: function (elem, val) {
			if (elem && val > 1 && elem[0]._wd !== val) {
				elem[0]._wd = val;
				val = Math.max(1, val - _pad_bdr(elem, 1));
				elem.css('width', val);
				return true;
			}
		},
		_elemHeight: function (elem, val, but) {
			if (elem && val > 1 && elem[0]._ht !== val) {
				elem[0]._ht = val;
				val = Math.max(1, val - _pad_bdr(elem));
				elem.css('height', val);
				if (but) {
					elem.find('SPAN').css('marginTop', Math.floor((val - 16) / 2));
				}
			}
		},
		_fixSize: function () {
			var o = this.options,
				elem = this._element,
				width = elem ? elem[0].offsetWidth : 0,
				height = elem ? elem[0].offsetHeight : 0;
			if (width || height) {
				if (this._oWidth !== width) {
					this._fixWidth(!this._oWidth && !o.width);
				}
				if (this._oHeight !== height) {
					this._fixHeight(!this._oHeight && !o.height);
				}
				this._oWidth = width;
				this._oHeight = height;
			}
			this._doTimer();
		},
		_doTimer: function () {
			var me = this,
				timer = me._timer1,
				ok = me._heightOk && !me._heightPerc && me._widthOk && !me._widthPerc;
			if (ok && timer) {
				clearInterval(timer);
				delete me._timer1;
			} else if (!timer) {
				me._timer1 = setInterval(function () {
					me._fixSize();
				}, 200);
			}
		},
		// if base element is DIV with display:block, then its height can be collapsed
		_fixHeight: function (zero) {
			// _1e: editor has only 1 element
			if (!this._field || this._1e || (this._heightOk && !this._heightPerc)) {
				return 1;
			}
			var field = this._field,
				elem = this._element,
				i = 4,
				height = (this._td || zero) ? 0 : Math.max(elem[0].offsetHeight - _pad_bdr(elem), 0),
				buts = this._buttons;
			height = height || field[0].offsetHeight;
			if (height > 1) {
				if (this._heightPerc) {
					height++;
				}
				this._elemHeight(field, height);
				if (buts) {
					while (i-- > 0) {
						this._elemHeight(buts[i], height, 1);
					}
				}
				this._heightOk = 1;
			}
			this._doTimer();
		},
		// adjust width of editor on first paint
		// return 1/true in case of failure and null/false in case of success
		_fixWidth: function (zero) {
			if (!this._field || this._1e || (this._widthOk && !this._widthPerc)) {
				return 1;
			}
			var v, left, but,
				field = this._field,
				clearHide = this._clearHide,
				buttonHide = this.options.buttonHidden,
				elem = this._element,
				i = 4,
				width = (this._td || zero) ? 0 : Math.max(elem[0].offsetWidth - _pad_bdr(elem, 1), 0),
				minWidth = width,
				minField = 3,
				buts = this._buttons;
			width = width || field[0].offsetWidth;
			if (width > 0) {
				if (buts) {
					// width which will be used, if application did not set it: use default width of INPUT
					zero = (this._td || zero) ? Math.max(width, 100) : 0;
					// width for field
					width = zero || width;
					if (this._widthPerc || this._td) {
						width--;
					}
					while (i-- > 0) {
						but = buts[i];
						if (but) {
							if ((i === 0 && buttonHide) || (i === 3 && clearHide)) {
								// temporary show clear/dropdown button to measure its width
								but.show();
							}
							but[0]._w = v = but[0].offsetWidth;
							// reduce zero width in order to keep overall width of editor same as default width of INPUT
							if (zero && !left) {
								width -= v;
								left = zero = zero - v;
							}
							// reduce width for field
							width -= v;
							// check if there is space for field, if not increase min width
							if (width < minField && !zero) {
								minWidth += minField - width;
								// left: flag that min width should be set
								left = width = minField;
							}
							if ((i === 0 && buttonHide) || (i === 3 && clearHide)) {
								// hide temporary shown clear/dropdown button to measure its width
								but.hide();
								//T.P. March 14th 2013, Bug 135760 Remove width increasing. The editor is not completely shown. 
								//width += v;
							}
						}
					}
					// if no width (zero), or buttons are larger than availiable width (left), then increase width
					if (zero || left) {
						elem.css('width', zero || (minWidth + minField));
					}
				} else if (zero && elem[0].offsetWidth > width + 4) {
					elem.css('width', width);
				}
				this._wF = width;
				if (this._elemWidth(field, width)) {
					this._listRemove();
				}
				// check if buttons did not jump on second line
				i = v = buts ? Math.min(width, 9) : 0;
				// decrease width of field
				while (v-- > 1 && i > 3) {
					left = field[0].offsetTop;
					for (i = 0; i < 4; i++) {
						if (buts[i] && Math.abs(buts[i][0].offsetTop - left) > 10) {
							this._elemWidth(field, --this._wF);
							break;
						}
					}
				}
				// get around zoom in Firefox and IE7/8/IE10
				if (buts) {
				    //T.P. 4th June 2014 Bug #169026 Fix editrs width for IE9, when the browser is zoomed in
					v = $.ig.util.isFF || $.ig.util.isIE ? 3 : 1;
					this._wF -= v;
					this._elemWidth(field, this._wF);
				}
				this._widthOk = 1;
				// show/hide clear/dropdown button
				this._butVis(clearHide, buttonHide);
			}
			this._doTimer();
		},
		_butVis: function (clear, dropdown) {
			var but, i = -1, o = this.options,
				// width of field
				width = this._wF,
				buts = this._buttons,
				field = this._field;
			if (_aNull(clear)) {
				but = 1;
				clear = this._clearHide;
			}
			if (_aNull(dropdown)) {
				but = 1;
				dropdown = o.buttonHidden;
			}
			if (!buts || (but && clear === this._clearHide && dropdown === o.buttonHidden)) {
				return;
			}
			o.buttonHidden = dropdown;
			this._clearHide = clear;
			while (++i < 2) {
				// 0-dropdown, 3-clear button
				but = buts[i * 3];
				if (but) {
					if ((!i && dropdown) || (i && clear)) {
						but.hide();
						// if button hidden, then increase width of INPUT
						width += but[0]._w;
					} else {
						but.show();
						width -= but[0]._w;
					}
				}
			}
			this._elemWidth(field, width);
		},
		// set width of editor
		_width: function (width) {
			// reduce width by widths of buttons
			var field = this._field,
				elem = (this._1e || this._td) ? field : this._element,
				buts = this._buttons,
				i = buts ? 4 : 0,
				val = _int(width);
			if (!field) {
				return;
			}
			if (this._widthOk) {
				delete this._widthOk;
				delete this._widthPerc;
				elem[0]._wd = null;
				field[0]._wd = null;
				elem.css('width', '');
				field.css('width', '');
				while (i-- > 0) {
					if (buts[i]) {
						buts[i][0]._wd = null;
						buts[i].css('width', '');
					}
				}
			}
			if (width) {
				if (width.indexOf && width.indexOf('px') < 0 && width !== val.toString()) {
					elem.css('width', width);
					this._widthPerc = !this._td && width.indexOf('%') > 0;
				} else {
					this._elemWidth(elem, val);
				}
			}
			this._fixWidth(!width);
		},
		// set height of editor
		_height: function (height) {
			var field = this._field,
				elem = (this._1e || this._td) ? field : this._element,
				buts = this._buttons,
				i = buts ? 4 : 0,
				val = _int(height);
			if (!field) {
				return;
			}
			if (this._heightOk) {
				delete this._heightOk;
				delete this._heightPerc;
				elem[0]._ht = null;
				field[0]._ht = null;
				elem.css('height', '');
				field.css('height', '');
				while (i-- > 0) {
					if (buts[i]) {
						buts[i][0]._ht = null;
						buts[i].css('height', '');
					}
				}
			}
			if (height) {
				if (height.indexOf && height.indexOf('px') < 0 && height !== val.toString()) {
					elem.css('height', height);
					this._heightPerc = !this._td && height.indexOf('%') > 0;
				} else {
					this._elemHeight(elem, val);
				}
			}
			this._fixHeight(!height);
		},
		// preprocess spin action
		_spin: function (delta) {
			var sel, fac, txt, nul = this._nullT, o = this.options;
			if (this._box || !this._field) {
				return;
			}
			if (this._fcs < 1 && o.focusOnSpin) {
				this.setFocus();
				if (this._fcs < 1) {
					this._focSpin = delta;
					return;
				}
			}
			// 14-spin
			if (this._fire(14, null, delta)) {
				return;
			}
			// case when readOnly+spinOnReadOnly
			if (nul) {
				this._nullT = null;
				this._fixCss();
			}
			txt = this._val();
			this.spin(delta);
			if (this._val() === txt) {
				if (nul) {
					this._nullT = nul;
					this._fixCss();
					return;
				}
				// roll over for numeric editor
				// 10-minValue, 11-maxValue
				if (this._type > 3 && o.spinWrapAround && !_aNull(this._prop(10)) && !_aNull(this._prop(11))) {
					// 7-numeric display factor (1-100)
					sel = this._sel0;
					fac = this._prop(7);
					if (!fac) {
						fac = 1;
					}
					delta = this._limits(this._getVal(true) * fac, true);
					this._setVal(delta / fac, this._fcs);
					this.select(sel);
				}
			}
			if (this._val() !== txt) {
				// 12-textChanged
				this._fire(12);
			}
		},
		_item: function (item) {
			if (item && !_aNull(item.text)) {
				item = item.text;
			}
			if (typeof item === 'function') {
				item = item();
			}
			return _aNull(item) ? '' : item;
		},
		// perform spin action related to list
		_spinList: function (delta) {
			var val, id, roll, len, list, o = this.options;
			list = o.listItems;
			len = list ? list.length : 0;
			if (len < 1) {
				return 1;
			}
			delta = (delta < 0) ? 1 : -1;
			id = this._listID + delta;
			roll = o.spinWrapAround;
			if (id >= len) {
				if (!roll) {
					return;
				}
				id = 0;
			}
			if (id < 0) {
				if (!roll) {
					return;
				}
				id = len - 1;
			}
			val = this._instant(1, null, 1);
			if (val === this._item(list[id])) {
				id += delta;
				if (id < 0) {
					if (!roll) {
						return;
					}
					id = len - 1;
				}
				if (id >= len) {
					if (!roll) {
						return;
					}
					id = 0;
				}
			}
			val = this._item(list[id]);
			if (!this._listSelect(id)) {
				delete this._lastY;
				this._set_val(val);
			}
		},
		// process key event by specific editor
		_doKey: function (k, ch, txt, len, sel0, sel1, bad, e) {
			// 12-maxLength
			var maxDec, iDot, d09, ok, dot, min, decSep, minus, mask, ePow, maxLen = this._prop(12), type = this._type;
			// mask/date editors
			if (type > 0 && type < 4) {
				mask = this._mask;
				len = mask ? mask.length : 0;
				if (len < 1 || k < 7 || (k > 8 && k < 32)) {
					k = 0;
				}
				if (bad) {
					if (k === 0 || !(mask.indexOf(ch) > 0 || this._optVal('am').indexOf(ch) >= 0 || this._optVal('pm').indexOf(ch) >= 0 || (k >= 48 && k <= 57))) {
						_stop(e);
					}
					return;
				}
				if (k === 0) {
					return;
				}
				txt = this._txt;
				if (sel0 !== sel1) {
					while (--sel1 >= sel0) {
						txt = txt.substring(0, sel1) + mask.charAt(sel1) + txt.substring(sel1 + 1);
					}
					sel1++;
				//del
				} else if (k === 7) {
					while (sel1 < len && mask.charCodeAt(sel1) >= 22) {
						sel1++;
					}
					if (sel1 >= len) {
						return;
					}
					txt = txt.substring(0, sel1) + mask.charAt(sel1) + txt.substring(sel1 + 1);
					sel1++;
				//back
				} else if (k === 8) {
					while (sel1 > 0 && mask.charCodeAt(sel1 - 1) >= 22) {
						sel1--;
					}
					if (sel1-- < 1) {
						return;
					}
					txt = txt.substring(0, sel1) + mask.charAt(sel1) + txt.substring(sel1 + 1);
				}
				if (k > 8 && sel1 < len) {
					if (sel1 >= len) {
						return;
					}
					sel0 = this._maskKey(k, ch, txt, len, sel1, mask);
					if (sel0 >= 0) {
						txt = this._txt;
						sel1 = sel0;
					} else {
						if (sel0 === -1) {
							return;
						}
						while (mask.charCodeAt(sel1) >= 22) {
							if (++sel1 >= len) {
								return;
							}
						}
						ch = this._maskFilter(mask.charCodeAt(sel1), ch, 0);
						if (_aNull(ch)) {
							return;
						}
						txt = txt.substring(0, sel1) + ch + txt.substring(sel1 + 1);
						sel1++;
					}
				}
				this._txt = txt;
				this._selKey = sel1;
				// _focusTxt may modify _selKey
				txt = this._focusTxt(true);
				this.select(this._selKey, 0, txt);
				this._selKey = 99999;
				this._listSelect(-1);
				return;
			}
			// numeric editors
			if (type > 3) {
				// 4-decimal separator
				decSep = this._prop(4);
				minus = this._isMinus(k);
				d09 = k >= 48 && k <= 57;
				// check if limit for negative values
				if (minus && sel0 === 0) {
					min = this._prop(10);
					if (!_aNull(min) && min >= 0) {
						return _stop(e);
					}
				}
				if (bad) {
					if (!(k < 9 || minus || d09 || k === decSep.charCodeAt(0))) {
						_stop(e);
					}
					return;
				}
				if (sel0 !== sel1) {
					txt = txt.substring(0, sel0) + txt.substring(sel1);
					sel1 = sel0;
					len = txt.length;
				// 7-del,8-back
				} else if (k === 7) {
					if (sel1++ >= len || len < 1) {
						return;
					}
				} else if (k === 8) {
					if (sel0-- < 1) {
						return;
					}
				}
				if (k < 9 || maxLen === 0 || maxLen > len) {
					dot = k === decSep.charCodeAt(0);
					iDot = txt.indexOf(decSep);
					// 8-maximum decimals
					maxDec = this._prop(8);
					ok = d09 || (sel0 === 0 && minus) || (dot && maxDec > 0);
					ePow = this._ePow();
					mask = ePow ? txt.indexOf(ePow) : -1;
					if (ePow && sel0 > 0) {
						// 69=E, 101=e
						if ((k === 69 || k === 101) && mask < 0) {
							ok = ch = ePow;
						}
						// do not allow dot after E
						if (dot && mask >= 0 && mask < sel0) {
							ok = false;
						}
					}
					// check for maxDecimals
					if (mask < 0 && d09 && iDot >= 0 && sel0 > iDot && iDot + maxDec < len) {
						// do not append digit after maxDecimals
						if (sel0 === len) {
							ok = false;
						// remove digits after maxDecimals
						} else {
							txt = txt.substring(0, --len);
						}
					}
					// allow minus after E
					if (sel0 > 0 && minus && txt.charAt(sel0 - 1).toUpperCase() === 'E' && txt.substring(sel0 - 1).indexOf('-') < 0) {
						ok = true;
					}
					if (len > 0 && sel0 === 0) {
						if (this._isMinus(txt.charCodeAt(0))) {
							ok = false;
						}
					}
					if (k > 8 && !ok) {
						return;
					}
					if (dot) {
						// remove old dot
						if (iDot >= 0) {
							if (iDot === sel0 || iDot === sel0 - 1) {
								return;
							}
							len--;
							if (iDot < sel0) {
								sel0 = --sel1;
							}
							txt = txt.substring(0, iDot) + txt.substring(iDot + 1);
						}
						// remove digits after maxDecimals
						if (mask < 0 && sel0 + maxDec < len) {
							len = sel0 + maxDec;
							txt = txt.substring(0, len);
						}
					}
					if (k > 8 && sel1 >= len) {
						txt += ch;
					} else {
						txt = txt.substring(0, sel0) + ch + txt.substring(sel1);
					}
				} else {
					k = 0;
				}
				this.select((k > 10) ? sel1 + 1 : sel0, 0, txt);
				this._listSelect(-1);
				return;
			}
			// text editor
			if (sel0 !== sel1) {
				txt = txt.substring(0, sel0) + txt.substring(sel1);
				sel1 = sel0;
				len = txt.length;
			// 7-del,8-back
			} else if (k === 7) {
				if (sel1++ >= len || len === 0) {
					return;
				}
				// get around IE mess with new lines in textarea: delete 2 characters instead of 1
				if (this._ta && txt.charCodeAt(sel1 - 1) === 13 && txt.charCodeAt(sel1) === 10) {
					sel1++;
				}
			} else if (k === 8) {
				if (sel0-- < 1) {
					return;
				}
				// get around IE mess with new lines in textarea: delete 2 characters instead of 1
				if (this._ta && txt.charCodeAt(sel0) === 10 && txt.charCodeAt(sel0 - 1) === 13) {
					sel0--;
				}
			}
			if (k < 9 || maxLen === 0 || maxLen > len) {
				if (k > 8 && sel1 >= len) {
					txt += ch;
				} else {
					txt = txt.substring(0, sel0) + ch + txt.substring(sel1);
				}
			} else {
				k = 0;
			}
			this._matchList(txt, k, (k > 10) ? sel1 + 1 : sel0);
		},
		_matchList: function (txt, key, sel) {
			var item;
			if (!this._field || this._type > 0 || (key < 0 && !this.options.listAutoComplete)) {
				return txt;
			}
			item = this._findItem(txt, key, sel);
			if (!item) {
				return null;
			}
			this._listSelect(item.id);
			txt = item.text;
			if (key >= 0) {
				this.select(item.sel, 0, txt);
			} else {
				this._field[0].value = txt;
			}
			return txt;
		},
		_findItem: function (txt, key, sel) {
			var o = this.options;
			return this._find(txt, key, o.listMatchOnly, o.listMatchIgnoreCase, true, o.listMatchContains, sel);
		},
		_find: function (txt, key, matchOnly, noCase, partial, contains, sel) {
			// shift: index of match inside of item-string, when contains-match is used
			// id: index of selected drop-down item
			var item, up, part, inside = null, i = -1, many = 0, shift = 0,
				id = -1, str = txt, len = txt.length,
				items = this.options.listItems, match = key >= 0 && matchOnly;
			if (len > 0 && items && (match || key < 0)) {
				part = match = -1;
				up = noCase;
				if (up) {
					str = str.toUpperCase();
				}
				while (++i < items.length) {
					item = this._item(items[i]);
					if (_aNull(item)) {
						continue;
					}
					item = item.toString();
					if (up) {
						item = item.toUpperCase();
					}
					shift = item.indexOf(str);
					if (shift === 0) {
						// full match
						if (item === str) {
							match = i;
							break;
						}
						// partial start-with-match
						many++;
						if (part < 0) {
							part = i;
						}
					// partial contains-match
					} else if (shift > 0 && contains) {
						if (!inside) {
							inside = { i: i, shift: shift };
						}
						many++;
					}
				}
				shift = 0;
				// if no start-with-match, then use contains-match
				if (part < 0 && inside) {
					part = inside.i;
					shift = inside.shift;
				}
				if (match < 0) {
					if (!partial) {
						return null;
					}
					// blur/enter: use first partial match
					if (key < 0) {
						match = part;
					// keyboard: no partial match: reduce length of string and do recursive call
					// though, if entry is char and no partial match for string cut-off by that char, then disable entry
					} else if (part < 0) {
						return (key > 10 && len === sel) ? null : this._find(txt.substring(0, --len), key, matchOnly, noCase, contains, sel);
					}
					// keyboard: single partial match: use it
					if (key > 10 && many === 1) {
						match = part;
					// keyboard: multiple partial matches: use substring of first partial match (upper/lower case)
					} else if (key >= 0) {
						txt = this._item(items[part]).toString().substring(0, len + shift);
					}
				}
				// match found
				if (match >= 0) {
					txt = this._item(items[match]).toString();
					// match found by single partial match: move caret to the end of text
					if (match === part) {
						sel = txt.length;
					}
				}
				id = (match >= 0) ? match : part;
			}
			return { text: txt, id: id, sel: (_aNull(sel, 1) ? len : sel) + shift };
		},
		_undo: function (redo) {
			var old, val = this._old;
			if (redo) {
				if (!this._canRedo) {
					return;
				}
				val = this._redo;
				this._canRedo = false;
			} else {
				old = this._instant(1, null, 1);
				if (old === val) {
					return;
				}
				this._canRedo = true;
				this._redo = old;
			}
			this._set_val(val);
			this._text = this._focusTxt(false);
			// notify validator about textChange event
			this._doError(1, this._evt);
		},
		// preprocess key (e)event, a: 0-keydown, 1-keypress, 2-keyup
		_doKey0: function (e, a) {
			var ch, up, len, excl, incl, bad = this._validator, me = this,
				t0 = this._text, t1 = this._val(), k = this._key, o = this.options;
			//Stop processing of up and down arrow in case of excel navigation mode
			if (o.excelNavigationMode && a !== 1 && (k === 38 || k === 40)) {
				return;
			}
			// can be called from setTimeout
			if (!this._field) {
				return;
			}
			// that is request from key-down on Ctrl+V: validate current value in field
			if (!e) {
				if (t0 !== t1) {
					this.paste(t1);
				}
				return;
			}
			// get around 'features' in Firefox under Japanese keyboard
			if (a === 1 && k === 192 && e.altKey && !e.ctrlKey) {
				return;
			}
			/* Bug 131604 */
			if (a === 1 && this._bad && this._k0 === 229) {
				/* Bug 149849 */
				this.getSelectedText();
				this._bad = 0;
			}
			// Special keys in NumPad of Opera break all filters and go into input (42,43,45,46,47)
			if (this._type > 0 && $.ig.util.isOpera && k > 41 && k < 48) {
				if (a === 0) {
					this._noKey = k;
				} else if (this._noKey === k) {
					_stop(e);
				}
			}
			if (a !== 1) {
				this._noPaste = 2 - a;
			} else if (this._noPaste !== 2) {
				this._noPaste = 1;
			}
			if (k === 9) {
				this._k0 = (a === 2) ? 0 : 9;
				// if validator has label, then event can be canceled by _onTab
				if (a === 0 && bad && bad._lbl) {
					bad._onTab(e);
				}
			}
			if (k === 0 || (k === 114 && a !== 1) || k === 9) {
				return;
			}
			if (this._bad > 2) {
				if (a === 0) {
					this._bad = 2;
				}
				if (a === 2) {
					this._bad -= 3;
				}
			}
			if (a === 0 && k === 229) {
				if (t0 !== t1) {
					this._bad = 2;
				} else {
					this._bad += 3;
				}
			}
			// Japanese Enter keyup in mask editor (fake "save-client-state" action)
			if (k === 13 && this._k0 === 229 && this._type === 1) {
				this._txt = this._setTxt(this._val(), 5, true);
			}
			// Ctrl+Z/Y undo/redo actions
			if (a === 0 && e.ctrlKey && !e.altKey && (k === 90 || k === 89)) {
				this._undo(k === 89);
				return;
			}
			if (this._bad === 2 || (a === 1 && e.ctrlKey)) {
				return;
			}
			if (a === 0 && !e.ctrlKey && !e.altKey && !e.shiftKey) {
				if (this._listKey(e, k)) {
					// prepare for keypress on arrow/action-keys raised by Opera and Firefox
					this._kBad = k;
					return _stop(e);
				}
			}
			if (this._box) {
				return;
			}
			// get around keypress on arrow/action-keys raised by Opera and Firefox
			if (a === 1 && k === this._kBad) {
				return _stop(e);
			}
			this._kBad = null;
			// (Ctrl+V)=86 or (Ctrl+X)=88 or (Shift+Insert)=45 set request to validate value in editor and do paste/remove
			if (a === 0 && ((e.ctrlKey && (k === 86 || k === 88)) || (e.shiftKey && k === 45))) {
				setTimeout(function () {
					me._doKey0();
				}, 1);
			}
			if (a !== 1 && (e.ctrlKey || e.altKey || k === 17)) {
				if (e.altKey) {
					this._k0 = -1;
				} else if (t0 !== t1 && (k === 86 || (k === 17 && a === 2))) {
					this.paste(t1);
					this._noPaste = 1;
				} else if (k === 17) {
					this.getSelectedText();
				}
				return;
			}
			if (a === 0) {
				this._k0 = k;
			}
			if (a === 2) {
				if (this._k0 > 0) {
					this._k0 = 0;
				}
				this._spinField = -1;
			}
			len = t1.length;
			bad = this._bad !== 0;
			if (k <= 46) {
				switch (k) {
				case 8:
				case 46: // back del
					if (this._k0 === k && a === 1) {
						a = 2;
					}
					if (a === 0) {
						a = 1;
						if (k === 46) {
							k = 7;
						}
					}
					break;
				case 27:
					_stop(e);
					if (a === 0) {
						this._undo();
						if (!this._escFix) {
							this._escTxt = this._field[0].value;
						}
					} else {
						// get around special Esc feature of Firefox
						if (this._escFix && this._escTxt !== t1 && !_aNull(this._escTxt)) {
							this._field[0].value = this._escTxt;
							delete this._escTxt;
						}
						if (a === 1) {
							// Firefox raises keypress for Esc
							this._escFix = 1;
						} else {
							delete this._escFix;
						}
					}
					return;
				case 13: // enter
					if (o.hideEnterKey) {
						if ((!this._ta || !e.shiftKey) || (this._type > 0 && this._ta && e.shiftKey)) {
							_stop(e);
						}
					} else {
						//#157090 T.P. If hideEnterKey is set to false, when a value is entered into the editor and "Enter" key is hit. Before the form is posted back we call _update(), so all the validations pass and the value gets changed. This updates the hidden input, which stores the value of the property passed back with the model to the server. 
						me._update();
					}					
					return;
				case 38:
				case 40: // up down
					if (this._ta) {
						break;
					}
					if (a === 0 && !e.shiftKey) {
						this._spin((k === 38) ? o.spinDelta : -o.spinDelta);
					}
					if (this._k0 === k) {
						a = 2;
					}
					break;
				}
			}
			if (a === 1 && k === this._k0 && ((k < 48 && k > 9 && k !== 32) || k > 90)) {
				return;
			}
			if (!bad) {
				if (a !== 0 && k !== 9) {
					_stop(e);
				}
				if (a === 1 && this._k0 === -1) {
					this._k0 = 0;
					this.getSelectedText();
				}
				if (a === 0 || k < 9) {
					this.getSelectedText();
				}
			}
			if (a === 1 && k > 6) {
				if (k > 31) {
					// 1-keypress
					if (this._fire(1, e)) {
						if (bad) {
							_stop(e);
						}
						return;
					}
					k = this._key;
					excl = o.excludeKeys;
					incl = o.includeKeys;
					if (o.toUpper || o.toLower || excl || incl) {
						ch = String.fromCharCode(k);
						up = ch.toUpperCase();
						if ((excl && excl.toUpperCase().indexOf(up) >= 0) || (incl && incl.toUpperCase().indexOf(up) < 0)) {
							return _stop(e);
						}
						if (o.toUpper) {
							k = up.charCodeAt(0);
						} else if (o.toLower) {
							k = ch.toLowerCase().charCodeAt(0);
						}
						this._key = k;
					}
				}
				this._doKey(k, (k < 10) ? '' : String.fromCharCode(k), t1, len, this._sel0, this._sel1, bad, e);
			}
		},
		paste: function (txt, flag) {
			/* Paste text at location of caret. Note: method raises the "textChanged" event.
				paramType="string" New text to paste.
				paramType="bool" optional="true" Internal use only.
				returnType="object" Returns reference to this igEditor.
			*/
			var prop, last = this._pasted, o = this.options;
			// prevent double set-text on same paste action
			if (last && _now() - last.now < 10 && (last.txt === txt || last.val === txt)) {
				return this;
			}
			this._pasted = last = last || {};
			last.now = _now();
			last.txt = txt;
			if ((this._nullT && !flag) || this._noPaste === 1) {
				return this;
			}
			// 12-maxLength
			prop = this._prop(12);
			if (prop > 0 && prop < txt.length) {
				txt = txt.substring(0, prop);
			}
			prop = o.includeKeys;
			if (prop) {
				// convert expression-flag-characters into normal characters (escape them)
				prop = prop.toUpperCase().replace(/\[/gm, '\\[').replace(/\]/gm, '\\]').replace(/\^/gm, '\\^').replace(/\-/gm, '\\-');
				// remove everything from txt, but 'include' characters
				txt = txt.replace(new RegExp('[^' + prop + ']', 'igm'), '');
			}
			prop = o.excludeKeys;
			if (prop) {
				// convert expression-flag-characters into normal characters (escape them)
				prop = prop.toUpperCase().replace(/\[/gm, '\\[').replace(/\]/gm, '\\]').replace(/\^/gm, '\\^').replace(/\-/gm, '\\-');
				// remove from txt 'exclude' characters
				txt = txt.replace(new RegExp('[' + prop + ']', 'igm'), '');
			}
			if (o.toUpper) {
				txt = txt.toUpperCase();
			} else if (o.toLower) {
				txt = txt.toLowerCase();
			}
			txt = this._matchList(txt, 0);
			if (_aNull(txt)) {
				txt = this._text;
			}
			this._text = '';
			this._fix = 0;
			this.text(txt, flag ? null : this._sel0); // mask
			this._fix = 1;
			// 12-textChanged
			this._fire(12);
			last.val = this._field[0].value;
			return this;
		},
		_touch: function (act) {
			var scroll, dd = this._ddList;
			if (dd && dd.igScroll) {
				scroll = dd.data('igScroll');
				if (!act) {
					// get around bugs in Android: diminish functionality of igScroll: do not use [cancelStart:true]
					return scroll ? scroll.barY : dd.igScroll({ direction: 'y', yThumb: 'draggable', yScroller: this._ddScroll, cancelStart: 'ms' }).attr('data-scroll', 'y');
				}
				if (scroll) {
					scroll[act](true);
				}
			}
		},
		_fixCss: function () {
			var but, i, dis, csso,
				elem = this._element,
				old = this._hoverOld,
				hov = this._hover,
				down = this._mouseDown,
				foc = this._fcs > 0,
				o = this.options,
				dd = this._ddList,
				css = this._css,
				border = '';
			if (!this._field) {
				return;
			}
			dis = o.disabled;
			csso = this.css;
			if (foc) {
				elem.addClass(csso.focus);
			} else {
				elem.removeClass(csso.focus);
			}
			if (hov) {
				elem.addClass(csso.hover);
			} else {
				elem.removeClass(csso.hover);
			}
			this._hoverOld = hov;
			if (!old || old === hov) {
				old = 0;
			}
			// remove hover from old hover-list-item of drop-down list
			if (old > 99) {
				if (!dd) {
					return;
				}
				this._listCss(dd, old, csso.listItemHover);
			}
			if (hov > 99 && !this._touch()) {
				this._listCss(dd, hov, csso.listItemHover, 1);
			}
			if (dis) {
				css += ' ' + csso.disabled;
			}
			if (this._nullT) {
				css += ' ' + csso.nullValue;
			}
			// numeric editor
			if (this._type > 3 && csso.negative && !this._nullT) {
				if (this._instant(1) < 0) {
					css += ' ' + csso.negative;
				}
			}
			this._setCss(this._field, css);
			// adjust appearance of buttons
			i = this._buttons ? 4 : 0;
			while (i-- > 0) {
				// 0-button, 1-upper spin, 2-lower spin, 3-clear button
				but = this._buttons[i];
				if (!but) {
					continue;
				}
				// _css: 0:default, 1:local-hover, 2:pressed, 3:disabled, 4:image-default, 5:image-hover, 6:image-pressed, 7:image-disabled
				csso = but[0]._css;
				css = csso[0];
				if (dis) {
					css += ' ' + csso[3];
				}
				if (hov === i + 1) {
					css += ' ' + csso[1];
				}
				if (foc) {
					css += ' ' + this.css.buttonFocus;
				}
				if (down === i + 1) {
					css += ' ' + csso[2];
				}
				this._setCss(but, css + border);
				css = csso[4];
				if (dis) {
					css += ' ' + csso[7];
				}
				if (down === i + 1) {
					css += ' ' + csso[6];
				} else if (hov === i + 1) {
					css += ' ' + csso[5];
				} else if (hov || foc) {
					css += ' ' + this.css.buttonsImageStateOverride;
				}
				this._setCss(but.find('SPAN'), css);
			}
		},
		_setCss: function (obj, css) {
			// check if css was modified externally
			var cur = obj[0].className, old = obj[0]._ig_oldCss;
			obj[0]._ig_oldCss = css;
			// avoid unneccary repainting/image-reloading (possible bugs in IE)
			if (css === old) {
				return;
			}
			// check if css was modified externally: keep external className
			if (old && cur && old !== cur && cur.indexOf(old) >= 0) {
				cur = cur.replace(old, '');
				css += ((cur.charAt(0) !== ' ') ? ' ' : '') + cur;
			}
			obj[0].className = css;
		},
		_enterTxt: function () {
			var d, type = this._type;
			// mask editor
			if (type === 1) {
				return this._getTxt(this._dataMode, '');
			}
			// date editor
			if (type === 2 || type === 3) {
				d = this._toDate(this._val(), true);
				return _aNull(d) ? '' : this._toTxt(d, true, '');
			}
			// numeric editors
			if (type > 3) {
				return this._toTxtNum(null, true, this._val(), '-', '.');
			}
			return this._val();
		},
		_update: function () {
			var v, old = this._old;
			if (this._lock) {
				return; //process valueChanged with alert(), enter part value in mask, keep mouse within text, press enter: 2 alerts.
			}
			this._lock = true;
			this._text = this._focusTxt(false, (this._fcs === 2 || this._hadFocus) ? '' : null); //''-still focus
			v = this._instant(1, null, 1);
			if (!_aNull(v) && !_aNull(old)) {
			    if (v.getTime && old.getTime && v.getTime() === old.getTime()) {
					v = old;
				}
			}
			if (v !== old || this._bad === 2) {
				this._val10 = v;
				// 10-valueChanging
				if (this._fire(10, null, v, old)) {
					this._set_val(old);
					this._text = this._focusTxt(false);
				} else {
					if (v !== this._val10) {
						this._setVal(this._val10);
					}
					// if application calls text() within ValueChanged event, then text can be wrong
					this._repaint();
					this.options.value = v = this._instant(1, null, 1);
					// 11-valueChanged
					this._fire(11, null, v, old);
					if (this._k0 !== 13) {
						this._old = this.options.value;
					}
					this._dtt();
				}
			}
			this._lock = false;
		},
		// trigger drop-down show/hide. return null if no trigger was found or action failed/canceled
		// k: -2:button, -1:focus, 1..:keycode
		_dropTrigger: function (e, k) {
			var len, ch, acts, o = this.options, on = this._ddOn;
			acts = o.dropDownTriggers;
			if (k === 0 || !acts || (o.readOnly && !o.dropDownOnReadOnly) || (k === -2 && acts.indexOf('button') < 0) || (k === -1 && acts.indexOf('focus') < 0)) {
				return;
			}
			if (((k === 38 && !on) || (k === 40 && on))) {
				return;
			}
			if (k > 0) {
				ch = (k === 38 || k === 40) ? 'arrow' : String.fromCharCode(k);
				if (e.ctrlKey) {
					ch = 'ctrl+' + ch;
				} else if (e.altKey) {
					ch = 'alt+' + ch;
				} else if (e.shiftKey) {
					ch = 'shift+' + ch;
				}
				len = ch.length;
				ch = acts.indexOf(ch);
				if (ch < 0 || (ch > 0 && acts.charAt(ch - 1) !== ',') || (ch + len < acts.length && acts.charAt(ch + len) !== ',')) {
					return;
				}
			}
			// skip double triggers (button+focus)
			if (!on || k !== -1 || _now() - on > 900) {
				return this._doDrop(1, e);
			}
		},
		// act for datepicker: 0:hide, 1:show, 2:refresh, 3:destroy
		_doDP: function (act, sel) {
			// noFocus - temporary swapped value from options
			var odp, dp, field, id, o = this.options, v = o.focusOnDropDownOpen;
			if (!this._field || this._type !== 3) {
				return;
			}
			if (!this._dp && act !== 1) {
				return 1;
			}
			// try to detect mobile/touch device
			if (_aNull(this._mobile)) {
				try {
					this._mobile = this.__touch || window.navigator.userAgent.toLowerCase().indexOf('mobile') > 0;
				} catch (ex) {}
			}
			// K.D. June 10th, 2014 Bug #171337 We dont need dummy focus for mobile devices.
			if (o.dropDownTriggers === "focus") {
				this._mobile = false;
			}
			// note for _noFocus==true: attempt to suppress default functionality of jquery.datepicker related to focus
			if (_aNull(v)) {
				this._noFocus = this._mobile;
			} else {
				this._noFocus = !v;
			}
			if (sel) {
				this._set_val(sel);
				// 12-textChanged
				this._fire(12);
			}
			dp = $.datepicker;
			field = this._field[0];
			id = field.id;
			// configure/hack-into $.datepicker
			if (!dp._old_selectDay) {
				dp._old_selectDay = dp._selectDay;
				dp._old_parseDate = dp.parseDate;
				dp._old_updateDatepicker = dp._updateDatepicker;
				dp._old_checkOffset = dp._checkOffset;
				// do not allow calendar to get focus on mousedown under firefox
				dp.dpDiv.bind('mousedown', function (evt) {
					var dp = $.datepicker._ig_dp;
					if (dp) {
						// get around SELECT in $.datepicker
						if (evt.target && evt.target.nodeName === 'SELECT') {
							// md=mousedown: flag to ignore blur and set focus() back to INPUT
							dp._ddmd = _now();
							// nf=noFocus: flag to skip setFocus
							dp._ddnf = $.ig.util.isFF || dp.__touch;
						} else {
							_stop(evt);
						}
					}
				});
				// prevent default update of field by calendar on select
				dp._selectDay = function (id, month, year, td) {
					var me = this._ig_dp;
					if (!me) {
						return this._old_selectDay(id, month, year, td);
					}
					id = $('a', td).html() || td.firstChild.innerHTML;
					// hide calendar and set value to selection
					me._doDrop(0, { type: 'mousedown' }, [year, month, _int(id)], 1);
					// stop xy-move timer: optional (should be stopped by now)
					me._xyCheck(true);
				};
				// do not allow calendar to get focus on mousedown under UI
				dp._updateDatepicker = function (inst) {
					var field, me = this._ig_dp;
					if (me) {
						this._ig_css = me.css.dropDown;
						this.dpDiv.addClass(this._ig_css);
						if (me._noFocus) {
							field = me._field[0];
							// happens on initial show
							if (field.disabled) {
								field = null;
							}
						}
					} else if (this._ig_css) {
						this.dpDiv.removeClass(this._ig_css);
						delete this._ig_css;
					}
					if (field) {
						//  "disabled": hack into $.datepicker.updateDatepicker to prevent input.focus()
						field.disabled = true;
					}
					this._old_updateDatepicker(inst);
					if (field) {
						// restore "disabled" hack used for $.datepicker.updateDatepicker
						field.disabled = false;
					}
					if (me) {
						this.dpDiv.find('*').attr('unselectable', 'on');
					}
				};
				// replace default parseDate by _getVal
				dp.parseDate = function (a, b, c) {
					return this._ig_dp ? this._ig_dp._df(this._ig_dp._getVal(1), -1) : this._old_parseDate(a, b, c);
				};
				// adjust left-position of calendar for possible buttons on left
				dp._checkOffset = function (inst, offset, isFixed) {
					var xy, me = this._ig_dp;
					offset = this._old_checkOffset(inst, offset, isFixed);
					if (me) {
						offset.left -= me._leftShift();
						_offset(null, offset);
						// if container of editor was moved, then close drop-down
						// start xy-move timer
						xy = _offset(me._swap ? me._field : me._element);
						me._xy = {
							x: xy.left,
							y: xy.top,
							i: setInterval(function () { me._xyCheck(); }, 300)
						};
					}
					return offset;
				};
			}
			// show calendar
			if (act === 1) {
				v = dp._ig_dp;
				if (v && v !== this) {
					delete dp._ig_dp;
					v._doDrop();
				}
				// ensure that field has unique id
				if (id.length < 1) {
					id = this.element[0].id + '_ig_dp_id';
					while (document.getElementById(id)) {
						id += Math.floor(Math.random() * 10);
					}
					field.id = id;
				}
				// create $.datepicker and connect it to field
				if (!this._dp) {
					odp = $.extend(o.datepickerOptions, this._dpRegion()) || {};
					v = o.animationShowDuration;
					if (v) {
						odp.duration = v;
					}
					v = o.animationShowEffect;
					if (v) {
						odp.showAnim = v;
					}
					odp.showOn = '';
					odp.onClose = function () {
						var me = dp._ig_dp;
						if (me) {
							// datepicker was closed by outside mouse click while its SELECT had focus
							if (me._fcs && me._ddnf && me._ddnf.type) {
								// fake blur event
								me._onEvt(me._ddnf, 9);
							}
							me._dpClosed = 1;
							me._doDrop();
							delete me._dpClosed;
							delete dp._ig_dp;
						}
					};
					this._dp = $(field).datepicker(odp);
				}
				odp = $.data(field, 'datepicker').settings;
				odp.minDate = odp.minDate || o.minValue;
				odp.maxDate = odp.maxDate || o.maxValue;
				if ($.ig.util.isOpera) {
					odp.changeYear = false;
				}
				dp._ig_dp = this;
				// prevent hide calendar on field-mouse-down, and allow destroy
				this._css += ' ' + $.datepicker.markerClassName;
				if (this._noFocus) {
					// "disabled": hack into $.datepicker._showDatepicker to prevent input.focus()
					field.disabled = true;
				} else if (this._fcs < 1) {
					this.setFocus(-1);
				}
				dp._showDatepicker(field);
				if (this._noFocus) {
					// restore "disabled" hack used for $.datepicker._showDatepicker
					field.disabled = false;
					// set focus to a dummy element in order to take focus away from possible current focused element
					try {
						dp._dummyFocus = dp._dummyFocus || (this._mobile ? $('<button />').css('position', 'absolute').css('top', '-100px').appendTo(document.body)[0] : dp.dpDiv[0]);
						dp._dummyFocus.focus();
					} catch (ex) {}
				}
			} else if (act === 2) {
				// update calendar selection from change in field
				dp._doKeyUp({ target: field });
			// 0 - hide, 3 - destroy
			} else {
				// stop xy-move timer
				this._xyCheck(true);
				// hide calendar
				if (!this._dpClosed) {
					dp._hideDatepicker(field);
				}
				// destroy calendar
				if (act === 3) {
					dp._destroyDatepicker(field);
				}
			}
			return 1;
		},
		_fixBC: function (src, e) {
			src = src.css('backgroundColor');
			e.css('backgroundColor', (!src || src === 'transparent' || src.replace(/ /g, '').indexOf('(0,0,0,0') > 0) ? 'white' : src);
		},
		// if element was moved, then close drop-down list
		_xyCheck: function (stop) {
			var xy = this._xy, xyE = this._swap ? this._field : this._element;
			if (!xy) {
				return;
			}
			if (xyE) {
				xyE = _offset(xyE);
				if (Math.abs(xyE.left - xy.x) > 2 || Math.abs(xyE.top - xy.y) > 2) {
					stop = true;
				}
			}
			if (stop || !xyE || !this._ddOn) {
				delete this._xy;
				clearInterval(xy.i);
				this._doDrop();
			}
		},
		// focus/dropdown interactions with igValidator
		// act: 'drop'-show dropdown, 'hide'-hide dropdown, true-focus, undefined/false-blur/remove
		// return: true-cancel action
		_vAct: function (act) {
			return $.ui.igValidator && $.ui.igValidator._act(this, act);
		},
		// show/hide/create drop-down list/calendar
		// act: 0/null-hide, 1-toggle
		// sel: null or [year,month,day] or listIndex+100
		_doDrop: function (act, e, sel, dp) {
			var borderClr, widthOuter, heightOuter, height, up, ht, y, b,
				row, col, cols, rows, dif, cell, max, end, el, xy, effect,
				width, dd, elem, body, len, items, heightEnd, par = this._ddParent,
				i = -1, val = sel, me = this, o = this.options;
			items = o.listItems;
			act = (act === 1) ? !this._ddOn : false;
			if (!act && !this._ddOn && !dp) {
				return;
			}
			if (!me._field || me._vAct(act ? 'drop' : 'hide')) {
				return;
			}
			len = items ? items.length : 0;
			// datepicker
			if (this._type === 3) {
				if (sel && !isNaN(sel[2])) {
					// 1: get Date object
					val = this._getVal(1);
					if (!val) {
						val = this._df(sel[0], sel[1], sel[2], 0, 0, 0, 0);
					} else {
						val = this._df(sel[0], sel[1], sel[2], this._df(val, 3), this._df(val, 4), this._df(val, 5), this._df(val, 6));
					}
				}
			} else {
				if (len < 1) {
					return;
				}
				if (sel) {
					val = this._item(items[sel - 100]);
				}
			}
			// 16-show drop-down, 17-hide
			if (this._fire(act ? 16 : 17, e, act ? null : { value: val }) && e) {
				return;
			}
			this._ddOn = act ? _now() : null;
			// show/hide calendar
			if (this._type === 3) {
				return this._doDP(act ? 1 : 0, val);
			}
			dd = me._ddList;
			elem = me._element;
			body = !o.listDropDownAsChild || elem === me._field;
			if (!dd) {
				dd = me._ddList = $('<div/>').addClass(me.css.dropDown + ' ' + me.css.list).scroll(function () {
					me._lazy();
				});
				// _id: 99:drop-down
				dd[0]._id = 99;
				me._ddSel = -1;
				me._ddLen = len;
				dd.css({ position: 'absolute', visibility: 'hidden' });
				width = o.listWidth;
				if (width < 5) {
					width = elem.outerWidth();
					if (width < 5) {
						width = 100;
					}
				}
				if (body) {
					me._ddParent = par = o.theme ? $('<span/>').addClass(o.theme).css('position', 'absolute').append(dd) : dd;
					MSApp.execUnsafeLocalFunction(function () {
						par.css({ left: '0px', top: '0px' }).appendTo($('body'));
					});
					dd.bind(me._mEvts);
				} else {
					me._ddParent = par = dd.prependTo(elem);
				}
				borderClr = dd.css('borderRightColor');
				cols = Math.max(1, o.listColumns);
				rows = me._rows = Math.ceil(len / cols);
				dif = dd.outerWidth() - dd.width();
				width = Math.ceil((width - dif) / cols - 1);
				me._listLazy = [];
				for (col = 0; col < cols; col++) {
					for (row = 0; row < rows; row++) {
						if (++i >= len) {
							break;
						}
						// check for last item
						cell = '<div style="width:' + width + 'px;position:absolute;white-space:nowrap;overflow:hidden;';
						val = me._item(items[i]);
						if (typeof val !== 'string') {
							if (me._type >= 4 && typeof val === 'number') {
								val = me._toTxtNum(val);
							} else if (val && me._type === 2 && val.getMonth) {
								val = me._toTxt(val);
							} else {
								val = _str(val);
							}
						}
						el = items[i];
						if (el && typeof el.getHtml === 'function') {
							el = el.getHtml() || val;
						} else {
							el = val;
						}
						if (i > 0) {
							cell += 'height:' + height + 'px;left:' + (col * widthOuter) + 'px;top:' + row * heightOuter + 'px;';
						}
						if (col + 1 < cols) {
							cell += 'border-right-color:' + borderClr;
						}
						cell += '" title="' + me._item(items[i]) + '" _id="' + (i + 100) + '" class="' + me.css.listItem;
						if (col + 1 < cols) {
							cell += ' ' + me.css.listItemColumnBorder;
						}
						cell += '">' + ((el === '') ? '&nbsp;' : el) + '</div>';
						// create only first and last (for scrollbar) items
						if (i === 0 || i + 1 === len) {
							MSApp.execUnsafeLocalFunction(function () {
								cell = $(cell).appendTo(dd);
							});
							// _id: 100+index:drop-down-item
							cell[0]._id = i + 100;
						} else {
							// all other items create by _lazy
							me._listLazy[i] = cell;
						}
						// calculate inner/outer width/height
						if (i === 0) {
							height = cell.height();
							if (height < 5) {
								height = 18;
							}
							dif = cell.outerWidth() - cell.width();
							if (dif > 0) {
								width -= dif;
								cell.css('width', width);
							}
							// width/height of drop-down container
							widthOuter = cell.outerWidth() + 1;
							me._ddWidth = widthOuter * cols;
							me._ddHeight0 = heightOuter = cell.outerHeight();
							me._ddHeight = me._ddHeight0 * rows;
							// ensure that dd-container has same backgroundColor as cell-item
							me._fixBC(cell, dd);
							max = Math.max(0, o.listMaxHeight);
							// make space for scrollbar
							if (max > 0 && me._ddHeight > max) {
								me._ddHeight = max;
								max = Math.ceil(16 / cols);
								width -= max;
								cell.css('width', width);
								widthOuter -= max;
							} else {
								max = 0;
							}
							dd.css('overflow', (max > 0) ? 'auto' : 'hidden');
							cell.css({ height: height, left: col * widthOuter, top: row * heightOuter });
						}
					}
				}
				me._page = Math.max(2, Math.floor(Math.min(me._ddHeight / height), len / 3) - 1);
			}
			if (sel) {
				if (!me._listSelect(sel - 100)) {
					val = this._item(items[sel - 100]);
					me._set_val(val);
					// 12-textChanged
					me._fire(12);
				}
			}
			if (!act) {
				me._lastY = dd[0].scrollTop;
			} else if (me._lastY) {
				dd[0].scrollTop = me._lastY;
			}
			me._listSelect(null, 1);
			val = act ? o.animationShowDuration : o.animationHideDuration;
			if (!val || (typeof val === 'number' && val < 5)) {
				val = null;
			} else {
				effect = act ? o.animationShowEffect : o.animationHideEffect;
				if (!$.effects || !$.effects[effect]) {
					if (!act && typeof val !== 'number') {
						val = 450;
					}
					effect = null;
				}
			}
			// starting height for show-animation, ending height for hide-animation
			heightEnd = (val && !effect) ? 0 : me._ddHeight;
			end = function () {
				if (act) {
					dd.css('filter', '');
					// ensure scroll
					if (!sel && me._lastY) {
						dd[0].scrollTop = me._lastY;
					} else {
						me._listSelect();
					}
					// verify that there is no horizontal scrollbar and increase width (IE+quirks)
					i = dd[0].scrollWidth - dd[0].clientWidth;
					if (!me._ddFixW && i > 0 && i && i < 4) {
						me._ddFixW = ++i;
						me._ddWidth += i;
						dd.css('width', me._ddWidth);
					}
					me._touch();
				} else {
					dd.css({ display: 'none', visibility: 'hidden' });
					me._touch('_hide');
				}
			};
			// show list
			if (act) {
				this._lazy();
				if (me._fcs < 1) {
					me.setFocus();
				}
				// validate if drop-down fits in window
				// ht: client height of window
				ht = 999;
				b = document.body;
				el = document.documentElement;
				// process window (not IE)
				i = window.innerHeight;
				if (i > 50 && i) {
					ht = i;
				} else if (el.clientHeight > 50 && el.clientHeight) {
					ht = el.clientHeight;
				} else if (b.clientHeight > 50 && b.clientHeight) {
					ht = b.clientHeight;
				}
				// y: scrollTop of window
				y = Math.max(window.pageYOffset || 0, Math.max(b.scrollTop, el.scrollTop));
				// if element was swapped, then under Firefox offset() returns wrong values: use original element
				el = me._swap ? me._field : elem;
				xy = _offset(el);
				me._xy = body ? { x: xy.left, y: xy.top } : null;
				xy.h = el[0].offsetHeight;
				// if enough space for drop-down below editor
				up = xy.top + xy.h + me._ddHeight - y - ht;
				if (up > 0 && y - xy.top + me._ddHeight < up) {
					// shift drop-down above editor
					up = me._ddHeight + 2;
					if (xy.top - up < y) {
						// do not allow drop-down go above top edge of window
						up = Math.max(xy.top - y, 2);
					}
					// xy.h is used for "marginTop", when drop-down is local to editor
					xy.h = -up;
					// xy.top is used for "top", when drop-down belongs to body
					xy.top += xy.h;
					// disable animation of height
					heightEnd = me._ddHeight;
					elem.addClass(me.css.noTopCorners);
					dd.addClass(me.css.noBottomCorners);
				} else {
					// show drop-down below editor
					// xy.top is used for "top", when drop-down belongs to body
					xy.top += xy.h;
					elem.addClass(me.css.noBottomCorners);
					dd.addClass(me.css.noTopCorners);
				}
				// initial styles before show-animation
				dd.css({ opacity: (val && !effect) ? 0 : 1, height: heightEnd, width: Math.floor(me._ddWidth / ((val && !effect) ? 2 : 1)), display: '', visibility: 'visible' });
				if (body) {
					// adjust for shift between left edge of field inside of container
					if (me._swap) {
						xy.left -= me._leftShift();
					}
					xy.left -= _int(elem.css('borderLeftWidth'));
					par.css({ left: xy.left, top: xy.top });
					me._xy.i = setInterval(function () {
						me._xyCheck();
					}, 300);
				} else {
					i = me._left ? 'Right' : 'Left';
					par.css('margin' + i, -_int(elem.css('border' + i + 'Width')) + 'px');
					par.css('marginTop', xy.h);
					// IE in quirks mode shifts drop-down to the right edge
					up = _offset(par).left - xy.left;
					if (up > 30 && up < elem[0].offsetWidth + 10) {
						par.css('marginLeft', -up + 'px');
					}
				}
				if (!val) {
					end();
				} else if (effect) {
					dd.show(effect, {}, val, end);
				} else {
					dd.animate({ opacity: 1, height: me._ddHeight, width: me._ddWidth }, val, null, end);
				}
			// hide list
			} else {
				me._xyCheck(true);
				elem.removeClass(me.css.noTopCorners).removeClass(me.css.noBottomCorners);
				dd.removeClass(me.css.noBottomCorners).removeClass(me.css.noTopCorners);
				if (!val) {
					end();
				} else if (effect) {
					dd.hide(effect, {}, val, end);
				} else {
					dd.animate({ opacity: 0.6 }, Math.floor(val * 0.34)).animate({ opacity: 0, height: heightEnd, width: Math.floor(me._ddWidth / 2) }, Math.floor(val * 0.66), null, end);
				}
			}
			return true;
		},
		_lazy: function (i) {
			var id, j, cols = Math.max(1, this.options.listColumns), items = this._listLazy, dd = this._ddOn ? this._ddList : null;
			if (!dd) {
				return;
			}
			if (i) {
				if (items[i]) {
					// _id: 100+index:drop-down-item
					MSApp.execUnsafeLocalFunction(function () {
						$(items[i]).appendTo(dd)[0]._id = i + 100;
						delete items[i];
					});
				}
				return;
			}
			id = Math.floor(dd[0].scrollTop / this._ddHeight0);
			while (cols-- > 0) {
				for (i = 0; i < this._page + 8; i++) {
					j = this._rows * cols + id + i;
					if (items[j]) {
						// _id: 100+index:drop-down-item
						MSApp.execUnsafeLocalFunction(function () {
							$(items[j]).appendTo(dd)[0]._id = j + 100;
							delete items[j];
						});
					}
				}
			}
		},
		_listCss: function (dd, id, css, add) {
			dd = $(dd.children('[_id=' + id + ']'));
			if (add) {
				dd.addClass(css);
			} else {
				dd.removeClass(css);
			}
		},
		// adjust selected item in drop-down list and scroll
		// on=2: do not repaint list, on=1: repaint list, on=null: repaint list if opened
		_listSelect: function (id, on) {
			var top, scroll, sel, arg = null, dd = (on !== 2 && (on || this._ddOn)) ? this._ddList : null, o = this.options;
			if (!o.listItems) {
				return;
			}
			if (!_aNull(id) && this._listID !== id) {
				arg = {index: id, oldIndex: this._listID, item: o.listItems[id]};
				//18: listSelecting
				if (this._fire(18, null, arg)) {
					return 1;
				}
				this._listID = id;
			}
			id = this._listID;
			if (dd) {
				if (on && id < 0) {
					on = this._findItem(this.text(), -1);
					if (!_aNull(on) && id !== on.id) {
						arg = {index: on.id, oldIndex: id, item: o.listItems[on.id]};
						//18: listSelecting
						if (this._fire(18, null, arg)) {
							return 1;
						}
						this._listID = id = on.id;
					}
				}
				// adjust css of selected item
				sel = this._ddSel;
				if (sel !== id) {
					this._lazy(id);
					this._listCss(dd, sel + 100, this.css.listItemSelected);
					sel = this._ddSel = id;
					this._listCss(dd, sel + 100, this.css.listItemSelected, 1);
				}
				if (sel >= 0) {
					// adjust scroll to keep selected item visible
					top = (sel % this._rows) * this._ddHeight0;
					scroll = dd[0].scrollTop;
					if (top > scroll) {
						top += this._ddHeight0 - this._ddHeight;
						if (top < scroll) {
							top = -9;
						}
					}
					if (top !== -9) {
						// get around scroll-bug in Safari after animation
						if ($.ig.util.isSafari && top > 20 && dd[0].scrollTop === top && !on) {
							dd[0].scrollTop = top - 1;
						}
						dd[0].scrollTop = top;
					}
				}
			}
			if (arg) {
				//19: listSelected
				this._fire(19, null, arg);
			}
		},
		// process keydown for drop-down list
		// return true if key was processed
		_listKey: function (e, k) {
			var i, len, dd = this._ddOn ? this._ddList : null, id = this._listID, kc = $.ui.keyCode;
			if (!dd) {
				return;
			}
			if (k === kc.ENTER || k === kc.SPACE || k === kc.ESCAPE) {
				this._doDrop(0, e, (k === kc.ESCAPE) ? null : id + 100);
				return true;
			}
			// not action key
			if (k < 33 || k > 40) {
				return;
			}
			len = this._ddLen - 1;
			i = id;
			if (i < 0) {
				i = -1000;
			}
			if (k === kc.DOWN) {
				i++;
			} else if (k === kc.UP) {
				i--;
			} else if (k === kc.PAGE_DOWN) {
				i += this._page;
			} else if (k === kc.PAGE_UP) {
				i -= this._page;
			} else if (k === kc.HOME) {
				i = 0;
			} else if (k === kc.END) {
				i = len;
			} else if (k === kc.RIGHT) {
				i += this._rows;
				if (i > len) {
					i = id;
				}
			} else if (k === kc.LEFT) {
				i -= this._rows;
				if (i < 0) {
					i = id;
				}
			} else {
				return;
			}
			this._listSelect(Math.max(0, Math.min(i, len)));
			return true;
		},
		_listChange: function (list, i, act) {
			var len, count, j, items = this.options.listItems;
			len = items ? items.length : 0;
			j = count = list ? list.length : 0;
			i = (_aNull(i) || i < 0) ? -1 : i;
			// 0:clear, 1:remove, 2:add
			if (act < 2) {
				if (len < 1) {
					return this;
				}
				// find index of item to remove
				if (act > 0 && i < 0) {
					if (list === null) {
						i = len - 1;
					} else {
						while (++i < len) {
							if (items[i] === list) {
								break;
							}
						}
					}
				}
				if (i < 0) {
					items.length = 0;
				} else if (i < len) {
					items.splice(i, 1);
				}
			} else if (!items) {
				this.options.listItems = list;
			} else {
				while (j-- > 0) {
					if (i >= len || i < 0) {
						items.push(list[count - j - 1]);
					} else if (i === 0) {
						items.unshift(list[j]);
					} else {
						items.splice(i, 0, list[j]);
					}
				}
			}
			this._listRemove();
			return this;
		},
		_listRemove: function () {
			if (this._ddList) {
				this._touch('destroy');
				this._element.removeClass(this.css.noTopCorners).removeClass(this.css.noBottomCorners);
				this._ddList.unbind();
				this._ddParent.remove();
				this._ddOn = this._ddList = this._ddParent = this._listLazy = null;
				this._listID = -1;
			}
		},
		_initValidator: function (end, req) {
			if (!this._field) {
				return;
			}
			var v = this._validator, o = this.options, vo = o.validatorOptions;
			// check if igValidator.js is available
			if (end || !vo || !this.element.igValidator) {
				if (v) {
					v.destroy();
					delete this._validator;
				}
				return;
			}
			vo.ctl = this;
			vo.required = o.required = o.required || (!req && vo.required);
			this._field.igValidator(vo);
		},
		// show/hide drop-down validator error label
		// flag: 1-textChanged event, 2-focus event, null-unconditional hide
		// e: browser event or null
		// mes: error message from _doInvalid, if flag=2,then it is submit flag
		_doError: function (flag, e, mes) {
			var val = this._validator;
			if (val && this._field) {
				if (!_aNull(mes)) {
					// 1: error message was canceled by application (used by this.validate)
					return val._doError(mes, null, flag) !== 1;
				}
				if (flag) {
					// notify validator about textChange/focus events
					val._evt(e, null, flag === 2);
					// if error displayed, then memorize current values of editor if focus is set back: used by _onEvt:focus
					if (val._lbl) {
						val._lbl._old = { t: _now(), val: this._val(), sel0: this._sel0, sel1: this._sel1, lastTxt: this._lastText, last: this._last, txt: this._text };
					}
				} else {
					val.hide(null);
				}
			}
		},
		// try to get around scroll-to-caret bugs in Firefox/Safari/Opera/IE9+TEXTAREA
		_doScrl: function (field, txt) {
			var ch, e, fox = $.ig.util.isFF && !this._dp, width = field.clientWidth, max = field.scrollWidth, len = txt.length, f = false, sel = this._sel0;
			if (!this._field || this._tr !== 1 || len < 4) {
				return;
			}
			// width of character in INPUT
			ch = max / len * 1.1;
			// text-length after caret
			len -= sel;
			// TEXTAREA
			if (this._ta) {
				max = field.scrollHeight;
				if (field.clientHeight + 2 > max) {
					return;
				}
				txt = txt.split('\n');
				// only for caret at the end of last line
				if (len * 15 < width && (fox || txt[txt.length - 1].length * 15 > width)) {
					field.scrollTop = max;
					return;
				}
				if (!fox) {
					return;
				}
			// short text before caret
			} else if (sel * 15 < width) {
				return;
			}
			// Safari/Chrome (not Firefox)
			if (!fox) {
				if (max > width + 2) {
					// check length of text after caret and scroll to the end
					if (len * ch * 1.3 < width) {
						field.scrollLeft = max;
					// check length of text before caret and scroll to keep caret at right
					} else if (sel * ch > width + field.scrollLeft) {
						field.scrollLeft = Math.floor(sel * ch - width - 3);
					}
				}
				return;
			}
			// no support for Japanese
			if (this._bad > 2) {
				return;
			}
			// flag to ignore _onEvt
			this._scrl = 1;
			// fake Space+BackSpace: it should trigger horizontal scroll in Firefox
			try {
				ch = field.maxLength;
				e = this._mask;
				if (ch > 0) {
					field.maxLength = Math.max(ch, e ? e.length : 0) + 2;
				}
				e = document.createEvent('KeyboardEvent');
				e.initKeyEvent('keypress', !f, !f, null, f, f, f, f, 0, 32);
				field.dispatchEvent(e);
				e = document.createEvent('KeyboardEvent');
				e.initKeyEvent('keypress', !f, !f, null, f, f, f, f, 8, 0);
				field.dispatchEvent(e);
				if (ch > 0) {
					field.maxLength = ch;
				}
			} catch (ignore) { }
			delete this._scrl;
		},
		_onEvt: function (e, type) {
			var old, txt, field = this._field, me = this;
			field = field ? field[0] : null;
			// _scrl: ignore-event-flag used for scroll-bug in Firefox
			if (!field || me._scrl) {
				return;
			}
			me._evt = e;
			// 11-paste, beforecut, cut, drop
			if (type !== 11) {
				me._doEvt(e, type, field);
				delete me._evt;
			} else {
				// get around IE8: paste using pop-up menu
				if (me._pasting && _now() - me._pasting < 2000) {
					return;
				}
				// paste, cut, drop, clear-button
				old = field.value;
				// try to get drop-data from clipboard (IE and Firefox)
				try {
					if (me._nullT && e && e.type === 'drop') {
						txt = e.originalEvent.dataTransfer;
						if (!_aNull(txt)) {
							txt = txt.getData('Text');
						}
					}
				} catch (ex) {
					txt = null;
				}
				me._pasting = _now();
				setTimeout(function () {
					if (!txt) {
						if (!me._field) {
							return;
						}
						txt = field.value;
					}
					// note: do not check for !txt, to support clear-button
					if (old !== txt) {
						me.paste(txt);
					}
					delete me._pasting;
				}, 0);
			}
		},
		// eType: 0-keydown, 1-keypress, 2-keyup, 3-mousedown, 4-mouseup, 5-mousemove, 6-mouseover, 7-mouseleave, 8-focus, 9-blur, 26-MSPointerOver
		_doEvt: function (e, eType, field) {
			var val, foc, skip, skip0, up, time, src, v = null, k = 0, me = this, o = this.options;
			// _noWidth: flag to calculate width
			if (me._noWidth) {
				me._fixWidth();
			}
			if (!e || o.disabled) {
				return;
			}
			if (eType === 10) {
				v = e.wheelDelta || e.detail;
				if (v) {
					_stop(e);
					me._spin((v > 0) ? o.spinDelta : -o.spinDelta);
				}
				return;
			}
			if ($.ig.util && $.ig.util.evtButton(e)) {
				return;
			}
			// MSPointerOver: flag to skip mouseover for touch event (if pointerType=2)
			if (eType === 26) {
				me._msOver = e.originalEvent.pointerType;
				return;
			}
			// that is continuation of MSPointerOver (2-touch event)
			if (me._msOver === 2 && eType === 6) {
				delete me._msOver;
				return;
			}
			val = src = e.target;
			// find field/button element which owns event
			// _id: -1:field, 1:button, 2:upper-spin, 3:lower-spin, 4:clear, 5:button-image, 6:upper-spin-image, 7:lower-spin-image, 8:clear-image 99:drop-down, 100+index:drop-down-item
			// find element in editor to which belongs browser event
			v = val._id;
			while (val && k++ < 5 && _aNull(v)) {
				val = val.parentNode;
				if (val) {
					v = val._id;
				}
			}
			// mouse leave
			if (eType === 7) {
				me._hover = me._mouseDown = 0;
				me._fixCss();
				me._fire(eType, e, v);
				return;
			}
			if (!v) {
				return;
			}
			// mouseover
			if (eType === 6) {
				// disable ability to get focus in IE
				if (v > 0 && !src.unselectable) {
					src.unselectable = 'on';
				}
				// get around drag-drop/paste in Chrome/Safari (no drop/paste/etc events is raised)
				val = field.value;
				if (val === me._lastText || me._pasting) {
					val = null;
				}
				// ignore drop if there is nullText
				if (!me._fcs && val && me._nullT) {
					if (val !== o.nullText) {
						me._fixNull();
					}
					val = null;
				}
				if (val) {
					me.paste(val, 1);
				}
			}
			// replace 5,6,7,8 (image id) by 1,2,3,4 (button id)
			if (v > 4 && v < 9) {
				v -= 4;
			}
			// keydown and no focus
			// get around bugs in IE8. It may set focus to element before 'init' was called, so: fake 'focus' event
			if (eType === 0 && me._fcs === 0) {
				me._onEvt({ target: src, type: 'focus' }, 8);
			}
			if (_aNull(me._evt0Spin1) && !me._box) {
				try {
					// new lines in TEXTAREA of IE9 are not compatible with IE6-8.
					// That kills calculations of caret: use selectionStart/End and sacrifice scrolling (process _scrl)
					//#159128 T.P. Fix the boolean expression, so when the browser is IE 11, it works correclty
					if (!($.ig.util.isIE && $.ig.util.browserVersion < 11 && !me._ta) && !_aNull(field.selectionStart)) {
						me._tr = 1;
					}
				} catch (ignore) { }
				if (me._tr !== 1) {
					me._tr = field.createTextRange ? field.createTextRange() : null;
				}
				me._bad = _aNull(me._tr) ? 1 : 0;
			}
			me._evt0Spin1 = 0;
			// cut from mask
			// 5-mousemove
			if (eType === 5 && me._fcs === 2 && e.button === 1) {
				me.getSelectedText();
			}
			time = _now();
			// 0-keydown, 1-keypress, 2-keyup
			if (eType < 3) {
				me._key = k = e.keyCode || e.which || 0;
				me._time = time;
			}
			// 1-keypress
			// 0,2,3,4,5,6,7-keydown,keyup,mousedown,mouseup,mousemove,mouseover,mouseleave
			if (eType !== 1 && eType < 8) {
				if (me._fire(eType, e, v)) {
					if (eType < 4) {
						_stop(e);
					}
					return;
				}
			}
			// 0,1,2-keydown,keypress,keyup
			if (eType < 3) {
				// show/hide drop-down
				if (eType === 0 && (me._fcs === 2 || o.dropDownOnReadOnly) && me._dropTrigger(e, k)) {
					return;
				}
				// readOnly state: allow to process up/down arrows
				if (me._fcs === 1 && (e.shiftKey || eType === 1 || !(o.spinOnReadOnly || (o.dropDownOnReadOnly && me._ddOn)) || k < 9 || k > 40)) {
					return;
				}
				// that may happen in grid-editor under Opera on "+" key
				// k=86: skip possible paste by Ctrl+V
				// k=13+this._k0=0: bug in latest Firefox for jp
				// T.P. 2014 June 16th. Under FF space key(32) with JP IME keyboard resets value to its previous state
				if (eType === 2 && me._k0 === 0 && k > 0 && k !== 13 && k !== 86 && me._text !== me._val() && k !== 32) {
					field.value = me._text;
					return;
				}
			}
			// 3-mousedown
			// v: -1:field, 1:button, 2:upper-spin, 3:lower-spin, 5:button-image, 6:upper-spin-image, 7:lower-spin-image, 99:drop-down, 100+index:drop-down-item
			// buttons, list
			if (eType === 3 && v > 0) {
				if (v === 99) {
					me._ddmd = time;
				}
				_stop(e);
			}
			if (eType === 3 && me._mouseDown !== v) {
				// spin buttons
				if (v > 1 && v < 4) {
					me._stopTimer(1);
					if (!o.readOnly || o.spinOnReadOnly) {
						up = (v === 2) ? o.spinDelta : -o.spinDelta;
						if (me._fcs < 1 && o.focusOnSpin) {
							me._evt0Spin1 = 1;
							me.setFocus();
						}
						me._spin(up);
						skip = skip0 = 5;
						me._spinField = -1;
						me._timer = setInterval(function () {
							if (me._mouseDown < 2) {
								return me._stopTimer(1);
							}
							if (--skip < 1) {
								me._spin(up);
								skip = (--skip0 > 8) ? --skip0 : skip0;
							}
						}, 60);
					}
				}
				me._hover = me._mouseDown = v;
				me._fixCss();
			}
			// 5-mousemove, 6-mouseover
			// v: -1:field, 1:button, 2:upper-spin, 3:lower-spin, 5:button-image, 6:upper-spin-image, 7:lower-spin-image, 99:drop-down, 100+index:drop-down-item
			if ((eType === 5 || eType === 6) && me._hover !== v) {
				me._hover = v;
				me._fixCss();
			}
			// 4-mouseup
			if (eType === 4 && me._mouseDown) {
				// v: 1:button, 4:clear
				if ((v === 1 || v === 4) && v === me._mouseDown) {
					// 15-buttonClick
					if (!me._fire(15, e)) {
						if (v === 4) {
							// _onEvt(null, 11) will setTimeout to raise possible textChanged/valueChanged events
							me._onEvt(null, 11);
							// _set_val does not reset "old" values
							me._set_val(null);
							me.select(0);
						} else {
							me._dropTrigger(e, -2);
						}
					}
				}
				// close drop-down list and select item under mouse
				if (v > 99) {
					me._doDrop(0, e, v);
				}
				me._mouseDown = 0;
				me._fixCss();
			}
			if (v > 0) {
				return;
			}
			foc = me._focTime;
			// 4-mouseup
			if (eType === 4) {
				// if focus was set by mouse click, then validate selectionOnFocus,
				// because mouseup in Firefox may set caret and distroy selection
				if (foc && foc + 500 > time) {
					me._select();
				}
				// clear for double click
				me._focTime = 0;
			}
			// 0..2 key events
			if (eType < 3) {
				me._doKey0(e, eType);
			}
			if (!me._field) {
				return;
			}
			val = me._val();
			// 2-keyup
			if (eType === 2) {
				me._last = val;
				// Firefox has list of last strings (like paste) and new value may come from nowhere on mousedown or enter
				if (me._key === 13 && $.ig.util.isFF && me._text !== val) {
					// 12-textChanged
					me._fire(12, e);
					me._update();
					me.text(val);
				}
			}
			// get around text-scroll-bugs in Firefox/Safari/Chrome/IE9+TEXTAREA
			if (eType === 1 && me._keyMod) {
				delete me._keyMod;
				me._doScrl(field, val);
			}
			// 8-focus, 9-blur
			if (eType >= 8) {
				if (me._bad > 2) {
					me._bad = 2;
				}
				me._spinField = -1;
				foc = (eType === 8);
				if (foc) {
					// get around SELECT in $.datepicker
					delete me._ddnf;
				}
				v = me._fcs > 0;
				if (foc === v) {
					return;
				}
				// condition to ignore blur (keep focus text, prevent validation, etc.)
				if (!foc && time - me._ddmd < 500) {
					// get around SELECT in $.datepicker
					// nf: flag to skip setFocus. Save reference to actual blur-event to raise it later
					if (me._ddnf) {
						me._ddnf = e;
					// set focus back to input
					} else {
						me.setFocus(-1);
					}
					return;
				}
				me._noPaste = 0;
				// get around IE-content-menu "delete" action when no text is selected
				if (!foc && me._lastText !== val) {
					me.paste(val, 1);
				}
				if (!foc && me._type < 2 && !val && !o.nullable) {
					val = me._old || (o.listItems ? o.listItems[0] : '');
					if (val) {
						me._set_val(val);
						val = me._text = me._focusTxt(false);
					} else {
						val = '';
					}
				}
				me._fcs = foc ? (o.readOnly ? 1 : 2) : 0;
				if (me._vAct(foc)) {
					return;
				}
				me._hadFocus = !foc;
				// reference to igValidator
				v = me._validator;
				if (foc) {
					me._k0 = 0;
					if (me._bad > 1) {
						me._bad = 0;
					}
					if (!o.readOnly) {
						if (me._nullT) {
							val = me._last = me._text = field.value = '';
						}
						me._nullT = null;
						// check if error/validator label is displayed (set by _doError)
						v = (v && v._lbl) ? v._lbl._old : null;
						if (v && v.t + 200 > _now()) {
							field.value = me._text = v.txt;
							me._lastText = v.lastTxt;
							me._last = v.last;
							me.select(v.sel0, v.sel1);
						} else {
							if (val !== me._text) {
								me.getSelectedText();
								me.paste(val);
							}
							me._lastText = me._last = me._text = me._focusTxt(foc, e);
						}
					}
					me._focTime = time;
					// show drop-down on focus
					me._dropTrigger(e, -1);
				} else {
					// handle situation when error message was displayed, but editor lost focus
					// and value was fixed internally (range, invalid text or required)
					if (v) {
						// notify validator about blur
						me._doError(2, e);
						// set timeout in case validator failed and set focus back to editor
						setTimeout(function () {
							// if value became valid, then hide error
							if (!me._fcs && !me._doInvalid(e, 9)) {
								me._doError();
							}
						}, 100);
					}
					// close drop-down on blur
					me._doDrop(0, e);
					val = me._matchList(val, -1);
					me._canRedo = null;
					if (!o.readOnly) {
						v = me._ta ? (o.maxLength || 0) : 0;
						if (v > 0 && val.length > v) {
							val = val.substring(0, v);
						}
						// temporary enable focus state, because set text(..) may fail. Remove, me._fix=1 to disable me._old-change (ValueChange+fast-Tab).
						if (me._last !== val || me._bad !== 0) {
							v = me._fix;
							me._fix = 0;
							me._fcs = 2;
							me.text(val);
							me._fcs = 0;
							me._fix = v;
						}
						// it will raise valueChange events
						me._update();
					}
				}
				me._repaint();
				me._fixCss();
				// 13:selectionOnFocus: -1:select all, 0:caret to start, 1:caret to end, 2:browser default
				if (foc && this._prop(13) < 2) {
					me.select(this._prop(13) * 10000);
					// if focus is set by Tab, then in Firefox select() may fail
					// and default whole text will be selected: select with delay
					me._select();
				}
				me._hadFocus = false;
				// _focSpin is a flag set by the _spin, when no-focus-spin is not allowed
				// so, when focus is received, then send "continue" spin logic back to its sender _spin function
				if (foc && me._focSpin) {
					me._spin(me._focSpin);
				}
				me._focSpin = null;
				me._fire(eType, e, -1);
				me._lastText = me._val();
				return;
			}
			if (!(eType > 3 && me._k0 === 0) && !me._nullT && val !== me._text) {
				me._text = val;
				// 12-textChanged
				me._fire(12, e);
			}
		},
		_fire: function (id, e, arg, a2) {
			if (!this._field) {
				return;
			}
			// 13-invalidValue, 17-hide drop-down, 18/19-listSelecting/listSelected
			var evt, ee = this.events, args = (id === 13 || id > 16) ? arg : {};
			for (evt in ee) {
				if (ee.hasOwnProperty(evt) && ee[evt] === id) {
					break;
				}
			}
			// 14-spin
			if (id === 14) {
				args.delta = arg;
				args.value = this._instant(1, null, 1);
			}
			// 12-textChanged
			if (id === 12) {
				args.oldText = this._lastText;
				arg = this._val();
				if (args.oldText === arg) {
					return;
				}
				// notify validator about textChange event
				this._doError(1, e);
				this._doClear(arg);
				args.text = this._lastText = this._text = arg;
				// change/spin while no focus
				if (this._fcs < 2 && this._evt0Spin1 !== 1) {
					this._update();
				}
				// update calendar
				this._doDP(2);
				// numeric editor (negative/positive value)
				if (this._type > 3) {
					this._fixCss();
				}
			}
			// key events
			if (id < 3) {
				args.key = this._key;
			// mouse events
			} else if (id < 8) {
				args.elementType = (arg === -1) ? 'field' : ((arg === 1 || arg === 5) ? 'button' : ((arg === 2 || arg === 6) ? 'spinUpper' : ((arg === 3 || arg === 7) ? 'spinLower' : ((arg === 99) ? 'dropDown' : ((arg > 99) ? 'item' + (arg - 100) : '')))));
				args.id = arg;
			}
			// 10-valueChanging, 11-valueChanged
			if (id === 10 || id === 11) {
				args.value = arg;
				args.oldValue = a2;
			}
			// 11-valueChanged
			if (id === 11 && this._fcs === 2) {
				this._update();
			}
			args.owner = this;
			if (!this._trigger(evt, e || this._evt, args)) {
				return true;
			}
			// key events
			if (id < 3) {
				this._key = args.key;
			}
			// 10-valueChanging
			if (id === 10) {
				this._val10 = args.value;
			}
		},
		// only when selectionStart/End is used: Firefox/Safari/Opera/IE9+TEXTAREA
		_select: function (x) {
			// 13:selectionOnFocus: -1:select all, 0:caret to start, 1:caret to end, 2:browser default
			var sel1, me = this, field = this._field[0], sel0 = this._prop(13);
			if (this._tr !== 1 || sel0 > 1) {
				return;
			}
			// flag to set timer
			if (!x) {
				setTimeout(function () {
					try {
						me._select(1);
					} catch (ignore) { }
				}, 0);
				return;
			}
			sel1 = field.value.length;
			// -1: select all, 0:caret to start, 1:caret to end
			if (sel0 === 0) {
				sel1 = 0;
			} else if (sel0 < 0) {
				sel0 = 0;
			} else {
				sel0 = sel1;
			}
			if (sel0 !== field.selectionStart || sel1 !== field.selectionEnd) {
				this.select(sel0, sel1);
			}
		},
		select: function (sel0, sel1, val) {
			/* Selects text in editor. If parameters are equal, then than method sets location of caret. That method has effect only when editor has focus.
				paramType="number" optional="true" Left edge of selection. If parameter is missing, then all text is selected.
				paramType="number" optional="true" Right edge of selection. If parameter is missing, then value of first parameter is used.
				paramType="string" optional="true" Internal use only (new text)
				returnType="object" Returns reference to this igEditor.
			*/
			var j, i, fix0 = 0, fix1 = 0, tr = this._tr, field = (this._fcs === 2) ? this._field[0] : null;
			if (!field || field.offsetWidth < 2 || this._box) {
				return this;
			}
			if (_aNull(val)) {
				val = field.value;
			} else {
				sel1 = sel0;
				if (field && field.value !== val) {
					this._keyMod = field.value = val;
				}
			}
			i = val.length;
			if (_aNull(sel1, 1)) {
				sel1 = sel0;
				if (_aNull(sel0, 1) || sel0 < 0) {
					sel0 = 0;
					sel1 = i;
				}
			}
			if (sel1 >= i) {
				sel1 = i;
			} else if (sel1 < sel0) {
				sel1 = sel0;
			}
			if (sel0 > sel1) {
				sel0 = sel1;
			}
			this._sel0 = sel0;
			this._sel1 = sel1;
			// IE8+TAB_key have problems with selection object
			try {
				// Firefox/Safari/Opera/IE9+TEXTAREA
				if (tr === 1) {
					field.selectionStart = sel0;
					field.selectionEnd = sel1;
					return this;
				}
				// unknown selection model or error
				if (!tr) {
					if (sel0 !== sel1) {
						field.select();
					}
					return this;
				}
				// all below is IE
				if (this._ta) {
					// get around IE-TEXTAREA mess with '\r\n'
					j = sel1;
					while (j-- > 0) {
						if (val.charCodeAt(j) === 10) {
							if (j < sel0) {
								fix0++;
							}
							fix1++;
						}
					}
					sel0 -= fix0;
					sel1 -= fix1;
				}
				sel1 -= sel0;
				if (this._ta) {
					tr.moveToElementText(field);
				} else {
					tr.move('textedit', -1);
				}
				tr.move('character', sel0);
				if (sel1 > 0) {
					tr.moveEnd('character', sel1);
				}
				// IE8 may raise exception on next line
				tr.select();
			} catch (ignore) { }
			return this;
		},
		getSelectedText: function () {
			/* Gets selected text in editor.
				returnType="string" Returns selected text.
			*/
			var i, range, val, txt = '', field = this._field[0], tr = this._tr, sel0 = 0;
			this._sel0 = this._sel1 = 0;
			// unknown selection model or error
			if (_aNull(tr)) {
				return txt;
			}
			// Firefox/Safari/Opera/IE9+TEXTAREA
			if (tr === 1) {
				this._sel0 = field.selectionStart;
				this._sel1 = field.selectionEnd;
				if (this._sel0 < this._sel1) {
					txt = field.value.substring(this._sel0, this._sel1);
				}
				return txt;
			}
			// all below is IE
			try {
				// IE8 may raise exception on next line
				range = document.selection.createRange();
				val = field.value;
				i = val.length;
				tr = range.duplicate();
				if (this._ta) {
					tr.moveToElementText(field);
				} else {
					tr.move('textedit', -1);
				}
				try {
					while (tr.compareEndPoints('StartToStart', range) < 0) {
						tr.moveStart('character', 1);
						sel0++;
						// get around IE-TEXTAREA mess with '\r\n'
						if (this._ta && val.charCodeAt(sel0) === 10) {
							sel0++;
						}
						if (sel0 > i) {
							break;
						}
					}
				} catch (ignore) { }
				txt = range.text;
			} catch (ignore) { }
			this._sel0 = sel0;
			this._sel1 = sel0 + txt.length;
			return txt;
		},
		getSelection: function (start) {
			/* Gets left or right edge of selection. That method can be used only when editor has focus.
				paramType="bool" optional="true" If true then left edge of selection is returned. Otherwise, right edge selection is returned.
				returnType="number" Position of left or right edge of selection.
			*/
			this.getSelectedText();
			return start ? this._sel0 : this._sel1;
		},
		setFocus: function (delay) {
			/* Set focus to editor with delay.
				paramType="number" optional="true" Delay in milliseconds. If parameter is missing, then 0 is used. If parameter is -1, then focus is set without delay.
				returnType="object" Returns reference to this igEditor.
			*/
			var me = this;
			// can be called from setTimeout
			if (me._field) {
				if (delay === -1) {
					try {
						me._field[0].focus();
					} catch (ignore) { }
				} else {
					setTimeout(function () {
						if (me._fcs < 1) {
							me.setFocus(-1);
						}
					}, delay || 0);
				}
			}
			return this;
		},
		hasFocus: function () {
			/* Checks if editor has focus.
				returnType="bool" Returns true if editor has focus.
			*/
			return this._fcs > 0;
		},
		// filter japanese/arabic digits
		// str (numeric editors): return string which represents English digit or separator
		_jpn: function (k, str) {
			if (str) {
				if (k === 12290 || k === 65294) {
					return '.';
				}
				if (k === 12289) {
					return ',';
				}
			} else if (!this._sTxt) {
				return k;
			}
			if (k > 65295 && k < 65306) {
				k -= 65248;
			} else if (k > 1631 && k < 1642) {
				k -= 1584;
			} else if (k > 1775 && k < 1786) {
				k -= 1728;
			} else {
				return str ? null : k;
			}
			return str ? String.fromCharCode(k) : k;
		},
		_dtt: function () {
			var v, f, input, dt = this._oldAttr.title, o = this.options, name = o.inputName;
			if (name) {
				f = o._vsFormat;
				v = this._getVal(1);
				if (_aNull(v, this._type > 3)) {
					v = '';
				} else if (this._date) {
					v = this._df(v, 0) + '-' + (this._df(v, 1) + 1) + '-' + this._df(v, 2) + ' ' + this._df(v, 3) + ':' + this._df(v, 4) + ':' + this._df(v, 5) + '.' + this._df(v, 6);
				} else if (f && this._type > 3) {
					v = v.toString().replace('.', f);
				}
				input = $('input[name="' + name + '"]');
				if (input[0] !== this.element[0]) {
					if (input.length === 0) {
						MSApp.execUnsafeLocalFunction(function () {
							input = $('<input type="hidden" name="' + name + '" />').appendTo(this._element.parent());
						});
					}
					input.val(v);
				}
			}
			if (!dt || dt.indexOf('{0}') < 0) {
				return;
			}
			v = this._val();
			if (v === '') {
				v = this.options.nullText;
			}
			this._element[0].title = this._field[0].title = this._field[0].alt = dt.replace('{0}', v);
		},
		_stopTimer: function (evt) {
			if (this._timer) {
				clearInterval(this._timer);
			}
			delete this._timer;
			if (!evt && this._timer1) {
				clearInterval(this._timer1);
				delete this._timer1;
			}
		},
		// mask
		_maskFlag: function (ch, upLow) {
			switch (ch) {
			case '>':
				return -1;
			case '<':
				return -2;
			case '&':
				ch = 1;
				break;
			case 'C':
				ch = 2;
				break;
			case 'A':
				ch = 7;
				break;
			case 'a':
				ch = 8;
				break;
			case 'L':
				ch = 13;
				break;
			case '?':
				ch = 14;
				break;
			case '0':
				return 19;
			case '9':
				return 20;
			case '#':
				return 21;
			default:
				return 0;
			}
			return ch + upLow * 2;
		},
		_maskFilter: function (flag, str, i, sf) {
			var ch, f;
			if (i >= str.length) {
				return sf;
			}
			ch = str.charCodeAt(i);
			f = Math.floor((flag - 1) / 6);
			str = str.charAt(i);
			if (ch < 22) {
				return sf;
			}
			if ((f === 1 || f === 3) && ch > 100) {
				ch = this._jpn(ch);
				if (ch < 100) {
					str = String.fromCharCode(ch);
				}
			}
			if (f === 3) {
				// flag==21==# optional and allows digits and +/-, it should be replaced by Space
				return ((flag === 21 && (str === '-' || str === '+')) || (ch > 47 && ch < 58)) ? str : sf;
			}
			if (f === 1 || f === 2) {
				if (f === 1 && ch > 47 && ch < 58) {
					return str;
				}
				if (ch < 256 && str.toUpperCase() === str.toLowerCase()) {
					return sf;
				}
			}
			flag = Math.floor((flag - 1) / 2) % 3;
			if (flag === 0) {
				return str;
			}
			return (flag === 2) ? str.toLowerCase() : str.toUpperCase();
		},
		_getTxt: function (vt, prompt, txt0, getVal) {
			var i, len, flag, iLast = this._selKey, mask = this._mask, txt = '', non = !_aNull(txt0), o = this.options;
			if (!non) {
				txt0 = (this._bad !== 0 && this._fcs > 1) ? this._val() : this._txt;
			}
			if (non) {
				non = this._type === 1;
			}
			if (_aNull(txt0) || _aNull(mask)) {
				return txt;
			}
			len = mask.length;
			// iLast: last character to display (caret/endSelection)
			iLast = (this._fcs > 1 && !getVal && o.hideMaskOnFocus) ? ((iLast && iLast < len) ? iLast - 1 : -1) : len;
			for (i = 0; i < len; i++) {
				flag = mask.charCodeAt(i);
				if (flag < 22) {
					if (i < txt0.length && txt0.charCodeAt(i) >= 22) {
						txt += txt0.charAt(i);
						if (i > iLast) {
							iLast = i;
						}
						non = false;
					} else if (vt % 3 === 2 || (vt % 3 === 1 && flag % 2 === 1)) {
						// flag==21==# optional and allows digits and +/-, it should be replaced by Space
						txt += (flag === 21 && prompt === '') ? o.padChar : prompt;
					}
				} else if (vt >= 3) {
					txt += mask.charAt(i);
					// move to next available position
					if (i === iLast + 1) {
						if (this._selKey === i) {
							this._selKey++;
						}
						iLast++;
					}
				}
			}
			if (iLast++ < len) {
				txt = txt.substring(0, iLast);
			}
			return non ? '' : txt;
		},
		// used only by mask editor
		_setTxt: function (v, vt, render) {
			var ch, flag, j = 0, i = -1, mask = this._mask, txt = this._mask;
			if (!_aNull(v)) {
				while (++i < mask.length) {
					if (vt === 1000 + j) {
						vt = this._dataMode;
					}
					if (j >= v.length) {
						break;
					}
					flag = mask.charCodeAt(i);
					if (flag < 22) {
						ch = this._maskFilter(mask.charCodeAt(i), v, j);
						if (!_aNull(ch)) {
							txt = txt.substring(0, i) + ch + txt.substring(i + 1);
						}
						j++;
					} else if (vt >= 3) {
						j++;
					}
				}
			}
			if (render) {
				return txt;
			}
			this._txt = txt;
			this._text = this._focusTxt(this._fcs > 1, ' ');
			this._repaint();
		},
		// convert inputMask (normal chars) to internal flags
		_setMask: function (str) {
			var x, ch, i, i0 = 0, upLow = 0, mask = '', txt = '', t0 = this._getTxt(0);
			for (i = 0; i < str.length; i++) {
				ch = str.charAt(i);
				x = this._maskFlag(ch, upLow);
				if (x !== 0) {
					if (x < 0) {
						upLow = (upLow === -x) ? 0 : -x;
						continue;
					}
					ch = String.fromCharCode(x);
					mask += ch;
					ch = this._maskFilter(x, t0, i0++, ch);
				} else if (ch === '\\' && i + 1 < str.length && this._maskFlag(str.charAt(i + 1), 0) !== 0) {
					ch = str.charAt(++i);
					mask += ch;
				} else {
					mask += ch;
				}
				txt += ch;
			}
			this._txt = txt;
			this._mask = mask;
		},
		// build mask for date editor
		_getMask: function (fields, v, foc) {
			var x, i, i0 = 0, flag = -1, txt = '';
			if (!v) {
				v = '';
			}
			if (foc) {
				v = v.replace('dddd', 'ddd').replace('ddd,', '').replace('ddd ', '').replace(' ddd', '').replace('ddd', '');
			}
			// temporary replace \\f,d,s,m,etc. by \x01-\x09
			v = v.replace(/\x08/g, ' ').replace(/\x09/g, ' ');
			v = v.replace(/\\f/g, '\x01').replace(/\\d/g, '\x02').replace(/\\s/g, '\x03').replace(/\\m/g, '\x04').replace(/\\t/g, '\x05').replace(/\\H/g, '\x06').replace(/\\h/g, '\x07').replace(/\\M/g, '\x08').replace(/\\y/g, '\x09');
			// 01-y,02-yy,03-yyyy,04-M,05-MM,06-MMM,07-MMMM,08-d,09-dd
			// 10-h,11-hh,12-H,13-HH,14-t,15-tt,16-m,17-mm,18-s,19-ss
			// 20-ddd,21-dddd,22-f,23-ff,24-fff
			v = v.replace('fff', '24').replace('ff', '23').replace('f', '22');
			v = v.replace('dddd', foc ? '' : '21').replace('ddd', foc ? '' : '20').replace('dd', '09').replace('d', '08').replace('ss', '19').replace('s', '18').replace('mm', '17').replace('m', '16');
			v = v.replace('tt', '15').replace('t', '14').replace('HH', '13').replace('H', '12').replace('hh', '11').replace('h', '10');
			v = v.replace('MMMM', foc ? 'MM' : '07').replace('MMM', foc ? 'MM' : '06').replace('MM', '05').replace('M', '04').replace('yyyy', '03').replace('yy', '02').replace('y', '01');
			// restore original \\f,d,s,m,etc.
			v = v.replace(/\x01/g, 'g').replace(/\x02/g, 'd').replace(/\x03/g, 's').replace(/\x04/g, 'm').replace(/\x05/g, 't').replace(/\x06/g, 'H').replace(/\x07/g, 'h').replace(/\x08/g, 'M').replace(/\x09/g, 'y');
			for (i = 0; i < v.length; i++) {
				x = v.charCodeAt(i);
				if (x < 48 || x > 57) {
					flag = v.charAt(i);
					if (!foc && flag === '\\' && i + 1 < v.length) {
						x = v.charAt(++i);
						if (x === '\\') {
							continue;
						}
						if (x === '0' || x === '9') {
							txt += flag;
						}
						txt += x;
					} else {
						txt += v.charAt(i);
					}
					continue;
				}
				flag = (x - 48) * 10 + v.charCodeAt(++i) - 48;
				if (!foc) {
					fields[i0++] = flag;
					txt += '\x01';
					continue;
				}
				fields[i0++] = flag;
				if (flag === 14) {
					txt += 'L';
				} else if (flag === 15) {
					txt += 'LL';
				} else if (flag === 22) {
					txt += '0';
				} else {
					txt += '00';
					if (flag === 3) {
						txt += '00';
					}
					while (flag-- > 23) {
						txt += '0';
					}
				}
			}
			return txt;
		},
		getValueByMode: function (mode, v, getVal) {
			/* Get value in editor by dataMode.
				paramType="string" The value of dataMode option supported by editor. It can be string or number. For example, in case of numeric editors that can be a number in range from -1 to 11, or string such as "text", "double", "byte", etc.
				paramType="object" optional="true" Internal use only.
				paramType="object" optional="true" Internal use only.
				returnType="string|number|date|object" Returns value in editor or null.
			*/
			var d, type = this._type, empty = this.options.emptyChar;
			mode = this._mode(mode, type);
			// text editor
			if (type === 0 || !this._field) {
				return this._val();
			}
			// numeric editors
			if (type > 3) {
				d = this._dataMode;
				this._dataMode = mode;
				v = this.value();
				this._dataMode = d;
				return v;
			}
			// mask editor
			if (type === 1) {
				return this._getTxt(mode, v ? '' : empty, null, getVal);
			}
			// date editors
			// v-limit
			d = (this._fcs < 2) ? (this._isNull ? null : this._date) : this._toDate(this._val(), true, v);
			return (mode === 0) ? d : (d ? this._toTxt(d, mode === 1, empty) : '');
		},
		// date
		// f:flag of field, d:Date, e:focus, ch:fill-up character
		_fieldVal: function (f, d, e, ch) {
			// 1-y,2-yy,3-yyyy,4-M,5-MM,6-MMM,7-MMMM,8-d,9-dd
			// 10-h,11-hh,12-H,13-HH,14-t,15-tt,16-m,17-mm,18-s,19-ss
			// 20-ddd,21-dddd,22-f,23-ff,24-fff
			var v, j, i = (f % 2) * 2, o = this.options;
			if (f < 4) {
				v = this._df(d, 0) + o.yearShift;
				if (f === 3) {
					i = 4;
				} else {
					v %= 100;
					i = (f === 2) ? 2 : 0;
				}
			} else if (f < 8) {
				this.d_s = 2;
				v = this._df(d, 1) + 1;
				if (f > 5) {
					// 6-MMM,7-MMMM
					f = this._optVal((f === 6) ? 'monthNamesShort' : 'monthNames')[v - 1];
					if (f.length > 0) {
						return f;
					}
				}
			} else if (f < 10) {
				v = this._df(d, 2);
			} else if (f < 16) {
				v = this._df(d, 3);
				//ampm
				if (f > 13) {
					v = this._optVal((v < 12) ? 'am' : 'pm');
					f -= 13;
					i = v.length;
					if (f === i) {
						return v;
					}
					if (i < f) {
						v += ' ';
					}
					return v.substring(0, f);
				}
				if (f < 12) {
					v %= 12;
					if (v === 0) {
						v = 12;
					}
				}
			} else if (f < 18) {
				v = this._df(d, 4);
			} else if (f < 20) {
				v = this._df(d, 5);
			} else if (f > 21) {
				v = this._df(d, 6);
				j = i = f - 21;
				while (j-- > 3) {
					v *= 10;
				}
				while (j++ < 2) {
					v = Math.floor(v / 10);
				}
			// 20-ddd,21-dddd
			} else {
				return this._optVal((f === 20) ? 'dayNamesShort' : 'dayNames')[d.getDay()];
			}
			v = _str(v);
			if (f < 20 || f > 22) {
				f = v.length;
				if (e) {
					if (i === 0) {
						i = 2;
					} else {
						e = false;
					}
				}
				if (i > 0) {
					if (i < f) {
						v = v.substring(0, i);
					} else {
						while (f++ < i) {
							v = (e ? ch : '0') + v;
						}
					}
				}
			}
			return v;
		},
		_limits: function (val, roll) {
			// 10-minValue, 11-maxValue
			var time, min = this._prop(10), max = this._prop(11);
			// numeric editors
			if (this._type > 3) {
				if (_aNull(val, 1) && !this.options.nullable) {
					val = this.options.nullValue;
					// -1:text, 0:editModeText, 1:double, 2:float, 3:decimal, etc.
					if (!val && this._dataMode > 2) {
						val = 0;
					}
				}
				if (!_aNull(val, 1)) {
					if (!_aNull(min, 1) && val <= min) {
						return roll ? max : min;
					}
					if (!_aNull(max, 1) && val >= max) {
						return roll ? min : max;
					}
				}
				return val;
			}
			// date editors
			if (_aNull(val)) {
				return val;
			}
			time = val.getTime();
			if (!_aNull(min)) {
				min = min.getTime();
			}
			if (!_aNull(max)) {
				max = max.getTime();
			}
			if (!_aNull(min) && (time < min || (roll && time === min))) {
				val.setTime(roll ? max : min);
				return val;
			}
			if (!_aNull(max) && (time > max || (roll && time === max))) {
				val.setTime(roll ? min : max);
				return val;
			}
			return null;
		},
		_date7: function (val) {
			var i;
			if (val.length < 13) {
				return null;
			}
			// build "y-M-d-h-m-s-ms-t" format and split it into array[7]
			val = val.replace(/[\. :]/g, '-').split('-');
			i = val.length;
			if (i !== 7) {
				return null;
			}
			while (i-- > 0) {
				val[i] = _int(val[i], -1);
				if (val[i] < 0) {
					return null;
				}
			}
			return this._df(val[0], val[1] - 1, val[2], val[3], val[4], val[5], val[6]);
		},
		// convert txt to Date
		// foc: focus state
		// limit: validate min/max limits
		// fire: request to fire invalid event (set this._inv)
		_toDate: function (txt, foc, limit, fire) {
			// n: count of ymd fields
			// mis: 0-all fields, 1..8-missing fields, 9..17-less than min number of fields
			var v, i0, c, iLen, invMes, mis = 0, n = 0, i = -1, j = -1,
				y = -1, mo = -1, day = -1, h = -2, m = -2, s = -2, ms = -2, pm = -1,
				any = false, inv = null, arg = {}, o = this.options,
				d = fire ? null : this._date7(txt),
				fields = (foc && fire) ? this._fields0(txt) : this._fields1(txt, foc);
			iLen = fields.length;
			if (!d) {
				while (++i < iLen) {
					j++;
					v = fields[i];
					i0 = foc ? this._field0IDs[i] : this._field1IDs[i];
					if (i0 < 4) {
						if (v > 100 && v > o.yearShift) {
							v -= o.yearShift;
						}
						arg.year = y = v;
						if (y < 0) {
							mis++;
						} else {
							n++;
							c = o.centuryThreshold;
							if (v < 100) {
								if (i0 < 3 && c < 0) {
									c = 29;
								}
								if (c >= 0) {
									y += (v > c) ? 1900 : 2000;
								}
							}
						}
					} else if (i0 < 8) {
						if (v < 1 || v > 12) {
							mis++;
						} else {
							arg.month = mo = v;
							n++;
						}
					} else if (i0 < 10) {
						arg.day = day = v;
						if (v < 1 || v > 31) {
							mis++;
						} else {
							n++;
						}
					} else if (i0 < 14) {
						if (v === 24) {
							v = 0;
						}
						if (i0 > 11) {
							pm = -4;
						} else {
							if (v === 12) {
								v = 0;
							}
							if (v > 12) {
								mis++;
							}
						}
						arg.hours = h = v;
						if (v > 23 || v < 0) {
							mis++;
						}
					} else {
						if (i0 < 16) {
							j--;
							if (v > 0) {
								pm++;
							}
							continue;
						}
						if (i0 < 18) {
							arg.minutes = m = v;
							if (v > 59 || v < 0) {
								mis++;
							}
						} else if (i0 < 20) {
							arg.seconds = s = v;
							if (v > 59 || v < 0) {
								mis++;
							}
						} else {
							if (i0 < 22) {
								j--;
								continue;
							}
							while (i0++ < 24) {
								v *= 10;
							}
							while (i0-- > 25) {
								v = Math.floor(v / 10);
							}
							arg.milliseconds = ms = v;
							if (v > 999 || v < 0) {
								mis++;
							}
						}
					}
					if (v >= 0) {
						any = true;
					}
					if (j < o.minNumberOfDateFields && mis > 0) {
						if (fire && any) {
							invMes = this._optVal('dateFields', 2);
							inv = 'numberOfFields';
						}
						// not enough fields
						mis += 9;
					}
				}
			}
			if (pm === 0 && h >= 0 && h < 12) {
				h += 12;
				arg.hours = h;
			}
			if (!d && (!o.nullable || mis < 9)) {
				// ymd are defined
				if (n === 3) {
					d = this._df(y, mo - 1, day, 0, 0, 0, 0);
					if (y < 100) {
						this._df(d, 0, y);
					}
				} else {
					d = this._df();
					if (this._date) {
						d.setTime(this._date.getTime());
					}
					if (day > 0) {
						this._df(d, 2, 10);
					}
					if (y >= 0) {
						this._df(d, 0, y);
					}
					if (mo > 0) {
						this._df(d, 1, mo - 1);
					}
					if (day > 0) {
						this._df(d, 2, day);
					}
				}
			}
			if (fire && day > 0 && d && day !== this._df(d, 2)) {
				invMes = this._optVal('invalidDay', 2);
				inv = 'dayOfMonth';
			}
			day = o.useLastGoodDate ? this._goodD : null;
			if (fire && !d && !o.nullable) {
				d = day;
				if (!d || !d.getTime) {
					d = this._df();
				} else {
					invMes = this._optVal('required', 2);
					inv = 'null';
				}
			}
			if (d) {
				if (h > -2) {
					this._df(d, 3, (h < 0) ? 0 : h);
				}
				if (m > -2) {
					this._df(d, 4, (m < 0) ? 0 : m);
				}
				if (s > -2) {
					this._df(d, 5, (s < 0) ? 0 : s);
				}
				if (ms > -2) {
					this._df(d, 6, (ms < 0) ? 0 : ms);
				}
				if (limit) {
					i = d;
					d = this._limits(d);
					if (_aNull(d)) {
						d = i;
					} else if (fire) {
						if (!o.minValue) {
							invMes = this._optVal('max', 2).replace('{0}', this._toTxt(o.maxValue));
						} else if (!o.maxValue) {
							invMes = this._optVal('min', 2).replace('{0}', this._toTxt(o.minValue));
						} else {
							invMes = this._optVal('range', 2).replace('{0}', this._toTxt(o.minValue)).replace('{1}', this._toTxt(o.maxValue));
						}
						inv = 'limit';
					}
				}
			}
			if (fire) {
				if (any && !d && txt.length > 0 && day) {
					if (!inv) {
						invMes = this._optVal('date', 2);
						inv = 'invalid';
					}
					d = day;
				}
				if (!any && o.required) {
					invMes = this._optVal('required', 2);
					inv = 'null';
				}
				arg.value = d;
				if (inv && (txt || !o.nullable)) {
					if (o.reduceDayOfInvalidDate !== false && d && any && this._df(d, 2) < 5 && arg.day > 27) {
						this._df(d, 2, 0);
						arg.value = d;
					}
					arg.text = txt;
					arg.reason = inv;
					arg.message = invMes;
					// set value for argument of invalid event
					this._inv = arg;
				}
			}
			return d;
		},
		_toTxt: function (d, foc, prompt, txt0) {
			var ch, k, i = -1, f0 = 0, txt = '',
				mask = foc ? this._mask : this._mask1,
				ids = foc ? this._field0IDs : this._field1IDs;
			if (_aNull(d)) {
				if (!foc) {
					return '';
				}
				if (txt0) {
					this._txt = mask;
				}
				return this._getTxt(5, prompt, mask);
			}
			this.d_s = 6; // seconds
			while (++i < mask.length) {
				ch = mask.charAt(i);
				k = mask.charCodeAt(i);
				if (k < 22) {
					txt += this._fieldVal(ids[f0++], d, foc, ch);
					if (foc) {
						while (i + 1 < mask.length) {
							if (mask.charCodeAt(i + 1) === k) {
								i++;
							} else {
								break;
							}
						}
					}
				} else {
					txt += ch;
				}
			}
			if (!foc) {
				return txt;
			}
			if (txt0) {
				this._txt = txt;
			}
			return this._getTxt(5, prompt, txt);
		},
		_isPM: function (t, i) {
			var pm = this._optVal('pm').toUpperCase();
			return pm.charAt(0) === t.charAt(i) && (pm.length < 2 || t.length <= i + 1 || pm.charAt(1) === t.charAt(i + 1));
		},
		_fields1: function (txt, foc) {
			var m, k, j, iLen, i = -1, v = -1, field = 0,
				fields = [], ids = foc ? this._field0IDs : this._field1IDs;
			iLen = ids.length;
			while (++i < iLen) {
				fields[i] = -1;
			}
			if (_aNull(txt)) {
				return fields;
			}
			txt = txt.toUpperCase();
			i = -1;
			while (++i < txt.length && field < iLen) {
				k = this._jpn(txt.charCodeAt(i)) - 48;
				j = ids[field];
				if (j === 20 || j === 21) {
					j = ids[++field]; //dow
				}
				//ampm
				if (j === 14 || j === 15) {
					if (k >= 0 && k <= 9) {
						v = -1;
						field++;
						i--;
						continue;
					}
					if (this._isPM(txt, i)) {
						fields[field++] = 1;
						v = -1;
					}
				} else {
					if (k >= 0 && k <= 9) {
						if (v < 0) {
							v = k;
						} else {
							v = v * 10 + k;
						}
					} else {
						if (v >= 0) {
							fields[field++] = v;
							v = -1;
						// 6-MMM,7-MMMM
						} else if (j === 6 || j === 7) {
							//MMM
							while (v-- > -3) {
								for (k = 0; k < 12; k++) {
									m = this._optVal((j === 6) ? 'monthNamesShort' : 'monthNames')[k];
									m = m.toUpperCase();
									j = m.length;
									if (j < 1) {
										continue;
									}
									if (v === -3) {
										if (j < 4) {
											continue;
										}
										m = m.substring(0, 3);
									}
									j = txt.indexOf(m) - 1;
									if (j > -2) {
										if (j < 0 || txt.charAt(j).toLowerCase() === txt.charAt(j)) {
											break;
										}
									}
								}
								if (k < 12) {
									fields[field++] = k + 1;
									break;
								}
							}
						}
					}
				}
			}
			if (field < iLen) {
				fields[field] = v;
			}
			return fields;
		},
		_fields0: function (txt) {
			var x, k, j = -1, i = -1, v = -1, field = -1, n = 22, mask = this._mask, fields = [];
			if (!txt) {
				txt = '';
			}
			while (++i < mask.length) {
				j++;
				x = mask.charCodeAt(i);
				if (x > 21 && n > 21) {
					continue;
				}
				if (x > 21) {
					if (field >= 0) {
						fields[field] = v;
					}
				} else {
					if (n > 21) {
						v = -1;
						field++;
					}
					if (j < txt.length) {
						if (x > 18) {
							k = this._jpn(txt.charCodeAt(j)) - 48;
							if (k >= 0 && k <= 9) {
								if (v < 0) {
									v = k;
								} else {
									v = v * 10 + k;
								}
							} else if (i + 1 < mask.length && txt.charAt(j) === mask.charAt(i + 1)) {
								j--;
							}
						} else if (n !== x && this._isPM(txt.toUpperCase(), j)) {
							v = 1;
						}
					}
				}
				n = x;
			}
			fields[field] = v;
			return fields;
		},
		_curField: function (s, mask) {
			var i, x, n = 22, field = -1;
			this._n0 = this._n1 = -1;
			for (i = 0; i < mask.length; i++) {
				x = mask.charCodeAt(i);
				//if ((x > 21) === (n > 21)) {
				if ((x > 21 && n > 21) || (x <= 21 && n <= 21)) {
					continue;
				}
				if (x > 21) {
					if (i >= s) {
						break;
					}
				} else {
					this._n0 = i;
					field++;
				}
				n = x;
			}
			if (this._n0 >= 0) {
				this._n1 = i;
			}
			field = this._field0IDs[field];
			if (_aNull(field)) {
				return -1;
			}
			if (field < 8) {
				return (field < 4) ? 0 : 1;
			}
			if (field < 20) {
				return Math.floor((field - 4) / 2);
			}
			return (field > 21) ? 8 : -1;
		},
		_maskKey: function (k, ch, txt, i, s, mask) {
			var field, n = 0, v = -1;
			// not date editors
			if (this._type < 2) {
				return -2;
			}
			field = this._curField(s, mask);
			if (s >= this._n1) {
				if (txt.charCodeAt(--s) > 21) {
					return this._maskKey(k, ch, txt, i, s + 2, mask);
				}
			}
			if (field < 0) {
				return -1;
			}
			//ampm
			if (field === 5) {
				if (s <= this._n0) {
					v = this._optVal('am');
					ch = ch.toUpperCase();
					if (v.charAt(0).toUpperCase() !== ch) {
						v = this._optVal('pm');
						if (v.charAt(0).toUpperCase() !== ch) {
							return -1;
						}
					}
					i = v.length;
					if (this._n1 === this._n0 + 1) {
						v = v.charAt(0);
					} else if (i < 2) {
						v += ' ';
					} else if (i > 2) {
						v = v.substring(0, 2);
					}
					this._txt = txt.substring(0, this._n0) + v + txt.substring(this._n1);
				}
				return this._n1;
			}
			if (k < 48 || k > 57) {
				if (s === 0 || (k !== 47 && k !== 58 && (k < 44 || k > 57))) {
					return -1;
				}
				if (mask.charCodeAt(s - 1) >= 22 || this._n1 === i) {
					return s;
				}
				while (s < i) {
					if (mask.charCodeAt(s++) >= 22) {
						break;
					}
					txt = txt.substring(0, s - 1) + mask.charAt(s - 1) + txt.substring(s);
				}
				this._txt = txt;
				return s;
			}
			k -= 48;
			if (this._n0 === s) {
				v = txt.charCodeAt(s + 1) - 48;
				// 0-y,1-M,2-d,3-h,4-H,5-AMPM,6-m,7-s,8-ms
				if (field === 2) {
					if (k > 3) {
						n = 1;
					} else if (k === 3 && v > 1) {
						n = 2;
					}
				// 6-m,7-s
				} else if (field === 6 || field === 7) {
					if (k > 5) {
						n = 1;
					}
				// 1-M,3-h,4-H
				} else if (field > 0 && field < 5) {
					if (field === 4) {
						k--;
						v -= 2;
					}
					if (k > 1) {
						n = 1;
					} else if (k === 1 && v > 2) {
						n = 2;
					}
				}
			}
			if (this._n0 + 1 === s) {
				v = txt.charCodeAt(s - 1) - 48;
				// 0-y,1-M,2-d,3-h,4-H,5-AMPM,6-m,7-s,8-ms
				if (field === 2) {
					if (v > 3 || (v === 3 && k > 1)) {
						n = 3;
					}
				// 6-m,7-s
				} else if (field === 6 || field === 7) {
					if (v > 6 || (v === 6 && k > 0)) {
						n = 3;
					}
				// 1-M,3-h,4-H
				} else if (field > 0 && field < 5) {
					if (field === 4) {
						v--;
						k -= 2;
					}
					if (v > 1 || (v === 1 && k > 2)) {
						n = 3;
					}
				}
			}
			if (n === 1) {
				txt = txt.substring(0, s) + mask.charAt(s) + txt.substring(s + 1);
				s++;
			}
			if (n === 2) {
				txt = txt.substring(0, s + 1) + mask.charAt(s + 1) + txt.substring(s + 2);
			}
			if (n === 3) {
				while (++s < i) {
					if (mask.charCodeAt(s) < 22) {
						break;
					}
				}
				if (s >= i) {
					return -1;
				}
				return this._maskKey(k + 48, ch, txt, i, s, mask);
			}
			this._txt = txt.substring(0, s) + ch + txt.substring(s + 1);
			return ++s;
		},
		_add: function (v0, v) {
			var dot0, dot1, dot2, s1, s2 = v.toString(), s0 = v0.toString(), v1 = v0 + v;
			s1 = v1.toString();
			dot0 = s0.indexOf('.');
			dot1 = s1.indexOf('.');
			if (dot0 < 1 || dot1 < 1) {
				return v1;
			}
			dot2 = s2.indexOf('.');
			if (dot2 > 0) {
				dot2 = s2.length - dot2;
			}
			dot0 = Math.max(dot2, s0.length - dot0);
			if (s1.length - dot1 <= dot0) {
				return v1;
			}
			v = 10;
			while (dot0-- > 2) {
				v *= 10;
			}
			return Math.round(v1 * v) / v;
		},
		// Performs spin action.
		spin: function (delta) {
			/* Increments of decrements value in editor according to the parameter.
				If editor has listItems, then that method increments or decrements selected index in list and sets value in editor to new selected item.
				In this case if delta is positive, then list selected index in incremented by 1 and if delta is negative then selected index is decremented by 1.
				paramType="number" Value to increment or decrement current value in editor.
				returnType="object" Returns reference to this igEditor.
			*/
			var val, x, i, d, o = this.options;
			if (!this._spinList(delta)) {
				return this;
			}
			// text/mask editors: no increment/decrement on spin
			if (this._type < 2) {
				return this;
			}
			// numeric editors
			if (this._type > 3) {
				val = this._toNum(this._val()) || 0;
				val = this._add(val, delta);
				delta = o.maxLength;
				if (!delta || delta < 1 || val.toString().length <= delta) {
					this._set_val(val, this._fcs);
				}
				return this;
			}
			// date editors
			i = this._spinField;
			d = this._df();
			d.setTime(this._date.getTime());
			if (i < 0 || i > 8) {
				if (this._fcs === 2) {
					this.getSelectedText();
					i = this._curField(this._sel0, this._mask);
					d = this._toDate(this._val(), true, true);
					if (_aNull(d)) {
						d = this._df();
					}
					this._spinField = i;
				} else {
					this._spinField = i = this.d_s;
				}
			}
			// 0-y,1-M,2-d,3-h,4-H,5-AMPM,6-m,7-s,8-ms
			if (i === 5) {
				delta = (delta > 0) ? 12 : -12;
			}
			x = o.spin1Field;
			switch (i) {
			case 0:
				delta += this._df(d, 0);
				this._df(d, 0, delta);
				if (x && delta !== this._df(d, 0)) {
					i = -1;
				}
				break;
			case 1:
				delta += this._df(d, 1);
				this._df(d, 1, delta);
				if (x && delta !== this._df(d, 1)) {
					i = -1;
				}
				break;
			case 2:
				delta += this._df(d, 2);
				this._df(d, 2, delta);
				if (x && delta !== this._df(d, 2)) {
					i = -1;
				}
				break;
			case 3:
			case 4:
			case 5:
				i = this._df(d, 2);
				delta += this._df(d, 3);
				this._df(d, 3, delta);
				if (x && i !== this._df(d, 2)) {
					i = -1;
				}
				break;
			case 6:
				delta += this._df(d, 4);
				this._df(d, 4, delta);
				if (x && delta !== this._df(d, 4)) {
					i = -1;
				}
				break;
			case 7:
				delta += this._df(d, 5);
				this._df(d, 5, delta);
				if (x && delta !== this._df(d, 5)) {
					i = -1;
				}
				break;
			case 8:
				for (i = this._n1 - this._n0; i < 3; i++) {
					delta *= 10;
				}
				delta += this._df(d, 6);
				this._df(d, 6, delta);
				if (x && delta !== this._df(d, 6)) {
					i = -1;
				}
				break;
			}
			if (i < 0) {
				return this;
			}
			delta = this._limits(d);
			if (!_aNull(delta)) {
				d = delta;
			}
			this._text = this._toTxt(d, this._fcs === 2, o.promptChar, true);
			this._date = d;
			this._isNull = false;
			this._repaint();
			this.select(this._sel0);
			if (this._fcs === 2) {
				this._last = this._val();
			}
			return this;
		},
		_mode: function (mode, t) {
			var mods;
			if (!mode || t < 1) {
				mode = _aNull(mode) ? ((t > 3) ? 1 : ((t === 1) ? 5 : 0)) : 0;
			} else if (typeof mode !== 'number') {
				mode = mode.toString().toLowerCase();
				if (t > 3) {
					// numeric: -1:text, 0:editModeText, 1:double, 2:float, 3:decimal, 4:long, 5:ulong, 6:int, 7:uint, 8:short, 9:ushort, 10:sbyte, 11:byte
					mods = { 'text': -1, 'editmodetext': 0, 'double': 1, 'float': 2, 'decimal': 3, 'long': 4, 'ulong': 5, 'int': 6, 'uint': 7, 'short': 8, 'ushort': 9, 'sbyte': 10, 'byte': 11 };
				} else if (t > 1) {
					// date: 0:date, 1:editModeText, 2:text
					mods = { 'date': 0, 'editmodetext': 1, 'text': 2 };
				} else if (t > 0) {
					// mask: 0:rawText, 1:rawTextWithRequiredPrompts, 2:rawTextWithAllPrompts, 3:rawTextWithLiterals, 4:rawTextWithRequiredPromptsAndLiterals, 5:allText
					mods = { 'rawtext': 0, 'rawtextwithrequiredprompts': 1, 'rawtextwithallprompts': 2, 'rawtextwithliterals': 3, 'rawtextwithrequiredpromptsandliterals': 4, 'alltext': 5 };
				}
				mode = mods[mode];
				if (_aNull(mode)) {
					mode = -2;
				}
			}
			// numeric: 1:double
			return (mode < -1) ? ((t > 3) ? 1 : 0) : mode;
		},
		// fix dataMode, numeric: adjust maxLength, date: adjust masks
		_fixMode: function (init) {
			var len, format, mask, mask1, mode, t = this._type, o = this.options, val = this._value;
			this._dataMode = mode = this._mode(o.dataMode, t);
			this._maxLen = o.maxLength;
			// mask and date editors
			if (t > 0 && t < 4) {
				if (!o.promptChar) {
					o.promptChar = '_';
				}
				if (!o.padChar) {
					o.padChar = ' ';
				}
				if (!o.emptyChar) {
					o.emptyChar = ' ';
				}
				if (t === 1 && init) {
					t = o.inputMask;
					this._setMask(t || 'CCCCCCCCCC');
				}
			}
			// text and mask editor
			if (t < 2) {
				if (init === 3) {
					this._setVal(val);
				}
				return;
			}
			// date editor
			if (t < 4) {
				format = o.dateInputFormat = o.dateInputFormat || 'date';
				if (!o.yearShift) {
					o.yearShift = 0;
				}
				if (_aNull(o.centuryThreshold)) {
					o.centuryThreshold = 29;
				}
				if (_aNull(o.minNumberOfDateFields)) {
					o.minNumberOfDateFields = 3;
				}
				mask = this._optVal(format + 'Pattern') || format;
				format = o.dateDisplayFormat || format;
				mask1 = this._optVal(format + 'Pattern') || format || mask;
				this._field0IDs = [];
				mask = this._getMask(this._field0IDs, mask, 1);
				this._field1IDs = [];
				this._mask1 = this._getMask(this._field1IDs, mask1);
				if (init === 1) {
					this._date = this._df();
					this._isNull = false;
				}
				// index of spinning field
				this._spinField = -1;
				// days or seconds
				this.d_s = 10;
				this._setMask(mask);
				if (init !== 1 && !this._isNull) {
					this._setVal(this._date, 1);
				}
				return;
			}
			// numeric editors
			// adjust maxLength, numeric mode: 0:text, 1:double, 2:float, 3:decimal
			if (mode > 3 && this._maxLen < 1) {
				// byte
				len = 3;
				// long
				if (mode < 6) {
					len = 19;
				// int
				} else if (mode < 8) {
					len = 10;
				// short
				} else if (mode < 10) {
					len = 5;
				}
				// ((mode + 1) % 2 === 1) means signed data mode
				this._field[0].maxLength = this._maxLen = len + (mode + 1) % 2;
			}
			if (init === 3) {
				this._setVal(val, 1);
			}
			if (!init && (val || val === 0)) {
				// 7-numeric display factor (1-100)
				this._setVal(val / this._prop(7));
			}
		},
		// convert object to number
		// fire: request to fire invalid event (set this._inv)
		_toNum: function (txt, limit, fire) {
			var val, min = null, max = null, invMes, o = this.options, num = txt, len = 0;
			if (typeof txt !== 'number') {
				txt = _str(txt);
				len = txt.length;
				num = parseFloat(this._txtAsNum(txt));
			}
			if (isNaN(num)) {
				num = null;
			} else if (!isFinite(num)) {
				num = (num === Number.NEGATIVE_INFINITY) ? -Number.MAX_VALUE : Number.MAX_VALUE;
			}
			val = limit ? this._limits(num) : num;
			if (fire && (val !== num || (_aNull(val, 1) && len > 0))) {
				fire = _aNull(num, 1) ? ((len === 0) ? 'null' : 'format') : 'limit';
				if (_aNull(num, 1)) {
					if (len === 0) {
						fire = 'null';
						invMes = this._optVal('required', 2);
					} else {
						fire = 'format';
						invMes = this._optVal('number', 2);
					}
				} else {
					fire = 'limit';
					limit = null;
					min = o.minValue;
					if (_aNull(min, 1)) {
						// 10 - minValue
						min = this._prop(10);
						if (!_aNull(min, 1)) {
							if (min !== val) {
								min = null;
							}
						}
					}
					max = o.maxValue;
					if (_aNull(max, 1)) {
						// 11 - maxValue
						max = this._prop(11);
						if (!_aNull(max, 1)) {
							if (max !== val) {
								max = null;
							}
						}
					}
					invMes = _aNull(max, 1) ? this._optVal('min', 2).replace('{0}', min.toString(10)) : (_aNull(min, 1) ? this._optVal('max', 2).replace('{0}', max.toString(10)) : this._optVal('range', 2).replace('{0}', min.toString(10)).replace('{1}', max.toString(10)));
				}
				// set value for argument of invalid event
				this._inv = { value: val, text: txt, reason: fire, message: invMes };
			}
			return val;
		},
		// convert text to number in javascript format
		_txtAsNum: function (txt, dec, min) {
			var ch, len = txt.length;
			if (!dec) {
				// 4-decimal separator
				dec = this._prop(4);
			}
			if (!min) {
				// 3-minus
				min = this._prop(3);
			}
			// filter japanese/arabic characters
			while (len-- > 0) {
				ch = this._jpn(txt.charCodeAt(len), true);
				if (ch) {
					txt = txt.replace(new RegExp(txt.charAt(len), 'g'), ch);
				}
			}
			txt = txt.replace('(', (txt.indexOf(min) < 0) ? '-' : '').replace(this._prop(2), '').replace(new RegExp(min, 'g'), '-');
			// temporary replace decimal separator by \01
			txt = txt.replace(dec, '\x01');
			// only one decimal separator
			ch = txt.indexOf(dec);
			if (ch > 0) {
				txt = txt.substring(0, ch);
			}
			// keep only e, E, -, digits and \01=decimalSeparator
			// note: there is no alternative in regexp, but the ^ flag
			/*jslint regexp:true*/
			txt = txt.replace(/[^0-9\-eE\x01]/gm, '').replace('\x01', '.');
			// validate for one dot
			len = txt.length;
			// validate for one minus
			ch = txt.indexOf('-');
			if (ch >= 0) {
				ch = txt.indexOf('-', ch + 1);
				if (ch + 1 < len && ch > 0) {
					if (ch > 0 && txt.toUpperCase().charAt(ch - 1) !== 'E') {
						txt = txt.substring(0, ch);
					}
				}
				len = txt.length;
				if (txt.toUpperCase().indexOf('E') < 0 && ch + 1 === len) {
					txt = '-' + txt.substring(0, len - 1);
				}
			}
			return (txt === '-' || txt === '.') ? '' : txt;
		},
		_ePow: function (plus) {
			var pow = this.options.scientificFormat,
				len = pow ? pow.length : 0,
				ch = len ? pow.charAt(0) : null;
			return ((ch === 'e' || ch === 'E') && (len === 1 || (len === 2 && pow.charAt(1) === '+'))) ? (plus ? pow : ch) : null;
		},
		// convert object/number to text in display format
		_toTxtNum: function (val, foc, txt, minus, dec, str) {
			// 8-maximum decimals
			var grps, gr0, gr, ch, iL, ePow = this._ePow(), ig = 0, iDec = 0, i = -1, neg = val, maxDec = this._prop(8);
			if (_aNull(txt)) {
				if (_aNull(val, 1)) {
					return '';
				}
				neg = val < 0;
				if (neg) {
					val = -val;
				}
				try {
					txt = ePow ? val.toString(10) : val.toFixed(maxDec);
				} catch (ex) {
					str = txt = _str(val);
				}
				// 3-minus char, 4-decimal separator
				return this._toTxtNum(neg, foc, txt.toUpperCase(), _aNull(minus) ? this._prop(3) : minus, _aNull(dec) ? this._prop(4) : dec, str);
			}
			// number in javascript format (used when val.toFixed failed)
			if (str) {
				txt = this._txtAsNum(txt, dec);
			}
			txt = txt.replace('+', '');
			iL = txt.indexOf('E');
			if (iL > 0) {
				ePow = ePow ? this._ePow(!foc && txt.charAt(iL + 1) !== '-') + txt.substring(iL + 1) : txt.substring(iL);
				txt = txt.substring(0, iL);
			} else {
				ePow = '';
			}
			// build string in requested (focus/display) format
			iL = txt.length;
			if (_aNull(neg)) {
				if (iL === 0) {
					return foc ? txt : '';
				}
				neg = this._isMinus(txt.charCodeAt(0));
				if (neg) {
					txt = txt.substring(1);
					iL--;
				}
			}
			// remove dot
			while (++i < iL) {
				ch = txt.charCodeAt(i);
				if (ch < 48 || ch > 57) {
					txt = txt.substring(0, i) + txt.substring(i + 1);
					iL--;
					break;
				}
			}
			// if dot,remove trailing 0s
			while (i < iL) {
				if (txt.charCodeAt(iL - 1) !== 48) {
					break;
				}
				txt = txt.substring(0, --iL);
			}
			iL = i;
			if (maxDec > 0 && iL < txt.length) {
				iDec = txt.length - iL;
				txt = txt.substring(0, iL) + dec + txt.substring(iL);
				iL += dec.length + maxDec;
			}
			if (iL < txt.length) {
				txt = txt.substring(0, iL);
			}
			// check for 0
			gr = txt.replace(/0/g, '');
			if (neg && (!gr || gr === dec)) {
				neg = false;
			}
			// 9-minimum decimals
			iL = this._prop(9);
			if (iL > 0) {
				if (iDec === 0) {
					txt += dec;
				}
				while (iL-- > iDec) {
					txt += '0';
				}
			}
			if (foc) {
				txt += ePow;
				return neg ? (minus + txt) : txt;
			}
			// 6-groups
			grps = this._prop(6);
			gr = gr0 = (grps.length > 0) ? grps[0] : 0;
			while (gr > 0 && --i > 0) {
				if (--gr === 0) {
					// 5-group separator
					txt = txt.substring(0, i) + this._prop(5) + txt.substring(i);
					gr = grps[++ig];
					if (_aNull(gr) || gr < 1) {
						gr = gr0;
					} else {
						gr0 = gr;
					}
				}
			}
			// format numeric text according to format pattern
			val = this._prop(neg ? 1 : 0).replace('n', txt + ePow);
			// 0-positive pattern, 1-negative pattern, 2-symbol
			return val.replace('$', this._prop(2));
		},
		_prop: function (flag) {
			var min, val, sign, o = this.options, t = this._type, mode = this._dataMode;
			if (flag === 13) {
				o = o.selectionOnFocus;
				return (o === -1 || o === 'select') ? -1 : ((o === 0 || o === 'start') ? 0 : ((o === 1 || o === 'end') ? 1 : 2));
			}
			if (flag === 12) {
				return (o.maxLength > 0) ? o.maxLength : this._maxLen;
			}
			if (flag === 0) {
				return o.positivePattern || ((t === 6) ? this._optVal('percentPositivePattern') : ((t === 5) ? this._optVal('currencyPositivePattern') : 'n'));
			}
			if (flag === 1) {
				val = o.negativePattern || this._optVal((t === 6) ? 'percentNegativePattern' : ((t === 5) ? 'currencyNegativePattern' : 'numericNegativePattern'));
				return val.replace('-', this._prop(3));
			}
			if (flag === 2) {
				val = o.symbol;
				if (!_aNull(val)) {
					return val;
				}
				return (t === 6) ? this._optVal('percentSymbol') : ((t === 5) ? this._optVal('currencySymbol') : '');
			}
			if (flag === 3) {
				return this._optVal('negativeSign') || '-';
			}
			if (flag === 4) {
				return o.decimalSeparator || this._optVal((t === 6) ? 'percentDecimalSeparator' : ((t === 5) ? 'currencyDecimalSeparator' : 'numericDecimalSeparator'));
			}
			if (flag === 5) {
				val = o.groupSeparator;
				if (!_aNull(val)) {
					return val;
				}
				return this._optVal((t === 6) ? 'percentGroupSeparator' : ((t === 5) ? 'currencyGroupSeparator' : 'numericGroupSeparator'));
			}
			if (flag === 6) {
				return o.groups || this._optVal((t === 6) ? 'percentGroups' : ((t === 5) ? 'currencyGroups' : 'numericGroups'));
			}
			if (flag === 7) {
				val = o.displayFactor;
				if (!_aNull(val)) {
					return val;
				}
				return (t === 6) ? this._optVal('percentDisplayFactor') : 1;
			}
			if (flag === 8) {
				// mode: 0:text, 1:double, 2:float, 3:decimal, 4:long, etc.
				if (mode > 3) {
					return 0;
				}
				val = o.maxDecimals;
				if (!_aNull(val)) {
					return val;
				}
				return this._optVal((t === 6) ? 'percentMaxDecimals' : ((t === 5) ? 'currencyMaxDecimals' : 'numericMaxDecimals'));
			}
			if (flag === 9) {
				// mode: 0:text, 1:double, 2:float, 3:decimal, 4:long, etc.
				if (mode > 3) {
					return 0;
				}
				val = o.minDecimals;
				if (!_aNull(val)) {
					return val;
				}
				return this._optVal((t === 6) ? 'percentMinDecimals' : ((t === 5) ? 'currencyMinDecimals' : 'numericMinDecimals'));
			}
			min = flag === 10;
			if (min || flag === 11) {
				val = min ? o.minValue : o.maxValue;
				if (t > 3 && typeof val === 'string') {
					val = parseFloat(val);
				}
				// mode: 0:text, 1:double, 2:float, 3:decimal, 4:long, etc.
				if (!_aNull(val, 1) || t < 4 || mode < 2 || mode === 3 || mode > 11) {
					return val;
				}
				// float
				if (mode === 2) {
					return min ? -3.40282347e38 : 3.40282347e38;
				}
				// byte
				val = 127;
				sign = (mode % 2) === 0;
				if (!sign && min) {
					return 0;
				}
				// long
				if (mode < 6) {
					val = 9223372036854775807;
				// int
				} else if (mode < 8) {
					val = 2147483647;
				// short
				} else if (mode < 10) {
					val = 32767;
				}
				return sign ? (min ? -(val + 1) : val) : (val * 2 + 1);
			}
		},
		_isMinus: function (k) {
			// japanese "'-","-","("
			// _prop: 3-minus, 1-negative pattern
			return k === this._prop(3).charCodeAt(0) || k === 45 || (k === 40 && this._prop(1).indexOf('(') >= 0) || k === 12540 || k === 65293 || k === 65288;
		},
		destroy: function () {
			/* Destroys editor and return base element back to its pre-init state.
				returnType="object" Returns reference to this igEditor.
			*/
			var par, e, b,
				elem = this._element,
				field = this._field,
				elem0 = this.element,
				buts = this._buttons,
				i = buts ? buts.length : 0;
			e = elem ? elem[0] : null;
			if (!field || !e) {
				return this;
			}
			// stop timer, remove drop-downs, unbind events
			this._stopTimer();
			// 3-flag to destroy
			this._doDP(3);
			// 1-flag to destroy
			this._initValidator(1);
			this._listRemove();
			field.unbind(this._evts);
			elem.unbind(this._mEvts);
			// restore layout
			// N.A. 24 October 2012 - Fixing bug #125484 - Unbind touch events from buttons.
			while (i-- > 0) {
				if (buts[i]) {
					buts[i].unbind(this._touchEvts);
				}
			}
			b = (buts && buts[0]) ? buts[0][0] : null;
			if (b && b.parentNode === e) {
				e.removeChild(b);
			}
			b = (buts && buts[1]) ? buts[1][0].parentNode : null;
			if (b && b.parentNode === e) {
				e.removeChild(b);
			}
			// do not call this._field.remove(), because it triggers recursive call to destroy
			if (field[0].parentNode === e) {
				e.removeChild(field[0]);
			}
			if (this._selElem) {
				elem.remove();
			} else if (this._swap) {
				par = e.parentNode;
				par.insertBefore(elem0[0], e);
				par.removeChild(e);
			}
			// restore attributes
			par = this._oldCss;
			for (i in par) {
				if (par.hasOwnProperty(i)) {
					elem0.css(i, par[i]);
				}
			}
			par = this._oldAttr;
			for (i in par) {
				if (par.hasOwnProperty(i)) {
					elem0[0][i] = par[i];
				}
			}
			elem0[0]._ig_oldCss = null;
			//4 June 2014 Bug #170176 Clear cached value for with and height into the destroy method of the editors widget
			if (e._wd) {
				e._wd = null;
			}
			if (e._ht) {
				e._ht = null;
			}
			elem0 = elem = field = this._dp = this._buttons = this._field = this._element = null;
			// N.A. 24 October 2012 - Fixing bug #125484 - Delete touch events object.
			this._evts = this._mEvts = this._touchEvts = this._oldAttr = this._oldCss = this._validator = null;
			$.Widget.prototype.destroy.apply(this, arguments);
			return this;
		}
	});
	$.extend($.ui.igEditor, { version: '14.1.20141.2249' });
	$.ui.igEditor.setDefaultCulture = function (regional) {
		/* Set values for regional options.
			paramType="object" optional="true" Override for regional options.
			If the value of parameter is String, such as "bg", "fr", etc, then editor will attempt to find and use $.ui.regional[param] object.
			Value of object should contain pairs or key:value members.
			If that parameter is string, then editor attempts to call $.datepicker.setDefaults($.datepicker.regional[param]).
		*/
		$.ig.regional = $.ig.regional || {};
		$.ig.regional.defaults = $.extend($.ig._regional, (typeof regional === 'string') ? $.ig.regional[regional] : regional);
		if (regional === 'en' || regional === 'en-US') {
			regional = '';
		}
		if ($.datepicker && $.datepicker.regional && $.datepicker.regional[regional]) {
			$.datepicker.setDefaults($.datepicker.regional[regional]);
		}
	};
	/*
		igTextEditor is a widget based on igEditor.
	*/
	$.widget('ui.igTextEditor', $.ui.igEditor, {
		options: {
			/* type="text|password|multiline|textarea" Sets gets text mode of editor such as: single-line text editor, password editor or multiline editor.
				That option has effect only on initialization and only if base element is not INPUT or TEXTAREA.
				If based element (selector) is TEXTAREA, then it is used as input-field.
				If based element is INPUT, then it is used as input-field.
				text type="string" single line text editor based on INPUT element is created.
				password type="string" editor based on INPUT element is created.
				multiline type="string" multiline editor based on TEXTAREA element is created. 
				textarea type="string" multiline editor based on TEXTAREA element is created. 
			*/
			textMode: null,
			/* type="number" Sets gets maximum length of text which can be entered by user.
				Negative values or 0 disables that behavior.
			*/
			maxLength: 0,
			/* type="string" Sets gets ability to enter only specific characters in input-field from keyboard and on paste.
				Notes:
				If "excludeKeys" option contains same characters as this option, then "excludeKeys" has priority.
				Letters should be set in upper case.
				Making difference between upper and lower case is not supported. */
			includeKeys: null,
			/* type="string" Sets gets ability to prevent entering specific characters from keyboard or on paste.
				Notes:
				If a character is specified in "includeKeys" option also, then "excludeKeys" has priority.
				Letters should be set in upper case.
				Making difference between upper and lower case is not supported. */
			excludeKeys: null,
			/* type="bool" Sets gets ability to convert input characters to upper case (true) or keeps characters as they are (false). That option has effect only while keyboard entries and paste. */
			toUpper: false,
			/* type="bool" Sets gets ability to convert input characters to lower case (true) or keeps characters as they are (false). That option has effect only while keyboard entries and paste. */
			toLower: false,
			/* type="bool" Sets gets case validation. Value of false enables and true disables validation for case of entries to match with items in listItems.
				That option has effect only when "listMatchOnly" or "listAutoComplete" options are enabled. */
			listMatchIgnoreCase: true,
			/* type="bool" Set gets list match.
				Value true enables and false disables validation of keyboard entries to match with items in listItems.
				If that option is enabled and entered text does not match with a part of any item in list, then entry is canceled.
				Notes:
				That option is supported only when the "type" of editor is "text" and it has effect only when listItems is set.
				Partial match can be validated from the beginning of an item or anywhere within an item. That is defined by the "listMatchContains" option.
				Validation can be case sensitive or not and that is defined by the "listMatchIgnoreCase" option. */
			listMatchOnly: false,
			/* type="bool" Sets gets list match contains.
				Value true enables and false disables validation for partial match of entered text anywhere within an item in the listItems or only from the beginning of an item.
				That option has effect only when "listMatchOnly" or "listAutoComplete" options are enabled. */
			listMatchContains: false,
			/* type="bool" Sets gets autocomplete.
				Value true enables and false disables auto-complete functionality to fill value of editor by a partially matching item from the listItems.
				If that option is enabled and entered text does not match with a part of any item in list, then original value is preserved.
				Notes:
				That option is supported only when the "type" of editor is "text" and it has effect only when listItems is set.
				Partial match can be validated from the beginning of an item or anywhere within an item. That is defined by the "listMatchContains" option.
				Validation can be case sensitive or not and that is defined by the "listMatchIgnoreCase" option. */
			listAutoComplete: false
		},
		_create: function () {
			$.ui.igEditor.prototype._create.apply(this, [0]);
		}
	});
	/*
		igMaskEditor is a widget based on igEditor which provides ability to filter end-user entries by predefined mask.
	*/
	$.widget('ui.igMaskEditor', $.ui.igEditor, {
		options: {
			/* type="string" Sets gets ability to enter only specific characters in input-field from keyboard and on paste.
				Notes:
				If "excludeKeys" option contains same characters as this option, then "excludeKeys" has priority.
				Letters should be set in upper case.
				Making difference between upper and lower case is not supported. */
			includeKeys: null,
			/* type="string" Sets gets ability to prevent entering specific characters from keyboard or on paste.
				Notes:
				If a character is specified in "includeKeys" option also, then "excludeKeys" has priority.
				Letters should be set in upper case.
				Making difference between upper and lower case is not supported. */
			excludeKeys: null,
			/* type="bool" Sets gets ability to convert input characters to upper case (true) or keeps characters as they are (false). That option has effect only while keyboard entries and paste. */
			toUpper: false,
			/* type="bool" Sets gets ability to convert input characters to lower case (true) or keeps characters as they are (false). That option has effect only while keyboard entries and paste. */
			toLower: false,
			/* type="bool" Sets gets case validation. Value of false enables and true disables validation for case of entries to match with items in listItems.
				That option has effect only when "listMatchOnly" or "listAutoComplete" options are enabled. */
			listMatchIgnoreCase: true,
			/* type="bool" Set gets list match.
				Value true enables and false disables validation of keyboard entries to match with items in listItems.
				If that option is enabled and entered text does not match with a part of any item in list, then entry is canceled.
				Notes:
				That option is supported only when the "type" of editor is "text" and it has effect only when listItems is set.
				Partial match can be validated from the beginning of an item or anywhere within an item. That is defined by the "listMatchContains" option.
				Validation can be case sensitive or not and that is defined by the "listMatchIgnoreCase" option. */
			listMatchOnly: false,
			/* type="bool" Sets gets list match contains.
				Value true enables and false disables validation for partial match of entered text anywhere within an item in the listItems or only from the beginning of an item.
				That option has effect only when "listMatchOnly" or "listAutoComplete" options are enabled. */
			listMatchContains: false,
			/* type="bool" Sets gets autocomplete.
				Value true enables and false disables auto-complete functionality to fill value of editor by a partially matching item from the listItems.
				If that option is enabled and entered text does not match with a part of any item in list, then original value is preserved.
				Notes:
				That option is supported only when the "type" of editor is "text" and it has effect only when listItems is set.
				Partial match can be validated from the beginning of an item or anywhere within an item. That is defined by the "listMatchContains" option.
				Validation can be case sensitive or not and that is defined by the "listMatchIgnoreCase" option. */
			listAutoComplete: false,
			/* type="string" Sets gets input mask. Mask may include filter-flags and literal characters.
				Literal characters are part of mask which cannot be modified by end user. In order to use a filter-flag as a literal character, the escape "\\" character should be used.
				Default is "CCCCCCCCCC"
				Note: optional flags/entries affect the value returned by get of the "value" and "text" methods.
				List of filter-flags:
				C: any keyboard character. Entry is optional.
				&: any keyboard character. Entry is required.
				a: letter or digit character. Entry is optional.
				A: letter or digit character. Entry is required.
				?: letter character. Entry is optional.
				L: letter character. Entry is required.
				9: digit character. Entry is optional.
				0: digit character. Entry is required.
				#: digit character or "+" or "_". Entry is optional with replacement by "emptyPositionChar" or by "padChar".
				>: all letters to the right are converted to the upper case. In order to disable conversion, the ">" flag should be used again.
				<: all letters to the right are converted to the lower case. In order to disable conversion, the "<" flag should be used again.
			*/
			inputMask: 'CCCCCCCCCC',
			/* type="string" Sets gets character which is used as prompt in edit mode for available entry position.  */
			promptChar: '_',
			/* type="string" Sets gets character which is used as replacement of not-filled required position in mask when editor is in display mode (not focused).  */
			padChar: ' ',
			/* type="string" Sets gets character which is used as replacement of not-filled required position in mask when application calls get for the "value" or for the "text" methods. */
			emptyChar: ' ',
			/* type="rawText|0|rawTextWithRequiredPrompts|1|rawTextWithAllPrompts|2|rawTextWithLiterals|3|rawTextWithRequiredPromptsAndLiterals|4|allText|5" Sets gets type of value returned by the get of value() method. That also affects functionality of the set value(val) method and the copy/paste operations of browser.
				rawText type="string" only entered text. All unfilled prompts (positions) and literals are ignored (removed). Note: that is used as default.
				0 type="number" only entered text. All unfilled prompts (positions) and literals are ignored (removed). Note: that is used as default.
				rawTextWithRequiredPrompts type="string" only entered text and required prompts (positions). All optional unfilled prompts and literals are ignored (removed)
				1 type="number" only entered text and required prompts (positions). All optional unfilled prompts and literals are ignored (removed).
				rawTextWithAllPrompts type="string" only entered text and prompts (positions). All literals are ignored (removed).
				2 type="number" only entered text and prompts (positions). All literals are ignored (removed).
				rawTextWithLiterals type="string" only entered text and literals. All unfilled prompts are ignored (removed).
				3 type="number" only entered text and literals. All unfilled prompts are ignored (removed).
				rawTextWithRequiredPromptsAndLiterals type="string" only entered text, required prompts (positions) and literals. All optional unfilled prompts are ignored (removed).
				4 type="number" only entered text, required prompts (positions) and literals. All optional unfilled prompts are ignored (removed).
				allText type="string" entered text, all prompts (positions) and literals.
				5 type="number" entered text, all prompts (positions) and literals.
			*/
			dataMode: 'alltext',
			/* type="bool" Set gets ability to hide mask in focus state.
				Value of false allows to show all input mask with prompt characters regardless if available mask positions are filled or not.
				Value of true will show only part of mask located on the left side from caret when available mask positions on the right side from caret are empty.
			*/
			hideMaskOnFocus: false
		},
		_create: function () {
			$.ui.igEditor.prototype._create.apply(this, [1]);
		}
	});
	/*
		igDateEditor is a widget based on igEditor, which provides ability to edit date and time fields.
		Date and time patterns are defined by the regional settings and can be customized using following setters:
		
		$.ig.setRegionalDefault(regional);
		$.ui.igEditor.setDefaultCulture(regional);

		where "regional" can be name of culture like 'en-US', 'ja', 'fr', etc. Or object, which contains pairs of key:value members.
		Note: if parameter is string, then igEditor will attempt to find and use "$.ig.regional[regional]".
		By default the "$.ig._regional" object is used and it is located in "ig.util.js".

		It is also possible to customize a specific value only:
		$.ig.regional.defaults.datePattern = "M-dd-yyyy";
		$.ig.regional.defaults.monthNamesShort[1] = "Febr";
	*/
	$.widget('ui.igDateEditor', $.ui.igEditor, {
		options: {
			/* type="object" Sets gets custom regional settings for editor. If it is string, then $.ig.regional[stringValue] is assumed. */
			regional: null,
			/* type="bool" Sets gets ability to modify only 1 date field on spin events.
				Value false enables changes of other date fields when incremented or decremented date-field reaches its limits.
				Value true modifies only value of one field.
			*/
			spin1Field: false,
			/* type="date" Sets gets the minimum value which can be entered in editor by user.*/
			minValue: null,
			/* type="date" Sets gets the maximum value which can be entered in editor by user. */
			maxValue: null,
			/* type="string"
				Sets gets format of date while editor has no focus.
				Value of that option can be set to a specific date pattern or to a flag defined by regional settings.
				If value is not set, then the dateInputFormat is used automatically.
				If value is set to explicit date pattern and pattern besides date-flags has explicit characters which match with date-flags or mask-flags, then the "escape" character should be used in front of them. 
				List of predefined regional flags:
				"date": the datePattern member of regional option is used
				"dateLong": the dateLongPattern member of regional option is used
				"time": the timePattern member of regional option is used
				"timeLong": the timeLongPattern member of regional option is used
				"dateTime": the dateTimePattern member of regional option is used
				List of explicit characters, which should have escape \\ character in front of them:
					C, &, a, A, ?, L, 9, 0, #, >, <, y, M, d, h, H, m, s, t, f.
				List of date-flags when explicit date pattern is used:
				"y": year field without century and without leading zero
				"yy": year field without century and with leading zero
				"yyyy": year field with leading zeros
				"M": month field as digit without leading zero
				"MM": month field as digit with leading zero
				"MMM": month field as short month name
				"MMMM": month field as long month name
				"d": day of month field without leading zero 
				"dd": day of month field with leading zero
				"ddd": day of the week as short name
				"dddd": day of the week as long name
				"t": first character of string which represents AM/PM field 
				"tt": 2 characters of string which represents AM/PM field
				"h": hours field in 12-hours format without leading zero
				"hh": hours field in 12-hours format with leading zero
				"H": hours field in 24-hours format without leading zero
				"HH": hours field in 24-hours format with leading zero
				"m": minutes field without leading zero
				"mm": minutes field with leading zero
				"s": seconds field without leading zero
				"ss": seconds field with leading zero
				"f": milliseconds field in thousands
				"ff": milliseconds field in hundreds
				"fff": milliseconds field
			*/
			dateDisplayFormat: null,
			/* type="string"
				Sets gets format of date while editor has focus.
				Value of that option can be set to explicit date pattern or to a flag defined by regional settings.
				If value is set to explicit date pattern and pattern besides date-flags has explicit characters which match with date-flags or mask-flags, then the "escape" character should be used in front of them.
				If option is not set, then the "date" is used automatically.
				List of predefined regional flags:
				"date": the datePattern member of regional option is used
				"dateLong": the dateLongPattern member of regional option is used
				"time": the timePattern member of regional option is used
				"timeLong": the timeLongPattern member of regional option is used
				"dateTime": the dateTimePattern member of regional option is used
				List of explicit characters, which should have escape \\ character in front of them: C, &, a, A, ?, L, 9, 0, #, >, <, y, M, d, h, H, m, s, t, f.
				List of date-flags when explicit date pattern is used:
				"y": year field without century and without leading zero
				"yy": year field without century and with leading zero
				"yyyy": year field with leading zeros
				"M": month field as digit without leading zero
				"MM": month field as digit with leading zero
				"MMM": month field as short month name. Note: in focused state the MM is used.
				"MMMM": month field as long month name. Note: in focused state the MM is used.
				"d": day of month field without leading zero 
				"dd": day of month field with leading zero
				"ddd": day of the week as short name. Note: in focused state that field is skipped.
				"dddd": day of the week as long name. Note: in focused state that field is skipped.
				"t": first character of string which represents AM/PM field 
				"tt": 2 characters of string which represents AM/PM field
				"h": hours field in 12-hours format without leading zero
				"hh": hours field in 12-hours format with leading zero
				"H": hours field in 24-hours format without leading zero
				"HH": hours field in 24-hours format with leading zero
				"m": minutes field without leading zero
				"mm": minutes field with leading zero
				"s": seconds field without leading zero
				"ss": seconds field with leading zero
				"f": milliseconds field in thousands
				"ff": milliseconds field in hundreds
				"fff": milliseconds field
			*/
			dateInputFormat: null,
			/* type="string" Sets gets character which is used as prompt in edit mode for available entry position. Default is "_" */
			promptChar: '_',
			/* type="date|0|editModeText|1|text|2" Sets gets type of value returned by the get of value() method. That also affects functionality of the set value(val) method and the copy/paste operations of browser.
				date type="string" The Date object is used. Note: that is used as default.
				0 type="number" The Date object is used. Note: that is used as default.
				editModeText type="string" The String object is used and the "text" in edit mode (focus) format (pattern).
				1 type="number" The String object is used and the "text" in edit mode (focus) format (pattern).
				text type="string" The String object is used and the "text" in display mode (no focus) format (pattern).
				2 type="number" The String object is used and the "text" in display mode (no focus) format (pattern).
			*/
			dataMode: 'date',
			/* type="number" Sets gets the minimum number of date fields, which makes entered date-string valid.
				All missing fields are automatically filled up from the previous valid date or with zeros or with the values from the today date.
				For example, if "dateInputPattern" is set to "yyyy/MM/dd hh:mm" and user entered only the first 3 fields (year, month, day), then values for hours and minutes are filled with zeros. */
			minNumberOfDateFields: 3,
			/* type="bool" Set gets ability to use last valid date when user entered invalid value.
				Value of true allows automatically use last valid date, when editor loses focus and user failed to enter a valid date.
				In case of value false, the entered date is considered invalid and null is used.
			*/
			useLastGoodDate: false,
			/* type="bool" Sets gets ability to decrease day of month.
				Value of true allows decreasing day of month, when editor loses focus and user entered day of month which is larger the maximum for that particular month.
				Value of false will automatically increment month and decrease day of month.
				Examples.
				If that option is true and user entered "09/31/2010", then on lost focus that string will be converted to "09/30/2010".
				If that option is false, then in similar situation the string will be converted to "10/01/2010". */
			reduceDayOfInvalidDate: true,
			/* type="bool" Sets gets ability to hide mask in focus state.
				Value of true allows showing or hiding all input mask with prompt characters regardless if available mask positions are filled or not.
				Value of true will show only part of mask located on the left side from caret when available mask positions on the right side from caret are empty.  */
			hideMaskOnFocus: false,
			/* type="number" Sets gets year for auto detection of 20th and 21st centuries.
				That option is used to automatically fill century when the user entered only 1 or 2 digits into the year field or when the date pattern contains only 1 or 2 year positions, e.g. "yy" or "y".
				If user entered value larger than value of this option, then 20th century is used, otherwise the 21st. */
			centuryThreshold: 29,
			/* type="bool" Sets gets formatting of the dates as UTC.
				That option is supported only when dataMode option is 'date' and Date objects are used to get/set value of editor.
				Notes:
				That option affects only functionality of get/set value method and the Date-value, which was set on initialization.
				When application uses the set-value, then internal Date-value and displayed-text is incremented by TimezoneOffset.
				When application uses the get-value, then editor returns internal Date-value decremented by TimezoneOffset.
				When that option is modified after initialization, then displayed text and internal Date-value are not affected.
				It is not recommended to change that option without resetting Date-value.
			*/
			enableUTCDates: false,
			/* type="number" Sets gets delta-value which is used to increment or decrement the value of field where caret is located is modified. */
			spinDelta: 1,
			/* type="bool" Sets gets ability to prevent null value.
				If that option is disabled, and editor has no value, then value is set to today date (or minValue/maxValue).
			*/
			nullable: true,
			/* type="number" Sets gets difference between year in Gregorian calendar and displayed year. */
			yearShift: 0
		},
		_create: function () {
			$.ui.igEditor.prototype._create.apply(this, [2]);
		}
	});
	/*
		igDatePicker is a widget based on igDateEditor, which provides ability to edit date and time fields and show drop-down calendar.
		Note: the calendar implemented by the "jquery.ui.datepicker" is used as drop-down calendar. It means that "datepicker" should be available on client.

		If application modifies regional settings using string-parameter in methods:
		$.ig.setRegionalDefault(regional);
		$.ui.igEditor.setDefaultCulture(regional);
		
		then igEditor attempts to call following method:		
		$.datepicker.setDefaults($.datepicker.regional[regional]);
	*/
	$.widget('ui.igDatePicker', $.ui.igDateEditor, {
		options: {
			/* type="dropdown|clear|spin" Sets gets visibility of spin and drop-down button.
			That option can be set only on initialization.
			dropdown type="string" Button to open list is located on the right side of input-field (or left side if base html element has direction:rtl)
			clear type="string" Button to clear value is located on the right side of input-field (or left side if base html element has direction:rtl)
			spin type="string" Spin buttons are located on the right side of input-field (or left side if base html element has direction:rtl) */
			button: 'dropdown',
			/* type="bool" Sets gets ability to automatically focus the input, when a calendar is opened.
				Possible values:
				true - keep focus in INPUT field (touch devices might pop-up keyboard when calendar is opened)
				false - prevent focus in INPUT field when calendar is opened (touch devices should not show keyboard)
				null - attempt to detect touch/mobile device and prevent focus in INPUT field when calendar is opened
			*/
			focusOnDropDownOpen: null,
			/* type="object" Sets gets options supported by the jquery.ui.datepicker. Only options related to drop-down calendar are supported. */
			datepickerOptions: null
		},
		_create: function () {
			$.ui.igEditor.prototype._create.apply(this, [3]);
		}
	});
	/*
		igNumericEditor is a widget based on igEditor, which provides ability to edit number.
		Numeric patterns are defined by the regional settings and can be customized using following setters:
		
		$.ig.setRegionalDefault(regional);
		$.ui.igEditor.setDefaultCulture(regional);
		
		where "regional" can be name of culture like 'en-US', 'ja', 'fr', etc. Or object, which contains pairs of key:value members.
		Note: if parameter is string, then igEditor will attempt to find and use "$.ig.regional[regional]".
		By default the "$.ig._regional" object is used and it is located in "ig.util.js".

		It is also possible to customize a specific value only:
		$.ig.regional.defaults.numericMaxDecimals = 4;
		$.ig.regional.defaults.numericNegativePattern = "(-$n)";
	*/
	$.widget('ui.igNumericEditor', $.ui.igEditor, {
		options: {
			/* type="object" Sets gets custom regional settings for editor. If it is string, then $.ig.regional[stringValue] is assumed. */
			regional: null,
			/* type="string" Sets gets the pattern for negative numeric values, which is used in display (no focus) state.
				The "n" flag represents the value of number. The "-" and "()" flags are static part of pattern.
				Note: this option has priority over possible regional settings. */
			negativePattern: null,
			/* type="string" Sets gets the character, which is used for negative numeric values.
				Note: this option has priority over possible regional settings. */
			negativeSign: null,
			/* type="string" Sets gets the character, which is used as decimal separator.
				Note: this option has priority over possible regional settings. */
			decimalSeparator: null,
			/* type="string" Sets gets the character, which is used as separator for groups (like thousands).
				That option has effect only in display (no focus) state.
				Note: this option has priority over possible regional settings. */
			groupSeparator: null,
			/* type="object" (array of number objects) Sets gets the number of digits in integer part of number, which are divided into groups.
				The "numericGroupSeparator" is inserted between groups.
				If the sum of all values in array is smaller than the length of integer part, then the last item in array is used for all following groups.
				Count of groups starts from the decimal point (from right to left).
				That option has effect only in display (no focus) state.
				Note: this option has priority over possible regional settings. */
			groups: null,
			/* type="number" Sets gets the maximum number of decimal places which are used in display (no focus) state.
				Note: this option has priority over possible regional settings. */
			maxDecimals: null,
			/* type="number" Sets gets the minimum number of decimal places which are used in display (no focus) state.
				If number of digits in fractional part of number is less than the value of this option, then the "0" characters are used to fill missing digits.
				Note: this option has priority over possible regional settings. */
			minDecimals: null,
			/* type="number" Sets gets the minimum value which can be entered in editor by end user. */
			minValue: null,
			/* type="number" Sets gets the maximum value which can be entered in editor by end user. */
			maxValue: null,
			/* type="null|E|e|E+|e+"
			Sets gets support for E-power format in edit mode.
			If that option is set, then numeric value appears as a string with possible E-power flag. In edit mode the "E" or "e" character can be entered as well.
			Notes: The "+" character is not supported in edit mode. The minimum and maximum number of decimal places are applied to the string which appears in front of E-part of string.
			null type="object" scientific format is disabled.
			E type="string" scientific format is enabled and the "E" character is used.
			e type="string" scientific format is enabled and the "e" character is used.
			E+ type="string" scientific format is enabled and the "E" character is used. The "E+" is used for positive values in display mode.
			e+ type="string" scientific format is enabled and the "e" character is used. The "e+" is used for positive values in display mode.
			*/
			scientificFormat: null,
			/* type="number" Sets gets the representation of null value.  */
			nullValue: null,
			/* type="number" Sets gets delta-value which is used to increment or decrement value in editor on spin events. */
			spinDelta: 1,
			/* type="bool" Sets gets ability to prevent null value.
				If that option is disabled, and editor has no value, then value is set to 0 (or minValue/maxValue).
			*/
			nullable: true,
			/* type="number" Sets gets maximum length of text which can be entered by user.
				Negative values or 0 disables that behavior.
			*/
			maxLength: 0,
			/* type="text|-1|editModeText|0|double|1|float|2|decimal|3|long|4|ulong|5|int|6|uint|7|short|8|ushort|9|sbyte|10|byte|11" Sets gets type of value returned by the get of value() method. That also affects functionality of the set value(val) method and the copy/paste operations of browser.
				text type="string" the String object is used with 'text' in display mode format.
				-1 type="number"
				editModeText type="string" the String object is used with 'text' in edit mode format.
				0 type="number"
				double type="string" the Number object is used with limits of double and if value is not set, then the null or Number.NaN is used depending on the option 'nullable'. Note: that is used as default.
				1 type="number"
				float type="string" the Number object is used with limits of double and if value is not set, then the null or Number.NaN is used depending on the option 'nullable'.
				2 type="number"
				decimal type="string" the Number object is used with limits of double and if value is not set, then the null or 0 is used depending on the option 'nullable'.
				3 type="number"
				long type="string" the Number object is used with limits of signed long and if value is not set, then the null or 0 is used depending on the option 'nullable'. 
				4 type="number"
				ulong type="string" the Number object is used with limits of unsigned long and if value is not set, then the null or 0 is used depending on the option 'nullable'.
				5 type="number"
				int type="string" the Number object is used with limits of signed int and if value is not set, then the null or 0 is used depending on the option 'nullable'.
				6 type="number"
				uint type="string" the Number object is used with limits of unsigned int and if value is not set, then the null or 0 is used depending on the option 'nullable'.
				7 type="number"
				short type="string" the Number object is used with limits of signed short and if value is not set, then the null or 0 is used depending on the option 'nullable'.
				8 type="number"
				ushort type="string" the Number object is used with limits of unsigned short and if value is not set, then the null or 0 is used depending on the option 'nullable'.
				9 type="number"
				sbyte type="string" the Number object is used with limits of signed byte and if value is not set, then the null or 0 is used depending on the option 'nullable'.
				10 type="number"
				byte type="string" the Number object is used with limits of unsigned byte and if value is not set, then the null or 0 is used depending on the option 'nullable'.
				11 type="number"
			*/
			dataMode: 'double'
		},
		_create: function () {
			$.ui.igEditor.prototype._create.apply(this, [4]);
		}
	});
	/*
		igCurrencyEditor is a widget based on igNumericEditor, which provides ability to edit number in currency format.
	*/
	$.widget('ui.igCurrencyEditor', $.ui.igNumericEditor, {
		options: {
			/* type="string" Sets gets the pattern for positive numeric values, which is used in display (no focus) state.
				The "$" flag represents "numericSymbol" and the "n" flag represents the value of number.
				Note: this option has priority over possible regional settings. */
			positivePattern: null,
			/* type="string" Sets gets the pattern for negative numeric values, which is used in display (no focus) state.
				The "$" flag represents "numericSymbol".
				The "n" flag represents the value of number.
				The "-" and "()" flags are static part of pattern.
				Note: this option has priority over possible regional settings. */
			negativePattern: null,
			/* type="string" Sets gets symbol, which is used in display (no focus) state.
				Note: this option has priority over possible regional settings. */
			symbol: null
		},
		_create: function () {
			$.ui.igEditor.prototype._create.apply(this, [5]);
		}
	});
	/*
		igPercentEditor is a widget based on igNumericEditor, which provides ability to edit number in percent format.
	*/
	$.widget('ui.igPercentEditor', $.ui.igNumericEditor, {
		options: {
			/* type="string" Sets gets the pattern for positive numeric values, which is used in display (no focus) state.
				The "$" flag represents "numericSymbol" and the "n" flag represents the value of number.
				Note: this option has priority over possible regional settings. */
			positivePattern: null,
			/* type="string" Sets gets the pattern for negative numeric values, which is used in display (no focus) state.
				The "$" flag represents "numericSymbol".
				The "n" flag represents the value of number.
				The "-" and "()" flags are static part of pattern.
				Note: this option has priority over possible regional settings. */
			negativePattern: null,
			/* type="string" Sets gets symbol, which is used in display (no focus) state.
				Note: this option has priority over possible regional settings. */
			symbol: null,
			/* type="number" Sets gets the factor which used for the get and set of the "value" method.
				On the get number (string) entered by user is divided by that factor and on the set the number (string) displayed in editor is multiplied by that factor.
				For example, if factor is 100 and the "value" is set to 0.123, then editor will show string "12.3".
				Possible values: 1, 10, 100, 1000, 10000, 100000, etc.
				Note: this option has priority over possible regional settings. */
			displayFactor: null
		},
		_create: function () {
			$.ui.igEditor.prototype._create.apply(this, [6]);
		}
	});
}(jQuery));







/*!@license
 * Infragistics.Web.ClientUI Tree 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *  jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	jquery.ui.draggable.js
 *	jquery.ui.droppable.js
 *	infragistics.templating.js
 *	infragistics.dataSource.js
 *  infragistics.ui.shared.js
 *	infragistics.util.js
 *	infragistics.ui.tree-en.js
 */

/*global jQuery */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {
    /*
		igTree is a widget based on jQuery UI that loads hierarchical data and visualizes it in the form of a 
		tree and providers the end user with a rich interaction functionality including the ability to expand/collapse 
		child data, node selection, checkboxes, node images, etc. The igTree supports performance optimization for large 
		data sources via load on demand. The igTree can be bound to various types of data such as JSON, XML, Remote data 
		providers, etc.
	*/
	$.widget('ui.igTree', {
		_const: {
			dragCursorAt: {
				top: -10,
				left: -10
			}
		},
		css: {
			/* classes applied to the top container element */
			tree: 'ui-widget ui-igtree',
			/* class applied to the node collection element */
			treeCollection: 'ui-igtree-collection',
			/* class applied to every node element in the tree */
			treeNode: 'ui-igtree-node',
			/* class applied to the root ul element in the tree */
			treeRoot: 'ui-igtree-root ui-widget-content',
			/* class applied to every node element that is a root node in the tree */
			treeRootNode: 'ui-igtree-noderoot',
			/* class applied nodes that have no children and thus no expander image */
			nodeNoChildren: 'ui-igtree-node-nochildren',
			/* class applied to nodes that have children */
			parentNode: 'ui-igtree-parentnode',
			/* classes defining the css sprite icon for collapsed node */
			collapseIcon: 'ui-icon ui-icon-triangle-1-s',
			/* classes defining the css sprite icon for expanded node */
			expandIcon: 'ui-icon ui-icon-triangle-1-e',
			/* class applied to the expand/collapse node container */
			nodeExpander: 'ui-igtree-expander',
			/* class defining the default state style of the node */
			nodeNormal: 'ui-state-default',
			/* class defining the highlight state style of the node */
			nodeHightlight: 'ui-state-highlight',
			/* class defining the hover state style of the node */
			nodeHovered: 'ui-state-hover',
			/* class defining the selected state style of the node */
			nodeSelected: 'ui-state-active',
			/* class defining the focus state style of the node */
			nodeActive: 'ui-state-focus',
			/* classes applied to the checkbox container */
			checkbox: 'ui-state-default ui-corner-all ui-igcheckbox-normal',
			/* classes defining the unchecked state of the checkbox */
			checkboxOff: 'ui-icon ui-icon-check ui-igcheckbox-normal-off',
			/* classes defining the checked state of the checkbox */
			checkboxOn: 'ui-icon ui-icon-check ui-igcheckbox-normal-on',
			/* classes defining the partially checked state of the checkbox */
			checkboxPartial: 'ui-icon ui-icon-check ui-state-disabled ui-igcheckbox-normal-on',
			/* classes applied to the invalid drop indicator container */
			invalidDropIndicator: 'ui-widget ui-igtree-dropindicator ui-state-error ui-corner-all',
			/* classes applied to the drop indicator container */
			dropIndicator: 'ui-widget ui-igtree-dropindicator ui-state-highlight ui-corner-all',
			/* classes defining the move to drop indicator icon */
			moveMarkupIcon: 'ui-icon ui-icon-arrowthick-1-e',
			/* classes defining the invalid move to drop indicator icon */
			invalidMoveMarkupIcon: 'ui-icon ui-icon-cancel',
			/* classes defining the copy drop indicator icon */
			copyMarkupIcon: 'ui-icon ui-icon-plus',
			/* classes applied to the insert line container */
			insertLine: 'ui-state-default ui-igtree-insertline'
		},
        options: {
			/* type="string|number|null Gets sets how the width of the control can be set."
                string The widget width can be set in pixels (px) and percentage (%).
                number The widget width can be set as a number in pixels.
                null type="object" will stretch to fit data, if no other widths are defined.
            */
			width: null,
			/* type="string|number|null Gets sets how the height of the control can be set."
                string The height width can be set in pixels (px) and percentage (%).
                number The height width can be set as a number in pixels.
                null type="object" will fit the tree inside its parent container, if no other widths are defined.
            */
			height: null,
			/* type="off|biState|triState" Gets the type of checkboxes rendered before the tree nodes. Can be set only at initialization.
				off type="string" Checkboxes are turned off and not rendered for the tree.
				biState type="string" Checkboxes are rendered and support two states (checked and unchecked). Checkboxes do not cascade down or up in this mode.
				triState type="string" Checkboxes are rendered and support three states (checked, partial and unchecked). Checkboxes cascade up and down in this mode.
            */
			checkboxMode: 'off',
			/* type="bool" If set to true then only one branch at each level of the tree can be expanded at a time. Otherwise multiple branches can be expanded at a time. */
			singleBranchExpand: false,
			/* type="bool" Setting this option to false would make the tree to not apply hover styles on the nodes when they are hovered */
			hotTracking: true,
			/* type="string"
				string Image with the specified URL will be rendered for each node that has children (If you define both image URL and class the URL would be rendered).
				null Option is ignored
            */
			parentNodeImageUrl: null,
			/* type="string"
				string Specified class with a CSS sprite would be rendered for each node that has children (If you define both image URL and class the URL would be rendered).
				null Option is ignored
            */
			parentNodeImageClass: null,
			/* type="string"
				string Specified a tooltip that would be rendered for each node that has children.
				null Option is ignored
            */
			parentNodeImageTooltip: null,
			/* type="string"
				string Image with the specified URL will be rendered for each node that has no children (If you define both image URL and class the URL would be rendered).
				null Option is ignored
            */
			leafNodeImageUrl: null,
			/* type="string"
				string Specified class with a CSS sprite would be rendered for each node that has no children (If you define both image URL and class the URL would be rendered).
				null Option is ignored
            */
			leafNodeImageClass: null,
			/* type="string"
				string Specified a tooltip that would be rendered for each node that has no children.
				null Option is ignored
            */
			leafNodeImageTooltip: null,
			/* type="number" Specifies the duration of each animation such as the expand/collapse. */
			animationDuration: 200,
			/* type="string" Specifies the node data-path separator character. */
			pathSeparator: '_',
			/* type="object" Specifies any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself. */
			dataSource: null,
			/* type="string" Specifies a remote URL accepted by $.ig.DataSource in order to request data from it */
			dataSourceUrl: null,
			/* type="string" Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property. */
			dataSourceType: null,
			/* type="string" see $.ig.DataSource. 
				string Specifies the name of the property in which data records are held if the response is wrapped. 
				null Option is ignored.
			*/
			responseDataKey: null,
			/* type="string" 
				string Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property.
				null Option is ignored.
			*/
			responseDataType: null,
			/* type="string" specifies the HTTP verb to be used to issue the request */
			requestType: "GET",
			/* type="string" content type of the response. See http://api.jquery.com/jQuery.ajax/ => contentType */
			responseContentType: null,
			/* type="number" Specifies the depth down to which the tree would be expanded upon initial render. */
			initialExpandDepth: -1,
			/* type="bool" Specifies all the data would be bound initially or each child collection would be bound upon demand. */
			loadOnDemand: false,
			/* type="object" Specifies the data binding properties and keys. */
			bindings: {
				/* type="string" Specifies the name of the data source property the value of which would be the node text. */
				textKey: 'Text',
				/* type="string" Specifies the XPath to the text attribute/node. Used in client-only binding directly to XML. */
				textXPath: '@Text',
				/* type="string" Specifies the name of the data source property the value of which would be the node value. */
				valueKey: 'Value',
				/* type="string" Specifies the XPath to the value attribute/node. Used in client-only binding directly to XML. */
				valueXPath: '@Value',
				/* type="string" Specifies the name of the data source property the value of which would be used as a URL 
								for the node image. 
				*/
				imageUrlKey: 'ImageUrl',
				/* type="string" Specifies the XPath to the image URL attribute/node. Used in client-only binding directly to XML. */
				imageUrlXPath: '@ImageUrl',
				/* type="string" Specifies the name of the data source property the value of which would be used as an href 
								attribute for the node anchor. 
				*/
				navigateUrlKey: 'NavigateUrl',
				/* type="string" Specifies the XPath to the navigate URL attribute/node. Used in client-only binding directly to XML. */
				navigateUrlXPath: '@NavigateUrl',
				/* type="string" Specifies the name of the data source property the value of which would be used as a target
								attribute for the node anchor. 
				*/
				targetKey: 'Target',
				/* type="string" Specifies the name of the data source property the value of which would indicate that the 
								node is expanded on initial load. 
				*/
				expandedKey: 'Expanded',
				/* type="string" Specifies the name of the data source property the value of which is the primary key attribute
								for the data. This property is used when load on demand is enabled and if specified the node paths
								would be generated using primary keys instead of indices.
				*/
				primaryKey: null,
				/* type="string" Specifies the node content template for the current layer of bindings. The igTree utilizes jQuery
								templating for generating node content templates. Please refer to http://api.jquery.com/jquery.tmpl/
								for more information.
				*/
				nodeContentTemplate: null,
				/* type="string" Specifies the name of the data source property that holds the child data of the current layer node. */
				childDataProperty: 'Nodes',
				/* type="string" Specifies the XPath to the child data node. Used in client-only binding directly to XML. */
				childDataXPath: 'Children',
				/* type="string" Specifies the XPath to the root data node. Used in client-only binding directly to XML. */
				searchFieldXPath: 'Nodes',
				/* type="object" Specifies the next layer of bindings in a recursive fashion. */
				bindings: {
					/* Recursively defines next layer fo bindings */
				}
			},
			/* type="string" Specifies the default target of the node anchor. */
			defaultNodeTarget: '_self',
			/* type="boolean" If set to true it would enable drag and drop functionality. */
			dragAndDrop: false,
			/* type="string" URL to which updating requests will be made. */
			updateUrl: null,
			/* type="object" Specific settings for the drag and drop functionality. */
			dragAndDropSettings: {
				/* type="boolean" Specifies whether the widget will accept D&D from other controls. boolean. Default value is false. */
				allowDrop: false,
				/* type="default|copy|move" Specifies the D&D mode. Accepted values "default", "copy", "move". Where "default" is "copy" 
											when Ctrl key is hold, else it means "move". Just like in Windows explorer. 
											None means the tree does not accept this node.  
				*/
				dragAndDropMode: 'default',
				/* type="number" Specifies the opacity of the drag helper: 0 is fully transparent while 1 is fully opaque. 
				*/
				dragOpacity: 0.75,
				/* type="boolean" Specifies whether the helper would revert to its original position upon an invalid drop. 
				*/
				revert: true,
				/* type="number" Specifies the duration of the revert animation. 
				*/
				revertDuration: 500,
				/* type="number" Specifies z-index that would be set for the drag helper. 
				*/
				zIndex: 10,
				/* type="number" Specifies the delay between mousedown and the start of the actual drag. Smaller values make the nodes 
									more sensitive to drag.
				*/
				dragStartDelay: 200,
				/* type="boolean" Specifies whether when dragging over a collapsed node with children the node will expand after
									the timeout specified in the expandDelay option.
				*/
				expandOnDragOver: true,
				/* type="number" Specifies the delay after hovering a parent node before it expands to show its children during drag.
				*/
				expandDelay: 1000,
				/* type="string|function" Specifies the helper for the drag operation. 'default' would render the internal helper,
											while a function returning a jQuery element can build entirely custom helper.
				*/
				helper: 'default',
				/* type="function" Returning true from this function would render the drop point valid, while false would make it invalid.
									The function has one parameter which is the current drop point and the context of the function is the
									drag element.
				*/
				customDropValidation: null,
				/* type="boolean|selector|element|string|array" Specifies the containment for the drag helper. The area inside of which the 
									helper is contained would be scrollable while dragging.
				*/
				containment: false,
				/* type="string" Specifies the HTML markup for the invalid helper.
				*/
				invalidMoveToMarkup: '<div><p><span></span><strong>{0}</strong></p></div>',
				/* type="string" Specifies the HTML markup for the "move to" helper.
				*/
				moveToMarkup: '<div><p><span></span><strong>Move to</strong> {0}</p></div>',
				/* type="string" Specifies the HTML markup for the "move between" helper.
				*/
				moveBetweenMarkup: '<div><p><span></span><strong>Move between</strong> {0} and {1}</p></div>',
				/* type="string" Specifies the HTML markup for the "move after" helper.
				*/
				moveAfterMarkup: '<div><p><span></span><strong>Move after</strong> {0}</p></div>',
				/* type="string" Specifies the HTML markup for the "move before" helper.
				*/
				moveBeforeMarkup: '<div><p><span></span><strong>Move before</strong> {0}</p></div>',
				/* type="string" Specifies the HTML markup for the "copy to" helper.
				*/
				copyToMarkup: '<div><p><span></span><strong>Copy to</strong> {0}</p></div>',
				/* type="string" Specifies the HTML markup for the "copy between" helper.
				*/
				copyBetweenMarkup: '<div><p><span></span><strong>Copy between</strong> {0} and {1}</p></div>',
				/* type="string" Specifies the HTML markup for the "copy after" helper.
				*/
				copyAfterMarkup: '<div><p><span></span><strong>Copy after</strong> {0}</p></div>',
				/* type="string" Specifies the HTML markup for the "copy before" helper.
				*/
				copyBeforeMarkup: '<div><p><span></span><strong>Copy before</strong> {0}</p></div>'
			}
        },
		events: {
			/* cancel="false" fired before databinding is performed 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tree performing databinding.
			*/
			dataBinding: 'dataBinding',
			/* fired after databinding is finished 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tree performing databinding.
				Use ui.dataView to get a reference to the data the tree has been databound to.
			*/
			dataBound: 'dataBound',
			/* cancel="false" fired before rendering of the tree begins 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tree performing rendering.
				Use ui.dataView to get a reference to the data the tree is going to render.
			*/
			rendering: 'rendering',
			/* fired after rendering of the tree has finished 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tree.
			*/
			rendered: 'rendered',
			/* cancel="true" fired before a new node is selected 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tree.
				Use ui.selectedNodes to get a reference to currently selected nodes.
				Use ui.newNodes to get a reference to the new nodes getting selected.
			*/
			selectionChanging: 'selectionChanging',
			/* fired after a new node is selected 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tree.
				Use ui.selectedNodes to get a reference to the selected nodes.
				Use ui.newNodes to get a reference to the newly added nodes to the selection.
			*/
			selectionChanged: 'selectionChanged',
			/* cancel="true" fired before the checkstate of a node is changed 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tree.
				Use ui.node to get a reference to the node object the checkbox of which is being interacted with.
				Use ui.currentState to get the current state of the checkbox.
				Use ui.newState to get the new future state of the checkbox.
				Use ui.currentCheckedNodes to get the collection of all checked nodes before the new state is applied.
			*/
			nodeCheckstateChanging: 'nodeCheckstateChanging',
			/* fired after the checkstate of a node is changed 
				Use ui.owner to get a reference to the tree.
				Use ui.node to get a reference to the node object the checkbox of which is being interacted with.
				Use ui.newState to get the new current state of the checkbox.
				Use ui.newCheckedNodes to get the collection of all checked nodes.
				Use ui.newPartiallyCheckedNodes to get the collection of all partially checked nodes.
			*/
			nodeCheckstateChanged: 'nodeCheckstateChanged',
			/* cancel="true" fired before the children of a node are populated in the case of load on demand 
				Use ui.path to get a reference to the path of the node being populated.
				Use ui.element to get a reference to the jQuery element of the node being populated.
				Use ui.data to get the node data.
				Use ui.binding to get a reference to the bindings object for the level at which the populating node is located.
			*/
			nodePopulating: 'nodePopulating',
			/* fired after the children of a node are populated in the case of load on demand 
				Use ui.path to get a reference to the path of the populated node.
				Use ui.element to get a reference to the jQuery element of the populated node.
				Use ui.data to get the node data.
				Use ui.binding to get a reference to the bindings object for the level at which the populated node is located.
			*/
			nodePopulated: 'nodePopulated',
			/* cancel="true" fired before a node is collapsed 
				Use ui.owner to get a reference to the tree.
				Use ui.node to get a reference to the node object about to collapse.
			*/
			nodeCollapsing: 'nodeCollapsing',
			/* fired after a node is collapsed 
				Use ui.owner to get a reference to the tree.
				Use ui.node to get a reference to the collapsed node object.
			*/
			nodeCollapsed: 'nodeCollapsed',
			/* cancel="true" fired before a node is expanded 
				Use ui.owner to get a reference to the tree.
				Use ui.node to get a reference to the node object about to expand.
			*/
			nodeExpanding: 'nodeExpanding',
			/* fired after a node is expanded 
				Use ui.owner to get a reference to the tree.
				Use ui.node to get a reference to the expanded node object.
			*/
			nodeExpanded: 'nodeExpanded',
			/* fired on node click 
				Use ui.owner to get a reference to the tree.
				Use ui.node to get a reference to the node object being clicked.
			*/
			nodeClick: 'nodeClick',
			/* fired on node double click
				Use ui.path to get a reference to the path of the double clicked node.
				Use ui.element to get a reference to the jQuery element of the double clicked node.
				Use ui.data to get the node data.
				Use ui.binding to get a reference to the bindings object for the level at which the double clicked node is located.
			*/
			nodeDoubleClick: 'nodeDoubleClick',
			/* cancel="true" fired on node drag start
				Use ui.binding to gets a reference to the binding.
				Use ui.data	to get a reference to the data.
				Use ui.element to get a reference to the element.
				Use ui.helper to get a reference to the helper.
				Use ui.offset to get a reference to the offset.
				Use ui.orginalPosition to get a reference to the original position of the draggable element (the node).
				Use ui.path	to get a reference to the node path.
				Use ui.position to get a reference to the current position of the draggable element.
			*/
			dragStart: 'dragStart',
			/* cancel="true" fired on node drag
				Use ui.binding to gets a reference to the binding.
				Use ui.data	to get a reference to the data.
				Use ui.element to get a reference to the element.
				Use ui.helper to get a reference to the helper.
				Use ui.offset to get a reference to the offset.
				Use ui.orginalPosition to get a reference to the original position of the draggable element (the node).
				Use ui.path	to get a reference to the node path.
				Use ui.position to get a reference to the current position of the draggable element.
			*/
			drag: 'drag',
			/* fired after a drag operation has completed
				Use ui.helper to get a reference to the helper.
				Use ui.offset to get a reference to the offset.
				Use ui.orginalPosition to get a reference to the original position of the draggable element (the node).
				Use ui.position to get a reference to the current position of the draggable element.
			*/
			dragStop: 'dragStop',
			/* cancel="true" fired before a node drop
				Use ui.binding to gets a reference to the binding.
				Use ui.data	to get a reference to the data.
				Use ui.draggable to get a reference to the draggable element (the node).
				Use ui.element to get a reference to the element.
				Use ui.helper to get a reference to the helper.
				Use ui.offset to get a reference to the offset.
				Use ui.path	to get a reference to the node path.
				Use ui.position to get a reference to the current position of the draggable element.
			*/
			nodeDropping: 'nodeDropping',
			/* fired after a node drop
				Use ui.binding to gets a reference to the binding.
				Use ui.data	to get a reference to the data.
				Use ui.draggable to get a reference to the draggable element (the node).
				Use ui.element to get a reference to the element.
				Use ui.helper to get a reference to the helper.
				Use ui.offset to get a reference to the offset.
				Use ui.path	to get a reference to the node path.
				Use ui.position to get a reference to the current position of the draggable element.
			*/
			nodeDropped: 'nodeDropped'
		},
		widget: function () {
            /* Returns the element that represents this widget.
				returnType="object" Returns the element that represents this widget.
			*/
			return this.element;
		},
		_createWidget: function (options, element) {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			this.options.bindings = null;
			this.options.dragAndDropSettings.moveToMarkup = '<div><p><span></span>' + $.ig.Tree.locale.moveTo + '</p></div>';
			this.options.dragAndDropSettings.moveBetweenMarkup = '<div><p><span></span>' + $.ig.Tree.locale.moveBetween + '</p></div>';
			this.options.dragAndDropSettings.moveAfterMarkup = '<div><p><span></span>' + $.ig.Tree.locale.moveAfter + '</p></div>';
			this.options.dragAndDropSettings.moveBeforeMarkup = '<div><p><span></span>' + $.ig.Tree.locale.moveBefore + '</p></div>';
			this.options.dragAndDropSettings.copyToMarkup = '<div><p><span></span>' + $.ig.Tree.locale.copyTo + '</p></div>';
			this.options.dragAndDropSettings.copyBetweenMarkup = '<div><p><span></span>' + $.ig.Tree.locale.copyBetween + '</p></div>';
			this.options.dragAndDropSettings.copyAfterMarkup = '<div><p><span></span>' + $.ig.Tree.locale.copyAfter + '</p></div>';
			this.options.dragAndDropSettings.copyBeforeMarkup = '<div><p><span></span>' + $.ig.Tree.locale.copyBefore + '</p></div>';
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
        _create: function () {
			var opt = this.options;
			this.dataBind();
			this.element.addClass(this.css.tree);
			// K.D. February 17th, 2014 Bug #164398 Attaching events only on create as delegate is used instead of bind now.
			this._attachEvents();
			// K.D. October 18th, 2011 Tree goes outside of it's container under IE7 when height is applied and the container
			// is with position static.
			if ($.ig.util.isIE && $.ig.util.browserVersion === 7 && this.element.css('position') === 'static') {
				this.element.css('position', 'relative');
			}
			if (opt.width) {
				this.element.css('width', opt.width);
			}
			if (opt.height) {
				this.element.css('height', opt.height);
			}
        },
        _setOption: function (option, value) {
			var css = this.css, elements, prevValue = this.options[option];
			if (prevValue === value) {
				return;
			}
            $.Widget.prototype._setOption.apply(this, arguments);

            switch (option) {
			case 'width':
				this.element.css('width', value);
				break;
			case 'height':
				this.element.css('height', value);
				break;
			case 'parentNodeImageUrl':
				elements = this.element.find('img[data-role=parent-node-image]');
				if (elements.length > 0) {
					elements.attr('src', value);
				} else {
					throw new Error($.ig.Tree.locale.setOptionError + option);
				}
				break;
			case 'parentNodeImageTooltip':
				elements = this.element.find('img[data-role=parent-node-image]');
				if (elements.length <= 0) {
					elements = this.element.find('span[data-role=parent-node-image]');
				}
				if (elements.length > 0) {
					elements.attr('title', value);
				} else {
					throw new Error($.ig.Tree.locale.setOptionError + option);
				}
				break;
			case 'parentNodeImageClass':
				elements = this.element.find('span[data-role=parent-node-image]');
				if (elements.length > 0) {
					elements.removeClass();
					elements.addClass(value);
				} else {
					throw new Error($.ig.Tree.locale.setOptionError + option);
				}
				break;
			case 'leafNodeImageUrl':
				elements = this.element.find('img[data-role=leaf-node-image]');
				if (elements.length > 0) {
					elements.attr('src', value);
				} else {
					throw new Error($.ig.Tree.locale.setOptionError + option);
				}
				break;
			case 'leafNodeImageTooltip':
				elements = this.element.find('img[data-role=leaf-node-image]');
				if (elements.length <= 0) {
					elements = this.element.find('span[data-role=leaf-node-image]');
				}
				if (elements.length > 0) {
					elements.attr('title', value);
				} else {
					throw new Error($.ig.Tree.locale.setOptionError + option);
				}
				break;
			case 'leafNodeImageClass':
				elements = this.element.find('span[data-role=leaf-node-image]');
				if (elements.length > 0) {
					elements.removeClass();
					elements.addClass(value);
				} else {
					throw new Error($.ig.Tree.locale.setOptionError + option);
				}
				break;
			case 'hotTracking':
			    if (value) {
			        // K.D. August 16th, 2013 Bug #149438 Switching to delegated events
					this.element.delegate('a', {
						'mouseover': function (event) {
							$(event.target).addClass(css.nodeHovered);
						},
						'mouseout': function (event) {
							$(event.target).removeClass(css.nodeHovered);
						}
					});
			    } else {
			        // K.D. August 16th, 2013 Bug #149438 Switching to delegated events
					this.element.undelegate('a', 'mouseover');
					this.element.undelegate('a', 'mouseout');
				}
				break;
			case 'checkboxMode':
				// K.D. February 10th, 2014 Bug #163522 When the igTree is initialized with checkboxMode = off setting its value to biState is not possible
				if (value.toLowerCase() === 'off') {
					this._removeCheckboxes();
				} else if (prevValue === 'off') {
					this._addCheckboxes();
				}
				break;
			case 'dataSource':
				// K.D. January 10th, 2012 Bug #99110 The tree needs to be rebound and rerendered after changing the DS
				this.dataBind();
				break;
			case 'dragAndDrop':
				if (value) {
					this._initDragAndDrop();
				} else {
					this._destroyDragAndDrop();
				}
				break;
			case 'updateUrl':
				this.options.dataSource.root().settings.updateUrl = value;
				break;
			case 'bindings':
			case 'loadOnDemand':
			case 'pathSeparator':
			case 'initialExpandDepth':
			case 'defaultNodeTarget':
                // K.D. April 14th, 2014 Bug #169669 Throwing an error on bindings
				throw new Error($.ig.Tree.locale.setOptionError + option);
				break;
            default:
                break;
            }
        },
		_removeCheckboxes: function () {
			this.element.find('span[data-role=checkbox]').remove();
		},
		_addCheckboxes: function () {
			var self = this;
			this.element.find('li[data-role=node]').each(function (index, element) {
				var $this = $(this);
				if ($this.children('span[data-role=expander]').length > 0) {
					$this.children('span[data-role=expander]').after(self._renderCheckbox());
				} else {
					$this.prepend(self._renderCheckbox());
				}
			});
		},
		_initDataOptions: function () {
			var dataOptions, ul, s;

			s = this._initDataSourceSchema();
			if (!this.options.dataSource && !this.options.dataSourceUrl) {
				if (!this.element.is('ul')) {
					ul = this.element.children('ul');
					this.options.dataSource = ul[0];
				} else {
					this.options.dataSource = this.element[0];
				}
			} else if (!this.options.dataSource && this.options.dataSourceUrl) {
				this.options.dataSource = this.options.dataSourceUrl;
			} else if ($.type(this.options.dataSource) === 'object' && 
						typeof this.options.dataSource._encodeHierarchicalUrlParams !== "function" && 
						typeof this.options.dataSource._xmlToArray !== "function" && 
						!this.options.dataSourceType) {
				// K.D. October 14th, 2013 Bug #154764 When the igTree is bound to an object and not an array an error is thrown
				this.options.dataSource = [this.options.dataSource];
			}

			dataOptions = {
			    callback: this._constructFromData,
			    callee: this,
				dataSource: this.options.dataSource,
				requestType: this.options.requestType,
				responseContentType: this.options.responseContentType,
				defaultChildrenDataProperty: this.options.bindings.childDataProperty,
				responseDataType: this.options.responseDataType,
				primaryKey: this.options.primaryKey,
				localSchemaTransform: this.options.dataSourceType && this.options.dataSourceType === 'xml' ? true : false,
				schema: s,
				updateUrl: this.options.updateUrl
		    };

			if (this.options.dataSourceType) {
				dataOptions.type = this.options.dataSourceType;
			}
			// K.D. September 20th, 2012 Bug #121861 The responseDataKey needs to be set in the data source
			if (this.options.responseDataKey) {
				dataOptions.responseDataKey = this.options.responseDataKey;
			}

			return dataOptions;
		},
		_initDataSourceSchema: function () {
			var schema = {}, opt = this.options, bindings = opt.bindings;

			if (bindings === null) {
				opt.bindings = {};
				schema.text = { name: 'Text', type: 'string' };
				opt.bindings.textKey = 'Text';
				schema.value = { name: 'Value', type: 'string' };
				opt.bindings.valueKey = 'Value';
				schema.imageUrl = { name: 'ImageUrl', type: 'string' };
				opt.bindings.imageUrlKey = 'ImageUrl';
				schema.navigateUrl = { name: 'NavigateUrl', type: 'string' };
				opt.bindings.navigateUrlKey = 'NavigateUrl';
				schema.childData = { name: 'Nodes', type: 'object' };
				opt.bindings.childDataProperty = 'Nodes';
				schema.target = { name: 'Target', type: 'string' };
				opt.bindings.targetKey = 'Target';
				bindings = opt.bindings;
			} else if (opt.dataSourceType === 'xml') {
				if (bindings.searchFieldXPath) {
					schema.searchField = bindings.searchFieldXPath;
				}
			}

			schema.fields = [];
			if (bindings.textKey) {
				schema.fields.push({ name: bindings.textKey, type: 'string', xpath: bindings.textXPath });
				schema.textKey = bindings.textKey;
			}
			if (bindings.valueKey) {
				schema.fields.push({ name: bindings.valueKey, type: 'string', xpath: bindings.valueXPath });
				schema.valueKey = bindings.valueKey;
			}
			if (bindings.navigateUrlKey) {
				schema.fields.push({ name: bindings.navigateUrlKey, type: 'string', xpath: bindings.navigateUrlXPath });
				schema.navigateUrlKey = bindings.navigateUrlKey;
			}
			if (bindings.imageUrlKey) {
				schema.fields.push({ name: bindings.imageUrlKey, type: 'string', xpath: bindings.imageUrlXPath });
				schema.imageUrlKey = bindings.imageUrlKey;
			}
			if (bindings.targetKey) {
				schema.fields.push({ name: bindings.targetKey, type: 'string' });
				schema.targetKey = bindings.targetKey;
			}
			if (bindings.expandedKey) {
				schema.fields.push({ name: 'Expanded', type: 'boolean' });
				schema.expandedKey = bindings.expandedKey;
			}
			if (bindings.primaryKey) {
				schema.fields.push({ name: bindings.primaryKey, type: 'string' });
				schema.primaryKey = bindings.primaryKey;
			}
			if (bindings.childDataProperty) {
				schema.fields.push({ name: bindings.childDataProperty, type: 'object', xpath: bindings.childDataXPath });
				schema.childDataProperty = bindings.childDataProperty;
			}
			// K.D. March 30th, 2012 Bug #106890 When the data source type is remoteUrl and responseDataKey is set, then searchField in the
			// schema needs to be set to be the responseDataKey
			if (!schema.searchField && opt.responseDataKey) {
				schema.searchField = opt.responseDataKey;
			}
			return schema;
		},
		_initDataSource: function (dataOptions) {
			var opt = this.options;

			if (!opt.dataSource || typeof opt.dataSource._encodeHierarchicalUrlParams !== "function") {
				opt.dataSource = new $.ig.HierarchicalDataSource(dataOptions);
			}
		},
		_helper: null,
		_insertLine: {
			html: null
		},
		_originalHelper: {
			html: null
		},
		_sourceNode: {
			data: null,
			element: null,
			owner: null
		},
		_validationObject: {
			valid: true,
			dropAfter: true,
			expandTimeout: null,
			target: null
		},
		_helperDirty: false,
		_dropAfter: true,
		_initDragOptions: function () {
			var self = this,
				dragAndDropSettings = self.options.dragAndDropSettings,
				helper = dragAndDropSettings.helper === 'default' ? function (event) {
					var target = $(event.target).closest('li[data-role=node]'),
						markup = $(self.options.dragAndDropSettings.invalidMoveToMarkup.replace('{0}', target.children('a').text()));
					markup.addClass(self.css.invalidDropIndicator)
						.find('span')
						.addClass(self.css.invalidMoveMarkupIcon);
					return markup;
				} : dragAndDropSettings.helper,
				opt = {
					revert: dragAndDropSettings.revert ? 'invalid' : false,
					opacity: dragAndDropSettings.dragOpacity,
					zIndex: dragAndDropSettings.zIndex,
					cursorAt: this._const.dragCursorAt,
					helper: helper,
					revertDuration: dragAndDropSettings.revertDuration,
					appendTo: self.element,
					delay: dragAndDropSettings.dragStartDelay,
					containment: dragAndDropSettings.containment,
					start: function (event, ui) {
						var node = self.nodeFromElement($(this)), noCancel;
						noCancel = self._triggerDragStart(event, ui, node.element);
						if (noCancel) {
							self._originalHelper.html = ui.helper.html();
							// K.D. October 17th, 2013 Bug #155067 A shallow copy should be created instead of a deep one
							self._sourceNode.data = $.extend(false, {}, node.data);
							self._sourceNode.owner = self;
							self._sourceNode.element = $(this);
						} else {
							return false;
						}
					},
					drag: function (event, ui) {
						var noCancel = self._triggerDrag(event, ui, self._sourceNode.element);
						if (noCancel) {
							self._performDrag(event, ui);
						} else {
							// K.D. October 29th, 2012 Bug #125545 When the drag event is cancelled all the objects need to be reset.
							self._resetSourceNode();
							self._resetValidationObject();
							return false;
						}
					},
					stop: function (event, ui) {
						self._triggerDragStop(event, ui);
						$(document).find('div[data-role=insert-line]').remove();
						self._helperDirty = false;
						self._resetSourceNode();
						self._resetValidationObject();
					}
				};
			return opt;
		},
		_performDrag: function (event, ui) {
			var target = $(event.originalEvent.target),
				markup,
				copy = (event.ctrlKey && this.options.dragAndDropSettings.dragAndDropMode === 'default') || this.options.dragAndDropSettings.dragAndDropMode === 'copy',
				targetTop,
				dragTop,
				self = this;
			if (target.is('div[data-role=insert-line]')) {
				return;
			}
			this._validationObject.valid = this._accept(this._sourceNode.element, target);
			$(document).find('div[data-role=insert-line]').remove();
			// Expand on hover
			// K.D. July 24th, 2012 Bug #117682 Expand on hover should only activate when hovering the anchor
			// K.D. February 7th, 2013 Bug #132384 Adding an option to disable the expandOnDragOver functionality
			if (this.options.dragAndDropSettings.expandOnDragOver) {
				if ((target.is('a') || target.closest('a').parent().is('li[data-role=node]')) && this._validationObject.target !== target.closest('li[data-role=node]')) {
					clearTimeout(this._validationObject.expandTimeout);
					this._validationObject.target = target.closest('li[data-role=node]');
					// K.D. September 3rd, 2012 Bug #118064 Checking whether the current target has children and not triggering the expand if it does not
					if (this._validationObject.target.hasClass('ui-igtree-parentnode')) {
						this._validationObject.expandTimeout = setTimeout(function () {
							self.expand(self._validationObject.target);
						}, this.options.dragAndDropSettings.expandDelay);
					}
				} else {
					clearTimeout(this._validationObject.expandTimeout);
					this._validationObject.expandTimeout = null;
					this._validationObject.target = null;
				}
			}
			// Show the appropriate drag and drop markup
			if ((target.is('a') || target.closest('a').parent().is('li[data-role=node]')) && this._validationObject.valid) {
				if (copy) {
					markup = $(this.options.dragAndDropSettings.copyToMarkup.replace('{0}', target.text()));
					markup.find('span').addClass(this.css.copyMarkupIcon);
				} else {
					markup = $(this.options.dragAndDropSettings.moveToMarkup.replace('{0}', target.text()));
					markup.find('span').addClass(this.css.moveMarkupIcon);
				}
				this._helper = markup.html();
				ui.helper.removeClass(this.css.invalidDropIndicator).addClass(this.css.dropIndicator).html(this._helper);
				this._helperDirty = true;
			} else if (target.is('li[data-role=node]') && this._validationObject.valid) {
				targetTop = target.offset().top + target.height() / 2;
				dragTop = ui.offset.top + this._const.dragCursorAt.top;
				if (dragTop > targetTop) {
					this._validationObject.dropAfter = true;
					if (copy) {
						if (target.next('li[data-role=node]').length > 0) {
							markup = $(this.options.dragAndDropSettings.copyBetweenMarkup.replace('{0}', target.children('a').text()).replace('{1}', target.next('li[data-role=node]').children('a').text()));
							markup.find('span').addClass(this.css.copyMarkupIcon);
						} else {
							markup = $(this.options.dragAndDropSettings.copyAfterMarkup.replace('{0}', target.children('a').text()));
							markup.find('span').addClass(this.css.copyMarkupIcon);
						}
					} else {
						if (target.next('li[data-role=node]').length > 0) {
							markup = $(this.options.dragAndDropSettings.moveBetweenMarkup.replace('{0}', target.children('a').text()).replace('{1}', target.next('li[data-role=node]').children('a').text()));
							markup.find('span').addClass(this.css.moveMarkupIcon);
						} else {
							markup = $(this.options.dragAndDropSettings.moveAfterMarkup.replace('{0}', target.children('a').text()));
							markup.find('span').addClass(this.css.moveMarkupIcon);
						}
					}
					$(this._insertLine.html).appendTo(target);
					this._helper = markup.html();
					ui.helper.removeClass(this.css.invalidDropIndicator)
						.addClass(this.css.dropIndicator)
						.html(this._helper);
				} else {
					this._validationObject.dropAfter = false;
					if (copy) {
						if (target.prev('li[data-role=node]').length > 0) {
							markup = $(this.options.dragAndDropSettings.copyBetweenMarkup.replace('{0}', target.children('a').text()).replace('{1}', target.prev('li[data-role=node]').children('a').text()));
							markup.find('span').addClass(this.css.copyMarkupIcon);
						} else {
							markup = $(this.options.dragAndDropSettings.copyBeforeMarkup.replace('{0}', target.children('a').text()));
							markup.find('span').addClass(this.css.copyMarkupIcon);
						}
					} else {
						if (target.prev('li[data-role=node]').length > 0) {
							markup = $(this.options.dragAndDropSettings.moveBetweenMarkup.replace('{0}', target.prev('li[data-role=node]')
								.children('a').text())
								.replace('{1}', target.children('a').text()));
							markup.find('span').addClass(this.css.moveMarkupIcon);
						} else {
							markup = $(this.options.dragAndDropSettings.moveBeforeMarkup.replace('{0}', target.children('a').text()));
							markup.find('span').addClass(this.css.moveMarkupIcon);
						}
					}
					if (target.index() === 0) {
						$(this._insertLine.html).prependTo(target).css('padding-bottom', '0.1em');
					} else {
						$(this._insertLine.html).appendTo(target.prev());
					}
					this._helper = markup.html();
					ui.helper.removeClass(this.css.invalidDropIndicator)
						.addClass(this.css.dropIndicator)
						.html(this._helper);
				}
				this._helperDirty = true;
			} else if (target.is(':ui-igTree')) {
				// K.D. December 13th, 2013 Bug #159540 Allowing for dragging and dropping into an empty tree.
				if (copy) {
					markup = $(this.options.dragAndDropSettings.copyToMarkup.replace('{0}', target.text()));
					markup.find('span').addClass(this.css.copyMarkupIcon);
				} else {
					markup = $(this.options.dragAndDropSettings.moveToMarkup.replace('{0}', target.text()));
					markup.find('span').addClass(this.css.moveMarkupIcon);
				}
				this._helper = markup.html();
				ui.helper.removeClass(this.css.invalidDropIndicator).addClass(this.css.dropIndicator).html(this._helper);
				this._helperDirty = true;
			} else {
				$(document).find('div[data-role=insert-line]').remove();
				if (this._helperDirty) {
					this._helper = null;
					ui.helper.removeClass(this.css.dropIndicator)
						.addClass(this.css.invalidDropIndicator)
						.html(this._originalHelper.html);
					this._helperDirty = false;
				}
			}
		},
		_resetSourceNode: function () {
			this._originalHelper.html = null;
			this._sourceNode.data = null;
			this._sourceNode.owner = null;
			this._sourceNode.element = null;
		},
		_resetValidationObject: function () {
			this._validationObject.valid = true;
			this._validationObject.dropAfter = true;
			clearTimeout(this._validationObject.expandTimeout);
			this._validationObject.expandTimeout = null;
			this._validationObject.target = null;
		},
		_initDropOptions: function () {
			var self = this,
				opt = {
					tolerance: 'pointer',
					greedy: true,
					drop: function (event, ui) {
						// K.D. October 12th, 2012 Bug #124246 Disallow external element drop inside the tree
						if (self._sourceNode.element === null && self._sourceNode.owner === null) {
							return false;
						}
						return self._performDrop(event, ui);
					},
					accept: function (dropElem) {
						return self._validationObject.valid;
					}
				};
			return opt;
		},
		_performDrop: function (event, ui) {
			var self = this, parent, target = $(event.originalEvent.target), noCancel;
			if (target.is('div[data-role=insert-line]')) {
				target = target.closest('li[data-role=node]');
			}
			self.element.find('div[data-role=insert-line]').remove();
			noCancel = self._triggerNodeDropping(event, ui, target.closest('li[data-role=node]'), target.next('li[data-role=node]').length > 0 || !self._validationObject.dropAfter ? target.index() + (self._validationObject.dropAfter ? 1 : 0) : target.index());
			if (noCancel) {
				if (target.is('a') || target.closest('a').parent().is('li[data-role=node]')) {
					target = target.closest('li[data-role=node]');
					switch (self.options.dragAndDropSettings.dragAndDropMode) {
					case 'move':
						self.addNode(self._sourceNode.data, target);
						self._sourceNode.owner.removeAt(self._sourceNode.element.attr('data-path'));
						break;
					case 'copy':
						self.addNode(self._sourceNode.data, target);
						break;
					default:
						if (!event.ctrlKey) {
							self.addNode(self._sourceNode.data, target);
							self._sourceNode.owner.removeAt(self._sourceNode.element.attr('data-path'));
						} else {
							self.addNode(self._sourceNode.data, target);
						}
						break;
					}
				} else if (target.is('li')) {
					parent = self.parentNode(target);
					switch (self.options.dragAndDropSettings.dragAndDropMode) {
					case 'move':
						self.addNode(self._sourceNode.data, parent, target.next('li[data-role=node]').length > 0 || !self._validationObject.dropAfter ? target.index() + (self._validationObject.dropAfter ? 1 : 0) : null);
						self._sourceNode.element.attr('data-path', self._sourceNode.element.attr('data-path') + '_remove');
						self._sourceNode.owner.removeAt(self._sourceNode.element.attr('data-path'));
						break;
					case 'copy':
						self.addNode(self._sourceNode.data, parent, target.next('li[data-role=node]').length > 0 || !self._validationObject.dropAfter ? target.index() + (self._validationObject.dropAfter ? 1 : 0) : null);
						break;
					default:
						if (!event.ctrlKey) {
							self.addNode(self._sourceNode.data, parent, target.next('li[data-role=node]').length > 0 || !self._validationObject.dropAfter ? target.index() + (self._validationObject.dropAfter ? 1 : 0) : null);
							self._sourceNode.element.attr('data-path', self._sourceNode.element.attr('data-path') + '_remove');
							self._sourceNode.owner.removeAt(self._sourceNode.element.attr('data-path'));
						} else {
							self.addNode(self._sourceNode.data, parent, target.next('li[data-role=node]').length > 0 || !self._validationObject.dropAfter ? target.index() + (self._validationObject.dropAfter ? 1 : 0) : null);
						}
						break;
					}
				} else if (target.is(':ui-igTree')) {
					// K.D. December 13th, 2013 Bug #159540 Allowing for dragging and dropping into an empty tree.
					switch (self.options.dragAndDropSettings.dragAndDropMode) {
					case 'move':
						self.addNode(self._sourceNode.data);
						self._sourceNode.owner.removeAt(self._sourceNode.element.attr('data-path'));
						break;
					case 'copy':
						self.addNode(self._sourceNode.data);
						break;
					default:
						if (!event.ctrlKey) {
							self.addNode(self._sourceNode.data);
							self._sourceNode.owner.removeAt(self._sourceNode.element.attr('data-path'));
						} else {
							self.addNode(self._sourceNode.data);
						}
						break;
					}
				}
				self._triggerNodeDropped(event, ui, target);
			} else {
				return false;
			}
		},
		_accept: function (dropElem, target) {
			// Validates the drop target
			var valid = true,
				node = target.closest('li[data-role=node]'),
				dropPath = dropElem.attr('data-path'),
				tree = target.closest('.ui-widget.ui-igtree'),
				sourceBinding = this._retrieveCurrentDepthBinding(parseInt(this._sourceNode.element.closest('ul').attr('data-depth'), 10)),
				destinationBinding;
			if ((target.is('a') && target.parent().is('li[data-role=node]')) || target.closest('a').parent().is('li[data-role=node]')) {
				destinationBinding = tree.data('igTree')._retrieveCurrentDepthBinding(parseInt(target.closest('ul').attr('data-depth'), 10) + 1);
			} else {
				if (target.is('li[data-role=node]')) {
					destinationBinding = tree.data('igTree')._retrieveCurrentDepthBinding(parseInt(target.closest('ul').attr('data-depth'), 10));
				} else if (target.is(':ui-igTree')) {
					// K.D. December 13th, 2013 Bug #159540 Allowing for dragging and dropping into an empty tree.
					destinationBinding = tree.data('igTree')._retrieveCurrentDepthBinding(0);
				} else {
					destinationBinding = false;
				}
			}
			if (node.length > 0 && (node.attr('data-path') === dropPath || node.attr('data-path').indexOf(dropPath) === 0) && this === tree.data('igTree')) {
				valid = false;
			} else if (this !== tree.data('igTree') && !tree.igTree('option', 'dragAndDropSettings').allowDrop) {
				valid = false;
			} else if (typeof tree.igTree('option', 'dragAndDropSettings').customDropValidation === 'function') {
				valid = tree.igTree('option', 'dragAndDropSettings').customDropValidation.apply(target, [dropElem]);
			}
			if (sourceBinding && destinationBinding && valid) {
				valid = this._validateBindings(sourceBinding, destinationBinding);
			}
			return valid;
		},
		_validateBindings: function (sourceBinding, destinationBinding) {
			var valid = true;
			if (destinationBinding.hasOwnProperty('primaryKey')) {
				if (!sourceBinding.hasOwnProperty('primaryKey') || sourceBinding.primaryKey !== destinationBinding.primaryKey) {
					valid = false;
				}
			}
			if (destinationBinding.textKey !== sourceBinding.textKey) {
				valid = false;
			}
			if (destinationBinding.hasOwnProperty('valueKey') && sourceBinding.hasOwnProperty('valueKey') && destinationBinding.valueKey !== sourceBinding.valueKey) {
				valid = false;
			}
			if (destinationBinding.hasOwnProperty('childDataProperty') && sourceBinding.hasOwnProperty('childDataProperty') && destinationBinding.childDataProperty !== sourceBinding.childDataProperty) {
				valid = false;
			}
			return valid;
		},
		_initDragAndDrop: function (element) {
			var dragOptions = this._initDragOptions(),
				dropOptions = this._initDropOptions();
			if (!this._insertLine.html) {
				this._insertLine.html = '<div data-role="insert-line" class="' + this.css.insertLine + '"></div>';
			}
			if (!element) {
				this.element.find('li[data-role=node]').draggable(dragOptions);
				this.element.droppable(dropOptions);
			    // K.D. August 16th, 2013 Bug #149438 Switching to delegated events
				this.element.delegate('a', 'mousedown', function (event) {
					$(this).focus();
				});
			} else {
				element.draggable(dragOptions);
				element.find('li[data-role=node]').draggable(dragOptions);
			}
		},
		_destroyDragAndDrop: function () {
			this.element.find('li[data-role=node]').draggable('destroy');
			this.element.droppable('destroy');
			this.element.undelegate('a', 'mousedown');
		},
		_constructFromData: function () {
			var ul, data = this.options.dataSource._rootds.data(), self = this;
			this._triggerDataBound(data);
			this._triggerRendering(data);
			// K.D. Adding data-scroll attribute for igScroll (custom scrolling under touch environments)
			this.element.attr('data-scroll', true);

			if (this.element.is('ul')) {
				this.element.empty();
				ul = this.element;
				ul.addClass(this.css.treeCollection).addClass(this.css.treeRoot).attr('data-depth', 0);
				// K.D. June 4th, 2014 Bug #162878 WinJS compatibility for the igTree
				MSApp.execUnsafeLocalFunction(function () {
					ul.html(self._initChildrenRecursively('', data));
				});
				this._triggerRendered();
			} else {
				this.element.empty();
				ul = '<ul class="' + this.css.treeCollection + ' ' + this.css.treeRoot + '" data-depth="0">';
				ul += this._initChildrenRecursively('', data);
				ul += '</ul>';
				// K.D. June 4th, 2014 Bug #162878 WinJS compatibility for the igTree
				MSApp.execUnsafeLocalFunction(function () {
					$(ul).appendTo(self.element);
				});
				this._triggerRendered();
			}

			if (this.options.dragAndDrop) {
				this._initDragAndDrop();
				if (typeof this.options.dragAndDropSettings.customDropValidation === 'string') {
					// K.D. November 9th, 2012 Bug #126853 An exception is thrown in old IEs because the global object
					// does not have hasOwnProperty() defined on it.
					if (window[this.options.dragAndDropSettings.customDropValidation] && typeof window[this.options.dragAndDropSettings.customDropValidation] === 'function') {
						this.options.dragAndDropSettings.customDropValidation = window[this.options.dragAndDropSettings.customDropValidation];
					}
				}
			}
		},
		_attachEvents: function () {
			var self = this, css = this.css, noCancel, target;
		    // Bind expander
		    // K.D. August 16th, 2013 Bug #149438 Switching to delegated events
			this.element.delegate('span[data-role=expander]', 'click', function (event) {
				self.toggle($(event.target).closest('li[data-role=node]'), event);
			});
			// Bind anchor
			if (this.options.hotTracking) {
				this.element.delegate('a', {
					'click': function (event) {
						target = $(event.target).closest('a');
						noCancel = self._triggerNodeClick(event, target.parent());

						if (noCancel) {
							self.select(target.parent(), event);
							if ($.ig.util.isWebKit) {
								target.focus();
							}
						} else {
							event.preventDefault();
						}
					},
					'dblclick': function (event) {
						event.preventDefault();
						self._triggerNodeDoubleClick(event, $(event.target.parentNode));
					},
					'keydown': function (event) {
						self._kbNavigation(event);
					},
					'focus': function (event) {
						self._focusNode(event);
					},
					'blur': function (event) {
						self._blurNode(event);
					},
					'mouseover': function (event) {
						target = $(event.target).closest('a');
						target.addClass(css.nodeHovered);
					},
					'mouseout': function (event) {
						target = $(event.target).closest('a');
						target.removeClass(css.nodeHovered);
					}
				});
			} else {
			    // K.D. August 16th, 2013 Bug #149438 Switching to delegated events
				this.element.delegate('a', {
					'click': function (event) {
						target = $(event.target).closest('a');
						noCancel = self._triggerNodeClick(event, target.parent());

						if (noCancel) {
							self.select(target.parent(), event);
							if ($.ig.util.isWebKit) {
								target.focus();
							}
						} else {
							event.preventDefault();
						}
					},
					'dblclick': function (event) {
						event.preventDefault();
						self._triggerNodeDoubleClick(event, $(event.target.parentNode));
					},
					'keydown': function (event) {
						self._kbNavigation(event);
					},
					'focus': function (event) {
						self._focusNode(event);
					},
					'blur': function (event) {
						self._blurNode(event);
					}
				});
			}
		    // Bind checkbox
		    // K.D. August 16th, 2013 Bug #149438 Switching to delegated events
			this.element.delegate('span[data-role=checkbox] > span', {
				'click': function (event) {
					self.toggleCheckstate($(event.target).closest('li[data-role=node]'), event);
				},
				'mouseover': function (event) {
					$(event.target).closest('span[data-role=checkbox]').addClass(css.nodeHovered);
				},
				'mouseout': function (event) {
					$(event.target).closest('span[data-role=checkbox]').removeClass(css.nodeHovered);
				}
			});
		},
		_initChildrenRecursively: function (path, data, depth, checkFlag, indexFeed) {
			var childUl, opt = this.options, childPath, binding, value, display, liStr = [], i = 0, li, children, tempPath;

			if (!indexFeed) {
				indexFeed = 0;
			}
			// Applying binding according to depth
			if (!depth) {
				depth = 0;
			}
			binding = this._retrieveCurrentDepthBinding(depth);
			if (!data.hasOwnProperty('length') && data.hasOwnProperty(binding.textKey)) {
				data = [data];
			}
			for (i; i < data.length; i++) {
				childUl = '';
				value = '';
				if (path.length <= 0) {
					if (binding.hasOwnProperty('primaryKey') && data[i].hasOwnProperty(binding.primaryKey)) {
						childPath = typeof data[i][binding.primaryKey] === 'function' ? data[i][binding.primaryKey]() : data[i][binding.primaryKey];
					} else {
						childPath =  i + indexFeed;
					}
				} else {
					if (binding.hasOwnProperty('primaryKey') && data[i].hasOwnProperty(binding.primaryKey)) {
						childPath = path + opt.pathSeparator + (typeof data[i][binding.primaryKey] === 'function' ? data[i][binding.primaryKey]() : data[i][binding.primaryKey]);
					} else {
						childPath = path + opt.pathSeparator + (i + indexFeed);
					}
				}
				if (binding.hasOwnProperty('valueKey') && data[i].hasOwnProperty(binding.valueKey)) {
					if (typeof data[i][binding.valueKey] === 'function') {
						value = data[i][binding.valueKey]();
					} else {
						value = data[i][binding.valueKey];
					}
				}
				li = '<li class="' + this._buildNodeCssString(data[i], depth, binding) + '" data-path="' + childPath + '" data-value="' + value + '" data-role="node">';

				children = data[i][binding.childDataProperty];
				if (typeof children === 'function') {
					children = children();
				}
				if ((children && children.length > 0) || (children && opt.loadOnDemand)) {
					if ((depth <= opt.initialExpandDepth && !opt.loadOnDemand) || (binding.hasOwnProperty('expandedKey') && data[i].hasOwnProperty(binding.expandedKey) && data[i][binding.expandedKey])) {
						li += this._renderExpanderImage(true);
						display = 'block';
					} else {
						li += this._renderExpanderImage(false);
						display = 'none';
					}
				}

				if (opt.checkboxMode && opt.checkboxMode.toLowerCase() !== 'off') {
					li += this._renderCheckbox(checkFlag);
				}
				li += this._renderNodeImage(data[i], binding);
				if (!binding.nodeContentTemplate) {
					li += this._renderAnchor(data[i], binding);
				} else {
					li += this._renderNodeTemplate(data[i], binding);
				}

				if ((children && children.length > 0) || (children && opt.loadOnDemand)) {
					childUl = '<ul style="display: ' + display + '" data-depth="' + (depth + 1) + '"';
					if (children.length > 0 && !opt.loadOnDemand) {
						childUl += '>' + this._initChildrenRecursively(childPath, children, depth + 1, checkFlag);
					} else {
						childUl += ' data-populated="false">';
					}
					childUl += '</ul>';
				}
				li += childUl;
				li += '</li>';
				liStr.push(li);
			}
			return liStr.join('');
		},
		_buildNodeCssString: function (data, depth, binding) {
			var css = this.css, str = css.treeNode, children;
			if (depth === 0) {
				str += ' ' + css.treeRootNode;
			}
			children = data[binding.childDataProperty];
			if (typeof children === 'function') {
				children = children();
			}
			if ((children && children.length > 0) || (children && this.options.loadOnDemand)) {
				str += ' ' + css.parentNode;
			} else {
				str += ' ' + css.nodeNoChildren;
			}
			return str;
		},
		_retrieveCurrentDepthBinding: function (depth) {
			var binding = this.options.bindings, i = 0;
			for (i; i < depth; i++) {
				if (binding.hasOwnProperty('bindings')) {
					binding = binding.bindings;
				} else {
					break;
				}
			}
			return binding;
		},
		_renderExpanderImage: function (expanded) {
			var self = this, css = self.css, expander = '';

			if (expanded) {
				expander = '<span data-role="expander" data-exp="true" class="' + css.collapseIcon + ' ' + css.nodeExpander + '"></span>';
			} else {
				expander = '<span data-role="expander" data-exp="false" class="' + css.expandIcon + ' ' + css.nodeExpander + '"></span>';
			}
			return expander;
		},
		_renderAnchor: function (data, binding) {
			var href, target, text;

			if (binding.hasOwnProperty('navigateUrlKey') && data[binding.navigateUrlKey]) {
				if (typeof data[binding.navigateUrlKey] === 'function') {
					href = data[binding.navigateUrlKey]();
				} else if (data[binding.navigateUrlKey].length <= 0) {
					href = '#';
				} else {
					href = data[binding.navigateUrlKey];
				}
			} else {
				href = '#';
			}

			if (binding.targetKey && binding.targetKey.length > 0 && data.hasOwnProperty(binding.targetKey)) {
				target = data[binding.targetKey];
			} else {
				target = this.options.defaultNodeTarget;
			}

			if (typeof data[binding.textKey] === 'function') {
				text = data[binding.textKey]();
			} else {
				text = data[binding.textKey];
			}

			return '<a href="' + href + '" target="' + target + '">' + text + '</a>';
		},
		_renderNodeTemplate: function (data, binding) {
			var div = $('<div></div>'), html, href, target, template = binding.nodeContentTemplate;
			// K.D. July 30th, 2013 Bug #148135 navigateURL non-responsive when nodeContentTemplate is set
			if (binding.hasOwnProperty('navigateUrlKey') && data[binding.navigateUrlKey]) {
				if (typeof data[binding.navigateUrlKey] === 'function') {
					href = data[binding.navigateUrlKey]();
				} else if (data[binding.navigateUrlKey].length <= 0) {
					href = '#';
				} else {
					href = data[binding.navigateUrlKey];
				}
			} else {
				href = '#';
			}
			if (binding.targetKey && binding.targetKey.length > 0 && data.hasOwnProperty(binding.targetKey)) {
				target = data[binding.targetKey];
			} else {
				target = this.options.defaultNodeTarget;
			}
			// K.D. February 14th, 2012 There needs to be a default case in which the html is simply the content of the div
			// without any manipulations
			if (typeof $.ig.tmpl === 'function') {
				div.html($.ig.tmpl(template, data));
				if (div.children('a').length <= 0) {
					html = '<a href="' + href + '" target="' + target + '">' + div.html() + '</a>';
				} else if (!div.children('a').attr('href')) {
					div.children('a').attr({
						href: href,
						target: target
					});
					html = div.html();
				} else {
					html = div.html();
				}
			} else {
				$.tmpl(template, data).appendTo(div);
				if (div.children('a').length <= 0) {
					html = '<a href="' + href + '" target="' + target + '">' + div.html() + '</a>';
				} else if (!div.children('a').attr('href')) {
					div.children('a').attr({
						href: href,
						target: target
					});
					html = div.html();
				} else {
					html = div.html();
				}
			}
			return html;
		},
		_renderCheckbox: function (checkFlag) {
			var self = this, css = self.css;
			return '<span data-chk="' + (checkFlag ? 'on' : 'off') + '" data-role="checkbox" class="' + css.checkbox + '"><span class="' + (checkFlag ? css.checkboxOn : css.checkboxOff) + '"></span></span>';
		},
		_renderNodeImage: function (data, binding) {
			var opt = this.options, hasChildren, img = '', src;

			hasChildren = (data[binding.childDataProperty] && data[binding.childDataProperty].length > 0) || (data[binding.childDataProperty] && opt.loadOnDemand);

			if (binding.hasOwnProperty('imageUrlKey') && data.hasOwnProperty(binding.imageUrlKey)) {
				if (typeof data[binding.imageUrlKey] === 'function') {
					src = data[binding.imageUrlKey]();
					if (src && src.length > 0) {
						img = '<img src="' + src + '" alt="error" data-role="node-image" />';
					}
				} else if (data[binding.imageUrlKey].length > 0) {
					img = '<img src="' + data[binding.imageUrlKey] + '" alt="error" data-role="node-image" />';
				}
			}
			if (opt.parentNodeImageUrl && hasChildren) {
				img += '<img src="' + opt.parentNodeImageUrl + '" alt="error" title="' + (opt.parentNodeImageTooltip !== null ? opt.parentNodeImageTooltip : '') + '" data-role="parent-node-image" />';
			} else if (opt.parentNodeImageClass && hasChildren) {
				img += '<span title="' + (opt.parentNodeImageTooltip !== null ? opt.parentNodeImageTooltip : '') + '" class="' + opt.parentNodeImageClass + '" data-role="parent-node-image"></span>';
			} else if (!hasChildren && opt.leafNodeImageUrl) {
				img += '<img src="' + opt.leafNodeImageUrl + '" alt="error" title="' + (opt.leafNodeImageTooltip !== null ? opt.leafNodeImageTooltip : '') + '" data-role="leaf-node-image" />';
			} else if (!hasChildren && opt.leafNodeImageClass) {
				img += '<span title="' + (opt.leafNodeImageTooltip !== null ? opt.leafNodeImageTooltip : '') + '" class="' + opt.leafNodeImageClass + '" data-role="leaf-node-image"></span>';
			}
			return img;
		},
		_focusNode: function (event) {
			$(event.target).addClass(this.css.nodeActive);
		},
		_blurNode: function (event) {
			$(event.target).removeClass(this.css.nodeActive);
		},
		_kbNavigation: function (event) {
			var opt = this.options, css = this.css, li = $(event.target.parentNode), nextLi, seq = li.index(), expander;

			if (event.keyCode === $.ui.keyCode.UP) {
				nextLi = this._nextVisibleNodeUp(li);
				if (!nextLi) {
					return;
				}

				if (event.ctrlKey) {
					// K.D. December 14th, 2011 Bug #85068 jQuery 1.4.4 does not trigger blur when 
					// calling focus so I'm calling it manually
					li.children('a').blur();
					nextLi.children('a').focus();
				} else if (event.shiftKey && opt.multipleSelection) {
					opt = this.options;
					// To do: Multiple selection logic
				} else {
					// K.D. December 14th, 2011 Bug #85068 jQuery 1.4.4 does not trigger blur when 
					// calling focus so I'm calling it manually
					li.children('a').blur();
					nextLi.children('a').focus();
					this.select(nextLi, null);
				}
				event.preventDefault();
			} else if (event.keyCode === $.ui.keyCode.DOWN) {
				nextLi = this._nextVisibleNodeDown(li, seq);
				if (!nextLi) {
					return;
				}

				if (event.ctrlKey) {
					// K.D. December 14th, 2011 Bug #85068 jQuery 1.4.4 does not trigger blur when 
					// calling focus so I'm calling it manually
					li.children('a').blur();
					nextLi.children('a').focus();
				} else if (event.shiftKey && opt.multipleSelection) {
					opt = this.options;
					// To do: Multiple selection logic
				} else {
					// K.D. December 14th, 2011 Bug #85068 jQuery 1.4.4 does not trigger blur when 
					// calling focus so I'm calling it manually
					li.children('a').blur();
					nextLi.children('a').focus();
					this.select(nextLi, null);
				}
				event.preventDefault();
			} else if (event.keyCode === $.ui.keyCode.RIGHT) {
				if (li.children('ul').length > 0) {
					expander = li.children('.' + css.nodeExpander);
					if (!expander.attr('data-exp') || expander.attr('data-exp') === 'false') {
						this.toggle(li, null);
					} else {
						nextLi = li.find('ul > li:first');
						if (nextLi.length > 0) {
							if (event.ctrlKey) {
								// K.D. December 14th, 2011 Bug #85068 jQuery 1.4.4 does not trigger blur when 
								// calling focus so I'm calling it manually
								li.children('a').blur();
								nextLi.children('a').focus();
							} else if (event.shiftKey && opt.multipleSelection) {
								opt = this.options;
								// To do: Multiple selection logic
							} else {
								// K.D. December 14th, 2011 Bug #85068 jQuery 1.4.4 does not trigger blur when 
								// calling focus so I'm calling it manually
								li.children('a').blur();
								nextLi.children('a').focus();
								this.select(nextLi, null);
							}
						}
					}
				}
			} else if (event.keyCode === $.ui.keyCode.LEFT) {
				expander = li.children('.' + css.nodeExpander);
				if (expander.attr('data-exp') && expander.attr('data-exp') !== 'false') {
					this.toggle(li, null);
				} else if (li.parent().parent().is('li')) {
					nextLi = li.parent().parent();
					if (event.ctrlKey) {
						// K.D. December 14th, 2011 Bug #85068 jQuery 1.4.4 does not trigger blur when 
						// calling focus so I'm calling it manually
						li.children('a').blur();
						nextLi.children('a').focus();
					} else if (event.shiftKey && opt.multipleSelection) {
						opt = this.options;
						// To do: Multiple selection logic
					} else {
						// K.D. December 14th, 2011 Bug #85068 jQuery 1.4.4 does not trigger blur when 
						// calling focus so I'm calling it manually
						li.children('a').blur();
						nextLi.children('a').focus();
						this.select(nextLi, null);
					}
				}
			} else if (event.keyCode === $.ui.keyCode.NUMPAD_ADD) {
				if (li.children('ul').length > 0) {
					expander = li.children('.' + css.nodeExpander);
					if (!expander.attr('data-exp') || expander.attr('data-exp') === 'false') {
						this.toggle(li, null);
					}
				}
			} else if (event.keyCode === $.ui.keyCode.NUMPAD_SUBTRACT) {
				if (li.children('ul').length > 0) {
					expander = li.children('.' + css.nodeExpander);
					if (expander.attr('data-exp') && expander.attr('data-exp') !== 'false') {
						this.toggle(li, null);
					}
				}
			} else if (event.keyCode === $.ui.keyCode.SPACE) {
				if (opt.checkboxMode && opt.checkboxMode.toLowerCase() !== 'off') {
					this.toggleCheckstate(li, null);
					event.preventDefault();
					event.stopPropagation();
				}
			} else if (event.keyCode === $.ui.keyCode.HOME) {
				// K.D. December 14th, 2011 Bug #85068 jQuery 1.4.4 does not trigger blur when 
				// calling focus so I'm calling it manually
				li.children('a').blur();
				li = this.element.find('li:first');
				if (li.length > 0) {
					li.children('a').focus();
					this.select(li);
				}
				event.preventDefault();
			} else if (event.keyCode === $.ui.keyCode.END) {
				// K.D. December 14th, 2011 Bug #85068 jQuery 1.4.4 does not trigger blur when 
				// calling focus so I'm calling it manually
				li.children('a').blur();
				li = this._lastVisibleNode();
				if (li) {
					li.children('a').focus();
					this.select(li);
				}
				event.preventDefault();
			}
		},
		_nextVisibleNodeDown: function (node, nodeSeq) {
			var expander = node.children('.' + this.css.nodeExpander), parentLi, seq = nodeSeq, result = null;

			if (expander.length > 0 && expander.attr('data-exp') && expander.attr('data-exp') !== 'false' && node.children('ul').children('li:first').length > 0) {
				return node.children('ul').children('li:first');
			}

			if (seq === node.siblings().length) {
				parentLi = node.parent().parent();
				while (parentLi.is('li')) {
					seq = parentLi.index();
					if (seq !== parentLi.siblings().length) {
						result = parentLi.next();
						break;
					}
					parentLi = parentLi.parent().parent();
				}
			} else {
				result = node.next();
			}
			return result;
		},
		_nextVisibleNodeUp: function (node) {
			var li = node.prev(), expander, result = null;

			if (li.length <= 0) {
				if (node.parent().parent().is('li')) {
					result = node.parent().parent();
				}
			} else {
				while (li.length > 0) {
					expander = li.children('.' + this.css.nodeExpander);
					if (li.children('ul').children('li').length <= 0 || !expander.attr('data-exp') || expander.attr('data-exp') === 'false') {
						result = li;
						break;
					}
					li = li.children('ul').children('li:last');
				}
			}
			return result;
		},
		_lastVisibleNode: function () {
			var li = this.element.is('ul') ? this.element.children('li:last') : this.element.children('ul').children('li:last'), expander, result;

			if (li.length <= 0) {
				result = null;
			} else {
				while (li.length > 0) {
					expander = li.children('.' + this.css.nodeExpander);
					if (li.children('ul').children('li').length <= 0 || !expander.attr('data-exp') || expander.attr('data-exp') === 'false') {
						result = li;
						break;
					}
					li = li.children('ul').children('li:last');
				}
			}
			return result;
		},
		_populatingNode: null,
		_populateNodeData: function (success, msg, data) {
			if (!success) {
				throw new Error($.ig.Tree.locale.errorOnRequest + msg);
			}
			var ul = this._populatingNode.ul, originalData = this.nodeDataFor(this._populatingNode.node.attr('data-path')), depth = ul.attr('data-depth'), binding = this._retrieveCurrentDepthBinding(depth - 1), checked, newData = data.data();

			if (this.options.checkboxMode.toLowerCase() === 'tristate') {
				checked = this.isChecked(this._populatingNode.node);
			}

		    // Clear the loading indicator space
		    // K.D. August 16th, 2013 Bug #149438 Keeping the already rendered nodes and rendering the loaded ones after
			ul.children('li[data-role="loading"]').remove();
			if (!originalData[binding.childDataProperty] || !originalData[binding.childDataProperty].length) {
				originalData[binding.childDataProperty] = newData;
			} else {
				originalData[binding.childDataProperty] = originalData[binding.childDataProperty].concat(newData);
			}
			this._triggerNodePopulated(null, this._populatingNode.node);
			// K.D. November 23rd, 2011 Bug #96609 The data should be extracted from the datasource before sent to the event trigger
			this._triggerRendering(newData);
		    // K.D. August 16th, 2013 Bug #149438 Keeping the already rendered nodes and rendering the loaded ones after
			ul.append(this._initChildrenRecursively(this._populatingNode.node.attr('data-path'), newData, parseInt(ul.attr('data-depth'), 10), checked));
			ul.attr('data-populated', true);
			if (this.options.dragAndDrop) {
				this._initDragAndDrop(ul);
			}
			this._triggerRendered();
			this.toggle(this._populatingNode.node);
			this._populatingNode.indicator.hide();
			this._populatingNode.indicator.destroy();
			this._populatingNode = null;
			this._loadRequest();
		},
		_prepareRequest: function (node, event) {
			var opt = this.options, pathKeyArr, path, key, data, binding, parentBinding, noCancel;

			if (this._populatingNode !== null) {
				return;
			}

			noCancel = this._triggerNodePopulating(event, node);
			if (noCancel) {
				pathKeyArr = this._buildRequestString(node);
				binding = this._retrieveCurrentDepthBinding(parseInt(node.children('ul').attr('data-depth'), 10));
				if (!pathKeyArr) {
					return;
				}
				path = pathKeyArr[0];
				key = pathKeyArr[1];

				data = this.nodeDataFor(node.attr('data-path'));
				parentBinding = this._retrieveCurrentDepthBinding(parseInt(node.children('ul').attr('data-depth'), 10) - 1);
				if (data.hasOwnProperty(parentBinding.childDataProperty)) {
					data = data[parentBinding.childDataProperty];
				}
				if (data && data.__deferred && data.__deferred.uri) {
					this._executeODataRequest(node, data);
				} else if (data && data.length > 0 && !opt.dataSourceUrl) {
					this._renderOnDemand(node, data);
				} else {
					this._executeUrlRequest(node, binding, path, key);
				}
			}
		},
		_executeODataRequest: function (node, data) {
			var dataSource, ul, indicator, opt = this.options, li;
			dataSource = new $.ig.JSONPDataSource({dataSource: data.__deferred.uri + '?$format=json&$callback=?', responseDataKey: opt.responseDataKey});
			ul = node.children('ul');
			// Create loading indicator space
			li = $('<li style="width: 20px" data-role="loading">&nbsp;</li>').appendTo(ul);
			ul.show();
			// K.D. December 19th, 2011 Bug #98217 Adding flag pointing that the loading indicator is instantiated by the tree
			indicator = li.igLoading({ includeVerticalOffset: false }).data('igLoading').indicator();
			indicator.show();
			this._populatingNode = {
				ul: ul,
				node: node,
				indicator: indicator
			};
			dataSource.dataBind(this._populateNodeData, this);
		},
		_renderOnDemand: function (node, data) {
			var ul, checked;
			ul = node.children('ul');
			if (this.options.checkboxMode.toLowerCase() === 'tristate') {
				checked = this.isChecked(node);
			}
			this._triggerNodePopulated(null, node);
			this._triggerRendering(data);
			// K.D. November 4th, 2013 Bug #156776 When we have render on demand and drag and drop we need to clear the container
			// because we've added the data to the data source and we've rendered an item upon drop and thus we end up with two 
			// items when we pass through this method
			ul.html(this._initChildrenRecursively(node.attr('data-path'), data, parseInt(ul.attr('data-depth'), 10), checked));
			ul.attr('data-populated', true);
			if (this.options.dragAndDrop) {
				this._initDragAndDrop(ul);
			}
			this._triggerRendered();
			this.toggle(node);
			this._loadRequest();
		},
		_executeUrlRequest: function (node, binding, path, key) {
			var opt = this.options, ul, indicator, dataSource, li;
			if (opt.dataSourceUrl && opt.dataSourceUrl.lastIndexOf('?') === -1) {
				opt.dataSourceUrl += '?';
			} else if (!opt.dataSourceUrl) {
				throw new Error($.ig.Tree.locale.noDataSourceUrl);
			}
			dataSource = new $.ig.DataSource({dataSource: opt.dataSourceUrl + '&' + this._encodeUrlPath(path, key) + '&' + this._encodeBinding(binding) + '&depth=' + node.parent().attr('data-depth'), dataSourceType: 'remoteUrl'});
			ul = node.children('ul');
			// Create loading indicator space
			li = $('<li style="width: 20px" data-role="loading">&nbsp;</li>').appendTo(ul);
			ul.show();
			// K.D. December 19th, 2011 Bug #98217 Adding flag pointing that the loading indicator is instantiated by the tree
			indicator = li.igLoading({ includeVerticalOffset: false }).data('igLoading').indicator();
			indicator.show();
			this._populatingNode = {
				ul: ul,
				node: node,
				indicator: indicator
			};
			dataSource.dataBind(this._populateNodeData, this);
		},
		_buildRequestString: function (node) {
			var nodePath, key = '', path = '', binding = this.options.bindings, i, result;

			nodePath = node.attr('data-path').split(this.options.pathSeparator);
			for (i = 0; i < nodePath.length; i++) {
				if (key.length > 0) {
					key += '/';
				}
				key += binding.childDataProperty;
				if (path.length > 0) {
					path += '/';
				}
				path += (binding.primaryKey ? binding.primaryKey + ':' : '') + nodePath[i];
				if (binding.bindings) {
					binding = binding.bindings;
				}
			}
			if (path.length <= 0) {
				result = null;
			} else {
				result = [path, key];
			}
			return result;
		},
		_encodeBinding: function (binding) {
			var temp = 'binding=', item;

			for (item in binding) {
				if (binding.hasOwnProperty(item) && item !== 'bindings' && item !== 'nodeContentTemplate') {
					temp += item.toString() + ':' + binding[item] + ',';
				}
			}
			temp = temp.substr(0, temp.length - 1);
			return temp;
		},
		_encodeUrlPath: function (path, key) {
			var result;
			if (path.lastIndexOf('/') === -1) {
				path += '/@' + key;
				result = 'path=' + path;
			} else {
				result = 'path=' + path.substr(path.lastIndexOf('/') + 1, path.length) + '/@' + key.substr(key.lastIndexOf('/') + 1, key.length);
			}
			return result;
		},
		_updateParentState: function (parent) {
			var expander = parent.children('span[data-role=expander]'),
				self = this;
			// Render expander image if this is the first add operation on a leaf node
			if (expander.length <= 0) {
				parent.removeClass(this.css.nodeNoChildren).addClass(this.css.parentNode);
				// K.D. September 24th, 2013 Bug #152109 Expanding the deleted items causes the tree to collapse
				$(this._renderExpanderImage(false)).prependTo(parent);
			} else if (parent.children('ul').children('li').length <= 0) {// Last child has been deleted
				parent.removeClass(this.css.parentNode).addClass(this.css.nodeNoChildren);
				parent.children('ul').remove();
				expander.remove();
			}
			this._updateImage(parent);
		},
		_updateParentCheckbox: function (parent) {
			var checkbox = parent.children('span[data-role=checkbox]'), checkIcon = checkbox.children('span'), checkState = checkbox.attr('data-chk'), shouldBe, checkCount = 0, css = this.css;
			parent.children('ul').children('li').each(function (index, element) {
				if ($(element).children('span[data-role=checkbox]').attr('data-chk') === 'on') {
					checkCount++;
				}
			});
			if (checkCount === 0) {
				shouldBe = 'off';
			} else if (checkCount === parent.children('ul').children('li').length) {
				shouldBe = 'on';
			} else {
				shouldBe = 'partial';
			}
			if (checkState !== shouldBe) {
				checkbox.attr('data-chk', shouldBe);
				switch (shouldBe) {
				case 'off':
					checkIcon.removeClass(css.checkboxOn).removeClass(css.checkboxPartial).addClass(css.checkboxOff);
					break;
				case 'partial':
					checkIcon.removeClass(css.checkboxOn).removeClass(css.checkboxOff).addClass(css.checkboxPartial);
					break;
				case 'on':
					checkIcon.removeClass(css.checkboxPartial).removeClass(css.checkboxOff).addClass(css.checkboxOn);
					break;
				default:
					checkIcon.removeClass(css.checkboxOn).removeClass(css.checkboxPartial).addClass(css.checkboxOff);
				}
				parent = this.parentNode(parent);
				if (parent) {
					this._updateParentCheckbox(parent);
				}
			}
		},
		_updateImage: function (parent) {
			var hasChildren = parent.children('ul').children('li').length > 0, opt = this.options, img;
			if (!hasChildren) {
				if (opt.leafNodeImageUrl) {
					img = parent.children('img[data-role=parent-node-image]');
					if (img.length > 0) {
						img.attr('title', (opt.leafNodeImageTooltip !== null ? opt.leafNodeImageTooltip : ''));
						img.attr('src', opt.leafNodeImageUrl);
						img.attr('data-role', 'leaf-node-image');
					}
				} else if (opt.leafNodeImageClass) {
					img = parent.children('span[data-role=parent-node-image]');
					if (img.length > 0) {
						img.attr('title', (opt.leafNodeImageTooltip !== null ? opt.leafNodeImageTooltip : ''));
						img.removeClass(opt.parentNodeImageClass).addClass(opt.leafNodeImageClass);
						img.attr('data-role', 'leaf-node-image');
					}
				}
			} else {
				if (opt.parentNodeImageUrl) {
					img = parent.children('img[data-role=leaf-node-image]');
					if (img.length > 0) {
						img.attr('title', (opt.parentNodeImageTooltip !== null ? opt.parentNodeImageTooltip : ''));
						img.attr('src', opt.parentNodeImageUrl);
						img.attr('data-role', 'parent-node-image');
					}
				} else if (opt.parentNodeImageClass) {
					img = parent.children('span[data-role=leaf-node-image]');
					if (img.length > 0) {
						img.attr('title', (opt.parentNodeImageTooltip !== null ? opt.parentNodeImageTooltip : ''));
						img.removeClass(opt.leafNodeImageClass).addClass(opt.parentNodeImageClass);
						img.attr('data-role', 'parent-node-image');
					}
				}
			}
		},
		_addData: function (data, path, depth, dataIndex) {
			var originalData = this.nodeDataFor(path),
				binding = this._retrieveCurrentDepthBinding(depth),
				temp,
				i;
			if (!binding.hasOwnProperty('primaryKey')) {
				if (!originalData) {
					if (this.options.dataSource._rootds._data.length <= this.element.find('.ui-igtree-noderoot').length || this.element.find('.ui-igtree-noderoot').length <= 0) {
						if (dataIndex === 0) {
							if ($.type(data) === 'array') {
								this.options.dataSource._rootds._data = data.concat(this.options.dataSource._rootds._data);
							} else {
								this.options.dataSource._rootds._data = [data].concat(this.options.dataSource._rootds._data);
							}
						} else if (!dataIndex) {
							if ($.type(data) === 'array') {
								for (i = 0; i < data.length; i++) {
									this.options.dataSource._rootds._data.push(data[i]);
								}
							} else {
								this.options.dataSource._rootds._data.push(data);
							}
						} else {
							this.options.dataSource._rootds._data.splice(dataIndex, 0, data);
						}
					}
				} else {
					if (typeof originalData[binding.childDataProperty] !== 'function') {
						if (!originalData.hasOwnProperty(binding.childDataProperty) || !originalData[binding.childDataProperty] || originalData[binding.childDataProperty].length === 0) {
							originalData[binding.childDataProperty] = [];
						}
						if (dataIndex === 0) {
							if ($.type(data) === 'array') {
								originalData[binding.childDataProperty] = data.concat(originalData[binding.childDataProperty]);
							} else {
								originalData[binding.childDataProperty] = [data].concat(originalData[binding.childDataProperty]);
							}
						} else if (!dataIndex) {
							originalData[binding.childDataProperty] = originalData[binding.childDataProperty].concat(data);
						} else {
							temp = originalData[binding.childDataProperty].slice(0, dataIndex);
							temp = temp.concat(data);
							originalData[binding.childDataProperty] = temp.concat(originalData[binding.childDataProperty].slice(dataIndex));
						}
					} else {
						if (originalData[binding.childDataProperty]().length <= this.nodeByPath(path).children('ul').children('li').length) {
							if (dataIndex === 0) {
								temp = $('<li></li>').appendTo(this.nodeByPath(path).children('ul'));
								originalData[binding.childDataProperty].unshift(data);
								temp.remove();
							} else if (!dataIndex) {
								temp = $('<li></li>').appendTo(this.nodeByPath(path).children('ul'));
								originalData[binding.childDataProperty].push(data);
								temp.remove();
							} else {
								temp = $('<li></li>').appendTo(this.nodeByPath(path).children('ul'));
								originalData[binding.childDataProperty]().splice(dataIndex, 0, data);
								temp.remove();
							}
						}
					}
				}
			} else {
				if (!originalData) {
					if (this.options.dataSource._rootds._data.length <= this.element.find('.ui-igtree-noderoot').length || this.element.find('.ui-igtree-noderoot').length <= 0) {
						if ($.type(data) === 'array') {
							for (i = 0; i < data.length; i++) {
								this.options.dataSource._rootds._data.push(data[i]);
							}
						} else {
							this.options.dataSource._rootds._data.push(data);
						}
					}
				} else {
					if (typeof originalData[binding.childDataProperty] !== 'function') {
						if (!originalData.hasOwnProperty(binding.childDataProperty) || !originalData[binding.childDataProperty] || originalData[binding.childDataProperty].length === 0) {
							originalData[binding.childDataProperty] = [];
						}
						originalData[binding.childDataProperty] = originalData[binding.childDataProperty].concat(data);
					} else {
						if (originalData[binding.childDataProperty]().length <= this.nodeByPath(path).children('ul').children('li').length) {
							temp = $('<li></li>').appendTo(this.nodeByPath(path).children('ul'));
							originalData[binding.childDataProperty].push(data);
							temp.remove();
						}
					}
				}
			}
		},
		_removeData: function (path) {
			var splitPath = path.split(this.options.pathSeparator), data = this.options.dataSource._rootds.data(), i, j, binding = this.options.bindings, key;

			if (splitPath.length === 1) {
				if (!binding.hasOwnProperty('primaryKey')) {
					data.splice(parseInt(splitPath[0], 10), 1);
				} else {
					for (j = 0; j < data.length; j++) {
						if (data[j].hasOwnProperty(binding.primaryKey)) {
							key = typeof data[j][binding.primaryKey] === 'function' ? data[j][binding.primaryKey]() : data[j][binding.primaryKey];
							if (key.toString() === splitPath[0].toString()) {
								data.splice(j, 1);
								break;
							}
						}
					}
				}
				return;
			}
			for (i = 0; i < splitPath.length - 1; i++) {
				if (!binding.hasOwnProperty('primaryKey')) {
					data = data[parseInt(splitPath[i], 10)];
				} else {
					for (j = 0; j < data.length; j++) {
						if (data[j].hasOwnProperty(binding.primaryKey)) {
							key = typeof data[j][binding.primaryKey] === 'function' ? data[j][binding.primaryKey]() : data[j][binding.primaryKey];
							if (key.toString() === splitPath[i].toString()) {
								data = data[j];
								break;
							}
						}
					}
				}
				if (i < splitPath.length - 2) {
					if (data[binding.childDataProperty] && typeof data[binding.childDataProperty] === 'function') {
						data = data[binding.childDataProperty]();
					} else {
						data = data[binding.childDataProperty];
					}
				}
				if (binding.hasOwnProperty('bindings') && i < splitPath.length - 2) {
					binding = binding.bindings;
				}
			}
			if (data[binding.childDataProperty] && typeof data[binding.childDataProperty] !== 'function') {
				if (data[binding.childDataProperty] && data[binding.childDataProperty].length <= 1) {
					delete data[binding.childDataProperty];
				} else {
					data = data[binding.childDataProperty];
					if (binding.hasOwnProperty('bindings')) {
						binding = binding.bindings;
					}
					if (!binding.hasOwnProperty('primaryKey') && data.length) {
						data.splice(parseInt(splitPath[splitPath.length - 1], 10), 1);
					} else {
						for (j = 0; j < data.length; j++) {
							if (data[j].hasOwnProperty(binding.primaryKey) && data[j][binding.primaryKey].toString() === splitPath[i].toString()) {
								data.splice(j, 1);
								break;
							}
						}
					}
				}
			} else {
				data = data[binding.childDataProperty]();
				if (binding.hasOwnProperty('bindings')) {
					binding = binding.bindings;
				}
				if (!binding.hasOwnProperty('primaryKey') && data.length) {
					data.splice(parseInt(splitPath[splitPath.length - 1], 10), 1);
				} else {
					for (j = 0; j < data.length; j++) {
						if (data[j].hasOwnProperty(binding.primaryKey)) {
							key = typeof data[j][binding.primaryKey] === 'function' ? data[j][binding.primaryKey]() : data[j][binding.primaryKey];
							if (key.toString() === splitPath[splitPath.length - 1].toString()) {
								data.splice(j, 1);
								break;
							}
						}
					}
				}
			}
		},
		_recalculatePaths: function (path) {
			var splitPath = path.split(this.options.pathSeparator), index = path.length > 0 ? splitPath[splitPath.length - 1] : 0, node, parentPath, newPath, ul, child;
			if (splitPath.length > 1) {
				splitPath.splice(splitPath.length - 1, 1);
				parentPath = splitPath.join(this.options.pathSeparator);
				node = this.nodeByPath(parentPath);
				for (index; index < node.children('ul').children('li').length; index++) {
					newPath = parentPath + this.options.pathSeparator + index;
					child = $(node.children('ul').children('li')[index]);
					child.attr('data-path', newPath);
					if (child.children('ul').length > 0 && child.children('ul').children('li').length > 0) {
						this._recalculatePaths(newPath + this.options.pathSeparator + '0');
					}
				}
			} else {
				ul = this.element.is('ul') ? this.element : this.element.children('ul');
				for (index; index < ul.children('li').length; index++) {
					child = $(ul.children('li')[index]);
					child.attr('data-path', index);
					if (child.children('ul').length > 0 && child.children('ul').children('li').length > 0) {
						this._recalculatePaths(index + this.options.pathSeparator + '0');
					}
				}
			}
		},
		// K.D. November 22nd, 2012 Implementing a request chain for expandToNode with Load on Demand
		_loadQueue: null,
		_toSelect: false,
		_triggerChainRequest: function (path, toSelect) {
			var list = path.split(this.options.pathSeparator), i, newPath = '';
			if (this._loadQueue === null) {
				this._loadQueue = [];
			}
			if (toSelect) {
				this._toSelect = true;
			}
			for (i = 0; i < list.length; i++) {
				newPath += list[i];
				this._loadQueue.push(newPath);
				newPath += this.options.pathSeparator;
			}
			this._loadRequest();
		},
		_loadRequest: function () {
			var node;
			if (this._populatingNode === null) {
				if (this._loadQueue && this._loadQueue.length > 0) {
					node = this.nodeByPath(this._loadQueue.shift());
					if (this._loadQueue.length > 0) {
						this.expand(node);
					} else if (this._toSelect) {
						this.select(node);
						this._toSelect = false;
					}
				}
			}
		},
		_replaceUIValue: function (node, data, item) {
			var element = node.element, binding = this._retrieveCurrentDepthBinding(parseInt(element.parent().attr('data-depth'), 10)), value;
			// K.D. August 15th, 2013 Bug #149367 The member does not necessarily need to be observable
			switch (item) {
			    case binding.textKey:
                // K.D. June 25th, 2014 Bug #173722 Adding handling for templates
				if (!binding.nodeContentTemplate) {
					value = typeof data[item] === 'function' ? data[item]() : data[item];
					element.children('a').text(value);
				} else {
					element.children('a').replaceWith(this._renderNodeTemplate(data, binding));
				}
				break;
			case binding.valueKey:
				value = typeof data[item] === 'function' ? data[item]() : data[item];
				element.attr('data-value', value);
				break;
			case binding.navigateUrlKey:
				value = typeof data[item] === 'function' ? data[item]() : data[item];
				element.children('a').attr('href', value);
				break;
			case binding.imageUrlKey:
				value = typeof data[item] === 'function' ? data[item]() : data[item];
				element.children('img[data-role=node-image]').attr('src', value);
				break;
			}
		},
		dataBind: function () {
			/* Performs databinding on the tree */
			var dataOpt;

			dataOpt = this._initDataOptions();
			this._initDataSource(dataOpt);
			this._triggerDataBinding();
			this.options.dataSource.dataBind(this._constructFromData, this);
		},
		toggleCheckstate: function (node, event) {
			/* Toggles the checkstate of a node if checkboxMode is not set to off, otherwise does nothing.
				paramType="object" optional="false" Specifies the jQuery object of the node element the checkbox of which would be toggled.
				paramType="object" optional="true" Indicates the browser even which triggered this action (not API).
			*/
			var self = this, opt = self.options, css = self.css, childCheckboxes, childCheckIcons, checkbox, checkIcon, parentLi, noCancel;
			// K.D. November 28th, 2011 Bug #96672 Checking if no argument is provided when doing the API call
			if (!node) {
				throw new Error($.ig.Tree.locale.incorrectNodeObject);
			}
			if (!opt.checkboxMode || opt.checkboxMode.toLowerCase() === 'off') {
				return;
			}

			checkbox = node.children('span[data-role=checkbox]');
			checkIcon = checkbox.children('span');
			noCancel = self._triggerNodeCheckstateChanging(event, node);
			if (noCancel) {
				if (opt.checkboxMode.toLowerCase() === 'tristate') {
					if (checkbox.attr('data-chk') === 'on' || checkbox.attr('data-chk') === 'partial') {
						childCheckboxes = node.find('span[data-role=checkbox]');
						childCheckIcons = childCheckboxes.children('span');
						checkbox.attr('data-chk', 'off');
						checkIcon.removeClass(css.checkboxOn).removeClass(css.checkboxPartial).addClass(css.checkboxOff);
						childCheckboxes.attr('data-chk', 'off');
						childCheckIcons.removeClass(css.checkboxOn).removeClass(css.checkboxPartial).addClass(css.checkboxOff);

						parentLi = checkbox.parent().parent().parent();
						while (parentLi && parentLi.is('li')) {
							// All child checkboxes are unchecked
							if (parentLi.find('ul > li > span[data-chk=on]').length <= 0) {
								checkbox = parentLi.children('span[data-role=checkbox]');
								checkIcon = checkbox.children('span');
								checkbox.attr('data-chk', 'off');
								checkIcon.removeClass(css.checkboxOn).removeClass(css.checkboxPartial).addClass(css.checkboxOff);
								parentLi = this.parentNode(parentLi);
							} else {
								checkbox = parentLi.children('span[data-role=checkbox]');
								checkIcon = checkbox.children('span');
								checkbox.attr('data-chk', 'partial');
								checkIcon.removeClass(css.checkboxOn).removeClass(css.checkboxOff).addClass(css.checkboxPartial);
								parentLi = this.parentNode(parentLi);
							}
						}
					} else {
						childCheckboxes = node.find('span[data-role=checkbox]');
						childCheckIcons = childCheckboxes.children('span');
						checkbox.attr('data-chk', 'on');
						checkIcon.removeClass(css.checkboxOff).removeClass(css.checkboxPartial).addClass(css.checkboxOn);
						childCheckboxes.attr('data-chk', 'on');
						childCheckIcons.removeClass(css.checkboxOff).removeClass(css.checkboxPartial).addClass(css.checkboxOn);

						parentLi = checkbox.parent().parent().parent();
						while (parentLi && parentLi.is('li')) {
							// All childcheckboxes are checked
							if (parentLi.find('ul > li > span[data-chk=on]').length === parentLi.find('ul > li').length) {
								checkbox = parentLi.children('span[data-role=checkbox]');
								checkIcon = checkbox.children('span');
								checkbox.attr('data-chk', 'on');
								checkIcon.removeClass(css.checkboxOff).removeClass(css.checkboxPartial).addClass(css.checkboxOn);
								parentLi = this.parentNode(parentLi);
							} else {
								checkbox = parentLi.children('span[data-role=checkbox]');
								checkIcon = checkbox.children('span');
								checkbox.attr('data-chk', 'partial');
								checkIcon.removeClass(css.checkboxOn).removeClass(css.checkboxOff).addClass(css.checkboxPartial);
								parentLi = this.parentNode(parentLi);
							}
						}
					}
				} else {
					if (checkbox.attr('data-chk') === 'on' || checkbox.attr('data-chk') === 'partial') {
						checkbox.attr('data-chk', 'off');
						checkIcon.removeClass(css.checkboxOn).removeClass(css.checkboxPartial).addClass(css.checkboxOff);
					} else {
						checkbox.attr('data-chk', 'on');
						checkIcon.removeClass(css.checkboxOff).addClass(css.checkboxOn);
					}
				}
				self._triggerNodeCheckstateChanged(event, node);
			}
		},
		toggle: function (node, event) {
			/* Toggles the collapse/expand for the specified node.
				paramType="object" optional="false" Specifies the jQuery object of the node element the checkbox of which would be toggled.
				paramType="object" optional="true" Indicates the browser even which triggered this action if this is not an API call.
			*/
			var self = this, opt = self.options, css = self.css, noCancel, sibling, siblingExpander, i = 0, expander;
			// K.D. November 28th, 2011 Bug #96672 Checking if no argument is provided when doing the API call
			if (!node) {
				throw new Error($.ig.Tree.locale.incorrectNodeObject);
			}
			if (!event) {
				expander = node.children('.' + css.nodeExpander);
			} else {
				expander = $(event.target).closest('span[data-role=expander]');
			}

			if (node.children('ul').attr('data-populated') && node.children('ul').attr('data-populated') === 'false') {
				this._prepareRequest(node, event);
				return;
			}

			if (expander.attr('data-exp') && expander.attr('data-exp') !== 'false') {
				noCancel = self._triggerNodeCollapsing(event, node);

				if (noCancel) {
					$(node).children('ul').hide(opt.animationDuration, function () {
						self._triggerNodeCollapsed(event, node);
					});
					expander.removeClass(css.collapseIcon).addClass(css.expandIcon).attr('data-exp', false);
				}
			} else {
				noCancel = self._triggerNodeExpanding(event, node);

				if (noCancel) {
					// Performing collapse on the same level if single expand is enabled
					if (opt.singleBranchExpand) {
						sibling = node.siblings();

						for (i; i < sibling.length; i++) {
							siblingExpander = $(sibling[i]).children('.' + css.nodeExpander);
							if (siblingExpander.length > 0 && (siblingExpander.attr('data-exp') === 'true' || siblingExpander.attr('data-exp') === true)) {
								noCancel = self._triggerNodeCollapsing(event, $(sibling[i]));

								if (noCancel) {
									$(sibling[i]).children('ul').hide(opt.animationDuration, $.proxy(this._triggerNodeCollapsed(event, $(sibling[i])), this));
									siblingExpander.removeClass(css.collapseIcon).addClass(css.expandIcon).attr('data-exp', false);
								}
							}
						}
					}

					node.children('ul').show(opt.animationDuration, function () {
						self._triggerNodeExpanded(event, node);
					});
					expander.removeClass(css.expandIcon).addClass(css.collapseIcon).attr('data-exp', true);
				}
			}
		},
		expandToNode: function (node, toSelect) {
			/* Expands the tree down to the specified node.
				paramType="object" optional="false" Specifies the jQuery object of the node element down to which the tree would be expanded.
				paramType="bool" optional="true" Specifies the whether to select the node after expanding to it.
			*/
			var parentNode, cachedanimationDuration;
			// K.D. November 28th, 2011 Bug #96672 Checking if no argument is provided when doing the API call
			if (node && node.length > 0) {
				if (typeof node === 'string' && this.nodeByPath(node).length > 0) {
					node = this.nodeByPath(node);
				}
				if (typeof node === 'string' && this.options.loadOnDemand) {
					this._triggerChainRequest(node, toSelect);
					return;
				}
				if (toSelect) {
					this.select(node);
				}
				parentNode = this.parentNode(node);
				cachedanimationDuration = this.options.animationDuration;
				this.options.animationDuration = 0;
				while (parentNode) {
					this.expand(parentNode);
					parentNode = this.parentNode(parentNode);
				}
				this.options.animationDuration = cachedanimationDuration;
			}
		},
		expand: function (node) {
			/* Expands the specified node.
				paramType="object" optional="false" Specifies the jQuery object of the node element to expand.
			*/
			var self = this, opt = self.options, css = self.css, sibling, siblingExpander, i = 0, expander;

			// K.D. November 28th, 2011 Bug #96672 Checking if no argument is provided when doing the API call
			if (!node || node.length <= 0) {
				throw new Error($.ig.Tree.locale.incorrectNodeObject);
			}

			if (node.children('ul').attr('data-populated') && node.children('ul').attr('data-populated') === 'false') {
				this._prepareRequest(node);
				return;
			}

			expander = node.children('.' + css.nodeExpander);

			if (!expander.attr('data-exp') || expander.attr('data-exp') === 'false') {
				// Performing collapse on the same level if single expand is enabled
				if (opt.singleBranchExpand) {
					sibling = node.siblings();

					for (i; i < sibling.length; i++) {
						siblingExpander = $(sibling[i]).children('.' + css.nodeExpander);
						if (siblingExpander.length > 0 && (siblingExpander.attr('data-exp') === 'true' || siblingExpander.attr('data-exp') === true)) {
							$(sibling[i]).children('ul').hide(opt.animationDuration);
							siblingExpander.removeClass(css.collapseIcon).addClass(css.expandIcon).attr('data-exp', false);
						}
					}
				}

				node.children('ul').show(opt.animationDuration);
				expander.removeClass(css.expandIcon).addClass(css.collapseIcon).attr('data-exp', true);
			}
		},
		collapse: function (node) {
			/* Collapses the specified node.
				paramType="object" optional="false" Specifies the jQuery object of the node element to collapse.
			*/
			var self = this, opt = self.options, css = self.css, expander;
			// K.D. November 28th, 2011 Bug #96672 Checking if no argument is provided when doing the API call
			if (!node || node.length <= 0) {
				throw new Error($.ig.Tree.locale.incorrectNodeObject);
			}
			expander = node.children('.' + css.nodeExpander);

			if (expander.attr('data-exp') && expander.attr('data-exp') !== 'false') {
				$(node).children('ul').hide(opt.animationDuration);
				expander.removeClass(css.collapseIcon).addClass(css.expandIcon).attr('data-exp', false);
			}
		},
		parentNode: function (node) {
			/* Retrieves the parent node of the specified node.
				paramType="object" optional="false" Specifies the jQuery selected node element to collapse.
				returnType="object" Returns the jQuery object of the parent node element, null if the node is a root level node. 
			*/
			if (!node) {
				throw new Error($.ig.Tree.locale.incorrectNodeObject);
			}
			var parent = node.parent().closest('li[data-role=node]');
			return parent.length > 0 ? parent : null;
		},
		nodeByPath: function (nodePath) {
			/* Retrieves the jQuery element of the node with the specified path.
				paramType="string" optional="false" Specifies the path to the required node.
				returnType="object" Returns the jQuery selected node element with the specified path. The length property would be 0 if node isn't found. 
			*/
			return this.element.find('li[data-path="' + nodePath + '"]');
		},
		nodesByValue: function (value) {
			/* Retrieves the jQuery element of the node with the specified value.
				paramType="string" optional="false" Specifies the value of the required node.
				returnType="object" Returns the jQuery object of the node element with the specified value. The length property would be 0 if node isn't found. 
			*/
			return this.element.find('li[data-value="' + value + '"]');
		},
		checkedNodes: function () {
			/* Retrieves all the node objects that have their checkboxes checked.
				returnType="array" Returns the jQuery array of all the checked nodes.
			*/
			var elements = this.element.find('span[data-chk=on]').parent(), i = 0, collection = [];
			if (elements.length > 0) {
				for (i; i < elements.length; i++) {
					collection.push(this.nodeFromElement($(elements[i])));
				}
				return collection;
			}
		},
		uncheckedNodes: function () {
			/* Retrieves all the node objects that have their checkboxes unchecked.
				returnType="array" Returns the jQuery array of all the unchecked nodes.
			*/
			var elements = this.element.find('span[data-chk=off]').parent(), i = 0, collection = [];
			if (elements.length > 0) {
				for (i; i < elements.length; i++) {
					collection.push(this.nodeFromElement($(elements[i])));
				}
				return collection;
			}
		},
		partiallyCheckedNodes: function () {
			/* Retrieves all the node objects that have their checkboxes partially checked.
				returnType="array" Returns the jQuery array of all the partially checked nodes.
			*/
			var elements = this.element.find('span[data-chk=partial]').parent(), i = 0, collection = [];
			if (elements.length > 0) {
				for (i; i < elements.length; i++) {
					collection.push(this.nodeFromElement($(elements[i])));
				}
				return collection;
			}
		},
		select: function (node, event) {
			/* Selects a node.
				paramType="object" optional="false" Specifies the jQuery object of the node element to be toggled.
				paramType="object" optional="true" Indicates the browser even which triggered this action (not API).
			*/
			// K.D. November 28th, 2011 Bug #96672 Checking if no argument is provided when doing the API call
			if (!node || node.length <= 0) {
				throw new Error($.ig.Tree.locale.incorrectNodeObject);
			}
			var css = this.css, nodeId = node.attr('data-path'), noCancel, prevent = false;

			if (event && (node.children('a').attr('href') === '#' || node.children('a').attr('href') === document.URLUnencoded + '#')) {
				prevent = true;
			}

			if (!this._selectedNode) {
				this._selectedNode = [{path: null, element: null, data: null, binding: null}];
			}

			// To do: Implement multiple selection logic
			if (this._selectedNode[0].path !== null) {
				if (this._selectedNode[0].path !== nodeId) {
					noCancel = this._triggerSelectionChanging(event, node);

					if (noCancel) {
						this._selectedNode[0].element.children('a').removeClass(css.nodeSelected);
						node.children('a').addClass(css.nodeSelected);
						this._selectedNode[0] = this.nodeFromElement(node);
						this._triggerSelectionChanged(event);
					} else if (event) {
						prevent = true;
					}
				}
			} else {
				noCancel = this._triggerSelectionChanging(event, node);

				if (noCancel) {
					node.children('a').addClass(css.nodeSelected);
					this._selectedNode[0] = this.nodeFromElement(node);
					this._triggerSelectionChanged(event);
				} else if (event) {
					prevent = true;
				}
			}

			if (prevent) {
				event.preventDefault();
			}
		},
		deselect: function (node) {
			/* Deselects the specified node.
				paramType="object" optional="false" Specifies the jQuery object of the node element to be deselected.
			*/
			// K.D. November 28th, 2011 Bug #96672 Checking if no argument is provided when doing the API call
			if (!node) {
				throw new Error($.ig.Tree.locale.incorrectNodeObject);
			}
			var opt = this.options, css = this.css, nodeId = node.attr('data-path');

			if (!this._selectedNode) {
				this._selectedNode = [{path: null, element: null, data: null, binding: null}];
			}

			if (opt.multipleSelection) {
				opt = this.options;
				// To do: Multiple selection logic 
			} else {
				if (this._selectedNode[0].path !== null) {
					if (this._selectedNode[0].path === nodeId) {
						node.children('a').removeClass(css.nodeSelected);
						this._selectedNode[0].path = null;
						this._selectedNode[0].element = null;
						this._selectedNode[0].data = null;
						this._selectedNode[0].binding = null;
					}
				}
			}
		},
		clearSelection: function () {
			/* Deselects all the selected nodes. */
			var css = this.css, i = 0;
			// K.D. August 16th, 2013 Bug #149419 Clearing selection before selecting anything results in an exception
			if (this._selectedNode && this._selectedNode[0].path !== null) {
				for (i; i < this._selectedNode.length; i++) {
					this._selectedNode[i].element.children('a').removeClass(css.nodeSelected);
				}
				this._selectedNode = [{
					path: null,
					element: null,
					data: null,
					binding: null
				}];
			}
		},
		selectedNode: function () {
			/* Retrieves the selected node.
				returnType="object" Object description: { path: "node_path", element: jQuery LI Element, data: data, binding: binding }
			*/
			if (!this._selectedNode) {
				this._selectedNode = [{path: null, element: null, data: null, binding: null}];
			}
			return this._selectedNode[0];
		},
		findNodesByText: function (text, parent) {
			/* Retrieves all node objects with the specified text (case sensitive).
				paramType="string" optional="false" The text to search by.
				paramType="object" optional="true" The jQuery selected node element. If not specified then search would start from the root of the tree.
				returnType="object" Object description: { path: "node_path", element: jQuery LI Element, data: data, binding: binding }
			*/
			var collection = [], nodes, self = this;
			nodes = parent ? parent.find('li > a:contains("' + text + '")') : this.element.find('li > a:contains("' + text + '")');
			nodes.each(function (index, element) {
				collection.push(self.nodeFromElement($(this).closest('li[data-role=node]')));
			});
			// if (parent && parent.length > 0) {
				// data = this.nodeDataFor(parent.attr('data-path'));
				// binding = this._retrieveCurrentDepthBinding(parent.parent().attr('data-depth'));
				// if (binding.hasOwnProperty('childDataProperty') && data.hasOwnProperty(binding.childDataProperty)) {
					// data = data[binding.childDataProperty];
					// tempPath = parent.attr('data-path') + this.options.pathSeparator;
					// if (binding.hasOwnProperty('bindings')) {
						// binding = binding.bindings;
					// }
				// } else {
					// return collection;
				// }
			// } else {
				// data = this.options.dataSource.root().data();
				// binding = this.options.bindings;
				// tempPath = '';
			// }

			// if (data) {
				// for (i = 0; i < data.length; i++) {
					// if (data[i][binding.textKey].toString() === text) {
						// if (binding.hasOwnProperty('primaryKey') && data[i].hasOwnProperty(binding.primaryKey)) {
							// tempNode = this.nodeByPath(tempPath + data[i][binding.primaryKey]);
							// collection.push(this.nodeFromElement(tempNode));
							// collection = collection.concat(this.findNodesByText(text, tempNode));
						// } else {
							// tempNode = this.nodeByPath(tempPath + i);
							// collection.push(this.nodeFromElement(tempNode));
							// collection = collection.concat(this.findNodesByText(text, tempNode));
						// }
					// } else {
						// if (binding.hasOwnProperty('primaryKey') && data[i].hasOwnProperty(binding.primaryKey)) {
							// tempNode = this.nodeByPath(tempPath + data[i][binding.primaryKey]);
							// collection = collection.concat(this.findNodesByText(text, tempNode));
						// } else {
							// tempNode = this.nodeByPath(tempPath + i);
							// collection = collection.concat(this.findNodesByText(text, tempNode));
						// }
					// }
				// }
			// }
			return collection;
		},
		findImmediateNodesByText: function (text, parent) {
			/* Retrieves all immediate children of the specified parent with the specified text (case sensitive).
				paramType="string" optional="false" The text to search by.
				paramType="object" optional="true" The jQuery selected node element the children of which would be retrieved.
				returnType="object" Object description: { path: "node_path", element: jQuery LI Element, data: data, binding: binding }
			*/
			var collection = [], nodes, self = this;
			nodes = parent ? parent.children('ul').children('li').children('a:contains("' + text + '")') : 
				this.element.is('ul') ? this.element.children('li').children('a:contains("' + text + '")') : 
					this.element.children('ul').children('li').children('a:contains("' + text + '")');
			nodes.each(function (index, element) {
				collection.push(self.nodeFromElement($(this).closest('li[data-role=node]')));
			});
			// if (parent && parent.length > 0) {
				// binding = this._retrieveCurrentDepthBinding(parent.parent().attr('data-depth'));
				// data = this.nodeDataFor(parent.attr('data-path'));
				// if (binding.hasOwnProperty('childDataProperty') && data.hasOwnProperty(binding.childDataProperty)) {
					// data = data[binding.childDataProperty];
					// tempPath = parent.attr('data-path');
					// if (binding.hasOwnProperty('bindings')) {
						// binding = binding.bindings;
					// }
				// } else {
					// return collection;
				// }
				// for (i = 0; i < data.length; i++) {
					// if (data[i][binding.textKey].toString() === text) {
						// if (binding.hasOwnProperty('primaryKey') && data[i].hasOwnProperty(binding.primaryKey)) {
							// tempNode = this.nodeByPath(tempPath + this.options.pathSeparator + data[i][binding.primaryKey]);
							// collection.push(this.nodeFromElement(tempNode));
						// } else {
							// tempNode = this.nodeByPath(tempPath + this.options.pathSeparator + i);
							// collection.push(this.nodeFromElement(tempNode));
						// }
					// }
				// }
			// } else {
				// binding = this.options.bindings;
				// data = this.options.dataSource.root().data();
				// for (i = 0; i < data.length; i++) {
					// if (data[i][binding.textKey].toString() === text) {
						// if (binding.hasOwnProperty('primaryKey') && data[i].hasOwnProperty(binding.primaryKey)) {
							// tempNode = this.nodeByPath(data[i][binding.primaryKey]);
							// collection.push(this.nodeFromElement(tempNode));
						// } else {
							// tempNode = this.nodeByPath(i);
							// collection.push(this.nodeFromElement(tempNode));
						// }
					// }
				// }
			// }
			return collection;
		},
		nodeByIndex: function (index, parent) {
			/* Retrieves the n-th jQuery node element child of the specified parent.
				paramType="number" optional="false" Specifies the index to be retrieved.
				paremType="object" optional="true" The jQuery object of the parent node element.
				returnType="object" The jQuery object of the node element.
			*/
			var node;
			if (!parent) {
				if (this.element.is('ul')) {
					node = this.element.children().eq(index);
				} else {
					node = this.element.children('ul').children().eq(index);
				}
			} else {
				node = parent.children('ul').children().eq(index);
			}
			return node;
		},
		nodeFromElement: function (element) {
			/* Retrieves a node object from provided jQuery node element.
				paramType="object" optional="false" Specifies the jQuery object of the node element.
				returnType="object" Object description: { path: "node_path", element: jQuery LI Element, data: data, binding: binding }
			*/
			if (element.length > 0) {
				var nodeElement = {
					path: element.attr('data-path'),
					element: element,
					data: this.nodeDataFor(element.attr('data-path')),
					binding: this._retrieveCurrentDepthBinding(element.parent().attr('data-depth'))
				};
				return nodeElement;
			}
		},
		children: function (parent) {
			/* Retrieves a node object collection of the immediate children of the provided node.
				paramType="object" optional="false" Specifies the jQuery object of the node element.
				returnType="object" Object description: { path: "node_path", element: jQuery LI Element, data: data, binding: binding }
			*/
			var children = [], self = this, child, ul;
			if (parent && parent.length > 0) {
				ul = parent.children('ul');
				if (ul.length > 0) {
					ul.children('li').each(function (index) {
						child = $(this);
						children.push(self.nodeFromElement(child));
					});
				}
				return children;
			}
			throw new Error($.ig.Tree.locale.incorrectNodeObject);
		},
		childrenByPath: function (path) {
			/* Retrieves a node object collection of the immediate children of the node with the provided path.
				paramType="string" optional="false" Specifies the path of the node the children of which are being retrieved.
				returnType="object" Object description: { path: "node_path", element: jQuery LI Element, data: data, binding: binding }
			*/
			var node = this.nodeByPath(path), children = [], self = this, child, ul;
			if (node.length > 0) {
				ul = node.children('ul');
				if (ul.length > 0) {
					ul.children('li').each(function (index) {
						child = $(this);
						children.push(self.nodeFromElement(child));
					});
				}
				return children;
			}
			throw new Error($.ig.Tree.locale.incorrectPath + path);
		},
		isSelected: function (node) {
			/* Returns true if the provided node is selected and false otherwise.
				paramType="object" optional="false" Specifies the jQuery object of the node element.
				returnType="bool"
			*/
			if (!this._selectedNode) {
				this._selectedNode = [{path: null, element: null, data: null, binding: null}];
			}
			if (node && node.length > 0) {
				return this._selectedNode[0].path === node.attr('data-path');
			}
			throw new Error($.ig.Tree.locale.incorrectNodeObject);
		},
		isExpanded: function (node) {
			/* Returns true if the provided node is expanded and false otherwise.
				paramType="object" optional="false" Specifies the jQuery object of the node element.
				returnType="bool"
			*/
			if (node && node.length > 0) {
				var expander = node.children('span[data-role=expander]');
				if (expander.length > 0) {
					return expander.attr('data-exp') === 'true';
				}
			} else {
				throw new Error($.ig.Tree.locale.incorrectNodeObject);
			}
		},
		isChecked: function (node) {
			/* Returns true if the provided node has its checkstate checked and false otherwise.
				paramType="object" optional="false" Specifies the jQuery object of the node element.
				returnType="bool"
			*/
			if (node && node.length > 0) {
				var checkbox = node.children('span[data-role=checkbox]');
				if (checkbox.length > 0) {
					return checkbox.attr('data-chk') === 'on';
				}
			} else {
				throw new Error($.ig.Tree.locale.incorrectNodeObject);
			}
		},
		checkState: function (node) {
			/* Returns true if the provided node has its checkstate checked and false otherwise.
				paramType="object" optional="false" Specifies the jQuery object of the node element.
				returnType="string" The checkbox state of the node.
			*/
			if (node && node.length > 0) {
				var checkbox = node.children('span[data-role=checkbox]');
				if (checkbox.length > 0) {
					return checkbox.attr('data-chk');
				}
			} else {
				throw new Error($.ig.Tree.locale.incorrectNodeObject);
			}
		},
		addNode: function (node, parent, nodeIndex) {
			/* Adds a new array of nodes to the tree. New nodes are appended to the root or to a specified parent node.
				paramType="object" optional="false" Specifies the data used to create the new node.
				paramType="object" optional="true" Specifies the jQuery object of the parent node the nodes are to be appended to.
				paramType="number" optional="true" Specifies the index at which the node to be inserted.
			*/
			// No data is being passed in
			// K.D. July 24th, 2012 Bug #117457 addNode creates an expansion indicator if the node param is an empty array []
			if (!node || node.length <= 0) {
				return;
			}
			if (!nodeIndex && typeof parent === 'number') {
				nodeIndex = parent;
				parent = null;
			}
			var ul, path, checked, isLi, li, isEmpty, r, binding, self = this;
			// Root node is to be used
			if (!parent) {
				parent = this.element.is('ul') ? this.element : this.element.children('ul');
				// No children case
				if (parent.children().length <= 0) {
					this._addData(node, '', 0);
					this._triggerRendering(node);
					r = $(this._initChildrenRecursively('', node)).appendTo(parent);
					if (this.options.dragAndDrop) {
						this._initDragAndDrop(r);
					}
					this._triggerRendered();
					// Update transaction log
					this.options.dataSource.root().addNode({
						data: node,
						parentPath: '',
						path: r.attr('data-path')
					});
					return;
				}
			}

			isLi = parent.is('li');
			ul = isLi ? parent.children('ul') : parent;
			if (ul.length <= 0) {
				ul = $('<ul data-depth="' + (parseInt(parent.parent().attr('data-depth'), 10) + 1) + '" style="display: none"></ul>').appendTo(parent);
			}
			path = isLi ? parent.attr('data-path') : '';
			binding = this._retrieveCurrentDepthBinding(parseInt(ul.attr('data-depth'), 10));
			if (this.options.checkboxMode.toLowerCase() === 'tristate') {
				checked = isLi ? this.isChecked(parent) : false;
			}
			// K.D. July 3rd, 2012 Bug #116064 We need the parent UL depth not the current UL. This would be at least 0 because the root insert is
			// handled up top.
			this._addData(node, path, parseInt(ul.attr('data-depth'), 10) - 1, nodeIndex);
			this._triggerRendering(node);
			isEmpty = ul.children('li').length <= 0;
			if (nodeIndex === 0) {
				// K.D. June 4th, 2014 Bug #162878 WinJS compatibility for the igTree
				MSApp.execUnsafeLocalFunction(function () {
					li = $(self._initChildrenRecursively(path, node, parseInt(ul.attr('data-depth'), 10), checked, ul.children('li').length)).prependTo(ul);
				});
				if (!binding.hasOwnProperty('primaryKey')) {
					this._recalculatePaths(path);
				}
			} else if (!nodeIndex) {
				// K.D. June 4th, 2014 Bug #162878 WinJS compatibility for the igTree
				MSApp.execUnsafeLocalFunction(function () {
					li = $(self._initChildrenRecursively(path, node, parseInt(ul.attr('data-depth'), 10), checked, ul.children('li').length)).appendTo(ul);
				});
			} else {
				// K.D. June 4th, 2014 Bug #162878 WinJS compatibility for the igTree
				MSApp.execUnsafeLocalFunction(function () {
					li = $(self._initChildrenRecursively(path, node, parseInt(ul.attr('data-depth'), 10), checked, ul.children('li').length)).insertBefore(ul.children('li:eq(' + nodeIndex + ')'));
				});
				if (!binding.hasOwnProperty('primaryKey')) {
					this._recalculatePaths(path);
				}
			}
			if (isLi && isEmpty) {
				this._updateParentState(parent);
			}
			if (this.options.dragAndDrop) {
				this._initDragAndDrop(li);
			}
            // K.D. August 16th, 2013 Bug #149438 Switching to delegated events
			this._triggerRendered();
			// Update transaction log
			r = [];
			li.each(function (index, value) {
				r.push($(value).attr('data-path'));
			});
			this.options.dataSource.root().addNode({
				data: node,
				parentPath: path,
				path: r
			});
			this._trigger("nodeAdded", null, {owner: this, element: li, data: node, index: nodeIndex, binding: binding});
		},
		removeAt: function (path) {
			/* Removes the node with with the specified path and all of its children.
				paramType="string" optional="false" Specifies the path of the node to be removed.
			*/
			var node = this.nodeByPath(path), depth = parseInt(node.parent().attr('data-depth'), 10), binding, parent = this.parentNode(node), data;
			// No such node
			if (node.length <= 0) {
				return;
			}
			if (path.indexOf('_remove') !== -1) {
				path = path.replace('_remove', '');
			}
			binding = this._retrieveCurrentDepthBinding(depth);
			// Update transaction log
			// K.D. October 17th, 2013 Bug #155067 A shallow copy should be created instead of a deep one
			data = {
				data: $.extend(false, {}, this.nodeDataFor(path)),
				path: path
			};
			this._removeData(path, binding);
			node.remove();
			if (!binding.hasOwnProperty('primaryKey')) {
				this._recalculatePaths(path);
			}
			if (parent && parent.children('ul').children('li').length <= 0) {
				this._updateParentState(parent);
			}
			if (this.options.checkboxMode.toLowerCase() === 'tristate' && parent) {
				this._updateParentCheckbox(parent);
			}
			this.options.dataSource.root().removeNode(data);
			this._trigger("nodeDeleted", null, {owner: this, data: data.data, path: path});
		},
		removeNodesByValue: function (value) {
			/* Removing all the nodes with the specified value.
				paramType="string" optional="false" Specifies the value of the nodes to be removed.
			*/
			var nodes = this.nodesByValue(value), self = this;
			nodes.each(function (index, value) {
				self.removeAt($(value).attr('data-path'));
			});
		},
		applyChangesToNode: function (element, data) {
		    /* Performs a UI update on the provided node element with the new provided data member.
				paramType="object" optional="false" Specifies the node to be updated.
                paramType="object" optional="false" Specifies the new data item the node would update according to.
			*/
			var node = this.nodeFromElement(element), item;
			for (item in node.data) {
				if (node.data.hasOwnProperty(item)) {
					this._replaceUIValue(node, data, item);
				}
			}
		},
		transactionLog: function () {
			/* Returns the transaction log stack.
				returnType="object" The transaction log stack.
			*/
			return this.options.dataSource.root()._transactionLog;
		},
		_triggerSelectionChanging: function (event, node) {
			var args = {
					owner: this,
					selectedNodes: this._selectedNode,
					newNodes: [this._constructNodeObject(node)]
				};

			return this._trigger(this.events.selectionChanging, event, args);
		},
		_triggerSelectionChanged: function (event) {
			var args = {
					owner: this,
					selectedNodes: this._selectedNode,
					newNodes: this._selectedNode
				};

			this._trigger(this.events.selectionChanged, event, args);
		},
		_triggerNodeCollapsing: function (event, node) {
			var args = {
					owner: this,
					node: this._constructNodeObject(node)
				};

			return this._trigger(this.events.nodeCollapsing, event, args);
		},
		_triggerNodeCollapsed: function (event, node) {
			var args = {
					owner: this,
					node: this._constructNodeObject(node)
				};

			this._trigger(this.events.nodeCollapsed, event, args);
		},
		_triggerNodeExpanding: function (event, node) {
			var args = {
					owner: this,
					node: this._constructNodeObject(node)
				};

			return this._trigger(this.events.nodeExpanding, event, args);
		},
		_triggerNodeExpanded: function (event, node) {
			var args = {
					owner: this,
					node: this._constructNodeObject(node)
				};

			this._trigger(this.events.nodeExpanded, event, args);
		},
		_triggerNodePopulating: function (event, node) {
			var args = this._constructNodeObject(node);
			return this._trigger(this.events.nodePopulating, event, args);
		},
		_triggerNodePopulated: function (event, node) {
			var args = this._constructNodeObject(node);
			this._trigger(this.events.nodePopulated, event, args);
		},
		_triggerNodeCheckstateChanging: function (event, node) {
			var state = node.children('span[data-role=checkbox]').attr('data-chk'), args = {
				owner: this,
				node: this._constructNodeObject(node),
				currentState: state,
				newState: state === 'off' ? 'on' : 'off',
				currentCheckedNodes: this.checkedNodes()
			};

			return this._trigger(this.events.nodeCheckstateChanging, event, args);
		},
		_triggerNodeCheckstateChanged: function (event, node) {
			var state = node.children('span[data-role=checkbox]').attr('data-chk'), args = {
				owner: this,
				node: this._constructNodeObject(node),
				newState: state,
				newCheckedNodes: this.checkedNodes(),
				newPartiallyCheckedNodes: this.partiallyCheckedNodes()
			};

			return this._trigger(this.events.nodeCheckstateChanged, event, args);
		},
		_triggerNodeClick: function (event, node) {
			var args = {
				owner: this,
				node: this._constructNodeObject(node)
			};

			return this._trigger(this.events.nodeClick, event, args);
		},
		_triggerNodeDoubleClick: function (event, node) {
			var args = this._constructNodeObject(node);

			return this._trigger(this.events.nodeDoubleClick, event, args);
		},
		_triggerDataBinding: function () {
			var args = { owner: this };

			this._trigger(this.events.dataBinding, null, args);
		},
		_triggerDataBound: function (dataView) {
			var args = { owner: this, dataView: dataView };

			this._trigger(this.events.dataBound, null, args);
		},
		_triggerRendering: function (dataView) {
			var args = { owner: this, dataView: dataView };

			this._trigger(this.events.rendering, null, args);
		},
		_triggerRendered: function () {
			var args = { owner: this };

			this._trigger(this.events.rendered, null, args);
		},
		_triggerDragStart: function (event, ui, node) {
			var obj = this._constructNodeObject(node),
				args = $.extend(false, obj, ui);

			return this._trigger(this.events.dragStart, event, args);
		},
		_triggerDrag: function (event, ui, node) {
			var obj = this._constructNodeObject(node),
				args = $.extend(false, obj, ui);

			return this._trigger(this.events.drag, event, args);
		},
		_triggerDragStop: function (event, ui) {
			this._trigger(this.events.dragStop, event, ui);
		},
		_triggerNodeDropping: function (event, ui, node, targetIndex) {
			var obj = this._constructNodeObject(node),
				args,
				indexDecrement;
			obj.targetIndex = targetIndex;
			obj.originalIndex = ui.draggable.index();
			// K.D. January 21st, 2013 Bug #129864 The position of the moved column in the moving dialog is not accurate to the one in the grid when dragging in the tree.
			// When moving up the indices in the same level we need to decrement the index.
			indexDecrement = this._sourceNode.element.parent().attr('data-depth') === node.parent().attr('data-depth') && obj.targetIndex > obj.originalIndex ? -1 : 0;
			obj.targetIndex += indexDecrement;
			args = $.extend(false, obj, ui);

			return this._trigger(this.events.nodeDropping, event, args);
		},
		_triggerNodeDropped: function (event, ui, node) {
			var obj = this._constructNodeObject(node),
				args = $.extend(false, obj, ui);

			this._trigger(this.events.nodeDropped, event, args);
		},
		_constructNodeObject: function (node) {
			// Logic for constructing node object that would be used by the developer
			var nodeData = this.nodeDataFor(node !== null ? node.attr('data-path') : null),
				nodeObject = {
					path: node !== null ? node.attr('data-path') : null,
					element: node !== null ? node : null,
					data: nodeData,
					binding: node !== null ? this._retrieveCurrentDepthBinding(parseInt(node.parent().attr('data-depth'), 10)) : null
				};

			return nodeObject;
		},
		nodeDataFor: function (path) {
			/* Returns the data for the node with specified path.
				paramType="string" optional="false" Specifies the node path for which the data is returned.
				returnType="object" The JSON object holding the node data.
			*/
			if (!path) {
				return;
			}

			var splitPath = path.split(this.options.pathSeparator), data = this.options.dataSource._rootds.data(), i, j, binding = this.options.bindings, temp;

			for (i = 0; i < splitPath.length - 1; i++) {
				if (!binding.hasOwnProperty('primaryKey')) {
					if (typeof data[parseInt(splitPath[i], 10)][binding.childDataProperty] === 'function') {
						data = data[parseInt(splitPath[i], 10)][binding.childDataProperty]();
					} else {
						data = data[parseInt(splitPath[i], 10)][binding.childDataProperty];
					}
				} else {
					for (j = 0; j < data.length; j++) {
						if (data[j].hasOwnProperty(binding.primaryKey)) {
							temp = typeof data[j][binding.primaryKey] === 'function' ? data[j][binding.primaryKey]() : data[j][binding.primaryKey];
							if (temp.toString() === splitPath[i].toString()) {
								data = typeof data[j][binding.childDataProperty] === 'function' ? data[j][binding.childDataProperty]() : data[j][binding.childDataProperty];
								break;
							}
						}
					}
				}
				if (binding.hasOwnProperty('bindings')) {
					binding = binding.bindings;
				}
			}
			// K.D. January 18th, 2012 Bug #99681 There are cases where there is only one data item and this is the data item we want as it's not an array
			if (!binding.hasOwnProperty('primaryKey') && data.length) {
				data = data[parseInt(splitPath[splitPath.length - 1], 10)];
			} else {
				for (j = 0; j < data.length; j++) {
					if (data[j].hasOwnProperty(binding.primaryKey)) {
						temp = typeof data[j][binding.primaryKey] === 'function' ? data[j][binding.primaryKey]() : data[j][binding.primaryKey];
						if (temp.toString() === splitPath[i].toString()) {
							data = data[j];
							break;
						}
					}
				}
			}
			if (typeof data === 'function') {
				data = data();
			}
			return data;
		},
        destroy: function () {
            /* Destructor */
            $.Widget.prototype.destroy.apply(this, arguments);
			// K.D. February 17th, 2014 Bug #164398 Attaching events only on create as delegate is used instead of bind now.
			this.element.undelegate();
			this.element.removeClass(this.css.tree);
			this.element.removeClass(this.css.treeCollection);
			this.element.removeClass(this.css.treeRoot);
			if (this.options.width) {
				this.element.css('width', '');
			}
			if (this.options.height) {
				this.element.css('height', '');
			}
			if (this.options.dragAndDrop) {
				this._destroyDragAndDrop();
			}
			this.element.removeAttr('data-depth');
			this.element.removeAttr('data-scroll');
			this.element.empty();
			return this;
        }
    });
    $.extend($.ui.igTree, {version: '14.1.20141.2249'});
}(jQuery));

 /*!@license
 * Infragistics.Web.ClientUI Grid 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on: 
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.dataSource.js
 *	infragistics.ui.shared.js
 *	infragistics.util.js
 */
/*global jQuery, Modernizr, MSApp */
if (typeof jQuery !== 'function') {
	throw new Error("jQuery is undefined");
}
(function ($) {
	var _hovTR, _aNull = function (val) { return val === null || val === undefined; };
	/*
		igGrid is a widget based on jQuery UI that provides Excel like functionality by rendering data in tabular form
		and includes support for paging, sorting, filtering and selection (both local and remote)
		the widget can be bound to various types of data sources such as JSON, XML, Remote WCF/REST services, etc.
	*/
	$.widget("ui.igGrid", {
		css: {
			/* classes applied to the top container element */
			"baseClass" : "ui-widget ui-helper-clearfix ui-corner-all",
			/* Widget content class applied to various content containers in the grid */
			"baseContentClass" : "ui-widget-content",
			/* class applied to the top container element */
			"gridClasses" : "ui-iggrid",
			/* classes applied to the TBODY, and inherited through css for the records */
			"recordClass" : "ui-ig-record ui-iggrid-record",
			/* classes applied on alternate records */
			"recordAltClass" : "ui-ig-altrecord ui-iggrid-altrecord",
			/* classes applied to the grid header elements */
			"headerClass" : "ui-iggrid-header ui-widget-header",
			/* classes applied to the header text container */
			"headerTextClass" : "ui-iggrid-headertext",
            /* classes which will be applied to the grid header cell element when feature icon is rendered */
            "headerCellFeatureEnabledClass": "ui-iggrid-headercell-featureenabled",
			/* jQuery UI class applied to the grid header elements */
			"baseHeaderClass" : "ui-widget-header",
			/* classes applied to the TABLE which holds the grid records */
			"gridTableClass" : "ui-iggrid-table ui-widget-content",
			/* when fixed headers is enabled, this class is applied to the table that holds the header TH elements */
			"gridHeaderTableClass" : "ui-iggrid-headertable",
			/* when fixed footers is enabled, this class is applied to the table that holds the footer TD elements */
			"gridFooterTableClass" : "ui-iggrid-footertable ui-widget-footer",
			/* when fixed headers is enabled, this class is applied to the table that holds the footer elements */
			"gridFooterClass" : "",
			/* when no headers are shown or fixed headers is false, the caption (if any) needs to be rendered in a separate table */
			"gridCaptionTableClass": "ui-iggrid-captiontable",
			/* classes applied to the element that's on top of the header that has some description */
			"gridHeaderCaptionClass" : "ui-iggrid-headercaption ui-widget-header ui-corner-top",
			/* class applied to the TABLE's TBODY holding data records */
			"gridTableBodyClass" : "ui-iggrid-tablebody",
			/* classes applied to the scrolling div container when width and height are defined and scrollbars is 'true' */
			"gridScrollDivClass" : "ui-iggrid-scrolldiv ui-widget-content",
			/* classes applied to the grid footer caption contents */
			"gridFooterCaptionClass" : "ui-iggrid-footercaption",
			/* classes applied to the deleted rows of grid before commit */
			deletedRecord: 'ui-iggrid-deletedrecord',
			/* classes applied to the modified rows of grid before commit */
			modifiedRecord: 'ui-iggrid-modifiedrecord',
			/* class appplied to the grid element when RTL is enabled */
			rtl: "ui-iggrid-rtl"
		},
		options: {
			/* type="string|number|null"
				string The widget width can be set in pixels (px) and percentage (%).
				number The widget width can be set as a number
				null type="object" will stretch to fit data, if no other widths are defined
			*/
			width : null,
			/* type="string|number|null" This is the total height of the grid, including all UI elements - scroll container with data rows, header, footer, filter row -  (if any), etc.  
				string The widget height can be set in pixels (px) and percentage (%).
				number The widget height can be set as a number
				null type="object" will stretch vertically to fit data, if no other heights are defined
			*/
			height : null,
			/* type="bool" If autoAdjustHeight is set to false, the options.height will be set only on the scrolling container, and all other UI elements such as paging footer / filter row/ headers will add on top of that, so the total height of the grid will be more than this value - the height of the scroll container (content area) will not be dynamically calculated. Setting this option to false will usually result in a lot better initial rendering performance for large data sets ( > 1000 rows rendered at once, no virtualization enabled), since no reflows will be made by browsers when accessing DOM properties such as offsetHeight. */
			autoAdjustHeight: true,
			/* type="string|number" used for virtualization, this is the average value in pixels (default) that will be used to calculate how many rows and which ones to render as the end user scrolls. Also all rows' height will be automatically equal to this value 
				string The avarage row height can be set in pixels (25px).
				number The avarage row height can be set as a number (25).
			*/
			avgRowHeight : 25,
			/* type="string|number" used for virtualization, this is the average value in pixels for a column width 
				string The avarage column width can be set in pixels (25px).
				number The avarage column width can be set as a number (25).
			*/
			avgColumnWidth: null,
			/* type="string|number" Default column width that will be set for all columns.
				string The default column width can be set in pixels (px).
				number The default column width can be set as a number.
			*/
			defaultColumnWidth : null,
			/* type="bool" if no columns collection is defined, and autoGenerateColumns is set to true, columns will be inferred from the data source */
			autoGenerateColumns : true,
			/* type="bool" Enables/disables virtualization. Virtualization can greatly enhance rendering performance. If enabled, the number of actual rendered rows (DOM elements) will be constant and related to the visible viewport of the grid. As the end user scrolls, those DOM elements will be dynamically reused to render the new data. */
			virtualization : false,
			/* type="fixed|continuous" Determines virtualization mode
				fixed type="string" renders only the visible rows and/or columns in the grid. On scrolling the same rows and/or columns are updated with new data from the data source.
				continuous type="string" renders a pre-defined number of rows in the grid. On scrolling the continuous virtualization loads another portion of rows and disposes the current one.
			*/
			virtualizationMode : 'fixed',
			/* type="bool" this is an internal option and should not be used. */
			requiresDataBinding: true,
			/* type="bool" option to enable virtualization for rows only (vertical) */
			rowVirtualization : false,
			/* type="bool" option to enable virtualization for columns only (horizontal) */
			columnVirtualization : false,
			/* type="number" number of pixels to move the grid when virtualization is enabled, and mouse wheel scrolling is performed over the virtual grid area. The "null" value will assume this is set to avgRowHeight */
			virtualizationMouseWheelStep: null,
			//visibleVirtualRecords: null, // if this is specified, then the height of the grid will be calculated automatically based on the average row height and the visible virtual records. if no average row height is specified, one will be calculated automatically at runtime 
			/* type="bool" If this option is set to true, the height of the grid row will be calculated automatically based on the average row height and the visible virtual records. If no average row height is specified, one will be calculated automatically at runtime.
			*/
			adjustVirtualHeights: false,
			/* type="string" *** IMPORTANT DEPRECATED ***
			This option has been deprecated as of the 14.1 release. The igGrid now uses column templates for individual column templating.
			jQuery templating style template that will be used to render data records */
			rowTemplate: null,
			/* type="bool" *** IMPORTANT DEPRECATED ***
			This option has been deprecated as of the 12.1 release. The igGrid now uses the custom Infragistics templating engine by default.
			custom high-performance rendering will be used for rendering by default. jQuery Templating plugin can be used and enabled by setting this option to true. This will allow usage of column / row templates in jQuery Templating style. If virtualization is enabled, it is advised to keep this option to "false", in order to have better scrolling/rendering performance
			*/
			jQueryTemplating: false,
			/* type="infragistics|jsRender" the templating engine that will be used to render the grid 
				infragistics type="string" the grid will use the Infragistics Templating engine to render its content and specific parts of the UI
				jsRender type="string" the grid will use jsRender to render its content and specific parts of the UI
			*/
			templatingEngine: "infragistics",
			/* type="array" an array of column objects */
			columns : [
				{
					/* type="string" Column header text */
					headerText: null,
					/* type="string" column key (property in the data source to which the column is bound) */
					key: null,
					/* type="object" Reference to a function (string or function) which will be used for formatting the cell values. The function should accept a value and return the new formatted value. */
					formatter: null,
					/* type="string" Sets gets format for cells in column. Default value is null.
						If dataType is "date", then supported formats are following: "date", "dateLong", "dateTime", "time", "timeLong", "MM/dd/yyyy", "MMM-d, yy, h:mm:ss tt", "dddd d MMM", etc.
						If dataType is "number", then supported numeric formats are following: "number", "currency", "percent", "int", "double", "0.00", "#.0####", "0", "#.#######", etc.
						The value of "double" will be similar to "number", but with unlimited maximum number of decimal places.
						The format patterns and rules for numbers and dates are defined in $.ig.regional.defaults object.
						If dataType is "string" or not set, then format is rendered as it is with replacement of possible "{0}" flag by value in cell. Example, if format is set to "Name: {0}" and value in cell is "Bob", then value will appear as "Name: Bob"
						If value is set to "checkbox", then checkboxes are used regardless of renderCheckboxes option of igGrid. That has effect only when dataType option of column is set to "bool".
					*/
					format: null,
					/* type="string|number|bool|date|object" data type of the column cell values 
						string
						number
						bool
						date
						object
					*/
					dataType: "string",
					/* type="string|number" Width of the column in pixels or percentage. Can have optional 'px' at the end. If width is not defined and defaultColumnWidth is set, it is assumed for all columns.
						string The column width can be set in pixels (px) and percentage (%).
						number The column width can be set as a number
					*/
					width: null,
					/* type="bool" Initial visibility of the column. A column can be hidden without the Hiding feature being enabled but there will be no UI for unhiding it. Columns can be defined as hidden in the options of the Hiding feature as well and those definitions take precedence.*/
					hidden: false,
					/* type="string" Sets a template for an individual column. the contents of the template should be the HTML markup that goes inside the table cell, without any <td> and </td> tags included in front and at the end. The syntax of the template, when referencing data keys and using conditional expressions is the same as the one for rowTemplate */
					template: null,
					/* type="bool" Sets whether column is bound to the datasource*/
					unbound: false,
					/* type="array" array of other column definitions. If the column has the property group than the grid has multi column headers*/
					group: [],
					/* type="number" used to adjust span of multi column header cell*/
					rowspan: 0,
					/* type="string|object" a reference or name of a javascript function which will calculate the value based on other cell values in the same row when column is unbound */
					formula: null,
					/* type="array" array of values which could be set for unbound columns at init time */
					unboundValues: null
				}
			],
			/* type="object" can be any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself */
			dataSource : null,
			/* type="string" specifies a remote URL as a data source, from which data will be retrieved using an AJAX call ($.ajax)*/
			dataSourceUrl: null,
			/* type="string" explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property */
			dataSourceType: null,
			/* type="string" see $.ig.DataSource. This is basically the property in the responses where data records are held, if the response is wrapped */
			responseDataKey: null,
			/* type="string" See $.ig.DataSource. Property in the response specifying the total number of records on the server. */
			responseTotalRecCountKey: null,
			/* type="string" specifies the HTTP verb to be used to issue the request */
			requestType: "GET",
			/* type="string" content type of the response. See http://api.jquery.com/jQuery.ajax/ => contentType */
			responseContentType: 'application/json; charset=utf-8',
			/* type="bool" option controlling the visibility of the grid header */
			showHeader : true,
			/* type="bool" option controlling the visibility of the grid footer */
			showFooter : true,
			/* type="bool" headers will be fixed if this option is set to true, and only the grid data will be scrollable. If virtualization is enabled, fixedHeaders will always act as if it's true, no matter which value is set */
			fixedHeaders: true,
			/* type="bool" footers will be fixed if this option is set to true, and only the grid data will be scrollable. If virtualization is enabled, fixedFooters will always act as if it's true, no matter which value is set */
			fixedFooters: true,
			/* type="string" caption text that will be shown above the grid header */
			caption: null,
			/* type="object" a list of grid features definitions: sorting, paging, etc. Each feature goes with its separate options that are documented for the feature accordingly */
			features : [
				{
					/* feature options object */
				}
			],
			/* type="number" initial tabIndex attribute that will be set on the container element */
			tabIndex: 0,
			/* type="bool" if this option is set to true, ARIA and role attributes will be rendered for data records, cells and grid containers */
			accessibilityRendering: false,
			/* type="bool" if this option is set to false, the data to which the grid is bound will be used "as is" with no additional transformations based on columns defined */
			localSchemaTransform: true,
			/* type="string" primary key name of the column containing unique identifiers */
			primaryKey: null,
			/* type="bool" if true, the transaction log will always be sent in the request for remote data, by the data source. Also this means that if there are values in the log, a POST will be done instead of GET */
			serializeTransactionLog: true,
			/* type="bool" automatically commits the transactions as rows/cells are being edited */
			autoCommit: false,
			/* type="bool" if set to true, the following behavior will take place:
				if a new row is added, and then deleted, there will be no transaction added to the log 
				if a new row is added, edited, then deleted, there will be no transaction added to the log
				if several edits are made to a row or an individual cell, this should result in a single transaction
				Note: This option takes effect only when autoCommit is set to false.
			*/
			aggregateTransactions: false,
			/* type="date|number|dateandnumber|true|false" Sets gets ability to automatically format text in cells for numeric and date columns. The format patterns and rules for numbers and dates are defined in $.ig.regional.defaults object.
				date formats only Date columns
				number formats only number columns
				dateandnumber type="string"
				true type="bool" formats Date and number columns
				false type="bool" auto formatting is disabled
			*/
			autoFormat: 'date',
			/* type="bool" Gets sets ability to render checkboxes and use checkbox editor when dataType of a column is "bool". That option is not available when jQueryTemplating is used. */
			renderCheckboxes: false,
			/* type="string" URL to which updating requests will be made. If autoCommit is true, updates will be done immediately to the data source, without keeping interim transaction logs */
			updateUrl: null,
			/* Settings related to REST compliant update routine */
			restSettings: {
				/* Settings for create requests */
				create: {
					/* type="string" specifies a remote URL to which create requests will be sent. This will be used for both batch and non-batch, however if template is also set, this URL will only be used for batch requests. */
					url: null,
					/* type="string" specifies a remote URL template. Use ${id} in place of the resource id. */
					template: null,
					/* type="bool" specifies whether create requests will be sent in batches */
					batch: false
				},
				/* Settings for update requests */
				update: {
					/* type="string" specifies a remote URL to which update requests will be sent. This will be used for both batch and non-batch, however if template is also set, this URL will only be used for batch requests. */
					url: null,
					/* type="string" specifies a remote URL template. Use ${id} in place of the resource id. */
					template: null,
					/* type="bool" specifies whether update requests will be sent in batches */
					batch: false
				},
				/* Settings for remove requests */
				remove: {
					/* type="string" specifies a remote URL to which remove requests will be sent. This will be used for both batch and non-batch, however if template is also set, this URL will only be used for batch requests. */
					url: null,
					/* type="string" specifies a remote URL template. Use ${id} in place of the resource id. */
					template: null,
					/* type="bool" specifies whether update requests will be sent in batches */
					batch: false
				},
				/* type="bool" specifies whether the ids of the removed resources are send through the request URI */
				encodeRemoveInRequestUri: true,
				/* type="function" specifies a custom function to serialize content sent to the server. It should accept a single object or an array of objects and return a string. If not specified, JSON.stringify() will be used. */
				contentSerializer: null,
				/* type="string" specifies the content type of the request */
				contentType: 'application/json; charset=utf-8'
			},
			/* type="bool" enables/disables rendering of alternating row styles (odd and even rows receive different styling). Note that if a custom jQuery template is set, this has no effect and CSS for the row should be adjusted manually in the template contents.  */
			alternateRowStyles: true,
			/* type="bool"  If autofitLastColumn is true and all columns' widths are specified and their combined width is less than the grid width then the last column width will be automatically adjusted to fill the entire grid. */
			autofitLastColumn: true,
			/* type="bool"  enables/disables rendering of ui-state-hover classes when the mouse is over a record. this can be useful in templating scenarios, for example, where we don't want to apply hover styling to templated content */
			enableHoverStyles: true,
			/* type="bool" enables formatting of the dates as UTC. Note that this may be desirable when the dates are coming from a backend, encoded as UTC. Otherwise, if dates are created on the client (in the browser), most probably keeping enableUTCDates to false is the desired behavior */
			enableUTCDates: false,
			/* type="bool" Merge unbound columns values inside datasource when data source is remote. If true then the unbound columns are merged to the datasource at runtime - indeed DataSource is expanded with the new data and this could cause performance issues when dataSource is huge, if false then the unbound data is sent to the client */
			mergeUnboundColumns: false,
            /* type="bool" When dataSource is string defines whether to set data source of type JSONP */
            jsonpRequest: false,
            /* type="bool" enables/disables check for resizing grid container */
            enableResizeContainerCheck: true,
			/* type="none|desktopOnly|always" Configures how the feature chooser icon should display on header cells - e.g. to display as gear icon or to not show gear icon but on click/tap the header cell to show the feature chooser
			none type="string" Always hide the feature chooser icon; The feature chooser is shown on tapping/clicking the column header
			desktopOnly type="string" Always show the icon on desktop but hide when touch device detected
			always type="string" Always show it in any environment. Chooser is shown when tapping the gear icon or column header
			*/
			featureChooserIconDisplay: 'desktopOnly'
		},
		events: {
			/* Event fired when a cell is clicked.
			Function takes arguments evt and ui.
			Use ui.cellElement to get reference to cell DOM element.
			Use ui.rowIndex to get row index.
			Use ui.colIndex to get column index.
			Use ui.owner to get reference to igGrid.
			*/
			cellClick: "cellClick",
			/* cancel="true" Event fired before data binding takes place.
			Return false in order to cancel data binding.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.
			*/
			dataBinding: "dataBinding",
			/* Event fired after data binding is complete.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.
			*/
			dataBound: "dataBound",
			/* Event fired before the grid starts rendering (all contents).
			This event is fired only when the grid is being initialized. 
			It will not be fired if the grid is rebound to its data 
			(for example, when calling the dataBind() API method 
			or when changing the page size (when paging is enabled)).
			
			Return false in order to cancel grid rendering.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.
			*/
			rendering: "rendering",
			/* Event fired after the whole grid widget has been rendered (including headers, footers, etc.).
			This event is fired only when the grid is being initialized. 
			It will not be fired if the grid is rebound to its data 
			(for example, when calling the dataBind() API method 
			or when changing the page size (when paging is enabled)).
			
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.
			*/
			rendered: "rendered",
			/* cancel="true" Event fired before the TBODY holding the data records starts its rendering.
			Return false in order to cancel data records rendering.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.			
			*/
			dataRendering: "dataRendering",
			/* Event fired after all of the data records in the grid table body have been rendered. 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.	
			*/
			dataRendered: "dataRendered",
			/* cancel="true" Event fired before the header starts its rendering.
			Return false in order to cancel header rendering.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.	
			*/
			headerRendering: "headerRendering",
			/* Event fired after the header has been rendered.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.
			Use ui.table to get reference to headers table DOM element.
			*/
			headerRendered: "headerRendered",
			/* cancel="true" Event fired before the footer starts its rendering.
			Return false in order to cancel footer rendering.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.
			*/
			footerRendering: "footerRendering",
			/* Event fired after the footer has been rendered.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.
			Use ui.table to get reference to footers table DOM element.
			*/
			footerRendered: "footerRendered",
			/* Event fired after every TH in the grid header has been rendered.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.
			Use ui.columnKey to get column key.
			Use ui.th to get reference to header cell DOM element.
			*/
			headerCellRendered: "headerCellRendered",
			/* Event fired before actual data rows (TRs) are rendered.
			Return false in order to cancel rows rendering.	
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.
			Use ui.tbody to get reference to grid's table body.
			*/
			rowsRendering: "rowsRendering",
			/* Event fired after data rows are rendered.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.
			Use ui.tbody to get reference to grid's table body.
			*/
			rowsRendered: "rowsRendered",
			/* Event fired after $.ig.DataSource schema has been generated, in case it needs to be modified.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.
			Use ui.schema to get reference to data source schema.
			Use ui.dataSource to get reference to data source.
			*/
			schemaGenerated: "schemaGenerated",
			/* Event fired after the columns colection has been modified(e.g. a column is hidden)
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGrid.
			*/
			columnsCollectionModified: "columnsCollectionModified",
			/*
				event fired if there is an error in the request, when the grid is doing a remote operation,
				such as data binding, paging, sorting, etc. 
				use ui.owner to get a reference to the grid
				use ui.message to get the processed error message sent by the server
				use ui.response to get reference to the whole response object
			*/
			requestError: "requestError",
			/*
				fired when the grid is created and the initial structure is rendered (this doesn't necessarily imply the data will be there if the data source is remote) 
				use ui.owner to get a reference to the grid
			*/
			created: "igcontrolcreated",
			/*
				fired when the grid is destroyed
				use ui.owner to get a reference to the grid
			*/
			destroyed: "igcontroldestroyed"
		},
		resizeTimeout: 300,
		/* type="boolean" setting this global widget property manually to true will always remove the data table's body at once, with the risk of memory leaks in IE and FF. The advantage is much faster operations 
			that need to cleanup existing data rows, such as sorting or filtering */
		speedupDOMCleanup: false,
        /* type="boolean" configure whether to clone child element of grid when element is TABLE(necessary in some cases when destroying grid to revert to initial state) */
        cloneChildElements: false,
		widget: function () {
			/* returns the element holding the data records */
			return this.element;
		},
		_createWidget: function (options, element) {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			/* S.S. May 23, 2014 - Bug #172064. As of jQuery UI 1.9.0 the widget options are not copied straight up
			and the options.columns would end up pointing to the prototype.options.columns, therefore adding anything
			in the array will change igGrid.prototype leading to unexpected behavior. The following is safe as we'll create 
			the array right after we ensure that it won't just end up being a reference to igGrid.prototype.
			*/
			this.options.columns = null;
			this.options.features = null;
			if (options && options.dataSource && ($.type(options.dataSource) === "array" || $.type(options.dataSource) === "object")) {
				this.tmpDataSource = options.dataSource;
				options.dataSource = null;
				this._originalOptions = options;
			}
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		//_init: function () {
		//},
		_setOption: function (key, value) {
			var header, isScrolling, hasWidthInPercent = this._gridHasWidthInPercent(), caption, width, containerWidth, id;
			// handle new settings and update options hash
			//A.T. fix for bug #118369
			// ensure setting an option with the same value does nothing
			if (value === this.options[key]) {
				return;
			}
			//isScrolling = this.options.scrollbars && (this.options.height !== null || this.options.width !== null);
			//A.T. 7 Feb. 2011 - usability review changes 
			isScrolling = (this.options.height !== null || this.options.width !== null);
			$.Widget.prototype._setOption.apply(this, arguments);
			// options that are supported:
			// width, height, defaultColumnWidth, dataSource, showHeader, showFooter, header caption
			// start by throwing an error for all option changes that aren't supported after the widget has been created
			if (key === 'virtualization' || key === 'autoGenerateColumns' || key === 'accessibilityRendering' ||
					key === 'rowVirtualization' || key === 'columnVirtualization' || key === 'fixedHeaders' || key === 'scrollbars') {
				throw new Error($.ig.Grid.locale.optionChangeNotSupported + ' ' + key);
			}
			if (key === 'width') {
				if (isScrolling === true) {
					this.container().css('width', value);
					this.element.css('width', value);
					//A.T. 22 Feb. Fix for bug #102486 
					if (this.options.fixedHeaders) {
						this.headersTable().css('width', value);
					}
                    // M.H. 21 Mar 2013 Fix for bug #136999: igGrid does not resize properly.
                    if (!this._allColumnWidthsInPercentage || !hasWidthInPercent) {
						if (this.options.virtualization === true || this.options.columnVirtualization === true || this.options.rowVirtualization === true) {
							// M.H. 13 May 2014 Fix for bug #171116: Virtualization prevents width from properly being applied
							containerWidth = this._calculateContainerWidth(false);
							id = this.id();
							if (value && value.indexOf && value.indexOf('%') !== -1) {
								// TODO
							} else {
								width = parseInt(value, 10);
							}
							this.container().find("#" + id + "_headers_v")
								.css('width', width)
								.css('max-width', width);
							this.element.css('width', width - this._scrollbarWidth());
							this._vdisplaycontainer()
								.css('width', width - this._scrollbarWidth())
								.css('max-width', width- this._scrollbarWidth());
							this._virtualcontainer()
								.css('width', width)
								.css('max-width', width);
							this._virtualcontainer().find("> colgroup > col")
								.first()
								.attr('width', width - this._scrollbarWidth());
							// M.H. 15 Aug 2013 Fix for bug #149242: Misalignment when resizing grid with summaries and virtualization
							this.container().find("#" + id + "_footer_container")
								.css('width', width)
								.css('max-width', width);
							this.container().find("#" + id + "_footers")
								.css('width', width)
								.css('max-width', width);
							this._gridInnerWidth = this._vdisplaycontainer().width() + this._scrollbarWidth();
						} else {
							this._gridInnerWidth = this.scrollContainer().width();
						}
					}
					// M.H. 1 Apr 2013 Fix for bug #138302: Horizontal scrollbar doesn't appear when resizing the igGrid
					if (this.options.width !== null && this.options.height !== null) {
						// M.H. 20 May 2013 Fix for bug #136999: igGrid does not resize properly.
						this._updateGridContentWidth();
					}
				} else {
					throw new Error($.ig.Grid.locale.optionChangeNotScrollingGrid + ' ' + key);
				}
			} else if (key === 'height') {
				// depends if the grid is scrolling or not
				if (isScrolling === true) {
					this.scrollContainer().css('overflow-y', 'auto');
					if (this.options.autoAdjustHeight) {
						this.container().css('height', value);
						this._virtualHeightReset = true;
						this._initializeHeights();
					} else {
						this.scrollContainer().css('height', value);
					}
					// M.H. 22 Apr 2014 Fix for bug #170404: avgRowHeight is not respected when resizing the igGrid
					if (this.options.virtualization || this.options.rowVirtualization || this.options.columnVirtualization) {
						if (this.options.virtualizationMode === "fixed") {
							//this._avgRowHeight = null;
							this._buildVirtualDom();
							this.virtualScrollTo(this._startRowIndex);
						}
					}
					/*
					children = this.container().children();
					height = 0;
					for (i = 0; i < children.length; i++) {
						if (!$(children[i]).attr('id').endsWith('_scroll') && $(children[i]).is(':visible')) {
							height += $(children[i]).outerHeight();
						}
					}
					*/
					//$('#' + this.element[0].id + '_scroll').height(this.container().height() - height);
				} else {
					throw new Error($.ig.Grid.locale.optionChangeNotScrollingGrid + ' ' + key);
				}
			} else if (key === 'dataSource') {
				this.options.dataSource = value;
				this.dataBind();
			} else if (key === 'showHeader') {
				header = this.headersTable();
				if (header.length > 0 && header.is('table')) {
					if (value === true) {
						header.show();
					} else {
						header.hide();
					}
				} else {
					header = this.element.find('thead tr');
					if (value === true) {
						header.show();
					} else {
						header.hide();
					}
				}
			} else if (key === 'caption') {
				// M.H. 30 Jan 2014 Fix for bug #116158: Caption property cannot be set dynamically at runtime.
				caption = this._caption();
				if (caption.length === 0) {
					this._renderCaption();
					if (this.options.autoAdjustHeight) {
						this._initializeHeights();
					}
				} else {
					// L.A. 06 July 2012 Fixing bug #116158 Unable to change Caption dynamically at runtime
					caption.text(value);
				}
			}
		},
		_initialized: false,
		_headersInitialized: false,
		_footerInitialized: false,
		_create: function () {
			var grid = this, i, container, attr;
			// M.H. 14 June 2012 Fix for bug #114327
			this._isHierarchicalGrid = false;
			this._hasUnboundColumns = false;
			if (this.options._isHierarchicalGrid === true) {
				this._isHierarchicalGrid = true;
			}
			// M.H. 8 Jan 2014 Fix for bug #159857: Calling igGrid.destroy doesn't remove the COLGROUP, TFOOT and THEAD tags as well as some attributes on the placeholder
			if (this.cloneChildElements && this.element.is("table") && this.element.children().length > 0) {
				// we use clone because we will preserve event binding to the elements(if any) if binging is through javascript
				// if we use innerHtml then it will be faster(better for performance) but will not preserve data binding to the element inside to the table(if any)
				// on the other hand if element is table and it is used huge data content this means that clone and table
				this._initialChildren = this.element.children().clone(true);
			}
			this._initialAttributes = [];
			attr = this.element[0].attributes;
			for (i = 0; i < attr.length; i++) {
				if (attr[i].name !== 'id') {
					this._initialAttributes.push({ name: attr[i].name, value: attr[i].value });
				}
			}
			// check for RTL
			this._rtl = this.element.css("direction") === "rtl";
			this._padding = this._rtl ? 'padding-left' : 'padding-right';
			if (this.tmpDataSource !== null && this.tmpDataSource !== undefined) {
				this.options.dataSource = this.tmpDataSource;
				this._originalOptions.dataSource = this.tmpDataSource;
			}
			this._testInnerHtml();
			this._headerInitCallbacks = [];
			this._footerInitCallbacks = [];
			this._cellStyleSubscribers = [];
			this._firstBind = true;
			this._isMultiColumnGrid = false;
			this._unboundValues = {};
			if (!this.options.columns) {
				this.options.columns = [];
			}
			if (!this.options.features) {
				this.options.features = [];
			}
			// analyze multicolumn headers
			if (this._isMultiColumnHeader() === true) {
				// get 2 objects - one flat representation of the columns(e.g. used for databinding and by the framework)
				// the other object is tree representation of the columns with some additional properties like colspan, rowspan
				this._isMultiColumnGrid = true;
				this._generateColumnFlatStructure(this.options.columns);
				this._headerCells = [];
			}
			//I.I. bug fix for 107647
			if (this.options.rowVirtualization === true && this.options.virtualizationMode === 'continuous') {
				this.options.virtualization = true;
			}
			//I.I. bug fix for 108205, this is by design, columnVirtualization requires virtualization to be switched on. columnVirtualization is not relevant for continuous virtualization
			if (this.options.columnVirtualization === true) {
				this.options.virtualization = true;
				if (this.options.virtualizationMode === 'continuous') {
					throw new Error($.ig.Grid.locale.colVirtualizationDenied);
				}
				this.options.virtualizationMode = 'fixed';
			}
			// virtualization always uses fixed headers 
			// S.S. May 11, 2012 #103088, Regardless of what the user sets, all virtualization uses fixed headers and fixed footers 
			// which should properly be recognized by all features
			if (this.options.virtualization === true || this.options.columnVirtualization === true || this.options.rowVirtualization === true) {
				if (this.options.virtualizationMode === undefined || this.options.virtualizationMode === '') {
					this.options.virtualizationMode = 'fixed';
				}
				if (this.options.virtualizationMode === 'fixed') {
					this.options.fixedHeaders = true;
					// M.H. 12 March 2012 Fix for bug #101222
					this.options.fixedFooters = true;
				}
			}
			//I.I. bug fix for 104408
			if (this.options.virtualization === true && this.options.virtualizationMode === 'continuous') {
				this.options.fixedHeaders = true;
			}
			/*
			if (this.options.jQueryTemplating === null && (this.options.virtualization === false && this.options.rowVirtualization === false)) {
				this.options.jQueryTemplating = true;
			} else if (this.options.jQueryTemplating === null && (this.options.virtualization === true || this.options.rowVirtualization === true)) {
				this.options.jQueryTemplating = false;
			}
			*/
			if ((this.options.height === null || parseInt(this.options.height, 10) <= 0) && this.options.fixedHeaders === true) {
				this.options.fixedHeaders = false;
			}
			// M.H. 12 March 2012 Fix for bug #101222
			if ((this.options.height === null || parseInt(this.options.height, 10) <= 0) && this.options.fixedFooters === true) {
				this.options.fixedFooters = false;
			}
			/*
			if (this.options.alternateRowStyles === null && (this.options.virtualization === true || this.options.rowVirtualization === true)) {
				this.options.alternateRowStyles = false;
			} else if (this.options.alternateRowStyles === null) {
				this.options.alternateRowStyles = true;
			}
			*/
			// trigger an internal data bind call
			this.dataBind(true);
			this._cellClickHandler = function (event) {
				var $et = $(event.target), row = $et.closest('tr'), key = row.attr("data-id"), colKey, $td, res, currGrid,
					/* L.A. 12 July 2012 - Fixing bug #116993 When cell selection is in use and 
					the user tries to edit a cell, the 3rd and each subsequent clicks on that cell 
					cause the igGrid's cellClick event handler to be fired incorrectly for the 1st 
					cell of the row
					L.A. 22 August 2012 - Fixing bug #119477 wrong cell index is returned when a checkbox
					is clicked
					*/
					colIndex = $et.closest("td").index(),
					// M.H. 14 May 2014 Fix for bug #171207: igHierarchicalGrid when grouped by column, ui.colKey retutns the next columKey insted of the correct one
					dataColIndex = colIndex - row.children("td.ui-iggrid-expandcolumn,th,td[data-skip]").length;
				// M.H. 14 May 2014 Fix for bug #171207: igHierarchicalGrid when grouped by column, ui.colKey retutns the next columKey insted of the correct one
				// we should not stop propagation for the click event because of the rowEdit template in updating (which is bound to this click event)
				// So in hierarchical grid we check whether the closest(to the clicked cell) grid has id equal to the grid.id()
				// this check should be done because when user clicks on the child bands the event is bubbled to the parent child grids
				if (grid.element.closest('.ui-iggrid-root').data('igGrid')) {
					currGrid = $et.closest(".ui-iggrid-table").data("igGrid");
					if (currGrid && grid.id() !== currGrid.id()) {
						return;
					}
				}
				if (key === "" || key === null || key === undefined) {
					key = row.index();
				}
				$td = $(event.target);
				if (!$td.is('td')) {
					$td = $(event.target).closest('td');
				}
				// M.H. 6 Jun 2013 Fix for bug #143586: CellClick event doesn't fire for fixed columns.
				if (grid.hasFixedColumns()) {
					if ($td.length === 1) {
						res = grid._getColumnByTD($td);
						///{column: visibleColumns[visibleInd], index: visibleInd}
						if (res !== null) {
							colKey = res.column.key;
							colIndex = res.index;
						}
					}
				} else {
					if (dataColIndex >= 0 && dataColIndex < grid._visibleColumns().length) {
						/* L.A. 12 July 2012 - Fixing bug #116909 When there's a hidden column, the igGrid's 
						cellClick event reports the ui.columnKey input arg as if there are no hidden columns*/
						colKey = grid._visibleColumns()[dataColIndex].key;
					}
				}
				// click for the main grid element; 'event' is the browser event 
				// M.H. 30 Jan 2014 Fix for bug #162408: cellClick event raises on filter textbox
				if (!$et.closest('tr').parent().is('thead') && ($et.is('td') || ($et.closest('td').length === 1 &&
						$et.closest('td').parent().attr("data-container") !== "true"))) {
					// M.H. 3 Apr 2014 Fix for bug #165339: type of PrimaryKey is always string in cellClick event
					key = grid._fixPKValue(key);
					// we need to conclude if the element that was clicked is a grid cell or not. As a start this check will be enough.
					grid._trigger(grid.events.cellClick, event, {
						'rowIndex': row.index(),
						'rowKey': key,
						'colIndex': colIndex,
						'colKey': colKey,
						'cellElement': $td[0],
						owner: grid
					});
				}
			};
			this.element.bind({
				'click': this._cellClickHandler
			});
			// auto adjusting heights when resizing and the grid height is defined with a percentage. In that case we need to either use a timeout
			// or resize (which only works in IE)
			// M.H. 17 Dec 2013 Fix for bug #151256: Performance issues caused by _resizeContainer function
			if (this.options.enableResizeContainerCheck &&
				((this.options.height !== null && this.options.height.indexOf && this.options.height.indexOf('%') !== -1) ||
				(this.options.width !== null && this.options.width.indexOf && this.options.width.indexOf('%') !== -1) ||
				!this.element.is(':visible'))) {
				// M.H. 26 Jul 2013 Fix for bug #146837: Vertical scroll bar does not display when control inside the Jquery UI tab
				if (!this.element.is(':visible')) {
					this._recheckVisibility = true;
				}
				// M.H. 17 Dec 2013 Fix for bug #151256: Performance issues caused by _resizeContainer function
				if ($.ig.util.isIE && $.ig.util.browserVersion <= 10) {
					container = this.container();
					if (container.length > 0 && container[0].attachEvent) {
						this._resizeContainerHandler = $.proxy(this.resizeContainer, this);
						container[0].attachEvent("onresize", this._resizeContainerHandler);
					}
				}
				if (!this._resizeContainerHandler) {
					this._resId = setInterval($.proxy(this.resizeContainer, this), this.resizeTimeout);
				}
			}
			//set default value for column.hidden
			for (i = 0; i < this.options.columns.length; i++) {
				if (this.options.columns[i].hidden === undefined) {
					this.options.columns[i].hidden = false;
				}
			}
			// listen to soft dispose. If a feature is of local type, but the invoking one is of remote type, the local one must be marked as fully dirty
			// example: sorting a column when sorting is local and then changing the page index when paging is remote
			this._uiSoftDirtyHandler = $.proxy(this._onFeaturesSoftDirty, this);
			this.element.bind('iggriduisoftdirty', this._uiSoftDirtyHandler);
			this._oldScrollTop = 0;
			// trigger created event
			this.element.trigger(this.events.created, {
				owner: this
			});
			// set the rtl class
			if (this._rtl) {
				this.container().addClass(this.css.rtl);
			}
		},
		_fixPKValue: function (val) {
			/* returns parsed to int val when the primary key is of type number(otherwise returns val)
				paramType="string" value of the primary key
				returnType="string|number" value of the primary key
			*/
			var col, data, pk = this.options.primaryKey;
			if (_aNull(val)) {
				return null;
			}
			if (pk) {
				col = this.columnByKey(pk);
				if (col && col.dataType) {
					if (col.dataType === "number" || col.dataType === "numeric") {
						val = parseInt(val, 10);
					}
				} else {
					data = this.dataSource._data;
					if (data && data.length > 0) {
						if (typeof data[0][pk] === 'number') {
							val = parseInt(val, 10);
						}
					}
				}
			} else {
				data = this.dataSource._data;
				if (data && data.length > 0) {
					if (typeof data[0].ig_pk === "number") {
						val = parseInt(val, 10);
					}
				}
			}
			return val;
		},
        hasFixedDataSkippedColumns: function () {
            return this._hasFixedDataSkippedColumns;
        },
		hasFixedColumns: function () {
            /* returns whether grid has fixed columns
               returnType="bool" 
			*/
			if (this._hasFixedDataSkippedColumns || (this._fixedColumns !== null && this._fixedColumns !== undefined && this._fixedColumns.length > 0)) {
				return true;
			}
			return false;
		},
		isFixedColumn: function (colKey) {
			/* returns whether the column with identifier colKey is fixed 
				paramType="number|string" An identifier of the column which should be checked. It can be a key or visible index.
				returnType="bool"
			*/
			var isFixed = false, typeColKey = $.type(colKey), cols;

			if (!this.hasFixedColumns()) {
				return false;
			}
			if (typeColKey === 'string') {
				$.each(this._fixedColumns, function (ind, c) {
					if (c.key === colKey) {
						isFixed = true;
						return false;// break
					}
				});
			} else if (typeColKey === 'number') {
				cols = this._visibleColumns();
				if (colKey < 0 || colKey >= cols.length) {
					return false;
				}
				isFixed = (cols[colKey].fixed === true);
			}
			return isFixed;
		},
		_onColumnFixed: function (colInd, isFixed, colsCount, isInit, visibleIndex) {
			var result = {
					colInd: colInd,
					isFixed: isFixed,
					fixedColsCount: colsCount,
					isInit: isInit,
					visibleIndex: visibleIndex
			};
			this._fireInternalEvent("_columnFixed", result);
		},
		_onGroupedColumnsChanging: function (groupedColumns) {
			this._fireInternalEvent("_groupedColumnsChanging", {groupedColumns: groupedColumns});
		},
		_onGroupedColumnsChanged: function (groupedColumns) {
			this._fireInternalEvent("_groupedColumnsChanged", {groupedColumns: groupedColumns});
		},
		_testInnerHtml: function () {
			var t = document.createElement("table");
			try {
				t.innerHTML = "<tr><td> t </td></tr>";
				this._canreplaceinner = true;
			} catch (e) {
				this._canreplaceinner = false;
			}
		},
		resizeContainer: function () {
			/* Called to detect whether grid container is resized. When autoAdjustHeight is true and height of the grid is changed then the height of grid is re-set.
			*/
			var scrollContainerWidth,
				o = this.options, visibilityChanged = false,
				v = o.virtualization === true || o.rowVirtualization === true || o.columnVirtualization === true;
			// M.H. 26 Jul 2013 Fix for bug #146837: Vertical scroll bar does not display when control inside the Jquery UI tab
			// when grid has not been visible on init then we should re-init heights
			if (this._recheckVisibility && this.element.is(':visible')) {
				this._prevContainerHeight = 0;
				visibilityChanged = true;
				this._recheckVisibility = false;
				// M.H. 17 Dec 2013 Fix for bug #151256: Performance issues caused by _resizeContainer function
				if (this._resId &&
					!((this.options.height !== null && this.options.height.indexOf && this.options.height.indexOf('%') !== -1) ||
					(this.options.width !== null && this.options.width.indexOf && this.options.width.indexOf('%') !== -1))) {
					clearInterval(this._resId);
				}
			}
			if (o.autoAdjustHeight && this.container().height() !== this._prevContainerHeight) {
				this._initializeHeights();
				if (v && visibilityChanged) {
					// M.H. 26 Jul 2013 Fix for bug #148282: When continuous virtualization is enabled and grid is initially hidden, on showing scrollbar is not proporly set
					this._avgRowHeight = null;
					this._updateVirtualScrollContainer();
					this._onVirtualVerticalScroll();
				}
			}
			if (o.width !== null && o.height !== null) {
				if (v === false) {
					scrollContainerWidth = this.scrollContainer().width();
				} else {
					scrollContainerWidth = this._vdisplaycontainer().width() + this._scrollbarWidth();
				}
				//A.T. 10 May 2012 - Fix for bug #111407 
				// L.A. 31 October 2012 - Fixing bug #125617
				// setting height property on grid causes a horizontal scroll bar placeholder to render
				if (this._gridInnerWidth !== scrollContainerWidth && (this._gridInnerWidth > 0 || scrollContainerWidth > 0)) {
					this._gridInnerWidth = scrollContainerWidth;
					this._updateHScrollbarVisibility();
				}
				if (v === false && (this.scrollContainer().get(0).scrollHeight >
					this.scrollContainer().get(0).clientHeight) !== this._hasVerticalScrollbar) {
					this._adjustLastColumnWidth();
				}
			}
		},
		_isMultiColumnHeader: function () {
			// checks whether the grid has multicolumn headers - checks whether in columns definition some of the columns on the root level has property group
			var cols = this.options.columns, i;
			for (i = 0; i < cols.length; i++) {
				if (cols[i].group !== undefined && cols[i].group !== null) {
					return true;
				}
			}
			return false;
		},
		// cols - current level of cols (the function is recursive),
		// newCols - flat list of columns at level 0
		// level - current level, oldCols - cols(which are passed to the grid.options.columns) with analyzed, colspan and level
		// children - list of children for each multicolumn header
		_analyzeMultiColumnHeaders: function (cols, newCols, level, oldCols, children, isHidden) {
			// analyze multicolumn headers - get colspans for multicolumn headers, set level for each header column and gets flat list of columns on level 0
			// sets identifier for each column - if column does not have key(even if multicolumn header) then it is set auto generated key
			// we need of keys to get easier cells and in some features - like resizing, hiding, column moving
			var i, j, res, colsLength = cols.length, colspan = 0, ind = [], groupChildren = [], identifier, hidden;
			for (i = 0; i < colsLength; i++) {
				if (cols[i].group !== undefined && cols[i].group !== null) {
					if (cols[i].key !== undefined && cols[i].key !== null) {
						// M.H. 4 July 2012 Fix for bug #116254 - column indentifier should be string
						identifier = cols[i].key.toString();
					} else {
						// M.H. 4 July 2012 Fix for bug #116254 - column indentifier should be string
						identifier = (this._multiColumnIdentifier++).toString();
					}
					if (!cols[i].identifier) {
					cols[i].identifier = identifier;
					}
					groupChildren = [];
					hidden = false;
					if (isHidden === true || cols[i].hidden === true) {
						hidden = true;
					}
					res = this._analyzeMultiColumnHeaders(cols[i].group, newCols, level + 1, oldCols[i].group, groupChildren, hidden);

					oldCols[i].colspan = res.colspan;
					oldCols[i].children = groupChildren;
					for (j = 0; j < groupChildren.length; j++) {
						children.push(groupChildren[j]);
					}
					ind.push(i);
					colspan += res.colspan;
				} else {
					colspan++;
					oldCols[i].level = 0;
					oldCols[i].level0 = true;
					if (isHidden === true) {
						cols[i].hidden = true;
					}
					children.push(cols[i]);
					newCols.push(cols[i]);
				}
			}
			for (j = 0; j < ind.length; j++) {
				oldCols[ind[j]].level = this._maxLevel - level;
			}
			return {colspan: colspan};
		},
		_getMultiHeaderColumnById: function (id, level, cols) {
			// get multi column header by id
			// if level specified search for the specified level
			var i, colsLength, res = null;
			if (cols === null || cols === undefined) {
				// M.H. 12 Dec 2012 Fix for bug #129344
				if (this._oldCols === null || this._oldCols === undefined) {
					return null;
				}
				cols = this._oldCols;
			}
			colsLength = cols.length;
			for (i = 0; i < colsLength; i++) {
				if (cols[i].identifier === id && (level === undefined || cols[i].level === level)) {
					return cols[i];
				}
				if (cols[i].group !== null && cols[i].group !== undefined) {
					res = this._getMultiHeaderColumnById(id, level, cols[i].group);

					if (res !== null) {
						return res;
					}
				}
			}
			return null;
		},
		_getMaxLevelRecursive: function (level, cols) {
			// get how deep multicolumn headers are
			var i, colsLength = cols.length, ml = level, l, rowspan;
			for (i = 0; i < colsLength; i++) {
				// M.H. 8 Aug 2012 Fix for bug #118599
				rowspan = 1;
				if (cols[i].rowspan !== null && cols[i].rowspan !== undefined && cols[i].rowspan > 0) {
					rowspan = cols[i].rowspan;
				}
				if (cols[i].group !== undefined && cols[i].group !== null) {
					l = this._getMaxLevelRecursive(level + rowspan, cols[i].group);
					if (l > ml) {
						ml = l;
					}
				} else if (rowspan > 0) {
					// M.H. 8 Aug 2012 Fix for bug #118599
					l = level + rowspan - 1;
					if (l > ml) {
						ml = l;
					}
				}
			}
			return ml;
		},
		// the second argument specifies whether data will be appended or prepended. the default is prepend. 
		_headerInit: function (tr, colgroup, prepend) {
			// different features that require extra cells such as group by, may register callbacks here
			// that will be called whenever a feature like filter row or add new row renders its logic
			var i;
			for (i = 0; i < this._headerInitCallbacks.length; i++) {
				this._headerInitCallbacks[i].func(tr, colgroup, prepend);
			}
		},
		_footerInit: function (tr, colgroup, prepend, cssClass) {
			// different features that require extra cells such as group by, may register callbacks here
			// that will be called whenever a feature like filter row or add new row renders its logic
			var i;
			for (i = 0; i < this._footerInitCallbacks.length; i++) {
				this._footerInitCallbacks[i].func(tr, colgroup, prepend, cssClass);
			}
		},
		id: function () {
			/* returns the ID of the TABLE element where data records are rendered 
				returnType="string" 
			*/
			return this.element[0].id;
		},
		// returns the grid caption element (above the headers table)
		_caption: function () {
			return this.container().find("caption");
		},
		_rootContainer: function () {
			var rootElement;
			if (!this._rContainer || this._rContainer.length === 0) {
				rootElement = this.element.closest(".ui-iggrid-root");
				this._rContainer = rootElement.length === 1 ? rootElement.data("igGrid").container() : this.container();
			}
			return this._rContainer;
		},
		container: function () {
			/* returns the DIV that is the topmost container of the grid widget
				returnType="dom"
			*/
			//if (this._isWrapped === true) {
			//	return this.element;
			//} else {
			//return $('#' + this.element[0].id + '_container');
			if (!this._container || this._container.length === 0) {
				this._container = this.element.closest("div[id="+ this.id() + "_container]");
			}
			return this._container;
			//}
		},
		headersTable: function () {
			/* returns the table that contains the header cells 
				returnType="dom"
			*/
			if (this.options.fixedHeaders === true && this.options.height !== null) {
				//return $('#' + this.element[0].id + '_headers');
				return this.container().find("#" + this.id() + "_headers");
			}
			return this.element;
		},
		footersTable: function () {
			/* returns the table that contains the footer cells 
				returnType="dom"
			*/
			if (this.options.fixedFooters === true && this.options.height !== null) {
				//return $('#' + this.element[0].id + '_footers');
				return this.container().find("#" + this.id() + "_footers");
			}
			return this.element;
		},
		scrollContainer: function () {
			/* returns the DIV that is used as a scroll container for the grid contents
				returnType="dom"
			*/
			//return $('#' + this.element[0].id + '_scroll');
			return this.container().children("#" + this.id() + "_scroll");
		},
        fixedContainer: function () {
			/* returns the DIV that is the topmost container of the fixed grid
				returnType="dom"
			*/
            return this.container().find("#" + this.id() + "_mainFixedContainer");
        },
        fixedBodyContainer: function () {
			/* returns the DIV that is the topmost container of the fixed body grid
				returnType="dom"
			*/
			//if (this._isWrapped === true) {
			//	return this.element;
			//} else {
			return this.container().find("#" + this.id() + "_fixedBodyContainer");
			//}
		},
		fixedFooterContainer: function () {
            /* returns container(jQuery representation) containing fixed footer
				returnType="object" jQuery representation of fixed table
			*/
			return this.container().find("#" + this.id() + "_fixedFooterContainer");
		},
		fixedHeaderContainer: function () {
            /* returns container(jQuery representation) containing fixed header
				returnType="object" jQuery representation of fixed table
			*/
            return this.container().find("#" + this.id() + "_fixedHeaderContainer");
        },
		fixedHeadersTable: function () {
			/* returns the table that contains the FIXED header cells 
				returnType="dom"
			*/
			if (this.options.fixedHeaders === true && this.options.height !== null) {
				return this.container().find("#" + this.id() + "_headers_fixed");
			}
			return this.container().find("#" + this.id() + "_fixed");
		},
        fixedFootersTable: function () {
			/* returns the table that contains the footer cells 
				returnType="dom"
			*/
			if (this.options.fixedFooters === true && this.options.height !== null) {
				return this.container().find("#" + this.id() + "_footers_fixed");
			}
			return this.container().find("#" + this.id() + "_fixed");
		},
		_vdisplaycontainer: function () {
			return this.container().find("#" + this.id() + "_displayContainer");
		},
		_virtualcontainer: function () {
			return this.container().find("#" + this.id() + "_virtualContainer");
		},
		_vhorizontalcontainer: function () {
			return this.container().find("#" + this.id() + "_horizontalScrollContainer");
		},
		_fixedfooters: function () {
			return this.container().find("#" + this.id() + "_footer_container");
		},
		// Accepts parameters:
		// x - column index
		// y - row index
        // isFixed - defines whether to get cell from fixed table
		cellAt: function (x, y, isFixed) {
			/* returns the cell TD element at the specified location
				paramType="number" The column index.
				paramType="number" The row index.
				paramType="bool" Optional parameter - if true get cell TD at the specified location from the fixed table
				returnType="dom" The cell at (x, y).
			*/
			var i;
			// returns a cell at the specified location in the table. jQuery selectors are not used for performance reasons. 
			if (x === undefined || y === undefined) {
				return null;
			}
			//return this.element.find('tbody tr:nth-child(' + (y + 1) + ') td:nth-child(' + (x + 1) + ')');
			if (this.table === undefined) {
				this.table = this.element[0];
			}
			//A.T. 21 Jan 2011 - We must account for all THEAD and TFOOT rows ! . Calculate that only once, for perf. reasons
			i = this._dataRowIndex(y);
			if (isFixed === true) {
				if (this._fixedTable === undefined) {
					this._fixedTable = this.element;
				}
				return this._fixedTable[0].rows[i].cells[x];
			}
			return this.table.rows[i].cells[x];
		},
		cellById: function (rowId, columnKey) {
			/* returns the cell TD element by row id and column key
				paramType="number|string" The id of the row.
				paramType="string" The column key.
				returnType="dom" The cell for (rowId, columnKey).
			*/
			var colIndex, i, cols, row, skippedCells, isFixed = this.isFixedColumn(columnKey);
			if (_aNull(rowId) || _aNull(columnKey)) {
				return null;
			}
			if (this.table === undefined) {
				this.table = this.element[0];
			}
			cols = this._visibleColumns(isFixed);
			for (i = 0; i < cols.length; i++) {
				if (cols[i].key === columnKey) {
					colIndex = i;
					break;
				}
			}
			if (_aNull(colIndex)) {
				return null;
			}
			if (isFixed) {
				row = this.fixedBodyContainer().find("tbody").first().children("[data-id='" + rowId + "']").first();
			} else {
				row = this.element.children("tbody").children("[data-id='" + rowId + "']").first();
			}
			skippedCells = row.children("th,[data-skip=true],[data-parent]").length;
			return row.children("td:nth-child(" + (colIndex + 1 + skippedCells) + ")");
		},
		// Returns fixed table
		fixedTable: function () {
			/* returns the fixed table
				returnType="object" jQuery representation of fixed table
			*/
			if (this._fixedTable === undefined) {
				this._fixedTable = this.element[0];
			}
			return this._fixedTable;
		},
		_calculateHeaderFooterRows: function () {
			// A.T. 29 Aug 2011 - this is recursive and needs to be reworked 
			//return this.element.find('thead tr').length + this.element.find('tfoot tr').length;
			var theadCount = 0, tfootCount = 0;
			theadCount = this.element.children("thead").children("tr").length;
			// M.H. 11 Oct. 2011 Fix for bug #90863 - footer  rows count should not be calculated
			// M.H. 27 April 2012 Fix for bug #105427 - Opera counts tfoot rows then tbody tr
			if ($.ig.util.isOpera) {
				tfootCount = this.element.children("tfoot").children("tr").length;
			}
			return theadCount + tfootCount;
		},
		_dataRowIndex: function (i) {
			var extrahr, j;
			if (this.table === undefined) {
				this.table = this.element[0];
			}
			if (this._additionalTrCount === undefined || this._additionalTrCount === null) {
				this._additionalTrCount = this._calculateHeaderFooterRows();
			}
			// get all data-container rows and exclude them
			if (this._hc === true) {
				extrahr = this.element.children("tbody").children("tr[data-container]");
				for (j = 0; j < extrahr.length; j++) {
					if ($(extrahr[j]).index() <= i) {
						i += 1;
					}
				}
			}
			i = i + this._additionalTrCount;
			if (i >= this.table.rows.length) {
				i = this.table.rows.length - 1;
			} else if (i < 0) {
				i = 0;
			}
			return i;
		},
		immediateChildrenWidgets: function () {
			/* gets all immediate igGrid children of the current grid
				returnType="array"
			*/
			return this.element.children("tbody").children("tr").children(".ui-iggrid-childarea").children("div").children("div").map(function () {
				if ($(this).children(".ui-iggrid-scrolldiv").length > 0) {
					return $(this).children(".ui-iggrid-scrolldiv").children(".ui-iggrid-table").data("igGrid");
				}
				return $(this).children(".ui-iggrid-table").data("igGrid");
			});
		},
		childrenWidgets: function () {
			/* gets all igGrid children of the current grid, recursively 
				returnType="array"
			*/
			return this.element.find("tbody > tr > .ui-iggrid-childarea").find(".ui-iggrid-table").map(function () {
				return $(this).data("igGrid");
			});
		},
		children: function () {
			/* gets all igGrid children's elements of the current grid, recursively 
				returnType="array"
			*/
			return this.element.find("tbody > tr > .ui-iggrid-childarea").find(".ui-iggrid-table");
		},
		immediateChildren: function () {
			/* gets all immediate igGrid children's elements of the current grid
				returnType="array"
			*/
			return this.element.children("tbody").children("tr").children(".ui-iggrid-childarea").children("div").children("div").map(function () {
				if ($(this).children(".ui-iggrid-scrolldiv").length > 0) {
					return $(this).children(".ui-iggrid-scrolldiv").children(".ui-iggrid-table");
				}
				return $(this).children(".ui-iggrid-table");
			});
		},
		// Accepts parameters:
		// i - row index 
		rowAt: function (i) {
			/* returns the row (TR element) at the specified index. jQuery selectors aren't used for performance reasons 
				paramType="number" The row index.
				returnType="dom" the row at the specified index
			*/
			//A.T. 21 Jan 2011 - We must account for all THEAD and TFOOT rows ! . Calculate that only once, for perf. reasons
			i = this._dataRowIndex(i);
			return this.table.rows[i];
		},
		rowById: function (rowId, isFixed) {
			/* returns the row TR element by row id
				paramType="number|string" The id of the row.
				paramType="bool" optional="true" Specify search in the fixed container.
				returnType="dom" The row for (rowId).
			*/
			if (_aNull(rowId)) {
				return null;
			}
			if (isFixed) {
				return this.fixedBodyContainer().find("tbody").first().children("[data-id='" + rowId + "']").first();
			}
			return this.element.children("tbody").children("[data-id='" + rowId + "']").first();
		},
		// Accepts parameters:
		// i - row index 
		fixedRowAt: function (i) {
			/* returns the fixed row (TR element) at the specified index. jQuery selectors aren't used for performance reasons 
				paramType="number" The row index.
				returnType="dom" the row at the specified index
			*/
			// M.H. 22 Aug 2013 Fix for bug #145764: The rowAt method returns only the unfixed row when there is fixed columns.
			var rows = this.fixedBodyContainer().find('tbody>tr');
			if (rows.length > 0) {
				return rows[i];
			}
			return null;
		},
		fixedRows: function () {
			/* returns a list of all fixed TR elements holding data in the grid
				returnType="array"
			*/
			// M.H. 23 Jul 2013 Fix for bug #143616: The row element that is returned by activeRow method is only from the unfixed area.
			return this.fixedBodyContainer().children("tbody").children("tr");
		},
		rows: function () {
			/* returns a list of all TR elements holding data in the grid
				returnType="array"
			*/
			//return this.element.find('tbody tr');
			return this.element.children("tbody").children("tr");
		},
		allFixedRows: function () {
			/* returns all data fixed rows recursively, not only the immediate ones 
				returnType="array"
			*/
			// M.H. 23 Jul 2013 Fix for bug #143616: The row element that is returned by activeRow method is only from the unfixed area.
			return this.fixedBodyContainer().find('tbody tr');
		},
		allRows: function () {
			/* returns all data rows recursively, not only the immediate ones 
				returnType="array"
			*/
			return this.element.find('tbody tr');
		},
		columnByKey: function (key) {
			/* returns a column object by the specified column key 
				paramType="string" The column key.
				returnType="object" a column definition
			*/
			var cols = this.options.columns, i;
			for (i = 0; i < cols.length; i++) {
				// L.A. 07 December 2012 - Fixing bug #129117 When you use DOM table as a data 
				// source for the grid and redefine the header of a column in columnSettings it 
				// duplicates the column with the new header text.
				// Features like column moving, sorting and etc are passing key as string
				if (String(cols[i].key) === String(key)) {
					return cols[i];
				}
			}
			return null;
		},
		columnByText: function (text) {
			/* Returns a column object by the specified header text. If there are multiple matches, returns the first one.
				paramType="string" The column header text.
				returnType="object" a column definition
			*/
			var cols = this.options.columns, i;
			for (i = 0; i < cols.length; i++) {
				if (cols[i].headerText === text) {
					return cols[i];
				}
			}
			return null;
		},
		activeCell: function () {
			/* returns the current active cell if any, Selection must be enabled. 
				returnType="object"
			*/
			return this._activeCell;
		},
		activeRow: function () {
			/* returns the current active row if any, Selection must be enabled. 
				returnType="object"
			*/
            // M.H. 23 Jul 2013 Fix for bug #143616: The row element that is returned by activeRow method is only from the unfixed area.
            if (this._activeRow) {
                if (this.hasFixedColumns()) {
                    if (this._activeFixedRow) {
                        this._activeRow.fixedElement = this._activeFixedRow.element;
                    } else {
                        this._activeRow.fixedElement = this.fixedBodyContainer()
                            .find('tbody tr:nth-child(' + (this._activeRow.index + 1) + ')');
                    }
                } else if (this._activeRow.fixedElement) {
                    this._activeRow.fixedElement = null;
                }
            }
			return this._activeRow;
		},
		selectedCell: function () {
			/* Returns the current selected cell if any. Selection must be enabled.
				returnType="object"
			*/
			return this._selectedCell;
		},
		selectedRow: function () {
			/* Returns the current selected row if any. Selection must be enabled.
				returnType="object"
			*/
			return this._selectedRow;
		},
		selectedCells: function () {
			/* Returns the current array of selected cells if any. Selection must be enabled and multipleSelection must be true.
				returnType="array"
			*/
			return this._selectedCells;
		},
		selectedRows: function () {
			/* Returns the current array of selected rows if any. Selection must be enabled and multipleSelection must be true.
				returnType="array"
			*/
			return this._selectedRows;
		},
		getCellValue: function (rowId, colKey) {
			/* Retrieves a cell value using the row index and the column key. If a primaryKey is defined, rowId is assumed to be the row Key (not index).
				If primary key is not defined, then rowId is converted to a number and is used as a row index.
				If colKey is a number, the index of the column is used (instead of a column name).
				paramType="object" Row index or row key (primary key).
				paramType="string" The column key.
				returnType="object" The corresponding cell value.
			*/
			var id = parseInt(rowId, 10), i, cols = this.options.columns, colFound = false, rec, primaryKeyCol, tx;
			// check the case where we have a local transaction log, and there is a corresponding entry for that row's cell
			tx = this.dataSource.pendingTransactions();
			if (this.options.autoCommit === false && tx.length > 0) {
				for (i = 0; i < tx.length; i++) {
					if (tx[i].rowId === rowId) {
						if (tx[i].type === "cell" && tx[i].col === colKey) {
							return tx[i].value;
						}
						if (tx[i].type === "row" || tx[i].type === "newrow") {
							return tx[i].row[colKey];
						}
					}
				}
			}
            // M.H. 6 Jan 2014 Fix for bug #160364: noSuchColumnDefined error is not thrown when an undefined column is used in getCellValue method
            if ($.type(colKey) === 'string') {
				for (i = 0; i < cols.length; i++) {
					if (cols[i].key === colKey) {
						colFound = true;
						break;
					}
				}
				if (colFound === false) {
					throw new Error($.ig.Grid.locale.noSuchColumnDefined);
				}
			}
			// check for primary key
			if (this.options.primaryKey !== null) {
				// assume rowId is the primary Key, not the row index
				primaryKeyCol = this.columnByKey(this.options.primaryKey);
				if (primaryKeyCol.dataType === "number" || primaryKeyCol.dataType === "numeric") {
					rec = this.dataSource.findRecordByKey(parseInt(rowId, 10));
				} else {
					rec = this.dataSource.findRecordByKey(rowId);
				}
				if (rec === null || rec === undefined) {
					throw new Error($.ig.Grid.locale.recordNotFound + " " + rowId);
				}
				return rec[colKey];
			}
			// validate
			if (id >= this.dataSource.dataView().length) {
				throw new Error($.ig.Grid.locale.indexOutOfRange);
			}
			if ($.type(colKey) === 'string') {
				return this.dataSource.dataView()[id][colKey];
			}
			if (cols.length <= colKey) {
				throw new Error($.ig.Grid.locale.columnIndexOutOfRange);
			}
			return this.dataSource.dataView()[id][colKey];
		},
		getCellText: function (rowId, colKey) {
			/* Returns the cell text. If colKey is a number, the index of the column is used (instead of a column name)
				This is the actual text (or HTML string) for the contents of the cell.
				paramType="object" Row index or row data key (primary key)
				paramType="string" Column key.
				returnType="string" the cell text for the respective cell 
			*/
			var colIndex;
			if ($.type(colKey) === 'string') {
				colIndex = this._getCellIndexByColumnKey(colKey);
			} else {
				colIndex = colKey;
			}
			if (colIndex === undefined) {
				throw new Error($.ig.Grid.locale.columnNotFound + " " + colKey);
			}
			// use with care. 
			if (this.options.primaryKey !== null) {
				// find the TR using a selector
				return this.element.find("tr[data-id='" + rowId + "']>td:nth-child(" + (colIndex + 1) + ")").text();
			}
			return $(this.cellAt(colIndex, parseInt(rowId, 10))).text();
		},
		setColumnTemplate: function (col, tmpl, render) {
			/* Sets a new template for a column after initialization and renders the grid if not explicitly disabled. This method will replace any existing explicitly set row template and will build one anew from the column ones.
				paramType="string|number" An identifier of the column to set template for (index or key)
				paramType="string" The column template to set
				paramType="bool" optional="true" default="true" Should the grid rerender after template is set
			*/
			var colIdx = this._getColIdxById(this.options.columns, col);
			if (colIdx === null || colIdx === undefined) {
				return;
			}
			col = this.options.columns[colIdx];
			col.template = tmpl;
			render = render === null || render === undefined ? true : render;
			if (render && !col.hidden) {
				this._renderData();
			}
		},
		commit: function (rowId) {
			/* Commits all pending transactions to the client data source. Note that there won't be anything to commit on the UI, since it is updated instantly. In order to rollback the actual UI, a call to dataBind() is required.
				paramType="string|number" optional="true" If specified, will commit only that transaction corresponding to the specified index/ key.
			*/
			var key;
			key = this._normalizedKey(rowId);
			// commits all changes to the data source (delegates to igDataSource). Note that there won't be anything to commit on the UI, since it is updated instantly ! 
			// in order to rollback the actual UI, a call to dataBind() is required ! 
			this.dataSource.commit(key);
			if (this._fireInternalEvent("_gridCommit")) {
				// if a feature handles the commit call we shouldn't redo the same
				return;
			}
			if (this.options.virtualization || this.options.rowVirtualization || this.options.columnVirtualization) {
				if (this.options.virtualizationMode === "continuous") {
					this._renderVirtualRecords();
				} else {
					this._buildVirtualDom();
					this.virtualScrollTo(this._startRowIndex);
				}
			} else {
				this._renderData();
			}
		},
		rollback: function (rowId, updateUI) {
			/* Clears the transaction log (delegates to igDataSource). Note that this does not update the UI. In case the UI must be updated, set the second parameter "updateUI" to true, which will trigger a call to dataBind() to re-render the contents. 
				paramType="string|number" optional="true" If specified, will only rollback the transactions with that row id.
				paramType="bool" optional="true" Whether to update the UI or not.
			*/
			var key = this._normalizedKey(rowId), transactions = this.dataSource.rollback(key),
				transaction, content, i, skip = false, tridx, rec, tr;
			if (updateUI === true) {
				if (!_aNull(rowId)) {
					if (transactions.length === 0) {
						// if no transactions are returned by the data source we shouldn't do anything
						return;
					}
					i = transactions.length;
					while (i-- > 0) {
						transaction = transactions[i];
						tr = this.element.find("tr[data-id='" + transaction.rowId + "']");
						switch (transaction.type) {
							case "newrow":
								// the row found needs to be removed
								tridx = this.element.children("tbody").children("tr:not([data-container],[data-grouprow])").index(tr);
								tr.remove();
								this._reapplyZebraStyle(tridx);
								break;
							case "deleterow":
								// the row found should have its deleted style cleared
								tr.removeClass(this.css.deletedRecord);
								break;
							case "cell":
								// all cell transactions for this row will have the same row id and therefore will be removed together
								// so we'll just remove the whole row's modified style
								tr.removeClass(this.css.modifiedRecord);
								td = this.cellById(transaction.rowId, transaction.col);
								rec = this.dataSource.findRecordByKey(transaction.rowId);
								if (this.options.rowTemplate && this.options.rowTemplate.length > 0) {
									content = this._renderTemplatedCell(rec, transaction.col);
									index = content.indexOf('>');
									content = content.substring(index + 1, content.length);
									td.html(content);
								} else {
									td.html(this._renderCell(rec[transaction.col], transaction.col, rec));
								}
								break;
							case "row":
								tr.removeClass(this.css.modifiedRecord);
								rec = this.dataSource.findRecordByKey(transaction.rowId);
								this._renderRow(rec, tr[0], rec[this.options.primaryKey]);
								break;
						}
					}
				} else {
					this.dataBind();
				}
			}
		},
		findRecordByKey: function (key) {
			/* returns a record by a specified key (requires that primaryKey is set in the settings).
				That is a wrapper for this.dataSource.findRecordByKey(key).
				paramType="string" Primary key of the record
				returnType="object" a JavaScript object specifying the found record, or null if no record is found
			*/
			return this.dataSource.findRecordByKey(key);
		},
		getDetachedRecord: function (t) {
			/* Returns a standalone object (copy) that represents the committed transactions, but detached from the data source.
				That is a wrapper for this.dataSource.getDetachedRecord(t).
				paramType="object" A transaction object.
				returnType="object" A copy of a record from the data source.
			*/
			return this.dataSource.getDetachedRecord(t);
		},
		pendingTransactions: function () {
			/* Returns a list of all transaction objects that are pending to be committed or rolled back to the data source.
				That is a wrapper for this.dataSource.pendingTransactions().
				returnType="array"
			*/
			return this.dataSource.pendingTransactions();
		},
		allTransactions: function () {
			/* returns a list of all transaction objects that are either pending, or have been committed in the data source. 
				That is a wrapper for this.dataSource.allTransactions().
				returnType="array"
			*/
			return this.dataSource.allTransactions();
		},
		transactionsAsString: function () {
			/* Returns the accumulated transaction log as a string. The purpose of this is to be passed to URLs or used conveniently.
				That is a wrapper for this.dataSource.transactionsAsString().
				returnType="string"
			*/
			return this.dataSource.transactionsAsString();
		},
		_normalizedKey: function (id) {
			// returns a normalized key because id can be both index or a primary key (string / number) 
			var key, primaryKeyCol;
			// A.T. 15 Sept. 2011 - Fix for #88104
			if (id === undefined || id === null) {
				return null;
			}
			key = id;
			if (this.options.primaryKey !== null) {
				primaryKeyCol = this.columnByKey(this.options.primaryKey);
				if (primaryKeyCol.dataType === "number" || primaryKeyCol.dataType === "numeric") {
					key = parseInt(id, 10);
				}
			} else {
				key = parseInt(id, 10);
			}
			return key;
		},
		saveChanges: function (success, error) {
			/* Invokes an AJAX request to the updateUrl option (if specified) and passes the serialized transaction log (a serialized JSON string) as part of the POST request. 
            paramType="function" Specifies a custom function to be called when AJAX request to the updateUrl option succeeds(optional)
            paramType="function" Specifies a custom function to be called when AJAX request to the updateUrl option fails(optional)
            */
			this.dataSource.saveChanges(success, error);
		},
		// if rowId is not null, then it is a request to fix css (update/add/delete row)
		_renderRow: function (rec, tr, rowId) {
			var i, td, col, id = 0, css, cols = this.options.columns, content, index;
			for (i = 0; i < tr.cells.length; i++) {
				td = $(tr.cells[i]);
				css = td[0].className;
				if (id > 0 || !(td.attr('data-skip') || (css && (css.indexOf('-expandcolumn') > 0 || css.indexOf('-rowselector') > 0)))) {
					// adjust for hidden columns
					while (true) {
						col = cols[id];
						if (!col) {
							return tr;
						}
						if (!col.hidden) {
							break;
						}
						id++;
					}
					// K.D. Bug #102873 Rendering branch is done here
					if (col.template && col.template.length) {
						content = this._renderTemplatedCell(rec, col);
						if (content.indexOf("<td") === 0) {
							td.html($(content).html());
						} else {
						td.html(content);
						}
					} else {
						td.html(this._renderCell(rec[col.key], col, rec));
					}
					id++;
				}
			}
			return tr;
		},
		renderNewRow: function (rec, key) {
			/* Adds a new row (TR) to the grid, by taking a data row object. Assumes the record will have the primary key.
				paramType="object" The data row JavaScript object.
				paramType="string" optional="true" Identifier/key of row. If missing, then number of rows in grid is used.
			*/
			var tbody = this.element.children("tbody"), index, self = this, virt = this.options.virtualization === true ||
				this.options.rowVirtualization === true, fv = this.options.virtualizationMode === "fixed";
			// S.S. April 25, 2013 Bug #139544 When virtualization is enabled we need to rebuild the dom so that all virtualization
			// related variables are properly set
			if (virt) {
				if (fv) {
					this._buildVirtualDom();
				} else {
					this._renderVirtualRecordsContinuous();
					this._startRowIndex = 0;
				}
				this.virtualScrollTo(this._totalRowCount);
			} else {
				index = tbody.children("[data-container!=\"true\"]").length;
				// K.D. April 5th, 2012 Bug #107910 Render record handles the rendering of regular and templated records.
				MSApp.execUnsafeLocalFunction(function () {
					tbody.append(self._renderRecord(rec, index));
				});
			}
		},
		_findTableRowByKey: function (key) {
			var primaryKeyIndex, cols = this.options.columns, r, i;
			// find the index of the primary key column
			if (this.options.primaryKey !== null) {
				for (i = 0; i < cols.length; i++) {
					if (cols[i].key === this.options.primaryKey) {
						primaryKeyIndex = i;
						break;
					}
				}
				if (primaryKeyIndex === undefined) {
					throw new Error($.ig.Grid.locale.columnNotFound + " " + this.options.primaryKey);
				}
				r = this.element.find("td:nth-child('" + (primaryKeyIndex + 1) + "'):contains('" + key + "')").parent();
				return r.length === 0 ? null : r[0];
			}
			return this.rowAt(parseInt(key, 10));
		},
		/* A.T. 21 Jan 2010 - Fix for bug #62277 - Data rebinding doesn't work properly. You have to reset all the properties for the binding
		 * widget options are deep cloned !!! Therefore if the data source is LOCAL json array or some object, it must be set through the API, not in the options
		 * alternatively if it is set from options, it will be deep copied !
		 */
		dataSourceObject: function (dataSource) {
			/* if the data source points to a local JSON array of data, and it is necessary to reset it at runtime, it must be done through this API member instead of the options (options.dataSource) 
				paramType="object" New data source object. 
			*/
			if (dataSource !== undefined) {
				this.options.dataSource = dataSource;
			} else {
				return this.options.dataSource;
			}
		},
		totalRecordsCount: function () {
			/* Returns the total number of records in the underlying backend. If paging or filtering is enabled, this may differ from the number of records in the client-side data source.
				In order for this to work, the response JSON/XML must include a property that specifies the total number of records, which name is specified by options.responseTotalRecCountKey.
				This functionality is completely delegated to the data source control.
				returnType="number" total number of records in the backend
			*/
			return this.dataSource.totalRecordsCount();
		},
		dataBind: function (internal) {
			/* causes the grid to data bind to the data source (local or remote) , and re-render all of the data as well 
			excluded="true"
			*/
			var dataOptions, i, noCancel = true, noCancelRendering = true;
			// M.H. 17 May 2012 Fix for bug #111100: The rendering event has to be fired	before   the (dataBinding and dataBound) pair of events
			// A.T. 9 Jan 2012 - fix for bug #98777
			if (!this._initialized) {
				noCancelRendering = this._trigger(this.events.rendering, null, {owner: this});
			}
			if (noCancelRendering) {
				// fire data binding event
				noCancel = this._trigger(this.events.dataBinding, null, {owner: this});
				if (internal === undefined) {
					this.options.requiresDataBinding = true;
				}
				if (noCancel) {
					if (this.options.requiresDataBinding) {
                        // M.H. 23 Jan 2013 Fix for bug #130586
                        if (this._hasUnboundColumns) {
                            this._rebindUnboundColumns = true;
                        }
						dataOptions = this._generateDataSourceOptions(this.options);
						//A.T. 18 Jan 2011 - Fix for bug #62277 - Data rebinding doesn't work properly. You have to reset all the properties for the binding
						this._setupDataSource(dataOptions);
						//initialize grid features and attach their event handlers
						this._dataOptions = dataOptions;
						//if (this.options.autoGenerateColumns === false) {
						if (!this._initialized) {
							// check if the element passed on the widget is of type table or div
							if (this.element.is("div")) {
								this._isWrapped = true;
								this.element = $("<table></table>").appendTo(this.element).attr('id', this.id() + "_table");
								this.element.data('igGrid', this);
								//gridElement = this.element[0];
							}
							for (i = 0; i < this.options.features.length; i++) {
								this._initFeature(this.options.features[i], dataOptions);
							}
							//NOTE: this is the only point were we can do the capturing of the 
							//hidden columns as it should be before we render the grid
							//and after all features(including hiding) have been initialized
							//A.Y. bug 98100. In the case of autogenerated columns this will be done later.
							if (this.options.autoGenerateColumns !== true) {
								this._captureInitiallyHiddenColumns();
							}
							this._visibleColumnsArray = undefined;
						} else {
                            // M.H. 26 Mar 2013 Fix for bug #126556: DataBound event is fired twice after GroupBy when explicitly invoking "dataBind" method
                            this._isDataBoundCalled = true;
							this.element.trigger('iggriduidirty', {owner: this});
							// fire UI State dirty so that features reset their UI (without destroying them)
							for (i = 0; i < this.options.features.length; i++) {
								this._initFeatureSettings(this.options.features[i]);
							}
							// M.H. 9 Nov 2012 Fix for bug #126509
							//this._trigger("headerExtraCellsModified", null, { owner: this });
						}
						//}
						this._renderGrid();
						if (this._loadingIndicator === undefined) {
							this._initLoadingIndicator();
						}
						if (this._loadingIndicator) {
							this._loadingIndicator.show();
						}
						this.dataSource.dataBind();
						this.options.requiresDataBinding = false;
					} else {
						// data source is already bound 
						this._renderGrid();
					}
				}
			// M.H. 17 May 2012 Fix for bug #111100
			} else {
				// cancel render data
				this._cancelRendering = true;
			}
		},
		_mergeUnboundValues: function () {
			// merge unbound values when datasource is remote and merguUnboundColumns is false
			var i, primaryKeyCol, metadataUC, rec, ucLength, primaryKeyColIsNumber, col, schema, type, dataLength, data, key, val, j,
				pk = this.options.primaryKey,
				metadata = this.dataSource.metadata("unboundValues"),
				self = this,
				hasPrimaryKey = (pk !== null && pk !== undefined),
				metaDataMergeFunction;
			if (metadata === undefined || metadata === null || metadata.length === 0 ||
					!this._unboundColumns) {
				return;
			}
			// M.H. 30 Aug 2012 Fix for bug #120134
			if (hasPrimaryKey) {
				metaDataMergeFunction = function (ind, val) {
					if (primaryKeyColIsNumber) {
						rec = self.dataSource.findRecordByKey(parseInt(ind, 10));
					} else {
						rec = self.dataSource.findRecordByKey(ind);
					}
					if (rec === null || rec === undefined) {
						return true;
					}
					// M.H. 10 Sep 2012 Fix for bug #120724
					if (schema !== undefined && schema !== null) {
						// M.H. 11 Sep 2012 Fix for bug #120867
						val = schema._convertType(type, val, rec[pk], key);
					}
					// M.H. 11 Sep 2012 Fix for bug #120668
					self._addUnboundColumnValue(key, val);
					rec[key] = val;
				};
				primaryKeyCol = this.columnByKey(pk);
				primaryKeyColIsNumber = (primaryKeyCol.dataType === "number");
			}
			ucLength = this._unboundColumns.length;
			schema = this.dataSource.schema();
			for (i = 0; i < ucLength; i++) {
				key = this._unboundColumns[i].key;
				metadataUC = metadata[key];
				if (metadataUC === null || metadataUC === undefined) {
					continue;
				}
				col = this.getUnboundColumnByKey(key);
				type = null;
				if (col !== null && col.dataType) {
					type = col.dataType;
				}
				// M.H. 30 Aug 2012 Fix for bug #120134
				if (hasPrimaryKey) {
					// M.H. 10 Sep 2012 Fix for bug #120724
					$.each(metadataUC, metaDataMergeFunction);
				} else {
					self._renderUnboundValues(metadataUC, key);
				}
				// M.H. 11 Sep 2012 Fix for bug #120569
				if (type === "bool" || type === "boolean") {
					data = this.dataSource.data();
					val = schema._convertType(type, undefined);
					dataLength = data.length;
					// just for performance - we do not want to traverse all 
					if (dataLength <= metadataUC.length) {
						continue;
					}
					for (j = 0; j < dataLength; j++) {
						if (data[j][key] === undefined) {
							data[j][key] = val;
						}
					}
				}
			}
		},
		_generateDataSourceOptions: function (options) {
			var schema, dataOptions, t, headers, i, instanceOfDs;
			// if there is neither options.dataSource specified, nor options.dataSourceUrl, we check if we are binding to a table and if there is any existing
			// data in it, and then we set the data source to that table DOM element, so that it can be processed by the data source control
			if (!this.options.dataSource && !this.options.dataSourceUrl && this.element.is('table') && this.element.find('tbody').children().length > 0) {
				this.options.dataSource = this.element[0];
			}
			// we need to look ahead and check if the data source is a HTML Table and has column headers defined. in that case we need to update the headerText in the column definitions
			if (this.options.dataSource && this.options.dataSource.tagName && this.options.dataSource.nodeType) {
				t = $(this.options.dataSource);
				if (t.is('table') && t.find('thead th').length > 0) {
					// generate column headers 
					headers = t.find('thead tr th');
					this._tb_h = true;
					this._tb_h_arr = [];
					for (i = 0; i < headers.length; i++) {
						this._tb_h_arr.push($(headers[i]).text());
					}
					/*
					if (this.options.columns.length > 0) {
						for (i = 0; i < headers.length && i < this.options.columns.length; i++) {
							this.options.columns[i].headerText = $(headers[i]).text();
						}
					} else {
						for (i = 0; i < headers.length; i++) {
							this.options.columns.push({"headerText": $(headers[i]).text()});
						}
					}
					*/
				}
			}
			dataOptions = {
				callback: $.proxy(this._renderData, this),
				callee: this,
				responseDataKey: this.options.responseDataKey,
				responseTotalRecCountKey: this.options.responseTotalRecCountKey,
				dataSource: this.options.dataSource,
				requestType: this.options.requestType,
				responseContentType: this.options.responseContentType,
				primaryKey: this.options.primaryKey,
				localSchemaTransform: this.options.localSchemaTransform,
				autoCommit: this.options.autoCommit,
				aggregateTransactions: this.options.aggregateTransactions,
				serializeTransactionLog: this.options.serializeTransactionLog,
				updateUrl: this.options.updateUrl,
				restSettings: this.options.restSettings
			};
			if (this.options.dataSourceType !== null) {
				dataOptions.type = this.options.dataSourceType;
			}
            // create a schema based on the columns definition
			// iterate over the columns collection, if such exists. Otherwise bind to everything
			//A.T. 28 March 2011 - fix for bug #68548
			//L.A. 02 August 2012 - Fixing bug #117263 - Grid doesn't render binding to XML string
			// M.H. 15 Sep 2012 Fix for bug #121429
			if (!this.options.dataSource || !this.options.dataSource.schema || !this.options.dataSource.schema() || this.options.dataSource.schema()._type !== "xml") {
				schema = this._generateDataSourceSchema();
			}
			// M.H. 27 Mar 2014 Fix for bug #168313: Grid overrides the data source schema fields and the localSchemaTransform option
			// if DataSource schema is set in the DataSource(taken from options) and is of type DataSchema then we use it otherwise we should generate it
			instanceOfDs = this.options.dataSource &&
				typeof this.options.dataSource._xmlToArray === "function" &&
				typeof this.options.dataSource._encodePkParams === "function";
			if ((instanceOfDs && (this.options.dataSource.settings.schema === null ||
				!this.options.dataSource.settings.schema.fields ||
				(this.options.dataSource.settings.schema.fields && this.options.dataSource.settings.schema.fields.length >= 0))) ||
				!instanceOfDs) {
				dataOptions = $.extend(dataOptions, { schema: schema });
			}
			return dataOptions;
		},
		_insertUnboundColumn: function (column) {
			if (this._unboundColumns === null || this._unboundColumns === undefined) {
				this._unboundColumns = [];
			}
			this._unboundColumns.push(column);
			// M.H. 3 Sep 2012 Fix for bug #120188
			if (column.key && (this._unboundValues[column.key] === null || this._unboundValues[column.key] === undefined)) {
				this._unboundValues[column.key] = [];
			}
			// M.H. 1 Nov 2012 Fix for bug #120553
			if (column.unboundValues && column.unboundValues.length > 0) {
				this._isToSetUnboundColumns = true;
			}
			this._hasUnboundColumns = true;
		},
		// M.H. 10 Sep 2012 Fix for bug #120696 - add index value
		_addUnboundColumnValue: function (key, value, index) {
			// insert in _unboundValues object for the unbound column with the specified key value. If index is specified at position index
			if (this._unboundValues[key] === null || this._unboundValues[key] === undefined) {
				this._unboundValues[key] = [];
			}
			if (index !== undefined && index !== null) {
				this._unboundValues[key][index] = value;
			} else {
				this._unboundValues[key].push(value);
			}
		},
		_generateDataSourceSchema: function () {
			var schema, i, rec, prop, count = 0, cols = this.options.columns, ds = this.options.dataSource, cl, counter = 0;
			//A.T. 22 Aug 2011 - make sure this scenario is covered as well 
			if (ds && typeof ds._xmlToArray === "function" && typeof ds._encodePkParams === "function") {
				if ($.type(ds.settings.dataSource) === "array" || $.type(ds.settings.dataSource) === "object") {
					ds = ds.settings.dataSource;
				} else if ($.type(ds.settings.dataSource) !== "string") {
					ds = ds.data();
				} else {
					ds = [];
				}
			}
			// M.H. 16 May 2012 Fix for bug #99426			
			if ($.type(ds) === "object" && this.options.responseDataKey) {
				ds = $.ig.findPath(ds, this.options.responseDataKey);
			}
			schema = {};
			schema.fields = [];
			schema.searchField = this.options.responseDataKey;
			//if (this.options.columns.length > 0) {
			if (cols.length > 0 && !this.options.autoGenerateColumns) {
			// if autoGenerateColumns is true, fields for all columns in the data source must be specified
				for (i = 0; i < cols.length; i++) {
					if (cols[i].unbound === true || cols[i].unboundDS === true) {
						this._insertUnboundColumn(cols[i]);
						if (cols[i].unbound === true) {
							continue;
						}
					}
					schema.fields[counter] = {};
					schema.fields[counter].name = cols[i].key;
					schema.fields[counter].type = cols[i].dataType;
					counter++;
				}
			//} else if (this.options.columns.length > 0 && this.options.autoGenerateColumns) {
			} else if (this.options.autoGenerateColumns) {
				// A.T. Fix for #74240. Please note that in this case (if autoGenerateColumns=true, and there are custom cols defined,
				// and they have widths defined, there MUST be defaultColumnWidth specified, otherwise the remaining columns in the data source
				// will be shrinked to zero and they won't be visible ! 
				if (ds && ds.tagName && $(ds).is("table") &&
						$(ds).find("tbody tr").length > 0) {
					rec = $(ds).find("tbody tr")[0];
				//	count = $(rec).find('td').length;
					$(rec).find('td').each(function () {
						if (cols.length > count) {
							schema.fields.push({name: cols[count].key || (count + 1),
								type: cols[count].dataType || "string"});
						} else {
							schema.fields.push({name: (count + 1), type: "string"});
						}
						count++;
					});
				} else if (ds && ds.length && ds.length > 0 &&
						$.type(ds) === "array") {
					// we need to iterate through all records, since the first one may not necessarily contain any children
					//rec = this.options.dataSource[0];
					for (i = 0; i < ds.length; i++) {
						rec = ds[i];
						for (prop in rec) {
							if (rec.hasOwnProperty(prop)) {
								// if the column isn't already defined in the columns collection 
								if (this.columnByKey(prop) === null && !this._fieldExists(prop, schema) &&
										$.type(rec[prop]) !== "object" && $.type(rec[prop]) !== "array") {
									schema.fields.push({name: prop, type: $.ig.getColType(rec[prop])});
								} else if (this.columnByKey(prop) !== null) {
									schema.fields.push({name: prop, type: this.columnByKey(prop).dataType});
								}
								count++;
							}
						}
						// performance improvement. The flat grid doesn't need that. Also the hierarchical grid doesn't need that if autoGenerateLayouts is not true.
						if (!this.options._recurseSchema) {
							break;
						}
					}
				}
				// check for unbound columns
				for (i = 0; i < cols.length; i++) {
					if (cols[i].unbound === true || cols[i].unboundDS === true) {
						this._insertUnboundColumn(cols[i]);
					}
				}
			}
			// used in special cases where the schema needs to be additionally modified ( as it is the case with hGrid, so that all complex objects
			// are also added to the schema whenever autoGenerateColumns === false (only in that case) 
			this._trigger(this.events.schemaGenerated, null, {owner: this, schema: schema, dataSource: ds});
			// generate fields for child layouts if any
			cl = this.options.columnLayouts;
			if (cl && cl.length && cl.length > 0) {
				for (i = 0; i < cl.length; i++) {
					// M.H. 22 Apr 2014 Fix for bug #170463: A JavaScript exception is thrown when igHierarchicalGrid.childrenDataProperty is used instead of igHierarchicalGrid.key
					if (cl[i].key === undefined) {
						continue;
					}
					schema.fields.push({name: cl[i].key});
				}
			}
			return schema;
		},
		_fieldExists: function (prop, schema) {
			var i;
			for (i = 0; i < schema.fields.length; i++) {
				if (schema.fields[i].name === prop) {
					return true;
				}
			}
			return false;
		},
		_setupDataSource: function (dataOptions) {
			var callee;
			if (!this.options.dataSource ||
				typeof this.options.dataSource._xmlToArray !== "function" ||
				typeof this.options.dataSource._encodePkParams !== "function") {
				// fix for JSONP
                // we use $.ig.util.isJsonpUrl to automatically detect whether to instantiate JSONP data source from the URL when jsonpRequest is not explicitly set
				if ($.type(dataOptions.dataSource) === "string" &&
                        (this.options.jsonpRequest || $.ig.util.isJsonpUrl(dataOptions.dataSource))) {
					this.dataSource = new $.ig.JSONPDataSource(dataOptions);
				} else if (this.options.restSettings.update.url !== null || this.options.restSettings.update.template !== null ||
						this.options.restSettings.create.url !== null || this.options.restSettings.create.template !== null ||
						this.options.restSettings.remove.url !== null || this.options.restSettings.remove.template !== null) {
					this.dataSource = new $.ig.RESTDataSource(dataOptions);
				} else {
					this.dataSource = new $.ig.DataSource(dataOptions);
				}
			} else {
				this.dataSource = this.options.dataSource;
				//dataOptions.dataSource = this.dataSource.settings.dataSource;
				//A.T. 12 Feb 2011 - Fix for bug #65899
				// M.H. 30 Oct 2012 Fix for bug #122396
				if (this.dataSource.settings.responseDataKey !== null) {
					delete dataOptions.responseDataKey;
					if (dataOptions.schema) {
						dataOptions.schema.searchField = this.dataSource.settings.responseDataKey;
					}
				}
				// M.H. 28 Apr 2014 Fix for bug #170712: When grid is bound to oData and paging is enabled a js error is thrown.
				if (dataOptions.responseTotalRecCountKey === null && this.dataSource.settings.responseTotalRecCountKey !== null) {
					delete dataOptions.responseTotalRecCountKey;
				}
				this._tds = this.dataSource.settings.dataSource;
				this.dataSource.settings.dataSource = null;
				// M.H. 30 Oct 2012 Fix for bug #122396
				if ($.ig.util.isIE8 && dataOptions.callee) {
					callee = dataOptions.callee;
					dataOptions.callee = null;
				}
				// M.H. 24 Sep 2012 Fix for bug #122201
				this.dataSource.settings = $.extend(true, {}, this.dataSource.settings, dataOptions);
				// M.H. 30 Oct 2012 Fix for bug #122396
				if ($.ig.util.isIE8 && callee) {
					this.dataSource.settings.callee = callee;
				}
				this.dataSource.settings.dataSource = this._tds;
				this._tds = null;
				if (dataOptions.schema) {
					this.dataSource._initSchema();
				}
			}
		},
		_generateColumns: function () {
			var r, key, i, hasExplicitCols = this.options.columns.length > 0,
				hasHeaders = false, len, col,
				isTable = false, arr = [],
				ds = this.options.dataSource,
				cdp = this.options.childrenDataProperty,
                newDs, colType;
			//this.options.columns = []; // A.T. 28 Feb  2011 - we shouldn't be clearing the columns !@ 
			// we need to take into account the case where columns are already defined. This means we render them first, and only then proceed
			// with the rest of the columns in the data source 
			if (ds && typeof ds._xmlToArray === "function" && typeof ds._encodePkParams === "function") {
				ds = ds.data(); // special case where the data source is an instance of an $.ig.DataSource
			} else if (typeof ds === "string") {
				ds = this.dataSource.data();
			}
			// M.H. 16 May 2012 Fix for bug #99426
			if ($.type(ds) === "object" && this.options.responseDataKey) {
				newDs = $.ig.findPath(ds, this.options.responseDataKey);
				if ($.type(newDs) === "array") {
					ds = newDs;
				}
			}
			// special case - having columns defined manually, and autoGenerateColumns = true at the same time
			// A.T. that's basically bug (#74240) - we shouldn't be using the dataView, because it's already bound according to whatever is defined in options.columns
			// and everything else is not bound at all !
			if (ds && ds.tagName && $(ds).is('table')) {
				len = $(ds).find('tbody tr').length;
				isTable = true;
			} else if (ds && ds.length) {
				len = ds.length;
			}
			if (ds && len && len === 0 && this.options.columns.length === 0) {
				throw new Error($.ig.Grid.locale.autoGenerateColumnsNoRecords);
			}
			if (ds && len && len > 0) {
				//r = this.dataSource.dataView()[0];
				if (isTable) {
					r = $(ds).find('tbody tr')[0];
				} else {
					r = ds[0];
				}
				if ($.type(r) === "array" || isTable) {
					// check if we aren't binding to a table that has headers defined already
					/*
					if (hasExplicitCols && this.options.columns[0].headerText) {
						hasHeaders = true;
						for (i = 0; i < this.options.columns.length; i++) {
							headers.push(this.options.columns[i].headerText);
						}
						this.options.columns = [];
					}
					*/
					hasHeaders = this._tb_h;
					if (isTable) {
						$(r).find('td').each(function () { arr.push($(this).text()); });
						r = arr;
					}
					for (i = 0; i < r.length; i++) {
						// detect type
						if (this.columnByKey(i + 1) === null && $.ig.getColType(r[i]) !== "object") {
							col = {
								headerText: hasHeaders ? this._tb_h_arr[i] : $.ig.Grid.locale.colPrefix + (i + 1),
                                // M.H. 25 Mar 2014 Fix for bug #159801: When the grid is bound to html table and the columns are autogenerated hiding does not work
								key: String((i + 1)),
								dataType: $.ig.getColType(r[i]),
								hidden: false
							};
							// L.A. 30 November 2012 - Fixing bug #128507
							col.headerText = (col.headerText || "").toString().trim();
							// M.H. 9 Aug 2012 Fix for bug #118689
							if (this._isMultiColumnGrid) {
								col.level0 = true;
								col.level = 0;
								this._oldCols.push(col);
							}
							this.options.columns.push(col);
							this._visibleColumnsArray = undefined;
						} else if (hasHeaders && !this.columnByKey(i + 1).headerText) {
							this.columnByKey(i + 1).headerText = this._tb_h_arr[i];
						}
					}
				} else {
					for (key in r) {
						// also detect type
						if (r.hasOwnProperty(key) && this.columnByKey(key) === null) {
							// L.A. 04 October 2012 - Fixing bug #123318 
							// If a column has a null value for the first call and autoGenerateColumns is true the column isn't generated.
							colType = $.ig.getColType(r[key]);
							if (((cdp && cdp !== key) || !cdp) && (colType !== "object" || r[key] === null) && key !== "ig_pk") {
								col = {headerText: key, key: key, dataType: $.ig.getColType(r[key]), hidden: false};
								this.options.columns.push(col);
								// M.H. 9 Aug 2012 Fix for bug #118689
								if (this._isMultiColumnGrid) {
									col.level0 = true;
									col.level = 0;
									this._oldCols.push(col);
								}
								this._visibleColumnsArray = undefined;
							}
						}
					}
				}
			}
			// we need to set the data source schema
			if ((this.dataSource.schema() === null || this.dataSource.schema().fields().length === 0) && !hasExplicitCols) {
				this.dataSource.settings.schema = this._generateDataSourceSchema();
				this.dataSource._initSchema();
			}
			if (this.options.width === null) {
				this._setContainerWidth(this.container());
			}
			this._trigger("columnsgenerated", null, {owner: this, key: this.options.key});
		},
		_renderGrid: function () {
			var gridElement = this.element[0],
				containerId,
				containerDiv,
				tbody = this.element.children('tbody'), //gridElement.find('tbody')
				ar = this.options.accessibilityRendering;

			this._cancelRendering = false;
			if (!this._initialized) {
				// we should have the data now in the data view
				// determine automatically if we want virtualization enabled or not 
				// IMPORTANT: height must also be always set ! 
				//if ($.type(this.options.virtualization) === "number" && this.dataSource.dataView().length > this.options.virtualization && this.options.height !== null) {
				//	this.options.virtualization = true;
				//}
				if (ar) {
					this.element.attr('role', 'grid');
				}
				if (this.options.virtualization === true || this.options.rowVirtualization === true || this.options.columnVirtualization === true) {
					if (this.options.height === undefined || this.options.height === null) {
						throw new Error($.ig.Grid.locale.virtualizationRequiresHeight);
					}
					this._createVirtualGrid();
				} else if (this.options.height !== null || this.options.width !== null) {
					this._createScrollingGrid();
				} else {
					// just wrap with a div, if it doesn't exist 
					//if (!this._isWrapped) {
					containerId =  gridElement.id + '_container';
					containerDiv = '<div id="' + containerId + '" class="' + this.css.gridClasses + ' ' + this.css.baseClass + '" style="position: relative"> </div>';
					this.element.wrap(containerDiv);
					//} else {
					//	containerId = this.element.parent().addClass(this.css.gridClasses).addClass(this.css.baseClass).attr('id');
					//}
					this.element.addClass(this.css.gridTableClass);
					if (ar) {
						this.element.attr('aria-describedby', containerId);
					}
					this._setContainerWidth(this.container());

					this.container().attr('tabIndex', this.options.tabIndex);
					if (this.options.height !== null) {
						this.container().css('overflow-y', 'hidden');
						//this.scrollContainer().css('height', this.options.height);
					}
				}
				// touch support code
				this._touch();
				// render colgroup for column widths
				if (this.options.columns.length > 0 &&
						(this.options.virtualization !== true && this.options.rowVirtualization !== true && this.options.columnVirtualization !== true) &&
						this.options.autogenerateColumns === false && this.options.columns.length > 0
						) {
					this._renderColgroup(this.element[0], false, false, this.options.autofitLastColumn);
				}
				// cellpadding, cellspacing, etc.
				$(gridElement).attr('cellpadding', '0');
				$(gridElement).attr('cellspacing', '0');
				$(gridElement).attr('border', '0');
				$(gridElement).css('table-layout', 'fixed');
				$(gridElement).addClass(this.css.gridTableClass);
				if (this.options.autoGenerateColumns === false && this.options.columns.length > 0 &&
						this._headerRenderCancel !== true) {
					this._renderHeader();
				}
				// render header caption
				this._renderCaption();
				if (this.options.autoAdjustHeight) {
					this._initializeHeights();
				}
			}
			if (tbody.length === 0) {
				tbody = $('<tbody></tbody>').appendTo(gridElement).addClass(this.css.baseContentClass).addClass(this.css.gridTableBodyClass).addClass(this.css.recordClass);
			}
			if (this.dataSource.type() !== 'htmlTableDom' && this.dataSource.type() !== 'htmlTableId') {
				tbody.empty();
			}
		},
		_setContainerWidth: function (element, rendered) {
			var cols = this._visibleColumns(), width = 0;
			// calculate based on column widths
			// if no col width is set, use the defaultColumnWidth
			//if (cols.length > 0 && !this.options.autoGenerateColumns) {
			if (cols.length > 0) {
				width = this._calculateContainerWidth(true);
				if (width > 0) {
					if (rendered) {
						// get outer widths for column headers
						width = 0;
						this.container().find('.ui-iggrid-header').each(function () {
							width += $(this).outerWidth();
						});
						element.width(width);
					} else {
						width += this._calculateSpecialColumnsWidth();
						element.css('width', width);
					}
				}
			} else if (this.options.width !== null) {
				element.css('width', this.options.width);
			}
		},
		_calculateContainerWidth: function (addScrollWidth) {
			var width = 0, cols = this.options.columns, i;
			for (i = 0; i < cols.length; i++) {
				//check if the columns is hidden
				//or will be hidden if we are still in the initialization phase
				if (cols[i].hidden !== true &&
						(this._initialHiddenColumns === undefined ||
						$.inArray(cols[i], this._initialHiddenColumns) === -1)) {
					width += cols[i].width ? parseInt(cols[i].width, 10) : this.options.defaultColumnWidth === null ? 0 : parseInt(this.options.defaultColumnWidth, 10);
				}
			}
			// add the scrollbar width if any 
            //L.A. 30 March 2012 Fixed bug #99024 When in grid fixedHeaders is false, it is not possible to resize last column
			if (this.options.height !== null && width > 0 && addScrollWidth === true) {
				//do not add the scrollbar width in case we have virtualization and no width
				width += this._scrollbarWidth();
			}
			return width;
		},
		// creates a scrolling, non-virtual grid
		_createScrollingGrid: function () {
			var self = this, containerWidth, totalWidth, scrollbarWidth = this._scrollbarWidth(),
                id =  this.id() + '_scroll',
                dataContainer,
				scrollDiv = '<div id="' + id + '"></div>';
			this.element.wrap(scrollDiv);
            //dataContainer = $('#' + id);
			dataContainer = this.element.parent();
			if (this.options.accessibilityRendering) {
				this.element.attr('aria-describedby', id);
			}
			dataContainer.addClass(this.css.gridScrollDivClass).wrap("<div id='" + this.id() + "_container'></div>");
			// L.A. 08 October 2012 - Fixing bug #121790 
			// The horizontall scollbar overlaps the last visible row when using paging
			// Scrollbar height is the same as _scrollbarWidth
			if ($.ig.util.isIE7) {
				dataContainer.css('padding-bottom', this._scrollbarWidth());
			}
			this.container().attr('tabIndex', this.options.tabIndex).addClass(this.css.baseClass).addClass(this.css.gridClasses);
			if (this.options.width !== null) {
				this.container().css('width', this.options.width);
				// A.T. 14 Feb 2011 - Fix for bug #66086
				if (this.options.width.indexOf && this.options.width.indexOf('%') !== -1) {
					//if ((this.options.width.indexOf('%') !== -1 && parseInt(this.options.width, 10) === 100) || this.options.width.indexOf('%') === -1) {
						//this.element.css('width', this.options.width);
					//} else if (this.options.width.indexOf('%') !== -1) {
					//if (this.options.width.indexOf('%') !== -1) {
					this.element.css('width', '100%');
					//}
				}// else {
					//this.element.css('width', this.options.width);
				//}
				if (this.options.height !== null) {
					this._addHorizontalScrollBar(dataContainer);
					this.scrollContainer().css('overflow-x', 'hidden');
                    // M.H. 19 Jun 2013 Fix for bug #143816: Horizontal scrollbar not visible for IgniteUI components when the OS has its scrollbars shown only when scrolling
                    containerWidth = dataContainer.width();
                    totalWidth = this._getHScrollContainerInner().width();
                    dataContainer.bind('scroll', function (e) {
                        var container = $(this), hScroller = self._hscrollbarcontent(),
                            containerLeft = container.scrollLeft(), hScrollerLeft = hScroller.scrollLeft();
                    
                        if (containerLeft !== hScrollerLeft) {
                            if (totalWidth === 0) {
                                totalWidth = self._getHScrollContainerInner().width();
                            }
							// M.H. 23 Apr 2014 Fix for bug #169582: Misalignment between the header and the footer when advanced filtering and continuous virtualization are enabled
							if (containerLeft === 0 && self.element.height() === 0) {
								return;
							}
                            if (containerLeft + containerWidth > totalWidth + scrollbarWidth) {
                                container.scrollLeft(hScrollerLeft);
                            } else {
                                hScroller.scrollLeft(containerLeft);
                            }
                        }
                    });
				}
			} else {
				this._setContainerWidth(this.container());
				// set overflow-x: hidden on the scrolling container
				this.scrollContainer().css('overflow-x', 'hidden');
			}
			this.container().css("position", "relative");
			if (this.options.height !== null) {
				this.scrollContainer().css('overflow-y', 'auto');
				if (this.options.autoAdjustHeight) {
					this.container().css('height', this.options.height);
				} else {
					this.scrollContainer().css('height', this.options.height);
				}
			}
			/*
			// touch scroll support
			if (this.options.height !== null && this.options.width !== null) {
				this.scrollContainer().attr("data-scroll", "true");
			} else if (this.options.height !== null) {
				this.scrollContainer().attr("data-scroll", "y");
			} else if (this.options.width !== null) {
				this.scrollContainer().attr("data-scroll", "x");
			}
			*/
		},
		_touch: function () {
			var id = this.id(), div = this.scrollContainer();
			if (div.length !== 1) {
				div = this._vdisplaycontainer();
			}
			if (div.length) {
				div.attr('data-scroll', 'true').attr('data-oneDirection', 'true');
				if (this._hscrollbarcontent()[0]) {
					div.attr('data-xScroller', '#' + id + '_hscroller');
				} else if (this._vhorizontalcontainer()[0]) {
					div.attr('data-xScroller', '#' + id + '_horizontalScrollContainer');
				}
				if (this._scrollContainer()[0]) {
					div.attr('data-yScroller', '#' + id + '_scrollContainer');
				}
				// M.H. 20 March 2012 Fix for bug #104415
				if (typeof Modernizr === 'object' &&
						Modernizr.touch === true &&
						this.element.igScroll !== undefined) {
					div.css('overflow-y', 'hidden');
				}
			}
		},
		// virtual grid implies scrolling grid 
		_createVirtualGrid: function () {
			/* 
			 *  // this is the general structure for virtualization when both column and row virtualization are enabled
			 *	<table border="0" cellspacing="0" cellpadding="0">
			 *		<tr>
			 *			<td><div id="#gridID_headers"></div></td>
			 *			<td></td>
			 *		</tr>
			 *			<tr>
			 *				<td><div id="#gridID_displayContainer"></td>
			 *				<td><div id="#gridID_scrollContainer"></div></td>
			 *			</tr>
			 *			<tr>
			 *			<td><div id="#gridID_horizontalScrollContainer"></div></td>
			 *			<td></td>
			 *			</tr>
			 *	</table>
			 */
			var id = this.id(),
				//touchstart,
				//touchend,
				grid,
				newW,
				percWidthStr = $.ig.util.isWebKit ? 'width=100%' : '',
				totalWidth,
				scrollContainerInner,
				scrollbarWidth,
				w = 0,
				virtualGridMarkup = '<div id="' + id + '_container" style="margin:0px; border:0px; padding:0px;"><table border="0" cellspacing="0" cellpadding="0" class="ui-iggrid-layout-helper" style="border-spacing:0px" id="' + id + '_virtualContainer" ><tbody><tr><td colspan="2" style="border-width:0px"><div id="' + id + '_headers_v" style="overflow:hidden;"></div></td></tr><tr><td style="border-width:0px;"><div id="' +
					id + '_displayContainer"></td>$verticalMarkup$</tr>$horizontalMarkup$</tbody></table></div>',
				verticalMarkup,
				horizontalMarkup = '<tr><td colspan="2" style="border-width: 0px"><div id="' + id + '_horizontalScrollContainer"></div></td></tr>';
			scrollbarWidth = this._scrollbarWidth();
			if ($.ig.util.isIE) {
				scrollbarWidth += 1;
			}
			if (parseInt(this.options.height, 10) > 0) {
				verticalMarkup = '<td style="border-width: 0px;"><div id="' + id + '_scrollContainer" style="overflow:scroll; overflow-x:hidden; width: ' + scrollbarWidth + 'px; height:' + this.options.height + ';"></div></td>';
			} else {
				verticalMarkup = '<td style="border-width: 0px;"><div id="' + id + '_scrollContainer" style="overflow:scroll; overflow-x:hidden; width: ' + scrollbarWidth + 'px;"></div></td>';
			}
			if (this.options.virtualization === true) {
				virtualGridMarkup = virtualGridMarkup.replace('$verticalMarkup$', verticalMarkup).replace('$horizontalMarkup$', horizontalMarkup);
			} else if (this.options.rowVirtualization === true) {
				virtualGridMarkup = virtualGridMarkup.replace('$verticalMarkup$', verticalMarkup).replace('$horizontalMarkup$', '');
			} else if (this.options.columnVirtualization === true) {
				virtualGridMarkup = virtualGridMarkup.replace('$horizontalMarkup$', horizontalMarkup).replace('$verticalMarkup$', '');
			}
			// if column virtualization is enabled we really need to make sure that we set the width of the data table to 100 % otherwise 
			// the column widths will not be correct and will try to be accomodated in the specified fixed width of the grid.
			if (this.options.virtualization === true || this.options.columnVirtualization === true) {
				this.element.css('width', '100%');
			}
			// now inject our existing grid in the place of the "displayContainer"
			this.element.wrap(virtualGridMarkup);
			// apply the base classes
			// M.H. 23 Apr 2014 Fix for bug #170317: Can't set focus to grid container when row virtualization is enabled
			this.container().attr('tabIndex', this.options.tabIndex).addClass(this.css.baseClass).addClass(this.css.gridClasses);
			if (this.options.width !== null) {
				// M.H. 21 Mar 2014 Fix for bug #159951: When virtualization is enabled in a grid with % width (not 100%), the layout is broken
				//if (this.options.width.indexOf && this.options.width.indexOf("%") === -1) {
					this.container().width(this.options.width);
				//} else {
				//this.container().width('100%');
				//}
			} else {
				this._setContainerWidth(this.container());
			}
			this._vdisplaycontainer().append(this.element[0]);
			//I.I. bug fix for 105701, 105703. When virtualization is continuous and grid is hierarchical, this line causes header misplacements.
			//I.I. bug fix for 110664
			// M.H. 21 May 2012 Fix for bug #112167 - renderColgroup will call visibleColumns which sets incorrect number of visible columns at init
			/*
			if (this.options.virtualization === true && this.options.virtualizationMode === 'fixed') {
				this._renderColgroup(this.element[0], false, false, this.options.autofitLastColumn);
			}
			*/
			grid = this;
			totalWidth = this._calculateContainerWidth(false);
			if (this.options.width !== null) {
				w = parseInt(this.options.width, 10);
			} else {
				w = totalWidth;
			}
			if (this.options.height !== null && this.options.width !== null) {
				w -= this._scrollbarWidth();
			}
			//A.Y. bug 98976. Make the width undefined if 0 or less so that it is ignored by jquery as the width of the container.
			if (w <= 0) {
				w = undefined;
			}
			// M.H. 11 April 2012 Fix for bug #108438
			if (w > 0 && this.options.expandColWidth && !this.options.width) {
				w += this.options.expandColWidth;
			}
			// set virtual container's width correctly
			$('<colgroup><col ' + (w <= 0 ? percWidthStr : ('width="' + w + '"')) + '></col><col width="' + this._scrollbarWidth() + '"></col></colgroup>').prependTo(this._virtualcontainer());
			newW = this.options.width;
			// M.H. 4 Apr 2014 Fix for bug #159951: When virtualization is enabled in a grid with % width (not 100%), the layout is broken
			if (newW && newW.indexOf && newW.indexOf('%') !== -1) {
                newW = '100%';
            }
			this._virtualcontainer().css('width', newW).css('max-width', newW);
			// now create the inner scrolling containers, that will be placed inside of the scrollContainer/horizonalScrollContainer,
			// and will cause the virtual scrollbars to appear and grow according to the total records in the data source
			scrollContainerInner = '<div style="width:1px; overflow:hidden; height:' + (this._totalRowCount * parseInt(this.options.avgRowHeight, 10)) + 'px;"></div>';
			this._scrollContainer().append(scrollContainerInner);
			// M.H. 9 June 2014 Fix for bug #173336: Horizontal scrollbar does not appear when row virtualization is enabled
			if ((this.options.virtualization === true || this.options.rowVirtualization === true) && this.options.width &&
				this.options.width.indexOf && this.options.width.indexOf('%') > 0 &&
				totalWidth > $("#" + id + "_container").width()) {
				this._addHorizontalScrollBar(this._virtualcontainer());
				this._virtualcontainer().css('table-layout', 'fixed');
			} else if ((this.options.virtualization === true || this.options.columnVirtualization === true) && this.options.width && (totalWidth > parseInt(this.options.width, 10))) {
				//we always need to have the horizontal scroll containers if we have width
				//as there may be hidden columns that when visible will show a scrollbar
				//I.I. bug fix for 110369
				// do the same for the horizontal scrolling
                // M.H. 5 Jul 2013 Fix for bug #145572: When Resizing with continuous rowVirtualization no horizontal scrollbar appears when needed
                // we need to render horizontal scroll container when virtualization mode is continuous
                // if we use another solution to show/hide horizontal scroll container then height is not properly calculated
                this._renderHorizontalScrollContainer(totalWidth);
			}
			if (parseInt(this.options.height, 10) > 0) {
				this._vdisplaycontainer().css('height', this.options.height).css('vertical-align', 'top');
			}
            //I.I. bug fix for 104085, tabindex=-1 added
            //L.A. fixed bug #105997 Can't navigate selection with arrow keys when fixed virtualization is enabled
            //Anchor should have some content in order to have get a focus. The content is visible but outside of the visible area.
            //L.A. fixed bug #112519 When continuous virtualization and selection with mode = row are enabled scrolling down the grid and 
            // selecting a row changes records values with wrong ones.
            //L.A. fixed bug #113287 fixed appending to the _virtualContainer
            this._vdisplaycontainer().css('position', 'relative').css('width', w).css('maxWidth', w);
            //L.A. fixed bug #101375 moving the anchor to _headers_v, because it's visible in IE8, IE9
            if (this.options.virtualization === true) {
                this.container().find("#" + id + "_headers_v").append("<a href='#' id='" + id + "_displayContainer_a' tabindex='-1' style='position:absolute;top:-100px;left:-100px'>&nbsp;</a>");
            }
			if (this.options.width && this.options.virtualization === false && this.options.columnVirtualization === false) {
				this._vdisplaycontainer().css({'overflow-y': 'hidden', 'overflow-x': 'auto'});
			} else {
				this._vdisplaycontainer().css('overflow', 'hidden');
			}
			// make sure mouse wheel scrolling also works for the table with data, not only the virtual scrollbar
			// it's a smart and little-known technique i am going to use here -:) 
            //I.I. bug fix for 109777, mouseover -> mouseenter, mouseout -> mouseleave
			this._vdisplaycontainer().parent().bind({
				mouseenter: function (event) {
					grid._isMouseOverVirtualTable = true;
				},
				mouseleave: function (event) {
					grid._isMouseOverVirtualTable = false;
				}
			});
			/*
			touchstart = function (event) {
				this._oldPageY = event.touches[0].pageY;
				event.stopPropagation();
				event.preventDefault();
			};
			touchend = function (event) {
				// compare pageY and pageX with the old ones
				if (event.changedTouches[0].pageY - this._oldPageY > 0) {
					grid._onVirtualVerticalScroll(event, Math.abs(event.changedTouches[0].pageY - this._oldPageY), 'up');
				} else if (event.changedTouches[0].pageY - this._oldPageY < 0) {
					grid._onVirtualVerticalScroll(event, Math.abs(event.changedTouches[0].pageY - this._oldPageY), 'down');
				}
			};
			$('#' + id + '_displayContainer').parent()[0].addEventListener("touchstart", $.proxy(touchstart, this), false);
			$('#' + id + '_displayContainer').parent()[0].addEventListener("touchend", $.proxy(touchend, this), false);
			*/
			// Refactor to keep in one place
            // M.H. 6 Nov 2013 Fix for bug #156713: Scrolling with the mouse wheel results in looping through a subset of the rows when using continuous virtualization in Chrome, Firefox, and Safari
            this._documentEvents = {
				DOMMouseScroll: function (event) { // Firefox
					var dir = 'down', delta, step;
					step = grid.options.virtualizationMouseWheelStep === null ? parseInt(grid.options.avgRowHeight, 10) : grid.options.virtualizationMouseWheelStep;
                    //I.I. bug fix for 104505. The issue is reproducible with jquery 1.7.1 only
					delta = -event.originalEvent.detail / 3; // // determine if we are scrolling up or down
					if (delta > 0) { // scroll up 
						dir = 'up';
					}  // else default => scroll down 
					// determine if mouse over  is true
					if (grid._isMouseOverVirtualTable) {
						grid._onVirtualVerticalScroll(event, step, dir); // define this # of pixels automatically
						event.preventDefault();
					}
				},
				mousewheel: function (event) { // IE, Chrome, Safari, Opera
                    var dir = 'down', delta, step;
					step = grid.options.virtualizationMouseWheelStep === null ? parseInt(grid.options.avgRowHeight, 10) : grid.options.virtualizationMouseWheelStep;
					//I.I. bug fix for 104505. The issue is reproducible with jquery 1.7.1 only
                    delta = event.originalEvent.wheelDelta / 120; // determine if we are scrolling up or down
					if (delta > 0) {
						dir = 'up';
					}
					if (grid._isMouseOverVirtualTable) {
						grid._onVirtualVerticalScroll(event, step, dir); // define this # of pixels automatically 
						event.preventDefault();
					}
				}
			};
			$(document).bind(this._documentEvents);
			// bind scroll event handlers
			if (this.options.virtualization === true || this.options.rowVirtualization === true) {
				this._scrollContainer().bind({
					scroll: function (event) {
						grid._onVirtualVerticalScroll(event);
						//bugs #70681  and bug #72116
						grid._virtualScrollMouseDown = false;
					},
					mousedown: function (event) {
						// this is necessary because of one special case. When we scroll just once, we want to move by 1 row always (in chrome and FF)
						// but when we scroll continuously, we don't want the scrollbar to jump (Refer to bugs #70681  and bug #72116
						grid._virtualScrollMouseDown = true;
					}
				});
			}
			if (this.options.virtualization === true || this.options.columnVirtualization === true) {
				this._vhorizontalcontainer().bind({
					scroll: function (event) {
						grid._onVirtualHorizontalScroll(event);
					}
				});
			}
			// S.S. May 11, 2012, #103088 We need to use a normal horizontal scroll container when we use only vertical
			// virtualization and the set grid's width is too narrow
			if (this._vhorizontalcontainer().length === 0 && this.options.width !== null) {
				// add the scrollbar
				// M.H. 4 Apr 2014 Fix for bug #159951: When virtualization is enabled in a grid with % width (not 100%), the layout is broken
				if (!this.options.width.indexOf || this.options.width.indexOf('%') === -1) {
					this._addHorizontalScrollBar(this._virtualcontainer());
				}
				// changes the overlow-x attribute of the main container
				this._vdisplaycontainer().css('overflow-x', 'hidden');
			}
			this.element.height(this._scrollContainer().height());
			//A.T. 16 Oct. Fix for bug #123235
			if (this.options.width && this.options.width.indexOf && this.options.width.indexOf("%") !== -1) {
				this.container().find("#" + id + "_virtualContainer > colgroup > col:first").css("width", "100%");
				this._vhorizontalcontainer().css("width", "100%");
				this._vdisplaycontainer().css("width", "100%").css("max-width", "100%");
			}
		},
        // M.H. 5 Jul 2013 Fix for bug #145572: When Resizing with continuous rowVirtualization no horizontal scrollbar appears when needed
        // render horizontal scroll container when virtualization mode is continuous
        _renderHorizontalScrollContainer: function (totalWidth) {
            var horizontalScrollContainerInner, w = this.options.width;
			// M.H. 4 Apr 2014 Fix for bug #159951: When virtualization is enabled in a grid with % width (not 100%), the layout is broken
            if (w && w.indexOf && w.indexOf('%') !== -1 && (this.options.virtualization === true || this.options.rowVirtualization === true)) {
				return;
			}
            // do the same for the horizontal scrolling
			this._vhorizontalcontainer().css('height', this._scrollbarWidth() + 'px').css('overflow', 'scroll');
			//if (this.options.virtualization === true || this.options.rowVirtualization === true) {
			//	$('#' + id + '_horizontalScrollContainer').css('width', parseInt(this.options.width, 10) - this._scrollbarWidth());
			//} else {
			if ($.ig.util.isIE) {
				// M.H. 3 Sep 2012 Fix for bug #118189: When virtualization is enabled, clicking on the horizontal scrollbar does not scroll the grid in IE9
				this._vhorizontalcontainer().css('width', parseInt(this.options.width, 10) + 1).css('height', '100%');
			} else {
				this._vhorizontalcontainer().css('width', this.options.width);
			}
			//}
			horizontalScrollContainerInner = '<div style="width:' + totalWidth + 'px;height:1px;"></div>';
			this._vhorizontalcontainer().append(horizontalScrollContainerInner);
        },
		// if offset is defined, this means there is mouse-wheel scroll which we are manually handling. the offset is the amount of px to move - up or down 
		_onVirtualVerticalScroll: function (event, offset, dir) {
			this._isHorizontal = false;
		//	originalEvent = event.originalEvent,
			var scrollContainer = this._scrollContainer(), scrollTopDiff,
                isIE = $.ig.util.isIE,
				current = scrollContainer.scrollTop(),
				mode = this.options.virtualizationMode;
            if (offset !== undefined) {
				if (dir === 'down') {
					scrollContainer.scrollTop(current + offset);
				} else {
					scrollContainer.scrollTop(current - offset);
				}
				current = scrollContainer.scrollTop();
			} /*else {
				// A.T. 31 March 2011 - fix for bug #70681 
				// Please revise
				if (Math.abs(current - this._oldScrollTop) < this.options.avgRowHeight && current - this._oldScrollTop !== 0) {
					if (current > this._oldScrollTop) {
						scrollContainer.scrollTop(this._oldScrollTop + this.options.avgRowHeight);
					} else {
						scrollContainer.scrollTop(this._oldScrollTop - this.options.avgRowHeight);
					}
				}
			}
			*/
			//this._startRowIndex = Math.ceil(scrollContainer.scrollTop() * this._totalRowCount / (scrollContainer[0].scrollHeight - scrollContainer[0].offsetHeight));
			scrollTopDiff = scrollContainer.scrollTop() - this._oldScrollTop;
			if (Math.abs(scrollTopDiff) < 5 && $.ig.util.isFF && !isIE) {
                return;
			}
            if (mode === undefined || mode === '') {
				mode = 'continuous';
			}
			if (mode === 'fixed') {
                this._startRowIndex = Math.ceil(scrollContainer.scrollTop() / parseInt(this.options.avgRowHeight, 10));
                if ((!isIE) && this._startRowIndex === this._oldStartRowIndex && this._virtualScrollMouseDown) {
					if (scrollTopDiff > 0 && scrollTopDiff < parseInt(this.options.avgRowHeight, 10)) {
						this._startRowIndex++;
						scrollContainer.scrollTop(scrollContainer.scrollTop() - scrollTopDiff + parseInt(this.options.avgRowHeight, 10));
					} else if (scrollTopDiff < 0 && Math.abs(scrollTopDiff) < parseInt(this.options.avgRowHeight, 10)) {
						this._startRowIndex--;
						scrollContainer.scrollTop(scrollContainer.scrollTop() - scrollTopDiff - parseInt(this.options.avgRowHeight, 10));
					}
				}
				if (this._startRowIndex > this._totalRowCount - this._virtualRowCount) {
					this._startRowIndex = this._totalRowCount - this._virtualRowCount;
				}
				if (this._startRowIndex < 0) {
					this._startRowIndex = 0;
				}
				this._oldStartRowIndex = this._startRowIndex;
				this._renderVirtualRecords();
			} else if (mode === 'continuous') {
                // M.H. 19 Jun 2013 Fix for bug #142650: igGrid.virtualScrollTo API method is not working
                this._virtualScrollToInternal(current);
			}
			this._oldScrollTop = scrollContainer.scrollTop();
		},
		_scrollContainer: function () {
			if (!this._scrollContainerObj || this._scrollContainerObj.length === 0) {
				this._scrollContainerObj = this.container().find("#" + this.id() + "_scrollContainer");
			}
			return this._scrollContainerObj;
		},
		_onVirtualHorizontalScroll: function (event) {
			var id = this.id(),
				internallyTriggered = event === undefined, //in the case of hiding or other features that would requred it
				horizontalScrollContainer = this._vhorizontalcontainer(),
				scrollLeft = horizontalScrollContainer.scrollLeft(),
				hiddenContentWidth = horizontalScrollContainer[0].scrollWidth - horizontalScrollContainer[0].offsetWidth,
                deltaScroll = scrollLeft - this._oldScrollLeft;
			if (!internallyTriggered && Math.abs(deltaScroll) < 5 && $.ig.util.isIE && !$.ig.util.isIE) {
				return;
			}
			//I.I. bug fix for 105932 and 105951
			if (this.options.virtualization === true && this.options.virtualizationMode === 'continuous') {
				this._setDisplayContainerScrollLeft(this._getDisplayContainerScrollLeft() + deltaScroll);
				this._oldScrollLeft = horizontalScrollContainer.scrollLeft();
				this.container().find("#" + id + "_headers_v").scrollLeft(this.container().find("#" + id + "_headers_v").scrollLeft() + deltaScroll);
				// M.H. 4 April 2012 Fix for bug #108082
				this.container().find("#" + id + "_footer_container").scrollLeft(this.container().find("#" + id + "_footer_container").scrollLeft() + deltaScroll);
				return;
			}
			this._isHorizontal = true;
			if (hiddenContentWidth > 0) {
				this._startColIndex = Math.ceil(scrollLeft * this._totalColumnCount / hiddenContentWidth);
				this._startColIndex = Math.min(this._startColIndex, this._totalColumnCount - this._virtualColumnCount);
			} else {
				this._startColIndex = 0;
			}
			if (internallyTriggered || this._oldStartColIndex !== this._startColIndex) {
				this._renderVirtualRecords();
				// trigger an event so that features that are header-dependent, such as filtering and sorting , update their UI accordingly
				this._trigger('virtualhorizontalscroll', null, {startColIndex: this._startColIndex, endColIndex: this._startColIndex + this._virtualColumnCount - 1});
			}
			this._oldScrollLeft = horizontalScrollContainer.scrollLeft();
			this._oldStartColIndex = this._startColIndex;
		},
		_initLoadingIndicator: function () {
			var widget;
			// attach loading indicator widget
			if (this.container().data("igLoading")) {
				this._loadingIndicator = this.container().data("igLoading").indicator();
			} else {
				widget = this.container().igLoading().data("igLoading");
				if (widget) {
					this._loadingIndicator = widget.indicator();
				}
			}
		},
		_addHorizontalScrollBar: function (parent) {
			var sb = $("<div id='" + this.id() + "_hscroller_container' ></div>")
				.css('height', this._scrollbarWidth() + 'px')
				.css("position", "relative")
				.css('display', 'none')
				.css('overflow', 'hidden')
				.append(
					$("<div id='" + this.id() + "_hscroller' ></div>")
						.css('width', '100%')
						.css('position', 'absolute')
						.css('bottom', '0px')
						.css('overflow-x', 'scroll')
						.css('overflow-y', 'scroll')
						.append(
							$("<div id='" + this.id() + "_hscroller_inner' ></div>")
								.css('height', '1px')
						)
						.bind("scroll", $.proxy(this._scrollData, this))
				);
			if (parent) {
				sb.insertAfter(parent);
			}
		},
		_updateVirtualHorizontalScrollbar: function () {
			var horizontalScrollContainerInner, horizontalScrollContainer;
			//update horizontalScrollbar by updating horizontalScrollContainer inner div width
			horizontalScrollContainerInner = this.container().find("#" + this.id() + "_horizontalScrollContainer div");
			horizontalScrollContainerInner.css('width', this._calculateContainerWidth(false));
			//hide the horizontalScrollContainer if no scrollbar should be visible
			horizontalScrollContainer = this._vhorizontalcontainer();
			if (horizontalScrollContainer.width() > horizontalScrollContainerInner.width()) {
				horizontalScrollContainer.css('display', 'none');
			} else {
				horizontalScrollContainer.css('display', '');
			}
		},
		_generateColumnFlatStructure: function (treeStructure) {
			var cols, oldCols, newCols = [];
			cols = treeStructure.slice(0);
			oldCols = treeStructure.slice(0);
			this._multiColumnIdentifier = 0;
			this._maxLevel = this._getMaxLevelRecursive(0, cols);
			this._hiddenColumns = {};
			this._analyzeMultiColumnHeaders(cols, newCols, 0, oldCols, []);
			this._oldCols = oldCols;
			this.options.columns = newCols;
		},
		moveColumn: function (column, target, after, inDom) {
			/* Moves a visible column at a specified place, in front or behind a target column or at a target index
			paramType="number|string" An identifier of the column to be moved. It can be a key, a Multi-Column Header identificator, or an index in a number format. The latter is not supported when the grid contains multi-column headers.
			paramType="number|string" An identifier of a column where the moved column should move to or an index at which the moved column should be moved to. In the case of a column identifier the column will be moved after it by default.
			paramType="bool" optional="true" Specifies whether the column moved should be moved after or before the target column. This parameter is disregarded if there is no target column specified but a target index is used. 
			paramType="bool" optional="true" Specifies whether the column moving will be enacted through DOM manipulation or through rerendering of the grid.
			*/
			var grid = this, found, nColArray, movingParams, hcPreserve;
			/*	The nColArray is a two dimensional array that consists of column id-s (or multicolumn header ids) and the number -1
				It normalizes the column layout where the ids represent actual columns and -1s represent absent columns due to 
				upper columns covering the space through rowspan > 1
				This array is crucial for column moving as moving needs to be done in depth when we are moving multicolumn headers and
				the lower levels have complex structures involving rowspans and smaller colspans (an MCH inside an MCH)
				By simplifying the structure to this array the actual move can be accomplished via iteration as opposed to a complex
				constructive recursion logic.
				To avoid possible sync issues we are going to build the array on each run (as opposed to using a cached version)
				A cached version would need to get updated everytime this method is called anyway.	*/
			nColArray = this._buildColumnLayoutArray();
			// Assume optional params
			after = after === null || after === undefined ? true : after;
			inDom = inDom === null || inDom === undefined ? true : inDom;
			// The first thing to do is move the columns in their internal collection wrappers. For a flat column layout
			// we'll use this.options.columns and for a multicolumn layout we'll use _oldCols and then force an update
			// on the columns collection.
			// we also need to normalize the column and target params
			movingParams = {
				column: column,
				target: target,
				after: after
			};
			if (this._oldCols) {
				found = this._performInternalMove(movingParams, this._oldCols);
				// and update the column defs while preserving the hidden columns array
				hcPreserve = jQuery.extend(true, {}, this._hiddenColumns);
				this._generateColumnFlatStructure(this._oldCols);
				this._hiddenColumns = hcPreserve;
				this._preserveColspans(this._oldCols);
			} else {
				found = this._performInternalMove(movingParams, this.options.columns);
			}
			// update params
			column = movingParams.column;
			target = movingParams.target;
			after = movingParams.after;
			// If we couldn't accomplish the move on an internal level there is no point going on 
			// with actual DOM manipulations or grid rendering.
			if (found === false) {
				throw new Error($.ig.Grid.locale.movingNotAllowedOrIncompatible);
			}
			if (inDom === true) {
				// proceed with the dom column move, it'll be done through a loading indicator and a seperate thread
				this._loadingIndicator.show();
				setTimeout(function () {
					grid._columnMovingResets();
					grid._performDomColumnMove(column, target, after, nColArray);
					grid._loadingIndicator.hide();
				}, 0);
			} else {
				this._columnMovingResets();
				this._performColumnMove(column, target, after, nColArray);
			}
		},
		_columnMovingResets: function () {
			var i, $th;
			this._updateHeaderColumnIndexes();
			delete this._virtualDom;
			delete this._visibleColumnsArray;
			this._headerCells = [];
			for (i = 0; i < this.options.columns.length; i++) {
				$th = this.container().find('#' + this.id() + '_' + this.options.columns[i].key).data('columnIndex', i);
				$th.data('data-mch-order', i);
				if ($th.is(":visible")) {
					this._headerCells.push($th);
				}
			}
		},
		_preserveColspans: function (cols) {
			var i, cs = 0, col, res;
			for (i = 0; i < cols.length; i++) {
				col = cols[i];
				if (col.group !== undefined && col.group !== null) {
					res = this._preserveColspans(col.group);
					col.colspan = res;
					cs += res;
				} else {
					if (col.hidden !== true) {
						cs++;
					}
				}
			}
			return cs;
		},
		_columnVisible: function (col) {
			return !col.hidden;
		},
		_buildColumnLayoutArray: function () {
			var i = 0,
				j = 0,
				col,						// a single col in the cycle
				id,							// the single col's identification
				colrs,						// the single col's rowspan
				l,							// current col's horizontal length (colspan)
				x = 0,						// current horizontal identificator
				cCols = this._oldCols ? jQuery.extend(true, [], this._oldCols) : jQuery.extend(true, [], this.options.columns),
				nCols,						// the newly built level
				level = 0,					// level number
				width = this.container().find("#" + this.id() + " colgroup:first>col").not("[data-skip=true]").length,
				height = this.container().find("#" + this.id() + (this.options.fixedHeaders === true ? "_headers " : " ") + "thead tr").length,
				array = [];					// the array we are going to build
			if (height === 0 && this.options.showHeader === false) {
				height = 1;
			}
			for (i = 0; i < width; i++) {
				array[i] = [];
			}
			i = 0;
			while (level < height) {
				nCols = [];
				while (i < cCols.length) {
					col = cCols[i];
					if (col.hidden === true) {
						i++;
						continue;
					}
					colrs = col.rowspan || 1;
					id = this._getColMarkForLevel(col);
					l = col.colspan || 1;
					for (j = 0; j < l; j++) {
						array[x + j][level] = id;
					}
					if (col.crs === colrs && col.group) {
						// we'll only preserve places for visible columns from the group
						nCols.push.apply(nCols, $.grep(col.group, this._columnVisible).slice(0));
					} else {
						nCols.push(col);
					}
					x += l;
					i++;
				}
				cCols = nCols;
				level++;
				x = 0;
				i = 0;
			}
			return array;
		},
		_getColMarkForLevel: function (col) {
			if (!col.crs) {
				col.crs = 0;
			}
			col.crs++;
			if (col.crs > 1) {
				return -1;
			}
			return col.key || col.identifier;
		},
		_performInternalMove: function (movingParams, subset) {
			/*	recursively searches for the required column and performs a move on the level the column was found 
				returns true if the move is successful
			*/
			var i = 0, j, success = true;
			i = this._getColIdxById(subset, movingParams.column);
			if (typeof movingParams.column === "number") {
				movingParams.column = subset[i].key || subset[i].identifier;
			}
			if (i || i === 0) {
				j = this._getColIdxById(subset, movingParams.target);
				// modify target when using indexes
				if (typeof movingParams.target === "number") {
					movingParams.target = subset[j].key || subset[j].identifier;
					if (j < i) {
						movingParams.after = false;
					} else {
						movingParams.after = true;
					}
				}
				//
				if (j || j === 0) {
					success = success && this._rearrangeArray(subset, i, 1, movingParams.after === true ? j + 1 : j);
					return success;
				}
				return false;
			}
			for (i = 0; i < subset.length; i++) {
				if (subset[i].group) {
					if (this._performInternalMove(movingParams, subset[i].group) === true) {
						return true;
					}
				}
			}
			return false;
		},
		_getColIdxById: function (array, id) {
			var i, col;
			if (typeof id === "number") {
				return id;
			}
			for (i = 0; i < array.length; i++) {
				col = array[i];
				if (col.key) {
					if (col.key === id) {
						return i;
					}
				} else if (col.identifier) {
					if (col.identifier === id) {
						return i;
					}
				}
			}
		},
		_getCellIndexByColumnKey: function (key) {
			// gets the index of the cell corresponding to a specific col key
			var i = this._getVisibleIndexByKey(key);
			return i === -1 ? i : i +
				this.element.find("tbody>tr:not([data-grouprow='true']):first")
				.children("th,td[data-skip='true'],td[data-parent]").length;
		},
		_findColAreaInLayout: function (col, nColArray, depth) {
			// searches for the column in the column layout array at a specified depth
			var i, j, res = {}; // the result is stored in a object with start and length properties
			for (i = 0; i < nColArray.length; i++) {
				if (nColArray[i][depth] === col) {
					res.start = i;
					for (j = i; j < nColArray.length; j++) {
						if (nColArray[j][depth] !== col) {
							break;
						}
					}
					res.length = j - i;
					return res;
				}
			}
			return null;
		},
		_rearrangeArray: function (array, start, length, at) {
			// rearranges an array by first removing the area from a specified start index and with a specified length
			// and then inserting it at a specified index
			var col, targetAfter = start < at, n;
			// targetAfter stores whether the target position for the column is to the right of the current position as
			// we need to modify the target position in this case
			if (start === at || start < 0 || at < 0 || start >= array.length || at > array.length) {
				//dummy check
				return false;
			}
			col = array.splice(start, length);
			for (n = 0; n < col.length; n++) {
				array.splice(targetAfter ? at - length + n : at + n, 0, col[n]);
			}
			return true;
		},
		_moveColumnInHeader: function (column, target, after, nColArray) {
			var rmil,			// result move in layout (stores the start and length parameters for the moved and target columns)
				movedColumn,	// an object storing the start and length params of the moved column area at the data level
				targetColumn,	// an object storing the start and length params of the target column area at the data level
				targetIndex,	// an index at which the column which will be used as a moving end point resides
				targetObject,	// an object storing more complex information about the moving end point in the cases where it needs to be
								// additonally calculated
				spStart,		// search parameter start (helper var)
				spEnd,			// search parameter end (helper var)
				i,
				j,
				cols,
				n,
				header;
			header = this.container().find("#" + this.id() + (this.options.fixedHeaders === true ? "_headers " : " ") + ">thead");
			// find moved and target columns in the column layout array
			for (j = 0; j < nColArray[0].length; j++) {
				movedColumn = this._findColAreaInLayout(column, nColArray, j);
				if (movedColumn) {
					targetColumn = this._findColAreaInLayout(target, nColArray, j);
					if (targetColumn) {
						break;
					}
				}
			}
			// create the rmil array
			rmil = [ movedColumn, targetColumn ];
			if (this.options.showHeader === false) {
				// if the header is not shown we just need to return this result so the table
				// columns can be moved
				return rmil;
			}
			// then we start moving the actual dom elements, initial target first
			this._moveThs(header, column, target, after);
			// afterwards we'll search each level below and determine how to move other columns so the grid's layout remains intact
			while (++j < nColArray[0].length) {
				cols = [];
				n = null;
				// we will get all real columns (not marked as -1) for the current level which resides under the 
				// area marked by the initial moved column
				for (i = movedColumn.start; i < movedColumn.start + movedColumn.length; i++) {
					if (nColArray[i][j] === -1) {
						continue;
					}
					if (nColArray[i][j] !== n) {
						n = nColArray[i][j];
						cols.push(n);
					}
				}
				// next we find a proper target to use as an end point for the dom manipulation
				// in the best case scenario we can find it simply by getting the columns at the edges of the target area
				targetIndex = after === true ? targetColumn.start + targetColumn.length - 1 : targetColumn.start;
				// if we find a column in this way we proceed with the actual dom manipulation
				if (nColArray[targetIndex][j] !== -1) {
					this._moveThs(header, cols, nColArray[targetIndex][j], after);
					continue;
				}
				// otherwise we need to try and find such a column either outside the target area or further inside it
				if (after === true) {
					// the index of the first element to the right
					spStart = targetColumn.start + targetColumn.length;
					// the index of the last element to be investigated, it depends on the relative position between
					// the moved and the target columns
					spEnd = movedColumn.start > targetColumn.start + targetColumn.length - 1 ? movedColumn.start : nColArray.length;
					// search to the right first
					targetObject = this._findTargetRight(spStart, spEnd, j, nColArray);
					if (!targetObject) {
						// if we couldn't find a good end point to the right we'll search to the left
						// the index of the first element to the left of the target's area end
						spStart = targetColumn.start + targetColumn.length - 2;
						// either the start of the array or the end of the moved column's area
						spEnd = movedColumn.start > targetColumn.start + targetColumn.length - 1 ?
								-1 : movedColumn.start + movedColumn.length;
						targetObject = this._findTargetLeft(spStart, spEnd, j, nColArray);
					}
				} else {
					// here we do just the same as above but since *after* is false the calculations differ
					spStart = targetColumn.start - 1;
					spEnd = movedColumn.start > targetColumn.start + targetColumn.length - 1 ? -1 : movedColumn.start + movedColumn.length;
					targetObject = this._findTargetLeft(spStart, spEnd, j, nColArray);
					if (!targetObject) {
						spStart = targetColumn.start + 1;
						spEnd = movedColumn.start > targetColumn.start + targetColumn.length - 1 ? movedColumn.start : nColArray.length;
						targetObject = this._findTargetRight(spStart, spEnd, j, nColArray);
					}
				}
				/* S.S. December 12, 2012 - The function is iterative and very fast but also filled with somewhat harder to follow logic.
				The best way to understand it is to imagine the column layout broken to a matrix (the nColArray), where we represent the forbidden
				fields with the number -1 and the normal fields with column keys (or mch id-s). At this point we already know the id of the column
				we want to move and the id of the column that it'll be inserted after/before. Therefore we can find the level we make the moving
				operation on and know that we need to do similar operations on each level below that.
				For each level below the initial one we grab all columns that reside under the column that was moved (or skip the level if 
				there are none). And then find where to move them. It's simple process of traversing the array's level horizontally searching 
				for a column id to perform the dom operations with. The only complexity comes from having to do it in a specific way so that
				we always know that the first column that we can use is going to provide us with the expected result. The issue really comes from
				the fact that the target area might be filled with forbidden fields which means the space is covered by a column at a higher level
				with a rowspan attribute. We need to find another column at that level, outside the target area to process the dom operation with.
				*/
				if (targetObject && targetObject.pos && targetObject.left !== undefined && targetObject.left !== null) {
					// if we managed to find a column this way we'll proceed with a dom manipulation, otherwise the column layout is such that
					// this level does not require any operation
					this._moveThs(header, cols, nColArray[targetObject.pos][j], targetObject.left);
				}
			}
			return rmil;
		},
		_moveColumnInBodyFooter: function (area, movedColumn, targetColumn, after) {
			// uses the data level parameters found by moving in the header to move columns in the body and footer
			var i, j, trs, $tr, tds, tar, skip;
			// get all data rows in the target area (TBODY or TFOOT)
			trs = area.find(">tr:not([data-container='true'],[data-grouprow='true'])");
			if (trs.length > 0) {
				// skip equals the amount of special TDs or THs in the row that should not participate in the move operation
				skip = trs.eq(0).find("[data-parent],[data-skip='true'],th").length;
			}
			for (j = 0; j < trs.length; j++) {
				// we'll be filling a jquery collection of TDs to move
				tds = $();
				$tr = trs.eq(j);
				// foreach TD in the moved area add the TD to the collection
				for (i = movedColumn.start; i < movedColumn.start + movedColumn.length; i++) {
					tds = tds.add($tr.children().eq(i + skip));
				}
				// then get an end point TD to perform the dom manipulation
				if (after === true) {
					tar = $tr.children().eq(targetColumn.start + targetColumn.length + skip - 1);
					tds.detach().insertAfter(tar);
				} else {
					tar = $tr.children().eq(targetColumn.start + skip);
					tds.detach().insertBefore(tar);
				}
			}
            // M.H. 4 Sep 2013 Fix for bug #144735: Right aligned last column content hides under scrollbar
            this._updateVerticalScrollbarCellPadding(true);
		},
		_findTargetRight: function (start, end, level, nColArray) {
			// traverses the nColArray from left to right at a specified level searching for a defined column
			var i, colFound = {};
			for (i = start; i >= 0 && i < end && i < nColArray.length; i++) {
				if (nColArray[i][level] !== -1) {
					colFound.pos = i;
					colFound.left = false;
					return colFound;
				}
			}
		},
		_findTargetLeft: function (start, end, level, nColArray) {
			// traverses the nColArray from left to right at a specified level searching for a defined column
			var i, colFound = {};
			for (i = start; i >= 0 && i > end && i < nColArray.length; i--) {
				if (nColArray[i][level] !== -1) {
					colFound.pos = i;
					colFound.left = true;
					return colFound;
				}
			}
		},
		_moveCols: function (area, movedColumn, targetColumn, after) {
			// moves cols in the colgroup of the specified area
			var i, cols = $(), tCol, skip = area.children("[data-skip='true']").length;
			for (i = movedColumn.start; i < movedColumn.start + movedColumn.length; i++) {
				cols = cols.add(area.children().eq(i + skip));
			}
			// get an end point COL to perform the dom manipulation
			if (after === true) {
				tCol = area.children().eq(targetColumn.start + targetColumn.length + skip - 1);
				cols.detach().insertAfter(tCol);
			} else {
				tCol = area.children().eq(targetColumn.start + skip);
				cols.detach().insertBefore(tCol);
			}
		},
		_moveThs: function (header, ids, tar, after) {
			// moves THs in the provided header
			var $tar, $ids = $(), $id, i, $pid; /* holds the TH containing the padding for the vertical scrollbar(last TH) */
			// find the move end point - the following selector always returns a single TH as THs either
			// contain an id attribute (data THs) or an data-mch-id attributed (MCH THs)
			$tar = header.find("th[data-mch-id='" + tar + "'],th[id='" + this.id() + "_" + tar + "']");
			// the ids param is either an array or a simple value
			if (typeof ids === "object") {
				for (i = 0; i < ids.length; i++) {
					$id = header.find("th[data-mch-id='" + ids[i] + "'],th[id='" + this.id() + "_" + ids[i] + "']");
					if ($id.attr('data-vscr-padding-icrement')) {
						$pid = $id;
					}
					$ids = $ids.add($id);
				}
			} else {
				$ids = header.find("th[data-mch-id='" + ids + "'],th[id='" + this.id() + "_" + ids + "']");
				if ($ids.attr('data-vscr-padding-icrement')) {
					$pid = $ids;
				}
			}
			// we detach all the THs we found
			$ids.detach();
			// and attach them after the target
			if (after) {
				$ids.insertAfter($tar);
			} else {
				$ids.insertBefore($tar);
			}
			// afterwards we need to assign the padding of the previously last column to the newly last column (if needed
			if ($tar.attr('data-vscr-padding-icrement') && after === true) {
				$ids
					.last()
					.css(this._padding, $tar.css(this._padding))
					.attr('data-vscr-padding-icrement', $tar.attr('data-vscr-padding-icrement'));
				$tar.css(this._padding, '');
				$tar.removeAttr('data-vscr-padding-icrement');
			} else if ($pid) {
				$pid
					.parent()
					.children(":last")
					.css(this._padding, $pid.css(this._padding))
					.attr('data-vscr-padding-icrement', $pid.attr('data-vscr-padding-icrement'));
				$pid.css(this._padding, '');
				$pid.removeAttr('data-vscr-padding-icrement');
			}
		},
		_moveSpecialThs: function (movedColumn, targetColumn, after) {
			// moves elements contained in special header rows (such as the Filter row)
			var i, j, spTrs, header, skip, ths, $tr, tar;
			header = this.container().find("#" + this.id() + (this.options.fixedHeaders === true ? "_headers " : " ") + "thead");
			spTrs = header.find(">tr[data-role]");
			if (spTrs.length > 0) {
				skip = spTrs.eq(0).find("[data-parent],[data-skip='true']").length;
			}
			for (j = 0; j < spTrs.length; j++) {
				ths = $();
				$tr = $(spTrs[j]);
				for (i = movedColumn.start; i < movedColumn.start + movedColumn.length; i++) {
					ths = ths.add($tr.children("td,th").eq(i + skip));
				}
				if (after === true) {
					tar = $tr.children().eq(targetColumn.start + targetColumn.length + skip - 1);
					ths.detach().insertAfter(tar);
				} else {
					tar = $tr.children().eq(targetColumn.start + skip);
					ths.detach().insertBefore(tar);
				}
			}
		},
		_performDomColumnMove: function (column, target, after, nColArray) {
			var rmil = this._moveColumnInHeader(column, target, after, nColArray), /* moving the header also produces
				information about how to perform the operation on the TBODY/TFOOT	*/
				movedColumn = rmil[0],
				targetColumn = rmil[1],
				footer;
			// rearrange header cells positionined in special header rows
			this._moveSpecialThs(movedColumn, targetColumn, after);
			// rearrange the cols for the header if fixedHeaders is enabled
			if (this.options.fixedHeaders === true) {
				this._moveCols(this.container().find("#" + this.id() + "_headers>colgroup"), movedColumn, targetColumn, after);
			}
			// and finally rearrange the body
			this._moveColumnInBodyFooter(this.element.find(">tbody"), movedColumn, targetColumn, after);
			// its colgroup
			this._moveCols(this.element.find(">colgroup"), movedColumn, targetColumn, after);
			// the footers
			if (this.options.fixedFooters === true) {
				//footer = $("#" + this.id() + "_footers");
				footer = this.footersTable();
				this._moveColumnInBodyFooter(footer.children("tfoot"), movedColumn, targetColumn, after);
				this._moveCols(footer.children("colgroup"), movedColumn, targetColumn, after);
			} else {
				this._moveColumnInBodyFooter(this.element.find("tfoot"), movedColumn, targetColumn, after);
			}
			// when the dom has changed we need to throw an event to notify other features to update dom related parameters
			this._trigger("_columnsmoved", null, {
				owner: this,
				start: movedColumn.start,
				len: movedColumn.length,
				index: after === true ? targetColumn.start + targetColumn.length : targetColumn.start
			});
		},
		_performColumnMove: function (column, target, after, nColArray) {
			var rmil = this._moveColumnInHeader(column, target, after, nColArray),
				movedColumn = rmil[0],
				targetColumn = rmil[1];
			// rearrange the cols for the header if needed
			if (this.options.fixedHeaders === true) {
				this._moveCols(this.container().find("#" + this.id() + "_headers>colgroup"), movedColumn, targetColumn, after);
			}
			this._renderData();
			this._renderFooter();
			this._rerenderColgroups();
		},
		showColumn: function (column) {
			/* Shows a hidden column. If the column is not hidden the method does nothing.
				paramType="number|string" An identifier for the column. If a number is provided it will be used as a column index. If a string is provided it will be used as a column key.
			*/
			var grid = this;
			this._loadingIndicator.show();
			if (!this._isShowingAllowed([column])) {
				return false;
			}
			setTimeout(function () {
				grid._setHidden(column, false);
				grid._loadingIndicator.hide();
			}, 0);
			return true;
		},
		hideColumn: function (column) {
			/* Hides a visible column. If the column is hidden the method does nothing.
				paramType="number|string" An identifier for the column. If a number is provided it will be used as a column index else if a string is provided it will be used as a column key.
			*/
			var grid = this;
			this._loadingIndicator.show();
			if (!this._isHidingAllowed([column])) {
				return false;
			}
			setTimeout(function () {
				grid._setHidden(column, true);
				grid._loadingIndicator.hide();
			}, 0);
			return true;
		},
		_setHidden: function (column, hidden) {
			var col;
			if (typeof column === 'number') {
				col = this.options.columns[column];
			} else {
				col = this.columnByKey(column);
			}
			//perform hiding/showing if the hidden value actually changed
			if (col && col.hidden !== hidden) {
				this._setHiddenColumns([col], hidden, false);
			}
		},
		_visibleAreaWidth: function (w) {
			// get or sets minimal visible area width
			if (w !== undefined) {
				this._minVAreaWidth = w;
			} else {
				return this._minVAreaWidth;
			}
		},
		_isShowingAllowed: function (columns) {
			// check whether showing columns is allowed - it should NOT be allowed if columns are fixed and showing them will increase the width of the fixed visible area more than the whole grid container
			if (!this.hasFixedColumns()) {
				return true;
			}
			var i, columnsLength = columns.length, totalW = 0, w, gridW, colType, col;

			for (i = 0; i < columnsLength; i++) {
				colType = (typeof columns[i]);
				if (colType === 'string') {
					col = this.columnByKey(columns[i]);
				} else if (colType === 'number') {
					col = this.options.columns[columns[i]];
				} else {
					col = columns[i];
				}
				if (!col || !col.hidden) {
					continue;
				}
				if (col.fixed && (col.width || col.oWidth)) {
					w = col.width || col.oWidth;
					w = parseInt(w, 10);
					totalW += w;
				}
			}
			// in case we show fixed columns
			if (totalW !== 0) {
				gridW = this.container().outerWidth();
				if (gridW - parseInt(this.fixedContainer().outerWidth(), 10) - totalW < this._visibleAreaWidth()) {
					return false;
				}
			}
			return true;
		},
		_isHidingAllowed: function (columns) {
			// Check whether hiding is allowed(it is made when there are fixed columns, otherwise returns true).
			// It can't be allowed when all columns in fixed or unfixed area are hidden
			// columns is array. It could be array of column indexes, column keys, or column objects(or mixed of these three)
			if (!this.hasFixedColumns()) {
				return true;
			}
			var i, columnsLength = columns.length, col, colType,
				fixed = [], unfixed = [];

			for (i = 0; i < columnsLength; i++) {
				colType = (typeof columns[i]);
				if (colType === 'string') {
					col = this.columnByKey(columns[i]);
				} else if (colType === 'number') {
					col = this.options.columns[columns[i]];
				} else {
					col = columns[i];
				}
				if (!col || col.hidden) {
					continue;
				}
				if (col.fixed) {
					fixed.push(col);
				} else {
					unfixed.push(col);
				}
			}
			if ((fixed.length !== 0 && this._visibleColumns(true).length <= fixed.length) ||
				this._visibleColumns(false).length <= unfixed.length) {
				return false;
			}
			return true;
		},
		_setHiddenColumns: function (columns, hidden, initial) {
			var columnNumberChanged = false,
				self = this,
				hasVirtualization = this.options.virtualization === true || this.options.columnVirtualization === true || this.options.rowVirtualization === true,
				hasColumnVirtualization = (this.options.virtualizationMode !== 'continuous') && ((this.options.virtualization === true && this.options.width) || this.options.columnVirtualization === true),
				isContinuos = false,
				visibleColumnsLength,
				visibleColumnsWithWidthLength,
				gridWidth,
				hasNoWidthPercentage,
				overflow,
				colgroup;
			if (columns.length === 0) {
				return;
			}
			// updating should remove AddNewRow objects, and _hidingFinished is too late 
			this._fireInternalEvent('_hidingFinishing', { columns: columns, hidden: hidden });
			if (hasVirtualization) {
				// M.H. 13 Sep 2012 Fix for bug #120220
				isContinuos = (this.options.virtualizationMode === 'continuous');
				self._updateVirtColCounters();
				if (!isContinuos) {
					$.each(columns, function (index, col) {
						var oldVirtualColumnCount = self._virtualColumnCount;
						col.hidden = hidden;
						self._visibleColumnsArray = undefined;
						self._updateVirtColCounters();
						if (self._virtualColumnCount !== oldVirtualColumnCount) {
							if (self._virtualColumnCount < oldVirtualColumnCount) {
								self._detachColumn(col);
							} else if (self._virtualColumnCount > oldVirtualColumnCount) {
								self._attachColumn(col);
							}
							columnNumberChanged = true;
							//force rebuild of _virtualDom
							self._virtualDom = null;
						}
					});
					if (hasColumnVirtualization) {
						//if we have column virtualization a horizontal scroll triggering is required
						this._vheaders = undefined;
						this._updateVirtualHorizontalScrollbar();
						// M.H. 12 Sep 2012 Fix for bug #120220
						this._onVirtualHorizontalScroll();
						// M.H. 12 Sep 2013 Fix for bug #146743: Columns are misaligned when columnVirtualization = true and there is an initially hidden column
						if (!this._initialized) {
							this._adjustLastColumnWidth(true);
						}
						// M.H. 27 Aug 2012 Fix for bug #119710
	//					if (horizontalScrollContainer.length > 0 && horizontalScrollContainer.is(':hidden') === false) {
	//						this._onVirtualHorizontalScroll();
	//					}
					}
					this._renderVirtualRecords();
				}
			}
			// M.H. 13 Sep 2012 Fix for bug #120220
			if (!hasVirtualization || isContinuos) {
				$.each(columns, function (index, col) {
					col.hidden = hidden;
					self._visibleColumnsArray = undefined;

					if (col.hidden) {
						self._detachColumn(col);
					} else {
						self._attachColumn(col);
					}
				});
				//clear tbody and render data
				this._cleanupTBody();
				columnNumberChanged = true;
				// M.H. 13 Sep 2012 Fix for bug #120220
				if (hasVirtualization) {
					this._renderVirtualRecords();
				} else {
					this._renderRecords();
				}
			}
			if (columnNumberChanged) {
				if (!this._initialized) {
					this._rerenderColgroups(initial);
					this._adjustLastColumnWidth(true);
				} else {
					//adjust last column width and grid width only if we have columns
					//leave the grid in the same configuration otherwise
					if (this._visibleColumns().length > 0) {
						this._rerenderColgroups(initial);
						//adjust the last column width after the data is rendered and we know if we need a scrollbar or not
						this._adjustLastColumnWidth(true);
						//adjust grid width 
						visibleColumnsLength = this._visibleColumns().length;
						visibleColumnsWithWidthLength =
							$.grep(this._visibleColumns(),
								function (col) {
									return col.width;
								}).length;
						//adjust width only if all visible columns have width
						if (visibleColumnsWithWidthLength === visibleColumnsLength) {
							if (this.options.width && parseInt(this.options.width, 10) > 0) {
								//if grid has width sum all visible columns' widths and set it as table width
								this._updateGridContentWidth();
							} else {
								//if grid has no width set the container width as the sum of all columns widths
								this._setContainerWidth(this.container());
								if (hasVirtualization) {
									//headerParent = $('#' + this.element[0].id + '_headers_v').css('width', width);
									gridWidth = this._calculateContainerWidth(true);
									if (this.options.height !== null) {
										gridWidth -= this._scrollbarWidth();
									}
									this._vdisplaycontainer()
										.css('width', gridWidth)
										.css('max-width', gridWidth);
								}
							}
						}
					}
				}
			}
			this._fireInternalEvent("_hidingFinished", { columns: columns, hidden: hidden });
			this.element.trigger('iggriduisoftdirty', {owner: this});
			this._trigger(this.events.columnsCollectionModified, null, {owner: this});
			// M.H. 17 July 2012 Fix for bug #105203 - it should be called after columnsCollectionModified because special column width is calculated properly
			if (columnNumberChanged && hasVirtualization && this._visibleColumns().length > 0 && visibleColumnsWithWidthLength === visibleColumnsLength) {
				if (this.options.virtualizationMode === 'continuous') {
					gridWidth += this._calculateSpecialColumnsWidth();
					this._vdisplaycontainer()
						.css('width', gridWidth)
						.css('max-width', gridWidth);
				}
				this.container().find('#' + this.id() + '_virtualContainer>colgroup col').eq(0).attr('width', gridWidth);
				//$('#' + this.element[0].id + '_headers_v').width()
				// M.H. 27 Aug 2012 Fix for bug #119710 - we should re-set width of the virtual container only when width is not set
				if (this.options.width === null || this.options.width === undefined) {
					this._setContainerWidth(this.container().find("#" + this.id() + "_headers_v"));
				}
			}
			this._origWidth = parseInt(this.container().css("width"), 10);
			// M.H. 31 Mar 2014 Fix for bug #167868: In Safari, IgniteUI grid header shifts right when the Filtering is enabled and the first column is initially hidden
			if (columnNumberChanged && $.ig.util.isSafari && this.options.showHeader) {
				this._refreshUI();
			}
			if (columnNumberChanged && ($.ig.util.isFF || $.ig.util.isIE8)) {
				//in order to have columns aligned correctly on FF and IE8 detach/attach calgroups
                hasNoWidthPercentage = false;
                // M.H. 16 Dec 2013 Fix for bug #154835: In Internet Explorer 8 when the grid has 100% width,  filtering is enabled and a column is hidden there is a blank space on the right of the grid.
                if ($.ig.util.isIE8 &&
                        typeof this.options.width === 'string' &&
                        this.options.width.indexOf('%') !== -1) {
					this._refreshUI();
                }
                //update the data table if it is different from the headers table or we are not showing headers
				if ((this.options.fixedHeaders === true && this.options.height !== null) ||
						this.options.showHeader === false) {
					colgroup = this.element.children("colgroup").detach();
					this.element.prepend(colgroup);
                    // M.H. 11 Sep 2013 Fix for bug #150851: When igGrid column widths are set in percentage and column hiding is performed the new column widths are not calculated as expected
                    if (this.options.width ||
                            (this.options.defaultColumnWidth && this.options.defaultColumnWidth.indexOf('%') === -1)) {
                        hasNoWidthPercentage = true;
                    }
                    // M.H. 9 Sep 2013 Fix for bug #151463: Firefox hack to force layout refresh when hiding columns no longer works
                    // this is a hack - we first check whether all columns have width. If not then we set overflow hidden and after that re-set overflow
                    // the bug is caused by the new updates in Firefox - it is replicated with version 23.0.1 - and is caused by the fact that the layout engine does not repaint table cells when col is removed from colgroup
                    colgroup.find('col').each(function () {
                        var w = this.style.width;
                        // M.H. 11 Sep 2013 Fix for bug #150851: When igGrid column widths are set in percentage and column hiding is performed the new column widths are not calculated as expected
                        if (w && w.indexOf('%') === -1) {
                            hasNoWidthPercentage = false;
                            return false;
                        }
                    });
				}
                // M.H. 7 Jan 2014 Fix for bug #160871: Hiding through API is causing misalignment in Firefox
                overflow = this.element[0].style.overflow;
                this.element[0].style.overflow = 'hidden';
                setTimeout(function () {
                    self.element[0].style.overflow = overflow;
                }, 0);
				if (this.options.showHeader) {
                    colgroup = this.headersTable().children("colgroup").detach();
					this.headersTable().prepend(colgroup);
                    // M.H. 9 Sep 2013 Fix for bug #151463: Firefox hack to force layout refresh when hiding columns no longer works
                    if (hasNoWidthPercentage) {
                        overflow = this.headersTable()[0].style.overflow;
                        this.headersTable()[0].style.overflow = 'hidden';
                        setTimeout(function () {
                            self.headersTable()[0].style.overflow = overflow;
                        }, 0);
                    }
				}
				//update the footers table if we have one
				if (this.options.fixedFooters === true && this.options.height !== null) {
					colgroup = this.footersTable().children('colgroup').detach();
					this.footersTable().prepend(colgroup);
                    // M.H. 9 Sep 2013 Fix for bug #151463: Firefox hack to force layout refresh when hiding columns no longer works
                    if (hasNoWidthPercentage) {
                        overflow = this.footersTable()[0].style.overflow;
                        this.footersTable()[0].style.overflow = 'hidden';
                        setTimeout(function () {
                            self.footersTable()[0].style.overflow = overflow;
                        }, 0);
                    }
				}
			}
		},
		_calculateSpecialColumnsWidth: function () {
			var width = 0;
			//take the special columns widths into account
			this.headersTable().find("> colgroup > col[data-skip=true]").each(function () {
				var colWidth = this.style.width;
				if (colWidth) {
					width += parseInt(colWidth, 10);
				}
			});
            // L.A. 07 May 2012 Fixed bug #111052 The width of a column in a grid changes with 6 to 7px after grouping by it
            if (width > 0) {
                this._origSum = width;
            }
			return width;
		},
		_allSpecialColumnsInPercentage: function () {
			var specCols = this.headersTable().find("> colgroup > col[data-skip=true]"), i;
			for (i = 0; i < specCols.length; i++) {
				if (!specCols[i].style.width.endsWith("%")) {
					return false;
				}
			}
			return true;
		},
		_synchronizeHScroll: function () {
			var hasFixedHeaders = this.options.showHeader && this.options.fixedHeaders === true && this.options.height !== null,
				hasFixedFooters = this.options.showFooter && this.options.fixedFooters === true && this.options.height !== null,
				scroller = this._hscrollbarcontent(),
				scrollContainer = this.scrollContainer(),
				horizontalScrollContainer = $('#' + this.id() + '_horizontalScrollContainer'),
				scrLeft = scroller.scrollLeft(),
				headers, footers;
			// M.H. 26 Jul 2013 Fix for bug #145572: When Resizing with continuous rowVirtualization no horizontal scrollbar appears when needed
            if (scroller.length === 0 && horizontalScrollContainer.length === 1) {
                scrLeft = horizontalScrollContainer.scrollLeft();
				this._vdisplaycontainer().scrollLeft(scrLeft);
            } else {
				scrollContainer.scrollLeft(scrLeft);
				// when there is no data in scrollContainer then scrollContainer.scrollLeft() always returns 0 even if scrLeft is not 0
				// M.H. 23 Apr 2014 Fix for bug #169582: Misalignment between the header and the footer when advanced filtering and continuous virtualization are enabled
				if (scrollContainer.scrollLeft() !== 0 || this.element.height() !== 0) {
					scrLeft = scrollContainer.scrollLeft();
					scroller.scrollLeft(scrLeft);
				}
            }
			if (hasFixedHeaders) {
				headers = this.headersTable().parent();
				headers.scrollLeft(scrLeft);
			}
			if (hasFixedFooters) {
				footers = this._fixedfooters();
				footers.scrollLeft(scrLeft);
			}
		},
        _updateFixedGridContentWidth: function (minAllowWidth) {
			var fixedContainerWidth = 0, gridW, gridInnerWidth;
			$.each(this._fixedColumns, function (index, col) {
                var colW;

                if (!col.width || (col.width.charAt && col.width.endsWith('%')) || col.hidden) {
                    return true;
                }
                colW = parseInt(col.width, 10);
				if (col.fixed === true) {
					fixedContainerWidth += colW;
				}
			});
			this._setGridFixedTablesWidth(fixedContainerWidth);
            if (this._gridHasWidthInPixels()) {
                gridW = parseInt(this.options.width, 10);
                gridInnerWidth = gridW - parseInt(this.fixedContainer().outerWidth(), 10);
                this._hscrollbar().css('width', gridInnerWidth + 'px');
                if (this.options.height !== null) {
                    this._gridInnerWidth = gridInnerWidth;
                    this._gridInnerWidth = this.scrollContainer().width();
                    this._updateHScrollbarVisibility();
                }
            }
		},
		_updateGridContentWidth: function () {
			var gridWidth = 0,
				scroller,
				scrLeft,
                hasFixedHeader = this.options.height !== null && this.options.fixedHeaders === true && this.options.showHeader && this._headerParent;
			$.each(this._visibleColumns(), function (index, col) {
                if (col.fixed === true) {
                    return true;
                }
				if (gridWidth !== undefined &&
						col.width &&
						!(col.width.charAt && col.width.endsWith('%'))) {
					gridWidth += parseInt(col.width, 10);
				} else {
					gridWidth = undefined;
				}
			});
			if (gridWidth === undefined) {
				return;
			}
			//take the special columns widths into account
			gridWidth += this._calculateSpecialColumnsWidth();
            /* L.A. 05 June 2012. Fixing bug #113545 When grid's width is bigger than the sum of column widths 
            and fixedHeaders=false the hidding icon of the last column is not visible. */
			if (!hasFixedHeader && this._hasVerticalScrollbar) {
                gridWidth -= this._scrollbarWidth();
            }
			if (this.options.width !== null && this.options.height !== null) {
				scroller = this._hscrollbarcontent();
				scrLeft = scroller.scrollLeft();
			}
			this._setGridContentWidth(gridWidth);
			if (this.options.height !== null && this.options.width !== null) {
				this._updateVerticalScrollbarCellPadding();
			}
			if (this.options.width !== null && this.options.height !== null) {
				//A.Y. bug 91577. restore the scrolLeft of the grid as some browsers may calculate it as 0 when the table size is changed.
				scroller.scrollLeft(scrLeft);
				this._synchronizeHScroll();
			}
		},
		_updateVerticalScrollbarCellPadding: function (skipHeaderFooters) {
			//if there is a vertical scrollbar the right padding
			//of the last column's header and footer cells should be adjusted 
			//such that the content is not over the scrollbar
			var hasFixedHeaders = this.options.showHeader && this.options.fixedHeaders === true && this.options.height !== null,
				hasFixedFooters = this.options.showFooter && this.options.fixedFooters === true && this.options.height !== null,
				emptySpace,
				paddingIncrement;
			if (this.options.height === null) {
				//if the grid has no height there is no vertical scrollbar
				return;
			}
			if (!hasFixedHeaders && !hasFixedFooters) {
				//if the grid doesn't hava fixed headers or footers the vertical scrollbar
				//is across the whole table, including the header and the footer,
				//and no padding adjustment is required
				return;
			}
			if (this._gridInnerWidth === undefined || this._gridContentWidth === undefined) {
				//if the grid's inner width or content width are undefined(not all columns have width in pixels)
				//then the grid content fills the whole grid
				emptySpace = 0;
			} else {
				emptySpace = this._gridInnerWidth - this._gridContentWidth;
			}
			if (this._hasVerticalScrollbar) {
				paddingIncrement = this._scrollbarWidth();
			} else {
				paddingIncrement = 0;
			}
			if (emptySpace >= 0) {
				//if there is empty space it should be substracted from the padding
				paddingIncrement -= emptySpace;
			}
			if (paddingIncrement < 0) {
				paddingIncrement = 0;
			}
			this._updateVScrollbarCellPaddingHelper(paddingIncrement, skipHeaderFooters);
		},
		_updateVScrollbarCellPaddingHelper: function (paddingIncrement, skipHeaderFooters) {
			var hasFixedHeaders = this.options.showHeader && this.options.fixedHeaders === true && this.options.height !== null,
				hasFixedFooters = this.options.showFooter && this.options.fixedFooters === true && this.options.height !== null;
			if (hasFixedHeaders && !skipHeaderFooters) {
				this._increaseLastHeaderCellVScrollbarPadding(this.headersTable(), paddingIncrement);
			}
			if (hasFixedFooters && !skipHeaderFooters) {
				this._increaseLastCellVScrollbarPadding(this.footersTable(), "tfoot", "td", paddingIncrement);
			}
			this._increaseLastCellVScrollbarPadding(this.element, "tbody", "td", paddingIncrement);
		},
		_increaseLastHeaderCellVScrollbarPadding: function (table, paddingIncrement) {
			var lastCells = table
				.children("thead")
				.children("tr")
				.not("[data-skip=true]")
				.children("th:last-child")
				.not("[data-skip=true]"),
				currIncrement = parseInt(lastCells.first().attr('data-vscr-padding-icrement'), 10),
				paddingValue;
			paddingValue = parseInt(lastCells.first().css(this._padding), 10);
			if (currIncrement) {
				//if the padding has currently been incremented
				//because of a vScrollbar we should remove that increment
				paddingValue -= currIncrement;
			}
			this._removeHeaderCellPadding(table);
			//hide the table to trigger just one reflow
			// L.A. 30 July 2012 - Fixing bug #117293 The drop-down menu is closing when you try to use keyboard navigation in IE
			//table.css('display', 'none');
			lastCells.css(this._padding, paddingValue + paddingIncrement);
			lastCells.first().attr('data-vscr-padding-icrement', paddingIncrement);
			//update the margin to be exactly the oposite of the padding cell
			//for the indicators that should always stay on the right regardless of the padding
			//this is the case with the resizing and hiding indicators
			lastCells
				.find("[data-nonpaddedindicator=right]")
				.css(this._rtl ? 'margin-left' : 'margin-right', -parseInt(lastCells.css(this._padding), 10) + 'px');
			// L.A. 30 July 2012 - Fixing bug #117293 The drop-down menu is closing when you try to use keyboard navigation in IE
			//table.css('display', '');
		},
		_removeHeaderCellPadding: function (table, removeAllPaddings) {
			var withoutLastCell = ":not(:last)";
			if (removeAllPaddings === true) {
				withoutLastCell = "";
			}
			table.find("thead > tr > th" + withoutLastCell + "[data-vscr-padding-icrement],thead > tr > td:not(:last)[data-vscr-padding-icrement]")
				.removeAttr("data-vscr-padding-icrement")
				.css(this._padding, "");
		},
		_removeCellPadding: function (table, tableGroup, rowElement, removeAllPaddings) {
			// M.H. 4 Sep 2013 Fix for bug #144735: Right aligned last column content hides under scrollbar
			var i, $cell, cells, withoutLastCell = ':not(:last)';
			if (removeAllPaddings === true) {
				withoutLastCell = "";
			}
			cells = table
				.find(" > " + tableGroup + " > tr:first > " + rowElement + withoutLastCell + "[data-vscr-padding-icrement]");
			for (i = 0; i < cells.length; i++) {
				$cell = $(cells[i]);
				$cell.removeAttr("data-vscr-padding-icrement");
				table
					.find(" > " + tableGroup + " > tr > " + rowElement + ":nth-child(" + ($cell.index() + 1) + ")")
					.css(this._padding, "");
			}
		},
		_increaseLastCellVScrollbarPadding: function (table, tableGroup, rowElement, paddingIncrement) {
			var paddingValue,
				lastCells = table.find(" > " + tableGroup + " > tr > " + rowElement + ":last-child"),
				currIncrement = parseInt(lastCells.first().attr('data-vscr-padding-icrement'), 10);

			// M.H. 4 Sep 2013 Fix for bug #144735: Right aligned last column content hides under scrollbar
			this._removeCellPadding(table, tableGroup, rowElement);
			//A.T. 9 July - Fix for bug #144735 - right aligned last column content hides under scrollbar
			paddingValue = parseInt(lastCells.first().css(this._padding), 10);
			if (currIncrement) {
				//if the padding has currently been incremented
				//because of a vScrollbar we should remove that increment
				paddingValue -= currIncrement;
			}
			lastCells.css(this._padding, paddingValue + paddingIncrement);
			lastCells.first().attr('data-vscr-padding-icrement', paddingIncrement);
		},
		_updateHScrollbarVisibility: function () {
			var scrollerContainer = this._hscrollbar(),
				scrollerWasHidden = scrollerContainer.css('display') === 'none';
			scrollerContainer.css('display', '');
			if (this._gridInnerWidth < this._gridContentWidth) {
				// M.H. 5 Jul 2013 Fix for bug #145572: When Resizing with continuous rowVirtualization no horizontal scrollbar appears when needed
				if (this.options.virtualizationMode === 'continuous' &&
						scrollerContainer.length === 0 &&
						this._getHScrollContainerInner().length === 0) {
					this._renderHorizontalScrollContainer(this._calculateContainerWidth(false));
					scrollerWasHidden = true;
				}
				if (scrollerWasHidden) {
					if (this.options.autoAdjustHeight) {
						this._initializeHeights();
					}
				}
			} else {
				// M.H. 5 Jul 2013 Fix for bug #145572: When Resizing with continuous rowVirtualization no horizontal scrollbar appears when needed
				if (this.options.virtualizationMode === 'continuous' &&
						scrollerContainer.length === 0 &&
						this._getHScrollContainerInner().length === 1) {
					this._vhorizontalcontainer().empty().attr('style', '');
					scrollerWasHidden = false;
				}
				scrollerContainer.css('display', 'none');
				if (!scrollerWasHidden) {
					if (this.options.autoAdjustHeight) {
						this._initializeHeights();
					}
				}
			}
		},
		_setGridContentWidth: function (gridContentWidth) {
			var o = this.options, w,
				v = o.virtualization === true || o.rowVirtualization === true || o.columnVirtualization === true;
			if (this.options.height !== null) {
				if (gridContentWidth) {
					this._gridContentWidth = gridContentWidth;
				}
				if (this._gridContentWidth) {
					// M.H. 26 Jun 2013 Fix for bug #142942: When Paging is enabled changing the page size to value big enough to have a vertical scrollbar while a column is fixed makes the grid misaligned when you scroll the grid to the right.
					w = (this._hasVerticalScrollbar && this.options.fixedHeaders ? this._gridContentWidth - this._scrollbarWidth() : this._gridContentWidth);
					// M.H. 22 Jul 2013 Fix for bug #146980: When height is defined and you resize a column from the unfixed area the scrollbar disappears.
					// when there are fixed columns and sort on unfixed columns hscrollbar is disabled
					//if (this.hasFixedColumns() && !gridContentWidth) {
					//	w -= parseInt(this.fixedContainer().outerWidth(), 10);
					//}
					// L.A. 23 April 2012 Fixing bug #99024 When in grid fixedHeaders is false, it is not possible to resize last column
					// L.A. 26 April 2012 Fixing bug #91585 In IE7 columns are not correct after scroll horizontal
					this._getHScrollContainerInner()
						.css('width', w);
				}
				this._updateHScrollbarVisibility();
			}
			if (v === false) {
				this._setGridTablesWidth(gridContentWidth);
			}
		},
        _setGridFixedTablesWidth: function (width) {
			var hasFixedHeaders = this.options.showHeader && this.options.fixedHeaders === true && this.options.height !== null,
				hasFixedFooters = this.options.showFooter && this.options.fixedFooters === true && this.options.height !== null;
			this.fixedTable().width(width);
			if (hasFixedHeaders) {
				this.fixedHeadersTable().width(width);
			}
			if (hasFixedFooters) {
				this.fixedFootersTable().width(width);
			}
		},
		_setGridTablesWidth: function (width) {
			var hasFixedHeaders = this.options.showHeader && this.options.fixedHeaders === true && this.options.height !== null,
				hasFixedFooters = this.options.showFooter && this.options.fixedFooters === true && this.options.height !== null;
			this.element.width(width);
			if (hasFixedHeaders) {
				this.headersTable().width(width);
			}
			if (hasFixedFooters) {
				this.footersTable().width(width);
			}
		},
		_detachHiddenColumns: function () {
			var col, i;
			for (i = 0; i < this.options.columns.length; i++) {
				col = this.options.columns[i];
				if (col.hidden) {
					this._detachColumn(col);
				}
			}
		},
		_rerenderColgroups: function () {
			var hasFixedHeader = this.options.height !== null && this.options.fixedHeaders === true && this.options.showHeader,
				hasFixedFooter = this.options.height !== null && this.options.fixedFooters === true && this.options.showFooter,
                initial = this.options.autofitLastColumn;

			if (hasFixedHeader) {
				this.headersTable().children("colgroup").remove();
				this._renderColgroup(this.headersTable()[0], true, false, initial);
			}
			if (hasFixedFooter) {
				this.footersTable().children('colgroup').remove();
				this._renderColgroup(this.footersTable()[0], false, true, initial);
			}
			this.element.children("colgroup").remove();
			this._renderColgroup(this.element[0], false, false, initial);
		},
		_detachColumn: function (col) {
			var position, cols, headerCells, isMultiColumnGrid = this._isMultiColumnGrid;
			col.hidden = false;
			this._visibleColumnsArray = undefined;
			cols = this._visibleColumns();
			position = $.inArray(col, cols);
			col.hidden = true;
			this._visibleColumnsArray = undefined;
			this._initializeDetachedContainers();
			headerCells = this.headersTable().children("thead").children("tr").not("[data-skip=true]");
			if (isMultiColumnGrid) {
				this._hideMultiHeaderCells(this._headerCells, position, col.key);
				headerCells = this.headersTable().children("thead").children("tr:not([data-mch-level])").not("[data-skip=true]");
				this._detachCells(
					headerCells,
					function (row) {
						return row.children("th, td").not("[data-skip=true]");
					},
					position,
					this._detachedHeaderCells,
					col.key
				);
			} else {
			this._detachCells(
					headerCells,
					function (row) {
						return row.children("th, td").not("[data-skip=true]");
					},
				position,
				this._detachedHeaderCells,
				col.key
			);
			}
			this._detachCells(
				this.footersTable().children("tfoot").children("tr"),
				function (row) { return row.children("td").not("[data-skip=true]"); },
				position,
				this._detachedFooterCells,
				col.key
			);
		},
		_attachColumn: function (col) {
			var headerCells, visibleCols = this._visibleColumns(),
				position = $.inArray(col, visibleCols);
			this._initializeDetachedContainers();
			if (this._isMultiColumnGrid) {
				this._showMultiHeaderCells(col.key);
				headerCells = this.headersTable().children("thead").children("tr:not([data-mch-level])").not("[data-skip=true]");
				this._attachCells(
					headerCells,
					function (row) { return row.children("th, td").not("[data-skip=true]"); },
					position,
					this._detachedHeaderCells,
					col.key
				);
			} else {
			this._attachCells(
				this.headersTable().children("thead").children("tr").not("[data-skip=true]"),
				function (row) { return row.children("th, td").not("[data-skip=true]"); },
				position,
				this._detachedHeaderCells,
				col.key
			);
			}
			this._attachCells(
				this.footersTable().children("tfoot").children("tr"),
				function (row) { return row.children("td").not("[data-skip=true]"); },
				position,
				this._detachedFooterCells,
				col.key
			);
		},
		_initializeDetachedContainers: function () {
			if (!this._detachedContainersInitialized) {
				this._detachedHeaderCells = {};
				this._detachedFooterCells = {};
				this._detachedContainersInitialized = true;
			}
		},
		_getParentsMultiHeader: function (key) {
			var i, cols = this._oldCols, colsLength = cols.length, arr = [];
			for (i = 0; i < colsLength; i++) {
				if (cols[i].key === key || cols[i].identifier === key) {
					arr.push(cols[i]);
					break;
				}
                if (cols[i].group) {
					if (this._getParentsMultiHeaderRecursive(key, cols[i].group, arr) === true) {
						arr.push(cols[i]);
						break;
					}
				}
			}
			return arr;
		},
		_getParentsMultiHeaderRecursive: function (key, arr, resArr) {
			var i, cols = arr, colsLength = arr.length, res = false;
			for (i = 0; i < colsLength; i++) {
				if (cols[i].key === key || cols[i].identifier === key) {
					resArr.push(cols[i]);
					res = true;
					break;
				}
				if (cols[i].group && this._getParentsMultiHeaderRecursive(key, cols[i].group, resArr) === true) {
					resArr.push(cols[i]);
					res = true;
					break;
				}
			}
			return res;
		},
		_hideMultiHeaderCells: function (headerCells, position, key) {
			var i, currentCell, parents = this._getParentsMultiHeader(key), parent, colspan, $th,
				headersTable = this.headersTable().find('thead > tr'), $tr;
			currentCell = headerCells[position];
			this._headerCells.splice(position, 1);
			$tr = currentCell.closest('tr');
			if ($tr[0].style.height === '') {
				$tr[0].style.height = $tr.outerHeight() + 'px';
			}
			currentCell.css('display', 'none');
			this._hiddenColumns[key] = currentCell;
			if (parents.length > 0) {
				for (i = 0; i < parents.length; i++) {
					parent = parents[i];
					if (parent.level === 0) {
						continue;
					}
					$th = headersTable.find('th[data-mch-id=' + parent.identifier + ']');
					// in case of fixed column
					if ($th.length === 0) {
						$th = this.fixedHeadersTable()
							.find('thead > tr')
							.find('th[data-mch-id=' + parent.identifier + ']');
					}
					colspan = parseInt($th.attr('colspan'), 10);
					if (colspan > 1) {
						$th.attr('colspan', --colspan);
						parent.colspan = colspan;
					} else {
						$tr = $th.closest('tr');
						if ($tr[0].style.height === '') {
							$tr[0].style.height = $tr.outerHeight() + 'px';
						}
						$th.attr('ishidden', 1);
						$th.css('display', 'none');
						parent.hidden = true;
						parent.colspan = 0;
					}
				}
			}
		},
		_detachCells: function (rows, cellSelectorFunction, position, container, key) {
			var detachedCells = [], i, cells, currentCell;
			if (rows.length > 0) {
				for (i = 0; i < rows.length; i++) {
					cells = cellSelectorFunction(rows.eq(i));
					currentCell = cells.eq(position);
					if (cells.length === 1) {
						currentCell.after(
							$("<" + currentCell[0].tagName + "></" + currentCell[0].tagName + ">")
								.attr("data-hiddenreplacement", "true")
								.css("height", currentCell.height())
								.attr("class", currentCell.attr("class"))
						);
					}
					detachedCells.push(currentCell.detach());
				}
				container[key] = detachedCells;
			}
		},
		_showMultiHeaderCells: function (key) {
			var i, currentCell = this._hiddenColumns[key],
				parents = this._getParentsMultiHeader(key), parent, colspan, $th, currentOrder, order,
				headerCellsLength = this._headerCells.length,
				headersTable = this.headersTable().find('thead > tr'), isHidden;
			if (currentCell === null || currentCell === undefined) {
				return;
			}
			currentOrder = currentCell.data('data-mch-order');
			for (i = 0; i < headerCellsLength; i++) {
				order = this._headerCells[i].data('data-mch-order');
				if (currentOrder < order) {
					this._headerCells.splice(i, 0, currentCell);
					break;
				}
			}
			if (i === headerCellsLength) {
				this._headerCells.push(currentCell);
			}
			currentCell.css('display', '');
			currentCell.removeAttr('ishidden');
			if (parents.length > 0) {
				for (i = 0; i < parents.length; i++) {
					parent = parents[i];
					if (parent.level === 0) {
						continue;
					}
					$th = headersTable.find('th[data-mch-id=' + parent.identifier + ']');
					// in case of fixed column
					if ($th.length === 0) {
						$th = this.fixedHeadersTable()
							.find('thead > tr')
							.find('th[data-mch-id=' + parent.identifier + ']');
					}
					isHidden = $th.attr('ishidden') === '1';
					colspan = parseInt($th.attr('colspan'), 10);
					if (!isHidden) {
						$th.attr('colspan', ++colspan);
						parent.colspan = colspan;
					} else {
						$th.removeAttr('ishidden');
						$th.css('display', '');
						parent.hidden = false;
						parent.colspan = 1;
					}
				}
			}
		},
		_attachCells: function (rows, cellSelectorFunction, position, container, key) {
			var detachedCells, i, cells, replacementCell, storedKey;
			if (rows.length > 0) {
				if (this.options.virtualization === true || this.options.columnVirtualization === true) {
					// M.H. 5 April 2012 Fix for bug #104627
					detachedCells = container[key];
					//if we are using virtualization the column that needs to be attached may not be in the list
					//of detached columns as the headers are reused and because of that any column from the list can be attached
					// M.H. 5 April 2012 Fix for bug #104627
					if (detachedCells === null || detachedCells === undefined) {
						for (storedKey in container) {
							if (container.hasOwnProperty(storedKey)) {
								detachedCells = container[storedKey];
								delete container[storedKey];
								break;
							}
						}
					} else {
                        // M.H. 24 Jun 2013 Fix for bug #145301: Sorting on previously hidden column causes an error to be thrown when virtualization is enabled.
                        delete container[key];
                    }
				} else {
					detachedCells = container[key];
					delete container[key];
				}
				// M.H. 23 Jan 2012 Fix for bug #91738
				if (detachedCells === undefined || detachedCells === null) {
					return;
				}
				for (i = 0; i < rows.length; i++) {
					cells = cellSelectorFunction(rows.eq(i)).not("[data-hiddenreplacement=true]");
					if (position === 0) {
						if (cells.length === 0) {
							replacementCell = rows.eq(i).find("[data-hiddenreplacement=true]");
							replacementCell.after(detachedCells[i]);
							replacementCell.remove();
						} else {
							//append before the second element which is now at position 0
							cells.eq(0).before(detachedCells[i]);
						}
					} else {
						//append after the element before the current
						cells.eq(position - 1).after(detachedCells[i]);
					}
				}
			}
		},
		_cleanupTBody: function () {
			var tbody = this.element.children('tbody');
			if ($.ui.igGrid.speedupDOMCleanup === false) {
				tbody.empty();
			} else {
				if (tbody.children().length > 0) {
					this.element[0].removeChild(tbody[0]);
					tbody = $('<tbody></tbody>')
						.appendTo(this.element)
						.addClass(this.css.baseContentClass)
						.addClass(this.css.gridTableBodyClass)
						.addClass(this.css.recordClass);
				}
			}
			return tbody;
		},
		_captureInitiallyHiddenColumns: function () {
			//capture the columns that are hidden initially and mark them as visible
			//the grid should render as all columns are visible and adjust later if there are hidden ones
			this._initialHiddenColumns = $.grep(this.options.columns, function (column, index) {
				var hidden = column.hidden;
				column.hidden = false;
				return hidden;
			});
		},
		getUnboundValues: function (key) {
			/*
			Gets unbound values for the specified column key. If key is not specified returns all unboundvalues
			paramType="string" column key
			returnType="object" unbound values
			*/
			var res;
			if (key === undefined || key === null) {
				return this._unboundValues;
			}
			res = this._unboundValues[key];
			// M.H. 3 Sep 2012 Fix for bug #120188
			if (res === undefined || res === null) {
				if (this.getUnboundColumnByKey(key) !== null) {
					res = [];
				} else {
					res = null;
				}
			}
			return res;
		},
		setUnboundValues: function (key, values, removeOldValues) {
			/*
				Sets unbound values for the unbound column with the specified key. If removeOldValues is true then values(if any) for the unbound columns are re-set with the new values
				paramType="string" key of the unbound column
				paramType="array" array of values to be set on unbound values
				paramType="boolean" if true removes current unbound values(if any) for the specified column and apply the new ones specified in parameter values. Otherwise merge current values with the specified in parameter values
			*/
			// M.H. 9 Oct 2012 Fix for bug #123732
			var i, column = this.getUnboundColumnByKey(key), uVals, data, len, reRenderData = false;
			if (column && !column.formula) {
				uVals = column.unboundValues;
				if (removeOldValues) {
					column.unboundValues = values;
					data = this.dataSource.data();
					len = data.length;
					for (i = 0; i < len; i++) {
						if (data[i][key] !== null && data[i][key] !== undefined) {
							reRenderData = true;
							delete data[i][key];
						}
					}
					if (reRenderData) {
						this._renderData();
					}
				} else {
					len = values.length;
					if (uVals && uVals.length > len) {
						for (i = 0; i < len; i++) {
							column.unboundValues[i] = values[i];
						}
					} else {
						column.unboundValues = values;
					}
				}
			}
			// M.H. 26 May 2014 Fix for bug #172283: When the grid is bound to remote data source, sorting the grid duplicates the unbound vaues
			if (!this._hasInitialUnboundValues) {
				this._hasInitialUnboundValues = {};
			}
			this._hasInitialUnboundValues[key] = true;
			this._renderUnboundValues(values, key);
		},
		// M.H. 9 Oct 2012 Fix for bug #123732
		_renderUnboundValues: function (values, key, notToRender) {
			/*
				Sets unbound values for the unbound column with the specified key.
				paramType="number" array of values
				paramType="string" key of the unbound column
				paramType="bool" optional - when set to true only set values into the datasource without render them in the grid
			*/
			var i, data = this.dataSource.data(), dataLength = data.length, valuesLength = values.length,
				isToConvert = false, type = "string", pk = this.options.primaryKey, col, schema, pkVal;
			if (valuesLength === 0) {
				return;
			}
			// M.H. 20 Sep 2012 Fix for bug #121830
			col = this.getUnboundColumnByKey(key);
			if (col === null) {
				return;
			}
			if (this.dataSource && this.dataSource.schema) {
				if (col.dataType) {
					type = col.dataType;
					isToConvert = true;
					schema = this.dataSource.schema();
				}
			}
			if (pk === undefined) {
				pk = null;
			}
			// M.H. 4 Sep 2012 Fix for bug #120302
			for (i = 0; i < valuesLength; i++) {
				if (data[i] === undefined || data[i] === null) {
					break;
				}
				if (isToConvert) {
					// M.H. 13 Sep 2012 Fix for bug #120867
					if (pk === null) {
						pkVal = i;
					} else {
						pkVal = data[i][pk];
					}
					values[i] = schema._convertType(type, values[i], pkVal, key);
				}
				data[i][key] = values[i];
				// M.H. 10 Sep 2012 Fix for bug #120696
				this._addUnboundColumnValue(key, values[i], i);
			}
			// M.H. 9 Nov 2012 Fix for bug #126903
			if ((type === "bool" || type === "boolean") && valuesLength < dataLength) {
				for (i = valuesLength; i < dataLength; i++) {
					data[i][key] = schema._convertType(type, null, pkVal, key);
				}
			}
			// M.H. 10 Sep 2012 Fix for bug #120720
			if (this.options.virtualization === true || this.options.rowVirtualization === true) {
				this._scrollTo(0);
			}
			if (notToRender !== true) {
				this._renderColumnData(key, this.dataSource.dataView());
			}
		},
		getUnboundColumnByKey: function (key) {
			/*
			Returns an unbound column with the specified key. If not found returns null
			paramType="string" a column key
			returnType="object" a column definition
			*/
			if (this._unboundColumns === undefined ||
					this._unboundColumns === null ||
					this._unboundColumns.length === 0 ||
					key === null ||
					key === undefined) {
				return null;
			}
			var column = null;
			$.each(this._unboundColumns, function (ind, col) {
				if (col.key === key) {
					column = col;
					return false;
				}
			});
			return column;
		},
		_renderColumnData: function (key, values) {
			/*
			Render for the column with the specified key the array of values
			paramType="string" column key
			paramType="array" array of objects
			*/
			if (values.length === 0) {
				return;
			}
			var visibleColumns = this._visibleColumns(),
				grid = this,
				tdIndex,
				index,
				tds,
				column,
				ds,
				isToConvertToString = false,
				hasTemplate,
				temp;
			// M.H. 27 Aug 2012 Fix for bug #119756
			index = this._getVisibleIndexByKey(key);
			column = visibleColumns[index];
			hasTemplate = column.template && column.template.length > 0;
			// M.H. 5 Sep 2012 Fix for bug #120516
			if (column === undefined || column === null) {
				return;
			}
			isToConvertToString = (column.dataType === 'bool');
			if (hasTemplate) {
				ds = this.dataSource.dataView();
			}
			// M.H. 5 Sep 2012 Fix for bug #120501
			// M.H. 7 Sep 2012 Fix for bug #120615
			tdIndex = index + this.headersTable().find('>thead>tr:eq(0)>th[data-skip=true]').length;
			tds = this.element.find(">tbody> tr > td:not([data-skip]):nth-child(" + (tdIndex + 1) + ")");
			$.each(values, function (ind, val) {
				var innerHtml;
				// M.H. 4 Sep 2012 Fix for bug #120306
				if (val[key] === undefined) {
					return true;
				}
				if (hasTemplate) {
					// M.H. 6 Sep 2012 Fix for bug #119627
					temp = grid._renderTemplatedCell(ds[ind], column);
					if (temp.indexOf("<td") === 0) {
						innerHtml = $(temp).html();
					} else {
						innerHtml = temp;
					}
				} else {
					innerHtml = grid._renderCell(val[key], column, val);
					// M.H. 1 Nov 2012 Fix for bug #126258
					if (isToConvertToString === true) {
						innerHtml = innerHtml.toString();
					}
				}
				if (!tds[ind]) {
					// break;
					return false;
				}
				$(tds[ind]).html(innerHtml);
			});
		},
		_renderData: function (success, errmsg, response) {
            //L.A. 22 March 2012 Bug 102502 - The dataBound event is fired before the grid's dataSource has any data (regardless if local or remote)
            // M.H. 26 Mar 2013 Fix for bug #126556: DataBound event is fired twice after GroupBy when explicitly invoking "dataBind" method
            if (!(this._isDataBoundCalled === true && success === undefined) || success !== undefined) {
                this._trigger(this.events.dataBound, null, {owner: this});
                this._isDataBoundCalled = false;
            }
			var gridElement = this.element,
				self = this,
				noCancel = true,
				sum = 0,
				cols,
				colsToUnbound,
				colsLength,
				data,
				key,
				j, i, f,
				diff = 0,
				isTable = false,
				noCancelError = true,
				isRemoteDS = (this._inferOpType() === "remote"),
				ucFormulaFunction,
                tbody,//gridElement.find('tbody')
				newW,
                totalWidth,
                isToRefreshUI = false,
				jsrnd = String(this.options.templatingEngine).toLowerCase() === "jsrender",
				displayCont;
			// M.H. 1 Oct 2012 Fix for bug #123198
			// M.H. 6 Nov 2012 Fix for bug #120553
			if ((this.options.requiresDataBinding === true || this._isToSetUnboundColumns === true || isRemoteDS) && this._hasUnboundColumns) {
				this._isToSetUnboundColumns = false;
				// M.H. 22 Jan 2013 Fix for bug #130586
				if (this._hasInitialUnboundValues === null || this._hasInitialUnboundValues === undefined) {
					this._hasInitialUnboundValues = {};
				}
				// M.H. 7 Sep 2012 Fix for bug #120553
				// M.H. 12 Sep 2012 Fix for bug #121028
				//if (this.options.requiresDataBinding === true || this._inferOpType() === "remote") {
				// M.H. 12 Sep 2012 Fix for bug #121019
				cols = this.options.columns;
				colsLength = cols.length;
				data = this.dataSource.data();
				ucFormulaFunction = function (data, f, col) {
					$.each(data, function (ind, val) {
						// M.H. 25 Apr 2014 Fix for bug #170559: Context of unbound formula function is the Window, as opposed to the Column object
						val[key] = f.apply(col, [val, gridElement]);
					// M.H. 10 Sep 2012 Fix for bug #120696
					self._addUnboundColumnValue(key, val[key], ind);
					});
				};
				colsToUnbound = [];
				// M.H. 6 Nov 2012 Fix for bug #120553
				if (isRemoteDS) {
					this._unboundValues = {};
				}
				for (i = 0; i < colsLength; i++) {
					if (cols[i].unbound === true) {
						key = cols[i].key;
						// M.H. 22 Jan 2013 Fix for bug #130586
						if (cols[i].unboundValues !== null &&
								cols[i].unboundValues !== undefined &&
								$.type(cols[i].unboundValues) === 'array') {
							// M.H. 23 Jan 2013 Fix for bug #130586
							if (this._rebindUnboundColumns === true ||
									(cols[i].unboundValues.length > 0 &&
									this._hasInitialUnboundValues[key] === undefined)) {
								this._hasInitialUnboundValues[key] = true;
								this._renderUnboundValues(cols[i].unboundValues, key, true);
							}
						} else if (cols[i].formula !== null && cols[i].formula !== undefined) {
							f = null;
							if ($.type(cols[i].formula) === "function") {
								f = cols[i].formula;
							} else if (window[cols[i].formula] && typeof window[cols[i].formula] === 'function') {
								f = window[cols[i].formula];
							}
							if (f) {
								// M.H. 25 Apr 2014 Fix for bug #170559: Context of unbound formula function is the Window, as opposed to the Column object
								ucFormulaFunction(data, f, cols[i]);
							}
						} else if (this._unboundValues[key] && this._unboundValues[key].length > 0) {
							colsToUnbound.push(key);
						}
					}
				}
				// M.H. 16 Apr 2014 Fix for bug #169743: Unbound values are duplicated for columns with empty cells after data binding and sorting any column
				this._rebindUnboundColumns = false;
				//}
				if (this.options.localSchemaTransform === true && colsToUnbound.length > 0 && data.length > 0) {
					for (i = 0; i < colsToUnbound.length; i++) {
						key = colsToUnbound[i];
						if (data[0][key] === undefined) {
							this._renderUnboundValues(this._unboundValues[key], key);
						}
					}
				}
				if (this.options.mergeUnboundColumns === false) {
					this._mergeUnboundValues();
				}
			}
			if (success === false) {
				// check if there is an event requestError defined
				noCancelError = this._trigger(this.events.requestError, null, { owner: this, message: errmsg, response: response });
				// if the handler returns false or doesn't return anything, the error will be propagated to teh grid and an Error object will be returned
				if (noCancelError) {
					throw new Error(errmsg);
				}
			}
			if (this._cancelRendering === true) {
				this._cancelRendering = false;
				return;
			}
			this.element.trigger('iggriduisoftdirty', {owner: this});
			// K.D. November 21st, 2012 Bug #127250 The auto-generated columns are not generated when the 'dataRendering' 
			// event is fired and autoGenerateColumns = TRUE
			// Making the columns collection as well as the features available before dataRendering starts
			if (!this._initialized) {
				// auto generate the columns collection, if options.autogenerateColumns is true
				if (this.options.autoGenerateColumns === true) {
					this._generateColumns();
					// M.H. 3 Sep 2013 Fix for bug #146575: Horizontal bar is missing when autoGenerateColumns = true and columnVirtualization = true
					if ((this.options.virtualization === true || this.options.columnVirtualization === true) &&
							this.options.width) {
						totalWidth = this._calculateContainerWidth(false);
						if (totalWidth > parseInt(this.options.width, 10) &&
								$('#' + this.id() + '_horizontalScrollContainer').children().length === 0) {
							this._renderHorizontalScrollContainer(totalWidth);
						}
					}
					// reinitialize all features
					for (i = 0; i < this.options.features.length; i++) {
						this._initFeature(this.options.features[i], this._dataOptions);
					}
				}
			}
			tbody = gridElement.children('tbody');
			noCancel = this._trigger(this.events.dataRendering, null, {owner: this, tbody: tbody});
			if (noCancel) {
				// show loading indicator
				//this.options.dataSource = this.dataSource.dataView();
				// generate and render markup on the client 
				// reset virtualization buffer
				/* jQuery's empty() will try to find all handlers, etc. which is very slow. On the other hand if we don't use a similar approach
					and just remove the tbody, there will be memory leaks (inherent in Firefox and IE by design). 
					tbody.innerHTML="" won't work for IE ! since it's read only for many types of DOM elements, including TBODY ! 
				*/
				//if (this.options.jQueryTemplating === true) {
				if (!(this.options.dataSource && this.options.dataSource.tagName && $(this.options.dataSource).is('table'))) {
					tbody = this._cleanupTBody();
				} else {
					isTable = true;
				}
				//}
				this._virtualDom = null;
				if (!this._initialized) {
					// auto generate the columns collection, if options.autogenerateColumns is true
					if (this.options.autoGenerateColumns === true) {
						//A.Y. bug 98100. When the grid's columns are autogenerated we need to first
						//receive the data, generate the columns, init features(hiding sets the hidden option there)
						//and then capture the initially hidden columns
						this._captureInitiallyHiddenColumns();
						// M.H. 13 Aug 2012 Fix for bug #118837 - re-initialize _visibleColumnsArray
						this._visibleColumnsArray = undefined;
						//A.Y. Bug 98593. We need to calculate the virtual column counters after the columns are generated.
						this._updateVirtColCounters();
					}
					if (isTable) {
						// now clean up the TABLE
						tbody.empty();
					}
					//A.T. 20 Dec. 2011 - fix for bug #98209
					// M.H. 10 May 2012 Fix for bug #108221 - renderHeader should be called only 1 time
					if (this._renderHeaderCalled !== true) {
						this._renderHeader();
						this._renderCaption();
					/* L.A. 20 June 2012 - Fixed bug #113607 When the grid has defined width less than the sum of its columns' 
						widths and showHeader = FALSE, the grid is rendered without a horizontal scrollbar 
					*/
					} else {
						if (this.options.width !== null && this.options.height === null) {
							this.scrollContainer().css('overflow-y', 'hidden').css('overflow-x', 'auto');
						}
					}
					// A.T. 21 Feb 2012 - Fix for #102322 - when we destroy the grid, we don't remove the whole colgroup
					if (this.element.find('colgroup').length === 0 || this.element.find('colgroup').children().length === 0) {
						this._renderColgroup(this.element[0], false, false, this.options.autofitLastColumn);
					}
					this._renderFooter();
				}
				this._trigger("dataEmpty", null, {owner: this, tbody: tbody});
				if (this.options.autoGenerateColumns === false && ((this.options.columns && this.options.columns.length === 0) || !this.options.columns)) {
					throw new Error($.ig.Grid.locale.noColumnsButAutoGenerateTrue);
				}
				this._tmplWrappers = jsrnd ? $.render : {};
				this._setTemplateDefinition(jsrnd);
				// A.Y. skip rendering if the grid has columns that have to be hidden
				// the data will be rendered after the hiding
				if (this._initialHiddenColumns === undefined || this._initialHiddenColumns.length === 0) {
					//A.T. 12 Feb - Fix for bug #65676 - Grid autogenerates columns when the columns are not defined and autoGenerateColumns = false
					if (this.options.columns.length > 0) {
						if (this.options.virtualization === true || this.options.rowVirtualization === true || this.options.columnVirtualization === true) {
							this._scrollContainer()[0].scrollTop = 0;
							this._renderVirtualRecords();
						} else {
							this._renderRecords();
						}
						if (this._initialized) {
							//this case is happending when we change the page in the paging feature
							this._adjustLastColumnWidth(false);
							if (this.options.width !== null && this.options.height !== null) {
								//A.Y. Bug 99817. In some browsers after _renderData is called and the tbody
								//is cleared and records rerendered the scrollLeft of the header and footer may become incorrect
								this._synchronizeHScroll();
							}
						} else {
							//A.Y. Bug 97395. If we have height we need to initializeHeights before the
							//call to _adjustLastColumnWidth as in some cases the grid incorrectly determines
							//that there should be no vertical scrollbar when there should be
							if (this.options.height !== null && this.options.autoAdjustHeight) {
								this._initializeHeights();
							}
							this._adjustLastColumnWidth(true);
						}
					}
				}
				// adjust scrolling grid height
				if (!this._initialized) {
					if (this.options.autoAdjustHeight) {
						this._initializeHeights();
					}
				}
				if (this._initialHiddenColumns !== undefined && this._initialHiddenColumns.length > 0) {
					this._setHiddenColumns(this._initialHiddenColumns, true, true);
					// M.H. 18 July 2012 Fix for bug #113972
					if (this._initialHiddenCells !== undefined && this._initialHiddenCells.length > 0) {
						$.each(this._initialHiddenCells, function (index, cell) {
							cell.css('display', '');
						});
					}
					// M.H. 15 Sep 2012 Fix for bug #105514
					$.each(this._initialHiddenColumns, function (index, column) {
						column._initiallyHidden = true;
					});
					this._initialHiddenCells = undefined;
					this._initialHiddenColumns = undefined;
                    // M.H. 15 Oct 2013 Fix for bug #154942: When Summaries are enabled and there is initially hidden column the grid does not have the correct height and the headers are misaligned in Firefox.
                    // M.H. 15 Aug 2013 Fix for bug #149165: Hidden columns do not affect visible columns' width in Firefox
                    // In FireFox the grid should be "re-rendered" - e.g. hidden/shown so the columns to be with proper width and hidden column to not take additional space
                    // M.H. 22 Oct 2013 Fix for bug #155548: When the grid does not have width and a column is hidden through columnSettings the grid is misaligned in firefox
                    if ($.ig.util.isFF) {
//						this._refreshUI();
                        isToRefreshUI = true;
                    }
				}
				// M.H. 27 April 2012 Fix for bug #108522 - it should be called datarendered after SetHidden columns is called
				this._registerAdditionalEvents();
				this._trigger(this.events.dataRendered, null, {owner: this});
                // M.H. 3 Jul 2013 Fix for bug #144681: Scrollbar misbehaves when there’s a small number of records.
                this._updateVirtualScrollContainer();
                this._fireInternalEvent("_dataRendered");
				if (this._loadingIndicator === undefined) {
					this._initLoadingIndicator();
				}
				this._loadingIndicator.hide();
			}
			if (this._fixScrollY) {
				this.scrollContainer().css('overflow-y', this.rows().length > 1 ? 'hidden' : 'visible');
			}
            //A.T. 2 March 2012 - fix for bug #99081 
			// the grid doesn't have a width, but such has been set on the container, which means columns have widths
			// M.H. 23 March 2012 Fix for bug #105213
			if (this.options.width === null && this.container()[0] && this.container()[0].style.width) {
				cols = this.element.find("colgroup > col[data-skip]");
				if (cols.length > 0) {
					for (j = 0; j < cols.length; j++) {
						// A.T. 30 March Fix for bug #105039
						sum += parseInt(cols[j].style.width, 10);
					}
				}
				if (!this._origSum) {
					this._origSum = 0;
				}
				diff = sum - this._origSum;
				if (diff < 0) {
					diff = 0;
				}
				newW = parseInt(this.container()[0].style.width, 10) + diff;
                //A.T. 11 April - Fix performance issue - doing something.width() is a very expensive operation (because of what jQuery does under the hood)
				this.container().css("width", newW);
				//S.S. 10 May 2012 - in virtual grids there are more containers to be resized
				displayCont = this._vdisplaycontainer();
				if (displayCont.length > 0) {
					displayCont.css("width", newW - this._scrollbarWidth()).css("max-width", newW - this._scrollbarWidth());
					// resize header and footer due to cont virtualization
					this.container().find("#" + this.id() + "_headers_v").css("width", newW);
					this._fixedfooters().css("width", newW);
				}
				this._origSum = sum;
			}
			// scenarios where the first load is sending JSON, but the second time we are actually making an AJAX request (MVC for example)
			if (this.options.dataSourceUrl !== null && this._firstBind) {
				this.options.dataSource = this.options.dataSourceUrl;
				this.dataSource.settings.dataSource = this.options.dataSourceUrl;
				this.dataSource.settings.type = "remoteUrl";
				this.dataSource._runtimeType = this.dataSource.analyzeDataSource();
				this._firstBind = false;
				//A.T. 26 July 2011
                // M.H. 2 Oct 2013 Fix for bug #153207: Javascript error: There was an error parsing/evaluating the JSON string: Invalid character occurs when RollBack is performed
                // Check also bug #139006: dataSourceType should be set explicitly when invoke dataBind with remote operations
				// M.H. 9 Oct 2013 Fix for bug #154309: Child remote operations don't work on first load
                // on hierarchical grid when we have paging and load on demand is false then paging is not properly shown for child layouts
                // this is done because dataSourceType is set to json and this option is common for the whole grid and setting it to remoteUrl will affect parsing dataSource and will ignore totalRecordsCount
				//this.options.dataSourceType = "remoteUrl";
			}
			if (!this._initialized) {
				this._trigger(this.events.rendered, null, {owner: this});
				// is this grid an hierarchical container or not
				this._hc = this.container().find('.ui-iggrid-expandheadercell').length > 0;
				this._initialized = true;
                // M.H. 11 Feb 2013 Fix for bug #131558
                if (document.documentMode === 7 || $.ig.util.isIE7) {
                    $.each($('#' + this.id() + '_container colgroup col'), function () {
                        var $col = $(this), styleWidth = parseInt(this.style.width, 10), width = $col.outerWidth();
                        if (styleWidth && styleWidth < width) {
                            $col.width(2 * styleWidth - width);
                        }
                    });
                }
			}
            // M.H. 22 Oct 2013 Fix for bug #155548: When the grid does not have width and a column is hidden through columnSettings the grid is misaligned in firefox
            if (isToRefreshUI) {
                this._refreshUI();
            }
			this._fireInternalEvent("_gridRendered", this.container());
		},
        // M.H. 15 Aug 2013 Fix for bug #149344: When the grid has multi-column headers, the columns do not have widths and the height is defined hiding a column misaligns the grid.
        _refreshUI: function () {
            var self = this;
            // M.H. 15 Aug 2013 Fix for bug #149165: Hidden columns do not affect visible columns' width in Firefox
            // In FireFox(versions 22, 23) the grid should be "re-rendered" - e.g. hiding/showing container. In cases like bug 149615 and 149242
            self.container().hide();
            setTimeout(function () {
                self.container().show();
            }, 0);
        },
        _updateVirtualScrollContainer: function () {
            // update virtual scroll container(if there is no need of scroll e.g. all rows are visible in display container then it should not be scrollable)
            // M.H. 19 Jun 2013 Fix for bug #144681: Scrollbar misbehaves when there’s a small number of records.
            var headersHeight = 0;
			this._totalRowCount = this._getTotalRowCount();
			if ((this.options.virtualization || this.options.rowVirtualization) &&
					this._totalRowCount) {
				/*
                if (this.options.virtualizationMode === "fixed") {
                    avgRowHeight = this._calculateAvgRowHeight();
                    if  (parseInt(this.options.avgRowHeight, 10) - avgRowHeight > 1) {
                        this._scrollContainer().find('div').height(this._totalRowCount * avgRowHeight);
                    }
                }
				*/
				if (this._avgRowHeight === undefined || this._avgRowHeight === null) {
					this._avgRowHeight = this._calculateAvgRowHeight();
				}
				if (this.options.showHeader) {
					headersHeight = this.headersTable().height();
				}
                //if (this._avgRowHeight) {
                    // M.H. 12 Jun 2013 Fix for bug #144009: With continuous virtualization rows fill the height of the grid
                    // we should not call initializeHeights twice
                // M.H. 18 Jul 2013 Fix for bug #146756: On deleting a row, the rows shrink their height and occupy only 50% of the grid's height and Average row height doesnot get applied
				if  (this._totalRowCount * this._avgRowHeight <= parseInt(this.options.height, 10) - headersHeight) {
					this.element.height("");
					// continuous virtualization doesn't add .ui-iggrid-virtualrow
					if (this.options.virtualizationMode === "fixed") {
                        this.element.find(".ui-iggrid-virtualrow").height(this._avgRowHeight);
                    }
                    // M.H. 28 Feb 2014 Fix for bug #164139: IGGrid virtualScrollTo doesn't seem to be reliable for fixed and continuous virtualization
                    this._setScrollContainerHeight(this._totalRowCount * this._avgRowHeight);
				} else {
                    //A.T.
					this.element.height(this._initialVirtualHeight);
                    if (this.options.virtualizationMode === "continuous") {
						// M.H. 28 Feb 2014 Fix for bug #164139: IGGrid virtualScrollTo doesn't seem to be reliable for fixed and continuous virtualization
                        // M.H. 22 Jul 2013 Fix for bug #146756: On deleting a row, the rows shrink their height and occupy only 50% of the grid's height and Average row height doesnot get applied
                        this._setScrollContainerHeight(this._totalRowCount * this._avgRowHeight);
                    }
				}
            }
        },
		// returns true if any of the columns have a template set
		_hasColumnTemplates: function () {
			var i, hasTemplates = false, t;
			for (i = 0; i < this.options.columns.length; i++) {
				t = this.options.columns[i].template;
				if (t !== null && t !== undefined && t !== "" && t.length > 0) {
					hasTemplates = true;
					break;
				}
			}
			return hasTemplates;
		},
		_gridHasWidthInPixels: function () {
			if (typeof this.options.width === 'string' && this.options.width.indexOf('%') !== -1) {
				return false;
			}
			return parseInt(this.options.width, 10) > 0;
		},
		_gridHasWidthInPercent: function () {
			if (typeof this.options.width === 'string' && this.options.width.indexOf('%') !== -1) {
				return true;
			}
			return false;
		},
		_adjustLastColumnWidth: function (colgroupsRerendered) {
			// if fixed headers is enabled, we need to make sure the last column's width is adjusted appropriately
			// we have to do this here, because we don't know if we need a scroll bar or not, before data is actually rendered
			// if colgroupsRerendered is true this function should always be called 
			// after a corresponding call to renderColgroup as there are fields than need to be calculated there
			var grid = this,
				hasFixedHeader = this.options.height !== null && this.options.fixedHeaders === true && this.options.showHeader && this._headerParent,
				hasFixedFooter = this.options.height !== null && this.options.fixedFooters === true && this.options.showFooter && this._footerParent,
				hasHeight = this.options.height && parseInt(this.options.height, 10) > 0,
				hasWidthInPixels = this._gridHasWidthInPixels(),
				hasWidthInPercent = this._gridHasWidthInPercent(),
				hasVirtualization = this.options.virtualization === true || this.options.columnVirtualization === true || this.options.rowVirtualization === true,
				gridWidth,
				specialColumnsWidth;
			if (hasHeight && !hasVirtualization) {
				// A.T. the below line is very slow on IE. Therefore we need to do some magic to avoid reflow, which will be caused
				// by calling height() on the various elements which have many children. height() just calls offsetHeight, which is a performance killer on IE9
				// when invoked on elements with many children 
				if ((this.options.autoAdjustHeight && this.element.height() <= this.scrollContainer().height()) ||
						(!this.options.autoAdjustHeight && this.options.avgRowHeight * this.element[0].rows.length < parseInt(this.options.height, 10))) {
					this._hasVerticalScrollbar = false;
				} else {
					this._hasVerticalScrollbar = true;
				}
			}
			if (colgroupsRerendered) {
				if (hasVirtualization) {
					if (hasFixedHeader) {
						this._headerParent.css(this._padding, this._scrollbarWidth());
					}
					if (hasFixedFooter) {
						this._footerParent.css(this._padding, this._scrollbarWidth());
					}
				}
				if (hasWidthInPixels || hasWidthInPercent) {
					if (this._allColumnWidthsInPixels) {
						gridWidth = this._totalColPixelWidth;
						//take the special columns widths into account
						specialColumnsWidth = this._calculateSpecialColumnsWidth();
						if (specialColumnsWidth > 0) {
							if (this._autoadjustedColumn && this._lastColPixelWidth) {
								//if the last column was autofited we should substract the
								//special columns width from its width
								// S.S. May 18, 2012 We need to check if the autoadjustedcolumn was not expanded 
								// for a smaller amount than what comes from special columns
								if (this._autoadjustedColumn.difference < specialColumnsWidth) {
									this._lastColPixelWidth -= this._autoadjustedColumn.difference;
									gridWidth -= this._autoadjustedColumn.difference - specialColumnsWidth;
								} else {
									this._lastColPixelWidth -= specialColumnsWidth;
								}
								this._autoadjustedColumn.width = this._lastColPixelWidth;

								if (hasFixedHeader) {
									this._lastHeaderCol.css('width', this._lastColPixelWidth + 'px');
								}
								if (hasFixedFooter) {
									this._lastFooterCol.css('width', this._lastColPixelWidth + 'px');
								}
								this._lastDataCol.css('width', this._lastColPixelWidth + 'px');
							} else {
								gridWidth += specialColumnsWidth;
							}
						}
						/* L.A. 05 June 2012. Fixing bug #113545 When grid's width is bigger than the sum of column widths 
						and fixedHeaders=false the hidding icon of the last column is not visible.
							L.A. 16 October 2012 - Fixing bug #123050 When showHeader = FALSE and the has a vertical and 
							horizontal scrollbars, the last column is 17 pixels less wide than expected
							L.A. 24 October 2012 - Fixing bug #118440 When grid's width = 100%, every column's width is set 
							in pixels and the page has vertical scrollbar there is an unnecessary vertical scrollbar.
							*/
						// M.H. 8 Nov 2012 Fix for bug #126666
						if (!hasFixedHeader && this._gridWidthGTColWidth && this._hasVerticalScrollbar) {
							gridWidth -= this._scrollbarWidth();
							this._lastColPixelWidth -= this._scrollbarWidth();
							this._lastDataCol.css('width', this._lastColPixelWidth + 'px');
						}
					} else if (this._allColumnWidthsInPercentage) {
						gridWidth = this.container().width();
						specialColumnsWidth = this._calculateSpecialColumnsWidth();
						if (this._allSpecialColumnsInPercentage() === true && specialColumnsWidth > 0) {
							this._lastColPercentWidth = this._lastColPercentWidth - specialColumnsWidth;
						}
						this._lastDataCol.css('width', this._lastColPercentWidth + '%');
						if (hasFixedHeader) {
							this._lastHeaderCol.css('width', this._lastColPercentWidth + '%');
						}
						if (hasFixedFooter) {
							this._lastFooterCol.css('width', this._lastColPercentWidth + '%');
						}
					} else if (hasWidthInPixels) {
						gridWidth = parseInt(grid.options.width, 10);
					} else if (hasWidthInPercent) {
						gridWidth = this.container().width();
					}

					if (!this._allColumnWidthsInPercentage || !hasWidthInPercent) {
						if (hasVirtualization === false) {
							this._gridInnerWidth = this.scrollContainer().width();
						} else {
							this._gridInnerWidth = //this.element.width() + this._scrollbarWidth();
								this._vdisplaycontainer().width() + this._scrollbarWidth();
						}
						// M.H. 17 May 2013 Fix for bug #140364: Text is covered over by the scroll bar when text is right aligned
                        // in Chrome width of the cell is not calculated properly in this case(width is not set for the cols) and padding is not properly set
                            // M.H. 12 Nov 2012 Fix for bug #127037
                            grid._setGridContentWidth(gridWidth);
                        }
					}
			} else {
				// even if columns are not rerendered we need to adjust the size of the horizontal 
				// scrollbar as this is called when height is adjusted which might render a vertical
				// scrollbar it wasn't taken into account in previous calculations.
				this._setGridContentWidth();
			}
			if (hasHeight && !hasVirtualization) {
				if (this.options.width !== null && this.options.height !== null) {
					if (this._hasVerticalScrollbar) {
						this._hscrollbarcontent().css('overflow-y', 'scroll');
					} else {
						this._hscrollbarcontent().css('overflow-y', 'hidden');
					}
				}
				if ((this._allColumnWidthsInPercentage && hasWidthInPercent) ||
						!(hasWidthInPixels || hasWidthInPercent)) {
					//if the grid has vertical scrollbar and no width or width in percent
					//and column widths in percent we should add padding
					//to the header and footer tables to align the columns properly
					if (this._hasVerticalScrollbar) {
						if (hasFixedHeader) {
							this._headerParent.css(this._padding, this._scrollbarWidth());
						}
						if (hasFixedFooter) {
							this._footerParent.css(this._padding, this._scrollbarWidth());
						}
					} else {
						if (hasFixedHeader) {
							this._headerParent.css(this._padding, '');
						}
						if (hasFixedFooter) {
							this._footerParent.css(this._padding, '');
						}
					}
				} else {
					//in all other casese the scrollbar is inside the last data column
					//and we need to add padding in the header/footer cells to align the icons
					//such that they do not go over the vertical scrollbar
					this._updateVerticalScrollbarCellPadding();
				}
			}
		},
		_initializeHeights: function () {
			// A.T. 6 April 2011 - changing this logic so that it's executed async in the background. This is just for re-setting the proper height of the scroll container,
			// in case there are other elements that take up space, such as paging footers, filter summaries, etc. 
			// with this approach , including setting overflow hidden to the container, and initializing the scroll container with the height of its parent, we don't get
			// the nasty visual flickerings and resetting of the scrollbar
			var initialHeight, hscrollerContainerHeight;
			if (this.options.height === null || this.options.height === undefined) {
				return;
			}
			initialHeight = parseInt(this.options.height, 10);
            if (this.hasFixedColumns()) {
                // check whether has fixed header
                if (this.options.showHeader && this.options.fixedHeaders === true && this.options.height !== null) {
                    initialHeight -= this.fixedHeadersTable().height();
                }
                hscrollerContainerHeight = this._hscrollbar().height();
                if (this.fixedBodyContainer().height() < initialHeight + hscrollerContainerHeight) {
                    initialHeight -= hscrollerContainerHeight;
                }
            }
			if (this.options.height.indexOf && this.options.height.indexOf('%') !== -1) {
				this.scrollContainer().height('100%');
			} else {
				this.scrollContainer().height(initialHeight);
			}
			//	setTimeout($.proxy(this._initializeHeightsInternal, this), 1);
			//} else {
			this._initializeHeightsInternal();
			//}
		},
		_initializeHeightsInternal: function () {
			var children, height, i, $child, ch, heightChanged = false, dc = this._vdisplaycontainer(),
				sc = this._scrollContainer();
			ch = this.container().height();
			this._prevContainerHeight = ch;
			if (this.options.height !== null) {
				children = this.container().children(':visible');
				height = 0;
				for (i = 0; i < children.length; i++) {
					$child = $(children[i]);
					// also check for the "excludeFromHeight" attribute. Such elements are filter dropdowns, which are children of the grid container
					// and may appear visible once they are open, but we don't want to include them in any calculations
                    // M.H. 28 Feb 2013 Fix for bug #134435: When height is set and column is fixed changing the page changes grid's height and the horizontal scrollbar is not on the correct place
					if ((($child.attr('id') !== undefined && !$child.attr('id').endsWith('_scroll') && !$child.attr('data-fixed-container') &&
							!$child.attr('id').endsWith('_virtualContainer') &&
							!$child.attr("id").endsWith("_loading")) || !$child.attr('id')) && $child.is(':visible') &&
							$child.data('efh') !== '1') {
						// the caption's table shows height of 0 on all browsers ! 
						if ($child.is('table') && $child.children().first().is('caption')) {
							height += $child.children().first().outerHeight();
						} else {
                            if ($child.css('position') !== 'absolute') {
							height += $child.outerHeight();
						}
					}
				}
				}
				if (height > 0) {
                    // M.H. 7 Mar 2014 Fix for bug #147490: The "Search Result" span is relocated when column is fixed and you filter the grid in Chrome.
					this._trigger("_heightChanging", null, { ch: ch, h: height });
					this.scrollContainer().height(ch - height);
					heightChanged = true;
				}
				// if there is virtualization, also adjust its containers accordingly
				if (this.options.virtualization || this.options.rowVirtualization) {
                    // exclude headers & footers (if any)
					// M.H. 9 Apr 2013 Fix for bug #139223: When virtualization is enabled the grid starts expanding its height.
                    if (($.type(this.options.height) === 'string' && this.options.height.indexOf('%') !== -1) || ch !== parseInt(this.options.height, 10)) {
                        this.container().height(this.options.height);
                        if ($.type(this.options.height) === 'string' && this.options.height.indexOf('%') !== -1) {
                            ch = parseInt(this.container().height(), 10);
                        }
                    }
					height += this.container().find('#' + this.id() + '_headers_v').outerHeight();
					height += this.container().find('#' + this.id() + '_footers_v').outerHeight();
                    // M.H. 24 Jun 2013 Fix for bug #145329: When virtualization is enabled gridVirtual container is bigger than grid container, because it includes scrollbars in its height
                    height += this._fixedfooters().outerHeight();
                    height += this._vhorizontalcontainer().outerHeight();
					if (!this._virtualHeightReset) {
						height = height * 2;
						this._virtualHeightReset = true;
					}
					if (height > 0 && dc.height() !== ch - height) {
                        // we should not call it twice
						// M.H. 7 Mar 2014 Fix for bug #147490: The "Search Result" span is relocated when column is fixed and you filter the grid in Chrome.
						if (!heightChanged) {
							this._trigger("_heightChanging", null, { ch: ch, h: height });
						}
						dc.height(ch - height);
						sc.height(ch - height);
                        this.element.height(ch - height);
						this._initialVirtualHeight = ch - height;
                        // M.H. 12 Mar 2014 Fix for bug #166434: VirtualScrollTo inconsistent with pixels input and fixed virtualization
						//this._virtualDom = null;
                        // M.H. - calling renderVirtualRecords causes js error and breaks the whole grid
                        //this._renderVirtualRecords();
						heightChanged = true;
					}
				}
				if (heightChanged) {
					this._trigger("_heightChanged", null, {ch: ch, h: height});
				}
			}
		},
		_registerAdditionalEvents: function () {
			var css = 'ui-state-hover',
				topmostGrid = this.element.closest('.ui-iggrid-root').data('igGrid') || this;
			if (this.options.enableHoverStyles) {
				// M.P.: 26 July 2013: Fix for bug:145783 - Memory leak on rebind grid multiple times
				if (this._hovEvts) {
					this.element.unbind(this._hovEvts);
				}
				this._hovEvts = {
					mousemove: function (e) {
						var par, tag, tr = e.target;
						while (tr) {
							par = tr.parentNode;
							tag = tr.nodeName;
							if (tag === 'TR' && par.nodeName === 'TBODY') {
								break;
							}
							tr = (tag === 'TABLE') ? null : par;
						}
						if (_hovTR !== tr) {
							// A.T. data-container=true => child row container. don't hover such rows. 
							if (_hovTR && $(_hovTR).attr('data-container') !== "true") {
								$('td', _hovTR).removeClass(css);
							}
							//I.I. bug fix for 100872 (if virtualization is on for child grid, hovering the scroller should not hover all the child grid's tds
							if (tr && $(tr).attr('data-container') !== "true" &&
									e.target.id.indexOf('_scrollContainer') === -1 &&
									e.target.parentNode.id.indexOf('_scrollContainer') === -1) {
								if (!topmostGrid._cancelHoveringEffects) {
									$('td', tr).addClass(css);
								}
							}
							_hovTR = tr;
						}
					},
					mouseleave: function (e) {
						if (_hovTR) {
							$('td', _hovTR).removeClass(css);
							_hovTR = null;
						}
					}
				};
				this.element.bind(this._hovEvts);
			}
		},
		_renderColgroup: function (table, isHeader, isFooter, autofitLastColumn) {
			var colgroup, hasFixedColumns = this.hasFixedColumns(),
				i, lc,
				cols = this._visibleColumns(),
				defWidth = this.options.defaultColumnWidth,
				totalColWidth = 0,
				totalGridWidth,
				hasWidthInPixels = this._gridHasWidthInPixels(),
				hasWidthInPercent = this._gridHasWidthInPercent(),
				hasWidth = hasWidthInPixels || hasWidthInPercent,
				hasVirtualization = this.options.virtualization === true || this.options.columnVirtualization === true || this.options.rowVirtualization === true,
				//I.I. bug fix for 107132
				hasColumnVirtualization = (this.options.virtualization === true && this.options.virtualizationMode === 'fixed') || this.options.columnVirtualization === true,
				hasColumnsWithNoWidth = false,
				isPercentage = true,
				desiredColWidth,
				desiredColWidthNumber,
				lastCol,
				lastColWidth,
				difference;
			// we render colgroup if there are columns defined and autoGenerateColumns is false
			colgroup = $(table).find('colgroup');
			if (colgroup.length === 0) {
				colgroup = $("<colgroup></colgroup>").prependTo(table);
			}
			// if we use virtualization we need cols just for the number of visible columns
			// M.H. 10 April 2012 Fix for bug #107566
			if ((hasVirtualization && this.options.virtualizationMode === 'fixed') || hasColumnVirtualization) {
				this._updateVirtColCounters();
				cols = cols.slice(0, this._virtualColumnCount);
			}
			for (i = 0; i < cols.length; i++) {
				if (cols[i].fixed) {
					continue;
				}
				if (cols[i].width) {
					// M.H. 16 Dec 2013 Fix for bug #154835: In Internet Explorer 8 when the grid has 100% width,  filtering is enabled and a column is hidden there is a blank space on the right of the grid.
					if (cols[i].oWidth) {
						desiredColWidth = cols[i].oWidth;
					} else {
						desiredColWidth = cols[i].width;
					}
				} else {
					desiredColWidth = defWidth;
					cols[i].width = defWidth;
				}
				if (desiredColWidth) {
					if (!desiredColWidth.charAt || !desiredColWidth.endsWith('%')) {
						isPercentage = false;
					}
					desiredColWidthNumber = parseInt(desiredColWidth, 10);
					if (desiredColWidthNumber <= 0) {
						desiredColWidthNumber = undefined;
					}
				} else {
					desiredColWidthNumber = undefined;
					isPercentage = false;
				}
				if (desiredColWidthNumber) { //desired column width is defined as pixels or percentage
					lastCol = $("<col></col>").appendTo(colgroup).css("width", desiredColWidth);
					lastColWidth = desiredColWidthNumber;
					//calculating the total sum of all widths or percentages
					totalColWidth += desiredColWidthNumber;
					cols[i].width = desiredColWidthNumber;
					// M.H. 26 Feb 2014 Fix for bug #165394: Last column occupies the width of the grid when there is a hidden column and the widths of the columns are set in percentage
					if (desiredColWidth && desiredColWidth.charAt && desiredColWidth.endsWith('%')) {// is percentage
						cols[i].width = cols[i].width + '%';
					}
				} else {
					lastCol = $("<col></col>").appendTo(colgroup);
					lastColWidth = undefined;
					hasColumnsWithNoWidth = true;
				}
				lc = cols[i];
			}
			if (!hasColumnVirtualization && autofitLastColumn && hasWidth && !hasColumnsWithNoWidth && lastColWidth) {
				// account for the special case where the grid has a width defined and widths defined for each column
				// but the total sum of column widths is less than the width of the grid(or not 100 for percentages), 
				// then we need to "expand" the last column to fill in the remaining blank space (so that it is not blank)
				if (isPercentage) {
					if (totalColWidth < 100) {
						lastColWidth += 100 - totalColWidth;
						lastCol.css('width', lastColWidth + '%');
						//set the new width as last column width
						this._autoadjustedColumn = cols.slice(-1)[0];
						// M.H. 16 Dec 2013 Fix for bug #154835: In Internet Explorer 8 when the grid has 100% width,  filtering is enabled and a column is hidden there is a blank space on the right of the grid.
						if (!this._autoadjustedColumn.oWidth) {
							this._autoadjustedColumn.oWidth = this._autoadjustedColumn.width;
						} 
						this._autoadjustedColumn.width = lastColWidth + '%';
						lc.width = lastColWidth + '%';
					}
				} else {
					if (hasWidthInPixels) {
						if (hasFixedColumns) {
							// M.H. 18 Feb 2014 Fix for bug #164303: When a column is fixed and autofitLastColumn is true hiding the last unfixed column increases the width of the column next to it.
							// M.H. 19 Feb 2014 Fix for bug #164599: When column is fixed and you hide enough column so the grid does not need a horizontal scrollbar but there is one anyway.
							totalGridWidth = this.container().width() - this.fixedContainer().outerWidth();
						} else {
						totalGridWidth = parseInt(this.options.width, 10);
						}
					} else if (hasWidthInPercent) {
						totalGridWidth = this.container().width();
					}
					if (totalGridWidth && totalGridWidth > totalColWidth) {
						difference = totalGridWidth - totalColWidth;
						lastColWidth += difference;
						totalColWidth += difference;
						lastCol.css('width', lastColWidth + 'px');
						//set the new width as last column width
						this._autoadjustedColumn = cols.slice(-1)[0];
						// M.H. 16 Dec 2013 Fix for bug #154835: In Internet Explorer 8 when the grid has 100% width,  filtering is enabled and a column is hidden there is a blank space on the right of the grid.
						if (!this._autoadjustedColumn.oWidth) {
							this._autoadjustedColumn.oWidth = this._autoadjustedColumn.width;
						}
						this._autoadjustedColumn.width = lastColWidth + 'px';
						this._autoadjustedColumn.difference = difference;
						lc.width = lastColWidth + 'px';
						/*
						L.A. 16 October 2012 - Fixing bug #123050 When showHeader = FALSE and the has a vertical and 
						horizontal scrollbars, the last column is 17 pixels less wide than expected
						*/
						this._gridWidthGTColWidth = true;
					}
				}
			} else {
				this._autoadjustedColumn = undefined;
			}
			//A.Y. bug 102220. When the grid has column virtualization and width
			//the scrollbar's width should be substracted from the last column's width
			// M.H. 2 April 2012 Fix for bug #107567 - it should not be only for isHeader(it should be for footer too)
			// S.S. May 17, 2012 The vertical scrollbar should be substracted from the last column's width at all times
			// otherwise the user needs to account for it's presence to determine a proper width for his grid and not get
			// a horizontal scroll bar (either virtual or normal)
			if (hasWidth && hasVirtualization && !hasColumnsWithNoWidth && lastColWidth) {
				if (!isPercentage) {
					lastColWidth -= this._scrollbarWidth();
					lastCol.css('width', lastColWidth + 'px');
				}
			}
			if (isHeader) {
				this._lastHeaderCol = lastCol;
			}
			if (isFooter) {
				this._lastFooterCol = lastCol;
			}
			if (!isHeader && !isFooter) {
				this._lastDataCol = lastCol;
			}
			this._allColumnWidthsInPercentage = isPercentage && !hasColumnsWithNoWidth && cols.length > 0;
			this._allColumnWidthsInPixels = !isPercentage && !hasColumnsWithNoWidth && cols.length > 0;
			if (this._allColumnWidthsInPixels) {
				this._lastColPixelWidth = lastColWidth;
				this._totalColPixelWidth = totalColWidth;
			} else if (this._allColumnWidthsInPercentage) {
				this._lastColPercentWidth = lastColWidth;
				this._totalColPixelWidth = undefined;
			} else {
				this._lastColPixelWidth = undefined;
				this._totalColPixelWidth = undefined;
			}
		},
		_renderRecords: function (start, end) {
			//console.log('_renderRecords');
			var prime, grid = this, tbody = this.element.children("tbody"), ph,
				ds = this.dataSource.dataView(), i, d = "", noCancel = true, tbodytmp;
			// S.S. August 21, 2012, Bug #113279 Adding the continuous virtualization markers to the event args so features 
			// that need those to render correctly can use them
			// S.S. February 11, 2013, Bug #130308 Adding an internal event to hook renderRecord() overriding widgets to, as using the same
			// event groupby cancels makes feature initialization order matter
			this._trigger("_rowsRendering", null, {owner: this, tbody: tbody, vrtWnd: { start: start, end: end }});
			noCancel = this._trigger(this.events.rowsRendering, null, {owner: this, tbody: tbody, vrtWnd: { start: start, end: end }});
			if (start === undefined) { //no params => render all
				start = 0;
				end = ds.length - 1;
			}
			if (start !== undefined && end === undefined) {
				end = start;
				if (end > ds.length - 1) {
					end = ds.length - 1;
				}
				start = 0;
			}
			if (start < 0) {
				start = 0;
			}
			if (end > ds.length - 1) {
				end = ds.length - 1;
			}
			if (noCancel) {
					for (i = start; i <= end; i++) {
						d += grid._renderRecord(ds[i], i);
					}
					if (!this._canreplaceinner || $.ig.util.isWebKit) { // Chrome is a special case, with it innerHTML is actually slower 
						ph = document.createElement("div");
						ph.innerHTML = "<table><tbody>" + d + "</tbody></table>";
						tbodytmp = ph.firstChild.firstChild;
						this.element[0].replaceChild(tbodytmp, tbody[0]);
					} else if (this._canreplaceinner) {
						MSApp.execUnsafeLocalFunction(function () {
							tbody[0].innerHTML = d;
						});
					}
					d = "";
				//_virtualDom should be built because features like selection expects it
				this._buildVirtualDomForContinuousVirtualization();
				this._trigger(this.events.rowsRendered, null, {owner: this, tbody: tbody});
			}
		},
		_reapplyZebraStyle: function (from) {
			var dataRows, toChange;
			if (!this.options.alternateRowStyles) {
				return;
			}
			dataRows = this.element.children("tbody").children("tr:not([data-container],[data-grouprow])");
			from = from || 0;
			toChange = dataRows.slice(from);
			toChange.filter(from % 2 === 0 ? ":odd" : ":even").addClass(this.css.recordAltClass);
			toChange.filter(from % 2 === 0 ? ":even" : ":odd").removeClass(this.css.recordAltClass);
			if (this.hasFixedColumns()) {
				dataRows = this.fixedContainer().find("tbody").children("tr:not([data-container],[data-grouprow])");
				toChange = dataRows.slice(from);
				toChange.filter(from % 2 === 0 ? ":odd" : ":even").addClass(this.css.recordAltClass);
				toChange.filter(from % 2 === 0 ? ":even" : ":odd").removeClass(this.css.recordAltClass);
			}
		},
		_buildFormatters: function () {
			var i, cols = this.options.columns, ret = {};
			for (i = 0; i < cols.length; i++) {
				if (cols[i].formatter !== undefined) {
					if ($.type(cols[i].formatter) === "function") {
						ret[cols[i].key + 'Formatter'] = cols[i].formatter;
					} else if (window[cols[i].formatter] && typeof window[cols[i].formatter] === 'function') {
						ret[cols[i].key + 'Formatter'] = window[cols[i].formatter];
					}
				}
			}
			return ret;
		},
		_getVisibleIndexByKey: function (columnKey) {
			var hasFixedColumns = this.hasFixedColumns(), fixedCounters, unfixedCounters, prevColumn,
				cols = this._visibleColumns(), index = -1;
			if (hasFixedColumns) {
				fixedCounters = 0;
				unfixedCounters = 0;
				prevColumn = null;
				$.each(cols, function (ind, value) {
					var isFixed = (value.fixed === true),
						prevColumnFixed = (prevColumn && (prevColumn.fixed === true));
					if (prevColumn === null || prevColumnFixed !== isFixed) {
						if (value.fixed === true) {
							fixedCounters = 0;
						} else {
							unfixedCounters = 0;
						}
					}
					prevColumn = value;
					if (value.hidden) {
						return true;
					}
					if (isFixed !== true) {
						unfixedCounters++;
					} else {
						fixedCounters++;
					}
					if (value.key === columnKey) {
						if (isFixed) {
							index = fixedCounters - 1;
						} else {
							index = unfixedCounters - 1;
						}
						if (index === -1) {
							index = 0;
						}
						return false;
					}
				});
			} else {
				$.each(cols, function (ind, value) {
					if (value.key === columnKey) {
						index = ind;
						return false;
					}
				});
			}
			return index;
		},
		_isColumnHidden: function (columnKey) {
			/* returns if column is hidden by column key */
			var cols = this.options.columns, i = cols.length;
			while (i-- >= 0) {
				if (cols[i].key === columnKey) {
					return cols[i].hidden || false;
				}
			}
			return true;
		},
		_visibleColumns: function (isFixed) {
			var vcArr;
			// isFixed is passed as an argument then it is supposed there are fixed columns - if true then return visible fixed columns, if false visible unfixed columns
			// when isFixed is not passed then it works as till now - returns cached _visibleColumnsArray if set otherwise populate it and returns it
			if (isFixed !== undefined) {
				vcArr = $.grep(this.options.columns, function (col) { var fixed = (col.fixed === true); return !col.hidden && fixed === isFixed; });
				return vcArr;
			}
			if (this._visibleColumnsArray === undefined) {
				//performance optimization as visibleColumns is called a lot
				this._visibleColumnsArray = $.grep(this.options.columns, function (col) { return !col.hidden; });
			}
			return this._visibleColumnsArray;
		},
		_visibleMchColumns: function (curLvl) {
			var vmch = [], cl = curLvl || this._oldCols, self = this;
			if (!cl) {
				return null;
			}
			$.each(cl, function () {
				if (!this.hidden || this.hidden === false) {
					vmch.push($.extend({}, this));
					if (this.group) {
						vmch[vmch.length - 1].group = self._visibleMchColumns(this.group);
					}
				}
			});
			return vmch;
		},
		_renderVirtualRecordsFixed: function () {
			var i, j, row, c, val, headersTexts, headerText, vheaderNode,
				iRow, tr, ds = this.dataSource, data = ds.dataView(), key = this.options.primaryKey,
                noVirtualDom = (this._virtualDom === null || this._virtualDom === undefined),
				visibleCols = this._visibleColumns();
			// trigger event so that features can clean up itself (end editing for example)
            // In IE this event is called more than once on initialization or on page change - caused by hack for 
			this._trigger('virtualrendering', null, {isBuiltVirtualDom: !noVirtualDom});
			if (this._startRowIndex === undefined || this._startRowIndex === null) {
                this._startRowIndex = 0;
			}
			if (this._startColIndex === undefined || this._startColIndex === null) {
				this._startColIndex = 0;
			}
			if (noVirtualDom) {
                this._buildVirtualDom();
				if (this.options.adjustVirtualHeights === true) {
					this._adjustVirtualHeights();
				}
			} else {
				//this._adjustVirtualHeights();
				for (i = 0; i < this._virtualRowCount && i < this._totalRowCount && this._startRowIndex + i < data.length; i++) {
						if ($.type(data[i]) === "array") {
							// K.D. January 17th, 2013 Bug #119619 The rendering should go through _renderRecord
						row = $(this._renderRecord([data[this._startRowIndex + i]], i));
						} else {
							// K.D. January 17th, 2013 Bug #119619 The rendering should go through _renderRecord
						row = $(this._renderRecord(data[this._startRowIndex + i], i));
						}
						// loop through cells
						c = row.children();
						//for (j = 0; j < c.length; j++) {
						for (j = 0; j < this._virtualColumnCount; j++) {
							this._virtualDom[i][j].innerHTML = c[j + this._startColIndex].innerHTML;
							// reset classes
							//$(this._virtualDom[i][j]).attr('class', '');
							this._virtualDom[i][j].className = '';
						}
					// fix for data-id
					iRow = this._startRowIndex + i;
					tr = this._virtualDom[i][0].parentNode;
					tr.className = ((i % 2 === 0 && this.options.alternateRowStyles) ? 'ui-iggrid-virtualrow ui-ig-altrecord' : 'ui-iggrid-virtualrow');
					if (data[iRow]) {
						if (!_aNull(key)) {
							tr.setAttribute('data-id', this._kval_from_key(key, data[iRow]));
						} else if (!_aNull(data[iRow].ig_pk)) {
							tr.setAttribute('data-id', data[iRow].ig_pk);
						}
					}
				}
			}
			// make sure to update the headers , too.
			if (this._isHorizontal) {
				this._isHorizontal = false;
				if ((this.options.virtualization === true || this.options.columnVirtualization === true) && parseInt(this.options.width, 10) > 0) {
					if (!this._vheaders) {
						headersTexts = this.headersTable().find('thead > tr > th > a > span:first-child');
						if (headersTexts.length > 0) {
							this._vheaders = headersTexts;
						} else {
							this._vheaders = this.headersTable().find('thead > tr > th > span');
						}
					}
					for (j = 0; j < this._virtualColumnCount; j++) {
						//L.A. 21 March 2012 Fixed bug 97377 - When using virtualization and the grid is scrolled horizontally, the IDs of the column header cells are not updated accordingly
						headerText = visibleCols[j + this._startColIndex].headerText;
						vheaderNode = $(this._vheaders[j]);
						// M.H. 3 Sep 2013 Fix for bug #146741: When column virtualization is used with Sorting scrolling horizontally doesn't update the IDs of the column header cells
						vheaderNode.closest('th').attr('id', this.element[0].id + '_' + visibleCols[j + this._startColIndex].key);
						vheaderNode.html(headerText);
					}
				}
			}
            // M.H. 19 Dec 2013 Fix for bug #160188: Selecting a row and then scrolling in IE with fixed virtualization does not retain the selection
            // trigger event so that features such as selection can apply the selection
            this._trigger('virtualrecordsrender', null, {owner: this, tbody: this.element.children("tbody"), dom: this._virtualDom, isBuiltVirtualDom: !noVirtualDom});
		},
		_updateVirtColCounters: function () {
			var visibleColsLength = this._visibleColumns().length;
			if (this.options.columns) {
				this._totalColumnCount = visibleColsLength;
				this._maxVirtualColumnCount = this.options.columns.length;
			} else {
				this._totalColumnCount = this.dataSource.dataView()[0].length;
				this._maxVirtualColumnCount = this._totalColumnCount;
			}
			if (this.options.columnVirtualization === false && this.options.virtualization === false) {
				this._virtualColumnCount = visibleColsLength;
			} else {
				if (this.options.width === null) {
					this._virtualColumnCount = this._totalColumnCount;
				} else {
					this._virtualColumnCount = Math.ceil(parseInt(this.options.width, 10) / this._avgColumnWidth());
					this._maxVirtualColumnCount = Math.min(this._maxVirtualColumnCount, this._virtualColumnCount);
					this._virtualColumnCount = Math.min(this._totalColumnCount, this._virtualColumnCount);
					// update the horizontal scrollbar inner width (div)
					this._vhorizontalcontainer().children().first().css('width', this._calculateContainerWidth(false));
				}
			}
		},
		_buildVirtualDom: function () {
			var grid = this, markup = '', row, i, j, dataLinkFn, ar = this.options.accessibilityRendering, shouldHide = false,
				visibleCols = this._visibleColumns(), key = this.options.primaryKey, data = this.dataSource.dataView(), temp;
			if (this._startRowIndex === undefined || this._startRowIndex === null) {
				this._startRowIndex = 0;
				this._startColIndex = 0;
				this._oldStartRowIndex = 0;
				this._oldStartColIndex = 0;
			}
			this._virtualDom = [];
			this._totalRowCount = data.length;
			if (this.options.height === null) {
				this._virtualRowCount = this._totalRowCount;
			} else {
				if (this.options.height.indexOf && this.options.height.indexOf("%") !== -1) {
					this._virtualRowCount = Math.ceil(this._vdisplaycontainer().innerHeight() / parseInt(this.options.avgRowHeight, 10), 10);
				} else {
					// M.H. 14 Jun 2013 Fix for bug #142448: Scroll height is not calculated correctly when virtualization is enabled
					//this._virtualRowCount = Math.ceil(parseInt(this.options.height, 10) / parseInt(this.options.avgRowHeight, 10), 10);
					this._virtualRowCount = Math.ceil(this._vdisplaycontainer().innerHeight() / parseInt(this.options.avgRowHeight, 10), 10);
				}
			}
			this._updateVirtColCounters();
			if (this.options.height !== null) {
				//$('#' + this.element[0].id + '_scrollContainer').children().first().height(this._totalRowCount * parseInt(this.options.avgRowHeight, 10));
				this._setScrollContainerHeight(this._totalRowCount * parseInt(this.options.avgRowHeight, 10));
			}
			dataLinkFn = function (row, i, vc) {
				//$(row).children().each(function (col) {
					//$(this).data('row', i).data('col', col);
					// link references 
				//for (j = grid._startColIndex; j < vc + grid._startColIndex; j++) {
				for (j = 0; j < vc; j++) {
					if (j < grid._totalColumnCount) {
						grid._virtualDom[i][j] = row[0].cells[j];
					}
				}
				//});
			};
			this.element.children('tbody').empty();
			for (i = 0; i < this._virtualRowCount; i++) {
				shouldHide = false;
				this._virtualDom[i] = [];
				markup = '';
				for (j = this._startColIndex; j < this._virtualColumnCount + this._startColIndex; j++) {
					if (j >= this._totalColumnCount) {
						break;
					}
					if (ar) {
						markup += '<td role="gridcell" aria-describedby="' + visibleCols[j].key + '"';
					} else {
						markup += '<td';
					}
						if (!data[i]) {
							shouldHide = true;
							// L.A. 09 November 2012 - Fixing bug #128605
							// Tabbing within 'Add New Row' section , while no rows exist, is causing editRowEnding event to fire earlier
							markup += '></td>';
						} else {
							if (this.options.autoFormat !== false) {
							if (visibleCols[j].template && visibleCols[j].template.length) {
								temp = this._renderTemplatedCell(data[i], visibleCols[j]);
								if (temp.indexOf("<td") === 0) {
									markup += temp.substring(3);
								} else {
									markup += '>' + temp;
								}
								markup = grid._editCellStyle(markup, data[i], visibleCols[j].key || j);
							} else {
								markup += grid._addCellStyle(data[i], visibleCols[j].key || j) + '>' + this._renderCell(data[i][visibleCols[j].key], visibleCols[j], data[i]);
							}
					} else {
							markup += grid._addCellStyle(data[i], visibleCols[j].key) + '>' + data[i][visibleCols[j].key];
						}
						markup += '</td>';
					}
				}
				row = $('<tr>' + markup + '</tr>').appendTo(this.element.children('tbody'));
				if (shouldHide) {
					row.css('visibility', 'hidden');
				}
				if (i % 2 === 0 && this.options.alternateRowStyles) {
					row.addClass('ui-ig-altrecord');
				}
				row.addClass('ui-iggrid-virtualrow');
				if (i % 2 === 0 && this.options.alternateRowStyles) {
					row.addClass('ui-ig-altrecord');
				}
				if (ar) {
					row.attr('role', 'row');
				}
				if (data[i]) {
					if (!_aNull(key)) {
						row.attr('data-id', this._kval_from_key(key, data[i]));
					} else if (!_aNull(data[i].ig_pk)) {
						row.attr('data-id', data[i].ig_pk);
					}
				}
				dataLinkFn(row, i, this._virtualColumnCount);
				// K.D. April 2nd, 2012 Bug #107070 "flag is not defined" error is thrown in jquery.tmlp.js when rowVirtualization=true
				// Breaking out of the loop if the dataView is smaller than the virtual column collection.
				if (i === data.length - 1) {
					break;
				}
			}
			this._updateVirtualScrollContainer();
			this._trigger('virtualdombuilt', null, { rows: this.element.children('tbody').children('tr') });
		},
		_adjustVirtualHeights: function () {
			var c = this._vdisplaycontainer(), tbody = c.find('tbody'), h = tbody.children().first().height();
			if (this.options.height === null) {
				return;
			}
			// 1. adjust avgRowHeight
			if (this.options.avgRowHeight !== h) {
				this.options.avgRowHeight = h;
				// adjust the first child of the scroll container
				//$('#' + this.element[0].id + '_scrollContainer').children().first().height(this._totalRecordsCount * this.options.avgRowHeight);
				// recalc
				//this._virtualRowCount = parseInt(this.options.height, 10) / parseInt(this.options.avgRowHeight, 10);
				this._buildVirtualDom();
			}
		},
		_verticalScroller: function () {
			if (!this._verticalScrollerObj || this._verticalScrollerObj.length === 0) {
				this._verticalScrollerObj = this._scrollContainer().children().first();
			}
			return this._verticalScrollerObj;
		},
		_hscrollbar: function () {
			return this.container().find("#" + this.id() + "_hscroller_container");
		},
		_hscrollbarcontent: function () {
			return this.container().find("#" + this.id() + "_hscroller");
		},
		_hscrollbarinner: function () {
			return this.container().find("#" + this.id() + "_hscroller_inner");
		},
		// calculates the average column width. This is needed for horizontal virtual scrolling where we need to determine 
		// the visible virtual columns
		_avgColumnWidth: function () {
			var width = 0, cols = this.options.columns, count = cols.length, def = this.options.defaultColumnWidth, i;
			if (this.options.avgColumnWidth !== null) {
				return parseInt(this.options.avgColumnWidth, 10);
			}
			for (i = 0; i < count; i++) {
				width += parseInt(cols[i].width, 10);
			}
			if ((count === 0 || isNaN(width)) && def) {
				return parseInt(def, 10);
			}
			if (count > 0 && this.options.autoGenerateColumns && isNaN(width)) {
				if (this.options.width === null || this.options.width === undefined) {
					throw new Error($.ig.DataSourceLocale.locale.columnVirtualizationRequiresWidth);
				}
				return parseInt(this.options.width, 10) / count;
			}
			if (width === 0 || (width < def)) {
				return def;
			}
			return width / count;
		},
		_scrollData: function () {
			// move the fixed header when the grid scrolling DIV moves
			var scroller = this._hscrollbarcontent(), scrollContainer;
			if (this.options.virtualization === true || this.options.rowVirtualization === true) {
				scrollContainer = this._vdisplaycontainer();
			} else {
				scrollContainer = this.scrollContainer();
			}
			scrollContainer.scrollLeft(scroller.scrollLeft());
		},
		_scrollHeader: function () {
			// move the fixed header when the grid scrolling DIV moves
			var scroller = this._hscrollbarcontent(),
				headers = this.headersTable().parent();
			headers.scrollLeft(scroller.scrollLeft());
		},
		_scrollFooter: function () {
			// move the fixed header when the grid scrolling DIV moves
			var scroller = this._hscrollbarcontent(),
				footers = this._fixedfooters();
			footers.scrollLeft(scroller.scrollLeft());
		},
		_renderCaption: function () {
			var colgroup, caption, tbl, scrollc;
			if (this.options.caption !== null) {
				if (this.container().find('.ui-iggrid-headercaption').length > 0) {
					return;
				}
				if (this.options.fixedHeaders === true && this.options.showHeader === true) {
					colgroup = this.headersTable().children('colgroup').first();
					if (colgroup.length === 0) {
						caption = $('<caption></caption>').prependTo(this.headersTable());
					} else {
						//A.Y. Bug 91574. The colgroup should always be the first element of the table.
						//If we already have a colgroup in the table we need to render the caption after it.
						caption = $('<caption></caption>').insertAfter(colgroup);
					}
					caption.text(this.options.caption).attr('id', this.id() + '_caption').addClass(this.css.gridHeaderCaptionClass);
				} else {
					// M.H. 30 Jan 2014 Fix for bug #116158: Caption property cannot be set dynamically at runtime.
					// it should be able to set properly caption even if paging header DOM element is rendered
					scrollc = this.scrollContainer();
					if (scrollc.length === 0) {
						tbl = $('<table></table>').prependTo(this.container());
					} else {
						tbl = $('<table></table>').insertBefore(scrollc);
					}
					// we need to render the caption in a separate table, which will be a first child of grid's container. otherwise won't stick.
					// also if there are no headers, we need to have some table to put the caption in :)
					caption = $('<caption></caption>').appendTo(tbl.css('width', '100%').addClass(this.css.captionTable)).text(this.options.caption).attr('id', this.id() + '_caption').addClass(this.css.gridHeaderCaptionClass);
				}
				caption.parent().css("margin", 0);
			}
		},
		// M.H. 22 Feb 2013 Fix for bug #133539: When the grid has vertical scrollbar and caption fixing a column makes the headers misaligned.
		_renderFixedCaption: function () {
			var colgroup, caption;
			if (this.options.caption !== null) {
				if (this.options.fixedHeaders === true && this.options.showHeader === true) {
					colgroup = this.fixedHeadersTable().children('colgroup').first();
					if (colgroup.length === 0) {
						caption = $('<caption></caption>').prependTo(this.fixedHeadersTable());
					} else {
						caption = $('<caption></caption>').insertAfter(colgroup);
					}
					caption.text(this.options.caption).attr('id', this.id() + '_caption_fixed').addClass(this.css.gridHeaderCaptionClass);
				}
				caption.parent().css("margin", 0);
			}
		},
		_createHeaderColumnMarkup: function (column, index) {
			var headerClass = this.css.headerClass,
				ar = this.options.accessibilityRendering,
				headerText = $('<span>' + column.headerText + '</span>').addClass(this.css.headerTextClass),
				markup = '<th></th>',
				headerCell;
			if (ar) {
				headerCell = $(markup).append(headerText).attr('id', this.id() + '_' + column.key).attr('role', 'rowheader').addClass(headerClass).data('columnIndex', index);
			} else {
				headerCell = $(markup).append(headerText).attr('id', this.id() + '_' + column.key).addClass(headerClass).data('columnIndex', index);
			}
			return headerCell;
		},
		_updateHeaderColumnIndexes: function () {
			var grid = this,
				cols = this.options.columns;
			if ((this.options.virtualization === true && this.options.virtualizationMode === 'fixed') ||
					this.options.columnVirtualization === true) {
				cols = cols.slice(0, this._maxVirtualColumnCount);
			}
			grid._initialHiddenCells = [];
			$(cols).each(function (i) {
				grid.container().find("#" + grid.id() + '_' + this.key).data('columnIndex', i);
			});
		},
		_renderHeaderColumns: function (header) {
			var grid = this,
				cols = this.options.columns;
			// if we use virtualization we need headers just for the maximum number of visible columns
			//I.I. bug fix for 107686
			if ((this.options.virtualization === true && this.options.virtualizationMode === 'fixed') || this.options.columnVirtualization === true) {
				cols = cols.slice(0, this._maxVirtualColumnCount);
			}
			grid._initialHiddenCells = [];
			// render header with the column names , if they are not defined, leave it empty 
			$(cols).each(function (i) {
				var headerCell, key = this.key;
				if (key) {
					headerCell = grid._createHeaderColumnMarkup(this, i);
					header.append(headerCell);
					grid._trigger(grid.events.headerCellRendered, null, {owner: grid, th: headerCell, columnKey: this.key});
					// M.H. 10 July 2012 Fix for bug #113972 - set first to display none
					$.each(grid._initialHiddenColumns, function () {
						if (this.key === key) {
							grid._initialHiddenCells.push(headerCell);
							headerCell.css('display', 'none');
							return false;
						}
					});
				}
			});
		},
		renderMultiColumnHeader: function (cols) {
			/*
				paramType="array" an array of column objects
				When called the method re-renders the whole grid(also rebinds to the data source) and renders the cols object
			*/
			// M.H. 31 Oct 2012 Fix for bug #125907
			var topmostGrid, layout;

			this._origSum = 0;
			this.options.columns = cols;
			this.destroy(true);
			this._initialized = false;
			this.options.requiresDataBinding = true;
			// M.H. 5 Sep 2012 Fix for bug #120472
			this._renderHeaderCalled = false;
			// M.H. 12 Nov 2012 Fix for bug #126991
			if (this._isHierarchicalGrid) {
				topmostGrid = this.element.closest('.ui-iggrid-root').data('igHierarchicalGrid');
				if (topmostGrid) {
					// M.H. 10 Dec 2012 Fix for bug #126991
					// M.H. 27 Sep 2013 Fix for bug #153474: The hierarchical grid throws a js error when you call renderMultiColumnHeader method. topmostGrid hasn't id function and also this function is called only by user when the grid is defined and the element should be rendered
					if (topmostGrid.element[0].id !== this.element[0].id && this.options.key) {
						layout = topmostGrid._findLayout(topmostGrid.options.columnLayouts, this.options.key);
						layout.columns = cols;
						topmostGrid._setOption("columnLayouts", topmostGrid.options.columnLayouts);
						//topmostGrid.element.data('igGrid').options.columnLayouts = topmostGrid.options.columnLayouts;
						topmostGrid._create();
						return;
					}
					topmostGrid._regevents(topmostGrid.element, topmostGrid);
				}
			}
			this._create();
		},
		_renderHeader: function () {
			/*
				Event fires headerRendering and headerRendered event ONLY when showHeader is TRUE
				It is fired headerRenderedInternal event so it is used by the hierarchical grid - it should not be called headerRendered event because header should not be rendered
				but should be called headerRenderedInternal so the hierarchical grid to create expander column
			*/
			var w, header, id, headerDom, headerMarkup = "",
				scrollc = this.scrollContainer(),
				noCancel = true,
				headerParent = this.element[0], width,
				headerScrollDiv,
				existingHeader,
				o = this.options,
				v = o.virtualization === true || o.rowVirtualization === true || o.columnVirtualization === true;
			// M.H. 10 May 2012 Fix for bug #108221 - it should be called renderHeader ONLY one time and we use this flag
			this._renderHeaderCalled = true;
			// M.H. 10 May 2012 Fix for bug #108221
			if (this.options.showHeader) {
				noCancel = this._trigger(this.events.headerRendering, null, {owner: this});
				if (noCancel) {
					id = this.id();
					// in order to have fixed headers, we must have a height set at least 
                    // M.H. 14 Feb 2013 Fix for bug #132840
					headerMarkup = "<thead><tr data-header-row></tr></thead>";
					headerParent = this.container();
					width = scrollc.css('width');
					if (this.options.showHeader && this.options.fixedHeaders && this.options.height !== null) {
						// set header parent
						if (v === false) {
							if (headerParent.length === 0) {
								scrollc.removeClass(this.css.gridClasses).removeClass(this.css.baseClasses).css('width', '').wrap("<div id='" + id + "_container'></div>");
								headerParent = this.container().addClass(this.css.baseClasses).addClass(this.css.gridClasses).css('width', width);
								this._isWrapped = true;
							}
						} else {
							// virtualization
							//I.I. bug fix for 103237
							width = this.element.parents('.ui-widget').css('width');
							headerParent = this.container().find('#' + id + '_headers_v').css('width', width);
							// M.H. 11 April 2012 Fix for bug #108438
							if (this.options.expandColWidth && !this.options.width) {
								headerParent.css('width', (parseInt(width, 10) + this.options.expandColWidth) + 'px');
							}
							//headerParent = $('#' + id + '_headers').css('width', width);
							if (o.width !== null) {
								// M.H. 21 Mar 2014 Fix for bug #159951: When virtualization is enabled in a grid with % width (not 100%), the layout is broken
								w = o.width;
								if (w.indexOf && w.indexOf('%') !== -1) {
									w = '100%';
								}
								headerParent.css('width', w).css('max-width', w).css('overflow-x', 'hidden');
							}
						}
						headerParent =
							$("<table id='" + id + "_headers'></table>")
							.prependTo(headerParent)
							.addClass(this.css.gridHeaderTableClass)
							.attr('cellpadding', 0)
							.attr('cellspacing', 0)
							.attr('border', '0');
						if (v === false) {
							// the fixed headers table should be inside another scrolling div
							headerScrollDiv = $("<div></div>").prependTo(headerParent.parent());
							headerScrollDiv
								.css('overflow', 'hidden')
								.css('position', 'relative')
								.css('white-space', 'nowrap');
							headerScrollDiv.addClass('ui-widget-header ui-helper-reset');
							headerScrollDiv.append(headerParent);
						} else if (this.options.rowVirtualization === true) {
							headerParent.addClass('ui-widget-header ui-helper-reset');
						}
						// now attach a handler on the grid scrolling container
						this._hscrollbarcontent()
							.bind("scroll", $.proxy(this._scrollHeader, this));
						this._renderColgroup(headerParent, true, false, this.options.autofitLastColumn);
					} else if (this.options.fixedHeaders !== true && this.options.showHeader) {
						headerParent = this.element;
					}
					// no scrolling
					if (this.options.width === null && this.options.height === null) {
						headerParent = this.element;
					}
					if (this.options.width !== null && this.options.height === null) {
						/* OK 13 OCT 2011 Fixed <91075> - When grid has only one row buttons Done,Cancel and Delete are not vissible */
						this._fixScrollY = 1;
						scrollc.css('overflow-y', 'hidden').css('overflow-x', 'auto');
						headerParent = this.element;
					}
					if (this._isMultiColumnGrid === true) {
						// it the grid has multicolumn headers then fire internal event. MulticolumnHeader widget is bound to this event and implements the logic for rendering
						this._headerParent = headerParent;
						this._fireInternalEvent("_renderingMultiColumnHeader");
						// M.H. 30 July 2012 Fix for bug #117466
						if (this.options.virtualization === true || this.options.rowVirtualization === true) {
							//append headers to the topmost table, so that they are fixed 
							this.container().find('#' + id + '_headers_v')
								.css('position', 'relative')
								//apply header styles as the div is now padded instead of the table
								.addClass('ui-widget-header ui-helper-reset')
								.addClass(this.css.baseClasses);
							headerParent.addClass(this.css.gridHeaderTableClass).attr('cellpadding', 0).attr('cellspacing', 0).attr('border', '0');
						}
					} else {
					if (this.options.showHeader) {
						if (this.options.headerTemplate === null || this.options.headerTemplate === undefined) {
							if (this.options.virtualization === true || this.options.rowVirtualization === true) {
								//append headers to the topmost table, so that they are fixed 
								this.container().find('#' + id + '_headers_v')
									.css('position', 'relative')
									//apply header styles as the div is now padded instead of the table
									.addClass('ui-widget-header ui-helper-reset')
									.addClass(this.css.baseClasses);

								headerParent.addClass(this.css.gridHeaderTableClass).attr('cellpadding', 0).attr('cellspacing', 0).attr('border', '0');
							}
							// L.A. 30 November 2012 Bug #128510 - the headers are displayed twice 
							// if you set height to the control while using HTML table as data source
							this.element.find('>thead').remove();
							// L.A. 10 May 2012 Bug #110557 - check for existing header before adding a new one
							existingHeader = headerParent.find('>thead');
							if (existingHeader.length === 0) {
								header = $(headerMarkup).appendTo(headerParent).children().first();
							} else {
								existingHeader.empty();
								// L.A. 15 August 2012 Fixing bugs #118934, #74552
									// M.H. 14 Feb 2013 Fix for bug #132840
									header = $('<tr data-header-row></tr>').appendTo(existingHeader);
							}
							this._renderHeaderColumns(header);
						} else {
							// check if there is a user defined template
							// the header template DOES NOT use jQuery templating, it's plain HTML with the actual column text there. 
							headerDom = this.options.headerTemplate;
							if (this.options.virtualization === true || this.options.rowVirtualization === true) {
								$(headerDom).children().each(function () {
									this.appendTo(this.container().find("#" + id + "_headers"));
								});
								header = this.headersTable().addClass(this.css.gridClasses);
							} else {
								header = $(headerMarkup).appendTo(headerParent).append(headerDom);
							}
						}
					}
					this._headerParent = headerParent;
					this._trigger(this.events.headerRendered, null, {owner: this, table: this.headersTable()});
					this._headerRenderCancel = false;
					}
				} else {
					this._headerRenderCancel = true;
				}
			}
			// M.H. 10 May 2012 Fix for bug #108221 - if headerRendering is called AND is canceled then it should not be called internal event headerRenderedInternal
			//if (this._headerRenderCancel !== true) {
			// M.H. 7 Aug 2012 Fix for bug #118444
			this._trigger("headerRenderedInternal", null, {owner: this, table: this.headersTable()});
			//}
		},
		_renderFooter: function () {
			var gridId = this.id(),
				w, o = this.options,
				elemParent,
				footerId = gridId + '_footer_container',
				footerMarkup = '<tfoot class="' + this.css.gridFooterClass + '"></tfoot>',
				$footer = this.container().find('#' + footerId),
				$table,
				width,
				noCancel,
				tableGrid = this.element,
				// footerParent = this.element[0],
				$tableGridContainer;
			if (tableGrid.length === 0) {
				return;
			}
			// check whether footer container is rendered
			if ($footer.length === 0 && o.showFooter) {
				noCancel = this._trigger(this.events.footerRendering, null, {owner: this});
				if (noCancel) {
					// M.H. 2 April 2012 Fix for bug #107566
					if ((o.virtualization === true || o.rowVirtualization === true || o.columnVirtualization === true) &&
							(
								(o.height !== null && o.height !== undefined) ||
								(o.width !== null && o.width !== undefined)
							)) {
						$tableGridContainer = this._vdisplaycontainer();
						this.options.fixedFooters = true;
						w = o.width;
						// M.H. 21 Mar 2014 Fix for bug #159951: When virtualization is enabled in a grid with % width (not 100%), the layout is broken
						if (w && w.indexOf && w.indexOf('%') !== -1) {
							w = '100%';
						}
						$tableGridContainer = $('<tr><td colspan="2" style="border-width: 0px;"></td></tr>')
							.insertAfter($tableGridContainer.closest("tr"));
						//$footer = $('#' + footerId).find('tfoot');
						$footer = $('<div></div>')
							.attr('id', footerId)
							.css({'overflow': 'hidden', 'position': 'relative'})
							.addClass('ui-widget-footer')
							.addClass(this.css.footerContainer)
							.width(w)
							.appendTo($tableGridContainer.find('td'));
						$table = $('<table></table>')
							.attr('cellpadding', 0)
							.attr('cellspacing', 0)
							.attr('border', 0)
							.appendTo($footer)
							.addClass(this.css.gridFooterTableClass)
							.width(w)
							.attr('id', gridId + '_footers');
						this._renderColgroup($table, false, true, this.options.autofitLastColumn);
						$(footerMarkup).appendTo($table);
						// M.H. 10 April 2012 Fix for bug #108453
						if (this.options.showFooter && this.options.fixedFooters === true && this.options.height !== null) {
							elemParent = this.element.parents('.ui-widget:first');
							if (elemParent.length === 1 && elemParent[0].style) {
								width = elemParent[0].style.width;
								// M.H. 4 Apr 2014 Fix for bug #159951: When virtualization is enabled in a grid with % width (not 100%), the layout is broken
								if (width && (!width.indexOf || width.indexOf('%') === -1)) {
									$footer.css('width', width);
								}
							}
						}
						// M.H. 11 April 2012 Fix for bug #108438
						if (o.expandColWidth && !o.width) {
							$footer.css('width', (parseInt($footer.width(), 10) + o.expandColWidth) + 'px');
						}
						this._hscrollbarcontent().bind("scroll", $.proxy(this._scrollFooter, this));
					} else if (o.fixedFooters === true && o.height !== null) {
						if (o.width !== null) {
							$tableGridContainer = this._hscrollbar();
						} else {
							$tableGridContainer = this.scrollContainer();
						}
						// usually table is wrapped in scroll element - e.g. in case when width/height are set
						// when they are not set then tableGridContainer should be the table
						if ($tableGridContainer.length === 0) {
							$tableGridContainer = tableGrid;
						}
						$footer = $('<div></div>')
							.attr('id', footerId)
							.css({
								'overflow': 'hidden',
								'position': 'relative',
								'white-space': 'nowrap'
							})
							.addClass(this.css.footerContainer)
							.addClass('ui-widget-footer')
							.insertAfter($tableGridContainer);
						$table = $('<table></table>')
							.attr('cellpadding', 0)
							.attr('cellspacing', 0)
							.attr('border', 0)
							.appendTo($footer)
							.addClass(this.css.gridFooterTableClass)
							.attr('id', gridId + '_footers');
						this._renderColgroup($table, false, true, this.options.autofitLastColumn);
						$(footerMarkup).appendTo($table);

						if (o.virtualization !== true && o.rowVirtualization !== true && o.columnVirtualization !== true) {
							// if there is scrolling then table is wrapped in div element. 
							// attach to scroll event of this div element
							this._hscrollbarcontent()
								.bind("scroll", $.proxy(this._scrollFooter, this));
						}
					} else {
						$tableGridContainer = tableGrid;
						// according to W3C specification tfoot should be before tbody
						// table grid container should be the table where is rendered grid
						$footer = $(footerMarkup).attr('id', footerId).insertBefore($tableGridContainer.find('tbody:eq(0)'));
					}
					// M.H. 11 Oct. 2011 Fix for bug #91147
					$footer.css('display', 'none');
					this._footer = $footer;
					this._footerParent = $table;
					this._trigger(this.events.footerRendered, null, {owner: this, table: this.footersTable()});
				}
			}
			return $footer;
		},
		_renderRecord: function (data, rowIndex) {
			// generate a Tr and append it to the table
			var i, key = this.options.primaryKey, ar = this.options.accessibilityRendering,
				grid = this, dstr = "", cols = this.options.columns, noVisibleColumns, temp;
			dstr += '<tr';
			if (rowIndex % 2 !== 0 && this.options.alternateRowStyles) {
				dstr += ' class="' + grid.css.recordAltClass + '"';
			}
			if (!_aNull(key)) {
				dstr += ' data-id="' + this._kval_from_key(key, data) + '"';
			} else if (!_aNull(data.ig_pk)) {
				dstr += ' data-id="' + data.ig_pk + '"';
			}
			//data index to which the row is bound
			if (this.options.virtualization && this.options.virtualizationMode === 'continuous') {
				dstr += ' data-row-idx="' + rowIndex + '"';
			}
			if (ar) {
				dstr += ' role="row">';
			} else {
				dstr += '>';
			}
				noVisibleColumns = true;
				$(cols).each(function (colIndex) {
					if (cols[colIndex].hidden || cols[colIndex].fixed === true) {
						return;
					}
					noVisibleColumns = false;
					if (ar) {
						dstr += '<td role="gridcell" aria-describedby="' + this.key + '"';
					} else {
						dstr += '<td';
					}
				if (cols[colIndex].template && cols[colIndex].template.length) {
					temp = grid._renderTemplatedCell(data, this);
					if (temp.indexOf("<td") === 0) {
						dstr += temp.substring(3);
						} else {
						dstr += '>' + temp;
						}
					dstr = grid._editCellStyle(dstr, data, this.key);
					} else {
					dstr += grid._addCellStyle(data, this.key ? this.key : colIndex) + '>' + grid._renderCell(data[this.key ? this.key : colIndex], this, data);
						}
						dstr += '</td>';
				});
				if (noVisibleColumns) {
					dstr += '<td role="gridcell"></td>';
				}

			dstr += '</tr>';
			return dstr;
		},
		_editCellStyle: function (dstr, data, col, isFixed) {
			var lastCellIdx, lastCellClass, start, end, nc = "", i; 
			if (!this._cellStyleSubscribers || this._cellStyleSubscribers.length === 0) {
				return dstr;
			}
			for (i = 0; i < this._cellStyleSubscribers.length; i++) {
				nc += this._cellStyleSubscribers[i](data, col, isFixed) + " ";
						}
			nc = nc.trim();
			if (nc.length === 0) {
				return dstr;
					}
			lastCellIdx = dstr.lastIndexOf("<td");
			lastCellClass = dstr.indexOf("class", lastCellIdx);
			if (lastCellClass > 0) {
				start = dstr.substring(0, lastCellClass + 7);
				end = dstr.substring(lastCellClass + 7);
				dstr = start + nc + " " + end;
							} else {
				start = dstr.substring(0, lastCellIdx + 3);
				end = dstr.substring(lastCellIdx + 3);
				dstr = start + ' class="' + nc + '"' + end;
					}
			return dstr;
		},
		_addCellStyle: function (data, col, isFixed) {
			var dstr = "", i;
			if (!this._cellStyleSubscribers || this._cellStyleSubscribers.length === 0) {
				return dstr;
				}
			for (i = 0; i < this._cellStyleSubscribers.length; i++) {
				dstr += this._cellStyleSubscribers[i](data, col, isFixed) + " ";
			}
			dstr = dstr.trim();
			return dstr.length > 0 ? ' class="' + dstr + '"' : dstr;
		},
		_enableHeaderCellFeature: function (th) {
			// apply css class to the specified header cell(or the header cell with the specified column key)
			var $th;
			if ($.type(th) === "string") {
				$th = this.container().find('#' + this.id() + '_' + th);
			} else {
				$th = th;
			}
			$th.addClass(this.css.headerCellFeatureEnabledClass);
		},
		_renderRecordInArray: function (darr, tbody, data, rowIndex) {
			// generate a Tr and append it to the table
			var i, key = this.options.primaryKey, ar = this.options.accessibilityRendering, grid = this, appendBehavior = false, cols = this.options.columns, temp;
			if (darr === null) {
				darr = [];
				appendBehavior = true;
			}
			darr.push('<tr');
			if (rowIndex % 2 !== 0 && this.options.alternateRowStyles) {
				darr.push(' class="' + grid.css.recordAltClass + '"');
			}
			if (!_aNull(key)) {
				darr.push(' data-id="' + this._kval_from_key(key, data) + '"');
			} else if (!_aNull(data.ig_pk)) {
				darr.push(' data-id="' + data.ig_pk + '"');
			}
			if (ar) {
				darr.push(' role="row">');
			} else {
				darr.push('>');
			}
			$(cols).each(function (colIndex) {
				if (cols[colIndex].hidden) {
					return;
				}
				if (ar) {
					darr.push('<td role="gridcell" aria-describedby="' + this.key + '" ');
				} else {
					darr.push('<td ');
				}
				// K.D. April 17th, 2012 Bug #109497 Template and non-template rendering is now branched in here
				if (data[this.key] === undefined) {
					if (cols[colIndex].template && cols[colIndex].template.length) {
						temp = grid._renderTemplatedCell(data, this);
						if (temp.indexOf("<td") === 0) {
							darr[darr.length - 1] = temp.replace("<td", darr[darr.length - 1]);
						} else {
							darr.push('>' + temp);
						}
						darr[darr.length - 1] = grid._editCellStyle(darr[darr.length - 1], data, colIndex);
					} else {
						darr.push(grid._addCellStyle(data, colIndex) + '>' + grid._renderCell(data[colIndex], this, data));
					}
					darr.push('</td>');
				} else {
					if (cols[colIndex].template && cols[colIndex].template.length) {
						temp = grid._renderTemplatedCell(data, this);
						if (temp.indexOf("<td") === 0) {
							darr[darr.length - 1] = temp.replace("<td", darr[darr.length - 1]);
						} else {
							darr.push('>' + temp);
						}
						darr[darr.length - 1] = grid._editCellStyle(darr[darr.length - 1], data, this.key);
					} else {
						darr.push(grid._addCellStyle(data, this.key) + '>' + grid._renderCell(data[this.key], this, data));
					}
					darr.push('</td>');
				}
			});
			darr.push('</tr>');
			if (appendBehavior) {
				tbody.append(darr.join(''));
			}
		},
		_fixDate: function (val, col) {
			var d, i;
			if (!col || !val) {
				return val;
			}
			if (col.dataType === 'date' && !val.getTime) {
				i = val.indexOf ? val.indexOf('ate(') : -1;
				if (i > 0) {
					d = val.substring(i + 4);
					i = d.indexOf(')');
					if (i > 0) {
						d = parseInt(d.substring(0, i), 10);
						if (!isNaN(d)) {
							val = new Date(d);
						}
					}
				}
			}
			return val;
		},
		// handles formatting
		_renderCell: function (val, col, record, displayStyle, returnObject) {
			var type = col.dataType, format = col.format, o = this.options, auto = o.autoFormat;
			val = this._fixDate(val, col);
			if (col.formatter) {
				return col.formatter(val, record);
			}
			// K.D. August 21st, 2012 Bug #119317 The checkBox is not rendered when column template is used in the grid.
			if (!format && type === 'bool' && o.renderCheckboxes) {
				format = 'checkbox';
			}
			if (format === 'checkbox' && type !== 'bool') {
				format = null;
			}
			type = (type === 'date' || type === 'number') ? type : '';
			if (format || ((auto === true || auto === 'dateandnumber') && type) || (auto && auto === type)) {
				// K.D. August 21st, 2012 Bug #119317 The checkBox is not rendered when column template is used in the grid.
				// L.A. 17 October 2012 - Fixing bug #123215 The group rows of a grouped checkbox column are too large
				return $.ig.formatter(val, type, format, true, o.enableUTCDates, displayStyle);
			}
			// L.A. 24 October 2012 - Fixing bug #125387 Boolean value is not evaluated correctly in rowTemplate
			// L.A. 12 November 2012 - Fixing bug #127006 Changing a value in an existing row causes boolean column values 
			// (from the edited or non-edited cell) to no longer be rendered after completing the edit
			if (returnObject) {
				return val;
			}
			return (val || val === 0 || val === false) ? val.toString() : '&nbsp;';
		},
		_renderTemplatedCell: function (val, col) {
			var v, d = $.extend({}, val);
            // M.H. 17 Jun 2013 Fix for bug #144484: When an unbound column has a template it crashes.
			if (val === undefined || val === null || val[col.key] === undefined) {
				if (col.unbound === true) {
					v = '&nbsp;';
				} else {
					v = this._renderCell(val, col, val, null, true);
				}
			} else {
				v = this._renderCell(val[col.key], col, val, null, true);
			}
			d[col.key] = v;
			return this._tmplWrappers[this.id() + "_" + col.key](d, col.template);
		},
		_defaultTemplateFunc: function (d, tmpl) {
			return $.ig.tmpl(tmpl, d);
		},
		_setTemplateDefinition: function (jsrnd) {
			var i, key;
			for (i = 0; i < this.options.columns.length; i++) {
				if (this.options.columns[i].template && this.options.columns[i].template.length) {
					key = this.id() + "_" + this.options.columns[i].key;
				if (jsrnd) {
					// we'll add the template with  gridId.colKey
						$.templates(key, this.options.columns[i].template);
				} else {
						this._tmplWrappers[key] = this._defaultTemplateFunc;
					}
				}
			}
		},
		// cross-browser calculation to check for the scrollbar width. we need this when creating the virtualization-enabled grid's layout 
		_scrollbarWidth: function () {
			if (!this._scrollbarWidthResolved) {
				var $parent, $div = $('<div id="' + this.id() + '_tmp"></div>')
					.css({ width: 50, height: 50, position: 'absolute', top: -500, left: -500 })
					.prependTo('body')
					.append('<div></div>').find('div').css({ height: 100 }),
					w1, w2;
				// L.A. 14 January 2013 - Fixing bug #130587 
				// Horizontal scrollbar is missing when document mode is set to IE7 and a different browser mode is used.
				if (document.documentMode === 7 || $.ig.util.isIE7) {
					w1 = $div.innerWidth();
					$div.parent().css('overflow-y', 'scroll');
					w2 = $div.innerWidth();
					this._scrollbarWidthResolved = w1 - w2;
				} else {
					$parent = $div.parent();
					$parent.css({ overflow: 'auto' });
					$div.css({ width: '100%' });
					// M.H. 12 June 2014 Fix for bug #173336: Horizontal scrollbar does not appear when row virtualization is enabled
					// when bootstrap(it is possible to happen such issue with other CSS framework) is applied then $parent is not with 50px width that's why I got the current width of the div
					this._scrollbarWidthResolved = $parent.width() - $div.width();
				}
				$("#" + this.id() + "_tmp").remove();
				// M.H. 2 Oct 2013 Fix for bug #153790: The grid is misaligned on touch devices when there is a vertical scrollbar
				//if (!this._scrollbarWidthResolved) {
				//// fallback
				//this._scrollbarWidthResolved = 17; // default
				//}
			}
			return this._scrollbarWidthResolved;
		},
		_fireInternalEvent: function (name, args) {
			var i, f, featureName, feature;
			for (i = 0; i < this.options.features.length; i++) {
				f = this.options.features[i];
				if (f !== undefined && f !== null && f.name !== undefined) {
					featureName = 'igGrid' + f.name;
					feature = this.element.data(featureName);
					if (feature !== null && feature !== undefined &&
							feature[name]) {
						if (args) {
							feature[name](args);
						} else {
							feature[name]();
						}
					}
				}
			}
		},
		_initFeature: function (featureObject, dataOptions, destroy) {
			if (!featureObject) {
				return;
			}
			// construct widget name
			if (featureObject.name === undefined) {
				return;
			}
			var widget = 'igGrid' + featureObject.name;
			// validate widget
			if ($.type(this.element[widget]) !== "function") {
				throw new Error($.ig.Grid.locale.noSuchWidget + ' ' + widget);
			}
			// M.H. 3 July 2012 Fix for bug #115938
			if (this.element.data(widget)) {
				this.element[widget]('destroy');
			}
			// instantiate widget
			//A.T. 4 Jan 2011			
			this.element[widget](featureObject);
			this.element.data(widget)._injectGrid(this);
		},
		_initFeatureSettings: function (featureObject) {
			if (!featureObject) {
				return;
			}
			// construct widget name
			if (featureObject.name === undefined) {
				return;
			}
			var widget = 'igGrid' + featureObject.name;
			// validate widget
			if ($.type(this.element[widget]) !== "function") {
				throw new Error($.ig.Grid.locale.noSuchWidget + ' ' + widget);
			}
			// L.A. 31 July 2012 Fixing bug #113983 After a 'destroy' of a feature, 'dataBind' throws a js error
			if (this.element.data(widget)) {
				this.element.data(widget)._injectGrid(this, true);
			}
		},
		_onFeaturesSoftDirty: function (e, args) {
			var i, feature;
			if (args.owner.options.type !== 'remote') {
				return;
			}
			for (i = 0; i < this.options.features.length; i++) {
				feature = this.element.data('igGrid' + this.options.features[i].name);
				if (feature && feature !== args.owner && feature.options && feature.options.type === 'local') {
					if (feature._onUIDirty && $.type(feature._onUIDirty) === 'function') {
						feature._onUIDirty(e, args);
					}
				}
			}
		},
		_kval_from_key: function (key, data) {
			var k, k_val = "", i;
			if (key.indexOf(",") !== -1) {
				k = key.split(",");
				for (i = 0; i < k.length; i++) {
					k_val += data[k[i]];
					if (i < k.length - 1) {
						k_val += ",";
					}
				}
			} else {
				k_val = data[key];
			}
			return k_val;
		},
		// returns key of row, or index of row, or last index of rows
		_rowId: function (rec, index) {
			var key = this.options.primaryKey;
			key = key ? this._kval_from_key(key, rec) : null;
			if (!key) {
				key = index;
				if (key !== 0) {
					key = this.rows().length - 1;
				}
			}
			return key;
		},
		_inferOpType: function () {
			// infer the default feature operation type, if it is not explicitly specified by the developer
			// that will be done based on the data source type after it's analyzed
			if (this.options.dataSourceUrl || this.dataSource.type() === "remoteUrl") {
				return "remote";
			}
			return "local";
		},
		//virtualization: branches the virtualization rendering according to the virtualizationMode
		_renderVirtualRecords: function () {
			// trigger event so that features can clean up itself (end editing for example)
			this._trigger('virtualrendering');
			var mode = this.options.virtualizationMode;
			if (mode === undefined || mode === '') {
				mode = 'continuous';
			}
			// M.H. 10 April 2012 Fix for bug #107566
			if (mode === 'fixed' || this.options.columnVirtualization === true) {
				this._renderVirtualRecordsFixed();
			} else if (mode === 'continuous') {
				this._renderVirtualRecordsContinuous();
				// trigger event so that features such as selection can apply the selection
				// M.H. 4 Dec 2013 Fix for bug #159020: Duplicated iggridvirtualrecordsrender event on changing pages
				this._trigger('virtualrecordsrender', null, {owner: this, dom: this._virtualDom});
			}
		},
		_getHScrollContainerInner: function () {
			var ret = this._hscrollbarinner();
			if (ret.length === 0 && this.options.virtualizationMode === "continuous") {
				ret = this.container().find("#" + this.id() + "_horizontalScrollContainer div");
			}
			return ret;
		},
		_getScrollContainerHeight: function () {
			return this._scrollContainer().children(':first-child').height();
		},
		_getDisplayContainerHeight: function () {
			return this._vdisplaycontainer().height();
		},
		_getDisplayContainerWidth: function () {
			return this._vdisplaycontainer().width();
		},
		_setDisplayContainerWidth: function (width) {
			if (width === undefined) {
				return;
			}
			this._vdisplaycontainer().css('max-width', width);
			this._vdisplaycontainer().width(width);
		},
		_getVHeadersWidth: function () {
			return this.container().find("#" + this.id() + "_headers_v").width();
		},
		_setVHeadersWidth: function (width) {
			if (width === undefined) {
				return;
			}
			this.container().find("#" + this.id() + "_headers_v").width(width);
		},
		_setScrollContainerHeight: function (height) {
			var sc = this._scrollContainer(), funcIEScroll;
			if (height === undefined) {
				return;
			}
			sc.children(':first-child').height(height);
			//A.T. 15 Jul - need this hack for IE because of an IE bug that doesn't immediately update the scrollbar visually
			if ($.ig.util.isIE) {
				funcIEScroll = function () {
					sc.scrollTop(sc.scrollTop() + 2);
					sc.scrollTop(sc.scrollTop() - 2);
				};
				// M.H. 21 Mar 2014 Fix for bug #167904: Javascript runtime error on initial grid load with virtualization
				if ($.ig.util.browserVersion <= 8) {
					setTimeout(function () {
						funcIEScroll();
					}, 0);
				} else {
					funcIEScroll();
				}
			}
		},
		_setScrollContainerScrollTop: function (top) {
			if (top === undefined) {
				return;
			}
			this._scrollContainer().scrollTop(top);
		},
		_getScrollContainerScrollTop: function () {
			return this._scrollContainer().scrollTop();
		},
		_setDisplayContainerScrollTop: function (top) {
			if (top === undefined) {
				return;
			}
			this._vdisplaycontainer().scrollTop(top);
		},
		_getDisplayContainerScrollTop: function () {
			return this._vdisplaycontainer().scrollTop();
		},
		_setDisplayContainerScrollLeft: function (left) {
			if (left === undefined) {
				return;
			}
			this._vdisplaycontainer().scrollLeft(left);
		},
		_getDisplayContainerScrollLeft: function () {
			return this._vdisplaycontainer().scrollLeft();
		},
		//continuous virtualization: calculates average row height
		_calculateAvgRowHeight: function () {
			var rowHeightSum = this.container().find("#" + this.id() + ' > tbody').height();
			// M.H. 25 Jul 2013 Fix for bug #146837: Vertical scroll bar does not display when control inside the Jquery UI tab
			if (rowHeightSum === 0) {
				rowHeightSum = parseInt(this.options.height, 10);
			}
			// M.H. 18 Jul 2013 Fix for bug #146756: On deleting a row, the rows shrink their height and occupy only 50% of the grid's height and Average row height doesnot get applied
			if (this.options.virtualizationMode === "fixed") {
				if (this._fixedAvgRowHeight) {
					return this._fixedAvgRowHeight;
				}
				this._fixedAvgRowHeight = rowHeightSum / this._virtualRowCount;
			}
			return rowHeightSum / this._virtualRowCount;
		},
		////continuous virtualization: gets the visible area of the displayed container
		_getDisplayContainerVisibleArea: function () {
			var scrollTop = this._getDisplayContainerScrollTop(), height = this._getDisplayContainerHeight();
			return {top : scrollTop, bottom : (scrollTop + height)};
		},
		// M.H. 19 Jun 2013 Fix for bug #142650: igGrid.virtualScrollTo API method is not working
		virtualScrollTo: function (scrollerPosition) {
			/* Scroll to the specified row or specified position(in pixels)
				paramType="string|number" An identifier of the vertical scroll position. When it is string then it is interpreted as pixels otherwise it is the row number
			*/
			var avgRowHeight, $scrollContainer = this._scrollContainer(), pos = parseInt(scrollerPosition, 10);
			// it is scrollerPosition is how much to be scrolled in pixels
			if ($.type(scrollerPosition) !== 'string') {
				// M.H. 28 Feb 2014 Fix for bug #164139: IGGrid virtualScrollTo doesn't seem to be reliable for fixed and continuous virtualization
				if (this.options.virtualizationMode === "fixed") {
					avgRowHeight = parseInt(this.options.avgRowHeight, 10);
				} else {
					if (this._avgRowHeight) {
						avgRowHeight = this._avgRowHeight;
					} else {
						avgRowHeight = this._calculateAvgRowHeight();
					}
				}
				scrollerPosition--;
				//avgRowHeight =  Math.ceil(avgRowHeight);
				pos = avgRowHeight * scrollerPosition;
				pos = Math.ceil(pos);
				// M.H. 24 Feb 2014 Fix for bug #164139: IGGrid virtualScrollTo doesn't seem to be reliable for fixed and continuous virtualization
				this._virtualScrollToIndex = scrollerPosition;
			}
			$scrollContainer.scrollTop(pos);
		},
		// M.H. 19 Jun 2013 Fix for bug #142650: igGrid.virtualScrollTo API method is not working
		//continuous virtualization: tries to scroll, if not successful loads new portion of data
		_virtualScrollToInternal: function (virtualScrollerY) {
			var tableId, firstRow, lastRow, scrollData, scrollResult;
			if (virtualScrollerY === this._oldScrollTop) {
				return;
			}
			tableId = "#" + this.id();
			firstRow = this.container().find(tableId + ' > tbody > tr:first');
			lastRow = this.container().find(tableId + ' > tbody > tr:last');
			//I.I. bug fix for 104538
			if (firstRow.length === 0 || lastRow.length === 0) {
				return;
			}
			scrollData = {
				virtualScrollerY: this._getScrollContainerScrollTop(),
				deltaScroll: virtualScrollerY - this._oldScrollTop,
				firstRow: firstRow,
				lastRow: lastRow,
				firstRowDataIndex: parseInt(firstRow.attr('data-row-idx'), 0),
				lastRowDataIndex: parseInt(lastRow.attr('data-row-idx'), 0),
				visibleArea: this._getDisplayContainerVisibleArea()
			};
			scrollResult = { action: 'SA_INITIAL' };
			if (!this._tryScroll(scrollData, scrollResult)) {
				this._rebuildVirtualRows(scrollData, scrollResult);
			}
			this._correctScrollPosition(this._getTotalRowsCount());
		},
		//continuous virtualization: returns the length of the datasource; 
		//this method is overriden by the groupby feature since groupby uses different datasource, hence the length is calculated differently
		_getTotalRowsCount: function () {
			return this.dataSource.dataView().length;
		},
		//continuous virtualization: tries to scroll to a given position and returns whether the scroll is successful. 
		//If the scroll is not successful the method returns what action should be performed to display the required data
		_tryScroll: function (scrollData, scrollResult) {
			var deltaScroll, firstRow, lastRow, displayContainerHeight, displayContainerScrollTop;
			if (scrollResult === undefined) {
				throw new Error('scrollResult parameter should be provided');
			}
			deltaScroll = scrollData.deltaScroll;
			firstRow = scrollData.firstRow;
			lastRow = scrollData.lastRow;
			displayContainerHeight = this._getDisplayContainerHeight();
			displayContainerScrollTop = this._getDisplayContainerScrollTop();
			//check if scroll is possible at all
			//if this is a scroll down
			//check if the last virtual row would be within scrolling area if scrolled by deltaScroll
			//I.I. rework for bug 108439, 108641 and 109013
			if (deltaScroll > 0) {
				if (lastRow[0].offsetTop + lastRow.outerHeight() >= displayContainerScrollTop + deltaScroll + displayContainerHeight ||
						isNaN(scrollData.lastRowDataIndex) || scrollData.lastRowDataIndex === this.dataSource.dataView().length - 1) {
					this._setDisplayContainerScrollTop(displayContainerScrollTop + deltaScroll);
					scrollResult.action = 'SA_SUCCESSFUL';
					return true;
				}
				if (deltaScroll <= (this._avgRowHeight * this._virtualRowCount)) {
					// M.H. 24 Feb 2014 Fix for bug #164139: IGGrid virtualScrollTo doesn't seem to be reliable for fixed and continuous virtualization
					if (deltaScroll + displayContainerHeight > (this._avgRowHeight * this._virtualRowCount)) {
						scrollResult.action = 'SA_NEED_SOME_PAGE';
						return false;
					}
					scrollResult.action = 'SA_NEED_NEXT_PAGE';
					return false;
				}
			}
			//if this is a scroll up
			//check if the first virtual row would be within scrolling area if scrolled by deltaScroll
			if (deltaScroll < 0) {
				if (firstRow[0].offsetTop <= displayContainerScrollTop + deltaScroll ||
						scrollData.firstRowDataIndex === 0) {
					this._setDisplayContainerScrollTop(displayContainerScrollTop + deltaScroll);
					scrollResult.action = 'SA_SUCCESSFUL';
					return true;
				}
				if (Math.abs(deltaScroll) <= (this._avgRowHeight * this._virtualRowCount)) {
					scrollResult.action = 'SA_NEED_PREV_PAGE';
					return false;
				}
			}
			scrollResult.action = 'SA_NEED_SOME_PAGE';
			return false;
		},
		//continuous virtualization: gets called each time when after scrolling current TRs are not sufficient to display the required data
		_rebuildVirtualRows: function (scrollData, scrollResult) {
			var noCancel, virtualScrollerY, deltaScroll, tableId, visibleArea, tbody,
				expandedRowsHeight, trs, i, scrollerHeight, firstVisibleTR, firstVisibleTRRelativeOffset, startIndexToBeLoaded,
				newFirstVisibleRow, displayContainerScrollTop, maxScrollPos, avgRowHeight, tr, lastVisibleTR, lastVisibleTRIndex,
				firstVisibleTRIndex, endIndexToBeLoaded, dataRowIndexToBeFirst, hasOverflow;
			noCancel = this._trigger('rebuildingvirtualrows', null, {owner : this, scrollData : scrollData, scrollResult : scrollResult});
			if (noCancel === false) {
				return;
			}
			virtualScrollerY = scrollData.virtualScrollerY;
			deltaScroll = scrollData.deltaScroll;
			tableId = '#' + this.id();
			visibleArea = scrollData.visibleArea;
			tbody = this.container().find(tableId + ' > tbody');
			expandedRowsHeight = 0;
			trs = this.container().find(tableId + " > tbody > tr[data-container='true']");
			for (i = 0; i < trs.length; i++) {
				expandedRowsHeight += $(trs[i]).outerHeight();
			}
			if (expandedRowsHeight > 0) {
				scrollerHeight = this._getScrollContainerHeight();
				this._setScrollContainerHeight(scrollerHeight - expandedRowsHeight);
			}
			//next virtual page needed
			if (deltaScroll > 0 && scrollResult.action === 'SA_NEED_NEXT_PAGE') {
				firstVisibleTR = this._getFirstVisibleTR(visibleArea);
				//get first visible TR offset relative to visible area
				firstVisibleTRRelativeOffset = Math.abs(firstVisibleTR[0].offsetTop - visibleArea.top);
				//first loaded data row becomes the row which was first visble before
				startIndexToBeLoaded = parseInt(firstVisibleTR.attr('data-row-idx'), 0);
				dataRowIndexToBeFirst = startIndexToBeLoaded;
				endIndexToBeLoaded = parseInt(this._virtualRowCount, 0) + startIndexToBeLoaded - 1;
				hasOverflow = false;
				if (endIndexToBeLoaded > this.dataSource.dataView().length - 1) {
					endIndexToBeLoaded = this.dataSource.dataView().length - 1;
					startIndexToBeLoaded = endIndexToBeLoaded - this._virtualRowCount + 1;
					hasOverflow = true;
				}
				tbody.empty();
				this._renderRecords(startIndexToBeLoaded, endIndexToBeLoaded);
				if (hasOverflow) {
					tr = this.container().find(tableId + " > tbody > tr[data-row-idx='" + dataRowIndexToBeFirst + "']");
					firstVisibleTRRelativeOffset = tr[0].offsetTop + firstVisibleTRRelativeOffset;
				}
				//scroll to where last visible row was and add the new scrolling
				this._setDisplayContainerScrollTop(firstVisibleTRRelativeOffset + deltaScroll);
			}
			//prev virtual page needed
			if (deltaScroll < 0 && scrollResult.action === 'SA_NEED_PREV_PAGE') {
				//get last visible tr -> lastTR
				lastVisibleTR = this._getLastVisibleTR(visibleArea);
				lastVisibleTRIndex = parseInt(lastVisibleTR.attr('data-row-idx'), 0);
				firstVisibleTR = this._getFirstVisibleTR(visibleArea);
				firstVisibleTRIndex = parseInt(firstVisibleTR.attr('data-row-idx'), 0);
				//get its data index
				endIndexToBeLoaded = lastVisibleTRIndex;
				startIndexToBeLoaded = endIndexToBeLoaded - parseInt(this._virtualRowCount, 0) + 1;
				//TODO: if start is < 0, recalc
				if (startIndexToBeLoaded < 0) {
					startIndexToBeLoaded = 0;
					endIndexToBeLoaded = startIndexToBeLoaded + this._virtualRowCount - 1;
				}
				//rebind from dataIndex - this._virtualRowsCount to dataIndex
				tbody.empty();
				this._renderRecords(startIndexToBeLoaded, endIndexToBeLoaded);
				tableId = '#' + this.id();
				newFirstVisibleRow = this.container().find(tableId + ' > tbody > tr[data-row-idx="' + firstVisibleTRIndex + '"]');
				this._setDisplayContainerScrollTop(newFirstVisibleRow[0].offsetTop + deltaScroll);
			}
			if (scrollResult.action === 'SA_NEED_SOME_PAGE') {
				startIndexToBeLoaded = Math.floor(virtualScrollerY / this._avgRowHeight);
				endIndexToBeLoaded = startIndexToBeLoaded + this._virtualRowCount - 1;
				if (startIndexToBeLoaded < 0) {
					startIndexToBeLoaded = 0;
					endIndexToBeLoaded = startIndexToBeLoaded + this._virtualRowCount - 1;
				}
				if (endIndexToBeLoaded >= this.dataSource.dataView().length - 1) {
					endIndexToBeLoaded = this.dataSource.dataView().length - 1;
					startIndexToBeLoaded = endIndexToBeLoaded - this._virtualRowCount + 1;
				}
				tbody.empty();
				this._renderRecords(startIndexToBeLoaded, endIndexToBeLoaded);
				displayContainerScrollTop = 0;
				maxScrollPos = this._getScrollContainerHeight() - this._getDisplayContainerHeight();
				if (maxScrollPos - 3 <= virtualScrollerY && virtualScrollerY <= maxScrollPos + 3) {
					displayContainerScrollTop = 10000;
				}
				this._setDisplayContainerScrollTop(displayContainerScrollTop);
			}
//			if (expandedRowsHeight > 0) {
//				this._setScrollContainerHeight (this._getScrollContainerHeight() - expandedRowsHeight);
//			}
			avgRowHeight = this._calculateAvgRowHeight();
			if (avgRowHeight > this._avgRowHeight) {
				this._avgRowHeight = avgRowHeight;
				//this._setScrollContainerHeight(avgRowHeight * this.dataSource.dataView().length);
			}
			this._startRowIndex = startIndexToBeLoaded;
			this._startColIndex = 0;
			this._trigger('virtualrecordsrender', null, {owner: this, tbody: tbody, dom: this._virtualDom});
		},
		//continuous virtualization: corrects the virtual scroller position if needed. 
		//this is necessary because virtualization uses approximation to scroll to a certain row, since the rows height is not constant
		_correctScrollPosition: function (totalRowCount) {
			var scrollTop, maxScrollPos, tableId, firstRow, firstRowDataIndex, lastRow, lastRowDataIndex,
				visibleArea, tbody, rowsLeft, displayContainerScrollTop, targetRow, delta;
			scrollTop = this._getScrollContainerScrollTop();
			maxScrollPos = this._getScrollContainerHeight() - this._getDisplayContainerHeight();
			tableId = '#' + this.id();
			firstRow = this.container().find(tableId + ' > tbody > tr:first');
			firstRowDataIndex = parseInt(firstRow.attr('data-row-idx'), 0);
			lastRow = this.container().find(tableId + ' > tbody > tr:last');
			lastRowDataIndex = parseInt(lastRow.attr('data-row-idx'), 0);
			visibleArea = this._getDisplayContainerVisibleArea();
			tbody = this.container().find(tableId + ' > tbody');
			if (scrollTop === 0) {
				if (visibleArea.top > 0) {
					this._scrollTo(visibleArea.top, true);
				} else if (firstRowDataIndex > 0) {
					this._scrollTo(firstRowDataIndex * this._avgRowHeight, true);
				}
			} else if (scrollTop >= maxScrollPos - 3 && scrollTop <= maxScrollPos + 3) {
				if (visibleArea.bottom < tbody.height() && lastRowDataIndex === totalRowCount - 1) {
					this._scrollTo(this._getScrollContainerScrollTop() - (tbody.height() - visibleArea.bottom), true);
				} else if (lastRowDataIndex < totalRowCount - 1) {
					rowsLeft = totalRowCount - lastRowDataIndex;
					//this._scrollTo(this._getScrollContainerScrollTop() - (rowsLeft * this._avgRowHeight), true);
					this._setScrollContainerHeight(this._getScrollContainerHeight() + (rowsLeft * this._avgRowHeight));
				}
			}
			displayContainerScrollTop = this._getDisplayContainerScrollTop();
			if (displayContainerScrollTop === 0 && firstRowDataIndex === 0 && this._getScrollContainerScrollTop() !== 0) {
				this._scrollTo(0, true);
			}
			if (displayContainerScrollTop === (tbody.height() - this._getDisplayContainerHeight()) && lastRowDataIndex === totalRowCount - 1) {
				this._scrollTo(this._getScrollContainerHeight(), true);
			}
			// M.H. 24 Feb 2014 Fix for bug #164139: IGGrid virtualScrollTo doesn't seem to be reliable for fixed and continuous virtualization
			if (this._virtualScrollToIndex !== undefined && this._virtualScrollToIndex !== null) {
				//this._scrollTo(scrollTop - firstRow.scrollTop(), true);
				targetRow = this.container().find(tableId + ' > tbody > tr[data-row-idx=' + this._virtualScrollToIndex + ']');
				delta = 0;
				if (targetRow.length === 1 && firstRowDataIndex !== this._virtualScrollToIndex) {
					delta = targetRow.offset().top - firstRow.offset().top;
				}
				this._virtualScrollToIndex = null;
				if (delta > 0) {
					this._vdisplaycontainer().scrollTop(delta);
				}
			}
		},
		//continuous virtualization: used when correcting the virtual scroll position
		_scrollTo: function (scrollTop, suppressScrollEvent) {
			if (suppressScrollEvent) {
				this._suppressScroll = true;
			}
			this._setScrollContainerScrollTop(scrollTop);
		},
		//continuous virtualization: returns the first TR in the grid which is partly or fully visible
		_getFirstVisibleTR: function (visibleArea) {
			var tableId = '#' + this.element[0].id, firstVisibleTR, visibleAreaTop = visibleArea.top;

			$(tableId + ' > tbody > tr:visible').each(function (index) {
				firstVisibleTR = $(this);
				if (this.offsetTop + firstVisibleTR.height() > visibleAreaTop) {
					return false;
				}
			});
//			firstVisibleTR = $(tableId + ' > tbody > tr:visible').filter(function (index) {
//				return this.offsetTop + $(this).height() > visibleArea.top;
//			}).first();
			return firstVisibleTR;
		},
		//continuous virtualization: returns the last TR in the grid which is partly or fully visible
		_getLastVisibleTR: function (visibleArea) {
			var tableId = '#' + this.id(), lastVisibleTR;
			lastVisibleTR = this.container().find(tableId + ' > tbody > tr:visible').filter(function (index) {
				return this.offsetTop < visibleArea.bottom;
			}).last();
			return lastVisibleTR;
		},
		//continuous virtualization: determines total number of rows which are used by the virtualization
		_determineVirtualRowCount: function () {
			var div, rowNumber = 10, ds, rows = '', i, height, avgRowHeight, displayContainerHeight, rowsPerPage, result;
			ds = this.dataSource.dataView();
			if (rowNumber > ds.length) {
				rowNumber = ds.length;
			}
			div = $('<div></div>)').appendTo('body').css({position: 'absolute', top : -1800, left : -1800, visibility: 'hidden'});
			for (i = 0; i < rowNumber; i++) {
				rows += this._renderRecord(ds[i], i);
			}
			div.html(rows);
			height = div.height();
			avgRowHeight = height / rowNumber;
			displayContainerHeight = this._getDisplayContainerHeight();
			rowsPerPage = displayContainerHeight / avgRowHeight;
			result = Math.ceil(rowsPerPage * 3);
			div.remove();
			this._fireInternalEvent("_virtRowCountDetermined", result);
			return result;
		},
		_getTotalRowCount: function () {
			return this.dataSource.dataView().length;
		},
		//continuous virtualization: called when grid tries to render its rows for first time
		_renderVirtualRecordsContinuous: function () {
			this._totalRowCount = this._getTotalRowCount();
			if (this._totalRowCount === 0) {
				this._setScrollContainerHeight(0);
				this._virtualDom = [];
				return;
			}
			this._virtualRowCount = this._determineVirtualRowCount();
			if (this._virtualRowCount > this._totalRowCount) {
				this._virtualRowCount = this._totalRowCount;
			}
			this._scrollTo(0, true);
			this._renderRecords(this._virtualRowCount - 1);
			this._avgRowHeight = this._calculateAvgRowHeight();
			this._setScrollContainerHeight(this._totalRowCount * this._avgRowHeight);
		},
		//just rerenders currently rendered virtual rows; usefull when delete a row from updating feature
		_rerenderVirtualRecordsContinuous: function () {
			var tableId = '#' + this.id(), lastRow, lastRowDataIndex;
			//firstRow = $(tableId + ' > tbody > tr:first');
			lastRow = this.container().find(tableId + ' > tbody > tr:last');
			// S.S. April 24, 2013 Bug #140677. We'll get the first index by the internal this._startRowIndex var so that
			// when the tr-s are changed (such as when some are deleted) the proper amount of rows is rendered
			//firstRowDataIndex = parseInt(firstRow.attr('data-row-idx'), 0);
			lastRowDataIndex = parseInt(lastRow.attr('data-row-idx'), 0);
			this._renderRecords(this._startRowIndex, lastRowDataIndex);
			this._trigger('virtualrecordsrender', null, {owner: this, tbody: this.element.children("tbody"), dom: this._virtualDom});
		},
		//_virtualDom should be built because features like selection expects it
		_buildVirtualDomForContinuousVirtualization: function () {
			var rows, cells, i, j;
			if (this.options.virtualization === true && this.options.virtualizationMode === 'continuous') {
				this._virtualDom = [];
				rows = this.container().find('#' + this.id() + ' > tbody > tr');
				for (i = 0; i < rows.length; i++) {
					this._virtualDom[i] = [];
					cells = rows[i].children;
					for (j = 0; j < cells.length; j++) {
						this._virtualDom[i][j] = cells[j];
					}
				}
				//A.T. 12 July Bug #146756
				this._updateVirtualScrollContainer();
			}
		},
		// returns true if TD(DOM element passed as an argument) is in fixed container
		_isFixedElement: function ($td) {
			if (this.hasFixedColumns() && $td.closest('div').attr('data-fixed-container') !== undefined) {
				return true;
			}
			return false;
		},
		_getColumnByTD: function ($td) {
			// returns column object and visible index for the table cell(TD) which is passed as argument
			// table cell should be TD(jQuery object). If it has attributes data-skip or data-parent returns null
			var i, ind = 0, isFixed, $tr = $td.closest('tr'), res = {}, visibleInd, visibleColumns;
			if ($tr.length === 0) {
				return null;
			}
			if ($td.attr('data-parent') || $td.attr('data-skip')) {
				return null;
			}
			visibleInd = $td.index() - $tr.find("td[data-parent='true'],td[data-skip='true']").length;
			if ($td.is('td')) {
				visibleInd -= $tr.find("th").length;
			}
			if (visibleInd < 0) {
				return null;
			}
			visibleColumns = this._visibleColumns();
			if (visibleColumns.length <= visibleInd) {
				return null;
			}
			if (this.hasFixedColumns()) {
				// table cell is in fixed container
				res.index = visibleInd;
				isFixed = ($td.closest('div').attr('data-fixed-container') !== undefined);
				for (i = 0; i < visibleColumns.length; i++) {
					if ((isFixed && visibleColumns[i].fixed === true) || (!isFixed && visibleColumns[i].fixed !== true)) {
						if (ind++ === visibleInd) {
							res.column = visibleColumns[i];
							break;
						}
					}
				}
			} else {
				res = { column: visibleColumns[visibleInd], index: visibleInd };
			}
			return res;
		},
		_savePersistenceData: function (data, feature, layout) {
			// layout is ID(taken from the ID of the DOM element) of the specific child layout
			var topmostGrid = this, featureId = feature;
			if ($.type(layout) === 'string' && layout.length > 0) {
				topmostGrid = this.element.closest('.ui-iggrid-root').data('igGrid') || this;
				if (layout !== topmostGrid.element[0].id) {
					featureId = feature + '_' + layout;
				}
			}
			// init persistenceData for the specified feature(if not)
			topmostGrid.persistenceData = topmostGrid.persistenceData || {};
			topmostGrid.persistenceData[featureId] = data;
		},
		_getPersistenceData: function (feature, layout) {
			var topmostGrid = this, featureId = feature;
			if ($.type(layout) === 'string' && layout.length > 0) {
				topmostGrid = this.element.closest('.ui-iggrid-root').data('igGrid') || this;
				if (layout !== topmostGrid.element[0].id) {
					featureId = feature + '_' + layout;
				}
			}
			topmostGrid.persistenceData = topmostGrid.persistenceData || {};
			return topmostGrid.persistenceData[featureId];
		},
		destroy: function (notToCallDestroy) {
			/* destroy is part of the jQuery UI widget API and does the following:
				1. Remove custom CSS classes that were added.
				2. Unwrap any wrapping elements such as scrolling divs and other containers.
				3. Unbind all events that were bound.
			*/
			// we need to make sure we check if the element has siblings, if it doesn't we append the actual this.element to its parent
			// this is necessary to return everything exactly to its previous state in the DOM tree
			// we first want to destroy all features
			var prev = this.container().prev(), i, prepend = false, a, attr;
			// M.H. 29 Oct 2012 Fix for bug #120642
			if (this._scrollHeader && this._hscrollbarcontent().length > 0) {
				this._hscrollbarcontent().unbind("scroll", $.proxy(this._scrollHeader, this));
			}
			this._headerInitCallbacks = [];
			this._footerInitCallbacks = [];
			this.tmpDataSource = null;
			//A.T. 1 Sept. 2011 - Fix for bug #85486
			for (i = 0; i < this.options.features.length; i++) {
				// L.A. 20 February 2013 - jQuery 1.9 compatibility
				// Don't call destroy on non existing widget (or already destroyed one)
				if (this.element.data('igGrid' + this.options.features[i].name)) {
					this.element['igGrid' + this.options.features[i].name]('destroy');
			}
			}
			if (prev.length === 0) {
				prev = this.container().parent();
				prepend = true;
			}
			if (prepend) {
				prev.prepend(this.element);
			} else {
				//prev.append(this.element);
				// L.A. 10 May 2012 Bug #110557
				this.element.insertAfter(prev);
			}
			// M.H. 29 Oct 2012 Fix for bug #120642
			this.element.unbind('click', this._cellClickHandler);
			delete this._cellClickHandler;
			this.element.find('thead').empty();
			this.element.find('colgroup').empty();
			//A.T. 19 Feb 2011 - fix for bug #66088
			// call remove() on the children of the container instead of the container directly because this will automatically call destroy again
			// resulting in too much recursion error message 
			if (notToCallDestroy !== true) {
			$.Widget.prototype.destroy.call(this);
			}
			//A.T. 9 Jan Fix for bug #98790
			if (this._isWrapped && this.container().parent().data('igGrid')) {
				// remove the widget from the real container
				this.container().parent().removeData('igGrid');
				// L.A. 02 January 2013 - Fixing bug #129045 - When the grid is instantiatied with DIV element and you use 
				// jQueryUI 1.9.1 destroying and recreating the grid throws a js error.
				//this.container().parent().removeData('uiIgGrid');
                // M.H. 20 May 2013 Fix for bug #142657: Calling igGrid.destroy on DIV placeholder doesn't cleanup the grid instance when jQuery 2.0 and jQuery UI 1.10 are used
				if ($.ui.igGrid.prototype.widgetFullName &&
						$.ui.igGrid.prototype.widgetFullName !== 'igGrid' &&
						this.container().parent().data($.ui.igGrid.prototype.widgetFullName)) {
                    this.container().parent().removeData($.ui.igGrid.prototype.widgetFullName);
                }
			}
			this.container().remove();
			this._container = null;
			// now empty the records
			this.element.find('tbody').empty().removeClass(this.css.gridTableBodyClass).removeClass(this.css.gridRecordClass);
			this.element.removeClass(this.css.gridTableClass);
            // M.H. 17 Dec 2013 Fix for bug #151256: Performance issues caused by _resizeContainer function
            if (this._resizeContainerHandler && this.container().length > 0) {
                this.container()[0].detachEvent("onresize", this._resizeContainerHandler);
            }
            // M.H. 6 Nov 2013 Fix for bug #156713: Scrolling with the mouse wheel results in looping through a subset of the rows when using continuous virtualization in Chrome, Firefox, and Safari
            if (this._documentEvents) {
                $(document).unbind(this._documentEvents);
            }
			this.element.unbind('iggriduisoftdirty', this._uiSoftDirtyHandler);
			// M.H. 29 Oct 2012 Fix for bug #120642
			this.element.trigger(this.events.destroyed, {owner: this});
			delete this._uiSoftDirtyHandler;
			// clear reisizing timeout
			if (this._resId) {
				clearInterval(this._resId);
			}
            //L.A. 23 March 2012 Fixed bug #99841 Initializing the grid with any feature after a previous grid was bound and destroyed on the same DIV element causes an exception
			// K.D. April 9th, 2012 Bug #99841 Changing fix to be for the specific case of instantiating a grid on a div
			if (this._isWrapped) {
				this.element.remove();
			}
			// M.H. 31 Oct 2012 Fix for bug #125907
			if (this._hovEvts) {
				this.element.unbind(this._hovEvts);
				this._hovEvts = null;
			}
			if (notToCallDestroy === true) {
				return;
			}
			// M.H. 29 Oct 2012 Fix for bug #120642
			if (this.dataSource) {
				this._dataSource = null;
				// M.H. 13 Nov 2012 Fix for bug #120642
				this.dataSource = null;
			}
			this._dataOptions = null;
			this._originalOptions = null;
			//this.options = null;
			this._padding = null;
			this._originalOptions = null;
			this._loadingIndicator = null;
			this._headerParent = null;
			this._footerParent = null;
			this._footer = null;
			this._hovEvts = null;
			this._lastDataCol = null;
			this._lastFooterCol = null;
			this._lastHeaderCol = null;
			// M.H. 8 Jan 2014 Fix for bug #159857: Calling igGrid.destroy doesn't remove the COLGROUP, TFOOT and THEAD tags as well as some attributes on the placeholder
			if (this.element.is('table')) {
				this.element.empty();
				if (this._initialChildren) {
					this._initialChildren.appendTo(this.element);
				}
			}
			attr = this.element[0].attributes;
			a = [];
			for (i = 0; i < attr.length; i++) {
				if (attr[i].name !== 'id') {
					a.push(attr[i].name);
				}
			}
			for (i = 0; i < a.length; i++) {
				this.element.removeAttr(a[i]);
			}
			for (i = 0; i < this._initialAttributes.length; i++) {
				if (this._initialAttributes[i].name !== 'id') {
					this.element.attr(this._initialAttributes[i].name, this._initialAttributes[i].value);
				}
			}
			//this.events = null;
			return this;
		}
	});
	$.extend($.ui.igGrid, {version: '14.1.20141.2249'});
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid Multi Headers 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery, toStaticHTML, MSApp */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {
	var _aNull = function (val) { return val === null || val === undefined; };

	$.widget("ui.igGridColumnFixing", {
		/*
		igGridColumnFixing widget 
		The widget is pluggable to the element where the grid is instantiated and the actual igGrid object doesn't know about it.
		*/
		/* property showing whether it should be rendered in feature chooser */
		renderInFeatureChooser: true,
		events: {
			/* cancel="true" Event which is fired when column fixing operation is initiated
			use args.columnKey to get the column key of the column to be fixed
			use args.columnIndex to get the column index of the column to be fixed
			use args.owner to get a reference to the widget
			*/
			columnFixing: "columnFixing",
			/* Event which is fired when column fixing operation is finished
			use args.columnKey to get the column key of the fixed column
			use args.columnIndex to get the column index of the fixed column
			use args.owner to get a reference to the widget
			*/
			columnFixed: "columnFixed",
			/* cancel="true" Event which is fired when column unfixing operation is initiated
			use args.columnKey to get the column key of the column to be unfixed
			use args.columnIndex to get the column index of the column to be unfixed
			use args.owner to get a reference to the widget
			*/
			columnUnfixing: "columnUnfixing",
			/* Event which is fired when column unfixing operation is done
			use args.columnKey to get the column key of the unfixed column
			use args.columnIndex to get the column index of the unfixed column
			use args.owner to get a reference to the widget
			*/
			columnUnfixed: "columnUnfixed",
			/* Event which is fired when column fixing operation is initiated but sum of the width of the fixed columns container and width of the column to be fixed exceeds the grid width
			use args.columnKey to get the column key of the column to be fixed
			use args.isGroupHeader to get whether header cell is of type multicolumn (when multicolumn headers are defined)
			use args.owner to get a reference to the widget
			*/
			columnFixingRefused: "columnFixingRefused"
		},
		css: {
			/* Classes applied to the main fixed container */
			fixedContainer: 'ui-iggrid-fixedcontainer',
			/* classes applied to the container div of header button(which holds button for fixing/unfixing) */
			headerButtonIconContainer: 'ui-iggrid-fixcolumn-headerbuttoncontainer',
			/* Classes applied to the left side container */
			leftFixedContainer: 'ui-iggrid-fixedcontainer-left',
			/* Classes applied right side fixed container */
			rightFixedContainer: 'ui-iggrid-fixedcontainer-right',
			/* Classes applied to header cell button for fixing column */
			headerButtonIcon: 'ui-icon ui-corner-all ui-icon-pin-w',
			/* Classes applied to header cell button for fixing column */
			headerButtonIconHover: '',//ui-state-hover
			/* Classes applied to header cell button for unfixing column */
			headerButtonUnfixIcon: 'ui-icon ui-corner-all ui-icon-pin-s',
			/* Classes applied in feature chooser icon when column is not fixed */
			featureChooserIconClassFixed: 'ui-icon ui-iggrid-icon-unfix',
			/* Classes applied in feature chooser icon when column is fixed */
			featureChooserIconClassUnfixed: 'ui-icon ui-iggrid-icon-fix',
			/* Classes applied in unfixed table when fixing direction is left */
			unfixedTableLeft: 'ui-iggrid-unfixed-table-left',
			/* Classes applied in unfixed table when fixing direction is right */
			unfixedTableRight: 'ui-iggrid-unfixed-table-right'
		},
		internalErrors: {
			NotValidIndex: -1,
			FixingRefused: -2,
			AlreadyFixed: -3,
			AlreadyHidden: -4,
			UnfixingRefused: -5
		},
		options: {
			/* type="string" Specifies altering text on column fixing header icon when column is not fixed */
			headerFixButtonText: $.ig.ColumnFixing.locale.headerFixButtonText,
			/* type="string" Specifies altering text on column fixing header icon when column is fixed */
			headerUnfixButtonText: $.ig.ColumnFixing.locale.headerUnfixButtonText,
			/* type="bool" option to show column fixing buttons in header cells */
			showFixButtons: true,
			/* type="bool" option enable syncing heights of rows between fixed/unfixed rows */
			syncRowHeights: true,
			/* type="number" option to configure scroll delta when scrolling with mouse wheel or keyboard in fixed columns area*/
			scrollDelta: 40,
			/* type="left|right" configure on which side to render fixed area
				left type="string" fixed column are rendered on the left side of the main grid.
				right type="string" fixed column are rendered on the right side of the main grid.
			*/
			fixingDirection: 'left',
			/* type="array" a list of column settings that specifies custom column fixing options on a per column basis */
			columnSettings: [
				{
					/* type="string" Specifies column key. Either key or index must be set in every column setting.*/
					columnKey: null,
					/* type="number" Specifies column index. Either key or index must be set in every column setting.*/
					columnIndex: null,
					/* type="bool" Specifies whether the column allows to be fixed or not.*/
					allowFixing: true,
					/* type="bool" Specifies whether the column to be fixed or not.*/
					isFixed: false
				}
			],
			/* type="string" Feature chooser text of the fixed column*/
			featureChooserTextFixedColumn: $.ig.ColumnFixing.locale.featureChooserTextFixedColumn,
			/* type="string" Feature chooser text of the unfixed column*/
			featureChooserTextUnfixedColumn: $.ig.ColumnFixing.locale.featureChooserTextUnfixedColumn,
			/* type="string|number" minimal visible area for unfixed columns. For instance if you fix a column(or columns) and the width of the fixed columns is such that the width of visible are of unfixed columns is less than this option then fixing will be canceled
				string The width can be set in pixels (px) and percentage (%).
				number The width can be set as a number.
			*/
			minimalVisibleAreaWidth: 30,
			/* type="bool" Specify initial fixing of non data columns(like specific rowSelectors columns on the left side of the grid) when fixingDirection is left*/
			fixNondataColumns: true
		},
		/* value to check when grid height is not set and fixed and unfixed area has different heights. When difference is more than this value then append blank div to fixed area so to compensate horizontal scrollbar */
		scrollContainerCheckValue: 2,
		_createWidget: function () {
			// feature chooser data
			this._fcData = {};
			this._tds = {};
			this._containers = {};
			this._colgroups = {};
			this._isInitFC = false;
			this._isFunctionsOverriden = false;
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		_unfixColumnInternal: function (colKey, isGroupHeader) {
			var noCancel, res, grid = this.grid;
			
			noCancel = this._trigger(this.events.columnUnfixing, null, {
				//'columnIndex' : colInd,
				'columnIdentifier': colKey,
				'isGroupHeader': isGroupHeader,
				owner: grid
			});
			if (noCancel) {
				res = this.unfixColumn(colKey, isGroupHeader);
				this._trigger(this.events.columnUnfixed, null, {
					'columnIdentifier': colKey,
					'isGroupHeader': isGroupHeader,
					owner: grid
				});
			}
			return res;
		},
		unfixColumn: function (colIdentifier, isGroupHeader) {
			/* Unfix column by specified column identifier - column key or column index
			paramType="number|string" An identifier of the column to be unfixed - column index or column key.
			paramType="bool" when true indicates that the column is multi-column header.
			*/
			var col, self = this, res, colWidth, scrollContainer, fixedContainer, $fixedTable, $unfixedTable,
				hasDataSkippedColumns = this._hasDataSkippedColumns(true), fc, c,
				children, columnKeys, columnIndex, colKey, MCHchildren, key, $th, containerBody, containerHeader,
				colIdentifierType = $.type(colIdentifier), containerFooter, initialFixedColsIndex,
				i, j, cols = this.grid.options.columns, colsLength = cols.length,
				grid = this.grid,
				initialFixedColumnsLength = this.grid._fixedColumns.length,
				columnIndexes = [],
				visibleIndex,
				vI, inMCHGroup,
				gridId = grid.id();
			
			res = {error: this.internalErrors.None, result: true, col: null, columnIndex: undefined};
			columnKeys = [];
			// M.H. 22 Feb 2013 Fix for bug #133770: fixColumn and unfixColumn methods should work with column index and column key.
			if (!isGroupHeader) {
				if (colIdentifierType === 'number') {
					columnIndex = colIdentifier;
				} else if (colIdentifierType === 'string') {
					for (i = 0; i < colsLength; i++) {
						if (cols[i].key === colIdentifier) {
							columnIndex = i;
							break;
						}
					}
					if (i === colsLength) {
						res.result = false;
						res.error = this.internalErrors.NotValidIdentifier;
						return res;
					}
				}
				col = cols[columnIndex];
				if (col === null || col === undefined) {
					res.result = false;
					res.error = this.internalErrors.NotValidIdentifier;
					return res;
				}
				// M.H. 4 Mar 2013 Fix for bug #134298: When calling fixColumn with index the method fixes the wrong column the third time.
				if (col.fixed === false) {
					res.result = false;
					res.error = this.internalErrors.AlreadyFixed;
					return res;
				}
				colKey = col.key;
				columnKeys.push(colKey);
				visibleIndex = this._getVisibleIndex(colKey, true);
				$th = this.grid.container().find("#" + gridId + "_" + colKey);
				res.columnIndex = columnIndex;
				res.col = col;
				columnIndexes.push({ cI: columnIndex, vI: visibleIndex });
				children = [col];
			} else {
				c = [];
				$th = this.grid.fixedHeadersTable().find('th[data-mch-id=' + colIdentifier + ']');
				colKey = colIdentifier;
				MCHchildren = this.grid._getMultiHeaderColumnById(colIdentifier);
				children = MCHchildren.children;
				columnKeys = [];
				for (i = 0; i < children.length; i++) {
					key = children[i].key;
					columnKeys.push(key);
					if (children[i].hidden === true) {
						vI = -1;
					} else {
						vI = this._getVisibleIndex(children[i].key, true);
						c.push(children[i]);
					}
					for (j = 0; j < colsLength; j++) {
						if (cols[j].key === key) {
							columnIndexes.push({ cI: j, vI: vI });
							break;
						}
					}
				}
				children = c;
			}
			// in case there is only 1 visible column in fixed area and we try to unfix
			if (!this.checkUnfixingAllowed(children)) {
				res.result = false;
				res.error = this.internalErrors.UnfixingRefused;
				return res;
			}
			if ($th.length > 0) {
				colWidth = $th.outerWidth();
			} else {
				colWidth = this.grid.container().find("#" + this.grid.id() + " tbody tr:nth-child(1) td:nth-child(" + (visibleIndex + 1) + ")").outerWidth();
			}
			this._populateContainers();
			containerBody = this._containers.body;
			containerHeader = this._containers.header;
			containerFooter = this._containers.footer;
			if (!containerHeader) {
				containerHeader = containerBody;
			}
			if (!containerFooter) {
				containerFooter = containerBody;
			}
			scrollContainer = containerBody.unfixedContainer;
			colWidth = -colWidth;
			if (this._hasWidthInPercent() && this.grid._allColumnWidthsInPercentage) {
				colWidth = '-' + col.width;
			}
			initialFixedColsIndex = self.grid._fixedColumns.length - 1;
			inMCHGroup = true;
			for (i = columnIndexes.length - 1, j = 0; i > -1; i--, j++) {
				if (columnIndexes[i].vI !== -1) {
					visibleIndex = columnIndexes[i].vI + 1;
					this._unfixColumnByVisibleIndex(visibleIndex, colWidth, false, inMCHGroup, colKey, isGroupHeader);
					inMCHGroup = false;
				}
				col = cols.splice(columnIndexes[i].cI, 1);
				col[0].fixed = false;
				cols.splice(initialFixedColsIndex - j, 0, col[0]);
				vI = -1;
				if (columnIndexes[i].vI !== -1) {
					vI = columnIndexes[i].vI + 1;
				}
				this.grid._onColumnFixed(columnIndexes[i].cI, false, initialFixedColumnsLength - j, false, vI);
			}
			for (i = 0; i < columnKeys.length; i++) {
				key = columnKeys[i];
				for (j = 0; j < this.grid._fixedColumns.length; j++) {
					if (this.grid._fixedColumns[j].key === key) {
						col = self.grid._fixedColumns.splice(j, 1);
						col[0].fixed = false;
						break;
					}
				}
			}
			this.grid._visibleColumnsArray = undefined;
			this.grid._hscrollbar().css({
				width:  scrollContainer.width() + 'px',
				left: 0
			});
			if ($.ig.util.isIE10 ||
					(this._hasWidthInPercent() && !this.grid._allColumnWidthsInPercentage)) {
				this.grid._hscrollbar().width('');
			}
			// M.H. 23 Aug 2013 Fix for bug #150279: When fixingDirection is "right" and row selectors are enabled unfixing columns breaks the grid.
			if (this.grid._fixedColumns.length === 0 &&
				(!hasDataSkippedColumns || this.options.fixingDirection === 'right' ||
				(hasDataSkippedColumns && !this.options.fixNondataColumns))) {
				// remove skipped columns
				if (this.options.fixingDirection === 'left') {
					this.unfixDataSkippedColumns();
				}
				fixedContainer = this._containers.body.fixedContainer;
				if (this._onMouseWheelHandler) {
					scrollContainer.unbind({
						keydown: this._onKeyDown,
						mousewheel: this._onMouseWheelHandler
					});
					fixedContainer.unbind({
						mousewheel: this._onMouseWheelHandler
					});
					this._onKeyDown = null;
					this._onMouseWheelHandler = null;
				}
				// M.H. 12 Dec 2013 Fix for bug #159796: Fixing the first column causes misalignment between rows in fixed/unfixed area(in the new theme)
				if (this._containers && this._containers.body) {
					this._containers.body.unfixedTable
						.removeClass(this.css.unfixedTableLeft)
						.removeClass(this.css.unfixedTableRight);
				}
				// M.H. 26 Feb 2013 Fix for bug #134003: When the fixingDirection is "right" mouse wheel scroll does not work when you hover the unfixed area.
				if (this._DOMMouseScroll !== null && this._DOMMouseScroll !== undefined) {
					scrollContainer.unbind({
						DOMMouseScroll: this._DOMMouseScroll
					});
					this._DOMMouseScroll = null;
				}
				grid.fixedContainer().remove();
				if (this.options.fixingDirection === 'right') {
					scrollContainer.css({'overflow-y': 'auto'});
				}
				// M.H. 21 Feb 2013 Fix for bug #133521: When you fix and unfix a column the width of the columns changes and scrolling the grid to the right misaligns it.
				grid._hscrollbar().css({
					width:  '100%',
					left: 0
				});
				// M.H. 24 Feb 2013 Fix for bug #133421: Columns and headers are misaligned on fixing a column when grid and its columns doesn't have width set
				if (grid.options.width === null && grid.container()[0].style.width === '') {
					grid.container().css('width', '');
				}
				containerHeader.unfixedTable.find('thead').eq(0).find('tr[data-header-row]').eq(0).css('height', '');
			} else if (this.options.syncRowHeights) {
				// M.H. 13 Dec 2013 Fix for bug #159796: Fixing the first column causes misalignment between rows in fixed/unfixed area(in the new theme)
				$fixedTable = this._containers.body.fixedTable;
				$unfixedTable = this._containers.body.unfixedTable;

				if (Math.abs($fixedTable.outerHeight() - $unfixedTable.outerHeight()) > 1 ||
					Math.abs($fixedTable.find('tbody tr:last').offset().top - $unfixedTable.find('tbody tr:last').offset().top) > 1) {
					this._syncRowsHeights($fixedTable, $unfixedTable);
					$unfixedTable.height($fixedTable.height());
				}
			}
			grid._updateHeaderColumnIndexes();
			grid._columnMovingResets();
			this._updateGridColWidths();
			this.grid._hscrollbarcontent().scrollLeft(0);
			if (isGroupHeader) {
				this._changeStyleHeaderButton(colIdentifier, false, isGroupHeader);
			} else {
				for (i = 0; i < columnKeys.length; i++) {
					this._changeStyleHeaderButton(columnKeys[i], false, isGroupHeader);
				}
			}
			// M.H. 22 Jul 2013 Fix for bug #147064: When column is resized and the content of the cells is distributed on two rows the rows from both areas are misaligned.
			// when width is changed gridContentWidth is not taken properly on unfixing columns
			if (this.grid.element.data("igGridResizing")) {
				this.grid._updateGridContentWidth();
			}
			// M.H. 8 Jan 2014 Fix for bug #161032: The fixing icon in the feature chooser does not change when you fix a column with API method.
			fc = this.grid.element.data('igGridFeatureChooser');
			if (fc !== undefined && fc !== null) {
				fc._setSelectedState('ColumnFixing', colKey, false, false);
			}
			grid._adjustLastColumnWidth(true);
			return res;
		},
		_getKeyByVisibleIndex: function (index, isFixed) {
			var hasDataSkippedColumns = this._hasDataSkippedColumns(), cols, col,
				dataSkippedColsLength = 0, visibleCols = this.grid._visibleColumns();

			cols = $.grep(visibleCols, function (col) {
				var f = (col.fixed === true);
				return f === isFixed;
			});
			if (hasDataSkippedColumns) {
				dataSkippedColsLength = this._getDataSkippedColumnsLength(isFixed);
				index -= dataSkippedColsLength;
			}
			// M.H. 16 June 2014 Fix for bug #173254: When ColumnFixing, RowSelectors and Tooltips are enabled hovering the row selector throws a js error.
			col = cols[index];
			if (!col) {
				return undefined;
			}
			return col.key;
		},
		_unfixColumnByVisibleIndex: function (
				visibleIndex,
				colWidth,
				isDataSkip,
				inMCHGroup,
				colIdentifier,
				isGroupHeader) {
			var grid = this.grid,
				containerBody = this._containers.body,
				containerHeader = this._containers.header,
				containerFooter = this._containers.footer,
				isMCH = grid._isMultiColumnGrid;
			
			if (!containerHeader) {
				containerHeader = containerBody;
			}
			if (!containerFooter) {
				containerFooter = containerBody;
			}
			this._getElementsByDOM(visibleIndex, containerHeader.fixedTable.find('thead').eq(0), 'header', false, isDataSkip);
			this._getElementsByDOM(visibleIndex, containerBody.fixedTable.find('tbody').eq(0), 'body', false, isDataSkip);
			this._getElementsByDOM(visibleIndex, containerFooter.fixedTable.find('tfoot').eq(0), 'footer', false, isDataSkip);
			this._getColgroups(visibleIndex, true);
			if (isDataSkip) {
				if (this._tds.header.length > 0) {
					colWidth = $(this._tds.header[0]).outerWidth();
				} else if (this._tds.body.length > 0) {
					colWidth = $(this._tds.body[0]).outerWidth();
				}
				colWidth = -colWidth;
			}
			this._detachColgroups(true);
			// detach header/ body / footer cells
			this._tds.header.detach();
			this._tds.body.detach();
			this._tds.footer.detach();
			if (inMCHGroup || isDataSkip) {
				this._syncWidth(colWidth);
			}
			this._attachColgroups(true);
			if (grid.options.showHeader) {
				this._unfixHeaderColumn();
			}
			this._unfixBodyColumn(visibleIndex);
			this._unfixFooterColumn(visibleIndex);

			if (grid.options.showHeader && isMCH && inMCHGroup) {
				this._unfixMultiColumnHeader(colIdentifier, isGroupHeader);
//				this._getElementsByDOM(visibleIndex, containerHeader.fixedTable.find('thead').eq(0), 'header');
//				this._unfixHeaderColumn();
			}
		},
		_setOption: function (key, value) {
			if (value === this.options[key]) {
				return;
			}
			$.Widget.prototype._setOption.apply(this, arguments);
			if (key === 'minimalVisibleAreaWidth') {
				this.grid._visibleAreaWidth(value);
			}
		},
		unfixDataSkippedColumns: function () {
			/* Unfix data skipped columns(like row selectors) if any when fixingDirection is left
			*/
			var i, dataSkippedColsLength,
				isMCH = this.grid._isMultiColumnGrid,
				hasDataSkippedColumns = this._hasDataSkippedColumns();
			// we should fix data skipped columns if any - for now supported scenario is ONLY if fixing direction is LEFT
			if (this.options.fixingDirection === 'left' && hasDataSkippedColumns) {
				dataSkippedColsLength = this._getDataSkippedColumnsLength(true);
				if (isMCH) {
					this._unfixMultiColumnHeaderDataSkip();
				}
				this.grid._hasFixedDataSkippedColumns = false;
				for (i = dataSkippedColsLength - 1; i > -1; i--) {
					this._unfixColumnByVisibleIndex((i + 1), null, true);
					this.grid._onColumnFixed(-1, false, 0, false);
				}
			}
		},
		unfixAllColumns: function () {
			/* Unfix all columns
			*/
			// M.H. 6 Jun 2013 Fix for bug #142858: The grid's multi column headers are shuffled when you fix a few groups and then you call unfixAllColumns.
			var i, ths, self = this, colsToUnfix = [], isMCH = this.grid._isMultiColumnGrid, cols = this.grid._fixedColumns, colsLength = cols.length;
			// M.H. 5 Mar 2013 Fix for bug #134548: UnfixAllColumns method reverts the order of columns.
			if (colsLength > 0) {
				if (isMCH) {
					// get first table row in headears fixed table - it is with fixed table top lever(root) cells and get IDs - column keys, data-mch-id
					ths = this.grid.fixedHeadersTable().find('thead tr[data-mch-level]:nth-child(1) th');
					ths.each(function (index, th) {
						var $th = $(th), id, isGroupHeader = true;

						id = $th.attr('data-mch-id');
						if (id === undefined) {
							id = $th.attr('id').replace(self.grid.id() + '_', '');
							isGroupHeader = false;
						}
						colsToUnfix.push({id: id, isGroupHeader: isGroupHeader});
					});
				} else {
					for (i = 0; i < colsLength; i++) {
						colsToUnfix.push({id: cols[i].key, isGroupHeader: undefined});
					}
				}

				if (colsToUnfix.length > 0) {
					for (i = colsToUnfix.length - 1; i >= 0; i--) {
						this.unfixColumn(colsToUnfix[i].id, colsToUnfix[i].isGroupHeader);
					}
				}
			}
		},
		_unfixMultiColumnHeaderDataSkip: function () {
			var i, $th, dataSkippedColsLength, $unfixedThead, $fixedThead,
				maxLevel = this.grid._maxLevel,
				container = this._containers.header;
				
				if (!container) {
					container = this._containers.body;
				}
				$unfixedThead = container.unfixedTable.find('thead');
				$fixedThead = this.grid.container().find("#" + container.unfixedTable.attr("id") + "_fixed").find('thead');

			if (this._hasDataSkippedColumns() && this.options.fixingDirection === 'left') {
				dataSkippedColsLength = this._getDataSkippedColumnsLength(true);
				for (i = dataSkippedColsLength - 1; i > -1; i--) {
					$th = $fixedThead.find('tr[data-mch-level=' + maxLevel + '] th[data-skip]:nth-child(' + (i + 1) + ')');
					$th.detach();
					$th.prependTo($unfixedThead.find('tr[data-mch-level=' + maxLevel + ']'));
				}
			}
		},
		_unfixMultiColumnHeader: function (colId, isGroupHeader) {
			var grid = this.grid, i, $th,
				gridId = grid.id(),
				maxLevel, cols,
				$fixedThead, $unfixedThead, fixedTable, oTable;
			
			if (this._containers.header) {
				oTable = this._containers.header.unfixedTable;
				fixedTable = this._containers.header.fixedTable;
			} else {
				oTable = this._containers.body.unfixedTable;
				fixedTable = this._containers.body.fixedTable;
			}
			$unfixedThead = oTable.find('thead');
			$fixedThead = fixedTable.find('thead');
			maxLevel = grid._maxLevel;
			if (isGroupHeader) {
				cols = grid._oldCols;
				for (i = 0; i < cols.length; i++) {
					if (cols[i].identifier === colId) {
						cols[i].fixed = false;
						this._unfixMCHColumn(cols[i], $fixedThead, $unfixedThead);
						break;
					}
				}
			} else {
				//$th = $('#' + gridId + '_' + colId);
				$th = this.grid.container().find("#" + gridId + "_" + colId);
				$th.detach().prependTo($unfixedThead.find('tr[data-mch-level=' + maxLevel + ']'));
			}
		},
		_updateGridColWidths: function () {
			// update grid variables for column widths - needed for adjustLastColumnWidth
			var totalColWidth = 0, lastColWidth, i, w, cols, grid = this.grid;

			if (grid._allColumnWidthsInPixels) {
				cols = grid._visibleColumns();
				for (i = 0; i < cols.length; i++) {
					if (!cols[i].fixed && cols[i].width) {
						w = parseInt(cols[i].width, 10);
						totalColWidth += w;
						lastColWidth = w;
					}
				}
				grid._lastColPixelWidth = lastColWidth;
				grid._totalColPixelWidth = totalColWidth;
			}
		},
		_unfixMCHColumn: function (el, $fixedHeader, $unfixedHeader) {
			var level = el.level, $th, domLevel, children, i;

			if (level === 0) {
				//$th = $('#' + this.grid.id() + '_' + el.key);
				$th = this.grid.container().find("#" + this.grid.id() + "_" + el.key);
			} else {
				$th = $fixedHeader.find('th[data-mch-id=' + el.identifier + ']');
				children = el.group;
			}
			domLevel = $th.closest('tr').attr('data-mch-level');
			$th.detach();
			$th.prependTo($unfixedHeader.find('tr[data-mch-level=' + domLevel + ']'));
			if (level > 0) {
				for (i = children.length - 1; i > -1; i--) {
					this._unfixMCHColumn(children[i], $fixedHeader, $unfixedHeader);
				}
			}
		},
		// M.H. 21 Aug 2013 Fix for bug #149676: When row selectors are enabled and you fix and unfix a column and then fix a column whose data is spanned on two rows the fixed and unfixed areas are misaligned.
		_isLastColumn: function () {
			var hasDataSkippedCols = this._hasDataSkippedColumns(),
				countFixedCols = this.grid._fixedColumns.length;
			
			return (countFixedCols === 1 && !hasDataSkippedCols) || (hasDataSkippedCols && countFixedCols === 0);
		},
		_unfixHeaderColumn: function () {
			var i, trs, dataSkippedColsLength,
				$unfixedThead,
				tdsFirst, oTable;
			
			if (this._containers.header) {
				oTable = this._containers.header.unfixedTable;
			} else {
				oTable = this._containers.body.unfixedTable;
			}
			$unfixedThead = oTable.find('thead');
			tdsFirst = this._tds.header;
			trs = $unfixedThead.find('tr:not([data-mch-level],[data-skip])');
			// M.H. 23 Aug 2013 Fix for bug #150279: When fixingDirection is "right" and row selectors are enabled unfixing columns breaks the grid.
			if (this._hasDataSkippedColumns(true) && this.options.fixingDirection === 'right') {
				dataSkippedColsLength = this._getDataSkippedColumnsLength();
				for (i = 0; i < trs.length; i++) {
					$(tdsFirst[i]).insertAfter(trs[i].children[dataSkippedColsLength - 1]);
				}
			} else {
				for (i = 0; i < trs.length; i++) {
					$(tdsFirst[i]).prependTo(trs[i]);
				}
			}
		},
		_unfixBodyColumn: function (colInd) {
			var i, tdsFirst, dataSkippedColsLength, trs,
				oTable = this._containers.body.unfixedTable,
				scrollContainer = this._containers.body.unfixedContainer,
				oTableWidth = oTable.width();
			// M.H. 20 Mar 2013 Fix for bug #137003: If you fix a column then fix a column with smaller width unfixing the bigger one makes the smaller's width bigger and fixing breaks after that.
			tdsFirst = this._tds.body;
			trs = oTable.find('tbody tr');
			// M.H. 23 Aug 2013 Fix for bug #150279: When fixingDirection is "right" and row selectors are enabled unfixing columns breaks the grid.
			if (this._hasDataSkippedColumns(true) && this.options.fixingDirection === 'right') {
				dataSkippedColsLength = this._getDataSkippedColumnsLength();
				for (i = 0; i < trs.length; i++) {
					$(tdsFirst[i]).insertAfter(trs[i].children[dataSkippedColsLength - 1]);
				}
			} else {
				trs.each(function (ind, tr) {
					var $td = $(tdsFirst[ind]);
					$td.prependTo($(tr));
				});
			}
			scrollContainer.scrollTop(0);
			// M.H. 21 Feb 2013 Fix for bug #133521: When you fix and unfix a column the width of the columns changes and scrolling the grid to the right misaligns it.
			this.grid._hscrollbarinner().css({
				width:  (this.grid._hasVerticalScrollbar && this.grid.options.fixedHeaders ? oTableWidth - this.grid._scrollbarWidth() : oTableWidth) + 'px',
				left: 0
			});
			// M.H. 21 Aug 2013 Fix for bug #149676: When row selectors are enabled and you fix and unfix a column and then fix a column whose data is spanned on two rows the fixed and unfixed areas are misaligned.
			if (this._isLastColumn()) {
				trs.height('');
			}
			// M.H. 24 Feb 2013 Fix for bug #133421: Columns and headers are misaligned on fixing a column when grid and its columns doesn't have width set
			if (this.grid.options.width === null) {
				if (this.grid._fixedColumns.length === 1) {
					oTable[0].style.width = '';
				}
			}
		},
		_unfixFooterColumn: function (colInd) {
			var i, container = this._containers.footer, dataSkippedColsLength, oTable, tdsFirst, trs;
			
			if (!container) {
				container = this._containers.body;
			}
			oTable = container.unfixedTable;
			tdsFirst = this._tds.footer;
			trs = oTable.find('tfoot tr');
			// M.H. 23 Aug 2013 Fix for bug #150279: When fixingDirection is "right" and row selectors are enabled unfixing columns breaks the grid.
			if (this._hasDataSkippedColumns(true) && this.options.fixingDirection === 'right') {
				dataSkippedColsLength = this._getDataSkippedColumnsLength();
				for (i = 0; i < trs.length; i++) {
					$(tdsFirst[i]).insertAfter(trs[i].children[dataSkippedColsLength - 1]);
				}
			} else {
				trs.each(function (ind, tr) {
					var $td = $(tdsFirst[ind]);
					$td.prependTo($(tr));
				});
			}
			// M.H. 21 Aug 2013 Fix for bug #149676: When row selectors are enabled and you fix and unfix a column and then fix a column whose data is spanned on two rows the fixed and unfixed areas are misaligned.
			if (this._isLastColumn()) {
				trs.height('');
			}
		},
		_fixColumnInternal: function (colKey, isGroupHeader) {
			var noCancel, res, grid = this.grid;
			
			// M.H. 5 Jun 2013 Fix for bug #143728: The ui's isGroupHeader property of columnFixing and columnFixed events is undefined.
			if (isGroupHeader === undefined || isGroupHeader === null) {
				isGroupHeader = false;
			}
			noCancel = this._trigger(this.events.columnFixing, null, {
				//'columnIndex' : colInd,
				'columnIdentifier': colKey,
				'isGroupHeader': isGroupHeader,
				owner: grid
			});
			if (noCancel) {
				res = this.fixColumn(colKey, isGroupHeader);
				if (res.error === this.internalErrors.FixingRefused || res.result === false) {
					this._trigger(this.events.columnFixingRefused, null, {
						//'columnIndex' : colInd,
						'columnIdentifier': colKey,
						'isGroupHeader': isGroupHeader,
						owner: grid
					});
				} else {
					//grid._trigger(grid.events.columnsCollectionModified, null, {owner: grid});
					this._trigger(this.events.columnFixed, null, {
						'columnIdentifier': colKey,
						'isGroupHeader': isGroupHeader,
						owner: grid
					});
				}
			}
			return res;
		},
		_getVisibleIndex: function (colId, isFixed, ignoreDataSkip) {
			// get visible index in fixed/unfixed table
			if ($.type(colId) === 'number') {
				return colId;
			}
			var i, fixedCol, unfixedColsLength, unfixedCols, col,
				cols = this.grid._visibleColumns(), visibleIndex = 0,
				fixedCols = this.grid._fixedColumns, fixedColsLength = fixedCols.length;

			if (isFixed === undefined) {
				col = this.grid.columnByKey(colId);
				if (col) {
					isFixed = (col.fixed === true);
				}
			}
			if (isFixed) {
				for (i = 0; i < fixedColsLength; i++) {
					fixedCol = fixedCols[i];
					if (fixedCol.key === colId) {
						break;
					}
					if (!fixedCol.hidden) {
						visibleIndex++;
					}
				}
			} else {
				unfixedCols = [];
				unfixedColsLength = 0;
				for (i = 0; i < cols.length; i++) {
					if (!cols[i].fixed) {
						unfixedColsLength++;
						unfixedCols.push(cols[i]);
					}
				}
				for (i = 0; i < unfixedColsLength; i++) {
					if (unfixedCols[i].key === colId) {
						break;
					}
					visibleIndex++;
				}
			}
			if (ignoreDataSkip) {
				return visibleIndex;
			}
			// M.H. 23 Aug 2013 Fix for bug #150176: [RowSelectors]When fixingDirection is right and you fix column the grid breaks
			// TODO: we should take into account skip columns(for instance expanders for hierarchical grid, group by, row selectors, etc)
			if (this._hasDataSkippedColumns()) {
				if (this.options.fixingDirection === 'left') {
					if (isFixed) {
						visibleIndex += this._getDataSkippedColumnsLength(isFixed);
					}
				} else if (!isFixed) {
					// M.H. 23 Aug 2013 Fix for bug #150279: When fixingDirection is "right" and row selectors are enabled unfixing columns breaks the grid.
					visibleIndex += this._getDataSkippedColumnsLength();
				}
			}

			return visibleIndex;
		},
		checkFixingAllowed: function (columns) {
			/* Check whether fixing is allowed for the passed argument - columns. It should not be allowed if there is only one visible column in unfixed area and there are hidden unfixed columns
			paramType="array" array of columns - could be column indexes, column keys, column object or mixed
			returnType="bool" returns whether it is allowed fixing for the specified columns
			*/
			if (this.grid._visibleColumns(false).length - columns.length < 1) {
				return false;
			}
			return this._isFixingUnfixingAllowed(columns, true);
		},
		checkUnfixingAllowed: function (columns) {
			/* Check whether unfixing is allowed for the passed argument - columns. It should not be allowed if there is only one visible column in fixed area and there are hidden fixed columns
			paramType="array" array of columns - could be column indexes, column keys, column object or mixed
			returnType="bool" returns whether it is allowed unfixing for the specified columns
			*/
			return this._isFixingUnfixingAllowed(columns, false);
		},
		_isFixingUnfixingAllowed: function (columns, isToFix) {
			// columns - array of columns - could be column indexes, column keys, column object or mixed
			// isToFix - boolean argument - check whether for the passed columns it is allowed to fix, if false then it is checked it is possible to unfix columns
			// Check whether fixing/unfixing is allowed
			// It should NOT be allowed if there is ONLY one visible column(and hidden unfixed columns) in unfixed area and trying to fix it or ONLY one visible fixed column(and there are other fixed hidden columns) and trying to unfix it
			var i, columnsLength = columns.length,
				hasHiddenUnfixed, hasHiddenFixed,
				oCols = this.grid.options.columns, oColsLength = oCols.length;

			for (i = 0; i < oColsLength; i++) {
				if (oCols[i].hidden) {
					if (oCols[i].fixed && !isToFix) {
						hasHiddenFixed = true;
						break;
					}
					if (!oCols[i].fixed && isToFix) {
						hasHiddenUnfixed = true;
						break;
					}
				}
			}
			if (i === oColsLength) {
				return true;
			}
			if ((isToFix && (this.grid._visibleColumns(false).length - columnsLength) < 1 && hasHiddenUnfixed) ||
				(!isToFix && (this.grid._visibleColumns(true).length - columnsLength) < 1 && hasHiddenFixed)) {
				return false;
			}
			return true;
		},
		fixColumn: function (colIdentifier, isGroupHeader) {
			/* Fix column by specified column identifier - column index or column key
			paramType="number|string" An identifier of the column to be fixed - column index or column key.
			paramType="bool" when true indicates that the column is multi-column header.
			*/
			var col, colWidth, columnIndex, res, i, j, children, $fixedTable, $unfixedTable, fc,
				colIdentifierType = $.type(colIdentifier), colKey, visibleIndex, isI,
				containerBody, containerHeader, shoulRerendedColgroups,
				grid = this.grid, gridId = grid.id(), $th, vI,
				isGridWidthPercentage = ($.type(grid.options.width) === 'string' && grid.options.width.indexOf('%') !== -1),
				MCHchildren,
				$mainFixedContainer,
				mainFixedContainerWidth = 0,
				gridWidth = parseInt(grid.options.width, 10),
				columnIndexes = [],
				hasDataSkippedColumns = false,
				initialFixedColumnsLength = this.grid._fixedColumns.length,
				isInit = (initialFixedColumnsLength === 0),
				inMCHGroup,
				cols = this.grid.options.columns, colsLength = cols.length;
			// it is possible to be thrown error when fixing column - for instance colIdentifier is not correct, the column is already fixed, etc. Used also in client side event columnFixingRefused
			res = { error: this.internalErrors.None, result: true, col: null, columnIndex: colIdentifier, isGroupHeader: isGroupHeader };
			// M.H. 22 Feb 2013 Fix for bug #133770: fixColumn and unfixColumn methods should work with column index and column key.
			if (!isGroupHeader) {
				if (colIdentifierType === 'number') {
					columnIndex = colIdentifier;
				} else if (colIdentifierType === 'string') {
					for (i = 0; i < colsLength; i++) {
						if (cols[i].key === colIdentifier) {
							columnIndex = i;
							break;
						}
					}
					if (i === colsLength) {
						res.result = false;
						res.error = this.internalErrors.NotValidIdentifier;
						return res;
					}
				}
				col = cols[columnIndex];
				if (col === null || col === undefined) {
					res.result = false;
					res.error = this.internalErrors.NotValidIdentifier;
					return res;
				}
				// M.H. 4 Mar 2013 Fix for bug #134298: When calling fixColumn with index the method fixes the wrong column the third time.
				if (col.fixed === true) {
					res.result = false;
					res.error = this.internalErrors.AlreadyFixed;
					return res;
				}
				visibleIndex = this._getVisibleIndex(col.key);
				colKey = col.key;
				//$th = $('#' + gridId + '_' + colKey);
				$th = this.grid.container().find("#" + gridId + "_" + colKey);
				res.columnIndex = columnIndex;
				res.col = col;
				colKey = col.key;
				columnIndexes.push({ cI: columnIndex, vI: visibleIndex });
			} else {
				$th = this.grid.headersTable().find('th[data-mch-id=' + colIdentifier + ']');
				colKey = colIdentifier;
			}
			// it should not be allowed fixing when there is only one visible column in fixed area and we try to fix this column
			if (!this.checkFixingAllowed([col], isGroupHeader)) {
				res.result = false;
				res.error = this.internalErrors.FixingRefused;
				return res;
			}
			// M.H. 7 Mar 2013 Fix for bug #134865: When width isn't set to the grid and the columns the user is able to fix all of the columns.
			if (isNaN(gridWidth) || isGridWidthPercentage) {
				gridWidth = this.grid.container().outerWidth();
			}
			if ($th.length === 1 || visibleIndex === undefined) {
				colWidth = $th.outerWidth();
			} else {
				colWidth = this.grid.container().find("#" + gridId + " tbody tr:nth-child(1) td:nth-child(" + (visibleIndex + 1) + ")").outerWidth();
			}
			// if last column has automatically increased width (because 1 or more of the last columns are hidden) then fixing it
			// the width of this column should be rolled back to its original width - we should get the widht not of the DOM element but the original Width
			// then we should rerender colgroups because fixing is just detaching the col from unfixed area and attaching to the fixed area
			shoulRerendedColgroups = false;
			if (col && this.grid.element.data('igGridHiding')) {
				if (col.oWidth !== undefined) {
					// M.H. 24 Feb 2014 Fix for bug #165231: When Hiding is enabled and resized column is fixed the fixed area occupied the whole grid.
					colWidth = parseInt(col.oWidth, 10);
					col.width = colWidth;
				} else if (col.width) {
					// M.H. 24 Feb 2014 Fix for bug #165231: When Hiding is enabled and resized column is fixed the fixed area occupied the whole grid.
					colWidth = parseInt(col.width, 10);
				}
				shoulRerendedColgroups = true;
			}
			if ((col && col.hidden) || colWidth === undefined) {
				colWidth = 0;
			}
			if (!isInit) {
				$mainFixedContainer = this.grid.fixedContainer();
				mainFixedContainerWidth = $mainFixedContainer.outerWidth();
			}
			// check whether we could fix a column - if the sum of width of new fixed area and width of the column exceeds the width of the grid then do not allow column fixing
			// M.H. 22 Feb 2013 Fix for bug #133421: Columns and headers are misaligned on fixing a column when grid and its columns doesn't have width set
			if (colWidth + mainFixedContainerWidth + this.grid._scrollbarWidth() >= gridWidth - parseInt(this.options.minimalVisibleAreaWidth, 10)) {
				res.result = false;
				res.error = this.internalErrors.FixingRefused;
				return res;
			}
			this._populateContainers();
			if (isGroupHeader) {
				MCHchildren = this.grid._getMultiHeaderColumnById(colIdentifier);
				children = MCHchildren.children;
				visibleIndex = undefined;
				for (i = 0; i < children.length; i++) {
					if (children[i].hidden !== true) {
						if (i === 0 || visibleIndex === undefined) {
							visibleIndex = this._getVisibleIndex(children[i].key, false);
						}
						vI = visibleIndex;
					} else {
						vI = -1;
					}
					for (j = 0; j < colsLength; j++) {
						if (cols[j].key === children[i].key) {
							columnIndexes.push({ cI: j, vI: vI });
							break;
						}
					}
					children[i].fixed = true;
					this.grid._fixedColumns.push(children[i]);
				}
			} else {
				col.fixed = true;
				this.grid._fixedColumns.push(col);
				// M.H. 8 Mar 2013 Fix for bug #135244: When showHeader is false column can't be fixed with API methods.
			}
			containerBody = this._containers.body;
			containerHeader = this._containers.header;
			if (!containerHeader) {
				containerHeader = containerBody;
			}
			isI = isInit;
			if (this._hasWidthInPercent() && grid._allColumnWidthsInPercentage) {
				colWidth = col.width;
			}
			// we should fix data skipped columns if any
			if (isInit && this.options.fixingDirection === 'left') {
				hasDataSkippedColumns = this._hasDataSkippedColumns();
				if (hasDataSkippedColumns) {
					this.fixDataSkippedColumns();
					isI = false;
				}
			}
			inMCHGroup = true;
			for (i = 0; i < columnIndexes.length; i++) {
				vI = -1;
				if (columnIndexes[i].vI !== -1) {
					vI = columnIndexes[i].vI + 1;
					this._fixColumnByVisibleIndex(vI, colWidth, isI, false, inMCHGroup, colIdentifier, isGroupHeader);
					inMCHGroup = false;
				}
				col = cols.splice(columnIndexes[i].cI, 1);
				cols.splice((initialFixedColumnsLength + i), 0, col[0]);
				this.grid._onColumnFixed(columnIndexes[i].cI, true, initialFixedColumnsLength + i + 1, isI, vI);
				if (isI && vI !== -1) {
					isI = false;
				}
			}
			if (isInit) {
				// M.H. 26 Feb 2013 Fix for bug #133862: When height is not defined and column is fixed filtering a column makes the footer too big and the grid keeps its original height.
				if (grid.options.height === null) {
					// M.H. 18 Sep 2013 Fix for bug #151251: The space under the row selectors is empty when fixNondataColumns is true.
					this._setDataHeightCompensate();
					if ($.ig.util.isIE && $.ig.util.browserVersion >= 9) {
						this._syncTableHeights();
					}
				}
				// M.H. 12 Dec 2013 Fix for bug #159796: Fixing the first column causes misalignment between rows in fixed/unfixed area(in the new theme)
				if (this._containers && this._containers.body) {
					if (this.options.fixingDirection === 'left') {
						this._containers.body.unfixedTable.addClass(this.css.unfixedTableLeft);
					} else {
						this._containers.body.unfixedTable.addClass(this.css.unfixedTableRight);
					}
				}
			}
			this.grid._visibleColumnsArray = undefined;
			this.grid._updateHeaderColumnIndexes();
			// M.H. 24 Feb 2013 Fix for bug #133421: Columns and headers are misaligned on fixing a column when grid and its columns doesn't have width set
			if (this.grid.options.width === null && this.grid._fixedColumns.length === 1) {
				gridWidth = grid.container().outerWidth();//$('#' + gridId + '_mainFixedContainer').outerWidth() + $('#' + gridId).outerWidth();
				grid.container().width(gridWidth);
				//$('#' + this.grid.element[0].id + '_container').css('width', gridWidth);
			}
			grid._columnMovingResets();
			this._updateGridColWidths();
			// when the dom has changed we need to throw an event to notify other features to update dom related parameters
			this.grid._hscrollbarcontent().scrollLeft(0);
			this._changeStyleHeaderButton(colKey, true, isGroupHeader);
			// M.H. 12 Dec 2013 Fix for bug #159796: Fixing the first column causes misalignment between rows in fixed/unfixed area(in the new theme)
			if (isInit && this.options.syncRowHeights) {
				$fixedTable = this._containers.body.fixedTable;
				$unfixedTable = this._containers.body.unfixedTable;

				if (Math.abs($fixedTable.outerHeight() - $unfixedTable.outerHeight()) > 1 ||
					Math.abs($fixedTable.find('tbody tr:last').offset().top - $unfixedTable.find('tbody tr:last').offset().top) > 1) {
					this._syncRowsHeights($fixedTable, $unfixedTable);
					$unfixedTable.height($fixedTable.height());
				}
			}
			// M.H. 8 Jan 2014 Fix for bug #161032: The fixing icon in the feature chooser does not change when you fix a column with API method.
			fc = this.grid.element.data('igGridFeatureChooser');
			if (fc !== undefined && fc !== null) {
				fc._setSelectedState('ColumnFixing', colKey, true, false);
			}
			// if last column is with automatically increased width (because 1 or more of the last columns are hidden) then fixing it
			// the width of this column should be rolled back to its original width and the scrollbar should be re-calculated 
			if (shoulRerendedColgroups) {
				//this._rerenderFixedColgroups();
				this.grid._rerenderColgroups();
				this._updateHScrollbar();
			}
			grid._adjustLastColumnWidth(true);
			return res;
		},
		_setDataHeightCompensate: function () {
			var grid = this.grid, h = grid.scrollContainer().height() - grid.element.outerHeight();
			// M.H. 21 Aug 2013 Fix for bug #149665: When row selectors are enabled and height is not defined fixing and unfixing a column a couple of times makes the fixed container bigger.
			if ( h > this.scrollContainerCheckValue &&
					grid.fixedContainer().find('div[data-height-compensate]').length === 0) {
				$('<div data-height-compensate="true"></div>').css('height', h).appendTo(grid.fixedContainer());
			}
		},
		fixDataSkippedColumns: function () {
			/* Fix data skipped columns(like row selectors) if any when fixing direction is left. If already fixed nothing is done
			*/
			var i, dataSkippedColsLength,
				isMCH = this.grid._isMultiColumnGrid,
				hasDataSkippedColumns = this._hasDataSkippedColumns();
			// we should fix data skipped columns if any - for now supported scenario is ONLY if fixing direction is LEFT
			if (this.options.fixingDirection === 'left' && hasDataSkippedColumns) {
				dataSkippedColsLength = this._getDataSkippedColumnsLength();
				if (dataSkippedColsLength > 0) {
					this.grid._hasFixedDataSkippedColumns = true;
				}
				for (i = 0; i < dataSkippedColsLength; i++) {
					this._fixColumnByVisibleIndex(1, null, (i === 0), true);
					this.grid._onColumnFixed(-1, true, 0, (i === 0));
				}
				if (isMCH) {
					this._fixMultiColumnHeaderDataSkip();
				}
				// M.H. 23 Sep 2013 Fix for bug #152468: The fixed and unfixed areas are misalinged when there are cells with text spanned on two rows and the grid doesn't have height in IE9.
				if (this.grid.options.height === null) {
					if ($.ig.util.isIE && $.ig.util.browserVersion >= 9) {
						this._syncTableHeights();
					}
				}
				if (this.grid.options.height === null) {
					this._setDataHeightCompensate();
				}
                // M.H. 5 Mar 2014 Fix for bug #165935: When Row Selectors and Column Fixing are enabled clearing the filter and scrolling the grid to the right misaligns the headers and data cells.
				this.grid._updateGridContentWidth();
			}
		},
		_fixColumnByVisibleIndex: function (visibleIndex, 
				colWidth, 
				isInit, 
				isDataSkip, 
				inMCHGroup, 
				colIdentifier, 
				isGroupHeader) {
			var grid = this.grid,
				isMCH = grid._isMultiColumnGrid,
				isGridWidthPercentage = ($.type(grid.options.width) === 'string' && grid.options.width.indexOf('%') !== -1),
				isToShowHeader = grid.options.showHeader,
				isToShowFooter = grid.options.showFooter,
				containerBody = this._containers.body,
				containerHeader = this._containers.header,
				containerFooter = this._containers.footer;

			if (!containerHeader) {
				containerHeader = containerBody;
			}
			if (!containerFooter) {
				containerFooter = containerBody;
			}
			
			this._getElementsByDOM(visibleIndex, containerHeader.unfixedTable.find('thead').eq(0), 'header', isInit, isDataSkip);
			this._getElementsByDOM(visibleIndex, containerBody.unfixedTable.find('tbody').eq(0), 'body', isInit, isDataSkip); 
			this._getElementsByDOM(visibleIndex, containerFooter.unfixedTable.find('tfoot').eq(0), 'footer', isInit, isDataSkip);
			this._getColgroups(visibleIndex);
			if (isInit && this.options.syncRowHeights) {
				this._setRowHeightsByContainer('header');
				this._setRowHeightsByContainer('body');
				this._setRowHeightsByContainer('footer');
			}
			if (isDataSkip) {
				inMCHGroup = true;
				if (this._tds.header.length > 0) {
					colWidth = $(this._tds.header[0]).outerWidth();
				} else if (this._tds.body.length > 0) {
					colWidth = $(this._tds.body[0]).outerWidth();
				}
			}
			// M.H. 22 Jul 2013 Fix for bug #147143: When the widths are in percents fixing a column in Firefox shrinks other columns' widths.
			// if we detach header cells then in FF it is not rendered properly when widht is in percentage
			if (!($.ig.util.isFF && isGridWidthPercentage)) {//!($.ig.util.isFF && isGridWidthPercentage)
				this._tds.header.detach();
			}
			this._tds.body.detach();
			this._tds.footer.detach();
			this._detachColgroups();
			if (isInit) {
				this._syncUnfixedWidth(colWidth);
				this._renderMainFixedContainer(colWidth);
			} else if (inMCHGroup) {
				this._syncWidth(colWidth);
			}
			this._attachColgroups();
			// render header
			this._fixBodyColumn(isInit);
			if (isToShowFooter) {
				this._fixFooterColumn(isInit);
			}
			if (isToShowHeader) {
				if (isMCH && inMCHGroup) {
					this._fixMultiColumnHeader(colIdentifier, isInit, isGroupHeader);

				}
				this._fixHeaderColumn(isInit);
				this._syncHeights(this._heights.header, containerHeader.fixedTable.find('thead').eq(0));
			}
		},
		_hasDataSkippedColumns: function (isFixed) {
			if (this._hasDataSkippedColumn !== undefined) {
				return this._hasDataSkippedColumn;
			}
			this._hasDataSkippedColumn = this._getDataSkippedColumnsLength(isFixed) > 0;
			return this._hasDataSkippedColumn;
		},
		_getDataSkippedColumnsLength: function (isFixed) {
			if (!this._containers || !this._containers.body) {
				this._populateContainers();
			}
			var $table = this._containers.body.unfixedTable;
			
			if (isFixed) {
				$table = this._containers.body.fixedTable;
			}
			return $table.find('colgroup col[data-skip]').length;
		},
		_renderMainFixedContainer: function (colWidth) {
			var self = this, grid = this.grid, gridId = grid.id(), diff,
				functionRenderContainer, fixedBodyTable, fixedHeaderContainer, fixedFooterContainer,
				fixingDirection, syncScrollContainers,
				$mainFixedContainer, fixedBodyContainer,
				mainFixedContainerId = grid.id() + '_mainFixedContainer',
				scrollContainer,
				headerContainer, footerContainer,
				oTable, scrollContainerHeight;
				
			// M.H. 28 Feb 2013 Fix for bug #134435: When height is set and column is fixed changing the page changes grid's height and the horizontal scrollbar is not on the correct place
			$mainFixedContainer = $('<div id="' + mainFixedContainerId + '" data-fixed-container="true"></div>');
			$mainFixedContainer
				.css({
				'overflow': 'hidden', 
				'position': 'relative'
			});
			scrollContainer = this._containers.body.unfixedContainer;
			$mainFixedContainer
				//.width(colWidth)
				//.addClass(scrollContainer.attr('class'))
				.addClass(this.css.fixedContainer);
			fixingDirection = 'left';
			if (this.options.fixingDirection === 'left') {
				fixingDirection = 'left';
				$mainFixedContainer.addClass(this.css.leftFixedContainer);
				if (this._containers.header) {
					$mainFixedContainer.insertBefore(this._containers.header.unfixedContainer);
				} else {
					$mainFixedContainer.insertBefore(scrollContainer);
				}
				$mainFixedContainer.css({'float': 'left', 'left': 0});
			} else if (this.options.fixingDirection === 'right') {
				fixingDirection = 'right';
				$mainFixedContainer.addClass(this.css.rightFixedContainer);
				if (this._containers.header) {
					$mainFixedContainer.insertBefore(this._containers.header.unfixedContainer);
				} else {
					$mainFixedContainer.insertBefore(scrollContainer);
				}
				$mainFixedContainer.css({'float': 'right', 'right': 0});
			}
			$mainFixedContainer.attr('data-fixing-direction', fixingDirection);
			// M.H. 6 Jun 2013 Fix for bug #143586: CellClick event doesn't fire for fixed columns.
			$mainFixedContainer.bind({'click': $.proxy(this.grid._cellClickHandler, this.grid)});
			// render containers
			// first we should render body container
			if (this._hasWidthInPercent()) {
				if (this.grid._allColumnWidthsInPercentage) {
					$mainFixedContainer.css('width', colWidth);
				} else {
					colWidth = (colWidth / (scrollContainer.find('table').width() + colWidth)) * 100;
					$mainFixedContainer.css('width', colWidth + '%');
				}
			} else {
				colWidth = 'width:' + colWidth + 'px';
			}
			functionRenderContainer = function (fixedContainerId, $container, type) {
				var $fixedContainer, $fixedTable;
				oTable = $container.find('table');
				$fixedContainer = $('<div id="' + fixedContainerId + '" data-scroll="true" data-fixed-container="true"></div>').appendTo($mainFixedContainer);
				$fixedTable = $('<table id="' + oTable.attr('id') + '_fixed" class="' + oTable.attr('class') + '" style="table-layout:fixed; ' + colWidth + '" border=0 cellpadding=0 cellspacing=0><colgroup /></table>')
					.appendTo($fixedContainer);
				self._containers[type].fixedContainer = $fixedContainer;
				self._containers[type].fixedTable = $fixedTable;
				$fixedContainer
					.css({
					'overflow': 'hidden', 
					//'height': scrollContainerHeight, //+ $('#' + grid.element[0].id + '_hscroller').height()
					'position': 'relative'
				});
				//fixedTable.addClass(oTable.attr('class'));
				return $fixedContainer;
			};
			// render body container
			fixedBodyContainer = functionRenderContainer(gridId + '_fixedBodyContainer', scrollContainer, 'body');
			// M.H. 14 Jun 2013 Fix for bug #144693: When you fix a column and then filter a column the records increase their height.
			// M.H. 6 Jun 2013 Fix for bug #143942: When filtering is enabled and column is fixed scrolling the grid vertically misaligns the fixed and unfixed areas.
			if (grid.options.height !== null && $.ig.util.isIE) {
				fixedBodyContainer.find('table').height(scrollContainer.find('table').height());
			}
			// M.H. 26 Feb 2013 Fix for bug #133862: When height is not defined and column is fixed filtering a column makes the footer too big and the grid keeps its original height.
			if (grid.options.height === null) {
				scrollContainerHeight = '100%';
			} else {
				scrollContainerHeight = scrollContainer.height();
				// M.H. 7 Mar 2013 Fix for bug #135253: When width and height are set to the grid, widths to the columns are not set and there is initially fixed column the fixed area has bigger height than the unfixed.
				if (this.grid._hscrollbar().is(':visible')) {
					scrollContainerHeight += this.grid._hscrollbar().outerHeight();
				}
			}
			fixedBodyContainer.height(scrollContainerHeight);
			//fixedBodyContainer.appendTo($mainFixedContainer);
			fixedBodyTable = fixedBodyContainer.find('table');
			$('<tbody />').appendTo(fixedBodyTable);
			if (grid.options.showHeader) {
				if (grid.options.fixedHeaders && grid.options.height !== null) {
					headerContainer = this._containers.header.unfixedContainer;
					fixedHeaderContainer = functionRenderContainer(gridId + '_fixedHeaderContainer', headerContainer, 'header');
					$('<thead />').appendTo(fixedHeaderContainer.find('table'));
					//fixedHeaderContainer.height(headerContainer.height());
					fixedHeaderContainer.prependTo($mainFixedContainer);
					//headerContainer.height(headerContainer.height());
					// M.H. 22 Feb 2013 Fix for bug #133539: When the grid has vertical scrollbar and caption fixing a column makes the headers misaligned.
					grid._renderFixedCaption();
				} else {
					$('<thead />').insertBefore(fixedBodyContainer.find('tbody'));
				}
			}
			if (grid.options.showFooter) {
				if (grid.options.fixedFooters && grid.options.height !== null) {
					footerContainer = this._containers.footer.unfixedContainer;
					fixedFooterContainer = functionRenderContainer(gridId + '_fixedFooterContainer', footerContainer, 'footer');
					$('<tfoot />').appendTo(fixedFooterContainer.find('table'));
					// M.H. 11 Jun 2013 Fix for bug #143596: When the width of a fixed column is smaller than the width of the text in summary cell this text goes in 2 rows and it makes the summaries misaligned.
					this._containers.footer.fixedTable.css('whiteSpace', this._containers.footer.unfixedTable.css('whiteSpace'));
					fixedFooterContainer.appendTo($mainFixedContainer);
				} else {
					$('<tfoot />').insertBefore(fixedBodyContainer.find('tbody'));
				}
			}
			// only for data container
			grid._fixedTable = fixedBodyTable;
			if (this.options.fixingDirection === 'right') {
				fixedBodyContainer.css({'overflow-y': 'auto'});
				scrollContainer.css({'overflow-y': 'hidden'});
			}
			// M.H. 5 Mar 2013 Fix for bug #134687: Sorted style is removed the first time you fix a sorted column.
			//this._renderFixedRecords(fixedBodyTable, undefined, undefined, true);
			syncScrollContainers = function (direction) {
				var scrollTop = fixedBodyContainer.scrollTop();
				scrollTop += -direction * self.options.scrollDelta;
				if (scrollTop <= 0) {
					scrollTop = 0;
				}
				fixedBodyContainer.scrollTop(scrollTop);
				scrollContainer.scrollTop(scrollTop);
			};
			this._onMouseWheelHandler = function (event) {
				var evt, direction, w, d;
				evt = event.originalEvent;
				w = evt.wheelDelta;
				d = evt.detail;
				if (d) {
					if (w) {
						direction = w/d/40*d > 0 ? 1 : -1; // Opera
					}
					else {
						direction = -d/3;// Firefox; TODO: do not /3 for OS X
					}
				} else {
					direction = w/120;// IE/Safari/Chrome TODO: /3 for Chrome OS X
				}
				syncScrollContainers(direction);
				// M.H. 4 Mar 2013 Fix for bug #134225: The page can't be scrolled vertically with mouse wheel when you hover the fixed column.
				if (grid.options.height === null) {
					return true;
				}
				return false;
			};
			// M.H. 26 Feb 2013 Fix for bug #134003: When the fixingDirection is "right" mouse wheel scroll does not work when you hover the unfixed area.
			this._DOMMouseScroll = function (event) { // Firefox
				var dir = -1, delta;
				//I.I. bug fix for 104505. The issue is reproducible with jquery 1.7.1 only
				delta = -event.originalEvent.detail / 3; // // determine if we are scrolling up or down
				if (delta > 0) { // scroll up 
					dir = 1;
				}  // else default => scroll down 
				syncScrollContainers(dir);
				// M.H. 4 Mar 2013 Fix for bug #134225: The page can't be scrolled vertically with mouse wheel when you hover the fixed column.
				if (grid.options.height === null) {
					return true;
				}
				event.preventDefault();
			};
			this._onKeyDown = function (event) {
				var isUp = (event.keyCode === $.ui.keyCode.UP), isDown = (event.keyCode === $.ui.keyCode.DOWN);
				if (isUp) {
					syncScrollContainers(1);
				} else if (isDown) {
					syncScrollContainers(-1);
				}
				//return false;
			};
			// M.H. 4 Jul 2014 Fix for bug #173032: Desynchronization between rows in the fixed and unfixed area on touch devices
			if (typeof Modernizr === 'object' &&
					Modernizr.touch === true && grid.element.igScroll !== undefined) {
				// instantiate igScroll for the fixed area
				fixedBodyContainer.igScroll({
					scrolled: function (e, args) {
						syncScrollContainers(0);
						//self._DOMMouseScroll(e);
					},
					stopped: function (e, args) {
						syncScrollContainers(0);
					}
				});
			}
			// add handlers
			// M.H. 26 Feb 2013 Fix for bug #134003: When the fixingDirection is "right" mouse wheel scroll does not work when you hover the unfixed area.
			if ($.ig.util.isIE || this.options.fixingDirection === 'right') {
				scrollContainer.bind({
					keydown: this._onKeyDown,
					mousewheel: this._onMouseWheelHandler,
					DOMMouseScroll: this._DOMMouseScroll
				});
			}
			scrollContainer.bind({
				scroll: function () {
					var top = $(this).scrollTop();
					fixedBodyContainer.scrollTop(top);
				}
			});
			fixedBodyContainer.bind({
				mousewheel: this._onMouseWheelHandler,
				// M.H. 22 Feb 2013 Fix for bug #133776: The mouse wheel scroll does not work when you hover the fixed area in Firefox.
				DOMMouseScroll: this._DOMMouseScroll
			});
			if (this.options.fixingDirection === 'right') {
				fixedBodyContainer.bind({
					scroll: function () {
						var top = $(this).scrollTop();

						scrollContainer.scrollTop(top);
					},
					keydown: this._onMouseWheelHandler
				});
			}
			// M.H. 21 May 2013 Fix for bug #141231: Column fixing breaks columns header with one normal header and other with multiple headers.
			if (grid.options.width === null) {
				diff = parseFloat($mainFixedContainer.css('borderRightWidth'));
				if (diff > 0) {
					this._syncUnfixedWidth(diff);
				}
			}
		},
		_getElementsByDOM: function (visibleIndex, $DOM, type, isInit, isDataSkipped) {
			var self = this, $TRS = $DOM.find('tr');
			
			if (isInit && this.options.syncRowHeights) {
				if (!self._heights) {
					self._heights = {};
				}
				self._heights[type] = [];
				$TRS.each(function (ind, tr) {
					self._heights[type].push({h: tr.offsetHeight, tr: tr});
				});
			}
			if (type === 'header') {
				this._tds[type] = $DOM.find('tr:not([data-mch-level],[data-skip]) th:nth-child(' + visibleIndex + '),tr:not([data-mch-level],[data-skip]) td:nth-child(' + visibleIndex + ')');
			} else if (isDataSkipped) {
				this._tds[type] = $DOM.find('th:nth-child(' + visibleIndex + '), td:nth-child(' + visibleIndex + ')');
			} else {
				this._tds[type] = $DOM.find('td:nth-child(' + visibleIndex + ')');
			}
		},
		_getColgroups: function (visibleIndex, isFixed) {
			var $bodyTable = this._containers.body.unfixedTable,
				$headerTable,
				$footerTable;

			if (isFixed) {
				$bodyTable = this._containers.body.fixedTable;
			}
			this._getColgroup(visibleIndex, $bodyTable, 'body');
			if (this._containers.header) {
				if (isFixed) {
					$headerTable = this._containers.header.fixedTable;
				} else {
					$headerTable = this._containers.header.unfixedTable;
				}
				this._getColgroup(visibleIndex, $headerTable, 'header');
			}
			if (this._containers.footer) {
				if (isFixed) {
					$footerTable = this._containers.footer.fixedTable;
				} else {
					$footerTable = this._containers.footer.unfixedTable;
				}
				this._getColgroup(visibleIndex, $footerTable, 'footer');
			}
		},
		_getColgroup: function (visibleIndex, $DOM, type) {
			var $cols = $DOM.find('colgroup col:nth-child(' + visibleIndex + ')');

			this._colgroups[type] = $cols;
		},
		_detachColgroups: function () {
			this._colgroups.body.detach();
			if (this._colgroups.header) {
				this._colgroups.header.detach();
			}
			if (this._colgroups.footer) {
				this._colgroups.footer.detach();
			}
		},
		_attachColgroups: function (isFixed) {
			var cols = this._colgroups.body,
				$bodyTable, $headerTable, $footerTable;
			
			if (isFixed) {
				$bodyTable = this._containers.body.unfixedTable;
			} else {
				$bodyTable = this._containers.body.fixedTable;
			}
			this._attachColgroup(cols, $bodyTable, isFixed);
			if (this._colgroups.header && this._colgroups.header.length > 0) {
				if (isFixed) {
					$headerTable = this._containers.header.unfixedTable;
				} else {
					$headerTable = this._containers.header.fixedTable;
				}
				cols = this._colgroups.header;
				this._attachColgroup(cols, $headerTable, isFixed);
			}
			if (this._colgroups.footer && this._colgroups.footer.length > 0) {
				if (isFixed) {
					$footerTable = this._containers.footer.unfixedTable;
				} else {
					$footerTable = this._containers.footer.fixedTable;
				}
				cols = this._colgroups.footer;
				this._attachColgroup(cols, $footerTable, isFixed);
			}
		},
		_attachColgroup: function (cols, $table, isFixed) {
			var i, dataSkippedColsLength, colsLength = cols.length, $colgroup = $table.find('colgroup');
			// M.H. 23 Aug 2013 Fix for bug #150279: When fixingDirection is "right" and row selectors are enabled unfixing columns breaks the grid.
			if (isFixed && this._hasDataSkippedColumns(true) && this.options.fixingDirection === 'right') {
				dataSkippedColsLength = this._getDataSkippedColumnsLength();
				for (i = 0; i < colsLength; i++) {
					$(cols[i]).insertAfter($colgroup.find('col').eq(dataSkippedColsLength - 1));
				}
			} else {
				for (i = 0; i < colsLength; i++) {
					if (isFixed) {
						$(cols[i]).prependTo($colgroup);
					} else {
						$(cols[i]).appendTo($colgroup);
					}
				}
			}
		},
		_setRowHeightsByContainer: function (type) {
			var i, heights = this._heights[type], heightsLength = heights.length;

			for (i = 0; i < heightsLength; i++) {
				heights[i].tr.style.height = heights[i].h + 'px';
			}
		},
		_syncRowStyles: function () {
			// sync styles between fixed and unfixed table body rows
			// M.H. 12 Jun 2013 Fix for bug #144399: Deleting a row and fixing a column breaks the zebra style of the records.
			var i, fixedRow, unfixedRow,
				container = this._containers.body,
				$unfixedTable = container.unfixedTable,
				$fixedTable = container.fixedTable,
				fixedRows = $fixedTable.find('tbody tr'),
				unfixedRows = $unfixedTable.find('tbody tr'),
				rowsLength = fixedRows.length;

			for (i = 0; i < rowsLength; i++) {
				fixedRow = fixedRows[i];
				unfixedRow = unfixedRows[i];
				fixedRow.setAttribute('style', unfixedRow.getAttribute('style'));
				fixedRow.setAttribute('class', unfixedRow.getAttribute('class'));
			}
		},
		_populateContainers: function () {
			var gridId = this.grid.id(),
				grid = this.grid,
				self = this,
				$unfixedHeaders = this.grid.container().find("#" + gridId + "_headers"),
				$unfixedFooters = this.grid.container().find("#" + gridId + "_footer_container"),
				$fixedBodyContainer = this.grid.container().find("#" + gridId + "_fixedBodyContainer"),
				functionPopulateContainers,
				scrollContainer;

			if (grid.options.virtualization === true || grid.options.rowVirtualization === true) {
				scrollContainer = this.grid._vdisplaycontainer();
			} else {
				scrollContainer = this.grid.scrollContainer();
			}
			if (scrollContainer.length === 0) {
				scrollContainer = this.grid.element;
			}
			this._containers = {};
			functionPopulateContainers = function ($unfixedContainer, $fixedContainer, type) {
				var $unfixedTable = $unfixedContainer.find('table'), $fixedTable = grid.container().find("#" + $unfixedTable.attr("id") + "_fixed");
				// M.H. 21 May 2013 Fix for bug #141231: Column fixing breaks columns header with one normal header and other with multiple headers.
				if ($unfixedTable.length === 0) {
					$unfixedTable = $unfixedContainer;
				}
				self._containers[type] = {
					fixedContainer: $fixedContainer,
					unfixedContainer: $unfixedContainer,
					fixedTable: $fixedTable,
					unfixedTable: $unfixedTable
				};
			};
			if ($unfixedHeaders.length > 0) {
				functionPopulateContainers($unfixedHeaders.parent('div'), this.grid.container().find("#" + gridId + "_fixedHeaderContainer"), "header");
			}
			functionPopulateContainers(scrollContainer, $fixedBodyContainer, "body");
			if ($unfixedFooters.length > 0 && $unfixedFooters[0].nodeName !== 'TFOOT') {
				//$fixedFooterContainer = $fixedBodyContainer;
				functionPopulateContainers($unfixedFooters, undefined, "footer");
			}
		},
		_fixMultiColumnHeaderDataSkip: function () {
			var i, $th, dataSkippedColsLength, $unfixedThead, $fixedThead,
				maxLevel = this.grid._maxLevel,
				container = this._containers.header;
				
			if (!container) {
				container = this._containers.body;
			}
			$unfixedThead = container.unfixedTable.find('thead');
			$fixedThead = this.grid.container().find("#" + container.unfixedTable.attr("id") + "_fixed").find('thead');
			if (this._hasDataSkippedColumns() && this.options.fixingDirection === 'left') {
				dataSkippedColsLength = this._getDataSkippedColumnsLength(true);
				for (i = 0; i < dataSkippedColsLength; i++) {
					$th = $unfixedThead.find('tr[data-mch-level=' + maxLevel + '] th[data-skip]:nth-child(1)');
					$th.detach();
					$th.appendTo($fixedThead.find('tr[data-mch-level=' + maxLevel + ']'));
				}
			}
		},
		_fixMultiColumnHeader: function (colInd, isInit, isGroupHeader) {
			var grid = this.grid, i, cols,
				gridId = grid.id(), $th, maxLevel,
				$fixedThead, $unfixedThead,
				fixedTable, oTable,
				//heights = [],
				container = this._containers.header;
			
			if (!container) {
				container = this._containers.body;
			}
			oTable = container.unfixedTable;
			$unfixedThead = oTable.find('thead');
			fixedTable = this.grid.container().find("#" + oTable.attr("id") + "_fixed");
			// M.H. 21 May 2013 Fix for bug #141231: Column fixing breaks columns header with one normal header and other with multiple headers.
			if (fixedTable.length === 0) {
				fixedTable = container.fixedTable;
			}
			$fixedThead = fixedTable.find('thead');
			maxLevel = grid._maxLevel;
			if (isInit) {
				$unfixedThead.find('tr[data-mch-level]').each(function (ci, tr) {
					var attr = tr.attributes, attrStr = '';
					//heights.push({h: this.offsetHeight, r: this});
					if (attr) {
						for (i = 0; i < attr.length; i++) {
							attrStr += ' ' + attr[i].name + '="' + attr[i].value + '"';
						}
					}
					$('<tr' + attrStr + '></tr>').appendTo($fixedThead);
				});
				//if (this.options.syncRowHeights && this._heights.header) {
					//this._syncHeights(this._heights.header, $fixedThead);
				//}
				// add dataskipped columns if any
//				if (this._hasDataSkippedColumns() && this.options.fixingDirection === 'left') {
//					dataSkippedColsLength = this._getDataSkippedColumnsLength(true);
//					for (i = 0; i < dataSkippedColsLength; i++) {
//						$th = $unfixedThead.find('tr[data-mch-level=' + maxLevel + '] th[data-skip]:nth-child(1)');
//						$th.detach();
//						$th.appendTo($fixedThead.find('tr[data-mch-level=' + maxLevel + ']'));
//					}
//				}
			}

			if (isGroupHeader) {
				cols = grid._oldCols;
				for (i = 0; i < cols.length; i++) {
					if (cols[i].identifier === colInd) {
						cols[i].fixed = true;
						this._renderMCHColumn(cols[i], $fixedThead, $unfixedThead);
						break;
					}
				}
			} else {
				//$th = $('#' + gridId + '_' + colInd);
				$th = this.grid.container().find("#" + gridId + "_" + colInd);
				//tdsFirst = oTable.find('thead tr[data-mch-level=' + maxLevel + '] th:nth-child(' + visibleIndex + ')');
				// changing col into colgroup
				$th.detach();
				$th.appendTo($fixedThead.find('tr[data-mch-level=' + maxLevel + ']'));
			}
		},
		// render single header column - it could be MultiColumn or at level 0, -renders all its children
		_renderMCHColumn: function (el, $fixedHeader, $unfixedHeader) {
			var level = el.level, domLevel, children, i, $th;

			if (level === 0) {
				//$th = $('#' + this.grid.id() + '_' + el.key);
				$th = this.grid.container().find("#" + this.grid.id() + "_" + el.key);
			} else {
				$th = $unfixedHeader.find('th[data-mch-id=' + el.identifier + ']');
				children = el.group;
			}
			domLevel = $th.closest('tr').attr('data-mch-level');
			$th.detach();
			$th.appendTo($fixedHeader.find('tr[data-mch-level=' + domLevel + ']'));
			if (level > 0) {
				for (i = 0; i < children.length; i++) {
					this._renderMCHColumn(children[i], $fixedHeader, $unfixedHeader);
				}
			}
		},
		_fixHeaderColumn: function (isInit) {
			var self = this,
				$fixedThead, trs, $tr,
				syncRowHeights = (this.options.syncRowHeights === true),
				$fixedTable, tdsFirst, $unfixedThead, tdsLength, j,
				$unfixedTable, heights,
				container = this._containers.header;
			
			if (!container) {
				container = this._containers.body;
			}
			$unfixedTable = container.unfixedTable;
			$fixedTable = container.fixedTable;
			$unfixedThead = $unfixedTable.find('thead');
			$fixedThead = $fixedTable.find('thead');
			tdsFirst = this._tds.header;
			if (!isInit) {
				// setting table TDs, THs
				trs = $fixedThead.find("tr:not([data-mch-level],[data-skip])");
				tdsLength = tdsFirst.length;
				if (tdsLength > 0) {
					for (j = 0; j < tdsLength; j++) {
						$(tdsFirst[j]).appendTo(trs[j]);
					}
				}
			} else {
				if (syncRowHeights) {
					heights = self._heights.header;
				}
				$unfixedThead.find('tr:not([data-mch-level])').each(function (ci, tr) {
					var i, $td = $(tdsFirst[ci]), attr = tr.attributes, attrStr = '';
					if (attr) {
						for (i = 0; i < attr.length; i++) {
							attrStr += ' ' + attr[i].name + '="' + attr[i].value + '"';
						}
					}
					$tr = $('<tr' + attrStr + '></tr>').appendTo($fixedThead);
					$td.appendTo($tr);
					if (syncRowHeights) {
						this.style.height = heights[ci].h + 'px';
					}
				});
			}
		},
		_fixBodyColumn: function (isInit) {
			var grid = this.grid, i, heights, $trsUnfixed,
				$trs, trsLength, tr, scroller,
				$fixedTable, tdsFirst,
				fixedControllerScrollerId = grid.id() + '_fixedContainerScroller',
				$unfixedTable, syncDataIds, dataId,
				container = this._containers.body;
			
			$unfixedTable = container.unfixedTable;
			$fixedTable = container.fixedTable;
			tdsFirst = this._tds.body;
			if (isInit) {
				// M.H. 5 Mar 2013 Fix for bug #134687: Sorted style is removed the first time you fix a sorted column.
				trsLength = $unfixedTable.find('tbody tr').length;
				this._renderFixedRecords($fixedTable, 0, trsLength - 1, true);
				$trs = $fixedTable.find('tbody tr');
				//trsLength = $trs.length;
				syncDataIds = false;
				if (trsLength !== grid.dataSource.dataView().length) {
					syncDataIds = true;
					$trsUnfixed = $unfixedTable.find('tbody tr');
				}
				for (i = 0; i < trsLength; i++) {
					tr = $trs[i];
					$(tdsFirst[i]).appendTo(tr);
					if (syncDataIds) {
						dataId = $trsUnfixed[i].getAttribute('data-id');
						if (dataId) {
							tr.setAttribute('data-id', dataId);
						}
					}
				}
				// we should first set "content" (tds inside TRs) and then set height of the rows because performance issue
				if (this.options.syncRowHeights) {
					heights = this._heights.body;
					for (i = 0; i < trsLength; i++) {
						$trs[i].style.height = heights[i].h + 'px';
					}
				}
			} else {
				$trs = $fixedTable.find('tbody tr');
				trsLength = $trs.length;
				for (i = 0; i < trsLength; i++) {
					tr = $trs[i];
					$(tdsFirst[i]).appendTo(tr);
				}
			}
			this._updateHScrollbar();
			// M.H. 24 Feb 2013 Fix for bug #133421: Columns and headers are misaligned on fixing a column when grid and its columns doesn't have width set
			if (grid.options.width === null && $unfixedTable[0].style.width === '') {
				$unfixedTable[0].style.width = $unfixedTable.outerWidth() + 'px';
			}
			// sync heights
			if (isInit) {
				scroller = this.grid._hscrollbarcontent();
				if (scroller.length === 1 && this.grid.container().find("#" + fixedControllerScrollerId).length === 0) {
					// M.H. 7 Mar 2013 Fix for bug #135253: When width and height are set to the grid, widths to the columns are not set and there is initially fixed column the fixed area has bigger height than the unfixed.
					$('<div style="height:' + this.grid._hscrollbar().height() + 'px" id="' + fixedControllerScrollerId + '"></div>').appendTo(container.fixedContainer);
				}
			}
		},
		_fixFooterColumn: function (isInit) {
			var trs, heights,
				$fixedTable, tdsFirst, $tfoot, tdsLength, j,
				$unfixedTable,
				syncRowHeights = (this.options.syncRowHeights === true),
				container = this._containers.footer;
			
			if (!container) {
				container = this._containers.body;
			}
			$unfixedTable = container.unfixedTable;
			$fixedTable = container.fixedTable;
			tdsFirst = this._tds.footer;
			if (!isInit) {
				// setting table TDs, THs
				trs = $fixedTable.find('tfoot tr');
				tdsLength = tdsFirst.length;
				if (tdsLength > 0) {
					for (j = 0; j < tdsLength; j++) {
						$(tdsFirst[j]).appendTo(trs[j]);
					}
				}
			} else {
				$tfoot = $fixedTable.find('tfoot');
				if (syncRowHeights) {
					heights = this._heights.footer;
				}
				$unfixedTable.find('tfoot tr').each(function (ci, tr) {
					var i, h, $td = $(tdsFirst[ci]), attr = tr.attributes, $tr, attrValue, attrName, attrStr = '';
					if (attr) {
						for (i = 0; i < attr.length; i++) {
							attrName = attr[i].name;
							attrValue = attr[i].value;
							// M.H. 26 Apr 2013 Fix for bug #140689: When column is fixed and summaries are enabled filtering a column makes the grid to render incorrectly.
							if (attrName.toLowerCase() === 'id') {
								attrValue += '_fixed';
							}
							attrStr += ' ' + attrName + '="' + attrValue + '"';
						}
					}
					$tr = $('<tr' + attrStr + '></tr>').appendTo($tfoot);
					// sync heights
					if (syncRowHeights) {
						// M.H. 6 Nov 2013 Fix for bug #157012: When Summaries are enabled fixing a column throws a js error in IE8.
						h = heights[ci].h;
						$tr.height(h);
						this.style.height = h + 'px';
					}
					$td.appendTo($tr);
				});
				// M.H. 5 Mar 2013 Fix for bug #134687: Sorted style is removed the first time you fix a sorted column.
				$fixedTable.find('tr').each(function(ind, $row) {
					$(tdsFirst[ind]).appendTo($row);
				});
				// M.H. 22 Aug 2013 Fix for bug #149851: When row selectors and summaries are enabled and there is a summary row spanned on two lines the fixed area is not aligned with the unfixed area.
				if (this._hasDataSkippedColumns() && this.grid._fixedColumns.length <= 1) {
					this._syncRowsHeights(this.grid.footersTable().find('tfoot'), this.grid.fixedFootersTable().find('tfoot'));
				}
			}
		},
		_syncRowsHeights: function ($container, $containerToSync) {
			var $trs = $container.find('tr'), $trsToSync = $containerToSync.find('tr');

			$trs.each(function (ind, tr) {
				var h = $(tr).outerHeight(), hToSync = $($trsToSync[ind]).outerHeight();

				if (h > hToSync) {
					hToSync = h;
				}
				$($trsToSync[ind]).height(hToSync);
				$(tr).height(hToSync);
			});
		},
		_syncHeights: function (heights, fixedTable) {
			var trs;

			if (this.options.syncRowHeights) {
				trs = fixedTable.find('tr');
				$.each(heights, function (ci, elem) {
					var h = elem.h + 'px';
					trs[ci].style.height = h;
					elem.tr.style.height = h;
				});
			}
		},
		// M.H. 11 Jun 2013 Fix for bug #144310: When autoCommit is true and there is a fixed column deleting a row does not remove the cells from the fixed area.
		_syncContainerHeights: function () {
			// sync heights between fixed and unfixed container(especially for table body)
			var $fixedTable, $unfixedTable,
				containers = this._containers;

			if (containers && containers.body) {
				$fixedTable = containers.body.fixedTable;
				$unfixedTable = containers.body.unfixedTable;
				if ($fixedTable.height() !== $unfixedTable.height()) {
					$fixedTable.height($unfixedTable.height());
				}
			}
		},
		_syncUnfixedWidth: function (colWidth) {
			this._syncUnfixedWidthByContainer(colWidth, this._containers.body.unfixedTable, this._containers.body.unfixedContainer);
			if (this._containers.header) {
				this._syncUnfixedWidthByContainer(colWidth, this._containers.header.unfixedTable, this._containers.header.unfixedContainer);
			}
			if (this._containers.footer) {
				this._syncUnfixedWidthByContainer(colWidth, this._containers.footer.unfixedTable, this._containers.footer.unfixedContainer);
			}
		},
		_syncUnfixedWidthByContainer: function (colWidth, $unfixedTable, scrollContainer) {
			if ($unfixedTable.length === 0) {
				return;
			}
			var oTableWidth = parseInt($unfixedTable[0].style.width, 10);
			
			if (isNaN(oTableWidth)) {
				oTableWidth = $unfixedTable.outerWidth();
			}
			// M.H. 24 Feb 2013 Fix for bug #133421: Columns and headers are misaligned on fixing a column when grid and its columns doesn't have width set
			//if (oTableWidth > 0 && !(this.grid.options.width === null && (oTableWidth + this.grid._scrollbarWidth()) === scrollContainer.width())) {
				oTableWidth -= colWidth;
				$unfixedTable.width(oTableWidth);
			//}
		},
		_syncWidth: function (colWidth) {
			var grid = this.grid, gridId = grid.id(), w, totalW,
			scrollContainer, $mainFixedContainer, $fixedFooterContainer,
			updateFixedTable = true,
			$unfixedHeaders = grid.container().find("#" + gridId + "_headers"),
			$unfixedFooters = grid._fixedfooters(),
			$fixedBodyContainer = grid.fixedBodyContainer();

			if (grid.options.virtualization === true || grid.options.rowVirtualization === true) {
				scrollContainer = grid._vdisplaycontainer();
			} else {
				scrollContainer = grid.scrollContainer();
				if (scrollContainer.length === 0) {
					scrollContainer = grid.element;
				}
			}
			if (this._hasWidthInPercent()) {
				updateFixedTable = false;
				$mainFixedContainer = grid.fixedContainer();
				w = parseFloat($mainFixedContainer[0].style.width);
				if (isNaN(w)) {
					w = 0;
				}
				if (!grid._allColumnWidthsInPercentage) {
					//w = Math.ceil(w);
					totalW = scrollContainer.find('table').width() / ((100 - w)/100);
					if (colWidth < 0) {
						colWidth = ((colWidth / $mainFixedContainer.width()) * ((w/100) * totalW));// the real column width (according to the total grid width)
					}
					w += (colWidth / totalW) * 100;
					$mainFixedContainer.css('width', w + '%');
				} else {
					// TODO
					if ($.type(colWidth) === 'string' && colWidth.indexOf('%') !== -1) {
						colWidth = parseInt(colWidth, 10);
						w += colWidth;
						$mainFixedContainer.css('width', w + '%');
					}
					return;
				}
			}
			if ($unfixedHeaders.length > 0) {
				this._updateContainersWidth(colWidth, $unfixedHeaders.parent('div'), grid.fixedHeaderContainer(), updateFixedTable);
			}
			this._updateContainersWidth(colWidth, scrollContainer, $fixedBodyContainer, updateFixedTable);
			if ($unfixedFooters.length > 0) {
				$fixedFooterContainer = grid.fixedFooterContainer();
				// M.H. 21 May 2013 Fix for bug #141231: Column fixing breaks columns header with one normal header and other with multiple headers.
				if ($fixedFooterContainer.length > 0) {
					this._updateContainersWidth(colWidth, $unfixedFooters, $fixedFooterContainer, updateFixedTable);
				}
			}
		},
		_updateHScrollbar: function () {
			var scrollContainer, grid = this.grid, $hScrollerContainer,
				oTableWidth = this._containers.body.unfixedTable.outerWidth();

			scrollContainer = this._containers.body.unfixedContainer;
			if (oTableWidth > 0) {
				// M.H. 27 Feb 2013 Fix for bug #133875: The records in fixed column are not synchronized with the unfixed columns when the grid is vertically scrolled.
				scrollContainer.scrollTop(0);
				$hScrollerContainer = grid._hscrollbar();
				$hScrollerContainer.css({
					width: (scrollContainer.width() - 1) + 'px',
					left: 0
				});
				if ($.ig.util.isIE10 ||
					(this._hasWidthInPercent() && !grid._allColumnWidthsInPercentage)) {
					$hScrollerContainer.width('');
				}
				// M.H. 21 Feb 2013 Fix for bug #133521: When you fix and unfix a column the width of the columns changes and scrolling the grid to the right misaligns it.
				grid._hscrollbarinner().css({
					width: (grid._hasVerticalScrollbar && grid.options.fixedHeaders ? oTableWidth - grid._scrollbarWidth() : oTableWidth) + 'px',
					left: 0
				});
			}
		},
		_updateSingleContainerWidth: function (width, fixed) {
			var $bodyTbl, $headerTbl, $footerTbl, funcUpdateTbl;

			width = !width ? 0 : parseInt(width, 10);
			this._populateContainers();
			if (fixed) {
				$bodyTbl = this._containers.body.fixedTable;
				if (this._containers.header) {
					$headerTbl = this._containers.header.fixedTable;
				}
				if (this._containers.footer) {
					$footerTbl = this._containers.footer.fixedTable;
				}
			} else {
				$bodyTbl = this._containers.body.unfixedTable;
				if (this._containers.header) {
					$headerTbl = this._containers.header.unfixedTable;
				}
				if (this._containers.footer) {
					$footerTbl = this._containers.footer.unfixedTable;
				}
			}
			funcUpdateTbl = function (nW, $tbl) {
				var w = parseInt($tbl[0].style.width, 10);
				if (isNaN(w)) {
					w = $tbl.outerWidth();
				}
				w += nW;
				$tbl.width(w);
			};
			funcUpdateTbl(width, $bodyTbl);
			if ($headerTbl) {
				funcUpdateTbl(width, $headerTbl);
			}
			if ($footerTbl) {
				funcUpdateTbl(width, $footerTbl);
			}
		},
		_updateContainersWidth: function (colWidth, $unfixedContainer, $fixedContainer, updateFixedTable) {
			var oTableWidth, width = 0, $unfixedTable = $unfixedContainer.find('table'),
				$fixedTable = this.grid.container().find("#" + $unfixedTable.attr("id") + "_fixed");

			if ($unfixedTable.length === 0) {
				$unfixedTable = $unfixedContainer;
			}
			if ($fixedTable.length === 0) {
				return;
			}
			width = parseInt($fixedTable[0].style.width, 10);
			if (isNaN(width)) {
				width = $fixedTable.outerWidth();
			}
			// setting width of fixed table
			oTableWidth = parseInt($unfixedTable[0].style.width, 10);
			if (isNaN(oTableWidth)) {
				oTableWidth = $unfixedTable.outerWidth();
			}
			// M.H. 24 Feb 2013 Fix for bug #133421: Columns and headers are misaligned on fixing a column when grid and its columns doesn't have width set
			//if (oTableWidth > 0 && !(this.grid.options.width === null && (oTableWidth + this.grid._scrollbarWidth()) === $unfixedContainer.width())) {
			oTableWidth -= colWidth;
			$unfixedTable.width(oTableWidth);
			//}
			if (updateFixedTable) {
				width += colWidth;
				$fixedTable.width(width);
			}
		},
		_headerRendered: function (sender, args) {
			//prevent handling of other grids' events in the case of hierarchical grid
			if (args.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}
			if (this.options.showFixButtons === false) {
				return;
			}
			
			var i, j, cs, columnKey, ths, children,
				isFixed = false,
				allowFixing = true,
				grid = this.grid,
				self = this,
				cols = grid.options.columns,
				colsLength = cols.length;
			
			if (grid._isMultiColumnGrid) {
				ths = grid.headersTable().find('tr[data-mch-level=' + grid._maxLevel + '] th');
				ths.each(function () {
					var $th = $(this);
					if ($th.attr('data-mch-id')) {
						// M.H. 10 Dec 2013 Fix for bug #158504: ColumnFixing combined with MultiColumnHeaders, the main columns can be fixed/unfixed with allowFixing set to false
						columnKey = $th.attr('data-mch-id');
						allowFixing = true;
						// M.H. 6 Feb 2014 Fix for bug #159858: ColumnFixing combined with MultiColumnHeaders, the main column fixing/unfixing options are overriden by the default options of the nested columns
						cs = self._getColumnSettingByKey(columnKey);
						if (cs && cs.allowFixing === false) {
							return true;// continue
						}
						for (j = 0; j < grid._oldCols.length; j++) {
							if (grid._oldCols[j].identifier === columnKey) {
								children = grid._oldCols[j].children;
								for (i = 0; i < children.length; i++) {
									cs = self._getColumnSettingByKey(children[i].key, i);
									if (cs && cs.allowFixing === false) {
										allowFixing = false;
										break;
									}
								}
								break;
							}
						}
						if (!allowFixing) {
							return true;
						}
						self._renderHeaderCellButton(columnKey, isFixed, true, $th);
					} else {
						if ($th.attr('data-skip')) {
							return true;
						}
						columnKey = $th.attr('id').replace(grid.id() + '_', '');
						// M.H. 10 Dec 2013 Fix for bug #158504: ColumnFixing combined with MultiColumnHeaders, the main columns can be fixed/unfixed with allowFixing set to false
						cs = self._getColumnSettingByKey(columnKey);
						if (cs && cs.allowFixing === false) {
							return true;
						}
						if (self._fcData[columnKey] !== true) {
							self._renderHeaderCellButton(columnKey, isFixed, false, $th);
						}
					}
				});
			} else {
				for (i = 0; i < colsLength; i++) {
					columnKey = cols[i].key;
					cs = this._getColumnSettingByKey(columnKey, i);
					isFixed = false;
					if (cs !== null) {
						// M.H. 4 Mar 2013 Fix for bug #134230: ColumnSettings do not work with columnIndex.
						if (cs.allowFixing === false) {
							continue;
						}
						if (cs.isFixed === true) {
							isFixed = true;
						}
					}
					if (this._fcData[columnKey] !== true ) {
						this._renderHeaderCellButton(columnKey, isFixed);
					}
				}
			}
		},
		_headerRendering: function (event, ui) {
			var i;
			for (i = 0; i < this.grid.options.features.length; i++) {
				if (this.grid.options.features[i].name === "Hiding") {
					this._hiding = this.grid.element.data("igGridGroupBy");
					break;
				}
			}
		},
		_getColumnSettingByKey: function (key, colIndex) {
			var i, cs = this.options.columnSettings, csLength = cs.length, res = null;

			for (i = 0; i < csLength; i++) {
				if (cs[i].columnKey !== null && cs[i].columnKey !== undefined) { 
					if (cs[i].columnKey === key) {
						res = cs[i];
						break;
					}
				} else if (cs[i].columnIndex !== null && cs[i].columnIndex !== undefined) {
					if (cs[i].columnIndex === colIndex) {
						res = cs[i];
						break;
					}
				}
			}
			return res;
		},
		_id: function () {
			var i, res = this.grid.id(), argumentsLength = arguments.length;

			if (argumentsLength === 0) {
				return null;
			}

			for (i = 0; i < argumentsLength; i++) {
				res += '_' + arguments[i];
			}

			return res;
		},
		_renderHeaderCellButton: function (columnKey, isFixed, isGroupHeader, $th) {
			// M.H. 25 Feb 2013 Fix for bug #133865: The filtering dropdown can't be opened for fixed column.
			var self = this,
				css = self.css,
				buttonId,
				gridId = this.grid.id(),
				$button,
				$divHeaderButtonContainer,
				$columnFixingHeaderIconContainer;

			if ($th === undefined) {
				$th = this.grid.container().find("#" + gridId + "_" + columnKey);
			}
			buttonId = this._id('header_cell', 'fixing', columnKey);
			if ($th.length === 0) {
				return;
			}
			this.grid._enableHeaderCellFeature($th);
			$columnFixingHeaderIconContainer = $th.find('.ui-iggrid-indicatorcontainer');
			if ($columnFixingHeaderIconContainer.length === 0) {
				$columnFixingHeaderIconContainer = $('<div class="ui-iggrid-indicatorcontainer"></div>').appendTo($th);
			}
			$button = this.grid.container().find("#" + buttonId);
			if ($button.length === 0) {
				// M.H. 31 Oct. 2011 Fix for bug 94362
				$button = $('<a></a>')
					.attr('href', '#')
					// M.H. 27 Feb 2013 Fix for bug #134339: The destroy method of columnFixing does not work.
					.attr('data-fixing-indicator', 'true')
					.attr('id', buttonId);
				// M.H. 31 Oct. 2011 Fix for bug 94362
				// M.H. 22 Feb 2013 Fix for bug #133719: When you fix and unfix columns some extra divs are added in the container of the fixing icon.
				$divHeaderButtonContainer = $columnFixingHeaderIconContainer.find('.ui-iggrid-fixcolumn-headerbuttoncontainer');
				if ($divHeaderButtonContainer.length === 0) {
					$divHeaderButtonContainer = $('<div></div>').addClass(css.headerButtonIconContainer).appendTo($columnFixingHeaderIconContainer);
				}
				$button.appendTo($divHeaderButtonContainer);
				$('<span></span>')
					.appendTo($button);
				$button.bind({
					mousedown: function (event) {
						//$(this).focus();
						// M.H. 4 Mar 2013 Fix for bug #134678: When sorting is enabled fixing a column applies focused style to its header.
						// M.H. 11 Jun 2013 Fix for bug #144395: When you fix a column, fixedHeaders is false and click "Add new row" clicking in the editor of the fixed column cancels the adding.
						//self._preventDefaultEvent(event);
						$(this).trigger('mouseout');
						// M.H. 11 Jun 2013 Fix for bug #144395: When you fix a column, fixedHeaders is false and click "Add new row" clicking in the editor of the fixed column cancels the adding.
						//return false;
					},
					click: function (event) {
						self._preventDefaultEvent(event);
						if ($button.attr('data-fixed') === 'true') { 
							self._unfixColumnInternal(columnKey, isGroupHeader);
						} else {
							self._fixColumnInternal(columnKey, isGroupHeader);
						}
					}
				});
			}
			this._changeStyleHeaderButton(columnKey, isFixed);
		},
		_getMCHHeader: function (id) {
			return this.grid.headersTable().find('th[data-mch-id=' + id + ']');
		},
		_changeStyleHeaderButton: function (columnKey, isFixed) {
			var css = this.css,
				attrVal = 'true', title = this.options.headerFixButtonText,
				$button = this.grid.container().find("#" + this._id("header_cell", "fixing", columnKey)),
				$span;
			
			$span = $button.find('span');
			if (isFixed) {
				$span.removeClass(css.headerButtonIcon);
				$span.addClass(css.headerButtonUnfixIcon);
				title = this.options.headerUnfixButtonText;
			} else {
				attrVal = 'false';
				$span.removeClass(css.headerButtonUnfixIcon);
				$span.addClass(css.headerButtonIcon);
			}
			$button.attr('data-fixed', attrVal).attr('title', title);
		},
		// M.H. 18 Sep 2013 Fix for bug #152468: The fixed and unfixed areas are misalinged when there are cells with text spanned on two rows and the grid doesn't have height in IE9.
		_dataRendering: function (event, ui) {
			if (ui === undefined) {
				return;
			}
			if (this.grid.id() !== ui.owner.id()) {
				return;
			}
			if (this.grid.options.height === null  && this.grid.hasFixedColumns() &&
					$.ig.util.isIE && $.ig.util.browserVersion >= 9) {
				$('#' + this.grid.id() + '_fixed').height("");
			}
		},
		// M.H. 18 Sep 2013 Fix for bug #152468: The fixed and unfixed areas are misalinged when there are cells with text spanned on two rows and the grid doesn't have height in IE9.
		// In IE9+ there is misalignment betweed fixed and unfixed table rows although it is set table heights row. We fix this as setting height of the fixed table
		_dataRendered: function (event, ui) {
			// M.H. 27 Sep 2013 Fix for bug #147490: The "Search Result" span is relocated when column is fixed and you filter the grid in Chrome.
			//this._fixResultContainer();
			if (ui === undefined) {
				return;
			}
			// M.H. 18 Sep 2013 Fix for bug #152468: The fixed and unfixed areas are misalinged when there are cells with text spanned on two rows and the grid doesn't have height in IE9.
			if (this.grid.id() !== ui.owner.id()) {
				return;
			}
			if (this.grid.options.height === null &&
					$.ig.util.isIE && $.ig.util.browserVersion >= 9 && this.grid.hasFixedColumns()) {
				this._syncTableHeights();
			}
		},
		// M.H. 18 Sep 2013 Fix for bug #152468: The fixed and unfixed areas are misalinged when there are cells with text spanned on two rows and the grid doesn't have height in IE9.
		// In IE9+ there is misalignment betweed fixed and unfixed table rows although it is set table heights row. We fix this as setting height of the fixed table
		_syncTableHeights: function () {
			$('#' + this.grid.id() + '_fixed').height(this.grid.element.height());
		},
		_gridInternalRendered: function (event, ui) {
			var i, j, cs = this.options.columnSettings, csLength = cs.length,
				columnKeys = [], hasColumnKey, hasColumnIndex,
				cols = this.grid.options.columns, col,
				countHidden = 0,
				colsLength = cols.length;
			
			for (i = 0; i < csLength; i++) {
				if (cs[i].isFixed !== true) {
					continue;
				}
				hasColumnKey = (cs[i].columnKey !== null && cs[i].columnKey !== undefined);
				hasColumnIndex = (cs[i].columnIndex !== null && cs[i].columnIndex !== undefined);
				if (!hasColumnKey) {
					if (!hasColumnIndex) {
						continue;
					}
					// M.H. 4 Mar 2013 Fix for bug #134230: ColumnSettings do not work with columnIndex.
					if (cs[i].columnIndex >= 0 && cs[i].columnIndex < colsLength) {
						columnKeys.push(cols[cs[i].columnIndex].key);
						if (cols[cs[i].columnIndex].hidden) {
							countHidden++;
						}
					}
				} else {
					columnKeys.push(cs[i].columnKey);
					col = this.grid.columnByKey(cs[i].columnKey);
					if (col && col.hidden) {
						countHidden++;
					}
				}
			}
			if (countHidden === columnKeys.length && countHidden > 0) {
				this._trigger(this.events.columnFixingRefused, null, {
					'columnIdentifier': columnKeys,
					owner: this.grid
				});
				return;
			}
			// M.H. 4 Mar 2013 Fix for bug #134230: ColumnSettings do not work with columnIndex.
			for (j = 0; j < columnKeys.length; j++) {
				this.fixColumn(columnKeys[j]);
			}
			// if width is in percentage then we should check when grid is resized(for instance its container) and sync thead/tbody rows if necessary
			if ($.type(this.grid.options.width) === 'string' && this.grid.options.width.indexOf('%') !== -1 &&
				!this.grid.element.closest(".ui-widget").data("igResponsiveContainer") && !this._responsive) {
				this._responsive = this.grid.element.closest(".ui-widget").igResponsiveContainer().data("igResponsiveContainer");
				this._callBackId = this._responsive.addCallback(this._containerResized, this, 10, "x");
			}
			if (this.options.fixNondataColumns) {
				this.fixDataSkippedColumns();
			}
		},
		_preventDefaultEvent: function (event) {
			event.preventDefault();
			event.stopPropagation();
		},
		_detachEvents: function () {
			if (this._headerRenderedHandler) {
				this.grid.element.unbind('iggridheaderrendered', this._headerRenderedHandler);
			}
			if (this._headerCellRenderedHandler) {
				this.grid.element.unbind('iggridheadercellrendered', this._headerCellRenderedHandler);
			}
			if (this._headerRenderingHandler) {
				this.grid.element.unbind('iggridheaderrendering', this._headerRenderingHandler);
			}
			if (this._gridRenderedHandler) {
				this.grid.element.unbind('iggridrendered', this._gridRenderedHandler);
			}
            // M.H. 7 Mar 2014 Fix for bug #147490: The "Search Result" span is relocated when column is fixed and you filter the grid in Chrome.
			if (this._gridHeightChangingHandler) {
				this.grid.element.unbind("iggrid_heightchanging", this._gridHeightChangingHandler);
			}
            if (this._dataRenderingHandler) {
				this.grid.element.unbind('iggriddatarendering', this._dataRenderingHandler);
			}
            if (this._dataRenderedHandler) {
				this.grid.element.unbind('iggriddatarendered', this._dataRenderedHandler);
			}
		},
		destroy: function () {
			/* destroys the columnfixing widget */
			var fc;
			if (this.grid._fixedColumns && this.grid._fixedColumns.length > 0) {
				this.unfixAllColumns();
			}
			// M.H. 27 Feb 2013 Fix for bug #134339: The destroy method of columnFixing does not work.
			this.grid.headersTable()
				.find("thead > tr > th")
				.not("[data-skip=true]")
				.each(function () {
					var th = $(this);
					th.find("a[data-fixing-indicator=true]").parent().remove();
				});
			this._detachEvents();
			if (this._gridRenderRowHandler !== undefined) {
				this.grid._renderRow = this._gridRenderRowHandler;
			}
			if (typeof this._callBackId === "number") {
				this._responsive.removeCallback(this._callBackId);
				this._callBackId = null;
			}
			fc = this.grid.element.data('igGridFeatureChooser');
			if (fc && this.renderInFeatureChooser) {
				fc._removeFeature('ColumnFixing');
			}
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		_headerCellRendered: function (event, ui) {
			/* check for which cells should be rendered in feature chooser
			*/
			//prevent handling of other grids' events in the case of hierarchical grid
			if (ui.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}
			if (this._isInitFC !== true) {
				this._initFC();
			}
		},
		//_heightChanged: function () {},
        // M.H. 7 Mar 2014 Fix for bug #147490: The "Search Result" span is relocated when column is fixed and you filter the grid in Chrome.
		_gridHeightChanging: function (e, arg) {
			if (!this._containers.body) {
				return;
			}
			var scrollContainerHeight, diff,
				pc = this.grid._prevContainerHeight,
				$fixedBodyContainer = this.grid.fixedBodyContainer();
			if ($fixedBodyContainer.length === 0) {
				return;
			}
			scrollContainerHeight = arg.ch - arg.h;//this._containers.body.unfixedContainer.outerHeight();
			if (this.grid._hscrollbar().is(':visible')) {
				scrollContainerHeight += this.grid._hscrollbar().outerHeight();
			}
			//if ($fixedBodyContainer.outerHeight() !== parseInt(scrollContainerHeight)) {
			// M.H. 21 May 2013 Fix for bug #141227: Scrollbar is in wrong place when Grid's height set to 100%.
			$fixedBodyContainer.height(scrollContainerHeight);
			diff = Math.abs(pc - this.grid.container().height());
			$fixedBodyContainer.height(scrollContainerHeight - diff);
			// M.H. 23 Aug 2013 Fix for bug #147490: The "Search Result" span is relocated when column is fixed and you filter the grid in Chrome.
			//this._fixResultContainer();
		},
		_initFC: function () {
			/* instantiate feature chooser */
			// check whether feature chooser is defined
			var i, fc,
				isMCH = this.grid._isMultiColumnGrid,
				o = this.options,
				cols = this.grid.options.columns,
				colsLength = cols.length, 
				cs,
				columnKey;

			this._isInitFC = true;
			// instantiate igGridFeatureChooser = if it is defined
			fc = this.grid.element.data('igGridFeatureChooser');
			
			if (fc !== null && fc !== undefined) {
				if (isMCH) {
					cols = this.grid._oldCols;
					colsLength = cols.length;
				}
				for (i = 0; i < colsLength; i++) {
					columnKey = cols[i].key;
					this._fcData[columnKey] = false;
					// M.H. 11 Jun 2013 Fix for bug #144394: When filtering is enabled the fixing icon is rendered next to feature chooser.
					if (isMCH && cols[i].level !== 0) {
						continue;
					}
					cs = this._getColumnSettingByKey(columnKey, i);
					if (cs && cs.allowFixing === false) {
						continue;
					}
					if (fc._shouldRenderInFeatureChooser(columnKey) === true) {
						fc._renderInFeatureChooser(columnKey,
							{
								name: 'ColumnFixing',
								text: o.featureChooserTextUnfixedColumn,
								textHide: o.featureChooserTextFixedColumn,
								iconClass: this.css.featureChooserIconClassFixed,
								iconClassOff: this.css.featureChooserIconClassUnfixed,
								//secondaryIconClass: this.css.featureChooserIconClassUnfixed,
								// M.H. 10 Jun 2013 Fix for bug #140584: When the column is initially fixed column the text in the feature chooser is not correct.
								isSelected: (cs && cs.isFixed === true),
								method: $.proxy(this._togglefromfc, this),
								updateOnClickAll: false,
								order: 3, // order in group
								groupName: 'toggle',
								groupOrder: 1,
								type: 'toggle',
								state: 'hide'
							}
							);
						//fc._setSelectedState('Summaries', columnKey, false, false);
						this._fcData[columnKey] = true;
					}
				}
			}
		},
		_togglefromfc: function (event, columnKey, isSelected) {
			var i, cols = this.grid.options.columns, colsLength = cols.length, col, ret;
			
			for (i = 0; i < colsLength; i++) {
				col = cols[i];
				if (col.key === columnKey) {
					if (col.fixed === true) {
						ret = this._unfixColumnInternal(columnKey);
					} else {
						ret = this._fixColumnInternal(columnKey);
					}
					break;
				}
			}
			// M.H. 10 Jun 2013 Fix for bug #144214: The "Fix Column" option changes even when column fixing is refused.
			return (ret.error === undefined);
		},
		_hasWidthInPercent: function () {
			// returns whether grid width is in percentage and/or columns are set in percentage and/or defaultColumnWidth in percentage
			var grid = this.grid, defaultColumnWidth = grid.options.defaultColumnWidth;

			if (grid._gridHasWidthInPercent() || grid._allColumnWidthsInPercentage) {
				return true;
			}
			// M.H. 16 Jul 2013 Fix for bug #146464: When columns don't have width but defaultColumnWidth option is set the grid throws a js error when you fix a column.
			if (defaultColumnWidth &&
				$.type(defaultColumnWidth) === 'string' &&
				defaultColumnWidth.indexOf('%') !== -1) {
				return true;
			}
			return false;
		},
		_columnMap: function () {
			var i, j, isMCH = this.grid._isMultiColumnGrid, cs, columnKey, elem, result = [], cols = this.grid.options.columns, colsLength = cols.length;

			if (this.options.showFixButtons === false) {
				return false;
			}
			for (i = 0; i < colsLength; i++) {
				columnKey = cols[i].key;
				elem = {columnKey: columnKey, enabled: true};
				cs = this._getColumnSettingByKey(columnKey, i);
				if (cs && cs.allowFixing === false) {
					elem.enabled = false;
				} else if (isMCH) {
					for (j = 0; j < this.grid._oldCols.length; j++) {
						if (this.grid._oldCols[j].key === columnKey) {
							break;
						}
					}
					if (j === this.grid._oldCols.length) {
						elem.enabled = false;
					}
				}
				result.push(elem);
			}
			return result;
		},
		/* Overriden functions */
		_renderRow: function (rec, tr, rowId) {
			// overriding grid _renderRow
			if (!this.grid.hasFixedColumns()) {
				return this._gridRenderRowHandler(rec, tr, rowId);
			}
			
			var i, col, index, content, $fixedRow, $unfixedRow, fixedCells, unfixedCells,
				counterFixed = 0, counterUnfixed = 0, $td,
				$tr = $(tr),
				grid = this.grid, cols = grid.options.columns, colsLength = cols.length, isFixedRow = this.grid._isFixedElement($tr);

			if (isFixedRow) {
				$fixedRow = $tr;
				$unfixedRow = grid.element.find('tbody tr:nth-child(' + ($tr.index() + 1) + ')');
			} else {
				$unfixedRow = $tr;
				$fixedRow = this.grid.fixedTable().find("tbody tr:nth-child(" + ($tr.index() + 1) + ")");
			}
			
			fixedCells = $fixedRow.find('td:not([data-skip])');
			unfixedCells = $unfixedRow.find('td:not([data-skip])');
			// render fixed records
			for (i = 0; i < colsLength; i++) {
				col = cols[i];
				if (col.hidden === true) {
					continue;
				}
				if (col.fixed === true) {
					$td = fixedCells.eq(counterFixed++);
				} else {
					$td = unfixedCells.eq(counterUnfixed++);
				}
				
				if (col.template && col.template.length) {
					content = grid._renderTemplatedCell(rec, col);
					if (content.indexOf("<td") === 0) {
						$td.html($(content).html());
					} else {
						$td.html(content);
					}
				} else {
					$td.html(grid._renderCell(rec[col.key], col, rec));
				}
			}
			return tr;
		},
		_renderRecords: function (start, end) {
			var $fixedTable, hasFixedColumns = this.grid.hasFixedColumns();
			this._gridRenderRecordsHandler(start, end);
			if (hasFixedColumns) {
				$fixedTable = this.grid.fixedTable();
				this._renderFixedRecords($fixedTable, start, end);
				// sync heights
                // M.H. 19 Feb 2014 Fix for bug #164298: When a column is fixed and other column is hidden showing this column makes some of the rows higher.
                // we shouldn't apply sync row heights when hide a column because after rendering rows it is applied adjustLastColumnWidth which could cause changes in row heights
				if (this.options.syncRowHeights && this._applySyncRowHeights !== false) {
					this._syncFixedHeights($fixedTable, this.grid.element);
				}
			}
		},
		_renderNewRow: function (rec, key) {
			var grid = this.grid, self = this, 
				tbody = this.grid.element.children("tbody"),
				index = tbody.children("[data-container!=\"true\"]").length,
				virt = (grid.options.virtualization === true || grid.options.rowVirtualization === true);

			this._gridRenderNewRowHandler(rec, key);
			if (!virt) {
				if (grid.hasFixedColumns()) {
					MSApp.execUnsafeLocalFunction(function () {
						grid.fixedTable().find('tbody').append(self._renderFixedRecord(rec, index));
					});
				}
			}
		},
		_updateVScrollbarCellPaddingHelper: function (paddingIncrement, skipHeaderFooters) {
			if (!this.grid.hasFixedColumns()) {
				this._gridUpdatePaddingHandler(paddingIncrement, skipHeaderFooters);
				return;
			}

			var grid = this.grid, gridOpts = grid.options, fTable, hTable, container,
				hasFixedHeaders = gridOpts.showHeader && gridOpts.fixedHeaders === true && gridOpts.height !== null,
				hasFixedFooters = gridOpts.showFooter && gridOpts.fixedFooters === true && gridOpts.height !== null;

			if (this.options.fixingDirection === 'right') {
				// clear scroll padding for unfixed part
				// first we will clear padding for fixed and unfixed part and then we will apply padding
				if (hasFixedHeaders && !skipHeaderFooters) {
					hTable = grid.fixedHeadersTable();
					// remove cell padding for non fixed thead cells(not only for the last)
					grid._removeHeaderCellPadding(grid.headersTable(), true);
				}
				if (hasFixedFooters && !skipHeaderFooters) {
					fTable = grid.fixedFootersTable();
					// remove cell padding for non fixed footers table(for all cells not only for the last)
					grid._removeCellPadding(grid.footersTable(), "tfoot", "td", true);
				}
				// remove cell padding for non fixed tbody cells(not only for the last)
				grid._removeCellPadding(grid.element, "tbody", "td", true);
				container = grid.fixedBodyContainer();
			} else {
				if (hasFixedHeaders && !skipHeaderFooters) {
					hTable = grid.headersTable();
					// remove cell padding for fixed thead cells(not only for the last)
					grid._removeHeaderCellPadding(grid.fixedHeadersTable(), true);
				}
				if (hasFixedFooters && !skipHeaderFooters) {
					fTable = grid.footersTable();
					// remove cell padding for fixed tfoot cells(not only for the last)
					grid._removeCellPadding(grid.fixedFootersTable(), "tfoot", "td", true);
				}
				// remove cell padding for fixed tbody cells(not only for the last)
				grid._removeCellPadding(grid.fixedBodyContainer(), "tbody", "td", true);
				container = this.element;
			}

			if (hasFixedHeaders && !skipHeaderFooters) {
				grid._increaseLastHeaderCellVScrollbarPadding(hTable, paddingIncrement);
			}
			if (hasFixedFooters && !skipHeaderFooters) {
				grid._increaseLastCellVScrollbarPadding(fTable, "tfoot", "td", paddingIncrement);
			}
			grid._increaseLastCellVScrollbarPadding(container, "tbody", "td", paddingIncrement);
		},
		/* // Override functions */
		_syncFixedHeights: function ($fixedTable, $unfixedTable) {
			var heights = [], $sc, $scTable, $trsFixedTable, $trsUnfixedTable,
				grid = this.grid,
				refreshHeight = ($.ig.util.isIE && grid.options.height !== null);
			// M.H. 14 Jun 2013 Fix for bug #144693: When you fix a column and then filter a column the records increase their height.
			// in IE9+ there is misalignment between fixed and unfixed records because rendering engine of IE does not render properly records when table row height is explicitly set
			// to fix this we should set height of fixed/unfixed table
			// when filtering and there is only one row to show then row gets the height of the whole fixed area when height is explicitly set for the table
			if (refreshHeight) {
				if (grid.options.virtualization === true || grid.options.rowVirtualization === true) {
					$sc = this.grid._vdisplaycontainer();
				} else {
					$sc = this.grid.scrollContainer();
				}
				if ($sc.length === 0) {
					$sc = this.grid.element;
				}
				$scTable = $sc.find('table');
				if ($scTable.length > 0 && $scTable[0].style.height === '') {
					this.grid.fixedBodyContainer().find('table').css('height', '');
				}
			}
			$trsFixedTable = $fixedTable.find('tr');
			$trsUnfixedTable = $unfixedTable.find('tr');
			$trsUnfixedTable.map(function (ind) {
				var unfixedHeight = this.offsetHeight, fixedHeight = $trsFixedTable[ind].offsetHeight;

				if (unfixedHeight < fixedHeight) {
					unfixedHeight = fixedHeight;
				}
				heights.push(unfixedHeight);
			});

			$.each(heights, function (ci, h) {
				var height = h + 'px';

				$trsFixedTable[ci].style.height = height;
				$trsUnfixedTable[ci].style.height = height;
			});

			if (refreshHeight) {
				this.grid.fixedBodyContainer().find('table').css('height', $scTable.height());
			}
		},
		// M.H. 5 Mar 2013 Fix for bug #134687: Sorted style is removed the first time you fix a sorted column.
		_renderFixedRecords: function ($table, start, end, onlyRows) {
			var prime, grid = this.grid, tmpl, rs,
				ds = grid.dataSource.dataView(), i, d = "", noCancel = true;

			if (start === undefined) { //no params => render all
				start = 0;
				end = ds.length - 1;
			}
			if (start !== undefined && end === undefined) {
				end = start;
				if (end > ds.length - 1) {
					end = ds.length - 1;
				}
				start = 0;
			}
			if (start < 0) {
				start = 0;
			}
			if (end > ds.length - 1 && !onlyRows) {
				end = ds.length - 1;
			}
			if (noCancel) {
				for (i = start; i <= end; i++) {
					// M.H. 5 Mar 2013 Fix for bug #134687: Sorted style is removed the first time you fix a sorted column.
					d += this._renderFixedRecord(ds[i], i, onlyRows);
				}
				$table.find('tbody').html(d);
			}
		},
		// M.H. 5 Mar 2013 Fix for bug #134687: Sorted style is removed the first time you fix a sorted column.
		_renderFixedRecord: function (data, rowIndex, onlyRows) {
			// generate a Tr and append it to the table
			var i, grid = this.grid,
				o = grid.options,
				key = o.primaryKey, ar = o.accessibilityRendering,
				dstr = "", cols = grid._fixedColumns, noVisibleColumns;
			dstr += '<tr';
			if (rowIndex % 2 !== 0 && o.alternateRowStyles) {
				dstr += ' class="' + grid.css.recordAltClass + '"';
			}
			if (data) {
				if (!_aNull(key)) {
					dstr += ' data-id="' + grid._kval_from_key(key, data) + '"';
				} else if (!_aNull(data.ig_pk)) {
					dstr += ' data-id="' + data.ig_pk + '"';
				}
			}
			//data index to which the row is bound
			if (o.virtualization && o.virtualizationMode === 'continuous') {
				dstr += ' data-row-idx="' + rowIndex + '"';
			}
			if (ar) {
				dstr += ' role="row">';
			} else {
				dstr += '>';
			}
			if (onlyRows === true) {
				dstr += '</tr>';
				return dstr;
			}
			noVisibleColumns = true;
			$(cols).each(function (colIndex) {
			if (cols[colIndex].hidden || cols[colIndex].fixed !== true) {
				return;
				}
				noVisibleColumns = false;
				if (ar) {
					dstr += '<td role="gridcell" aria-describedby="' + this.key + '"';
				} else {
					dstr += '<td';
				}
				if (cols[colIndex].template && cols[colIndex].template.length) {
					temp = grid._renderTemplatedCell(data, this);
					if (temp.indexOf("<td") === 0) {
						dstr += temp.substring(3);
					} else {
						dstr += '>' + temp;
					}
					dstr = grid._editCellStyle(dstr, data, this.key, true);
				} else {
					dstr += grid._addCellStyle(data, this.key ? this.key : colIndex, true) + '>' + grid._renderCell(data[this.key ? this.key : colIndex], this, data);
				}
				dstr += '</td>';
			});
			if (noVisibleColumns) {
				dstr += '<td role="gridcell"></td>';
			}
			dstr += '</tr>';
			return dstr;
		},
		_detachColumn: function (col) {
			var position, fixed, headerCells, grid = this.grid, tPos,
				isMultiColumnGrid = grid._isMultiColumnGrid, footerCells,
				hasFixedColumns = grid.hasFixedColumns();

			if (!hasFixedColumns) {
				this._gridDetachColumnHandler(col);
			} else {
				fixed = col.fixed;
				col.hidden = false;
				grid._visibleColumnsArray = undefined;
				// we need to get total position of header cells(no matter fixed/unfixed) - position according to this._headerCells(in case of MCH)
				tPos = $.inArray(col, this.grid._visibleColumns());
				position = this._getVisibleIndex(col.key, (col.fixed === true), true);
				col.hidden = true;
				grid._visibleColumnsArray = undefined;
				grid._initializeDetachedContainers();
				if (fixed) {
					headerCells = grid.fixedHeadersTable().children("thead").children("tr").not("[data-skip=true]");
					footerCells = grid.fixedFootersTable().children("tfoot").children("tr");
				} else {
					footerCells = grid.footersTable().children("tfoot").children("tr");
					headerCells = grid.headersTable().children("thead").children("tr").not("[data-skip=true]");
				}
				if (isMultiColumnGrid) {
					grid._hideMultiHeaderCells(grid._headerCells, tPos, col.key);
					if (fixed) {
						headerCells = grid.fixedHeadersTable().children("thead").children("tr:not([data-mch-level])").not("[data-skip=true]");
					} else {
						headerCells = grid.headersTable().children("thead").children("tr:not([data-mch-level])").not("[data-skip=true]");
					}
					grid._detachCells(
						headerCells,
						function (row) {
							return row.children("th, td").not("[data-skip=true]");
						},
						position,
						grid._detachedHeaderCells,
						col.key
					);
				} else {
					grid._detachCells(
							headerCells,
							function (row) {
								return row.children("th, td").not("[data-skip=true]");
							},
						position,
						grid._detachedHeaderCells,
						col.key
					);
				}
				grid._detachCells(
					footerCells,
					function (row) { return row.children("td").not("[data-skip=true]"); },
					position,
					grid._detachedFooterCells,
					col.key
				);
			}
		},
		_attachColumn: function (col) {
			if (!this.grid.hasFixedColumns()) {
				this._gridAttachColumnHandler(col);
				return;
			}
			var headerCells, footerCells, fixed = col.fixed,
				grid = this.grid, position = this._getVisibleIndex(col.key, (col.fixed === true), true);

			grid._initializeDetachedContainers();
			if (grid._isMultiColumnGrid) {
				grid._showMultiHeaderCells(col.key);
				if (fixed) {
					headerCells = grid.fixedHeadersTable().children("thead").children("tr:not([data-mch-level])").not("[data-skip=true]");
					footerCells = grid.fixedFootersTable().children("tfoot").children("tr");
				} else {
					headerCells = grid.headersTable().children("thead").children("tr:not([data-mch-level])").not("[data-skip=true]");
					footerCells = grid.footersTable().children("tfoot").children("tr");
				}
				grid._attachCells(
					headerCells,
					function (row) { return row.children("th, td").not("[data-skip=true]"); },
					position,
					grid._detachedHeaderCells,
					col.key
				);
			} else {
				if (fixed) {
					headerCells = grid.fixedHeadersTable().children("thead").children("tr").not("[data-skip=true]");
					footerCells = grid.fixedFootersTable().children("tfoot").children("tr");
				} else {
					headerCells = grid.headersTable().children("thead").children("tr").not("[data-skip=true]");
					footerCells = grid.footersTable().children("tfoot").children("tr");
				}
				grid._attachCells(
					headerCells,
					function (row) { return row.children("th, td").not("[data-skip=true]"); },
					position,
					grid._detachedHeaderCells,
					col.key
				);
			}
			grid._attachCells(
				footerCells,
				function (row) { return row.children("td").not("[data-skip=true]"); },
				position,
				grid._detachedFooterCells,
				col.key
			);
		},
		_renderColgroup: function (table, isHeader, isFooter, autofitLastColumn) {
			this._gridRenderColgroupHandler(table, isHeader, isFooter, autofitLastColumn);
			if (!this.grid.hasFixedColumns()) {
				return;
			}
			//w = parseInt(this.grid.fixedContainer().css('width'), 10)
			this._renderFixedColgroup(isHeader, isFooter, autofitLastColumn);
			//this._deltaWidth = nW - w;
		},
		_rerenderFixedColgroups: function () {
			if (this._containers.header.fixedTable) {
				this._renderFixedColgroup(true, false);
			}
			this._renderFixedColgroup();
			if (this._containers.footer.fixedTable) {
				this._renderFixedColgroup(false, true);
			}
		},
		_renderFixedColgroup: function (isHeader, isFooter, autofitLastColumn) {
			var i, table, colgroup, w, totalWidth = 0,
				cols = this.grid._visibleColumns(true);
            // M.H. 25 Mar 2014 Fix for bug #168158: When autoGenerateColumns is TRUE fixing a column causes a JS error
			if (!this._containers || !this._containers.body) {
                this._populateContainers();
            }
			if (isHeader) {
				table = this._containers.header.fixedTable || this._containers.body.fixedTable;
			} else if (isFooter) {
				table = this._containers.footer.fixedTable || this._containers.body.fixedTable;
			} else {
				table = this._containers.body.fixedTable;
			}
			colgroup = $(table).find('colgroup');
			if (colgroup.length === 0) {
				colgroup = $("<colgroup></colgroup>").prependTo(table);
			}
			colgroup.empty();
			for (i = 0; i < cols.length; i++) {
				if (!cols[i].fixed) {
					continue;
				}
				if (cols[i].oWidth) {
					w = cols[i].oWidth;
				} else {
					w = cols[i].width;
				}
				totalWidth += parseInt(w, 10);
				$("<col></col>").appendTo(colgroup).css("width", w);
			}
			return totalWidth;
		},
		_containerResized: function () {
			// when grid container is resized and width is in percentage then we should sync header heights and row heights between fixed and unfixed area
			if (!this.grid.hasFixedColumns()) {
				return;
			}
			var headersTableHeight = this.grid.headersTable().outerHeight(),
				fixedHeadersTableHeight = this.grid.fixedHeadersTable().outerHeight();
			// if offset top of the last row is different between fixed and unfixed area we should sync heights of table rows(in fixed/unfixed tables)
			// we do not check offset of each table row and do not sync heights of all table rows because this could cause performance issue
			if (this._containers && this._containers.body) {
				// M.H. 6 Jan 2014 Fix for bug #160621: By setting a column as fixed, Row height does not auto resize when resizing the column.
				if (Math.abs(this._containers.body.fixedTable.outerHeight() - this._containers.body.unfixedTable.outerHeight()) > 1) {
					this._syncRowsHeights(this._containers.body.unfixedContainer, this._containers.body.fixedContainer);
				}
			}
			// if headers table heights in fixed/unfixed area are different then we should sync table head rows
			if (Math.abs(headersTableHeight - fixedHeadersTableHeight) > 1) {
				this._syncRowsHeights(this.grid.headersTable().find('thead'), this.grid.fixedHeadersTable().find('thead'));
				this.grid._initializeHeights();
			}
		},
		_checkGridNotSupportedFeatures: function () {
			// Throw an exception for unsupported integration scenarios
			if (this.grid.options._isHierarchicalGrid) {
				throw new Error($.ig.ColumnFixing.locale.hierarchicalGridNotSupported);
			}
			if ((this.grid.options.width === null || this.grid.options.width === '') && 
				(this.grid.options.height === null || this.grid.options.height === '')) {
				throw new Error($.ig.ColumnFixing.locale.noGridWidthHeightNotSupported);
			}
			var i, featureName,
				gridOptions = this.grid.options,
				features = gridOptions.features, featuresLength = features.length;
			// this means features
			if (featuresLength === 1) {
				return;
			}
			// M.H. 16 Sep 2013 Fix for bug #144030: When no width and height are set, and columnFixing is enabled, no descriptive error is thrown
			if (gridOptions.virtualization === true ||
					(gridOptions.rowVirtualization === true && gridOptions.height !== null) ||
					(gridOptions.columnVirtualization === true && gridOptions.width !== null)) {
				throw new Error($.ig.ColumnFixing.locale.virtualizationNotSupported);
			}
			for (i = 0; i < featuresLength; i++) {
				featureName = features[i].name;
				if (!featureName) {
					continue;
				}
				featureName = featureName.toLowerCase();
				switch(featureName) {
					case "groupby":
						throw new Error($.ig.ColumnFixing.locale.groupByNotSupported);
					case "columnmoving":
						throw new Error($.ig.ColumnFixing.locale.columnMovingNotSupported);
					case "responsive":
						throw new Error($.ig.ColumnFixing.locale.responsiveNotSupported);
				}
			}
		},
		_hidingFinishing: function (args) {
			var i, cols = args.columns;
            // M.H. 19 Feb 2014 Fix for bug #164298: When a column is fixed and other column is hidden showing this column makes some of the rows higher.
			this._applySyncRowHeights = false;
			if (args.hidden) {
				for (i = 0; i < cols.length; i++) {
					this._columnHiding(null, { columnKey: cols[i].key });
				}
			} else {
                // M.H. 13 Feb 2014 Fix for bug #164298: When a column is fixed and other column is hidden showing this column makes some of the rows higher.
				// when showing columns then renderRecords is called. In that case colgroup is not re-rendered although the new TDs are rendered inside the table rows which causes in some cases the grid rows to enlarge heights
				// to fix the problem we re-set hidden properties and then reRenderColgroups
				for (i = 0; i < cols.length; i++) {
					cols[i].hidden = false;
				}
				this.grid._visibleColumnsArray = undefined;
				this.grid._rerenderColgroups();
			}
		},
		_hidingFinished: function (args) {
			var i, cols = args.columns, $fixedTable;

			if (args.hidden) {
				for (i = 0; i < cols.length; i++) {
					this._columnHidden(null, { columnKey: cols[i].key });
				}
			} else {
				for (i = 0; i < cols.length; i++) {
					this._columnShown(null, { columnKey: cols[i].key });
				}
			}
			// sync heights
			if (this.grid.hasFixedColumns() && this.options.syncRowHeights && this._applySyncRowHeights === false) {
				$fixedTable = this.grid.fixedTable();
				this._syncFixedHeights($fixedTable, this.grid.element);
			}
            // M.H. 19 Feb 2014 Fix for bug #164298: When a column is fixed and other column is hidden showing this column makes some of the rows higher.
			this._applySyncRowHeights = true;
		},
		//Hiding events
		_columnShown: function (event, ui) {
			/* If autoFitLastColumn is TRUE and we show fixed column then: 
			1. the width of fixed area should be increased(the width of the shown column)
			2. on the other hand the unfixed area should be decreased.
			*/
			var i, columnKey = ui.columnKey, cols = this.grid.options.columns, colsLength = cols.length, col;
			for (i = 0; i < colsLength; i++) {
				col = cols[i];
				if (col.key === columnKey) {
					break;
				}
			}
			if (!col) {
				return;
			}
			if (col.fixed) {
				this._updateSingleContainerWidth(col.width, true);
				if (this.grid.options.autofitLastColumn) {
					this._updateSingleContainerWidth(-col.width, false);
					// in case of autofitlastcolumn then we should re-render the colgroups so that columns have correct widths.
					this.grid._rerenderColgroups();
					this.grid._adjustLastColumnWidth(false);
				}
			}
			this._populateContainers();
			this._updateHScrollbar();
			this.grid._columnMovingResets();
		},
		_columnHiding: function (event, ui) {
			// there are cases when hiding fixed column could cause misalignment because fixed part will be with another width(different then after hiding is finished)
			// rows height should be calculated according to the actual(after hiding is applied) width
			var w, columnKey = ui.columnKey, col = this.grid.columnByKey(columnKey);

			if (!col) {
				return;
			}
			if (col.fixed && col.width) {
				w = parseInt(col.width, 10);
				this._updateSingleContainerWidth(-w, true);
			}
		},
		_columnHidden: function (event, ui) {
			var i, w, columnKey = ui.columnKey, cols = this.grid.options.columns, colsLength = cols.length, col;
			for (i = 0; i < colsLength; i++) {
				col = cols[i];
				if (col.key === columnKey) {
					break;
				}
			}
			if (!col) {
				return;
			}
			if (col.fixed) {
				w = parseInt(col.width, 10);
				//this._updateSingleContainerWidth(-w, true);
				if (this.grid.options.autofitLastColumn) {
					this._updateSingleContainerWidth(w, false);
					this.grid._rerenderColgroups();
					this.grid._adjustLastColumnWidth(true);
				}
			} else {
				if (this.grid.options.autofitLastColumn) {
					this.grid._rerenderColgroups();
					this.grid._adjustLastColumnWidth(true);
				}
			}
			this._populateContainers();
			this._updateHScrollbar();
		},
		_injectGrid: function (gridInstance, isRebind) {
			this.grid = gridInstance;
			// M.H. 9 Sep 2013 Fix for bug #144030: When no width and height are set, and columnFixing is enabled, no descriptive error is thrown
			this._checkGridNotSupportedFeatures();
			// M.H. 28 May 2014 Fix for bug #172200: Memory leak when using the features of the grid
			this._detachEvents();
			this._headerCellRenderedHandler = $.proxy(this._headerCellRendered, this);
			this.grid.element.bind('iggridheadercellrendered', this._headerCellRenderedHandler);
			this._headerRenderedHandler = $.proxy(this._headerRendered, this);
			this.grid.element.bind('iggridheaderrendered', this._headerRenderedHandler);
			this._headerRenderingHandler = $.proxy(this._headerRendering, this);
			this.grid.element.bind('iggridheaderrendering', this._headerRenderingHandler);
			// we should re-render main fixed container when grid changes its height
			//if (this.grid.options.height !== null) {
			//this._gridContainerHeightHandler = $.proxy(this._heightChanged, this);
			//this.grid.element.bind("iggrid_heightchanged", this._gridContainerHeightHandler);
            // M.H. 7 Mar 2014 Fix for bug #147490: The "Search Result" span is relocated when column is fixed and you filter the grid in Chrome.
			this._gridHeightChangingHandler = $.proxy(this._gridHeightChanging, this);
			this.grid.element.bind("iggrid_heightchanging", this._gridHeightChangingHandler);
			//}
			if (this.grid._columns === undefined || this.grid._columns === null) {
				this.grid._columns = this.grid.options.columns.clone();
			}
			this._gridRenderedHandler = $.proxy(this._gridInternalRendered, this);
			this.grid.element.bind('iggridrendered', this._gridRenderedHandler);
			// M.H. 24 Jul 2013 Fix for bug #143633: If you call dataBind method while you have fixed columns the grid becomes misaligned after you scroll it horizontally.
			// we should not reset fixedColumns array - for instance on rebind(in this case isRebind is true) we should preserve _fixedColumns array
			if (this.grid._fixedColumns === undefined) {
				this.grid._fixedColumns = [];
			}
			// M.H. 18 Sep 2013 Fix for bug #152468: The fixed and unfixed areas are misalinged when there are cells with text spanned on two rows and the grid doesn't have height in IE9.
			if (this.grid.options.height === null &&
					$.ig.util.isIE && $.ig.util.browserVersion >= 9) {
				this._dataRenderingHandler = $.proxy(this._dataRendering, this);
				this.grid.element.bind('iggriddatarendering', this._dataRenderingHandler);
				this._dataRenderedHandler = $.proxy(this._dataRendered, this);
				this.grid.element.bind('iggriddatarendered', this._dataRenderedHandler);
			}
			// override functions
			if (!this._isFunctionsOverriden) {
				this.grid._visibleAreaWidth(this.options.minimalVisibleAreaWidth);
				this._gridRenderRowHandler = $.proxy(this.grid._renderRow, this.grid);
				this._renderRowHandler = $.proxy(this._renderRow, this);
				this.grid._renderRow = this._renderRowHandler;

				this._gridRenderRecordsHandler = $.proxy(this.grid._renderRecords, this.grid);
				this._renderRecordsHandler = $.proxy(this._renderRecords, this);
				this.grid._renderRecords = this._renderRecordsHandler;

				this._gridRenderNewRowHandler = $.proxy(this.grid.renderNewRow, this.grid);
				this._renderNewRowHandler = $.proxy(this._renderNewRow, this);
				this.grid.renderNewRow = this._renderNewRowHandler;
				//override detach/attach cells
				this._gridDetachColumnHandler = $.proxy(this.grid._detachColumn, this.grid);
				this._detachColumnHandler = $.proxy(this._detachColumn, this);
				this.grid._detachColumn = this._detachColumnHandler;
				this._gridAttachColumnHandler = $.proxy(this.grid._attachColumn, this.grid);
				this._attachColumnHandler = $.proxy(this._attachColumn, this);
				this.grid._attachColumn = this._attachColumnHandler;

				this._gridRenderColgroupHandler = $.proxy(this.grid._renderColgroup, this.grid);
				this._renderColgroupHandler = $.proxy(this._renderColgroup, this);
				this.grid._renderColgroup = this._renderColgroupHandler;

				this._gridUpdatePaddingHandler = $.proxy(this.grid._updateVScrollbarCellPaddingHelper, this.grid);
				this._updateVScrollbarCellPaddingHelperHandler = $.proxy(this._updateVScrollbarCellPaddingHelper, this);
				this.grid._updateVScrollbarCellPaddingHelper = this._updateVScrollbarCellPaddingHelperHandler;
				this._isFunctionsOverriden = true;

				// attaching to hiding events
				/*
				this._columnShownHandler = $.proxy(this._columnShown, this);
				this.grid.element.bind('iggridhidingcolumnshown', this._columnShownHandler);

				this._columnHidingHandler = $.proxy(this._columnHiding, this);
				this.grid.element.bind('iggridhidingcolumnhiding', this._columnHidingHandler);

				this._columnHiddenHandler = $.proxy(this._columnHidden, this);
				this.grid.element.bind('iggridhidingcolumnhidden', this._columnHiddenHandler);
				*/
			}
		}
	});

	$.extend($.ui.igGridColumnFixing, {version: '14.1.20141.2249'});
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid Column Moving 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.tree.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery, window, document */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}
(function ($) {

	$.widget("ui.igGridColumnMoving", {
		renderInFeatureChooser: true,
		options: {
			/* type="array" A list of column settings that specifies moving options on a per column basis. */
			columnSettings: [
				{
					/* type="string" Column key. this is a required property in every column setting if columnIndex is not set. */
					columnKey: null,
					/* type="number" Column index. Can be used in place of column key. The preferred way of populating a column setting is to always use the column keys as identifiers. */
					columnIndex: null,
					/* type="bool" Allows the column to be moved. */
					allowMoving: true
				}
			],
			/* type="deferred|immediate" Specify the drag-and-drop mode for the feature
			immediate type="string" Column headers will rearange as you drag with a space opening under the cursor for the header to be dropped on
			deferred type="string" A clone of the header dragged will be created and indicators will be shown between columns to help navigate the drop.
			*/
			mode: "immediate",
			/* type="dom|render" Specify the way columns will be rearranged
			dom type="string" Columns will be rearranged through dom manipulation
			render type="string" Columns will not be rearranged but the grid will be rendered again with the new column order. Please note this option is incompatible with immediate move mode.
			*/
			moveType: "dom",
			/* type="bool" Specifies if header cells should include an additional button that opens a moving helper dropdown. */
			addMovingDropdown: true,
			/* type="number" Specifies width of column moving dialog */
			movingDialogWidth: 400,
			/* type="number" Specifies height of column moving dialog */
			movingDialogHeight: "",
			/* type="number" Specifies time in milliseconds for animation duration to show/hide modal dialog */
			movingDialogAnimationDuration: 200,
			/* type="number" Specifies the length (in pixels) between the dragged column and the column edges below which the move operation is accepted */
			movingAcceptanceTolerance: 20,
			/* type="number" Specifies the length (in pixels) between the dragged column and the grid edges below which horizontal scrolling occurs */
			movingScrollTolerance: 20,
			/* type="number" Specifies a multiplier for the delay between subsequent scroll operations. The larger this number is, the slower scrolling will appear to be. */
			scrollSpeedMultiplier: 2.0,
			/* type="number" Specifies the length (in pixels) of each individual scroll operation */
			scrollDelta: 2,
			/* type="bool" Specifies whether the contents of the column being dragged will get hidden. The option is only
			relevant in immediate moving mode. */
			hideHeaderContentsDuringDrag: true,
			/* type="number" Specifies the opacity of the drag markup, while a column header is being dragged.
			The value must be between 0 and 1. When GroupBy is enabled, the corresponding option in the GroupBy configuration 
			will be used with priority over this one. */
			dragHelperOpacity: 1.0,
			/* type="string" Specifies caption for each move down button in the column moving dialog */
			movingDialogCaptionButtonDesc: $.ig.ColumnMoving.locale.movingDialogCaptionButtonDesc,
			/* type="string" Specifies caption for each move up button in the column moving dialog */
			movingDialogCaptionButtonAsc: $.ig.ColumnMoving.locale.movingDialogCaptionButtonAsc,
			/* type="string" Specifies caption text for the column moving dialog */
			movingDialogCaptionText: $.ig.ColumnMoving.locale.movingDialogCaptionText,
			/* type="string" Specifies caption text for the feature chooser entry */
			movingDialogDisplayText: $.ig.ColumnMoving.locale.movingDialogDisplayText,
			/* type="string" Specifies caption for the move left dropdown button */
			dropDownMoveLeftText: $.ig.ColumnMoving.locale.dropDownMoveLeftText,
			/* type="string" Specifies caption for the move right dropdown button */
			dropDownMoveRightText: $.ig.ColumnMoving.locale.dropDownMoveRightText,
			/* type="string" Specifies caption for the move first dropdown button */
			dropDownMoveFirstText: $.ig.ColumnMoving.locale.dropDownMoveFirstText,
			/* type="string" Specifies caption for the move last dropdown button */
			dropDownMoveLastText: $.ig.ColumnMoving.locale.dropDownMoveLastText,
			/* type="string" Specifies tooltip text for the move indicator*/
			movingToolTipMove: $.ig.ColumnMoving.locale.movingToolTipMove,
			/* type="string" Specifies caption text for the feature chooser submenu button */
			featureChooserSubmenuText: $.ig.ColumnMoving.locale.featureChooserSubmenuText,
			/* type="string" Controls containment behavior of column moving dialog.
				owner type="string" The dialog will be draggable only in the grid area
				window type="string" The dialog will be draggable in the whole window area
			*/
			columnMovingDialogContainment: "owner"
		},
		css: {
			/* Classes applied to the table header cells when the mouse hovers on them */
			headerCellMouseOver: "ui-state-hover",
			/* Classes applied to the table header button expanding the moving dropdown */
			dropDownButton: "ui-iggrid-moving-indicator",
			/* Classes applied to the container for the drop down header button */
			dropDownIndicatorContainer: "ui-iggrid-indicatorcontainer",
			/* Classes applied to the top column moving indicator in deferred mode */
			dragIndicatorTop: "ui-iggrid-columnmoving-dragtop",
			/* Classes applied to the bottom column moving indicator in deferred mode */
			dragIndicatorBottom: "ui-iggrid-columnmoving-dragbottom",
			/* Classes applied to the feature chooser icon container */
			dropDownIconContainer: "ui-iggrid-columnmovingiconcontainer",
			/* Classes applied to the feature chooser icon for column moving feature */
			featureChooserMovingDialogIcon: "ui-icon ui-iggrid-icon-move",
			/* Classes applied to the move left icon for the column moving dialog */
			featureChooserLeftIcon: "ui-iggrid-featurechooser-li-iconcontainer ui-icon ui-iggrid-icon-left",
			/* Classes applied to the move right icon for the column moving dialog */
			featureChooserRightIcon: "ui-iggrid-featurechooser-li-iconcontainer ui-icon ui-iggrid-icon-right",
			/* Classes applied to the move first icon for the column moving dialog */
			featureChooserFirstIcon: "ui-iggrid-featurechooser-li-iconcontainer ui-icon ui-iggrid-icon-first",
			/* Classes applied to the move last icon for the column moving dialog */
			featureChooserLastIcon: "ui-iggrid-featurechooser-li-iconcontainer ui-icon ui-iggrid-icon-last",
			featureChooserSubmenu: "ui-iggrid-featurechooser-list-submenu ui-menu ui-widget ui-widget-content ui-corner-all",
			featureChooserSubmenuItem: "ui-iggrid-featurechooser-list-submenu-item ui-state-default",
			featureChooserSubmenuItemMouserOver: "ui-state-hover",
			/* Classes applied to the column moving dropdown dialog */
			columnMovingDropDown: "ui-iggrid-columnmoving-dropdown-dialog ui-widget ui-widget-content ui-corner-all",
			/* Classes applied to the column moving dropdown list */
			columnMovingDropDownList: "ui-iggrid-columnmoving-dropdown-list ui-menu",
			/* Classes applied to each item in the column moving dropdown list */
			columnMovingDropDownItem: "ui-iggrid-columnmoving-dropdown-ddlistitemicons ui-state-default",
			/* Classes applied to each item in the column moving dropdown list when mouse hovers over them */
			columnMovingDropDownItemHover: "ui-iggrid-columnmoving-dropdown-listitem-hover ui-state-active ui-state-hover",
			/* Classes applied to the text of each item in the column moving dropdown list when mouse hovers over them */
			columnMovingDropDownItemText: "ui-iggrid-columnmoving-dropdown-ddlistitemtext",
			/* Classes applied to the column indicators of the moving drop down */
			columnMovingIndicatorSelected: "ui-iggrid-hiding-indicator-selected",
			/* Classes applied to the lists of items in the moving dialog */
			movingDialogItemList: "ui-iggrid-moving-dialog-columns",
			/* Classes applied to the items in the item lists in the moving dialog */
			movingDialogListItem: "ui-widget-content",
			/* Classes applied to the move up arrow of each list item in the moving dialog */
			movingDialogListItemArrowUp: "ui-icon-arrowthick-1-n ui-button-icon-primary ui-icon",
			/* Classes applied to the move down arrow of each list item in the moving dialog */
			movingDialogListItemArrowDown: "ui-icon-arrowthick-1-s ui-button-icon-primary ui-icon",
			/* Classes applied to the inner button elements of the arrow indicators in the moving dialog */
			movingDialogListItemArrowButton: "ui-button ui-corner-all ui-button-icon-only ig-sorting-indicator",
			/* Classes applied to the text of each list item in the moving dialog */
			movingDialogListItemText: "ui-iggrid-dialog-text",
			/* Classes applied to the close button for the moving dialog */
			movingDialogCloseButton: "ui-icon ui-icon-close"
		},
		events: {
			/* cancel="true" Event which is fired when a drag operation begins on a column header
			use args.columnKey to get the column key of the column being dragged
			use args.columnIndex to get the column index of the column being dragged
			use args.owner to get a reference to the widget
			use args.header to get a reference to the orginal th being dragged
			use args.helper to get a reference to cloned DOM element that's actually being dragged
			*/
			columnDragStart: "columnDragStart",
			/* Event which is fired when a drag operation ends on a column header
			use args.columnKey to get the column key of the column that was being dragged
			use args.columnIndex to get the column index of the column that was being dragged
			use args.owner to get a reference to the widget
			use args.header to get a reference to the orginal th that was being dragged
			use args.helper to get a reference to cloned DOM element that was actually being dragged
			*/
			columnDragEnd: "columnDragEnd",
			/* Event which is fired when a drag operation is canceled
			use args.columnKey to get the column key of the column that was being dragged
			use args.columnIndex to get the column index of the column that was being dragged
			use args.owner to get a reference to the widget
			use args.header to get a reference to the orginal th that was being dragged
			use args.helper to get a reference to cloned DOM element that was actually being dragged
			*/
			columnDragCanceled: "columnDragCanceled",
			/* cancel="true" Event which is fired when a column moving operation is initiated
			use args.columnKey to get the column key of the column that was being moved
			use args.columnIndex to get the column index of the column that was being moved
			use args.targetIndex to get the new column index of the column that was being moved
			use args.owner to get a reference to the widget			
			*/
			columnMoving: "columnMoving",
			/* Event which is fired when a column moving operation completes
			use args.columnKey to get the column key of the column that was moved
			use args.oldIndex to get the previous column index of the column that was moved
			use args.newIndex to get the new column index of the column that was being moved
			use args.owner to get a reference to the widget
			*/
			columnMoved: "columnMoved",
			/* cancel="true" event fired before the moving dialog is opened.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridColumnMoving widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.movingDialogElement to get a reference to the moving dialog element. This is a jQuery object.
			*/
			movingDialogOpening: "movingDialogOpening",
			/* event fired after the column chooser is already opened.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridColumnMoving widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.movingDialogElement to get a reference to the moving dialog element. This is a jQuery object.
			*/
			movingDialogOpened: "movingDialogOpened",
			/* event fired every time the moving dialog changes its position.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridMoving widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.movingDialogElement to get a reference to the moving dialog element. This is a jQuery object.
			Use ui.originalPosition to get the original position of the moving dialog div as { top, left } object, relative to the page.
			Use ui.position to get the current position of the moving dialog div as { top, left } object, relative to the page.
			*/
			movingDialogDragged: "movingDialogDragged",
			/* cancel="true" event fired before the moving dialog is closed.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridColumnMoving widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.movingDialogElement to get a reference to the moving dialog element. This is a jQuery object.
			*/
			movingDialogClosing: "movingDialogClosing",
			/* event fired after the moving dialog has been closed.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridColumnMoving widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.movingDialogElement to get a reference to the moving dialog element. This is a jQuery object.
			*/
			movingDialogClosed: "movingDialogClosed",
			/* cancel="true" event fired before the contents of the model dialog are rendered.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridColumnMoving widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.movingDialog to get a reference to the Moving Dialog element. This is a jQuery object.
			*/
			movingDialogContentsRendering: "movingDialogContentsRendering",
			/* event fired after the contents of the model dialog are rendered.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridColumnMoving widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.movingDialog to get a reference to the Moving Dialog element. This is a jQuery object.
			*/
			movingDialogContentsRendered: "movingDialogContentsRendered",
			/* event fired when move up button is pressed in the moving dialog
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridColumnMoving widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.movingDialog to get a reference to the Moving Dialog element. This is a jQuery object.
			Use ui.columnKey to get the column key of the column that was being moved
			Use ui.columnIndex to get the column index of the column that was being moved
			Use ui.targetIndex to get the new column index of the column that was being moved
			*/
			movingDialogMoveUpButtonPressed: "movingDialogMoveUpButtonPressed",
			/* event fired when move down button is pressed in the moving dialog
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridColumnMoving widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.movingDialog to get a reference to the Moving Dialog element. This is a jQuery object.
			Use ui.columnKey to get the column key of the column that was being moved
			Use ui.columnIndex to get the column index of the column that was being moved
			Use ui.targetIndex to get the new column index of the column that was being moved
			*/
			movingDialogMoveDownButtonPressed: "movingDialogMoveDownButtonPressed",
			/* cancel="true" event fired when column moving is initiated through dragging it in the moving dialog
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridColumnMoving widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.movingDialog to get a reference to the Moving Dialog element. This is a jQuery object.
			Use ui.columnKey to get the column key of the column that was being moved
			Use ui.columnIndex to get the column index of the column that was being moved
			Use ui.targetIndex to get the new column index of the column that was being moved
			*/
			movingDialogDragColumnMoving: "movingDialogDragColumnMoving",
			/* event fired when column moving is completed through dragging it in the moving dialog
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridColumnMoving widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.movingDialog to get a reference to the Moving Dialog element. This is a jQuery object.
			Use ui.columnKey to get the column key of the column that was being moved
			Use ui.columnIndex to get the column index of the column that was being moved
			Use ui.targetIndex to get the new column index of the column that was being moved
			*/
			movingDialogDragColumnMoved: "movingDialogDragColumnMoved"
		},
		_createWidget: function (options, element) {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			this.options.columnSettings = [];
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		_create: function () {
			// stores the left coordinate of all column borders per table header row
			this._cache = {};
			// stores the currently dragged column key
			this._cKey = "";
			// stores the currently dragged column index
			this._cIdx = -1;
			// stores the target key for the currently dragged column
			this._tKey = "";
			// stores the target index for the currently dragged column
			this._tIdx = -1;
			// stores the original header in immediate mode
			this._oTh = null;
			// stores the bottom indivator in deferred mode
			this._cmib = null;
			// stores the top indicator in deferred mode
			this._cmit = null;
			// stores the modal dialog for the control
			this._movingDialog = null;
			// the groupby feature if enabled
			this._groupBy = null;
			// stores info about the dropdown buttons
			this._ddButtons = {
				first: {
					text: this.options.dropDownMoveFirstText,
					func: $.proxy(this._moveFirst, this),
					icon: this.css.featureChooserFirstIcon
				},
				left: {
					text: this.options.dropDownMoveLeftText,
					func: $.proxy(this._moveLeft, this),
					icon: this.css.featureChooserLeftIcon
				},
				right: {
					text: this.options.dropDownMoveRightText,
					func: $.proxy(this._moveRight, this),
					icon: this.css.featureChooserRightIcon
				},
				last: {
					text: this.options.dropDownMoveLastText,
					func: $.proxy(this._moveLast, this),
					icon: this.css.featureChooserLastIcon
				}
			};
			// scrolling container
			this._hscroller = null;
			// scrolling parameters
			this._scroller = {
				on: false,
				delay: -1
			};
			// dummy check
			if (this.options.mode !== "immediate" && this.options.mode !== "deferred") {
				this.options.mode = "immediate";
			}
			if (this.options.mode === "immediate" && this.options.moveType === "render") {
				this.options.moveType = "dom";
			}
			if (this.options.addMovingDropdown === false) {
				this.renderInFeatureChooser = false;
			}
		},
		_setOption: function (key, value) {
			// we don't support changing the mode type for moving as it involves heavy modifications to the dom
			if (key === "mode" || key === "columnSettings" || key === "addMovingDropdown") {
				throw new Error($.ig.Grid.locale.optionChangeNotSupported + ' ' + key);
			}
			$.Widget.prototype._setOption.apply(this, arguments);
		},
		// public methods
		destroy: function () {
			this._unregisterEvents();
			this._removeMoving();
			/* destroys the column moving widget */
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		moveColumn: function (column, target, after, inDom) {
			/* Moves a visible column at a specified place, in front or behind a target column or at a target index
			paramType="number|string" An identifier of the column to be moved. It can be a key, a Multi-Column Header identificator, or an index in a number format. The latter is not supported when the grid contains multi-column headers.
			paramType="number|string" An identifier of a column where the moved column should move to or an index at which the moved column should be moved to. In the case of a column identifier the column will be moved after it by default.
			paramType="bool" optional="true" Specifies whether the column moved should be moved after or before the target column. 
			paramType="bool" optional="true" Specifies whether the column moving will be enacted through DOM manipulation or through rerendering of the grid.
			*/
			this._moveColumn(column, target, after, inDom, true);
		},
		// grid event handlers
		_headerCellRendered: function (event, args) {
			if (this.grid.id() !== args.owner.id()) {
				return;
			}
			this._thRendered(args.th);
		},
		_headerRendering: function (event, args) {
			var i;
			for (i = 0; i < this.grid.options.features.length; i++) {
				if (this.grid.options.features[i].name === "GroupBy") {
					this._groupBy = this.grid.element.data("igGridGroupBy");
					break;
				}
			}
		},
		_headerRendered: function (event, args) {
			if (this.grid.id() !== args.owner.id()) {
				return;
			}
			this._thsRendered(args.table);
		},
		_gridFullyRendered: function (event, args) {
			var self = this;
			this.grid.scrollContainer().bind("scroll", this._containerScrolledHandler);
			this._updateLayout();
		},
		_containerScrolled: function (event, args, fromParent) {
			// handles when the scroll container is scrolled. This handler should not do anything if the scroll is triggered
			// by the autoScroll so that the moving elements are not fixed twice. It's also important to propagate to all children
			var grids, i, cmi;
			if (!this._autoScrolled) {
				// updated for this grid
				if (this.options.mode === "deferred") {
					this._adjustIndicators(event.originalEvent.detail, fromParent);
				}
			}
			// propagate to child grids
			grids = this.grid.element.find(".ui-iggrid-table");
			for (i = 0; i < grids.length; i++) {
				cmi = grids.eq(i).data("igGridColumnMoving");
				if (cmi) {
					cmi._containerScrolled.call(cmi, event, args, true);
				}
			}
		},
		// ui draggable moving event handlers
		_headerPicked: function (event, args) {
			var $th = $(event.target).closest("th"), id = this._getIdOfTh($th), noCancel = true;
			args = {
				columnKey: id,
				columnIndex: $th.index(),
				owner: this,
				header: $th,
				helper: args.helper
			};
			noCancel = this._trigger(this.events.columnDragStart, event, args);
			if (noCancel) {
				// M.H. 3 Oct 2013 Fix for bug #153904: When you open feature chooser and move column by dragging the feature chooser does not close.
				if (this.grid._focusedElement) {
					this.grid._focusedElement.blur();
				}
				this._thPicked($th, id);
			}
			return noCancel;
		},
		_headerDragged: function (event, args) {
			var left;
			if (this._oPos) {
				left = this._oPos.left > args.position.left;
			} else {
				left = args.originalPosition.left > args.position.left;
			}
			this._oPos = { left: args.position.left };
			// in order to support groupby's invalid revert, we need to update the original position for the
			// drag and drop operation, so dropping the header will result in a correct animation
			if (this._thDragged(args.helper, args.offset, left)) {
				args.originalPosition.left = args.position.left;
			}
		},
		_headerDropped: function (event, args) {
			var $th = $(event.target).closest("th"), id = this._getIdOfTh($th), noCancel = true;
			args = {
				columnKey: id,
				columnIndex: $th.index(),
				owner: this,
				header: $th,
				helper: args.helper
			};
			noCancel = this._trigger(this.events.columnDragEnd, event, args);
			if (noCancel) {
				this._thDropped();
			} else {
				this._trigger(this.events.columnDragCanceled, event, args);
			}
			return noCancel;
		},
		// moving dialog event handlers
		_dialogUpPressed: function (event, args) {
			var tar = $(event.target),
				item = tar.closest("li"),
				parent = item.parent(),
				idx = item.index(),
				iItem = idx === 0 ? item.parent().children().last().attr("data-value") : item.prev().attr("data-value"),
				iDir = idx === 0 ? true : false,
				col = tar.closest("span").attr("datakey"),
				a;
			a = {
				owner: this,
				movingDialog: this._movingDialog,
				columnKey: col,
				columnIndex: idx,
				targetIndex: idx === 0 ? parent.children().length - 1 : idx - 1
			};
			if (idx === 0) {
				item.detach().insertAfter(parent.children("li:last"));
			} else {
				item.detach().insertBefore(parent.children("li:eq(" + (idx - 1) + ")"));
			}
			this._cKey = col;
			this._cIdx = a.columnIndex;
			this._tIdx = a.targetIndex;
			this._moveColumn(col, iItem, iDir, this.options.moveType === "dom", false);
			this._trigger(this.events.movingDialogMoveUpButtonPressed, null, a);
		},
		_dialogDownPressed: function (event, args) {
			var tar = $(event.target),
				item = tar.closest("li"),
				parent = item.parent(),
				idx = item.index(),
				iItem = idx === item.siblings().length ? item.parent().children().first().attr("data-value") : item.next().attr("data-value"),
				iDir = idx === item.siblings().length ? false : true,
				col = tar.closest("span").attr("datakey"),
				a;
			a = {
				owner: this,
				movingDialog: this._movingDialog,
				columnKey: col,
				columnIndex: idx,
				targetIndex: idx === parent.children().length - 1 ? 0 : idx + 1
			};
			if (idx === item.parent().children().length - 1) {
				item.detach().insertBefore(parent.children("li:first"));
			} else {
				item.detach().insertAfter(parent.children("li:eq(" + idx + ")"));
			}
			this._cKey = col;
			this._cIdx = a.columnIndex;
			this._tIdx = a.targetIndex;
			this._moveColumn(col, iItem, iDir, this.options.moveType === "dom", false);
			this._trigger(this.events.movingDialogMoveDownButtonPressed, null, a);
		},
		_dialogRearranging: function (event, args) {
			var noCancel, a,
				column = $(args.draggable),
				target = $(args.element),
				cid = column.attr("data-value"),
				tid = target.attr("data-value"),
				aft = $(args.element).closest("ul[data-depth=0]").data("igTree")._validationObject.dropAfter,
				cix = column.index(),
				tix = target.index();
			// depending on other params the target index needs to be changed
			tix = tix > cix ? (aft ? tix : tix - 1) : (aft ? tix + 1 : tix);
			a = {
				owner: this,
				movingDialog: this._movingDialog,
				columnKey: cid,
				columnIndex: cix,
				targetIndex: tix
			};
			noCancel = this._trigger(this.events.movingDialogDragColumnMoving, null, a);
			if (noCancel) {
				this._cKey = cid;
				this._cIdx = a.columnIndex;
				this._tIdx = a.targetIndex;
				this._moveColumn(cid, tid, aft, this.options.moveType === "dom", false);
				a.movingDialog.find("div.ui-state-highlight").remove();
				this._trigger(this.events.movingDialogDragColumnMoved, null, a);
				return true;
			}
			return false;
		},
		_dialogRearranged: function (event, args) {
			this._bindUpDownDialogButtons(args.element.parent());
		},
		_dialogDragged: function (event, args) {
			this._trigger(this.events.movingDialogDragged, null,
				{
					movingDialogElement: event.target,
					owner: this,
					originalPosition: args.originalPosition,
					position: args.position
				});
		},
		_dialogOpening: function (event, args) {
			var noCancel;
			noCancel = this._trigger(this.events.movingDialogOpening, null, { movingDialogElement: event.target, owner: this });
			if (noCancel) {
				this._renderMovingDialogContent(event, args);
				this._trigger(this.events.movingDialogOpened, null, { movingDialogElement: event.target, owner: this });
			}
			return noCancel;
		},
		_dialogClosing: function (event, args) {
			return this._trigger(this.events.movingDialogClosing, null, { movingDialogElement: event.target, owner: this });
		},
		_dialogClosed: function (event, args) {
			this._trigger(this.events.movingDialogClosed, null, { movingDialogElement: event.target, owner: this });
		},
		// dropdown event handlers
		_dropDownMouseDown: function (event, args) {
			var ind = $(event.target);
			this._toggleDropDown(ind, $("div[data-moving-inddropdown='" + this.grid.id() + "']"));
			this._cancelEvent(event);
		},
		_dropDownKeyDown: function (event, args) {
			var sItem,
				nItem,
				nItemB,
				dropdown = $("div[data-moving-inddropdown='" + this.grid.id() + "']");
			if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
				sItem = dropdown.find("ul .ui-state-hover:first");
				if (dropdown.is(':visible') && sItem.length > 0) {
					sItem.trigger("mousedown");
				}
				this._toggleDropDown($(event.target), dropdown, false);
				this._cancelEvent(event);
			} else if (event.keyCode === $.ui.keyCode.ESCAPE) {
				this._toggleDropDown($(event.target), dropdown, false);
				this._cancelEvent(event);
			} else if (event.keyCode === $.ui.keyCode.DOWN || event.keyCode === $.ui.keyCode.UP) {
				if (dropdown.is(':visible')) {
					sItem = dropdown.find('ul .ui-state-hover:first').closest('li');
					if (sItem.length === 0) {
						nItem = dropdown.find('ul li:eq(0)');
					} else {
						if (sItem.index() === 0 && event.keyCode === $.ui.keyCode.UP) {
							nItem = sItem.parent().children(":last");
						} else {
							nItem = event.keyCode === $.ui.keyCode.DOWN ? sItem.next() : sItem.prev();
						}
					}
					dropdown.find('ul .ui-state-hover').removeClass(this.css.columnMovingDropDownItemHover);
					nItemB = nItem.find("[role='button']");
					if (nItemB.length > 0) {
						nItem = nItemB;
					}
					nItem.addClass(this.css.columnMovingDropDownItemHover);
				}
				this._cancelEvent(event);
			}
		},
		_dropDownButtonMouseOver: function (event, args) {
			$(event.currentTarget).addClass(this.css.columnMovingDropDownItemHover);
		},
		_dropDownButtonMouseOut: function (event, args) {
			$(event.currentTarget).removeClass(this.css.columnMovingDropDownItemHover);
		},
		_moveLeft: function (event, args) {
			var sib = this._cache.siblings[args], cid, tid, i;
			for (i = 0; i < sib.length; i++) {
				cid = sib[i].key || sib[i].identifier;
				if (cid === args) {
					if (i > 0) {
						this._cKey = args;
						this._cIdx = i;
						this._tIdx = i - 1;
						tid = sib[i - 1].key || sib[i - 1].identifier;
						this._moveColumn(cid, tid, false, this.options.moveType === "dom", false);
					}
					break;
				}
			}
		},
		_moveRight: function (event, args) {
			var sib = this._cache.siblings[args], cid, tid, i;
			for (i = 0; i < sib.length; i++) {
				cid = sib[i].key || sib[i].identifier;
				if (cid === args) {
					if (i < sib.length - 1) {
						this._cKey = args;
						this._cIdx = i;
						this._tIdx = i + 1;
						tid = sib[i + 1].key || sib[i + 1].identifier;
						this._moveColumn(cid, tid, true, this.options.moveType === "dom", false);
					}
					break;
				}
			}
		},
		_moveFirst: function (event, args) {
			var sib = this._cache.siblings[args], cid, tid, i;
			for (i = 0; i < sib.length; i++) {
				cid = sib[i].key || sib[i].identifier;
				if (cid === args) {
					if (i !== 0) {
						this._cKey = args;
						this._cIdx = i;
						this._tIdx = 0;
						tid = sib[0].key || sib[0].identifier;
						this._moveColumn(cid, tid, false, this.options.moveType === "dom", false);
					}
					break;
				}
			}
		},
		_moveLast: function (event, args) {
			var sib = this._cache.siblings[args], cid, tid, i;
			for (i = 0; i < sib.length; i++) {
				cid = sib[i].key || sib[i].identifier;
				if (cid === args) {
					if (i !== sib.length - 1) {
						this._cKey = args;
						this._cIdx = i;
						this._tIdx = sib.length - 1;
						tid = sib[sib.length - 1].key || sib[sib.length - 1].identifier;
						this._moveColumn(cid, tid, true, this.options.moveType === "dom", false);
					}
					break;
				}
			}
		},
		// style event handlers
		_headerMouseOver: function (event, args) {
			$(event.target).closest("th").addClass(this.css.headerCellMouseOver);
		},
		_headerMouseOut: function (event, args) {
			$(event.target).closest("th").removeClass(this.css.headerCellMouseOver);
		},
		// render functions
		_renderHelpers: function () {
			var existingBottomIndicator = this.grid._rootContainer().children("[id$='_moving_indicator_bottom']"),
				existingTopIndicator = this.grid._rootContainer().children("[id$='_moving_indicator_top']");
			if (existingBottomIndicator.length > 0 && existingTopIndicator.length > 0) {
				this._cmib = existingBottomIndicator;
				this._cmib.data("users", this._cmib.data("users") + 1);
				this._cmit = existingTopIndicator;
				this._cmit.data("users", this._cmit.data("users") + 1);
			} else {
				this._cmib = $("<div>&nbsp;</div>")
					.attr("id", this.grid.id() + "_moving_indicator_bottom")
					.addClass(this.css.dragIndicatorTop)
					.css({
						"position": "absolute",
						"z-index": "1000000",
						"width": "16px",
						"height": "16px",
						"display": "none"
					})
					.appendTo(this.grid._rootContainer());
				this._cmit = $("<div>&nbsp;</div>")
					.attr("id", this.grid.id() + "_moving_indicator_top")
					.addClass(this.css.dragIndicatorBottom)
					.css({
						"position": "absolute",
						"z-index": "1000000",
						"width": "16px",
						"height": "16px",
						"display": "none"
					})
					.appendTo(this.grid._rootContainer());
			}
		},
		_renderFeatureChooser: function (col, th) {
			var fc = this.grid.element.data('igGridFeatureChooser');
			if (fc) {
				if (fc._shouldRenderInFeatureChooser(col) === true) {
					this._addMoveButtonsInFeatureChooser(fc, col);
				} else {
					this._renderMovingDropDownIndicator(th, col);
					// S.S. September 20, 2013 Fix for bug #152681 - We need to add a specific class to the drop down
					// indicator so that the header cell is always rendered in one line
					this.grid._enableHeaderCellFeature(th);
				}
			}
		},
		_renderMovingDropDownIndicator: function (th, col) {
			var $button, $anchor, $container, self = this;
			$button = $("<span></span>").addClass(this.css.dropDownButton);
			$anchor = $("<a></a>")
				.attr("href", "#")
				.attr("th-remove-focus", "")
				.attr("title", this.options.movingToolTipMove)
				.attr("id", this.grid.id() + "_moving_headerButton_" + col)
				.bind({
					keydown: this._dropDownKeyHandler,
					blur: function (e) {
						self._toggleDropDown($(e.target), $("div[data-moving-inddropdown='" + self.grid.id() + "']"), true);
					},
					mousedown: this._dropDownButtonHandler,
					mouseup: this._cancelEventHandler,
					click: this._cancelEventHandler
				});
			$container = $("<div></div>").addClass(this.css.dropDownIndicatorContainer).appendTo(th);
			$button.appendTo($anchor);
			$anchor.appendTo($container);
			this._needToRenderDropDown = true;
		},
		_renderMovingDialogContent: function () {
			/* Render moving modal dialog and its content */
			var $content = this._movingDialog.igGridModalDialog('getContent'),
				movingDialog = this._movingDialog,
				$tree = $content.find("#" + this.grid.id() + "_dialog_tree"),
				noCancel;
			noCancel = this._trigger(this.events.movingDialogContentsRendering, null, { movingDialogElement: movingDialog, owner: this });
			if (noCancel) {
				if ($tree.length > 0) {
					$tree
						.igTree("option", "dataSource", this._getClonedDataSource(this.grid._visibleMchColumns() || this.grid._visibleColumns()));
				} else {
					$tree = this._initializeTree($content);
				}
				this._bindUpDownDialogButtons($tree);
				this._trigger(this.events.movingDialogContentsRendered, null, { movingDialogElement: movingDialog, owner: this });
			}
		},
		_initializeTree: function (content) {
			var self = this;
			return $("<ul id='" + this.grid.id() + "_dialog_tree'></ul>")
				.appendTo(content)
				.igTree({
					dataSourceType: 'json',
					dataSource: this._getClonedDataSource(this.grid._visibleMchColumns() || this.grid._visibleColumns()),
					bindings: {
						primaryKey: 'key',
						textKey: 'headerText',
						valueKey: 'key',
						childDataProperty: 'group',
						nodeContentTemplate: this._getTreeTemplate()
					},
					dragAndDrop: true,
					dragAndDropSettings: {
						dragAndDropMode: 'move',
						revert: true,
						zIndex: 1000001,
						customDropValidation: function (col) {
							var context = $(this), $col = $(col);
							if (self._isColumnMovable($col.attr("data-value"))) {
								if (context.is("li") && context.parent()[0] === $col.parent()[0]) {
									return true;
								}
							}
							return false;
						},
						containment: false
					},
					nodeDropping: this._dialogRearrangingHandler,
					nodeDropped: this._dialogRearrangedHandler,
					selectionChanging: function () { return false; }
				});
		},
		_getClonedDataSource: function (ds) {
			return jQuery.extend(true, [], ds, this._cloneMovable(ds));
		},
		_cloneMovable: function (ds) {
			var self = this, movableClone = [], idx = 0;
			$.each(ds, function () {
				if (this.group) {
					movableClone.push({ 
						movable: self._isColumnMovable(this.key, idx++),
						group: self._cloneMovable(this.group),
						key: this.key || this.identifier || idx 
					});
				} else {
					movableClone.push({
						movable: self._isColumnMovable(this.key, idx++),
						key: this.key || idx
					});
				}
			});
			return movableClone;
		},
		_getTreeTemplate: function () {
			var tmpl = "", up, down, wrapper, data;
			data = "<span>${headerText}</span>";
			wrapper = "<span class='" + this.css.movingDialogListItemArrowButton + "'>";
			up = wrapper + "<span id='" + this.grid.id() +
				"_moving_dialog_${key}_up' title='" + this.options.movingDialogCaptionButtonAsc +
				"' role='button' datakey='${key}' class='" + this.css.movingDialogListItemArrowUp + "' style='" +
				"margin-top:-10px;'></span></span>";
			down = wrapper + "<span id='" + this.grid.id() +
				"_moving_dialog_${key}_down' title='" + this.options.movingDialogCaptionButtonDesc +
				"' role='button' datakey='${key}' class='" + this.css.movingDialogListItemArrowDown + "' style='" +
				"margin-top:-10px;'></span></span>";
			wrapper += "</span>";
			tmpl += "{{if ${movable} }}";
			tmpl += up + down + data;
			tmpl += "{{else}}";
			tmpl += wrapper + wrapper + data;
			tmpl += '{{/if}}';
			return tmpl;
		},
		_renderMovingDialog: function () {
			var containment,
				o = this.options,
				$captionButtonContainer,
				$closeButton,
				movingDialog;
			if (this.options.columnMovingDialogContainment === "owner") {
				containment = this.grid.container();
			} else {
				containment = 'window';
			}
			movingDialog = $('<div></div>')
					.appendTo(this.grid._rootContainer())
					.attr('id', this.grid.id() + '_moving_movingDialog');
			this._movingDialog = movingDialog;
			movingDialog.igGridModalDialog({
				containment: containment,
				renderFooterButtons: false,
				modalDialogCaptionText: o.movingDialogCaptionText,
				modalDialogWidth: o.movingDialogWidth,
				modalDialogHeight: o.movingDialogHeight,
				animationDuration: o.movingDialogAnimationDuration,
				//grid: this.grid,
				gridContainer: this.grid.container(),
				modalDialogOpening: this._dialogOpeningHandler,
				modalDialogMoving: this._dialogDraggedHandler,
				modalDialogClosing: this._dialogClosingHandler,
				modalDialogClosed: this._dialogClosedHandler
			});
			// render close button
			$captionButtonContainer = movingDialog.igGridModalDialog('getCaptionButtonContainer');
			$closeButton = $('<button></button>')
				.attr('id', this.grid.id() + '_moving_movingDialog_closeButton')
				.appendTo($captionButtonContainer);
			$closeButton.igButton({
				onlyIcons: true,
				icons: {
					primary: this.css.movingDialogCloseButton
				},
				width: "20px",
				height: "20px",
				click: this._dialogCloseButtonHandler
			});
		},
		_renderDropDown: function (element) {
			var self = this, dropDown, list;
			dropDown = $("<div data-moving-inddropdown='" + this.grid.id() + "'></div>")
				.css('position', 'absolute')
				.css('display', 'none')
				.addClass(this.css.columnMovingDropDown)
				.appendTo(this.grid._rootContainer());
			list = $('<ul tabindex="0"></ul>').addClass(this.css.columnMovingDropDownList).appendTo(dropDown);
			$.each(this._ddButtons, function (key, val) {
				$('<li></li>')
					.addClass(self.css.columnMovingDropDownItem)
					.attr("data-key", key)
					.bind({
						mouseover: self._dropDownButtonMouseOverHandler,
						mouseout: self._dropDownButtonMouseOutHandler
					})
					.append(
						$('<span></span>')
							.addClass(self.css.dropDownIconContainer)
							.append(
								$('<span></span>')
									.addClass(val.icon)
							)
					)
					.append(
						$('<span></span>')
							.addClass(self.css.columnMovingDropDownItemText)
							.text(val.text)
					)
					.appendTo(list);
			});
			// moving dialog button
			$('<a></a>')
				.appendTo($("<li></li>").appendTo(list))
				.igButton({
					labelText: this.options.movingDialogCaptionText,
					mousedown: function (event) {
						if (event.target) {
							setTimeout(function () { $(event.target).removeClass('ui-state-active'); }, 0);
						}
						self._toggleDropDown(element, dropDown, true);
						self._openMovingDialog(element, dropDown, true);
					}
				});
			return dropDown;
		},
		_toggleDropDown: function (element, dropDown, isCalledFromBlur) {
			var th,
				id,
				isLast,
				offset,
				rOffset,
				left,
				isVisible = (dropDown.is(':visible') === true),
				nth = element ? element.closest("th") : null,
				nid = nth ? nth.attr("id") || nth.attr("data-mch-id") : null,
				self = this;
			if (dropDown.data('isAnimating') === true ||
				(nid !== null && this._currentlyToggled !== nid && isCalledFromBlur === true) ||
				(isVisible === false && isCalledFromBlur === true)) {
				return;
			}
			if (!isVisible) {
				th = nth;
				isLast = th.parent().children().length - th.index() <= 2;
				offset = th.offset();
				if (isLast) {
					left = offset.left + th.outerWidth() - dropDown.outerWidth();
					left = Math.max(0, left);
				} else {
					left = offset.left;
				}
				rOffset = $.ig.util.getRelativeOffset(dropDown);
				dropDown.css("top", offset.top + th.outerHeight() - rOffset.top);
				dropDown.css("left", left - rOffset.left);
				$.each(this._ddButtons, function (key, value) {
					dropDown.find("li[data-key='" + key + "']")
						.bind("mousedown.temp", function (event) {
							self._toggleDropDown(element, dropDown, true);
							id = th.attr("id");
							if (id) {
								id = id.replace(self.grid.id() + "_", "");
							} else {
								id = th.attr("data-mch-id");
							}
							value.func(null, id);
							event.stopPropagation();
							event.preventDefault();
						});
				});
				this._currentlyToggled = th.attr("id") || th.attr("data-mch-id");
			} else {
				$.each(this._ddButtons, function (key, value) {
					dropDown.find("li[data-key='" + key + "']").unbind("mousedown.temp");
				});
			}
			dropDown.data('isAnimating', true);
			dropDown.toggle(200, function () {
				if (dropDown.is(':visible') === true) {
					th.find('a').focus();
					if (element) {
						element.addClass(self.css.columnMovingIndicatorSelected);
						element.attr("data-indicator-selected", "true");
					}
				} else {
					if (element) {
						element.removeClass(self.css.columnMovingIndicatorSelected);
						element.removeAttr("data-indicator-selected");
					}
				}
				dropDown.data('isAnimating', false);
			});
		},
		_renderSubmenuFC: function (columnKey, $submenu) {
			var $ul, moveColumns, moveLeft, moveRight, moveFirst, moveLast;
			$ul = $('<ul class="' + this.css.featureChooserSubmenu + '"></ul>').appendTo($submenu);
			moveColumns = {
				name: 'ColumnMovingDialog',
				text: this.options.movingDialogDisplayText,
				iconClass: this.css.featureChooserMovingDialogIcon,
				method: this._openMovingDialogHandler
			};
			moveLeft = {
				name: 'Left',
				text: this.options.dropDownMoveLeftText,
				iconClass: this.css.featureChooserLeftIcon,
				method: $.proxy(this._moveLeft, this)
			};
			moveRight = {
				name: 'Right',
				text: this.options.dropDownMoveRightText,
				iconClass: this.css.featureChooserRightIcon,
				method: $.proxy(this._moveRight, this)
			};
			moveFirst = {
				name: 'First',
				text: this.options.dropDownMoveFirstText,
				iconClass: this.css.featureChooserFirstIcon,
				method: $.proxy(this._moveFirst, this)
			};
			moveLast = {
				name: 'Last',
				text: this.options.dropDownMoveLastText,
				iconClass: this.css.featureChooserLastIcon,
				method: $.proxy(this._moveLast, this)
			};
			this._renderSubmenuFCItem(moveColumns, $ul, columnKey, $submenu);
			this._renderSubmenuFCItem(moveFirst, $ul, columnKey, $submenu);
			this._renderSubmenuFCItem(moveLeft, $ul, columnKey, $submenu);
			this._renderSubmenuFCItem(moveRight, $ul, columnKey, $submenu);
			this._renderSubmenuFCItem(moveLast, $ul, columnKey, $submenu);
		},
		_renderSubmenuFCItem: function (obj, $ul, columnKey, $submenu) {
			var $li, text = obj.text, html, fnBlur, $next,
				css = this.css,
				id = this.grid.id() + '_featurechooser_dd_li_' + columnKey + '_' + obj.name,
				method = obj.method;
			fnBlur = function ($e) {
				setTimeout(function () {
					$e.blur();
				}, 50);
			};
			html = '<li tabindex="0" data-fc-item="1" class="' + this.css.featureChooserSubmenuItem + '" id="' + id + '" title="' + text + '">' + text + '</li>';
			$li = $(html).appendTo($ul);
			$li.bind({
				keydown: function (event) {
					var keyCode = event.keyCode;
					switch (keyCode) {
						case $.ui.keyCode.ENTER:
						case $.ui.keyCode.SPACE:
							method(event, columnKey);
							fnBlur($(event.target));
							break;
						case $.ui.keyCode.DOWN:
							$next = $li.next();
							if ($next.length === 0) {
								$ul.find('li:first').focus();
							} else {
								$next.focus();
							}
							break;
						case $.ui.keyCode.UP:
							$li.prev().focus();
							if ($li.prev().length === 0) {
								$('#' + $submenu.data('buttonId')).focus();
							}
							break;
						case $.ui.keyCode.ESCAPE:
							fnBlur($(event.target));
							break;
					}
				},
				mousedown: function (e, args) {
					method(e, columnKey);
					fnBlur($(e.target));
				},
				mouseover: function (e, args) {
					$(this).addClass(css.featureChooserSubmenuItemMouserOver);
				},
				mouseleave: function (e, args) {
					$(this).removeClass(css.featureChooserSubmenuItemMouserOver);
				}
			});
		},
		_addMoveButtonsInFeatureChooser: function (fc, key) {
			fc._renderInFeatureChooser(key,
				{
					name: 'ColumnMovingDropDown',
					text: this.options.featureChooserSubmenuText,
					iconClass: 'ui-iggrid-featurechooser-li-iconcontainer ui-icon ui-iggrid-icon-move', //featureChooserIconClass: 'ui-icon ui-icon-calculator',
					//secondaryIconClass: this.css.featureChooserIconClass,
					//method: $.proxy(this._togglefromfc, this),
					methodRenderSubmenu: $.proxy(this._renderSubmenuFC, this),
					//methodToggleSubmenu: $.proxy(this._toggleSubmenuFC, this),
					order: 1, // order in group
					groupName: 'dropdown',
					groupOrder: 4,
					type: 'dropdown',
					state: 'hide'
				}
			);
		},
		// private function
		_moveColumn: function (column, target, after, inDom, fromApi) {
			var noCancel = true, args;
			if (fromApi === false) {
				args = {
					columnKey: this._cKey,
					columnIndex: this._cIdx,
					targetIndex: this._tIdx,
					owner: this
				};
				noCancel = this._trigger(this.events.columnMoving, null, args);
			}
			if (noCancel) {
				this._movingDirty = true;
				this.grid.moveColumn(column, target, after, inDom);
				if (fromApi === false) {
					delete args.columnIndex;
					delete args.targetIndex;
					args.oldIndex = this._cIdx;
					args.newIndex = this._tIdx;
					this._triggerColumnMovedAsync(args);
				}
			}
		},
		_thRendered: function (th) {
			var cid = this._getIdOfTh(th), cix = th.index("not[data-skip='true']");
			if (this._isColumnMovable(cid, cix) === true) {
				this._markForMoving(th);
				if (this.options.addMovingDropdown === true) {
					this._renderFeatureChooser(cid, th);
				}
			}
		},
		_thsRendered: function () {
			if (this.options.mode === "deferred") {
				// in deferred mode we need the moving helpers
				this._renderHelpers();
			}
			if (this.options.addMovingDropdown === true) {
				// check if the moving dialog isn't alreay rendered
				if (!this._movingDialog || (this._movingDialog instanceof jQuery && this._movingDialog.length === 0)) {
					this._renderMovingDialog();
				}
				// check if the dropdown isn't already rendered
				if ($("div[data-moving-inddropdown='" + this.grid.id() + "']").length === 0) {
					this._renderDropDown();
				}
			}
		},
		_thPicked: function (th, id) {
			this._cKey = id;
			this._cIdx = th.index();
			if (this.options.mode === "immediate") {
				if (this.options.hideHeaderContentsDuringDrag === true) {
					th.children().not("div[data-hiddencolindicator]").hide();
				}
				this._oTh = th;
			}
		},
		_thDragged: function (helper, pos, left) {
			var siblings,			// all columns at the level of the one being moved
				targetKey,			// the key of the column tested for being target
				targetPosition,		// the position of the column tested for being target
				targetLeft,			// only the left coordinate of the above
				scrollLeft = 0,		// the scrollbar left position
				dragX,				/* the left coordinate we are polling, if we are moving to the right, this is the right edge of
									the helper, if we are moving to the left it's the left edge of the helper */
				i = 0, j = 0,
				updateEvent = false;// we'll return this variable so that the original event can be modified if needed
			// get the columns on the level we are moving
			siblings = this._cache.siblings[this._cKey];
			// get the scrollLeft value
			if (this._hscroller.length > 0) {
				scrollLeft = this._hscroller.scrollLeft();
			}
			// depending on the direction we are moving the helper we get the front we'll try moving for
			dragX = left === true ? pos.left : pos.left + helper.width();
			dragX += this._getAbsoluteScroll(this.grid.headersTable());
			// we won't do anything if the grid is loading or if there is a different moving action going on
			if (!this._gridReady() || this._movingDirty) {
				return;
			}
			// we need to loop through each possible position the column can be dropped on
			// this includes the last position, which needs to be calculated as it's not present in the coordinates cache upfront
			while (i <= siblings.length) {
				j = i === siblings.length ? i - 1 : i;
				targetKey = siblings[j].key || siblings[j].identifier;
				// we won't do anything if the potential move will not change the 
				// column collection in any way, however indicators still need to be shown 
				if (targetKey === this._cKey && this.options.mode === "immediate") {
					i += 2;
					continue;
				}
				targetPosition = this._cache.columns[targetKey];
				targetLeft = j !== i ? targetPosition.offset.left + targetPosition.dimensions.width : targetPosition.offset.left;
				// we have the two X coordinates to test against (dragX for the helper; targetLeft for the column)
				if (dragX > targetLeft - this.options.movingAcceptanceTolerance &&		// left acceptance border
					dragX < targetLeft + this.options.movingAcceptanceTolerance) {		// right acceptance border
					this._tKey = targetKey;
					this._tIdx = this._cIdx > j || j !== i ? j : j - 1;
					if (this.options.mode === "immediate") {
						this._moveColumn(this._cKey, targetKey, j !== i ? true : false, true, false);
						updateEvent = true;
					} else {
						this._last = i === siblings.length;
						this._showIndicators(targetLeft - this._getAbsoluteScroll(this.grid.headersTable()),
							targetPosition.element.offset().top,
							targetPosition.dimensions);
					}
					break;
				}
				i++;
			}
			if (this._hscroller.length > 0) {
				this._checkScroll(scrollLeft, dragX, left);
			}
			return updateEvent;
		},
		_thDropped: function () {
			if (this.options.mode === "immediate") {
				if (this.options.hideHeaderContentsDuringDrag === true) {
					this._oTh.children().show();
				}
				return;
			}
			this._hideIndicators();
			if (this._tKey && this._cKey !== this._tKey) {
				this._moveColumn(this._cKey, this._tKey, this._last, this.options.moveType === "dom", false);
			}
			delete this._cKey;
			delete this._tKey;
			$(".ui-draggable-dragging").hide();
			this._scroller.on = false;
		},
		_isColumnMovable: function (col, idx) {
			var i, cs;
			for (i = 0; i < this.options.columnSettings.length; i++) {
				cs = this.options.columnSettings[i];
				if (cs.columnIndex) {
					if (i === idx) {
						return cs.allowMoving;
					}
				}
				if (cs.columnKey) {
					if (col === cs.columnKey) {
						return cs.allowMoving;
					}
				}
			}
			return true;
		},
		_isColumnGroupable: function (col) {
			var gbColumnSetting = this._groupBy._findColumnSetting(this._getIdOfTh(col));
			return gbColumnSetting && gbColumnSetting.allowGrouping;
		},
		_getIdOfTh: function (th) {
			var mchid = th.attr("data-mch-id");
			if (mchid) {
				return mchid;
			}
			return th.attr("id").replace(this.grid.id() + "_", "");
		},
		_getThById: function (id) {
			return $("th[data-mch-id='" + id + "'],th[id='" + this.grid.id() + "_" + id + "']");
		},
		_adjustIndicators: function (delta, fromParent) {
			var newl = parseInt(this._cmib.css("left"), 10) - delta, fhr, fhrt;
			this._cmib.css("left", newl);
			this._cmit.css("left", newl);
			if (fromParent) {
				fhr = this.grid.headersTable().find("tr").first();
				fhrt = fhr.offset().top;
				this._cmib.css("top", fhrt - 16 - $.ig.util.getRelativeOffset(this._cmib).top);
				this._cmit.css("top", fhrt + fhr.height() - $.ig.util.getRelativeOffset(this._cmit).top);
			}
		},
		_showIndicators: function (left, top, dim) {
			this._cmib.css("left", left - 8 - $.ig.util.getRelativeOffset(this._cmib).left).show();
			this._cmib.css("top", top - 16 - $.ig.util.getRelativeOffset(this._cmib).top);
			this._cmit.css("left", left - 8 - $.ig.util.getRelativeOffset(this._cmit).left).show();
			this._cmit.css("top", top + dim.height - $.ig.util.getRelativeOffset(this._cmit).top);
		},
		_hideIndicators: function () {
			this._cmib.hide();
			this._cmit.hide();
		},
		_markForMoving: function (col) {
			// check if another feature created a draggable
			// on the column prior to ColumnMoving
			if (col.data("draggable") || this._groupBy) {
				if (this._isColumnGroupable(col)) {
					col.bind("drag", this._moveHandler);
					col.bind("dragstop", this._dropHandler);
					col.bind("dragstart", this._dragHandler);
					return;
				}
				col.attr('groupby-disabled', 'true');
			}
			// otherwise we'll create a new draggable on the column
			col.draggable({
				containment: this.grid._rootContainer(),
				appendTo: this.grid.container(),
				distance: 5,
				scroll: false, // will need to disable scroll so the helper doesn't scroll parent layouts automatically
				revert: "valid",
				//cancel: 'div.ui-iggrid-indicatorcontainer',
				helper: function (event) {
					var th, clone;
					th = $(event.target).closest("th");
					clone = th.clone()
						.css('overflow', 'hidden')
						.css('z-index', 10000)
						.width(th.width())
						.height(th.height())
						.addClass("ui-widget ui-iggrid")
						.wrap($('<div class="ui-iggrid-dragMarkup"></div>').width(th.outerWidth()).height(th.outerHeight()))
						.parent();
					clone.find("div[data-hiddencolindicator]").remove();
					return clone;
				},
				opacity: this.options.dragHelperOpacity,
				//scroll: true,
				drag: this._moveHandler,
				stop: this._dropHandler,
				start: this._dragHandler
			});
			// finally add style 
			col.unbind("mouseover.moving").bind("mouseover.moving", this._headerMouseOverHandler);
			col.unbind("mouseout.moving").bind("mouseout.moving", this._headerMouseOutHandler);
		},
		_updateLayout: function () {
			var cols, self = this;
			if (!this._gridReady()) {
				setTimeout(function () {
					self._updateLayout();
				}, 50);
				return;
			}
			if (this.grid._oldCols) {
				cols = $.grep(this.grid._oldCols, this.grid._columnVisible);
			} else {
				cols = this.grid._visibleColumns();
			}
			// update hscroller (if the grid is resized)
			this._hscroller = this.grid._hscrollbarcontent();
			this._hscroller = this._hscroller.length > 0 ? this._hscroller : this.grid.scrollContainer();
			// rebuild cache
			this._cache.columns = {};
			this._cache.siblings = {};
			this._updateLayoutPerLevel(cols);
			delete this._movingDirty;
		},
		_updateLayoutPerLevel: function (cols) {
			var i, id, $th, os, sl = this._hscroller.length > 0 ? this._hscroller.scrollLeft() : 0;
			for (i = 0; i < cols.length; i++) {
				id = cols[i].key || cols[i].identifier;
				$th = this._getThById(id);
				os = $th.offset();
				os.left = os.left + this._getAbsoluteScroll($th);
				this._cache.columns[id] = {};
				this._cache.columns[id].element = $th;
				this._cache.columns[id].offset = os;
				this._cache.columns[id].dimensions = { width: $th.outerWidth(), height: $th.outerHeight() };
				this._cache.siblings[id] = cols;
			}
			for (i = 0; i < cols.length; i++) {
				if (cols[i].group && cols[i].hidden !== true) {
					this._updateLayoutPerLevel($.grep(cols[i].group, this.grid._columnVisible));
				}
			}
		},
		_getAbsoluteScroll: function (el) {
			var cel = el, abs = 0;
			while (cel.length > 0 && cel.attr("id") !== this.grid._rootContainer().attr("id")) {
				abs += cel.scrollLeft();
				cel = cel.parent();
			}
			return abs;
		},
		_openMovingDialog: function () {
			this._movingDialog.igGridModalDialog("openModalDialog");
		},
		_closeMovingDialog: function (e) {
			this._movingDialog.igGridModalDialog("closeModalDialog");
			if (e) {
				e.preventDefault();
			}
		},
		_triggerColumnMovedAsync: function (args) {
			var self = this;
			if (!this._gridReady()) {
				setTimeout(function () {
					self._triggerColumnMovedAsync(args);
				}, 50);
				return;
			}
			this._trigger(this.events.columnMoved, null, args);
		},
		_gridReady: function () {
			return !(this.grid._loadingIndicator && this.grid._loadingIndicator._indicator.is(":visible"));
		},
		_bindUpDownDialogButtons: function (list) {
			list.find("span[class='" + this.css.movingDialogListItemArrowDown + "']")
				.unbind("mousedown", this._dialogDownHandler)
				.bind("mousedown", this._dialogDownHandler);
			list.find("span[class='" + this.css.movingDialogListItemArrowUp + "']")
				.unbind("mousedown", this._dialogUpHandler)
				.bind("mousedown", this._dialogUpHandler);
		},
		_checkScroll: function (scrollLeft, dragX, left) {
			var sbw = this.grid._hasVerticalScrollbar === true ? this.grid._scrollbarWidth() : 0;
			if (scrollLeft > 0 && left === true && dragX - scrollLeft < this.options.movingScrollTolerance) {
				this._updateScroller(true, dragX - scrollLeft);
			} else if (scrollLeft < this._hscroller[0].scrollWidth + sbw - this._hscroller.outerWidth() &&
					left === false && dragX - scrollLeft > this._hscroller.outerWidth() - this.options.movingScrollTolerance) {
				this._updateScroller(false, this._hscroller.outerWidth() - dragX + scrollLeft);
			} else {
				this._stopScroller();
			}
		},
		_startScroller: function (left, delta) {
			this._scroller.on = true;
			this._scroller.delay = delta * this.options.scrollSpeedMultiplier;
			this._scroller.direction = left === true ? "left" : "right";
			this._autoScroll();
		},
		_updateScroller: function (left, delta) {
			if (this._scroller.on === false) {
				this._startScroller(left, delta);
				return;
			}
			this._scroller.delay = delta;
		},
		_stopScroller: function () {
			this._scroller.on = false;
		},
		_scrollGrid: function () {
			var sl = this._hscroller.scrollLeft(), delta, res, sbw;
			delta = this._scroller.direction === "left" ? this.options.scrollDelta * -1 : this.options.scrollDelta;
			res = sl + delta;
			sbw = this.grid._hasVerticalScrollbar === true ? this.grid._scrollbarWidth() : 0;
			this._hscroller.scrollLeft(res);
			if ((res <= 0 && delta < 0) ||
					(res >= this._hscroller[0].scrollWidth + sbw - this._hscroller.outerWidth() && delta > 0)) {
				this._stopScroller();
			}
			if (this._hscroller[0].id.indexOf("_hscroller") > 0) {
				this.grid._synchronizeHScroll();
			}
			if (this.options.mode === "deferred") {
				this._adjustIndicators(delta);
			}
			if (this._scroller.on === true) {
				setTimeout(this._autoScroll, this._scroller.delay);
			}
		},
		_cancelEvent: function (e) {
			e.stopPropagation();
			e.preventDefault();
		},
		_columnMap: function () {
			/* function used by the FeatureChooser */
			return $.map(this.grid.options.columns, function (col, index) {
				return { "columnKey": col.key, "enabled": true };
			});
		},
		// service
		_removeMoving: function () {
			var ths = this.grid.headersTable().find('>thead th'), i, th, mdl, removeContainer, fc;
			// selects all moving elements and removes them
			if (this._cmit && this.cmit.length > 0) {
				if (this._cmit.data("users") === 1) {
					this._cmit.remove();
				} else {
					this._cmit.data("users", this._cmit.data("users") - 1);
				}
			}
			if (this._cmib && this._cmib.length > 0) {
				if (this._cmib.data("users") === 1) {
					this._cmib.remove();
				} else {
					this._cmib.data("users", this._cmib.data("users") - 1);
				}
			}
			if (this.options.addMovingDropdown === true) {
				mdl = this._movingDialog;
				if (mdl && mdl instanceof jQuery) {
					mdl.igGridModalDialog("destroy");
					mdl.remove();
				}
				$("div[data-moving-inddropdown='" + this.grid.id() + "']").remove();
			}
			fc = this.grid.element.data("igGridFeatureChooser");
			removeContainer = true;
			if (this.renderInFeatureChooser && fc) {
				fc._removeFeature("ColumnMovingDropDown", true);
				removeContainer = false;
			}
			for (i = 0; i < ths.length; ++i) {
				th = $(ths[i]);
				if (removeContainer) {
					th.find(">div").find("span").unbind("mousedown", this._dropDownButtonHandler);
					th.find(">div").remove();
				}
				th.unbind("mouseover.moving", this._headerMouseOverHandler);
				th.unbind("mouseout.moving", this._headerMouseOutHandler);
				if (!this._grpByEnabled) {
					if (th.data && th.data("draggable")) {
						th.draggable("destroy");
					}
				} else {
					th.unbind("draggabledrag", this._moveHandler);
					th.unbind("draggablestop", this._dropHandler);
					th.unbind("draggablestart", this._dragHandler);
				}
			}
		},
		_unregisterEvents: function () {
			this.grid.element.unbind("iggridheadercellrendered", this._headerCellRenderedHandler);
			this.grid.element.unbind("iggridheaderrendering", this._headerRenderingHandler);
			this.grid.element.unbind("iggridheaderrendered", this._headerRenderedHandler);
			this.grid.element.unbind("iggridrendered", this._gridFullyRenderedHandler);
			this.grid.element.unbind("iggridresizingcolumnresized", this._columnStateChanged);
			this.grid.element.unbind("iggridcolumnscollectionmodified", this._columnStateChanged);
			this.grid.element.unbind("iggridpagingpagingdropdownrendered", this._columnStateChanged);
			this.grid.element.unbind("iggrid_columnsmoved", this._columnStateChanged);
			this.grid.headersTable().find("th").unbind("moving");
		},
		_registerEvents: function () {
			this.grid.element.bind("iggridheadercellrendered", this._headerCellRenderedHandler);
			this.grid.element.bind("iggridheaderrendering", this._headerRenderingHandler);
			this.grid.element.bind("iggridheaderrendered", this._headerRenderedHandler);
			this.grid.element.bind("iggridrendered", this._gridFullyRenderedHandler);
			// column state change events
			this.grid.element.bind("iggridresizingcolumnresized", this._columnStateChanged);
			this.grid.element.bind("iggridcolumnscollectionmodified", this._columnStateChanged);
			this.grid.element.bind("iggridpagingpagingdropdownrendered", this._columnStateChanged);
			this.grid.element.bind("iggrid_columnsmoved", this._columnStateChanged);
		},
		_createHandlers: function () {
			this._headerCellRenderedHandler = $.proxy(this._headerCellRendered, this);
			this._headerRenderingHandler = $.proxy(this._headerRendering, this);
			this._headerRenderedHandler = $.proxy(this._headerRendered, this);
			this._gridFullyRenderedHandler = $.proxy(this._gridFullyRendered, this);
			// draggable
			this._dragHandler = $.proxy(this._headerPicked, this);
			this._moveHandler = $.proxy(this._headerDragged, this);
			this._dropHandler = $.proxy(this._headerDropped, this);
			// header mouseover
			this._headerMouseOverHandler = $.proxy(this._headerMouseOver, this);
			this._headerMouseOutHandler = $.proxy(this._headerMouseOut, this);
			// dropdown
			this._dropDownButtonHandler = $.proxy(this._dropDownMouseDown, this);
			this._dropDownKeyHandler = $.proxy(this._dropDownKeyDown, this);
			this._openMovingDialogHandler = $.proxy(this._openMovingDialog, this);
			this._dropDownButtonMouseOverHandler = $.proxy(this._dropDownButtonMouseOver, this);
			this._dropDownButtonMouseOutHandler = $.proxy(this._dropDownButtonMouseOut, this);
			// dialog
			this._dialogOpeningHandler = $.proxy(this._dialogOpening, this);
			this._dialogDraggedHandler = $.proxy(this._dialogDragged, this);
			this._dialogClosingHandler = $.proxy(this._dialogClosing, this);
			this._dialogClosedHandler = $.proxy(this._dialogClosed, this);
			this._dialogCloseButtonHandler = $.proxy(this._closeMovingDialog, this);
			this._dialogUpHandler = $.proxy(this._dialogUpPressed, this);
			this._dialogDownHandler = $.proxy(this._dialogDownPressed, this);
			this._dialogRearrangingHandler = $.proxy(this._dialogRearranging, this);
			this._dialogRearrangedHandler = $.proxy(this._dialogRearranged, this);
			// cache rebuild
			this._columnStateChanged = $.proxy(this._updateLayout, this);
			// cancel events
			this._cancelEventHandler = $.proxy(this._cancelEvent, this);
			// auto scroller
			this._autoScroll = $.proxy(this._scrollGrid, this);
			// scroller events
			this._containerScrolledHandler = $.proxy(this._containerScrolled, this);
		},
		// inject grid
		_injectGrid: function (gridInstance, isRebind) {
			this.grid = gridInstance;
			if (isRebind === true) {
				return;
			}
			//init igGridFeatureChooser
			if (this.grid.element.igGridFeatureChooser !== undefined) {
				this.grid.element.igGridFeatureChooser();
			} else {
				throw new Error($.ig.ColumnMoving.locale.featureChooserNotReferenced);
			}
			this._createHandlers();
			this._unregisterEvents();
			this._registerEvents();
		}
	});
	$.extend($.ui.igGridColumnMoving, { version: "14.1.20141.2249" });
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI jQuery Popover 14.1.20141.2249
 *
 * Copyright (c) 2013-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *  jquery-1.4.2.js
 *  jquery.ui.core.js
 *  jquery.ui.widget.js
 *  infragistics.util.js
 */
/*global jQuery, Modernizr, HTMLElement */
if (typeof jQuery !== "function") {
    throw new Error("jQuery is undefined");
}
(function ($) {
    $.widget("ui.igPopover", {
        css: {
            /* classes applied to the main popover container */
            baseClasses: "ui-widget ui-igpopover",
            /* classes applied to the popover arrow (like ui-igpopover-arrow-top, ui-igpopover-arrow-left, etc)*/
            arrowBaseClass: "ui-igpopover-arrow ui-igpopover-arrow-",
            /* classes applied to the close button */
            closeButtonClass: "ui-icon ui-icon-closethick ui-igpopover-close-button",
            /* classes applied to the title container(if title is defined in options) */
            titleClass: "ui-igpopover-title"
        },
        options: {
            /* type="bool" controls whether the popover will close on blur or not */
            closeOnBlur: true,
            /* type="auto|left|right|top|bottom" controls the direction in which the control shows relative to the target element
                auto type="string" lets the control show on the side where enough space is available with the following priority top > bottom > right > left
                left type="string" shows popover on the left side of the target element
                right type="string" shows popover on the right side of the target element
                top type="string" shows popover on the top of the target element
                bottom type="string" shows popover on the bottom of the target element
           */
            direction: "auto",
            /* type="auto|balanced|start|end" controls the position of the popover according to the target element in case the popover is larger than the target on the side we want to position, if the popover is smaller it should always be in the middle of the visible area
                auto type="string" lets the control choose a position depending on available space with the following priority balanced > end > start
                balanced type="string" the popover is positioned at the middle of the target element
                start type="string" the popover is positioned at the beginning of the target element
                end type="string" the popover is positioned at the end of the target element
           */
            position: "auto",
            /* type="number|string" defines width for the popover. leave null for auto. 
                number The width can be set as a number.
                string The width can be set in pixels (px).
            */
            width: null,
            /* type="number|string" defines height for the popover. leave null for auto
                number The height can be set as a number.
                string The height can be set in pixels (px).
            */
            height: null,
            /* type="number|string" defines width the popover won't exceed even if no specific one is set. 
                number The maxWidth can be set as a number.
                string The maxWidth can be set in pixels (px).
            */
            maxWidth: 200,
            /* type="number|string" defines height the popover won't exceed even if no specific one is set. 
                number The max height can be set as a number.
                string The max height can be set in pixels (px).
            */
            maxHeight: 200,
            /* type="number" sets the time popover fades in and out when showing/hiding */
            animationDuration: 150,
            /* type="string|function" sets the content for the popover container. If left null the content will be get from the target.
                string   String content of the popover container
                function Function which is a callback that can either return the content directly, or call the first argument, passing in the content
            */
            contentTemplate: null,
            /* type="string" Selectors indicating which items should show popovers. The predefined value is [title]. Customize if you're using something other then the title attribute for the popover content, or if you need a different selector for event delegation. When changing this option, you likely need to also change the contentTemplate option 
            */
            selectors: null,
            /* type="object" sets the content for the popover header */
            headerTemplate: {
                /* type="bool" controls whether the popover renders a functional close button */
                closeButton: false,
                /* type="string" sets the content for the popover header */
                title: null
            },
            /* type="mouseenter|click|focus" sets the event on which the popover will be shown. Predefined values are "mouseenter", "click" and "focus"
                mouseenter   type="string" the popover is shown on mouse enter in the target element
                click        type="string" the popover is shown on click on the target element
                focus        type="string" the popover is shown on focusing the target element
            */
            showOn: "mouseenter",
            /* type="object" sets the containment for the popover. Accepts a jQuery object */
            containment: null
        },
        events: {
            /* cancel="true" Event fired before popover is shown.
            Function takes arguments evt and ui.
            Use ui.element to get the element the popover will show for.
            Use ui.content to get or set the content to be shown as a string.
            Use ui.popover to get the popover element showing.
            Use ui.owner to get reference to the igPopover widget
            */
            showing: "showing",
            /* Event fired after popover is shown.
            Function takes arguments evt and ui.
            Use ui.element to get the element the popover showed for.
            Use ui.content to get the content that was shown as a string.
            Use ui.popover to get the popover element shown.
            Use ui.owner to get reference to the igPopover widget
            */
            shown: "shown",
            /* cancel="true" Event fired before popover is hidden.
            Function takes arguments evt and ui.
            Use ui.element to get the element the popover will hide for.
            Use ui.content to get the current content displayed in the popover as a string.
            Use ui.popover to get the popover element hiding.
            Use ui.owner to get reference to the igPopover widget
            */
            hiding: "hiding",
            /* Event fired after popover is hidden.
            Function takes arguments evt and ui.
            Use ui.element to get the element the popover is hidden for.
            Use ui.content to get the content displayed in the popover as a string.
            Use ui.popover to get the popover element hidden.
            Use ui.owner to get reference to the igPopover widget
            */
            hidden: "hidden"
        },
        _create: function () {
            // T.G. 24 Jan 2014 Fix for bug 161249 - Target option is not obligatory because the user expects it to be the element on which the popover is initialized
            this._target = ( this.options.selectors === null || this.options.selectors  === undefined) ? this.element : null;
            this._priorityDir = ["bottom", "top", "right", "left"];
            this._arrowDir = ["top", "bottom", "left", "right"];
            this._positions = ["balanced", "start", "end"];
            this._directionIndex = -1;
            this._positionIndex = -1;
            this._forced = this.options.direction !== "auto" && this.options.position !== "auto";
        },
        _createWidget: function (options, element) {
            $.Widget.prototype._createWidget.apply(this, arguments);
            this.element = $(element);
            if (element && element.nodeType !== undefined) {
                this._renderPopover();
            }
            if (this.options.direction !== "auto" || this.options.position !== "auto") {
                this._getPrioritiesIndex();
            }
        },
        _setOption: function (key, value) {
            switch (key) {
                case "direction":
                    this.options.direction = value;
                    if (this.options.direction !== "auto") {
                        this._getPrioritiesIndex();
                    }
                    this._forced = this.options.direction !== "auto" && this.options.position !== "auto";
                    break;
                case "position":
                    this.options.position = value;
                    if (this.options.position !== "auto") {
                        this._getPrioritiesIndex();
                    }
                    this._forced = this.options.direction !== "auto" && this.options.position !== "auto";
                    break;
                case "contentTemplate":
                    if (typeof value === "string") {
                        this.options.contentTemplate = value;
                    }
                    break;
                case "animationDuration":
                    if (typeof value === "number") {
                        this.options.animationDuration = value;
                    }
                    break;
                case "containment":
                    if (value instanceof jQuery) {
                        this.options.containment = value;
                    }
                    break;
                case "headerTemplate":
                case "selectors":
                case "width":
                case "height":
                case "closeOnBlur":
                case "maxWidth":
                case "maxHeight":
                case "showOn":
                    throw new Error( $.ig.Popover.locale.popoverOptionChangeNotSupported + ' ' + key );
            }
        },
        destroy: function () {
            /* Destroys the popover widget.*/
            this._detachEventsFromTarget();
            $('#' + this.id() + "_popover").remove();
            $.Widget.prototype.destroy.call(this);
            return this;
        },
        id: function () {
            /* returns the ID of the element the popover is attached to
               returnType="string"
            */
            return this.element[0].id;
        },
        container: function () {
            /* returns the container for the popover contents
               returnType="object"
            */
            return $("#" + this.id() + "_popover_contentInner");
        },
        show: function (trg, content) {
            /* shows the popover for the specified target
              paramType="dom" optional="true" The element to show popover for.
              paramType="string" optional="true" The string to set for the popover to show.
             */
            var target = trg || this._target;
            if (content) {
                this._setNewContent(content);
            }
            //T.G. 23 Jan 2014 Fix for bug 162111 - An error is thrown when calling igPopover.show method when the igPopover.selectors is set
            if( target === null ) {
                throw new Error( $.ig.Popover.locale.popoverShowMethodWithoutTarget );
            } else {
                this._openPopover( target );
            }
        },
        hide: function () {
            /* hides the popover for the specified target */
            this._closePopover();
        },
        getContent: function () {
            /* gets the currently set content for the popover container
               returnType="string" The popover content.
            */
            return $("#" + this.id() + "_popover_contentInner").html();
        },
        setContent: function (newCnt) {
            /* sets the content for the popover container
                paramType="string" The popover content to set.
            */
            if (typeof newCnt === 'string') {
                this._setNewContent(newCnt);
            }
        },
        target: function () {
            /* gets the popover current target 
               returnType="object" The current target.
            */
            if (this._currentTarget) {
                return this._currentTarget;
            }
            return null;
        },
        getCoordinates: function (){
            /* gets the current coordinates of the popover 
            returnType="object" The popover coordinates in pixels.
            */
            var currPosition = { left: 0, top: 0 };
            currPosition.left = this.popover.css( 'left' );
            currPosition.top = this.popover.css( 'top' );
            return currPosition;
        },
        setCoordinates: function (pos){
            /* set the currently coordinates of the popover 
            paramType="object" The popover coordinates in pixels.
            */
            this.popover.css( {
                'top': pos.top,
                'left': pos.left
            } );
        },
        _renderPopover: function () {
            this.popover = $('<div></div>').attr('id', this.id() + "_popover").addClass(this.css.baseClasses);
            // T.G 12 Dec 2013 Fix 159000 - Arrow is separated from the inner frame 
            if (this.options.direction !== "auto") {
                this._getPrioritiesIndex();
                $('<div></div>')
                    .attr('id', this.id() + "_popover_arrow")
                    .addClass( this.css.arrowBaseClass + this._arrowDir[this._directionIndex] )
                    .appendTo(this.popover);
            }
            this.popover.appendTo( window.document.body );
            this._attachEventsToTarget();
            this._createContentDiv();
        },
        _createContentDiv: function () {
            var cnt, currContent;
            cnt = $( '<div></div>' )
                .attr( 'id', this.id() + "_popover_contentFrame" )
                .css( 'position', 'relative' )
                .css( 'max-width', this.options.maxWidth )
                .css( 'max-height', this.options.maxHeight )
                .css( 'width', this.options.width || 'auto' )
                .css( 'height', this.options.height || 'auto' )
                .addClass( "ui-widget-content ui-corner-all" )
                .appendTo( this.popover );
            if ( this.options.headerTemplate !== null ) {
                if ( this.options.headerTemplate.closeButton ) {
                    $( '<div></div>' )
                        .attr( 'id', this.id() + "_popover_closeBtn" )
                        .addClass( this.css.closeButtonClass )
                        .bind( 'click.popover', $.proxy( this._closeBtnClick, this ) )
                        .appendTo( cnt );
                }
                if (this.options.headerTemplate.title !==null ) {
                    $('<div></div>')
                        .attr('id', this.id() + "_popover_title")
                        .addClass(this.css.titleClass)
                        .html( this.options.headerTemplate.title )
                        .appendTo(cnt);
                }
            }
            // if there is a single target and a content set, the inner html is set to depend on them
            currContent = this.options.contentTemplate;
            if ((typeof currContent === "string" || !currContent) && this._target) {
                // the content is with priority over the title in case when target is set
                currContent = this.options.contentTemplate || this._target[0].title || "";
            } else if ( this.options.selectors !== null && !this._target && !currContent ) {
                // if no target and content are set, and the selectors is set than the title of the element will be displayed
                this.options.contentTemplate = function () { return $( this ).attr( 'title' ); };
            } else if ( typeof currContent === "function" && this._target ){
                currContent = this.options.contentTemplate.call( this._target[0], function ( response ) { return; } );
            }
            var rightMargin = ( this.options.headerTemplate.closeButton && ( this.options.headerTemplate.title === null || this.options.headerTemplate.title === "" ) ) ? $( '.ui-icon' ).width()  : null;
            $('<div></div>')
                .attr('id', this.id() + "_popover_contentInner")
                .css( 'position', 'relative' )
                .css( 'margin-right', rightMargin )
                .html(currContent)
                .appendTo(cnt);
            $('<div></div>')
              .css('clear', 'both')
              .appendTo(cnt);
        },
        _updateArrowDiv: function (nDir, idx) {
            var arrowDiv = $("#" + this.id() + "_popover_arrow"),
              conDiv = $( "#" + this.id() + "_popover_contentFrame" ),
              dims; 
            if (arrowDiv.length === 0) {
                // T.G 12 Dec 2013 Fix 159000 - Arrow is separated from the inner frame 
                arrowDiv = $('<div></div>')
                .attr( 'id', this.id() + "_popover_arrow" )
                .addClass( this.css.arrowBaseClass + this._arrowDir[idx] )
                .appendTo( this.popover );
            } else {
                arrowDiv
                .removeClass( "ui-igpopover-arrow-left ui-igpopover-arrow-right ui-igpopover-arrow-bottom ui-igpopover-arrow-top" )
                .addClass( this.css.arrowBaseClass + this._arrowDir[idx] );
            }
            dims = this._getHiddenElementsDimensions([arrowDiv, conDiv]);
            // Arrow should be positioned according to target, not according to content div.
            // T.G 12 Dec 2013 Fix 159000 - Arrow is separated from the inner frame 
            switch (nDir) {
                case "top":
                    conDiv.css({
                        'left': '',
                        'top': dims[0].height * -1,
                        'float': ''
                    });
                    arrowDiv.css({
                        'left': '',
                        'top': '',
                        'float': ''
                    });
                    break;
                case "bottom":
                    conDiv.css({
                        'left': '',
                        'top': dims[0].height, 
                        'float': ''
                    });
                    arrowDiv.css({
                        'left': '',
                        'top': '',
                        'float': ''
                    });
                    break;
                case "left":
                    conDiv.css({
                        'left': dims[0].width * -1, 
                        'top': '',
                        'float': 'left'
                    });
                    arrowDiv.css({
                        'left': '',
                        'top': '',
                        'float': 'left'
                    });
                    break;
                case "right":
                    conDiv.css({
                        'left': dims[0].width,
                        'top': '',
                        'float': 'left'
                    });
                    arrowDiv.css({
                        'left': '',
                        'top': '',
                        'float': 'left'
                    });
                    break;
            }
            this.oDir = nDir;
        },
        _targetMouseLeave: function () {
            this._hoveredTarget = null;
            if (this.options.closeOnBlur === true) {
                this._closePopover();
            }
        },
        _targetMouseMove: function (trg) {
            var self = this;           
            // if target is set , it is with higher priority than the selectors
            if (this._target) {
                this._openPopover($(this._target));
            } else {
                // T.G. Bug 150520 - (fix) set timeout for the mouseenter event 
                // T.G  15.10.2013 Bug 154985 - Popover doesn't hide when the group of elements are shown fast
                // T.P. & M.H. Bug 154985 Previous fix has regressed the case when target element has no id. 
                $(trg.currentTarget).addClass('is-hover');
                setTimeout(function () {
                    if ( self._hoveredTarget === trg.currentTarget ){
                        self._openPopover($(trg.currentTarget));
                        $(trg.currentTarget).removeClass('is-hover');
                    }
                }, self.options.animationDuration );
                this._hoveredTarget = trg.currentTarget;
            }
        },
        _targetClick: function (trg) {
            var t = this._target || trg.currentTarget;
            if ($(t).data('onFocus') && this.container().is(':visible')) {
                this._closePopover();
                $(t).data('onFocus', false);
            } else {
                this._openPopover( $( t ) );
                $( t ).focus();
                $( t ).data( 'onFocus', true );
            }
        },
        _targetBlur: function (trg) {
            var t = this._target || trg.currentTarget,
                self = this;
            setTimeout( function () {
                if ( $( t ).data( 'onFocus' ) ){
                    // T.G. 24 Jan 2014, Bug 162268 - Clicking elements in the popover closes it.
                    if (self.options.closeOnBlur === true) {
                        self._closePopover();
                        $( t ).data( 'onFocus', false );
                    }
                } else {
                    $( t ).focus();
                }
            }, 10);
        },
        _focusin: function (trg) {
            var t = this._target || trg.currentTarget;
            this._openPopover($(t));
        },
        _focusout: function () {
            this._closePopover();
        },
        _closeBtnClick: function (event, ui) {
            this._closePopover();
            event.stopPropagation();
        },
        _attachEventsToTarget: function () {
            var self = this, t = this._target,
                showEvt, hideEvt, targetShowEvt, targetHideEvt;
            if (this.options.showOn && this.options.showOn.match(/click|focus|mouseenter/)) {
                switch (this.options.showOn) {
                    case "click":
                        showEvt = 'click.popover';
                        hideEvt = 'blur.popover';
                        targetShowEvt = self._targetClick;
                        targetHideEvt = self._targetBlur;
                        break;
                    case "focus":
                        showEvt = 'focusin.popover';
                        hideEvt = 'focusout.popover';
                        targetShowEvt = self._focusin;
                        targetHideEvt = self._focusout;
                        break;
                    case "mouseenter":
                        showEvt = 'mouseenter.popover';
                        hideEvt = 'mouseleave.popover';
                        targetShowEvt = self._targetMouseMove;
                        targetHideEvt = self._targetMouseLeave;  
                        break;
                }
            }
            // K.D. July 18th, 2012 Bug #117374 The HTMLElement object is natively not defined in IE <= 8
            // Abstain from referring to "natively" defined objects as we're not sure in what cases they would
            // actually be undefined. Add to check if is jQuery object
            if (t && window.HTMLElement !== undefined && (t instanceof HTMLElement || t instanceof jQuery) && showEvt) {
                $(t).unbind(showEvt).bind(showEvt, $.proxy(targetShowEvt, this));
                $(t).unbind(hideEvt).bind(hideEvt, $.proxy(targetHideEvt, this));
            } else if (this.options.selectors && showEvt) {
                this.element.find(self.options.selectors).addBack().each(function () {
                    var target = $(this)[0];
                    // verify that no popover should be shown for the original div
                    if (target.id === self.id()) {
                        return;
                    }
                    $(target).unbind(showEvt).bind(showEvt, $.proxy(targetShowEvt, self));
                    $(target).unbind(hideEvt).bind(hideEvt, $.proxy(targetHideEvt, self));
                });
            }
        },
        _detachEventsFromTarget: function () {
            // T.G Sep 23th, 2013 Bug #152943 destroy of igPopover
            var t = this._target, self = this;			
            // K.D. July 18th, 2012 Bug #117374 The HTMLElement object is natively not defined in IE <= 8
            // Abstain from referring to "natively" defined objects as we're not sure in what cases they would
            // actually be undefined. Add to check if is jQuery object
            if (t && window.HTMLElement !== undefined && (t instanceof HTMLElement || t instanceof jQuery)) {
                $(t).unbind('.popover');
            } else if (this.options.selectors) {
                this.element.find(self.options.selectors).addBack().each(function () {
                    var target = $(this);
                    $(target).unbind('.popover');
                });
            }
        },
        _positionPopover: function (trg) {
            var i = 0, fn, fnRes;
            if (this.options.direction === "auto") {
                do {
                    this._updateArrowDiv(this._priorityDir[i], i);
                    fn = "_" + this._priorityDir[i] + "Position";
                    fnRes = this[fn](trg);
                    i++;
                } while (fnRes === false && i < this._priorityDir.length);
                if (fnRes === false) {
                    // "Couldn't find space anywhere. Please exceed screen dimensions" 
                    return;
                }
            } else {
                this._updateArrowDiv(this.options.direction, this._directionIndex);
                fn = "_" + this.options.direction + "Position";                
                if ( !this[fn]( trg ) ) { 
                    //&& (this.options.selectors || !this._target)
                    //trying to find a place on the screen if there is no space to show with the position set
                   this._forced = true;
                    do {
                        this._updateArrowDiv(this._priorityDir[i], i);
                        fn = "_" + this._priorityDir[i] + "Position";
                        fnRes = this[fn](trg);
                        i++;
                    } while ( fnRes === false && i < this._priorityDir.length );
                    return;
                }
            }
        },
        _findProperPosition: function (dir, x, trg) {
            var i = 0,
                fnRes, y, cDim, cPos, win = $( window ),
                trgFDim, wScroll, tPos, boundary, countainmentBoundary,
                $containment;
            if (dir === "left") {
                cPos = "left";
                cDim = "outerWidth";
                wScroll = win.scrollLeft();
            } else {
                cPos = "top";
                cDim = "outerHeight";
                wScroll = win.scrollTop();
            }
            boundary = wScroll + win[0][cDim];
            $containment = this.options.containment;
            if (this.options.containment) {
                countainmentBoundary = $containment.offset()[cPos];
                if (cDim === "outerWidth") {
                    countainmentBoundary = countainmentBoundary + $containment.outerWidth();
                } else {
                    countainmentBoundary = countainmentBoundary + $containment.outerHeight();
                }
                if (boundary > countainmentBoundary) {
                    boundary = countainmentBoundary;
                }
            }
            // target element is not fully visible on the screen along the axis we need
            if (trg.offset()[cPos] + trg[cDim]() > boundary) {
                // we use a redux value to not create the popover outside the screen borders
                trgFDim = boundary - trg.offset()[cPos];
            } else {
                trgFDim = trg[cDim]();
            }
            if (trg[cDim]() > this.popover[cDim]()) {
                // if the popover is smaller on the side we want to position 
                // it should always get in the middle of the visible area
                y = trg.offset()[cPos] + trgFDim / 2 - this.popover[cDim]() / 2;
                fnRes = dir === "left" ? this._checkCollision(x, y, trg) : this._checkCollision(y, x, trg);
            } else {
                // rotate between possible positions until the popover fits or it's clear it won't fit
                if (this.options.position === "auto") {
                    do {
                        tPos = this._positions[i];
                        y = this._getCounterPosition(trg, trgFDim, tPos, cPos, cDim);
                        fnRes = dir === "left" ? this._checkCollision(x, y, trg) : this._checkCollision(y, x, trg);
                    } while (fnRes === false && ++i < this._positions.length);
                } else {
                    y = this._getCounterPosition(trg, trgFDim, this.options.position, cPos, cDim);
                    fnRes = dir === "left" ? this._checkCollision(x, y, trg) : this._checkCollision(y, x, trg);
                }
            }
            if (fnRes === true) {
                this._adjustArrowPosition(trg, dir, cPos, cDim);
            }
            return fnRes;
        },
        _getCounterPosition: function (trg, trgFDim, tPos, cPos, cDim) {
            var y;
            switch (tPos) {
                case "balanced":
                    y = trg.offset()[cPos] + trgFDim / 2 - this.popover[cDim]() / 2;
                    break;
                case "start":
                    y = trg.offset()[cPos];
                    break;
                case "end":
                    y = trg.offset()[cPos] - this.popover[cDim]() + trgFDim;
                    break;
            }
            return y;
        },
        _topPosition: function (trg) {
            var top = trg.offset().top - this.popover.outerHeight();
            // finds are proper left position for the popover if one exists
            return this._findProperPosition("left", top, trg);
        },
        _bottomPosition: function (trg) {
            var top = trg.offset().top + trg.outerHeight();
            return this._findProperPosition("left", top, trg);
        },
        _leftPosition: function (trg) {
            var left = trg.offset().left - this.popover.outerWidth();
            return this._findProperPosition("top", left, trg);
        },
        _rightPosition: function (trg) {
            var left = trg.offset().left + trg.outerWidth();
            return this._findProperPosition("top", left, trg);
        },
        _checkCollision: function (top, left, trg) {
            var tfullw = this.popover.outerWidth(),
                tfullh = this.popover.outerHeight(),
                win = $( window ), wh, ww, os,
                $containment, arrow, rightBoundary, bottomBoundary, leftBoundary, topBoundary;
            ww = win.width() + win.scrollLeft();
            wh = win.height() + win.scrollTop();
            arrow = $("#" + this.id() + "_popover_arrow");
            // M.H. 26 Sep 2013 Fix for bug #151629: The feature chooser for the last column is not rendered correctly on a mobile device.
            rightBoundary = ww;
            bottomBoundary = wh;
            leftBoundary = win.scrollLeft();
            topBoundary = win.scrollTop();
            $containment = this.options.containment;
            if ( this.options.containment ) {
                if (leftBoundary < $containment.offset().left) {
                    leftBoundary = $containment.offset().left;
                }
                if ($containment.offset().left + $containment.outerWidth() < rightBoundary) {
                    rightBoundary = $containment.offset().left + $containment.outerWidth();
                }
                if (bottomBoundary > $containment.offset().top + $containment.outerHeight()) {
                    bottomBoundary = $containment.offset().top + $containment.outerHeight();
                }
                if (topBoundary < $containment.offset().top) {
                    topBoundary = $containment.offset().top;
                }
            }
            if ( left < leftBoundary ) {
                if ( this.options.direction === "left" ){
                    return false;
                }
                else {
                    left = leftBoundary;
                }
            }
            if (trg.offset().left + (tfullw / 2) > rightBoundary) {
                left = rightBoundary - tfullw;
            }
            if ( ((trg.offset().top + tfullh + arrow.height() > bottomBoundary) && (this.oDir === "bottom")) ||
                        ((trg.offset().top - tfullh - arrow.height() < topBoundary) && (this.oDir === "top")) ) {
                if (this.options.selectors) {
                    return false;
                }
            }
            if ( left < leftBoundary || left + tfullw > rightBoundary || top < topBoundary || top + tfullh > bottomBoundary ) {
                if ( this._forced === true ) { 
                    //  T.G. 29 Jan 2014 Fix 162164- When the element is relative in scrollable container the popover does not change its position when you scroll the container.
                   return false;
                }
                // T.G. 7 Mar 2014 Fix 162110 - The popover does not change its position if there is no room on the left or right.
                //return false;
            }
            if (!this.options.containment && this._target) {
                os = this._getRelativeOffset();
                top = top - os.top;
                left = left - os.left;
            }
            this.popover.css({
                'top': top,
                'left': left
            });
            return true;
        },
        _getPrioritiesIndex: function () {
            var i;
            if (this.options.direction !== "auto") {
                for (i = 0; i < this._priorityDir.length; i++) {
                    if (this.options.direction === this._priorityDir[i]) {
                        this._directionIndex = i;
                        break;
                    }
                }
            }
            if (this.options.position !== "auto") {
                for (i = 0; i < this._positions.length; i++) {
                    if (this.options.position === this._positions[i]) {
                        this._positionIndex = i;
                        break;
                    }
                }
            }
        },
        _openPopover: function (trg) {
            var args, noCancel, val = this.getContent(),self = this, contentFunc;
            args = {
                element: trg,
                content: val,
                popover: this.popover,
                owner: this
            };
            $( this.popover ).data( 'isAnimating', true );
            noCancel = this._trigger(this.events.showing, this, args);
            if ( noCancel === true ) {
                self._restoreOriginalTitle( self._currentTarget );
                if ( args.content !== val ) {
                    this._setNewContent(args.content);
                } else if ( typeof this.options.contentTemplate === "function" ) {
                    contentFunc = this.options.contentTemplate;
                    args.content = contentFunc.call(trg[0], function (response) { return; });
                    this._setNewContent(args.content || "");
                }
                this._positionPopover(trg);
                this._currentTarget = trg;
                $( this.popover ).data( 'isAnimating', false );
                this.popover.fadeIn( this.options.animationDuration, function () {
                    self._trigger( self.events.shown, self, args );
                });
                this._removeOriginalTitle( trg );
            }
        },
        _closePopover: function () {
            var args, noCancel, self = this;
            args = {
                element: this._currentTarget,
                content: this.getContent(),
                popover: this.popover,
                owner: this
            };
            $( this.popover ).data( 'isAnimating', true );
            noCancel = this._trigger(this.events.hiding, this, args);
            if (noCancel === true) {
                $( this.popover ).data( 'isAnimating', false );
                this.popover.fadeOut( this.options.animationDuration, function () {
                    self._trigger(self.events.hidden, self, args);
                } );
            }
        },
        _mouseenter: function ( e ) {
            _removeOriginalTitle( $( e._currentTarget ) );
        },
        _removeOriginalTitle: function ( element ) {
            while ( element.length && !element.is( "body" ) ) {
                // if we have a title, clear it to prevent the native tooltip
                if ( element.attr( "title" ) ) {
                    element.data( "popover-title", element.attr( "title" ) );
                    element.attr( "title", "" );
                }
                element = element.parent();
            }
        }, 
        _restoreOriginalTitle: function ( element ) {
            if ( element && element.data( "popover-title" ) ) {
                element.attr( "title", element.data( "popover-title" ) );
                element.removeData( "popover-title" );
            }
        },
        _adjustArrowPosition: function (trg, dir, cPos, cDim) {
            var arrow = $("#" + this.id() + "_popover_arrow"),
             offset = { left: 0, top: 0 };
            if (!this.options.containment && this._target) {
                offset = this._getRelativeOffset();
            }
            if (dir === "top") {
                arrow.css({
                    "top": (trg.offset()[cPos] - parseInt(this.popover.css(cPos), 10) - offset.top) + (trg[cDim]() / 2) - (arrow.height() / 2)
                });
            } else {
              if (trg[cDim]() < this.popover[cDim]()) {
                // T.G., 28 Jan 2014, Fix bug 162181 - The arrow does not stay in the containment element when the container is scrolled.
                var left = (trg.offset()[cPos] - parseInt(this.popover.css(cPos), 10) - offset.left) + (trg[cDim]() / 2);
                left = (left < parseInt(arrow.css("border-left-width"),10)) ? parseInt(arrow.css("border-left-width"),10) : left;
                arrow.css({
                   // T.G., 18 June 2014, Fix bug 158915 - If igGrid is scrolled on the right the popover tooltip is misaligned and the arrow is not positioned correctly
                   // T.G., 18 June 2014, Fix bug 166644 - The arrow and the container are displayed separately when the target is larger than the browser window and scroll is available
                   "left": left
                });
              }
            }
        },
        _getRelativeOffset: function () {
            var offset = { left: 0, top: 0 }, elem = this.popover;
            if (this.options.containment) {
                elem = this.options.containment;
            }
            while (elem[0] !== null && elem[0] !== undefined && elem[0].nodeName !== "#document") {
                if (elem.css('position') === 'relative') {
                    offset.left = elem.offset().left;
                    offset.top = elem.offset().top;
                    break;
                }
                elem = elem.parent();
            }
            return offset;
        },
        _getHiddenElementsDimensions: function ( elArr ) {
            var dim = [], i, elem;
            $( "#" + this.id() + "_popover" ).show();
            for ( i = 0; i < elArr.length; i++ ) {
                elem = elArr[i];
                dim.push({
                    width: elem.outerWidth(),
                    height: elem.outerHeight()
                });
            }
            $("#" + this.id() + "_popover").hide();
            return dim;
        },
        _setNewContent: function ( nc ) {
            var newContent = nc;
            if ( nc instanceof jQuery ) {
                newContent = nc.html();
            } else if ( typeof nc === "object" ) {
                newContent = nc.innerHTML;
            }
            $( "#" + this.id() + "_popover_contentInner" ).html( newContent );
        }
    });
    // support: jQuery <1.8
    if (!$.fn.addBack) {
        $.fn.addBack = function ( selector ) {
            return this.add(( selector === null || selector === undefined ) ?
                this.prevObject : this.prevObject.filter( selector )
            );
        };
    }
    $.extend($.ui.igPopover, {
        version: '14.1.20141.2249'
    });
} (jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid Feature Chooser 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.popover.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery, Modernizr, Class, window, ActiveXObject*/
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {
	
	$.widget("ui.igGridFeatureChooserPopover", $.ui.igPopover, {
		options: {
			gridId: '',
			targetButton: null,
			closeOnBlur: true,
			containment: null
		},
		_create: function () {
			$.extend($.ui.igGridFeatureChooserPopover.prototype.options, $.ui.igPopover.prototype.options);
			$.extend($.ui.igGridFeatureChooserPopover.prototype.css, $.ui.igPopover.prototype.css);
			$.ui.igPopover.prototype._create.apply(this);
		},
		isShown: function () {
			return this.container().is(':visible');
		},
		_setFCElementFocus: function (focus, $target) {
			if ($target === undefined || $target === null) {
				$target = this.options.targetButton;
			}

			this.options.targetButton.data('onFocus', focus);
			if (focus) {
				$target.focus();
			}
		},
		registerElements: function (elements) {
			var events, $targetButton = this.options.targetButton,
				self = this;

			events = {
				focus: function (e) {
					setTimeout(function () {
						$targetButton.data('onFocus', true);
					}, 1);
				},
				blur: function (e) {
					$targetButton.data('onFocus', false);
					setTimeout(function () {
						if (!$targetButton.data('onFocus') && self.isShown()) {
							self._closePopover();
						}
					}, 10);
				}
			};
			elements.bind(events);
		},
		_createWidget: function (options, element) {
			//this.options.defaultMaxWidth = null;
			var self = this,
				$targetButton;

			this._attachedToBody = true;
            this.options.content = "";
			$.Widget.prototype._createWidget.apply(this, arguments);
			$.ui.igPopover.prototype._createWidget.apply(this, arguments);
			this._detachEventsFromTarget();
			$targetButton = this.options.targetButton;
			if (this.options.closeOnBlur) {
				$targetButton.attr('tabindex', '0');
				this._eventsFC = {
					'iggridfeaturechooserpopovershown': function (events, args) {
						self._setFCElementFocus(true);
					}, 
					'iggridfeaturechooserpopoverhidden': function (events, args) {
						self._setFCElementFocus(false);
						// M.H. 26 Sep 2013 Fix for bug #150389: Feature chooser is not properly shown when browser window is scrolled left
						self.popover.width('');
						self.popover.css({'left': ''});
					},
					'mousedown': function (event) {
						setTimeout( function () {
							self._setFCElementFocus(true);
						}, 1);
					},
					'touchstart': function () {
						setTimeout( function () {
							self._setFCElementFocus(true);
						}, 1);
					}
				};
				this.element.bind(this._eventsFC);
				this.registerElements($targetButton);
			}
		},
		_positionPopover: function ( trg ) {
			var $popover, w = this.popover.outerWidth(),
				availableWidth, top, left, rOffset,
				mw = this.options.maxWidth,
				$containment = this.options.containment,
				$window = $(window);
			// M.H. 26 Sep 2013 Fix for bug #150389: Feature chooser is not properly shown when browser window is scrolled left
			if (mw && mw < w) {
				w = mw;
			}
			$popover = this.popover;
			// M.H. 3 Oct 2013 Fix for bug #153973: When grid's width is 300px the feature chooser is not rendered correctly.
			if ($popover) {
				// M.H. 8 Nov 2013 Fix for bug #153482: Feature chooser is not properly rendered when widow is resized
				if ($containment.offset().left >= $window.scrollLeft()) {
					availableWidth = $window.width() + $window.scrollLeft() - $containment.offset().left;
				} else {
					availableWidth = $window.width();
				}
				if (w > availableWidth) {
					w = parseInt(availableWidth, 10);
				}
				this.popover.width(w);
			}
			$.ui.igPopover.prototype._positionPopover.apply(this, arguments);
			// M.H. 26 Sep 2013 Fix for bug #150389: Feature chooser is not properly shown when browser window is scrolled left
			$popover.width(w);
            top = parseFloat($popover.css('top'));
            left = parseFloat($popover.css('left'));
            if (this._attachedToBody) {
                $popover.detach().appendTo($containment);
                this._attachedToBody = false;
            }
            rOffset = $.ig.util.getRelativeOffset($popover);
            if (!isNaN(top)) {
                $popover.css("top", (top - rOffset.top));
            }
            if (!isNaN(left)) {
                $popover.css("left", (left - rOffset.left));
            }
		},
		destroy: function () {
			var $targetButton;

			if (this._eventsFCTargetButton) {
				$targetButton = this.options.targetButton;
				$targetButton.unbind(this._eventsFCTargetButton);
			}
			if (this._eventsFC) {
				this.element.unbind(this._eventsFC);
			}
			$.ui.igPopover.prototype.destroy.apply(this, arguments);
		}
	});
	$.extend($.ui.igGridFeatureChooserPopover, { version: '14.1.20141.2249' });
	$.ig = $.ig || {};
	$.ig.GridFeatureChooserSections = $.ig.GridFeatureChooserSections || {
		click: "click",
		toggle: "toggle",
		modalDialog: "modalDialog"
	};

	$.widget("ui.igGridFeatureChooser", {
		/* igGridSummaries widget -  The widget is pluggable to the element where the grid is instantiated and the actual igGrid object doesn't know about this			
		*/
		/* the instance of the grid to which this feature is going to attach its functionality */
		css: {
			featureChooserDropDown: '',
			headerButtonIcon: 'ui-iggrid-featurechooserbutton ui-icon ui-icon-gear',
			headerButtonIconMouseOver: 'ui-iggrid-header-icon-mouseover',
			headerButtonIconSelected: 'ui-iggrid-header-icon-selected',
			listClass: 'ui-iggrid-featurechooser-list ui-menu ui-widget ui-widget-content ui-corner-all',
			listItemClass: 'ui-iggrid-featurechooserddlistitemicons ui-state-default',
			listItemContainer: 'ui-iggrid-featurechooser-li-container',
			listItemIconContainer: 'ui-iggrid-featurechooser-li-iconcontainer',
			itemSecondaryIconContainer: 'ui-iggrid-featurechooser-secondaryicon-container',
			separator: 'ui-iggrid-featurechooser-separator',
			listItemText: 'ui-iggrid-featurechooserddlistitemtext',
			itemSelected: "item-selected",
			dropDownListItemHover: 'ui-iggrid-featurechooser-listitem-hover ui-state-active ui-state-hover',
			dropDownButtonClasses: "ui-igbutton",
			dropDownButtonHoverClasses : "",
			dropDownButtonActiveClasses : "", // when button is clicked 
			dropDownButtonFocusClasses : "", // when button get focus
			dropDownButtonLabelClass : "",
			containerDelimiter: 'ui-iggrid-featurechooser-container-delimiter',
			containerSection: 'ui-iggrid-featurechooser-container-section',
			itemNoIcon: 'ui-iggrid-featurechooserbutton ui-icon ui-icon-close',
			submenu: 'ui-iggrid-featurechooser-submenu ui-widget-content ui-corner-all',
			submenuIcon: 'ui-iggrid-featurechooser-submenuicon ui-icon ui-icon-triangle-1-s'
		},
		options: {
			dropDownWidth: null,
			animationDuration: 400
		},
		events: {
			featureChooserRendering: 'featureChooserRendering',
			featureChooserRendered: 'featureChooserRendered',
			featureChooserDropDownOpening: 'featureChooserDropDownOpening',
			featureChooserDropDownOpened: 'featureChooserDropDownOpened',
			menuToggling: 'menuToggling',
			featureToggling: 'featureToggling',
			featureToggled: 'featureToggled'
		},
		_createWidget: function (options, element) {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			//this.options.columnSettings = [];
			$.Widget.prototype._createWidget.apply(this, arguments);
		},

		_create: function () {
			this.analyzedData = {};
			this.data = {};

			this._features = [];
			this._isFeaturesAnalyzed = false;

			this.isInitialized = false;
			this.grid = this.element.data('igGrid');
			this.gridId = this.element[0].id;

			this._analyzeGridFeaturesOptions();
			this._countRenderedFeatures = 0;
			// M.H. 19 Dec 2013 Fix for bug 158542: Memory Leak in IE8 when calling dataBind
			if (this._headerRenderedHandler) {
				this.grid.element.unbind('iggridheaderrendered', this._headerRenderedHandler);
			}
			this._headerRenderedHandler = $.proxy(this._headerRendered, this);
			this.grid.element.bind('iggridheaderrendered', this._headerRenderedHandler);
			// M.H. 19 Dec 2013 Fix for bug 158542: Memory Leak in IE8 when calling dataBind
			if (this._gridDestroyedHandler) {
				this.grid.element.unbind('igcontroldestroyed', this._gridDestroyedHandler);
			}
			// M.H. 29 Oct 2012 Fix for bug #120642
			this._gridDestroyedHandler = $.proxy(this.destroy, this);
			this.grid.element.bind('igcontroldestroyed', this._gridDestroyedHandler);
		},
		_analyzeGridFeaturesOptions: function () {
			/* analyze features and push those which are defined in grid element */
			var i,
				features = this.grid.options.features,
				featuresLength = features.length;

			for (i = 0; i < featuresLength; i++) {
				this._features.push(features[i].name);
			}
		},
		shouldShowFeatureIcon: function (key) {
			if (this.analyzedData[key] !== undefined && this.analyzedData[key] !== null) {
				return (this.analyzedData[key].length <= 1);
			}

			return true;
		},
		_setOption: function (key, value) {
			// handle new settings and update options hash
			$.Widget.prototype._setOption.apply(this, arguments);
		},
		_id: function (name, suffix) {
			var res = this.gridId + '_' + name;
			if (suffix !== undefined && suffix !== null && $.type(suffix) === 'string') {
				res += '_' + suffix;
			}
			return res;
		},
		_isMetroIE: function () {
			return (('ontouchstart' in window) || (navigator.MaxTouchPoints > 0) || (navigator.msMaxTouchPoints > 0));
		},
		_isTouchDevice: function () {
			var fcIconDisplay;
			if (this._isTouch === undefined) {
				fcIconDisplay = this.grid.options.featureChooserIconDisplay;
				if (fcIconDisplay === 'none') {
					this._isTouch = true;
				} else if (fcIconDisplay === 'always') {
					this._isTouch = false;
				} else {
					this._isTouch = (typeof Modernizr === "object" && Modernizr.touch === true) ||
						this._isMetroIE();
				}
			}
			return this._isTouch;
		},
		_callFeatureMethod: function (feature, isSelected, columnKey, event) {
			// if callback feature function returns false(for instance in column fixing it is cancelled) then it should return false and feature chooser should not be updated
			var method,
				returnType = true,
				methodType = $.type(feature.method),
				featureData = this.grid.element.data('igGrid' + feature.name);

			if (methodType === 'string') {
				if (featureData === undefined || featureData === null) {
					return false;
				}
				method = featureData[feature.method];
			} else if (methodType === 'function') {
				method = feature.method;
			}

			if (method === undefined || method === null) {
				return false;
			}

			// the event should be called from button - e.g. in filtering it tries to get column cell - 
			// which is parent of the target element
			// M.H. 10 Jun 2013 Fix for bug #144214: The "Fix Column" option changes even when column fixing is refused.
			if ($.type(feature.method) === 'string') {
				returnType = featureData[feature.method](event, columnKey, isSelected, feature.methodData);
			} else {
				returnType = feature.method(event, columnKey, isSelected, feature.methodData);
			}
			return returnType;
		},
		_getFeatureByKeyName: function (columnKey, featureName) {
			var i,
				feature = null,
				columnData = this.data[columnKey],
				columnDataLength;
			
			if (!columnData) {
				return feature;
			}
			columnDataLength = columnData.length;
			for (i = 0; i < columnDataLength; i++) {
				if (columnData[i].name === featureName) {
					feature = columnData[i];
					break;
				}
			}

			return feature;
		},
		_clickFeature: function (event) {
			var i, j,
				$target = ($(event.target).data('data') !== undefined) ? $(event.target) : $(event.currentTarget),
				d = $target.data('data'),
				self = this,
				isSelected = null,
				type = d.type,
				columnKey = d.columnKey,
				featureName = d.featureName,
				columnData = this.data[columnKey],
				columnDataLength = columnData.length,
				feature = null;


			feature = this._getFeatureByKeyName(columnKey, featureName);
			if (feature === null || feature === undefined) {
				return;
			}
			// M.H. 23 Jul 2013 Fix for bug #144214: The "Fix Column" option changes even when column fixing is refused.
			if (type === 'toggle') {
				isSelected = !feature.isSelected;
			}
			if (this._trigger(
					this.events.featureToggling,
					null,
					{
						target: $target,
						columnKey: columnKey,
						isToSelect: isSelected,
						featureName: 'igGrid' + feature.name
					}
				) === false) {
				return;
			}
			if (this._callFeatureMethod(feature, isSelected, columnKey, event) === false) {
				return;
			}
			// when updateOnClickAll is true AND isOnBottom is <> true then
			// update the state of this feature in the other feature chooser dropdowns
			if (type === 'toggle') {
				// M.H. 23 Jul 2013 Fix for bug #144214: The "Fix Column" option changes even when column fixing is refused.
				feature.isSelected = isSelected;
				self._setSelectedItem(
					columnKey,
					isSelected,
					$('#' + self._id('featurechooser_dd_li_' + columnKey, featureName))
				);

				if (feature.updateOnClickAll === true) {
					$.each(self.data, function (index, value) {
						if (index !== columnKey) {
							for (j = 0; j < value.length; j++) {
								if (value[j].name === featureName) {
									break;
								}
							}
							if (j === value.length) {
								return true;
							}

							// update isSelected property for other columns specified feature
							columnData = self.data[index];
							if (columnData === null || columnData === undefined) {
								return true;
							}
							columnDataLength = columnData.length;

							for (i = 0; i < columnDataLength; i++) {
								if (columnData[i].name === featureName) {
									columnData[i].isSelected = isSelected;
									break;
								}
							}

							self._setSelectedItem(
								index,
								isSelected,
								$('#' + self._id('featurechooser_dd_li_' + index, value[j].name))
							);
						}
					});
				}
			}
		},
		_setListItemText: function (columnKey, featureName, text) {
			// M.H. 20 March 2012 Fix for bug #105270
			$('#' + this._id('featurechooser_dd_li_' + columnKey, featureName) + ' span.ui-iggrid-featurechooserddlistitemtext').text(text);
		},
		_analyzeFeatures: function () {
			if (this._isFeaturesAnalyzed === true) {
				return;
			}

			var i, k,
				cs = this.grid.options.columns,
				csLength = cs.length,
				featureName,
				featuresLength = this._features.length,
				features = this._features,
				newFeatures = [],
				columnsFeature,
				columnsFeatureLength,
				featureInstance,
				columnKey;

			for (i = 0; i < featuresLength; i++) {
				featureName = features[i];
				featureInstance = this.grid.element.data('igGrid' + featureName);

				if (featureInstance === undefined || featureInstance === null) {
					continue;
				}

				if (featureInstance.renderInFeatureChooser !== true) {
					continue;
				}

				if (featureInstance._columnMap === undefined || featureInstance._columnMap === null) {
					continue;
				}

				columnsFeature = featureInstance._columnMap();
				if (columnsFeature === false || columnsFeature === null || columnsFeature === undefined) {
					// there is no column settings for specified feature
					continue;
				}

				columnsFeatureLength = columnsFeature.length;
				if (columnsFeatureLength === 0) {
					// feature should be shown in all columns
					for (k = 0; k < csLength; k++) {
						columnKey = cs[k].key;
						if (this.analyzedData[columnKey] === undefined || this.analyzedData[columnKey] === null) {
							this.analyzedData[columnKey] = [];
						}

						if (this._isFeatureExistByColumnKey(featureName, columnKey) === true) {
							continue;
						}
						this.analyzedData[columnKey].push(
							{
								name: featureName,
								method: null,
								text: null,
								iconClass: null,
								isSelected: false,
								columnCell: null,
								isActive: false
							}
						);
					}
				} else {
					for (k = 0; k < columnsFeatureLength; k++) {
						columnKey = columnsFeature[k].columnKey;
						if (this.analyzedData[columnKey] === undefined ||
								this.analyzedData[columnKey] === null) {
							this.analyzedData[columnKey] = [];
						}

						if (columnsFeature[k].enabled !== true || this._isFeatureExistByColumnKey(featureName, columnKey) === true) {
							continue;
						}

						this.analyzedData[columnKey].push(
							{
								name: featureName,
								method: null,
								text: null,
								iconClass: null,
								isSelected: false,
								columnCell: null,
								isActive: false
							}
						);
					}
				}
				newFeatures.push({name: featureName, instance: featureInstance});
			}

			this._features = newFeatures;
			this._isFeaturesAnalyzed = true;
		},
		_isFeatureExistByColumnKey: function (featureName, columnKey) {
			var aData = this.analyzedData[columnKey], ret = false;

			if (aData === null || aData === undefined) {
				return true;
			}

			$.each(aData, function (index, value) {
				if (value.name === featureName) {
					ret = true;
					return false;
				}
			});

			return ret;
		},
		_shouldRenderInFeatureChooser: function (columnKey) {
			// it is called only for the first time when _shouldRenderInFeatureChooser
			this._analyzeFeatures();

			if (this.analyzedData[columnKey] !== undefined && this.analyzedData[columnKey] !== null) {
				return this.analyzedData[columnKey].length > 1;
			}
			return false;
		},
		_headerRendered: function (sender, args) {
			//prevent handling of other grids' events in the case of hierarchical grid
			if (args.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}
			if (sender.target.id !== this.grid.element[0].id) {
				return;
			}
			var self = this;
			$.each(this.data, function (columnKey, elem) {
				self._initFC(columnKey, elem);
			});

		},
		_touchStart: function (e, columnKey) {
			// M.H. 10 Sep 2013 Fix for bug #151643: When you tap on a hiding indicator feature chooser opens and then hiding dropdown on a mobile device.
			if ($(e.target).attr('data-skip-event')) {
				return e;
			}
			this.toggleDropDown(columnKey);
			e.preventDefault();
			e.stopPropagation();
		},
		_initFC: function (columnKey, elem) {
			var self = this,
				thead = this.grid.container().find('thead'),
				$columnCell,
				$theadCell,
				buttonId,
				cancelFunc,
				$button,
				$headerContainer;

			$columnCell = $('#' + self.grid.element[0].id + '_' + columnKey);
			buttonId = self._id('featureChooser_headerButton', columnKey);
			cancelFunc = function (e) { e.preventDefault(); e.stopPropagation(); };
			// Cancel rendering is fired only when features are not rendered in feature chooser. 
			// Otherwise this means some features are rendered and then rendering of feature chooser is canceled
			if (elem.isCancelledRendering !== false &&
					self._trigger(self.events.featureChooserRendering,
										null,
										{owner: self.grid, columnKey: columnKey, columnCell: $columnCell}) === false) {
				elem.isCancelledRendering = true;
				return;
			}
			elem.isCancelledRendering = false;
			if (this._isTouchDevice()) {
				// M.H. 9 Sep 2013 Fix for bug #151657: Tapping on fixed column's header does not open the feature chooser on Ipad.
				// this is a hack for MS Surface devices - we should use bind instead of live
				// M.H. 16 Sep 2013 Fix for bug #152244: Grid is not shown and js error is thrown when it is used 1.7.2+ jQuery version and FeatureChooser should be shown
				$columnCell.bind({
					click: function (e) {
						self._touchStart(e, columnKey);
					}
				});
			} else {
				$theadCell = thead.find('#' + self.grid.element[0].id + '_' + columnKey);
				this.grid._enableHeaderCellFeature($theadCell);
				$headerContainer = $theadCell.find('.ui-iggrid-indicatorcontainer');
					// it is not set container for feature chooser in the header

				if ($headerContainer.length === 0) {
					$headerContainer = $('<div></div>')
						.appendTo($theadCell)
						.addClass('ui-iggrid-indicatorcontainer');
				}
				$button = $('<span></span>').prependTo($headerContainer).addClass(self.css.headerButtonIcon);
				$button.wrap('<a id="' + buttonId + '" href="#" title=""></a>');
				// M.H. 22 March 2012 Fix for bug #105757
				$button.parent()
					.attr('th-remove-focus', '')
					.bind({
					// M.H. 22 March 2012 Fix for bug #105783
						keydown: function (event) {
							var $item, $nextPrevItem, $dialog = $('#' + self._id('featureChooser_dd', columnKey));

							if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
								$item = $dialog.find('ul li.ui-iggrid-featurechooser-listitem-hover');
								if ($dialog.is(':visible') && $item.length > 0) {
									if ($item.find('*[role="button"]').length) {
										event.target = $item.find('*[role="button"]:eq(0)');
									} else {
										event.target = $item[0];
									}
									self._clickFeature(event);
								}
								self.toggleDropDown(columnKey);
								cancelFunc(event);
							} else if (event.keyCode === $.ui.keyCode.DOWN || event.keyCode === $.ui.keyCode.UP) {
								if ($dialog.is(':visible')) {
									$item = $dialog.find('ul li.ui-iggrid-featurechooser-listitem-hover');
									if ($item.length > 1) {
										$.each($item, function (index, value) {
											self._removeCssSelectionListItem($(value));
										});
									}
									$nextPrevItem = ((event.keyCode === $.ui.keyCode.DOWN) ? $item.next() : $item.prev());
									if ($nextPrevItem.attr('data-fc-separator')) {
										$nextPrevItem = ((event.keyCode === $.ui.keyCode.DOWN) ? $nextPrevItem.next() : $nextPrevItem.prev());
									}
									if ($item.length === 0) {
										self._addCssSelectionListItem($dialog.find('ul li:eq(0)'));
									} else if ($nextPrevItem.length > 0 && $nextPrevItem.is('li')) {
										self._removeCssSelectionListItem($item);
										self._addCssSelectionListItem($nextPrevItem);
									}
									cancelFunc(event);
								}
							}
						},
						mousedown: function (event) {
							self.toggleDropDown(columnKey);
							cancelFunc(event);
						},
						mouseover: function (event) {
							if ($button.hasClass(self.css.headerButtonIconSelected) === false) {
								$button.addClass(self.css.headerButtonIconMouseOver);
							}
						},
						mouseout: function (event) {
							$button.removeClass(self.css.headerButtonIconMouseOver);
						},
						mouseup: cancelFunc,
						click: cancelFunc
					});
				// M.H. 20 Feb 2013 Fix for bug #132371: Hierarchical grid - can not hide a column on a child layout
				// we should remove dropdown containers - we should clear inner data with grid reference otherwise in child layout it is save the "old" reference
				$('#' + this._id('featureChooser_dd', columnKey)).remove();
			}
			self._trigger(
				self.events.featureChooserRendered,
				null,
				{owner: self.grid, columnKey: columnKey, columnCell: $columnCell}
			);
		},
		_renderInFeatureChooser: function (columnKey, data) {
			// render icon of the feature widget ONLY if it the column key exists in the analyzed data with keys
			var i,
				columnData = this.analyzedData[columnKey],
				columnDataLength;

			if (columnData === undefined || columnData === null) {
				// question: throw exception or just return
				return;
			}

			columnDataLength = columnData.length;
			if (columnData.isCancelledRendering === true) {
				return;
			}

			for (i = 0; i < columnDataLength; i++) {
				if (columnData[i].name.toLowerCase() === data.name.toLowerCase()) {
					this.analyzedData[columnKey][i] = data;
					break;
				}
			}

			if (i === columnDataLength) {
				this.analyzedData[columnKey].push(data);
			}


			if (this.data[columnKey] === null || this.data[columnKey] === undefined) {
				this.data[columnKey] = [];
			}
			if ($.type(this.data[columnKey].order) !== 'number') {
				this.data[columnKey].order = 0;
			}

			// check whether for this columnKey it is already registered this feature
			// example when autoGenerateColumns is true - _renderInFeatureChooser method is called twice for each feature
			for (i = 0; i < this.data[columnKey].length; i++) {
				if (this.data[columnKey][i].name === data.name && data.name !== undefined) {
					return;
				}
			}
			this.data[columnKey].push(data);
        },
        _renderMenu: function (columnKey) {
            var i, data, self = this,
                listItems,
                popoverInstance,
                $targetButton,
                $headerCell = $('#' + this.grid.id() + '_' + columnKey),
                dropDownId = this._id('featureChooser_dd', columnKey),
                $dropDown = $('#' + dropDownId);
            if ($dropDown.length > 0) {
                return;
            }
            // check whether dropdown container is initialized and if not - initialize
            $dropDown = $('<div tabindex="0"></div>')
                .attr('id', dropDownId)
                //.css({'position': 'absolute', 'display': 'none'})
                .appendTo(this.grid._rootContainer());
            $targetButton = $('#' + this._id('featureChooser_headerButton', columnKey)).find("span");
            if ($targetButton.length === 0) {
                $targetButton = $headerCell;
            }
            // M.H. 25 Sep 2013 Fix for bug #153407: FC is positioned according to the header cell but the arrow is positioned next to the gearbox
            $dropDown.igGridFeatureChooserPopover({
            // T.G. 15 Jan 2014 Fix for bug 161249 - Target option is not needed because the user expects it to be the element on which the popover is initialized
            // target: $targetButton,
                position: 'auto',
                targetButton: $targetButton,
                maxWidth: this.grid.container().width(),
                direction: 'bottom',
                maxHeight: null,
                containment: this.grid.container()
            });
            popoverInstance = $dropDown.data('igGridFeatureChooserPopover');
            //popoverInstance.container().attr('tabindex', '0');
            $dropDown.bind('iggridfeaturechooserpopovershown', function (events, args) {
                self._visiblePopover = dropDownId;
                //popoverInstance.container().focus().data('onFocus', true);
            });
            $dropDown.bind('iggridfeaturechooserpopoverhiding', function (events, args) {
                if (self._activeSubmenuId) {
                    $('#' + self._activeSubmenuId).hide();
                    self._activeSubmenuId = null;
                }
                //$dropDown.find('[data-submenu]').hide();
                //popoverInstance.container().focus().data('onFocus', true);
            });
            data = this.data[columnKey];
            
            if (data) {
                for (i = 0; i < data.length; i++) {
                    this._renderDropDownItem(columnKey, data[i]);
                }
                listItems = popoverInstance.container().find('li[data-fc-order]');
                $dropDown.igGridFeatureChooserPopover('registerElements', listItems);
                $targetButton.bind({
                    keydown: function (e) {
                        if (e.keyCode === $.ui.keyCode.ESCAPE) {
                            popoverInstance._closePopover();
                        } else if (e.keyCode === $.ui.keyCode.TAB &&
                                !e.shiftKey && 
                                popoverInstance.isShown()) {
                            popoverInstance.popover.find('li[data-fc-order]:first').focus();
                            e.stopPropagation();
                            e.preventDefault();
                        }
                    }
                });
                listItems.bind({
                    keydown: function (e) {
                        var $elem, keyCode = e.keyCode;

						switch(keyCode) {
							case $.ui.keyCode.ESCAPE:
								$targetButton.data('onFocus', false).focus();
								popoverInstance._closePopover();
								break;
							case $.ui.keyCode.TAB:
								$elem = $(this);
								if (!e.shiftKey) {
									if ($elem.is(':last-child')) {
										$elem.closest('ul').find('li:first-child').focus();
										e.preventDefault();
									}
									//e.stopPropagation();
								} else {
									if ($elem.is(':first-child')) {
										$elem.closest('ul').find('li:last-child').focus();
										e.preventDefault();
									}
								}
								break;
							case $.ui.keyCode.RIGHT:
								$elem = $(this);
								$elem = $elem.nextAll('li[data-fc-order]').eq(0);
								if ($elem.length === 0) {
									$elem = $(this).closest('ul').find('li:first-child');
								}
								$elem.focus();
								e.preventDefault();
								break;
							case $.ui.keyCode.LEFT:
								$elem = $(this);
								$elem = $elem.prevAll('li[data-fc-order]').eq(0);
								if ($elem.length === 0) {
									$elem = $(this).closest('ul').find('li:last-child');
								}
								$elem.focus();
								e.preventDefault();
								break;
						}
					}
				});
			}
			$dropDown.bind({
				keydown: function (event) {
					if (event.keyCode === $.ui.keyCode.ESCAPE && popoverInstance.container().is(':visible')) {
						self.toggleDropDown(columnKey);
						popoverInstance.container().blur();
					}
				}
			});
			//this._clearSections($dropDown);
		},
		_removeFeature: function (featureName, submenu) {
			var self = this, cols = this.grid.options.columns;

			$.each(cols, function (index, col) {
				self._removeDropDownItem(col.key, featureName);
				if (submenu) {
					$('#' + self._id('featurechooser_submenu_' + col.key, featureName)).remove();
				}
			});
		},
		_removeDropDownItem: function (columnKey, featureName) {
			var index = -1, data, $dropDown = $('#' + this._id('featureChooser_dd', columnKey)),
				$dropDownList = $('#' + this._id('featurechooser_dd_list', columnKey)),
				$item = $('#' + this._id('featurechooser_dd_li_' + columnKey, featureName));
			
			if ($dropDown.length === 0) {
				data = this.data[columnKey];
				if (data) {
					$.each(data, function (i, dataItem) {
						if (dataItem.name === featureName) {
							index = i;
							return false;
						}
					});
					if (index > -1) {
						data.splice(index, 1);
						if (data.length === 0) {
							this._removeFC(columnKey);
						}
					}
				}
				return;
			} else if ($item.length > 0) {
				$item.remove();
				if ($dropDownList.find('li:not([data-fc-separator])').length === 0) {
					this._removeFC(columnKey);
				} else {
					this._removeSeparatorItem(columnKey);
				}
			}
		},
		_removeFC: function (columnKey) {
			var  $dropDown = $('#' + this._id('featureChooser_dd', columnKey));

			$dropDown.igGridFeatureChooserPopover('destroy');
			$dropDown.remove();
			$('#' + this._id('featureChooser_headerButton', columnKey)).remove();
		},
		_removeSeparatorItem: function (columnKey) {
			var listLiSeparator = $('#' + this._id('featurechooser_dd_list', columnKey)).find('[data-fc-separator]');
				
			listLiSeparator.each(function (index) {
				var $li = $(this), 
					$prevLi = $li.prev(),
					$nextLi = $li.next();
				if ($prevLi.length === 0 || $prevLi.attr('data-fc-separator') !== undefined ||
					$nextLi.length === 0 || $nextLi.attr('data-fc-separator') !== undefined) {
					$li.remove();
					return false;
				}
			});
		},
		_renderDropDownItem: function (columnKey, data) {
			var dropDownId = this._id('featureChooser_dd', columnKey),
				$dropDownContainer = $('#' + dropDownId).igGridFeatureChooserPopover('container'),
				$li, listId, $list,
				funcClickOnFeature,
				$iconContainer, $span,
				cssClassIcon = '',
				self = this,
				isSelected = data.isSelected,
				featureName = data.name,
				innerData,
				liId = this._id('featurechooser_dd_li_' + columnKey, featureName),
				groupName = data.groupName,
				groupOrder = data.groupOrder,
				listItemsGroup,// items which belongs to specific group (or does not belong to any group)
				insertElementObj,
				labelText;

			// M.H. 10 Oct. 2011 Fix for bug #89870
			if ($('#' + liId).length > 0) {
				return;
			}
			if (groupName === undefined || groupName === null) {
				groupName = 'click';
			}
			listId = this._id('featurechooser_dd_list', columnKey);
			$list = $('#' + listId);
			if ($list.length === 0) {
				$dropDownContainer.html('');
				$list = $('<ul></ul>')
						.attr('id', listId)
						.addClass(this.css.listClass)
						.appendTo($dropDownContainer);
			}
			// for instance default behavior for buttons is to be rendered on bottom of the list
			if (isSelected === undefined || isSelected === null) {
				isSelected = false;
			}
			$li = $('<li tabindex="0"></li>')
					.addClass(this.css.listItemClass)
					.attr('id', liId)
					.attr('data-fc-order', data.order);
			if (groupName !== undefined && groupName !== null) {
				$li.attr('data-fc-groupname', groupName);
			}
			if (groupOrder !== undefined && groupOrder !== null) {
				$li.attr('data-fc-grouporder', groupOrder);
			}
			innerData = {
				columnKey: columnKey,
				featureName: featureName,
				updateOnClickAll: data.updateOnClickAll,
				iconClass: data.iconClass,
				iconClassOff: data.iconClassOff,
				groupName: groupName,
				groupOrder: groupOrder,
				type: data.type,
				textHide: data.textHide,
				state: data.state,
				text: data.text
			};
			$li.data('data', innerData);
			funcClickOnFeature = function (event) {
				var submenuId = self._id('featurechooser_submenu_' + columnKey, featureName),
					e = event,
					$submenu,
					keyCode = event.keyCode;

				if (data.type !== 'dropdown') {
					if (!keyCode || keyCode === $.ui.keyCode.ENTER || keyCode === $.ui.keyCode.SPACE) {
						if (event.target === undefined) {
							e.target = event.srcElement;
						}
						self._clickFeature(event);
						self.hideDropDown(columnKey);
					}
				} else {
					// M.H. 23 Oct 2013 Fix for bug #155672: The Column Moving submenu in Feature Chooser does not open in IE8.
					if (self._visiblePopover) {
						if (!keyCode) {
							self._toggleSubmenu(columnKey, featureName, data);
							setTimeout(function () {
								$('#' + self._visiblePopover).data('igGridFeatureChooserPopover')._setFCElementFocus(true);
							}, 5);
						} else {
							if (keyCode === $.ui.keyCode.DOWN) {
								$submenu = $('#' + submenuId);
								if ($submenu.is(':visible')) {
									$submenu.find('[data-fc-item]:first').focus();
								} else {
									self._toggleSubmenu(columnKey, featureName, data);
								}
							} else if (keyCode === $.ui.keyCode.ENTER || keyCode === $.ui.keyCode.SPACE) {
								self._toggleSubmenu(columnKey, featureName, data);
							} else if (keyCode === $.ui.keyCode.UP) {
								$submenu = $('#' + submenuId);
								if ($submenu.is(':visible')) {
									self._toggleSubmenu(columnKey, featureName, data);
								}
							}
						}
					}
					// M.H. 26 Sep 2013 Fix for bug #153462: Clicking on "Move To" icon in feature chooser causes FC to hide
					//event.stopPropagation();
					if (event.preventDefault) {
						event.preventDefault();
					}
				}
			};
			$li.bind({
				keydown: funcClickOnFeature,
				mousedown: funcClickOnFeature
			});
			if (data.iconClass !== null && data.iconClass !== undefined && data.iconClass !== '') {
				if (data.iconClassOff && data.isSelected === false) {
					cssClassIcon = data.iconClassOff;
				} else {
					cssClassIcon = data.iconClass;
				}
			}
			$iconContainer = $('<div></div>').addClass(this.css.listItemContainer).appendTo($li);
			$span = $('<span></span>').addClass(this.css.listItemIconContainer).appendTo($iconContainer);
			if (cssClassIcon !== '') {
				$span.addClass(cssClassIcon);
			} else {
				$span.addClass(this.css.itemNoIcon);
			}
			labelText = data.text;
			$li.attr('title', labelText);
			$('<span></span>').text(data.text).addClass(this.css.listItemText).appendTo($iconContainer);
			// order by groups
			listItemsGroup = $('#' + listId + ' li[data-fc-groupName = ' + groupName + ']');
			if (listItemsGroup.length === 0) {
				// we should add such group
				// first we should find its position - where to insert
				listItemsGroup = $('#' + listId + ' li[data-fc-groupName]');
				insertElementObj = this._getInsertElement(listItemsGroup, groupOrder, 'data-fc-grouporder');
				if (insertElementObj.item !== null) {
					$list = listItemsGroup;
				}
				this._insertElement(insertElementObj, $list, $li, groupName);
			} else {
				// we should find the correct position of element inside the group
				insertElementObj = this._getInsertElement(listItemsGroup, data.order, 'data-fc-order');
				this._insertElement(insertElementObj, listItemsGroup, $li, groupName);
			}
			if (data.type === 'toggle') {
				this._setSelectedItem(columnKey, data.isSelected, $li);
			}
			if (data.type === 'dropdown') {
				$('<span class="' + this.css.submenuIcon + '" data-submenu-arrow="true"></span>').appendTo($iconContainer);
				self._renderSubmenu(columnKey, featureName, data);
			}
		},
		_renderSubmenu: function (columnKey, featureName, data) {
			var submenuId = this._id('featurechooser_submenu_' + columnKey, featureName),
				$submenu;

			if ($('#' + submenuId).length > 0) {
				$('#' + submenuId).remove();
			}
			if (this._submenus === null || this._submenus === undefined) {
				this._submenus = [];
			}
			this._submenus.push(submenuId);
			$submenu = $('<div id="' + submenuId + '" style="position:absolute" class="' + this.css.submenu + '"></div>')
				.appendTo(this.grid._rootContainer());
			$submenu.data('buttonId', this._id('featurechooser_dd_li_' + columnKey, featureName));
			$submenu.hide();
			if (data.methodRenderSubmenu) {                
				data.methodRenderSubmenu(columnKey, $submenu);
				$('#' + this._id('featureChooser_dd', columnKey))
					.igGridFeatureChooserPopover('registerElements', $submenu.find('[data-fc-item]'));
			}
		},
		_toggleSubmenu: function (columnKey, featureName, data) {
			var rOffset, $li = $('#' + this._id('featurechooser_dd_li_' + columnKey, featureName)),
				$innerDiv = $li.find('div:nth-child(1)'),
				targetWidth = $innerDiv.outerWidth(),
				targetLeft = $innerDiv.offset().left,
				submenuId = this._id('featurechooser_submenu_' + columnKey, featureName),
				$submenu = $('#' + submenuId),
                left = targetLeft - (Math.abs($submenu.outerWidth() - targetWidth) / 2),
                top = $innerDiv.offset().top + $innerDiv.outerHeight();

			// we should position submenu
			rOffset = $.ig.util.getRelativeOffset($submenu);
            // we should position submenu
            $submenu.css({
                'left': left - rOffset.left,
                'top': top - rOffset.top
            });
			if (data.methodToggleSubmenu) {
				data.methodToggleSubmenu(columnKey, !$submenu.is(':visible'), $submenu);
			}
			if (this._activeSubmenuId && this._activeSubmenuId !== submenuId) {
				$('#' + this._activeSubmenuId).hide();
			}
			this._activeSubmenuId = submenuId;
			// show/hide submenu
			$submenu.toggle(
				'slide',
				{
					duration: 150,
					direction: 'up'
				}
			);
		},
		_getSeparatorItem: function () {
			return $('<li data-fc-separator="1" class="' + this.css.separator + '"></li>');
		},
		_insertElement: function (insertElementObj, $list, $li, groupName) {
			// insert element $li at the correct position in $list
			// insertElementObj - the element before/after the element $li should be inserted - if null insert it at the end of $list
			// groupName - name of the Group of $li
			var $insertElement = insertElementObj.item,
				insertElementPosition = insertElementObj.position,
				$prevElement;

			if ($insertElement === null) {
				$li.appendTo($list);

				// check for separator UP
				$prevElement = $li.prev();
				if ($prevElement !== undefined &&
						$prevElement.length > 0 &&
						$prevElement.attr('data-fc-separator') !== '1' &&
						$prevElement.attr('data-fc-groupname') !== undefined &&
						$prevElement.attr('data-fc-groupname') !== groupName) {
					// add separator
					this._getSeparatorItem().insertBefore($li);
				}
			} else {
				if (insertElementPosition === 'after') {
					$li.insertAfter($insertElement);
					// check for separator UP
					if ($insertElement !== undefined &&
							$insertElement.length > 0 &&
							$insertElement.attr('data-fc-separator') !== '1' &&
							$insertElement.attr('data-fc-groupname') !== undefined &&
							$insertElement.attr('data-fc-groupname') !== groupName) {
						// add separator
						this._getSeparatorItem().insertBefore($li);
					}
				} else {
					$li.insertBefore($insertElement);
					$prevElement = $li.prev();
					// check for separator UP
					if ($prevElement !== undefined &&
							$prevElement.length > 0 &&
							$prevElement.attr('data-fc-separator') !== '1' &&
							$prevElement.attr('data-fc-groupname') !== undefined &&
							$prevElement.attr('data-fc-groupname') !== groupName) {
						// add separator
						this._getSeparatorItem().insertBefore($li);
					} else if ($insertElement !== undefined &&
							$insertElement.length > 0 &&
							$insertElement.attr('data-fc-separator') !== '1' &&
							$insertElement.attr('data-fc-groupname') !== undefined &&
							$insertElement.attr('data-fc-groupname') !== groupName) {
						// add separator
						this._getSeparatorItem().insertAfter($li);
					}

				}
			}
		},
		_getInsertElement: function (listItems, targetOrder, attr) {
			// return from list of items object which is of type {item: $item, position: pos}
			// where $item is jQuery wrapped DOM element or NULL
			// if $item is null insert at the beginning of the list
			// if $item is NOT null then if pos is:
			// 'before' insert element before $item
			// 'after' insert element after $item
			var $item = null, itemOrder, at, i;

			for (i = 0; i < listItems.length; i++) {
				$item = $(listItems[i]);
				at = $item.attr(attr);

				if (at === undefined) {
					continue;
				}
				itemOrder = parseInt(at, 10);
				if (itemOrder > targetOrder) {
					return {item: $item, position: 'before'};
				}
			}

			return {item: $item, position: 'after'};
		},
		_setSelectedState: function (featureName, columnKey, isSelected, executeCallback) {
			var data = this.data[columnKey], $listItem, self = this;

			if (data === undefined || data === null) {
				return false;
			}
			$.each(data, function (index, value) {
				if (value.name.toLowerCase() === featureName.toLowerCase()) {
					$listItem = $('#' + self._id('featurechooser_dd_li_' + columnKey, value.name));
					self._setSelectedItem(columnKey, isSelected, $listItem);
					self.data[columnKey][index].isSelected = !isSelected;
					if (executeCallback === true) {
						self._callFeatureMethod(value, isSelected, columnKey, null);
					}
					value.isSelected = isSelected;
					return false;
				}
			});
		},
		_setSelectedItem: function (columnKey, isSelected, $listItem) {
			if ($listItem === null || $listItem === undefined || $listItem.length === 0) {
				return;
			}
			var innerData = $listItem.data('data'),
				textShow,
				textHide,
				labelText,
				$label = null;

			if (innerData !== undefined && innerData !== null) {
				textShow = innerData.text;

				textHide = innerData.textHide;
				$label = $listItem.find('span.ui-iggrid-featurechooserddlistitemtext');
			}
			$listItem.attr('data-fc-selected', isSelected);
			if (isSelected === true) {
				$listItem.addClass(this.css.itemSelected);
				labelText = textShow;
				if ($label !== null && textShow !== null && textShow !== undefined) {
					$label.text(labelText);
				}
				if (innerData.iconClassOff) {
					$listItem.find('span.ui-iggrid-featurechooser-li-iconcontainer')
						.removeClass(innerData.iconClassOff)
						.addClass(innerData.iconClass);
				}
			} else {
				$listItem.removeClass(this.css.itemSelected);
				labelText = textHide;
				if ($label !== null && textHide !== null && textHide !== undefined) {
					$label.text(labelText);
				}
				if (innerData.iconClassOff) {
					$listItem.find('span.ui-iggrid-featurechooser-li-iconcontainer')
						.removeClass(innerData.iconClass)
						.addClass(innerData.iconClassOff);
				}
			}
			$listItem.attr('title', labelText);
		},
		// M.H. 2 Aug 2012 Fix for bug #118136
		_toggleSelectedItems: function (featureName, selected) {
			var i, $li, columnKey, cols = this.grid.options.columns, colsLength = cols.length, isSelected, feature;
			if (selected !== undefined) {
				isSelected = selected;
			}
			for (i = 0; i < colsLength; i++) {
				columnKey = cols[i].key;
				// M.H. 9 Apr 2014 Fix for bug #169578: igGridFiltering.toggleFilterRowByFeatureChooser method doesn't update feature chooser labels.
				//if dropdown is not rendered then update the data(it is used when rendering dropdown items)
				if ($('#' + this._id('featureChooser_dd', columnKey)).length === 0) {
					feature = this._getFeatureByKeyName(columnKey, featureName);
					if (feature === null || feature === undefined) {
						continue;
					}
					// M.H. 23 Jul 2013 Fix for bug #144214: The "Fix Column" option changes even when column fixing is refused.
					if (isSelected === undefined) {
						isSelected = feature.isSelected;
					}
				} else {
					$li = $('#' + this._id('featurechooser_dd_li_' + columnKey, featureName));
					if ($li.data('data') === null || $li.data('data') === undefined) {
						continue;
					}
					if (selected === undefined) {
						isSelected = $li.attr('data-fc-selected') === "true";
					}
				}
				this._setSelectedState(featureName, columnKey, !isSelected);
				//this._setSelectedItem(columnKey, !($li.attr('data-fc-selected') === "true"), $li);
			}
		},
		showDropDown: function (columnKey) {
			/* Show feature chooser dialog by the specified column key
			paramType="string" Key of the column that should be shown.
			*/
			var $targetButton, dropDownId = this._id('featureChooser_dd', columnKey),
				$dropDown = this.getDropDownByColumnKey(columnKey);
			// M.H. 3 Oct 2013 Fix for bug #153904: When you open feature chooser and move column by dragging the feature chooser does not close.
			this.grid._focusedElement = $('#' + this._id('featureChooser_headerButton', columnKey)).find('span');
			$targetButton = $( '#' + this._id( 'featureChooser_headerButton', columnKey ) ).find( "span" );
			if ($targetButton.length === 0) {
				$targetButton = $( '#' + this.grid.id() + '_' + columnKey );
			}	
			if (this._visiblePopover && dropDownId !== this._visiblePopover) {
				$('#' + this._visiblePopover).data('igGridFeatureChooserPopover')._closePopover();
				setTimeout(function () {
					$dropDown.igGridFeatureChooserPopover('show', $targetButton);
				}, 100);
			} else {
				$dropDown.igGridFeatureChooserPopover('show', $targetButton);
			}
		},
		hideDropDown: function (columnKey) {
			/* Hide feature chooser dialog by column key
			paramType="string" Key of the column that should be hidden.
			*/
			var $dropDown = this.getDropDownByColumnKey(columnKey);
			$dropDown.igGridFeatureChooserPopover('hide');
			// M.H. 3 Oct 2013 Fix for bug #153904: When you open feature chooser and move column by dragging the feature chooser does not close.
			this.grid._focusedElement = null;
		},
		getDropDownByColumnKey: function (columnKey) {
			/* Get jQuery representation of the div holding dropdown for the specified columnKey
			paramType="string" Key of the column
			*/
			var dropDownId = this._id('featureChooser_dd', columnKey),
				$dropDown = $('#' + dropDownId);
			if ($dropDown.length === 0) {
				this._renderMenu(columnKey);
				$dropDown = $('#' + dropDownId);
			}
			return $dropDown;
		},
		toggleDropDown: function (columnKey) {
			/* Show/hide feature chooser dialog by column key
			paramType="string" Key of the column that should be shown/hidden.
			*/ 
			var $dropDown = this.getDropDownByColumnKey(columnKey),
				isVisible = $dropDown.igGridFeatureChooserPopover('isShown');
			this._trigger(this.events.menuToggling, null, {isVisible: isVisible, columnKey: columnKey, owner: this});
			if (isVisible) {
				this.hideDropDown(columnKey);
			} else {
				this.showDropDown(columnKey);
			}
		},
		_mouseOverDropDownItem: function (event) {
			this._addCssSelectionListItem($(event.currentTarget));
		},
		_mouseOutDropDownItem: function (event) {
			this._removeCssSelectionListItem($(event.currentTarget));
		},
		_addCssSelectionListItem: function ($listItem) {
			$listItem.addClass(this.css.dropDownListItemHover);
		},
		_removeCssSelectionListItem: function ($listItem) {
			$listItem.removeClass(this.css.dropDownListItemHover);
		},
		destroy: function () {
			var i, l, self = this, sbm = this._submenus;
			this.data = null;
			// M.H. 29 Oct 2012 Fix for bug #120642
			$.each(this.grid.options.columns, function (ind, column) {
				var $dd = $('#' + self._id('featureChooser_dd', column.key));

				if ($dd.length > 0) {
					$dd.igGridFeatureChooserPopover('destroy');
					$dd.remove();
				}
			});
			if (sbm) {
				l = sbm.length;
				for (i = 0; i < l; i++) {
					$('#' + sbm[i]).remove();
				}
			}
			if (this._headerRenderedHandler) {
				this.grid.element.unbind('iggridheaderrendered', this._headerRenderedHandler);
			}
			if (this._gridDestroyedHandler) {
				this.grid.element.unbind('igcontroldestroyed', this._gridDestroyedHandler);
			}
			if (this._gridRenderedHandler) {
				this.grid.element.unbind('iggridrendered', this._gridRenderedHandler);
			}
			delete this._gridRenderedHandler;
			delete this._headerRenderedHandler;
			delete this._gridDestroyedHandler;
			$.Widget.prototype.destroy.apply(this, arguments);
			return this;
		}
	});
	$.extend($.ui.igGridFeatureChooser, {version: '14.1.20141.2249'});
}(jQuery));


/*
 * Infragistics.Web.ClientUI Grid Modal Dialog 14.1.20141.2249
 *
 * Copyright (c) 2011 Infragistics Inc.
 * <Licensing info>
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	ig.ui.grid.framework.js
 *	ig.ui.shared.js
 *	ig.util.js
 */

/*global jQuery, window, document */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}
(function ($) {
	/*
		igGridModalDialog summary
		Modal dialog will show content for advanced group by, column chooser and multiple sorting
	*/
	$.widget("ui.igGridModalDialog", {
		options: {
			buttonApplyText: "Apply",
			buttonCancelText: "Cancel",
			modalDialogCaptionText: 'Header',
			/* type="number" The default modal dialog width in pixels. */
			modalDialogWidth: 250,
			/* type="number" The default modal dialog height in pixels. */
			modalDialogHeight: '',
			renderFooterButtons: true,
			animationDuration: 200
		},
		css: {
			/* Classes applied to the modal dialog element */
			"modalDialog": "ui-dialog ui-draggable ui-resizable ui-iggrid-dialog ui-widget ui-widget-content ui-corner-all",
			/* Classes applied to the modal dialog dialog header caption area */
			"modalDialogHeaderCaption": "ui-dialog-titlebar ui-widget-header ui-corner-top ui-helper-reset ui-corner-all ui-helper-clearfix",
			/* Classes applied to the modal dialog dialog header caption title */
			"modalDialogHeaderCaptionTitle": "ui-dialog-title",
			/* Classes applied to the modal dialog dialog content */
			"modalDialogContent": "ui-dialog-content ui-widget-content",
			/* Classes applied to the modal dialog handlebar at the bottom */
			"modalDialogHandleBar": "",
			/* Classes applied to button container at the caption */
			"captionButtonContainer": "ui-iggrid-modaldialog-caption-buttoncontainer",
			/* Classes applied to the footer container at the bottom */
			"modalDialogFooter": "ui-dialog-buttonpane ui-widget-content ui-helper-clearfix",
			/* Classes applied to button set in the footer */
			"buttonset": "ui-dialog-buttonset",
			/* Classes applied to block area over which it is shown modal dialog */
			"blockArea": "ui-widget-overlay ui-iggrid-blockarea"
		},
		events: {
			/* cancel="true" event fired before the modal dialog is opened.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridModalDialog widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			*/
			modalDialogOpening: "modalDialogOpening",
			/* event fired after the modal dialog is already opened.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridModalDialog widget.
			Use ui.modalDialog to get the reference to the igGridModalDialog element
			*/
			modalDialogOpened: "modalDialogOpened",
			/* event fired every time the modal dialog changes its position.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridModalDialog widget.
			Use ui.modalDialog to get the reference to the igGridModalDialog element
			Use ui.originalPosition to get the original position of the modal dialog div as { top, left } object, relative to the page.
			Use ui.position to get the current position of the modal dialog div as { top, left } object, relative to the page.
			*/
			modalDialogMoving: "modalDialogMoving",
			/* cancel="true" event fired before the modal dialog is closed.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridModalDialog widget.
			Use ui.modalDialog to get the reference to the igGridModalDialog element
			*/
			modalDialogClosing: "modalDialogClosing",
			/* event fired after the modal dialog has been closed.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridModalDialog widget.
			Use ui.modalDialog to get the reference to the igGridModalDialog element
			*/
			modalDialogClosed: "modalDialogClosed",
			/* cancel="true" event fired before the contents of the modal dialog are rendered.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridModalDialog widget.
			Use ui.modalDialog to get the reference to the igGridModalDialog element
			*/
			modalDialogContentsRendering: "modalDialogContentsRendering",
			/* event fired after the contents of the modal dialog are rendered.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridModalDialog widget.
			Use ui.modalDialog to get the reference to the igGridModalDialog element
			*/
			modalDialogContentsRendered: "modalDialogContentsRendered",
			/* cancel="true" event fired when the button OK/Apply is clicked
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridModalDialog widget.
			Use ui.modalDialog to get the reference to the igGridModalDialog element
			*/
			buttonOKClick: "buttonOKClick"
		},
		_createWidget: function (options, element) {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			//this.options.columnSettings = [];
			// M.H. 8 May 2012 Fix for bug #110344
			this.gridContainer = options.gridContainer;
			this.containment = options.containment || options.gridContainer;
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		_create: function () {
			this._setGridWidthHeight();
			this._renderModalDialog();
		},

		_setGridWidthHeight: function () {
			this.element
				.css('width', this.options.modalDialogWidth)
				.css('height', this.options.modalDialogHeight);
		},

		openModalDialog: function () {
			var maxZ = 10000, rOffset,
				scrollLeft,
				scrollTop,
				pageLeft,
				pageTop,
				pageRight,
				pageBottom,
				pos,
				h,
				w,
				bh,
				bw,
				mdW,
				mdH,
				caption,
				content,
				footer,
				modalDialogTop,
				modalDialogLeft,
				noCancel = true,
				modalDialog = this.element,
				modalDialogBody,
				block,
				animationDuration = this._getAnimationDuration(),
				blockId = this._id('_modaldialog_block');

			if (this._modalDialogOpened) {
				return;
			}
			noCancel = this._trigger(this.events.modalDialogOpening, null, {modalDialog: modalDialog, owner: this});
			if (noCancel) {
				// M.H. 21 March 2012 Fix for bug #105213
				$('#' + blockId).remove();
				this._setGridWidthHeight();
				modalDialogBody = modalDialog.find("table tbody");
				modalDialogBody.empty();
				// M.H. 9 Nov 2012 Fix for bug #115850
				pos = $.ig.util.offset(this.gridContainer);
				w = this.gridContainer.outerWidth();
				h = this.gridContainer.outerHeight();
				scrollLeft = $(window).scrollLeft();
				scrollTop = $(window).scrollTop();
				pageLeft = pos.left - scrollLeft;
				pageTop = pos.top - scrollTop;
				pageRight = pageLeft + w;
				pageBottom = pageTop + h;
				// M.H. 21 March 2012 Fix for bug #105447
				mdW = parseInt(this.options.modalDialogWidth, 10);
				mdH = parseInt(this.options.modalDialogHeight, 10);
				// M.H. 21 March 2012 Fix for bug #105213
				block = $('<div></div>')
					.appendTo(this.gridContainer)
					.attr('id', blockId)
					.css('position', 'absolute')
					.addClass(this.css.blockArea).hide();

				if (block.outerWidth() !== this.gridContainer.outerWidth()) {
					block.css('width', this.gridContainer.outerWidth());
				}
				if (block.outerHeight() !== this.gridContainer.outerHeight()) {
					block.css('height', this.gridContainer.outerHeight());
				}
                rOffset = $.ig.util.getRelativeOffset(block);
				block.css({left: pos.left - rOffset.left, top: pos.top - rOffset.top}).fadeToggle(animationDuration);

				if (!mdW) {
					mdW = this.element.width();
				}
				if (!mdH) {
					mdH = this.element.height();
				}
				if (pageLeft < 0) {
					pageLeft = 0;
				}
				if (pageTop < 0) {
					pageTop = 0;
				}

				bw = $(window).width();
				bh = $(window).height();
				if (pageRight > bw) {
					pageRight = bw;
				}
				if (pageBottom > bh) {
					pageBottom = bh;
				}

				modalDialogTop = pageTop + scrollTop + (pageBottom - pageTop) / 2 - mdH / 2;
				modalDialogLeft = pageLeft + scrollLeft + (pageRight - pageLeft) / 2 - mdW / 2;
				// M.H. 13 March 2012 Fix for bug #104443
				if (modalDialogTop < 0) {
					modalDialogTop = pageTop;
				}

				if (modalDialogLeft < 0) {
					modalDialogLeft = pageLeft;
				}
				// M.H. 10 July 2012 Fix for bug #106407
				maxZ = $.ig.getMaxZIndex(this.element[0].id);
                rOffset = $.ig.util.getRelativeOffset(modalDialog);
				modalDialog
					.css({
						left: modalDialogLeft - rOffset.left,
						top: modalDialogTop - rOffset.top,
						zIndex: maxZ + 2
					})
					.fadeToggle(animationDuration);
				block.css({zIndex: maxZ + 1});
				//add a fixed height to the content div so that it overflows and shows a scrollbar,
				//this height should be calculated as the space left after the caption and resizing handles are taken into account
				caption = modalDialog.children('div.ui-dialog-titlebar');
				content = modalDialog.children('div.ui-dialog-content');
				footer = modalDialog.children('div.ui-dialog-buttonpane');
				content.css('height', modalDialog.height() - caption.outerHeight() -
					(content.outerHeight() - content.height()) - footer.outerHeight());
				// M.H. 9 March 2012 Fix for bug #104366
				$('#' + this._id('content')).css({width: ''});
				this._modalDialogOpened = true;
				this._trigger(this.events.modalDialogOpened, null, {modalDialogElement: modalDialog, owner: this});
				// focus modal dialog so it can be closed with the ESCAPE key 
				modalDialog.focus();
			}
		},
		_getAnimationDuration: function () {
			var animationDuration = this.options.animationDuration;

			if (animationDuration === null || animationDuration === undefined) {
				animationDuration = 200;
			}
			return animationDuration;
		},
		_setOption: function (key, value) {
			// M.H. 14 March 2012 Fix for bug #104700
			// handle new settings and update options hash
			$.Widget.prototype._setOption.apply(this, arguments);
			switch (key) {
			case 'buttonApplyText':
				$('#' + this._id('footer_buttonok')).igButton('option', 'labelText', value);
				break;
			case 'buttonCancelText':
				$('#' + this._id('footer_buttoncancel')).igButton('option', 'labelText', value);
				break;
			case 'modalDialogCaptionText':
				this.element.find('span.ui-dialog-title:eq(0)').html(value);
				break;
			case 'modalDialogWidth':
				this.element
					.css('width', value);
				break;
			case 'modalDialogHeight':
				this.element
					.css('height', value);
				break;
			case 'renderFooterButtons':
				// dialog should be re-rendered
				if (this.element.is(':visible')) {
					this.closeModalDialog();
				}
				this.element.empty();
				this._renderModalDialog();
				break;
			default:
				break;
			}
		},
		closeModalDialog: function () {
			var noCancel = true,
				modalDialog = this.element,
				animationDuration = this._getAnimationDuration();

			if (!this._modalDialogOpened) {
				return;
			}
			noCancel = this._trigger(this.events.modalDialogClosing, null, {modalDialog: modalDialog, owner: this});
			if (noCancel) {
				modalDialog.fadeToggle(animationDuration);
				// M.H. 21 March 2012 Fix for bug #105213
				$('#' + this._id('_modaldialog_block')).fadeToggle(animationDuration);
				this._modalDialogOpened = false;
				this._trigger(this.events.modalDialogClosed, null, {modalDialog: modalDialog, owner: this});
			}
		},
		_modalDialogMove: function (e, ui) {
			var oPos = ui.originalPosition, pos = ui.position;
			this._trigger(this.events.modalDialogMoving, null,
				{
					modalDialog: e.target,
					owner: this,
					originalPosition: oPos,
					position: pos
				});
		},

		/********* Getter methods ********/
		getCaptionButtonContainer: function () {
			return $('#' + this._id('caption_button_container'));
		},
		getFooter: function () {
			return $('#' + this._id('footer'));
		},
		getContent: function () {
			return $('#' + this._id('content'));
		},
		/********* //Getter methods ********/

		_renderModalDialog: function () {
			var self = this,
				css = this.css,
				modalDialog = this.element,
				caption,
				containment,
				modalDialogContent,
				footer,
				o = this.options,
				$buttonSet,
				$buttonOK,
				$buttonCancel,
				noCancel = true;

			modalDialog.css('position', 'absolute')
				.addClass(this.css.modalDialog)
				.hide();
			noCancel = this._trigger(this.events.modalDialogContentsRendering, null, {modalDialog: modalDialog, owner: this});
			if (noCancel) {
				caption = $('<div></div>').addClass(this.css.modalDialogHeaderCaption).appendTo(modalDialog);
				$('<span></span>')
					.text(this.options.modalDialogCaptionText)
					.addClass(this.css.modalDialogHeaderCaptionTitle)
					.appendTo(caption);
				$('<div></div>')
					.attr('id', this._id('caption_button_container'))
					.addClass(css.captionButtonContainer)
					.appendTo(caption);
				modalDialogContent =
					$("<div></div>")
					.css('overflow', 'auto')
					.addClass(this.css.modalDialogContent)
					.attr('id', this._id('content'))
					.appendTo(modalDialog);
				if (o.renderFooterButtons === true) {
					footer = $('<div></div>')
						.addClass(this.css.modalDialogFooter)
						.attr('id', this._id('footer'))
						.appendTo(modalDialog);
					$buttonSet = $('<div></div>')
						.addClass(this.css.buttonset)
						.appendTo(footer);
					$buttonOK = $('<button></button>')
						.attr('id', this._id('footer_buttonok'))
						.appendTo($buttonSet);
					$buttonOK.igButton({
						labelText: o.buttonApplyText
					});
					$buttonCancel = $('<button></button>')
						.attr('id', this._id('footer_buttoncancel'))
						.appendTo($buttonSet);
					$buttonCancel.igButton({
						labelText: o.buttonCancelText
					});
					$buttonCancel.bind({
						click: function (e, args) {
							noCancel = self._trigger(self.events.buttonCancelClick, e, {modalDialog: modalDialog, owner: self});
							if (noCancel) {
								self.closeModalDialog();
								e.preventDefault();
								e.stopPropagation();
							}
						}
					});
				}
				// M.H. 22 May 2014 Fix for bug #162225: Allow Users to Position the igGrid Advanced Filter Dialog Anywhere in Browser Window
				containment = this.containment;
				if (containment === 'window') {
					containment = 'document';
				}
				//$('<div></div>').addClass(this.css.modalDialogHandleBar).appendTo(modalDialog);
				// M.H. 23 March 2012 Fix for bug #106009
				modalDialog
					.bind({
						keydown: function (e) { if (e.keyCode === $.ui.keyCode.ESCAPE) { self.closeModalDialog(); } }
					})
					.draggable({containment: containment, handle: caption, drag: $.proxy(this._modalDialogMove, this)})
					.attr('role', 'dialog')
					.attr('tabIndex', -1);

				// M.H. 20 April 2012 Fix for bug #104800
				// M.H. 16 June 2014 Fix for bug #173464: When modernizr is not referenced modal dialogs are not resizable
				if (typeof Modernizr !== "object" || Modernizr.touch === false) {
					// M.H. 22 May 2014 Fix for bug #162225: Allow Users to Position the igGrid Advanced Filter Dialog Anywhere in Browser Window
					modalDialog.resizable({
						alsoResize: modalDialogContent,
						minHeight: modalDialog.outerHeight() / 4,
						minWidth: modalDialog.outerWidth() / 2
					});
					// M.H. 9 June 2014 Fix for bug #173021: Resizing the edit template causes it to shrink when grid height is less.
					// if we use containment window, body or document there are issues with resizing
					if (this.containment !== 'window') {
						modalDialog.resizable('option', 'containment', 'parent');
					}
				}
				this._trigger(this.events.modalDialogContentsRendered, null, {modalDialog: modalDialog, owner: this});
			}
		},
		// helper methods
		_id: function () {
			var i, ar = arguments, res = this.element[0].id;

			for (i = 0; i < ar.length; i++) {
				res += '_' + ar[i];
			}
			return res;
		},

		destroy: function () {
			// M.H. 10 May 2012 Fix for bug #111002
			$('#' + this._id('_modaldialog_block')).remove();
			$.Widget.prototype.destroy.apply(this, arguments);
			return this;
		}
	});

	$.extend($.ui.igGridModalDialog, {version: '14.1.20141.2249'});
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid Sorting 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	jquery-tmpl.js (https://github.com/jquery/jquery-tmpl)
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.editors.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery, toStaticHTML, Modernizr */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}
(function ($) {

	/*
		igGridFiltering widget. The widget is pluggable to the element where the grid is instantiated and the actual igGrid object doesn't know about this
		the filtering widget just attaches its functionality to the grid
		it supports filtering dropdowns with various predefined filtering expressions based on the column type 
		the widget also implements has full keyboard support with the TAB , SPACE/ENTER keys. 
	*/
    $.widget("ui.igGridFiltering", {
        /* property showing whether it should be rendered in feature chooser */
        renderInFeatureChooser: true,
		options: {
			/* type="bool" Enables or disables the filtering case sensitivity. Works only for local filtering.If true, it enables filtering case sensitivity. If false, it disables filtering case sensitivity. 
            */
			caseSensitive: false,
			//dropDownAnimations: true,
			/* type="bool" Enable/disable footer visibility with summary info about the filter.
            When false, the filter summary row (in the footer) will only be visible when paging is enabled (or some other feature that renders a footer).
            When true, the filter summary row will only be visible when a filter is applied i.e. it's not visible by default.
            */
			filterSummaryAlwaysVisible: true,
            /* type="bool" Render in feature chooser. Feature chooser is dialog which lists all the enabled features (like Sorting, Filtering, Hiding etc.) of igGrid. */
            renderFC: true,
			/* type="string" Summary template that will appear in the bottom left corner of the footer. Has the format '${matches} matching records' */
			filterSummaryTemplate: $.ig.GridFiltering.locale.filterSummaryTemplate,
			/* 
                type="linear|none" type of animations for the column filter dropdowns
                linear type="string"
                none type="string"
            */
			filterDropDownAnimations: "linear",
			/* type="number" animation duration in milliseconds for the filter dropdown animations */
			filterDropDownAnimationDuration: 500,
			/* type="string|number" width of the column filter dropdowns
                string The width in pixels (0px)
                number The width as a number (0)
            */
			filterDropDownWidth: 0,
			/* type="object" Height of the column filter dropdowns
                string The height of the column filter dropdowns in pixels (0px).
                number The height of the column filter dropdowns as a number (0).
            */
			filterDropDownHeight: 0,
			/* type="string" URL key name that specifies how the filtering expressions will be encoded for remote requests, e.g. &filter('col') = startsWith. Default is OData */
			filterExprUrlKey: null,
			/* type="true|false" Enable/disable filter icons visibility.
                true type="bool" all predefined filters in the filter dropdowns will have icons rendered in front of the text
                false type="bool"
            */
			filterDropDownItemIcons: true,
			/* type="array" a list of column settings that specifies custom filtering options on a per column basis */
			columnSettings: [
				{
					/* type="string" Specifies column key. Either key or index must be set in every column setting.*/
					columnKey: null,
					/* type="number" Specifies column index. Either key or index must be set in every column setting.*/
					columnIndex: null,
					/* type="bool" Enables/disables filtering for the column.*/
					allowFiltering: true,
					/* type="empty|notEmpty|null|notNull|equals|doesNotEqual|startsWith|contains|doesNotContain|endsWith|greaterThan|lessThan|greaterThanOrEqualTo|lessThanOrEqualTo|true|false|on|notOn|before|after|today|yesterday|thisMonth|lastMonth|nextMonth|thisYear|nextYear|lastYear" default filtering condition for the column
                    empty type="string"
                    notEmpty type="string"
                    null type="string"
                    notNull type="string"
                    equals type="string"
                    doesNotEqual type="string"
                    startsWith type="string"
                    contains type="string"
                    doesNotContain type="string"
                    endsWith type="string"
                    greaterThan type="string"
                    lessThan type="string"
                    greaterThanOrEqualTo type="string"
                    lessThanOrEqualTo type="string"
                    true type="bool"
                    false type="bool"
                    on type="string"
                    notOn type="string"
                    before type="string"
                    after type="string"
                    today type="string"
                    yesterday type="string"
                    thisMonth type="string"
                    lastMonth type="string"
                    nextMonth type="string"
                    thisYear type="string"
                    nextYear type="string"
                    lastYear type="string"
                    */
					condition: null,
                    /* type="object" Initial filtering expressions - if set they will be applied on initialization
                    */
                    defaultExpressions: []
				}
			],
			/* type="remote|local" Type of filtering. Delegates all filtering functionality to the $.ig.DataSource.
            remote type="string"
            local type="string"
             */
			type: null,
			/* type="number" Time in milliseconds for which widget will wait for keystrokes before sending filtering request.*/
			filterDelay: 500,
			/* type="simple|advanced" Default is 'simple' for non-virtualized grids, and 'advanced' when virtualization is enabled 
                simple type="string" renders just a filter row
                advanced type="string" allows to configure multiple filters from a dialog - Excel style
            */
			mode: null,
			/* type="bool" defines whether to show/hide editors in advanced mode. If false, no editors will be rendered in the advanced mode 
            */
			advancedModeEditorsVisible: false,
			/* type="left|right" location of the advanced filtering button when advancedModeEditorsVisible is false (i.e. when the button is rendered in the header) 
            left type="string"
            right type="string"
            */
			advancedModeHeaderButtonLocation: "left",
			/* showEditorsOnClick: false, // when true, editors will not be rendered for every column, and one shared editor will be reused */
			/* type="string|number" default filter dialog width (used for Advanced filtering) 
                string The dialog window width in pixels (370px).
                number The dialog window width as a number (370).
            */
			filterDialogWidth: 370,
			/* type="string|number" maximum filter dialog height (used for Advanced filtering)  
                string The dialog window height in pixels (350px).
                number The dialog window height as a number (350).
            */
			filterDialogMaxHeight: 350,
			/* type="string|number" default filter dialog height (used for Advanced filtering)  
                string The dialog window height in pixels (350px).
                number The dialog window height as a number (350).
            */
			filterDialogHeight: '',
			/* type="string|number" Width of the filtering condition dropdowns in the advanced filter dialog 
                string The filtering condition dropdowns width in pixels (80px).
                number The filtering condition dropdowns width as a number (80).
            */
			filterDialogFilterDropDownDefaultWidth: 80,
			/* type="string|number" width of the filtering expression input boxes in the advanced filter dialog 
                string The filtering expression input boxes width in pixels (80px).
                number The filtering expression input boxes width as a number (80).
            */
			filterDialogExprInputDefaultWidth: 80,
			/* type="string|number" Width of the column chooser dropdowns in the advanced filter dialog 
                string The column chooser dropdowns width in pixels (80px).
                number The column chooser dropdowns width as a number (80).
            */
			filterDialogColumnDropDownDefaultWidth: null,
			/* showFilterDialogClearAllButton: true, // if false, doesn't render the "Clear ALL" button link in the advanced filtering dialog */
			/* type="bool" Enable/disable filter button visibility. If false,no filter dropdown buttons will be rendered and predefined list of filters will not be rendered for the columns
            */
			renderFilterButton: true,
			/* type="left|right" the filtering button for filter dropdowns can be rendered either on the left of the filter editor or on the right 
            left type="string"
            right type="string"
            */
			filterButtonLocation: "left",
			/* list of configurable and localized null texts that will be used for the filter editors */
			nullTexts: {
				/* type="string" */
				"startsWith": $.ig.GridFiltering.locale.startsWithNullText,
				/* type="string" */
				"endsWith": $.ig.GridFiltering.locale.endsWithNullText,
				/* type="string" */
				"contains": $.ig.GridFiltering.locale.containsNullText,
				/* type="string" */
				"doesNotContain": $.ig.GridFiltering.locale.doesNotContainNullText,
				/* type="string" */
				"equals": $.ig.GridFiltering.locale.equalsNullText,
				/* type="string" */
				"doesNotEqual": $.ig.GridFiltering.locale.doesNotEqualNullText,
				/* type="string" */
				"greaterThan": $.ig.GridFiltering.locale.greaterThanNullText,
				/* type="string" */
				"lessThan": $.ig.GridFiltering.locale.lessThanNullText,
				/* type="string" */
				"greaterThanOrEqualTo": $.ig.GridFiltering.locale.greaterThanOrEqualToNullText,
				/* type="string" */
				"lessThanOrEqualTo": $.ig.GridFiltering.locale.lessThanOrEqualToNullText,
				/* type="string" */
				"on": $.ig.GridFiltering.locale.onNullText,
				/* type="string" */
				"notOn": $.ig.GridFiltering.locale.notOnNullText,
                /* type="string" */
				"after": $.ig.GridFiltering.locale.afterNullText,
				/* type="string" */
				"before": $.ig.GridFiltering.locale.beforeNullText,
				/* type="string" */
				"thisMonth": $.ig.GridFiltering.locale.thisMonthLabel,
				/* type="string" */
				"lastMonth": $.ig.GridFiltering.locale.lastMonthLabel,
				/* type="string" */
				"nextMonth": $.ig.GridFiltering.locale.nextMonthLabel,
				/* type="string" */
				"thisYear": $.ig.GridFiltering.locale.thisYearLabel,
				/* type="string" */
				"lastYear": $.ig.GridFiltering.locale.lastYearLabel,
				/* type="string" */
				"nextYear": $.ig.GridFiltering.locale.nextYearLabel,
				/* type="string" */
				"empty": $.ig.GridFiltering.locale.emptyNullText,
				/* type="string" */
				"notEmpty": $.ig.GridFiltering.locale.notEmptyNullText,
				/* type="string" */
				"null": $.ig.GridFiltering.locale.nullNullText,
				/* type="string" */
				"notNull": $.ig.GridFiltering.locale.notNullNullText
			},
			/* A list of configurable and localized labels that are used for the predefined filtering conditions in the filter dropdowns. */
			labels: {
				/* type="string" */
				noFilter: $.ig.GridFiltering.locale.noFilterLabel,
				/* type="string" */
				clear: $.ig.GridFiltering.locale.clearLabel,
				/* type="string" */
				startsWith: $.ig.GridFiltering.locale.startsWithLabel,
				/* type="string" */
				endsWith: $.ig.GridFiltering.locale.endsWithLabel,
				/* type="string" */
				contains: $.ig.GridFiltering.locale.containsLabel,
				/* type="string" */
				doesNotContain: $.ig.GridFiltering.locale.doesNotContainLabel,
				/* type="string" */
				equals: $.ig.GridFiltering.locale.equalsLabel,
				/* type="string" */
				doesNotEqual: $.ig.GridFiltering.locale.doesNotEqualLabel,
				/* type="string" */
				greaterThan: $.ig.GridFiltering.locale.greaterThanLabel,
				/* type="string" */
				lessThan: $.ig.GridFiltering.locale.lessThanLabel,
				/* type="string" */
				greaterThanOrEqualTo: $.ig.GridFiltering.locale.greaterThanOrEqualToLabel,
				/* type="string" */
				lessThanOrEqualTo: $.ig.GridFiltering.locale.lessThanOrEqualToLabel,
				/* type="string" */
				trueLabel: $.ig.GridFiltering.locale.trueLabel,
				/* type="string" */
				falseLabel: $.ig.GridFiltering.locale.falseLabel,
				/* type="string" */
				after: $.ig.GridFiltering.locale.afterLabel,
				/* type="string" */
				before: $.ig.GridFiltering.locale.beforeLabel,
				/* type="string" */
				today: $.ig.GridFiltering.locale.todayLabel,
				/* type="string" */
				yesterday: $.ig.GridFiltering.locale.yesterdayLabel,
				/* type="string" */
				thisMonth: $.ig.GridFiltering.locale.thisMonthLabel,
				/* type="string" */
				lastMonth: $.ig.GridFiltering.locale.lastMonthLabel,
				/* type="string" */
				nextMonth: $.ig.GridFiltering.locale.nextMonthLabel,
				/* type="string" */
				thisYear: $.ig.GridFiltering.locale.thisYearLabel,
				/* type="string" */
				lastYear: $.ig.GridFiltering.locale.lastYearLabel,
				/* type="string" */
				nextYear: $.ig.GridFiltering.locale.nextYearLabel,
				/* type="string" */
				on: $.ig.GridFiltering.locale.onLabel,
				/* type="string" */
				notOn: $.ig.GridFiltering.locale.notOnLabel,
				/* type="string" */
				advancedButtonLabel: $.ig.GridFiltering.locale.advancedButtonLabel,
				/* type="string" */
				filterDialogCaptionLabel: $.ig.GridFiltering.locale.filterDialogCaptionLabel,
				/* type="string" */
				filterDialogConditionLabel1: $.ig.GridFiltering.locale.filterDialogConditionLabel1,
				/* type="string" */
				filterDialogConditionLabel2: $.ig.GridFiltering.locale.filterDialogConditionLabel2,
				/* type="string" */
				filterDialogOkLabel: $.ig.GridFiltering.locale.filterDialogOkLabel,
				/* type="string" */
				filterDialogCancelLabel: $.ig.GridFiltering.locale.filterDialogCancelLabel,
				/* type="string" */
				filterDialogAnyLabel: $.ig.GridFiltering.locale.filterDialogAnyLabel,
				/* type="string" */
				filterDialogAllLabel: $.ig.GridFiltering.locale.filterDialogAllLabel,
				/* type="string" */
				filterDialogAddLabel: $.ig.GridFiltering.locale.filterDialogAddLabel,
				/* type="string" */
				filterDialogErrorLabel: $.ig.GridFiltering.locale.filterDialogErrorLabel,
				/* type="string" */
				filterSummaryTitleLabel: $.ig.GridFiltering.locale.filterSummaryTitleLabel,
				/* type="string" */
				filterDialogClearAllLabel: $.ig.GridFiltering.locale.filterDialogClearAllLabel,
				/* type="string" */
				empty: $.ig.GridFiltering.locale.emptyNullText,
				/* type="string" */
				notEmpty: $.ig.GridFiltering.locale.notEmptyNullText,
				/* type="string" */
				nullLabel: $.ig.GridFiltering.locale.nullNullText,
				/* type="string" */
				notNull: $.ig.GridFiltering.locale.notNullNullText
			},
			/* type="string" custom tooltip template for the filter button, when a filter is applied */
			tooltipTemplate: $.ig.GridFiltering.locale.tooltipTemplate,
			/* type="string" Custom template for add condition area in the filter dialog.
				The default template is "<div><span>${label1}</span><div><select></select></div><span>${label2}</span></div>"
			*/
			filterDialogAddConditionTemplate: null,
			/* type="string" Custom template for options in dropdown in add condition area in the filter dialog.
				The default template is "<option value='${value}'>${text}</option>"
			*/
			filterDialogAddConditionDropDownTemplate: null,
			/* type="string" Custom template for filter dialog 
				The default template is "<tr><td><input/></td><td><select></select></td><td><input /> </td><td><span></span></td></tr>"
			*/
			filterDialogFilterTemplate: null,
			//filterDialogFilterColumnsListTemplate: "<option value='${columnKey}'>${columnKey}</option>",
			/* type="string" Custom template for options in condition list in filter dialog 
				The default template is "<option value='${conditionName}'>${conditionLabel}</option>"
			*/
			filterDialogFilterConditionTemplate: null,
			/* type="string|number" add button width - in the advanced filter dialog 
                string The dialog Add button width in pixels (100px).
                number The dialog Add button width as a number (100).
            */
			filterDialogAddButtonWidth: 100,
			/* type="string|number" Width of the Ok and Cancel buttons in the advanced filtering dialogs 
                string The advanced filter dialog Ok and Cancel buttons width in pixels (120px).
                number The advanced filter dialog Ok and Cancel buttons width as a number (120).
            */
			filterDialogOkCancelButtonWidth: 120,
			/* type="number" Maximum number of filter rows in the advanced filtering dialog. if this number is exceeded, an error message will be rendered */
			filterDialogMaxFilterCount: 5,
            /* type="string" Controls containment behavior. 
                owner type="string" The filter dialog will be draggable only in the grid area
                window type="string" The filter dialog will be draggable in the whole window area
            */
            filterDialogContainment: "owner",
			/* type="bool" Enable/disable empty condition visibility in the filter. If true, shows empty and not empty filtering conditions in the dropdowns
            */
			showEmptyConditions: false,
			/* type="bool" Enable/disable visibility of null and not null filtering conditions in the dropdowns. If true, shows null and not null filtering conditions in the dropdowns
            */
			showNullConditions: false,
			/* type="string" Feature chooser text when filter is shown and filter mode is simple*/
			featureChooserText: $.ig.GridFiltering.locale.featureChooserText,
			/* type="string" Feature chooser text when filter is hidden and filter mode is simple*/
			featureChooserTextHide: $.ig.GridFiltering.locale.featureChooserTextHide,
			/* type="string" Feature chooser text when filter mode is advanced*/
			featureChooserTextAdvancedFilter: $.ig.GridFiltering.locale.featureChooserTextAdvancedFilter,
			/* type="bool" Enables / disables filtering persistence between states*/
			persist: true
		},
		css: {
			/* Classes applied to the filter row TR in the headers table */
			"filterRow": "ui-iggrid-filterrow ui-widget", // A.T. 15 Feb 2011 - removing ui-widget-content as it messes up hover and focus styles for buttons
			/* Classes applied to every filter cell TH */
			"filterCell": "ui-iggrid-filtercell",
			/* Classes applied to every filter editor element (igEditor) */
			"filterCellEditor": "ui-iggrid-filtereditor",
			/* Classes applied to the UL filter dropdown list */
			"filterDropDownList": "ui-menu ui-widget ui-widget-content ui-iggrid-filterddlist ui-corner-all",
			/* Classes applied to the DIV which wraps the dropdown UL */
			"filterDropDown": "ui-iggrid-filterdd",
			/* Classes applied to the element that holds the text in every filter list item (LI) */
			"filterDropDownListItemTextContainer": "ui-iggrid-filterddlistitemcontainer",
			/* Classes applied to each filter dropdown list item  (LI) */
			"filterDropDownListItem": "ui-iggrid-filterddlistitem",
			/* Class applied to the list item that holds the Advanced button, if options are configured such that editors are shown when mode = "advanced" */
			"filterDropDownListItemAdvanced": "ui-iggrid-filterddlistitemadvanced",
			/* Classes applied to the list item when filtering icons are visible for it */
			"filterDropDownListItemWithIcons": "ui-iggrid-filterddlistitemicons ui-state-default",
			/* Classes applied to the "clear" filter list item */
			"filterDropDownListItemClear": "ui-iggrid-filterddlistitemclear",
			/* Classes applied to the list item when it is hovered */
			"filterDropDownListItemHover": "ui-iggrid-filterddlistitemhover ui-state-hover",
			/* Classes applied to the list item when it is selected */
			"filterDropDownListItemActive": "ui-iggrid-filterddlistitemactive ui-state-active",
			"filterDateCell": "",
			"filterTextCell": "",
			"filterNumberCell": "",
			"filterBoolCell": "",
			/* Classes applied to every filtering dropdown button */
			"filterButton": "ui-iggrid-filterbutton ui-corner-all ui-icon ui-icon-triangle-1-s",
			/* Classes applied to the button when mode = advanced. This also applies to the button when it's rendered in the header (which is the default behavior). */
			"filterButtonAdvanced": "ui-iggrid-filterbutton ui-iggrid-filterbuttonadvanced ui-icon ui-icon-search", // icon similar to Excel's filtering
			/* Classes applied to the advanced filtering button when it is rendered on the right */
			"filterButtonAdvancedRight": "ui-iggrid-filterbuttonright ui-iggrid-filterbuttonadvanced ui-icon ui-icon-search",
			/* Classes applied to the filter button when it is hovered */
			"filterButtonHover": "ui-iggrid-filterbuttonhover ui-state-hover",
			/* Classes applied to the filter button when it is selected */
			"filterButtonActive": "ui-iggrid-filterbuttonactive ui-state-active",
			/* Classes applied to the filter button when it has focus but is not selected. */
			"filterButtonFocus": "ui-iggrid-filterbuttonfocus ui-state-focus",
			/* Classes applied to the filtering button when it is disabled  */
			"filterButtonDisabled": "ui-iggrid-filterbuttondisabled ui-state-disabled",
			/* Classes applied to the filter button when a date filter is defined for the column */
			"filterButtonDate": "ui-iggrid-filterbuttondate",
			/* Classes applied to the filter button when a string filter is applied for the column (default) */
			"filterButtonString": "ui-iggrid-filterbuttonstring",
			/* Classes applied to the filter button when a number filter is applied for the column (default) */
			"filterButtonNumber": "ui-iggrid-filterbuttonnumber",
			/* Classes applied to the filter button when a boolean filter is applied for the column (default) */
			"filterButtonBoolean": "ui-iggrid-filterbuttonbool",
			/* Classes applied on the advanced button when it is hovered */
			"filterButtonAdvancedHover": "ui-iggrid-filterbuttonadvancedhover ui-state-hover",
			/* Classes applied on the advanced button when it is selected */
			"filterButtonAdvancedActive": "ui-iggrid-filterbuttonadvancedactive ui-state-active",
			/* Classes applied on the advanced button when it has focus */
			"filterButtonAdvancedFocus": "ui-iggrid-filterbuttonadvancedfocus ui-state-focus",
			/* Classes applied on the advanced button when it is disabled */
			"filterButtonAdvancedDisabled": "ui-iggrid-filterbuttonadvanceddisabled ui-state-disabled",
			/* Classes applied to every filter dropdown list item's image icon area */
			"filterItemIcon": "ui-iggrid-filtericon",
			/* Classes applied to the item icon's container element */
			"filterItemIconContainer": "ui-iggrid-filtericoncontainer",
			/* Classes applied to the item icon's span when the item holds a startsWith condition */
			"filterItemIconStartsWith": "ui-iggrid-filtericonstartswith",
			/* Classes applied to the item icon's span when the item holds an endsWith condition */
			"filterItemIconEndsWith": "ui-iggrid-filtericonendswith",
			/* Classes applied to the item icon's span when the item holds a contains condition */
			"filterItemIconContains": "ui-iggrid-filtericoncontains",
			/* Classes applied to the item icon's span when the item holds a contains condition */
			"filterItemIconEquals": "ui-iggrid-filtericonequals",
			/* Classes applied to the item icon's span when the item holds a doesNotEqual condition */
			"filterItemIconDoesNotEqual": "ui-iggrid-filtericondoesnotequal",
			/* Classes applied to the item icon's span when the item holds a doesNotContain condition */
			"filterItemIconDoesNotContain": "ui-iggrid-filtericondoesnotcontain",
			/* Classes applied to the item icon's span when the item holds a greaterThan condition */
			"filterItemIconGreaterThan": "ui-iggrid-filtericongreaterthan",
			/* Classes applied to the item icon's span when the item holds a lessThan condition */
			"filterItemIconLessThan": "ui-iggrid-filtericonlessthan",
			/* Classes applied to the item icon's span when the item holds a greaterThanOrEqualTo condition */
			"filterItemIconGreaterThanOrEqualTo": "ui-iggrid-filtericongreaterthanorequalto",
			/* Classes applied to the item icon's span when the item holds a lessThanOrEqualTo condition */
			"filterItemIconLessThanOrEqualTo": "ui-iggrid-filtericonlessthanorequalto",
			/* Classes applied to the item icon's span when the item holds a true condition */
			"filterItemIconTrue": "ui-iggrid-filtericontrue",
			/* Classes applied to the item icon's span when the item holds a false condition */
			"filterItemIconFalse": "ui-iggrid-filtericonfalse",
			/* Classes applied to the item icon's span when the item holds an after condition */
			"filterItemIconAfter": "ui-iggrid-filtericonafter",
			/* Classes applied to the item icon's span when the item holds a before condition */
			"filterItemIconBefore": "ui-iggrid-filtericonbefore",
			/* Classes applied to the item icon's span when the item holds a today condition */
			"filterItemIconToday": "ui-iggrid-filtericontoday",
			/* Classes applied to the item icon's span when the item holds a yesterday condition */
			"filterItemIconYesterday": "ui-iggrid-filtericonyesterday",
			/* Classes applied to the item icon's span when the item holds a thisMonth condition */
			"filterItemIconThisMonth": "ui-iggrid-filtericonthismonth",
			/* Classes applied to the item icon's span when the item holds a lastMonth condition */
			"filterItemIconLastMonth": "ui-iggrid-filtericonlastmonth",
			/* Classes applied to the item icon's span when the item holds a nextMonth condition */
			"filterItemIconNextMonth": "ui-iggrid-filtericonnextmonth",
			/* Classes applied to the item icon's span when the item holds a thisYear condition */
			"filterItemIconThisYear": "ui-iggrid-filtericonthisyear",
			/* Classes applied to the item icon's span when the item holds a lastYear condition */
			"filterItemIconLastYear": "ui-iggrid-filtericonlastyear",
			/* Classes applied to the item icon's span when the item holds a nextYear condition */
			"filterItemIconNextYear": "ui-iggrid-filtericonnextyear",
			/* Classes applied to the item icon's span when the item holds an on condition */
			"filterItemIconOn": "ui-iggrid-filtericonon",
			/* Classes applied to the item icon's span when the item holds a notOn condition */
			"filterItemIconNotOn": "ui-iggrid-filtericonnoton",
			/* Classes applied to the item icon's span when the item holds a clear condition */
			"filterItemIconClear": "ui-iggrid-filtericonclear",
			/* Classes applied to the filtering block area, when the advanced filter dialog is opened and the area behind it is grayed out (that's the block area) */
			"blockArea": "ui-widget-overlay ui-iggrid-blockarea",
			/* Classes applied to the filter dialog element */
			"filterDialog": "ui-dialog ui-draggable ui-resizable ui-iggrid-dialog ui-widget ui-widget-content ui-corner-all",
			/* Classes applied to the filter dialog header caption area */
			"filterDialogHeaderCaption": "ui-dialog-titlebar ui-iggrid-filterdialogcaption ui-widget-header ui-corner-all ui-helper-reset ui-helper-clearfix",
			/* Class applied to the filter dialog header caption title */
			"filterDialogHeaderCaptionTitle": "ui-dialog-title",
			/* Classes applied to the filter dialog add condition area */
			"filterDialogAddCondition": "ui-iggrid-filterdialogaddcondition",
			/* Classes applied to the filter dialog add condition SELECT dropdown. */
			"filterDialogAddConditionDropDown": "ui-iggrid-filterdialogaddconditionlist",
			/* Classes applied to the filter dialog add button */
			"filterDialogAddButton": "ui-iggrid-filterdialogaddbuttoncontainer ui-helper-reset",
			/* Classes applied to the filter dialog OK and Cancel buttons. */
			"filterDialogOkCancelButton": "ui-dialog-buttonpane ui-widget-content ui-helper-clearfix ui-iggrid-filterdialogokcancelbuttoncontainer",
			/* Classes applied to the filter dialog filters table */
			"filterDialogFiltersTable": "ui-iggrid-filtertable ui-helper-reset",
			/* Classes applied to the "X" button used to remove filters from the filters table */
			"filterDialogFilterRemoveButton": "ui-icon ui-icon-closethick",
			/* Classes applied to the filter dialog "Clear All" button. */
			"filterDialogClearAllButton": "ui-iggrid-filterdialogclearall",
			/*Classes applied to the feature chooser icon when filter shows advanced dialog*/
			"featureChooserModalDialogIcon": "ui-icon ui-iggrid-icon-advanced-filter"
		},
		events: {
			/* cancel="true" Event fired before a filtering operation is executed (remote request or local). 
			Return false in order to cancel filtering operation.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.columnIndex to get column index.
			Use ui.columnKey to get column key.
            Use ui.expressions to get filtering expressions. Filtering expressions could be changed in this event handler and after that data binding is applied. In this way the user could control filtering more easily before applying data-binding.
			*/
			dataFiltering: "dataFiltering",
			/* Event fired after the filtering has been executed and results are rendered.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.columnIndex to get column index.
			Use ui.columnKey to get column key.
			*/
			dataFiltered: "dataFiltered",
			/* cancel="true" Event fired before the filter dropdown is opened for a specific column. 
			Return false in order to cancel dropdown opening.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.dropDown to get reference to dropdown DOM element.
			*/
			dropDownOpening: "dropDownOpening",
			/* Event fired after the filter dropdown is opened for a specific column. 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.dropDown to get reference to dropdown DOM element.
			*/
			dropDownOpened: "dropDownOpened",
			/* cancel="true" Event fired before the filter dropdown starts closing. 
            Return false in order to cancel dropdown closing.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.dropDown to get reference to dropdown DOM element.
			*/
			dropDownClosing: "dropDownClosing",
			/* Event fired after a filter column dropdown is completely closed. 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.dropDown to get reference to dropdown DOM element.
			*/
			dropDownClosed: "dropDownClosed",
			/* cancel="true" Event fired before the advanced filtering dialog is opened.
			Return false in order to cancel filter dialog opening.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.dialog to get reference to filtering dialog DOM element.
			*/
			filterDialogOpening: "filterDialogOpening",
			/* Event fired after the advanced filter dialog is already opened.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.dialog to get reference to filtering dialog DOM element.
			*/
			filterDialogOpened: "filterDialogOpened",
			/* Event fired every time the advanced filter dialog changes its position.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.dialog to get reference to filtering dialog DOM element.
			Use ui.originalPosition to get the original position of the groupby dialog div as { top, left } object, relative to the page.
            Use ui.position to get the current position of the groupby dialog div as { top, left } object, relative to the page.
			*/
			filterDialogMoving: "filterDialogMoving",
			/* cancel="true" Event fired before a filter row is added to the advanced filter dialog.
			Return false in order to cancel filter adding to the advanced filtering dialog.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.filtersTableBody to get reference to filters table body DOM element.			
			*/
			filterDialogFilterAdding: "filterDialogFilterAdding",
			/* Event fired after a filter row is added to the advanced filter dialog.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.filter to get reference to filters table row DOM element.	
			*/
			filterDialogFilterAdded: "filterDialogFilterAdded",
			/* cancel="true" Event fired before the advanced filter dialog is closed. 
			Return false in order to cancel filtering dialog closing.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			*/
			filterDialogClosing: "filterDialogClosing",
			/* Event fired after the advanced filter dialog has been closed.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			*/
			filterDialogClosed: "filterDialogClosed",
			/* cancel="true" Event fired before the contents of the advanced filter dialog are rendered. 
			Return false in order to cancel filtering dialog rendering.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.dialogElement to get reference to filtering dialog DOM element.	
			*/
			filterDialogContentsRendering: "filterDialogContentsRendering",
			/* Event fired after the contents of the advanced filter dialog are rendered.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.dialogElement to get reference to filtering dialog DOM element.	
			*/
			filterDialogContentsRendered: "filterDialogContentsRendered",
			/* Event fired when the OK button in the advanced filter dialog is pressed. 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridFiltering.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.dialog to get reference to filtering dialog DOM element.	*/
			filterDialogFiltering: "filterDialogFiltering"
		},
		_createWidget: function (options, element) {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			this.options.columnSettings = [];
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		_create: function () {
			this._editors = [];
			if (!$.fn.fadeToggle) {
				$.fn.fadeToggle = $.fn.toggle;
			}
            // feature chooser data
            this._fcData = {};
            // flag for feature chooser whether summary columns are analyzed
            this._isInitFC = false;
			if (this.options.filterDropDownAnimations === 'none') {
				this.options.filterDropDownAnimationDuration = 1;
				this.options.filterDropDownAnimations = 'linear';
			}
		},
		_setOption: function (key, value) {
			// handle new settings and update options hash
			$.Widget.prototype._setOption.apply(this, arguments);
			// options that are supported: filterDropDownWidth, filterDropDownHeight, filterDialogWidth, filterDialogHeight
			// start by throwing an error for the options that aren't supported:
			if (key === 'mode' || key === 'renderFilterButton' || key === 'filterButtonLocation' || key === 'type') {
				throw new Error($.ig.Grid.locale.optionChangeNotSupported + ' ' + key);
			}
			// handle filterDropDownWidth
			if (key === 'filterDropDownWidth') {
				this.grid.container().find('div ul').parent().css('width', value);
			// handle filterDropDownHeight
			} else if (key === 'filterDropDownHeight') {
				this.grid.container().find('div ul').parent().css('height', value);
			// handle filterDialogWidth
			} else if (key === 'filterDialogWidth') {
				$('#' + this.grid.container().attr('id') + '_dialog').css('width', value);
			// handle filterDialogHeight
			} else if (key === 'filterDialogHeight') {
				$('#' + this.grid.container().attr('id') + '_dialog').css('height', value);
            // handle columnSettings
			} else if (key === 'columnSettings') {
                // M.H. 1 Apr 2013 Fix for bug #130581: Rebinding igGrid after setting igGridFiltering.columnSetting at runtime causes an error
                this._initDefaultSettings();
            }
		},
		destroy: function () {
			/* destroys the filtering widget - remove fitler row, unbinds events, returns the grid to its previous state. */
			var i, fc, cols = this.grid.options.columns, block = $('#' + this.grid.id() + '_container_block'), dialog = $('#' + this.grid.id() + '_container_dialog');
			// remove the filter row, and it will take care of unbinding all events
			$('#' + this.grid.container()[0].id + ' .ui-iggrid-filterrow').remove();
			// also remove all filtering dropdowns
			$('#' + this.grid.container()[0].id + ' .ui-iggrid-filterdd').remove();
			// remove all filtering dropdowns
			for (i = 0; i < cols.length; i++) {
				$("#" + this.grid.id() + '_dd_' + cols[i].key).remove();
			}
			// and the advanced filter dialog and block area, if present (if Advanced filtering is enabled)
			// M.H. 29 Oct 2012 Fix for bug #120642
			block.remove();
			dialog.remove();
			this.grid.element.unbind('iggridheadercellrendered', this._headerCellRenderedHandler);
			this.grid.element.unbind('iggridheaderrendered', this._headerRenderedHandler);
			this.grid.element.unbind('iggridvirtualhorizontalscroll', this._virtualHorizontalScrollHandler);
			this.grid.element.unbind('iggridresizingcolumnresized', this._columnResizedHandler);
			this.grid.element.unbind('iggridheaderextracellsmodified', this._headerInitHandler);
			this.grid.element.unbind('iggrid_columnsmoved', this._columnsAlteredHandler);
			this.grid.element.unbind('iggriduidirty', this._onUIDirtyHandler);

			delete this._headerCellRenderedHandler;
			delete this._headerRenderedHandler;
			delete this._virtualHorizontalScrollHandler;
			delete this._columnResizedHandler;
			delete this._headerInitHandler;
			delete this._onUIDirtyHandler;
			delete this._columnsAlteredHandler;

			this._editors = null;
			this._fcData = null;
			this.options.columnSettings = null;
			this.options = null;
			if (this._loadingIndicator) {
				delete this._loadingIndicator;
			}
			if (this._filterInternal) {
				delete this._filterInternal;
			}

			if (this._toggleFilterRowHandler) {
				delete this._toggleFilterRowHandler;
			}
            // M.H. 4 Oct 2013 Fix for bug #151434: When filtering is advanced and advancedModeEditorsVisible = true the button for advanced filtering dialog is missing from the feature chooser.
            if (this._openFilterDialogFromFCHandler) {
                delete this._openFilterDialogFromFCHandler;
            }
			if (this._exitEditModeHandler) {
				delete this._exitEditModeHandler;
			}
			if (this._enterEditModeHandler) {
				delete this._enterEditModeHandler;
			}
			fc = this.grid.element.data('igGridFeatureChooser');
			if (fc && this.renderInFeatureChooser) {
				fc._removeFeature('Filtering');
				fc._removeFeature('AdvancedFiltering');
			}
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		_initLoadingIndicator: function () {
			// attach loading indicator widget
			this._loadingIndicator = this.grid.container().length > 0 ? this.grid.container().igLoading().data("igLoading") : this.grid.element.igLoading().data("igLoading").indicator();
		},
		// if uiDirty event is fired, it means that all subscribed features will need to reset their state. For example page size change triggers onUIDirty
		_onUIDirty: function (e, args) {
			var i, cols = this.grid.options.columns, condition;
			// A.T. 23 Aug 2011 - add additional checks so that events don't propagate across hierarchical grids
            if (args.owner === this || args.owner.element[0].id !== this.element[0].id) {
                return;
            }
            // reset all filtering states & UI
            this._filterDialogClearAll();
			if (this._editors !== null && this._editors !== undefined) {
				for (i = 0; i < this._editors.length; i++) {
					if (this.options.columnSettings[i].allowFiltering !== false) {
						this._editors[i].value(null);
                        // M.H. 2 Apr 2013 Fix for bug #138427: The condition set in the columnSettings of filtering feature is returned back to default after dataBind.
                        condition = null;
                        if (this.options.columnSettings[i].columnKey) {
                            condition = this.options.nullTexts[this._findColumnSetting(this.options.columnSettings[i].columnKey).condition];//this.options.columnSettings[i].condition;
                        }
                        if (condition === null || condition === undefined) {
                            condition = this.options.nullTexts[this._getDefaultCondition(cols[i].dataType)];
                        }
                        this._editors[i].element.igEditor(
							'option',
							'nullText',
                            condition
						);
					}
				}
			}
			// clear selected items in the dropdowns:
			for (i = 0; i < cols.length; i++) {
				$("#" + this.grid.id() + '_dd_' + cols[i].key).find('li').removeClass("ui-iggrid-filterddlistitemactive ui-state-active");
			}
			// clear tooltips
			$('.ui-iggrid-filterbutton', this.grid.container()).parent().attr('title', this.options.tooltipTemplate.replace('${condition}', this.options.labels.noFilter));
			// last but not least clear the filter expressions
			this.grid.dataSource.settings.filtering.expressions = [];
		},
		_dataRendered: function () {
			var defExpr, expr, matches = 0, grid = this.grid, summary = this.grid.container().find(".ui-iggrid-footer .ui-iggrid-results").eq(0),
				footer = summary.parent(), shouldInitHeights = false, isInitiallyFiltered = false, i;
			if (!this._loadingIndicator) {
				this._initLoadingIndicator();
			}
            // M.H. 6 Feb 2014 Fix for bug #160331: Hidden column is visible until the data is being fetched
            if (this._hiddenCells && this._hiddenCells.length > 0) {
                for (i = 0; i < this._hiddenCells.length; i++) {
                    this._hiddenCells[i].show();
                }
                this._hiddenCells = undefined;
            }
            // M.H. 19 Jul 2013 Fix for bug #147233: cannot set default filtering expressions in ig.DataSource (they aren't taken into account , similar to sorting default expressions)
            if (this._defaultExpressions && this._defaultExpressions.length > 0) {
                defExpr = this._defaultExpressions;
                this._defaultExpressions = [];
                this._updateFiltersUI(defExpr, false);
                isInitiallyFiltered = true;
                this._isFilteringRequest = true;
            }
            if (this._shouldFireDataFiltered) {
                this._shouldFireDataFiltered = false;
				this._trigger(this.events.dataFiltered, null, {columnKey: this._curColKey, columnIndex: this._curColIndex, owner: this});
			}
            // M.H. 17 May 2013 Fix for bug #142492: When you filter a column and then clear the filter the height of the grid decreases.
            if (!summary.is(':visible')) {
                shouldInitHeights = true;
            }
            // change filter summary
			if (this._isFilteringRequest === true) {
                if (this.options.filterSummaryAlwaysVisible === true && summary.length === 0) {
					// we need to render a footer
					footer = $('<div></div>').appendTo(this.grid.container()).addClass("ui-widget ui-helper-clearfix ui-corner-bottom ui-widget-header ui-iggrid-footer");
                    summary = $('<span></span>').appendTo(footer).addClass("ui-iggrid-results");
                    // M.H. 19 Jul 2013 Fix for bug #147233: cannot set default filtering expressions in ig.DataSource (they aren't taken into account , similar to sorting default expressions)
                    if (isInitiallyFiltered && this.grid.element.data("igGridPaging")) {
                        footer.attr('id', this.grid.element[0].id + '_pager');
                        summary.attr('id', this.grid.element[0].id + '_pager_label');
                    }
					shouldInitHeights = true;
				}
				if (this.options.type === "local" || (this.options.type === "remote" && this.grid.dataSource.hasTotalRecordsCount() === false)) {
					if (this.grid.dataSource._filter) {
						//matches = this.grid.dataSource.dataView().length; // this should be used when applyToAllData = false
						matches = this.grid.dataSource._filteredData.length;
					} else {
						matches = this.grid.dataSource._data.length;
					}
				// we need that when, say, both paging and filtering are enabled, and both are remote
				} else {
					matches = this.grid.dataSource.totalRecordsCount();
				}
                // M.H. 30 Jan 2014 Fix for bug #162407: Footer area remains after filter condition is removed
                if (!summary.parent().is(':visible')) {
                    summary.parent().show();
                    shouldInitHeights = true;
                }
				summary.text(this.options.filterSummaryTemplate.replace("${matches}", matches)).attr('title', this.options.labels.filterSummaryTitleLabel);
				summary.show();
				this._isFilteringRequest = false;
			} else if (this._isFilteringRequest === false) {
                // M.H. 30 Jan 2014 Fix for bug #162407: Footer area remains after filter condition is removed
                // if we have sorting + filtering in case we filter and then apply sorting twice we should check whether there are filtering expressions - and if there are we shouldn't hide footer/ footer info
                expr = this.grid.dataSource.settings.filtering.expressions || [];
				if (summary.data('hideflag') !== false && expr.length === 0) {
					summary.hide();
                    // M.H. 30 Jan 2014 Fix for bug #162407: Footer area remains after filter condition is removed
                    // we should be sure that we want to hide footer only if there aren't any other children(for instance paging is enabled and pager is rendered as a child)
                    // for instance if there is paging + filtering + sorting - when we filter column after that clear filtering, only label should be hidden. When sort by column summary.data('hideflag') will be true but we shouldn't hide the whole footer if paging is rendered
                    if (summary.parent().children().length === 1) {
                        summary.parent().hide();
                    }
				} else {
					summary.data('hideflag', true);
				}
                // M.H. 17 May 2013 Fix for bug #142492: When you filter a column and then clear the filter the height of the grid decreases.
                shouldInitHeights = true;
			}
			this._loadingIndicator.hide();
			if (shouldInitHeights) {
				this.grid._initializeHeights();
			}
            // M.H. 14 May 2013 Fix for bug #135074: With continuous virtualization rows expand to fill the height of the grid.
            // M.H. 1 Sep 2013 Fix for bug #153659: When fixed virtualization rows expand to fill the height of the grid after the grid is filtered
            if (grid.options.virtualization || grid.options.rowVirtualization) {
                // we should not call initializeHeights twice
                if (!shouldInitHeights) {
                    this.grid._initializeHeights();
                }
                if (grid._totalRowCount * grid._avgRowHeight <= parseInt(grid.options.height, 10)) {
					grid.element.height('');
					grid._avgRowHeight = grid._calculateAvgRowHeight();
					grid._setScrollContainerHeight(grid._totalRowCount * grid._avgRowHeight);
                }
            }
			this._setEditorsWidth();
		},
        _initFC: function () {
            /* check whether it should be rendered in Feature Chooser */
            var columnKey, i,
				fc = this.grid.element.data('igGridFeatureChooser'),
				o = this.options,
				cs = this.options.columnSettings,
                showAdvancedButton = (o.mode === "advanced" && o.advancedModeEditorsVisible === true),
				isAdvanced = (o.mode !== "simple" && o.advancedModeEditorsVisible === false);

            this._isInitFC = true;
            // if renderFC is disabled or column key is not found return
            if (o.renderFC === false) {
                return;
            }
            // instantiate igGridFeatureChooser = if it is defined
            if (fc !== null && fc !== undefined) {
				// M.H. 29 Oct 2012 Fix for bug #120642
				if (this._toggleFilterRowHandler === null || this._toggleFilterRowHandler === undefined) {
					this._toggleFilterRowHandler = $.proxy(this.toggleFilterRowByFeatureChooser, this);
				}
                // M.H. 4 Oct 2013 Fix for bug #151434: When filtering is advanced and advancedModeEditorsVisible = true the button for advanced filtering dialog is missing from the feature chooser.
                if (this._openFilterDialogFromFCHandler === null || this._openFilterDialogFromFCHandler === undefined) {
					this._openFilterDialogFromFCHandler = $.proxy(this._openFilterDialogFromFC, this);
				}
				for (i = 0; i < cs.length; i++) {
                    // check for the specified column whether allowFiltering is enabled
                    columnKey = cs[i].columnKey;
					if (columnKey &&
							cs[i].allowFiltering === true &&
							fc._shouldRenderInFeatureChooser(columnKey) === true) {
                        this._filterRowShown = true;
                        this._fcData[columnKey] = true;
                        // M.H. 4 Oct 2013 Fix for bug #151434: When filtering is advanced and advancedModeEditorsVisible = true the button for advanced filtering dialog is missing from the feature chooser.
						if (isAdvanced || showAdvancedButton) {
							fc._renderInFeatureChooser(columnKey, {
								name: 'AdvancedFiltering',
								// M.H. 13 Oct. 2011 Fix for bug #91007
								text: o.featureChooserTextAdvancedFilter,
								iconClass: this.css.featureChooserModalDialogIcon,
								isSelected: true,
								// M.H. 29 Oct 2012 Fix for bug #120642
								method: this._openFilterDialogFromFCHandler,
								updateOnClickAll: true,
								groupName: 'modaldialog',
								groupOrder: 3,
								order: 3
							});
						} 
                        if (!isAdvanced) {
							fc._renderInFeatureChooser(columnKey, {
								name: 'Filtering',
								// M.H. 13 Oct. 2011 Fix for bug #91007
								text: o.featureChooserText,
								textHide: o.featureChooserTextHide,
								iconClass: this.css.featureChooserModalDialogIcon,
								isSelected: true,
								// M.H. 29 Oct 2012 Fix for bug #120642
								method: this._toggleFilterRowHandler,
								updateOnClickAll: true,
								groupName: 'toggle',
								groupOrder: 1,
								order: 2,
								type: 'toggle',
								state: 'hide'
							});
						}
                    }
				}
            }
        },
		_columnResized: function () {
			if (this._filterRowShown !== false) {
				this._setEditorsWidth();
			}
		},
		_setEditorsWidth: function () {
			if (this.options.mode !== "simple" && this.options.advancedModeEditorsVisible !== true) {
				return;
			}

			var cs = this.options.columnSettings,
				cols = this.grid._visibleColumns(),
				cells = this.grid.headersTable()
					.find('thead tr[data-role=filterrow]')
					.first()
					.find('td')
					.not('[data-skip=true]'),
				cellWidth,
				i,
				j,
				skipColumn;

			for (i = 0; i < cols.length; i++) {
				// continue if filtering is disabled for that particular column
				for (j = 0; j < cs.length; j++) {
					if (cs[j].columnKey === cols[i].key && cs[j].allowFiltering === false) {
						skipColumn = true;
						break;
					}
				}
				if (skipColumn) {
					skipColumn = false;
					continue;
				}

				if (!$.ig.util.isOpera && ((this.grid.options.height && this.grid.options.fixedHeaders === true) || $.ig.util.isWebKit)) {
					//A.T. 10 April 2011 - changing from outerWidth to innerWidth, so that the borders width is accounted for, and excluded from the calculations 
					// if inner height is used, there is the border space remaining. if outer height is used, the editors /dropdowns are a bit cut on the right. 
					cellWidth = cells.eq(i).innerWidth();
				} else {
					cellWidth = cells.eq(i).width();
				}

				cellWidth -= cells.eq(i).data('buttonWidth');

				cells.eq(i).children('span').first().igEditor('option', 'width', cellWidth);
			}
		},
		_headerRendered: function (sender, args) {
			// render the filter row
			var thead, filterrow, i = 0, cell, w, button, cols = this.grid.options.columns, thCell,
				id, j, cs = this.options.columnSettings, skipColumn = false, buttonCss,
				showAdvancedInHeader = false, indicatorContainer, cancelFunc, ci, buttonWidth,
				isSimpleMode = (this.options.mode === "simple" || this.options.advancedModeEditorsVisible === true),
                // M.H. 17 Oct 2013 Fix for bug #155162: When it is used simple filtering and jquery version 1.9.1+ js error is thrown
                isToCheck = (this.grid._initialHiddenColumns && this.grid._initialHiddenColumns.length > 0);
            
			//A.T. if the event is fired from another grid, return ! (hierarchical grid scenarios where events are bubbling
			if (sender.target.id !== this.grid.element[0].id) {
				return;
			}
			// 1. find the correct THEAD
			thead = this.grid.container().find('thead');

			//A.T. take into account hierarchy
			/*
			if (this._hc === undefined) {
				this._hc = this.grid.container().find('.ui-iggrid-expandheadercell').length > 0;
			}
			*/
			// add the filter row
			//V1
			if (this.options.mode === "simple" || this.options.advancedModeEditorsVisible === true) {
				filterrow = $('<tr></tr>').appendTo(thead).addClass(this.css.filterRow).attr('data-role', 'filterrow');
				//if (this._hc === true) {
				//	$('<td></td>').appendTo(filterrow).css('border-width', 0);
				//}
				this.grid._headerInit(filterrow);
			} else {
				//V2: A.T. 27 Jan 2011
				filterrow = thead.find('tr:first');
			}
			cancelFunc = function (e) { e.preventDefault(); e.stopPropagation(); };
			// render the filter row cells
			/*
			if (this._hc === true) {
				ci = i + 1;
			} else {
				ci = i;
			}
			*/
            // M.H. 15 Oct 2013 Fix for bug #154835: When the grid has 100% width,  filtering is enabled and a column is hidden there is a white space on the right of the grid.
            if (isToCheck) {
                this._hiddenCells = [];
            }
            // find all cells marked with a data-skip attribute
            ci = i + filterrow.find("[data-skip=true]").length;
			for (i = 0; i < cols.length; i++, ci++) {
				// A.T. V1
				if (isSimpleMode === true) {
					cell = $('<td></td>').appendTo(filterrow).addClass(this.css.filterCell);
                    // M.H. 15 Oct 2013 Fix for bug #154835: When the grid has 100% width,  filtering is enabled and a column is hidden there is a white space on the right of the grid.
                    // this bug is caused because td for filtering cell is rendered and the IE8 layout engine takes into account its width. That's why we should hide this cell
                    // NOTE: later we should show this cell because if feature hiding is enabled and we show filtered cell then editors should be shown too
                    // M.H. 6 Feb 2014 Fix for bug #160331: Hidden column is visible until the data is being fetched
                    if (isToCheck && this._hiddenCells.length < this.grid._initialHiddenColumns.length) {
                        for (j = this.grid._initialHiddenColumns.length - 1; j >= 0; j--) {
                            if (this.grid._initialHiddenColumns[j].key === cols[i].key) {
                                cell.hide();
                                this._hiddenCells.push(cell);
                                break;
                            }
                        }
                    }
					// A.T. V2 27 Jan 2011
				} else {
					// M.H. 19 July 2012 Fix for bug #117306
					if (this.grid._isMultiColumnGrid) {
						cell  = $(this.grid._headerCells[ci]);
					} else {
						cell = $(filterrow[0].cells[ci]);
					}
					// Sorting and other features which modify the header 
					if (cell.children().first().is('a')) {
						cell.children().first().css('display', 'inline');
						cell.css('cursor', 'pointer');
					}
					//cell.data('colName', cols[i].headerText);
					cell.data('colName', cols[i].key);
				}

				if (this.grid._isMultiColumnGrid !== true || isSimpleMode === true) {
					if (i === cols.length - 1 && this.grid.options.height && parseInt(this.grid.options.height, 10) > 0) {
						// set last col width explicitly
						cell.css('width', parseInt(cols[i].width, 10) + this.grid._scrollbarWidth());
					} else {
						cell.css('width', cols[i].width);
					}
				}
				// continue if filtering is disabled for that particular column
				for (j = 0; j < cs.length; j++) {
					if (cs[j].columnKey === cols[i].key && cs[j].allowFiltering === false) {
						if (this.options.advancedModeEditorsVisible === true || this.options.mode !== "advanced") {
							this._editors.push({});
						}
						skipColumn = true;
						break;
					}
				}
				if (skipColumn) {
					skipColumn = false;
					continue;
				}
                thCell = thead.children().first().find('th:nth-child(' + (ci + 1) + ')');
                // M.H. 14 Mar 2013 Fix for bug #135924: Column headers are misalign in Safari when using filtering
                // M.H. 3 Apr 2013 Fix for bug #138576: DataSourceUrl with Filtering and RowSelectors throws error in Google Chrome
                // M.H. 8 Nov 2013 Fix for bug #157211: Column header misalignment when there are initially hidden columns under Android stock browser
                if ($.ig.util.isWebKit && thCell.length > 0) {
                    w = thCell[0].offsetWidth;
                } else if ((this.grid.options.height && this.grid.options.fixedHeaders === true) || $.ig.util.isWebKit) {
				// render editor in cell
                // L.A. 24 April 2012 - Fixed bug #83009 Last column's cell in the filter row doesn't look correct in Opera
                // Removed opera condition. It seems that the latest Opera version is rendering the content correctly.
					//A.T. 10 April 2011 - changing from outerWidth to innerWidth, so that the borders width is accounted for, and excluded from the calculations 
					// if inner height is used, there is the border space remaining. if outer height is used, the editors /dropdowns are a bit cut on the right. 
					w = thCell.innerWidth();
				} else {
					w = thCell.width();
				}
                // M.H. 12 Sep 2013 Fix for bug #151972: Setting renderFilterButton to false does not hide the filter button.
				showAdvancedInHeader = (this.options.advancedModeEditorsVisible === false &&
                        this.options.mode === "advanced" &&
                        this.options.renderFilterButton === true);
				if ((this.options.renderFilterButton === true && !showAdvancedInHeader) ||
						(showAdvancedInHeader && this._renderFCFor(cols[i].key) === false)) {
					id = this.grid.element.attr('id') + '_dd_' + cols[i].key;
					// render the dropdown associated with that button
					if (this.options.advancedModeEditorsVisible === true || this.options.mode !== "advanced") {
						this._renderDropDown(cols[i].dataType, id, cols[i].key);
					}
					buttonCss = this.options.mode === "advanced" ? this.css.filterButtonAdvanced : this.css.filterButton;
					if (showAdvancedInHeader && this.options.advancedModeHeaderButtonLocation === "right") {
						buttonCss = this.css.filterButtonAdvancedRight;
						button = $('<span></span>').appendTo(cell).addClass(buttonCss).data('colIndex', i);
					} else {
						button = $('<span></span>').prependTo(cell).addClass(buttonCss).data('colIndex', i);
					}
                    // M.H. 1 Nov 2013 Fix for bug #156411: Advanced filtering icon spans the header of the grid on two rows
                    if (this.options.mode === "advanced") {
                        if (!cell.hasClass(this.grid.css.headerCellFeatureEnabledClass)) {
                            cell.addClass(this.grid.css.headerCellFeatureEnabledClass);
                        }
                    }
					if (this.options.mode === "simple" ||
							(this.options.mode === "advanced" && this.options.advancedModeEditorsVisible === true)) {
						button.wrap('<a id="' + id + '_button" href="#" title="' + this.options.tooltipTemplate.replace('${condition}', this.options.labels.noFilter) + '" ></a>');
					} else {
						button.wrap('<a id="' + id + '_button" href="#" title="' + this.options.tooltipTemplate.replace('${condition}', this.options.labels.noFilter) + '" style="display:inline;"></a>');
					}
					indicatorContainer = cell.find('.ui-iggrid-indicatorcontainer');

					if (indicatorContainer.length === 0) {
						indicatorContainer = $('<div></div>').appendTo(cell).addClass('ui-iggrid-indicatorcontainer');
					}

					indicatorContainer.append(button.parent());
					w = parseInt(w, 10);
					if (this.grid.options.height === null && $.ig.util.isFF) {
						buttonWidth = button.outerWidth(true);
					} else {
						buttonWidth = button.outerWidth(false);
					}
					w -= buttonWidth;
					cell.data('buttonWidth', buttonWidth);
				}
				if (this.options.renderFilterButton === true) {
					if (this.options.advancedModeEditorsVisible === true || this.options.mode !== "advanced") {
						button.parent().bind({
							mousedown: $.proxy(this._toggleDropDown, this),
							mouseup: cancelFunc,
							click: cancelFunc,
							blur: $.proxy(this._closeDropDown, this),
							keydown: $.proxy(this._toggleDropDownKeyboard, this),
							mouseover: $.proxy(this._hoverButton, this),
							mouseout: $.proxy(this._unhoverButton, this),
							focus: $.proxy(this._activateButton, this)
						});
                        // L.A. 08 May 2012 Fixing bug #106229 - Filtering dropdown item list does not close after you select item in IE7.
						// L.A. 17 October 2012 Fixing bug #120937 - Filter dropdown is not hiding in IE 9 compatibility mode when the grid is inside tab
						// Browser mode may be IE9, but rendering mode may be IE7 or IE8
                        if (document.documentMode === 5 || document.documentMode === 7 || $.ig.util.isIE7) {
                            button.parent().bind({
                                focusout: $.proxy(this._closeDropDown, this)
                            });
                        }
					} else if (this._renderFCFor(cols[i].key) === false) {
						button.parent().bind({
							click: $.proxy(this._openFilterDialog, this),
							keydown: $.proxy(this._openFilterDialogFromKeyboard, this),
							focus: $.proxy(this._activateButton, this),
							blur: $.proxy(this._deactivateButton, this)
						});
					}
				}
				if (this.options.advancedModeEditorsVisible === true || this.options.mode !== "advanced") {
					this._createEditor(cell, w, i, cols[i].dataType, cols[i].key, cols[i]);
				}
			}
			// if advanced filtering is enabled we will also render the advanced filtering dialog
			// NOTE that it is only a single dialog for the whole grid, not per column !
			if ($('#' + this.grid.container().attr('id') + '_dialog').length > 0) {
				$('#' + this.grid.container().attr('id') + '_dialog').remove();
			}
			this._renderFilterDialog();
		},
        _renderFCFor: function (columnKey) {
            // returns whether it should be rendered in Feature Chooser for the specified columnKey
			return !(this._fcData === null ||
						this._fcData === undefined ||
						this.options.renderFC === false ||
						this._fcData[columnKey] !== true
                    );
        },
        _columnMap: function () {
            var o = this.options,
                i,
                elem,
                cs = o.columnSettings,
                csLength = cs.length,
                result = [];

            if (o.renderFC === false) {
                return false;
            }

            for (i = 0; i < csLength; i++) {
                elem = {columnKey: cs[i].columnKey, enabled: true};
                if (cs[i].allowFiltering === false) {
                    elem.enabled = false;
                }
                result.push(elem);
            }

            return result;
        },
        _headerCellRendered: function (event, ui) {
            if (this._isInitFC !== true) {
                this._initFC();
            }
        },
        // M.H. 4 Oct 2013 Fix for bug #151434: When filtering is advanced and advancedModeEditorsVisible = true the button for advanced filtering dialog is missing from the feature chooser.
        _openFilterDialogFromFC: function (event, columnKey) {
            this._openFilterDialog(event, columnKey);
        },
		// M.H. 30 March 2012 Fix for bug #106217
        toggleFilterRowByFeatureChooser: function (event) {
			/* toggle filter row when mode is simple or advancedModeEditorsVisible is TRUE. Otherwise show/hide advanced dialog
				paramType="object" Represents click event object
			*/
            var fc,
				o = this.options,
                isShown = this._filterRowShown,
                $thead = this.grid.container().find('thead'),
                $filterRow,
                isAdvanced = !(o.mode === "simple" || o.advancedModeEditorsVisible === true);

            if (isShown === null || isShown === undefined) {
                this._filterRowShown = true;
                isShown = this._filterRowShown;
            }
            if (isAdvanced === false || (isAdvanced && o.advancedModeEditorsVisible)) {
                $filterRow = $thead.find('tr[data-role="filterrow"]');
                if (isShown === true) {
                    $filterRow.hide();
                    // M.H. 14 Feb 2013 Fix for bug #132858
                    if (document.documentMode === 7 || $.ig.util.isIE7) {
                        $filterRow.children().hide();
                    }
                    isShown = false;
                } else {
                    $filterRow.show();
                    // M.H. 14 Feb 2013 Fix for bug #132858
                    if (document.documentMode === 7 || $.ig.util.isIE7) {
                        $filterRow.children().show();
                    }
					this._setEditorsWidth();
                    isShown = true;
                }
				// M.H. 2 Aug 2012 Fix for bug #118136
				// not called by FeatureChooser
				// M.H. 9 Apr 2014 Fix for bug #169578: igGridFiltering.toggleFilterRowByFeatureChooser method doesn't update feature chooser labels.
				if (event === null || event === undefined) {
					fc = this.grid.element.data('igGridFeatureChooser');
					if (fc) {
						fc._toggleSelectedItems("Filtering");
					}
				}
                // M.H. 21 Jun 2013 Fix for bug #143614: When grid is hierarchical with continuous virtualization and feature chooser is enabled height of rows is unnecessarily increased
                this._filterRowShown = isShown;
                this.grid._initializeHeights();
				// M.H. 10 May 2012 Fix for bug #110952
				this.grid._adjustLastColumnWidth(true);
            }
        },
		_createEditor: function (parent, w, colIndex, colType, colKey, col) {
			var editor, options, type = this._getEditorType(colType), isDatePicker = (type === 'datepicker');
			editor = $('<span />').css('float', 'left').css('width', '5px');
			if (this.options.filterButtonLocation === "left") {
				editor.appendTo(parent);
			} else {
				editor.prependTo(parent);
			}
			// M.H. 29 Oct 2012 Fix for bug #120642
			if (this._enterEditModeHandler === undefined || this._enterEditModeHandler === null) {
				this._enterEditModeHandler = $.proxy(this._fireEnterEditModeEvents, this);
			}
			if (this._exitEditModeHandler === undefined || this._exitEditModeHandler === null) {
				this._exitEditModeHandler = $.proxy(this._fireExitEditModeEvents, this);
			}
			options = {
				textChanged: $.proxy(this._filter, this),
				width: w,
				disabled: (this.grid.options.columns[colIndex].dataType === "bool" || this.grid.options.columns[colIndex].dataType === "boolean"),
				type: type,
				textAlign: 'left',
				button: isDatePicker ? 'dropdown' : null,
				// fix for bug #76266
				maxDecimals: 6,
				nullText: this.options.nullTexts[this._findColumnSetting(colKey).condition],
				// M.H. 29 Oct 2012 Fix for bug #120642
				focus: this._enterEditModeHandler,
				// M.H. 29 Oct 2012 Fix for bug #120642
				blur: this._exitEditModeHandler,
				//_utc: true
				enableUTCDates: this.grid.options.enableUTCDates
			};
			// M.H. 28 May 2014 Fix for bug #172388: Date filter editor doesn't take into account grid's column format
			if (isDatePicker && col.format) {
				options.dateInputFormat = col.format;
			}
			editor.data('colIndex', colIndex).data('colKey', colKey);
			editor.igEditor(options);
			this._editors.push(editor.data('igEditor'));
			// A.T. 29 Dec 2010
			editor.find('input').addClass(this.css.filterCellEditor);
			// M.H. 29 Oct 2012 Fix for bug #120642
			//return editor;
		},
		_columnsAltered: function (event, args) {
			var i, cs, start = args.start, len = args.len, idx = args.index;
			for (i = 0; i < this.options.columnSettings.length; i++) {
				cs = this.options.columnSettings[i];
				if (this.grid._isColumnHidden(cs.columnKey) === true) {
					start += i <= start ? 1 : 0;
					len += i >= start && i < start + len ? 1 : 0;
					idx += i <= idx ? 1 : 0;
				}
			}
			this.grid._rearrangeArray(this.options.columnSettings, start, len, idx);
			this.grid._rearrangeArray(this._editors, start, len, idx);
			for (i = 0; i < this._editors.length; i++) {
				$(this._editors[i].element).data('colIndex', i);
				$(this._editors[i].element).closest("td").find("span.ui-iggrid-filterbutton").data('colIndex', i);
			}
		},
		_getEditorType: function (type) {
			return (type === 'date') ? 'datepicker' : ((type === 'number') ? 'numeric' : 'text');
		},
		_findColumnSetting: function (key) {
			var i;
			for (i = 0; i < this.options.columnSettings.length; i++) {
				if (this.options.columnSettings[i].columnKey === key) {
					return this.options.columnSettings[i];
				}
			}
		},
		// Accepts parameters:
		// expressions - a list of filtering expressions (objects) 
		// updateUI - flag specifying whether the filter row UI should also be updated when applying the filter 
		filter: function (expressions, updateUI, addedFromAdvanced) {
			/* Applies filtering programmatically and updates the UI by default
				paramType="array" An array of filtering expressions, each one having the format {fieldName: , expr: , cond: , logic: } where  fieldName is the key of the column, expr is the actual expression string with which we would like to filter, logic is 'AND' or 'OR', and cond is one of the following strings: "equals", "doesNotEqual", "contains", "doesNotContain", "greaterThan", "lessThan", "greaterThanOrEqualTo", "lessThanOrEqualTo", "true", "false", "null", "notNull", "empty", "notEmpty", "startsWith", "endsWith", "today", "yesterday", "on", "notOn", "thisMonth", "lastMonth", "nextMonth", "before", "after", "thisYear", "lastYear", "nextYear". The difference between the empty and null filtering conditions is that empty includes null, NaN, and undefined, as well as the empty string.
				paramType="bool" optional="true" specifies whether the filter row should be also updated once the grid is filtered 
				paramType="bool" excluded="true"
			*/
            this._loadingIndicator.show();
			if (expressions !== undefined && expressions.length > 0) {
				this._isFilteringRequest = true;
			}
			if (!addedFromAdvanced) {
				this._filterDataSource(expressions, true);
                // M.H. 5 Mar 2013 Fix for bug #120009: When filtering through the API method you are unable to apply multiple filters through separate calls.
                this._updateFiltersUI([], false);
			} else {
				this._filterDataSource(expressions);
			}
			if (updateUI === undefined || updateUI === true) {
				this._updateFiltersUI(expressions === undefined ? this._generateExpressions() : expressions, addedFromAdvanced);
			}
		},
		_filter: function (ui, args) {
			clearTimeout(this._timeoutId);
			this._ui = ui;
			this._args = args;
            if (parseInt(this.options.filterDelay, 10) === 0) {
                this._filterInternal();
			} else {
                this._timeoutId = setTimeout($.proxy(this._filterInternal, this), this.options.filterDelay);
			}
		},
		// Restore old selection after editor got focus by request in _filterInternal.
		// Selection can be lost when grid is repainted and headers are temporary hidden.
		_fireEnterEditModeEvents: function (evt, ui) {
			var sel = ui && ui.owner ? ui.owner._grid_sel : null;
			if (sel) {
				// assume that getting focus after filtering will not take longer than 1s
				if (sel.time + 1000 > new Date().getTime()) {
					ui.owner.select(sel.sel);
				}
				this.grid._synchronizeHScroll();
				delete ui.owner._grid_sel;
			}
		},
		_filterInternal: function (colIndex, colKey) {
			// determine the column
			var args = this._args, _colIndex, _colKey, noCancel, editor, exprs;
			if (args !== undefined) {
				_colIndex = $(args.owner.element).data('colIndex');
				_colKey = $(args.owner.element).data('colKey');
			} else {
				_colIndex = colIndex;
				_colKey = colKey;
			}
            // M.H. 14 Jan 2014 Fix for bug #161067: Using the after filter condition will leave values from the selected date unfiltered.
            // we want first to generate expressions so we pass it as arguments to the dataFiltering event. In this way we will allow users to manipulate filtering expressions before databinding
            exprs = this._generateExpressions(true);
			noCancel = this._trigger(this.events.dataFiltering, null, {columnKey: _colKey, columnIndex: _colIndex, owner: this, expressions: exprs});
			if (noCancel) {
				// M.H. 1 Oct 2012 Fix for bug #123198
				this.grid._isToSetUnboundColumns = true;
				this._loadingIndicator.show();
				editor = this._editors ? this._editors[_colIndex] : null;
				// mark the column so that we know it's not generated from the advanced filters 
				if (editor) {
					editor._addedFromAdvanced = false;
				}
				this._curColKey = _colKey;
				this._curColIndex = _colIndex;
				this._filterDataSource(exprs, false, true);
				if (editor) {
					// save old selection (see _fireEnterEditModeEvents)
					editor._grid_sel = { time: new Date().getTime(), sel: editor._sel0 };
					editor.setFocus();
				}
				//this._trigger(this.events.dataFiltered, null, {columnKey: _colKey, columnIndex: _colIndex, owner: this});
			}
		},
		_filterDataSource: function (expressions, apiCall, updateUI) {
            // updateUI is bool - it is possible expressions to be generated but we should update button title
			var exprs, i, j, button, groupBy, cols = this.grid.options.columns, found = false, defaultTooltip, noCancel; // i, exprs;
			defaultTooltip = this.options.tooltipTemplate.replace('${condition}', this.options.labels.noFilter);
			if (expressions !== undefined && !updateUI) {
                // L.A. 09 May 2012 - reset all filtering states & UI on each new api call
                if (apiCall === true) {
					// M.H. 5 Mar 2013 Fix for bug #120009: When filtering through the API method you are unable to apply multiple filters through separate calls.
					this.grid.dataSource.settings.filtering.expressions = expressions;
                    this._filterDialogClearAll();
                    for (i = 0; i < expressions.length; i++) {
                        this._addFilterFromDialog(null, expressions[i]);
                    }
                } else {
					// L.A. 24 September 2012 - fixing bug #122228
					// Grid -> Advanced Filtering sample-> filter condition is not cleared
					// Different behavior needs to be applied. If the call is from the API
					// then the expressions should be agregated
					// Otherwise the call is made from the UI and the expressions needs
					// to be replaced
					this.grid.dataSource.settings.filtering.expressions = expressions;
				}
			} else {
                if (expressions !== undefined && updateUI) {
                    exprs = expressions;
                } else {
					exprs = this._generateExpressions(true);
                }
				// update the tooltips, since we are doing simple filtering (expressions are not provided)
				for (i = 0; i < cols.length; i++) {
					found = false;
					button = $('#' + this.grid.element[0].id + '_dd_' + cols[i].key + '_button');
					for (j = 0; j < exprs.length; j++) {
						if (cols[i].key === exprs[j].fieldName) {
							found = true;
							if ((exprs[j].expr === undefined || exprs[j].expr === null || exprs[j].expr === '') && this._requiresEntry(exprs[j].cond)) {
								button.attr('title', defaultTooltip);
							} else {
								//button.attr('title', exprs[j].fieldName + ' ' + exprs[j].cond + ' ' + exprs[j].expr + ' ');
								button.attr('title', this.options.tooltipTemplate.replace('${condition}', exprs[j].cond));
							}
							break;
						}
					}
					if (!found) {
						// place the default no filter 
						button.attr('title', defaultTooltip);
					}
				}
				this.grid.dataSource.settings.filtering.expressions = exprs;
			}
			if (this.options.persist) {
				this._saveFilteringExpressions();
			}
            // M.H. 23 Jan 2013 Fix for bug #130586
            if (this.grid._hasUnboundColumns) {
                this.grid._rebindUnboundColumns = true;
            }
			// A.T. 13 April 2011 fix for bug #72284
			this.grid.element.trigger('iggriduisoftdirty', {owner: this});
			noCancel = this.grid._trigger(this.grid.events.dataBinding, null, {owner: this.grid});
			if (noCancel) {
				exprs = this.grid.dataSource.settings.filtering.expressions;

				// A.T. fix for bug #73509
				// it's important that paging also resets its "current" page Index, otherwise the paging dropdown, etc. won't be refreshed. 
                // L.A. 03 May 2012 Fixed bug #110881
                // If filtering is done local (only the selected page is filtered) then the pageIndex should not be changed to 0
                if (this.options.type === "remote") {
					this.grid.dataSource.settings.paging.pageIndex = 0;
					this.grid._shouldResetPaging = true;
                } else if (this.grid.container().find(".ui-iggrid-footer .ui-iggrid-results").length > 0) {
                    // M.H. 8 Mar 2013 Fix for bug #135130: When paging is defined after filtering and on filtering the footer is pagerRecordsLabelTemplate istead of filterSummaryTemplate
                    this.grid.container().find(".ui-iggrid-footer .ui-iggrid-results").data('overrideLabel', exprs.length);
                }
                this._isFilteringRequest = true;
				this._preserveSorting();
				if (exprs.length === 0) {
					// A.T. 4 April 2011 - Fix for bug #66210
					//this._isFilteringRequest = false;
					if (!apiCall) {
						this._shouldFireDataFiltered = true;
					}
					// M.H. 15 Feb 2013 Fix for bug #132957
					if (this.options.type === "remote") {
                        this._isFilteringRequest = false;
						this.grid.dataSource.dataBind();
					} else {
						this.grid.dataSource.settings.filtering.type = "local";
						this._isFilteringRequest = false;
						this.grid.dataSource.clearLocalFilter();
                        // M.H. 24 Jun 2013 Fix for bug #145179: Grouped rows are not correct while clearing the filtered data after ungrouping. 
                        groupBy = this.grid.element.data("igGridGroupBy");
						if (groupBy && groupBy.options && groupBy.options.groupedColumns && groupBy.options.groupedColumns.length > 0) {
                            if (this.grid.dataSource.settings.sorting.expressions.length > 0 && groupBy.options.type === 'local') {
                                this.grid.dataSource.sort(this.grid.dataSource.settings.sorting.expressions);
							}
                        }
						this.grid._renderData();
					}
				} else {
					if (this.options.type === "remote") {
						if (!apiCall) {
							this._shouldFireDataFiltered = true;
						}
						this.grid.dataSource.dataBind();
					} else {
						this.grid.dataSource.settings.filtering.type = "local";
						this.grid.dataSource.filter(exprs);
                        // M.H. 14 Oct 2013 Fix for bug #154649: Rows are grouped incorrectly when applying and removing a filter if a filter is applied by default through code
                        // when there is initial filtering and then groupby is applied the dataSource is not sorted(if first groupBy is applied the whole dataSource is sorted and then filtering and groupby works properly)
                        // and filtering again causes issues
                        groupBy = this.grid.element.data("igGridGroupBy");
						if (groupBy && groupBy.options && groupBy.options.groupedColumns && groupBy.options.groupedColumns.length > 0) {
                            if (this.grid.dataSource.settings.sorting.expressions.length > 0 && groupBy.options.type === 'local' &&
                                this.grid.dataSource._allDataSorted === false) {
                                this.grid.dataSource.sort(this.grid.dataSource.settings.sorting.expressions);
							}
                        }
						// L.A. 07 January 2013 - Fixing bug #129527 dataBound event is fired twice on filtering
						// dataBound event is immediately fired in _renderData, therefore it should be commented here
						//this.grid._trigger(this.grid.events.dataBound, null, {owner: this.grid});
						this.grid._renderData();
						if (!apiCall) {
							this._trigger(this.events.dataFiltered, null, {columnKey: this._curColKey, columnIndex: this._curColIndex, owner: this});
						}
					}
				}
			}
		},
		_filterDataSourceClear: function (colKey, colIndex) {
			var i, exprs = this._generateExpressions(true), noCancel, noCancelFiltering;
			for (i = 0; i < exprs.length; i++) {
				if (exprs[i].fieldName === colKey) {
					//A.T. 8 March 2012 - Fix for bug #104244 
					//exprs.remove(i);
					$.ig.removeFromArray(exprs, i);
					break;
				}
			}
			this.grid.dataSource.settings.filtering.expressions = exprs;
			// M.H. 25 Feb 2014 Fix for bug #165286: Filter expression is kept after dataBind when  "Clear Filter" condition is applied and persistence is enabled
			if (this.options.persist) {
				this._saveFilteringExpressions();
			}
			// trigger dirty so that any other features reset their UI and state 
            this.grid.element.trigger('iggriduidirty', {owner: this});
			// A.T. 22 Nov 2011 - fix for bug #90396
			if (!this._curColKey || colKey) {
				this._curColKey = colKey;
				this._curColIndex = colIndex;
			}
            // M.H. 14 Jan 2014 Fix for bug #161067: Using the after filter condition will leave values from the selected date unfiltered.
			noCancelFiltering = this._trigger(this.events.dataFiltering, null, {columnKey: this._curColKey, columnIndex: this._curColIndex, owner: this, expressions: exprs});
			if (noCancelFiltering) {
				noCancel = this.grid._trigger(this.grid.events.dataBinding, null, {owner: this.grid});

				if (noCancel) {

					this.grid.dataSource.settings.paging.pageIndex = 0;
					this._preserveSorting();
					this.grid._shouldResetPaging = true;
					// M.H. 1 Oct 2012 Fix for bug #123198
					this.grid._isToSetUnboundColumns = true;
					// L.A. 24 October 2012 - Fixing bug #125473 Clearing the last remaining filtering expression causes a data rebinding (local filtering)
					if (this.options.type === "remote") {
						if (exprs.length > 0) {
							this._shouldFireDataFiltered = true;
						} else {
                            // M.H. 13 Feb 2013 Fix for bug #131548
							this._isFilteringRequest = false;
							this._shouldFireDataFiltered = true;
						}
						this.grid.dataSource.dataBind();
					} else {
						this.grid.dataSource.settings.filtering.type = "local";
                        // M.H. 8 Mar 2013 Fix for bug #135130: When paging is defined after filtering and on filtering the footer is pagerRecordsLabelTemplate istead of filterSummaryTemplate
                        if (this.grid.container().find(".ui-iggrid-footer .ui-iggrid-results").length > 0) {
                            this.grid.container().find(".ui-iggrid-footer .ui-iggrid-results").data('overrideLabel', exprs.length);
                        }
						if (exprs.length > 0) {
							this.grid.dataSource.filter(exprs);
						} else {
							this._isFilteringRequest = false;
							this.grid.dataSource.clearLocalFilter();
						}
						this.grid._renderData();
						this._trigger(this.events.dataFiltered, null, { columnKey: this._curColKey, columnIndex: this._curColIndex, owner: this });
					}
				}
			}
		},
		_preserveSorting: function () {
			// we need to be aware if there are groupedColumns or not. If there aren't we shouldn't do this. 
			// A.T. Fix for bug #91599
			var hasGroupedCols = false, groupBy = this.grid.element.data("igGridGroupBy");
			if (groupBy && groupBy.options && groupBy.options.groupedColumns && groupBy.options.groupedColumns.length > 0) {
				hasGroupedCols = true;
			}
			if (this.grid.dataSource.settings.sorting.expressions.length > 0 && hasGroupedCols) {
				this.grid.dataSource.settings.sorting.defaultFields = this.grid.dataSource.settings.sorting.expressions;
			}
		},
		// M.H. 11 Mar 2014 Fix for bug #166528: Sorting and Filtering does not persist its state, when they are applied to unbound column
		_getDataColumnFilteringExpressions: function (fe) {
			// return only those filtering expressions that are for data bound columns(for which property unbound is not equal to TRUE)
			if (!this.grid._hasUnboundColumns) {
				return fe;
			}
			var grid = this.grid, newFE;
			newFE = $.grep(fe, function (s) {
				var col = grid.columnByKey(s.fieldName);
				return !col || col.unbound !== true;
			});
			return newFE;
		},
		_saveFilteringExpressions: function () {
			var fe = this._getDataColumnFilteringExpressions(this.grid.dataSource.settings.filtering.expressions);
			if (this.element.closest('.ui-iggrid-root').data('igGrid')) {
				this.grid._savePersistenceData(fe, 'filtering', this.grid.element[0].id);
			}
			this._filteringExpressions = fe;
		},
		_preserveFiltering: function () {
			var fe = this._filteringExpressions || this.grid._getPersistenceData('filtering', this.grid.element[0].id);
			if (fe) {
				// M.H. 11 Mar 2014 Fix for bug #166528: Sorting and Filtering does not persist its state, when they are applied to unbound column
				// because the first time we rebind _onUIDirty is not called we use a hack for removing the value in editors
				if (this.grid._hasUnboundColumns) {
					this._updateFiltersUI([], false);
				}
				this.grid.dataSource.settings.filtering.expressions = fe;
				this.grid.dataSource.settings.filtering.defaultFields = fe;
				// we need to set _defaultExpressions - used to populate UI editors
				this._defaultExpressions = fe;
			}
		},
		_updateFiltersUI: function (expressions, addedFromAdvanced) {
			var i, j, editor, filterList, items;
			// L.A. 10 October 2012 - Fixing bug #124163
			// Filter method does not update the UI when empty array is used and updateUI=true
			// M.H. 20 May 2013 Fix for bug #141618: When advancedModeEditorsVisible option is true, deleting an expression from the advanced filtering dialog does not change the value from the filtering editor.
			if (this._editors) {//expressions.length === 0 && 
				// make sure we update (clear) the inputs 
				for (i = 0; i < this._editors.length; i++) {
					if (this.options.columnSettings[i].allowFiltering !== false) {
						this._editors[i].value(null);
						//this._editors[i]._addedFromAdvanced = false;
					}
				}
			}
			for (i = 0; i < expressions.length; i++) {
				//1.  update the selected item in the filter dropdown
				filterList = $('#' + this.grid.element[0].id + '_dd_' + expressions[i].fieldName).find('ul');
				items = filterList.children();
				for (j = 0; j < items.length; j++) {

					if ($(items[j]).data('cond') === expressions[i].cond) {
						// update selection
						// L.A. 29 October 2012 - Fixing bug #124166 - Filter client API method doesn't rebind the grid
						this._selectDropDownItem({currentTarget: items[j]}, null, expressions[i]);
						break;
					}
				}
				//2. update the editor text (and value)
				editor = this._editors[this._columnIndexFromKey(expressions[i].fieldName)];
				// L.A. 06 November 2012 - Fixing bug #126543
				// igGridFiltering.filter method throws an error when filtered column is configured with allowFiltering: false
				if (editor !== undefined && editor !== null && editor.value) {
					editor.value(expressions[i].expr);
					editor._addedFromAdvanced = true;
				}
			}
			this._updateTooltips(expressions);
		},
		_updateTooltips: function (expressions) {
			var button, title, found, titleText, tempTooltipExpr, cols = this.grid.options.columns, colsLength = cols.length, i, j, expressionFieldName,
                isSimpleMode = (this.options.mode === "simple" || this.options.advancedModeEditorsVisible === true);
			titleText = this.options.tooltipTemplate.replace('${condition}', this.options.labels.noFilter);
			title = '';
			for (i = 0; i < expressions.length; i++) {
				// update the advanced filtering tooltips
				// 1. find the tooltip for the column
				button = $('#' + this.grid.element[0].id + '_dd_' + expressions[i].fieldName + '_button');
				// A.T. 1 Sept 2011 - fix for bug #85220
				if (!this._requiresEntry(expressions[i].cond) || expressions[i].expr === undefined || expressions[i].expr === null) {
					tempTooltipExpr = '';
				} else {
					tempTooltipExpr = expressions[i].expr;
                    // M.H. 1 Apr 2013 Fix for bug #137908: Date filter value is one day behind the selected date
                    if (expressions[i].type === 'date') { 
                        if ($.type(tempTooltipExpr) === 'number') {
                            tempTooltipExpr = new Date(tempTooltipExpr);
                        }
                        if (this.grid.options.enableUTCDates && $.type(tempTooltipExpr) === 'date' && tempTooltipExpr.toUTCString) {
                            tempTooltipExpr = tempTooltipExpr.toUTCString();
                        }
                    }
				}
                // M.H. 2 Apr 2013 Fix for bug #137910: Column filter tooltip shows the column key instead of column header when using Advanced filtering
                expressionFieldName = expressions[i].fieldName;
                for (j = 0; j < colsLength; j++) {
					if (cols[j].key === expressionFieldName) {
                        expressionFieldName = cols[j].headerText;
						break;
					}
				}
                // M.H. 17 Sep 2013 Fix for bug #148955: Filtering tooltip is different when filter through UI and API
                if (isSimpleMode) {
                    button.attr('title', this.options.tooltipTemplate.replace('${condition}', expressions[i].cond));
                    continue;
                }
                if (i === 0) {
					button.attr('title', expressionFieldName + ' ' + expressions[i].cond + ' ' + tempTooltipExpr + ' ');
				} else {
					button.attr('title', title + expressions[i].logic + ' ' + expressionFieldName + ' ' + expressions[i].cond + ' ' + tempTooltipExpr + ' ');
				}
				title = button.attr('title');
			}
			// if some column doesn't have a filter applied, we should update its tooltip to match the "no filter" tooltip 
			for (i = 0; i < colsLength; i++) {
				found = false;
				for (j = 0; j < expressions.length; j++) {
					if (expressions[j].fieldName === cols[i].key) {
						found = true;
						break;
					}
				}
				if (!found) {
					// update tooltip
					$('#' + this.grid.element[0].id + '_dd_' + cols[i].key + '_button').attr('title', titleText);
				}
			}
		},
		_columnIndexFromKey: function (key) {
			var i;
			for (i = 0; i < this.grid.options.columns.length; i++) {
				if (this.grid.options.columns[i].key === key) {
					return i;
				}
			}
		},
		_generateExpressions: function (filterRowTrigger) {
			// iterate over the columns and generate the current filtering expressions array
			var exprs = [], cols = this.grid.options.columns, expr, i, currentCondition, requiresEntry, isExprAdded, dt,
				precise, format, preciseInd;
			for (i = 0; i < cols.length; i++) {
				if (this._editors && this._editors[i] && this._editors[i]._addedFromAdvanced && !filterRowTrigger) {
					continue;
				}
				// if filtering is disabled for this column, exit
				if (this.options.columnSettings[i].allowFiltering !== true) {
					continue;
				}
				expr = this._editors[i].value();
				requiresEntry = this._requiresEntry(this.options.columnSettings[i].condition);
				if ((expr === undefined || expr === null ||  expr === "") && requiresEntry) {
					continue;
				} /* else if (!requiresEntry) {
					expr = null;
				}
				*/
				currentCondition = this.options.columnSettings[i].condition;

				if (currentCondition === undefined || currentCondition === null || currentCondition === "") {
					continue;
				}
				precise = '';
                dt = cols[i].dataType;
                // M.H. 17 Jun 2013 Fix for bug #144579: Filtering by date when browser timezone is negative gives wrong results (date is one day behind)
                if (dt === 'date' && expr) {
                    if (this.options.type === "remote" && this.options.filterExprUrlKey !== null && this.options.filterExprUrlKey !== undefined) {
                        expr = Date.UTC(expr.getUTCFullYear(), expr.getUTCMonth(), expr.getUTCDate(), expr.getUTCHours(), expr.getUTCMinutes());
                    } else {
						// detect whether there is precise datetime format
						format = cols[i].format;
						if (format && format.indexOf) {
							preciseInd = format.indexOf('h');
							if (preciseInd === -1) {
								preciseInd = format.indexOf('m');
							}
							if (preciseInd === -1) {
								preciseInd = format.indexOf('s');
							}
							if (preciseInd > -1) {
								precise = format.substr(preciseInd);
							}
						}
						if (precise === '' && currentCondition === 'after' && $.type(expr) === 'date') {
							// M.H. 14 Jan 2014 Fix for bug #161067: Using the after filter condition will leave values from the selected date unfiltered.
							expr.setHours(23);
							expr.setMinutes(59);
							expr.setSeconds(59);
							expr.setMilliseconds(999);
						}
					}
                }
				isExprAdded = false;
				//A.T. 28 March 2011 - Fix for bug #69561
				if (dt !== 'date' || (dt === 'date' && expr !== null &&
						expr !== undefined && currentCondition !== 'empty' &&
						currentCondition !== 'notEmpty' && currentCondition !== 'null' && currentCondition !== 'notNull') ||
						(dt === 'date' && !this._requiresEntry(this.options.columnSettings[i].condition))) {
					if (expr !== "" && !this.options.filterExprUrlKey) {
						isExprAdded = true;
						exprs.push({fieldName: cols[i].key, cond: currentCondition, expr: expr});
					} else if ((dt === "bool" && expr !== "") || (dt !== "bool" &&
							((this.options.filterExprUrlKey !== undefined && this.options.filterExprUrlKey !== null) || this.options.type === "local"))) {
						isExprAdded = true;
						exprs.push({fieldName: cols[i].key, cond: currentCondition, expr: expr});
					} else if (dt === "bool" && expr === "" && (currentCondition === 'null' || currentCondition === 'notNull' ||
							currentCondition === 'empty' || currentCondition === 'notEmpty')) {
						isExprAdded = true;
						exprs.push({fieldName: cols[i].key, cond: currentCondition, expr: expr});
					}
                    // M.H. 6 Feb 2014 Fix for bug #162227: Handle Invalid Column Config in igGrid
                    if (isExprAdded) {
                        if (dt === undefined && $.type(expr) === 'string') {
                            exprs[exprs.length - 1].dataType = 'string';
                        }
                        // M.H. 10 Sep 2012 Fix for bug #120759
						if (cols[i].unbound) {
							exprs[exprs.length - 1].dataType = dt;
						}
						if (precise) {
							exprs[exprs.length - 1].preciseDateFormat = precise;
						}
                    }
				}
			}
			return exprs;
		},
		_getDefaultCondition: function (type) {
			var result = "equals";
			if (type === undefined || type === null || type === "string") {
				result = "contains";
			} else if (type === "number") {
				result = "equals";
			} else if (type === "date") {
				result = "on";
			} else if (type === "bool") {
				result = "true";
			}
			return result;
		},
		_initDefaultSettings: function () {
            // fill in default column settings, so that later on we can get the current sort state of every sortable column 
			// iterate through columns
			var settings = [], key, de, cs = this.options.columnSettings, i, j, k, cols = this.grid.options.columns, allowFiltering,
                defExpr, isToCheckUnboundColumns = (this.grid._hasUnboundColumns === true && this.options.type === "remote");
            // M.H. 19 Jul 2013 Fix for bug #147233: cannot set default filtering expressions in ig.DataSource (they aren't taken into account , similar to sorting default expressions)
            this._defaultExpressions = this.grid.dataSource.settings.filtering.expressions || [];
			// initialize
			if (cols && cols.length > 0) {
				for (i = 0; i < cols.length; i++) {
					allowFiltering = true;
					// remote filtering should be forbidden for unbound columns
					if (isToCheckUnboundColumns && this.grid.getUnboundColumnByKey(cols[i].key) !== null) {
						allowFiltering = false;
					}
					settings[i] = {'columnIndex': i, 'columnKey': cols[i].key, condition: this._getDefaultCondition(cols[i].dataType), 'allowFiltering': allowFiltering};
				}
			}
            // M.H. 24 Mar 2014 Fix for bug #165993: Sorting is not working with initial sorting, autogenerate column and no columns definition
            // we got defaultExpressions from columnSettings(only for those which have defined columnKey - NOTE: columnKey should be properly defined)
            if (settings.length === 0 &&
                this.grid.options.autoGenerateColumns &&
                cs.length > 0) {
                for (i = 0; i < cs.length; i++) {
                    if (!cs[i].columnKey) {
                        continue;
                    }
                    defExpr = cs[i].defaultExpressions;
                    if (defExpr && defExpr.length > 0) {
                        for (k = 0; k < defExpr.length; k++) {
                            de = { fieldName: cs[i].columnKey, expr: defExpr[k].expr, cond: defExpr[k].cond};
                            if (defExpr[k].logic) {
                                de.logic = defExpr[k].logic;
                            }
                            this._defaultExpressions.push(de);
                        }
                    }
                }
            } else {
                for (i = 0; i < cs.length; i++) {
                    for (j = 0; j < settings.length; j++) {
                        if (settings[j].columnKey === cs[i].columnKey || settings[j].columnIndex === cs[i].columnIndex) {
                            break;
						}
					}
					if (j === settings.length) {
						continue;
					}
					for (key in cs[i]) {
						if (cs[i].hasOwnProperty(key)) {
                            if (key !== 'columnKey' && key !== 'columnIndex') {
								settings[j][key] = cs[i][key];
							}
                            // M.H. 19 Jul 2013 Fix for bug #147233: cannot set default filtering expressions in ig.DataSource (they aren't taken into account , similar to sorting default expressions)
                            if (key === 'defaultExpressions' && cs[i][key]) {
                                defExpr = cs[i][key];
                                for (k = 0; k < defExpr.length; k++) {
                                    de = { fieldName: cs[i].columnKey, expr: defExpr[k].expr, cond: defExpr[k].cond};
                                    if (defExpr[k].logic) {
                                        de.logic = defExpr[k].logic;
                                    }
                                    this._defaultExpressions.push(de);
                                }
                            }
						}
                    }
				}
            }
			// copy
			this.options.columnSettings = settings;
			// store default expressions
			// L.A. 03 December 2012 - Fixing bug #128401 - $.ig.DataSource.filtering.expressions are cleared by igGridFiltering
			this.grid.dataSource.settings.filtering.expressions = this._defaultExpressions;// || this.grid.dataSource.settings.filtering.expressions;
            // M.H. 19 Jul 2013 Fix for bug #147233: cannot set default filtering expressions in ig.DataSource (they aren't taken into account , similar to sorting default expressions)
            this.grid.dataSource.settings.filtering.defaultFields = this._defaultExpressions;
		},
		_renderDropDown: function (type, id, colName) {
			var ul, i, cs = this.options.columnSettings, cols = this.grid.options.columns, item, obj, conds = [], cond;
			if (type === "number") {
				ul = this._renderNumericFilterDropDown(id, colName);
			} else if (type === "date") {
				ul = this._renderDateFilterDropDown(id, colName);
			} else if (type === "boolean" || type === "bool") {
				//A.T. 12 Feb 2011 - Fix for bug #66113
				ul = this._renderBooleanFilterDropDown(id, colName);
			} else {
				// string 
				ul = this._renderStringFilterDropDown(id, colName);
			}
			if (this.options.filterDropDownItemIcons !== true) {
				if (this.options.showEmptyConditions) {
					$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'empty')).text(this.options.labels.empty).addClass('ui-corner-all');
					$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'notEmpty')).text(this.options.labels.notEmpty).addClass('ui-corner-all');
				}
				if (this.options.showNullConditions) {
					$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'null')).text(this.options.labels.nullLabel).addClass('ui-corner-all');
					$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'notNull')).text(this.options.labels.notNull).addClass('ui-corner-all');
				}
			} else {
				obj = {
					itemClass: this.css.filterDropDownListItemWithIcons,
					imgContainerClass: this.css.filterItemIconContainer,
					textClass: this.css.filterDropDownListItemTextContainer
				};
				if (this.options.showEmptyConditions) {
					// Empty
					conds.push({ text: this.options.labels.empty, imgClass: this.css.filterItemIcon, condition: "empty" });
					// Not Empty
					conds.push({ text: this.options.labels.notEmpty, imgClass: this.css.filterItemIcon, condition: "notEmpty" });
				}
				if (this.options.showNullConditions) {
					// Null
					conds.push({ text: this.options.labels.nullLabel, imgClass: this.css.filterItemIcon, condition: "null" });
					// Not Null
					conds.push({ text: this.options.labels.notNull, imgClass: this.css.filterItemIcon, condition: "notNull" });
				}
				for (i = 0; i < conds.length; i++) {
					cond = $("<li class='" + obj.itemClass + "'><span class='" + obj.imgContainerClass + "'>" +
						"<span class='" + this.css.filterItemIcon + " " + conds[i].imgClass + "'></span></span>" +
						"<span class='" + obj.textClass + "'> " + conds[i].text + "</span></li>");
					cond.appendTo(ul).data("cond", conds[i].condition);
				}
			}
			// if the mode is "Advanced", add the "Advanced" button
			if (this.options.mode === "advanced") {
				this._renderAdvancedButton(ul);
			}
			//A.T. 14 Feb 2011 - Fix for bug #65814
			// set initially selected value, if any
			for (i = 0; i < cs.length; i++) {
				if (cs[i].columnKey === colName && cs[i].condition !== this._getDefaultCondition(cols[i].dataType)) {
					// find the item
					if (cs[i].condition === 'null') {
						item = ul.find(':contains("' + this.options.labels.nullLabel + '")');
					} else {
						item = ul.find(':contains("' + this.options.labels[cs[i].condition] + '")');
					}
					item = item.children().first().closest('li');
					item.addClass(this.css.filterDropDownListItemActive).parent().data('selectedItem', $('li', item.parent()).index(item));
				}
			}
		},
		_renderAdvancedButton: function (ul) {
			var li;
			li = $('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItemAdvanced);
			// render the igButton inside the LI 
			this._currentButton = $(toStaticHTML('<input type="button"></input>'));
			this._currentButton.igButton({labelText: this.options.labels.advancedButtonLabel}).bind({
				mousedown: $.proxy(this._openFilterDialog, this)
			});
			li.append(this._currentButton);
		},
		_openFilterDialogFromKeyboard: function (event) {
			if (event.keyCode === $.ui.keyCode.ENTER) {
				this._openFilterDialog(event);
			}
		},
		// M.H. 30 March 2012 Fix for bug #106217
		_openFilterDialog: function (event, columnKey) {
			// show the dialog that has been created before
			var maxZ, left, top, pos, h, w, bh, dh, dw, bw, noCancel = true, block = $('#' + this.grid.container().attr('id') + '_block'),
				dialog = $('#' + this.grid.container().attr('id') + '_dialog'), i, addDefault = true, rOffset,
                expressions = this.grid.dataSource.settings.filtering.expressions;
			// M.H. 10 July 2012 Fix for bug #106407
			maxZ = $.ig.getMaxZIndex(this.grid.container().attr('id') + '_dialog');
			block.css('zIndex', maxZ + 1);
			dialog.css('zIndex', maxZ + 2);
			// recalc containment
            // L.A. 13 June 2012 Fixing bug #114457 Advanced search filtering dialog cannot be dragged outside of the grid
            if (this.options.filterDialogContainment === "owner") {
				dialog.draggable('option', 'containment', this.grid.container());
            } else {
				// M.H. 22 May 2014 Fix for bug #162225: Allow Users to Position the igGrid Advanced Filter Dialog Anywhere in Browser Window
                dialog.draggable('option', 'containment', 'document');
            }
			// fire filterDialogOpening event
			this._dialogCurrentColumn = $(event.target).closest('ul').data('colName');
			if (this._dialogCurrentColumn === undefined || this._dialogCurrentColumn === null) {
				// M.H. 30 March 2012 Fix for bug #106217
				if (columnKey !== null && columnKey !== undefined) {
					this._dialogCurrentColumn = columnKey;
				} else {
					// in advanced mode when we don't render dropdowns there is no UL, so we take the col name from the closest TH which is the header's TH
					this._dialogCurrentColumn = $(event.target).closest('th').data('colName');
				}
			}
            // L.A. 10 May 2012 Fixing bug #110975
            if (this._dialogCurrentColumn === undefined || this._dialogCurrentColumn === null) {
                this._dialogCurrentColumn = this.grid.options.columns[0];
            }
            // M.H. 5 Mar 2013 Fix for bug #120009: When filtering through the API method you are unable to apply multiple filters through separate calls.
            dialog.find('.ui-iggrid-filtertable tbody tr').remove();
            this._dialogCurrentType = this.grid.columnByKey(this._dialogCurrentColumn).dataType;
            // M.H. 8 Mar 2013 Fix for bug #135184: Columns are added for filtering if you open the advanced filtering dialog and click Cancel
            dialog.find('.ui-iggrd-filtertable tbody tr').remove();
            if (expressions && expressions.length > 0) {
                addDefault = true;
                for (i = 0; i < expressions.length; i++) {
                    // M.H. 8 Mar 2013 Fix for bug #135184: Columns are added for filtering if you open the advanced filtering dialog and click Cancel
                    if (!addDefault || expressions[i].fieldName === this._dialogCurrentColumn) {
                        addDefault = false;
                    }
                    //this._addFilterFromDialog(null, expressions[i]);
                    this._addFilterFromDialog(null, expressions[i]);
                }
                if (addDefault) {
                    this._addFilterFromDialog();
                }
            } else {
                this._addFilterFromDialog();
            }
			noCancel = this._trigger(this.events.filterDialogOpening, null, {dialog: dialog, owner: this});
			if (noCancel) {
				// M.H. 9 Nov 2012 Fix for bug #126471
				pos = $.ig.util.offset(this.grid.container());
				left = pos.left;
				top = pos.top;
				if (block.outerWidth() !== this.grid.container().outerWidth()) {
					block.css('width', this.grid.container().outerWidth());
				}
				if (block.outerHeight() !== this.grid.container().outerHeight()) {
					block.css('height', this.grid.container().outerHeight());
				}
				// hide any error messages that are shown
				$('#' + this.grid.container().attr('id') + '_dialog_error').hide();
                rOffset = $.ig.util.getRelativeOffset(block);
				block.css({left: left - rOffset.left, top: top - rOffset.top}).fadeToggle();
				// show the actual dialog
				w = this.grid.container().outerWidth();
				h = this.grid.container().outerHeight();
				// calculate browser height and width, and if the grid's w  & h exceed the browser ones, position the advanced filtering dialog
				// so that it can be seen on screen
				bw = $(window).width();
				bh = $(window).height();
				if (w + left > bw) {
					w = w - (w + left - bw);
				}
				if (w <= 0) {
					w = this.grid.container().outerWidth();
				}
				if (h + top > bh) {
					h = h - (h + top - bh);
				}
				if (h <= 0) {
					h = this.grid.container().outerHeight();
				}
				dh = parseInt(this.options.filterDialogHeight, 10);
				dw = parseInt(this.options.filterDialogWidth, 10);
				if (isNaN(dh) || dh <= 0) {
					dh = dialog.outerHeight();
				}
				if (isNaN(dw) || dw <= 0) {
					dw = dialog.outerWidth();
				}
				// L.A. 05 September 2012 Fixing bug #120390 
				// When the grid is shorter than the Advanced filtering dialog the pop up window hides its titlebar
				top = top + parseInt(h / 2, 10) - dh / 2;
				left = left + parseInt(w / 2, 10) - dw / 2;
				top = top < 0 ? pos.top : top;
				left = left < 0 ? pos.left : left;
                rOffset = $.ig.util.getRelativeOffset(dialog);
				dialog.css({left: left - rOffset.left, top: top - rOffset.top})
					.fadeToggle($.proxy(this._setResizableEnv, this));
				// fire opened event
				this._trigger(this.events.filterDialogOpened, null, {dialog: dialog, owner: this});
				// focus dialog so that the dropdown closes (on blur), and the advanced dialog can be closed with the ESCAPE key 
				dialog.focus();
				event.preventDefault();
				event.stopPropagation();
				// close dropdown
                // M.H. 4 Oct 2013 Fix for bug #151434: When filtering is advanced and advancedModeEditorsVisible = true the button for advanced filtering dialog is missing from the feature chooser.
				if (!(this.options.mode === 'advanced' && this.options.advancedModeEditorsVisible === false) &&
						this._currentTarget !== null && this._currentTarget !== undefined) {
					this._toggleDropDown({currentTarget: this._currentTarget}, true);
				}
			}
		},
		_closeFilterDialog: function (e) {
			var noCancel = true;
			noCancel = this._trigger(this.events.filterDialogClosing, null, {owner: this});
			if (noCancel) {
				$('#' + this.grid.container().attr('id') + '_block').fadeToggle();
				$('#' + this.grid.container().attr('id') + '_dialog').fadeToggle();
				this._trigger(this.events.filterDialogClosed, null, {owner: this});
				if (e) {
					e.preventDefault();
					e.stopPropagation();
				}
				return false;
			}
		},
		_searchFilterDialog: function (e) {

			var expressions = [], rows, boolLogic, selectLogic, noCancel = true, i, type, expr, noCancelFiltering = true, cond;
			noCancel = this._trigger(this.events.filterDialogFiltering, null, {dialog: $('#' + this.grid.container().attr('id') + '_dialog'), owner: this});

			if (noCancel) {
				// construct filter expressions from table
				rows = $('#' + this.grid.container().attr('id') + '_dialog table tbody').children();
				boolLogic = "and";
				selectLogic = $('#' + this.grid.container().attr('id') + '_dialog select:first');
				if (selectLogic.length > 0) {
					boolLogic = $('#' + this.grid.container().attr('id') + '_dialog select:first')[0].value === "all" ? "AND" : "OR";
				}
				for (i = 0; i < rows.length; i++) {
					type = this.grid.columnByText($(rows[i].cells[0]).find('input')[0].value).dataType; // get the column type 
					expr = $(rows[i].cells[2]).find('input').igEditor('value');
					if (expr && (expr.nodeName || (expr[0] && expr[0].nodeName))) {
						expr = $(rows[i].cells[2]).find('span').igEditor('value');
					}
                    cond = $(rows[i].cells[1]).find('select')[0].value;
                    // M.H. 1 Apr 2013 Fix for bug #137908: Date filter value is one day behind the selected date
                    if ($.type(expr) === 'date') {
                        if (this.grid.options.enableUTCDates) {
                            expr = Date.UTC(expr.getUTCFullYear(), expr.getUTCMonth(), expr.getUTCDate(), expr.getUTCHours(), expr.getUTCMinutes());
                        }
                        // M.H. 14 Jan 2014 Fix for bug #161067: Using the after filter condition will leave values from the selected date unfiltered.
                        if (cond === 'after' && this.options.type === "local") {
                            expr.setHours(23);
                            expr.setMinutes(59);
                            expr.setSeconds(59);
                            expr.setMilliseconds(999);
                        }
                    }
					expressions.push({
						// fire user-defined function to extract expression from row
						fieldName: this.grid.columnByText($(rows[i].cells[0]).find('input')[0].value).key,
						cond: cond,
						expr: expr,
						logic: boolLogic,
						type: type
					});
					// M.H. 19 Feb 2014 Fix for bug #162227: Handle Invalid Column Config in igGrid
					if (type === undefined && $.type(expr) === 'string') {
						expressions[expressions.length - 1].dataType = 'string';
					}
				}
				this._closeFilterDialog(e);
				// when the editors are visible and the mode is advanced, make sure we are not ignoring the filter row (Bug #70099)
				//if (this.options.advancedModeEditorsVisible === true && this.options.mode === "advanced") {
					// merge the two arrays of expressions
					//$.merge(expressions, this._generateExpressions());
				//}
				this._currentAdvancedExpressions = expressions;
				// there are no column key / index here, because advanced filtering may include many colum filters, it doesn't have to be just one. 
                // M.H. 14 Jan 2014 Fix for bug #161067: Using the after filter condition will leave values from the selected date unfiltered.
                // passing filtering expressions to the dataFiltering event. In this way we will allow users easily to manipulate filtering expressions before databinding
				noCancelFiltering = this._trigger(this.events.dataFiltering, null, {owner: this, expressions: expressions});
				if (noCancelFiltering) {
					this.filter(expressions, true, true); // the third parameter denotes that those filters have been added from the advanced window 
				}
			}
			e.preventDefault();
			e.stopPropagation();
		},
		_filterDialogStartMove: function (e) {
			this._isFilterDialogMouseDown = true;
		},
		_filterDialogStopMove: function (e) {
			this._isFilterDialogMouseDown = false;
			this._dialogClientX = undefined;
			this._dialogClientY = undefined;
		},
		_filterDialogMove: function (e, ui) {
			$(e.target).find('.ui-igedit-fieldincontainer').igEditor('dropDownVisible', false);
			//var dialog = $('#' + this.grid.container().attr('id') + '_dialog'), left, top, newLeft, newTop, noCancel = true;
			this._trigger(this.events.filterDialogMoving, null, {
				// M.H. 22 May 2014 Fix for bug #162225: Allow Users to Position the igGrid Advanced Filter Dialog Anywhere in Browser Window
				dialog: e.target, owner: this, originalPosition: ui.originalPosition, position: ui.position
			});
			/*
			noCancel = this._trigger(this.events.filterDialogMoving, null, {dialog: dialog, owner: this});
			if (noCancel) {
				left = parseInt(dialog.css('left'), 10);
				top = parseInt(dialog.css('top'), 10);
				if (this._isFilterDialogMouseDown !== undefined && this._isFilterDialogMouseDown === true) {
					if (this._dialogClientX === undefined && this._dialogClientY === undefined) {
						this._dialogClientX = parseInt(e.clientX, 10);
						this._dialogClientY = parseInt(e.clientY, 10);
						newLeft = left;
						newTop = top;
					} else {
						newLeft = left + (e.clientX - this._dialogClientX);
						newTop = top + (e.clientY - this._dialogClientY);
					}
					this._dialogClientX = e.clientX;
					this._dialogClientY = e.clientY;
					dialog.css({left: newLeft, top: newTop});
				}
			}
			*/
		},
		_renderFilterDialog: function () {
			var dialog, condObj, dropDownData, condElement, condDropDown, okCancelContainer, f = this,
				caption, dialogContent, noCancel = true, addClearButtons, limit, container;
			// M.H. 9 Apr 2014 Fix for bug #162225: Allow Users to Position the igGrid Advanced Filter Dialog Anywhere in Browser Window
			container = this.grid._rootContainer();
			// append the block area div to the grid's "_container"
			$('<div></div>').appendTo(container).attr('id', this.grid.container().attr('id') + '_block').css('position', 'absolute').addClass(this.css.blockArea).data('efh', '1').hide();
			dialog = $('<div></div>').appendTo(container).attr('id', this.grid.container().attr('id') + '_dialog').css('position', 'absolute').css('width', this.options.filterDialogWidth).css('height', this.options.filterDialogHeight).addClass(this.css.filterDialog).data('efh', '1').hide();
			noCancel = this._trigger(this.events.filterDialogContentsRendering, null, {dialogElement: dialog, owner: this});
			if (noCancel) {
				// add caption to the dialog
				caption = $('<div></div>').appendTo(dialog).addClass(this.css.filterDialogHeaderCaption);
				$('<span></span>')
					.appendTo(caption)
					.text(this.options.labels.filterDialogCaptionLabel)
					.addClass(this.css.filterDialogHeaderCaptionTitle);
				$('<span></span>').appendTo($('<a></a>').appendTo(caption).attr('href', '#').attr('role', 'button').addClass('ui-dialog-titlebar-close ui-corner-all')).bind({
					click: $.proxy(this._closeFilterDialog, this)
				}).addClass('ui-icon ui-icon-closethick');
                // L.A. 20 June 2012 Fixing bug #114456 Adding more filtering criteria forces the advanced search dialog to expand rather than show scrollbars
				dialogContent = $('<div></div>').appendTo(dialog).addClass('ui-dialog-content').css('overflow', 'auto').css('height', this.options.filterDialogMaxHeight);

				// add condition dialog
				condObj = {label1: this.options.labels.filterDialogConditionLabel1, label2: this.options.labels.filterDialogConditionLabel2};
				dropDownData = [
					{text: this.options.labels.filterDialogAllLabel, value: 'all'},
					{text: this.options.labels.filterDialogAnyLabel, value: 'any'}
				];
				if (this.options.filterDialogAddConditionTemplate && typeof this.options.filterDialogAddConditionTemplate === "string") {
					condElement = $(this._fTmplWrappers[this.grid.id() + "_filterDialogAddConditionTemplate"](condObj));
				} else {
					condElement = $("<div><span>" + condObj.label1 + "</span><div><select></select></div><span>" + condObj.label2 + "</span></div>");
				}	
				condElement.appendTo(dialogContent).addClass(this.css.filterDialogAddCondition);
				//condElement = $.tmpl(this.options.filterDialogAddConditionTemplate, condObj).appendTo(dialogContent).addClass(this.css.filterDialogAddCondition); 
				/* bind({
					change: $.proxy(this._changeFilterCondition, this) 
				}); */
				if (this.options.filterDialogAddConditionDropDownTemplate && typeof this.options.filterDialogAddConditionDropDownTemplate === "string") {
					condDropDown = $(this._fTmplWrappers[this.grid.id() + "_filterDialogAddConditionDropDownTemplate"](dropDownData));
				} else {
					condDropDown = $("<option value='" + dropDownData[0].value + "'>" + dropDownData[0].text + "</option>" + 
						"<option value='" + dropDownData[1].value + "'>" + dropDownData[1].text + "</option>"
					);
				}
				condDropDown.appendTo(condElement.find('div').addClass(this.css.filterDialogAddConditionDropDown).find('select'));
				//$.tmpl(this.options.filterDialogAddConditionDropDownTemplate, dropDownData).appendTo(condElement.find('div').addClass(this.css.filterDialogAddConditionDropDown).find('select'));
				addClearButtons = $('<div></div>').appendTo(dialogContent);
				// add filters table
				$(toStaticHTML('<input type="button"></input>')).appendTo($('<span></span>').appendTo(addClearButtons).addClass(this.css.filterDialogAddButton)).igButton({labelText: this.options.labels.filterDialogAddLabel,
					width: this.options.filterDialogAddButtonWidth}).bind({
					mousedown: $.proxy(this._addFilterFromDialog, this)
				});
				// add Clear All button
				/* if (this.options.showFilterDialogClearAllButton === true) { */
				$('<button />').appendTo(addClearButtons).css('float', 'right').igButton({
					labelText: this.options.labels.filterDialogClearAllLabel,
					click: $.proxy(this._filterDialogClearAll, this),
					css: {
						"buttonClasses": this.css.filterDialogClearAllButton,
						"buttonHoverClasses": "",
						"buttonActiveClasses": "", //when button is clicked 
						"buttonFocusClasses": "", //when button get focus
						"buttonLabelClass": ""
					}
				});
				$('<label></label>').appendTo(dialogContent).attr('id', dialog.attr('id') + '_error').hide().text(this.options.labels.filterDialogErrorLabel).addClass("ui-widget ui-state-error ui-igvalidator-label");
				$('<table><tbody></tbody></table>').appendTo(dialogContent).addClass(this.css.filterDialogFiltersTable);
				okCancelContainer = $('<div></div>').appendTo($('<div></div>').appendTo(dialog).addClass(this.css.filterDialogOkCancelButton)).addClass('ui-dialog-buttonset');
				// M.H. 7 Mar 2013 Fix for bug #134420: The buttons of the advanced filtering dialog are switched.
                // Add Ok button
				$('<button id="' + this.grid.element[0].id + '_filter_dialog_ok_button"/>').appendTo(okCancelContainer).igButton({labelText: this.options.labels.filterDialogOkLabel,
					width: this.options.filterDialogOkCancelButtonWidth}).bind({
					click: $.proxy(this._searchFilterDialog, this)
				});
				//Add Cancel button
				$('<button id="' + this.grid.element[0].id + '_filter_dialog_cancel_button"/>').appendTo(okCancelContainer).igButton({labelText: this.options.labels.filterDialogCancelLabel,
					width: this.options.filterDialogOkCancelButtonWidth}).bind({
					mousedown: $.proxy(this._closeFilterDialog, this),
					click: function (e) { e.preventDefault(); }
				});
				//A.T. 14 Feb 2011 - Fix for #64483
				if (this._hc === true) {
					limit = $('#' + this.grid.element[0].id.split('_')[0] + '_container');
				} else {
					limit = this.grid.container();
				}
				dialog.bind({
					keydown: function (e) { if (e.keyCode === $.ui.keyCode.ESCAPE) { f._closeFilterDialog(); } }
				}).draggable({containment: limit, handle: caption, drag: $.proxy(this._filterDialogMove, this)}).attr('role', 'dialog').attr('tabIndex', -1);
				// M.H. 31 Oct 2012 Fix for bug #104800
				if (typeof Modernizr !== 'object' || Modernizr.touch === false) {
					// M.H. 22 May 2014 Fix for bug #162225: Allow Users to Position the igGrid Advanced Filter Dialog Anywhere in Browser Window
					dialog.resizable({ minHeight: dialog.outerHeight() / 4, minWidth: dialog.outerWidth() / 2,
						resize: $.proxy(this._resizeHandler, this)
					});
					// M.H. 9 June 2014 Fix for bug #173021: Resizing the edit template causes it to shrink when grid height is less.
					if (this.options.filterDialogContainment === "owner") {
						dialog.resizable("option", "containment", "parent");
					}
				}
				this._trigger(this.events.filterDialogContentsRendered, null, {dialogElement: dialog, owner: this});
			}
		},
		_setResizableEnv: function () {
			var e = $("#" + this.grid.container().attr('id') + "_dialog"),
				rCont = e.find(">.ui-dialog-content"),
				hCont = e.find(">.ui-dialog-titlebar"),
				bCont = e.find(">.ui-dialog-buttonpane"),
				pad = rCont.outerHeight() - rCont.height();
			this._resizeCont = rCont;
			this._heightDifference = hCont.outerHeight(true) + bCont.outerHeight(true) + pad;
		},
		_resizeHandler: function (event, ui) {
			var u = ui.originalElement;
			//	rCont = u.find(".ui-dialog-content");
			this._resizeCont.css({
				height: (u.height() - this._heightDifference) + "px"
			});
		},
		_changeFilterCondition: function (e) {
			// if the condition does not require an entry, set the value in the third dropdown and disable it
			var requiresEntry, editor, condition, editorObject;
			condition = e.target.value;
			editor = $(e.target).closest('td').parent().find('td:nth-child(3)').find('input');
			requiresEntry = this._requiresEntry(condition);
			if (!requiresEntry) {
				editor.igEditor("option", "disabled", true);
				editorObject = editor.data('igEditor');
				// set correct input value if it doesn't require an entry
				this._editorValueForCondition(condition, editorObject);
			} else {
				editor.igEditor("option", "disabled", false);
			}
		},
		_addFilterFromDialog: function (e, expression) {
			var tableBody = $('#' + this.grid.container().attr('id') + '_dialog table tbody'), j, cs = this.options.columnSettings,
				filterObj = {}, filterRow, colKeys, i, noCancel = true, field, type, cnd, allowed, defaultValue, condition, col;
			noCancel = this._trigger(this.events.filterDialogFilterAdding, null, {filtersTableBody: tableBody, owner: this});
			if (noCancel) {
				if (tableBody.children().length >= this.options.filterDialogMaxFilterCount) {
					// use the validation framework to validate the button?
					$('#' + this.grid.container().attr('id') + '_dialog_error').show();
					return;
				}
				// fire filter adding event
				if (this.options.filterDialogFilterTemplate && typeof this.options.filterDialogFilterTemplate === "string") {
					filterRow = $(this._fTmplWrappers[this.grid.id() + "_filterDialogFilterTemplate"](filterObj));
				} else {
					filterRow = $("<tr><td><input/></td><td><select></select></td><td><input /> </td><td><span></span></td></tr>");
				}
				filterRow.appendTo(tableBody).hide();
				//filterRow = $.tmpl(this.options.filterDialogFilterTemplate, filterObj).appendTo(tableBody).hide();
				// instantiate editors and fill in values
				// 1. list of columns
				colKeys = [];
				for (i = 0; i < this.grid.options.columns.length; i++) {
					// check if filtering is allowed on this column
					allowed = true;
					for (j = 0; j < cs.length; j++) {
						if ((this.grid.options.columns[i].key === cs[j].columnKey || i === cs[j].columnIndex) && cs[j].allowFiltering === false) {
							allowed = false;
							break;
						}
					}
					if (allowed) {
						colKeys.push(this.grid.options.columns[i].headerText);
					}
				}
                // L.A. 10 May 2012 Fixing bug #110975
                if (expression === undefined) {
					field = this.grid.columnByKey(this._dialogCurrentColumn).headerText;
					type = this._dialogCurrentType;
					// M.H. 30 May 2014 Fix for bug #172388: Date filter editor doesn't take into account grid's column format
					col = this.grid.columnByKey(field);
                } else {
                    col = this.grid.columnByKey(expression.fieldName);
                    if (col !== null) {
                        field = col.headerText;
                        type = col.dataType;
                    }
                    condition = expression.cond;
                    defaultValue = expression.expr;
                    // M.H. 20 May 2013 Fix for bug #142681: When enableUTCDates is set to true and the Filtering is advanced after filtering a date column the value in the date picker is removed the second time you open the dialog.
                    if (type === 'date' && $.type(defaultValue) === 'number' && this.grid.options.enableUTCDates) {
                        defaultValue = new Date(defaultValue);
                    }
                }				// use igeditor
				filterRow.find('td:first').find('input').css('width', 80).igEditor({
					listItems: colKeys,
					button: 'dropdown',
					listAutoComplete: true,
					listMatchOnly: true,
					width: this.options.filterDialogColumnDropDownDefaultWidth || 120,
					textChanged: $.proxy(this._polulateFilterConditionDropDown, this),
					//value: this.grid.columnByKey(field).headerText
					value: field,
					//_utc: true
					enableUTCDates: this.grid.options.enableUTCDates
				});
				cnd = filterRow.find('td:nth-child(2)').children().first();
				//2. conditions for the respective column will be populated later dynamically, when the column is changed
				this._populateConditionsList(cnd, field, type);
                // M.H. 2 Apr 2013 Fix for bug #138403: The condition of the applied expression in the advanced dialog is not persisted after you open the dialog for the second time.
                if (condition !== undefined && cnd.length > 0) {
                    cnd[0].value = condition;
                }
				// attach a handler to the conditions list for value change
				cnd.bind('change', $.proxy(this._changeFilterCondition, this));
				filterRow.find('td:nth-child(2)').children().first().css('width', this.options.filterDialogFilterDropDownDefaultWidth);
				// show filterRow (INPUT) before creating editor, because hidden drop-down button may flicker
				filterRow.show();
                this._populateFilterDialogInput(filterRow.find('td:nth-child(3)').children().first(), type, defaultValue, col);
				//3. remove button for the filter
				filterRow.find('td:last').children().first().addClass(this.css.filterDialogFilterRemoveButton).bind({
					mousedown: $.proxy(this._removeFilterFromDialog, this)
				});
				// fire filter added
				this._trigger(this.events.filterDialogFilterAdded, null, {filter: filterRow, owner: this});
			}
		},
		_filterDialogClearAll: function (e) {
			// events? 
			var tableBody = $('#' + this.grid.container().attr('id') + '_dialog table tbody');
			tableBody.empty();
			//A.T. 12 Feb 2011 - Fix for bug #64538
			// clear validation error message if any
			$('#' + this.grid.container().attr('id') + '_dialog_error').hide();
			if (e) {
				e.preventDefault();
			}
		},
		_polulateFilterConditionDropDown: function (e) {
			var selectedColKey = e.target.value, conditionList, cols = this.grid.options.columns, type, expr, i, col;
			// find the column, and populate the conditions based on the type
			conditionList = $(e.target).closest('tr').find('td:nth-child(2)').children().first();
			expr = $(e.target).closest('tr').find('td:nth-child(3)').children().first();
			for (i = 0; i < cols.length; i++) {
				if (cols[i].headerText === selectedColKey) {
					type = cols[i].dataType;
					col = cols[i];
					break;
				}
			}
			// no full match
			if (type === undefined) {
				return;
			}
			this._populateConditionsList(conditionList, selectedColKey, type);
			this._populateFilterDialogInput(expr, type, undefined, col);
		},
		_populateFilterDialogInput: function (input, type, defaultValue, col) {
			var options = {
				type: this._getEditorType(type),
				buttonHidden: type !== 'date',
				button: 'dropdown',
				disabled: type === 'bool',
				maxDecimals: 12,
				textAlign: (type === 'number') ? 'right' : 'left',
				width: this.options.filterDialogExprInputDefaultWidth,
				value: defaultValue,
				//_utc: true
				enableUTCDates: this.grid.options.enableUTCDates
			};
			// M.H. 30 May 2014 Fix for bug #172388: Date filter editor doesn't take into account grid's column format
			if (type === 'date' && col && col.format) {
				options.dateInputFormat = col.format;
			}
			// do not allow to create same igEditor for different elements. First time it is INPUT, but later it can be SPAN or INPUT
			if (!input.is('input')) {
				input = input.find('INPUT');
			}
			input.igEditor(options);
		},
		_populateConditionsList: function (conditionList, selectedColKey, type) {

			var conditions = [], condList = "", i;

			if (type === "number") {
				conditions.push({conditionName: "equals", conditionLabel: this.options.labels.equals});
				conditions.push({conditionName: "doesNotEqual", conditionLabel: this.options.labels.doesNotEqual});
				conditions.push({conditionName: "greaterThan", conditionLabel: this.options.labels.greaterThan});
				conditions.push({conditionName: "lessThan", conditionLabel: this.options.labels.lessThan});
				conditions.push({conditionName: "greaterThanOrEqualTo", conditionLabel: this.options.labels.greaterThanOrEqualTo});
				conditions.push({conditionName: "lessThanOrEqualTo", conditionLabel: this.options.labels.lessThanOrEqualTo});

			} else if (type === "bool" || type === "boolean") {
				conditions.push({conditionName: "true", conditionLabel: this.options.labels.trueLabel});
				conditions.push({conditionName: "false", conditionLabel: this.options.labels.falseLabel});

			} else if (type === "date") {
				conditions.push({conditionName: "on", conditionLabel: this.options.labels.on});
				conditions.push({conditionName: "notOn", conditionLabel: this.options.labels.notOn});
				conditions.push({conditionName: "after", conditionLabel: this.options.labels.after});
				conditions.push({conditionName: "before", conditionLabel: this.options.labels.before});
				conditions.push({conditionName: "today", conditionLabel: this.options.labels.today});
				conditions.push({conditionName: "yesterday", conditionLabel: this.options.labels.yesterday});
				conditions.push({conditionName: "thisMonth", conditionLabel: this.options.labels.thisMonth});
				conditions.push({conditionName: "lastMonth", conditionLabel: this.options.labels.lastMonth});
				conditions.push({conditionName: "nextMonth", conditionLabel: this.options.labels.nextMonth});
				conditions.push({conditionName: "thisYear", conditionLabel: this.options.labels.thisYear});
				conditions.push({conditionName: "lastYear", conditionLabel: this.options.labels.lastYear});
				conditions.push({conditionName: "nextYear", conditionLabel: this.options.labels.nextYear});
			} else { // string
				conditions.push({conditionName: "startsWith", conditionLabel: this.options.labels.startsWith});
				conditions.push({conditionName: "endsWith", conditionLabel: this.options.labels.endsWith});
				conditions.push({conditionName: "contains", conditionLabel: this.options.labels.contains});
				conditions.push({conditionName: "doesNotContain", conditionLabel: this.options.labels.doesNotContain});
				conditions.push({conditionName: "equals", conditionLabel: this.options.labels.equals});
				conditions.push({conditionName: "doesNotEqual", conditionLabel: this.options.labels.doesNotEqual});
			}

			if (this.options.showEmptyConditions) {
				conditions.push({conditionName: "empty", conditionLabel: this.options.labels.empty});
				conditions.push({conditionName: "notEmpty", conditionLabel: this.options.labels.notEmpty});
			}

			if (this.options.showNullConditions) {
				conditions.push({conditionName: "null", conditionLabel: this.options.labels.nullLabel});
				conditions.push({conditionName: "notNull", conditionLabel: this.options.labels.notNull});
			}
			// clear the list from existing conditions
			conditionList.empty();
			// reset selected value
			if (this.options.filterDialogFilterConditionTemplate && typeof this.options.filterDialogFilterConditionTemplate === "string") {
				condList = $(this._fTmplWrappers[this.grid.id() + "_filterDialogFilterConditionTemplate"](conditions));
			} else {
				for (i = 0; i < conditions.length; i++) {
					condList += "<option value='" + conditions[i].conditionName + "'>" + conditions[i].conditionLabel + "</option>";
				}
				condList = $(condList);
			}
			condList.appendTo(conditionList);
			//$.tmpl(this.options.filterDialogFilterConditionTemplate, conditions).appendTo(conditionList);
			// IE9 has a pretty obvious bug, we need this hack to handle that case
			if ($.ig.util.isIE) {
				conditionList.parent().append(conditionList);
				conditionList.width(conditionList.width());
			}
		},
		_removeFilterFromDialog: function (e) {
			// remove filter
			var tableBody = $('#' + this.grid.container().attr('id') + '_dialog table tbody');
			$(e.target).closest('tr').remove();
			// hide the error message if it is shown
			if (tableBody.children().length < this.options.filterDialogMaxFilterCount) {
				$('#' + this.grid.container().attr('id') + '_dialog_error').hide();
			}
		},
		// append dropdowns as children of the grid container
		// create string filtering dropdowns
		_renderStringFilterDropDown: function (id, colName) {
			var ul = this._renderDropDownElement(id, colName), obj, conds = [], cond;
			// render items in the list
			if (this.options.filterDropDownItemIcons !== true) {
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).addClass(this.css.filterDropDownListItemClear)).text(this.options.labels.clear).addClass('ui-corner-all');
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'startsWith')).text(this.options.labels.startsWith).addClass('ui-corner-all');
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'endsWith')).text(this.options.labels.endsWith).addClass('ui-corner-all');
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'contains')).text(this.options.labels.contains).addClass('ui-corner-all');
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'doesNotContain')).text(this.options.labels.doesNotContain).addClass('ui-corner-all');
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'equals')).text(this.options.labels.equals).addClass('ui-corner-all');
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'doesNotEqual')).text(this.options.labels.doesNotEqual).addClass('ui-corner-all');
			} else {
				// the template is: "<li class='${itemClass}'><span class='${imgClass}'></span><span class='${textClass}'> ${text} </span></li>"
				obj = {
					itemClass: this.css.filterDropDownListItemWithIcons,
					imgContainerClass: this.css.filterItemIconContainer,
					textClass: this.css.filterDropDownListItemTextContainer
				};
				// Clear
				conds.push({ text: this.options.labels.clear, imgClass: this.css.filterItemIconClear });
				// Starts With
				conds.push({ text: this.options.labels.startsWith, imgClass: this.css.filterItemIconStartsWith, condition: "startsWith" });
				// Ends with
				conds.push({ text: this.options.labels.endsWith, imgClass: this.css.filterItemIconEndsWith, condition: "endsWith" });
				// Contains
				conds.push({ text: this.options.labels.contains, imgClass: this.css.filterItemIconContains, condition: "contains" });
				// Does Not Contain
				conds.push({ text: this.options.labels.doesNotContain, imgClass: this.css.filterItemIconDoesNotContain, condition: "doesNotContain" });
				// Equals
				conds.push({ text: this.options.labels.equals, imgClass: this.css.filterItemIconEquals, condition: "equals" });
				// Does Not Equal
				conds.push({ text: this.options.labels.doesNotEqual, imgClass: this.css.filterItemIconDoesNotEqual, condition: "doesNotEqual" });
				// add to list
				this._renderDropDownToList(obj, conds, ul);
			}
			return ul;
		},
		// create numeric filtering dropdowns
		_renderNumericFilterDropDown: function (id, colName) {
			var ul = this._renderDropDownElement(id, colName), obj, conds = [], cond;
			// render items in the list 
			if (this.options.filterDropDownItemIcons !== true) {
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).addClass(this.css.filterDropDownListItemClear)).text(this.options.labels.clear);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'equals')).text(this.options.labels.equals);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'doesNotEqual')).text(this.options.labels.doesNotEqual);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'greaterThan')).text(this.options.labels.greaterThan);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'lessThan')).text(this.options.labels.lessThan);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'greaterThanOrEqualTo')).text(this.options.labels.greaterThanOrEqualTo);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'lessThanOrEqualTo')).text(this.options.labels.lessThanOrEqualTo);
			} else {
				obj = {
					itemClass: this.css.filterDropDownListItemWithIcons,
					imgContainerClass: this.css.filterItemIconContainer,
					textClass: this.css.filterDropDownListItemTextContainer
				};
				// Clear
				conds.push({ text: this.options.labels.clear, imgClass: this.css.filterItemIconClear });
				// Equals
				conds.push({ text: this.options.labels.equals, imgClass: this.css.filterItemIconEquals, condition: "equals" });
				// Does Not Equal
				conds.push({ text: this.options.labels.doesNotEqual, imgClass: this.css.filterItemIconDoesNotEqual, condition: "doesNotEqual" });
				// GreaterThan
				conds.push({ text: this.options.labels.greaterThan, imgClass: this.css.filterItemIconGreaterThan, condition: "greaterThan" });
				// LessThan
				conds.push({ text: this.options.labels.lessThan, imgClass: this.css.filterItemIconLessThan, condition: "lessThan" });
				// GreaterThanOrEqualTo
				conds.push({ text: this.options.labels.greaterThanOrEqualTo, imgClass: this.css.filterItemIconGreaterThanOrEqualTo, condition: "greaterThanOrEqualTo" });
				// LessThanOrEqualTo
				conds.push({ text: this.options.labels.lessThanOrEqualTo, imgClass: this.css.filterItemIconLessThanOrEqualTo, condition: "lessThanOrEqualTo" });
				// add to list
				this._renderDropDownToList(obj, conds, ul);
			}
			return ul;
		},
		// create date filtering dropdowns 
		_renderDateFilterDropDown: function (id, colName) {
			var ul = this._renderDropDownElement(id, colName), obj, conds = [], cond;
			// render items in the list 
			if (this.options.filterDropDownItemIcons !== true) {
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).addClass(this.css.filterDropDownListItemClear)).text(this.options.labels.clear);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'on')).text(this.options.labels.on);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'notOn')).text(this.options.labels.notOn);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'after')).text(this.options.labels.after);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'before')).text(this.options.labels.before);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'today')).text(this.options.labels.today);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'yesterday')).text(this.options.labels.yesterday);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'thisMonth')).text(this.options.labels.thisMonth);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'lastMonth')).text(this.options.labels.lastMonth);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'nextMonth')).text(this.options.labels.nextMonth);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'thisYear')).text(this.options.labels.thisYear);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'lastYear')).text(this.options.labels.lastYear);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'nextYear')).text(this.options.labels.nextYear);
			} else {
				obj = {
					itemClass: this.css.filterDropDownListItemWithIcons,
					imgContainerClass: this.css.filterItemIconContainer,
					textClass: this.css.filterDropDownListItemTextContainer
				};
				// Clear
				conds.push({ text: this.options.labels.clear, imgClass: this.css.filterItemIconClear });
				// On
				conds.push({ text: this.options.labels.on, imgClass: this.css.filterItemIconOn, condition: "on" });
				// Not On
				conds.push({ text: this.options.labels.notOn, imgClass: this.css.filterItemIconNotOn, condition: "notOn" });
				// After
				conds.push({ text: this.options.labels.after, imgClass: this.css.filterItemIconAfter, condition: "after" });
				// Before
				conds.push({ text: this.options.labels.before, imgClass: this.css.filterItemIconBefore, condition: "before" });
				//Today
				conds.push({ text: this.options.labels.today, imgClass: this.css.filterItemIconToday, condition: "today" });
				// Yesterday
				conds.push({ text: this.options.labels.yesterday, imgClass: this.css.filterItemIconYesterday, condition: "yesterday" });
				// thisMonth
				conds.push({ text: this.options.labels.thisMonth, imgClass: this.css.filterItemIconThisMonth, condition: "thisMonth" });
				// lastMonth
				conds.push({ text: this.options.labels.lastMonth, imgClass: this.css.filterItemIconLastMonth, condition: "lastMonth" });
				// NextMonth
				conds.push({ text: this.options.labels.nextMonth, imgClass: this.css.filterItemIconNextMonth, condition: "nextMonth" });
				// ThisYear
				conds.push({ text: this.options.labels.thisYear, imgClass: this.css.filterItemIconThisYear, condition: "thisYear" });
				// LastYear
				conds.push({ text: this.options.labels.lastYear, imgClass: this.css.filterItemIconLastYear, condition: "lastYear" });
				// NextYear
				conds.push({ text: this.options.labels.nextYear, imgClass: this.css.filterItemIconNextYear, condition: "nextYear" });
				// add to list
				this._renderDropDownToList(obj, conds, ul);
			}
			return ul;
		},
		// create boolean filtering dropdowns
		_renderBooleanFilterDropDown: function (id, colName) {
			var ul = this._renderDropDownElement(id, colName), obj, conds = [], cond;
			// render items in the list
			if (this.options.filterDropDownItemIcons !== true) {
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).addClass(this.css.filterDropDownListItemClear)).text(this.options.labels.clear);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'true')).text(this.options.labels.trueLabel);
				$('<a></a>').appendTo($('<li></li>').appendTo(ul).addClass(this.css.filterDropDownListItem).data('cond', 'false')).text(this.options.labels.falseLabel);
			} else {
				obj = {
					itemClass: this.css.filterDropDownListItemWithIcons,
					imgContainerClass: this.css.filterItemIconContainer,
					textClass: this.css.filterDropDownListItemTextContainer
				};
				// Clear
				conds.push({ text: this.options.labels.clear, imgClass: this.css.filterItemIconClear });
				// True
				conds.push({ text: this.options.labels.trueLabel, imgClass: this.css.filterItemIconTrue, condition: "true" });
				// False
				conds.push({ text: this.options.labels.falseLabel, imgClass: this.css.filterItemIconFalse, condition: "false" });
				// add to list
				this._renderDropDownToList(obj, conds, ul);
			}
			return ul;
		},
		_renderDropDownToList: function (obj, list, ul) {
			var i, cond;
			for (i = 0; i < list.length; i++) {
				cond = $("<li class='" + obj.itemClass + "'><span class='" + obj.imgContainerClass + "'>" +
					"<span class='" + this.css.filterItemIcon + " " + list[i].imgClass + "'></span></span>" +
					"<span class='" + obj.textClass + "'> " + list[i].text + "</span></li>");
				cond.appendTo(ul).data("cond", list[i].condition);
			}
		},
		_renderDropDownElement: function (id, colName) {
			var ul, container;
			ul = $('<ul></ul>').appendTo(this.grid._rootContainer()).addClass(this.css.filterDropDownList);
			container = $('<div></div>').appendTo(this.grid._rootContainer()).attr('id', id).addClass(this.css.filterDropDown).css('overflow', 'hidden').css('position', 'absolute').hide();
			if (!$.ig.util.isIE) {
				container.css('overflow-y', 'auto');
			}
			container.remove();
			if (this.options.filterDropDownWidth > 0) {
				ul.css('width', this.options.filterDropDownWidth);
			}
			if (this.options.filterDropDownHeight > 0) {
				container.css('height', this.options.filterDropDownHeight);
			}
			ul.data('colName', colName);
			ul.wrap(container);
			// mark it with the "efh" attribute - "excludeFromHeight"
			ul.parent().data('efh', '1');
			// attach events
			$('#' + id).delegate("li", {
				mousedown: $.proxy(this._selectDropDownItem, this),
				mouseover: $.proxy(this._hoverDropDownItem, this),
				mouseout: $.proxy(this._unhoverDropDownItem, this)
			});
			return ul;
		},
		_hoverButton: function (event) {
			var $target  = $(event.currentTarget).find('span');
			if (this.options.mode === "advanced") {
				$target.addClass(this.css.filterButtonAdvancedHover);
			} else {
				$target.addClass(this.css.filterButtonHover);
			}
		},
		_unhoverButton: function (event) {
			var $target  = $(event.currentTarget).find('span');
			if (this.options.mode === "advanced") {
				$target.removeClass(this.css.filterButtonAdvancedHover);
			} else {
				$target.removeClass(this.css.filterButtonHover);
			}
		},
		_activateButton: function (event) {
			var $target = $(event.currentTarget).find('span');
			if (this._dontApplyStyles) {
				this._dontApplyStyles = false;
				return;
			}
			if (this.options.mode === "advanced") {
				$target.addClass(this.css.filterButtonAdvancedActive);
			} else {
				$target.addClass(this.css.filterButtonActive);
			}
		},
		_deactivateButton: function (event) {
			var target = $(event.target).find('span');
			target.removeClass(this.css.filterButtonAdvancedActive);
			target.removeClass(this.css.filterButtonActive);
		},
		_toggleDropDown: function (event, close, dontFocus) {
			var $target  = $(event.currentTarget), id = $target.attr('id'), dd, left, top, noCancel = true, button = $target.find('span'), rOffset,
				maxZ, block = $('#' + this.grid.container().attr('id') + '_block'), dialog = $('#' + this.grid.container().attr('id') + '_dialog');

			if (this._animating && id === this._animatingId) {
				return;
			}
			// L.A. 18 October 2012 - Fixing bug #123537
			// IE 7: When jQuery dialog with igGrid in it is opened for the second time filter containers are shown behind dialog
			// Using // M.H. 10 July 2012 Fix for bug #106407
			maxZ = $.ig.getMaxZIndex(this.grid.container().attr('id') + '_dialog');
			block.css('zIndex', maxZ + 1);
			dialog.css('zIndex', maxZ + 2);

			// find the dropdown
			dd = $('#' + id.substring(0, id.indexOf('_button')));
			// M.H. 1 Nov 2012 Fix for bug #123537
			dd.css('zIndex', maxZ + 3);

			if (!(!dd.is(":visible") && close === true)) {
				this._animating = true;
				this._animatingId = id;
			}

			if (this._openingAnimation !== true) {
				this._dontFocus = dontFocus;
			} else {
				this._dontFocus = null;
			}
			this._isClosing = false;
			// trigger dropdown opening / closing
			if (dd.is(":visible")) {
				// trigger closing
				noCancel = this._trigger(this.events.dropDownClosing, null, {dropDown: dd, owner: this});
				this._isClosing = true;
			} else {
				// trigger opening
				if (!close) {
					noCancel = this._trigger(this.events.dropDownOpening, null, {dropDown: dd, owner: this});
				}
			}
			if (noCancel) {
				// looks like this issue is fixed in FF4, therefore i am not going to 
				//if (!$.ig.util.isWebKit && !$.ig.util.isIE) {
					//leftScroll = $(document).scrollLeft();
					//topScroll = $(document).scrollTop();
				//} 
				left = $.ig.util.offset(button).left;
				top = $.ig.util.offset(button).top + button.outerHeight();
				// account for body padding
				//left = left + parseInt($('body').css('margin-left'), 10) + parseInt($('body').css('padding-left'), 10);
				//top = top + parseInt($('body').css('margin-top'), 10) + parseInt($('body').css('padding-top'), 10);
				// finally, show the dropdown, if it is hidden, or hide it alternatively
				if (dd.offset().left !== left && dd.offset().top !== top) {
                    rOffset = $.ig.util.getRelativeOffset(dd);
                    left -= rOffset.left;
                    top -= rOffset.top;
                    dd.css('left', left).css('top', top);
				}
				this._currentTarget = $target;
				this._dd = dd;
				if (!this._isClosing) {
					this._opendd = dd;
				}
				if ($.ig.util.isIE) {
					dd.css('overflow-x', 'hidden');
					dd.css('overflow-y', 'hidden');
				}
				if (close !== undefined && close === true) {
					if (dd.is(':visible')) {
						if (this.options.filterDropDownAnimations !== "none") {
							dd.hide(this.options.filterDropDownAnimationDuration, $.proxy(this._animationEnd, this));
						} else {
							dd.hide();
							// trigger closed event
							this._trigger(this.events.dropDownClosed, null, {dropDown: dd, owner: this});
						}
					}
				} else {
					if (this.options.filterDropDownAnimations !== "none") {
						if (dd.is(':visible')) {
							this._closingTarget = this._currentTarget;
						} else {
							this._openingTarget = this._currentTarget;
							this._openingAnimation = true;
						}
						dd.toggle(this.options.filterDropDownAnimationDuration, $.proxy(this._animationEnd, this));
					} else {
						dd.toggle();
						// trigger closed/opened events
						if (this._isClosing) {
							this._trigger(this.events.dropDownClosed, null, {dropDown: dd, owner: this});
						} else {
							this._trigger(this.events.dropDownOpened, null, {dropDown: dd, owner: this});
						}
						// we need to focus the button manually
						if (dontFocus !== true) {
							this._dontApplyStyles = true;
							$target.focus();
						}
					}
				}
			}
		},
		_animationEnd: function () {
			if (this._isClosing === true) {
				this._trigger(this.events.dropDownClosed, null, {dropDown: this._dd, owner: this});
			} else {
				this._trigger(this.events.dropDownOpened, null, {dropDown: this._opendd, owner: this});
				this._openingAnimation = false;
			}
			if (this._dd && $.ig.util.isIE) {
				this._dd.css('overflow-y', 'auto');
			}
			this._isClosing = null;
			// we need to focus the button manually
			if (this._dontFocus !== true) {
				this._dontApplyStyles = true;
				this._openingTarget.focus();
			}
			this._animating = false;
		},
		_toggleDropDownKeyboard: function (event) {
			var parent, selectedItem, $target = $(event.target), ddVisible;
			if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
				event.stopPropagation();
				event.preventDefault();
				parent = $('#' + $target.attr('id').substring(0, $target.attr('id').indexOf('_button'))).find('ul');
				if (parent.data('selectedItem')) {
					selectedItem = parent.find('li:nth-child(' + (parent.data('selectedItem') + 1) + ')');
					ddVisible = $('#' + $target.attr('id').substring(0, $target.attr('id').indexOf('_button'))).is(":visible");
					if ($(selectedItem).hasClass('ui-iggrid-filterddlistitemadvanced') && ddVisible) {
						// open advanced filter dialog
						this._openFilterDialog(event);
					}
				}
				this._toggleDropDown(event);
			} else if (event.keyCode === $.ui.keyCode.DOWN) {
				event.stopPropagation();
				event.preventDefault();
				this._selectDropDownItem(event, 'next');
			} else if (event.keyCode === $.ui.keyCode.UP) {
				event.stopPropagation();
				event.preventDefault();
				this._selectDropDownItem(event, 'prev');
			}
		},
		_closeDropDown: function (event) {
			var $target = $(event.currentTarget).find('span'), $targetButton = $(event.currentTarget), dd;
			if (this._openingTarget && event.target.id === this._openingTarget.attr('id') && this._openingAnimation === true) {
				return;
			}
			dd = $('#' + $targetButton.attr('id').substring(0, $targetButton.attr('id').indexOf('_button')));
			if (dd && !dd.is(':visible')) {
				// remove focus styles
				$target.removeClass(this.css.filterButtonActive);
				return; // no need to close the dropdown if it has been already closed
			}
			this._toggleDropDown(event, true, true);
			if (this._dontApplyStyles) {
				this._dontApplyStyles = false;
				return;
			}
			if (this.options.mode === "advanced") {
				$target.removeClass(this.css.filterButtonAdvancedActive);
			} else {
				$target.removeClass(this.css.filterButtonActive);
			}
		},
		_selectDropDownItem: function (event, nav, expr) {
			var $target = $(event.currentTarget), filterCondition, colIndex, sel, parent, button, requiresEntry, currentCond;
			if ($target.find('input').length > 0 && this.options.mode === "advanced") {
				return;
			}
			if (nav === 'next' || nav === 'prev') {
				parent = $('#' + $target.attr('id').substring(0, $target.attr('id').indexOf('_button'))).find('ul');
			}
			if (nav === 'next') {
				// get the currently selected item
				if (parent.data('selectedItem') === undefined) {
					$target = parent.find('li:first');
				} else {
					$target = parent.find('li:nth-child(' + (parent.data('selectedItem') + 1) + ')');
					if ($target.next().length === 0) {
					// last, get the first
						$target = parent.find('li:first');
					} else {
						$target = $target.next();
					}
				}
			}
			if (nav === 'prev') {
				// get the currently selected item
				if (parent.data('selectedItem') === undefined) {
					$target = parent.find('li:last');
				} else {
					$target = parent.find('li:nth-child(' + (parent.data('selectedItem') + 1) + ')');
					if ($target.prev().length === 0) {
						// last, get the first
						$target = parent.find('li:last');
					} else {
						$target = $target.prev();
					}
				}
			}
			filterCondition = $target.data('cond');
			// update tooltip
			button = $('#' + $target.closest('div').attr('id') + '_button');
			if ($target.data('cond') === undefined) {
				button.attr('title', this.options.tooltipTemplate.replace('${condition}', this.options.labels.noFilter));
			} else {
				button.attr('title', this.options.tooltipTemplate.replace('${condition}', $target.text()));
			}
			colIndex = $('#' + $target.closest('div').attr('id') + '_button').find('span').data('colIndex');
			// L.A. 29 October 2012 - Fixing bug #124166 - Filter client API method doesn't rebind the grid
			if (!colIndex && expr) {
				$.each(this.options.columnSettings, function (index, col) {
					if (col.columnKey === expr.fieldName) {
						colIndex = index;
						return false;
					}
				});
			}
			currentCond = this.options.columnSettings[parseInt(colIndex, 10)].condition;
			if (filterCondition !== undefined) {
				// change the editor condition
				this.options.columnSettings[parseInt(colIndex, 10)].condition = filterCondition;
			} else if (currentCond === 'empty' || currentCond === 'notEmpty' || currentCond === 'null' || currentCond === 'notNull' || !this._requiresEntry(currentCond)) {
				// should not be null but the default condition !
				this.options.columnSettings[parseInt(colIndex, 10)].condition = this._getDefaultCondition(this.grid.options.columns[colIndex].dataType);
                // M.H. 11 Mar 2013 Fix for bug #134207: null condition label is misleading after clearing a Null filter
                // M.H. 7 Nov 2013 Fix for bug #157107: Date column preset filter nullText is retained after the filter is cleared
                if (currentCond === 'null' ||
                    this.grid.options.columns[colIndex].dataType === 'date') {
                    this._editors[colIndex].element.igEditor("option", "nullText", this.options.nullTexts[this._getDefaultCondition(this.grid.options.columns[colIndex].dataType)]);
                }
			}
			// apply active state on target
			sel = $target.parent().data('selectedItem');
			if (sel !== undefined) {
				$target.parent().find('li:nth-child(' + (sel + 1) + ')').removeClass(this.css.filterDropDownListItemActive);
			}
			$target.addClass(this.css.filterDropDownListItemActive);
			$target.parent().data('selectedItem', $('li', $target.parent()).index($target));
			// reinitialize editor
			this._editors[colIndex].element.igEditor("option", "nullText", this.options.nullTexts[filterCondition]);
			requiresEntry = this._requiresEntry(filterCondition);
			// we should always clear the filter after a new one has been selected
			if ($target.hasClass('ui-iggrid-filterddlistitemclear') || (this.options.filterDropDownItemIcons === true && $target.find('.ui-iggrid-filtericonclear').length > 0)) {
				// clear editor
				// if the default condition does not require an entry, set disabled to false on the editor
				if (!requiresEntry || filterCondition === undefined) {
					this._editors[colIndex].element.igEditor("option", "disabled", this.grid.options.columns[colIndex].dataType === 'bool');
				}
				this._editors[colIndex].value(null);
				this._filterDataSourceClear(this.grid.options.columns[colIndex].key, colIndex);
			} else {
				// determine if the condition requires entry
                // M.H. 19 Jul 2013 Fix for bug #147233: cannot set default filtering expressions in ig.DataSource (they aren't taken into account , similar to sorting default expressions)
                // update filters UI updates also dropdowns - e.g. when filtering column is boolean then it causes infinite rebinding because _updateFiltersUI calls _selectDropDownItem which in these cases calls filtering again
				if (!requiresEntry && !expr) {
					this._editors[colIndex].element.igEditor("option", "disabled", true);
					// set correct input value if it doesn't require an entry
					this._editorValueForCondition(filterCondition, this._editors[colIndex]);
                    // M.H. 25 Jun 2013 Fix for bug #143295: Wrong data in ui.columnKey and ui.columnIndex for dataFiltering and dataFiltered events
                    this._args = undefined;
					this._filterInternal(colIndex, this.grid.options.columns[colIndex].key);
				//A.T. 14 Feb 2011 - Fix for bug #64465
				} else if (this._editors[colIndex].value() !== "" && this._editors[colIndex].value() !== null) {
					this._editors[colIndex].value(null);
				}
				if (requiresEntry) {
					this._editors[colIndex].element.igEditor("option", "disabled", false);
				}
				if (nav === undefined && filterCondition !== undefined) {
					this._editors[colIndex].setFocus();
				}
			}
		},
		_requiresEntry: function (filterCondition) {
			if (filterCondition === "true" ||
					filterCondition === "false" ||
					filterCondition === "today" ||
					filterCondition === "yesterday" ||
					filterCondition === "thisMonth" ||
					filterCondition === "nextMonth" ||
					filterCondition === "lastMonth" ||
					filterCondition === "thisYear" ||
					filterCondition === "lastYear" ||
					filterCondition === "empty" ||
					filterCondition === "notEmpty" ||
					filterCondition === "null" ||
					filterCondition === "notNull" ||
					filterCondition === "nextYear") {
				return false;
			}
			if (filterCondition === undefined || filterCondition === null) {
				return false;
			}
			return true;
		},
		_editorValueForCondition: function (filterCondition, editor) {
			var date = new Date();
			if (filterCondition === "true") {
				editor.value(true);
			} else if (filterCondition === "false") {
				editor.value(false);
			} else if (filterCondition === "today") {
				editor.value(new Date());
			} else if (filterCondition === "yesterday") {
				if (this.grid.options.enableUTCDates) {
					editor.value(new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate() - 1, 0, 0, 0, 0)));
				} else {
					editor.value(new Date(date.getFullYear(), date.getMonth(), date.getDate() - 1, 0, 0, 0, 0));
				}
			/*
			} else if (filterCondition === "empty") {
				editor.value('empty');
			} else if (filterCondition === "notEmpty") {
				editor.value('notEmpty');
			} else if (filterCondition === "null") {
				editor.value('null');
			} else if (filterCondition === "notNull") {
				editor.value('notNull');
			*/
			} else {
				editor.value(null);
			}
		},
		_assignTemplates: function () {
			var self = this, opts = self.options, gId = this.grid.id();
			this._fTmplWrappers = {};
			this._fTmplWrappers[gId + "_filterDialogFilterTemplate"] = function (d) {
				return $.ig.tmpl(opts.filterDialogFilterTemplate, d);
			};
			this._fTmplWrappers[gId + "_filterDialogAddConditionTemplate"] = function (d) {
				return $.ig.tmpl(opts.filterDialogAddConditionTemplate, d);
			};
			this._fTmplWrappers[gId + "_filterDialogAddConditionDropDownTemplate"] = function (d) {
				return $.ig.tmpl(opts.filterDialogAddConditionDropDownTemplate, d);
			};
			this._fTmplWrappers[gId + "_filterDialogFilterConditionTemplate"] = function (d) {
				return $.ig.tmpl(opts.filterDialogFilterConditionTemplate, d);
			};
			if (String(this.grid.options.templatingEngine).toLowerCase() === "jsrender") {
				this._jsr = true;
				$.templates(gId + "_filterDialogFilterTemplate", opts.filterDialogFilterTemplate);
				$.templates(gId + "_filterDialogAddConditionTemplate", opts.filterDialogAddConditionTemplate);
				$.templates(gId + "_filterDialogAddConditionDropDownTemplate", opts.filterDialogAddConditionDropDownTemplate);
				$.templates(gId + "_filterDialogFilterConditionTemplate", opts.filterDialogFilterConditionTemplate);
				this._fTmplWrappers = $.render;
			}
		},
		_hoverDropDownItem: function (event) {
			if ($(event.currentTarget).find('input').length === 0) {
				$(event.currentTarget).addClass(this.css.filterDropDownListItemHover);
			}
		},
		_unhoverDropDownItem: function (event) {
			$(event.currentTarget).removeClass(this.css.filterDropDownListItemHover);
		},
		_virtualHorizontalScroll: function (event, args) {
			var start = args.startColIndex, i, headers = this.grid.headersTable().find('th'), columnKey;
			if (this._currentTarget) {
				this._toggleDropDown({currentTarget: this._currentTarget}, true);
			}

			if (this.options.mode === "advanced" && this.options.advancedModeEditorsVisible !== true) {
				for (i = 0; i < this.grid._virtualColumnCount; i++) {
                    columnKey = this.grid.options.columns[i + start].key;
					$(headers[i]).data('colName', columnKey);
                    if (this._fcData[columnKey] === true) {
                        // if filter button is shown in feature chooser do not update in indicator container
                        continue;
                    }
					// update button ID
					$(headers[i]).find('a').attr('id', this.grid.element[0].id + '_dd_' + columnKey + '_button');
				}
				this._updateTooltips(this._currentAdvancedExpressions || []);
			} else {
				throw new Error($.ig.GridFiltering.locale.virtualizationSimpleFilteringNotAllowed);
				/*
				// re-create the editors and reset the dropdown buttons as we scroll
				buttons = $('.ui-iggrid-filterrow', this.grid.container()).find('.ui-iggrid-filterbutton');
				for (i = 0; i < this.grid._virtualColumnCount; i++) {
					// change the button ids and the header IDs
					$(buttons[i]).parent().attr('id', this.grid.element[0].id + '_dd_' + this.grid.options.columns[i + start].key + '_button');
					$(headers[i]).attr('id', this.grid.options.columns[i + start].key);
					
					// now swap the editors
					this._editors[i].element.swap(this._editors[i + start].element);
				}
				*/
			}
		},
        _columnFixed: function (args) {
            var i, colInd = args.colInd, cs, editor, fixedColumnsLength = args.fixedColsCount;
            
            cs = this.options.columnSettings[colInd];
            if (cs) {
                this.options.columnSettings.splice(colInd, 1);
				this.options.columnSettings.splice(fixedColumnsLength - 1, 0, cs);
            }
            editor = this._editors[colInd];
            if (editor) {
                this._editors.splice(colInd, 1);
				this._editors.splice(fixedColumnsLength - 1, 0, editor);

                for (i = 0; i < this._editors.length; i++) {
					$(this._editors[i].element).data('colIndex', i);
					$(this._editors[i].element).closest("td").find("span.ui-iggrid-filterbutton").data('colIndex', i);
				}
            }
        },
		_headerInit: function (owner, args) {
			var filterrow;
			// clear all cells from the filter row that are marked with data-skip=true
			// L.A. 03 January 2012 - Fixing bug #130031 Filtering/Group By integration issue - when advancedModeEditorsVisible = TRUE 
			// and the column is grouped, the filtering editors shift with 1 column to the left
			if ((this.options.mode !== "simple" && this.options.advancedModeEditorsVisible !== true) || this.grid.element.attr('id') !== args.owner.element.attr('id')) {
				return;
			}
			// M.H. 21 May 2014 Fix for bug #171794: Column Filtering is moving one column right with Row Selectors, Selection  and Column Fixing features enabled
			filterrow = this.grid.container().find('thead:first').find("[data-role=filterrow]");
			filterrow.find("[data-skip=true]").remove();
			this.grid._headerInit(filterrow, null, true);
		},
		_injectGrid: function (gridInstance, isRebind) {
			var topmostGrid = null;
			this.grid = gridInstance;
			if (this.options.type === null) {
				// infer type
				this.options.type = this.grid._inferOpType();
			}
			// M.H. 21 Mar 2014 Fix for bug #167839: Remote filtering, sorting or group by are not persisted when applied to the child and root layout
			if (this.options.persist && this.options.type === 'remote') {
				topmostGrid = this.element.closest('.ui-iggrid-root').data('igGrid');
				if (topmostGrid && topmostGrid.element.attr('id') !== this.grid.element[0].id &&
					topmostGrid.options.initialDataBindDepth === -1) {
					this.options.persist = false;
				}
			}
            // M.H. 19 Jul 2013 Fix for bug #147233: cannot set default filtering expressions in ig.DataSource (they aren't taken into account , similar to sorting default expressions)
            if (this.options.type) {
                this.grid.dataSource.settings.filtering.type = this.options.type;
            } else {
                this.grid.dataSource.settings.filtering.type = "remote";
            }
            // attach headerRendered handler
			if (this.options.filterExprUrlKey) {
				this.grid.dataSource.settings.filtering.filterExprUrlKey = this.options.filterExprUrlKey;
			}
			this.grid.dataSource.settings.filtering.caseSensitive = this.options.caseSensitive;

            if (this._headerCellRenderedHandler !== null && this._headerCellRenderedHandler !== undefined) {
                this.grid.element.unbind('iggridheadercellrendered', this._headerCellRenderedHandler);
			}
            this._headerCellRenderedHandler = $.proxy(this._headerCellRendered, this);
			this.grid.element.bind('iggridheadercellrendered', this._headerCellRenderedHandler);

			if (this._headerRenderedHandler !== null && this._headerRenderedHandler !== undefined) {
				this.grid.element.unbind('iggridheaderrendered', this._headerRenderedHandler);
			}
            this._headerRenderedHandler = $.proxy(this._headerRendered, this);
			this.grid.element.bind('iggridheaderrendered', this._headerRenderedHandler);

			if (this._columnResizedHandler !== null && this._columnResizedHandler !== undefined) {
				this.grid.element.unbind('iggridresizingcolumnresized', this._columnResizedHandler);
			}
            this._columnResizedHandler = $.proxy(this._columnResized, this);
			this.grid.element.bind('iggridresizingcolumnresized', this._columnResizedHandler);

			if (this._columnsAlteredHandler !== null && this._columnsAlteredHandler !== undefined) {
				this.grid.element.unbind('iggrid_columnsmoved', this._columnsAlteredHandler);
			}
			this._columnsAlteredHandler = $.proxy(this._columnsAltered, this);
			this.grid.element.bind('iggrid_columnsmoved', this._columnsAlteredHandler);

            //if (!isRebind) {
			this._initDefaultSettings();
			//}
			// register for uiDirty
			// M.H. 29 Oct 2012 Fix for bug #120642
			if (this._onUIDirtyHandler !== null && this._onUIDirtyHandler !== undefined) {
				this.grid.element.unbind('iggriduidirty', this._onUIDirtyHandler);
			}
			this._onUIDirtyHandler = $.proxy(this._onUIDirty, this);
			this.grid.element.bind('iggriduidirty', this._onUIDirtyHandler);
			// manage horizontal virtual scrolling -> columns need to be updated accordingly and 
            if (this._virtualHorizontalScrollHandler !== null && this._virtualHorizontalScrollHandler !== undefined) {
                this.grid.element.unbind('iggridvirtualhorizontalscroll', this._virtualHorizontalScrollHandler);
            }
			this._virtualHorizontalScrollHandler = $.proxy(this._virtualHorizontalScroll, this);
			this.grid.element.bind('iggridvirtualhorizontalscroll', this._virtualHorizontalScrollHandler);

			if (((this.grid.options.virtualization === true && this.grid.options.width !== null) || this.grid.options.columnVirtualization === true) && this.options.mode === null) {
				this.options.mode = 'advanced';
			} else if (((this.grid.options.virtualization === false || (this.grid.options.virtualization === true && this.grid.options.width === null)) && this.grid.options.columnVirtualization === false) && this.options.mode === null) {
				this.options.mode = 'simple';
			} else if (this.options.mode === 'simple' && (this.grid.options.virtualization === true || this.grid.options.columnVirtualization === true)) {
				throw new Error($.ig.GridFiltering.locale.virtualizationSimpleFilteringNotAllowed);
			}
            if (this._headerInitHandler !== null && this._headerInitHandler !== undefined) {
                this.grid.element.unbind('iggridheaderextracellsmodified', this._headerInitHandler);
            }
            this._headerInitHandler = $.proxy(this._headerInit, this);
			this.grid.element.bind('iggridheaderextracellsmodified', this._headerInitHandler);
            if (this.grid.element.igGridFeatureChooser !== undefined) {
                this.grid.element.igGridFeatureChooser();
            } else {
				throw new Error($.ig.GridFiltering.locale.featureChooserNotReferenced);
			}
			this._assignTemplates();
			// if persistance is enabled we need to set filtering expressions, default filtering expressions to datasource
			// we can do using injectGrid because in grid framework DataBind the steps for setup datasource are:
			// 1. setupDataSource is called and DS filtering expressions are cleared
			// 2. UI Dirty is called
			// 3. Inject Grid is called - in this case filtering expressions are reset and it is set DS defaultEpxressions because if they are set then data source filter is called and filtering is applied
			if (this.options.persist) {
				this._preserveFiltering();
			}
		}
	});
    $.extend($.ui.igGridFiltering, {version: '14.1.20141.2249'});
}(jQuery));

/*!@license
* Infragistics.Web.ClientUI Outlook GroupBy feature 14.1.20141.2249
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends on:
*	jquery-1.4.4.js
*	jquery.ui.core.js
*	jquery.ui.widget.js
*	infragistics.ui.grid.framework.js
*	modernizr.js
*/

/*global jQuery, Modernizr, MSApp*/
(function ($) {

    $.widget("ui.igGridGroupBy", {
        css: {
            /* Classes applied to the markup that's being dragged*/
            dragMarkup: "ui-iggrid-dragMarkup",
            /* classes applied to the group by area, where column headers can be dropped */
            groupByArea: "ui-iggrid-groupbyarea",
            /* classes applied to the text container in the group by area */
            groupByAreaText: "ui-iggrid-groupbyareatext",
            /* classes applied to every group row TR */
            groupedRow: "ui-iggrid-groupedrow",
            /* classes applied to the special group by cell rendered in the header (the small empty first cell) */
            expandHeaderCellGroupBy: "ui-iggrid-header ui-widget-header",
            /* classes applied to the group by expander span element, when the group row is expanded */
            groupByExpandCellExpanded: "ui-icon ui-iggrid-expandbutton ui-iggrid-expandbuttonexpanded ui-icon-minus",
            /* classes applied to the group by expander span element, when the group row is collapsed */
            groupByExpandCellCollapsed: "ui-icon ui-iggrid-expandbutton ui-icon-plus",
            /* class applied when we are dragging a label and we are over a groupby area, before it's dropped */
            groupByAreaDropHover: "ui-iggrid-groupbyareahover",
            /* classes applied to the groupBy expander TD cell */
            groupByExpandColumn: "ui-iggrid-expandcolumn",
            /* classes applied to every cell that's rendered in front of a data cell, which is not a grouped row. this is necessary so that data rows and grouped rows align well */
            nonGroupRowEmptyCell: "ui-iggrid-nongrouprowemptycell",
            /* classes applied to the LI which is rendered in the groupBy area, when a column header is dropped there */
            groupedColumnLabel: "ui-iggrid-groupedcolumnlabel ui-state-default",
            /* classes applied to the text in the group by label */
            groupedColumnLabelText: "ui-iggrid-groupedcolumnlabeltext",
            /* classses applied to the remove button that appears for every column label that's dropped in the groupBy area. The button appears on hover */
            groupByRemoveButton: "ui-icon ui-icon-circle-close ui-iggrid-groupbyremovebutton",
            /* classes applied to the right edge of the groupBy area bread-crumb labels, when there are no more labels to the right. so that it appears as triangle */
            groupedColumnLabelRightEdgeEnd: "ui-iggrid-groupbylabelrightedgeend",
            /* classes applied to the right edge of a groupBy column label, when it's in the middle of the bread-crumb */
            groupedColumnLabelRightEdge: "ui-iggrid-groupbylabelrightedge",
            /* classes apppled to the text container, which specifies the columnLayout name in front of the groupBy column label, in case the grid is hierarchical */
            groupedColumnLayoutLabel: "ui-iggrid-groupbylayoutlabel",
			/* classes which are applied to the extra rendered cell in the header */
            headerExtraCell: "ui-iggrid-expandheadercellgb",
            // M.H. 17 Oct. 2011 Fix for bug 90815 - add css class for footer cell
            /* classes which are applied to the extra rendered cell in the footer */
            footerExtraCell: "ui-widget-content ui-iggrid-footerextracell",
            /* classes which are applied to the feature chooser groupby item */
            featureChooserIconClass: 'ui-icon ui-iggrid-icon-groupby',
            /* classes which are applied to container of grouped columns the groupby dialog */
            dialogGroupedColumns: 'ui-iggrid-groupby-dialog-groupedcolumns',
            /* classes which are applied to container of columns which are not grouped the groupby dialog */
            dialogUnroupedColumns: 'ui-iggrid-groupby-dialog-ungroupedcolumns',
            /* classes which are applied to each of grouped columns in the groupby dialog */
            dialogGroupedItem: "ui-widget-content",
            /* classes which are applied to each of columns(NOT grouped) in the groupby dialog */
            dialogUngroupedItem: "ui-widget-content",
            /* classes which are applied to groupby button of columns(NOT grouped) in the groupby dialog */
            dialogUngroupedColumnsGroupByButton: "ui-iggrid-dialog-groupby-button",
            /* classes which are applied to each column name container of columns(NOT grouped) in the groupby dialog */
            dialogUngroupedColumnsText: "ui-iggrid-dialog-text",
            /* classes which are applied to indicator for ascending sorted columns in the groupby dialog */
            dialogButtonAsc: "ui-button ui-corner-all ui-button-icon-only ig-sorting-indicator",
            /* classes which are applied to icon indicator for ascending sorted columns in the groupby dialog */
            dialogButtonAscIcon: 'ui-button-icon-primary ui-icon ui-icon-arrowthick-1-n',
            /* classes which are applied to indicator for descending sorted columns in the groupby dialog */
            dialogButtonDesc: "ui-button ui-corner-all ui-button-icon-only ig-sorting-indicator",
            /* classes which are applied to icon indicator for descending sorted columns in the groupby dialog */
            dialogButtonDescIcon: 'ui-button-icon-primary ui-icon ui-icon-arrowthick-1-s',
            /* classes which are applied to button which ungroup columns in the groupby dialog */
            dialogButtonUngroup: "ui-iggrid-dialog-groupedbuttons ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only ui-igbutton ui-widget-content ui-igbutton-remove",
            /* classes which are applied to container which holds all columns(NOT grouped) in the groupby dialog */
            dialogButtonUngroupContainer: "ui-button-icon-primary ui-icon ui-icon-circle-close",
            /* classes which are applied to column name container for each grouped column in the groupby dialog */
            dialogGroupedColumnTextContainer: "ui-iggrid-dialog-text",
            /* classes which are applied to the list of grouped columns in the groupby dialog */
            dialogListGroupedColumns: 'ui-iggrid-dialog-list-groupedcolumns',
            /* classes which are applied to the list of columns(NOT grouped) in the groupby dialog */
            dialogListUngroupedColumns: 'ui-iggrid-dialog-list-ungroupedcolumns',
            /* classes which are applied to the layers dropdown button in the groupby dialog */
            dialogLayoutsDDButton: "ui-icon ui-icon-triangle-1-s ui-iggrid-dialog-layouts-dd-button",
            /* classes which are applied to the container which holds layouts tree in the groupby dialog */
            dropDownLayoutsContainer: "ui-iggrid-featurechooser-dropdown-dialog ui-widget ui-widget-content ui-corner-all",
            /* classes which are applied to the layouts dropdown field in the groupby dialog */
            dialogLayoutsDDField: "ui-iggrid-dialog-layouts-dd-field",
            /* classes which are applied to the container which holds layouts dropdown in the groupby dialog*/
            dialogLayoutsDD: "ui-iggrid-dialog-layouts-dd ui-widget-content ui-corner-all ig-combo-icon-container",
            //			dialogButtonSlide: "ui-iggrid-sorting-dialog-button-slide ui-button ui-widget ui-state-default ui-corner-bottom ui-button-icon-only",
            //			dialogButtonSlideContainer: "ui-button-icon-primary ui-icon ui-icon-triangle-1-n",
            //			dialogButtonSlideUp: "ui-icon-triangle-1-s",
            //			dialogSlideArea: "ui-iggrid-multiplesorting-dialog-slide ui-widget-content",
            //			dialogSlideAreaContainer: "ui-iggrid-multiplesorting-dialog-slide-button-container",
            /* classes which are applied to the container of layout tree in groupby dialog */
            modalDialogTreeContainer: "ui-iggrid-groupby-dialog-tree",
            /* classes which are applied to the layouts container in the groupby dialog */
            modalDialogLayoutsContainer: "ui-iggrid-groupby-dialog-layoutscontainer",
            /* classes which are applied to hover state of buttons */
            dialogButtonsHover: "ui-state-hover",
			/* classes which are added to the last empty cell before expander cell */
			groupByLastEmptyCell: "ui-iggrid-last-emptycell"
        },
        renderInFeatureChooser: false,
        options: {
            /* type="top|hidden|bottom" Sets the place in the grid where the groupBy area will be 
            top type="string" the GroupBy area will be rendered above the grid headers 
            hidden type="string" the GroupBy area will not be rendered
            bottom type="string" the GroupBy area will be rendered below the grid footer (and above the pager, if any)
            */
            groupByAreaVisibility: "top",
            /* type="bool" Specifies if after grouping, the grouped rows will be initially expanded or collapsed. This option can be set only at initialization. */
            initialExpand: true,
            /* type="string" Text that will be shown in the GroupBy area when there are no grouped columns */
            emptyGroupByAreaContent: $.ig.GridGroupBy.locale.emptyGroupByAreaContent,
            /* type="string" Text of link(on click shows modal dialog with columns which could be group/ungroup by) that will be shown in the GroupBy area when there are no grouped columns */
            emptyGroupByAreaContentSelectColumns: $.ig.GridGroupBy.locale.emptyGroupByAreaContentSelectColumns,
            /* type="bool" Specifies if grouped rows will have an expander image that will allow end users to expand and collapse them. This option can be set only at initialization. */
            expansionIndicatorVisibility: true,
            /* type="number" By default, the column width for the header is taken. If this is specified it's used for all headers. */
            groupByLabelWidth: null,
            /* type="number" Specifies the opacity of the drag markup, while a column header is being dragged. The value must be between 0 and 1. */
            labelDragHelperOpacity: 0.5,
            /* type="number" specifies the indentation for a grouped row. If several columns are grouped, the total indentation will grow */
            indentation: 30,
        	/* type="asc|desc" default sort order - asc or desc */
            defaultSortingDirection: "asc",
            /* type="object" Returns the list of currently grouped columns. The option is read-only and cannot be set at initialization or at runtime. */
            groupedColumns: [
				{
				    /* type="string" key of the column that's grouped */
				    key: null,
				    /* type="asc|desc" sort order - ascending or descending */
				    dir: "asc",
				    /* type="string" key of the columnLayout, if the grid is hierarchical */
				    layout: null,
				    /* type="object" column object for the column that is grouped */
				    col: null
				}
			],
            /* type="string" Specifies a key to get group by data from the response. This option can be set only at initialization. */
            resultResponseKey: null,
            /* type="string" Template for the grouped row's text, follows jQuery's templating guidelines. Variables available for the template are ${key}, ${val} and ${count}. */
            groupedRowTextTemplate: "${key}: ${val} (${count})",
            /* type="remote|local" Specifies whether the groupBy operation takes place locally on client-side or remotely on server-side.
            local type="string" Execute the groupBy operation locally on client-side.
            remote type="string" Execute the groupBy operation by a request to the server.
            */
            type: null,
            /* type="string" URL param name which specifies how groupBy expressions will be encoded in the URL. The OData conventions for sorting params are used if the grid is bound to an OData service. ex: ?groupby(col1)=asc */
			groupByUrlKey: null,
			/* type="string" URL param value for ascending type of grouping. The OData conventions for sorting params are used if the grid is bound to an OData service. Example: ?groupBy(col1)=asc*/
			groupByUrlKeyAscValue: null,
			/* type="string" URL param value for descending type of grouping. The OData conventions for sorting params are used if the grid is bound to an OData service. Example: ?groupBy(col1)=desc */
			groupByUrlKeyDescValue: null,
            /* type="object" specifies the settings for GroupBy summaries */
            summarySettings: {
                /* type="bool" specifies if summaries are going to be rendered inline as part of the grouped row, or in separate dedicated rows */
                //renderSummariesInGroupRow: true,
                /* type="top|bottom" specifies the location of the summary row, relevant when renderSummariesInGroupRow = false */
                //summariesPosition: "top",
                /* type="string" specifies the delimiter for multiple summaries, in case they are rendered inline in the grouped row */
                multiSummaryDelimiter: ",",
                /* type="string" by default, two digits are shown after the decimal place */
                summaryFormat: "#.00"
            },
            /* type="object" Get sets settings for individual columns such as whether the grid is grouped by that column or grouping is allowed for that column. */
            columnSettings: [
				{
				    /* type="bool" enables/disables a column to participate in grouping. By default all columns can be grouped */
				    allowGrouping: true,
				    /* type="bool" specifies if a column should be grouped by default */
				    isGroupBy: false,
				    /* type="function" specifies a custom group by function, which accepts the column setting, the first and the second value to compare and returns bool */
				    groupComparerFunction: null,
					/* type="function" Reference to a function which will be used for formatting the cell values. The function should accept a value from the grouped column and return the new formatted value in the label of the row.*/
					groupLabelFormatter: null,
				    /* type="object" A list of aggregation functions to calculate on the column values for each group. */
				    summaries: [
						{
						    /* type="avg|min|max|sum|count|custom" the summary function 
						    avg type="string" average
						    min type="string" minimal
						    max type="string" maximal
						    sum type="string" sum
						    count type="string" count
						    custom type="string" custom summary
						    */
						    summaryFunction: "avg",
						    /* specifies the Summary text that will be shown before the value */
						    text: null,
						    /* specifies a custom summary function, which is called for each group, accepts an array of cell values for the specific column and returns the custom summary result */
						    customSummary: null
						}
					]
				}
			],
            /* type="string" specifies the expand indicator tooltip for grouped rows */
            expandTooltip: $.ig.GridGroupBy.locale.expandTooltip,
            /* type="string" specifies the collapse indicator tooltip for grouped rows */
            collapseTooltip: $.ig.GridGroupBy.locale.collapseTooltip,
            /* type="string" specifies the tooltip for the remove button */
            removeButtonTooltip: $.ig.GridGroupBy.locale.removeButtonTooltip,
            /* type="string" specifies the text in feature chooser */
            featureChooserText: $.ig.GridGroupBy.locale.featureChooserText,
            /* type="string" specifies hide text in feature chooser */
            featureChooserTextHide: $.ig.GridGroupBy.locale.featureChooserTextHide,
            /* type="bool" specifies whether on click in groupby dialog to be immediately grouped/ungrouped columns. When it is false then it is shown Apply button in the groupby dialog  */
            modalDialogGroupByOnClick: false,
            /* type="string" specifies the text of GroupBy button in the groupby dialog */
            modalDialogGroupByButtonText: $.ig.GridGroupBy.locale.modalDialogGroupByButtonText,
            /* type="string" Specifies caption for each descending sorted column in groupby dialog */
            modalDialogCaptionButtonDesc: $.ig.GridGroupBy.locale.modalDialogCaptionButtonDesc,
            /* type="string" Specifies caption for each ascending sorted column in groupby dialog */
            modalDialogCaptionButtonAsc: $.ig.GridGroupBy.locale.modalDialogCaptionButtonAsc,
            /* type="string" Specifies caption button ungroup in groupby dialog */
            modalDialogCaptionButtonUngroup: $.ig.GridGroupBy.locale.modalDialogCaptionButtonUngroup,
            /* type="string" Specifies caption text for groupby dialog */
            modalDialogCaptionText: $.ig.GridGroupBy.locale.modalDialogCaptionText,
            /* type="string" Specifies label for layouts dropdown in groupby dialog */
            modalDialogDropDownLabel: $.ig.GridGroupBy.locale.modalDialogDropDownLabel,
            /* type="string" Specifies name of the root layout which is shown layouts tree dialog */
            modalDialogRootLevelHierarchicalGrid: $.ig.GridGroupBy.locale.modalDialogRootLevelHierarchicalGrid,
            /* type="string" Specifies caption of layouts dropdown button in groupby dialog */
            modalDialogDropDownButtonCaption: $.ig.GridGroupBy.locale.modalDialogDropDownButtonCaption,
            /* type="string" Specifies label for clear all button in groupby dialog */
            modalDialogClearAllButtonLabel: $.ig.GridGroupBy.locale.modalDialogClearAllButtonLabel,
            /* type="string" Specifies caption for button which opens groupby dialog */
            emptyGroupByAreaContentSelectColumnsCaption: $.ig.GridGroupBy.locale.emptyGroupByAreaContentSelectColumnsCaption,
            /* type="number" Specifies width of layouts dropdown in groupby dialog */
            modalDialogDropDownWidth: 200,
            /* type="number" Specifies height of layouts dropdown in groupby dialog */
            modalDialogDropDownAreaWidth: null,
            /* type="number" Specifies time in milliseconds for animation duration to show/hide modal dialog */
            modalDialogAnimationDuration: 200,
            /* type="number" Specifies width of groupby dialog */
            modalDialogWidth: 400,
            /* type="number" Specifies height of groupby dialog */
            modalDialogHeight: '',
            // M.H. 9 March 2012 Fix for bug #103978
            /* type="string" Specifies text of button which apply changes in modal dialog */
            modalDialogButtonApplyText: $.ig.GridGroupBy.locale.modalDialogButtonApplyText,
            /* type="string" Specifies text of button which cancel changes in modal dialog */
            modalDialogButtonCancelText: $.ig.GridGroupBy.locale.modalDialogButtonCancelText,
			/* type="bool" Format grouped column using the formatter set in igGrid.columns[i].formatter or igGrid format. */
			useGridColumnFormatter: true,
			/* type="bool" Enables / disables groupby persistence between states*/
			persist: true,
			/* type="string" Controls containment behavior for the groupby dialog. 
                owner type="string" The groupby dialog will be draggable only in the grid area
                window type="string" The groupby dialog will be draggable in the whole window area
            */
			groupByDialogContainment: "owner"
        },
        events: {
            /* cancel="true" Event which is fired when the grouped columns collection is about to change. This event is not fired when group/ungroup from groupby modal dialog
            use args.owner in order to access the groupby widget object
            use args.owner.grid to access the grid widget option
            use args.groupedColumns to get a reference to the current groupedColumns
            use args.key to get a reference to the current column's key that's being grouped
            use args.layout to get a reference to the current layout object, if any
            use args.grid to get a reference to the current child grid element, in case it's an hierarchical grid
            */
            groupedColumnsChanging: "groupedColumnsChanging",
            /* event which is fired when the groupedColumns collection has changed. This event is fired also when group/ungroup from groupby modal dialog but key, layout and grid are not set
            use args.owner in order to access the groupby widget object
            use args.owner.grid to access the grid widget option
            use args.groupedColumns to get a reference to the current groupedColumns
            use args.key to get a reference to the current column's key that's being grouped
            use args.layout to get a reference to the current layout object, if any
            use args.grid to get a reference to the current child grid element, in case it's an hierarchical grid
            */
            groupedColumnsChanged: "groupedColumnsChanged",
            /* cancel="false" Event fired every time the groupby dialog changes its position.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupBy widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.modalDialogElement to get a reference to the Column Chooser element. This is a jQuery object.
            Use ui.originalPosition to get the original position of the groupby dialog div as { top, left } object, relative to the page.
            Use ui.position to get the current position of the groupby dialog div as { top, left } object, relative to the page.
            */
            modalDialogMoving: "modalDialogMoving",
            /* cancel="true" event fired before the modal dialog is closed.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupBy widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
            */
            modalDialogClosing: "modalDialogClosing",
            /* event fired after the modal dialog has been closed.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupBy widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
            */
            modalDialogClosed: "modalDialogClosed",
            /* cancel="true" event fired before the modal dialog is opened.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupBy widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
            */
            modalDialogOpening: "modalDialogOpening",
            /* event fired after the modal dialog is already opened.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupBy widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
            */
            modalDialogOpened: "modalDialogOpened",
            /* cancel="true" event fired before the contents of the modal dialog are rendered.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupby widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
            */
            modalDialogContentsRendering: "modalDialogContentsRendering",
            /* event fired after the contents of the modal dialog are rendered.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupBy widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
            */
            modalDialogContentsRendered: "modalDialogContentsRendered",
            /* cancel="true" event fired when the button is Apply is clicked.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupby widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
            Use ui.groupedColumns to get the array of grouped columns
            Use ui.groupedColumnLayouts to get array of column layouts
            Use ui.sortingExpr to get array of sorted columns
            */
            modalDialogButtonApplyClick: "modalDialogButtonApplyClick",
            /* cancel="true" event fired when reset button is clicked.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupby widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
            */
            modalDialogButtonResetClick: "modalDialogButtonResetClick",
            /* cancel="true" event fired when column in modal dialog is clicked to be grouped.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupby widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.key to get the key of the column to be grouped.
            Use ui.layout to get the layout of the columns
            */
            modalDialogGroupingColumn: "modalDialogGroupingColumn",
            /* event fired when column in modal dialog is clicked to be grouped.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupby widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.key to get the key of the column to be grouped.
            Use args.groupedColumns to get a reference to the current groupedColumns
            Use ui.layout to get the layout of the columns
            */
            modalDialogGroupColumn: "modalDialogGroupColumn",
            /* cancel="true" event fired when column in modal dialog is clicked to be ungrouped.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupby widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.key to get the key of the column to be grouped.
            Use ui.layout to get the layout of the columns
            */
            modalDialogUngroupingColumn: "modalDialogUngroupingColumn",
            /* event fired when column in modal dialog is clicked to be ungrouped.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupby widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use args.groupedColumns to get a reference to the current groupedColumns
            Use ui.key to get the key of the column to be grouped.
            Use ui.layout to get the layout of the columns
            */
            modalDialogUngroupColumn: "modalDialogUngroupColumn",
            /* cancel="true" event fired when column in modal dialog is clicked to be ungrouped.
            The handler function takes arguments evt and ui.
            Use ui.owner to get the reference to the igGridGroupby widget.
            Use ui.owner.grid to get the reference to the igGrid widget.
            Use ui.key to get the key of the column to be grouped.
            Use ui.layout to get the layout of the columns
            Use ui.isAsc to get whether column should be sorted ascending or descending
            */
            modalDialogSortGroupedColumn: "modalDialogSortGroupedColumn"
        },
        _create: function () {
			// A.T. 21 March 2012 - fix for #91992
			this._orderedGroupedCols = [];
        },
        _createWidget: function (options, element) {
            /* !Strip dummy objects from options, because they are defined for documentation purposes only! */
            this.options.columnSettings = [];
            this.options.groupedColumns = [];
            this._tempSortingExpr = [];
            this._tempGroupedColumns = [];
			// M.H. 23 March 2012 Fix for bug #105946
			this._tempOrderedGroupedCols = [];
            this._tempOptions = {};
            this._currentTreeLayer = null;
            this._isInitFC = false;
            this._modalSelectedLayout = null;
            $.Widget.prototype._createWidget.apply(this, arguments);
        },
        _setOption: function (key, value) {
            var modalDialog = $('#' + this.grid.id() + '_groupby_modalDialog');
            $.Widget.prototype._setOption.apply(this, arguments);
            if (key === "groupByAreaVisibility" || key === "expansionIndicatorVisibility") {
                throw new Error($.ig.Grid.locale.optionChangeNotSupported + ' ' + key);
            }
            // M.H. 14 March 2012 Fix for bug #104700
            switch (key) {
            case 'modalDialogGroupByOnClick':
                $('#' + this.grid.id() + '_groupby_modalDialog').remove();
                this._renderGroupByDialog();
                break;
            case 'modalDialogCaptionText':
                modalDialog.igGridModalDialog('option', 'modalDialogCaptionText', value);
                break;
            case 'modalDialogAnimationDuration':
                modalDialog.igGridModalDialog('option', 'animationDuration', value);
                break;
            case 'modalDialogWidth':
                modalDialog.igGridModalDialog('option', 'modalDialogWidth', value);
                break;
            case 'modalDialogHeight':
                modalDialog.igGridModalDialog('option', 'modalDialogHeight', value);
                break;
            case 'modalDialogButtonApplyText':
                modalDialog.igGridModalDialog('option', 'buttonApplyText', value);
                break;
            case 'modalDialogButtonCancelText':
                modalDialog.igGridModalDialog('option', 'buttonCancelText', value);
                break;
            default:
                break;
            }
        },
        _headerRendered: function (event, args) {
            // render the groupby area on top of the grid
            var groupby = this, groupbyarea;
            if (args.owner.id() !== this.grid.id()) {
                return;
            }
			/*
			if (this._hierarchical !== true && this._hierarchical !== false) {
                if (this.grid.headersTable().find(".ui-iggrid-expandheadercell").length > 0) {
                    this._hierarchical = true;
                } else {
                    this._hierarchical = false;
                }
            }
			*/
            if (args.owner.element.attr('data-childgrid')) {
                return;
            }
			// M.H. 31 May 2014 Fix for bug #172881: When groupByAreaVisibility ="hidden" the openGroupByDialog API method is not working
			this._renderGroupByDialog();
            if (this.options.groupByAreaVisibility === "top") {
                //groupbyarea = $("<div></div>").prependTo(args.table.parent());
                groupbyarea = $("<div></div>").prependTo(this.grid.container());
            } else if (this.options.groupByAreaVisibility === "bottom") {
                groupbyarea = $("<div></div>").appendTo(args.owner.container());
            } else if (this.options.groupByAreaVisibility === "hidden") {
                return; // group area is not visible
            }
            groupbyarea.attr('id', this.grid.element.attr('id') + "_groupbyarea").addClass(this.css.groupByArea);
            this._setGroupAreaTextContent($('<span></span>').appendTo(groupbyarea).addClass(this.css.groupByAreaText));
            groupbyarea.droppable({
                accept: "th:not([groupby-disabled])",
                hoverClass: groupby.css.groupByAreaDropHover,
                drop: function (event, ui) {
                    var accepted, isdescendant;
					isdescendant = ui.draggable.closest(".ui-iggrid-root").attr('id') === groupby.grid.id() ||
						ui.draggable.closest('.ui-iggrid').find('.ui-iggrid-root').length > 0;
                    if (!groupby.grid.element.hasClass("ui-iggrid-root")) {
                        isdescendant = true;
                    }
                    accepted = ui.draggable.hasClass('ui-iggrid-header') && isdescendant;
                    if (accepted) {
                        // invoke group by
                        groupby._groupBy(event, ui.draggable);
                    }
                }
            });
			// M.H. 11 July 2012 Fix for bug #115984
			if (this.grid._isMultiColumnGrid) {
				groupbyarea.droppable('option', 'tolerance', 'touch');
			}
            //this.openGroupByDialog();
        },
        _renderGroupByDialog: function () {
			var $buttonOK, containment,
				self = this,
				o = this.options,
				$captionButtonContainer,
				modalDialog;
			if (this.options.groupByDialogContainment === "owner") {
				containment = this.grid.container();
            } else {
                containment = 'window';
            }
			modalDialog = $('<div></div>')
					.appendTo(this.grid._rootContainer())
					.attr('id', this.grid.id() + '_groupby_modalDialog');
            modalDialog.igGridModalDialog({
                renderFooterButtons: !o.modalDialogGroupByOnClick,
                modalDialogCaptionText: o.modalDialogCaptionText,
                modalDialogWidth: o.modalDialogWidth,
                modalDialogHeight: o.modalDialogHeight,
                animationDuration: o.modalDialogAnimationDuration,
				// M.H. 9 March 2012 Fix for bug #103978
                buttonApplyText: o.modalDialogButtonApplyText,
                buttonCancelText: o.modalDialogButtonCancelText,
                // M.H. 8 May 2012 Fix for bug #110344
				containment: containment,
				gridContainer: this.grid.container(),
                modalDialogOpening: function (event, args) {
                    self._groupByDialogOpening(event, args);
                },
                // M.H. 13 March 2012 Fix for bug #104549
                modalDialogMoving: function (e, ui) {
                    self._trigger(self.events.modalDialogMoving, null,
						{
						    modalDialogElement: e.target,
						    owner: self,
						    originalPosition: ui.originalPosition,
						    position: ui.position
						});
                },
                modalDialogClosing: function (event, args) {
                    // M.H. 13 March 2012 Fix for bug #104549
                    return self._trigger(self.events.modalDialogClosing, null, { modalDialogElement: modalDialog, owner: self });
                },
                modalDialogClosed: function (event, args) {
                    // M.H. 13 March 2012 Fix for bug #104549
                    self._trigger(self.events.modalDialogClosed, null, { modalDialogElement: modalDialog, owner: self });
                }
            });
            if (o.modalDialogGroupByOnClick) {
                // show close button
                $captionButtonContainer = modalDialog.igGridModalDialog('getCaptionButtonContainer');
                $('<span></span>')
					.bind("click.hiding", function (event) {
					    modalDialog.igGridModalDialog('closeModalDialog', true);
					    event.preventDefault();
					    event.stopPropagation();
					    return false;
					})
					.addClass('ui-icon ui-icon-closethick')
					.appendTo(
						$('<a></a>')
							.appendTo($captionButtonContainer)
							.attr('title', $.ig.GridHiding.locale.columnChooserCloseButtonTooltip)
							.attr('href', '#')
							.attr('role', 'button')
							.addClass('ui-dialog-titlebar-close ui-corner-all')
					);
            } else {
                $captionButtonContainer = modalDialog.igGridModalDialog('getCaptionButtonContainer');
                $buttonOK = $('#' + this.grid.id() + '_groupby_modalDialog_footer_buttonok');
                $buttonOK.bind('igbuttonclick', function (e) { self._groupByDialogButtonOKClick(e); });
            }
        },
        openGroupByDialog: function () {
            /* Open groupby modal dialog */
            var modalDialog = $('#' + this.grid.id() + '_groupby_modalDialog');
            modalDialog.igGridModalDialog('openModalDialog');
        },
        closeGroupByDialog: function () {
            /* Close groupby modal dialog */
            var modalDialog = $('#' + this.grid.id() + '_groupby_modalDialog');
            modalDialog.igGridModalDialog('closeModalDialog');
        },
        _groupByDialogOpening: function () {
            var noCancel, modalDialog = $('#' + this.grid.id() + '_groupby_modalDialog');
            noCancel = this._trigger(this.events.modalDialogOpening, null, { modalDialogElement: modalDialog, owner: this });
            if (noCancel) {
                this.renderGroupByModalDialog();
                this._trigger(this.events.modalDialogOpened, null, { modalDialogElement: modalDialog, owner: this });
            }
        },
        renderGroupByModalDialog: function () {
            /* Render groupby modal dialog and its content */
            var $content, i,
				self = this,
				o = this.options,
				css = this.css,
				modalDialog = $('#' + this.grid.id() + '_groupby_modalDialog'),
				noCancel,
				$groupedColumns,
				$ungroupedColumns;

            noCancel = this._trigger(this.events.modalDialogContentsRendering, null, { modalDialogElement: modalDialog, owner: this });
            if (noCancel) {
                $content = modalDialog.igGridModalDialog('getContent');
                $content.empty();
				self._tempGroupedColumns = o.groupedColumns.slice(0);
				// M.H. 23 March 2012 Fix for bug #105946
				self._tempOrderedGroupedCols = self._orderedGroupedCols.slice(0);
				// M.H. 12 March 2012 Fix for bug #104507
                self._tempSortingExpr = self.grid.dataSource.settings.sorting.expressions.slice(0);
                self._tempOptions = { columnLayouts: [] };
				// M.H. 20 March 2012 Fix for bug #105271
                if (this.grid.options.columnLayouts && this.grid.options.columnLayouts.length > 0) {
					for (i = 0; i < this.grid.options.columnLayouts.length; i++) {
						self._tempOptions.columnLayouts.push($.extend(true, {}, this.grid.options.columnLayouts[i]));
					}
                    this._renderLayoutsDropDown();
                }
                $groupedColumns = $('<div></div>')
					.attr('id', this.grid.id() + "_groupby_modalDialog_groupedcolumns")
					.addClass(css.dialogGroupedColumns)
					.appendTo($content);
                $ungroupedColumns = $('<div></div>')
					.attr('id', this.grid.id() + "_groupby_modalDialog_ungroupedcolumns")
					.addClass(css.dialogUnroupedColumns)
					.appendTo($content);

                $('<ul></ul>')
					.addClass(css.dialogListGroupedColumns)
					.appendTo($groupedColumns);
                $('<ul></ul>')
					.addClass(css.dialogListUngroupedColumns)
					.appendTo($ungroupedColumns);

                this._renderColumnsDialog(this.grid.options.columns);
                this._currentTreeLayer = null;
                if (this._isToRenderClearAllButton()) {
                    this._renderDialogButtonClearAll();
                } else {
                    // M.H. 8 March 2012 Fix for bug #103675
                    $('#' + this.grid.id() + '_groupbydialog_reset_button').remove();
                }
                this._trigger(this.events.modalDialogContentsRendered, null, { modalDialogElement: modalDialog, owner: this });
            }
            //this._addSlideButtonGroupedColumns();
        },
        _addSlideButtonGroupedColumns: function () {
            var css = this.css,
				o = this.options,
				$groupedColumns = $('#' + this.grid.id() + "_groupby_modalDialog_groupedcolumns"),
				buttonId = this.grid.id() + '_groupbymodaldialot_slidebutton',
				$button,
				innerHTML;

            innerHTML = '<div class="' + css.dialogSlideArea + '">' +
				'	<div class="' + css.dialogSlideAreaContainer + '">' +
				'		<button id="' + buttonId + '" class="' + css.dialogButtonSlide + '" role="button" aria-disabled="false" title="' + o.dialogButtonSlideCaption + '">' +
				'			<span class="' + css.dialogButtonSlideContainer + '"></span>' +
				'			<span class="ui-button-text">' + o.dialogButtonSlideCaption + '</span>' +
				'		</button>' +
				'	</div>' +
				'</div>';
            $(innerHTML).insertAfter($groupedColumns);
            $button = $('#' + buttonId);
            $button.bind({
                click: function (e, args) {
                    $groupedColumns.slideToggle("slow");
                    $(this).find('span:eq(0)').toggleClass(css.dialogButtonSlideUp);
                    return false;
                }
            });
        },
        _renderLayoutsDropDown: function () {
            var o = this.options, fn, w, dW, $ddField,
				self = this,
				css = this.css,
				modalDialog = $('#' + this.grid.id() + '_groupby_modalDialog'),
				$content = modalDialog.igGridModalDialog('getContent'),
				cancelFunc,
				htmlLayouts,
				$buttonDD,
				$dropDown,
				$tree,
				dropDownId = this.grid.id() + '_groupby_modalDialog_layoutsDD',
				modalDialogDropDownAreaWidth = o.modalDialogDropDownAreaWidth || o.modalDialogDropDownWidth,
				columnLayoutsData = this.grid.options.columnLayouts.slice(0),
				$layoutsContainer;

            $layoutsContainer = $('<div></div>')
				.attr('id', this.grid.id() + '_groupby_modalDialog_layoutsContainer')
				.addClass(css.modalDialogLayoutsContainer)
				.appendTo($content);

            htmlLayouts = '<div style="float: left;">' + o.modalDialogDropDownLabel + '</div>' +
				'<div class="' + css.dialogLayoutsDD + '">' +
				'	<div id="' + this.grid.id() + '_groupby_modalDialog_layoutsDDField" class="' + css.dialogLayoutsDDField + '">' + o.modalDialogRootLevelHierarchicalGrid + '</div>' +
				'	<span id="' + this.grid.id() + '_groupby_modalDialog_layoutsDDButton" style="float:right;">^</span>' +
				'	<div style="clear: both;"></div>' +
				'</div>' +
				'<div style="clear: both;"></div>';

            $layoutsContainer.html(htmlLayouts);
            $buttonDD = $('#' + this.grid.id() + '_groupby_modalDialog_layoutsDDButton');
            $buttonDD.wrap('<a href="#" title="' + o.modalDialogDropDownButtonCaption + ' "></a>');
            cancelFunc = function (e) { e.preventDefault(); e.stopPropagation(); };

            $buttonDD.closest('div').bind({
                mousedown: function (event) {
                    self._toggleDropDown(event, false);
                },
                mouseup: cancelFunc,
                click: cancelFunc
            });

            $buttonDD.addClass(css.dialogLayoutsDDButton);
            if (this._checkIsGroupByInherit(this.grid.options) === false) {
                columnLayoutsData = this._getEnabledGroupByLayouts(columnLayoutsData);
            }
            if (columnLayoutsData.length > 0 || this._checkIsGroupByEnabled(this.grid.options)) {
                $dropDown = $('#' + dropDownId);
                $dropDown.remove();

                // check whether dropdown container is initialized and if not - initialize
                $dropDown = $('<div></div>');
                $dropDown
					.attr('id', dropDownId).css({ 'position': 'absolute', 'display': 'none', 'z-index': '1000' })
					.addClass(this.css.dropDownLayoutsContainer).appendTo($('#' + this.grid.id() + '_groupby_modalDialog_content'))
					.bind({
						// M.H. 26 Mar 2014 Fix for bug #160244: When clicking the scrollbar of the dropdown in GrouBy it closes before selecting an item from the tree
					    mousedown: function (e, args) {
					        clearTimeout(self._dropDownTimeout);
					        setTimeout(function () {
					            $buttonDD.closest('a').focus();
					        }, 10);
					    }
					});
                if (o.modalDialogDropDownWidth) {
                    $buttonDD.closest('div').width(o.modalDialogDropDownWidth);
                }
                if (modalDialogDropDownAreaWidth) {
                    $dropDown.width(modalDialogDropDownAreaWidth);
                }
				// M.H. 26 Mar 2014 Fix for bug #160241: Long text exceeds the size of the dropdown in GroupBy modal dialog
				if (o.modalDialogDropDownWidth &&
					(!o.modalDialogDropDownWidth.indexOf || o.modalDialogDropDownWidth.indexOf('%') === -1)) {
					w = $buttonDD.closest('div').width() - $buttonDD.outerWidth();
					$ddField = $('#' + this.grid.id() + '_groupby_modalDialog_layoutsDDField');
					$ddField.width(w);
					dW = $ddField.outerWidth() - w;
					if (dW > 0) {
						w -= dW;
						$ddField.width(w - 2);
					}
				}
                $tree = $('<div></div>')
					.attr('id', this.grid.id() + '_groupby_modal_treeLayouts')
					.addClass(css.modalDialogTreeContainer);
                $tree.appendTo($dropDown);
                columnLayoutsData = [{ key: 'root', columnLayouts: columnLayoutsData, isRoot: true}];

                $tree.igTree({
                    dataSourceType: 'json',
                    dataSource: columnLayoutsData,
                    initialExpandDepth: 1000000,
                    bindings: {
                        textKey: 'key',
                        childDataProperty: 'columnLayouts'
                    },
                    nodeClick: function (event, args) {
                        var data = args.node.data, keyLayout = data.key,
							$groupedUL = $('#' + self.grid.id() + "_groupby_modalDialog_groupedcolumns ul"),
							$ungroupedUL = $('#' + self.grid.id() + "_groupby_modalDialog_ungroupedcolumns ul");
                        // M.H. 13 March 2012 Fix for bug #104646
                        if (data.dislabledGroupBy === true) {
                            return;
                        }
                        $groupedUL.empty();
                        $ungroupedUL.empty();
                        $('#' + self.grid.id() + '_groupby_modalDialog_layoutsDDField').text(keyLayout);
                        if (args.node.path.length === 1) {
                            self._renderColumnsDialog(self.grid.options.columns);
                            self._currentTreeLayer = null;
                        } else {
                            self._currentTreeLayer = keyLayout;
                            self._renderColumnsDialog(data.columns, keyLayout);
                        }
                        self._toggleDropDown();
                    }
                });

                // M.H. 14 March 2012 Fix for bug #104647
                fn = function () {
                    self._dropDownTimeout = setTimeout(function () {
                        self.closeDropDown();
                    }, 200);
                };
                $buttonDD.closest('a').bind({
                    focus: function () {
                        self._igTreeHasFocus = true;
                        clearTimeout(self._dropDownTimeout);
                    },
                    blur: function () {
                        self._igTreeHasFocus = false;
                        fn();
                    }
                });
                // M.H. 14 March 2012 Fix for bug #104647
                $tree.find('a').bind({
                    focus: function () {
                        clearTimeout(self._dropDownTimeout);
                    },
                    blur: function () {
                        fn();
                    }
                });

                $tree.find('span.ui-igtree-expander.ui-icon').bind({
                    click: function () {
                        clearTimeout(self._dropDownTimeout);
                        setTimeout(function () {
                            $buttonDD.closest('a').focus();
                        }, 10);
                    }
                });
            }
        },
        openDropDown: function () {
            /* Open layouts dropdown */
            var $dropDown = $('#' + this.grid.id() + '_groupby_modalDialog_layoutsDD');
            if ($dropDown.is(':visible') === false) {
                this._toggleDropDown();
            }
        },
        closeDropDown: function () {
            /* Close layouts dropdown */
            var $dropDown = $('#' + this.grid.id() + '_groupby_modalDialog_layoutsDD');
            if ($dropDown.is(':visible') === true) {
                this._toggleDropDown();
            }
        },
        // M.H. 13 March 2012 Fix for bug #104646
        _getEnabledGroupByLayouts: function (layouts) {
            // get only those layouts which are groupby enabled(also inherit can be applied)
            var resultLayouts = [], i, tempChildLayouts, layout;
            if (layouts) {
                for (i = 0; i < layouts.length; i++) {
                    tempChildLayouts = null;
                    // M.H. 14 March 2012 Fix for bug #104823
                    layout = $.extend(true, {}, layouts[i]);

                    if (layout.columnLayouts && this._checkIsGroupByInherit(layout) === false) {
                        tempChildLayouts = this._getEnabledGroupByLayouts(layout.columnLayouts);
                        if (tempChildLayouts && tempChildLayouts.length > 0) {
                            // M.H. 15 March 2012 Fix for bug #104646
                            layout.columnLayouts = tempChildLayouts;
                        } else {
                            // M.H. 15 March 2012 Fix for bug #104646
                            layout.columnLayouts = null;
                        }
                    }
                    if (this._checkIsGroupByEnabled(layout)) {
                        resultLayouts.push(layout);
                    } else if (layout.columnLayouts !== null && layout.columnLayouts !== undefined) {
                        layout.dislabledGroupBy = true;
                        resultLayouts.push(layout);
                    }
                }
            }

            return resultLayouts;
        },
        _checkIsGroupByInherit: function (layout) {
            var i;

            if (layout && layout.features) {
                for (i = 0; i < layout.features.length; i++) {
                    if (layout.features[i].name === "GroupBy" && layout.features[i].inherit === true) {
                        return true;
                    }
                }
            }
            return false;
        },
        _checkIsGroupByEnabled: function (layout) {
            var i;

            if (layout && layout.features) {
                for (i = 0; i < layout.features.length; i++) {
                    if (layout.features[i].name === "GroupBy") {
                        return true;
                    }
                }
            }
            return false;
        },
        _toggleDropDown: function () {
            // show/hide feature chooser dialog
            var $button = $('#' + this.grid.id() + '_groupby_modalDialog_layoutsDDButton').parent(),
				$modalDialogContent = $('#' + this.grid.id() + '_groupby_modalDialog_content'),
				$layoutsDDField = $('#' + this.grid.id() + '_groupby_modalDialog_layoutsDDField').parent(),
                left = 0,
                top = 0,
                $dropDown = $('#' + this.grid.id() + '_groupby_modalDialog_layoutsDD'),
                isVisible = ($dropDown.is(':visible') === true),
                self = this;
            if ($dropDown.data('isAnimating') === true) {
                return;
            }
            if (!isVisible) {
				// M.H. 3 April 2012 Fix for bug #104645
                top = $layoutsDDField.offset().top - $modalDialogContent.offset().top + $layoutsDDField.height() + 1;
                left = $layoutsDDField.offset().left - $modalDialogContent.offset().left;
                $dropDown.css({ 'top': top, 'left': left });
            }
            $dropDown.data('isAnimating', true);
            $dropDown.slideToggle(
				400,
				function () {
				    var $layoutsDD = $('#' + self.grid.id() + '_groupby_modalDialog_layoutsDD'),
						$tree = $('#' + self.grid.id() + '_groupby_modal_treeLayouts');
				    if ($dropDown.is(':visible') === true) {
				        $button.focus();
				        self._activeDropdown = $dropDown;
				        if (!self.options.modalDialogDropDownAreaWidth && !self.options.modalDialogDropDownWidth) {
				            if ($layoutsDD.width() !== $tree.width()) {
				                $layoutsDD.width($tree.width());
				            }
				        }
				        //$button.children('span:first').addClass(self.css.headerButtonIconSelected);
				    } else {
				        self._activeDropdown = null;
				        //$button.children('span:first').removeClass(self.css.headerButtonIconSelected);
				    }
				    $dropDown.data('isAnimating', false);
				}
			);
        },
        _groupByDialogButtonOKClick: function (e, args) {
            var noCancel, o = this.options, modalDialog = $('#' + this.grid.id() + '_groupby_modalDialog'), i, j, len, tempGroupedCol, isToCallGroupedColumnsChanged = false, copy;
            // M.H. 13 March 2012 Fix for bug #104524
            noCancel = this._trigger(this.events.modalDialogButtonApplyClick, null, { modalDialogElement: modalDialog, owner: this, groupedColumns: this._tempGroupedColumns, groupedColumnLayouts: this._tempOptions.columnLayouts, sortingExpr: this._tempSortingExpr });
            if (noCancel) {
				// M.H. 4 April 2012 Fix for bug #106390
				if (this._orderedGroupedCols.length !== this._tempOrderedGroupedCols.length) {
					isToCallGroupedColumnsChanged = true;
				} else {
					len = this._orderedGroupedCols.length;
					for (i = 0; i < len; i++) {
						tempGroupedCol = this._tempOrderedGroupedCols[i];
						for (j = 0; j < len; j++) {
							if (tempGroupedCol.key === this._orderedGroupedCols[j].key &&
									tempGroupedCol.layout === this._orderedGroupedCols[j].layout) {
								break;
							}
						}
						if (j === len) {
							isToCallGroupedColumnsChanged = true;
							break;
						}
					}
				}
				// M.H. 4 April 2012 Fix for bug #106390
				// M.H. 6 April 2012 Fix for bug #108338
				if (isToCallGroupedColumnsChanged === true) {
					this.grid._onGroupedColumnsChanged(this._tempGroupedColumns);
					this._trigger(this.events.groupedColumnsChanged, e, {
						owner: this,
						groupedColumns: this._tempGroupedColumns
						//key: key,
						//layout: layout,
						//grid: cgrid
					});
				}
				// M.H. 23 March 2012 Fix for bug #105946
				// M.H. 28 March 2012 Fix for bug #106980
				//if (this._hierarchical) {
				this._orderedGroupedCols = this._tempOrderedGroupedCols;
				//}
				if (o.groupedColumns) {
                    o.groupedColumns = this._tempGroupedColumns;
                }

				if (this.grid.options.columnLayouts) {
                    this.grid.options.columnLayouts = this._tempOptions.columnLayouts;
                }

                if (this.grid.dataSource.settings.sorting.expressions) {
					this.grid.dataSource.settings.sorting.expressions = this._tempSortingExpr;
                }
                // M.H. 20 March 2012 Fix for bug #105273
				if (this._isToRenderClearAllButton() === false) {
					if ($('.ui-iggrid-groupbyarea', this.grid.container()).find("ul li").length === 0) {
						this._isgroup = null;
					} else {
						this._isgroup = false;
					}
				} else {
					this._isgroup = true;
				}
                // M.H. 15 March 2012 Fix for bug #104507
                if (o.groupedColumns.length === 0 && this.grid.headersTable().find('thead tr').children().first().hasClass('ui-iggrid-expandheadercellgb')) {
                    this.grid.element.find("colgroup").children().first().remove();
                    if (this.grid.options.fixedHeaders) {
                        this.grid.headersTable().find("colgroup").children().first().remove();
                    }
                    // M.H. 12 Oct. 2011 Fix for bug #90815
                    if (this.grid.options.fixedFooters && this.grid.options.height !== null) {
                        this.grid.footersTable().find("colgroup").children().first().remove();
                    }
                    // L.A. 04 January 2013 - Fixing bug #129797 A column's header cell is removed instead 
                    // of the group-by expander header cell when ungrouping is performed (either through the UI or programatically)  
                    // while a column is being grouped (remote GroupBy)
                    this.grid.headersTable().find('thead tr').children('[data-skip]').first().remove();
                }
                // M.H. 30 Oct 2012 Fix for bug #117396
                copy = this._orderedGroupedCols.slice(0);
                this._orderedGroupedCols = [];
                this._ensureLabelsOrder(copy, this._orderedGroupedCols, this.grid.options);
                this._rebind();
				// M.H. 29 May 2012 Fix for bug #112881
				if (this.grid.options.width !== null && this.grid.options.width !== undefined) {
					this.grid._updateGridContentWidth();
				}
                this.grid._trigger("headerExtraCellsModified", null, { owner: this });

                e.preventDefault();
                e.stopPropagation();
                modalDialog.igGridModalDialog('closeModalDialog');
            }
        },
        _setSortingTempExpr: function (key, dir, layout) {
            var i, layouts,
				j, gc = this._tempGroupedColumns, gcTemp, sexpr, s = this._tempSortingExpr, settings, lobj;

            sexpr = { fieldName: key, dir: dir, layout: layout, isGroupBy: true };
			// M.H. 19 March 2012 Fix for bug #104507 - remove sorting when dir is not specified(when it is '')
			if (dir === '') {
				for (j = 0; j < s.length; j++) {
                    if (s[j].fieldName === key && s[j].layout === layout) {
                        s.splice(j, 1);
                        break;
                    }
                }
				return;
			}
            if (gc.length === 0 && !layout) {
                // if we are inside of changeSortState and the count is zero, get all grouped cols)
                gcTemp = this._tempGroupedColumns.slice(0);
                this._allGroupedCols(gcTemp);
                gc = gcTemp.slice(0);
            }
            for (i = 0; i < gc.length; i++) {
                if (gc[i].key === key) {
                    gc[i].dir = dir;
                    for (j = 0; j < s.length; j++) {
                        if (s[j].fieldName === key) {
                            s[j].dir = gc[i].dir;
                            if (gc[i].layout) {
                                s[j].layout = gc[i].layout;
                            }
                            break;
                        }
                    }
                    if (j === s.length) {
						// M.H. 17 May 2012 Fix for bug #111331
						this._addSortingExpressions(s, sexpr);
                        //s.push(sexpr);
                    }
                    break;
                }
            }
            if (layout) {
				// M.H. 28 March 2012 Fix for bug #106952
				for (i = 0; i < this._tempOrderedGroupedCols.length; i++) {
					if (this._tempOrderedGroupedCols[i].key === key &&
							((this._tempOrderedGroupedCols.layout && this._tempOrderedGroupedCols.layout === layout) || !this._tempOrderedGroupedCols.layout)) {
						this._tempOrderedGroupedCols[i].dir = dir;
						break;
					}
				}

                for (j = 0; j < s.length; j++) {
                    if (s[j].fieldName === key && s[j].layout === layout) {
                        s[j].dir = dir;
                        break;
                    }
                }
                if (j === s.length) {
					// M.H. 17 May 2012 Fix for bug #111331
					this._addSortingExpressions(s, sexpr);
                    //s.push(sexpr);
                }
                // find the layout and change the settings
                layouts = [];
                this._findLayout(layout, this._tempOptions, layouts);
                lobj = layouts[0];
                for (i = 0; lobj.features && i < lobj.features.length; i++) {
                    if (lobj.features[i].name === "GroupBy") {
                        // find the col setting in order to change the sort direction
                        settings = lobj.features[i].columnSettings;
                        for (j = 0; j < settings.length; j++) {
                            if (settings[j].columnKey === key) {
                                settings[j].dir = dir;
                                break;
                            }
                        }
                        break;
                    }
                }
            }
        },
        _setGroupByTempExpr: function (key, isGroupBy, dir, layout) {
            var i, gexpr, expr, lobj, c, fcs, setting, layouts;

            if (layout) {
                layouts = [];
                this._findLayout(layout, this._tempOptions, layouts);
                lobj = layouts[0];
				//lobj = $.extend(true, {}, layouts[0]);
                c = this._getColumnByLayoutKey(key, lobj.columns);
            } else {
                lobj = this.grid.options;
                c = this.grid.columnByKey(key);
            }
            if (layout) {
                if (!lobj.features) {
                    lobj.features = [];
                    lobj.features.push({ name: "GroupBy", columnSettings: [] });
                    fcs = lobj.features[0].columnSettings;
                } else {
                    for (i = 0; i < lobj.features.length; i++) {
                        if (lobj.features[i].name === "GroupBy") {
                            fcs = lobj.features[i].columnSettings;
                            if (!fcs) {
                                lobj.features[i].columnSettings = [];
                                fcs = lobj.features[i].columnSettings;
                            }
                            break;
                        }
                    }
                }
                for (i = 0; i < fcs.length; i++) {
                    if (fcs[i].columnKey === key) {
                        if (!isGroupBy) {
                            fcs.splice(i, 1);
                        } else {
                            setting = fcs[i];
                        }
                        break;
                    }
                }

                if (isGroupBy) {
                    if (!setting) {
                        fcs.push({ columnKey: key, isGroupBy: isGroupBy, dir: dir });
                    } else {
                        setting.isGroupBy = isGroupBy;
                        setting.dir = dir;
                    }
                }
            }
            // if the layout is defined we need to store that layout in the data source, and set the group expression to the layout's settings 
            // where it belongs to
            gexpr = { key: key, dir: dir, layout: layout, col: c };

            if (!layout) {
                expr = this._tempGroupedColumns;

                for (i = 0; i < expr.length; i++) {
                    if (expr[i].key === key) {
                        expr.splice(i, 1);
                        break;
                    }
                }
                if (isGroupBy) {
                    expr = expr.concat(gexpr);
                }
                this._tempGroupedColumns = expr;
            }
			if (isGroupBy) {
				this._tempOrderedGroupedCols.push(gexpr);
			} else {
				for (i = 0; i < this._tempOrderedGroupedCols.length; i++) {
					if (this._tempOrderedGroupedCols[i].key === key &&
							((this._tempOrderedGroupedCols.layout && this._tempOrderedGroupedCols.layout === layout) || !this._tempOrderedGroupedCols.layout)) {
						$.ig.removeFromArray(this._tempOrderedGroupedCols, i);
						break;
					}
				}
			}
			// M.H. 19 March 2012 Fix for bug #104507
            this._setSortingTempExpr(key, dir, layout);
        },
        // M.H. 19 Sep 2013 Fix for bug #131441: checkColumnIsGrouped API doesn't work
        _checkColumnIsGroupedInternal: function (key, layout, groupedColumns, options) {
            var isGrouped = false, i, j, layouts, lobj, fcs;

            if (!layout) {
                for (i = 0; i < groupedColumns.length; i++) {
                    if (groupedColumns[i].key === key) {
                        isGrouped = true;
                        break;
                    }
                }
            } else {
                layouts = [];
                this._findLayout(layout, options, layouts);
                lobj = layouts[0];
                if (lobj && lobj.features) {
                    for (i = 0; i < lobj.features.length; i++) {
                        if (lobj.features[i].name === "GroupBy") {
                            fcs = lobj.features[i].columnSettings;
                            if (fcs) {
                                for (j = 0; j < fcs.length; j++) {
                                    if (fcs[j].columnKey === key) {
                                        if (fcs[j].isGroupBy) {
                                            isGrouped = true;
                                        }
                                        break;
                                    }
                                }
                            }
                            break;
                        }
                    }
                }
            }
            return isGrouped;
        },
        checkColumnIsGrouped: function (key, layout) {
            /* Check whether column with specified key and layout is grouped
            paramType="string" key of the column
            paramType="string" layout name
            */
            return this._checkColumnIsGroupedInternal(key, layout, this.options.groupedColumns, this.grid.options);
        },
		_getAllColumns: function (columns, columnsRes) {
			var i, columnsLength = columns.length;

			for (i = 0; i < columnsLength; i++) {
				if (columns[i].group) {
					this._getAllColumns(columns[i].group, columnsRes);
				} else {
					columnsRes.push(columns[i]);
				}
			}
		},
        _renderColumnsDialog: function (columns, layout) {
            var self = this, columnsRes = [];

			if (this.grid._isMultiColumnGrid) {
				this._getAllColumns(columns, columnsRes);
			} else {
				columnsRes = columns;
			}

            $.each(columnsRes, function (columnIndex, column) {
				var cs = self._findColumnSetting(column.key);
				// M.H. 7 Sep 2012 Fix for bug #120471 - do not show unbound columns in column list of the advanced dialog
				// M.H. 12 Sep 2012 Fix for bug #121078 - Selecting a child grid where there's at least one unbound column causes a JS error when GroupBy is remote and inherited
				// M.H. 10 Oct 2012 Fix for bug #123203 - Unbound column(s) are not listed in local group-by's modal dialog
				if (self.options.type === 'remote' && (column.unboundDS === true || column.unbound === true)) {
					return true;
				}
				// M.H. 21 March 2012 Fix for bug #105590
				if (!cs || cs.allowGrouping) {
                    // M.H. 19 Sep 2013 Fix for bug #131441: checkColumnIsGrouped API doesn't work
                    if (self._checkColumnIsGroupedInternal(column.key, layout, self._tempGroupedColumns, self._tempOptions)) {
						self._renderDialogGroupedColumn(column, layout);
					} else {
						self._renderDialogUngroupedColumn(column, layout);
					}
				}
            });
        },
        _clearAllGroupedColumns: function () {
            this._tempGroupedColumns = [];
            this._clearAllGroupedColumnsLayout(this._tempOptions);
        },
        _clearAllGroupedColumnsLayout: function (layout) {
            var i, fcs;
            if (layout !== null && layout.features) {
                for (i = 0; i < layout.features.length; i++) {
                    if (layout.features[i].name === "GroupBy") {
                        fcs = layout.features[i].columnSettings;
                        if (fcs) {
                            layout.features[i].columnSettings = [];
                        }
                    }
                }
            }

            for (i = 0; layout.columnLayouts && i < layout.columnLayouts.length; i++) {
                this._clearAllGroupedColumnsLayout(layout.columnLayouts[i]);
            }
        },
        _isToRenderClearAllButton: function () {
            // M.H. 8 March 2012 Fix for bug #103407
            if (this.options.modalDialogGroupByOnClick === true) {
                return true;
            }
            if (this._tempGroupedColumns.length > 0) {
                return true;
            }

            if (this._checkRenderLayoutsClearAll(this.grid.options) === true) {
                return true;
            }

            return false;
        },
        _checkRenderLayoutsClearAll: function (layout) {
            var i, j, fcs;
            if (layout !== null && layout.features) {
                for (i = 0; i < layout.features.length; i++) {
                    if (layout.features[i].name === "GroupBy") {
                        fcs = layout.features[i].columnSettings;
                        if (fcs) {
                            for (j = 0; j < fcs.length; j++) {
                                if (fcs[j].isGroupBy) {
                                    return true;
                                }
                            }
                        }
                    }
                }
            }

            for (i = 0; layout.columnLayouts && i < layout.columnLayouts.length; i++) {
                if (this._checkRenderLayoutsClearAll(layout.columnLayouts[i]) === true) {
                    return true;
                }
            }
            return false;
        },
        _renderDialogGroupedColumn: function (column, layout) {
            var i, j, s, $li, liHTML, $buttonUngroup,
				o = this.options,
				self = this,
				css = this.css,
				key = column.key,
				$ul = $('#' + this.grid.id() + "_groupby_modalDialog_groupedcolumns ul"),
				buttonAscDescId = this.grid.id() + "_" + key + "_groupbydialog_groupedcolumns_buttonascdesc",
				buttonUngroupId = this.grid.id() + "_" + key + "_groupbydialog_groupedcolumns_buttonungroup",
				dir = 'asc',
				gc = null;
			// L.A. 03 October 2012 - Fixing bug #122446 - Group by dialog doesn't look right when you group a couple of columns in IE8.
			// The cruel idea is to cause the IE8 to flush the dialog rendering by just reading the width value
			$('#' + this.grid.id() + '_groupby_modalDialog').css('width');
            if (!layout) {
                for (i = 0; i < self._tempGroupedColumns.length; i++) {
                    if (self._tempGroupedColumns[i].key === key) {
                        gc = self._tempGroupedColumns[i];
                        dir = gc.dir;
                        break;
                    }
                }
            } else {
                s = self._tempSortingExpr;
                for (j = 0; j < s.length; j++) {
                    if (s[j].fieldName === key && s[j].layout === layout) {
                        dir = s[j].dir;
                        break;
                    }
                }
            }
            $li = $('<li></li>')
				.attr('id', self.grid.id() + '_' + key + '_groupbydialog_grouped_li')
				.addClass(css.dialogGroupedItem);
            $li.appendTo($ul);
            //this._insertColumnModalDialog($ul, $li, columnSetting.columnIndex);
            liHTML = '<span id="' + buttonAscDescId + '" class="' + css.dialogButtonAsc + '" role="button" title="' + o.modalDialogCaptionButtonAsc + '">' +
				'	<span class="' + css.dialogButtonAscIcon + '"></span>' +
				'</span>' +
				'<span class="' + css.dialogGroupedColumnTextContainer + '">' + column.headerText + '</span>' +
				'<button id="' + buttonUngroupId + '" class="' + css.dialogButtonUngroup + '" role="button" title="' + o.modalDialogCaptionButtonUngroup + '" >' +
				'	<span class="' + css.dialogButtonUngroupContainer + '"></span>' +
				'	<span class="ui-button-text">' + o.modalDialogCaptionButtonUngroup + '</span>' +
				'</button>';
            $li.html(liHTML);
            $buttonUngroup = $('#' + buttonUngroupId);
            self._setDialogButtonAscDesc((dir === 'asc'), key);

            $li.bind({
                click: function (e, args) {
                    self._dialogButtonAscDescClick(key, layout);
                }
            });
            $buttonUngroup.bind({
                click: function (e, args) {
                    var noCancel;
                    // M.H. 15 March 2012 Fix for bug #104449
                    noCancel = self._trigger(self.events.modalDialogUngroupingColumn, e, { key: key, layout: layout, owner: self });
                    if (noCancel) {
                        $li.remove();
                        if (o.modalDialogGroupByOnClick === true) {
                            self.ungroupByColumn(key, layout);
                        } else {
                            self._setGroupByTempExpr(key, false, "", layout);
                        }
                        self._renderDialogUngroupedColumn(column, layout);
						// M.H. 19 March 2012 Fix for bug #105102
						if ($('#' + self.grid.id() + "_groupby_modalDialog_groupedcolumns ul li").length === 0 &&
								self._isToRenderClearAllButton() === false) {
							$('#' + self.grid.id() + '_groupbydialog_reset_button').remove();
						}
						// M.H. 15 March 2012 Fix for bug #104449
						self._trigger(self.events.modalDialogUngroupColumn, e, { key: key, layout: layout, owner: self, groupedColumns: self._tempGroupedColumns });
                    }
                    e.preventDefault();
                    e.stopPropagation();
                },
                mouseover: function (e, args) {
                    if (!$(this).hasClass(css.dialogButtonsHover)) {
                        $(this).addClass(css.dialogButtonsHover);
                    }
                },
                mouseout: function (e, args) {
                    if ($(this).hasClass(css.dialogButtonsHover)) {
                        $(this).removeClass(css.dialogButtonsHover);
                    }
                }
            });
        },
        _dialogButtonAscDescClick: function (key, layout) {
            var o = this.options,
				$buttonAscDesc = $('#' + this.grid.id() + "_" + key + "_groupbydialog_groupedcolumns_buttonascdesc"),
				noCancel,
				modalDialog = $('#' + this.grid.id() + '_groupby_modalDialog'),
				isAsc = $buttonAscDesc.data('isAsc');
            // M.H. 13 March 2012 Fix for bug #104705
            noCancel = this._trigger(this.events.modalDialogSortGroupedColumn, null, { modalDialogElement: modalDialog, owner: this, key: key, isAsc: !isAsc, layout: layout });
            if (noCancel) {
                if (isAsc === true) {
                    if (o.modalDialogGroupByOnClick === true) {
                        this._setSortingTempExpr(key, 'desc', layout);
                        this.grid.dataSource.settings.sorting.expressions = this._tempSortingExpr;
                        this._rebind();
                    } else {
                        this._setSortingTempExpr(key, 'desc', layout);
                    }
                } else {
                    if (o.modalDialogGroupByOnClick === true) {
                        this._setSortingTempExpr(key, 'asc', layout);
                        this.grid.dataSource.settings.sorting.expressions = this._tempSortingExpr;
                        this._rebind();
                    } else {
                        this._setSortingTempExpr(key, 'asc', layout);
                    }
                }
                this._setDialogButtonAscDesc(!isAsc, key);
            }
        },
        _setDialogButtonAscDesc: function (isAsc, key) {
            var css = this.css,
				$buttonAscDesc = $('#' + this.grid.id() + "_" + key + "_groupbydialog_groupedcolumns_buttonascdesc"),
				$spanIcon = $buttonAscDesc.find('span:eq(0)'),
				caption;
            if (isAsc === true) {
                $buttonAscDesc
					.removeClass(css.dialogButtonDesc)
					.addClass(css.dialogButtonAsc);
                $spanIcon
					.removeClass(css.dialogButtonDescIcon)
					.addClass(css.dialogButtonAscIcon);
                caption = this.options.modalDialogCaptionButtonAsc;
            } else {
                $buttonAscDesc
					.removeClass(css.dialogButtonAsc)
					.addClass(css.dialogButtonDesc);
                $spanIcon
					.removeClass(css.dialogButtonAscIcon)
					.addClass(css.dialogButtonDescIcon);
                caption = this.options.modalDialogCaptionButtonDesc;
            }
            // M.H. 13 March 2012 Fix for bug #104509
            $buttonAscDesc.data('isAsc', isAsc).attr('title', caption);
        },
        _renderDialogButtonClearAll: function () {
            // M.H. 8 March 2012 Fix for bug #103407
            if (this.options.modalDialogGroupByOnClick === true) {
                return;
            }
            var self = this,
				o = this.options,
				resetButtonId = self.grid.id() + '_groupbydialog_reset_button',
				modalDialog = $('#' + this.grid.id() + '_groupby_modalDialog'),
				$captionButtonContainer,
				$resetButton;
            if ($('#' + resetButtonId).length === 0) {
                $captionButtonContainer = modalDialog.igGridModalDialog('getCaptionButtonContainer');
                $resetButton = $('<button></button>')
					.attr('id', resetButtonId)
					.appendTo($captionButtonContainer);
                $resetButton.igButton({
                    labelText: o.modalDialogClearAllButtonLabel,
                    click: function (e) {
                        var noCancel, $groupedUL, $ungroupedUL, layouts = [];
                        noCancel = self._trigger(self.events.modalDialogButtonResetClick, e, { modalDialogElement: modalDialog, owner: self });
                        if (noCancel) {
                            self._clearAllGroupedColumns();
                            // M.H. 12 March 2012 Fix for bug #104507
                            self._tempSortingExpr = self.grid.dataSource.settings.sorting.expressions.slice(0);
                            $groupedUL = $('#' + self.grid.id() + "_groupby_modalDialog_groupedcolumns ul");
                            $ungroupedUL = $('#' + self.grid.id() + "_groupby_modalDialog_ungroupedcolumns ul");
                            $groupedUL.empty();
                            $ungroupedUL.empty();
							// M.H. 22 March 2012 Fix for bug #105360
							self._tempSortingExpr = [];
							// M.H. 23 March 2012 Fix for bug #105946
							self._tempOrderedGroupedCols = [];

                            if (!self._currentTreeLayer) {
                                self._renderColumnsDialog(self.grid.options.columns);
                            } else {
                                self._findLayout(self._currentTreeLayer, self._tempOptions, layouts);
                                if (layouts.length > 0) {
                                    self._renderColumnsDialog(layouts[0].columns, self._currentTreeLayer);
                                }
                            }
                            $(this).remove();
                        }
                    }
                });
            }
        },
        _renderDialogUngroupedColumn: function (column, layout) {
            var self = this, $li, $a,
				key = column.key,
				o = this.options,
				css = this.css,
				$ul = $('#' + this.grid.id() + "_groupby_modalDialog_ungroupedcolumns ul");
            $li = $('<li></li>')
				.attr('id', self.grid.id() + '_' + key + '_groupbydialog_grouped_li')
				.addClass(css.dialogUngroupedItem)
				.append('<span class="' + css.dialogUngroupedColumnsGroupByButton + '"><a href="#"></a></span> <span class="' + css.dialogUngroupedColumnsText + '">' + column.headerText + '</span>');
            //this._insertColumnModalDialog($ul, $li, columnSetting.columnIndex);
            $li.appendTo($ul);
            $a = $li.find('a:first');
            $a.addClass(css.modalDialogSortByColumn);
            $a.html(o.modalDialogGroupByButtonText);
            $li.bind({
                click: function (e, args) {
                    var noCancel;
                    // M.H. 15 March 2012 Fix for bug #104449
                    noCancel = self._trigger(self.events.modalDialogGroupingColumn, e, { key: key, layout: layout, owner: self });
                    if (noCancel) {
                        $li.remove();
                        if (o.modalDialogGroupByOnClick) {
                            self.groupByColumn(key, layout);
                        } else {
                            // M.H. 11 Mar 2014 Fix for bug #162907: GroupBy does not have option to set sort direction
                            self._setGroupByTempExpr(key, true, o.defaultSortingDirection, layout);
                        }
                        self._renderDialogButtonClearAll();
                        self._renderDialogGroupedColumn(column, layout);
                        self._renderDialogButtonClearAll();
                        // M.H. 15 March 2012 Fix for bug #104449
                        self._trigger(self.events.modalDialogGroupColumn, e, { key: key, layout: layout, owner: self, groupedColumns: self._tempGroupedColumns });
                    }
                    e.preventDefault();
                    e.stopPropagation();
                }
            });
        },
        _setGroupAreaTextContent: function ($area) {
            var text = this.options.emptyGroupByAreaContent, linkText = this.options.emptyGroupByAreaContentSelectColumns,
				linkTextCaption = this.options.emptyGroupByAreaContentSelectColumnsCaption, $a, self = this;

            //modalDialog.igGridModalDialog('openModalDialog');
            text = text.replace('{0}', '<a href="#" id="' + this.grid.id() + '_link_selectcolumns" title="' + linkTextCaption + '">' + linkText + '</a>');
            $area.html(text);
            $a = $('#' + this.grid.id() + '_link_selectcolumns');
            $a.bind({
                click: function (e, args) {
                    self.openGroupByDialog();
                    e.preventDefault();
                    e.stopPropagation();
                }
            });
        },
        _headerCellDragCancel: function (event, args) {
            // we should always cancel the "cancelling" of the draggability of headers, done by features such as sorting 
            return false;
        },
        _headerCellRendered: function (event, args) {
            var groupby = this, cs, hg, hgTemp, isMultiColumnHeaderGrid = this.grid._isMultiColumnGrid;
            if (args.owner.id() !== this.grid.id()) {
                return;
            }
			// M.H. 2 July 2012 Fix for bug #115940
			if (args.isMultiColumnHeader === true) {
				return;
			}
			// M.H. 11 June 2012 Fix for bug #114220
			hg = groupby.grid.element.hasClass('ui-iggrid-root') ? groupby.grid.container() : groupby.grid.element.closest('.ui-iggrid-root');
			if (hg.length === 0) {
				hg = groupby.grid.container();
			} else {
				hgTemp = hg.closest('.ui-widget');
				if (hgTemp.length > 0) {
					hg = hgTemp;
				}
			}
            // take all TH elements and attach draggable to them individually
            // take the column key and check if the column is allowed to participate in grouping
            cs = this._findColumnSetting(args.columnKey);
            args.th.find('.ui-iggrid-headertext').css('width', '100%');
            if ((cs && cs.allowGrouping) || !cs) {
                args.th.draggable({
                    containment: hg,
                    appendTo: hg,
                    distance: 5,
                    revert: "invalid",
					scroll: false,
                    // M.H. 12 Oct. 2011 Fix for bug #91090
                    cancel: 'div.ui-iggrid-indicatorcontainer',
                    helper: function (event) {
                        var th, helperDOM;
                        if ($(event.target).is("span")) {
                            groupby._spanDragging = true;
                        } else {
                            groupby._spanDragging = false;
                        }
                        th = $(event.target).closest("th");
						// M.H. 11 July 2012 Fix for bug #115984
						helperDOM = th.clone()
                        //A.Y. Bug 91597. Adding "overflow: hidden" so that hiding indicators
                        //are not visible when dragging a column header
							.css('overflow', 'hidden')
							.width(th.width())
							.addClass("ui-widget ui-iggrid")
							// M.H. 16 May 2012 Fix for bug #111507
							/* L.A. 31 July 2012 Fixing bug #115961
							When the grid has width bigger than the screen and when you drag a column that was outside the initially visible area 
							it appears smaller while you drag it to the drop area. */
							.wrap($('<div class="' + groupby.css.dragMarkup + '"/>').width(th.outerWidth()));
						if (isMultiColumnHeaderGrid) {
							helperDOM.height(th.height());
						}
						return helperDOM.parent();
                    },
                    opacity: groupby.options.labelDragHelperOpacity,
                    /*
                    cursorAt: {
                    bottom: -5,
                    top: 5,
                    },
                    */
                    drag: function (event, ui) {
						var groupbyarea;
                        groupby._isDragging = true;
                        groupbyarea = $('.ui-iggrid-groupbyarea', hg);
                        if (!groupbyarea.hasClass("ui-iggrid-groupbyareahover") && !groupby._movingEnabled) {
                            // change mouse cursor to red (stop)
                            if (groupby._spanDragging) {
                                ui.helper.find('span').css('cursor', 'no-drop');
                            } else {
                                ui.helper.css('cursor', 'no-drop');
                            }
                        } else {
                            if (groupby._spanDragging) {
                                ui.helper.find('span').css('cursor', 'move');
                            } else {
                                ui.helper.css('cursor', 'move');
                            }
                        }
                    },
                    stop: function (event, ui) {
                        groupby._isDragging = false;
                    }
                }).bind({
                    mouseover: groupby._headerMouseOverHandler,
                    mouseout: groupby._headerMouseOutHandler
                });
                // if this is a child grid TH that we are dropping, we also need to encode
                // the layout key as a data-* attribute 
                if (args.owner.element.attr("data-childgrid")) {
                    args.th.attr('data-layout', args.owner.options.key).attr('data-grid-id', args.owner.element.attr('id'));
                }
            }
        },
        _findColumnSetting: function (key) {
            var i;
            for (i = 0; i < this.options.columnSettings.length; i++) {
                if (this.options.columnSettings[i].columnKey === key) {
                    return this.options.columnSettings[i];
                }
            }
        },
        /* V1 - decorating on existing markup
        _dataRendered: function () {
		
        start = new Date().getTime();
        var grid = this.grid, groupby = this, count = 0, tmpCount = 0, tmpSum = 0, registeredTd,
        idval = null, indent = this.options.indentation, gc = this.options.groupedColumns,
        grow, expcell, textcell;
        //TODO
        //if (gc.length > 0) {
        registeredTd = false;
        for (i = 0; i < gc.length; i++) {
        tmpCount = 0;
        // we need to insert group by rows and indentation cells based on the group #
        // iterate through all rendered TRs
        if (!grid.headersTable().find('thead tr th').hasClass("ui-iggrid-expandheadercell")) {
        $('<th></th>').prependTo(grid.headersTable().find('thead tr')).addClass("ui-iggrid-expandheadercell ui-iggrid-header ui-widget-header"); //TODO
        $("<col></col>").prependTo(grid.headersTable().find("colgroup")).width(indent);
        } else if (indent > this.options.indentation) {
        grid.headersTable().find("colgroup col:nth-child(1)").width(indent);
        }
        rows = grid.rows();
        //this._tbody.children().map(function (index, element) {
        for (j = 0; j < rows.length; j++) {
        //var grow, expcell, textcell;
					
        // if it's already a grouped row, return
        if ($(rows[j]).attr('data-grouprow')) {
        //return;
        continue;
        }
        if (j < tmpCount || tmpCount >= grid.dataSource.dataView().length) {
        //return;
        continue;
        }
        if (grid.dataSource.dataView()[tmpCount][gc[i].fieldName] !== idval) {
        idval = grid.dataSource.dataView()[tmpCount][gc[i].fieldName];
        // render new group row 
        //grow = $('<tr></tr>').insertBefore(rows[j]).addClass(grid.css.recordClass)
        //	.attr('data-grouprow', true).attr('data-state', 'expanded').attr('data-glevel', i);
        rows[j].parentNode.insertBefore($("<tr></tr>").addClass(grid.css.recordClass)
        .attr('data-grouprow', true).attr('data-state', 'expanded').attr('data-glevel', i)[0], rows[j]);
        grow = rows[j].previousSibling;
        expcell = $('<td class="ui-iggrid-expandcolumn"><span class="ui-iggrid-expandbutton ui-icon ui-icon-minus ui-iggrid-groupexpandcell"></span></td>').appendTo(grow);
        // set the margin left
        if (i > 0) {
        expcell.children().first().css("margin-left", parseInt(groupby.options.indentation, 10) * i);
        }
        textcell = $('<td></td>').appendTo(grow).attr('colspan', grid.options.columns.length);
        //tmpCount = count;
        while (tmpCount < grid.dataSource.dataView().length &&
        grid.dataSource.dataView()[tmpCount][gc[i].fieldName] === idval) {
        tmpCount++;
        tmpSum++;
        // add an extra TD for every tr
        //if (!registeredTd) {
        //	$('<td></td>').prependTo(this).addClass("ui-iggrid-nongrouprowemptycell");
        //}
        }
        textcell.text(grid.columnByKey(gc[i].fieldName).headerText + ': ' + idval + ' (' + tmpSum + ')');
        //tmpCount = 0;
        tmpSum = 0;
        //tmpCount = 0;
        } //else {
        //if (!registeredTd) {
        //	$('<td></td>').prependTo(this).addClass("ui-iggrid-nongrouprowemptycell");
        //}
        //}
        // indentation
        //$('<td></td>').prependTo(this);
        //count++;
        //});
        }
        // add extra TDs for every non-grouped row
        if (!registeredTd) {
        //this._tbody.children().map(function () {
        rows = grid.rows();
        for (j = 0; j < rows.length; j++) {
        if ($(rows[j]).attr('data-grouprow') !== "true") {
        //add extra td
        $('<td></td>').prependTo(rows[j]).addClass("ui-iggrid-nongrouprowemptycell");
        }
        //});
        }
        }
        indent += indent;
        registeredTd = true;
        }
        // finally show the data
        this._tbody.show();
        },
        */
        // intercepting renderRecords directly
        _renderRecords: function (ui, args) {
            if (args.owner.id() !== this.grid.id()) {
                return;
            }
            if (this._getTotalRowCountHandler) {
                this.grid._getTotalRowCount = this._getTotalRowCountHandler;
                this._getTotalRowCountHandler = null;
            }
            if (this.options.groupedColumns.length > 0) {
                // we are going to render the rows ourselves
                this._renderRecordsInternal();
            } else {
                return true;
            }
            return false;
        },
        _recordsRendered: function (ui, args) {
			var currentScrollTop = $(window).scrollTop();
            if (!args.tbody.is(':visible')) {
                args.tbody.css('display', '');
            }
			if (this._scrolltop !== 0 && currentScrollTop !== 0 && this._scrolltop !== currentScrollTop) {
				$(window).scrollTop(this._scrolltop); // restore the scrolltop 
			}
        },
        _renderRecordsInternal: function () {
            // iterate all records in the data source instead of rendered table rows
            // IMPORTANT: the initial value of idval is really important ! 
            var grid = this.grid, idval = null, ds = grid.dataSource.dataView(), firstTime = true, counter,
				d = [], tbody = grid.element.children("tbody"), fh = false, html, i, tbodyHtml, $thDataSkip,
                gr, groupedRowsLength, tr, countHiddenRows;

            this._indent = this.options.indentation;
            if (this.grid.options.fixedHeaders === true) {
                fh = true;
            }
            // S.S. January 21st, 2012 Bug #98209 Colspan calculation should be done on a colgroup level 
            // because when showHeader is false for the grid there is no header row to calculate against
            // L.A. 27 March 2012 Fixed bug #106069, 104826, 98209.
            // I've combined the previous two fixes into one conditional
			if (this.grid._isMultiColumnGrid) {
				this._colspan = this.grid.container().find("#" + this.grid.id() + " colgroup:first>col").length - 1;
			} else {
				if (this.grid.options.showHeader) {
					this._colspan = this.grid.container().find("#" + this.grid.id() + (fh === true ? "_headers" : "") + " thead>tr:first")
						.children("th:not(.ui-iggrid-expandheadercellgb)").length;
				} else {
					this._colspan = this.grid.container().find("#" + this.grid.id() + " colgroup:first>col").length - 1;
				}
			}
            //this._colspan = $("#" + this.grid.id() + (fh === true ? "_headers" : "") + " thead>tr:first")
            //	.children("th:not(.ui-iggrid-expandheadercellgb)").length;
            this._processGroupsRecursive(0, ds, tbody, d, idval, 0, ds.length, firstTime);
            // we need to insert group by rows and indentation cells based on the group #
            // iterate through all rendered TRs
            if (!grid.headersTable().find('thead tr th').hasClass("ui-iggrid-expandheadercellgb")) {
				$thDataSkip = $('<th></th>').prependTo(grid.headersTable().find('thead tr:nth-child(1)'))
					.addClass(this.css.expandHeaderCellGroupBy).addClass(this.css.headerExtraCell).attr('data-skip', true);
				if (grid._isMultiColumnGrid) {
					$thDataSkip.attr('rowspan', grid._maxLevel + 1);
				}
                if (grid.headersTable().attr('id') !== grid.element.attr('id')) {
                    // M.H. 14 May 2013 Fix for bug 142258: Grouping column cause the last column to disappear and a wider expand button container in jquery 2.0.0
                    $("<col />").prependTo(grid.headersTable().find("colgroup")).attr('data-skip', 'true').width(this._indent);
                }

                // M.H. 11 Oct. 2011 Fix for bug #90801 - add col in colgroup for footers table
                if (grid.footersTable().attr('id') !== grid.element.attr('id')) {
                    // M.H. 14 May 2013 Fix for bug 142258: Grouping column cause the last column to disappear and a wider expand button container in jquery 2.0.0
                    $("<col />").prependTo(grid.footersTable().find("colgroup")).attr('data-skip', 'true').width(this._indent);
                }

            } else {
                // change the colgroup width
                grid.headersTable().find("colgroup col:nth-child(1)").width(this._indent);
                // M.H. 11 Oct. 2011 Fix for bug #90815
                grid.footersTable().find("colgroup col:nth-child(1)").width(this._indent);
            }
            tbody.show();

            html = d.join("");

            if (grid.options.virtualization === true) {
                this.grid._scrollTo(0, true);
                this._groupedRows = this._tokenizeTBody(html);

                if (this._groupedRows.length > 0) {
                    this._groupedRows[0] = this._groupedRows[0].substr(0, 3) + ' data-firstgrouprow="true" ' + this._groupedRows[0].substr(3);
                    this._groupedRows[this._groupedRows.length - 1] = this._groupedRows[this._groupedRows.length - 1].substr(0, 3) + ' data-lastrow="true" ' + this._groupedRows[this._groupedRows.length - 1].substr(3);
                    for (i = this._groupedRows.length - 1; i >= 0; i--) {
                        if (this._groupedRows[i].indexOf('data-grouprow="true"') >= 0) {
                            this._groupedRows[i] = this._groupedRows[i].substr(0, 3) + ' data-lastgrouprow="true" ' + this._groupedRows[i].substr(3);
                            break;
                        }
                    }
                    this._virtualRowCount = this._determineVirtualRowCount(this._groupedRows, grid._getDisplayContainerHeight());
                    if (this._virtualRowCount > this._groupedRows.length) {
                        this._virtualRowCount = this._groupedRows.length;
                    }
                    tbodyHtml = '';
                    // M.H. 29 Aug 2013 Fix for bug #149879: When using grouping and continuous virtualization the page hangs on scroll.
                    // When initialExpand is false. We render only grouping rows and cache the other rows. We show them when expanding grouping rows
                    if (!this.options.initialExpand) {
                        // override _getTotalRowCount function
                        if (!this._getTotalRowCountHandler) {
                            this._getTotalRowCountHandler = $.proxy(grid._getTotalRowCount, grid);
                            grid._getTotalRowCount = $.proxy(this._getTotalRowCount, this);
                        }
                        this._countGroupedRows = html.match(/(data-grouprow="true")/ig).length;
                        
                        this._cachedGroupedRows = this._groupedRows;
                        gr = [];
                        this._groups = {};
                        counter = 0;
                        groupedRowsLength = this._groupedRows.length;
                        countHiddenRows = 0;
                        for (i = 0; i < groupedRowsLength; i++) {
                            tr = this._groupedRows[i];
                            if (tr.indexOf('data-grouprow') > -1) {// .match(/<tr.*style="display: none.*>/)
                                counter++;
                                countHiddenRows = 0;
                                //tr = tr.substr(0, 3) + ' data-row-vidx="' + (counter - 1) + '" ' + tr.substr(3);
                                tr = tr.replace(/data-row-idx="(\d)+"/i, 'data-row-idx="' + (counter - 1) + '"');
                                gr.push(tr);
                            } else {
                                if (++countHiddenRows > this._virtualRowCount) {
                                    continue;
                                }
                                if (!this._groups[counter - 1]) {
                                    this._groups[counter - 1] = [];
                                }
                                this._groups[counter - 1].push(tr);
                            }
                        }
                        this._groupedRows = gr;
                        gr = null;
                        if (this._virtualRowCount > this._groupedRows.length) {
                            this._virtualRowCount = this._groupedRows.length;
                        }
                        for (i = 0; i < this._virtualRowCount; i++) {
                            tbodyHtml += this._groupedRows[i];
                        }
                    } else {
                        for (i = 0; i < this._virtualRowCount; i++) {
                            tbodyHtml += this._groupedRows[i];
                        }
                    }
					// K.D. September 4th, 2012 Bug #119685 Checking if MSApp is defined to recognize whether the control is running
					// in a WinJS environment
					if (window.MSApp === undefined) {
						tbody.html(tbodyHtml);
					} else {
						MSApp.execUnsafeLocalFunction(function () {
							tbody.html(tbodyHtml);
						});
					}

                    //I.I bug fix for 102462
                    this.grid._buildVirtualDomForContinuousVirtualization();
                }
            } else {
				// K.D. September 4th, 2012 Bug #119685 Checking if MSApp is defined to recognize whether the control is running
				// in a WinJS environment
				if (window.MSApp === undefined) {
					tbody.html(html);
				} else {
					MSApp.execUnsafeLocalFunction(function () {
						tbody.html(html);
					});
				}

                //A.Y. when the grid has no width the container width should be recalculated
                //to account for the extra cell that is added for the group by
                if (this.grid.options.width === null) {
                    this.grid._setContainerWidth(this.grid.container());
                } else {
                    this.grid._updateGridContentWidth();
                }
            }

            this._avgRowHeight = this.grid._calculateAvgRowHeight();
			// S.S. Bug #107178 After rendering all rows GroupBy should throw rowsRendered event 
			// for the grid so other features can do rendering-specific actions
			this.grid._trigger(this.grid.events.rowsRendered, null, {owner: this.grid, tbody: tbody});
        },
        _getTotalRowCount: function () {
            if (this.options.groupedColumns.length > 0) {
                return this._countGroupedRows;
            }
            return this._getTotalRowCountHandler();
        },
        _processGroupsRecursive: function (i, ds, tbody, d, idval, start, end, firstTime) {
            var index, tmpSum = 0, j, tmpCount = start, tmpStart = start, k, arr, arrLength, cssClass,
				gcval = this.options.groupedColumns[i].key, cs;
            if (ds.length === 0) {
                return;
            }
            idval = ds[tmpCount][gcval];
            cs = this._settingFromKey(gcval);
            firstTime = true;
            // M.H. 25 Sep 2013 Fix for bug #153365: GroupBy option "indentation" does not work with percentages
            if (!(this.options.indentation && this.options.indentation.indexOf &&
                    this.options.indentation.indexOf('%') !== -1)) {
                this._indent = parseInt(this.options.indentation, 10) * (i + 1);
            }
            for (j = start; j < end; j++) {
                if (j < tmpCount || tmpCount >= end) {
                    continue;
                }
                // check if we don't have a custom group function defined for gcval
                if (!this._cmp(cs, ds[tmpCount][gcval], idval) || firstTime) {
                    firstTime = false;
                    idval = ds[tmpCount][gcval];
                    if (cs.customGroupName) {
						index = this._renderGroupRow(d, i, gcval, idval, cs.customGroupName, cs, ds[tmpCount]);
                    } else {
						index = this._renderGroupRow(d, i, gcval, idval, null, cs, ds[tmpCount]);
                    }
                    tmpStart = tmpCount;
                    if (this.options.groupedColumns.length - 1 > i) {
                        while (tmpCount < end && this._cmp(cs, ds[tmpCount][gcval], idval)) {
                            tmpCount++;
                            tmpSum++;
                        }
                        // check if we don't have the value in the data source
                        this._rs(gcval, idval, index, tmpSum, tmpStart, tmpCount, ds, d);
                        tmpSum = 0;
                        this._processGroupsRecursive(i + 1, ds, tbody, d, idval, j, tmpCount, firstTime);
                    } else {
						arr = [];
                        // check if we don't have a custom group function defined for gcval
                        while (tmpCount < end && this._cmp(cs, ds[tmpCount][gcval], idval)) {
                            tmpCount++;
                            tmpSum++;
                            // render normal row
                            // make sure we are limiting the rendering to what's in the dataView, as this may have
                            // local client-side paging and filtering applied, even though the actual calculations will need to be done
                            // on the whole local data
                            //if (tmpCount < dvmax) {
                            this._renderRecord(d, tbody, ds[tmpCount - 1], tmpCount - 1, this.options.initialExpand, arr);
                            //}
                        }
						// M.H. 15 May 2012 Fix for bug #103502 - set for the last cell in group by rows specific class
						arrLength = arr.length;
						for (k = 0; k < arrLength; k++) {
							cssClass = this.css.nonGroupRowEmptyCell;
							if (k === arrLength - 1) {
								cssClass += ' ' + this.css.groupByLastEmptyCell;
							}
							d[arr[k]] += '<td class="' + cssClass + '" data-skip="true"></td>';
						}
                        this._rs(gcval, idval, index, tmpSum, tmpStart, tmpCount, ds, d);
                        tmpSum = 0;
                    }
                }
            }
        },
        _rs: function (gcval, idval, index, tmpSum, tmpStart, tmpCount, ds, d) {
            var subdata;
            tmpSum = this._calcRealSum(gcval, idval, tmpSum, ds);
            d[index] = d[index].replace('__sum__', tmpSum);
            if (d[index].indexOf('$$value$$') !== -1) {
                subdata = ds.slice(tmpStart, tmpCount);
                d[index] = this._calcRealSummary(d[index], gcval, idval, subdata);
            }
        },
        _cmp: function (cs, val1, val2) {
            var res, o = this.grid.options, enableUTCDates = o.enableUTCDates, rowTemplate = (!o.rowTemplate || o.rowTemplate.length <= 0), format, key, col;
            if (cs.groupComparerFunction) {
                if (typeof (cs.groupComparerFunction) === "function") {
                    res = cs.groupComparerFunction(cs, val1, val2);
                } else {
                    res = window[cs.groupComparerFunction](cs, val1, val2);
                }
				return res;
            }
            // L.A. 04 June 2012 New feature #112933 Default grouping for date columns
			if ($.type(val1) === "date" && $.type(val2) === "date") {
                key = cs.columnKey;
                if (key !== undefined && key !== null) {
                    col = this.grid.columnByKey(key);
                    if (col !== undefined && col !== null) {
                        format = col.format;
                    }
                }
                return $.ig.formatter(val1, "date", format, rowTemplate, enableUTCDates) === $.ig.formatter(val2, "date", format, rowTemplate, enableUTCDates);
            }
			return val1 === val2;
        },
        _encodeSummaryParams: function (owner, params) {
            var cs = this.options.columnSettings, i, j, key;
            for (i = 0; i < cs.length; i++) {
                if (cs[i].summaries && cs[i].summaries.length > 0) {
                    for (j = 0; j < cs[i].summaries.length; j++) {
                        key = "gs(" + cs[i].columnKey + ")";
                        if (params.extraParams[key]) {
                            params.extraParams[key] = params.extraParams[key] + "," + cs[i].summaries[j].summaryFunction;
                        } else {
                            params.extraParams[key] = cs[i].summaries[j].summaryFunction;
                        }
                    }
                }
            }
        },
        _calcRealSummary: function (contents, gcval, idval, subdata) {
            var n, k, i, cs, j, mdata = this.grid.dataSource.metadata(this.options.resultResponseKey),
				o, str = contents, val, found = false, mul = 1, t, k_val;
            n = this.grid.dataSource.data();
            // scenario 1. check if summaries aren't coming from the server
            if (mdata && mdata !== null) {
                cs = this.options.columnSettings;
                for (i = 0; i < cs.length; i++) {
                    for (j = 0; j < cs[i].summaries.length; j++) {
                        // get the summary from the metadata
                        o = mdata[cs[i].columnKey + "_" + cs[i].summaries[j].summaryFunction];
                        // find the object whose key is equal to idval
                        for (k in o) {
                            if (o.hasOwnProperty(k)) {
                                // we need to convert the metadata value based on the column's type
                                // bool and number are the ones that are tricky. 
                                t = this.grid.columnByKey(gcval).dataType;
                                if (t === "bool" && $.type(k) === "string") {
                                    k_val = k.toLowerCase() === "true" ? true : false;
                                } else if (t === "number" && $.type(k) === "string") {
                                    k_val = mul * k;
                                } else {
                                    k_val = k;
                                }
                                if ((idval !== null && !idval.length && (idval === k_val * mul)) || k_val === idval) {
                                    val = o[k];
                                    val = $.ig.formatter(val, "number", this.options.summarySettings.summaryFormat);
                                    // ensure that we support mixed summaries - both remote (coming in metadata from the server), as well as local
                                    //str = str.replace(cs[i].columnKey + cs[i].summaries[j].summaryFunction + "$$value$$", val);
                                    // custom summaries may only exist and be calculated on the client
                                    if (cs[i].summaries[j].customSummary === undefined || cs[i].summaries[j].customSummary === null) {
                                        //found = true;
                                        str = str.replace(cs[i].columnKey + cs[i].summaries[j].summaryFunction + "$$value$$", val);
                                    }
                                }
                            }
                        }
                    }
                }
                // ensure that we support mixed summaries - both remote (coming in metadata from the server), as well as local
                //if (found) {
                //    return str;
                //}
            }
            if (!found || (this.grid.dataSource.dataView().length < n.length)) {
                /*
                setting = this._settingFromKey(gcval);
                for (k = 0; k < n.length; k++) {
                //if (n[k][gcval] === idval) {
                if (this._cmp(setting, n[k][gcval], idval)) {
                startIndex = k;
                break;
                }
                }
                for (k = startIndex; k < n.length; k++) {
                if (!this._cmp(setting, n[k][gcval], idval)) {
                break;
                }
                }
                */
                //subdata = n.slice(startIndex, k);
                // we still need to call this, cause there may be local summaries to consider. the difference to the previous implementation
                // is that we have already replaced th ones calculated on the server, so this is safe. 
                return this._summaries(str, subdata, gcval);
            }
        },
        // used when there is local or remote paging/filtering. We need to know the real values not the ones that are on the client
        _calcRealSum: function (gcval, idval, sum, ds) {
            var tmpSum = 0, k, n, nLen, setting, mul = 1, idx, metadata, t, n_val;
            setting = this._settingFromKey(gcval);
            metadata = this.grid.dataSource.metadata(this.options.resultResponseKey);
            // check if we don't have the value in the data source
            if (metadata && metadata[gcval]) {
                k = metadata[gcval];
                for (n in k) {
                    if (k.hasOwnProperty(n)) {
                        // we need to convert the metadata value based on the column's type
                        // bool and number are the ones that are tricky. 
                        t = this.grid.columnByKey(gcval).dataType;
                        if (t === "bool" && $.type(n) === "string") {
                            n_val = n.toLowerCase() === "true" ? true : false;
                        } else if (t === "number" && $.type(n) === "string") {
                            n_val = mul * n;
                        } else {
                            n_val = n;
                        }
                        if (idval !== null && idval !== undefined && !idval.length && (idval === n_val * mul)) {
                            tmpSum = k[n];
                        } else if (n_val === idval) {
                            tmpSum = k[n];
                        }
                    }
                }
            } else if (ds.length < this.grid.dataSource.data().length) {
                // we have local paging or filtering, but still all info is present in the data source
                // find the unique values count, assuming the data source is already sorted
                tmpSum = 0;
                // M.H. 14 Oct 2013 Fix for bug #154649: Rows are grouped incorrectly when applying and removing a filter if a filter is applied by default through code
                // if filtering is applied the groupby aggregate function is not properly calculated because it is taken from the dataSource not from the filtered data
                if (this.grid.dataSource._filter && this.grid.dataSource._filteredData &&
                    this.options.type === "local") {
                    n = this.grid.dataSource._filteredData;
                } else {
                    n = this.grid.dataSource.data();
                }
                nLen = n.length;
                for (k = 0; k < nLen; k++) {
                    //if (n[k][gcval] === idval) {
                    if (this._cmp(setting, n[k][gcval], idval)) {
                        idx = k;
                        break;
                    }
                }
                for (k = idx; k < nLen; k++) {
                    if (this._cmp(setting, n[k][gcval], idval)) {
                        tmpSum++;
                    } else {
                        break;
                    }
                }
            }
            return tmpSum > 0 ? tmpSum : sum;
        },
        _settingFromKey: function (key) {
            var cs, j;
            for (j = 0; j < this.options.columnSettings.length; j++) {
                if (this.options.columnSettings[j].columnKey === key) {
                    cs = this.options.columnSettings[j];
                }
            }
            return cs;
        },
        _renderGroupRow: function (arr, indent, field, val, customName, colCustomSetting, record) {
            var expcell, textcell, col, margin = indent > 0 ? parseInt(this.options.indentation, 10) * indent : 0,
				text, state, css, i, cs = this.options.columnSettings, shtml = "", tmpl, title, j, hide = false;
            if (this.options.initialExpand) {
                css = this.css.groupByExpandCellExpanded;
                title = this.options.collapseTooltip;
            } else {
                css = this.css.groupByExpandCellCollapsed;
                title = this.options.expandTooltip;
                if (indent > 0) {
                    hide = true;
                }
            }
            if (this.options.expansionIndicatorVisibility) {
                //L.A. 04 May 2012 - Fixing bug #Bug 107316 - The icon in the expander cell is misaligned to the left side of the cell
                expcell = '<td class="' + this.css.groupByExpandColumn + '" gbexpandcell="1"><span class="ui-iggrid-expandbuttoncontainer-group-by" style="margin-left:' +
					margin + 'px;"><span class="' + css + '" title="' + title + '"></span></span></td>';
            } else {
                expcell = '<td class="' + this.css.groupByExpandColumn + '" gbexpandcell="1"></td>';
            }
            //text = this.grid.columnByKey(field).headerText + ': ' + val + ' (__sum__)';
            // default template:  "${key}: ${val} (${count})"
            tmpl = this.options.groupedRowTextTemplate;
			// M.H. 15 May 2012 Fix for bug #111450
			col = this.grid.columnByKey(field);
			if (colCustomSetting && colCustomSetting.groupLabelFormatter) {
				if (typeof (colCustomSetting.groupLabelFormatter) === "function") {
					val = colCustomSetting.groupLabelFormatter(val);
				} else {
					val = window[colCustomSetting.groupLabelFormatter](val);
				}
			} else if (this.options.useGridColumnFormatter === true) {
				// L.A. 17 October 2012 - Fixing bug #123215 The group rows of a grouped checkbox column are too large
				val = this.grid._renderCell(val, col, record, ' ');
			}
            tmpl = tmpl.replace("${key}", col.headerText);
            if (customName) {
                text = tmpl.replace("${val}", customName).replace("${count}", "__sum__");
            } else {
                text = tmpl.replace("${val}", val).replace("${count}", "__sum__");
            }
            if (this.options.initialExpand) {
                state = "expanded";
            } else {
                state = "collapsed";
            }
            // we need to check if there are summaries, and if renderSummariesInGroupRow = true
            //if (this.options.summarySettings.renderSummariesInGroupRow) {
            // create a template for the summaries
            for (i = 0; i < cs.length; i++) {
                //if (cs[i].columnKey === field) {
                for (j = 0; j < cs[i].summaries.length; j++) {
                    shtml += " " + cs[i].columnKey + " " +
						(cs[i].summaries[j].text || cs[i].summaries[j].summaryFunction) + " " +
						cs[i].columnKey + cs[i].summaries[j].summaryFunction + "$$value$$";
                    if (j !== cs[i].summaries.length - 1) {
                        shtml += this.options.summarySettings.multiSummaryDelimiter;
                    }
                }
                //}
            }
            text += shtml;
            //} 
            /*else {
            for (i = 0; i < cs.length; i++) {
            for (j = 0; j < cs[i].summaries.length; j++) {
            //TODO: implement summaries in a separate row (above or below)
            }
            }
            }
            */
            textcell = '<td colspan="' + this._colspan + '">' + text + '</td>';
            arr.push('<tr class="' + this.grid.css.recordClass + " " + this.css.groupedRow + '" data-grouprow="true" data-state="' +
				state + '" data-glevel="' + indent + '"' + (hide ? ' style="display:none;"' : '') + '>' + expcell + textcell + '</tr>');
            return arr.length - 1;
        },
        _renderRecord: function (d, tbody, data, rowIndex, expand, arr) {
			var i, j, dLen, lastIndex = d.length;
			//if (this.grid.options.jQueryTemplating === false) {
			// K.D. April 17th, 2012 Bug #109497 Template and non-template rendering is now branched in _renderRecordsInArray
			this.grid._renderRecordInArray(d, tbody, data, rowIndex);
            dLen = d.length;
			// take the last string from d, and add a TD in front of it (empty cell)
			//if (!registeredTd) {
			for (i = lastIndex; i < dLen; i++) {
			    if (d[i].indexOf && d[i].indexOf('<tr') !== -1) {
				    // initial expand or collapse
				    if (!expand) {
					    d[i] = d[i] + ' style="display: none;"';
				    }
				    for (j = i; j < dLen; j++) {
					    if (d[j].indexOf && d[j].indexOf('data-grouprow') !== -1) {
						    break;
					    }
                        if (d[j].indexOf && d[j].indexOf('>') !== -1) {
						    // M.H. 15 May 2012 Fix for bug #103502
						    arr.push(j);
						    //d[j] += '<td class="' + this.css.nonGroupRowEmptyCell + '" data-skip="true">1</td>';
						    break;
					    }
				    }
				    break;
                }
			}
			//}
			// } else {
			// tmpl = this.grid._generateRowTemplate();
			// if (this.grid.options.alternateRowStyles) {
			// data.ig_zebraStyle = rowIndex;
			// }
			// rec = $($.ig.tmpl(tmpl, data, this.grid._buildFormatters()));
			// $('<td class="' + this.css.nonGroupRowEmptyCell + '" data-skip="true"></td>').prependTo(rec);
			// d.push($('<div>').append(rec).html());
			// }
		},
		_renderNewRow: function (rec, key) {
			var tbody = this.grid.element.children("tbody"),
				dataRows = tbody.children("tr:not([data-container='true'],[data-grouprow='true'])"),
				index = dataRows.length,
				row,
				ind,
				i;
			row = $(this.grid._renderRecord(rec, index));
			ind = dataRows.last().find("td." + this.css.nonGroupRowEmptyCell).removeClass(this.css.groupByLastEmptyCell).length;
			for (i = 0; i < ind; i++) {
				$("<td></td>")
					.addClass(this.css.nonGroupRowEmptyCell)
					.addClass(this.css.groupByLastEmptyCell)
					.attr("data-skip", true)
					.prependTo(row);
			}
			// K.D. October 8th, 2013 Bug #154311 Exception when adding new row into grouped table in WinJS
			MSApp.execUnsafeLocalFunction(function () {
				tbody.append(row);
			});
		},
        _summaries: function (contents, data, gcval) {
            var i, j, cs = this.options.columnSettings, s, ret = contents, arr, val;
            // check what summaries need to be applied
            // the format is: columnKey_summaryFunction$$value$$
            // nothing to calculate
            if (contents && contents.indexOf && contents.indexOf("$$value$$") === -1) {
                return contents;
            }
            for (i = 0; i < cs.length; i++) {
                //if (cs[i].columnKey === gcval) {
                s = cs[i].summaries;
                if (s.length > 0) {
                    arr = this._arr(cs[i].columnKey, data);
                    for (j = 0; j < s.length; j++) {
                        val = $.ig.calcSummaries(s[j].summaryFunction, arr, s[j].customSummary);
                        val = $.ig.formatter(val, "number", this.options.summarySettings.summaryFormat);
                        ret = ret.replace(cs[i].columnKey + s[j].summaryFunction + "$$value$$", val);
                    }
                }
                //}
            }
            return ret;
        },
        _arr: function (key, data) {
            var arr = [], i;
            for (i = 0; i < data.length; i++) {
                arr.push(data[i][key]);
            }
            return arr;
        },
        // dataEmpty follows dataRendering and is invoked when the tbody is emptied
        // this is necessary because jQuery automatically "shows" the elements that have been
        // emptied, which is not correct. 
        _dataEmpty: function (event, args) {
            var indent = 0, indentation = parseInt(this.options.indentation, 10), colGroup, headersColGroup;
            if (args.owner.id() !== this.grid.id()) {
                return;
            }
            if (this.options.groupedColumns.length > 0) {
                //args.tbody.hide();
				indent += indentation * this.options.groupedColumns.length;
                // M.H. 25 Sep 2013 Fix for bug #153365: GroupBy option "indentation" does not work with percentages
                if (this.options.indentation && this.options.indentation.indexOf &&
                        this.options.indentation.indexOf('%') >= 0) {
                    indent = this.options.indentation;
                }
                // L.A. 27 April 2012 Fixed bug #110760 When in child layout autoGenerateColumns is true and group by a column it is not possible to resize layout columns
                // _registeredCol flag is saved now directly in the element
                colGroup = args.owner.element.children("colgroup");
                // L.A. 01 June 2012 Fixed bug #113180 When you group by a column and then hide a column the grid becomes misaligned.
                headersColGroup = this.grid.headersTable().children("colgroup");
                if (colGroup.children('[data-registeredCol=true]').length === 0 && headersColGroup.children('[data-registeredCol=true]').length === 0) {
                    // M.H. 14 May 2013 Fix for bug 142258: Grouping column cause the last column to disappear and a wider expand button container in jquery 2.0.0
                    $("<col />").prependTo(colGroup)
                        .attr('data-skip', 'true')
                        .attr('data-registeredCol', 'true').width(indent);
                } else {
                    colGroup.children("col:nth-child(1)").width(indent);
                }
            }
            if (this._isgroup !== null && this._isgroup !== undefined && parseInt(this.grid.container().width(), 10) > 0 && !this.grid.options.width) {
                if (this._isgroup === true) {
					// M.H. 11 April 2012 Fix for bug #108399
					if (this.grid.options.virtualization !== true) {
						this.grid.container().width(parseInt(this.grid.container().width(), 10) + indentation);
					}
                    //} else if (this.options.groupedColumns.length > 0) {
                } else {
                    this.grid.container().width(parseInt(this.grid.container().width(), 10) - indentation);
                    indentation *= -1;
                }

                //I.I. bug fix for 107222
                if (this.grid.options.virtualization === true && this.grid.options.virtualizationMode === 'continuous') {
					this.grid._setDisplayContainerWidth(this.grid._getDisplayContainerWidth() + indentation);
                    this.grid._setVHeadersWidth(this.grid._getVHeadersWidth() + indentation);
                }

                this._isgroup = null;
            }
            this._tbody = args.tbody;
            if (!this._isgroup && this.groupByColumns().length > 0) {
                this._groupAreaList();
            }
            event.stopPropagation();
        },
        _checkGroupExists: function (key) {
            var exists = false, i;
            for (i = 0; i < this.options.groupedColumns.length; i++) {
                if (this.options.groupedColumns[i].key === key) {
                    exists = true;
                    break;
                }
            }
            return exists;
        },
        _groupBy: function (event, th) {
            // fire groupedColumnsChanging
            var noCancel, key, layout, cgrid, fc, exists = false;
            // check for the data-layout attribute
            layout = th.attr('data-layout');
            if (layout) {
                //I.I. bug fix for 108342
                // find the layout object. layouts must have unique keys
                cgrid = $('#' + th.attr('data-grid-id')).data('igGrid');
                key = cgrid.options.columns[th.data('columnIndex')].key;
            } else {
                // M.H. 13 Feb 2013 Fix for bug #131796
                if (th.data('columnIndex') === null || th.data('columnIndex') === undefined) {
                    return;
				}
				key = this.grid.options.columns[th.data('columnIndex')].key;
                cgrid = this.grid;
            }

            fc = this.grid.element.data('igGridFeatureChooser');
            if (fc !== undefined && fc !== null) {
                fc._setSelectedState('GroupBy', key, true, false);
            }

            // check if the groupedColumns collection doesn't already contain that entry
            if (!layout) {
                exists = this._checkGroupExists(key);
            }
            if (exists) {
                return;
            }
            noCancel = this._trigger(this.events.groupedColumnsChanging, event, {
                owner: this,
                groupedColumns: this.options.groupedColumns,
                key: key,
                layout: layout,
                grid: cgrid
            });
            if (noCancel) {
                this.groupByColumn(key, layout);
                // fire groupedColumnsChanged
                this._trigger(this.events.groupedColumnsChanged, event, {
                    owner: this,
                    groupedColumns: this.options.groupedColumns,
                    key: key,
                    layout: layout,
                    grid: cgrid
                });
            }
        },
        groupByColumns: function () {
            /* Adds a column to the group by columns list, executes the group by operation and updates the view.
            returnType="object" returns the currently grouped columns collection
            */
            //A.T. 12 March 2012 - fix for bug #101236
            var gc = [];
            if (this._hierarchical) {
                //this._allGroupedCols(gc);
				// we need to preserve the order in which columns were dragged
				//A.T. 21 March 2012 - bug #91992 - we want to preserve the original order of dragging to the groupby area or grouping programmatically
				gc = this._orderedGroupedCols;
            } else {
                gc = this.options.groupedColumns;
            }
            return gc;
        },
		//A.T. 28 March 2012 - fix for Bug #106918
		// ensure order is correct both within the hierarchy as well as the layouts themselves
		_ensureLabelsOrder: function (from, to, layout) {
			var i, key = layout ? layout.key : null;
			for (i = 0; i < from.length; i++) {
				if ((from[i].layout === key || (!from[i].layout && !key)) && !this._exists(to, from[i])) {
					to.push(from[i]);
				}
			}
			for (i = 0; layout.columnLayouts && i < layout.columnLayouts.length; i++) {
				this._ensureLabelsOrder(from, to, layout.columnLayouts[i]);
			}
		},
		_exists: function (arr, layout) {
			var i;
			for (i = 0; i < arr.length; i++) {
				if ((arr[i].layout === layout.layout || (!arr[i].layout && !layout.layout)) && arr[i].key === layout.key) {
					return true;
				}
			}
			return false;
		},
        _findLayout: function (layout, opts, layouts) {
            var i;
            if (opts.key === layout) {
                //return opts;
                layouts.push(opts);
            } else if (!layout) {
				layouts.push(this.grid.options);
			} else {
                for (i = 0; opts.columnLayouts && i < opts.columnLayouts.length; i++) {
                    this._findLayout(layout, opts.columnLayouts[i], layouts);
                }
            }
            //return opts;
        },
		_isGroupColumn: function (key, layout, gc) {
			// check in collection gc - grouped columns whether there is such column with the specified key and layout
			var i, gcLen = gc.length;
			for (i = 0; i < gcLen; i++) {
				if (gc[i].key === key && gc[i].layout === layout) {
					return true;
				}
			}
			return false;
		},
        _allGroupedCols: function (gc) {
			var i, j, key, layout, isToAdd;
            for (i = 0; i < this.options.groupedColumns.length; i++) {
				key = this.options.groupedColumns[i].key;
				layout = this.options.groupedColumns[i].layout;
				isToAdd = true;
				for (j = 0; j < gc.length; j++) {
					if (key === gc[j].key && layout === gc[j].layout) {
						this.options.groupedColumns[i] = gc[j];
						isToAdd = false;
						break;
					}
				}
				if (isToAdd) {
                gc.push(this.options.groupedColumns[i]);
            }
			}
            this._addGroupsRecursive(gc, this.grid.options.columnLayouts);
        },
        _addGroupsRecursive: function (gc, layouts) {
			var i, j, gb, col, k, persist;
            if (!layouts) {
                return;
            }
            for (i = 0; i < layouts.length; i++) {
                for (j = 0; layouts[i].features && j < layouts[i].features.length; j++) {
                    if (layouts[i].features[j].name === "GroupBy") {
                        gb = layouts[i].features[j];
                        break;
                    }
                }
                if (gb) {
					persist = (gb.persist || this.options.persist);
                    for (j = 0; gb.columnSettings && gb.columnSettings.length && j < gb.columnSettings.length; j++) {
                        if (gb.columnSettings[j].isGroupBy) {
							// M.H. 27 Feb 2014 Fix for bug #165349: Grouping a column in child layout with persitance enabled cause the grouping of the same column to be done twice
							// we should ensure that there isn't added the same grouped column(with the same key and layout) twice in gc collection
							if (persist && gb.columnSettings[j].columnKey) {
								if (this._isGroupColumn(gb.columnSettings[j].columnKey, layouts[i].key, gc)) {
									continue;
								}
							}
                            for (k = 0; k < layouts[i].columns.length; k++) {
                                if (layouts[i].columns[k].key === gb.columnSettings[j].columnKey || gb.columnSettings[j].columnIndex === k) {
                                    col = layouts[i].columns[k];
                                    break;
                                }
                            }
                            gc.push({
								key: gb.columnSettings[j].columnKey || col.key,
								layout: layouts[i].key,
								dir: gb.columnSettings[j].dir,
								col: col
							});
                        }
                    }
                }
                gb = null;
                this._addGroupsRecursive(gc, layouts[i].columnLayouts);
            }
        },
		_getColumnByLayoutKey: function (key, columns) {
			var c, i;

			if (this.grid._isMultiColumnGrid) {
				for (i = 0; i < columns.length; i++) {
					if (columns[i].key === key) {
						c = columns[i];
						break;
					}
					if (columns[i].group !== undefined && columns[i].group !== null) {
						c = this._getColumnByLayoutKey(key, columns[i].group);
						if (c !== undefined && c !== null) {
							break;
						}
					}
				}
			} else {
				for (i = 0; i < columns.length; i++) {
					if (columns[i].key === key) {
						c = columns[i];
						break;
					}
				}
			}
			return c;
		},
        groupByColumn: function (key, layout, sortingDirection) {
            /* Groups by a column
            paramType="string" optional="false" Column Key - group by the column with the specified key
            paramType="string" optional="true" layout is an optional parameter. if set it means the grouped column is not in the root level but is a child layout column
			paramType="asc|desc" optional="true" if not set it is taken from option defaultSortingDirection
            */
            // set sorting expressions for the key for the current grid's data source
            // then call dataBind()
            // check if we haven't already grouped by this col
        	var i, expr, gexpr, lobj, c, fcs, setting, layouts, exists = this._checkGroupExists(key), copy, dir = 'asc';
        	if (sortingDirection !== undefined && sortingDirection !== null) {
        		dir = sortingDirection;
        	} else if (this.options.defaultSortingDirection !== undefined) {
        		dir = this.options.defaultSortingDirection;
        	}
            // already grouped by that column
            if (!layout && exists) {
                return;
            }
            if (layout) {
                layouts = [];
                this._findLayout(layout, this.grid.options, layouts);
                lobj = layouts[0];

				c = this._getColumnByLayoutKey(key, lobj.columns);
            } else {
                lobj = this.grid.options;
                c = this.grid.columnByKey(key);
            }
            if (layout) {
                if (!lobj.features) {
                    lobj.features = [];
                    lobj.features.push({ name: "GroupBy", columnSettings: [] });
                    fcs = lobj.features[0].columnSettings;
                } else {
                    for (i = 0; i < lobj.features.length; i++) {
                        if (lobj.features[i].name === "GroupBy") {
                            fcs = lobj.features[i].columnSettings;
                            if (!fcs) {
                                lobj.features[i].columnSettings = [];
                                fcs = lobj.features[i].columnSettings;
                            }
                            break;
                        }
                    }
                }
                for (i = 0; i < fcs.length; i++) {
                    if (fcs[i].columnKey === key) {
                        if (fcs[i].isGroupBy) {
                            return;
                        }
                        setting = fcs[i];
                        break;
                    }
                }
                if (!setting) {
                    fcs.push({ columnKey: key, isGroupBy: true, dir: dir });
                } else {
                    setting.isGroupBy = true;
                }
            }
            // if the layout is defined we need to store that layout in the data source, and set the group expression to the layout's settings 
            // where it belongs to
            expr = { fieldName: key, dir: dir, layout: layout, isGroupBy: true };
            gexpr = { key: key, dir: dir, layout: layout, col: c };

            //if (layout) {
            //	//fcs.groupedColumns.push(gexpr);
            //	setting.isGroupBy = true;
            //	setting.dir = "asc";
            //} else {
            if (!layout) {
                this.options.groupedColumns.push(gexpr);
            }// else {
			//A.T. 21 March 2012 - bug #91992 - we want to preserve the original order of dragging to the groupby area or grouping programmatically
			this._orderedGroupedCols.push(gexpr);
			copy = this._orderedGroupedCols.slice(0);
			this._orderedGroupedCols = [];
			this._ensureLabelsOrder(copy, this._orderedGroupedCols, this.grid.options);
			//}
            //this._refreshHeaderHandlers();
            // firing this event tells all subscribers that they need to re-render their header extra cells
            // this could happen in the case when a column is grouped, and it adds extra cell to the header
            // therefore features such as filtering or sorting also need to add extra headers, etc. 
            this.grid._trigger("headerExtraCellsModified", null, { owner: this });
            //}
			// M.H. 17 May 2012 Fix for bug #111331
            //this.grid.dataSource.settings.sorting.expressions.push(expr);//unshift
			this._addSortingExpressions(this.grid.dataSource.settings.sorting.expressions, expr);
            if (!layout) {
                this._isgroup = true;
            }
            this._rebind();
			this.grid._onGroupedColumnsChanged(this.options.groupedColumns);
        },
		_addSortingExpressions: function (se, expr) {
			// insert expr at the first position of the se (sorting expressions) if there are not any other expressions with flag group by
			// otherwise if there are such expressions inserts after the last 
			var i, seLength = se.length, found = -1;

			for (i = 0; i < seLength; i++) {
				if (se[i].isGroupBy === true) {
					found = i;
				}
			}

			if (found === -1) {
				se.unshift(expr);
			} else {
				se.splice(found + 1, 0, expr);
			}
		},
        ungroupByColumn: function (key, layout) {
            /* Removes the specified column from the group by columns list, executes the group by operation and updates the view.
            paramType="string" optional="false" Column Key - ungroup by the column with the specified key
            paramType="string" optional="true" Layout is an optional parameter. If set it means the grouped column is not in the root level but is a child layout column.
            */
            var i, fc, self = this,
                exprs = this.grid.dataSource.settings.sorting.expressions, lobj, fcs, layouts, exists = this._checkGroupExists(key), copy;
            if (!layout && !exists) {
                return;
            }
			this.grid._onGroupedColumnsChanging(this.options.groupedColumns);
            if (layout) {
                layouts = [];
                this._findLayout(layout, this.grid.options, layouts);
                lobj = layouts[0];
            } else {
                lobj = this.grid.options;
            }
            fc = this.grid.element.data('igGridFeatureChooser');
            if (fc !== undefined && fc !== null) {
                fc._setSelectedState('GroupBy', key, false, false);
            }
            for (i = 0; i < lobj.features.length; i++) {
                if (lobj.features[i].name === "GroupBy") {
                    fcs = lobj.features[i].columnSettings;
                    break;
                }
            }
            for (i = 0; fcs && i < fcs.length; i++) {
                if (fcs[i].columnKey === key) {
                    fcs[i].isGroupBy = false;
                }
            }
            if (!layout) {
                for (i = 0; i < this.options.groupedColumns.length; i++) {
                    if (this.options.groupedColumns[i].key === key) {
                        //A.T. 8 March 2012 - Fix for bug #104244 
                        //this.options.groupedColumns.remove(i);
                        $.ig.removeFromArray(this.options.groupedColumns, i);
                        break;
                    }
                }
            } //else {
			// remove from the ordered expressions
			for (i = 0; i < this._orderedGroupedCols.length; i++) {
				if (this._orderedGroupedCols[i].key === key &&
						((this._orderedGroupedCols[i].layout && this._orderedGroupedCols[i].layout === layout) ||
							(!this._orderedGroupedCols[i].layout && (layout === "" || layout === undefined)))) {
					$.ig.removeFromArray(this._orderedGroupedCols, i);
					break;
				}
			}
			//}
            for (i = 0; i < exprs.length; i++) {
                if (exprs[i].fieldName === key && (!layout || (layout && layout === exprs[i].layout))) {
                    //A.T. 8 March 2012 - Fix for bug #104244 
                    //exprs.remove(i);
                    $.ig.removeFromArray(exprs, i);
                }
            }
			copy = this._orderedGroupedCols.slice(0);
			this._orderedGroupedCols = [];
			this._ensureLabelsOrder(copy, this._orderedGroupedCols, this.grid.options);
            //this._refreshHeaderHandlers();
            this.grid._trigger("headerExtraCellsModified", null, { owner: this });
            // we also need to ensure that we clear the UI from any unnecessary cols and headers, if there are no more
            // grouped rows in groupedColumns
            //if (parseInt(this.grid.container().width(), 10) > 0 && !this.grid.options.width) {
            //	this.grid.container().width(parseInt(this.grid.container().width(), 10) - parseInt(this.options.indentation, 10));
            //}
            this.grid.element.children("tbody").hide();
			// L.A. 29 October 2012 - Fixing bug #123405 - Ungrouping in sample cause shrinking of columns in IE8
			if (document.documentMode === 8) {
				this.grid.element.hide();
				this.grid.headersTable().hide();
			}
            if (!layout && this.options.groupedColumns.length === 0) {
                this.grid.element.find("colgroup").children().first().remove();
                if (this.grid.options.fixedHeaders) {
                    this.grid.headersTable().find("colgroup").children().first().remove();
                }
                // M.H. 12 Oct. 2011 Fix for bug #90815
                if (this.grid.options.fixedFooters && this.grid.options.height !== null) {
                    this.grid.footersTable().find("colgroup").children().first().remove();
                }
                // L.A. 04 January 2013 - Fixing bug #129797 A column's header cell is removed instead 
                // of the group-by expander header cell when ungrouping is performed (either through the UI or programatically)  
                // while a column is being grouped (remote GroupBy)
                this.grid.headersTable().find('thead tr').children('[data-skip]').first().remove();
            }
            if (!layout) {
                this._isgroup = false;
            }
            this._rebind();
			// L.A. 29 October 2012 - Fixing bug #123405 - Ungrouping in sample cause shrinking of columns in IE8
			if (document.documentMode === 8) {
				this.grid.headersTable().show();
				this.grid.element.show();
			}
            // decrease the grid width accordingly
            if (this.options.groupedColumns.length === 0) {
                // M.H. 23 Oct 2013 Fix for bug #155756: Group and ungroup when there is an unbound column causes the summaries of the unbound column to disapear in Firefox
                // when summaries are enabled then we should refresh hide and then show footers table in FF(version 22, 23, 24) so the layout engine to be forced to refresh UI and show properly columns
                if (window.mozInnerScreenX !== undefined && self.grid.options.fixedFooters === true) {
                    self.grid.footersTable().hide();
                    setTimeout(function () {
                        self.grid.footersTable().show();
                    }, 0);
                }
                this._setGroupAreaTextContent($('.ui-iggrid-groupbyarea .ui-iggrid-groupbyareatext', this.grid.container()));
				// M.H. 29 May 2012 Fix for bug #112881
				// M.H. 7 Aug 2012 Fix for bug #113954
				if (this.grid.options.width !== null && this.grid.options.width !== undefined) {
					this.grid._updateGridContentWidth();
				}
            }
			this.grid._onGroupedColumnsChanged(this.options.groupedColumns);
        },
        _clearSettings: function (layouts) {
            var i, j, cs, k;
            for (i = 0; i < layouts.length; i++) {
                if (layouts[i].features && layouts[i].features.length) {
                    for (j = 0; j < layouts[i].features.length; j++) {
                        if (layouts[i].features[j].name === "GroupBy") {
                            cs = layouts[i].features[j].columnSettings;
							// A.T. 2 April 2012 fix for #105052
							if (cs) {
								for (k = 0; k < cs.length; k++) {
									cs[k].isGroupBy = false;
								}
							}
                        }
                    }
                }
                if (layouts[i].columnLayouts) {
                    this._clearSettings(layouts[i].columnLayouts);
                }
            }
        },
        ungroupAll: function () {
            /* Clears the group by columns list and updates the view. */
            var indent = 0, i, layouts = this.grid.options.columnLayouts, cols = this.groupByColumns(), hasRoot = false;
            // do nothing if there's nothing grouped
            //A.T. 14 March 2012 - Fix for #101231 
            if (cols.length === 0) {
                //if (this.options.groupedColumns.length === 0) {
                return;
            }
			// M.H. 15 Apr 2014 Fix for bug #170091: When Updating is enabled "Add new row" gets displaced after calling the groupByColumn API
			this.grid._onGroupedColumnsChanging(this.options.groupedColumns);
            for (i = 1; i < this.options.groupedColumns.length; i++) {
                indent += parseInt(this.options.indentation, 10);
            }
            if (parseInt(this.grid.container().width(), 10) > 0 && !this.grid.options.width) {
				this.grid.container().width(parseInt(this.grid.container().width(), 10) - indent);
            }
            this.grid.dataSource.settings.sorting.expressions = [];
            this.options.groupedColumns = [];
			this._orderedGroupedCols = [];
			if (!this._hierarchical) {
				cols = [];
			} else {
				for (i = 0; i < cols.length; i++) {
					if (!cols[i].layout) {
						hasRoot = true;
						break;
					}
				}
				if (hasRoot) {
					cols = [];
				}
			}
            if (layouts) {
				// we need to iterate over all column layouts and check the column settings as well
				this._clearSettings(layouts);
			}
            //A.T. 14 March 2012 - do the below only of both are 0, otherwise we will remove the columns cols
            // do this only if we are ungrouping ROOT (current) level columns, not child ones 
            if (this.options.groupedColumns.length === 0 && cols.length === 0) {
                this.grid.element.find("colgroup").children().first().remove();
                if (this.grid.options.fixedHeaders) {
                    this.grid.headersTable().find("colgroup").each(function () {
						// M.H. 24 Sep 2012 Fix for bug #122404
                        $(this).children('[data-skip]').first().remove();
                    });
                }
                // M.H. 12 Oct. 2011 Fix for bug #90815
                if (this.grid.options.fixedFooters) {
                    this.grid.footersTable().find("colgroup").each(function () {
						// M.H. 24 Sep 2012 Fix for bug #122404
						$(this).children('[data-skip]').first().remove();
                    });
                }
				this.grid.headersTable().find('thead tr').each(function () {
					// M.H. 24 Sep 2012 Fix for bug #122404
					$(this).children('[data-skip]').first().remove();
				});
                // M.H. 1 Nov. 2011 Fix for bug #95004
                this.grid.footersTable().find('tfoot tr').each(function () {
					// M.H. 24 Sep 2012 Fix for bug #122404
					$(this).children('[data-skip]').first().remove();
                });
			}
			this._isgroup = false;
			this._rebind();
			// L.A. 07 January 2013 - Fixing bug #128970, 130443
			// When the grid has width and height, every column has a width, you group by a column and then click "Clear Filter" 
			// option from filtering dropdown the columns change their original width.			
			// Just adding similar fix from ungroupByColumn method
			// decrease the grid width accordingly
			if (this.options.groupedColumns.length === 0) {
				// M.H. 29 May 2012  Fix for bug #112881
				// M.H. 7 Aug 2012 Fix for bug #113954
				if (this.grid.options.width !== null && this.grid.options.width !== undefined) {
					this.grid._updateGridContentWidth();
				}
			}
			// M.H. 15 Apr 2014 Fix for bug #170091: When Updating is enabled "Add new row" gets displaced after calling the groupByColumn API
			this.grid._onGroupedColumnsChanged([]);
        },
        /*
        _refreshHeaderHandlers: function () {
        var i;
        for (i = 0; i < this.grid._headerInitCallbacks; i++) {
        // check that we have one handler registered for every column that's currently grouped
        if (this.grid._headerInitCallbacks[i].type === "GroupBy") {
        // remove that entry
        this.grid._headerInitCallbacks.remove(i);
        }
        }
        // now for every grouped row, add:
        for (i = 0; i < this.options.groupedColumns.length; i++) {
        this.grid._headerInitCallbacks.push({type: "GroupBy", func: this._renderExtraHeaderCellHandler});
        }
        },
        */
        _regroup: function () {
            var items = $('.ui-iggrid-groupbyarea', this.grid.container()).find("ul li"), groupby = this, copy;
            this.options.groupedColumns = [];
            this.grid.dataSource.settings.sorting.expressions = [];
			copy = this._orderedGroupedCols.slice(0);
			this._orderedGroupedCols = [];
            items.each(function () {
                var direction, k, layout, c, lobj, layouts = [], i;
                k = $(this).attr("data-key");
                layout = $(this).attr("data-layout");
                direction = $(this).find(".ui-iggrid-asc").length > 0 ? "asc" : "desc";
                if (layout) {
                    groupby._findLayout(layout, groupby.grid.options, layouts);
                    lobj = layouts[0];
                    for (i = 0; lobj && i < lobj.columns.length; i++) {
                        if (lobj.columns[i].key === k) {
                            c = lobj.columns[i];
                            break;
                        }
                    }
                } else {
                    c = groupby.grid.columnByKey(k);
                }
                if (layout) {
                    // don't do anything, the column is already marked as grouped
                    //groupby.grid.dataSource.settings.sorting.expressions.push({ fieldName: k, dir: direction, layout: layout });
					// M.H. 17 May 2012 Fix for bug #111331
					groupby._addSortingExpressions(groupby.grid.dataSource.settings.sorting.expressions, { fieldName: k, dir: direction, layout: layout, isGroupBy: true });
                } else {
                    groupby.options.groupedColumns.push({ key: k, dir: direction, col: c });
                    //groupby.grid.dataSource.settings.sorting.expressions.push({ fieldName: k, dir: direction });
					// M.H. 17 May 2012 Fix for bug #111331
					groupby._addSortingExpressions(groupby.grid.dataSource.settings.sorting.expressions, { fieldName: k, dir: direction, isGroupBy: true });
                }
				groupby._orderedGroupedCols.push({key: k, dir: direction, col: c, layout: layout});
            });
			groupby._ensureLabelsOrder(copy, groupby._orderedGroupedCols, groupby.grid.options); // ensure we don't allow layouts to preceed higher level layouts or root ones
            this.grid._loadingIndicator.show();
            this._rebindDataSource();
        },
        _rebind: function () {
			// get the scrolltop of the browser window
			this._scrolltop = $(window).scrollTop();
            this.grid._loadingIndicator.show();
			this._saveSortingExpressions();
            this._rebindDataSource();
            // add group by list
            this._groupAreaList();
        },
        _rebindDataSource: function () {
            if (this.options.type === "remote") {
				this.grid.dataSource.dataBind();
            } else {
                // M.H. 15 March 2012 Fix for bug #104535
				// L.A. 11 September 2012 Fixing bug #120131 
				// Ungrouping when Type = local makes request to the remote dataSource
                if (this.grid.dataSource.settings.sorting.expressions.length > 0) {
                    this.grid.dataSource.sort(this.grid.dataSource.settings.sorting.expressions);
                }
				this.grid._renderData();
            }
        },
        _renderPartialRecords: function (parentrow) {
            if (parentrow.attr('data-loaded')) {
                return;
            }
            var dataRowId, rows, html = '', i, rowsLength, scrollerHeight;

            dataRowId = parseInt(parentrow.attr('data-row-idx'), 10);
            if (dataRowId >= 0) {
                rows = this._groups[dataRowId];
            }
            if (!rows) {
                return;
            }
            rowsLength = rows.length;
            for (i = 0; i < rowsLength; i++) {
                html += rows[i];
            }
            $(html).insertAfter(parentrow);
            scrollerHeight = this.grid._getScrollContainerHeight();
            this._addScrollHeight = parentrow.outerHeight() * rowsLength;
            this.grid._setScrollContainerHeight(scrollerHeight + this._addScrollHeight);
            parentrow.attr('data-loaded', true);
        },
        _toggleGroup: function (event, args) {
            // get the grouped row
            // find all trs between two grouped rows
            // change their visibility / display attributes
            var parentrow = $(event.target).closest('tr'), grid, i, el, currentLevel,
				cindex, glevel = parentrow.attr('data-glevel'), grouprow, rowPath = [], level = glevel, style;
			cindex = parentrow.index();
			if (this._hierarchical) {
				grid = parentrow.closest('.ui-iggrid-table').data('igGrid');
			} else {
				grid = this.grid;
			}
            // L.A. Fixing bug #108470 Only the first grouped row is collapsed with initialExpand: false
            // All collapsed/expanded children will not preserve their states and their child states
            // L.A. 04 May 2012 - Fixing bug #107316 - The icon in the expander cell is misaligned to the left side of the cell
            if (parentrow.attr('data-state') === "expanded") {
                parentrow.attr('data-state', 'collapsed').find(".ui-iggrid-expandbutton")
					.attr('title', this.options.expandTooltip)
					.removeClass(this.css.groupByExpandCellExpanded).addClass(this.css.groupByExpandCellCollapsed);
            } else {
                parentrow.attr('data-state', 'expanded').find(".ui-iggrid-expandbutton")
					.attr('title', this.options.collapseTooltip)
					.removeClass(this.css.groupByExpandCellCollapsed).addClass(this.css.groupByExpandCellExpanded);
                if (this._getTotalRowCountHandler) {
                    this._renderPartialRecords(parentrow);
                }
            }
            rowPath[glevel] = parentrow;
            grid.element.children("tbody").children().each(function (index, element) {
                if (index > cindex) {
                    var $this = $(this);
                    grouprow = $this.attr('data-grouprow');
                    level = $this.attr('data-glevel');

                    //Exit loop
                    if (grouprow === "true" && level <= glevel) {
                        return false;
                    }

                    //Calculate real level. If the row is not a grouprow, increase the level by one
                    if (grouprow) {
                        currentLevel = level;
                    } else {
                        currentLevel = parseInt(rowPath[rowPath.length - 1].attr('data-glevel'), 10) + 1;
                    }

                    //Detect visiblity by reading the whole row path
                    style = '';
                    for (i = 0; i < currentLevel; i++) {
                        if (rowPath[i] !== undefined && rowPath[i].attr('data-state') !== 'expanded') {
                            style = 'none';
                            break;
                        }
                    }
                    $this.css('display', style);

                    //Update row path
                    if (grouprow) {
                        rowPath[parseInt($this.attr('data-glevel'), 10)] = $this;
                    }
                }
            });

            // Empty the array to ensure no memory leaks in IE
            for (el in rowPath) {
                if (rowPath.hasOwnProperty(el)) {
                    el = null;
                    $.ig.removeFromArray(rowPath, el);
                }
            }
			// M.H. 10 May 2012 Fix for bug #110952
			// M.H. 29 May 2012 Fix for bug #112865
			this.grid._adjustLastColumnWidth(false);
            event.stopPropagation();
        },
        _groupAreaList: function () {
			var area = $('.ui-iggrid-groupbyarea', this.grid.container()), layout, allgrouped = [], dropFunc, mousedownFunc,
				list = area.find("ul"), i, groupby = this, css, key, item, itemEdge, helperFunc, overFunc, outFunc, text;
            //this._allGroupedCols(allgrouped);
			allgrouped = this.groupByColumns();
            if (list.length > 0) {
                list.empty();
            } else {
                // A.T. 15 Sept 2011 - Fix for bug #87562. Removing float:left from the UL, because it increases the overall height of teh group by area, unnecessarily
                // list = $("<ul></ul>").appendTo(area).addClass("ui-iggrid-grouparealist").css('float', 'left').sortable({
                list = $("<ul></ul>").appendTo(area).addClass("ui-iggrid-grouparealist");
            }
            helperFunc = function (event) {
                var li = null;
                if ($(event.target).is("li")) {
                    li = $(event.target);
                } else {
                    li = $(event.target).closest("li");
                }
                li = li.clone();
                li.find(".ui-iggrid-groupbylabelrightedgeend").remove();
                li.find(".ui-iggrid-groupbylabelrightedge").remove();
                li.find(".ui-iggrid-groupbyremovebutton").remove();
                li.attr("data-dragging", true);
                return li;
            };
            overFunc = function (event, ui) {
                if (!ui.draggable.hasClass("ui-iggrid-groupedcolumnlabel")) {
                    return false;
                }
                if (ui.draggable.attr("data-key") === $(this).attr("data-key")) {
                    return false;
                }
                $(event.target).addClass("ui-iggrid-groupbydroppableedge");
            };
            outFunc = function (event, ui) {
                if (!ui.draggable.hasClass("ui-iggrid-groupedcolumnlabel")) {
                    return false;
                }
                if (ui.draggable.attr("data-key") === $(this).attr("data-key")) {
                    return false;
                }
                $(event.target).removeClass("ui-iggrid-groupbydroppableedge");
            };
            dropFunc = function (event, ui) {
                var parent, dragged;
                $(this).removeClass("ui-iggrid-groupbydroppableedge");
                if (!ui.draggable.hasClass("ui-iggrid-groupedcolumnlabel")) {
                    return;
                }
                if (ui.draggable.attr("data-key") !== $(this).attr("data-key")) {
                    // regroup
                    // reorder items, first find the original of the cloned one
                    parent = $(this).closest("ul");
                    dragged = parent.find("li[data-key=" + ui.draggable.attr("data-key") + "]").first();
                    dragged.insertAfter(this);
                    parent.find("li[data-dragging=true]").remove();
                    parent.find("li").removeClass("ui-iggrid-groupbydroppableedge");
                    groupby._regroup();
                    groupby._groupAreaList();
                    event.preventDefault();
                    event.stopPropagation();
                    return false;
                }

                return;
            };
            mousedownFunc = function (event) {
                event.preventDefault();
                event.stopPropagation();
                return false;
            };
            for (i = 0; i < allgrouped.length; i++) {
                key = allgrouped[i].key;
                layout = allgrouped[i].layout;
                text = allgrouped[i].col.headerText;
                if (allgrouped[i].dir === "asc") {
                    css = "ui-iggrid-asc ui-icon ui-icon-arrowthick-1-n";
                } else {
                    css = "ui-iggrid-desc ui-icon ui-icon-arrowthick-1-s";
                }
                //w = allgrouped[i].col ? allgrouped[i].col.width : "";
                item = $("<li></li>").appendTo(list).addClass(this.css.groupedColumnLabel)
					.css("float", "left")
					.attr("data-key", key).attr("data-layout", layout || "")
					.bind({
					    mouseup: $.proxy(this._changeSortState, this)
					    //mousedown: $.proxy(this._changeSortState, this)
					}).draggable({
					    containment: 'body',
					    appendTo: 'parent',
					    distance: 5,
					    revert: "invalid",
					    helper: helperFunc
					    //opacity: groupby.options.labelDragHelperOpacity
					}).droppable({
					    accept: "li",
					    //activeClass: "ui-iggrid-groupbydroppableedge",
					    over: overFunc,
					    out: outFunc,
					    drop: dropFunc
					});
                if (this.options.groupByLabelWidth !== null) {
                    item.width(this.options.groupByLabelWidth);
                }
                // append triangle item (which is not a label). It should have the rightEdgeEnd class applied
                itemEdge = $("<span></span>").appendTo(item).css({ "float": "right" })
					.addClass(this.css.groupedColumnLabel).addClass(this.css.groupedColumnLabelRightEdgeEnd);
                itemEdge.attr("data-marker", "edge");
                //itemEdge.css("border-color", area.css("border-color"));
                // now get the previous item, if any, and change its class from "rightEdgeEnd" to "rightEdge"
                item.prev().find("span[data-marker]").removeClass(this.css.groupedColumnLabelRightEdgeEnd).addClass(this.css.groupedColumnLabelRightEdge);
                //$("<span></span>").appendTo($("<a></a>").appendTo(item).attr("href", "#").css("text-decoration", "none")).text(key);
                if (layout) {
                    $("<span></span>").appendTo(item).text(text).addClass(this.css.groupedColumnLabelText);
                    $("<span></span>").prependTo(item).text(layout).addClass(this.css.groupedColumnLayoutLabel);
                } else {
                    $("<span></span>").appendTo(item).text(text);
                }
                $("<span></span>").appendTo(item).addClass(css);
                // M.H. 15 March 2012 Fix for bug #104811
                if (typeof Modernizr !== 'object' || Modernizr.touch === false) {
                    // create remove button
                    $('<span></span>').appendTo(item).addClass("ui-iggrid-groupbyremovebutton")
						.attr('title', groupby.options.removeButtonTooltip).bind({
						    mouseup: $.proxy(groupby._removeButtonClick, groupby),
						    mousedown: mousedownFunc
//							mouseover: $.proxy(groupby._removeButtonHover, groupby),
//							mouseout: $.proxy(groupby._removeButtonUnhover, groupby)
						});
                }
                // add a Li that won't be a grouped one but will show an arrow
                // the "magic" value is required so that it leaves space for the icon plus the paddings/borders/margins
                // so that when we hover, the item doesn't change its width dynamically
				// L.A. 05 October 2012 - Fixing bug #119933 - Groupby bar and show records per page style appear wrong in IE7, MVC4
				// Specific patch for IE7 width defaults
				if ($.ig.util.isIE7 && item.width() > 300) {
					item.width(260);
				} else {
					item.width(Math.ceil(item.width()) + 22);
				}
            }
            // attach events
            list.children().bind({
                "mouseover": $.proxy(this._showRemoveButton, this),
                "mouseout": $.proxy(this._hideRemoveButton, this)
            });
        },
        _changeSortState: function (event) {
            var li = $(event.target).closest("li"), key = li.attr("data-key"), i, layout = li.attr("data-layout"), layouts,
				j, gc = this._orderedGroupedCols, s = this.grid.dataSource.settings.sorting.expressions, settings, lobj;
            //if (gc.length === 0 && !layout) {
                // if we are inside of changeSortState and the count is zero, get all grouped cols)
                //this._allGroupedCols(gc);
           // }
            for (i = 0; i < gc.length; i++) {
                if (gc[i].key === key && ((layout && layout === gc[i].layout) || !layout)) {
                    if (gc[i].dir === "asc") {
                        gc[i].dir = "desc";
                    } else {
                        gc[i].dir = "asc";
                    }
                    for (j = 0; j < s.length; j++) {
                        if (s[j].fieldName === key && ((layout && layout === s[j].layout) || !layout)) {
                            s[j].dir = gc[i].dir;
                            break;
                        }
                    }
                    // rebind
                    this._rebind();
                    // this._groupAreaList();
                    break;
                }
            }
            if (layout) {
                // find the layout and change the settings
                layouts = [];
                this._findLayout(layout, this.grid.options, layouts);
                lobj = layouts[0];
                for (i = 0; lobj.features && i < lobj.features.length; i++) {
                    if (lobj.features[i].name === "GroupBy") {
                        // find the col setting in order to change the sort direction
                        settings = lobj.features[i].columnSettings;
                        for (j = 0; j < settings.length; j++) {
                            if (settings[j].columnKey === key) {
                                settings[j].dir = settings[j].dir === "asc" ? "desc" : "asc";
                                break;
                            }
                        }
                        break;
                    }
                }
                this._rebind();
            }
            // li.removeClass("ui-state-highlight").find("[data-marker]").removeClass("ui-state-highlight");
        },
        _showRemoveButton: function (event) {
            var button = $(event.target).closest("li").find(".ui-iggrid-groupbyremovebutton"),
				key = $(event.target).closest("li").attr("data-key"),
				layout = $(event.target).closest("li").attr("data-layout");
            if (!key) {
                return;
            }
            // position it and change its attribute
            button.attr("data-key", key).attr("data-layout", layout).addClass("ui-icon ui-icon-circle-close");
            // remove hovering for the items based on Lucia's request
            //$(event.target).closest("li").addClass("ui-state-hover");
        },
        _hideRemoveButton: function (event) {
            var button = $(event.target).closest("li").find(".ui-iggrid-groupbyremovebutton");
            //if (!button.hasClass("ui-state-hover")) {
            button.removeClass("ui-icon ui-icon-circle-close");
            $(event.target).closest("li").removeClass("ui-state-hover");
            //}
        },
        _removeButtonClick: function (event) {
            var key = $(event.target).attr("data-key"), noCancel, layout;//, area = $('.ui-iggrid-groupbyarea', this.grid.container())
            if (this._isDragging) {
                return;
            }
            noCancel = this._trigger(this.events.groupedColumnsChanging, event, { owner: this, groupedColumns: this.options.groupedColumns, key: key });
            if (noCancel) {
                layout = $(event.target).attr("data-layout");
                this.ungroupByColumn(key, layout);
                // remove the actual list element
               // $(event.target).hide();
                //area.find('ul li[data-key="' + key + '"][data-layout="' + layout + '"]').remove();
                this._trigger(this.events.groupedColumnsChanged, event, { owner: this, groupedColumns: this.options.groupedColumns, key: key });
            }
            event.preventDefault();
            event.stopPropagation();
            return false;
        },
        destroy: function () {
            /*
            Destroys the group by feature object. 
            */
            var modalDialog = $('#' + this.grid.id() + '_groupby_modalDialog');
            // remove the groupby area
            this.grid.container().find('.ui-iggrid-groupbyarea').remove();
            // rebind the grid
            // remove any sorting expressions from the data source (this means that if a column has been sorted, that state will be lost when
            // GroupBy is destroyed
            // M.H. 13 Mar 2014 Fix for bug #166844: When the grouping is initial and you ungroup through modal dialog the grid remain grouped
            if (this.grid._initialized) {
                this.ungroupAll();
            }
            // M.H. 8 May 2012 Fix for bug #107895
			this._detachEvents(true);
            modalDialog.igGridModalDialog('getCaptionButtonContainer');
            modalDialog.remove();
            // call base destroy
            $.Widget.prototype.destroy.call(this);
            return this;
        },
        _detachEvents: function (isDestroyDraggable) {
            var ths = this.grid.headersTable().find("th"), i;
			// M.H. 8 May 2012 Fix for bug #107895
			// when it is called from destroy it should be removed destroy functionallity. Otherwise when databind method of the grid is called then draggable should not be removed
			if (isDestroyDraggable === true) {
				// L.A. 20 February 2013 - jQuery 1.9 compatibility
				// Error: cannot call methods on draggable prior to initialization; attempted to call method 'destroy'
				for (i = 0; i < ths.length; ++i) {
					if ($(ths[i]).data().draggable) {
						$(ths[i]).draggable("destroy");
					}
				}
			}
            ths.unbind("mouseover", this._headerMouseOverHandler).unbind("mouseout", this._headerMouseOutHandler);
			// M.H. 26 April 2012 Fix for bug #105949
            //this.grid.element.undelegate("td[gbexpandcell=1]", "mousedown", this._toggleGroupHandler);
            // M.H. 26 Sep 2013 Fix for bug #153447: It is not possible to collapse a group row when columns are autogenerated and selection is enabled
            $(document).undelegate("#" + this.grid.id() + "_container td[gbexpandcell=1]", "mousedown", this._toggleGroupHandler);
            //this.grid.container().unbind('iggridheaderrendering', this._headerRenderingHandler);
			// M.H. 10 May 2012 Fix for bug #108221
            this.grid.element.unbind('iggridheaderrenderedinternal', this._headerRenderedHandler);
            this.grid.element.unbind('iggriddataempty', this._dataRenderingHandler);
            this.grid.element.unbind('iggridrowsrendering', this._rowsRenderingHandler);
            this.grid.element.unbind('iggridrowsrendered', this._rowsRenderedHandler);
            this.grid.element.unbind('iggridheadercellrendered', this._headerCellRenderedHandler);
            this.grid.element.unbind('iggridheadercelldragcancel', this._headerDragCancelHandler);
            this.grid.element.unbind('iggriduidirty', this._uiDirtyHandler);
			this.grid.element.unbind('iggriddatabound', this._dataBoundHandler);
			// M.H. 12 Feb 2014 Fix for bug #164195: igGrid header/column misalignment when data source is changed at runtime, and grouping and hiding are applied
            if (this._columnsCollectionModifiedHandler) {
            	this.grid.element.unbind("iggridcolumnscollectionmodified", this._columnsCollectionModifiedHandler);
            }
			// M.H. 29 Oct 2012 Fix for bug #120642
			if (isDestroyDraggable === true) {
				delete this._dataRenderingHandler;
				delete this._rowsRenderingHandler;
				delete this._rowsRenderedHandler;
				delete this._headerCellRenderedHandler;
				delete this._headerDragCancelHandler;
				delete this._uiDirtyHandler;
				delete this._columnsCollectionModifiedHandler;
			}
        },
        _initDefaultSettings: function () {
            var settings = [], key, cs = this.options.columnSettings, i, j, allowGroupBy,
				isToCheckUnboundColumns = (this.grid._hasUnboundColumns === true && this.options.type === "remote");
			this._orderedColumnSettings = [];
            // initialize
            if (this.grid.options.columns && this.grid.options.columns.length > 0) {
                for (i = 0; i < this.grid.options.columns.length; i++) {
					allowGroupBy = true;
					if (isToCheckUnboundColumns && this.grid.getUnboundColumnByKey(this.grid.options.columns[i].key) !== null) {
						allowGroupBy = false;
					}
                    settings[i] = {
                        'columnIndex': i,
                        'columnKey': this.grid.options.columns[i].key,
                        'allowGrouping': allowGroupBy,
                        'summaries': [],
                        isGroupBy: false
                    };
                }
            }
            // M.H. 24 Mar 2014 Fix for bug #165993: Sorting is not working with initial sorting, autogenerate column and no columns definition
            // default expressions are applied ONLY IF column key is properly defined
            if (settings.length === 0 &&
                this.grid.options.autoGenerateColumns &&
                cs.length > 0) {
                for (i = 0; i < cs.length; i++) {
                    if (!cs[i].columnKey) {
                        continue;
                    }
                    if (!cs[i].dir) {
                        cs[i].dir = this.options.defaultSortingDirection || 'asc';
                    }
                    this._orderedColumnSettings.push(cs[i]);
                }
            } else {
                for (i = 0; i < cs.length; i++) {
                    for (j = 0; j < settings.length; j++) {
                        if (settings[j].columnKey === cs[i].columnKey || settings[j].columnIndex === cs[i].columnIndex) {
                            break;
                        }
                    }
                    if (j === settings.length) {
                        continue;
                    }

                    for (key in cs[i]) {
                        if (cs[i].hasOwnProperty(key) && key !== 'columnKey' && key !== 'columnIndex') {
                            settings[j][key] = cs[i][key];
                        }
                    }
                    // M.H. 5 Mar 2014 Fix for bug #162907: GroupBy does not have option to set sort direction
                    if (settings[j].dir === undefined && this.options.defaultSortingDirection) {
                        settings[j].dir = this.options.defaultSortingDirection;
                    }
				    this._orderedColumnSettings.push(settings[j]);
                }
            }
            // copy
            this.options.columnSettings = settings;
            // remove the header and footer init callbacks if they exist
            for (i = 0; this.grid._headerInitCallbacks && i < this.grid._headerInitCallbacks.length; i++) {
                if (this.grid._headerInitCallbacks[i].type === "GroupBy") {
                    //A.T. 8 March 2012 - Fix for bug #104244 
                    //this.grid._headerInitCallbacks.remove(i);
                    $.ig.removeFromArray(this.grid._headerInitCallbacks, i);
                    break;
                }
            }
            for (i = 0; this.grid._footerInitCallbacks && i < this.grid._footerInitCallbacks.length; i++) {
                if (this.grid._footerInitCallbacks[i].type === "GroupBy") {
                    //A.T. 8 March 2012 - Fix for bug #104244 
                    //this.grid._footerInitCallbacks.remove(i);
                    $.ig.removeFromArray(this.grid._footerInitCallbacks, i);
                    break;
                }
            }
        },
        _renderExtraFooterCells: function (row, colgroup, prepend) {
            // M.H. 12 Oct. 2011 Fix for bug #91479
            // its how many grouped columns we have, the cell is only one
            // also mark the extra cell with a data-skip attribute so that features can do their 
            // calculations based on this

            if (this.options.groupedColumns.length > 0) {
                if (prepend === true) {
                    // M.H. 17 Oct. 2011 Fix for bug 90815 - remove border-width and add css class
                    $('<td></td>').addClass(this.css.footerExtraCell).prependTo(row).attr('data-skip', true);
                } else {
                    // M.H. 17 Oct. 2011 Fix for bug 90815
                    $('<td></td>').addClass(this.css.footerExtraCell).appendTo(row).attr('data-skip', true);
                }
            }
        },
        _renderExtraHeaderCells: function (row, colgroup, prepend) {
            // its how many grouped columns we have, the cell is only one
            //for (i = 0; i < this.options.groupedColumns.length; i++) {
            // also mark the extra cell with a data-skip attribute so that features can do their 
            // calculations based on this
            if (this.options.groupedColumns.length > 0) {
                if (prepend === true) {
                    $('<td></td>').prependTo(row).addClass(this.css.headerExtraCell).attr('data-skip', true);
                    if (colgroup) {
                        $('<col />').prependTo(colgroup).attr('data-skip', true).css('width', this.options.indentation);
                    }
                } else {
					$('<td></td>').appendTo(row).addClass(this.css.headerExtraCell).attr('data-skip', true);
                    if (colgroup) {
                        $('<col />').appendTo(colgroup).attr('data-skip', true).css('width', this.options.indentation);
                    }
                }
            }
        },
        _columnsCollectionModified: function (event, args) {
            var colGroup;
			// M.H. 4 April 2012 Fix for bug #107199
			if (args.owner.id() !== this.grid.id()) {
                return;
            }
            args.tbody = this.grid.element.children("tbody");
            if (this.options.groupedColumns.length > 0) {
                // L.A. 27 April 2012 Fixed bug #110760 When in child layout autoGenerateColumns is true and group by a column it is not possible to resize layout columns
                // _registeredCol flag is saved now directly in the element
                colGroup = this.grid.headersTable().children("colgroup");
                if (colGroup.children('[data-registeredCol=true]').length === 0) {
                    // M.H. 14 May 2013 Fix for bug 142258: Grouping column cause the last column to disappear and a wider expand button container in jquery 2.0.0
                    $("<col />").prependTo(colGroup)
                        .attr('data-skip', 'true')
                        .attr('data-registeredCol', 'true').width(this._indent);
                } else {
                    colGroup.children("col:nth-child(1)").width(this._indent);
                }
                if (this.grid.headersTable().attr('id') !== this.grid.element.attr('id')) {
                    //A.Y. bug 93426. If we have a separate table for the data 
                    //we need to add a col to the data table colgroup as well.
                    // M.H. 14 May 2013 Fix for bug 142258: Grouping column cause the last column to disappear and a wider expand button container in jquery 2.0.0
                    $("<col />").prependTo(this.grid.element.children("colgroup")).attr('data-skip', 'true').width(this._indent);
                }

                if (this.grid.footersTable().attr('id') !== this.grid.element.attr('id')) {
                    // M.H. 14 May 2013 Fix for bug 142258: Grouping column cause the last column to disappear and a wider expand button container in jquery 2.0.0
                    $("<col />").prependTo(this.grid.footersTable().children("colgroup")).attr('data-skip', 'true').width(this._indent);
                }

                if (this.grid.options.width === null) {
                    //A.Y. if grid has no width we need to adjust the container width to account for the special columns
                    //it is done in the _setHiddenColumns function but the groupby column is not yet rendered
                    //so we need to do it here again
                    this.grid._setContainerWidth(this.grid.container());
                } else {
                    this.grid._updateGridContentWidth();
                }
            }
            this._dataEmpty(event, args);
        },
        _onUIDirty: function (event, args) {
			if (this.options.persist) {
				return;
			}
            // reset groups
            this.ungroupAll();
        },
		_saveSortingExpressions: function () {
			if (this.options.persist) {
				this.grid._savePersistenceData(this.grid.dataSource.settings.sorting.expressions, 'sorting', this.grid.element[0].id);
				// M.H. 26 Feb 2014 Fix for bug #165340: Initially grouped columns are not persisted on data bind
				this._groupedColumns = this._orderedGroupedCols;
				this._optionsGC = this.options.groupedColumns;
			}
		},
		_getSortingExpressions: function () {
			return this.grid._getPersistenceData('sorting', this.grid.element[0].id);
		},
		_preserveGroupBy: function () {
			// M.H. 26 Feb 2014 Fix for bug #165340: Initially grouped columns are not persisted on data bind
			var se = this._getSortingExpressions(), col, layout, layouts, lobj;
			if (this._groupedColumns) {
				this._orderedGroupedCols = this._groupedColumns;
			}
			if (this._optionsGC) {
				this.options.groupedColumns = this._optionsGC;
				// M.H. 11 Mar 2014 Fix for bug #166528: Sorting and Filtering does not persist its state, when they are applied to unbound column
				if (this.grid._hasUnboundColumns && this.options.type === 'local') {
					for (i = 0; i < this._optionsGC.length; i++) {
						key = this._optionsGC[i].key;
						if (this._optionsGC[i].layout) {
							layouts = [];
							this._findLayout(this._optionsGC[i].layout, this.grid.options, layouts);
							lobj = layouts[0];

							col = this._getColumnByLayoutKey(key, lobj.columns);
						} else {
							col = this.grid.columnByKey(key);
						}
						if (col && col.unbound) {
							this.ungroupByColumn(key, this._optionsGC[i].layout);
						}
					}
				}
			}
			if (se) {
				this.grid.dataSource.settings.sorting.expressions = se;
				this.grid.dataSource.settings.sorting.defaultFields = se;
			}
		},
		_onDataBound: function (event, args) {
			if (this.options.groupedColumns.length > 0 && this.grid._isDataBoundCalled) {
				// M.H. 9 Nov 2012 Fix for bug #126509
				this.grid._trigger("headerExtraCellsModified", null, { owner: this });
			}
		},
		_injectGrid: function (gridInstance, isRebind) {
            var i, gc, gcsort, s, root = null, orderedGrouped = null, layoutGrouped = null;
            this.grid = gridInstance;
            if (this.options.type === null) {
                // infer type
                this.options.type = this.grid._inferOpType();
            }
			root = this.element.closest(".ui-iggrid-root");
			if (root.is("div")) {
				root = root.find("#" + root.attr("id") + "_table");
			}
			root = root.data("igGridGroupBy");
			if (root) {
				orderedGrouped = root._orderedGroupedCols;
				if (orderedGrouped && orderedGrouped.length > 0 && this.grid.options.key) {
					layoutGrouped = [];
					for (i = 0; i < orderedGrouped.length; i++) {
						if (this.grid.options.key === orderedGrouped[i].layout) {
							layoutGrouped.push(orderedGrouped[i]);
						}
					}
				}
			}
			for (i = 0; i < this.grid.options.features.length; i++) {
				if (this.grid.options.features[i].name === "ColumnMoving") {
					this._movingEnabled = true;
					break;
				}
			}
            //this._headerRenderingHandler = $.proxy(this._headerRendering, this);
            this._headerRenderedHandler = $.proxy(this._headerRendered, this);
            this._dataRenderingHandler = $.proxy(this._dataEmpty, this);
            this._toggleGroupHandler = $.proxy(this._toggleGroup, this);
            this._rowsRenderingHandler = $.proxy(this._renderRecords, this);
            this._rowsRenderedHandler = $.proxy(this._recordsRendered, this);
            this._headerCellRenderedHandler = $.proxy(this._headerCellRendered, this);
            this._headerDragCancelHandler = $.proxy(this._headerCellDragCancel, this);
			this._dataBoundHandler = $.proxy(this._onDataBound, this);
            if (this.grid.options.virtualization === true && this.grid.options.virtualizationMode === 'continuous') {
                this._rebuildVirtualRowsHandler = $.proxy(this._rebuildVirtualRows, this);
                this.grid.element.bind('iggridrebuildingvirtualrows', this._rebuildVirtualRowsHandler);

                this.grid._getTotalRowsCount = $.proxy(this._getTotalRowsCount, this);
            }
            //A.T. 23 Nov Fix for bug #96602 The grouped row can't be expanded when bind the data after init and initialExpand is set to false
            this._detachEvents();
			// M.H. 10 May 2012 Fix for bug #108221
            this.grid.element.bind('iggridheaderrenderedinternal', this._headerRenderedHandler);
            this.grid.element.bind('iggriddataempty', this._dataRenderingHandler);
            this.grid.element.bind('iggridrowsrendering', this._rowsRenderingHandler);
            this.grid.element.bind('iggridrowsrendered', this._rowsRenderedHandler);
            this.grid.element.bind('iggridheadercellrendered', this._headerCellRenderedHandler);
			this.grid.element.bind('iggriddatabound', this._dataBoundHandler);
            // we need to cancel the "drag cancelling" done by features such as sorting, because GroupBy needs to be able to drag the headers
            // into the groupby area
            this.grid.element.bind('iggridheadercelldragcancel', this._headerDragCancelHandler);

            this._headerMouseOverHandler = function (event) {
                $(event.currentTarget).addClass("ui-state-hover");
            };
            this._headerMouseOutHandler = function (event) {
                $(event.currentTarget).removeClass("ui-state-hover");
            };
            // group by works on sorting
           // this.grid.dataSource.settings.sorting.sortUrlKey = "sort";
           // this.grid.dataSource.settings.sorting.sortUrlAscValueKey = "asc";
           // this.grid.dataSource.settings.sorting.sortUrlDescValueKey = "desc";
			// A.T. 3 May - fix for bug 105720
			this.grid.dataSource.settings.sorting.sortUrlKey = this.options.groupByUrlKey;
			this.grid.dataSource.settings.sorting.sortUrlAscValueKey = this.options.groupByUrlKeyAscValue;
			this.grid.dataSource.settings.sorting.sortUrlDescValueKey = this.options.groupByUrlKeyDescValue;
            if (this.options.type) {
                this.grid.dataSource.settings.sorting.type = this.options.type;
            } else {
                this.grid.dataSource.settings.sorting.type = "remote";
            }
            this.grid.dataSource.settings.encodeExtraParams = $.proxy(this._encodeSummaryParams, this);
            this._initDefaultSettings();
            this.options.groupedColumns = [];
			if (!this.grid.options.key && (layoutGrouped === null || layoutGrouped.length === 0)) {
				for (i = 0; i < this._orderedColumnSettings.length; i++) {
					if (this._orderedColumnSettings[i].isGroupBy) {
						s = this._orderedColumnSettings[i];
						gc = { key: s.columnKey, dir: s.dir || "asc", col: this.grid.columnByKey(s.columnKey) };
						this.options.groupedColumns.push(gc);
						// M.H. 17 May 2012 Fix for bug #111331
						gcsort = { fieldName: s.columnKey, dir: s.dir || "asc", layout: this.grid.options.key, isGroupBy: true };
						if (this.options.type === "local") {
							gcsort.layout = null;
							this.grid.dataSource.settings.sorting.defaultFields.push(gcsort);
						}
						//this.grid.dataSource.settings.sorting.expressions.push(gcsort);
						// M.H. 17 May 2012 Fix for bug #111331
						this._addSortingExpressions(this.grid.dataSource.settings.sorting.expressions, gcsort);
					}
				}
			} else {
				for (i = 0; layoutGrouped !== null && i < layoutGrouped.length; i++) {
					this.options.groupedColumns.push(layoutGrouped[i]);
					gcsort = { fieldName: layoutGrouped[i].key, dir: layoutGrouped[i].dir || "asc", layout: this.grid.options.key, isGroupBy: true };
					if (this.options.type === "local") {
						gcsort.layout = null;
						this.grid.dataSource.settings.sorting.defaultFields.push(gcsort);
					}
					//this.grid.dataSource.settings.sorting.expressions.push(gcsort);
					// M.H. 17 May 2012 Fix for bug #111331
					this._addSortingExpressions(this.grid.dataSource.settings.sorting.expressions, gcsort);
				}
			}
            if (this.grid.element.closest('.ui-iggrid-root').length === 0 || this.grid.element.hasClass('ui-iggrid-root') || this.grid._isWrapped) {
				// M.H. 26 April 2012 Fix for bug #105949 - attach mousedown to TD
                //this.grid.element.delegate("td[gbexpandcell=1]", "mousedown", this._toggleGroupHandler);
                // M.H. 26 Sep 2013 Fix for bug #153447: It is not possible to collapse a group row when columns are autogenerated and selection is enabled
                $(document).delegate("#" + this.grid.id() + "_container td[gbexpandcell=1]", "mousedown", this._toggleGroupHandler);
            }
            // now add the special empty cell callback
            this._renderExtraHeaderCellHandler = $.proxy(this._renderExtraHeaderCells, this);
            // M.H. 12 Oct. 2011 Fix for bug #91479
            this._renderExtraFooterCellHandler = $.proxy(this._renderExtraFooterCells, this);
            // we must check if those entries don't exist yet (or remove them in destroy)
            this.grid._headerInitCallbacks.push({ type: "GroupBy", func: this._renderExtraHeaderCellHandler });
            // M.H. 12 Oct. 2011 Fix for bug #91479
            this.grid._footerInitCallbacks.push({ type: "GroupBy", func: this._renderExtraFooterCellHandler });
            this._columnsCollectionModifiedHandler = $.proxy(this._columnsCollectionModified, this);
            this.grid.element.bind("iggridcolumnscollectionmodified", this._columnsCollectionModifiedHandler);
            this._uiDirtyHandler = $.proxy(this._onUIDirty, this);
            this.grid.element.bind('iggriduidirty', this._uiDirtyHandler);
            if (this.grid.element.igGridFeatureChooser !== undefined) {
                this.grid.element.igGridFeatureChooser();
            }
			// M.H. 14 June 2012 Fix for bug #114327
			this._hierarchical = this.grid._isHierarchicalGrid;
			//A.T. 21 March 2012
			if (this.options.persist) {
				// M.H. 26 Feb 2014 Fix for bug #165340: Initially grouped columns are not persisted on data bind
				this._preserveGroupBy();
				//this._groupAreaList();
				//this.grid._renderData();
			}
			this._allGroupedCols(this._orderedGroupedCols);
        },
        //continuous virtualization: converts the pre-generated tbody to an array
        //each array element represents a TR; TRs can be grouping or not.
        _tokenizeTBody: function (html) {
            var start = 0, trTokens = [], index = 0, begin, end, tr;
            while (true) {
                begin = html.indexOf('<tr', start);
                end = html.indexOf('</tr>', start);
                if (begin === -1 || end === -1) {
                    break;
                }
                tr = html.substr(begin, end + 5 - begin);
                tr = tr.substr(0, 3) + ' data-row-idx="' + (index++) + '" ' + tr.substr(3);
                trTokens.push(tr);
                if (end + 5 < html.length - 1) {
                    start = end + 5;
                } else {
                    break;
                }
            }
            return trTokens;
        },
        //continuous virtualization: overrides _determineVirtualRowCount of the grid.framework to determine the number of virtual rows
        _determineVirtualRowCount: function (allRows, displayContainerHeight) {
            var div, rowNumber, rows, i, height, avgRowHeight, rowsPerPage, result;
            div = $('<div></div>)').appendTo('body').css({ position: 'absolute', top: -1800, left: -1800, visibility: 'hidden' });
            rowNumber = allRows.length > 10 ? 10 : allRows.length;
            rows = '';
            for (i = 0; i < rowNumber; i++) {
                rows += allRows[i];
            }
            div.html(rows);
            height = div.height();
            avgRowHeight = height / rowNumber;
            rowsPerPage = displayContainerHeight / avgRowHeight;
            result = Math.ceil(rowsPerPage * 3);
            div.remove();
            return result;
        },
        //continuous virtualization: overrides _getTotalRowsCount of the grid.framework to determine total row count
        _getTotalRowsCount: function () {
            if (this.options.groupedColumns.length > 0) {
                // M.H. 4 Sep 2013 Fix for bug #151288: When you groupby a column in virtual grid you cannot scroll all the way down
                if (this._getTotalRowCountHandler) {
                    return this._countGroupedRows;
                }
                return this._groupedRows.length;
            }

            return this.grid.dataSource.dataView().length;
        },
        //continuous virtualization: overrides _rebuildVirtualRows of grid.framework
        //gets called each time when after scrolling current TRs are not sufficient to display the required data
        _rebuildVirtualRows: function (event, args) {

            var scrollData, scrollResult, virtualScrollerY, deltaScroll, tableId,
                visibleArea, tbody, expandedRowsHeight, trs, i, scrollerHeight, firstVisibleTR, firstVisibleTRRelativeOffset,
                startIndexToBeLoaded, dataRowIndexToBeFirst, endIndexToBeLoaded, hasOverflow, tr,
                lastVisibleTR, lastVisibleTRIndex, firstVisibleTRIndex, rowsHtml,
                newFirstVisibleRow, start, end, displayContainerScrollTop, avgRowHeight, maxScrollPos;

            //I.I. bug fix for 107870
            if (args.owner.id() !== this.grid.id()) {
                return;
            }

            if (this.options.groupedColumns.length === 0) {
                return true;
            }
            scrollData = args.scrollData;
            scrollResult = args.scrollResult;
            virtualScrollerY = scrollData.virtualScrollerY;
            deltaScroll = scrollData.deltaScroll;
            tableId = '#' + this.element[0].id;
            visibleArea = scrollData.visibleArea;
            tbody = $(tableId + ' > tbody');
            expandedRowsHeight = 0;
            tableId = '#' + this.element[0].id;
            trs = $(tableId + " > tbody > tr[data-container='true']");
            for (i = 0; i < trs.length; i++) {
                expandedRowsHeight += $(trs[i]).outerHeight();
            }
            if (expandedRowsHeight > 0) {
                scrollerHeight = this.grid._getScrollContainerHeight();
                this.grid._setScrollContainerHeight(scrollerHeight - expandedRowsHeight);
            }
            //next virtual page needed
            if (deltaScroll > 0 && scrollResult.action === "SA_NEED_NEXT_PAGE") {
                //get first visble TR
                firstVisibleTR = this.grid._getFirstVisibleTR(visibleArea);
                //get first visible TR offset relative to visible area
                firstVisibleTRRelativeOffset = Math.abs(firstVisibleTR[0].offsetTop - visibleArea.top);
                //first loaded data row becomes the row which was first visble before
                startIndexToBeLoaded = parseInt(firstVisibleTR.attr('data-row-idx'), 0);
                dataRowIndexToBeFirst = startIndexToBeLoaded;
                endIndexToBeLoaded = parseInt(this._virtualRowCount, 0) + startIndexToBeLoaded - 1;
                hasOverflow = false;
                if (endIndexToBeLoaded > this._groupedRows.length - 1) {
                    endIndexToBeLoaded = this._groupedRows.length - 1;
                    startIndexToBeLoaded = endIndexToBeLoaded - this._virtualRowCount + 1;
                    hasOverflow = true;
                }
                tbody.empty();
                rowsHtml = '';
                for (i = startIndexToBeLoaded; i <= endIndexToBeLoaded; i++) {
                    rowsHtml += this._groupedRows[i];
                }
                tbody.html(rowsHtml);
                if (hasOverflow) {
                    tr = $(tableId + " > tbody > tr[data-row-idx='" + dataRowIndexToBeFirst + "']");
                    firstVisibleTRRelativeOffset = tr[0].offsetTop + firstVisibleTRRelativeOffset;
                }
                //scroll to where last visible row was and add the new scrolling
                this.grid._setDisplayContainerScrollTop(firstVisibleTRRelativeOffset + deltaScroll);
            }
            //prev virtual page needed
            if (deltaScroll < 0 && scrollResult.action === "SA_NEED_PREV_PAGE") {
                //get last visible tr -> lastTR
                lastVisibleTR = this.grid._getLastVisibleTR(visibleArea);
                lastVisibleTRIndex = parseInt(lastVisibleTR.attr('data-row-idx'), 0);
                firstVisibleTR = this.grid._getFirstVisibleTR(visibleArea);
                firstVisibleTRIndex = parseInt(firstVisibleTR.attr('data-row-idx'), 0);
                //get its offset
                //lastVisibleTRRelativeOffset = visibleArea.bottom - lastVisibleTR[0].offsetTop;
                //get its data index
                endIndexToBeLoaded = lastVisibleTRIndex;
                startIndexToBeLoaded = endIndexToBeLoaded - parseInt(this._virtualRowCount, 0) + 1;
                //TODO: if start is < 0, recalc
                if (startIndexToBeLoaded < 0) {
                    startIndexToBeLoaded = 0;
                    endIndexToBeLoaded = startIndexToBeLoaded + this._virtualRowCount - 1;
                }
                //rebind from dataIndex - this._virtualRowsCount to dataIndex
                tbody.empty();
                rowsHtml = '';
                for (i = startIndexToBeLoaded; i <= endIndexToBeLoaded; i++) {
                    rowsHtml += this._groupedRows[i];
                }
                tbody.html(rowsHtml);
                tableId = '#' + this.element[0].id;
                newFirstVisibleRow = $(tableId + ' > tbody > tr[data-row-idx="' + firstVisibleTRIndex + '"]');
                this.grid._setDisplayContainerScrollTop(newFirstVisibleRow[0].offsetTop + deltaScroll);
            }
            if (scrollResult.action === "SA_NEED_SOME_PAGE") {
                start = Math.floor(virtualScrollerY / this._avgRowHeight);
                end = start + this._virtualRowCount - 1;
                if (start < 0) {
                    start = 0;
                    end = start + this._virtualRowCount - 1;
                }
                if (end >= this._groupedRows.length - 1) {
                    end = this._groupedRows.length - 1;
                    start = end - this._virtualRowCount + 1;
                }
                tbody.empty();
                rowsHtml = '';
                for (i = start; i <= end; i++) {
                    rowsHtml += this._groupedRows[i];
                }
                tbody.html(rowsHtml);
                displayContainerScrollTop = 0;
                maxScrollPos = this.grid._getScrollContainerHeight() - this.grid._getDisplayContainerHeight();
                if (maxScrollPos - 3 <= virtualScrollerY && virtualScrollerY <= maxScrollPos + 3) {
                    displayContainerScrollTop = 10000;
                }
                this.grid._setDisplayContainerScrollTop(displayContainerScrollTop);
            }
            if (this._addScrollHeight) {
                scrollerHeight = this.grid._getScrollContainerHeight();
                this.grid._setScrollContainerHeight(scrollerHeight - this._addScrollHeight);
                this.grid.element.height('');
            }
            avgRowHeight = this.grid._calculateAvgRowHeight();
            if (avgRowHeight > this._avgRowHeight) {
                this._avgRowHeight = avgRowHeight;
                //this._setScrollContainerHeight(avgRowHeight * this.dataSource.dataView().length);
            }
            return false;
        }
    });
    $.extend($.ui.igGridGroupBy, { version: '14.1.20141.2249' });
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid Column Hiding 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery, window, document */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}
(function ($) {
	/*
		igGridHiding summary
	*/
	$.widget("ui.igGridHiding", {
		options: {
			/* type="array" A list of column settings that specifies hiding options on a per column basis. */
			columnSettings: [
				{
					/* type="string" Column key. this is a required property in every column setting if columnIndex is not set. */
					columnKey: null,
					/* type="number" Column index. Can be used in place of column key. the preferred way of populating a column setting is to always use the column keys as identifiers. */
					columnIndex: null,
					/* type="bool" Allows the column to be hidden. */
					allowHiding: true,
					/* type="bool" Sets the initial visibility of the column. */
					hidden: false
				}
			],
			/* type="int" The width in pixels of the hidden column indicator in the header. */
			hiddenColumnIndicatorHeaderWidth: 7,
			/* type="string" Controls containment behavior. 
				owner type="string" The column chooser dialog will be draggable only in the grid area
				window type="string" The column chooser dialog will be draggable in the whole window area
			*/
			columnChooserContainment: "owner",
			/* type="number" The default column chooser width in pixels. */
			columnChooserWidth: 350,
			/* type="number" The default column chooser height in pixels. */
			columnChooserHeight: '',
			/* type="number" The duration of the dropdown animation in milliseconds. */
			dropDownAnimationDuration: 500,
			/* type="string" The caption of the column chooser dialog. */
			columnChooserCaptionText: $.ig.GridHiding.locale.columnChooserCaptionLabel,
			/* type="string" The text used in the drop down tools menu(Feature Chooser) to launch the column chooser dialog. */
			columnChooserDisplayText: $.ig.GridHiding.locale.columnChooserDisplayText,
			/* type="string" The text displayed in the tooltip of the hidden column indicator. */
			hiddenColumnIndicatorTooltipText: $.ig.GridHiding.locale.hiddenColumnIndicatorTooltipText,
			/* type="string" The text used in the drop down tools menu(Feature Chooser) to hide a column. */
			columnHideText: $.ig.GridHiding.locale.columnHideText,
			/* type="string" The text used in the column chooser to show column */
			columnChooserShowText: $.ig.GridHiding.locale.columnChooserShowText,
			/* type="string" The text used in the column chooser to hide column */
			columnChooserHideText: $.ig.GridHiding.locale.columnChooserHideText,
			/* type="bool" Specifies on click show/hide directly to be shown/hidden columns. If columnChooserHideOnClick is false then Apply and Cancel Buttons are shown on the bottom of modal dialog. Columns are Shown/Hidden after the Apply button is clicked */
			columnChooserHideOnClick: false,
			/* type="string" Text label for reset button. */
			columnChooserResetButtonLabel: $.ig.GridHiding.locale.columnChooserResetButtonLabel,
			/* type="number" Specifies time of milliseconds for animation duration to show/hide modal dialog */
			columnChooserAnimationDuration: 200,
			// M.H. 9 March 2012 Fix for bug #103978
			/* type="string" Specifies text of button which apply changes in modal dialog */
			columnChooserButtonApplyText: $.ig.GridHiding.locale.columnChooserButtonApplyText,
			/* type="string" Specifies text of button which cancel changes in modal dialog */
			columnChooserButtonCancelText: $.ig.GridHiding.locale.columnChooserButtonCancelText
		},
		css: {
			/* Classes applied to the column chooser element */
			"columnChooser": "ui-dialog ui-draggable ui-resizable ui-iggrid-dialog ui-widget ui-widget-content ui-corner-all",
			/* Classes applied to the column chooser dialog header caption area */
			"columnChooserHeaderCaption": "ui-dialog-titlebar ui-iggrid-columnchooser-caption ui-widget-header ui-corner-top ui-helper-reset ui-helper-clearfix",
			/* Classes applied to the column chooser dialog header caption title */
			"columnChooserHeaderCaptionTitle": "ui-dialog-title ui-iggrid-columnchooser-caption-title",
			/* Classes applied to the column chooser dialog content */
			"columnChooserContent": "ui-dialog-content ui-iggrid-columnchooser-content",
			/* Classes applied to the hiding header icon */
			"hidingHeaderIndicator": "ui-iggrid-hiding-indicator",
			/* Classes applied to the column chooser handlebar at the bottom */
			"columnChooserHandleBar": "ui-iggrid-columnchooser-handlebar",
			/* Classes applied to the hidden column indicator in the header */
			"hiddenColumnIndicator": "ui-iggrid-hiding-hiddencolumnindicator",
			/* Classes applied to the hidden column indicator in the header when it is selected(user has clicked and the dropdown is visible) */
			"hiddenColumnIndicatorSelected": "ui-iggrid-hiding-indicator-selected",
			/* Classes applied to the hidden column indicator in the header when the mouse is over it */
			"hiddenColumnIndicatorMouseOver": "ui-iggrid-hiding-indicator-mouseover",
			/* Classes applied to the hidden columns dropdown div */
			"hiddenColumnsDropDown": "ui-iggrid-hiding-dropdown-dialog ui-widget ui-widget-content ui-corner-all",
			/* Classes applied to the hidden columns dropdown ul */
			"hiddenColumnsDropDownList": "ui-iggrid-hiding-dropdown-list ui-menu",
			/* Classes applied to the hidden columns dropdown li*/
			"hiddenColumnsDropDownItem": "ui-iggrid-hiding-dropdown-ddlistitemicons ui-state-default",
			/* Classes applied to the hidden columns dropdown li when hovered */
			"hiddenColumnsDropDownItemHover": "ui-iggrid-hiding-dropdown-listitem-hover ui-state-active ui-state-hover",
			/* Classes applied to the hidden columns dropdown span inside the li */
			"hiddenColumnsDropDownItemText": "ui-iggrid-hiding-dropdown-ddlistitemtext",
			/* Classes applied to list(which shows all columns) in column chooser */
			"columnChooserListItems": "ui-iggrid-columnchooser-listitems",
			/* Classes applied to list item(which shows single column) in column chooser */
			"columnChooserItem": "ui-iggrid-columnchooser-item ui-widget-content",
			/* Classes applied to list item(which shows single column) in column chooser when column is hidden */
			"columnChooserItemHidden": "ui-iggrid-columnchooser-itemhidden",
			/* Classes applied to hide button in list item(which shows single column) in column chooser */
			"columnChooserHideButton": "ui-iggrid-columnchooser-hidebutton",
			/* Classes applied to show button in list item(which shows single column) in column chooser */
			"columnChooserItemText": "ui-iggrid-dialog-text",
			/* Classes applied to the feature chooser icon for hiding feature */
			"featureChooserHidingIcon": "ui-icon ui-iggrid-icon-hide",
			/* Classes applied to the feature chooser icon for column chooser feature */
			"featureChooserModalDialogIcon": "ui-icon ui-iggrid-icon-column-chooser"
		},
		events: {
			/* cancel="true" event fired before a hiding operation is executed.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnIndex to get the hidden column index. Has a value only if the column's key is a number.
			Use ui.columnKey to get the hidden column key. Has a value only if the column's key is a string.
			*/
			columnHiding: "columnHiding",
			/* event fired when trying to hide all columns in fixed or unfixed area.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnKeys array of column keys. Has a value only if the column's key is a string.
			*/
			columnHidingRefused: "columnHidingRefused",
			/* event fired when trying to show column(s) in fixed area and total width of fixed are will be larger than whole grid width.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnKeys array of column keys. Has a value only if the column's key is a string.
			*/
			columnShowingRefused: "columnShowingRefused",
			/* cancel="true" event fired before a hiding operation is executed.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnKeys to get array of the hidden column keys. In case when click on Reset button in column chooser then this is an array of column keys.
			*/
			multiColumnHiding: "multiColumnHiding",
			/* event fired after the hiding has been executed and results are rendered.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnIndex to get the hidden column index. Has a value only if the column's key is a number.
			Use ui.columnKey to get the hidden column key. Has a value only if the column's key is a string.
			*/
			columnHidden: "columnHidden",
			/* cancel="true" event fired before a showing operation is executed.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnIndex to get the shown column index.
			Use ui.columnKey to get the shown column key.
			*/
			columnShowing: "columnShowing",
			/* event fired after the showing has been executed and results are rendered.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnIndex to get the shown column index.
			Use ui.columnKey to get the shown column key.
			*/
			columnShown: "columnShown",
			/* cancel="true" event fired before the column chooser is opened.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnChooserElement to get a reference to the Column Chooser element. This is a jQuery object.
			*/
			columnChooserOpening: "columnChooserOpening",
			/* event fired after the column chooser is already opened.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnChooserElement to get a reference to the Column Chooser element. This is a jQuery object.
			*/
			columnChooserOpened: "columnChooserOpened",
			/* event fired every time the column chooser changes its position.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnChooserElement to get a reference to the Column Chooser element. This is a jQuery object.
			Use ui.originalPosition to get the original position of the column chooser div as { top, left } object, relative to the page.
			Use ui.position to get the current position of the column chooser div as { top, left } object, relative to the page.
			*/
			columnChooserMoving: "columnChooserMoving",
			/* cancel="true" event fired before the column chooser is closed.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnChooserElement to get a reference to the Column Chooser element. This is a jQuery object.
			*/
			columnChooserClosing: "columnChooserClosing",
			/* event fired after the column chooser has been closed.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnChooserElement to get a reference to the Column Chooser element. This is a jQuery object.
			*/
			columnChooserClosed: "columnChooserClosed",
			/* cancel="true" event fired before the contents of the column chooser are rendered.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnChooserElement to get a reference to the Column Chooser element. This is a jQuery object.
			*/
			columnChooserContentsRendering: "columnChooserContentsRendering",
			/* event fired after the contents of the column chooser are rendered.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnChooserElement to get a reference to the Column Chooser element. This is a jQuery object.
			*/
			columnChooserContentsRendered: "columnChooserContentsRendered",
			/* event fired when button Apply in column chooser is clicked
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnChooserElement to get a reference to the Column Chooser element. This is a jQuery object.
			Use ui.columnsToShow to get array of columns identifiers which should be shown
			Use ui.columnsToHide to get array of columns identifiers which should be hidden
			*/
			columnChooserButtonApplyClick: "columnChooserButtonApplyClick",
			/* event fired when button Reset in column chooser is clicked
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridHiding widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnChooserElement to get a reference to the Column Chooser element. This is a jQuery object.
			*/
			columnChooserButtonResetClick: "columnChooserButtonResetClick"
		},
		renderInFeatureChooser: true,
		_headerHashDataKey: "igGrid-hiding-hash",
		_createWidget: function (options, element) {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			this.options.columnSettings = [];
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		_setOption: function (key, value) {
			throw new Error($.ig.Grid.locale.optionChangeNotSupported + ' ' + key);
			// handle new settings and update options hash
			//$.Widget.prototype._setOption.apply(this, arguments);
		},
		destroy: function () {
			/* destroys the hiding widget */
			var fc, self = this,
				modalDialog = $('#' + this.grid.id() + '_hiding_modalDialog');
			this.grid.element.unbind(".hiding");
			this.grid.headersTable()
				.find("thead > tr > th")
				.not("[data-skip=true]")
				.each(function () {
					var th = $(this);
					th.find("a[data-hiding-indicator=true]").remove();

					self._clearHiddenColumnIndicator(true, th);
					self._clearHiddenColumnIndicator(false, th);
				});
			//remove dropdown elements
			$("div[data-hiding-inddropdown='" + this.grid.id() + "']").remove();
			//remove the column chooser element
			this.grid.element.unbind('iggridheadercellrendered', this._headerCellRenderedHandler);
			this.grid.element.unbind('iggridvirtualhorizontalscroll', this._virtualHorizontalScrollHandler);
			this.grid.element.unbind('iggriduidirty', this._uiDirtyHandler);
			this.grid.element.unbind('iggridheaderrendered', this._headerRenderedHandler);
			this.grid.element.unbind('iggrid_columnsmoved', this._columnsMovedHandler);
			modalDialog.igGridModalDialog('getCaptionButtonContainer');
			modalDialog.remove();
			fc = this.grid.element.data('igGridFeatureChooser');
			if (fc && this.renderInFeatureChooser) {
				fc._removeFeature('Hiding');
				fc._removeFeature('ColumnChooser');
			}
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		showColumnChooser: function () {
			/* Shows the Column Chooser dialog. If it is visible the method does nothing. */
			this._openColumnChooser(false);
		},
		hideColumnChooser: function () {
			/* Hides the Column Chooser dialog. If it is not visible the method does nothing. */
			this._closeColumnChooser(false);
		},
		showColumn: function (column, isMultiColumnHeader) {
			/* Shows a hidden column. If the column is not hidden the method does nothing.
			paramType="number|string" An identifier for the column. If a number is provided it will be used as a column index else if a strings is provided it will be used as a column key.
			paramType="bool" optional="true" If it is true then the column is of type multicolumnheader. An identifier for the column should be of type string.
			*/
			var i, colToShow, len, arrIds = [];
			if (isMultiColumnHeader === true) {
				colToShow = this.grid._getMultiHeaderColumnById(column);
				if (colToShow === null) {
					return;
				}
				len = colToShow.children.length;
				for (i = 0; i < len; i++) {
					arrIds.push(colToShow.children[i].key);
				}
				this.showMultiColumns(arrIds);
				colToShow.hidden = false;
				colToShow.colspan = len;
			} else {
				this.grid.showColumn(column);
			}
		},
		hideColumn: function (column, isMultiColumnHeader) {
			/* Hides a visible column. If the column is hidden the method does nothing.
			paramType="number|string" An identifier for the column. If a number is provided it will be used as a column index else if a strings is provided it will be used as a column key.
			paramType="bool" optional="true" If it is true then the column is of type multicolumnheader. An identifier for the column should be of type string.
			*/
			var i, colToHide, len, arrIds = [];
			if (isMultiColumnHeader === true) {
				colToHide = this.grid._getMultiHeaderColumnById(column);
				if (colToHide === null) {
					return;
				}
				len = colToHide.children.length;
				for (i = 0; i < len; i++) {
					arrIds.push(colToHide.children[i].key);
				}
				this.hideMultiColumns(arrIds);
				colToHide.hidden = true;
				colToHide.colspan = 0;
			} else {
				this.grid.hideColumn(column);
			}
		},
		hideMultiColumns: function (columns) {
			/* Hides visible columns specified by the array. If the column is hidden the method does nothing.
			paramType="array" An array of identifiers for the columns. If a number is provided it will be used as a column index else if a strings is provided it will be used as a column key.
			*/
			var i, columnsLength = columns.length;

			for (i = 0; i < columnsLength; i++) {
				this.grid.hideColumn(columns[i]);
			}
		},
		showMultiColumns: function (columns) {
			/* Show visible columns specified by the array. If the column is shown the method does nothing.
			paramType="array" An array of identifiers for the columns. If a number is provided it will be used as a column index else if a strings is provided it will be used as a column key.
			*/
			var i, columnsLength = columns.length;

			for (i = 0; i < columnsLength; i++) {
				this.grid.showColumn(columns[i]);
			}
		},
		_showColumnFromUI: function (column) {
			var columnKey,
				columnIndex,
				noCancel, self = this;

			if (typeof column === 'number') {
				columnIndex = column;
			} else {
				columnKey = column;
			}
			noCancel = this._trigger(this.events.columnShowing, null, { owner: this, columnKey: columnKey, columnIndex: columnIndex });
			if (!this.grid._isShowingAllowed([column])) {
				this._trigger(this.events.columnShowingRefused, null, { owner: this, columnKeys: [columnKey] });
				return false;
			}
			if (noCancel) {
				// M.H. 16 June 2014 Fix for bug #173154: columnHidden/columnShown events are triggered before the column is actually detached/attached to the DOM
				self.grid._loadingIndicator.show();
				setTimeout(function () {
					self.grid._setHidden(column, false);
					self._trigger(self.events.columnShown, null, {owner: self, columnKey: columnKey, columnIndex: columnIndex});
					self.grid._loadingIndicator.hide();
				}, 0);
			}
			return noCancel;
		},
		_setHiddenMultipleColumns: function (columnsToShow, columnsToHide) {
			// first it should be processed columnsToShow then columnsToHide
			// if columnsToHide is processed first then it will not be hidden all of them, because it will not hide the column because it will be shown at least 1 column
			var self = this,
				columnKey,
				columnIndex;
			self.grid._loadingIndicator.show();
			setTimeout(function () {
				var i, column, noCancel;
				for (i = 0; i < columnsToShow.length; i++) {
					column = columnsToShow[i];
					if (typeof column === 'number') {
						columnIndex = column;
					} else {
						columnKey = column;
					}
					noCancel = self._trigger(self.events.columnShowing, null, {owner: self, columnKey: columnKey, columnIndex: columnIndex});
					if (noCancel) {
						self.grid._setHidden(column, false);
					}
					self._trigger(self.events.columnShown, null, { owner: self, columnKey: columnKey, columnIndex: columnIndex });
				}
				for (i = 0; i < columnsToHide.length; i++) {
					column = columnsToHide[i];
					if (self.grid._visibleColumns().length === 1) {
						//hiding the last column through the UI should be forbidden
						break;
					}
					if (typeof column === 'number') {
						columnIndex = column;
					} else {
						columnKey = column;
					}
					noCancel = self._trigger(self.events.columnHiding, null, {owner: self, columnKey: columnKey, columnIndex: columnIndex});
					if (noCancel) {
						self.grid._setHidden(column, true);
						self._trigger(self.events.columnHidden, null, { owner: self, columnKey: columnKey, columnIndex: columnIndex });
					}
				}
				self.grid._loadingIndicator.hide();
			}, 0);
		},
		_hideMultiColumnFromUI: function (id) {
			var i, self = this,
				column,
				children,
				columnKey,
				childrenLength,
				noCancel,
				visibleChildrenLength = 0,
				columnKeysToHide = [],
				columnKeysHidden = [];

			if (self.grid._visibleColumns().length === 1) {
				//hiding the last column through the UI should be forbidden
				return false;
			}
			// M.H. 4 July 2012 Fix for bug #116254 - column indentifier should be string
			column = this.grid._getMultiHeaderColumnById(id);
			if (column === null) {
				return;
			}
			children = column.children;
			childrenLength = children.length;
			for (i = 0; i < childrenLength; i++) {
				if (!children[i].hidden) {
					visibleChildrenLength++;
				}
			}
			if (self.grid._visibleColumns().length - visibleChildrenLength < 1) {
				//hiding the last column through the UI should be forbidden
				return false;
			}
			for (i = 0; i < childrenLength; i++) {
				columnKeysToHide.push(children[i].key);
			}
			if (!this.grid._isHidingAllowed(columnKeysToHide)) {
				this._trigger(this.events.columnHidingRefused, null, { owner: this, columnKeys: columnKeysToHide});
				return false;
			}
			noCancel = this._trigger(this.events.multiColumnHiding, null, {owner: this, columnKeys: columnKeysToHide});
			if (noCancel) {
				self.grid._loadingIndicator.show();
				setTimeout(function () {
					for (i = 0; i < childrenLength; i++) {
						columnKey = columnKeysToHide[i];
						noCancel = self._trigger(self.events.columnHiding, null, { owner: self, columnKey: columnKey, columnIndex: undefined });
						if (noCancel) {
							if (children[i].allowHiding && !children[i].hidden) { //
								self.grid._setHidden(columnKey, true);
								columnKeysHidden.push(columnKey);
								self._trigger(self.events.columnHidden, null, { owner: self, columnKey: columnKey, columnIndex: undefined });
							}
						}
					}
					column.hidden = true;
					column.colspan = 0;
					self.grid._loadingIndicator.hide();
					self._trigger(self.events.multiColumnHidden, null, { owner: self, columnKeys: columnKeysHidden });
				}, 0);
			}
		},
		_columnFixed: function (args) {
			this._renderHiddenColumnIndicators();
		},
		_hideColumnFromUI: function (column) {
			var self = this,
				columnKey,
				columnIndex,
				noCancel;

			if (self.grid._visibleColumns().length === 1) {
				//hiding the last column through the UI should be forbidden
				return false;
			}
			if (typeof column === 'number') {
				columnIndex = column;
			} else {
				columnKey = column;
			}
			if (!this.grid._isHidingAllowed([column])) {
				this._trigger(this.events.columnHidingRefused, null, { owner: this, columnKeys: [columnKey] });
				return;
			}
			noCancel = this._trigger(this.events.columnHiding, null, {owner: this, columnKey: columnKey, columnIndex: columnIndex});
			if (noCancel) {
				// M.H. 15 Aug 2013 Fix for bug #149344: When the grid has multi-column headers, the columns do not have widths and the height is defined hiding a column misaligns the grid.
				if (!self.grid._allColumnWidthsInPixels && $.ig.util.isFF) {
					self.grid._refreshUI();
				}
				// M.H. 16 June 2014 Fix for bug #173154: columnHidden/columnShown events are triggered before the column is actually detached/attached to the DOM
				self.grid._loadingIndicator.show();
				setTimeout(function () {
					self.grid._setHidden(column, true);
					self._trigger(self.events.columnHidden, null, {owner: self, columnKey: columnKey, columnIndex: columnIndex});
					self.grid._loadingIndicator.hide();
				}, 0);
			}
			return noCancel;
		},
		_headerCellRendered: function (event, ui) {
			//prevent handling of other grids' events in the case of hierarchical grid
			if (ui.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}
			if (ui.isMultiColumnHeader === true) {
				return;
			}
			var i,
				col,
				featureChooserInstance = this.grid.element.data('igGridFeatureChooser');
			if (!this._featureChooserInitialized) {
				this._featureChooserInitialized = true;
				this._hidingIconColumnKeys = [];
				for (i = 0; i < this.grid.options.columns.length; i++) {
					col = this.grid.options.columns[i];
					if (this._getColumnSettingsByIndex(i).allowHiding) {
						if (featureChooserInstance._shouldRenderInFeatureChooser(col.key) === true) {
							featureChooserInstance._renderInFeatureChooser(
								col.key,
								{
									name: 'Hiding',
									text: this.options.columnHideText,
									iconClass: this.css.featureChooserHidingIcon,
									// M.H. 10 Oct. 2011 Fix for bug #89761 - hiding should not be selectable - on click item should not change its state
									isSelectable: false,
									isSelected: false, //if the column is hidden by default the feature chooser for this column will not be visible too
									method: $.proxy(this._featureChooserHide, this),
									updateOnClickAll: false,
									groupName: 'click',
									groupOrder: 2,
									order: 2
								}
							);
							featureChooserInstance._renderInFeatureChooser(
								col.key,
								{
									name: 'ColumnChooser',
									text: this.options.columnChooserDisplayText,
									iconClass: this.css.featureChooserModalDialogIcon,
									method: $.proxy(this._featureChooserColumnChooser, this),
									groupName: 'modaldialog',
									groupOrder: 3,
									order: 1
								}
							);
						} else {
							this._hidingIconColumnKeys.push(col.key);
						}
					}
				}
			}
		},
		_featureChooserHide: function (event, columnKey, isSelected) {
			this._closeColumnChooser(true);
			//we can't show a column from here so isSelected doesn't matter
			this._hideColumnFromUI(columnKey);
		},
		_featureChooserColumnChooser: function (event, columnKey, isSelected) {
			this._openColumnChooser(true);
		},
		_columnMap: function () {
			var self = this;
			/* function used by the FeatureChooser */
			return $.map(this.grid.options.columns, function (col, index) {
				return { "columnKey": col.key, "enabled": self._getColumnSettingsByIndex(index).allowHiding };
			});
		},
		_renderHidingColumnIcon: function (th, columnKey, isMultiColumnHeader) {
			var self = this,
				indicatorContainer = th.find('.ui-iggrid-indicatorcontainer');

			if (indicatorContainer.length === 0) {
				indicatorContainer = $('<div></div>').addClass('ui-iggrid-indicatorcontainer').appendTo(th);
			}
			$("<span>&laquo;</span>")
				.addClass(this.css.hidingHeaderIndicator)
				.appendTo(indicatorContainer)
				.wrap($('<a></a>')
					.css('display', 'inline')
					.attr('data-hiding-indicator', 'true')
					.attr('href', '#')
					.attr('title', $.ig.GridHiding.locale.hideColumnIconTooltip))
				.bind("click.hiding", function (event) {
					//L.A. 19 March 2012. Fixed bug 105173 Showing a hidden column makes the header's hover state stay forever
					$(this).parent().mouseout();
					self._closeColumnChooser(true);
					if (isMultiColumnHeader) {
						self._hideMultiColumnFromUI(th.attr('data-mch-id'));
					} else {
						self._hideColumnFromUI(columnKey);
					}
					event.preventDefault();
					event.stopPropagation();
				});
			// M.H. 19 Sep 2013 Fix for bug #152681: The header text and feature icon are rendered on two rows in the header.
			this.grid._enableHeaderCellFeature(th);
		},
		_populateMultiColumnHeadersLevel0: function () {
			var i, j, self = this, cols = this.grid._oldCols, colsLength = cols.length, ths = $(this.grid._headerCells),
				level0 = [], level0Length, visibleColumns = this.grid._visibleColumns();
			for (i = 0; i < colsLength; i++) {
				if (cols[i].level === 0) {
					level0.push(cols[i]);
				} else {
					for (j = 0; j < cols[i].children.length; j++) {
						level0.push(cols[i].children[j]);
					}
				}
			}
			level0Length = level0.length;
			ths.each(function (index) {
				var th = $(this),
					col = visibleColumns[index],
					cs;
				if (col === null || col === undefined) {
					return true;
				}
				cs = self._getColumnSettingsByKey(col.key);
				if (cs.allowHiding) {
					for (i = 0; i < level0.length; i++) {
						if (level0[i].key === col.key) {
							break;
						}
					}
					if (i < level0Length) {
						level0[i].allowHiding = true;
						level0[i].visibleIndex = index;
						level0[i].settings = cs;
					}
					th.col = level0[i];
				}
			});
		},
		_renderHidingIcons: function () {
			var thsMultiHeader, self = this,
				ths;
			// M.H. 11 June 2012 Fix for bug #113740
			if (self.grid._isMultiColumnGrid === true) {
				thsMultiHeader = this.grid.headersTable().find("> thead > tr th").not("[data-skip=true]").not("[data-isheadercell=true]");
				this._populateMultiColumnHeadersLevel0();
				thsMultiHeader.each(function (index) {
					var th = $(this);
					self._renderHidingColumnIcon(th, null, true);
				});
				// M.H. 10 Aug 2012 Fix for bug #118771
				ths = $(this.grid._headerCells);//$($.grep(this.grid._headerCells, function (elem) {return $(elem).is(':visible');}));//this.grid.headersTable().find("> thead > tr th[data-isheadercell=true]").not("[data-skip=true]");
			} else {
				ths = this.grid.headersTable().find("thead > tr > th").not("[data-skip=true]");
			}
			//clear the old hiding icons
			ths.find("a[data-hiding-indicator=true]").remove();
			ths.each(function (index) {
				var th = $(this),
					visibleColumns = self.grid._visibleColumns(),
					visibleIndex,
					columnKey;
				if (self.grid.options.virtualizationMode === 'fixed' && (self.grid.options.virtualization === true || self.grid.options.columnVirtualization === true)) {
					visibleIndex = (self.grid._startColIndex || 0) + index;
				} else {
					visibleIndex = index;
				}
				columnKey = visibleColumns[visibleIndex].key;
				if ($.inArray(columnKey, self._hidingIconColumnKeys) !== -1) {
					self._renderHidingColumnIcon(th, columnKey);
				}
			});
		},
		_headerRendered: function (event, ui) {
			//prevent handling of other grids' events in the case of hierarchical grid
			if (ui.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}
			this._renderHidingIcons();
			this._renderColumnChooser();
		},
		_columnChooserButtonOKClick: function (e) {
			var self = this, changedColumns = self._columnsToHide,
				columnsToHide = [], columnsToShow = [], noCancel,
				modalDialog = $('#' + this.grid.id() + '_hiding_modalDialog');
			$.each(this.grid.options.columns, function (columnIndex, column) {
				var cs, columnIdentifier, col;
				cs = self._getColumnSettingsByIndex(columnIndex);
				if (!cs.allowHiding) {
					return;
				}
				// if we use _hideColumnFromUI and _showColumnFromUI this will allow us to hide all columns because hiding and showing columns from framework is made async and this.grid._visibleColumns() is not updated properly
				columnIdentifier = cs.columnKey || cs.columnIndex || column.key;
				col = changedColumns[columnIdentifier];
				// M.H. 26 March 2012 Fix for bug #106157
				if (col !== null && col !== undefined) {
					if (col) {
						// M.H. 24 Sep 2012 Fix for bug #122410
						if (column.hidden === false) {
							columnsToHide.push(columnIdentifier);
						}
						//self._hideColumnFromUI(columnIdentifier);
					} else {
						// M.H. 24 Sep 2012 Fix for bug #122410
						if (column.hidden === true) {
							columnsToShow.push(columnIdentifier);
						}
						//self._showColumnFromUI(columnIdentifier);
					}
				}
			});
			noCancel = this._trigger(this.events.columnChooserButtonApplyClick, null, { columnChooserElement: modalDialog, owner: this, columnsToHide: columnsToHide, columnsToShow: columnsToShow });
			if (!this.grid._isHidingAllowed(columnsToHide)) {
				this._trigger(this.events.columnHidingRefused, null, { owner: this, columnKeys: columnsToHide });
				return;
			}
			// M.H. 25 Feb 2014 Fix for bug #165105: When the width of the fixed columns plus the width of the hidden fixed columns is bigger than grid's defined width showing the hidden columns via the column chooser makes the fixed area as big as the grid itself.
			if (!this.grid._isShowingAllowed(columnsToShow)) {
				this._trigger(this.events.columnShowingRefused, null, { owner: this, columnKeys: columnsToShow });
				return;
			}
			if (noCancel) {
				self._setHiddenMultipleColumns(columnsToShow, columnsToHide);
				$('#' + this.grid.id() + '_hiding_modalDialog').igGridModalDialog("closeModalDialog", true);
			}
		},
		isToRenderButtonReset: function () {
			// M.H. 29 March 2012 Fix for bug #107039
			var self = this,
				columnsToHide = self._columnsToHide,
				result = false;
			$.each(this.grid.options.columns, function (columnIndex, column) {
				var cs, columnIdentifier, col, isHidden;
				cs = self._getColumnSettingsByIndex(columnIndex);
				if (cs && !cs.allowHiding) {
					return true;
				}
				// if we use _hideColumnFromUI and _showColumnFromUI this will allow us to hide all columns because hiding and showing columns from framework is made async and this.grid._visibleColumns() is not updated properly
				columnIdentifier = cs.columnKey || cs.columnIndex || column.key;
				col = columnsToHide[columnIdentifier];
				// M.H. 15 Sep 2012 Fix for bug #105514
				if (column._initiallyHidden === true) {
					isHidden = true;
				} else {
					isHidden = cs.hidden;
				}
				// M.H. 26 March 2012 Fix for bug #106157
				if (col !== null && col !== undefined) {
					if (col !== isHidden) {
						result = true;
						return false;//break;
					}
				}
			});
			return result;
		},
		// M.H. 3 April 2012 Fix for bug #106792
		_isVisibleColumnsNotAllowHiding: function () {
			var self = this, res = false;
			$.each(this.grid.options.columns, function (columnIndex, column) {
				var cs;
				cs = self._getColumnSettingsByIndex(columnIndex);
				if (cs && !cs.allowHiding && !column.hidden) {
					res = true;
					return false;
				}
			});
			return res;
		},
		_columnChooserOpening: function (e, args) {
			var $ul, noCancel, $content,
				self = this,
				o = this.options,
				css = this.css,
				countColumnsAllowHiding = 0,
				modalDialog = $('#' + this.grid.id() + '_hiding_modalDialog');

			noCancel = this._trigger(this.events.columnChooserOpening, null, {columnChooserElement: modalDialog, owner: this});
			if (noCancel) {
				noCancel = this._trigger(this.events.columnChooserContentsRendering, null, {columnChooserElement: modalDialog, owner: this});
				if (noCancel) {
					this.removeColumnChooserResetButton();
					$content = modalDialog.igGridModalDialog('getContent');
					$content.empty();
					$ul = $('<ul></ul>')
						.addClass(css.columnChooserListItems)
						.appendTo($content);
					this._columnsToHide = {};
					$.each(this.grid.options.columns, function (columnIndex, column) {
						var cs, columnIdentifier, $a, $li;
						cs = self._getColumnSettingsByIndex(columnIndex);
						if (!cs.allowHiding) {
							return;
						}
						countColumnsAllowHiding++;
						//use the key or index that is in the column settings and if none is present use the column.key
						//by doing this we will trigger the event with the identifier that was used for matching the settings
						columnIdentifier = cs.columnKey || cs.columnIndex || column.key;
						$li = $('<li></li>')
							.attr('id', self.grid.element[0].id + '_' + columnIdentifier + '_columnchooser_li')
							.addClass(css.columnChooserItem)
							.append('<span class="' + css.columnChooserHideButton + '"><a href="#"></a></span><span class="' + css.columnChooserItemText + '">' + column.headerText + '</span>');
						$li.appendTo($ul);
						$a = $li.find('a:first');
						if (o.columnChooserHideOnClick === true) {
							$li
								.bind("click.hiding", function (event) {
									var isHidden;

									if ($a.attr("ishidden") === '1') {
										noCancel = self._showColumnFromUI(columnIdentifier);
										isHidden = false;
									} else {
										noCancel = self._hideColumnFromUI(columnIdentifier);
										isHidden = true;
									}
									if (noCancel) {
										self._renderColumnChooserHideButton($a, isHidden);
									}
									event.preventDefault();
									event.stopPropagation();
									return false;
								});
						} else {
							$li
								.bind("click.hiding", function (event) {
									var isHidden, key, c;
									if ($a.attr("ishidden") === '1') {
										isHidden = false;
									} else {
										isHidden = true;
									}
									// we should check whether it is possible to hide column when it is only one visible column in fixed/unfixed area
									if (isHidden && self.grid.hasFixedColumns()) {
										c = [];
										for (key in self._columnsToHide) {
											if (self._columnsToHide.hasOwnProperty(key) && self._columnsToHide[key]) {
												c.push(key);
											}
										}
										c.push(columnIdentifier);
										if (!self.grid._isHidingAllowed(c)) {
											return;
										}
									}
									// M.H. 26 March 2012 Fix for bug #106089
									// M.H. 3 April 2012 Fix for bug #106792
									if (isHidden &&
											!self._isVisibleColumnsNotAllowHiding() &&
											$ul.find('a[ishidden=1]').length === countColumnsAllowHiding - 1) {
										return;
									}
									self._columnsToHide[columnIdentifier] = isHidden;
									self._renderColumnChooserHideButton($a, isHidden);
									if (self.isToRenderButtonReset()) {
										// M.H. 29 March 2012 Fix for bug #107039
										self.renderColumnChooserResetButton();
									} else {
										self.removeColumnChooserResetButton();
									}
									event.preventDefault();
									event.stopPropagation();
									return false;
								});
						}
						self._columnsToHide[columnIdentifier] = column.hidden;
						self._renderColumnChooserHideButton($a, column.hidden);
					});
					this._trigger(this.events.columnChooserContentsRendered, null, {columnChooserElement: modalDialog, owner: this});
					// M.H. 29 March 2012 Fix for bug #107039
					if (o.columnChooserHideOnClick === false && self.isToRenderButtonReset()) {
						self.renderColumnChooserResetButton();
					}
				}
				this._trigger(this.events.columnChooserOpened, null, {columnChooserElement: modalDialog, owner: this});
			}
			return true;
		},
		resetHidingColumnChooser: function () {
			/* Reset hidden/shown column to initial state of dialog(when it is opened) */
			var self = this;
			$.each(this.grid.options.columns, function (columnIndex, column) {
				var cs, columnIdentifier, isToHide;
				cs = self._getColumnSettingsByIndex(columnIndex);
				if (!cs) {
					return true;
				}
				if (!cs.allowHiding) {
					return true;
				}
				isToHide = cs.hidden;
				// M.H. 15 Sep 2012 Fix for bug #105514
				if (column._initiallyHidden === true) {
					isToHide = true;
				}
				//use the key or index that is in the column settings and if none is pressent use the column.key
				//by doing this we will trigger the event with the identificator that was used for matching the settings
				columnIdentifier = cs.columnKey || cs.columnIndex || column.key;
				// M.H. 29 March 2012 Fix for bug #107039
				self._columnsToHide[columnIdentifier] = isToHide;
				self._renderColumnChooserHideButton($('#' + self.grid.id() + '_' + columnIdentifier + '_columnchooser_li a:first'), isToHide);
			});
			self.removeColumnChooserResetButton();
		},
		renderColumnChooserResetButton: function () {
			// M.H. 29 March 2012 Fix for bug #107039
			var o = this.options,
				self = this,
				resetButtonId = this.grid.id() + '_hiding_modalDialog_reset_button',
				modalDialog = $('#' + this.grid.id() + '_hiding_modalDialog'),
				$captionButtonContainer,
				$resetButton;
			if ($('#' + resetButtonId).length === 0) {
				$captionButtonContainer = modalDialog.igGridModalDialog('getCaptionButtonContainer');
				$resetButton = $('<button></button>')
					.attr('id', resetButtonId)
					.appendTo($captionButtonContainer);
				$resetButton.igButton({
					labelText: o.columnChooserResetButtonLabel,
					click: function (e) {
						self._trigger(self.events.columnChooserButtonResetClick, e, {columnChooserElement: modalDialog, owner: self});
						self.resetHidingColumnChooser();
					}
				});
			}
		},
		removeColumnChooserResetButton: function () {
			/* Remove Reset button in column chooser modal dialog*/
			$('#' + this.grid.id() + '_hiding_modalDialog_reset_button').remove();
		},
		_renderColumnChooserHideButton: function ($a, isHidden) {
			var text, attrIsHidden, css = this.css, $li = $a.closest('li');
			if (isHidden === false) {
				attrIsHidden = '0';
				text = this.options.columnChooserHideText;
				$li.removeClass(css.columnChooserItemHidden);
			} else {
				attrIsHidden = '1';
				text = this.options.columnChooserShowText;
				$li.addClass(css.columnChooserItemHidden);
			}
			$a.attr('ishidden', attrIsHidden).text(text);
		},
		_renderColumnChooser: function () {
			// M.H. 20 Feb 2013 Fix for bug #132371: Hierarchical grid - can not hide a column on a child layout
			$('#' + this.grid.id() + '_hiding_modalDialog').remove();
			var $buttonOK,
				self = this,
				o = this.options,
				$captionButtonContainer,
				containment = this.grid._rootContainer(),
				modalDialog;
			if (this.options.columnChooserContainment !== "owner") {
				containment = 'window';
			}
			modalDialog = $('<div></div>')
					.appendTo(this.grid._rootContainer())
					.attr('id', this.grid.id() + '_hiding_modalDialog');
			modalDialog.igGridModalDialog({
				// M.H. 9 March 2012 Fix for bug #103978
				// M.H. 26 March 2012 Fix for bug #106204
				modalDialogWidth: o.columnChooserWidth,
				modalDialogHeight: o.columnChooserHeight,
				modalDialogCaptionText: o.columnChooserCaptionText,
				buttonApplyText: o.columnChooserButtonApplyText,
				buttonCancelText: o.columnChooserButtonCancelText,
				containment: containment,
				// M.H. 8 May 2012 Fix for bug #110344
				gridContainer: this.grid.container(),
				renderFooterButtons: !o.columnChooserHideOnClick,
				animationDuration: o.columnChooserAnimationDuration,
				modalDialogOpening: function (event, args) {
					self._columnChooserOpening(event, args);
				},
				modalDialogMoving: function (e, ui) {
					self._trigger(self.events.columnChooserMoving, null,
						{
							// M.H. 29 March 2012 Fix for bug #107140
							columnChooserElement: $(e.target),
							owner: self,
							originalPosition: ui.originalPosition,
							position: ui.position
						});
				},
				modalDialogClosing: function (event, args) {
					return self._trigger(self.events.columnChooserClosing, null, {columnChooserElement: modalDialog, owner: self});
				},
				modalDialogClosed: function (event, args) {
					self._trigger(self.events.columnChooserClosed, null, {columnChooserElement: modalDialog, owner: self});
				}
			});
			if (!o.columnChooserHideOnClick) {
				$buttonOK = $('#' + this.grid.id() + '_hiding_modalDialog_footer_buttonok');
				$buttonOK.bind('igbuttonclick', function (e) { self._columnChooserButtonOKClick(e); e.preventDefault(); });
			} else {
				$captionButtonContainer = modalDialog.igGridModalDialog('getCaptionButtonContainer');
				$('<span></span>')
					.bind("click.hiding", function (event) {
						modalDialog.igGridModalDialog('closeModalDialog', true);
						event.preventDefault();
						event.stopPropagation();
						return false;
					})
					.addClass('ui-icon ui-icon-closethick')
					.appendTo(
						$('<a></a>')
							.appendTo($captionButtonContainer)
							.attr('title', $.ig.GridHiding.locale.columnChooserCloseButtonTooltip)
							.attr('href', '#')
							.attr('role', 'button')
							.addClass('ui-dialog-titlebar-close ui-corner-all')
					);
			}
		},
		_hidingFinished: function () {
			if (this.options.virtualization === true && this.options.virtualizationMode === 'fixed') {
				return;
			}
			if (this.options.columnVirtualization === true) {
				return;
			}
			this._renderHiddenColumnIndicators();
		},
		_virtualHorizontalScroll: function () {
			this._renderHiddenColumnIndicators();
			this._renderHidingIcons();
		},
		_getIndicators: function (indicators, isFixed) {
			var i, col, columns = this.grid.options.columns, columnsLength = columns.length,
				visibleIndex = 0, fixed;

			for (i = 0; i < columnsLength; i++) {
				col = columns[i];
				fixed = (col.fixed === true);
				if (fixed !== isFixed) {
					continue;
				}
				if (col.hidden) {
					if (this._getColumnSettingsByIndex(i).allowHiding) {
						//add an indicator for this group of hidden columns
						if (indicators[visibleIndex] === undefined) {
							indicators[visibleIndex] = [];
						}
						indicators[visibleIndex].push(col.key);
					}
				} else {
					visibleIndex++;
				}
			}
			return visibleIndex;
		},
		_renderHiddenColumnIndicators: function () {
			var self = this, ths, visibleIndex = 0, indicators = [], oldDropDowns, fHCells, ufHCells,
				hasFixedColumns = this.grid.hasFixedColumns(), fixedIndicators = [];

			visibleIndex = this._getIndicators(indicators, false);
			if (hasFixedColumns) {
				this._getIndicators(fixedIndicators, true);
			}
			//remove the old dropdowns with a setTimeout so that we give the animation time to finish
			oldDropDowns = this.grid.container().children("div[data-hiding-inddropdown='" + self.grid.id() + "']");
			setTimeout(function () {
				oldDropDowns.remove();
			}, this.options.dropDownAnimationDuration * 2 + 1);
			//all columns are hidden
			if (visibleIndex === 0) {
				this.grid.headersTable().find("thead > tr > th[data-hiddenreplacement=true]")
					.each(function () {
						var a = self._renderHiddenColumnIndicator(true, $(this));
						self._bindDropDownToIndicator(a.find("span"), indicators[0]);
					});
			} else {
				if (this.grid._isMultiColumnGrid) {
					ths = $(this.grid._headerCells);
				} else {
					ths = this.grid.headersTable().find("thead > tr > th").not("[data-skip=true]");
				}
				// when there is at least one fixed column then first we render indicators for unfixed columns, then for the fixed one
				if (hasFixedColumns) {
					if (this.grid._isMultiColumnGrid) {
						fHCells = $();
						ufHCells = $();
						$.each(this.grid._headerCells, function (index, cell) {
							if (self.grid._isFixedElement(cell)) {
								fHCells.push(cell);
							} else {
								ufHCells.push(cell);
							}
						});
						this._renderHiddenColumnIndicatorsHelper(ufHCells, indicators, false);
						this._renderHiddenColumnIndicatorsHelper(fHCells, fixedIndicators, true);
					} else {
						this._renderHiddenColumnIndicatorsHelper(ths, indicators, false);
						ths = this.grid.fixedHeadersTable().find("thead > tr > th").not("[data-skip=true]");
						this._renderHiddenColumnIndicatorsHelper(ths, fixedIndicators, true);
					}
				} else {
					this._renderHiddenColumnIndicatorsHelper(ths, indicators);
				}
			}
		},
		_renderHiddenColumnIndicatorsHelper: function (ths, indicators, isFixed) {
			var self = this;
			ths.each(function (index) {
				var th = $(this), a, visibleIndex;
				if ((self.grid.options.virtualization === true && self.grid.options.virtualizationMode === 'fixed') || self.grid.options.columnVirtualization === true) {
					visibleIndex = self.grid._startColIndex + index;
				} else {
					visibleIndex = index;
				}
				self._clearHiddenColumnIndicator(true, th);
				self._clearHiddenColumnIndicator(false, th);
				if (indicators[visibleIndex] !== undefined) {
					a = self._renderHiddenColumnIndicator(true, th);
					self._bindDropDownToIndicator(a.find("span"), indicators[visibleIndex]);
				}
				//the last th may have an indicator at its end if all columns on the right are hidden
				if (visibleIndex === self.grid._visibleColumns(isFixed).length - 1) {
					if (indicators[visibleIndex + 1] !== undefined) {
						a = self._renderHiddenColumnIndicator(false, th);
						self._bindDropDownToIndicator(a.find("span"), indicators[visibleIndex + 1]);
					}
				}
			});
		},
		_renderHiddenColumnIndicator: function (left, th) {
			var padding,
				margin,
				nonPaddedIndicatorsAttr,
				position,
				indicatorMarkup,
				spanMarkup,
				paddingValue,
				div,
				a,
				span;
			if (left) {
				padding = "padding-left";
				margin = "margin-left";
				position = "left";
				indicatorMarkup = "<div data-hiddencolindicator='left' />";
				spanMarkup = "<span data-nonpaddedindicator='left'></span>";
				nonPaddedIndicatorsAttr = "[data-nonpaddedindicator=left]";
			} else {
				padding = "padding-right";
				margin = "margin-right";
				position = "right";
				indicatorMarkup = "<div data-hiddencolindicator='right' />";
				spanMarkup = "<span data-nonpaddedindicator='right'></span>";
				nonPaddedIndicatorsAttr = "[data-nonpaddedindicator=right]";
			}
			//increase padding
			paddingValue = parseInt(th.css(padding), 10) + this.options.hiddenColumnIndicatorHeaderWidth;
			th.css(padding, paddingValue + 'px');
			//update the margin of all indicator that should not be affected by padding
			th.find(nonPaddedIndicatorsAttr).css(margin, -paddingValue + 'px');
			div = $(indicatorMarkup)
				.css("position", "relative")
				.css("width", "100%")
				.css("height", "0px")
				.css("top", "0px")
				.css("left", "0px")
				.prependTo(th);
			a = $("<a href='#' />")
				.attr("title", this.options.hiddenColumnIndicatorTooltipText)
				.prependTo(div);
			span = $(spanMarkup)
				//A.Y. bug #89113.
				//For some odd reason in IE we need to have title on the span as well.
				.attr("title", this.options.hiddenColumnIndicatorTooltipText)
				// M.H. 10 Sep 2013 Fix for bug #151643: When you tap on a hiding indicator feature chooser opens and then hiding dropdown on a mobile device.
				.attr("data-skip-event", "true")
				.css('position', 'absolute')
				.css(margin, -paddingValue + 'px')
				.css(position, '0px')
				.css('width', this.options.hiddenColumnIndicatorHeaderWidth + 'px')
				.addClass(this.css.hiddenColumnIndicator)
				.appendTo(a);
			//A.Y. bug #107365. On IE7 there is a bug with overflow:hidden not working correctly
			//when we have abosulte positioned children. So we need to size the indicator to not overflow.
			if ($.ig.util.isIE7) {
				span.css({
					'top': -parseInt(th.css('padding-top'), 10),
					'height': th.innerHeight()
				});
			}
			return a;
		},
		_clearHiddenColumnIndicator: function (left, th) {
			var padding, paddingValue, indicatorSelector, indicator;
			if (left) {
				padding = "padding-left";
				indicatorSelector = "div[data-hiddencolindicator=left]";
			} else {
				padding = "padding-right";
				indicatorSelector = "div[data-hiddencolindicator=right]";
			}
			indicator = th.find(indicatorSelector);
			if (indicator.length !== 0) {
				indicator.remove();
				//decrease padding
				paddingValue = parseInt(th.css(padding), 10);
				th.css(padding, (paddingValue - this.options.hiddenColumnIndicatorHeaderWidth) + 'px');
			}
		},
		_bindDropDownToIndicator: function (button, columnKeys) {
			var self = this,
				dropDown = this._renderDropDown(button, columnKeys);
			// M.H. 19 May 2012 Fix for bug #111585
			dropDown.find('ul').bind({
				blur: function (e) {
					self._toggleDropDown(button, dropDown, true);
				}
			});
			button.parent().bind({
				mousedown: function (e) {
					self._toggleDropDown(button, dropDown, false);
					e.preventDefault();
					e.stopPropagation();
				},
				mouseover: function (e) {
					if (button.attr("data-indicator-selected") !== 'true') {
						button.addClass(self.css.hiddenColumnIndicatorMouseOver);
					}
				},
				mouseout: function (e) {
					button.removeClass(self.css.hiddenColumnIndicatorMouseOver);
				},
				mouseup: function (e) { e.preventDefault(); e.stopPropagation(); },
				click: function (e) { e.preventDefault(); e.stopPropagation(); }
			});
		},
		_renderDropDown: function (button, columnKeys) {
			var self = this, dropDown, list;
			dropDown = $("<div data-hiding-inddropdown='" + this.grid.id() + "'></div>")
				.css('position', 'absolute')
				.css('display', 'none')
				.addClass(this.css.hiddenColumnsDropDown)
				.appendTo(this.grid._rootContainer());
			list = $('<ul tabindex="0"></ul>').addClass(this.css.hiddenColumnsDropDownList).appendTo(dropDown);
			$.each(columnKeys, function (index, columnKey) {
				$('<li></li>')
					.addClass(self.css.hiddenColumnsDropDownItem)
					.bind({
						mouseover: function (e) {
							$(e.currentTarget).addClass(self.css.hiddenColumnsDropDownItemHover);
						},
						mouseout: function (e) {
							$(e.currentTarget).removeClass(self.css.hiddenColumnsDropDownItemHover);
						},
						mousedown: function (e) {
							self._closeColumnChooser(true);
							self._showColumnFromUI(columnKey);
							self._toggleDropDown(button, dropDown, true);
						}
					})
					.append(
						$('<span></span>')
							.addClass(self.css.hiddenColumnsDropDownItemText)
							.text(self.grid.columnByKey(columnKey).headerText)
					)
					.appendTo(list);
			});
			$('<a></a>')
				.appendTo($("<li></li>").appendTo(list))
				.igButton({
					labelText: this.options.columnChooserDisplayText,
					mousedown: function (event) {
						// M.H. 26 March 2012 Fix for bug #106195
						if (event.target) {
							setTimeout(function () {$(event.target).removeClass('ui-state-active'); }, 0);
						}
						self._openColumnChooser(true);
						self._toggleDropDown(button, dropDown, true);
					}
				});
			return dropDown;
		},
		_toggleDropDown: function (button, dropDown, isCalledFromBlur) {
			var th, rOffset,
				isLast,
				offset,
				left,
				isVisible = (dropDown.is(':visible') === true),
				self = this;
			if ((dropDown.data('isAnimating') === true) ||
					(isVisible === false && isCalledFromBlur === true)) {
				return;
			}
			if (!isVisible) {
				th = button.closest('th');
				isLast = button.closest('div').attr('data-hiddencolindicator') === 'right';
				// M.H. 9 Nov 2012 Fix for bug #115306
				offset = $.ig.util.offset(th);
				if (isLast) {
					left = offset.left + th.outerWidth() - dropDown.outerWidth();
					left = Math.max(0, left);
				} else {
					left = offset.left;
				}
				rOffset = $.ig.util.getRelativeOffset(dropDown);
				dropDown.css('top', offset.top + th.outerHeight() - rOffset.top);
				dropDown.css('left', left - rOffset.left);
			}
			dropDown.data('isAnimating', true);
			dropDown.toggle(this.options.dropDownAnimationDuration, function () {
				if (dropDown.is(':visible') === true) {
					// M.H. 19 May 2012 Fix for bug #111585
					dropDown.find('ul').focus();
					button.addClass(self.css.hiddenColumnIndicatorSelected);
					button.attr("data-indicator-selected", "true");
				} else {
					button.removeClass(self.css.hiddenColumnIndicatorSelected);
					button.removeAttr("data-indicator-selected");
				}
				dropDown.data('isAnimating', false);
			});
		},
		_openColumnChooser: function (fireEvents) {
			var modalDialog = $('#' + this.grid.id() + '_hiding_modalDialog');
			modalDialog.igGridModalDialog('openModalDialog');
		},
		_closeColumnChooser: function (fireEvents) {
			var modalDialog = $('#' + this.grid.id() + '_hiding_modalDialog');
			modalDialog.igGridModalDialog('closeModalDialog');
		},
		_columnChooserMove: function (e, ui) {
			this._trigger(this.events.columnChooserMoving, null,
				{
					columnChooserElement: e.target,
					owner: this,
					originalPosition: ui.originalPosition,
					position: ui.position
				});
		},
		_getColumnSettings: function (index, key) {
			var i, foundByIndex;
			for (i = 0; i < this.options.columnSettings.length; i++) {
				if (this.options.columnSettings[i].columnKey === key) {
					return this._mergeColumnSettingsDefaults(this.options.columnSettings[i]);
				}
				if (this.options.columnSettings[i].columnIndex === index) {
					foundByIndex = this.options.columnSettings[i];
				}
			}
			//fallback to the column settings found by index
			return this._mergeColumnSettingsDefaults(foundByIndex);
		},
		_getColumnSettingsByIndex: function (index) {
			var key = this.grid.options.columns[index].key;
			return this._getColumnSettings(index, key);
		},
		_getColumnSettingsByKey: function (key) {
			var i;
			for (i = 0; i < this.grid.options.columns.length; i++) {
				if (this.grid.options.columns[i].key === key) {
					return this._getColumnSettings(i, key);
				}
			}
		},
		_mergeColumnSettingsDefaults: function (columnSettings) {
			var defaults = {
					'allowHiding': true,
					'hidden': false
				},
				copy = $.extend({}, columnSettings),
				key;
			for (key in defaults) {
				if (defaults.hasOwnProperty(key) &&
						typeof copy[key] !== "boolean") {
					copy[key] = defaults[key];
				}
			}
			return copy;
		},
		_columnsMoved: function () {
			var self = this;
			this.grid.headersTable()
				.find("thead > tr > th")
				.not("[data-skip=true]")
				.each(function () {
					var th = $(this);
					self._clearHiddenColumnIndicator(true, th);
					self._clearHiddenColumnIndicator(false, th);
				});
			this._renderHiddenColumnIndicators();
		},
		_injectGrid: function (gridInstance, isRebind) {
			var i, j, cs, col;
			this.grid = gridInstance;
			if (this._headerCellRenderedHandler !== null && this._headerCellRenderedHandler !== undefined) {
				this.grid.element.unbind('iggridheadercellrendered', this._headerCellRenderedHandler);
			}
			if (this._headerRenderedHandler !== null && this._headerRenderedHandler !== undefined) {
				this.grid.element.unbind('iggridheaderrendered', this._headerRenderedHandler);
			}
			if (this._virtualHorizontalScrollHandler !== null && this._virtualHorizontalScrollHandler !== undefined) {
				this.grid.element.unbind('iggridvirtualhorizontalscroll', this._virtualHorizontalScrollHandler);
			}
			if (this._columnsMovedHandler !== null && this._columnsMovedHandler !== undefined) {
				this.grid.element.unbind('iggrid_columnsmoved', this._columnsMovedHandler);
			}

			this._headerRenderedHandler = $.proxy(this._headerRendered, this);
			this._headerCellRenderedHandler = $.proxy(this._headerCellRendered, this);
			this._virtualHorizontalScrollHandler = $.proxy(this._virtualHorizontalScroll, this);
			this._columnsMovedHandler = $.proxy(this._columnsMoved, this);
			// register for headerCellRendered	
			this.grid.element.bind('iggridheadercellrendered', this._headerCellRenderedHandler);
			// register for headerRendered	
			this.grid.element.bind('iggridheaderrendered', this._headerRenderedHandler);
			this.grid.element.bind('iggridvirtualhorizontalscroll', this._virtualHorizontalScrollHandler);
			this.grid.element.bind('iggrid_columnsmoved', this._columnsMovedHandler);
			//instantiate igGridFeatureChooser
			if (this.grid.element.igGridFeatureChooser !== undefined) {
				this.grid.element.igGridFeatureChooser();
			} else {
				throw new Error($.ig.GridHiding.locale.featureChooserNotReferenced);
			}
			//apply hidden column settings
			for (i = 0; i < this.options.columnSettings.length; i++) {
				cs = this.options.columnSettings[i];
				if (typeof cs.hidden === 'boolean') {
					if (typeof cs.columnKey  === 'string') {
						col = this.grid.columnByKey(cs.columnKey);
					} else if (typeof cs.columnIndex === 'number') {
						col = this.grid.options.columns[cs.columnIndex];
					}
					if (col !== undefined && col !== null) {
						// M.H. 12 Nov 2012 Fix for bug #126924
						// M.H. 12 Dec 2012 Fix for bug #129334
						// M.H. 26 Mar 2013 Fix for bug #137831: If you rebind the grid after you show initially hidden column the cells of that column disappear and the other columns are shifted.
						if (col.hidden === undefined ||
							(cs.hidden === true && col.hidden !== col._initiallyHidden && col._initiallyHidden !== true)) {
							col.hidden = cs.hidden;
						}
					} else if (this.grid._isMultiColumnGrid === true && cs.columnKey !== null && cs.columnKey !== undefined) {
						// M.H. 12 Dec 2012 Fix for bug #129344
						col = this.grid._getMultiHeaderColumnById(cs.columnKey);
						if (col !== undefined && col !== null && col.children) {
							for (j = 0; j < col.children.length; j++) {
								col.children[j].hidden = cs.hidden;
							}
						}
					}
				}
			}
		}
	});
	$.extend($.ui.igGridHiding, {version: '14.1.20141.2249'});
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Hierarchical Grid 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.dataSource.js
 *	infragistics.ui.shared.js
 *	infragistics.util.js
 *	infragistics.ui.grid.framework.js
 */

/*global jQuery */
(function ($) {

	$.widget("ui.igHierarchicalGrid", {
		// check the parent path. the path has the following format PrimaryKeyID/ChildKeyID1/childKeyID2[band_name]. for example an empty key gives the root grid
		// a key of "1[0]" specifies the first child band of the second root row, a key of "1[0]/2[0]" specifies the first child band of the third child row of the 
		// first band of the second parent row. 
		// a key can also have the format "1[0]/3" which gives the third data row element of the first child band of the second root row. 
		css: {
			/* classes that are applied to the expander column TD */
			expandColumn: "ui-iggrid-expandcolumn",
			/* classes applied when the TD in which the expand/collapse indicator is located, is currently in expand state */
			expandColumnExpanded: "ui-iggrid-expandcolumn-expanded",
			/* classes applied to the expand button SPAN, when it's collapsed */
			expandButton: "ui-iggrid-expandbutton ui-icon-plus",
			/* classes applied to a collapsed expand button span, when it's hovered */
			expandButtonHover: "ui-iggrid-expandbuttonhover ui-icon-plus ui-state-hover",
			/* classes applied to an expanded expand button span, when it's hovered */
			expandButtonExpandedHover: "ui-iggrid-expandbuttonexpandedhover ui-icon-plus ui-state-hover",
			/* classes applied to the expand button SPAN, when it's expanded */
			expandButtonExpanded: "ui-iggrid-expandbutton ui-iggrid-expandbuttonexpanded ui-icon-minus",
			/* classes applied to the expand button SPAN, when it's clicked */
			expandButtonClick: "ui-iggrid-expandbuttonclick ui-icon-plus",
			/* classes applied to the child grid TD container when it is expanded */
			childGridArea: "ui-iggrid-childarea",
			/* classes applied to the child grid TD container when it's collapsed */
			childGridAreaCollapsed: "ui-iggrid-childarea-collapsed",
			/* classes applied to the special header cell  TH which is for the expand column */
			expandHeaderCell: "ui-iggrid-expandheadercell ui-iggrid-header ui-widget-header",
			/* classes applied to the SPAN holding the expand header cell icon */
			expandHeaderCellTriangle: "ui-icon ui-icon-triangle-1-se",
			/* classes applied to the root grid's table element */
			root: "ui-iggrid-root",
			/* achieves a "dotted-line" effect in between two child grids, excluding first and last ones */
			childGridSeparator: "ui-iggrid-childgridseparator"
		},
		// the options listed here are only specific to the hierarchical grid. All other options that are exposed by the flat grid, will be copied automatically
		// such as width, height, fixedHeaders, etc. 
		options: {
			// specific hierarchical grid options go here. everything else gets merged with the flat grid CSS (meaning root level)
			// even though this widget *does not extend* the flat grid
			/* type="number" Only the first level will be data-bound initially. Also serves as "render" depth, meaning that depending on this prop, the grid will */
			initialDataBindDepth: -1,
			/* type="number" No levels will be automatically expanded when the widget is instantiated for the first time */
			initialExpandDepth: -1,
			/* type="bool" If true, encodes all requests using OData conventions and the $expand syntax */
			odata: false,
			/* type="bool" If true, load on demand will be achieved using REST compliant resource access with appropriate url-s for
				the ajax GET calls. */
			rest: false,
			/* type="number" Specifies the limit on the number of levels to bind to */
			maxDataBindDepth: -1,
			/* type="string" Specifies the default property in the response where children will be located */
			defaultChildrenDataProperty: "children",
			/* type="bool" if true, will autogenerate all layouts assuming default values for "childrenDataProperty" 
				When autoGenerateLayouts is enabled, it will automatically generate all columns recursively. (all columns on all levels)
			*/
			autoGenerateLayouts: false,
			/* type="bool" applies a linear animation - either expanding or collapsing depending on the parent row state */
			expandCollapseAnimations: true,
			/* type="number" Specifies the expand column width */
			expandColWidth: 30,
			/* type="string" Specifies the delimiter for constructing paths , for hierarchical lookup of data */
			pathSeparator: "/",
			/* type="number" The row expanding/collapsing animation duration in ms. */
			animationDuration: 500,
			/* type="string" Specifies the default tooltip applied to an expand column cell, that is currently collapsed */
			expandTooltip: $.ig.Grid.locale.expandTooltip,
			/* type="string" Specifies the default tooltip applied to an expand column cell, that is currently expanded */
			collapseTooltip: $.ig.Grid.locale.collapseTooltip,
			/* type="array" An array of column objects */
			columns: [
			],
			/* type="object" List of columnLayout objects that specify the structure of the child grids. All options that are applicable to a flat grid are also applicable here */
			columnLayouts: [
				{
					/* type="string" Specifies the columnLayout key. This is the property that holds the data records for the current column layout. */
					key: null,
					/* type="string" Specifies the primaryKey of the columnLayout. This also serves as the column key for the current column layout. */
					primaryKey: null,
					/* type="string" specifies the foreignKey of the columnLayout. This is also the column key of the parent grid. */
					foreignKey: null
				}
			]
			// all options for the flat grid are also applicable here
		},
		events: {
			/* cancel="true" Event which is fired when a hierarchical row is about to be expanded
				use args.owner to access the hierarchical grid object
				use args.parentrow to access the row element for the row that's about to be expanded
			*/
			rowExpanding : "rowExpanding",
			/* Event which is fired after a hierarchical row has been expanded 
				use args.owner to access the hierarchical grid object
				use args.parentrow to access the row element for the row that was expanded
			*/
			rowExpanded : "rowExpanded",
			/* cancel="true" Event which is fired when a hierarchical row is about to be collapsed 
				use args.owner to access the hierarchical grid object
				use args.parentrow to access the row element for the row that's about to be collapsed
			*/
			rowCollapsing : "rowCollapsing",
			/* Event which is fired when a hierarchical row has been collapsed 
				use args.owner to access the hierarchical grid object
				use args.parentrow to access the row element for the row that was collapsd
			*/
			rowCollapsed : "rowCollapsed",
			/* cancel="true" Event which is fired when children are about to be populated (Load on demand)
				use args.owner to access the hierarchical grid object
				use args.parentrow to access the row element for the row that's about to be populated
				use args.id to get the data ID of the row 
			*/
			childrenPopulating: "childrenPopulating",
			/* Event which is fired when children have been populated (Load on demand) 
				use args.owner to access the hierarchical grid object
				use args.parentrow to access the row element for the row that was populated
				use args.id to get the data ID of the row 
			*/
			childrenPopulated: "childrenPopulated",
			/*
				event fired before a child grid is going to be created, allows the developer to override the child grid creation 
				cancel="true"
			*/
			childGridCreating: "igchildgridcreating",
			/*
				event fired after a child grid is created
				cancel="false"
			*/
			childGridCreated: "igchildgridcreated"
		},
		_setOption: function (key, value) {
			// handle new settings and update options hash
			// delegate to the flat root grid
			if (key === "dataSource") {
				this.options.dataSource = value;
				this.dataBind();
			} else if (key === "initialDataBindDepth" || key === "initialExpandDepth" || key === "expandColWidth") {
				throw new Error($.ig.Grid.locale.optionChangeNotSupported + ' ' + key);
			}
			if (key === "odata" || key === "defaultChildrenDataProperty" || key === "expandTooltip" || key === "collapseTooltip" ||
					key === "autoGenerateLayouts" || key === "expandCollapseAnimations" || key === "animationDuration") {
				$.Widget.prototype._setOption.apply(this, arguments);
			} else if (this.rootWidget() && key !== "dataSource") {
				this.rootWidget()._setOption(key, value);
			}
		},
		_create: function () {
			// bind to the headerRendered event for the root grid, as well as dataRendering
			this._regevents(this.element, this);
			// the options need to be merged with the flat grid's *default* options. all child layouts inherit the default flat grid's options
			// we need to ensure we strip all dummy column definitions, before the widget is created
			$.ui.igGrid.prototype.options.columns = [];
			$.ui.igGrid.prototype.options.features = [];
			this.options = $.extend(true, {}, $.ui.igGrid.prototype.options, this.options);
			if (this.tmpDataSource !== null && this.tmpDataSource !== undefined) {
				this.options.dataSource = this.tmpDataSource;
				this._originalOptions.dataSource = this.tmpDataSource;
			}

			//hGrid supports continous virtualiztion only
			if (this.options.virtualization === true) {
				this.options.virtualizationMode = 'continuous';
			}

			// we need to data-bind the hierarchical data source, and then create recursively child grids where appropriate, 
			// and bind the child data to them 
			this._eventQueue = [];
			this._animationQueue = [];
			this.dataBind();
			// multicolumn headers could be set only for some of the column layouts
			this.rootWidget()._isMultiColumnGrid = this._checkIsMultiColumnHeader(this.options);
		},
		_createWidget: function (options, element) {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			this.options.columns = [];
			this.options.features = [];
			this.options.columnLayouts = [];
			if (options.dataSource && ($.type(options.dataSource) === "array" || $.type(options.dataSource) === "object")) {
				this.tmpDataSource = options.dataSource;
				options.dataSource = null;
				// later we would need to restore the data source to the original external options object
				this._originalOptions = options;
			}
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		dataBind: function () {
			/* Data binds the hierarchical grid. No child grids will be created or rendered by default, unless there is initialExpandDepth >= 0 set. 
			*/
			var hds, hdsoptions, rootds, opts;
			//this._parseLayouts();
			// auto generate layouts
			if (this.options.autoGenerateLayouts) {
				this._generateLayouts();
			}
			hdsoptions = this._hdsoptions();
			hds = new $.ig.HierarchicalDataSource(hdsoptions);
			// do not data-bind the hierarchical data source. Instead "ask" it to generate options for the respective sources
			// such as the root one
			//hds.dataBind();
			this._hds = hds;
			// create the root level grid
			// two ways, pass the root ds instance, or the dynamically generated options object 
			rootds = this._hds.root();
			this._tmpds = this.options.dataSource;
			this.options.dataSource = null;
			opts = $.extend(true, {}, this.options);
			this.options.dataSource = this._tmpds;
			this._tmpds = null;
			opts.dataSource = rootds;
			if ($.type(hdsoptions.dataSource) === "string") {
				opts.dataSourceUrl = hdsoptions.dataSource;
			}
			if (!this._columnsGeneratedHandler) {
				this._columnsGeneratedHandler = $.proxy(this._columnsGenerated, this);
			} else {
				this.element.unbind("iggridcolumnsgenerated", this._columnsGeneratedHandler);
			}
			this.element.bind('iggridcolumnsgenerated', this._columnsGeneratedHandler);
			// bind to the databound event so that we can auto generate the layouts if that option is enabled
			if (this.options.autoGenerateLayouts === true) {
				if (!this._databoundHandler) {
					this._databoundHandler = $.proxy(this._layouts, this);
				} else {
					this.element.unbind("iggridcolumnsgenerated", this._databoundHandler);
				}
				this.element.bind('iggriddatarendering', this._databoundHandler);
			}
			// used for initialExpandDepth, in order to start expanding and creating child grids once the root one has been rendered
			//this._renderedHandler = $.proxy(this._handleBatchExpandRender, this);
			//this.element.bind('iggriddatarendered', this._renderedHandler);
			//}
			//mark the element with a special class specifying that it's the hierarchical grid root
			this.element.addClass(this.css.root);
			this.element.attr("data-level", 0);
			// M.H. 14 June 2012 Fix for bug #114327
			opts._isHierarchicalGrid = true;
			if (this._root) {
				this._root.igGrid('option', 'dataSource', opts.dataSource);
			} else {
				if (this.options.autoGenerateLayouts === true) {
					opts._recurseSchema = true;
				}
				this._root = this.element.igGrid(opts);
			}
			// init loading indicator
			if (this.rootWidget().container().data("igLoading")) {
				this.indicator = this.rootWidget().container().data("igLoading").indicator();
			} else {
				this.indicator = this.rootWidget().container().igLoading().data("igLoading").indicator();
			}
			this._regToggleEvent(this.element, this);
		},
		// auto generation of layouts
		_generateLayouts: function () {
			var rec, i, ds = this.options.dataSource;
			if (($.type(ds) !== "array" && $.type(ds) !== "object") || ds.length === 0) {
				return;
			}
			if ($.type(ds) === "object" && this.options.responseDataKey) {
				ds = ds[this.options.responseDataKey] || ds;
			}
			for (i = 0; i < ds.length; i++) {
				rec = ds[i];
				this._generateLayout(rec, this.options);
			}
		},
		_generateLayout: function (record, options) {
			var name, layout, tmpLayout, i, rec, hasRespKey = false;
			for (name in record) {
				if (record.hasOwnProperty(name) && ($.type(record[name]) === "array" ||
					($.type(record[name]) === "object" && options.responseDataKey && $.type(record[name][options.responseDataKey]) === "array"))) {
					rec = record[name];
					if (options.responseDataKey && $.type(rec) === "object") {
						if (rec[options.responseDataKey] && $.type(rec[options.responseDataKey]) === "array") {
							rec = rec[options.responseDataKey];
							hasRespKey = true;
						} else {
							continue;
						}
					}
					layout = {key: name, childrenDataProperty: name, columnLayouts: [] };
					if (hasRespKey) {
						layout.responseDataKey = options.responseDataKey;
					}
					// check if the layout exists. Needs to be recursive. 
					tmpLayout = this._layoutExistsRecursive(this.options, name);
					if (!tmpLayout) {
						if (options.columnLayouts === undefined || options.columnLayouts === null) {
							options.columnLayouts = [];
						}
						options.columnLayouts.push(layout);
					} else {
						layout = tmpLayout;
					}
					if (rec.length > 0) {
						for (i = 0; i < rec.length; i++) {
							this._generateLayout(rec[i], layout);
						}
					}
				}
			}
		},
		_layoutExistsRecursive: function (options, key) {
			var i, tmpLayout = null;
			tmpLayout = options.key === key ? options : tmpLayout;
			if (!tmpLayout) {
				for (i = 0; options.columnLayouts && i < options.columnLayouts.length; i++) {
					tmpLayout = this._layoutExistsRecursive(options.columnLayouts[i], key);
					if (tmpLayout) {
						break;
					}
				}
			}
			return tmpLayout;
		},
		root: function () {
			/* returns the element of the root grid (igGrid)
				returnType="object" jquery wrapped element of the root grid
			*/
			return this._root;
		},
		rootWidget: function () {
			/* returns the widget object of the root grid (igGrid)
				returnType="object" widget object of the root igGrid (not igHierarchicalGrid)
			*/
			return this.root().data('igGrid');
		},
		allChildrenWidgets: function () {
			/* returns a flat list of all child grid widgets (not elements) - recursive
				returnType="object"
			*/
			return this.root().find(".ui-iggrid-table").map(function () {
				return $(this).data("igGrid");
			});
		},
		allChildren: function () {
			/* returns a flat list of all child grid elements (recursive)
				returnType="object"
			*/
			return this.root().find(".ui-iggrid-table");
		},
		toggle: function (element) {
			/* expands or collapses (toggles) a parent row
				paramType="dom" accepts a dom element, or a jquery wrapped dom element that should be a TR and should specify a parent row
			*/
			this._toggleInternal({target: $(element).find(".ui-iggrid-expandcolumn")}, true);
		},
		expand: function (id) {
			/* expands (toggles) a parent row
				paramType="dom" accepts a dom element, or a jquery wrapped dom element that should be a TR and should specify a parent row
			*/
			// if there is load on demand we need to use toggleInternal
			if (!this.populated(id)) {
				this._toggleInternal({target: $(id).find(".ui-iggrid-expandcolumn")}, true);
			} else {
				this._expand(id, true);
			}
		},
		_expand: function (id, suppressEvents) {
			var tr = $(id), c, noCancel = true, handler, emptystr = "", rootgrid;
			if (!suppressEvents) {
				noCancel = this._trigger(this.events.rowExpanding, null, {owner: this, parentrow: tr});
			}
			rootgrid = this._rootgrid || this.element.closest(".ui-iggrid-root").data('igHierarchicalGrid');
			if (noCancel) {
				// M.H. 4 Dec 2013 Fix for bug #159045: Cannot expand row which was previously canceled from exapnsion on rowExpanding event
				if (this.options.expandCollapseAnimations) {
					if (rootgrid._animationQueue[tr.attr('data-id') + emptystr] === true) {
						return; // animation in progress
					}
					rootgrid._animationQueue[tr.attr('data-id') + emptystr] = true;
				}
				c = tr.find('.ui-iggrid-expandcolumn');
				tr.next().css('display', '').css('visibility', 'visible');
				if (this.options.expandCollapseAnimations) {
					if (!suppressEvents) {
						handler = this._expandend;
					} else {
						handler = this._expandendnoevents;
					}
					tr.next().find("> td > div").slideDown(this.options.animationDuration, handler);
				} else {
					tr.next().find("> td > div").show();
					c.addClass(this.css.expandColumnExpanded).find('.ui-iggrid-expandbutton')
						.removeClass(this.css.expandButton).addClass(this.css.expandButtonExpanded)
						.attr('title', this.options.collapseTooltip);
					if (!suppressEvents) {
						this._rowExpanded({owner: this, parentrow: tr});
						this._trigger(this.events.rowExpanded, null, {owner: this, parentrow: tr});
					}
				}
				tr.attr('state', 'e');
				tr.next().children().first().removeClass(this.css.childGridAreaCollapsed).addClass(this.css.childGridArea);
			}
		},
		expanded: function (element) {
			/* checks if a parent row is expanded or not
				paramType="dom" accepts a dom element, or a jquery wrapped dom element that should be a TR and should specify a parent row
				returnType="bool" specifies if the row is currently expanded or collapsed
			*/
			var $e = element.length !== undefined ? element : $(element);
			if ($e === null || $e === undefined) {
				return false;
			}
			if ($e.attr('state') !== 'e' || $e.attr('state') === undefined) {
				return false;
			}
			return true;
		},
		_expandendnoevents: function (ctx) {
			var expcell, expcellspan, rootgrid, $this = ctx ? $(ctx) : $(this),
				prow = $this.closest('tr[data-container]').prev(), emptystr = "";
			
			rootgrid = this._rootgrid || $this.closest(".ui-iggrid-root").data('igHierarchicalGrid');
			expcell = $this.closest('[data-container=true]').prev().find('.ui-iggrid-expandcolumn');
			expcellspan = expcell.find('.ui-iggrid-expandbutton');
			expcell.addClass(rootgrid.css.expandColumnExpanded);
			expcellspan.removeClass(rootgrid.css.expandButton)
				.addClass(rootgrid.css.expandButtonExpanded).attr('title', rootgrid.options.collapseTooltip);
			if (rootgrid._animationQueue[prow.attr('data-id') + emptystr] === true) {
				delete rootgrid._animationQueue[prow.attr('data-id') + emptystr];
			}
		},
		_expandend: function () {
			// child td
			var $this = $(this), rootgrid, prow = $this.closest('tr[data-container]').prev(),
				parentGrid = prow.closest(".ui-iggrid-table").data("igGrid");
			rootgrid = this._rootgrid || $this.closest(".ui-iggrid-root").data('igHierarchicalGrid');
			rootgrid._expandendnoevents(this);
			// L.A. 30 October 2012 - Fixing bug #122750 - When a hierarchical child grid has a vertical scrollbar, 
			// expanding a row in it causes its header cells to be misaligned with the records
			parentGrid._adjustLastColumnWidth(false);
			rootgrid._rowExpanded({owner: rootgrid, parentrow: prow});
			rootgrid._trigger(rootgrid.events.rowExpanded, null, {owner: rootgrid, parentrow: prow});
		},
		_collapseendnoevents: function (ctx) {
			var expcell, expcellspan, rootgrid, $this = ctx ? $(ctx) : $(this), ctd = $this.closest('.ui-iggrid-childarea'),
				prow = $this.closest('tr[data-container]').prev(), emptystr = "";
			
			rootgrid = this._rootgrid || $this.closest(".ui-iggrid-root").data('igHierarchicalGrid');
			ctd.removeClass(rootgrid.css.childGridArea).addClass(rootgrid.css.childGridAreaCollapsed);
			ctd.closest('tr').css('display', 'none').css('visibility', 'hidden');
			expcell = $this.closest('[data-container=true]').prev().find('.ui-iggrid-expandcolumn');
			expcellspan = expcell.find('.ui-iggrid-expandbutton');
			expcell.removeClass(rootgrid.css.expandColumnExpanded);
			expcellspan.removeClass(rootgrid.css.expandButtonExpanded)
				.addClass(rootgrid.css.expandButton).attr('title', rootgrid.options.expandTooltip);
			if (rootgrid._animationQueue[prow.attr('data-id') + emptystr] === true) {
				delete rootgrid._animationQueue[prow.attr('data-id') + emptystr];
			}
		},
		_collapseend: function () {
			var $this = $(this), rootgrid, prow = $this.closest('tr[data-container]').prev(),
				parentGrid = prow.closest(".ui-iggrid-table").data("igGrid");
			rootgrid = this._rootgrid || $this.closest(".ui-iggrid-root").data('igHierarchicalGrid');
			rootgrid._collapseendnoevents(this);
			// L.A. 30 October 2012 - Fixing bug #122750 - When a hierarchical child grid has a vertical scrollbar, 
			// expanding a row in it causes its header cells to be misaligned with the records
			parentGrid._adjustLastColumnWidth(false);
			rootgrid._trigger(rootgrid.events.rowCollapsed, null, {owner: rootgrid, parentrow: prow});
		},
		collapse: function (id) {
			/* collapses a parent row
				paramType="dom" accepts a dom element, or a jquery wrapped dom element that should be a TR and should specify a parent row
			*/
			this._collapse(id, true);
		},
		_collapse: function (id, suppressEvents) {
			var tr = $(id), c, noCancel = true, handler, emptystr = "", rootgrid;
			if (!suppressEvents) {
				noCancel = this._trigger(this.events.rowCollapsing, null, {owner: this, parentrow: tr});
			}
			rootgrid = this._rootgrid || this.element.closest(".ui-iggrid-root").data('igHierarchicalGrid');
			if (noCancel) {
				// M.H. 4 Dec 2013 Fix for bug #159045: Cannot expand row which was previously canceled from exapnsion on rowExpanding event
				if (this.options.expandCollapseAnimations) {
					if (rootgrid._animationQueue[tr.attr('data-id') + emptystr] === true) {
						return; // animation in progress
					}
					rootgrid._animationQueue[tr.attr('data-id') + emptystr] = true;
				}
				c = tr.find('.ui-iggrid-expandcolumn');
				if (this.options.expandCollapseAnimations) {
					if (!suppressEvents) {
						handler = this._collapseend;
					} else {
						handler = this._collapseendnoevents;
					}
					this._rowCollapsed({owner: this, parentrow: tr});
					tr.next().find("> td > div").slideUp(this.options.animationDuration, handler);
				} else {
					tr.next().find("> td > div").hide();
					tr.next().children().first().removeClass(this.css.childGridArea).addClass(this.css.childGridAreaCollapsed);
					tr.next().css('display', 'none').css('visibility', 'hidden');
					c.find('.ui-iggrid-expandbutton').removeClass(this.css.expandButtonExpanded)
						.addClass(this.css.expandButton).attr('title', this.options.expandTooltip);
					if (!suppressEvents) {
						this._rowCollapsed({owner: this, parentrow: tr});
						this._trigger(this.events.rowCollapsed, null, {owner: this, parentrow: tr});
					}
				}
				tr.attr('state', 'c');
			}
		},
		collapsed: function (element) {
			/* checks if a parent row is currently collapsed 
				paramType="dom" accepts a dom element, or a jquery wrapped dom element that should be a TR and should specify a parent row
				returnType="bool" returns a boolean value indicating if the parent row specified by the "element" is currently collapsed or expanded 
			*/
			var $e = element.length !== undefined ? element : $(element);
			if ($e === null || $e === undefined) {
				return true;
			}
			if ($e.attr('state') === 'c' || $e.attr('state') === undefined) {
				return true;
			}
			return false;
		},
		/*
		// this may be not possible to implement due to the architecture of the grid
		// assuming if there are features, they need to encode the url, and this only happens 
		// once the grid is created after a data source url is assigned to it
		populate: function (element, suppressEvents) { 
		
		},
		*/
		populated: function (element) {
			/* checks if a parent row is populated with data
				paramType="dom" accepts a dom element, or a jquery wrapped dom element that should be a TR and should specify a parent row
				returnType="bool" returns a boolean value indicating if the parent row's child grids are populated and created
			*/
			var $e = element.length !== undefined ? element : $(element);
			if ($e === null || $e === undefined) {
				return false;
			}
			if ($e.attr('c') === 'true') {
				return true;
			}
			return false;
		},
		_mouseOver: function (event) {
			$(event.target).addClass(this.css.expandButtonHover);
		},
		_mouseOut: function (event) {
			$(event.target).removeClass(this.css.expandButtonHover).addClass(this.css.expandButton);
		},
		_toggleInternalWithDelay: function (event) {
			var self = this;
			//Fixing bug #130025
			// valueChanged in the igEditor doesn't fire when you modify cell when initalDataBindDepth is set to 2
			setTimeout(function () { self._toggleInternal(event);}, 0);
			// M.H. 20 June 2014 Fix for bug #174049: igHierarchicalGrid LoadOnDemand is not working for the second child layout
			event.stopImmediatePropagation();
		},
		_toggleInternal: function (event, suppressEvents) {
			var created = $(event.target).closest('tr').attr('c'), tr = $(event.target).closest('tr'),
				p = tr.find('.ui-iggrid-expandcolumn'), hgrid = this, x, y, isExpand, instanceOfDs,
				expandTout = this.options.virtualization === true ? 50 : 0;
			isExpand = $(event.target).hasClass("ui-iggrid-expandbutton") || $(event.target).children(".ui-iggrid-expandbutton").length > 0;
			// start loading indicator if the child grids aren't created yet
			if (!created && this.options.initialDataBindDepth === -1 && isExpand) { // if there is load on demand, we don't need explicit async, since it's async anyway. 
				// we want the indicator to be positioned below the parent row
				// M.H. 1 Nov 2013 Fix for bug #156657: New loading indicator isn't well positioned when used for hiearchical grid expand row scenario
//				x = tr.offset().left;
//				y = p.offset().top;
//				this.indicator._indicator.css('left', x + tr.width() / 2).css('top', y + p.height() / 3 - 4);
				// M.H. 6 Nov 2013 Fix for bug #156657: New loading indicator isn't well positioned when used for hiearchical grid expand row scenario
				this.indicator.refreshPos();
				// hide the expand indicator for a while
				// if the loading indicator is shown on chrome and safari, text selection appears randomly on all child layouts. Couldn't find a way
				// to resolve this any other way
				if (!$.ig.util.isWebKit) {
					p.find('.ui-iggrid-expandbutton').css('visibility', 'hidden');
					this.indicator.show(false);
				} else {
					// M.H. 19 Nov 2013 Fix for bug #156657: New loading indicator isn't well positioned when used for hiearchical grid expand row scenario
					this.indicator.show(false);
				}
				// Async, don't block the UI
				// L.A. 05 November 2012 - Fixing bug #113718 
				// When continuous virtualization is in use, the loading indicator is not displayed while expanding a row
				setTimeout(function () {
					hgrid._toggleInternalAsync(event, suppressEvents);
				}, expandTout);
			} else {
				// L.A. 03 January 2012 - Fixing bug #130025
				// valueChanged in the igEditor doesn't fire when you modify cell when initalDataBindDepth is set to 2
				// M.H. 18 June 2014 Fix for bug #172395: [Hierarchical Grid] 'initialExpandDepth' property is not working
				// MH: We should not call _toggleInternalAsync using setTimeout - when initialExpandDepth is gth 1 is not working
				//setTimeout(function () {
				hgrid._toggleInternalAsync(event, suppressEvents);
				//}, expandTout);
			}
			//A.T. 20 Feb. 2012 Fix for bug #100588
			if (!suppressEvents) {
				event.stopImmediatePropagation();
			}
		},
		_toggleInternalAsync: function (event, suppressEvents) {
			// obtain the row id
			var $td = $(event.target), parentrow = $td.closest('tr'), rowid = "", keyspath = "", keyspathvar = "", pgridp, o, level = -1, sp = false, curpath = 0, restSettingsSet,
				childds, created = parentrow.attr('c'), childrow, childgrids = [], ds, opts = [], id, k, isHierarchical, tmpkey, pki, dsobj, dsString, key,
				cs, popts, i, h, parentLevel = 0, tmpgrid, state = parentrow.attr('state'), animatec, noCancel = true, noCancelChild = true, pid; // parent options

			if (($td.is("td") && $td.attr("data-parent") !== "true") || $td.closest("td").attr("data-parent") !== "true") {
				return;
			}
			if (state === undefined) {
				state = 'c';
			}
			restSettingsSet = this.options.restSettings.update.url !== null || this.options.restSettings.update.template !== null ||
				this.options.restSettings.create.url !== null || this.options.restSettings.create.template !== null ||
				this.options.restSettings.remove.url !== null || this.options.restSettings.remove.template !== null;
			if (!created && state === 'c') {
				parentrow.after('<tr></tr>');
				childrow = parentrow.next();
				childrow.attr('data-container', true);
				//childrow.hide();
				popts = parentrow.closest('table').data('igGrid').options;
				opts = this._optsFor(popts);
				//cs = popts.columns.length + 1;
				if (popts.childrenDataProperty === undefined) {
					if (popts.key) {
						keyspath = popts.key;
					}
				} else {
					keyspath += popts.childrenDataProperty;
				}
				// call populate if necessary (remote)
				pgridp = parentrow.closest('.ui-iggrid-childarea').parent().prev();
				while (pgridp.length > 0) {
					if (curpath !== 0) {
						rowid += this.options.pathSeparator;
					}
					o = pgridp.closest('.ui-iggrid-table').data('igGrid').options;
					//k = o.foreignKey;
					//if (!k) {
					k = o.primaryKey;
					//}
					rowid += k + ':' + pgridp.attr('data-id');
					if (o.childrenDataProperty === undefined) {
						if (o.key) {
							keyspath += this.options.pathSeparator + o.key;
						}
					} else {
						keyspath += this.options.pathSeparator + o.childrenDataProperty;
					}
					pgridp = pgridp.closest('.ui-iggrid-childarea').parent().prev();
					curpath++;
				}
				// reverse keyspath and rowid
				keyspath = keyspath.split(this.options.pathSeparator).reverse().join(this.options.pathSeparator);
				rowid = rowid.split(this.options.pathSeparator).reverse().join(this.options.pathSeparator);
				//k = parentrow.closest('.ui-iggrid-table').data('igGrid').options.foreignKey;
				//if (!k) {
				k = parentrow.closest('table').data('igGrid').options.primaryKey;
				//}
				if (rowid === "") {
					rowid = k + ':' + parentrow.attr('data-id');
				} else {
					rowid += this.options.pathSeparator + k + ':' + parentrow.attr('data-id');
				}
				cs = parentrow.find("td,th").length;
				animatec = $('<div></div>').appendTo($('<td></td>')
					.appendTo(childrow).addClass(this.css.childGridArea).attr('colspan', cs));
				// create a table for each child grid
				for (i = 0; i < opts.length; i++) {
					keyspathvar = "";
					childgrids.push($('<table></table>').appendTo(animatec).attr('data-childgrid', true));
					// check if we need to add a separator div, to achieve the "dotted line" effect as shown in wireframes
					if (i < opts.length - 1) {
						$("<div></div>").appendTo(animatec).addClass(this.css.childGridSeparator);
					}
					// set the ID of the child grid element
					// important - append layout name!
					// M.H. 29 May 2014 Fix for bug #170463: A JavaScript exception is thrown when igHierarchicalGrid.childrenDataProperty is used instead of igHierarchicalGrid.key
					key = (opts[i].key !== undefined) ? opts[i].key : opts[i].childrenDataProperty;
					childgrids[i].attr('id', this.root()[0].id + '_' +
						parentrow.attr('data-id') + '_' + key + '_child');
					// in the case of composite keys, we need to replace the comma character (",") with a dash ("-") or similar
					// otherwise it's not compilant and the generated id won't work with jQuery selectors
					parentLevel = parseInt(parentrow.closest('table').attr('data-level'), 10);
					childgrids[i].attr('id', childgrids[i].attr('id').replace(",", "-")).attr('data-level', parentLevel + 1);
					// find the data, construct the options, create the container, init the grid
					// first check if the child is already created (via attr. ?)
					// create a new <tr> below the parent one which will hold the child data, with one td with colspan colcount + 1 (the expandable column)
					if (keyspath === "") {
						keyspathvar = opts[i].childrenDataProperty === undefined ? opts[i].key : opts[i].childrenDataProperty;
					} else {
						keyspathvar = this.options.pathSeparator +
							(opts[i].childrenDataProperty === undefined ? opts[i].key : opts[i].childrenDataProperty);
					}
					childds = this._hds.dataAt(rowid, keyspath + keyspathvar);
					//if ($.type(childds) !== "array") {
					if ($.type(childds) !== "array" && !opts[i].responseDataKey && childds !== undefined) {
						childds = [childds];
					} else if (childds === null || childds === undefined) {
						childds = [];
					}
					// register the child grid
					// init hierarchical events, if this grid has layouts defined, otherwise init as purely a FLAT grid ! 
					isHierarchical = false;
					// here we shouldn't check for primary / foreign keys. it's irrelevant as to whether the grid is hierarchical or not. 
					// what's important is whether it has layouts defined. 
					// its another story if this layout has matching records or not
					// that determines whether the row will have an expansion indicator or not.
					if (opts[i].columnLayouts && opts[i].columnLayouts.length > 0) {
						isHierarchical = true;
					}
					if (isHierarchical) {
						this._regevents(childgrids[i], this);
					}
					// A.T. load on demand support (always remote ! when data source is remote. ) 
					// 1. check level index, if it surpasses initialDataBindDepth populate data
					// through the data source, by also showing the loading indicator
					// level => count the number of separator characters
					level = rowid.split(this.options.pathSeparator).length;
					if (level > this.options.initialDataBindDepth && this.options.initialDataBindDepth !== -1) {
						sp = true;
					}
					// 2. mark the parent record as already populated
					ds = this._hdsoptions().dataSource;
					if (!sp) {
						// pass layout / level info 
						opts[i].dataSource = childds;
						// L.A. 15 January 2013 - Fixing bug #130730
						// When the dataSource of the HGrid is URL the remote features in child layouts do not use the correct Url for their requests.
						if ($.type(ds) === "string" && this.options.rest !== true && !opts[i].dataSourceUrl) {
							opts[i].dataSourceUrl = ds;
						}
						if (opts[i].dataSourceUrl && $.type(opts[i].dataSourceUrl) === 'string') {
							if (opts[i].dataSourceUrl.indexOf("?") !== -1) {
								opts[i].dataSourceUrl += "&" + this._hds._encodeUrlPath(rowid, opts[i].key); //rowid + "/[" + opts[i].key + "]";
							} else {
								opts[i].dataSourceUrl += "?" + this._hds._encodeUrlPath(rowid, opts[i].key);
							}
						}
						// we need to copy the ig_pk col, if present (that's given there are no primary keys defined). 
						// in that case the grid is generating the primary keys itself, so that auto generation of layouts
						// works fine
						if (this.options.autoGenerateLayouts === true) {
							opts[i]._recurseSchema = true;
						}
						childgrids[i].trigger(this.events.childGridCreating, {
							owner: this,
							options: opts[i],
							element: childgrids[i],
							id: rowid,
							path: keyspath + keyspathvar
						});
						noCancelChild = childgrids[i].attr("data-create");
						if (noCancelChild !== "false") {
							if ((this.options.rest || this.options.odata) && restSettingsSet === true) {
								this._inheritRestSettings(null, parentrow.attr('data-id'), keyspathvar.toLowerCase(), popts, opts[i]);
							}
							// M.H. 10 Dec 2012 Fix for bug #126991
							if (isHierarchical) {
								opts[i]._isHierarchicalGrid = true;
							}
							childgrids[i].igGrid(opts[i]);
							if (isHierarchical) {
								this._regToggleEvent(childgrids[i], this);
							}
							childgrids[i].trigger(this.events.childGridCreated, {owner: this, element: childgrids[i]});
						}
						if (opts[i].primaryKey === null || opts[i].primaryKey === undefined) {
							if (opts[i].dataSource &&
									typeof opts[i].dataSource._xmlToArray === "function" &&
									typeof opts[i].dataSource._encodePkParams === "function") {
								throw new Error($.ig.Grid.locale.noPrimaryKey);
							}
							tmpgrid = childgrids[i].data("igGrid");
							tmpkey = tmpgrid.dataSource.schema().schema.searchField;
							if (tmpkey !== null) {
								for (pki = 0; pki < opts[i].dataSource[tmpkey].length; pki++) {
									opts[i].dataSource[tmpkey][pki].ig_pk = tmpgrid.dataSource.data()[pki].ig_pk;
								}
							} else {
								for (pki = 0; pki < opts[i].dataSource.length; pki++) {
									if (opts[i].dataSource[pki]) {
										opts[i].dataSource[pki].ig_pk = tmpgrid.dataSource.data()[pki].ig_pk;
									}
								}
							}
						}
					} else {
						instanceOfDs = ds &&
								typeof ds._xmlToArray === "function" &&
								typeof ds._encodePkParams === "function";
						// can child layouts have dataSource themselves ? i.e. sth like mashup data source?
						if (this.options.odata) {
							dsobj = (instanceOfDs) ? ds.settings.dataSource : ds;
							dsString = (popts.dataSource &&
									typeof popts.dataSource._xmlToArray === "function" &&
									typeof popts.dataSource._encodePkParams === "function") ? popts.dataSource.settings.dataSource : popts.dataSource;
							//childds = this._hds.dataAt(rowid, keyspath + keyspathvar);
							childds = parentrow.closest('table').data('igGrid').dataSource.data();
							tmpkey = parentrow.attr('data-id');
							k = parentrow.closest('table').data('igGrid').options.primaryKey;
							// find the primary column type
							if (parentrow.closest('table').data('igGrid').columnByKey(k).dataType === "number") {
								tmpkey = parseInt(tmpkey, 10);
							}
							for (pki = 0; pki < childds.length; pki++) {
								if (childds[pki][parentrow.closest('table').data('igGrid').options.primaryKey] === tmpkey) {
									childds = childds[pki][opts[i].key];
									break;
								}
							}
							if (!childds) {
								// with webapi implementation we need to create the uri similarly to how rest is done
								if (dsString.substr(dsString.length - 1) === "/") {
									dsString = dsString.substring(0, dsString.length - 1);
								}
								pid = typeof tmpkey === "string" ? "'" + tmpkey + "'" : tmpkey;
								if (keyspathvar.charAt(0) !== '/') {
									keyspathvar = '/' + keyspathvar;
								}
								if ($.type(dsobj) === 'string' && dsobj !== dsString) {
									dsString = dsobj.substring(0, dsobj.lastIndexOf('/')) + dsString.substring(dsString.lastIndexOf('/'));
								}
								opts[i].dataSource = dsString + "(" + pid + ")" + keyspathvar;
							} else {
								// the OData spec specifies that all deferred content which hasn't been initially retrieved using $expand
								// should be contained in a __deferred object.
								if (childds.__deferred && childds.__deferred.uri) {
									opts[i].dataSource = childds.__deferred.uri;
									// we need to handle the special case when JSONP protocol is used. For that a callback=? is necessary in the URL
									// if the original data source contains this fragment, we need to ensure we add it for all dynamically constructed URLs
									// for child data sources. The OData spec doesn't say anything about $expand and __deferred syntax having callback
									// i.e. it's not inherited from parent URLs.
									if (dsobj.indexOf("$callback=?") !== -1) {
										opts[i].dataSource += "?$callback=?";
									}
									// copy $format
									if (dsobj.indexOf("$format=") !== -1) {
										if (dsobj.indexOf("$format=json") !== -1) {
											opts[i].dataSource += "&$format=json";
										} else {
											opts[i].dataSource += "&$format=atom";
										}
									}
								}
							}
							if (restSettingsSet === true) {
								this._inheritRestSettings(null, parentrow.attr('data-id'), keyspathvar.toLowerCase(), popts, opts[i]);
							}
						} else if (this.options.rest === true) {
							if (ds.substr(ds.length - 1) !== "/") {
								ds += "/";
							}
							pid = parentrow.attr('data-id');
							opts[i].dataSource = ds + pid + "/" + keyspathvar.toLowerCase();
							if (restSettingsSet === true) {
								this._inheritRestSettings(opts[i].dataSource, pid, keyspathvar.toLowerCase(), popts, opts[i]);
							}
						} else if (instanceOfDs) {
							opts[i].dataSource = ds.settings.dataSource + this._hds._encodeUrlPath(rowid, opts[i].key);
						} else {
							//check for  the existence of dataSourceUrl (MVC scenario)
							/* L.A. 28 August 2012 Fixing bug 119708
							When LoadOnDemand = TRUE and the root grid is assigned a DataSourceURL (and no initial source data), 
							expanding a root grid row causes JS errors due to incorrect child layout binding.
							The problem is caused because dataSourceUrl is not used anymore. dataSource is used instead.
							*/
							if (opts[i].dataSource) {
								if (opts[i].dataSource.indexOf("?") !== -1) {
									opts[i].dataSource += '&' + this._hds._encodeUrlPath(rowid, opts[i].key);
								} else {
									opts[i].dataSource += '?' + this._hds._encodeUrlPath(rowid, opts[i].key);
								}
								opts[i].dataSourceType = "remoteUrl";
							} else {
								// 10 Oct. 2011 - Fix for bug #91254 
								if ($.type(opts[i].dataSource) === "string" && $.type(ds) !== "string") {
									opts[i].dataSource += '?' + this._hds._encodeUrlPath(rowid, opts[i].key);
									opts[i].dataSourceType = "remoteUrl";
								} else {
									opts[i].dataSource = ds + '?' + this._hds._encodeUrlPath(rowid, opts[i].key);
									//this._hds.populate(rowid, $.proxy(this._populateComplete, this), params);
								}
							}
							// M.H. 17 May 2013 Fix for bug #142453: Remote inhereted operations for third layout throw js error (GroupBy, Paging and Sorting)
							if (opts[i].dataSource !== opts[i].dataSourceUrl) {
								opts[i].dataSourceUrl = opts[i].dataSource;
							}
						}
					}
				}
				if (sp) {
					// fire children populating
					noCancel = this._trigger(this.events.childrenPopulating, null, {owner: this, parentrow: parentrow, id: rowid});
					if (noCancel) {
						// create the grids
						for (i = 0; i < opts.length; i++) {
							// we need to handle the children populated events, and for this reason we need to handle the gridRendered events and 
							// fire a single children populated after the last gridRendered is called
							id = parentrow.attr('data-id');
							if (!this._eventQueue["id" + id] || !this._eventQueue["id" + id].length) {
								this._eventQueue["id" + id] = [];
							}
							h =  $.proxy(this._childRendered, this);
							this._eventQueue["id" + id].push({grid: childgrids[i], handler: h, parentrow: parentrow, id: rowid});
							childgrids[i].bind('iggridrendered', h);
							if (this.options.autoGenerateLayouts === true) {
								opts[i]._recurseSchema = true;
							}
							// M.H. 10 Dec 2012 Fix for bug #126991
							if (isHierarchical) {
								opts[i]._isHierarchicalGrid = true;
							}
							childgrids[i].igGrid(opts[i]);
							if (isHierarchical) {
								this._regToggleEvent(childgrids[i], this);
							}
						}
					}
				}
				animatec.attr('id', 'ac');
				parentrow.attr('c', true);
				parentrow.next().hide();
				animatec.hide();
				this._expand(parentrow, suppressEvents);
			} else {
				// just toggle the visibility
				if (state === 'e') {
					// collapse
					this._collapse(parentrow, suppressEvents);
				} else if (state === 'c') {
					// expand
					this._expand(parentrow, suppressEvents);
				}
			}
			this.indicator.hide();
			parentrow.find('.ui-iggrid-expandbutton').css('visibility', 'visible');
		},
		// parse the hierarchical layout definitions
		_layouts: function () {
			// traverse the DS and generate the layouts. 
			// does autoGenerateLayouts make any sense at all ? 
			// traverses the existing data source and auto generates the layouts
			this.element.unbind('iggriddatarendering', this._databoundHandler);
		},
		_columnsGenerated: function (event, args) {
			// this is necessary cause when columns start to be generated, we want to fill the root layouts. 
			// potential optimization: if columns get generated for one child grid, when another child grid from the same layout is expanded,
			// we don't need to generate its own columns - we can put the existing ones in its own options when they are passed to .igGrid(..)
			var layoutKey = args.key, layout;
			if (!layoutKey) {
				return;
			}
			// search the layout, and if it exists and doesn't have columns, add args.owner.options.columns to it
			layout = this._findLayout(this.rootWidget().options.columnLayouts, layoutKey);
			if (layout.columns && layout.columns.length && layout.columns.length > 0) {
				return;
			}
			layout.columns = args.owner.options.columns;
		},
		_findLayout: function (layouts, key) {
			var i, layout;
			for (i = 0; layouts && i < layouts.length; i++) {
				if (layouts[i].key === key) {
					layout = layouts[i];
					break;
				}
				if (!layout && layouts[i].columnLayouts) {
					layout = this._findLayout(layouts[i].columnLayouts, key);
				}
			}
			return layout;
		},
		_hdsoptions: function () {
			var opts, schema, instanceOfHds;
			opts = {
				responseDataKey: this.options.responseDataKey,
				responseTotalRecCountKey: this.options.responseTotalRecCountKey,
				dataSource: this.options.dataSource,
				primaryKey: this.options.primaryKey,
				localSchemaTransform: this.options.localSchemaTransform,
				autoCommit: this.options.autoCommit,
				odata: this.options.odata,
				serializeTransactionLog: this.options.serializeTransactionLog,
				updateUrl: this.options.updateUrl,
				restSettings: this.options.restSettings,
				initialDataBindDepth: this.options.initialDataBindDepth
			};
			if (this.options.dataSourceType !== null) {
				opts.type = this.options.dataSourceType;
			}
			schema = this._hschema();
			instanceOfHds = this.options.dataSource &&
							typeof this.options.dataSource._encodeHierarchicalUrlParams === 'function' &&
							this.options.dataSource.settings && this.options.dataSource.settings.hasOwnProperty &&
							this.options.dataSource.settings.hasOwnProperty('initialDataBindDepth');
			if ((instanceOfHds && this.options.dataSource.settings.schema === null) || !instanceOfHds) {
				opts = $.extend(opts, {schema: schema});
			}
			return opts;
		},
		// M.H. 20 Sep 2012 Fix for bug #121981
		_getDataColumns: function (cols) {
			var i, j, res = [], colsLength = cols.length, dCols;

			for (i = 0; i < colsLength; i++) {
				if (cols[i].group !== undefined && cols[i].group !== null) {
					dCols = this._getDataColumns(this._getDataColumns(cols[i].group));
					for (j = 0; j < dCols.length; j++) {
						res.push(dCols[j]);
					}
				} else {
					res.push(cols[i]);
				}
			}
			return res;
		},
		_hschema: function () {
			// M.H. 20 Sep 2012 Fix for bug #121981
			var schema, i, j, rec, prop, cols = this._getDataColumns(this.options.columns), encodedLayouts = [], k, c;
			// generate top level schema
			if (cols.length > 0 && !this.options.autoGenerateColumns) {
				// if autoGenerateColumns is true, fields for all columns in the data source must be specified
				schema = {};
				schema.fields = [];
				j = 0;
				for (i = 0; i < cols.length; i++) {
					// M.H. 4 Sep 2012 Fix for bug #120414
					if (cols[i].unbound === true) {
						continue;
					}
					schema.fields[j] = {};
					schema.fields[j].name = cols[i].key;
					schema.fields[j].type = cols[i].dataType;
					j++;
				}
				schema.searchField = this.options.responseDataKey;
			} else if (this.options.autoGenerateColumns) {
				schema = {};
				schema.fields = [];
				if (this.options.dataSource && this.options.dataSource.length && this.options.dataSource.length > 0 &&
						$.type(this.options.dataSource) === "array") {
					rec = this.options.dataSource[0];
					for (prop in rec) {
						if (rec.hasOwnProperty(prop)) {
							// if the column isn't already defined in the columns collection
							for (k = 0; k < cols; k++) {
								if (cols[k].key === prop) {
									c = cols[k];
									break;
								}
							}
							if (c === null || c === undefined) {
								schema.fields.push({name: prop, type: $.ig.getColType(rec[prop])});
							} else {
								// M.H. 4 Sep 2012 Fix for bug #120414
								if (c.unbound === true) {
									continue;
								}
								schema.fields.push({name: prop, type: c.dataType});
							}
							//count++;
						}
					}
				}
			}
			//for (i = 0; i < this.options.columns.length; i++) {
			if (this.options.columnLayouts && this.options.columnLayouts.length > 0) {
				for (j = 0; j < this.options.columnLayouts.length; j++) {
					schema.fields.push({name: this.options.columnLayouts[j].childrenDataProperty === undefined ?
							this.options.columnLayouts[j].key : this.options.columnLayouts[j].childrenDataProperty});
				}
			}
			//}
			// encode layouts. Layouts are encoded as part of the settings of the schema of the 
			// hierarchical data source. They are stored in a hash (normal JS array, which it always a hash)
			// where the hey is the "path" of primary keys, such as /Code:<childrenDataProperty>:ID/<level 2 definition ..>
			//(which means parent col Code => connected to ID as the primary key, and children are stored in the 
			// <childrenDataProperty. so that we can have multiple layout configurations bound to the same data
			// with different settings
			// second option is the current layout "path" which is recursively accumulated
			this._parseLayouts(encodedLayouts, "", this.options);
			schema.layouts = encodedLayouts;
			return schema;
		},
		_parseLayouts: function (layouts, cpath, options) {
			var j, layout, p, cdp = null;
			if (options.columnLayouts && options.columnLayouts.length !== undefined && options.columnLayouts.length > 0) {
				for (j = 0; j < options.columnLayouts.length; j++) {
					layout = options.columnLayouts[j];
					cdp = layout.childrenDataProperty === undefined ? layout.key : layout.childrenDataProperty;
					if (!cdp) {
						cdp = this.options.defaultChildrenDataProperty;
					}
					p = cpath + this.options.pathSeparator + cdp + ":" + layout.primaryKey;
					layouts[p] = layout;
					this._parseLayouts(layouts, p, layout);
				}
			}
		},
		_batchExpand: function () {
			var crows = [], tmpanim, hgrid;
			hgrid = this.element.closest('.ui-iggrid-root').data('igHierarchicalGrid');
			if (!hgrid) {
				hgrid = this.element.data('igHierarchicalGrid');
			}
			tmpanim = hgrid.options.expandCollapseAnimations;
			hgrid.options.expandCollapseAnimations = false;
			crows = this.element.find("tr[data-id]");
			// get all rows
			// now call off the hierarchical grid object
			hgrid._batchExpandLevel(crows);
			hgrid.options.expandCollapseAnimations = tmpanim;
		},
		_batchExpandLevel: function (rows) {
			var i;
			for (i = 0; i < rows.length; i++) {
				this.toggle(rows[i]);
			}
		},
		_renderExtraHeaderCell: function (row, colgroup, prepend) {
			if (prepend === true) {
				$('<td></td>').prependTo(row).css('border-width', 0).attr('data-skip', true);
			} else {
				$('<td></td>').appendTo(row).css('border-width', 0).attr('data-skip', true);
			}
		},
		_renderExtraFooterCell: function (row, colgroup, prepend, cssClass) {
			if (prepend === true) {
				$('<td></td>').addClass(cssClass).prependTo(row).attr('data-skip', true);
			} else {
				$('<td></td>').addClass(cssClass).appendTo(row).attr('data-skip', true);
			}
		},
		// M.H. 10 May 2012 Fix for bug #108221
		_headerrenderedinternal: function (sender, args) {
			// M.H. 9 Oct 2012 Fix for bug #124072
			if (args.owner.element[0].id !== sender.currentTarget.id && args.owner.element[0].id !== sender.currentTarget.id + '_table') {
				return;
			}
			var self = this, flatRenderColgroup = args.owner._renderColgroup, tmpid, $thDataSkip;
			args.owner._renderRecord = $.proxy(this._hierarchicalRenderRecord, args.owner);

			args.owner._getFirstVisibleTR = $.proxy(this._hierarchicalGetFirstVisibleTR, args.owner);
			args.owner._getLastVisibleTR = $.proxy(this._hierarchicalGetLastVisibleTR, args.owner);

			args.owner._renderRecordInArray = $.proxy(this._hierarchicalRenderRecordInArray, args.owner);
			args.owner._renderColgroup = function () {
				self._hierarchicalRenderColgroup.apply(args.owner, $.merge([flatRenderColgroup, self], arguments));
			};
			args.owner._headerInitCallbacks.push({type: "HierarchicalGrid", func: $.proxy(this._renderExtraHeaderCell, this)});
			args.owner._footerInitCallbacks.push({type: "HierarchicalGrid", func: $.proxy(this._renderExtraFooterCell, this)});
			args.owner._trigger('headerextracellsmodified', null, {owner: args.owner});
			//args.owner._registerAdditionalEvents = $.proxy(this._registerAdditionalEvents, args.owner);
			// insert extra <col> and extra <th> in front
			// M.H. 13 Nov 2012 Fix for bug #126991
			if (args.table.attr('id') !== args.owner.element.attr('id') && $(args.table).find('colgroup col[data-expander]').length === 0) {
				$("<col></col>").attr('data-skip', 'true').attr('data-expander', true).prependTo(args.table.find("colgroup")).width(this.options.expandColWidth);
			}

			$thDataSkip = $("<th></th>");
			$("<span></span>").appendTo($thDataSkip.prependTo(args.table.find("thead tr:first"))
				.addClass(this.css.expandHeaderCell).attr('data-skip', true)).addClass(this.css.expandHeaderCellTriangle);
			if (args.owner._isMultiColumnGrid) {
				$thDataSkip.attr('rowspan', args.owner._maxLevel + 1);
			}
			// A.T. 4 April 2012 - This isn't necessary any more, because we are doing this generically in grid.framework => dataRender => any col which has data-skip
			// increase the container grid width, if there is no grid width defined, but there are column widths defined
			//if (args.owner.options.width === null && args.owner.options.columns.length > 0 && args.owner.options.columns[0].width !== null) {
			//	args.owner.container().width(parseInt(args.owner.container().width(), 10) + parseInt(this.options.expandColWidth, 10));
			//}
			// M.H. 5 Nov 2012 Fix for bug #126444
			if (args.owner._isWrapped) {
				tmpid = args.owner.element.attr('id').substring(0, args.owner.element.attr('id').indexOf('_table'));
				// M.H. 10 May 2012 Fix for bug #108221
				args.owner.container().find('#' + tmpid).unbind("iggridheaderrenderedinternal", args.owner.element.data('hr'));
				args.owner.container().find('#' + tmpid).removeData('hr');
			} else {
				// M.H. 10 May 2012 Fix for bug #108221
				args.owner.element.unbind("iggridheaderrenderedinternal", args.owner.element.data('hr'));
				args.owner.element.removeData('hr');
			}
		},
		_checkIsMultiColumnHeader: function (lobj) {
			var i, columnLayouts = lobj.columnLayouts, cols = lobj.columns,
				columnLayoutsLength,
				colsLength;
			// M.H. 31 July 2012 Fix for bug #115599
			if (cols) {
				colsLength = cols.length;
				for (i = 0; i < colsLength; i++) {
					if (cols[i].group !== undefined && cols[i].group !== null) {
						return true;
					}
				}
			}
			// M.H. 16 May 2014 Fix for bug #171779: Cannot sort parent grid columns if child grid has multi column headers and the parent grid does not
			//if (columnLayouts) {
			//	columnLayoutsLength = columnLayouts.length;
			//	for (i = 0; i < columnLayoutsLength; i++) {
			//		if (this._checkIsMultiColumnHeader(columnLayouts[i]) === true) {
			//			return true;
			//		}
			//	}
			//}

			return false;
		},
		_hierarchicalRenderRecord: function (data, rowIndex) {
			// generate a Tr and append it to the table
			var i, key, ar = this.options.accessibilityRendering, grid = this, lod, hg, childprop, dstr = "",
				val, markup = "", layouts, hasChildren, noVisibleColumns, layout, temp;
			if (rowIndex % 2 !== 0 && this.options.alternateRowStyles) {
				dstr += '<tr class="' + grid.css.recordAltClass + '"';
			} else {
				dstr += '<tr';
			}

			//data index to which the row is bound
			dstr += ' data-row-idx="' + rowIndex + '"';

			if (!this._hg) {
				hg = this.element.closest(".ui-iggrid-root").data('igHierarchicalGrid');
				if (!hg) {
					hg = this.element.hasClass(".ui-iggrid-root") ? this.element : undefined;
				}
				this._hg = hg;
			} else {
				hg = this._hg;
			}
			// render row ID, check if the grid has a primary key defined. It is also mandatory to check if the grid has any parents, and append existing "paths" 
			if (this.options.foreignKey) {
				// handle composite keys; they are always separated by comma in the value of foreignKey
				dstr += " data-id-fk='" + this._kval_from_key(this.options.foreignKey, data) + "'";
			} else {
				if (this.options.primaryKey === null || this.options.primaryKey === undefined) {
					// generate a primary key and put it in the data source in another column called ig_pk
					this.options.primaryKey = "ig_pk";
					val = hg._getVal(data);
					dstr += " data-id-fk='" + val + "'";
				} else if (this.options.primaryKey === "ig_pk") {
					val = hg._getVal(data);
					dstr += " data-id-fk='" + val + "'";
				} else {
					// generate record foreign key ID
					// handle composite keys
					dstr += " data-id-fk='" + this._kval_from_key(this.options.primaryKey, data) + "'";
				}
			}
			if (this.options.primaryKey === null || this.options.primaryKey === undefined) {
				//throw new Error($.ig.Grid.locale.noPrimaryKey);
				this.options.primaryKey = "ig_pk";
				val = hg._getVal(data);
				dstr += " data-id='" + val + "'";
			} else if (this.options.primaryKey === "ig_pk") {
				val = hg._getVal(data);
				dstr += " data-id='" + val + "'";
			} else {
				// generate record ID
				dstr += " data-id='" + this._kval_from_key(this.options.primaryKey, data) + "'";
			}
			if (ar) {
				dstr += ' role="row">';
			} else {
				dstr += '>';
			}
			// add hierarchical td
			// check if there is child data, and load on demand is not enabled
			// first we need to get the layout's childrenDataProperties so that we aren't
			// checking all properties which are objects (arrays)
			layouts = this.options.columnLayouts;
			hasChildren = false;
			lod = hg ? hg.options.initialDataBindDepth > -1 : false;
			if (!lod) {
				for (i = 0; layouts && i < layouts.length; i++) {
					if (data[layouts[i].key]) {
						childprop = layouts[i].key;
						layout = layouts[i];
					} else {
						childprop = layouts[i].childrenDataProperty;
					}
					//if (!layout) {
					//	layout = this.options;
					//}
					childprop = childprop || this.options.defaultChildrenDataProperty;
					if (childprop) {
						if (layout && layout.responseDataKey) {
							if (data[childprop] && data[childprop][layout.responseDataKey] &&
									data[childprop][layout.responseDataKey].length !== undefined &&
									(data[childprop][layout.responseDataKey].length > 0 || this._shouldAlwaysRenderChildIndicator)) {
								hasChildren = true;
								break;
							}
						} else {
							// M.H. 29 May 2014 Fix for bug #170463: A JavaScript exception is thrown when igHierarchicalGrid.childrenDataProperty is used instead of igHierarchicalGrid.key
							// make sure the case where the children also have response key is also considered: || $.type(data[childprop]) === "object" 
							if (data[childprop]) {
								if (data[childprop].length !== undefined && (data[childprop].length > 0 || this._shouldAlwaysRenderChildIndicator)) {
									hasChildren = true;
									break;
								} else {
									// M.H. 29 May 2014 Fix for bug #170463: A JavaScript exception is thrown when igHierarchicalGrid.childrenDataProperty is used instead of igHierarchicalGrid.key
									if (this.options.responseDataKey && data[childprop][this.options.responseDataKey] &&
										data[childprop][this.options.responseDataKey].length !== undefined &&
										(data[childprop][this.options.responseDataKey].length > 0 || this._shouldAlwaysRenderChildIndicator)) {
										hasChildren = true;
										break;
									}
								}
							}
						}
					}
				}
			} else {
				hasChildren = true;
			}
			if (hasChildren) {
				markup = '<span class="ui-iggrid-expandbuttoncontainer"><span class="ui-iggrid-expandbutton ui-icon ui-icon-plus" title="' + hg.options.expandTooltip + '"></span></span>';
			}
			dstr += '<td class="ui-iggrid-expandcolumn' + grid._addCellStyle(data, -1).replace(/class=\"/, "").replace(/\"/, "") + '" data-parent="' + hasChildren + '">' + markup + '</td>';
			noVisibleColumns = true;
			$(this.options.columns).each(function (colIndex) {
				var col = grid.options.columns[colIndex];
				if (col.hidden) {
					return;
				}
				noVisibleColumns = false;
				if (ar) {
					dstr += '<td role="gridcell" aria-describedby="' + this.key + '"';
				} else {
					dstr += '<td';
				}
				if (data[this.key] === undefined) {
					if (this.template && this.template.length) {
						// M.H. 2 Sep 2013 Fix for bug #151051: Template is not working for the unbound column in the root layout in igHierarchicalGrid
						if (col.unbound) {
							temp = grid._renderTemplatedCell(data, this);
						} else {
							temp = grid._renderTemplatedCell(data[colIndex], this);
						}
						if (temp.indexOf("<td") === 0) {
							dstr += temp.substring(3);
						} else {
							dstr += '>' + temp;
						}
						dstr = grid._editCellStyle(dstr, data, colIndex);
					} else {
						dstr += grid._addCellStyle(data, colIndex) + '>' + grid._renderCell(data[colIndex], this, data);
					}
					dstr += '</td>';
				} else {
					if (this.template && this.template.length) {
						temp = grid._renderTemplatedCell(data, this);
						if (temp.indexOf("<td") === 0) {
							dstr += temp.substring(3);
						} else {
							dstr += '>' + temp;
						}
						dstr = grid._editCellStyle(dstr, data, this.key);
					} else {
						dstr += grid._addCellStyle(data, this.key) + '>' + grid._renderCell(data[this.key], this, data);
					}
					dstr += '</td>';
				}
			});
			if (noVisibleColumns) {
				dstr += '<td role="gridcell"></td>';
			}
			dstr += '</tr>';
			return dstr;
		},
		_getVal: function (data) {
			var val;
			if (data.ig_pk) {
				val = data.ig_pk;
			} else {
				val = $.ig.util.getCheckSumForObject(data);//$.ig.uid();
				data.ig_pk = val;
			}
			return val;
		},
		_hierarchicalRenderRecordInArray: function (darr, tbody, data, rowIndex) {
			// generate a Tr and append it to the table
			var i, key, ar = this.options.accessibilityRendering, grid = this, lod, hg, childprop,
				val, markup = "", layouts, hasChildren, noVisibleColumns, appendBehavior = false, temp;
			if (darr === null) {
				darr = [];
				appendBehavior = true;
			}
			if (rowIndex % 2 !== 0 && this.options.alternateRowStyles) {
				darr.push('<tr class="' + grid.css.recordAltClass + '"');
			} else {
				darr.push('<tr');
			}
			// render row ID, check if the grid has a primary key defined. It is also mandatory to check if the grid has any parents, and append existing "paths"
			if (this.options.foreignKey) {
				// handle composite keys; they are always separated by comma in the value of foreignKey
				darr.push(" data-id-fk='" + this._kval_from_key(this.options.foreignKey, data) + "'");
			} else {
				if (this.options.primaryKey === null || this.options.primaryKey === undefined) {
					//throw new Error($.ig.Grid.locale.noPrimaryKey);
					// generate a primary key and put it in the data source in another column called ig_pk
					this.options.primaryKey = "ig_pk";
					//TODO refactor in separate func 
					val = $.ig.util.getCheckSumForObject(data);//$.ig.uid();
					darr.push(" data-id-fk='" + val + "'");
					data.ig_pk = val;
				} else if (this.options.primaryKey === "ig_pk") {
					val = $.ig.util.getCheckSumForObject(data);//$.ig.uid();
					darr.push(" data-id-fk='" + val + "'");
					data.ig_pk = val;
				} else {
					// generate record foreign key ID
					// handle composite keys
					darr.push(" data-id-fk='" + this._kval_from_key(this.options.primaryKey, data) + "'");
				}
			}
			if (this.options.primaryKey === null || this.options.primaryKey === undefined) {
				//throw new Error($.ig.Grid.locale.noPrimaryKey);
				this.options.primaryKey = "ig_pk";
				val = $.ig.util.getCheckSumForObject(data);//$.ig.uid();
				darr.push(" data-id='" + val + "'");
				data.ig_pk = val;
			} else if (this.options.primaryKey === "ig_pk") {
				val = $.ig.util.getCheckSumForObject(data);//$.ig.uid();
				darr.push(" data-id='" + val + "'");
				data.ig_pk = val;
			} else {
				// generate record ID
				darr.push(" data-id='" + this._kval_from_key(this.options.primaryKey, data) + "'");
			}
			if (ar) {
				darr.push(' role="row">');
			} else {
				darr.push('>');
			}
			// add hierarchical td
			// check if there is child data, and load on demand is not enabled
			// first we need to get the layout's childrenDataProperties so that we aren't
			// checking all properties which are objects (arrays)
			layouts = this.options.columnLayouts;
			hasChildren = false;
			// optimize
			hg = this.element.closest(".ui-iggrid-root").data('igHierarchicalGrid');
			if (!hg) {
				hg = this.element.hasClass(".ui-iggrid-root") ? this.element : undefined;
			}
			lod = hg ? hg.options.initialDataBindDepth > -1 : false;
			if (!lod) {
				for (i = 0; layouts && i < layouts.length; i++) {
					if (data[layouts[i].key]) {
						childprop = layouts[i].key;
					} else {
						childprop = layouts[i].childrenDataProperty;
					}
					childprop = childprop || this.options.defaultChildrenDataProperty;
					if (childprop) {
						if (this.options.responseDataKey) {
							if (data[childprop] && data[childprop][this.options.responseDataKey] &&
									data[childprop][this.options.responseDataKey].length !== undefined &&
									data[childprop][this.options.responseDataKey].length > 0) {
								hasChildren = true;
								break;
							}
						} else {
							if (data[childprop] &&
									data[childprop].length !== undefined &&
									data[childprop].length > 0) {
								hasChildren = true;
								break;
							}
						}
					}
				}
			} else {
				hasChildren = true;
			}
			if (hasChildren) {
				markup = '<span class="ui-iggrid-expandbuttoncontainer"><span class="ui-iggrid-expandbutton ui-icon ui-icon-plus" title="' + hg.options.expandTooltip + '"></span></span>';
			}
			darr.push('<td class="ui-iggrid-expandcolumn' + grid._addCellStyle(data, -1) + '" data-parent="' + hasChildren + '">' + markup + '</td>');
			noVisibleColumns = true;
			$(this.options.columns).each(function (colIndex) {
				if (grid.options.columns[colIndex].hidden) {
					return;
				}
				noVisibleColumns = false;
				if (ar) {
					darr.push('<td role="gridcell" aria-describedby="' + this.key + '"');
				} else {
					darr.push('<td');
				}
				if (data[this.key] === undefined) {
					if (this.template && this.template.length) {
						temp = grid._renderTemplatedCell(data, this);
                        if (temp.indexOf("<td") === 0) {
                            darr[darr.length - 1] = temp.replace("<td", darr[darr.length - 1]);
                        } else {
                            darr.push('>' + temp);
                        }
                        darr[darr.length - 1] = grid._editCellStyle(darr[darr.length - 1], data, colIndex);
					} else {
						darr.push(grid._addCellStyle(data, colIndex) + '>' + grid._renderCell(data[colIndex], this, data));
					}
					darr.push('</td>');
				} else {
					if (this.template && this.template.length) {
						temp = grid._renderTemplatedCell(data, this);
                        if (temp.indexOf("<td") === 0) {
                            darr[darr.length - 1] = temp.replace("<td", darr[darr.length - 1]);
                        } else {
                            darr.push('>' + temp);
                        }
                        darr[darr.length - 1] = grid._editCellStyle(darr[darr.length - 1], data, this.key);
					} else {
						darr.push(grid._addCellStyle(data, this.key) + '>' + grid._renderCell(data[this.key], this, data));
					}
					darr.push('</td>');
				}
			});
			if (noVisibleColumns) {
				darr.push('<td role="gridcell"></td>');
			}
			darr.push('</tr>');
			if (appendBehavior) {
				tbody.append(darr.join(''));
			}
		},
		_hierarchicalRenderColgroup: function (flatRenderColgroup, hierarchicalGrid, table, isHeader, isFooter, autofitLastColumn) {
			flatRenderColgroup.apply(this, [table, isHeader, isFooter, autofitLastColumn]);
			if ($(table).find('colgroup col[data-expander]').length > 0) {
				return;
			}
			$("<col></col>")
				.prependTo($(table).find("colgroup"))
				.css('width', hierarchicalGrid.options.expandColWidth)
				.attr('data-skip', 'true')
				.attr('data-expander', true);
		},
		_schemaGenerated: function (event, args) {
			// check the initialDataBindDepth of the root grid, if it is greater than -1 (load on demand), do nothing
			// since we have load on demand and we don't care (on the client), if parent rows have children or not, at this very moment
			var hg, i, rec, schema = args.schema, ds = args.dataSource, $this = args.owner, prop;
			hg = $this.element.closest(".ui-iggrid-root").data('igHierarchicalGrid');
			if (!hg) {
				hg = $this.element.hasClass(".ui-iggrid-root") ? $this.element : undefined;
			}
			if (!hg || hg.options.initialDataBindDepth > -1) {
				return;
			}
			// add fields which are complex objects (or arrays)
			for (i = 0; ds && ds.length && $.type(ds) === "array" && i < ds.length; i++) {
				rec = ds[i];
				for (prop in rec) {
					if (rec.hasOwnProperty(prop)) {
						if (!$this._fieldExists(prop, schema) && ($.type(rec[prop]) === "array" || $.type(rec[prop]) === "object")) {
							schema.fields.push({name: prop, type: $.ig.getColType(rec[prop])});
						}
					}
				}
			}
		},
		_childRendered: function (sender, args) {
			// traverse the event queue specified by args.owner.element[id] and check if all 
			// events have been fired, then fire the populated event
			// {grid: childgrids[i], handler: h, parentrow: parentrow, id: rowid}
			var ptr = args.owner.element.closest('tr').prev(),
				pid = "id" + ptr.attr('data-id'),
				e = this._eventQueue[pid],
				i,
				fire = true;

			for (i = 0; e.length !== undefined && i < e.length; i++) {
				if (e[i].grid.attr('id') === args.owner.element.attr('id')) {
					// we found the child grid which was just rendered 
					e[i].done = true;
					// unbind
					e[i].grid.unbind("iggridrendered", e[i].handler);
					break;
				}
			}
			// check if all grids are rendered, and if so, fire the populated event
			for (i = 0; e.length !== undefined && i < e.length; i++) {
				if (!e[i].done) {
					fire = false;
					break;
				}
			}
			if (fire) {
				// fire childrenPopulated event
				this._trigger(this.events.childrenPopulated, null, {owner: this, parentrow: ptr, id: e[0].id});
				// clear queue
				delete this._eventQueue[pid];
			}
		},
		/*
		_registerAdditionalEvents: function () {
			var css = 'ui-state-hover';
			// hovering (Hot Tracking) and unhovering
			$('#' + this.element[0].id + ' th.ui-state-default').hover(
				function () { $(this).addClass('ui-state-hover'); },
				function () { $(this).removeClass('ui-state-hover'); }
			);
			this.element.bind(this._hovEvts = {
				mousemove: function (e) {
					var par, tag, tr = e.target;
					while (tr) {
						par = tr.parentNode;
						if ((tag = tr.nodeName) === 'TR' && par.nodeName === 'TBODY') {
							break;
						}
						tr = (tag === 'TABLE') ? null : par;
					}
					if (_hovTR !== tr) {
						// A.T. crc = child row container. don't hover such rows. 
						if (_hovTR && $(_hovTR).attr('crc') !== "true") {
							$('td', _hovTR).removeClass(css);
						}
						if (tr && $(tr).attr('crc') !== "true") {
							$('td', tr).addClass(css);
						}
						_hovTR = tr;
					}
				},
				mouseleave: function (e) {
					if (_hovTR && $(_hovTR).attr('crc') !== "true") {
						$('td', _hovTR).removeClass(css);
						_hovTR = null;
					}
				}
			});
		},
		*/
		// returns child options given parent options
		_optsFor: function (popts) {
			var i, j, o = [], layouts;
			if (popts.columnLayouts && popts.columnLayouts.length > 0 && $.type(popts.columnLayouts) === "array") {
				layouts = popts.columnLayouts;
				for (j = 0; j < layouts.length; j++) {
					// handle features inheritance. Parameters passed - parent options and child options
					this._inherit(popts, layouts[j]);
					o.push($.extend(true, {}, $.ui.igGrid.prototype.options, layouts[j]));
				}
			}
			// L.A. 15 January 2013 - Fixing bug #130730
			// When the dataSource of the HGrid is URL the remote features in child layouts do not use the correct Url for their requests.
			for (i = 0; i < o.length; i++) {
				if (!o[i].dataSource) {
					o[i].dataSourceUrl = popts.dataSourceUrl;
				} else {
					// L.A. 15 February 2013 - Combined fix for bugs 128891, 130642, 132970
					if (String(popts.initialDataBindDepth) === "-1" || popts.initialDataBindDepth === undefined) {
						o[i].dataSourceUrl = o[i].dataSource;
					}
				}
			}

			return o;
		},
		_inherit: function (parent, child) {
			// traverse all parent features
			var i, f, j, nowrite;
			if (parent.dataSourceType) {
				child.dataSourceType = parent.dataSourceType;
			}
			if (!parent.features || parent.features.length === undefined || parent.features.length === 0) {
				return;
			}
			if (!child.features || child.features.length === undefined) {
				child.features = [];
			}
			for (i = 0; i < parent.features.length; i++) {
				if (parent.features[i].inherit === true) {
					// check if there is a feature with the same name (id) defined on the child layout
					f = null;
					for (j = 0; j < child.features.length; j++) {
						if (child.features[j].name === parent.features[i].name) {
							f = child.features[j];
							break;
						}
					}
					if (f === null || f === undefined) {
						// just copy everything, excluding columnSettings. 
						// columnSettings cannot be inherited because of difference of columns ! 
						child.features.push($.extend(true, {}, parent.features[i]));
						child.features[child.features.length - 1].columnSettings = [];
					} else {
						// merge the options with the child ones taking priority (meaning they override the parent ones)
						nowrite = false;
						if (child.features[j].columnSettings && child.features[j].columnSettings.length > 0) {
							nowrite = true;
						}
						child.features[j] = $.extend(true, {}, parent.features[i], f);
						if (!nowrite) {
							child.features[j].columnSettings = [];
						}
					}
				}
			}
		},
		// decorates the flat grid with hierarchical functionality 
		_regevents: function (e, context) {
			// M.H. 10 May 2012 Fix for bug #108221
			var headerRenderedInternal, datarendered, schemaGenerated;
			// M.H. 10 May 2012 Fix for bug #108221
			headerRenderedInternal = $.proxy(context._headerrenderedinternal, context);
			datarendered = $.proxy(this._handleBatchExpandRender, context);
			schemaGenerated = $.proxy(this._schemaGenerated, context);
			// M.H. 10 May 2012 Fix for bug #108221 - bind to this event. It is called even when showHeader is false
			e.bind("iggridheaderrenderedinternal", headerRenderedInternal);
			e.bind("iggriddatarendered", datarendered);
			e.bind("iggridschemagenerated", schemaGenerated);
			//A.T. watch out for live()'s perf. AND SELECTORS.
			// M.H. 5 Nov 2012 Fix for bug #126444
			// M.H. 10 May 2012 Fix for bug #108221
			e.data('hr', headerRenderedInternal);
		},
		_regToggleEvent: function (e, context) {
			var toggle;
			// M.H. 18 June 2014 Fix for bug #172395: [Hierarchical Grid] 'initialExpandDepth' property is not working
			// this is applied as a fix for bug 130025
			toggle = $.proxy(context._toggleInternalWithDelay, context);
			//A.T. 31 Jan 2012 - fix for bug #
			e.undelegate(".ui-iggrid-expandcolumn > .ui-iggrid-expandbuttoncontainer", "mousedown");
			e.delegate(".ui-iggrid-expandcolumn > .ui-iggrid-expandbuttoncontainer", "mousedown", toggle);
		},
		commit: function () {
			/* Commits pending transactions to the client data source for main and all child grids.
			*/
			var elem = this.element;
			elem.find(".ui-iggrid-table").each(function () {
				$(this).igGrid("commit");
			});
			elem.igGrid("commit");
		},
		rollback: function (rebind) {
			/* Clears the transaction log (delegates to igDataSource). Note that this does not update the UI. In case the UI must be updated, set the second parameter "updateUI" to true, which will trigger a call to dataBind() to re-render the contents. 
				paramType="bool" optional="true" Whether to perform a rebind.
			*/
			var elem = this.element;
			elem.find(".ui-iggrid-table").each(function () {
				$(this).igGrid("rollback", null, rebind);
			});
			elem.igGrid("rollback", null, rebind);
		},
		_addToLog: function (elem, taLog, child) {
			var grid = elem.data("igGrid"),
				ds = grid ? grid.dataSource : null,
				gridLog = ds ? ds._accumulatedTransactionLog : null,
				i = gridLog ? gridLog.length : 0;
			if (!i) {
				return;
			}
			this._dsLog = this._dsLog || [];
			this._dsLog.push(ds);
			while (i-- > 0) {
				taLog.push($.extend(true, child ? { layoutKey: grid.options.key } : {}, gridLog[i]));
			}
		},
		saveChanges: function (success, error) {
			/* posts to the settings.updateUrl using $.ajax, by serializing the changes as url params 
            paramType="function" Specifies a custom function to be called when AJAX request to the updateUrl option succeeds(optional)
            paramType="function" Specifies a custom function to be called when AJAX request to the updateUrl option fails(optional)
            */
			var self = this,
                opts,
				elem = self.element,
				url = self.options.updateUrl,
				taLog = [];
			if ((this.options.rest || this.options.odata) && this.options.restSettings) {
				this._saveChangesForEachGrid();
				return;
			}
			if (!url || !elem) {
				return;
			}
			delete self._dsLog;
			self._addToLog(elem, taLog);
			elem.find(".ui-iggrid-table").each(function () {
				self._addToLog($(this), taLog, true);
			});
            // M.H. 17 Feb 2014 Fix for bug #153639: Add successCallback and errorCallback params to the igDataSource.saveChanges API
            opts = {
                type: "POST",
                url: url,
                data: { "ig_transactions": JSON.stringify(taLog) },
                success: function (data, textStatus, jqXHR) {
					var logs = self._dsLog,
						i = logs ? logs.length : 0;
					while (i-- > 0) {
						logs[i]._saveChangesSuccess(data, textStatus, jqXHR);
					}
                    if (success) {
                        success(data, textStatus, jqXHR);
                    }
				},
                error: function (jqXHR, textStatus, errorThrown) {
                    var logs = self._dsLog,
						i = logs ? logs.length : 0;
					while (i-- > 0) {
						logs[i]._saveChangesError(jqXHR, textStatus, errorThrown);
					}
                    if (error) {
                        error(jqXHR, textStatus, errorThrown);
                    }
                }
            };
			// post to the Url using $.ajax, by serializing the changes as url params 
			$.ajax(opts);
		},
		_saveChangesForEachGrid: function (success, error) {
			// will call each of the open layouts save changes instead of one full transaction log
			this.rootWidget().saveChanges(success, error);
			$.each(this.allChildrenWidgets(), function () {
				this.saveChanges(success, error);
			});
		},
		// when there is virtualization enabled, we need to handle the expansion columns in a special way
		_handleBatchExpandRender: function (sender, args) {
			var level = 0, grid = args.owner, keyspath, ds, hdsData, o, k, curpath, rowid, popts, pgridp,
				gridId = grid.element[0].id, tId = sender.currentTarget.id;
			if (gridId !== tId && gridId !== tId + '_table') {// && (!sender.target || sender.target.id !== gridId)
				return;
			}
			// render first cells for every data rows
			// implementation for initialExpandDepth. The prerequisite is that the initialDataBindDepth 
			// should always exceed the value of initialExpandDepth
			// check level
			level = parseInt(grid.element.attr("data-level"), 10);
			if (isNaN(level)) {
				level = 0;
				grid.element.attr("data-level", level);
			}
			// M.H. 27 Mar 2013 Fix for bug #133320: When remote paging and remote filtering are enabled if you filter a column from a child layout and the result is from another page expanding this result makes the grid to throw a js error.
			// we should check for each databind and set the proper databind
			if (level > 0 &&
					this.options.initialDataBindDepth === -1 &&
					this._hds.settings.type === "json" &&
					$.type(grid.options.dataSource) === 'string') {
				keyspath = "";
				curpath = 0;
				rowid = "";
				popts = grid.options;
				if (popts.childrenDataProperty === undefined) {
					if (popts.key) {
						keyspath = popts.key;
					}
				} else {
					keyspath += popts.childrenDataProperty;
				}


				pgridp = grid.element;
				pgridp = pgridp.closest('.ui-iggrid-childarea').parent().prev();

				while (pgridp.length > 0) {
					if (curpath !== 0) {
						rowid += this.options.pathSeparator;
					}
					o = pgridp.closest('.ui-iggrid-table').data('igGrid').options;
					//k = o.foreignKey;
					//if (!k) {
					k = o.primaryKey;
					//}
					rowid += k + ':' + pgridp.attr('data-id');
					if (o.childrenDataProperty === undefined) {
						if (o.key) {
							keyspath += this.options.pathSeparator + o.key;
						}
					} else {
						keyspath += this.options.pathSeparator + o.childrenDataProperty;
					}
					pgridp = pgridp.closest('.ui-iggrid-childarea').parent().prev();
					curpath++;
				}
				
				
				keyspath = keyspath.split(this.options.pathSeparator).reverse().join(this.options.pathSeparator);
				rowid = rowid.split(this.options.pathSeparator).reverse().join(this.options.pathSeparator);
				hdsData = this._hds.dataAt(rowid, keyspath);
				ds = grid.dataSource;
				if (hdsData[popts.responseDataKey]) {
					hdsData[popts.responseDataKey] = ds._dataView;
					hdsData.Metadata = ds.metadata();
				}
			}
			if (level > this.options.initialExpandDepth) {
				return;
			}
			if ((this.options.initialDataBindDepth === -1 ||
					this.options.initialDataBindDepth >= this.options.initialExpandDepth) &&
					this.options.initialExpandDepth !== -1) {
				// non blocking UI
				setTimeout($.proxy(this._batchExpand, args.owner), 1);
				//this._batchExpand();
			}
			// unbind later (at destroy)
			//this.element.unbind('iggriddatarendered', this._renderedHandler);
		},
		_inheritRestSettings: function (path, pid, layout, popts, copts) {
			var crest = copts.restSettings, prest = popts.restSettings, rs, ptmpl, fullpath;
			// path, parent id, layout name, parent options, child options
			if (!path) {
				// if we don't have path we need to get it from the parent restSettings and inherit from there
				if (prest.update.template || prest.remove.template) {
					// get the path from the template with higher priority
					path = prest.update.template || prest.remove.template;
					path = path.replace("${id}", pid);
				} else {
					// get the path from the urls
					path = prest.create.url || prest.update.url || prest.remove.url;
					if (path.substr(path.length - 1) !== "/") {
						path += "/";
					}
					path += pid;
				}
				// e.g [/employees/5] or [/employees(5)]
				if (layout.substr(0, 1) === "/") {
					layout = layout.substr(1);
				}
				if (path.substr(path.length - 1) !== "/") {
					path += "/";
				}
				// e.g [/employees/5/] or [/employees(5)/]
				fullpath = path + layout;
			} else {
				fullpath = path;
			}
			// urls are easy - they should just equal the generated path + the layout
			rs = {
				update: {
					url: fullpath
				},
				create: {
					url: fullpath
				},
				remove: {
					url: fullpath
				}
			};
			// inheriting the templates is trickier
			if (crest.create.template && prest.create.template) {
				ptmpl = prest.create.template.replace("${id}", pid);
				crest.create.template = ptmpl + "/" + crest.create.template;
			}
			if (crest.remove.template && prest.remove.template) {
				ptmpl = prest.remove.template.replace("${id}", pid);
				crest.remove.template = ptmpl + "/" + crest.remove.template;
			}
			if (crest.update.template && prest.update.template) {
				ptmpl = prest.update.template.replace("${id}", pid);
				crest.update.template = ptmpl + "/" + crest.update.template;
			}
			// apply the generated settings
			crest = $.extend(true, crest, rs);
		},
		//continuous virtualization: gets called each time a row gets expanded to increase the scroller height
		_rowExpanded: function (args) {
			var rowExpansion, rowHeight, parentGrid, currentHeight;

			rowExpansion = args.parentrow.next();
			if (rowExpansion.length === 0 || !rowExpansion.is('tr[data-container="true"]')) {
				return;
			}
			rowHeight = rowExpansion.outerHeight();
			//I.I. bug fix for 105446
			parentGrid = args.parentrow.closest('.ui-iggrid-table').data('igGrid');
			currentHeight = parentGrid._getScrollContainerHeight();
			parentGrid._setScrollContainerHeight(currentHeight + rowHeight);
		},
		//continuous virtualization: gets called each time a row gets collapsed to decrease the scroller height
		_rowCollapsed: function (args) {
			var rowExpansion = args.parentrow.next(), rowHeight, parentGrid, currentHeight;

			if (rowExpansion.length === 0 || !rowExpansion.is('tr[data-container="true"]')) {
				return;
			}
			//TODO: rowHeight is already collaped, should be handled partly in the colapsing event
			rowHeight = rowExpansion.outerHeight();
			//I.I. bug fix for 105446
			parentGrid = args.parentrow.closest('.ui-iggrid-table').data('igGrid');
			currentHeight = parentGrid._getScrollContainerHeight();
			parentGrid._setScrollContainerHeight(currentHeight - rowHeight);
		},
		//continuous virtualization: overrides _getFirstVisibleTR of grid.gramework
		//returns the first TR in the grid which is partly or fully visible
		_hierarchicalGetFirstVisibleTR: function (visibleArea) {
			var tableId = '#' + this.element[0].id, firstVisibleTR;

			firstVisibleTR = $(tableId + ' > tbody > tr:not([data-container="true"])').filter(function (index) {
				return this.offsetTop + $(this).height() > visibleArea.top;
			}).first();

			return firstVisibleTR;
		},
		//continuous virtualization: overrides _getLastVisibleTR of grid.gramework
		//returns the last TR in the grid which is partly or fully visible
		_hierarchicalGetLastVisibleTR : function (visibleArea) {
			var tableId = '#' + this.element[0].id, lastVisibleTR;

			lastVisibleTR = $(tableId + ' > tbody > tr:not([data-container="true"])').filter(function (index) {
				return this.offsetTop < visibleArea.bottom;
			}).last();
			return lastVisibleTR;
		},
		destroy: function () {
			/* destroys the hierarchical grid by recursively destroying all child grids */
			this.tmpDataSource = null;
			this._rootgrid = null;
			this.rootWidget().destroy();
			$.Widget.prototype.destroy.call(this);
		}
	});
	$.extend($.ui.igHierarchicalGrid, {version: '14.1.20141.2249'});
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid Merged Cells 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}
(function ($) {
	/*
		igGridCellMerging widget.
		The widget is pluggable to the element where the grid is instantiated and the actual igGrid object doesn't know about this.
		The merged cells widget just attaches its functionality to the grid.
		The widget is used for applying specific "merged" styles to the grid cells when their value is repeated multiple times
		in subsequent cells. Usually used after sorting for making groups of values more distinguishable for the end-user.
	*/
	"use strict";
	$.widget("ui.igGridCellMerging", {
		css: {
			/* Classes applied to the top cell of a merged group */
			mergedCellsTop: "ui-iggrid-mergedcellstop",
			/* Classes applied to the bottom cell of a merged group */
			mergedCellsBottom: "ui-iggrid-mergedcellsbottom",
			/* Classes applied to every cell of a merged group */
			mergedCell: "ui-iggrid-mergedcell"
		},
		options: {
			/* type="regular|merged" controls the initial state 
			regular type="string" the grid won't be initialized with cells merged
			merged type="string" the grid will be initialized with cells merged
			*/
			initialState: "regular"
		},
		events: {
			/* cancel="true" Event fired before a new merged cells group is created.
			Function takes arguments evt and ui.
			Use ui.row to get reference to the row the merged group starts in.
			Use ui.rowIndex to get the index of the row the merged group starts in.
			Use ui.rowKey to get the key of the row the merged group starts in.
			Use ui.owner to get reference to igGridCellMerging.
			Use ui.grid to get reference to the igGrid the igGridCellMerging are initialized for.
			Use ui.value to get the cells value which is repeated and caused the merged group to be created.
			*/
			cellsMerging: "cellsMerging",
			/* 
			Use ui.row to get reference to the row the merged group starts in.
			Use ui.rowIndex to get the index of the row the merged group starts in.
			Use ui.rowKey to get the key of the row the merged group starts in.
			Use ui.owner to get reference to igGridCellMerging.
			Use ui.grid to get reference to the igGrid the igGridCellMerging are initialized for.
			Use ui.value to get the cells value which is repeated and caused the merged group to be created.
			Use ui.count to get the total count of cells that were merged.
			*/
			cellsMerged: "cellsMerged"
		},
		_create: function () {
			this._db = 0;
			this._sortingRequested = false;
			this._v = false;
		},
		destroy: function () {
			this._removePaint();
			this._unregisterEvents();
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		_gridPaging: function () {
			this._db--;
		},
		_gridSorting: function () {
			this._sortingRequested = true;
		},
		_gridSorted: function () {
			this._sortingRequested = false;
		},
		_gridRendered: function (event, ui) {
			var key, index, sExp = this.grid.dataSource.settings.sorting.expressions, i, j;
			if (this.options.initialState === "merged" && this._db === 0 && this._sortingRequested === false) {
				for (j = 0; j < this.grid._visibleColumns().length; j++) {
					this._paintMergedCells(j, this.grid._visibleColumns()[j].key);
				}
			} else {
				for (i = 0; i < sExp.length; i++) {
					key = sExp[i].fieldName;
					for (j = 0; j < this.grid._visibleColumns().length; j++) {
						if (this.grid._visibleColumns()[j].key === key) {
							index = j;
							break;
						}
					}
					if (typeof (this.grid._startColIndex) === "number") {
						index -= this.grid._startColIndex;
					}
					if (index !== null && index !== undefined && key) {
						this._paintMergedCells(index, key);
					}
				}
			}
			this._db++;
		},
		_rrn: function (event, args) {
			this._db--;
			this._gridRendered();
		},
		_rcn: function (event, args) {
			this._db--;
			this._gridRendered();
		},
		_columnsCollectionModified: function () {
			this._gridRendered();
		},
		_paintMergedCells: function (index, key) {
			var cells,			// all cells to be painted
				prvCell,		// the cell from the previous pass
				curCell,		// the cell from the current pass
				prvCellTxt,		// the text of the prvCell
				curCellTxt,		// the text of the curCell
				first = true,	// marks the firt pass
				str = false,	// marks group being constructed through passes
				hasFixedCols = this.grid.hasFixedColumns(), // check whether there are fixed columns
				id,
				count = 0,		// keeps count of merged cells in group to use in events
				i,				// cell iterator
				args,			// event arguments
				cval,			// current repeating value
				noCancel;		// event cancelled
			if (hasFixedCols) {
				// M.H. 28 Feb 2014 Fix for bug #165654: When fixed column is hidden cell merging is applied to the wrong column.
				if (key) {
					index = this.grid.element.data("igGridColumnFixing")._getVisibleIndex(key) + 1;
				} else {
					index = (index + 1 + this._getSystemFixedColumnsCount());
				}
				if (this.grid.isFixedColumn(key)) {
					// M.H. 23 Aug 2013 Fix for bug #150006: When row selectors are enabled and you sort a fixed column the cell merging is applied to the wrong column.
					cells = this.grid.container().find("#" + this.grid.id() + "_fixed tbody tr>td:nth-child(" + index + ")");
				} else {
					//index -= this.grid._fixedColumns.length;
					cells = this.grid.container().find("#" + this.grid.id() + " tbody tr>td:nth-child(" + index + ")");
				}
			} else {
				cells = this.grid.container().find("#" + this.grid.id() + " tbody tr>td:nth-child(" + (index + 1 + this._getSystemColumnsCount()) + ")");
			}
			// the function will add fictive cells to the start and end of the cell array representing the data
			// of the cell above and below the visible arrea of a hierarchical grid
			this._addVirtualBorderCells(cells, key);
			prvCell = cells.eq(0);
			for (i = 1; i < cells.length; i++) {
				curCell = cells.eq(i);
				prvCellTxt = this._getComparableCellText(prvCell);
				curCellTxt = this._getComparableCellText(curCell);
				if (prvCellTxt === curCellTxt && prvCellTxt !== cval) {
					// a new merged group is being created
					if (str === false) {
						args = this._getEventArgsForCell(prvCell);
						noCancel = this._trigger(this.events.cellsMerging, this, args);
						//	canceling the event cause the whole group to not be grouped
						if (noCancel !== true) {
							cval = prvCellTxt;
							prvCell = curCell;
							continue;
						}
					}
					// clearing cancelled values
					cval = null;
					str = true;
					if (first === true) {
						if (!cells.eq(i - 1)[0].fictive) {
							cells.eq(i - 1).addClass(this.css.mergedCellsTop);
						}
						first = false;
						count++;
					}
					if (!curCell[0].fictive) {
						curCell.addClass(this.css.mergedCell);
					}
					count++;
				} else {
					// if we had a merged cells group before add the merged 
					// cells bottom class and throw merged event
					if (str === true) {
						args.count = count;
						count = 0;
						this._trigger(this.events.cellsMerged, this, args);
						// this will never be fictive so we don't need to check
						cells.eq(i - 1).addClass(this.css.mergedCellsBottom);
						str = false;
					}
					first = true;
				}
				prvCell = curCell;
			}
			if (str === true) {
				args.count = count;
				this._trigger(this.events.cellsMerged, this, args);
				if (!cells.eq(cells.length - 1)[0].fictive) {
					cells.eq(cells.length - 1).addClass(this.css.mergedCellsBottom);
				}
			}
		},
		_addVirtualBorderCells: function (list, key) {
			var ds = this.grid.dataSource.dataView();
			if (this._v === true) {
				// check if there is a row above the displayed ones
				if (this.grid._startRowIndex > 0) {
					list.splice(0, 0,
						{ txt: String(ds[this.grid._startRowIndex - 1][key]), fictive: true }
						);
				}
				// check if there is a row below the displayed ones
				if (this.grid._startRowIndex + this.grid._virtualRowCount < this.grid.dataSource.dataView().length) {
					list.splice(list.length, 0,
						{ txt: String(ds[this.grid._startRowIndex + this.grid._virtualRowCount][key]), fictive: true }
						);
				}
			}
		},
		_getSystemFixedColumnsCount: function () {
			var firstRow = this.grid.fixedContainer().find("tbody>tr:not([data-container='true'],[data-grouprow='true']):first");
			return firstRow.children("[data-parent='true'],[data-skip='true'],th").length;
		},
		_getSystemColumnsCount: function () {
			var firstRow = this.grid.container().find("#" + this.grid.id() + " tbody>tr:not([data-container='true'],[data-grouprow='true']):first");
			return firstRow.children("[data-parent='true'],[data-skip='true'],th").length;
		},
		_getEventArgsForCell: function (cell) {
			var args, row, rKey, rIdx, val; 
			if (cell[0].fictive) {
				// fictive cell
				row = null;
				rKey = null;
				rIdx = this.grid._startRowIndex ? this.grid._startRowIndex - 1 : -1;
				val = cell[0].txt;
			} else {
				row = cell.closest("tr");
				rKey = row.attr("data-id");
				rIdx = this._getVisibleRowIndex(row);
				if (rKey === "" || rKey === null || rKey === undefined) {
					rKey = rIdx;
				}
				val = cell.html();
			}
			args = {
				owner: this,
				row: row,
				rowIndex: rIdx,
				rowKey: rKey,
				grid: this.grid,
				value: val
			};
			return args;
		},
		_getComparableCellText: function (cell) {
			var text = cell[0].fictive ? cell[0].txt : cell.html().replace(/^&nbsp;$/, ''); // removing empty cell's &nbsp; markup
			if (this.grid.dataSource.settings.sorting.caseSensitive === false) {
				text = text.toLowerCase();
			}
			return text;
		},
		_getVisibleRowIndex: function (row) {
			return row.closest("tbody")
				.children("tr:not([data-container='true'],[data-grouprow='true'])")
				.index(row) + (this.grid._startRowIndex || 0);
		},
		_removePaint: function () {
			var dataRows = this.grid.container().find("#" + this.grid.id() + "> tbody > tr:not([data-container='true'],[data-grouprow='true'])"), cells, i;
			cells = dataRows.children("td." + this.css.mergedCellsTop + ",td." + this.css.mergedCell);
			for (i = 0; i < cells.length; i++) {
				$(cells[i])
					.removeClass(this.css.mergedCellsTop)
					.removeClass(this.css.mergedCell)
					.removeClass(this.css.mergedCellsBottom);
			}
		},
		_createHandlers: function () {
			this._gridRenderedHandler = $.proxy(this._gridRendered, this);
			this._sortingInitiatedHandler = $.proxy(this._gridSorting, this);
			this._sortingHandler = $.proxy(this._gridSorted, this);
			this._pagingHandler = $.proxy(this._gridPaging, this);
			this._virtualRowsHandler = $.proxy(this._rrn, this);
			this._virtualColumnsHandler = $.proxy(this._rcn, this);
			this._columnsCollectionModifiedHandler = $.proxy(this._columnsCollectionModified, this);
		},
		_registerEvents: function () {
			this.grid.element.bind('ig_gridrendered', this._gridRenderedHandler);
			this.grid.element.bind('iggridsortingcolumnsorting', this._sortingInitiatedHandler);
			this.grid.element.bind('iggridsortingcolumnsorted', this._sortingHandler);
			this.grid.element.bind('iggridpagingpageindexchanging', this._pagingHandler);
			this.grid.element.bind('iggridvirtualrecordsrender', this._virtualRowsHandler);
			this.grid.element.bind('iggridvirtualhorizontalscroll', this._virtualColumnsHandler);
			this.grid.element.bind('iggridcolumnscollectionmodified', this._columnsCollectionModifiedHandler);
		},
		_unregisterEvents: function () {
			this.grid.element.unbind('ig_gridrendered', this._gridRenderedHandler);
			this.grid.element.unbind('iggridsortingcolumnsorting', this._sortingInitiatedHandler);
			this.grid.element.unbind('iggridsortingcolumnsorted', this._sortingHandler);
			this.grid.element.unbind('iggridpagingpageindexchanging', this._pagingHandler);
			this.grid.element.unbind('iggridvirtualrecordsrender', this._virtualRowsHandler);
			this.grid.element.unbind('iggridvirtualhorizontalscroll', this._virtualColumnsHandler);
			this.grid.element.unbind('iggridcolumnscollectionmodified', this._columnsCollectionModifiedHandler);
		},
		_injectGrid: function (gridInstance) {
			this.grid = gridInstance;
			// merged cells need to know if the grid is virtual
			this._v = this.grid.options.virtualization === true || this.grid.options.rowVirtualization === true;
			this._createHandlers();
			this._unregisterEvents();
			this._registerEvents();
		}
	});
	$.extend($.ui.igGridCellMerging, {version: '14.1.20141.2249'});
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid LoadOnDemand 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.editors.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery, toStaticHTML */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {
	$.widget("ui.igGridLoadOnDemand", {
		options: {
			/* type="remote|local"
			remote type="string" request data from the remote endpoint
			local type="string" loading data on the client-side
			*/
			type: null,
			/* type="number" default number of records per chunk */
			chunkSize: 25,
			/* type="string" the property in the response that will hold the total number of records in the data source */
			recordCountKey: null,
			/* type="string" denotes the name of the encoded URL parameter that will state what is the currently requested chunk size */
			chunkSizeUrlKey: null,
			/* type="string" denotes the name of the encoded URL parameter that will state what is the currently requested chunk index */
			chunkIndexUrlKey: null,
			/* type="number" initial chunk index position */
			defaultChunkIndex: 0,
			/* type="number" current chunk index position */
			currentChunkIndex: 0,
			/* type="auto|button" denotes the load on demand request method 
			auto type="string" new record will be appended to the grid while the user scrolls the scrollbar
			button type="string" a button will be rendered at the bottom of the grid. The user should press it to load more rows
			*/
			loadTrigger: "auto",
			/* type="string" Specifies caption text for the "load more data" button. */
			loadMoreDataButtonText: $.ig.GridLoadOnDemand.locale.loadMoreDataButtonText
		},
		events: {
			/* cancel="true" Event fired before the rows are requested from the remote endpoint.
			Return false in order to cancel requesting of rows.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridLoadOnDemand.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.chunkIndex to get next chunk index.
			Use ui.chunkSize to get chunk size.
			*/
			rowsRequesting: "rowsRequesting",
			/* Event fired after the requested rows are returned from the remote endpoint, but before grid data rebinds 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridLoadOnDemand.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.chunkIndex to get current chunk index.
			Use ui.chunkSize to get chunk size.
			Use ui.rows to get requested rows.
			*/
			rowsRequested: "rowsRequested"
		},
		_loadingIndicator: null,
		// every grid feature widget should implement this 
		_injectGrid: function (gridInstance, isRebind) {
			this.grid = gridInstance;
			this._checkNotSupportedScenarios();
			this.options.currentChunkIndex = this.options.defaultChunkIndex;
			if (this.options.type === null) {
				// infer type
				this.options.type = this.grid._inferOpType();
			}
			// delegate to the data source all paging options
			this.grid.dataSource.settings.paging.type = this.options.type || "remote";
			// delegate to the data source all paging options
			this._defaultChunkSize = parseInt(this.options.chunkSize, 10) * (this.options.defaultChunkIndex + 1);
			this.grid.dataSource.settings.paging.pageSize = this._defaultChunkSize;

			if (this.options.chunkSizeUrlKey !== null && this.options.chunkIndexUrlKey) {
				this.grid.dataSource.settings.paging.pageSizeUrlKey = this.options.chunkSizeUrlKey;
				this.grid.dataSource.settings.paging.pageIndexUrlKey = this.options.chunkIndexUrlKey;
			}
			if (this.options.recordCountKey !== null) {
				this.grid.dataSource.settings.responseTotalRecCountKey = this.options.recordCountKey;
			}
			this.grid.dataSource.settings.paging.enabled = true;
			if (this.options.loadTrigger === "auto") {
				this._verticalScrollHandler = $.proxy(this._probeForNextPage, this);
			}
			this._appendRecordsHandler = $.proxy(this._appendRecords, this);
			this.grid.element.bind('iggridrowsrendered', this._rowsRenderingHandler);
		},
		_dataRendered: function () {
			var scrollId = "#" + this.grid.scrollContainer()[0].id, buttonId, container;
			this.grid.scrollContainer().css("background-color", "white");
			this._originalDataSourceCallback = this.grid.dataSource.settings.callback;
			this._initLoadingIndicator();
			if (this.options.loadTrigger === "auto") {
				$(scrollId).unbind("scroll", this._verticalScrollHandler);
				$(scrollId).bind("scroll", this._verticalScrollHandler);
				this._probeForNextPage();
			}
			this._requestPending = false;
			if (this.options.loadTrigger === "button") {
				if (!this._buttonRow) {
					buttonId = this.grid.id() + "_loadMoreButton";
					container = this.grid.options.height ? this.grid.scrollContainer() : this.grid.container();
					this._buttonRow = container.append("<div class='ui-iggrid-loadmorebutton'><input type='button' id='" + buttonId + "'></input></div>");
					$("#" + buttonId).igButton({
						labelText: this.options.loadMoreDataButtonText,
						click: $.proxy(this._nextChunk, this),
						width: "100%"
					});
				}
			}

			if (this._loadingIndicator) {
				this._hideLoading();
			}
		},
		_checkNotSupportedScenarios: function () {
			// Throw an exception for unsupported integration scenarios
			if (this.options.loadTrigger === "auto" && !this.grid.options.height) {
				throw new Error($.ig.GridLoadOnDemand.locale.loadOnDemandRequiresHeight);
			}

			if (this.grid.options.virtualization) {
				throw new Error($.ig.GridLoadOnDemand.locale.virtualizationNotSupported);
			}

			var i, featureName,
			features = this.grid.options.features, featuresLength = features.length;
			if (featuresLength === 1) {
				return;
			}
			for (i = 0; i < featuresLength; i++) {
				featureName = features[i].name;
				if (!featureName) {
					continue;
				}
				featureName = featureName.toLowerCase();
				switch (featureName) {
					case "groupby":
						throw new Error($.ig.GridLoadOnDemand.locale.groupByNotSupported);
					case "paging":
						throw new Error($.ig.GridLoadOnDemand.locale.pagingNotSupported);
					case "cellmerging":
						throw new Error($.ig.GridLoadOnDemand.locale.cellMergingNotSupported);
				}
			}
		},
		_setOption: function (key, value) {
			// handle new settings and update options hash
			$.Widget.prototype._setOption.apply(this, arguments);
			// options that are supported: 
			// start by throwing an error for the options that aren't supported
			if (key === "defaultChunkIndex") {
				throw new Error($.ig.Grid.locale.optionChangeNotSupported + ' ' + key);
			}
			if (key === "currentChunkIndex" || key === "chunkSize") {
				this.grid.dataSource.settings.paging.pageSize = (this.options.currentChunkIndex + 1) * this.options.chunkSize;
				this.grid.dataSource.dataBind();
			}
		},
		_initLoadingIndicator: function () {
			// attach loading indicator widget
			this._loadingIndicator = this.grid.container().igLoading().data("igLoading").indicator();
		},
		_nextChunk: function () {
			var noCancel = true;
			if (this.grid.dataSource.pageIndex() >= (this.grid.dataSource.pageCount() - 1)) {
				return;
			}
			noCancel = this._trigger(this.events.rowsRequesting, null, { owner: this, chunkIndex: this.options.currentChunkIndex + 1, chunkSize: this.options.chunkSize });
			if (noCancel) {
				this._showLoading();
				this.grid.dataSource.settings.paging.pageSize = this.options.chunkSize;
				this.grid.dataSource.settings.paging.pageIndex = this.options.currentChunkIndex;
				this.grid.dataSource.settings.paging.appendPage = true;
				this._originalDataSourceCallback = this.grid.dataSource.settings.callback;
				this.grid.dataSource.settings.callback = this._appendRecordsHandler;
				this._requestPending = true;
				this.grid.dataSource.nextPage();
			}
		},
		_showLoading: function () {
			this._loadingIndicator.show();
		},
		_hideLoading: function () {
			this._loadingIndicator.hide();
		},
		destroy: function () {
			/* destroys the load on demand widget */
			var buttonId = this.grid.id() + "_loadMoreButton",
				scrollId = "#" + this.grid.scrollContainer()[0].id,
				container = this.grid.options.height ? this.grid.scrollContainer() : this.grid.container(),
				button = this.grid.container().find("div.ui-iggrid-loadmorebutton");
			$("#" + buttonId).igButton("destroy");
			if (button) {
				button.remove();
			}
			this.grid.element.unbind('iggridrowsrendered', this._rowsRenderingHandler);
			$(scrollId).unbind("scroll", this._verticalScrollHandler);
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		_appendRecords: function (success, errmsg) {
			var i, currentPage = [], noCancelError, sorting = this.grid.element.data("igGridSorting");
			if (success === true) {
				currentPage = this.grid.dataSource.recordsForPage(this.grid.dataSource.settings.paging.pageIndex);
				}
			this._requestPending = false;
			this.grid.dataSource.settings.paging.pageSize = this.options.chunkSize * (this.options.currentChunkIndex + 1);
			this.grid.dataSource.settings.paging.pageIndex = 0;
			this.grid.dataSource.settings.paging.appendPage = false;
			this.grid.dataSource.settings.callback = this._originalDataSourceCallback;
			for (i = 0; i < currentPage.length; i++) {
				this.grid.renderNewRow(currentPage[i]);
			}
			// re-apply sorting styles
			if (sorting) {
				sorting._dataRendered();
			}
			this._hideLoading();
			if (success === false) {
				// check if there is an event requestError defined
				noCancelError = this._trigger(this.grid.events.requestError, null, {owner: this, message: errmsg});
				// if the handler returns false or doesn't return anything, the error will be propagated to teh grid and an Error object will be returned
				if (noCancelError) {
					throw new Error(errmsg);
				}
			}
			this.options.currentChunkIndex++;
			this.grid.dataSource.settings.paging.pageSize = this.options.chunkSize * (this.options.currentChunkIndex + 1);
			this._trigger(this.events.rowsRequested, null, { owner: this, chunkIndex: this.options.currentChunkIndex, chunkSize: this.options.chunkSize, rows: currentPage });
		},
		_refreshData: function () {
			this._showLoading();
			this.grid.dataSource.settings.paging.appendPage = false;
			this.grid.dataSource.settings.callback = this._originalDataSourceCallback;
			this._requestPending = true;
			this.grid.dataSource.dataBind();
		},
		_probeForNextPage: function (evt, ui) {
			var delta = (this.grid.scrollContainer().scrollTop() + this.grid.scrollContainer().height()) / $(this.grid.element).height();
			if ((delta >= 1) && !this._requestPending) {
				this._nextChunk();
			}
		},
		nextChunk: function () {
			/*Loads the next chunk of data.*/
			this._nextChunk();
		}
	});
	$.extend($.ui.igGridLoadOnDemand, {version: '14.1.20141.2249'});
}(jQuery));
/*!@license
 * Infragistics.Web.ClientUI Grid Multi Headers 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {
	$.widget("ui.igGridMultiColumnHeaders", {
		/* 
		igGridMultiHeaders widget 
		The widget is pluggable to the element where the grid is instantiated and the actual igGrid object doesn't know about it.
		*/
		css: {
			/* classes applied to the multi-column header cell(group header cell which has children in the multi-column headers) */
			multiHeaderCell: 'ui-iggrid-multiheader-cell'
		},
		options: {
		},
		_createWidget: function () {
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		_renderingMultiColumnHeader: function () {
			// internal event multi column headers
			this._renderHeaderColumns(this.grid._headerParent);
			this.grid._trigger(this.grid.events.headerRendered, null, {owner: this.grid, table: this.grid.headersTable()});
			this.grid._headerRenderCancel = false;
		},
		_analyzeRowspanRows: function (oldCols, level) {
			// analyze rowspans for each cell
			// if header is at level 0 set its rowspan if it is rendered on row which is not on level 0
			// if rowspan is set for some of the column cells through column options generates custom spans and sets the correct level at which columns should be rendered
			var i, col, groups = [], ml = this.grid._maxLevel - level, rowspan;

			for (i = 0; i < oldCols.length; i++) {
				rowspan = 1;
				col = oldCols[i];
				// M.H. 4 July 2012 Fix for bug #116205
				if ($.type(col.rowspan) === "string") {
					col.rowspan = parseInt(col.rowspan, 10);
				}
				if (col.rowspan > 0) {
					rowspan = col.rowspan;
				}
				if (col.group !== undefined && col.group !== null) {
					groups.push({group: col.group, level: level + rowspan});
				} else {
					if (col.level === 0) {
						// M.H. 4 July 2012 Fix for bug #116205
						if (col.rowspan === null || col.rowspan === undefined || isNaN(col.rowspan)) {
							if (ml + 1 - col.level > 0) {
								col.rowspan = ml + 1 - col.level;
							}
						}
					}
				}
				if (this._rows[ml] === undefined || this._rows[ml] === null) {
					this._rows[ml] = [];
				}
				this._rows[ml].push(col);
			}
			for (i = 0; i < groups.length; i++) {
				this._analyzeRowspanRows(groups[i].group, groups[i].level);
			}
		},
		_renderRow: function (headerContainer, row, level) {
			// render each row
			var col, i, $headerCell, $tr = $('<tr data-mch-level="' + level + '"></tr>').appendTo(headerContainer);

			for (i = 0; i < row.length; i++) {
				col = row[i];
				$headerCell = this._createHeaderColumnMarkup(col.headerText, col.colspan, col.key, col.level, col.identifier, col.rowspan);
				$headerCell.appendTo($tr);
			}
		},
		_renderHeaderColumns: function ($container) {
			// function is called when the internal event _renderingMultiColumnHeader is called
			// analyze multicolumn headers - set for each row the necessary header cells and renders header columns
			var $th, i, j, k, oldCols, parents, key, headersTable, parentCol, mchElement,
				cols = this.grid.options.columns, mchChildren, isToHide,
				colsLength = cols.length,
				initHiddenCols = this.grid._initialHiddenColumns,
				gridId = this.grid.id(), $thead;

			this._arrayTargetRowspan = [];
			this._totalColumnsLength = $container.find('colgroup col').length;
			// M.H. 23 Aug 2012 Fix for bug #118364 - if container has thead then empty and use it to show MCH - e.g.: when binding to table
			$thead = $container.find('thead');
			if ($thead.length > 0) {
				$container = $thead.empty();
			} else {
				$container = $('<thead></thead>').appendTo($container);
			}
			this._tr = {};
			oldCols = this.grid._oldCols;
			this._rows = {};
			// analyze rowspans for reach row and sets for each row which are column columns
			this._analyzeRowspanRows(oldCols, 0);
			// when analyzed redner multicolumn headers
			for (i = this.grid._maxLevel; i >= 0; i--) {
				if (this._rows[i] !== null && this._rows[i] !== undefined) {
					this._renderRow($container, this._rows[i], i);
				}
			}
			// set data-index and populates headercells - internal array which persists order of column header cells at level 0
			for (i = 0; i < colsLength; i++) {
				$th = this.grid.container().find('#' + gridId + '_' + cols[i].key).data('columnIndex', i);
				$th.data('data-mch-order', i);
				this.grid._headerCells.push($th);
			}
			// M.H. 20 July 2012 Fix for bug #117468
			if (initHiddenCols) {
				// M.H. 27 Mar 2013 Fix for bug #117468: When the grid is bound to remote data and at least one column from (the first defined) column group is hidden by default, that column's header cell is still visible while the grid is waiting for the data
				headersTable = this.grid.headersTable().find('thead');
				for (i = 0; i < initHiddenCols.length; i++) {
					// M.H. 27 Mar 2013 Fix for bug #117468: When the grid is bound to remote data and at least one column from (the first defined) column group is hidden by default, that column's header cell is still visible while the grid is waiting for the data
					key = initHiddenCols[i].key;
					this.grid.container().find('#' + gridId + '_' + key).css('display', 'none');
					parents = this.grid._getParentsMultiHeader(key);
					// M.H. 3 Apr 2013 Fix for bug #138703: Initially hidden column hides all group of multi column headers
					for (j = 0; j < parents.length; j++) {
						parentCol = parents[j];
						if (parentCol.level > 0) {
							mchElement = this.grid._getMultiHeaderColumnById(parentCol.identifier);
							if (mchElement && mchElement.children) {
								mchChildren = mchElement.children;
								isToHide = true;
								if (mchElement.hidden !== true) {
									for (k = 0; k < mchChildren.length; k++) {
										if (mchChildren[k].level === 0) {
											$th = this.grid.container().find('#' + gridId + '_' + mchChildren[k].key);
										} else {
											$th = headersTable.find('th[data-mch-id=' + mchChildren[k].identifier + ']');
										}
										if (!$th.is(':visible')) {
											isToHide = false;
											break;
										}
									}
								}
								if (isToHide) {
									headersTable.find('th[data-mch-id=' + parentCol.identifier + ']').css('display', 'none');
								}
							}
						}
					}
					
				}
			}
		},
		_createHeaderColumnMarkup: function (headerText, colSpan, columnKey, level, identifier, rowspan) {
			// render each header column and fire headerCellRendered event
			var grid = this.grid, id,
				isMultiColumnHeader = true,
				headerClass = grid.css.headerClass,
				$th = $('<th></th>'),
				$headerCell;

			$headerCell = $th.append('<span class="' + grid.css.headerTextClass + '">' + headerText + '</span>')
				.attr('role', 'rowheader').addClass(headerClass);
			if (colSpan > 1) {
				$th.attr('colspan', colSpan);
			}
			if (rowspan > 1) {
				$headerCell.attr('rowspan', rowspan);
			}

			if (columnKey) {
				$headerCell.attr('id', this.grid.element[0].id + '_' + columnKey);
			}
			if (level === 0) {
				id = columnKey;
				isMultiColumnHeader = false;
				$headerCell.attr('data-isheadercell', true);
			} else {
				id = identifier;
				$headerCell.addClass(this.css.multiHeaderCell);
				$headerCell.attr('data-mch-id', identifier);
			}

			grid._trigger(grid.events.headerCellRendered, null, {owner: grid, th: $headerCell, columnKey: id, isMultiColumnHeader: isMultiColumnHeader});

			return $headerCell;
		},
		getMultiColumnHeaders: function () {
			/* returns multicolumn headers array. if there aren't multicolumn headers returns undefined
				returnType="array" array of columns
			*/
			return this.grid._oldCols;
		},
		destroy: function () {
			/* destroys the multicolumn widget */
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		_injectGrid: function (gridInstance, isRebind) {
			this.grid = gridInstance;
		}
	});

	$.extend($.ui.igGridMultiHeaders, {version: '14.1.20141.2249'});
}(jQuery));
/*!@license
 * Infragistics.Web.ClientUI Grid Paging 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.editors.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery, toStaticHTML */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {

	// we will define a new widget for paging. That kind of widget is completely independent one and doesn't subclass the grid 
	// it subscribes to grid events such as BodyRendered, and has the grid instance (igGrid) injected into it
	// for paging 
	/*
		igGridPaging widget -  The widget is pluggable to the element where the grid is instantiated and the actual igGrid object doesn't know about this
		the paging widget just attaches its functionality to the grid 
		the paging widget renders most of its UI in the grid footer. Optionally there can be a dropdown to choose the page size, that can be placed above the header
		keyboard navigation inside the pager is supported with TAB & SPACE/ENTER keys 
	*/
	$.widget("ui.igGridPaging", {
		css : {
			/*  classes applied to the pager area */
			"pagerClass" : "ui-widget ui-iggrid-pager ui-helper-clearfix ui-corner-bottom ui-widget-header ui-iggrid-footer",
			/* classes applied to a page link that can be clicked with the mouse */
			"pageLink" : "ui-iggrid-pagelink ui-helper-reset",
			/* classes applied to a page container element (list item) */
			"page" : "ui-iggrid-page ui-state-default ui-corner-all",
			/* classes applied to a page list item when it's hovered */
			"pageHover": "ui-iggrid-page-hover ui-state-hover",
			/* classes applied to the UL list that holds all pages */
			"pageList" : "ui-helper-reset ui-iggrid-pagelist ui-iggrid-paging-item",
			/* classes applied to the anchor of the current page item */
			"pageLinkCurrent" : "ui-iggrid-pagelinkcurrent",
			/* clases applied to the current page (corresponding to the current page index) */
			"pageCurrent" : "ui-iggrid-pagecurrent ui-state-active ui-corner-all",
			/* classes applied to the current page that has focus (when keyboard anvigation is used) */
			"pageFocused" : "ui-iggrid-pagefocused ui-state-focus",
			/* classes applied to the area where the next page button and label are rendered */
			"nextPage" : "ui-iggrid-nextpage ui-iggrid-paging-item ui-state-default",
			/* classes applied to the area where the prev page button and label are rendered */
			"prevPage" : "ui-iggrid-prevpage ui-iggrid-paging-item ui-state-default",
			/* classes applied to the area where the first page button and label are rendered */
			"firstPage" : "ui-iggrid-firstpage ui-iggrid-paging-item ui-state-default ui-corner-left",
			/* classes applied to the area where the last page button and label are rendered */
			"lastPage" : "ui-iggrid-lastpage ui-iggrid-paging-item ui-state-default ui-corner-right",
			/* classes applied to the next page's label (span) */
			"nextPageLabel" : "ui-iggrid-nextpagelabel",
			/* classes applied to the prev page's label (span) */
			"prevPageLabel" : "ui-iggrid-prevpagelabel",
			/* classes applied to the first page's label (span) */
			"firstPageLabel" : "ui-iggrid-firstpagelabel",
			/* classes applied to the last page's label (span) */
			"lastPageLabel" : "ui-iggrid-lastpagelabel",
			/* classes applied to the next page's label (span) when it's disabled */
			"nextPageLabelDisabled" : "ui-iggrid-nextpagelabeldisabled ui-state-disabled",
			/* classes applied to the prev page's label (span) when it's disabled */
			"prevPageLabelDisabled" : "ui-iggrid-prevpagelabeldisabled ui-state-disabled",
			/* classes applied to the first page's label (span) when it's disabled */
			"firstPageLabelDisabled" : "ui-iggrid-firstpagelabeldisabled ui-state-disabled",
			/* classes applied to the last page's label (span) when it's disabled */
			"lastPageLabelDisabled" : "ui-iggrid-lastpagelabeldisabled ui-state-disabled",
			/* classes applied to the next page area that holds the span for the icon */
			"nextPageImage" : "ui-iggrid-pageimg ui-iggrid-nextpageimg ui-icon ui-icon-triangle-1-e",
			/* classes applied to the prev page area that holds the span for the icon */
			"prevPageImage" : "ui-iggrid-pageimg ui-iggrid-prevpageimg ui-icon ui-icon-triangle-1-w",
			/* classes applied to the first page area that holds the span for the icon */
			"firstPageImage" : "ui-iggrid-pageimg ui-iggrid-firstpageimg ui-icon ui-icon-arrowstop-1-w",
			/* classes applied to the last page area that holds the span for the icon */
			"lastPageImage" : "ui-iggrid-pageimg ui-iggrid-lastpageimg ui-icon ui-icon-arrowstop-1-e",
			/* classes applied to the next page area that holds the span for the icon when it is disabled */
			"nextPageImageDisabled" : "ui-iggrid-pageimg ui-iggrid-nextpageimgdisabled ui-icon ui-state-disabled ui-icon-triangle-1-e",
			/* classes applied to the prev page area that holds the span for the icon when it is disabled */
			"prevPageImageDisabled" : "ui-iggrid-pageimg ui-iggrid-prevpageimgdisabled ui-icon ui-state-disabled ui-icon-triangle-1-w",
			/* classes applied to the first page area that holds the span for the icon when it is disabled */
			"firstPageImageDisabled" : "ui-iggrid-pageimg ui-iggrid-firstpageimgdisabled ui-icon ui-state-disabled ui-icon-arrowstop-1-w",
			/* classes applied to the last page area that holds the span for the icon when it is disabled */
			"lastPageImageDisabled" : "ui-iggrid-pageimg ui-iggrid-lastpageimgdisabled ui-icon ui-state-disabled ui-icon-arrowstop-1-e",
			/* classes applied to the label showing how many records are rendered of some total number */
			"pagerRecordsLabel" : "ui-iggrid-pagerrecordslabel ui-iggrid-results",
			/* classes applied to the editor dropdown label from where page size can be changed */
			"pageSizeLabel" : "ui-iggrid-pagesizelabel",
			/* classes applied to the editor dropdown from where page size can be changed */
			"pageSizeDropDown" : "ui-iggrid-pagesizedropdown",
			/* classes applied to the element that holds the page size dropdown */
			"pageSizeDropDownContainer" : "ui-helper-clearfix ui-iggrid-pagesizedropdowncontainer",
			/* classes applied to the container of the page size dropdown editor, when it is rendered above the header */
			"pageSizeDropDownContainerAbove" : "ui-widget ui-helper-clearfix ui-iggrid-pagesizedropdowncontainerabove ui-iggrid-toolbar ui-widget-header and ui-corner-top",
			/* classes applied to the element holding the editor dropdown from where the page index can be changed */
			"pageDropDownContainer" : "ui-iggrid-pagedropdowncontainer",
			/* classes applied to the spans that are before and after the dropdown editor from where the page index can be changed */
			"pageDropDownLabels" : "ui-iggrid-pagedropdownlabels",
			/* classes applied to the editor dropdown from where the page index can be changed */
			"pageDropDown" : "ui-iggrid-pagedropdown",
			/* classes applied to the area on the right of the footer where first, last, prev, next buttons as well as page links and page index dropdown are rendered */
			"pagerRightAreaContainer": "ui-iggrid-paging",
			/* classes applied around the label showing the currently rendered record indices out of some total value */
			"pagingResults": "ui-iggrid-results"
		},
		options: {
			/* type="number" default number of records per page */
			pageSize: 25,
			/* type="string" the property in the response that will hold the total number of records in the data source */
			recordCountKey: null,
			/* type="string" denotes the name of the encoded URL parameter that will state what is the currently requested page size */
			pageSizeUrlKey: null,
			/* type="string" denotes the name of the encoded URL parameter that will state what is the currently requested page index */
			pageIndexUrlKey: null,
			/* type="number" current page index that's bound and rendered in the UI */
			currentPageIndex: 0,
			/* type="remote|local"
			remote type="string" request
			local type="string" paging on the client-side
			*/
			type: null,
			/* type="bool" if false, a dropdown allowing to change the page size will not be rendered in the UI */
			showPageSizeDropDown: true,
			/* type="string" label rendered in front of the page size dropdown */
			pageSizeDropDownLabel: $.ig.GridPaging.locale.pageSizeDropDownLabel,
			/* type="string" Trailing label for the page size dropdown */
			pageSizeDropDownTrailingLabel: $.ig.GridPaging.locale.pageSizeDropDownTrailingLabel,
			/* type="above|inpager"
			above type="string" it will be rendered above the grid header
			inpager type="string" it will be rendered next to page links
			*/
			pageSizeDropDownLocation: 'above',
			/* type="bool" option specifying whether to show summary label for the currently rendered records or not */
			showPagerRecordsLabel: true,
			/* type="string" custom pager records label template - in jQuery templating style and syntax */
			pagerRecordsLabelTemplate: $.ig.GridPaging.locale.pagerRecordsLabelTemplate,
			/* type="string" localized text for the next page label */
			nextPageLabelText: $.ig.GridPaging.locale.nextPageLabelText,
			/* type="string" localized text for the prev page label */
			prevPageLabelText: $.ig.GridPaging.locale.prevPageLabelText,
			/* type="string" localized text for the first page label */
			firstPageLabelText: $.ig.GridPaging.locale.firstPageLabelText,
			/* type="string" localized text for the last page label */
			lastPageLabelText: $.ig.GridPaging.locale.lastPageLabelText,
			/* type="bool" option specifying whether to render the first and last page buttons */
			showFirstLastPages: true,
			/* type="bool" option specifying whether to render the previous and next page buttons */
			showPrevNextPages: true,
			/* type="string" leading label for the dropdown from where the page index can be switched */
			currentPageDropDownLeadingLabel: $.ig.GridPaging.locale.currentPageDropDownLeadingLabel,
			/* type="string" localized trailing label for the dropdown from where the page index can be switched */
			currentPageDropDownTrailingLabel: $.ig.GridPaging.locale.currentPageDropDownTrailingLabel,
			/* type="string" custom localized tooltip for the page index dropdown */
			currentPageDropDownTooltip: $.ig.GridPaging.locale.currentPageDropDownTooltip,
			/* type="string" custom localized tooltip for the page size dropdown */
			pageSizeDropDownTooltip: $.ig.GridPaging.locale.pageSizeDropDownTooltip,
			/* type="string" custom localized tooltip for the pager records label */
			pagerRecordsLabelTooltip: $.ig.GridPaging.locale.pagerRecordsLabelTooltip,
			/* type="string" custom localized tooltip for the prev. page button */
			prevPageTooltip: $.ig.GridPaging.locale.prevPageTooltip,
			/* type="string" custom localized tooltip for the next. page button */
			nextPageTooltip: $.ig.GridPaging.locale.nextPageTooltip,
			/* type="string" custom localized tooltip for the first. page button */
			firstPageTooltip: $.ig.GridPaging.locale.firstPageTooltip,
			/* type="string" custom localized tooltip for the last. page button */
			lastPageTooltip: $.ig.GridPaging.locale.lastPageTooltip,
			/* type="string" custom localized format string for tooltips of buttons that directly jump to a particular page. The format string follows the jQuery templating style and syntax. See also the pageCountLimit option.  */
			pageTooltipFormat: $.ig.GridPaging.locale.pageTooltipFormat,
			/* type="array" Default: [5, 10, 20, 25, 50, 75, 100]. contents of the page size dropdown indicating what preconfigured page sizes are available to the end user */
			pageSizeList: [],
			/* type="number" sets gets the number of pages which if exceeded a drop down list of page indices is displayed. If the number of pages is less than or equal to this option then page buttons are displayed. */
			pageCountLimit: 10,
			/* type="number" number of pages that are constantly visible. For the invisible pages, prev and next buttons are used */
			visiblePageCount: 5,
			/* type="number" dropdown width for page size and page index dropdowns */
			defaultDropDownWidth: 70,
			/* type="number" Time in milliseconds for which page dropdown will wait for keystrokes before changing the page. */
			delayOnPageChanged: 350
		},
		events: {
			/* cancel="true" Event fired before the page index is changed.
			Return false in order to cancel page index changing.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridPaging.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.currentPageIndex to get current page index.
			Use ui.newPageIndex to get new page index.
			*/
			pageIndexChanging: "pageIndexChanging",
			/* Event fired after the page index is changed , but before grid data rebinds 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridPaging.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.pageIndex to get current page index.
			*/
			pageIndexChanged: "pageIndexChanged",
			/* cancel="true" Event fired when the page size is about to be changed from the page size dropdown.
			Return false in order to cancel page size changing.			
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridPaging.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.currentPageSize to get current page size.
			Use ui.newPageSize to get new page size.
			*/
			pageSizeChanging: "pageSizeChanging",
			/* Event fired after the page size is changed from the page size dropdown. 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridPaging.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.pageSize to get current page size.
			*/
			pageSizeChanged: "pageSizeChanged",
			/* cancel="true" Event fired before the pager footer is rendered (the whole area below the grid records). 
			Return false in order to cancel pager footer rendering.			
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridPaging.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.dataSource to get reference to grid's data source.
			*/
			pagerRendering: "pagerRendering",
			/* Event fired after the pager footer is rendered 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridPaging.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.dataSource to get reference to grid's data source.
			*/
			pagerRendered: "pagerRendered"
		},
		_loadingIndicator: null,
		_isPaging: false,
		_setOption: function (key, value) {
			var items, label, pager;
			pager = this._pager();
			// handle new settings and update options hash
			$.Widget.prototype._setOption.apply(this, arguments);
			// options that are supported: pageSize, currentPageIndex, showFirstLastPages, showPrevNextPages, pageSizeList, 
			// nextPageLabelText, prevPageLabelText, firstPageLabelText, lastPageLabelText
			// start by throwing an error for the options that aren't supported
			if (key === 'type' || key === 'showPageSizeDropDown' || key === 'pageSizeDropDownLocation' || key === 'showPagerRecordsLabel' ||
					key === 'visiblePageCount') {
				throw new Error($.ig.Grid.locale.optionChangeNotSupported + ' ' + key);
			}
			if (key === 'pageSize') {
				this.pageSize(value);
			} else if (key === 'currentPageIndex') {
				this.pageIndex(value);
			} else if (key === 'showFirstLastPages') {
				if (value === true) {
					pager.find('.ui-iggrid-firstpage').show();
					pager.find('.ui-iggrid-lastpage').show();
				} else {
					pager.find('.ui-iggrid-firstpage').hide();
					pager.find('.ui-iggrid-lastpage').hide();
				}
			} else if (key === 'showPrevNextPages') {
				if (value === true) {
					pager.find('.ui-iggrid-prevpage').show();
					pager.find('.ui-iggrid-nextpage').show();
				} else {
					pager.find('.ui-iggrid-prevpage').hide();
					pager.find('.ui-iggrid-nextpage').hide();
				}
			} else if (key === 'pageSizeList') {
				if ($.type(value) === 'string') {
					items = value.split(',');
				} else {
					items = value;
				}
				if (this._pageSizeDD) {
					this._pageSizeDD.igEditor('option', 'listItems', items);
				}
			} else if (key === 'nextPageLabelText') {
				label = pager.find('.ui-iggrid-nextpagelabel');
				label = label.length === 0 ? pager.find('.ui-iggrid-nextpagelabeldisabled') : label;
				label.text(value);
			} else if (key === 'prevPageLabelText') {
				label = pager.find('.ui-iggrid-prevpagelabel');
				label = label.length === 0 ? pager.find('.ui-iggrid-prevpagelabeldisabled') : label;
				label.text(value);
			} else if (key === 'firstPageLabelText') {
				label = pager.find('.ui-iggrid-firstpagelabel');
				label = label.length === 0 ? pager.find('.ui-iggrid-firstpagelabeldisabled') : label;
				label.text(value);
			} else if (key === 'lastPageLabelText') {
				label = pager.find('.ui-iggrid-lastpagelabel');
				label = label.length === 0 ? pager.find('.ui-iggrid-nextpagelabeldisabled') : label;
				label.text(value);
			}
		},
		// Accepts parameters:
		// index - page index to switch to 
		pageIndex: function (index) {
			/* gets /sets the current page index, delegates data binding and paging to $.ig.DataSource 
				paramType="number" optional="true" the page index to go to
				returnType="number" optional="true" if no param is specified, returns the current page index
			*/
			if (index !== null && index !== undefined) {
				this._overrideLabel = true;
				this.options.currentPageIndex = index;
			}
			// fire partial dirty event - currently used only in Selection - cause we just need to call clearSelection without clearing any visual states or reset the whole UI 
			// we cannot use UI Dirty cause if we trigger this event here it means behaviors such as *Sorting* (not Selection!) will reset their whole state, and we want to keep the
			// data sorted (for example) while paging locally
			// L.A. 12 June 2012 - Fixing bug #114318
			// If index is not set then the pageIndex is called as GET index, so it's not necessary to 
			// to call the UIDIRTY function which removes clears the selection
			if (index !== undefined && index !== null) {
				this.grid.element.trigger('iggriduisoftdirty', {owner: this});
			}
			// M.H. 20 Sep 2013 Fix for bug #145014: When using remote paging and sorting  the values of the unbound columns set via the unboundValues option are not persisted.
			// M.H. 15 Oct 2013 Fix for bug #154987: When the dataSource is remote, any action that rearranges records mess up the unbound values
			if (this.grid._hasUnboundColumns && this.options.type === 'remote') {
				this.grid._rebindUnboundColumns = true;
			}
			return this.grid.dataSource.pageIndex(index);
		},
		// Accepts parameters:
		// size - page size 
		pageSize: function (size) {
			/* gets / sets the page Size. if no parameter is specified, just returns the current page size
				paramType="number" optional="true" the page size 
				returnType="number" optional="true" if no param is specified, returns the current page size
			*/
			var noCancel = true;
			if (size) {
				this.grid.dataSource.settings.paging.pageIndex = 0;
				this.options.currentPageIndex = 0;
				// trigger DataBinding / DataBound
				noCancel = this.grid._trigger(this.grid.events.dataBinding, null, {owner: this.grid});
				if (noCancel) {
					this._showLoading();
					// M.H. 20 Sep 2013 Fix for bug #145014: When using remote paging and sorting  the values of the unbound columns set via the unboundValues option are not persisted.
					// M.H. 15 Oct 2013 Fix for bug #154987: When the dataSource is remote, any action that rearranges records mess up the unbound values
					if (this.grid._hasUnboundColumns && this.options.type === 'remote') {
						this.grid._rebindUnboundColumns = true;
					}
					// M.H. 13 Feb 2014 Fix for bug #164277: Paging shows not existing chunk of data when you change the page size, change the page and data bind after that.
					this.options.pageSize = size;
					this.grid.dataSource.pageSize(size);
				}
				//A.T. 14 Feb 2011 - fix for bug #65975
				// update page size dropdown
				if (this._pageSizeDD) {
					this._pageSizeDD.igEditor('value', size);
				}
			} else {
				return this.grid.dataSource.pageSize();
			}
		},
		_initLoadingIndicator: function () {
			// attach loading indicator widget
			this._loadingIndicator = this.grid.container().igLoading().data("igLoading").indicator();
		},
		_nextPage: function (event) {
			var noCancel = true, noCancelBinding = true;
			noCancel = this._trigger(this.events.pageIndexChanging, null, {newPageIndex: this.options.currentPageIndex + 1, currentPageIndex: this.options.currentPageIndex, owner: this});
			if (noCancel) {
				if (this.options.currentPageIndex >= this.grid.dataSource.pageCount() - 1) {
					return;
				}
				this.options.currentPageIndex = this.options.currentPageIndex + 1;
				noCancelBinding = this.grid._trigger(this.grid.events.dataBinding, null, {owner: this.grid});
				this._shouldFirePageIndexChanged = true;
				if (noCancelBinding) {
					this._showLoading();
					this._overrideLabel = true;
					this.grid.element.trigger('iggriduisoftdirty', {owner: this});
					// M.H. 20 Sep 2013 Fix for bug #145014: When using remote paging and sorting  the values of the unbound columns set via the unboundValues option are not persisted.
					// M.H. 15 Oct 2013 Fix for bug #154987: When the dataSource is remote, any action that rearranges records mess up the unbound values
					if (this.grid._hasUnboundColumns && this.options.type === 'remote') {
						this.grid._rebindUnboundColumns = true;
					}
					this.grid.dataSource.nextPage();
				}
				//this._trigger(this.events.pageIndexChanged, null, {pageIndex: this.options.currentPageIndex, owner: this});
			}
			if (event) {
				event.stopPropagation();
				event.preventDefault();
			}
		},
		_prevPage: function (event) {
			var noCancel = true, noCancelBinding = true;
			noCancel = this._trigger(this.events.pageIndexChanging, null, {newPageIndex: this.options.currentPageIndex - 1, currentPageIndex: this.options.currentPageIndex, owner: this});
			if (noCancel) {
				if (this.options.currentPageIndex === 0) {
					return;
				}
				this.options.currentPageIndex = this.options.currentPageIndex - 1;
				noCancelBinding = this.grid._trigger(this.grid.events.dataBinding, null, {owner: this.grid});
				this._shouldFirePageIndexChanged = true;
				if (noCancelBinding) {
					this._showLoading();
					this._overrideLabel = true;
					this.grid.element.trigger('iggriduisoftdirty', {owner: this});
					// M.H. 20 Sep 2013 Fix for bug #145014: When using remote paging and sorting  the values of the unbound columns set via the unboundValues option are not persisted.
					// M.H. 15 Oct 2013 Fix for bug #154987: When the dataSource is remote, any action that rearranges records mess up the unbound values
					if (this.grid._hasUnboundColumns && this.options.type === 'remote') {
						this.grid._rebindUnboundColumns = true;
					}
					this.grid.dataSource.prevPage();
				}
				//this._trigger(this.events.pageIndexChanged, null, {pageIndex: this.options.currentPageIndex, owner: this});
			}
			if (event) {
				event.stopPropagation();
				event.preventDefault();
			}
		},
		_firstPage: function (event) {
			var noCancel = true, noCancelBinding = true;
			noCancel = this._trigger(this.events.pageIndexChanging, null, {newPageIndex: 0, currentPageIndex: this.options.currentPageIndex, owner: this});
			if (noCancel) {
				noCancelBinding = this.grid._trigger(this.grid.events.dataBinding, null, {owner: this.grid});
				this._shouldFirePageIndexChanged = true;
				if (noCancelBinding) {
					this._showLoading();
					this.pageIndex(0);
				}
				//this._trigger(this.events.pageIndexChanged, null, {pageIndex: 0, owner: this});
			}
			if (event) {
				event.stopPropagation();
				event.preventDefault();
			}
		},
		_lastPage: function (event) {
			var noCancel = true, noCancelBinding = true;
			noCancel = this._trigger(this.events.pageIndexChanging, null, {newPageIndex: this.grid.dataSource.pageCount() - 1, currentPageIndex: this.options.currentPageIndex, owner: this});
			if (noCancel) {
				noCancelBinding = this.grid._trigger(this.grid.events.dataBinding, null, {owner: this.grid});
				this._shouldFirePageIndexChanged = true;
				if (noCancelBinding) {
					this._showLoading();
					this.pageIndex(this.grid.dataSource.pageCount() - 1);
				}
				//this._trigger(this.events.pageIndexChanged, null, {pageIndex: this.grid.dataSource.pageCount() - 1, owner: this});
			}
			if (event) {
				event.stopPropagation();
				event.preventDefault();
			}
		},
		_showLoading: function () {
			this._loadingIndicator.show();
		},
		_hideLoading: function () {
			this._loadingIndicator.hide();
		},
		_bindEvents: function (pagerElement) {
			var paging = this, grid = this.grid, noCancel = true, id, noCancelBinding = true;
			id = '#' + grid.element[0].id + '_pager';
			// M.H. 7 Nov 2013 Fix for bug #156757: Clicking a button the change the page index does not work if you dont click on the text
			$(id + ' li').bind({
				mousedown: function (event) {
					// page changed 
					var $eventTarget = $(event.target),
						newIndex = $eventTarget.data('pageIndex');
					
					if (newIndex === undefined) {
						newIndex = $eventTarget.parent().data('pageIndex');
					}
					if ($.type(newIndex) === "number" && newIndex !== paging.options.currentPageIndex) {
						// fire PageIndexChanging
						noCancel = paging._trigger(paging.events.pageIndexChanging, event, {newPageIndex: newIndex, currentPageIndex: paging.options.currentPageIndex, owner: paging});
						paging._shouldFirePageIndexChanged = true;
						if (noCancel) {
							noCancelBinding = paging.grid._trigger(paging.grid.events.dataBinding, null, {owner: paging.grid});
							if (noCancelBinding) {
								paging._showLoading(grid.element.children("tbody"));
								paging.pageIndex(newIndex);
							}
							// decide exactly when should the pageIndexChanged event fire
							//paging._trigger(paging.events.pageIndexChanged, event, {pageIndex: paging.options.currentPageIndex, owner: paging});
						}
					}
				}
			});
			// hover styles
			$(id + ' li').bind({
				mouseover: function (event) {
					$(event.currentTarget).addClass(paging.css.pageHover);
				},
				mouseout: function (event) {
					$(event.currentTarget).removeClass(paging.css.pageHover);
				}
			});
			// L.A. 24 January 2013 - Fixing bug #130620 totalRecordsCount is inaccurate when adding or deleting rows
			this.grid.element.bind('iggridupdatinginternalrowdeleted', this._rowDeletedHandler);
			this.grid.element.bind('iggridupdatinginternalrowadded', this._rowAddedHandler);
		},
		_gridRendered: function (gridContainer) {
			var self = this;
			// L.A. 19 February 2013 - Fixing bug #124252
			// When the height is fixed and pageSizeDropDownLocation is inpager the footer and the next element in DOM are overlapped
			if (this.options.showPageSizeDropDown === true && this.options.pageSizeDropDownLocation === 'above' && !this._pageSizeDropDownRendered) {
				// the second arg means prepend not append if it is true
				self._renderPageSizeDropDown(gridContainer, true);
			}
			if (this.grid.options.autoAdjustHeight) {
				this.grid._initializeHeights();
				this.grid._adjustLastColumnWidth();
			}
			// remove rounded corners from the caption, if any
			// M.H. 10 June 2014 Fix for bug #173280: In Metro theme when caption is enabled the headers, caption and add new row do not extend across whole grid in IE 8+.
			if (this.grid.options.caption !== null &&
				!($.ig.util.isIE && $.ig.util.browserVersion >= 8)) {
				this.grid._caption().removeClass('ui-corner-top');
			}
		},
		_rowDeleted: function (evt, ui) {
			// M.H. 9 Sep 2013 Fix for bug #151489: Unable to delete rows when autoCommit is true and paging set to remote.
			if (this.options.type === "remote" || ui.owner.grid.id() !== this.grid.id()) {
				return;
			}
			// M.H. 3 Jul 2013 Fix for bug #146146: The rows displayed on a page become less than the page size and a page might become unavailable when deleting rows
			// when row is deleted we should apply again paging so rows to be shown properly - for instance to be shown those from previous page if not last page - zebra style will be lost
			var currentPageIndex = this.options.currentPageIndex,
				pageCount = this.grid.dataSource.pageCount();
			if (currentPageIndex > 0 && currentPageIndex + 1 > pageCount) {
				currentPageIndex--;
			}
			this.pageIndex(currentPageIndex);
		},
		_rowAdded: function (evt, ui) {
			if (this.options.type === "remote" || ui.owner.grid.id() !== this.grid.id()) {
				return;
			}
			var currentPageIndex = this.options.currentPageIndex,
				pageCount = this.grid.dataSource.pageCount();
			if (currentPageIndex < pageCount && this.grid.options.autoCommit) {
				this.pageIndex(pageCount - 1);
			} else {
				this._dataRendered();
			}
		},
		_gridCommit: function () {
			if (this.options.type === "remote") {
				return;
			}
			this.pageIndex(this.options.currentPageIndex);
			return true;
		},
		_plabel: function () {
			return this._pager().find(".ui-iggrid-pagerrecordslabel");
		},
		_pager: function () {
			return this.grid.container().find(".ui-iggrid-pager");
		},
		_dataRendered: function () {
			var id = this.grid.element[0].id,
				pageCount,
				i,
				html,
				// construct pager div
				pagerHtml = toStaticHTML('<div id="' + id +  '_pager"></div>'),
				pageLinkHtml = toStaticHTML('<li class="${pageClass}"><a class="${pageLinkClass}" href="javascript:void(0);">${page}</a></li>'),
				pager = null,
				startRecord = 0,
				endRecord = 0,
				recordsCount = 0,
				localRecordsCount = 0,
				noCancel = true,
				pageList,
				pagesArray,
				dropDownContainer,
				startPageIndex = 0,
				endPageIndex = 0,
				template = this.options.pagerRecordsLabelTemplate,
				self = this,
				pagerRight = null,
				vpc = this.options.visiblePageCount,
				val = 0,
				recordsLabel = null;
			this._deleteOld();
			noCancel = this._trigger(this.events.pagerRendering, null, {dataSource: this.grid.dataSource, owner: this});
			if (noCancel) {
				if (this.grid._shouldResetPaging) {
					this.options.currentPageIndex = 0;
					this.grid._shouldResetPaging = false;
				}
				// empty everything but the summary label
				if (this._plabel().length > 0) {
					this._pager().find(".ui-iggrid-paging").remove();
				} else {
					this._pager().empty();
				}
				this._initLoadingIndicator();
				if (this.grid.dataSource.pageSizeDirty()) {
					this.options.currentPageIndex = this.grid.dataSource.pageIndex();
					this.grid.dataSource.pageSizeDirty(false);
				}
				// check if we have virtualization enabled or not
				if (this._pager().length === 0) {
					id = this.grid.element[0].id;
					pager = $(pagerHtml).appendTo(this.grid.container());
				} else {
					pager = this._pager();
				}
				// apply pager class
				pager.addClass(this.css.pagerClass);
				if (this.options.showPagerRecordsLabel) {
					// calculate startRecord and endRecord
					recordsCount = this.grid.dataSource.totalRecordsCount() > 0 ? this.grid.dataSource.totalRecordsCount() : this.grid.dataSource.totalLocalRecordsCount();
					startRecord = this.options.currentPageIndex === 0 ? 1 : this.options.currentPageIndex * this.pageSize() + 1;

					// special case when there is filtering (Bug #67998)
					if (this.grid.dataSource._filter) {
						recordsCount = this.grid.dataSource._filteredData.length;
						localRecordsCount = this.grid.dataSource._filteredData.length;
					} else {
						localRecordsCount = this.grid.dataSource.totalLocalRecordsCount();
					}
					endRecord = this.options.currentPageIndex === 0 && this.pageSize() <= recordsCount ?
							this.pageSize() : startRecord + this.pageSize() > recordsCount ? recordsCount : (startRecord - 1) + this.pageSize();

					if (this.grid.dataSource.totalLocalRecordsCount() === 0) {
						// nothing to show
						startRecord = 0;
						endRecord = 0;
					}
					// check if dataView has less records than page size
					if (endRecord > localRecordsCount && this.options.type === "local") {
						endRecord = localRecordsCount;
					}
					// render label
					// M.H. 8 Mar 2013 Fix for bug #135130: When paging is defined after filtering and on filtering the footer is pagerRecordsLabelTemplate istead of filterSummaryTemplate
					if (this.grid.container().find(".ui-iggrid-footer .ui-iggrid-results").data('overrideLabel') === 0 ||
							this._overrideLabel || !this.grid.dataSource._filter) {
						this._plabel().remove();
						template = template.replace('${startRecord}', startRecord).replace('${endRecord}', endRecord).replace('${recordCount}', recordsCount);
						recordsLabel = $('<span>' + template + '</span>').appendTo(pager).attr('id', pager[0].id + '_label').addClass(this.css.pagerRecordsLabel).attr('title', this.options.pagerRecordsLabelTooltip).show();
					} else if (this._plabel().length === 0) {
						recordsLabel = $('<span></span>').appendTo(pager).attr('id', pager[0].id + '_label').addClass(this.css.pagerRecordsLabel).attr('title', this.options.pagerRecordsLabelTooltip).show();
					}
					if (recordsLabel) {
						recordsLabel.data('hideflag', false);
					}
					this._plabel().show();
					this._overrideLabel = false;
				}
				// get page count from the data source and render a span for each page index
				pageCount = this.grid.dataSource.pageCount();
				// A.T. render the container for first page, prev page, the page links, next page and last page
				pagerRight = $('<div></div>').appendTo(pager).addClass(this.css.pagerRightAreaContainer);
				if (this.options.showFirstLastPages === true) {
					this._renderFirstPage(pagerRight);
				}
				if (this.options.showPrevNextPages === true) {
					this._renderPrevPage(pagerRight);
				}
				// if the pageCountLimit is exceeded, switch to dropdown rendering automatically ! 
				if (this.grid.dataSource.pageCount() <= this.options.pageCountLimit) {
					pageList = $('<ul></ul>').appendTo(pagerRight).addClass(this.css.pageList);
					// M.H. 7 Nov 2013 Fix for bug #157047: Loading indicator does not disappear when changing page using keyboard navigation
					if (!this._pagerEvents) {
						this._pagerEvents = {
							keydown: function (event) {
								if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
									// L.A. 23 April 2012 Fixed bug #88118 The loading indicator is not displayed when keyboard navigation is used on the page index buttons (remote paging)
									self._showLoading();
									self.pageIndex($(event.currentTarget).closest('li').data('pageIndex'));
									event.stopPropagation();
									event.preventDefault();
								}
							},
							focus: function (event) {
								$(event.currentTarget).closest('li').addClass(self.css.pageFocused);
							},
							blur: function (event) {
								$(event.currentTarget).closest('li').removeClass(self.css.pageFocused);
							}
						};
					} else {
						this._pager().undelegate("li a", this._pagerEvents);
					}
					this._pager().delegate("li a", this._pagerEvents);
					val = Math.floor(parseInt(vpc, 10) / 2);
					// we will render the number of page links specified by visiblePageCount
					startPageIndex = this.options.currentPageIndex - val;
					if (startPageIndex < 0) {
						startPageIndex = 0;
					}
					endPageIndex = this.options.currentPageIndex + val;
					// compensate the indices, so that we always get the same count
					if (this.options.currentPageIndex - startPageIndex < val) {
						endPageIndex += val - (this.options.currentPageIndex - startPageIndex);
					}
					if (this.grid.dataSource.pageCount() - (this.options.currentPageIndex + 1) < val && vpc % 2 !== 0) {
						startPageIndex = startPageIndex - (val - (this.grid.dataSource.pageCount() - (this.options.currentPageIndex + 1)));
					}
					if (endPageIndex >= this.grid.dataSource.pageCount()) {
						endPageIndex = this.grid.dataSource.pageCount() - 1;
					}
					if (startPageIndex < 0) {
						startPageIndex = 0;
					}
					if (vpc % 2 === 0 && endPageIndex - startPageIndex < vpc - 1) {
						startPageIndex -= (vpc - 1) - (endPageIndex - startPageIndex);
					}
					if (startPageIndex < 0) {
						startPageIndex = 0;
					}
					for (i = startPageIndex; i <= endPageIndex && i - startPageIndex < vpc; i++) {
						html = pageLinkHtml.replace('${page}', (i + 1)).replace('${pageLinkClass}', i === this.options.currentPageIndex ? this.css.pageLinkCurrent : this.css.pageLink);
						html = html.replace('${pageClass}', i === this.options.currentPageIndex ? this.css.pageCurrent : this.css.page);
						$(html).appendTo(pageList).attr('title', this.options.pageTooltipFormat.replace('${index}', i + 1)).data('pageIndex', i);
					}
				} else {
					// render dropdown
					pagesArray = [];
					for (i = 1; i <= pageCount; i++) {
						pagesArray.push(i + this._empty());
					}
					// create the igEditor
					dropDownContainer = $('<div></div>').appendTo(pagerRight).addClass(this.css.pageDropDownContainer).attr('title', this.options.currentPageDropDownTooltip);
					$('<span></span>').appendTo(dropDownContainer).text(this.options.currentPageDropDownLeadingLabel).addClass(this.css.pageDropDownLabels);
					// render igEditor now
					this._curPageDD = $('<span />').css('display', 'none').appendTo(dropDownContainer).addClass(this.css.pageDropDownContainer).igEditor({
						listItems: pagesArray,
						readOnly: false,
						listMatchOnly: true,
						width: this.options.defaultDropDownWidth,
						nullable: false,
						listAutoComplete: true,
						button: 'dropdown',
						type: 'text',
						value: this.options.currentPageIndex + 1,
						dropDownTriggers: 'button,focus',
						textChanged: $.proxy(this._onSelectDropDownPageIndex, this)
					}).css('display', '');
					// render trailing label
					$('<span></span>').appendTo(dropDownContainer).text(this.options.currentPageDropDownTrailingLabel.replace('${count}', this.grid.dataSource.pageCount())).addClass(this.css.pageDropDownLabels);
				}
				if (this.options.showPrevNextPages === true) {
					this._renderNextPage(pagerRight);
				}
				if (this.options.showFirstLastPages === true) {
					this._renderLastPage(pagerRight);
				}
				if (this.options.showPageSizeDropDown && this.options.pageSizeDropDownLocation === 'inpager') {
					this._renderPageSizeDropDown(pagerRight);
				}
				this._bindEvents(pager);
				// hide loading message
				this._hideLoading(this.grid.element.children("tbody"));
				pager.show();
				// M.H. 8 May 2013 Fix for bug #138949: Inconsistent event sequence between local and remote pageSizeChanged event
				if (this._shouldFirePageSizeChanged) {
					this._shouldFirePageSizeChanged = false;
					this._trigger(this.events.pageSizeChanged, null, {pageSize: this.pageSize(), owner: this});
				}
				// fire pager rendered event 
				this._trigger(this.events.pagerRendered, null, {dataSource: this.grid.dataSource, owner: this});
				if (this._shouldFirePageIndexChanged) {
					this._shouldFirePageIndexChanged = false;
					this._trigger(this.events.pageIndexChanged, null, {pageIndex: this.options.currentPageIndex, owner: this});
				}
			}
		},
		_onSelectDropDownPageIndex: function (event, args) {
			var self = this;
			// M.H. 18 Jul 2013 Fix for bug #146362: Unable to type more than one digit in the paging dropdown input and go to page with number several digits long
			if (this._timeoutId !== undefined) {
				clearTimeout(this._timeoutId);
			}
			if (parseInt(this.options.delayOnPageChanged, 10) === 0) {
				this._dropDownPageIndex(event, args);
			} else {
				this._timeoutId = setTimeout(function () {self._dropDownPageIndex(event, args); }, this.options.delayOnPageChanged);
			}
		},
		_dropDownPageIndex: function (event, args) {
			var noCancel = true, noCancelBinding = true;
			noCancel = this._trigger(this.events.pageIndexChanging, null, {newPageIndex: parseInt(args.text, 10) - 1, currentPageIndex: this.options.currentPageIndex, owner: this});
			if (noCancel) {
				noCancelBinding = this.grid._trigger(this.grid.events.dataBinding, null, {owner: this.grid});
				if (noCancelBinding) {
					this._shouldFirePageIndexChanged = true;
					if (args.text) {
						this._showLoading();
						this.pageIndex(parseInt(args.text, 10) - 1);
					}
				}
				this.grid.element.trigger('iggriduisoftdirty', {owner: this});
				//this._trigger(this.events.pageIndexChanged, null, {pageIndex: this.options.currentPageIndex, owner: this});
			} else {
				// M.H. 13 May 2013 Fix for bug #141665: Canceling the pageSizeChanging and pageIndexChanging events does not revert the state of the pager drop downs.
				args.owner.value(this.options.currentPageIndex + 1);
			}
		},
		_renderPrevPage: function (pager) {
			// we render one div, which has one span for the prev image, and one span for the prev text
			var prev, self = this, imgspan;
			prev = $('<div></div>').appendTo(pager).addClass(this.css.prevPage).attr('title', this.options.prevPageTooltip);
			if (this.options.currentPageIndex === 0) {
				$('<span></span>').appendTo(prev).addClass(this.css.prevPageImageDisabled);
				$('<span></span>').appendTo(prev).addClass(this.css.prevPageLabelDisabled).append(this.options.prevPageLabelText);
			} else {
				prev.bind('mousedown', $.proxy(this._prevPage, this));
				imgspan = $('<span></span>').appendTo(prev).addClass(this.css.prevPageImage);
				$('<span></span>').appendTo(prev).addClass(this.css.prevPageLabel).append(this.options.prevPageLabelText);
				imgspan.wrap(toStaticHTML('<a href="javascript:void(0);"></a>'));
				imgspan.parent().bind({
					keydown: function (event) {
						if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
							self._prevPage();
							event.stopPropagation();
							event.preventDefault();
						}
					},
					focus: function (event) {
						$(event.currentTarget).closest('div').removeClass('ui-state-default').addClass('ui-state-focus');
					},
					blur: function (event) {
						$(event.currentTarget).closest('div').removeClass('ui-state-focus').addClass('ui-state-default');
					}
				});
			}
		},
		_renderNextPage: function (pager) {
			// we render one div, which has one span for the next image, and one span for the next text
			var next, self = this, imgspan;
			next = $('<div></div>').appendTo(pager).addClass(this.css.nextPage).attr('title', this.options.nextPageTooltip);
			if (this.options.currentPageIndex === this.grid.dataSource.pageCount() - 1) {
				$('<span></span>').appendTo(next).addClass(this.css.nextPageLabelDisabled).append(this.options.nextPageLabelText);
				$('<span></span>').appendTo(next).addClass(this.css.nextPageImageDisabled);
			} else {
				next.bind('mousedown', $.proxy(this._nextPage, this));
				$('<span></span>').appendTo(next).addClass(this.css.nextPageLabel).append(this.options.nextPageLabelText);
				imgspan = $('<span></span>').appendTo(next).addClass(this.css.nextPageImage);
				imgspan.wrap(toStaticHTML('<a href="javascript:void(0);"></a>'));
				imgspan.parent().bind({
					keydown: function (event) {
						if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
							self._nextPage();
							event.stopPropagation();
							event.preventDefault();
						}
					},
					focus: function (event) {
						$(event.currentTarget).closest('div').removeClass('ui-state-default').addClass('ui-state-focus');
					},
					blur: function (event) {
						$(event.currentTarget).closest('div').removeClass('ui-state-focus').addClass('ui-state-default');
					}
				});
			}
		},
		_renderFirstPage: function (pager) {
			var first, self = this, imgspan;
			first = $('<div></div>').appendTo(pager).addClass(this.css.firstPage).attr('title', this.options.firstPageTooltip);
			if (this.options.currentPageIndex === 0) {
				$('<span></span>').appendTo(first).addClass(this.css.firstPageImageDisabled);
				$('<span></span>').appendTo(first).addClass(this.css.firstPageLabelDisabled).append(this.options.firstPageLabelText);
			} else {
				first.bind('mousedown', $.proxy(this._firstPage, this));
				imgspan = $('<span></span>').appendTo(first).addClass(this.css.firstPageImage);
				$('<span></span>').appendTo(first).addClass(this.css.firstPageLabel).append(this.options.firstPageLabelText);
				imgspan.wrap(toStaticHTML('<a href="javascript:void(0);"></a>'));

				imgspan.parent().bind({
					keydown: function (event) {
						if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
							self._firstPage();
							event.stopPropagation();
							event.preventDefault();
						}
					},
					focus: function (event) {
						$(event.currentTarget).closest('div').removeClass('ui-state-default').addClass('ui-state-focus');
					},
					blur: function (event) {
						$(event.currentTarget).closest('div').removeClass('ui-state-focus').addClass('ui-state-default');
					}
				});
			}
		},
		_renderLastPage: function (pager) {
			// we render one div, which has one span for the next image, and one span for the next text
			var last, self = this, imgspan;
			last = $('<div></div>').appendTo(pager).addClass(this.css.lastPage).attr('title', this.options.lastPageTooltip);
			if (this.options.currentPageIndex === this.grid.dataSource.pageCount() - 1) {
				$('<span></span>').appendTo(last).addClass(this.css.lastPageLabelDisabled).append(this.options.lastPageLabelText);
				$('<span></span>').appendTo(last).addClass(this.css.lastPageImageDisabled);
			} else {
				last.bind('mousedown', $.proxy(this._lastPage, this));
				$('<span></span>').appendTo(last).addClass(this.css.lastPageLabel).append(this.options.lastPageLabelText);
				imgspan = $('<span></span>').appendTo(last).addClass(this.css.lastPageImage);
				imgspan.wrap(toStaticHTML('<a href="javascript:void(0);"></a>'));
				imgspan.parent().bind({
					keydown: function (event) {
						if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
							self._lastPage();
							event.stopPropagation();
							event.preventDefault();
						}
					},
					focus: function (event) {
						$(event.currentTarget).closest('div').removeClass('ui-state-default').addClass('ui-state-focus');
					},
					blur: function (event) {
						$(event.currentTarget).closest('div').removeClass('ui-state-focus').addClass('ui-state-default');
					}
				});
			}
		},
		_renderPageSizeDropDown: function (parent, prepend) {
			// render label here 
			var editorId = this.grid.id() + '_editor', cClass, items;
			cClass = this.options.pageSizeDropDownLocation === 'above' ? this.css.pageSizeDropDownContainerAbove : this.css.pageSizeDropDownContainer;
			if (prepend) {
				parent = $('<div></div>').prependTo(parent).addClass(cClass);
			} else {
				parent = $('<div></div>').appendTo(parent).addClass(cClass);
			}
			parent.attr('title', this.options.pageSizeDropDownTooltip);
			parent = $('<div></div>').appendTo(parent).addClass(this.css.pagingResults);
			if (prepend) {
				$('<span>' + this.options.pageSizeDropDownTrailingLabel + '</span>').prependTo(parent).addClass(this.css.pageSizeLabel);
				$('<span></span>').prependTo(parent).attr('id', editorId).addClass(this.css.pageSizeDropDown);
				$('<span>' + this.options.pageSizeDropDownLabel + '</span>').prependTo(parent).addClass(this.css.pageSizeLabel);
			} else {
				$('<span>' + this.options.pageSizeDropDownLabel + '</span>').appendTo(parent).addClass(this.css.pageSizeLabel);
				$('<span></span>').appendTo(parent).attr('id', editorId).addClass(this.css.pageSizeDropDown);
				$('<span>' + this.options.pageSizeDropDownTrailingLabel + '</span>').appendTo(parent).addClass(this.css.pageSizeLabel);
			}
			items = (this.options.pageSizeList === null || this.options.pageSizeList.length === 0) ? [5, 10, 20, 25, 50, 75, 100] : this.options.pageSizeList;
			if ($.type(items) === 'string') {
				items = items.split(',');
			}
			//this._pageSizeDD = $('#' + editorId).css('display', 'none').igEditor({
			this._pageSizeDD = this.grid.container().find("#" + editorId).css('display', 'none').igEditor({
				width: this.options.defaultDropDownWidth,
				button: 'dropdown',
				dropDownOnReadOnly: true,
				dropDownTriggers: 'button,focus',
				listItems: items,
				listMatchOnly: true,
				readOnly: true,
				textAlign: 'left',
				type: 'numeric',
				value: this.pageSize(),
				textChanged: $.proxy(this._changePageSize, this)
			}).css('display', '');
			// M.H. 26 Jul 2013 Fix for bug #146248: When enabled with various other features and the width of the columns causes a horizontal scrollbar, the column headers do not align with the columns
			// it is an edge case - the issue is caused by getting innerHTML of the input in igEdidor source. So one possible solution is just to force the browser to re-render header
			if ($.ig.util.isIE8 === true && this.grid.options._isHierarchicalGrid && this.grid.options.fixedHeaders) {
				$('<col></col>').appendTo(this.grid.headersTable().find('colgroup')).remove();
				//colgroup.find('col:last').detach().appendTo(colgroup);
			}
			this._pageSizeDropDownRendered = true;
			// S.S. September 21, 2012 - An event after rendering the dropdown container for the paging widget is needed by the Column Moving
			// to recalculate the header cell positions.
			this._trigger("pagingdropdownrendered");
		},
		_changePageSize: function (event, args) {
			// M.H. 20 Nov 2012 Fix for bug #127328
			var noCancel = true, size =  args.owner.value();
			noCancel = this._trigger(this.events.pageSizeChanging, null, {currentPageSize: this.pageSize(), newPageSize: size, owner: this});
			if (noCancel) {
				//A.T. 29 Nov 2011 - Fix for #91994 - moving the dirty event trigger before the page size change
				// that's necessary because if everything is bound remotely, the filtering/sorting/etc params can be encoded
				// in advance, before dirty is triggered, which will result in the filtering or sorting being persisted
				// trigger UI dirty on the grid
				// M.H. 12 Dec 2013 Fix for bug #159725: Filter option Tooltip displays as "No filter applied" after Page size is changed
				if (this.options.type === "remote") {
					this.grid.element.trigger('iggriduidirty', {owner: this});
				} else {
					this.grid.element.trigger('iggriduisoftdirty', {owner: this});
				}
				this.pageSize(size);
				// M.H. 8 May 2013 Fix for bug #138949: Inconsistent event sequence between local and remote pageSizeChanged event
				if (this.options.type === "remote") {
					this._shouldFirePageSizeChanged = true;
				} else {
					this._trigger(this.events.pageSizeChanged, null, {pageSize: size, owner: this});
				}
			} else {
				// M.H. 13 May 2013 Fix for bug #141665: Canceling the pageSizeChanging and pageIndexChanging events does not revert the state of the pager drop downs.
				args.owner.value(this.pageSize());
				//args.owner.value(size);
			}
		},
		_deleteOld: function (destroy) {
			if (this._curPageDD) {
				this._curPageDD.igEditor('destroy');
				delete this._curPageDD;
			}
			// L.A. 21 January 2013 - Fixing bug #131005
			// Exception is thrown in the filtering module when jQuery 1.9.1. is used
			if (this._pageSizeDD && this._pageSizeDD.closest("body").length > 0 && (destroy || this.options.pageSizeDropDownLocation === 'inpager')) {
				this._pageSizeDD.igEditor('destroy');
				delete this._pageSizeDD;
			}
			// M.H. 3 Jul 2013 Fix for bug #146146: The rows displayed on a page become less than the page size and a page might become unavailable when deleting rows
			this.grid.element.unbind('iggridupdatinginternalrowdeleted', this._rowDeletedHandler);
			this.grid.element.unbind('iggridupdatinginternalrowadded', this._rowAddedHandler);
		},
		destroy: function () {
			/*destroys the igGridPaging feature by removing all elements in the pager area, unbinding events, and resetting data to discard data filtering on paging*/
			var pager = this._pager();
			// rebind the grid by setting pageSize to 0
			this.pageSize(0);
			this._deleteOld(true);
			// unbind events and remove elements
			if (this.options.showPageSizeDropDown === true && this.options.pageSizeDropDownLocation === 'above') {
				$('#' + this.grid.container()[0].id + ' .ui-iggrid-pagesizedropdowncontainerabove').remove();
			}
			// jQuery's remove is recursive and should take care of unregistering all events and removing all child elements
			pager.remove();
			// M.H. 29 Oct 2012 Fix for bug #120642
			if (this._loadingIndicator) {
				delete this._loadingIndicator;
			}
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		// L.A. 24 January 2013 - Fixing bug #130620 totalRecordsCount is inaccurate when adding or deleting rows
		_createHandlers: function () {
			// M.H. 3 Jul 2013 Fix for bug #146146: The rows displayed on a page become less than the page size and a page might become unavailable when deleting rows
			this._rowDeletedHandler = $.proxy(this._rowDeleted, this);
			this._rowAddedHandler = $.proxy(this._rowAdded, this);
		},
		// every grid feature widget should implement this 
		_injectGrid: function (gridInstance, isRebind) {
			this.grid = gridInstance;
			// L.A. 24 January 2013 - Fixing bug #130620 totalRecordsCount is inaccurate when adding or deleting rows
			this._createHandlers();
			if (this.options.type === null) {
				// infer type
				this.options.type = this.grid._inferOpType();
			}
			// delegate to the data source all paging options
			this.grid.dataSource.settings.paging.type = this.options.type || "remote";
			//if (!isRebind) {
			this.grid.dataSource.settings.paging.pageIndex = this.options.currentPageIndex;
			//} else {
			//	this.grid.dataSource.settings.paging.pageIndex = 0;
			//	this.options.currentPageIndex = 0;
			//}
			this.grid.dataSource.settings.paging.pageSize = parseInt(this.options.pageSize, 10);
			if (this.options.pageSizeUrlKey !== null && this.options.pageIndexUrlKey) {
				this.grid.dataSource.settings.paging.pageSizeUrlKey = this.options.pageSizeUrlKey;
				this.grid.dataSource.settings.paging.pageIndexUrlKey = this.options.pageIndexUrlKey;
			}
			if (this.options.recordCountKey !== null) {
				this.grid.dataSource.settings.responseTotalRecCountKey = this.options.recordCountKey;
			}
			this.grid.dataSource.settings.paging.enabled = true;
			//A.T 13 April 2011 - fix for bug #72431
			if (this._pageSizeDD) {
				this._pageSizeDD.igEditor('option', 'value', this.options.pageSize);
			}
		},
		_empty: function () {
			return "";
		}
	});
	$.extend($.ui.igGridPaging, {version: '14.1.20141.2249'});
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid Column Resizing 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery, window, document */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}
(function ($) {
	/*
		igGridResizing summary
	*/
	$.widget("ui.igGridResizing", {
		options: {
			/* type="bool" Resize the column to the size of the longest currently visible cell value. */
			allowDoubleClickToResize: true,
			/* type="bool" Specifies whether the resizing should be deferred until the user finishes resizing or applied immediately. */
			deferredResizing: false,
			/* type="array" A list of column settings that specifies resizing options on a per column basis. */
			columnSettings: [
				{
					/* type="string" Column key. this is a required property in every column setting if columnIndex is not set. */
					columnKey: null,
					/* type="number" Column index. Can be used in place of column key. the preferred way of populating a column setting is to always use the column keys as identifiers. */
					columnIndex: null,
					/* type="bool" Enables disables resizing for the column. */
					allowResizing: true,
					/* type="int" Minimum column width in pixels. */
					minimumWidth: 20,
					/* type="int" Maximum column width in pixels. */
					maximumWidth: null
				}
			],
			/* type="int" The width in pixels of the resizing handle which is position at the right side of each resizeable column header. */
			handleTreshold: 5
		},
		css: {
			/* Class applied to the resize line that is visible during resizing */
			"columnResizeLine": "ui-iggrid-resize-line",
			/* Class applied to the resizing handle and the body to change the cursor */
			"resizingHandleCursor": "ui-iggrid-resizing-handle-cursor",
			/* Class applied to the resizing handle */
			"resizingHandle": "ui-iggrid-resizing-handle"
		},
		events: {
			/* cancel="true" event fired before a resizing operation is executed.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridResizing widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnIndex to get the resized column index.
			Use ui.columnKey to get the resized column key.
			Use ui.desiredWidth to get the desired width(before min/max coercion) for the resized column.
			*/
			columnResizing: "columnResizing",
			/* event fired(only when columnFixing is enabled) when trying to resize column in fixed area so total width of unfixed area to be less than minimalVisibleAreaWidth(option defined in columnFixing)
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridResizing widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnIndex to get the resized column index.
			Use ui.columnKey to get the resized column key.
			Use ui.desiredWidth to get the desired width(before min/max coercion) for the resized column.
			*/
			columnResizingRefused: "columnResizingRefused",
			/* event fired after the resizing has been executed and results are rendered 
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridResizing widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnIndex to get the resized column index.
			Use ui.columnKey to get the resized column key.
			Use ui.originalWidth to get the original column width.
			Use ui.newWidth to get the final column width after resizing.
			*/
			columnResized: "columnResized"
		},
		_createWidget: function (options, element) {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */

			this.options.columnSettings = [];
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		_setOption: function (key, value) {
			throw new Error($.ig.Grid.locale.optionChangeNotSupported + ' ' + key);

			// handle new settings and update options hash
			// $.Widget.prototype._setOption.apply(this, arguments);
		},
		destroy: function () {
			/* destroys the resizing widget */

			this._clearResizingHandles();

			//unbind element events
			this.grid.element.unbind('.resizing');

			$.Widget.prototype.destroy.call(this);
			return this;
		},
		resize: function (column, width) {
			/* resizes a column to a specified with in pixels or auto if no width is specified.
			paramType="number|string" An identifier for the column. If a number is provided it will be used as a columnIndex else if a strings is provided it will be used as a columnKey.
			paramType="number" optional="true" Width of the column in pixels. If no width is specified the column will be autofitted to the width of the data in it.
			*/
			var columnIndex;

			if (typeof column === 'number') {
				columnIndex = column;
			} else {
				$.each(this.grid._visibleColumns(), function (index, col) {
					if (col.key === column) {
						columnIndex = index;
					}
				});
			}

			if (width === undefined || width === null) {
				this._autoResize(columnIndex, false, null);
			} else {
				this._resizeColumn(columnIndex, width, false, null);
			}
		},
		_headerRendered: function (event, ui) {
			this._renderResizingHandles();
		},
		_columnsCollectionModified: function () {
			this._renderResizingHandles();
		},
		_columnsMoved: function () {
			this._populateMultiColumnHeadersLevel0();
		},
        _columnFixed: function (args) {
            this._renderResizingHandles();
        },
		_renderResizingHandles: function () {
			var self = this, i, ths, visibleColumns = this.grid._visibleColumns(), thsMultiHeader, gridId = this.grid.element.attr('id'),
                hasFixedColumns = this.grid.hasFixedColumns();

			this._clearResizingHandles();
			//A.Y. bug 91602. If all columns are hidden no resizing handles should be rendered.
			if (visibleColumns.length === 0) {
				return;
			}
			if (this.grid._isMultiColumnGrid) {
				thsMultiHeader = this.grid.headersTable().find("> thead > tr th").not("[data-skip=true]").not("[data-isheadercell=true]");
				if (hasFixedColumns) {
					$.each(this.grid.fixedHeadersTable().find("> thead > tr th").not("[data-skip=true]").not("[data-isheadercell=true]"),
						function (index, th) {
							thsMultiHeader.push($(th));
						});
				}
				this._populateMultiColumnHeadersLevel0();
				thsMultiHeader.each(function (index) {
					var a, th = $(this);

					a = self._renderResizingHandle(th);
					self._bindMultipleResizingHandle(th, a.find("span"));
				});
				ths = $(this.grid._headerCells);//this.grid.headersTable().find("> thead > tr th[data-isheadercell=true]").not("[data-skip=true]");
			} else {
				// M.H. 14 Feb 2013 Fix for bug #132840
				if (this.grid.options.virtualization === true || this.grid.options.rowVirtualization === true) {
					ths = this.grid.headersTable().find("> thead > tr").eq(0).children("th").not("[data-skip=true]");
				} else {
					if (hasFixedColumns) {
						ths = $();
						for (i = 0; i < visibleColumns.length; i++) {
							ths.push($('#' + gridId + '_' + visibleColumns[i].key));
						}
					} else {
						ths = this.grid.headersTable().find("> thead > tr[data-header-row]").eq(0).children("th").not("[data-skip=true]");
					}
				}
			}
			ths.each(function (index) {
				var a, cs, th = $(this),
					col = visibleColumns[index];

				if (col === null || col === undefined) {
					return true;
				}
				cs = self._findColumnSettingsByKey(col.key);
				if (cs.allowResizing) {
					a = self._renderResizingHandle(th);
					self._bindResizingHandle(th, a.find("span"), col);
				}
			});
		},
		_renderResizingHandle: function (th) {
			var  div, a;

			if (!this._resizingHandles) {
				this._resizingHandles = [];
			}

			div = $("<div data-resizinghandle='true' />")
				.css("position", "relative")
				.css("width", "100%")
				.css("height", "0px")
				.css("top", "0px")
				.css("left", "0px")
				.prependTo(th);

			a = $("<a href='#' />")
				//A.Y. bug 82895. Required to prevent the sorting tooltip from appearing when resizing.
				.attr("title", '')
				.prependTo(div);

			if ($.ig.util.isIE9) {
				//A.Y. required to fix bug 92472. 

				//since we have not called preventDefault on IE9(look at mouseWrapper in ig.ui.shared)
				//the browser will show the default cursor for a link when we mousedown on the <a/>
				//so we need to change it to our resizing cursor
				a.addClass(this.css.resizingHandleCursor);
			}

			$("<span data-nonpaddedindicator='right'></span>")
				//Adding title to the span as well otherwise it will not be visible in IE(look at bug 89113).
				.attr('title', '')
				.css('position', 'absolute')
				.css('margin-right', -parseInt(th.css('padding-right'), 10) + 'px')
				.css('right', '0px')
				.css('width', this.options.handleTreshold + 'px')
				.addClass(this.css.resizingHandleCursor)
				.addClass(this.css.resizingHandle)
				.appendTo(a);

			this._resizingHandles.push(div);

			return a;
		},

		_populateMultiColumnHeadersLevel0: function () {
			var i, j, self = this, cols = this.grid._oldCols || [], colsLength = cols.length,
				ths = $(this.grid._headerCells), level0 = [], level0Length, visibleColumns = this.grid._visibleColumns();

			for (i = 0; i < colsLength; i++) {
				if (cols[i].level === 0) {
					level0.push(cols[i]);
				} else {
					for (j = 0; j < cols[i].children.length; j++) {
						level0.push(cols[i].children[j]);
					}
				}
			}
			level0Length = level0.length;

			ths.each(function (index) {
				var th = $(this),
					col = visibleColumns[index],
					cs;

				if (col === null || col === undefined) {
					return true;
				}
				cs = self._findColumnSettingsByKey(col.key);

				if (cs.allowResizing) {
					for (i = 0; i < level0.length; i++) {
						if (level0[i].key === col.key) {
							break;
						}
					}
					if (i < level0Length) {
						level0[i].allowResizing = true;
						level0[i].visibleIndex = index;
						level0[i].settings = cs;
					}
					th.col = level0[i];
				}
			});
		},
		_bindMultipleResizingHandle: function ($th, button) {
			var self = this, id = $th.attr('data-mch-id'), column;
			// M.H. 4 July 2012 Fix for bug #116254
			column = this.grid._getMultiHeaderColumnById(id);
			button
				.mouseWrapper({
					distance: 5,
					start: function (event) {
						return self._startResizing($th);
					},
					drag: function (event) {
						return self._doResizingMultiColumnHeader(event.originalEvent, $th, column);
					},
					stop: function (event) {
						return self._stopResizingMiltiColumnHeader(event.originalEvent, $th, column);
					}
				})
				.bind("dblclick.resizing", function (event) {
					self._handleMouseMultiColumnHeaderDbClick(event, $th, column);
				})
				.bind("click.resizing", function (event) {
					event.preventDefault();
					event.stopPropagation();
				});
		},

		_bindResizingHandle: function (th, button, column) {
			var self = this;

			button
				.mouseWrapper({
					distance: 5,
					start: function (event) {
						return self._startResizing(th);
					},
					drag: function (event) {
						return self._doResizing(event.originalEvent, th, column);
					},
					stop: function (event) {
						return self._stopResizing(event.originalEvent, th, column);
					}
				})
				.bind("dblclick.resizing", function (event) {
					self._handleMouseDbClick(event, th, column);
				})
				.bind("click.resizing", function (event) {
					event.preventDefault();
					event.stopPropagation();
				});
		},
		_clearResizingHandles: function () {
			var i;

			if (this._resizingHandles) {
				for (i = 0; i < this._resizingHandles.length; i++) {
					this._resizingHandles[i].remove();
				}
				this._resizingHandles = [];
			}
		},
		_handleMouseDbClick: function (event, th, column) {
			if (!this.options.allowDoubleClickToResize) {
				return;
			}

			this._autoResize($.inArray(column,  this.grid._visibleColumns()), true, event);
		},
		_handleMouseMultiColumnHeaderDbClick: function (event, $th, column) {
			var i, children = column.children,
				childrenLength = children.length;

			if (!this.options.allowDoubleClickToResize) {
				return;
			}

			for (i = 0; i < childrenLength; i++) {
				if (children[i].allowResizing === true) {
					this._autoResize(children[i].visibleIndex, true, event);
				}
			}
		},
		_autoResize: function (columnIndex, fireEvents, event) {
			var rows, isFixed, columnKey,
				hasFixedCols = this.grid.hasFixedColumns(),
				rowsContainer = this.grid.element,
				visibleColumns,
				cells = [],
				visibleIndex = columnIndex,
				maxWidth = 0,
				measureDiv,
				i;

			if (hasFixedCols) {
				visibleColumns = this.grid._visibleColumns();
				isFixed = visibleColumns[columnIndex].fixed === true;
				columnKey = visibleColumns[columnIndex].key;
				visibleIndex = this.grid._getVisibleIndexByKey(columnKey);
				if (isFixed) {
					rowsContainer = this.grid.fixedContainer().find('table');
				}
			}
			rows = rowsContainer.find("> tbody > tr")
				//A.Y. bug 90819. Skip the expanded rows of the hierarchical grid.
				.not("[data-container=true]")
				//A.Y. bug 93141. Skip groupby rows.
				.not("[data-grouprow=true]");

			for (i = 0; i < rows.length; i++) {
				cells.push(rows.eq(i).children("td")
					.not("[data-skip=true]")
					.not(".ui-iggrid-rowselector-class")
					.not(".ui-iggrid-expandcolumn")
					.eq(visibleIndex));
			}

			if (cells.length > 0) {
				//create a hidden div with the font styles of the cell
				measureDiv = $("<div></div>").css({
					"position": "absolute",
					"visibility": "hidden",
					"height": "auto",
					"width": "auto",
					"left": -1000,
					"top": -1000,
					"font-family": cells[0].css("fontFamily"),
					"font-size": cells[0].css("fontSize"),
					"font-size-adjust": cells[0].css("fontSizeAdjust"),
					"font-stretch": cells[0].css("fontStretch"),
					"font-style": cells[0].css("fontStyle"),
					"font-variant": cells[0].css("fontVariant"),
					"font-weight": cells[0].css("fontWeight")
				}).appendTo($(document.body));

				//put every cell's content inside the div and measure its width
				for (i = 0; i < cells.length; i++) {
					measureDiv.html(cells[i][0].innerHTML);
					maxWidth = Math.max(maxWidth, measureDiv[0].offsetWidth);
				}

				//take cell padding and borders into account as the column size includes these
				maxWidth = maxWidth + cells[0].outerWidth() - cells[0].width();

				//A.Y. bug 85248. IE seems to apply ellipsis even though the text width is exactly
				//the same as the width of the content area
				if ($.ig.util.isIE) {
					maxWidth += 1;
				}

				measureDiv.remove();

				return this._resizeColumn(columnIndex, maxWidth, fireEvents, event);
			}
		},
		_cancelHoveringEffects: function (cancel) {
			var topmostGrid = this.grid.element.closest(".ui-iggrid-root").data('igGrid');

			if (topmostGrid === undefined || topmostGrid === null) {
				topmostGrid = this.grid;
			}

			topmostGrid._cancelHoveringEffects = cancel;
		},
		_startResizing: function (th) {
			var body = $(document.body), resizeLineTop, heightOffset;

			this._resizing = true;
			this._cancelHoveringEffects(true);

			//A.Y. bug 81452. remove focus from the activeElement to trigger dropdowns to close
			// M.H. 19 Jul 2013 Fix for bug #147135: When resizing a column with an overlapping window, the window which contains the grid is sometimes set behind the other window.
			if (!$.ig.util.isIE10) {
				$(document.activeElement).blur();
			} else {
				body.focus();
			}

			//change the cursor while resizing
			body.addClass(this.css.resizingHandleCursor);


			if (this.grid._isMultiColumnGrid) {
				heightOffset = th.offset().top - this._gridContainerPositioningOffset().top;
			}

			resizeLineTop = th.offset().top + this._gridContainerPositioningOffset().top;
			//A.Y. bug 84856.
			//if we don't have fixed headers it is posible for the grid
			//to be scrolled vertically so that part of the header is hidden
			if (this.grid.options.height !== null &&
					this.grid.options.showHeader === true &&
					this.grid.options.fixedHeaders === false) {
				resizeLineTop += this.grid.scrollContainer().scrollTop();
			}

			//create the resizeLine
			this._resizeLine = $("<div></div>")
				.addClass(this.css.columnResizeLine)
				//the resize line's height should not be taken into account when
				//autoadjusting height as it is now in the grid container
				.data('efh', '1')
				.css({
					"height": this._calculateGridResizableHeight(heightOffset),
					"top": resizeLineTop,
					"visibility": "hidden"
				})
				.appendTo(this.grid.container());

			return true;
		},

		_doResizingMultiColumnHeader: function (event, $th, column) {
			var i, width, resizeCellRange,
				resizeResult,
				//columnIndex = $.inArray(column, this.grid._visibleColumns()),
				range, vI,
				offsetLeft,
				offsetHeight,
				children = column.children,
				childrenLength = children.length,
				child = null,
				cellToResize;

			width = event.pageX - $th.offset().left;
			if (width < 0) {
				width = 0;
			}
			offsetHeight = $th.offset().top - this.grid.headersTable().offset().top;
			if (!this.options.deferredResizing) {
				for (i = childrenLength - 1; i >= 0; i--) {
					if (children[i].allowResizing && !children[i].hidden) {
						child = children[i];
						child.resized = !child.resized;
						if (child.resized) {
							break;
						}
						//if (child.isResized = )
					}
				}
				if (child !== null && !child.hidden) {
					cellToResize = $('#' + this.grid.element[0].id + '_' + child.key);
					vI = $.inArray(child, this.grid._visibleColumns());
                    //width = event.pageX - cellToResize.offset().left;
					width = cellToResize[0].offsetWidth - $th[0].offsetWidth + width;
					resizeResult = this._resizeColumn(vI, width, true, event, vI);
				}
				if (!resizeResult) {
					return true;
				}
				if (!resizeResult.canceled) {
					//update the line height as it may have changed due to the resizing
					this._resizeLine.css("height", this._calculateGridResizableHeight(offsetHeight));

					//update resizeLine position to match header right
					this._resizeLine.css({
						"left":
							$th.offset().left +
							$th.outerWidth() +
							this._gridContainerPositioningOffset().left,
						"visibility": "visible"
					});
				}
			} else {
				offsetLeft = $th.offset().left;
				range = {min: offsetLeft, max: offsetLeft};
				for (i = 0; i < childrenLength; i++) {
					child = children[i];
					if (child.hidden) {
						continue;
					}

					if (child.allowResizing) {
						resizeCellRange = this._getRange(this.options.columnSettings[child.visibleIndex]);
						range.min += resizeCellRange.min;
						if (resizeCellRange.max === Infinity) {
							range.max = Infinity;
						} else if (range.max !== Infinity) {
							range.max += resizeCellRange.max;
						}
					} else {
						range.min += $('#' + this.grid.element[0].id + '_' + child.key)[0].offsetWidth;
					}
				}

				this._resizeLine.css("height", this._calculateGridResizableHeight(offsetHeight));
				this._resizeLine.css({
					"left":
						this._coerceRange(range, event.pageX) +
						this._gridContainerPositioningOffset().left,
					"visibility": "visible"
				});
			}

			return true;
		},

		_doResizing: function (event, th, column) {
			var width,
				resizeResult,
				columnIndex = $.inArray(column, this.grid._visibleColumns()),
				range,
				offsetLeft,
				offsetHeight;

			if (!this.options.deferredResizing) {
				width = event.pageX - th.offset().left;

				if (width < 0) {
					width = 0;
				}

				if (this.grid._isMultiColumnGrid) {
					offsetHeight = th.offset().top - this.grid.headersTable().offset().top;
				}

				resizeResult = this._resizeColumn(columnIndex, width, true, event);
				if (!resizeResult.canceled) {
					//update the line height as it may have changed due to the resizing
					this._resizeLine.css("height", this._calculateGridResizableHeight(offsetHeight));

					//update resizeLine position to match header right
					this._resizeLine.css({
						"left":
							th.offset().left +
							th.outerWidth() +
							this._gridContainerPositioningOffset().left,
						"visibility": "visible"
					});
				}
			} else {
				//update resizeLine position to the postion of the mouse after range coercion
				range = this._getRange(this.options.columnSettings[columnIndex]);
				offsetLeft = th.offset().left;
				range.min += offsetLeft;
				range.max += offsetLeft;

				this._resizeLine.css({
					"left":
						this._coerceRange(range, event.pageX) +
						this._gridContainerPositioningOffset().left,
					"visibility": "visible"
				});
			}

			return true;
		},
		_stopResizingMiltiColumnHeader: function (event, th, column) {
			var i, width, cs, columnKey,
				self = this,
				children,
				childrenLength,
				childrenLengthAllowResizing = 0,
				childrenToResize;

			if (this.options.deferredResizing) {
				// M.H. 8 Nov 2012 Fix for bug #126554
				width = event.pageX - th.offset().left;
				children = column.children;
				childrenLength = children.length;
				childrenToResize = [];
				for (i = 0; i < childrenLength; i++) {
					columnKey = children[i].key;
					// M.H. 4 Apr 2013 Fix for bug #138710: When deferredResizing = true on resizing root group of multiColumnHeaders in order to increase its size it gets smaller
					cs = this._findColumnSettingsByKey(columnKey);
					if (children[i].allowResizing === false || (cs && cs.allowResizing === false)) {
						width -= $('#' + this.grid.element[0].id + '_' + columnKey)[0].offsetWidth;
						continue;
					}
					childrenToResize.push(children[i]);
					childrenLengthAllowResizing++;
				}
				if (childrenLengthAllowResizing > 0) {
					// M.H. 1 Nov 2012 Fix for bug #120722
					this._resizeMCHDeffered(width, childrenToResize);
				}
			}
			//remove the resizing cursor
			$('body').removeClass(this.css.resizingHandleCursor);
			// M.H. 4 Mar 2014 Fix for bug #165697: Control automatically sorts the records while resizing the column using mouse
			setTimeout(function () {
				self._resizing = false;
			}, 0);
			this._cancelHoveringEffects(false);
			this._resizeLine.remove();
			this._resizeLine = undefined;

			return true;
		},
		// M.H. 1 Nov 2012 Fix for bug #120722
		_resizeMCHDeffered: function (width, columns) {
			// we set average width for each MCH cell - but for some of them (usually which has maximumWidth or minimumWidth) cells are not resized to the averageWidth
			// that's why we run again _resizeMCHDeffered to set the difference of these columns
			var i, column, columnIndex, columnsLength = columns.length, visibleColumns = [], gridVC = this.grid._visibleColumns(),
				resizeInfo, newWidth = width, newColumnsToResize = [], avgWidth;

			if (columnsLength === 0) {
				return;
			}
			// M.H. 4 Apr 2013 Fix for bug #138710: When deferredResizing = true on resizing root group of multiColumnHeaders in order to increase its size it gets smaller
			// First we need to get only visible and columns collection are visible so we can resize only them
			for (i = 0; i < columnsLength; i++) {
				columnIndex = $.inArray(columns[i], gridVC);
				if (columnIndex === -1 || this.options.columnSettings[columnIndex].allowResizing === false) {
					continue;
				}
				visibleColumns.push({column: column, columnIndex : columnIndex});
			}
			columnsLength = visibleColumns.length;
			if (columnsLength > 0) {
				// M.H. 4 Apr 2013 Fix for bug #132976: Can't resize parent column when child column is hidden and 'deferredResizing' is true
				avgWidth = parseInt((width / columnsLength), 10);
				for (i = 0; i < columnsLength; i++) {
					column = visibleColumns[i].column;
					columnIndex = visibleColumns[i].columnIndex;
					// M.H. 15 Feb 2013 Fix for bug #132976
					resizeInfo = this._resizeColumn(columnIndex, avgWidth, true);
					if (resizeInfo.newWidth !== avgWidth) {
						newWidth -= resizeInfo.newWidth;
					} else {
						newColumnsToResize.push(column);
					}
				}
			}
			// tollerance
			if (newWidth > 5 && newWidth !== width && newColumnsToResize.length > 0) {
				this._resizeMCHDeffered(newWidth, newColumnsToResize);
			}
		},

		_stopResizing: function (event, th, column) {
			var width, self = this,
				columnIndex = $.inArray(column, this.grid._visibleColumns());

			if (this.options.deferredResizing) {
				width = event.pageX - th.offset().left;
				width = this._coerceRange(this._getRange(this.options.columnSettings[columnIndex]), width);

				this._resizeColumn(columnIndex, width, true, event);
			}
			//remove the resizing cursor
			$('body').removeClass(this.css.resizingHandleCursor);
			// M.H. 4 Mar 2014 Fix for bug #165697: Control automatically sorts the records while resizing the column using mouse
			setTimeout(function () {
				self._resizing = false;
			}, 0);
			this._cancelHoveringEffects(false);
			this._resizeLine.remove();
			this._resizeLine = undefined;

			return true;
		},
		_resizeColumn: function (columnIndex, width, fireEvents, originalEvent, startIndex) {
			var gridWidth, minimalVisibleAreaWidth = 0,
				visibleColumns = this.grid._visibleColumns(),
				columnKey = visibleColumns[columnIndex].key,
				visibleIndex = columnIndex,
				headersTable = this.grid.headersTable(),
				cs,
				isFixed,
				headers,
				headerWidth,
				headerColumns,
				columnSettings = this.options.columnSettings,
				hasFixedCols = this.grid.hasFixedColumns(),
				columnsLength,
				headerColStyleWidth,
				hasPercentageWidth,
				actualColumnStyleWidths = [],
				actualColumnWidths = [],
				requiredColumnPercentageWidths = [],
				newColumnStyleWidths = [],
				i,
				widthToDistribute,
				shrinkColumns,
				widthDistributed,
				widthUsed,
				coercedWidth,
				widthPerColumn,
				range,
				totalWidth,
				readyColumns,
				readyColumnsCount,
				finalPixelWidth,
				allColumnsHaveWidth,
				noCancel,
				containerWidth,
				isResized = true;

			if (hasFixedCols) {
				visibleIndex = this.grid._getVisibleIndexByKey(columnKey);
				isFixed = visibleColumns[columnIndex].fixed === true;
			}
			if (isFixed) {
				headersTable = this.grid.fixedHeadersTable();
			}
			if (this.grid._isMultiColumnGrid) {
				headers = $(this.grid._headerCells);//headersTable.find("> thead > tr th[data-isheadercell=true]").not("[data-skip=true]");
				// M.H. 4 Dec 2013 Fix for bug #157949: Resizing on child band when showHeaders is false throws a js error
				if (headers.length > 0) {
					headerWidth = $(headers[columnIndex])[0].offsetWidth;//$(headers[columnIndex]).offsetWidth;
				}
			} else {
				// M.H. 14 Feb 2013 Fix for bug #132840
				if (this.grid.options.virtualization === true || this.grid.options.rowVirtualization === true) {
					headers = headersTable.find("> thead > tr").first().children("th").not("[data-skip=true]");
				} else {
					headers = headersTable.find("> thead > tr[data-header-row]").first().children("th").not("[data-skip=true]");
				}
				// M.H. 4 Dec 2013 Fix for bug #157949: Resizing on child band when showHeaders is false throws a js error
				if (headers.length > 0) {
					headerWidth = headers.get(visibleIndex).offsetWidth;
				}
			}

			headerColumns = headersTable.find("> colgroup > col").not("[data-skip=true]");
			columnSettings = this.options.columnSettings;
			columnsLength = headerColumns.length;
			headerColStyleWidth = headerColumns[visibleIndex].style.width;
			hasPercentageWidth = /%$/.test(headerColStyleWidth);
			if (fireEvents) {
				noCancel = this._trigger(this.events.columnResizing, originalEvent,
					{
						owner: this,
						columnIndex: columnIndex,
						columnKey: columnKey,
						desiredWidth: width
					});

				if (!noCancel) {
					return {
						canceled: true,
						originalWidth: width,
						newWidth: width
					};
				}
			}
			// M.H. 11 Feb 2014 Fix for bug #164074: Resizing column settings are not taken into account for a column if there is an initially hidden column with a lower column index than the configured column
			if (columnKey !== undefined) {
				cs = this._findColumnSettingsByKey(columnKey);
			} else {
				cs = columnSettings[columnIndex];
			}
			range = this._getRange(cs);
			//coerce width within min/max
			width = this._coerceRange(range, width);

			//make sure width is an integer
			width = Math.floor(width);

			if (width === range.min || width === range.max) {
				isResized = false;
			}
			// check whether unfixed area has reached its min visible width
			if (isFixed) {
				widthToDistribute = headerWidth - width;
				gridWidth = parseInt(this.grid.options.width, 10);
				if (isNaN(gridWidth)) {
					gridWidth = this.grid.container().outerWidth();
				}
				if (widthToDistribute < 0) {
					if (this.grid.element.igGridColumnFixing !== undefined) {
						minimalVisibleAreaWidth = this.grid.element.data("igGridColumnFixing").options.minimalVisibleAreaWidth;
					}
					if (this.grid.fixedContainer().outerWidth() - widthToDistribute > gridWidth - this.grid._scrollbarWidth() - minimalVisibleAreaWidth) {
						if (fireEvents) {
							this._trigger(this.events.columnResizingRefused, originalEvent,
							{
								owner: this,
								columnIndex: columnIndex,
								columnKey: columnKey,
								desiredWidth: width
							});
						}
						return {
							canceled: true,
							originalWidth: width,
							newWidth: width
						};
					}
				}
			}
			// M.H. 21 Mar 2013 Fix for bug #129578: Chrome: When columns are set in percent values and resizing is executed some of the columns are resized incorrectly
			if (this.grid._isMultiColumnGrid) {
				if ($.ig.util.isWebKit && hasPercentageWidth) {
					totalWidth = headersTable[0].offsetWidth;
					for (i = 0; i < columnsLength; i++) {
						actualColumnWidths[i] = (parseFloat(headerColumns[i].style.width) / 100) * totalWidth;
					}
				} else if (headers.length > 0) {
					// M.H. 4 Dec 2013 Fix for bug #157949: Resizing on child band when showHeaders is false throws a js error
					for (i = 0; i < columnsLength; i++) {
						actualColumnStyleWidths[i] = headerColumns[i].style.width;
						actualColumnWidths[i] = headers[i][0].offsetWidth;
					}
				}
			} else {
				// M.H. 21 Mar 2013 Fix for bug #129578: Chrome: When columns are set in percent values and resizing is executed some of the columns are resized incorrectly
				if ($.ig.util.isWebKit && hasPercentageWidth) {
					totalWidth = headersTable[0].offsetWidth;
					for (i = 0; i < columnsLength; i++) {
						actualColumnWidths[i] = (parseFloat(headerColumns[i].style.width) / 100) * totalWidth;
					}
				} else if (headers.length > 0) {
					// M.H. 4 Dec 2013 Fix for bug #157949: Resizing on child band when showHeaders is false throws a js error
					for (i = 0; i < columnsLength; i++) {
						actualColumnStyleWidths[i] = headerColumns[i].style.width;
						actualColumnWidths[i] = headers[i].offsetWidth;
					}
				}
			}
			if (hasPercentageWidth) {
				//negative if the resized column grows, positive if it shrinks
				widthToDistribute = headerWidth - width;
				shrinkColumns = widthToDistribute < 0;

				readyColumns = [];
				readyColumnsCount = 0;
				widthDistributed = 0;
				if (startIndex === undefined || startIndex === null) {
					startIndex = 0;
				}

				//distrubiting the width until it reaches close to 0 or all columns reach their min/max
				while (readyColumnsCount < columnsLength - 1 - startIndex &&
						((shrinkColumns && widthToDistribute < -0.05) ||
						(!shrinkColumns && widthToDistribute > 0.05))) {
					//calculate how much each column should receive
					widthPerColumn = widthToDistribute / (columnsLength - 1);

					for (i = startIndex; i < columnsLength; i++) {
						//ignore the resizedColumn and ready columns
						if (i !== columnIndex && !readyColumns[i]) {

							//taking into account the fact that due to rounding we may have less to distribute then the average per column
							if (shrinkColumns) {
								widthUsed = Math.max(widthPerColumn, widthToDistribute);
							} else {
								widthUsed = Math.min(widthPerColumn, widthToDistribute);
							}

							actualColumnWidths[i] += widthUsed;

							range = this._getRange(columnSettings[i]);
							coercedWidth = this._coerceRange(range, actualColumnWidths[i]);

							//as we are dealing with floating point values we should chech for equility within an Epsilon region
							if (Math.abs(actualColumnWidths[i] - coercedWidth) > 0.000005) {
								//update the widthUsed as we didn't take as much as we wanted
								widthUsed -= actualColumnWidths[i] - coercedWidth;

								actualColumnWidths[i] = coercedWidth;

								readyColumns[i] = true;
								readyColumnsCount++;
							}

							widthDistributed += widthUsed;
							widthToDistribute -= widthUsed;
						}
					}
				}

				//remove the distributed width from the size of the resized column
				//this will be its final width
				actualColumnWidths[columnIndex] -= widthDistributed;

				totalWidth = 0;
				for (i = 0; i < columnsLength; i++) {
					totalWidth += actualColumnWidths[i];
				}

				for (i = 0; i < columnsLength; i++) {
					requiredColumnPercentageWidths[i] = 100 * actualColumnWidths[i] / totalWidth;
				}

				//save the desired widths for each column
				for (i = 0; i < columnsLength; i++) {
					newColumnStyleWidths[i] = requiredColumnPercentageWidths[i] + "%";
					visibleColumns[i].width = newColumnStyleWidths[i];
				}

				finalPixelWidth = actualColumnWidths[columnIndex];

				this._applyToEachGridCOL(function (index, col) {
					col.css("width", newColumnStyleWidths[index]);
				}, isFixed);
			} else {
				allColumnsHaveWidth = true;
				for (i = 0; i < columnsLength; i++) {
					if (i === visibleIndex) {
						//set the width of the resized column
						newColumnStyleWidths[i] = width + "px";
						finalPixelWidth = width;
						visibleColumns[columnIndex].width = newColumnStyleWidths[i];
					} else {
						newColumnStyleWidths[i] = actualColumnStyleWidths[i];
						allColumnsHaveWidth =
							allColumnsHaveWidth && parseInt(actualColumnStyleWidths[i], 10) > 0;
					}
				}

				this._applyToEachGridCOL(function (index, col) {
					col.css("width", newColumnStyleWidths[index]);
				}, isFixed);
				
				containerWidth = this.grid._calculateContainerWidth(false);
				if (allColumnsHaveWidth) {
					if (this.grid.options.width && parseInt(this.grid.options.width, 10) > 0) {
						if (isFixed) {
							this.grid._updateFixedGridContentWidth();
						} else {
							this.grid._updateGridContentWidth();
						}
						$("#" + this.grid.element[0].id + '_horizontalScrollContainer')
							.children('div')
							.css('width', containerWidth);
						// M.H. 6 Aug 2013 Fix for bug #145572: When Resizing with continuous rowVirtualization no horizontal scrollbar appears when needed
						if (this.grid.options.virtualization === true || this.grid.options.rowVirtualization === true) {
							this.grid._oldScrollLeft = $("#" + this.grid.id() + '_horizontalScrollContainer').scrollLeft();
						}
					} else {
						// M.H. 7 Jun 2013 Fix for bug #144153: Resizing is not working properly when there are fixed column(s) and width is not set
						if (hasFixedCols) {
							if (isFixed) {
								this.grid._updateFixedGridContentWidth();
							} else {
								this.grid._updateGridContentWidth();
							}
						}
						// M.H. 19 Sep 2013 Fix for bug #152604: Resizing the grid columns cause javascript error
						this.grid._setContainerWidth($('#'+ this.grid.id() + '_container'));

						if (this.grid.options.rowVirtualization || this.grid.options.virtualization === true) {
							//A.Y. bug 91641. When we have rowVirtualization we need to adjust
							//the displayContainer and the virtualContainer first columns as well.

							//I.I. bug fix for 106920
							$("#" + this.grid.element[0].id + '_headers_v')
								.css('width', containerWidth + this.grid._scrollbarWidth())
								.css('max-width', containerWidth + this.grid._scrollbarWidth());

							$("#" + this.grid.element[0].id + '_displayContainer')
								.css('width', containerWidth)
								.css('max-width', containerWidth);
							$("#" + this.grid.element[0].id + '_virtualContainer > colgroup > col')
								.first()
								.attr('width', containerWidth);
							// M.H. 15 Aug 2013 Fix for bug #149242: Misalignment when resizing grid with summaries and virtualization
							$("#" + this.grid.id() + '_footer_container')
								.css('width', containerWidth + this.grid._scrollbarWidth())
								.css('max-width', containerWidth + this.grid._scrollbarWidth());
						}
					}
				}
			}
			// M.H. 26 Jun 2013 Fix for bug #143357: The fixed area becomes misaligned when you resize it enough to increase its header's height.
			if (hasFixedCols) {
				// M.H. 22 Jul 2013 Fix for bug #147064: When column is resized and the content of the cells is distributed on two rows the rows from both areas are misaligned.
				this.grid.element.data("igGridColumnFixing")._containerResized();
			}
			if (fireEvents) {
				this._trigger(this.events.columnResized, originalEvent,
					{
						owner: this,
						columnIndex: columnIndex,
						columnKey: columnKey,
						originalWidth: headerWidth,
						newWidth: finalPixelWidth
					});
			}

			return { canceled: false, originalWidth: headerWidth, newWidth: finalPixelWidth, isResized: isResized };
		},
		_applyToEachGridCOL: function (appliedFunction, isFixed) {
			var headersTable, footersTable;
			if (this.grid.options.showHeader) {
				if (isFixed) {
					headersTable = this.grid.fixedHeadersTable();
				} else {
					headersTable = this.grid.headersTable();
				}
				headersTable.find("> colgroup > col").not("[data-skip=true]").each(function (i) {
					appliedFunction(i, $(this));
				});
			}

			//update the data table if it is different from the headers table or we are not showing headers
			if ((this.grid.options.fixedHeaders === true && this.grid.options.height !== null) ||
					this.grid.options.showHeader === false) {
				if (isFixed) {
					$("#" + this.grid.id() + "_fixed").find("> colgroup > col").not("[data-skip=true]").each(function (i) {
						appliedFunction(i, $(this));
					});
				} else {
					this.grid.element.find("> colgroup > col").not("[data-skip=true]").each(function (i) {
						appliedFunction(i, $(this));
					});
				}
			}

			//update the footers table if we have one
			if (this.grid.options.fixedFooters === true && this.grid.options.height !== null) {
				if (isFixed) {
					footersTable = this.grid.fixedFootersTable();
				} else {
					footersTable = this.grid.footersTable();
				}
				footersTable.find("> colgroup > col").not("[data-skip=true]").each(function (i) {
					appliedFunction(i, $(this));
				});
			}
		},
		_getRange: function (column) {
			var min = column.minimumWidth,
				max = column.maximumWidth;

			min = isNaN(min) ? 0 : min;
			min = Math.max(0, min);
			max = isNaN(max) ? Infinity : max;

			return { "min": min, "max": max };
		},
		_coerceRange: function (range, value) {
			value = Math.max(range.min, value);
			value = Math.min(range.max, value);
			return value;
		},
		_gridContainerPositioningOffset: function () {
            // M.H. 17 Feb 2014 Fix for bug #164370: Resize line is not aligned correctly
            // grid container is with relative position - se we just should get its offset
            var offset = this.grid.container().offset();
            return {
                top: - offset.top,
                left: - offset.left
            };
            /*
			//This method calculates how much we should add to a position
			//relative to the document(jQuery.offset()) to express it as top/left values for an
			//absolutely positioned element within the grid container(this.grid.container()).
			//We need this to fix bug #94177 which requires the resizeLine to be absolutely
			//positioned within the grid container instead of the document body.
			var gridContainer = this.grid.container(),
				gridContainerOffsetParent = gridContainer.offsetParent(),
				gridContainerPosition = gridContainer.position(),
				gridContainerOffset = gridContainer.offset(),
				offsetParentScrollTop,
				offsetParentScrollLeft;

			//A.Y. bug #99092. Since we are positioning the resize line relatively if the offset parent 
			//is the 'body' the scrollTop/Left should be ignored and indeed in IE/FF/Opera the 
			//scrollTop/Left is always 0 but in WebKit browsers the body is the scrollable element.
			if (gridContainerOffsetParent.is('body')) {
				offsetParentScrollTop = 0;
				offsetParentScrollLeft = 0;
			} else {
				offsetParentScrollTop = gridContainerOffsetParent.scrollTop();
				offsetParentScrollLeft = gridContainerOffsetParent.scrollLeft();
			}

			return {
				top:
					offsetParentScrollTop +
					gridContainerPosition.top -
					gridContainerOffset.top,
				left:
					offsetParentScrollLeft +
					gridContainerPosition.left -
					gridContainerOffset.left
			};
            */
		},
		_calculateGridResizableHeight: function (heightOffset) {
			// L.A. 23 April 2012 Fixing bug #99471 When grid has row virtualization resize line height is not correct
			var height, caption, headersTable, footersTable, scrollerContainer,
				hasVirtualization = this.grid.options.virtualization === true ||
				this.grid.options.rowVirtualization === true ||
				this.grid.options.columnVirtualization === true,
				hasWidthOrHeight = this.grid.options.height !== null ||
				this.grid.options.width !== null;
			if (hasVirtualization) {
				height = $("#" + this.grid.element[0].id + "_displayContainer").height();
			} else if (hasWidthOrHeight) {
				height = this.grid.scrollContainer().height();
			} else {
				height = this.grid.element.height();
			}
			if (hasVirtualization || hasWidthOrHeight) {
				headersTable = this.grid.headersTable();
				footersTable = this.grid.footersTable();
				if (this.grid.options.fixedHeaders === true && this.grid.options.showHeader === true) {
					if (headersTable.length !== 0 && this.grid.element[0].id !== headersTable[0].id) {
						height += headersTable.height();
					}
					//in this case the caption is in the headersTable
					caption = headersTable.children("#" + this.grid.element[0].id + '_caption');
					if (caption.length !== 0) {
						//A.Y. bug 98449. FF has a bug and does not include the height of the caption when it calculates the table height.
						if (!$.ig.util.isFF) {
							height -= caption.outerHeight(true);
						}
					}
				}
				// L.A. 08 May 2012 Fixing bug #111034 When in grid fixedHeaders is false and column resizing and summaries are enabled, the resize line does not appear correctly
				scrollerContainer = $("#" + this.element[0].id + "_hscroller_container");
				if (scrollerContainer.is(":visible")) {
					height += scrollerContainer.height();
				}
				if (this.grid.options.fixedFooters === true &&
						this.grid.options.showFooter === true && footersTable.length !== 0 && this.grid.element[0].id !== footersTable[0].id) {
					height += footersTable.height();
				}
			}
			if (heightOffset) {
				height -= heightOffset;
			}
			return height;
		},
		_findColumnSettingsByKey: function (key) {
			var i;
			for (i = 0; i < this.options.columnSettings.length; i++) {
				if (this.options.columnSettings[i].columnKey === key) {
					return this.options.columnSettings[i];
				}
			}
		},
		_initDefaultSettings: function () {
			var settings = [], key, cs = this.options.columnSettings, i, j;

			//create default setting for each grid column
			if (this.grid.options.columns && this.grid.options.columns.length > 0) {
				for (i = 0; i < this.grid.options.columns.length; i++) {
					settings[i] =
						{
							'columnIndex': i,
							'columnKey': this.grid.options.columns[i].key,
							'allowResizing': true,
							'minimumWidth': 20
						};
				}
			}

			for (i = 0; i < cs.length; i++) {
				//find the corresponding column settings
				for (j = 0; j < settings.length; j++) {
					if (settings[j].columnKey === cs[i].columnKey || settings[j].columnIndex === cs[i].columnIndex) {
						//foundByKey = settings[j].columnKey === cs[i].columnKey;
						break;
					}
				}

				//not found, continue
				if (j === settings.length) {
					continue;
				}

				//copy properties
				for (key in cs[i]) {
					if (cs[i].hasOwnProperty(key) && key !== 'columnIndex' && key !== 'columnKey') {
						settings[j][key] = cs[i][key];
					}
				}
			}

			this.options.columnSettings = settings;
		},
		_injectGrid: function (gridInstance, isRebind) {
			this.grid = gridInstance;
			// M.H. 2 Sep 2013 Fix for bug #150449: After rebinding the grid many times on interval the gird becomes unresponsive.
			this.grid.element.unbind('.resizing');
			this._initDefaultSettings();

			// register for headerRendered	
			this.grid.element.bind('iggridheaderrendered.resizing', $.proxy(this._headerRendered, this));

			// register for columnsCollectionModified
			this.grid.element.bind('iggridcolumnscollectionmodified.resizing', $.proxy(this._columnsCollectionModified, this));

			// register for columnsMoved
			this.grid.element.bind('iggrid_columnsmoved.resizing', $.proxy(this._columnsMoved, this));
		}
	});
	$.extend($.ui.igGridResizing, {version: '14.1.20141.2249'});
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid Responsive 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.tree.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery, Class, window, document */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}
(function ($) {

	"use strict";
	$.widget("ui.igGridResponsive", {
		options: {
			/* type="array" A list of column settings that specifies how columns will react based on the environment the grid is run on. */
			columnSettings: [
				{
					/* type="string" Column key. This is a required property in every column setting if columnIndex is not set. */
					columnKey: null,
					/* type="number" Column index. Can be used in place of column key. The preferred way of populating a column setting is to always use the column keys as identifiers. */
					columnIndex: null,
					/* type="string" A list of predefined classes to decide element's visibility on. */
					classes: "",
					/* type="object" A configuration object to use for the responsive functionality. Uses the keys defined in the widget's responsiveModes object. The classes property is not used if this one is set. */
					configuration: null
				}
			],
			/* type="bool" If this option is set to true an igResponsiveContainer widget will be attached to the igGrid control which will notify the feature when changes in the width of the container occur. */
			reactOnContainerWidthChanges: true,
			/* type="bool" If this option is set to true the widget will ensure the grid's width is always set to 100%. */
			forceResponsiveGridWidth: true,
			/* type="number" The amount of pixels the window needs to resize with for the grid to respond. */
			responsiveSensitivity: 20,
			/* type="object" The recognized types of environments and their configuration. */
			responsiveModes: null,
			/* type="bool" Enable or disable the responsive vertical rendering for the grid. */
			enableVerticalRendering: true,
			/* type="string|number|null" The window's width under which the grid will render its contents vertically. 
				string The width in a (px) string
				number The width as a number
				null type="object" The grid will determine when to render this mode automatically.
			*/
			windowWidthToRenderVertically: null,
			/* type="string|number" The width of the properties column when vertical rendering is enabled
				string The width in a (%) string
				number The width as a number in percents
			*/
			propertiesColumnWidth: "50%",
			/* type="string|number" The width of the values column when vertical rendering is enabled
				string The width in a (%) string
				number The width as a number in percents
			*/
			valuesColumnWidth: "50%",
			/* type="object" When windowWidthToRenderVertically is null, determine minimal widths columns can take before
				forcing vertical rendering for the grid
			*/
			allowedColumnWidthPerType: {
				/* type="number" minimal width in pixels string columns can take before forcing vertical rendering */
				string: 120,
				/* type="number" minimal width in pixels number columns can take before forcing vertical rendering */
				number: 50,
				/* type="number" minimal width in pixels bool columns can take before forcing vertical rendering */
				bool: 50,
				/* type="number" minimal width in pixels date columns can take before forcing vertical rendering */
				date: 80,
				/* type="number" minimal width in pixels object columns can take before forcing vertical rendering */
				object: 150
			}
		},
		events: {
			/* cancel="true" Event fired before a hiding operation is executed on a collection of columns.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridResponsive widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnIndex to get the hidden column index. Has a value only if the column's key is a number.
			Use ui.columnKey to get the hidden column key. Has a value only if the column's key is a string.
			*/
			responsiveColumnHiding: "responsiveColumnHiding",
			/* Event fired after a hiding operation is executed on the collection of columns.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridResponsive widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnIndex to get the hidden column index. Has a value only if the column's key is a number.
			Use ui.columnKey to get the hidden column key. Has a value only if the column's key is a string.
			*/
			responsiveColumnHidden: "responsiveColumnHidden",
			/* cancel="true" Event fired before a showing operation is executed on a collection of columns.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridResponsive widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnIndex to get the shown column index. Has a value only if the column's key is a number.
			Use ui.columnKey to get the shown column key. Has a value only if the column's key is a string.
			*/
			responsiveColumnShowing: "responsiveColumnShowing",
			/* Event fired after a showing operation is executed on the collection of columns.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridResponsive widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnIndex to get the shown column index. Has a value only if the column's key is a number.
			Use ui.columnKey to get the shown column key. Has a value only if the column's key is a string.
			*/
			responsiveColumnShown: "responsiveColumnShown",
			/* Event which is fired when the widget detects an environment change.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridResponsive widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.previousMode to get the previously assumed mode.
			Use ui.mode to get the newly assumed mode.
			*/
			responsiveModeChanged: "responsiveModeChanged"
		},
		css: {
			/* Classes applied to the grid table when vertical rendering is enabled */
			verticalContainerCssClass: "ui-iggrid-responsive-vertical"
		},
		_createWidget: function (options, element) {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			this.options.columnSettings = [];
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		_create: function () {
			// stores the identifier sent by the responsive container for the callback
			this._callBackId = null;
			// stores a reference to the responsive container for easy use
			this._responsive = null;
			// stores a flag on whether the responsiveContainer was created exclusively for this widget
			this._exclusiveContainer = false;
			// stores the currently recognized environment
			this._mode = "";
			// stores the environment modes
			this._modes = this.options.responsiveModes || {
				desktop: "infragistics",
				tablet: "infragistics",
				phone: "infragistics"
			};
			this._modes = this._initializeModeRecognizers(this._modes);
			// stores if we check for visibility by class or by configuration
			this._hiddenByClass = this._flagClassConfiguration();
			// stores the default templates per column and the default row template
			this._defaultColumnTemplates = null;
			// stores a footers % displacement due to borders
			this._footersDisplacement = 0.1;
			// stores a reference to the original renderRecord
			this._originalRenderRecord = null;
			// stores a reference to the modified renderRecord
			this._newRenderRecord = null;
			// stores a parsed width to kick virtual rendering under
			this._vrw = typeof this.options.windowWidthToRenderVertically === "string" ?
				parseInt(this.options.windowWidthToRenderVertically, 10) :
				this.options.windowWidthToRenderVertically;
			// stores if grid is rendered / should be rendered vertically
			this._vr = null;
		},
		_setOption: function (key, value) {
			switch (key) {
				case "propertiesColumnWidth":
				case "valuesColumnWidth":
					throw new Error($.ig.Grid.locale.optionChangeNotSupported + ' ' + key);
				case "responsiveModes":
					this._modes = value;
					this._modes = this._initializeModeRecognizers(this._modes);
					break;
				case "reactOnContainerWidthChanges":
					if (value === true) {
						this._activateContainer();
					} else {
						this._deactivateContainer();
					}
					break;
				case "enableVerticalRendering":
					this.options.enableVerticalRendering = value;
					if (this._shouldRenderVertically()) {
						if (!this._vr) {
							this._enableVerticalGrid();
						}
					} else {
						if (this._vr) {
							this._disableVerticalGrid();
						}
					}
					break;
				case "windowWidthToRenderVertically":
					this._vrw = typeof value === "string" ? parseInt(value, 10) : value;
					break;
			}
			$.Widget.prototype._setOption.apply(this, arguments);
			this._hiddenByClass = this._flagClassConfiguration();
		},
		destroy: function () {
			/* Destroys the responsive widget. */
			this._deactivateContainer();
			if (this._initialGridRenderedHandler) {
				this.grid.element.unbind("iggridrendered", this._initialGridRenderedHandler);
				this.grid.element.unbind("iggridheaderrendering", this._gridHeaderRenderingHandler);
			}
			this.grid.element.unbind("iggrid_heightchanged", this._gridContainerHeightHandler);
			$("#" + this.grid.element[0].id + "_responsive_test_container").remove();
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		getCurrentResponsiveMode: function () {
			/* Returns the currently active responsive mode.
			*/
			return this._mode;
		},
		_activateContainer: function () {
			// Checks for the presence of the responsive container and 
			// initializes it if needed. Adds the resizing callback.
			if (!this._responsive || typeof this._responsive.addCallback !== "function") {
				this._responsive = this.grid.element.closest(".ui-widget").igResponsiveContainer().data("igResponsiveContainer");
				this._exclusiveContainer = true;
			}
			this._callBackId = this._responsive.addCallback(this._containerResized, this, this.options.responsiveSensitivity, "x");
		},
		_deactivateContainer: function (removeContainer) {
			// Deactivates further callbacks and destroys the responsiveContainer 
			// widget if it was created exclusively for the needs of the feature.
			if (typeof this._callBackId === "number") {
				this._responsive.removeCallback(this._callBackId);
				this._callBackId = null;
			}
			if (this._exclusiveContainer === true) {
				this._responsive.destroy();
				delete this._responsive;
				this._exclusiveContainer = false;
			}
		},
		_renderTestElement: function () {
			// Renders an element with absolute position outside the browser's viewport 
			// that will be used to check if a set of classes make it hidden or not.
			$("<div></div>")
				.attr("id", this.grid.element[0].id + "_responsive_test_container")
				.css("position", "fixed")
				.css("top", "-100px")
				.text("&nbsp;")
				.appendTo(this.grid.container());
		},
		_initializeModeRecognizers: function (definedModes) {
			// Changes the values of the provided mode definitions to objects of the appropriate classes.
			var self = this, transformed = {}, nval;
			$.each(this._modes, function (key, value) {
				if (typeof value === "string") {
					// strings should be translated to classes in the ig namespace
					nval = value.substring(0, 1).toUpperCase() + value.substring(1);
					nval = new $.ig[nval + "Mode"]({
						// the recognition is key based
						key: key,
						// we add the feature's visiblity tester if it's needed
						visibilityTester: $.proxy(self._checkVisibilityByClass, self)
					});

				} else if (typeof value === "object" && !value.isActive) {
					// if an object with dimensions is provided we'll use the default ResponsiveMode recognizer
					nval = new $.ig.ResponsiveMode({
						minWidth: value.minWidth || -1,
						maxWidth: value.maxWidth || Number.MAX_VALUE,
						minHeight: value.minHeight || -1,
						maxHeight: value.maxHeight || Number.MAX_VALUE
					});
				} else {
					nval = value;
				}
				transformed[key] = nval;
			});
			return transformed;
		},
		_flagClassConfiguration: function () {
			// Checks for conflicts in the visibility options and decides which ones to use
			var byClass = false;
			$.each(this.options.columnSettings, function () {
				if (this.classes) {
					byClass = true;
					return false;
				}
			});
			return byClass;
		},
		_getDefaultColumnTemplates: function () {
			var cache = {}, col, i;
			for (i = 0; i < this.grid.options.columns.length; i++) {
				col = this.grid.options.columns[i];
				if (col.template) {
					if (col.key) {
						cache[col.key] = col.template;
					} else {
						cache[i] = col.template;
					}
				}
			}
			return cache;
		},
		_checkVisibilityByClass: function (classes) {
			// Using the created test container this function applies the provided
			// classes and checks if the container is visible with them.
			var testContainer = $("#" + this.grid.element[0].id + "_responsive_test_container");
			// remove all classes to ensure initial state
			testContainer.removeClass();
			// add classes
			testContainer.addClass(classes);
			return testContainer.is(":visible");
		},
		_gridReady: function () {
			return !(this.grid._loadingIndicator && this.grid._loadingIndicator._indicator.is(":visible"));
		},
		_shouldRenderVertically: function () {
			if (!this.options.enableVerticalRendering) {
				return false;
			}
			if (this._vrw === null || this._vrw === undefined) {
				return this._shouldRenderVerticallyByDefault();
			}
			if ($(window).width() < this._vrw) {
				return true;
			}
			if ($(window).width() >= this._vrw) {
				return false;
			}
			return false;
		},
		_shouldRenderVerticallyByDefault: function () {
			var i, gw = this.grid.element.width(), gp = 100, cw, cols = [], col, tcocww = 0, p, aw;
			for (i = 0; i < this.grid._visibleColumns().length; i++) {
				col = this.grid._visibleColumns()[i];
				if (col.width) {
					cw = -1;
					if (typeof col.width === "string") {
						if (col.width.endsWith("%")) {
							cw = parseInt(col.width, 10);
							gp -= cw;
						} else {
							gw -= parseInt(col.width, 10);
						}
					} else {
						gw -= col.width;
					}
					if (cw !== -1) {
						cols.push({ key: col.key || i, width: cw });
					}
					continue;
				}
				tcocww++;
				cols.push({ key: col.key || i, width: -1, type: col.dataType });
			}
			for (i = 0; i < cols.length; i++) {
				p = cols[i].width === -1 ? gp / tcocww : cols[i].width;
				aw = (p / 100) * gw;
				if (aw <= this.options.allowedColumnWidthPerType[cols[i].type]) {
					return true;
				}
			}
			return false;
		},
		_updateGridSync: function (initial, full) {
			// Ensures updateGrid will only be called when no internal rendering operations are in place
			var self = this;
			if (!this._gridReady()) {
				setTimeout(function () {
					self._updateGridSync(initial, full);
				}, 50);
				return;
			}
			self._updateGrid(initial, full);
		},
		_updateGrid: function (initial, full) {
			// Updates the grid's settings based on the current mode and rerenders the grid if needed.
			var result = [], applyTemplates = false, colsToShow, colsToHide, self = this, i;
			// We update the columns by class if no configuration is set
			if (this._hiddenByClass === true) {
				result = this._updateColumnsByClass();
			}
			if (full === true) {
				if (this._hiddenByClass === false) {
					result = this._updateColumns();
				}
				applyTemplates = this._updateTemplates();
			}
			colsToShow = result[0] || [];
			colsToHide = result[1] || [];
			if (colsToShow.length === 0 && colsToHide.length === 0) {
				// this is a special case in which we won't hide/show anything but we still have new templates
				// this means we need to rerender the grid with those
				if (applyTemplates === true && initial === false) {
					this.grid._renderData();
				}
				return;
			}
			if (initial === false) {
				this.grid._loadingIndicator.show();
				setTimeout(function () {
					self.grid._setHiddenColumns(colsToShow, false, initial);
					for (i = 0; i < colsToShow.length; i++) {
						self._trigger(self.events.responsiveColumnShown, null, self._getArgsByColumn(colsToShow[i]));
					}
					self.grid._setHiddenColumns(colsToHide, true, initial);
					for (i = 0; i < colsToHide.length; i++) {
						self._trigger(self.events.responsiveColumnHidden, null, self._getArgsByColumn(colsToHide[i]));
					}
					if (initial === false) {
						self.grid._loadingIndicator.hide();
					}
					// finally update grid
					self._setMaxWidthOnGrid();
				}, 0);
			} else {
				// grid is not yet rendered so we can just set the column properties and let
				// the default rendering do the rest
				$.each(colsToShow, function () {
					this.hidden = false;
				});
				$.each(colsToHide, function () {
					this.hidden = true;
				});
			}
		},
		_updateColumnsByClass: function () {
			// Updates the grid's column visiblity based on the classes set in the options
			var i, cs = this.options.columnSettings, col, colsToHide = [], colsToShow = [], noCancel, hidden, visible;
			for (i = 0; i < cs.length; i++) {
				if (cs[i].classes) {
					col = this._getGridColumnBySetting(cs[i]);
					if (!col) {
						// wrongly set columnSettings may result in not being able to find the corresponsing grid column
						// in this case we'll just skip this iteration
						continue;
					}
					hidden = col.hidden || false;
					visible = this._checkVisibilityByClass(cs[i].classes);
					if (hidden === true && visible === true) {
						noCancel = this._trigger(this.events.responsiveColumnShowing, null, this._getArgsByColumnSetting(cs[i]));
						if (noCancel) {
							colsToShow.push(col);
						}
					}
					if (hidden === false && visible === false) {
						noCancel = this._trigger(this.events.responsiveColumnHiding, null, this._getArgsByColumnSetting(cs[i]));
						if (noCancel) {
							colsToHide.push(col);
						}
					}
				}
			}
			return [colsToShow, colsToHide];
		},
		_updateColumns: function () {
			// Updates the grid's column visiblity based on the explicit configuration
			var i, cs = this.options.columnSettings, col, colsToHide = [], colsToShow = [], noCancel, m = this._mode, hidden, visible;
			for (i = 0; i < cs.length; i++) {
				if (cs[i].configuration) {
					col = this._getGridColumnBySetting(cs[i]);
					if (!col) {
						// wrongly set columnSettings may result in not being able to find the corresponsing grid column
						// in this case we'll just skip this iteration
						continue;
					}
					hidden = col.hidden || false;
					visible = !(cs[i].configuration[m] && cs[i].configuration[m].hidden);
					if (hidden === true && visible === true) {
						noCancel = this._trigger(this.events.responsiveColumnShowing, null, this._getArgsByColumnSetting(cs[i]));
						if (noCancel) {
							colsToShow.push(col);
						}
					}
					if (hidden === false && visible === false) {
						noCancel = this._trigger(this.events.responsiveColumnHiding, null, this._getArgsByColumnSetting(cs[i]));
						if (noCancel) {
							colsToHide.push(col);
						}
					}
				}
			}
			return [colsToShow, colsToHide];
		},
		_updateTemplates: function () {
			// Updates the grid's templates based on the explicit configuration
			var i, cs = this.options.columnSettings, nt, updated = false, col, m = this._mode,
				jsRndr = String(this.grid.options.templatingEngine).toLowerCase() === "jsrender";
			for (i = 0; i < cs.length; i++) {
				col = this._getGridColumnBySetting(cs[i]);
				if (!col) {
					// wrongly set columnSettings may result in not being able to find the corresponsing grid column
					// in this case we'll just skip this iteration
					continue;
				}
				if (cs[i].configuration && cs[i].configuration[m] && cs[i].configuration[m].template) {
					// we've explicitly set a template for the current mode
					nt = cs[i].configuration[m].template;
				} else {
					// no template is set which means we'll try to go back to the default one
					nt = col.key ? this._defaultColumnTemplates[col.key] :
						this._defaultColumnTemplates[$.inArray(col, this.grid.options.columns)];
				}
				if (col.template !== nt) {
					col.template = nt;
					updated = true;
				}
			}
			// finally reset internal row template cache so the new templates can be applied
			if (updated === true) {
				if (!this.grid._tmplWrappers) {
					this.grid._tmplWrappers = jsRndr ? $.render : {};
				}
				this.grid._setTemplateDefinition(jsRndr);
			}
			return updated;
		},
		_renderRecord: function (data, index) {
			var i = 0, str, tstr, alt, vc = this.grid._visibleColumns();
			if (!this._vr) {
				return this._originalRenderRecord(data, index);
			}
			str = "";
			alt = index % 2 !== 0 && this.grid.options.alternateRowStyles;
			for (i = 0; i < vc.length; i++) {
				str += '<tr';
				if (alt) {
					str += ' class="' + this.grid.css.recordAltClass + '"';
				}
				str += '><td>';
				str += vc[i].headerText + "</td>";
				str += "<td";
				if (vc[i].template && vc[i].template.length) {
					tstr = this.grid._renderTemplatedCell(data, vc[i]);
					if (tstr.indexOf("<td") === 0) {
						str += tstr.substring(3);
					} else {
						str += '>' + tstr;
					}
				} else {
					str += ">" + this.grid._renderCell(data[vc[i].key], vc[i]);
				}
				str += "</td></tr>";
			}
			return str;
		},
		_renderColgroup: function (table, isHeader, isFooter, autofitLastColumn) {
			var colgroup, fcw, scw;
			this._vr = this._vr === null ? this._shouldRenderVertically() : this._vr;
			if (!this._vr) {
				this._originalRenderColgroup(table, isHeader, isFooter, autofitLastColumn);
				return;
			}
			colgroup = $(table).find('colgroup');
			if (colgroup.length === 0) {
				colgroup = $("<colgroup></colgroup>").prependTo(table);
			}
			colgroup.empty();
			fcw = typeof this.options.propertiesColumnWidth === "string" ?
				parseInt(this.options.propertiesColumnWidth, 10) : this.options.propertiesColumnWidth;
			scw = typeof this.options.valuesColumnWidth === "string" ?
				parseInt(this.options.valuesColumnWidth, 10) : this.options.valuesColumnWidth;
			colgroup.append("<col width='" + fcw + "%'></col><col width='" + scw + "%'></col>");
		},
		_enableVerticalGrid: function () {
			this.grid.element.addClass(this.css.verticalContainerCssClass);
			if (!this.grid.options.showHeader || !this.grid.options.fixedHeaders || this.grid.options.height === null) {
				this.grid.headersTable().children("thead").css("display", "none");
			} else {
				this.grid.headersTable().css("position", "absolute");
				this.grid.headersTable().css("top", "-100px");
			}
			this._vr = true;
			this._modifySortingStyles();
			this.grid._rerenderColgroups();
			this.grid._renderData();
		},
		_disableVerticalGrid: function () {
			this.grid.element.removeClass(this.css.verticalContainerCssClass);
			if (!this.grid.options.showHeader || !this.grid.options.fixedHeaders || this.grid.options.height === null) {
				this.grid.headersTable().children("thead").css("display", "");
			} else {
				this.grid.headersTable().css("position", "");
				this.grid.headersTable().css("top", "");
			}
			this._vr = false;
			this._modifySortingStyles(true);
			this.grid._rerenderColgroups();
			this.grid._renderData();
		},
		_getGridColumnBySetting: function (cs) {
			// Gets the column in the grid options corresponding to the provided columnSetting
			// returns undefined if the column cannot be found
			var col;
			if (cs.columnKey && typeof cs.columnKey === "string") {
				col = this.grid.columnByKey(cs.columnKey);
			} else if (cs.columnIndex !== null && cs.columnIndex !== undefined && typeof cs.columnIndex === "number" &&
				cs.columnIndex >= 0 && cs.columnIndex < this.grid.options.columns.length) {
				col = this.grid.options.columns[cs.columnIndex];
			}
			return col;
		},
		_getArgsByColumnSetting: function (cs) {
			// Gets the event args per column setting
			return {
				owner: this,
				columnIndex: cs.columnIndex || null,
				columnKey: cs.columnKey || null
			};
		},
		_getArgsByColumn: function (col) {
			// Gets the event args per column
			return {
				owner: this,
				columnIndex: $.inArray(col, this.grid.options.columns),
				columnKey: col.key || null
			};
		},
		_getCurrentMode: function () {
			// Gets the current mode as a string.
			// returns undefined if no mode is detected
			var env;
			$.each(this._modes, function (key, value) {
				if (this.isActive() === true) {
					env = key;
					return false;
				}
			});
			return env;
		},
		_containerResized: function (nw, nh) {
			// The resposniveContainer callback.
			// Detects mode changes and notifies about them, calls for update if needed.
			var mode = this._getCurrentMode(), shouldUpdate = false;
			if (nw <= 0 && nh <= 0) {
				// don't react as the grid is probably hidden
				return;
			}
			this._setMaxWidthOnGrid();
			if (mode && mode !== this._mode) {
				this._trigger(this.events.responsiveModeChanged, null, { owner: this, previousMode: this._mode, mode: mode });
				this._mode = mode;
				shouldUpdate = true;
			}
			if (shouldUpdate || this._hiddenByClass) {
				this._updateGridSync(false, shouldUpdate);
			}
			if (this._shouldRenderVertically()) {
				if (!this._vr) {
					this._enableVerticalGrid();
				}
			} else {
				if (this._vr) {
					this._disableVerticalGrid();
				}
			}
		},
		_gridHeaderRendering: function (evt, ui) {
			var i;
			if (ui.owner.id() !== this.grid.id()) {
				return;
			}
			this._renderTestElement();
			this._mode = this._getCurrentMode();
			this._defaultColumnTemplates = this._getDefaultColumnTemplates();
			if ($.isArray(this.grid._initialHiddenColumns)) {
				for (i = 0; i < this.grid._initialHiddenColumns.length; i++) {
					this.grid._initialHiddenColumns[i].hidden = true;
				}
			}
			this._updateGridSync(true, true);
			this.grid._captureInitiallyHiddenColumns();
		},
		_initialGridRendered: function (evt, ui) {
			this._activateContainer();
			if (this._vr === true) {
				if (!this.grid.options.showHeader || !this.grid.options.fixedHeaders || this.grid.options.height === null) {
					this.grid.headersTable().children("thead").css("display", "none");
				} else {
					this.grid.headersTable().css("position", "absolute");
					this.grid.headersTable().css("top", "-100px");
				}
				this.grid.element.addClass(this.css.verticalContainerCssClass);
				this._modifySortingStyles();
			}
			this._alreadyRendered = true;
			this._setMaxWidthOnGrid();
		},
		_dataRendered: function () {
			this._setMaxWidthOnGrid();
		},
		_modifySortingStyles: function (restore) {
			var sorting = this.grid.element.data("igGridSorting");
			if (sorting) {
				if (restore) {
					sorting.options.applySortedColumnCss = this._srs;
				} else {
					this._srs = sorting.options.applySortedColumnCss;
					sorting.options.applySortedColumnCss = false;
				}
			}
		},
		_heightChanged: function (evt, ui) {
			var newHeight = $('#' + this.grid.element[0].id + '_scroll').height();
			if (this._height !== newHeight) {
				this._height = newHeight;
				this.grid._adjustLastColumnWidth(false);
				this._setMaxWidthOnGrid();
			}
		},
		_setMaxWidthOnGrid: function () {
			var sbw = this.grid._hasVerticalScrollbar === true ? this.grid._scrollbarWidth() : 0, npw;
			// forces grid to acknowledge the whole content is visible and
			// no horizontal scrollbar should appear
			this.grid._gridContentWidth = 0;
			this.grid.element.css("width", "100%");
			if (!this.grid._allColumnWidthsInPercentage) {
				npw = 100 - (sbw / this.grid.container().width()) * 100;
				if (this.grid.options.fixedHeaders === true) {
					this.grid.headersTable().css("width", npw + "%");
				}
				if (this.grid.options.fixedFooters === true) {
					this.grid.footersTable().css("width", (npw + this._footersDisplacement) + "%");
				}
			}
		},
		_createHandlers: function () {
			this._gridHeaderRenderingHandler = $.proxy(this._gridHeaderRendering, this);
			this._initialGridRenderedHandler = $.proxy(this._initialGridRendered, this);
			this._gridContainerHeightHandler = $.proxy(this._heightChanged, this);
		},
		_injectGrid: function (gridInstance, isRebind) {
			if (isRebind === true) {
				return;
			}
			this.grid = gridInstance;
			this._createHandlers();
			if (this.options.forceResponsiveGridWidth === true) {
				this.grid.options.width = typeof this.grid.options.width === "string" && this.grid.options.width.endsWith("%") ?
					this.grid.options.width : "100%";
				this.grid.options.autoFitLastColumn = false;
			}
			if (this.options.reactOnContainerWidthChanges === true) {
				this.grid.element.bind("iggridheaderrendering", this._gridHeaderRenderingHandler);
				this.grid.element.bind("iggridrendered", this._initialGridRenderedHandler);
			}
			// If the grid has height in % we need to react when grid changes heights
			if (this.grid.options.height !== null && this.grid.options.height.indexOf && this.grid.options.height.indexOf('%') !== -1) {
				this.grid.element.bind("iggrid_heightchanged", this._gridContainerHeightHandler);
			}
			// vertical rendering implementation
			this._originalRenderRecord = $.proxy(this.grid._renderRecord, this.grid);
			this._newRenderRecord = $.proxy(this._renderRecord, this);
			this._originalRenderColgroup = $.proxy(this.grid._renderColgroup, this.grid);
			this._newRenderColgroup = $.proxy(this._renderColgroup, this);
			this.grid._renderRecord = this._newRenderRecord;
			this.grid._renderColgroup = this._newRenderColgroup;
		}
	});
	$.extend($.ui.igGridResponsive, { version: "14.1.20141.2249" });

	$.ig = $.ig || {};

	$.ig.ResponsiveMode = $.ig.ResponsiveMode || Class.extend({
		settings: {
			minWidth: -1,
			maxWidth: Number.MAX_VALUE,
			minHeight: -1,
			maxHeight: Number.MAX_VALUE
		},
		init: function (options) {
			if (options) {
				this.settings = $.extend(true, {}, $.ig.ResponsiveMode.prototype.settings, options);
			}
			return this;
		},
		isActive: function () {
			return window.innerWidth >= this.settings.minWidth &&
				window.innerWidth <= this.settings.maxWidth &&
				window.innerHeight >= this.settings.minHeight &&
				window.innerHeight <= this.settings.maxHeight;
		}
	});

	$.ig.InfragisticsMode = $.ig.InfragisticsMode || $.ig.ResponsiveMode.extend({
		settings: {
			key: "",
			visibilityTester: null
		},
		init: function (options) {
			this._hc = "ui-hidden-" + options.key;
			this._vc = "ui-visible-" + options.key;
			this._super(options);
			return this;
		},
		isActive: function () {
			if (typeof this.settings.visibilityTester === "function") {
				return this.settings.visibilityTester(this._hc) === false && this.settings.visibilityTester(this._vc) === true;
			}
			return this._super();
		}
	});

	$.ig.BootstrapMode = $.ig.BootstrapMode || $.ig.ResponsiveMode.extend({
		settings: {
			key: "",
			visibilityTester: null
		},
		init: function (options) {
			this._hc = "hidden-" + options.key;
			this._vc = "visible-" + options.key;
			this._super(options);
			return this;
		},
		isActive: function () {
			if (typeof this.settings.visibilityTester === "function") {
				return this.settings.visibilityTester(this._hc) === false && this.settings.visibilityTester(this._vc) === true;
			}
			return this._super();
		}
	});
}(jQuery));
/*!@license
 * Infragistics.Web.ClientUI Grid Tooltips 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.editors.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}
(function ($) {

	/*
		igGridRowSelectors widget.
		The widget is pluggable to the element where the grid is instantiated and the actual igGrid object doesn't know about this.
		The Row Selectors widget works as a grid feature and injects an additional column on the left side of the initial table
		The column cells can be clicked to expand children grids derriving from the expanded row.
	*/
	$.widget("ui.igGridRowSelectors", {
		options: {
			/* type="bool" determines whether the row selectors column should contain row numbering */
			enableRowNumbering: true,
			/* type="bool" determines whether the row selectors column should contain checkboxes */
			enableCheckBoxes: false,
			/* type="number" the seed to be added to the default numbering */
			rowNumberingSeed: 0,
			/* type="string|number|null"
				string The row selector column width can be set in pixels (px) and percentage (%)
				number The row selector width can be set as a number
				null type="object" will let the feature decide the best width depending on enabled contents
			*/
			rowSelectorColumnWidth: null,
			/* type="bool" determines whether the selection feature is required for the row selectors. If set to "false" 
			the widget will not check for Selection availability. If set to "true" an exception will be thrown if Selection is
			not available. */
			requireSelection: true,
			/* type="bool" determines whether checkboxes will be shown only if row selectors are on focus/selected.
			*/
			showCheckBoxesOnFocus: false
		},
		css: {
			/* Classes applied to the row selectors grid cells. */
			rowSelector: "ui-iggrid-rowselector-class",
			/* Classes applied to the row selectors grid cells when they are selected */
			rowSelectorSelected: "ui-iggrid-selectedcell ui-state-active",
			/* Classes applied to the row selectors header cells. */
			headerRowSelector: "ui-iggrid-rowselector-header",
			/* Classes applied to the row selectors footer cells. */
			footerRowSelector: "ui-iggrid-rowselector-footer",
			/* Classes applied to the checkbox container */
			checkBox: "ui-state-default ui-corner-all ui-igcheckbox-normal",
			/* Classes defining the unchecked state of the checkbox */
			checkBoxOff: "ui-icon ui-icon-check ui-igcheckbox-normal-off",
			/* Classes defining the checked state of the checkbox */
			checkBoxOn: "ui-icon ui-icon-check ui-igcheckbox-normal-on",
			/* Class defining the hover state style of the node */
			nodeHovered: "ui-state-hover"
		},
		events: {
			/* Event fired after a row selector is clicked. 
			Function takes arguments evt and ui.
			Use ui.row to get reference to the row the clicked row selector resides in.
			Use ui.fixedRow to get reference to the fixed row the clicked row selector resides in(if there are fixed columns).
			Use ui.rowIndex to get the index of the row the clicked row selector resides in.
			Use ui.rowKey to get the key of the row the clicked row selector resides in.
			Use ui.rowSelector to get reference to the row selector cell.
			Use ui.owner to get reference to igRowSelectors.
			Use ui.grid to get reference to the igGrid the igRowSelectors are initialized for.
			*/
			rowSelectorClicked: "rowSelectorClicked",
			/* cancel="true" Event fired when a row selector checkbox is changing.
			Function takes arguments evt and ui.
			Use ui.row to get reference to the row the clicked row selector resides in.
			Use ui.rowIndex to get the index of the row the clicked row selector resides in.
			Use ui.rowKey to get the key of the row the clicked row selector resides in.
			Use ui.rowSelector to get reference to the row selector cell.
			Use ui.owner to get reference to igRowSelectors.
			Use ui.grid to get reference to the igGrid the igRowSelectors are initialized for.
			Use ui.currentState to get the current state of the checkbox ("on","off").
			Use ui.newState to get the new state of the checkbox ("on","off").
			Use ui.isHeader to check if the header check box is the one being clicked. In this case no row related args are passed.
			*/
			checkBoxStateChanging: "checkBoxStateChanging",
			/* Event fired after a row selector checkbox had changed state.
			Function takes arguments evt and ui.
			Use ui.row to get reference to the row the clicked row selector resides in.
			Use ui.rowIndex to get the index of the row the clicked row selector resides in.
			Use ui.rowKey to get the key of the row the clicked row selector resides in.
			Use ui.rowSelector to get reference to the row selector cell.
			Use ui.owner to get reference to igRowSelectors.
			Use ui.grid to get reference to the igGrid the igRowSelectors are initialized for.
			Use ui.state to get the state of the checkbox ("on","off").
			Use ui.isHeader to check if the header check box is the one being clicked. In this case no row related args are passed.
			*/
			checkBoxStateChanged: "checkBoxStateChanged"
		},
		_createWidget: function (options, element) {
			$.Widget.prototype._createWidget.apply(this, arguments);
			if (this.options.rowSelectorColumnWidth === null) {
				this.options.rowSelectorColumnWidth = 55;
				if (this.options.enableCheckBoxes === true && this.options.enableRowNumbering === true) {
					this.options.rowSelectorColumnWidth += 15;
				}
			}
		},
		_create: function () {
			// the the index of the last generated row selector
			this._cIdx = 0;
			// whether grid rendering functions have been replaced with rs ones
			this._functionsRedirected = false;
			// stores the hovered table row
			this._hovTR = null;
			// stores the original renderRecord function
			this._gridRenderRecord = null;
			// stores the original renderRecordInArray function
			this._gridRenderRecordInArray = null;
			// stores the checkboxes visibility status
			this._checkBoxesShown = false;
			// stores a template for getting number span when templating is enabled
			this._nTmpl = "{{html ig_rs_idx}}";
			this._sTmpl = "{{if ${ig_rs_sel} === true}}" + this.css.rowSelectorSelected + "{{/if}}";
			// stores fixed v flag
			this._v = false;
			// multiple selection flag
			this._ms = false;
		},
		destroy: function () {
			this._unregisterEvents();
			this._unregisterCellEvents();
			if (this._gridRenderRecordHandler !== undefined) {
				this.grid._renderColgroup = this._flatRenderColgroup;
				this.grid._renderRecord = this._gridRenderRecordHandler;
				this.grid._renderRecordInArray = this._gridRenderRecordInArrayHandler;
			}
			if (this.options.enableCheckBoxes === true) {
				this._unregisterCheckBoxEvents();
			}
			this._cleanInterface(false);
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		_renderHeaderRowSelectors: function (owner) {
			var rows, i, cell, header, $thDataSkip;
			if (owner.id() !== this.grid.id()) {
				return;
			}
			rows = this.grid.headersTable().children("thead").children();
			// creates the header cells for row selectors on each row
			if (rows.length > 0) {
				// getting the expand header cell
				cell = rows.eq(0).find("th.ui-iggrid-expandheadercell").first();
				if (cell.length === 0) {
					this._index = 0;
				} else {
					this._index = cell.index() + 1;
				}
				// add support for multi column headers
				if (this.grid._isMultiColumnGrid) {
					$thDataSkip = $("<th></th>").prependTo(this.grid.headersTable().find("thead tr:nth-child(1)"))
						.addClass(this.css.headerRowSelector)
						.addClass(this.grid.css.headerClass)
						.attr("data-role", "rs")
						.attr("data-skip", "true");
					$thDataSkip.attr("rowspan", this.grid._maxLevel + 1);
					if (this.options.enableCheckBoxes === true && this._ms) {
						// M.H. 13 Aug 2012 Fix for bug #118563
						$(this._getCheckBox(true)).appendTo($thDataSkip);
					}
				} else {
					for (i = 0; i < rows.length; i++) {
						// the row selector cell is already present
						if (rows.eq(i).find("th[data-role='rs']").length > 0) {
							continue;
						}
						// adding the header cell
						// S.S. April 9, 2012 Bug #103459 IE7 doesn't render empty cells, we need to add dummy data.
						header = $("<th>" + ($.ig.util.isIE7 ? "&nbsp;" : "") + "</th>")
							.addClass(this.css.headerRowSelector)
							.addClass(i === 0 ? this.grid.css.headerClass : "")
							.attr("data-role", "rs")
							.attr("data-skip", "true")
							.insertBefore(rows.eq(i).children().eq(this._index));
						if (this.options.enableCheckBoxes === true && i === 0 && this._ms) {
							$(this._getCheckBox(true)).appendTo(header);
						}
					}
				}
			}
		},
		_renderFooterRowSelectors: function (owner) {
			var rows, i;
			if (owner.id() !== this.grid.id()) {
				return;
			}
			rows = this.grid.footersTable().children("tfoot").children();
			// creates the header cells for row selectors on each row
			if (rows.length > 0) {
				for (i = 0; i < rows.length; i++) {
					// the row selector cell is already present
					if (rows.eq(i).find("td[data-role='rs']").length > 0) {
						continue;
					}
					// adding the header cell
					// S.S. April 9, 2012 Bug #103459 IE7 doesn't render empty cells, we need to add dummy data.
					$("<td>" + ($.ig.util.isIE7 ? "&nbsp;" : "") + "</td>")
						.addClass(this.css.footerRowSelector)
						.attr("data-role", "rs")
						.attr("data-skip", "true")
						.insertBefore(rows.eq(i).children().eq(this._index));
				}
			}
		},
		_headerRendered: function (event, ui) {
			this._ms = !this._skipRefresh && this.grid.element.igGridSelection("option", "multipleSelection") === true;
			this._renderHeaderRowSelectors(ui.owner);
			this._getColumnFixingInstance();
		},
		_footerRendered: function (event, ui) {
			this._renderFooterRowSelectors(ui.owner);
		},
		_getColumnFixingInstance: function () {
			if (!this._columnFixing && this.grid.element.data('igGridColumnFixing')) {
				this._columnFixing = this.grid.element.data('igGridColumnFixing');
			}
			return this._columnFixing;
		},
		_recordsRendering: function (event, ui) {
			if (this.grid.id() !== ui.owner.id()) {
				return;
			}
			// S.S. August 21, 2012, Bug #113279 Adding the continuous virtualization marker detection so that proper numbering can be
			// applied in the non-template case
			this._cIdx = ui.vrtWnd.start && ui.vrtWnd.end ? ui.vrtWnd.start : 0;
			if (this._functionsRedirected === false) {
				// render record
				this._renderRecordHandler = $.proxy(this._rsRenderRecord, this);
				this._renderRecordInArrayHandler = $.proxy(this._rsRenderRecordInArray, this);
				this._gridRenderRecordHandler = $.proxy(this.grid._renderRecord, this.grid);
				this._gridRenderRecordInArrayHandler = $.proxy(this.grid._renderRecordInArray, this.grid);
				// register for row rendering
				this._gridRenderRecord = this._gridRenderRecordHandler;
				this._gridRenderRecordInArray = this._gridRenderRecordInArrayHandler;
				this.grid._renderRecord = this._renderRecordHandler;
				this.grid._renderRecordInArray = this._renderRecordInArrayHandler;
			}
			this._functionsRedirected = true;
		},
		_recordsRendered: function (event, ui) {
			if (this.grid.id() !== ui.owner.id()) {
				return;
			}
			if (this.options.enableCheckBoxes === true) {
				this._registerCheckBoxEvents();
				this._updateHeader();
			}
		},
		_gridRendered: function (event, ui) {
			if (ui === undefined) {
				return;
			}
			if (this.grid.id() !== ui.owner.id()) {
				return;
			}
			// ensuring the internal property is set even when showHeader is false
			this._ms = !this._skipRefresh && this.grid.element.igGridSelection("option", "multipleSelection") === true;
			this._unregisterCellEvents();
			this._registerCellEvents();
			if (this.options.enableCheckBoxes === true) {
				this._registerCheckBoxEvents();
			}
		},
		_hidingFinished: function () {
			this._unregisterCellEvents();
			this._registerCellEvents();
		},
		_rsRenderColgroup: function (flatRenderColgroup, rs, table, isHeader, isFooter, autofitLastColumn) {
			var cf;
			flatRenderColgroup.apply(this, [table, isHeader, isFooter, autofitLastColumn]);
			if (rs.grid.hasFixedColumns()) {
				cf = rs._getColumnFixingInstance();
				if (cf.options.fixingDirection === 'left') {
					return;
				}
			}
			rs._rsRenderColgroupHelper(table);
		},
		_rsRenderColgroupHelper: function (table) {
			var cgrp;
			cgrp = $(table).find("colgroup");
			if (cgrp.find("col[data-role='rs']").length === 0) {
				$("<col></col>")
					.prependTo(cgrp)
					.css('width', this.options.rowSelectorColumnWidth)
					.attr('data-skip', 'true')
					.attr('data-role', 'rs');
			}
		},
		_rsRenderFixedColgroup: function (isHeader, isFooter, autofitLastColumn) {
			var cf = this._columnFixing, table;
			this._renderFixedColgroupHandler(isHeader, isFooter, autofitLastColumn);

			if (!cf || cf.options.fixingDirection !== 'left') {
				return;
			}
			if (isHeader) {
				table = cf._containers.header.fixedTable || cf._containers.body.fixedTable;
			} else if (isFooter) {
				table = cf._containers.footer.fixedTable || cf._containers.body.fixedTable;
			} else {
				table = cf._containers.body.fixedTable;
			}
			this._rsRenderColgroupHelper(table);
		},
		_rsRenderFixedRecord: function (data, rowIndex) {
			var markup = this._renderFixedRecordHandler(data, rowIndex), pre, app, idx,
				rs = this._getRowSelectorCellMarkup(false, markup.indexOf("ui-iggrid-selectedcell") !== -1);
			idx = markup.indexOf("ui-iggrid-expandcolumn");
			if (idx >= 0) {
				app = markup.substr(idx);
				idx = idx + app.indexOf("</td>") + 4;
				pre = markup.substring(0, idx + 1);
				app = markup.substring(idx + 1);
			} else {
				idx = markup.indexOf(">") + 1;
				pre = markup.substring(0, idx);
				app = markup.substring(idx);
			}
			markup = pre + rs + app;
			return markup;
		},
		_rsRenderRecord: function (data, rowIndex) {
			var markup = this._gridRenderRecord(data, rowIndex), pre, app, idx,
				rs = this._getRowSelectorCellMarkup(false, markup.indexOf("ui-iggrid-selectedcell") !== -1);
			idx = markup.indexOf("ui-iggrid-expandcolumn");
			if (idx >= 0) {
				app = markup.substr(idx);
				idx = idx + app.indexOf("</td>") + 4;
				pre = markup.substring(0, idx + 1);
				app = markup.substring(idx + 1);
			} else {
				idx = markup.indexOf(">") + 1;
				pre = markup.substring(0, idx);
				app = markup.substring(idx);
			}
			markup = pre + rs + app;
			return markup;
		},
		_rsRenderRecordInArray: function (darr, tbody, data, rowIndex) {
			var i, j, sel = false;
			this._gridRenderRecordInArray(darr, tbody, data, rowIndex);
			for (i = darr.length - 1; i >= 0; i--) {
				if (darr[i].indexOf && darr[i].indexOf("<tr") !== -1) {
					for (j = i; j < darr.length; j++) {
						if (darr[j].indexOf && darr[j].indexOf("ui-iggrid-selectedcell") !== -1) {
							sel = true;
								break;
							}
					}
					for (j = i; j < darr.length; j++) {
						if (darr[j].indexOf && darr[j].indexOf("<td") !== -1) {
							if (darr[j].indexOf("ui-iggrid-expandcolumn") !== -1) {
								darr[j] += this._getRowSelectorCellMarkup(false, sel);
								sel = false;
							break;
						}
							darr[j] = this._getRowSelectorCellMarkup(false, sel) + darr[j];
							sel = false;
							break;
					}
					}
					break;
				}
			}
		},
		_renderExtraHeaderCells: function (row, colgroup, prepend) {
			this._renderExtraCells(row, colgroup, prepend, true);
		},
		_renderExtraFooterCells: function (row, colgroup, prepend, cssClass) {
			this._renderExtraCells(row, colgroup, prepend, false, cssClass);
		},
		_renderExtraCells: function (row, colgroup, prepend, header, cssClass) {
			var rHeader, rCol, index, cell;
			// the row selector cell is already present
			// S.S. October 20, 2011 Bug #93127 Footer cells were changed to TD-s in an earlier stage and this selector should
			// work for both TH-s and TD-s so it can properly skip adding additional cells in both THEAD and TFOOT.
			if (row.find("[data-role='rs']").length > 0) {
				return;
			}
			if (header === true) {
				// S.S. April 9, 2012 Bug #103459 IE7 doesn't render empty cells, we need to add dummy data.
				rHeader = $("<th>" + ($.ig.util.isIE7 ? "&nbsp;" : "") + "</th>")
					.addClass(this.css.headerRowSelector)
					.attr("data-role", "rs")
					.attr("data-skip", "true");
			} else {
				rHeader = $("<td>" + ($.ig.util.isIE7 ? "&nbsp;" : "") + "</td>")
					.addClass(this.css.footerRowSelector)
					.addClass(cssClass)
					.attr("data-role", "rs")
					.attr("data-skip", "true");
			}
			cell = row.find("th.ui-iggrid-expandheadercell,td.ui-iggrid-expandheadercellgb");
			if (cell.length === 0) {
				cell = row.children().first();
				index = 0;
			} else {
				index = cell.last().index() + 1;
			}
			if (index === 0) {
				rHeader.prependTo(row);
			} else {
				rHeader.insertBefore(row.children().eq(index));
			}
			if (colgroup) {
				rCol = $("<col></col>")
					.attr("data-skip", "true")
					.attr("data-role", "rs")
					.css("width", this.options.rowSelectorColumnWidth);
				rCol.insertBefore(colgroup.children().eq(index));
			}
		},
		_registerCellEvents: function () {
			// select all body th-s
			this._allRowSelectorCells()
				.bind({
					"click": this._rsClickHandler
				});
			// bind to tbody for hover styles
			this.grid.element.children("tbody")
				.bind({
					"mousemove": this._rrHoverHandler,
					"mouseleave": this._rrLeaveHandler
				});
		},
		_unregisterCellEvents: function () {
			this._allRowSelectorCells()
				.unbind({
					"click": this._rsClickHandler
				});
			this.grid.element.children("tbody")
				.unbind({
					"mousemove": this._rrHoverHandler,
					"mouseleave": this._rrLeaveHandler
				});
		},
		_registerCheckBoxEvents: function () {
			this._allCheckboxes()
				.unbind({
					"click": this._checkboxClickHandler,
					"mouseover": this._checkboxMouseOverHandler,
					"mouseout": this._checkboxMouseOutHandler
				})
				.bind({
					"click": this._checkboxClickHandler,
					"mouseover": this._checkboxMouseOverHandler,
					"mouseout": this._checkboxMouseOutHandler
				});
			this._headerCheckbox()
				.unbind({
					"click": this._hCheckboxClickHandler,
					"mouseover": this._checkboxMouseOverHandler,
					"mouseout": this._checkboxMouseOutHandler
				})
				.bind({
					"click": this._hCheckboxClickHandler,
					"mouseover": this._checkboxMouseOverHandler,
					"mouseout": this._checkboxMouseOutHandler
				});
		},
		_unregisterCheckBoxEvents: function () {
			this._allCheckboxes()
				.unbind({
					"click": this._checkboxClickHandler,
					"mouseover": this._checkboxMouseOverHandler,
					"mouseout": this._checkboxMouseOutHandler
				});
			this._headerCheckbox()
				.unbind({
					"click": this._hCheckboxClickHandler,
					"mouseover": this._checkboxMouseOverHandler,
					"mouseout": this._checkboxMouseOutHandler
				});
		},
		_checkboxMouseOver: function (event) {
			$(event.target).closest("span[data-role='checkbox']").addClass(this.css.nodeHovered);
		},
		_checkboxMouseOut: function (event) {
			$(event.target).closest("span[data-role='checkbox']").removeClass(this.css.nodeHovered);
		},
		_checkBoxClicked: function (event) {
			var trg = $(event.target).closest("span[name='chk']"), rCell = trg.parent(), rRow = rCell.parent(), args,
				rIdx = this._getVisibleRowIndex(rRow), rKey = rRow.attr("data-id"), noCancel, state = trg.attr("data-chk");
			if (rKey === "" || rKey === null || rKey === undefined) {
				rKey = rIdx;
			}
			args = {
				row: rRow,
				rowIndex: rIdx,
				rowKey: rKey,
				rowSelector: rCell,
				owner: this,
				grid: this.grid,
				currentState: state,
				newState: state === "off" ? "on" : "off",
				isHeader: false
			};
			noCancel = this._triggerCheckingEvent(event, args);
			if (noCancel === true) {
				this._handleCheck(trg);
				this._updateHeader();
				// modifying args to trigger checked event
				delete args.currentState;
				args.state = args.newState;
				delete args.newState;
				this._triggerCheckedEvent(event, args);
			}
			event.stopPropagation();
		},
		_headerCheckBoxClicked: function (event) {
			var trg = $(event.target).closest("span[name='hchk']"), args, noCancel, state = trg.attr("data-chk");
			args = {
				owner: this,
				grid: this.grid,
				currentState: state,
				newState: state === "off" ? "on" : "off",
				isHeader: true
			};
			noCancel = this._triggerCheckingEvent(event, args);
			if (noCancel === true) {
				this._handleHeaderCheck(trg);
				// modifying args to trigger checked event
				delete args.currentState;
				args.state = args.newState;
				delete args.newState;
				this._triggerCheckedEvent(event, args);
			}
			event.stopPropagation();
			event.preventDefault();
		},
		_handleCheck: function (checkbox) {
			var row = checkbox.parent().parent(), idx = this._getVisibleRowIndex(row),
				rIdx = this._getVisibleHRowIndex(row), offset = 0, upd, sel;
			if (checkbox === undefined || checkbox === null) {
				return;
			}
			upd = this.grid.element.data("igGridUpdating");
			sel = this.grid.element.data("igGridSelection");
			if (sel && sel._suspend) {
				if (upd) {
					if (upd.findInvalid()) {
						return;
					} else {
						upd._endEdit(null, true);
					}
				} else {
					return;
				}
			}
			if (this._v === true) {
				offset = this.grid._startRowIndex;
			}
			if (checkbox.attr("data-chk") === "off") {
				this._alterCheckbox(checkbox, true);
				// if selection is single we need to explicitly remove the styles
				if (!this._ms) {
					this._clearRowSelectorsSelection();
				}
				// selects the row using the igGridSelection method
				this.grid.element.igGridSelection("selectRow", rIdx + offset);
			} else {
				this._alterCheckbox(checkbox, false);
				// deselects the row using the igGridSelection method
				this.grid.element.igGridSelection("deselectRow", rIdx + offset);
			}
		},
		_handleHeaderCheck: function (checkbox) {
			var checkBoxes = this._allCheckboxes(), i, vfs, sm;
			this.grid.element.unbind("iggridselectioninternalrowselectionchanged", this._rowSelectionChangedHandler);
			if (checkbox.attr("data-chk") === "off") {
				this._alterCheckbox(checkbox, true);
				for (i = 0; i < checkBoxes.length; i++) {
					if (checkBoxes.eq(i).attr("data-chk") === "off") {
						this._handleCheck(checkBoxes.eq(i));
					}
				}
			} else {
				this._alterCheckbox(checkbox, false);
				for (i = 0; i < checkBoxes.length; i++) {
					if (checkBoxes.eq(i).attr("data-chk") === "on") {
						this._handleCheck(checkBoxes.eq(i));
					}
				}
			}
			if (this._v === true) {
				// if we have a virtual grid we need to extend the header checkbox
				// effect to checkboxes which cannot be immediately selected.
				vfs = checkbox.attr("data-chk") === "on" ? true : false;
				sm = vfs ? "selectRow" : "deselectRow";
				for (i = 0; i < this.grid._startRowIndex; i++) {
						this.grid.element.igGridSelection(sm, i);
					}
				for (i = this.grid._startRowIndex + this.grid._virtualRowCount; i < this.grid._totalRowCount; i++) {
						this.grid.element.igGridSelection(sm, i);
					}
				}
			this.grid.element.bind("iggridselectioninternalrowselectionchanged", this._rowSelectionChangedHandler);
		},
		_updateHeader: function () {
			var checkboxes = this._allCheckboxes(), header = this._headerCheckbox(), check = true, i;
			for (i = 0; i < checkboxes.length; i++) {
				if (checkboxes.eq(i).attr("data-chk") === "off") {
					check = false;
					break;
				}
			}
			this._alterCheckbox(header, check);
		},
		_alterCheckbox: function (checkbox, check) {
			var inner = checkbox.children().first();
			if (checkbox.length > 0 && inner.length > 0) {
				if (check === true) {
					checkbox.attr("data-chk", "on");
					inner.removeClass(this.css.checkBoxOff).addClass(this.css.checkBoxOn);
				} else {
					checkbox.attr("data-chk", "off");
					inner.removeClass(this.css.checkBoxOn).addClass(this.css.checkBoxOff);
				}
			}
		},
		_getRowSelectorCellMarkup: function (template, selected) {
			var markup = '';
			markup += '<th class="' + this.css.rowSelector;
			if (selected) {
				markup += ' ' + this.css.rowSelectorSelected;
			}
			if (template) {
				markup += ' ' + this._sTmpl;
			}
			markup += '"><span class="ui-icon ui-icon-triangle-1-e" style="margin-left: -5px"></span>';
			if (this.options.enableRowNumbering) {
				markup += template === true ? this._nTmpl : this._getCurrentNumber();
			}
			if (this.options.enableCheckBoxes) {
				markup += this._getCheckBox(false, selected);
			}
			markup += '</th>';
			return markup;
		},
		_getCheckBox: function (header, checked) {
			var markup = '';
			markup += '<span name="' + (header === true ? 'hchk' : 'chk') + '" ';
			markup += 'data-chk="' + (checked ? "on" : "off") + '" ';
			markup += 'data-role="checkbox" class="' + this.css.checkBox + ' "';
			if (this.options.showCheckBoxesOnFocus === true && this._checkBoxesShown === false) {
				markup += ' style="visibility: hidden;"';
			}
			markup += '><span class="' + (checked ? this.css.checkBoxOn : this.css.checkBoxOff) + '">';
			markup += '</span></span>';
			return markup;
		},
		_getCurrentNumber: function (id) {
			var seed;
			if (id !== undefined && id !== null) {
				seed = id;
			} else {
				seed = ++this._cIdx;
			}
			return '<span class="ui-iggrid-rowselector-row-number">' +
				(seed + this.options.rowNumberingSeed + this._getStartingIndexForPage()) +
				'</span>';
		},
		_getStartingIndexForPage: function () {
			return (this.grid.dataSource.pageIndex() * this.grid.dataSource.pageSize());
		},
		_rsRenderVirtualRecords: function (event, ui) {
			var i = 0, rs;
			// every time records are rerendered we need to clean rendering flags
			this._cIdx = 0;
			// generate rs dom and prepend to rows
			for (i; i < ui.rows.length; i++) {
				rs = $(this._getRowSelectorCellMarkup());
				rs.prependTo(ui.rows.eq(i));
			}
			// register events
			this._unregisterCellEvents();
			this._registerCellEvents();
			if (this.options.enableCheckBoxes === true) {
				this._registerCheckBoxEvents();
			}
		},
		_rrn: function (event, args) {
			var rs = this._allRowSelectorCells(), cb = this._allCheckboxes(), i = 0, self = this,
				sri = this.grid._startRowIndex || 0, trc = this.grid._totalRowCount, sc, sr;
			if (this.options.enableRowNumbering === true) {
				for (i = 0; i < rs.length; i++) {
					rs.eq(i)
						.removeClass(this.css.nodeHovered)
						.children("span.ui-iggrid-rowselector-row-number")
						.text(sri + i + this.options.rowNumberingSeed + 1);
				}
			}
			if (!this._skipRefresh) {
				rs.removeClass(this.css.rowSelectorSelected);
				cb.map(function () {
					self._alterCheckbox($(this), false);
				});
				if (!this._ms) {
					sc = this.grid._selectedCell ? [this.grid._selectedCell] : [];
					sr = this.grid._selectedRow ? [this.grid._selectedRow] : [];
				} else {
					sc = this.grid._selectedCells;
					sr = this.grid._selectedRows;
				}
				for (i = 0; i < sc.length; i++) {
					if (sc[i].rowIndex >= sri && sc[i].rowIndex < sri + trc) {
						rs.eq(sc[i].rowIndex - sri).addClass(this.css.rowSelectorSelected);
			}
				}
				for (i = 0; i < sr.length; i++) {
					if (sr[i].index >= sri && sr[i].index < sri + trc) {
						rs.eq(sr[i].index - sri).addClass(this.css.rowSelectorSelected);
						if (this.options.enableCheckBoxes === true) {
							this._alterCheckbox(cb.eq(sr[i].index - sri), true);
				}
				}
				}
			}
		},
		_cSelectionChanged: function (event, ui) {
			var cells, cog = false;
			if (ui.owner.grid.id() !== this.grid.id()) {
				cog = true;
			}
			if (!this._ms) {
				cells = [this.grid._selectedCell];
			} else {
				cells = ui.selectedCells;
			}
			this._selectionChanged(this.grid._selectedRows, cells, cog);
		},
		_rSelectionChanged: function (event, ui) {
			var rows, cog = false;
			if (ui.owner.grid.id() !== this.grid.id()) {
				cog = true;
			}
			if (!this._ms) {
				rows = [this.grid._selectedRow];
			} else {
				rows = ui.selectedRows;
			}
			// M.H. 23 Aug 2013 Fix for bug #149779: When you check and uncheck a checkbox of a row the row selector stays selected.
			if (this.grid.hasFixedColumns() &&
				this._getColumnFixingInstance().options.fixingDirection === 'left') {
				// M.H. 4 Sep 2013 Fix for bug #151245: When row selectors are fixed selecting a row does not select the row selector.
				if (ui.selectedFixedRows.length === 0) {
					rows = [this.grid._selectedFixedRow];
				} else {
					rows = ui.selectedFixedRows;
				}
				this._selectionChanged(rows, this.grid._selectedFixedCells, cog);
			} else {
				this._selectionChanged(rows, this.grid._selectedCells, cog);
			}
		},
		_selectionChanged: function (selRows, selCells, selectedOtherGrid) {
			var i, row, cell, rowInRange, rowSelector, checkbox, selRow, selCell, sri = this.grid._startRowIndex || 0;
			this._clearRowSelectorsSelection();
			if (selectedOtherGrid === true) {
				return;
			}
			if (this._checkBoxesShown === false && this.options.showCheckBoxesOnFocus === true) {
				this._animateCheckboxes(true);
			}
			for (i = 0; i < selRows.length; i++) {
				selRow = selRows[i];
				rowInRange = true;
				if (this._v === true) {
					rowInRange = sri <= selRow.index && selRow.index < sri + this.grid._virtualRowCount;
				}
				row = selRow.element;
				if (row && row.length > 0 && rowInRange) {
					rowSelector = row.children("th");
					if (!rowSelector.hasClass(this.css.rowSelectorSelected)) {
						rowSelector.addClass(this.css.rowSelectorSelected);
					}
					if (this.options.enableCheckBoxes === true) {
						checkbox = rowSelector.find("span[name='chk']");
						this._alterCheckbox(checkbox, true);
					}
				}
			}
			for (i = 0; i < selCells.length; i++) {
				selCell = selCells[i];
				rowInRange = true;
				if (this._v === true) {
					rowInRange = sri <= selCell.rowIndex && selCell.rowIndex < sri + this.grid._virtualRowCount;
				}
				cell = selCell.element;
				if (cell && cell.length > 0 && rowInRange) {
					rowSelector = cell.siblings("th");
					if (!rowSelector.hasClass(this.css.rowSelectorSelected)) {
						rowSelector.addClass(this.css.rowSelectorSelected);
					}
				}
			}
			this._updateHeader();
		},
		_clearSelection: function (evt, ui) {
			if (ui.owner.id() === this.grid.id()) {
				this._clearRowSelectorsSelection();
			}
		},
		_clearRowSelectorsSelection: function () {
			// clears every selected row selector cell and checkbox
			var checkboxes, cb;
			this._allRowSelectorCells().removeClass(this.css.rowSelectorSelected);
			checkboxes = this.options.enableCheckBoxes ? this._allCheckboxes() : [];
			for (i = 0; i < checkboxes.length; i++) {
				cb = checkboxes.eq(i);
				if (cb.attr("data-chk") === "on") {
					this._alterCheckbox(cb, false);
				}
			}
			if (checkboxes.length > 0) {
				this._updateHeader();
			}
		},
		_cellClick: function (event, ui) {
			var args, target = $(event.target), fRow, rCell = target.closest("th"), rRow = rCell.parent(),
				rIdx = this._getVisibleRowIndex(rRow), rKey = rRow.attr("data-id");
			// Updating draws in the first cell. If it is the Row Selector cell unwanted events
			// are going to be thrown.
			if (this.options.showCheckBoxesOnFocus === true && this._checkBoxesShown === false) {
				this._animateCheckboxes(true);
			}
			if (target.is("span") && target.attr("unselectable")) {
				return;
			}
			if (rKey === "" || rKey === null || rKey === undefined) {
				rKey = rIdx;
			}
			// M.H. 22 Aug 2013 Fix for bug #149786: The row propery of the rowSelectorClicked's args object contains only the fixed row.
			if (this.grid.hasFixedColumns()) {
				if (this.grid._isFixedElement(rCell)) {
					fRow = rRow;
					rRow = this.grid.scrollContainer().find("tbody > tr").eq(rRow.index());
				} else {
					fRow = this.grid.fixedContainer().find("tbody > tr").eq(rRow.index());
				}
			}
			args = {
				row: rRow,
				fixedRow: fRow,
				rowIndex: rIdx,
				rowKey: rKey,
				rowSelector: rCell,
				owner: this,
				grid: this.grid
			};
			this._triggerClickEvent(event, args);
		},
		_mouseHoverRow: function (event, ui) {
			var par, tag, tr = event.target;
			while (tr) {
				par = tr.parentNode;
				tag = tr.nodeName;
				if (tag === "TR" && par.nodeName === "TBODY") {
					break;
				}
				tr = (tag === "TABLE") ? null : par;
			}
			if (this._hovTR !== tr) {
				if (this._hovTR && $(this._hovTR).attr("data-container") !== "true") {
					$("th." + this.css.rowSelector, this._hovTR).removeClass(this.css.nodeHovered);
				}
				if (tr && $(tr).attr("data-container") !== "true") {
					$("th." + this.css.rowSelector, tr).addClass(this.css.nodeHovered);
				}
				this._hovTR = tr;
			}
		},
		_mouseLeaveRow: function (event, ui) {
			if (this._hovTR) {
				$("th", this._hovTR).removeClass(this.css.nodeHovered);
				this._hovTR = null;
			}
		},
		_triggerClickEvent: function (event, args) {
			this._trigger(this.events.rowSelectorClicked, event, args);
		},
		_triggerCheckingEvent: function (event, args) {
			return this._trigger(this.events.checkBoxStateChanging, event, args);
		},
		_triggerCheckedEvent: function (event, args) {
			this._trigger(this.events.checkBoxStateChanged, event, args);
		},
		_getVisibleRowIndex: function (row) {
			return row.closest("tbody")
				.children("tr:not([data-container='true'],[data-grouprow='true'])")
				.index(row);
		},
		_getVisibleHRowIndex: function (row) {
			return row.closest("tbody")
				.children("tr:not([data-container='true'])")
				.index(row);
		},
		_animateCheckboxes: function (trans) {
			var h = this._headerCheckbox(),
				c = this._allCheckboxes(),
				all = h.add(c);
			if (trans === true) {
				all.css("visibility", "visible").css("opacity", 0).animate({ opacity: 1 }, 1000);
			} else {
				all.css("opacity", 1000).animate({ opacity: 0 }, 1000, function () { $(this).css("visibility", "hidden"); });
			}
			this._checkBoxesShown = trans;
		},
		_newRowAdded: function (event, ui) {
			this._unregisterCellEvents();
			this._registerCellEvents();
			if (this.options.enableCheckBoxes === true) {
				this._registerCheckBoxEvents();
			}
		},
		_resetIndexing: function () {
			this._cIdx = 0;
		},
		_groupedColumnsChanging: function (args) {
			// internal event of GroupBy
			// handle index reset events
			this._resetIndexing();
		},
		_cleanInterface: function (isRebind) {
			var header, footer, cols, rsCells, w;
			// the function cleans all or some of the row selectors interface depending on context
			if (isRebind === true) {
				this._alterCheckbox(this._headerCheckbox(), false);
				return;
			}
			cols = this.grid.element.children("colgroup").children("[data-role='rs']");
			cols = cols.add(this.grid.fixedContainer().find("colgroup").children("[data-role='rs']"));
			if (this.grid.options.fixedHeaders === true) {
				cols = cols.add(this.grid.headersTable().children("colgroup").children("[data-role='rs']"));
				cols = cols.add(this.grid.fixedHeadersTable().children("colgroup").children("[data-role='rs']"));
			}
			if (this.grid.options.fixedFooters === true) {
				cols = cols.add(this.grid.footersTable().children("colgroup").children("[data-role='rs']"));
				cols = cols.add(this.grid.fixedFootersTable().children("colgroup").children("[data-role='rs']"));
			}
			footer = this._footerRowSelectorCells();
			header = this._headerRowSelectorCells();
			rsCells = this._allRowSelectorCells();
			if (!this.grid.options.width && this._functionsRedirected) {
				w = this.grid.container().css("width");
				if (w && !w.endsWith("%")) {
					this.grid.container().css("width", parseInt(w, 10) - this.options.rowSelectorColumnWidth);
				}
			}
			cols.remove();
			footer.remove();
			header.remove();
			rsCells.remove();
		},
		_allRowSelectorCells: function () {
			var rowSelectors = this.grid.element.children("tbody").children("tr").children("th." + this.css.rowSelector);
			if (rowSelectors.length === 0 && this.grid.hasFixedColumns()) {
				rowSelectors = this.grid.fixedContainer().find("tbody > tr > th." + this.css.rowSelector);
			}
			return rowSelectors;
		},
		_headerRowSelectorCells: function () {
			var headerCells = this.grid.headersTable().children("thead").find("th[data-role='rs']");
			if (headerCells.length === 0 && this.grid.hasFixedColumns()) {
				headerCells = this.grid.fixedHeadersTable().children("thead").find("th[data-role='rs']");
			}
			return headerCells;
		},
		_footerRowSelectorCells: function () {
			var footerCells = this.grid.footersTable().children("tfoot").find("td[data-role='rs']");
			if (footerCells.length === 0 && this.grid.hasFixedColumns()) {
				footerCells = this.grid.fixedFootersTable().children("tfoot").find("td[data-role='rs']");
			}
			return footerCells;
		},
		_allCheckboxes: function () {
			var checkboxes = this.grid.element.children("tbody").children("tr").children("th").find("span[name='chk']");
			if (checkboxes.length === 0 && this.grid.hasFixedColumns() &&
				this._getColumnFixingInstance().options.fixingDirection === 'left') {
				checkboxes = this.grid.fixedContainer().find("tbody > tr > th span[name='chk']");
			}
			return checkboxes;
		},
		_headerCheckbox: function () {
			var checkbox = this.grid.headersTable().children("thead").find("tr > th span[name='hchk']");
			if (checkbox.length === 0 && this.grid.hasFixedColumns() &&
				this._getColumnFixingInstance().options.fixingDirection === 'left') {
				checkbox = this.grid.fixedHeadersTable().children("thead").find("tr > th span[name='hchk']");
			}
			return checkbox;
		},
		_columnFixed: function (args) {
			var columnFixingInstance = this._getColumnFixingInstance(),
				countFixedCols = args.fixedColsCount;
			if (!columnFixingInstance) {
				return;
			}
			if (columnFixingInstance.options.fixingDirection === "right") {
				return;
			}
			if (!this._renderFixedColgroupHandler) {
				this._renderFixedColgroupHandler = $.proxy(columnFixingInstance._renderFixedColgroup, columnFixingInstance);
				columnFixingInstance._renderFixedColgroup = $.proxy(this._rsRenderFixedColgroup, this);
			}
			// if it is fixed for the first time - initialize handler of renderFixedRecord
			if (!this._isColumnFixingFunctionsRedirected) {
				this._renderFixedRecordHandler = $.proxy(columnFixingInstance._renderFixedRecord, columnFixingInstance);
				this._isColumnFixingFunctionsRedirected = true;
			}
			// override functions
			// when fixing first column override renderFixedRecord
			// renderRecord should be the grid function
			if (args.isFixed) {
				if (args.isInit) {
					this.grid._renderRecord = this._gridRenderRecordHandler;
					columnFixingInstance._renderFixedRecord = $.proxy(this._rsRenderFixedRecord, this);
				}
			} else {
				// when unfixing last column use rowSelector renderRecord overridden function and do not use renderFixedRecord
				if (countFixedCols <= 1 && !this.grid.hasFixedDataSkippedColumns()) {
					this.grid._renderRecord = this._renderRecordHandler;
					columnFixingInstance._renderFixedRecord = this._renderFixedRecordHandler;
				}
			}
		},
		_checkForSelection: function () {
			var i, isSelection = false;
			for (i = 0; i < this.grid.options.features.length; i++) {
				if (this.grid.options.features[i].name === "Selection") {
					isSelection = true;
					if (this.options.enableCheckBoxes === true) {
						this.grid.options.features[i].mode = "row";
					}
					break;
				}
			}
			if (isSelection === false) {
				if (this.options.requireSelection === true) {
					throw new Error($.ig.GridRowSelectors.locale.selectionNotLoaded);
				}
				this._skipRefresh = true;
			}
		},
		_createHandlers: function () {
			this._headerRenderedHandler = $.proxy(this._headerRendered, this);
			this._footerRenderedHandler = $.proxy(this._footerRendered, this);
			this._recordsRenderingHandler = $.proxy(this._recordsRendering, this);
			this._recordsRenderedHandler = $.proxy(this._recordsRendered, this);
			this._gridRenderedHandler = $.proxy(this._gridRendered, this);
			this._cellSelectionChangedHandler = $.proxy(this._cSelectionChanged, this);
			this._rowSelectionChangedHandler = $.proxy(this._rSelectionChanged, this);
			this._clearSelectionHandler = $.proxy(this._clearSelection, this);
			this._virtualDomBuiltHandler = $.proxy(this._rsRenderVirtualRecords, this);
			this._virtualRowsHandler = $.proxy(this._rrn, this);
			this._renderExtraHeaderCellHandler = $.proxy(this._renderExtraHeaderCells, this);
			this._renderExtraFooterCellHandler = $.proxy(this._renderExtraFooterCells, this);
			this._rsClickHandler = $.proxy(this._cellClick, this);
			this._rrHoverHandler = $.proxy(this._mouseHoverRow, this);
			this._rrLeaveHandler = $.proxy(this._mouseLeaveRow, this);
			this._newRowAddedHandler = $.proxy(this._newRowAdded, this);
			if (this.options.enableCheckBoxes === true) {
				this._checkboxMouseOverHandler = $.proxy(this._checkboxMouseOver, this);
				this._checkboxMouseOutHandler = $.proxy(this._checkboxMouseOut, this);
				this._checkboxClickHandler = $.proxy(this._checkBoxClicked, this);
				this._hCheckboxClickHandler = $.proxy(this._headerCheckBoxClicked, this);
			}
		},
		_registerEvents: function () {
			// these handle rendering of non-virtual grids
			this.grid.element.bind("iggridheaderrendered", this._headerRenderedHandler);
			this.grid.element.bind("iggridfooterrendered", this._footerRenderedHandler);
			this.grid.element.bind("iggrid_rowsrendering", this._recordsRenderingHandler);
			this.grid.element.bind("iggridrowsrendered", this._recordsRenderedHandler);
			this.grid.element.bind("iggriddatarendered", this._gridRenderedHandler);
			// these handle rendering of virtual grid
			this.grid.element.bind("iggridvirtualdombuilt", this._virtualDomBuiltHandler);
			this.grid.element.bind("iggridvirtualrecordsrender", this._virtualRowsHandler);
			// these handle changing of row selectors selection state
			this.grid.element.bind("iggridselectioncellselectionchanged", this._cellSelectionChangedHandler);
			this.grid.element.bind("iggridselectionrowselectionchanged", this._rowSelectionChangedHandler);
			this.grid.element.bind("iggridselectioninternalrowselectionchanged", this._rowSelectionChangedHandler);
			this.grid.element.bind('iggridselectioninternalcellselectionchanged', this._cellSelectionChangedHandler);
			this.grid.element.bind("iggridselectionselectioncleared", this._clearSelectionHandler);
			// this handles new row updating row selector generation
			this.grid.element.bind("iggridupdatingrowadded", this._newRowAddedHandler);
			this.grid.element.bind("iggridupdatinginternalrowadded", this._newRowAddedHandler);
			this.grid.element.bind("iggridloadondemandrowsrequested", this._newRowAddedHandler);
		},
		_unregisterEvents: function () {
			this.grid.element.unbind("iggridheaderrendered", this._headerRenderedHandler);
			this.grid.element.unbind("iggridfooterrendered", this._footerRenderedHandler);
			this.grid.element.unbind("iggrid_rowsrendering", this._recordsRenderingHandler);
			this.grid.element.unbind("iggridrowsrendered", this._recordsRenderedHandler);
			this.grid.element.unbind("iggriddatarendered", this._gridRenderedHandler);
			this.grid.element.unbind("iggridvirtualdombuilt", this._virtualDomBuiltHandler);
			this.grid.element.unbind("iggridvirtualrecordsrender", this._virtualRowsHandler);
			this.grid.element.unbind("iggridselectioncellselectionchanged", this._cellSelectionChangedHandler);
			this.grid.element.unbind("iggridselectionrowselectionchanged", this._rowSelectionChangedHandler);
			this.grid.element.unbind("iggridselectioninternalrowselectionchanged", this._rowSelectionChangedHandler);
			this.grid.element.unbind('iggridselectioninternalcellselectionchanged', this._cellSelectionChangedHandler);
			this.grid.element.unbind("iggridselectioncleared", this._clearSelectionHandler);
			this.grid.element.unbind("iggridupdatingrowadded", this._newRowAddedHandler);
			this.grid.element.unbind("iggridupdatinginternalrowadded", this._newRowAddedHandler);
			this.grid.element.unbind("iggridloadondemandrowsrequested", this._newRowAddedHandler);
		},
		_injectGrid: function (gridInstance, isRebind) {
			if (isRebind === true) {
				this._cleanInterface(true);
				return;
			}
			var self = this;
			this.grid = gridInstance;
			this._v = this.grid.options.virtualization === true || this.grid.options.rowVirtualization === true;
			this._flatRenderColgroup = this.grid._renderColgroup;
			this._createHandlers();
			// adds cells rendering logic for other features
			this.grid._headerInitCallbacks.push({ type: "RowSelectors", func: this._renderExtraHeaderCellHandler });
			this.grid._footerInitCallbacks.push({ type: "RowSelectors", func: this._renderExtraFooterCellHandler });
			this._registerEvents();
			// register for colgroup creation
			this.grid._renderColgroup = function () {
				if (self._flatRenderColgroup !== undefined) {
					self._rsRenderColgroup.apply(self.grid, $.merge([self._flatRenderColgroup, self], arguments));
				}
			};
			this._checkForSelection();
		}
	});
	$.extend($.ui.igGridRowSelectors, { version: "14.1.20141.2249" });
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid Selection (and Keyboard navigation) 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 *	modernizr.js
 */
/*global jQuery, Modernizr*/
if (typeof jQuery !== 'function') {
	throw new Error("jQuery is undefined");
}

(function ($) {
	/* Grid selection jQuery UI widget */
	$.widget("ui.igGridSelection", {
		css: {
			/* classes applied to a cell once it's selected */
			selectedCell: "ui-iggrid-selectedcell ui-state-active",
			/* classes applied to a row once it's selected */
			selectedRow: "ui-iggrid-selectedrow ui-state-active",
			//selectedHeader: "ui-iggrid-selectedheader ui-state-active", // for columns
			/* classes applied to the currently active cell, if any (mode = "cell") */
			activeCell: "ui-iggrid-activecell ui-state-focus",
			/* classes applied to the currently active row, if any (mode = "row") */
			activeRow: "ui-iggrid-activerow ui-state-focus"
		},
		options: {
			/* type="bool" Enables / Disables multiple selection of cells and rows - depending on the mode */
			multipleSelection: false,
			/* type="bool" Enables / disables selection via dragging with the mouse - only applicable for cell selection */
			mouseDragSelect: true,
			/* type="row|cell" Defines type of the selection.
            row type="string" Defines row selection mode.
            cell type="string" Defines cell selection mode.
            */
			mode: 'row',
			/* type="bool" Enables / disables activation of rows and cells. Activation implies ability to perform navigating through cells and rows via the keyboard, and selecting rows and cells using CTRL / SHIFT - in the way cells/rows are selected in Ms Excel */
			activation: true,
			/* type="bool" if wrapAround is enabled and selection is on the first or last row or cell, then when the end user tries to go beyond that, the first/last row or cell will be selected */
			wrapAround: true,
			/* if true will basically skip going into child grids with down / up / right / left arrow keys, when in the context of hierarchical grid */
			skipChildren: true,
			/* type="bool" if true multiple selection of cells is done as if CTRL is being held. the option is disregarded if mode is set
			to row. this option is useful for enabling multiple discountinued selection on touch environments. */
			multipleCellSelectOnClick: false,
			/* type="bool" Enables / disables selection via continuous touch event - only applicable for cell selection and
			touch-supported environments */
			touchDragSelect: true,
			/* type="bool" Enables / disables selection persistance between states. */
			persist: true
		},
		events: {
			/* cancel="true" Event fired before row(s) are about to be selected (cancellable).
			Return false in order to cancel selection changing.			
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridSelection.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.row.element to get reference to row DOM element.
			Use ui.row.index to get row index.
			Use ui.selectedRows to get reference to rows object array.
            Use ui.selectedFixedRows to get reference to fixed rows object array if any.
			ui.manual - returns true if internal trigger.
			*/
			rowSelectionChanging: "rowSelectionChanging",
			/* Event fired after row(s) are selected.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridSelection.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.row.element to get reference to row DOM element.
			Use ui.row.index to get row index.
			Use ui.selectedRows to get reference to rows object array.
            Use ui.selectedFixedRows to get reference to fixed rows object array if any.
			ui.manual - returns true if internal trigger.
			*/
			rowSelectionChanged: "rowSelectionChanged",
			/* cancel="true" Event fired before cell(s) are about to be selected (cancellable).
			Return false in order to cancel cell selection changing.			
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridSelection.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.cell.element to get reference to cell DOM element.
			Use ui.cell.columnKey to get reference to column key.
			Use ui.cell.index to get column index.
			Use ui.cell.row to get reference to row DOM element.
			Use ui.cell.rowIndex to get row index.
			Use ui.selectedCells to get reference to selected cells object array.
			ui.manual - returns true if internal trigger.
			*/
			cellSelectionChanging: "cellSelectionChanging",
			/* cancel="true" Event fired after cell(s) are selected.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridSelection.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.cell.element to get reference to cell DOM element.
			Use ui.cell.columnKey to get reference to column key.
			Use ui.cell.index to get column index.
			Use ui.cell.row to get reference to row DOM element.
			Use ui.cell.rowIndex to get row index.
			Use ui.selectedCells to get reference to selected cells object array.
			ui.manual - returns true if internal trigger.
			*/
			cellSelectionChanged: "cellSelectionChanged",
			/* cancel="true" Event fired before a cell becomes active (focus style applied) (cancellable).
			Return false in order to cancel active cell changing.	
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridSelection.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.cell.element to get reference to cell DOM element.
			Use ui.cell.columnKey to get column key.
			Use ui.cell.index to get column index.
			Use ui.cell.row to get reference to row DOM element.
			Use ui.cell.rowIndex to get row index.
			*/
			activeCellChanging: "activeCellChanging",
			/* Event fired after a cell becomes active (focus style applied).
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridSelection.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.cell.element to get reference to cell DOM element.
			Use ui.cell.columnKey to get column key.
			Use ui.cell.index to get column index.
			Use ui.cell.row to get reference to row DOM element.
			Use ui.cell.rowIndex to get row index.
			*/
			activeCellChanged: "activeCellChanged",
			/* cancel="true" Event fired before a row becomes active (focus style applied) (cancellable).
			Return false in order to cancel active row changing.			
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridSelection.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.row.element to get reference to active row DOM element.
			Use ui.row.index to get active row index.
			*/
			activeRowChanging: "activeRowChanging",
			/* Event fired after a row becomes active (focus style applied). 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridSelection.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.row.element to get reference to active row DOM element.
			Use ui.row.index to get row index.
			*/
			activeRowChanged: "activeRowChanged"
		},
		_create: function () {
			this._isMouseDown = false;
			this._isDrag = false;
			this._registeredEvents = false;
			this.y_exclude_current = 0;
			this.x_exclude_current = 0;
		},
		_setOption: function (key, value) {
			// handle new settings and update options hash
			$.Widget.prototype._setOption.apply(this, arguments);
			// throw an error for the options that cannot be changed after the widget has been created
			if (key === 'mode') {
				throw new Error($.ig.Grid.locale.optionChangeNotSupported + ' ' + key);
			}
		},
		// M.H. 4 Dec 2013 Fix for bug #158542: Memory Leak in IE8 when calling dataBind
		_dataRendering: function (e, args) {
			var tbody;
			if (args.owner.id() !== this.grid.id()) {
				return;
			}
			tbody = this.grid.element.find('tbody');
			if (this._mouseDownHandler) {
				tbody.unbind({
					mousedown: this._mouseDownHandler,
					mousemove: this._mouseMoveHandler,
					mouseup: this._mouseUpHandler,
					selectstart: this._selectStartHandler
				});
				if (this._touchEvents) {
					tbody.unbind({
						touchstart: this._touchStartHandler,
						touchend: this._touchEndHandler,
						MSPointerDown: this._touchStartHandler,
						MSPointerMove: this._touchMoveHandler,
						MSPointerUp: this._touchEndHandler,
						pointerdown: this._touchStartHandler,
						pointermove: this._touchMoveHandler,
						pointerup: this._touchEndHandler
					});
					tbody[0].removeEventListener("touchmove", this._touchMoveHandler);
				}
			}
			if (this.options.persist && !this.grid.options.primaryKey) {
				// add checksum code for each record in the data source
				this._createUidForData();
			}
			this._buildSelectionCache();
		},
		_hidingFinishing: function () {
			this._buildSelectionCache();
		},
		_dataRendered: function () {
			if (!this._registeredEvents) {
				this._registerEvents();
				this._registeredEvents = true;
			} else {
				this._registerTbodyEvents();
			}
			if (this._hc === undefined) {
				this._hc = this.grid.container().closest('.ui-iggrid-root').length > 0;
				if (this._hc === false) {
					this._hc = this.grid.element.hasClass('ui-iggrid-root');
				}
			}
			if (this._hc) {
				this._hgrid = this.grid.element.closest(".ui-iggrid-root");
			}
			if (this._groupBy === undefined) {
				this._groupBy = this.grid.container().find('.ui-iggrid-groupbyarea').length > 0;
			}
			this._refresh(true);
			// if selectedRowIndex and selectedCellIndex are defined, select them (initial programmatic selection)
			if (!this._initialSelectionInitialized) {
				if (this.options.selectedRowIndex !== undefined && this.options.selectedRowIndex !== null && this.options.selectedRowIndex >= 0) {
					if (this.options.selectedCellIndex === undefined) {
						this.selectRow(this.options.selectedRowIndex);
					} else if (this.options.selectedCellIndex !== undefined && this.options.selectedRowIndex !== null && this.options.selectedCellIndex >= 0) {
						this.selectCell(this.options.selectedRowIndex, this.options.selectedCellIndex);
					}
				}
				this._initialSelectionInitialized = true;
			}
			// VS 04/18/2012. Bug 109531
			this.grid._startRowIndex = this.grid._startRowIndex || 0;
			// reapply active cell/row
			if (this.options.persist) {
				this._reapplySelectionParams();
			}
		},
		_hidingFinished: function () {
			if (this.options.persist) {
				this._reapplySelectionParams();
			}
		},
		_virtRowCountDetermined: function (count) {
			this._buildSelectionCache();
		},
		_refresh: function (init) {
			if (!init || !(this._firstCell && this._firstCell.length !== 0)) {
				this._firstCell = this.grid.element.children('tbody').children('tr:visible:nth-child(1) td:nth-child(1)');
				if (!this._firstCell) {
					this._firstRow = this.grid.element.children('tbody').children('tr:visible:nth-child(1)');
				}
			}
			if (!init || !(this._firstRow && this._firstRow.length !== 0) || !this._rowCount) {
				this._firstRow = this.grid.element.children('tbody').children('tr:visible:nth-child(1)');
				if (this.grid.options.virtualization || this.grid.options.rowVirtualization) {
					this._rowCount = this.grid.dataSource.dataView().length;
				} else {
					this._rowCount = this.grid.element.find('tbody tr').length;
				}
				this._length = this._firstRow ? this._firstRow.children().length : 0;
			}
			this.x_exclude_current = this._calcExtraCells();
		},
		_registerTbodyEvents: function () {
			var tbody = this.grid.element.find('tbody'), opts = this.options;
			if (!this._mouseDownHandler) {
				this._mouseDownHandler = $.proxy(this._mouseDown, this);
				this._selectStartHandler = $.proxy(this._selectStart, this);
				this._mouseMoveHandler = $.proxy(this._dragSelectChange, this);
				this._mouseUpHandler = $.proxy(this._selectInternal, this);
				// we'll add a few more events if we are on a touch device and touch drag select is enabled
				// otherwise mousedown and mouseup events should be enough to handle normal click/tap selection
				if (((typeof Modernizr === "object" && Modernizr.touch === true) ||
					(window.navigator.msPointerEnabled || window.navigator.pointerEnabled)) &&
					opts.multipleSelection === true && opts.mode === "cell" && opts.touchDragSelect === true) {
					this._touchStartHandler = $.proxy(this._touchStart, this);
					this._touchEndHandler = $.proxy(this._touchEnd, this);
					this._touchMoveHandler = $.proxy(this._touchMove, this);
					this._touchEvents = true;
				}
			} else {
				tbody.unbind({
					mousedown: this._mouseDownHandler,
					mousemove: this._mouseMoveHandler,
					mouseup: this._mouseUpHandler,
					selectstart: this._selectStartHandler
				});
				if (this._touchEvents) {
					tbody.unbind({
						touchstart: this._touchStartHandler,
						touchend: this._touchEndHandler,
						MSPointerDown: this._touchStartHandler,
						MSPointerMove: this._touchMoveHandler,
						MSPointerUp: this._touchEndHandler,
						pointerdown: this._touchStartHandler,
						pointermove: this._touchMoveHandler,
						pointerup: this._touchEndHandler
					});
					tbody[0].removeEventListener("touchmove", this._touchMoveHandler);
				}
			}
			tbody.bind({
				mousedown: this._mouseDownHandler,
				mousemove: this._mouseMoveHandler,
				mouseup: this._mouseUpHandler,
				selectstart: this._selectStartHandler
			});
			if (this._touchEvents) {
				tbody.bind({
					touchstart: this._touchStartHandler,
					touchend: this._touchEndHandler,
					MSPointerDown: this._touchStartHandler,
					MSPointerMove: this._touchMoveHandler,
					MSPointerUp: this._touchEndHandler,
					pointerdown: this._touchStartHandler,
					pointermove: this._touchMoveHandler,
					pointerup: this._touchEndHandler
				});
				// jQuery has issues with touchmove so we need to bind to it in js way to ensure
				// it's going to be handled properly across the different devices
				tbody[0].addEventListener("touchmove", this._touchMoveHandler);
			}
		},
		_registerFixedTbodyEvents: function () {
			var tbody = this.grid.fixedContainer().find('tbody'), opts = this.options;
			if (!this._mouseDownFixedHandler) {
				this._mouseDownFixedHandler = $.proxy(this._mouseDown, this);
				this._selectStartFixedHandler = $.proxy(this._selectStart, this);
				this._mouseMoveFixedHandler = $.proxy(this._dragSelectChange, this);
				this._mouseUpFixedHandler = $.proxy(this._selectInternal, this);
				if (((typeof Modernizr === "object" && Modernizr.touch === true) ||
					(window.navigator.msPointerEnabled || window.navigator.pointerEnabled)) &&
					opts.multipleSelection === true && opts.mode === "cell" && opts.touchDragSelect === true) {
					this._touchStartFixedHandler = $.proxy(this._touchStart, this);
					this._touchEndFixedHandler = $.proxy(this._touchEnd, this);
					this._touchMoveFixedHandler = $.proxy(this._touchMove, this);
					this._touchEvents = true;
				}
			} else {
				tbody.unbind({
					mousedown: this._mouseDownFixedHandler,
					mousemove: this._mouseMoveFixedHandler,
					mouseup: this._mouseUpFixedHandler,
					selectstart: this._selectStartFixedHandler
				});
				if (this._touchEvents) {
					tbody.unbind({
						touchstart: this._touchStartFixedHandler,
						touchend: this._touchEndFixedHandler,
						MSPointerDown: this._touchStartFixedHandler,
						MSPointerMove: this._touchMoveFixedHandler,
						MSPointerUp: this._touchEndFixedHandler,
						pointerdown: this._touchStartHandler,
						pointermove: this._touchMoveHandler,
						pointerup: this._touchEndHandler
					});
					tbody[0].removeEventListener("touchmove", this._touchMoveFixedHandler);
				}
			}
			tbody.bind({
				mousedown: this._mouseDownFixedHandler,
				mousemove: this._mouseMoveFixedHandler,
				mouseup: this._mouseUpFixedHandler,
				selectstart: this._selectStartFixedHandler
			});
			if (this._touchEvents) {
				tbody.bind({
					touchstart: this._touchStartFixedHandler,
					touchend: this._touchEndFixedHandler,
					MSPointerDown: this._touchStartFixedHandler,
					MSPointerMove: this._touchMoveFixedHandler,
					MSPointerUp: this._touchEndFixedHandler,
					pointerdown: this._touchStartHandler,
					pointermove: this._touchMoveHandler,
					pointerup: this._touchEndHandler
				});
				tbody[0].addEventListener("touchmove", this._touchMoveFixedHandler);
			}
		},
		_registerEvents: function () {
			this._registerTbodyEvents();
			// M.H. 29 Oct 2012 Fix for bug #120642
			if (this._releaseMouseHandler === null || this._releaseMouseHandler === undefined) {
				this._releaseMouseHandler = $.proxy(this._releaseMouse, this);
			}
			$(document).bind({
				mouseup: this._releaseMouseHandler
			});
			if (this.grid.options.virtualization) {
				$('#' + this.grid.element[0].id + '_scrollContainer').bind({
					scroll: $.proxy(this._releaseMouse, this)
				});
			} else {
				$('#' + this.grid.element[0].id + '_scroll').bind({
					scroll: $.proxy(this._releaseMouse, this)
				});
			}
			this._keyDownHandler = $.proxy(this._navigate, this);
			this._focusHandler = $.proxy(this._navigateFocus, this);
			this._markMouseDownHandler = $.proxy(this._markMouseDown, this);
			if (this.grid.options.virtualization || this.grid.options.rowVirtualization) {
				$('#' + this.grid.element[0].id + '_displayContainer_a').bind({
					keydown: this._keyDownHandler,
					focus: this._focusHandler
					//	mousedown: this._markMouseDownHandler
				});
			} else {
				this.grid.container().bind({
					keydown: this._keyDownHandler,
					focus: this._focusHandler
					//	mousedown: this._markMouseDownHandler
				});
			}
			if (this.options.multipleSelection === true) {
				this.grid.element.addClass('ui-iggrid-canceltextselection');
			}
		},
		_unregisterEvents: function () {
			// M.H. 29 Oct 2012 Fix for bug #120642
			var tbody = this.grid.element.find('tbody');

			this.grid.element.unbind('mousedown', this._mouseDownHandler);
			this.grid.element.unbind('selectstart', this._selectStartHandler);
			this.grid.element.unbind('mousemove', this._mouseMoveHandler);
			this.grid.element.unbind('mouseup', this._mouseUpHandler);
			// M.H. 29 Oct 2012 Fix for bug #120642
			this.grid.container().unbind('keydown', this._keyDownHandler);
			this.grid.container().unbind('focus', this._focusHandler);
			this.grid.container().unbind('mousedown', this._markMouseDownHandler);
			this.grid.element.unbind('iggriduisoftdirty', this._uiDirtyHandler);
			this.grid.element.unbind('ighierarchicalgridrowexpanded', this._rowExpandedHandler);
			this.grid.element.unbind('iggridcolumnscollectionmodified', this._columnsCollectionModifiedHandler);
			// M.H. 29 Oct 2012 Fix for bug #120642
			this.grid.element.unbind('iggridvirtualrecordsrender', this._virtualRecordsRendererHandler);
			tbody.unbind({
				mousedown: this._mouseDownHandler,
				mousemove: this._mouseMoveHandler,
				mouseup: this._mouseUpHandler,
				selectstart: this._selectStartHandler
			});
			if (this._touchEvents) {
				tbody.unbind({
					touchstart: this._touchStartHandler,
					touchend: this._touchEndHandler,
					MSPointerDown: this._touchStartHandler,
					MSPointerMove: this._touchMoveHandler,
					MSPointerUp: this._touchEndHandler,
					pointerdown: this._touchStartHandler,
					pointermove: this._touchMoveHandler,
					pointerup: this._touchEndHandler
				});
				tbody[0].removeEventListener("touchmove", this._touchMoveHandler);
			}
			if (this._releaseMouseHandler) {
				$(document).unbind({
					mouseup: this._releaseMouseHandler
				});
				delete this._releaseMouseHandler;
			}
			//this.grid.element.unbind('iggriduidirty', this._uiDirtyHandler);
			delete this._mouseDownHandler;
			delete this._selectStartHandler;
			delete this._mouseMoveHandler;
			delete this._mouseUpHandler;
			delete this._keyDownHandler;
			delete this._focusHandler;
			delete this._markMouseDownHandler;
			delete this._uiDirtyHandler;
			delete this._rowExpandedHandler;
			delete this._columnsCollectionModifiedHandler;
			delete this._virtualRecordsRendererHandler;
			delete this._touchEvents;
			this.grid.element.removeClass('ui-iggrid-canceltextselection');
		},
		_dragSelectChange: function (event) {
			var selectedCells = [], startRowIndex, startColIndex, endRowIndex, endColIndex, outgrid,
				currentCell, tmp, noCancel = true, v = this.grid.options.virtualization || this.grid.options.rowVirtualization;
			if (event && this._suspend) {
				return;
			}
			if (!this._prevX && !this._prevY) {
				this._prevX = event.clientX;
				this._prevY = event.clientY;
			}
			//A.T. 24 Nov 2011 - Fix for bug #80811 Multiple cell selection by click + holding Shift/ Ctrl not working in IE when virtualization = true
			// we need to ensure that we don't consider this a dragging operation, for some reason when virtualization
			// is enabled, in IE, mouse move is triggered with a few pixels diff 
			if (Math.abs(this._prevX - event.clientX) < 5 && Math.abs(this._prevY - event.clientY) < 5) {
				return;
			}
			this._prevX = event.clientX;
			this._prevY = event.clientY;
			if (this.options.mouseDragSelect === false || this.options.multipleSelection === false || this.options.mode === 'row') {
				return;
			}
			if (this._isMouseDown === true) {
				this._isDrag = true;
			} else {
				return;
			}
			// check if dragging
			if (this._isMouseDown !== true || this.options.mode !== 'cell') {
				return;
			}
			// if we are in an hierarchical grid check that we aren't trying to drag over other grids (in expanded rows)
			//A.T. fix for bug #92299
			if (this._hc && event && event.target) {
				outgrid = $(event.target).closest(".ui-iggrid-table");
				if (outgrid.length > 0 && outgrid.attr('id') !== this.grid.element.attr('id')) {
					event.stopPropagation();
					event.preventDefault();
					return;
				}
			}
			currentCell = this._cellFromEvent(event);
			if (!currentCell) {
				return;
			}
			if (currentCell && this.activeCell() && currentCell.index === this.activeCell().index && currentCell.rowIndex === this.activeCell().rowIndex) {
				return;
			}
			if (this._touchEvents && !(window.navigator.msPointerEnabled || window.navigator.pointerEnabled)) {
				event = { originalEvent: event };
			}
			noCancel = this._trigger(this.events.cellSelectionChanging, event, { cell: currentCell, selectedCells: this.grid._selectedCells, owner: this, manual: false });
			if (noCancel) {
				// activate the cell
				if (this.options.activation === true) {
					this._activateCell(currentCell, event);
				}
				startRowIndex = this._firstDragCell.rowIndex;
				startColIndex = this._firstDragCell.index + this._firstDragCell.element.parent().children("[data-skip=true]").length;
				endRowIndex = currentCell.rowIndex;
				endColIndex = currentCell.index + this._firstDragCell.element.parent().children("[data-skip=true]").length;

				if (endRowIndex < startRowIndex) {
					tmp = startRowIndex;
					startRowIndex = endRowIndex;
					endRowIndex = tmp;
				}
				if (currentCell.isFixed === this._firstDragCell.isFixed && endColIndex < startColIndex) {
					tmp = startColIndex;
					startColIndex = endColIndex;
					endColIndex = tmp;
				}
				if (currentCell.isFixed !== this._firstDragCell.isFixed && (this._lastSelectedIndex === undefined || this._lastSelectedIndex === null)) {
					if (currentCell.isFixed === true) {
						this._lastSelectedIndex = this.grid._selectedCells[this.grid._selectedCells.length - 1].index;
					} else {
						this._lastSelectedIndex = endColIndex;
					}
				}

				// A.T. Fix for bug #73402
				// A.T. should call clear selection here
				this.clearSelection(true);
				/*
				for (i = 0; i < this.grid._selectedCells.length; i++) {
					this.grid._selectedCells[i].element.removeClass(this.css.selectedCell);
				}
				this.grid._selectedCells = [];
				*/
				if (v) {
					startRowIndex -= this.grid._startRowIndex;
					endRowIndex -= this.grid._startRowIndex;
				}
				//                if (currentCell.isFixed !== this._firstDragCell.isFixed) {
				//                    if (currentCell.isFixed === true) {
				//                        var tmpSRIndex, tmpERIndex, tmpSCIndex, tmpECIndex;

				//                        tmpECIndex = this._lastSelectedIndex + this._firstDragCell.element.parent().children("[data-skip=true]").length;
				//                        if (tmpECIndex > startColIndex) {
				//                            this._selectCell(startRowIndex, endRowIndex, startColIndex, tmpECIndex, false);
				//                        } else {
				//                            this._selectCell(startRowIndex, endRowIndex, tmpECIndex, startColIndex, false);
				//                        }
				//                        this._selectCell(startRowIndex, endRowIndex, 0, endColIndex, true);
				//                    } else {
				//                        tmpECIndex = this._lastSelectedIndex + this._firstDragCell.element.parent().children("[data-skip=true]").length;
				//                        this._selectCell(startRowIndex, endRowIndex, 0, startColIndex, true);
				//                        if (tmpECIndex > endColIndex) {
				//                            this._selectCell(startRowIndex, endRowIndex, endColIndex, tmpECIndex, false);
				//                        } else {
				//                            this._selectCell(startRowIndex, endRowIndex, tmpECIndex, endColIndex, false);
				//                        }
				//                    }
				//                } else {
				this._selectCell(startRowIndex, endRowIndex, startColIndex, endColIndex, currentCell.isFixed);

				// fire Selection Changed 
				this._currentCells = selectedCells;
				this._trigger(this.events.cellSelectionChanged, event, { cell: currentCell, selectedCells: this.grid._selectedCells, owner: this, manual: false });
			}
		},
		// touch events wrapping some touch specific functionality 
		// that otherwise is not needed when handling inferred mouse events
		_touchStart: function (event) {
			// handles both mspointer and touch events
			event.clientX = event.originalEvent.touches ? event.originalEvent.touches[0].pageX : event.originalEvent.clientX;
			event.clientY = event.originalEvent.touches ? event.originalEvent.touches[0].pageY : event.originalEvent.clientY;
			// we'll only start touch drag select if we are starting the drag gesture from an already selected cell
			if (this._cellFromEvent(event).element.hasClass(this.css.selectedCell)) {
				this.grid.element.css("-ms-touch-action", "none");
				this._touchDragStart = true;
			}
		},
		_touchEnd: function (event) {
			// clean touch drag select flags
			if (this._touchDragStart) {
				this._isMouseDown = false;
			}
			this._touchDragStart = false;
			this._isDrag = false;
			this.grid.element.find("tbody").css("-ms-touch-action", "auto");
		},
		_touchMove: function (event) {
			// if touch drag select requirements are not met we'll let the browser execute default behavior
			if (!this._touchDragStart) {
				return true;
			}
			// otherwise we'll prevent that
			event.preventDefault();
			// ensure we can get the correct cell later
			event.clientX = event.touches ? event.touches[0].pageX : event.originalEvent.clientX;
			event.clientY = event.touches ? event.touches[0].pageY : event.originalEvent.clientY;
			// set some internals
			this._touchDragStart = true;
			this._isMouseDown = true;
			// and call the default move handler
			this._dragSelectChange(event);
		},
		_selectCell: function (startRowIndex, endRowIndex, startColIndex, endColIndex, isFixed) {
			var i, j, cell;
			for (i = startRowIndex; i <= endRowIndex; i++) {
				for (j = startColIndex; j <= endColIndex; j++) {
					// M.H. 6 Mar 2013 Fix for bug #134554: Selection's keyboard navigation doesn't work in fixed columns.
					cell = $(this.grid.cellAt(j, i, isFixed)).addClass(this.css.selectedCell);
					this.grid._selectedCells.push(this._cellFromElement(cell, i + this.grid._startRowIndex, j, isFixed));
				}
			}
		},
		// cell style restoration
		_applyCellStyle: function (data, col) {
			var sc;
			if (!this._scc) {
				return "";
			}
			return this._isCellSelectedByKey(data[this.grid.options.primaryKey || "ig_pk"], col, this._scc) ? this.css.selectedCell : "";
		},
		_applyRowStyle: function (data, col, isFixed) {
			var sr, pk = this.grid.options.primaryKey || "ig_pk", cache = isFixed ? this._srcf : this._src;
			if (!cache) {
				return "";
			}
			if (this._procRecord && this._procRecord.key === data[pk]) {
				return this._procRecord.selected ? this.css.selectedCell : "";
			}
			this._procRecord = {
				key: data[pk],
				selected: this._isRowSelectedByKey(data[pk], cache)
			};
			return this._procRecord.selected ? this.css.selectedCell : "";
		},
		_cellFromEvent: function (event) {
			var target, $target, isFixed = false;
			if (this._touchEvents === true) {
				$target = $(document.elementFromPoint(event.clientX, event.clientY));
			} else {
				$target = $(event.originalEvent.originalTarget || event.originalEvent.srcElement);
			}
			target = $target.is('td,th') ? $target[0] : $target.closest('td,th')[0];
			if (this.grid.hasFixedColumns()) {
				isFixed = ($target.closest('div').attr('data-fixed-container') !== undefined);
			}

			return this._cellFromElement(target, undefined, undefined, isFixed);
		},
		_cellFromElement: function (e, row, col, isFixed) {
			var $target, parent, parentIndex, cellIndex, key = null, tmpIndex, res;

			if (isFixed === null || isFixed === undefined) {
				isFixed = false;
			}
			$target = $(e);
			parent = $target.parent();
			if (row === undefined || col === undefined) {
				cellIndex = $target.index();
				parentIndex = parent.index();
				// virtualization fix
				if (this.grid.options.virtualization || this.grid.options.rowVirtualization || this.grid.options.columnVirtualization) {
					if (this.grid._startRowIndex > 0) {
						parentIndex += this.grid._startRowIndex;
					}
					if (this.grid._startColIndex > 0) {
						cellIndex += this.grid._startColIndex;
					}
				}
			} else {
				cellIndex = col;
				parentIndex = row;
			}
			if (cellIndex === -1) {
				return;
			}
			if (cellIndex - this.x_exclude_current < 0) {
				tmpIndex = 0;
			} else if (cellIndex - this.x_exclude_current >= this.grid._visibleColumns().length) {
				tmpIndex = this.grid._visibleColumns().length - 1;
			} else {
				tmpIndex = cellIndex - this.x_exclude_current;
			}
			tmpIndex -= $target.siblings("th,td.ui-iggrid-expandcolumn").length;
			if (tmpIndex >= 0 && this.grid._visibleColumns().length > tmpIndex) {
				key = this.grid._visibleColumns()[tmpIndex].key;
			}
			if (this.y_exclude_current !== undefined) {
				parentIndex -= this.y_exclude_current;
			}
			if (this.x_exclude_current !== undefined) {
				cellIndex -= this.x_exclude_current;
			}
			// M.H. 6 Jun 2013 Fix for bug #143606: When you fix columns, select a cell from the unfixed area and you call activeCell method the object has the wrong columnKey.
			if (this.grid.hasFixedColumns() && $target.is('td')) {
				res = this.grid._getColumnByTD($target);
				if (res !== null) {
					key = res.column.key;
				}
			}
			return { element: $target, row: parent, rowId: this.grid._fixPKValue(parent.attr("data-id")), index: cellIndex, rowIndex: parentIndex, columnKey: key, isFixed: isFixed };
		},
		_reapplySelectionParams: function () {
			var ac, ar, self = this, newElement, newRow, newFixedRow, ni, nuid;
			ac = this.grid._activeCell;
			ar = this.grid._activeRow;
			if (ac) {
				newElement = this._cellFromElement(this.grid.cellById(ac.rowId, ac.columnKey));
				if (newElement && newElement.element instanceof jQuery) {
					this._activateCell(newElement);
				}
			}
			if (ar) {
				newElement = this.grid.rowById(ar.id);
				if (newElement && newElement.length > 0) {
					nidx = newElement.index();
					nuid = newElement.data() ? newElement.data().id : null;
					newRow = {
						element: newElement,
						index: nidx,
						id: nuid
					};
					if (this.grid.hasFixedColumns()) {
						newFixedRow = $.extend({}, newRow, { element: this.grid.fixedBodyContainer().find("tbody tr:nth-child(" + (nidx + 1) + ")") });
					}
					this._activateRow(newRow, null, newFixedRow);
				}
			}
			setTimeout(function () {
				var i = 0, element;
				if (self.grid._selectedRows) {
					for (i = 0; i < self.grid._selectedRows.length; i++) {
						self.grid._selectedRows[i].element = self.grid.rowById(self.grid._selectedRows[i].id);
						if (self.grid._selectedRows[i].element && self.grid._selectedRows[i].element.length > 0) {
							self.grid._selectedRows[i].index = self.grid._selectedRows[i].element.index();
						}
					}
				}
				if (self.grid._selectedRow) {
					self.grid._selectedRow.element = self.grid.rowById(self.grid._selectedRow.id);
					if (self.grid._selectedRow.element && self.grid._selectedRow.element.length > 0) {
						self.grid._selectedRow.index = self.grid._selectedRow.element.index();
					}
				}
				if (self.grid._selectedCells) {
					for (i = 0; i < self.grid._selectedCells.length; i++) {
						self.grid._selectedCells[i].element = self.grid.cellById(self.grid._selectedCells[i].rowId, self.grid._selectedCells[i].columnKey);
						if (self.grid._selectedCells[i].element && self.grid._selectedCells[i].element.length > 0) {
							self.grid._selectedCells[i].row = self.grid._selectedCells[i].element.parent("tr");
							self.grid._selectedCells[i].rowIndex = self.grid._selectedCells[i].row.index();
						}
					}
				}
				if (self.grid._selectedCell) {
					self.grid._selectedCell.element = self.grid.cellById(self.grid._selectedCell.rowId, self.grid._selectedCell.columnKey);
					if (self.grid._selectedCell.element && self.grid._selectedCell.element.length > 0) {
						self.grid._selectedCell.row = self.grid._selectedCell.element.parent("tr");
						self.grid._selectedCell.rowIndex = self.grid._selectedCell.row.index();
					}
				}
				if (self.grid._selectedFixedRows) {
					for (i = 0; i < self.grid._selectedFixedRows.length; i++) {
						self.grid._selectedFixedRows[i].element = self.grid.rowById(self.grid._selectedFixedRows[i].id, true);
						if (self.grid._selectedFixedRows[i].element && self.grid._selectedFixedRows[i].element.length > 0) {
							self.grid._selectedFixedRows[i].index = self.grid._selectedFixedRows[i].element.index();
						}
					}
				}
				if (self.grid._selectedFixedRow) {
					self.grid._selectedFixedRow.element = self.grid.rowById(self.grid._selectedFixedRow.id, true);
					if (self.grid._selectedFixedRow.element && self.grid._selectedFixedRow.element.length > 0) {
						self.grid._selectedFixedRow.index = self.grid._selectedFixedRow.element.index();
					}
				}
			}, 0);
			this._removeSelectionCache();
		},
		_mouseDown: function (event) {
			var v = (this.grid.options.virtualization || this.grid.options.rowVirtualization || this.grid.options.columnVirtualization), outgrid,
				ncv = this.grid.options.virtualizationMode !== "continuous";
			if (event && this._suspend) {
				return;
			}
			// S.S. Bug #113846, July 6th, 2012 In Chrome if a scrollbar is hit no mouseup event is followed therefore an endless
			// drag select is initiated. We should ensure we exit mousedown before it modifies the selection state
			if (event.target && $(event.target).hasClass("ui-iggrid-scrolldiv")) {
				return;
			}
			// check if event is thrown on touch.
			if (event && event.which === 0) {
				event.which = 1;
			}
			// check if we are clicking the left or the right mouse button. Cancel selection on the right mouse button
			if (event && event.which !== 1) {
				return;
			}
			// we need to ensure that selection doesn't get propagated in child grids
			if (this._hc && event && event.target) {
				outgrid = $(event.target).closest(".ui-iggrid-table");
				if (outgrid.length > 0 && outgrid.attr('id') !== this.grid.element.attr('id')) {
					//event.stopPropagation();
					//event.preventDefault();
					return;
				}
			}
			// skip special empty cells (Outlook GroupBy, etc.)
			if (event.target && $(event.target).closest('td').attr('data-skip') === "true") {
				event.stopPropagation();
				event.preventDefault();
				// suppressing mousedown event destroyes igGridUpdating
				$(event.target).trigger('iggridselectionmousedown');
				return;
			}
			if (event.which === 2) {
				return; // middle mouse button was clicked, so we don't want to do anything in that case
			}
			this._isMouseDown = true;
			if (this.options.multipleSelection === false && v && ncv) {
				$('#' + this.grid.element[0].id + '_displayContainer_a').focus();
				// L.A. 28 May 2012 Fixed bug #105997 - Can't navigate selection with arrow keys when fixed virtualization is enabled
				// fixed in case of continuous virtualization
				if ((this.grid.options.virtualization || this.grid.options.rowVirtualization) && this.grid.options.virtualizationMode === 'continuous') {
					event.preventDefault();
				}
			}
			if (this.options.mouseDragSelect === false || this.options.multipleSelection === false) {
				// S.S. Fix for bug #154833 October 15, 2013 - this code prevents updating from working
				// when in combination with Selection and virtualization (105399, 102462 do not reproduce even removing it)
				//I.I. bug fix for 105399, 102462
				//if ((this.grid.options.virtualization || this.grid.options.rowVirtualization) && this.grid.options.virtualizationMode !== 'continuous') {
				//return false;
				return;
			}
			// save mouse coordinates
			this._mouseLocation = { clientX: event.clientX, clientY: event.clientY };
			this._firstDragCell = this._cellFromEvent(event);
			this._lastSelectedIndex = null;
			if (!event.ctrlKey && !event.shiftKey && this.options.multipleSelection !== true) {
				this.clearSelection(true);
			}
			this._isInternalFocus = true;
			// focus the grid container element
			if (this.options.multipleSelection === true && v && ncv) {
				$('#' + this.grid.element[0].id + '_displayContainer_a').focus();
			}
			// S.S. June 18, 2013 - Bug #143508 This container focus should not be needed for multiple selection and in fact is
			// breaking some templating functionality (i.e. select elements inside cells do not work properly)
			/* else {
                this.grid.container().focus();
			}*/
			if (!$(event.target).hasClass('ui-iggrid-expandbutton') &&
				!$(event.target).hasClass('ui-iggrid-expandcolumn') &&
				!$(event.target).hasClass('ui-iggrid-expandbuttongb')) {
				// L.A. 28 September 2012 - Fixing bug #121829 Selection's keyboard navigation does not work when multipleSelection is true.
				if (v) {
					// L.A. 27 August 2012 - Fixing bug #119735 Selection's keyboard navigation doesn't work when virtualization is true.
					event.stopPropagation();
					event.preventDefault();
				}
				// suppressing mousedown event destroyes igGridUpdating
				$(event.target).trigger('iggridselectionmousedown');
			}
		},
		_markMouseDown: function (event) {
			this._isMouseDown = true;
		},
		_selectStart: function (event) {
			if (event.target && $(event.target).closest(".ui-iggrid-table").attr("id") !== this.grid.id()) {
				return;
			}
			if (event && this._suspend) {
				return;
			}
			if (this.options.mouseDragSelect === false || this.options.multipleSelection === false) {
				return false;
			}
			event.stopPropagation();
			event.preventDefault();
		},
		_releaseMouse: function () {
			this._isMouseDown = false;
			this._isDrag = false;
		},
		_selectInternal: function (event, row, col, isFixed) {
			// apply row selected class to TR 
			// add row to the selected rows collection
			var target, parent, $target, gridCell, gridRow, i, noCancel = true, isInternal = false, vindex, isRs, outgrid, contSelection, fixedGridRow, cs, self = this,
				isRowSelection = false, parentIndex, v, excludeTmp, hasFixedColumns = this.grid.hasFixedColumns(), clickedOnFixedContainer = false, selectedRowIndex, sri;
			// the _startRowIndex may not be init yet
			sri = this.grid._startRowIndex || 0;
			v = this.grid.options.virtualization || this.grid.options.columnVirtualization || this.grid.options.rowVirtualization;
			//A.T. 29 Nov. Fix for bug #96743 - When select a column from Hidden Columns drop down a row is selected
			if (!this._isMouseDown && event) {
				return;
			}
			// if we are on touch which is 0 and we need to make it work as though we've clicked left mouse button
			if (event && event.which === 0) {
				event.which = 1;
			}
			// check if we are clicking the left or the right mouse button. Cancel selection on the right mouse button
			if (event && event.which !== 1) {
				return;
			}
			if (event !== null && event.target && ($(event.target).hasClass("ui-iggrid-childarea") ||
				$(event.target).parent().hasClass("ui-iggrid-childarea") || $(event.target).hasClass("ui-widget-header"))) {
				return;
			}
			// check for programmatic access
			if (event === null) {
				isInternal = true;
				// when we are doing shift selections, we don't want to include again the special rows, they don't matter
				excludeTmp = this.y_exclude_current;
				if (this._isContinuous || isInternal) {
					excludeTmp = 0;
				}
				vindex = row - sri < 0 ? 0 : row - sri + excludeTmp;
				event = { originalEvent: {} };
				if (col === null || col === undefined) {
					isRowSelection = true;
					if (v) {
						event.originalEvent.originalTarget = this.grid.rowAt(vindex);
					} else {
						event.originalEvent.originalTarget = this.grid.rowAt(row - excludeTmp);
					}
				} else {
					if (v) {
						// M.H. 6 Mar 2013 Fix for bug #134554: Selection's keyboard navigation doesn't work in fixed columns.
						event.originalEvent.originalTarget = this.grid.cellAt(col, vindex, isFixed);
					} else {
						// M.H. 6 Mar 2013 Fix for bug #134554: Selection's keyboard navigation doesn't work in fixed columns.
						event.originalEvent.originalTarget = this.grid.cellAt(col + this.x_exclude_current, row - excludeTmp, isFixed);
					}
				}
				event.originalEvent.srcElement = event.originalEvent.originalTarget;
			}
			// S.S. March 16, 2012 Switching the positions of certain checks, due to RowSelector specific issues when selection is wiped
			// on hierarchial grid children bands before RowSelector click is recognized.
			target = event.originalEvent.originalTarget || event.originalEvent.srcElement;
			$target = $(target);
			// get on which container the row is selected(when there is fixed columns)
			if (hasFixedColumns) {
				clickedOnFixedContainer = ($target.closest('div').attr('data-fixed-container') !== undefined);
			}
			isRs = $target.closest("th.ui-iggrid-rowselector-class").length === 1;
			// Clicking a rs checkbox
			if (event && $target.is("span") && ($target.attr("data-chk") !== undefined || $target.parent().attr("data-chk") !== undefined)) {
				this._mouseCtrlSelect = true;
				return;
			}
			if (this._hc) {
				outgrid = $target.closest(".ui-iggrid-table");
				if (outgrid.length > 0 && outgrid.attr('id') !== this.grid.element.attr('id')) {
					if (event && !isInternal) {
						//event.stopPropagation();
						event.preventDefault();
						this._isMouseDown = false;
						this._isDrag = false;
					}
					return;
				}
				$target.parents("tr[data-container]").each(function () {
					if ($(this).closest(".ui-iggrid-table").attr("id") === self.grid.element.attr("id")) {
						cs = true;
						return false;
					}
				});
				if (cs) {
					return;
				}
				// clear the rest of the selection, if this is the first time we select anything (only if the previous selection is either undefined or in a different grid)
				// otherwise we will be calling this every time we select a row or cell from the same grid, which will be very ineffective in terms of performance
				// the idea of the data-selectgrid is to store the current id of the grid we're working with. initially that will be undefined
				if (this._hgrid && this._hgrid.data("data-selectgrid") !== this.grid.element.attr("id")) {
					this.clearSelectionAllOthers(false, true);
					this._hgrid.data("data-selectgrid", this.grid.element.attr('id'));
				}
			}
			if (this._hc && this._hdirty) {
				//this.y_exclude = this._excludeRows($(event.target).closest('tr'));
				this.y_exclude_current = this._excludeRowsLt($target.closest('tr'));
			} else if (!this._hc) {
				this.y_exclude_current = 0;
			}
			if (this.x_exclude_current === undefined) {
				// check if we don't have extra cells
				this.x_exclude_current = this._calcExtraCells();
			}
			if (event && this._suspend) {
				return;
			}
			if (event && event.which === 2) {
				return;
			}
			if (this._isDrag === true && event !== null) {
				this._isDrag = false;
				return;
			}
			// fix for templating. if the cell template contains other elements, and we click on them, just taking $(target) won't give us the TR but (probably) the TD ! 
			parent = $target.closest('tr');
			//parent = $target.parent();
			if ($target.closest('th').length > 0 && isRs === false) {
				return; // we are clicking on the headers 
			}
			if ($target.closest('td').attr('data-skip') === "true") {
				//event.stopPropagation();
				//event.preventDefault();
				return;
			}
			// A.T. 23 Aug 2011: clicking directly on expansion indicators shouldn't select anything
			//if ($target.hasClass('ui-iggrid-expandcolumn') || $target.hasClass('ui-iggrid-expandbutton')) {
			//	return;
			//}
			if (event.ctrlKey) {
				this._isContinuous = false;
				this._mouseCtrlSelect = true;
			}
			if (this.options.multipleCellSelectOnClick === true && this.options.mode === "cell" && this.activeCell()) {
				this._isContinuous = false;
				this._mouseCtrlSelect = true;
				contSelection = true;
			}
			if (this.options.mode === 'cell' && isRowSelection === false) {
				if (isRs === true) {
					// S.S. April 11, 2012, Bug #100732, #100737 if the the call is done internally it's caused by
					// keyboard navigation in which chase we need to activate the RS cell so navigation doesn't break
					if (isInternal === true) {
						target = $target.is('th') ? $target[0] : $target.closest('th')[0];
					} else {
						target = $target.is('th') ? $target.next()[0] : $target.closest('th').next()[0];
					}
				} else {
					target = $target.is('td') ? $target[0] : $target.closest('td')[0];
				}
				gridCell = this._cellFromElement(target, undefined, undefined, clickedOnFixedContainer, isFixed);
				if (this.options.activation === true && this._rangeSelect !== true && this._singleShiftSelect !== true && this._ctrlSelect !== true) {
					if (this._mouseCtrlSelect !== true) {
						this._activateCell(gridCell, event);
					} else {
						this._activateCell(gridCell, event);
					}
				}
			} else {
				if (isInternal) {
					parent = $(target);
				}
				// Bug #92033 S.S. May 15, 2012. parent.index() returns the row index without taking into account expanded/group rows therefore
				// unexpected number is pushed in the selectedRows array and later deselecting the same row can only be done if that specific
				// index is known to the user. In the new way the index only depends on data rows. 
				// Bug #104635 S.S. March 26, 2012. Removing [data-grouprow='true'] from the selector because navigation does not work.
				//parentIndex = parent.parent().children("tr:not([data-container='true'])").index(parent);
				parentIndex = parent.index();
				//if (v) {
				//	parentIndex += this.grid._startRowIndex;
				//}
				// L.A. 04 February 2013 - Task 118546 - selected rows should expose their primaryKey
				selectedRowIndex = parentIndex + sri - this.y_exclude_current;
				if (clickedOnFixedContainer) {
					// M.H. 21 Aug 2013 Fix for bug #149708: When height is not defined and you select the first row with row selector the headers get ui-iggrid-selectedcell and ui-state-active classes.
					parent = this.grid.scrollContainer().find('tbody tr:nth-child(' + (selectedRowIndex + 1) + ')');
				}
				gridRow = { element: parent, index: selectedRowIndex, id: this.grid._fixPKValue(parent.attr("data-id")) };
				if (hasFixedColumns) {
					// M.H. 21 Aug 2013 Fix for bug #149708: When height is not defined and you select the first row with row selector the headers get ui-iggrid-selectedcell and ui-state-active classes.
					fixedGridRow = { element: this.grid.fixedBodyContainer().find('tbody tr:nth-child(' + (selectedRowIndex + 1) + ')'), index: selectedRowIndex, id: parent.data() ? parent.data().id : null };
				}
				// L.A. 26 October 2012 - Fixing bug #117299
				// Paging and Selection for Hierarchical grid when changing page in child layout the whole layout border is selected
				if (gridRow.element.attr('data-container')) {
					return;
				}
				if (this.options.activation === true && this._rangeSelect !== true && this._singleShiftSelect !== true && this._ctrlSelect !== true) {
					if (this._mouseCtrlSelect !== true) {
						this._activateRow(gridRow, event, fixedGridRow);
					} else if (this.activeRow() && gridRow.index !== this.activeRow().index) {
						this._activateRow(gridRow, event, fixedGridRow);
					}
				}
			}
			if (((isInternal === false && this.options.mode === 'cell') || (isInternal === true && isRowSelection === false))) {
				// fire 'ing' event
				if ((isInternal === false && !event.shiftKey) || this._ctrlSelect === true) {
					noCancel = this._trigger(this.events.cellSelectionChanging, event, { cell: gridCell, selectedCells: this.grid._selectedCells, owner: this, manual: isInternal });
				}
				if (noCancel && gridCell && gridCell.element && !gridCell.element.hasClass("ui-iggrid-expandcolumn") && !gridCell.element.hasClass("ui-iggrid-rowselector-class")) {
					// check if multiple selection is not enabled, remove the previous selection
					if (this.options.multipleSelection !== true) {
						// remove the previous selection
						if (this.grid._selectedCell !== null) {
							if (v) {
								// M.H. 6 Mar 2013 Fix for bug #134554: Selection's keyboard navigation doesn't work in fixed columns.
								$(this.grid.cellAt(this.grid._selectedCell.index, this.grid._selectedCell.rowIndex - sri, isFixed)).removeClass(this.css.selectedCell);
							} else {
								this.grid._selectedCell.element.removeClass(this.css.selectedCell);
							}
						}
						// remove selection from a grid row selected via row selector
						if (this.grid._selectedRow !== null && this.grid._selectedRow !== undefined) {
							if (v) {
								this.grid.rowAt(this.grid._selectedRow.index - sri).children().removeClass(this.css.selectedCell);
							} else {
								this.grid._selectedRow.element.children().removeClass(this.css.selectedCell);
							}
						}
						if (this.grid._selectedFixedRow !== null && this.grid._selectedFixedRow !== undefined) {
							this.grid._selectedFixedRow.element.children().removeClass(this.css.selectedCell);
						}
					} else {
						// check if CTRL is pressed
						if (event.ctrlKey || this._ctrlSelect === true || contSelection === true) {
							// add the cell to the selected cells collection
							if (gridCell.element.hasClass(this.css.selectedCell)) {
								for (i = 0; i < this.grid._selectedCells.length; i++) {
									if (this.grid._selectedCells[i].element && this.grid._selectedCells[i].element.length > 0) {
										if (this.grid._selectedCells[i].element.index() === gridCell.rowIndex &&
											this.grid._selectedCells[i].index === gridCell.index) {
											//A.T. 8 March 2012 - Fix for bug #104244 
											//this.grid._selectedCells.remove(i);
											$.ig.removeFromArray(this.grid._selectedCells, i);
										}
									} else {
										if (this.grid._selectedCells[i].rowIndex === gridCell.rowIndex &&
											this.grid._selectedCells[i].index === gridCell.index) {
											$.ig.removeFromArray(this.grid._selectedCells, i);
										}
									}
								}
							} else {
								this.grid._selectedCells.push(gridCell);
							}
						} else if (!event.shiftKey) {
							if (!isInternal) {
								this.clearSelection(true);
							}
							if (!this._isCellSelected(gridCell.rowIndex, gridCell.index)) {
								this.grid._selectedCells.push(gridCell);
							}
							if (!isInternal) {
								this._realActiveCell = gridCell;
							}
						} else {
							this._shiftCellSelection(gridCell);
							return;
						}
					}
					if ((event.ctrlKey || this._ctrlSelect === true || contSelection === true) && gridCell.element.hasClass(this.css.selectedCell)) {
						gridCell.element.removeClass(this.css.selectedCell);
					} else {
						gridCell.element.addClass(this.css.selectedCell);
						this.grid._selectedCell = gridCell;
					}
					// fire 'ed' event
					if (isInternal === false || this._ctrlSelect === true) {
						this._trigger(this.events.cellSelectionChanged, event, { cell: gridCell, selectedCells: this.grid._selectedCells, owner: this, manual: isInternal });
					}
				} /*else if (noCancel) {
					if (gridCell.element.hasClass(this.css.selectedCell)) {
						gridCell.element.removeClass(this.css.selectedCell);
					} else {
						gridCell.element.addClass(this.css.selectedCell);
					}
				}
				*/
			} else if (((isInternal === false && this.options.mode === 'row') || (isInternal === true && isRowSelection === true))) {
				if ((isInternal === false && !event.shiftKey) || this._ctrlSelect === true) {
					noCancel = this._trigger(this.events.rowSelectionChanging, event, { row: gridRow, selectedRows: this.grid._selectedRows, owner: this, manual: isInternal });
				}
				if (noCancel) {
					if (this.options.multipleSelection !== true) {
						// remove the previous selection
						if (this.grid._selectedRow !== null) {
							if (v) {
								$(this.grid.rowAt(this.grid._selectedRow.index - sri)).children().removeClass(this.css.selectedCell);
							} else {
								$(this.grid._selectedRow.element).children().removeClass(this.css.selectedCell);
							}
						}
						if (this.grid._selectedFixedRow !== null && this.grid._selectedFixedRow !== undefined) {
							$(this.grid._selectedFixedRow.element).children().removeClass(this.css.selectedCell);
						}
						// remove selection from a grid cell selected when in addition to a row selector
						if (this.grid._selectedCell !== null && this.grid._selectedCell !== undefined) {
							if (v) {
								// M.H. 6 Mar 2013 Fix for bug #134554: Selection's keyboard navigation doesn't work in fixed columns.
								$(this.grid.cellAt(this.grid._selectedCell.index, this.grid._selectedCell.rowIndex - sri, isFixed)).removeClass(this.css.selectedCell);
							} else {
								this.grid._selectedCell.element.removeClass(this.css.selectedCell);
							}
						}
						if (this.grid._selectedFixedCell !== null && this.grid._selectedFixedCell !== undefined) {
							this.grid._selectedFixedCell.element.removeClass(this.css.selectedFixedCell);
						}
					} else {
						if (event.ctrlKey || this._ctrlSelect === true) {
							if (gridRow.element.children().hasClass(this.css.selectedCell)) {
								for (i = 0; i < this.grid._selectedRows.length; i++) {
									if (this.grid._selectedRows[i].element && this.grid._selectedRows[i].element.length > 0) {
										if (this.grid._selectedRows[i].element.index() === gridRow.index) {
											$.ig.removeFromArray(this.grid._selectedRows, i);
											if (hasFixedColumns && this.grid._selectedFixedRows[i]) {
												$.ig.removeFromArray(this.grid._selectedFixedRows, i);
											}
										}
									} else {
										if (this.grid._selectedRows[i].index === gridRow.index) {
											//A.T. 8 March 2012 - Fix for bug #104244
											//this.grid._selectedRows.remove(i);
											$.ig.removeFromArray(this.grid._selectedRows, i);
											if (hasFixedColumns && this.grid._selectedFixedRows[i]) {
												$.ig.removeFromArray(this.grid._selectedFixedRows, i);
											}
										}
									}
								}
							} else {
								this.grid._selectedRows.push(gridRow);
								if (hasFixedColumns) {
									this.grid._selectedFixedRows.push(fixedGridRow);
								}
							}
						} else if (!event.shiftKey) {
							if (!isInternal) {
								this.clearSelection(true);
							}
							if (!this._isRowSelected(gridRow.index)) {
								this.grid._selectedRows.push(gridRow);
								if (hasFixedColumns) {
									this.grid._selectedFixedRows.push(fixedGridRow);
								}
							}
							if (!isInternal) {
								this._realActiveRow = gridRow;
							}
						} else {
							this._shiftRowSelection(gridRow);
							return;
						}
					}
					if ((event.ctrlKey || this._ctrlSelect === true) && gridRow.element.children().hasClass(this.css.selectedCell)) {
						gridRow.element.removeClass(this.css.selectedRow);
						gridRow.element.children().removeClass(this.css.selectedCell);
						if (hasFixedColumns && fixedGridRow) {
							fixedGridRow.element.removeClass(this.css.selectedRow);
							fixedGridRow.element.children().removeClass(this.css.selectedCell);
						}
						// protect igGridUpdating
					} else if (parent.is('tr')) {
						parent.children(":not(.ui-iggrid-nongrouprowemptycell)").addClass(this.css.selectedCell);
						if (hasFixedColumns) {
							fixedGridRow.element.children(":not(.ui-iggrid-nongrouprowemptycell)").addClass(this.css.selectedCell);
						}
					}
					this.grid._selectedRow = gridRow;
					if (hasFixedColumns) {
						this.grid._selectedFixedRow = fixedGridRow;
					}
					if (isInternal === false || this._ctrlSelect === true) {
						this._trigger(this.events.rowSelectionChanged, event, { row: gridRow, selectedRows: this.grid._selectedRows, selectedFixedRows: this.grid._selectedFixedRows, owner: this, manual: isInternal });
					} else if (isInternal === true && !this._rangeSelect) {
						// S.S. September 27, 2012 Bug #119509 Even if selection is performed through the API an indicationa about it
						// should be thrown so other widgets can be updated accordingly.
						this._trigger("internalrowselectionchanged", event, { row: gridRow, selectedRows: this.grid._selectedRows, selectedFixedRows: this.grid._selectedFixedRows, owner: this });
					}
				}
			}
			this._mouseCtrlSelect = false;
		},
		_shiftRowSelection: function (row, noClear, singleRowNavigate, currentRow, event) {
			var i, startIndex, endIndex, noCancel = true;
			//A.T. 23 Nov 2011 - fix for bug #76038. introducing this new property
			// This is a really tricky scenario - i mean, realActiveRow/realActiveCell should only count when
			// there is a continuous shift selection, and only after that we are moving one row up or down, and 
			// CTRL and SHIFT aren't active. 
			this._isContinuous = true;
			if (this.grid._selectedRows.length === 0) {
				//this.grid._selectedRows.push(row);
				this._singleShiftSelect = true;
				// select the current row and return
				noCancel = this._trigger(this.events.rowSelectionChanging, null, { row: row, startIndex: row.index, endIndex: row.index, selectedRows: this.grid._selectedRows, owner: this, manual: false, selectedFixedRows: this.grid._selectedFixedRows });
				if (noCancel) {
					this.selectRow(row.index);
					this._trigger(this.events.rowSelectionChanged, null, { row: row, selectedRows: this.grid._selectedRows, owner: this, manual: false, selectedFixedRows: this.grid._selectedFixedRows });
				}
				this._singleShiftSelect = false;
				return;
			}
			endIndex = row.index;
			startIndex = this.grid._selectedRows[0].index;
			noCancel = this._trigger(this.events.rowSelectionChanging, null, { row: row, startIndex: startIndex, endIndex: endIndex, selectedRows: this.grid._selectedRows, owner: this, manual: false, selectedFixedRows: this.grid._selectedFixedRows });
			if (noCancel) {
				// the list of below scenarios is taken from the behavior in MS Excel
				// 1. new index > last selected row index => select all remaining rows from last existing to the current "row" one
				//L.A. 03 Aug 2012 - Fixing bug #80824 Multiple selection doesn't select correctly when virtualization is enabled
				this._rangeSelect = true;
				if (!singleRowNavigate) {
					if (this.grid._selectedRows.length > 0 && this.grid._selectedRows[0].index < row.index) {
						if (noClear !== false) {
							this.clearSelection(true);
						}
						for (i = startIndex; i <= endIndex; i++) {
							this.selectRow(i);
						}
					}
					// 2. new index < first selected row index
					if (this.grid._selectedRows.length > 0 && this.grid._selectedRows[0].index > row.index) {
						// select from new index to initial index
						if (noClear !== false) {
							this.clearSelection(true);
						}
						for (i = startIndex; i >= endIndex; i--) {
							this.selectRow(i);
						}
					}
				} else {
					if (event) {
						this._activateRow(row, event);
					}
					if (this._isRowSelected(this.activeRow().index)) {
						this.deselectRow(currentRow.index);
					} else {
						this.selectRow(this.activeRow().index);
					}
					this._singleShiftSelect = false;
				}
				//L.A. 03 Aug 2012 - Fixing bug #80824 Multiple selection doesn't select correctly when virtualization is enabled
				this._rangeSelect = false;
				// 3. selection in between
				this._trigger(this.events.rowSelectionChanged, null, { row: row, selectedRows: this.grid._selectedRows, owner: this, manual: false, selectedFixedRows: this.grid._selectedFixedRows });
			}
		},
		_shiftCellSelection: function (cell, noClear, singleCellNavigate, currentCell, event) {
			var firstCell, firstRowIndex, lastRowIndex, firstCellIndex, lastCellIndex, i, j,
				noCancel = true, lastSelRow = 0, firstSelRow = Number.MAX_VALUE, lastSelCol = 0, firstSelCol = Number.MAX_VALUE;
			//A.T. 23 Nov 2011 - fix for bug #76038. introducing this new property
			// This is a really tricky scenario - i mean, realActiveRow/realActiveCell should only count when
			// there is a continuous shift selection, and only after that we are moving one row up or down, and 
			// CTRL and SHIFT aren't active. 
			this._isContinuous = true;
			if (this.grid._selectedCells.length === 0) {
				this._singleShiftSelect = true;
				// select the current cell and return
				noCancel = this._trigger(this.events.cellSelectionChanging, null, { cell: cell, firstRowIndex: cell.rowIndex, lastRowIndex: cell.rowIndex, firstColumnIndex: cell.index, lastColumnIndex: cell.index, selectedCells: this.grid._selectedCells, owner: this, manual: false });
				if (noCancel) {
					this.selectCell(cell.rowIndex, cell.index);
					this._trigger(this.events.cellSelectionChanged, null, { cell: cell, selectedCells: this.grid._selectedCells, owner: this, manual: false });
				}
				this._singleShiftSelect = false;
				return;
			}
			firstCell = this.grid._selectedCells[0];
			firstRowIndex = firstCell.rowIndex;
			lastRowIndex = cell.rowIndex;
			firstCellIndex = firstCell.index;
			lastCellIndex = cell.index;
			noCancel = this._trigger(this.events.cellSelectionChanging, null, {
				cell: cell, firstRowIndex: firstRowIndex,
				lastRowIndex: lastRowIndex, firstColumnIndex: firstCellIndex, lastColumnIndex: lastCellIndex, selectedCells: this.grid._selectedCells, owner: this, manual: false
			});
			if (noCancel) {
				if (noClear !== false) {
					this.clearSelection(true);
				}

				//L.A. 06 November 2012 - Fixing bug #80824 Multiple selection doesn't select correctly when virtualization is enabled
				this._rangeSelect = true;
				if (!singleCellNavigate) {
					if (firstCell.isFixed === cell.isFixed) {
						if (firstRowIndex <= lastRowIndex) {
							for (i = firstRowIndex; i <= lastRowIndex; i++) {
								if (firstCellIndex <= lastCellIndex) {
									for (j = firstCellIndex; j <= lastCellIndex; j++) {
										this.selectCell(i, j, cell.isFixed);
									}
								} else {
									for (j = firstCellIndex; j >= lastCellIndex; j--) {
										this.selectCell(i, j, cell.isFixed);
									}
								}
							}
						} else {
							for (i = firstRowIndex; i >= lastRowIndex; i--) {
								if (firstCellIndex <= lastCellIndex) {
									for (j = firstCellIndex; j <= lastCellIndex; j++) {
										this.selectCell(i, j, cell.isFixed);
									}
								} else {
									for (j = firstCellIndex; j >= lastCellIndex; j--) {
										this.selectCell(i, j, cell.isFixed);
									}
								}
							}
						}
					}
				} else {
					// additional scenarios:
					// 1. firstSelRow - lastSelRow > 0 && moving left
					// 2. firstSelRow - lastSelRow > 0 && moving right 
					// 3. firstSelCol - lastSelCol > 0 && moving up
					// 4. firstSelCol - lastSelCol > 0 && moving down 
					// we are moving one cell to the left, top, right or bottom 
					this._singleShiftSelect = true;
					if (event) {
						this._activateCell(cell, event);
					}
					if (this._isCellSelected(this.activeCell().rowIndex, this.activeCell().index)) {
						this.deselectCell(currentCell.rowIndex, currentCell.index);
						// calc boundaries after last deselect
						for (i = 0; i < this.grid._selectedCells.length; i++) {
							if (this.grid._selectedCells[i].rowIndex > lastSelRow) {
								lastSelRow = this.grid._selectedCells[i].rowIndex;
							}
							if (this.grid._selectedCells[i].rowIndex < firstSelRow) {
								firstSelRow = this.grid._selectedCells[i].rowIndex;
							}
							if (this.grid._selectedCells[i].index > lastSelCol) {
								lastSelCol = this.grid._selectedCells[i].index;
							}
							if (this.grid._selectedCells[i].index < firstSelCol) {
								firstSelCol = this.grid._selectedCells[i].index;
							}
						}

						if (Math.abs(firstSelRow - lastSelRow) > 0 && Math.abs(this.activeCell().index - currentCell.index) > 0) { // moving right or left
							if (firstSelRow <= lastSelRow) {
								for (i = firstSelRow; i <= lastSelRow; i++) {
									this.deselectCell(i, currentCell.index);
								}
							} else {
								for (i = firstSelRow; i >= lastSelRow; i--) {
									this.deselectCell(i, currentCell.index);
								}
							}
						} else if (Math.abs(firstSelCol - lastSelCol) > 0 && Math.abs(this.activeCell().rowIndex - currentCell.rowIndex) > 0) { // moving up or down
							if (firstSelCol <= lastSelCol) {
								for (i = firstSelCol; i <= lastSelCol; i++) {
									this.deselectCell(currentCell.rowIndex, i);
								}
							} else {
								for (i = firstSelCol; i >= lastSelCol; i--) {
									this.deselectCell(currentCell.rowIndex, i);
								}
							}
						}
					} else {
						this.selectCell(this.activeCell().rowIndex, this.activeCell().index);
						// calc boundaries after last select
						for (i = 0; i < this.grid._selectedCells.length; i++) {
							if (this.grid._selectedCells[i].rowIndex > lastSelRow) {
								lastSelRow = this.grid._selectedCells[i].rowIndex;
							}
							if (this.grid._selectedCells[i].rowIndex < firstSelRow) {
								firstSelRow = this.grid._selectedCells[i].rowIndex;
							}
							if (this.grid._selectedCells[i].index > lastSelCol) {
								lastSelCol = this.grid._selectedCells[i].index;
							}
							if (this.grid._selectedCells[i].index < firstSelCol) {
								firstSelCol = this.grid._selectedCells[i].index;
							}
						}
						// we need to select also all cells which are selected in column currentCell.index, but not in this.grid._activeCell.index
						if (Math.abs(firstSelRow - lastSelRow) > 0 && Math.abs(this.activeCell().index - currentCell.index) > 0) { // moving right or left
							if (firstSelRow <= lastSelRow) {
								for (i = firstSelRow; i <= lastSelRow; i++) {
									this.selectCell(i, this.activeCell().index);
								}
							} else {
								for (i = firstSelRow; i >= lastSelRow; i--) {
									this.selectCell(i, this.activeCell().index);
								}
							}
						} else if (Math.abs(firstSelCol - lastSelCol) > 0 && Math.abs(this.activeCell().rowIndex - currentCell.rowIndex) > 0) { // moving up or down
							if (firstSelCol <= lastSelCol) {
								for (i = firstSelCol; i <= lastSelCol; i++) {
									this.selectCell(this.activeCell().rowIndex, i);
								}
							} else {
								for (i = firstSelCol; i >= lastSelCol; i--) {
									this.selectCell(this.activeCell().rowIndex, i);
								}
							}
						}
					}
					//L.A. 06 November 2012 - Fixing bug #80824 Multiple selection doesn't select correctly when virtualization is enabled
					this._singleShiftSelect = false;
				}
				this._rangeSelect = false;
				this._trigger(this.events.cellSelectionChanged, null, { cell: cell, selectedCells: this.grid._selectedCells, owner: this, manual: false });
			}
		},
		_rowExpanded: function (event, args) {
			this._hdirty = true;
		},
		// Activation (with arrow keys) - changes the currently focused cell
		_navigate: function (event) {
			var vcontainer = $('#' + this.grid.element[0].id + '_displayContainer_a'), active, shouldNavigate = false;
			if (event && this._suspend) {
				return;
			}
			if (this._isMouseDown === true) {
				return;
			}
			if (event.keyCode !== $.ui.keyCode.ENTER && event.keyCode !== $.ui.keyCode.SPACE &&
				event.keyCode !== $.ui.keyCode.UP && event.keyCode !== $.ui.keyCode.DOWN &&
				event.keyCode !== $.ui.keyCode.LEFT && event.keyCode !== $.ui.keyCode.RIGHT) {
				return;
			}
			// if we have an hierarchical grid, and there are expanded rows, exclude those from selection
			// need to handle the expansion event of the hierarchical grid in order to mark the excude count as dirty 
			if (this._hc) {
				active = this.options.mode === "row" ? this.activeRow() : this.activeCell();
				if (active !== undefined && active !== null) {
					active = this.options.mode === "row" ? active.element : active.element.closest('tr');
					//this.y_exclude = this._excludeRows(active);
					this.y_exclude_current = this._excludeRowsLt(active);
				}
				//this._hdirty = false; // only do this for the hgrid
			} else {
				//this.y_exclude = 0;
				this.y_exclude_current = 0;
			}
			if (this.x_exclude_current === undefined) {
				// check if we don't have extra cells
				this.x_exclude_current = this._calcExtraCells();
			}
			// check if we are actually navigating on cells (rows) or the header row 
			if (this.grid.options.virtualization) {
				if ($.ig.util.isIE && document.activeElement &&
					(document.activeElement.id !== this.grid.id() &&
					document.activeElement.id !== this.grid.container().attr("id") &&
					!$(document.activeElement).is('td') &&
					$(document.activeElement).closest("table")[0].id !== this.grid.id())) {
					return;
				}
				if (!$.ig.util.isIE && event.target.id !== vcontainer.attr('id')) {
					return;
				}
			} else {
				if ($.ig.util.isIE && document.activeElement &&
					(document.activeElement.id !== this.grid.id() &&
					document.activeElement.id !== this.grid.container().attr("id") &&
					!$(document.activeElement).is('td') &&
					$(document.activeElement).closest("table")[0].id !== this.grid.id())) {
					return;
				}
				if (!$.ig.util.isIE && event.target.id !== this.grid.container().attr('id')) {
					return;
				}
			}
			// if there is no active cell, and activation is enabled, activate the cell. 
			//firstCellKey = this.grid.options.columns.length > 0 ? this.grid.options.columns[0].key : null;
			//firstCell = this._firstCell;
			//firstRow = this._firstRow;
			if (this.options.activation === true) {
				// if there is multiple selection , we just apply the active style, otherwise we apply both active and selected
				if (this.options.mode === 'cell') {
					if (this.options.multipleSelection === true) {
						if (this.activeCell() === null || this.activeCell() === undefined) {
							// the first cell on the first row becomes active
							//this._activateCell({element: firstCell, index: 0, rowIndex: 0, columnKey: firstCellKey, row: $(this.grid.rowAt(0))}, event);
							this.selectCell(0, 0);
						} else {
							if (this.options.skipChildren === false && this._hc && this._isMovingUpDown(event)) {
								shouldNavigate = this._activateNextGrid(event);
								if (!shouldNavigate) {
									this._navigateCell(event, false);
								}
							} else {
								this._navigateCell(event, false);
							}
						}
					} else {
						if ((this.activeCell() === null && this.grid._selectedCell === null) || (this.activeCell() === undefined && this.grid._selectedCell === undefined)) {
							//this._activateCell({element: firstCell, index: 0, rowIndex: 0, columnKey: firstCellKey, row: $(this.grid.rowAt(0))}, event);
							this.selectCell(0, 0);
						} else {
							if (this.options.skipChildren === false && this._hc && this._isMovingUpDown(event)) {
								shouldNavigate = this._activateNextGrid(event);
								if (!shouldNavigate) {
									this._navigateCell(event, true);
								}
							} else {
								this._navigateCell(event, true);
							}
						}
					}
				} else { // row
					if (this.options.multipleSelection === true) {
						if (this.activeRow() === null || this.activeRow() === undefined) {
							// the first cell on the first row becomes active
							//this._activateRow({element: firstRow, index: 0}, event);
							this.selectRow(0);
						} else {
							if (this.options.skipChildren === false && this._hc && this._isMovingUpDown(event)) {
								shouldNavigate = this._activateNextGrid(event);
								if (!shouldNavigate) {
									this._navigateRow(event, false);
								}
							} else {
								this._navigateRow(event, false);
							}
						}
					} else {
						if ((this.activeRow() === null && this.grid._selectedRow === null) || (this.activeRow() === undefined && this.grid._selectedRow === undefined)) {
							//this._activateRow({element: firstRow, index: 0}, event);
							this.selectRow(0);
						} else {
							if (this.options.skipChildren === false && this._hc && this._isMovingUpDown(event)) {
								shouldNavigate = this._activateNextGrid(event);
								if (!shouldNavigate) {
									this._navigateRow(event, true);
								}
							} else {
								this._navigateRow(event, true);
							}
						}
					}
				}
			}
		},
		_isMovingUpDown: function (event) {
			if (event.keyCode === $.ui.keyCode.UP || event.keyCode === $.ui.keyCode.DOWN) {
				return true;
			}
			return false;
		},
		_navigateFocus: function (event) {
			if (($.ig.util.isFF && event.originalEvent && $(event.originalEvent.explicitOriginalTarget).is('th'))) {
				return;
			}
			// check if we are clicking the left or the right mouse button. Cancel selection on the right mouse button
			// L.A. 27 June 2012 - Fixing bug #113714 Page scrolls down in IE9 and Chrome when clicking on a row while multiple selection is enabled.
			// L.A. 27 June 2012 - Fixing bug #115566 Page scrolls up and only grid header remains visible when multiple selection true
			// L.A. 03 August 2012 - Fixing bug #118735 Up/down arrow key navigation does not work with virtualization
			// There is a complicated chain of focusing events, so we need to cut the chain, focus the element and then restore the events binding
			if (event.which !== 1) {
				$('#' + this.grid.element[0].id + '_displayContainer_a').unbind('focus', this._focusHandler);
				$('#' + this.grid.element[0].id + '_displayContainer_a').focus();
				$('#' + this.grid.element[0].id + '_displayContainer_a').bind({ focus: this._focusHandler });
				event.stopPropagation();
				return;
			}
			this._navigate(event);
		},
		_navigateCell: function (event, select) {
			var nextX, nextY, x, y, currentCell = this.activeCell(), rowCount, newCell, length, newCellObject, noCancel = true, fixingDirection,
				sri = this.grid._startRowIndex, sci = this.grid._startColIndex, $newCell, hgrid, ptr, indexTmp = 0, cKey, parent, cb, isFixedCell = false,
				v = this.grid.options.virtualization || this.grid.options.rowVirtualization, c, ret = false, rs, hasFixedColumns = this.grid.hasFixedColumns();
			c = v && this.grid.options.virtualizationMode === "continuous";
			//A.T. 29 March - #92424
			if (currentCell === null) {
				return;
			}
			// M.H. 6 Mar 2013 Fix for bug #134554: Selection's keyboard navigation doesn't work in fixed columns.
			if (hasFixedColumns) {
				if (currentCell.element.closest('div').attr('data-fixed-container') !== undefined) {
					isFixedCell = true;
					fixingDirection = currentCell.element.closest('div[data-fixing-direction]').attr('data-fixing-direction');
				} else {
					fixingDirection = this.grid.container().find('div[data-fixing-direction]').eq(0).attr('data-fixing-direction');
				}
			}
			if (sri === undefined || sri === null) {
				sri = 0;
			}
			if (sci === undefined || sri === null) {
				sci = 0;
			}
			if (v) {
				x = currentCell.index - sci;
				y = currentCell.rowIndex - sri;
			} else {
				x = currentCell.index;
				y = currentCell.rowIndex;
			}
			y += this.y_exclude_current;
			x += this.x_exclude_current;
			if (!this._rowCount || !this._length) {
				this._refresh();
			}
			rowCount = this._rowCount;
			length = this._length;
			// M.H. 6 Mar 2013 Fix for bug #134554: Selection's keyboard navigation doesn't work in fixed columns.
			if (hasFixedColumns) {
				length -= this.grid._fixedColumns.length;
			}
			if (this.x_exclude_current > 0) {
				length += this.x_exclude_current;
			}
			if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
				// select (does nothing if select in the args is true)
				nextX = x;

				nextY = y;
				if (event.ctrlKey && this._isCellSelected(y + sri - this.y_exclude_current, x + sci - this.x_exclude_current)) {
					// fire events
					noCancel = this._trigger(this.events.cellSelectionChanging, event, { cell: currentCell, selectedCells: this.grid._selectedCells, owner: this, manual: false });
					if (noCancel) {
						this.deselectCell(y + sri - this.y_exclude_current, x + sci - this.x_exclude_current);
						this._trigger(this.events.cellSelectionChanged, event, { cell: currentCell, selectedCells: this.grid._selectedCells, owner: this, manual: false });
					}
					// fix for bug #75165 - Cell selection cannot be triggered by pressing SPACE or ENTER
				} else if (event.ctrlKey || !this._isCellSelected(y - this.y_exclude_current, x)) {
					this._ctrlSelect = true;
					this._selectInternal(null, y - this.y_exclude_current, x - this.x_exclude_current);
					this._ctrlSelect = false;
				}
				// go to the next cell and activate it (optionally select it if select in the args is true)
			} else if (event.keyCode === $.ui.keyCode.DOWN) {
				// go to the next row, same cell 
				nextX = x;
				nextY = y + 1;
				if (this._realActiveCell !== null && this._realActiveCell !== undefined && this._isContinuous &&
						this.options.multipleSelection === true && this.grid._selectedCells.length > 1 && !event.shiftKey && !event.ctrlKey) {
					nextX = this._realActiveCell.index - sci + this.x_exclude_current;
					nextY = this._realActiveCell.rowIndex + 1 - sri + this.y_exclude_current;
				}
				if (nextY - this.y_exclude_current > rowCount - 1 - sri && this.options.wrapAround === true && !v) {
					nextY = this.y_exclude_current;
				} else if (nextY - this.y_exclude_current > rowCount - 1 - sri && this.options.wrapAround === false) {
					//nextY = y;
					// check if we have a grid 
					if (this._hc && !this.options.skipChildren) {
						this._activateNextGrid(null, true); // activate the next grid, going down 
					}
					return;
				}
			} else if (event.keyCode === $.ui.keyCode.UP) {
				// go to the prev. row, same cell 
				nextX = x;
				nextY = y - 1;
				if (this._realActiveCell !== null && this._realActiveCell !== undefined && this._isContinuous &&
						this.options.multipleSelection === true && this.grid._selectedCells.length > 1 && !event.shiftKey && !event.ctrlKey) {
					nextX = this._realActiveCell.index - sci + this.x_exclude_current;
					nextY = this._realActiveCell.rowIndex - 1 - sri + this.y_exclude_current;
				}
				if (!v) {
					if (nextY - this.y_exclude_current < 0 && this.options.wrapAround === true) {
						nextY = rowCount - 1;
					} else if (nextY - this.y_exclude_current < 0 && this.options.wrapAround === false) {
						//nextY = y;
						if (this._hc && !this.options.skipChildren) {
							this._activateNextGrid(null, false); // activate the previous grid, going up
						}
						return;
					}
				}
			} else if (event.keyCode === $.ui.keyCode.LEFT) {
				// go to the prev. cell on the same row
				nextX = x - 1;
				nextY = y;
				// M.H. 6 Mar 2013 Fix for bug #134554: Selection's keyboard navigation doesn't work in fixed columns.
				if (hasFixedColumns) {
					if (isFixedCell) {
						if (nextX < 0) {
							isFixedCell = false;
							if (fixingDirection === 'left') {
								nextX = length - 1;
								nextY -= 1;
							} else {
								nextX = length - 1;
							}
						}
					} else {
						if (nextX < 0) {
							isFixedCell = true;
							nextX = this.grid._fixedColumns.length - 1;
							if (fixingDirection === 'right') {
								nextY -= 1;
								if (nextY < 0) {
									nextY = rowCount - 1;
								}
							}
						}
					}
				}
				if (nextX - this.x_exclude_current < 0) {
					if (this._hc && !this.options.skipChildren) {
						ret = this._activateNextGrid(null, false, true); // activate the previous grid, going up (level down)
					}
					if (ret) {
						return;
					}
					nextX = length - 1;
					nextY = y - 1;
				}
				if (this._realActiveCell !== null && this._realActiveCell !== undefined &&
						this.options.multipleSelection === true && this.grid._selectedCells.length > 1 && !event.shiftKey && !event.ctrlKey) {
					nextX = this._realActiveCell.index - 1 - sci + this.x_exclude_current;
					nextY = this._realActiveCell.rowIndex - sri + this.y_exclude_current;
				}
				if (!v) {
					if (nextY < 0 && this.options.wrapAround === true) {
						nextX = length - 1;
						nextY = rowCount - 1;
					} else if (nextY < 0 && this.options.wrapAround === false) {
						//nextX = x;
						//nextY = y;
						if (this._hc && !this.options.skipChildren) {
							this._activateNextGrid(null, false); // activate the previous grid, going up (level up)
						}
						return;
					}
				}
			} else if (event.keyCode === $.ui.keyCode.RIGHT) {
				// go to the next cell on the same row
				nextX = x + 1;
				nextY = y;
				// M.H. 6 Mar 2013 Fix for bug #134554: Selection's keyboard navigation doesn't work in fixed columns.
				if (hasFixedColumns) {
					if (isFixedCell) {
						if (nextX >= this.grid._fixedColumns.length) {
							isFixedCell = false;
							if (fixingDirection === 'right') {
								nextY += 1;
							}
							nextX = 0;
						}
					} else {
						if (nextX >= length) {
							if (fixingDirection === 'left') {
								nextY += 1;
							}
							isFixedCell = true;
							nextX = 0;
						}
					}
				}
				if (nextX >= length) {
					if (this._hc && !this.options.skipChildren) {
						ret = this._activateNextGrid(null, true, true); // activate the next grid, going down (level down)
					}
					if (ret) {
						return;
					}
					nextX = 0;
					nextY = y + 1;
				}
				if (this._realActiveCell !== null && this._realActiveCell !== undefined &&
						this.options.multipleSelection === true && this.grid._selectedCells.length > 1 && !event.shiftKey && !event.ctrlKey) {
					nextX = this._realActiveCell.index + 1 - sci + this.x_exclude_current;
					nextY = this._realActiveCell.rowIndex - sri + this.y_exclude_current;
				}
				if (!v) {
					if (nextY >= rowCount + this.y_exclude_current && this.options.wrapAround === true) {
						nextX = 0;
						nextY = 0;
					} else if (nextY >= rowCount + this.y_exclude_current && this.options.wrapAround === false) {
						//nextX = x;
						//nextY = y;
						if (this._hc && !this.options.skipChildren) {
							this._activateNextGrid(null, true); // activate the next grid, going down (level up)
						}
						return;
					}
				}
			} else {
				return;
			}
			if (v && !c && nextY >= this.grid._virtualRowCount) {
				//if (nextY !== y) {
				this._setScrollTop(this.grid.element.parent(), newCell, nextY > y ? 'down' : 'up', nextY - this.y_exclude_current);
				//}
				nextY = this.grid._virtualRowCount - 1;
				//newCell = this.grid.cellAt(nextX, nextY);
			} else if (v && !c && nextY < 0 && sri > 0) {
				//if (nextY !== y) {
				this._setScrollTop(this.grid.element.parent(), newCell, 'up', nextY - this.y_exclude_current);
				//}
				nextY = 0;
				//newCell = this.grid.cellAt(nextX, nextY);
			} else if (v && !c && nextY < 0) {
				return;
			} //else {
			//	newCell = this.grid.cellAt(nextX, nextY);
			//}
			if (this.x_exclude_current > 0 && this.grid.rowAt(nextY).cells.length < length) {
				nextX = this.grid.rowAt(nextY).cells.length - 1;
			}
			// M.H. 6 Mar 2013 Fix for bug #134554: Selection's keyboard navigation doesn't work in fixed columns.
			newCell = this.grid.cellAt(nextX === 0 ? this.x_exclude_current : nextX, nextY - this.y_exclude_current, isFixedCell);
			if (newCell === undefined && (event.keyCode === $.ui.keyCode.DOWN || event.keyCode === $.ui.keyCode.UP)) {
				if (event.keyCode === $.ui.keyCode.DOWN) {
					nextY++;
				} else if (event.keyCode === $.ui.keyCode.UP) {
					nextY--;
				}
				// M.H. 6 Mar 2013 Fix for bug #134554: Selection's keyboard navigation doesn't work in fixed columns.
				newCell = this.grid.cellAt(nextX, nextY, isFixedCell);
			}
			/*
			if (newCell && $(newCell).attr('data-skip') === "true") {
				event.stopPropagation();
				event.preventDefault();
				return;
			}
			*/
			// recalc scrollTop and scrollLeft
			if (!v || c) {
				this._setScrollTop(this.grid.element.parent(), newCell, nextY >= y ? 'down' : 'up', nextY - this.y_exclude_current);
				if (c) {
					if (sri !== this.grid._startRowIndex) {
						nextY = nextY + (nextY >= y ? -1 : 1) * Math.abs(this.grid._startRowIndex - sri);
						sri = this.grid._startRowIndex;
					}
					// M.H. 6 Mar 2013 Fix for bug #134554: Selection's keyboard navigation doesn't work in fixed columns.
					newCell = this.grid.cellAt(nextX, nextY, isFixedCell);
				}
				//A.Y. bug #98047. When we have both width and height the grid's hScroll is 
				//determinded by the _hscroller element
				if (this.grid.options.width !== null && this.grid.options.height !== null) {
					parent = $('#' + this.grid.element[0].id + '_hscroller');
				} else if (this.grid.scrollContainer().length > 0) {
					parent = this.grid.scrollContainer();
				} else {
					parent = this.grid.element.parent();
				}
				this._setScrollLeft(parent, newCell, nextX >= x ? 'right' : 'left', nextX - this.x_exclude_current);
			}
			if (newCell === undefined || newCell.length > 1) {
				return;
			}
			$newCell = $(newCell);
			if (this._hc && ($newCell.hasClass('ui-iggrid-expandbutton') || $newCell.hasClass('ui-iggrid-expandcolumn'))) {
				// toggle selected/active styles on the expand indicator cell
				//if ($newCell.hasClass('ui-iggrid-selectedcell')) {
				//	$newCell.removeClass('ui-iggrid-selectedcell ui-iggrid-activecell ui-state-focus ui-state-active');
				//} else {
				//	$newCell.addClass('ui-iggrid-selectedcell ui-iggrid-activecell ui-state-focus ui-state-active');
				//}
				if (event.keyCode === $.ui.keyCode.ENTER) {
					ptr = $newCell.closest('tr');
					hgrid = $newCell.closest('.ui-iggrid-root').data('igHierarchicalGrid');
					// find hierarchical grid
					// toggle hierarchical row
					hgrid.toggle(ptr);
				}
				//return;
			}
			// S.S. April 11, 2012, Bug #100732, #100737 when we can activate the rs cell via navigation we should also be able
			// to toggle the rs cell by ENTER and SPACE
			if ($newCell.hasClass('ui-iggrid-rowselector-class') &&
					(event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE)) {
				rs = this.grid.element.data('igGridRowSelectors');
				cb = $newCell.find("span[data-role='checkbox']");
				if (rs && cb.length > 0) {
					rs._handleCheck(cb);
				}
			}
			indexTmp = nextX - this.x_exclude_current;
			if (event.keyCode !== $.ui.keyCode.ENTER && event.keyCode !== $.ui.keyCode.SPACE) {
				$(currentCell.element).removeClass(this.css.activeCell);
				if (nextX === 0) {
					indexTmp = this.x_exclude_current;
				} //else {
				//	indexTmp = nextX - this.x_exclude_current;
				//}
				if (nextX >= this.grid.options.columns.length) {
					cKey = this.grid.options.columns[this.grid.options.columns.length - 1].key;
				} else {
					cKey = this.grid.options.columns[nextX === 0 ? 0 : indexTmp - (this._hc === true ? 1 : 0)].key;
				}
				if (nextX <= 0 && this._hc) {
					cKey = null;
				}
				if (v) {
					newCellObject = {
						element: $(newCell),
						index: nextX === 0 ? sci : indexTmp + sci,
						rowIndex: nextY + sri - this.y_exclude_current,
						row: $(this.grid.rowAt(nextY)),
						columnKey: cKey
					};
				} else {
					newCellObject = {
						element: $(newCell),
						index: nextX === 0 ? 0 : indexTmp,
						rowIndex: nextY - this.y_exclude_current,
						row: $(this.grid.rowAt(nextY)),
						columnKey: cKey
					};
				}
				if (event.ctrlKey && this.activeCell() && (this.activeCell().index !== newCellObject.index || this.activeCell().rowIndex !== newCellObject.rowIndex)) {
					this._activateCell(newCellObject, event);
				}
				if (!event.ctrlKey && event.shiftKey && this.options.multipleSelection === true) {
					this._shiftCellSelection(newCellObject, false, true, currentCell, event);
				} else if (!event.ctrlKey) {
					noCancel = this._trigger(this.events.cellSelectionChanging, event, { cell: newCellObject, selectedCells: this.grid._selectedCells, owner: this, manual: false });
					if (noCancel) {
						this.clearSelection(true);
						//if (v) {
						//	this._selectInternal(null, nextY + sri, nextX + sci);
						//} else {
						this._selectInternal(null, nextY - this.y_exclude_current, nextX === 0 ? 0 : indexTmp, isFixedCell);
						//}
						this._trigger(this.events.cellSelectionChanged, event, { cell: newCellObject, selectedCells: this.grid._selectedCells, owner: this, manual: false });
					}
				}
			}
			event.preventDefault();
			event.stopPropagation();
		},
		_navigateRow: function (event, select) {
			var nextY, y, currentRow = this.activeRow(), rowCount, newRowObject, newRow, noCancel = true, v, c,
				sri = this.grid._startRowIndex; //sci = this.grid._startColIndex;
			v = this.grid.options.virtualization || this.grid.options.rowVirtualization;
			c = v && this.grid.options.virtualizationMode === "continuous";
			if (!currentRow) {
				return;
			}
			if (v) {
				y = currentRow.index - sri;
			} else {
				y = currentRow.index;
			}
			y += this.y_exclude_current;
			rowCount = this._rowCount;
			if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
				// select (does nothing if select in the args is true)
				nextY = y;
				if (event.ctrlKey && this._isRowSelected(y - this.y_exclude_current)) {
					noCancel = this._trigger(this.events.rowSelectionChanging, event, { row: currentRow, selectedRows: this.grid._selectedRows, selectedFixedRows: this.grid._selectedFixedRows, owner: this, manual: false });
					if (noCancel) {
						this.deselectRow(y - this.y_exclude_current);
						this._trigger(this.events.rowSelectionChanged, event, { row: currentRow, selectedRows: this.grid._selectedRows, selectedFixedRows: this.grid._selectedFixedRows, owner: this, manual: false });
					}
					noCancel = true;
				} else {
					this._ctrlSelect = true;
					this._selectInternal(null, y - this.y_exclude_current);
					this._ctrlSelect = false;
				}
			} else if (event.keyCode === $.ui.keyCode.DOWN) {
				// go to the next row
				//if (!this.grid.options.virtualization) {
				nextY = y + 1;
				//}
				if (this._realActiveRow !== null && this._realActiveRow !== undefined && this.options.multipleSelection === true && this.grid._selectedRows.length > 1 && !event.shiftKey && !event.ctrlKey && this._isContinuous) {
					nextY = this._realActiveRow.index + 1 + this.y_exclude_current;
				}
				if (!v) {
					if (nextY - this.y_exclude_current > rowCount - 1 && this.options.wrapAround === true) {
						nextY = this.y_exclude_current;
					} else if (nextY - this.y_exclude_current > rowCount - 1 && this.options.wrapAround === false) {
						//nextY = y;
						if (this._hc && !this.options.skipChildren) {
							this._activateNextGrid(null, true); // activate the next grid, going down 
						}
						return;
					}
				}
			} else if (event.keyCode === $.ui.keyCode.UP) {
				// go to the prev. row
				nextY = y - 1;
				if (this._realActiveRow !== null && this._realActiveRow !== undefined && this.options.multipleSelection === true && this.grid._selectedRows.length > 1 && !event.shiftKey && !event.ctrlKey && this._isContinuous) {
					nextY = this._realActiveRow.index - 1 + this.y_exclude_current;
				}
				if (!v) {
					if (nextY - this.y_exclude_current < 0 && this.options.wrapAround === true) {
						nextY = rowCount - 1;
					} else if (nextY - this.y_exclude_current < 0 && this.options.wrapAround === false) {
						//nextY = y;
						if (this._hc && !this.options.skipChildren) {
							this._activateNextGrid(null, false); // activate the previous grid, going up 
						}
						return;
					}
				}
			} else {
				return;
			}
			// get the new cell
			event.preventDefault();
			event.stopPropagation();
			//nextY = this._adjustVirtualVerticalPosition(nextY);
			if (v && !c && nextY >= this.grid._virtualRowCount) {
				// L.A. 23 August 2012 Fixing bug #119476 When virtualization is enabled the selection via the arrow keys of the keyboard 
				// is not working for the non-visible part of the grid
				nextY = this.grid._virtualRowCount - 1;
				newRow = this.grid.rowAt(nextY - this.y_exclude_current);
				this._setScrollTop(this.grid.element.parent(), newRow, nextY >= y ? 'down' : 'up', nextY - this.y_exclude_current);
			} else if (v && !c && nextY < 0 && sri > 0) {
				// L.A. 23 August 2012 Fixing bug #119476 When virtualization is enabled the selection via the arrow keys of the keyboard 
				// is not working for the non-visible part of the grid
				nextY = -1;
				newRow = this.grid.rowAt(nextY);
				this._setScrollTop(this.grid.element.parent(), newRow, 'up', nextY - this.y_exclude_current);
			} else if (!(v && !c && nextY < 0)) {
				// virtualization & selection does not support wrapping around
				newRow = this.grid.rowAt(nextY);
			} else {
				return;
			}
			if (newRow === undefined || newRow.length > 1) {
				return;
			}
			// L.A. 23 October 2012 - Merging bug #91157 from 11.2
			while (newRow && !$(newRow).is(":visible") && nextY > 0 && nextY < rowCount - 1) {
				newRow = this.grid.rowAt(event.keyCode === $.ui.keyCode.UP ? --nextY : ++nextY);
			}
			if (!v || c) {
				this._setScrollTop(this.grid.element.parent(), newRow, nextY >= y ? 'down' : 'up', nextY - this.y_exclude_current);
				if (c) {
					if (sri !== this.grid._startRowIndex) {
						nextY = nextY + (nextY >= y ? -1 : 1) * Math.abs(this.grid._startRowIndex - sri);
						sri = this.grid._startRowIndex;
					}
					newRow = this.grid.rowAt(nextY);
				}
			}
			if (event.keyCode !== $.ui.keyCode.ENTER && event.keyCode !== $.ui.keyCode.SPACE) {
				$(currentRow.element).removeClass(this.css.activeRow);
				if (v) {
					newRowObject = { element: $(newRow), index: nextY + sri - this.y_exclude_current };
				} else {
					newRowObject = { element: $(newRow), index: nextY - this.y_exclude_current };
				}
				if (event.ctrlKey && this.activeRow() && this.activeRow().index !== newRowObject.index) {
					this._activateRow(newRowObject, event);
				}
				if (!event.ctrlKey && event.shiftKey && this.options.multipleSelection === true) {
					this._shiftRowSelection(newRowObject, false, true, currentRow, event);
				} else if (!event.ctrlKey) {
					noCancel = this._trigger(this.events.rowSelectionChanging, event, { row: newRowObject, selectedRows: this.grid._selectedRows, selectedFixedRows: this.grid._selectedFixedRows, owner: this, manual: false });
					if (noCancel) {
						this.clearSelection(true);
						this._selectInternal(null, nextY - this.y_exclude_current);
						this._trigger(this.events.rowSelectionChanged, event, { row: newRowObject, selectedRows: this.grid._selectedRows, selectedFixedRows: this.grid._selectedFixedRows, owner: this, manual: false });
					}
				}
			}
		},
		//A.T: what about navigating across layouts (in the same level ???) 
		_activateNextGrid: function (event, goingDown, levelDown) {
			// we need to determine whether there is an immediate next/prev expanded parent container. if there isn't, we don't do anything
			// return true if we are navigating to the next grid, otherwise the usual navigateCell/Row takes over 
			var target, nextTarget, currentGrid = this.grid.container(), reset = true;
			if (this.options.mode === "row") {
				target = this.activeRow().element;
			} else {
				target = $(this.activeCell().element).closest("tr");
			}
			if (event !== null || levelDown === true) {
				if (!event) {
					event = { keyCode: goingDown ? $.ui.keyCode.DOWN : $.ui.keyCode.UP };
				}
				if (event.keyCode === $.ui.keyCode.UP) {
					nextTarget = target.prev();
					if (nextTarget.attr("data-container") && nextTarget.is(":visible")) {
						// get the last grid from the list of child grilds, activate and select its first cell or row, and clear the rest of the selection
						nextTarget = nextTarget.find(".ui-iggrid-table").last();
					} else {
						return false;
					}
				} else {
					// down
					nextTarget = target.next();
					if (nextTarget.attr("data-container") && nextTarget.is(":visible")) {
						// get the first grid from the list of child grids, activate and select its first cell or row, and clear the rest of the selection
						nextTarget = nextTarget.find(".ui-iggrid-table").first();
					} else {
						return false;
					}
				}
			} else {
				// there are two cases, in priority:
				// 1. sibling child grid (when there is more than one column layout)
				// 2. up level grid row/cell, which can be either above or below the current grid 
				if (goingDown) {
					if (currentGrid.next().length > 0) {
						nextTarget = currentGrid.nextAll(".ui-iggrid").first().children(".ui-iggrid-table");
					} else {
						// try to go up by one level and select the next row (down) in the upper grid
						nextTarget = currentGrid.closest("tr:[data-container=true]").next();
						reset = false;
					}
				} else {
					if (currentGrid.prev().length > 0) {
						nextTarget = currentGrid.prevAll(".ui-iggrid").first().children(".ui-iggrid-table");
					} else {
						// try to go up by one level and select the previous row (up) in the upper grid
						nextTarget = currentGrid.closest("tr:[data-container=true]").prev();
						reset = false;
					}
				}
			}
			this.clearSelection(false, true); // clear the selection of the current grid
			if (reset) {
				if (this.options.mode === "row") {
					if (goingDown !== undefined && !goingDown) {
						nextTarget.igGridSelection("selectRow", nextTarget.find(".ui-iggrid-tablebody > tr").last().index());
					} else {
						nextTarget.igGridSelection("selectRow", 0);
					}
				} else {
					if (goingDown !== undefined && !goingDown) {
						nextTarget.igGridSelection("selectCell", nextTarget.find(".ui-iggrid-tablebody > tr").last().index(), 0);
					} else {
						nextTarget.igGridSelection("selectCell", 0, 0);
					}
				}
			} else if (nextTarget && nextTarget.length > 0) {
				if (this.options.mode === "row") {
					nextTarget.closest(".ui-iggrid-table").igGridSelection("selectRow", nextTarget.index());
				} else {
					nextTarget.closest(".ui-iggrid-table").igGridSelection("selectCell", nextTarget.index(), 0);
				}
			}
			// focus the child grid so that keyboard navigation can continue
			nextTarget.closest(".ui-iggrid").focus();
			return true;
		},
		_setScrollTop: function (parent, child, direction, index) {
			var parentOffset = parent.offset(), childOffset = $(child).offset(), childh, isDown, isUp, v, c, st;
			if (!child) {
				return;
			}
			v = (this.grid.options.virtualization || this.grid.options.rowVirtualization);
			c = v && this.grid.options.virtualizationMode === "continuous";
			childh = v && !c ? parseInt(this.grid.options.avgRowHeight, 10) : $(child).outerHeight();
			if (!v || c) {
				isDown = childOffset.top + childh + this.grid._scrollbarWidth() > parentOffset.top + $(parent).outerHeight();
				isUp = childOffset.top < parentOffset.top || (c && index < 0);
			} else {
				isDown = childh * (index + 1) >= parseInt(this.grid.options.height, 10);
				isUp = index < 0;
			}
			if (index === 0) {
				parent[0].scrollTop = 0;
			} else if (direction === 'down') {
				if (isDown) {
					if (c || !v) {
						st = parent[0].scrollTop + childOffset.top + this.grid._scrollbarWidth() -
							(parentOffset.top + parent.outerHeight()) + $(child).outerHeight();
						if (c) {
							// continuous virtualization
							this.grid._onVirtualVerticalScroll({}, childh, direction);
						} else {
							parent[0].scrollTop = st;
						}
					} else {
						this._scrollVmanual(true);
					}
				}
			} else {
				if (isUp) {
					if (c || !v) {
						st = parent[0].scrollTop - $(child).outerHeight();
						if (c) {
							// continuous virtualization
							this.grid._onVirtualVerticalScroll({}, childh, direction);
						} else {
							parent[0].scrollTop = st;
						}
					} else {
						this._scrollVmanual(false);
					}
				}
			}
		},
		_scrollVmanual: function (down) {
			var sc = $('#' + this.grid.element[0].id + '_scrollContainer'), h = parseInt(this.grid.options.avgRowHeight, 10);
			this.grid._ignoreScroll = true;
			if (down) {
				sc.scrollTop(sc.scrollTop() + h);
			} else {
				sc.scrollTop(sc.scrollTop() - h);
			}
			this.grid._onVirtualVerticalScroll();
			this.grid._ignoreScroll = false;
		},
		_setScrollLeft: function (parent, child, direction, index) {
			var parentOffset = parent.offset(), childOffset = $(child).offset();
			if (!child) {
				return;
			}
			if (index === 0) {
				parent[0].scrollLeft = 0;
			} else if (direction === 'right') {
				if (childOffset.left + $(child).outerWidth() > parentOffset.left + $(parent).outerWidth()) {
					parent[0].scrollLeft = parent[0].scrollLeft + childOffset.left - (parentOffset.left + parent.outerWidth()) + $(child).outerWidth();
				}
			} else {
				if (childOffset.left < parentOffset.left) {
					parent[0].scrollLeft = parent[0].scrollLeft - $(child).outerWidth();
				}
			}
		},
		_isRowSelected: function (y) {
			var i;
			for (i = 0; i < this.grid._selectedRows.length; i++) {
				if (this.grid._selectedRows[i].index === y) {
					return true;
				}
			}
			return false;
		},
		_isRowSelectedByKey: function (key, cache) {
			var del = !!cache, srows = cache || this.grid._selectedRows, i;
			for (i = 0; i < srows.length; i++) {
				if (srows[i].id === key) {
					if (del) {
						$.ig.removeFromArray(srows, i, i);
					}
					return true;
				}
			}
			return false;
		},
		_isCellSelected: function (y, x) {
			var i;
			for (i = 0; i < this.grid._selectedCells.length; i++) {
				if (this.grid._selectedCells[i].index === x && this.grid._selectedCells[i].rowIndex === y) {
					return true;
				}
			}
			return false;
		},
		_isCellSelectedByKey: function (rowKey, colKey, cache) {
			var del = !!cache, scells = cache || this.grid._selectedCells, i;
			for (i = 0; i < scells.length; i++) {
				if ((scells[i].rowId === rowKey && scells[i].columnKey === colKey) ||
					(scells[i].rowId === rowKey && scells[i].columnKey === null && scells[i].index === 0 && colKey === -1)) {
					if (del) {
						$.ig.removeFromArray(scells, i, i);
					}
					return true;
				}
			}
			return false;
		},
		// refreshes selection 
		_rs: function (e, args) {
			//var cells = this.grid._selectedCells, row = this.grid._selectedRows;
			var dom = args.dom, i = 0, j = 0, ac = this.activeCell(), ar = this.activeRow(), rows = this.grid.rows(),
				sri = this.grid._startRowIndex || 0, sci = this.grid._startColIndex, dataSkip = this._firstRow ? this._firstRow.find("th,[data-skip='true']").length : 0;
			//S.S. Bug #105706 If the function is called for other grids we shouldn't do anything.
			if (this.grid.id() !== args.owner.id()) {
				return;
			}
			//I.I. bug fix for 104635
			//when contunous virtualization the body is recreated whenever more rows are neede, thus all tbody event handlers get lost
			if (this.grid.options.virtualization === true && this.grid.options.virtualizationMode === 'continuous') {
				this._registerTbodyEvents();
			}
			//I.I. bug fix for 104639
			//selected row/cell, active row/cell should be reinitialize, since tbody got recreated and these members point to non existing dom elements
			if (this.grid._selectedCell) {
				this.grid._selectedCell.element = rows.eq(this.grid._selectedCell.rowIndex - sri).children('td').eq(this.grid._selectedCell.index - dataSkip);
				this.grid._selectedCell.row = this.grid._selectedCell.element.parent('tr');
			}

			if (this.grid._selectedRow) {
				this.grid._selectedRow.element = rows.eq(this.grid._selectedRow.index - sri);
			}

			if (this.grid._activeRow) {
				this.grid._activeRow.element = rows.eq(this.grid._activeRow.index - sri);
			}

			if (this.grid._activeCell) {
				this.grid._activeCell.element = rows.eq(this.grid._activeCell.rowIndex - sri).children('td').eq(this.grid._activeCell.index);
				this.grid._activeCell.row = this.grid._activeCell.element.parent('tr');
			}
			if (this.grid._selectedRows && this.grid._selectedRows.length > 0) {
				for (i = 0; i < this.grid._selectedRows.length; i++) {
					this.grid._selectedRows[i].element = rows.eq(this.grid._selectedRows[i].index - sri);
				}
			}
			if (this.grid._selectedCells && this.grid._selectedCells.length > 0) {
				for (i = 0; i < this.grid._selectedCells.length; i++) {
					this.grid._selectedCells[i].element = rows.eq(this.grid._selectedCells[i].rowIndex - sri).children('td').eq(this.grid._selectedCells[i].index - dataSkip);
					this.grid._selectedCells[i].row = this.grid._selectedCells[i].element.parent('tr');
				}
			}

			ac = this.activeCell();
			ar = this.activeRow();
			// we need to return back the styles 
			for (i = 0; i < dom.length; i++) {
				for (j = 0; j < dom[i].length; j++) {
					if (this.options.mode === "cell") {
						if (this.options.multipleSelection) {
							if (this._isCellSelected(i + sri, j + sci + dataSkip)) {
								// add selected style
								$(dom[i][j]).addClass(this.css.selectedCell);
							}
						} else if (this.grid._selectedCell) {
							if (i + sri === this.grid._selectedCell.rowIndex && j + sci + dataSkip === this.grid._selectedCell.index) {
								$(dom[i][j]).addClass(this.css.selectedCell);
							}
						}
					} else {
						if (this.options.multipleSelection) {
							if (this._isRowSelected(i + sri)) {
								// add selected style
								$(dom[i][j]).addClass(this.css.selectedRow);
							}
						} else if (this.grid._selectedRow) {
							if (i + sri === this.grid._selectedRow.index) {
								$(dom[i][j]).addClass(this.css.selectedRow);
							}
						}
					}
				}
			}
			// S.S. March 11, 2013,  Bug #134805 We should reapply active row/cell styling in all browsers
			// Also changing the activeRow logic to apply the style on row level, not for each cell
			//if (!$.ig.util.isFF) {
			if (ac) {
				if (ac.rowIndex - sri >= 0 && ac.rowIndex - sri < dom.length &&
						ac.index - sci - dataSkip > 0 && ac.index - sci - dataSkip < dom[ac.rowIndex - sri].length) {
					$(dom[ac.rowIndex - sri][ac.index - sci - dataSkip]).addClass(this.css.activeCell);
				}
			}
			if (ar) {
				if (ar.index - sri >= 0 && ar.index - sri < dom.length) {
					$(dom[ar.index - sri]).first().closest("tr").addClass(this.css.activeRow);
				}
			}
		},
		// API for programatically selecting rows and cells
		selectCell: function (row, col, isFixed) {
			/* selects a cell by row/col 
				paramType="number" Row index
				paramType="number" Column index
			*/
			var rv = this.grid.options.virtualization || this.grid.options.rowVirtualization,
				cv = this.grid.options.virtualization || this.grid.options.columnVirtualization,
				sri = this.grid._startRowIndex || 0, sci = this.grid._startColIndex || 0;
			if ((rv && (row >= sri + this.grid._virtualRowCount || row < sri)) ||
				(cv && (col >= sci + this.grid._virtualColumnCount || col < sci))) {
				if (this.options.multipleSelection === true) {
					this.grid._selectedCells.push({ index: col, rowIndex: row });
					this.grid._selectedCell = null;
				} else {
					this.clearSelection();
					this._activateCell({ index: col, rowIndex: row }, null, false);
				}
				this.grid._activeCell = { index: col, rowIndex: row };
			} else {
				this._selectInternal(null, row, col, isFixed);
			}
		},
		deselectCell: function (row, col) {
			/* deselects a cell by row/col 
				paramType="number" Row index
				paramType="number" Column index
			*/
			var i;
			// find the cell
			if (this.options.multipleSelection === true) {
				for (i = 0; i < this.selectedCells().length; i++) {
					if (this.selectedCells()[i].index === col && this.selectedCells()[i].rowIndex === row) {
						this._deselectCell(this.selectedCells()[i]);
						//A.T. 8 March 2012 - Fix for bug #104244 
						//this.selectedCells().remove(i);
						$.ig.removeFromArray(this.selectedCells(), i);
						this.grid._selectedCell = null;
						break;
					}
				}
			} else {
				if (this.selectedCell() !== null && this.selectedCell() !== undefined) {
					this._deselectCell(this.selectedCell());
					this.grid._selectedCell = null;
				}
			}
			this._trigger("internalcellselectionchanged", null, { cell: null, selectedCells: this.grid._selectedCells, owner: this });
		},
		selectRow: function (index) {
			/* selects a row by index
				paramType="number" Row index
			*/
			var v = this.grid.options.virtualization || this.grid.options.rowVirtualization, sri = this.grid._startRowIndex || 0;
			if (v && (index >= sri + this.grid._virtualRowCount || index < sri)) {
				if (this.options.multipleSelection === true) {
					this.grid._selectedRows.push({ index: index });
					this.grid._selectedRow = null;
				} else {
					this.clearSelection();
					this.grid._selectedRow = { index: index };
				}
				this._activateRow({ index: index }, null, false);
			} else {
				this._selectInternal(null, index);
			}
		},
		deselectRow: function (index) {
			/* deselects a row by index
				paramType="number" Row index
			*/
			var i, hasFixedColumns = this.grid.hasFixedColumns();
			if (this.options.multipleSelection === true) {
				for (i = 0; i < this.selectedRows().length; i++) {
					if (this.selectedRows()[i].index === index ||
						(this.selectedRows()[i].element && this.selectedRows()[i].element.index() === index)) {
						this._deselectRow(this.selectedRows()[i]);
						//A.T. 8 March 2012 - Fix for bug #104244 
						//this.selectedRows().remove(i);
						$.ig.removeFromArray(this.selectedRows(), i);
						this.grid._selectedRow = null;
						if (hasFixedColumns && this.grid._selectedFixedRows) {
							if (this.grid._selectedFixedRows[i]) {
								this._deselectRow(this.grid._selectedFixedRows[i]);
							}
							$.ig.removeFromArray(this.grid._selectedFixedRows, i);
							this.grid._selectedFixedRow = null;
						}
						break;
					}
				}
			} else {
				if (this.selectedRow() !== null && this.selectedRow() !== undefined) {
					this._deselectRow(this.selectedRow());
					if (hasFixedColumns && this.grid._selectedFixedRow) {
						this._deselectRow(this.grid._selectedFixedRow);
						this.grid._selectedFixedRow = null;
					}
					this.grid._selectedRow = null;
				}
			}
			this._trigger("internalrowselectionchanged", null, { row: null, selectedRows: this.grid._selectedRows, owner: this });
		},
		_deselectRow: function (row) {
			var el;
			if (row.element && row.element instanceof jQuery) {
				el = row.element;
			} else {
				// element may only be unavailable in virtual grids
				el = $(this.grid._virtualDom[row.index]);
			}
			el.removeClass(this.css.selectedRow);
			el.children().removeClass(this.css.selectedCell);
			if (this.grid.hasFixedColumns()) {
				el = this.grid.fixedContainer().find('tbody>tr').eq(el.index());
				el.removeClass(this.css.selectedRow);
				el.children().removeClass(this.css.selectedCell);
			}
		},
		_deselectCell: function (cell) {
			var el;
			if (cell.element && cell.element instanceof jQuery) {
				el = cell.element;
			} else {
				// element may only be unavailable in virtual grids
				el = $(this.grid._virtualDom[cell.rowIndex][cell.index]);
			}
			el.removeClass(this.css.selectedCell);
		},
		_activateCell: function (cell, event, isFixed) {
			var noCancel = true, v = this.grid.options.virtualization || this.grid.options.rowVirtualization,
				sri = this.grid._startRowIndex || 0;
			noCancel = this._trigger(this.events.activeCellChanging, event, { cell: cell, owner: this });

			if (noCancel) {
				if (this.activeCell()) {
					if (v) {
						$(this.grid.cellAt(this.grid._activeCell.index,
							this.grid._activeCell.rowIndex - sri)).removeClass(this.css.activeCell);
					} else {
						$(this.activeCell().element).removeClass(this.css.activeCell);
					}
				}
				if (this.activeRow()) {
					if (v) {
						$(this.grid.rowAt(this.grid._activeRow.index - sri)).removeClass(this.css.activeRow);
					} else {
						$(this.activeRow().element).removeClass(this.css.activeRow);
					}
					this.activeRow(null);
				}
				this.activeCell(cell);
				$(this.activeCell().element).addClass(this.css.activeCell);
				this._trigger(this.events.activeCellChanged, event, { cell: cell, owner: this });
			}
		},
		_activateRow: function (row, event, fixedRow) {
			var noCancel = true, v = this.grid.options.virtualization || this.grid.options.rowVirtualization, sri = this.grid._startRowIndex || 0;
			noCancel = this._trigger(this.events.activeRowChanging, event, { row: row, owner: this });
			if (noCancel) {
				if (this.activeRow()) {
					if (v) {
						$(this.grid.rowAt(this.grid._activeRow.index - sri)).removeClass(this.css.activeRow);
					} else {
						$(this.activeRow().element).removeClass(this.css.activeRow);
					}
				}
				if (this.activeFixedRow()) {
					//if (v) {
					//	$(this.grid.rowAt(this.grid._activeRow.index - this.grid._startRowIndex)).removeClass(this.css.activeRow);
					//} else {
					$(this.activeFixedRow().element).removeClass(this.css.activeRow);
					//}
				}
				if (this.activeCell()) {
					if (v) {
						$(this.grid.cellAt(this.grid._activeCell.index,
							this.grid._activeCell.rowIndex - sri)).removeClass(this.css.activeCell);
					} else {
						$(this.activeCell().element).removeClass(this.css.activeCell);
					}
					this.activeCell(null);
				}
				this.activeRow(row);
				//if (v) {
				//	$(this.grid.rowAt(this.grid._activeRow.index - this.grid._startRowIndex)).addClass(this.css.activeRow);
				//} else {
				if (fixedRow) {
					$(fixedRow.element).addClass(this.css.activeRow);
					this.activeFixedRow(fixedRow);
				}
				$(this.activeRow().element).addClass(this.css.activeRow);
				//}
				this._trigger(this.events.activeRowChanged, event, { row: row, owner: this });
			}
		},
		// API - should we have both (cells vs. cell) or only the multiple: and in case of single it will return only one object? 
		// returns an array of $.ig.GridCell objects
		selectedCells: function () {
			/* returns an array of selected cells where every objects has the format {element: , row: , index: , rowIndex: , columnKey: }
				returnType="array"
			*/
			return this.grid._selectedCells;
		},
		// returns an array of $.ig.GridRow objects
		selectedRows: function () {
			/* returns an array of selected rows where every object has the format {element: , index: }
				returnType="array"
			*/
			return this.grid._selectedRows;
		},
		selectedFixedCells: function () {
			/* returns an array of selected fixed cells where every objects has the format {element: , row: , index: , rowIndex: , columnKey: }
				returnType="array"
			*/
			return this.grid._selectedFixedCells;
		},
		// returns an array of $.ig.GridRow objects
		selectedFixedRows: function () {
			/* returns an array of selected fixed rows where every object has the format {element: , index: }
				returnType="array"
			*/
			return this.grid._selectedFixedRows;
		},
		// returns an instance of $.ig.GridCell
		selectedCell: function () {
			/* returns the currently selected cell that has the format {element: , row: , index: , rowIndex: , columnKey: }, if any. If multiple selection is enabled, will return null 
				returnType="object"
			*/
			return this.grid._selectedCell;
		},
		// returns an instance of $.ig.GridRow
		selectedRow: function () {
			/* returns the currently selected row that has the format {element: , index: }, if any. If multiple selection is enabled, will return null 
				returnType="object"
			*/
			return this.grid._selectedRow;
		},
		// returns an instance of $.ig.GridRow
		selectedFixedRow: function () {
			/* returns the currently selected fixed row that has the format {element: , index: }, if any. If multiple selection is enabled, will return null 
				returnType="object"
			*/
			return this.grid._selectedFixedRow;
		},
		// returns an instance of $.ig.GridCell
		activeCell: function (cell) {
			/* returns the currently active (focused) cell that has the format {element: , row: , index: , rowIndex: , columnKey: }, if any.
				returnType="object"
			*/
			if (cell !== undefined) {
				this.grid._activeCell = cell;
			} else {
				return this.grid._activeCell;
			}
		},
		activeRow: function (row) {
			/* returns the currently active (focused) row that has the format {element: , index: }, if any.
				returnType="object"
			*/
			if (row !== undefined) {
				this.grid._activeRow = row;
			} else {
				return this.grid._activeRow;
			}
		},
		activeFixedRow: function (row) {
			/* returns the currently active (focused) fixed row that has the format {element: , index: }, if any.
				returnType="object"
			*/
			if (row !== undefined) {
				this.grid._activeFixedRow = row;
			} else {
				return this.grid._activeFixedRow;
			}
		},
		clearSelection: function (internal, uiDirty) {
			/* clears all selected cells, selected rows, active cell and active row. Also updates the UI accordingly 
				paramType="bool" excluded="true"
				paramType="bool" excluded="true"
			*/
			// clear selected cells
			var i, v = this.grid.options.virtualization || this.grid.options.rowVirtualization,
                hasFixedColumns = this.grid.hasFixedColumns();
			for (i = 0; i < this.grid._selectedCells.length; i++) {
				if (!v) {
					this.grid._selectedCells[i].element.removeClass(this.css.selectedCell);
				} else if (v && this.grid._selectedCells[i].rowIndex - this.grid._startRowIndex >= 0) {
					$(this.grid.cellAt(this.grid._selectedCells[i].index, this.grid._selectedCells[i].rowIndex - this.grid._startRowIndex)).removeClass(this.css.selectedCell);
				}
			}
			if (hasFixedColumns) {
				for (i = 0; i < this.grid._selectedFixedCells.length; i++) {
					if (!v || (v && this.grid._selectedFixedCells[i].rowIndex - this.grid._startRowIndex >= 0)) {
						this.grid._selectedFixedCells[i].element.removeClass(this.css.selectedCell);
					}
				}
				this.grid._selectedFixedCells = [];

				for (i = 0; i < this.grid._selectedFixedRows.length; i++) {
					if (!v || (v && this.grid._selectedFixedRows[i].index - this.grid._startRowIndex >= 0)) {
						$(this.grid._selectedFixedRows[i].element.children()).removeClass(this.css.selectedCell);
					}
				}
				this.grid._selectedFixedRows = [];

				if (this.grid._selectedFixedRow !== null && this.grid._selectedFixedRow !== undefined) {
					if (v && this.grid._selectedFixedRow.index - this.grid._startRowIndex >= 0) {
						$(this.grid.rowAt(this.grid._selectedFixedRow.index - this.grid._startRowIndex)).children().removeClass(this.css.selectedCell);
					} else {
						$(this.grid._selectedFixedRow.element.children()).removeClass(this.css.selectedCell);
					}
					this.grid._selectedFixedRow = null;
				}
				// clear selected cell (single)
				if (this.grid._selectedFixedCell !== null && this.grid._selectedFixedCell !== undefined) {
					if (v && this.grid._selectedFixedCell.rowIndex - this.grid._startRowIndex >= 0) {
						$(this.grid.cellAt(this.grid._selectedFixedCell.index, this.grid._selectedCell.rowIndex - this.grid._startRowIndex)).removeClass(this.css.selectedCell);
					} else {
						this.grid._selectedFixedCell.element.removeClass(this.css.selectedCell);
					}
					this.grid._selectedFixedCell = null;
				}
			}
			this.grid._selectedCells = [];
			// clear selected rows
			for (i = 0; i < this.grid._selectedRows.length; i++) {
				if (!v) {
					$(this.grid._selectedRows[i].element.children()).removeClass(this.css.selectedCell);
				} else if (v && this.grid._selectedRows[i].index - this.grid._startRowIndex >= 0) {
					$(this.grid.rowAt(this.grid._selectedRows[i].index - this.grid._startRowIndex)).children().removeClass(this.css.selectedCell);
				}
			}
			this.grid._selectedRows = [];
			// clear selected row (single)
			if (this.grid._selectedRow !== null && this.grid._selectedRow !== undefined) {
				if (v && this.grid._selectedRow.index - this.grid._startRowIndex >= 0) {
					$(this.grid.rowAt(this.grid._selectedRow.index - this.grid._startRowIndex)).children().removeClass(this.css.selectedCell);
				} else {
					$(this.grid._selectedRow.element.children()).removeClass(this.css.selectedCell);
				}
				this.grid._selectedRow = null;
			}
			// clear selected cell (single)
			if (this.grid._selectedCell !== null && this.grid._selectedCell !== undefined) {
				if (v && this.grid._selectedCell.rowIndex - this.grid._startRowIndex >= 0) {
					$(this.grid.cellAt(this.grid._selectedCell.index, this.grid._selectedCell.rowIndex - this.grid._startRowIndex)).removeClass(this.css.selectedCell);
				} else {
					this.grid._selectedCell.element.removeClass(this.css.selectedCell);
				}
				this.grid._selectedCell = null;
			}
			if (!internal) {
				if (this.activeCell()) {
					if (v) {
						$(this.grid.cellAt(this.grid._activeCell.index,
							this.grid._activeCell.rowIndex - this.grid._startRowIndex)).removeClass(this.css.activeCell);
					} else {
						this.activeCell().element.removeClass(this.css.activeCell);
					}
					this.activeCell(null);
				}
				if (this._realActiveCell) {
					this._realActiveCell.element.removeClass(this.css.activeCell);
					this._realActiveCell = null;
				}
				if (this._realActiveRow) {
					this._realActiveRow.element.removeClass(this.css.activeRow);
					this._realActiveRow = null;
				}
				if (this.activeRow()) {
					if (v) {
						$(this.grid.rowAt(this.grid._activeRow.index - this.grid._startRowIndex)).removeClass(this.css.activeRow);
					} else {
						this.activeRow().element.removeClass(this.css.activeRow);
					}
					this.activeRow(null);
				}
			}
			if (uiDirty) {
				this.activeCell(null);
				this.activeRow(null);
			}
			// trigger internal event that selection has been cleared
			this._trigger("selectioncleared", this, { owner: this.grid, uiDirty: uiDirty });
		},
		// clear selection for the current grid, including all child grids that are part of the current hierarchical grid
		clearSelectionAllChildren: function (internal, uiDirty) {
			/*Clears the selection of the child grids of the current grid.
			*/
			var children = this.grid.children(), i, sel;
			for (i = 0; i < children.length; i++) {
				sel = $(children[i]).data("igGridSelection");
				if (sel) {
					sel.clearSelection(internal, uiDirty);
				}
			}
		},
		clearSelectionAll: function (internal, uiDirty) {
			/*Clears the selection of the current grid and its child grids.
			*/

			this.clearSelection(internal, uiDirty);
			this.clearSelectionAllOthers(internal, uiDirty);
		},
		clearSelectionAllOthers: function (internal, uiDirty) {
			/* Clears the selection on all other grids recursively, that are part of the hierarchical grid, excluding the current one.
			*/
			// find the hierarchical grid
			var hgrid, children, i, sel, rootSel;
			if (!this._hgrid) {
				if (this.grid.element.hasClass("ui-iggrid-root")) {
					hgrid = this.grid.element.data('igHierarchicalGrid');
				} else {
					hgrid = this.grid.element.closest('.ui-iggrid-root').data('igHierarchicalGrid');
				}
			} else {
				hgrid = this._hgrid.data('igHierarchicalGrid');
			}
			if (hgrid) {
				children = hgrid.allChildren();
				for (i = 0; i < children.length; i++) {
					sel = $(children[i]).data("igGridSelection");
					if (sel && $(children[i]).attr('id') !== this.grid.element.attr('id')) {
						sel.clearSelection(internal, uiDirty);
					}
				}
			}
			if ((hgrid.element.attr('id') !== this.grid.element.attr('id') && hgrid.element.is("table")) ||
				(hgrid.element.is("div") && $("#" + hgrid.element.attr("id") + "_table").attr('id') !== this.grid.element.attr('id'))) {
				// also clear the root level selection
				if (!hgrid.element.is("table")) {
					rootSel = $("#" + hgrid.element.attr("id") + "_table").data("igGridSelection");
				} else {
					rootSel = hgrid.element.data("igGridSelection");
				}
				// M.P. 15 July 2013: fix for bug: 146517
				if (rootSel) {
					rootSel.clearSelection(internal, uiDirty);
				}
			}
		},
		_excludeRows: function (element) {
			//var index = element.index();
			//return this.grid.element.find('tbody tr:lt(' + index + ')').find("[data-container=true]").length;
			return this.grid.element.children("tbody").children("tr:[data-container=true]").length;
		},
		// in the context of the hierarchical grid, returns the rows that are up to index "i", which should be excluded
		// from calculations
		_excludeRowsLt: function (element) {
			var index = element.index();
			return this.grid.element.children('tbody').children('tr:lt(' + index + ')').filter('[data-container=true]').length;
		},
		_calcExtraCells: function () {
			// S.S. November 30th, 2011, Bug #95307 We need to ensure the calculation is based on what is in the TBODY, as
			// especially after paging the code was returning results for TFOOT where Row Selector cells do have the data-skip
			// attribute. This made selection fall behind with one column after paging and when TFOOT has markup in it (e.g.
			// from Summaries).
			return this.grid.element.find("tbody > tr > td[data-skip=true]").first().parent().find("[data-skip=true]").length;
		},
		_columnsCollectionModified: function (evt, ui) {
			if (ui.owner.id() === this.grid.id()) {
				this._registerTbodyEvents();
			}
		},
		_columnFixed: function (args) {
			var i, rows = [], cells = [];
			// M.H. 1 Mar 2013 Fix for bug #134495: If a row is selected fixing a column removes the selected and active style from the cell.
			if (args.isFixed) {
				if (args.isInit) {
					// register events
					this._registerFixedTbodyEvents();
					// we should set selected rows/cells(if necessary) for when fixing for the first time because
					// cells are NOT re-attached but markup for fixed column is re-generated. This is done because performance issues
					// for the second time when it is fixing column - columns are detached and reattached
					if (this.options.mode === 'row') {
						if (this.grid.selectedRows().length > 0) {
							rows = this.grid.selectedRows().clone();
						} else if (this.grid.selectedRow() !== null) {
							rows = [this.grid.selectedRow()];
						}
						if (rows.length > 0) {
							this.clearSelection(false);
							for (i = 0; i < rows.length; i++) {
								this.selectRow(rows[i].index);
							}
						}
					}
				}
			}

			if (this.grid.selectedCells().length > 0) {
				cells = this.grid.selectedCells();
			} else if (this.grid.selectedCell() !== null) {
				cells = [this.grid.selectedCell()];
			}
			for (i = 0; i < cells.length; i++) {
				if (this.grid.columnByKey(cells[i].columnKey).fixed !== cells[i].isFixed) {
					cells[i].isFixed = !cells[i].isFixed;
				}
			}
			// M.H. 11 Jun 2013 Fix for bug #143606: When you fix columns, select a cell from the unfixed area and you call activeCell method the object has the wrong columnKey.
			if (this.grid._activeCell) {
				this.grid._activeCell.index = this.grid._activeCell.element.index();
				// M.H. 22 Jul 2013 Fix for bug #143606: When you fix columns, select a cell from the unfixed area and you call activeCell method the object has the wrong columnKey.
				this.grid._activeCell.isFixed = this.grid._isFixedElement(this.grid._activeCell.element);
			}
		},
		_buildSelectionCache: function () {
			if (this.options.persist) {
				this._scc = [];
				this._src = [];
				this._srcf = [];
				if (this.options.multipleSelection === true &&
					(this.grid._selectedCells.length > 0 || this.grid._selectedRows.length > 0)) {
					jQuery.extend(this._scc, this.grid._selectedCells);
					jQuery.extend(this._src, this.grid._selectedRows);
					jQuery.extend(this._srcf, this.grid._selectedFixedRows);
				}
				if (this.grid._selectedCell && this.grid._selectedCells.length === 0) {
					this._scc.push(this.grid._selectedCell);
				}
				if (this.grid._selectedRow && this.grid._selectedCells.length === 0) {
					this._src.push(this.grid._selectedRow);
				}
				if (this.grid._selectedFixedRow && this.grid._selectedFixedRows.length === 0) {
					this._srcf.push(this.grid._selectedFixedRow);
				}
			}
		},
		_createUidForData: function () {
			var i = 0, ds = this.grid.dataSource ? this.grid.dataSource._data : [];
			for (i = 0; i < ds.length; i++) {
				if (!ds[i].ig_pk) {
					ds[i].ig_pk = $.ig.util.getCheckSumForObject(ds[i]);
				}
			}
		},
		_removeSelectionCache: function () {
			if (this._scc) {
				delete this._scc;
			}
			if (this._src) {
				delete this._src;
			}
			if (this._srcf) {
				delete this._srcf;
			}
		},
		destroy: function () {
			/*Destroys the selection widget.
			*/
			this.clearSelection();
			this._unregisterEvents();
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		_onUIDirty: function (e, args) {
			// if selection itself has triggered the event, return
			// A.T. 23 Aug 2011 - add additional checks so that events don't propagate across hierarchical grids
			if (args.owner === this || args.owner.element[0].id !== this.element[0].id) {
				return;
			}
			// reset row count
			if (!this.grid.options.virtualization && !this.grid.options.rowVirtualization) {
				this._rowCount = this.grid.dataSource.dataView().length;
			}
			if (this._groupBy) {
				// include all grouped rows
				// L.A. 23 October 2012 - Fixing bug #124887 
				// The selection is applied on the hidden rows when collapse a grouped row and 
				// change the selection using the keyboard navigation
				this._rowCount += this.grid.element.children('tbody').children('tr[data-grouprow=true]').length;
			}
			if (!this.options.persist) {
			this.clearSelection(true, true);
			}
		},
		// every grid feature widget should implement this 
		_injectGrid: function (gridInstance, isRebind) {
			var i;
			this.grid = gridInstance;
			if (!isRebind || !this.options.persist) {
			this.activeCell(null);
			this.grid._selectedCell = null;
			this.grid._selectedRow = null;
			this.activeRow(null);
			this.grid._selectedCells = [];
			this.grid._selectedRows = [];
			this.grid._selectedFixedCells = [];
			this.grid._selectedFixedRows = [];
			}
			// selection is always inheritable ! 
			for (i = 0; i < this.grid.options.features.length; i++) {
				if (this.grid.options.features[i].name === "Selection") {
					this.grid.options.features[i].inherit = true;
				}
				if (this.grid.options.features[i].name === "RowSelectors") {
					if (this.grid.options.features[i].enableCheckBoxes === true) {
						this.options.mode = "row";
					}
				}
			}
			/* peristence will generate unique keys if no pk is defined
			if (this.options.persist && !this.grid.options.primaryKey) {
				throw new Error($.ig.GridSelection.locale.persistenceImpossible);
			}*/
			if (this._virtualRecordsRendererHandler !== null && this._virtualRecordsRendererHandler !== undefined) {
				this.grid.element.unbind('iggridvirtualrecordsrender', this._virtualRecordsRendererHandler);
			}
			// M.H. 29 Oct 2012 Fix for bug #120642
			this._virtualRecordsRendererHandler = $.proxy(this._rs, this);
			this.grid.element.bind('iggridvirtualrecordsrender', this._virtualRecordsRendererHandler);
			if (this._uiDirtyHandler !== null && this._uiDirtyHandler !== undefined) {
				this.grid.element.unbind('iggriduisoftdirty', this._uiDirtyHandler);
			}
			this._uiDirtyHandler = $.proxy(this._onUIDirty, this);
			this.grid.element.bind('iggriduisoftdirty', this._uiDirtyHandler);
			// M.H. 4 Dec 2013 Fix for bug #158542: Memory Leak in IE8 when calling dataBind
			// we should unbind events before dataRendered internal event is fired
			// because in grid framework in _renderData the tbody is populated with the new html(using innerHTML). Using this technique if event handlers are not removed causes memory leaks
			if (this._dataRenderingHandler !== null && this._dataRenderingHandler !== undefined) {
				this.grid.element.unbind('iggriddatarendering', this._dataRenderingHandler);
			}
			this._dataRenderingHandler = $.proxy(this._dataRendering, this);
			this.grid.element.bind('iggriddatarendering', this._dataRenderingHandler);
			if (this._rowExpandedHandler !== null && this._rowExpandedHandler !== undefined) {
				this.grid.element.unbind('ighierarchicalgridrowexpanded', this._rowExpandedHandler);
			}
			this._rowExpandedHandler = $.proxy(this._rowExpanded, this);
			this.grid.element.bind('ighierarchicalgridrowexpanded', this._rowExpandedHandler);
			// M.H. 12 Jun 2013 Fix for bug #144027: JavaScript error when hiding a column, opening the hiding dropdown from the column header, and clicking on the column header to sort it afterwards
			if (this._columnsCollectionModifiedHandler !== null && this._columnsCollectionModifiedHandler !== undefined) {
				this.grid.element.unbind('iggridcolumnscollectionmodified', this._columnsCollectionModifiedHandler);
			}
			this._columnsCollectionModifiedHandler = $.proxy(this._columnsCollectionModified, this);
			this.grid.element.bind('iggridcolumnscollectionmodified', this._columnsCollectionModifiedHandler);
			this._hdirty = true;
			// persistence requires cell rendering to be rewritten
			if (this.options.persist && !isRebind) {
				this.grid._cellStyleSubscribers.push(this.options.mode === "row" ?
					$.proxy(this._applyRowStyle, this) :
					$.proxy(this._applyCellStyle, this));
			}
			//this.grid.element.bind('iggriduidirty', this._uiDirtyHandler);
		}
	});
	$.extend($.ui.igGridSelection, { version: '14.1.20141.2249' });

}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid Sorting 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {
	// we will define a new widget for sorting. That kind of widget is completely independent one and doesn't subclass the grid 
	// it subscribes to grid events such as BodyRendering/BodyRendered, and has the grid instance (igGrid) injected into it
	// for sorting the this.element[0] will be the TR hosting the <TH>s 
	$.widget("ui.igGridSorting", {
		/* igGridSorting widget -  The widget is pluggable to the element where the grid is instantiated and the actual igGrid object doesn't know about this
			the sorting widget just attaches its functionality to the grid
			it supports single and multiple column sorting, with predefined sorting settings specified on a per column basis
			the sorted column headers have spefific appearance and icons applied based on the current sorting condition applied, also the column cells can receive special styling (configurable)
			the widget also implements has full keyboard support with the TAB , SPACE/ENTER keys. 
		*/
		css: {
			/* classes applied to a sortable column header */
			"sortableColumnHeader": "ui-iggrid-sortableheader ui-state-default",
			/* classes appied to a sortable header when it's active (navigated with keyboard / clicked) */
			"sortableColumnHeaderActive": "ui-iggrid-sortableheaderactive ui-state-active",
			/* classes applied to a sortable column header when it is hovered */
			"sortableColumnHeaderHover": "ui-iggrid-sortableheaderhover ui-state-hover",
			/* classes applied to the sortable column header when it has focus */
			"sortableColumnHeaderFocus": "ui-iggrid-sortableheaderfocus ui-state-focus",
			/* classes applied to a column header when it's sorted ascending */
			"ascendingColumnHeader": "ui-iggrid-colheaderasc",
			/* classes applied to a column header when it's sorted descending */
			"descendingColumnHeader": "ui-iggrid-colheaderdesc",
			/* classes applied to a column's cells when it's sorted ascending */
			"ascendingColumn": "ui-iggrid-colasc ui-state-highlight",
			/* classes applied to a column's cells when it's sorted descending */
			"descendingColumn": "ui-iggrid-coldesc ui-state-highlight",
			/* classes applied to the sorting indicator SPAN rendered inside the column header */
			"sortIndicator": "ui-iggrid-colindicator",
			/* classes applied to the ascending sorting indicator in feature chooser */
			"fcSortIndicatorAscending": "ui-iggrid-featurechooser-li-iconcontainer ui-icon ui-iggrid-icon-sort-a-z",
			/* classes applied to the descending sorting indicator in feature chooser */
			"fcSortIndicatorDescending": "ui-iggrid-featurechooser-li-iconcontainer ui-icon ui-iggrid-icon-sort-z-a",
			/* classes applied to the sorting indicator span when it's in ascending state */
			"sortIndicatorAscending": "ui-iggrid-colindicator-asc ui-icon ui-icon-arrowthick-1-n",
			/* classes applied to the sorting indicator span when it's in descending state */
			"sortIndicatorDescending": "ui-iggrid-colindicator-desc ui-icon ui-icon-arrowthick-1-s",
			/* classes applied to container of sorted columns in multiple sorting dialog */
			"dialogSortedColumns": "ui-iggrid-sorting-dialog-sortedcolumns",
			/* classes applied to container of unsorted columns in multiple sorting dialog */
			"dialogUnsortedColumns": "ui-iggrid-sorting-dialog-unsortedcolumns",
			/* classes applied to sort button for each colum in multiple sorting dialog */
			"dialogUnsortedColumnsSortByButton": "ui-iggrid-sorting-dialog-unsortedcolumns-sortbybutton",
			/* classes applied to ascending/descending button in multiple sorting dialog */
			"dialogAsdDescButton": "ui-iggrid-sorting-dialog-ascdescbutton",
			/* classes applied to sort by button in multiple sorting dialog */
			"modalDialogSortByColumn": "ui-iggrid-sorting-dialog-sortbybutton",
			/* classes applied to list item for each sorted column in multiple sorting dialog */
			"dialogSortedColumnsItem": "ui-widget-content",
			/* classes applied to list item for each unsorted column in multiple sorting dialog */
			"dialogUnsortedColumnsItem": "ui-widget-content",
			/* classes applied to ascending button for sorted column in multiple sorting dialog */
			"dialogButtonAsc": "ui-button ui-corner-all ui-button-icon-only ig-sorting-indicator",
			/* classes applied to ascending button icon for sorted column in multiple sorting dialog */
			"dialogButtonAscIcon": 'ui-button-icon-primary ui-icon ui-icon-arrowthick-1-n',
			/* classes applied to descending button icon for sorted column in multiple sorting dialog */
			"dialogButtonDesc": "ui-button ui-corner-all ui-button-icon-only ig-sorting-indicator",
			/* classes applied to descending button icon for sorted column in multiple sorting dialog */
			"dialogButtonDescIcon": 'ui-button-icon-primary ui-icon ui-icon-arrowthick-1-s',
			/* classes applied to remove sorting button for sorted column in multiple sorting dialog */
			"dialogButtonUnsort": "ui-iggrid-sorting-dialog-sortbybuttons ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only ui-igbutton ui-widget-content ui-igbutton-remove",
			/* classes applied to remove sorting button for sorted column in multiple sorting dialog */
			"dialogButtonUnsortContainer": "ui-button-icon-primary ui-icon ui-icon-circle-close",
			/* classes applied to container which holds sorted column name in multiple sorting dialog */
			"dialogSortedColumnTextContainer": "ui-iggrid-dialog-text",
			/* classes applied to container which holds unsorted column name in multiple sorting dialog */
			"dialogItemText": "ui-iggrid-dialog-text",
//			"dialogButtonSlide": "ui-iggrid-sorting-dialog-button-slide ui-button ui-widget ui-state-default ui-corner-bottom ui-button-icon-only",
//			"dialogButtonSlideContainer": "ui-button-icon-primary ui-icon ui-icon-triangle-1-n",
//			"dialogButtonSlideUp": "ui-icon-triangle-1-s",
//			"dialogSlideArea": "ui-iggrid-multiplesorting-dialog-slide ui-widget-content",
//			"dialogSlideAreaContainer": "ui-iggrid-multiplesorting-dialog-slide-button-container",
			/* classes applied to hovered buttons - e.g. unsort button in multiple sorting dialog */
			"dialogButtonsHover": "ui-state-hover",
			/* Classes applied to the feature chooser icon to show multiple sorting dialog */
			"featureChooserModalDialogIcon": "ui-icon ui-iggrid-icon-multiple-sorting"
		},
		options: {
			/* type="remote|local" Defines local or remote sorting.
			remote type="string"
			local type="string"
			*/
			type: null,
			/* type="bool" Enables or disables the case sensitivity of the sorting. Works only for local sorting */
			caseSensitive: false,
			/* type="bool" Enables/disables special styling for sorted columns. If false, sorted column cells will not have any special sort-related styling
			*/
			applySortedColumnCss: true,
			/* type="string" URL param name which specifies how sorting expressions will be encoded in the URL. Uses OData conventions. ex: ?sort(col1)=asc */
			sortUrlKey: null,
			/* type="string" URL param value for ascending type of sorting. Uses OData conventions. Example: ?sort(col1)=asc */
			sortUrlKeyAscValue: null,
			/* type="string" URL param value for descending type of sorting. Uses OData conventions */
			sortUrlKeyDescValue: null,
			/* type="single|multi" Defines single column sorting or multiple column sorting.
			single type="string"
			multi type="string" if enabled, previous sorted state for columns won't be cleared 
			*/
			mode: "single",
			/* type="function" custom sort function(or name of the function as a string) accepting three parameters - the data to be sorted, an array of data source field definitions, and the direction to sort with (optional). The function should return the sorted data array */
			customSortFunction: null,
			/* type="ascending|descending" Specifies which direction to use on the first click / keydown, if the column hasn't been sorted before 
			ascending type="string"
			descending type="string"
			*/
			firstSortDirection: 'ascending',
			/* type="string" custom sorted column tooltip in jQuery templating format */
			sortedColumnTooltip: $.ig.GridSorting.locale.sortedColumnTooltipFormat,
			/* type="bool" Specifies whether sorting to be applied immediately when click sort/unsort columns in multiple sorting dialog. When it is false Apply button shows and sorting is applied when the button is clicked */
			modalDialogSortOnClick: false,
			/* type="string" Specifies sortby button text for each unsorted column in multiple sorting dialog */
			modalDialogSortByButtonText: $.ig.GridSorting.locale.modalDialogSortByButtonText,
			/* type="string" Specifies sortby button label for each unsorted column in multiple sorting dialog */
			modalDialogResetButtonLabel: $.ig.GridSorting.locale.modalDialogResetButton,
			/* type="string" Specifies caption for each descending sorted column in multiple sorting dialog */
			modalDialogCaptionButtonDesc: $.ig.GridSorting.locale.modalDialogCaptionButtonDesc,
			/* type="string" Specifies caption for each ascending sorted column in multiple sorting dialog */
			modalDialogCaptionButtonAsc: $.ig.GridSorting.locale.modalDialogCaptionButtonAsc,
			/* type="string" Specifies caption for unsort button in multiple sorting dialog */
			modalDialogCaptionButtonUnsort: $.ig.GridSorting.locale.modalDialogCaptionButtonUnsort,
			//dialogButtonSlideCaption: $.ig.GridSorting.locale.modalDialogButtonSlideCaption,
			/* type="number" Specifies width of multiple sorting dialog */
			modalDialogWidth: 350,
			/* type="number|string" Specifies height of multiple sorting dialog 
				string The widget height can be set in pixels (px) and percentage (%).
				number The widget height can be set as a number
			*/
			modalDialogHeight: '',
			/* type="number" Specifies time of milliseconds for animation duration to show/hide modal dialog */
			modalDialogAnimationDuration: 200,
			/* type="string" Specifies text in feature chooser */
			featureChooserText: $.ig.GridSorting.locale.featureChooserText,
			/* type="string" custom unsorted column tooltip in jQuery templating format */
			unsortedColumnTooltip: $.ig.GridSorting.locale.unsortedColumnTooltip,
			/* type="array" a list of custom column settings that specify custom sorting settings for a specific column (whether sorting is enabled / disabled, default sort direction, first sort direction, etc.) */
			columnSettings: [
				{
					/* type="string" column key. Either key or index must be set in every column setting */
					columnKey: null,
					/* type="number" column index. Either key or index must be set in every column setting */
					columnIndex: null,
					/* type="asc|desc" This will be the first sort direction when the column hasn't been sorted before 
					asc type="string"
					desc type="string"
					*/
					firstSortDirection: null,
					/* type="asc|desc" The current (or default) sort direction. If this setting is specified, the column will be rendered sorted according to this option. 
					asc type="string"
					desc type="string"
					*/
					currentSortDirection: null,
					/* type="bool" enables / disables sorting on the specified column. By default all columns are sortable */
					allowSorting: true
				}
			],
			/* type="string" Specifies caption text for multiple sorting dialog */
			modalDialogCaptionText: $.ig.GridSorting.locale.modalDialogCaptionText,
			/* type="string" Specifies text of button which apply changes in modal dialog */
			modalDialogButtonApplyText: $.ig.GridSorting.locale.modalDialogButtonApplyText,
			/* type="string" Specifies text of button which cancel changes in modal dialog */
			modalDialogButtonCancelText: $.ig.GridSorting.locale.modalDialogButtonCancelText,
			featureChooserSortAsc: $.ig.GridSorting.locale.featureChooserSortAsc,
			featureChooserSortDesc: $.ig.GridSorting.locale.featureChooserSortDesc,
			/* type="bool" Enables / disables sorting persistence between states*/
			persist: true,
			/* type="string" Controls containment behavior of multiple sorting dialog.
                owner type="string" The multi sorting dialog will be draggable only in the grid area
                window type="string" The multi sorting dialog will be draggable in the whole window area
            */
            sortingDialogContainment: "owner"
		},
		renderInFeatureChooser: true,
		events: {
			/* cancel="true" Event fired before sorting is invoked for a certain column.
			Return false in order to cancel column sorting.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridSorting.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.columnKey to get column key.
			Use ui.direction to get sorting direction.
			*/
			columnSorting: "columnSorting",
			/* cancel="false" Event fired after the column has already been sorted and data - re-rendered.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridSorting.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.columnKey to get column key.
			Use ui.direction to get sorting direction.
			*/
			columnSorted: "columnSorted",
			/* cancel="true" event fired before the modal dialog is opened.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridSorting widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.columnChooserElement to get a reference to the modal dialog element. This is a jQuery object.
			*/
			modalDialogOpening: "modalDialogOpening",
			/* event fired after the modal dialog is already opened.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridSorting widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
			*/
			modalDialogOpened: "modalDialogOpened",
			/* event fired every time the modal dialog changes its position.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridSorting widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
			Use ui.originalPosition to get the original position of the modal dialog div as { top, left } object, relative to the page.
			Use ui.position to get the current position of the modal dialog div as { top, left } object, relative to the page.
			*/
			modalDialogMoving: "modalDialogMoving",
			/* cancel="true" event fired before the modal dialog is closed.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridSorting widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
			*/
			modalDialogClosing: "modalDialogClosing",
			/* event fired after the modal dialog has been closed.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridSorting widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
			*/
			modalDialogClosed: "modalDialogClosed",
			/* cancel="true" event fired before the contents of the modal dialog are rendered.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridSorting widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
			*/
			modalDialogContentsRendering: "modalDialogContentsRendering",
			/* event fired after the contents of the modal dialog are rendered.
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridSorting widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
			*/
			modalDialogContentsRendered: "modalDialogContentsRendered",
			/* cancel="true" event fired when sorting of column is changed in modal dialog. Column should be sorted
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridSorting widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
			Use ui.columnKey to get the column key
			Use ui.isAsc to get whether column should be ascending or not. If true it should be ascending
			*/
			modalDialogSortingChanged: "modalDialogSortingChanged",
			/* cancel="true" event fired when button to unsort column is clicked in modal dialog
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridSorting widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
			Use ui.columnKey to get the column key
			*/
			modalDialogButtonUnsortClick: "modalDialogButtonUnsortClick",
			/* cancel="true" event fired when column(which is not sorted) is clicked to be sorted in modal dialog
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridSorting widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
			Use ui.columnKey to get the column key
			*/
			modalDialogSortClick: "modalDialogSortClick",
			/* cancel="true" event fired when button Apply in modal dialog is clicked
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridSorting widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
			Use ui.columnsToSort to get array of columns which should be sorted - array of objects of sort order - Asc/Desc and columnIdentifier
			*/
			modalDialogButtonApplyClick: "modalDialogButtonApplyClick",
			/* cancel="true" event fired when the button to reset sorting is clicked. 
			The handler function takes arguments evt and ui.
			Use ui.owner to get the reference to the igGridSorting widget.
			Use ui.owner.grid to get the reference to the igGrid widget.
			Use ui.modalDialogElement to get a reference to the modal dialog element. This is a jQuery object.
			*/
			modalDialogButtonResetClick: "modalDialogButtonResetClick"
		},
		_createWidget: function (options, element) {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			this.options.columnSettings = [];
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		_create: function () {
			var self = this;
			this._headers = [];
			this._clickHandler = function (event) {
				var th, id;
				// A.T. 12 Sept. Fix for bug #87042
				id = $(event.target).closest(".ui-iggrid").attr("id").replace("_container", "");
				if (self.grid.element.attr("id") !== id) {
					return;
				}
				th = $(event.currentTarget).closest('th');
				if (th.attr("data-skip") !== "true" && (self.grid._isMultiColumnGrid !== true || th.attr("data-isheadercell") === "true")) {
					th.find('a').focus();
					self._handleSort(event);
					// sync the grid's scrollbar if the grid has width
					// check if there is a scrollLeft
					if ($('#' + self.grid.id() + '_hscroller').scrollLeft() > 0 && self.grid.options.fixedHeaders === true) {
						//set the new scrollLeft to the one of the header
						self.grid.headersTable().parent().scrollLeft($('#' + self.grid.id() + '_hscroller').scrollLeft());
					}
				}
			};
			this._dragStartHandler = function (event) {
				var id, noCancel = true;
				noCancel = self.grid._trigger("headercelldragcancel", event, {});
				if (noCancel) {
					id = $(event.target).closest(".ui-iggrid").attr("id").replace("_container", "");
					if (self.grid.element.attr("id") !== id) {
						return;
					}
					event.stopPropagation();
					event.preventDefault();
				} else {
					return true;
				}
				return false;
			};
			this._mouseOverHandler = function (event) {
				var id, $target = $(event.currentTarget), cs;
				id = $(event.target).closest(".ui-iggrid").attr("id").replace("_container", "");
				if (self.grid.element.attr("id") !== id) {
					return;
				}
				// check if the column is sortable
				cs = self._getColSettingFromElement(event.currentTarget);
				if (cs && cs.allowSorting !== false) {
					$target.addClass(self.css.sortableColumnHeaderHover);
				}
			};
			this._mouseOutHandler = function (event) {
				var id;
				id = $(event.target).closest(".ui-iggrid").attr("id").replace("_container", "");
				if (self.grid.element.attr("id") !== id) {
					return;
				}
				$(event.currentTarget).removeClass(self.css.sortableColumnHeaderHover);
			};
			// bind events - we assume the <tr> holding the <th>s is already there
			$('#' + this.element[0].id).delegate("thead th", {
				click: this._clickHandler,
				//A.T. 21 Jan 2011 - Fix for bug #63737 - Droping a column in the filter row area results in displaying "javascript:void(0)" in the filter area
				//dragstart: this._dragStartHandler,
				mouseover: this._mouseOverHandler,
				mouseout: this._mouseOutHandler
			});
			$('#' + this.element[0].id + ' thead th').bind("dragstart", this._dragStartHandler);
			$('#' + this.element[0].id + '_headers thead th').bind("dragstart", this._dragStartHandler);
			$(document).delegate("#" + this.element[0].id + "_headers thead th", {
				click: this._clickHandler,
				//A.T. 21 Jan 2011 - Fix for bug #63737 - Droping a column in the filter row area results in displaying "javascript:void(0)" in the filter area
				//dragstart: this._dragStartHandler,
				mouseover: this._mouseOverHandler,
				mouseout: this._mouseOutHandler
			});
			this._keyDownHandler = function (event) {
				self._handleSortKb(event);
			};
			this._focusHandler = function (event) {
				self._handleFocusKb(event);
			};
			this._blurHandler = function (event) {
				self._handleBlurKb(event);
			};
			// M.H. 22 March 2012 Fix for bug #105757
			$('#' + this.element[0].id).delegate("thead th a:not([th-remove-focus])", {
				keydown: this._keyDownHandler,
				focus: this._focusHandler,
				blur: this._blurHandler
			});
			// M.H. 22 March 2012 Fix for bug #105757
			$(document).delegate("#" + this.element[0].id + "_headers thead th a:not([th-remove-focus])", {
				keydown: this._keyDownHandler,
				focus: this._focusHandler,
				blur: this._blurHandler
			});
		},
		_setOption: function (key, value) {
			var i, col, featureChooserInstance, modalDialog = $('#' + this.grid.element[0].id + '_multiplesorting_modalDialog');
			// M.H. 20 March 2012 Fix for bug #105270
			// handle new settings and update options hash
			$.Widget.prototype._setOption.apply(this, arguments);
			switch (key) {
			case 'type':
				// start by throwing an error for the options that aren't supported:
				throw new Error($.ig.Grid.locale.optionChangeNotSupported + ' ' + key);
			case 'caseSensitive':
				// reinitialize data source setting
				//A.T. 12 Feb 2011 - Fix for #66143 - igSorting caseSensitive option doesn't change case sensitivity
				this.grid.dataSource.settings.sorting.caseSensitive = this.options.caseSensitive;
				break;
			case 'modalDialogSortOnClick':
				modalDialog.remove();
				this._renderMultipleSortingDialog();
				break;
			case 'modalDialogAnimationDuration':
				modalDialog.igGridModalDialog('option', 'animationDuration', value);
				break;
			case 'modalDialogWidth':
				modalDialog.igGridModalDialog('option', 'modalDialogWidth', value);
				break;
			case 'modalDialogHeight':
				modalDialog.igGridModalDialog('option', 'modalDialogHeight', value);
				break;
			case 'modalDialogButtonApplyText':
				modalDialog.igGridModalDialog('option', 'buttonApplyText', value);
				break;
			case 'modalDialogButtonCancelText':
				modalDialog.igGridModalDialog('option', 'buttonCancelText', value);
				break;
			case 'modalDialogCaptionText':
				modalDialog.igGridModalDialog('option', 'modalDialogCaptionText', value);
				break;
			case 'featureChooserText':
				featureChooserInstance = this.grid.element.data('igGridFeatureChooser');
				if (featureChooserInstance) {
					for (i = 0; i < this.grid.options.columns.length; i++) {
						col = this.grid.options.columns[i].key;
						featureChooserInstance._setListItemText(col, 'Sorting', value);
					}
				}
				break;
			default:
				break;
			}
		},
		_getColSettingFromElement: function (e) {
			var index, cs = this.options.columnSettings, $e = $(e);
			index = parseInt($e.data('columnIndex'), 10);
			return cs[index];
		},
		_handleSortKb: function (event) {
			var index = $(event.currentTarget).closest('th').data('columnIndex'), id;
			id = $(event.target).closest(".ui-iggrid").attr("id").replace("_container", "");
			if (this.grid.element.attr("id") !== id) {
				return;
			}
			if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
				if (this._currentActiveHeader) {
					this._currentActiveHeader.removeClass(this.css.sortableColumnHeaderActive);
				}
				$(event.currentTarget).closest('th').addClass(this.css.sortableColumnHeaderActive);
				this._currentActiveHeader = $(event.currentTarget).closest('th');
				// M.H. 22 March 2012 Fix for bug #105214
				if (event.shiftKey) {
					this.unsortColumn(index, $(event.currentTarget).closest('th'));
				} else {
					//A.T. 15 Feb 2011 - fix for bug #66140
					this.sortColumn(index, null, $(event.currentTarget).closest('th'));
					//A.T. 19 March 2012 - fix for bug #105209
					if ($.ig.util.isIE) {
						$(event.currentTarget).focus();
					}
				}
				event.stopPropagation();
				event.preventDefault();
			}
		},
		_handleFocusKb: function (event) {
			// M.H. 17 Mar 2014 Fix for bug #165697: Control automatically sorts the records while resizing the column using mouse
			if (this._resizing && this._resizing._resizing) {
				return;
			}
			var $target = $(event.currentTarget), id = $(event.target).closest(".ui-iggrid").attr("id").replace("_container", "");
			// M.H. 11 Jun 2013 Fix for bug #144395: When you fix a column, fixedHeaders is false and click "Add new row" clicking in the editor of the fixed column cancels the adding.
			if (this.grid.element.attr("id") !== id || $target.attr('data-fixing-indicator') !== undefined) {
				return;
			}
			$target.closest('th').addClass(this.css.sortableColumnHeaderFocus);
		},
		_handleBlurKb: function (event) {
			var id = $(event.target).closest(".ui-iggrid").attr("id").replace("_container", "");
			if (this.grid.element.attr("id") !== id) {
				return;
			}
			$(event.currentTarget).closest('th').removeClass(this.css.sortableColumnHeaderFocus);
		},
		_handleSort: function (event) {
			// M.H. 4 Mar 2014 Fix for bug #165697: Control automatically sorts the records while resizing the column using mouse
			if (this._resizing && this._resizing._resizing) {
				this._resizing._resizing = false;
				return;
			}
			var $th = $(event.currentTarget).closest('th'), index = $th.data('columnIndex'), isShiftClicked = false;
			if (this._currentActiveHeader) {
				this._currentActiveHeader.removeClass(this.css.sortableColumnHeaderActive);
			}
			isShiftClicked = event.shiftKey;
			if (isShiftClicked) {
				$th.removeClass(this.css.sortableColumnHeaderFocus)
					.removeClass(this.css.sortableColumnHeaderActive);
				this._currentHeader = $th;
				this.unsortColumn(index, $th);
			} else {
				$(event.currentTarget).addClass(this.css.sortableColumnHeaderActive);
				this._currentActiveHeader = $th;
				this.sortColumn(index, null, $(event.currentTarget));
			}
			event.stopPropagation();
			event.preventDefault();
		},
		_initLoadingIndicator: function () {
			// attach loading indicator widget
			this._loadingIndicator = this.grid.container().length > 0 ? this.grid.container().igLoading().data("igLoading").indicator() : this.grid.element.igLoading().data("igLoading").indicator();
		},
		_getHeaderCellByIdentifier: function (identifier) {
			var $headerCell, colKey;

			if ($.type(identifier) === 'number') {
				colKey = this.grid.options.columns[identifier].key;
			} else {
				colKey = identifier;
			}
			$headerCell = $('#' + this.grid.element[0].id + '_' + colKey);
			return $headerCell;
		},
		sortColumn: function (index, direction, header) {
			/* sorts a grid column and updates the UI  
				paramType="object" Column key (string) or index (number). Specifies the column which we want to sort. If the mode is multiple, previous sorting states are not cleared. 
				paramType="asc|desc" Specifies sorting direction (ascending or descending) 
				paramType="object" excluded="true"
			*/
			var colKey, expr, noCancel = true, s, i, visualIndex, groupby, reset = true, se, newSE = [],
				apiCall = (header === null || header === undefined),
				addSE = false,
				isHidden = false;
			// M.H. 10 April 2012 Fix for bug #107671
			this._currentIdentifier = index;
			if ($.type(index) === 'number') {
				colKey = this.grid.options.columns[index].key;
				if (this.grid.options.columns[index].hidden) {
					isHidden = true;
				}
			} else {
				colKey = index;
//				for (i = 0; i < this.grid.options.columns.length; i++) {
//					if (this.grid.options.columns[i].key === colKey) {
//						index = i;
//						break;
//					}
//				}
				if (header === null || header === undefined) {
					header = $('#' + this.grid.element[0].id + '_' + colKey);
				}
				index = header.data('columnIndex');
				// M.H. 22 Feb 2013 Fix for bug #132629: Sorting cannot be applied on a hidden column
				if (index === undefined) {
					isHidden = true;
				}
			}

			expr = this.grid.dataSource.settings.sorting.expressions;
			s = this._findColumnSetting(colKey);
			if (this.grid.options.virtualizationMode === 'fixed' && (this.grid.options.virtualization === true || this.grid.options.columnVirtualization === true)) {
				visualIndex = index - this.grid._startColIndex;
			} else {
				visualIndex = index;
			}
			if (apiCall && this._currentActiveHeader) {
				this._currentActiveHeader.removeClass(this.css.sortableColumnHeaderActive);
			}
			if (header === null || header === undefined) {
				// programmatic sorting 
				//A.T. 11 Oct - Fix for bug #91033
				visualIndex += this.grid.headersTable().children("thead").children("tr").children("th[data-skip=true]").length;
				// M.H. 12 April 2012 Fix for bug #108488
				if (colKey) {
					header = $('#' + this.grid.element[0].id + '_' + colKey);
				} else {
					header = this.grid.headersTable().children("thead").children("tr").children('th:nth-child(' + (visualIndex + 1) + ')');
				}
				apiCall = true;
			}
			if (s && s.allowSorting === false) {
				return;
			}
			if (direction !== null && direction !== undefined) {
				s.currentSortDirection = direction;
			} else {
				if ((s.currentSortDirection !== undefined && s.currentSortDirection !== null && !s.currentSortDirection.startsWith('asc') && !s.currentSortDirection.startsWith('desc')) || s.currentSortDirection === undefined || s.currentSortDirection === null) {
					s.currentSortDirection = s.firstSortDirection === undefined ? this.options.firstSortDirection : s.firstSortDirection;
				} else {
					s.currentSortDirection = (s.currentSortDirection !== undefined && s.currentSortDirection !== null && s.currentSortDirection.indexOf('asc') !== -1) ? 'descending' : 'ascending';
				}
			}
			// fire sorting event
			if (!apiCall) {
				noCancel = this._trigger(this.events.columnSorting, null, {columnKey: colKey, direction: s.currentSortDirection, owner: this});
			}
			if (noCancel) {
				this._loadingIndicator.show();
				//  update title attributes
				header.attr('title', s.currentSortDirection.startsWith('asc') ? this.options.sortedColumnTooltip.replace('${direction}', $.ig.GridSorting.locale.ascending) : this.options.sortedColumnTooltip.replace('${direction}', $.ig.GridSorting.locale.descending));
				if (this.options.mode === "single") {
					// M.H. 22 Feb 2013 Fix for bug #132629: Sorting cannot be applied on a hidden column
					if (isHidden) {
						this._clearSortStates(header, -1);
						for (i = 0; i < this.grid.options.columns.length; i++) {
							if (this.options.columnSettings[i] &&
									this.options.columnSettings[i].allowSorting !== false &&
									this.options.columnSettings[i].columnKey !== colKey) {
								this._clearSortState(header, this.options.columnSettings[i].columnIndex, this.options.columnSettings[i].columnKey);
							}
						}
					} else {
						if (colKey && this.grid.hasFixedColumns()) {
							this._clearSortStatesByKey(header, colKey);
						} else {
							this._clearSortStates(header, index);
						}
					}
					// check if we have group columns (GroupBy feature)
					for (i = 0; this.grid.options.features && i < this.grid.options.features.length; i++) {
						if (this.grid.options.features[i].name === "GroupBy") {
							// try getting the feature
							groupby = this.grid.element.data("igGridGroupBy");
							if (groupby && groupby.options.groupedColumns && groupby.options.groupedColumns.length > 0) {
								reset = false;
							}
						}
					}
					// M.H. 22 Feb 2013 Fix for bug #132629: Sorting cannot be applied on a hidden column
					if (isHidden && direction !== null && direction !== undefined) {
						s.currentSortDirection = direction;
					}

					// A.T. 10 Oct 2011 if we have Grouped columns, even though the sorting is single, we shouldn't clear all existing sorting expressions
					// because essentially GroupBy is using the same sorting expressions for the groups
					if (reset) {
						this.grid.dataSource.settings.sorting.expressions = [{fieldName: colKey, dir: s.currentSortDirection.startsWith('asc') ? 'asc' : 'desc'}];
					} else {
						// replace the sorting expression which is for the current key
						// M.H. 21 May 2012 Fix for bug #112188
						// we should insert first groupby sorting expressions (those which are marked with flag groupBy) and then to push at the end of the array current sorting expression
						se = this.grid.dataSource.settings.sorting.expressions;
						addSE = true;
						// M.H. 6 Jan 2014 Fix for bug #160660: When applying groupBy and sorting to the same column the generated  $orderby is set twice on the same column
						for (i = 0; i < se.length; i++) {
							if (se[i].isGroupBy === true) {
								if (se[i].fieldName === colKey) {
									addSE = false;
								}
								newSE.push(se[i]);
							}
						}
						if (addSE) {
							newSE.push({fieldName: colKey, dir: s.currentSortDirection.startsWith('asc') ? 'asc' : 'desc'});
						}
						this.grid.dataSource.settings.sorting.expressions = newSE;
					}
				} else {
					// multi-column sorting
					for (i = 0; i < expr.length; i++) {
						if (expr[i].fieldName === colKey) {
							expr.splice(i, 1);
						}
					}
					this.grid.dataSource.settings.sorting.expressions = expr.concat([{fieldName: colKey, dir: s.currentSortDirection.startsWith('asc') ? 'asc' : 'desc'}]);
				}
				// trigger DataBinding event on the grid
				noCancel = this.grid._trigger(this.grid.events.dataBinding, null, {owner: this.grid});
				// M.H. 5 Sep 2013 Fix for bug #145014: When using remote paging and sorting  the values of the unbound columns set via the unboundValues option are not persisted.
				// M.H. 15 Oct 2013 Fix for bug #154987: When the dataSource is remote, any action that rearranges records mess up the unbound values
				if (this.grid._hasUnboundColumns && this.options.type === "remote") {
					this.grid._rebindUnboundColumns = true;
				}
				if (noCancel) {
					this._saveSortingExpressions();
					// A.T. 13 April 2011 fix for bug #72284
					this.grid.element.trigger('iggriduisoftdirty', {owner: this});
					this._currentHeader = header;
					this._currentIndex = index;
					if (this.options.type === "remote") {
						if (!apiCall) {
							this._shouldFireColumnSorted = true;
						}
						this.grid.dataSource.dataBind();
					} else {
						this.grid.dataSource.sort(this.grid.dataSource.settings.sorting.expressions, s.currentSortDirection);
						// L.A. 07 August 2012 - Fixing bug #118388 The 'databound' event fires twice when sorting a column
						// _renderData fires again databound, therefore this call is not needed.
						//this.grid._trigger(this.grid.events.dataBound, null, {owner: this.grid});
						this.grid._renderData();
						if (!apiCall) {
							this._trigger(this.events.columnSorted, null, {columnKey: colKey, direction: s.currentSortDirection, owner: this});
						}
					}
					this._curColKey = colKey;
					this._curSortDir = s.currentSortDirection;
				}
			}
		},
		sortMultiple: function () {
			/* sorts grid columns and updates the UI
			*/
			// trigger DataBinding event on the grid
			var self = this,
				noCancel,
				expr = this.grid.dataSource.settings.sorting.expressions,
				header;

			noCancel = this.grid._trigger(this.grid.events.dataBinding, null, {owner: this.grid});
			if (noCancel) {
				$.each(this.grid.options.columns, function (index, column) {
					var i, cs, colKey = column.key;
					header = $('#' + self.grid.element[0].id + '_' + colKey);

					for (i = 0; i < expr.length; i++) {
						if (expr[i].fieldName === colKey) {
							break;
						}
					}
					cs = self._findColumnSetting(colKey);
					if (cs) {
						if (i === expr.length) {
							// remove sorting for the column
							cs.currentSortDirection = undefined;
						} else {
							cs.currentSortDirection = expr[i].dir;
						}
					}
					self._applySortStyles(header, index);
				});
				// A.T. 13 April 2011 fix for bug #72284
				this.grid.element.trigger('iggriduisoftdirty', { owner: this });
				// M.H. 18 July 2012 Fix for bug #105514
				if (this._isResetClick === true) {
					// M.H. 19 July 2012 Fix for bug #105514
					this._isResetClick = false;
				}
				// M.H. 29 May 2014 Fix for bug #170808: Sorting is remain applied after data binding and clicking reset button in sorting dialog when persistence is enabled
				this._saveSortingExpressions();
				if (this.options.type === "remote") {
					this.grid.dataSource.dataBind();
				} else {
					this.grid.dataSource.sort(this.grid.dataSource.settings.sorting.expressions);
					// M.H. 19 Sep 2013 Fix for bug #139696: igGridSorting duplicated dataBound event when sorting through the mutliple sorting dialog
					//this.grid._trigger(this.grid.events.dataBound, null, {owner: this.grid});
					this.grid._renderData();
				}
				// render Asc/Desc buttons
			}
		},
		unsortColumn: function (index, header) {
			if (this.options.mode === "single") {
				return;
			}
			var colKey, expr, noCancel = true, s, i, apiCall = false;
			if ($.type(index) === 'number') {
				colKey = this.grid.options.columns[index].key;
			} else {
				colKey = index;
				for (i = 0; i < this.grid.options.columns.length; i++) {
					if (this.grid.options.columns[i].key === colKey) {
						index = i;
						break;
					}
				}
			}
			expr = this.grid.dataSource.settings.sorting.expressions;
			s = this._findColumnSetting(colKey);
			if (s === null || s === undefined) {
				return;
			}
			if (s && s.allowSorting === false) {
				return;
			}
			s.currentSortDirection = undefined;
			for (i = 0; i < expr.length; i++) {
				if (expr[i].fieldName === colKey) {
					expr.splice(i, 1);
				}
			}
			// M.H. 18 April 2012 Fix for bug #109745
			this._currentIndex = null;
			this._currentHeader = null;

			// M.H. 16 March 2012 Fix for bug #105074
			this._applySortStyles($('#' + this.grid.element[0].id + '_' + colKey), index);
			noCancel = this.grid._trigger(this.grid.events.dataBinding, null, {owner: this.grid});
			if (noCancel) {
				this.grid.element.trigger('iggriduisoftdirty', {owner: this});
				// M.H. 10 April 2012 Fix for bug #107671 - it should not be set current index
				//this._currentIndex = index;
				this._currentHeader = header;
				if (this.options.type === "remote") {
					if (!apiCall) {
						this._shouldFireColumnSorted = true;
					}
					this.grid.dataSource.dataBind();
				} else {
					this.grid.dataSource.sort(this.grid.dataSource.settings.sorting.expressions);
					this.grid._trigger(this.grid.events.dataBound, null, {owner: this.grid});
					this.grid._renderData();
					if (!apiCall) {
						this._trigger(this.events.columnSorted, null, {columnKey: colKey, direction: s.currentSortDirection, owner: this});
					}
				}
				this._curColKey = colKey;
				this._curSortDir = s.currentSortDirection;
				this._saveSortingExpressions();
			}
		},
		/* A.T. fix for bug #73496 */
		_excludeExpr: function (key) {
			// M.H. 5 Mar 2014 Fix for bug #165360: Sorting persistance is not working for the child layouts of the grid
			if (this.options.persist && !this._couldPreserveData()) {
				return;
			}
			var expr = this.grid.dataSource.settings.sorting.expressions, i;
			for (i = 0; i < expr.length; i++) {
				if (expr[i].fieldName === key) {
					// remove the entry from the array
					//A.T. 8 March 2012 - Fix for bug #104244 
					//expr.remove(i);
					$.ig.removeFromArray(expr, i);
				}
			}
		},
		// M.H. 2 April 2012 Fix for bug #106392
		// M.H. 10 April 2012 Fix for bug #107671 - add ignore selected style
		_applySortStyles: function (header, index, columnKey, ignoreActiveSelection) {
			// M.H. 5 April 2012 Fix for bug #106392
			var oldHeight = null, span, col, indicatorContainer, visualIndex, indexResolved, i, tmpIndexResolved, currentColumnSetting,
				columnOption = this.grid.options.columns[index], dataSkipColumnCount = 0, isFixed,
				// L.A. 21 September 2012 - fixing bug #121812 
				// Grid - Incorrect Tooltip in Multiple Sorting and Hiding Events with Modal Window sample
				toolTip = this.options.sortedColumnTooltip,
				hasFixedColumns = this.grid.hasFixedColumns(),
				sortAsc = toolTip.replace('${direction}', $.ig.GridSorting.locale.ascending),
				sortDesc = toolTip.replace('${direction}', $.ig.GridSorting.locale.descending);

			if (this.grid.options.virtualizationMode === 'fixed' && (this.grid.options.virtualization === true || this.grid.options.columnVirtualization === true)) {
				visualIndex = index - this.grid._startColIndex;
			} else {
				visualIndex = index;
			}
			// M.H. 16 May 2013 Fix for bug 142351: Cell value is split into single character when a flat grid is shown after a hierarchical grid has been expanded
			if (this.grid.options.fixedHeaders) {
				oldHeight = this.grid.headersTable().outerHeight();
			}
			// apply class to sorting indicator
			span = header.find('.ui-iggrid-colindicator');
			// S.S. Bug #108027 April 9, 2012 sorting indicator span hasn't been added yet
			if (span.length === 0) {
				span = $('<span></span>').addClass(this.css.sortIndicator);
			}
			indicatorContainer = header.find('.ui-iggrid-indicatorcontainer');
			if (indicatorContainer.length === 0) {
				indicatorContainer = $('<div></div>').appendTo(header).addClass('ui-iggrid-indicatorcontainer');
			}
			indicatorContainer.append(span);
			// A.T. check if we are running in a hierarchical grid context
			/*
			if (this._hc === true) {
				indexResolved = visualIndex + 2;
			} else {
				indexResolved = visualIndex + 1;
			}
			*/
			// M.H. 1 June 2012 Fix for bug #113186
			//dataSkipColumnCount = header.parent('thead').children("[data-skip=true]").length;
			// do not include in the count columns cells like filtering data skipped cells
			dataSkipColumnCount = header.closest('thead').find(".ui-iggrid-header[data-skip=true]").length;

			indexResolved = visualIndex + dataSkipColumnCount + 1;
			tmpIndexResolved = indexResolved;
			for (i = 0; i < this.grid.options.columns.length; i++) {
				// M.H. 8 May 2012 Fix for bug #107156 - indexResolved starts from 1 but it is compared to 0 starting value
				// M.H. 1 June 2012 Fix for bug #113186
				if (i + dataSkipColumnCount < indexResolved && this.grid.options.columns[i].hidden) {
					tmpIndexResolved--;
				}
			}

			indexResolved = tmpIndexResolved;
			// A.T. fix failing unit tests
			// M.H. 2 April 2012 Fix for bug #106392
			if (columnKey !== null && columnKey !== undefined) {
				for (i = 0; i < this.options.columnSettings.length; i++) {
					if (this.options.columnSettings[i].columnKey === columnKey) {
						currentColumnSetting = this.options.columnSettings[i];
						break;
					}
				}
			} else {
				// M.H. 2 April 2012 Fix for bug #106392
				currentColumnSetting = this.options.columnSettings[index];
			}
			if (hasFixedColumns) {
				if (columnOption) {
					columnKey = columnOption.key;
					isFixed = (columnOption.fixed === true);
				} else if (currentColumnSetting) {
					columnKey = currentColumnSetting.columnKey;
					isFixed = (this.grid.columnByKey(columnKey).fixed === true);
				}
				indexResolved = this._columnFixing._getVisibleIndex(columnKey, isFixed) + 1;
			}
			if (hasFixedColumns && this.grid._isFixedElement(header)) {
				col = $('#' + this.element[0].id + '_fixed tbody tr td:nth-child(' + indexResolved + ')');
			} else {
				if (hasFixedColumns && !columnOption && !currentColumnSetting) {
					indexResolved -= this.grid._fixedColumns.length;
				}
				if (this.grid.options.fixedHeaders !== true) {
					col = header.closest('thead').parent().find('tbody tr td:nth-child(' + indexResolved + ')');
				} else if (this.options.applySortedColumnCss !== false) {
					col = this.grid.element.find('tr td:nth-child(' + indexResolved + ')');
				}
			}
			// M.H. 2 April 2012 Fix for bug #106392
			// do not apply sorting styles on a hidden column - indexResolved is not calculated properly
			// M.H. 5 April 2012 Fix for bug #106392
			if (currentColumnSetting !== undefined && currentColumnSetting.currentSortDirection !== undefined &&
					(!columnOption || (columnOption && columnOption.hidden !== true))) {
				if (currentColumnSetting.currentSortDirection.indexOf('asc') !== -1) {
					span.removeClass(this.css.sortIndicatorDescending).addClass(this.css.sortIndicatorAscending);
					header.removeClass(this.css.descendingColumnHeader).addClass(this.css.ascendingColumnHeader);
					// L.A. 21 September 2012 - fixing bug #121812 
					// Grid - Incorrect Tooltip in Multiple Sorting and Hiding Events with Modal Window sample
					header.attr('title', sortAsc);
					// change the CSS class for the column
					if (this.options.applySortedColumnCss !== false && ignoreActiveSelection !== true) {
						col.removeClass(this.css.descendingColumn).addClass(this.css.ascendingColumn);
					}
				} else {
					span.removeClass(this.css.sortIndicatorAscending).addClass(this.css.sortIndicatorDescending);
					header.removeClass(this.css.ascendingColumnHeader).addClass(this.css.descendingColumnHeader);
					// L.A. 21 September 2012 - fixing bug #121812 
					// Grid - Incorrect Tooltip in Multiple Sorting and Hiding Events with Modal Window sample
					header.attr('title', sortDesc);
					// change the css class for the column
					if (this.options.applySortedColumnCss !== false && ignoreActiveSelection !== true) {
						col.removeClass(this.css.ascendingColumn).addClass(this.css.descendingColumn);
					}
				}
			} else {
				// L.A. 21 September 2012 - fixing bug #121812 
				// Grid - Incorrect Tooltip in Multiple Sorting and Hiding Events with Modal Window sample
				header.attr('title', this.options.unsortedColumnTooltip);
				// M.H. 27 Feb 2014 Fix for bug #165592: When multi column headers are enabled and sorting can't be undone by Shift+Click in multiple mode.
				if (this.grid._isMultiColumnGrid === true) {
					span = header.find('.ui-iggrid-colindicator');
				} else {
					span = header.parent('tr').find('th:nth-child(' + indexResolved + ') .ui-iggrid-colindicator');
				}
				// M.H. 13 Mar 2014 Fix for bug #165592: When multi column headers are enabled and sorting can't be undone by Shift+Click in multiple mode.
				span.removeClass(this.css.sortIndicatorAscending).removeClass(this.css.descendingColumnHeader);
				header.removeClass(this.css.sortableColumnHeaderActive)
                      .removeClass(this.css.sortableColumnHeaderFocus)
                      .removeClass(this.css.ascendingColumnHeader)
                      .removeClass(this.css.descendingColumnHeader);
			}
			// M.H. 16 May 2013 Fix for bug 142351: Cell value is split into single character when a flat grid is shown after a hierarchical grid has been expanded
			if (oldHeight !== null && oldHeight !== this.grid.headersTable().outerHeight()) {
				this.grid._initializeHeights();
			}
		},
		// will clear all sort states except the one specified as index. If none is specified will clear all
		_clearSortStatesByKey: function (header, key) {
			var i, cs = this.options.columnSettings, csLen = cs.length, 
				clearHiddenCols = (this.options.mode === 'single') && this.grid._detachedHeaderCells;
			for (i = 0; i < csLen; i++) {
				if (cs[i].allowSorting === false || cs[i].columnKey === key) {
					continue;
				}
				delete cs[i].currentSortDirection;
				this._clearSortState(header, cs[i].columnIndex, cs[i].columnKey);
				
				if (clearHiddenCols && cs[i].columnKey && this.grid._detachedHeaderCells[cs[i].columnKey]) {
					this._clearHeaderCellSortState(this.grid._detachedHeaderCells[cs[i].columnKey][0]);
				}
			}
		},
		// will clear all sort states except the one specified as index. If none is specified will clear all
		_clearSortStates: function (header, index) {
			var i, cs = this.options.columnSettings, realIndex = index, isSingleMode = this.options.mode === 'single';
			// take into account all hidden columns with index below "index"
			for (i = 0; i < this.grid.options.columns.length; i++) {
				if (i < index && this.grid.options.columns[i].hidden) {
					realIndex--;
					//hiddenCount++;
				}
			}
			index = realIndex;
			for (i = 0; i < this.options.columnSettings.length; i++) {
				if (cs[i].allowSorting !== false) {
					if (index !== undefined && cs[i].columnIndex !== index) {
						//cs[i].currentSortDirection = null;
						//if (cs[i].currentSortDirection) {
						//	cs[i].currentSortDirection = cs[i].userSet_currentSortDirection;
						//}
						delete cs[i].currentSortDirection;
						//this._clearSortState(header, i - hiddenCount < 0 ? 0 : i - hiddenCount);
						// M.H. 4 June 2012 Fix for bug #113187
						this._clearSortState(header, cs[i].columnIndex, cs[i].columnKey);
					}
					// M.H. 19 July 2012 Fix for bug #113505
					if (this.grid._detachedHeaderCells && isSingleMode && cs[i].columnKey && this.grid._detachedHeaderCells[cs[i].columnKey]) {
						if (cs[i].currentSortDirection !== undefined && cs[i].currentSortDirection !== null) {
							delete cs[i].currentSortDirection;
						}
						this._clearHeaderCellSortState(this.grid._detachedHeaderCells[cs[i].columnKey][0]);
					}
				}
			}
		},
		_clearSortStateFixing: function (columnKey) {
			var th, id = this.grid.element.attr('id') + '_' + columnKey,
				visibleIndex = this._columnFixing._getVisibleIndex(columnKey);

			th = $('#' + id);
			this._clearSortStateByVisibleIndex(visibleIndex, th);
		},
		_clearSortState: function (header, i, columnKey) {
			if (this.grid.hasFixedColumns() && columnKey !== undefined) {
				this._clearSortStateFixing(columnKey);
				return;
			}
			var th, ths, fixedColumnsLength;
			
			if (this.grid._isMultiColumnGrid === true) {
				// M.H. 10 Aug 2012 Fix for bug #118779
				ths = this.grid._headerCells;//headersTable().find("thead th[data-isheadercell=true]").not("[data-skip=true]");
				th = ths[i];
				if (th === undefined) {
					return;
				}
			} else {
				if (this.grid.hasFixedColumns()) {
					fixedColumnsLength = this.grid._fixedColumns.length;
					if (i < fixedColumnsLength) {
						ths = this.grid.fixedHeadersTable().find("thead > tr").first().find("th").not("[data-skip=true]");
					} else {
						ths = this.grid.headersTable().find("thead > tr").first().find("th").not("[data-skip=true]");
						i -= fixedColumnsLength;
					}
					th = ths.eq(i);
				} else {
					ths = this.grid.headersTable().find("thead > tr").first().find("th").not("[data-skip=true]");
					th = ths.eq(i);
				}
			}
			this._clearSortStateByVisibleIndex(i, th);
		},
		_clearSortStateByVisibleIndex: function (i, th) {
			var spanHeader = th, col;

			this._clearHeaderCellSortState(spanHeader);
			//A.T. 12 Feb 2011 - Fix for bug #66082
			// reset tooltip
			//if (this._hc === true) {
			//	this._headers[i - 1].header.attr('title', this.options.unsortedColumnTooltip);
			//} else {
			if (this.options.columnSettings.length > i && this.options.columnSettings[i].allowSorting) {
				th.attr('title', this.options.unsortedColumnTooltip);
			} else {
				th.attr('title', '');
			}
			//}
			if (this.options.applySortedColumnCss !== false) {
				if (this.grid.options.fixedHeaders !== true) {
					col = th.closest('thead').parent().find('tbody tr td:nth-child(' + (i + 1) + ')');
				} else {
					col = this.grid.element.find('tr td:nth-child(' + (i + 1) + ')');
				}
				// change the CSS class for the column
				col.removeClass(this.css.descendingColumn).removeClass(this.css.ascendingColumn);
			}
		},
		_clearHeaderCellSortState: function (spanHeader) {
			var span = spanHeader.find('.ui-iggrid-colindicator');
			if (span.hasClass('ui-iggrid-colindicator-desc') || span.hasClass('ui-iggrid-colindicator-asc')) {
				span.removeClass(this.css.sortIndicatorDescending).removeClass(this.css.sortIndicatorAscending);
				// we need to get the correct header, that corresponds to the span
				spanHeader.removeClass(this.css.ascendingColumnHeader).removeClass(this.css.descendingColumnHeader).removeClass(this.css.sortableColumnHeaderFocus);
			}
		},
		_initDefaultSettings: function () {
			// fill in default column settings, so that later on we can get the current sort state of every sortable column 
			// iterate through columns
			var settings = [], key, cs = this.options.columnSettings, i, j, k, colIndex = 0, defaultExpressions = [],
                defExpLength, isToSkipGroupBySortingExpr = false, dir,
				allowSorting, isToCheckUnboundColumns = (this.grid._hasUnboundColumns === true && this.options.type === "remote");
			// M.H. 9 May 2012 Fix for bug #111339 - it is possible for instance to be set groupby with default settings and then sorting expressions will be overwritten
			if (this.grid.dataSource.settings.sorting.expressions !== null && this.grid.dataSource.settings.sorting.expressions !== undefined) {
				defaultExpressions = this.grid.dataSource.settings.sorting.expressions;
			}
			defExpLength = defaultExpressions.length;
			// initialize
			if (this.grid.options.columns && this.grid.options.columns.length > 0) {
				for (i = 0; i < this.grid.options.columns.length; i++) {
					allowSorting = true;
					if (isToCheckUnboundColumns && this.grid.getUnboundColumnByKey(this.grid.options.columns[i].key) !== null) {
						allowSorting = false;
					}
					settings[i] = {'columnIndex': colIndex, 'columnKey': this.grid.options.columns[i].key, 'allowSorting': allowSorting};
					// M.H. 19 May 2012 Fix for bug #112103
					// column index should be set properly when hiding is set on init. Otherwise clearsortstates does not clear the sort state for the proper column
					if (this.grid.options.columns[i].hidden !== true) {
						colIndex++;
					}
				}
			}
			for (i = 0; i < cs.length; i++) {
				for (key in cs[i]) {
					if (cs[i].hasOwnProperty(key) && key !== 'columnKey' && key !== 'columnIndex') {
						if (key === "userSet_currentSortDirection") {
							// M.H. 10 Apr 2014 Fix for bug #169650: Missing headers in Sorting dialog after clicking reset button in multiple sorting dialog
							if (cs[i].userSet_currentSortDirection === "undefined" || cs[i].userSet_currentSortDirection === undefined) {
								delete cs[i].currentSortDirection;
								//delete cs[i]["userSet_currentSortDirection"];
							} else {
								cs[i].currentSortDirection = cs[i].userSet_currentSortDirection;
							}
						} else if (key === "userSet_allowSorting") {
							//A.T. 22 Feb 2012 - Fix for #102444 - The column which "allowSorting" option is false came to be sortable after dataSource is set.
							cs[i].allowSorting = cs[i][key];
							delete cs[i][key];
						}
					}
				}
			}
            // M.H. 24 Mar 2014 Fix for bug #165993: Sorting is not working with initial sorting, autogenerate column and no columns definition
            // default expressions are applied ONLY IF column key is properly defined
            if (settings.length === 0 &&
                this.grid.options.autoGenerateColumns &&
                cs.length > 0) {
                for (i = 0; i < cs.length; i++) {
                    if (!cs[i].columnKey) {
                        continue;
                    }
                    if (!cs[i].currentSortDirection || !cs[i].currentSortDirection.startsWith) {
                        dir = 'asc';
                    } else {
                        dir = (cs[i].currentSortDirection.startsWith('asc') ? 'asc' : 'desc');
                    }
                    defaultExpressions.push({fieldName: cs[i].columnKey, dir: dir});
                }
            } else {
				for (i = 0; i < cs.length; i++) {
					for (j = 0; j < settings.length; j++) {
						// M.H. 6 Jan 2014 Fix for bug #160381: When a column is hidden and you assign new data source to the grid the first column becomes sortable again.
						// in case when there are initially hidden columns, columnIndexes of settings and cs could be equal even if columnKeys are not equal(and are set)
						if (settings[j].columnKey !== null &&
							settings[j].columnKey !== undefined &&
							cs[i].columnKey !== null &&
							cs[i].columnKey !== undefined) {
							if (settings[j].columnKey === cs[i].columnKey) {
								break;
							}
						} else if (settings[j].columnIndex === cs[i].columnIndex) {
							break;
						}
					}
					if (j === settings.length) {
						continue;
					}
					for (key in cs[i]) {
						if (cs[i].hasOwnProperty(key) && key !== 'columnKey' && key !== 'columnIndex' && !key.startsWith('userSet')) {
							settings[j][key] = cs[i][key];
							settings[j]['userSet_' + key] = cs[i][key]; // we need to do that so after rebind the original user defined settings are restored
							if (key === 'currentSortDirection' && cs[i][key]) {
								if ($.type(settings[j].columnKey) !== "number") {
									// M.H. 9 May 2012 Fix for bug #111339 - we should not include 2 objects with the same field names in defaultExpressions
									// M.H. 23 Aug 2012 Fix for bug #119413 - if there is sorting expression from group by ignore the sorting expression
									isToSkipGroupBySortingExpr = false;
									if (defExpLength > 0) {
										for (k = 0; k < defExpLength; k++) {
											if (defaultExpressions[k].fieldName === settings[j].columnKey) {
												// M.H. 11 Jun 2012 Fix for bug #111339 - groupby sorting expressions are with higher priority than sorting expressions of sorting
												if (defaultExpressions[k].isGroupBy === true) {
													isToSkipGroupBySortingExpr = true;
												} else {
													defaultExpressions.splice(k, 1);
												}
												break;
											}
										}
									}
									if (isToSkipGroupBySortingExpr === true) {
										continue;
									}
									defaultExpressions.push({fieldName: settings[j].columnKey, dir: cs[i][key].startsWith('asc') ? 'asc' : 'desc'});
								} else {
									defaultExpressions.push({fieldIndex: settings[j].columnKey, dir: cs[i][key].startsWith('asc') ? 'asc' : 'desc'});
								}
							}
						}
					}
				}
            }
			for (i = 0; i < settings.length; i++) {
				if (!settings[i].hasOwnProperty("currentSortDirection")) {
					settings[i].userSet_currentSortDirection = "undefined";
				}
			}
			// copy
			this.options.columnSettings = settings;
			// store default expressions
			this.grid.dataSource.settings.sorting.expressions = defaultExpressions;
			this.grid.dataSource.settings.sorting.defaultFields = defaultExpressions;
		},
		// grid event handlers
		_headerCellRendered: function (event, ui) {
			// decorate sorting logic, apply CSS classes, etc. 
			// apply sortable CSS class
			var cs = this._findColumnSetting(ui.columnKey), i, col,
				initialSorting,
				featureChooserInstance = this.grid.element.data('igGridFeatureChooser');
			//A.T. if the event is fired from another grid, return ! (hierarchical grid scenarios where events are bubbling
			if (event.target.id !== this.grid.element[0].id) {
				return;
			}
			if (ui.isMultiColumnHeader === true) {
				return;
			}
			if (ui.columnKey && cs) {
				this._headers.push({header: ui.th, index: cs.columnIndex});
				if (cs.allowSorting !== false) {
					ui.th.addClass(this.css.sortableColumnHeader);
					// apply title attributes
					if (cs.currentSortDirection === undefined || cs.currentSortDirection === null) {
						ui.th.attr('title', this.options.unsortedColumnTooltip);
					} else {
						ui.th.attr('title', cs.currentSortDirection.startsWith('asc') ? this.options.sortedColumnTooltip.replace('${direction}', $.ig.GridSorting.locale.ascending) : this.options.sortedColumnTooltip.replace('${direction}', $.ig.GridSorting.locale.descending));
					}
					// render span
					$('<span></span>').appendTo(ui.th).addClass(this.css.sortIndicator);
					// keyboard navigation
					// M.H. 11 Jul 2014 Fix for bug #175845: Sorting a column adds '#' to page's URL when you stop click event's propagation of the anchor element.
					$(ui.th).wrapInner('<a href="javascript:void(0);"></a>');
					// if the column has been initially sorted
					if (cs.currentSortDirection !== undefined) {
						this._applySortStyles(ui.th, cs.columnIndex);
					}
				} else {
					// M.H. 11 Jul 2014 Fix for bug #175845: Sorting a column adds '#' to page's URL when you stop click event's propagation of the anchor element.
					$(ui.th).wrapInner('<a href="javascript:void(0);"></a>');
				}
			}
			// M.H. 21 March 2012 Fix for bug #105568
			if (!this._featureChooserInitialized && featureChooserInstance) {
				this._featureChooserInitialized = true;
				this._featureChooserMenuTogglingHandler = $.proxy(this._featureChooserMenuToggling, this);
				this.grid.element.bind('iggridfeaturechoosermenutoggling', this._featureChooserMenuTogglingHandler);
				if (featureChooserInstance._isTouchDevice()) {
					for (i = 0; i < this.grid.options.columns.length; i++) {
						col = this.grid.options.columns[i];
						cs = this._getColumnSettingsByIndex(i);
						if (cs.allowSorting) {
							// M.H. 16 March 2012 Fix for bug #105037
							if (featureChooserInstance && featureChooserInstance._shouldRenderInFeatureChooser(col.key) === true) {
								initialSorting = cs.currentSortDirection;
								if (initialSorting === null) {
									initialSorting = false;
								}
								featureChooserInstance._renderInFeatureChooser(
									col.key,
									{
										name: 'SortingAscending',
										// M.H. 13 Oct. 2011 Fix for bug #91007
										text: this.options.featureChooserSortAsc,
										textHide: this.options.featureChooserSortAsc,
										iconClass: this.css.fcSortIndicatorAscending,
										iconClassOff: this.css.fcSortIndicatorAscending,
										isSelected: initialSorting && typeof initialSorting === 'string'? initialSorting.toLowerCase().indexOf('asc') > -1 : false,
										// M.H. 29 Oct 2012 Fix for bug #120642
										method: $.proxy(this._sortAscFromFeatureChooser, this),
										updateOnClickAll: false,
										groupName: 'toggle',
										groupOrder: 1,
										order: 0,
										type: 'toggle'
									}
								);
								featureChooserInstance._renderInFeatureChooser(
									col.key,
									{
										name: 'SortingDescending',
										// M.H. 13 Oct. 2011 Fix for bug #91007
										text: this.options.featureChooserSortDesc,
										textHide: this.options.featureChooserSortDesc,
										iconClass: this.css.fcSortIndicatorDescending,
										iconClassOff: this.css.fcSortIndicatorDescending,
										isSelected: initialSorting && typeof initialSorting === 'string'? initialSorting.toLowerCase().indexOf('desc') > -1 : false,
										// M.H. 29 Oct 2012 Fix for bug #120642
										method: $.proxy(this._sortDescFromFeatureChooser, this),
										updateOnClickAll: false,
										groupName: 'toggle',
										groupOrder: 1,
										order: 0,
										type: 'toggle'
									}
								);
							}
						}
					}
				}
				if (this.options.mode !== 'single') {
					for (i = 0; i < this.grid.options.columns.length; i++) {
						col = this.grid.options.columns[i];
						if (this._getColumnSettingsByIndex(i).allowSorting) {
							// M.H. 16 March 2012 Fix for bug #105037
							if (featureChooserInstance._shouldRenderInFeatureChooser(col.key) === true) {
								featureChooserInstance._renderInFeatureChooser(
									col.key,
									{
										name: 'MultipleSorting',
										text: this.options.featureChooserText,
										iconClass: this.css.featureChooserModalDialogIcon,
										method: $.proxy(this.openMultipleSortingDialog, this),
										groupName: 'modaldialog',
										groupOrder: 3,
										order: 2
									}
								);
							}
						}
					}
				}
			}
		},
		_featureChooserMenuToggling: function (event, args) {
			var i, expr, isAsc, hasSorting = false,
				columnKey = args.columnKey,
				featureChooserInstance = this.grid.element.data('igGridFeatureChooser'), 
				exprs = this.grid.dataSource.settings.sorting.expressions,
				exprsLength = exprs.length;

			if (!args.isVisible) {
				for (i = 0; i < exprsLength; i++) {
					expr = exprs[i];
					if (expr.fieldName === columnKey) {
						hasSorting = true;
						isAsc = false;
						if (expr.dir && expr.dir.toLowerCase().indexOf('asc') > -1) {
							isAsc = true;
						} 
						featureChooserInstance._setSelectedState('SortingDescending', columnKey, !isAsc, false);
						featureChooserInstance._setSelectedState('SortingAscending', columnKey, isAsc, false);
					}
				}
				if (!hasSorting) {
					featureChooserInstance._setSelectedState('SortingDescending', columnKey, false, false);
					featureChooserInstance._setSelectedState('SortingAscending', columnKey, false, false);
				}
			}
		},
		_sortAscFromFeatureChooser: function (event, columnKey, isSelected) {
			var featureChooserInstance = this.grid.element.data('igGridFeatureChooser');
			
			if (!featureChooserInstance) {
				return;
			}
			featureChooserInstance._setSelectedState('SortingDescending', columnKey, false, false);
			if (isSelected) {
				this.sortColumn(columnKey, 'asc');
			} else {
				this.unsortColumn(columnKey);
			}
		},
		_sortDescFromFeatureChooser: function (event, columnKey, isSelected) {
			var featureChooserInstance = this.grid.element.data('igGridFeatureChooser');
			
			featureChooserInstance._setSelectedState('SortingAscending', columnKey, false, false);
			if (!featureChooserInstance) {
				return;
			}
			if (isSelected) {
				this.sortColumn(columnKey, 'desc');
			} else {
				this.unsortColumn(columnKey);
			}
		},
		_columnFixed: function (args) {
			var i, colInd = args.colInd, cs, fixedTable = this.grid.fixedHeadersTable(),
				isAttachedSortingHandlers = false, fixedColumnsLength = args.fixedColsCount;

			isAttachedSortingHandlers = fixedTable.data('attachedSortingHandlers');
			if (isAttachedSortingHandlers !== true) {   
				fixedTable.data('attachedSortingHandlers', true);
				fixedTable.delegate("thead th", {
					click: this._clickHandler,
					//A.T. 21 Jan 2011 - Fix for bug #63737 - Droping a column in the filter row area results in displaying "javascript:void(0)" in the filter area
					//dragstart: this._dragStartHandler,
					mouseover: this._mouseOverHandler,
					mouseout: this._mouseOutHandler
				});
			}
			cs = this.options.columnSettings[colInd];
			if (cs) {
				this.options.columnSettings.splice(colInd, 1);
				this.options.columnSettings.splice(fixedColumnsLength - 1, 0, cs);
			}
			for (i = 0; i < this.options.columnSettings.length; i++) {
				this.options.columnSettings[i].columnIndex = i;
			}
			//this._initDefaultSettings();
		},
		_columnsRearranged: function (event, ui) {
			this._initDefaultSettings();
		},
		_columnMap: function () {
			// M.H. 26 March 2012 Fix for bug #105568
			var self = this, isMultiple = (self.options.mode !== 'single');

			/* function used by the FeatureChooser */
			return $.map(this.grid.options.columns, function (col, index) {
				//M.H. 14 Feb 2012 - Fix for #101696
				var allowSorting = false;
				if (isMultiple && self._getColumnSettingsByIndex(index).allowSorting) {
					allowSorting = true;
				}
				return { "columnKey": col.key, "enabled": allowSorting};
			});
		},
		_findColumnSetting: function (key) {
			var i;
			for (i = 0; i < this.options.columnSettings.length; i++) {
				if (this.options.columnSettings[i].columnKey === key) {
					return this.options.columnSettings[i];
				}
			}
		},
		_dataRendered: function () {
			var i, cs, expr, col, colKey, gridId = this.grid.element[0].id, ignoreActiveSelection;
			if (!this._loadingIndicator) {
				this._initLoadingIndicator();
			}
			// apply sorting styles
			expr = this._sortingExpressions;
			// fire column sorted if rendering has been triggered by sorting
			if (this._shouldFireColumnSorted) {
				this._trigger(this.events.columnSorted, null, {columnKey: this._curColKey, direction: this._curSortDir, owner: this});
				this._shouldFireColumnSorted = false;
			}
			this._loadingIndicator.hide();
			if (this._currentIndex !== undefined && this._currentIndex !== null && this._currentHeader !== undefined && this._currentHeader !== null) {
				this._applySortStyles(this._currentHeader, this._currentIndex);
			} else if (this.options.persist && this._restoreSorting && expr && expr.length > 0) {
				for (i = 0; i < expr.length; i++) {
					if (expr[i].isGroupBy) {
						continue;
					}
					colKey = expr[i].fieldName;
					cs = this._findColumnSetting(colKey);
					if (cs) {
						cs.currentSortDirection = expr[i].dir;
					}
					col = $('#' + gridId + '_' + colKey);
					col.addClass(this.css.sortableColumnHeaderActive);
					this._currentActiveHeader = col;
					ignoreActiveSelection = true;
					if (i + 1 === expr.length) {
						ignoreActiveSelection = false;
					}
					//this._currentHeader = col;
					//this._columnIndex = col.data('columnIndex');
					this._applySortStyles(col, col.data('columnIndex'), colKey, ignoreActiveSelection);
				}
				
			}
			if (this._hc === undefined) {
				this._hc = this.grid.container().find('.ui-iggrid-expandheadercell').length > 0;
			}
			// if there is virtualization enabled, set the scrolltop to 0. 
			//A.T. 2 March - fix for bug #99940
			if (this.grid.options.rowVirtualization || this.grid.options.virtualization) {
				$("#" + this.grid.element.attr('id') + "_scrollContainer").scrollTop(0);
			}
		},
		_onUIDirty: function (e, args) {
			// if sorting itself has triggered the event, return
			var i, j, exprs = this.grid.dataSource.settings.sorting.expressions, defaultExprs = this.grid.dataSource.settings.sorting.defaultFields,
				cs = this.options.columnSettings, skip = false;
			// A.T. 23 Aug 2011 - add additional checks so that events don't propagate across hierarchical grids
			if (args.owner === this || args.owner.element[0].id !== this.element[0].id) {
				return;
			}
			this._currentIdentifier = null;
			this._currentIndex = null;
			this._currentHeader = null;
			this._clearUi(true);

			//A.T. Fix for bug #91651
			// clear data source sorting expressions
			for (i = 0; i < exprs.length; i++) {
				skip = false;
				for (j = 0; j < cs.length; j++) {
					if (cs[j].columnKey === exprs[i].fieldName && cs[j].userSet_currentSortDirection) {
						skip = true;
						break;
					}
				}
				if (!skip) {
					if (exprs.length > i) {
						$.ig.removeFromArray(exprs, i);
					}
					if (defaultExprs.length > i) {
						$.ig.removeFromArray(defaultExprs, i);
					}
				}
			}
		},
		_clearUi: function (resetAll) {
			var i, header, csd, isMCH = this.grid._isMultiColumnGrid, persist = this.options.persist;
			for (i = 0; this._headers && i < this._headers.length; i++) {
				// A.T. fix for bug 72281 - (Related to bug #67517)
				csd = this.options.columnSettings[i].userSet_currentSortDirection;
                // M.H. 13 Mar 2014 Fix for bug #166980: When data bind sorting applies an extra sorting indicator when there are multi column headers
                if ((isMCH || persist) && this.options.columnSettings[i].columnKey) {
                    header = $('#' + this.grid.element[0].id + '_' + this.options.columnSettings[i].columnKey);
                } else {
                    header = this._headers[i].header;
                }
				if (csd === undefined || csd === null || csd === "undefined") {
					//this._clearSortStates(this._headers[i].header, resetAll === true ? null : this._headers[i].index);
					this._clearSortState(header, i, this.options.columnSettings[i].columnKey);
					//A.T. Fix for bug #73496
					// M.H. 26 March 2012 Fix for bug #105568
					if (this.options.mode !== "single") {
						delete this.options.columnSettings[i].currentSortDirection;
						// exclude the expression from the expressions in the data source
						this._excludeExpr(this.options.columnSettings[i].columnKey);
					}
				} else {
					// apply sort State
					this._applySortStyles(header, i);
				}
				header.removeClass(this.css.sortableColumnHeaderActive).removeClass(this.css.sortableColumnHeaderHover).removeClass(this.css.sortableColumnAscending).removeClass(this.css.sortableColumnDescending).addClass(this.grid.css.headerClass);
				// M.H. 28 Feb 2014 Fix for bug #165671: When there is feature chooser in the header calling "Clear Filter" removes ui-iggrid-headercell-featureenabled class from the element.
				if (!header.hasClass(this.grid.css.headerCellFeatureEnabledClass)) {
					// M.H. 27 Sep 2013 Fix for bug #153515: When Sorting is enabled feature chooser icon and header text get misaligned after dataBind.
					header.addClass(this.grid.css.headerCellFeatureEnabledClass);
				}
				// A.T. 3 May - fix for #102444
				if (this.options.columnSettings[i].allowSorting) {
					header.addClass(this.css.sortableColumnHeader);
				}
			}
		},
		_virtualHorizontalScroll: function (event, args) {
			// get the current col index from args, and reinitialize the header cells 
			var start = args.startColIndex, end = args.endColIndex, i, j, cs = this.options.columnSettings, header,
				ths = this.grid.headersTable().find("thead > tr").first().find("th").not("[data-skip=true]"),
				visibleColumns = this.grid._visibleColumns();
			for (i = 0; i < ths.length; i++) {
				header = ths.eq(i);
				// 1. clear && 2. apply styles
				// set correct key/values using data()
				this._clearSortState(header, i);
				header.removeClass(this.css.sortableColumnHeaderActive)
					.removeClass(this.css.sortableColumnHeaderHover)
					.removeClass(this.css.sortableColumnAscending)
					.removeClass(this.css.sortableColumnDescending)
					.addClass(this.grid.css.headerClass)
					.addClass(this.css.sortableColumnHeader);
				//this._applySortStyles(this._headers[i].header, i);
				// remove the column styles
			}
			for (i = start; i <= end; i++) {
				header = ths.eq(i - start);
				header.data('columnIndex', i);
				for (j = 0; j < cs.length; j++) {
					if (cs[j].currentSortDirection && cs[j].columnKey === visibleColumns[i].key) {
						this._applySortStyles(header, i);
						// don't break cause it may be multi-col sorting
					}
				}
			}
		},
		_columnsCollectionModified: function (event, args) {
			// M.H. 3 Dec 2013 Fix for bug #158002: Sorting and Summary styles are applied after sorting of parent grid
			if (args.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}
			// we need to reset column settings' indices
			var i, j, found, colKey, cs, col, colApplySelection, indexApplySelection;

			for (i = 0; i < this.options.columnSettings.length; i++) {
				// find the column corresponding to this column setting
				j = 0;
				found = false;
				for (j = 0; j < this.grid._visibleColumns().length; j++) {
					if (this.grid._visibleColumns()[j].key === this.options.columnSettings[i].columnKey) {
						found = true;
						colKey = this.grid._visibleColumns()[j].key;
						break;
					}
				}
				if (found) {
					this.options.columnSettings[i].columnIndex = j;
					// M.H. 28 March 2012 Fix for bug #106392
					cs = this._findColumnSetting(colKey);

					if (cs &&
							cs.currentSortDirection !== undefined &&
							this.options.applySortedColumnCss !== false) {
						// M.H. 30 March 2012 Fix for bug #106392
						col = $('#' + this.grid.element[0].id + '_' + colKey);

						this._applySortStyles(col, col.data('columnIndex'), colKey, true);
					}
				}
			}
			// M.H. 10 April 2012 Fix for bug #107671
			if (this._currentIdentifier) {
				if ($.type(this._currentIdentifier) === 'number') {
					if (this._currentIndex !== undefined && this._currentIndex !== null && this._currentHeader !== undefined && this._currentHeader !== null) {
						this._applySortStyles(this._currentHeader, this._currentIndex);
					}
				} else {
					colApplySelection = $('#' + this.grid.element[0].id + '_' + this._currentIdentifier);
					indexApplySelection = colApplySelection.data('columnIndex');
					if ($.type(indexApplySelection) === 'number') {
						this._applySortStyles(colApplySelection, indexApplySelection, this._currentIdentifier);
					}
				}
			}

			// A.T. 10 Oct Fix for #91161
			$('#' + this.element[0].id + ' thead th').removeClass(this.css.sortableColumnHeaderHover);
		},
		// M.H. 28 May 2014 Fix for bug #172200: Memory leak when using the features of the grid
		_detachEvents: function () {
			if (this._headerCellRenderedHandler) {
				this.grid.element.unbind('iggridheadercellrendered', this._headerCellRenderedHandler);
			}
			if (this._virtualHorizontalScrollHandler) {
				this.grid.element.unbind('iggridvirtualhorizontalscroll', this._virtualHorizontalScrollHandler);
			}
			if (this._uiDirtyHandler) {
				this.grid.element.unbind('iggriduidirty', this._uiDirtyHandler);
			}
			if (this._headerRenderedHandler) {
				this.grid.element.unbind('iggridheaderrendered', this._headerRenderedHandler);
			}
			if (this._columnsCollectionModifiedHandler) {
				// M.H. 29 Oct 2012 Fix for bug #120642
				this.grid.element.unbind("iggridcolumnscollectionmodified", this._columnsCollectionModifiedHandler);
			}
			if (this._columnsRearangedHandler) {
				this.grid.element.unbind('iggridcolumnmovingcolumnmoved', this._columnsRearangedHandler);
			}
			// M.H. 23 Sep 2013 Fix for bug #152875: igFeatureChooserPopover doesn't destroy correctly
			if (this._featureChooserMenuTogglingHandler) {
				this.grid.element.unbind('iggridfeaturechoosermenutoggling', this._featureChooserMenuTogglingHandler);
			}
		},
		destroy: function () {
			// unbind events, removes added sorting elements, etc. 
			var i, a, fc, header, span, text, modalDialog = $('#' + this.grid.element[0].id + '_multiplesorting_modalDialog');
			if (!this.grid) {
				return;
			}
			$('#' + this.element[0].id).undelegate("thead th", "dragstart", this._dragStartHandler);
			$('#' + this.element[0].id).undelegate("thead th", "mouseover", this._mouseOverHandler);
			$('#' + this.element[0].id).undelegate("thead th", "mouseout", this._mouseOutHandler);
			$('#' + this.element[0].id).undelegate("thead th", "click", this._clickHandler);
			$(document).undelegate("#" + this.element[0].id + "_headers thead th", "dragstart", this._dragStartHandler);
			$(document).undelegate("#" + this.element[0].id + "_headers thead th", "mouseover", this._mouseOverHandler);
			$(document).undelegate("#" + this.element[0].id + "_headers thead th", "mouseout", this._mouseOutHandler);
			$(document).undelegate("#" + this.element[0].id + "_headers thead th", "click", this._clickHandler);
			$('#' + this.element[0].id).undelegate("thead th a", "keydown", this._keyDownHandler);
			$('#' + this.element[0].id).undelegate("thead th a", "focus", this._focusHandler);
			$('#' + this.element[0].id).undelegate("thead th a", "blur", this._blurHandler);
			$(document).undelegate("#" + this.element[0].id + "_headers thead th a", "keydown", this._keyDownHandler);
			$(document).undelegate("#" + this.element[0].id + "_headers thead th a", "focus", this._focusHandler);
			$(document).undelegate("#" + this.element[0].id + "_headers thead th a", "blur", this._blurHandler);
			// M.H. 29 Oct 2012 Fix for bug #120642
			$('#' + this.element[0].id).undelegate("thead th a:not([th-remove-focus])", {
				keydown: this._keyDownHandler,
				focus: this._focusHandler,
				blur: this._blurHandler
			});
			// M.H. 29 Oct 2012 Fix for bug #120642
			$(document).undelegate("#" + this.element[0].id + "_headers thead th a:not([th-remove-focus])", {
				keydown: this._keyDownHandler,
				focus: this._focusHandler,
				blur: this._blurHandler
			});
			// M.H. 28 May 2014 Fix for bug #172200: Memory leak when using the features of the grid
			this._detachEvents();
			delete this._blurHandler;
			delete this._clickHandler;
			delete this._headerCellRenderedHandler;
			delete this._focusHandler;
			delete this._keyDownHandler;
			delete this._mouseOutHandler;
			delete this._mouseOverHandler;
			delete this._dragStartHandler;
			delete this._uiDirtyHandler;
			delete this._virtualHorizontalScrollHandler;
			delete this._headerRenderedHandler;
			delete this._columnsRearangedHandler;
			// remove sorted classes for columns
			this.grid.element.find('.ui-iggrid-colasc').removeClass('ui-iggrid-colasc ui-state-highlight');
			this.grid.element.find('.ui-iggrid-coldesc').removeClass('ui-iggrid-coldesc ui-state-highlight');
			this._clearUi(true);
			// clear styling and markup
			for (i = 0; this._headers && i < this._headers.length; i++) {
				header = this._headers[i].header;
				header.removeClass('ui-iggrid-sortableheader ui-state-default ui-state-active ui-state-hover ui-state-focus');
				header.attr('title', '');
				span = header.find('a span');
				text = span.text();
				//span.remove();
				a = header.find('a:not([th-remove-focus])');
				$('<span>' + text + '</span>').appendTo(header).addClass('ui-iggrid-headertext');
				a.remove();
				//delete header;
			}
			fc = this.grid.element.data('igGridFeatureChooser');
			if (fc && this.renderInFeatureChooser) {
				fc._removeFeature('SortingAscending');
				fc._removeFeature('SortingDescending');
				fc._removeFeature('MultipleSorting');
			}
			this._headers = null;
			// M.H. 29 Oct 2012 Fix for bug #120642
			if (this._loadingIndicator) {
				delete this._loadingIndicator;
			}
			modalDialog.igGridModalDialog('getCaptionButtonContainer');
			modalDialog.remove();

			$.Widget.prototype.destroy.apply(this, arguments);
			return this;
		},
		_renderMultipleSortingDialog: function () {
			var $buttonOK, containment,
				self = this,
				o = this.options,
				modalDialogId = this.grid.element[0].id + '_multiplesorting_modalDialog',
				$captionButtonContainer,
				modalDialog;

			if (this.options.sortingDialogContainment === "owner") {
				containment = this.grid.container();
            } else {
                containment = 'window';
            }
			$('#' + modalDialogId).remove();
			modalDialog = $('<div></div>')
				.appendTo(this.grid._rootContainer())
				.attr('id', modalDialogId);
			modalDialog.igGridModalDialog({
				containment: containment,
				buttonApplyText: o.modalDialogButtonApplyText,
				buttonCancelText: o.modalDialogButtonCancelText,
				renderFooterButtons: !o.modalDialogSortOnClick,
				modalDialogCaptionText: o.modalDialogCaptionText,
				modalDialogWidth: o.modalDialogWidth,
				modalDialogHeight: o.modalDialogHeight,
				animationDuration: o.modalDialogAnimationDuration,
				// M.H. 8 May 2012 Fix for bug #110344
				gridContainer: this.grid.container(),
				modalDialogOpening: function (event, args) {
					// M.H. 21 March 2012 Fix for bug #105460
					var noCancel = self._trigger(self.events.modalDialogOpening, null, {modalDialogElement: modalDialog, owner: self});
					if (noCancel) {
						self._multiplesortingDialogOpening(event, args);
						self._trigger(self.events.modalDialogOpened, null, {modalDialogElement: modalDialog, owner: self});
					}
					return noCancel;
				},
				modalDialogMoving: function (e, ui) {
					self._trigger(self.events.modalDialogMoving, null,
						{
							modalDialogElement: e.target,
							owner: self,
							originalPosition: ui.originalPosition,
							position: ui.position
						});
				},
				modalDialogClosing: function (event, args) {
					return self._trigger(self.events.modalDialogClosing, null, {modalDialogElement: modalDialog, owner: self});
				},
				modalDialogClosed: function (event, args) {
					self._trigger(self.events.modalDialogClosed, null, {modalDialogElement: modalDialog, owner: self});
				}
			});
			if (o.modalDialogSortOnClick) {
				// show close button
				$captionButtonContainer = modalDialog.igGridModalDialog('getCaptionButtonContainer');

				$('<span></span>')
					.bind("click.hiding", function (event) {
						modalDialog.igGridModalDialog('closeModalDialog', true);
						event.preventDefault();
						event.stopPropagation();
						return false;
					})
					.addClass('ui-icon ui-icon-closethick')
					.appendTo(
						$('<a></a>')
							.appendTo($captionButtonContainer)
							.attr('title', $.ig.GridHiding.locale.columnChooserCloseButtonTooltip)
							.attr('href', '#')
							.attr('role', 'button')
							.addClass('ui-dialog-titlebar-close ui-corner-all')
					);
			} else {
				$captionButtonContainer = modalDialog.igGridModalDialog('getCaptionButtonContainer');
				$buttonOK = $('#' + this.grid.element[0].id + '_multiplesorting_modalDialog_footer_buttonok');
				$buttonOK.bind('igbuttonclick', function (e) { self._multiplesortingDialogButtonOKClick(e); e.preventDefault(); });
			}
		},
		openMultipleSortingDialog: function () {
			/* Open multiple sorting dialog */
			var modalDialog = $('#' + this.grid.element[0].id + '_multiplesorting_modalDialog');
			modalDialog.igGridModalDialog('openModalDialog');
		},
		closeMultipleSortingDialog: function () {
			/* Close multiple sorting dialog */
			var modalDialog = $('#' + this.grid.element[0].id + '_multiplesorting_modalDialog');
			modalDialog.igGridModalDialog('closeModalDialog');
		},
		_multiplesortingDialogOpening: function () {
			this._tempExpr = this.grid.dataSource.settings.sorting.expressions.slice(0);
			this.renderMultipleSortingDialogContent(true);
		},
		renderMultipleSortingDialogContent: function (isToCallEvents) {
			/* Renders content of multiple sorting dialog - sorted and unsorted columns. */
			var $content, $sortedColumns, $unsortedColumns, i, j, noCancel = true,
				self = this,
				//o = this.options,
				columns = this.grid.options.columns,
				css = this.css,
				se = this.grid.dataSource.settings.sorting.expressions,
				seLength = se.length,
				sortedColumns = [],
				modalDialog = $('#' + this.grid.element[0].id + '_multiplesorting_modalDialog');
			if (isToCallEvents) {
				noCancel = this._trigger(this.events.modalDialogContentsRendering, null, {modalDialogElement: modalDialog, owner: this});
			}
			if (noCancel) {
				this.removeDialogClearButton();
				$content = modalDialog.igGridModalDialog('getContent');
				$content.empty();
				$sortedColumns = $('<div></div>')
					.attr('id', this.grid.element[0].id + "_multiplesorting_modalDialog_sortedcolumns")
					.addClass(css.dialogSortedColumns)
					.appendTo($content);
				$unsortedColumns = $('<div></div>')
					.attr('id', this.grid.element[0].id + "_multiplesorting_modalDialog_unsortedcolumns")
					.addClass(css.dialogUnsortedColumns)
					.appendTo($content);

				$('<ul></ul>')
					.addClass(css.dialogSortedColumnsList)
					.appendTo($sortedColumns);
				$('<ul></ul>')
					.addClass(css.dialogUnsortedColumnsList)
					.appendTo($unsortedColumns);

				$.each(columns, function (columnIndex, column) {
					var cs, columnIdentifier, direction;
					cs = self._getColumnSettingsByIndex(columnIndex);
					if (cs === null || cs === undefined || cs.allowSorting === false) {
						return true;
					}
					columnIdentifier = cs.columnKey || cs.columnIndex || column.key;
					for (i = 0; i < self._tempExpr.length; i++) {
						if (self._tempExpr[i].fieldName === columnIdentifier) {
							break;
						}
					}
					if (i !== self._tempExpr.length) {
						sortedColumns.push({column: column, columnIndex: cs.columnIndex, dir: self._tempExpr[i].dir, columnIdentifier: columnIdentifier});
					} else {
						// M.H. 16 Sep 2013 Fix for bug #139357: Sorting dialog doesn't take into account the firstSortDirection option
						direction = cs.currentSortDirection || self.options.firstSortDirection;
						self._renderDialogUnsortedColumn(column, cs.columnIndex, direction, columnIdentifier);
					}
				});
				// order of sorting depends on order in sort expressions - that's why show columns in modal dialog according to order in sorting expressions
				for (i = 0; i < seLength; i++) {
					for (j = 0; j < sortedColumns.length; j++) {
						if (se[i].fieldName === sortedColumns[j].columnIdentifier) {
							//orderedSortedColumns.push(sortedColumns[j]);
							self._renderDialogSortedColumn(sortedColumns[j].column, sortedColumns[j].columnIndex, sortedColumns[j].dir, sortedColumns[j].columnIdentifier);
							break;
						}
					}
				}

				//this._addSlideButtonSortingColumns();
				if (isToCallEvents) {
					this._trigger(this.events.modalDialogContentsRendered, null, {modalDialogElement: modalDialog, owner: this});
				}
				// M.H. 28 March 2012 Fix for bug #107039
				if (this._checkRenderButtonReset()) {
					this._renderDialogButtonClearAll();
				}
			}
		},
		_addSlideButtonSortingColumns: function () {
			var css = this.css,
				o = this.options,
				$sortedColumns = $('#' + this.grid.element[0].id + "_multiplesorting_modalDialog_sortedcolumns"),
				buttonId = this.grid.element[0].id + '_multiplesorting_modalDialog_slidebutton',
				$button,
				innerHTML;

			innerHTML = '<div class="' + css.dialogSlideArea + '">' +
				'	<div class="' + css.dialogSlideAreaContainer + '">' +
				'		<button id="' + buttonId + '" class="' + css.dialogButtonSlide + '" role="button" aria-disabled="false" title="' + o.dialogButtonSlideCaption + '">' +
				'			<span class="' + css.dialogButtonSlideContainer + '"></span>' +
				'			<span class="ui-button-text">' + o.dialogButtonSlideCaption + '</span>' +
				'		</button>' +
				'	</div>' +
				'</div>';
			$(innerHTML).insertAfter($sortedColumns);
			$button = $('#' + buttonId);
			$button.bind({
				click: function (e, args) {
					$sortedColumns.slideToggle("slow");
					$(this).find('span:eq(0)').toggleClass(css.dialogButtonSlideUp);
					return false;
				}
			});
		},
		_renderDialogSortedColumn: function (column, columnIndex, direction, columnIdentifier) {
			var	self = this, $li, css = this.css, $buttonUnsort, liHTML,
				o = this.options,
				buttonAscDescId = this.grid.element[0].id + "_" + columnIdentifier + "_multiplesorting_modalDialog_sortedcolumns_buttonascdesc",
				buttonUnsortId = this.grid.element[0].id + "_" + columnIdentifier + "_multiplesorting_modalDialog_sortedcolumns_buttonunsort",
				$ul = $('#' + this.grid.element[0].id + "_multiplesorting_modalDialog_sortedcolumns ul");

			// M.H. 12 Feb 2013 Fix for bug #130430 - Related with bug 122446
			// The cruel idea is to cause the IE8 to flush the dialog rendering by just reading the width value
			$ul.css('width');
			$li = $('<li></li>')
				.attr('id', self.grid.element[0].id + '_' + columnIdentifier + '_multiplesorting_sorted_li')
				.addClass(css.dialogSortedColumnsItem);
			$li.appendTo($ul);
			//this._insertColumnModalDialog($ul, $li, columnIndex);
			if (columnIndex !== null && columnIndex !== undefined) {
				$li.attr('li-order', columnIndex);
			}
			liHTML = '<span id="' + buttonAscDescId + '" class="' + css.dialogButtonAsc + '" role="button" title="' + o.modalDialogCaptionButtonDesc + '" >' +
				'	<span class="' + css.dialogButtonAscIcon + '"></span>' +
				'</span>' +
				'<span class="' + css.dialogSortedColumnTextContainer + '">' + column.headerText + '</span>' +
				'<button id="' + buttonUnsortId + '" class="' + css.dialogButtonUnsort + '" role="button" title="' + o.modalDialogCaptionButtonUnsort + '" >' +
				'	<span class="' + css.dialogButtonUnsortContainer + '"></span>' +
				'	<span class="ui-button-text">' + o.modalDialogCaptionButtonUnsort + '</span>' +
				'</button>';
			$li.bind({
				click: function (e, args) {
					self._currentIdentifier = columnIdentifier;
					self._dialogButtonAscDescClick(columnIdentifier);
					// M.H. 28 March 2012 Fix for bug #107039
					if (self._checkRenderButtonReset()) {
						self._renderDialogButtonClearAll();
					} else {
						self.removeDialogClearButton();
					}

					e.preventDefault();
					e.stopPropagation();
				}
			});
			$li.html(liHTML);
			$buttonUnsort = $('#' + buttonUnsortId);
			if (direction !== undefined) {
				if (direction.indexOf('asc') !== -1) {
					self._setDialogButtonAscDesc(true, columnIdentifier);
					self._setTempExpr(columnIdentifier, 'asc');
				} else {
					self._setDialogButtonAscDesc(false, columnIdentifier);
					self._setTempExpr(columnIdentifier, 'desc');
				}
			} else {
				self._setDialogButtonAscDesc(true, columnIdentifier);
				self._setTempExpr(columnIdentifier, 'asc');
			}
			$buttonUnsort.bind({
				click: function (e, args) {
					var noCancel, modalDialog = $('#' + self.grid.element[0].id + '_multiplesorting_modalDialog');

					noCancel = self._trigger(self.events.modalDialogButtonUnsortClick, e, {modalDialogElement: modalDialog, owner: self, columnKey: columnIdentifier});
					if (noCancel) {
						$li.remove();
						if (o.modalDialogSortOnClick === true) {
							self.unsortColumn(columnIdentifier);
						} else {
							self._setTempExpr(columnIdentifier);
						}
						self._renderDialogUnsortedColumn(column, columnIndex, direction, columnIdentifier);
						// M.H. 28 March 2012 Fix for bug #107039
						if (self._checkRenderButtonReset()) {
							self._renderDialogButtonClearAll();
						} else {
							self.removeDialogClearButton();
						}
					}
					e.preventDefault();
					e.stopPropagation();
				},
				mouseover: function (e, args) {
					if (!$(this).hasClass(css.dialogButtonsHover)) {
						$(this).addClass(css.dialogButtonsHover);
					}
				},
				mouseout: function (e, args) {
					if ($(this).hasClass(css.dialogButtonsHover)) {
						$(this).removeClass(css.dialogButtonsHover);
					}
				}
			});
		},
		_dialogButtonAscDescClick: function (columnIdentifier) {
			var o = this.options,
				noCancel,
				modalDialog = $('#' + this.grid.element[0].id + '_multiplesorting_modalDialog'),
				$buttonAscDesc = $('#' + this.grid.element[0].id + "_" + columnIdentifier + "_multiplesorting_modalDialog_sortedcolumns_buttonascdesc"),
				isAsc = $buttonAscDesc.data('isAsc');

			noCancel = this._trigger(this.events.modalDialogSortingChanged, null, {modalDialogElement: modalDialog, owner: this, columnKey: columnIdentifier, isAsc: !isAsc});
			if (noCancel) {
				if (isAsc === true) {
					if (o.modalDialogSortOnClick === true) {
						this.sortColumn(columnIdentifier, "descending", this._getHeaderCellByIdentifier(columnIdentifier));
					} else {
						this._setTempExpr(columnIdentifier, 'desc');
					}
					this._setDialogButtonAscDesc(false, columnIdentifier);
				} else {
					if (o.modalDialogSortOnClick === true) {
						this.sortColumn(columnIdentifier, "ascending", this._getHeaderCellByIdentifier(columnIdentifier));
					} else {
						this._setTempExpr(columnIdentifier, 'asc');
					}
					this._setDialogButtonAscDesc(true, columnIdentifier);
				}

			}
		},
		_setDialogButtonAscDesc: function (isAsc, columnIdentifier) {
			var css = this.css,
				buttonAscDescId = this.grid.element[0].id + "_" + columnIdentifier + "_multiplesorting_modalDialog_sortedcolumns_buttonascdesc",
				$buttonAscDesc = $('#' + buttonAscDescId),
				$spanIcon = $buttonAscDesc.find('span:eq(0)');

			$buttonAscDesc.data('isAsc', isAsc);
			// M.H. 20 March 2012 Fix for bug #105078
			if (isAsc === true) {
				$buttonAscDesc
					.attr('title', this.options.modalDialogCaptionButtonDesc)
					.removeClass(css.dialogButtonDesc)
					.addClass(css.dialogButtonAsc);
				$spanIcon
					.removeClass(css.dialogButtonDescIcon)
					.addClass(css.dialogButtonAscIcon);
				this._setTempExpr(columnIdentifier, 'asc');
			} else {
				$buttonAscDesc
					.attr('title', this.options.modalDialogCaptionButtonAsc)
					.removeClass(css.dialogButtonAsc)
					.addClass(css.dialogButtonDesc);
				$spanIcon
					.removeClass(css.dialogButtonAscIcon)
					.addClass(css.dialogButtonDescIcon);
				this._setTempExpr(columnIdentifier, 'desc');
			}
		},
		_setTempExpr: function (colKey, dir) {
			var i, expr = this._tempExpr;

			for (i = 0; i < expr.length; i++) {
				if (expr[i].fieldName === colKey) {
					expr.splice(i, 1);
					if (dir === null || dir === undefined) {
						this._tempExpr = expr;
						return;
					}
				}
			}
			this._tempExpr = expr.concat([{fieldName: colKey, dir: dir}]);
		},
		_renderDialogUnsortedColumn: function (column, columnIndex, direction, columnIdentifier) {
			var self = this, $li, $a,
				o = this.options,
				css = this.css,
				$ul = $('#' + this.grid.element[0].id + "_multiplesorting_modalDialog_unsortedcolumns ul");
			
			// M.H. 12 Feb 2013 Fix for bug #130430 - Related with bug 122446
			// The cruel idea is to cause the IE8 to flush the dialog rendering by just reading the width value
			$ul.css('width');
			$li = $('<li></li>')
				.attr('id', self.grid.element[0].id + '_' + columnIdentifier + '_multiplesorting_unsorted_li')
				.addClass(css.dialogUnsortedColumnsItem)
				.append('<span class="' + css.dialogUnsortedColumnsSortByButton + '"><a href="#"></a></span> <span class="' + css.dialogItemText + '">' + column.headerText + '</span>');
			this._insertColumnModalDialog($ul, $li, columnIndex);
			if (columnIndex !== null && columnIndex !== undefined) {
				$li.attr('li-order', columnIndex);
			}
			$a = $li.find('a:first');
			$a.addClass(css.modalDialogSortByColumn);
			$a.html(o.modalDialogSortByButtonText);
			$li.bind({
				click: function (e, args) {
					var noCancel, modalDialog = $('#' + self.grid.element[0].id + '_multiplesorting_modalDialog');
					noCancel = self._trigger(self.events.modalDialogSortClick, e, {modalDialogElement: modalDialog, owner: self, columnKey: columnIdentifier});

					if (noCancel) {
						$li.remove();
						self._renderDialogSortedColumn(column, columnIndex, direction, columnIdentifier);
						if (o.modalDialogSortOnClick) {
							// M.H. 9 April 2012 Fix for bug #108488
							self.sortColumn(columnIdentifier, null, self._getHeaderCellByIdentifier(columnIdentifier));
//							self.grid.dataSource.settings.sorting.expressions = self._tempExpr;
//							self.sortMultiple();
						} else {
							// M.H. 28 March 2012 Fix for bug #107039
							if (self._checkRenderButtonReset()) {
								self._renderDialogButtonClearAll();
							} else {
								self.removeDialogClearButton();
							}
						}
					}
					e.preventDefault();
					e.stopPropagation();
				}
			});
		},
		_checkRenderButtonReset: function () {
			// M.H. 28 March 2012 Fix for bug #107039
			var i, j, cs, columnKey,
				expr = this._tempExpr;
			// M.H. 19 July 2012 Fix for bug #105514
			this._isResetClick = false;
			for (i = 0; i < this.options.columnSettings.length; i++) {
				cs = this.options.columnSettings[i];
				if (cs.allowSorting === false) {
					continue;
				}
				columnKey = cs.columnKey;

				for (j = 0; j < expr.length; j++) {
					if (expr[j].fieldName === columnKey) {
						if (cs.userSet_currentSortDirection !== expr[j].dir) {
							return true;
						}
						break;
					}
				}
				// M.H. 10 Apr 2014 Fix for bug #169650: Missing headers in Sorting dialog after clicking reset button in multiple sorting dialog
				if (j === expr.length && cs.userSet_currentSortDirection !== "undefined" && cs.userSet_currentSortDirection !== undefined) {
					return true;
				}
			}
			// M.H. 19 July 2012 Fix for bug #105514
			this._isResetClick = true;
			return false;
		},
		removeDialogClearButton: function () {
			/* Remove clear button for multiple sorting dialog */
			$('#' + this.grid.element[0].id + '_sorting_modalDialog_reset_button').remove();
		},
		_renderDialogButtonClearAll: function () {
			if (this.options.modalDialogSortOnClick === true) {
				return;
			}
			var self = this,
				o = this.options,
				resetButtonId = self.grid.element[0].id + '_sorting_modalDialog_reset_button',
				modalDialog = $('#' + this.grid.element[0].id + '_multiplesorting_modalDialog'),
				$captionButtonContainer,
				$resetButton;

			if ($('#' + resetButtonId).length === 0) {
				$captionButtonContainer = modalDialog.igGridModalDialog('getCaptionButtonContainer');
				$resetButton = $('<button></button>')
					.attr('id', resetButtonId)
					.appendTo($captionButtonContainer);

				$resetButton.igButton({
					labelText: o.modalDialogResetButtonLabel,
					click: function (e) {
						var noCancel, i, cs = self.options.columnSettings;
						noCancel = self._trigger(self.events.modalDialogButtonResetClick, e, {modalDialogElement: modalDialog, owner: self});
						if (noCancel) {
							// M.H. 21 March 2012 Fix for bug #105464
							// M.H. 28 March 2012 Fix for bug #107039
							self._tempExpr = [];
							for (i = 0; i < cs.length; i++) {
								// M.H. 10 Apr 2014 Fix for bug #169650: Missing headers in Sorting dialog after clicking reset button in multiple sorting dialog
								if (cs[i].allowSorting !== false &&
										cs[i].userSet_currentSortDirection !== "undefined" &&
										cs[i].userSet_currentSortDirection !== undefined) {
									self._tempExpr.push({fieldName: cs[i].columnKey, dir: cs[i].userSet_currentSortDirection});
								}
							}
							self.renderMultipleSortingDialogContent(false);
							self.removeDialogClearButton();
							// M.H. 19 July 2012 Fix for bug #105514
							self._isResetClick = true;
						}
					}
				});
			}
		},
		_multiplesortingDialogButtonOKClick: function (e, args) {
			var noCancel, modalDialog = $('#' + this.grid.element[0].id + '_multiplesorting_modalDialog');

			noCancel = this._trigger(this.events.modalDialogButtonApplyClick, null, {modalDialogElement: modalDialog, owner: this, columnsToSort: this._tempExpr});
			if (noCancel) {
				this.grid.dataSource.settings.sorting.expressions = this._tempExpr;
				this.sortMultiple();
				modalDialog.igGridModalDialog('closeModalDialog');
			}
		},
		_insertColumnModalDialog: function ($ul, $li, pos) {
			var i, $currLi, currPos, listItems = $ul.find('li'), listItemsLength = listItems.length;
			if (listItemsLength === 0 || pos === null || pos === undefined) {
				$li.appendTo($ul);
				return;
			}
			for (i = 0; i < listItemsLength; i++) {
				$currLi = $(listItems[i]);
				currPos = $currLi.attr('li-order');
				if (currPos >= pos) {
					$li.insertBefore($currLi);
					break;
				}
			}
			if (i === listItemsLength) {
				$li.appendTo($ul);
			}
		},
		_getColumnSettings: function (index, key) {
			var i, foundByIndex = null;
			for (i = 0; i < this.options.columnSettings.length; i++) {
				if (this.options.columnSettings[i].columnKey === key) {
					foundByIndex = this.options.columnSettings[i];
					break;
				}

				if (this.options.columnSettings[i].columnIndex === index) {
					foundByIndex = this.options.columnSettings[i];
					break;
				}
			}
			return foundByIndex;
		},
		_getColumnSettingsByIndex: function (index) {
			var key = this.grid.options.columns[index].key;

			return this._getColumnSettings(index, key);
		},
		_headerRendered: function (event, ui) {
			//prevent handling of other grids' events in the case of hierarchical grid
			if (ui.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}
			// M.H. 4 Mar 2014 Fix for bug #165697: Control automatically sorts the records while resizing the column using mouse
			if (this.grid.element.data('igGridResizing')) {
				this._resizing = this.grid.element.data('igGridResizing');
			}
			if (!this._columnFixing && this.grid.element.data("igGridColumnFixing")) {
				this._columnFixing = this.grid.element.data("igGridColumnFixing");
			}
			// M.H. 26 March 2012 Fix for bug #105568
			if (this.options.mode !== 'single') {
				this._renderMultipleSortingDialog();
				//this.openMultipleSortingDialog();
			}
		},
		// M.H. 11 Mar 2014 Fix for bug #166528: Sorting and Filtering does not persist its state, when they are applied to unbound column
		_getDataColumnSortingExpressions: function (se) {
			// return only those sorting expressions that are for data bound columns(for which property unbound is not equal to TRUE)
			if (!this.grid._hasUnboundColumns) {
				return se;
			}
			var grid = this.grid, newSE;
			newSE = $.grep(se, function (s) {
				var col = grid.columnByKey(s.fieldName);
				return !col || col.unbound !== true;
			});
			return newSE;
		},
		_saveSortingExpressions: function () {
			if (this.options.persist) {
				var se;
				// M.H. 26 Feb 2014 Fix for bug #165287: Sorting arrow indicator appear after databinding when there are initial sorting settings and persist: true
				// we are using restoreSorting flag to not iterate through all colulmnsetting every time we save sorting expressions 
				// only when 
				// 1. There aren't set sorting expressions
				// 2. It is called for the first time we are sorting(after injectGrid is called)
				if (this._restoreSorting === undefined || this._restoreSorting) {
					// we should delete current sort direction because we do not need to use it for persistence
					// in clearUI it is used and is called appliedSortStyles
					$.each(this.options.columnSettings, function (i, setting) {
						delete setting.userSet_currentSortDirection;
					});
				}
				// preseerve only data sorting expressions that are of data boundable columns(unbound <> TRUE)
				se = this._getDataColumnSortingExpressions(this.grid.dataSource.settings.sorting.expressions);
				//if (this.element.closest('.ui-iggrid-root').data('igGrid')) {
				this.grid._savePersistenceData(se, 'sorting', this.grid.element[0].id);
				//}
				this._sortingExpressions = se;
				this._restoreSorting = false;
			}
		},
		_preserveSorting: function () {
			var se = this.grid._getPersistenceData('sorting', this.grid.element[0].id);
			if (se) {
				this._restoreSorting = true;
				if (se !== this._sortingExpressions) {
					this._sortingExpressions = se;
				}
				this.grid.dataSource.settings.sorting.expressions = se;
				this.grid.dataSource.settings.sorting.defaultFields = se;
			}
		},
		_couldPreserveData: function () {
			// M.H. 5 Mar 2014 Fix for bug #165360: Sorting persistance is not working for the child layouts of the grid
			// it is not working because in setupDataSource in grid framework it is reset dataSource but in hierarchical grid it is no reset grid sorting expressions for child layout datasources
			return !this.options.persist || this.grid.dataSource.settings.sorting.expressions !== this.grid._getPersistenceData('sorting', this.grid.element[0].id);
		},
		// every grid feature widget should implement this
		_injectGrid: function (gridInstance, isRebind) {
			this.grid = gridInstance;
			// M.H. 28 May 2014 Fix for bug #172200: Memory leak when using the features of the grid
			this._detachEvents();
			var restoreSortingExpr, topmostGrid;
			if (this.options.type === null) {
				// infer type
				this.options.type = this.grid._inferOpType();
			}
			// M.H. 21 Mar 2014 Fix for bug #167839: Remote filtering, sorting or group by are not persisted when applied to the child and root layout
			if (this.options.persist && this.options.type === 'remote') {
				topmostGrid = this.element.closest('.ui-iggrid-root').data('igGrid');
				if (topmostGrid && topmostGrid.element.attr('id') !== this.grid.element[0].id &&
					topmostGrid.options.initialDataBindDepth === -1) {
					this.options.persist = false;
				}
			}
			if (this.options.type) {
				this.grid.dataSource.settings.sorting.type = this.options.type;
			} else {
				this.grid.dataSource.settings.sorting.type = "remote";
			}
			//A.T. 12 Feb 2011 - Fix for #66143 - igSorting caseSensitive option doesn't change case sensitivity
			this.grid.dataSource.settings.sorting.caseSensitive = this.options.caseSensitive;
			this.grid.dataSource.settings.sorting.defaultFields = this.grid.dataSource.settings.sorting.expressions;
			this.grid.dataSource.settings.sorting.enabled = true;
			this.grid.dataSource.settings.sorting.sortUrlKey = this.options.sortUrlKey;
			this.grid.dataSource.settings.sorting.sortUrlAscValueKey = this.options.sortUrlKeyAscValue;
			this.grid.dataSource.settings.sorting.sortUrlDescValueKey = this.options.sortUrlKeyDescValue;
			if ($.type(this.options.customSortFunction) === 'function') {
				this.grid.dataSource.settings.sorting.customFunc = this.options.customSortFunction;
			} else if (typeof this.options.customSortFunction === 'string') {
				if (window[this.options.customSortFunction] && typeof window[this.options.customSortFunction] === 'function') {
					this.grid.dataSource.settings.sorting.customFunc = window[this.options.customSortFunction];
				}
			}
			this._headerCellRenderedHandler = $.proxy(this._headerCellRendered, this);
			this._columnsCollectionModifiedHandler = $.proxy(this._columnsCollectionModified, this);
			this._uiDirtyHandler = $.proxy(this._onUIDirty, this);
			this._headerRenderedHandler = $.proxy(this._headerRendered, this);
			this._columnsRearangedHandler = $.proxy(this._columnsRearranged, this);
			this.grid.element.bind('iggridheadercellrendered', this._headerCellRenderedHandler);
			this._virtualHorizontalScrollHandler = $.proxy(this._virtualHorizontalScroll, this);
			this.grid.element.bind('iggridvirtualhorizontalscroll', this._virtualHorizontalScrollHandler);
			// register for uiDirty so that sorting states are cleared when dirty  event gets fired 
			this.grid.element.bind('iggriduidirty', this._uiDirtyHandler);
			this.grid.element.bind("iggridcolumnscollectionmodified", this._columnsCollectionModifiedHandler);
			this.grid.element.bind('iggridheaderrendered', this._headerRenderedHandler);
			this.grid.element.bind('iggridcolumnmovingcolumnmoved', this._columnsRearangedHandler);
			//if (!isRebind) {
			// M.H. 11 Mar 2014 Fix for bug #166528: Sorting and Filtering does not persist its state, when they are applied to unbound column
			if (this.options.persist && this.grid._hasUnboundColumns) {
				cs = this.options.columnSettings;
				for (i = 0; i < cs.length; i++) {
					if (cs[i].columnKey && cs[i].currentSortDirection) {
						col = this.grid.columnByKey(cs[i].columnKey);
						if (col && col.unbound === true) {
							delete cs[i].currentSortDirection;
						}
					}
				}
			}
			this._initDefaultSettings();
			//}
			// when we have multi sorting + groupBy AND groupby is defined before sorting in features definition then
			// sorting expressions is equal to dataSource sorting expressions and in ClearUI this.dataSource.sortingExpressions is cleared
			// M.H. 27 Feb 2014 Fix for bug #165268: The group does not retain after dataBind when GroupBy and multiple Sorting are enabled
			restoreSortingExpr = null;
			if (this.options.persist && this.grid.element.data("igGridGroupBy") && this.options.mode !== 'single') {
				if (this.grid.element.data("igGridGroupBy")._getSortingExpressions() === this.grid.dataSource.settings.sorting.expressions) {
					restoreSortingExpr = this.grid.dataSource.settings.sorting.expressions.slice(0);
				}
			}
			this._clearUi();
			// M.H. 27 Feb 2014 Fix for bug #165268: The group does not retain after dataBind when GroupBy and multiple Sorting are enabled
			if (restoreSortingExpr) {
				// we need to reset dataSource sorting expressions and internal variable which holds this expression
				this.grid.dataSource.settings.sorting.expressions = restoreSortingExpr;
				this._saveSortingExpressions();
			}
			this._currentActiveHeader = null;
			this._currentHeader = null;
			this._currentIndex = null;
			this._currentIdentifier = null;
			if (this.options.persist) {
				this._preserveSorting();
			}
		}
	});
	$.extend($.ui.igGridSorting, {version: '14.1.20141.2249'});
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid Column Summaries 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 * Depends on:
 *	jquery-1.4.4.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.ui.grid.framework.js
 *	infragistics.ui.shared.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 */

/*global jQuery */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {

	$.widget("ui.igGridSummaries", {
		/* 
		igGridSummaries widget 
		The widget is pluggable to the element where the grid is instantiated and the actual igGrid object doesn't know about it.
		The summaries widget just attaches its functionality to the grid.
		It supports summaries dropdown with default predefined summary functions like AVG, SUM, COUNT, etc and custom functions
		Predefined summary functions are shown according to develop options and type of the column.
		*/
		/* the instance of the grid to which this feature is going to attach its functionality */
		grid: null,
		css: {
			/* classes applied to dropdown */
			columnSummariesDropdown: 'ui-iggrid-summaries-dialog',
			/* classes applied to DOM element in the summary cell which contains text for summaries result */
			footerRowTextContainer: 'ui-iggrid-summaries-footer-text-container',
			/* classes applied to DOM element which contains text for icon in the summary cell */
			footerRowIconContainer: 'ui-iggrid-summaries-footer-icon-container',
			/* classes applied to the container of OK/Cancel button in dropdown */
			footerDropdownButtonsContainer: 'ui-iggrid-summaries-footer-dialog-buttons-container',
			/* classes applied to footer button icon(which show/hide dropdown) */
			footerButtonIcon: 'ui-icon ui-icon-calculator ui-iggrid-icon-summaries',
			/* classes applied to footer button icon when hovered (button show/hide dropdown) */
			footerButtonIconHover: 'ui-corner-all ui-iggrid-filterbuttonhover ui-state-hover',
			/* classes applied to footer button icon when selected(the dropdown is opened) */
			footerButtonIconActive: 'ui-iggrid-filterbuttonactive ui-corner-all ui-state-active',
			/* classes for icon to be showin in the feature chooser */
			featureChooserIconClass: 'ui-icon ui-iggrid-icon-summaries',
			/* classes applied to container which holds all checkboxes in dropdown */
			dropDownListContainer: 'ui-iggrid-summaries-dropdown-listcontainer ui-widget',
			/* classes applied to list item in the dropdown */
			dropDownListItem: 'ui-iggrid-summaries-dialog-listitem',
			/* classes applied to the container div of header button(which shows/hides summaries) */
			headerButtonContainer: 'ui-iggrid-summaries-headerbuttoncontainer ui-corner-all',
			/* classes applied to the header button(which shows/hides summaries) */
			headerButtonIcon: 'ui-iggrid-summaries-header-icon ui-corner-all ui-icon ui-icon-summaries',
			/* classes applied to the header button when hovered(which shows/hides summaries) */
			headerButtonIconHover: 'ui-iggrid-summaries-header-icon-hover ui-state-hover',
			/* classes applied to footer row cell */
			footerRowCell: 'ui-widget-footer ui-state-default',
			/* classes applied to footer row cell when it is hovered */
			footerRowCellHover: 'ui-state-hover',
			/* classes applied to the checkbox container */
			checkbox: 'ui-state-default ui-corner-all ui-igcheckbox-normal',
			/* classes defining the unchecked state of the checkbox */
			checkboxOff: 'ui-icon ui-icon-check ui-igcheckbox-normal-off',
			/* classes defining the checked state of the checkbox */
			checkboxOn: 'ui-icon ui-icon-check ui-igcheckbox-normal-on',
			/* class defining the hover state style of the checkbox */
			checkboxHovered: 'ui-state-hover',
			/* classes applied to DOM element when showSummariesButton is false */
			footerRowIconContainerEmpty: 'ui-iggrid-summaries-footer-icon-container-empty',
			/* classes applied to DOM element in the summary cell which contains text for summaries result when showSummariesButton is false */
			footerRowTextContainerEmpty: 'ui-iggrid-summaries-footer-text-container-empty',
			/* class for IE7 */
			"baseClassIE7": "ui-ie7"
		},
		defaultDecimalDisplay: 2,
		/* A list of default summary methods 
			For now these are: Count, Min, Max, Sum, Avg and custom.
			Each of them has:
				text - default text shown in dropdown near the checkbox
				type - unique string identifier for summary method name
				allowed - for which data type columns this summary method could be applied
				order - the order shown in dropdown/summary footer. 
					*order of custom methods should be greater or equal than default custom summary method
				type="int" The number of digits after the decimal point. 
			
		*/
		// M.H. 13 Oct. 2011 Fix for bug 91008
		defaultSummaryMethods: [
			{'rowDisplayLabel': $.ig.GridSummaries.locale.defaultSummaryRowDisplayLabelCount, 'type': 'count', 'allowed': 'all', 'active': true, 'order': 0, decimalDisplay: this.defaultDecimalDisplay},
			{'rowDisplayLabel': $.ig.GridSummaries.locale.defaultSummaryRowDisplayLabelMin, 'type': 'min', 'allowed': ['number', 'date', 'numeric'], 'active': true, 'order': 1, decimalDisplay: this.defaultDecimalDisplay},
			{'rowDisplayLabel': $.ig.GridSummaries.locale.defaultSummaryRowDisplayLabelMax, 'type': 'max', 'allowed': ['number', 'date', 'numeric'], 'active': true, 'order': 2, decimalDisplay: this.defaultDecimalDisplay},
			{'rowDisplayLabel': $.ig.GridSummaries.locale.defaultSummaryRowDisplayLabelSum, 'type': 'sum', 'allowed': ['number', 'numeric'], 'active': true, 'order': 3, decimalDisplay: this.defaultDecimalDisplay},
			{'rowDisplayLabel': $.ig.GridSummaries.locale.defaultSummaryRowDisplayLabelAvg, 'type': 'avg', 'allowed': ['number', 'numeric'], 'active': true, 'order': 4, decimalDisplay: this.defaultDecimalDisplay},
			{'rowDisplayLabel': $.ig.GridSummaries.locale.defaultSummaryRowDisplayLabelCustom, 'type': 'custom', 'allowed': 'all', 'active': true, 'summaryCalculator': null, 'order': 5, decimalDisplay: this.defaultDecimalDisplay}
		],
		renderInFeatureChooser: true,
		options: {
			/* type="remote|local" type of summaries calculating.
			remote type="string" when it is remote summaries calculations are made on the server
			local type="string"	When it is local calculations are made on the client
			*/
			type: null,
			/* type="string" Text of the button OK in the summaries dropdown */
			dialogButtonOKText: $.ig.GridSummaries.locale.dialogButtonOKText,
			/* type="string" Text of the button Cancel in the summaries dropdown */
			dialogButtonCancelText: $.ig.GridSummaries.locale.dialogButtonCancelText,
			/* type="okcancelbuttons|onselect" Specifies when calculations are made. 
			onselect type="string" summaries are updated when checkbox is checked/unchecked 
			okcancelbuttons type="string" summaries are updated only when OK button is clicked
			*/
			calculateRenderMode: 'okcancelbuttons',//okcancelbuttons|onselect
			/* type="string" Get or set text that is shown in the feature chooser dropdown when summaries are hidden*/
			featureChooserText: $.ig.GridSummaries.locale.featureChooserText,
			/* type="string" Get or set text that is shown in the feauture chooser dropdown when summaries are shown*/
			featureChooserTextHide: $.ig.GridSummaries.locale.featureChooserTextHide,
			/* type="true|false|auto" Specifies how compact the summaries are rendered. 
			When true indicates that the summaries may be rendered compactly, even mixing different summaries on the same line. 
			False ensures that each summary type is occupying a separate line. 
			Auto will use True if the maximum number of visible summaries is one or less and False otherwise.
			*/
			compactRenderingMode: true,
			// M.H. 18 Oct. 2011 Fix for bug 92454
			/* type="number" The number of digits after the decimal point. If gridFormatter is True then this option is ignored. */
			defaultDecimalDisplay: 2,
			/* type="bool" Show header button icon in the header cell. On click - shows/hides summaries */
			showSummariesButton: true,
			/* type="string" Result key by which we get data from the result returned by remote data source.*/
			summariesResponseKey: 'summaries',
			/* type="string" Set key in GET Request for summaries - used only when type is remote */
			summaryExprUrlKey: 'summaries',
			/* type="function" Function reference - it is called when data is retrieved from the data source */
			callee: null,
			/* type="number" Height of the dropdown in pixels */
			dropDownHeight: '',
			/* type="number" Width of the dropdown in pixels */
			dropDownWidth: '',
			/* type="bool" Show/hide footer button(on click show/hide dropdown) */
			showDropDownButton: true,
			/* type="priortofilteringandpaging|afterfilteringbeforepaging|afterfilteringandpaging" Determines when the summary values are calculated when type is local
			priortofilteringandpaging type="string" summaries are calculated prior to filtering and paging
			afterfilteringbeforepaging type="string" summaries are calculated after filtering and before paging
			afterfilteringandpaging type="string" summaries are calculated after filtering and paging
			*/
			summaryExecution: 'afterfilteringbeforepaging',
			/* type="int" Dropdown animation duration */
			dropDownDialogAnimationDuration: 400,
			/* type="string" Empty text template to be shown for empty cells */
			emptyCellText: $.ig.GridSummaries.locale.emptyCellText,
			/* type="string" Tooltip text for header cell button */
			summariesHeaderButtonTooltip: $.ig.GridSummaries.locale.summariesHeaderButtonTooltip,
			/* type="string" Result template for summary result(shown in table cell)*/
			resultTemplate: '{0} = {1}',
			/* type="bool" if this property is enabled and in summaryOperand isGridFormatter  is undefined then use grid formatting for cells */
			isGridFormatter: true,
			/* type="array" a list of column settings that specifies custom summaries options per column basis */
			columnSettings: [
				{
					/* type="bool" Enables disables summaries for the column */
					allowSummaries: true,
					/* type="string" Column key. This is a required property in every column setting if columnIndex is not set */
					columnKey: null,
					/* type="number" Column index. Can be used in place of column key. The preferred way of populating a column setting is to always use the column keys as identifiers */
					columnIndex: -1,
					/* type="array" Check defaultSummaryOperands */
					summaryOperands: [
						{
							/* type="string" Text of the summary method which is shown in summary cell */
							rowDisplayLabel: '',
							/* type="count|min|max|sum|avg|custom" Set type of summary operand 
							count type="string" calculate count of result rows for the specified column
							min type="string" calculate min of result rows for the specified column
							max type="string" calculate max of result rows for the specified column
							sum type="string" calculate sum of result rows for the specified column
							avg type="string" calculate average of result rows for the specified column
							custom type="string" calculate custom function (specified by summaryCalculator property) of result rows for the specified column
							*/
							type: 'custom',
							/* type="bool" If it is false the summary operand will be shown in dropdown but it will not be made calculation */
							active: true,
							/* type="string" Name of the custom summary function which should be executed when type is custom */
							summaryCalculator: null,
							/* type="number" Specifies the order of elements in dropdown. It is recommended to set order of custom operands and to be greater or equal to 5 */
							order: 5,
							/* type="number" Specifies the number of digits after the decimal point for result of the current summary operand. This property will be ignored when isGridFormatter is true */
							decimalDisplay: 2,
							/* type="bool" Specifies whether to be used grid formatter for result for the current summary operand. */
							isGridFormatter: false
						}
					]
				}
			]
		},
		events: {
			/* cancel="true" Event fired before drop down is opened for a specific column summary 
			Return false in order to cancel opening the drop down.
			Function takes arguments evt and ui.
			Use ui.columnKey to get column key of the column where drop down is opening.
			Use ui.owner in order to access the igGridSummaries widget object.
			*/
			dropDownOpening: 'dropDownOpening',
			/* Event fired after the summaries dropdown is opened for a specific column
			Function takes arguments evt and ui.
			Use ui.columnKey to get column key of the column where drop down is shown.
			Use ui.owner in order to access the igGridSummaries widget object.
			 */
			dropDownOpened: 'dropDownOpened',
			/* cancel="true" Event fired before the dropdown for a summary column starts closing 
			Return false in order to cancel closing the drop down.
			Function takes arguments evt and ui.
			Use ui.columnKey to get column key of the column where drop down is closing.
			Use ui.owner in order to access the igGridSummaries widget object.
			*/
			dropDownClosing: 'dropDownClosing',
			/* Event fired after the dropdown for a summary column is closed 
			Function takes arguments evt and ui.
			Use ui.columnKey to get column key of the column where drop down is closing.
			Use ui.owner in order to access the igGridSummaries widget object.
			*/
			dropDownClosed: 'dropDownClosed',
			/* cancel="true" Event fired before summaries calculations are made
			Return false in order to cancel calculation of summaries.
			Function takes arguments evt and ui.
			Use ui.owner in order to access the igGridSummaries widget object.
			*/
			summariesCalculating: 'summariesCalculating',
			/* Event fired after summaries calculation are completely made
			Function takes arguments evt and ui.
			Use ui.data to get data for calculated summaries
			Use ui.owner in order to access the igGridSummaries widget object.
			*/
			summariesCalculated: 'summariesCalculated',
			/* Event fired when user selects/deselects summary method from checkbox 
			Function takes arguments evt and ui.
			Use ui.columnKey to get column key of the column where it is changed selection of summary method
			Use ui.isSelected to get whether method is selected or not
			Use ui.methodName to get summary method name
			Use ui.owner in order to access the igGridSummaries widget object.
			*/
			summariesMethodSelectionChanged: 'summariesMethodSelectionChanged',
			/* cancel="true" Event is fired bofore summary rows start toggling 
			Return false in order to cancel showing/hiding of summaries.
			Function takes arguments evt and ui.
			Use ui.isToShow to get whether summaries are shown or not.
			Use ui.owner in order to access the igGridSummaries widget object.
			*/
			summariesToggling: 'summariesToggling',
			/* Event is fired after summary rows are toggled
			Function takes arguments evt and ui.
			Use ui.isToShow to get whether summaries are shown or not.
			Use ui.owner in order to access the igGridSummaries widget object.
			*/
			summariesToggled: 'summariesToggled',
			/* Event is fired when OK button is clicked in drop down
			Function takes arguments evt and ui.
			Use ui.columnKey to get column key for which OK button is clicked.
			Use ui.eventData to get data about which summary methods are(not) selected. Format of event data is {type: 'min', active: false};
			Use ui.owner in order to access the igGridSummaries widget object.
			*/
			dropDownOKClicked: 'dropDownOKClicked',
			/* Event is fired when Cancel button is clicked in drop down.
			Function takes arguments evt and ui.
			Use ui.columnKey to get column key for which Cancel button is clicked.
			Use ui.owner in order to access the igGridSummaries widget object.
			*/
			dropDownCancelClicked: 'dropDownCancelClicked'
		},
		_createWidget: function () {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			this.options.columnSettings = [];
			this._summariesRows = [];
			this._data = {}; // {columnKey: '', res: [{type:'min', result: 2}]}
			this._currentOpenedColumnKey = null;
			this._isRenderedSummariesRows = false;
			this._footerInitialized = false;
			this._currentRowShownIcons = null;
			// array which is used when analyze custom summary methods of type 'custom' - set them with type custom1, custom2, etc.
			this._customInitMethods = [];
			// feature chooser data
			this._fcData = {};
			this._isInitFC = false;
			this._isSummariesRowsHidden = false;
			this._disallowedSummaries = [];
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		_create: function () {
			// M.H. 29 Sept. 2011 Fix for bug #88718 - first it should be called parent method and then re-initialized options
			var compactRenderingMode = this.options.compactRenderingMode;
			
			// check whether compact rendering mode option is string
			if (compactRenderingMode === 'true') {
				compactRenderingMode = true;
			} else if (compactRenderingMode === 'false') {
				compactRenderingMode = false;
			}
			this.options.compactRenderingMode = compactRenderingMode;
		},
		_initColumnSettings: function () {
			var settings = [], i, j, k, l,
				cs = this.options.columnSettings,
				csetting,
				columnSettingsLength = cs.length,
				gridColumnsLength = (this.grid.options.columns) ? this.grid.options.columns.length : 0;

			this.newColumnSettings = [];
			this._disallowedSummaries = [];
			for (i = 0; i < gridColumnsLength; i++) {
				settings.push({'columnIndex': i, 'columnKey': this.grid.options.columns[i].key, 'dataType': this.grid.options.columns[i].dataType});
			}
			if (columnSettingsLength > 0) {
				// First it should be initialized _customInitMethods array with those custom methods which are of type 'customN' where N is digit - 1,2,3, ...
				// in this way we know all custom types and we will be able to enumerate correctly summaries with type 'custom' and to set their correct type if exists
				// M.H. 17 Oct. 2011 Fix for bug 89444
				for (i = 0; i < columnSettingsLength; i++) {
					csetting = cs[i];
					if (csetting.summaryOperands === null || csetting.summaryOperands === undefined) {
						continue;
					}
					if ((csetting.columnKey !== null && csetting.columnKey !== undefined) ||
							(csetting.columnIndex !== null && csetting.columnIndex !== undefined)) {
						for (j = 0; j < gridColumnsLength; j++) {
							for (l = 0; l < csetting.summaryOperands.length; l++) {
								// M.H. 18 Oct. 2011 Fix for bug 92460
								// M.H. 12 Oct 2012 Fix for bug #124080
								if (csetting.summaryOperands[l].active === null || csetting.summaryOperands[l].active === undefined) {
									csetting.summaryOperands[l].active = true;
								}
								if (csetting.summaryOperands[l].type.startsWith('custom') === true) {
									if (csetting.summaryOperands[l].type !== 'custom') {
										for (k = 0; k < this._customInitMethods.length; k++) {
											if (csetting.summaryOperands[l].summaryCalculator === this._customInitMethods[k].summaryCalculator) {
												break;
											}
										}
										// add new custom type
										if (this._customInitMethods.length === k) {
											this._customInitMethods.push({
												summaryCalculator: csetting.summaryOperands[l].summaryCalculator,
												type: csetting.summaryOperands[l].type,
												index: csetting.summaryOperands[l].type.replace('custom', '')
											});
										}
									}
								}
							}
						}
					}
				}
				// check columnSettings if key/index is defined
				for (i = 0; i < columnSettingsLength; i++) {
					csetting = cs[i];
					if ((csetting.columnKey !== null && csetting.columnKey !== undefined) ||
							(csetting.columnIndex !== null && csetting.columnIndex !== undefined)) {
						for (j = 0; j < gridColumnsLength; j++) {
							if (
								(settings[j].columnIndex === csetting.columnIndex &&
									csetting.columnIndex !== undefined && csetting.columnIndex !== null) ||
									(settings[j].columnKey === csetting.columnKey &&
										csetting.columnKey !== undefined && csetting.columnKey !== null)
							) {
								csetting.dataType = settings[j].dataType;
								csetting.columnIndex = settings[j].columnIndex;
								csetting.columnKey = settings[j].columnKey;
								csetting.summaryOperands = this._initAllowedSummaryMethods(csetting);

								if (csetting.allowSummaries !== false) {
									this.newColumnSettings.push(csetting);
								} else {
									this._disallowedSummaries[settings[j].columnKey] = true;
								}
								break;
							}
						}
					}
				}
				for (i = 0; i < gridColumnsLength; i++) {
					for (j = 0; j < this.newColumnSettings.length; j++) {
						if (this.newColumnSettings[j].columnKey === settings[i].columnKey) {
							break;
						}
					}
					if (j === this.newColumnSettings.length && this._disallowedSummaries[settings[i].columnKey] !== true) {
						this.newColumnSettings.push({dataType: settings[i].dataType, columnIndex: i, columnKey: settings[i].columnKey, summaryOperands: this._initAllowedSummaryMethods(settings[i], false)});
					}
				}
			} else {
				for (i = 0; i < gridColumnsLength; i++) {
					this.newColumnSettings.push({dataType: settings[i].dataType, columnIndex: i, columnKey: settings[i].columnKey, summaryOperands: this._initAllowedSummaryMethods(settings[i])});
				}
			}
			this.columnSettings = this.newColumnSettings;
		},
		_initAllowedSummaryMethods: function (column, isNotActive) {
			var i, j, k, z, c,
				lastCustomSummaryOperandIndex,
				defaultSummaryMethodsLength = this.defaultSummaryMethods.length,
				columnDataType,
				methods = [],
				allowedMethods = [],
				methodName,
				methodsLength,
				isActive,
				defaultMethodName;

			if (column === null || column === undefined) {
				return;
			}
			columnDataType = column.dataType;
			if (column !== null && column !== undefined && column.summaryOperands !== undefined && column.summaryOperands !== null) {
				for (i = 0; i < column.summaryOperands.length; i++) {
					if (column.summaryOperands[i].type === undefined || column.summaryOperands[i].type === null) {
						return;
					}
					methodName = column.summaryOperands[i].type.toLowerCase();
					if (this._isAllowedMethodName(methodName) === true) {
						if (isNotActive === true) {
							column.summaryOperands[i].active = false;
						}
						// M.H. 17 Oct. 2011 Fix for bug 89444
						// when type is 'custom' we should check all summary operands which are of type 'custom1', 'custom2', 'custom3', etc.
						// it is checked by summaryCalculator method. If it does not exist set new value which will be the biggest N from 'customN' plus 1 to 'custom(N+1)' 
						// if till now it is defined custom1, custom2 then the new custom type will be custom3
						// NOTE: we have preliminarily in array _customInitMethods all summary methods that are of type custom1, custom2, etc. from columnSettings
						// here we check only those which are of type 'custom'
						if (column.summaryOperands[i].type === 'custom') {
							if (column.summaryOperands[i].summaryCalculator === null ||
									column.summaryOperands[i].summaryCalculator === undefined) {
								continue;
							}
							lastCustomSummaryOperandIndex = 1;
							for (k = 0; k < this._customInitMethods.length; k++) {
								if (column.summaryOperands[i].summaryCalculator === this._customInitMethods[k].summaryCalculator) {
									column.summaryOperands[i].type = this._customInitMethods[k].type;
									break;
								}
								if (this._customInitMethods[k].index > lastCustomSummaryOperandIndex) {
									lastCustomSummaryOperandIndex = this._customInitMethods[k].index;
								}
							}
							// add new custom type
							if (this._customInitMethods.length === k) {
								lastCustomSummaryOperandIndex++;
								column.summaryOperands[i].type = 'custom' + lastCustomSummaryOperandIndex;
								this._customInitMethods.push({
									summaryCalculator: column.summaryOperands[i].summaryCalculator,
									type: 'custom' + lastCustomSummaryOperandIndex,
									index: lastCustomSummaryOperandIndex
								});
							}
						}
						methods.push(column.summaryOperands[i]);
					}
				}
			} else {
				for (i = 0; i < defaultSummaryMethodsLength; i++) {
					c = this.defaultSummaryMethods[i];
					// type should be custom1, custom2, etc. 
					// if it is ONLY 'custom' then we should check each custom type and if they are equal by summaryOperand to make them equal as types
					if (c.type.startsWith('custom')) {
						continue;
					}
					isActive = c.active;
					if (isNotActive === true) {
						isActive = false;
					}
					methods.push(
						{
							'rowDisplayLabel': c.rowDisplayLabel,
							'type': c.type,
							'allowed': c.allowed,
							'active': isActive,
							'order': c.order,
							'decimalDisplay': c.decimalDisplay,
							'isGridFormatter': c.isGridFormatter
						}
					);
				}
			}
			methodsLength = methods.length;
			// check which methods are appropriate for the column data type
			for (i = 0; i < methodsLength; i++) {
				for (j = 0; j < defaultSummaryMethodsLength; j++) {
					defaultMethodName = this.defaultSummaryMethods[j].type.toUpperCase();
					if (defaultMethodName === methods[i].type.toUpperCase() ||
							methods[i].type.startsWith('custom')) {
						// check order - if it is lower than custom method
						// check for NOT custom methods order - it could be only those from default
						if (methods[i].type.toLowerCase().startsWith('custom')) {
							if (methods[i].order < this.defaultSummaryMethods[j].order) {
								methods[i].order = this.defaultSummaryMethods[j].order;
							}
						} else if (methods[i].order !== this.defaultSummaryMethods[j].order) {
							methods[i].order = this.defaultSummaryMethods[j].order;
						}
						// M.H. 19 Oct 2012 Fix for bug #124080
						if (methods[i].rowDisplayLabel === null || methods[i].rowDisplayLabel === undefined) {
							methods[i].rowDisplayLabel = this.defaultSummaryMethods[j].rowDisplayLabel;
						}
						if (this.defaultSummaryMethods[j].allowed === 'all') {
							allowedMethods.push(methods[i]);
						} else {
							for (z = 0; z < this.defaultSummaryMethods[j].allowed.length; z++) {
								if (this.defaultSummaryMethods[j].allowed[z] === columnDataType) {
									allowedMethods.push(methods[i]);
									break;
								}
							}
						}
						break;
					}
				}
			}
			return allowedMethods;
		},
		_setOption: function (key, value) {
			// handle new settings and update options hash
			var i, o = this.options,
				columns, columnsLength,
				cs, csLength,
				$colCell,
				columnKey,
				gridId = this.grid.element[0].id;

			switch (key) {
			case "dialogButtonOKText":
				if (o.dialogButtonOKText !== value) {
					columns = this.grid.options.columns;
					columnsLength = columns.length;
					for (i = 0; i < columnsLength; i++) {
						$('#' + this._id('summaries', 'dialog_button_ok', columns[i].key))
							.igButton('option', 'labelText', value);
					}
				}
				break;
			case "dialogButtonCancelText":
				if (o.dialogButtonCancelText !== value) {
					columns = this.grid.options.columns;
					columnsLength = columns.length;
					for (i = 0; i < columnsLength; i++) {
						$('#' + this._id('summaries', 'dialog_button_cancel', columns[i].key))
							.igButton('option', 'labelText', value);
					}
				}
				break;
			case "calculateRenderMode":
				if (o.calculateRenderMode !== value) {
					o.calculateRenderMode = value;
					columns = this.grid.options.columns;
					columnsLength = columns.length;
					for (i = 0; i < columnsLength; i++) {
						this._renderDropDown(columns[i].key);
					}
				}
				break;
			case "compactRenderingMode":
				if (o.compactRenderingMode !== value) {
					o.compactRenderingMode = value;

					this._clearAllRows();
					this.calculateSummaries();
				}
				break;
			case "showSummariesButton":
				if (o.showSummariesButton !== value) {
					o.showSummariesButton = value;
					cs = this.columnSettings;
					csLength = cs.length;

					for (i = 0; i < csLength; i++) {
						columnKey = cs[i].columnKey;

						if (value === true) {
							$colCell = $('#' + gridId + '_' + columnKey);
							if (this._fcData !== null && this._fcData !== undefined &&
									$colCell.length > 0 && this._fcData[columnKey] !== true) {
								this._renderHeaderCellButton($colCell, columnKey);
							}
						} else {
							$('#' + this._id('summaries', 'header_column_icon', columnKey)).remove();
						}
					}
				}
				break;
			case "disabled":
				if (o.disabled !== value) {
					o.disabled = value;
					if (value === true) {
						this._clearAllRows();
					} else {
						this.calculateSummaries();
					}
				}
				break;
			case "type":
				if (o.type !== value) {
					o.type = value;
					this._setDataSourceColumnSettingsOptions();
				}
				break;
			case "summaryExprUrlKey":
				if (o.summaryExprUrlKey !== value) {
					o.summaryExprUrlKey = value;
					this._setDataSourceColumnSettingsOptions();
				}
				break;
			case "dropDownHeight":
				if (o.dropDownHeight !== value) {
					o.dropDownHeight = value;
					columns = this.grid.options.columns;
					columnsLength = columns.length;
					for (i = 0; i < columnsLength; i++) {
						$('#' + this._id('summaries', 'methods_dialog', columns[i].key)).css('height', value);
					}
				}
				break;
			case "dropDownWidth":
				if (o.dropDownWidth !== value) {
					o.dropDownWidth = value;
					columns = this.grid.options.columns;
					columnsLength = columns.length;
					for (i = 0; i < columnsLength; i++) {
						$('#' + this._id('summaries', 'methods_dialog', columns[i].key)).css('width', value);
					}
				}
				break;
			case "showDropDownButton":
				if (o.showDropDownButton !== value) {
					o.showDropDownButton = value;
					if (value === true) {
						this._renderFooterIcons();
					} else {
						this._clearFooterIcons();
					}
				}
				break;
			case "emptyCellText":
				if (o.emptyCellText !== value) {
					o.emptyCellText = value;
					this._clearAllRows();
					this.calculateSummaries();
				}
				break;
			case "resultTemplate":
				if (o.resultTemplate !== value) {
					o.resultTemplate = value;
					this._clearAllRows();
					this.calculateSummaries();
				}
				break;
			case "isGridFormatter":
				if (o.isGridFormatter !== value) {
					o.isGridFormatter = value;
					this._clearAllRows();
					this.calculateSummaries();
				}
				break;
			case "defaultDecimalDisplay":
				if (o.defaultDecimalDisplay !== value) {
					o.defaultDecimalDisplay = value;
					this._clearAllRows();
					this.calculateSummaries();
				}
				break;
			case "columnSettings":
				if (o.columnSettings !== value) {
					o.columnSettings = value;
					// M.H. 3 Nov. 2011 Fix for bug 95290
					this.columnSettings = [];
					this.newColumnSettings = [];
					// data should be reinitialized
					this._data = {};

					this._clearAllRows();
					this._initColumnSettings();

					columns = this.grid.options.columns;
					columnsLength = columns.length;
					this.grid.dataSource.dataBind();
					for (i = 0; i < columnsLength; i++) {
						this._renderDropDown(columns[i].key);
					}
				}
				break;
			}
			$.Widget.prototype._setOption.apply(this, arguments);
		},
		// M.H. 29 Oct 2012 Fix for bug #120642
		_removeHeaderColumnIcons: function () {
			var i, cs = this.columnSettings, csLength = cs.length;

			for (i = 0; i < csLength; i++) {
				$('#' + this._id('summaries', 'header_column_icon', cs[i].columnKey)).remove();
			}
		},
		destroy: function () {
			var i, columns, columnsLength, fc;
			/*destroys the igGridSummaries feature by removing all elements in the footer area, unbinding events*/
			// M.H. 26 Jan 2012 - fix for bug #91738
			this._detachEvents();

			this._clearAllRows();
			this.newColumnSettings = null;
			this.options.columnSettings = null;
			this.options = null;
			this._summariesRows.length = 0;
			this._summariesRows = null;
			if (this._activeDialog) {
				this._activeDialog.remove();
				this._activeDialog = null;
			}
			this._data = null;
			this._currentOpenedColumnKey = null;
			this._isRenderedSummariesRows = null;
			this._footerInitialized = null;
			this._currentRowShownIcons = null;
			this._customInitMethods = null;
			this._fcData = null;
			this._isInitFC = null;
			this._isSummariesRowsHidden = null;
			this._disallowedSummaries = null;
			this._activeDialog = null;
			this.defaultSummaryMethods = null;
			// remove summaries dialogs
			// M.H. 3 Oct 2013 Fix for bug #153955: [igGrid Summaries]Destroying Grid Summaries does not remove dropdown elements from DOM
			columns = this.grid.options.columns;
			columnsLength = columns.length;
			for (i = 0; i < columnsLength; i++) {
				$('#' + this._id('summaries', 'methods_dialog', columns[i].key)).remove();
			}
			fc = this.grid.element.data('igGridFeatureChooser');
			if (fc && this.renderInFeatureChooser) {
				fc._removeFeature('Summaries');
			}
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		_detachEvents: function () {
			// M.H. 28 May 2014 Fix for bug #172200: Memory leak when using the features of the grid
			this.grid.footersTable().find('tr:first td').unbind(".summaries");
			// M.H. 26 Jan 2012 - fix for bug #91738
			if (this._headerRenderedHandler) {
				this.grid.element.unbind('iggridheaderrendered', this._headerRenderedHandler);
			}
			if (this._footerRenderedHandler) {
				this.grid.element.unbind('iggridfooterrendered', this._footerRenderedHandler);
			}
			if (this._headerCellRenderedHandler) {
				this.grid.element.unbind('iggridheadercellrendered', this._headerCellRenderedHandler);
			}
			if (this._headerFooterInitHandler) {
				this.grid.element.unbind('iggridheaderextracellsmodified', this._headerFooterInitHandler);
			}
			if (this._columnsCollectionModifiedHandler) {
				this.grid.element.unbind('iggridcolumnscollectionmodified', this._columnsCollectionModifiedHandler);
			}
			if (this._virtualHorizontalScrollHandler) {
				this.grid.element.unbind('iggridvirtualhorizontalscroll', this._virtualHorizontalScrollHandler);
			}
			if (this._rowUpdatedHandler) {
            // M.H. 15 Mar 2013 Fix for bug #136429: Updating Values does not fire updating of summary
				this.grid.element.unbind('iggridupdatingeditrowended', this._rowUpdatedHandler);
				this.grid.element.unbind('iggridupdatinginternalrowdeleted', this._rowUpdatedHandler);
			}
		},
		_headerCellRendered: function (event, ui) {
			/* check for which cells should be rendered in feature chooser
			*/
			//prevent handling of other grids' events in the case of hierarchical grid
			if (ui.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}

			if (this._isInitFC !== true) {
				this._initFC();
			}
		},
		_initFC: function () {
			/* instantiate feature chooser */
			// check whether feature chooser is defined
			var i, fc,
				o = this.options,
				cs = this.columnSettings,
				csLength = cs.length,
				columnKey;
			this._isInitFC = true;
			// instantiate igGridFeatureChooser = if it is defined
			fc = this.grid.element.data('igGridFeatureChooser');
			if (fc !== null && fc !== undefined) {
				for (i = 0; i < csLength; i++) {
					if (cs[i].allowSummaries === false) {
						continue;
					}
					columnKey = cs[i].columnKey;
					if (fc._shouldRenderInFeatureChooser(columnKey) === true) {
						fc._renderInFeatureChooser(columnKey,
							{
								name: 'Summaries',
								text: o.featureChooserText,
								textHide: o.featureChooserTextHide,
								iconClass: this.css.featureChooserIconClass,
								iconClassOff: this.css.featureChooserIconClass,
								//secondaryIconClass: this.css.featureChooserIconClass,
								isSelected: true,
								method: $.proxy(this._togglefromfc, this),
								updateOnClickAll: true,
								order: 1, // order in group
								groupName: 'toggle',
								groupOrder: 1,
								type: 'toggle',
								state: 'hide'
							}
							);
						//fc._setSelectedState('Summaries', columnKey, false, false);
						this._fcData[columnKey] = true;
					}
				}
			}
		},
		_footerRendered: function (sender, args) {
			//prevent handling of other grids' events in the case of hierarchical grid
			if (args.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}
			var i,
				cs = this.columnSettings,
				csLength = cs.length,
				columnKey;
			for (i = 0; i < csLength; i++) {

				if (cs[i].allowSummaries === false) {
					continue;
				}
				columnKey = cs[i].columnKey;
				// M.H. 27 Sep 2011 - fix for bug #84759
				// initializing of summary dialogs should be in header rendered NOT in headercellrendered
				// because when showHeaders is false then headercellrendered is not called
				this._renderDropDown(columnKey);
			}
		},
		_headerRendered: function (sender, args) {
			//prevent handling of other grids' events in the case of hierarchical grid
			if (args.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}
			var i,
				cs = this.columnSettings,
				csLength = cs.length,
				$colCell,
				columnKey,
				gridId = this.grid.element[0].id;

			for (i = 0; i < csLength; i++) {
				if (cs[i].allowSummaries === false) {
					continue;
				}
				columnKey = cs[i].columnKey;
				// M.H. 27 Sep 2011 - fix for bug #84759
				// initializing of summary dialogs should be in header rendered NOT in headercellrendered
				// because when showHeaders is false then headercellrendered is not called
				//$colCell = $('#' + gridId + '_' + columnKey);
				$colCell = this.grid.headersTable().find("#" + gridId + "_" + columnKey);
				if ($colCell.length > 0 && this._fcData[columnKey] !== true && this.options.showSummariesButton !== false) {
					this._renderHeaderCellButton($colCell, columnKey);
				}
			}
		},
		_columnMap: function () {
			var o = this.options,
				cs = this.newColumnSettings,
				i,
				csLength = cs.length,
				elem,
				result = [];

			if (o.showSummariesButton === false) {
				return false;
			}

			for (i = 0; i < csLength; i++) {
				elem = {columnKey: cs[i].columnKey, enabled: true};
				if (cs[i].allowSummaries === false) {
					elem.enabled = false;
				}
				result.push(elem);
			}
			return result;
		},
		_dataRendered: function () {
			// M.H. 29 Oct 2012 Fix for bug #120642
			if (this.options.disabled !== true && this._isSummariesRowsHidden === false) {
				this.calculateSummaries();
			}
		},
		_rowUpdated: function () {
			// M.H. 15 Mar 2013 Fix for bug #136429: Updating Values does not fire updating of summary
			// M.H. 21 Jun 2013 Fix for bug #144973: Summaries are shown after updating when autoCommit=true
			if (this.grid.options.autoCommit && this._isRenderedSummariesRows) {
				this.calculateSummaries();
			}
		},
		isSummariesRowsHidden: function () {
			/* Returns whether summaries rows are hidden */
			return this._isSummariesRowsHidden;
		},
		calculateSummaries: function () {
			/* Calculate summaries */
			this._trigger(this.events.rowsInitialize, null, {});
			this._calculateInternalSummaries();
			if (this.options.showDropDownButton === true) {
				this._renderFooterIcons();
			}
			this._adjustHeights();
		},
		_adjustHeights: function () {
			var grid = this.grid, gridHeight = grid.options.height, newHeight, hasVScrollbar, oS;

			if (gridHeight === null || gridHeight === undefined) {
				return;
			}
			if (this._isVirtualization() === true) {
				// reRender Heights
				newHeight = parseInt(this.grid.options.height, 10) -  parseInt($('#' + this._id('footer', 'container')).height(), 10);
				$('#' + this.grid.element[0].id).height(newHeight);
				$('#' + this.grid.element[0].id + '_displayContainer').height(newHeight);
				$('#' + this.grid.element[0].id + '_scrollContainer').height(newHeight);
				// M.H. 14 Jun 2013 Fix for bug #142448: Scroll height is not calculated correctly when virtualization is enabled
				grid._initializeHeights();
				// M.H. 30 March 2012 Fix for bug #106094
				if (this.grid.options.virtualizationMode === 'fixed') {
                    oS = grid._scrollContainer().scrollTop();
					grid._buildVirtualDom();
                    if (oS > 0) {
                        // M.H. 13 Jan 2014 Fix for bug #161351: When virtualization and summaries are enabled and the grid is scrolled to the bottom hiding and showing the summaries makes the grid to render the wrong records.
                        // in FF we should use this "hack" with setTimeout, in other browsers there is no need of this hack
                        if ($.ig.util.isFF) {
                            grid._scrollContainer().scrollTop(0);
                            setTimeout(function () {
                                grid._scrollContainer().scrollTop(oS);
                            }, 0);
                        } else {
                            grid._scrollContainer().scrollTop(oS - 2);
                            grid._scrollContainer().scrollTop(oS);
                        }
                    }
				}
			} else {
				if (!this.grid.hasFixedColumns()) {
					this.grid._initializeHeights();
					// M.H. 23 Jan 2012 Fix for bug #99091
					// M.H. 17 May 2012 Fix for bug #110952 - for now bug 99091 is not replicated as we uncomment adjustLastColumnWidth
					// S.S. 31 May 2012 Fix for bug #113275 - colgroups are not rerendered therefore false should be passed as param
					// M.H. 7 May 2013 Fix for bug #140364: Text is covered over by the scroll bar when text is right aligned
					// _adjustLastColumnWidth grid method mainly (re)set width of the last cells according to whether there is vertical scrollbar. In this method 
					// global grid variable _hasVerticalScrollbar is set. So we should check whether to call this method according to change in visibility of vertical scrollbar
					hasVScrollbar = !((grid.options.autoAdjustHeight && grid.element.height() <= $('#' + grid.element[0].id + '_scroll').height()) ||
						(!grid.options.autoAdjustHeight && grid.options.avgRowHeight * grid.element[0].rows.length < parseInt(grid.options.height, 10)));
					if (hasVScrollbar !== grid._hasVerticalScrollbar) {
						this.grid._adjustLastColumnWidth(false);
					}
				} else {
					this._syncFixedUnfixedRowHeights();
					// M.H. 26 Jun 2013 Fix for bug #145563: When you fix a column and summaries are enabled and height is set when you hide summaries grid is not resized and height of the whole grid is decreased
					this.grid._initializeHeights();
				}
			}
		},
		_removeFooterRows: function () {
			// remove all footer rows which are in _summariesRow array and clears the array
			var i,
				sr = this._summariesRows,
				hasFixedColumns = this.grid.hasFixedColumns(),
				srLength = sr.length;
			
			for (i = 0; i < srLength; i++) {
				$('#' + this._id('summaries', 'footer_row', sr[i].type)).remove();
				if (hasFixedColumns) {
					$('#' + this._id('summaries', 'footer_row', sr[i].type, 'fixed')).remove();
				}
			}
			this._isRenderedSummariesRows = false;
			this._summariesRows = [];
		},
		_calculateSelectedSummaries: function (columnKey) {
			// analyze whether checkboxes are selected/unselected for the column(with the specified columnKey) and calculates(if there is such need) summaries and/or refresh summaries(if there is such need)
			// if checkboxes are only unchecked for the specified column - do not recalculate summaries - just refreshes UI
			var i, k, methods,
				hasFixedColumns = this.grid.hasFixedColumns(),
				res = [],
				csLength,
				$checkbox,
				methodsLength,
				summariesRowsLength,
				isToCalculate = false,
				data, newMax, max,
				cs = null,
				isChecked,
				j,
				compactRenderingMode = this.options.compactRenderingMode,
				selectedColumnSettingsIndex,
				columnSettingsLength = this.columnSettings.length,
				isToRerender = false,
				isToRemoveRow = false,
				methodNameToRemove,
				unactiveMethods = [],
				unactiveMethodsLength = 0,
				activeMethods = [],
				isToRemoveFirstRow = false,
				elemDataCalculating,
				rowToRemoveMethodName = '';
			if (columnKey === undefined || columnKey === null) {
				return;
			}
			for (j = 0; j < columnSettingsLength; j++) {
				// M.H. 12 Oct. 2011 Fix for bug #91580
				if (this.columnSettings[j].columnKey === columnKey && this._isVisibleColumn(columnKey)) {
					cs = this.columnSettings[j];
					selectedColumnSettingsIndex = j;
					break;
				}
			}
			if (cs === null || cs === undefined) {
				return;
			}
			methods = cs.summaryOperands;
			methodsLength = methods.length;
			// check each of the rendered methods - if there are changes - re-render
			// analyze each of the checkboxes whether are only unchecked or it should be made summaries calculation
			// if there is no changes in checkboxes then isToRerender is FALSE, otherwise it is TRUE and should be refreshed summaries
			// if it should be made summaries calculation then isToCalculate is set to TRUE
			// save the state of active and not active methods in 2 arrays
			for (i = 0; i < methodsLength; i++) {
				$checkbox = $('#' + this._id('summaries_footer_checkbox', methods[i].type.toLowerCase(), columnKey));
				isChecked = ($checkbox.attr('data-chk').toLowerCase() === 'on');
//                if (isChecked === true) {
//                    countCheckedSettings++;
//                }
				if (isChecked !== methods[i].active) {
					isToRerender = true;
					// if there are options that are checked
					this.newColumnSettings[selectedColumnSettingsIndex].summaryOperands[i].active = isChecked;
					if (isChecked === true) {
						isToCalculate = true;
						activeMethods.push(this.newColumnSettings[selectedColumnSettingsIndex].summaryOperands[i]);
					} else {
						unactiveMethods.push(methods[i]);
					}
				}
			}
			this.columnSettings[selectedColumnSettingsIndex].summaryOperands = this.newColumnSettings[selectedColumnSettingsIndex].summaryOperands;
			this.isToCalculateInRemoteMode = false;
			// M.H. 17 April 2012 Fix for bug #109058
			if (this.options.compactRenderingMode === 'auto') {
				if (this._summariesRows.length === 1 &&
						this._analyzeAutoCompactRenderingMode() === false) {
					// when compact rendering mode is AUTO and count of summary rows is 1 but should be shown more than 1 row
					$('#' + this._summariesRows[0].id).remove();
					if (hasFixedColumns) {
						$('#' + this._summariesRows[0].id + '_fixed').remove();
					}
					this._summariesRows = [];
					this.calculateSummaries();
					return;
				}
				if (this._summariesRows.length > 1 &&
						this._analyzeAutoCompactRenderingMode() === true) {
					// when compact rendering mode is AUTO and count of summary rows is more than 1 but should be shown ONLY 1 row
					for (i = 0; i < this._summariesRows.length; i++) {
						$('#' + this._summariesRows[i].id).remove();
						if (hasFixedColumns) {
							$('#' + this._summariesRows[i].id + '_fixed').remove();
						}
					}
					this._summariesRows = [];
					this.calculateSummaries();
					return;
				}
			}
			if (isToCalculate === true) {
				// if some new methods are added then recalculate
				// remove Footer Rows
				if ((compactRenderingMode === false ||
						(compactRenderingMode === 'auto' && this._analyzeAutoCompactRenderingMode() === false)) &&
							this._summariesRows.length === 1) {
					// check whether it should be removed first row - it should be removed if no info is selected
					rowToRemoveMethodName = this._summariesRows[0].type.toLowerCase();
					isToRemoveFirstRow = true;
					for (j = 0; j < this.columnSettings.length; j++) {
						// M.H. 12 Oct. 2011 Fix for bug #91580
						if (!this._isVisibleColumn(this.columnSettings[j].columnKey)) {
							continue;
						}
						for (k = 0; k < this.columnSettings[j].summaryOperands.length; k++) {
							if (this.columnSettings[j].summaryOperands[k].type.toLowerCase() === rowToRemoveMethodName &&
									this.columnSettings[j].summaryOperands[k].active !== false) {
								isToRemoveFirstRow = false;
								break;
							}
						}
						if (isToRemoveFirstRow === false) {
							break;
						}
					}
				}
				// if type is remote - rebind - otherwise - recalculate
				if (this.options.type === 'remote') {
					if (this.options.calculateRenderMode === 'onselect') {
						this.isToCalculateInRemoteMode = true;
						elemDataCalculating = {
							type: activeMethods[0].type,
							result: 'calculating',
							rowDisplayLabel: activeMethods[0].rowDisplayLabel,
							order: activeMethods[0].order,
							decimalDisplay: activeMethods[0].decimalDisplay,
							// M.H. 27 Sept. 2011 Fix for bug #88109 - add dataType
							dataType: this.newColumnSettings[selectedColumnSettingsIndex].dataType
						};

						if (this._data[columnKey] === null || this._data[columnKey] === undefined) {
							this._data[columnKey] = [];
						}
						this._data[columnKey].push(elemDataCalculating);

						this._renderFooterColumnInfo(columnKey,
										this._data[columnKey]
							);
					} else {
						this._setDataSourceColumnSettingsOptions();
						this.grid.dataSource.dataBind();
					}
				} else {
					/*
					if (this.options.calculateDataView === true) {
						// get summaries only for current DataView - e.g. if paging is enabled only for current page
						data = ds.dataView();
					} else if (ds._filteredData !== undefined && ds._filteredData !== null) {
						data = ds._filteredData;
					} else {
						data = ds.data();
					}*/
					data = this._dataSummaries();
					// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
					if (this._trigger(this.events.summariesCalculating, null, {owner: this}) !== false) {
						res = this.calculateSummaryColumn(columnKey, activeMethods, data, this.newColumnSettings[selectedColumnSettingsIndex].dataType);
						if (compactRenderingMode === false ||
								(compactRenderingMode === 'auto' && this._analyzeAutoCompactRenderingMode() === false)) {
							this._renderFooterColumnInfo(columnKey, res);
						}
						// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
						this._trigger(this.events.summariesCalculated, null, {data: data, owner: this});
					}
				}
			}
			unactiveMethodsLength = unactiveMethods.length;
			if (compactRenderingMode === true ||
					(compactRenderingMode === 'auto' && this._analyzeAutoCompactRenderingMode() === true)) {
				cs = this.newColumnSettings;
				csLength = cs.length;
				max = 0;
				newMax = 0;
				if (compactRenderingMode === 'auto') {
					unactiveMethods = [];
					for (i = 0; i < methodsLength; i++) {
						$checkbox = $('#' + this._id('summaries_footer_checkbox', methods[i].type.toLowerCase(), columnKey));
						isChecked = ($checkbox.attr('data-chk').toLowerCase() === 'on');
						if (isChecked === false) {
							unactiveMethods.push(methods[i]);
						}
					}
					unactiveMethodsLength = unactiveMethods.length;
				}
				for (i = 0; i < unactiveMethodsLength; i++) {
					this._removeDataResult(columnKey, unactiveMethods[i].type.toLowerCase());
				}
				if (unactiveMethodsLength > activeMethods.length) {
					// remove empty rows
					for (i = 0; i < csLength; i++) {
						// M.H. 12 Oct. 2011 Fix for bug #91580
						if (!this._isVisibleColumn(cs[i].columnKey)) {
							continue;
						}
						newMax = 0;
						for (j = 0; j < cs[i].summaryOperands.length; j++) {
							if (cs[i].summaryOperands[j].active === true) {
								newMax++;
							}
						}

						if (newMax > max) {
							max = newMax;
						}
					}
					summariesRowsLength = this._summariesRows.length;

					if (max > summariesRowsLength) {
						return;
					}
					for (i = 0; i < max; i++) {
						$('#' + this._id('summaries', 'footer_row_text_container',
									this._summariesRows[i].type.toLowerCase(),
									columnKey))
							.html(this.options.emptyCellText);
					}
					for (i = max; i < summariesRowsLength; i++) {
						$('#' + this._summariesRows[i].id).remove();
						if (hasFixedColumns) {
							$('#' + this._summariesRows[i].id + '_fixed').remove();
						}
					}
					for (i = max; i < summariesRowsLength; i++) {
						this._summariesRows.pop();
					}
					if (hasFixedColumns && this.grid.options.height === null &&
						$.ig.util.isIE && $.ig.util.browserVersion >= 9) {
						this.grid.element.data("igGridColumnFixing")._syncTableHeights();
					}
				} else if (activeMethods.length > unactiveMethodsLength) {
					this._initCompactModeSummariesRows();
				}
				this._renderFooterColumnInfo(columnKey, this._data[columnKey]);

				if (this._summariesRows.length === 0) {
					this._insertSummariesRows(this.defaultSummaryMethods[0].type.toLowerCase(),
						this.defaultSummaryMethods[0].order);
					this._renderFooterIcons();
				}
				this._adjustHeights();
			}
			if (isToRerender &&
					(compactRenderingMode === false ||
					(compactRenderingMode === 'auto' && this._analyzeAutoCompactRenderingMode() === false))
					) {
				// if it should be removed members do not recalculate only remove cells
				for (i = 0; i < unactiveMethodsLength; i++) {
					methodNameToRemove = unactiveMethods[i].type.toLowerCase();
					$('#' + this._id('summaries', 'footer_row_text_container', methodNameToRemove, columnKey))
						.html(this.options.emptyCellText);
					this._removeDataResult(columnKey, methodNameToRemove);
					// M.H. 12 Oct. 2011 Fix for bug #91580
					if (this._summariesRows.length <= 1) {
						continue;
					}
					// check is to remove row 
					// it should be removed only when summaries rows are more than 1 
					// for each cell of this row it is not shown info
					isToRemoveRow = true;
					for (j = 0; j < this.columnSettings.length; j++) {
						if (!this._isVisibleColumn(this.columnSettings[j].columnKey)) {
							continue;
						}
						for (k = 0; k < this.columnSettings[j].summaryOperands.length; k++) {
							if (this.columnSettings[j].summaryOperands[k].type.toLowerCase() === methodNameToRemove &&
									this.columnSettings[j].summaryOperands[k].active !== false) {
								isToRemoveRow = false;
								break;
							}
						}
						if (isToRemoveRow === false) {
							break;
						}
					}
					if (isToRemoveRow === true && this._summariesRows.length > 1) {
						this._removeRowsDataByType(methodNameToRemove);
						$('#' + this._id('summaries', 'footer_row', methodNameToRemove)).remove();
						if (hasFixedColumns) {
							$('#' + this._id('summaries', 'footer_row', methodNameToRemove, 'fixed')).remove();
						}
					}
				}
				if (this._summariesRows.length >= 1 && isToRemoveFirstRow === true) {
					for (i = 0; i < activeMethods.length; i++) {
						if (activeMethods[i].type.toLowerCase() === rowToRemoveMethodName) {
							break;
						}
					}
					if (i === activeMethods.length) {
						this._removeRowsDataByType(rowToRemoveMethodName);
						$('#' + this._id('summaries', 'footer_row', rowToRemoveMethodName)).remove();
						if (hasFixedColumns) {
							$('#' + this._id('summaries', 'footer_row', rowToRemoveMethodName, 'fixed')).remove();
						}
					}
				}
				if (this._summariesRows.length > 0 && $('#' + this._id('summaries', 'footer_row_button_dd', this._summariesRows[0].type, columnKey)).length === 0) {
					this._renderFooterIcons();
				}
				this._adjustHeights();
			}
		},
		_analyzeAutoCompactRenderingMode: function () {
			// when compact rendering mode is Auto analyze whether to render as compact or not 
			// when for each of the columns is selected only 1(or less) methods then render as compact and returns TRUE otherwise returns FALSE
			var i, j, methods,
				cs,
				methodsLength,
				activeMethodsCount,
				columnSettingsLength = this.columnSettings.length;
			for (j = 0; j < columnSettingsLength; j++) {
				cs = this.columnSettings[j];
				methods = cs.summaryOperands;
				methodsLength = methods.length;
				// check each of the rendered methods - if there are changes - re-render
				activeMethodsCount = 0;
				for (i = 0; i < methodsLength; i++) {
					if (methods[i].active === true && ++activeMethodsCount > 1) {
						return false;
					}
				}
			}
			return true;
		},
		_removeRowsDataByType: function (methodNameToRemove) {
			if (methodNameToRemove === undefined || methodNameToRemove === null) {
				return;
			}
			var hasFixedColumns = this.grid.hasFixedColumns();
			this._summariesRows = $.grep(this._summariesRows, function (n) {
				if (n.type === methodNameToRemove) {
					$(n).remove();
					if (hasFixedColumns) {
						$('#' + n.id + '_fixed').remove();
					}
				}
				return (n.type !== methodNameToRemove);
			});
		},
		_syncFixedUnfixedRowHeights: function () {
			var $tfoot = this.grid.footersTable().find('tfoot'),
				$fixedTFoot = this.grid.fixedFootersTable().find('tfoot'),
				summariesRows = $tfoot.find('tr[data-role]'),
				fixedSummariesRows = $fixedTFoot.find('tr[data-role]'),
				$fixedRow;
			
			$.each(summariesRows, function (index, r) {
				var h, fixedRowHeight, rowHeight, $row = $(r);
				
				$fixedRow = fixedSummariesRows.eq(index);
				if ($fixedRow.length === 0) {
					return true;
				}
				fixedRowHeight = $fixedRow.height();
				rowHeight = $row.height();
				if (fixedRowHeight > rowHeight) {
					h = fixedRowHeight;
				} else {
					h = rowHeight;
				}
				$row.height(h);
				$fixedRow.height(h);
			});
		},
		_clearFooterIcons: function () {
			var i, currentRow = this._currentRowShownIcons,
				columns,
				columnsLength;

			if (currentRow === null || currentRow === undefined) {
				return;
			}

			columns = this.grid.options.columns;
			columnsLength = columns.length;
			for (i = 0; i < columnsLength; i++) {
				$('#' + this._id('summaries', 'footer_row_button_dd', currentRow.type, columns[i].key)).remove();
			}
		},
		clearAllFooterIcons: function () {
			/* Remove all summaries dropdown buttons. */
			var i, j,
				rows = this._summariesRows,
				rowsLength = rows.length,
				columns = this.grid.options.columns,
				columnsLength = columns.length;

			for (i = 0; i < rowsLength; i++) {
				for (j = 0; j < columnsLength; j++) {
					$('#' + this._id('summaries', 'footer_row_button_dd', rows[i].type, columns[j].key)).remove();
				}
			}
		},
		_clearAllRows: function () {
			// remove all rows as markup AND remove internal rows Data
			var i,
				summaryRowsLength = this._summariesRows.length,
				hasFixedColumns = this.grid.hasFixedColumns(),
				$row;

			for (i = 0; i < summaryRowsLength; i++) {
				$row = $('#' + this._summariesRows[i].id);
				$row.remove();
				if (hasFixedColumns) {
					$('#' + this._summariesRows[i].id + '_fixed').remove();
				}
			}
			this._summariesRows.length = 0;
		},
		_removeUnusedFooterRows: function (oldRows) {
			var i, j,
				sr = this._summariesRows,
				summariesRowsLength = this._summariesRows.length,
				hasFixedColumns = this.grid.hasFixedColumns(),
				oldRowsLength = oldRows.length;
			// if count of summaries rows is 0 then remove old rows
			if (summariesRowsLength === 0) {
				for (i = 0; i < oldRowsLength; i++) {
					$('#' + oldRows.id).remove();
				}
				return;
			}
			// remove those old rows that are not contained in summaries rows
			for (i = 0; i < oldRowsLength; i++) {
				for (j = 0; j < summariesRowsLength; j++) {
					if (sr[j].id === oldRows[i].id) {
						continue;
					}
				}
				if (j === summariesRowsLength) {
					$('#' + oldRows[i].id).remove();
					if (hasFixedColumns) {
						$('#' + oldRows[i].id + '_fixed').remove();
					}
				}
			}
		},
		_renderFooterIcons: function (startInd, endInd) {
			var i,
				columnKey,
				sr = this._summariesRows,
				columnSetting,
				isToRemoveRow = true,
				gridColumns = this.grid.options.columns,
				gridColumnsLength = gridColumns.length,
				methodName;

			if (startInd === null || startInd === undefined) {
				startInd = 0;
			}
			if (endInd === null || endInd === undefined) {
				endInd = gridColumnsLength;
			}
			if (sr.length === 0) {
				return;
			}
			this._clearFooterIcons();
			methodName = sr[0].type;
			this._currentRowShownIcons = sr[0];
			for (i = startInd; i < endInd; i++) {
				columnKey = gridColumns[i].key;
				if (this._disallowedSummaries[columnKey] === true) {
					continue;
				}
				// check is to render icon - if there is no summary methods do not render
				columnSetting = this._getColumnSettingByKey(columnKey);
				if (columnSetting === null ||
						columnSetting === undefined ||
						columnSetting.length === 0 ||
						columnSetting.allowSummaries === false) {
					continue;
				}
				isToRemoveRow = false;
				this._renderFooterIconMarkup(methodName, columnKey);
				/*
				$button = $('<span></span>')
					.appendTo($('#' + this._id('summaries', 'footer_row_icon_container', methodName, columnKey)))
					.addClass(self.css.footerButtonIcon);//self.css.footerButtonIcon
				$button.wrap('<a id="' +  
					this._id('summaries', 'footer_row_button_dd', methodName, columnKey) + '" href="#" title="' + '" ></a>');
				$button.data('columnKey', columnKey);
				$button.parent().bind({
					mousedown: $.proxy(self._onMouseDownFooterIcon, self),
					click: $.proxy(self._onClickFooterIcon, self),
					mouseover: $.proxy(self._onMouseOverFooterIcon, self),
					mouseout: $.proxy(self._onMouseOutFooterIcon, self)
				});
				*/
			}
			if (isToRemoveRow === true) {
				this._removeRowsDataByType(methodName);
			}
			// M.H. 14 Oct. 2011 Fix for bug #88116
			/*
			if (this._documentClickHandler === null || this._documentClickHandler === undefined) {
				documentClickHandler = $.proxy(self._documentClick, self);
				self._documentClickHandler = documentClickHandler;
				$(document).bind('mousedown', documentClickHandler);
			}
			*/
		},
		_renderFooterIconMarkup: function (methodName, columnKey) {
			var self = this,
				$button;

			$button = $('<span></span>')
				.appendTo($('#' + this._id('summaries', 'footer_row_icon_container', methodName, columnKey)))
				.addClass(self.css.footerButtonIcon);//self.css.footerButtonIcon
			$button.wrap('<a id="' +
				this._id('summaries', 'footer_row_button_dd', methodName, columnKey) + '" href="#" title="' + '"></a>');
			$button.data('columnKey', columnKey);
			$button.closest('td').bind({
				"mousedown.summaries": function (e) { self.toggleDropDown(columnKey, null); e.stopPropagation(); }
            });
			$button.parent().bind({
				mousedown: $.proxy(self._onMouseDownFooterIcon, self),
				click: $.proxy(self._onClickFooterIcon, self),
				mouseover: $.proxy(self._onMouseOverFooterIcon, self),
				mouseout: $.proxy(self._onMouseOutFooterIcon, self),
				focus: $.proxy(self._onMouseOverFooterIcon, self),
				blur: $.proxy(self._onMouseOutFooterIcon, self),
				keydown: function (event) {
					if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
						event.stopPropagation();
						event.preventDefault();
						self.toggleDropDown(null, event);
					}
				}
			});
		},
		_onMouseOverFooterIcon: function (e) {
			var $button = $(e.target);

			if ($button.closest('div').hasClass(this.css.footerButtonIconActive) === false) {
				$button.closest('div').addClass(this.css.footerButtonIconHover);
			}
		},
		_onMouseOutFooterIcon: function (e) {
			var $button = $(e.target);
			if ($button.closest('div').hasClass(this.css.footerButtonIconActive) === false) {
				$button.closest('div').removeClass(this.css.footerButtonIconHover);
			}
		},
		_onClickFooterIcon: function (e) {
			e.preventDefault();
		},
		_onMouseDownFooterIcon: function (event) {
//            event.preventDefault();
//            event.stopPropagation();
			this.toggleDropDown(null, event);//, true
		},
		_isFirstRowEmpty: function () {
			/*
			Check whether first footer summaries row is empty
			*/
			var i,
				res = true,
				columnKey,
				sr = this._summariesRows,
				data = null,
				row,
				gridColumns = this.grid.options.columns,
				gridColumnsLength = gridColumns.length;

			if (sr.length === 0) {
				// there is no first row
				return false;
			}
			row = sr[0];
			for (i = 0; i < gridColumnsLength; i++) {
				columnKey = gridColumns[i].key;
				data = this._getDataByKeyMethodName(columnKey, row.type);
				if (data !== null) {
					return false;
				}
			}
			return res;
		},
		toggleDropDown: function (columnKey, event) {//, explicitClose
			/* Toggle drop down
			paramType="string" toggle drop down for the column with the specified key
			paramType="object" event object. Its data should contain current columnKey, isAnimating, buttonId*/
			//paramType="bool" If true and option calculateRenderMode is okcancelbuttons then rollbacks checkboxes state before showing the active dropdown
            var $target, $dialog, top, left, self, isVisible, rOffset, $footersTable;
			if (!event) {
				// M.H. 2 Jul 2014 Fix for bug #174640: When click summries cell to show menu in fixed part js error is thrown
				if (this.grid.isFixedColumn(columnKey)) {
					$footersTable = this.grid.fixedFootersTable();
				} else {
					$footersTable = this.grid.footersTable();
				}
				$target = $footersTable
					.find('tfoot tr:first-child td[data-key=' + columnKey + '] a>span');
			} else {
				$target = $(event.target);
				columnKey = $target.data('columnKey');
			}
			if (columnKey === null || columnKey === undefined) {
				// tries to get span
				$target = $target.find('span');
				columnKey = $target.data('columnKey');
			}
			$dialog = $('#' + this._id('summaries', 'methods_dialog', columnKey));
			top = $.ig.util.offset($target).top;
			left = $.ig.util.offset($target).left;
			self = this;
			isVisible = ($dialog.is(':visible') === true);
			// if $dialog is not found OR animating is in progress AND active dialog is the same as $dialog
			if ($dialog.length === 0 ||
					$dialog.data('isAnimating') === true
					) {
				return;
			}
			// M.H. 31 Oct 2013 Fix for bug #156216: Summaries dialog appears over the summaries button in jquery 1.8.1 and above
			top -= $target.height() - 2;
			if ($target.is('span') === true) {
				// M.H. 18 Oct. 2011 Fix for bug 92709 - save id of the button element
				$dialog.data('buttonId', $target.parent().attr('id'));
			}
			if (!isVisible) {
				rOffset = $.ig.util.getRelativeOffset($dialog);
				$dialog.css({'top': top - $dialog.height() - rOffset.top, 'left': left - rOffset.left});
			}
			if (self._activeDialog !== null &&
					self._activeDialog !== undefined &&
					$dialog !== self._activeDialog &&
					columnKey !== self._activeDialog.data('columnKey')) {
				self.showHideDialog(self._activeDialog);//, true
			}

			if (isVisible === true) {
				self._currentOpenedColumnKey = null;
			} else {
				self._currentOpenedColumnKey = columnKey;
			}
            // M.H. 10 Jan 2014 Fix for bug #160290: Reversing change from summaries dropdown does not work when clicking over summaries footer button or hitting escape key
			self.showHideDialog($dialog);//, explicitClose
		},
		showHideDialog: function ($dialog) {//, explicitClose
			/* Show/Hide dialog 
				paramType="object" jQuery object representation of dropdown div element*/
			//paramType="bool" If true and option and option calculateRenderMode is okcancelbuttons then rollbacks checkboxes state before showing the active dropdown
			if ($dialog === null || $dialog === undefined) {
				return;
			}
			var self = this,
				e = this.events,
				// M.H. 18 Oct. 2011 Fix for bug 92709
				$button = $('#' + $dialog.data('buttonId')),
				columnKey = $dialog.data('columnKey'),
				animationDuration = self.options.dropDownDialogAnimationDuration;

			if ($dialog.data('isAnimating') === true && self._activeDialog === $dialog) {
				return;
			}
			if (($dialog.is(':visible') === true)) {
				// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
				if (this._trigger(e.dropDownClosing, null, {columnKey: columnKey, owner: this}) === false) {
					return;
				}
				if ($button !== null && $button !== undefined) {
					$button.closest('div').removeClass(self.css.footerButtonIconActive);
				}
			} else {
				// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
				if (this._trigger(e.dropDownOpening, null, {columnKey: columnKey, owner: this}) === false) {
					return;
				}
				if ($button !== null && $button !== undefined) {
					$button.closest('div').removeClass(self.css.footerButtonIconHover);
					$button.closest('div').addClass(self.css.footerButtonIconActive);
                    // M.H. 13 Jan 2014 Fix for bug #160382: Summaries hidden by the user get visible after an igGrid.dataBind method was called.
                    this._rollbackCheckboxState(columnKey);
				}
			}
			// M.H. 14 Oct. 2011 Fix for bug 88116
			if (animationDuration <= 0) {
				animationDuration = 1;
			}
			$dialog.data('isAnimating', true);
			$dialog.toggle(
				'slide',
				{
					duration: animationDuration,
					direction: 'down'
				},
				function () {
					$dialog.data('isAnimating', false);
					if ($dialog.is(':visible') === true) {
						$dialog.focus();
						// M.H. 3 Oct 2013 Fix for bug #153904: When you open feature chooser and move column by dragging the feature chooser does not close.
						self.grid._focusedElement = $dialog;
						self._activeDialog = $dialog;
						// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
						self._trigger(e.dropDownOpened, null, {columnKey: columnKey, owner: this});
					} else {
						// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
						self._trigger(e.dropDownClosed, null, {columnKey: columnKey, owner: this});
						// M.H. 3 Oct 2013 Fix for bug #153904: When you open feature chooser and move column by dragging the feature chooser does not close.
						self.grid._focusedElement = null;
						// on close try to calculate for the selected column summaries
						if (self.options.type === 'remote' &&
								self.options.calculateRenderMode === 'onselect' &&
								self.isToCalculateInRemoteMode === true) {
							// recalculate when the drop down is closed(if there is such need)
							self.isToCalculateInRemoteMode = false;
							self._setDataSourceColumnSettingsOptions();
							self.grid.dataSource.dataBind();
						}
						//self._activeDialog = null;
						//$(document).unbind('mousedown', documentClickHandler);
						// M.H. 31 Oct. 2011 Fix for bug 94362
						if (self._activeDialog !== null &&
								self._activeDialog !== undefined &&
								(self._activeDialog.data('columnKey') === columnKey)) {
							self._activeDialog = null;
						}
					}
				}
			);
		},
		// M.H. 14 Oct. 2011 Fix for bug 88116
		/*
		_documentClick: function (e) {
			var self = this,
				clickX = e.pageX,
				clickY = e.pageY,
				$dialog = this._activeDialog,
				dialogWidth,
				dialogHeight,
				dialogTop,
				dialogLeft;
			return;
			if ($dialog === null || $dialog === undefined) {
				return;
			}
			if ($dialog.is(':visible') === false) {
				this._activeDialog = null;
				return;
			}

			dialogWidth = $dialog.width();
			dialogHeight = $dialog.height();
			dialogTop = parseInt($dialog.css('top'), 10);
			dialogLeft = parseInt($dialog.css('left'), 10);

			if (clickX < dialogLeft || clickX > dialogLeft + dialogWidth
					|| clickY < dialogTop || clickY > dialogTop + dialogHeight) {
				self._closeDropDown();
			}
		},
		*/
		_closeDropDown: function () {
			var $dialog = this._activeDialog;
            
            this.showHideDialog($dialog);//, true
		},
		_setDataSourceColumnSettingsOptions: function () {
			// it should be initialized/refreshed newColumneSettings before call this method
			var o = this.options;

			this.grid.dataSource.settings.summaries.columnSettings = this.newColumnSettings;
			this.grid.dataSource.settings.summaries.type = o.type;
			this.grid.dataSource.settings.summaries.summaryExecution = o.summaryExecution;
			this.grid.dataSource.settings.summaries.summaryExprUrlKey = o.summaryExprUrlKey;
			this.grid.dataSource.settings.summaries.summariesResponseKey = o.summariesResponseKey;
			// L.A. 15 January 2013 - Fixing bug #130642, 128891
			// The hierarchical grid bound to remote data throws a js error when you expand a row.
			if (this.grid.dataSource.type && this.grid.dataSource.type() === "remoteUrl" &&
					this.grid._dataOptions && $.type(this.grid._dataOptions.dataSource) === "string") {
				this.grid.dataSource.settings.dataSource = this.grid._dataOptions.dataSource;
			}
		},
		_getColumnSettingByKey: function (columnKey) {
			var i, len = this.columnSettings.length;

			if (columnKey === null || columnKey === undefined) {
				return null;
			}
			for (i = 0; i <  len; i++) {
				if (this.columnSettings[i].columnKey === columnKey) {
					return this.columnSettings[i];
				}
			}
			return null;
		},
		/* summary columns specific code */
		_renderHeaderCellButton: function (columnCell, columnKey) {
			var summaryHeaderIconContainer,
				self = this,
				css = self.css,
				buttonId = this._id('summaries', 'header_column_icon', columnKey),
				$button,
				$divHeaderButtonContainer;

			summaryHeaderIconContainer = columnCell.find('.ui-iggrid-indicatorcontainer');
			this.grid._enableHeaderCellFeature(columnCell);
			if (summaryHeaderIconContainer.length === 0) {
				summaryHeaderIconContainer = $('<div></div>').appendTo(columnCell);
				summaryHeaderIconContainer.addClass('ui-iggrid-indicatorcontainer');
			}
			$('#' + buttonId).remove();
			// M.H. 31 Oct. 2011 Fix for bug 94362
			$button = $('<a></a>')
				.attr('href', '#')
				.attr('id', buttonId)
				.attr('title', this.options.summariesHeaderButtonTooltip);

			// M.H. 31 Oct. 2011 Fix for bug 94362
			$divHeaderButtonContainer = summaryHeaderIconContainer.find('.ui-iggrid-summaries-headerbuttoncontainer');
			if ($divHeaderButtonContainer.length === 0) {
				$divHeaderButtonContainer = $('<div></div>').addClass(css.headerButtonContainer).appendTo(summaryHeaderIconContainer);
			}
			$button.appendTo($divHeaderButtonContainer);
			$('<span></span>')
				.addClass(css.headerButtonIcon)
				.appendTo($button);
			if ($.ig.util.isIE7 === true) {
				$button.parent().addClass(this.css.baseClassIE7);
			}
			$button.hover(
				function () {$(this).parent().addClass(css.headerButtonIconHover); },
				function () {$(this).parent().removeClass(css.headerButtonIconHover); }
			);
			$button.bind({
				click: function (event) {
					event.preventDefault();
					event.stopPropagation();
					self._internalToggleSummariesRow(null, event);
				}
			});
		},
		_togglefromfc: function (event, columnKey, isSelected) {
			this._internalToggleSummariesRow(isSelected, event);
		},
		_internalToggleSummariesRow: function (isToShow, event) {
			if (isToShow === null || isToShow === undefined) {
				isToShow = !this._isRenderedSummariesRows;
			}
			// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
			if (this._trigger(this.events.summariesToggling, event, {isToShow: isToShow, owner: this}) === false) {
				return;
			}
			this.toggleSummariesRows(isToShow, true);
			// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
			this._trigger(this.events.summariesToggled, event, {isShown: isToShow, owner: this});
		},
		toggleSummariesRows: function (isToShow, isInternalCall) {
			/* Toggle summaries rows
			paramType="bool" Specifies whether to show or not summaries
			paramType="bool" Optional parameter.Specifies whether this function is called internally by the widget. */
			var fc, cs, csLength, i, $hScroller, hScrollerLeft;

			if (isToShow === true) {
				$hScroller = $('#' + this.grid.id() + '_horizontalScrollContainer');
				// M.H. 11 Sep 2013 Fix for bug #146740: Toggling the summaries will show wrong results when columnVirtualization = true
				if ($hScroller.length > 0) {
					hScrollerLeft =  $hScroller.scrollLeft();
					$hScroller.scrollLeft(0);
				}
				this.calculateSummaries();
				// M.H. 11 Sep 2013 Fix for bug #146740: Toggling the summaries will show wrong results when columnVirtualization = true
				if (hScrollerLeft) {
					setTimeout(function () {
						$hScroller.scrollLeft(hScrollerLeft);
					}, 0);
				}
				// M.H. 28 Sept. 2011 Fix for bug #89580
				this.grid._scrollFooter();
				this._isSummariesRowsHidden = false;
				// M.H. 23 Jan 2012 Fix for bug #99938
				if (this._summariesRows.length === 0) {
					// it should be shown summaries rows
					cs = this.newColumnSettings;
					csLength = cs.length;
					this._insertSummariesRows(this.defaultSummaryMethods[0].type, this.defaultSummaryMethods[0].order);
					for (i = 0; i < csLength; i++) {
						if (!this._isVisibleColumn(cs[i].columnKey)) {
							continue;
						}
						this._renderFooterIconMarkup(this.defaultSummaryMethods[0].type, cs[i].columnKey);
					}
				}
			} else {
				this._removeFooterRows();
				this._isSummariesRowsHidden = true;
			}
			this._adjustHeights();
			if (isInternalCall === undefined || isInternalCall === false) {
				fc = this.grid.element.data('igGridFeatureChooser');
				if (fc !== null && fc !== undefined) {
					fc._toggleSelectedItems('Summaries', !isToShow);
				}
			}
		},
		_renderDropDown: function (columnKey) {
			var $dialog, $ul, i, j,
				$buttonOK, $buttonCancel,
				$div, minInd, swap, $li,
				id = this._id('summaries', 'methods_dialog', columnKey), methodsLength,
				cs = this._getColumnSettingByKey(columnKey),
				css = this.css,
				checkboxId,
				allowedMethods,
				self = this,
				o = this.options,
				isChecked = false,
				cssClassCheckBox,
				onFocusLi,
				onMousedownLi,
				toggleState,
				onBlurLi,
				onKeydownLi,
				onMousedown,
				onMouseover,
				onMouseout,
				$checkbox,
				onClick;

			if (cs === null || cs === undefined) {
				return;
			}
			allowedMethods = cs.summaryOperands;
			if (allowedMethods === null || allowedMethods === undefined) {
				return;
			}
			// remove div with specified id if exists
			// M.H. 29 Oct 2012 Fix for bug #120642
			// M.H. 7 Nov 2012 Fix for bug #126637
			$('#' + id).remove();
			$dialog = $('<div></div>').appendTo(this.grid._rootContainer()).attr('id', id)
				.css('position', 'absolute')
				.css('width', this.options.dropDownWidth)
				.css('height', this.options.dropDownHeight)
				.addClass(this.css.columnSummariesDropdown)
				// M.H. 14 Oct. 2011 Fix for bug 88116
				.attr('tabindex', 0)
				.hide();
			$dialog.data('methods', allowedMethods);
			$ul = $('<ul></ul>').addClass(css.dropDownListContainer);
			$ul.appendTo($dialog);
			// render allowed methods
			methodsLength = allowedMethods.length;
			for (i = 0; i < methodsLength; i++) {
				minInd = i;
				for (j = i; j < methodsLength; j++) {
					if (allowedMethods[j].order === null || allowedMethods[j].order === undefined) {
						allowedMethods[j].order = 0;
					}
					if (allowedMethods[minInd].order > allowedMethods[j].order) {
						minInd = j;
					}
				}
				if (minInd !== i) {
					// swap elements
					swap = allowedMethods[minInd];
					allowedMethods[minInd] = allowedMethods[i];
					allowedMethods[i] = swap;
				}
			}
			toggleState = function ($checkbox, event) {
				self.toggleCheckstate($checkbox);
				// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
				// M.H. 18 Oct. 2011 Fix for bug #92828 - this event should be triggered not only for calculaterendermode="onselect"
                self._trigger(
                    self.events.summariesMethodSelectionChanged,
                    event,
                    {
                        columnKey: columnKey,
						isSelected: ($checkbox.attr('data-chk').toLowerCase() === 'on'),
						methodName: $checkbox.data('methodName'),
						owner: this
                    }
                );
                if (o.calculateRenderMode === 'onselect') {
                    self._calculateSelectedSummaries(columnKey);
					if (self.grid.hasFixedColumns()) {
						self._syncFixedUnfixedRowHeights();
					}
                }
            };
            onClick = function (event) {
				toggleState($(event.currentTarget), event);
				// M.H. 14 Oct. 2011 Fix for bug 88116
				if (self._activeDialog) {
					self._activeDialog.data('focussed', true);
					self._activeDialog.focus();
				}
				event.preventDefault();
				event.stopPropagation();
            };
			onMousedown = function (event) {
				// M.H. 14 Oct. 2011 Fix for bug 88116
				if (self._activeDialog) {
					self._activeDialog.data('focussed', true);
					self._activeDialog.focus();
				}
				event.preventDefault();
				event.stopPropagation();
			};
			onMouseover = function (event) {
				$(event.currentTarget).addClass(css.checkboxHovered);
			};
			onMouseout = function (event) {
				$(event.currentTarget).removeClass(css.checkboxHovered);
			};
			$dialog.bind({
				blur: function (event) {
					// M.H. 14 Oct. 2011 Fix for bug 88116
					$dialog.data('focussed', false);
					setTimeout($.proxy(self._checkCloseDropDown, self), 300);
				},
				focus: function (event) {
					$dialog.data('focussed', true);
				},
				keydown: function (event) {
					if (event.keyCode === $.ui.keyCode.ESCAPE ||
							event.keyCode === $.ui.keyCode.SPACE ||
							event.keyCode === $.ui.keyCode.ENTER) {
						event.stopPropagation();
						event.preventDefault();
						self.toggleDropDown(null, event);//, (event.keyCode === $.ui.keyCode.ESCAPE)
						if (self._summariesRows.length > 0) {
							$('#' + self._id('summaries', 'footer_row_button_dd', self._summariesRows[0].type, columnKey))
								.focus();
						}
					}
				}
			});
			onFocusLi = function (event) {
				if (self._activeDialog) {
					self._activeDialog.data('focussed', true);
				}
			};
			onBlurLi = function (e) {
				if (self._activeDialog) {
					self._activeDialog.data('focussed', false);
				}
				setTimeout($.proxy(self._checkCloseDropDown, self), 300);
			};
			onKeydownLi = function (event) {
				var $liFocused = $(this),
					keyCode = event.keyCode;
				
				if (keyCode === $.ui.keyCode.ENTER || keyCode === $.ui.keyCode.SPACE) {
					//$liFocused.mousedown();
					toggleState($('#' + $liFocused.data('checkboxId')), event);
					event.stopPropagation();
					event.preventDefault();
				} else if (keyCode === $.ui.keyCode.ESCAPE) {
					$dialog.blur();
				}
			};
			onMousedownLi = function (event) {
				toggleState($('#' + $(this).data('checkboxId')), event);
			};
			for (i = 0; i < methodsLength; i++) {
				checkboxId = this._id('summaries_footer_checkbox', allowedMethods[i].type.toLowerCase(), columnKey);
				if (allowedMethods[i].active === true || allowedMethods[i].active === 1) {
					isChecked = 'on';
					cssClassCheckBox = css.checkboxOn;
				} else {
					isChecked = 'off';
					cssClassCheckBox = css.checkboxOff;
				}
				$li = $('<li></li>')
					.data('checkboxId', checkboxId)
					.addClass(css.dropDownListItem)
					.appendTo($ul)
					.attr('tabindex', 0);
				$li.bind({
					focus: onFocusLi,
					blur: onBlurLi,
					keydown: onKeydownLi,
					mousedown: onMousedownLi
				});
				$('<span id="' + checkboxId + '" class="' + css.checkbox + '"></span>')
					.appendTo($li);
				$('<label></label>')
					.html(allowedMethods[i].rowDisplayLabel)
					.appendTo($li);
				$checkbox = $('#' + checkboxId);
				$('<span class="' + cssClassCheckBox + '"></span>').appendTo($checkbox);
				$checkbox
					.attr('data-chk', isChecked)
					.attr('data-role', 'checkbox');
				$checkbox.data('methodName', allowedMethods[i].type);
				$checkbox.bind({
					//change: onChange,
					'click': onClick,
					'mouseover': onMouseover,
					'mouseout': onMouseout,
					'mousedown': onMousedown
				});
			}
			$div = $('<div></div>')
				.addClass(this.css.footerDropdownButtonsContainer)
				.appendTo($dialog);
			if (o.calculateRenderMode === 'okcancelbuttons') {
				$buttonOK = $('<a href="http://localhost/">' + '</a>');
				$buttonOK
					.attr('id', this._id('summaries', 'dialog_button_ok', columnKey))
					.appendTo($div);
				$buttonOK.igButton({
					// M.H. 22 Nov. 2011 Fix for bug 84440
					link: {href: '#', title: ''},
					labelText: this.options.dialogButtonOKText,
					// M.H. 22 Nov. 2011 Fix for bug 84440
					keydown: function (event) {
						if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
							self._clickOKButton(columnKey);
						}
						if (event.keyCode !== $.ui.keyCode.TAB) {
							event.stopPropagation();
							event.preventDefault();
						}
					},
					click: function (e) {
						self._clickOKButton(columnKey);
						// M.H. 12 Oct. 2011 Fix for bug #89777
						e.preventDefault();
						e.stopPropagation();
					},
					mousedown: function (event) {
						event.preventDefault();
						event.stopPropagation();
					},
					// M.H. 18 Oct. 2011 Fix for bug 88116 - on focus dropdown should NOT be closed
					focus: function (event) {
						if (self._activeDialog) {
							self._activeDialog.data('focussed', true);
						}
					},
					blur: function (e) {
						// M.H. 18 Oct. 2011 Fix for bug 88116 - on blur check whether dropdown should be closed
						// M.H. 20 Oct. 2011 Fix for bug 93136
						if (self._activeDialog) {
							self._activeDialog.data('focussed', false);
						}
						setTimeout($.proxy(self._checkCloseDropDown, self), 300);
					}
				});
				$buttonCancel = $('<a></a>');
				$buttonCancel.attr('id', this._id('summaries', 'dialog_button_cancel', columnKey)).appendTo($div);
				$buttonCancel.igButton({
					// M.H. 22 Nov. 2011 Fix for bug 84440
					link: {href: '#', title: ''},
					labelText: this.options.dialogButtonCancelText,
					click: function (e) {
						self._clickCancelButton(columnKey);
						// M.H. 12 Oct. 2011 Fix for bug #89777
						e.preventDefault();
						e.stopPropagation();
					},
					// M.H. 12 Oct. 2011 Fix for bug #89128
					mousedown: function (event) {
						event.preventDefault();
						event.stopPropagation();
					},
					// M.H. 12 Oct. 2011 Fix for bug #91433  
					focus: function (event) {
						// M.H. 18 Oct. 2011 Fix for bug 88116 - on focus dropdown should NOT be closed
						if (self._activeDialog) {
							self._activeDialog.data('focussed', true);
						}
					},
					blur: function (e) {
						// M.H. 18 Oct. 2011 Fix for bug 88116 - on blur this element check whether dropdown should be closed
						// M.H. 20 Oct. 2011 Fix for bug 93136
						if (self._activeDialog) {
							self._activeDialog.data('focussed', false);
						}
						setTimeout($.proxy(self._checkCloseDropDown, self), 300);
					}
				});
			}
			$dialog.data('columnKey', columnKey);
		},
		_checkCloseDropDown: function () {
			// M.H. 14 Oct. 2011 Fix for bug 88116
			if (this._activeDialog === null) {
				return;
			}

			if (this._activeDialog.data('focussed') === false) {
				setTimeout($.proxy(this._closeDropDown, this), 10);
			}
		},
		toggleCheckstate: function ($checkbox) {
			/* Toggles the checkstate of a checkbox if checkboxMode is not set to off, otherwise does nothing.
				paramType="object" optional="false" Specifies the jQuery object of the checkbox.
			*/
			var noCancel;
			noCancel = true;//this._triggerNodeCheckstateChanging(event, node);
			if (noCancel) {
				if ($checkbox.attr('data-chk') === 'on') {
					this.selectCheckBox($checkbox, false);
				} else {
					this.selectCheckBox($checkbox, true);
				}
			}
		},
		selectCheckBox: function ($checkbox, isToSelect) {
			/* Select/Unselect specified checkbox
				paramType="object" Specifies the jQuery object for checkbox
				paramType="bool" Specify whether to select or not checkbox
			*/
			var css = this.css,
				$innerSpan = $checkbox.children('span');

			if (isToSelect === true) {
				$innerSpan.removeClass(css.checkboxOff).addClass(css.checkboxOn);
				$checkbox.attr('data-chk', 'on');
			} else {
				$innerSpan.removeClass(css.checkboxOn).addClass(css.checkboxOff);
				$checkbox.attr('data-chk', 'off');
			}
		},
		_clickOKButton: function (columnKey) {
			var i, j, cs,
				$checkbox,
				columnSettingsLength = this.columnSettings.length,
				methods,
				methodsLength,
				eventData = [], elem;

			if (columnKey === null || columnKey === undefined) {
				return;
			}
			for (j = 0; j < columnSettingsLength; j++) {
				if (this.columnSettings[j].columnKey === columnKey) {
					cs = this.columnSettings[j];
					break;
				}
			}
			if (cs === null || cs === undefined) {
				return;
			}
			methods = cs.summaryOperands;
			methodsLength = methods.length;
			// check each of the rendered methods - if there are changes - re-render
			for (i = 0; i < methodsLength; i++) {
				$checkbox = $('#' + this._id('summaries_footer_checkbox', methods[i].type.toLowerCase(), columnKey));
				elem = {type: methods[i].type.toLowerCase(), active: false};
				if ($checkbox.attr('data-chk') !== undefined &&
						$checkbox.attr('data-chk').toLowerCase() === 'on') {
					elem.active = true;
				}
				eventData.push(elem);
			}
			// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
			this._trigger(this.events.dropDownOKClicked, null, {columnKey: columnKey, eventData: eventData, owner: this});
			// M.H. 13 Oct. 2011 Fix for bug 90350
			this.showHideDialog($('#' + this._id('summaries', 'methods_dialog', columnKey)));
			this._calculateSelectedSummaries(columnKey);
			if (this.grid.hasFixedColumns()) {
				this._syncFixedUnfixedRowHeights();
			}
		},
		_clickCancelButton: function (columnKey) {
			// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
			this._trigger(this.events.dropDownCancelClicked, null, {columnKey: columnKey, owner: this});
			this.showHideDialog($('#' + this._id('summaries', 'methods_dialog', columnKey)));//, true
		},
		_rollbackCheckboxState: function (columnKey) {
			var cs, i, j, methods, isChecked, methodsLength,
				columnSettingsLength = this.columnSettings.length,
				$checkbox;

			if (columnKey === undefined || columnKey === null) {
				return;
			}
			for (j = 0; j < columnSettingsLength; j++) {
				if (this.columnSettings[j].columnKey === columnKey) {
					cs = this.columnSettings[j];
					//selectedColumnSettingsIndex = j;
					break;
				}
			}
			if (cs === null || cs === undefined) {
				return;
			}
			methods = cs.summaryOperands;
			methodsLength = methods.length;
			// check each of the rendered methods - if there are changes - re-render
			for (i = 0; i < methodsLength; i++) {
				$checkbox = $('#' + this._id('summaries_footer_checkbox', methods[i].type.toLowerCase(), columnKey));
				if ($checkbox.attr('data-chk') !== undefined) {
					isChecked = ($checkbox.attr('data-chk').toLowerCase() === 'on');
					if (methods[i].active !== isChecked) {
						if (methods[i].active === true) {
							this.selectCheckBox($checkbox, true);
						} else {
							this.selectCheckBox($checkbox, false);
						}
					}
				}
			}
		},
		_initCompactModeSummariesRows: function () {
			/*
			Check how exactly rows should be rendered - if there is such need
			*/
			var i, j, k, cs = this.newColumnSettings,
				csLength = cs.length, columnMaxMethods = cs[0],
				cmm, cmmLength,
				countRowsToAdd,
				methodName,
				maxMethods = -1,
				summariesRowsLength,
				newMaxMethods;

			for (i = 0; i < csLength; i++) {
				// M.H. 12 Oct. 2011 Fix for bug #91580
				if (!this._isVisibleColumn(cs[i].columnKey)) {
					continue;
				}
				newMaxMethods = 0;
				if (cs[i].summaryOperands === null || cs[i].summaryOperands === undefined) {
					continue;
				}
				for (j = 0; j < cs[i].summaryOperands.length; j++) {
					if (cs[i].summaryOperands[j].active === true) {
						newMaxMethods++;
					}
				}
				if (newMaxMethods > maxMethods) {
					maxMethods = newMaxMethods;
					columnMaxMethods = cs[i];
				}
			}
			if (columnMaxMethods === undefined || columnMaxMethods === null) {
				return;
			}
			cmm = columnMaxMethods.summaryOperands;
			cmmLength = cmm.length;
			summariesRowsLength = this._summariesRows.length;
			// it should not be rendered because it is rendered
			if (summariesRowsLength > maxMethods) {
				return;
			}
			countRowsToAdd = maxMethods - summariesRowsLength;
			if (countRowsToAdd === 0) {
				return;
			}
			k = 0;
			for (i = 0; i < cmmLength; i++) {
				methodName = cmm[i].type.toLowerCase();

				if ($('#' + this._id('summaries', 'footer_row', methodName)).length === 0) {
					this._insertSummariesRows(methodName, null);
					if (++k === countRowsToAdd) {
						break;
					}
				}
			}
		},
		_calculateInternalSummaries: function () {
			var cs = this.newColumnSettings, csLength = cs.length, i,
				o = this.options, data, res,
				e = this.events;
			// M.H. 12 Oct. 2011 Fix for bug #91580
			// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
			if (this._trigger(e.summariesCalculating, null, {owner: this}) === false) {
				return;
			}
			data = this._dataSummaries();
			if (o.callee !== null &&
					o.callee !== undefined &&
					$.type(o.callee) === 'function') {
				data = o.callee(data);
			}
			if (data === null || data === undefined) {
				data = [];
			}
			if (o.compactRenderingMode === true ||
					(o.compactRenderingMode === 'auto' && this._analyzeAutoCompactRenderingMode() === true)) {
				this._initCompactModeSummariesRows();
			}
			for (i = 0; i < csLength; i++) {
				// M.H. 12 Oct. 2011 Fix for bug #91580
				if (!this._isVisibleColumn(cs[i].columnKey)) {
					continue;
				}
				res = this.calculateSummaryColumn(cs[i].columnKey, cs[i].summaryOperands, data, cs[i].dataType);
				this._renderFooterColumnInfo(cs[i].columnKey, res);
			}
			this._isRenderedSummariesRows = true;
			// M.H. 10 Oct. 2011 Fix for bug #90333 - add owner as event argument
			this._trigger(e.summariesCalculated, null, {data: data, owner: this});
		},
		_isVisibleColumn: function (columnKey) {
			// M.H. 12 Oct. 2011 Fix for bug #91580 - add function to check whether column is hidden
			var cols = this.grid._visibleColumns(), ret = false;

			$.each(cols, function (index, value) {
				if (value.key === columnKey) {
					ret = true;
					return false;
				}
			});
			return ret;
		},
		calculateSummaryColumn: function (ck, columnMethods, data, dataType) {
			/*
			Summary calculate the whole data for the specified column key, columnMethods and dataType (used when datasource is remote and dataType is date)
			paramType="string" ColumnKey
			paramType="array" Array of column methods objects
			paramType="object" Object which represents result 
			dataType="string" represents dataType for the current column
			*/
			var i, j, val,
				o = this.options,
				columnMethodsLength,
				tmpArr = [],
				rowsCount = 0,
				res = [],
				order,
				resultCalculated,
				resElement,
				methodName,
				gridDataSource,
				isDate;

			if (ck === null || ck === undefined) {
				// M.H. 22 March 2012 Fix for bug #105616
				throw new Error($.ig.GridSummaries.locale.calculateSummaryColumnKeyNotSpecified);
			}
			if (columnMethods === undefined || columnMethods === null) {
				return;
			}
			columnMethodsLength = columnMethods.length;
			// check if data source is local and type of getting information is local
			if (o.type === 'local') { // && ds._runtimeType !== "remoteUrl"
				rowsCount = data.length;
				isDate = (dataType === 'date');
				if (isDate === true) {
					for (i = 0; i < rowsCount; i++) {
						if (data[i][ck] !== null && data[i][ck] !== undefined) {
							if (data[i][ck].getTime) {
								tmpArr.push(data[i][ck].getTime());
							} else {
								tmpArr.push(data[i][ck]);
							}
						}
					}
				} else {
					for (i = 0; i < rowsCount; i++) {
						// M.H. 14 Sep 2012 Fix for bug #120721
						if (data[i][ck] === undefined) {
							data[i][ck] = null;
						}
						tmpArr.push(data[i][ck]);
					}
				}
				for (i = 0; i < columnMethodsLength; i++) {
					methodName = columnMethods[i].type.toLowerCase();
					if (methodName.startsWith('custom')) {
						methodName = 'custom';
					}
					if (columnMethods[i].active === true || columnMethods[i].active === 1) {
						order = columnMethods[i].order;
						if (order === undefined) {
							order = null;
						}
						// M.H. 27 Sept. 2011 Fix for bug #88793 - when date is null it should be tracked its count
						if (methodName === 'count') {
							resultCalculated = rowsCount;
						} else {
							resultCalculated = $.ig.calcSummaries(methodName, tmpArr, columnMethods[i].summaryCalculator, dataType);
						}
						resElement = {
							type: columnMethods[i].type,
							result: resultCalculated,
							rowDisplayLabel: columnMethods[i].rowDisplayLabel,
							order: order,
							decimalDisplay: columnMethods[i].decimalDisplay,
							isGridFormatter: columnMethods[i].isGridFormatter,
							dataType: dataType
						};
						res.push(resElement);
						this._addDataResult(ck, resElement);
					}
				}
			} else if (o.type === 'remote') {
				if (data[ck] !== undefined && data[ck] !== null) {
					for (i = 0; i < columnMethodsLength; i++) {
						val = data[ck][columnMethods[i].type];
						if (columnMethods[i].active === true || columnMethods[i].active === 1) {
							order = columnMethods[i].order;
							if (order === undefined) {
								order = null;
							}
							if (val === null || val === undefined) {
								if (columnMethods[i].summaryCalculator !== undefined) {
									// M.H. 16 Nov. 2011 Fix for bug 97886 - we should get data from dataSource, we need only the data for the specified by the columnKey fields
									gridDataSource = this.grid.dataSource._data;
									rowsCount = gridDataSource.length;
									isDate = (dataType === 'date');
									if (isDate === true) {
										for (j = 0; j < rowsCount; j++) {
											if (gridDataSource[j][ck] !== null && gridDataSource[j][ck] !== undefined) {
												tmpArr.push(gridDataSource[j][ck].getTime());
											}
										}
									} else {
										for (j = 0; j < rowsCount; j++) {
											tmpArr.push(gridDataSource[j][ck]);
										}
									}
									val = $.ig.calcSummaries(columnMethods[i].type.toLowerCase(), tmpArr, columnMethods[i].summaryCalculator, dataType);
								} else {
									val = '';
								}
							}

							res.push({
								type: columnMethods[i].type,
								result: val,
								rowDisplayLabel: columnMethods[i].rowDisplayLabel,
								order: order,
								decimalDisplay: columnMethods[i].decimalDisplay,
								isGridFormatter: columnMethods[i].isGridFormatter,
								dataType: dataType
							});
						}
					}
				}
				this._data[ck] = res;
			}
			return res;
		},
		summaryCollection: function () {
			/*
			Return a JQUERY object which holds all summaries for all columns
			*/
			return this._data;
		},
		summariesFor: function (columnKey) {
			/*
			Return a JQUERY object which holds all summaries for column with the specified column key
			*/
			return this._data[columnKey];
		},
		_addDataResult: function (columnKey, resElement) {
			var d = this._data[columnKey],
				i,
				dLen;

			if (d === null || d === undefined) {
				this._data[columnKey] = [];
				this._data[columnKey].push(resElement);
				return;
			}
			dLen = d.length;
			for (i = 0; i < dLen; i++) {
				if (d[i].type.toLowerCase() === resElement.type.toLowerCase()) {
					d[i] = resElement;
					break;
				}
			}
			if (i === dLen) {
				this._data[columnKey].push(resElement);
			}
		},
		_removeDataResult: function (columnKey, methodName) {
			var d = this._data[columnKey];

			if (d === undefined || d === null) {
				return;
			}
			d = $.grep(d, function (n) {
				return (n.type.toLowerCase() !== methodName.toLowerCase());
			});
			this._data[columnKey] = d;
		},
		_getDataByKeyMethodName: function (columnKey, methodName) {
			var i, d = this._data[columnKey], dLength, res = null;

			methodName = methodName.toLowerCase();
			if (d === undefined || d === null) {
				return null;
			}

			dLength = d.length;

			for (i = 0; i < dLength; i++) {
				if (d[i].type.toLowerCase() === methodName) {
					return d[i];
				}
			}

			return res;
		},
		_renderFooterColumnInfo: function (columnKey, data) {
			// render data for the column with specified columnKey
			if (data === null || data === undefined) {
				return;
			}
			var i, j, methodName, result, decimalDisplay,
				footerRowId, $footerRow, order,
				compactRenderingMode = this.options.compactRenderingMode,
				dataLength = data.length,
				min, swapElement;

			if (compactRenderingMode === true ||
					((this.options.compactRenderingMode === 'auto' &&
						this._analyzeAutoCompactRenderingMode() === true))
					) {
				//if (dataLength < this._summariesRows.length) {
				// reorder data
				if (dataLength > 1) {
					for (i = 0; i < dataLength; i++) {
						min = i;
						for (j = i + 1; j < dataLength; j++) {
							if (data[j].order < data[min].order) {
								swapElement = data[j];
								data[j] = data[min];
								data[min] = swapElement;
								min = j;
							}
						}
					}
				}
				for (i = 0; i < dataLength; i++) {
					if (this._summariesRows[i] === undefined ||
							this._summariesRows[i] === null ||
							data[i] === undefined ||
							data[i] === null) {
						continue;
					}
					result = data[i].result;
					decimalDisplay = data[i].decimalDisplay;
					if (decimalDisplay === undefined || decimalDisplay === null) {
						decimalDisplay = this.defaultDecimalDisplay;
					}
					if (decimalDisplay !== null &&
							decimalDisplay !== undefined &&
							this._isNumber(result) === true) {
						result = (parseFloat(result)).toFixed(decimalDisplay);
					}
					this._renderCell(this._summariesRows[i].type,
						columnKey,
						data[i]);
				}
			} else if (compactRenderingMode === false ||
					(this.options.compactRenderingMode === 'auto' && this._analyzeAutoCompactRenderingMode() === false)) {
				for (i = 0; i < dataLength; i++) {
					methodName = data[i].type.toLowerCase();
					footerRowId = this._id('summaries', 'footer_row', methodName);
					//$footerRow = $('#' + footerRowId);
					// M.H. 21 Aug 2013 Fix for bug #149886: When you unselect a summary of a fixed column and then select it again it doesn't appear.
					$footerRow = this.grid.container().find("#" + footerRowId);
					if ($footerRow.length === 0) {
						order = data[i].order;
						// order footer row
						if (order === undefined) {
							order = null;
						}
						this._addDataResult(columnKey, data[0]);
						this._insertSummariesRows(methodName, order);
					}
					/*
					if (this._isFirstRowEmpty() === true) {
						// remove first row if all cells of the first row are empty
						//$('#' + this._id('summaries', 'footer_row', this._summariesRows[0].type)).remove();
						//this._removeRowsDataByType(this._summariesRows[0].type);
					}
					*/
					// update value(s) for the cell
					this._renderCell(
						methodName,
						columnKey,
						data[i]
					);
				}
			}
		},
		_renderCell: function (methodName, columnKey, data) {
			var resultTemplate = this.options.resultTemplate, column,
				autoFormat = this.grid.options.autoFormat,
				res = data.result, i, format, oRes = res,
				value,
				isToFixFloat = false,
				summaryOperand = data.type,
				rowDisplayLabel = data.rowDisplayLabel,
				isGridFormatter = data.isGridFormatter,
				dataType = data.dataType,
				defaultDecimalDisplay = this.options.defaultDecimalDisplay,
				decimalDisplay = data.decimalDisplay,
				isNumber = this._isNumber(res);
			if (isNumber && dataType === 'bool') {
				isGridFormatter = false;
			}
			// M.H. 27 March 2012 Fix for bug #104054
			if (isNumber === true) {
				// M.H. 9 Dec 2013 Fix for bug #158820: Summaries are not displayed correctly when the french local is used
				if (decimalDisplay === undefined || decimalDisplay === null) {
					if (defaultDecimalDisplay !== null && defaultDecimalDisplay !== undefined) {
						decimalDisplay = defaultDecimalDisplay;
						isToFixFloat = true;
					}
				} else {
					isToFixFloat = true;
				}
				// M.H. 9 Dec 2013 Fix for bug #158504: ColumnFixing combined with MultiColumnHeaders, the main columns can be fixed/unfixed with allowFixing set to false
				res = parseFloat(res);
				// M.H. 16 Dec 2013 Fix for bug #158820: Summaries are not displayed correctly when the french locale is used
				if (isToFixFloat && decimalDisplay >= 0) {
					if (((autoFormat === true || autoFormat === 'dateandnumber') && dataType) ||
							(autoFormat && autoFormat === dataType)) {
						format = '0.';
						for (i = 0; i < decimalDisplay; i++) {
							format += '0';
						}
						// M.H. 16 Dec 2013 Fix for bug #158820: Summaries are not displayed correctly when the french locale is used
						if (summaryOperand === 'count') {
							dataType = 'number';
						} else {
                            // L.A. 03 December 2012 - Fixing bug #128404 Summaries Count value is formatted with currency format
                            isToFixFloat = false;
                        }
						if (decimalDisplay === 0) {
							res = oRes;
						} else {
							res = $.ig.formatter(oRes, dataType, format);
						}
					} else {
						res = res.toFixed(decimalDisplay);
                        if (summaryOperand !== 'count') {
                            isToFixFloat = false;
                        }
					}
				}
			}
			value = res;
			// M.H. 6 Oct. 2011 Fix for bug #90225
			// L.A. 03 December 2012 - Fixing bug #128404 Summaries Count value is formatted with currency format
			// M.H. 21 Feb 2013 Fix for bug #128404: Summaries Count value is formatted with currency format
			// M.H. 10 Dec 2013 Fix for bug #158820: Summaries are not displayed correctly when the french local is used
			// M.H. 16 Dec 2013 Fix for bug #158820: Summaries are not displayed correctly when the french locale is used
			if ((isGridFormatter === true || (isGridFormatter === undefined && this.options.isGridFormatter === true))) {
				column = this._getGridColumnFor(columnKey);
				if (column !== null) {
					// M.H. 14 Oct. 2011 Fix for bug 91175
					if (dataType === 'date' &&
							isNumber &&
							(summaryOperand === 'min' || summaryOperand === 'max')) {
						// M.H. 18 Oct. 2011 Fix for bug 92467
						value = new Date(parseInt(value, 10));
					}
					// M.H. 16 Dec 2013 Fix for bug #158820: Summaries are not displayed correctly when the french locale is used
					if (!isToFixFloat || dataType === 'date') {
						res = this.grid._renderCell(value, column);
					}
					value = res;
				}
			} else if (value === null || value === undefined) {
				value = '';
			} else if (dataType === 'date' &&
					isNumber &&
					(summaryOperand === 'min' || summaryOperand === 'max')) {
				value = new Date(parseInt(value, 10));
			}
			if (resultTemplate) {
				res = resultTemplate.replace('{0}', rowDisplayLabel).replace('{1}', value);
			}
			// M.H. 21 Aug 2013 Fix for bug #149886: When you unselect a summary of a fixed column and then select it again it doesn't appear.
			this.grid.container().find("#" + this._id('summaries', 'footer_row_text_container', methodName, columnKey))
				.html(res);
		},
		_getGridColumnFor: function (columnKey) {
			var i, gridColumnsLength = (this.grid.options.columns) ? this.grid.options.columns.length : 0;
			for (i = 0; i < gridColumnsLength; i++) {
				// M.H. 12 Oct. 2011 Fix for bug #91580
				if (this.grid.options.columns[i].key === columnKey) {
					return this.grid.options.columns[i];
				}
			}
			return null;
		},
		_isNumber: function (n) {
			return !isNaN(parseFloat(n)) && isFinite(n);
		},
		_columnsCollectionModified: function (event, ui) {
			if (ui.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}
			// M.H. 13 Oct. 2011 Fix for bug #91738
			if (this._isSummariesRowsHidden === true) {
				return;
			}
			// M.H. 12 Oct. 2011 Fix for bug #91580 - remove data binding
			this._clearAllRows();
			this.calculateSummaries();
		},
		_insertSummariesRows: function (methodName, order) {
			methodName = methodName.toLowerCase();
			var srLength, i, j,
				srOrder,
				hasFixed = this.grid.hasFixedColumns(),
				css = this.css,
				$grid = this.grid,
				// M.H. 12 Oct. 2011 Fix for bug #91580
				gridColumns = $grid._visibleColumns(),
				gridColumnsLength = gridColumns.length,
				$tfoot = this._tfoot,
				$td, $tfootFixed,
				$footer = $grid._footer,
				footerRowIdFixed,
				$footerRowFixed,
				footerRowId = this._id('summaries', 'footer_row', methodName),
				$footerRow = $('<tr></tr>').attr('id', footerRowId).attr('data-role', 'summaryrow'),
				elem = {id: footerRowId, type: methodName, order: order},
				footerRowCellMousein = function () { $(this).addClass(css.footerRowCellHover); },
				footerRowCellMouseout = function () { $(this).removeClass(css.footerRowCellHover); };
			
			if (hasFixed === true) {
				footerRowIdFixed = this._id('summaries', 'footer_row', methodName, 'fixed');
				$footerRowFixed = $('<tr></tr>').attr('id', footerRowIdFixed).attr('data-role', 'summaryrow');
				$tfootFixed = this.grid.fixedFootersTable().find('tfoot');
			}
			if ($tfoot === null || $tfoot === undefined) {
				if ($footer === undefined || $footer === null || $footer.length === 0) {
					// init $footer
					$grid._renderFooter();
					$footer = $grid._footer;
				}
				if ($footer === undefined || $footer === null || $footer.length === 0) {
					// M.H. 22 March 2012 Fix for bug #105616
					//throw new Error("Footer is not defined in _insertSummariesRows");
					return;
				}
				// M.H. 11 Oct. 2011 Fix for bug #91147
				$footer.css('display', '');
				if (this._isVirtualization() === true) {
					//$tfoot = $('#' + $grid.element[0].id + '_footers').find('tfoot');
					$tfoot = this.grid.footersTable().find('tfoot');
				} else if (this._isFixedFooters() === true) {
					$tfoot = $footer.find('tfoot');
				} else {
					$tfoot = $footer;
				}
				this._tfoot = $tfoot;
			}
			// M.H. 10 Oct. 2011 Fix for bug #89870
			// fix strange behavior - when it is in hierarchical grid and hide column, expand and close first layout
			// then show hidden column and expand again first layout when click to hide summaries it works
			// BUT when again clicks on summaries they are not shown, appendTo is not working
			if ($tfoot.attr('id') !== '' && $tfoot.attr('id') !== null && $tfoot.attr('id') !== undefined) {
				$tfoot = $('#' + $tfoot.attr('id'));
			}
			if (order === null) {
				elem.order = this._summariesRows.length;
				this._summariesRows.push(elem);
				$footerRow.appendTo($tfoot);
				if (hasFixed) {
					$footerRowFixed.appendTo($tfootFixed);
				}
			} else {
				// insert at the correct position
				srLength = this._summariesRows.length;
				if (srLength === 0) {
					this._summariesRows.push(elem);
					$footerRow.appendTo($tfoot);
					if (hasFixed) {
						$footerRowFixed.appendTo($tfootFixed);
					}
				} else {
					if (this.options.compactRenderingMode === true ||
							(this.options.compactRenderingMode === 'auto' &&
								this._analyzeAutoCompactRenderingMode() === true)) {
						$footerRow.appendTo($tfoot);
						if (hasFixed) {
							$footerRowFixed.appendTo($tfootFixed);
						}
						this._summariesRows.push(elem);
					} else if (this.options.compactRenderingMode === false ||
							(this.options.compactRenderingMode === 'auto' &&
								this._analyzeAutoCompactRenderingMode() === false)) {
						for (i = 0; i < srLength; i++) {
							srOrder = this._summariesRows[i].order;
							if (srOrder === undefined || srOrder === null) {
								continue;
							}
							if (order <= srOrder) {
								$footerRow
									.insertBefore($('#' + this._id('summaries', 'footer_row', this._summariesRows[i].type)));
								if (hasFixed) {
									$footerRowFixed
										.insertBefore($('#' + this._id('summaries', 'footer_row', this._summariesRows[i].type, 'fixed')));
								}
								this._summariesRows.splice(i, 0, elem);
								break;
							}
						}
						if (i === srLength) {
							this._summariesRows.push(elem);
							$footerRow.appendTo($tfoot);
							if (hasFixed) {
								$footerRowFixed.appendTo($tfootFixed);
							}
						}
					}
				}
			}
			// M.H. 2 April 2012 Fix for bug #107567
			// M.H. 4 April 2012 Fix for bug #108082
			if (this._isVirtualization() && this.grid.options.virtualizationMode === 'fixed') {
				gridColumnsLength = this.grid._virtualColumnCount;
			}
			for (j = 0; j < gridColumnsLength; j++) {
				$td = $('<td></td>')
					.addClass(css.footerRowCell)
					.attr('data-key', gridColumns[j].key);
				if (gridColumns[j].fixed === true) {
					$td.appendTo($footerRowFixed);
					$('#' + footerRowIdFixed + ' td.ui-state-default').hover(
						footerRowCellMousein,
						footerRowCellMouseout
					);
				} else {
					$td.appendTo($footerRow);
					$('#' + footerRowId + ' td.ui-state-default').hover(
						footerRowCellMousein,
						footerRowCellMouseout
					);
				}
				if (j === gridColumnsLength - 1 && $grid.options.height && parseInt($grid.options.height, 10) > 0) {
					// set last col width explicitly
					$td.css('width', parseInt(gridColumns[j].width, 10) + $grid._scrollbarWidth());
				} else {
					$td.css('width', gridColumns[j].width);
				}
				this._renderInnerCellMarkup($td, methodName, gridColumns[j].key);
				/*
				$textContainer = $('<div></div>')
					.attr('id', this._id('summaries', 'footer_row_text_container', methodName, gridColumns[j].key))
					.addClass(this.css.footerRowTextContainer)
					.appendTo($td)
					.html(this.options.emptyCellText);
				$iconContainer = $('<div></div>')
					.attr('id', this._id('summaries', 'footer_row_icon_container', methodName, gridColumns[j].key))
					.addClass(this.css.footerRowIconContainer)
					.insertBefore($textContainer);
				if ($.ig.util.isIE7 === true) {
					$iconContainer.addClass(this.css.baseClassIE7);
				}
				*/
			}
			// M.H. 23 Aug 2013 Fix for bug #149880: When row selectors are enabled unchecking and checking a summary of a number column makes its Avg summary to render in the next column.
			if (hasFixed && this.grid.hasFixedDataSkippedColumns() &&
				this.grid.element.data("igGridColumnFixing").options.fixingDirection === 'left') {
				this.grid._footerInit($footerRowFixed, null, true, css.footerRowCell);
			} else {
				this.grid._footerInit($footerRow, null, true, css.footerRowCell);
			}
		},
		_renderInnerCellMarkup: function ($td, methodName, columnKey) {
			var $textContainer, $iconContainer;

			$textContainer = $('<div></div>')
				.attr('id', this._id('summaries', 'footer_row_text_container', methodName, columnKey))
				.addClass(this.css.footerRowTextContainer)
				.appendTo($td)
				.html(this.options.emptyCellText);
			$iconContainer = $('<div></div>')
				.attr('id', this._id('summaries', 'footer_row_icon_container', methodName, columnKey))
				.addClass(this.css.footerRowIconContainer)
				.insertBefore($textContainer);
			if ($.ig.util.isIE7 === true) {
				$iconContainer.addClass(this.css.baseClassIE7);
			}
			// M.H. 28 May 2012 Fix for bug #107927
			if (this.options.showDropDownButton === false) {
				$iconContainer.addClass(this.css.footerRowIconContainerEmpty);
				$textContainer.addClass(this.css.footerRowTextContainerEmpty);
			}
		},
		_virtualHorizontalScroll: function (event, args) {
			//prevent handling of other grids' events in the case of hierarchical grid
			/*
			if (args.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}
			*/
			if (this._isRenderedSummariesRows === false) {
				return;
			}
			// get the current col index from args, and reinitialize the header cells 
			var start = args.startColIndex, end = args.endColIndex, i, j, $row, $children, $td,
				sr = this._summariesRows, srLength = sr.length, columnSetting, columnKey,
				// M.H. 12 Oct. 2011 Fix for bug #91580
				cols = this.grid._visibleColumns(), self = this;
			// M.H. 2 April 2012 Fix for bug #107567
			end = start + this.grid._virtualColumnCount;
			if (srLength > 0) {
				$children = sr[0];
				$.each($children, function (index, element) {
					$('#' + self._id('summaries', 'methods_dialog', $(element).attr('data-key'))).remove();
				});
			}
			for (i = 0; i < srLength; i++) {
				$row = $('#' + sr[i].id);
				$children = $row.children();
				$children.html('');

				for (j = start; j <= end; j++) {
					$td = $row.find('td:nth-child(' + (j - start + 1) + ')');
					$td.html('');

					if (cols[j] === null || cols[j] === undefined) {
						continue;
					}
					this._renderInnerCellMarkup($td, sr[i].type, cols[j].key);
				}
			}
			//this._renderFooterIcons(start, end);
			for (i = start; i < end; i++) {
				if (cols[i] !== null && cols[i] !== undefined) {
					columnKey = cols[i].key;
					columnSetting = this._getColumnSettingByKey(columnKey);
					if (columnKey === undefined || columnKey === null) {
						continue;
					}
					this._renderFooterIconMarkup(sr[0].type, columnKey);
					this._renderDropDown(columnKey);

					if (columnSetting === null || columnSetting === undefined) {
						continue;
					}
					this._renderFooterColumnInfo(columnKey, this._data[columnKey]);
				}
			}
			if (this.grid.hasFixedColumns()) {
				this._syncFixedUnfixedRowHeights();
			}
		},
		/* Helper methods */
		_isFixedFooters: function () {
			return (this.grid.options.fixedFooters === true && this.grid.options.height !== null);
		},
		_isVirtualization: function () {
			var gridOptions = this.grid.options;
			// M.H. 2 April 2012 Fix for bug #107566
			return (gridOptions.virtualization === true ||
					(gridOptions.rowVirtualization === true && gridOptions.height !== null) ||
					(gridOptions.columnVirtualization === true && gridOptions.width !== null));
		},
		_id: function () {
			var i, res = this.grid.element[0].id, argumentsLength = arguments.length;

			if (argumentsLength === 0) {
				return null;
			}
			for (i = 0; i < argumentsLength; i++) {
				res += '_' + arguments[i];
			}
			return res;
		},
		_isAllowedMethodName: function (methodName) {
			var defaultMethodName, isAllowed = false, len = this.defaultSummaryMethods.length, i;

			for (i = 0; i < len; i++) {
				defaultMethodName = this.defaultSummaryMethods[i].type;
				if (defaultMethodName === methodName ||
						defaultMethodName === methodName.substr(0, defaultMethodName.length)) {
					isAllowed = true;
					break;
				}
			}
			return isAllowed;
		},
		_footerInit: function (owner, args) {
			//prevent handling of other grids' events in the case of hierarchical grid
			if (args.owner.element.attr("id") !== this.grid.element.attr("id")) {
				return;
			}
			var rows, i;
			// clear all cells from the summary rows that are marked with data-skip=true
			rows = this.grid.footersTable().find("[data-role=summaryrow]");
			//colgroup = this.grid.footersTable().find("colgroup");
			rows.find("[data-skip=true]").remove();
			//colgroup.find("[data-skip=true]").remove();
			for (i = 0; i < rows.length; i++) {
				// M.H. 12 Oct. 2011 Fix for bug #91479
				// M.H. 21 Dec. 2011 Fix for bug #98183
				this.grid._footerInit($(rows[i]), null, true, this.css.footerRowCell);
			}
		},
		_dataSummaries: function () {
			// return data for summaries
			var ds = this.grid.dataSource;
			// M.H. 29 Sept. 2011 Fix for bug #89411
			return ds.dataSummaries();
			/*
			
			if (o.type === 'local' && ds.settings.type === 'remote') {
				// when summaries type is local but datasource type is remote then get Data from Datasource
				// because in dataSummaries method the data is not populated
				data = ds.data();
			} else {
				data = ds.dataSummaries();
			}

			return data;
			*/
		},
		_injectGrid: function (gridInstance, isRebind) {
			this.grid = gridInstance;
			/*
			if (this._headerRenderedHandler !== null) {
				this.grid.element.unbind('iggridheaderrendered', this._headerRenderedHandler);
			}
			*/
			if (this.options.type === null) {
				// infer type
				this.options.type = this.grid._inferOpType();
			}
			// M.H. 28 May 2014 Fix for bug #172200: Memory leak when using the features of the grid
			this._detachEvents();
			this._headerRenderedHandler = $.proxy(this._headerRendered, this);
			this._footerRenderedHandler = $.proxy(this._footerRendered, this);
			this._headerCellRenderedHandler = $.proxy(this._headerCellRendered, this);
			this._headerFooterInitHandler = $.proxy(this._footerInit, this);
			// M.H. 12 Oct. 2011 Fix for bug #91580
			this._columnsCollectionModifiedHandler = $.proxy(this._columnsCollectionModified, this);
			// M.H. 15 Mar 2013 Fix for bug #136429: Updating Values does not fire updating of summary
			this._rowUpdatedHandler = $.proxy(this._rowUpdated, this);

			this.grid.element.bind('iggridheaderrendered', this._headerRenderedHandler);
			this.grid.element.bind('iggridfooterrendered', this._footerRenderedHandler);
			this.grid.element.bind('iggridheadercellrendered', this._headerCellRenderedHandler);
			this.grid.element.bind('iggridheaderextracellsmodified', this._headerFooterInitHandler);
			// M.H. 15 Mar 2013 Fix for bug #136429: Updating Values does not fire updating of summary
			this.grid.element.bind('iggridupdatingeditrowended', this._rowUpdatedHandler);
			this.grid.element.bind('iggridupdatinginternalrowdeleted', this._rowUpdatedHandler);
			// M.H. 12 Oct. 2011 Fix for bug #91580
			this.grid.element.bind('iggridcolumnscollectionmodified', this._columnsCollectionModifiedHandler);
			this._virtualHorizontalScrollHandler = $.proxy(this._virtualHorizontalScroll, this);
			this.grid.element.bind('iggridvirtualhorizontalscroll', this._virtualHorizontalScrollHandler);
			this._initColumnSettings();
			this._setDataSourceColumnSettingsOptions();

			if (this.grid.element.igGridFeatureChooser !== undefined) {
				this.grid.element.igGridFeatureChooser();
			} else {
				throw new Error($.ig.GridSummaries.locale.featureChooserNotReferenced);
			}
		}
	});
	$.extend($.ui.igGridSummaries, {version: '14.1.20141.2249'});
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI Grid Tooltips 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.4.3.js
 *	modernizr.js
 *	infragistics.ui.popover.js
 *	infragistics.ui.grid.framework.js
 */

/*global jQuery, Modernizr */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}
(function ($) {
	/*
		igGridTooltips widget.
		The widget is pluggable to the element where the grid is instantiated and the actual igGrid object doesn't know about this.
		The tooltips widget just attaches its functionality to the grid.
	*/
	"use strict";
	$.widget("ui.igGridTooltips", {
		options: {
			/* type="always|never|overflow" determines the tooltip visibility option 
			always type="string" tooltips always show for hovered elements
			never type="string" tooltips do not show automatically
			overflow type="string" tooltips show only when the underlying data overflows its container 
			*/
			visibility: "overflow",
			/* type="tooltip|popover" controls the tooltip's style 
			tooltip type="string" the tooltip will be positioned according to the mouse cursor
			popover type="string" the tooltip will be positioned according to the target element
			with an arrow pointing the element. this style is more suitable for touch-supported environments.
			*/
			style: "tooltip",
			/* type="integer" The time in milliseconds after which tooltip will show when 
			mouse cursor is hovered over a cell. */
			showDelay: 500,
			/* Type="integer" The time in milliseconds after which tooltip hides when mouse 
			cursor gets outside of the cell. 
			*/
			hideDelay: 300,
			/* a list of custom column settings that specify custom tooltip settings for a specific column (whether tooltips are enabled / disabled) */
			columnSettings: [
				{
					/* type="string" Either key or index must be set in every column setting.*/
					columnKey: null,
					/* type="number" Either key or index must be set in every column setting. */
					columnIndex: -1,
					/* type="bool" Enables / disables tooltips on the specified column. By default tooltips are displayed for each column. Note: This option is mandatory. */
					allowTooltips: true
				}
			],
			/* sets the time tooltip fades in and out when showing/hiding */
			fadeTimespan: 150,
			/* sets the left position of the tooltip relative to the mouse cursor */
			cursorLeftOffset: 10,
			/* sets the top position of the tooltip relative to the mouse cursor */
			cursorTopOffset: 15
		},
		css: {
			/* Classes applied to the tooltip widget */
			"tooltip": "ui-iggrid-tooltip",
			/* Classes applied to the tooltip container */
			"tooltipContent": "ui-iggrid-tooltip-content"
		},
		events: {
			/* cancel="true" event fired when the mouse has hovered on an element long enough to display a tooltip
			use args.owner to get a reference to the widget
			use args.tooltip to get or set the string to be displayed
			use args.value to get the value of the cell the tooltip is displayed for
			use args.element to get a reference to the cell the tooltip is displayed for
			use args.index to get the row index of the cell the tooltip is displayed for
			use args.columnKey to get the column key of the cell the tooltip is displayed for
			use args.columnIndex to get the column index of the cell the tooltip is displayed for
			*/
			tooltipShowing: "tooltipShowing",
			/* event fired after a tooltip is shown
			use args.owner to get a reference to the widget
			use args.tooltip to get the string displayed in the tooltip
			use args.value to get the value of the cell the tooltip is displayed for
			use args.element to get a reference to the cell the tooltip is displayed for
			use args.index to get the row index of the cell the tooltip is displayed for
			use args.columnKey to get the column key of the cell the tooltip is displayed for
			use args.columnIndex to get the column index of the cell the tooltip is displayed for
			*/
			tooltipShown: "tooltipShown",
			/* cancel="true" event fired when the mouse has left an element and the tooltip is about to hide
			use args.owner to get a reference to the widget
			use args.tooltip to get the string displayed in the tooltip
			use args.value to get the value of the cell the tooltip is displayed for
			use args.element to get a reference to the cell the tooltip is displayed for
			use args.index to get the row index of the cell the tooltip is displayed for
			use args.columnKey to get the column key of the cell the tooltip is displayed for
			use args.columnIndex to get the column index of the cell the tooltip is displayed for
			*/
			tooltipHiding: "tooltipHiding",
			/* event fired after a tooltip is hidden
			use args.owner to get a reference to the widget
			use args.tooltip to get the string displayed in the tooltip
			use args.value to get the value of the cell the tooltip was displayed for
			use args.element to get a reference to the cell the tooltip was displayed for
			use args.index to get the row index of the cell the tooltip was displayed for
			use args.columnKey to get the column key of the cell the tooltip was displayed for
			use args.columnIndex to get the column index of the cell the tooltip was displayed for
			*/
			tooltipHidden: "tooltipHidden"
		},
		_createWidget: function (options, element) {
			this.visible = false;
			this._canFadeIn = true;
			this._canFadeOut = true;
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		destroy: function () {
			/* 
				Destroys the tooltip widget.
			*/
			this.grid.element.unbind(".tooltip");
			if (this.tooltip) {
				if (this.tooltip.data("users") === 1) {
				this.tooltip.remove();
				} else {
					this.tooltip.data("users", this.tooltip.data("users") - 1);
					this.tooltip.children("[id$='_content']")
						.unbind("mouseenter." + this.grid.id())
						.unbind("mouseleave." + this.grid.id());
			}
			}
			if (this.ruler) {
				if (this.ruler.data("users") === 1) {
					this.ruler.remove();
				} else {
					this.ruler.data("users", this.ruler.data("users") - 1);
				}
			}
			$.Widget.prototype.destroy.call(this);
			return this;
		},
		id: function () {
			/*  returns the ID of the parent div element bounding the ruler and the tooltip container 
				returnType="string" 
			*/
			return this.tooltip[0].id;
		},
		_injectGrid: function (gridInstance, isRebind) {
			if (isRebind === true) {
				return;
			}
			this.grid = gridInstance;
			this._createHandlers();
			this._unregisterGridEvents();
			this._registerGridEvents();
		},
		_createTooltip: function () {
			var existingTooltip = this.grid._rootContainer().children("[id$='_tooltips']");
			if (existingTooltip.length > 0) {
				this.tooltip = existingTooltip;
				this.tooltip.data("users", this.tooltip.data("users") + 1);
			} else {
			if (this.options.style === "tooltip") {
					this.tooltip = $("<div></div>")
						.attr("id", this.grid.id() + "_tooltips")
						.attr("role", "tooltip")
					.addClass("ui-tooltip")
					.addClass("ui-widget")
					.addClass("ui-corner-all")
					.addClass("ui-widget-content")
					.addClass(this.css.tooltip)
					.css({
							"position": "absolute",
							"display": "none",
							"white-space": "normal",
						// S.S. September 28, 2011 Bug #86596 Long words need to be broken 
							// down so they don"t overlap the container.
							"word-wrap": "break-word"
						});
					// create content container
					$("<div></div>")
						.attr("id", this.id() + "_content")
						.addClass("ui-tooltip-content")
						.addClass(this.css.tooltipContent)
						.appendTo(this.tooltip);
			} else if (this.options.style === "popover") {
					this.tooltip = $("<div><div>")
						.attr("id", this.grid.id() + "_tooltips")
					.igPopover({
						animationDuration: this.options.fadeTimespan
					});
			}
				this.tooltip.data("users", 1);
			}
			// bind content events
			if (this.options.style === "tooltip") {
				this.tooltip.children("[id$='_content']")
					.bind("mouseenter." + this.grid.id(), $.proxy(this._tooltipMouseEnter, this))
					.bind("mouseleave." + this.grid.id(), $.proxy(this._tooltipMouseLeave, this));
			}
			this.tooltip.appendTo(this.grid._rootContainer());
		},
		_createRuler: function () {
			var existingRuler = this.grid._rootContainer().children("[id$='_ruler']");
			if (existingRuler.length > 0) {
				this.ruler = existingRuler;
				this.ruler.data("users", this.ruler.data("users") + 1);
			} else {
				this.ruler = $("<span></span>")
					.attr("id", this.id() + "_ruler")
					.css("display", "none")
					.css("white-space", "normal")
					.css("word-wrap", "break-word")
				.appendTo(this.grid._rootContainer());
				this.ruler.data("users", 1);
			}
		},
		_displayOverflow: function (element) {
			var ruler = this.ruler, textHeightInPixels;
			ruler.text(element.text());
			ruler.css({
				"font-family": element.css("font-family"),
				"font-size": element.css("font-size"),
				"font-size-adjust": element.css("font-size-adjust"),
				"font-stretch": element.css("font-stretch"),
				"font-style": element.css("font-style"),
				"font-variant": element.css("font-variant"),
				"font-weight": element.css("font-weight"),
				"padding-left": element.css("padding-left"),
				"padding-top": element.css("padding-top"),
				"padding-right": element.css("padding-right"),
				"padding-bottom": element.css("padding-bottom")
			});
			ruler.width(element.width());
			textHeightInPixels = ruler.height();
			// if the ruler's height is larger the cell cannot fit it's contents
			if (textHeightInPixels <= element.height()) {
				return false;
			}
			return true;
		},
		_gridHeaderRendering: function (event, ui) {
			if (ui.owner.id() !== this.grid.id()) {
				return;
			}
			this._createTooltip();
			this._createRuler();
		},
		_dataRendered: function (event, ui) {
			var $tbody, $tbodyFixed;
			if (ui !== undefined) {
				if ($(ui.owner.element).attr("id") !== this.grid.id()) {
					return;
				}
			}
			if (!this.tooltip) {
				this._createTooltip();
				this._createRuler();
			}
			$tbody = this.grid.element.children("tbody");
			this._registerMouseEvents($tbody);
			if (this.grid.hasFixedColumns()) {
				$tbodyFixed = this.grid.fixedTable().find('tbody');
				this._registerMouseEvents($tbodyFixed);
			}
			// S.S. September 16, 2011, We should save our thead so we can use it to get column indexes.
			if (this.grid.options.fixedHeaders === true) {
				this._$thead = this.grid.headersTable().find("thead");
			} else {
				this._$thead = this.grid.container().find("#" + this.grid.id() + " thead");
			}
		},
		_rowsRendering: function (evt, args) {
			var tbody;
			if (args.owner.id() !== this.grid.id()) {
				return;
			}
			tbody = this.grid.element.find('tbody');
			tbody.unbind('mouseleave.tooltip');
			tbody.unbind('mousemove.tooltip');
		},
		_rowsRendered: function (event, ui) {
			var $tbody;
			if (ui !== undefined) {
				if ($(ui.owner.element).attr("id") !== this.grid.id()) {
					return;
				}
			}
			$tbody = this.grid.element.children("tbody");
			this._registerMouseEvents($tbody);
		},
		_registerMouseEvents: function (tbody) {
			// S.S. August 9, 2011, Bug #83695, #83697, Binding is done on tbody instead of the whole table.
			// This prevents tooltips to be displayed for filter rows and fixes some issues with column headers.
			tbody.bind('mouseleave.tooltip', this._gridMouseLeaveHandler);
			tbody.bind('mousemove.tooltip', this._gridMouseMoveHandler);
		},
		_gridMouseLeave: function (event, ui) {
			clearTimeout(this.timeoutShowing);
			clearTimeout(this.timeoutHiding);
			// S.S. August 9, 2011 Bug #83691 Hiding should not be called if the tooltip is not visible because
			// it throws an unnecessary tooltipHiding event.
			if (this.tooltip.css('display') !== "none") {
				this._hideTooltip(true);
			}
			this._currentlyHovered = null;
		},
		_gridMouseMove: function (event, ui) {
			var element = $(event.target).closest("td,th"), elementData, hidePrevious = true, shouldShow,
                hasFixedCols = this.grid.hasFixedColumns(), isFixedElement = this.grid._isFixedElement(element);
			// if the parent table isn't the one the widget is initialized for we should return
			// M.H. 7 Mar 2013 Fix for bug #135335: Tooltips throws error for child layouts
			// M.H. 5 Jul 2013 Fix for bug #145825: ToolTip does not display when a column(s) is fixed.
			if ((element.closest("table").attr("id") !== this.grid.id() && !isFixedElement) ||
                    (hasFixedCols && isFixedElement && element.closest("table").attr("id") !== this.grid.id() + '_fixed')) {
				return;
			}
			this.mouseX = event.pageX;
			this.mouseY = event.pageY;
			// if we hover on the same element or the element is unknown we should return
			if (element[0] === this._currentlyHovered || element.length === 0) {
				return;
			}
			elementData = this._getElementValue(element);
			if (elementData === undefined) {
				hidePrevious = true;
			}
			// if we return on an element a tooltip is currently displayed for we should keep this tooltip
			if (element[0] === this._currentlyDisplayed && this.visible === true) {
				hidePrevious = false;
				clearTimeout(this.timeoutHiding);
				return;
			}
			this._currentlyHovered = element[0];
			this._previouslyHoveredData = this._currentlyHoveredData;
			this._currentlyHoveredData = elementData;
			// At this point the widget should clear a previously executed tooltip show timeout.
			clearTimeout(this.timeoutShowing);
			// S.S. September 28, 2011 Bug #88214 If the mouse hovers the delete button (Updating widget)
			// the old tooltip should hide and no new tooltip should be shown.
			shouldShow = this._shouldShowForTarget(element) && elementData !== undefined &&
				elementData !== "" && $(event.target).attr("unselectable") === undefined;
			// Hides the tooltip displayed for the previously hovered item.
			if (this.visible === true && hidePrevious === true) {
				this._hideTooltip(!shouldShow);
			}
			// Checks if a tooltip should be displayed for the currently hovered element based on widget options.
			if (shouldShow === true) {
				this._currentlyDisplayed = this._currentlyHovered;
				this._showTooltip();
			}
		},
		_tooltipMouseEnter: function () {
			if (this.timeoutHiding !== null && this.timeoutHiding !== undefined) {
			clearTimeout(this.timeoutHiding);
			}
		},
		_tooltipMouseLeave: function () {
			this._hideTooltip();
		},
		_getColumnFixingInstance: function () {
			if (!this._columnFixing && this.grid.element.data('igGridColumnFixing')) {
				this._columnFixing = this.grid.element.data('igGridColumnFixing');
			}
			return this._columnFixing;
		},
		_getElementValue: function (element) {
			var col, val, tlog, i, tid, row = element.closest("tr"), vrowidx = -1, key,
				hasFixedCols = this.grid.hasFixedColumns(), hskip = 0, cf;
			if (this.grid.options.virtualization || this.grid.options.columnVirtualization) {
				hskip = this.grid._startColIndex || 0;
			}
			// column fixing integration
			if (hasFixedCols) {
				cf = this._getColumnFixingInstance();
				col = element.index();
				key = cf._getKeyByVisibleIndex(col, this.grid._isFixedElement(element));
				} else {
				if (this._$thead.length > 0) {
					col = element.index() - this._$thead.children(":first").children("th[data-skip='true']").length + hskip;
				} else {
					col = element.index() - element.parent().find("td[data-parent='true'],td[data-skip='true'],th").length + hskip;
				}
			}
			if (col < 0) {
				return val;
			}
			if (!key) {
				key = this.grid._visibleColumns()[col].key;
			}
			this._pRowIdx = this._rowIdx;
			this._rowIdx = element.closest("tbody")
				.children("tr:not([data-container='true'],[data-grouprow='true'])")
				.index(row);
			// if there is row virtualization we need to take care about the starting index
			if (this.grid.options.virtualization || this.grid.options.rowVirtualization) {
				if (this.grid.options.virtualizationMode === "fixed") {
					this._rowIdx += this.grid._startRowIndex;
				} else {
					// for 12.1 onwards if virtualization mode is continuous we no longer have startRowIndex
					vrowidx = parseInt(row.attr("data-row-idx"), 10);
					this._rowIdx = vrowidx || this._rowIdx;
				}
			}
			// attempting to get data from the transaction log
			tlog = this.grid.dataSource.pendingTransactions();
			tid = parseInt(element.parent().attr("data-id"), 10);
			// loop should start from the end to get the latest change first
			for (i = tlog.length - 1; i >= 0; i--) {
				if (tlog[i].type === "deleterow") {
					continue;
				}
				if (tlog[i].type === "cell") {
					// match cell
					if (tlog[i].rowId === tid && tlog[i].col === key) {
						val = tlog[i].value;
						break;
					}
				} else {
					// match row
					if (tlog[i].rowId === tid) {
						val = tlog[i].row[key];
						break;
					}
				}
			}
			// if failed the data should be taken from the data source
			// S.S. October 21, 2011 A cell content can be deleted therefore the transaction log will have null or "" for
			// its value. We should fall back to dataView only if val is still undefined.
			if (val === undefined && this.grid.dataSource.dataView()[this._rowIdx] !== undefined) {
				val = this.grid.dataSource.dataView()[this._rowIdx][key];
			}
			// L.A. 11 September 2012 Fixing bug #120485 The control still converts the hours to the local time zone 
			// even when EnableUTCDates property is set
			if ($.type(val) === "date") {
				if (this.grid.options.enableUTCDates === true) {
					val = $.ig.formatter(val, 'date', 'dateTime', true, this.grid.options.enableUTCDates);
				}
			}
			return val;
		},
		_shouldShowForTarget: function (element) {
			var shouldShow = true, dataIdx, hasFixedColumns = this.grid.hasFixedColumns(), col;
			switch (this.options.visibility) {
				case "always":
					break;
				case "never":
					shouldShow = false;
					break;
				case "overflow":
					shouldShow = this._displayOverflow(element);
					break;
			}
			if (shouldShow === false) {
				return false;
			}
			dataIdx = element.parent().children("td:not([data-parent='true'],[data-skip='true'])").index(element);
			this._pColumnIdx = this._columnIdx;
			// M.H. 15 Feb 2013 Fix for bug #132983
			if (this.grid._isMultiColumnGrid) {
				this._columnIdx = dataIdx;
			} else {
				if (hasFixedColumns && element.closest('[data-fixed-container]').length === 1) {
					this._columnIdx = this.grid.fixedHeadersTable().find("thead th[id]").not("[data-skip='true']").eq(dataIdx).data("columnIndex");
				} else {
					this._columnIdx = this._$thead.find("th[id]").not("[data-skip='true']").eq(dataIdx).data("columnIndex");
				}
			}
			if (this._columnIdx === undefined || this._columnIdx === null) {
				this._columnIdx = dataIdx;
			}
			if (this._columnIdx < 0 || this._columnIdx >= this.grid.options.columns.length) {
				return false;
			}
			this._pColumnKey = this._columnKey;
			// M.H. 20 June 2014 Fix for bug #174010: When the grid has MultiColumn headers and a column is fixed columnKey property of tooltipShowing event is wrong.
			if (hasFixedColumns) {
				col = this.grid._getColumnByTD(element);
				if (col) {
					this._columnKey = col.column.key;
				}
			} else {
				// M.H. 15 Feb 2013 Fix for bug #132983
				if (this.grid._isMultiColumnGrid) {
					this._columnKey = this.grid._visibleColumns()[dataIdx].key;
				} else {
					this._columnKey = this.grid.options.columns[this._columnIdx].key;
				}
			}
			return shouldShow && this._shouldShowForColumn();
		},
		_shouldShowForColumn: function () {
			var i, colSettings = this.options.columnSettings;
			for (i = 0; i < colSettings.length; i++) {
				if (colSettings[i].columnKey === this._columnKey || colSettings[i].columnIndex === this._columnIdx) {
					return colSettings[i].allowTooltips !== undefined ? colSettings[i].allowTooltips : true;
				}
			}
			return true;
		},
		_hideTooltip: function (current) {
			var self = this, args, fn;
			args = {
				owner: this,
				tooltip: current === true ? String(this._currentlyHoveredData) : String(this._previouslyHoveredData),
				value: current === true ? this._currentlyHoveredData : this._previouslyHoveredData,
				element: this._currentlyDisplayed,
				columnKey: current === true ? this._columnKey : this._pColumnKey,
				index: current === true ? this._rowIdx : this._pRowIdx,
				columnIndex: current === true ? this._columnIdx : this._pColumnIdx
			};
			fn = function () {
				var noCancel = self._trigger(self.events.tooltipHiding, self, args);
				if (noCancel === true) {
					self._hideTooltipNoDelay();
					self._trigger(self.events.tooltipHidden, self, args);
				}
			};
			if (typeof Modernizr === "object" && Modernizr.touch === true) {
				fn();
			} else {
				clearTimeout(this.timeoutHiding);
				this.timeoutHiding = setTimeout(fn, this.options.hideDelay);
			}
		},
		_showTooltip: function () {
			var self = this, args, fn;
			args = {
				owner: this,
				tooltip: String(this._currentlyHoveredData),
				value: this._currentlyHoveredData,
				element: this._currentlyDisplayed,
				columnKey: this._columnKey,
				index: this._rowIdx,
				columnIndex: this._columnIdx
			};
			fn = function () {
				var noCancel = self._trigger(self.events.tooltipShowing, self, args);
				if (noCancel === true) {
					self._showTooltipNoDelay(args.tooltip);
					self._trigger(self.events.tooltipShown, self, args);
				}
			};
			if (typeof Modernizr === "object" && Modernizr.touch === true) {
				fn();
			} else {
				this.timeoutShowing = setTimeout(fn, this.options.showDelay);
			}
		},
		_hideTooltipNoDelay: function () {
			if (this.options.style === "tooltip") {
				if (this._canFadeOut === true) {
					this._canFadeOut = false;
					this.tooltip.fadeOut(this.options.fadeTimespan, $.proxy(this._fadeOutEnd, this));
				}
			} else if (this.options.style === "popover") {
				this.tooltip.igPopover("hide");
			}
			this.visible = false;
		},
		_showTooltipNoDelay: function (value) {
			var tooltip;
			if (this._currentlyDisplayed === null) {
				return;
			}
			clearTimeout(this.timeoutHiding);
			tooltip = $("#" + this.id());
			if (this.options.style === "tooltip") {
				this._updateTooltip(value);
				if (this._canFadeIn === true) {
					this._canFadeIn = false;
					tooltip.fadeIn(this.options.fadeTimespan, $.proxy(this._fadeInEnd, this));
				}
			} else if (this.options.style === "popover") {
				tooltip.igPopover("show", $(this._currentlyDisplayed), value);
			}
			this.visible = true;
		},
		_fadeOutEnd: function () {
			this._canFadeOut = true;
		},
		_fadeInEnd: function () {
			this._canFadeIn = true;
		},
		_updateTooltip: function (value) {
			var tooltipContent = this.tooltip.children("[id$='_content']");
			tooltipContent.text(value);
			tooltipContent.parent().css("max-width", $(this._currentlyDisplayed).width());
			this._positionTooltip(tooltipContent.parent());
		},
		_positionTooltip: function (tooltip) {
			var win = $(window), left, top, tfullw = tooltip.outerWidth(), tfullh = tooltip.outerHeight(), toffset;
			toffset = $.ig.util.getRelativeOffset(tooltip);
			left = this.mouseX - toffset.left + this.options.cursorLeftOffset - win.scrollLeft();
			top = this.mouseY - toffset.top + this.options.cursorTopOffset - win.scrollTop();
			// repositions the tooltip if it would otherwise overflow the browser window to the right
			if (left + tfullw > win.width()) {
				left = win.width() - tfullw;
			}
			// repositions the tooltip if it would otherwise overflow the browser window to the bottom
			if (top + tfullh > win.height()) {
				top = win.height() - tfullh;
			}
			tooltip.css({
				"top": top + win.scrollTop(),
				"left": left + win.scrollLeft()
			});
		},
		_columnFixed: function (args) {
			// the method is called when some column is fixed/unfixed
			var $tbodyFixed;
			if (this.grid.hasFixedColumns()) {
				$tbodyFixed = this.grid.fixedTable().find('tbody');
				this._registerMouseEvents($tbodyFixed);
			}
		},
		_createHandlers: function () {
			this._dataRenderedHandler = $.proxy(this._dataRendered, this);
			this._rowsRenderedHandler = $.proxy(this._rowsRendered, this);
			this._rowsRenderingHandler = $.proxy(this._rowsRendering, this);
			this._gridMouseLeaveHandler = $.proxy(this._gridMouseLeave, this);
			this._gridMouseMoveHandler = $.proxy(this._gridMouseMove, this);
			this._gridHeaderRenderingHandler = $.proxy(this._gridHeaderRendering, this);
		},
		_registerGridEvents: function () {
			this.grid.element.bind('iggrid_rowsrendering.tooltip', this._rowsRenderingHandler);
			// S.S. August 9, 2011, Bug #83695, #83697, Binding is done on tbody instead of the whole table.
			// This prevents tooltips to be displayed for filter rows and fixes some issues with column headers.
			this.grid.element.bind('iggridrendered.tooltip', this._dataRenderedHandler);
			// Updating rerenders only the rows but dom is changed regardless and dom events need to be rebound.
			this.grid.element.bind('iggridrowsrendered.tooltip', this._rowsRenderedHandler);
			this.grid.element.bind('iggridheaderrendering.tooltip', this._gridHeaderRenderingHandler);
		},
		_unregisterGridEvents: function () {
			this.grid.element.unbind('iggrid_rowsrendering.tooltip', this._rowsRenderingHandler);
			this.grid.element.unbind('iggridrendered.tooltip', this._dataRenderedHandler);
			this.grid.element.unbind('iggridrowsrendered.tooltip', this._rowsRenderedHandler);
			this.grid.element.unbind('iggridheaderrendering.tooltip', this._gridHeaderRenderingHandler);
		}
	});
	$.extend($.ui.igGridTooltips, { version: '14.1.20141.2249' });
}(jQuery));

/*!@license
* Infragistics.Web.ClientUI Grid Editing 14.1.20141.2249
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends on:
* jquery-1.4.4.js
* jquery.ui.core.js
* jquery.ui.widget.js
* infragistics.ui.grid.framework.js
* infragistics.ui.editors.js
* infragistics.ui.validator.js
* infragistics.ui.combo.js
* infragistics.ui.rating.js
* infragistics.ui.shared.js
* infragistics.dataSource.js
* infragistics.util.js
*/

/*global jQuery, window, document, setTimeout, Class, Modernizr */
(function ($) {
	var _aNull = function (v, nan) {
		// get around bug in new versions of jquery.attr, which may return "undefined" instead of undefined
		return v === null || v === undefined || v === "undefined" || (nan && isNaN(v));
	}, _int = function (e, val) {
		val = e ? e.css(val) : 0;
		try {
			val = parseInt(val, 10);
		} catch (ignore) { }
		return (val && !isNaN(val)) ? val : 0;
	}, _filter = function (elem, name, p1, p2) {
		elem = elem.data('igEditorFilter');
		return elem ? elem.options.provider[name](p1, p2) : null;
	}, _now = function () {
		return new Date().getTime();
	}, _throw = function (def) {
		var str = $.ig.GridUpdating && $.ig.GridUpdating.locale ? $.ig.GridUpdating.locale[def] : def;
		throw new Error(str || def);
	}, _stop = function (e) {
		if (e && e !== 1) {
			try {
				e.preventDefault();
				e.stopPropagation();
			} catch (ignore) { }
		}
	};
	/*
	igGridUpdating is a widget based on jQuery UI that provides support for functionality related to data updates of igGrid.
	That implements following features:
	- row or cell editing
	- row deleting
	- adding new row
	*/
	$.widget('ui.igGridUpdating', {
		grid: null,
		options: {
			/* type="array" Sets gets array of settings for each column. */
			columnSettings: [{
				/* type="string" Sets gets identifier for column. That value should correspond to the "key" of a column in the "columns" of igGrid. */
				columnKey: null,
				/* type="text|0|mask|1|date|2|datepicker|3|numeric|4|currency|5|percent|6|combo|rating" Sets type of editor.
				Note: the css and js files used by ui.igEditor should be available.
				text type="string" the igEditor with type text is created
				0 type="number" the igEditor with type text is created (same as 'text')
				mask type="string" the igEditor with type mask is created
				1 type="number" the igEditor with type mask is created (same as 'mask')
				date type="string" the igEditor with type date editor is created
				2 type="number" the igEditor with type date editor is created (same as 'date')
				datepicker type="string" the igEditor with type datepicker is created. Note: the css and js files used by jquery.ui.datepicker should be available.
				3 type="number" the igEditor with type datepicker is created (same as 'datepicker')
				numeric type="string" the igEditor with type numeric is created
				4 type="number" the igEditor with type numeric is created (same as 'numeric')
				currency type="string" the igEditor with type currency is created
				5 type="number" the igEditor with type currency is created (same as 'currency')
				percent type="string" the igEditor with type percent is created
				6 type="number" the igEditor with type percent is created (same as 'percent')
				combo type="string" the igCombo editor is created. Note: the css and js files used by ui.igCombo should be available.
				rating type="string" the igRating editor is created. Note: the css and js files used by ui.igRating should be available.
				*/
				editorType: null,
				/* type="object" Sets gets custom editor provider. It should extend $.ig.EditorProviderDefault or it should have definitions of all its methods. */
				editorProvider: null,
				/* type="object" Sets gets options supported by corresponding editor such as igEditor, igCombo, or custom editor defined by editorProvider option.
					In addition to specific editor options, it may contain the member "id", which will be set to the element of editor.
					That "id" can be usefull to link cascading igCombo editors.
				*/
				editorOptions: null,
				/* type="bool" Sets gets validation for required entry. */
				required: null,
				/* type="bool" Sets gets read only. If option is enabled, then editor is not used and cells in column are excluded from editing. */
				readOnly: null,
				/* type="bool" Enables disables validation of editor value.
				Value true: enable validation according to rules of igEditor.
				In case of numeric editors, the validation occurs for min/maxValue including range of values for dataMode, illegal number like "." or "-".
				In case of date editors, the validation occurs for min/maxValue and missing fields in "dateInputFormat".
				In case of mask editors, the validation occurs for not filled required positions in inputMask.
				If "editorOptions" enables "required", then validation for all types of editor has effect.
				Value false: do not enable validation. */
				validation: null,
				/* type="object" Sets gets default value in cell for add-new-row. That can be string, number, Date or boolean. */
				defaultValue: null
			}],
			/* type="row|cell|rowedittemplate|none|null" Sets gets edit mode.
			row type="string" editors in all cells in a row are displayed. Editor under clicked cell should get input focus. Optional Done/Cancel buttons can be displayed.
			cell type="string" editor only for clicked cell is displayed. The Done/Cancel buttons are not supported.
			rowedittemplate type="string" editor for all cells will be rendered as popup dialog
			none type="string" editing of grid-cells is disabled
			null type="object" editing of grid-cells is disabled
			*/
			editMode: 'row', //'cell', 'none', null
			/* 
			type="bool" Used in row edit template when editing is disabled for a particular column
			Value true: disabled columns are rendered as disabled
			Value false: disabled columns are not rendered in the editors
			*/
			showReadonlyEditors: true,
			/* type="bool" Sets gets delete-row functionality.
			Value true: the "Delete" button is displayed on mouse-over a row and all selected rows are deleted by Delete-key.
			Value false: delete-row is disabled.
			*/
			enableDeleteRow: true,
			/* type="bool" Sets gets add-new-row functionality.
			Notes: If igGrid has primaryKey, then application should process generatePrimaryKeyValue event and provide value for a cell.
			It is also recommended to set readOnly:true for the column (within columnSettings) with the primaryKey or to use editorOptions:{readOnly:true}.
			By default the value of a cell with primary key is generated automatically and its value is equal to number of rows in grid plus 1.
			Value true: the "Add Row" button is displayed on header, click on that button shows editors in all columns and new row inserted at the end of editing.
			Value false: add-row functionality is disabled.
			*/
			enableAddRow: true,
			/* type="bool" Sets gets option to enable validation for all columns. */
			validation: false,
			/* type="string" Sets gets text for Done editing button. If that is not set, then $.ig.GridUpdating.locale.doneLabel is used. */
			doneLabel: null,
			/* type="string" Sets gets text for title of Done editing button. If that is not set, then $.ig.GridUpdating.locale.doneTooltip is used. */
			doneTooltip: null,
			/* type="string" Sets gets text for Cancel editing button. If that is not set, then $.ig.GridUpdating.locale.cancelLabel is used. */
			cancelLabel: null,
			/* type="string" Sets gets text for title of Cancel editing button. If that is not set, then $.ig.GridUpdating.locale.cancelTooltip is used. */
			cancelTooltip: null,
			/* type="string" Sets gets text for add-new-row button. If that is not set, then $.ig.GridUpdating.locale.addRowLabel is used. */
			addRowLabel: null,
			/* type="string" Sets gets text for title of add-new-row button. If that is not set, then $.ig.GridUpdating.locale.addRowTooltip is used. */
			addRowTooltip: null,
			/* type="string" Sets gets text for Delete row button. If that is not set, then $.ig.GridUpdating.locale.deleteRowLabel is used. */
			deleteRowLabel: null,
			/* type="string" Sets gets text for title of Delete row button. If that is not set, then $.ig.GridUpdating.locale.deleteRowTooltip is used. */
			deleteRowTooltip: null,
			/* type="string" Sets gets text for caption of the rowEditDialog. If that is not set, then $.ig.GridUpdating.locale.rowEditDialogCaptionLabel is used. */
			rowEditDialogCaptionLabel: null,
			/* type="bool" Sets gets visibility of the end-edit pop-up dialog with Done/Cancel buttons. */
			showDoneCancelButtons: true,
			/* type="bool" Sets gets ability to enable or disable exception, which is raised when grid has pending transaction and may fail to render data correctly. */
			enableDataDirtyException: true,
			/* type="string|number" the height of the row edit dialog content 
				string The dialog content height in pixels (150px).
				number The dialog content height as a number (150).
			*/
			rowEditDialogContentHeight: 150,
			/* type="number" width of the row edit dialog fields
				number The width as a number (0)
			*/
			rowEditDialogFieldWidth: 140,
			/* type="string|number" default row edit dialog width
				string The dialog window width in pixels (370px).
				number The dialog window width as a number (370).
			*/
			rowEditDialogWidth: 370,
			/* type="string|number" default row edit dialog height
				string The dialog window height in pixels (350px).
				number The dialog window height as a number (350).
			*/
			rowEditDialogHeight: '350',
			/* type="string" Sets gets triggers for start edit mode.
			Possible values: "click", "dblclick", "F2", "enter" and their combinations separated by coma.
			Notes:
			The array of strings similar to ['dblclick', 'f2'] is also supported.
			The keyboard triggers have effect only when "Selection" feature of grid is enabled.
			If the 'dblclick' is included, then 'click' has no effect.
			*/
			startEditTriggers: 'click,F2,enter',
			/* type="string" Controls containment behavior. 
				owner type="string" The row edit dialog will be draggable only in the grid area
				window type="string" The row edit dialog will be draggable in the whole window area
			*/
			rowEditDialogContainment: "owner",
			/* type="string|number" Width of the Ok and Cancel buttons in the row edit dialogs 
				string The advanced row edit dialog Ok and Cancel buttons width in pixels (100px).
				number The advanced row edit dialog Ok and Cancel buttons width as a number (100).
			*/
			rowEditDialogOkCancelButtonWidth: 120,
			/* type="string" Custom template for rows in row edit dialog
				The default template is "<tr><td>${headerText}</td><td data-key='${dataKey}'><input /></td></tr>"
			*/
			rowEditDialogRowTemplate: null,
			/* type="string" ID to x-jquery-tmpl template. If both rowEditDialogRowTemplate and rowEditDialogRowTemplateID are
				specified, then rowEditDialogRowTemplateID will be used */
			rowEditDialogRowTemplateID: null,
			/* type="bool" Enables horizontal move to the right on Enter while editing a cell.
			Value true: Pressing Enter will move the focus to the next edited cell on the right
			Value false: Pressing Enter will move the focus to the next edited cell on the row below
			*/
			horizontalMoveOnEnter: false,
			/* type="bool" Enables excel navigating style while editing a cell
			Value true: Arrows will not navigate inside the edited cell, but will exit the edit mode
			and move the focus to the nearest cell.
			Value false: Arrows will navigate the cursor inside the edited cell
			*/
			excelNavigationMode: false,
			/* type="function|string" Specifies a custom function to be called when AJAX request to the updateUrl option succeeds. Receives as argument the data returned by the server */
			saveChangesSuccessHandler: null,
			/* type="function|string" Specifies a custom function to be called when AJAX request to the updateUrl option fails. Receives three arguments - the jqXHR, string describing the type of error and an optional exception object */
			saveChangesErrorHandler: null,
			/* type="string|number" The swipe distance when on touch to trigger row delete button to appear. */
			swipeDistance: "100px"
		},
		events: {
			/* cancel="true" Event which is raised before start row editing.
			Return false in order to cancel editing and do not show editors in row.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.rowID to get key or index of row.
			Use ui.rowAdding to check if that event is raised while new-row-adding.
			*/
			editRowStarting: null,
			/* Event which is raised after start row editing.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.rowID to get key or index of row.
			Use ui.rowAdding to check if that event is raised while new-row-adding.
			*/
			editRowStarted: null,
			/* cancel="true" Event which is raised before end row editing.
			Return false in order to cancel update of data source.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.rowID to get key or index of row.
			Use ui.keepEditing=true in order to keep editing. It has effect only when evt.originalEvent is defined.
			Use ui.update to check if value of any cell was modified and data source will be updated.
			Use ui.rowAdding to check if that event is raised while new-row-adding.
			Use ui.values[key] to get value of cell in column with the key. That is available only when ui.update is true.
			Use ui.oldValues[key] to get old value of cell in column with the key. That is available only when ui.update is true.
			*/
			editRowEnding: null,
			/* Event which is raised after end row editing.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.rowID to get key or index of row.
			Use ui.update to check if value of any cell was modified and data source will be updated.
			Use ui.rowAdding to check if that event is raised while new-row-adding.
			Use ui.values[key] to get value of cell in column with the key. That is available only when ui.update is true.
			Use ui.oldValues[key] to get old value of cell in column with the key. That is available only when ui.update is true.
			*/
			editRowEnded: null,
			/* cancel="true" Event which is raised before start cell editing.
			Return false in order to cancel start editing and do not show editors.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.rowID to get key or index of row.
			Use ui.columnIndex to get index of column.
			Use ui.columnKey to get key of column.
			Use ui.editor to get reference to igEditor.
			Use ui.value to get or set value of editor.
			Use ui.rowAdding to check if that event is raised while new-row-adding.
			*/
			editCellStarting: null,
			/* Event which is raised after start cell editing.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.rowID to get key or index of row.
			Use ui.columnIndex to get index of column.
			Use ui.columnKey to get key of column.
			Use ui.editor to get reference to igEditor.
			Use ui.value to get value of editor.
			Use ui.rowAdding to check if that event is raised while new-row-adding.
			*/
			editCellStarted: null,
			/* cancel="true" Event which is raised before end cell editing.
			Return false in order to cancel update of data source.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.rowID to get key or index of row.
			Use ui.columnIndex to get index of column.
			Use ui.columnKey to get key of column.
			Use ui.keepEditing=true in order to keep editing. It has effect only when evt.originalEvent is defined and only when editMode is "cell".
			Use ui.editor to get reference to igEditor.
			Use ui.value to get value of cell/editor. That value can be modified and it will be used to update data source.
			Use ui.oldValue to get old value.
			Use ui.update to check if value was modified and data source will be updated.
			Use ui.rowAdding to check if that event is raised while new-row-adding.
			*/
			editCellEnding: null,
			/* Event which is raised after end cell editing.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.rowID to get key or index of row.
			Use ui.columnIndex to get index of column.
			Use ui.columnKey to get key of column.
			Use ui.editor to get reference to igEditor.
			Use ui.value to get value of cell.
			Use ui.oldValue to get old value.
			Use ui.update to check if cell was modified and data source will be updated.
			Use ui.rowAdding to check if that event is raised while new-row-adding.
			*/
			editCellEnded: null,
			/* cancel="true" Event which is raised before adding new row.
			Return false in order to cancel adding new row to data source.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.values[key] to get new value of cell in column with the key.
			Use ui.oldValues[key] to get default value (before editing) of cell in column with the key.
			*/
			rowAdding: null,
			/* Event which is raised after adding new row.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.values[key] to get new value of cell in column with the key.
			Use ui.oldValues[key] to get default value (before editing) of cell in column with the key.
			*/
			rowAdded: null,
			/* cancel="true" Event which is raised before row deleting.
			Return false in order to cancel.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.element to get reference to jquery object which represents TR of row to delete.
			Use ui.rowID to get key or index of row to delete.
			*/
			rowDeleting: null,
			/* Event which is raised after row deleting.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.element to get reference to jquery object which represents TR of row to delete.
			Use ui.rowID to get key or index of row to delete.
			*/
			rowDeleted: null,
			/* cancel="true" Event which is raised when autoCommit of grid is not enabled and grid has pending transaction which may fail to be correctly rendered.
			Application should process that event and it may trigger commit of grid.
			Return false in order to prevent exception.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			*/
			dataDirty: null,
			/* cancel="false" Event which is raised before adding new row to get value of cell for primaryKey column.
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.owner.grid to get reference to igGrid.
			Use ui.value to set unique record-key-identifier for new row. It is prefilled with suggested value (defaultValue of column or number of rows in data source)
			*/
			generatePrimaryKeyValue: null,
			/* cancel="false" Event fired before the row edit dialog is opened. 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.dialogElement to get reference to row edit dialog DOM element.
			*/
			rowEditDialogOpening: null,
			/* cancel="false" Event fired after the row edit dialog is opened. 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.dialogElement to get reference to row edit dialog DOM element.
			*/
			rowEditDialogOpened: null,
			/* cancel="false" Event fired before the contents of the row edit dialog are rendered. 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.dialogElement to get reference to row edit dialog DOM element.
			*/
			rowEditDialogContentsRendering: null,
			/* cancel="false" Event fired after the contents of the row edit dialog are rendered. 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.dialogElement to get reference to row edit dialog DOM element.
			*/
			rowEditDialogContentsRendered: null,
			/* cancel="false" Event fired before the row edit dialog is closed. 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.dialogElement to get reference to row edit dialog DOM element.
			*/
			rowEditDialogClosing: null,
			/* cancel="false" Event fired after the row edit dialog is closed. 
			Function takes arguments evt and ui.
			Use ui.owner to get reference to igGridUpdating.
			Use ui.dialogElement to get reference to row edit dialog DOM element.
			*/
			rowEditDialogClosed: null
		},
		css: {
			/* Classes applied to the container of Done and Cancel editing buttons. Default value is 'ui-iggrid-buttoncontainer ui-widget-content' */
			buttonContainer: 'ui-iggrid-buttoncontainer ui-widget-content ui-corner-all',
			/* Classes applied to the buttons. Default value is 'ui-iggrid-button ui-state-default' */
			button: 'ui-iggrid-button ui-state-default ui-corner-all',
			/* Classes applied to the Done button. Default value is 'ui-iggrid-donebutton ui-priority-primary' */
			doneButton: 'ui-iggrid-donebutton ui-priority-primary ui-corner-all',
			/* Class applied to the Cancel button. Default value is 'ui-iggrid-cancelbutton' */
			cancelButton: 'ui-iggrid-cancelbutton ui-corner-all',
			/* Classes applied to the Delete button. Default value is 'ui-iggrid-deletebutton ui-state-default' */
			deleteButton: 'ui-iggrid-deletebutton ui-state-default ui-corner-all',
			/* Classes applied to buttons in mouse-over state. Default value is 'ui-iggrid-buttonhover ui-state-hover' */
			buttonHover: 'ui-iggrid-buttonhover ui-state-hover',
			/* Classes applied to buttons in disabled state. Default value is 'ui-iggrid-buttondisabled ui-state-disabled' */
			buttonDisabled: 'ui-iggrid-buttondisabled ui-state-disabled',
			/* Classes applied to buttons in active/focus state. Default value is 'ui-iggrid-buttonactive ui-state-active' */
			buttonActive: 'ui-iggrid-buttonactive ui-state-active',
			/* Classes applied to the icon on Done button. Default value is 'ui-iggrid-doneicon ui-icon ui-icon-check' */
			doneIcon: 'ui-iggrid-doneicon ui-icon ui-icon-check',
			/* Classes applied to the icon on Done button. Default value is 'ui-iggrid-cancelicon ui-icon ui-icon-cancel' */
			cancelIcon: 'ui-iggrid-cancelicon ui-icon ui-icon-cancel',
			/* Class applied to Done and Cangel buttons when they have no text. Default value is 'ui-iggrid-button-icon-only' */
			buttonIconOnly: 'ui-iggrid-button-icon-only',
			/* Classes applied to the editing cells. Default value is 'ui-iggrid-editingcell' */
			editingCell: 'ui-iggrid-editingcell',
			/* Classes applied to the add-new-row button. Default value is 'ui-iggrid-addrow ui-widget-header' */
			addRow: 'ui-iggrid-addrow ui-widget-header',
			/* Classes applied to the add-new-row button in mouse-over state. Default value is 'ui-iggrid-addrowhover ui-state-hover' */
			addRowHover: 'ui-iggrid-addrowhover ui-state-hover',
			/* Classes applied to the add-new-row button in active/focus state. Default value is 'ui-iggrid-addrowactive ui-state-active' */
			addRowActive: 'ui-iggrid-addrowactive ui-state-active',
			/* Classes applied to the icon on add-new-row button. Default value is 'ui-iggrid-addrowicon ui-icon ui-icon-circle-plus' */
			addRowIcon: 'ui-iggrid-addrowicon ui-icon ui-icon-circle-plus',
			/* Classes applied to the icon on Delete button. Default value is 'ui-iggrid-deleteicon ui-icon ui-icon-circle-close' */
			deleteIcon: 'ui-iggrid-deleteicon ui-icon ui-icon-circle-close',
			/* Class applied to editors. Default value is 'ui-iggrid-editor' */
			editor: 'ui-iggrid-editor',
			/* Class applied to editors.  */
			rowEditDialogHeaderCaption: "ui-dialog-titlebar ui-iggrid-filterdialogcaption ui-widget-header ui-corner-all ui-helper-reset ui-helper-clearfix",
			/* Class applied to editors.  */
			rowEditDialogHeaderCaptionTitle: "ui-dialog-title",
			/* Classes applied to the row edit dialog element */
			"rowEditDialog": "ui-dialog ui-draggable ui-resizable ui-iggrid-dialog ui-widget ui-widget-content ui-corner-all",
			/* Classes applied to the filtering block area, when the advanced row edit dialog is opened and the area behind it is grayed out (that's the block area) */
			"blockArea": "ui-widget-overlay ui-iggrid-blockarea",
			/* Classes applied to the row edit dialog OK and Cancel buttons. */
			"rowEditDialogOkCancelButton": "ui-dialog-buttonpane ui-widget-content ui-helper-clearfix ui-iggrid-filterdialogokcancelbuttoncontainer",
			/* Classes applied to the row edit dialog table */
			"rowEditDialogTable": "ui-iggrid-filtertable ui-helper-reset"
		},
		setCellValue: function (rowId, colKey, value, tr) {
			/* Sets a cell value for the specified cell. It also creates a transaction and updates the UI. Functionality depends on autoCommit option of igGrid.
			If the specified cell is currently in edit mode, the function will set the desired value in the cell's editor instead.
			paramType="object" identifier of row such as value at primaryKey-column of igGrid or if it is not used, then index or row within dataSource of grid
			paramType="string" column key
			paramType="object" the new cell value
			paramType="dom" optional="true" reference to the TR-row where TD-cell is located
			*/
			var $tr, $td, tdi;
			if (!_aNull(rowId) && typeof colKey === 'string') {
				$tr = tr ? $(tr) : this.grid.element.children('tbody').children('tr[data-id="' + rowId + '"]');
				if ($tr.length !== 1) {
					$tr = 1;
					$td = $();
				} else {
					tdi = this.grid._getCellIndexByColumnKey(colKey);
					$td = tdi >= 0 ? $tr.children().eq(tdi) : $();
					$tr = $tr[0];
				}
				if (this.isEditing() && this._tds[colKey] && 
					$td.find(".ui-igedit,.ui-igcombo").length > 0 && this.editorForKey(colKey) instanceof jQuery) {
					if (this.editorForKey(colKey).data().hasOwnProperty("igCombo")) {
						this.editorForKey(colKey).igCombo("value", value);
					} else {
						this.editorForKey(colKey).igEditor("value", value);
					}
					this._notifyChanged();
				} else {
					this._update(rowId, $tr, value, colKey, $td);
				}
			}
		},
		updateRow: function (rowId, values, tr) {
			/* Set values for all cells in a row. It also creates a transaction and updates the UI. Functionality depends on autoCommit option of igGrid.
			If the specified row is currently in edit mode, the function will set the desired values in the row's editors instead.
			paramType="object" identifier of row such as value at primaryKey-column of igGrid or if it is not used, then index or row within dataSource of grid
			paramType="object" pairs of values in the format { column1Key: value1, column2Key: value2, ... }
			paramType="dom" optional="true" reference to the TR element which represents row
			*/
			var key;
			if (!_aNull(rowId) && values) {
				tr = tr || this.grid.element.children('tbody').children('tr[data-id="' + rowId + '"]')[0] || 1;
				if (this.isEditing() && $(tr).find(".ui-igedit,.ui-igcombo").length > 0) {
					for (key in values) {
						if (values.hasOwnProperty(key) && this.editorForKey(key) instanceof jQuery) {
							if (this.editorForKey(key).data().hasOwnProperty("igCombo")) {
								this.editorForKey(key).igCombo("value", values[key]);
							} else {
								this.editorForKey(key).igEditor("value", values[key]);
							}
						}
					}
					this._notifyChanged();
				} else {
					this._update(rowId, tr, values);
				}
			}
		},
		addRow: function (values) {
			/* Adds a new row to the grid. It also creates a transaction and updates the UI. Functionality depends on autoCommit option of igGrid.
			paramType="object" pairs of values in the format { column1Key: value1, column2Key: value2, ... }
			*/
			values = values || {};
			var cols = this.options.columnSettings,
				i = cols ? cols.length : 0,
				key, val;
			while (i-- > 0) {
				key = cols[i].columnKey;
				val = cols[i].defaultValue;
				if (!_aNull(val) && !_aNull(key)) {
					if (_aNull(values[key])) {
							values[key] = val;
					}
				}
			}
			this._update(values);
		},
		deleteRow: function (rowId, tr) {
			/* Deletes a row from the grid. It also creates a transaction and updates the UI. Functionality depends on autoCommit option of igGrid.
			paramType="object" value of the primary key column of the igGrid.
			paramType="dom" optional="true" reference to the TR element which represents row
			*/
			if (!_aNull(rowId)) {
				tr = tr || this.grid.element.children('tbody').children('tr[data-id="' + rowId + '"]')[0] || 1;
				if (this.isEditing() && $(tr).find(".ui-igedit,.ui-igcombo").length > 0) {
					this.endEdit(false);
				}
				this._update(rowId, tr);
			}
		},
		startEdit: function (row, col, e) {
			/* Start editing for the row or cell specified.
			paramType="number|string" The row id.
			paramType="number|string" The column key or index.
			paramType="object" optional="true" Browser event. If it is defined, then events are raised.
			returnType="bool" Returns true in case of success or current editing is continued.
			*/
			var colIdx, td, tr = this.grid.element.find("tr[data-id='" + row + "']");
			if (this.options.editMode === "rowedittemplate") {
				return this._startEditRowTemplate(e, tr);
			}
			if ($.type(col) === "string") {
				colIdx = this.grid._getCellIndexByColumnKey(col);
			} else {
				colIdx = col || 0;
			}
			if (colIdx === undefined) {
				throw new Error($.ig.Grid.locale.columnNotFound + " " + col);
			}
			if (this.grid.isFixedColumn(col)) {
				tr = this.grid.fixedBodyContainer().find("tbody").children("tr[data-id='" + row + "']");
			}
			td = tr.children("td").not("[data-skip='true']").eq(colIdx);
			if (td && td.length === 1) {
				td = this._startEdit(td, e || 1, 1) === 1;
			}
			return !!td;
		},
		startAddRowEdit: function (e) {
			/* Start row editing.
			paramType="object" optional="true" Browser event. If it is defined, then events are raised.
			returnType="bool" Returns true in case of success or current editing is continued.
			*/
			var tr = this._newTR, h,
                hasFixedColumns = this.grid.hasFixedColumns();
			if (this.options.editMode === 'rowedittemplate') {
				return this._startEditRowTemplate(e, null, null, true);
			}
			if (tr) {
                if (e && e.target && hasFixedColumns) {
                    if (this.grid._isFixedElement($(e.target))) {
                        tr = $(e.target).closest('thead').find('tr[data-new-row]');
                    }
                }
				tr = this._startEdit($(tr.children()[0]), e || 1, 1, 1, this._addTR.children()[0].offsetHeight) === 1;
                if (this._newTR && hasFixedColumns) {
                    // M.H. 3 Sep 2013 Fix for bug #146403: [Updating]The editors row looks cut off when there is fixed column and there is vertical scrollbar.
                    // M.H. 16 Sep 2013 Fix for bug #146403: [Updating]The editors row looks cut off when there is fixed column and there is vertical scrollbar.
                    if ($.ig.util.isIE) {
                        h = this._addTR.outerHeight();
                    } else {
                        h = this._addTR.height();
			}
                    this.grid.fixedContainer().find('thead tr[data-new-row]')
                        .height(h);
                    this.grid.container().find('thead tr[data-new-row]')
                        .height(h);
                    $(tr).height(h);
			}
			}
			return !!tr;
		},
		endEdit: function (update, e) {
			/* End row editing.
			paramType="bool" optional="true" Request to update grid with new values.
			paramType="object" optional="true" Browser event. If it is defined, then events are raised.
			returnType="bool" Returns false if request failed and editing is continued.
			*/
			if (this.options.editMode === 'rowedittemplate') {
				return update ? this._rowEditDialogDoUpdate(e) : this._closeRowEditDialog(e);
			}
			return !this._endEdit(e || 1, update);
		},
		findInvalid: function () {
			/* Find column-key which editor has invalid value.
			returnType="string|number" Return null or key of column which editor has invalid value and validation of column is enabled.
			*/
			var key, all = this._editors;
			for (key in all) {
				if (all.hasOwnProperty(key) && all[key] && !_filter(all[key], 'isValid')) {
					return key;
				}
			}
			return null;
		},
		isEditing: function () {
			/* Check if editing is on.
			returnType="bool" Returns true if editing is on.
			*/
			return !!this._tds;
		},
		editorForKey: function (key) {
			/* Find editor for a column with key. That method can be used only after editor was already created.
			paramType="object" Key of column. That can be string or number depending on structure of data in dataSource of grid.
			returnType="object" Returns reference to igEditor or null.
			*/
			var e = this._editors;
			return e ? e[key] : null;
		},
		editorForCell: function (td, add) {
			/* Find or create editor which is used for a cell in igGrid.
			paramType="$" Reference to jquery TD object in igGrid.
			paramType="bool" optional="true" Request to create editor. That parameter was designed for internal use and first td parameter must contain valid cell in grid.
			returnType="object" Returns reference to igEditor or null.
			*/
			var e, key = this._key(td), edits = this._editors;
			if (!edits) {
				edits = this._editors = {};
			}
			e = edits[key];
			if (!e && add) {
				e = edits[key] = this._createEditor(td, key);
			}
			return e;
		},
		findHiddenComboEditor: function (editor) {
			/* Find reference to igCombo, which is assigned to a hidden column and which is used as provider of data for visible cascading igCombo editor.
			That method can be used only after visible editor was already created.
			paramType="$" Reference to jQuery element which represents visible cascading igCombo linked to hidden igCombo.
			returnType="object" Returns reference to igCombo or null.
			*/
			var combos = this._hCombos,
				combo = combos && editor ? editor.data('igCombo') : null,
				hComboID = combo ? combo.options._hComboID : null,
				obj = hComboID ? combos[hComboID] : null;
			combo = obj ? obj.combo.data('igCombo') : null;
			if (combo) {
				combo._colKey = obj.key;
			}
			return combo;
		},
		_setOption: function (key, value) {
			var o = this.options;
			if (o[key] === value) {
				return this;
			}
			this._endEdit();
			// 2-remove buttons
			this._doButtons(2);
			o[key] = value;
			if (key.indexOf('ddRow') > 0) {
				this._headerRendered();
				this.grid._initializeHeights();
				// M.H. 26 Jul 2013 Fix for bug #146837: Vertical scroll bar does not display when control inside the Jquery UI tab
				if (this.grid.options.virtualization === true || this.grid.options.rowVirtualization === true) {
					this.grid._onVirtualVerticalScroll();
				}
			} else if (key === 'saveChangesSuccessHandler') {
                // M.H. 18 Feb 2014 Fix for bug #153639: Add successCallback and errorCallback params to the igDataSource.saveChanges API
                this._addDSSuccessHandler();
            } else if (key === 'saveChangesErrorHandler') {
                // M.H. 18 Feb 2014 Fix for bug #153639: Add successCallback and errorCallback params to the igDataSource.saveChanges API
                this._addDSErrorHandler();
            }
			return this;
		},
		_fire: function (name, e, a) {
			if (a && e && e !== 1) {
				a.owner = this;
				return this._trigger(name, e, a);
			}
			return 1;
		},
		// get localized string from: options or $.ig.GridUpdating.locale
		_loc: function (prop, title) {
			prop += title ? "Tooltip" : "Label";
			title = this.options[prop];
			if (_aNull(title)) {
				title = $.ig.GridUpdating && $.ig.GridUpdating.locale ? $.ig.GridUpdating.locale[prop] : null;
			}
			return title || '';
		},
		_div: function () {
			return this.grid.container();
		},
		_hscroll: function (scroller) {
			if (!this._hscr1) {
				var grid = this.grid.element;
				this._hscr1 = $("#" + grid[0].id + "_hscroller");
				this._hscr2 = this._hscr1.length ? this._hscr1 : grid.parent();
			}
			return scroller ? this._hscr1 : this._hscr2;
		},
		_groupedColumnsChanged: function (args) {
			// internal event of GroupBy called when grouped columns collection is changed
			this._groupCols = args.groupedColumns.length;
			this._mapAdd = this._map = null;
			//this._hidingFinishing();
			//this._headerRendered();
		},
		//i=1: flag to destroy
		_headerRendered: function (i) {
			// render the filter row
			var th, txt, title, me = this, grid = me.grid, hasFixedCols = grid.hasFixedColumns(),
				tr = me._addTR, o = me.options, cols = grid.options.columns, len = cols.length, fCols, ufCols;
			if (!o.enableAddRow || i === 1) {
				if (tr) {
					tr.remove();
					me._newTR.remove();
					me._hierTD = me._newTR = me._addTR = null;
                    // M.H. 24 Jul 2013 Fix for bug #144635: When there are fixed columns the updating's destroy method does not remove the add new row and you can still enter in edit mode.
                    if (this.grid.hasFixedColumns()) {
                        this.grid.fixedHeadersTable().find('thead tr[data-add-row]').remove();
                        this.grid.fixedHeadersTable().find('thead tr[data-new-row]').remove();
                        this.grid.element.data("igGridColumnFixing")._syncContainerHeights();//_heightChanged
				}
				}
				return;
			}
			txt = me._loc('addRow') || '&nbsp;';
			title = me._loc('addRow', 1);
			if (tr) {
				tr.find('.anr_t').html(txt);
				tr.find('.ui-iggrid-addrow').attr('title', title);
				tr.find('.anr_i').css('display', 'inline-block');
			}
			th = me._div().find('thead');
			if (!th || tr) {
				return;
			}
			if (hasFixedCols) {
				fCols = [];
				ufCols = [];
				for (i = 0; i < len; i++) {
					if (cols[i].fixed === true) {
						fCols.push(cols[i]);
					} else {
						ufCols.push(cols[i]);
					}
				}
				th = me._div().find('div[data-fixed-container]').find('thead');
				cols = ufCols;
				this._headerRenderedHelper(fCols, th, txt, title);
				th = me._div().find('div:not([data-fixed-container])').find('thead');
			}
			this._headerRenderedHelper(cols, th, txt, title);
		},
		_headerRenderedHelper: function (cols, th, txt, title) {
			var i, plus, td, col, colSet, me = this, css = me.css, shift = me._addTrShift, colSpan = 0,
				tr = me._addTR, o = me.options, grid = me.grid, len = cols.length,
				hiddenColumns = grid._initialHiddenColumns || [], hiddenKeys = [];

			plus = o.showPlusIcon;
			tr = me._addTR = $('<tr />').addClass(css.addRow).attr('data-skip', 'true').attr('data-add-row', 'true').appendTo(th);
			// insert leading TDs/THs which existed before _hidingFinishing
			if (shift) {
				for (i = 0; i < shift.length; i++) {
					$(shift[i]).appendTo(tr);
				}
			} else {
				me._hierOn = _now();
				// insert hierarchical grid cell
				grid._headerInit(tr);
				// flag that hierarchical TD was created
				me._hierTD = tr.children().length;
			}
			// skip hidden columns
			for (i = 0; i < len; i++) {
				if (!cols[i].hidden) {
					colSpan++;
				} else {
					hiddenKeys.push(cols[i].key);
				}
			}
			// L.A. 05 October 2012 - Fixing bug #123361
			// Initially hiding a column causes extra space when trying to add a new row.
			// Read initially hidden columns via the hiding column settings
			// and avoid overlapping column keys for columns set via the grid.columns 
			for (i = 0; i < hiddenColumns.length; i++) {
				if ($.ig.indexInArray(hiddenKeys, hiddenColumns[i].key) === -1) {
					hiddenKeys.push(hiddenColumns[i].key);
					colSpan--;
				}
			}
			// if grid has grouped columns, then insert extra TD to match with number columns in headers
			/*if (me._groupCols) {
				// save reference in order to remove it if group or hidden columns are changed
				me._groupTD1 = $('<td />').addClass('ui-iggrid-rowselector-header').attr('data-skip', 'true').appendTo(tr);
			}*/
			td = $('<td colspan="' + colSpan + '"></td>').attr('title', title).addClass(css.addRow).appendTo(tr);
			// initial shift of AddNewRow content from left edge of table
			me._addLeft = _int(td, 'paddingLeft');
			$('<span />').css('display', 'inline-block').addClass(css.addRowIcon).addClass('anr_i').appendTo(td);
			// notes: do not use tabIndex for TD, to get around bug in IE which scrolls header
			// use _ti+1, because editors should get focus on external Tab before buttons/addNewRow
			$('<span>' + txt + '</span>').addClass('anr_t').css('outline', 0).attr('tabIndex', me._ti + 1).focus(function (e) { me._onEvt(e, 5); }).blur(function (e) { me._onEvt(e, 6); }).appendTo(td);
			// render (hidden) cells
			tr = me._newTR = $('<tr />').attr('data-skip', 'true').attr('data-new-row', 'true').appendTo(th).hide();
			// insert leading TDs/THs which existed before _hidingFinishing
			shift = this._newTrShift;
			if (shift) {
				for (i = 0; i < shift.length; i++) {
					$(shift[i]).appendTo(tr);
				}
			} else {
				// insert hierarchical grid cell
				grid._headerInit(tr);
			}
			/*if (me._groupCols) {
				me._groupTD2 = $('<td />').addClass('ui-iggrid-rowselector-header').attr('data-skip', 'true').appendTo(tr);
			}*/
			for (i = 0; i < len; i++) {
				col = cols[i];
				// skip hidden columns
				// L.A. 05 October 2012 - Fixing bug #123361
				// Initially hiding a column causes extra space when trying to add a new row.
				if (!col.hidden && $.ig.indexInArray(hiddenKeys, col.key) === -1) {
					colSet = me._colSet(0, col ? col.key : null);
					plus = colSet && colSet.readOnly;
					txt = plus ? colSet.defaultValue : null; 
					txt = _aNull(txt) ? '&nbsp;' : grid._renderCell(txt, col);
					td = $('<td>' + txt + '</td>').addClass(css.editingCell).appendTo(tr);
					if (plus && col && col.key === grid.options.primaryKey) {
						me._tdAddPrime = td;
					}
				}
			}
		},
		// check if number of leading extra header cells in updating-rows is the same as number of extra cells in any other header row.
		_hierGridInDiv: function () {
			var css, kids, len, elem,
				extra = 0,
				i = -1,
				tr = this._newTR,
				trA = this._addTR;
			// number of rows in header
			kids = tr.parent().children();
			// find any not _newTR/_addTR row in header
			while (++i < kids.length) {
				if (kids[i] !== trA[0] && kids[i] !== tr[0]) {
					break;
				}
			}
			if (i > kids.length) {
				return;
			}
			// find number of leading special/dummy cells in not-updating-row
			kids = kids[i].childNodes;
			len = kids.length;
			for (i = 0; i < len; i++) {
				elem = kids[i];
				// test for extra leading cells in header
				css = elem.getAttribute('data-skip') ? elem.className : null;
				if (css && (css.indexOf('-expand') >= 0 || css.indexOf('-rowselector') >= 0)) {
					extra++;
				} else {
					break;
				}
			}
			// adjust for existing leading special/dummy cells in updating-row
			kids = tr.children();
			len = kids.length;
			for (i = 0; i < len; i++) {
				elem = kids[i];
				if (elem.getAttribute('data-skip')) {
					extra--;
				} else {
					break;
				}
			}
			// add missing leading special/dummy cells
			while (extra-- > 0) {
				this.grid._headerInit(tr, null, true);
				this.grid._headerInit(trA, null, true);
			}
		},
		// ensure that hierarchical TD was created (96606: base of grid is DIV)
		_headerInit: function () {
			if (this._addTR) {
				this._addTR.find("[data-skip=true]").remove();
				this.grid._headerInit(this._addTR, null, true);
			}
			if (this._newTR) {
				this._newTR.find("[data-skip=true]").remove();
				this.grid._headerInit(this._newTR, null, true);
			}
			this._mapAdd = this._map = null;
		},
		_dataRendered: function () {
			if (this._wasInit) {
				return;
			}
			// enable processing scroll events
			this._scrollDiv();
			if (this._renderTouchUI && this.options.editMode !== "row") {
				this._div().bind(this._tEvts);
				// some touch browsers will throw mouse events which will interfere
				// with the specialized touch support
				delete this._evts.mousemove;
				delete this._evts.mouseleave;
			}
			this._div().bind(this._evts);
			this._wasInit = true;
		},
		_findCell: function (e) {
			var i = 0, td = $(e), grid = this.grid.element[0], headerst = this.grid.headersTable()[0];
			if (this.grid.hasFixedColumns() && td.closest('div').attr('data-fixed-container') !== undefined) {
				grid = $('#' + this.grid.id() + '_fixed')[0];
				headerst = this.grid.fixedHeadersTable()[0];
			}
			if (!td.is('td')) {
				td = td.closest('td');
			}
			e = td;
			while (e && i++ < 5) {
				e = e.parent();
				if (e && (e[0] === grid || e[0] === headerst)) {
					break;
				}
			}
			return (i === 3 && this._col(td) >= 0 && this._row(td) >= 0) ? td : null;
		},
		_td: function (from) {
			var i, tds = this._tds;
			if (tds) {
				for (i in tds) {
					if (tds.hasOwnProperty(i) && tds[i] && (from ? i === from : true)) {
						return tds[i];
					}
				}
			}
		},
		_row: function (td) {
			return td ? td.parent().index() : -1;
		},
		_idForCol: function (id, shift) {
			var last = -1, map = this._col(1), i = map ? map.length : 0;
			while (--i >= 0) {
				if (map[i] < 0) {
					continue;
				}
				// request to return first valid column
				if (shift === -2) {
					return i;
				}
				if (map[i] === id) {
					// flag to return next valid column
					if (shift === 1) {
						return last;
					}
					// set flag to return first valid column
					if (shift === -1) {
						shift = -2;
					} else {
						break;
					}
				}
				last = i;
			}
			return i;
		},
		// gets the column key for the editor element passed
		_keyForEditor: function (editor) {
			var ckey;
			editor = editor instanceof jQuery ? editor[0] : editor;
			for (ckey in this._editors) {
				if (this._editors.hasOwnProperty(ckey) && this._editors[ckey] &&
					this._editors[ckey][0] === editor) {
					return ckey;
				}
			}
		},
		// check if td belongs to addNewRow-TR or to data-TR
		_isAdd: function (td) {
			return (td === 1) ? this._adding : (this._isSrc(this._addTR, td) || this._isSrc(this._newTR, td));
		},
		// get column index within grid columns for TD	
		_col: function (td) {
            var col, shift, len, cols, id, i, add = this._isAdd(td), colInd = -1,
                hasFixedCols = this.grid.hasFixedColumns(),
			// add-row and data-row may have different leading extra TDs, so, maps should be different
				map = add ? this._mapAdd : this._map;

            if (hasFixedCols && td !== 1) {
                col = this.grid._getColumnByTD($(td));
                if (col !== null) {
                    colInd = col.index;
                }
            }
			if (!map) {
				shift = this._colShift(td);
				map = [];
				id = i = -1;
				while (shift-- > 0) {
					map[++i] = -1;
				}
				cols = this.grid.options.columns;
				len = cols.length;
				while (++id < len) {
					if (cols[id] && !cols[id].hidden) {
						map[++i] = id;
					}
				}
				if (add) {
					this._mapAdd = map;
				} else {
					this._map = map;
				}
			}
			if (td === 1) {
				return map;
			}
            if (hasFixedCols && colInd !== -1) {
                return colInd;
            }
			id = td.index() + (this.grid._startColIndex || 0);
			return (td && id < map.length) ? map[id] : -1;
		},
		_colSet: function (td, key) {
			var i, cols = this.options.columnSettings;
			if (!key) {
				key = this._key(td);
			}
			i = (cols && key) ? cols.length : 0;
			while (i-- > 0) {
				if (cols[i].columnKey === key) {
					return cols[i];
				}
			}
		},
		_isSame: function (td1, td2) {
			return this._row(td1) === this._row(td2) && this._col(td1) === this._col(td2);
		},
		_gridCol: function (key, id) {
			var i = -1, cols = this.grid.options.columns;
			while (++i < cols.length) {
				if (cols[i].key === key) {
					return id ? i : cols[i];
				}
			}
		},
		// return value of cell in primary-column for a row or index of row (if grid does not have primary key)
		_prime: function (td) {
			var key = td.parent().attr('data-id');
			return _aNull(key) ? this._row(td) : this._fixPrime(key);
		},
		_defVal: function (key, fire) {
			var col;
			if (key) {
				col = this._colSet(null, key);
				col = col ? col.defaultValue : null;
				if (fire && key === this.grid.options.primaryKey) {
					col = this._defValue;
					if (!col) {
						col = { value: col || this._addRowNum };
						this._fire('generatePrimaryKeyValue', this._evt || {}, col);
						this._defValue = col = col.value;
					}
				}
			}
			return col;
		},
		// fill defaultValue for readOnly columns, because there are no editors for them and grid will not be updated with defaults
		_addReadOnly: function (add) {
			var v, key, prime, cols = this.options.columnSettings, vals = {};
			for (key in cols) {
				if (cols.hasOwnProperty(key)) {
					v = cols[key];
					key = v.columnKey;
					if (v.readOnly) {
						if (!add) {
							// get value from possible transactions (like editing of already added row)
							vals[key] = this._getVal(this._row_, key);
						} else {
							v = this._defVal(key, 1);
							if (!_aNull(v)) {
								prime = key;
								vals[prime] = v;
							}
						}
					}
				}
			}
			// hidden column with primary key: ensure generatePrimaryKeyValue is raised before rowAdding
			if (!prime && add) {
				this._fixPrime(vals, this.grid.dataSource);
			}
			return vals;
		},
		_key: function (td) {
			var cols, col;
			if (this.grid.hasFixedColumns()) {
				col = this.grid._getColumnByTD(td);
				if (col !== null) {
					return col.column.key;
				}
			}
			cols = this.grid.options.columns;
			col = this._col(td);
			col = (cols && col >= 0) ? cols[col] : null;
			return col ? col.key : null;
		},
		_equals: function (v1, v2) {
			return v1 === v2 || (v1 && v2 && v1.getTime && v2.getTime && v1.getTime() === v2.getTime());
		},
		// get/set value of cell in grid
		// if set and edit mode is row, then update vals[key] with new value and return "not undefined"
		_val: function (td, arg, vals) {
			var val, add = this._adding, row = this._row_, key = this._key(td);
			if (add) {
				val = this._defVal(key, vals && _aNull(vals[key]));
			} else {
				val = this._getVal(row, key);
			}
			// set cell value
			if (arg) {
				if (add || !this._equals(val, arg.value)) {
					// row update container
					if (vals) {
						return arg.value;
					}
					// cell update
					this._update(row, td.parent()[0], arg.value, key, td);
				}
				return undefined;
			}
			// get cell value
			return val;
		},
		// returns number of TDs in front of 1st addNewRow-TD or dataRow-TD
		_colShift: function (td, tr) {
			var i, add, shift = this._cShift, shiftAdd = this._cShiftAdd;
			if (!tr && td) {
				tr = td.parent()[0];
			}
			if (!tr) {
				return (shift < 0) ? 0 : shift;
			}
			add = this._isAdd(tr);
			if (add) {
				if (shiftAdd >= 0) {
					return shiftAdd;
				}
			} else if (shift >= 0) {
				return shift;
			}
			tr = tr ? tr.childNodes : null;
			if (!tr) {
				return 0;
			}
			shift = 0;
			for (i = 0; i < tr.length - 1; i++) {
				td = tr[i].className;
				if ((td && (td.indexOf('-expandcolumn') >= 0 || td.indexOf('-rowselector') >= 0)) || tr[i].getAttribute('data-skip')) {
					shift++;
				} else {
					break;
				}
			}
			if (add) {
				this._cShiftAdd = shift;
			} else {
				this._cShift = shift;
			}
			return shift;
		},
		// return object which holds reference to TABLE and row/col edit-indexes of cell: to restore TD after update by autoCommit
		_cur: function (td, i) {
			return { tbl: td.parent().parent().parent(), row: i ? this._rowIndex : this._row(td), col: this._col(td) };
		},
        _nextTDFixing: function (cur, shift, row) {
            var td = null, $fixedContainer, isLeft, tds;
            if (this.grid._isFixedElement(cur.td)) {
                isLeft = (cur.td.closest('div[data-fixing-direction]').attr('data-fixing-direction') === 'left');
                if (isLeft) {
                    // next TD
                    if (shift === 1) {
                        tds = this.grid.element.find('tbody tr:nth-child(' + (row + 1) + ')').children();
                        if (tds.length > 0) {
                            td = tds[0];
                        }
                    } else if (shift === -1 && row >= 1) {
                        tds = this.grid.element.find('tbody tr:nth-child(' + row + ')').children();
                        if (tds.length > 0) {
                            // prev TD
                            td = tds[tds.length - 1];
                        }
                    }
                } else {
                    // next TD
                    if (shift === 1) {
                        tds = this.grid.element.find('tbody tr:nth-child(' + (row + 2) + ')').children();
                        // prev TD
                        if (tds.length > 0) {
                            td = tds[0];
                        }
                    } else if (shift === -1) {
                        tds = this.grid.element.find('tbody tr:nth-child(' + (row + 1) + ')').children();
                        if (tds.length > 0) {
                            td = tds[tds.length - 1];
                        }
                    }
                }
            } else {
                $fixedContainer = this.grid.container().find('div[data-fixing-direction]');
                isLeft = $fixedContainer.attr('data-fixing-direction') === 'left';
                if (isLeft) {
                    // next TD
                    if (shift === 1) {
                        tds = $fixedContainer.find('tbody tr:nth-child(' + (row + 2) + ')').children();
                        if (tds.length > 0) {
                            td = tds[0];
                        }
                    } else if (shift === -1) {
                        tds = $fixedContainer.find('tbody tr:nth-child(' + (row + 1) + ')').children();
                        if (tds.length > 0) {
                            // prev TD
                            td = tds[tds.length - 1];
                        }
                    }
                } else {
                    // next TD
                    if (shift === 1) {
                        tds = $fixedContainer.find('tbody tr:nth-child(' + (row + 1) + ')').children();
                        // prev TD
                        if (tds.length > 0) {
                            td = tds[0];
                        }
                    } else if (shift === -1 && row >= 1) {
                        tds = $fixedContainer.find('tbody tr:nth-child(' + row + ')').children();
                        if (tds.length > 0) {
                            td = tds[tds.length - 1];
                        }
                    }
                }
            }
            return td;
        },
		// find next TD which should go in edit mode
		// shift: 0-next TR, 1-next TD, -1-previous TD, -tr1 same TD on the previous row
		//	cur: {tbl: TABLE, row: TD_rowIndex, col: TD_colIndex}
		_nextTD: function (cur, shift, edit) {
			// L.A. 26 September 2012 - Fixing bug #122667
			// Pressing the Enter key while editing in the Add Row causes JS errors
			/* VS 09/26/2012: cur.tbl.children('tbody')[0].childNodes should be used, but not cur.tbl.children('tbody').childNodes */
			var i, tds, tr, td, map, hasFixedCols = this.grid.hasFixedColumns(),
				tbody = cur.tbl.children('tbody')[0],
				rows = tbody ? tbody.childNodes : 0,
				rowsLen = rows ? rows.length : 0,
				row = cur.row;
			if (rowsLen < 1 || row < 0 || row >= rowsLen) {
				return;
			}
			tr = rows[row];
			if (!tr) {
				return;
			}
			// TDs in current row
			tds = tr.childNodes;
			map = this._col(1);
			// index of next TR
			if (shift === '-tr1' || (shift === -1 && cur.col === 0 && cur.row === 0)) {
				tr = row - 1 < 0 ? rowsLen - 1 : row - 1;
			} else {
				tr = row + (shift || 1);
				tr = tr >= rowsLen ? 0 : tr;
			}
			// index of next TD
			// M.H. 6 Mar 2014 Fix for bug #166087: When column is fixed and another is hidden changing the editable cell with TAB key skips a cell after the hidden column.
			if (hasFixedCols && cur.col >= 0) {
				i = cur.col;
				if (shift === 1) {
					i += 1;
				} else if (shift === -1) {
					i -= 1;
				}
				if (!tds[i]) {
					i = -1;
				}
			} else {
			i = this._idForCol(cur.col, shift);
			}
			// tab key: next/prev TD in TR
			if (shift && shift !== '-tr1') {
				if (i >= 0) {
					// find next/prev column in same row
					cur.col = map[i];
					td = tds[i];
				}
				if (!td && edit) {
					if (hasFixedCols) {
                        td = this._nextTDFixing(cur, shift, row);
                    } else if (tr >= 0 && tr < rowsLen) {
                        // we handle ONLY cases when trying to go to next row(first cell), prev row(last cell) and there is column fixing
                        // in other case it is working as expected
						// find first column in next row
						if (shift > 0) {
							i = (map[0] >= 0) ? 0 : 1;
						} else {
							// find last column in prev row
							i = map.length;
							while (--i >= 0) {
								if (map[i] >= 0) {
									break;
								}
							}
						}
						if (i >= 0) {
							cur.col = map[i];
							cur.row = tr;
							td = rows[cur.row].childNodes[i];
						}
					}
				}
				// enter key: next TR
			} else {
				if (tr < rowsLen) {
					cur.row = tr;
					td = rows[cur.row].childNodes[i];
				} else {
					td = null;
				}
			}
			cur.td = td ? $(td) : null;
			return td ? cur : null;
		},
		// find next editor in row
		_nextEditor: function (key, shift) {
            var e, col, ok = null, edits = this._editors, i, editors, cols, colsLength;
            if (this.grid.hasFixedColumns()) {
                editors = {};
                cols = this.grid.options.columns;
                colsLength = cols.length;
                // re-arrange editors according to grid columns
                for (i = 0; i < colsLength; i++) {
                    col = cols[i].key;
                    if (edits.hasOwnProperty(col)) {
                        editors[col] = edits[col];
                    }
                }
                edits = this._editors = editors;
            }

			for (col in edits) {
				if (edits.hasOwnProperty(col)) {
					if (shift && key === col) {
						return ok;
					}
					if (col) {
						e = edits[col];
						if (e && e[0] && e[0].offsetWidth > 0) {
							if (key === null) {
								return e;
							}
							ok = e;
						}
					}
					if (key === col) {
						key = null;
					}
				}
			}
		},
		// start edit mode for next cell/row
		// shift: 0-next TR, 1-next TD in TR, -1-previous TD in TR
		// from: the col key to go from when in row edit mode // optional
		_nextEdit: function (e, shift, from) {
			var cur, td = this._td(from);
			if (!td) {
				return;
			}
			cur = this._cur(td, true);
            cur.td = td;
			while (this._nextTD(cur, shift, 1)) {
				if (_aNull(this.editorForCell(cur.td)) && this.options.editMode !== "cell") {
					continue;
				}
				if (this._startEdit(cur.td, e, this.options.editMode === "cell" ? 1 : false, null, null, null, true)) {
					return;
				}
			}
			this._endEdit(e, 1);
		},
		// creates editor for cell
		// td: the cell to create editor for
		// key: the column key of the cell
		// element: the element to create the editor on (null for auto)
		_createEditor: function (td, key, element) {
			var v, oValid, elem,
				oEdit = {},
				me = this,
				gridCol = me._gridCol(key) || {},
				format = gridCol.format,
				css = me.css.editor,
				xy = me._xy,
				col = me._colSet(td, key),
				provider = col ? col.editorProvider : null,
				topBorder = me._tdBdrTop,
				retDone = $("#" + this.grid.container().attr("id") + "_igButton");
			if (col && col.readOnly && !element) {
				return null;
			}
			// measure attributes of editor class
			if (!xy && !element) {
				topBorder = me._tdBdrTop = _int(td, 'borderTopWidth');
				v = $('<span />').addClass(css).prependTo(td);
				// shift of editor relative to the left-top corner of cell
				me._xy = xy = { x: _int(v, 'marginLeft'), y: _int(v, 'marginTop') };
				// reduction of editor width/height
				xy.dx = xy.x + _int(v, 'marginRight');
				xy.dy = xy.y + _int(v, 'marginBottom');
				v.remove();
			}
			v = null;
			if (col) {
				oEdit = col.editorOptions || oEdit;
				oValid = oEdit.validatorOptions;
				v = col.required;
				if (!oValid && (col.validation || v)) {
					oValid = {};
				}
				if (v) {
					oValid.required = oEdit.required = true;
				}
			}
			if (me.options.validation && !oValid) {
				oValid = {};
			}
			if (oValid) {
				if (!me.grid.element.igValidator) {
					_throw('igValidatorException');
				}
				if (col) {
					col.editorOptions = oEdit;
				}
				oEdit.validatorOptions = oValid;
				oValid.bodyAsParent = false;
				oValid.errorHidden = function () {
					// remove current-error flag
					me._error = null;
					if (me._butDone) {
						/* OK 12 OCT 2011 - Fixed <91232> - When a column has combo editor and deleted its value then select new button Done is still dissabled */
						me._butDone.removeClass(me.css.buttonDisabled);
					}
					// same for RET dialog done button
					if (retDone.length > 0) {
						retDone.igButton("option", "disabled", false);
					}
				};
				oValid.errorShowing = function () {
					// do not show error message if another editor has it
					if (!_aNull(me._error) && me._error !== key) {
						return false;
					}
				};
				oValid.errorShown = function (evt, ui) {
					// set current-error flag
					me._error = key;
					if (me._butDone) {
						me._butDone.addClass(me.css.buttonDisabled);
					}
					//T.P. 4th June 2014. Bug #170025 Setting zIndex to 99999 for the error message places the error message on top of the datepicker and prevents the user from selecting previous month. 
					/*ui = ui.owner._lbl;
					if (ui) {
						ui.css('zIndex', 99999);
					}*/
					me._scrollTo(key);
				};
			}
			if (!provider) {
				if (gridCol.dataType === 'bool' && (format === 'checkbox' || (!format && me.grid.options.renderCheckboxes)) && !element) {
					provider = new $.ig.EditorProviderCheckbox();
				} else if (col && col.editorType === 'combo') {
					provider = new $.ig.EditorProviderCombo();
				} else if (col && col.editorType === 'rating') {
					provider = new $.ig.EditorProviderRating();
				} else {
					provider = new $.ig.EditorProviderDefault();
				}
			}
			me._hComboInit(oEdit);
			elem = provider.createEditor(me, key, col, me._ti, format, gridCol.dataType, me._val(td), element);
			if (!element) {
				elem.addClass(css).css({ marginLeft: (xy.x - _int(td, 'paddingLeft')) + 'px', marginTop: (xy.y - topBorder - _int(td, 'paddingTop')) + 'px' });
			}
			v = elem.igEditorFilter({ 'provider': provider });
			return v;
		},
		_notifyChanged: function () {
			/* Notification about changed value in editor. That should be called by $.ig.EditorProvider
			in order to enable Done button and update data.
			*/
			var e = this._butDone;
			if (e) {
				if (this.findInvalid()) {
					e.addClass(this.css.buttonDisabled);
				} else {
					e.removeClass(this.css.buttonDisabled);
				}
			}
			e = $("#" + this.grid.container().attr("id") + "_igButton");
			if (e.length > 0) {
				if (this.findInvalid()) {
					e.igButton("option", "disabled", true);
				} else {
					e.igButton("option", "disabled", false);
				}
			}
			this._modified = 1;
		},
		// process esc, enter tab keys of igEditor
		_notifyEditorKey: function (e, colKey) {
			/* Notification about keydown event in editor. That should be called by $.ig.EditorProvider
			in order to correctly process Esc, Enter and Tab keys.
			paramType="object" Browser event.
			paramType="string" Key of column. That can be string or number.
			*/
			var but, old, val, next, cur, tar,
				// M.H. 19 Mar 2013 Fix for bug #132935: Unable to tab between cells when edit mode is cell with jQueryUI 1.8.16 and older.
				key = e.keyCode || e.which || 0,
				esc = key === 27,
				o = this.options, shift;
			if (key !== 9 && key !== 13 && !esc) {
				return;
			}
			cur = this._editors[colKey];
			// _13: skip enter/13 key
			if (!cur || (key === 13 && (e.shiftKey || e.ctrlKey || this._13))) {
				return;
			}
			if (esc) {
				old = cur._oldCellVal;
				val = _filter(cur, 'getValue');
				if (!this._equals(old, val)) {
					_filter(cur, 'setValue', old);
					// revalidate value again: editors like dateEditor may remove some fields (hours, minuted) not exposed in pattern
					if (!this._equals(_filter(cur, 'getValue'), val)) {
						_filter(cur, 'validate');
						// get around bugs in Firefox
						_stop(e);
						return;
					}
				}
				return this._endEdit(e, null, 200);
			}
			// enter key or cell-edit mode
			if (key === 13 || (!this._adding && o.editMode === 'cell')) {
				// S.S. March 18, 2013, Bug #135215 Using tab starts edit on next element but does not trigger 'blur' on the current
				// one which prevents validation to occur
				tar = $(e.target);
				if (tar.length > 0) {
					tar.find("input").first().trigger("blur");
				}
				if (this.options.horizontalMoveOnEnter) {
					shift = 1;
				} else {
					shift = (key === 9) ? (e.shiftKey ? -1 : 1) : 0;
				}
				return this._nextEdit(e, shift);
			}
			// tab key + row-editing
			next = this._nextEditor(colKey, e.shiftKey);
			if (!_filter(cur, 'validate') && _filter(cur, 'keepFocus')) {
				_stop(e);
				return;
			}
			if ((key === 13 || key === 9) && !next && !this._adding) {
				tar = $(e.target);
				if (tar.length > 0) {
					tar.find("input").first().trigger("blur");
				}
			}
			_stop(e);
			try {
				// check if add-new-row in virtual grid and grid failed to render all tds in a row
				if (next && this._adding && !_aNull(this.grid._startColIndex) && this.grid.table && this.grid.table.rows[0] && !(this.grid.cellAt(this._col(next.parent()), 0))) {
					next = null;
				}
			} catch (ex) { next = null; }
			if (next) {
				// scroll to and edit next cell in row
				this._scrollTo(next.parent(), next);
				return;
			}
			but = this._butDone;
			// if no Done/Cancel buttons, then start edit cell in another row
			if (!but || but[0].offsetWidth === 0) {
				return this._nextEdit(e, e.shiftKey ? -1 : 0);
			}
			// if Done button is disabled, then set focus to Cancel button
			if (but.hasClass(this.css.buttonDisabled)) {
				but = this._butCancel;
			}
			but[0].focus();
			// used by shift+tab keys
			this._prevEdit = cur;
		},
		_evtArg: function (td, editor, val) {
			var arg = { rowAdding: !!this._adding, columnIndex: this._col(td), rowID: this._row_, columnKey: this._key(td), editor: editor };
			arg.value = _aNull(val) ? null : val;
			return arg;
		},
		// check hidden columns
		// add default values for hidden columns
		_checkHidden: function (vals) {
			var col, key, colG, cols = this.grid.options.columns, i = cols.length;
			while (i-- > 0) {
				colG = cols[i];
				if (colG && colG.hidden) {
					key = colG.key;
					col = this._colSet(null, key);
					col = (col && _aNull(vals[key])) ? col.defaultValue : null;
					if (col !== null) {
						vals[key] = col;
					}
				}
			}
		},
		// check if mouse was clicked within checkbox image
		_isToggle: function (e) {
			e = e && e.type && e.type.indexOf('click') >= 0 ? e.target : null;
			return e && e.className && e.className.indexOf('ui-icon-check') >= 0;
		},
		// Reduce width of last cell in row for scrollbar width, which may overlap grid.
		// igGrid currently may set paddingRight to large value ~20px for (asuming partially) visible cell, but fully visible cell also may have that large padding.
		// There are also many possible cases, which may require that.
		// Changesets:276093,277095 and Bugs:101650,115607,118770
		_lastTDWidth: function (td, width) {
			// check for padding
			var pad = _int(td, 'paddingRight') > 12,
			// check if cell is last
				div = (pad || !td.next()[0]) ? td.closest('div')[0] : null,
			// check if cell fits in container div
				v = div && td[0].offsetLeft + td[0].offsetWidth > div.clientWidth + 5 ? div.offsetWidth - div.clientWidth : 0;
			if (v > 10) {
				// if horizontal scroller is active, then no need for fix
				div = pad ? null : this._hscroll(1)[0];
				if (!div || div.offsetWidth < div.clientWidth + 3) {
					width -= Math.min(18, v);
				}
			}
			return width;
		},
		// initialize igCombo located in hidden column
		_hComboInit: function (oEdit) {
			var i, gCol, col, key, cols, combo,
				cell = this.options.editMode === 'cell',
				hComboID = oEdit.parentCombo,
				combos = this._hCombos;
			if (!hComboID) {
				return;
			}
			cols = this.options.columnSettings;
			i = cols.length;
			// find existing hidden igCombo which uses same parentCombo
			combo = combos ? combos[hComboID] : null;
			if (combo) {
				oEdit._hComboID = hComboID;
				oEdit.parentCombo = combo.combo;
				i = 0;
			}
			// check if a hidden column contains igCombo with id which points to parentCombo
			while (i-- > 0) {
				col = cols[i];
				key = col.columnKey;
				gCol = this._gridCol(key);
				combo = col.editorType === 'combo' && (cell || (gCol && gCol.hidden)) ? col.editorOptions : null;
				// hidden column is found
				if (combo && combo.id === hComboID) {
					this._hCombos = combos = combos || {};
					oEdit._hComboID = hComboID;
					// replace parentCombo by actual instance of igCombo, because that igCombo hangs nowhere and connection events may fail
					oEdit.parentCombo = combo = $('<span id="' + hComboID + '"></span>').igCombo(combo);
					// save key and reference to hidden igCombo: provider of cascading data
					combos[hComboID] = { key: key, combo: combo };
					return;
				}
			}
		},
		// edit cell of slave igCombo linked to data-provider cascading igCombo located in hidden column
		_hComboEdit: function (editor) {
			var val, o, combo = this.findHiddenComboEditor(editor);
			if (!combo) {
				return;
			}
			o = combo.options;
			// in case of filtering ensure that old selection and data are reset
			if (o.filteringType) {
				combo.selectedIndex(-1);
				combo.activeIndex(-1);
				combo.dataBind();
			}
			// get cell-value for hidden igCombo within editing row
			val = this.grid.getCellValue(this._row_, combo._colKey);
			// set new value to hidden igCombo
			if (o.allowCustomValue) {
				combo.text(val === null ? (o.nullText || "") : val);
			} else {
				combo.value(val);
			}
		},
		// reset changes related to hidden igCombo
		_hComboRemove: function (destroy) {
			var i, o, combo, combos = this._hCombos;
			if (!combos) {
				return;
			}
			// destroy hidden igCombos
			for (i in combos) {
				if (combos.hasOwnProperty(i)) {
					combo = combos[i].combo;
					if (combo) {
						combo.igCombo('destroy');
					}
				}
			}
			delete this._hCombos;
			// restore original value of editorOptions.parentCombo
			combos = this.options.columnSettings;
			i = destroy ? 0 : combos.length;
			while (i-- > 0) {
				o = combos[i].editorOptions;
				combo = o ? o._hComboID : null;
				if (combo) {
					o.parentCombo = combo;
				}
			}
		},
		// return 1: success or keep editing
		// td: jquery TD, e: event, foc: setFocus, add:addNewRow, height:height of row
		// e: browser event, null, or 1-flag from startEdit
		// foc: request to set focus
		// add: add row
		// height: height of td
		// toggle: request to toggle checkbox
		// focNoDelay: request that focus is first set without delay (for hold-tab navigation) 
		_startEdit: function (td, e, foc, add, height, toggle, focNoDelay) {
			var i, tds, width, arg, editor, val, hasFixedCols = this.grid.hasFixedColumns(), funcIterator,
				grid = this.grid, prime = grid.options.primaryKey, me = this, fixedTDs = [], unfixedTDs = [],
				td0 = td ? td[0] : null, but = null, v = false, o = this.options;
			if (!td0) {
				return;
			}
			if (e) {
				// reset temporary automatic primary key to prevent raising multiple events
				delete this._defValue;
				this._delHover();
				// L.A. 02 October 2012 - Fixing bug #116198
				// When GroupBy (with remote type) and Updating (with row mode) are enabled for hierarchical 
				// grid after grouping the updating fields are misaligned
				this._cShift = this._cShiftAdd = -1;
				this._map = undefined;
				// ensure end-edit
				if (this._tds) {
					// after _endEdit grid can be modified, so, reference to td will be wrong
					// save props of td and restore it after _endEdit
					if (!add) {
						// M.H. 6 Mar 2014 Fix for bug #166087: When column is fixed and another is hidden changing the editable cell with TAB key skips a cell after the hidden column.
						if (hasFixedCols) {
							i = td.index();
						}
						td = this._cur(td);
					}
					if (this._endEdit(e, 1)) {
						return 1;
					}
					if (!add) {
						// M.H. 6 Mar 2014 Fix for bug #166087: When column is fixed and another is hidden changing the editable cell with TAB key skips a cell after the hidden column.
						if (i === undefined || !hasFixedCols) {
						i = this._idForCol(td.col);
						}
						// restore td after _endEdit
						tds = (td.row < 0 || td.col < 0 || i < 0) ? null : td.tbl.children('tbody')[0];
						td = tds ? tds.childNodes[td.row] : null;
						if (td) {
							td = td.childNodes[i];
						}
						if (!td) {
							return;
						}
						td = $(td);
					}
				}
				if (!add && !this._checkRow(td.parent())) {
					return;
				}
				this._row_ = add ? -1 : this._prime(td);
				this._rowIndex = add ? -1 : this._row(td);
				if (!height) {
					height = td[0].offsetHeight;
				}
				if (add || o.editMode === 'row') {
					arg = { rowAdding: !!add, rowID: this._row_ };
					if (!this._fire('editRowStarting', e, arg)) {
						this._row_ = null;
						this._rowIndex = -3;
						return;
					}
					if (add) {
						this._adding = add;
						if (this._tdAddPrime) {
							i = this._gridCol(prime);
							val = this._defVal(prime, 1);
							this._tdAddPrime.html(i ? grid._renderCell(val, i) : val);
						}
						this._addTR.hide();
						this._newTR.show();
                        if (hasFixedCols) {
                            this.grid.fixedHeadersTable().find('thead tr[data-add-row]').hide();
                            this.grid.fixedHeadersTable().find('thead tr[data-new-row]').show();
                        }
						// synchronize horizontal scroll of header with horizontal scroll of grid-cells
						if (!this._addFixScroll) {
							this._addFixScroll = {
								scroll: function () {
									var cont = grid.scrollContainer()[0], left1 = cont ? cont.scrollLeft : -1, left2 = this.scrollLeft;
									if (!_aNull(left2) && left1 >= 0 && left1 !== left2) {
										cont.scrollLeft = left2;
									}
								}
							};
						}
						this._addTR.closest('div').bind(this._addFixScroll);
					}
					tds = td.parent().children();
					this._evt = e;
					if (hasFixedCols) {
						funcIterator = function (TDs) {
							for (i = 0; i < TDs.length; i++) {
								td = $(TDs[i]);
								// table cells for row selectors do NOT have  attr data-skip but are TH
								if (me._col(td) < 0 || TDs[i].offsetWidth < 3 || td.attr('data-skip') || td.is('th')) {
									continue;
								}
								td.addClass(me.css.editingCell);
								but = but || td;
								// set focus to TD under mouse
								// M.H. 5 Jul 2013 Fix for bug #146399: [Updating]When there are fixed columns and you click Add New Row in the fixed area the fixed editor is unfocused and focused again.
								if (me._startEdit(td, null, (e && td[0] === td0), add, height, me._isToggle(e) && td[0] === td0)) {
									v = 1;
									foc = null;
								}
							}
						};
						if (this.grid._isFixedElement(td)) {
							fixedTDs = tds;
							if (add) {
								unfixedTDs = this.grid.headersTable().find('thead tr:nth-child(' + (td.parent('tr').index() + 1) + ')').children();
							} else {
								unfixedTDs = this.grid.element.find('tbody tr:nth-child(' + (td.parent('tr').index() + 1) + ')').children();
							}
						} else {
							unfixedTDs = tds;
							if (add) {
								fixedTDs = this.grid.fixedHeadersTable().find('thead tr:nth-child(' + (td.parent().index() + 1) + ')').children();
							} else {
								fixedTDs = $('#' + this.grid.id() + '_fixed').find('tbody tr:nth-child(' + (td.parent().index() + 1) + ')').children();
							}
						}
						funcIterator(unfixedTDs);
						funcIterator(fixedTDs);
					} else {
					for (i = 0; i < tds.length; i++) {
						td = $(tds[i]);
						if (this._col(td) < 0 || tds[i].offsetWidth < 3) {
							continue;
						}
						td.addClass(this.css.editingCell);
						// set focus to TD under mouse
						if (this._startEdit(td, null, foc === 1 || (e && td[0] === td0), add, height, this._isToggle(e) && td[0] === td0)) {
							v = 1;
							foc = null;
							but = but || td;
						}
					}
					}
					delete this._evt;
					if (v && but && o.showDoneCancelButtons) {
						this._doButtons(but);
					}
					if (this._butDelete) {
						if (add) {
							this._butDelete.addClass(this.css.buttonDisabled);
						} else {
							this._butDelete.removeClass(this.css.buttonDisabled);
						}
					} 
					if (v) {
						_stop(e);
						this._fire('editRowStarted', e, arg);
					} else {
						tds.removeClass(this.css.editingCell);
					}
					// change active row and disable selection
					this._sel('act', but);
					// add-new-row may reduce height of TR: ensure that it is not less than height of editor
					if (add && v) {
						// note: Firefox fails to adjust its offsetHeight for padding and border??
						// so, use loop instead of if...
                        // M.H. 10 Jun 2013 Fix for bug #144244: When height is not defined and there is a fixed column clicking the "Add New Row" misaligns the fixed and unfixed area.
                        if (!this.grid._isFixedElement(td)) {
						while (height - this._newTR[0].offsetHeight > 0) {
							if (v) {
								v = null;
								td = $(tds[0]);
								// maximum adjustment/shift for height
								add = _int(td, 'paddingTop') + _int(td, 'paddingBottom') + _int(td, 'borderTopWidth') + _int(td, 'borderBottomWidth') + 1;
							}
							// for Firefox
							if (--add < 0) {
								break;
							}
							td.css('height', height - add);
						}
                        }
						v = 1;
					}
					return v;
				}
				// cell
				toggle = toggle || this._isToggle(e);
			}
			editor = this.editorForCell(td, 1);
			if (_aNull(this._row_) || !editor) {
				return;
			}
			width = td.outerWidth();
			if (!height) {
				height = td[0].offsetHeight;
			}
			arg = this._evtArg(td, editor, this._val(td, null, 1));
			if (!width || !height) {
				return;
			}
			if (!this._fire('editCellStarting', e || this._evt, arg)) {
				return "canceled";
			}
			this._hComboEdit(editor);
			width = this._lastTDWidth(td, width);
			// adjust width/height for shift of editor relative to the left-top corner of cell
			width -= this._xy.dx + 2;
			height -= this._xy.dy;
			if (e) {
				_stop(e);
				td.addClass(this.css.editingCell);
			}
			editor.prependTo(td);
			_filter(editor, 'setSize', Math.max(8, width), Math.max(10, height));
			if (!this._tds) {
				this._tds = {};
			}
			this._tds[this._key(td)] = td;
			v = _filter(editor, 'validator');
			if (v && v._setOption) {
				v._setOption('bodyAsParent', grid.options.fixedHeaders !== false || !grid.options.height);
			}
			_filter(editor, 'setValue', arg.value);
			editor._oldCellVal = _filter(editor, 'getValue');
			this._fire('editCellStarted', e || this._evt, arg);
			if (foc) {
				// scroll to and edit cell, delay of 100 ms can be not enough: request double setFocus in 300ms
				this._scrollTo(td, editor, false, focNoDelay ? false : 300, toggle);
			}
			if (e) {
				// change active row and disable selection
				this._sel('act', td);
			}
			return 1;
		},
		// return 1: keep editing
		// e: browser event, null, or 1-flag from endEdit
		// update: request to update grid
		// foc: request to take focus from editor
		_endEdit: function (e, update, foc) {
			var i, editor, val, key, td, arg, oldVals, stop,
				oldUpdate = update,
				eArg = e || 'undefined',
				add = this._adding,
				tr = null,
				argR = null,
				vals = null,
				tds = this._tds,
                hasFixedCols = this.grid.hasFixedColumns(),
				o = this.options;
			// prevent double processing of same event (user showed alert!)
			if (!tds || this._skip) {
				return;
			}
			if (e && e.type !== 'mousedown') {
				stop = e;
				_stop(stop);
			}
			// flag for row-editing and request to remove editingCell css
			i = add || o.editMode === 'row';
			if (!this._modified && !add) {
				update = false;
			}
			if (i) {
				// check if there is already error message
				for (key in tds) {
					if (tds.hasOwnProperty(key)) {
						td = tds[key];
						if (e && !_aNull(td)) {
							editor = this.editorForCell(td);
							if (oldUpdate && !_aNull(editor) && editor[0] && editor[0].offsetWidth && editor.igEditorFilter('hasInvalidMessage')) {
								if (!stop) {
									stop = e;
									_stop(stop);
								}
								// scroll to and set focus to editor
								this._scrollTo(td, editor, 1);
								return 1;
							}
						}
					}
				}
				// vals=object is a flag that instead of setCellValue, "vals"-container of changes should be filled
				// fill defaultValues for readOnly columns, because there are no editors for them and grid will not be updated with defaults
				vals = this._addReadOnly(add);
				oldVals = {};
				// trigger validation and check if values are valid
				for (key in tds) {
					if (tds.hasOwnProperty(key)) {
						td = tds[key];
						if (oldUpdate && !_aNull(td) && !_aNull(this.editorForCell(td))) {
							editor = this.editorForCell(td);
							vals[key] = _filter(editor, 'getValue');
							oldVals[key] = editor._oldCellVal;
							// true for 2nd param will prevent showing error message
							if (e && editor[0] && editor[0].offsetWidth && !_filter(editor, 'validate', !o)) {
								if (!stop) {
									stop = e;
									_stop(stop);
								}
								if (o) {
									// scroll to and set focus to editor
									this._scrollTo(td, editor, 1);
								}
								// flag for failed validation
								o = null;
							}
						}
					}
				}
				// row validation failed
				if (e && !o) {
					return 1;
				}
				if (add) {
					this._checkHidden(vals);
				}
				// prevent double processing of same event (user showed alert!)
				this._skip = 1;
				argR = { oldValues: oldVals, values: vals, rowID: this._row_, keepEditing: false, update: !!update, rowAdding: !!add };
				if (!this._fire('editRowEnding', eArg, argR)) {
					argR.update = update = oldUpdate = false;
				}
				delete this._skip;
				if (e && argR.keepEditing) {
					return 1;
				}
			}
			// remove editingCell from all TDs in editing row
			if (i) {
				this._td().parent().children().removeClass(this.css.editingCell);
                if (hasFixedCols) {
                    // M.H. 23 Aug 2013 Fix for bug #150138: The values in the fixed cells goes become misaligned when you enter in edit mode and click Cancel.
                    $('#' + this.grid.id() + '_fixed').find('tbody tr:nth-child(' + (this._td().parent().index() + 1) + ')').children().removeClass(this.css.editingCell);
			}
			}
			// tr-flag reference to TR if value of cell in row was modified
			tr = null;
			for (key in tds) {
				if (tds.hasOwnProperty(key)) {
					td = tds[key];
					if (!_aNull(td) && !_aNull(this.editorForCell(td))) {
						editor = this.editorForCell(td);
						// cell editing
						if (!vals) {
							if (e && oldUpdate && !_filter(editor, 'validate')) {
								if (!stop) {
									stop = e;
									_stop(stop);
								}
								// scroll to and set focus to editor
								this._scrollTo(td, editor, 1);
								return 1;
							}
							td.removeClass(this.css.editingCell);
						}
						// prevent double processing of same event (user showed alert!)
						this._skip = 1;
						// 1-hide buttons
						this._doButtons(1);
						val = _filter(editor, 'getValue');
						arg = this._evtArg(td, editor, val);
						arg.update = !!update;
						// S.S. Feb 25, 2014 - If we are updating, the new cell value should be tested
						// against the initial one to ensure the update event arg represents the actual behavior
						// afterwards (same values don't mod the transaction log)
						if (!this._adding) {
							arg.update = arg.update && !this._equals(this._getVal(this._row_, this._key(td)), val);
						}
						arg.oldValue = editor._oldCellVal;
						if (!vals) {
							arg.keepEditing = false;
						}
						if (!this._fire('editCellEnding', eArg, arg)) {
							arg.value = editor._oldCellVal;
						}
						if (oldUpdate && !vals && e && arg.keepEditing) {
							_stop(e);
							// scroll to and set focus to editor
							this._scrollTo(td, editor, 1);
							delete this._skip;
							return 1;
						}
						/* VS 07/18/2013 Bug 145543: before removing focus from editor, check if editor has focus */
						val = foc ? (editor.data('igEditor') || editor.data('igCombo') || editor.data('igRating')) : null;
						if (val && typeof val.hasFocus === 'function' && val.hasFocus()) {
							/* VS 02/11/2013 Bug 132463: dummy caret after end edit when grid-paging is enabled */
							try { editor.parent()[0].focus(); } catch (ignore) { }
							// original intention of "foc" was to set focus to grid with delay in ms, though, browser might scroll page if grid is tall: cant use logic like below
							//var me = this; setTimeout(function () { try { this.grid.element[0].focus(); } catch (ex) { } }, foc);
							foc = null;
						}
						editor.igEditorFilter('remove');
						val = arg.value;
						if (update && vals) {
							vals[key] = val;
						}
						// (tr!=null) flag that at least 1 cell in row was modified
						// _val will update vals: must keep it as 1st condition
						if (update && this._val(td, arg, vals) !== undefined && !tr && !this._equals(val, editor._oldCellVal)) {
							tr = td.parent()[0];
						}
						delete tds[key];
						this._fire('editCellEnded', eArg, arg);
						delete this._skip;
					}
				}
			}
			// prevent double processing of same event (user showed alert!)
			this._skip = 1;
			this._modified = this._prevEdit = this._tds = this._error = null;
			if (add) {
				this._addTR.closest('div').unbind(this._addFixScroll);
				this._addTR.show();
				this._newTR.hide();
                if (hasFixedCols) {
                    this.grid.fixedHeadersTable().find('thead tr[data-add-row]').show();
                    this.grid.fixedHeadersTable().find('thead tr[data-new-row]').hide();
                }
				this._adding = null;
				if (update && this._fire('rowAdding', eArg, argR)) {
					this._update(vals);
					// refresh selection
					this._sel('refresh');
					this._fire('rowAdded', eArg, argR);
				}
			} else if (tr) {
				this._update(this._row_, tr, vals);
			}
			this._fire('editRowEnded', eArg, argR);
			// remove pointers to currently editing rowIndex and rowKey
			this._rowIndex = -3;
			this._row_ = null;
			// enable selection
			this._sel('end', e);
			delete this._skip;
		},
		_scrollDiv: function () {
			var me = this, div = me._scrl, tbl = me.grid.element;
			if (div && me._sEvts) {
				return div;
			}
			me._scrl = div = tbl ? tbl.parent() : null;
			if (div && !me._sEvts && div.is('div')) {
				me._scrollX = div.scrollLeft;
				me._sEvts = {
					scroll: function (e) {
						me._onEvt(e, 9);
					}
				};
				div.bind(me._sEvts);
			}
			return div;
		},
		// td: reference to TD or column key
		// editor: reference to igEditor (null if td is key)
		// checkError: false/null/undefined-skip validation/adjustments for error message
		// delay: undefined, extra milliseconds to repeat set focus or false for no delay 
		// toggle: request to toggle checkbox
		_scrollTo: function (td, editor, checkError, delay, toggle) {
			var cur, rect, div, x, y, lbl, xy, shift, add = this._adding, errorWidth = 0, errorHeight = 0, foc = editor;
			// check if instead of td the column key is used and find td and editor
			if (!editor && typeof td === 'string') {
				td = this._tds ? this._tds[td] : null;
				if (!td) {
					return;
				}
				editor = this.editorForCell(td);
				if (!editor) {
					return;
				}
				checkError = 1;
			}
			// request to set focus to editor
			if (foc) {
				editor.igEditorFilter('setFocus', delay !== false ? 100 : false, toggle);
				// delay of 100 ms can be not enough: request to repeat setFocus
				if ($.type(delay) === "number") {
					editor.igEditorFilter('setFocus', delay);
				}
			}
			if (editor && checkError) {
				// get reference to error label used by validator
				lbl = _filter(editor, 'validator');
				lbl = lbl ? lbl._lbl : null;
				// if validator is external to td, then skip error label adjustments
				// validator._lbl[0]._width0/_height0 contains offsetWidth/Height of label before animation
				if (lbl && (add || td.has(lbl).length !== 0)) {
					errorWidth = lbl[0]._width0 || 80;
					errorHeight = lbl[0]._height0 || 18;
					cur = this._cur(td);
				}
			}
			div = this._scrollDiv();
			xy = td.offset();
			rect = div.offset();
			div = div[0];
			rect.w = div.clientWidth;
			rect.h = div.clientHeight;
			xy.w = td.outerWidth();
			xy.h = td.outerHeight();
			x = xy.left - rect.left;
			y = xy.top - rect.top;
			// adjust for width of validion error message
			if (errorWidth > xy.w) {
				// save original index of column
				delay = cur.col;
				shift = xy.w;
				errorWidth += 5;
				xy.w = errorWidth;
				// _nextTD sets "cur.td" to the TD located on right side from current td
				while (shift < errorWidth && this._nextTD(cur, 1)) {
					shift += cur.td[0].offsetWidth;
				}
				// condition when right edge of error label is outside of table
				shift -= errorWidth;
				if (shift < 0) {
					// do not allow left edge of error message outside of table
					xy.x += shift;
					if (xy.x < 0 && !add) {
						shift -= xy.x;
						xy.x = 0;
					}
					// L.A. 14 November 2012 - Fixing bug #127130
					// The validation message is shown below scrollbar of the grid.
					if (this.grid._hasVerticalScrollbar) {
						shift -= this.grid._scrollbarWidth();
					}
					// shift error message to right
					lbl.css('marginLeft', shift + 'px');
				}
			}
			// do not allow validion error message below table
			if (!add && errorHeight > 1 && cur.row > 1) {
				// restore original index of column
				cur.col = delay;
				errorHeight += 3;
				shift = errorHeight;
				// _nextTD sets "cur.td" to the TD located below current td
				while (shift > 0 && this._nextTD(cur, 0)) {
					shift -= cur.td[0].offsetHeight;
				}
				if (shift > 0) {
					// shift error message above cell
					lbl.css('marginTop', '-' + errorHeight + 'px');
					y -= errorHeight;
				}
			}
			if (div.nodeName !== 'DIV') {
				return;
			}
			if (x > 0) {
				x = Math.max(x + xy.w - rect.w, 0);
			}
			// check vertical visibility
			if (y > 0) {
				y = Math.max(y + errorHeight + xy.h - rect.h, 0);
			}
			// adjust scroll
			if (x !== 0) {
				this._hscroll()[0].scrollLeft += x;
			}
			if (!add && y !== 0) {
				div.scrollTop += y;
			}
		},
		// return 1: drop down (single row), -1: drop up (last row), 0: use calculations
		_upDown: function (td) {
			td = td.parent();
			// down
			if (td.prev().length < 1) {
				return 1;
			}
			// use calculations
			if (td.next().length > 0) {
				return 0;
			}
			td = this.grid.element;
			var par = td.parent()[0];
			// use calculations or up
			return (par && par.clientHeight - td[0].offsetHeight > 25) ? 0 : -1;
		},
		// minimum width of container where delete/done/cancel buttons are located (to calculate marginLeft of button)
		_minWidth: function (td, div) {
			var par = div[0];
			// if div a child of grid, then validate width of parent
			if (par.id.indexOf('_container') < 0 && div.parents('.ui-iggrid').length > 0) {
				par = div.parent()[0];
			}
			div = Math.min(div[0].clientWidth || div[0].offsetWidth, par.clientWidth || par.offsetWidth);
			return td ? Math.min(div, td.closest('table')[0].clientWidth) : div;
		},
		// td: 1-hide buttons, 2-remove buttons, [object]-parent TD for buttons, null-adjust scroll
		_doButtons: function (td) {
			var xyTD, xyBut, htBut, htTD, txt, div, cont, scroll, down, x,
				oldOverflow = this._oldOverflow,
				add = this._adding,
				css = this.css,
				grid = this.grid.element,
				hasHeight = !_aNull(this.grid.options.height),
				buts = this._buts;
			if (td === 1 || td === 2) {
				if (oldOverflow) {
					delete this._oldOverflow;
					oldOverflow.e.css('overflowX', oldOverflow.x).css('overflowY', oldOverflow.y);
				}
				if (buts) {
					buts.hide();
					if (td === 2) {
						buts.remove();
						this._buts = null;
					}
				}
				if (td === 2 && this._delBut) {
					this._delHover();
					this._delBut.remove();
					delete this._delBut;
				}
				return;
			}
			div = this._scrollDiv();
			if (td) {
				cont = hasHeight ? grid.parent() : grid.closest(".ui-iggrid");
				/* Bug 122934: temporary disable overflow of container */
				x = cont[0] ? Math.max(cont[0].scrollHeight, cont[0].offsetHeight) : -1;
				if (x >= 0 && x < 20) {
					this._oldOverflow = { e: cont, x: cont.css('overflowX'), y: cont.css('overflowY') };
					cont.css('overflowX', 'visible').css('overflowY', 'visible');
				}
				if (!buts) {
					buts = this._buts = $('<div />').css('position', 'absolute').addClass(css.buttonContainer).attr('unselectable', 'on');
					if (hasHeight) {
						buts.prependTo(cont);
					} else {
						buts.appendTo(cont);
					}
					// note: use _ti+1, because editors should get focus on external Tab before buttons
					this._butDone = x = $('<span />').addClass('done_id').addClass(css.button).addClass(css.doneButton).attr('unselectable', 'on').attr('tabIndex', this._ti + 1).attr('title', this._loc('done', 1)).appendTo(buts).bind(this._evts);
					$('<span />').css('display', 'inline-block').addClass(css.doneIcon).attr('unselectable', 'on').appendTo(x);
					txt = this._loc('done');
					if (txt) {
						$('<span />').css('display', 'inline-block').attr('unselectable', 'on').html(txt).appendTo(x);
					} else {
						x.addClass(css.buttonIconOnly);
					}
					this._butCancel = x = $('<span />').addClass(css.button).addClass(css.cancelButton).attr('unselectable', 'on').attr('tabIndex', this._ti + 1).attr('title', this._loc('cancel', 1)).appendTo(buts).bind(this._evts);
					$('<span />').css('display', 'inline-block').addClass(css.cancelIcon).attr('unselectable', 'on').appendTo(x);
					txt = this._loc('cancel');
					if (txt) {
						$('<span />').css('display', 'inline-block').attr('unselectable', 'on').html(txt).appendTo(x);
					} else {
						x.addClass(css.buttonIconOnly);
					}
					// add delete button here for touch environments
					if (this._renderTouchUI && this.options.enableDeleteRow) {
						this._butDelete = x = $("<span />")
							.addClass(css.button)
							.addClass(css.doneButton)
							.attr({
								"unselectable": "on",
								"tabIndex": this._ti + 1,
								"title": this._loc("deleteRow", 1)
							})
							.prependTo(buts);
						$("<span />").css("display", "inline-block").addClass(css.deleteIcon).attr("unselectable", "on").appendTo(x).css("left", 0).bind(this._evts);
						txt = this._loc("deleteRow", true);
						$("<span />").css("display", "inline-block").attr("unselectable", "on").html(txt).appendTo(x);
						x.css("float", "left");
						this._butCancel.css("float", "right");
						this._butDone.css("float", "right");
						buts.css("width", this._minWidth(td, div) - 6);
					}
					buts._height = buts[0].offsetHeight;
					buts._width = buts[0].offsetWidth;
				}
				this._tdelTR = td.parent();
			}
			if (!buts) {
				return;
			}
			// reset x/y location and adjust y location
			if (td) {
				x = Math.max(grid[0].offsetHeight, grid.parent()[0].offsetHeight);
				buts.show();
				if (add && this.findInvalid() === null) {
					this._butDone.removeClass(css.buttonDisabled);
				} else {
					this._butDone.addClass(css.buttonDisabled);
				}
				this._butsX = 0;
				buts.css({ marginLeft: this._butsX + 'px', marginTop: '0px' });
				xyBut = buts.offset();
				htBut = buts[0].offsetHeight;
				xyTD = td.offset();
				htTD = td[0].offsetHeight;
				xyTD.top -= xyBut.top;
				scroll = div[0].scrollTop;
				// compare available space below and above row
				// if (down>0), then dropDown, else dropUp
				down = add ? 1 : this._upDown(td);
				if (!down) {
					down = div[0].clientHeight + scroll - xyTD.top - htTD - 5 - htBut;
					if (down < 1 && down > xyTD.top - htBut - scroll - 5) {
						down = 1;
					}
				}
				down = down > 0 ? (xyTD.top + htTD + 5) : (xyTD.top - htBut - 5);
				// ensure that buttons do not overflow bounds of grid
				if (down + htBut > x) {
					if (down + htBut < x + 6) {
						down = x - htBut - 2;
					} else {
						down -= 10 + htBut + htTD;
					}
					down = Math.max(0, down);
				}
				buts.css({ marginTop: down + 'px' });
				// add-button and data are located in same TABLE
				this._butsY = (add && grid.has(this._addTR).length === 1) ? down : 0;
			}
			// adjust x location
			x = this._minWidth(td, div) - (buts.offset().left + buts._width + 3 - div.offset().left);
			if (this._renderTouchUI && this.options.enableDeleteRow) {
				x += 1;
			}
			if (x !== 0) {
				this._butsX += x;
				buts.css('marginLeft', this._butsX + 'px');
			}
			if (add && this.grid.options.fixedHeaders !== false) {
				buts.css('marginTop', (this._butsY + div[0].scrollTop + 2) + 'px');
			}
		},
		_isEditor: function (e) {
			var end, el, editor, key, td, tds = this._tds, o = this.options;
			if (!tds || _aNull(e)) {
				return;
			}
			td = this._findCell(e);
			if (td && o.editMode === 'row' && (this._row(td) === this._rowIndex)) {
				return 1;
			}
			end = this.grid.element[0];
			for (key in tds) {
				if (tds.hasOwnProperty(key)) {
					td = tds[key];
					if (td) {
						editor = this.editorForCell(td);
						if (editor) {
							el = e;
							editor = editor[0];
							while (el && el !== end) {
								if (el === editor) {
									return 1;
								}
								el = el.parentNode;
							}
						}
					}
				}
			}
		},
		// return jquery TD for active cell to start edit
		_aCell: function () {
			var td, i = -1, sel = this._sel('get');
			td = sel ? sel.activeCell() : null;
			if (td) {
				return td.element;
			}
			td = sel ? sel.activeRow() : null;
			if (td) {
				td = td.element.children("td:not([data-parent='true'],[data-skip='true'])");
				while (++i < td.length) {
					if (td[i].offsetWidth > 0) {
						return $(td[i]);
					}
				}
			}
		},
		// flag: "get"-return igGridSelection,
		//   "refresh"-refresh selection
		//   "wait"-return 1 if selection is enabled and td is not selected
		//   "end"-enable selection and raise sel._mouseDown(td)
		//   "act"-disable selection and activate selection
		// td: [object]-reference to jquery-TD (request to change active row/cell in selection)
		_sel: function (flag, td) {
			var i, obj, elem, sel = this.grid.element.data('igGridSelection');
			if (!sel || flag === 'get') {
				return sel;
			}
			if (flag === 'end') {
				delete sel._suspend;
				if (td && td.type === 'mousedown') {
					sel._mouseDown(td);
				}
				return;
			}
			if (flag === 'wait') {
				obj = sel.selectedRows();
				i = obj ? obj.length : 0;
				while (i-- > 0) {
					elem = obj[i].element;
					if (elem && elem.has(td).length) {
						return;
					}
				}
				obj = sel.selectedCells();
				i = obj ? obj.length : 0;
				while (i-- > 0) {
					elem = obj[i].element;
					if (elem && elem[0] === td[0]) {
						return;
					}
				}
				obj = sel.selectedRow();
				elem = obj ? obj.element : null;
				if (elem && elem.has(td).length) {
					return;
				}
				obj = sel.selectedCell();
				elem = obj ? obj.element : null;
				if (elem && elem[0] === td[0]) {
					return;
				}
				// M.H. 22 Aug 2013 Fix for bug #150024: When selection is enabled you can't enter in edit mode from the fixed area.
				if (this.grid.hasFixedColumns()) {
					obj = sel.selectedFixedRows();
					i = obj ? obj.length : 0;
					while (i-- > 0) {
						elem = obj[i].element;
						if (elem && elem.has(td).length) {
							return;
						}
					}
					obj = sel.selectedFixedCells();
					i = obj ? obj.length : 0;
					while (i-- > 0) {
						elem = obj[i].element;
						if (elem && elem[0] === td[0]) {
					return;
						}
					}
					// M.H. 5 Mar 2014 Fix for bug #166058: When Selection is enabled Updating's Edit Mode can't be started by clicking fixed columns.
					obj = sel.selectedFixedRow();
					elem = obj ? obj.element : null;
					if (elem && elem.has(td).length) {
						return;
				}
				}
				return 1;
			}
			if (flag === 'refresh') {
				return sel._refresh();
			}
			if (flag === 'act') {
				if (!td) {
					return;
				}
				sel._suspend = 1;
				if (!sel.options.activation) {
					return;
				}
				if (sel.options.mode === 'row') {
					sel._realActiveRow = { element: td.parent(), index: this._row(td) + this.grid._startRowIndex || 0, id: this._prime(td) };
					return sel._activateRow(sel._realActiveRow);
				}
				td = sel._cellFromElement(td[0], this._row(td), td.index());
				return sel._activateCell(td);
			}
		},
		_doDelete: function (e, tr) {
			var i, sel, arg;
			// delete-key
			if (!tr) {
				sel = this._sel('get');
				arg = sel ? sel.selectedRows() : null;
				for (i = 0; i < (arg ? arg.length : 0); i++) {
					this._doDelete(e, arg[i].element);
				}
				arg = sel ? sel.selectedRow() : null;
				if (arg) {
					this._doDelete(e, arg.element);
				}
			}
			arg = { element: tr, rowID: this._prime($(tr.children()[0])) };
			if (!tr || !this._fire('rowDeleting', e, arg)) {
				return;
			}
			this._delHover();
			this._update(arg.rowID, tr[0]);
			if (e) {
				// refresh selection
				this._sel('refresh');
			}
			this._fire('rowDeleted', e, arg);
			return 1;
		},
		_checkRow: function (tr) {
            var tbody;
			tr = (tr && tr.index() < this.grid.rows().length) ? tr[0] : null;
			/* OK 10/11/2011 90312 - added a check got the 'data-grouprow' addtribute to avoid updating on a group row. */
			/* DAY 10/11/2011 91369, 90338 - Making sure row is in tbody so summary and header rows don't show delete button */
			/* DAY 10/11/2011 90340 - TR should only be returned if event source is part of this grid's table. */
            //return (tr && tr.className.indexOf(this.grid.css.deletedRecord) < 0 && !$(tr).attr('data-grouprow') && $(tr).parent().is("tbody") && $(tr).parent()[0] === this.grid.element.find('tbody')[0]) ? tr : null;
			if (tr && tr.className.indexOf(this.grid.css.deletedRecord) < 0 && !$(tr).attr('data-grouprow') && $(tr).parent().is("tbody")) { 
                if (this.grid.hasFixedColumns() && $(tr).closest('div').attr('data-fixed-container')) {
                    tbody = $('#' + this.grid.id() + '_fixed').find('tbody');
                } else {
                    tbody = this.grid.element.find('tbody');
                }
                if ($(tr).parent()[0] === tbody[0]) {
                    return tr;
                }
            }
            return null;
		},
		_delHover: function (src) {
			var i, v, left, iBut, iTD, iDiv, iScroll, shift, xyBut, xyTD, div, tds, td, down,
				but = this._delBut,
				tr = this._delTR,
				hasFixedColumns = this.grid.hasFixedColumns(),
				css = this.css;
			if (but) {
				this._doHov(this._isSrc(but, src) ? but[0] : null, css.buttonHover);
			}
			if (src !== null && src !== undefined && hasFixedColumns) {
                if (this.grid._isFixedElement($(src))) {
                    src = this.grid.element.find('tbody tr[data-id="' + $(src).closest('tr').attr('data-id') + '"]');
                }
            }

			src = src ? this._checkRow($(src).closest('tr')) : null;
			if (src === tr || (!tr && !src) || (!but && !src)) {
				return;
			}
			this._delTR = src;
			if (!but) {
				this._delBut = but = $('<span />').css('position', 'absolute').addClass(css.deleteButton).attr('unselectable', 'on').attr('title', this._loc('deleteRow', 1));
				$('<span />').css('display', 'inline-block').addClass(css.deleteIcon).attr('unselectable', 'on').appendTo(but);
				v = this._loc('deleteRow');
				if (v) {
					$('<span />').css('display', 'inline-block').attr('unselectable', 'on').html(v).appendTo(but);
				}
			}
			// hide delete-button
			if (tr) {
				but.hide();
			}
			if (!src) {
				return;
			}
			// insert delete-button into new hover-td
			i = this._colShift(null, src) - 1;
			tds = src.childNodes;
			while (++i < tds.length) {
				if (tds[i].offsetWidth > 0) {
					break;
				}
			}
			src = tds[i];
			if (!src) {
				return;
			}
			td = $(src);
			div = this.grid.element.parent();
            // M.H. 5 Sep 2013 Fix for bug #146737: When the fixingDirection is "right" the delete button of the updating is not next to the vertical scrollbar.
			if (hasFixedColumns && 
                this.grid.element.data("igGridColumnFixing").options.fixingDirection === "right") {                
                div = this.grid.fixedBodyContainer();//this.grid.fixedContainer();
                //alert(div.attr('id'))
                td = div.find('tbody tr').eq(td.closest('tr').index()).find('td:last');
            }
			v = but[0].parentNode;
			// check if button has correct parent
			if (v !== div && v !== div[0]) {
				if (!v) {
					// mouseup: get around failure of igGridSelection to check for delete-button
					but.bind(this._evts).mouseup(function (e) { _stop(e); });
				}
				// attempt to get around Android when child is in TD and never gets its own events:
				// append delete-button to top DIV instead of TD
				but.prependTo(div);
			}
			but.css({ marginLeft: '0px', marginTop: '0px' }).show();
			xyBut = but.offset();
			xyTD = td.offset();
			iBut = but[0].offsetHeight;
			iTD = src.offsetHeight;
			shift = xyTD.top - xyBut.top;
			down = shift + Math.round((iTD - iBut) / 2);
			iScroll = div[0].scrollLeft;
			iDiv = this._minWidth(td, div);
			iBut = but[0].offsetWidth;
			left = iDiv + iScroll - iBut - _int(td, 'paddingLeft') - _int(td, 'borderLeftWidth') - 5;
			but.css({ marginTop: down + 'px', marginLeft: left + 'px' });
			// get around bugs in IE, if text-align is not left
			shift = iBut + but.offset().left - xyTD.left - iScroll - iDiv + 5;
			if (shift > 0) {
				but.css('marginLeft', (left - shift) + 'px');
			}
		},
		_isSrc: function (e, src) {
			if (e && src && (e[0] === src || e[0] === src[0] || e.has(src).length > 0)) {
				return e;
			}
		},
		_doHov: function (e, css) {
			var hov = this._hov;
			if (hov && css && hov.e[0] === e) {
				return 1;
			}
			if (hov) {
				hov.e.removeClass(hov.css);
			}
			if (css) {
				e = $(e);
				this._hov = { e: e, css: css };
				return e.addClass(css);
			}
			delete this._hov;
		},
		// attempt to get around fantom scrolling in Android and other touch
		// check(bool): return true if move is not allowed
		_noMove: function (check) {
			var x, y, div, id, noMove = this._nm;
			if (noMove === 1 || (check && !noMove)) {
				return;
			}
			if (!noMove) {
				id = this.grid.element[0].id;
				// scroll container
				div = $('#' + id + '_scroll');
				if (div.length !== 1) {
					div = $('#' + id + '_displayContainer');
				}
				if (!div.length) {
					this._nm = 1;
					return;
				}
			}
			// noMove.div/ex/ey used to speed up codes
			noMove = this._nm = this._nm || { x: 0, y: 0, div: div[0] };
			// possible horizontal scroller
			noMove.ex = noMove.ex || $('#' + id + '_hscroller')[0] || $('#' + id + '_horizontalScrollContainer')[0] || noMove.div;
			x = noMove.ex.scrollLeft;
			// possible vertical scroller
			noMove.ey = noMove.ey || $('#' + id + '_scrollContainer')[0] || noMove.div;
			y = noMove.ey.scrollTop;
			if (check) {
				// if grid was scrolled, then return true
				return Math.abs(noMove.x - x) > 1 || Math.abs(noMove.y - y) > 1;
			}
			noMove.x = x;
			noMove.y = y;
		},
		// process events
		// type: 1-mousedown, 2-click, 3-dblclick, 4-keydown, 5-focus, 6-blur, 7-mousemove, 8-mouseleave, 9-scroll, 11-touch
		_onEvt: function (e, type) {
			var td, cancel, done, addTD, tbody, but, next,
				me = this,
				now = _now(),
				touch = me._hovTouch,
				src = e ? e.target : null,
				k = e ? e.keyCode : 0,
				x = me._lastEvt, y,
				css = me.css,
				delBut = me._delBut,
				rdelBut = me._butDelete,
				newTR = me._newTR,
				addTR = me._addTR,
				tbl = me.grid.element,
				hasFixedCols = me.grid.hasFixedColumns(),
				o = me.options, editor, key,
				// touch ui specific
				touchX, scrollLeft, scrollWidth;
			// VS 05/14/2013 Bug 142105: skip mousedown on iOS if it comes after click
			// touchstart
			// click
			if (type === 2 && me._skipMD && now - me._skipMD < 999) {
				me._skipMD = now + 200;
			}
            // if it is clicked on fixed area
            if (hasFixedCols && $(src).closest('div').attr('data-fixed-container') !== undefined) {
                //tbl = $('#' + me.grid.id() + '_fixed');
                tbl = $(src).closest('table');
            }
			// mousedown
			if ((type === 1 && me._skipMD && me._skipMD - now > 0) || $.ig.util.evtButton(e)) {
				return;
			}
			if (o.excelNavigationMode === true && this._isEditor(src)) {
				td = this._findCell(src);
				//A.T. 10 July - Fix for bug #144612 - Script error is thrown on key navigation when ExcelNavigationMode is enabled
				if (td) {
					editor = this.editorForCell(td);
					if (!editor) {
						return;
					}
					editor = editor.data("igEditor") || editor.data("igCombo") || editor.data("igEditorFilter");
					key = this._keyForEditor(editor.element);
					if ($.ig.indexInArray([39, 37], k) >= 0) {
						if ((editor._old === null || editor._old === undefined) ||
							(editor._old !== null && editor._old !== undefined &&
							(editor.value() !== null && editor._old.toString() === editor.value().toString()) ||
							(Object.prototype.toString.call(editor._old) === "[object Date]" &&
							editor._old.toString() === this._val(td).toString()))) {
								if (this.options.editMode === "row" || this._isAdd(td)) {
									// tab key + row-editing
									next = this._nextEditor(key, k === 37 ? -1 : 0);
									if (next) {
										// scroll to and edit next cell in row
										this._scrollTo(next.parent(), next);
										return;
									}
									but = this._butDone;
									// if no Done/Cancel buttons, then start edit cell in another row
									if (!but || but[0].offsetWidth === 0) {
										this._nextEdit(e, k === 37 ? -1 : 0);
										return; 
									}
								} else {
								//Left arrow, to the left cell
								if (k === 37) {
									this._nextEdit(e, -1);
								}
								//Right arrow, to the right cell
								if (k === 39) {
									this._nextEdit(e, 1);
								}
								return;
							}
						}
					}
					//Arrow up, go on the upper row
					if (k === 38) {
						this._nextEdit(e, '-tr1', key);
						return;
					}
					//Arrow down, go on the next row
					if (k === 40) {
						this._nextEdit(e, 0, key);
						return;
					}
				}
			}
			// _13: skip enter/13 key
			if (!tbl || !src || ((type < 4 || k === 13) && (e.shiftKey || e.ctrlKey)) || (k === 13 && me._13)) {
				return;
			}
			// prevent navigation of browser to previous page on backspace
			if (k === 8 && src.readOnly) {
				_stop(e);
			}
			// Do not process same event twice.
			// Same events are attached to DIV and its children (buttons) and _onEvt can be called twice.
			// Some browsers (Android) may fail to process button events attached to DIV or to child, so, both handlers are needed.
			if (type !== 9 && x && x.src === src && x.type === type && x.x === e.pageX && x.y === e.pageY && now < x.now + 500) {
				return;
			}
			me._lastEvt = { src: src, now: now, type: type, x: e.pageX, y: e.pageY };
			if (type >= 11 && type !== 14) {
				// touch events
				touchX = e.originalEvent.touches && e.originalEvent.touches[0] ?
					e.originalEvent.touches[0].pageX : e.originalEvent.clientX;
				switch (type) {
					case 11:
						// touchstart|MSPointerDown|pointerDown
						// store start/current point
						me._firstTouchX = touchX;
						me._lastTouchX = touchX;
						// store row of first touch
						me._firstTouchRow = e.originalEvent.touches ?
							$(e.originalEvent.touches[0].target).closest("tr") :
							$(e.originalEvent.target).closest("tr");
						break;
					case 12:
						if (Math.abs(me._lastTouchX - me._firstTouchX) > parseInt(me.options.swipeDistance, 10) && me._firstTouchRow) {
							this._delHover();
							this._delHover(me._firstTouchRow);
						}
						delete me._firstTouchX;
						delete me._lastTouchX;
						delete me._firstTouchRow;
						break;
					case 13:
						// touchmove|MSPointerMove|pointerMove
						scrollLeft = me.grid.scrollContainer().scrollLeft() || 0;
						scrollWidth = me.grid.scrollContainer().width() || 0;
						// we'll cancel default behavior if the touch didn't produce any scrolling
						if ((touchX > me._lastTouchX && scrollLeft === 0) ||
							(touchX < me._lastTouchX && scrollLeft >= me.grid._hscrollbarinner().width() - scrollWidth)) {
							e.preventDefault();
						}
						// update current point if we have an active tracking
						if (me._firstTouchRow) {
							me._lastTouchX = touchX;
						}
						break;
				}
				return;
			}
			// 8-mouseleave
			if (type === 8) {
				if (touch) {
					return;
				}
				this._delHover();
				return this._doHov();
			}
			x = delBut ? me._isSrc(delBut, src) : null;
			y = rdelBut && !rdelBut.hasClass(me.css.buttonDisabled) ? me._isSrc(rdelBut, src) : null;
			tbody = tbl.find('tbody');
			// mousemove
			if (type === 7) {
				if (o.enableDeleteRow) {
					if (x) {
						delBut.addClass(me.css.buttonHover);
					} else {
						if (delBut) {
							delBut.removeClass(me.css.buttonHover);
						}
						this._delHover((this._tds || !this._isSrc(tbody, src) || this._noMove(true)) ? null : src);
					}
				}
				return;
			}
			if ((x || y) && (type < 4 || type === 14)) {
				if (((type === 2 && !($.ig.util.isIE && $.ig.util.browserVersion >= 10)) || type === 14) && (this._delTR || this._tdelTR)) {
					_stop(e);
					this._endEdit();
					if (this._doDelete(e, $(this._delTR || this._tdelTR))) {
						delete this._delTR;
						delete this._tdelTR;
					}
				}
				return;
			}
			addTD = addTR ? addTR.children()[addTR.children().length - 1] : null;
			if (k === 46) {
				return o.enableDeleteRow ? this._doDelete(e) : null;
			}
			// 9-scroll
			if (type === 9) {
				if (this._nm && !this._noMove(true)) {
					return;
				}
				this._delHover();
				x = src.scrollLeft;
				if (this._tds) {
					this._doButtons();
				}
				if (addTR && x !== this._scrollX) {
					$(addTD).css('paddingLeft', (this._addLeft + x) + 'px');
				}
				this._scrollX = x;
				return;
			}
			if (this._isSrc(addTR, src)) {
				if (!this._isSrc($(addTD), src)) {
					return;
				}
				this._delHover();
				src = addTD;
				if (type === 5) {
					return $(src).addClass(css.addRowActive);
				}
				if (type === 6) {
					return $(src).removeClass(css.addRowActive);
				}
				if (type === 7) {
					return this._doHov(src, css.addRowHover);
				}
				if (k === 32 || k === 13) {
					// add-new-row
					return this.startAddRowEdit(e);
				}
			}
			// 27-esc keydown
			if (k === 27) {
				return this._endEdit(e, null, 50);
			}
			// check if it is event coming from Done/Cancel buttons or their container
			done = this._isSrc(this._butDone, src);
			cancel = this._isSrc(this._butCancel, src);
			td = this._isSrc(this._buts, src);
			if (td || done || cancel) {
				// check for Done/Cancel buttons
				if (done || cancel) {
					if (type < 5) {
						_stop(e);
					}
					src = done || cancel;
					// type: 1-mousedown, 2-click, 3-dblclick, 4-keydown, 5-focus, 6-blur, 7-mousemove, 8-mouseleave, 9-scroll
					if (type === 2) {
						if (src.hasClass(css.buttonDisabled)) {
							return;
						}
						this._endEdit(e, done, 1);
					} else if (type === 7 && !src.hasClass(css.buttonDisabled)) {
						this._doHov(src[0], css.buttonHover);
					} else if (type === 5) {
						src.addClass(css.buttonActive);
					} else if (type === 6) {
						src.removeClass(css.buttonActive);
					} else if (k === 13 || k === 32) {
						this._endEdit(e, done, 1);
					} else if (k === 9) {
						if (e.shiftKey) {
							td = (done || this._butDone.hasClass(css.buttonDisabled)) ? null : this._butDone;
						} else {
							if (!td) {
								return;
							}
							td = this._butCancel;
						}
						if (td) {
							td[0].focus();
							return;
						}
						src = this._lastEditor();
						td = src ? src.parent() : null;
						if (td) {
							this._scrollTo(td, src);
						}
					}
				}
				return;
			}
			// newTR-flag to trigger addNewRow action
			// mouse events
			if (newTR && type < 4) {
				// mouse on add-row while editing
				if (this._isSrc(newTR, src)) {
					return;
				}
				// inside of AddNewRow label
                if (hasFixedCols && this.grid._isFixedElement($(src))) {
                    addTR = this.grid.fixedHeadersTable().find('thead tr[data-add-row]');
                }
				if (this._isSrc(addTR, src)) {
					// only click on AddNewRow can start edit mode
					if (type === 2) {
						if (o.editMode === 'rowedittemplate') {
							this._startEditRowTemplate(e, null, td, 1);
						} else {
							this.startAddRowEdit(e);
						}
					}
					return;
				}
			}
			// mousedown outside of grid-table
			if (type < 4 && !this._isSrc(tbody, src)) {
				// check for DIV
                // M.H. 11 Jun 2013 Fix for bug #144395: When you fix a column, fixedHeaders is false and click "Add new row" clicking in the editor of the fixed column cancels the adding.
                if (hasFixedCols && this.grid._isFixedElement($(src)) && !$(src).is('th') && !$(src).parent().is('th') && $(src).closest('div').attr('data-fixed-container') === tbody.closest('div').attr('data-fixed-container')) {
                    return;
                }
				if (this._tds && src !== tbl.parent()[0] && src !== this._div()[0] && src !== this._hscroll(1)[0]) {
					// header, footer, etc.
					this._endEdit(e);
				}
				return;
			}
			// 13-enter keydown
			if (k === 13) {
				this._nextEdit(e, 0);
				if (this._tds) {
					return;
				}
			}
			if (this._isEditor(src) || this._isEditor($(src).find("input")[0])) {
				return;
			}
			td = this._findCell(src);
			// stop editing
			// 1-mousedown, 2-click, 3-dblclick
			if (this._tds && type < 4 && (type > 1 || td)) {
				if (this._endEdit(e, this._adding ? null : 1)) {
					return;
				}
			}
			// mousedown
			if (type === 1) {
				// check if td is selected
				if (td && this._sel('get')) {
					this._waitSel = this._sel('wait', td);
				}
				return;
			}
			// start editing
			// 2-click, 3-dblclick
			x = o.editMode === 'cell';
			src = o.startEditTriggers;
			if (src && !this._tds && (x || (o.editMode === 'row' || o.editMode === 'rowedittemplate'))) {
				if (!src.toLowerCase) {
					src = src.toString();
				}
				src = src.toLowerCase();
				if ((k === 113 && src.indexOf('f2') >= 0) || (k === 13 && src.indexOf('enter') >= 0)) {
					td = this._aCell();
				} else if (src.indexOf(e.type) < 0 || (type === 2 && src.indexOf('dbl') >= 0)) {
					td = null;
				}
				if (touch && type < 3 && touch !== me._delTR) {
					// edit only row which has "delete" button
					return;
				}
				// if td is not require selection, then start editing
				if (td && (this._isToggle(e) || ((!this._waitSel || type === 4) && !this._sel('wait', td)))) {
					if (o.editMode === 'rowedittemplate' && td.parent().attr('data-grouprow') !== "true") {
						this._startEditRowTemplate(e, null, td);
						return;
					}
					if (this._startEdit(td, e, x)) {
						return;
					}
				}
			}
		},
		_startEditRowTemplate: function (e, tr, td, addNewRow) {
			var dialog = $('#' + this.grid.container().attr('id') + '_ret'), arg;
			tr = !_aNull(td) && td.parent().length > 0 ? td.parent() : tr;
			arg = { rowAdding: addNewRow ? true : false, rowID: addNewRow ? -1 : this._prime(td || tr.children().first()) };
			if (!this._fire("editRowStarting", e, arg)) {
				return;
			}
			if (this._checkRow(tr) || addNewRow) {
				if (dialog[0] === undefined) {
					this._renderRowEditDialog(e, tr);
				}
				if (this._openRowEditDialog(e, tr)) {
					this._fire("editRowStarted", e, arg);
					return 1;
				}
			}
			return 0;
		},
		_calcRowDialogLeftTop: function (dialog) {
			var left, top, pos, h, w, bh, dh, dw, bw,
				block = $('#' + this.grid.container().attr('id') + '_block_ret'),
				rootWidget, rootContainer, hScrollbar,
				cc, bc, tc;
			if (this.element.closest(".ui-iggrid-root").data('igHierarchicalGrid')) {
				rootWidget = this.element.closest(".ui-iggrid-root").data('igHierarchicalGrid').rootWidget();
			} else {
				rootWidget = this.grid;
			}
			rootContainer = rootWidget.container();
			hScrollbar = rootWidget.container().children("[id$='_hscroller_container']");
			pos = rootContainer.offset();
			left = pos.left;
			top = pos.top;
			if (block.outerWidth() !== rootContainer.outerWidth() || $.ig.util.isIE7 === true) {
				block.css('width', rootContainer.outerWidth());
			}
			if (block.outerHeight() !== rootContainer.outerHeight() || $.ig.util.isIE7 === true) {
				block.css('height', rootContainer.outerHeight() + ($.ig.util.isIE7 ? hScrollbar.height() : 0));
			}
			// hide any error messages that are shown
			$('#' + this.grid.container().attr('id') + '_dialog_error').hide();
			block.css({ left: 0, top: 0 }).fadeToggle();
			// show the actual dialog
			w = rootContainer.outerWidth();
			h = rootContainer.outerHeight();
			// calculate browser height and width, and if the grid's w  & h exceed the browser ones,
			// position the advanced filtering dialog
			// so that it can be seen on screen
			bw = $(window).width();
			bh = $(window).height();
			if (w + left > bw) {
				w = w - (w + left - bw);
			}
			if (w <= 0) {
				w = rootContainer.outerWidth();
			}
			if (h + top > bh) {
				h = h - (h + top - bh);
			}
			if (h <= 0) {
				h = rootContainer.outerHeight();
			}
			dh = parseInt(this.options.rowEditDialogHeight, 10);
			dw = parseInt(this.options.rowEditDialogWidth, 10);
			if (isNaN(dh) || dh <= 0) {
				dh = dialog.outerHeight();
			}
			if (isNaN(dw) || dw <= 0) {
				dw = dialog.outerWidth();
			}
			top = Math.max(parseInt(h / 2, 10) - dh / 2, 0);
			left = parseInt(w / 2, 10) - dw / 2;
			cc = dialog.children(".ui-dialog-content");
			tc = dialog.children(".ui-dialog-titlebar");
			bc = dialog.children(".ui-dialog-buttonpane");
			dialog.css({
				left: left,
				top: top,
				width: dw,
				height: dh
			});
			dialog.fadeToggle($.proxy(this._setResizableEnv, this));
			cc.css("height", dialog.height() - tc.outerHeight(true) - bc.outerHeight(true) - cc.outerHeight() + cc.height());
		},
		_getColumnSettingsByKey: function (colKey) {
			var i;
			for (i = 0; i < this.options.columnSettings.length; ++i) {
				if (this.options.columnSettings[i].columnKey === colKey) {
					return this.options.columnSettings[i];
				}
			}
			return null;
		},
		_doType: function (type, val) {
			if (type === 'text') {
				type = 0;
			}
			if (type === 'mask') {
				type = 1;
			}
			if (type === 'date') {
				type = 2;
			}
			if (type === 'datepicker') {
				type = 3;
			}
			if (type === 'numeric') {
				type = 4;
			}
			if (type === 'currency') {
				type = 5;
			}
			if (type === 'percent') {
				type = 6;
			}
			if (typeof type !== 'number' || type < 0 || type > 6) {
				if (typeof val === 'number') {
					type = 4;
				} else if (val && val.getMonth) {
					type = 2;
				} else {
					type = 0;
				}
			}
			this._type = type;
			return type;
		},
		_fillRowEditDialogTable: function (event_tr) {
			var tableBody, cols = this.grid.options.columns, i, tr, input, colVal, colSettings,
				newColSettings, colKey, templateData,
				rowEditDialogRowTemplate = this.options.rowEditDialogRowTemplate,
				rowEditDialogRowTemplateID = this.options.rowEditDialogRowTemplateID,
				buttonId = "#" + this.grid.container().attr("id") + "_igButton", parent;
			tableBody = $("#" + this.grid.container().attr("id") + "_ret table tbody");
			tableBody.empty();
			this._editors = this._editors || {};
			if (!event_tr) {
				this._adding = true;
			}
			for (i = 0; i < cols.length; ++i) {
				templateData = [];
				colKey = cols[i].key;
				colSettings = this._getColumnSettingsByKey(colKey);
				shouldAdd = colSettings === null ? true : false;
				colSettings = colSettings || {};
				if (event_tr) {
					colVal = this._getVal(this._fixPrime(event_tr.attr("data-id")), colKey);
				} else {
					colVal = this._defVal(colKey, true);
				}
				//Do not render columns when showReadonlyEditors is FALSE and the column is read only
				if ((colSettings && colSettings.readOnly && !this.options.showReadonlyEditors) || (cols[i].hidden)) {
					continue;
				}
				templateData.push({ headerText: cols[i].headerText, dataKey: colKey });
				if (rowEditDialogRowTemplateID) {
					tr = this._jsr ? $($('#' + rowEditDialogRowTemplateID).render(templateData)) :
						$($.ig.tmpl($('#' + rowEditDialogRowTemplateID).html().fullTrim(), templateData));
				} else if (rowEditDialogRowTemplate) {
					tr = this._jsr ? $($.render[this.grid.id() + "_rowEditDialogRowTemplate"](templateData)) :
						$($.ig.tmpl(this.options.rowEditDialogRowTemplate, templateData));
				} else {
					tr = $("<tr><td>" + cols[i].headerText + "</td><td data-key='" + colKey + "'><input /></td></tr>");
				}
				tr.appendTo(tableBody);
				input = $(tr.find(">td[data-key] input")[0]);
				// we need to change the editor element to textarea for multiline editors
				if (input.length && colSettings.editorOptions && colSettings.editorOptions.textMode === "multiline") {
					input.parent().append("<textarea />");
					input.remove();
					input = $();
				}
				if (!input.length) {
					input = $(tr.find(">td[data-key] textarea")[0]);
				}
				if (cols[i].dataType === "bool") {
					$.extend(true, colSettings, { editorOptions: { listItems: [true, false], button: "dropdown" } });
				}
				if (colSettings.readOnly) {
					$.extend(true, colSettings, { editorOptions: { readOnly: true } });
				}
				if (colSettings.editorOptions) {
					colSettings.editorOptions.width = _aNull(colSettings.editorOptions.width) ?
						this.options.rowEditDialogFieldWidth : colSettings.editorOptions.width;
				} else {
					colSettings.editorOptions = { width: this.options.rowEditDialogFieldWidth };
				}
				if (shouldAdd) {
					this.options.columnSettings.push($.extend(true, {}, colSettings, { columnKey: colKey }));
				}
				this._createEditor(event_tr ? event_tr.children().eq(i) : this._newTR.children().eq(i), colKey, input);
				this._editors[colKey] = input;
				_filter(input, "setValue", colVal);
			}
			$(buttonId).igButton("option", "disabled", true);
		},
		_openRowEditDialog: function (event, tr) {
			var dialog = $('#' + this.grid.container().attr('id') + '_ret'), noCancel, $this = this;
			noCancel = this._fire('rowEditDialogOpening', event, { dialogElement: dialog, owner: this });
			if (noCancel) {
				dialog.data('tr', tr);
				this._fillRowEditDialogTable(tr);
				this._calcRowDialogLeftTop(dialog);
				// focus dialog so that the dropdown closes (on blur), and the advanced dialog 
				//can be closed with the ESCAPE key 
				//This focus magic is needed for Chrome - Bug 121920
				setTimeout(function () {
					if (dialog.find('input')[0]) {
						dialog.find('input')[0].focus();
					} else {
						dialog.focus();
					}
					// fire opened event
					$this._fire('rowEditDialogOpened', event,
						{ dialogElement: dialog, owner: $this }
					);
				}, 100);
				if (event !== null && event !== undefined) {
					event.preventDefault();
					event.stopPropagation();
				}
				return 1;
			}
			return 0;
		},
		_renderRowEditDialog: function (e, tr) {
			var dialog, caption, dialogContent, noCancel, limit, f = this, okCancelContainer;
			dialog = $('<div></div>')
				.appendTo(this.grid._rootContainer())
				.attr('id', this.grid.container().attr('id') + '_ret')
				.css('position', 'absolute')
				.addClass(this.css.rowEditDialog)
				.data('efh', '1')
				.hide();
			dialog.data('tr', tr);
			noCancel = this._fire('rowEditDialogContentsRendering', e,
				{dialogElement: dialog, owner: f}
				);
			if (noCancel) {
				$('<div></div>')
					.appendTo(this.grid._rootContainer())
					.attr('id', this.grid.container().attr('id') + '_block_ret')
					.css('position', 'absolute')
					.addClass(this.css.blockArea)
					.data('efh', '1')
					.hide();
				caption = $('<div></div>').appendTo(dialog).addClass(this.css.rowEditDialogHeaderCaption);
				// add caption to the dialog
				$('<span></span>')
					.appendTo(caption)
					.text(this._loc("rowEditDialogCaption"))
					.addClass(this.css.rowEditDialogHeaderCaptionTitle);
				//Add close button
				$('<span></span>')
					.appendTo($('<a></a>')
						.appendTo(caption)
						.attr('href', '#')
						.attr('role', 'button')
						.addClass('ui-dialog-titlebar-close ui-corner-all'))
						.bind({click: $.proxy(this._closeRowEditDialog, this)})
						.addClass('ui-icon ui-icon-closethick');
				// L.A. 20 June 2012 Fixing bug #114456 Adding more filtering criteria forces the 
				//advanced search dialog to expand rather than show scrollbars
				dialogContent = $('<div></div>')
					.appendTo(dialog)
					.addClass('ui-dialog-content')
					.css('overflow', 'auto')
					.css('height', this.options.rowEditDialogContentHeight);
				$('<table><tbody></tbody></table>')
					.appendTo(dialogContent)
					.addClass(this.css.rowEditDialogTable);
				okCancelContainer = $('<div></div>')
					.appendTo($('<div></div>')
						.appendTo(dialog)
						.addClass(this.css.rowEditDialogOkCancelButton))
					.addClass('ui-dialog-buttonset');
				//Add Cancel button
				$('<button/>').appendTo(okCancelContainer)
					.igButton({labelText: this._loc('cancel'),
						width: this.options.rowEditDialogOkCancelButtonWidth}).bind({
						mousedown: $.proxy(this._closeRowEditDialog, this),
						// M.H. 7 Apr 2014 Fix for bug #169028: When grid is in a form, buttons in the grid modal dialogs like advanced filtering or column chooser submit the form when clicked
						click: function (e, args) {e.preventDefault();}
					});
				// Add Ok button
				$('<button/>').appendTo(okCancelContainer).igButton({labelText: this._loc('done'),
					disabled: true,
					width: this.options.rowEditDialogOkCancelButtonWidth}).bind({
					click: $.proxy(this._rowEditDialogDoUpdate, this)
				}).attr('id', this.grid.container().attr('id') + '_igButton');
				//A.T. 14 Feb 2011 - Fix for #64483
				// L.A. 13 June 2012 Fixing bug #114457 Advanced search filtering dialog cannot be 
				// dragged outside of the grid
				if (this._hc === true) {
					limit = $('#' + this.grid.element[0].id.split('_')[0] + '_container');
				} else if (this.options.rowEditDialogContainment === "owner") {
					limit = this.grid.container();
				} else {
					// M.H. 26 May 2014 Fix for bug #162225: Allow Users to Position the igGrid Advanced Filter Dialog Anywhere in Browser Window
					limit = 'document';
				}
				dialog
					.bind({
						keydown: function (e) {
							if (e.keyCode === $.ui.keyCode.ESCAPE) {
								f._closeRowEditDialog(e);
							}
						}
					})
					.draggable({
						containment: limit,
						handle: caption
					})
					.attr('role', 'dialog')
					.attr('tabIndex', -1);
				// M.H. 31 Oct 2012 Fix for bug #104800
				if (typeof Modernizr !== 'object' || Modernizr.touch === false) {
					// M.H. 26 May 2014 Fix for bug #162225: Allow Users to Position the igGrid Advanced Filter Dialog Anywhere in Browser Window
					dialog.resizable({ minHeight: dialog.outerHeight() / 4,
						minWidth: dialog.outerWidth() / 2,
						resize: $.proxy(this._resizeHandler, this)
					});
					// M.H. 9 June 2014 Fix for bug #173021: Resizing the edit template causes it to shrink when grid height is less.
					if (this.options.rowEditDialogContainment === 'owner') {
						dialog.resizable('option', 'containment', 'parent');
					}
				}
				this._fire('rowEditDialogContentsRendered', e,
					{dialogElement: dialog, owner: this});
			}
		},
		_setResizableEnv: function () {
			var e = $("#" + this.grid.container().attr('id') + "_ret"),
				rCont = e.find(">.ui-dialog-content"),
				hCont = e.find(">.ui-dialog-titlebar"),
				bCont = e.find(">.ui-dialog-buttonpane"),
				pad = rCont.outerHeight() - rCont.height();
			this._resizeCont = rCont;
			this._heightDifference = hCont.outerHeight(true) + bCont.outerHeight(true) + pad;
		},
		_resizeHandler: function (event, ui) {
			var u = ui.originalElement;
			//	rCont = u.find(".ui-dialog-content");
			this._resizeCont.css({
				height: (u.height() - this._heightDifference) + "px"
			});
		},
		_rowEditDialogDoUpdate: function (e) {
			var ret = $("#" + this.grid.container().attr("id") + "_ret"),
				tds = ret.find("table tbody [data-key]"),
				tr = ret.data("tr"),
				i,
				vals = {},
				oldvals = {},
				colKey,
				arg,
				rowID,
				addRow;
			if (this.findInvalid()) {
				return 0;
			}
			for (i = 0; i < tds.length; ++i) {
				colKey = tds.eq(i).attr("data-key");
				vals[colKey] = _filter(this._editors[colKey], "getValue");
				oldvals[colKey] = this._editors[colKey]._oldCellVal;
			}
			addRow = !(tr !== null && tr !== undefined && tr.length > 0);
			rowID = addRow ? -1 : this._prime(tr.children().first());
			arg = { 
				oldValues: oldvals,
				values: vals,
				rowID: rowID,
				keepEditing: false,
				update: true,
				rowAdding: addRow
			};
			if (!this._fire("editRowEnding", e, arg)) {
				return 0;
			}
			//Edit row
			if (!addRow) {
				this._update(tr.data().id, tr[0], vals);
			//Add new row
			} else {
				if (this._fire("rowAdding", e, arg)) {
					this._update(vals);
					this._fire("rowAdded", e, arg);
				}
			}
			this._fire("editRowEnded", e, arg);
			this._closeRowEditDialog(e);
			return 1;
		},
		_closeRowEditDialog: function (e) {
			var noCancel = true, dialog = $('#' + this.grid.container().attr('id') + '_ret');
			noCancel = this._fire('rowEditDialogClosing', e, { dialogElement: dialog, owner: this });
			if (noCancel) {
				$('#' + this.grid.container().attr('id') + '_block_ret').fadeToggle();
				$('#' + this.grid.container().attr('id') + '_ret').data('tr', null).fadeToggle();
				delete this._defValue;
				if (e) {
					e.preventDefault();
					e.stopPropagation();
				}
				delete this._editors;
				this._fire('rowEditDialogClosed', e,
					{dialogElement: dialog, owner: this});
				return 1;
			}
			return 0;
		},
		_lastEditor: function () {
			var key, last = this._prevEdit, all = this._editors;
			if (!last) {
				for (key in all) {
					if (all.hasOwnProperty(key)) {
						last = all[key] || last;
					}
				}
			}
			return last;
		},
		_end: function () {
			this._delHover();
			this._endEdit();
		},
		destroy: function () {
			/* Destroys igGridUpdating
			returnType="object" Returns reference to this igGridUpdating.
			*/
			var div = this._div(), grid = this.grid, el = grid.element;
			if (!this._evts || !el || !div) {
				return this;
			}
			this._hComboRemove(true);
			// 2-remove buttons
			this._doButtons(2);
			div.unbind(this._evts);
			if (this._renderTouchUI && this.options.editMode !== "row") {
				div.unbind(this._tEvts);
			}
			if (this._sEvts) {
				el.parent().unbind(this._sEvts);
			}
			el.unbind(this._gEvts);
			this._end();
            // M.H. 25 Jul 2013 Fix for bug #144635: When there are fixed columns the updating's destroy method does not remove the add new row and you can still enter in edit mode.
            if (grid.hasFixedColumns() && this._evts) {
                grid.fixedContainer().unbind(this._evts);
            }
			// remove addNewRow from header
			this._headerRendered(1);
			this._evts = this._sEvts = this._gEvts = null;
			$.Widget.prototype.destroy.call(this);
			if (this.options.editMode === "rowedittemplate") {
				$('#' + this.grid.container().attr('id') + '_block_ret').remove();
				$('#' + this.grid.container().attr('id') + '_ret').remove();
			}
			return this;
		},
		_hidingFinished: function () {
			this._headerRendered();
		},
		_hidingFinishing: function () {
			var key, shift, tr = this._addTR, grid = this.grid, edits = this._editors;
			if (!grid._initialized) {
				return;
			}
			this._endEdit();
			// 2-remove buttons
			this._doButtons(2);
			if (this._groupTD1) {
				this._groupTD1.remove();
				this._groupTD2.remove();
				delete this._groupTD1;
				delete this._groupTD2;
				// reset short-cut shifts in order properly calculate _colShift below
				this._cShift = this._cShiftAdd = -1;
			}
			if (tr) {
				shift = this._colShift(null, tr[0]);
				this._addTrShift = [];
				this._newTrShift = [];
				// save leading TRs/THs not related to columns
				while (shift-- > 0) {
					this._addTrShift[shift] = tr.children()[shift];
					this._newTrShift[shift] = this._newTR.children()[shift];
				}
				tr.remove();
				this._newTR.remove();
				if (this.grid.hasFixedColumns()) {
					this.grid.fixedHeadersTable()
						.find('thead tr[data-new-row], thead tr[data-add-row]').remove();
				}
			}
			for (key in edits) {
				if (edits.hasOwnProperty(key) && edits[key]) {
					edits[key].remove();
				}
			}
			this._newTR = this._addTR = this._editors = this._mapAdd = this._map = null;
			this._cShiftAdd = this._cShift = -1;
			this._hComboRemove();
		},
		// rerender modified cells
		_rerender: function (args) {
			var iTD, val, ta, row, cell, col, td, tds, key, grid = this.grid,
				tx = grid.pendingTransactions(), i = tx ? tx.length : 0,
				tbody = grid.element.children('tbody'), tmpl = grid.options.jQueryTemplating;
			/* DAY 17 OCT 2011 Fixed <90918> - When update a row in parent layout, rows in child layout are changed */
			if (args && args.owner && args.owner.id() !== grid.id()) {
				return;
			}
			while (i-- > 0) {
				ta = tx[i];
				cell = ta.type === 'cell';
				row = tbody.find('[data-id="' + ta.rowId + '"]');
				if (ta.type === 'row' || ta.type === 'newrow' || cell) {
					row.addClass(grid.css.modifiedRecord);
					tds = (row.length && !tmpl) ? row.children('td') : null;
					iTD = tds ? tds.length : 0;
					while (iTD-- > 0) {
						td = $(tds[iTD]);
						key = this._key(td);
						val = undefined;
						if (ta.row) {
							val = ta.row[key];
						} else if (cell && key === ta.col) {
							val = ta.value;
						}
						if (val !== undefined) {
							col = _aNull(key) ? null : this._gridCol(key);
							val = col ? grid._renderCell(val, col) : $.ig.formatter(val);
							td.html(val);
						}
					}
				}
				if (ta.type === 'deleterow' || ta.type === 'insertrow') {
					row.addClass(grid.css.deletedRecord);
                    $('#' + this.grid.id() + '_fixed').find('[data-id="' + ta.rowId + '"]').addClass(grid.css.deletedRecord);
				}
			}
		},
		// ensure that data has primary identifier
		// raise dataDirty event
		_bind: function (args) {
			var t1, t2, grid = this.grid, data = grid.dataSource._data, i = data ? data.length : 0,
				txNew = this.grid.dataSource.pendingTransactions(), len = txNew ? txNew.length : 0,
				txLast = this._txLast, lenLast = txLast ? txLast.length : 0;
			this._addRowNum = Math.max(this._addRowNum || 1, i + 1);
			this._endEdit();
			if (!args) {
				if (i && _aNull(grid.options.primaryKey) && _aNull(data[0].ig_pk)) {
					while (i-- > 0) {
						data[i].ig_pk = i;
					}
				}
				// databind for wrong/child/parent grid
			} else if (args.owner && args.owner.id() !== this.grid.id()) {
				return;
			}
			// no pending transactions
			if (len < 1) {
				return;
			}
			// check if event with current pending transactions was already once raised
			if (len === lenLast) {
				while (lenLast-- > 0) {
					t1 = txNew[lenLast];
					t2 = txLast[lenLast];
					if (t1.tid !== t2.tid || t1.value !== t2.value || t1.row !== t2.row) {
						break;
					}
				}
				// same transactions
				if (lenLast < 0) {
					return;
				}
			}
			// save current transactions
			txLast = this._txLast = [];
			while (len-- > 0) {
				txLast[len] = { tid: txNew[len].tid, value: txNew[len].value, row: txNew[len].row };
			}
			if (this._fire('dataDirty', this._evt || {}, {}) && this.options.enableDataDirtyException) {
				_throw('dataDirtyException');
			}
		},
		// replace number-string by number
		// if (ds), then it is request to return prime key for new row, in this case "key" is record with members
		_fixPrime: function (key, ds) {
			var grid = this.grid, o = grid.options, prime = o.primaryKey, primeType,
				col = _aNull(prime) ? null : this._gridCol(prime), data = grid.dataSource._data;
			if (ds) {
				if (!col) {
					key.ig_pk = ds = data.length;
					return ds;
				}
				// primary column can be hidden
				ds = key[prime];
				if (_aNull(ds)) {
					ds = key[prime] = this._defVal(prime, 1);
				}
				key = ds;
			}
			// S.S. September 9, 2013 - Bug #151572 Adding a check for the type of primaryKey so that keys can be
			// parsed even if the user does not specify data type of the primary key column
			primeType = data && data.length > 0 && !_aNull(data[0][prime]) ? typeof data[0][prime] : null;
			key = col && (col.dataType === "number" || col.dataType === "numeric" || primeType === "number") ? parseInt(key, 10) : key;
			if (!col && (!data[key] || data[key].ig_pk !== key)) {
				_throw('noPrimaryKeyException');
			}
			return key;
		},
		// get reference to data[id]
		_getRecord: function (id) {
			var i = -1, data = this.grid.dataSource._data, len = data.length, prime = this.grid.options.primaryKey;
			id = this._fixPrime(id);
			if (_aNull(prime)) {
				prime = 'ig_pk';
			}
			while (++i < len) {
				if (data[i][prime] === id) {
					return data[i];
				}
			}
		},
		// get value of cell including transactions
		_getVal: function (rowId, key) {
			var val, ta, grid = this.grid, tx = grid.dataSource.pendingTransactions(), i = tx ? tx.length : 0;
			while (i-- > 0 && val === undefined) {
				ta = tx[i];
				if (ta.rowId === rowId) {
					if (ta.row) {
						val = ta.row[key];
					} else if (ta.type === 'cell' && ta.col === key) {
						val = ta.value;
					}
				}
			}
			if (val === undefined) {
				rowId = this._getRecord(rowId);
				val = rowId ? rowId[key] : null;
			}
			return grid._fixDate(val, this._gridCol(key));
		},
		_childrenWithAddRowEnabled: function (opts, inheritedRule) {
			var i, j, cl, clr;
			if (opts.columnLayouts) {
				for (i = 0; i < opts.columnLayouts.length; i++) {
					cl = opts.columnLayouts[i];
					clr = inheritedRule || false;
					if (cl.features && cl.features.length > 0) {
						for (j = 0; j < cl.features.length; j++) {
							if (cl.features[j].name === "Updating") {
								clr = _aNull(cl.features[j].enableAddRow) ? clr : cl.features[j].enableAddRow;
								break;
							}
						}
					}
					if (clr) {
						return true;
					}
				}
			}
			return false;
		},
		// update grid with modified cell or row, delete row
		// if(col) set cell value
		// if(val) set cell or row value
		// if(!val) delete row
		// if(!tr) add row
		_update: function (rowId, tr, val, col, td) {
			var tx, i, vDiv, vScroll,
				del = val === undefined,
				grid = this.grid,
				oGrid = grid.options,
				autoCommit = oGrid.autoCommit,
				ds = grid.dataSource,
				hasFixedCols = this.grid.hasFixedColumns(),
				key = this._fixPrime(rowId, tr ? null : ds),
				fk = this.grid.options.foreignKey,
				virt = grid._virtualDom, cols, gridCol, nr, $tr, idx,
				updateObj = {}, recObj, groupedGrid, layoutKeys = [], tdContent;
			// L.A. 19 October 2012 - Fixing bug #124965 
			// In Update method when updating a row hidden columns have a value of null in transaction.row.
			// Get the full record from the datasource
			// Loop each property and append it, if it's missing in the updating/transaction object
			// This way the transaction will contain all fields/columns
			if (col && td) { //cell update mode
				updateObj[col] = val;
				recObj = jQuery.extend(true, {}, updateObj);
			} else {   // row update mode
				updateObj = jQuery.extend(true, {}, val);
				recObj = this.grid.findRecordByKey(rowId);
				if (recObj) {
					// L.A. 11 December 2012 - Fixing bug #129337 When LoadOnDemand = FALSE (initialDataBindDepth= -1) and editMode = row, 
					// updating an existing row causes the entire hierarchical JSON of the row's data record to be posted as a transaction
					if (grid.options.columnLayouts && grid.options.columnLayouts.length) {
						for (i = 0; i < grid.options.columnLayouts.length; ++i) {
							layoutKeys.push(grid.options.columnLayouts[i].key);
						}
					}
					$.each(recObj, function (prop, propVal) {
						if (updateObj && !updateObj.hasOwnProperty(prop) && ($.ig.indexInArray(layoutKeys, prop) === -1)) {
							updateObj[prop] = propVal;
						}
					});
				}
			}
			// note assignement to val is a dummy work around for jslint
			// M.H. 12 Jun 2013 Fix for bug #144399: Deleting a row and fixing a column breaks the zebra style of the records.
			if (del) {
				this._isRowDeleted = true;
			}
			if (tr) {
				if (del) {
					i = ds.deleteRow(rowId, autoCommit)
				} else {
					if (col) {
						i = ds.setCellValue(key, col, val, autoCommit)
					} else {
						i = ds.updateRow(key, updateObj, autoCommit);
					}
				}
			} else {
				// make sure to include the foreign key to the transaction if available
				if (fk && !rowId[fk]) {
					rowId[fk] = ds._origDs && ds._origDs.length > 0 ? ds._origDs[0][fk] : null;
				}
				i = ds.addRow(key, rowId, autoCommit);
			}
			// get around dataSource mixing of cell and row transactions
			tx = ds.pendingTransactions();
			i = tx ? tx.length : 0;
			while (i-- > 0) {
				if (rowId === tx[i].rowId) {
					// copy cell transaction to row
					if (tx[i].row && col) {
						tx[i].row[col] = val;
					}
					break;
				}
			}
			// note: if grid is virtual, then this._renderRow can not be used, because of virtually scrolled columns
			// M.H. 14 Mar 2013 Fix for bug #135845: Updating a record with a rowId of 0 causes the grid to rerender
			if (!del && (virt || (autoCommit && (rowId === null || rowId === undefined || recObj === null || recObj[grid.options.primaryKey] === null)))) {
				vDiv = $('#' + grid.id() + (virt ? '_scrollContainer' : '_scroll'))[0];
				vScroll = vDiv ? vDiv.scrollTop : 0;
				// VS 08/14/2012 Bug 118764: igGridSelection fails after _rerenderVirtualRecordsContinuous
				if (virt && oGrid.virtualizationMode === "continuous") {
					grid._rerenderVirtualRecordsContinuous();
				}
				if (virt && oGrid.virtualizationMode === "fixed") {
					grid._renderVirtualRecords();
				}
				if (vScroll) {
					vDiv.scrollTop = vScroll;
				}
				if (virt) {
					grid._onVirtualVerticalScroll();
				}
				return;
			}
			// L.A. 28 August 2012 - Fixing bug #118740 Scrolling position and state of expanded rows are not 
			// retained if grid is updated when columns are grouped by.
			// L.A. 28 December 2012 - Fixing bug #129692 
			// When autoCommit = TRUE, changing the value of the primary key column causes the row to be rendered without values; 
			// when you enter edit mode on that row again, the editors are also blank
			// L.A. 17 January 2013 - Fixing bug #130781 Error occurs when adding a row to an empty grid with column
			// template and more than one hidden columns
			if (autoCommit && grid.options.primaryKey && recObj && recObj[grid.options.primaryKey]) {
				// M.H. 12 Jun 2013 Fix for bug #144533: The updating throws an error if you edit a fixed cell and after that enter in edit mode from the unfixed area and edit cell there.
				if (hasFixedCols) {
					if (grid._isFixedElement($(tr))) {
						this.grid.element.find('tbody tr[data-id="' + tr.getAttribute('data-id') + '"]')
							.data('id', recObj[grid.options.primaryKey])
							.attr('data-id', recObj[grid.options.primaryKey]);
					} else {
						$('#' + grid.id() + '_fixed').find('[data-id="' + tr.getAttribute('data-id') + '"]')
							.data('id', recObj[grid.options.primaryKey])
							.attr('data-id', recObj[grid.options.primaryKey]);
					}
				}
				$(tr).data('id', recObj[grid.options.primaryKey]);
				$(tr).attr('data-id', recObj[grid.options.primaryKey]);
			}
			if (!tr) {
				groupedGrid = grid.element.children('tbody').children('tr.ui-iggrid-groupedrow').length > 0;
				tr = groupedGrid === true ? grid.element.data("igGridGroupBy")._renderNewRow(rowId, key) : grid.renderNewRow(rowId, key);
				tr = grid.element.children('tbody').children('tr');
				tr = tr[tr.length - 1];
				// prepare default value of primaryKey for next add
				if (!oGrid.virtualization && !oGrid.rowVirtualization) {
					this._addRowNum++;
				}
				delete this._defValue;
				this._trigger("internalrowadded", null, { owner: this });
			} else {
				if (del) {
					// L.A. 24 October 2012 - Fixing bug #125209 
					// The deleted row is shown with a cross line when autoCommit = true
					if (autoCommit) {
						// S.S. June 6, 2013 - Fix for bug #143729 Implementing virtualization support!
						if (oGrid.virtualization || oGrid.rowVirtualization) {
							if (oGrid.virtualizationMode === 'continuous') {
								grid._rerenderVirtualRecordsContinuous();
							} else {
								if (this.grid._startRowIndex + this.grid._virtualRowCount === this.grid._totalRowCount) {
									this.grid._startRowIndex = Math.max(0, this.grid._startRowIndex - 1);
								}
								this.grid._totalRowCount--;
								if (this.grid._virtualRowCount > this.grid._totalRowCount) {
									grid._buildVirtualDom();
								} else {
									grid._renderVirtualRecords();
									this.grid._setScrollContainerHeight(this.grid._totalRowCount * parseInt(this.grid.options.avgRowHeight, 10));
								}
							}
							tr = null;
							// M.H. 3 Jul 2013 Fix for bug #144681: Scrollbar misbehaves when there’s a small number of records.
							//A.T. 15 Jul - this is no longer needed since i am calling it inside buildVirtualDom / renderVirtualRecordsContinuous. 
							//grid._updateVirtualScrollContainer();
						} else {
							// S.S. July 18, 2013 Bug #147061 When autoCommit is true deleting a parent row should delete
							// any open child grids for it
							$tr = $(tr);
							idx = $tr.parent().children(":not([data-container],[data-grouprow])").index(tr);
							nr = $tr.next("tr[data-container='true']");
							$tr.remove();

							if (nr.length === 1) {
								nr.remove();
							}
							if (hasFixedCols) {
								$('#' + this.grid.id() + '_fixed').find('[data-id="' + $(tr).attr('data-id') + '"]').remove();
								this.grid.element.data("igGridColumnFixing")._syncContainerHeights();
							}
							this.grid._reapplyZebraStyle(idx);
						}
						// L.A. 24 January 2013 - Fixing bug #130620 totalRecordsCount is inaccurate when adding or deleting rows
						this._trigger("internalrowdeleted", null, { owner: this });
					} else if (hasFixedCols) {
						// M.H. 11 Jun 2013 Fix for bug #144310: When autoCommit is true and there is a fixed column deleting a row does not remove the cells from the fixed area.
						$('#' + this.grid.id() + '_fixed').find('[data-id="' + $(tr).attr('data-id') + '"]').addClass(grid.css.deletedRecord);
					}
					return $(tr).addClass(grid.css.deletedRecord);
				}
				cols = oGrid.columns;
				// get latest values for a row
				// S.S. February 7, 2014 - We need to render the row even if we are in cell selection
				// because some cells rendering might depend on others
				val = {};
				rowId = recObj && !_aNull(recObj[grid.options.primaryKey]) ? recObj[grid.options.primaryKey] : rowId;
				i = cols.length;
				while (i-- > 0) {
					key = cols[i].key;
					val[key] = this._getVal(rowId, key);
				}
				// update the UI (DOM), rowId is a request to fix css
				// if tr==1, then row is out of view: do not repaint
				val = tr !== 1 ? grid._renderRow(col && td ? val : updateObj, tr, rowId) : null;
				if (!_aNull(val)) {
					tr = val;
				}
			}
			// if tr==1, then row is out of view: do not repaint
			// L.A. 28 August 2012 - Fixing bug #118740 Scrolling position and state of expanded rows are not 
			// retained if grid is updated when columns are grouped by.
			if (tr && tr !== 1 && !autoCommit) {
				// M.H. 11 Jun 2013 Fix for bug #144306: When you edit a row and there is fixed column only the row that the editing was started from gets the ui-iggrid-modifiedrecord style.
				if (hasFixedCols) {
					if (grid._isFixedElement($(tr))) {
						this.grid.element.find('tbody tr[data-id="' + tr.getAttribute('data-id') + '"]').addClass(grid.css.modifiedRecord);
					} else {
						$('#' + this.grid.id() + '_fixed').find('[data-id="' + tr.getAttribute('data-id') + '"]').addClass(grid.css.modifiedRecord);
					}
				}
				$(tr).addClass(grid.css.modifiedRecord);
			}
		},
        // when user fix column then bind to fixed area events(if it is not bound event)
        // on unfixing columns unbind event
		_columnFixed: function (args) {
			this._cfUpdateDataSkipRows(args);
			if (args.isFixed) {
				if (args.isInit) {
					this.grid.fixedContainer().bind(this._evts);
					// M.H. 24 Jun 2013 Fix for bug #144619: When enableAddRow is false and you fix a column you can't enter in edit mode.
					if (this.options.enableAddRow) {
						this._newTR = this.grid.headersTable().find('thead tr[data-new-row]');
					}
					// M.H. 12 Jun 2013 Fix for bug #144399: Deleting a row and fixing a column breaks the zebra style of the records.
					if (this._isRowDeleted) {
						this.grid.element.data("igGridColumnFixing")._syncRowStyles();
					}
				}
			}
			this._mapAdd = null;
		},
		// update data-skip rows like new row and add row when columnFixing is triggered(on fix/unfix column)
		_cfUpdateDataSkipRows: function (args) {
			if (args.visibleIndex === -1) {
				return;
			}
			var $td, colspan,
				visibleIndex = args.visibleIndex,
				isDataSkip = (args.colInd === -1),
				$unfixedTR = this.grid.headersTable().find('thead tr[data-new-row]'),
				$fixedTR = this.grid.fixedHeadersTable().find('thead tr[data-new-row]');
			if (args.isFixed) {
				if (isDataSkip) {
					$unfixedTR.find('[data-skip]:nth-child(1)').detach().appendTo($fixedTR);
					// apply the same for add row
					$unfixedTR = this.grid.headersTable().find('thead tr[data-add-row]');
					$fixedTR = this.grid.fixedHeadersTable().find('thead tr[data-add-row]');
					$unfixedTR.find('[data-skip]:nth-child(1)').detach().appendTo($fixedTR);
				} else {
					$td = $unfixedTR.find('td:nth-child(' + visibleIndex + ')');
					$td.detach().appendTo($fixedTR);

					$unfixedTR = this.grid.headersTable().find('thead tr[data-add-row]');
					$fixedTR = this.grid.fixedHeadersTable().find('thead tr[data-add-row]');
					$td = $unfixedTR.find('td[colspan]').eq(0);
					colspan = parseInt($td.attr('colspan'), 10);
					$td.attr('colspan', colspan - 1);
					if ($fixedTR.find('td[colspan]').length === 0) {
						$td.clone()
							.appendTo($fixedTR)
							.attr('colspan', 1);
					} else {
						$td = $fixedTR.find('td[colspan]');
						colspan = parseInt($td.attr('colspan'), 10);
						$td.attr('colspan', colspan + 1);
					}
				}
			} else {
				if (isDataSkip) {
					$fixedTR.find('[data-skip]:last-child').detach().prependTo($unfixedTR);
					$unfixedTR = this.grid.headersTable().find('thead tr[data-add-row]');
					$fixedTR = this.grid.fixedHeadersTable().find('thead tr[data-add-row]');
					$fixedTR.find('[data-skip]:last-child').detach().prependTo($unfixedTR);
				} else {
					$td = $fixedTR.find('td:nth-child(' + visibleIndex + ')');
					$td.detach().prependTo($unfixedTR);

					$unfixedTR = this.grid.headersTable().find('thead tr[data-add-row]');
					$fixedTR = this.grid.fixedHeadersTable().find('thead tr[data-add-row]');
					$td = $fixedTR.find('td[colspan]').eq(0);
					colspan = parseInt($td.attr('colspan'), 10);
					if (colspan - 1 === 0) {
						$td.remove();
					} else {
						$td.attr('colspan', colspan - 1);
					}
					$td = $unfixedTR.find('td[colspan]');
					colspan = parseInt($td.attr('colspan'), 10);
					$td.attr('colspan', colspan + 1);
				}
			}
		},
		_addDSSuccessHandler: function () {
			// remove the existing save changes success handler from the data source (if any) and after that adds saveChangesSuccessHandler
			var me = this, fS, grid = me.grid;
			if (me._addChangesSuccessHandler !== null && me._addChangesSuccessHandler !== undefined) {
				grid.dataSource._removeChangesSuccessHandler(me._addChangesSuccessHandler);
			}
			// M.H. 17 Feb 2014 Fix for bug #153639: Add successCallback and errorCallback params to the igDataSource.saveChanges API
			fS = me.options.saveChangesSuccessHandler;
			if (fS) {
				if ($.type(fS) === 'string' && window[fS] && $.type(window[fS]) === 'function') {
					fS = window[fS];
				}
			}
			if ($.type(fS) !== 'function') {
				fS = null;
			}
			me._addChangesSuccessHandler = function (data) {
				if (data.Success) {
					// if there are deleted rows, then whole grid should be repainted, because of zebra styles
					if (grid.rows().parent().find('.' + grid.css.deletedRecord).length) {
						grid._renderData();
					}
					grid.rows().removeClass(grid.css.modifiedRecord);
					if (fS) {
						fS(data);
					}
				}
			};
			/* DAY 18 OCT 2011 90177- When call saveChanges the rows should not be marked as dirty */
			grid.dataSource._addChangesSuccessHandler(me._addChangesSuccessHandler);
		},
        _addDSErrorHandler: function () {
			// remove the existing save changes error handler from the data source (if any) and after that adds saveChangesErrorHandler if defined in options
			var me = this, fE, grid = me.grid;
			if (me._addChangesErrorHandler !== null && me._addChangesErrorHandler !== undefined) {
				grid.dataSource._removeChangesErrorHandler(me._addChangesErrorHandler);
			}
			// M.H. 17 Feb 2014 Fix for bug #153639: Add successCallback and errorCallback params to the igDataSource.saveChanges API
			if (me.options.saveChangesErrorHandler) {
				fE = me.options.saveChangesErrorHandler;
				if ($.type(fE) === 'string' && window[fE] && $.type(window[fE]) === 'function') {
					fE = window[fE];
				}
				if ($.type(fE) === 'function') {
					me._addChangesErrorHandler = function (jqXHR, textStatus, errorThrown) {
					fE(jqXHR, textStatus, errorThrown);
					};
					grid.dataSource._addChangesErrorHandler(me._addChangesErrorHandler);
				}
			}
		},
		// every grid feature widget should implement this 
		_injectGrid: function (grid) {
			var me = this, hg, cl, opts = me.options;
			// initialize options.css
			me.grid = grid;
			me._cShiftAdd = me._cShift = -1;
			if (me._gEvts !== undefined && me._gEvts !== null) {
				grid.element.unbind(this._gEvts);
			}
			// process iggridheaderrendered and headerRendered events of grid
			me._gEvts = {
				iggridvirtualrendering: function () { me._end(); },
				ighierarchicalgridrowexpanded: function () { me._end(); },
				iggriddatabinding: function (e, args) { me._bind(args); },
				// L.A. 31 October 2012 - Fixing bugs #122460, 125562 
				// args are missing so the code below in bind doesn't work:
				// databind for wrong/child/parent grid
				iggriddatarendering: function (e, args) { me._bind(args); },
				iggridrowsrendering: function (e, args) { me._bind(args); },
				iggriduidirty: function () { me._end(); },
				iggridresizingcolumnresizing: function () { me._end(); },
				iggridvirtualrecordsrender: function (e, args) { me._rerender(args); },
				iggridrowsrendered: function (e, args) { me._rerender(args); }
			};
			if (this.options.enableAddRow) {
				me._gEvts.iggridheaderrenderedinternal = function () { me._headerRendered(); };
				me._gEvts.iggridheaderextracellsmodified = function () { me._headerInit(); };
			}
			// L.A. 12 June 2012 Fixing bug #113919 The columns shift to the left on edit mode.
			//me._gEvts.iggridgroupbygroupedcolumnschanged = function (e, args) { me._groupedColumnsChanged(args); };
			grid.element.bind(this._gEvts);
			me._ti = parseInt(grid.options.tabIndex || 1, 10);
			me._evts = {
				// igGridSelection may suppress mousedown event
				iggridselectionmousedown: function (e) { me._onEvt(e, 1); },
				mousedown: function (e) { me._onEvt(e, 1); },
				click: function (e) { me._onEvt(e, 2); },
				dblclick: function (e) { me._onEvt(e, 3); },
				keydown: function (e) { me._onEvt(e, 4); },
				focus: function (e) { me._onEvt(e, 5); },
				blur: function (e) { me._onEvt(e, 6); },
				mousemove: function (e) { me._onEvt(e, 7); },
				mouseleave: function (e) { me._onEvt(e, 8); },
				MSPointerUp: function (e) { me._onEvt(e, 14); },
				pointerup: function (e) { me._onEvt(e, 14); }
			};
			me._tEvts = {
				touchstart: function (e) { me._onEvt(e, 11); },
				touchend: function (e) { me._onEvt(e, 12); },
				touchmove: function (e) { me._onEvt(e, 13); }
			};
            // M.H. 18 Feb 2014 Fix for bug #153639: Add successCallback and errorCallback params to the igDataSource.saveChanges API
			me._addDSSuccessHandler();
			me._addDSErrorHandler();
			if (me.grid.options._isHierarchicalGrid && me.grid._originalOptions) {
				// we'll flag the grid if enableAddRow is true for at least one child layout
				// this flag will be used to enable expanding of new rows added in this layout even
				// if they don't contain any data in their child layout properties
				if (opts.inherit) {
					me.grid._shouldAlwaysRenderChildIndicator = me._childrenWithAddRowEnabled(me.grid.options, opts.enableAddRow);
				} else {
					me.grid._shouldAlwaysRenderChildIndicator = me._childrenWithAddRowEnabled(me.grid.options);
				}
				// we also need to add layouts to the data schema for the child data sources 
				// in this way we will know which properties to add empty collections for when adding rows
				if (!me.grid.dataSource.settings.schema.layouts) {
					hg = me.grid.element.closest('.ui-iggrid-root').data('igHierarchicalGrid');
					cl = [];
					hg._parseLayouts(cl, "", me.grid._originalOptions);
					me.grid.dataSource.settings.schema.layouts = cl;
				}
			}
			this._renderTouchUI = typeof Modernizr === "object" && Modernizr.touch === true;
			if (window.navigator.msPointerEnabled || window.navigator.pointerEnabled) {
				me.grid.element.css("-ms-touch-action", "none");
			}
			if (String(grid.options.templatingEngine).toLowerCase() === "jsrender") {
				this._jsr = true;
				if (opts.rowEditDialogRowTemplate && typeof opts.rowEditDialogRowTemplate === "string") {
					$.templates(this.grid.id() + "_rowEditDialogRowTemplate", opts.rowEditDialogRowTemplate);
				}
			}
		}
	});
	$.extend($.ui.igGridUpdating, { version: '14.1.20141.2249' });

	$.widget('ui.igEditorFilter', {
		setFocus: function (delay, toggle) {
			var provider = this.options.provider;
			if (delay && $.type(delay) === "number" && delay > 0) {
				setTimeout(function () { provider.setFocus(toggle); }, delay);
			} else {
				provider.setFocus(toggle);
			}
		},
		remove: function () {
			if (!this.options.provider.removeFromParent()) {
				var p, e = this.element;
				p = e[0].parentNode;
				if (p && p.tagName) {
					p.removeChild(e[0]);
				}
				e = this.validator();
				if (e) {
					e.hide();
				}
			}
		},
		validator: function () {
			return this.options.provider.validator();
		},
		hasInvalidMessage: function () {
			var validator = this.validator();
			return validator ? validator.isMessageDisplayed() : false;
		},
		destroy: function () {
			this.options.provider.destroy();
		}
	});
	$.extend($.ui.igEditorFilter, { version: '14.1.20141.2249' });
	// editor providers
	$.ig.EditorProvider = $.ig.EditorProvider || Class.extend({
		createEditor: function (updating, key, columnSetting, tabIndex, format, dataType, cellValue, element) { return null; },
		getValue: function () { return ""; },
		setValue: function (val, updating) { return false; },
		setFocus: function (toggle) { return null; },
		setSize: function (width, height) { return null; },
		removeFromParent: function () { return false; },
		destroy: function () { return this; },
		validator: function () { return null;},
		validate: function (noLabel) {
			var validator = this.validator();
			return validator ? !validator.validate() : true;
		},
		keepFocus: function () {
			var validator = this.validator(), foc = validator ? validator._foc1(validator.options) : false;
			if (!foc) {
				return false;
			}
			if (foc === 2) {
				return true;
			}
			foc = validator && !validator._focTime;
			validator._focTime = new Date().getTime();
			return foc;
		},
		isValid: function () {
			var validator = this.validator();
			return validator ? validator.isValidState() : true;
		}
	});
	$.ig.EditorProviderDefault = $.ig.EditorProviderDefault || $.ig.EditorProvider.extend({
		createEditor: function (updating, key, columnSetting, tabIndex, format, dataType, cellValue, element) {
			var v, o = {};
			if (columnSetting) {
				o = columnSetting.editorOptions || o;
				o.type = columnSetting.editorType || o.type;
			}
			v = o.type;
			//A.T. make sure we pass the value of enableUTCDates to any editors that updating & its editor providers create
			if (o.enableUTCDates !== false && updating.grid.options.enableUTCDates) {
				o.enableUTCDates = true;
			}
			if (!v) {
				if (dataType === 'bool') {
					o.listItems = ['true', 'false'];
					o.button = 'dropdown';
					this._bool = o.readOnly = o.dropDownOnReadOnly = o.spinOnReadOnly = o.spinWrapAround = true;
				} else if (format === 'currency' || format === 'percent' || format === 'date') {
					v = format;
					o.displayFactor = o.displayFactor || 1;
				} else if (dataType === 'number') {
					v = 'numeric';
				} else if (dataType === 'date') {
					v = 'date';
				} else if (!dataType) {
					v = cellValue;
					v = (typeof v === 'number') ? 'numeric' : ((v && v.getTime) ? 'date' : null);
				}
				o.type = v;
			}
			if (format === 'int') {
				o.maxDecimals = 0;
			} else if (format === 'double' && !o.maxDecimals) {
				o.maxDecimals = 100;
			} else if (format && v && v.toString().indexOf('date') === 0 && !o.dateInputFormat) {
				o.dateInputFormat = format;
			}
			if ((v === 'datepicker' || v === 3) && !o.button) {
				o.button = 'dropdown';
			}
			o.tabIndex = tabIndex;
			// save custom events defined by editorOptions
			o._eo = o._eo || { tc: o.textChanged, kd: o.keydown };
			o.textChanged = function (e, ui) {
				updating._notifyChanged();
				// raise custom event defined by editorOptions
				if (o._eo.tc) {
					o._eo.tc(e, ui);
				}
			};
			// editor cancels esc, tab and enter keys, so, they can not be processed by grid
			o.keydown = function (e, ui) {
				// flag to skip enter/13 key for multiline editor with disabled hideEnterKey
				updating._13 = o.textMode && !o.hideEnterKey;
				updating._notifyEditorKey(e, key);
				// raise custom event defined by editorOptions
				if (o._eo.kd) {
					o._eo.kd(e, ui);
				}
			};
			v = element || $('<span />');
			if (!v.igEditor) {
				_throw('igEditorException');
			}
			if (o.id) {
				v.attr('id', o.id);
			}
			o.excelNavigationMode = updating.options.excelNavigationMode;
			v = v.igEditor(o);
			this.editor = v.data('igEditor');
			return v;
		},
		getValue: function () {
			var val = this.editor.value();
			return this._bool ? (val === 'true') : val;
		},
		setValue: function (val) {
			return this.editor.value(this._bool ? ((val && val !== 'false') ? 'true' : 'false') : val);
		},
		setSize: function (width, height) {
			this.editor._listRemove();
			this.editor._width(width);
			this.editor._height(height);
		},
		setFocus: function () {
			this.editor.setFocus(-1);
		},
		removeFromParent: function () {
			return this.editor.remove();
		},
		destroy: function () {
			this.editor.destroy();
		},
		validator: function () {
			return this.editor.validator();
		},
		validate: function (noLabel) {
			return this.editor.validate(noLabel);
		},
		isValid: function () {
			return this.editor.isValid();
		}
	});
	$.ig.EditorProviderCombo = $.ig.EditorProviderCombo || $.ig.EditorProvider.extend({
		createEditor: function (updating, key, columnSetting, tabIndex, format, dataType, cellValue, element) {
			var v, o = {};
			if (columnSetting) {
				o = columnSetting.editorOptions || o;
			}
			o.tabIndex = tabIndex;
			// save custom events defined by editorOptions
			o._eo = o._eo || { tc: o.textChanged, kd: o.keydown };
			o.textChanged = function (e, ui) {
				updating._notifyChanged();
				// raise custom event defined by editorOptions
				if (o._eo.tc) {
					o._eo.tc(e, ui);
				}
			};
			// editor cancels esc, tab and enter keys, so, they can not be processed by grid
			o.keydown = function (e, ui) {
				if (!ui || ui.keyCode === 9 || !ui.owner || !ui.owner._ddOn) {
					updating._notifyEditorKey(e, key);
				}
				// raise custom event defined by editorOptions
				if (o._eo.kd) {
					return o._eo.kd(e, ui);
				}
			};
			v = element || $('<span />');
			if (!v.igCombo) {
				_throw('igComboException');
			}
			if (o.id) {
				v.attr('id', o.id);
			}
			v = v.igCombo(o);
			this.editor = v.data('igCombo');
			return v;
		},
		getValue: function () {
			return this.editor.options.allowCustomValue ? this.editor.text() : this.editor.value();
		},
		setValue: function (val) {
			var combo = this.editor, o = combo.options;
			if (o.filteringType) {
				combo.selectedIndex(-1);
				combo.activeIndex(-1);
				if (!o.parentCombo) {
					combo.dataBind();
				}
			}
			return o.allowCustomValue ? combo.text((val === null ? (o.nullText || "") : val)) : combo.value(val);
		},
		setSize: function (width, height) {
			this.editor.options.width = width;
			this.editor.options.height = height;
			this.editor._doSize();
		},
		setFocus: function () {
			this.editor.setFocus(-1);
			// S.S. April 23, 2013 Bug #140196 - Tabbing into igCombo on the edit-row should also select its current text 
			this.editor.fieldElem[0].select();
		},
		removeFromParent: function () {
			return this.editor.remove();
		},
		validator: function () {
			return this.editor.validator();
		},
		destroy: function () {
			this.editor.destroy();
		}
	});
	$.ig.EditorProviderRating = $.ig.EditorProviderRating || $.ig.EditorProvider.extend({
		createEditor: function (updating, key, columnSetting, tabIndex, format, dataType, cellValue, element) {
			var foc, v, o = {};
			if (columnSetting) {
				o = columnSetting.editorOptions || o;
			}
			// save custom events defined by editorOptions
			o._eo = o._eo || { vc: o.valueChange };
			o.valueChange = function (e, ui) {
				updating._notifyChanged();
				// raise custom event defined by editorOptions
				if (o._eo.vc) {
					return o._eo.vc(e, ui);
				}
			};
			v = element || $('<div />');
			if (!v.igRating) {
				_throw('igRatingException');
			}
			if (o.id) {
				v.attr('id', o.id);
			}
			v = v.igRating(o);
			this.editor = v.data('igRating');
			foc = this.editor._foc;
			if (foc) {
				foc.attr('tabIndex', tabIndex);
				foc.keydown(function (e) {
					updating._notifyEditorKey(e, key);
				});
			}
			return v;
		},
		getValue: function () {
			return this.editor.value();
		},
		setValue: function (val) {
			return this.editor.value(val || 0);
		},
		setSize: function (width, height) {
			if (!this._once) {
				this.editor._doVotes(this.editor.options);
			}
			this._once = 1;
			var back = this.editor.element.parent().css('backgroundColor');
			// adjust 2px for borders
			this.editor.element.css({ width: width, height: height, backgroundColor: back });
		},
		setFocus: function () {
			this.editor.focus();
		},
		validator: function () {
			return this.editor.validator();
		},
		destroy: function () {
			this.editor.destroy();
		}
	});
	$.ig.EditorProviderCheckbox = $.ig.EditorProviderCheckbox || $.ig.EditorProvider.extend({
		createEditor: function (updating, key, columnSetting, tabIndex, format, dataType) {
			var elem, me = this, o = columnSetting;
			me.updating = updating;
			me.none = dataType === 'bool' ? false : null;
			me.element = elem = $('<span tabindex="' + tabIndex + '"/>').addClass('ui-igedit-field ui-state-default ui-corner-all').css({
				overflow: 'hidden',
				textAlign: 'center',
				outline: 0,
				background: '#ffffff',
				display: 'block'
			}).click(function () {
				me.setValue(0, updating);
			}).focus(function () {
				me.css(true, true);
			}).blur(function () {
				me.css(true);
			}).mouseover(function () {
				me.css(null, true);
			}).mouseleave(function () {
				me.css();
			}).keydown(function (e) {
				updating._notifyEditorKey(e, key);
				if (e && e.keyCode === 32) {
					_stop(e);
					me.setValue(0, updating);
				}
			});
			o = o ? o.editorOptions : null;
			if (o && o.id) {
				elem.attr('id', o.id);
			}
			elem = $('<span class="ui-state-default ui-corner-all ui-igcheckbox-small" />').css('display', 'inline-block').appendTo(elem);
			$('<span class="ui-icon ui-icon-check ui-igcheckbox-small-on" />').css('display', 'block').appendTo(elem);
			return this.element;
		},
		// get reference to element: 0-main, 1-checkbox, 2-icon
		el: function (depth) {
			var e = this.element;
			while (depth-- > 0) {
				e = $(e.children()[0]);
			}
			return e;
		},
		getValue: function () {
			return this.value;
		},
		setValue: function (val, updating) {
			var css = 'ui-igcheckbox-small-off';
			if (updating) {
				val = !this.value;
			}
			this.value = (val || val === false) ? val : this.none;
			if (val) {
				this.el(2).removeClass(css);
			} else {
				this.el(2).addClass(css);
			}
			if (updating) {
				updating._notifyChanged();
			}
		},
		// configure focus/hover appearance
		css: function (foc, on) {
			var i = 2, css = foc ? 'ui-state-focus' : 'ui-state-hover';
			while (i-- > 0) {
				if (on) {
					this.el(i).addClass(css);
				} else {
					this.el(i).removeClass(css);
				}
			}
		},
		setSize: function (width, height) {
			var elem = this.el(0);
			this.el(1).css('marginTop', Math.floor((height - 15) / 2) + 'px');
			this.css();
			this.css(true);
			elem.css({ width: width - _int(elem, 'borderLeftWidth') - _int(elem, 'borderRightWidth'),
				height: height - _int(elem, 'borderTopWidth') - _int(elem, 'borderBottomWidth') });
		},
		setFocus: function (toggle) {
			this.el(0).focus();
			if (toggle) {
				this.setValue(0, this.updating);
			}
		}
	});
}(jQuery));
/*!@license
* Infragistics.Web.ClientUI Layout Manager 14.1.20141.2249
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends on:
*	jquery-1.7.0.js
*	jquery.ui.core.js
*	jquery.ui.widget.js
*   infragistics.util.js
*/
/*global jQuery, Modernizr, MSApp, window */
if (typeof jQuery !== 'function') {
    throw new Error("jQuery is undefined");
}
(function ($) {
    /*
		igLayoutManager is a widget based on jQuery UI that implements different layout modes - flow layout, vertical layout,
		a border layout, which divides the container into left/right/footer/header/center regions, responsive and fluid column layout based on 12 columns,
		as well as a grid layout which allows items to be positioned at arbitrary places on the screen, and have variable row and col spans. 
	*/
    $.widget("ui.igLayoutManager", {
        css: {
            /* classes applied to an individual layout item */
            "item": "ig-layout-item",
            /* classes applied to the  main container element, on which the layout manager widget is instantiated */
            "container": "ig-layout",
            /* classes applied to an item that is part of a flow layout*/
            "flowItem": "ig-layout-flow-item",
            /* classes applied to the container when layout mode is flow*/
            "flow": "ig-layout-flow",
            /* classes applied to the container when layout mode is vertical */
            "vertical": "ig-layout-vertical",
            /* classes applied to the individual layout item, when layout is vertical*/
            "verticalItem": "ig-layout-vertical-item",
            /* classes applied to the container when layout mode is border */
            "border": "ig-layout-border",
            /* classes applied to the individual layout item, when layout is of border type */
            "borderItem": "ig-layout-border-item",
            /* classes applied to the  header region of a border layout */
            "borderHeader": "ig-layout-border-header",
            /* classes applied to the  footer region of a border layout */
            "borderFooter": "ig-layout-border-footer",
            /* classes applied to the left region of a border layout */
            "borderLeft": "ig-layout-border-left",
            /* classes applied to the center region of a border layout */
            "borderCenter": "ig-layout-border-center",
            /* classes applied to the right region of a border layout */
            "borderRight": "ig-layout-border-right",
            /* classes applied to the  container element, when mode is border */
            "borderContainer": "ig-layout-border-container",
            /* classes applied to the item elements, when mode is grid and the items are absolutely positioned */
            "gridItemAbs": "ig-layout-griditem-abs",
            /* classes applied to the item elements, when mode is grid and the items are relatively positioned */
            "gridItemRel": "ig-layout-griditem-rel"
            /*
			"borderWrapper1": "ig-layout-border-wrapper1",
			"borderWrapper2": "ig-layout-border-wrapper2"
			*/
        },
        options: {
            /* type="grid|border|flow" defines the layout type
				grid
				border
				flow
				column
				vertical
			*/
            layoutMode: "column",
            /* will apply styles that will use media queries in order to alter the # of columns when shown on devices with smaller form factor
				such as mobile phones, tablets, etc. */
            //responsive: true, // no need of this option, this can be controlled by setting a meta tag in the page
            /* null implies auto mode, a value of "true" will use CSS3 translate transforms,
				a value of "false" will set left/top values for positioning 
				
				depending on the algorithm, this may be (optional) Flexbox / HTML5 Grid, etc. 
			*/
            //useCSS3: null,
            /* allows the whole layout container to be resizable, then reorders items 
				depending on mode algorithm settings 
			*/
            //resizable: true,
            /* allows individual items to be resized by using splitter UI */
            //itemsResizable: false,
            /* type="number" number of items to render, this is only applicable to layouts: vertical and flow */
            itemCount: null,
            /* type="object" options specific to grid layout mode */
            gridLayout: {
                /* type="number" number of columns in the grid */
                cols: null,
                /* type="number" number of rows in the grid */
                rows: null,
                /* Accepts number or string with width in px or percents */
                columnWidth: null,
                /* Accepts number or string with height in px or percents */
                columnHeight: null,
                /* type="number" specifies the margin left css property for items */
                marginLeft: 0,
                /* type="number" specifies the margin top css property for items */
                marginTop: 0,
                /* type="boolean" Specified whether the items should rearrange to fit in the container when it is resized.
                    Have effect only when fixed columnWidth option is set. */
                rearrangeItems: true,
                /* type="boolean" Specifies whether the previous set options should be overriden when setting options */
                overrideConfigOnSetOption: true,
                /* type="number" Specifies the duration of the animations in the layout manager's grid layout */
                animationDuration: 500
            },
            /* type="object" options specific to a border layout */
            borderLayout: { // also known as 3 column layout
                /* type="bool" option specifying whether the header region in the border layout will be hidden or shown */
                showHeader: true,
                /* type="bool" option specifying whether the footer region in the border layout will be hidden or shown */
                showFooter: true,
                /* type="bool" option specifying whether the left region in the border layout will be hidden or shown */
                showLeft: true,
                /* type="bool" option specifying whether the right region in the border layout will be hidden or shown */
                showRight: true,
                /* type="string" option specifying the width of the left region, either in px or percentages */
                leftWidth: '20%',
                /* type="string" option specifying the width of the right region, either in px or percentages */
                rightWidth: '10%'
                //enableSplitters: true
                /* can be relative or "fixed" */
                //positioning: "relative"
            },
            /* type="array" an array of item descriptions 
				this assumes the container is empty, and every item
				is described by rowspan,colspan, etc. - otherwise values of
				1 are assumed
				items can have various properties some of which may not be applicable
				depending on the layoutMode.
				for example rowSpan/colSpan/colIndex/rowIndex are only applicable to gridlayout
			*/
            items: [
				{
				    /* type="number" rowSpan of the item */
				    rowSpan: 1,
				    /* type="number" colSpan of the item */
				    colSpan: 1,
				    /* type="number" column index of the item in the grid */
				    colIndex: 0,
				    /* type="number" row index of the item in the grid */
				    rowIndex: 0,
				    /* type="string" individual item width, either in px or percentage */
				    width: null,
				    /* type="string" individual item height, either in px or percentage */
				    height: null
				}
            ],
            //enableAnimations: true,
            /* type="string" width of the layout container */
            width: null,
            /* type="string" height of the layout container */
            height: null
        },
        events: {
            /* cancel="false" Event fired before an item is rendered in the container
				Function takes arguments evt and ui.
				Use ui.owner to get reference to the igLayoutManager.
				Use ui.itemData to get a reference of item's settings, such as colspan ,rowspan, etc. 
				use ui.index to get a reference of the item's index, if the layout is flow or vertical
			*/
            itemRendering: "itemRendering",
            /* Event fired after an item has been rendered in the container
				Function takes arguments evt and ui.
				Use ui.owner to get reference to the igLayoutManager.
				Use ui.itemData to get a reference of item's settings, such as colspan ,rowspan, etc. 
				use ui.index to get a reference of the item's index, if the layout is flow or vertical
			*/
            itemRendered: "itemRendered",
            /*
		     Event fired after all items are rendered.
                Function takes arguments evt and ui.
				Use ui.owner to get reference to the igLayoutManager.
            */
            rendered: "rendered",
            /* cancel="true" Event fired before items are resized.
                Use ui.owner to get a reference to the layout manager performing resizing.*/
            internalResizing: 'internalResizing',
            /* cancel="false" Event fired after items are resized.
                Use ui.owner to get a reference to the layout manager performing resizing.*/
            internalResized: 'internalResized'
            /* Event fired before an item is going to accomodate 100% of the container's width/height
				Function takes arguments evt and ui.
				Use ui.owner to get reference to the igLayoutManager.
			*/
            //TODO: not implemented
            //itemMaximizing: "itemMaximizing",
            /* Event fired after an item is maximized
				Function takes arguments evt and ui.
				Use ui.owner to get reference to the igLayoutManager.
			*/
            //TODO: not implemented
            //itemMaximized: "itemMaximized",
            /* Event fired before an item is positioned (i.e. its size , offsets, etc - are calculated)
				Note that this is different from the "Rendering/Rendered" events in the sense that positioning/positioned
				are always fired, while rendering/rendered are only fired if the layout items are defined as part of the options
				otherwise the assumption is that they will be looked up either using the provided selector, or the child elements
				will be used 
				Function takes arguments evt and ui.
				Use ui.owner to get reference to the igLayoutManager.
			*/
            //TODO: not implemented
            //itemPositioning: "itemPositioning",
            /*
				Function takes arguments evt and ui.
				Use ui.owner to get reference to the igLayoutManager.
			*/
            //TODO: not implemented
            //itemPositioned: "itemPositioned",
            /* Event fired before an item's position is restored to its original position
				Function takes arguments evt and ui.
				Use ui.owner to get reference to the igLayoutManager.
			*/
            //TODO: not implemented
            //itemRestoring: "itemRestoring",
            /* Event fired after the item's original position in the "dashboard" has been restored
				Function takes arguments evt and ui.
				Use ui.owner to get reference to the igLayoutManager.
			*/
            //TODO: not implemented
            //itemRestored: "itemRestored",
            /* Event fired when the layout container resizes
			
			*/
            //TODO: not implemented
            //resize: "resize"
        },
        _opt: null,
        _createWidget: function (options, element) {
            this.options.items = [];
            this.options.gridLayout.useOffset = true;
            // D.A.September 18th 2013 BUG #148630 Use deep copy of the items configuration
            // to avoid issues when the same instance of items configuration is used in
            // multiple layout managers. jQuery options merging does not deep copy arrays.
            if (options && options.items) {
                options.items = $.extend(true, [], options.items);
            }
            $.Widget.prototype._createWidget.apply(this, arguments);
        },
        _create: function () {
            var self = this;
            // D.A. 28th April 2014, Bug #170423 The _opt object should be created after the user and default options are merged.
            this._opt = {
                eventHandlers: {},
                gridLayout: null,
                borderLayout: null,
                scrollBarWidth: $.ig.util.getScrollWidth(),
                scrollBarHeight: $.ig.util.getScrollHeight(),
                resizeLayout: this.options.layoutMode === "grid" ||
                    this.options.layoutMode === "border"
            };
            this.element.addClass(this.css.container);
            if (this.options.width !== null) {
                this.element.css('width', this.options.width);
            }
            if (this.options.height !== null) {
                this.element.css('height', this.options.height);
            }
            // D.A. 15th April 2014, Bug #169721 InternalResizing / InternalResize 
            // events should fire only for layouts that actually resize internally.
            if (this._opt.resizeLayout) {
                // track resizing
                this._opt.eventHandlers.elementResizeHandler = function (e) {
                    var noCancel = self._triggerInternalResizing(e);
                    if (noCancel) {
                        self.reflow(false, null, e);
                    }
                };
                this.element.on("resize", this._opt.eventHandlers.elementResizeHandler);
                this._opt.eventHandlers.windowResizeHandler = function (e) {
                    var noCancel = self._triggerInternalResizing(e);
                    if (noCancel) {
                        self.reflow(false, null, e);
                    }
                };
                $(window).on("resize", this._opt.eventHandlers.windowResizeHandler);
            }
            // also listen to device orientation changes
            //TODO ? (depending on algorithm)
            switch (this.options.layoutMode) {
            case "grid":
                this._initGridLayout();
                break;
            case "border":
                this._initBorderLayout();
                break;
            case "flow":
                this._initFlowLayout();
                break;
            case "column":
                //D.A. March 18th, 2013 Bug #136557 The _initColumnLayout method is not implemented. 
                //Instead column layout is achieved entirely through css.
                //this._initColumnLayout();
                break;
            case "vertical":
                this._initVerticalLayout();
                break;
            default:
                //this._initColumnLayout();
                break;
            }
        },
        _setOption: function (option, value) {
            if (this.options[option] === value) {
                return;
            }

            var opt = this.options,
                borderLayout = $.extend(true, {}, this.options.borderLayout),
                initGridLayout, gridLayout;

            switch (option) {
            case 'gridLayout':
                if (opt.gridLayout.overrideConfigOnSetOption) {
                    // Use the default options
                    gridLayout = $.extend(true, {
                        overrideConfigOnSetOption: opt.gridLayout.overrideConfigOnSetOption,
                        useOffset: opt.gridLayout.useOffset
                    }, {
                        cols: null,
                        rows: null,
                        columnWidth: null,
                        columnHeight: null,
                        marginLeft: 0,
                        marginTop: 0,
                        rearrangeItems: true,
                        animationDuration: 500
                    });
                    initGridLayout = true;
                } else {
                    // Preserve previous set options
                    gridLayout = $.extend(true, {}, this.options.gridLayout);
                    // Reinit the grid layout only when any of the layout options are changed
                    initGridLayout = value.cols || value.rows || value.columnWidth ||
                        value.columnHeight || typeof value.marginLeft === "number" ||
                        typeof value.marginTop === "number" || value.useOffset;
                }
                break;
            default:
                break;
            }
            $.Widget.prototype._setOption.apply(this, arguments);
            switch (option) {
            case 'width':
                this.element.width(this.options.width);
                if (opt.layoutMode === 'grid') {
                    this.reflow(true);
                }
                break;
            case 'height':
                this.element.height(this.options.height);
                if (opt.layoutMode === 'grid') {
                    this.reflow(true);
                }
                break;
            case 'gridLayout':
                this.options.gridLayout = $.extend(
                    true, {}, gridLayout, this.options.gridLayout);
                if (initGridLayout) {
                    this._initGlFromItemsConfig(false);
                } else {
                    if (value.hasOwnProperty('rearrangeItems')) {
                        this._opt.gridLayout.rearrangeItems = value.rearrangeItems;
                    }
                    if (value.hasOwnProperty('animationDuration')) {
                        this._opt.gridLayout.animationDuration = value.animationDuration;
                    }
                }
                break;
            case 'borderLayout':
                this._destroyBorderLayout();
                this.options.borderLayout = $.extend(
                    true, {}, borderLayout, this.options.borderLayout);
                this._initBorderLayout();
                break;
            case 'items':
                switch (opt.layoutMode) {
                case 'vertical':
                    this._destroyVerticalLayout();
                    this._initVerticalLayout();
                    break;
                case 'grid':
                    this._initGlFromItemsConfig(false);
                    break;
                case 'flow':
                    this._destroyFlowLayout();
                    this._initFlowLayout();
                    break;
                }
                break;
            case 'itemCount':
                switch (opt.layoutMode) {
                case 'vertical':
                    this._destroyVerticalLayout();
                    this._initVerticalLayout();
                    break;
                case 'flow':
                    this._destroyFlowLayout();
                    this._initFlowLayout();
                    break;
                }
                break;
            default:
                break;
            }
        },
        /*
		addItems: function (items) {
			// add extra items to this.options.gridLayout.items, and cause a reflow
		},
		*/
        reflow: function (forceReflow, animationDuration, event) {
            /* Triggers recalculation of the layout dimensions. Layouts may not need to be reflowed manually, if their sizes are in percentages (i.e. they are responsive by default)
			   this can be particularly useful with a grid layout, when the container has percentage sizes, but items are calculated in pixels and positioned absolutely in the container. 
               paramType="boolean" optional="true" Indicates whether the reflow should be forced. Useful in cases where the items size and position was changed manually.
               paramType="number" optional="true" The animation duration to be used for this reflow only. Supported only for Grid Layout mode.
               paramType="object" optional="true" Indicates the browser even which triggered this action (not API).
			*/
            // trigger recalculation
            // since different layout algorithms may or may not need to reflow depending on whether
            // they are responsive by nature, we are going to fire an event, and different 
            // implementations are going to subscribe to it, so that we avoid doing if/else checks here, etc.
            if (this.options.layoutMode === 'grid') {
                parsedDur = parseInt(animationDuration, 10);
                animationDuration = parsedDur >= 0 ? parsedDur : this.options.gridLayout.animationDuration;

                this._reflowGlConfiguration(forceReflow, animationDuration, event);
            }
            // D.A. 13th March 2014 Bug #164295 Update container paddings when the header/footer height changes.
            if (this.options.layoutMode === "border") {
                this._setBorderLayoutPaddings();
            }
        },
        /*
		_initColumnLayout: function () {
		
		},
		*/
        _initVerticalLayout: function () {
            var i, length = this.options.itemCount, items = this.options.items, item;
            this.element.addClass(this.css.vertical);
            if (length > 0) {
                for (i = 0; i < length; i++) {
                    this._trigger(this.events.itemRendering, null, { index: i });
                    item = $("<div></div>").appendTo(this.element).addClass(this.css.verticalItem);
                    this.options.destroyItems = true;
                    this._trigger(this.events.itemRendered, null, { item: item, index: i });
                }
                this._trigger(this.events.rendered, null, { owner: this });
            } else if (items && items.length > 0) {
				this.element.empty();
                for (i = 0; i < items.length; i++) {
                    this._trigger(this.events.itemRendering, null, { itemData: items[i], index: i });
                    item = $("<div></div>").appendTo(this.element).addClass(this.css.verticalItem);
                    if (items[i].width) {
                        item.css("width", items[i].width);
                    }
                    if (items[i].height) {
                        item.css("height", items[i].height);
                    }
                    this._trigger(this.events.itemRendered, null, { item: item, index: i });
                }
                this.options.destroyItems = true;
                this._trigger(this.events.rendered, null, { owner: this });
            } else {
                this.element.children().addClass(this.css.verticalItem);
            }
        },
        // When items configuration is given get the cols and rows values from it.
        _analyzeGlItems: function () {
            var config = this._opt.gridLayout,
		        items = config.items,
                cols = 0,
                rows = 0,
		        item, itemCols, itemRows, i;
            for (i = 0; items.length > i; i++) {
                item = items[i];
                itemCols = item.colIndex + item.colSpan;
                itemRows = item.rowIndex + item.rowSpan;
                if (itemCols > cols) {
                    cols = itemCols;
                }
                if (itemRows > rows) {
                    rows = itemRows;
                }
            }
            if (cols > 0) {
                config.cols = cols;
            }
            if (rows > 0) {
                config.rows = rows;
            }
        },
        _analyzeGlWidth: function () {
            var config = this._opt.gridLayout,
                columnWidth = config.columnWidth,
                elWidth = this.element.width(),
		        units;

            // Convert the column width option to number value
            if (columnWidth) {
                if (typeof columnWidth === 'string') {
                    if (columnWidth.indexOf('%') !== -1) {
                        units = columnWidth.substring(0, columnWidth.length - 1);
                        units = parseInt(units, 10) / 100;
                        if (!isNaN(units) && units > 0) {
                            // Keep the ratio to resize the tiles when the container is resized
                            config.columnWidthRatio = units;
                            // When columnWidth option is set in percent
                            // consider the margin-left to be part of it for users ease
                            config.columnWidth = Math.floor(elWidth * units - config.marginLeft);
                        }
                    } else {
                        // Try to parse the value
                        units = parseInt(columnWidth, 10);
                        if (!isNaN(units) && units > 0) {
                            config.columnWidth = units;
                        }
                    }
                }
            }
        },
        _analyzeGlHeight: function () {
            var config = this._opt.gridLayout,
                columnHeight = config.columnHeight,
                elHeight = this.element.height(),
		        units;

            // Convert the column height option to number value
            if (columnHeight) {
                if (typeof columnHeight === 'string') {
                    if (columnHeight.indexOf('%') !== -1) {
                        units = columnHeight.substring(0, columnHeight.length - 1);
                        units = parseInt(units, 10) / 100;
                        if (!isNaN(units) && units > 0) {
                            config.columnHeightRatio = units;
                            // When columnHeight option is set in percent
                            // consider the margin-top to be part of it for users ease
                            config.columnHeight = Math.floor(elHeight * units - config.marginTop);
                        }
                    } else {
                        units = parseInt(columnHeight, 10);
                        if (!isNaN(units) && units > 0) {
                            config.columnHeight = units;
                        }
                    }
                }
            }
        },
        _analyzeGlNotSetOptions: function () {
            var config = this._opt.gridLayout,
                elWidth = this.element.width(),
                elHeight = this.element.height(),
                itemsLength = config.items.length,
		        columnWidthOption = typeof config.columnWidth === 'number' &&
                    config.columnWidth > 0,
                columnHeightOption = typeof config.columnHeight === 'number' &&
                    config.columnHeight > 0,
		        colsOption = typeof config.cols === 'number' && config.cols > 0,
		        rowsOption = typeof config.rows === 'number' && config.rows > 0;

            // Calculate cols/rows depending on provided options
            if (!colsOption) {
                if (rowsOption) {
                    // When rows are given, but cols are not. Calculate cols from the rows.
                    config.cols = Math.ceil(itemsLength / config.rows);
                } else {
                    if (columnWidthOption) {
                        // When cols & rows options are not given, but column width option is given.
                        // Calculate cols/rows from column width.
                        config.cols = Math.floor(elWidth / (config.columnWidth + config.marginLeft));
                        config.rows = Math.ceil(itemsLength / config.cols);
                    } else if (columnHeightOption) {
                        // When cols, rows and column width options are not given, but column height is given.
                        // Calculate cols/rows from column height.
                        config.rows = Math.floor(elHeight / (config.columnHeight + config.marginTop));
                        config.cols = Math.ceil(itemsLength / config.rows);
                    } else {
                        // Default, when no options are given.
                        config.cols = Math.ceil(Math.sqrt(itemsLength));
                        config.rows = Math.ceil(itemsLength / config.cols);
                    }
                }
            } else if (!rowsOption) {
                // When cols are given, but rows are not. Calculate rows from the cols.
                config.rows = Math.ceil(itemsLength / config.cols);
            }
            // When columnWidth is not given. Consider it is set in percent and calculate it from number of cols.
            if (!columnWidthOption) {
                config.columnWidth = Math.floor(elWidth * (1 / config.cols) - config.marginLeft);
                config.columnWidthRatio = 1 / config.cols;
            }
            // When columnHeight is not set. Consider it is set in percent and calculate it from number of rows.
            if (!columnHeightOption) {
                config.columnHeight = Math.floor(elHeight * (1 / config.rows) - config.marginTop);
                config.columnHeightRatio = 1 / config.rows;
            }
            // Adjust the columnHeight automatically based on the container's height when no options
            // specifying the columnHeight were provided in the configuration (as columnHeight, cols, items).
            // This is possible only when the columnWidth is fixed value and the items rearrange.
            if (!columnHeightOption && !colsOption && !config.columnWidthRatio) {
                config.autoAdjustColumnHeight = true;
            }
            // Adjust the columnWidth automatically based on the container's width when no options
            // specifying the columnWidth were provided in the configuration (as columnWidth, rows, items).
            // This is possible only when the columnHeight is fixed value and the items rearrange.
            if (!columnWidthOption && !rowsOption && !config.columnHeightRatio) {
                config.autoAdjustColumnWidth = true;
            }
        },
        _analyzeGlConfiguration: function () {
            this._analyzeGlWidth();
            this._analyzeGlHeight();
            this._analyzeGlItems();
            this._analyzeGlNotSetOptions();
        },
        _createGlConfig: function () {
            var gl,
                e = this.element;

            // Initialize internal grid layout options
            this._opt.gridLayout = gl = $.extend(true, {}, this.options.gridLayout, {
                // The items configurations
                items: $.extend(true, [], this.options.items),
                // The items sorted from left to right and top to bottom
                sortedItems: [],
                // The created items
                elements: $(),
                // The minimum column count
                minColCount: 1,
                // The column width to container width ratio
                columnWidthRatio: null,
                // The column height to container height ratio
                columnHeightRatio: null,
                // The effective width of the container, the width without the vertical scrollbar
                // The initial value is be set to the full container's width.
                // When vertical scroll appear or disappear the value is recalculated accordingly
                containerWidthNoScroll: e.width(),
                // The effective height of the container, the height without the horizontal scrollbar
                // The initial value is be set to the full container's height
                // When horizontal scroll appear or disappear the value is recalculated accordingly
                containerHeightNoScroll: e.height(),
                // Items are considered resizable when their width or height is set in percent
                resizeItems: false,
                // Whether the items are currently animated
                animating: false,
                // When the items are rearranged and the columnWidth or cols are not set
                // The columnWidth will be automatically adjusted to fit the items in the container
                autoAdjustColumnWidth: false,
                // When the items are rearranged and the columnHeight or rows are not set
                // The columnHeight will be automatically adjusted to fit the items in the container
                autoAdjustColumnHeight: false,
                // D.A. 12th May 2014, Bug #160622, Preserve the initial configuration when reflowing
                initialCols: 0,
                initialRows: 0,
                initialColWidth: 0,
                initialColWidthRatio: null,
                initialColHeight: 0,
                initialColHeightRation: null,
                initialSortedItems: [],
                initialReflow: true,
                useOffset: (e.css('position') === 'static' || e.css('position') === 'fixed')
                    && this.options.gridLayout.useOffset ? true : false,
                destroyItemsFromIndex: e.children().length
            });

            // D.A. 4th April 2014, Bug #169251 Grid Layout doesn't accept string values for cols/rows options
            if (typeof gl.cols === "string") {
                gl.cols = parseInt(gl.cols, 10);
            }

            if (typeof gl.rows === "string") {
                gl.rows = parseInt(gl.rows, 10);
            }

            // Analyze configuration's columnWidth/Height and cols/rows
            // Sets columnWidth/HeightRatio
            this._analyzeGlConfiguration();

            // Resize the items if columnWidth or columnHeight was set in percent ( % ).
            gl.resizeItems = !!(gl.columnWidthRatio || gl.columnHeightRatio);
        },
        _glSortItemsByPositionOrder: function () {
            var gl = this._opt.gridLayout,
                compareFunc = function (item1, item2) {
                    return (item1.rowIndex !== item2.rowIndex) ?
                        item1.rowIndex - item2.rowIndex : item1.colIndex - item2.colIndex;
                };

            // Sort the items from left to right and top to bottom
            gl.sortedItems = $.extend(true, [], gl.items).sort(compareFunc);
        },
        _renderGlItemsFromItemsConfig: function (initialRendering) {
            var i,
                item,
                itemData,
                width,
                height,
                top,
                left,
                row,
                col,
                colSpan,
                rowSpan,
                $currChild,
                renderNewItem,
                e = this.element,
                gl = this._opt.gridLayout,
                ml = gl.marginLeft,
                mt = gl.marginTop,
                iw = gl.columnWidth,
                ih = gl.columnHeight,
                items = gl.items,
                offset = e.offset(),
                $children = e.children();

            // Create items for each item definition in this.options.items
            for (i = 0; i < items.length; i++) {
                itemData = items[i];
                $currChild = $children.eq(i);
                renderNewItem = $currChild.length === 0;

                colSpan = itemData.colSpan = (typeof itemData.colSpan === 'number') ?
                    itemData.colSpan : 1;
                rowSpan = itemData.rowSpan = (typeof itemData.rowSpan === 'number') ?
                    itemData.rowSpan : 1;
                row = itemData.rowIndex = (typeof itemData.rowIndex === 'number') ?
                    itemData.rowIndex : Math.floor(i / gl.cols);
                col = itemData.colIndex = (typeof itemData.colIndex === 'number') ?
                    itemData.colIndex : i % gl.cols;

                if (renderNewItem || initialRendering) {
                    // Trigger Item Rendering
                    this._trigger(this.events.itemRendering, null, {
                        itemData: itemData,
                        index: i
                    });
                }

                if (renderNewItem) {
                    item = $("<div>").appendTo(this.element);
                } else {
                    item = $currChild;
                }

                itemData.item = item;
                gl.elements = gl.elements.add(item);

                if (colSpan > gl.minColCount) {
                    gl.minColCount = colSpan;
                }

                width = colSpan * iw + (colSpan - 1) * ml;
                height = rowSpan * ih + (rowSpan - 1) * mt;
                left = col * iw + (col + 1) * ml;
                top = row * ih + (row + 1) * mt;

                if (gl.useOffset) {
                    top += offset.top;
                    left += offset.left;
                }

                item.addClass(this.css.item)
                    .addClass(this.css.gridItemAbs)
                    .attr('data-index', i)
                    .css({
                        top: top,
                        left: left,
                        width: width,
                        height: height
                    });

                if (renderNewItem || initialRendering) {
                    // Trigger Item Rendered
                    this._trigger(this.events.itemRendered, null, {
                        item: item,
                        itemData: itemData,
                        index: i
                    });
                }
            }

            this._glSortItemsByPositionOrder();

            // Remove excess elements when setOption "items" 
            // is called with less item configurations
            $children.slice(items.length).remove();

            if (initialRendering) {
                // Trigger grid layout rendered
                this._trigger(this.events.rendered, null, {
                    items: this.options.items
                });
            }
        },
        _initGlFromItemsConfig: function (initialRendering) {
            // Initialize and analyze the internal grid layout configuration
            this._createGlConfig();
            // Render the grid layout based on the items configuration
            this._renderGlItemsFromItemsConfig(initialRendering);
            // Reflow the items in case scrollbar appeared
            this.reflow(false, 0);
        },
        _renderGlItemsFromColsRows: function (initialRendering) {
            var i,
                j,
                top,
                left,
                item,
                gl = this._opt.gridLayout,
                ml = gl.marginLeft,
                mt = gl.marginTop,
                iw = gl.columnWidth,
                ih = gl.columnHeight;

            for (i = 0; i < gl.rows; i++) {
                for (j = 0; j < gl.cols; j++) {
                    item = $("<div>")
                        .appendTo(this.element)
                        .addClass(this.css.item)
                        .addClass(this.css.gridItemAbs)
                        .attr('data-index', i * gl.cols + j)
                        .width(iw)
                        .height(ih);

                    // Trigger Item Rendered
                    this._trigger(this.events.itemRendered, null, {
                        item: item
                    });

                    left = j * iw + (j + 1) * ml;
                    top = i * ih + (i + 1) * mt;
                    left += j === 0 ? ml : 0;

                    item.css({
                        top: top,
                        left: left
                    });
                }
            }

            if (initialRendering) {
                // Trigger Grid Layout rendered
                this._trigger(this.events.rendered, null, {
                    items: this.options.items
                });
            }
        },
        _initGlFromColsRows: function (initialRendering) {
            this._createGlConfig();
            this._renderGlItemsFromColsRows(initialRendering);
        },
        _initGridLayout: function () {
            var i,
                items = this.options.items,
                e = this.element,
                $children = e.children(),
                lenDiff = $children.length - this.options.items.length;

            // D.A 3rd April 2014, Bug #168927 Grid Layout is not 
            // instantiated correctly from markup when items are not provided
            if (lenDiff > 0) {
                // Add items configuration for each child
                for (i = 0; i < lenDiff; i++) {
                    this.options.items.push({});
                }
            }

            if (items && items.length > 0) {
                this._initGlFromItemsConfig(true);
            } else if ($children.length === 0) {
                // When there aren't any children, and cols & rows is defined in the gridLayout settings
                // we are going to create cols * rows number of DIVs
                this._initGlFromColsRows(true);
            }
        },
        // Stores the grid layout configuration as it is upon initialization
        _setGlInitialConfig: function () {
            var gl = this._opt.gridLayout;

            gl.initialCols = gl.cols;
            gl.initialRows = gl.rows;
            gl.initialColHeight = gl.columnHeight;
            gl.initialColWidth = gl.columnWidth;
            gl.initialColWidthRatio = gl.columnWidthRatio;
            gl.initialColHeightRatio = gl.columnHeightRatio;
            gl.initialSortedItems = $.extend(true, [], gl.sortedItems);
        },
        // returnType='boolean' Returns "true" when grid layout reflow is needed
        // to adjust the tiles in case scrollbars appeared or disappeared.
        _glReflowNeeded: function () {
            var e = this.element,
                gl = this._opt.gridLayout,
                newContainerWidthNoScroll = e.width() -
                    ($.ig.util.hasVerticalScroll(e) ? this._opt.scrollBarWidth : 0),
                newContainerHeightNoScroll = e.height() -
                    ($.ig.util.hasHorizontalScroll(e) ? this._opt.scrollBarHeight : 0);

            // Reflow is needed when vertical scrollbar appeared or disappeared and columnWidth
            // is in percent or is fixed and enough space for new column is available.
            // Reflow is needed also when horizontal scrollbar appeared or disappeared and
            // columnHeight is in percent.
            return (gl.containerWidthNoScroll !== newContainerWidthNoScroll &&
                (gl.columnWidthRatio || gl.cols !== Math.floor(newContainerWidthNoScroll / (gl.columnWidth + gl.marginLeft)))) ||
                (gl.containerHeightNoScroll !== newContainerHeightNoScroll && gl.columnHeightRatio);
        },
        _reflowGlConfiguration: function (forceReflow, animationDuration, event) {
            var self = this,
                e = this.element,
                gl = this._opt.gridLayout,
                ml = gl.marginLeft,
                mt = gl.marginTop,
                items = gl.sortedItems,
                newContainerWidthNoScroll = e.width() -
                    ($.ig.util.hasVerticalScroll(e) ? this._opt.scrollBarWidth : 0),
                newContainerHeightNoScroll = e.height() -
                    ($.ig.util.hasHorizontalScroll(e) ? this._opt.scrollBarHeight : 0),
                leftOffset = gl.useOffset ? e.offset().left : 0,
                topOffset = gl.useOffset ? e.offset().top : 0,
                col, row, colSpan, rowSpan, newColCount, newDim, helperArray, itemData,
                colWidthChanged, colHeightChanged, positionsChanged, foundMatch,
                currentRow, item, i, j, k, r, n,
                rearrangeCallback = function () {
                    // Check if all animations have ended
                    if (!gl.elements.is(':animated')) {
                        gl.animating = false;
                        if (self._glReflowNeeded()) {
                            self.reflow(false, animationDuration, event);
                        } else {
                            // Trigger the internal resized event.
                            // The calls of the public api  method will also trigger the event.
                            self._triggerInternalResized(event);
                        }
                    }
                };

            if (items) {
                // Update columnWidth value when it is set in percent and container width changed
                if (gl.columnWidthRatio &&
                        gl.containerWidthNoScroll !== newContainerWidthNoScroll) {
                    gl.columnWidth = Math.floor(
                        newContainerWidthNoScroll * gl.columnWidthRatio - ml);
                    colWidthChanged = true;
                } else {
                    colWidthChanged = false;
                }
                // Update columnHeight when it is set in percent and container height changed
                if (gl.columnHeightRatio &&
                        gl.containerHeightNoScroll !== newContainerHeightNoScroll) {
                    gl.columnHeight = Math.floor(
                        newContainerHeightNoScroll * gl.columnHeightRatio - mt);
                    colHeightChanged = true;
                } else {
                    colHeightChanged = false;
                }
                // Recalculate the columnWidth of the items to most efficiently use the container's
                // width when the container's height changed and the height should be autoadjusted.
                // This might happen only when no options specifying the columnWidth were set by the user 
                // (columnWidth, cols and items) and the items are rearrangeable or reflow was forced.
                if (gl.autoAdjustColumnWidth && ((gl.containerHeightNoScroll !==
                    newContainerHeightNoScroll && gl.rearrangeItems) || forceReflow)) {
                    gl.rows = Math.max(Math.floor(newContainerHeightNoScroll / (gl.columnHeight + mt)), 1);
                    gl.columnWidthRatio = 1 / Math.ceil(items.length / gl.rows);
                    gl.columnWidth = Math.floor(
                        newContainerWidthNoScroll * gl.columnWidthRatio - ml);
                    colWidthChanged = true;
                }
                // Update the container width value
                gl.containerWidthNoScroll = newContainerWidthNoScroll;
                // Update the container height value
                gl.containerHeightNoScroll = newContainerHeightNoScroll;
                // Rearrange items
                if (gl.rearrangeItems || forceReflow) {
                    if (gl.rearrangeItems) {
                        if (gl.columnWidthRatio) {
                            newColCount = Math.floor(1 / gl.columnWidthRatio);
                        } else {
                            newColCount = Math.floor(newContainerWidthNoScroll /
                                (gl.columnWidth + ml));
                        }
                    } else {
                        // When the reflow is forced
                        if (gl.autoAdjustColumnWidth) {
                            // Update the column value when autoAdjustment is necessary
                            newColCount = Math.ceil(items.length / gl.rows);
                        } else if (gl.autoAdjustColumnHeight) {
                            // Update the column value when autoAdjustment is necessary
                            newColCount = Math.floor(newContainerWidthNoScroll /
                                (gl.columnWidth + ml));
                        } else {
                            // Preserve the cols value when the items are not
                            // rearrangeable, but the reflow was forced.
                            newColCount = gl.cols;
                        }
                    }
                    // D.A. 18. July 2013 Bug#147162 Items do not rearrange when restoring the browser
                    // and the width of the container is less than the minimum column count
                    if (gl.minColCount > newColCount) {
                        newColCount = gl.minColCount;
                    }
                    // Rearrange only when the new column count value is different from the old one
                    if (newColCount !== gl.cols || forceReflow) {
                        if (newColCount === gl.initialCols) {
                            // D.A. 12th May 2014, Bug #160622, Preserve the initial configuration when reflowing
                            items = gl.sortedItems = $.extend(true, [], gl.initialSortedItems);
                            gl.rows = gl.initialRows;
                            gl.cols = gl.initialCols;
                        } else {
                            gl.cols = newColCount;
                            helperArray = [[]];
                            helperArray[0].length = gl.cols;

                            // Rearrange items to best fit in the container and to keep their original order
                            for (i = 0; i < items.length; i++) {
                                itemData = items[i];
                                colSpan = itemData.colSpan;
                                rowSpan = itemData.rowSpan;
                                foundMatch = false;
                                // Create array with 1 row and the same number of columns as the grid layout.
                                // Search for a matching position for each item.
                                // If such position cannot be found, add new row to the array.
                                // Keep the items order as in the items array.
                                // When a matching position is found, mark it as occupied.
                                // Change the item colIndex and rowIndex according to the position found.
                                // "j" is the rowIndex. "k" is the colIndex.
                                // Animate the items to their new positions.
                                for (j = 0; j < helperArray.length && !foundMatch; j++) {
                                    for (k = 0; k < helperArray[j].length && !foundMatch; k++) {
                                        // Check if the position is occupied
                                        if (!helperArray[j][k]) {
                                            foundMatch = true;
                                            for (r = 0; foundMatch && r < rowSpan * colSpan; r++) {
                                                if (colSpan > helperArray[j].length - k) {
                                                    foundMatch = false;
                                                } else {
                                                    currentRow = j + Math.floor(r / colSpan);
                                                    if (!helperArray[currentRow]) {
                                                        helperArray[currentRow] = [];
                                                        helperArray[currentRow].length = gl.cols;
                                                    }
                                                    if (helperArray[currentRow][k + (r % colSpan)] === 1) {
                                                        foundMatch = false;
                                                    }
                                                }
                                            }
                                        }
                                        if (foundMatch) {
                                            itemData.rowIndex = j;
                                            itemData.colIndex = k;
                                            // Mark the positions as occupied
                                            for (n = 0; n < rowSpan * colSpan; n++) {
                                                helperArray[itemData.rowIndex + Math.floor(n / colSpan)][
                                                    itemData.colIndex + (n % colSpan)] = 1;
                                            }
                                        } else if (j === (helperArray.length - 1) &&
                                            k === (helperArray[j].length - 1)) {
                                            helperArray[j + 1] = [];
                                            helperArray[j + 1].length = gl.cols;
                                        }
                                    }
                                }
                                //TODO: If no custom items were provided we can fallback to this method
                                //row = items[i].rowIndex;
                                //col = items[i].colIndex;
                                //items[i].rowIndex = Math.floor(i / newColCount);
                                //items[i].colIndex = i % newColCount;
                                //item = self.element.find('> [data-index=' + '"' + i + '"' + ']');
                            }
                            // Recalculate the columnHeight of the items to most efficiently use the container's
                            // height when the rows count changed and the height should be auto adjusted.
                            // This may happen only when no options specifying the columnHeight were set by the user 
                            // (columnHeight, rows and items) and items are rearrangeable or reflow was forced.
                            if (gl.autoAdjustColumnHeight && gl.rows !== helperArray.length) {
                                gl.columnHeightRatio = 1 / helperArray.length;
                                gl.columnHeight = Math.floor(
                                    newContainerHeightNoScroll * gl.columnHeightRatio - mt);
                                colHeightChanged = true;
                            }
                            gl.rows = helperArray.length;
                        }

                        positionsChanged = true;
                    }
                }

                // Adjust the items size and position
                if ((colWidthChanged || colHeightChanged || positionsChanged) || forceReflow) {
                    gl.animating = (positionsChanged && animationDuration > 0) || gl.animating;
                    for (i = 0; i < items.length; i++) {
                        itemData = items[i];
                        item = itemData.item;
                        row = itemData.rowIndex;
                        col = itemData.colIndex;
                        colSpan = itemData.colSpan;
                        rowSpan = itemData.rowSpan;
                        newDim = {};
                        // Animate to the new values when the items positions changed.
                        // When the columnWidth/Height is changed while animation is
                        // still running (e.g. from container resizing), animate to the new values.
                        if (positionsChanged || gl.animating) {
                            newDim.left = (col * gl.columnWidth + (col + 1) * ml) + leftOffset;
                            newDim.top = (row * gl.columnHeight + (row + 1) * mt) + topOffset;
                            if (colWidthChanged || forceReflow) {
                                newDim.width = colSpan * gl.columnWidth + (colSpan - 1) * ml;
                            }
                            if (colHeightChanged || forceReflow) {
                                newDim.height = rowSpan * gl.columnHeight + (rowSpan - 1) * mt;
                            }
                            if (animationDuration > 0) {
                                // Animate the items to their new positions when animation duration is greater than 0.
                                // Trigger the internal resized event in the callback.
                                item.animate(newDim, {
                                    duration: animationDuration,
                                    queue: false,
                                    complete: rearrangeCallback
                                });
                            } else {
                                item.css(newDim);
                            }
                        } else {
                            if (colWidthChanged || forceReflow) {
                                newDim.left = (col * gl.columnWidth + (col + 1) * ml) + leftOffset;
                                newDim.width = colSpan * gl.columnWidth + (colSpan - 1) * ml;
                            }
                            if (colHeightChanged || forceReflow) {
                                newDim.top = (row * gl.columnHeight + (row + 1) * mt) + topOffset;
                                newDim.height = rowSpan * gl.columnHeight + (rowSpan - 1) * mt;
                            }
                            item.css(newDim);
                        }
                    }
                }

                // When items are animating the event will be triggered
                // in the callback when all animations are completed.
                if (!gl.animating) {
                    if (this._glReflowNeeded()) {
                        this.reflow(false, animationDuration, event);
                    } else {
                        // Sets the initial grid layout config after the layout is initially reflowed
                        if (gl.initialReflow) {
                            this._setGlInitialConfig();
                            gl.initialReflow = false;
                        }
                        this._triggerInternalResized(event);
                    }
                }
            }
        },
        _initBorderLayout: function () {
            var left, right, center, header, footer,
                rwidth, lwidth, container, sections,
                maxHeight, currHeight, i,
				bl = this.options.borderLayout;
            this.element.addClass(this.css.border);
            // init from markup
            left = this.element.find(".left");
            header = this.element.find(".header");
            right = this.element.find(".right");
            center = this.element.find(".center");
            footer = this.element.find(".footer");
            // create elements if they don't exist
            if (left.length === 0 && bl.showLeft) {
                this._trigger(this.events.itemRendering, null, { region: "left" });
                left = $("<div></div>").appendTo(this.element);
                this._removeLeft = true;
                this._trigger(this.events.itemRendered, null, { region: "left", element: left });
            }
            left.addClass(this.css.borderItem).addClass(this.css.borderLeft);
            if (right.length === 0 && bl.showRight) {
                this._trigger(this.events.itemRendering, null, { region: "right" });
                right = $("<div></div>").appendTo(this.element);
                this._removeRight = true;
                this._trigger(this.events.itemRendered, null, { region: "right", element: right });
            }
            right.addClass(this.css.borderItem).addClass(this.css.borderRight);
            if (center.length === 0) {
                this._trigger(this.events.itemRendering, null, { region: "center" });
                center = $("<div></div>").appendTo(this.element);
                this._removeCenter = true;
                this._trigger(this.events.itemRendered, null, { region: "center", element: center });
            }
            center.addClass(this.css.borderItem).addClass(this.css.borderCenter);
            if (footer.length === 0 && bl.showFooter) {
                this._trigger(this.events.itemRendering, null, { region: "footer" });
                footer = $("<div></div>").appendTo(this.element);
                this._removeFooter = true;
                this._trigger(this.events.itemRendered, null, { region: "footer", element: footer });
            }
            footer.addClass(this.css.borderItem).addClass(this.css.borderFooter);
            if (header.length === 0 && bl.showHeader) {
                this._trigger(this.events.itemRendering, null, { region: "header" });
                header = $("<div></div>").appendTo(this.element);
                this._removeHeader = true;
                this._trigger(this.events.itemRendered, null, { region: "header", element: header });
            }
            header.addClass(this.css.borderItem).addClass(this.css.borderHeader);
            // create container element
            //wrapper1 = $("<div></div>").appendTo(this.element).addClass(this.css.borderWrapper1);
            //wrapper2 = $("<div></div>").appendTo(wrapper1).addClass(this.css.borderWrapper2);
            container = $("<div></div>").appendTo(this.element).addClass(this.css.borderContainer)
				.append(left)
				.append(right)
				.append(center);
            // put footer at the end
            this.element.append(footer);
            // check sizes if we have them set via options
            // check if we have size of the left col defined in options
            if (bl.leftWidth !== null && bl.showLeft) {
                left.css("width", bl.leftWidth);
                /* K.D. May 28th, 2013 Bug #140104 Horizontal scrollbar is always displayed in the browser when using border layout */
                //left.css("right", bl.leftWidth);
                //container.css("padding-left", bl.leftWidth);
            } else if (bl.showLeft === false || left.length === 0) {
                container.css("padding-left", 0);
            }
            if (bl.rightWidth !== null && bl.showRight) {
                right.css("width", bl.rightWidth);
                /* K.D. May 28th, 2013 Bug #140104 Horizontal scrollbar is always displayed in the browser when using border layout */
                //container.css("padding-right", bl.rightWidth);
            } else if (bl.showRight === false || right.length === 0) {
                container.css("padding-right", 0);
            }
            lwidth = bl.leftWidth && bl.leftWidth.indexOf && bl.leftWidth.indexOf("%") !== -1 ? 0 : parseInt(bl.leftWidth, 10);
            rwidth = bl.rightWidth && bl.rightWidth.indexOf && bl.rightWidth.indexOf("%") !== -1 ? 0 : parseInt(bl.rightWidth, 10);
            this.element.css('min-width', lwidth + rwidth);
            // D.A. 13th March 2014 Bug #164295 Layout Manager in border layout mode doesn't set height correctly
            this._opt.borderLayout = {
                header: header,
                footer: footer,
                paddingTop: null,
                paddingBottom: null
            };
            this._setBorderLayoutPaddings();
            // D.A. 29th April 2014, Bug #169730 Set default height equal to the maximum height of the sections
            if (this.options.height === null) {
                sections = left.add(right).add(center);
                for (i = 0, maxHeight = 0; i < sections.length; i++) {
                    currHeight = sections.eq(i).outerHeight(true);
                    if (currHeight > maxHeight) {
                        maxHeight = currHeight;
                    }
                }
                this.element.height(maxHeight);
            }
            this._trigger(this.events.rendered, null, { owner: this });
        },
        _setBorderLayoutPaddings: function () {
            var headerHeight, footerHeight,
                _bl = this._opt.borderLayout;
            if (_bl.header.length) {
                headerHeight = _bl.header.outerHeight(true);
                if (_bl.paddingTop !== headerHeight) {
                    _bl.paddingTop = headerHeight;
                    this.element.css("paddingTop", _bl.paddingTop);
                }
            }
            if (_bl.footer.length) {
                footerHeight = _bl.footer.outerHeight(true);
                if (_bl.paddingBottom !== footerHeight) {
                    _bl.paddingBottom = footerHeight;
                    this.element.css("paddingBottom", _bl.paddingBottom);
                }
            }
        },
        // reflowBorder: function (event) {
        // var center = this.element.find('.ig-layout-border-center'),
        // bl = this.options.borderLayout,
        // lwidth = bl.showLeft ? parseInt(bl.leftWidth, 10) : 0,
        // rwidth = bl.showRight ? parseInt(bl.rightWidth, 10) : 0,
        // cwidth = this.element.width() - lwidth - rwidth;
        // center.css("width", cwidth);
        // },
        _initFlowLayout: function () {
            var i, length = this.options.itemCount, items = this.options.items, item;
            this.element.addClass(this.css.flow);
            if (length > 0) {
                for (i = 0; i < length; i++) {
                    this._trigger(this.events.itemRendering, null, { index: i });
                    item = $("<li></li>").appendTo(this.element).addClass(this.css.flowItem);
                    this.options.destroyItems = true;
                    this._trigger(this.events.itemRendered, null, { item: item, index: i });
                }
                this._trigger(this.events.rendered, null, { owner: this });
            } else if (items && items.length > 0) {
				this.element.empty();
                for (i = 0; i < items.length; i++) {
                    this._trigger(this.events.itemRendering, null, { itemData: items[i], index: i });
                    item = $("<li></li>").appendTo(this.element).addClass(this.css.flowItem);
                    if (items[i].width) {
                        item.css("width", items[i].width);
                    }
                    if (items[i].height) {
                        item.css("height", items[i].height);
                    }
                    this._trigger(this.events.itemRendered, null, { item: item, index: i });
                }
                this.options.destroyItems = true;
                this._trigger(this.events.rendered, null, { owner: this });
            } else {
                this.element.children().addClass(this.css.flowItem);
            }
        },
        _triggerInternalResizing: function (event) {
            var args = {
                owner: this
            };
            return this._trigger(this.events.internalResizing, event, args);
        },
        _triggerInternalResized: function (event) {
            var args = {
                owner: this
            };
            return this._trigger(this.events.internalResized, event, args);
        },
        /* recalculates the layout, if it can be done all via CSS, this is not necessary */
        /*
		_doGridLayout: function () {
		
		},
		_doBorderLayout: function () {
			throw new Error("Not Implemented");
		},
		_doFlowLayout: function () {
			throw new Error("Not Implemented");
		},
		*/
        _destroyBorderLayout: function () {
            this.element.removeClass(this.css.border);
            this.element.find('.' + this.css.borderLeft).unwrap();
            if (this._removeLeft) {
                this.element.children('.' + this.css.borderLeft).remove();
            }
            if (this._removeRight) {
                this.element.children('.' + this.css.borderRight).remove();
            }
            if (this._removeCenter) {
                this.element.children('.' + this.css.borderCenter).remove();
            }
            if (this._removeHeader) {
                this.element.children('.' + this.css.borderHeader).remove();
            }
            if (this._removeFooter) {
                this.element.children('.' + this.css.borderFooter).remove();
            }
            this.element.children().removeClass(this.css.borderItem)
                .removeClass(this.css.borderLeft)
                .removeClass(this.css.borderRight)
                .removeClass(this.css.borderCenter)
                .removeClass(this.css.borderFooter)
                .removeClass(this.css.borderHeader);
        },
        _destroyGridLayout: function () {
            var $children = this.element.children();

            // S.T., D.A 29th April 2014, Bug #169723: Remove dynamically added markup
            $children
                .slice(this._opt.gridLayout.destroyItemsFromIndex)
                    .remove();

            $children
                    .removeClass(this.css.item)
                    .removeClass(this.css.gridItemAbs)
                    .removeClass(this.css.gridItemRel)
                    .removeAttr('data-index');
        },
        _destroyFlowLayout: function () {
            this.element.removeClass(this.css.flow);
            if (this.options.destroyItems) {
                this.element.empty();
            } else {
                this.element.children().removeClass(this.css.flowItem);
            }
        },
        _destroyVerticalLayout: function () {
            this.element.removeClass(this.css.vertical);
            if (this.options.destroyItems) {
                this.element.empty();
            } else {
                this.element.children().removeClass(this.css.verticalItem);
            }
        },
        destroy: function () {
            /* destroy is part of the jQuery UI widget API and does the following:
				1. Remove custom CSS classes that were added.
				2. Remove any elements that were added at widget's initialization and after that, which didn't below to the original markup
				3. Unbind all events that were bound.
			*/
            $.Widget.prototype.destroy.apply(this, arguments);
            this.element.removeClass(this.css.container);
            switch (this.options.layoutMode) {
            case 'grid':
                this._destroyGridLayout();
                break;
            case 'border':
                this._destroyBorderLayout();
                break;
            case 'flow':
                this._destroyFlowLayout();
                break;
            case 'vertical':
                this._destroyVerticalLayout();
                break;
            default:
                break;
            }
            if (this._opt.resizeLayout) {
                //D.A. 24th October 2013 Remove the attached window events upon destroy
                this.element.off('resize', this._opt.eventHandlers.elementResizeHandler);
                $(window).off('resize', this._opt.eventHandlers.windowResizeHandler);
            }
            return this;
        }
    });
    $.extend($.ui.igLayoutManager, { version: '14.1.20141.2249' });
}(jQuery));
/*!@license
 * Infragistics.Web.ClientUI Splitter 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *  jquery-1.4.4.js
 *	infragistics.util.js
 *	infragistics.ui.splitter-en.js
 */

/*global jQuery, document, window */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {
	/*
		igSplitter is a widget based on jQuery UI that manages layout into two panels with split bar and providers the end user with a rich interaction functionality including the ability to expand/collapse panel, and resize panels via split bar.
	*/
	$.widget('ui.igSplitter', {
		_const: {
			orientations: {
				horizontal: {
					size: 'height',
					oppositeSize: 'width',
					outerSize: 'outerHeight',
					dimention: 'top',
					start: '_startY',
					mouse: '_mouseStartY',
					page: 'pageY',
					keyboard: ['UP', 'DOWN']
				},
				vertical: {
					size: 'width',
					oppositeSize: 'height',
					outerSize: 'outerWidth',
					dimention: 'left',
					start: '_startX',
					mouse: '_mouseStartX',
					page: 'pageX',
					keyboard: ['LEFT', 'RIGHT']
				}
			},
			// S.T. 21 May 2013 #142543
			// Added propeties _min and _max in order to hold percentage size of the panel
			properties: ["max", "_max", "min", "_min", "size", "collapsed", "collapsible", "resizable"],
			step: 10,
			touchEvents: {
				mousedown: "touchstart",
				mouseup: "touchend",
				mousemove: "touchmove",
				mouseenter: "",
				mouseleave: "",
				focus: "focus",
				blur: "blur",
				keydown: "keydown"
			}
		},
		css: {
			/* classes applied to the top container element */
			splitter: 'ui-igsplitter ui-widget ui-widget-content',
			/* classes applied to the vertical panel in the splitter */
			verticalPanel: 'ui-igsplitter-panel-vertical ui-widget-content',
			/* classes applied to the horizontal panel in the splitter */
			horizontalPanel: 'ui-igsplitter-panel-horizontal ui-widget-content',
			/* class applied to the split bar in the splitter */
			bar: 'ui-igsplitter-splitbar',
			/* classes defining the default state style of the split bar */
			barNormal: 'ui-igsplitter-splitbar-default ui-state-default',
			/* class defining the collapsed state style of the split bar */
			barCollapsed: 'ui-igsplitter-splitbar-collapsed',
			/* classes defining the hover state style of the split bar */
			barHover: 'ui-igsplitter-splitbar-hover ui-state-hover',
			/* classes defining the focus state style of the split bar */
			barActive: 'ui-igsplitter-splitbar-focus ui-state-focus',
			/* class defining the invalid state style of the split bar */
			barInvalid: 'ui-igsplitter-splitbar-invalid',
			/* class applied to the resize handler in the split bar */
			resizeHandler: 'ui-igsplitter-splitbar-resize-handler',
			/* class applied to the inner resize handler in the split bar */
			resizeHandlerInner: 'ui-igsplitter-splitbar-resize-handler-inner',
			/* class applied to the left vertical collapse button in the split bar when it is expanded */
			verticalCollapseButtonLeftExpanded: 'ui-igsplitter-collapse-button-vertical-left',
			/* classes defining the left expanded collapse button icon in vertical orientation */
			verticalCollapseButtonLeftExpandedIcon: 'ui-icon ui-icon-triangle-1-w',
			/* class applied to the left vertical collapse button in the split bar when it is collapsed  */
			verticalCollapseButtonLeftCollapsed: 'ui-igsplitter-collapse-button-vertical-left',
			/* class defining the left collapsed button icon in vertical orientation */
			verticalCollapseButtonLeftCollapsedIcon: 'ui-icon ui-icon-triangle-1-e',
			/* class applied to the right vertical collapse button in the split bar when it is expanded */
			verticalCollapseButtonRightExpanded: 'ui-igsplitter-collapse-button-vertical-right',
			/* class defining the right expanded button icon in vertical orientation */
			verticalCollapseButtonRightExpandedIcon: 'ui-icon ui-icon-triangle-1-e',
			/* class applied to the right vertical button in the split bar when it is collapsed */
			verticalCollapseButtonRightCollapsed: 'ui-igsplitter-collapse-button-vertical-right',
			/* class defining the right collapsed button icon in vertical orientation */
			verticalCollapseButtonRightCollapsedIcon: 'ui-icon ui-icon-triangle-1-w',
			/* class applied to the left horizontal collapse button in the split bar when it is expanded */
			horizontalCollapseButtonLeftExpanded: 'ui-igsplitter-collapse-button-horizontal-left',
			/* class defining the left expanded button icon in horizontal orientation */
			horizontalCollapseButtonLeftExpandedIcon: 'ui-icon ui-icon-triangle-1-n',
			/* class applied to the left horizontal collapse button in the split bar when it is collapsed */
			horizontalCollapseButtonLeftCollapsed: 'ui-igsplitter-collapse-button-horizontal-left',
			/* class defining the right collapsed button icon in horizontal orientation */
			horizontalCollapseButtonLeftCollapsedIcon: 'ui-icon ui-icon-triangle-1-s',
			/* class applied to the right horizontal collapse button in the split bar when it is expanded */
			horizontalCollapseButtonRightExpanded: 'ui-igsplitter-collapse-button-horizontal-right',
			/* class defining the right expanded button icon in horizontal orientation */
			horizontalCollapseButtonRightExpandedIcon: 'ui-icon ui-icon-triangle-1-s',
			/* class applied to the right horizontal collapse button in the split bar when it is collapsed */
			horizontalCollapseButtonRightCollapsed: 'ui-igsplitter-collapse-button-horizontal-right',
			/* class defining the right collapsed button icon in horizontal orientation */
			horizontalCollapseButtonRightCollapsedIcon: 'ui-icon ui-icon-triangle-1-n',
			/* class defining the default state style of the button */
			collapseButtonDefault: 'ui-state-default',
			/* class applied to a button in the split bar when it is single */
			collapseButtonSingle: 'ui-igsplitter-collapse-single-button',
			/* class defining the pressed state style of the button */
			collapseButtonPressed: 'ui-igsplitter-collapse-button-pressed',
			/* classes defining the hover state style of the button */
			collapseButtonHover: 'ui-igsplitter-collapse-button-hover ui-state-hover',
			/* classes disabling the panel scrolling while width is zero */
			noScroll: 'ui-igsplitter-no-scroll'
		},
		events: {
			/* cancel="false" fired after collapsing is performed 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the splitter instance.
				Use ui.index to get an index of collased panel.
			*/
			collapsed: 'collapsed',
			/* cancel="false" fired after expanding is performed 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the splitter instance.
				Use ui.index to get an index of expanded panel.
			*/
			expanded: 'expanded',
			/* cancel="false" fired before split bar move is performed 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the splitter instance.
			*/
			resizeStarted: 'resizeStarted',
			/* cancel="true" fired while split bar move is performed 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the splitter instance.
			*/
			resizing: 'resizing',
			/* cancel="false" fired after split bar move is performed 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the splitter instance.
			*/
			resizeEnded: 'resizeEnded',
			/* cancel="true" Fired before the panels are going to go refreshed because of browser's resizing.
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the splitter instance.*/
			layoutRefreshing: 'layoutRefreshing',
			/* cancel="false" fired after the panels are refreshed because of browser's resizing.
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the splitter instance.*/
			layoutRefreshed: 'layoutRefreshed'
		},
		options: {
			/* type="string|number|null" Gets sets how the width of the control can be set.
				string The widget width can be set in pixels (px) and percentage (%).
				number The widget width can be set as a number in pixels.
				null type="object" will stretch to fit data, if no other widths are defined.
			*/
			width: null,
			/* type="string|number|null" Gets sets how the height of the control can be set.
				string The height width can be set in pixels (px) and percentage (%).
				number The height width can be set as a number in pixels.
				null type="object" will fit the tree inside its parent container, if no other widths are defined.
			*/
			height: null,
			/* type="vertical|horizontal" Specifies the orientation of the splitter.
				vertical type="string"                
				horizontal type="string"
				*/
			orientation: 'vertical',
			/* type="enumeration" Specifies the panel settings. The panels are no more than two. Settings are specified via enumeration.
			size="string|int"
			min type="string|int"
			max type="string|int"
			resizable type="bool"
			collapsed type="bool"
			collapsible type="bool"
			*/
			panels: [],
			/* type="int" Specifies drag delta of the split bar. In order to start dragging move, the mouse has to be moved specific distance from original position. */
			dragDelta: 3,
            /* type="boolean" Specifies whether the other splitters on the page will be resized as this splitter resizes. */
            resizeOtherSplitters: true
		},
		widget: function () {
			/* Returns the element that represents this widget.
				returnType="object" Returns the element that represents this widget.
			*/
			return this.element;
		},
		_createWidget: function (options, element) {
			this._opt = {
				eventHandlers: {}
			};
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		_create: function () {
			var splitters, length = $(this.element.children("div")).length;
			this._htmlMarkup = this.element.html();
			if (this.options.panels.length > 2 || length > 2) {
				throw new Error($.ig.Splitter.locale.errorPanels);
			}
			if (length === 1) {
				this.element.append("<div/>");
			} else if (length === 0) {
				this.element.append("<div/>");
				this.element.append("<div/>");
			}
			this._panels = [];
			this._splitter = {};
			splitters = $.data(document.body, "ig-splitters") || [];
			splitters.push(this.element);
			$.data(document.body, "ig-splitters", splitters);
			if (this.options.width) {
				this.element.css('width', this.options.width);
			}
			if (this.options.height) {
				this.element.css('height', this.options.height);
			}
			this._render();
			this._removeClasses();
			this._addClasses();
			this._removeEventHandlers();
			this._addEventHandlers();
			this._panelsLayout();
		},
		_setOption : function(option, value){
		    var oldWidth, oldHeight;

			if (this.options[option] === value) {
				return;
			}

			$.Widget.prototype._setOption.apply(this, arguments);
			
			switch(option) {
			case "width":
				oldWidth = this.element.width();
				this.element.css('width', value);
					
				if(this.options.orientation === "vertical"){
					this._setPanelsNewWidth(value, oldWidth);
				}
					
				this._panelsLayout();
				break;
			case "height":
				oldHeight = this.element.height();
				this.element.css('height', value);
					
				if(this.options.orientation === "horizontal"){
					this._setPanelsNewHeight(value, oldHeight);
				}
					
				this._panelsLayout();
				break;
			case "orientation":
			case "panels":
			    throw new Error($.ig.Splitter.locale.errorSettingOption);
			    break;
			default:
				break;
			}
		},
		_setPanelsNewWidth: function(newWidth, oldWidth){
			var secondPanelRatio = this.secondPanel().width() / oldWidth;
				
			this.setSecondPanelSize(newWidth * secondPanelRatio);
		},
		_setPanelsNewHeight: function(newHeight, oldHeight){
			var secondPanelRatio = this.secondPanel().height() / oldHeight;
				
			this.setSecondPanelSize(newHeight * secondPanelRatio);
		},
		_render: function () {
			//D.U. 8st July 2014 default size always NaN while width or height was set with percentage.
			var panels = $(this.element.children("div")), panel, self = this, reducedSize, defaultSize = 0, j, elementSize;
			reducedSize = this._reducedSize();
			if (this.options[this._getOrientation("size")]) {
				//D.U. 8st July 2014 default size always NaN while width or height was set with percentage.
				elementSize = this._getOrientation("size") === "width" ? this.element.width() : this.element.height();
				defaultSize = elementSize - reducedSize.size;
			} else {
				defaultSize = this._getSize(this._getOrientation("size")) - reducedSize.size;
			}
			if ((panels.length - reducedSize.length) !== 0) {
				defaultSize = Math.floor(defaultSize / (panels.length - reducedSize.length));
			}
			if (this._panels.length < 1) {
				panels.each(function (i, element) {
					panel = $(element);
					// S.T. 21 May 2013 #142543
					// Added propeties _min and _max in order to hold percentage size of the panel. Here, they are initiliazed to 0% for _min and 1005 for _max.
					panel.options = {
						max: 9007199254740992,
						_max: "100%",
						min: 0,
						_min: "0",
						collapsible: false,
						resizable: true,
						collapsed: false,
						size: panel[self._getOrientation("size")]()
					};
					for (j = 0; j < self._const.properties.length; j++) {
						if (self.options.panels[i] && self.options.panels[i][self._const.properties[j]] !== undefined && self.options.panels[i][self._const.properties[j]] !== null) {
							panel.options[self._const.properties[j]] = self.options.panels[i][self._const.properties[j]];
						} else {
							if (self._const.properties[j] === "size") {
								if (panel[0].style[self._getOrientation("size")] !== "auto" && panel[0].style[self._getOrientation("size")] !== "") {
									panel.options.size = panel[self._getOrientation("size")]();
								} else {
									panel.options.size = defaultSize;
								}
							}
						}
					}
					self._panels.push(panel);
				});
				this._createSplitter();
			}
		},
		_reducedSize: function () {
			var i, reducedSize = {"size": 0, "length": 0}, size = 0;
			for (i = 0; i < this.options.panels.length; i++) {
				size = 0;
				if (this.options.panels[i].size !== undefined) {
					if(/%/.test(this.options.panels[i].size)) {
						this.options.panels[i].size = this.options.panels[i].size.replace("%", "") * this._getSize(this._getOrientation("size")) / 100;
						this._isPercentLayout = true;
					}
					if(/px/.test(this.options.panels[i].size)) {
						this.options.panels[i].size = parseInt(this.options.panels[i].size, 10);
					}
					if(/px/.test(this.options.panels[i].min)) {
						this.options.panels[i].min = parseInt(this.options.panels[i].min, 10);
					}
					if(/%/.test(this.options.panels[i].min)) {
						// S.T. 21 May 2013 #142543
						// If the layout is in percentage then keep min size in percentage
						this.options.panels[i]._min = this.options.panels[i].min;
						this.options.panels[i].min = this.options.panels[i].min.replace("%", "") * this._getSize(this._getOrientation("size")) / 100;
					}
					if(/px/.test(this.options.panels[i].max)) {
						this.options.panels[i].max = parseInt(this.options.panels[i].max, 10);
					}
					if(/%/.test(this.options.panels[i].max)) {
						// S.T. 21 May 2013 #142543
						// If the layout is in percentage then keep max size in percentage
						this.options.panels[i]._max = this.options.panels[i].max;
						this.options.panels[i].max = this.options.panels[i].max.replace("%", "") * this._getSize(this._getOrientation("size")) / 100;
					}
					size = this.options.panels[i].size;
					reducedSize.length += 1;
				}
				reducedSize.size += size;
			}
			return reducedSize;
		},
		_getSize: function (size) {
			//S.T. 8 May 2013 #140833 and #142820
			//The container in JSFiddle that’s hold the splitter control has float width - 834.5px. 
			//The splitter is initialized without width. So, it’s width 799.5px in IE9. In Chrome, the splitter has width 800px. 
			//When it gets container width in IE9 with jQuery function width(), the result is 800px, not 799.5px. And that’s cause the issue.
			//Now, it is using getComputedStyle in order to take the container width direclty from DOM (if getComputedStyle is defined)
			//getComputedStyle is not supported in IE7 and IE8
			var boxSizing = this.element.css("box-sizing"), value;
			if (window.getComputedStyle !== undefined) {
				value = parseInt(window.getComputedStyle(this.element[0])[size], 10);
				// S.T. 22 May 2013 #142262
				// If the cointaner is with border box and the browser is Chrome, in the computed style of the element is not include border width
				if ($.ig.util.isChrome && boxSizing === "border-box") {
					value -= parseInt(this.element.css("border-width"), 10) * 2;
				}
				return value;
			}
			return this.element[size]();
		},
		_getOrientation: function (property) {
			return this._const.orientations[this.options.orientation][property];
		},
		_getEvent: function (event) {
			if (this._isTouch()) {
				return this._const.touchEvents[event];
			}
			return event;
		},
		_isTouch: function () {
			var isTouch = typeof window.Modernizr === 'object' && window.Modernizr.touch === true;
			return isTouch;
		},
		_createSplitter: function () {
			var collapseButtons = $("<div><span></span></div><div><span></span></div>"), bar = $("<div></div>").attr("tabindex", 0), self = this,
				div, topMarginButtonLeftCollapsed;
			this._splitter = {
				left: this._panels[0],
				right: this._panels[1]
			};
			bar.insertAfter(this._panels[0]);
			this._splitter.bar = bar;
			this._splitter.bar.append(collapseButtons);
			div = $("<div/>").appendTo(this._splitter.bar);
			//D.A. 31st October 2013 JSLint validation. Removing unused variable span.
			$("<span></span>")[this._getOrientation("size")](this._splitter.bar[this._getOrientation("size")]).attr('title', '').appendTo(div);

			if($.ig.util.isIEOld){
				setTimeout(function(){
					topMarginButtonLeftCollapsed = $('.ui-igsplitter-collapse-button-vertical-left.ui-state-default').css('margin-top');
					$('.ui-igsplitter-collapse-button-vertical-left.ui-state-default').css('margin-top', topMarginButtonLeftCollapsed);
				}, 1);
			}
			
		},
		_removeClasses: function () {
			var buttonLeft, buttonRight, resizeHandler, i;
			this.element.removeClass(this.css.splitter);
			for (i = 0; i < this._panels.length; i++) {
				this._panels[i].removeClass(this.css[this.options.orientation + "Panel"]);
			}
			this._splitter.bar.removeClass(this.css.bar + "-" + this.options.orientation);
			this._splitter.bar.removeClass(this.css.barNormal);
			this._splitter.bar.removeClass(this.css.barCollapsed);
			buttonLeft = $(this._splitter.bar.children()[0]);
			buttonRight = $(this._splitter.bar.children()[1]);
			buttonLeft.removeClass(this.css[this.options.orientation + "CollapseButtonLeftExpanded"]);
			buttonRight.removeClass(this.css[this.options.orientation + "CollapseButtonRightExpanded"]);
			buttonLeft.removeClass(this.css.collapseButtonDefault);
			buttonRight.removeClass(this.css.collapseButtonDefault);
			resizeHandler = $(this._splitter.bar.children()[2]);
			resizeHandler.removeClass(this.css.resizeHandler + "-" + this.options.orientation);
			$(resizeHandler.children()[0]).removeClass(this.css.resizeHandlerInner + "-" + this.options.orientation);
		},
		_addClasses: function () {
			var buttonLeft, buttonRight, i, resizeHandler;
			this.element.addClass(this.css.splitter);
			for (i = 0; i < this._panels.length; i++) {
				this._panels[i].addClass(this.css[this.options.orientation + "Panel"]);
			}
			this._splitter.bar.addClass(this.css.bar + "-" + this.options.orientation);
			this._splitter.bar.addClass(this.css.barNormal);
			if (this._panels[0].options.collapsed || this._panels[1].options.collapsed) {
				this._splitter.bar.addClass(this.css.barCollapsed);
			}
			buttonLeft = $(this._splitter.bar.children()[0]);
			buttonRight = $(this._splitter.bar.children()[1]);
			buttonLeft.addClass(this.css[this.options.orientation + "CollapseButtonLeftExpanded"]);
			$(buttonLeft.children()).addClass(this.css[this.options.orientation + "CollapseButtonLeftExpandedIcon"]);
			buttonRight.addClass(this.css[this.options.orientation + "CollapseButtonRightExpanded"]);
			$(buttonRight.children()).addClass(this.css[this.options.orientation + "CollapseButtonRightExpandedIcon"]);
			resizeHandler = $(this._splitter.bar.children()[2]);
			resizeHandler.addClass(this.css.resizeHandler + "-" + this.options.orientation);
			$(resizeHandler.children()[0]).addClass(this.css.resizeHandlerInner + "-" + this.options.orientation);
			if (!this._panels[0].options.collapsible) {
				buttonLeft.hide();
				buttonRight.addClass(this.css.collapseButtonSingle);
			}
			if (!this._panels[1].options.collapsible) {
				buttonRight.hide();
				buttonLeft.addClass(this.css.collapseButtonSingle);
			}
			buttonLeft.addClass(this.css.collapseButtonDefault);
			buttonRight.addClass(this.css.collapseButtonDefault);
		},
		_removeEventHandlers: function () {
			$(this._splitter.bar).unbind(this._getEvent("focus"), 
				this._getEvent("blur"), 
				this._getEvent("keydown"));
			$(this._splitter.bar.children()[0]).unbind(this._getEvent("mousedown"));			
			$(this._splitter.bar.children()[1]).unbind(this._getEvent("mousedown"));
			//T.P. Bug #155452 fix _removeEventHandlers so when under mobile devices mouseenter and mouseleave are not unbinded
			if (!this._isTouch()) {
				$(this._splitter.bar).unbind(this._getEvent("mouseenter"), 
					this._getEvent("mouseleave"));	
				$(this._splitter.bar.children()[0]).unbind(this._getEvent("mouseenter"), this._getEvent("mouseleave"));
				$(this._splitter.bar.children()[1]).unbind(this._getEvent("mouseenter"), this._getEvent("mouseleave"));
			}
		},
		_addEventHandlers: function () {
			var self = this;
			self.autoResize = true;
			this._opt.eventHandlers.documentMouseUp = function () {
				self.autoResize = false;
				self._stopDrag(self);
				self.autoResize = true;
				self._lastMove = null;
			};
			$(document).bind(this._getEvent("mouseup") + "." + this.element.attr("id"), this._opt.eventHandlers.documentMouseUp);
			this._opt.eventHandlers.documentMouseMove = function (ev) {
				var noCancel = true;
				self._currentMove = self._isTouch() ? ev.originalEvent.touches[0][self._getOrientation("page")] : ev[self._getOrientation("page")];
				if (self._capturedElement && self._isDragging() && !self._isDrag) {
					self._triggerResizeStarted();
					self._isDrag = true;
				}
				if (self._capturedElement && self._isDragging()) {
					noCancel = self._triggerResizing();
				}							
				if(noCancel && self._isDragging()) {
					self._performDrag(self, ev);
				} else {
					return false;
				}
			};
			$(document).bind(this._getEvent("mousemove") + "." + this.element.attr("id"), this._opt.eventHandlers.documentMouseMove);
			this._opt.eventHandlers.windowResize = function (ev) {
				var noCancel = self._triggerLayoutRefreshing();
				if (noCancel) {
					self._panelsLayout();
					self._triggerLayoutRefreshed();
				}
			};
			$(window).bind("resize." + this.element.attr("id"), this._opt.eventHandlers.windowResize);
			this._addBarHandlers(this._splitter);
			this._addCollapseButtonHandlers($(this._splitter.bar.children()[0]), 0);
			this._addCollapseButtonHandlers($(this._splitter.bar.children()[1]), 1);
		},
		_isDragging: function () {
			return Math.abs(this._currentMove - this._lastMove) > this.options.dragDelta;
		},
		_addBarHandlers: function (splitter) {
			var self = this;
			splitter.bar.bind(this._getEvent("mousedown"), {
				self: this
			}, this._startDrag);
			$(splitter.bar.children()[2]).bind(this._getEvent("mousedown"), {
				self: this
			}, this._startDrag);
			splitter.bar.bind(this._getEvent("keydown"), {
				self: this
			}, this._kbNavigation);
			//T.P. Bug #155452 fix _addBarHandlers so when under mobile devices mouseenter and mouseleave are not binded
			if(!this._isTouch()) {
				splitter.bar.bind(this._getEvent("mouseenter"), function () {
					$(this).addClass(self.css.barHover);
				});
				splitter.bar.bind(this._getEvent("mouseleave"), function () {
						$(this).removeClass(self.css.barHover);
				});
			}
			splitter.bar.bind(this._getEvent("focus"), function () {
					$(this).addClass(self.css.barActive);
			});
			splitter.bar.bind(this._getEvent("blur"), function () {
					$(this).removeClass(self.css.barActive);
			});
		},
		_kbNavigation: function (event) {
			var splitter = event.data.self, noCancel = true;
			// Right/Down
			if (event.keyCode === $.ui.keyCode[splitter._getOrientation("keyboard")[0]]) {
				if (event.ctrlKey) {
					splitter._stopDrag(splitter, true, true);
					if (splitter._panels[1].options.collapsed) {
						splitter.expandAt(1);
					} else if (!splitter._panels[0].options.collapsed) {
						splitter.collapseAt(0);
					}
				} else {
					splitter._startDrag(event);
					splitter._kbMove -= splitter._kbLockRight ? 0 : splitter._getStep();
					if (splitter._capturedElement && !splitter._isDrag) {
						splitter._triggerResizeStarted();
						splitter._isDrag = true;
					}
					if (splitter._capturedElement) {
						noCancel = splitter._triggerResizing();
					}
					if(noCancel) {
						splitter._performDrag(splitter, event);
					} else {
						return false;
					}
					if (splitter._capturedElement && splitter._capturedElement.hasClass(splitter.css.barInvalid)) {
						splitter._kbLockRight = true;
						splitter._kbLockLeft = false;
					} else {
						splitter._kbLockRight = false;
						splitter._kbLockLeft = false;
					}
				}
				event.preventDefault();
			// Left/Up
			} else if (event.keyCode === $.ui.keyCode[splitter._getOrientation("keyboard")[1]]) {
				if (event.ctrlKey) {
					splitter._stopDrag(splitter, true, true);
					if (splitter._panels[0].options.collapsed) {
						splitter.expandAt(0);
					} else if (!splitter._panels[1].options.collapsed) {
						splitter.collapseAt(1);
					}
				} else {
					splitter._startDrag(event);
					splitter._kbMove += splitter._kbLockLeft ? 0 : splitter._getStep();
					if (splitter._capturedElement && !splitter._isDrag) {
						splitter._triggerResizeStarted();
						splitter._isDrag = true;
					}
					if (splitter._capturedElement) {
						noCancel = splitter._triggerResizing();
					}
					if(noCancel) {
						splitter._performDrag(splitter, event);
					} else {
						return false;
					}
					if (splitter._capturedElement && splitter._capturedElement.hasClass(splitter.css.barInvalid)) {
						splitter._kbLockRight = false;
						splitter._kbLockLeft = true;
					} else {
						splitter._kbLockRight = false;
						splitter._kbLockLeft = false;
					}
				}
				event.preventDefault();
			} else if (event.keyCode === $.ui.keyCode.ENTER || event.keyCode === $.ui.keyCode.SPACE) {
				splitter._stopDrag(splitter, false, true);
				event.preventDefault();
			} else if (event.keyCode === $.ui.keyCode.ESCAPE) {
				splitter._stopDrag(splitter, true);
			} else if (event.keyCode === $.ui.keyCode.TAB) {
				splitter._stopDrag(splitter, false, true);
			}
		},
		_startDrag: function (event) {
			var splitter = event.data.self, left, right;
			splitter._splitter.bar.focus();
			splitter._resizeArea = splitter._splitter;
			if (splitter._resizeArea !== null) {
				if ((splitter._resizeArea.left.options.resizable === undefined || splitter._resizeArea.left.options.resizable) && (splitter._resizeArea.right.options.resizable === undefined || splitter._resizeArea.right.options.resizable)) {
					left = splitter._resizeArea.left;
					right = splitter._resizeArea.right;
					if ((!left.options.collapsed && !right.options.collapsed) && !(right.options.max <= right[splitter._getOrientation("outerSize")]() && left.options.max <= left[splitter._getOrientation("outerSize")]())) {
						if (!splitter._capturedElement) {
							splitter._lastMove = splitter._isTouch() ? event.originalEvent.touches[0][splitter._getOrientation("page")] : event[splitter._getOrientation("page")];
							if ($(event.target).is("span")) {
								splitter._capturedElement = splitter._clone($($(event.target).parent()).parent());
							} else {
								splitter._capturedElement = splitter._clone(event.target);
							}
							//S.T. 8 May 2013
							//In IE7 and IE8 left and right are 0 in some reason. This make them to return correct values.
							splitter._capturedElement.offset();
							splitter._startX = splitter._capturedElement.offset().left;
							splitter._startY = splitter._capturedElement.offset().top;
							splitter._kbMove = 0;
							splitter._kbLockLeft = false;
							splitter._kbLockRight = false;
							splitter._mouseStartX = splitter._isTouch() ? event.originalEvent.touches[0].pageX : event.pageX;
							splitter._mouseStartY = splitter._isTouch() ? event.originalEvent.touches[0].pageY : event.pageY;
						}
					}
				}
				return false;
			}
			return false;
		},
		_clone: function (bar) {
			var clonedBar = $(bar).clone();
			clonedBar.css({
				position: "absolute",
				top: $(bar).offset().top,
				left: $(bar).offset().left,
				"z-index": 9999
			}).fadeTo(0, 0.7);
			$(document.body).append(clonedBar);
			return clonedBar;
		},
		_addCollapseButtonHandlers: function (button, index) {
			var self = this;
			button.bind(this._getEvent("mouseenter"), function (e) {
				$($(this).parent()).removeClass(self.css.barHover);
				$(this).addClass(self.css.collapseButtonHover);
				if (e.stopPropagation !== undefined) {
					e.stopPropagation();
				}
				if (e.preventDefault !== undefined) {
					e.preventDefault();
				}
				return false;
			});
			button.bind(this._getEvent("mouseleave"), function (e) {
				$($(this).parent()).addClass(self.css.barHover);
				$(this).removeClass(self.css.collapseButtonHover);
			});
			button.bind("mousedown touchstart", function (e) {
				$(this).toggleClass(self.css.collapseButtonPressed);
				if (self._panels[index].options.collapsed) {
					self.expandAt(index);
				} else {
					self.collapseAt(index);
				}
				if (e.stopPropagation !== undefined) {
					e.stopPropagation();
				}
				if (e.preventDefault !== undefined) {
					e.preventDefault();
				}
				return false;
			});
		},
		_performDrag: function (self, ev) {
			var page = self._isTouch() ? ev.originalEvent.touches[0][self._getOrientation("page")] : ev[self._getOrientation("page")], bar;
			if (ev.which === 0 && $.ig.util.isIE && $.ig.util.isIEOld) {
				self._stopDrag(self);
				return false;
			}
			if (self._capturedElement) {
				if (ev.type === "keydown") {
					bar = self[self._getOrientation("start")] + self._kbMove;
				} else {
					bar = (page - self[self._getOrientation("mouse")]) + self[self._getOrientation("start")];
				}
				self._moveBar(bar);
				return false;
			}
			return true;
		},
		_moveBar: function (bar) {
			bar = this._validatePosition(bar);
			if (bar.invalid) {
				this._capturedElement.addClass(this.css.barInvalid);
			} else {
				this._capturedElement.removeClass(this.css.barInvalid);
			}
			this._capturedElement.css(this._getOrientation("dimention"), bar.position);
		},
		_validatePosition: function (bar) {
			var resizeArea = this._resizeArea,
				rightBoundary = this._getNextBoundary(resizeArea),
				getPreviousBoundary = this._getPreviousBoundary(resizeArea),
				min = Math.min(rightBoundary, rightBoundary - resizeArea.right.options.min, getPreviousBoundary + resizeArea.left.options.max),
				max = Math.max(getPreviousBoundary, getPreviousBoundary + resizeArea.left.options.min, rightBoundary - resizeArea.right.options.max),
				pos;
			if (max > min) {
				pos = resizeArea.right.offset()[this._getOrientation("dimention")] - this._capturedElement[this._getOrientation("outerSize")](true);
				return {
					position: pos,
					invalid: true
				};
			}
			if (bar < max) {
				return {
					position: max,
					invalid: true
				};
			}
			if (bar > min) {
				return {
					position: min,
					invalid: true
				};
			}
			return {
				position: bar,
				invalid: false
			};
		},
		_getNextBoundary: function (panel) {
			var size = panel.right.offset()[this._getOrientation("dimention")] + panel.right[this._getOrientation("size")]() - this._capturedElement[this._getOrientation("outerSize")](true);
			if (panel.right.options.collapsed) {
				size -= panel.right.options.min;
			}
			return size;
		},
		_getPreviousBoundary: function (panel) {
			var size = panel.left.offset()[this._getOrientation("dimention")];
			if (panel.left.options.collapsed) {
				size += panel.left.options.min;
			}
			return size;
		},
		_stopDrag: function (self, cancel, kbMove) {
			if (self._capturedElement) {
				if (!cancel && (self._isDrag || kbMove)) {
					self._performAreaResize();
				}
				self._capturedElement.remove();
				self._isDrag = false;
			}
			self._capturedElement = null;
		},
		_performAreaResize: function () {
			var resizeArea = this._resizeArea,
				offset = this._capturedElement.offset()[this._getOrientation("dimention")] - this[this._getOrientation("start")],
				left = resizeArea.left[this._getOrientation("size")]() + offset,
				right = resizeArea.right[this._getOrientation("size")]() - offset;
			this._setPanelSize(resizeArea.left, left);
			this._setPanelSize(resizeArea.right, right);
			if (offset !== 0) {
				this._triggerResizeEnded();
			}
			this._splittersLayout();
		},
		_splittersLayout: function () {
		    var splitters = $.data(document.body, "ig-splitters") || [],
                $currSplitter, i;
			for (i = 0; i < splitters.length; i++) {
			    $currSplitter = splitters[i];
			    if ($currSplitter === this.element) {
			        $currSplitter.data("igSplitter")._panelsLayout();
			    } else if (this.options.resizeOtherSplitters) {
			        // D.A. 29th April 2014, Bug #164471 Added option whether the other splitters on the page should be resized
			        $currSplitter.data("igSplitter")._panelsLayout();
			    }
			}
		},
		_panelsLayout: function () {
			var i, outerSize = (this._panels.length - 1) * this._splitter.bar[this._getOrientation("outerSize")](true),
				size = this._getSize(this._getOrientation("size")),
			    $splitterBarChildren = this._splitter.bar.children(),
				$currChild,
		        $currChildChildren;
			for (i = 0; i < this._panels.length; i++) {
				if (!this._panels[i].options.collapsed) {
					outerSize += this._handlerPanelSize(this._panels[i], outerSize, size);
				} else {
				    $currChild = $splitterBarChildren.eq(i);
				    $currChildChildren = $currChild.children();

				    this._handlerPanelSize(this._panels[i], outerSize, size);
				    $splitterBarChildren.eq((i + 1) % 2).hide();
				    $currChild.removeClass(this.css[this.options.orientation + "CollapseButton" + (i % 2 === 0 ? 'Left' : 'Right') + "Expanded"]);
				    $currChildChildren.removeClass(this.css[this.options.orientation + "CollapseButton" + (i % 2 === 0 ? 'Left' : 'Right') + "ExpandedIcon"]);
				    $currChild.addClass(this.css[this.options.orientation + "CollapseButton" + (i % 2 === 0 ? 'Left' : 'Right') + "Collapsed"]);
				    $currChildChildren.addClass(this.css[this.options.orientation + "CollapseButton" + (i % 2 === 0 ? 'Left' : 'Right') + "CollapsedIcon"]);
				}
			}
			if (outerSize < size) {
				this._createPanel(size, outerSize, this._panels.length - 1);
			}
			this._splitter.bar[this._getOrientation("oppositeSize")](this.element[this._getOrientation("oppositeSize")]() - 2);
			$splitterBarChildren.eq(2).find("span")[this._getOrientation("oppositeSize")](this.element[this._getOrientation("oppositeSize")]());
		},
		_getStep: function () {
			return this._const.step + this._splitter.bar[this._getOrientation("size")]();
		},
		_handlerPanelSize: function (panel, outerSize, size) {
			// S.T. 21 May 2013 #142543
			// If the layout is in percentage then keep aspect ration while resize the splitter.
			if (this._isPercentLayout) {
				if (panel.options._min !== undefined) {
					panel.options.min = panel.options._min.replace("%", "") * this._getSize(this._getOrientation("size")) / 100;
				}
				if (panel.options._max !== undefined) {
					panel.options.max = panel.options._max.replace("%", "") * this._getSize(this._getOrientation("size")) / 100;
				}
			} 
			this._setPanelSize(panel, panel.options.size);
			var newSize;
			if (outerSize + panel.options.size >= size && !panel.options.collapsed) {
				newSize = size - outerSize;
				// S.T. 21 May 2013 #142543
				// If the layout is in percentage, break the layout.
				//newSize = Math.min(newSize, panel.options.max);
				//newSize = Math.max(newSize, panel.options.min);
				if (!panel.options.collapsed) {
					if (this._isPercentLayout) {
						panel[this._getOrientation("size")]((newSize / this._getSize(this._getOrientation("size"))) * 100 + "%");
					} else {
						panel[this._getOrientation("size")](newSize);
					}
					panel.options.size = newSize;
				}
			}
			return panel[this._getOrientation("outerSize")](true);
		},
		_setPanelSize: function (panel, size) {
			if (!panel.options.collapsed) {
				panel.options.size = parseInt(size, 10);
				// S.T. 21 May 2013 #142543
				// If the layout is in percentage, it hides the scrolbar because it is break the layout
				if (panel.options.size === 0 || (this._isPercentLayout && panel.options.size <= $.ig.util.getScrollWidth())) {
					panel.addClass(this.css.noScroll);
				} else {
					panel.removeClass(this.css.noScroll);
				}
				if (this._isPercentLayout) {
					// S.T. 21 May 2013 #142544
					size = parseInt(size, 10);
					panel[this._getOrientation("size")]((size / this._getSize(this._getOrientation("size"))) * 100 + "%");
				} else {
					panel[this._getOrientation("size")](size);
				}
			} else {
				panel.addClass(this.css.noScroll);
				panel[this._getOrientation("size")](0);
			}
		},
		_createPanel: function (size, outerSize, index) {
			if (index === undefined) {
				index = 0;
			}
			var panel = this._panels[index],
				newSize = size - outerSize,
				panelSize = panel[this._getOrientation("size")](),
				maxSize = newSize + panelSize;
			if (index <= this._panels.length) {
				if (panel.options.collapsed) {
					this._panelHelper(outerSize, size);
				} else {
					if (maxSize > panel.options.max) {
						panel.options.max = maxSize;
					}
					if (this._isPercentLayout) {
						panel[this._getOrientation("size")]((maxSize / this._getSize(this._getOrientation("size"))) * 100 + "%");
					} else {
						panel[this._getOrientation("size")](maxSize);
					}
					panel.options.size = maxSize;
				}
				return;
			}
			maxSize = Math.min(maxSize, panel.options.max);
			if (!panel.options.collapsed) {
				panel[this._getOrientation("size")](maxSize);
				panel.options.size = maxSize;
			} else {
				maxSize = panelSize = 0;
			}
			if (maxSize + (outerSize - panelSize) < size || panel.options.collapsed) {
				this._createPanel(size, (outerSize - panelSize) + maxSize, index - 1);
			}
		},
		_panelHelper: function (outerSize, size) {
			var panel, flag = false, i;
			for (i = 0; i < this._panels.length && !flag; i++) {
				panel = this._panels[i];
				if (!panel.options.collapsed) {
					flag = true;
				}
			}
			panel[this._getOrientation("size")](size - outerSize + panel[this._getOrientation("size")]());
		},
		expandAt: function (index) {
			/* Expand the specified panel.
				paramType="int" optional="false" Specifies the index of the panel to expand.
			*/
			var neighborPanel;
				//animationDuration = 0;
			if (index <= this._panels.length && index >= 0 && this._panels[index].options.collapsed) {
				neighborPanel = this._panels[index % 2 === 0 ? 1 : 0];
				this._panels[index].options.collapsed = false;
				this._panels[index].options.size = Math.min(this._panels[index].options.size, neighborPanel[this._getOrientation("size")]());
				neighborPanel.options.size = neighborPanel[this._getOrientation("size")]() - this._panels[index].options.size;
				this._splitter.bar.removeClass(this.css.barCollapsed);
				if (this._panels[(index + 1) % 2].options.collapsible) {
					$(this._splitter.bar.children()[(index + 1) % 2]).show();
				}
				$(this._splitter.bar.children()[index]).removeClass(this.css.collapseButtonPressed);
				$(this._splitter.bar.children()[index]).removeClass(this.css[this.options.orientation + "CollapseButton" + (index % 2 === 0 ? 'Left' : 'Right') + "Collapsed"]);
				$($(this._splitter.bar.children()[index]).children()).removeClass(this.css[this.options.orientation + "CollapseButton" + (index % 2 === 0 ? 'Left' : 'Right') + "CollapsedIcon"]);
				$(this._splitter.bar.children()[index]).addClass(this.css[this.options.orientation + "CollapseButton" + (index % 2 === 0 ? 'Left' : 'Right') + "Expanded"]);
				$($(this._splitter.bar.children()[index]).children()).addClass(this.css[this.options.orientation + "CollapseButton" + (index % 2 === 0 ? 'Left' : 'Right') + "ExpandedIcon"]);
				//A.T. 12 March 2013
				//this._animateResize(neighborPanel, neighborPanel.options.size, animationDuration);
				//this._animateResize(this._panels[index], this._panels[index].options.size, animationDuration);
				neighborPanel.css(this._getOrientation("size"), neighborPanel.options.size);
				this._panels[index].css(this._getOrientation("size"), this._panels[index].options.size);
				this._splittersLayout();
				this._triggerExpanded(index);
			}
		},
		collapseAt: function (index) {
			/* Collapse the specified panel.
				paramType="int" optional="false" Specifies the index of the panel to collapse.
			*/
			var size, neighborPanel;
				//animationDuration = 0;
			if (index < this._panels.length && index >= 0 && !this._panels[index].options.collapsed && this._panels[index].options.collapsible) {
				size = this._panels[index][this._getOrientation("size")]();
				neighborPanel = this._panels[index % 2 === 0 ? 1 : 0];
				this._panels[index].options.size = size || this._panels[index].options.size;
				this._panels[index].options.collapsed = true;
				this._splitter.bar.addClass(this.css.barCollapsed);
				$(this._splitter.bar.children()[(index + 1) % 2]).hide();
				$(this._splitter.bar.children()[index]).addClass(this.css.collapseButtonPressed);
				$(this._splitter.bar.children()[index]).removeClass(this.css[this.options.orientation + "CollapseButton" + (index % 2 === 0 ? 'Left' : 'Right') + "Expanded"]);
				$($(this._splitter.bar.children()[index]).children()).removeClass(this.css[this.options.orientation + "CollapseButton" + (index % 2 === 0 ? 'Left' : 'Right') + "ExpandedIcon"]);
				$(this._splitter.bar.children()[index]).addClass(this.css[this.options.orientation + "CollapseButton" + (index % 2 === 0 ? 'Left' : 'Right') + "Collapsed"]);
				$($(this._splitter.bar.children()[index]).children()).addClass(this.css[this.options.orientation + "CollapseButton" + (index % 2 === 0 ? 'Left' : 'Right') + "CollapsedIcon"]);
				neighborPanel.options.size = neighborPanel[this._getOrientation("size")]() + size;
				//A.T. 12 March 2013
				//this._animateResize(neighborPanel, neighborPanel.options.size, animationDuration);
				//this._animateResize(this._panels[index], 0, animationDuration);
				neighborPanel.css(this._getOrientation("size"), neighborPanel.options.size);
				this._panels[index].css(this._getOrientation("size"), 0);
				this._splittersLayout();
				this._triggerCollapsed(index);
			}
		},
		_animateResize: function (panel, size, animationDuration, callback) {
			var properties = {}, self = this;
			properties[this._getOrientation("size")] = size;
			panel.animate(properties, {
				step: function () {
					self._splittersLayout();
				},
				duration: animationDuration,
				complete: function () {
					self._splittersLayout();
					if (callback && typeof callback === 'function') {
						callback();
					}
				}
			});
		},
		_triggerCollapsed: function (index) {
			var args = { owner: this, index: index };
			this._trigger(this.events.collapsed, null, args);
		},
		_triggerExpanded: function (index) {
			var args = { owner: this, index: index };
			this._trigger(this.events.expanded, null, args);
		},
		_triggerResizeStarted: function () {
			var args = { owner: this };
			this._trigger(this.events.resizeStarted, null, args);
		},
		_triggerResizing: function () {
			var args = { owner: this };
			return this._trigger(this.events.resizing, null, args);
		},
		_triggerResizeEnded: function () {
			var args = { owner: this };
			this._trigger(this.events.resizeEnded, null, args);
		},
		_triggerLayoutRefreshing: function () {
			var args = { owner: this };
			return this._trigger(this.events.layoutRefreshing, null, args);
		},
		_triggerLayoutRefreshed: function () {
			var args = { owner: this };
			return this._trigger(this.events.layoutRefreshed, null, args);
		},
		firstPanel: function () {
			/* Retrieves the jQuery element of the first panel.
				returnType="object" Returns the jQuery object of the first panel element.
			*/
			return this._panels[0];
		},
		secondPanel: function () {
			/* Retrieves the jQuery element of the second panel.
				returnType="object" Returns the jQuery object of the second panel element.
			*/
			return this._panels[1];
		},
		refreshLayout: function () {
			/* You can refresh layout after the splitter is rendered in order to render it correctly.
			*/
			this._panelsLayout();
		},
		// S.T. 14 June 2013 #144685
		// Improve Splitter API with set method for panel's size
		setFirstPanelSize: function (size) {
			/* 
			You can set new size of the first panel after the splitter is rendered.
			paramType="int|string" optional="false" Specifies the new size of the first panel.
			*/
			if(/%/.test(size)) {
				size = size.replace("%", "") * this._getSize(this._getOrientation("size")) / 100;
				this._isPercentLayout = true;
			}
			if(/px/.test(size)) {
				size = parseInt(size, 10);
			}
			this._setPanelSize(this._panels[0], size);
			this._splittersLayout();
		},
		// S.T. 14 June 2013 #144685
		// Improve Splitter API with set method for panel's size
		setSecondPanelSize: function (size) {
			/* 
			You can set new size of the second panel after the splitter is rendered.
			paramType="int|string" optional="false" Specifies the new size of the second panel.
			*/
			if(/%/.test(size)) {
				size = size.replace("%", "") * this._getSize(this._getOrientation("size")) / 100;
				this._isPercentLayout = true;
			}
			if(/px/.test(size)) {
				size = parseInt(size, 10);
			}
			this._setPanelSize(this._panels[0], this._getSize(this._getOrientation("size")) - size);
			this._splittersLayout();
		},
		destroy: function () {
			/* Destructor */
			var evtHandlers = this._opt.eventHandlers,
				i, splitters, index;
			this._removeEventHandlers();
			this._removeClasses();
			this.element.html(this._htmlMarkup);
			splitters = $.data(document.body, "ig-splitters") || [];
			for (i = 0; i < splitters.length; i++) {
				if (splitters[i][0].id === this.element[0].id) {
					index = i;
					break;
				}
			}
			splitters.splice(index, 1);
			$.data(document.body, "ig-splitters", splitters);
			// D.A. 24th October 2013 Remove the attached events to window and document
			$(document).unbind(this._getEvent("mouseup"), evtHandlers.documentMouseUp);
			$(document).unbind(this._getEvent("mousemove"), evtHandlers.documentMouseMove);
			$(window).unbind('resize', evtHandlers.windowResize);
			$.Widget.prototype.destroy.apply(this, arguments);
			return this;
		}
	});
	$.extend($.ui.igSplitter, {version: '14.1.20141.2249'});
}(jQuery));
/*!@license
 * Infragistics.Web.ClientUI SplitButton 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 * <Licensing info>
 *
 * http://www.infragistics.com/
 *
 * Depends on: 
 *   jquery-1.9.1.js
 *   jquery.ui.core.js
 *   jquery.ui.widget.js
 *   infragistics.util.js
 *   infragistics.ui.shared.js
 *   infragistics.ui.toolbarbutton.js
 */

/*global jQuery, window, document, Class, $ */
if (typeof jQuery !== "function") {
    throw new Error("jQuery is undefined");
}

(function ($) {
    /*
		The igSplitButton is a jQuery based widget.
	*/
    $.widget("ui.igSplitButton", {
        options: {
			/* type="array" Button items. */
            items: [{
				/* type="string" Item name*/
                name: "button1",
				/* type="string" Item display label*/
                label: "Button 1",
				/* type="string" Css class to represent the iconClass of the item*/
                iconClass: "ui-icon-gear"
            }],
            /* type="string" Default button item. */
            defaultItemName: "button1",
            /* type="boolean" Specifies whether the default button will be switched when another button is selected. */
            swapDefaultEnabled: false
        },
        events: {
            click: "click",
            /* cancel="false" Event fired after the button is expanded. */
            expanded: "expanded",
            /* cancel="true" Event fired before a button item is expanded. */
            expanding: "expanding",
            /* cancel="false" Event fired after the button is collapsed. */
            collapsed: "collapsed",
            /* cancel="true" Event fired before a button item is collapsed. */
            collapsing: "collapsing"
        },
        css: {
            /* The widget base class css. */
            container: "ui-splitbutton ui-widget ui-state-default",
            arrow: "ui-splitbutton-arrow",
            conrnersLeft: "ui-corner-left",
            conrnersRight: "ui-corner-right",
            hover: "ui-splitbutton-hover",
            active: "ui-state-active",
            focus: "ui-state-focus"
        },
        _id: function (id) {
            return this.element[0].id + id;
        },
        _renderDefaultBtn: function () {
            var options = this.options,
                defaultItem = this._getDefaultItem(options.defaultItemName);

            this._options.defaultButton = $('<div id="' + this._id("_" + options.defaultItemName) + '"></div>')
                .appendTo(this.element)
                .igToolbarButton({
                    onlyIcons: true,
                    labelText: "&nbsp;",
                    title: defaultItem.label,
                    icons: {
                        primary: defaultItem.iconClass
                    },
                    name: options.defaultItemName,
                    allowToggling: false
                })
                .addClass("ui-splitbutton-cleargaps " + this.css.conrnersLeft)
                .removeClass("ui-corner-all");
        },
        _renderExpandBtn: function () {
            this._options.expandButton = $("<div id='" + this._id("_arrow") + "' class='" + this.css.arrow + "'></div>")
                .igToolbarButton({
                    onlyIcons: true,
                    labelText: "&nbsp;",
                    icons: {
                        primary: "ui-icon-triangle-1-s"
                    },
                    allowToggling: false
                })
                .addClass("ui-splitbutton-cleargaps " + this.css.conrnersRight)
                .removeClass("ui-corner-all")
                .appendTo(this.element);
        },
        _setupElement: function () {
            this.element
                .addClass(this.css.container)
                .attr("tabIndex", 0);
        },
        _create: function () {
            var _opt,
                options = this.options,
                defaultItem = this._getDefaultItem(options.defaultItemName);

            this._options = {
                defaultButton: null,
                expandButton: null,
                itemsList: null,
                isExpanded: false,
                justFocused: false
            };

            this._setupElement();
            this._renderDefaultBtn();
            this._renderExpandBtn();
            this._createItemsList();
            this._attachEvents();
        },
        _attachEvents: function () {
            var _opt = this._options;

            _opt.defaultButton.on("igtoolbarbuttonclick", $.proxy(this._onDefaultBtnClick, this));
            _opt.expandButton.on("focus", $.proxy(this._onExpandBtnFocus, this));
            _opt.expandButton.on("blur", $.proxy(this._onExpandBtnBlur, this));
            _opt.expandButton.on("igtoolbarbuttonclick", $.proxy(this._onExpandBtnClick, this));
            _opt.itemsList.on("igtoolbarbuttonclick", "a", $.proxy(this._onItemClick, this));

            this.element.on("keypress", $.proxy(this._onEnterKeypress, this));
            this.element.hover($.proxy(this._onMouseEnter, this), $.proxy(this._onMouseLeave, this));
        },
        _onDefaultBtnClick: function (e) {
            var self = this;

            e.stopPropagation();
            this._trigger(this.events.click, e, {
                name: self._options.defaultButton.igToolbarButton("option", "name"),
                item: self.element
            });
        },
        _onExpandBtnClick: function (e) {
            var _options = this._options;

            // IE not focusing the element when clicking the inside span
            // Also IE triggers blur when the element is 
            // already focused and the inner span is clicked
            if (!_options.expandButton.is(":focus")) {
                if (!_options.isExpanded) {
                    _options.expandButton.focus();
                }
                return;
            }

            // Prevents collapsing the split button when
            // it was just expanded by the focus event
            if (_options.justFocused) {
                _options.justFocused = false;
            } else {
                this.toggle(e);
            }
        },
        _onExpandBtnFocus: function (e) {
            var noCancel;
            if (!this._options.isExpanded) {
                noCancel = this._triggerExpanding(e);
                if (noCancel) {
                    this.expand(e);
                    this._options.justFocused = true;
                }
            }
        },
        _onExpandBtnBlur: function (e) {
            var noCancel,
                self = this;

            if (this._options.isExpanded) {
                // Time for item click event to fire 
                // on the menu before it is hidden.
                setTimeout(function () {
                    noCancel = self._triggerCollapsing(e);
                    if (noCancel) {
                        self.collapse(e);
                    }
                }, 150);
            }
        },
        _onItemClick: function (e, ui) {
            var $target = $(e.currentTarget);

            if (this.options.swapDefaultEnabled) {
                this.switchToButton($target);
            }
            e.stopImmediatePropagation();

            this._trigger(this.events.click, e, {
                name: $target.igToolbarButton("option", "name")
            });
        },
        _onEnterKeypress: function (e) {
            if (e.which === $.ui.keyCode.ENTER) {
                this.toggle(e);
            }
        },
        _onMouseEnter: function () {
            this.element.addClass(this.css.hover);
        },
        _onMouseLeave: function () {
            this.element.removeClass(this.css.hover);
        },
        _getDefaultItem: function (name) {
            var options = this.options,
                i;
            for (i = 0; i < options.items.length; i++) {
                if (options.items[i].name === name) {
                    return options.items[i];
                }
            }
        },
        _createItemsList: function () {
            var list = $("<ul class='ui-splitbutton-list ui-menu ui-widget ui-widget-content ui-corner-all'></ul>"),
                options = this.options,
                i,
                item;

            for (i = 0; i < options.items.length; i++) {
                if (options.items[i].name !== options.defaultItemName) {
                    item = $('<a id="' + this._id("_" + options.items[i].name) + '" class="ui-corner-all" tabindex="-1"></a>')
                        .igToolbarButton({
                            onlyIcons: true,
                            labelText: "",
                            title: options.items[i].label,
                            icons: {
                                primary: options.items[i].iconClass
                            },
                            name: options.items[i].name,
                            allowToggling: false
                        }).addClass("ui-splitbutton-cleargaps");

                    $('<li class="ui-menu-item" role="menuitem"></li>').appendTo(list).append(item);
                }
            }

            this._options.itemsList = list.appendTo(this.element);
        },
        switchToButton: function (button) {
            /*
                Switch to given button.
                paramType="string|object" optional="false". The button to which we are going to switch.
            */
            var defaultButton = this._options.defaultButton,
                targetButton = (typeof button === "string") ? $("#" + this._id("_" + button)) : button,
                defBtnOpts = defaultButton.igToolbarButton("option"),
                defBtnId = defaultButton.attr("id"),
                targetBtnOpts = targetButton.igToolbarButton("option"),
                targetBtnId = targetButton.attr("id");

            targetButton
                .igToolbarButton("option", defBtnOpts)
                .attr("id", defBtnId);
            defaultButton
                .igToolbarButton("option", targetBtnOpts)
                .attr("id", targetBtnId)
                .igToolbarButton("toggle");
        },
        _triggerCollapsing: function (event) {
            var args = {
                owner: this
            };

            return this._trigger(this.events.collapsing, null, args);
        },
        _triggerCollapsed: function (event) {
            var args = {
                owner: this
            };

            return this._trigger(this.events.collapsed, null, args);
        },
        _triggerExpanding: function (event) {
            var args = {
                owner: this
            };

            return this._trigger(this.events.expanding, null, args);
        },
        _triggerExpanded: function (event) {
            var args = {
                owner: this
            };

            return this._trigger(this.events.expanded, null, args);
        },
        widget: function () {
            return this.element;
        },
        toggle: function (e) {
            /* Toggle widget state between collapsed and expanded. */
            var noCancel,
                _options = this._options;

            if (_options.isExpanded) {
                noCancel = this._triggerCollapsing(e);
                if (noCancel) {
                    this.collapse(e);
                }
            } else {
                noCancel = this._triggerExpanding(e);
                if (noCancel) {
                    this.expand(e);
                }
            }
        },
        collapse: function (e) {
            /* Collapse the widget. */
            var self = this,
                _opt = this._options,
                expandButton = _opt.expandButton;

            _opt.itemsList.hide(0, function () {
                self.element.removeClass(self.css.active);
                _opt.expandButton.removeClass(self.css.focus);
                _opt.isExpanded = false;
                if (e && e.originalEvent) {
                    self._triggerCollapsed(e);
                } else if (expandButton.is(":focus")) {
                    // Remove the expandButton focus when called as API method
                    expandButton.blur();
                }
            });
        },
        expand: function (e) {
            /* Expands the widget. */
            var self = this,
                _opt = this._options,
                expandButton = _opt.expandButton;

            _opt.itemsList.show(0, function () {
                self.element.addClass(self.css.active);
                _opt.isExpanded = true;

                if (e && e.originalEvent) {
                    self._triggerExpanded(e);
                } else if (!expandButton.is(":focus")) {
                    // Focus the expandButton when called as API method
                    expandButton.focus();
                }
            });
        },
        destroy: function () {
            /* Destroy the widget. */
            var _opt = this._options;

            $.Widget.prototype.destroy.apply(this, arguments);

            _opt.itemsList.off();
            this.element
                .find(":ui-igToolbarButton")
                    .igToolbarButton("destroy")
                .end()
                .off()
                .removeClass(this.css.container)
                .removeAttr("tabindex")
                .empty();

            delete _opt.expandButton;
            delete _opt.itemsList;
        }
    });

    $.extend($.ui.igSplitButton, { version: '14.1.20141.2249' });
}(jQuery));
/*!@license
* Infragistics.Web.ClientUI infragistics.olapxmladatasource.js 14.1.20141.2249
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends:
*     jquery-1.4.4.js
*     jquery.ui.core.js
*     jquery.ui.widget.js
*     infragistics.util.js
*/

// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["AbstractEnumerable:a", 
"Object:b", 
"Type:c", 
"Boolean:d", 
"ValueType:e", 
"Void:f", 
"String:g", 
"IComparable:h", 
"Number:i", 
"Number:j", 
"Single:k", 
"Number:l", 
"String:m", 
"Array:n", 
"RegExp:o", 
"RuntimeTypeHandle:p", 
"MethodInfo:q", 
"MethodBase:r", 
"MemberInfo:s", 
"ParameterInfo:t", 
"TypeCode:u", 
"Enum:v", 
"ConstructorInfo:w", 
"IEnumerable:x", 
"IEnumerator:y", 
"Func$1:z", 
"MulticastDelegate:aa", 
"IntPtr:ab", 
"AbstractEnumerator:ac", 
"IEnumerable$1:ad", 
"IEnumerator$1:ae", 
"ICollection$1:af", 
"IList$1:ag", 
"IArrayList:ah", 
"Array:ai", 
"ICollection:aj", 
"CompareCallback:ak", 
"List$1:al", 
"IList:am", 
"IDisposable:an", 
"IArray:ao", 
"Script:ap", 
"Date:aq", 
"Date:ar", 
"Number:as", 
"Func$3:at", 
"Action$1:au", 
"IDictionary$2:aw", 
"Dictionary$2:ax", 
"IDictionary:ay", 
"Dictionary:az", 
"IEqualityComparer$1:a0", 
"KeyValuePair$2:a1", 
"NotImplementedException:a2", 
"Error:a3", 
"GenericEnumerable$1:a4", 
"GenericEnumerator$1:a5", 
"INotifyCollectionChanged:a6", 
"NotifyCollectionChangedEventHandler:a7", 
"NotifyCollectionChangedEventArgs:a8", 
"EventArgs:a9", 
"NotifyCollectionChangedAction:ba", 
"ObservableCollection$1:bd", 
"INotifyPropertyChanged:be", 
"PropertyChangedEventHandler:bf", 
"PropertyChangedEventArgs:bg", 
"Delegate:bh", 
"ReadOnlyCollection$1:bj", 
"NameValueCollection:bl", 
"IOrderedEnumerable$1:bu", 
"Enumerable:bz", 
"Func$2:b0", 
"SortedList$1:b1", 
"Math:b2", 
"Number:b3", 
"Number:b4", 
"Number:b5", 
"Number:b6", 
"Number:b7", 
"Number:b8", 
"Number:b9", 
"ArgumentNullException:ca", 
"AggregateException:cn", 
"ArgumentException:co", 
"AsyncCompletedEventArgs:cq", 
"ListSortDirection:cs", 
"Environment:cu", 
"InvalidOperationException:cv", 
"Debug:cw", 
"ICredentials:cz", 
"NetworkCredential:c0", 
"Uri:c1", 
"UploadStringCompletedEventHandler:c2", 
"UploadStringCompletedEventArgs:c3", 
"WebClient:c4", 
"Encoding:c5", 
"UTF8Encoding:c6", 
"UnicodeEncoding:c7", 
"WebHeaderCollection:c8", 
"Task$1:c9", 
"Task:da", 
"JQueryPromise:db", 
"Action:dc", 
"TaskStatus:dd", 
"TaskCompletionSource$1:de", 
"JQueryDeferred:df", 
"JQuery:dg", 
"JQueryObject:dh", 
"Element:di", 
"ElementAttributeCollection:dj", 
"ElementCollection:dk", 
"WebStyle:dl", 
"ElementNodeType:dm", 
"Document:dn", 
"EventListener:dp", 
"IElementEventHandler:dq", 
"ElementEventHandler:dr", 
"ElementAttribute:ds", 
"JQueryPosition:dt", 
"JQueryCallback:du", 
"JQueryEvent:dv", 
"JQueryUICallback:dw", 
"FaultCode:dx", 
"FaultException:dy", 
"FaultReason:dz", 
"FaultException$1:d0", 
"StringBuilder:d1", 
"TaskFactory:d4", 
"Tuple$2:d5", 
"JavaScriptSerializer:d6", 
"XObject:f9", 
"XmlNode:ga", 
"XmlNodeList:gb", 
"XmlNamedNodeMap:gc", 
"XmlNodeType:gd", 
"XmlDocument:ge", 
"XmlElement:gf", 
"XmlLinkedNode:gg", 
"XmlAttribute:gh", 
"XmlUtils:gi", 
"XAttribute:gj", 
"XNode:gk", 
"XContainer:gl", 
"XElement:gm", 
"XName:gn", 
"XNamespace:go", 
"XDocument:gp"]);












$.ig.util.defType('TaskStatus', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('TaskStatus', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('ListSortDirection', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('ListSortDirection', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('NotifyCollectionChangedAction', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('NotifyCollectionChangedAction', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('AbstractEnumerable', 'Object', {
	__inner: null
	, 
	init: function (inner) {



		$.ig.Object.prototype.init.call(this);
			this.__inner = inner;
	}

	, 
	getEnumerator: function () {
		return new $.ig.AbstractEnumerator(this.__inner().getEnumerator());
	}
	, 
	$type: new $.ig.Type('AbstractEnumerable', $.ig.Object.prototype.$type, [$.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('AbstractEnumerator', 'Object', {
	__inner: null
	, 
	init: function (inner) {



		$.ig.Object.prototype.init.call(this);
			this.__inner = inner;
	}

	, 
	current: function () {

			return this.__inner.current();
	}

	, 
	moveNext: function () {
		return this.__inner.moveNext();
	}

	, 
	reset: function () {
		this.__inner.reset();
	}
	, 
	$type: new $.ig.Type('AbstractEnumerator', $.ig.Object.prototype.$type, [$.ig.IEnumerator.prototype.$type])
}, true);

$.ig.util.defType('IEnumerable$1', 'Object', {
	$type: new $.ig.Type('IEnumerable$1', null, [$.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('ICollection$1', 'Object', {
	$type: new $.ig.Type('ICollection$1', null, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('IList$1', 'Object', {
	$type: new $.ig.Type('IList$1', null, [$.ig.ICollection$1.prototype.$type.specialize(0), $.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('IArrayList', 'Object', {
	$type: new $.ig.Type('IArrayList', null)
}, true);

$.ig.util.defType('List$1', 'Object', {
	$t: null, 
	__inner: null
	, 
	init: function ($t, initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}

		this.__syncRoot = {};

		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.__inner = new $.ig.Array();
	}
	, 
	init1: function ($t, initNumber, source) {


		this.__syncRoot = {};

		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.__inner = new $.ig.Array();
			if (this.tryArray(0, source)) {
				return;
			}

			var en = source.getEnumerator();
			while (en.moveNext()) {
				var item = en.current();
				this.add1(item);
			}

	}
	, 
	init2: function ($t, initNumber, capacity) {


		this.__syncRoot = {};

		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.__inner = new $.ig.Array();
	}

	, 
	setItem: function (index, newItem) {
		this.__inner[index] = newItem;
	}

	, 
	insertItem: function (index, newItem) {
		this.__inner.insert(index, newItem);
	}

	, 
	addItem: function (newItem) {
		this.__inner.add(newItem);
	}

	, 
	removeItem: function (index) {
		this.__inner.removeAt(index);
	}

	, 
	clearItems: function () {
		this.__inner.clear();
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			this.setItem(index, value);
			return value;
		} else {

			return this.__inner[index];
		}
	}

	, 
	indexOf: function (item) {
		return this.__inner.indexOf(item);
	}

	, 
	insert: function (index, item) {
		this.insertItem(index, item);
	}

	, 
	removeAt: function (index) {
		this.removeItem(index);
	}

	, 
	count: function () {

			return this.__inner.length;
	}

	, 
	isReadOnly: function () {

			return false;
	}

	, 
	add1: function (item) {
		this.addItem(item);
	}

	, 
	clear: function () {
		this.clearItems();
	}

	, 
	contains1: function (item) {
		return this.__inner.contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		for (var i = 0; i < this.__inner.length; i++) {
			array[arrayIndex + i] = this.__inner[i];
		}

	}

	, 
	remove1: function (item) {
		var indexOf = this.indexOf(item);
		if (indexOf < 0) {
			return false;
		}

		this.removeItem(indexOf);
		return true;
	}

	, 
	getEnumerator: function () {
		var $self = this;
		var $iter = function () { return function () { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.__inner.getEnumerator();
								this.$state = 4;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$current = this.$item;
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 5;
								}
								break;

							case 5:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } () };
		return new $.ig.GenericEnumerator$1(this.$t, $iter());
	}

	, 
	asArrayList: function () {
		return this.__inner;
	}

	, 
	tryArray: function (index, collection_) {
		var asArrayList = $.ig.util.cast($.ig.IArrayList.prototype.$type, collection_);
		if (asArrayList != null) {
			this.__inner.insertRange1(index, asArrayList.asArrayList());
			return true;
		}

		var asArray = $.ig.util.cast($.ig.IArray.prototype.$type, collection_);
		if (asArray != null) {
			this.__inner.insertRange(index, asArray.asArray());
			return true;
		}

		var asList = $.ig.util.cast($.ig.IList$1.prototype.$type.specialize(this.$t), collection_);
		if (asList != null) {
			for (var i = 0; i < asList.count(); i++) {
				this.__inner.insert(index + i, asList.item(i));
			}

			return true;
		}

		var arr = $.isArray(collection_) ? collection_ : null;;
		if (arr != null) {
			this.__inner.insertRange(index, arr);
			return true;
		}

		return false;
	}

	, 
	insertRange1: function (index, collection) {
		if (this.tryArray(index, collection)) {
			return;
		}

		var j = 0;
		var en = collection.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			this.__inner.insert(index + j, item);
			j++;
		}

	}

	, 
	insertRange: function (index, collection) {
		if (this.tryArray(index, collection)) {
			return;
		}

		var j = 0;
		var en = collection.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			this.__inner.insert(index + j, item);
			j++;
		}

	}

	, 
	removeRange: function (index, numToRemove) {
		this.__inner.splice(index, numToRemove);
	}

	, 
	copyTo1: function (array, index) {
		this.__inner.copyTo(array, index);
	}

	, 
	isFixedSize: function () {

			return false;
	}

	, 
	add: function (value) {
		this.addItem(value);
		return this.__inner.length - 1;
	}

	, 
	contains: function (value) {
		return this.__inner.contains(value);
	}

	, 
	indexOf1: function (value) {
		return this.__inner.indexOf(value);
	}

	, 
	insert1: function (index, value) {
		this.insertItem(index, value);
	}

	, 
	remove: function (value) {
		var indexOf = this.indexOf1(value);
		this.removeItem(indexOf);
	}

	, 
	sort: function () {
		var $self = this;
		var c = null;
		if ($self.$t == Number) {
			c = function (n1, n2) {
					var d1 = n1;
					var d2 = n2;
					if (d1 < d2) {
						return -1;
					}

					if (d1 == d2) {
						return 0;
					}

					return 1;
			};

		} else if ($self.$t == $.ig.Single.prototype.$type) {
			c = function (n1, n2) {
					var f1 = n1;
					var f2 = n2;
					if (f1 < f2) {
						return -1;
					}

					if (f1 == f2) {
						return 0;
					}

					return 1;
			};

		} else if ($self.$t == $.ig.Number.prototype.$type) {
			c = function (n1, n2) {
					var i1 = n1;
					var i2 = n2;
					if (i1 < i2) {
						return -1;
					}

					if (i1 == i2) {
						return 0;
					}

					return 1;
			};

		} else if ($self.$t == $.ig.Date.prototype.$type) {
			c = function (n1, n2) {
					var d1 = n1;
					var d2 = n2;
					if (d1.getTime() < d2.getTime()) {
						return -1;
					}

					if (d1.getTime() == d2.getTime()) {
						return 0;
					}

					return 1;
			};

		} else {
			c = function (n1, n2) {
					return (n1).compareTo(n2);
			};
		}




		$self.sortHelper(c);
	}

	, 
	sortHelper: function (compare) {
		this.__inner.sort(compare);
	}

	, 
	sort1: function (compare) {
		var $self = this;
		$self.__inner.sort(function (o1, o2) {
				var t1 = o1;
				var t2 = o2;
				return compare(t1, t2);
		});
	}

	, 
	_capacity: 0,
	capacity: function (value) {
		if (arguments.length === 1) {
			this._capacity = value;
			return value;
		} else {
			return this._capacity;
		}
	}

	, 
	addRange: function (values) {
		var en = values.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			this.__inner.add(item);
		}

	}

	, 
	toArray: function () {
		return  this.__inner.slice(0);
	}

	, 
	forEach: function (action) {
	}

	, 
	isSynchronized: function () {

			return true;
	}
	, 
	__syncRoot: null

	, 
	syncRoot: function () {

			return this.__syncRoot;
	}
	, 
	$type: new $.ig.Type('List$1', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(0), $.ig.IArrayList.prototype.$type, $.ig.IList.prototype.$type])
}, true);


$.ig.util.defType('KeyValuePair$2', 'ValueType', {
	$tKey: null, 
	$tValue: null, 
	init: function ($tKey, $tValue, initNumber) {
		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}
		this.$tKey = $tKey;
		this.$tValue = $tValue;
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);

		$.ig.ValueType.prototype.init.call(this);

	}, 
	__key: null
	, 
	__value: null
	, 
	init1: function ($tKey, $tValue, initNumber, key, value) {



		this.$tKey = $tKey
		this.$tValue = $tValue
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);
		$.ig.ValueType.prototype.init.call(this);
			this.__key = key;
			this.__value = value;
	}

	, 
	key: function () {

			return this.__key;
	}

	, 
	value: function () {

			return this.__value;
	}
	, 
	$type: new $.ig.Type('KeyValuePair$2', $.ig.ValueType.prototype.$type)
}, true);

$.ig.util.defType('IDictionary$2', 'Object', {
	$type: new $.ig.Type('IDictionary$2', null, [$.ig.ICollection$1.prototype.$type.specialize($.ig.KeyValuePair$2.prototype.$type.specialize(this.$tKey, this.$tValue)), $.ig.IEnumerable$1.prototype.$type.specialize($.ig.KeyValuePair$2.prototype.$type.specialize(this.$tKey, this.$tValue)), $.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('Dictionary$2', 'Object', {
	$tKey: null, 
	$tValue: null, 
	__inner: null
	, 
	__keys: null
	, 
	init: function ($tKey, $tValue, initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}

		this.__comparer = null;
		this._useToString = false;
		this._checkedString = false;
		this._needsEnsure = false;

		this.$tKey = $tKey
		this.$tValue = $tValue
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);
		$.ig.Object.prototype.init.call(this);
			this.__inner = new $.ig.Dictionary(0);
			this.__keys = new $.ig.Dictionary(0);
	}
	, 
	init1: function ($tKey, $tValue, initNumber, capacity) {


		this.__comparer = null;
		this._useToString = false;
		this._checkedString = false;
		this._needsEnsure = false;

		this.$tKey = $tKey
		this.$tValue = $tValue
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);
		$.ig.Object.prototype.init.call(this);
			this.__inner = new $.ig.Dictionary(1, capacity);
			this.__keys = new $.ig.Dictionary(0);
	}
	, 
	__comparer: null
	, 
	init2: function ($tKey, $tValue, initNumber, comparer) {


		this.__comparer = null;
		this._useToString = false;
		this._checkedString = false;
		this._needsEnsure = false;

		this.$tKey = $tKey
		this.$tValue = $tValue
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);
		$.ig.Object.prototype.init.call(this);
			this.__inner = new $.ig.Dictionary(0);
			this.__keys = new $.ig.Dictionary(0);
			this.__comparer = comparer;
	}

	, 
	count: function () {

			return this.__inner.count();
	}

	, 
	item: function (key, value) {
		if (arguments.length === 2) {

			this.__inner.item(this.hash(key), value);
			this.__keys.item(this.hash(key), key);
			return value;
		} else {

			return this.__inner.item(this.hash(key));
		}
	}

	, 
	length: function () {

			return this.__inner.length();
	}

	, 
	containsKey: function (key) {
		return this.__inner.containsKey(this.hash(key));
	}

	, 
	remove: function (key) {
		var hash = this.hash(key);
		if (!this.__keys.containsKey(hash)) {
			return false;
		}

		this.__inner.remove(hash);
		this.__keys.remove(hash);
		return true;
	}

	, 
	clear: function () {
		this.__inner.clear();
		this.__keys.clear();
	}
	, 
	_useToString: false
	, 
	_checkedString: false
	, 
	_needsEnsure: false

	, 
	ensureConfig: function (key_) {
		if (!this._checkedString) {
			this._checkedString = true;
			this._needsEnsure = (typeof key_ == 'object');;
			if (!this._needsEnsure) {
				this._useToString = !key_.getHashCode;;
			}

		}

	}

	, 
	hash: function (key_) {
		this.ensureConfig(key_);
		if (this._needsEnsure) {
			$.ig.util.ensureUniqueId(key_);;
		}

		if (this.__comparer != null) {
			return this.__comparer.getHashCode(key_).toString();
		}

		if (this._useToString) {
			return key_.toString();

		} else {
			return key_.getHashCode().toString();
		}

	}

	, 
	add: function (key, value) {
		this.__inner.item(this.hash(key), value);
		this.__keys.item(this.hash(key), key);
	}

	, 
	tryGetValue: function (key, value) {
		if (!this.__inner.containsKey(this.hash(key))) {
			value = null;
			return {
				ret: false, 
				value: value
			};
		}

		value = this.__inner.item(this.hash(key));
		return {
			ret: true, 
			value: value
		};
		return {
			value: value
		};
	}

	, 
	keys: function () {

			var $self = this;
			var $iter = function () { return function () { return {
				$state: 0,
				$this: $self,
				$current: null,
				$key : null,
				$en : null,
				getEnumerator: function() {
					if (this.$state === -1) {
						this.$state = 0;
					}
					return this;
				},
				current: function () {
					return this.$current;
				},
				moveNext: function() {
					do {
						switch (this.$state) {
							case 0:
									this.$state = 1;
									break;
								case 1:
									this.$en = this.$this.__keys.values().getEnumerator();
									this.$state = 4;
									break;
																case 2:
									this.$key = this.$en.current();
										this.$current = this.$key;
										this.$state = 3;
										return true;
									case 3:

									this.$state = 4;
									break;
case 4:
									if (this.$en.moveNext()) {
										this.$state = 2;
									}
									else {
										this.$state = 5;
									}
									break;

								case 5:

								this.$state = -2;
								break;
							case -2:
								return false;
						}
					} while (this.$state > 0);
				}
			}; } () };
			return new $.ig.GenericEnumerable$1(this.$tKey, $iter);
	}

	, 
	values: function () {

			var $self = this;
			var $iter = function () { return function () { return {
				$state: 0,
				$this: $self,
				$current: null,
				$value : null,
				$en : null,
				getEnumerator: function() {
					if (this.$state === -1) {
						this.$state = 0;
					}
					return this;
				},
				current: function () {
					return this.$current;
				},
				moveNext: function() {
					do {
						switch (this.$state) {
							case 0:
									this.$state = 1;
									break;
								case 1:
									this.$en = this.$this.__inner.values().getEnumerator();
									this.$state = 4;
									break;
																case 2:
									this.$value = this.$en.current();
										this.$current = this.$value;
										this.$state = 3;
										return true;
									case 3:

									this.$state = 4;
									break;
case 4:
									if (this.$en.moveNext()) {
										this.$state = 2;
									}
									else {
										this.$state = 5;
									}
									break;

								case 5:

								this.$state = -2;
								break;
							case -2:
								return false;
						}
					} while (this.$state > 0);
				}
			}; } () };
			return new $.ig.GenericEnumerable$1(this.$tValue, $iter);
	}

	, 
	isReadOnly: function () {

			return false;
	}

	, 
	add1: function (item) {
		this.add(item.key(), item.value());
	}

	, 
	contains: function (item) {
		return this.containsKey(item.key());
	}

	, 
	copyTo: function (array, arrayIndex) {
		throw new $.ig.NotImplementedException();
	}

	, 
	remove1: function (item) {
		this.remove(item.key());
		return true;
	}

	, 
	keyValueEnumerableGenerator: function () {
		var $self = this;
		var $iter = function () { return function () { return {
			$state: 0,
			$this: $self,
			$current: null,
			$key : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.__keys.values().getEnumerator();
								this.$state = 4;
								break;
														case 2:
								this.$key = this.$en.current();
									this.$current = new $.ig.KeyValuePair$2(this.$tKey, this.$tValue, 1, this.$key, this.$this.__inner.item(this.$this.hash(this.$key)));
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 5;
								}
								break;

							case 5:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } () };
		return new $.ig.GenericEnumerable$1($.ig.KeyValuePair$2.prototype.$type.specialize(this.$tKey, this.$tValue), $iter);
	}

	, 
	getEnumerator: function () {
		return this.keyValueEnumerableGenerator().getEnumerator();
	}
	, 
	$type: new $.ig.Type('Dictionary$2', $.ig.Object.prototype.$type, [$.ig.IDictionary$2.prototype.$type.specialize(0, 1), $.ig.IDictionary.prototype.$type])
}, true);

$.ig.util.defType('GenericEnumerable$1', 'Object', {
	$t: null, 
	__inner: null
	, 
	init: function ($t, inner) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.__inner = inner;
	}

	, 
	getEnumerator: function () {
		return new $.ig.GenericEnumerator$1(this.$t, this.__inner().getEnumerator());
	}
	, 
	$type: new $.ig.Type('GenericEnumerable$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('IEnumerator$1', 'Object', {
	$type: new $.ig.Type('IEnumerator$1', null, [$.ig.IEnumerator.prototype.$type])
}, true);

$.ig.util.defType('GenericEnumerator$1', 'Object', {
	$t: null, 
	__inner: null
	, 
	init: function ($t, inner) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.__inner = inner;
	}

	, 
	current: function () {

			return this.__inner.current();
	}

	, 
	moveNext: function () {
		return this.__inner.moveNext();
	}

	, 
	reset: function () {
		this.__inner.reset();
	}
	, 
	$type: new $.ig.Type('GenericEnumerator$1', $.ig.Object.prototype.$type, [$.ig.IEnumerator$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('INotifyCollectionChanged', 'Object', {
	$type: new $.ig.Type('INotifyCollectionChanged', null)
}, true);


$.ig.util.defType('NotifyCollectionChangedEventArgs', 'EventArgs', {
	init: function (initNumber, action) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.EventArgs.prototype.init.call(this);
			this.__action = action;
			this.__oldItems = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			this.__newItems = new $.ig.List$1($.ig.Object.prototype.$type, 0);
	}
	, 
	init1: function (initNumber, action, changedItem, index) {


		var $self = this;

		$.ig.EventArgs.prototype.init.call(this);
			this.__action = action;
			this.__oldItems = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			if (this.__action == $.ig.NotifyCollectionChangedAction.prototype.remove || this.__action == $.ig.NotifyCollectionChangedAction.prototype.replace) {
				this.__oldItems.add(changedItem);
				this.__oldStartingIndex = index;
			}

			if (this.__action != $.ig.NotifyCollectionChangedAction.prototype.remove) {
				this.__newItems = (function () { var $ret = new $.ig.List$1($.ig.Object.prototype.$type, 0);
				$ret.add(changedItem); return $ret;}());

			} else {
				this.__newItems = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			}

			this.__newStartingIndex = index;
	}
	, 
	init2: function (initNumber, action, newItem, oldItem, index) {


		var $self = this;

		$.ig.EventArgs.prototype.init.call(this);
			this.__action = action;
			this.__newStartingIndex = index;
			this.__oldStartingIndex = index;
			this.__newItems = (function () { var $ret = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			$ret.add(newItem); return $ret;}());
			this.__oldItems = (function () { var $ret = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			$ret.add(oldItem); return $ret;}());
	}
	, 
	__action: null

	, 
	action: function () {

			return this.__action;
	}
	, 
	__newItems: null

	, 
	newItems: function () {

			return this.__newItems;
	}
	, 
	__newStartingIndex: 0

	, 
	newStartingIndex: function () {

			return this.__newStartingIndex;
	}
	, 
	__oldItems: null

	, 
	oldItems: function () {

			return this.__oldItems;
	}
	, 
	__oldStartingIndex: 0

	, 
	oldStartingIndex: function () {

			return this.__oldStartingIndex;
	}
	, 
	$type: new $.ig.Type('NotifyCollectionChangedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);



$.ig.util.defType('ObservableCollection$1', 'List$1', {
	$t: null, 
	init: function ($t, initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}


		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.List$1.prototype.init.call(this, this.$t);
	}
	, 
	init1: function ($t, initNumber, source) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.List$1.prototype.init1.call(this, this.$t, 1, source);
	}
	, 
	init2: function ($t, initNumber, capacity) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.List$1.prototype.init2.call(this, this.$t, 2, capacity);
	}

	, 
	setItem: function (index, newItem) {
		var oldItem = this.__inner[index];
		$.ig.List$1.prototype.setItem.call(this, index, newItem);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(2, $.ig.NotifyCollectionChangedAction.prototype.replace, newItem, oldItem, index);
			this.onCollectionChanged(args);
		}

	}

	, 
	clearItems: function () {
		$.ig.List$1.prototype.clearItems.call(this);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Count"));
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(0, $.ig.NotifyCollectionChangedAction.prototype.reset);
			this.onCollectionChanged(args);
		}

	}

	, 
	insertItem: function (index, newItem) {
		$.ig.List$1.prototype.insertItem.call(this, index, newItem);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Count"));
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, newItem, index);
			this.onCollectionChanged(args);
		}

	}

	, 
	addItem: function (newItem) {
		$.ig.List$1.prototype.addItem.call(this, newItem);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Count"));
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, newItem, this.count() - 1);
			this.onCollectionChanged(args);
		}

	}

	, 
	removeItem: function (index) {
		var oldItem = this.__inner[index];
		$.ig.List$1.prototype.removeItem.call(this, index);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Count"));
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.remove, oldItem, index);
			this.onCollectionChanged(args);
		}

	}
	, 
	collectionChanged: null, 
	propertyChanged: null
	, 
	onPropertyChanged: function (args) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, args);
		}

	}

	, 
	onCollectionChanged: function (args) {
		if (this.collectionChanged != null) {
			this.collectionChanged(this, args);
		}

	}
	, 
	$type: new $.ig.Type('ObservableCollection$1', $.ig.List$1.prototype.$type.specialize(0), [$.ig.INotifyCollectionChanged.prototype.$type, $.ig.INotifyPropertyChanged.prototype.$type])
}, true);


$.ig.util.defType('ReadOnlyCollection$1', 'Object', {
	$t: null, 
	init: function ($t, initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		this.__syncRoot = {};

		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
	}
	, 
	init1: function ($t, initNumber, source) {


		this.__syncRoot = {};

		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.__inner = source;
	}
	, 
	__inner: null

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			this.__inner.item(index, value);
			return value;
		} else {

			return this.__inner.item(index);
		}
	}

	, 
	indexOf: function (item) {
		return this.__inner.indexOf(item);
	}

	, 
	insert: function (index, item) {
	}

	, 
	removeAt: function (index) {
	}

	, 
	count: function () {

			return this.__inner.count();
	}

	, 
	isReadOnly: function () {

			return true;
	}

	, 
	add1: function (item) {
	}

	, 
	clear: function () {
	}

	, 
	contains1: function (item) {
		return this.__inner.contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		this.__inner.copyTo(array, arrayIndex);
	}

	, 
	remove1: function (item) {
		return false;
	}

	, 
	getEnumerator: function () {
		return this.__inner.getEnumerator();
	}

	, 
	isFixedSize: function () {

			return true;
	}

	, 
	add: function (value) {
		return -1;
	}

	, 
	contains: function (value) {
		return this.__inner.contains(value);
	}

	, 
	indexOf1: function (value) {
		return this.__inner.indexOf(value);
	}

	, 
	insert1: function (index, value) {
	}

	, 
	remove: function (value) {
	}

	, 
	copyTo1: function (array, index) {
		this.__inner.copyTo(array, index);
	}

	, 
	items: function () {

			return this.__inner;
	}

	, 
	isSynchronized: function () {

			return true;
	}
	, 
	__syncRoot: null

	, 
	syncRoot: function () {

			return this.__syncRoot;
	}
	, 
	$type: new $.ig.Type('ReadOnlyCollection$1', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(0), $.ig.IList.prototype.$type])
}, true);


$.ig.util.defType('NameValueCollection', 'Object', {
	__dict: null
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__dict = new $.ig.Dictionary$2(String, String, 0);
	}

	, 
	item: function (name, value) {
		if (arguments.length === 2) {

			if (this.__dict.containsKey(name)) {
				this.__dict.item(name, value);

			} else {
				this.__dict.add(name, value);
			}

			return value;
		} else {

			if (this.__dict.containsKey(name)) {
				return this.__dict.item(name);

			} else {
				return null;
			}

		}
	}
	, 
	$type: new $.ig.Type('NameValueCollection', $.ig.Object.prototype.$type)
}, true);









$.ig.util.defType('IOrderedEnumerable$1', 'Object', {
	$type: new $.ig.Type('IOrderedEnumerable$1', null, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type])
}, true);


$.ig.util.defType('Enumerable', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	where$1: function ($tSource, predicate) {
		var $self = this;
		var $iter = function () { return function ($tSource, predicate) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 7;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$state = 3;
									break;
								case 3:
									if (predicate(this.$item)) {
										this.$state = 4;
									}
									else {
										this.$state = 6;
									}
									break;

								case 4:
		this.$current = this.$item;
		this.$state = 5;
		return true;
	case 5:

	this.$state = 6;
	break;

case 6:

								this.$state = 7;
								break;
case 7:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 8;
								}
								break;

							case 8:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, predicate) };
		return new $.ig.GenericEnumerable$1($tSource, $iter);
	}

	, 
	where$11: function ($tSource, predicate) {
		var $self = this;
		var $iter = function () { return function ($tSource, predicate) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$index : 0,
			$item : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$index = 0;
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 7;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$state = 3;
									break;
								case 3:
									if (predicate(this.$item, this.$index)) {
										this.$state = 4;
									}
									else {
										this.$state = 6;
									}
									break;

								case 4:
		this.$current = this.$item;
		this.$state = 5;
		return true;
	case 5:

	this.$state = 6;
	break;

case 6:

									this.$index++;
								this.$state = 7;
								break;
case 7:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 8;
								}
								break;

							case 8:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, predicate) };
		return new $.ig.GenericEnumerable$1($tSource, $iter);
	}

	, 
	select$2: function ($tSource, $tResult, selector) {
		var $self = this;
		var $iter = function () { return function ($tSource, $tResult, selector) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 4;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$current = selector(this.$item);
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 5;
								}
								break;

							case 5:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, $tResult, selector) };
		return new $.ig.GenericEnumerable$1($tResult, $iter);
	}

	, 
	selectMany$2: function ($tSource, $tResult, selector) {
		var $self = this;
		var $iter = function () { return function ($tSource, $tResult, selector) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			$item2 : null,
			$en1 : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 8;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$state = 3;
									break;
								case 3:
									this.$en1 = selector(this.$item).getEnumerator();
									this.$state = 6;
									break;
																case 4:
									this.$item2 = this.$en1.current();
										this.$current = this.$item2;
										this.$state = 5;
										return true;
									case 5:

									this.$state = 6;
									break;
case 6:
									if (this.$en1.moveNext()) {
										this.$state = 4;
									}
									else {
										this.$state = 7;
									}
									break;

								case 7:

								this.$state = 8;
								break;
case 8:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 9;
								}
								break;

							case 9:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, $tResult, selector) };
		return new $.ig.GenericEnumerable$1($tResult, $iter);
	}

	, 
	ofType$1: function ($tResult) {
		var $self = this;
		var $iter = function () { return function ($tResult) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 7;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$state = 3;
									break;
								case 3:
									if ($.ig.util.cast($tResult, this.$item) !== null) {
										this.$state = 4;
									}
									else {
										this.$state = 6;
									}
									break;

								case 4:
		this.$current = this.$item;
		this.$state = 5;
		return true;
	case 5:

	this.$state = 6;
	break;

case 6:

								this.$state = 7;
								break;
case 7:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 8;
								}
								break;

							case 8:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tResult) };
		return new $.ig.GenericEnumerable$1($tResult, $iter);
	}

	, 
	last$1: function ($tSource) {
		var ilist = $.ig.util.cast($.ig.IList$1.prototype.$type.specialize($tSource), this);
		if (ilist != null) {
			return ilist.item(ilist.count() - 1);
		}

		var current = null;
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			current = item;
		}

		return current;
	}

	, 
	first$1: function ($tSource) {
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			return item;
		}

		return null;
	}

	, 
	firstOrDefault$1: function ($tSource) {
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			return item;
		}

		return null;
	}

	, 
	orderBy$2: function ($tSource, $tKey, keySelector) {
		var $self = this;
		var buffer = new $.ig.SortedList$1($tSource, $self);
		buffer.sort1(function (o1, o2) {
			var t1 = o1;
			var t2 = o2;
			var k1 = keySelector(t1);
			var k2 = keySelector(t2);
			if ($.ig.util.cast($.ig.IComparable.prototype.$type, k1) !== null) {
				return ($.ig.util.cast($.ig.IComparable.prototype.$type, k1)).compareTo(k2);

			} else {
				return k1.toString().compareTo(k2.toString());
			}

		});
		return buffer;
	}

	, 
	orderByDescending$2: function ($tSource, $tKey, keySelector) {
		var $self = this;
		var buffer = new $.ig.SortedList$1($tSource, $self);
		buffer.sort1(function (o2, o1) {
			var t1 = o1;
			var t2 = o2;
			var k1 = keySelector(t1);
			var k2 = keySelector(t2);
			if ($.ig.util.cast($.ig.IComparable.prototype.$type, k1) !== null) {
				return ($.ig.util.cast($.ig.IComparable.prototype.$type, k1)).compareTo(k2);

			} else {
				return k1.toString().compareTo(k2.toString());
			}

		});
		return buffer;
	}

	, 
	toList$1: function ($tSource) {
		var list = new $.ig.List$1($tSource, 1, this);
		return list;
	}

	, 
	range: function (startValue, count) {
		var $self = this;
		var $iter = function () { return function (startValue, count) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$i : 0,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
																this.$i = startValue;
								this.$state = 5;
								break;
														case 2:
									this.$current = this.$i;
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								this.$i++;
								this.$state = 5;
								break;
							case 5:
								if (this.$i < count) {
									this.$state = 2;
								}
								else {
									this.$state = 6;
								}
								break;
							case 6:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } (startValue, count) };
		return new $.ig.GenericEnumerable$1($.ig.Number.prototype.$type, $iter);
	}

	, 
	concat$1: function ($tSource, source2) {
		var $self = this;
		var $iter = function () { return function ($tSource, source2) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			$item1 : null,
			$en1 : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 4;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$current = this.$item;
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 5;
								}
								break;

							case 5:

								this.$state = 6;
								break;
							case 6:
								this.$en1 = source2.getEnumerator();
								this.$state = 9;
								break;
														case 7:
								this.$item1 = this.$en1.current();
									this.$current = this.$item1;
									this.$state = 8;
									return true;
								case 8:

								this.$state = 9;
								break;
case 9:
								if (this.$en1.moveNext()) {
									this.$state = 7;
								}
								else {
									this.$state = 10;
								}
								break;

							case 10:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, source2) };
		return new $.ig.GenericEnumerable$1($tSource, $iter);
	}

	, 
	max: function () {
		var first = true;
		var max = 0;
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			if (first) {
				first = false;
				max = item;

			} else {
				max = Math.max(max, item);
			}

		}

		return max;
	}

	, 
	max$1: function ($tSource, selector) {
		return this.select$2($tSource, $.ig.Number.prototype.$type, selector).max();
	}

	, 
	min: function () {
		var first = true;
		var min = 0;
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			if (first) {
				first = false;
				min = item;

			} else {
				min = Math.min(min, item);
			}

		}

		return min;
	}

	, 
	min$1: function ($tSource, selector) {
		return this.select$2($tSource, $.ig.Number.prototype.$type, selector).max();
	}

	, 
	count$1: function ($tSource) {
		var count = 0;
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			count++;
		}

		return count;
	}

	, 
	reverse$1: function ($tSource) {
		var $self = this;
		var $iter = function () { return function ($tSource) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$list : null,
			$i : 0,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$list = new $.ig.List$1($tSource, 1, this.$this);
								this.$state = 1;
								break;
							case 1:
																this.$i = this.$list.count() - 1;
								this.$state = 5;
								break;
														case 2:
									this.$current = this.$list.__inner[this.$i];
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								this.$i--;
								this.$state = 5;
								break;
							case 5:
								if (this.$i > 0) {
									this.$state = 2;
								}
								else {
									this.$state = 6;
								}
								break;
							case 6:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource) };
		return new $.ig.GenericEnumerable$1($tSource, $iter);
	}

	, 
	cast$1: function ($tResult) {
		if (this == null) {
			throw new $.ig.ArgumentNullException("source");
		}

		var enumerable = $.ig.util.cast($.ig.IEnumerable$1.prototype.$type.specialize($tResult), this);
		if (enumerable != null) {
			return enumerable;
		}

		var list = new $.ig.List$1($tResult, 0);
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			if ($.ig.util.cast($tResult, item) !== null) {
				list.add1(item);

			} else {
				list.add1(null);
			}

		}

		return list;
	}

	, 
	take$1: function ($tSource, toTake) {
		var $self = this;
		var $iter = function () { return function ($tSource, toTake) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 9;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$state = 3;
									break;
								case 3:
									if (toTake > 0) {
										this.$state = 4;
									}
									else {
										this.$state = 6;
									}
									break;

								case 4:
		toTake--;
		this.$current = this.$item;
		this.$state = 5;
		return true;
	case 5:

	this.$state = 8;
	break;

case 6:

		this.$state = -2;
		return false;
	case 7:

	this.$state = 8;
	break;
case 8:

								this.$state = 9;
								break;
case 9:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 10;
								}
								break;

							case 10:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, toTake) };
		return new $.ig.GenericEnumerable$1($tSource, $iter);
	}

	, 
	skip$1: function ($tSource, toSkip) {
		var $self = this;
		var $iter = function () { return function ($tSource, toSkip) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 8;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$state = 3;
									break;
								case 3:
									if (toSkip <= 0) {
										this.$state = 4;
									}
									else {
										this.$state = 6;
									}
									break;

								case 4:
		this.$current = this.$item;
		this.$state = 5;
		return true;
	case 5:

	this.$state = 7;
	break;

case 6:
		toSkip--;
	this.$state = 7;
	break;
case 7:

								this.$state = 8;
								break;
case 8:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 9;
								}
								break;

							case 9:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, toSkip) };
		return new $.ig.GenericEnumerable$1($tSource, $iter);
	}

	, 
	any$1: function ($tSource) {
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			return true;
		}

		return false;
	}

	, 
	contains$1: function ($tSource, value_) {
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item_ = en.current();
			if (item_ === value_)
                {
                    return true;
                };
		}

		return false;
	}

	, 
	union$1: function ($tSource, second) {
		return null;
	}

	, 
	toArray$1: function ($tSource) {
		var arr = new $.ig.List$1($tSource, 1, this);
		return arr.asArrayList();
	}

	, 
	elementAt$1: function ($tSource, index) {
		var iList = $.ig.util.cast($.ig.IList$1.prototype.$type.specialize($tSource), this);
		if (iList != null) {
			return iList.item(index);
		}

		return this.skip$1($tSource, index).first$1($tSource);
	}

	, 
	sum: function () {
		var sum = 0;
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			sum += item;
		}

		return sum;
	}

	, 
	sum$1: function ($tSource, selector) {
		return this.select$2($tSource, Number, selector).sum();
	}
	, 
	$type: new $.ig.Type('Enumerable', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SortedList$1', 'List$1', {
	$tElement: null, 
	init: function ($tElement, source) {



		this.$tElement = $tElement
		this.$type = this.$type.specialize(this.$tElement);
		$.ig.List$1.prototype.init1.call(this, this.$tElement, 1, source);
	}

	, 
	getEnumerator: function () {
		return $.ig.List$1.prototype.getEnumerator.call(this);
	}
	, 
	$type: new $.ig.Type('SortedList$1', $.ig.List$1.prototype.$type.specialize(0), [$.ig.IOrderedEnumerable$1.prototype.$type.specialize(0)])
}, true);


$.ig.util.defType('IArray', 'Object', {
	$type: new $.ig.Type('IArray', null)
}, true);








$.ig.util.defType('AggregateException', 'Error', {
	init: function (initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.Error.prototype.init.call(this);
	}
	, 
	init1: function (initNumber, message) {



		$.ig.Error.prototype.init1.call(this, 1, message);
	}
	, 
	init2: function (initNumber, message, innerException) {



		$.ig.Error.prototype.init2.call(this, 2, message, innerException);
	}
	, 
	$type: new $.ig.Type('AggregateException', $.ig.Error.prototype.$type)
}, true);

$.ig.util.defType('ArgumentException', 'Error', {
	init: function (initNumber, message) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.Error.prototype.init1.call(this, 1, message);
	}
	, 
	init1: function (initNumber, errorMessage, paramName) {



		$.ig.Error.prototype.init1.call(this, 1, errorMessage);
	}
	, 
	$type: new $.ig.Type('ArgumentException', $.ig.Error.prototype.$type)
}, true);

$.ig.util.defType('ArgumentNullException', 'Error', {
	init: function (argumentName) {



		$.ig.Error.prototype.init1.call(this, 1, argumentName + " cannot be null.");
	}
	, 
	$type: new $.ig.Type('ArgumentNullException', $.ig.Error.prototype.$type)
}, true);


$.ig.util.defType('AsyncCompletedEventArgs', 'EventArgs', {
	__error: null
	, 
	__cancelled: false
	, 
	__userState: null
	, 
	init: function (error, cancelled, userState) {



		$.ig.EventArgs.prototype.init.call(this);
			this.__cancelled = cancelled;
			this.__error = error;
			this.__userState = userState;
	}

	, 
	error: function () {

			return this.__error;
	}

	, 
	cancelled: function () {

			return this.__cancelled;
	}

	, 
	userState: function () {

			return this.__userState;
	}

	, 
	raiseExceptionIfNecessary: function () {
		if (this.error() != null) {
			throw this.error();
		}

	}
	, 
	$type: new $.ig.Type('AsyncCompletedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);



$.ig.util.defType('Environment', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	newLine: function () {

			return "\n";
	}
	, 
	$type: new $.ig.Type('Environment', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('InvalidOperationException', 'Error', {
	init: function (initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.Error.prototype.init1.call(this, 1, "Invalid operation");
	}
	, 
	init1: function (initNumber, errorMessage) {



		$.ig.Error.prototype.init1.call(this, 1, errorMessage);
	}
	, 
	$type: new $.ig.Type('InvalidOperationException', $.ig.Error.prototype.$type)
}, true);

$.ig.util.defType('Debug', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	assert1: function (condition, text) {
	}

	, 
	writeLine: function (line) {
	}

	, 
	assert: function (value) {
	}
	, 
	$type: new $.ig.Type('Debug', $.ig.Object.prototype.$type)
}, true);



$.ig.util.defType('ICredentials', 'Object', {
	$type: new $.ig.Type('ICredentials', null)
}, true);

$.ig.util.defType('NetworkCredential', 'Object', {
	init: function (initNumber, userName, password) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.NetworkCredential.prototype.init1.call(this, 1, userName, password, String.empty());
	}
	, 
	init1: function (initNumber, userName, password, domain) {



		$.ig.Object.prototype.init.call(this);
			this.userName(userName);
			this.password(password);
			this.domain(domain);
	}

	, 
	getCredential: function (uri, authType) {
		return this;
	}

	, 
	_userName: null,
	userName: function (value) {
		if (arguments.length === 1) {
			this._userName = value;
			return value;
		} else {
			return this._userName;
		}
	}

	, 
	_password: null,
	password: function (value) {
		if (arguments.length === 1) {
			this._password = value;
			return value;
		} else {
			return this._password;
		}
	}

	, 
	_domain: null,
	domain: function (value) {
		if (arguments.length === 1) {
			this._domain = value;
			return value;
		} else {
			return this._domain;
		}
	}
	, 
	$type: new $.ig.Type('NetworkCredential', $.ig.Object.prototype.$type, [$.ig.ICredentials.prototype.$type])
}, true);


$.ig.util.defType('UploadStringCompletedEventArgs', 'AsyncCompletedEventArgs', {
	__result: null
	, 
	init: function (result, exception, cancelled, userToken) {



		$.ig.AsyncCompletedEventArgs.prototype.init.call(this, exception, cancelled, userToken);
			this.__result = result;
	}

	, 
	result: function () {

			this.raiseExceptionIfNecessary();
			return this.__result;
	}
	, 
	$type: new $.ig.Type('UploadStringCompletedEventArgs', $.ig.AsyncCompletedEventArgs.prototype.$type)
}, true);

$.ig.util.defType('WebClient', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.headers(new $.ig.WebHeaderCollection());
	}

	, 
	_encoding: null,
	encoding: function (value) {
		if (arguments.length === 1) {
			this._encoding = value;
			return value;
		} else {
			return this._encoding;
		}
	}

	, 
	_headers: null,
	headers: function (value) {
		if (arguments.length === 1) {
			this._headers = value;
			return value;
		} else {
			return this._headers;
		}
	}

	, 
	_credentials: null,
	credentials: function (value) {
		if (arguments.length === 1) {
			this._credentials = value;
			return value;
		} else {
			return this._credentials;
		}
	}
	, 
	uploadStringCompleted: null
	, 
	uploadStringAsync: function (address, method, data, userData) {
		var $self = this;
		$self.uploadStringTaskAsync(address, method, data).continueWith1(function (t) {
			if ($self.uploadStringCompleted != null) {
				var result = null;
				var exception = null;
				try {
						result = t.result();

				}
				catch (e_) {
						exception = e_;

				}
				$self.uploadStringCompleted($self, new $.ig.UploadStringCompletedEventArgs(result, exception, t.status() == $.ig.TaskStatus.prototype.canceled, userData));
			}

		});
	}

	, 
	uploadStringTaskAsync: function (address, method, data) {
		var url_ = address.value();
		var method_ = method;
		var data_ = data;
		var contentType_ = this.headers().item("Content-Type");
		var credentials_ = this.credentials();
		var promise = $.ig.util.ajax(url_, contentType_, data_, method_, credentials_);
		return new $.ig.Task$1(String, promise, null);
	}

	, 
	onSuccess: function (tcs, data, textStatus, jqXHR) {
		tcs.setResult(data);
	}

	, 
	onError: function (tcs, jqXHR, textStatus, errorThrown) {
		tcs.setException(new $.ig.Error(1, errorThrown));
	}
	, 
	$type: new $.ig.Type('WebClient', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('WebHeaderCollection', 'NameValueCollection', {
	init: function () {

		$.ig.NameValueCollection.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('WebHeaderCollection', $.ig.NameValueCollection.prototype.$type)
}, true);

$.ig.util.defType('FaultCode', 'Object', {
	init: function (name) {



		$.ig.Object.prototype.init.call(this);
			this.name(name);
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}
	, 
	$type: new $.ig.Type('FaultCode', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('FaultException', 'Error', {
	init: function (reason, code, action) {



		$.ig.Error.prototype.init.call(this);
			this.reason(reason);
			this.code(code);
			this.action(action);
	}

	, 
	_action: null,
	action: function (value) {
		if (arguments.length === 1) {
			this._action = value;
			return value;
		} else {
			return this._action;
		}
	}

	, 
	_code: null,
	code: function (value) {
		if (arguments.length === 1) {
			this._code = value;
			return value;
		} else {
			return this._code;
		}
	}

	, 
	_reason: null,
	reason: function (value) {
		if (arguments.length === 1) {
			this._reason = value;
			return value;
		} else {
			return this._reason;
		}
	}
	, 
	$type: new $.ig.Type('FaultException', $.ig.Error.prototype.$type)
}, true);

$.ig.util.defType('FaultException$1', 'FaultException', {
	$tDetail: null, 
	init: function ($tDetail, detail, reason, code, action) {



		this.$tDetail = $tDetail
		this.$type = this.$type.specialize(this.$tDetail);
		$.ig.FaultException.prototype.init.call(this, reason, code, action);
			this.detail(detail);
	}

	, 
	_detail: null,
	detail: function (value) {
		if (arguments.length === 1) {
			this._detail = value;
			return value;
		} else {
			return this._detail;
		}
	}
	, 
	$type: new $.ig.Type('FaultException$1', $.ig.FaultException.prototype.$type)
}, true);

$.ig.util.defType('FaultReason', 'Object', {
	__text: null
	, 
	init: function (text) {



		$.ig.Object.prototype.init.call(this);
			this.__text = text;
	}

	, 
	toString: function () {
		return this.__text;
	}
	, 
	$type: new $.ig.Type('FaultReason', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('StringBuilder', 'Object', {

	_internal: null,
	internal: function (value) {
		if (arguments.length === 1) {
			this._internal = value;
			return value;
		} else {
			return this._internal;
		}
	}
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this._internal = [];
	}

	, 
	append1: function (str_) {
		this._internal.push(str_);
		return this;
	}

	, 
	append2: function (builder) {
		var str_ = builder.toString();
		this._internal.push(str_);
		return this;
	}

	, 
	append: function (chr_) {
		this._internal.push(chr_);
		return this;
	}

	, 
	appendLine: function (str_) {
		this._internal.push(str_ + String.fromCharCode(10));
		return this;
	}

	, 
	insert: function (index_, chr_) {
		this._internal.splice(index_, 0, chr_);
		return this;
	}

	, 
	insert1: function (index_, str_) {
		this._internal.splice(index_, 0, str_);
		return this;
	}

	, 
	remove: function (startIndex_, length_) {
		this._internal.splice(startIndex_, length_);
		return this;
	}

	, 
	toString: function () {
		return this._internal.join('');
	}
	, 
	$type: new $.ig.Type('StringBuilder', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('NotImplementedException', 'Error', {
	init: function () {



		$.ig.Error.prototype.init1.call(this, 1, "not implemented");
	}
	, 
	$type: new $.ig.Type('NotImplementedException', $.ig.Error.prototype.$type)
}, true);


$.ig.util.defType('Encoding', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	uTF8: function () {

			if ($.ig.Encoding.prototype._utfEncoding == null) {
				$.ig.Encoding.prototype._utfEncoding = new $.ig.UTF8Encoding();
			}

			return $.ig.Encoding.prototype._utfEncoding;
	}

	, 
	unicode: function () {

			if ($.ig.Encoding.prototype._unicodeEncoding == null) {
				$.ig.Encoding.prototype._unicodeEncoding = new $.ig.UnicodeEncoding();
			}

			return $.ig.Encoding.prototype._unicodeEncoding;
	}

	, 
	getString: function (bytes, startIndex, length) {
		return "";
	}

	, 
	getBytes2: function (chars, charIndex, charCount, bytes, byteIndex) {
	}

	, 
	getBytes: function (chars, index, count) {
		var array = new Array(this.getByteCount(chars, index, count));
		this.getBytes2(chars, index, count, array, 0);
		return array;
	}

	, 
	getBytes1: function (input) {
		if (input == null) {
			throw new $.ig.ArgumentNullException("input");
		}

		var array = new Array(input.length);
		for (var i = 0; i < input.length; i++) {
			array[i] = input.charAt(i);
		}

		return this.getBytes(array, 0, array.length);
	}

	, 
	getByteCount: function (chars, index, count) {
	}
	, 
	$type: new $.ig.Type('Encoding', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('UnicodeEncoding', 'Encoding', {
	init: function () {

		$.ig.Encoding.prototype.init.call(this);

	}
	, 
	getString: function (bytes_, startIndex, length) {
		var ret = "";
		for (var i_ = startIndex; i_ < length; i_ = i_ + 2) {
			if (bytes_[i_] == 0) {
				break;
			}

			if (i_ + 1 >= length) {
				ret = ret + '�';

			} else {
				var bits0 = (bytes_[i_]).toString(16);
				var bits1 = (bytes_[i_ + 1]).toString(16);
				var code = $.ig.Number.prototype.parseInt(bits1 + bits0, 16);
				ret = ret + String.fromCharCode(code);
			}

		}

		return ret;
	}

	, 
	getByteCount: function (chars, index, count) {
		return 0;
	}

	, 
	getBytes2: function (chars, charIndex, charCount, bytes, byteIndex) {
		return 0;
	}

	, 
	getBytes: function (chars, index, count) {
		return $.ig.Encoding.prototype.getBytes.call(this, chars, index, count);
	}

	, 
	getBytes1: function (input_) {
		var bytes = new Array(input_.length * 2);
		for (var i_ = 0; i_ < input_.length; i_++) {
			var hex_ = input_.charCodeAt(i_).toString(16).padLeft(4, '0');
			bytes[2 * i_] = $.ig.Number.prototype.parseInt(hex_.substr(2), 16);
			bytes[2 * i_ + 1] = $.ig.Number.prototype.parseInt(hex_.substr(0, 2), 16);
		}

		return bytes;
	}
	, 
	$type: new $.ig.Type('UnicodeEncoding', $.ig.Encoding.prototype.$type)
}, true);

$.ig.util.defType('UTF8Encoding', 'Encoding', {
	init: function () {

		$.ig.Encoding.prototype.init.call(this);

	}
	, 
	getString: function (bytes_, startIndex, length) {
		var ret_ = "";
		for (var i_ = startIndex; i_ < length; i_++) {
			if (bytes_[i_] == 0) {
				break;
			}

			ret_ = ret_ + String.fromCharCode(bytes_[i_]);
		}

		ret_ = decodeURIComponent(escape(ret_));
		return ret_;
	}

	, 
	getByteCount: function (chars, index, count) {
		return 0;
	}

	, 
	getBytes2: function (chars, charIndex, charCount, bytes, byteIndex) {
		return 0;
	}

	, 
	getBytes: function (chars, index, count) {
		return $.ig.Encoding.prototype.getBytes.call(this, chars, index, count);
	}

	, 
	getBytes1: function (input_) {
		var bytes = new Array(input_.length);
		var inputUTF8_ = unescape(encodeURIComponent(input_));
		for (var i_ = 0; i_ < inputUTF8_.length; i_++) {
			bytes[i_] = inputUTF8_.charCodeAt(i_);
		}

		return bytes;
	}
	, 
	$type: new $.ig.Type('UTF8Encoding', $.ig.Encoding.prototype.$type)
}, true);

$.ig.util.defType('Task', 'Object', {

	_promise: null,
	promise: function (value) {
		if (arguments.length === 1) {
			this._promise = value;
			return value;
		} else {
			return this._promise;
		}
	}

	, 
	_isCanceled: false,
	isCanceled: function (value) {
		if (arguments.length === 1) {
			this._isCanceled = value;
			return value;
		} else {
			return this._isCanceled;
		}
	}

	, 
	_exception: null,
	exception: function (value) {
		if (arguments.length === 1) {
			this._exception = value;
			return value;
		} else {
			return this._exception;
		}
	}
	, 
	init: function (initNumber, promise) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.Task.prototype.init1.call(this, 1, promise, null);
	}
	, 
	init1: function (initNumber, promise, state) {


		var $self = this;

		$.ig.Object.prototype.init.call(this);
			var doneContinuation = function () {
			};
			var failContinuation = function (exception) {
				if (exception == null) {
					$self.isCanceled(true);

				} else {
					$self.exception(new $.ig.AggregateException(2, "Exception occurred during task execution", exception));
				}

			};
			this.promise(promise.done(doneContinuation).fail(failContinuation));
			this.asyncState(state);
	}

	, 
	status: function () {

			if (this.isCanceled()) {
			return $.ig.TaskStatus.prototype.canceled;
			}

			switch (this.promise().state()) {
				case "pending":
					return $.ig.TaskStatus.prototype.created;
				case "resolved":
					return $.ig.TaskStatus.prototype.ranToCompletion;
				case "rejected":
					return $.ig.TaskStatus.prototype.faulted;
				default:
					return $.ig.TaskStatus.prototype.created;
			}

	}

	, 
	_asyncState: null,
	asyncState: function (value) {
		if (arguments.length === 1) {
			this._asyncState = value;
			return value;
		} else {
			return this._asyncState;
		}
	}

	, 
	continueWith: function (continuationAction) {
		var $self = this;
		var doneContinuation = function () { return continuationAction($self); };
		var failContinuation = function (exception) { return continuationAction($self); };
		var continuationPromise = $self.promise().done(doneContinuation).fail(failContinuation);
		return new $.ig.Task(0, continuationPromise);
	}

	, 
	continueWith$1: function ($tNewResult, continuationFunction) {
		var $self = this;
		var tcs = new $.ig.TaskCompletionSource$1($tNewResult, 0);
		var continuation = function () {
			try {
					var newResult = continuationFunction($self);
					tcs.setResult(newResult);

			}
			catch (e_) {
					tcs.setException(e_);

			}
		};
		var doneContinuation = function (res) { return continuation(); };
		var failContinuation = function (exc) { return continuation(); };
		$self.promise().done(doneContinuation).fail(failContinuation);
		return tcs.task();
	}
	, 
	$type: new $.ig.Type('Task', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Task$1', 'Task', {
	$tResult: null, 
	init: function ($tResult, promise, state) {


		var $self = this;
		this.__resultReady = false;

		this.$tResult = $tResult
		this.$type = this.$type.specialize(this.$tResult);
		$.ig.Task.prototype.init1.call(this, 1, promise, state);
			var doneContinuation = function (res) {
				var result = res;
				$self.__result = result;
				$self.__resultReady = true;
			};
			var failContinuation = function (exc) {
				$self.__resultReady = true;
			};
			this.promise().done(doneContinuation).fail(failContinuation);
	}
	, 
	__resultReady: false
	, 
	__result: null

	, 
	result: function () {

			if (!this.__resultReady) {
				throw 'Result is not ready yet';
			}

			if (this.exception() != null) {
				throw this.exception();
			}

			return this.__result;
	}

	, 
	continueWith1: function (continuationAction) {
		var $self = this;
		return $.ig.Task.prototype.continueWith.call($self, function (t) { return continuationAction(t); });
	}

	, 
	continueWith$11: function ($tNewResult, continuationFunction) {
		var $self = this;
		var wrapperFunction = function (t) { return continuationFunction(t); };
		return $self.continueWithBase$1($.ig.Object.prototype.$type, wrapperFunction).continueWithBase$1($tNewResult, function (t) { return (t).result(); });
	}

	, 
	continueWithBase$1: function ($tNewResult, continuationFunction) {
		return $.ig.Task.prototype.continueWith$1.call(this, $tNewResult, continuationFunction);
	}
	, 
	$type: new $.ig.Type('Task$1', $.ig.Task.prototype.$type)
}, true);

$.ig.util.defType('TaskCompletionSource$1', 'Object', {
	$tResult: null
	, 
	_deferred: null,
	deferred: function (value) {
		if (arguments.length === 1) {
			this._deferred = value;
			return value;
		} else {
			return this._deferred;
		}
	}
	, 
	init: function ($tResult, initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		this.$tResult = $tResult
		this.$type = this.$type.specialize(this.$tResult);
		$.ig.TaskCompletionSource$1.prototype.init1.call(this, this.$tResult, 1, null);
	}
	, 
	init1: function ($tResult, initNumber, state) {



		this.$tResult = $tResult
		this.$type = this.$type.specialize(this.$tResult);
		$.ig.Object.prototype.init.call(this);
			this.deferred($.ig.util.deferred());
			this.task(new $.ig.Task$1(this.$tResult, this.deferred().promise(), state));
	}

	, 
	setCanceled: function () {
		this.deferred().reject(null);
	}

	, 
	setException: function (exception) {
		this.deferred().reject(exception);
	}

	, 
	setResult: function (result) {
		this.deferred().resolve(result);
	}

	, 
	_task: null,
	task: function (value) {
		if (arguments.length === 1) {
			this._task = value;
			return value;
		} else {
			return this._task;
		}
	}
	, 
	$type: new $.ig.Type('TaskCompletionSource$1', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TaskFactory', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	continueWhenAll: function (tasks, continuationAction) {
		var $self = this;
		return new $.ig.Task(0, $self.whenAll($self.getPromises(tasks)).always(function () { return continuationAction(tasks); }));
	}

	, 
	continueWhenAll$1: function ($tResult, tasks, continuationFunction) {
		var $self = this;
		var tcs = new $.ig.TaskCompletionSource$1($tResult, 0);
		$self.whenAll($self.getPromises(tasks)).always(function () {
			try {
					var result = continuationFunction(tasks);
					tcs.setResult(result);

			}
			catch (e_) {
					tcs.setException(e_);

			}
		});
		return tcs.task();
	}

	, 
	continueWhenAll$2: function ($tAntecedentResult, $tResult, tasks, continuationFunction) {
		var $self = this;
		var wrapperFunction = function (t) { return continuationFunction(t); };
		return $self.continueWhenAll$1($.ig.Object.prototype.$type, tasks, wrapperFunction).continueWith$1($tResult, function (t) { return t.result(); });
	}

	, 
	getPromises: function (tasks) {
		var promises = new Array(tasks.length);
		for (var i = 0; i < tasks.length; i++) {
			promises[i] = tasks[i].promise();
		}

		return promises;
	}

	, 
	whenAll: function (promises) {
		var promises_ = promises;
		var whenPromise = (function (p) {
    //can't use $.when as it rejects the master Deferred as soon as one of the Deferreds is rejected
    //and we need to wait for all to complete
    function whenAll() {
	    var whenDeffered = $.ig.util.deferred();

	    if (arguments.length === 0) {
		    whenDeffered.resolve();
		    return whenDeffered;
	    }
   
	    var count = arguments.length;
	    var resolve = true;
	
	    for (var i = 0; i < arguments.length; i++) {
		    arguments[i].done(
			    function () {
				    resolve = resolve && true;
			    }).fail(
			    function () {
				    resolve = resolve && false;
			    }
		    ).always(function () {
			    count--;
			    if (count <= 0) {
				    if (resolve) {
					    whenDeffered.resolve();
				    } else {
					    whenDeffered.reject();
				    }
			    }
		    });
	    }
	
	    return whenDeffered;
    }
	return whenAll.apply($, p);
})(promises_);;
		return whenPromise;
	}
	, 
	$type: new $.ig.Type('TaskFactory', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Tuple$2', 'Object', {
	$t1: null, 
	$t2: null
	, 
	_item1: null,
	item1: function (value) {
		if (arguments.length === 1) {
			this._item1 = value;
			return value;
		} else {
			return this._item1;
		}
	}

	, 
	_item2: null,
	item2: function (value) {
		if (arguments.length === 1) {
			this._item2 = value;
			return value;
		} else {
			return this._item2;
		}
	}
	, 
	init: function ($t1, $t2, item1, item2) {



		this.$t1 = $t1
		this.$t2 = $t2
		this.$type = this.$type.specialize(this.$t1, this.$t2);
		$.ig.Object.prototype.init.call(this);
			this.item1(item1);
			this.item2(item2);
	}
	, 
	$type: new $.ig.Type('Tuple$2', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Uri', 'Object', {
	init: function (uri) {



		$.ig.Object.prototype.init.call(this);
			this.value(uri);
	}

	, 
	_value: null,
	value: function (value) {
		if (arguments.length === 1) {
			this._value = value;
			return value;
		} else {
			return this._value;
		}
	}
	, 
	$type: new $.ig.Type('Uri', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('JavaScriptSerializer', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
	}

	, 
	deserializeObject: function (input) {
		var text_ = input;
		return JSON.parse(text_);
	}

	, 
	serialize: function (obj) {
		var value_ = obj;
		return JSON.stringify(value_);
	}
	, 
	$type: new $.ig.Type('JavaScriptSerializer', $.ig.Object.prototype.$type)
}, true);






































































$.ig.util.defType('XObject', 'Object', {
	init: function (node) {



		$.ig.Object.prototype.init.call(this);
			this.backingNode(node);
	}

	, 
	_backingNode: null,
	backingNode: function (value) {
		if (arguments.length === 1) {
			this._backingNode = value;
			return value;
		} else {
			return this._backingNode;
		}
	}

	, 
	nodeType: function () {

	}

	, 
	toString: function () {
		if (this.backingNode() != null) {
			return $.ig.XmlUtils.prototype.xmlNodeToString(this.backingNode());

		} else {
			return "";
		}

	}
	, 
	$type: new $.ig.Type('XObject', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XAttribute', 'XObject', {
	init: function (node) {



		$.ig.XObject.prototype.init.call(this, node);
	}

	, 
	attachToElement: function (element) {
		this.backingNode(this.backingNode().cloneNode(true));
		element.setAttributeNode(this.backingNode());
	}

	, 
	nodeType: function () {

			return $.ig.XmlNodeType.prototype.attribute;
	}

	, 
	value: function () {

			return $.ig.XmlUtils.prototype.getAttributeValue(this.backingNode());
	}
	, 
	$type: new $.ig.Type('XAttribute', $.ig.XObject.prototype.$type)
}, true);

$.ig.util.defType('XNode', 'XObject', {
	init: function (node) {



		$.ig.XObject.prototype.init.call(this, node);
	}
	, 
	$type: new $.ig.Type('XNode', $.ig.XObject.prototype.$type)
}, true);

$.ig.util.defType('XContainer', 'XNode', {
	init: function (node) {



		$.ig.XNode.prototype.init.call(this, node);
	}

	, 
	element: function (name) {
		var element = null;
		var backingNode = this.backingNode();
		var children = backingNode.childNodes;
		var childrenCount = children.length;
		var localName = name.localName();
		var namespaceName = name.namespaceName();
		for (var i = 0; i < childrenCount; i++) {
			var currNode = children.item(i);
			if (currNode.namespaceURI == namespaceName && currNode.nodeType == $.ig.XmlNodeType.prototype.element && $.ig.XmlUtils.prototype.getLocalName(currNode) == localName) {
				element = currNode;
			}

		}

		if (element == null) {
			return null;

		} else {
			return new $.ig.XElement(0, element);
		}

	}

	, 
	elements: function () {
		return this.elementsImpl(null);
	}

	, 
	elements1: function (name) {
		return this.elementsImpl(name);
	}

	, 
	elementsImpl: function (name) {
		var elements = new $.ig.List$1($.ig.XElement.prototype.$type, 0);
		for (var i = 0; i < this.backingNode().childNodes.length; i++) {
			var currNode = this.backingNode().childNodes.item(i);
			if (currNode.nodeType == $.ig.XmlNodeType.prototype.element) {
				var match = false;
				if (name != null) {
					if ($.ig.XmlUtils.prototype.getLocalName(currNode) == name.localName() && currNode.namespaceURI == name.namespaceName()) {
						match = true;
					}


				} else {
					match = true;
				}

				if (match) {
					elements.add1(new $.ig.XElement(0, currNode));
				}

			}

		}

		return elements;
	}

	, 
	add: function (content) {
		var node = this.backingNode();
		var doc;
		if ($.ig.util.cast($.ig.XDocument.prototype.$type, this) !== null) {
			doc = this.backingNode();

		} else {
			doc = this.backingNode().ownerDocument;
		}

		if ($.ig.util.cast($.ig.XAttribute.prototype.$type, content) !== null) {
			(content).attachToElement(node);

		} else if ($.ig.util.cast($.ig.XElement.prototype.$type, content) !== null) {
			(content).attachToNode(node, doc);
		}


	}
	, 
	$type: new $.ig.Type('XContainer', $.ig.XNode.prototype.$type)
}, true);

$.ig.util.defType('XDocument', 'XContainer', {
	init: function (initNumber, doc) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.XContainer.prototype.init.call(this, doc);
	}
	, 
	init1: function (initNumber) {



		$.ig.XContainer.prototype.init.call(this, $.ig.XmlUtils.prototype.createDocument());
	}

	, 
	nodeType: function () {

			return $.ig.XmlNodeType.prototype.document;
	}

	, 
	parse: function (text) {
		return new $.ig.XDocument(0, $.ig.XmlUtils.prototype.parseXml(text));
	}
	, 
	$type: new $.ig.Type('XDocument', $.ig.XContainer.prototype.$type)
}, true);

$.ig.util.defType('XElement', 'XContainer', {
	init: function (initNumber, element) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.XContainer.prototype.init.call(this, element);
	}
	, 
	init1: function (initNumber, name) {



		$.ig.XElement.prototype.init2.call(this, 2, name, null);
	}
	, 
	init2: function (initNumber, name, content) {



		$.ig.XContainer.prototype.init.call(this, $.ig.XmlUtils.prototype.createDetachedElement(name.localName(), name.namespaceName()));
			var value = content == null ? "" : content.toString();
			this.value(value);
	}

	, 
	value: function (value) {
		if (arguments.length === 1) {

			$.ig.XmlUtils.prototype.setInnerText(this.backingNode(), value);
			return value;
		} else {

			return $.ig.XmlUtils.prototype.getInnerText(this.backingNode());
		}
	}

	, 
	nodeType: function () {

			return $.ig.XmlNodeType.prototype.element;
	}

	, 
	name: function () {

			return $.ig.XName.prototype.get($.ig.XmlUtils.prototype.getLocalName(this.backingNode()), this.backingNode().namespaceURI);
	}

	, 
	attribute: function (name) {
		return new $.ig.XAttribute($.ig.XmlUtils.prototype.getAttributeNode(this.backingNode(), name.localName(), name.namespaceName()));
	}

	, 
	attachToNode: function (node, doc) {
		if (this.backingNode().ownerDocument != doc) {
			this.backingNode($.ig.XmlUtils.prototype.importNode(doc, this.backingNode()));
		}

		node.appendChild(this.backingNode());
	}
	, 
	$type: new $.ig.Type('XElement', $.ig.XContainer.prototype.$type)
}, true);

$.ig.util.defType('XmlUtils', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	isW3CDom: function () {
		return !!window.DOMParser;
	}

	, 
	parseW3CDom: function (text) {
		var text_ = text;
		return (new DOMParser()).parseFromString(text_, 'text/xml');
	}

	, 
	parseMSXmlDom: function (text) {
		var text_ = text;
		return (function (xml) {
    var xmlDoc = new ActiveXObject('Microsoft.XMLDOM');
    xmlDoc.async = false;
    xmlDoc.loadXML(xml);
    return xmlDoc;
})(text_);;
	}

	, 
	w3CDomNodeToString: function (node) {
		var node_ = node;
		return (new XMLSerializer()).serializeToString(node_);
	}

	, 
	mSXmlDomNodeToString: function (node) {
		var node_ = node;
		return node_.xml;
	}

	, 
	createMSXmlDom: function () {
		return new ActiveXObject('Microsoft.XMLDOM');
	}

	, 
	parseXml: function (text) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return $.ig.XmlUtils.prototype.parseW3CDom(text);

		} else {
			return $.ig.XmlUtils.prototype.parseMSXmlDom(text);
		}

	}

	, 
	xmlNodeToString: function (node) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return $.ig.XmlUtils.prototype.w3CDomNodeToString(node);

		} else {
			return $.ig.XmlUtils.prototype.mSXmlDomNodeToString(node);
		}

	}

	, 
	createDocument: function () {
		var doc;
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			doc = $.ig.XmlUtils.prototype.parseW3CDom("<dummy/>");
			doc.removeChild(doc.documentElement);

		} else {
			doc = $.ig.XmlUtils.prototype.createMSXmlDom();
		}

		return doc;
	}

	, 
	createDetachedElement: function (localName, namespaceName) {
		var doc_ = $.ig.XmlUtils.prototype.createDocument();
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return doc_.createElementNS(namespaceName, localName);

		} else {
			var name_ = localName;
			var namespaceURI_ = namespaceName;
			return doc_.createNode(1/*NODE_ELEMENT*/, name_, namespaceURI_);
		}

	}

	, 
	getInnerText: function (node) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return node.textContent;

		} else {
			var node_ = node;
			return node_.text;
		}

	}

	, 
	setInnerText: function (node, text) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			node.textContent = text;

		} else {
			var node_ = node;
			var text_ = text;
			node_.text = text_;
		}

	}

	, 
	importNode: function (doc, node) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return doc.importNode(node, true);

		} else {
			return node;
		}

	}

	, 
	getLocalName: function (node) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return node.localName;

		} else {
			var node_ = node;
			return node_.baseName;
		}

	}

	, 
	getAttributeNode: function (element, localName, namespaceName) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return element.getAttributeNodeNS(namespaceName, localName);

		} else {
			var elem_ = element;
			var ln_ = localName;
			var nn_ = namespaceName;
			return elem_.attributes.getQualifiedItem(ln_, nn_);
		}

	}

	, 
	getAttributeValue: function (attr) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return attr.nodeValue;

		} else {
			var attr_ = attr;
			return attr_.value;
		}

	}
	, 
	$type: new $.ig.Type('XmlUtils', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XName', 'Object', {
	__localName: null
	, 
	__namespaceName: null
	, 
	init: function (localName, namespaceName) {



		$.ig.Object.prototype.init.call(this);
			this.__localName = localName;
			this.__namespaceName = namespaceName;
	}

	, 
	localName: function () {

			return this.__localName;
	}

	, 
	namespaceName: function () {

			return this.__namespaceName;
	}

	, 
	namespace: function () {

			return $.ig.XNamespace.prototype.get(this.__namespaceName);
	}

	, 
	get: function (localName, namespaceName) {
		return new $.ig.XName(localName, namespaceName);
	}
	, 
	$type: new $.ig.Type('XName', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XNamespace', 'Object', {
	__namespaceName: null
	, 
	init: function (namespaceName) {



		$.ig.Object.prototype.init.call(this);
			this.__namespaceName = namespaceName;
	}

	, 
	get: function (namespaceName) {
		return new $.ig.XNamespace(namespaceName);
	}

	, 
	xmlns: function () {

			return $.ig.XNamespace.prototype.get("http://www.w3.org/2000/xmlns/");
	}

	, 
	namespaceName: function () {

			return this.__namespaceName;
	}
	, 
	$type: new $.ig.Type('XNamespace', $.ig.Object.prototype.$type)
}, true);













$.ig.TaskStatus.prototype.created = 0;
$.ig.TaskStatus.prototype.ranToCompletion = 5;
$.ig.TaskStatus.prototype.canceled = 6;
$.ig.TaskStatus.prototype.faulted = 7;


$.ig.ListSortDirection.prototype.ascending = 0;
$.ig.ListSortDirection.prototype.descending = 1;


$.ig.NotifyCollectionChangedAction.prototype.add = 0;
$.ig.NotifyCollectionChangedAction.prototype.remove = 1;
$.ig.NotifyCollectionChangedAction.prototype.replace = 2;
$.ig.NotifyCollectionChangedAction.prototype.reset = 4;




$.ig.Encoding.prototype._utfEncoding = null;
$.ig.Encoding.prototype._unicodeEncoding = null;



$.ig.util.extCopy($.ig.Queryable, [[[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.ICollection$1, $.ig.IEnumerable$1, $.ig.IList$1, $.ig.List$1, $.ig.IEnumerable, $.ig.ICollection, $.ig.IList, $.ig.Array, $.ig.Dictionary, $.ig.XmlNodeList, $.ig.XmlNamedNodeMap, $.ig.AbstractEnumerable, $.ig.IDictionary$2, $.ig.Dictionary$2, $.ig.GenericEnumerable$1, $.ig.ReadOnlyCollection$1, $.ig.Stack$1, $.ig.IOrderedEnumerable$1], ['asQueryable']]]);
$.ig.util.extCopy($.ig.Enumerable, [[[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.ICollection$1, $.ig.IEnumerable$1, $.ig.IList$1, $.ig.List$1, $.ig.IDictionary$2, $.ig.Dictionary$2, $.ig.GenericEnumerable$1, $.ig.ReadOnlyCollection$1, $.ig.Stack$1, $.ig.IOrderedEnumerable$1], ['where$1', 'where$11', 'select$2', 'selectMany$2', 'last$1', 'first$1', 'firstOrDefault$1', 'orderBy$2', 'orderByDescending$2', 'toList$1', 'concat$1', 'max', 'max$1', 'min', 'min$1', 'count$1', 'reverse$1', 'take$1', 'skip$1', 'any$1', 'contains$1', 'union$1', 'toArray$1', 'elementAt$1', 'sum', 'sum$1']], [[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.ICollection$1, $.ig.IEnumerable$1, $.ig.IList$1, $.ig.List$1, $.ig.IEnumerable, $.ig.ICollection, $.ig.IList, $.ig.Array, $.ig.Dictionary, $.ig.XmlNodeList, $.ig.XmlNamedNodeMap, $.ig.AbstractEnumerable, $.ig.IDictionary$2, $.ig.Dictionary$2, $.ig.GenericEnumerable$1, $.ig.ReadOnlyCollection$1, $.ig.Stack$1, $.ig.IOrderedEnumerable$1], ['ofType$1', 'cast$1']]]);

} (jQuery));


// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["ICoreOlapElement:a", 
"String:b", 
"Object:c", 
"Type:d", 
"Boolean:e", 
"ValueType:f", 
"Void:g", 
"RuntimeTypeHandle:h", 
"MethodInfo:i", 
"MethodBase:j", 
"MemberInfo:k", 
"ParameterInfo:l", 
"TypeCode:m", 
"Enum:n", 
"Number:o", 
"IComparable:p", 
"Number:q", 
"Single:r", 
"Number:s", 
"ConstructorInfo:t", 
"String:u", 
"Array:v", 
"RegExp:w", 
"Cube:x", 
"CubeType:y", 
"Date:z", 
"Date:aa", 
"Number:ab", 
"Catalog:ac", 
"Dimension:ad", 
"DimensionType:ae", 
"KpiDimension:af", 
"HierarchyOrigin:ai", 
"AggregatorType:aj", 
"CardinalityType:ak", 
"MemberType:al", 
"Hierarchy:am", 
"Kpi:an", 
"Level:ao", 
"Measure:ap", 
"KpiMeasure:aq", 
"MeasureGroup:ar", 
"MeasureGroupDimension:as", 
"Member:at", 
"Nullable$1:au", 
"OlapResult:av", 
"IList$1:aw", 
"ICollection$1:ax", 
"IEnumerable$1:ay", 
"IEnumerable:az", 
"IEnumerator:a0", 
"IEnumerator$1:a1", 
"OlapResultAxis:a2", 
"PositionResolver$2:a3", 
"List$1:a4", 
"IArrayList:a5", 
"Array:a6", 
"ICollection:a7", 
"CompareCallback:a8", 
"MulticastDelegate:a9", 
"IntPtr:ba", 
"IList:bb", 
"IDisposable:bc", 
"IArray:bd", 
"Script:be", 
"Func$3:bf", 
"Action$1:bg", 
"PositionItemInfo$2:bh", 
"Dictionary$2:bi", 
"IDictionary$2:bj", 
"IDictionary:bk", 
"Dictionary:bl", 
"IEqualityComparer$1:bm", 
"KeyValuePair$2:bn", 
"NotImplementedException:bo", 
"Error:bp", 
"IHierarchicalPositionItem$2:bq", 
"IPositionItem$2:br", 
"IPosition$2:bs", 
"Math:bt", 
"Number:bu", 
"Number:bv", 
"Number:bw", 
"Number:bx", 
"Number:by", 
"Number:bz", 
"Number:b0", 
"Enumerable:b1", 
"Func$2:b2", 
"IOrderedEnumerable$1:b3", 
"SortedList$1:b4", 
"ArgumentNullException:b5", 
"EventHandler$1:b6", 
"Delegate:b7", 
"ListSortDirection:b8", 
"OlapResultTuple:b9", 
"ReadOnlyCollection$1:ca", 
"OlapResultAxisMember:cb", 
"OlapResultCell:cc", 
"IConnection:cd", 
"IOlapDataProviderFactory:ce", 
"IOlapDiscoverDataProvider:cf", 
"Task$1:cg", 
"Task:ch", 
"JQueryPromise:ci", 
"Action:cj", 
"AggregateException:ck", 
"TaskStatus:cl", 
"TaskCompletionSource$1:cm", 
"JQueryDeferred:cn", 
"JQuery:co", 
"JQueryObject:cp", 
"Element:cq", 
"ElementAttributeCollection:cr", 
"ElementCollection:cs", 
"WebStyle:ct", 
"ElementNodeType:cu", 
"Document:cv", 
"EventListener:cw", 
"IElementEventHandler:cx", 
"ElementEventHandler:cy", 
"ElementAttribute:cz", 
"JQueryPosition:c0", 
"JQueryCallback:c1", 
"JQueryEvent:c2", 
"JQueryUICallback:c3", 
"IOlapExecuteCommandProvider:c4", 
"HeaderCellsLayoutOrientation:c5", 
"LevelSpanManager:c6", 
"SpanSource:c7", 
"ITableViewHeadersFactory:c8", 
"TableViewHeadersFactory:c9", 
"ArrayListCollection$1:da", 
"INotifyCollectionChanged:db", 
"NotifyCollectionChangedEventHandler:dc", 
"NotifyCollectionChangedEventArgs:dd", 
"EventArgs:de", 
"NotifyCollectionChangedAction:df", 
"TableViewHeaderCellSource:dg", 
"OlapTableViewHeaderCell:dh", 
"TableCompactViewHeadersFactory:di", 
"TableViewImpl:dj", 
"TableViewSettings:dk", 
"ResultHeaderSorter:dl", 
"ResultSorter$1:dm", 
"AxisTupleVisitor:dn", 
"LevelSortDirection:dp", 
"LevelSortBehavior:dq", 
"AxisHeaderSortingVisitor:dr", 
"TupleSortDirection:ds", 
"ResultColumnValueSorter:dt", 
"AxisValueSortingVisitor:du", 
"OlapTableViewResultCell:dv", 
"OlapResultView:dw", 
"InvalidOperationException:dx", 
"ResultViewHelper:dy", 
"IOlapDataSource:dz", 
"OlapMetadataTreeItem:d0", 
"OlapMetadataTreeItemType:d1", 
"MeasureListLocation:d2", 
"MeasureList:d3", 
"OlapDataSource:d4", 
"DataSourceBaseOptions:d5", 
"CubeMetaItemsCache:d6", 
"MeasureGroupMetaItemsCache:d7", 
"Tuple$2:d8", 
"NotSupportedException:d9", 
"PositionInfo:ea", 
"TaskExtensions:eb", 
"AxisElement:ec", 
"AxisDefinitionParser:ed", 
"Debug:ee", 
"TaskFactory:ef", 
"MetaTreeHelper:eg", 
"HierarchyItemPosition:eh", 
"CoreOlapElementParser:el", 
"KeyValueItem:eu", 
"HierarchyFilterView:ev", 
"FilterMember:ew", 
"INotifyPropertyChanged:ex", 
"PropertyChangedEventHandler:ey", 
"PropertyChangedEventArgs:ez", 
"FilterMemberStateChangedEventArgs:e0", 
"DataSourceBase:e1", 
"jQueryUtils:e2", 
"OlapUtilities:e3", 
"OlapTableView:e4", 
"AbstractEnumerable:e5", 
"Func$1:e6", 
"AbstractEnumerator:e7", 
"GenericEnumerable$1:e8", 
"GenericEnumerator$1:e9"]);

$.ig.util.defType('LevelSortBehavior', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('LevelSortBehavior', $.ig.Enum.prototype.$type)
}, true);





$.ig.util.defType('OlapMetadataTreeItemType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('OlapMetadataTreeItemType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('MeasureListLocation', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MeasureListLocation', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('HeaderCellsLayoutOrientation', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('HeaderCellsLayoutOrientation', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('MemberType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MemberType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('CardinalityType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('CardinalityType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('AggregatorType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('AggregatorType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('HierarchyOrigin', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('HierarchyOrigin', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('DimensionType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('DimensionType', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('CubeType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('CubeType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('ICoreOlapElement', 'Object', {
	$type: new $.ig.Type('ICoreOlapElement', null)
}, true);

$.ig.util.defType('Cube', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_catalogName: null,
	catalogName: function (value) {
		if (arguments.length === 1) {
			this._catalogName = value;
			return value;
		} else {
			return this._catalogName;
		}
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_cubeType: null,
	cubeType: function (value) {
		if (arguments.length === 1) {
			this._cubeType = value;
			return value;
		} else {
			return this._cubeType;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_lastProcessed: null,
	lastProcessed: function (value) {
		if (arguments.length === 1) {
			this._lastProcessed = value;
			return value;
		} else {
			return this._lastProcessed;
		}
	}

	, 
	_lastUpdated: null,
	lastUpdated: function (value) {
		if (arguments.length === 1) {
			this._lastUpdated = value;
			return value;
		} else {
			return this._lastUpdated;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	uniqueName: function (value) {
		if (arguments.length === 1) {

			this.name(value);
			return value;
		} else {

			return this.name();
		}
	}
	, 
	$type: new $.ig.Type('Cube', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('Catalog', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}
	, 
	$type: new $.ig.Type('Catalog', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('Dimension', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_dimensionType: null,
	dimensionType: function (value) {
		if (arguments.length === 1) {
			this._dimensionType = value;
			return value;
		} else {
			return this._dimensionType;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_defaultHierarchy: null,
	defaultHierarchy: function (value) {
		if (arguments.length === 1) {
			this._defaultHierarchy = value;
			return value;
		} else {
			return this._defaultHierarchy;
		}
	}
	, 
	$type: new $.ig.Type('Dimension', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('KpiDimension', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}
	, 
	$type: new $.ig.Type('KpiDimension', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('Hierarchy', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_defaultHierarchy: null,
	defaultHierarchy: function (value) {
		if (arguments.length === 1) {
			this._defaultHierarchy = value;
			return value;
		} else {
			return this._defaultHierarchy;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_defaultMember: null,
	defaultMember: function (value) {
		if (arguments.length === 1) {
			this._defaultMember = value;
			return value;
		} else {
			return this._defaultMember;
		}
	}

	, 
	_allMember: null,
	allMember: function (value) {
		if (arguments.length === 1) {
			this._allMember = value;
			return value;
		} else {
			return this._allMember;
		}
	}

	, 
	_dimensionUniqueName: null,
	dimensionUniqueName: function (value) {
		if (arguments.length === 1) {
			this._dimensionUniqueName = value;
			return value;
		} else {
			return this._dimensionUniqueName;
		}
	}

	, 
	_hierarchyOrigin: null,
	hierarchyOrigin: function (value) {
		if (arguments.length === 1) {
			this._hierarchyOrigin = value;
			return value;
		} else {
			return this._hierarchyOrigin;
		}
	}

	, 
	_hierarchyDisplayFolder: null,
	hierarchyDisplayFolder: function (value) {
		if (arguments.length === 1) {
			this._hierarchyDisplayFolder = value;
			return value;
		} else {
			return this._hierarchyDisplayFolder;
		}
	}
	, 
	$type: new $.ig.Type('Hierarchy', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('Kpi', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_measureGroupName: null,
	measureGroupName: function (value) {
		if (arguments.length === 1) {
			this._measureGroupName = value;
			return value;
		} else {
			return this._measureGroupName;
		}
	}

	, 
	_kpiDisplayFolder: null,
	kpiDisplayFolder: function (value) {
		if (arguments.length === 1) {
			this._kpiDisplayFolder = value;
			return value;
		} else {
			return this._kpiDisplayFolder;
		}
	}

	, 
	_kpiValue: null,
	kpiValue: function (value) {
		if (arguments.length === 1) {
			this._kpiValue = value;
			return value;
		} else {
			return this._kpiValue;
		}
	}

	, 
	_kpiGoal: null,
	kpiGoal: function (value) {
		if (arguments.length === 1) {
			this._kpiGoal = value;
			return value;
		} else {
			return this._kpiGoal;
		}
	}

	, 
	_kpiStatus: null,
	kpiStatus: function (value) {
		if (arguments.length === 1) {
			this._kpiStatus = value;
			return value;
		} else {
			return this._kpiStatus;
		}
	}

	, 
	_kpiTrend: null,
	kpiTrend: function (value) {
		if (arguments.length === 1) {
			this._kpiTrend = value;
			return value;
		} else {
			return this._kpiTrend;
		}
	}

	, 
	_kpiStatusGraphic: null,
	kpiStatusGraphic: function (value) {
		if (arguments.length === 1) {
			this._kpiStatusGraphic = value;
			return value;
		} else {
			return this._kpiStatusGraphic;
		}
	}

	, 
	_kpiTrendGraphic: null,
	kpiTrendGraphic: function (value) {
		if (arguments.length === 1) {
			this._kpiTrendGraphic = value;
			return value;
		} else {
			return this._kpiTrendGraphic;
		}
	}

	, 
	_kpiWeight: null,
	kpiWeight: function (value) {
		if (arguments.length === 1) {
			this._kpiWeight = value;
			return value;
		} else {
			return this._kpiWeight;
		}
	}

	, 
	_parentKpiName: null,
	parentKpiName: function (value) {
		if (arguments.length === 1) {
			this._parentKpiName = value;
			return value;
		} else {
			return this._parentKpiName;
		}
	}

	, 
	_currentTimeMember: null,
	currentTimeMember: function (value) {
		if (arguments.length === 1) {
			this._currentTimeMember = value;
			return value;
		} else {
			return this._currentTimeMember;
		}
	}
	, 
	$type: new $.ig.Type('Kpi', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('Level', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_depth: 0,
	depth: function (value) {
		if (arguments.length === 1) {
			this._depth = value;
			return value;
		} else {
			return this._depth;
		}
	}

	, 
	_hierarchyUniqueName: null,
	hierarchyUniqueName: function (value) {
		if (arguments.length === 1) {
			this._hierarchyUniqueName = value;
			return value;
		} else {
			return this._hierarchyUniqueName;
		}
	}

	, 
	_dimensionUniqueName: null,
	dimensionUniqueName: function (value) {
		if (arguments.length === 1) {
			this._dimensionUniqueName = value;
			return value;
		} else {
			return this._dimensionUniqueName;
		}
	}

	, 
	_membersCount: 0,
	membersCount: function (value) {
		if (arguments.length === 1) {
			this._membersCount = value;
			return value;
		} else {
			return this._membersCount;
		}
	}

	, 
	_levelOrigin: 0,
	levelOrigin: function (value) {
		if (arguments.length === 1) {
			this._levelOrigin = value;
			return value;
		} else {
			return this._levelOrigin;
		}
	}

	, 
	_levelOrderingProperty: null,
	levelOrderingProperty: function (value) {
		if (arguments.length === 1) {
			this._levelOrderingProperty = value;
			return value;
		} else {
			return this._levelOrderingProperty;
		}
	}
	, 
	$type: new $.ig.Type('Level', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('Measure', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_measureGroupName: null,
	measureGroupName: function (value) {
		if (arguments.length === 1) {
			this._measureGroupName = value;
			return value;
		} else {
			return this._measureGroupName;
		}
	}

	, 
	_aggregatorType: null,
	aggregatorType: function (value) {
		if (arguments.length === 1) {
			this._aggregatorType = value;
			return value;
		} else {
			return this._aggregatorType;
		}
	}

	, 
	_defaultFormatString: null,
	defaultFormatString: function (value) {
		if (arguments.length === 1) {
			this._defaultFormatString = value;
			return value;
		} else {
			return this._defaultFormatString;
		}
	}

	, 
	_measureDisplayFolder: null,
	measureDisplayFolder: function (value) {
		if (arguments.length === 1) {
			this._measureDisplayFolder = value;
			return value;
		} else {
			return this._measureDisplayFolder;
		}
	}
	, 
	$type: new $.ig.Type('Measure', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('KpiMeasure', 'Measure', {
	init: function (uniqueName, caption) {



		$.ig.Measure.prototype.init.call(this);
			this.uniqueName(uniqueName);
			this.caption(caption);
	}

	, 
	_graphic: null,
	graphic: function (value) {
		if (arguments.length === 1) {
			this._graphic = value;
			return value;
		} else {
			return this._graphic;
		}
	}

	, 
	createKpiValueMeasure: function (kpi) {
		return new $.ig.KpiMeasure(kpi.kpiValue(), kpi.caption() + " Value");
	}

	, 
	createKpiGoalMeasure: function (kpi) {
		return new $.ig.KpiMeasure(kpi.kpiGoal(), kpi.caption() + " Goal");
	}

	, 
	createKpiWeightMeasure: function (kpi) {
		return new $.ig.KpiMeasure(kpi.kpiWeight(), kpi.caption() + " Weight");
	}

	, 
	createKpiStatusMeasure: function (kpi) {
		var measure = new $.ig.KpiMeasure(kpi.kpiStatus(), kpi.caption() + " Status");
		measure.graphic(kpi.kpiStatusGraphic());
		return measure;
	}

	, 
	createKpiTrendMeasure: function (kpi) {
		var measure = new $.ig.KpiMeasure(kpi.kpiTrend(), kpi.caption() + " Trend");
		measure.graphic(kpi.kpiTrendGraphic());
		return measure;
	}
	, 
	$type: new $.ig.Type('KpiMeasure', $.ig.Measure.prototype.$type)
}, true);

$.ig.util.defType('MeasureGroup', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_cubeName: null,
	cubeName: function (value) {
		if (arguments.length === 1) {
			this._cubeName = value;
			return value;
		} else {
			return this._cubeName;
		}
	}

	, 
	_catalogName: null,
	catalogName: function (value) {
		if (arguments.length === 1) {
			this._catalogName = value;
			return value;
		} else {
			return this._catalogName;
		}
	}

	, 
	uniqueName: function (value) {
		if (arguments.length === 1) {

			this.name(value);
			return value;
		} else {

			return this.name();
		}
	}
	, 
	$type: new $.ig.Type('MeasureGroup', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('MeasureGroupDimension', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_cubeName: null,
	cubeName: function (value) {
		if (arguments.length === 1) {
			this._cubeName = value;
			return value;
		} else {
			return this._cubeName;
		}
	}

	, 
	_catalogName: null,
	catalogName: function (value) {
		if (arguments.length === 1) {
			this._catalogName = value;
			return value;
		} else {
			return this._catalogName;
		}
	}

	, 
	_measureGroupName: null,
	measureGroupName: function (value) {
		if (arguments.length === 1) {
			this._measureGroupName = value;
			return value;
		} else {
			return this._measureGroupName;
		}
	}

	, 
	_dimensionUniqueName: null,
	dimensionUniqueName: function (value) {
		if (arguments.length === 1) {
			this._dimensionUniqueName = value;
			return value;
		} else {
			return this._dimensionUniqueName;
		}
	}

	, 
	_measureGroupCardinality: null,
	measureGroupCardinality: function (value) {
		if (arguments.length === 1) {
			this._measureGroupCardinality = value;
			return value;
		} else {
			return this._measureGroupCardinality;
		}
	}

	, 
	_dimensionCardinality: null,
	dimensionCardinality: function (value) {
		if (arguments.length === 1) {
			this._dimensionCardinality = value;
			return value;
		} else {
			return this._dimensionCardinality;
		}
	}

	, 
	_isDimensionVisible: false,
	isDimensionVisible: function (value) {
		if (arguments.length === 1) {
			this._isDimensionVisible = value;
			return value;
		} else {
			return this._isDimensionVisible;
		}
	}

	, 
	_isFactDimension: false,
	isFactDimension: function (value) {
		if (arguments.length === 1) {
			this._isFactDimension = value;
			return value;
		} else {
			return this._isFactDimension;
		}
	}

	, 
	_dimensionPath: null,
	dimensionPath: function (value) {
		if (arguments.length === 1) {
			this._dimensionPath = value;
			return value;
		} else {
			return this._dimensionPath;
		}
	}

	, 
	_dimensionGranularity: null,
	dimensionGranularity: function (value) {
		if (arguments.length === 1) {
			this._dimensionGranularity = value;
			return value;
		} else {
			return this._dimensionGranularity;
		}
	}
	, 
	$type: new $.ig.Type('MeasureGroupDimension', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Member', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			var nullValue = $.ig.util.toNullable($.ig.Number.prototype.$type, null);
			this.scope(nullValue);
	}

	, 
	_cubeName: null,
	cubeName: function (value) {
		if (arguments.length === 1) {
			this._cubeName = value;
			return value;
		} else {
			return this._cubeName;
		}
	}

	, 
	_catalogName: null,
	catalogName: function (value) {
		if (arguments.length === 1) {
			this._catalogName = value;
			return value;
		} else {
			return this._catalogName;
		}
	}

	, 
	_dimensionUniqueName: null,
	dimensionUniqueName: function (value) {
		if (arguments.length === 1) {
			this._dimensionUniqueName = value;
			return value;
		} else {
			return this._dimensionUniqueName;
		}
	}

	, 
	_hierarchyUniqueName: null,
	hierarchyUniqueName: function (value) {
		if (arguments.length === 1) {
			this._hierarchyUniqueName = value;
			return value;
		} else {
			return this._hierarchyUniqueName;
		}
	}

	, 
	_levelUniqueName: null,
	levelUniqueName: function (value) {
		if (arguments.length === 1) {
			this._levelUniqueName = value;
			return value;
		} else {
			return this._levelUniqueName;
		}
	}

	, 
	_levelDepth: 0,
	levelDepth: function (value) {
		if (arguments.length === 1) {
			this._levelDepth = value;
			return value;
		} else {
			return this._levelDepth;
		}
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_memberType: null,
	memberType: function (value) {
		if (arguments.length === 1) {
			this._memberType = value;
			return value;
		} else {
			return this._memberType;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_childrenCardinality: 0,
	childrenCardinality: function (value) {
		if (arguments.length === 1) {
			this._childrenCardinality = value;
			return value;
		} else {
			return this._childrenCardinality;
		}
	}

	, 
	_parentLevel: 0,
	parentLevel: function (value) {
		if (arguments.length === 1) {
			this._parentLevel = value;
			return value;
		} else {
			return this._parentLevel;
		}
	}

	, 
	_parentUniqueName: null,
	parentUniqueName: function (value) {
		if (arguments.length === 1) {
			this._parentUniqueName = value;
			return value;
		} else {
			return this._parentUniqueName;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_scope: $.ig.util.toNullable($.ig.Number.prototype.$type, null),
	scope: function (value) {
		if (arguments.length === 1) {
			this._scope = value;
			return value;
		} else {
			return this._scope;
		}
	}
	, 
	$type: new $.ig.Type('Member', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('OlapResult', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_isEmpty: false,
	isEmpty: function (value) {
		if (arguments.length === 1) {
			this._isEmpty = value;
			return value;
		} else {
			return this._isEmpty;
		}
	}

	, 
	_axes: null,
	axes: function (value) {
		if (arguments.length === 1) {
			this._axes = value;
			return value;
		} else {
			return this._axes;
		}
	}

	, 
	_cells: null,
	cells: function (value) {
		if (arguments.length === 1) {
			this._cells = value;
			return value;
		} else {
			return this._cells;
		}
	}
	, 
	$type: new $.ig.Type('OlapResult', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapResultAxis', 'Object', {
	init: function (tuples, tupleSize) {



		$.ig.Object.prototype.init.call(this);
			this.tuples(tuples.toList$1($.ig.OlapResultTuple.prototype.$type));
			this.tupleSize(tupleSize);
			this.positionResolver(new $.ig.PositionResolver$2(String, $.ig.Object.prototype.$type, tuples, tupleSize));
	}

	, 
	_positionResolver: null,
	positionResolver: function (value) {
		if (arguments.length === 1) {
			this._positionResolver = value;
			return value;
		} else {
			return this._positionResolver;
		}
	}

	, 
	clone: function () {
		var $self = this;
		var tuples = new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 0);
		var en = $self.tuples().getEnumerator();
		while (en.moveNext()) {
			var tuple = en.current();
			tuples.add(tuple.clone());
		}

		return (function () { var $ret = new $.ig.OlapResultAxis(tuples, $self.tupleSize());
		$ret.name($self.name()); return $ret;}());
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_tupleSize: 0,
	tupleSize: function (value) {
		if (arguments.length === 1) {
			this._tupleSize = value;
			return value;
		} else {
			return this._tupleSize;
		}
	}

	, 
	_tuples: null,
	tuples: function (value) {
		if (arguments.length === 1) {
			this._tuples = value;
			return value;
		} else {
			return this._tuples;
		}
	}
	, 
	$type: new $.ig.Type('OlapResultAxis', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IPosition$2', 'Object', {
	$type: new $.ig.Type('IPosition$2', null)
}, true);

$.ig.util.defType('OlapResultTuple', 'Object', {
	init: function (members) {



		$.ig.Object.prototype.init.call(this);
			this.members(new $.ig.ReadOnlyCollection$1($.ig.OlapResultAxisMember.prototype.$type, 1, members));
	}

	, 
	_members: null,
	members: function (value) {
		if (arguments.length === 1) {
			this._members = value;
			return value;
		} else {
			return this._members;
		}
	}

	, 
	getItems: function () {
		return this.members();
	}

	, 
	itemsCount: function () {

			return this.members().count();
	}

	, 
	indexOf: function (positionItem) {
		return this.members().indexOf(positionItem);
	}

	, 
	item: function (itemIndex) {

			return this.members().item(itemIndex);
	}

	, 
	isEmpty: function () {

			return false;
	}

	, 
	clone: function () {
		var axisMembers = new $.ig.List$1($.ig.OlapResultAxisMember.prototype.$type, 0);
		var en = this.members().getEnumerator();
		while (en.moveNext()) {
			var axisMember = en.current();
			axisMembers.add(axisMember.clone());
		}

		var tuple = new $.ig.OlapResultTuple(axisMembers);
		var en1 = axisMembers.getEnumerator();
		while (en1.moveNext()) {
			var axisMember1 = en1.current();
			axisMember1.position(tuple);
		}

		return tuple;
	}
	, 
	$type: new $.ig.Type('OlapResultTuple', $.ig.Object.prototype.$type, [$.ig.IPosition$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)])
}, true);

$.ig.util.defType('IPositionItem$2', 'Object', {
	$type: new $.ig.Type('IPositionItem$2', null)
}, true);

$.ig.util.defType('IHierarchicalPositionItem$2', 'Object', {
	$type: new $.ig.Type('IHierarchicalPositionItem$2', null, [$.ig.IPositionItem$2.prototype.$type.specialize(0, 1)])
}, true);

$.ig.util.defType('OlapResultAxisMember', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.properties(new $.ig.Dictionary$2(String, String, 0));
			this.ordinal(-1);
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_levelUniqueName: null,
	levelUniqueName: function (value) {
		if (arguments.length === 1) {
			this._levelUniqueName = value;
			return value;
		} else {
			return this._levelUniqueName;
		}
	}

	, 
	_hierarchyUniqueName: null,
	hierarchyUniqueName: function (value) {
		if (arguments.length === 1) {
			this._hierarchyUniqueName = value;
			return value;
		} else {
			return this._hierarchyUniqueName;
		}
	}

	, 
	_levelNumber: 0,
	levelNumber: function (value) {
		if (arguments.length === 1) {
			this._levelNumber = value;
			return value;
		} else {
			return this._levelNumber;
		}
	}

	, 
	_displayInfo: null,
	displayInfo: function (value) {
		if (arguments.length === 1) {
			this._displayInfo = value;
			return value;
		} else {
			return this._displayInfo;
		}
	}

	, 
	childCount: function () {

			return ((this.displayInfo() & ~65536) & ~131072);
	}

	, 
	drilledDown: function () {

			return (this.displayInfo() & 65536) == 65536;
	}

	, 
	parentSameAsPrev: function () {

			return (this.displayInfo() & 131072) == 131072;
	}

	, 
	_properties: null,
	properties: function (value) {
		if (arguments.length === 1) {
			this._properties = value;
			return value;
		} else {
			return this._properties;
		}
	}

	, 
	_position: null,
	position: function (value) {
		if (arguments.length === 1) {
			this._position = value;
			return value;
		} else {
			return this._position;
		}
	}

	, 
	key: function () {

			return this.uniqueName();
	}

	, 
	sortKey: function () {

			if (this.ordinal() > -1) {
				return this.ordinal();
			}

			var decimalValue = parseFloat(this.caption());
			if (!isNaN(decimalValue)) {
				return decimalValue;
			}

			return this.caption();
	}

	, 
	_ordinal: 0,
	ordinal: function (value) {
		if (arguments.length === 1) {
			this._ordinal = value;
			return value;
		} else {
			return this._ordinal;
		}
	}

	, 
	hierarchyKey: function () {

			return this.hierarchyUniqueName();
	}

	, 
	hierarchyLevelKey: function () {

			return this.levelUniqueName();
	}

	, 
	parentKey: function () {

			var $self = this;
			var parentKey;
			(function () { var $ret = $self.properties().tryGetValue("PARENT_UNIQUE_NAME", parentKey); parentKey = $ret.value; return $ret.ret; }());
			return parentKey;
	}

	, 
	depth: function () {

			return this.levelNumber();
	}

	, 
	isExpandable: function () {

			return this.childCount() > 0;
	}

	, 
	clone: function () {
		var axisMember = new $.ig.OlapResultAxisMember();
		axisMember.caption(this.caption());
		axisMember.displayInfo(this.displayInfo());
		axisMember.hierarchyUniqueName(this.hierarchyUniqueName());
		axisMember.levelNumber(this.levelNumber());
		axisMember.levelUniqueName(this.levelUniqueName());
		axisMember.ordinal(this.ordinal());
		var en = this.properties().getEnumerator();
		while (en.moveNext()) {
			var keyValuePair = en.current();
			axisMember.properties().add(keyValuePair.key(), keyValuePair.value());
		}

		axisMember.uniqueName(this.uniqueName());
		axisMember.position(this.position());
		return axisMember;
	}
	, 
	$type: new $.ig.Type('OlapResultAxisMember', $.ig.Object.prototype.$type, [$.ig.IHierarchicalPositionItem$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)])
}, true);

$.ig.util.defType('OlapResultCell', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.properties(new $.ig.Dictionary$2(String, $.ig.Object.prototype.$type, 0));
	}

	, 
	_cellOrdinal: 0,
	cellOrdinal: function (value) {
		if (arguments.length === 1) {
			this._cellOrdinal = value;
			return value;
		} else {
			return this._cellOrdinal;
		}
	}

	, 
	_properties: null,
	properties: function (value) {
		if (arguments.length === 1) {
			this._properties = value;
			return value;
		} else {
			return this._properties;
		}
	}

	, 
	clone: function () {
		var $self = this;
		var cell = (function () { var $ret = new $.ig.OlapResultCell();
		$ret.cellOrdinal($self.cellOrdinal()); return $ret;}());
		var en = $self.properties().getEnumerator();
		while (en.moveNext()) {
			var keyValuePair = en.current();
			cell.properties().add(keyValuePair.key(), keyValuePair.value());
		}

		return cell;
	}
	, 
	$type: new $.ig.Type('OlapResultCell', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IConnection', 'Object', {
	$type: new $.ig.Type('IConnection', null)
}, true);

$.ig.util.defType('IOlapDataProviderFactory', 'Object', {
	$type: new $.ig.Type('IOlapDataProviderFactory', null)
}, true);

$.ig.util.defType('IOlapDiscoverDataProvider', 'Object', {
	$type: new $.ig.Type('IOlapDiscoverDataProvider', null)
}, true);

$.ig.util.defType('IOlapExecuteCommandProvider', 'Object', {
	$type: new $.ig.Type('IOlapExecuteCommandProvider', null)
}, true);

$.ig.util.defType('LevelSpanManager', 'Object', {
	__spanSourceTable: null
	, 
	init: function (positionSize) {



		$.ig.Object.prototype.init.call(this);
			this.positionSize(positionSize);
			this.__spanSourceTable = new Array(positionSize);
	}

	, 
	_positionSize: 0,
	positionSize: function (value) {
		if (arguments.length === 1) {
			this._positionSize = value;
			return value;
		} else {
			return this._positionSize;
		}
	}

	, 
	getSpanSource: function (positionItemIndex, positionItemDepth) {
		var $self = this;
		var positionIndexSpanSources = $self.__spanSourceTable[positionItemIndex];
		if (positionIndexSpanSources == null) {
			positionIndexSpanSources = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.SpanSource.prototype.$type, 0);
			$self.__spanSourceTable[positionItemIndex] = positionIndexSpanSources;
		}

		var positionSpanSource;
		if (!(function () { var $ret = positionIndexSpanSources.tryGetValue(positionItemDepth, positionSpanSource); positionSpanSource = $ret.value; return $ret.ret; }())) {
			positionSpanSource = new $.ig.SpanSource();
			if (positionItemDepth > 0) {
				var parentSpanSource;
				if ((function () { var $ret = positionIndexSpanSources.tryGetValue(positionItemDepth - 1, parentSpanSource); parentSpanSource = $ret.value; return $ret.ret; }())) {
					positionSpanSource.parent(parentSpanSource);
					parentSpanSource.increaseSpanForChildren();
				}

			}

			positionIndexSpanSources.add(positionItemDepth, positionSpanSource);
		}

		return positionSpanSource;
	}
	, 
	$type: new $.ig.Type('LevelSpanManager', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SpanSource', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__spanValue = 1;
	}

	, 
	_parent: null,
	parent: function (value) {
		if (arguments.length === 1) {
			this._parent = value;
			return value;
		} else {
			return this._parent;
		}
	}
	, 
	__spanValue: 0

	, 
	spanValue: function (value) {
		if (arguments.length === 1) {

			if (this.__spanValue != value) {
				var diff = value - this.__spanValue;
				if (this.parent() != null) {
					this.parent().spanValue(this.parent().spanValue() + diff);
				}

				this.__spanValue = value;
			}

			return value;
		} else {

			return this.__spanValue;
		}
	}
	, 
	__hasChildren: false

	, 
	increaseSpanForChildren: function () {
		if (!this.__hasChildren) {
			this.__hasChildren = true;
			this.spanValue(this.spanValue() + 1);
		}

	}
	, 
	$type: new $.ig.Type('SpanSource', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ITableViewHeadersFactory', 'Object', {
	$type: new $.ig.Type('ITableViewHeadersFactory', null)
}, true);

$.ig.util.defType('TableViewHeadersFactory', 'Object', {

	_sourceAxis: null,
	sourceAxis: function (value) {
		if (arguments.length === 1) {
			this._sourceAxis = value;
			return value;
		} else {
			return this._sourceAxis;
		}
	}

	, 
	_originalAxis: null,
	originalAxis: function (value) {
		if (arguments.length === 1) {
			this._originalAxis = value;
			return value;
		} else {
			return this._originalAxis;
		}
	}

	, 
	_layoutOrientation: null,
	layoutOrientation: function (value) {
		if (arguments.length === 1) {
			this._layoutOrientation = value;
			return value;
		} else {
			return this._layoutOrientation;
		}
	}

	, 
	_isParentInFront: false,
	isParentInFront: function (value) {
		if (arguments.length === 1) {
			this._isParentInFront = value;
			return value;
		} else {
			return this._isParentInFront;
		}
	}

	, 
	_orderedTuples: null,
	orderedTuples: function (value) {
		if (arguments.length === 1) {
			this._orderedTuples = value;
			return value;
		} else {
			return this._orderedTuples;
		}
	}
	, 
	init: function (sourceAxis, originalAxis, layoutOrientation, isParentInFront, orderedTuples) {



		$.ig.Object.prototype.init.call(this);
			this.sourceAxis(sourceAxis);
			this.originalAxis(originalAxis);
			this.layoutOrientation(layoutOrientation);
			this.isParentInFront(isParentInFront);
			this.orderedTuples(orderedTuples);
	}

	, 
	createHeaderCells: function () {
		var $self = this;
		if ($self.sourceAxis().positionResolver().hasUnregisterdPositions()) {
			$self.sourceAxis().positionResolver().completeRegisterPositions();
		}

		var rootPositionInfo = $self.sourceAxis().positionResolver().rootPositionInfo();
		var headerCellCollections = new $.ig.List$1($.ig.IList$1.prototype.$type.specialize($.ig.TableViewHeaderCellSource.prototype.$type), 0);
		for (var i = 0; i < rootPositionInfo.positionSize(); i++) {
			headerCellCollections.add(new $.ig.List$1($.ig.TableViewHeaderCellSource.prototype.$type, 0));
		}

		$.ig.TableViewHeadersFactory.prototype.createHeaderCells2(rootPositionInfo, rootPositionInfo.positionItemDepthMin(), headerCellCollections, $self.isParentInFront(), $self.orderedTuples());
		var result = new $.ig.ArrayListCollection$1($.ig.OlapTableViewHeaderCell.prototype.$type);
		var levelDepthOffset = 0;
		for (var i1 = 0; i1 < rootPositionInfo.positionSize(); i1++) {
			var headerCellsCollection = headerCellCollections.item(i1);
			var directionIndex = 0;
			var maxLevelDepth = 0;
			var en = headerCellsCollection.getEnumerator();
			while (en.moveNext()) {
				var cellSource = en.current();
				var columnIndex;
				var columnSpan;
				var rowIndex;
				var rowSpan;
				if ($self.layoutOrientation() == $.ig.HeaderCellsLayoutOrientation.prototype.horizontal) {
					columnIndex = directionIndex;
					columnSpan = cellSource.headerSpanSource().spanValue();
					rowIndex = cellSource.positionItemInfo().positionItemDepth() + levelDepthOffset;
					rowSpan = cellSource.levelSpanSource().spanValue();

				} else {
					rowIndex = directionIndex;
					rowSpan = cellSource.headerSpanSource().spanValue();
					columnIndex = cellSource.positionItemInfo().positionItemDepth() + levelDepthOffset;
					columnSpan = cellSource.levelSpanSource().spanValue();
				}

				var position = $self.sourceAxis().tuples().__inner[cellSource.positionItemInfo().positionIndex()];
				var positionItem = position.item(cellSource.positionItemInfo().positionItemIndex());
				var tuple = $self.sourceAxis().tuples().__inner[cellSource.tupleIndex()];
				if ($self.originalAxis().positionResolver().hasUnregisterdPositions()) {
					$self.originalAxis().positionResolver().completeRegisterPositions();
				}

				var originalIndex = $self.originalAxis().positionResolver().getPositionIndex(tuple);
				var headerCell = (function () { var $ret = new $.ig.OlapTableViewHeaderCell();
				$ret.axisName($self.sourceAxis().name());
				$ret.hierarchyNumber(cellSource.positionItemInfo().positionItemIndex());
				$ret.levelNumber(cellSource.positionItemInfo().positionItemDepth());
				$ret.caption(positionItem.caption());
				$ret.columnIndex(columnIndex);
				$ret.columnSpan(columnSpan);
				$ret.isExpanded(cellSource.isExpanded());
				$ret.isExpandable(cellSource.isExpandable());
				$ret.tupleIndex(originalIndex);
				$ret.memberIndex(cellSource.positionItemInfo().positionItemIndex());
				$ret.rowIndex(rowIndex);
				$ret.rowSpan(rowSpan); return $ret;}());
				if (!cellSource.isHeaderCellGroup()) {
					directionIndex = directionIndex + cellSource.headerSpanSource().spanValue();
				}

				maxLevelDepth = Math.max(maxLevelDepth, cellSource.positionItemInfo().positionItemDepth());
				result.add(headerCell);
			}

			levelDepthOffset += maxLevelDepth + 1;
		}

		return result;
	}

	, 
	createHeaderCells2: function (hostPositionItemInfo, topMostPositionItemDetph, headerCellsCollections, isParentInFront, orderedTuples) {
		var $self = this;
		var spanManager = new $.ig.LevelSpanManager(hostPositionItemInfo.positionSize());
		var en = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == topMostPositionItemDetph; }).getEnumerator();
		while (en.moveNext()) {
			var positionItemInfo = en.current();
			var tableViewHeaderCell;
			var headerCellSpan;
			(function () { var $ret = $.ig.TableViewHeadersFactory.prototype.createHeaderCells1(hostPositionItemInfo, positionItemInfo, headerCellsCollections, spanManager, isParentInFront, orderedTuples, tableViewHeaderCell, headerCellSpan); tableViewHeaderCell = $ret.headerCellSource; headerCellSpan = $ret.totalSpan; return $ret.ret; }());
		}

	}

	, 
	createHostedHeaderCells: function (positionItemInfo, headerCellCollections, spanManager, isParentInFront, headerCellSource, orderedTuples) {
		var $self = this;
		var hostedPosionsInfo = positionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == positionItemInfo.positionItemDepthMin(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (hostedPosionsInfo.count() > 0) {
			var en = hostedPosionsInfo.getEnumerator();
			while (en.moveNext()) {
				var hostedItemInfo = en.current();
				var hostedHeaderCell;
				var hostedCellSpan;
				(function () { var $ret = $.ig.TableViewHeadersFactory.prototype.createHeaderCells1(positionItemInfo, hostedItemInfo, headerCellCollections, spanManager, isParentInFront, orderedTuples, hostedHeaderCell, hostedCellSpan); hostedHeaderCell = $ret.headerCellSource; hostedCellSpan = $ret.totalSpan; return $ret.ret; }());
				headerCellSource.headerSpanSource().spanValue(headerCellSource.headerSpanSource().spanValue() + hostedCellSpan);
				if (hostedHeaderCell.isHeaderCellGroup()) {
					headerCellSource.headerSpanSource().spanValue(headerCellSource.headerSpanSource().spanValue() + 1);
				}

			}

			headerCellSource.headerSpanSource().spanValue(headerCellSource.headerSpanSource().spanValue() - 1);

		} else {
			orderedTuples.add(positionItemInfo.positionIndex());
		}

		headerCellSource.tupleIndex(positionItemInfo.positionIndex());
	}

	, 
	createHeaderCells1: function (hostPositionItemInfo, positionItemInfo, headerCellCollections, spanManager, isParentInFront, orderedTuples, headerCellSource, totalSpan) {
		var $self = this;
		var headerCellsTargetCollection = headerCellCollections.item(positionItemInfo.positionItemIndex());
		var levelSpanSource = spanManager.getSpanSource(positionItemInfo.positionItemIndex(), positionItemInfo.positionItemDepth());
		var grandTotalHeaderCellSource = (function () { var $ret = new $.ig.TableViewHeaderCellSource();
		$ret.levelSpanSource(levelSpanSource);
		$ret.positionItemInfo(positionItemInfo);
		$ret.isExpandable(positionItemInfo.isExpandable()); return $ret;}());
		headerCellSource = grandTotalHeaderCellSource;
		if (isParentInFront) {
			headerCellsTargetCollection.add(grandTotalHeaderCellSource);
			$.ig.TableViewHeadersFactory.prototype.createHostedHeaderCells(positionItemInfo, headerCellCollections, spanManager, true, grandTotalHeaderCellSource, orderedTuples);
		}

		var childrenPosionInfo = null;
		if (positionItemInfo.isExpanded()) {
			childrenPosionInfo = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.parentKey() == positionItemInfo.key(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		}

		if (childrenPosionInfo != null && childrenPosionInfo.count() > 0) {
			var headerGroupCellSource = (function () { var $ret = new $.ig.TableViewHeaderCellSource();
			$ret.isHeaderCellGroup(true);
			$ret.positionItemInfo(positionItemInfo);
			$ret.isExpandable(positionItemInfo.isExpandable()); return $ret;}());
			headerCellsTargetCollection.add(headerGroupCellSource);
			var en = childrenPosionInfo.getEnumerator();
			while (en.moveNext()) {
				var childItemInfo = en.current();
				var childHeaderCell;
				var childItemSpan;
				(function () { var $ret = $.ig.TableViewHeadersFactory.prototype.createHeaderCells1(hostPositionItemInfo, childItemInfo, headerCellCollections, spanManager, isParentInFront, orderedTuples, childHeaderCell, childItemSpan); childHeaderCell = $ret.headerCellSource; childItemSpan = $ret.totalSpan; return $ret.ret; }());
				headerGroupCellSource.headerSpanSource().spanValue(headerGroupCellSource.headerSpanSource().spanValue() + childItemSpan);
				if (childHeaderCell.isHeaderCellGroup()) {
					headerGroupCellSource.headerSpanSource().spanValue(headerGroupCellSource.headerSpanSource().spanValue() + 1);
				}

			}

			headerGroupCellSource.headerSpanSource().spanValue(headerGroupCellSource.headerSpanSource().spanValue() - 1);
			grandTotalHeaderCellSource.isExpanded(true);
			grandTotalHeaderCellSource.isExpandable(false);
			headerGroupCellSource.isExpanded(true);
			grandTotalHeaderCellSource.headerCellGroup(headerGroupCellSource);
			if (!isParentInFront) {
				headerCellsTargetCollection.add(grandTotalHeaderCellSource);
				$.ig.TableViewHeadersFactory.prototype.createHostedHeaderCells(positionItemInfo, headerCellCollections, spanManager, false, grandTotalHeaderCellSource, orderedTuples);
			}

			headerGroupCellSource.tupleIndex(grandTotalHeaderCellSource.tupleIndex());
			headerCellSource = headerGroupCellSource;
			totalSpan = grandTotalHeaderCellSource.headerSpanSource().spanValue() + headerGroupCellSource.headerSpanSource().spanValue() - 1;

		} else {
			if (positionItemInfo.isExpanded()) {
				grandTotalHeaderCellSource.isExpandable(false);
			}

			if (!isParentInFront) {
				headerCellsTargetCollection.add(grandTotalHeaderCellSource);
				$.ig.TableViewHeadersFactory.prototype.createHostedHeaderCells(positionItemInfo, headerCellCollections, spanManager, false, grandTotalHeaderCellSource, orderedTuples);
			}

			totalSpan = grandTotalHeaderCellSource.headerSpanSource().spanValue();
		}

		return {
			headerCellSource: headerCellSource, 
			totalSpan: totalSpan
		};
	}
	, 
	$type: new $.ig.Type('TableViewHeadersFactory', $.ig.Object.prototype.$type, [$.ig.ITableViewHeadersFactory.prototype.$type])
}, true);

$.ig.util.defType('TableCompactViewHeadersFactory', 'Object', {

	_sourceAxis: null,
	sourceAxis: function (value) {
		if (arguments.length === 1) {
			this._sourceAxis = value;
			return value;
		} else {
			return this._sourceAxis;
		}
	}

	, 
	_originalAxis: null,
	originalAxis: function (value) {
		if (arguments.length === 1) {
			this._originalAxis = value;
			return value;
		} else {
			return this._originalAxis;
		}
	}

	, 
	_layoutOrientation: null,
	layoutOrientation: function (value) {
		if (arguments.length === 1) {
			this._layoutOrientation = value;
			return value;
		} else {
			return this._layoutOrientation;
		}
	}

	, 
	_isParentInFront: false,
	isParentInFront: function (value) {
		if (arguments.length === 1) {
			this._isParentInFront = value;
			return value;
		} else {
			return this._isParentInFront;
		}
	}

	, 
	_orderedTuples: null,
	orderedTuples: function (value) {
		if (arguments.length === 1) {
			this._orderedTuples = value;
			return value;
		} else {
			return this._orderedTuples;
		}
	}
	, 
	init: function (sourceAxis, originalAxis, layoutOrientation, isParentInFront, orderedTuples) {



		$.ig.Object.prototype.init.call(this);
			this.sourceAxis(sourceAxis);
			this.originalAxis(originalAxis);
			this.layoutOrientation(layoutOrientation);
			this.isParentInFront(isParentInFront);
			this.orderedTuples(orderedTuples);
	}

	, 
	createHeaderCells: function () {
		var $self = this;
		if ($self.sourceAxis().positionResolver().hasUnregisterdPositions()) {
			$self.sourceAxis().positionResolver().completeRegisterPositions();
		}

		var rootPositionInfo = $self.sourceAxis().positionResolver().rootPositionInfo();
		var headerCellCollections = new $.ig.List$1($.ig.IList$1.prototype.$type.specialize($.ig.TableViewHeaderCellSource.prototype.$type), 0);
		for (var i = 0; i < rootPositionInfo.positionSize(); i++) {
			headerCellCollections.add(new $.ig.List$1($.ig.TableViewHeaderCellSource.prototype.$type, 0));
		}

		$.ig.TableCompactViewHeadersFactory.prototype.createHeaderCells2(rootPositionInfo, rootPositionInfo.positionItemDepthMin(), headerCellCollections, $self.isParentInFront(), $self.orderedTuples());
		var result = new $.ig.ArrayListCollection$1($.ig.OlapTableViewHeaderCell.prototype.$type);
		var levelDepthOffset = 0;
		for (var i1 = 0; i1 < rootPositionInfo.positionSize(); i1++) {
			var headerCellsCollection = headerCellCollections.item(i1);
			var directionIndex = 0;
			var maxLevelDepth = 0;
			var en = headerCellsCollection.getEnumerator();
			while (en.moveNext()) {
				var cellSource = en.current();
				var columnIndex;
				var columnSpan;
				var rowIndex;
				var rowSpan;
				if ($self.layoutOrientation() == $.ig.HeaderCellsLayoutOrientation.prototype.horizontal) {
					columnIndex = directionIndex;
					columnSpan = cellSource.headerSpanSource().spanValue();
					rowIndex = levelDepthOffset;
					rowSpan = 1;

				} else {
					rowIndex = directionIndex;
					rowSpan = cellSource.headerSpanSource().spanValue();
					columnIndex = levelDepthOffset;
					columnSpan = 1;
				}

				var position = $self.sourceAxis().tuples().__inner[cellSource.positionItemInfo().positionIndex()];
				var positionItem = position.item(cellSource.positionItemInfo().positionItemIndex());
				var tuple = $self.sourceAxis().tuples().__inner[cellSource.tupleIndex()];
				if ($self.originalAxis().positionResolver().hasUnregisterdPositions()) {
					$self.originalAxis().positionResolver().completeRegisterPositions();
				}

				var originalIndex = $self.originalAxis().positionResolver().getPositionIndex(tuple);
				var headerCell = (function () { var $ret = new $.ig.OlapTableViewHeaderCell();
				$ret.axisName($self.sourceAxis().name());
				$ret.hierarchyNumber(cellSource.positionItemInfo().positionItemIndex());
				$ret.levelNumber(cellSource.positionItemInfo().positionItemDepth());
				$ret.caption(positionItem.caption());
				$ret.columnIndex(columnIndex);
				$ret.columnSpan(columnSpan);
				$ret.isExpanded(cellSource.isExpanded());
				$ret.isExpandable(cellSource.isExpandable());
				$ret.tupleIndex(originalIndex);
				$ret.memberIndex(cellSource.positionItemInfo().positionItemIndex());
				$ret.rowIndex(rowIndex);
				$ret.rowSpan(rowSpan); return $ret;}());
				if (!cellSource.isHeaderCellGroup()) {
					directionIndex = directionIndex + cellSource.headerSpanSource().spanValue();
				}

				result.add(headerCell);
			}

			levelDepthOffset += maxLevelDepth + 1;
		}

		return result;
	}

	, 
	createHeaderCells2: function (hostPositionItemInfo, topMostPositionItemDetph, headerCellsCollections, isParentInFront, orderedTuples) {
		var $self = this;
		var spanManager = new $.ig.LevelSpanManager(hostPositionItemInfo.positionSize());
		var en = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == topMostPositionItemDetph; }).getEnumerator();
		while (en.moveNext()) {
			var positionItemInfo = en.current();
			var tableViewHeaderCell;
			var headerCellSpan;
			(function () { var $ret = $.ig.TableCompactViewHeadersFactory.prototype.createHeaderCells1(hostPositionItemInfo, positionItemInfo, headerCellsCollections, spanManager, isParentInFront, orderedTuples, tableViewHeaderCell, headerCellSpan); tableViewHeaderCell = $ret.headerCellSource; headerCellSpan = $ret.totalSpan; return $ret.ret; }());
		}

	}

	, 
	createHostedHeaderCells: function (positionItemInfo, headerCellCollections, spanManager, isParentInFront, headerCellSource, orderedTuples) {
		var $self = this;
		var hostedPosionsInfo = positionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == positionItemInfo.positionItemDepthMin(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (hostedPosionsInfo.count() > 0) {
			var en = hostedPosionsInfo.getEnumerator();
			while (en.moveNext()) {
				var hostedItemInfo = en.current();
				var hostedHeaderCell;
				var hostedCellSpan;
				(function () { var $ret = $.ig.TableCompactViewHeadersFactory.prototype.createHeaderCells1(positionItemInfo, hostedItemInfo, headerCellCollections, spanManager, isParentInFront, orderedTuples, hostedHeaderCell, hostedCellSpan); hostedHeaderCell = $ret.headerCellSource; hostedCellSpan = $ret.totalSpan; return $ret.ret; }());
				headerCellSource.headerSpanSource().spanValue(headerCellSource.headerSpanSource().spanValue() + hostedCellSpan);
				if (hostedHeaderCell.headerCellGroup() != null) {
					headerCellSource.headerSpanSource().spanValue(headerCellSource.headerSpanSource().spanValue() + 1);
				}

			}

			headerCellSource.headerSpanSource().spanValue(headerCellSource.headerSpanSource().spanValue() - 1);

		} else {
			orderedTuples.add(positionItemInfo.positionIndex());
		}

		headerCellSource.tupleIndex(positionItemInfo.positionIndex());
	}

	, 
	createHeaderCells1: function (hostPositionItemInfo, positionItemInfo, headerCellCollections, spanManager, isParentInFront, orderedTuples, headerCellSource, totalSpan) {
		var $self = this;
		var headerCellsTargetCollection = headerCellCollections.item(positionItemInfo.positionItemIndex());
		var levelSpanSource = spanManager.getSpanSource(positionItemInfo.positionItemIndex(), positionItemInfo.positionItemDepth());
		var grandTotalHeaderCellSource = (function () { var $ret = new $.ig.TableViewHeaderCellSource();
		$ret.levelSpanSource(levelSpanSource);
		$ret.positionItemInfo(positionItemInfo);
		$ret.isExpandable(positionItemInfo.isExpandable()); return $ret;}());
		headerCellSource = grandTotalHeaderCellSource;
		if (isParentInFront) {
			headerCellsTargetCollection.add(grandTotalHeaderCellSource);
			$.ig.TableCompactViewHeadersFactory.prototype.createHostedHeaderCells(positionItemInfo, headerCellCollections, spanManager, true, grandTotalHeaderCellSource, orderedTuples);
		}

		var childrenPosionInfo = null;
		if (positionItemInfo.isExpanded()) {
			childrenPosionInfo = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.parentKey() == positionItemInfo.key(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		}

		if (childrenPosionInfo != null && childrenPosionInfo.count() > 0) {
			var headerGroupCellSource = (function () { var $ret = new $.ig.TableViewHeaderCellSource();
			$ret.isHeaderCellGroup(true);
			$ret.positionItemInfo(positionItemInfo);
			$ret.isExpandable(positionItemInfo.isExpandable()); return $ret;}());
			var en = childrenPosionInfo.getEnumerator();
			while (en.moveNext()) {
				var childItemInfo = en.current();
				var childHeaderCell;
				var childItemSpan;
				(function () { var $ret = $.ig.TableCompactViewHeadersFactory.prototype.createHeaderCells1(hostPositionItemInfo, childItemInfo, headerCellCollections, spanManager, isParentInFront, orderedTuples, childHeaderCell, childItemSpan); childHeaderCell = $ret.headerCellSource; childItemSpan = $ret.totalSpan; return $ret.ret; }());
				headerGroupCellSource.headerSpanSource().spanValue(headerGroupCellSource.headerSpanSource().spanValue() + childItemSpan);
				if (childHeaderCell.headerCellGroup() != null) {
					headerGroupCellSource.headerSpanSource().spanValue(headerGroupCellSource.headerSpanSource().spanValue() + 1);
				}

			}

			headerGroupCellSource.headerSpanSource().spanValue(headerGroupCellSource.headerSpanSource().spanValue() - 1);
			grandTotalHeaderCellSource.isExpanded(true);
			grandTotalHeaderCellSource.isExpandable(true);
			grandTotalHeaderCellSource.headerCellGroup(headerGroupCellSource);
			if (!isParentInFront) {
				headerCellsTargetCollection.add(grandTotalHeaderCellSource);
				$.ig.TableCompactViewHeadersFactory.prototype.createHostedHeaderCells(positionItemInfo, headerCellCollections, spanManager, false, grandTotalHeaderCellSource, orderedTuples);
			}

			headerGroupCellSource.tupleIndex(grandTotalHeaderCellSource.tupleIndex());
			totalSpan = grandTotalHeaderCellSource.headerSpanSource().spanValue() + headerGroupCellSource.headerSpanSource().spanValue() - 1;

		} else {
			if (positionItemInfo.isExpanded()) {
				grandTotalHeaderCellSource.isExpandable(false);
			}

			if (!isParentInFront) {
				headerCellsTargetCollection.add(grandTotalHeaderCellSource);
				$.ig.TableCompactViewHeadersFactory.prototype.createHostedHeaderCells(positionItemInfo, headerCellCollections, spanManager, false, grandTotalHeaderCellSource, orderedTuples);
			}

			totalSpan = grandTotalHeaderCellSource.headerSpanSource().spanValue();
		}

		return {
			headerCellSource: headerCellSource, 
			totalSpan: totalSpan
		};
	}
	, 
	$type: new $.ig.Type('TableCompactViewHeadersFactory', $.ig.Object.prototype.$type, [$.ig.ITableViewHeadersFactory.prototype.$type])
}, true);

$.ig.util.defType('TableViewHeaderCellSource', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.headerSpanSource(new $.ig.SpanSource());
			this.levelSpanSource(new $.ig.SpanSource());
	}

	, 
	_isHeaderCellGroup: false,
	isHeaderCellGroup: function (value) {
		if (arguments.length === 1) {
			this._isHeaderCellGroup = value;
			return value;
		} else {
			return this._isHeaderCellGroup;
		}
	}

	, 
	_rowIndex: 0,
	rowIndex: function (value) {
		if (arguments.length === 1) {
			this._rowIndex = value;
			return value;
		} else {
			return this._rowIndex;
		}
	}

	, 
	_columnIndex: 0,
	columnIndex: function (value) {
		if (arguments.length === 1) {
			this._columnIndex = value;
			return value;
		} else {
			return this._columnIndex;
		}
	}

	, 
	_levelSpanSource: null,
	levelSpanSource: function (value) {
		if (arguments.length === 1) {
			this._levelSpanSource = value;
			return value;
		} else {
			return this._levelSpanSource;
		}
	}

	, 
	_headerSpanSource: null,
	headerSpanSource: function (value) {
		if (arguments.length === 1) {
			this._headerSpanSource = value;
			return value;
		} else {
			return this._headerSpanSource;
		}
	}

	, 
	_headerCellGroup: null,
	headerCellGroup: function (value) {
		if (arguments.length === 1) {
			this._headerCellGroup = value;
			return value;
		} else {
			return this._headerCellGroup;
		}
	}

	, 
	_positionItemInfo: null,
	positionItemInfo: function (value) {
		if (arguments.length === 1) {
			this._positionItemInfo = value;
			return value;
		} else {
			return this._positionItemInfo;
		}
	}

	, 
	_tupleIndex: 0,
	tupleIndex: function (value) {
		if (arguments.length === 1) {
			this._tupleIndex = value;
			return value;
		} else {
			return this._tupleIndex;
		}
	}

	, 
	_memberIndex: 0,
	memberIndex: function (value) {
		if (arguments.length === 1) {
			this._memberIndex = value;
			return value;
		} else {
			return this._memberIndex;
		}
	}

	, 
	_isExpanded: false,
	isExpanded: function (value) {
		if (arguments.length === 1) {
			this._isExpanded = value;
			return value;
		} else {
			return this._isExpanded;
		}
	}

	, 
	_isExpandable: false,
	isExpandable: function (value) {
		if (arguments.length === 1) {
			this._isExpandable = value;
			return value;
		} else {
			return this._isExpandable;
		}
	}
	, 
	$type: new $.ig.Type('TableViewHeaderCellSource', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TableViewImpl', 'Object', {
	init: function (result, hasColumns, hasRows, viewSettings) {


		var $self = this;

		$.ig.Object.prototype.init.call(this);
			if (result == null) {
				throw new $.ig.ArgumentNullException("result");
			}

			this.result(result);
			this.originalResult(result);
			if (viewSettings == null) {
				this.viewSettings(new $.ig.TableViewSettings());

			} else {
				this.viewSettings(viewSettings);
			}

			this.hasColumns(hasColumns);
			this.hasRows(hasRows);
			this.columnSortDirections(new $.ig.ArrayListCollection$1($.ig.TupleSortDirection.prototype.$type));
			(this.columnSortDirections()).collectionChanged = $.ig.Delegate.prototype.combine((this.columnSortDirections()).collectionChanged, function (sender, e) {
				$self.isModified(true);
			});
			this.levelSortDirections(new $.ig.ArrayListCollection$1($.ig.LevelSortDirection.prototype.$type));
			(this.levelSortDirections()).collectionChanged = $.ig.Delegate.prototype.combine((this.levelSortDirections()).collectionChanged, function (sender, e) {
				$self.isModified(true);
			});
			this.appliedColumnSortDirections(new $.ig.List$1($.ig.TupleSortDirection.prototype.$type, 0));
			this.appliedLevelSortDirections(new $.ig.List$1($.ig.LevelSortDirection.prototype.$type, 0));
			this.appliedSortDirectionsMap(new $.ig.Dictionary$2(String, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type)), 0));
	}

	, 
	_viewSettings: null,
	viewSettings: function (value) {
		if (arguments.length === 1) {
			this._viewSettings = value;
			return value;
		} else {
			return this._viewSettings;
		}
	}

	, 
	_result: null,
	result: function (value) {
		if (arguments.length === 1) {
			this._result = value;
			return value;
		} else {
			return this._result;
		}
	}

	, 
	_originalResult: null,
	originalResult: function (value) {
		if (arguments.length === 1) {
			this._originalResult = value;
			return value;
		} else {
			return this._originalResult;
		}
	}

	, 
	_hasRows: false,
	hasRows: function (value) {
		if (arguments.length === 1) {
			this._hasRows = value;
			return value;
		} else {
			return this._hasRows;
		}
	}

	, 
	_hasColumns: false,
	hasColumns: function (value) {
		if (arguments.length === 1) {
			this._hasColumns = value;
			return value;
		} else {
			return this._hasColumns;
		}
	}

	, 
	_rowHeadersFactory: null,
	rowHeadersFactory: function (value) {
		if (arguments.length === 1) {
			this._rowHeadersFactory = value;
			return value;
		} else {
			return this._rowHeadersFactory;
		}
	}

	, 
	_columnHeadersFactory: null,
	columnHeadersFactory: function (value) {
		if (arguments.length === 1) {
			this._columnHeadersFactory = value;
			return value;
		} else {
			return this._columnHeadersFactory;
		}
	}

	, 
	_isInitialized: false,
	isInitialized: function (value) {
		if (arguments.length === 1) {
			this._isInitialized = value;
			return value;
		} else {
			return this._isInitialized;
		}
	}

	, 
	_isModified: false,
	isModified: function (value) {
		if (arguments.length === 1) {
			this._isModified = value;
			return value;
		} else {
			return this._isModified;
		}
	}
	, 
	__rowHeaders: null
	, 
	__columnHeaders: null
	, 
	__resultCells: null

	, 
	rowHeaders: function (value) {
		if (arguments.length === 1) {

			this.__rowHeaders = value;
			return value;
		} else {

			if (!this.isInitialized() || this.isModified()) {
				this.initialize();
			}

			return this.__rowHeaders;
		}
	}

	, 
	columnHeaders: function (value) {
		if (arguments.length === 1) {

			this.__columnHeaders = value;
			return value;
		} else {

			if (!this.isInitialized() || this.isModified()) {
				this.initialize();
			}

			return this.__columnHeaders;
		}
	}

	, 
	resultCells: function (value) {
		if (arguments.length === 1) {

			this.__resultCells = value;
			return value;
		} else {

			if (!this.isInitialized() || this.isModified()) {
				this.initialize();
			}

			return this.__resultCells;
		}
	}

	, 
	_columnSortDirections: null,
	columnSortDirections: function (value) {
		if (arguments.length === 1) {
			this._columnSortDirections = value;
			return value;
		} else {
			return this._columnSortDirections;
		}
	}

	, 
	_levelSortDirections: null,
	levelSortDirections: function (value) {
		if (arguments.length === 1) {
			this._levelSortDirections = value;
			return value;
		} else {
			return this._levelSortDirections;
		}
	}

	, 
	_appliedColumnSortDirections: null,
	appliedColumnSortDirections: function (value) {
		if (arguments.length === 1) {
			this._appliedColumnSortDirections = value;
			return value;
		} else {
			return this._appliedColumnSortDirections;
		}
	}

	, 
	_appliedLevelSortDirections: null,
	appliedLevelSortDirections: function (value) {
		if (arguments.length === 1) {
			this._appliedLevelSortDirections = value;
			return value;
		} else {
			return this._appliedLevelSortDirections;
		}
	}

	, 
	_appliedSortDirectionsMap: null,
	appliedSortDirectionsMap: function (value) {
		if (arguments.length === 1) {
			this._appliedSortDirectionsMap = value;
			return value;
		} else {
			return this._appliedSortDirectionsMap;
		}
	}

	, 
	initialize: function () {
		var $self = this;
		$self.rowHeadersFactory(null);
		$self.columnHeadersFactory(null);
		$self.rowHeaders(null);
		$self.columnHeaders(null);
		$self.resultCells(null);
		$self.result($self.originalResult());
		if ($self.result().isEmpty()) {
			$self.isModified(false);
			$self.isInitialized(true);
			return;
		}

		if ($self.levelSortDirections().count() > 0) {
			var resultHeaderSorter = new $.ig.ResultHeaderSorter($self.result(), $self.hasRows(), $self.hasColumns(), $self.levelSortDirections());
			$self.result(resultHeaderSorter.sort());
			$self.appliedLevelSortDirections(resultHeaderSorter.appliedSortDirections());
			$self.appliedSortDirectionsMap(resultHeaderSorter.appliedSortDirectionsMap());

		} else {
			$self.appliedLevelSortDirections(new $.ig.List$1($.ig.LevelSortDirection.prototype.$type, 0));
			$self.appliedSortDirectionsMap(new $.ig.Dictionary$2(String, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type)), 0));
		}

		if ($self.hasRows() && $self.columnSortDirections().count() > 0) {
			if ($self.appliedLevelSortDirections().count() > 0) {
				if ($self.originalResult().axes().item(0).positionResolver().hasUnregisterdPositions()) {
					$self.originalResult().axes().item(0).positionResolver().completeRegisterPositions();
				}

				if ($self.result().axes().item(0).positionResolver().hasUnregisterdPositions()) {
					$self.result().axes().item(0).positionResolver().completeRegisterPositions();
				}

				var sortDirections = new $.ig.List$1($.ig.TupleSortDirection.prototype.$type, 2, $self.columnSortDirections().count());
				var tupleIndicesMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Number.prototype.$type, 1, $self.appliedColumnSortDirections().count());
				var en = $self.columnSortDirections().getEnumerator();
				while (en.moveNext()) {
					var sd = en.current();
					var tuple = $self.originalResult().axes().item(0).tuples().__inner[sd.tupleIndex()];
					var newTupleIndex = $self.result().axes().item(0).positionResolver().getPositionIndex(tuple);
					var newTupleSortDirection = new $.ig.TupleSortDirection();
					newTupleSortDirection.sortDirection(sd.sortDirection());
					newTupleSortDirection.tupleIndex(newTupleIndex);
					newTupleSortDirection.comparer(sd.comparer());
					sortDirections.add(newTupleSortDirection);
					tupleIndicesMap.item(newTupleIndex, sd.tupleIndex());
				}

				var resultColumnValueSorter = new $.ig.ResultColumnValueSorter($self.result(), $self.hasRows(), $self.hasColumns(), sortDirections);
				$self.result(resultColumnValueSorter.sort());
				var en1 = resultColumnValueSorter.appliedSortDirections().getEnumerator();
				while (en1.moveNext()) {
					var sd1 = en1.current();
					sd1.tupleIndex(tupleIndicesMap.item(sd1.tupleIndex()));
				}

				$self.appliedColumnSortDirections(resultColumnValueSorter.appliedSortDirections());

			} else {
				var resultColumnValueSorter1 = new $.ig.ResultColumnValueSorter($self.result(), $self.hasRows(), $self.hasColumns(), $self.columnSortDirections());
				$self.result(resultColumnValueSorter1.sort());
				$self.appliedColumnSortDirections(resultColumnValueSorter1.appliedSortDirections());
			}


		} else {
			$self.appliedColumnSortDirections(new $.ig.List$1($.ig.TupleSortDirection.prototype.$type, 0));
		}

		var axisIndex = 0;
		var columnIndexesMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Number.prototype.$type, 0);
		var columnsCount = 1;
		if ($self.hasColumns()) {
			var columnAxis = $self.result().axes().item(axisIndex);
			var originalColumnAxis = $self.originalResult().axes().item(axisIndex);
			var orderedColumnTuples = $self.initializeColumnHeaders(columnAxis, originalColumnAxis);
			for (var i = 0; i < orderedColumnTuples.count(); i++) {
				var index = orderedColumnTuples.item(i);
				columnIndexesMap.add(index, i);
			}

			axisIndex++;
			columnsCount = columnAxis.tuples().count();
		}

		var rowIndexesMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Number.prototype.$type, 0);
		if ($self.hasRows()) {
			var rowAxis = $self.result().axes().item(axisIndex);
			var originalRowAxis = $self.originalResult().axes().item(axisIndex);
			var orderedRowTuples = $self.initializeRowHeaders(rowAxis, originalRowAxis);
			for (var i1 = 0; i1 < orderedRowTuples.count(); i1++) {
				var index1 = orderedRowTuples.item(i1);
				rowIndexesMap.add(index1, i1);
			}

		}

		var resultCells = new $.ig.ArrayListCollection$1($.ig.OlapTableViewResultCell.prototype.$type);
		for (var i2 = 0; i2 < $self.result().cells().count(); i2++) {
			var cell = $self.result().cells().item(i2);
			var cellValue;
			(function () { var $ret = cell.properties().tryGetValue("Value", cellValue); cellValue = $ret.value; return $ret.ret; }());
			var formatedValue;
			(function () { var $ret = cell.properties().tryGetValue("FmtValue", formatedValue); formatedValue = $ret.value; return $ret.ret; }());
			var cellOrdinal = cell.cellOrdinal();
			if ($self.hasColumns()) {
				var columnIndex = cellOrdinal % columnsCount;
				var newIndex = columnIndexesMap.item(columnIndex);
				if (columnIndex != newIndex) {
					var rowIndex = $.ig.intDivide(cellOrdinal, columnsCount);
					cellOrdinal = rowIndex * columnsCount + newIndex;
				}

			}

			if ($self.hasRows()) {
				var rowIndex1 = $.ig.intDivide(cellOrdinal, columnsCount);
				var newIndex1 = rowIndexesMap.item(rowIndex1);
				if (rowIndex1 != newIndex1) {
					var columnIndex1 = cellOrdinal % columnsCount;
					cellOrdinal = newIndex1 * columnsCount + columnIndex1;
				}

			}

			resultCells.add((function () { var $ret = new $.ig.OlapTableViewResultCell();
			$ret.value(cellValue);
			$ret.formattedValue(formatedValue);
			$ret.cellOrdinal(cellOrdinal);
			$ret.resultCellIndex(i2); return $ret;}()));
			$self.resultCells(resultCells);
		}

		$self.isModified(false);
		$self.isInitialized(true);
	}

	, 
	initializeColumnHeaders: function (columnAxis, originalColumnAxis) {
		var orderedTuples = new $.ig.List$1($.ig.Number.prototype.$type, 0);
		if (this.viewSettings().compactColumnHeaders()) {
			this.columnHeadersFactory(new $.ig.TableCompactViewHeadersFactory(columnAxis, originalColumnAxis, $.ig.HeaderCellsLayoutOrientation.prototype.horizontal, this.viewSettings().isParentInFrontForColumns(), orderedTuples));

		} else {
			this.columnHeadersFactory(new $.ig.TableViewHeadersFactory(columnAxis, originalColumnAxis, $.ig.HeaderCellsLayoutOrientation.prototype.horizontal, this.viewSettings().isParentInFrontForColumns(), orderedTuples));
		}

		this.columnHeaders(this.columnHeadersFactory().createHeaderCells());
		return orderedTuples;
	}

	, 
	initializeRowHeaders: function (rowAxis, originalRowAxis) {
		var orderedTuples = new $.ig.List$1($.ig.Number.prototype.$type, 0);
		if (this.viewSettings().compactRowHeaders()) {
			this.rowHeadersFactory(new $.ig.TableCompactViewHeadersFactory(rowAxis, originalRowAxis, $.ig.HeaderCellsLayoutOrientation.prototype.vertical, this.viewSettings().isParentInFrontForRows(), orderedTuples));

		} else {
			this.rowHeadersFactory(new $.ig.TableViewHeadersFactory(rowAxis, originalRowAxis, $.ig.HeaderCellsLayoutOrientation.prototype.vertical, this.viewSettings().isParentInFrontForRows(), orderedTuples));
		}

		this.rowHeaders(this.rowHeadersFactory().createHeaderCells());
		return orderedTuples;
	}
	, 
	$type: new $.ig.Type('TableViewImpl', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TableViewSettings', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_isParentInFrontForColumns: false,
	isParentInFrontForColumns: function (value) {
		if (arguments.length === 1) {
			this._isParentInFrontForColumns = value;
			return value;
		} else {
			return this._isParentInFrontForColumns;
		}
	}

	, 
	_isParentInFrontForRows: false,
	isParentInFrontForRows: function (value) {
		if (arguments.length === 1) {
			this._isParentInFrontForRows = value;
			return value;
		} else {
			return this._isParentInFrontForRows;
		}
	}

	, 
	_compactRowHeaders: false,
	compactRowHeaders: function (value) {
		if (arguments.length === 1) {
			this._compactRowHeaders = value;
			return value;
		} else {
			return this._compactRowHeaders;
		}
	}

	, 
	_compactColumnHeaders: false,
	compactColumnHeaders: function (value) {
		if (arguments.length === 1) {
			this._compactColumnHeaders = value;
			return value;
		} else {
			return this._compactColumnHeaders;
		}
	}
	, 
	$type: new $.ig.Type('TableViewSettings', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapResultView', 'Object', {
	init: function (result, visibleResult, hasColumns, hasRows) {



		$.ig.Object.prototype.init.call(this);
			if (result == null) {
				throw new $.ig.ArgumentNullException("result");
			}

			this.result(result);
			this.visibleResult(visibleResult);
			this.hasColumns(hasColumns);
			this.hasRows(hasRows);
	}

	, 
	_result: null,
	result: function (value) {
		if (arguments.length === 1) {
			this._result = value;
			return value;
		} else {
			return this._result;
		}
	}

	, 
	_visibleResult: null,
	visibleResult: function (value) {
		if (arguments.length === 1) {
			this._visibleResult = value;
			return value;
		} else {
			return this._visibleResult;
		}
	}

	, 
	_hasRows: false,
	hasRows: function (value) {
		if (arguments.length === 1) {
			this._hasRows = value;
			return value;
		} else {
			return this._hasRows;
		}
	}

	, 
	_hasColumns: false,
	hasColumns: function (value) {
		if (arguments.length === 1) {
			this._hasColumns = value;
			return value;
		} else {
			return this._hasColumns;
		}
	}

	, 
	getSubResult: function (result, rowAxis, columnAxis, hasRows, hasColumns) {
		var $self = this;
		var axisIndex = 0;
		var fullColumnAxis = null;
		var fullColumnsCount = 1;
		if (hasColumns) {
			fullColumnAxis = result.axes().item(axisIndex);
			fullColumnsCount = fullColumnAxis.tuples().count();
			axisIndex++;
		}

		var fullRowAxis = null;
		var fullRowsCount = 1;
		if (hasRows) {
			fullRowAxis = result.axes().item(axisIndex);
			fullRowsCount = fullRowAxis.tuples().count();
		}

		var rowsCount = 1;
		if (rowAxis != null) {
			rowsCount = rowAxis.tuples().count();
		}

		var columnsCount = 1;
		if (columnAxis != null) {
			columnsCount = columnAxis.tuples().count();
		}

		var cells = new Array(rowsCount * columnsCount);
		if (result.cells().count() > 0) {
			var cellIndex = 0;
			var cell = result.cells().item(cellIndex);
			for (var i = 0; i < fullRowsCount; i++) {
				var cellRowIndex = $.ig.intDivide(cell.cellOrdinal(), fullColumnsCount);
				if (cellRowIndex != i) {
					continue;
				}

				var rowTupleIndex = 0;
				if (rowAxis != null && fullRowAxis != null) {
					var rowTuple = fullRowAxis.tuples().__inner[i];
					rowTupleIndex = rowAxis.positionResolver().getPositionIndex(rowTuple);
				}

				if (rowTupleIndex == -1) {
					while (cellRowIndex == i) {
						cellIndex++;
						if (cellIndex < result.cells().count()) {
							cell = result.cells().item(cellIndex);
							cellRowIndex = $.ig.intDivide(cell.cellOrdinal(), fullColumnsCount);

						} else {
							break;
						}


					}
					continue;
				}

				var cellColumnIndex = cell.cellOrdinal() % fullColumnsCount;
				for (var j = 0; j < fullColumnsCount; j++) {
					if (cellColumnIndex != j) {
						continue;
					}

					var columnTupleIndex = -1;
					if (columnAxis == null || fullColumnAxis == null) {
						columnTupleIndex = 0;

					} else {
						var columnTuple = fullColumnAxis.tuples().__inner[j];
						columnTupleIndex = columnAxis.positionResolver().getPositionIndex(columnTuple);
					}

					if (columnTupleIndex == -1) {
						cellIndex++;
						if (cellIndex < result.cells().count()) {
							cell = result.cells().item(cellIndex);
							cellRowIndex = $.ig.intDivide(cell.cellOrdinal(), fullColumnsCount);
							if (cellRowIndex > i) {
								break;
							}

							cellColumnIndex = cell.cellOrdinal() % fullColumnsCount;
						}

						continue;
					}

					var newCell = cell.clone();
					newCell.cellOrdinal(rowTupleIndex * columnsCount + columnTupleIndex);
					cells[newCell.cellOrdinal()] = newCell;
					cellIndex++;
					if (cellIndex < result.cells().count()) {
						cell = result.cells().item(cellIndex);
						cellRowIndex = $.ig.intDivide(cell.cellOrdinal(), fullColumnsCount);
						if (cellRowIndex > i) {
							break;
						}

						cellColumnIndex = cell.cellOrdinal() % fullColumnsCount;
					}

				}

			}

		}

		var resultCells = new $.ig.List$1($.ig.OlapResultCell.prototype.$type, 0);
		for (var i1 = 0; i1 < cells.length; i1++) {
			var cell1 = cells[i1];
			if (cell1 != null) {
				resultCells.add(cell1);
			}

		}

		var resultAxes = new $.ig.List$1($.ig.OlapResultAxis.prototype.$type, 0);
		if (hasColumns) {
			resultAxes.add(columnAxis);
		}

		if (hasRows) {
			resultAxes.add(rowAxis);
		}

		return (function () { var $ret = new $.ig.OlapResult();
		$ret.axes(resultAxes);
		$ret.cells(resultCells);
		$ret.isEmpty(!hasRows && !hasColumns && resultCells.count() == 0); return $ret;}());
	}

	, 
	createSubAxis: function (sourceAxis, indexes, inner) {
		var $self = this;
		var tuples = new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 0);
		if (inner) {
			for (var i = 0; i < indexes.count(); i++) {
				var index = indexes.item(i);
				tuples.add(sourceAxis.tuples().__inner[index].clone());
			}


		} else {
			var index1 = 0;
			var skipIndex = indexes.item(index1);
			for (var i1 = 0; i1 < sourceAxis.tuples().count(); i1++) {
				if (i1 == skipIndex) {
					index1++;
					if (index1 < indexes.count()) {
						skipIndex = indexes.item(index1);
					}


				} else {
					tuples.add(sourceAxis.tuples().__inner[i1].clone());
				}

			}

		}

		var subAxis = (function () { var $ret = new $.ig.OlapResultAxis(tuples, sourceAxis.tupleSize());
		$ret.name(sourceAxis.name()); return $ret;}());
		return subAxis;
	}

	, 
	expandTupleMember: function (axisName, tupleIndex, memberIndex) {
		var $self = this;
		var positionInfo = $self.getPositionItem(axisName, tupleIndex, memberIndex, $self.visibleResult());
		if (positionInfo == null) {
			return null;
		}

		if (!positionInfo.isExpandable()) {
			throw new $.ig.InvalidOperationException(1, "The position is not expandable.");
		}

		if (positionInfo.isExpanded()) {
			return $self;
		}

		var visibleAxis = $self.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var cellsAxis = $self.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var isRowAxis = (axisName == "Axis0" && !$self.hasColumns()) || (axisName == "Axis1" && $self.hasRows());
		var visibleTuple = visibleAxis.tuples().__inner[tupleIndex];
		var cachedTupleIndex = cellsAxis.positionResolver().getPositionIndex(visibleTuple);
		var childrenIndexes = $self.getChildrenPositionIndexes(axisName, cachedTupleIndex, memberIndex, $self.result());
		if (childrenIndexes.count() == 0) {
			return null;
		}

		var rowAxis = null;
		var columnAxis = null;
		if (isRowAxis) {
			rowAxis = $self.createSubAxis(cellsAxis, childrenIndexes, true);
			if ($self.hasColumns()) {
				columnAxis = $self.visibleResult().axes().item(0);
			}


		} else {
			columnAxis = $self.createSubAxis(cellsAxis, childrenIndexes, true);
			if ($self.hasRows()) {
				rowAxis = $self.visibleResult().axes().item(1);
			}

		}

		var subResult = $self.getSubResult($self.result(), rowAxis, columnAxis, $self.hasRows(), $self.hasColumns());
		var extendedResult = $self.extendResult($self.visibleResult(), subResult, cellsAxis.name());
		return new $.ig.OlapResultView($self.result(), extendedResult, $self.hasColumns(), $self.hasRows());
	}

	, 
	collapseTupleMember: function (axisName, tupleIndex, memberIndex) {
		var $self = this;
		var positionInfo = $self.getPositionItem(axisName, tupleIndex, memberIndex, $self.visibleResult());
		if (positionInfo == null) {
			return null;
		}

		if (!positionInfo.isExpandable()) {
			throw new $.ig.InvalidOperationException(1, "The position is not expandable.");
		}

		if (!positionInfo.isExpanded()) {
			return $self;
		}

		var childrenIndexes = $self.getChildrenPositionIndexes(axisName, tupleIndex, memberIndex, $self.visibleResult());
		if (childrenIndexes.count() == 0) {
			return null;
		}

		var cellsAxis = $self.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var isRowAxis = (axisName == "Axis0" && !$self.hasColumns()) || (axisName == "Axis1" && $self.hasRows());
		var rowAxis = null;
		var columnAxis = null;
		if (isRowAxis) {
			rowAxis = $self.createSubAxis(cellsAxis, childrenIndexes, false);
			if ($self.hasColumns()) {
				columnAxis = $self.visibleResult().axes().item(0);
			}


		} else {
			columnAxis = $self.createSubAxis(cellsAxis, childrenIndexes, false);
			if ($self.hasRows()) {
				rowAxis = $self.visibleResult().axes().item(1);
			}

		}

		var resultAxis = $self.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var position = resultAxis.tuples().__inner[tupleIndex];
		if (resultAxis.positionResolver().hasUnregisterdPositions()) {
			resultAxis.positionResolver().completeRegisterPositions();
		}

		var hostPosition = resultAxis.positionResolver().getHostPositionItemInfo(position, memberIndex);
		var itemPosition = hostPosition.item(position.item(memberIndex).key());
		itemPosition.isExpanded(false);
		var subResult = $self.getSubResult($self.visibleResult(), rowAxis, columnAxis, $self.hasRows(), $self.hasColumns());
		return new $.ig.OlapResultView($self.result(), subResult, $self.hasColumns(), $self.hasRows());
	}

	, 
	extend: function (partialResult, axisName) {
		var $self = this;
		var cellsAxis = $self.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var isRowAxis = (axisName == "Axis0" && !$self.hasColumns()) || (axisName == "Axis1" && $self.hasRows());
		var rowsVisibleAxis = null;
		var columnsVisibleAxis = null;
		var fullOpositeAxis = null;
		var resetCache = false;
		if (isRowAxis) {
			rowsVisibleAxis = cellsAxis;
			if ($self.hasColumns()) {
				columnsVisibleAxis = $self.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
				fullOpositeAxis = $self.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
				resetCache = columnsVisibleAxis.tuples().count() != fullOpositeAxis.tuples().count();
			}


		} else {
			columnsVisibleAxis = cellsAxis;
			if ($self.hasRows()) {
				rowsVisibleAxis = $self.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
				fullOpositeAxis = $self.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
				resetCache = rowsVisibleAxis.tuples().count() != fullOpositeAxis.tuples().count();
			}

		}

		var result = null;
		var visibleResult = null;
		if (fullOpositeAxis != null && resetCache) {
			var subResult = $self.getSubResult($self.result(), rowsVisibleAxis, columnsVisibleAxis, $self.hasRows(), $self.hasColumns());
			result = $self.extendResult(subResult, partialResult, axisName);
			visibleResult = $self.extendResult(subResult, partialResult, axisName);

		} else {
			result = $self.extendResult($self.result(), partialResult, axisName);
			visibleResult = $self.extendResult($self.visibleResult(), partialResult, axisName);
		}

		return new $.ig.OlapResultView(result, visibleResult, $self.hasColumns(), $self.hasRows());
	}

	, 
	extendResult: function (result, partialResult, axisName) {
		var $self = this;
		var axisToExtend = result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		if (axisToExtend == null) {
			return null;
		}

		var sourceAxis = partialResult.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var isRowAxis = (axisName == "Axis0" && !$self.hasColumns()) || (axisName == "Axis1" && $self.hasRows());
		var opositeAxisToExtend = null;
		var opositeSourceAxis = null;
		if (isRowAxis) {
			if ($self.hasColumns()) {
				opositeAxisToExtend = result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
				opositeSourceAxis = partialResult.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
			}


		} else {
			if ($self.hasRows()) {
				opositeAxisToExtend = result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
				opositeSourceAxis = partialResult.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
			}

		}

		var tuples = new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 0);
		var en = axisToExtend.tuples().getEnumerator();
		while (en.moveNext()) {
			var tuple = en.current();
			tuples.add(tuple.clone());
		}

		var en1 = sourceAxis.tuples().getEnumerator();
		while (en1.moveNext()) {
			var tuple1 = en1.current();
			tuples.add(tuple1);
		}

		var sourceAxisTuplesCount = sourceAxis.tuples().count();
		var opositeSourceAxisTuplesCount = opositeSourceAxis != null && opositeSourceAxis.tuples().count() > 0 ? opositeSourceAxis.tuples().count() : 1;
		var axisToExtendTuplesCount = axisToExtend.tuples().count() > 0 ? axisToExtend.tuples().count() : 1;
		var notChangedAxisTuplesCount = opositeAxisToExtend != null && opositeAxisToExtend.tuples().count() > 0 ? opositeAxisToExtend.tuples().count() : 1;
		var cellsArrayMaxSize = axisToExtendTuplesCount * notChangedAxisTuplesCount;
		var cells = new $.ig.List$1($.ig.OlapResultCell.prototype.$type, 0);
		if (isRowAxis) {
			var en2 = result.cells().getEnumerator();
			while (en2.moveNext()) {
				var cell = en2.current();
				cells.add(cell.clone());
			}

			var newCells = new Array(sourceAxisTuplesCount * notChangedAxisTuplesCount);
			var offset = axisToExtendTuplesCount * notChangedAxisTuplesCount;
			var en3 = partialResult.cells().getEnumerator();
			while (en3.moveNext()) {
				var cell1 = en3.current();
				var newCell = cell1.clone();
				var columnIndex = $self.getMappedCellColumnIndex(newCell.cellOrdinal(), opositeAxisToExtend, opositeSourceAxis);
				var currentRowIndex = $.ig.intDivide(newCell.cellOrdinal(), opositeSourceAxisTuplesCount);
				newCell.cellOrdinal(currentRowIndex * notChangedAxisTuplesCount + columnIndex);
				newCell.cellOrdinal(newCell.cellOrdinal() + cellsArrayMaxSize);
				newCells[newCell.cellOrdinal() - offset] = newCell;
			}

			for (var i = 0; i < newCells.length; i++) {
				var newCell1 = newCells[i];
				if (newCell1 != null) {
					cells.add(newCell1);
				}

			}


		} else {
			var cellsArray = new Array(notChangedAxisTuplesCount * (axisToExtendTuplesCount + sourceAxisTuplesCount));
			var en4 = result.cells().getEnumerator();
			while (en4.moveNext()) {
				var cell2 = en4.current();
				var newCell2 = cell2.clone();
				var rowIndex = $.ig.intDivide(newCell2.cellOrdinal(), axisToExtendTuplesCount);
				newCell2.cellOrdinal(newCell2.cellOrdinal() + rowIndex * sourceAxisTuplesCount);
				cellsArray[newCell2.cellOrdinal()] = newCell2;
			}

			var en5 = partialResult.cells().getEnumerator();
			while (en5.moveNext()) {
				var cell3 = en5.current();
				var newCell3 = cell3.clone();
				var rowIndex1 = $self.getMappedCellRowIndex(newCell3.cellOrdinal(), opositeAxisToExtend, opositeSourceAxis, sourceAxisTuplesCount);
				var currentRowIndex1 = $.ig.intDivide(cell3.cellOrdinal(), sourceAxisTuplesCount);
				if (rowIndex1 != currentRowIndex1) {
				}

				var currentColumnIndex = newCell3.cellOrdinal() % sourceAxisTuplesCount;
				newCell3.cellOrdinal(rowIndex1 * sourceAxisTuplesCount + currentColumnIndex);
				newCell3.cellOrdinal(newCell3.cellOrdinal() + (rowIndex1 + 1) * axisToExtendTuplesCount);
				cellsArray[newCell3.cellOrdinal()] = newCell3;
			}

			for (var i1 = 0; i1 < cellsArray.length; i1++) {
				var cell4 = cellsArray[i1];
				if (cell4 != null) {
					cells.add(cell4);
				}

			}

		}

		var combinedResult = new $.ig.OlapResult();
		combinedResult.axes(new $.ig.List$1($.ig.OlapResultAxis.prototype.$type, 0));
		var combinedAxis = (function () { var $ret = new $.ig.OlapResultAxis(tuples, axisToExtend.tupleSize());
		$ret.name(axisToExtend.name()); return $ret;}());
		if (isRowAxis) {
			if (opositeAxisToExtend != null) {
				combinedResult.axes().add(opositeAxisToExtend);
			}

			combinedResult.axes().add(combinedAxis);

		} else {
			combinedResult.axes().add(combinedAxis);
			if (opositeAxisToExtend != null) {
				combinedResult.axes().add(opositeAxisToExtend);
			}

		}

		combinedResult.cells(cells);
		combinedResult.isEmpty(!$self.hasColumns() && !$self.hasRows() && cells.count() == 0);
		return combinedResult;
	}

	, 
	getMappedCellColumnIndex: function (cellOrdinal, targetAxis, sourceAxis) {
		if (sourceAxis == null) {
			return 0;
		}

		var columnIndex = cellOrdinal % sourceAxis.tuples().count();
		var tuple = sourceAxis.tuples().__inner[columnIndex];
		var tupleIndex = targetAxis.positionResolver().getPositionIndex(tuple);
		return tupleIndex;
	}

	, 
	getMappedCellRowIndex: function (cellOrdinal, targetAxis, sourceAxis, columnsCount) {
		if (sourceAxis == null) {
			return 0;
		}

		var rowIndex = $.ig.intDivide(cellOrdinal, columnsCount);
		var tuple = sourceAxis.tuples().__inner[rowIndex];
		var tupleIndex = targetAxis.positionResolver().getPositionIndex(tuple);
		return tupleIndex;
	}

	, 
	getChildrenPositionIndexes: function (axisName, tupleIndex, memberIndex, result) {
		var $self = this;
		var cellAxis = result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var position = cellAxis.tuples().__inner[tupleIndex];
		var positionItem = position.item(memberIndex);
		if (cellAxis.positionResolver().hasUnregisterdPositions()) {
			cellAxis.positionResolver().completeRegisterPositions();
		}

		var indexList = cellAxis.positionResolver().getChildPositionsIndexes(positionItem, $.ig.ListSortDirection.prototype.ascending);
		if (indexList != null) {
			return indexList.toList$1($.ig.Number.prototype.$type);
		}

		return null;
	}

	, 
	getPositionItem: function (axisName, tupleIndex, memberIndex, result) {
		var $self = this;
		var cellAxis = result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var position = cellAxis.tuples().__inner[tupleIndex];
		var positionItem = position.item(memberIndex);
		if (cellAxis.positionResolver().hasUnregisterdPositions()) {
			cellAxis.positionResolver().completeRegisterPositions();
		}

		var hostPositionInfo = cellAxis.positionResolver().getHostPositionItemInfo(position, memberIndex);
		var positionInfo;
		(function () { var $ret = hostPositionInfo.tryGetValue(positionItem.key(), positionInfo); positionInfo = $ret.value; return $ret.ret; }());
		return positionInfo;
	}
	, 
	$type: new $.ig.Type('OlapResultView', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ResultViewHelper', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	setPositionIsExpaned2: function (axisName, tupleIndex, memberIndex, isExpanded, resultView) {
		$.ig.ResultViewHelper.prototype.setPositionIsExpaned1(axisName, tupleIndex, memberIndex, true, resultView.visibleResult());
		$.ig.ResultViewHelper.prototype.setPositionIsExpaned1(axisName, tupleIndex, memberIndex, true, resultView.result());
	}

	, 
	syncPositionExpansionState: function (axisName, sourceResultView, targetResultView) {
		var $self = this;
		var sourceVisibleAxis = sourceResultView.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (ax) { return ax.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var targetVisibleAxis = targetResultView.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (ax) { return ax.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		$.ig.ResultViewHelper.prototype.setExpansionStates1(sourceVisibleAxis.positionResolver(), targetVisibleAxis.positionResolver());
		var sourceAxis = sourceResultView.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (ax) { return ax.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var targetAxis = targetResultView.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (ax) { return ax.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		$.ig.ResultViewHelper.prototype.setExpansionStates1(sourceAxis.positionResolver(), targetAxis.positionResolver());
	}

	, 
	setPositionIsExpaned1: function (axisName, tupleIndex, memberIndex, isExpanded, result) {
		var $self = this;
		var resultAxis = result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		if (resultAxis.positionResolver().hasUnregisterdPositions()) {
			resultAxis.positionResolver().completeRegisterPositions();
		}

		$.ig.ResultViewHelper.prototype.setPositionIsExpaned(tupleIndex, memberIndex, isExpanded, resultAxis.positionResolver());
	}

	, 
	setPositionIsExpaned: function (tupleIndex, memberIndex, isExpanded, targetResolver) {
		if (targetResolver.hasUnregisterdPositions()) {
			targetResolver.completeRegisterPositions();
		}

		var position = targetResolver.positions().__inner[tupleIndex];
		var hostPosition = targetResolver.getHostPositionItemInfo(position, memberIndex);
		var itemPosition = hostPosition.item(position.item(memberIndex).key());
		itemPosition.isExpanded(isExpanded);
	}

	, 
	setExpansionStates1: function (source, target) {
		if (source.hasUnregisterdPositions()) {
			source.completeRegisterPositions();
		}

		if (target.hasUnregisterdPositions()) {
			target.completeRegisterPositions();
		}

		$.ig.ResultViewHelper.prototype.setExpansionStates(source.rootPositionInfo(), target.rootPositionInfo());
	}

	, 
	setExpansionStates: function (source, target) {
		var $self = this;
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var sourcePositionInfo = en.current();
			var sourceItem = sourcePositionInfo.value();
			var targetItem;
			if ((function () { var $ret = target.tryGetValue(sourcePositionInfo.key(), targetItem); targetItem = $ret.value; return $ret.ret; }())) {
				if (sourceItem.isExpanded() != true) {
					targetItem.isExpanded(false);
				}

				if (targetItem.count() > 0) {
					$.ig.ResultViewHelper.prototype.setExpansionStates(sourceItem, targetItem);
				}

			}

		}

	}
	, 
	$type: new $.ig.Type('ResultViewHelper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapTableViewHeaderCell', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.columnSpan(1);
			this.rowSpan(1);
	}

	, 
	_id: null,
	id: function (value) {
		if (arguments.length === 1) {
			this._id = value;
			return value;
		} else {
			return this._id;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_isExpanded: false,
	isExpanded: function (value) {
		if (arguments.length === 1) {
			this._isExpanded = value;
			return value;
		} else {
			return this._isExpanded;
		}
	}

	, 
	_isExpandable: false,
	isExpandable: function (value) {
		if (arguments.length === 1) {
			this._isExpandable = value;
			return value;
		} else {
			return this._isExpandable;
		}
	}

	, 
	_rowIndex: 0,
	rowIndex: function (value) {
		if (arguments.length === 1) {
			this._rowIndex = value;
			return value;
		} else {
			return this._rowIndex;
		}
	}

	, 
	_rowSpan: 0,
	rowSpan: function (value) {
		if (arguments.length === 1) {
			this._rowSpan = value;
			return value;
		} else {
			return this._rowSpan;
		}
	}

	, 
	_columnIndex: 0,
	columnIndex: function (value) {
		if (arguments.length === 1) {
			this._columnIndex = value;
			return value;
		} else {
			return this._columnIndex;
		}
	}

	, 
	_columnSpan: 0,
	columnSpan: function (value) {
		if (arguments.length === 1) {
			this._columnSpan = value;
			return value;
		} else {
			return this._columnSpan;
		}
	}

	, 
	_axisName: null,
	axisName: function (value) {
		if (arguments.length === 1) {
			this._axisName = value;
			return value;
		} else {
			return this._axisName;
		}
	}

	, 
	_tupleIndex: 0,
	tupleIndex: function (value) {
		if (arguments.length === 1) {
			this._tupleIndex = value;
			return value;
		} else {
			return this._tupleIndex;
		}
	}

	, 
	_memberIndex: 0,
	memberIndex: function (value) {
		if (arguments.length === 1) {
			this._memberIndex = value;
			return value;
		} else {
			return this._memberIndex;
		}
	}

	, 
	_levelNumber: 0,
	levelNumber: function (value) {
		if (arguments.length === 1) {
			this._levelNumber = value;
			return value;
		} else {
			return this._levelNumber;
		}
	}

	, 
	_hierarchyNumber: 0,
	hierarchyNumber: function (value) {
		if (arguments.length === 1) {
			this._hierarchyNumber = value;
			return value;
		} else {
			return this._hierarchyNumber;
		}
	}

	, 
	toString: function () {
		return this.caption();
	}
	, 
	$type: new $.ig.Type('OlapTableViewHeaderCell', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapTableViewResultCell', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_value: null,
	value: function (value) {
		if (arguments.length === 1) {
			this._value = value;
			return value;
		} else {
			return this._value;
		}
	}

	, 
	_formattedValue: null,
	formattedValue: function (value) {
		if (arguments.length === 1) {
			this._formattedValue = value;
			return value;
		} else {
			return this._formattedValue;
		}
	}

	, 
	_cellOrdinal: 0,
	cellOrdinal: function (value) {
		if (arguments.length === 1) {
			this._cellOrdinal = value;
			return value;
		} else {
			return this._cellOrdinal;
		}
	}

	, 
	_resultCellIndex: 0,
	resultCellIndex: function (value) {
		if (arguments.length === 1) {
			this._resultCellIndex = value;
			return value;
		} else {
			return this._resultCellIndex;
		}
	}
	, 
	$type: new $.ig.Type('OlapTableViewResultCell', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ArrayListCollection$1', 'Object', {
	$t: null, 
	init: function ($t) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.inner(new $.ig.Array());
	}

	, 
	_inner: null,
	inner: function (value) {
		if (arguments.length === 1) {
			this._inner = value;
			return value;
		} else {
			return this._inner;
		}
	}
	, 
	collectionChanged: null
	, 
	indexOf: function (item) {
		return this.inner().indexOf(item);
	}

	, 
	insert: function (index, item) {
		this.inner().insert(index, item);
		this.triggerItemAdded(index, item);
	}

	, 
	removeAt: function (index) {
		var item = this.inner()[index];
		this.inner().removeAt(index);
		this.triggerItemRemoved(index, item);
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			this.inner()[index] = value;
			return value;
		} else {

			return this.inner()[index];
		}
	}

	, 
	add: function (item) {
		this.inner().add(item);
		this.triggerItemAdded(this.inner().length - 1, item);
	}

	, 
	clear: function () {
		this.inner().clear();
		this.triggerClear();
	}

	, 
	contains: function (item) {
		return this.inner().contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		throw new $.ig.NotImplementedException();
	}

	, 
	count: function () {

			return this.inner().length;
	}

	, 
	isReadOnly: function () {

			return false;
	}

	, 
	remove: function (item) {
		var index = this.inner().indexOf(item);
		if (index >= 0) {
			this.inner().removeAt(index);
			this.triggerItemRemoved(index, item);
			return true;
		}

		return false;
	}

	, 
	enumerate: function () {
		var $self = this;
		var $iter = function () { return function () { return {
			$state: 0,
			$this: $self,
			$current: null,
			$i : 0,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
																this.$i = 0;
								this.$state = 5;
								break;
														case 2:
									this.$current = this.$this.inner()[this.$i];
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								this.$i++;
								this.$state = 5;
								break;
							case 5:
								if (this.$i < this.$this.inner().length) {
									this.$state = 2;
								}
								else {
									this.$state = 6;
								}
								break;
							case 6:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } () };
		return new $.ig.GenericEnumerable$1(this.$t, $iter);
	}

	, 
	getEnumerator: function () {
		return this.enumerate().getEnumerator();
	}

	, 
	triggerItemAdded: function (index, item) {
		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, item, index);
			this.collectionChanged(this, args);
		}

	}

	, 
	triggerItemRemoved: function (index, item) {
		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.remove, item, index);
			this.collectionChanged(this, args);
		}

	}

	, 
	triggerClear: function () {
		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.reset, null, -1);
			this.collectionChanged(this, args);
		}

	}
	, 
	$type: new $.ig.Type('ArrayListCollection$1', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(0), $.ig.INotifyCollectionChanged.prototype.$type])
}, true);

$.ig.util.defType('IOlapDataSource', 'Object', {
	$type: new $.ig.Type('IOlapDataSource', null)
}, true);

$.ig.util.defType('MeasureList', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	uniqueName: function (value) {
		if (arguments.length === 1) {

			this.name(value);
			return value;
		} else {

			return this.name();
		}
	}

	, 
	_measures: null,
	measures: function (value) {
		if (arguments.length === 1) {
			this._measures = value;
			return value;
		} else {
			return this._measures;
		}
	}
	, 
	$type: new $.ig.Type('MeasureList', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('OlapMetadataTreeItem', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_item: null,
	item: function (value) {
		if (arguments.length === 1) {
			this._item = value;
			return value;
		} else {
			return this._item;
		}
	}

	, 
	_type: null,
	type: function (value) {
		if (arguments.length === 1) {
			this._type = value;
			return value;
		} else {
			return this._type;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_children: null,
	children: function (value) {
		if (arguments.length === 1) {
			this._children = value;
			return value;
		} else {
			return this._children;
		}
	}

	, 
	addChild: function (metaItem) {
		if (this.children() == null) {
			this.children(new Array(1));
			this.children()[0] = metaItem;
			return;
		}

		var children = new Array(this.children().length + 1);
		$.ig.Array.prototype.copy(this.children(), 0, children, 0, this.children().length);
		children[this.children().length] = metaItem;
		this.children(children);
	}
	, 
	$type: new $.ig.Type('OlapMetadataTreeItem', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapDataSource', 'Object', {
	__positionsToExpand: null
	, 
	__positionsToCollapse: null
	, 
	__measureListIndex: 0
	, 
	__measureListLocation: null
	, 
	__dataProviderFactory: null
	, 
	init: function (options) {


		var $self = this;
		this.__positionsToExpand = new $.ig.List$1($.ig.PositionInfo.prototype.$type, 0);
		this.__positionsToCollapse = new $.ig.List$1($.ig.PositionInfo.prototype.$type, 0);
		this._membersSelectionChangedList = new $.ig.List$1(String, 0);

		$.ig.Object.prototype.init.call(this);
			this.columnFilters(new $.ig.List$1($.ig.AxisElement.prototype.$type, 0));
			this.rowFilters(new $.ig.List$1($.ig.AxisElement.prototype.$type, 0));
			this.filterFilters(new $.ig.List$1($.ig.AxisElement.prototype.$type, 0));
			this.isInitializing(false);
			this.initializeTask(null);
			this.isUpdating(false);
			this.updateTask(null);
			this.isInitialized(false);
			this.isColumnsAxisChanged(false);
			this.isRowsAxisChanged(false);
			this.isFiltersAxisChanged(false);
			this.isMeasuresAxisChanged(false);
			this.isMeasureListLocationChanged(false);
			this.isMeasureListIndexChanging(false);
			this.catalogs(new $.ig.ArrayListCollection$1($.ig.Catalog.prototype.$type));
			this.cubes(new $.ig.ArrayListCollection$1($.ig.Cube.prototype.$type));
			this.measureGroups(new $.ig.ArrayListCollection$1($.ig.MeasureGroup.prototype.$type));
			this.rowAxis(new $.ig.ArrayListCollection$1($.ig.ICoreOlapElement.prototype.$type));
			this.columnAxis(new $.ig.ArrayListCollection$1($.ig.ICoreOlapElement.prototype.$type));
			this.filters(new $.ig.ArrayListCollection$1($.ig.Hierarchy.prototype.$type));
			this.measures(new $.ig.ArrayListCollection$1($.ig.Measure.prototype.$type));
			this.measureListLocation($.ig.MeasureListLocation.prototype.columns);
			this.measureListIndex(-1);
			this.sourceOptions(options);
			this.result((function () { var $ret = new $.ig.OlapResult();
			$ret.isEmpty(true); return $ret;}()));
	}

	, 
	_isInitialized: false,
	isInitialized: function (value) {
		if (arguments.length === 1) {
			this._isInitialized = value;
			return value;
		} else {
			return this._isInitialized;
		}
	}

	, 
	_catalogs: null,
	catalogs: function (value) {
		if (arguments.length === 1) {
			this._catalogs = value;
			return value;
		} else {
			return this._catalogs;
		}
	}

	, 
	_cubes: null,
	cubes: function (value) {
		if (arguments.length === 1) {
			this._cubes = value;
			return value;
		} else {
			return this._cubes;
		}
	}

	, 
	_cube: null,
	cube: function (value) {
		if (arguments.length === 1) {
			this._cube = value;
			return value;
		} else {
			return this._cube;
		}
	}

	, 
	_measureGroup: null,
	measureGroup: function (value) {
		if (arguments.length === 1) {
			this._measureGroup = value;
			return value;
		} else {
			return this._measureGroup;
		}
	}

	, 
	_measureGroups: null,
	measureGroups: function (value) {
		if (arguments.length === 1) {
			this._measureGroups = value;
			return value;
		} else {
			return this._measureGroups;
		}
	}

	, 
	_sourceOptions: null,
	sourceOptions: function (value) {
		if (arguments.length === 1) {
			this._sourceOptions = value;
			return value;
		} else {
			return this._sourceOptions;
		}
	}

	, 
	dataProviderFactory: function (value) {
		if (arguments.length === 1) {

			this.__dataProviderFactory = value;
			return value;
		} else {

			if (this.__dataProviderFactory == null) {
				this.__dataProviderFactory = this.createOlapDataProviderFactory();
			}

			return this.__dataProviderFactory;
		}
	}

	, 
	_metadataTree: null,
	metadataTree: function (value) {
		if (arguments.length === 1) {
			this._metadataTree = value;
			return value;
		} else {
			return this._metadataTree;
		}
	}

	, 
	_rowAxis: null,
	rowAxis: function (value) {
		if (arguments.length === 1) {
			this._rowAxis = value;
			return value;
		} else {
			return this._rowAxis;
		}
	}

	, 
	_columnAxis: null,
	columnAxis: function (value) {
		if (arguments.length === 1) {
			this._columnAxis = value;
			return value;
		} else {
			return this._columnAxis;
		}
	}

	, 
	_filters: null,
	filters: function (value) {
		if (arguments.length === 1) {
			this._filters = value;
			return value;
		} else {
			return this._filters;
		}
	}

	, 
	_measures: null,
	measures: function (value) {
		if (arguments.length === 1) {
			this._measures = value;
			return value;
		} else {
			return this._measures;
		}
	}

	, 
	measureListIndex: function (value) {
		if (arguments.length === 1) {

			if (this.__measureListIndex != value) {
				this.isMeasureListIndexChanging(true);
				this.__measureListIndex = value;
				this.updateMeasureList();
				this.isMeasureListIndexChanging(false);
			}

			return value;
		} else {

			return this.__measureListIndex;
		}
	}

	, 
	measureListLocation: function (value) {
		if (arguments.length === 1) {

			if (this.__measureListLocation != value) {
				this.removeMeasureList();
				this.__measureListLocation = value;
				this.updateMeasureList();
			}

			return value;
		} else {

			return this.__measureListLocation;
		}
	}

	, 
	_result: null,
	result: function (value) {
		if (arguments.length === 1) {
			this._result = value;
			return value;
		} else {
			return this._result;
		}
	}

	, 
	_resultView: null,
	resultView: function (value) {
		if (arguments.length === 1) {
			this._resultView = value;
			return value;
		} else {
			return this._resultView;
		}
	}

	, 
	_cubeCache: null,
	cubeCache: function (value) {
		if (arguments.length === 1) {
			this._cubeCache = value;
			return value;
		} else {
			return this._cubeCache;
		}
	}

	, 
	_columnFilters: null,
	columnFilters: function (value) {
		if (arguments.length === 1) {
			this._columnFilters = value;
			return value;
		} else {
			return this._columnFilters;
		}
	}

	, 
	_rowFilters: null,
	rowFilters: function (value) {
		if (arguments.length === 1) {
			this._rowFilters = value;
			return value;
		} else {
			return this._rowFilters;
		}
	}

	, 
	_filterFilters: null,
	filterFilters: function (value) {
		if (arguments.length === 1) {
			this._filterFilters = value;
			return value;
		} else {
			return this._filterFilters;
		}
	}
	, 
	_membersSelectionChangedList: null

	, 
	_isInitializing: false,
	isInitializing: function (value) {
		if (arguments.length === 1) {
			this._isInitializing = value;
			return value;
		} else {
			return this._isInitializing;
		}
	}

	, 
	_initializeTask: null,
	initializeTask: function (value) {
		if (arguments.length === 1) {
			this._initializeTask = value;
			return value;
		} else {
			return this._initializeTask;
		}
	}

	, 
	_isUpdating: false,
	isUpdating: function (value) {
		if (arguments.length === 1) {
			this._isUpdating = value;
			return value;
		} else {
			return this._isUpdating;
		}
	}

	, 
	_updateTask: null,
	updateTask: function (value) {
		if (arguments.length === 1) {
			this._updateTask = value;
			return value;
		} else {
			return this._updateTask;
		}
	}

	, 
	_isColumnsAxisChanged: false,
	isColumnsAxisChanged: function (value) {
		if (arguments.length === 1) {
			this._isColumnsAxisChanged = value;
			return value;
		} else {
			return this._isColumnsAxisChanged;
		}
	}

	, 
	_isRowsAxisChanged: false,
	isRowsAxisChanged: function (value) {
		if (arguments.length === 1) {
			this._isRowsAxisChanged = value;
			return value;
		} else {
			return this._isRowsAxisChanged;
		}
	}

	, 
	_isFiltersAxisChanged: false,
	isFiltersAxisChanged: function (value) {
		if (arguments.length === 1) {
			this._isFiltersAxisChanged = value;
			return value;
		} else {
			return this._isFiltersAxisChanged;
		}
	}

	, 
	_isMeasuresAxisChanged: false,
	isMeasuresAxisChanged: function (value) {
		if (arguments.length === 1) {
			this._isMeasuresAxisChanged = value;
			return value;
		} else {
			return this._isMeasuresAxisChanged;
		}
	}

	, 
	_isMeasureListLocationChanged: false,
	isMeasureListLocationChanged: function (value) {
		if (arguments.length === 1) {
			this._isMeasureListLocationChanged = value;
			return value;
		} else {
			return this._isMeasureListLocationChanged;
		}
	}

	, 
	_isMeasureListIndexChanging: false,
	isMeasureListIndexChanging: function (value) {
		if (arguments.length === 1) {
			this._isMeasureListIndexChanging = value;
			return value;
		} else {
			return this._isMeasureListIndexChanging;
		}
	}

	, 
	getMembersOfLevel: function (levelUniqueName) {
	}

	, 
	getMembersOfHierarchy: function (hierarchyUniqueName) {
	}

	, 
	getMembersOfMember: function (memberUniqueName) {
	}

	, 
	setCube: function (cubeName) {
		if (!this.isInitialized()) {
			throw new $.ig.InvalidOperationException(1, "Data source is not initialized.");
		}

		return this.onSetCube(cubeName);
	}

	, 
	setMeasureGroup: function (measureGroupName) {
		if (!this.isInitialized()) {
			throw new $.ig.InvalidOperationException(1, "Data source is not initialized.");
		}

		return this.onSetMeasureGroup(measureGroupName);
	}

	, 
	getCoreElement: function (predicate, elementType) {
		if (elementType == $.ig.MeasureList.prototype.$type) {
			var measureListAxis;
			if (this.measureListLocation() == $.ig.MeasureListLocation.prototype.columns) {
				measureListAxis = this.columnAxis();

			} else {
				measureListAxis = this.rowAxis();
			}

			var measureList = null;
			var en = measureListAxis.getEnumerator();
			while (en.moveNext()) {
				var coreOlapElement = en.current();
				measureList = $.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement);
				if (measureList != null) {
					break;
				}

			}

			return measureList;

		} else {
			return this.getCoreElements(predicate, elementType).firstOrDefault$1($.ig.ICoreOlapElement.prototype.$type);
		}

	}

	, 
	getCoreElements: function (predicate, elementType) {
		var $self = this;
		if (elementType == $.ig.Dimension.prototype.$type) {
			return $self.toArrayListCollection$1($.ig.Dimension.prototype.$type, $self.cubeCache().dimensionItems().where$1($.ig.Dimension.prototype.$type, function (d) { return predicate(d); }));
		}

		if (elementType == $.ig.Hierarchy.prototype.$type) {
			return $self.toArrayListCollection$1($.ig.Hierarchy.prototype.$type, $self.cubeCache().hierarchyItems().where$1($.ig.Hierarchy.prototype.$type, function (d) { return predicate(d); }));
		}

		if (elementType == $.ig.Level.prototype.$type) {
			return $self.toArrayListCollection$1($.ig.Level.prototype.$type, $self.cubeCache().levelItems().where$1($.ig.Level.prototype.$type, function (d) { return predicate(d); }));
		}

		if (elementType == $.ig.Measure.prototype.$type) {
			return $self.toArrayListCollection$1($.ig.Measure.prototype.$type, $self.cubeCache().measures().where$1($.ig.Measure.prototype.$type, function (d) { return predicate(d); }));
		}

		if (elementType == $.ig.KpiMeasure.prototype.$type) {
			return $self.toArrayListCollection$1($.ig.KpiMeasure.prototype.$type, $self.cubeCache().kpiMeasures().where$1($.ig.KpiMeasure.prototype.$type, function (d) { return predicate(d); }));
		}

		if (elementType == $.ig.Kpi.prototype.$type) {
			return $self.toArrayListCollection$1($.ig.Kpi.prototype.$type, $self.cubeCache().kpis().where$1($.ig.Kpi.prototype.$type, function (d) { return predicate(d); }));
		}

		throw new $.ig.NotSupportedException(0, "Supported types are Dimension, Hierarchy, Level and Measure");
	}

	, 
	expandTupleMember: function (axisName, tupleIndex, memberIndex) {
		var $self = this;
		var resultAxis = $self.getResultAxis(axisName, $self.result());
		if (resultAxis == null) {
			throw new $.ig.InvalidOperationException(1, "No axis found for the specified index.");
		}

		var positionInfo = $self.__positionsToExpand.where$1($.ig.PositionInfo.prototype.$type, function (pi) { return pi.axisName() == axisName && pi.tupleIndex() == tupleIndex && pi.memberIndex() == memberIndex; }).firstOrDefault$1($.ig.PositionInfo.prototype.$type);
		if (positionInfo == null) {
			positionInfo = (function () { var $ret = new $.ig.PositionInfo();
			$ret.axisName(axisName);
			$ret.memberIndex(memberIndex);
			$ret.tupleIndex(tupleIndex); return $ret;}());
			$self.__positionsToExpand.add(positionInfo);

		} else {
			$self.__positionsToExpand.remove(positionInfo);
		}

	}

	, 
	collapseTupleMember: function (axisName, tupleIndex, memberIndex) {
		var $self = this;
		var resultAxis = $self.getResultAxis(axisName, $self.result());
		if (resultAxis == null) {
			throw new $.ig.InvalidOperationException(1, "No axis found for the specified index.");
		}

		var positionInfo = $self.__positionsToExpand.where$1($.ig.PositionInfo.prototype.$type, function (pi) { return pi.axisName() == axisName && pi.tupleIndex() == tupleIndex && pi.memberIndex() == memberIndex; }).firstOrDefault$1($.ig.PositionInfo.prototype.$type);
		if (positionInfo == null) {
			positionInfo = (function () { var $ret = new $.ig.PositionInfo();
			$ret.axisName(axisName);
			$ret.memberIndex(memberIndex);
			$ret.tupleIndex(tupleIndex); return $ret;}());
			$self.__positionsToCollapse.add(positionInfo);

		} else {
			$self.__positionsToExpand.remove(positionInfo);
		}

	}

	, 
	clearPendingChanges: function () {
		this.__positionsToCollapse.clear();
		this.__positionsToExpand.clear();
	}

	, 
	update: function () {
		var $self = this;
		if ($self.isUpdating()) {
			return $self.updateTask();
		}

		$self.isUpdating(true);
		if ($self.__positionsToExpand.count() > 0) {
			var loadExpandedMembers = $self.loadExpandedMemberSiblings($self.__positionsToExpand);
			$self.updateTask(loadExpandedMembers.continueWithTask$1($.ig.OlapResult.prototype.$type, function (t) { return $self.onUpdate(); }));

		} else {
			$self.updateTask($self.onUpdate());
		}

		var task = $self.updateTask();
		$self.updateTask().continueWith1(function (t) {
			$self.isUpdating(false);
			$self.updateTask(null);
		});
		return task;
	}

	, 
	initialize: function () {
		var $self = this;
		if ($self.isInitializing()) {
			return $self.initializeTask();
		}

		$self.isInitializing(true);
		$self.initializeTask($self.onInitialize());
		var task = $self.initializeTask();
		$self.initializeTask().continueWith1(function (t) {
			$self.isInitializing(false);
			$self.initializeTask(null);
		});
		return task;
	}

	, 
	addFilterMember: function (hierarchyUniqueName, memberUniqueName) {
		var $self = this;
		var axisElementsCollection;
		var axisElement = (function () { var $ret = $self.findAxisElement(hierarchyUniqueName, axisElementsCollection); axisElementsCollection = $ret.filtersCollection; return $ret.ret; }());
		if (axisElement == null) {
			axisElement = new $.ig.AxisElement(hierarchyUniqueName, (function () { var $ret = new $.ig.ArrayListCollection$1(String);
			$ret.add(memberUniqueName); return $ret;}()));
			axisElementsCollection.add(axisElement);

		} else {
			if (!axisElement.memberNames().contains(memberUniqueName)) {
				axisElement.memberNames().add(memberUniqueName);
				if ($self._membersSelectionChangedList.contains(memberUniqueName)) {
					$self._membersSelectionChangedList.remove(memberUniqueName);

				} else {
					$self._membersSelectionChangedList.add(memberUniqueName);
				}

			}

		}

	}

	, 
	getFilterMemberNames: function (hierarchyUniqueName) {
		var $self = this;
		var axisElementsCollection;
		var axisElement = (function () { var $ret = $self.findAxisElement(hierarchyUniqueName, axisElementsCollection); axisElementsCollection = $ret.filtersCollection; return $ret.ret; }());
		if (axisElement != null) {
			return $self.toArrayListCollection$1(String, axisElement.memberNames());
		}

		return new $.ig.ArrayListCollection$1(String);
	}

	, 
	removeFilterMember: function (hierarchyUniqueName, memberUniqueName) {
		var $self = this;
		var axisElementsCollection;
		var axisElement = (function () { var $ret = $self.findAxisElement(hierarchyUniqueName, axisElementsCollection); axisElementsCollection = $ret.filtersCollection; return $ret.ret; }());
		if (axisElement == null) {
			return;
		}

		if (axisElement.memberNames().remove(memberUniqueName)) {
			if ($self._membersSelectionChangedList.contains(memberUniqueName)) {
				$self._membersSelectionChangedList.remove(memberUniqueName);

			} else {
				$self._membersSelectionChangedList.add(memberUniqueName);
			}

		}

	}

	, 
	removeAllFilterMembers: function (hierarchyUniqueName) {
		var $self = this;
		var axisElementsCollection;
		var axisElement = (function () { var $ret = $self.findAxisElement(hierarchyUniqueName, axisElementsCollection); axisElementsCollection = $ret.filtersCollection; return $ret.ret; }());
		if (axisElement == null) {
			return;
		}

		for (var i = axisElement.memberNames().count() - 1; i >= 0; i--) {
			var memberName = axisElement.memberNames().item(i);
			axisElement.memberNames().removeAt(i);
			if ($self._membersSelectionChangedList.contains(memberName)) {
				$self._membersSelectionChangedList.remove(memberName);

			} else {
				$self._membersSelectionChangedList.add(memberName);
			}

		}

	}

	, 
	getProviderDefaultProperties: function () {
		var properties = new $.ig.List$1($.ig.KeyValueItem.prototype.$type, 0);
		return properties;
	}

	, 
	getProviderDefaultRestrictions: function () {
		var restrictions = new $.ig.List$1($.ig.KeyValueItem.prototype.$type, 0);
		return restrictions;
	}

	, 
	tryGetMember: function (memberUniqueName, member) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.cubeCache().tryGetMember1(memberUniqueName, member); member = $ret.member; return $ret.ret; }()), 
			member: member
		};
		return {
			member: member
		};
	}

	, 
	tryGetMembersForLevel: function (levelUniqueName, members) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.cubeCache().tryGetMembersForLevel(levelUniqueName, members); members = $ret.members; return $ret.ret; }()), 
			members: members
		};
		return {
			members: members
		};
	}

	, 
	onInitialize: function () {
	}

	, 
	onUpdate: function () {
	}

	, 
	createOlapDataProviderFactory: function () {
	}

	, 
	cacheCubeMetaItems: function () {
	}

	, 
	onSetCube: function (cubeName) {
		var $self = this;
		if (String.isNullOrEmpty(cubeName)) {
			if (cubeName == null) {
				throw new $.ig.ArgumentNullException("cubeName");
			}

			throw new $.ig.InvalidOperationException(1, "cubeName cannot be empty.");
		}

		var setCubeCompleted = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		if ($self.cube() != null) {
			if ($self.cube().name() == cubeName) {
				setCubeCompleted.setResult($self.metadataTree());
				return setCubeCompleted.task();
			}

			$self.clearCubeCache();
		}

		var en = $self.cubes().getEnumerator();
		while (en.moveNext()) {
			var cube = en.current();
			if (cube.name() == cubeName) {
				$self.cube(cube);
				break;
			}

		}

		var cacheCubeItemsTask = $self.cacheCubeMetaItems();
		if (!$self.isInitialized()) {
			var measureGroupName = $self.sourceOptions().measureGroup();
			if (!String.isNullOrEmpty(measureGroupName)) {
				return cacheCubeItemsTask.continueWithTask$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) { return $self.onSetMeasureGroup(measureGroupName); });
			}

		}

		return cacheCubeItemsTask.continueWithTask$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t1) { return $self.onSetMeasureGroup(null); });
	}

	, 
	initializeAxes: function () {
		var $self = this;
		var columnElements = null;
		var rowElements = null;
		var filterElements = null;
		var hierarchiesWithFilters = new $.ig.List$1($.ig.AxisElement.prototype.$type, 0);
		if (!String.isNullOrEmpty($self.sourceOptions().columns())) {
			var columnsParser = new $.ig.AxisDefinitionParser($self.sourceOptions().columns());
			columnElements = columnsParser.parse();
		}

		if (!String.isNullOrEmpty($self.sourceOptions().rows())) {
			var rowsParser = new $.ig.AxisDefinitionParser($self.sourceOptions().rows());
			rowElements = rowsParser.parse();
		}

		if (!String.isNullOrEmpty($self.sourceOptions().filters())) {
			var filtersParser = new $.ig.AxisDefinitionParser($self.sourceOptions().filters());
			filterElements = filtersParser.parse();
		}

		if (columnElements != null && columnElements.count() > 0) {
			var en = columnElements.getEnumerator();
			while (en.moveNext()) {
				var axisElement = en.current();
				$self.addCoreElementToAxis$1($.ig.ICoreOlapElement.prototype.$type, axisElement.name(), $self.columnAxis(), $.ig.Hierarchy.prototype.$type);
				$self.columnFilters().add(axisElement);
				if (axisElement.memberNames().count() > 0) {
					hierarchiesWithFilters.add(axisElement);
					var en1 = axisElement.memberNames().getEnumerator();
					while (en1.moveNext()) {
						var memberName = en1.current();
						$self._membersSelectionChangedList.add(memberName);
					}

				}

			}

		}

		if (rowElements != null && rowElements.count() > 0) {
			var en2 = rowElements.getEnumerator();
			while (en2.moveNext()) {
				var axisElement1 = en2.current();
				$self.addCoreElementToAxis$1($.ig.ICoreOlapElement.prototype.$type, axisElement1.name(), $self.rowAxis(), $.ig.Hierarchy.prototype.$type);
				$self.rowFilters().add(axisElement1);
				if (axisElement1.memberNames().count() > 0) {
					hierarchiesWithFilters.add(axisElement1);
					var en3 = axisElement1.memberNames().getEnumerator();
					while (en3.moveNext()) {
						var memberName1 = en3.current();
						$self._membersSelectionChangedList.add(memberName1);
					}

				}

			}

		}

		if (filterElements != null && filterElements.count() > 0) {
			var en4 = filterElements.getEnumerator();
			while (en4.moveNext()) {
				var axisElement2 = en4.current();
				$self.addCoreElementToAxis$1($.ig.Hierarchy.prototype.$type, axisElement2.name(), $self.filters(), $.ig.Hierarchy.prototype.$type);
				$self.filterFilters().add(axisElement2);
				if (axisElement2.memberNames().count() > 0) {
					hierarchiesWithFilters.add(axisElement2);
					var en5 = axisElement2.memberNames().getEnumerator();
					while (en5.moveNext()) {
						var memberName2 = en5.current();
						$self._membersSelectionChangedList.add(memberName2);
					}

				}

			}

		}

		var measureElements = null;
		if (!String.isNullOrEmpty($self.sourceOptions().measures())) {
			var measuresParser = new $.ig.AxisDefinitionParser($self.sourceOptions().measures());
			measureElements = measuresParser.parse();
		}

		if (measureElements != null && measureElements.count() > 0) {
			var en6 = measureElements.getEnumerator();
			while (en6.moveNext()) {
				var measureElement = en6.current();
				$self.addCoreElementToAxis$1($.ig.Measure.prototype.$type, measureElement.name(), $self.measures(), $.ig.Measure.prototype.$type);
			}

		}

		if ($self.isColumnsAxisChanged() || $self.isRowsAxisChanged() || $self.isFiltersAxisChanged() || $self.isMeasuresAxisChanged() || $self.isMeasureListIndexChanging()) {
			if (hierarchiesWithFilters.count() > 0) {
				var tasksToComplete = new Array(hierarchiesWithFilters.count());
				for (var i = 0; i < hierarchiesWithFilters.count(); i++) {
					var hierarchyName = hierarchiesWithFilters.item(i).name();
					tasksToComplete[i] = $self.getMembersOfHierarchy(hierarchyName);
				}

				var tcs1 = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
				var tf = new $.ig.TaskFactory();
				tf.continueWhenAll(tasksToComplete, function (t) {
					$self.onUpdate().continueWith1(function (t1) {
						$self.initializeCompleted();
						tcs1.setResult($self.metadataTree());
					});
				});
				return tcs1.task();
			}

			return $self.onUpdate().continueWithTask$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) {
				$self.initializeCompleted();
				var tcs1 = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
				tcs1.setResult($self.metadataTree());
				return tcs1.task();
			});
		}

		$self.initializeCompleted();
		var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		tcs.setResult($self.metadataTree());
		return tcs.task();
	}

	, 
	loadCubes: function (catalogName) {
		var $self = this;
		var provider = $self.dataProviderFactory().createDataProvider();
		var restrictions = $self.getProviderDefaultRestrictions();
		var properties = $self.getProviderDefaultProperties();
		var task = provider.discoverCubesAsync(properties, restrictions).continueWith$1($.ig.IList$1.prototype.$type.specialize($.ig.Cube.prototype.$type), function (t) {
			$self.cubes($self.toArrayListCollection$1($.ig.Cube.prototype.$type, t.result()));
			return $self.cubes();
		});
		return task;
	}

	, 
	loadMeasureGroups: function () {
		var $self = this;
		var provider = $self.dataProviderFactory().createDataProvider();
		var restrictions = $self.getProviderDefaultRestrictions();
		var properties = $self.getProviderDefaultProperties();
		var task = provider.discoverMeasureGroupsAsync(properties, restrictions).continueWith$1($.ig.IList$1.prototype.$type.specialize($.ig.MeasureGroup.prototype.$type), function (t) {
			$self.measureGroups($self.toArrayListCollection$1($.ig.MeasureGroup.prototype.$type, t.result()));
			return $self.measureGroups();
		});
		return task;
	}

	, 
	initializeCompleted: function () {
		this.isInitialized(true);
	}

	, 
	clearCubeCache: function () {
		this.cube(null);
		this.measureGroups(new $.ig.ArrayListCollection$1($.ig.MeasureGroup.prototype.$type));
		this.filters().clear();
		this.rowAxis().clear();
		this.columnAxis().clear();
		this.measures().clear();
		this.cubeCache(null);
		this.clearMeasureGroupCache();
	}

	, 
	clearMeasureGroupCache: function () {
		this.measureGroup(null);
		this.metadataTree(null);
	}

	, 
	onSetMeasureGroup: function (measureGroupName) {
		var $self = this;
		if ($self.cube() == null) {
			throw new $.ig.InvalidOperationException(1, "Data source has no Cube set.");
		}

		var setMeasueGroupCompleted = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		if ($self.measureGroup() != null) {
			if ($self.measureGroup().name() == measureGroupName) {
				setMeasueGroupCompleted.setResult($self.metadataTree());
				return setMeasueGroupCompleted.task();
			}

			$self.clearMeasureGroupCache();
		}

		if (!String.isNullOrEmpty(measureGroupName) && $self.measureGroups().count() == 0) {
			var setMeasureGroupTask = $self.loadMeasureGroups().continueWithTask$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) {
				if ($self.measureGroups().count() == 0) {
					return $self.onSetMeasureGroup(null);
				}

				return $self.onSetMeasureGroup(measureGroupName);
			});
			return setMeasureGroupTask;
		}

		var en = $self.measureGroups().getEnumerator();
		while (en.moveNext()) {
			var measureGroup = en.current();
			if (measureGroup.name() == measureGroupName) {
				$self.measureGroup(measureGroup);
				break;
			}

		}

		$self.metadataTree($self.createMetadataTree(measureGroupName));
		setMeasueGroupCompleted.setResult($self.metadataTree());
		return setMeasueGroupCompleted.task();
	}

	, 
	createMetadataTree: function (measureGroupName) {
		var $self = this;
		var cubeRoot = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
		$ret.type($.ig.OlapMetadataTreeItemType.prototype.cube);
		$ret.caption($self.cube().caption());
		$ret.item($self.cube()); return $ret;}());
		var dimensions;
		var measures;
		var kpis;
		var createMeasureGroupFolders = true;
		if (String.isNullOrEmpty(measureGroupName) || $self.measureGroups() == null) {
			dimensions = $self.cubeCache().dimensionItems();
			measures = $self.cubeCache().measures();
			kpis = $self.cubeCache().kpis();

		} else {
			createMeasureGroupFolders = false;
			dimensions = $self.cubeCache().measureGroupDimensionsCache().getMeasureGroupDimensions(measureGroupName);
			measures = $self.cubeCache().measureGroupDimensionsCache().getMeasureGroupMeasures(measureGroupName);
			kpis = $self.cubeCache().measureGroupDimensionsCache().getMeasureGroupKpis(measureGroupName);
		}

		var dimensionMetaItems = $.ig.MetaTreeHelper.prototype.getDimensionMetaItems(dimensions, measures, kpis, $self.cubeCache().hierarchyItems(), $self.cubeCache().levelItems(), createMeasureGroupFolders, $self.cubeCache());
		$.ig.MetaTreeHelper.prototype.setMetaItemChildren(cubeRoot, dimensionMetaItems);
		return cubeRoot;
	}

	, 
	getResultAxis: function (axisName, result) {
		var $self = this;
		if (result != null && result.axes().count() > 0) {
			return result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (ax) { return ax.name() == axisName; }).firstOrDefault$1($.ig.OlapResultAxis.prototype.$type);
		}

		return null;
	}

	, 
	updateAxisState: function (changedEventArgs, filters) {
		var $self = this;
		switch (changedEventArgs.action()) {
			case $.ig.NotifyCollectionChangedAction.prototype.add:
				var en = changedEventArgs.newItems().getEnumerator();
				while (en.moveNext()) {
					var newItem = en.current();
					var hierarchy = $.ig.util.cast($.ig.Hierarchy.prototype.$type, newItem);
					if (hierarchy != null) {
						if ($self.isInitialized()) {
							filters.add(new $.ig.AxisElement(hierarchy.uniqueName(), new $.ig.ArrayListCollection$1(String)));
						}

					}

				}

				break;
			case $.ig.NotifyCollectionChangedAction.prototype.remove:
				var en1 = changedEventArgs.oldItems().getEnumerator();
				while (en1.moveNext()) {
					var oldItem = en1.current();
					var hierarchy1 = $.ig.util.cast($.ig.Hierarchy.prototype.$type, oldItem);
					if (hierarchy1 != null) {
						var axisElement = filters.where$1($.ig.AxisElement.prototype.$type, function (ae) { return ae.name() == hierarchy1.uniqueName(); }).firstOrDefault$1($.ig.AxisElement.prototype.$type);
						if (axisElement != null) {
							var memberNames = new $.ig.List$1(String, 0);
							for (var i = 0; i < axisElement.memberNames().count(); i++) {
								memberNames.add(axisElement.memberNames().item(i));
							}

							for (var i1 = 0; i1 < memberNames.count(); i1++) {
								var memberName = memberNames.item(i1);
								$self.removeFilterMember(axisElement.name(), memberName);
							}

							filters.remove(axisElement);
						}


					} else {
						var measureList = $.ig.util.cast($.ig.MeasureList.prototype.$type, oldItem);
						if (measureList != null) {
							if (!$self.isMeasuresAxisChanged() && !$self.isMeasureListLocationChanged() && !$self.isMeasureListIndexChanging()) {
								$self.measures().clear();
							}

						}

					}

				}

				break;
		}

	}

	, 
	updateMeasureListIndex: function (changedEventArgs, filters) {
		var $self = this;
		switch (changedEventArgs.action()) {
			case $.ig.NotifyCollectionChangedAction.prototype.add:
				var en = changedEventArgs.newItems().getEnumerator();
				while (en.moveNext()) {
					var newItem = en.current();
					var hierarchy = $.ig.util.cast($.ig.Hierarchy.prototype.$type, newItem);
					if (hierarchy != null) {
						var measureList = $.ig.util.cast($.ig.MeasureList.prototype.$type, filters.where$1($.ig.ICoreOlapElement.prototype.$type, function (x) { return $.ig.util.cast($.ig.MeasureList.prototype.$type, x) !== null; }).firstOrDefault$1($.ig.ICoreOlapElement.prototype.$type));
						if (measureList != null && $self.measureListIndex() >= changedEventArgs.newStartingIndex()) {
							$self.measureListIndex($self.measureListIndex() + 1);
						}

					}

				}

				break;
			case $.ig.NotifyCollectionChangedAction.prototype.remove:
				var en1 = changedEventArgs.oldItems().getEnumerator();
				while (en1.moveNext()) {
					var oldItem = en1.current();
					var hierarchy1 = $.ig.util.cast($.ig.Hierarchy.prototype.$type, oldItem);
					if (hierarchy1 != null) {
						var measureList1 = $.ig.util.cast($.ig.MeasureList.prototype.$type, filters.where$1($.ig.ICoreOlapElement.prototype.$type, function (x) { return $.ig.util.cast($.ig.MeasureList.prototype.$type, x) !== null; }).firstOrDefault$1($.ig.ICoreOlapElement.prototype.$type));
						if (measureList1 != null && $self.measureListIndex() > changedEventArgs.oldStartingIndex()) {
							$self.measureListIndex($self.measureListIndex() - 1);
						}

					}

				}

				break;
		}

	}

	, 
	updateMeasureList: function () {
		var $self = this;
		var measureListAxis;
		if ($self.measureListLocation() == $.ig.MeasureListLocation.prototype.columns) {
			measureListAxis = $self.columnAxis();

		} else {
			measureListAxis = $self.rowAxis();
		}

		var measureList = null;
		var measureListIndex = 0;
		var en = measureListAxis.getEnumerator();
		while (en.moveNext()) {
			var coreOlapElement = en.current();
			measureList = $.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement);
			if (measureList != null) {
				break;
			}

			measureListIndex++;
		}

		if ($self.measures().count() > 1) {
			if (measureList == null) {
				measureList = (function () { var $ret = new $.ig.MeasureList();
				$ret.measures($self.measures()); return $ret;}());
				if ($self.measureListIndex() < 0 || $self.measureListIndex() > measureListAxis.count()) {
					$self.__measureListIndex = measureListAxis.count();
					measureListAxis.add(measureList);

				} else {
					measureListAxis.insert($self.measureListIndex(), measureList);
				}


			} else {
				if (measureListIndex != $self.measureListIndex()) {
					measureListAxis.removeAt(measureListIndex);
					if ($self.measureListIndex() > measureListAxis.count()) {
						$self.__measureListIndex = measureListAxis.count();
						measureListAxis.add(measureList);

					} else {
						measureListAxis.insert($self.measureListIndex(), measureList);
					}

				}

			}


		} else {
			if (measureList != null) {
				measureListAxis.removeAt(measureListIndex);
			}

		}

	}

	, 
	getPositionsToExpand: function () {
		return this.__positionsToExpand;
	}

	, 
	getPositionsToCollapse: function () {
		return this.__positionsToCollapse;
	}

	, 
	addCoreElementToAxis$1: function ($tItem, elementUniqueName, axisItems, elementType) {
		var $self = this;
		var predicate = function (ce) { return (ce).uniqueName() == elementUniqueName; };
		var coreElement = $self.getCoreElement(predicate, elementType);
		if (coreElement != null && !axisItems.contains($.ig.Object.prototype.$type, coreElement)) {
			axisItems.add(coreElement);
		}

	}

	, 
	loadExpandedMemberSiblings: function (positionsToExpand) {
		var $self = this;
		var levelNames = new $.ig.List$1(String, 0);
		var en = positionsToExpand.getEnumerator();
		while (en.moveNext()) {
			var positionInfo = en.current();
			var axisMember = $self.getResultAxis(positionInfo.axisName(), $self.result()).tuples().__inner[positionInfo.tupleIndex()].members().item(positionInfo.memberIndex());
			var nextLevel = $self.getCoreElement(function (l) { return (l).hierarchyUniqueName() == axisMember.hierarchyUniqueName() && (l).depth() == axisMember.levelNumber() + 1; }, $.ig.Level.prototype.$type);
			if (nextLevel != null && !$self.cubeCache().isLevelLoaded(nextLevel.uniqueName()) && !levelNames.contains(nextLevel.uniqueName())) {
				levelNames.add(nextLevel.uniqueName());
			}

		}

		if (levelNames.count() > 0) {
			var loadLevelTasks = new Array(levelNames.count());
			for (var i = 0; i < levelNames.count(); i++) {
				loadLevelTasks[i] = $self.getMembersOfLevel(levelNames.item(i));
			}

			return new $.ig.TaskFactory().continueWhenAll$1($.ig.Array.prototype.$type, loadLevelTasks, function (t) { return t; });
		}

		var tcs = new $.ig.TaskCompletionSource$1($.ig.Array.prototype.$type, 0);
		tcs.setResult(new Array(0));
		return tcs.task();
	}

	, 
	removeMeasureList: function () {
		var measureListAxis;
		if (this.measureListLocation() == $.ig.MeasureListLocation.prototype.columns) {
			measureListAxis = this.columnAxis();

		} else {
			measureListAxis = this.rowAxis();
		}

		if (measureListAxis == null) {
			return;
		}

		var measureList = null;
		var measureListIndex = 0;
		var en = measureListAxis.getEnumerator();
		while (en.moveNext()) {
			var coreOlapElement = en.current();
			measureList = $.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement);
			if (measureList != null) {
				break;
			}

			measureListIndex++;
		}

		if (measureList != null) {
			this.isMeasureListLocationChanged(true);
			measureListAxis.removeAt(measureListIndex);
		}

	}

	, 
	toArrayListCollection$1: function ($t, enumerable) {
		var res = new $.ig.ArrayListCollection$1($t);
		var en = enumerable.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			res.add(item);
		}

		return res;
	}

	, 
	findAxisElement: function (hierarchyUniqueName, filtersCollection) {
		var $self = this;
		var axisElement = $self.columnFilters().where$1($.ig.AxisElement.prototype.$type, function (ae) { return ae.name() == hierarchyUniqueName; }).firstOrDefault$1($.ig.AxisElement.prototype.$type);
		if (axisElement != null) {
			filtersCollection = $self.columnFilters();
			return {
				ret: axisElement, 
				filtersCollection: filtersCollection
			};
		}

		axisElement = $self.rowFilters().where$1($.ig.AxisElement.prototype.$type, function (ae) { return ae.name() == hierarchyUniqueName; }).firstOrDefault$1($.ig.AxisElement.prototype.$type);
		if (axisElement != null) {
			filtersCollection = $self.rowFilters();
			return {
				ret: axisElement, 
				filtersCollection: filtersCollection
			};
		}

		axisElement = $self.filterFilters().where$1($.ig.AxisElement.prototype.$type, function (ae) { return ae.name() == hierarchyUniqueName; }).firstOrDefault$1($.ig.AxisElement.prototype.$type);
		if (axisElement != null) {
			filtersCollection = $self.filterFilters();
			return {
				ret: axisElement, 
				filtersCollection: filtersCollection
			};
		}

		filtersCollection = null;
		return {
			ret: null, 
			filtersCollection: filtersCollection
		};
		return {
			filtersCollection: filtersCollection
		};
	}
	, 
	$type: new $.ig.Type('OlapDataSource', $.ig.Object.prototype.$type, [$.ig.IOlapDataSource.prototype.$type])
}, true);

$.ig.util.defType('PositionInfo', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_axisName: null,
	axisName: function (value) {
		if (arguments.length === 1) {
			this._axisName = value;
			return value;
		} else {
			return this._axisName;
		}
	}

	, 
	_tupleIndex: 0,
	tupleIndex: function (value) {
		if (arguments.length === 1) {
			this._tupleIndex = value;
			return value;
		} else {
			return this._tupleIndex;
		}
	}

	, 
	_memberIndex: 0,
	memberIndex: function (value) {
		if (arguments.length === 1) {
			this._memberIndex = value;
			return value;
		} else {
			return this._memberIndex;
		}
	}
	, 
	$type: new $.ig.Type('PositionInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CubeMetaItemsCache', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

		this.__membersCache = new $.ig.Dictionary$2(String, $.ig.Tuple$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.Member.prototype.$type), 0);
		this.__membersIdCache = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Member.prototype.$type, 0);
		this.__membersForLevels = new $.ig.Dictionary$2(String, $.ig.IList$1.prototype.$type.specialize($.ig.Member.prototype.$type), 0);
		this.__membersForMember = new $.ig.Dictionary$2(String, $.ig.IList$1.prototype.$type.specialize($.ig.Member.prototype.$type), 0);
		this.__measuresCache = new $.ig.Dictionary$2(String, $.ig.Measure.prototype.$type, 0);
		this.__kpiMeasuresCache = new $.ig.Dictionary$2(String, $.ig.KpiMeasure.prototype.$type, 0);
		this.__loadedLevels = new $.ig.Dictionary$2(String, $.ig.Boolean.prototype.$type, 0);
		this.__loadedHierarchies = new $.ig.Dictionary$2(String, $.ig.Boolean.prototype.$type, 0);
	}, 
	__membersCache: null
	, 
	__membersIdCache: null
	, 
	__membersForLevels: null
	, 
	__membersForMember: null
	, 
	__measuresCache: null
	, 
	__kpiMeasuresCache: null
	, 
	__loadedLevels: null
	, 
	__loadedHierarchies: null

	, 
	_measures: null,
	measures: function (value) {
		if (arguments.length === 1) {
			this._measures = value;
			return value;
		} else {
			return this._measures;
		}
	}

	, 
	_kpiMeasures: null,
	kpiMeasures: function (value) {
		if (arguments.length === 1) {
			this._kpiMeasures = value;
			return value;
		} else {
			return this._kpiMeasures;
		}
	}

	, 
	_dimensionItems: null,
	dimensionItems: function (value) {
		if (arguments.length === 1) {
			this._dimensionItems = value;
			return value;
		} else {
			return this._dimensionItems;
		}
	}

	, 
	_hierarchyItems: null,
	hierarchyItems: function (value) {
		if (arguments.length === 1) {
			this._hierarchyItems = value;
			return value;
		} else {
			return this._hierarchyItems;
		}
	}

	, 
	_levelItems: null,
	levelItems: function (value) {
		if (arguments.length === 1) {
			this._levelItems = value;
			return value;
		} else {
			return this._levelItems;
		}
	}

	, 
	_kpis: null,
	kpis: function (value) {
		if (arguments.length === 1) {
			this._kpis = value;
			return value;
		} else {
			return this._kpis;
		}
	}

	, 
	_measureGroupDimensions: null,
	measureGroupDimensions: function (value) {
		if (arguments.length === 1) {
			this._measureGroupDimensions = value;
			return value;
		} else {
			return this._measureGroupDimensions;
		}
	}

	, 
	_measureGroupDimensionsCache: null,
	measureGroupDimensionsCache: function (value) {
		if (arguments.length === 1) {
			this._measureGroupDimensionsCache = value;
			return value;
		} else {
			return this._measureGroupDimensionsCache;
		}
	}

	, 
	isLevelLoaded: function (levelUniqueName) {
		var $self = this;
		var loaded;
		if (!(function () { var $ret = $self.__loadedLevels.tryGetValue(levelUniqueName, loaded); loaded = $ret.value; return $ret.ret; }())) {
			return false;
		}

		return loaded;
	}

	, 
	setIsLevelLoaded: function (levelUniqueName) {
		this.__loadedLevels.item(levelUniqueName, true);
	}

	, 
	isHierarchyLoaded: function (hierarchyUniqueName) {
		var $self = this;
		var loaded;
		if (!(function () { var $ret = $self.__loadedHierarchies.tryGetValue(hierarchyUniqueName, loaded); loaded = $ret.value; return $ret.ret; }())) {
			return false;
		}

		return loaded;
	}

	, 
	setIsHierarchyLoaded: function (hierarchyUniqueName) {
		var $self = this;
		$self.__loadedHierarchies.item(hierarchyUniqueName, true);
		var en = $self.levelItems().where$1($.ig.Level.prototype.$type, function (l) { return l.hierarchyUniqueName() == hierarchyUniqueName; }).getEnumerator();
		while (en.moveNext()) {
			var level = en.current();
			$self.setIsLevelLoaded(level.uniqueName());
		}

	}

	, 
	isMemberLoaded: function (levelUniqueName) {
		return this.__membersForMember.containsKey(levelUniqueName);
	}

	, 
	addMember: function (member) {
		var $self = this;
		var memberEntity;
		if (!(function () { var $ret = $self.__membersCache.tryGetValue(member.uniqueName(), memberEntity); memberEntity = $ret.value; return $ret.ret; }())) {
			var memberId = $self.__membersCache.count();
			memberEntity = new $.ig.Tuple$2($.ig.Number.prototype.$type, $.ig.Member.prototype.$type, memberId, member);
			$self.__membersCache.item(member.uniqueName(), memberEntity);
			$self.__membersIdCache.item(memberId, member);
			var membersForLevel;
			if (!(function () { var $ret = $self.__membersForLevels.tryGetValue(member.levelUniqueName(), membersForLevel); membersForLevel = $ret.value; return $ret.ret; }())) {
				membersForLevel = new $.ig.ArrayListCollection$1($.ig.Member.prototype.$type);
				$self.__membersForLevels.item(member.levelUniqueName(), membersForLevel);
			}

			if (!String.isNullOrEmpty(member.parentUniqueName())) {
				var membersForMember;
				if (!(function () { var $ret = $self.__membersForMember.tryGetValue(member.parentUniqueName(), membersForMember); membersForMember = $ret.value; return $ret.ret; }())) {
					membersForMember = new $.ig.List$1($.ig.Member.prototype.$type, 0);
					$self.__membersForMember.item(member.parentUniqueName(), membersForMember);
				}

				membersForMember.add(member);
			}

			membersForLevel.add(member);
		}

		return memberEntity.item1();
	}

	, 
	tryGetMemberOrdinal: function (memberUniqueName, memberOrdinal) {
		var $self = this;
		var memberEntity;
		if ((function () { var $ret = $self.__membersCache.tryGetValue(memberUniqueName, memberEntity); memberEntity = $ret.value; return $ret.ret; }())) {
			memberOrdinal = memberEntity.item1();
			return {
				ret: true, 
				memberOrdinal: memberOrdinal
			};
		}

		memberOrdinal = -1;
		return {
			ret: false, 
			memberOrdinal: memberOrdinal
		};
		return {
			memberOrdinal: memberOrdinal
		};
	}

	, 
	tryGetMember1: function (memberUniqueName, member) {
		var $self = this;
		var memberEntity;
		if ((function () { var $ret = $self.__membersCache.tryGetValue(memberUniqueName, memberEntity); memberEntity = $ret.value; return $ret.ret; }())) {
			member = memberEntity.item2();
			return {
				ret: true, 
				member: member
			};
		}

		member = null;
		return {
			ret: false, 
			member: member
		};
		return {
			member: member
		};
	}

	, 
	tryGetMember: function (memberId, member) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.__membersIdCache.tryGetValue(memberId, member); member = $ret.value; return $ret.ret; }()), 
			member: member
		};
		return {
			member: member
		};
	}

	, 
	tryGetMembersForMember: function (levelUniqueName, members) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.__membersForMember.tryGetValue(levelUniqueName, members); members = $ret.value; return $ret.ret; }()), 
			members: members
		};
		return {
			members: members
		};
	}

	, 
	tryGetMembersForLevel: function (levelUniqueName, members) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.__membersForLevels.tryGetValue(levelUniqueName, members); members = $ret.value; return $ret.ret; }()), 
			members: members
		};
		return {
			members: members
		};
	}

	, 
	tryGetMeasure: function (uniqueName, measure) {
		var $self = this;
		if (!(function () { var $ret = $self.__measuresCache.tryGetValue(uniqueName, measure); measure = $ret.value; return $ret.ret; }())) {
			measure = $self.measures().where$1($.ig.Measure.prototype.$type, function (m) { return m.uniqueName() == uniqueName; }).firstOrDefault$1($.ig.Measure.prototype.$type);
			if (measure == null) {
				return {
					ret: false, 
					measure: measure
				};
			}

			$self.__measuresCache.add(uniqueName, measure);
		}

		return {
			ret: true, 
			measure: measure
		};
		return {
			measure: measure
		};
	}

	, 
	tryGetKpiMeasure: function (uniqueName, measure) {
		var $self = this;
		if (!(function () { var $ret = $self.__kpiMeasuresCache.tryGetValue(uniqueName, measure); measure = $ret.value; return $ret.ret; }())) {
			measure = $self.kpiMeasures().where$1($.ig.KpiMeasure.prototype.$type, function (m) { return m.uniqueName() == uniqueName; }).firstOrDefault$1($.ig.KpiMeasure.prototype.$type);
			if (measure == null) {
				return {
					ret: false, 
					measure: measure
				};
			}

			$self.__kpiMeasuresCache.add(uniqueName, measure);
		}

		return {
			ret: true, 
			measure: measure
		};
		return {
			measure: measure
		};
	}
	, 
	$type: new $.ig.Type('CubeMetaItemsCache', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MetaTreeHelper', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	getDimensionMetaItems: function (dimensions, measures, kpis, hierarchies, levels, createMeasureGroupFolders, itemsCache) {
		var $self = this;
		var metaItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		var itemPosition = new $.ig.HierarchyItemPosition();
		itemPosition.hierarchyIndex(0);
		itemPosition.levelIndex(0);
		var hierarchiesList = new $.ig.List$1($.ig.Hierarchy.prototype.$type, 0);
		var en = hierarchies.getEnumerator();
		while (en.moveNext()) {
			var hierarchy = en.current();
			hierarchiesList.add(hierarchy);
		}

		var levelsList = new $.ig.List$1($.ig.Level.prototype.$type, 0);
		var en1 = levels.getEnumerator();
		while (en1.moveNext()) {
			var level = en1.current();
			levelsList.add(level);
		}

		var en2 = dimensions.getEnumerator();
		while (en2.moveNext()) {
			var dimension = en2.current();
			var hierarchiesMetaItems = $.ig.MetaTreeHelper.prototype.getHierarchyMetaItems(hierarchiesList, levelsList, dimension, itemPosition);
			if (dimension.dimensionType() != $.ig.DimensionType.prototype.measure) {
				var dimensionMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
				$ret.type($.ig.OlapMetadataTreeItemType.prototype.dimension);
				$ret.caption(dimension.caption());
				$ret.item(dimension); return $ret;}());
				$.ig.MetaTreeHelper.prototype.setMetaItemChildren(dimensionMetaItem, hierarchiesMetaItems);
				metaItems.add(dimensionMetaItem);

			} else {
				var measuresMetaItem = $.ig.MetaTreeHelper.prototype.getMeasureMetadataItem(measures, dimension);
				metaItems.insert(0, measuresMetaItem);
				if (kpis.count$1($.ig.Kpi.prototype.$type) > 0) {
					var kpiDimension = (function () { var $ret = new $.ig.KpiDimension();
					$ret.caption("Kpis"); return $ret;}());
					var kpisMetaItem = $.ig.MetaTreeHelper.prototype.getKpiMetadataItem(kpis, kpiDimension, itemsCache);
					kpisMetaItem.type($.ig.OlapMetadataTreeItemType.prototype.kpiRoot);
					metaItems.insert(1, kpisMetaItem);
				}

			}

		}

		return metaItems;
	}

	, 
	setMetaItemChildren: function (metaItem, children) {
		var $self = this;
		if (children.count() > 0) {
			var folders = children.where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() == $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).toArray$1($.ig.OlapMetadataTreeItem.prototype.$type);
			var items = children.where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() != $.ig.OlapMetadataTreeItemType.prototype.group; }).toArray$1($.ig.OlapMetadataTreeItem.prototype.$type);
			var childrenArray = new Array(folders.length + items.length);
			for (var i = 0; i < folders.length; i++) {
				childrenArray[i] = folders[i];
			}

			for (var i1 = 0; i1 < items.length; i1++) {
				childrenArray[folders.length + i1] = items[i1];
			}

			metaItem.children(childrenArray);
		}

	}

	, 
	getHierarchyMetaItems: function (hierarchiesList, levelsList, dimension, itemPosition) {
		var $self = this;
		var hierarchyFolders = new $.ig.Dictionary$2(String, $.ig.Tuple$2.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type)), 0);
		var hierarchiesMetaItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		var hierarchy = hierarchiesList.item(itemPosition.hierarchyIndex());
		while (hierarchy.dimensionUniqueName() != dimension.uniqueName()) {
			itemPosition.hierarchyIndex(itemPosition.hierarchyIndex() + 1);
			hierarchy = hierarchiesList.item(itemPosition.hierarchyIndex());

		}
		while (hierarchy.dimensionUniqueName() == dimension.uniqueName()) {
			var upperTuple = null;
			if (!String.isNullOrEmpty(hierarchy.hierarchyDisplayFolder())) {
				var folderNamePart = String.empty();
				var folderNames = $.ig.MetaTreeHelper.prototype.parseFolderPath(hierarchy.hierarchyDisplayFolder());
				for (var i = 0; i < folderNames.length; i++) {
					var folderName = folderNames[i];
					folderNamePart += folderName + "\\";
					var folderTuple;
					if (!(function () { var $ret = hierarchyFolders.tryGetValue(folderNamePart, folderTuple); folderTuple = $ret.value; return $ret.ret; }())) {
						var folderMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
						$ret.type($.ig.OlapMetadataTreeItemType.prototype.group);
						$ret.caption(folderName); return $ret;}());
						folderTuple = new $.ig.Tuple$2($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type), folderMetaItem, new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0));
						hierarchyFolders.add(folderNamePart, folderTuple);
						if (upperTuple != null) {
							upperTuple.item2().add(folderMetaItem);

						} else {
							hierarchiesMetaItems.add(folderMetaItem);
						}

					}

					upperTuple = folderTuple;
				}

			}

			var metadataItemType;
			switch (hierarchy.hierarchyOrigin()) {
				case $.ig.HierarchyOrigin.prototype.systemEnabled:
					metadataItemType = $.ig.OlapMetadataTreeItemType.prototype.systemEnabledHierarchy;
					break;
				case $.ig.HierarchyOrigin.prototype.userDefined:
					metadataItemType = $.ig.OlapMetadataTreeItemType.prototype.userDefinedHierarchy;
					break;
				default:
					metadataItemType = $.ig.OlapMetadataTreeItemType.prototype.parentChildHierarchy;
					break;
			}

			var levelMetaItems = $.ig.MetaTreeHelper.prototype.getLevelMetaItems(levelsList, hierarchy, itemPosition);
			var hierarchyMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
			$ret.type(metadataItemType);
			$ret.caption(hierarchy.caption());
			$ret.item(hierarchy); return $ret;}());
			$.ig.MetaTreeHelper.prototype.setMetaItemChildren(hierarchyMetaItem, levelMetaItems);
			if (upperTuple != null) {
				upperTuple.item2().add(hierarchyMetaItem);

			} else {
				hierarchiesMetaItems.add(hierarchyMetaItem);
			}

			if (itemPosition.hierarchyIndex() + 1 >= hierarchiesList.count()) {
				break;
			}

			itemPosition.hierarchyIndex(itemPosition.hierarchyIndex() + 1);
			hierarchy = hierarchiesList.item(itemPosition.hierarchyIndex());

		}
		var en = hierarchyFolders.values().getEnumerator();
		while (en.moveNext()) {
			var metaItemTuple = en.current();
			var metaItem = metaItemTuple.item1();
			$.ig.MetaTreeHelper.prototype.setMetaItemChildren(metaItem, metaItemTuple.item2());
		}

		return hierarchiesMetaItems;
	}

	, 
	getLevelMetaItems: function (levelsList, hierarchy, itemPosition) {
		var $self = this;
		var levelMetaItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		if (levelsList == null || levelsList.count() == 0) {
			return levelMetaItems;
		}

		var level = levelsList.item(itemPosition.levelIndex());
		while (level.hierarchyUniqueName() != hierarchy.uniqueName()) {
			itemPosition.levelIndex(itemPosition.levelIndex() + 1);
			level = levelsList.item(itemPosition.levelIndex());

		}
		while (level.hierarchyUniqueName() == hierarchy.uniqueName()) {
			var itemType;
			switch (level.depth()) {
				case 0:
				case 1:
					itemType = $.ig.OlapMetadataTreeItemType.prototype.level1;
					break;
				case 2:
					itemType = $.ig.OlapMetadataTreeItemType.prototype.level2;
					break;
				case 3:
					itemType = $.ig.OlapMetadataTreeItemType.prototype.level3;
					break;
				case 4:
					itemType = $.ig.OlapMetadataTreeItemType.prototype.level4;
					break;
				default:
					itemType = $.ig.OlapMetadataTreeItemType.prototype.level5;
					break;
			}

			var levelMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
			$ret.type(itemType);
			$ret.caption(level.caption());
			$ret.item(level); return $ret;}());
			levelMetaItems.add(levelMetaItem);
			if (itemPosition.levelIndex() + 1 >= levelsList.count()) {
				break;
			}

			itemPosition.levelIndex(itemPosition.levelIndex() + 1);
			level = levelsList.item(itemPosition.levelIndex());

		}
		return levelMetaItems;
	}

	, 
	getMeasureMetadataItem: function (measures, measureDimension) {
		var $self = this;
		var subFolders = new $.ig.Dictionary$2(String, $.ig.Tuple$2.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type)), 0);
		var measuresRoot = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
		$ret.type($.ig.OlapMetadataTreeItemType.prototype.measure);
		$ret.caption(measureDimension.caption());
		$ret.item(measureDimension); return $ret;}());
		var rootTuple = new $.ig.Tuple$2($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type), measuresRoot, new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0));
		var en = measures.getEnumerator();
		while (en.moveNext()) {
			var measure = en.current();
			if ($.ig.util.cast($.ig.KpiMeasure.prototype.$type, measure) !== null) {
				continue;
			}

			var measureGroupTuple = rootTuple;
			if (!String.isNullOrEmpty(measure.measureGroupName())) {
				if (!(function () { var $ret = subFolders.tryGetValue(measure.measureGroupName(), measureGroupTuple); measureGroupTuple = $ret.value; return $ret.ret; }())) {
					var groupMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
					$ret.type($.ig.OlapMetadataTreeItemType.prototype.group);
					$ret.caption(measure.measureGroupName()); return $ret;}());
					measureGroupTuple = new $.ig.Tuple$2($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type), groupMetaItem, new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0));
					subFolders.add(measure.measureGroupName(), measureGroupTuple);
					rootTuple.item2().add(measureGroupTuple.item1());
				}

			}

			var upperTuple = measureGroupTuple;
			if (!String.isNullOrEmpty(measure.measureDisplayFolder())) {
				var folderNamePart = measure.measureGroupName();
				var folderNames = $.ig.MetaTreeHelper.prototype.parseFolderPath(measure.measureDisplayFolder());
				for (var i = 0; i < folderNames.length; i++) {
					var folderName = folderNames[i];
					folderNamePart += "\\" + folderName;
					var folderTuple;
					if (!(function () { var $ret = subFolders.tryGetValue(folderNamePart, folderTuple); folderTuple = $ret.value; return $ret.ret; }())) {
						var folderMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
						$ret.type($.ig.OlapMetadataTreeItemType.prototype.group);
						$ret.caption(folderName); return $ret;}());
						folderTuple = new $.ig.Tuple$2($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type), folderMetaItem, new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0));
						subFolders.add(folderNamePart, folderTuple);
						upperTuple.item2().add(folderMetaItem);
					}

					upperTuple = folderTuple;
				}

			}

			var measureMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
			$ret.type($.ig.OlapMetadataTreeItemType.prototype.measure);
			$ret.caption(measure.caption());
			$ret.item(measure); return $ret;}());
			upperTuple.item2().add(measureMetaItem);
		}

		var measureItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		var en1 = rootTuple.item2().where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() == $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).getEnumerator();
		while (en1.moveNext()) {
			var item = en1.current();
			measureItems.add(item);
		}

		var en2 = rootTuple.item2().where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() != $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).getEnumerator();
		while (en2.moveNext()) {
			var item1 = en2.current();
			measureItems.add(item1);
		}

		$.ig.MetaTreeHelper.prototype.setMetaItemChildren(measuresRoot, measureItems);
		var en3 = subFolders.values().getEnumerator();
		while (en3.moveNext()) {
			var metaItemTuple = en3.current();
			var itemsList = metaItemTuple.item2();
			var groups = itemsList.where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() == $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).toList$1($.ig.OlapMetadataTreeItem.prototype.$type);
			var singleItems = itemsList.where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() != $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).toList$1($.ig.OlapMetadataTreeItem.prototype.$type);
			var childItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
			for (var i1 = 0; i1 < groups.count(); i1++) {
				childItems.add(groups.item(i1));
			}

			for (var j = 0; j < singleItems.count(); j++) {
				childItems.add(singleItems.item(j));
			}

			var metaItem = metaItemTuple.item1();
			$.ig.MetaTreeHelper.prototype.setMetaItemChildren(metaItem, childItems);
		}

		return measuresRoot;
	}

	, 
	getKpiMetadataItem: function (kpis, kpiDimension, itemsCache) {
		var $self = this;
		var subFolders = new $.ig.Dictionary$2(String, $.ig.Tuple$2.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type)), 0);
		var measures = itemsCache.measures().toList$1($.ig.Measure.prototype.$type);
		itemsCache.measures(measures);
		var kpiMeasures = new $.ig.List$1($.ig.KpiMeasure.prototype.$type, 0);
		itemsCache.kpiMeasures(kpiMeasures);
		var kpisRoot = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
		$ret.type($.ig.OlapMetadataTreeItemType.prototype.kpiRoot);
		$ret.caption(kpiDimension.caption());
		$ret.item(kpiDimension); return $ret;}());
		var rootTuple = new $.ig.Tuple$2($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type), kpisRoot, new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0));
		var en = kpis.getEnumerator();
		while (en.moveNext()) {
			var kpi = en.current();
			var upperTuple = rootTuple;
			if (!String.isNullOrEmpty(kpi.kpiDisplayFolder())) {
				var folderNamePart = String.empty();
				var folderNames = $.ig.MetaTreeHelper.prototype.parseFolderPath(kpi.kpiDisplayFolder());
				for (var i = 0; i < folderNames.length; i++) {
					var folderName = folderNames[i];
					folderNamePart += "\\" + folderName;
					var folderTuple;
					if (!(function () { var $ret = subFolders.tryGetValue(folderNamePart, folderTuple); folderTuple = $ret.value; return $ret.ret; }())) {
						var folderMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
						$ret.type($.ig.OlapMetadataTreeItemType.prototype.group);
						$ret.caption(folderName); return $ret;}());
						folderTuple = new $.ig.Tuple$2($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type), folderMetaItem, new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0));
						subFolders.add(folderNamePart, folderTuple);
						upperTuple.item2().add(folderMetaItem);
					}

					upperTuple = folderTuple;
				}

			}

			var kpiMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
			$ret.type($.ig.OlapMetadataTreeItemType.prototype.kpi);
			$ret.caption(kpi.caption());
			$ret.item(kpi); return $ret;}());
			if (!String.isNullOrEmpty(kpi.kpiValue())) {
				var measure = null;
				var itemType = $.ig.OlapMetadataTreeItemType.prototype.measure;
				var caption = "Value";
				if (!(function () { var $ret = itemsCache.tryGetMeasure(kpi.kpiValue(), measure); measure = $ret.measure; return $ret.ret; }())) {
					itemType = $.ig.OlapMetadataTreeItemType.prototype.kpiValue;
					measure = $.ig.KpiMeasure.prototype.createKpiValueMeasure(kpi);
					measures.add(measure);
					kpiMeasures.add(measure);

				} else {
					caption += " (" + measure.caption() + ")";
				}

				kpiMetaItem.addChild((function () { var $ret = new $.ig.OlapMetadataTreeItem();
				$ret.caption(caption);
				$ret.item(measure);
				$ret.type(itemType); return $ret;}()));
			}

			if (!String.isNullOrEmpty(kpi.kpiGoal())) {
				var measure1 = null;
				var itemType1 = $.ig.OlapMetadataTreeItemType.prototype.measure;
				var caption1 = "Goal";
				if (!(function () { var $ret = itemsCache.tryGetMeasure(kpi.kpiGoal(), measure1); measure1 = $ret.measure; return $ret.ret; }())) {
					itemType1 = $.ig.OlapMetadataTreeItemType.prototype.kpiGoal;
					measure1 = $.ig.KpiMeasure.prototype.createKpiGoalMeasure(kpi);
					measures.add(measure1);
					kpiMeasures.add(measure1);

				} else {
					caption1 += " (" + measure1.caption() + ")";
				}

				kpiMetaItem.addChild((function () { var $ret = new $.ig.OlapMetadataTreeItem();
				$ret.caption(caption1);
				$ret.item(measure1);
				$ret.type(itemType1); return $ret;}()));
			}

			if (!String.isNullOrEmpty(kpi.kpiStatus())) {
				var measure2 = $.ig.KpiMeasure.prototype.createKpiStatusMeasure(kpi);
				measures.add(measure2);
				kpiMeasures.add(measure2);
				kpiMetaItem.addChild((function () { var $ret = new $.ig.OlapMetadataTreeItem();
				$ret.caption("Status");
				$ret.item(measure2);
				$ret.type($.ig.OlapMetadataTreeItemType.prototype.kpiStatus); return $ret;}()));
			}

			if (!String.isNullOrEmpty(kpi.kpiTrend())) {
				var measure3 = $.ig.KpiMeasure.prototype.createKpiTrendMeasure(kpi);
				measures.add(measure3);
				kpiMeasures.add(measure3);
				kpiMetaItem.addChild((function () { var $ret = new $.ig.OlapMetadataTreeItem();
				$ret.caption("Trend");
				$ret.item(measure3);
				$ret.type($.ig.OlapMetadataTreeItemType.prototype.kpiTrend); return $ret;}()));
			}

			if (!String.isNullOrEmpty(kpi.kpiWeight())) {
				var measure4 = $.ig.KpiMeasure.prototype.createKpiWeightMeasure(kpi);
				measures.add(measure4);
				kpiMeasures.add(measure4);
				kpiMetaItem.addChild((function () { var $ret = new $.ig.OlapMetadataTreeItem();
				$ret.caption("Weight");
				$ret.item(measure4);
				$ret.type($.ig.OlapMetadataTreeItemType.prototype.kpiWeight); return $ret;}()));
			}

			upperTuple.item2().add(kpiMetaItem);
		}

		var kpiItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		var en1 = rootTuple.item2().where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() == $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).getEnumerator();
		while (en1.moveNext()) {
			var item = en1.current();
			kpiItems.add(item);
		}

		var en2 = rootTuple.item2().where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() != $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).getEnumerator();
		while (en2.moveNext()) {
			var item1 = en2.current();
			kpiItems.add(item1);
		}

		$.ig.MetaTreeHelper.prototype.setMetaItemChildren(kpisRoot, kpiItems);
		var en3 = subFolders.values().getEnumerator();
		while (en3.moveNext()) {
			var metaItemTuple = en3.current();
			var itemsList = metaItemTuple.item2();
			var groups = itemsList.where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() == $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).toList$1($.ig.OlapMetadataTreeItem.prototype.$type);
			var singleItems = itemsList.where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() != $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).toList$1($.ig.OlapMetadataTreeItem.prototype.$type);
			var childItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
			for (var i1 = 0; i1 < groups.count(); i1++) {
				childItems.add(groups.item(i1));
			}

			for (var j = 0; j < singleItems.count(); j++) {
				childItems.add(singleItems.item(j));
			}

			var metaItem = metaItemTuple.item1();
			$.ig.MetaTreeHelper.prototype.setMetaItemChildren(metaItem, childItems);
		}

		return kpisRoot;
	}

	, 
	parseFolderPath: function (folderPath) {
		var folders = folderPath.split('\\');
		return folders;
	}
	, 
	$type: new $.ig.Type('MetaTreeHelper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('HierarchyItemPosition', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_hierarchyIndex: 0,
	hierarchyIndex: function (value) {
		if (arguments.length === 1) {
			this._hierarchyIndex = value;
			return value;
		} else {
			return this._hierarchyIndex;
		}
	}

	, 
	_levelIndex: 0,
	levelIndex: function (value) {
		if (arguments.length === 1) {
			this._levelIndex = value;
			return value;
		} else {
			return this._levelIndex;
		}
	}
	, 
	$type: new $.ig.Type('HierarchyItemPosition', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DataSourceBaseOptions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_cube: null,
	cube: function (value) {
		if (arguments.length === 1) {
			this._cube = value;
			return value;
		} else {
			return this._cube;
		}
	}

	, 
	_measureGroup: null,
	measureGroup: function (value) {
		if (arguments.length === 1) {
			this._measureGroup = value;
			return value;
		} else {
			return this._measureGroup;
		}
	}

	, 
	_measures: null,
	measures: function (value) {
		if (arguments.length === 1) {
			this._measures = value;
			return value;
		} else {
			return this._measures;
		}
	}

	, 
	_filters: null,
	filters: function (value) {
		if (arguments.length === 1) {
			this._filters = value;
			return value;
		} else {
			return this._filters;
		}
	}

	, 
	_columns: null,
	columns: function (value) {
		if (arguments.length === 1) {
			this._columns = value;
			return value;
		} else {
			return this._columns;
		}
	}

	, 
	_rows: null,
	rows: function (value) {
		if (arguments.length === 1) {
			this._rows = value;
			return value;
		} else {
			return this._rows;
		}
	}
	, 
	$type: new $.ig.Type('DataSourceBaseOptions', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('AxisDefinitionParser', 'Object', {
	init: function (initString) {



		$.ig.Object.prototype.init.call(this);
			this.position(-1);
			this.initString(initString);
	}

	, 
	_isFilter: false,
	isFilter: function (value) {
		if (arguments.length === 1) {
			this._isFilter = value;
			return value;
		} else {
			return this._isFilter;
		}
	}

	, 
	_elementName: null,
	elementName: function (value) {
		if (arguments.length === 1) {
			this._elementName = value;
			return value;
		} else {
			return this._elementName;
		}
	}

	, 
	_position: 0,
	position: function (value) {
		if (arguments.length === 1) {
			this._position = value;
			return value;
		} else {
			return this._position;
		}
	}

	, 
	_initString: null,
	initString: function (value) {
		if (arguments.length === 1) {
			this._initString = value;
			return value;
		} else {
			return this._initString;
		}
	}

	, 
	readNextElement: function () {
		if (this.position() == this.initString().length - 1) {
			return false;
		}

		var elementBeginIndex = -1;
		var elementEndIndex = -1;
		var terminationElementFound = false;
		while (this.position() + 1 < this.initString().length) {
			this.position(this.position() + 1);
			var value = this.initString().substr(this.position(), 1);
			switch (value) {
				case $.ig.AxisDefinitionParser.prototype.elementBegin:
					if (elementBeginIndex == -1) {
						elementBeginIndex = this.position();
					}

					break;
				case $.ig.AxisDefinitionParser.prototype.elementEnd:
					elementEndIndex = this.position();
					while (this.position() + 1 < this.initString().length) {
						value = this.initString().substr(this.position() + 1, 1);
						switch (value) {
							case $.ig.AxisDefinitionParser.prototype.elementEnd:
								elementEndIndex = this.position() + 1;
								break;
							case $.ig.AxisDefinitionParser.prototype.elementSeparator:
								if ($.ig.AxisDefinitionParser.prototype.elementEnd == this.initString().substr(this.position(), 1)) {
									terminationElementFound = true;
								}

								break;
							case $.ig.AxisDefinitionParser.prototype.filterGroupBegin:
							case $.ig.AxisDefinitionParser.prototype.filterGroupEnd:
								terminationElementFound = true;
								break;
						}

						if (terminationElementFound) {
							break;
						}

						this.position(this.position() + 1);

					}
					terminationElementFound = true;
					break;
				case $.ig.AxisDefinitionParser.prototype.elementSeparator:
					terminationElementFound = true;
					break;
				case $.ig.AxisDefinitionParser.prototype.filterGroupBegin:
					this.isFilter(true);
					break;
				case $.ig.AxisDefinitionParser.prototype.filterGroupEnd:
					$.ig.Debug.prototype.assert(this.isFilter());
					terminationElementFound = true;
					this.isFilter(false);
					break;
			}

			if (terminationElementFound) {
				terminationElementFound = false;
				if (elementBeginIndex > -1 && elementEndIndex > -1) {
					break;
				}

			}


		}
		if (this.position() == this.initString().length - 1) {
			if (elementEndIndex == -1 || elementBeginIndex == -1) {
			return false;
			}

		}

		var elementValue = this.initString().substr(elementBeginIndex, elementEndIndex - elementBeginIndex + 1).trim();
		this.elementName(elementValue);
		return true;
	}

	, 
	parse: function () {
		var elementValues = new $.ig.List$1($.ig.AxisElement.prototype.$type, 0);
		var filterValues = null;
		while (this.readNextElement()) {
			if (!this.isFilter()) {
				filterValues = new $.ig.ArrayListCollection$1(String);
				var axisElement = new $.ig.AxisElement(this.elementName(), filterValues);
				elementValues.add(axisElement);

			} else if (filterValues != null) {
				filterValues.add(this.elementName());
			}



		}
		return elementValues;
	}
	, 
	$type: new $.ig.Type('AxisDefinitionParser', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('CoreOlapElementParser', 'Object', {
	init: function (elementName) {



		$.ig.Object.prototype.init.call(this);
			this.position(-1);
			this.initString(elementName);
	}

	, 
	_elementName: null,
	elementName: function (value) {
		if (arguments.length === 1) {
			this._elementName = value;
			return value;
		} else {
			return this._elementName;
		}
	}

	, 
	_position: 0,
	position: function (value) {
		if (arguments.length === 1) {
			this._position = value;
			return value;
		} else {
			return this._position;
		}
	}

	, 
	_initString: null,
	initString: function (value) {
		if (arguments.length === 1) {
			this._initString = value;
			return value;
		} else {
			return this._initString;
		}
	}

	, 
	readNextElement: function () {
		if (this.position() == this.initString().length - 1) {
			return false;
		}

		var elementBeginIndex = -1;
		var elementEndIndex = -1;
		var terminationElementFound = false;
		while (this.position() + 1 < this.initString().length) {
			this.position(this.position() + 1);
			var value = this.initString().substr(this.position(), 1);
			switch (value) {
				case $.ig.CoreOlapElementParser.prototype.elementBegin:
					if (elementBeginIndex == -1) {
						elementBeginIndex = this.position();
					}

					break;
				case $.ig.CoreOlapElementParser.prototype.elementEnd:
					elementEndIndex = this.position();
					while (this.position() + 1 < this.initString().length) {
						value = this.initString().substr(this.position() + 1, 1);
						switch (value) {
							case $.ig.CoreOlapElementParser.prototype.elementEnd:
								elementEndIndex = this.position() + 1;
								break;
							case $.ig.CoreOlapElementParser.prototype.elementSeparator:
								terminationElementFound = true;
								break;
						}

						if (terminationElementFound) {
							break;
						}

						this.position(this.position() + 1);

					}
					break;
				case $.ig.CoreOlapElementParser.prototype.elementSeparator:
					terminationElementFound = true;
					break;
			}

			if (terminationElementFound) {
				terminationElementFound = false;
				if (elementBeginIndex > -1 && elementEndIndex > -1) {
					break;
				}

			}


		}
		if (this.position() == this.initString().length - 1) {
			if (elementEndIndex == -1 || elementBeginIndex == -1) {
			return false;
			}

		}

		var elementValue = this.initString().substr(elementBeginIndex, elementEndIndex - elementBeginIndex + 1).trim();
		this.elementName(elementValue);
		return true;
	}

	, 
	getPartNames: function () {
		var elementValues = new $.ig.List$1(String, 0);
		while (this.readNextElement()) {
			elementValues.add(this.elementName());

		}
		return elementValues;
	}
	, 
	$type: new $.ig.Type('CoreOlapElementParser', $.ig.Object.prototype.$type)
}, true);






$.ig.util.defType('KeyValueItem', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_key: null,
	key: function (value) {
		if (arguments.length === 1) {
			this._key = value;
			return value;
		} else {
			return this._key;
		}
	}

	, 
	_value: null,
	value: function (value) {
		if (arguments.length === 1) {
			this._value = value;
			return value;
		} else {
			return this._value;
		}
	}
	, 
	$type: new $.ig.Type('KeyValueItem', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('AxisElement', 'Object', {
	init: function (name, memberNames) {



		$.ig.Object.prototype.init.call(this);
			this.name(name);
			this.memberNames(memberNames);
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_memberNames: null,
	memberNames: function (value) {
		if (arguments.length === 1) {
			this._memberNames = value;
			return value;
		} else {
			return this._memberNames;
		}
	}
	, 
	$type: new $.ig.Type('AxisElement', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MeasureGroupMetaItemsCache', 'Object', {
	__measureGroupDimensions: null
	, 
	__measureGroupMeasures: null
	, 
	__measureGroupKpis: null
	, 
	__measureGroupDimensionsCollection: null
	, 
	__dimensions: null
	, 
	__measures: null
	, 
	__kpis: null
	, 
	init: function (dimensions, measures, kpis, measureGroupDimensions) {



		$.ig.Object.prototype.init.call(this);
			this.__measureGroupDimensions = new $.ig.Dictionary$2(String, $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Dimension.prototype.$type), 0);
			this.__measureGroupMeasures = new $.ig.Dictionary$2(String, $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Measure.prototype.$type), 0);
			this.__measureGroupKpis = new $.ig.Dictionary$2(String, $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Kpi.prototype.$type), 0);
			this.__measureGroupDimensionsCollection = measureGroupDimensions;
			this.__dimensions = dimensions;
			this.__measures = measures;
			this.__kpis = kpis;
	}

	, 
	getMeasureGroupDimensions: function (measureGroupName) {
		var $self = this;
		var measureGroupDimensions;
		if (!(function () { var $ret = $self.__measureGroupDimensions.tryGetValue(measureGroupName, measureGroupDimensions); measureGroupDimensions = $ret.value; return $ret.ret; }())) {
			var dimensionNames = new $.ig.List$1(String, 0);
			var en = $self.__measureGroupDimensionsCollection.getEnumerator();
			while (en.moveNext()) {
				var measureGroupDimension = en.current();
				if (measureGroupDimension.measureGroupName() == measureGroupName) {
					dimensionNames.add(measureGroupDimension.dimensionUniqueName());
				}

			}

			var dimensions = new $.ig.List$1($.ig.Dimension.prototype.$type, 0);
			var en1 = $self.__dimensions.getEnumerator();
			while (en1.moveNext()) {
				var dimension = en1.current();
				if (dimensionNames.contains(dimension.uniqueName()) || dimension.dimensionType() == $.ig.DimensionType.prototype.measure) {
					dimensions.add(dimension);
				}

			}

			$self.__measureGroupDimensions.add(measureGroupName, dimensions);
			measureGroupDimensions = dimensions;
		}

		return measureGroupDimensions;
	}

	, 
	getMeasureGroupMeasures: function (measureGroupName) {
		var $self = this;
		var measureGroupMeasures;
		if (!(function () { var $ret = $self.__measureGroupMeasures.tryGetValue(measureGroupName, measureGroupMeasures); measureGroupMeasures = $ret.value; return $ret.ret; }())) {
			var measures = new $.ig.List$1($.ig.Measure.prototype.$type, 0);
			var en = $self.__measures.getEnumerator();
			while (en.moveNext()) {
				var measure = en.current();
				if (measure.measureGroupName() == measureGroupName) {
					measures.add(measure);
				}

			}

			$self.__measureGroupMeasures.add(measureGroupName, measures);
			measureGroupMeasures = measures;
		}

		return measureGroupMeasures;
	}

	, 
	getMeasureGroupKpis: function (measureGroupName) {
		var $self = this;
		var measureGroupKpis;
		if (!(function () { var $ret = $self.__measureGroupKpis.tryGetValue(measureGroupName, measureGroupKpis); measureGroupKpis = $ret.value; return $ret.ret; }())) {
			var kpis = new $.ig.List$1($.ig.Kpi.prototype.$type, 0);
			var en = $self.__kpis.getEnumerator();
			while (en.moveNext()) {
				var kpi = en.current();
				if (kpi.measureGroupName() == measureGroupName) {
					kpis.add(kpi);
				}

			}

			$self.__measureGroupKpis.add(measureGroupName, kpis);
			measureGroupKpis = kpis;
		}

		return measureGroupKpis;
	}
	, 
	$type: new $.ig.Type('MeasureGroupMetaItemsCache', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('PositionItemInfo$2', 'Dictionary$2', {
	$tKey: null, 
	$tSortKey: null, 
	init: function ($tKey, $tSortKey, positionItem, positionIndex, positionItemIndex, positionSize) {


		this.__parentsToExpand = new $.ig.Dictionary$2(this.$tKey, $.ig.Object.prototype.$type, 0);

		this.$tKey = $tKey
		this.$tSortKey = $tSortKey
		this.$type = this.$type.specialize(this.$tKey, this.$tSortKey);
		$.ig.Dictionary$2.prototype.init.call(this, this.$tKey, $.ig.PositionItemInfo$2.prototype.$type.specialize(this.$tKey, this.$tSortKey));
			this.positionItem(positionItem);
			this.positionIndex(positionIndex);
			this.positionItemIndex(positionItemIndex);
			this.positionItemDepth(0);
			this.positionItemDepthMin(-1);
			this.positionItemDepthMax(Number.MAX_VALUE);
			this.positionSize(positionSize);
			if (positionItem != null) {
				this.positionItemDepth(this.positionItem().depth());
				this.key(this.positionItem().key());
				this.parentKey(this.positionItem().parentKey());
				this.hierarchyKey(this.positionItem().hierarchyKey());
				this.hierarchyLevelKey(this.positionItem().hierarchyLevelKey());
				this.sortKey(this.positionItem().sortKey());
				this.caption(this.positionItem().caption());
			}

	}

	, 
	createInstance: function (positionItem, index, memberIndex, positionSize) {
		return new $.ig.PositionItemInfo$2(this.$tKey, this.$tSortKey, positionItem, index, memberIndex, positionSize);
	}

	, 
	_positionItemDepthMin: 0,
	positionItemDepthMin: function (value) {
		if (arguments.length === 1) {
			this._positionItemDepthMin = value;
			return value;
		} else {
			return this._positionItemDepthMin;
		}
	}

	, 
	_positionItemDepthMax: 0,
	positionItemDepthMax: function (value) {
		if (arguments.length === 1) {
			this._positionItemDepthMax = value;
			return value;
		} else {
			return this._positionItemDepthMax;
		}
	}

	, 
	_positionItem: null,
	positionItem: function (value) {
		if (arguments.length === 1) {
			this._positionItem = value;
			return value;
		} else {
			return this._positionItem;
		}
	}

	, 
	_positionIndex: 0,
	positionIndex: function (value) {
		if (arguments.length === 1) {
			this._positionIndex = value;
			return value;
		} else {
			return this._positionIndex;
		}
	}

	, 
	_positionItemDepth: 0,
	positionItemDepth: function (value) {
		if (arguments.length === 1) {
			this._positionItemDepth = value;
			return value;
		} else {
			return this._positionItemDepth;
		}
	}

	, 
	_positionItemIndex: 0,
	positionItemIndex: function (value) {
		if (arguments.length === 1) {
			this._positionItemIndex = value;
			return value;
		} else {
			return this._positionItemIndex;
		}
	}

	, 
	_positionSize: 0,
	positionSize: function (value) {
		if (arguments.length === 1) {
			this._positionSize = value;
			return value;
		} else {
			return this._positionSize;
		}
	}

	, 
	_key: null,
	key: function (value) {
		if (arguments.length === 1) {
			this._key = value;
			return value;
		} else {
			return this._key;
		}
	}

	, 
	_parentKey: null,
	parentKey: function (value) {
		if (arguments.length === 1) {
			this._parentKey = value;
			return value;
		} else {
			return this._parentKey;
		}
	}

	, 
	_hierarchyKey: null,
	hierarchyKey: function (value) {
		if (arguments.length === 1) {
			this._hierarchyKey = value;
			return value;
		} else {
			return this._hierarchyKey;
		}
	}

	, 
	_hierarchyLevelKey: null,
	hierarchyLevelKey: function (value) {
		if (arguments.length === 1) {
			this._hierarchyLevelKey = value;
			return value;
		} else {
			return this._hierarchyLevelKey;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_sortKey: null,
	sortKey: function (value) {
		if (arguments.length === 1) {
			this._sortKey = value;
			return value;
		} else {
			return this._sortKey;
		}
	}

	, 
	_isExpandable: false,
	isExpandable: function (value) {
		if (arguments.length === 1) {
			this._isExpandable = value;
			return value;
		} else {
			return this._isExpandable;
		}
	}

	, 
	_isExpanded: false,
	isExpanded: function (value) {
		if (arguments.length === 1) {
			this._isExpanded = value;
			return value;
		} else {
			return this._isExpanded;
		}
	}

	, 
	addChildObject: function (position, index, lookupPosition) {
		var membersMatch = false;
		if (this.positionItemIndex() == -1) {
			membersMatch = true;

		} else {
			if (lookupPosition != null) {
				if (position.item(this.positionItemIndex()).key() != null) {
					var lookupPositionItem = lookupPosition.item(this.positionItemIndex());
					membersMatch = position.item(this.positionItemIndex()).key().equals(lookupPositionItem.key());
				}

			}

		}

		if (this.positionItemIndex() + 1 == this.positionSize()) {
			return membersMatch;
		}

		var childMemberMatch = this.addChildObject1(position, index, this.positionItemIndex() + 1, lookupPosition);
		return membersMatch && childMemberMatch;
	}

	, 
	onChildAdded: function (position, childItemInfo) {
	}
	, 
	__parentsToExpand: null

	, 
	addChildObject1: function (position, index, positionItemIndex, lookupPosition) {
		var $self = this;
		var membersMatch;
		var positionItem = position.item(positionItemIndex);
		if (!$self.containsKey(positionItem.key())) {
			var linkedNode = $self.createInstance(positionItem, index, positionItemIndex, $self.positionSize());
			linkedNode.isExpandable(positionItem.isExpandable());
			if ($self.__parentsToExpand.containsKey(linkedNode.key())) {
				$self.__parentsToExpand.remove(linkedNode.key());
				linkedNode.isExpanded(true);
			}

			if (positionItem.parentKey() != null) {
				var parentPositionInfo = null;
				if ((function () { var $ret = $self.tryGetValue(positionItem.parentKey(), parentPositionInfo); parentPositionInfo = $ret.value; return $ret.ret; }())) {
					parentPositionInfo.isExpanded(true);

				} else {
					if (!$self.__parentsToExpand.containsKey(positionItem.parentKey())) {
						$self.__parentsToExpand.add(positionItem.parentKey(), null);
					}

				}

			}

			membersMatch = linkedNode.addChildObject(position, index, lookupPosition);
			$self.add(positionItem.key(), linkedNode);
			if ($self.positionItemDepthMin() == -1) {
				$self.positionItemDepthMin(positionItem.depth());

			} else {
				$self.positionItemDepthMin(Math.min($self.positionItemDepthMin(), positionItem.depth()));
			}

			if ($self.positionItemDepthMax() == Number.MAX_VALUE) {
				$self.positionItemDepthMax(positionItem.depth());

			} else {
				$self.positionItemDepthMax(Math.max($self.positionItemDepthMax(), positionItem.depth()));
			}

			$self.onChildAdded(position, linkedNode);

		} else {
			var positionItemInfo = $self.item(positionItem.key());
			membersMatch = positionItemInfo.addChildObject(position, index, lookupPosition);
		}

		return membersMatch;
	}

	, 
	getIndex2: function (positionItems) {
		var keys = new Array(positionItems.count());
		for (var i = 0; i < keys.length; i++) {
			keys[i] = positionItems.item(i).key();
		}

		return this.getIndex(keys);
	}

	, 
	getIndex: function (keys) {
		return this.getIndex1(keys, keys.length);
	}

	, 
	getIndex1: function (keys, itemsCount) {
		var $self = this;
		if ($self.positionItemIndex() == itemsCount - 1) {
			return $self.positionIndex();
		}

		var positionItemInfo;
		if (!(function () { var $ret = $self.tryGetValue(keys[$self.positionItemIndex() + 1], positionItemInfo); positionItemInfo = $ret.value; return $ret.ret; }())) {
			return -1;
		}

		if (positionItemInfo.count() == 0) {
			return positionItemInfo.positionIndex();
		}

		return positionItemInfo.getIndex1(keys, itemsCount);
	}
	, 
	$type: new $.ig.Type('PositionItemInfo$2', $.ig.Dictionary$2.prototype.$type.specialize(0, 1))
}, true);

$.ig.util.defType('PositionResolver$2', 'Object', {
	$tKey: null, 
	$tSortKey: null, 
	__registeredPositionsCount: 0
	, 
	__rootPositionInfo: null
	, 
	__rootTupleInfoKey: null
	, 
	__rootTupleInfoParentKey: null
	, 
	init: function ($tKey, $tSortKey, positions, positionSize) {


		this.__registeredPositionsCount = 0;

		this.$tKey = $tKey
		this.$tSortKey = $tSortKey
		this.$type = this.$type.specialize(this.$tKey, this.$tSortKey);
		$.ig.Object.prototype.init.call(this);
			this.positions(positions.toList$1($.ig.IPosition$2.prototype.$type.specialize(this.$tKey, this.$tSortKey)));
			this.positionSize(positionSize);
	}
	, 
	getPositionIndexCompleted: null
	, 
	_positions: null,
	positions: function (value) {
		if (arguments.length === 1) {
			this._positions = value;
			return value;
		} else {
			return this._positions;
		}
	}

	, 
	_positionSize: 0,
	positionSize: function (value) {
		if (arguments.length === 1) {
			this._positionSize = value;
			return value;
		} else {
			return this._positionSize;
		}
	}

	, 
	rootPositionInfo: function () {

			if (this.__rootPositionInfo == null) {
				this.__rootPositionInfo = this.resolverRootPositionInfo(this.positionSize());
			}

			return this.__rootPositionInfo;
	}

	, 
	resolverRootPositionInfo: function (positionSize) {
		return new $.ig.PositionItemInfo$2(this.$tKey, this.$tSortKey, null, -1, -1, positionSize);
	}

	, 
	hasUnregisterdPositions: function () {

			return this.__registeredPositionsCount < this.positions().count();
	}

	, 
	completeRegisterPositions: function () {
		if (this.hasUnregisterdPositions()) {
			this.registerAndGetPositionIndex(null);
		}

	}

	, 
	resolveParentPositionItem: function (positionItem, parentPositionIndex) {
		parentPositionIndex = -1;
		var hierarchicalPosition = $.ig.util.cast($.ig.IHierarchicalPositionItem$2.prototype.$type.specialize(this.$tKey, this.$tSortKey), positionItem);
		if (hierarchicalPosition == null || hierarchicalPosition.parentKey() == null) {
			return {
				ret: null, 
				parentPositionIndex: parentPositionIndex
			};
		}

		var memberIndex = hierarchicalPosition.position().indexOf(hierarchicalPosition);
		var keys = new Array(hierarchicalPosition.position().itemsCount());
		for (var i = 0; i < hierarchicalPosition.position().itemsCount(); i++) {
			keys[i] = hierarchicalPosition.position().item(i).key();
		}

		keys[memberIndex] = hierarchicalPosition.parentKey();
		parentPositionIndex = this.rootPositionInfo().getIndex(keys);
		if (parentPositionIndex == -1) {
			return {
				ret: null, 
				parentPositionIndex: parentPositionIndex
			};
		}

		var parentPosition = this.positions().__inner[parentPositionIndex];
		var parentMember = parentPosition.item(memberIndex);
		return {
			ret: parentMember, 
			parentPositionIndex: parentPositionIndex
		};
		return {
			parentPositionIndex: parentPositionIndex
		};
	}

	, 
	getHostPositionItemInfo: function (position, positionItemIndex) {
		var $self = this;
		var indexInfo = $self.rootPositionInfo();
		var positionItem = position.item(positionItemIndex);
		for (var i = 0; i < positionItemIndex; i++) {
			var nextPositionItemInfo;
			if ((function () { var $ret = indexInfo.tryGetValue(position.item(i).key(), nextPositionItemInfo); nextPositionItemInfo = $ret.value; return $ret.ret; }())) {
				indexInfo = nextPositionItemInfo;

			} else {
				indexInfo = null;
				break;
			}

		}

		if (indexInfo == null) {
			return null;
		}

		if (!indexInfo.containsKey(positionItem.key())) {
			return null;
		}

		return indexInfo;
	}

	, 
	getChildPositionsIndexes: function (positionItem, sortDirection) {
		var $self = this;
		if ($self.rootPositionInfo().count() == 0) {
			return null;
		}

		var indexInfo = $self.rootPositionInfo();
		var index = positionItem.position().indexOf(positionItem);
		for (var i = 0; i < index; i++) {
			var nextPositionItemInfo;
			if ((function () { var $ret = indexInfo.tryGetValue(positionItem.position().item(i).key(), nextPositionItemInfo); nextPositionItemInfo = $ret.value; return $ret.ret; }())) {
				indexInfo = nextPositionItemInfo;

			} else {
				indexInfo = null;
				break;
			}

		}

		if (indexInfo == null) {
			return null;
		}

		if (!indexInfo.containsKey(positionItem.key())) {
			return null;
		}

		var resultList = new $.ig.List$1($.ig.Number.prototype.$type, 0);
		$self.getChildPositionsIndexes1(positionItem.key(), indexInfo, resultList);
		if (sortDirection == $.ig.ListSortDirection.prototype.descending) {
			resultList.sort1(function (x, y) {
				if (x == y) {
					return 0;
				}

				if (x > y) {
					return -1;
				}

				return 1;
			});
			return resultList;
		}

		resultList.sort1(function (x, y) {
			if (x == y) {
				return 0;
			}

			if (x > y) {
				return 1;
			}

			return -1;
		});
		return resultList;
	}

	, 
	getChildPositionsIndexes1: function (parentUniqueName, indexInfo, resultList) {
		var $self = this;
		var en = indexInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize($self.$tKey, $self.$tSortKey), function (tii) { return parentUniqueName.equals(tii.parentKey()); }).getEnumerator();
		while (en.moveNext()) {
			var positionInfo = en.current();
			if (positionInfo.count() == 0) {
				resultList.add(positionInfo.positionIndex());

			} else {
				$self.fillMemberTuplesIndexes(positionInfo, resultList);
			}

			if (!positionInfo.isExpanded()) {
				continue;
			}

			if (positionInfo.positionItemDepth() < indexInfo.positionItemDepthMax()) {
				$self.getChildPositionsIndexes1(positionInfo.key(), indexInfo, resultList);
			}

		}

	}

	, 
	fillMemberTuplesIndexes: function (indexInfo, resultList) {
		var $self = this;
		var en = indexInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize($self.$tKey, $self.$tSortKey), function (tii) { return tii.parentKey() == null; }).getEnumerator();
		while (en.moveNext()) {
			var positionItemInfo = en.current();
			if (positionItemInfo.count() == 0) {
				resultList.add(positionItemInfo.positionIndex());

			} else {
				$self.fillMemberTuplesIndexes(positionItemInfo, resultList);
			}

			if (!positionItemInfo.isExpanded()) {
				continue;
			}

			if (positionItemInfo.positionItemDepth() < indexInfo.positionItemDepthMax()) {
				$self.getChildPositionsIndexes1(positionItemInfo.key(), indexInfo, resultList);
			}

		}

	}

	, 
	getChildren: function (position, positionItemIndex) {
		var $self = this;
		if ($self.hasUnregisterdPositions()) {
			$self.completeRegisterPositions();
		}

		var indexInfo = $self.getHostPositionItemInfo(position, positionItemIndex);
		var positionItem = position.item(positionItemIndex);
		return indexInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize($self.$tKey, $self.$tSortKey), function (pi) { return positionItem.key().equals(pi.parentKey()); });
	}

	, 
	isMemberExpanded: function (positionItem) {
		var $self = this;
		if ($self.hasUnregisterdPositions()) {
			$self.completeRegisterPositions();
		}

		var positionIndex = $self.getPositionIndex(positionItem.position());
		if (positionIndex == -1 || $self.rootPositionInfo().count() == 0) {
			return $.ig.util.toNullable(Boolean, null);
		}

		var index = positionItem.position().indexOf(positionItem);
		var indexInfo = $self.rootPositionInfo();
		for (var i = 0; i < index; i++) {
			var nextPositionItemInfo;
			if ((function () { var $ret = indexInfo.tryGetValue(positionItem.position().item(i).key(), nextPositionItemInfo); nextPositionItemInfo = $ret.value; return $ret.ret; }())) {
				indexInfo = nextPositionItemInfo;

			} else {
				indexInfo = null;
				break;
			}

		}

		if (indexInfo == null) {
			return $.ig.util.toNullable(Boolean, null);
		}

		if (!indexInfo.containsKey(positionItem.key())) {
			return $.ig.util.toNullable(Boolean, null);
		}

		var childMember = null;
		var e = indexInfo.values().getEnumerator();
		while (e.moveNext()) {
			if (positionItem.key().equals(e.current().parentKey())) {
				childMember = e.current();
				break;
			}


		}
		return $.ig.util.toNullable(Boolean, childMember != null);
	}

	, 
	getPositionIndex: function (position) {
		if (position == null) {
			return -1;
		}

		if (position.itemsCount() != this.positionSize()) {
			return -1;
		}

		if (position.isEmpty() && this.positions().count() == 1 && this.positions().__inner[0].isEmpty()) {
			return 0;
		}

		if (this.__registeredPositionsCount > 0) {
			var positionIndex = this.getPositionIndexImpl(position);
			if (positionIndex > -1) {
				return positionIndex;
			}

			if (this.__registeredPositionsCount == this.positions().count()) {
				return -1;
			}

		}

		return this.registerAndGetPositionIndex(position);
	}

	, 
	getPositionIndexImpl: function (position) {
		if (position.isEmpty() && this.positions().count() == 1 && this.positions().__inner[0].isEmpty()) {
			return 0;
		}

		return this.rootPositionInfo().getIndex2(position.getItems().toList$1($.ig.IPositionItem$2.prototype.$type.specialize(this.$tKey, this.$tSortKey)));
	}

	, 
	registerAndGetPositionIndex: function (lookupPosition) {
		var registerAll = lookupPosition == null;
		var positionIndex = -1;
		for (var i = this.__registeredPositionsCount; i < this.positions().count(); i++) {
			var position = this.positions().__inner[i];
			var positionFound = this.rootPositionInfo().addChildObject(position, i, lookupPosition);
			this.__registeredPositionsCount++;
			if (positionIndex == -1 && positionFound) {
				positionIndex = i;
				if (!registerAll) {
					break;
				}

			}

		}

		return positionIndex;
	}
	, 
	$type: new $.ig.Type('PositionResolver$2', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LevelSortDirection', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.sortBehavior($.ig.LevelSortBehavior.prototype.system);
	}

	, 
	_levelUniqueName: null,
	levelUniqueName: function (value) {
		if (arguments.length === 1) {
			this._levelUniqueName = value;
			return value;
		} else {
			return this._levelUniqueName;
		}
	}

	, 
	_sortDirection: null,
	sortDirection: function (value) {
		if (arguments.length === 1) {
			this._sortDirection = value;
			return value;
		} else {
			return this._sortDirection;
		}
	}

	, 
	_sortBehavior: null,
	sortBehavior: function (value) {
		if (arguments.length === 1) {
			this._sortBehavior = value;
			return value;
		} else {
			return this._sortBehavior;
		}
	}
	, 
	$type: new $.ig.Type('LevelSortDirection', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TaskExtensions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	continueWithTask$1: function ($tResult, continuationFunction) {
		var $self = this;
		var tcs = new $.ig.TaskCompletionSource$1($tResult, 0);
		$self.continueWith(function (t) {
			if (t.exception() == null) {
				try {
						continuationFunction(t).continueWith1(function (t1) {
							if (t1.exception() == null) {
								tcs.setResult(t1.result());
								return;
							}

							tcs.setException(t1.exception());
						});

				}
				catch (e_) {
						var exception;
						exception = e_;
						tcs.setException(exception);

				}

			} else {
				tcs.setException(t.exception());
			}

		});
		return tcs.task();
	}

	, 
	continueWithTask$2: function ($tResult1, $tResult2, continuationFunction) {
		var $self = this;
		return $self.continueWithTask$1($tResult2, function (t) { return continuationFunction(t); });
	}
	, 
	$type: new $.ig.Type('TaskExtensions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('HierarchyFilterView', 'Object', {
	__filterItems: null
	, 
	__filterLevels: null
	, 
	__selectedFilterItems: null
	, 
	init: function (hierarchy) {


		this.__selectedFilterItems = new $.ig.Dictionary$2(String, $.ig.FilterMember.prototype.$type, 0);

		$.ig.Object.prototype.init.call(this);
			this.hierarchy(hierarchy);
			this.__filterLevels = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.FilterMember.prototype.$type), 0);
			this.__filterItems = new $.ig.Dictionary$2(String, $.ig.FilterMember.prototype.$type, 0);
	}
	, 
	filterMemberExpansionChanged: null, 
	filterMemberSelectionChanged: null
	, 
	_hierarchy: null,
	hierarchy: function (value) {
		if (arguments.length === 1) {
			this._hierarchy = value;
			return value;
		} else {
			return this._hierarchy;
		}
	}

	, 
	addFiltersForMembers: function (members) {
		var en = members.getEnumerator();
		while (en.moveNext()) {
			var member = en.current();
			this.addFilterForMember(member);
		}

	}

	, 
	addFilterForMember: function (member) {
		var $self = this;
		if (!$self.__filterItems.containsKey(member.uniqueName())) {
			var filterItem = new $.ig.FilterMember(member);
			filterItem.propertyChanged = $.ig.Delegate.prototype.combine(filterItem.propertyChanged, $self.filterItem_PropertyChanged.runOn($self));
			filterItem.selectionChanged = $.ig.Delegate.prototype.combine(filterItem.selectionChanged, $self.filterItem_SelectionChanged.runOn($self));
			var levelItems;
			if (!(function () { var $ret = $self.__filterLevels.tryGetValue(member.levelDepth(), levelItems); levelItems = $ret.value; return $ret.ret; }())) {
				levelItems = new $.ig.List$1($.ig.FilterMember.prototype.$type, 0);
				$self.__filterLevels.add(member.levelDepth(), levelItems);
			}

			$self.__filterItems.add(member.uniqueName(), filterItem);
			$self.__selectedFilterItems.add(member.uniqueName(), filterItem);
			levelItems.add(filterItem);
			$self.addChildren(filterItem);
			$self.attachToParent(filterItem);
		}

	}

	, 
	tryGetFilterMember: function (memberUniqueName, filterMember) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.__filterItems.tryGetValue(memberUniqueName, filterMember); filterMember = $ret.value; return $ret.ret; }()), 
			filterMember: filterMember
		};
		return {
			filterMember: filterMember
		};
	}

	, 
	getRootFilterMembers: function () {
		var minIndex = -1;
		var en = this.__filterLevels.keys().getEnumerator();
		while (en.moveNext()) {
			var key = en.current();
			if (minIndex == -1) {
				minIndex = key;

			} else {
				minIndex = Math.min(key, minIndex);
			}

		}

		if (minIndex == -1) {
			return null;
		}

		return this.__filterLevels.item(minIndex);
	}

	, 
	getSelectedFilterItems: function () {
		var rootLevelItems = this.getRootFilterMembers();
		var filterItems = new $.ig.List$1($.ig.FilterMember.prototype.$type, 0);
		var selectedRootLevelItemsCount = 0;
		var en = rootLevelItems.getEnumerator();
		while (en.moveNext()) {
			var rootLevelItem = en.current();
			if (rootLevelItem.isSelected().hasValue() == true && rootLevelItem.isSelected().value() == true) {
				selectedRootLevelItemsCount++;
			}

		}

		if (selectedRootLevelItemsCount == rootLevelItems.count()) {
			return filterItems;
		}

		var en1 = rootLevelItems.getEnumerator();
		while (en1.moveNext()) {
			var rootLevelItem1 = en1.current();
			if (rootLevelItem1.isSelected().hasValue() == false) {
				this.fillSelectedItems(rootLevelItem1, filterItems);

			} else if (rootLevelItem1.isSelected().hasValue() == true && rootLevelItem1.isSelected().value() == true) {
				filterItems.add(rootLevelItem1);
			}


		}

		return filterItems;
	}

	, 
	filterItem_SelectionChanged: function (sender, e) {
		if (this.filterMemberSelectionChanged != null) {
			this.filterMemberSelectionChanged(this, new $.ig.FilterMemberStateChangedEventArgs(sender));
		}

	}

	, 
	filterItem_PropertyChanged: function (sender, e) {
		if (e.propertyName() == "IsExpanded") {
			if (this.filterMemberExpansionChanged != null) {
				this.filterMemberExpansionChanged(this, new $.ig.FilterMemberStateChangedEventArgs(sender));
			}

		}

	}

	, 
	fillSelectedItems: function (filterItem, filterItems) {
		if (filterItem.isSelected().hasValue() == true && filterItem.isSelected().value() == true) {
			filterItems.add(filterItem);

		} else {
			if (filterItem.children() == null) {
				return;
			}

			var en = filterItem.children().getEnumerator();
			while (en.moveNext()) {
				var child = en.current();
				this.fillSelectedItems(child, filterItems);
			}

		}

	}

	, 
	attachToParent: function (filterItem) {
		var $self = this;
		var parentName = filterItem.member().parentUniqueName();
		if (String.isNullOrEmpty(parentName)) {
			return;
		}

		var parentItem;
		if ((function () { var $ret = $self.__filterItems.tryGetValue(parentName, parentItem); parentItem = $ret.value; return $ret.ret; }())) {
			parentItem.addChildItem(filterItem);
			if (parentItem.isSelected().hasValue() == true && parentItem.isSelected().value() == false) {
				filterItem.isSelected($.ig.util.toNullable($.ig.Boolean.prototype.$type, false));
			}

		}

	}

	, 
	addChildren: function (filterItem) {
		var $self = this;
		var levelIndex = filterItem.member().levelDepth();
		var nextLevelMembers;
		if ((function () { var $ret = $self.__filterLevels.tryGetValue(levelIndex + 1, nextLevelMembers); nextLevelMembers = $ret.value; return $ret.ret; }())) {
			var en = nextLevelMembers.getEnumerator();
			while (en.moveNext()) {
				var nextLevelMember = en.current();
				if (nextLevelMember.member().parentUniqueName() == filterItem.member().uniqueName()) {
					filterItem.addChildItem(nextLevelMember);
				}

			}

		}

	}
	, 
	$type: new $.ig.Type('HierarchyFilterView', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('FilterMember', 'Object', {
	__isSelected: $.ig.util.toNullable($.ig.Boolean.prototype.$type, null)
	, 
	__isExpanded: false
	, 
	__skipParentUpdate: false
	, 
	__skipChildrenUpdate: false
	, 
	init: function (member) {


		this.__skipParentUpdate = false;
		this.__skipChildrenUpdate = false;

		$.ig.Object.prototype.init.call(this);
			var trueValue = $.ig.util.toNullable($.ig.Boolean.prototype.$type, true);
			this.__isSelected = trueValue;
			this.member(member);
			this.unselectedChildrenCount(0);
			this.nullChildrenCount(0);
	}
	, 
	selectionChanged: null, 
	propertyChanged: null
	, 
	_parent: null,
	parent: function (value) {
		if (arguments.length === 1) {
			this._parent = value;
			return value;
		} else {
			return this._parent;
		}
	}

	, 
	_member: null,
	member: function (value) {
		if (arguments.length === 1) {
			this._member = value;
			return value;
		} else {
			return this._member;
		}
	}

	, 
	isExpandable: function () {

			return this.member().childrenCardinality() > 0;
	}

	, 
	isExpanded: function (value) {
		if (arguments.length === 1) {

			if (this.__isExpanded != value) {
				this.__isExpanded = value;
				this.onPropertyChanged("IsExpanded");
			}

			return value;
		} else {

			return this.__isExpanded;
		}
	}

	, 
	isSelected: function (value) {
		if (arguments.length === 1) {

			var newValue = value;
			var nullValue = $.ig.util.toNullable($.ig.Boolean.prototype.$type, null);
			if (($.ig.util.nullableEquals(this.__isSelected, newValue)) == false) {
				var oldValue = this.__isSelected;
				this.__isSelected = value;
				if (!this.__skipChildrenUpdate) {
					if (this.__isSelected.hasValue() == true) {
						if (this.children() != null) {
							var en = this.children().getEnumerator();
							while (en.moveNext()) {
								var filterItem = en.current();
								filterItem.__skipParentUpdate = true;
								filterItem.isSelected(this.__isSelected);
								filterItem.__skipParentUpdate = false;
							}

						}

					}

				}

				if (this.parent() != null) {
					if (oldValue.hasValue() == true && oldValue.value() == false) {
						if (this.__isSelected.hasValue() == false) {
							this.updateNullChildrenCount(true);
						}

						this.updateUnselectedChildrenCount(false);

					} else if (oldValue.hasValue() == false) {
						if (this.__isSelected.hasValue() == true && this.__isSelected.value() == false) {
							this.updateUnselectedChildrenCount(true);
						}

						this.updateNullChildrenCount(false);

					} else {
						if (this.__isSelected.hasValue() == true && this.__isSelected.value() == false) {
							this.updateUnselectedChildrenCount(true);

						} else if (this.__isSelected.hasValue() == false) {
							this.updateNullChildrenCount(true);
						}


					}


					if (!this.__skipParentUpdate) {
						this.parent().__skipChildrenUpdate = true;
						var unselected = this.parent().unselectedChildrenCount();
						var nullSelected = this.parent().nullChildrenCount();
						var total = this.parent().children().count();
						if (nullSelected == 0) {
							if (unselected == 0) {
								this.parent().isSelected($.ig.util.toNullable($.ig.Boolean.prototype.$type, true));

							} else if (unselected == total) {
								this.parent().isSelected($.ig.util.toNullable($.ig.Boolean.prototype.$type, false));

							} else {
								this.parent().isSelected(nullValue);
							}



						} else {
							this.parent().isSelected(nullValue);
						}

						this.parent().__skipChildrenUpdate = false;
					}

				}

				this.onPropertyChanged("IsSelected");
				if (!this.__skipParentUpdate && !this.__skipChildrenUpdate) {
					if (this.selectionChanged != null) {
						this.selectionChanged(this, $.ig.EventArgs.prototype.empty);
					}

				}

			}

			return value;
		} else {

			return this.__isSelected;
		}
	}

	, 
	updateUnselectedChildrenCount: function (increaseUnselected) {
		if (increaseUnselected) {
			this.parent().unselectedChildrenCount(this.parent().unselectedChildrenCount() + 1);

		} else {
			this.parent().unselectedChildrenCount(this.parent().unselectedChildrenCount() - 1);
		}

	}

	, 
	updateNullChildrenCount: function (increaseUnselected) {
		if (increaseUnselected) {
			this.parent().nullChildrenCount(this.parent().nullChildrenCount() + 1);

		} else {
			this.parent().nullChildrenCount(this.parent().nullChildrenCount() - 1);
		}

	}

	, 
	_children: null,
	children: function (value) {
		if (arguments.length === 1) {
			this._children = value;
			return value;
		} else {
			return this._children;
		}
	}

	, 
	addChildItem: function (filterItem) {
		if (this.children() == null) {
			this.children(new $.ig.List$1($.ig.FilterMember.prototype.$type, 0));
		}

		filterItem.parent(this);
		this.children().add(filterItem);
		this.onPropertyChanged("Children");
	}

	, 
	_unselectedChildrenCount: 0,
	unselectedChildrenCount: function (value) {
		if (arguments.length === 1) {
			this._unselectedChildrenCount = value;
			return value;
		} else {
			return this._unselectedChildrenCount;
		}
	}

	, 
	_nullChildrenCount: 0,
	nullChildrenCount: function (value) {
		if (arguments.length === 1) {
			this._nullChildrenCount = value;
			return value;
		} else {
			return this._nullChildrenCount;
		}
	}

	, 
	onPropertyChanged: function (propertyName) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(propertyName));
		}

	}
	, 
	$type: new $.ig.Type('FilterMember', $.ig.Object.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);

$.ig.util.defType('FilterMemberStateChangedEventArgs', 'EventArgs', {
	init: function (filterMember) {



		$.ig.EventArgs.prototype.init.call(this);
			this.filterMember(filterMember);
	}

	, 
	_filterMember: null,
	filterMember: function (value) {
		if (arguments.length === 1) {
			this._filterMember = value;
			return value;
		} else {
			return this._filterMember;
		}
	}
	, 
	$type: new $.ig.Type('FilterMemberStateChangedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.util.defType('ResultSorter$1', 'Object', {
	$t: null
	, 
	_result: null,
	result: function (value) {
		if (arguments.length === 1) {
			this._result = value;
			return value;
		} else {
			return this._result;
		}
	}

	, 
	_hasRows: false,
	hasRows: function (value) {
		if (arguments.length === 1) {
			this._hasRows = value;
			return value;
		} else {
			return this._hasRows;
		}
	}

	, 
	_hasColumns: false,
	hasColumns: function (value) {
		if (arguments.length === 1) {
			this._hasColumns = value;
			return value;
		} else {
			return this._hasColumns;
		}
	}
	, 
	init: function ($t, result, hasRows, hasColumns) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.result(result);
			this.hasRows(hasRows);
			this.hasColumns(hasColumns);
	}

	, 
	sort: function () {
	}

	, 
	sortAxis: function (visitor, axis, indicesMap) {
		visitor.visitTuples();
		var tupleIndices = visitor.visitedTupleIndices();
		var tuples = new Array(tupleIndices.count());
		for (var i = 0; i < tupleIndices.count(); i++) {
			var index = tupleIndices.item(i);
			indicesMap.add(index, i);
		}

		for (var i1 = 0; i1 < tupleIndices.count(); i1++) {
			var index1 = tupleIndices.item(i1);
			var tuple = axis.tuples().__inner[index1];
			tuples[i1] = tuple;
		}

		return new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 1, tuples);
	}
	, 
	$type: new $.ig.Type('ResultSorter$1', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ResultHeaderSorter', 'ResultSorter$1', {
	__sortDirections: null

	, 
	_appliedSortDirections: null,
	appliedSortDirections: function (value) {
		if (arguments.length === 1) {
			this._appliedSortDirections = value;
			return value;
		} else {
			return this._appliedSortDirections;
		}
	}

	, 
	_appliedSortDirectionsMap: null,
	appliedSortDirectionsMap: function (value) {
		if (arguments.length === 1) {
			this._appliedSortDirectionsMap = value;
			return value;
		} else {
			return this._appliedSortDirectionsMap;
		}
	}
	, 
	init: function (result, hasRows, hasColumns, sortDirections) {



		$.ig.ResultSorter$1.prototype.init.call(this, $.ig.AxisHeaderSortingVisitor.prototype.$type, result, hasRows, hasColumns);
			this.__sortDirections = new $.ig.Dictionary$2(String, $.ig.LevelSortDirection.prototype.$type, 1, sortDirections.count());
			var en = sortDirections.getEnumerator();
			while (en.moveNext()) {
				var levelSortDirection = en.current();
				this.__sortDirections.item(levelSortDirection.levelUniqueName(), levelSortDirection);
			}

	}

	, 
	sort: function () {
		var $self = this;
		$self.appliedSortDirections(new $.ig.List$1($.ig.LevelSortDirection.prototype.$type, 0));
		$self.appliedSortDirectionsMap(new $.ig.Dictionary$2(String, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type)), 0));
		if ($self.result().isEmpty()) {
			return $self.result();
		}

		var sortedAxes = new $.ig.List$1($.ig.OlapResultAxis.prototype.$type, 0);
		var axisIndex = 0;
		var columnsCount = 1;
		var columnIndicesMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Number.prototype.$type, 0);
		var rowIndecesMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Number.prototype.$type, 0);
		if ($self.hasColumns()) {
			var columnAxis = $self.result().axes().item(axisIndex);
			var columnSortDirectionsMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type), 0);
			var visitor = new $.ig.AxisHeaderSortingVisitor(columnAxis, $self.__sortDirections, $self.appliedSortDirections(), columnSortDirectionsMap);
			var sortedTuples = $self.sortAxis(visitor, columnAxis, columnIndicesMap);
			var sortedColumnAxis = (function () { var $ret = new $.ig.OlapResultAxis(sortedTuples, columnAxis.tupleSize());
			$ret.name(columnAxis.name()); return $ret;}());
			sortedAxes.add(sortedColumnAxis);
			$self.appliedSortDirectionsMap().item(columnAxis.name(), columnSortDirectionsMap);
			columnsCount = columnAxis.tuples().count();
			axisIndex++;
		}

		if ($self.hasRows()) {
			var rowAxis = $self.result().axes().item(axisIndex);
			var rowSortDirectionsMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type), 0);
			var visitor1 = new $.ig.AxisHeaderSortingVisitor(rowAxis, $self.__sortDirections, $self.appliedSortDirections(), rowSortDirectionsMap);
			var sortedTuples1 = $self.sortAxis(visitor1, rowAxis, rowIndecesMap);
			var sortedRowAxis = (function () { var $ret = new $.ig.OlapResultAxis(sortedTuples1, rowAxis.tupleSize());
			$ret.name(rowAxis.name()); return $ret;}());
			sortedAxes.add(sortedRowAxis);
			$self.appliedSortDirectionsMap().item(rowAxis.name(), rowSortDirectionsMap);
		}

		var sortedCells = new $.ig.List$1($.ig.OlapResultCell.prototype.$type, 2, $self.result().cells().count());
		var en = $self.result().cells().getEnumerator();
		while (en.moveNext()) {
			var c = en.current();
			var cell = c.clone();
			var cellOrdinal = cell.cellOrdinal();
			if ($self.hasColumns()) {
				var columnIndex = cellOrdinal % columnsCount;
				var newIndex = columnIndicesMap.item(columnIndex);
				if (columnIndex != newIndex) {
					var rowIndex = $.ig.intDivide(cellOrdinal, columnsCount);
					cellOrdinal = rowIndex * columnsCount + newIndex;
				}

			}

			if ($self.hasRows()) {
				var rowIndex1 = $.ig.intDivide(cellOrdinal, columnsCount);
				var newIndex1 = rowIndecesMap.item(rowIndex1);
				if (rowIndex1 != newIndex1) {
					var columnIndex1 = cellOrdinal % columnsCount;
					cellOrdinal = newIndex1 * columnsCount + columnIndex1;
				}

			}

			cell.cellOrdinal(cellOrdinal);
			sortedCells.add(cell);
		}

		var sortedResult = (function () { var $ret = new $.ig.OlapResult();
		$ret.isEmpty($self.result().isEmpty());
		$ret.axes(sortedAxes);
		$ret.cells(sortedCells); return $ret;}());
		return sortedResult;
	}
	, 
	$type: new $.ig.Type('ResultHeaderSorter', $.ig.ResultSorter$1.prototype.$type.specialize($.ig.AxisHeaderSortingVisitor.prototype.$type))
}, true);

$.ig.util.defType('AxisTupleVisitor', 'Object', {

	_axis: null,
	axis: function (value) {
		if (arguments.length === 1) {
			this._axis = value;
			return value;
		} else {
			return this._axis;
		}
	}

	, 
	_visitedTupleIndices: null,
	visitedTupleIndices: function (value) {
		if (arguments.length === 1) {
			this._visitedTupleIndices = value;
			return value;
		} else {
			return this._visitedTupleIndices;
		}
	}
	, 
	init: function (axis) {



		$.ig.Object.prototype.init.call(this);
			this.axis(axis);
	}

	, 
	visitTuples: function () {
		var $self = this;
		if ($self.axis().positionResolver().hasUnregisterdPositions()) {
			$self.axis().positionResolver().completeRegisterPositions();
		}

		$self.visitedTupleIndices(new $.ig.List$1($.ig.Number.prototype.$type, 2, $self.axis().tuples().count()));
		var rootItemPositionInfo = $self.axis().positionResolver().rootPositionInfo();
		var positionItemInfos = rootItemPositionInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == rootItemPositionInfo.positionItemDepthMin(); });
		var en = $self.sortPositions(rootItemPositionInfo, positionItemInfos).getEnumerator();
		while (en.moveNext()) {
			var positionItemInfo = en.current();
			$self.visitTuples1(rootItemPositionInfo, positionItemInfo);
		}

	}

	, 
	getChildPositions: function (hostPositionItemInfo, positionItemInfo) {
	}

	, 
	sortPositions: function (hostPositionItemInfo, positionItemInfos) {
	}

	, 
	visitTuples1: function (hostPositionItemInfo, positionItemInfo) {
		var $self = this;
		var hostedPosionsInfo = positionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == positionItemInfo.positionItemDepthMin(); });
		if (hostedPosionsInfo.count$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)) > 0) {
			var en = hostedPosionsInfo.getEnumerator();
			while (en.moveNext()) {
				var hostedItemInfo = en.current();
				$self.visitTuples1(positionItemInfo, hostedItemInfo);
			}


		} else {
			$self.visitedTupleIndices().add(positionItemInfo.positionIndex());
		}

		var childrenPosionInfo = $self.getChildPositions(hostPositionItemInfo, positionItemInfo);
		var en1 = childrenPosionInfo.getEnumerator();
		while (en1.moveNext()) {
			var childItemInfo = en1.current();
			$self.visitTuples1(hostPositionItemInfo, childItemInfo);
		}

	}
	, 
	$type: new $.ig.Type('AxisTupleVisitor', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('AxisHeaderSortingVisitor', 'AxisTupleVisitor', {
	__sortDirections: null
	, 
	__appliedSortDirections: null
	, 
	__appliedSortDirectionsMap: null
	, 
	init: function (axis, sortDirections, appliedSortDirections, appliedSortDirectionsMap) {



		$.ig.AxisTupleVisitor.prototype.init.call(this, axis);
			this.__sortDirections = sortDirections;
			this.__appliedSortDirections = appliedSortDirections;
			this.__appliedSortDirectionsMap = appliedSortDirectionsMap;
	}

	, 
	getChildPositions: function (hostPositionItemInfo, positionItemInfo) {
		var $self = this;
		var childPositions = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.parentKey() == positionItemInfo.key(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (childPositions.count() > 0) {
			var childPositionInfo = childPositions.item(0);
			var sortDirection;
			if ((function () { var $ret = $self.__sortDirections.tryGetValue(childPositionInfo.hierarchyLevelKey(), sortDirection); sortDirection = $ret.value; return $ret.ret; }())) {
				if (sortDirection.sortBehavior() == $.ig.LevelSortBehavior.prototype.system) {
					childPositions = sortDirection.sortDirection() == $.ig.ListSortDirection.prototype.ascending ? childPositions.orderBy$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), $.ig.Object.prototype.$type, function (pi) { return pi.sortKey(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)) : childPositions.orderByDescending$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), $.ig.Object.prototype.$type, function (pi) { return pi.sortKey(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));

				} else {
					childPositions = sortDirection.sortDirection() == $.ig.ListSortDirection.prototype.ascending ? childPositions.orderBy$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), String, function (pi) { return pi.caption(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)) : childPositions.orderByDescending$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), String, function (pi) { return pi.caption(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
				}

				if (!$self.__appliedSortDirections.select$2($.ig.LevelSortDirection.prototype.$type, String, function (x) { return x.levelUniqueName(); }).contains$1(String, sortDirection.levelUniqueName())) {
					$self.__appliedSortDirections.add(sortDirection);
				}

				var positions;
				if (!(function () { var $ret = $self.__appliedSortDirectionsMap.tryGetValue(childPositionInfo.positionItemIndex(), positions); positions = $ret.value; return $ret.ret; }())) {
					positions = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type, 0);
					$self.__appliedSortDirectionsMap.add(positionItemInfo.positionItemIndex(), positions);
				}

				positions.item(positionItemInfo.positionItemDepth(), sortDirection.sortDirection());
			}

		}

		return childPositions;
	}

	, 
	sortPositions: function (hostPositionItemInfo, positionItemInfos) {
		var $self = this;
		var positionItemInfosList = positionItemInfos.toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (positionItemInfosList.count() > 0) {
			var childPositionInfo = positionItemInfosList.item(0);
			var sortDirection;
			if (childPositionInfo.hierarchyLevelKey() != null && (function () { var $ret = $self.__sortDirections.tryGetValue(childPositionInfo.hierarchyLevelKey(), sortDirection); sortDirection = $ret.value; return $ret.ret; }())) {
				if (sortDirection.sortBehavior() == $.ig.LevelSortBehavior.prototype.system) {
					positionItemInfosList = sortDirection.sortDirection() == $.ig.ListSortDirection.prototype.ascending ? positionItemInfosList.orderBy$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), $.ig.Object.prototype.$type, function (pi) { return pi.sortKey(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)) : positionItemInfosList.orderByDescending$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), $.ig.Object.prototype.$type, function (pi) { return pi.sortKey(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));

				} else {
					positionItemInfosList = sortDirection.sortDirection() == $.ig.ListSortDirection.prototype.ascending ? positionItemInfosList.orderBy$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), String, function (pi) { return pi.caption(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)) : positionItemInfosList.orderByDescending$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), String, function (pi) { return pi.caption(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
				}

				$self.__appliedSortDirections.add(sortDirection);
				var positions;
				if (!(function () { var $ret = $self.__appliedSortDirectionsMap.tryGetValue(childPositionInfo.positionItemIndex(), positions); positions = $ret.value; return $ret.ret; }())) {
					positions = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type, 0);
					$self.__appliedSortDirectionsMap.add(hostPositionItemInfo.positionItemIndex(), positions);
				}

				positions.item(hostPositionItemInfo.positionItemDepth(), sortDirection.sortDirection());
			}

		}

		return positionItemInfosList;
	}
	, 
	$type: new $.ig.Type('AxisHeaderSortingVisitor', $.ig.AxisTupleVisitor.prototype.$type)
}, true);

$.ig.util.defType('ResultColumnValueSorter', 'ResultSorter$1', {
	__tupleSortDirections: null

	, 
	_appliedSortDirections: null,
	appliedSortDirections: function (value) {
		if (arguments.length === 1) {
			this._appliedSortDirections = value;
			return value;
		} else {
			return this._appliedSortDirections;
		}
	}
	, 
	init: function (result, hasRows, hasColumns, tupleSortDirections) {



		$.ig.ResultSorter$1.prototype.init.call(this, $.ig.AxisValueSortingVisitor.prototype.$type, result, hasRows, hasColumns);
			this.__tupleSortDirections = tupleSortDirections;
	}

	, 
	sort: function () {
		var $self = this;
		$self.appliedSortDirections(new $.ig.List$1($.ig.TupleSortDirection.prototype.$type, 0));
		if (!$self.hasRows() || $self.result().isEmpty()) {
			return $self.result();
		}

		var sortedAxes = new $.ig.List$1($.ig.OlapResultAxis.prototype.$type, 0);
		var axisIndex = 0;
		var columnAxis = null;
		var columnsCount = 1;
		if ($self.hasColumns()) {
			columnAxis = $self.result().axes().item(axisIndex);
			columnsCount = columnAxis.tuples().count();
			sortedAxes.add(columnAxis.clone());
			axisIndex++;
		}

		var rowAxis = $self.result().axes().item(axisIndex);
		var rowsCount = $self.result().axes().item(axisIndex).tuples().count();
		var cellsMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Object.prototype.$type, 1, $self.result().cells().count());
		var en = $self.result().cells().getEnumerator();
		while (en.moveNext()) {
			var cell = en.current();
			var value = null;
			if ((function () { var $ret = cell.properties().tryGetValue("Value", value); value = $ret.value; return $ret.ret; }())) {
			cellsMap.item(cell.cellOrdinal(), value);

			} else {
				(function () { var $ret = cell.properties().tryGetValue("FmtValue", value); value = $ret.value; return $ret.ret; }());
				cellsMap.item(cell.cellOrdinal(), value);
			;
			}

		}

		var columnValuesToSort = new $.ig.List$1($.ig.KeyValuePair$2.prototype.$type.specialize($.ig.TupleSortDirection.prototype.$type, $.ig.Array.prototype.$type), 2, $self.__tupleSortDirections.count());
		var en1 = $self.__tupleSortDirections.getEnumerator();
		while (en1.moveNext()) {
			var tupleSortDirection = en1.current();
			var columnIndex;
			if (columnAxis != null && tupleSortDirection.memberNames() != null) {
				if (columnAxis.positionResolver().hasUnregisterdPositions()) {
					columnAxis.positionResolver().completeRegisterPositions();
				}

				columnIndex = columnAxis.positionResolver().rootPositionInfo().getIndex(tupleSortDirection.memberNames());
				tupleSortDirection.tupleIndex(columnIndex);

			} else {
				columnIndex = tupleSortDirection.tupleIndex();
			}

			if (columnIndex > -1 && columnIndex < columnsCount) {
				var column = new Array(rowsCount);
				for (var rowIndex = 0; rowIndex < rowsCount; rowIndex++) {
					var cell1 = null;
					(function () { var $ret = cellsMap.tryGetValue(rowIndex * columnsCount + columnIndex, cell1); cell1 = $ret.value; return $ret.ret; }());
					column[rowIndex] = cell1;
				}

				columnValuesToSort.add(new $.ig.KeyValuePair$2($.ig.TupleSortDirection.prototype.$type, $.ig.Array.prototype.$type, 1, tupleSortDirection, column));
				$self.appliedSortDirections().add(tupleSortDirection);
			}

		}

		var rowIndecesMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Number.prototype.$type, 0);
		var visitor = new $.ig.AxisValueSortingVisitor(rowAxis, columnValuesToSort);
		var sortedTuples = $self.sortAxis(visitor, rowAxis, rowIndecesMap);
		var sortedRowAxis = (function () { var $ret = new $.ig.OlapResultAxis(sortedTuples, rowAxis.tupleSize());
		$ret.name(rowAxis.name()); return $ret;}());
		sortedAxes.add(sortedRowAxis);
		var sortedCells = new $.ig.List$1($.ig.OlapResultCell.prototype.$type, 2, $self.result().cells().count());
		var en2 = $self.result().cells().getEnumerator();
		while (en2.moveNext()) {
			var c = en2.current();
			var cell2 = c.clone();
			var cellOrdinal = cell2.cellOrdinal();
			var rowIndex1 = $.ig.intDivide(cellOrdinal, columnsCount);
			var newIndex = rowIndecesMap.item(rowIndex1);
			if (rowIndex1 != newIndex) {
				var columnIndex1 = cellOrdinal % columnsCount;
				cellOrdinal = newIndex * columnsCount + columnIndex1;
			}

			cell2.cellOrdinal(cellOrdinal);
			sortedCells.add(cell2);
		}

		var sortedResult = (function () { var $ret = new $.ig.OlapResult();
		$ret.isEmpty($self.result().isEmpty());
		$ret.axes(sortedAxes);
		$ret.cells(sortedCells); return $ret;}());
		return sortedResult;
	}
	, 
	$type: new $.ig.Type('ResultColumnValueSorter', $.ig.ResultSorter$1.prototype.$type.specialize($.ig.AxisValueSortingVisitor.prototype.$type))
}, true);

$.ig.util.defType('AxisValueSortingVisitor', 'AxisTupleVisitor', {
	__tupleSortDirections: null
	, 
	init: function (axis, tupleSortDirections) {



		$.ig.AxisTupleVisitor.prototype.init.call(this, axis);
			this.__tupleSortDirections = tupleSortDirections;
	}

	, 
	getChildPositions: function (hostPositionItemInfo, positionItemInfo) {
		var $self = this;
		var childPositions = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.parentKey() == positionItemInfo.key(); });
		return $self.sortPositions(hostPositionItemInfo, childPositions);
	}

	, 
	sortPositions: function (hostPositionItemInfo, positionItemInfos) {
		var positionItemInfos_ = positionItemInfos.toArray$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (positionItemInfos_.length > 0) {
			var tupleSortDirections_ = this.__tupleSortDirections.toArray$1($.ig.KeyValuePair$2.prototype.$type.specialize($.ig.TupleSortDirection.prototype.$type, $.ig.Array.prototype.$type));
			
var sortFunction = function (tupleSortDirections) {
    var compareCells = function (comparer, cell1, cell2) {
        var result = comparer(cell1, cell2);
        if (result < 0) {
            return -1;
        }
        if (result > 0) {
            return 1;
        }
        return (!isNaN(parseFloat(result)) && isFinite(result)) ? result : 0;
    };
    return function (o1, o2) {
        var i, length, tupleSortDirection, cells, direction,
            cell1, cell2, arr1 = [], arr2 = [];

        for (i=0;i<tupleSortDirections.length;i++) {
            tupleSortDirection = tupleSortDirections[i].key();
            cells = tupleSortDirections[i].value();

            if (tupleSortDirection.sortDirection() === $.ig.ListSortDirection.prototype.ascending) {
                direction = 1;
            } else {
                direction = -1;
            }

            comparer = tupleSortDirection.comparer();

            cell1 = cells[o1.positionIndex()];
            cell2 = cells[o2.positionIndex()];
            if (tupleSortDirections.length === 1) {
                arr1 = direction * compareCells(comparer, cell1, cell2);
                arr2 = direction * compareCells(comparer, cell2, cell1);
            } else {
                arr1.push(direction * compareCells(comparer, cell1, cell2));
                arr2.push(direction * compareCells(comparer, cell2, cell1));
            }
        }

        if (arr1 < arr2) {
            return -1;
        }
        if (arr1 > arr2) {
            return 1;
        }
        return 0;
    };
};

positionItemInfos_.sort(sortFunction(tupleSortDirections_));
;
		}

		return positionItemInfos_;
	}
	, 
	$type: new $.ig.Type('AxisValueSortingVisitor', $.ig.AxisTupleVisitor.prototype.$type)
}, true);

$.ig.util.defType('TupleSortDirection', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
	}

	, 
	_tupleIndex: 0,
	tupleIndex: function (value) {
		if (arguments.length === 1) {
			this._tupleIndex = value;
			return value;
		} else {
			return this._tupleIndex;
		}
	}

	, 
	_memberNames: null,
	memberNames: function (value) {
		if (arguments.length === 1) {
			this._memberNames = value;
			return value;
		} else {
			return this._memberNames;
		}
	}

	, 
	_sortDirection: null,
	sortDirection: function (value) {
		if (arguments.length === 1) {
			this._sortDirection = value;
			return value;
		} else {
			return this._sortDirection;
		}
	}

	, 
	_comparer: null,
	comparer: function (value) {
		if (arguments.length === 1) {
			this._comparer = value;
			return value;
		} else {
			return this._comparer;
		}
	}
	, 
	$type: new $.ig.Type('TupleSortDirection', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DataSourceBase', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_dataSource: null,
	dataSource: function (value) {
		if (arguments.length === 1) {
			this._dataSource = value;
			return value;
		} else {
			return this._dataSource;
		}
	}

	, 
	isInitialized: function () {

			if (this.dataSource() == null) {
				return false;
			}

			return this.dataSource().isInitialized();
	}

	, 
	_isModified: false,
	isModified: function (value) {
		if (arguments.length === 1) {
			this._isModified = value;
			return value;
		} else {
			return this._isModified;
		}
	}

	, 
	_isUpdating: false,
	isUpdating: function (value) {
		if (arguments.length === 1) {
			this._isUpdating = value;
			return value;
		} else {
			return this._isUpdating;
		}
	}

	, 
	initialize: function () {
		var promise_ = this.dataSource().initialize().promise();
		
var $this = this;
if (!this._isInitializedAttached) {
    this._isInitializedAttached = true;
    promise_.always(function (result) {
        var args = {
            error: null,
            metadataTreeRoot: null
        };

        if (this.state() === 'rejected') {
            args.error = result;
        } else {
            args.metadataTreeRoot = result;
        }

        $($this).trigger('initialized', args);
        $this._isInitializedAttached = false;
    });
}
;
		return promise_;
	}

	, 
	cubes: function () {

			return (this.dataSource().cubes()).inner();
	}

	, 
	cube: function () {

			return this.dataSource().cube();
	}

	, 
	setCube: function (cubeName) {
		var $self = this;
		return $self.dataSource().setCube(cubeName).continueWith$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) {
	return t.result();
}).promise();
	}

	, 
	metadataTree: function () {

			return this.dataSource().metadataTree();
	}

	, 
	addRowItem: function (rowItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, rowItem) !== null) {
			this.dataSource().rowAxis().add(rowItem);
			this.isModified(true);
		}

	}

	, 
	insertRowItem: function (index, rowItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, rowItem) !== null) {
			this.dataSource().rowAxis().insert(index, rowItem);
			this.isModified(true);
		}

	}

	, 
	removeRowItem: function (rowItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, rowItem) !== null || $.ig.util.cast($.ig.MeasureList.prototype.$type, rowItem) !== null) {
			this.dataSource().rowAxis().remove(rowItem);
			this.isModified(true);
		}

	}

	, 
	addColumnItem: function (columnItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, columnItem) !== null) {
			this.dataSource().columnAxis().add(columnItem);
			this.isModified(true);
		}

	}

	, 
	insertColumnItem: function (index, columnItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, columnItem) !== null) {
			this.dataSource().columnAxis().insert(index, columnItem);
			this.isModified(true);
		}

	}

	, 
	removeColumnItem: function (columnItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, columnItem) !== null || $.ig.util.cast($.ig.MeasureList.prototype.$type, columnItem) !== null) {
			this.dataSource().columnAxis().remove(columnItem);
			this.isModified(true);
		}

	}

	, 
	addFilterItem: function (filterItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, filterItem) !== null) {
			this.dataSource().filters().add(filterItem);
			this.isModified(true);
		}

	}

	, 
	insertFilterItem: function (index, filterItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, filterItem) !== null) {
			this.dataSource().filters().insert(index, filterItem);
			this.isModified(true);
		}

	}

	, 
	removeFilterItem: function (filterItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, filterItem) !== null) {
			this.dataSource().filters().remove(filterItem);
			this.isModified(true);
		}

	}

	, 
	addMeasureItem: function (measureItem) {
		if ($.ig.util.cast($.ig.Measure.prototype.$type, measureItem) !== null) {
			this.dataSource().measures().add(measureItem);
			this.isModified(true);
		}

	}

	, 
	insertMeasureItem: function (index, measureItem) {
		if ($.ig.util.cast($.ig.Measure.prototype.$type, measureItem) !== null) {
			this.dataSource().measures().insert(index, measureItem);
			this.isModified(true);
		}

	}

	, 
	removeMeasureItem: function (measureItem) {
		if ($.ig.util.cast($.ig.Measure.prototype.$type, measureItem) !== null) {
			this.dataSource().measures().remove(measureItem);
			this.isModified(true);
		}

	}

	, 
	setMeasureListIndex: function (index) {
		this.dataSource().measureListIndex(index);
		this.isModified(true);
	}

	, 
	setMeasureListLocation: function (location) {
		switch (location) {
			case "rows":
				this.dataSource().measureListLocation($.ig.MeasureListLocation.prototype.rows);
				break;
			case "columns":
				this.dataSource().measureListLocation($.ig.MeasureListLocation.prototype.columns);
				break;
			default:
				break;
		}

		this.isModified(true);
	}

	, 
	getMeasureListLocation: function () {
		switch (this.dataSource().measureListLocation()) {
			case $.ig.MeasureListLocation.prototype.rows:
				return "rows";
				break;
			case $.ig.MeasureListLocation.prototype.columns:
				return "columns";
				break;
			default:
				return null;
				break;
		}

	}

	, 
	expandTupleMember: function (axisName, tupleIndex, memberIndex) {
		this.dataSource().expandTupleMember(axisName, tupleIndex, memberIndex);
	}

	, 
	collapseTupleMember: function (axisName, tupleIndex, memberIndex) {
		this.dataSource().collapseTupleMember(axisName, tupleIndex, memberIndex);
	}

	, 
	rowAxis: function () {

			return (this.dataSource().rowAxis()).inner();
	}

	, 
	columnAxis: function () {

			return (this.dataSource().columnAxis()).inner();
	}

	, 
	filters: function () {

			return (this.dataSource().filters()).inner();
	}

	, 
	measures: function () {

			return (this.dataSource().measures()).inner();
	}

	, 
	result: function () {

			return this.dataSource().result();
	}

	, 
	bindCollectionChanged: function (options) {
		var options_ = options;
		var ds_ = this.dataSource();
		
var attachCollectionChanged = function(collection, handler) {
    collection.collectionChanged = $.ig.Delegate.prototype.combine(
        collection.collectionChanged,
        handler
    );
};

if ($.isFunction(options_['filters'])) {
    attachCollectionChanged(ds_._filters, options_['filters']);
}
if ($.isFunction(options_['rowAxis'])) {
    attachCollectionChanged(ds_._rowAxis, options_['rowAxis']);
}
if ($.isFunction(options_['columnAxis'])) {
    attachCollectionChanged(ds_._columnAxis, options_['columnAxis']);
}
if ($.isFunction(options_['measures'])) {
    attachCollectionChanged(ds_._measures, options_['measures']);
}
;
	}

	, 
	unbindCollectionChanged: function (options) {
		var options_ = options;
		var ds_ = this.dataSource();
		
unbindCollectionChanged = function(collection, handler) {
    collection.collectionChanged = $.ig.Delegate.prototype.remove(
        collection.collectionChanged,
        handler
    );
};

if ($.isFunction(options_['filters'])) {
    unbindCollectionChanged(ds_._filters, options_['filters']);
}
if ($.isFunction(options_['rowAxis'])) {
    unbindCollectionChanged(ds_._rowAxis, options_['rowAxis']);
}
if ($.isFunction(options_['columnAxis'])) {
    unbindCollectionChanged(ds_._columnAxis, options_['columnAxis']);
}
if ($.isFunction(options_['measures'])) {
    unbindCollectionChanged(ds_._measures, options_['measures']);
}
;
	}

	, 
	clearPendingChanges: function () {
		this.dataSource().clearPendingChanges();
	}

	, 
	update: function () {
		var promise_ = this.dataSource().update().promise();
		
var $this = this;
if (!this.isUpdating()) {
    this.isUpdating(true);
    promise_.always(function (result) {
        var args = {
            error: null,
            result: null
        };

        if (this.state() === 'rejected') {
            args.error = result;
        } else {
            args.result = result;
        }

        $this.isUpdating(false);
        $this.isModified(false);
        $($this).trigger('updated', args);
    });
}
;
		return promise_;
	}

	, 
	getCoreElement: function (predicate, elementType) {
		return this.dataSource().getCoreElement(predicate, elementType);
	}

	, 
	getCoreElements: function (predicate, elementType) {
		return (this.dataSource().getCoreElements(predicate, elementType)).inner();
	}

	, 
	getMembersOfHierarchy: function (hierarchyUniqueName) {
		return this.dataSource().getMembersOfHierarchy(hierarchyUniqueName).promise();
	}

	, 
	getMembersOfLevel: function (levelUniqueName) {
		return this.dataSource().getMembersOfLevel(levelUniqueName).promise();
	}

	, 
	tryGetMember: function (memberUniqueName) {
		var $self = this;
		var member;
		if ((function () { var $ret = $self.dataSource().tryGetMember(memberUniqueName, member); member = $ret.member; return $ret.ret; }())) {
			return member;
		}

		return null;
	}

	, 
	tryGetMembersForLevel: function (levelUniqueName) {
		var $self = this;
		var members = new $.ig.ArrayListCollection$1($.ig.Member.prototype.$type);
		var success = (function () { var $ret = $self.dataSource().tryGetMembersForLevel(levelUniqueName, members); members = $ret.members; return $ret.ret; }());
		return success ? (members).inner() : (new $.ig.ArrayListCollection$1($.ig.Member.prototype.$type)).inner();
	}

	, 
	getMembersOfMember: function (memberUniqueName) {
		return this.dataSource().getMembersOfMember(memberUniqueName).promise();
	}

	, 
	addFilterMember: function (hierarchyUniqueName, memberUniqueName) {
		this.dataSource().addFilterMember(hierarchyUniqueName, memberUniqueName);
		this.isModified(true);
	}

	, 
	removeAllFilterMembers: function (hierarchyUniqueName) {
		this.dataSource().removeAllFilterMembers(hierarchyUniqueName);
		this.isModified(true);
	}

	, 
	getFilterMemberNames: function (hierarchyUniqueName) {
		return (this.dataSource().getFilterMemberNames(hierarchyUniqueName)).inner();
	}

	, 
	getDimension: function (dimensionUniqueName) {
		var $self = this;
		return $self.dataSource().getCoreElement(function (d) { return d.uniqueName() == dimensionUniqueName; }, $.ig.Dimension.prototype.$type);
	}

	, 
	getHierarchy: function (hierarchyUniqueName) {
		var $self = this;
		return $self.dataSource().getCoreElement(function (h) { return h.uniqueName() == hierarchyUniqueName; }, $.ig.Hierarchy.prototype.$type);
	}

	, 
	getLevel: function (levelUniqueName) {
		var $self = this;
		return $self.dataSource().getCoreElement(function (l) { return l.uniqueName() == levelUniqueName; }, $.ig.Level.prototype.$type);
	}

	, 
	getMeasure: function (measurelUniqueName) {
		var $self = this;
		return $self.dataSource().getCoreElement(function (m) { return m.uniqueName() == measurelUniqueName; }, $.ig.Measure.prototype.$type);
	}

	, 
	getMeasureList: function () {
		return this.dataSource().getCoreElement(null, $.ig.MeasureList.prototype.$type);
	}
	, 
	$type: new $.ig.Type('DataSourceBase', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('jQueryUtils', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	javascriptObjectToDictionary$1: function ($t, jsObject) {
		if (jsObject == null) {
		return null;
		}

		var jsObject_ = jsObject;
		var dict_ = new $.ig.Dictionary$2(String, $t, 0);
		(function (obj, dict) {
                var tempDict = $.ig.Dictionary.prototype.getDictionary(obj);
                var keys = tempDict.keys();
                while (keys.moveNext()){
                    var key = keys.current();
                    var value = tempDict.item(key);
                    dict.add(key, value);
                }
            })(jsObject_, dict_);
		return dict_;
	}

	, 
	javascriptObjectFromDictionary$1: function ($t, dict) {
		if (dict == null) {
		return null;
		}

		var dict_ = dict;
		return dict_.__inner.proxy;
	}

	, 
	convertToObjectDictionary: function (jsObject) {
		return $.ig.jQueryUtils.prototype.javascriptObjectToDictionary$1($.ig.Object.prototype.$type, jsObject);
	}

	, 
	convertToStringDictionary: function (jsObject) {
		return $.ig.jQueryUtils.prototype.javascriptObjectToDictionary$1(String, jsObject);
	}

	, 
	convertFromObjectDictionary: function (dictionary) {
		return $.ig.jQueryUtils.prototype.javascriptObjectFromDictionary$1($.ig.Object.prototype.$type, dictionary);
	}

	, 
	convertFromStringDictionary: function (dictionary) {
		return $.ig.jQueryUtils.prototype.javascriptObjectFromDictionary$1(String, dictionary);
	}

	, 
	createJavascriptObject: function () {
		return {};
	}

	, 
	getJavascriptObjectProperty: function (jsObject, property) {
		var jsObject_ = jsObject;
		var property_ = property;
		return jsObject_[property_];
	}

	, 
	setJavascriptObjectProperty: function (jsObject, property, value) {
		var jsObject_ = jsObject;
		var property_ = property;
		var value_ = value;
		jsObject_[property_] = value_;
	}

	, 
	getJavascriptObjectMethodResult: function (jsObject, method, args) {
	args = Array.prototype.slice.call(arguments, 2);
		var jsObject_ = jsObject;
		var method_ = method;
		var args_ = args;
		return jsObject_[method_].call(jsObject_, args_);
	}
	, 
	$type: new $.ig.Type('jQueryUtils', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapUtilities', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	dateMemberProvider: function (datePart, datePropName, format, datePartFormat) {
		if (String.isNullOrEmpty(datePart) || String.isNullOrEmpty(datePropName)) {
			return null;
		}

		var propName_ = datePropName;
		var datePartFormat_ = datePartFormat;
		var format_ = format;
		var yearProvider_;
		var semesterProvider_;
		var quarterProvider_;
		var monthProvider_;
		datePart = datePart.toLowerCase();
		switch (datePart) {
			case "year":
				if (datePartFormat_ == null) {
					datePartFormat_ = "yyyy";
				}

				if (format_ == null) {
					return function (item) { return $.ig.formatter(new Date(item[propName_]), 'date', datePartFormat_); };
				}

				return function (item) { return format_.replace('{0}', $.ig.formatter(new Date(item[propName_]), 'date', datePartFormat_)); };
			case "semester":
				if (format_ == null) {
					format_ = "H{0}";
				}

				yearProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("year", datePropName, null, null);
				return function (item) {
                    var year = yearProvider_(item);
                    return format_.replace('{0}', Math.floor(new Date(item[propName_]).getMonth() / 6) + 1).replace('{1}', year); 
                };
			case "quarter":
				if (format_ == null) {
					format_ = "Q{0}";
				}

				yearProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("year", datePropName, null, null);
				semesterProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("semester", datePropName, null, null);
				return function (item) {
                    var year = yearProvider_(item);
                    var semester = semesterProvider_(item);
                    return format_.replace('{0}', Math.floor(new Date(item[propName_]).getMonth() / 3) + 1).replace('{1}', semester).replace('{2}', year); 
                };
			case "month":
				if (datePartFormat_ == null) {
					datePartFormat_ = "MMMM";
				}

				if (format_ == null) {
					return function (item) { return $.ig.formatter(new Date(item[propName_]), 'date', datePartFormat_); };
				}

				yearProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("year", datePropName, null, null);
				semesterProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("semester", datePropName, null, null);
				quarterProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("quarter", datePropName, null, null);
				return function (item) {
                    var year = yearProvider_(item);
                    var semester = semesterProvider_(item);
                    var quarter = quarterProvider_(item);
                    return format_.replace('{0}', $.ig.formatter(new Date(item[propName_]), 'date', datePartFormat_)).replace('{1}', quarter).replace('{2}', semester).replace('{3}', year); 
                };
			case "date":
				if (datePartFormat_ == null) {
					datePartFormat_ = "MM/dd/yyyy";
				}

				if (format_ == null) {
					return function (item) { return $.ig.formatter(new Date(item[propName_]), 'date', datePartFormat_); };
				}

				yearProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("year", datePropName, null, null);
				semesterProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("semester", datePropName, null, null);
				quarterProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("quarter", datePropName, null, null);
				monthProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("month", datePropName, null, null);
				return function (item) {
                    var year = yearProvider_(item);
                    var semester = semesterProvider_(item);
                    var quarter = quarterProvider_(item);
                    var month = monthProvider_(item);
                    return format_.replace('{0}', $.ig.formatter(new Date(item[propName_]), 'date', datePartFormat_)).replace('{1}', month).replace('{2}', quarter).replace('{3}', semester).replace('{4}', year); 
                };
		}

		return null;
	}

	, 
	getDateHierarchy: function (datePropName, dateParts, name, caption, levelCaptions, rootCaption) {
		var $self = this;
		if (String.isNullOrEmpty(datePropName)) {
			return null;
		}

		if (dateParts == null || dateParts.length == 0) {
			dateParts = (function () { var $ret = new Array();
			$ret.add("year");
			$ret.add("quarter");
			$ret.add("month");
			$ret.add("date");return $ret;}());

		} else {
			for (var i = 0; i < dateParts.length; i++) {
				dateParts[i] = dateParts[i].toLowerCase();
			}

		}

		if (name == null) {
			name = "Dates";
		}

		if (caption == null) {
			caption = name;
		}

		var res_ = null;
		var name_ = name;
		var caption_ = caption;
		var rootCaption_ = rootCaption;
		var dateParts_ = dateParts;
		if (levelCaptions == null) {
			levelCaptions = new Array(dateParts.length);
			for (var i1 = 0; i1 < levelCaptions.length; i1++) {
				var datePart = dateParts[i1];
				levelCaptions[i1] = datePart.substr(0, 1).toUpperCase() + datePart.substr(1, datePart.length) + "s";
			}

		}

		var captions_ = levelCaptions;
		var memberProviders_ = new Array(dateParts.length);
		for (var i2 = 0; i2 < dateParts.length; i2++) {
			var datePart1 = dateParts[i2];
			memberProviders_[i2] = $.ig.OlapUtilities.prototype.dateMemberProvider(datePart1, datePropName, null, null);
		}

		
            var levelsMetadata = [];
            var levelOffset = 0;

            if (rootCaption_ != null && rootCaption_ != '') {
                levelOffset = 1;
                levelsMetadata[0] = { name: rootCaption_, caption: rootCaption_, memberProvider: function(item) { return rootCaption_;}};
            }

            for (var i = 0; i < memberProviders_.length; i++){
                levelsMetadata[i + levelOffset] = { name: dateParts_[i], caption: captions_[i], memberProvider: memberProviders_[i]};
            }

            res_ = { name: name_, caption: caption_, levels: levelsMetadata};
;
		return res_;
	}

	, 
	sumAggregator: function (propName, precision) {
		var propName_ = propName;
		var precision_ = precision;
		return function(items, cellMetadata) {
            var sum = 0, areAllNullOrUndefined = true, value;

            for (var i = 0; i < items.length; i++) {
                value = items[i][propName_];
                if (value !== null && value !== undefined) {
                    areAllNullOrUndefined = false;
                    sum += value;
                }
            }
            
            if (areAllNullOrUndefined)
                return null;
            if (precision_ != null) {
                return sum.toFixed(precision_);
            }
            return sum;            
        };
	}

	, 
	avgAggregator: function (propName, precision) {
		var propName_ = propName;
		var precision_ = precision;
		return function(items, cellMetadata) {
            if (precision_ == null) {
                precision_ = 2;
            }
            var sum = 0, count = 0, areAllNullOrUndefined = true, value;
            for (var i = 0; i < items.length; i++) {
                value = items[i][propName_];
                if (value !== null && value !== undefined) {
                    areAllNullOrUndefined = false;
                    sum += value;
                    count++;
                }
            }
                
            if (areAllNullOrUndefined)
                return null;

            return (sum/count).toFixed(precision_);
        };
	}

	, 
	minAggregator: function (propName) {
		var propName_ = propName;
		return function(items, cellMetadata) {
            var result = items[0][propName_];;                
            for (var i = 1; i < items.length; i++) {
                result = Math.min(result, items[i][propName_]);
            }
            return result;
        };
	}

	, 
	maxAggregator: function (propName) {
		var propName_ = propName;
		return function(items, cellMetadata) {
            var result = items[0][propName_];;                
            for (var i = 1; i < items.length; i++) {
                result = Math.max(result, items[i][propName_]);
            }
            return result;
        };
	}

	, 
	countAggregator: function () {
		return function(items, cellMetadata) {
            return items.length;
        };
	}
	, 
	$type: new $.ig.Type('OlapUtilities', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapTableView', 'Object', {
	__tableViewImpl: null
	, 
	init: function (result, hasColumns, hasRows, viewSettings) {



		$.ig.Object.prototype.init.call(this);
			var settings = this.settingsFromJavascriptObject(viewSettings);
			this.__tableViewImpl = new $.ig.TableViewImpl(result, hasColumns, hasRows, settings);
	}

	, 
	rowHeaders: function () {

			if (this.__tableViewImpl.rowHeaders() == null) {
			return null;
			}

			return (this.__tableViewImpl.rowHeaders()).inner();
	}

	, 
	columnHeaders: function () {

			if (this.__tableViewImpl.columnHeaders() == null) {
			return null;
			}

			return (this.__tableViewImpl.columnHeaders()).inner();
	}

	, 
	resultCells: function () {

			if (this.__tableViewImpl.resultCells() == null) {
			return null;
			}

			return (this.__tableViewImpl.resultCells()).inner();
	}

	, 
	columnSortDirections: function (value) {
		if (arguments.length === 1) {

			this.__tableViewImpl.columnSortDirections().clear();
			var en = value.getEnumerator();
			while (en.moveNext()) {
				var obj = en.current();
				var tupleSortDirection = this.tupleSortDirectionFromJavascriptObject(obj);
				this.__tableViewImpl.columnSortDirections().add(tupleSortDirection);
			}

			return value;
		} else {

			var columnSortDirections = new $.ig.Array();
			var en = this.__tableViewImpl.columnSortDirections().getEnumerator();
			while (en.moveNext()) {
				var columnSortDirection = en.current();
				columnSortDirections.add(this.tupleSortDirectionToJavascriptObject(columnSortDirection));
			}

			return columnSortDirections;
		}
	}

	, 
	appliedColumnSortDirections: function () {

			var columnSortDirections = new $.ig.Array();
			var en = this.__tableViewImpl.appliedColumnSortDirections().getEnumerator();
			while (en.moveNext()) {
				var columnSortDirection = en.current();
				columnSortDirections.add(this.tupleSortDirectionToJavascriptObject(columnSortDirection));
			}

			return columnSortDirections;
	}

	, 
	levelSortDirections: function (value) {
		if (arguments.length === 1) {

			this.__tableViewImpl.levelSortDirections().clear();
			var en = value.getEnumerator();
			while (en.moveNext()) {
				var obj = en.current();
				var levelSortDirection = this.levelSortDirectionFromJavascriptObject(obj);
				this.__tableViewImpl.levelSortDirections().add(levelSortDirection);
			}

			return value;
		} else {

			var levelSortDirections = new $.ig.Array();
			var en = this.__tableViewImpl.levelSortDirections().getEnumerator();
			while (en.moveNext()) {
				var levelSortDirection = en.current();
				levelSortDirections.add(this.levelSortDirectionToJavascriptObject(levelSortDirection));
			}

			return levelSortDirections;
		}
	}

	, 
	appliedLevelSortDirections: function () {

			var levelSortDirections = new $.ig.Array();
			var en = this.__tableViewImpl.appliedLevelSortDirections().getEnumerator();
			while (en.moveNext()) {
				var levelSortDirection = en.current();
				levelSortDirections.add(this.levelSortDirectionToJavascriptObject(levelSortDirection));
			}

			return levelSortDirections;
	}

	, 
	appliedSortDirectionsMap: function () {

			var resultMap_ = $.ig.jQueryUtils.prototype.createJavascriptObject();
			var i_En = this.__tableViewImpl.appliedSortDirectionsMap().getEnumerator();
			while (i_En.moveNext()) {
				var i_ = i_En.current();
				var axisMap_ = $.ig.jQueryUtils.prototype.createJavascriptObject();
				var j_En = i_.value().getEnumerator();
				while (j_En.moveNext()) {
					var j_ = j_En.current();
					var hierarchyMap_ = $.ig.jQueryUtils.prototype.createJavascriptObject();
					var k_En = j_.value().getEnumerator();
					while (k_En.moveNext()) {
						var k_ = k_En.current();
						var sortDirection_ = k_.value() == $.ig.ListSortDirection.prototype.ascending ? "ascending" : "descending";
						hierarchyMap_[k_.key()] = sortDirection_;

					}
					axisMap_[j_.key()] = hierarchyMap_;

				}
				resultMap_[i_.key()] = axisMap_;

			}
			return resultMap_;
	}

	, 
	initialize: function () {
		this.__tableViewImpl.initialize();
	}

	, 
	settingsFromJavascriptObject: function (o) {
		var $self = this;
		var isParentInFrontForColumns = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "isParentInFrontForColumns");
		var isParentInFrontForRows = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "isParentInFrontForRows");
		var compactColumnHeaders = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "compactColumnHeaders");
		var compactRowHeaders = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "compactRowHeaders");
		return (function () { var $ret = new $.ig.TableViewSettings();
		$ret.isParentInFrontForColumns(isParentInFrontForColumns);
		$ret.isParentInFrontForRows(isParentInFrontForRows);
		$ret.compactColumnHeaders(compactColumnHeaders);
		$ret.compactRowHeaders(compactRowHeaders); return $ret;}());
	}

	, 
	tupleSortDirectionFromJavascriptObject: function (o_) {
		var $self = this;
		var memberNames = $.ig.util.cast($.ig.Array.prototype.$type, $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o_, "memberNames"));
		var index = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o_, "tupleIndex");
		var sortDirection = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o_, "sortDirection");
		var parsedSortDirection = $.ig.ListSortDirection.prototype.ascending;
		if (!String.isNullOrEmpty(sortDirection)) {
			sortDirection = sortDirection.toLowerCase();
			if (sortDirection == "descending") {
				parsedSortDirection = $.ig.ListSortDirection.prototype.descending;
			}

		}

		var comparer_ = null;
		
if ($.isFunction(o_.comparer)) {
    comparer_ = o_.comparer;
} else {
    comparer_ = function (o1, o2) {
        return parseFloat(o1 || -Infinity) - parseFloat(o2 || -Infinity);
    };
}
;
		return (function () { var $ret = new $.ig.TupleSortDirection();
		$ret.memberNames(memberNames);
		$ret.tupleIndex(index);
		$ret.sortDirection(parsedSortDirection);
		$ret.comparer(comparer_); return $ret;}());
	}

	, 
	tupleSortDirectionToJavascriptObject: function (tupleSortDirection) {
		var jsTupleSortDirection = $.ig.jQueryUtils.prototype.createJavascriptObject();
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(jsTupleSortDirection, "memberNames", tupleSortDirection.memberNames());
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(jsTupleSortDirection, "tupleIndex", tupleSortDirection.tupleIndex());
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(jsTupleSortDirection, "sortDirection", tupleSortDirection.sortDirection() == $.ig.ListSortDirection.prototype.ascending ? "ascending" : "descending");
		if (tupleSortDirection.comparer() != null) {
			$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(jsTupleSortDirection, "comparer", tupleSortDirection.comparer());
		}

		return jsTupleSortDirection;
	}

	, 
	levelSortDirectionFromJavascriptObject: function (o) {
		var levelUniqueName = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "levelUniqueName");
		var sortDirection = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "sortDirection");
		var sortBehavior = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "sortBehavior");
		if (!String.isNullOrEmpty(levelUniqueName)) {
			var levelSortDirection = new $.ig.LevelSortDirection();
			levelSortDirection.sortDirection($.ig.ListSortDirection.prototype.ascending);
			levelSortDirection.sortBehavior($.ig.LevelSortBehavior.prototype.system);
			levelSortDirection.levelUniqueName(levelUniqueName);
			if (!String.isNullOrEmpty(sortDirection)) {
				sortDirection = sortDirection.toLowerCase();
				if (sortDirection == "descending") {
					levelSortDirection.sortDirection($.ig.ListSortDirection.prototype.descending);
				}

			}

			if (!String.isNullOrEmpty(sortBehavior)) {
				sortBehavior = sortBehavior.toLowerCase();
				if (sortBehavior == "alphabetical") {
					levelSortDirection.sortBehavior($.ig.LevelSortBehavior.prototype.alphabetical);
				}

			}

			return levelSortDirection;

		} else {
			return null;
		}

	}

	, 
	levelSortDirectionToJavascriptObject: function (levelSortDirection) {
		var jsLevelSortDirection = $.ig.jQueryUtils.prototype.createJavascriptObject();
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(jsLevelSortDirection, "levelUniqueName", levelSortDirection.levelUniqueName());
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(jsLevelSortDirection, "sortDirection", levelSortDirection.sortDirection() == $.ig.ListSortDirection.prototype.ascending ? "ascending" : "descending");
		return jsLevelSortDirection;
	}
	, 
	$type: new $.ig.Type('OlapTableView', $.ig.Object.prototype.$type)
}, true);


$.ig.LevelSortBehavior.prototype.alphabetical = 0;
$.ig.LevelSortBehavior.prototype.system = 1;






$.ig.OlapMetadataTreeItemType.prototype.cube = 0;
$.ig.OlapMetadataTreeItemType.prototype.dimension = 1;
$.ig.OlapMetadataTreeItemType.prototype.group = 2;
$.ig.OlapMetadataTreeItemType.prototype.userDefinedHierarchy = 3;
$.ig.OlapMetadataTreeItemType.prototype.systemEnabledHierarchy = 4;
$.ig.OlapMetadataTreeItemType.prototype.parentChildHierarchy = 5;
$.ig.OlapMetadataTreeItemType.prototype.measure = 6;
$.ig.OlapMetadataTreeItemType.prototype.level1 = 7;
$.ig.OlapMetadataTreeItemType.prototype.level2 = 8;
$.ig.OlapMetadataTreeItemType.prototype.level3 = 9;
$.ig.OlapMetadataTreeItemType.prototype.level4 = 10;
$.ig.OlapMetadataTreeItemType.prototype.level5 = 11;
$.ig.OlapMetadataTreeItemType.prototype.kpiRoot = 12;
$.ig.OlapMetadataTreeItemType.prototype.kpi = 13;
$.ig.OlapMetadataTreeItemType.prototype.kpiValue = 14;
$.ig.OlapMetadataTreeItemType.prototype.kpiGoal = 15;
$.ig.OlapMetadataTreeItemType.prototype.kpiStatus = 16;
$.ig.OlapMetadataTreeItemType.prototype.kpiTrend = 17;
$.ig.OlapMetadataTreeItemType.prototype.kpiWeight = 18;


$.ig.MeasureListLocation.prototype.rows = 0;
$.ig.MeasureListLocation.prototype.columns = 1;


$.ig.HeaderCellsLayoutOrientation.prototype.horizontal = 0;
$.ig.HeaderCellsLayoutOrientation.prototype.vertical = 1;


$.ig.MemberType.prototype.unknown = 0;
$.ig.MemberType.prototype.regular = 1;
$.ig.MemberType.prototype.all = 2;
$.ig.MemberType.prototype.measure = 3;
$.ig.MemberType.prototype.formula = 4;


$.ig.CardinalityType.prototype.one = 0;
$.ig.CardinalityType.prototype.many = 1;


$.ig.AggregatorType.prototype.unknown = 0;
$.ig.AggregatorType.prototype.sum = 1;
$.ig.AggregatorType.prototype.count = 2;
$.ig.AggregatorType.prototype.min = 3;
$.ig.AggregatorType.prototype.max = 4;
$.ig.AggregatorType.prototype.average = 5;
$.ig.AggregatorType.prototype.variance = 6;
$.ig.AggregatorType.prototype.std = 7;
$.ig.AggregatorType.prototype.distinctCount = 8;
$.ig.AggregatorType.prototype.none = 9;
$.ig.AggregatorType.prototype.averageOfChildren = 10;
$.ig.AggregatorType.prototype.firstNonEmpty = 13;
$.ig.AggregatorType.prototype.lastNonEmpty = 14;
$.ig.AggregatorType.prototype.byAccount = 15;
$.ig.AggregatorType.prototype.calculated = 127;


$.ig.HierarchyOrigin.prototype.userDefined = 1;
$.ig.HierarchyOrigin.prototype.systemEnabled = 2;
$.ig.HierarchyOrigin.prototype.systemInternal = 4;



$.ig.DimensionType.prototype.unknown = 0;
$.ig.DimensionType.prototype.time = 1;
$.ig.DimensionType.prototype.measure = 2;
$.ig.DimensionType.prototype.other = 3;
$.ig.DimensionType.prototype.quantitative = 5;
$.ig.DimensionType.prototype.accounts = 6;
$.ig.DimensionType.prototype.customers = 7;
$.ig.DimensionType.prototype.products = 8;
$.ig.DimensionType.prototype.scenario = 9;
$.ig.DimensionType.prototype.utility = 10;
$.ig.DimensionType.prototype.currency = 11;
$.ig.DimensionType.prototype.rates = 12;
$.ig.DimensionType.prototype.channel = 13;
$.ig.DimensionType.prototype.promotion = 14;
$.ig.DimensionType.prototype.organization = 15;
$.ig.DimensionType.prototype.billOfMaterials = 16;
$.ig.DimensionType.prototype.geography = 17;



$.ig.CubeType.prototype.cube = 0;
$.ig.CubeType.prototype.dimension = 1;
$.ig.CubeType.prototype.unknown = 2;


$.ig.AxisDefinitionParser.prototype.elementBegin = "[";
$.ig.AxisDefinitionParser.prototype.elementEnd = "]";
$.ig.AxisDefinitionParser.prototype.filterGroupBegin = "{";
$.ig.AxisDefinitionParser.prototype.filterGroupEnd = "}";
$.ig.AxisDefinitionParser.prototype.elementSeparator = ",";


$.ig.CoreOlapElementParser.prototype.elementBegin = "[";
$.ig.CoreOlapElementParser.prototype.elementEnd = "]";
$.ig.CoreOlapElementParser.prototype.elementSeparator = ".";
$.ig.CoreOlapElementParser.prototype.memberNameStart = "&";


$.ig.util.extCopy($.ig.TaskExtensions, [[[$.ig.Task, $.ig.Task$1], ['continueWithTask$1', 'continueWithTask$2']]]);
$.ig.util.extCopy($.ig.Queryable, [[[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.ArrayListCollection$1], ['asQueryable']]]);
$.ig.util.extCopy($.ig.Enumerable, [[[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.ArrayListCollection$1], ['where$1', 'where$11', 'select$2', 'selectMany$2', 'last$1', 'first$1', 'firstOrDefault$1', 'orderBy$2', 'orderByDescending$2', 'toList$1', 'concat$1', 'max', 'max$1', 'min', 'min$1', 'count$1', 'reverse$1', 'take$1', 'skip$1', 'any$1', 'contains$1', 'union$1', 'toArray$1', 'elementAt$1', 'sum', 'sum$1']], [[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.ArrayListCollection$1], ['ofType$1', 'cast$1']]]);

} (jQuery));


// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["IXmlaDataProvider:a", 
"IOlapDiscoverDataProvider:b", 
"Task$1:c", 
"Task:d", 
"Object:e", 
"Type:f", 
"Boolean:g", 
"ValueType:h", 
"Void:i", 
"String:j", 
"IComparable:k", 
"Number:l", 
"Number:m", 
"Single:n", 
"Number:o", 
"String:p", 
"Array:q", 
"RegExp:r", 
"RuntimeTypeHandle:s", 
"MethodInfo:t", 
"MethodBase:u", 
"MemberInfo:v", 
"ParameterInfo:w", 
"TypeCode:x", 
"Enum:y", 
"ConstructorInfo:z", 
"JQueryPromise:aa", 
"Action:ab", 
"MulticastDelegate:ac", 
"IntPtr:ad", 
"Action$1:ae", 
"AggregateException:af", 
"Error:ag", 
"TaskStatus:ah", 
"Func$2:ai", 
"TaskCompletionSource$1:aj", 
"JQueryDeferred:ak", 
"JQuery:al", 
"JQueryObject:am", 
"Element:an", 
"ElementAttributeCollection:ao", 
"ElementCollection:ap", 
"WebStyle:aq", 
"ElementNodeType:ar", 
"Document:as", 
"EventListener:at", 
"IElementEventHandler:au", 
"ElementEventHandler:av", 
"ElementAttribute:aw", 
"JQueryPosition:ax", 
"JQueryCallback:ay", 
"JQueryEvent:az", 
"JQueryUICallback:a0", 
"Script:a1", 
"IEnumerable$1:a2", 
"IEnumerable:a3", 
"IEnumerator:a4", 
"IEnumerator$1:a5", 
"IOlapExecuteCommandProvider:a6", 
"MdxDataSourceImpl:a7", 
"OlapDataSource:a8", 
"IOlapDataSource:a9", 
"OlapMetadataTreeItem:ba", 
"ICoreOlapElement:bb", 
"OlapMetadataTreeItemType:bc", 
"IList$1:bd", 
"ICollection$1:be", 
"MeasureListLocation:bf", 
"OlapResult:bg", 
"ArrayListCollection$1:bh", 
"INotifyCollectionChanged:bi", 
"NotifyCollectionChangedEventHandler:bj", 
"NotifyCollectionChangedEventArgs:bk", 
"EventArgs:bl", 
"NotifyCollectionChangedAction:bm", 
"IList:bn", 
"ICollection:bo", 
"List$1:bp", 
"IArrayList:bq", 
"Array:br", 
"CompareCallback:bs", 
"IDisposable:bt", 
"IArray:bu", 
"Date:bv", 
"Date:bw", 
"Number:bx", 
"Func$3:by", 
"Delegate:bz", 
"NotImplementedException:b0", 
"Cube:b1", 
"CubeType:b2", 
"Member:b3", 
"MemberType:b4", 
"Nullable$1:b5", 
"MeasureGroup:b6", 
"DataSourceBaseOptions:b7", 
"IOlapDataProviderFactory:b8", 
"OlapResultView:b9", 
"ArgumentNullException:ca", 
"OlapResultAxis:cb", 
"PositionResolver$2:cc", 
"PositionItemInfo$2:cd", 
"Dictionary$2:ce", 
"IDictionary$2:cf", 
"IDictionary:cg", 
"Dictionary:ch", 
"IEqualityComparer$1:ci", 
"KeyValuePair$2:cj", 
"IHierarchicalPositionItem$2:ck", 
"IPositionItem$2:cl", 
"IPosition$2:cm", 
"Math:cn", 
"Number:co", 
"Number:cp", 
"Number:cq", 
"Number:cr", 
"Number:cs", 
"Number:ct", 
"Number:cu", 
"Enumerable:cv", 
"IOrderedEnumerable$1:cw", 
"SortedList$1:cx", 
"EventHandler$1:cy", 
"ListSortDirection:cz", 
"OlapResultTuple:c0", 
"ReadOnlyCollection$1:c1", 
"OlapResultAxisMember:c2", 
"OlapResultCell:c3", 
"InvalidOperationException:c4", 
"CubeMetaItemsCache:c5", 
"MeasureGroupMetaItemsCache:c6", 
"MeasureGroupDimension:c7", 
"CardinalityType:c8", 
"Dimension:c9", 
"DimensionType:da", 
"Measure:db", 
"AggregatorType:dc", 
"Kpi:dd", 
"Level:de", 
"Tuple$2:df", 
"KpiMeasure:dg", 
"MeasureList:dh", 
"Hierarchy:di", 
"HierarchyOrigin:dj", 
"NotSupportedException:dk", 
"PositionInfo:dl", 
"TaskExtensions:dm", 
"AxisElement:dn", 
"AxisDefinitionParser:dp", 
"Debug:dq", 
"TaskFactory:dr", 
"MetaTreeHelper:ds", 
"HierarchyItemPosition:dt", 
"KpiDimension:du", 
"MdxDataSourceOptions:dv", 
"MdxSettings:dw", 
"MdxDimensionAxisSettings:dx", 
"MdxAxisSettings:dy", 
"MdxSetSettings:dz", 
"MdxSlicerAxisSettings:d0", 
"ObservableCollection$1:d1", 
"INotifyPropertyChanged:d2", 
"PropertyChangedEventHandler:d3", 
"PropertyChangedEventArgs:d4", 
"Catalog:d5", 
"MdxSlicerAxisProvider:d6", 
"IMdxAxisProvider:d7", 
"IMdxAxis:d8", 
"IMdxExpression:d9", 
"IMdxSet:ea", 
"IMdxElement:eb", 
"MdxElementType:ec", 
"MdxSlicerAxis:ed", 
"MdxAxis:ee", 
"StringBuilder:ef", 
"Environment:eg", 
"IMdxSlicerAxis:eh", 
"IMdxExtendedFilterInfo:ei", 
"IMdxFilterInfo:ej", 
"IAxisFilterElement:ek", 
"IMdxCollectionElement:el", 
"MdxSlicerAxisBuilder:em", 
"MdxAxisFilterElement:en", 
"MdxElementCollectionElement:eo", 
"MdxSingleElement:ep", 
"MdxElement:eq", 
"IMdxItemElement:er", 
"ArgumentException:es", 
"MdxSlicerSet:et", 
"MdxSet:eu", 
"MdxLevelMembersElement:ev", 
"MdxChildrenCollectionElement:ew", 
"MdxDimensionMember:ex", 
"KeyValueItem:ey", 
"MdxDimensionAxisProvider:ez", 
"IMdxDimensionAxisProvider:e0", 
"ResultViewHelper:e1", 
"MdxQueryBuilder:e2", 
"MdxCalculatedMembersCache:e3", 
"XmlaDataProvider:e4", 
"ICoreXmlaConnection:e5", 
"IConnection:e6", 
"XmlaSoapWebClient$1:e7", 
"XmlaSoapWebClient:e8", 
"ICredentials:e9", 
"NetworkCredential:fa", 
"Uri:fb", 
"Encoding:fc", 
"UTF8Encoding:fd", 
"UnicodeEncoding:fe", 
"WebClient:ff", 
"WebHeaderCollection:fg", 
"NameValueCollection:fh", 
"UploadStringCompletedEventHandler:fi", 
"UploadStringCompletedEventArgs:fj", 
"AsyncCompletedEventArgs:fk", 
"IXmlaSoapMethod:fl", 
"XmlaPropertiesCollection:fm", 
"XmlaQueryProperty:fn", 
"XNamespace:fo", 
"XmlaSoapMessageBuilder:fp", 
"XElement:fq", 
"XContainer:fr", 
"XNode:fs", 
"XObject:ft", 
"XmlNode:fu", 
"XmlNodeList:fv", 
"XmlNamedNodeMap:fw", 
"XmlNodeType:fx", 
"XmlDocument:fy", 
"XmlElement:fz", 
"XmlLinkedNode:f0", 
"XmlAttribute:f1", 
"XmlUtils:f2", 
"XName:f3", 
"XDocument:f4", 
"XAttribute:f5", 
"RequestCompletedEventArgs$1:f6", 
"XmlaSoapFaultXmlTypeSerializer:f7", 
"IXmlTypeSerializer$1:f8", 
"XmlaSoapFault:f9", 
"FaultDetail:ga", 
"FaultError:gb", 
"SerializerUtils:gc", 
"ErrorXmlTypeSerializer:gd", 
"FaultReason:ge", 
"FaultCode:gf", 
"FaultException$1:gg", 
"FaultException:gh", 
"DiscoverResponseResult:gi", 
"XmlaSoapMethodResult:gj", 
"IXmlaMethodResult:gk", 
"ExecuteResponseResult:gl", 
"DatabaseXmlTypeSerializer:gm", 
"CubeXmlTypeSerializer:gn", 
"DimensionXmlTypeSerializer:go", 
"HierarchyXmlTypeSerializer:gp", 
"LevelXmlTypeSerializer:gq", 
"MeasureXmlTypeSerializer:gr", 
"MeasureGroupXmlTypeSerializer:gs", 
"MeasureGroupDimensionXmlTypeSerializer:gt", 
"MemberXmlTypeSerializer:gu", 
"KpiXmlTypeSerializer:gv", 
"ResultXmlTypeSerializer:gw", 
"ArraySerializer:gx", 
"AxisXmlTypeSerializer:gy", 
"TupleXmlTypeSerializer:gz", 
"AxisMemberXmlTypeSerializer:g0", 
"CellXmlTypeSerializer:g1", 
"XmlaSoapMethodExecute:g2", 
"XmlaSoapMethod:g3", 
"XmlaSoapMethodDiscover:g4", 
"XmlaSoapMessageHeader:g5", 
"CatalogConstants:g6", 
"DbSchemaConstants:ha", 
"CubeConstants:hf", 
"DimensionConstants:hg", 
"HierarchyConstants:hh", 
"InstanceConstants:hi", 
"KpiConstants:hj", 
"LevelConstants:hk", 
"MeasureConstants:hl", 
"MeasureGroupConstants:hm", 
"MeasureGroupDimensionConstants:hn", 
"MemberConstants:ho", 
"OlapSchemaConstants:hp", 
"CubeRestrictions:hq", 
"DimensionRestrictions:hr", 
"HierarchyRestrictions:hs", 
"KpiRestrictions:ht", 
"LevelRestrictions:hu", 
"MeasureRestrictions:hv", 
"MeasureGroupRestrictions:hw", 
"MeasureGroupDimensionRestrictions:hx", 
"MemberRestrictions:hy", 
"XmlaConstants:hz", 
"XmlaNamespace:h0", 
"IXmlaDataProviderFactory:h6", 
"DefaultXmlaDataProviderFactory:h7", 
"XmlaConnection:h8", 
"RemoteXmlaDataProviderFactory:h9", 
"JsonRemoteRequestSerializer:ia", 
"IRemoteRequestSerializer:ib", 
"RemoteRequest:ic", 
"RemoteRequestType:id", 
"JavaScriptSerializer:ie", 
"RemoteRequestJsonTypeSeriazlier:ig", 
"JsonTypeSeriazlierBase$1:ih", 
"IJsonTypeSerializer$1:ii", 
"JsonSerializerUtils:ij", 
"jQueryUtils:ik", 
"JsonRemoteResponseSerializer:il", 
"IRemoteResponseSerializer:im", 
"ArrayJsonSerializer:io", 
"CatalogJsonTypeSeriazlier:ip", 
"CubeJsonTypeSeriazlier:iq", 
"DimensionJsonTypeSeriazlier:ir", 
"HierarchyJsonTypeSeriazlier:is", 
"LevelJsonTypeSeriazlier:it", 
"MeasureJsonTypeSeriazlier:iu", 
"MeasureGroupJsonTypeSeriazlier:iv", 
"MeasureGroupDimensionJsonTypeSeriazlier:iw", 
"MemberJsonTypeSeriazlier:ix", 
"KpiJsonTypeSeriazlier:iy", 
"ResultJsonTypeSeriazlier:iz", 
"AxisJsonTypeSeriazlier:i0", 
"TupleJsonTypeSeriazlier:i1", 
"AxisMemberJsonTypeSeriazlier:i2", 
"CellJsonTypeSeriazlier:i3", 
"RemoteXmlaDataProvder:i4", 
"XmlaDataSourceImpl:i5", 
"XmlaDataSourceOptions:i6", 
"RequestOptions:i7", 
"XmlaDiscoverProperties:i8", 
"CustomRemoteXmlaRequestSerializer:ja", 
"CustomRemoteXmlaResponseSerializer:jb", 
"OlapXmlaDataSource:jc", 
"DataSourceBase:jd", 
"AbstractEnumerable:je", 
"Func$1:jf", 
"AbstractEnumerator:jg", 
"GenericEnumerable$1:jh", 
"GenericEnumerator$1:ji"]);

$.ig.util.defType('RemoteRequestType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('RemoteRequestType', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('MdxElementType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MdxElementType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('XmlaSoapMessageHeader', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('XmlaSoapMessageHeader', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('IXmlaDataProvider', 'Object', {
	$type: new $.ig.Type('IXmlaDataProvider', null, [$.ig.IOlapDiscoverDataProvider.prototype.$type, $.ig.IOlapExecuteCommandProvider.prototype.$type])
}, true);

$.ig.util.defType('MdxDataSourceImpl', 'OlapDataSource', {
	__mdxAxes: null
	, 
	__useResultViewCache: false
	, 
	init: function (options) {


		this.__mdxAxes = new $.ig.List$1($.ig.MdxDimensionAxisProvider.prototype.$type, 0);

		$.ig.OlapDataSource.prototype.init.call(this, options);
			this.mdxSettings(options.mdxSettings());
			this.mdxSourceOptions(options);
			this.dataProviderFactory(options.dataProviderFactory());
			this.__useResultViewCache = true;
			if (this.mdxSourceOptions() != null) {
				this.__useResultViewCache = this.mdxSourceOptions().enableResultCache() == true;
			}

	}

	, 
	_mdxSourceOptions: null,
	mdxSourceOptions: function (value) {
		if (arguments.length === 1) {
			this._mdxSourceOptions = value;
			return value;
		} else {
			return this._mdxSourceOptions;
		}
	}

	, 
	_mdxSettings: null,
	mdxSettings: function (value) {
		if (arguments.length === 1) {
			this._mdxSettings = value;
			return value;
		} else {
			return this._mdxSettings;
		}
	}

	, 
	_catalog: null,
	catalog: function (value) {
		if (arguments.length === 1) {
			this._catalog = value;
			return value;
		} else {
			return this._catalog;
		}
	}

	, 
	setCatalog: function (catalogName) {
		if (!this.isInitialized()) {
			throw new $.ig.InvalidOperationException(1, "Data source is not initialized.");
		}

		return this.onCatalogChanged(catalogName);
	}

	, 
	removePositionsAtIndex: function (hostPosition, maxValidIndex) {
		if (hostPosition.positionItemIndex() == maxValidIndex) {
			hostPosition.clear();

		} else {
			var en = hostPosition.values().getEnumerator();
			while (en.moveNext()) {
				var positionItemInfo = en.current();
				this.removePositionsAtIndex(positionItemInfo, maxValidIndex);
			}

		}

	}

	, 
	createSlicerAxis: function (columnsFilters, rowsFilters, filterFilters, mdxSettings) {
		var $self = this;
		var filters = new $.ig.List$1($.ig.AxisElement.prototype.$type, 0);
		var en = filterFilters.getEnumerator();
		while (en.moveNext()) {
			var filterFilter = en.current();
			var filterCopy = new $.ig.AxisElement(filterFilter.name(), new $.ig.List$1(String, 0));
			for (var i = 0; i < filterFilter.memberNames().count(); i++) {
				var memberName = filterFilter.memberNames().item(i);
				var member;
				if ((function () { var $ret = $self.cubeCache().tryGetMember1(memberName, member); member = $ret.member; return $ret.ret; }())) {
					if (member.scope().hasValue() == false) {
						filterCopy.memberNames().add(memberName);
					}

				}

			}

			filters.add(filterCopy);
		}

		var rows = new $.ig.List$1($.ig.AxisElement.prototype.$type, 0);
		var en1 = rowsFilters.getEnumerator();
		while (en1.moveNext()) {
			var rowFilter = en1.current();
			var filterCopy1 = new $.ig.AxisElement(rowFilter.name(), new $.ig.List$1(String, 0));
			for (var i1 = 0; i1 < rowFilter.memberNames().count(); i1++) {
				var memberName1 = rowFilter.memberNames().item(i1);
				var member1;
				if ((function () { var $ret = $self.cubeCache().tryGetMember1(memberName1, member1); member1 = $ret.member; return $ret.ret; }())) {
					if (member1.scope().hasValue() == false) {
						filterCopy1.memberNames().add(memberName1);
					}

				}

			}

			rows.add(filterCopy1);
		}

		var columns = new $.ig.List$1($.ig.AxisElement.prototype.$type, 0);
		var en2 = columnsFilters.getEnumerator();
		while (en2.moveNext()) {
			var columnsFilter = en2.current();
			var filterCopy2 = new $.ig.AxisElement(columnsFilter.name(), new $.ig.List$1(String, 0));
			for (var i2 = 0; i2 < columnsFilter.memberNames().count(); i2++) {
				var memberName2 = columnsFilter.memberNames().item(i2);
				var member2;
				if ((function () { var $ret = $self.cubeCache().tryGetMember1(memberName2, member2); member2 = $ret.member; return $ret.ret; }())) {
					if (member2.scope().hasValue() == false) {
						filterCopy2.memberNames().add(memberName2);
					}

				}

			}

			columns.add(filterCopy2);
		}

		return new $.ig.MdxSlicerAxisProvider($self, columns, rows, filters, mdxSettings);
	}

	, 
	getMembersOfLevel: function (levelUniqueName) {
		var $self = this;
		var levelName = levelUniqueName;
		var properties = $self.getProviderDefaultProperties();
		var restrictions = $self.getProviderDefaultRestrictions();
		if (restrictions != null) {
			restrictions.add((function () { var $ret = new $.ig.KeyValueItem();
			$ret.key($.ig.MemberRestrictions.prototype.levelUniqueName);
			$ret.value(levelUniqueName); return $ret;}()));
		}

		var xmlaDataProvider = $self.dataProviderFactory().createDataProvider();
		var getMembersTask = xmlaDataProvider.discoverMembersAsync(properties, restrictions);
		getMembersTask.continueWith1(function (t) {
			var en = t.result().getEnumerator();
			while (en.moveNext()) {
				var member = en.current();
				$self.cubeCache().addMember(member);
			}

			$self.cubeCache().setIsLevelLoaded(levelName);
		});
		return getMembersTask;
	}

	, 
	getMembersOfHierarchy: function (hierarchyUniqueName) {
		var $self = this;
		var hierarchyName = hierarchyUniqueName;
		var properties = $self.getProviderDefaultProperties();
		var restrictions = $self.getProviderDefaultRestrictions();
		if (restrictions != null) {
			restrictions.add((function () { var $ret = new $.ig.KeyValueItem();
			$ret.key($.ig.MemberRestrictions.prototype.hierarchyUniqueName);
			$ret.value(hierarchyUniqueName); return $ret;}()));
		}

		var xmlaDataProvider = $self.dataProviderFactory().createDataProvider();
		var getMembersTask = xmlaDataProvider.discoverMembersAsync(properties, restrictions);
		getMembersTask.continueWith1(function (t) {
			var en = t.result().getEnumerator();
			while (en.moveNext()) {
				var member = en.current();
				$self.cubeCache().addMember(member);
			}

			$self.cubeCache().setIsHierarchyLoaded(hierarchyName);
		});
		return getMembersTask;
	}

	, 
	getMembersOfMember: function (memberUniqueName) {
		var $self = this;
		var properties = $self.getProviderDefaultProperties();
		var restrictions = $self.getProviderDefaultRestrictions();
		if (restrictions != null) {
			restrictions.add((function () { var $ret = new $.ig.KeyValueItem();
			$ret.key($.ig.MemberRestrictions.prototype.memberUniqueName);
			$ret.value(memberUniqueName); return $ret;}()));
			restrictions.add((function () { var $ret = new $.ig.KeyValueItem();
			$ret.key($.ig.MemberRestrictions.prototype.treeOp);
			$ret.value("1"); return $ret;}()));
		}

		var xmlaDataProvider = $self.dataProviderFactory().createDataProvider();
		var getMembersTask = xmlaDataProvider.discoverMembersAsync(properties, restrictions);
		getMembersTask.continueWithTask$2($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Member.prototype.$type), $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Member.prototype.$type), function (t) { return $self.preloadLevelMembers(t.result()); });
		return getMembersTask;
	}

	, 
	preloadLevelMembers: function (members) {
		var $self = this;
		var loadedMembers = new $.ig.List$1($.ig.Member.prototype.$type, 0);
		var en = members.getEnumerator();
		while (en.moveNext()) {
			var member = en.current();
			loadedMembers.add(member);
			break;
		}

		if (loadedMembers.count() > 0) {
			var levelUniqueName = loadedMembers.item(0).levelUniqueName();
			if (!$self.cubeCache().isLevelLoaded(levelUniqueName)) {
				return $self.getMembersOfLevel(levelUniqueName).continueWith$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Member.prototype.$type), function (t1) { return members; });
			}

		}

		var tcs = new $.ig.TaskCompletionSource$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Member.prototype.$type), 0);
		tcs.setResult(members);
		return tcs.task();
	}

	, 
	updateAxisMemberSortKeys: function (result) {
		var $self = this;
		if (result.isEmpty()) {
			return;
		}

		var en = result.axes().getEnumerator();
		while (en.moveNext()) {
			var axis = en.current();
			var tuples = axis.tuples();
			for (var i = 0; i < tuples.count(); i++) {
				var members = tuples.__inner[i].members();
				for (var j = 0; j < members.count(); j++) {
					var axisMember = members.item(j);
					var memberOrdinal;
					if ((function () { var $ret = $self.cubeCache().tryGetMemberOrdinal(axisMember.uniqueName(), memberOrdinal); memberOrdinal = $ret.memberOrdinal; return $ret.ret; }())) {
						axisMember.ordinal(memberOrdinal);
					}

				}

			}

		}

	}

	, 
	updateAxisProvidersCache1: function (hasColumns, hasRows) {
		var axisIndex = 0;
		var measureListIndex = this.measureListIndex();
		if (hasColumns) {
			var columnsAxisProvider = this.getAxisProvider(axisIndex);
			if (columnsAxisProvider != null && this.measureListLocation() == $.ig.MeasureListLocation.prototype.columns) {
				if (measureListIndex > -1) {
					var rootPosition = columnsAxisProvider.rootPositionInfo();
					if (rootPosition != null) {
						this.removePositionsAtIndex(rootPosition, measureListIndex - 1);
					}

					columnsAxisProvider.clearAxis();
				}

			}

			axisIndex++;
		}

		if (hasRows) {
			var rowsAxisProvider = this.getAxisProvider(axisIndex);
			if (rowsAxisProvider != null && this.measureListLocation() == $.ig.MeasureListLocation.prototype.rows) {
				if (measureListIndex > -1) {
					var rootPosition1 = rowsAxisProvider.rootPositionInfo();
					if (rootPosition1 != null) {
						this.removePositionsAtIndex(rootPosition1, measureListIndex - 1);
					}

					rowsAxisProvider.clearAxis();
				}

			}

		}

	}

	, 
	updateAxisProvidersCache: function (result, hasRows, hasColumns) {
		var axisIndex = 0;
		if (hasColumns) {
			var axis = axisIndex < result.axes().count() ? result.axes().item(axisIndex) : null;
			var axisProvider = axis != null ? this.getAxisProvider(axisIndex) : null;
			if (axisProvider != null) {
				axisProvider.rootPositionInfo(axis.positionResolver().rootPositionInfo());
				axisProvider.clearAxis();
			}

			axisIndex++;
		}

		if (hasRows) {
			var axis1 = axisIndex < result.axes().count() ? result.axes().item(axisIndex) : null;
			var axisProvider1 = axis1 != null ? this.getAxisProvider(axisIndex) : null;
			if (axisProvider1 != null) {
				axisProvider1.rootPositionInfo(axis1.positionResolver().rootPositionInfo());
				axisProvider1.clearAxis();
			}

			axisIndex++;
		}

	}

	, 
	expandCollapseTupleMembers: function (hasColumns, hasRows, useResultViewCahce, axisPositionsMap) {
		var $self = this;
		$self.collapseTupleMembers(hasColumns, hasRows, useResultViewCahce);
		var axisToAdd = new $.ig.Dictionary$2(String, $.ig.Boolean.prototype.$type, 0);
		var positionsToExpand = $self.getPositionsToExpand();
		axisPositionsMap = new $.ig.Dictionary$2(String, $.ig.IList$1.prototype.$type.specialize($.ig.PositionInfo.prototype.$type), 0);
		for (var i = 0; i < positionsToExpand.count(); i++) {
			var positionInfo = positionsToExpand.item(i);
			var axisPositions;
			if (!(function () { var $ret = axisPositionsMap.tryGetValue(positionInfo.axisName(), axisPositions); axisPositions = $ret.value; return $ret.ret; }())) {
				axisPositions = new $.ig.List$1($.ig.PositionInfo.prototype.$type, 0);
				axisPositionsMap.add(positionInfo.axisName(), axisPositions);
			}

			axisPositions.add(positionInfo);
			if ($self.resultView() == null) {
				$self.resultView(new $.ig.OlapResultView($self.result(), $self.result(), hasColumns, hasRows));
			}

			var resolvedCache = $self.resultView().expandTupleMember(positionInfo.axisName(), positionInfo.tupleIndex(), positionInfo.memberIndex());
			if (resolvedCache == null) {
				axisToAdd.item(positionInfo.axisName(), true);

			} else {
				var oldResultView = $self.resultView();
				$self.resultView(resolvedCache);
				$.ig.ResultViewHelper.prototype.syncPositionExpansionState(positionInfo.axisName(), oldResultView, $self.resultView());
				$.ig.ResultViewHelper.prototype.setPositionIsExpaned2(positionInfo.axisName(), positionInfo.tupleIndex(), positionInfo.memberIndex(), true, $self.resultView());
				$self.result($self.resultView().visibleResult());
				$self.updateAxisMemberSortKeys($self.result());
				$self.updateAxisProvidersCache($self.resultView().visibleResult(), hasRows, hasColumns);
			}

		}

		var axisesToExpand = new $.ig.List$1($.ig.IMdxAxis.prototype.$type, 0);
		var en = axisPositionsMap.getEnumerator();
		while (en.moveNext()) {
			var axisPositions1 = en.current();
			var resultAxis = $self.getResultAxis1(axisPositions1.key());
			if (resultAxis == null) {
				continue;
			}

			if (resultAxis.positionResolver().hasUnregisterdPositions()) {
				resultAxis.positionResolver().completeRegisterPositions();
			}

			var positionsToExtend = new $.ig.List$1($.ig.IPositionItem$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), 0);
			var en1 = axisPositions1.value().getEnumerator();
			while (en1.moveNext()) {
				var positionInfo1 = en1.current();
				if (positionInfo1.tupleIndex() < resultAxis.tuples().count()) {
					var position = resultAxis.tuples().__inner[positionInfo1.tupleIndex()];
					var positionItem = position.item(positionInfo1.memberIndex());
					positionsToExtend.add(positionItem);
				}

			}

			if (positionsToExtend.count() > 0) {
				var axisToExtendIndex = $self.result().axes().indexOf(resultAxis);
				var axisProvider = $self.getAxisProvider(axisToExtendIndex);
				var mdxAxis = axisProvider.createAxis(axisToExtendIndex);
				var add = false;
				if ((function () { var $ret = axisToAdd.tryGetValue(resultAxis.name(), add); add = $ret.value; return $ret.ret; }()) && add) {
					axisProvider = new $.ig.MdxDimensionAxisProvider(1, resultAxis, axisProvider.mdxSettings(), positionsToExtend);
					var partialAxis = axisProvider.extendAxis(mdxAxis, mdxAxis.axisIndex());
					axisesToExpand.add(partialAxis);
				}

			}

		}

		$self.getPositionsToExpand().clear();
		return {
			ret: axisesToExpand, 
			axisPositionsMap: axisPositionsMap
		};
		return {
			axisPositionsMap: axisPositionsMap
		};
	}

	, 
	getMdxAxis: function (axisToUpdate, rebuildAxis, axisIndex) {
		var axisProvider = null;
		if (axisToUpdate.count() > 0) {
			axisProvider = this.getAxisProvider(axisIndex);
			if (rebuildAxis) {
				var rootPositionCache = null;
				if (axisProvider != null) {
					rootPositionCache = axisProvider.rootPositionInfo();
				}

				var settings = axisIndex == 0 ? this.mdxSettings().columnsAxisSettings() : this.mdxSettings().rowsAxisSettings();
				axisProvider = new $.ig.MdxDimensionAxisProvider(0, this, settings, axisToUpdate, rootPositionCache);
				this.setAxisProvider(axisIndex, axisProvider);
			}

		}

		if (axisProvider != null) {
			return axisProvider.createAxis(axisIndex);
		}

		return null;
	}

	, 
	collapseTupleMembers: function (hasColumns, hasRows, useResultViewCahce) {
		var $self = this;
		if ($self.result() != null) {
			var axisPositionsMap = new $.ig.Dictionary$2(String, $.ig.IList$1.prototype.$type.specialize($.ig.PositionInfo.prototype.$type), 0);
			var positionsToCollapse = $self.getPositionsToCollapse();
			for (var i = 0; i < positionsToCollapse.count(); i++) {
				var positionInfo = positionsToCollapse.item(i);
				var axisPositions;
				if (!(function () { var $ret = axisPositionsMap.tryGetValue(positionInfo.axisName(), axisPositions); axisPositions = $ret.value; return $ret.ret; }())) {
					axisPositions = new $.ig.List$1($.ig.PositionInfo.prototype.$type, 0);
					axisPositionsMap.add(positionInfo.axisName(), axisPositions);
				}

				axisPositions.add(positionInfo);
				if (useResultViewCahce) {
					if ($self.resultView() == null) {
						$self.resultView(new $.ig.OlapResultView($self.result(), $self.result(), hasColumns, hasRows));

					} else {
						$self.resultView($self.resultView().collapseTupleMember(positionInfo.axisName(), positionInfo.tupleIndex(), positionInfo.memberIndex()));
						$self.result($self.resultView().visibleResult());
						$self.updateAxisMemberSortKeys($self.result());
						$self.updateAxisProvidersCache($self.resultView().visibleResult(), hasRows, hasColumns);
					}

				}

			}

			var axesToUpdate = new $.ig.List$1($.ig.OlapResultAxis.prototype.$type, 0);
			var en = axisPositionsMap.getEnumerator();
			while (en.moveNext()) {
				var positionGroup = en.current();
				var resultAxis = $self.getResultAxis1(positionGroup.key());
				if (resultAxis == null) {
					continue;
				}

				if (resultAxis.positionResolver().hasUnregisterdPositions()) {
					resultAxis.positionResolver().completeRegisterPositions();
				}

				if (!axesToUpdate.contains(resultAxis)) {
					axesToUpdate.add(resultAxis);
				}

				if (!useResultViewCahce) {
					var en1 = positionGroup.value().getEnumerator();
					while (en1.moveNext()) {
						var positionInfo1 = en1.current();
						if (positionInfo1.tupleIndex() < resultAxis.tuples().count()) {
							var position = resultAxis.tuples().__inner[positionInfo1.tupleIndex()];
							var positionItem = position.item(positionInfo1.memberIndex());
							var hostItemInfo = resultAxis.positionResolver().getHostPositionItemInfo(position, positionInfo1.memberIndex());
							var itemInfo = hostItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.key() == positionItem.key(); }).firstOrDefault$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
							if (itemInfo != null) {
								itemInfo.isExpanded(false);
							}

						}

					}

				}

			}

			if (axesToUpdate.count() > 0) {
				if (!useResultViewCahce && !$self.result().isEmpty()) {
					$self.updateAxisProvidersCache($self.result(), hasRows, hasColumns);
				}

				var en2 = axesToUpdate.getEnumerator();
				while (en2.moveNext()) {
					var axis = en2.current();
					var index = hasRows && axis.name() == "Axis1" ? 1 : 0;
					var axisProvider = $self.getAxisProvider(index);
					axisProvider.clearAxis();
				}

			}

			$self.getPositionsToCollapse().clear();
		}

	}

	, 
	clearCatalogCache: function () {
		this.catalog(null);
		this.cubes(new $.ig.ArrayListCollection$1($.ig.Cube.prototype.$type));
		this.clearCubeCache();
	}

	, 
	loadCatalogs: function () {
		var $self = this;
		var provider = $self.dataProviderFactory().createDataProvider();
		var properties = $self.getProviderDefaultProperties();
		var task = provider.discoverCatalogsAsync(properties, null).continueWithTask$2($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Catalog.prototype.$type), $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Catalog.prototype.$type), function (t) {
			$self.catalogs($self.toArrayListCollection$1($.ig.Catalog.prototype.$type, t.result()));
			return t;
		});
		return task;
	}

	, 
	onCatalogChanged: function (catalogName) {
		var $self = this;
		if (String.isNullOrEmpty(catalogName)) {
			if (catalogName == null) {
				throw new $.ig.ArgumentNullException("catalogName");
			}

			throw new $.ig.InvalidOperationException(1, "catalogName cannot be empty.");
		}

		var setCatalogCompleted = new $.ig.TaskCompletionSource$1($.ig.IList$1.prototype.$type.specialize($.ig.Cube.prototype.$type), 0);
		if ($self.catalog() != null) {
			if ($self.catalog().name() == catalogName) {
				setCatalogCompleted.setResult($self.cubes());
				return setCatalogCompleted.task();
			}

			$self.clearCatalogCache();
		}

		var en = $self.catalogs().getEnumerator();
		while (en.moveNext()) {
			var catalog = en.current();
			if (catalog.name() == catalogName) {
				$self.catalog(catalog);
				break;
			}

		}

		if ($self.cubes() == null || $self.cubes().count() == 0) {
			$self.loadCubes(catalogName).continueWith1(function (t1) {
				if (t1.exception() == null) {
					setCatalogCompleted.setResult(t1.result());
					return;
				}

				setCatalogCompleted.setException(t1.exception());
			});

		} else {
			setCatalogCompleted.setResult($self.cubes());
		}

		return setCatalogCompleted.task();
	}

	, 
	onInitialize: function () {
		var $self = this;
		var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		if ($self.isInitialized()) {
			tcs.setResult($self.metadataTree());
			return tcs.task();
		}

		var catalogName = $self.mdxSourceOptions().catalog();
		var cubeName = $self.mdxSourceOptions().cube();
		($self.columnAxis()).collectionChanged = $.ig.Delegate.prototype.combine(($self.columnAxis()).collectionChanged, $self.columnsAxisChanged.runOn($self));
		($self.rowAxis()).collectionChanged = $.ig.Delegate.prototype.combine(($self.rowAxis()).collectionChanged, $self.rowsAxisChanged.runOn($self));
		($self.filters()).collectionChanged = $.ig.Delegate.prototype.combine(($self.filters()).collectionChanged, $self.filtersAxisChanged.runOn($self));
		($self.measures()).collectionChanged = $.ig.Delegate.prototype.combine(($self.measures()).collectionChanged, $self.measuresAxisChanged.runOn($self));
		var loadCatalogsTask = $self.loadCatalogs();
		if (String.isNullOrEmpty(catalogName)) {
			loadCatalogsTask.continueWith1(function (t) {
				if (t.exception() == null) {
					$self.initializeCompleted();
					var r1 = (function () { var $ret = new $.ig.OlapResult();
					$ret.isEmpty(true); return $ret;}());
					$self.resultView(new $.ig.OlapResultView(r1, r1, false, false));
					$self.result(r1);
					tcs.setResult(null);
					return;
				}

				tcs.setException(t.exception());
			});
			return tcs.task();
		}

		var setCatalogTask = loadCatalogsTask.continueWithTask$1($.ig.IList$1.prototype.$type.specialize($.ig.Cube.prototype.$type), function (t) {
			if (t.exception() == null) {
				return $self.onCatalogChanged(catalogName);
			}

			var faultedTcs = new $.ig.TaskCompletionSource$1($.ig.IList$1.prototype.$type.specialize($.ig.Cube.prototype.$type), 0);
			faultedTcs.setException(t.exception());
			return faultedTcs.task();
		});
		if (String.isNullOrEmpty(cubeName)) {
			setCatalogTask.continueWith1(function (t) {
				if (t.exception() == null) {
					$self.initializeCompleted();
					var r2 = (function () { var $ret = new $.ig.OlapResult();
					$ret.isEmpty(true); return $ret;}());
					$self.resultView(new $.ig.OlapResultView(r2, r2, false, false));
					$self.result(r2);
					tcs.setResult(null);
					return;
				}

				tcs.setException(t.exception());
			});
			return tcs.task();
		}

		var setCubeTask = setCatalogTask.continueWithTask$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) { return $self.onSetCube(cubeName); }).continueWithTask$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) { return $self.initializeAxes(); });
		return setCubeTask;
	}

	, 
	onUpdate: function () {
		var $self = this;
		var hasColumnChanges = $self.isColumnsAxisChanged();
		var hasRowChanges = $self.isRowsAxisChanged();
		var hasMeasureChanges = $self.isMeasuresAxisChanged();
		var hasFilterChanges = $self.isFiltersAxisChanged();
		var hasPositionsToExpand = $self.getPositionsToExpand().count() > 0;
		var hasPositionsToCollapse = $self.getPositionsToCollapse().count() > 0;
		var hasMembersSelectionChanged = $self._membersSelectionChangedList.count() > 0;
		if (!hasColumnChanges && !hasRowChanges && !hasMeasureChanges && !hasFilterChanges && !hasPositionsToExpand && !hasPositionsToCollapse && !hasMembersSelectionChanged) {
			var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
			tcs.setResult($self.result());
			return tcs.task();
		}

		var hasColumns = $self.columnAxis().count() > 0;
		var hasRows = $self.rowAxis().count() > 0;
		if ($self.rowAxis().count() == 0 && $self.columnAxis().count() == 0 && $self.measures().count() == 0) {
			var result = (function () { var $ret = new $.ig.OlapResult();
			$ret.isEmpty(true); return $ret;}());
			var tcs1 = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
			tcs1.setResult(result);
			$self.resultView(new $.ig.OlapResultView(result, result, false, false));
			$self.result(result);
			$self.updateAxisMemberSortKeys(result);
			$self.updateAxisProvidersCache($self.resultView().visibleResult(), hasRows, hasColumns);
			$self.clearPendingChanges();
			return tcs1.task();
		}

		if ($self.isMeasuresAxisChanged()) {
			$self.updateAxisProvidersCache1(hasColumns, hasRows);
		}

		$self.isMeasuresAxisChanged(false);
		$self.isFiltersAxisChanged(false);
		$self.isMeasureListLocationChanged(false);
		var useResultViewCahce = false;
		if ($self.__useResultViewCache && !$self.isColumnsAxisChanged() && !$self.isRowsAxisChanged()) {
			useResultViewCahce = true;
		}

		var mdxColumsAxis = null;
		var mdxRowsAxis = null;
		var axisIndex = 0;
		mdxColumsAxis = $self.getMdxAxis($self.columnAxis(), $self.isColumnsAxisChanged(), axisIndex);
		$self.isColumnsAxisChanged(false);
		if (mdxColumsAxis != null) {
			axisIndex++;
		}

		mdxRowsAxis = $self.getMdxAxis($self.rowAxis(), $self.isRowsAxisChanged(), axisIndex);
		$self.isRowsAxisChanged(false);
		if (mdxRowsAxis != null) {
			mdxRowsAxis.axisIndex(axisIndex);
			axisIndex++;
		}

		var axisPositionsMap;
		var axisesToExpand = (function () { var $ret = $self.expandCollapseTupleMembers(hasColumns, hasRows, useResultViewCahce, axisPositionsMap); axisPositionsMap = $ret.axisPositionsMap; return $ret.ret; }());
		var slicerAxisProvider = $self.createSlicerAxis($self.columnFilters(), $self.rowFilters(), $self.filterFilters(), $self.mdxSettings());
		var slicerAxis = slicerAxisProvider.createAxis(axisIndex);
		var mdxQueryBuilder = new $.ig.MdxQueryBuilder(1, $self.mdxSettings());
		var properties = $self.getProviderDefaultProperties();
		var restrictions = $self.getProviderDefaultRestrictions();
		var provider = $self.dataProviderFactory().createDataProvider();
		if (useResultViewCahce && !hasMembersSelectionChanged && (hasPositionsToExpand || hasPositionsToCollapse)) {
			var expandTask = null;
			if (mdxColumsAxis != null) {
				var partialColumnAxis = axisesToExpand.where$1($.ig.IMdxAxis.prototype.$type, function (a) { return a.axisIndex() == mdxColumsAxis.axisIndex(); }).firstOrDefault$1($.ig.IMdxAxis.prototype.$type);
				var columnPositionsToExpand;
				(function () { var $ret = axisPositionsMap.tryGetValue("Axis0", columnPositionsToExpand); columnPositionsToExpand = $ret.value; return $ret.ret; }());
				if (partialColumnAxis != null) {
					var expandColumnsStatement = mdxQueryBuilder.buildMdxQuery(partialColumnAxis, mdxRowsAxis, slicerAxis, new $.ig.MdxCalculatedMembersCache(), $self.cube().name());
					expandTask = provider.executeStatementAsync(expandColumnsStatement, properties, restrictions);
					expandTask = expandTask.continueWithTask$2($.ig.OlapResult.prototype.$type, $.ig.OlapResult.prototype.$type, function (t) {
						if ($self.resultView() == null) {
							$self.resultView(new $.ig.OlapResultView($self.result(), $self.result(), hasColumns, hasRows));
						}

						var oldResultView = $self.resultView();
						$self.resultView($self.resultView().extend(t.result(), "Axis0"));
						$self.result($self.resultView().visibleResult());
						$self.updateAxisMemberSortKeys($self.result());
						$.ig.ResultViewHelper.prototype.syncPositionExpansionState("Axis0", oldResultView, $self.resultView());
						var en = columnPositionsToExpand.getEnumerator();
						while (en.moveNext()) {
							var positionInfo = en.current();
							$.ig.ResultViewHelper.prototype.setPositionIsExpaned2(positionInfo.axisName(), positionInfo.tupleIndex(), positionInfo.memberIndex(), true, $self.resultView());
						}

						var hasRowsValue = hasRows;
						var hasColumnsValue = hasColumns;
						$self.updateAxisProvidersCache($self.resultView().visibleResult(), hasRowsValue, hasColumnsValue);
						var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
						tcs.setResult($self.resultView().visibleResult());
						return tcs.task();
					});
				}

			}

			if (mdxRowsAxis != null) {
				var partialRowsAxis = axisesToExpand.where$1($.ig.IMdxAxis.prototype.$type, function (a) { return a.axisIndex() == mdxRowsAxis.axisIndex(); }).firstOrDefault$1($.ig.IMdxAxis.prototype.$type);
				var axisName = $self.resultView().hasColumns() ? "Axis1" : "Axis0";
				var rowPositionsToExpand;
				(function () { var $ret = axisPositionsMap.tryGetValue(axisName, rowPositionsToExpand); rowPositionsToExpand = $ret.value; return $ret.ret; }());
				if (partialRowsAxis != null) {
					if (expandTask != null) {
						expandTask = expandTask.continueWithTask$1($.ig.OlapResult.prototype.$type, function (t) {
							mdxColumsAxis = $self.getMdxAxis($self.columnAxis(), false, 0);
							var expandRowsStatement = mdxQueryBuilder.buildMdxQuery(mdxColumsAxis, partialRowsAxis, slicerAxis, new $.ig.MdxCalculatedMembersCache(), $self.cube().name());
							return provider.executeStatementAsync(expandRowsStatement, properties, restrictions);
						});

					} else {
						var expandRowsStatement = mdxQueryBuilder.buildMdxQuery(mdxColumsAxis, partialRowsAxis, slicerAxis, new $.ig.MdxCalculatedMembersCache(), $self.cube().name());
						expandTask = provider.executeStatementAsync(expandRowsStatement, properties, restrictions);
					}

					expandTask = expandTask.continueWithTask$2($.ig.OlapResult.prototype.$type, $.ig.OlapResult.prototype.$type, function (t) {
						if ($self.resultView() == null) {
							$self.resultView(new $.ig.OlapResultView($self.result(), $self.result(), hasColumns, hasRows));
						}

						var oldResultView = $self.resultView();
						$self.resultView($self.resultView().extend(t.result(), axisName));
						$self.result($self.resultView().visibleResult());
						$self.updateAxisMemberSortKeys($self.result());
						$.ig.ResultViewHelper.prototype.syncPositionExpansionState(axisName, oldResultView, $self.resultView());
						var en = rowPositionsToExpand.getEnumerator();
						while (en.moveNext()) {
							var positionInfo = en.current();
							$.ig.ResultViewHelper.prototype.setPositionIsExpaned2(positionInfo.axisName(), positionInfo.tupleIndex(), positionInfo.memberIndex(), true, $self.resultView());
						}

						var hasRowsValue = hasRows;
						var hasColumnsValue = hasColumns;
						$self.updateAxisProvidersCache($self.resultView().visibleResult(), hasRowsValue, hasColumnsValue);
						var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
						tcs.setResult($self.resultView().visibleResult());
						return tcs.task();
					});
				}

			}

			if (expandTask != null) {
				return expandTask;
			}

			var currentResultSource = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
			currentResultSource.setResult($self.result());
			return currentResultSource.task();

		} else {
			if (hasMembersSelectionChanged) {
				$self._membersSelectionChangedList.clear();
			}

				axisIndex = 0;
				mdxColumsAxis = $self.getMdxAxis($self.columnAxis(), $self.isColumnsAxisChanged(), axisIndex);
				if (mdxColumsAxis != null) {
					axisIndex++;
				}

				mdxRowsAxis = $self.getMdxAxis($self.rowAxis(), $self.isRowsAxisChanged(), axisIndex);
			;
			var statement = mdxQueryBuilder.buildMdxQuery(mdxColumsAxis, mdxRowsAxis, slicerAxis, new $.ig.MdxCalculatedMembersCache(), $self.cube().name());
			return provider.executeStatementAsync(statement, properties, restrictions).continueWith$1($.ig.OlapResult.prototype.$type, function (t) {
				$self.resultView(new $.ig.OlapResultView(t.result(), t.result(), hasColumns, hasRows));
				$self.result($self.resultView().visibleResult());
				$self.updateAxisMemberSortKeys($self.result());
				var hasRowsValue = hasRows;
				var hasColumnsValue = hasColumns;
				$self.updateAxisProvidersCache($self.resultView().visibleResult(), hasRowsValue, hasColumnsValue);
				$self.clearPendingChanges();
				return $self.result();
			});
		}

	}

	, 
	onSetCube: function (cubeName) {
		if (this.catalog() == null) {
			throw new $.ig.InvalidOperationException(1, "Data source has no Catalog set.");
		}

		return $.ig.OlapDataSource.prototype.onSetCube.call(this, cubeName);
	}

	, 
	onSetMeasureGroup: function (measureGroupName) {
		if (this.catalog() == null) {
			throw new $.ig.InvalidOperationException(1, "Data source has no Catalog set.");
		}

		return $.ig.OlapDataSource.prototype.onSetMeasureGroup.call(this, measureGroupName);
	}

	, 
	cacheCubeMetaItems: function () {
		var $self = this;
		var taskList = new $.ig.List$1($.ig.Task.prototype.$type, 0);
		var properties = $self.getProviderDefaultProperties();
		var restrictions = $self.getProviderDefaultRestrictions();
		var xmlaDataProvider = $self.dataProviderFactory().createDataProvider();
		taskList.add(xmlaDataProvider.discoverMeasuresAsync(properties, restrictions));
		taskList.add(xmlaDataProvider.discoverKpisAsync(properties, restrictions));
		taskList.add(xmlaDataProvider.discoverDimensionsAsync(properties, restrictions));
		taskList.add(xmlaDataProvider.discoverHierarchiesAsync(properties, restrictions));
		taskList.add(xmlaDataProvider.discoverLevelsAsync(properties, restrictions));
		taskList.add(xmlaDataProvider.discoverMeasureGroupDimensionsAsync(properties, restrictions));
		taskList.add($self.loadMeasureGroups());
		var tasks = new Array(taskList.count());
		taskList.copyTo(tasks, 0);
		var tf = new $.ig.TaskFactory();
		var cubeCache = new $.ig.CubeMetaItemsCache();
		$self.cubeCache(cubeCache);
		return tf.continueWhenAll(tasks, function (t) {
			var getMeasuresTask = t[0];
			var getKpisTask = t[1];
			var getDimensionsTask = t[2];
			var getHierarchiesTask = t[3];
			var getLevelsTask = t[4];
			var getMeasureGroupDimensionsTask = t[5];
			cubeCache.measures(getMeasuresTask.result());
			cubeCache.dimensionItems(getDimensionsTask.result());
			cubeCache.hierarchyItems(getHierarchiesTask.result());
			cubeCache.levelItems(getLevelsTask.result());
			cubeCache.kpis(getKpisTask.result());
			if ($self.measureGroups() != null) {
				cubeCache.measureGroupDimensions(getMeasureGroupDimensionsTask.result());
				cubeCache.measureGroupDimensionsCache(new $.ig.MeasureGroupMetaItemsCache(cubeCache.dimensionItems(), cubeCache.measures(), cubeCache.kpis(), cubeCache.measureGroupDimensions()));
			}

		});
	}

	, 
	toArrayListCollection$1: function ($t, enumerable) {
		var res = new $.ig.ArrayListCollection$1($t);
		var en = enumerable.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			res.add(item);
		}

		return res;
	}

	, 
	getProviderDefaultRestrictions: function () {
		var $self = this;
		var restrictions = $.ig.OlapDataSource.prototype.getProviderDefaultRestrictions.call($self);
		if ($self.catalog() != null) {
			restrictions.add((function () { var $ret = new $.ig.KeyValueItem();
			$ret.key($.ig.CubeRestrictions.prototype.catalogName);
			$ret.value($self.catalog().name()); return $ret;}()));
			if ($self.cube() != null) {
				restrictions.add((function () { var $ret = new $.ig.KeyValueItem();
				$ret.key($.ig.CubeRestrictions.prototype.cubeName);
				$ret.value($self.cube().name()); return $ret;}()));
			}

		}

		return restrictions;
	}

	, 
	columnsAxisChanged: function (sender, e) {
		this.isColumnsAxisChanged(true);
		this.updateMdxAxesItems(0, this.columnAxis(), this.rowAxis());
		this.updateAxisState(e, this.columnFilters());
		this.updateMeasureListIndex(e, this.columnAxis());
		if (e.action() != $.ig.NotifyCollectionChangedAction.prototype.reset && this.columnAxis() != null) {
			var validToIndex = Math.max(e.newStartingIndex(), e.oldStartingIndex());
			this.updateExpandCollapseCache("Axis0", validToIndex);
		}

	}

	, 
	rowsAxisChanged: function (sender, e) {
		this.isRowsAxisChanged(true);
		this.updateMdxAxesItems(1, this.rowAxis(), this.columnAxis());
		this.updateAxisState(e, this.rowFilters());
		this.updateMeasureListIndex(e, this.rowAxis());
		if (e.action() != $.ig.NotifyCollectionChangedAction.prototype.reset && this.rowAxis() != null) {
			var axisName = this.columnAxis() == null ? "Axis0" : "Axis1";
			var validToIndex = Math.max(e.newStartingIndex(), e.oldStartingIndex());
			this.updateExpandCollapseCache(axisName, validToIndex);
		}

	}

	, 
	updateExpandCollapseCache: function (axisName, validToIndex) {
		var positionsToCollapse = this.getPositionsToCollapse();
		for (var i = positionsToCollapse.count() - 1; i >= 0; i--) {
			var positionInfo = positionsToCollapse.item(i);
			if (positionInfo.axisName() == axisName && positionInfo.memberIndex() >= validToIndex) {
				positionsToCollapse.removeAt(i);
			}

		}

		var positionsToExpand = this.getPositionsToExpand();
		for (var i1 = positionsToExpand.count() - 1; i1 >= 0; i1--) {
			var positionInfo1 = positionsToExpand.item(i1);
			if (positionInfo1.axisName() == axisName && positionInfo1.memberIndex() >= validToIndex) {
				positionsToExpand.removeAt(i1);
			}

		}

	}

	, 
	updateMdxAxesItems: function (mdxAxisIndex, axisToManageForMdx, opositeAxisToManage) {
		if (axisToManageForMdx.count() > 0) {
			if (opositeAxisToManage.count() > 0) {
				if (this.__mdxAxes.count() < 2) {
					this.__mdxAxes.insert(mdxAxisIndex, null);
				}


			} else {
				if (this.__mdxAxes.count() == 0) {
					this.__mdxAxes.insert(0, null);
				}

			}


		} else {
			if (this.__mdxAxes.count() > 0) {
				if (this.__mdxAxes.count() > 1) {
					this.__mdxAxes.removeAt(mdxAxisIndex);

				} else {
					this.__mdxAxes.removeAt(0);
				}

			}

		}

	}

	, 
	filtersAxisChanged: function (sender, e) {
		this.isFiltersAxisChanged(true);
		this.updateAxisState(e, this.filterFilters());
	}

	, 
	measuresAxisChanged: function (sender, e) {
		this.isMeasuresAxisChanged(true);
		this.updateMeasureList();
	}

	, 
	ensureEntryValue: function (entries, key, value) {
		var $self = this;
		var keyValueItem = null;
		var en = entries.getEnumerator();
		while (en.moveNext()) {
			var p = en.current();
			if (p.key() == key) {
				keyValueItem = p;
				break;
			}

		}

		if (keyValueItem == null) {
			entries.add((function () { var $ret = new $.ig.KeyValueItem();
			$ret.key(key);
			$ret.value(value); return $ret;}()));
		}

	}

	, 
	getResultAxis1: function (axisName) {
		var $self = this;
		if ($self.result() != null && $self.result().axes().count() > 0) {
			return $self.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (ax) { return ax.name() == axisName; }).firstOrDefault$1($.ig.OlapResultAxis.prototype.$type);
		}

		return null;
	}

	, 
	getAxisProvider: function (axisIndex) {
		if (axisIndex < this.__mdxAxes.count()) {
			return this.__mdxAxes.item(axisIndex);
		}

		return null;
	}

	, 
	setAxisProvider: function (axisIndex, mdxAxis) {
		this.__mdxAxes.item(axisIndex, mdxAxis);
	}
	, 
	$type: new $.ig.Type('MdxDataSourceImpl', $.ig.OlapDataSource.prototype.$type)
}, true);

$.ig.util.defType('MdxDataSourceOptions', 'DataSourceBaseOptions', {
	init: function () {

		$.ig.DataSourceBaseOptions.prototype.init.call(this);

	}
	, 
	_catalog: null,
	catalog: function (value) {
		if (arguments.length === 1) {
			this._catalog = value;
			return value;
		} else {
			return this._catalog;
		}
	}

	, 
	_discoverProperties: null,
	discoverProperties: function (value) {
		if (arguments.length === 1) {
			this._discoverProperties = value;
			return value;
		} else {
			return this._discoverProperties;
		}
	}

	, 
	_executeProperties: null,
	executeProperties: function (value) {
		if (arguments.length === 1) {
			this._executeProperties = value;
			return value;
		} else {
			return this._executeProperties;
		}
	}

	, 
	_dataProviderFactory: null,
	dataProviderFactory: function (value) {
		if (arguments.length === 1) {
			this._dataProviderFactory = value;
			return value;
		} else {
			return this._dataProviderFactory;
		}
	}

	, 
	_enableResultCache: false,
	enableResultCache: function (value) {
		if (arguments.length === 1) {
			this._enableResultCache = value;
			return value;
		} else {
			return this._enableResultCache;
		}
	}

	, 
	_mdxSettings: null,
	mdxSettings: function (value) {
		if (arguments.length === 1) {
			this._mdxSettings = value;
			return value;
		} else {
			return this._mdxSettings;
		}
	}
	, 
	$type: new $.ig.Type('MdxDataSourceOptions', $.ig.DataSourceBaseOptions.prototype.$type)
}, true);

$.ig.util.defType('XmlaDataProvider', 'Object', {
	__xmlaConnection: null
	, 
	__initXmlaMethod: null
	, 
	init: function (xmlaConnection, initXmlaMethod) {



		$.ig.Object.prototype.init.call(this);
			this.__xmlaConnection = xmlaConnection;
			this.__initXmlaMethod = initXmlaMethod;
	}

	, 
	discoverCatalogsAsync: function (properties, restrictions) {
		return this.discoverAsync$1($.ig.Catalog.prototype.$type, new $.ig.DatabaseXmlTypeSerializer(), $.ig.DbSchemaConstants.prototype.catalogs, properties, restrictions);
	}

	, 
	discoverCubesAsync: function (properties, restrictions) {
		return this.discoverAsync$1($.ig.Cube.prototype.$type, new $.ig.CubeXmlTypeSerializer(), $.ig.OlapSchemaConstants.prototype.cubes, properties, restrictions);
	}

	, 
	discoverDimensionsAsync: function (properties, restrictions) {
		return this.discoverAsync$1($.ig.Dimension.prototype.$type, new $.ig.DimensionXmlTypeSerializer(), $.ig.OlapSchemaConstants.prototype.dimensions, properties, restrictions);
	}

	, 
	discoverHierarchiesAsync: function (properties, restrictions) {
		return this.discoverAsync$1($.ig.Hierarchy.prototype.$type, new $.ig.HierarchyXmlTypeSerializer(), $.ig.OlapSchemaConstants.prototype.hierarchies, properties, restrictions);
	}

	, 
	discoverLevelsAsync: function (properties, restrictions) {
		return this.discoverAsync$1($.ig.Level.prototype.$type, new $.ig.LevelXmlTypeSerializer(), $.ig.OlapSchemaConstants.prototype.levels, properties, restrictions);
	}

	, 
	discoverMeasuresAsync: function (properties, restrictions) {
		return this.discoverAsync$1($.ig.Measure.prototype.$type, new $.ig.MeasureXmlTypeSerializer(), $.ig.OlapSchemaConstants.prototype.measures, properties, restrictions);
	}

	, 
	discoverMeasureGroupsAsync: function (properties, restrictions) {
		return this.discoverAsync$1($.ig.MeasureGroup.prototype.$type, new $.ig.MeasureGroupXmlTypeSerializer(), $.ig.OlapSchemaConstants.prototype.measureGroups, properties, restrictions);
	}

	, 
	discoverMeasureGroupDimensionsAsync: function (properties, restrictions) {
		return this.discoverAsync$1($.ig.MeasureGroupDimension.prototype.$type, new $.ig.MeasureGroupDimensionXmlTypeSerializer(), $.ig.OlapSchemaConstants.prototype.measureGroupDimensions, properties, restrictions);
	}

	, 
	discoverMembersAsync: function (properties, restrictions) {
		return this.discoverAsync$1($.ig.Member.prototype.$type, new $.ig.MemberXmlTypeSerializer(), $.ig.OlapSchemaConstants.prototype.members, properties, restrictions);
	}

	, 
	discoverKpisAsync: function (properties, restrictions) {
		return this.discoverAsync$1($.ig.Kpi.prototype.$type, new $.ig.KpiXmlTypeSerializer(), $.ig.OlapSchemaConstants.prototype.kpis, properties, restrictions);
	}

	, 
	executeStatementAsync: function (statement, properties, parameters) {
		var $self = this;
		var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
		var client = $self.__xmlaConnection.getXmlaSoapWebClient$1($.ig.ExecuteResponseResult.prototype.$type);
		var serializer = new $.ig.ResultXmlTypeSerializer();
		client.requestCompleted = $.ig.Delegate.prototype.combine(client.requestCompleted, function (s, args) { return $self.executeAsyncCompleted$1($.ig.OlapResult.prototype.$type, serializer, args, tcs); });
		var method = new $.ig.XmlaSoapMethodExecute(statement);
		$self.initializeExecuteMethod(method, properties, parameters);
		client.requestAsync(method);
		return tcs.task();
	}

	, 
	discoverAsync$1: function ($t, serializer, requestType, properties, restrictions) {
		var $self = this;
		var tcs = new $.ig.TaskCompletionSource$1($.ig.IEnumerable$1.prototype.$type.specialize($t), 0);
		var client = $self.__xmlaConnection.getXmlaSoapWebClient$1($.ig.DiscoverResponseResult.prototype.$type);
		client.requestCompleted = $.ig.Delegate.prototype.combine(client.requestCompleted, function (s, args) { return $self.discoverAsyncCompleted$1($t, serializer, args, tcs); });
		var method = new $.ig.XmlaSoapMethodDiscover(requestType);
		$self.initializeDiscoverMethod(method, properties, restrictions);
		client.requestAsync(method);
		return tcs.task();
	}

	, 
	initializeDiscoverMethod: function (method, properties, restrictions) {
		if (restrictions != null) {
			var en = restrictions.getEnumerator();
			while (en.moveNext()) {
				var restriction = en.current();
				method.restrictions().add(restriction.key(), restriction.value());
			}

		}

		if (properties != null) {
			var en1 = properties.getEnumerator();
			while (en1.moveNext()) {
				var property = en1.current();
				method.properties().add(new $.ig.XmlaQueryProperty(1, property.key(), property.value()));
			}

		}

		if (this.__initXmlaMethod != null) {
			this.__initXmlaMethod(method);
		}

	}

	, 
	initializeExecuteMethod: function (method, properties, parameters) {
		if (parameters != null) {
			var en = parameters.getEnumerator();
			while (en.moveNext()) {
				var restriction = en.current();
			}

		}

		if (properties != null) {
			var en1 = properties.getEnumerator();
			while (en1.moveNext()) {
				var property = en1.current();
				method.properties().add(new $.ig.XmlaQueryProperty(1, property.key(), property.value()));
			}

		}

		if (this.__initXmlaMethod != null) {
			this.__initXmlaMethod(method);
		}

	}

	, 
	discoverAsyncCompleted$1: function ($t, ser, e, tcs) {
		if (e.error() != null) {
			tcs.setException(e.error());

		} else if (e.cancelled()) {
			tcs.setCanceled();

		} else {
			var result = e.result();
			if (result != null) {
				var arrSer = new $.ig.ArraySerializer();
				var x = arrSer.deserialize$1($t, e.result().returnElement(), $.ig.XName.prototype.get("row", $.ig.XmlaNamespace.prototype.rowset), ser);
				tcs.setResult(x);
			}

		}


	}

	, 
	executeAsyncCompleted$1: function ($t, ser, e, tcs) {
		if (e.error() != null) {
			tcs.setException(e.error());

		} else if (e.cancelled()) {
			tcs.setCanceled();

		} else {
			var result = e.result();
			if (result != null) {
				var x = ser.deserialize(e.result().returnElement());
				tcs.setResult(x);
			}

		}


	}
	, 
	$type: new $.ig.Type('XmlaDataProvider', $.ig.Object.prototype.$type, [$.ig.IXmlaDataProvider.prototype.$type])
}, true);

$.ig.util.defType('CatalogConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('CatalogConstants', $.ig.Object.prototype.$type)
}, true);




$.ig.util.defType('DbSchemaConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('DbSchemaConstants', $.ig.Object.prototype.$type)
}, true);





$.ig.util.defType('CubeConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('CubeConstants', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DimensionConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('DimensionConstants', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('HierarchyConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('HierarchyConstants', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('InstanceConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('InstanceConstants', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('KpiConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('KpiConstants', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LevelConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('LevelConstants', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MeasureConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MeasureConstants', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MeasureGroupConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MeasureGroupConstants', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MeasureGroupDimensionConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MeasureGroupDimensionConstants', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MemberConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MemberConstants', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapSchemaConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('OlapSchemaConstants', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CubeRestrictions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('CubeRestrictions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DimensionRestrictions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('DimensionRestrictions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('HierarchyRestrictions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('HierarchyRestrictions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('KpiRestrictions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('KpiRestrictions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LevelRestrictions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('LevelRestrictions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MeasureRestrictions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MeasureRestrictions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MeasureGroupRestrictions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MeasureGroupRestrictions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MeasureGroupDimensionRestrictions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MeasureGroupDimensionRestrictions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MemberRestrictions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MemberRestrictions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ICoreXmlaConnection', 'Object', {
	$type: new $.ig.Type('ICoreXmlaConnection', null, [$.ig.IConnection.prototype.$type])
}, true);

$.ig.util.defType('ArraySerializer', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	deserialize$1: function ($t, element, rowElementName, serializer) {
		var result = new $.ig.List$1($t, 0);
		var en = element.elements1(rowElementName).getEnumerator();
		while (en.moveNext()) {
			var rowElement = en.current();
			result.add(serializer.deserialize(rowElement));
		}

		return result;
	}
	, 
	$type: new $.ig.Type('ArraySerializer', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IXmlTypeSerializer$1', 'Object', {
	$type: new $.ig.Type('IXmlTypeSerializer$1', null)
}, true);

$.ig.util.defType('AxisXmlTypeSerializer', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			if ($.ig.AxisXmlTypeSerializer.prototype.xNamesCache != null) {
				return;
			}

			$.ig.AxisXmlTypeSerializer.prototype.xNamesCache = new $.ig.Dictionary$2(String, $.ig.XName.prototype.$type, 0);
			$.ig.AxisXmlTypeSerializer.prototype.xNamesCache.item("0", $.ig.XName.prototype.get("Tuple", $.ig.XmlaNamespace.prototype.mdDataset));
			$.ig.AxisXmlTypeSerializer.prototype.xNamesCache.item("1", $.ig.XName.prototype.get("Tuples", $.ig.XmlaNamespace.prototype.mdDataset));
	}

	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var axisName = $.ig.SerializerUtils.prototype.getText(element.attribute($.ig.XName.prototype.get("name", "")));
		var tuplesElement = element.element($.ig.AxisXmlTypeSerializer.prototype.xNamesCache.item("1"));
		var arr = new $.ig.ArraySerializer();
		var tuples = arr.deserialize$1($.ig.OlapResultTuple.prototype.$type, tuplesElement, $.ig.AxisXmlTypeSerializer.prototype.xNamesCache.item("0"), new $.ig.TupleXmlTypeSerializer());
		var tupleSize = 0;
		if (tuples.count() > 0) {
			tupleSize = tuples.__inner[0].members().count();
		}

		return (function () { var $ret = new $.ig.OlapResultAxis(tuples, tupleSize);
		$ret.name(axisName); return $ret;}());
	}
	, 
	$type: new $.ig.Type('AxisXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.OlapResultAxis.prototype.$type)])
}, true);

$.ig.util.defType('TupleXmlTypeSerializer', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			if ($.ig.TupleXmlTypeSerializer.prototype.xNamesCache != null) {
				return;
			}

			$.ig.TupleXmlTypeSerializer.prototype.xNamesCache = new $.ig.Dictionary$2(String, $.ig.XName.prototype.$type, 0);
			$.ig.TupleXmlTypeSerializer.prototype.xNamesCache.item("0", $.ig.XName.prototype.get("Member", $.ig.XmlaNamespace.prototype.mdDataset));
	}

	, 
	deserialize: function (node) {
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var arr = new $.ig.ArraySerializer();
		var members = arr.deserialize$1($.ig.OlapResultAxisMember.prototype.$type, element, $.ig.TupleXmlTypeSerializer.prototype.xNamesCache.item("0"), new $.ig.AxisMemberXmlTypeSerializer());
		var tuple = new $.ig.OlapResultTuple(members);
		var en = members.getEnumerator();
		while (en.moveNext()) {
			var axisMember = en.current();
			axisMember.position(tuple);
		}

		return tuple;
	}
	, 
	$type: new $.ig.Type('TupleXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.OlapResultTuple.prototype.$type)])
}, true);

$.ig.util.defType('AxisMemberXmlTypeSerializer', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			if ($.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache != null) {
				return;
			}

			$.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache = new $.ig.Dictionary$2(String, $.ig.XName.prototype.$type, 0);
			$.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache.item("0", $.ig.XName.prototype.get("UName", $.ig.XmlaNamespace.prototype.mdDataset));
			$.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache.item("1", $.ig.XName.prototype.get("LName", $.ig.XmlaNamespace.prototype.mdDataset));
			$.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache.item("2", $.ig.XName.prototype.get("Caption", $.ig.XmlaNamespace.prototype.mdDataset));
			$.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache.item("3", $.ig.XName.prototype.get("LNum", $.ig.XmlaNamespace.prototype.mdDataset));
			$.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache.item("4", $.ig.XName.prototype.get("DisplayInfo", $.ig.XmlaNamespace.prototype.mdDataset));
	}

	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var uniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache.item("0")));
		var levelUniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache.item("1")));
		var caption = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache.item("2")));
		var levelDepth = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache.item("3")));
		var displayInfo = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache.item("4")));
		var hierarchyUniqueName = element.attribute($.ig.XName.prototype.get("Hierarchy", "")).value();
		var tupleMember = (function () { var $ret = new $.ig.OlapResultAxisMember();
		$ret.hierarchyUniqueName(hierarchyUniqueName);
		$ret.levelUniqueName(levelUniqueName);
		$ret.levelNumber($.ig.Number.prototype.parseInt(levelDepth));
		$ret.uniqueName(uniqueName);
		$ret.caption(caption);
		$ret.displayInfo(String.isNullOrEmpty(displayInfo) ? 0 : $.ig.Number.prototype.parseInt(displayInfo)); return $ret;}());
		var en = element.elements().getEnumerator();
		while (en.moveNext()) {
			var xElement = en.current();
			switch (xElement.name().localName()) {
				case "UName":
				case "LName":
				case "Caption":
				case "LNum":
				case "DisplayInfo":
					continue;
				default:
					tupleMember.properties().add(xElement.name().localName(), xElement.value());
					break;
			}

		}

		return tupleMember;
	}
	, 
	$type: new $.ig.Type('AxisMemberXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.OlapResultAxisMember.prototype.$type)])
}, true);

$.ig.util.defType('CellXmlTypeSerializer', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var cellOrdinal = element.attribute($.ig.XName.prototype.get("CellOrdinal", "")).value();
		var cell = (function () { var $ret = new $.ig.OlapResultCell();
		$ret.cellOrdinal($.ig.Number.prototype.parseInt(cellOrdinal)); return $ret;}());
		var en = element.elements().getEnumerator();
		while (en.moveNext()) {
			var xElement = en.current();
			cell.properties().add(xElement.name().localName(), xElement.value());
		}

		return cell;
	}
	, 
	$type: new $.ig.Type('CellXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.OlapResultCell.prototype.$type)])
}, true);

$.ig.util.defType('CubeXmlTypeSerializer', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var name = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.CubeConstants.prototype.cubeName, $.ig.XmlaNamespace.prototype.rowset)));
		var caption = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.CubeConstants.prototype.cubeCaption, $.ig.XmlaNamespace.prototype.rowset)));
		var description = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.CubeConstants.prototype.description, $.ig.XmlaNamespace.prototype.rowset)));
		var cubeType;
		var cubeTypeString = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.CubeConstants.prototype.cubeType, $.ig.XmlaNamespace.prototype.rowset)));
		switch (cubeTypeString) {
			case $.ig.XmlaConstants.prototype.cubeStringConstant:
				cubeType = $.ig.CubeType.prototype.cube;
				break;
			case $.ig.XmlaConstants.prototype.dimensionStringConstant:
				cubeType = $.ig.CubeType.prototype.dimension;
				break;
			default:
				cubeType = $.ig.CubeType.prototype.unknown;
				break;
		}

		var catalogName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.CubeConstants.prototype.catalogName, $.ig.XmlaNamespace.prototype.rowset)));
		var lastProcessed = $.ig.SerializerUtils.prototype.getDateTime(element.element($.ig.XName.prototype.get($.ig.CubeConstants.prototype.lastDataUpdate, $.ig.XmlaNamespace.prototype.rowset)));
		var lastUpdated = $.ig.SerializerUtils.prototype.getDateTime(element.element($.ig.XName.prototype.get($.ig.CubeConstants.prototype.lastSchemaUpdate, $.ig.XmlaNamespace.prototype.rowset)));
		return (function () { var $ret = new $.ig.Cube();
		$ret.name(name);
		$ret.caption(caption);
		$ret.description(description);
		$ret.cubeType(cubeType);
		$ret.catalogName(catalogName);
		$ret.lastProcessed(lastProcessed);
		$ret.lastUpdated(lastUpdated); return $ret;}());
	}
	, 
	$type: new $.ig.Type('CubeXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.Cube.prototype.$type)])
}, true);

$.ig.util.defType('DatabaseXmlTypeSerializer', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var name = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.CatalogConstants.prototype.catalogName, $.ig.XmlaNamespace.prototype.rowset)));
		var description = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.CatalogConstants.prototype.description, $.ig.XmlaNamespace.prototype.rowset)));
		return (function () { var $ret = new $.ig.Catalog();
		$ret.name(name);
		$ret.caption(name);
		$ret.uniqueName(name);
		$ret.description(description); return $ret;}());
	}
	, 
	$type: new $.ig.Type('DatabaseXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.Catalog.prototype.$type)])
}, true);

$.ig.util.defType('DimensionXmlTypeSerializer', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			if ($.ig.DimensionXmlTypeSerializer.prototype.xNamesCache != null) {
				return;
			}

			$.ig.DimensionXmlTypeSerializer.prototype.xNamesCache = new $.ig.Dictionary$2(String, $.ig.XName.prototype.$type, 0);
			$.ig.DimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.DimensionConstants.prototype.dimensionName, $.ig.XName.prototype.get($.ig.DimensionConstants.prototype.dimensionName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.DimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.DimensionConstants.prototype.dimensionUniqueName, $.ig.XName.prototype.get($.ig.DimensionConstants.prototype.dimensionUniqueName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.DimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.DimensionConstants.prototype.dimensionCaption, $.ig.XName.prototype.get($.ig.DimensionConstants.prototype.dimensionCaption, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.DimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.DimensionConstants.prototype.description, $.ig.XName.prototype.get($.ig.DimensionConstants.prototype.description, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.DimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.DimensionConstants.prototype.dimensionType, $.ig.XName.prototype.get($.ig.DimensionConstants.prototype.dimensionType, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.DimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.DimensionConstants.prototype.defaultHierarchy, $.ig.XName.prototype.get($.ig.DimensionConstants.prototype.defaultHierarchy, $.ig.XmlaNamespace.prototype.rowset));
	}

	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var name = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.DimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.DimensionConstants.prototype.dimensionName)));
		var uniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.DimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.DimensionConstants.prototype.dimensionUniqueName)));
		var caption = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.DimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.DimensionConstants.prototype.dimensionCaption)));
		var description = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.DimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.DimensionConstants.prototype.description)));
		var typeString = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.DimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.DimensionConstants.prototype.dimensionType)));
		var dimensionType = ($.ig.Number.prototype.parseInt(typeString));
		var defaultHierarchy = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.DimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.DimensionConstants.prototype.defaultHierarchy)));
		return (function () { var $ret = new $.ig.Dimension();
		$ret.name(name);
		$ret.uniqueName(uniqueName);
		$ret.caption(caption);
		$ret.description(description);
		$ret.dimensionType(dimensionType);
		$ret.defaultHierarchy(defaultHierarchy); return $ret;}());
	}
	, 
	$type: new $.ig.Type('DimensionXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.Dimension.prototype.$type)])
}, true);

$.ig.util.defType('FaultError', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_errorCode: null,
	errorCode: function (value) {
		if (arguments.length === 1) {
			this._errorCode = value;
			return value;
		} else {
			return this._errorCode;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_source: null,
	source: function (value) {
		if (arguments.length === 1) {
			this._source = value;
			return value;
		} else {
			return this._source;
		}
	}

	, 
	_helpFile: null,
	helpFile: function (value) {
		if (arguments.length === 1) {
			this._helpFile = value;
			return value;
		} else {
			return this._helpFile;
		}
	}

	, 
	_severity: null,
	severity: function (value) {
		if (arguments.length === 1) {
			this._severity = value;
			return value;
		} else {
			return this._severity;
		}
	}
	, 
	$type: new $.ig.Type('FaultError', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ErrorXmlTypeSerializer', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	deserialize: function (node) {
		var e = new $.ig.FaultError();
		var element = node;
		e.errorCode($.ig.SerializerUtils.prototype.getText(element.attribute($.ig.XName.prototype.get("ErrorCode", ""))));
		e.description($.ig.SerializerUtils.prototype.getText(element.attribute($.ig.XName.prototype.get("Description", ""))));
		e.source($.ig.SerializerUtils.prototype.getText(element.attribute($.ig.XName.prototype.get("Source", ""))));
		e.helpFile($.ig.SerializerUtils.prototype.getText(element.attribute($.ig.XName.prototype.get("HelpFile", ""))));
		e.severity($.ig.SerializerUtils.prototype.getText(element.attribute($.ig.XName.prototype.get("Severity", ""))));
		return e;
	}
	, 
	$type: new $.ig.Type('ErrorXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.FaultError.prototype.$type)])
}, true);

$.ig.util.defType('HierarchyXmlTypeSerializer', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			if ($.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache != null) {
				return;
			}

			$.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache = new $.ig.Dictionary$2(String, $.ig.XName.prototype.$type, 0);
			$.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.hierarchyName, $.ig.XName.prototype.get($.ig.HierarchyConstants.prototype.hierarchyName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.hierarchyUniqueName, $.ig.XName.prototype.get($.ig.HierarchyConstants.prototype.hierarchyUniqueName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.hierarchyCaption, $.ig.XName.prototype.get($.ig.HierarchyConstants.prototype.hierarchyCaption, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.description, $.ig.XName.prototype.get($.ig.HierarchyConstants.prototype.description, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.defaultMember, $.ig.XName.prototype.get($.ig.HierarchyConstants.prototype.defaultMember, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.allMember, $.ig.XName.prototype.get($.ig.HierarchyConstants.prototype.allMember, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.dimensionUniqueName, $.ig.XName.prototype.get($.ig.HierarchyConstants.prototype.dimensionUniqueName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.hierarchyDisplayFolder, $.ig.XName.prototype.get($.ig.HierarchyConstants.prototype.hierarchyDisplayFolder, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.hierarchyOrigin, $.ig.XName.prototype.get($.ig.HierarchyConstants.prototype.hierarchyOrigin, $.ig.XmlaNamespace.prototype.rowset));
	}

	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var name = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.hierarchyName)));
		var uniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.hierarchyUniqueName)));
		var caption = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.hierarchyCaption)));
		var description = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.description)));
		var defaultMember = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.defaultMember)));
		var allMember = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.allMember)));
		var dimensionUniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.dimensionUniqueName)));
		var displayFolder = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.hierarchyDisplayFolder)));
		var hierarchyOriginString = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache.item($.ig.HierarchyConstants.prototype.hierarchyOrigin)));
		var hierarchyOrigin = (hierarchyOriginString == null ? 1 : $.ig.Number.prototype.parseInt(hierarchyOriginString));
		return (function () { var $ret = new $.ig.Hierarchy();
		$ret.name(name);
		$ret.uniqueName(uniqueName);
		$ret.caption(caption);
		$ret.description(description);
		$ret.defaultMember(defaultMember);
		$ret.allMember(allMember);
		$ret.dimensionUniqueName(dimensionUniqueName);
		$ret.hierarchyDisplayFolder(displayFolder);
		$ret.hierarchyOrigin(hierarchyOrigin); return $ret;}());
	}
	, 
	$type: new $.ig.Type('HierarchyXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.Hierarchy.prototype.$type)])
}, true);

$.ig.util.defType('KpiXmlTypeSerializer', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var name = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiName, $.ig.XmlaNamespace.prototype.rowset)));
		var uniqueName = name;
		var caption = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiCaption, $.ig.XmlaNamespace.prototype.rowset)));
		var description = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiDescription, $.ig.XmlaNamespace.prototype.rowset)));
		var measureGroupName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.measureGroupName, $.ig.XmlaNamespace.prototype.rowset)));
		var displayFolder = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiDisplayFolder, $.ig.XmlaNamespace.prototype.rowset)));
		var kpiValue = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiValue, $.ig.XmlaNamespace.prototype.rowset)));
		var kpiGoal = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiGoal, $.ig.XmlaNamespace.prototype.rowset)));
		var kpiStatus = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiStatus, $.ig.XmlaNamespace.prototype.rowset)));
		var kpiTrend = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiTrend, $.ig.XmlaNamespace.prototype.rowset)));
		var kpiWeight = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiWeight, $.ig.XmlaNamespace.prototype.rowset)));
		var kpiStatusGraphic = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiStatusGraphic, $.ig.XmlaNamespace.prototype.rowset)));
		var kpiTrendGraphic = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiTrendGraphic, $.ig.XmlaNamespace.prototype.rowset)));
		var parentKpiName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiParentKpiName, $.ig.XmlaNamespace.prototype.rowset)));
		var currentTimeMember = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.KpiConstants.prototype.kpiCurrentTimeMember, $.ig.XmlaNamespace.prototype.rowset)));
		return (function () { var $ret = new $.ig.Kpi();
		$ret.name(name);
		$ret.uniqueName(uniqueName);
		$ret.caption(caption);
		$ret.description(description);
		$ret.measureGroupName(measureGroupName);
		$ret.kpiDisplayFolder(displayFolder);
		$ret.kpiValue(kpiValue);
		$ret.kpiGoal(kpiGoal);
		$ret.kpiStatus(kpiStatus);
		$ret.kpiTrend(kpiTrend);
		$ret.kpiStatusGraphic(kpiStatusGraphic);
		$ret.kpiTrendGraphic(kpiTrendGraphic);
		$ret.kpiWeight(kpiWeight);
		$ret.parentKpiName(parentKpiName);
		$ret.currentTimeMember(currentTimeMember); return $ret;}());
	}
	, 
	$type: new $.ig.Type('KpiXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.Kpi.prototype.$type)])
}, true);

$.ig.util.defType('LevelXmlTypeSerializer', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var name = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.LevelConstants.prototype.levelName, $.ig.XmlaNamespace.prototype.rowset)));
		var uniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.LevelConstants.prototype.levelUniqueName, $.ig.XmlaNamespace.prototype.rowset)));
		var caption = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.LevelConstants.prototype.levelCaption, $.ig.XmlaNamespace.prototype.rowset)));
		var description = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.LevelConstants.prototype.description, $.ig.XmlaNamespace.prototype.rowset)));
		var dimensionUniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.LevelConstants.prototype.dimensionUniqueName, $.ig.XmlaNamespace.prototype.rowset)));
		var hierarchyUniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.LevelConstants.prototype.hierarchyUniqueName, $.ig.XmlaNamespace.prototype.rowset)));
		var levelDepth = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.LevelConstants.prototype.levelNumber, $.ig.XmlaNamespace.prototype.rowset)));
		var levelCardinality = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.LevelConstants.prototype.levelCardinality, $.ig.XmlaNamespace.prototype.rowset)));
		var levelOriginValue = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.LevelConstants.prototype.levelOrigin, $.ig.XmlaNamespace.prototype.rowset)));
		var levelOrderingProperty = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.LevelConstants.prototype.levelOrderingProperty, $.ig.XmlaNamespace.prototype.rowset)));
		return (function () { var $ret = new $.ig.Level();
		$ret.name(name);
		$ret.uniqueName(uniqueName);
		$ret.caption(caption);
		$ret.description(description);
		$ret.dimensionUniqueName(dimensionUniqueName);
		$ret.hierarchyUniqueName(hierarchyUniqueName);
		$ret.depth($.ig.Number.prototype.parseInt(levelDepth));
		$ret.membersCount($.ig.Number.prototype.parseInt(levelCardinality));
		$ret.levelOrigin(String.isNullOrEmpty(levelOriginValue) ? 0 : $.ig.Number.prototype.parseInt(levelOriginValue));
		$ret.levelOrderingProperty(levelOrderingProperty); return $ret;}());
	}
	, 
	$type: new $.ig.Type('LevelXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.Level.prototype.$type)])
}, true);

$.ig.util.defType('MeasureGroupDimensionXmlTypeSerializer', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			if ($.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache != null) {
				return;
			}

			$.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache = new $.ig.Dictionary$2(String, $.ig.XName.prototype.$type, 0);
			$.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.catalogName, $.ig.XName.prototype.get($.ig.MeasureGroupDimensionConstants.prototype.catalogName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.cubeName, $.ig.XName.prototype.get($.ig.MeasureGroupDimensionConstants.prototype.cubeName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.measureGroupName, $.ig.XName.prototype.get($.ig.MeasureGroupDimensionConstants.prototype.measureGroupName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.dimensionUniqueName, $.ig.XName.prototype.get($.ig.MeasureGroupDimensionConstants.prototype.dimensionUniqueName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.measureGroupCardinality, $.ig.XName.prototype.get($.ig.MeasureGroupDimensionConstants.prototype.measureGroupCardinality, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.dimensionCardinality, $.ig.XName.prototype.get($.ig.MeasureGroupDimensionConstants.prototype.dimensionCardinality, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.dimensionIsVisible, $.ig.XName.prototype.get($.ig.MeasureGroupDimensionConstants.prototype.dimensionIsVisible, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.dimensionIsFactDimension, $.ig.XName.prototype.get($.ig.MeasureGroupDimensionConstants.prototype.dimensionIsFactDimension, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.dimensionPath, $.ig.XName.prototype.get($.ig.MeasureGroupDimensionConstants.prototype.dimensionPath, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.dimensionGranularity, $.ig.XName.prototype.get($.ig.MeasureGroupDimensionConstants.prototype.dimensionGranularity, $.ig.XmlaNamespace.prototype.rowset));
	}

	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var catalogName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.catalogName)));
		var cubeName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.cubeName)));
		var measureGroupName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.measureGroupName)));
		var dimensionUniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.dimensionUniqueName)));
		var measureGroupCardinality = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.measureGroupCardinality)));
		var measureGroupCardinalityType = measureGroupCardinality == "ONE" ? $.ig.CardinalityType.prototype.one : $.ig.CardinalityType.prototype.many;
		var dimensionCardinality = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.dimensionCardinality)));
		var dimensionCardinalityType = dimensionCardinality == "ONE" ? $.ig.CardinalityType.prototype.one : $.ig.CardinalityType.prototype.many;
		var isDimensionVisible = $.ig.SerializerUtils.prototype.getBoolean(element.element($.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.dimensionIsVisible)));
		var isFactDimension = $.ig.SerializerUtils.prototype.getBoolean(element.element($.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.dimensionIsFactDimension)));
		var dimensionPath = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.dimensionPath)));
		var dimensionGranularity = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupDimensionConstants.prototype.dimensionGranularity)));
		return (function () { var $ret = new $.ig.MeasureGroupDimension();
		$ret.catalogName(catalogName);
		$ret.cubeName(cubeName);
		$ret.measureGroupName(measureGroupName);
		$ret.dimensionUniqueName(dimensionUniqueName);
		$ret.measureGroupCardinality(measureGroupCardinalityType);
		$ret.dimensionCardinality(dimensionCardinalityType);
		$ret.isDimensionVisible(isDimensionVisible);
		$ret.isFactDimension(isFactDimension);
		$ret.dimensionPath(dimensionPath);
		$ret.dimensionGranularity(dimensionGranularity); return $ret;}());
	}
	, 
	$type: new $.ig.Type('MeasureGroupDimensionXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.MeasureGroupDimension.prototype.$type)])
}, true);

$.ig.util.defType('MeasureGroupXmlTypeSerializer', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			if ($.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache != null) {
				return;
			}

			$.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache = new $.ig.Dictionary$2(String, $.ig.XName.prototype.$type, 0);
			$.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupConstants.prototype.catalogName, $.ig.XName.prototype.get($.ig.MeasureGroupConstants.prototype.catalogName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupConstants.prototype.cubeName, $.ig.XName.prototype.get($.ig.MeasureGroupConstants.prototype.cubeName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupConstants.prototype.measureGroupName, $.ig.XName.prototype.get($.ig.MeasureGroupConstants.prototype.measureGroupName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupConstants.prototype.measureGroupCaption, $.ig.XName.prototype.get($.ig.MeasureGroupConstants.prototype.measureGroupCaption, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupConstants.prototype.description, $.ig.XName.prototype.get($.ig.MeasureGroupConstants.prototype.description, $.ig.XmlaNamespace.prototype.rowset));
	}

	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var catalogName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupConstants.prototype.catalogName)));
		var cubeName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupConstants.prototype.cubeName)));
		var name = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupConstants.prototype.measureGroupName)));
		var caption = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupConstants.prototype.measureGroupCaption)));
		var description = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureGroupConstants.prototype.description)));
		return (function () { var $ret = new $.ig.MeasureGroup();
		$ret.catalogName(catalogName);
		$ret.cubeName(cubeName);
		$ret.name(name);
		$ret.caption(caption);
		$ret.description(description); return $ret;}());
	}
	, 
	$type: new $.ig.Type('MeasureGroupXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.MeasureGroup.prototype.$type)])
}, true);

$.ig.util.defType('MeasureXmlTypeSerializer', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			if ($.ig.MeasureXmlTypeSerializer.prototype.xNamesCache != null) {
				return;
			}

			$.ig.MeasureXmlTypeSerializer.prototype.xNamesCache = new $.ig.Dictionary$2(String, $.ig.XName.prototype.$type, 0);
			$.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.measureName, $.ig.XName.prototype.get($.ig.MeasureConstants.prototype.measureName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.measureUniqueName, $.ig.XName.prototype.get($.ig.MeasureConstants.prototype.measureUniqueName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.measureCaption, $.ig.XName.prototype.get($.ig.MeasureConstants.prototype.measureCaption, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.description, $.ig.XName.prototype.get($.ig.MeasureConstants.prototype.description, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.defaultFormatString, $.ig.XName.prototype.get($.ig.MeasureConstants.prototype.defaultFormatString, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.measureGroupName, $.ig.XName.prototype.get($.ig.MeasureConstants.prototype.measureGroupName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.measureAggregator, $.ig.XName.prototype.get($.ig.MeasureConstants.prototype.measureAggregator, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.measureDisplayFolder, $.ig.XName.prototype.get($.ig.MeasureConstants.prototype.measureDisplayFolder, $.ig.XmlaNamespace.prototype.rowset));
	}

	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var name = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.measureName)));
		var uniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.measureUniqueName)));
		var caption = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.measureCaption)));
		var description = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.description)));
		var defaultFormatString = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.defaultFormatString)));
		var groupName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.measureGroupName)));
		var aggregatorTypeString = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.measureAggregator)));
		var aggregatorType = ($.ig.Number.prototype.parseInt(aggregatorTypeString));
		var displayFolder = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MeasureXmlTypeSerializer.prototype.xNamesCache.item($.ig.MeasureConstants.prototype.measureDisplayFolder)));
		return (function () { var $ret = new $.ig.Measure();
		$ret.name(name);
		$ret.uniqueName(uniqueName);
		$ret.caption(caption);
		$ret.description(description);
		$ret.defaultFormatString(defaultFormatString);
		$ret.measureGroupName(groupName);
		$ret.aggregatorType(aggregatorType);
		$ret.measureDisplayFolder(displayFolder); return $ret;}());
	}
	, 
	$type: new $.ig.Type('MeasureXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.Measure.prototype.$type)])
}, true);

$.ig.util.defType('MemberXmlTypeSerializer', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			if ($.ig.MemberXmlTypeSerializer.prototype.xNamesCache != null) {
				return;
			}

			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache = new $.ig.Dictionary$2(String, $.ig.XName.prototype.$type, 0);
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.catalogName, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.catalogName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.cubeName, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.cubeName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.memberName, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.memberName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.memberUniqueName, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.memberUniqueName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.memberType, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.memberType, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.dimensionUniqueName, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.dimensionUniqueName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.hierarchyUniqueName, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.hierarchyUniqueName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.levelUniqueName, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.levelUniqueName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.memberCaption, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.memberCaption, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.description, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.description, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.levelNumber, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.levelNumber, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.childrenCardinality, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.childrenCardinality, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.parentUniqueName, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.parentUniqueName, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.scope, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.scope, $.ig.XmlaNamespace.prototype.rowset));
			$.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.parentLevel, $.ig.XName.prototype.get($.ig.MemberConstants.prototype.parentLevel, $.ig.XmlaNamespace.prototype.rowset));
	}

	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var element = node;
		var catalogName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.catalogName)));
		var cubeName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.cubeName)));
		var name = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.memberName)));
		var uniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.memberUniqueName)));
		var memberTypeValue = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.memberType)));
		var dimensionUniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.dimensionUniqueName)));
		var hierarchyUniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.hierarchyUniqueName)));
		var levelUniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.levelUniqueName)));
		var caption = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.memberCaption)));
		var description = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.description)));
		var levelDepth = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.levelNumber)));
		var childrenCardinality = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.childrenCardinality)));
		var parentUniqueName = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.parentUniqueName)));
		var scope = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.MemberXmlTypeSerializer.prototype.xNamesCache.item($.ig.MemberConstants.prototype.scope)));
		var parentLevelValue = $.ig.SerializerUtils.prototype.getText1(element.element($.ig.XName.prototype.get($.ig.MemberConstants.prototype.parentLevel, $.ig.XmlaNamespace.prototype.rowset)));
		var nullValue = $.ig.util.toNullable($.ig.Number.prototype.$type, null);
		return (function () { var $ret = new $.ig.Member();
		$ret.catalogName(catalogName);
		$ret.cubeName(cubeName);
		$ret.dimensionUniqueName(dimensionUniqueName);
		$ret.hierarchyUniqueName(hierarchyUniqueName);
		$ret.levelUniqueName(levelUniqueName);
		$ret.levelDepth($.ig.Number.prototype.parseInt(levelDepth));
		$ret.name(name);
		$ret.uniqueName(uniqueName);
		$ret.memberType($.ig.Number.prototype.parseInt(memberTypeValue));
		$ret.caption(caption);
		$ret.childrenCardinality($.ig.Number.prototype.parseInt(childrenCardinality));
		$ret.description(description);
		$ret.parentUniqueName(parentUniqueName);
		$ret.scope(scope == null ? nullValue : $.ig.Number.prototype.parseInt(scope));
		$ret.parentLevel(String.isNullOrEmpty(parentLevelValue) ? 0 : $.ig.Number.prototype.parseInt(parentLevelValue)); return $ret;}());
	}
	, 
	$type: new $.ig.Type('MemberXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.Member.prototype.$type)])
}, true);

$.ig.util.defType('ResultXmlTypeSerializer', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	deserialize: function (node) {
		var $self = this;
		if (node.nodeType() != $.ig.XmlNodeType.prototype.element) {
			return null;
		}

		var result = node;
		var namespaceName = result.name().namespaceName();
		switch (namespaceName) {
			case $.ig.XmlaNamespace.prototype.empty:
				return (function () { var $ret = new $.ig.OlapResult();
				$ret.isEmpty(true); return $ret;}());
			case $.ig.XmlaNamespace.prototype.mdDataset:
				var axisInfo = result.element($.ig.XName.prototype.get("OlapInfo", $.ig.XmlaNamespace.prototype.mdDataset));
				var axesElement = result.element($.ig.XName.prototype.get("Axes", $.ig.XmlaNamespace.prototype.mdDataset));
				var arr = new $.ig.ArraySerializer();
				var axes = arr.deserialize$1($.ig.OlapResultAxis.prototype.$type, axesElement, $.ig.XName.prototype.get("Axis", $.ig.XmlaNamespace.prototype.mdDataset), new $.ig.AxisXmlTypeSerializer());
				var cellData = result.element($.ig.XName.prototype.get("CellData", $.ig.XmlaNamespace.prototype.mdDataset));
				var cells = arr.deserialize$1($.ig.OlapResultCell.prototype.$type, cellData, $.ig.XName.prototype.get("Cell", $.ig.XmlaNamespace.prototype.mdDataset), new $.ig.CellXmlTypeSerializer());
				return (function () { var $ret = new $.ig.OlapResult();
				$ret.axes(axes);
				$ret.cells(cells); return $ret;}());
		}

		return null;
	}
	, 
	$type: new $.ig.Type('ResultXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.OlapResult.prototype.$type)])
}, true);

$.ig.util.defType('SerializerUtils', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	getText1: function (element) {
		if (element != null) {
			return element.value();

		} else {
			return null;
		}

	}

	, 
	getText: function (attribute) {
		if (attribute != null) {
			return attribute.value();

		} else {
			return null;
		}

	}

	, 
	getBoolean: function (element) {
		var value = $.ig.SerializerUtils.prototype.getText1(element).toLowerCase();
		return value == "true";
	}

	, 
	getDateTime: function (element) {
		if (element != null && !String.isNullOrEmpty(element.value())) {
			return $.ig.SerializerUtils.prototype.parseDate(element.value());

		} else {
			return $.ig.SerializerUtils.prototype.getDefaultDate();
		}

	}

	, 
	parseDate: function (dateString) {
		var dateString_ = dateString;
		var date;
		date = (function (text) {
	var match = /^\s*(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2})(.*)$/.exec(text);
	if (!match) {
		throw 'Invalid textual date representation.';
	}

    var year = parseInt(match[1], 10);
    var month = parseInt(match[2], 10) - 1; //javascript months start from 0
    var day = parseInt(match[3], 10);
    var hours = parseInt(match[4], 10);
    var minutes = parseInt(match[5], 10);
    var seconds = parseInt(match[6], 10);
	
	return new Date(year, month, day, hours, minutes, seconds);
})(dateString_);;
		return date;
	}

	, 
	getDefaultDate: function () {
		var date;
		date = new Date(2000, 0, 1);
		return date;
	}
	, 
	$type: new $.ig.Type('SerializerUtils', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XmlaConstants', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('XmlaConstants', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XmlaSoapFault', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_faultCode: null,
	faultCode: function (value) {
		if (arguments.length === 1) {
			this._faultCode = value;
			return value;
		} else {
			return this._faultCode;
		}
	}

	, 
	_faultString: null,
	faultString: function (value) {
		if (arguments.length === 1) {
			this._faultString = value;
			return value;
		} else {
			return this._faultString;
		}
	}

	, 
	_faultActor: null,
	faultActor: function (value) {
		if (arguments.length === 1) {
			this._faultActor = value;
			return value;
		} else {
			return this._faultActor;
		}
	}

	, 
	_faultDetail: null,
	faultDetail: function (value) {
		if (arguments.length === 1) {
			this._faultDetail = value;
			return value;
		} else {
			return this._faultDetail;
		}
	}
	, 
	$type: new $.ig.Type('XmlaSoapFault', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XmlaSoapFaultXmlTypeSerializer', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	deserialize: function (node) {
		var $self = this;
		var faultElement = node;
		var fault = new $.ig.XmlaSoapFault();
		var en = faultElement.elements().getEnumerator();
		while (en.moveNext()) {
			var xElement = en.current();
			switch (xElement.name().localName()) {
				case "faultcode":
					fault.faultCode($.ig.SerializerUtils.prototype.getText1(xElement));
					break;
				case "faultstring":
					fault.faultString($.ig.SerializerUtils.prototype.getText1(xElement));
					break;
				case "faultactor":
					fault.faultActor($.ig.SerializerUtils.prototype.getText1(xElement));
					break;
			}

		}

		var detail = faultElement.element($.ig.XName.prototype.get("detail", ""));
		if (detail != null) {
			var errors = detail.elements1($.ig.XName.prototype.get("Error", ""));
			var errorsList = new $.ig.List$1($.ig.FaultError.prototype.$type, 0);
			var errorXmlSerializer = new $.ig.ErrorXmlTypeSerializer();
			var en1 = errors.getEnumerator();
			while (en1.moveNext()) {
				var error = en1.current();
				var e = errorXmlSerializer.deserialize(error);
				errorsList.add(e);
			}

			fault.faultDetail((function () { var $ret = new $.ig.FaultDetail();
			$ret.error(errorsList.toArray()); return $ret;}()));
		}

		return fault;
	}
	, 
	$type: new $.ig.Type('XmlaSoapFaultXmlTypeSerializer', $.ig.Object.prototype.$type, [$.ig.IXmlTypeSerializer$1.prototype.$type.specialize($.ig.XmlaSoapFault.prototype.$type)])
}, true);

$.ig.util.defType('IXmlaMethodResult', 'Object', {
	$type: new $.ig.Type('IXmlaMethodResult', null)
}, true);

$.ig.util.defType('XmlaSoapMethodResult', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	__returnField: null

	, 
	returnElement: function (value) {
		if (arguments.length === 1) {

			this.__returnField = value;
			return value;
		} else {

			return this.__returnField;
		}
	}

	, 
	_sessionId: null,
	sessionId: function (value) {
		if (arguments.length === 1) {
			this._sessionId = value;
			return value;
		} else {
			return this._sessionId;
		}
	}
	, 
	$type: new $.ig.Type('XmlaSoapMethodResult', $.ig.Object.prototype.$type, [$.ig.IXmlaMethodResult.prototype.$type])
}, true);

$.ig.util.defType('DiscoverResponseResult', 'XmlaSoapMethodResult', {
	init: function () {

		$.ig.XmlaSoapMethodResult.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('DiscoverResponseResult', $.ig.XmlaSoapMethodResult.prototype.$type)
}, true);

$.ig.util.defType('RequestCompletedEventArgs$1', 'AsyncCompletedEventArgs', {
	$t: null, 
	__result: null
	, 
	init: function ($t, result, exception, cancelled, userState) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.AsyncCompletedEventArgs.prototype.init.call(this, exception, cancelled, userState);
			this.__result = result;
	}

	, 
	result: function () {

			$.ig.AsyncCompletedEventArgs.prototype.raiseExceptionIfNecessary.call(this);
			return this.__result;
	}
	, 
	$type: new $.ig.Type('RequestCompletedEventArgs$1', $.ig.AsyncCompletedEventArgs.prototype.$type)
}, true);

$.ig.util.defType('ExecuteResponseResult', 'XmlaSoapMethodResult', {
	init: function () {

		$.ig.XmlaSoapMethodResult.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('ExecuteResponseResult', $.ig.XmlaSoapMethodResult.prototype.$type)
}, true);

$.ig.util.defType('FaultDetail', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_error: null,
	error: function (value) {
		if (arguments.length === 1) {
			this._error = value;
			return value;
		} else {
			return this._error;
		}
	}
	, 
	$type: new $.ig.Type('FaultDetail', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IXmlaSoapMethod', 'Object', {
	$type: new $.ig.Type('IXmlaSoapMethod', null)
}, true);

$.ig.util.defType('XmlaNamespace', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('XmlaNamespace', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XmlaQueryProperty', 'Object', {
	init: function (initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.Object.prototype.init.call(this);
	}
	, 
	init1: function (initNumber, name, value) {



		$.ig.Object.prototype.init.call(this);
			this.propertyName(name);
			this.value(value);
	}

	, 
	_propertyName: null,
	propertyName: function (value) {
		if (arguments.length === 1) {
			this._propertyName = value;
			return value;
		} else {
			return this._propertyName;
		}
	}

	, 
	_value: null,
	value: function (value) {
		if (arguments.length === 1) {
			this._value = value;
			return value;
		} else {
			return this._value;
		}
	}

	, 
	toString: function () {
		return String.concat(this.propertyName(), " = ", this.value());
	}
	, 
	$type: new $.ig.Type('XmlaQueryProperty', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XmlaPropertiesCollection', 'Object', {
	__internalDictionary: null
	, 
	__itemsMap: null
	, 
	__items: null
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__internalDictionary = new $.ig.Dictionary$2(String, $.ig.XmlaQueryProperty.prototype.$type, 0);
			this.__itemsMap = new $.ig.Dictionary$2(String, $.ig.Number.prototype.$type, 0);
			this.__items = new $.ig.List$1($.ig.XmlaQueryProperty.prototype.$type, 0);
	}

	, 
	tryGetValue: function (name, value) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.__internalDictionary.tryGetValue(name, value); value = $ret.value; return $ret.ret; }()), 
			value: value
		};
		return {
			value: value
		};
	}

	, 
	contains1: function (name) {
		return this.__internalDictionary.containsKey(name);
	}

	, 
	indexOf: function (item) {
		return this.__items.indexOf(item);
	}

	, 
	insert: function (index, item) {
		this.__internalDictionary.add(item.propertyName(), item);
		this.__items.insert(index, item);
	}

	, 
	removeAt: function (index) {
		if (index < this.__items.count()) {
			var item = this.__items.item(index);
			if (this.__internalDictionary.remove(item.propertyName())) {
				this.__items.removeAt(index);
			}

		}

	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			var item = this.__items.item(index);
			this.__internalDictionary.remove(item.propertyName());
			this.__internalDictionary.add(value.propertyName(), value);
			this.__items.item(index, value);
			return value;
		} else {

			return this.__items.item(index);
		}
	}

	, 
	add: function (item) {
		this.__internalDictionary.add(item.propertyName(), item);
		this.__items.add(item);
	}

	, 
	clear: function () {
		this.__items.clear();
		this.__internalDictionary.clear();
	}

	, 
	contains: function (item) {
		return this.__items.contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		this.__items.copyTo(array, arrayIndex);
	}

	, 
	count: function () {

			return this.__items.count();
	}

	, 
	isReadOnly: function () {

			return this.__items.isReadOnly();
	}

	, 
	remove: function (item) {
		if (this.__items.remove(item)) {
			return this.__internalDictionary.remove(item.propertyName());
		}

		return false;
	}

	, 
	getEnumerator: function () {
		return this.__items.getEnumerator();
	}

	, 
	isFixedSize: function () {

			return false;
	}

	, 
	isSynchronized: function () {

			return (this.__items).isSynchronized();
	}

	, 
	syncRoot: function () {

			return (this.__items).syncRoot();
	}
	, 
	$type: new $.ig.Type('XmlaPropertiesCollection', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize($.ig.XmlaQueryProperty.prototype.$type), $.ig.IList.prototype.$type])
}, true);

$.ig.util.defType('XmlaSoapMessageBuilder', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_xmlaMethod: null,
	xmlaMethod: function (value) {
		if (arguments.length === 1) {
			this._xmlaMethod = value;
			return value;
		} else {
			return this._xmlaMethod;
		}
	}

	, 
	build: function () {
		if (this.xmlaMethod() == null) {
			throw new $.ig.InvalidOperationException(1, "XmlaMethod is not specified.");
		}

		var envelopeNamespace = $.ig.XNamespace.prototype.get($.ig.XmlaSoapMessageBuilder.prototype.xmlnsEnvelope);
		this.xmlaMethod().construct(envelopeNamespace);
		var envelope = this.createEnvelope();
		return envelope.toString();
	}

	, 
	createEnvelope: function () {
		var envelope = new $.ig.XElement(1, $.ig.XName.prototype.get($.ig.XmlaSoapMessageBuilder.prototype.envelopeConstant, $.ig.XmlaSoapMessageBuilder.prototype.xmlnsEnvelope));
		this.addHeader(envelope);
		this.addBody(envelope);
		return envelope;
	}

	, 
	addHeader: function (parentElement) {
		var header = new $.ig.XElement(1, $.ig.XName.prototype.get($.ig.XmlaSoapMessageBuilder.prototype.headerConstant, parentElement.name().namespace().namespaceName()));
		parentElement.add(header);
		var en = this.xmlaMethod().headers().getEnumerator();
		while (en.moveNext()) {
			var element = en.current();
			header.add(element);
		}

	}

	, 
	addBody: function (parentElement) {
		var body = new $.ig.XElement(1, $.ig.XName.prototype.get($.ig.XmlaSoapMessageBuilder.prototype.bodyConstant, parentElement.name().namespace().namespaceName()));
		parentElement.add(body);
		var methodElement = new $.ig.XElement(1, $.ig.XName.prototype.get(this.xmlaMethod().name(), $.ig.XmlaNamespace.prototype.analysis));
		body.add(methodElement);
		var en = this.xmlaMethod().parameters().getEnumerator();
		while (en.moveNext()) {
			var element = en.current();
			methodElement.add(element);
		}

	}
	, 
	$type: new $.ig.Type('XmlaSoapMessageBuilder', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XmlaSoapMethod', 'Object', {
	__parameters: null
	, 
	__headers: null
	, 
	__parametersList: null
	, 
	__headersList: null
	, 
	__properties: null
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__parametersList = new $.ig.List$1($.ig.XElement.prototype.$type, 0);
			this.__headersList = new $.ig.List$1($.ig.XElement.prototype.$type, 0);
			this.__parameters = new $.ig.ReadOnlyCollection$1($.ig.XElement.prototype.$type, 1, this.__parametersList);
			this.__headers = new $.ig.ReadOnlyCollection$1($.ig.XElement.prototype.$type, 1, this.__headersList);
			this.__properties = new $.ig.XmlaPropertiesCollection();
	}

	, 
	properties: function () {

			return this.__properties;
	}

	, 
	name: function () {

	}

	, 
	parameters: function () {

			return this.__parameters;
	}

	, 
	headers: function () {

			return this.__headers;
	}

	, 
	parametersList: function () {

			return this.__parametersList;
	}

	, 
	headersList: function () {

			return this.__headersList;
	}

	, 
	construct: function (headerNamespace) {
	}

	, 
	mergeProperties: function (properties) {
		var $self = this;
		if (properties == null) {
			return;
		}

		var en = properties.getEnumerator();
		while (en.moveNext()) {
			var xmlaQueryProperty = en.current();
			var propInstance;
			if ((function () { var $ret = $self.properties().tryGetValue(xmlaQueryProperty.propertyName(), propInstance); propInstance = $ret.value; return $ret.ret; }())) {
				propInstance.value(xmlaQueryProperty.value());

			} else {
				$self.properties().add(xmlaQueryProperty);
			}

		}

	}
	, 
	$type: new $.ig.Type('XmlaSoapMethod', $.ig.Object.prototype.$type, [$.ig.IXmlaSoapMethod.prototype.$type])
}, true);

$.ig.util.defType('XmlaSoapMethodDiscover', 'XmlaSoapMethod', {
	__restrictions: null
	, 
	init: function (requestType) {



		$.ig.XmlaSoapMethod.prototype.init.call(this);
			this.headerType($.ig.XmlaSoapMessageHeader.prototype.none);
			this.requestType(requestType);
			this.__restrictions = new $.ig.Dictionary$2(String, $.ig.Object.prototype.$type, 0);
	}

	, 
	restrictions: function () {

			return this.__restrictions;
	}

	, 
	_requestType: null,
	requestType: function (value) {
		if (arguments.length === 1) {
			this._requestType = value;
			return value;
		} else {
			return this._requestType;
		}
	}

	, 
	name: function () {

			return $.ig.XmlaSoapMethodDiscover.prototype.methodName;
	}

	, 
	_headerType: null,
	headerType: function (value) {
		if (arguments.length === 1) {
			this._headerType = value;
			return value;
		} else {
			return this._headerType;
		}
	}

	, 
	_sessionId: null,
	sessionId: function (value) {
		if (arguments.length === 1) {
			this._sessionId = value;
			return value;
		} else {
			return this._sessionId;
		}
	}

	, 
	construct: function (headerNamespace) {
		var analysis = $.ig.XNamespace.prototype.get($.ig.XmlaNamespace.prototype.analysis);
		var requestType = new $.ig.XElement(1, $.ig.XName.prototype.get($.ig.XmlaSoapMethodDiscover.prototype.requestTypeConstant, analysis.namespaceName()));
		requestType.value(this.requestType());
		var properties = new $.ig.XElement(1, $.ig.XName.prototype.get($.ig.XmlaSoapMethod.prototype.propertiesConstant, $.ig.XmlaNamespace.prototype.analysis));
		var propertyList = new $.ig.XElement(1, $.ig.XName.prototype.get($.ig.XmlaSoapMethod.prototype.propertyListConstant, properties.name().namespace().namespaceName()));
		properties.add(propertyList);
		var restrictions = new $.ig.XElement(1, $.ig.XName.prototype.get($.ig.XmlaSoapMethodDiscover.prototype.restrictionsConstant, $.ig.XmlaNamespace.prototype.analysis));
		var restrictionList = new $.ig.XElement(1, $.ig.XName.prototype.get($.ig.XmlaSoapMethodDiscover.prototype.restrictionListConstant, restrictions.name().namespace().namespaceName()));
		restrictions.add(restrictionList);
		var en = this.properties().getEnumerator();
		while (en.moveNext()) {
			var property = en.current();
			propertyList.add(new $.ig.XElement(2, $.ig.XName.prototype.get(property.propertyName(), $.ig.XmlaNamespace.prototype.analysis), property.value()));
		}

		var en1 = this.__restrictions.getEnumerator();
		while (en1.moveNext()) {
			var restriction = en1.current();
			restrictionList.add(new $.ig.XElement(2, $.ig.XName.prototype.get(restriction.key(), ""), restriction.value()));
		}

		this.parametersList().add(requestType);
		this.parametersList().add(restrictions);
		this.parametersList().add(properties);
	}
	, 
	$type: new $.ig.Type('XmlaSoapMethodDiscover', $.ig.XmlaSoapMethod.prototype.$type)
}, true);

$.ig.util.defType('XmlaSoapMethodExecute', 'XmlaSoapMethod', {
	init: function (statement) {



		$.ig.XmlaSoapMethod.prototype.init.call(this);
			this.statement(statement);
	}

	, 
	name: function () {

			return $.ig.XmlaSoapMethodExecute.prototype.methodName;
	}

	, 
	_statement: null,
	statement: function (value) {
		if (arguments.length === 1) {
			this._statement = value;
			return value;
		} else {
			return this._statement;
		}
	}

	, 
	construct: function (headerNamespace) {
		var analysis = $.ig.XNamespace.prototype.get($.ig.XmlaNamespace.prototype.analysis);
		var command = new $.ig.XElement(1, $.ig.XName.prototype.get($.ig.XmlaSoapMethodExecute.prototype.commandConstant, analysis.namespaceName()));
		var statement = new $.ig.XElement(1, $.ig.XName.prototype.get($.ig.XmlaSoapMethodExecute.prototype.statementConstant, analysis.namespaceName()));
		statement.value(this.statement());
		command.add(statement);
		var properties = new $.ig.XElement(1, $.ig.XName.prototype.get($.ig.XmlaSoapMethod.prototype.propertiesConstant, $.ig.XmlaNamespace.prototype.analysis));
		var propertyList = new $.ig.XElement(1, $.ig.XName.prototype.get($.ig.XmlaSoapMethod.prototype.propertyListConstant, properties.name().namespace().namespaceName()));
		properties.add(propertyList);
		var en = this.properties().getEnumerator();
		while (en.moveNext()) {
			var property = en.current();
			propertyList.add(new $.ig.XElement(2, $.ig.XName.prototype.get(property.propertyName(), $.ig.XmlaNamespace.prototype.analysis), property.value()));
		}

		this.parametersList().add(command);
		this.parametersList().add(properties);
	}
	, 
	$type: new $.ig.Type('XmlaSoapMethodExecute', $.ig.XmlaSoapMethod.prototype.$type)
}, true);

$.ig.util.defType('XmlaSoapWebClient', 'Object', {
	staticInit: function () {



			$.ig.XmlaSoapWebClient.prototype._registeredPrefixes = new $.ig.List$1(String, 0);
	}
	, 
	$type: new $.ig.Type('XmlaSoapWebClient', $.ig.Object.prototype.$type)
}, true);
$.ig.util.defType('XmlaSoapWebClient$1', 'XmlaSoapWebClient', {
	$t: null, 
	__webClient: null
	, 
	__requestCompleted: false
	, 
	init: function ($t, serverUri, encoding) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.XmlaSoapWebClient.prototype.init.call(this);
			this.__webClient = new $.ig.WebClient();
			this.__webClient.encoding(encoding);
			this.__webClient.uploadStringCompleted = $.ig.Delegate.prototype.combine(this.__webClient.uploadStringCompleted, this.requestAsyncCompleted.runOn(this));
			this.serverUri(serverUri);
	}
	, 
	requestCompleted: null
	, 
	_credentials: null,
	credentials: function (value) {
		if (arguments.length === 1) {
			this._credentials = value;
			return value;
		} else {
			return this._credentials;
		}
	}

	, 
	_serverUri: null,
	serverUri: function (value) {
		if (arguments.length === 1) {
			this._serverUri = value;
			return value;
		} else {
			return this._serverUri;
		}
	}

	, 
	isCompleted: function () {

			return this.__requestCompleted;
	}

	, 
	requestAsync: function (xmlaSoapMethod) {
		this.requestAsync1(xmlaSoapMethod, null);
	}

	, 
	requestAsync1: function (xmlaSoapMethod, userData) {
		var messageBuilder = new $.ig.XmlaSoapMessageBuilder();
		messageBuilder.xmlaMethod(xmlaSoapMethod);
		var xmlaRequest = messageBuilder.build();
		if (this.credentials() != null) {
			this.__webClient.credentials(this.credentials());

		} else {
			this.__webClient.credentials(null);
		}

		this.__webClient.headers().item("Content-Type", "text/xml");
		this.__webClient.uploadStringAsync(this.serverUri(), "POST", xmlaRequest, userData);
	}

	, 
	onRequestCompleted: function (args) {
		if (this.requestCompleted != null) {
			this.requestCompleted(this, args);
		}

	}

	, 
	requestAsyncCompleted: function (sender, e) {
		this.__requestCompleted = true;
		this.onRequestCompletedImpl(e);
	}

	, 
	onRequestCompletedImpl: function (e) {
		var result = null;
		var faultException = null;
		var error = null;
		if (!e.cancelled() && e.error() == null) {
			try {
					var resultDocument = $.ig.XDocument.prototype.parse(e.result());
					var envelope = resultDocument.element($.ig.XName.prototype.get("Envelope", "http://schemas.xmlsoap.org/soap/envelope/"));
					var body = envelope.element($.ig.XName.prototype.get("Body", "http://schemas.xmlsoap.org/soap/envelope/"));
					var faultElement = body.element($.ig.XName.prototype.get("Fault", "http://schemas.xmlsoap.org/soap/envelope/"));
					if (faultElement != null) {
						var faultSerializer = new $.ig.XmlaSoapFaultXmlTypeSerializer();
						var fault = faultSerializer.deserialize(faultElement);
						faultException = new $.ig.FaultException$1($.ig.XmlaSoapFault.prototype.$type, fault, new $.ig.FaultReason(fault.faultString()), new $.ig.FaultCode(fault.faultCode()), null);

					} else {
						if (this.$t == $.ig.DiscoverResponseResult.prototype.$type) {
							var discoverResponse = body.element($.ig.XName.prototype.get("DiscoverResponse", $.ig.XmlaNamespace.prototype.analysis));
							var returnElement = discoverResponse.element($.ig.XName.prototype.get("return", $.ig.XmlaNamespace.prototype.analysis));
							var root = returnElement.element($.ig.XName.prototype.get("root", $.ig.XmlaNamespace.prototype.rowset));
							var discoverResponseResult = new $.ig.DiscoverResponseResult();
							discoverResponseResult.returnElement(root);
							result = discoverResponseResult;
						}

						if (this.$t == $.ig.ExecuteResponseResult.prototype.$type) {
							var response = body.element($.ig.XName.prototype.get("ExecuteResponse", $.ig.XmlaNamespace.prototype.analysis));
							var returnElement1 = response.element($.ig.XName.prototype.get("return", $.ig.XmlaNamespace.prototype.analysis));
							var root1 = returnElement1.element($.ig.XName.prototype.get("root", $.ig.XmlaNamespace.prototype.mdDataset));
							var executeResponseResult = new $.ig.ExecuteResponseResult();
							executeResponseResult.returnElement(root1);
							result = executeResponseResult;
						}

					}


			}
			catch (e_) {
					error = e_;

			}
		}

		if (error == null) {
			error = e.error() != null ? e.error() : faultException;
		}

		var args = new $.ig.RequestCompletedEventArgs$1(this.$t, result, error, e.cancelled(), e.userState());
		this.onRequestCompleted(args);
	}
	, 
	$type: new $.ig.Type('XmlaSoapWebClient$1', $.ig.XmlaSoapWebClient.prototype.$type)
}, true);

$.ig.util.defType('XmlaSoapWebClient', 'Object', {
	staticInit: function () {



			$.ig.XmlaSoapWebClient.prototype._registeredPrefixes = new $.ig.List$1(String, 0);
	}
	, 
	$type: new $.ig.Type('XmlaSoapWebClient', $.ig.Object.prototype.$type)
}, true);
$.ig.util.defType('XmlaSoapWebClient$1', 'XmlaSoapWebClient', {
	$t: null, 
	__webClient: null
	, 
	__requestCompleted: false
	, 
	init: function ($t, serverUri, encoding) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.XmlaSoapWebClient.prototype.init.call(this);
			this.__webClient = new $.ig.WebClient();
			this.__webClient.encoding(encoding);
			this.__webClient.uploadStringCompleted = $.ig.Delegate.prototype.combine(this.__webClient.uploadStringCompleted, this.requestAsyncCompleted.runOn(this));
			this.serverUri(serverUri);
	}
	, 
	requestCompleted: null
	, 
	_credentials: null,
	credentials: function (value) {
		if (arguments.length === 1) {
			this._credentials = value;
			return value;
		} else {
			return this._credentials;
		}
	}

	, 
	_serverUri: null,
	serverUri: function (value) {
		if (arguments.length === 1) {
			this._serverUri = value;
			return value;
		} else {
			return this._serverUri;
		}
	}

	, 
	isCompleted: function () {

			return this.__requestCompleted;
	}

	, 
	requestAsync: function (xmlaSoapMethod) {
		this.requestAsync1(xmlaSoapMethod, null);
	}

	, 
	requestAsync1: function (xmlaSoapMethod, userData) {
		var messageBuilder = new $.ig.XmlaSoapMessageBuilder();
		messageBuilder.xmlaMethod(xmlaSoapMethod);
		var xmlaRequest = messageBuilder.build();
		if (this.credentials() != null) {
			this.__webClient.credentials(this.credentials());

		} else {
			this.__webClient.credentials(null);
		}

		this.__webClient.headers().item("Content-Type", "text/xml");
		this.__webClient.uploadStringAsync(this.serverUri(), "POST", xmlaRequest, userData);
	}

	, 
	onRequestCompleted: function (args) {
		if (this.requestCompleted != null) {
			this.requestCompleted(this, args);
		}

	}

	, 
	requestAsyncCompleted: function (sender, e) {
		this.__requestCompleted = true;
		this.onRequestCompletedImpl(e);
	}

	, 
	onRequestCompletedImpl: function (e) {
		var result = null;
		var faultException = null;
		var error = null;
		if (!e.cancelled() && e.error() == null) {
			try {
					var resultDocument = $.ig.XDocument.prototype.parse(e.result());
					var envelope = resultDocument.element($.ig.XName.prototype.get("Envelope", "http://schemas.xmlsoap.org/soap/envelope/"));
					var body = envelope.element($.ig.XName.prototype.get("Body", "http://schemas.xmlsoap.org/soap/envelope/"));
					var faultElement = body.element($.ig.XName.prototype.get("Fault", "http://schemas.xmlsoap.org/soap/envelope/"));
					if (faultElement != null) {
						var faultSerializer = new $.ig.XmlaSoapFaultXmlTypeSerializer();
						var fault = faultSerializer.deserialize(faultElement);
						faultException = new $.ig.FaultException$1($.ig.XmlaSoapFault.prototype.$type, fault, new $.ig.FaultReason(fault.faultString()), new $.ig.FaultCode(fault.faultCode()), null);

					} else {
						if (this.$t == $.ig.DiscoverResponseResult.prototype.$type) {
							var discoverResponse = body.element($.ig.XName.prototype.get("DiscoverResponse", $.ig.XmlaNamespace.prototype.analysis));
							var returnElement = discoverResponse.element($.ig.XName.prototype.get("return", $.ig.XmlaNamespace.prototype.analysis));
							var root = returnElement.element($.ig.XName.prototype.get("root", $.ig.XmlaNamespace.prototype.rowset));
							var discoverResponseResult = new $.ig.DiscoverResponseResult();
							discoverResponseResult.returnElement(root);
							result = discoverResponseResult;
						}

						if (this.$t == $.ig.ExecuteResponseResult.prototype.$type) {
							var response = body.element($.ig.XName.prototype.get("ExecuteResponse", $.ig.XmlaNamespace.prototype.analysis));
							var returnElement1 = response.element($.ig.XName.prototype.get("return", $.ig.XmlaNamespace.prototype.analysis));
							var root1 = returnElement1.element($.ig.XName.prototype.get("root", $.ig.XmlaNamespace.prototype.mdDataset));
							var executeResponseResult = new $.ig.ExecuteResponseResult();
							executeResponseResult.returnElement(root1);
							result = executeResponseResult;
						}

					}


			}
			catch (e_) {
					error = e_;

			}
		}

		if (error == null) {
			error = e.error() != null ? e.error() : faultException;
		}

		var args = new $.ig.RequestCompletedEventArgs$1(this.$t, result, error, e.cancelled(), e.userState());
		this.onRequestCompleted(args);
	}
	, 
	$type: new $.ig.Type('XmlaSoapWebClient$1', $.ig.XmlaSoapWebClient.prototype.$type)
}, true);


$.ig.util.defType('IMdxExpression', 'Object', {
	$type: new $.ig.Type('IMdxExpression', null)
}, true);

$.ig.util.defType('IMdxElement', 'Object', {
	$type: new $.ig.Type('IMdxElement', null, [$.ig.IMdxExpression.prototype.$type])
}, true);

$.ig.util.defType('IAxisFilterElement', 'Object', {
	$type: new $.ig.Type('IAxisFilterElement', null, [$.ig.IMdxElement.prototype.$type])
}, true);

$.ig.util.defType('IMdxAxis', 'Object', {
	$type: new $.ig.Type('IMdxAxis', null, [$.ig.IMdxExpression.prototype.$type])
}, true);

$.ig.util.defType('IMdxAxisProvider', 'Object', {
	$type: new $.ig.Type('IMdxAxisProvider', null)
}, true);


$.ig.util.defType('IMdxCollectionElement', 'Object', {
	$type: new $.ig.Type('IMdxCollectionElement', null, [$.ig.IMdxElement.prototype.$type])
}, true);

$.ig.util.defType('IMdxDimensionAxisProvider', 'Object', {
	$type: new $.ig.Type('IMdxDimensionAxisProvider', null, [$.ig.IMdxAxisProvider.prototype.$type])
}, true);

$.ig.util.defType('IMdxFilterInfo', 'Object', {
	$type: new $.ig.Type('IMdxFilterInfo', null)
}, true);

$.ig.util.defType('IMdxExtendedFilterInfo', 'Object', {
	$type: new $.ig.Type('IMdxExtendedFilterInfo', null, [$.ig.IMdxFilterInfo.prototype.$type])
}, true);

$.ig.util.defType('IMdxItemElement', 'Object', {
	$type: new $.ig.Type('IMdxItemElement', null, [$.ig.IMdxElement.prototype.$type])
}, true);


$.ig.util.defType('IMdxSet', 'Object', {
	$type: new $.ig.Type('IMdxSet', null, [$.ig.IMdxExpression.prototype.$type])
}, true);

$.ig.util.defType('MdxAxis', 'Object', {
	__setsList: null
	, 
	__sets: null
	, 
	__isExpressionReady: false
	, 
	__expression: null
	, 
	__axisIndex: 0
	, 
	__axisNames: null
	, 
	init: function (initNumber, axisIndex) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		this.__axisNames = (function () { var $ret = new Array();
		$ret.add("COLUMNS");
		$ret.add("ROWS");
		$ret.add("PAGES");return $ret;}());

		$.ig.MdxAxis.prototype.init1.call(this, 1, axisIndex, new $.ig.MdxDimensionAxisSettings());
	}
	, 
	init1: function (initNumber, axisIndex, settings) {


		this.__axisNames = (function () { var $ret = new Array();
		$ret.add("COLUMNS");
		$ret.add("ROWS");
		$ret.add("PAGES");return $ret;}());

		$.ig.Object.prototype.init.call(this);
			this.axisIndex(axisIndex);
			this.mdxSettings(settings != null ? settings : new $.ig.MdxDimensionAxisSettings());
			this.__setsList = new $.ig.List$1($.ig.IMdxSet.prototype.$type, 0);
			this.__sets = new $.ig.ReadOnlyCollection$1($.ig.IMdxSet.prototype.$type, 1, this.__setsList);
	}

	, 
	axisIndex: function (value) {
		if (arguments.length === 1) {

			if (this.__axisIndex != value) {
				this.__axisIndex = value;
				this.__isExpressionReady = false;
			}

			return value;
		} else {

			return this.__axisIndex;
		}
	}

	, 
	_mdxSettings: null,
	mdxSettings: function (value) {
		if (arguments.length === 1) {
			this._mdxSettings = value;
			return value;
		} else {
			return this._mdxSettings;
		}
	}

	, 
	mdxDimensionAxisSettings: function () {

			return $.ig.util.cast($.ig.MdxDimensionAxisSettings.prototype.$type, this.mdxSettings());
	}

	, 
	sets: function () {

			return this.__sets;
	}

	, 
	mdxExpression: function () {

			if (!this.__isExpressionReady) {
				this.__expression = this.getMdxExpression();
				this.__isExpressionReady = true;
			}

			return this.__expression;
	}

	, 
	rebuildExpression: function () {
		this.__expression = this.getMdxExpression();
		this.__isExpressionReady = true;
	}

	, 
	getMdxSets: function () {
		var $self = this;
		var $iter = function () { return function () { return {
			$state: 0,
			$this: $self,
			$current: null,
			$e : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$e = this.$this.__sets.getEnumerator();
								this.$state = 1;
								break;
							case 1:
								this.$state = 4;
								break;
														case 2:
									this.$current = this.$e.current();
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								if (this.$e.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 5;
								}
								break;
							case 5:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } () };
		return new $.ig.GenericEnumerable$1($.ig.IMdxSet.prototype.$type, $iter);
	}

	, 
	addSet: function (mdxSet) {
		this.__setsList.add(mdxSet);
		this.__isExpressionReady = false;
	}

	, 
	getMdxExpression: function () {
		var stringBuilder = new $.ig.StringBuilder();
		var addComma = false;
		var en = this.sets().getEnumerator();
		while (en.moveNext()) {
			var mdxSet = en.current();
			if (!mdxSet.isEnabled()) {
				continue;
			}

			if (addComma) {
				stringBuilder.append1(",");
				stringBuilder.append1($.ig.Environment.prototype.newLine());
			}

			stringBuilder.append1(mdxSet.mdxExpression());
			addComma = true;
		}

		if (this.sets().count() > 1) {
			stringBuilder.insert1(0, "{");
			stringBuilder.append1("}");
		}

		this.addDisctinct(stringBuilder, this.mdxDimensionAxisSettings());
		this.addNonEmpty(stringBuilder, this.mdxDimensionAxisSettings());
		this.addDimensionProperties(stringBuilder, this.mdxDimensionAxisSettings());
		this.addAxisName(stringBuilder);
		return stringBuilder.toString();
	}

	, 
	addDisctinct: function (stringBuilder, settings) {
		if (settings.distinct()) {
			stringBuilder.insert1(0, "Distinct(");
			stringBuilder.append1(")");
		}

	}

	, 
	addNonEmpty: function (stringBuilder, settings) {
		if (settings.nonEmpty()) {
			stringBuilder.insert1(0, $.ig.Environment.prototype.newLine());
			stringBuilder.insert1(0, "NON EMPTY");
		}

	}

	, 
	addDimensionProperties: function (stringBuilder, settings) {
		if (settings.addDimensionProperties()) {
			stringBuilder.append1($.ig.Environment.prototype.newLine());
			stringBuilder.append1("DIMENSION PROPERTIES");
			var properties = settings.dimensionProperties();
			var addComma = false;
			var en = properties.getEnumerator();
			while (en.moveNext()) {
				var property = en.current();
				stringBuilder.append1($.ig.Environment.prototype.newLine());
				if (addComma) {
					stringBuilder.append1(",");
				}

				stringBuilder.append1(property);
				addComma = true;
			}

		}

	}

	, 
	addAxisName: function (stringBuilder) {
		if (this.axisIndex() < 2) {
			stringBuilder.append1($.ig.Environment.prototype.newLine());
			stringBuilder.append1(String.concat("ON ", this.__axisNames[this.axisIndex()]));
		}

	}
	, 
	$type: new $.ig.Type('MdxAxis', $.ig.Object.prototype.$type, [$.ig.IMdxAxis.prototype.$type])
}, true);

$.ig.util.defType('MdxAxisFilterElement', 'Object', {
	__filterCollection: null
	, 
	__singleFilterElements: null
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__singleFilterElements = new $.ig.List$1($.ig.IMdxElement.prototype.$type, 0);
			this.singleFilterElements(new $.ig.ReadOnlyCollection$1($.ig.IMdxElement.prototype.$type, 1, this.__singleFilterElements));
			this.__filterCollection = new $.ig.MdxElementCollectionElement();
	}

	, 
	mdxExpression: function () {

			var $self = this;
			if ($self.__filterCollection.collectionElements().count() > 1) {
				$self.__filterCollection.wrapExpressionWithBrackets((function () { var $ret = new Array();
				$ret.add("(");
				$ret.add(")");return $ret;}()));
			}

			return $self.__filterCollection.mdxExpression();
	}

	, 
	_singleFilterElements: null,
	singleFilterElements: function (value) {
		if (arguments.length === 1) {
			this._singleFilterElements = value;
			return value;
		} else {
			return this._singleFilterElements;
		}
	}

	, 
	filterCollection: function () {

			return this.__filterCollection.collectionElements();
	}

	, 
	rebuildExpression: function () {
		this.__filterCollection.rebuildExpression();
	}

	, 
	addFilterPart: function (filterCollection, addToSingleCollection) {
		if (filterCollection.collectionElements().count() > 0) {
			if (filterCollection.collectionElements().count() == 1 && addToSingleCollection) {
				this.__singleFilterElements.add(filterCollection.collectionElements().item(0));
				return;
			}

			this.__filterCollection.addElement(filterCollection);
		}

	}

	, 
	elementType: function () {

			return $.ig.MdxElementType.prototype.filter;
	}
	, 
	$type: new $.ig.Type('MdxAxisFilterElement', $.ig.Object.prototype.$type, [$.ig.IAxisFilterElement.prototype.$type])
}, true);

$.ig.util.defType('MdxCalculatedMembersCache', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

		this.__registeredMembers = new $.ig.List$1(String, 0);
		this.__memberExpression = new $.ig.Dictionary$2(String, String, 0);
	}, 
	__registeredMembers: null
	, 
	__memberExpression: null

	, 
	getCalculatedMembers: function (calculatedMembersCache) {
		var stringBuilder = new $.ig.StringBuilder();
		var en = calculatedMembersCache.getMemberAliasExpressionPairs().getEnumerator();
		while (en.moveNext()) {
			var aliasExpressionPair = en.current();
			$.ig.MdxCalculatedMembersCache.prototype.addCalculatedMemberWithClause(stringBuilder, aliasExpressionPair.key(), aliasExpressionPair.value());
		}

		return stringBuilder.toString();
	}

	, 
	addMember: function (uniqueName, queryAlias, expression) {
		if (!this.__registeredMembers.contains(uniqueName)) {
			this.__registeredMembers.add(uniqueName);
		}

		if (!this.__memberExpression.containsKey(queryAlias)) {
			this.__memberExpression.add(queryAlias, expression);
		}

	}

	, 
	getMemberAliasExpressionPairs: function () {
		var $self = this;
		var $iter = function () { return function () { return {
			$state: 0,
			$this: $self,
			$current: null,
			$e : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$e = this.$this.__memberExpression.getEnumerator();
								this.$state = 1;
								break;
							case 1:
								this.$state = 4;
								break;
														case 2:
									this.$current = this.$e.current();
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								if (this.$e.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 5;
								}
								break;
							case 5:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } () };
		return new $.ig.GenericEnumerable$1($.ig.KeyValuePair$2.prototype.$type.specialize(String, String), $iter);
	}

	, 
	checkCacheMember: function (uniqueName) {
		return this.__registeredMembers.contains(uniqueName);
	}

	, 
	addCalculatedMemberWithClause: function (stringBuilder, alias, expression) {
		stringBuilder.append1(String.concat("MEMBER ", alias, " AS", $.ig.Environment.prototype.newLine()));
		stringBuilder.append1(expression);
		stringBuilder.append1($.ig.Environment.prototype.newLine());
	}
	, 
	$type: new $.ig.Type('MdxCalculatedMembersCache', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MdxElement', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.elementType($.ig.MdxElementType.prototype.userDefined);
	}

	, 
	mdxExpression: function () {

	}

	, 
	_elementType: null,
	elementType: function (value) {
		if (arguments.length === 1) {
			this._elementType = value;
			return value;
		} else {
			return this._elementType;
		}
	}

	, 
	_sourceItemExpression: null,
	sourceItemExpression: function (value) {
		if (arguments.length === 1) {
			this._sourceItemExpression = value;
			return value;
		} else {
			return this._sourceItemExpression;
		}
	}

	, 
	rebuildExpression: function () {
	}
	, 
	$type: new $.ig.Type('MdxElement', $.ig.Object.prototype.$type, [$.ig.IMdxItemElement.prototype.$type])
}, true);

$.ig.util.defType('MdxSingleElement', 'MdxElement', {
	init: function (initNumber, elementExpression, elementUniqueName, memberDepth) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.MdxSingleElement.prototype.init1.call(this, 1, elementExpression, elementUniqueName, memberDepth, $.ig.MdxElementType.prototype.member);
	}
	, 
	init1: function (initNumber, elementExpression, elementUniqueName, memberDepth, elementType) {



		$.ig.MdxElement.prototype.init.call(this);
			this.memberDepth(memberDepth);
			switch (elementType) {
				case $.ig.MdxElementType.prototype.member:
				case $.ig.MdxElementType.prototype.calculated:
					this.sourceItemExpression(elementExpression);
					this.elementUniqueName(elementUniqueName);
					this.elementType(elementType);
					break;
				default:
					throw new $.ig.ArgumentException(1, "Element type could be MdxElementType.Member or MdxElementType.Calculated", "elementType");
			}

	}

	, 
	mdxExpression: function () {

			return this.sourceItemExpression();
	}

	, 
	_elementUniqueName: null,
	elementUniqueName: function (value) {
		if (arguments.length === 1) {
			this._elementUniqueName = value;
			return value;
		} else {
			return this._elementUniqueName;
		}
	}

	, 
	_memberDepth: 0,
	memberDepth: function (value) {
		if (arguments.length === 1) {
			this._memberDepth = value;
			return value;
		} else {
			return this._memberDepth;
		}
	}
	, 
	$type: new $.ig.Type('MdxSingleElement', $.ig.MdxElement.prototype.$type)
}, true);

$.ig.util.defType('MdxDimensionMember', 'MdxSingleElement', {
	init: function (elementExpression, elementUniqueName, memberDepth, parentHierarchyUniqueName, parent) {



		$.ig.MdxSingleElement.prototype.init.call(this, elementExpression, elementUniqueName, memberDepth);
			this.parentHierarchyUniqueName(parentHierarchyUniqueName);
			this.parent(parent);
	}

	, 
	_parentHierarchyUniqueName: null,
	parentHierarchyUniqueName: function (value) {
		if (arguments.length === 1) {
			this._parentHierarchyUniqueName = value;
			return value;
		} else {
			return this._parentHierarchyUniqueName;
		}
	}

	, 
	_parent: null,
	parent: function (value) {
		if (arguments.length === 1) {
			this._parent = value;
			return value;
		} else {
			return this._parent;
		}
	}
	, 
	$type: new $.ig.Type('MdxDimensionMember', $.ig.MdxSingleElement.prototype.$type)
}, true);

$.ig.util.defType('MdxChildrenCollectionElement', 'MdxDimensionMember', {
	init: function (elementExpression, elementUniqueName, memberDepth, parentHierarchyUniqueName, parent) {



		$.ig.MdxDimensionMember.prototype.init.call(this, elementExpression, elementUniqueName, memberDepth, parentHierarchyUniqueName, parent);
	}

	, 
	mdxExpression: function () {

			return String.concat(this.sourceItemExpression(), ".Children");
	}
	, 
	$type: new $.ig.Type('MdxChildrenCollectionElement', $.ig.MdxDimensionMember.prototype.$type)
}, true);


$.ig.util.defType('MdxElementCollectionElement', 'Object', {
	__collectionElementsList: null
	, 
	__isExpressionReady: false
	, 
	__expression: null
	, 
	__wrapExpressionWithBrackets: null
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__collectionElementsList = new $.ig.List$1($.ig.IMdxElement.prototype.$type, 0);
			this.collectionElements(new $.ig.ReadOnlyCollection$1($.ig.IMdxElement.prototype.$type, 1, this.__collectionElementsList));
	}

	, 
	wrapExpressionWithBrackets: function (value) {
		if (arguments.length === 1) {

			if (this.__wrapExpressionWithBrackets != value) {
				this.__isExpressionReady = false;
				this.__wrapExpressionWithBrackets = value;
			}

			return value;
		} else {

			return this.__wrapExpressionWithBrackets;
		}
	}

	, 
	_collectionElements: null,
	collectionElements: function (value) {
		if (arguments.length === 1) {
			this._collectionElements = value;
			return value;
		} else {
			return this._collectionElements;
		}
	}

	, 
	elementType: function () {

			return $.ig.MdxElementType.prototype.collection;
	}

	, 
	mdxExpression: function () {

			if (!this.__isExpressionReady) {
				this.__expression = this.getMdxExpression();
				this.__isExpressionReady = true;
			}

			return this.__expression;
	}

	, 
	rebuildExpression: function () {
		this.__expression = this.getMdxExpression();
		this.__isExpressionReady = true;
	}

	, 
	addElement: function (mdxElement) {
		var $self = this;
		$self.__collectionElementsList.add(mdxElement);
		if ($self.collectionElements().count() > 1) {
			$self.wrapExpressionWithBrackets((function () { var $ret = new Array();
			$ret.add("{");
			$ret.add("}");return $ret;}()));
		}

		$self.__isExpressionReady = false;
	}

	, 
	getMdxExpression: function () {
		if (this.collectionElements().count() == 0) {
			return String.empty();
		}

		var stringBuilder = new $.ig.StringBuilder();
		var addComma = false;
		var en = this.collectionElements().getEnumerator();
		while (en.moveNext()) {
			var filterElementItem = en.current();
			if (addComma) {
				stringBuilder.append1(",");
				stringBuilder.append1($.ig.Environment.prototype.newLine());
			}

			stringBuilder.append1(filterElementItem.mdxExpression());
			addComma = true;
		}

		if (this.wrapExpressionWithBrackets() != null && this.wrapExpressionWithBrackets().length == 2) {
			stringBuilder.insert1(0, this.wrapExpressionWithBrackets()[0]);
			stringBuilder.append1(this.wrapExpressionWithBrackets()[1]);
		}

		return stringBuilder.toString();
	}
	, 
	$type: new $.ig.Type('MdxElementCollectionElement', $.ig.Object.prototype.$type, [$.ig.IMdxCollectionElement.prototype.$type])
}, true);

$.ig.util.defType('MdxLevelMembersElement', 'MdxSingleElement', {
	init: function (elementExpression, elementUniqueName, memberDepth) {



		$.ig.MdxSingleElement.prototype.init.call(this, elementExpression, elementUniqueName, memberDepth);
	}

	, 
	mdxExpression: function () {

			return String.concat(this.sourceItemExpression(), ".MEMBERS");
	}
	, 
	$type: new $.ig.Type('MdxLevelMembersElement', $.ig.MdxSingleElement.prototype.$type)
}, true);

$.ig.util.defType('MdxQueryBuilder', 'Object', {
	__mdxSettings: null
	, 
	init: function (initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.MdxQueryBuilder.prototype.init1.call(this, 1, new $.ig.MdxSettings());
	}
	, 
	init1: function (initNumber, settings) {



		$.ig.Object.prototype.init.call(this);
			this.mdxSettings(settings);
	}

	, 
	mdxSettings: function (value) {
		if (arguments.length === 1) {

			this.__mdxSettings = value;
			return value;
		} else {

			if (this.__mdxSettings == null) {
				this.__mdxSettings = new $.ig.MdxSettings();
			}

			return this.__mdxSettings;
		}
	}

	, 
	buildMdxQuery: function (mdxColumnsAxis, mdxRowsAxis, mdxSlicerAxis, calculatedMembersCache, cubeName) {
		var filterInfo = mdxSlicerAxis;
		var withRegion = this.getCalculatedMembers(mdxColumnsAxis, mdxRowsAxis, filterInfo, calculatedMembersCache);
		var where = this.getWhereClause(filterInfo);
		var from = this.getFromClause(filterInfo, cubeName);
		var stringBuilder = new $.ig.StringBuilder();
		if (!String.isNullOrEmpty(withRegion)) {
			stringBuilder.append1(String.concat("WITH", $.ig.Environment.prototype.newLine()));
		}

		stringBuilder.append1(withRegion);
		stringBuilder.append1("SELECT");
		stringBuilder.append1($.ig.Environment.prototype.newLine());
		if (mdxColumnsAxis != null) {
			stringBuilder.append1(mdxColumnsAxis.mdxExpression());
		}

		if (mdxRowsAxis != null) {
			if (mdxColumnsAxis == null) {
				mdxRowsAxis.axisIndex(0);

			} else {
				stringBuilder.append1(String.concat(",", $.ig.Environment.prototype.newLine()));
			}

			stringBuilder.append1(mdxRowsAxis.mdxExpression());
		}

		stringBuilder.append1($.ig.Environment.prototype.newLine());
		stringBuilder.append1(from);
		if (!String.isNullOrEmpty(where)) {
			stringBuilder.append1($.ig.Environment.prototype.newLine());
			stringBuilder.append1(where);
		}

		var query = stringBuilder.toString();
		return query;
	}

	, 
	getCalculatedMembers: function (mdxColumnsAxis, mdxRowsAxis, filterInfo, calculatedMembersCache) {
		return $.ig.MdxCalculatedMembersCache.prototype.getCalculatedMembers(calculatedMembersCache);
	}

	, 
	getFromClause: function (filterInfo, cubeName) {
		var fromClause = String.concat("FROM ", "[", cubeName, "]");
		var extendedFilterInfo = $.ig.util.cast($.ig.IMdxExtendedFilterInfo.prototype.$type, filterInfo);
		fromClause = this.getFilterFromClause(fromClause, filterInfo.filtersFilter());
		if (filterInfo.columnsFilter() != null) {
			fromClause = this.getFilterFromClause(fromClause, filterInfo.columnsFilter(), filterInfo.rowsFilter());

		} else {
			fromClause = this.getFilterFromClause(fromClause, filterInfo.rowsFilter());
		}

		if (extendedFilterInfo != null) {
			fromClause = this.getExtendedFilterInfoFromClause(fromClause, extendedFilterInfo);
		}

		return fromClause;
	}

	, 
	getExtendedFilterInfoFromClause: function (fromClause, extendedFilterInfo) {
		if (extendedFilterInfo.filterElements() != null && extendedFilterInfo.filterElements().count() > 0) {
			var en = extendedFilterInfo.filterElements().getEnumerator();
			while (en.moveNext()) {
				var filterElement = en.current();
				var stringBuilder = new $.ig.StringBuilder();
				stringBuilder.insert1(0, String.concat("FROM", $.ig.Environment.prototype.newLine(), "(", $.ig.Environment.prototype.newLine(), "SELECT", $.ig.Environment.prototype.newLine()));
				stringBuilder.append1(String.concat(filterElement.mdxExpression(), " ON COLUMNS", $.ig.Environment.prototype.newLine()));
				stringBuilder.append1(fromClause);
				stringBuilder.append1(this.getWhereClause(extendedFilterInfo));
				stringBuilder.append1(String.concat(")", $.ig.Environment.prototype.newLine()));
				fromClause = stringBuilder.toString();
			}

		}

		return fromClause;
	}

	, 
	getFilterFromClause: function (fromClause, filterInfo1, filterInfo2) {
		if (filterInfo1 == null || filterInfo1.filterCollection().count() == 0) {
			return fromClause;
		}

		var stringBuilder = new $.ig.StringBuilder();
		stringBuilder.append1("FROM");
		stringBuilder.append1($.ig.Environment.prototype.newLine());
		stringBuilder.append1("(");
		stringBuilder.append1($.ig.Environment.prototype.newLine());
		stringBuilder.append1("SELECT");
		stringBuilder.append1($.ig.Environment.prototype.newLine());
		stringBuilder.append1(filterInfo1.mdxExpression());
		stringBuilder.append1(" ON COLUMNS");
		if (filterInfo2 != null && filterInfo2.filterCollection().count() > 0) {
			stringBuilder.append1($.ig.Environment.prototype.newLine());
			stringBuilder.append1(", ");
			stringBuilder.append1(filterInfo2.mdxExpression());
			stringBuilder.append1(" ON ROWS");
		}

		stringBuilder.append1($.ig.Environment.prototype.newLine());
		stringBuilder.append1(fromClause);
		stringBuilder.append1($.ig.Environment.prototype.newLine());
		stringBuilder.append1(")");
		return stringBuilder.toString();
	}

	, 
	getWhereClause: function (filterInfo) {
		var $self = this;
		var whereClauseCollection = new $.ig.MdxElementCollectionElement();
		if (filterInfo.measureFilter() != null && filterInfo.measureFilter().singleFilterElements().count() == 1) {
			whereClauseCollection.addElement(filterInfo.measureFilter().singleFilterElements().item(0));
		}

		if (filterInfo.filtersFilter() != null) {
			var en = filterInfo.filtersFilter().singleFilterElements().getEnumerator();
			while (en.moveNext()) {
				var singleFilterElement = en.current();
				whereClauseCollection.addElement(singleFilterElement);
			}

		}

		if (whereClauseCollection.collectionElements().count() == 0) {
			return String.empty();
		}

		whereClauseCollection.wrapExpressionWithBrackets((function () { var $ret = new Array();
		$ret.add("(");
		$ret.add(")");return $ret;}()));
		return String.concat("WHERE ", whereClauseCollection.mdxExpression());
	}
	, 
	$type: new $.ig.Type('MdxQueryBuilder', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MdxSet', 'Object', {
	__elementsList: null
	, 
	__elements: null
	, 
	__isExpressionReady: false
	, 
	__expression: null
	, 
	init: function (initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.MdxSet.prototype.init1.call(this, 1, new $.ig.MdxSetSettings());
			this.__elementsList = new $.ig.List$1($.ig.IMdxElement.prototype.$type, 0);
			this.__elements = new $.ig.ReadOnlyCollection$1($.ig.IMdxElement.prototype.$type, 1, this.__elementsList);
			this.isEnabled(true);
	}
	, 
	init1: function (initNumber, mdxSettings) {



		$.ig.Object.prototype.init.call(this);
			this.__elementsList = new $.ig.List$1($.ig.IMdxElement.prototype.$type, 0);
			this.__elements = new $.ig.ReadOnlyCollection$1($.ig.IMdxElement.prototype.$type, 1, this.__elementsList);
			this.isEnabled(true);
			this.mdxSettings(mdxSettings != null ? mdxSettings : new $.ig.MdxSetSettings());
	}

	, 
	_mdxSettings: null,
	mdxSettings: function (value) {
		if (arguments.length === 1) {
			this._mdxSettings = value;
			return value;
		} else {
			return this._mdxSettings;
		}
	}

	, 
	_isEnabled: false,
	isEnabled: function (value) {
		if (arguments.length === 1) {
			this._isEnabled = value;
			return value;
		} else {
			return this._isEnabled;
		}
	}

	, 
	elements: function () {

			return this.__elements;
	}

	, 
	mdxExpression: function () {

			if (!this.__isExpressionReady) {
				this.__expression = this.getMdxExpression();
				this.__isExpressionReady = true;
			}

			return this.__expression;
	}

	, 
	rebuildExpression: function () {
		this.__expression = this.getMdxExpression();
		this.__isExpressionReady = true;
	}

	, 
	addElement: function (mdxElement) {
		if (this.supportsElementType(mdxElement)) {
			this.__elementsList.add(mdxElement);
			this.__isExpressionReady = false;
		}

	}

	, 
	getMdxElements: function () {
		var $self = this;
		var $iter = function () { return function () { return {
			$state: 0,
			$this: $self,
			$current: null,
			$e : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$e = this.$this.__elementsList.getEnumerator();
								this.$state = 1;
								break;
							case 1:
								this.$state = 4;
								break;
														case 2:
									this.$current = this.$e.current();
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								if (this.$e.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 5;
								}
								break;
							case 5:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } () };
		return new $.ig.GenericEnumerable$1($.ig.IMdxElement.prototype.$type, $iter);
	}

	, 
	supportsElementType: function (mdxElement) {
		switch (mdxElement.elementType()) {
			case $.ig.MdxElementType.prototype.memberTree:
			case $.ig.MdxElementType.prototype.member:
			case $.ig.MdxElementType.prototype.calculated:
			case $.ig.MdxElementType.prototype.collection:
				return true;
		}

		return false;
	}

	, 
	getMdxExpression: function () {
		$.ig.Debug.prototype.assert1(this.elements().count() > 0, "MdxSet.Elements collection is empty.");
		var stringBuilder = new $.ig.StringBuilder();
		var topElement = this.elements().item(0);
		this.addElementExpression(stringBuilder, topElement);
		for (var i = 1; i < this.elements().count(); i++) {
			stringBuilder.insert1(0, "CrossJoin(");
			stringBuilder.insert1(10, $.ig.Environment.prototype.newLine());
			stringBuilder.append1(",");
			stringBuilder.append1($.ig.Environment.prototype.newLine());
			var mdxElement = this.elements().item(i);
			this.addElementExpression(stringBuilder, mdxElement);
			stringBuilder.append1(")");
		}

		return stringBuilder.toString();
	}

	, 
	addElementExpression: function (stringBuilder, mdxElement) {
		var partBuilder = new $.ig.StringBuilder();
		switch (mdxElement.elementType()) {
			case $.ig.MdxElementType.prototype.calculated:
				var mdxCalculatedElement = mdxElement;
				var memberUniqueName = mdxCalculatedElement.elementUniqueName();
				partBuilder.append1("{");
				partBuilder.append1(memberUniqueName);
				partBuilder.append1("}");
				break;
			case $.ig.MdxElementType.prototype.member:
				partBuilder.append1("{");
				partBuilder.append1(mdxElement.mdxExpression());
				partBuilder.append1("}");
				break;
			case $.ig.MdxElementType.prototype.collection:
			case $.ig.MdxElementType.prototype.memberTree:
				partBuilder.append1(mdxElement.mdxExpression());
				break;
		}

		if ($.ig.util.cast($.ig.MdxLevelMembersElement.prototype.$type, mdxElement) !== null || $.ig.util.cast($.ig.MdxChildrenCollectionElement.prototype.$type, mdxElement) !== null) {
			this.addCalculatedMembers(partBuilder, mdxElement);
		}

		switch (mdxElement.elementType()) {
			case $.ig.MdxElementType.prototype.memberTree:
			case $.ig.MdxElementType.prototype.member:
				this.addVisualTotals(partBuilder, mdxElement);
				break;
		}

		stringBuilder.append2(partBuilder);
	}

	, 
	addVisualTotals: function (stringBuilder, mdxElement) {
	}

	, 
	addCalculatedMembers: function (stringBuilder, mdxElement) {
		if (this.mdxSettings().addCalculatedMembers()) {
			stringBuilder.insert1(0, "AddCalculatedMembers(");
			stringBuilder.append1(")");
		}

	}

	, 
	clone: function () {
		var set = new $.ig.MdxSet(1, this.mdxSettings());
		var en = this.elements().getEnumerator();
		while (en.moveNext()) {
			var mdxElement = en.current();
			set.addElement(mdxElement);
		}

		return set;
	}
	, 
	$type: new $.ig.Type('MdxSet', $.ig.Object.prototype.$type, [$.ig.IMdxSet.prototype.$type])
}, true);

$.ig.util.defType('MdxSettings', 'Object', {
	__addVisualTotalsOnRows: false
	, 
	__addVisualTotalsOnColumns: false
	, 
	__addCalculatedMembersOnRows: false
	, 
	__addCalculatedMembersOnColumns: false
	, 
	__hierarchizeRows: false
	, 
	__hierarchizeColumns: false
	, 
	__distinctOnRows: false
	, 
	__distinctOnColumns: false
	, 
	__nonEmptyOnRows: false
	, 
	__nonEmptyOnColumns: false
	, 
	__addDimensionPropertiesOnRows: false
	, 
	__addDimensionPropertiesOnColumns: false
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.columnsAxisSettings(new $.ig.MdxDimensionAxisSettings());
			this.rowsAxisSettings(new $.ig.MdxDimensionAxisSettings());
			this.slicerAxisSettings(new $.ig.MdxSlicerAxisSettings());
			this.nonEmptyOnRows(true);
			this.nonEmptyOnColumns(true);
			var dimensionRowProperties = new $.ig.ObservableCollection$1(String, 0);
			dimensionRowProperties.collectionChanged = $.ig.Delegate.prototype.combine(dimensionRowProperties.collectionChanged, this.dimensionRowPropertiesCollectionChanged.runOn(this));
			this.dimensionPropertiesOnRows(dimensionRowProperties);
			var dimensionColumnProperties = new $.ig.ObservableCollection$1(String, 0);
			dimensionColumnProperties.collectionChanged = $.ig.Delegate.prototype.combine(dimensionColumnProperties.collectionChanged, this.dimensionColumnPropertiesCollectionChanged.runOn(this));
			this.dimensionPropertiesOnColumns(dimensionColumnProperties);
			this.addDimensionPropertiesOnRows(true);
			this.addDimensionPropertiesOnColumns(true);
			this.addCalculatedMembersOnRows(true);
			this.addCalculatedMembersOnColumns(true);
			this.resetToDefaultDimensionPropertiesImpl(this.dimensionPropertiesOnRows());
			this.resetToDefaultDimensionPropertiesImpl(this.dimensionPropertiesOnColumns());
	}

	, 
	dimensionRowPropertiesCollectionChanged: function (sender, e) {
		this.rowsAxisSettings().dimensionProperties().clear();
		var en = this.dimensionPropertiesOnRows().getEnumerator();
		while (en.moveNext()) {
			var rowDimProperty = en.current();
			this.rowsAxisSettings().dimensionProperties().add(rowDimProperty);
		}

	}

	, 
	dimensionColumnPropertiesCollectionChanged: function (sender, e) {
		this.columnsAxisSettings().dimensionProperties().clear();
		var en = this.dimensionPropertiesOnColumns().getEnumerator();
		while (en.moveNext()) {
			var columnDimProperty = en.current();
			this.columnsAxisSettings().dimensionProperties().add(columnDimProperty);
		}

	}

	, 
	_columnsAxisSettings: null,
	columnsAxisSettings: function (value) {
		if (arguments.length === 1) {
			this._columnsAxisSettings = value;
			return value;
		} else {
			return this._columnsAxisSettings;
		}
	}

	, 
	_rowsAxisSettings: null,
	rowsAxisSettings: function (value) {
		if (arguments.length === 1) {
			this._rowsAxisSettings = value;
			return value;
		} else {
			return this._rowsAxisSettings;
		}
	}

	, 
	_slicerAxisSettings: null,
	slicerAxisSettings: function (value) {
		if (arguments.length === 1) {
			this._slicerAxisSettings = value;
			return value;
		} else {
			return this._slicerAxisSettings;
		}
	}

	, 
	visualTotalsOnRows: function (value) {
		if (arguments.length === 1) {

			if (this.__addVisualTotalsOnRows != value) {
				this.__addVisualTotalsOnRows = value;
				this.rowsAxisSettings().visualTotals(value);
			}

			return value;
		} else {

			return this.__addVisualTotalsOnRows;
		}
	}

	, 
	visualTotalsOnColumns: function (value) {
		if (arguments.length === 1) {

			if (this.__addVisualTotalsOnColumns != value) {
				this.__addVisualTotalsOnColumns = value;
				this.columnsAxisSettings().visualTotals(value);
			}

			return value;
		} else {

			return this.__addVisualTotalsOnColumns;
		}
	}

	, 
	addCalculatedMembersOnRows: function (value) {
		if (arguments.length === 1) {

			if (this.__addCalculatedMembersOnRows != value) {
				this.__addCalculatedMembersOnRows = value;
				this.rowsAxisSettings().addCalculatedMembers(value);
			}

			return value;
		} else {

			return this.__addCalculatedMembersOnRows;
		}
	}

	, 
	addCalculatedMembersOnColumns: function (value) {
		if (arguments.length === 1) {

			if (this.__addCalculatedMembersOnColumns != value) {
				this.__addCalculatedMembersOnColumns = value;
				this.columnsAxisSettings().addCalculatedMembers(value);
			}

			return value;
		} else {

			return this.__addCalculatedMembersOnColumns;
		}
	}

	, 
	hierarchizeRows: function (value) {
		if (arguments.length === 1) {

			if (this.__hierarchizeRows != value) {
				this.__hierarchizeRows = value;
				this.rowsAxisSettings().hierarchize(value);
			}

			return value;
		} else {

			return this.__hierarchizeRows;
		}
	}

	, 
	hierarchizeColumns: function (value) {
		if (arguments.length === 1) {

			if (this.__hierarchizeColumns != value) {
				this.__hierarchizeColumns = value;
				this.columnsAxisSettings().hierarchize(value);
			}

			return value;
		} else {

			return this.__hierarchizeColumns;
		}
	}

	, 
	distinctOnRows: function (value) {
		if (arguments.length === 1) {

			if (this.__distinctOnRows != value) {
				this.__distinctOnRows = value;
				this.rowsAxisSettings().distinct(value);
			}

			return value;
		} else {

			return this.__distinctOnRows;
		}
	}

	, 
	distinctOnColumns: function (value) {
		if (arguments.length === 1) {

			if (this.__distinctOnColumns != value) {
				this.__distinctOnColumns = value;
				this.columnsAxisSettings().distinct(value);
			}

			return value;
		} else {

			return this.__distinctOnColumns;
		}
	}

	, 
	nonEmptyOnRows: function (value) {
		if (arguments.length === 1) {

			if (this.__nonEmptyOnRows != value) {
				this.__nonEmptyOnRows = value;
				this.rowsAxisSettings().nonEmpty(value);
			}

			return value;
		} else {

			return this.__nonEmptyOnRows;
		}
	}

	, 
	nonEmptyOnColumns: function (value) {
		if (arguments.length === 1) {

			if (this.__nonEmptyOnColumns != value) {
				this.__nonEmptyOnColumns = value;
				this.columnsAxisSettings().nonEmpty(value);
			}

			return value;
		} else {

			return this.__nonEmptyOnColumns;
		}
	}

	, 
	addDimensionPropertiesOnRows: function (value) {
		if (arguments.length === 1) {

			if (this.__addDimensionPropertiesOnRows != value) {
				this.__addDimensionPropertiesOnRows = value;
				this.rowsAxisSettings().addDimensionProperties(value);
			}

			return value;
		} else {

			return this.__addDimensionPropertiesOnRows;
		}
	}

	, 
	addDimensionPropertiesOnColumns: function (value) {
		if (arguments.length === 1) {

			if (this.__addDimensionPropertiesOnColumns != value) {
				this.__addDimensionPropertiesOnColumns = value;
				this.columnsAxisSettings().addDimensionProperties(value);
			}

			return value;
		} else {

			return this.__addDimensionPropertiesOnColumns;
		}
	}

	, 
	_dimensionPropertiesOnRows: null,
	dimensionPropertiesOnRows: function (value) {
		if (arguments.length === 1) {
			this._dimensionPropertiesOnRows = value;
			return value;
		} else {
			return this._dimensionPropertiesOnRows;
		}
	}

	, 
	_dimensionPropertiesOnColumns: null,
	dimensionPropertiesOnColumns: function (value) {
		if (arguments.length === 1) {
			this._dimensionPropertiesOnColumns = value;
			return value;
		} else {
			return this._dimensionPropertiesOnColumns;
		}
	}

	, 
	resetToDefaultDimensionProperties: function (dimensionProperties) {
		this.resetToDefaultDimensionPropertiesImpl(dimensionProperties);
	}

	, 
	resetToDefaultDimensionPropertiesImpl: function (dimensionProperties) {
		dimensionProperties.clear();
		dimensionProperties.add("CHILDREN_CARDINALITY");
		dimensionProperties.add("PARENT_UNIQUE_NAME");
	}
	, 
	$type: new $.ig.Type('MdxSettings', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MdxAxisSettings', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MdxAxisSettings', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MdxSlicerAxisSettings', 'MdxAxisSettings', {
	init: function () {

		$.ig.MdxAxisSettings.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MdxSlicerAxisSettings', $.ig.MdxAxisSettings.prototype.$type)
}, true);

$.ig.util.defType('MdxDimensionAxisSettings', 'MdxAxisSettings', {
	__addVisualTotals: false
	, 
	__addCalculatedMembers: false
	, 
	init: function () {



		$.ig.MdxAxisSettings.prototype.init.call(this);
			this.dimensionProperties(new $.ig.List$1(String, 0));
			this.mdxSetSettings(new $.ig.MdxSetSettings());
	}

	, 
	_mdxSetSettings: null,
	mdxSetSettings: function (value) {
		if (arguments.length === 1) {
			this._mdxSetSettings = value;
			return value;
		} else {
			return this._mdxSetSettings;
		}
	}

	, 
	_hierarchize: false,
	hierarchize: function (value) {
		if (arguments.length === 1) {
			this._hierarchize = value;
			return value;
		} else {
			return this._hierarchize;
		}
	}

	, 
	_distinct: false,
	distinct: function (value) {
		if (arguments.length === 1) {
			this._distinct = value;
			return value;
		} else {
			return this._distinct;
		}
	}

	, 
	_nonEmpty: false,
	nonEmpty: function (value) {
		if (arguments.length === 1) {
			this._nonEmpty = value;
			return value;
		} else {
			return this._nonEmpty;
		}
	}

	, 
	_addDimensionProperties: false,
	addDimensionProperties: function (value) {
		if (arguments.length === 1) {
			this._addDimensionProperties = value;
			return value;
		} else {
			return this._addDimensionProperties;
		}
	}

	, 
	visualTotals: function (value) {
		if (arguments.length === 1) {

			if (this.__addVisualTotals != value) {
				this.__addVisualTotals = value;
				this.mdxSetSettings().visualTotals(value);
			}

			return value;
		} else {

			return this.__addVisualTotals;
		}
	}

	, 
	addCalculatedMembers: function (value) {
		if (arguments.length === 1) {

			if (this.__addCalculatedMembers != value) {
				this.__addCalculatedMembers = value;
				this.mdxSetSettings().addCalculatedMembers(value);
			}

			return value;
		} else {

			return this.__addCalculatedMembers;
		}
	}

	, 
	_dimensionProperties: null,
	dimensionProperties: function (value) {
		if (arguments.length === 1) {
			this._dimensionProperties = value;
			return value;
		} else {
			return this._dimensionProperties;
		}
	}
	, 
	$type: new $.ig.Type('MdxDimensionAxisSettings', $.ig.MdxAxisSettings.prototype.$type)
}, true);

$.ig.util.defType('MdxSetSettings', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_visualTotals: false,
	visualTotals: function (value) {
		if (arguments.length === 1) {
			this._visualTotals = value;
			return value;
		} else {
			return this._visualTotals;
		}
	}

	, 
	_addCalculatedMembers: false,
	addCalculatedMembers: function (value) {
		if (arguments.length === 1) {
			this._addCalculatedMembers = value;
			return value;
		} else {
			return this._addCalculatedMembers;
		}
	}
	, 
	$type: new $.ig.Type('MdxSetSettings', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IMdxSlicerAxis', 'Object', {
	$type: new $.ig.Type('IMdxSlicerAxis', null, [$.ig.IMdxExtendedFilterInfo.prototype.$type])
}, true);

$.ig.util.defType('MdxSlicerAxis', 'MdxAxis', {
	init: function (settings) {



		$.ig.MdxAxis.prototype.init1.call(this, 1, 2, settings);
	}

	, 
	_columnsFilter: null,
	columnsFilter: function (value) {
		if (arguments.length === 1) {
			this._columnsFilter = value;
			return value;
		} else {
			return this._columnsFilter;
		}
	}

	, 
	_rowsFilter: null,
	rowsFilter: function (value) {
		if (arguments.length === 1) {
			this._rowsFilter = value;
			return value;
		} else {
			return this._rowsFilter;
		}
	}

	, 
	_filtersFilter: null,
	filtersFilter: function (value) {
		if (arguments.length === 1) {
			this._filtersFilter = value;
			return value;
		} else {
			return this._filtersFilter;
		}
	}

	, 
	_measureFilter: null,
	measureFilter: function (value) {
		if (arguments.length === 1) {
			this._measureFilter = value;
			return value;
		} else {
			return this._measureFilter;
		}
	}

	, 
	_filterElements: null,
	filterElements: function (value) {
		if (arguments.length === 1) {
			this._filterElements = value;
			return value;
		} else {
			return this._filterElements;
		}
	}
	, 
	$type: new $.ig.Type('MdxSlicerAxis', $.ig.MdxAxis.prototype.$type, [$.ig.IMdxSlicerAxis.prototype.$type])
}, true);

$.ig.util.defType('MdxSlicerSet', 'MdxSet', {
	init: function () {

		$.ig.MdxSet.prototype.init.call(this);

	}
	, 
	supportsElementType: function (mdxElement) {
		return $.ig.util.cast($.ig.IAxisFilterElement.prototype.$type, mdxElement) !== null;
	}
	, 
	$type: new $.ig.Type('MdxSlicerSet', $.ig.MdxSet.prototype.$type)
}, true);

$.ig.util.defType('MdxDimensionAxisProvider', 'Object', {
	__hierarchyLevelsCollection: null
	, 
	__measureNames: null
	, 
	__measureListIndex: 0
	, 
	init: function (initNumber, xmlaDataSource, mdxSettings, sourceAxis, rootPositionInfo) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		this.__hierarchyLevelsCollection = new $.ig.Dictionary$2(String, $.ig.MdxElementCollectionElement.prototype.$type, 0);
		this.__measureNames = new $.ig.List$1(String, 0);
		this.__measureListIndex = -1;

		$.ig.Object.prototype.init.call(this);
			if (xmlaDataSource == null) {
				throw new $.ig.ArgumentNullException("xmlaDataSource");
			}

			this.xmlaDataSource(xmlaDataSource);
			this.mdxSettings(mdxSettings);
			this.sourceAxis(sourceAxis);
			this.rootPositionInfo(rootPositionInfo);
	}
	, 
	init1: function (initNumber, curentResultAxis, mdxSettings, positionsToExtend) {


		this.__hierarchyLevelsCollection = new $.ig.Dictionary$2(String, $.ig.MdxElementCollectionElement.prototype.$type, 0);
		this.__measureNames = new $.ig.List$1(String, 0);
		this.__measureListIndex = -1;

		$.ig.Object.prototype.init.call(this);
			this.mdxSettings(mdxSettings);
			this.currentResultAxis(curentResultAxis);
			this.positionsToExtend(positionsToExtend);
	}

	, 
	_axis: null,
	axis: function (value) {
		if (arguments.length === 1) {
			this._axis = value;
			return value;
		} else {
			return this._axis;
		}
	}
	, 
	__rootPositionInfo: null

	, 
	rootPositionInfo: function (value) {
		if (arguments.length === 1) {

			this.__rootPositionInfo = value;
			return value;
		} else {

			return this.__rootPositionInfo;
		}
	}

	, 
	_mdxSettings: null,
	mdxSettings: function (value) {
		if (arguments.length === 1) {
			this._mdxSettings = value;
			return value;
		} else {
			return this._mdxSettings;
		}
	}

	, 
	_xmlaDataSource: null,
	xmlaDataSource: function (value) {
		if (arguments.length === 1) {
			this._xmlaDataSource = value;
			return value;
		} else {
			return this._xmlaDataSource;
		}
	}

	, 
	_sourceAxis: null,
	sourceAxis: function (value) {
		if (arguments.length === 1) {
			this._sourceAxis = value;
			return value;
		} else {
			return this._sourceAxis;
		}
	}

	, 
	_positionsToExtend: null,
	positionsToExtend: function (value) {
		if (arguments.length === 1) {
			this._positionsToExtend = value;
			return value;
		} else {
			return this._positionsToExtend;
		}
	}

	, 
	_currentResultAxis: null,
	currentResultAxis: function (value) {
		if (arguments.length === 1) {
			this._currentResultAxis = value;
			return value;
		} else {
			return this._currentResultAxis;
		}
	}

	, 
	clearAxis: function () {
		this.axis(null);
	}

	, 
	extendAxis: function (axisToExtend, axisIndex) {
		var $self = this;
		var axis = axisToExtend;
		var positionsToExtend = $self.positionsToExtend();
		var positionResolver = $self.currentResultAxis().positionResolver();
		var partialAxis = new $.ig.MdxAxis(1, axisToExtend.axisIndex(), $self.mdxSettings());
		var en = positionsToExtend.getEnumerator();
		while (en.moveNext()) {
			var positionItemToExpand = en.current();
			var mdxSet = new $.ig.MdxSet(1, (axis.mdxSettings()).mdxSetSettings());
			var sets = new $.ig.List$1($.ig.IMdxSet.prototype.$type, 0);
			var hostPositionInfo = positionResolver.getHostPositionItemInfo(positionItemToExpand.position(), positionItemToExpand.position().indexOf(positionItemToExpand));
			var en1 = positionItemToExpand.position().getItems().getEnumerator();
			while (en1.moveNext()) {
				var positionItem = en1.current();
				var mdxElement;
				if (positionItem == positionItemToExpand) {
					mdxElement = new $.ig.MdxChildrenCollectionElement(positionItem.key(), positionItem.key(), -1, null, null);
					mdxSet.addElement(mdxElement);
					break;
				}

				mdxElement = new $.ig.MdxSingleElement(0, positionItem.key(), positionItem.key(), positionItem.depth());
				mdxSet.addElement(mdxElement);
			}

			var positionItemInfo = hostPositionInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.key() == positionItemToExpand.key(); }).firstOrDefault$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
			if (positionItemInfo != null) {
				if (positionItemInfo.count() == 0) {
					sets.add(mdxSet);

				} else {
					$self.addRootPositionsToSet(positionItemInfo, mdxSet, sets, false, true, false);
				}

				var en2 = sets.getEnumerator();
				while (en2.moveNext()) {
					var set = en2.current();
					axisToExtend.addSet(set);
					partialAxis.addSet(set);
				}

			}

		}

		return partialAxis;
	}

	, 
	generateSets: function (hostPositionItemInfo, sets) {
		if (this.__measureListIndex != 0) {
			var mainRootSet = new $.ig.MdxSet(1, this.mdxSettings().mdxSetSettings());
			if (this.__measureListIndex == -1) {
				sets.add(mainRootSet);
			}

			this.generateMainRootSet(hostPositionItemInfo, mainRootSet, sets);
			this.addRootPositionsToSet(hostPositionItemInfo, new $.ig.MdxSet(1, this.mdxSettings().mdxSetSettings()), sets, true, false, true);

		} else {
			this.addRootPositionsToSet(hostPositionItemInfo, new $.ig.MdxSet(1, this.mdxSettings().mdxSetSettings()), sets, false, false, true);
		}

	}

	, 
	generateMainRootSet: function (hostPositionItemInfo, set, sets) {
		var $self = this;
		var rootItems = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == hostPositionItemInfo.positionItemDepthMin(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (rootItems.count() == 0) {
			return;
		}

		if ($self.__measureListIndex == hostPositionItemInfo.positionItemIndex() + 1) {
			var en = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == 0; }).getEnumerator();
			while (en.moveNext()) {
				var positionItemInfo = en.current();
				var setClone = set.clone();
				var measureElement = new $.ig.MdxSingleElement(0, positionItemInfo.positionItem().key(), positionItemInfo.positionItem().key(), 0);
				setClone.addElement(measureElement);
				sets.add(setClone);
				$self.validateHostedItems(positionItemInfo);
				if (positionItemInfo.count() == 0) {
					$self.addElementsToSet($self.sourceAxis(), positionItemInfo.positionItemIndex() + 1, setClone);

				} else {
					$self.generateMainRootSet(positionItemInfo, setClone, sets);
				}

			}


		} else {
			var rootSample = rootItems.item(0);
			var levelMembersElement = new $.ig.MdxLevelMembersElement(rootSample.hierarchyLevelKey(), rootSample.hierarchyLevelKey(), hostPositionItemInfo.positionItemDepthMin());
			set.addElement(levelMembersElement);
			$self.validateHostedItems(rootSample);
			if (rootSample.count() == 0) {
				if ($self.__measureListIndex != -1) {
					sets.add(set);
				}

				$self.addElementsToSet($self.sourceAxis(), rootSample.positionItemIndex() + 1, set);

			} else {
				$self.generateMainRootSet(rootSample, set, sets);
			}

		}

	}

	, 
	createAxis: function (axisIndex) {
		if (this.axis() != null) {
			return this.axis();
		}

		if (this.rootPositionInfo() == null) {
			this.axis(this.createAxis1(axisIndex, this.sourceAxis()));
			return this.axis();
		}

		this.createValidationEntries(axisIndex);
		this.validateHostedItems(this.rootPositionInfo());
		if (this.rootPositionInfo().count() == 0) {
			this.axis(this.createAxis1(axisIndex, this.sourceAxis()));
			return this.axis();
		}

		var sets = new $.ig.List$1($.ig.IMdxSet.prototype.$type, 0);
		this.generateSets(this.rootPositionInfo(), sets);
		var axis = new $.ig.MdxAxis(1, axisIndex, this.mdxSettings());
		var en = sets.getEnumerator();
		while (en.moveNext()) {
			var mdxSet = en.current();
			axis.addSet(mdxSet);
		}

		this.axis(axis);
		return axis;
	}

	, 
	createValidationEntries: function (axisIndex) {
		var hasColumns = this.xmlaDataSource().columnAxis().count() > 0;
		var hasRows = this.xmlaDataSource().rowAxis().count() > 0;
		var checkRoot = this.xmlaDataSource().measures().count() > 1;
		if (checkRoot) {
			if (axisIndex == 0) {
				if (hasColumns) {
					if (this.xmlaDataSource().measureListLocation() == $.ig.MeasureListLocation.prototype.columns) {
						this.__measureListIndex = this.xmlaDataSource().measureListIndex();
					}


				} else if (hasRows && this.xmlaDataSource().measureListLocation() == $.ig.MeasureListLocation.prototype.rows) {
					this.__measureListIndex = this.xmlaDataSource().measureListIndex();
				}



			} else if (axisIndex == 1 && hasRows && this.xmlaDataSource().measureListLocation() == $.ig.MeasureListLocation.prototype.rows) {
				this.__measureListIndex = this.xmlaDataSource().measureListIndex();
			}


		}

		var en = this.xmlaDataSource().measures().getEnumerator();
		while (en.moveNext()) {
			var measure = en.current();
			this.__measureNames.add(measure.uniqueName());
		}

	}

	, 
	validateHostedItems: function (positionItemInfo) {
		if (this.sourceAxis() != null) {
			var itemIndex = positionItemInfo.positionItemIndex() + 1;
			if (itemIndex < this.sourceAxis().count()) {
				var axisCoreElement = this.sourceAxis().item(itemIndex);
				var measureList = $.ig.util.cast($.ig.MeasureList.prototype.$type, axisCoreElement);
				if (measureList != null) {
					var rootItemsInfo = positionItemInfo.values().toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
					var en = rootItemsInfo.getEnumerator();
					while (en.moveNext()) {
						var itemInfo = en.current();
						if (!this.__measureNames.contains(itemInfo.key())) {
							positionItemInfo.remove(itemInfo.key());
						}

					}

				}

				var hierarchy = $.ig.util.cast($.ig.Hierarchy.prototype.$type, axisCoreElement);
				if (hierarchy != null) {
					var hostedItemInfo = positionItemInfo.values().firstOrDefault$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
					if (hostedItemInfo != null) {
						if (hostedItemInfo.hierarchyKey() != hierarchy.uniqueName()) {
							positionItemInfo.clear();
						}

					}

				}


			} else {
				positionItemInfo.clear();
			}

		}

	}

	, 
	createAxis1: function (axisIndex, dataSourceAxis) {
		var mdxSet = new $.ig.MdxSet(1, this.mdxSettings().mdxSetSettings());
		this.addElementsToSet(dataSourceAxis, 0, mdxSet);
		var axis = new $.ig.MdxAxis(1, axisIndex, this.mdxSettings());
		axis.addSet(mdxSet);
		return axis;
	}

	, 
	addElementsToSet: function (dataSourceAxis, startIndex, mdxSet) {
		var $self = this;
		if (dataSourceAxis == null) {
			return;
		}

		for (var i = startIndex; i < dataSourceAxis.count(); i++) {
			var coreOlapElement = dataSourceAxis.item(i);
			var hierarchy = $.ig.util.cast($.ig.Hierarchy.prototype.$type, coreOlapElement);
			if (hierarchy != null) {
				if (hierarchy.allMember() == null) {
					var levels = $self.xmlaDataSource().getCoreElements(function (e) { return (e).hierarchyUniqueName() == hierarchy.uniqueName(); }, $.ig.Level.prototype.$type).toList$1($.ig.ICoreOlapElement.prototype.$type);
					var rootLevel = levels.item(0);
					mdxSet.addElement(new $.ig.MdxLevelMembersElement(rootLevel.uniqueName(), rootLevel.uniqueName(), 0));

				} else {
					mdxSet.addElement(new $.ig.MdxSingleElement(0, hierarchy.defaultMember(), hierarchy.defaultMember(), 0));
				}

				continue;
			}

			var level = $.ig.util.cast($.ig.Level.prototype.$type, coreOlapElement);
			if (level != null) {
				var levelsCollection;
				if (!(function () { var $ret = $self.__hierarchyLevelsCollection.tryGetValue(level.hierarchyUniqueName(), levelsCollection); levelsCollection = $ret.value; return $ret.ret; }())) {
					levelsCollection = new $.ig.MdxElementCollectionElement();
					mdxSet.addElement(levelsCollection);
					$self.__hierarchyLevelsCollection.add(level.hierarchyUniqueName(), levelsCollection);
				}

				levelsCollection.addElement(new $.ig.MdxLevelMembersElement(level.uniqueName(), level.uniqueName(), level.depth()));
				continue;
			}

			var measureList = $.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement);
			if (measureList != null) {
				var collectionElement = new $.ig.MdxElementCollectionElement();
				var en = measureList.measures().getEnumerator();
				while (en.moveNext()) {
					var measure = en.current();
					collectionElement.addElement(new $.ig.MdxSingleElement(0, measure.uniqueName(), measure.uniqueName(), 0));
				}

				mdxSet.addElement(collectionElement);
			}

		}

	}

	, 
	addPositionToSet: function (hostPositionItemInfo, positionItemInfo, set, sets, addSetIfHasChildren, hasChildren, addChildren) {
		var setCopy = (set).clone();
		setCopy.addElement(new $.ig.MdxSingleElement(0, positionItemInfo.key(), positionItemInfo.key(), positionItemInfo.positionItemDepth()));
		this.validateHostedItems(positionItemInfo);
		if (positionItemInfo.count() == 0) {
			if (addSetIfHasChildren) {
				if (hasChildren) {
					sets.add(setCopy);
					this.addElementsToSet(this.sourceAxis(), positionItemInfo.positionItemIndex() + 1, setCopy);
				}


			} else {
				sets.add(setCopy);
				this.addElementsToSet(this.sourceAxis(), positionItemInfo.positionItemIndex() + 1, setCopy);
			}


		} else {
			this.addRootPositionsToSet(positionItemInfo, setCopy, sets, addSetIfHasChildren, hasChildren, addChildren);
		}

		if (addChildren && positionItemInfo.isExpanded()) {
			this.addChildrenPositionsToSet(positionItemInfo, sets, hostPositionItemInfo, set);
		}

	}

	, 
	addChildrenPositionsToSet: function (positionItemInfo, sets, hostPositionItemInfo, setPrototype) {
		var $self = this;
		var childrenPositionsInfo = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.parentKey() == positionItemInfo.key(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (childrenPositionsInfo.count() > 0) {
			var set2 = (setPrototype).clone();
			set2.addElement(new $.ig.MdxChildrenCollectionElement(positionItemInfo.key(), positionItemInfo.key(), positionItemInfo.positionItemDepth(), null, null));
			$self.validateHostedItems(positionItemInfo);
			if (positionItemInfo.count() == 0) {
				sets.add(set2);
				$self.addElementsToSet($self.sourceAxis(), positionItemInfo.positionItemIndex() + 1, set2);

			} else {
				$self.addRootPositionsToSet(positionItemInfo, set2, sets, true, true, false);
			}

		}

		var en = childrenPositionsInfo.getEnumerator();
		while (en.moveNext()) {
			var childPositionItemInfo = en.current();
			var set3 = (setPrototype).clone();
			set3.addElement(new $.ig.MdxSingleElement(0, childPositionItemInfo.key(), childPositionItemInfo.key(), childPositionItemInfo.positionItemDepth()));
			$self.validateHostedItems(childPositionItemInfo);
			if (childPositionItemInfo.isExpanded()) {
				$self.addChildrenPositionsToSet(childPositionItemInfo, sets, hostPositionItemInfo, setPrototype);
			}

			$self.addRootPositionsToSet(childPositionItemInfo, set3, sets, true, false, true);
		}

	}

	, 
	addRootPositionsToSet: function (hostPositionItemInfo, set, sets, addSetIfHasChildren, hasChildren, addChildren) {
		var $self = this;
		var rootItems = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == hostPositionItemInfo.positionItemDepthMin(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (rootItems.count() == 0) {
			return;
		}

		var en = rootItems.getEnumerator();
		while (en.moveNext()) {
			var positionItemInfo = en.current();
			$self.addPositionToSet(hostPositionItemInfo, positionItemInfo, set, sets, addSetIfHasChildren, hasChildren, addChildren);
		}

	}
	, 
	$type: new $.ig.Type('MdxDimensionAxisProvider', $.ig.Object.prototype.$type, [$.ig.IMdxDimensionAxisProvider.prototype.$type])
}, true);

$.ig.util.defType('MdxSlicerAxisProvider', 'Object', {
	__columnFilters: null
	, 
	__rowFilters: null
	, 
	__filterFilters: null
	, 
	init: function (dataSource, columnsFilters, rowsFilters, filterFilters, mdxSettings) {


		this.__columnFilters = new $.ig.List$1($.ig.AxisElement.prototype.$type, 0);
		this.__rowFilters = new $.ig.List$1($.ig.AxisElement.prototype.$type, 0);
		this.__filterFilters = new $.ig.List$1($.ig.AxisElement.prototype.$type, 0);

		$.ig.Object.prototype.init.call(this);
			this.dataSource(dataSource);
			this.mdxSettings(mdxSettings);
			this.__columnFilters = columnsFilters;
			this.__rowFilters = rowsFilters;
			this.__filterFilters = filterFilters;
	}

	, 
	_dataSource: null,
	dataSource: function (value) {
		if (arguments.length === 1) {
			this._dataSource = value;
			return value;
		} else {
			return this._dataSource;
		}
	}

	, 
	_mdxSettings: null,
	mdxSettings: function (value) {
		if (arguments.length === 1) {
			this._mdxSettings = value;
			return value;
		} else {
			return this._mdxSettings;
		}
	}

	, 
	createAxis: function (axisIndex) {
		var mdxSlicerAxis = new $.ig.MdxSlicerAxis(this.mdxSettings().slicerAxisSettings());
		mdxSlicerAxis.axisIndex(axisIndex);
		mdxSlicerAxis.columnsFilter($.ig.MdxSlicerAxisBuilder.prototype.createFilterElement(this.__columnFilters, mdxSlicerAxis));
		mdxSlicerAxis.rowsFilter($.ig.MdxSlicerAxisBuilder.prototype.createFilterElement(this.__rowFilters, mdxSlicerAxis));
		mdxSlicerAxis.filtersFilter($.ig.MdxSlicerAxisBuilder.prototype.createFilterElement(this.__filterFilters, mdxSlicerAxis));
		mdxSlicerAxis.measureFilter($.ig.MdxSlicerAxisBuilder.prototype.createMeasureFilterElement(this.dataSource().measures(), mdxSlicerAxis));
		return mdxSlicerAxis;
	}
	, 
	$type: new $.ig.Type('MdxSlicerAxisProvider', $.ig.Object.prototype.$type, [$.ig.IMdxAxisProvider.prototype.$type])
}, true);

$.ig.util.defType('MdxSlicerAxisBuilder', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	createMeasureFilterElement: function (measures, slicerAxis) {
		if (measures.count$1($.ig.Measure.prototype.$type) == 0) {
			return null;
		}

		var measureAxisFilter = new $.ig.MdxAxisFilterElement();
		var measuresFilterCollection = new $.ig.MdxElementCollectionElement();
		var en = measures.getEnumerator();
		while (en.moveNext()) {
			var measure = en.current();
			var measureMdxElement = new $.ig.MdxSingleElement(0, measure.uniqueName(), measure.uniqueName(), 0);
			measuresFilterCollection.addElement(measureMdxElement);
		}

		var measureSet = new $.ig.MdxSlicerSet();
		measureSet.addElement(measureAxisFilter);
		slicerAxis.addSet(measureSet);
		measureAxisFilter.addFilterPart(measuresFilterCollection, true);
		return measureAxisFilter;
	}

	, 
	createFilterElement: function (axisElements, slicerAxis) {
		var $self = this;
		var axisFilterElement = new $.ig.MdxAxisFilterElement();
		for (var i = 0; i < axisElements.count(); i++) {
			var axisElement = axisElements.item(i);
			var filterElementCollection = new $.ig.MdxElementCollectionElement();
			var mdxDimensionMembers = new $.ig.Dictionary$2(String, $.ig.MdxSingleElement.prototype.$type, 0);
			var en = axisElement.memberNames().getEnumerator();
			while (en.moveNext()) {
				var filterMemberName = en.current();
				var mdxFilterElement;
				if (!(function () { var $ret = mdxDimensionMembers.tryGetValue(filterMemberName, mdxFilterElement); mdxFilterElement = $ret.value; return $ret.ret; }())) {
					mdxFilterElement = new $.ig.MdxSingleElement(0, filterMemberName, filterMemberName, -1);
					mdxDimensionMembers.add(filterMemberName, mdxFilterElement);
				}

				filterElementCollection.addElement(mdxFilterElement);
			}

			axisFilterElement.addFilterPart(filterElementCollection, false);
		}

		if (axisFilterElement.filterCollection().count() == 0 && axisFilterElement.singleFilterElements().count() == 0) {
			return null;
		}

		var slicerSet = new $.ig.MdxSlicerSet();
		slicerSet.addElement(axisFilterElement);
		slicerAxis.addSet(slicerSet);
		return axisFilterElement;
	}
	, 
	$type: new $.ig.Type('MdxSlicerAxisBuilder', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IXmlaDataProviderFactory', 'Object', {
	$type: new $.ig.Type('IXmlaDataProviderFactory', null, [$.ig.IOlapDataProviderFactory.prototype.$type])
}, true);

$.ig.util.defType('DefaultXmlaDataProviderFactory', 'Object', {
	__serverUrl: null
	, 
	__credentials: null
	, 
	init: function (serverUrl, credentials) {



		$.ig.Object.prototype.init.call(this);
			this.__serverUrl = serverUrl;
			this.__credentials = credentials;
	}

	, 
	createDataProvider: function () {
		return new $.ig.XmlaDataProvider(new $.ig.XmlaConnection(new $.ig.Uri(this.__serverUrl), this.__credentials), null);
	}
	, 
	$type: new $.ig.Type('DefaultXmlaDataProviderFactory', $.ig.Object.prototype.$type, [$.ig.IXmlaDataProviderFactory.prototype.$type])
}, true);

$.ig.util.defType('RemoteXmlaDataProviderFactory', 'Object', {
	__requestSerializer: null
	, 
	__responseSerializer: null
	, 
	__serverUrl: null
	, 
	__credentials: null
	, 
	init: function (initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.Object.prototype.init.call(this);
			this.__requestSerializer = new $.ig.JsonRemoteRequestSerializer();
			this.__responseSerializer = new $.ig.JsonRemoteResponseSerializer();
	}
	, 
	init1: function (initNumber, serverUrl, credentials) {



		$.ig.Object.prototype.init.call(this);
			this.__requestSerializer = new $.ig.JsonRemoteRequestSerializer();
			this.__responseSerializer = new $.ig.JsonRemoteResponseSerializer();
			this.__serverUrl = serverUrl;
			this.__credentials = credentials;
	}
	, 
	init2: function (initNumber, requestSerializer, responseSerializer) {



		$.ig.Object.prototype.init.call(this);
			this.__requestSerializer = requestSerializer;
			this.__responseSerializer = responseSerializer;
	}

	, 
	createDataProvider: function () {
		return new $.ig.RemoteXmlaDataProvder(this.__serverUrl, this.__credentials, this.__requestSerializer, this.__responseSerializer);
	}
	, 
	$type: new $.ig.Type('RemoteXmlaDataProviderFactory', $.ig.Object.prototype.$type, [$.ig.IXmlaDataProviderFactory.prototype.$type])
}, true);

$.ig.util.defType('IRemoteRequestSerializer', 'Object', {
	$type: new $.ig.Type('IRemoteRequestSerializer', null)
}, true);

$.ig.util.defType('IRemoteResponseSerializer', 'Object', {
	$type: new $.ig.Type('IRemoteResponseSerializer', null)
}, true);

$.ig.util.defType('JsonRemoteRequestSerializer', 'Object', {
	__serializer: null
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__serializer = new $.ig.JavaScriptSerializer();
	}

	, 
	serializeRequest: function (request) {
		return $.ig.RemoteRequestJsonTypeSeriazlier.prototype.instance().serialize(request, this.__serializer);
	}

	, 
	deserializeRequest: function (request) {
		return $.ig.RemoteRequestJsonTypeSeriazlier.prototype.instance().deserialize(request, this.__serializer);
	}
	, 
	$type: new $.ig.Type('JsonRemoteRequestSerializer', $.ig.Object.prototype.$type, [$.ig.IRemoteRequestSerializer.prototype.$type])
}, true);

$.ig.util.defType('JsonRemoteResponseSerializer', 'Object', {
	__serializer: null
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__serializer = new $.ig.JavaScriptSerializer();
	}

	, 
	serializeResponse: function (response, type) {
		switch (type) {
			case $.ig.RemoteRequestType.prototype.discoverCatalogs:
				return $.ig.ArrayJsonSerializer.prototype.instance().serialize$1($.ig.Catalog.prototype.$type, response, $.ig.CatalogJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverCubes:
				return $.ig.ArrayJsonSerializer.prototype.instance().serialize$1($.ig.Cube.prototype.$type, response, $.ig.CubeJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverDimensions:
				return $.ig.ArrayJsonSerializer.prototype.instance().serialize$1($.ig.Dimension.prototype.$type, response, $.ig.DimensionJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverHierarchies:
				return $.ig.ArrayJsonSerializer.prototype.instance().serialize$1($.ig.Hierarchy.prototype.$type, response, $.ig.HierarchyJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverLevels:
				return $.ig.ArrayJsonSerializer.prototype.instance().serialize$1($.ig.Level.prototype.$type, response, $.ig.LevelJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverMeasures:
				return $.ig.ArrayJsonSerializer.prototype.instance().serialize$1($.ig.Measure.prototype.$type, response, $.ig.MeasureJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverMeasureGroups:
				return $.ig.ArrayJsonSerializer.prototype.instance().serialize$1($.ig.MeasureGroup.prototype.$type, response, $.ig.MeasureGroupJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverMeasureGroupDimensions:
				return $.ig.ArrayJsonSerializer.prototype.instance().serialize$1($.ig.MeasureGroupDimension.prototype.$type, response, $.ig.MeasureGroupDimensionJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverMembers:
				return $.ig.ArrayJsonSerializer.prototype.instance().serialize$1($.ig.Member.prototype.$type, response, $.ig.MemberJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverKpis:
				return $.ig.ArrayJsonSerializer.prototype.instance().serialize$1($.ig.Kpi.prototype.$type, response, $.ig.KpiJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.executeStatement:
				return $.ig.ResultJsonTypeSeriazlier.prototype.instance().serialize(response, this.__serializer);
			default:
				throw new $.ig.Error(1, "Unknown RemoteXmlaRequestType.");
		}

	}

	, 
	deserializeResponse: function (response, type) {
		switch (type) {
			case $.ig.RemoteRequestType.prototype.discoverCatalogs:
				return $.ig.ArrayJsonSerializer.prototype.instance().deserialize$1($.ig.Catalog.prototype.$type, response, $.ig.CatalogJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverCubes:
				return $.ig.ArrayJsonSerializer.prototype.instance().deserialize$1($.ig.Cube.prototype.$type, response, $.ig.CubeJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverDimensions:
				return $.ig.ArrayJsonSerializer.prototype.instance().deserialize$1($.ig.Dimension.prototype.$type, response, $.ig.DimensionJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverHierarchies:
				return $.ig.ArrayJsonSerializer.prototype.instance().deserialize$1($.ig.Hierarchy.prototype.$type, response, $.ig.HierarchyJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverLevels:
				return $.ig.ArrayJsonSerializer.prototype.instance().deserialize$1($.ig.Level.prototype.$type, response, $.ig.LevelJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverMeasures:
				return $.ig.ArrayJsonSerializer.prototype.instance().deserialize$1($.ig.Measure.prototype.$type, response, $.ig.MeasureJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverMeasureGroups:
				return $.ig.ArrayJsonSerializer.prototype.instance().deserialize$1($.ig.MeasureGroup.prototype.$type, response, $.ig.MeasureGroupJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverMeasureGroupDimensions:
				return $.ig.ArrayJsonSerializer.prototype.instance().deserialize$1($.ig.MeasureGroupDimension.prototype.$type, response, $.ig.MeasureGroupDimensionJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverMembers:
				return $.ig.ArrayJsonSerializer.prototype.instance().deserialize$1($.ig.Member.prototype.$type, response, $.ig.MemberJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.discoverKpis:
				return $.ig.ArrayJsonSerializer.prototype.instance().deserialize$1($.ig.Kpi.prototype.$type, response, $.ig.KpiJsonTypeSeriazlier.prototype.instance(), this.__serializer);
			case $.ig.RemoteRequestType.prototype.executeStatement:
				return $.ig.ResultJsonTypeSeriazlier.prototype.instance().deserialize(response, this.__serializer);
			default:
				throw new $.ig.Error(1, "Unknown RemoteXmlaRequestType.");
		}

	}
	, 
	$type: new $.ig.Type('JsonRemoteResponseSerializer', $.ig.Object.prototype.$type, [$.ig.IRemoteResponseSerializer.prototype.$type])
}, true);

$.ig.util.defType('ArrayJsonSerializer', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
	}

	, 
	instance: function () {

			return $.ig.ArrayJsonSerializer.prototype._instance;
	}

	, 
	deserialize$1: function ($t, s, jsonSerializer, serializer) {
		var arr = serializer.deserializeObject(s);
		return this.fromJsonArray$1($t, arr, jsonSerializer);
	}

	, 
	serialize$1: function ($t, items, jsonSerializer, serializer) {
		var resArr = this.toJsonArray$1($t, items, jsonSerializer);
		return serializer.serialize(resArr);
	}

	, 
	fromJsonArray$1: function ($t, arr, jsonSerializer) {
		var result = new $.ig.List$1($t, 0);
		for (var i = 0; i < arr.length; i++) {
			var o = arr[i];
			result.add(jsonSerializer.fromJsonObject(o));
		}

		return result;
	}

	, 
	toJsonArray$1: function ($t, list, jsonSerializer) {
		var arr = list.toArray$1($t);
		var resArr = new Array(arr.length);
		for (var i = 0; i < arr.length; i++) {
			resArr[i] = jsonSerializer.toJsonObject(arr[i]);
		}

		return resArr;
	}
	, 
	$type: new $.ig.Type('ArrayJsonSerializer', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IJsonTypeSerializer$1', 'Object', {
	$type: new $.ig.Type('IJsonTypeSerializer$1', null)
}, true);

$.ig.util.defType('JsonTypeSeriazlierBase$1', 'Object', {
	$t: null, 
	init: function ($t) {
		this.$t = $t;
		this.$type = this.$type.specialize(this.$t);

		$.ig.Object.prototype.init.call(this);

	}
	, 
	deserialize: function (s, serializer) {
		return this.fromJsonObject(serializer.deserializeObject(s));
	}

	, 
	serialize: function (o, serializer) {
		return serializer.serialize(this.toJsonObject(o));
	}

	, 
	fromJsonObject: function (o) {
	}

	, 
	toJsonObject: function (o) {
	}
	, 
	$type: new $.ig.Type('JsonTypeSeriazlierBase$1', $.ig.Object.prototype.$type, [$.ig.IJsonTypeSerializer$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('AxisJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.OlapResultAxis.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.AxisJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		var name = $.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "n");
		var tuples = $.ig.ArrayJsonSerializer.prototype.instance().fromJsonArray$1($.ig.OlapResultTuple.prototype.$type, $.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "t"), $.ig.TupleJsonTypeSeriazlier.prototype.instance());
		var tupleSize = 0;
		if (tuples.count() > 0) {
			tupleSize = tuples.item(0).members().count();
		}

		return (function () { var $ret = new $.ig.OlapResultAxis(tuples, tupleSize);
		$ret.name(name); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var tuples = $.ig.ArrayJsonSerializer.prototype.instance().toJsonArray$1($.ig.OlapResultTuple.prototype.$type, o.tuples(), $.ig.TupleJsonTypeSeriazlier.prototype.instance());
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "n", o.name());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "t", tuples);
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('AxisJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.OlapResultAxis.prototype.$type))
}, true);

$.ig.util.defType('AxisMemberJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.OlapResultAxisMember.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.AxisMemberJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		return (function () { var $ret = new $.ig.OlapResultAxisMember();
		$ret.hierarchyUniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "hun"));
		$ret.uniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "un"));
		$ret.levelUniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "lun"));
		$ret.caption($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "c"));
		$ret.levelNumber($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "ln"));
		$ret.displayInfo($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "di"));
		$ret.properties($.ig.JsonSerializerUtils.prototype.getStringDictionaryProperty(o, "p")); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "hun", o.hierarchyUniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "un", o.uniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "lun", o.levelUniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "c", o.caption());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "ln", o.levelNumber());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "di", o.displayInfo());
		$.ig.JsonSerializerUtils.prototype.setStringDictionaryProperty(jsonObj, "p", o.properties());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('AxisMemberJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.OlapResultAxisMember.prototype.$type))
}, true);

$.ig.util.defType('CatalogJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.Catalog.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.CatalogJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		return (function () { var $ret = new $.ig.Catalog();
		$ret.caption($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "c"));
		$ret.description($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "d"));
		$ret.name($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "n"));
		$ret.uniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "un")); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "c", o.caption());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "d", o.description());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "n", o.name());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "un", o.uniqueName());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('CatalogJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.Catalog.prototype.$type))
}, true);

$.ig.util.defType('CellJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.OlapResultCell.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.CellJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		return (function () { var $ret = new $.ig.OlapResultCell();
		$ret.cellOrdinal($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "co"));
		$ret.properties($.ig.JsonSerializerUtils.prototype.getObjectDictionaryProperty(o, "p")); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "co", o.cellOrdinal());
		$.ig.JsonSerializerUtils.prototype.setObjectDictionaryProperty(jsonObj, "p", o.properties());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('CellJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.OlapResultCell.prototype.$type))
}, true);

$.ig.util.defType('CubeJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.Cube.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.CubeJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		return (function () { var $ret = new $.ig.Cube();
		$ret.caption($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "c"));
		$ret.description($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "d"));
		$ret.name($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "n"));
		$ret.catalogName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "cn"));
		$ret.cubeType($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "ct"));
		$ret.lastProcessed($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "lp"));
		$ret.lastUpdated($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "lu")); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "c", o.caption());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "d", o.description());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "n", o.name());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "cn", o.catalogName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "ct", o.cubeType());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "lp", o.lastProcessed());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "lu", o.lastUpdated());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('CubeJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.Cube.prototype.$type))
}, true);

$.ig.util.defType('DimensionJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.Dimension.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.DimensionJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		return (function () { var $ret = new $.ig.Dimension();
		$ret.caption($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "c"));
		$ret.description($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "d"));
		$ret.name($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "n"));
		$ret.uniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "un"));
		$ret.dimensionType($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "dt")); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "c", o.caption());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "d", o.description());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "n", o.name());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "un", o.uniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "dt", o.dimensionType());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('DimensionJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.Dimension.prototype.$type))
}, true);

$.ig.util.defType('HierarchyJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.Hierarchy.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.HierarchyJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		return (function () { var $ret = new $.ig.Hierarchy();
		$ret.caption($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "c"));
		$ret.description($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "d"));
		$ret.name($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "n"));
		$ret.uniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "un"));
		$ret.allMember($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "am"));
		$ret.defaultMember($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "dm"));
		$ret.dimensionUniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "dun"));
		$ret.hierarchyDisplayFolder($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "hdf"));
		$ret.hierarchyOrigin($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "ho")); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "c", o.caption());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "d", o.description());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "n", o.name());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "un", o.uniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "am", o.allMember());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "dm", o.defaultMember());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "dun", o.dimensionUniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "hdf", o.hierarchyDisplayFolder());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "ho", o.hierarchyOrigin());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('HierarchyJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.Hierarchy.prototype.$type))
}, true);

$.ig.util.defType('JsonSerializerUtils', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	createObject: function () {
		return $.ig.jQueryUtils.prototype.createJavascriptObject();
	}

	, 
	getObjectProperty: function (o, property) {
		return $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, property);
	}

	, 
	setObjectProperty: function (o, property, value) {
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(o, property, value);
	}

	, 
	getObjectDictionaryProperty: function (o, property) {
		return $.ig.jQueryUtils.prototype.convertToObjectDictionary($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, property));
	}

	, 
	setObjectDictionaryProperty: function (o, property, value) {
		var obj = $.ig.jQueryUtils.prototype.convertFromObjectDictionary(value);
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(o, property, obj);
	}

	, 
	getStringDictionaryProperty: function (o, property) {
		return $.ig.jQueryUtils.prototype.convertToStringDictionary($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, property));
	}

	, 
	setStringDictionaryProperty: function (o, property, value) {
		var obj = $.ig.jQueryUtils.prototype.convertFromStringDictionary(value);
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(o, property, obj);
	}
	, 
	$type: new $.ig.Type('JsonSerializerUtils', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('KpiJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.Kpi.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.KpiJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		return (function () { var $ret = new $.ig.Kpi();
		$ret.caption($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "c"));
		$ret.description($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "d"));
		$ret.name($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "n"));
		$ret.uniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "un"));
		$ret.kpiDisplayFolder($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "kdf"));
		$ret.measureGroupName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "mgn"));
		$ret.kpiStatusGraphic($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "ksg"));
		$ret.kpiTrendGraphic($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "ktg"));
		$ret.parentKpiName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "pkn"));
		$ret.kpiGoal($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "kg"));
		$ret.kpiStatus($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "ks"));
		$ret.kpiTrend($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "kt"));
		$ret.kpiValue($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "kv"));
		$ret.kpiWeight($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "kw")); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "c", o.caption());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "d", o.description());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "n", o.name());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "un", o.uniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "kdf", o.kpiDisplayFolder());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "mgn", o.measureGroupName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "ksg", o.kpiStatusGraphic());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "ktg", o.kpiTrendGraphic());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "pkn", o.parentKpiName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "kg", o.kpiGoal());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "ks", o.kpiStatus());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "kt", o.kpiTrend());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "kv", o.kpiValue());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "kw", o.kpiWeight());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('KpiJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.Kpi.prototype.$type))
}, true);

$.ig.util.defType('LevelJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.Level.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.LevelJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		return (function () { var $ret = new $.ig.Level();
		$ret.caption($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "c"));
		$ret.description($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "d"));
		$ret.name($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "n"));
		$ret.uniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "un"));
		$ret.depth($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "d"));
		$ret.dimensionUniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "dun"));
		$ret.hierarchyUniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "hun"));
		$ret.levelOrderingProperty($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "lop"));
		$ret.levelOrigin($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "lo"));
		$ret.membersCount($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "mc")); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "c", o.caption());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "d", o.description());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "n", o.name());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "un", o.uniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "d", o.depth());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "dun", o.dimensionUniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "hun", o.hierarchyUniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "lop", o.levelOrderingProperty());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "lo", o.levelOrigin());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "mc", o.membersCount());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('LevelJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.Level.prototype.$type))
}, true);

$.ig.util.defType('MeasureGroupDimensionJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.MeasureGroupDimension.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.MeasureGroupDimensionJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		return (function () { var $ret = new $.ig.MeasureGroupDimension();
		$ret.catalogName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "cn"));
		$ret.cubeName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "cbn"));
		$ret.dimensionCardinality($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "dc"));
		$ret.dimensionGranularity($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "dg"));
		$ret.dimensionPath($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "dap"));
		$ret.dimensionUniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "dun"));
		$ret.isDimensionVisible($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "idv"));
		$ret.isFactDimension($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "iafd"));
		$ret.measureGroupCardinality($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "mgc"));
		$ret.measureGroupName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "mgn")); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "cn", o.catalogName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "cbn", o.cubeName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "dc", o.dimensionCardinality());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "dg", o.dimensionGranularity());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "dap", o.dimensionPath());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "dun", o.dimensionUniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "idv", o.isDimensionVisible());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "iafd", o.isFactDimension());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "mgc", o.measureGroupCardinality());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "mgn", o.measureGroupName());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('MeasureGroupDimensionJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.MeasureGroupDimension.prototype.$type))
}, true);

$.ig.util.defType('MeasureGroupJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.MeasureGroup.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.MeasureGroupJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		return (function () { var $ret = new $.ig.MeasureGroup();
		$ret.caption($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "c"));
		$ret.description($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "d"));
		$ret.name($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "n"));
		$ret.catalogName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "cn"));
		$ret.cubeName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "cbn")); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "c", o.caption());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "d", o.description());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "n", o.name());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "cn", o.catalogName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "cbn", o.cubeName());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('MeasureGroupJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.MeasureGroup.prototype.$type))
}, true);

$.ig.util.defType('MeasureJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.Measure.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.MeasureJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		return (function () { var $ret = new $.ig.Measure();
		$ret.caption($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "c"));
		$ret.description($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "d"));
		$ret.name($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "n"));
		$ret.uniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "un"));
		$ret.aggregatorType($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "at"));
		$ret.defaultFormatString($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "dfs"));
		$ret.measureDisplayFolder($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "mdf"));
		$ret.measureGroupName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "mgn")); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "c", o.caption());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "d", o.description());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "n", o.name());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "un", o.uniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "at", o.aggregatorType());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "dfs", o.defaultFormatString());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "mdf", o.measureDisplayFolder());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "mgn", o.measureGroupName());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('MeasureJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.Measure.prototype.$type))
}, true);

$.ig.util.defType('MemberJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.Member.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.MemberJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		var nullValue = $.ig.util.toNullable($.ig.Number.prototype.$type, null);
		var scope = $.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "s");
		return (function () { var $ret = new $.ig.Member();
		$ret.caption($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "c"));
		$ret.description($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "d"));
		$ret.name($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "n"));
		$ret.uniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "un"));
		$ret.catalogName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "cn"));
		$ret.childrenCardinality($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "cc"));
		$ret.cubeName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "cbn"));
		$ret.dimensionUniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "dun"));
		$ret.hierarchyUniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "hun"));
		$ret.levelDepth($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "ld"));
		$ret.levelUniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "lun"));
		$ret.memberType($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "mt"));
		$ret.parentLevel($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "pl"));
		$ret.parentUniqueName($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "pun"));
		$ret.scope(scope == null ? nullValue : $.ig.Number.prototype.parseInt(scope)); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "c", o.caption());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "d", o.description());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "n", o.name());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "un", o.uniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "cn", o.catalogName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "cc", o.childrenCardinality());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "cbn", o.cubeName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "dun", o.dimensionUniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "hun", o.hierarchyUniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "ld", o.levelDepth());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "lun", o.levelUniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "mt", o.memberType());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "pl", o.parentLevel());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "pun", o.parentUniqueName());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "s", o.scope());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('MemberJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.Member.prototype.$type))
}, true);

$.ig.util.defType('RemoteRequest', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_type: null,
	type: function (value) {
		if (arguments.length === 1) {
			this._type = value;
			return value;
		} else {
			return this._type;
		}
	}

	, 
	_properties: null,
	properties: function (value) {
		if (arguments.length === 1) {
			this._properties = value;
			return value;
		} else {
			return this._properties;
		}
	}

	, 
	_restrictions: null,
	restrictions: function (value) {
		if (arguments.length === 1) {
			this._restrictions = value;
			return value;
		} else {
			return this._restrictions;
		}
	}

	, 
	_parameters: null,
	parameters: function (value) {
		if (arguments.length === 1) {
			this._parameters = value;
			return value;
		} else {
			return this._parameters;
		}
	}

	, 
	_statement: null,
	statement: function (value) {
		if (arguments.length === 1) {
			this._statement = value;
			return value;
		} else {
			return this._statement;
		}
	}
	, 
	$type: new $.ig.Type('RemoteRequest', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('RemoteRequestJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.RemoteRequest.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.RemoteRequestJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		return (function () { var $ret = new $.ig.RemoteRequest();
		$ret.type($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "t"));
		$ret.properties($.ig.JsonSerializerUtils.prototype.getStringDictionaryProperty(o, "p"));
		$ret.restrictions($.ig.JsonSerializerUtils.prototype.getStringDictionaryProperty(o, "r"));
		$ret.parameters($.ig.JsonSerializerUtils.prototype.getStringDictionaryProperty(o, "par"));
		$ret.statement($.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "s")); return $ret;}());
	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "t", o.type());
		$.ig.JsonSerializerUtils.prototype.setStringDictionaryProperty(jsonObj, "p", o.properties());
		$.ig.JsonSerializerUtils.prototype.setStringDictionaryProperty(jsonObj, "r", o.restrictions());
		$.ig.JsonSerializerUtils.prototype.setStringDictionaryProperty(jsonObj, "par", o.parameters());
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "s", o.statement());
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('RemoteRequestJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.RemoteRequest.prototype.$type))
}, true);

$.ig.util.defType('ResultJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.OlapResult.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.ResultJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var $self = this;
		var isEmpty = $.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "ie");
		if (isEmpty) {
			return (function () { var $ret = new $.ig.OlapResult();
			$ret.isEmpty(true); return $ret;}());

		} else {
			var axes = $.ig.ArrayJsonSerializer.prototype.instance().fromJsonArray$1($.ig.OlapResultAxis.prototype.$type, $.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "a"), $.ig.AxisJsonTypeSeriazlier.prototype.instance());
			var cells = $.ig.ArrayJsonSerializer.prototype.instance().fromJsonArray$1($.ig.OlapResultCell.prototype.$type, $.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "c"), $.ig.CellJsonTypeSeriazlier.prototype.instance());
			return (function () { var $ret = new $.ig.OlapResult();
			$ret.axes(axes);
			$ret.cells(cells); return $ret;}());
		}

	}

	, 
	toJsonObject: function (o) {
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "ie", o.isEmpty());
		if (!o.isEmpty()) {
			var axes = $.ig.ArrayJsonSerializer.prototype.instance().toJsonArray$1($.ig.OlapResultAxis.prototype.$type, o.axes(), $.ig.AxisJsonTypeSeriazlier.prototype.instance());
			var cells = $.ig.ArrayJsonSerializer.prototype.instance().toJsonArray$1($.ig.OlapResultCell.prototype.$type, o.cells(), $.ig.CellJsonTypeSeriazlier.prototype.instance());
			$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "a", axes);
			$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "c", cells);
		}

		return jsonObj;
	}
	, 
	$type: new $.ig.Type('ResultJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.OlapResult.prototype.$type))
}, true);

$.ig.util.defType('TupleJsonTypeSeriazlier', 'JsonTypeSeriazlierBase$1', {
	init: function () {



		$.ig.JsonTypeSeriazlierBase$1.prototype.init.call(this, $.ig.OlapResultTuple.prototype.$type);
	}

	, 
	instance: function () {

			return $.ig.TupleJsonTypeSeriazlier.prototype._instance;
	}

	, 
	fromJsonObject: function (o) {
		var members = $.ig.ArrayJsonSerializer.prototype.instance().fromJsonArray$1($.ig.OlapResultAxisMember.prototype.$type, $.ig.JsonSerializerUtils.prototype.getObjectProperty(o, "m"), $.ig.AxisMemberJsonTypeSeriazlier.prototype.instance());
		var tuple = new $.ig.OlapResultTuple(members);
		var en = members.getEnumerator();
		while (en.moveNext()) {
			var axisMember = en.current();
			axisMember.position(tuple);
		}

		return tuple;
	}

	, 
	toJsonObject: function (o) {
		var members = $.ig.ArrayJsonSerializer.prototype.instance().toJsonArray$1($.ig.OlapResultAxisMember.prototype.$type, o.members(), $.ig.AxisMemberJsonTypeSeriazlier.prototype.instance());
		var jsonObj = $.ig.JsonSerializerUtils.prototype.createObject();
		$.ig.JsonSerializerUtils.prototype.setObjectProperty(jsonObj, "m", members);
		return jsonObj;
	}
	, 
	$type: new $.ig.Type('TupleJsonTypeSeriazlier', $.ig.JsonTypeSeriazlierBase$1.prototype.$type.specialize($.ig.OlapResultTuple.prototype.$type))
}, true);

$.ig.util.defType('RemoteXmlaDataProvder', 'Object', {
	__serverUrl: null
	, 
	__credentials: null
	, 
	__requestSerializer: null
	, 
	__responseSerializer: null
	, 
	init: function (serverUrl, credentials, requestSerializer, responseSerializer) {



		$.ig.Object.prototype.init.call(this);
			this.__serverUrl = serverUrl;
			this.__credentials = credentials;
			this.__requestSerializer = requestSerializer;
			this.__responseSerializer = responseSerializer;
	}

	, 
	discoverCatalogsAsync: function (properties, restrictions) {
		var $self = this;
		var responseSerializer = $self.__responseSerializer;
		return $self.sendRequest($.ig.RemoteRequestType.prototype.discoverCatalogs, properties, restrictions, null, null).continueWith$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Catalog.prototype.$type), function (t) {
			return responseSerializer.deserializeResponse(t.result(), $.ig.RemoteRequestType.prototype.discoverCatalogs);
		});
	}

	, 
	discoverCubesAsync: function (properties, restrictions) {
		var $self = this;
		var responseSerializer = $self.__responseSerializer;
		return $self.sendRequest($.ig.RemoteRequestType.prototype.discoverCubes, properties, restrictions, null, null).continueWith$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Cube.prototype.$type), function (t) {
			return responseSerializer.deserializeResponse(t.result(), $.ig.RemoteRequestType.prototype.discoverCubes);
		});
	}

	, 
	discoverDimensionsAsync: function (properties, restrictions) {
		var $self = this;
		var responseSerializer = $self.__responseSerializer;
		return $self.sendRequest($.ig.RemoteRequestType.prototype.discoverDimensions, properties, restrictions, null, null).continueWith$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Dimension.prototype.$type), function (t) {
			return responseSerializer.deserializeResponse(t.result(), $.ig.RemoteRequestType.prototype.discoverDimensions);
		});
	}

	, 
	discoverHierarchiesAsync: function (properties, restrictions) {
		var $self = this;
		var responseSerializer = $self.__responseSerializer;
		return $self.sendRequest($.ig.RemoteRequestType.prototype.discoverHierarchies, properties, restrictions, null, null).continueWith$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Hierarchy.prototype.$type), function (t) {
			return responseSerializer.deserializeResponse(t.result(), $.ig.RemoteRequestType.prototype.discoverHierarchies);
		});
	}

	, 
	discoverLevelsAsync: function (properties, restrictions) {
		var $self = this;
		var responseSerializer = $self.__responseSerializer;
		return $self.sendRequest($.ig.RemoteRequestType.prototype.discoverLevels, properties, restrictions, null, null).continueWith$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Level.prototype.$type), function (t) {
			return responseSerializer.deserializeResponse(t.result(), $.ig.RemoteRequestType.prototype.discoverLevels);
		});
	}

	, 
	discoverMeasuresAsync: function (properties, restrictions) {
		var $self = this;
		var responseSerializer = $self.__responseSerializer;
		return $self.sendRequest($.ig.RemoteRequestType.prototype.discoverMeasures, properties, restrictions, null, null).continueWith$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Measure.prototype.$type), function (t) {
			return responseSerializer.deserializeResponse(t.result(), $.ig.RemoteRequestType.prototype.discoverMeasures);
		});
	}

	, 
	discoverMeasureGroupsAsync: function (properties, restrictions) {
		var $self = this;
		var responseSerializer = $self.__responseSerializer;
		return $self.sendRequest($.ig.RemoteRequestType.prototype.discoverMeasureGroups, properties, restrictions, null, null).continueWith$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.MeasureGroup.prototype.$type), function (t) {
			return responseSerializer.deserializeResponse(t.result(), $.ig.RemoteRequestType.prototype.discoverMeasureGroups);
		});
	}

	, 
	discoverMeasureGroupDimensionsAsync: function (properties, restrictions) {
		var $self = this;
		var responseSerializer = $self.__responseSerializer;
		return $self.sendRequest($.ig.RemoteRequestType.prototype.discoverMeasureGroupDimensions, properties, restrictions, null, null).continueWith$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.MeasureGroupDimension.prototype.$type), function (t) {
			return responseSerializer.deserializeResponse(t.result(), $.ig.RemoteRequestType.prototype.discoverMeasureGroupDimensions);
		});
	}

	, 
	discoverMembersAsync: function (properties, restrictions) {
		var $self = this;
		var responseSerializer = $self.__responseSerializer;
		return $self.sendRequest($.ig.RemoteRequestType.prototype.discoverMembers, properties, restrictions, null, null).continueWith$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Member.prototype.$type), function (t) {
			return responseSerializer.deserializeResponse(t.result(), $.ig.RemoteRequestType.prototype.discoverMembers);
		});
	}

	, 
	discoverKpisAsync: function (properties, restrictions) {
		var $self = this;
		var responseSerializer = $self.__responseSerializer;
		return $self.sendRequest($.ig.RemoteRequestType.prototype.discoverKpis, properties, restrictions, null, null).continueWith$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Kpi.prototype.$type), function (t) {
			return responseSerializer.deserializeResponse(t.result(), $.ig.RemoteRequestType.prototype.discoverKpis);
		});
	}

	, 
	executeStatementAsync: function (statement, properties, parameters) {
		var $self = this;
		var responseSerializer = $self.__responseSerializer;
		return $self.sendRequest($.ig.RemoteRequestType.prototype.executeStatement, properties, null, parameters, statement).continueWith$1($.ig.OlapResult.prototype.$type, function (t) {
			return responseSerializer.deserializeResponse(t.result(), $.ig.RemoteRequestType.prototype.executeStatement);
		});
	}

	, 
	sendRequest: function (type, properties, restrictions, parameters, statement) {
		var $self = this;
		var webClient = (function () { var $ret = new $.ig.WebClient();
		$ret.credentials($self.__credentials); return $ret;}());
		var requestData = $self.__requestSerializer.serializeRequest((function () { var $ret = new $.ig.RemoteRequest();
		$ret.type(type);
		$ret.properties($self.dictionaryFromKVPCollection(properties));
		$ret.restrictions($self.dictionaryFromKVPCollection(restrictions));
		$ret.parameters($self.dictionaryFromKVPCollection(parameters));
		$ret.statement(statement); return $ret;}()));
		var tcs = new $.ig.TaskCompletionSource$1(String, 0);
		webClient.uploadStringCompleted = $.ig.Delegate.prototype.combine(webClient.uploadStringCompleted, $self.uploadStringAsyncCompleted.runOn($self));
		webClient.uploadStringAsync(new $.ig.Uri($self.__serverUrl), "POST", requestData, tcs);
		return tcs.task();
	}

	, 
	uploadStringAsyncCompleted: function (sender, e) {
		var tcs = e.userState();
		if (e.cancelled()) {
			tcs.setCanceled();

		} else if (e.error() != null) {
			tcs.setException(e.error());

		} else {
			tcs.setResult(e.result());
		}


	}

	, 
	dictionaryFromKVPCollection: function (collection) {
		if (collection == null) {
		return null;
		}

		var dict = new $.ig.Dictionary$2(String, String, 0);
		var en = collection.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			dict.add(item.key(), item.value());
		}

		return dict;
	}
	, 
	$type: new $.ig.Type('RemoteXmlaDataProvder', $.ig.Object.prototype.$type, [$.ig.IXmlaDataProvider.prototype.$type])
}, true);

$.ig.util.defType('XmlaConnection', 'Object', {
	__serverUri: null
	, 
	__credentials: null
	, 
	init: function (serverUri, credentials) {



		$.ig.Object.prototype.init.call(this);
			this.__serverUri = serverUri;
			this.__credentials = credentials;
	}

	, 
	getXmlaSoapWebClient$1: function ($t) {
		var client = new $.ig.XmlaSoapWebClient$1($t, this.__serverUri, $.ig.Encoding.prototype.uTF8());
		client.credentials(this.__credentials);
		return client;
	}
	, 
	$type: new $.ig.Type('XmlaConnection', $.ig.Object.prototype.$type, [$.ig.ICoreXmlaConnection.prototype.$type])
}, true);

$.ig.util.defType('XmlaDataSourceImpl', 'MdxDataSourceImpl', {
	init: function (options) {



		$.ig.MdxDataSourceImpl.prototype.init.call(this, options);
			this.xmlaSourceOptions(options);
	}

	, 
	_xmlaSourceOptions: null,
	xmlaSourceOptions: function (value) {
		if (arguments.length === 1) {
			this._xmlaSourceOptions = value;
			return value;
		} else {
			return this._xmlaSourceOptions;
		}
	}

	, 
	loadCubes: function (catalogName) {
		var $self = this;
		var provider = $self.dataProviderFactory().createDataProvider();
		var restrictions = $self.getProviderDefaultRestrictions();
		$self.ensureEntryValue(restrictions, $.ig.CubeRestrictions.prototype.catalogName, catalogName);
		var properties = $self.getProviderDefaultProperties();
		$self.ensureEntryValue(properties, $.ig.XmlaDiscoverProperties.prototype.catalog, catalogName);
		var task = provider.discoverCubesAsync(properties, restrictions).continueWith$1($.ig.IList$1.prototype.$type.specialize($.ig.Cube.prototype.$type), function (t) {
			$self.cubes($self.toArrayListCollection$1($.ig.Cube.prototype.$type, t.result()));
			return $self.cubes();
		});
		return task;
	}

	, 
	loadMeasureGroups: function () {
		var $self = this;
		var catalogName = $self.catalog().name();
		var cubeName = $self.cube().name();
		var provider = $self.dataProviderFactory().createDataProvider();
		var restrictions = $self.getProviderDefaultRestrictions();
		$self.ensureEntryValue(restrictions, $.ig.MeasureGroupRestrictions.prototype.catalogName, catalogName);
		$self.ensureEntryValue(restrictions, $.ig.MeasureGroupRestrictions.prototype.cubeName, cubeName);
		var properties = $self.getProviderDefaultProperties();
		$self.ensureEntryValue(properties, $.ig.XmlaDiscoverProperties.prototype.catalog, catalogName);
		var task = provider.discoverMeasureGroupsAsync(properties, restrictions).continueWith$1($.ig.IList$1.prototype.$type.specialize($.ig.MeasureGroup.prototype.$type), function (t) {
			$self.measureGroups($self.toArrayListCollection$1($.ig.MeasureGroup.prototype.$type, t.result()));
			return $self.measureGroups();
		});
		return task;
	}

	, 
	createOlapDataProviderFactory: function () {
		return new $.ig.DefaultXmlaDataProviderFactory(this.xmlaSourceOptions().serverUrl(), this.xmlaSourceOptions().requestOptions());
	}

	, 
	getProviderDefaultProperties: function () {
		var $self = this;
		var properties = new $.ig.List$1($.ig.KeyValueItem.prototype.$type, 0);
		if ($self.mdxSourceOptions().discoverProperties() != null) {
			var en = $self.mdxSourceOptions().discoverProperties().getEnumerator();
			while (en.moveNext()) {
				var kvp = en.current();
				var xmlaQueryProperty = new $.ig.XmlaQueryProperty(1, kvp.key(), kvp.value());
				properties.add((function () { var $ret = new $.ig.KeyValueItem();
				$ret.key(xmlaQueryProperty.propertyName());
				$ret.value(xmlaQueryProperty.value()); return $ret;}()));
			}

		}

		if ($self.catalog() != null) {
			$self.ensureEntryValue(properties, $.ig.XmlaDiscoverProperties.prototype.catalog, $self.catalog().name());
		}

		return properties;
	}
	, 
	$type: new $.ig.Type('XmlaDataSourceImpl', $.ig.MdxDataSourceImpl.prototype.$type)
}, true);

$.ig.util.defType('XmlaDiscoverProperties', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('XmlaDiscoverProperties', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XmlaDataSourceOptions', 'MdxDataSourceOptions', {
	init: function () {

		$.ig.MdxDataSourceOptions.prototype.init.call(this);

	}
	, 
	_serverUrl: null,
	serverUrl: function (value) {
		if (arguments.length === 1) {
			this._serverUrl = value;
			return value;
		} else {
			return this._serverUrl;
		}
	}

	, 
	_requestOptions: null,
	requestOptions: function (value) {
		if (arguments.length === 1) {
			this._requestOptions = value;
			return value;
		} else {
			return this._requestOptions;
		}
	}
	, 
	$type: new $.ig.Type('XmlaDataSourceOptions', $.ig.MdxDataSourceOptions.prototype.$type)
}, true);

$.ig.util.defType('RequestOptions', 'NetworkCredential', {
	init: function (initNumber, userName, password) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.RequestOptions.prototype.init1.call(this, 1, userName, password, String.empty());
	}
	, 
	init1: function (initNumber, userName, password, domain) {



		$.ig.NetworkCredential.prototype.init1.call(this, 1, userName, password, domain);
	}
	, 
	$type: new $.ig.Type('RequestOptions', $.ig.NetworkCredential.prototype.$type)
}, true);


$.ig.util.defType('CustomRemoteXmlaRequestSerializer', 'Object', {
	__serializeRequest: null
	, 
	init: function (serializeRequest) {



		$.ig.Object.prototype.init.call(this);
			this.__serializeRequest = serializeRequest;
	}

	, 
	serializeRequest: function (request) {
		return this.__serializeRequest(request);
	}

	, 
	deserializeRequest: function (request) {
		throw new $.ig.NotSupportedException(1);
	}
	, 
	$type: new $.ig.Type('CustomRemoteXmlaRequestSerializer', $.ig.Object.prototype.$type, [$.ig.IRemoteRequestSerializer.prototype.$type])
}, true);

$.ig.util.defType('CustomRemoteXmlaResponseSerializer', 'Object', {
	__deserializeResponse: null
	, 
	init: function (deserializeResponse) {



		$.ig.Object.prototype.init.call(this);
			this.__deserializeResponse = deserializeResponse;
	}

	, 
	serializeResponse: function (response, type) {
		throw new $.ig.NotSupportedException(1);
	}

	, 
	deserializeResponse: function (response, type) {
		return this.__deserializeResponse(response, type);
	}
	, 
	$type: new $.ig.Type('CustomRemoteXmlaResponseSerializer', $.ig.Object.prototype.$type, [$.ig.IRemoteResponseSerializer.prototype.$type])
}, true);

$.ig.util.defType('OlapXmlaDataSource', 'DataSourceBase', {
	staticInit: function () {



			$.ig.OlapXmlaDataSource.prototype.xmlaDataSourceIE8Fixes();
	}
	, 
	init: function (options) {


		var $self = this;

		$.ig.DataSourceBase.prototype.init.call(this);
			var serverUrl = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "serverUrl");
			var catalog = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "catalog");
			var cube = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "cube");
			var measures = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "measures");
			var measureGroup = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "measureGroup");
			var filters = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "filters");
			var columns = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "columns");
			var rows = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "rows");
			var requestOptionsObject = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "requestOptions");
			var enableResultCacheValue = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "enableResultCache");
			var enableResultCache = true;
			if (enableResultCacheValue != null) {
				enableResultCache = enableResultCacheValue;
			}

			var discoverProperties = $.ig.jQueryUtils.prototype.convertToStringDictionary($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "discoverProperties"));
			var executeProperties = $.ig.jQueryUtils.prototype.convertToStringDictionary($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "executeProperties"));
			var isRemote = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "isRemote");
			if (isRemote) {
				if (requestOptionsObject == null) {
					requestOptionsObject = {};
				}

				var ro_ = requestOptionsObject;
				ro_.isCrossDomain = false;
			}

			var serializeRequest = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "serializeRequest");
			var deserializeResponse = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "deserializeResponse");
			var mdxSettings = this.resolveMdxSettings(options);
			var dataSourceOptions = (function () { var $ret = new $.ig.XmlaDataSourceOptions();
			$ret.serverUrl(serverUrl);
			$ret.requestOptions(requestOptionsObject);
			$ret.catalog(catalog);
			$ret.cube(cube);
			$ret.measures(measures);
			$ret.measureGroup(measureGroup);
			$ret.filters(filters);
			$ret.columns(columns);
			$ret.rows(rows);
			$ret.discoverProperties(discoverProperties);
			$ret.executeProperties(executeProperties);
			$ret.enableResultCache(enableResultCache);
			$ret.mdxSettings(mdxSettings); return $ret;}());
			if (isRemote) {
				var requestSerializer = null;
				var responseSerializer = null;
				if (serializeRequest != null) {
					requestSerializer = new $.ig.CustomRemoteXmlaRequestSerializer(serializeRequest);
				}

				if (deserializeResponse != null) {
					responseSerializer = new $.ig.CustomRemoteXmlaResponseSerializer(deserializeResponse);
				}

				var remoteProviderFactory = new $.ig.RemoteXmlaDataProviderFactory(1, serverUrl, requestOptionsObject);
				dataSourceOptions.dataProviderFactory(remoteProviderFactory);
			}

			this.dataSource(new $.ig.XmlaDataSourceImpl(dataSourceOptions));
	}

	, 
	catalogs: function () {

			return ((this.dataSource()).catalogs()).inner();
	}

	, 
	catalog: function () {

			return (this.dataSource()).catalog();
	}

	, 
	setCatalog: function (catalogName) {
		var $self = this;
		return ($self.dataSource()).setCatalog(catalogName).continueWith$1($.ig.Array.prototype.$type, function (t) {
	return (t.result()).inner();
}).promise();
	}

	, 
	measureGroups: function () {

			return ((this.dataSource()).measureGroups()).inner();
	}

	, 
	measureGroup: function () {

			return (this.dataSource()).measureGroup();
	}

	, 
	setMeasureGroup: function (measureGroupName) {
		var $self = this;
		return ($self.dataSource()).setMeasureGroup(measureGroupName).continueWith$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) {
	return t.result();
}).promise();
	}

	, 
	resolveMdxSettings: function (options) {
		var mdxSettings = new $.ig.MdxSettings();
		var mdxSettingsObject = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "mdxSettings");
		if (mdxSettingsObject == null) {
			return mdxSettings;
		}

		var nonEmptyOnRows = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(mdxSettingsObject, "nonEmptyOnRows");
		if (nonEmptyOnRows != null) {
			mdxSettings.nonEmptyOnRows(nonEmptyOnRows);
		}

		var nonEmptyOnColumns = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(mdxSettingsObject, "nonEmptyOnColumns");
		if (nonEmptyOnColumns != null) {
			mdxSettings.nonEmptyOnColumns(nonEmptyOnColumns);
		}

		var addCalcMembersOnRows = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(mdxSettingsObject, "addCalculatedMembersOnRows");
		if (addCalcMembersOnRows != null) {
			mdxSettings.addCalculatedMembersOnRows(addCalcMembersOnRows);
		}

		var addCalcMembersOnColumns = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(mdxSettingsObject, "addCalculatedMembersOnColumns");
		if (addCalcMembersOnColumns != null) {
			mdxSettings.addCalculatedMembersOnColumns(addCalcMembersOnColumns);
		}

		var dimensionPropertiesOnRows = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(mdxSettingsObject, "dimensionPropertiesOnRows");
		if (dimensionPropertiesOnRows != null) {
			for (var i = 0; i < dimensionPropertiesOnRows.count(); i++) {
				mdxSettings.dimensionPropertiesOnRows().add(dimensionPropertiesOnRows.item(i));
			}

		}

		var dimensionPropertiesOnColumns = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(mdxSettingsObject, "dimensionPropertiesOnColumns");
		if (dimensionPropertiesOnColumns != null) {
			for (var i1 = 0; i1 < dimensionPropertiesOnColumns.count(); i1++) {
				mdxSettings.dimensionPropertiesOnColumns().add(dimensionPropertiesOnColumns.item(i1));
			}

		}

		return mdxSettings;
	}

	, 
	xmlaDataSourceIE8Fixes: function () {
		
            $.ig.StringBuilder.prototype.toString = function () {
                return this._internal.join('');
            }

            $.ig.XObject.prototype.toString = function () {
                if (this.backingNode() != null) {
                    return $.ig.XmlUtils.prototype.xmlNodeToString(this.backingNode());

                } else {
                    return '';
                }
            };
	}
	, 
	$type: new $.ig.Type('OlapXmlaDataSource', $.ig.DataSourceBase.prototype.$type)
}, true);


$.ig.RemoteRequestType.prototype.discoverCatalogs = 0;
$.ig.RemoteRequestType.prototype.discoverCubes = 1;
$.ig.RemoteRequestType.prototype.discoverDimensions = 2;
$.ig.RemoteRequestType.prototype.discoverHierarchies = 3;
$.ig.RemoteRequestType.prototype.discoverLevels = 4;
$.ig.RemoteRequestType.prototype.discoverMeasures = 5;
$.ig.RemoteRequestType.prototype.discoverMeasureGroups = 6;
$.ig.RemoteRequestType.prototype.discoverMeasureGroupDimensions = 7;
$.ig.RemoteRequestType.prototype.discoverMembers = 8;
$.ig.RemoteRequestType.prototype.discoverKpis = 9;
$.ig.RemoteRequestType.prototype.executeStatement = 10;



$.ig.MdxElementType.prototype.member = 0;
$.ig.MdxElementType.prototype.memberTree = 1;
$.ig.MdxElementType.prototype.calculated = 2;
$.ig.MdxElementType.prototype.filter = 3;
$.ig.MdxElementType.prototype.collection = 4;
$.ig.MdxElementType.prototype.userDefined = 5;


$.ig.XmlaSoapMessageHeader.prototype.none = 0;
$.ig.XmlaSoapMessageHeader.prototype.session = 1;
$.ig.XmlaSoapMessageHeader.prototype.beginSession = 2;
$.ig.XmlaSoapMessageHeader.prototype.endSession = 3;


$.ig.CatalogConstants.prototype.catalogName = "CATALOG_NAME";
$.ig.CatalogConstants.prototype.description = "DESCRIPTION";
$.ig.CatalogConstants.prototype.roles = "ROLES";
$.ig.CatalogConstants.prototype.dateModified = "DATE_MODIFIED";


$.ig.DbSchemaConstants.prototype.catalogs = "DBSCHEMA_CATALOGS";
$.ig.DbSchemaConstants.prototype.columns = "DBSCHEMA_COLUMNS";
$.ig.DbSchemaConstants.prototype.tables = "DBSCHEMA_TABLES";
$.ig.DbSchemaConstants.prototype.providerTypes = "DBSCHEMA_PROVIDER_TYPES";



$.ig.CubeConstants.prototype.catalogName = "CATALOG_NAME";
$.ig.CubeConstants.prototype.schemaName = "SCHEMA_NAME";
$.ig.CubeConstants.prototype.cubeName = "CUBE_NAME";
$.ig.CubeConstants.prototype.cubeType = "CUBE_TYPE";
$.ig.CubeConstants.prototype.lastSchemaUpdate = "LAST_SCHEMA_UPDATE";
$.ig.CubeConstants.prototype.lastDataUpdate = "LAST_DATA_UPDATE";
$.ig.CubeConstants.prototype.description = "DESCRIPTION";
$.ig.CubeConstants.prototype.isDrillThroughEnabled = "IS_DRILLTHROUGH_ENABLED";
$.ig.CubeConstants.prototype.isLinkable = "IS_LINKABLE";
$.ig.CubeConstants.prototype.isWriteEnabled = "IS_WRITE_ENABLED";
$.ig.CubeConstants.prototype.isSQLEnabledConstatnt = "IS_SQL_ENABLED";
$.ig.CubeConstants.prototype.cubeCaption = "CUBE_CAPTION";
$.ig.CubeConstants.prototype.baseCubeName = "BASE_CUBE_NAME";
$.ig.CubeConstants.prototype.annotations = "ANNOTATIONS";


$.ig.DimensionConstants.prototype.catalogName = "CATALOG_NAME";
$.ig.DimensionConstants.prototype.schemaName = "SCHEMA_NAME";
$.ig.DimensionConstants.prototype.cubeName = "CUBE_NAME";
$.ig.DimensionConstants.prototype.dimensionName = "DIMENSION_NAME";
$.ig.DimensionConstants.prototype.dimensionUniqueName = "DIMENSION_UNIQUE_NAME";
$.ig.DimensionConstants.prototype.dimensionCaption = "DIMENSION_CAPTION";
$.ig.DimensionConstants.prototype.dimensionOrdinal = "DIMENSION_ORDINAL";
$.ig.DimensionConstants.prototype.dimensionType = "DIMENSION_TYPE";
$.ig.DimensionConstants.prototype.dimensionCardinality = "DIMENSION_CARDINALITY";
$.ig.DimensionConstants.prototype.defaultHierarchy = "DEFAULT_HIERARCHY";
$.ig.DimensionConstants.prototype.description = "DESCRIPTION";
$.ig.DimensionConstants.prototype.isVirtual = "IS_VIRTUAL";
$.ig.DimensionConstants.prototype.isReadWrite = "IS_READWRITE";
$.ig.DimensionConstants.prototype.dimensionUniqueSettings = "DIMENSION_UNIQUE_SETTINGS";
$.ig.DimensionConstants.prototype.dimensionMasterName = "DIMENSION_MASTER_NAME";
$.ig.DimensionConstants.prototype.dimensionIsVisible = "DIMENSION_IS_VISIBLE";


$.ig.HierarchyConstants.prototype.catalogName = "CATALOG_NAME";
$.ig.HierarchyConstants.prototype.cubeName = "CUBE_NAME";
$.ig.HierarchyConstants.prototype.dimensionUniqueName = "DIMENSION_UNIQUE_NAME";
$.ig.HierarchyConstants.prototype.hierarchyName = "HIERARCHY_NAME";
$.ig.HierarchyConstants.prototype.hierarchyUniqueName = "HIERARCHY_UNIQUE_NAME";
$.ig.HierarchyConstants.prototype.hierarchyCaption = "HIERARCHY_CAPTION";
$.ig.HierarchyConstants.prototype.dimensionType = "DIMENSION_TYPE";
$.ig.HierarchyConstants.prototype.hierarchyCardinality = "HIERARCHY_CARDINALITY";
$.ig.HierarchyConstants.prototype.defaultMember = "DEFAULT_MEMBER";
$.ig.HierarchyConstants.prototype.allMember = "ALL_MEMBER";
$.ig.HierarchyConstants.prototype.description = "DESCRIPTION";
$.ig.HierarchyConstants.prototype.isVirtual = "IS_VIRTUAL";
$.ig.HierarchyConstants.prototype.isReadWrite = "IS_READWRITE";
$.ig.HierarchyConstants.prototype.dimensionUniqueSettings = "DIMENSION_UNIQUE_SETTINGS";
$.ig.HierarchyConstants.prototype.dimensionIsVisible = "DIMENSION_IS_VISIBLE";
$.ig.HierarchyConstants.prototype.dimensionMasterUniqueName = "DIMENSION_MASTER_UNIQUE_NAME";
$.ig.HierarchyConstants.prototype.hierarchyOrdinal = "HIERARCHY_ORDINAL";
$.ig.HierarchyConstants.prototype.dimensionIsShared = "DIMENSION_IS_SHARED";
$.ig.HierarchyConstants.prototype.hierarchyIsVisible = "HIERARCHY_IS_VISIBLE";
$.ig.HierarchyConstants.prototype.hierarchyOrigin = "HIERARCHY_ORIGIN";
$.ig.HierarchyConstants.prototype.hierarchyDisplayFolder = "HIERARCHY_DISPLAY_FOLDER";
$.ig.HierarchyConstants.prototype.instanceSelection = "INSTANCE_SELECTION";
$.ig.HierarchyConstants.prototype.groupingBehavior = "GROUPING_BEHAVIOR";
$.ig.HierarchyConstants.prototype.structureType = "STRUCTURE_TYPE";


$.ig.InstanceConstants.prototype.instanceName = "INSTANCE_NAME";
$.ig.InstanceConstants.prototype.instancePortNumber = "INSTANCE_PORT_NUMBER";
$.ig.InstanceConstants.prototype.instanceState = "INSTANCE_STATE";


$.ig.KpiConstants.prototype.catalogName = "CATALOG_NAME";
$.ig.KpiConstants.prototype.schemaName = "SCHEMA_NAME";
$.ig.KpiConstants.prototype.cubeName = "CUBE_NAME";
$.ig.KpiConstants.prototype.measureGroupName = "MEASUREGROUP_NAME";
$.ig.KpiConstants.prototype.kpiName = "KPI_NAME";
$.ig.KpiConstants.prototype.kpiCaption = "KPI_CAPTION";
$.ig.KpiConstants.prototype.kpiDescription = "KPI_DESCRIPTION";
$.ig.KpiConstants.prototype.kpiDisplayFolder = "KPI_DISPLAY_FOLDER";
$.ig.KpiConstants.prototype.kpiValue = "KPI_VALUE";
$.ig.KpiConstants.prototype.kpiGoal = "KPI_GOAL";
$.ig.KpiConstants.prototype.kpiStatus = "KPI_STATUS";
$.ig.KpiConstants.prototype.kpiTrend = "KPI_TREND";
$.ig.KpiConstants.prototype.kpiStatusGraphic = "KPI_STATUS_GRAPHIC";
$.ig.KpiConstants.prototype.kpiTrendGraphic = "KPI_TREND_GRAPHIC";
$.ig.KpiConstants.prototype.kpiWeight = "KPI_WEIGHT";
$.ig.KpiConstants.prototype.kpiCurrentTimeMember = "KPI_CURRENT_TIME_MEMBER";
$.ig.KpiConstants.prototype.kpiParentKpiName = "KPI_PARENT_KPI_NAME";


$.ig.LevelConstants.prototype.catalogName = "CATALOG_NAME";
$.ig.LevelConstants.prototype.cubeName = "CUBE_NAME";
$.ig.LevelConstants.prototype.dimensionUniqueName = "DIMENSION_UNIQUE_NAME";
$.ig.LevelConstants.prototype.hierarchyUniqueName = "HIERARCHY_UNIQUE_NAME";
$.ig.LevelConstants.prototype.levelName = "LEVEL_NAME";
$.ig.LevelConstants.prototype.levelUniqueName = "LEVEL_UNIQUE_NAME";
$.ig.LevelConstants.prototype.levelCaption = "LEVEL_CAPTION";
$.ig.LevelConstants.prototype.levelNumber = "LEVEL_NUMBER";
$.ig.LevelConstants.prototype.levelCardinality = "LEVEL_CARDINALITY";
$.ig.LevelConstants.prototype.levelType = "LEVEL_TYPE";
$.ig.LevelConstants.prototype.description = "DESCRIPTION";
$.ig.LevelConstants.prototype.customRollupSettings = "CUSTOM_ROLLUP_SETTINGS";
$.ig.LevelConstants.prototype.levelUniqueSettings = "LEVEL_UNIQUE_SETTINGS";
$.ig.LevelConstants.prototype.levelIsVisible = "LEVEL_IS_VISIBLE";
$.ig.LevelConstants.prototype.levelOrderingProperty = "LEVEL_ORDERING_PROPERTY";
$.ig.LevelConstants.prototype.levelDbType = "LEVEL_DBTYPE";
$.ig.LevelConstants.prototype.levelKeyCardinality = "LEVEL_KEY_CARDINALITY";
$.ig.LevelConstants.prototype.levelOrigin = "LEVEL_ORIGIN";


$.ig.MeasureConstants.prototype.catalogName = "CATALOG_NAME";
$.ig.MeasureConstants.prototype.schemaName = "SCHEMA_NAME";
$.ig.MeasureConstants.prototype.cubeName = "CUBE_NAME";
$.ig.MeasureConstants.prototype.measureName = "MEASURE_NAME";
$.ig.MeasureConstants.prototype.measureUniqueName = "MEASURE_UNIQUE_NAME";
$.ig.MeasureConstants.prototype.measureCaption = "MEASURE_CAPTION";
$.ig.MeasureConstants.prototype.measureAggregator = "MEASURE_AGGREGATOR";
$.ig.MeasureConstants.prototype.dataType = "DATA_TYPE";
$.ig.MeasureConstants.prototype.numericPrecision = "NUMERIC_PRECISION";
$.ig.MeasureConstants.prototype.numericScale = "NUMERIC_SCALE";
$.ig.MeasureConstants.prototype.expression = "EXPRESSION";
$.ig.MeasureConstants.prototype.description = "DESCRIPTION";
$.ig.MeasureConstants.prototype.measureIsVisible = "MEASURE_IS_VISIBLE";
$.ig.MeasureConstants.prototype.measureNameSqlCoulmnName = "MEASURE_NAME_SQL_COLUMN_NAME";
$.ig.MeasureConstants.prototype.measureUnqualifiedCaption = "MEASURE_UNQUALIFIED_CAPTION";
$.ig.MeasureConstants.prototype.measureGroupName = "MEASUREGROUP_NAME";
$.ig.MeasureConstants.prototype.measureDisplayFolder = "MEASURE_DISPLAY_FOLDER";
$.ig.MeasureConstants.prototype.defaultFormatString = "DEFAULT_FORMAT_STRING";


$.ig.MeasureGroupConstants.prototype.catalogName = "CATALOG_NAME";
$.ig.MeasureGroupConstants.prototype.schemaName = "SCHEMA_NAME";
$.ig.MeasureGroupConstants.prototype.cubeName = "CUBE_NAME";
$.ig.MeasureGroupConstants.prototype.measureGroupName = "MEASUREGROUP_NAME";
$.ig.MeasureGroupConstants.prototype.description = "DESCRIPTION";
$.ig.MeasureGroupConstants.prototype.measureGroupCaption = "MEASUREGROUP_CAPTION";


$.ig.MeasureGroupDimensionConstants.prototype.catalogName = "CATALOG_NAME";
$.ig.MeasureGroupDimensionConstants.prototype.schemaName = "SCHEMA_NAME";
$.ig.MeasureGroupDimensionConstants.prototype.cubeName = "CUBE_NAME";
$.ig.MeasureGroupDimensionConstants.prototype.measureGroupName = "MEASUREGROUP_NAME";
$.ig.MeasureGroupDimensionConstants.prototype.measureGroupCardinality = "MEASUREGROUP_CARDINALITY";
$.ig.MeasureGroupDimensionConstants.prototype.dimensionUniqueName = "DIMENSION_UNIQUE_NAME";
$.ig.MeasureGroupDimensionConstants.prototype.dimensionCardinality = "DIMENSION_CARDINALITY";
$.ig.MeasureGroupDimensionConstants.prototype.dimensionIsVisible = "DIMENSION_IS_VISIBLE";
$.ig.MeasureGroupDimensionConstants.prototype.dimensionIsFactDimension = "DIMENSION_IS_FACT_DIMENSION";
$.ig.MeasureGroupDimensionConstants.prototype.dimensionPath = "DIMENSION_PATH";
$.ig.MeasureGroupDimensionConstants.prototype.dimensionGranularity = "DIMENSION_GRANULARITY";


$.ig.MemberConstants.prototype.catalogName = "CATALOG_NAME";
$.ig.MemberConstants.prototype.schemaName = "SCHEMA_NAME";
$.ig.MemberConstants.prototype.cubeName = "CUBE_NAME";
$.ig.MemberConstants.prototype.dimensionUniqueName = "DIMENSION_UNIQUE_NAME";
$.ig.MemberConstants.prototype.hierarchyUniqueName = "HIERARCHY_UNIQUE_NAME";
$.ig.MemberConstants.prototype.levelUniqueName = "LEVEL_UNIQUE_NAME";
$.ig.MemberConstants.prototype.levelNumber = "LEVEL_NUMBER";
$.ig.MemberConstants.prototype.memberName = "MEMBER_NAME";
$.ig.MemberConstants.prototype.memberUniqueName = "MEMBER_UNIQUE_NAME";
$.ig.MemberConstants.prototype.memberType = "MEMBER_TYPE";
$.ig.MemberConstants.prototype.memberGuid = "MEMBER_GUID";
$.ig.MemberConstants.prototype.memberCaption = "MEMBER_CAPTION";
$.ig.MemberConstants.prototype.childrenCardinality = "CHILDREN_CARDINALITY";
$.ig.MemberConstants.prototype.parentLevel = "PARENT_LEVEL";
$.ig.MemberConstants.prototype.parentUniqueName = "PARENT_UNIQUE_NAME";
$.ig.MemberConstants.prototype.parentCount = "PARENT_COUNT";
$.ig.MemberConstants.prototype.description = "DESCRIPTION";
$.ig.MemberConstants.prototype.expression = "EXPRESSION";
$.ig.MemberConstants.prototype.memberKey = "MEMBER_KEY";
$.ig.MemberConstants.prototype.isPlaceholderMember = "IS_PLACEHOLDERMEMBER";
$.ig.MemberConstants.prototype.isDataMember = "IS_DATAMEMBER";
$.ig.MemberConstants.prototype.scope = "SCOPE";


$.ig.OlapSchemaConstants.prototype.cubes = "MDSCHEMA_CUBES";
$.ig.OlapSchemaConstants.prototype.dimensions = "MDSCHEMA_DIMENSIONS";
$.ig.OlapSchemaConstants.prototype.measureGroups = "MDSCHEMA_MEASUREGROUPS";
$.ig.OlapSchemaConstants.prototype.measureGroupDimensions = "MDSCHEMA_MEASUREGROUP_DIMENSIONS";
$.ig.OlapSchemaConstants.prototype.measures = "MDSCHEMA_MEASURES";
$.ig.OlapSchemaConstants.prototype.hierarchies = "MDSCHEMA_HIERARCHIES";
$.ig.OlapSchemaConstants.prototype.levels = "MDSCHEMA_LEVELS";
$.ig.OlapSchemaConstants.prototype.members = "MDSCHEMA_MEMBERS";
$.ig.OlapSchemaConstants.prototype.kpis = "MDSCHEMA_KPIS";


$.ig.CubeRestrictions.prototype.catalogName = "CATALOG_NAME";
$.ig.CubeRestrictions.prototype.schemaName = "SCHEMA_NAME";
$.ig.CubeRestrictions.prototype.cubeName = "CUBE_NAME";
$.ig.CubeRestrictions.prototype.cubeSource = "CUBE_SOURCE";


$.ig.DimensionRestrictions.prototype.catalogName = "CATALOG_NAME";
$.ig.DimensionRestrictions.prototype.schemaName = "SCHEMA_NAME";
$.ig.DimensionRestrictions.prototype.cubeName = "CUBE_NAME";
$.ig.DimensionRestrictions.prototype.dimensionName = "DIMENSION_NAME";
$.ig.DimensionRestrictions.prototype.dimensionUniqueName = "DIMENSION_UNIQUE_NAME";
$.ig.DimensionRestrictions.prototype.cubeSource = "CUBE_SOURCE";
$.ig.DimensionRestrictions.prototype.dimensionVisibility = "DIMENSION_VISIBILITY";


$.ig.HierarchyRestrictions.prototype.catalogName = "CATALOG_NAME";
$.ig.HierarchyRestrictions.prototype.schemaName = "SCHEMA_NAME";
$.ig.HierarchyRestrictions.prototype.cubeName = "CUBE_NAME";
$.ig.HierarchyRestrictions.prototype.dimensionUniqueName = "DIMENSION_UNIQUE_NAME";
$.ig.HierarchyRestrictions.prototype.hierarchyName = "HIERARCHY_NAME";
$.ig.HierarchyRestrictions.prototype.hierarchyUniqueName = "HIERARCHY_UNIQUE_NAME";
$.ig.HierarchyRestrictions.prototype.hierarchyOrigin = "HIERARCHY_ORIGIN";
$.ig.HierarchyRestrictions.prototype.cubeSource = "CUBE_SOURCE";
$.ig.HierarchyRestrictions.prototype.hierarchyVisibility = "HIERARCHY_VISIBILITY";


$.ig.KpiRestrictions.prototype.catalogName = "CATALOG_NAME";
$.ig.KpiRestrictions.prototype.schemaName = "SCHEMA_NAME";
$.ig.KpiRestrictions.prototype.cubeName = "CUBE_NAME";
$.ig.KpiRestrictions.prototype.kpiName = "KPI_NAME";
$.ig.KpiRestrictions.prototype.cubeSource = "CUBE_SOURCE";


$.ig.LevelRestrictions.prototype.catalogName = "CATALOG_NAME";
$.ig.LevelRestrictions.prototype.schemaName = "SCHEMA_NAME";
$.ig.LevelRestrictions.prototype.cubeName = "CUBE_NAME";
$.ig.LevelRestrictions.prototype.dimensionUniqueName = "DIMENSION_UNIQUE_NAME";
$.ig.LevelRestrictions.prototype.hierarchyUniqueName = "HIERARCHY_UNIQUE_NAME";
$.ig.LevelRestrictions.prototype.levelName = "LEVEL_NAME";
$.ig.LevelRestrictions.prototype.levelUniqueName = "LEVEL_UNIQUE_NAME";
$.ig.LevelRestrictions.prototype.levelOrigin = "LEVEL_ORIGIN";
$.ig.LevelRestrictions.prototype.cubeSource = "CUBE_SOURCE";
$.ig.LevelRestrictions.prototype.levelVisibility = "LEVEL_VISIBILITY";


$.ig.MeasureRestrictions.prototype.catalogName = "CATALOG_NAME";
$.ig.MeasureRestrictions.prototype.schemaName = "SCHEMA_NAME";
$.ig.MeasureRestrictions.prototype.cubeName = "CUBE_NAME";
$.ig.MeasureRestrictions.prototype.measureName = "MEASURE_NAME";
$.ig.MeasureRestrictions.prototype.measureUniqueName = "MEASURE_UNIQUE_NAME";
$.ig.MeasureRestrictions.prototype.measureGroupName = "MEASUREGROUP_NAME";
$.ig.MeasureRestrictions.prototype.cubeSource = "CUBE_SOURCE";
$.ig.MeasureRestrictions.prototype.measureVisibility = "MEASURE_VISIBILITY";


$.ig.MeasureGroupRestrictions.prototype.catalogName = "CATALOG_NAME";
$.ig.MeasureGroupRestrictions.prototype.schemaName = "SCHEMA_NAME";
$.ig.MeasureGroupRestrictions.prototype.cubeName = "CUBE_NAME";
$.ig.MeasureGroupRestrictions.prototype.measureGroupName = "MEASUREGROUP_NAME";


$.ig.MeasureGroupDimensionRestrictions.prototype.catalogName = "CATALOG_NAME";
$.ig.MeasureGroupDimensionRestrictions.prototype.schemaName = "SCHEMA_NAME";
$.ig.MeasureGroupDimensionRestrictions.prototype.cubeName = "CUBE_NAME";
$.ig.MeasureGroupDimensionRestrictions.prototype.measureGroupName = "MEASUREGROUP_NAME";
$.ig.MeasureGroupDimensionRestrictions.prototype.dimensionUniqueName = "DIMENSION_UNIQUE_NAME";
$.ig.MeasureGroupDimensionRestrictions.prototype.dimensionVisibility = "DIMENSION_VISIBILITY";


$.ig.MemberRestrictions.prototype.catalogName = "CATALOG_NAME";
$.ig.MemberRestrictions.prototype.schemaName = "SCHEMA_NAME";
$.ig.MemberRestrictions.prototype.cubeName = "CUBE_NAME";
$.ig.MemberRestrictions.prototype.dimensionUniqueName = "DIMENSION_UNIQUE_NAME";
$.ig.MemberRestrictions.prototype.hierarchyUniqueName = "HIERARCHY_UNIQUE_NAME";
$.ig.MemberRestrictions.prototype.levelUniqueName = "LEVEL_UNIQUE_NAME";
$.ig.MemberRestrictions.prototype.levelNumber = "LEVEL_NUMBER";
$.ig.MemberRestrictions.prototype.memberName = "MEMBER_NAME";
$.ig.MemberRestrictions.prototype.memberUniqueName = "MEMBER_UNIQUE_NAME";
$.ig.MemberRestrictions.prototype.memberType = "MEMBER_TYPE";
$.ig.MemberRestrictions.prototype.treeOp = "TREE_OP";
$.ig.MemberRestrictions.prototype.cubeSource = "CUBE_SOURCE";


$.ig.AxisXmlTypeSerializer.prototype.xNamesCache = null;


$.ig.TupleXmlTypeSerializer.prototype.xNamesCache = null;


$.ig.AxisMemberXmlTypeSerializer.prototype.xNamesCache = null;


$.ig.DimensionXmlTypeSerializer.prototype.xNamesCache = null;


$.ig.HierarchyXmlTypeSerializer.prototype.xNamesCache = null;


$.ig.MeasureGroupDimensionXmlTypeSerializer.prototype.xNamesCache = null;


$.ig.MeasureGroupXmlTypeSerializer.prototype.xNamesCache = null;


$.ig.MeasureXmlTypeSerializer.prototype.xNamesCache = null;


$.ig.MemberXmlTypeSerializer.prototype.xNamesCache = null;


$.ig.XmlaConstants.prototype.schemaCatalogsStringConstant = "DBSCHEMA_CATALOGS";
$.ig.XmlaConstants.prototype.schemaCubesStringConstant = "MDSCHEMA_CUBES";
$.ig.XmlaConstants.prototype.restrictionListStringConstant = "RestrictionList";
$.ig.XmlaConstants.prototype.propertyListStringConstant = "PropertyList";
$.ig.XmlaConstants.prototype.dataSourceInfoStringConstant = "DataSourceInfo";
$.ig.XmlaConstants.prototype.catalogPropertyNameStringConstant = "Catalog";
$.ig.XmlaConstants.prototype.schemaNameStringConstant = "SCHEMA_NAME";
$.ig.XmlaConstants.prototype.rowStringConstant = "row";
$.ig.XmlaConstants.prototype.descriptionStringConstant = "DESCRIPTION";
$.ig.XmlaConstants.prototype.cubeStringConstant = "CUBE";
$.ig.XmlaConstants.prototype.dimensionStringConstant = "DIMENSION";
$.ig.XmlaConstants.prototype.schemaDimensionsStringConstant = "MDSCHEMA_DIMENSIONS";
$.ig.XmlaConstants.prototype.schemaMeasureGroupsStringConstant = "MDSCHEMA_MEASUREGROUPS";
$.ig.XmlaConstants.prototype.measureGroupNameStringConstant = "MEASUREGROUP_NAME";
$.ig.XmlaConstants.prototype.measureGroupCaptionStringConstant = "MEASUREGROUP_CAPTION";
$.ig.XmlaConstants.prototype.schemaMeasureGroupDimensionsStringConstant = "MDSCHEMA_MEASUREGROUP_DIMENSIONS";
$.ig.XmlaConstants.prototype.dimensionNameStringConstant = "DIMENSION_NAME";
$.ig.XmlaConstants.prototype.dimensionUniqueNameStringConstant = "DIMENSION_UNIQUE_NAME";
$.ig.XmlaConstants.prototype.dimensionCaptionStringConstant = "DIMENSION_CAPTION";
$.ig.XmlaConstants.prototype.schemaMeasuresStringConstant = "MDSCHEMA_MEASURES";
$.ig.XmlaConstants.prototype.measureNameStringConstant = "MEASURE_NAME";
$.ig.XmlaConstants.prototype.measureUniqueNameStringConstant = "MEASURE_UNIQUE_NAME";
$.ig.XmlaConstants.prototype.measureCaptionStringConstant = "MEASURE_CAPTION";
$.ig.XmlaConstants.prototype.measureAggregatorStringConstant = "MEASURE_AGGREGATOR";
$.ig.XmlaConstants.prototype.dimensionTypeStringConstant = "DIMENSION_TYPE";
$.ig.XmlaConstants.prototype.schemaHierarchiesStringConstant = "MDSCHEMA_HIERARCHIES";
$.ig.XmlaConstants.prototype.hierarchyNameStringConstant = "HIERARCHY_NAME";
$.ig.XmlaConstants.prototype.hierarchyUniqueNameStringConstant = "HIERARCHY_UNIQUE_NAME";
$.ig.XmlaConstants.prototype.hierarchyCaptionStringConstant = "HIERARCHY_CAPTION";
$.ig.XmlaConstants.prototype.hierarchyOriginStringConstant = "HIERARCHY_ORIGIN";
$.ig.XmlaConstants.prototype.defaultMemberStringConstant = "DEFAULT_MEMBER";
$.ig.XmlaConstants.prototype.allMemberStringConstant = "ALL_MEMBER";
$.ig.XmlaConstants.prototype.levelNameStringConstant = "LEVEL_NAME";
$.ig.XmlaConstants.prototype.levelCaptionStringConstant = "LEVEL_CAPTION";
$.ig.XmlaConstants.prototype.levelUniqueNameStringConstant = "LEVEL_UNIQUE_NAME";
$.ig.XmlaConstants.prototype.levelNumberStringConstant = "LEVEL_NUMBER";
$.ig.XmlaConstants.prototype.levelCardinalityStringConstant = "LEVEL_CARDINALITY";
$.ig.XmlaConstants.prototype.schemaLevelsStringConstant = "MDSCHEMA_LEVELS";
$.ig.XmlaConstants.prototype.schemaMembersStringConstant = "MDSCHEMA_MEMBERS";
$.ig.XmlaConstants.prototype.treeOpStringConstant = "TREE_OP";
$.ig.XmlaConstants.prototype.memberNameStringConstant = "MEMBER_NAME";
$.ig.XmlaConstants.prototype.memberUniqueNameStringConstant = "MEMBER_UNIQUE_NAME";
$.ig.XmlaConstants.prototype.memberCaptionStringConstant = "MEMBER_CAPTION";
$.ig.XmlaConstants.prototype.parentUniqueNameStringConstant = "PARENT_UNIQUE_NAME";
$.ig.XmlaConstants.prototype.childrenCardinalityStringConstant = "CHILDREN_CARDINALITY";
$.ig.XmlaConstants.prototype.defaultFormatStringConstant = "DEFAULT_FORMAT_STRING";
$.ig.XmlaConstants.prototype.hierarchyDisplayFolderStringConstant = "HIERARCHY_DISPLAY_FOLDER";
$.ig.XmlaConstants.prototype.scopeStringConstant = "SCOPE";


$.ig.XmlaSoapMethodResult.prototype.returnPropertyName = "return";


$.ig.XmlaNamespace.prototype.sql = "urn:schemas-microsoft-com:xml-sql";
$.ig.XmlaNamespace.prototype.analysis = "urn:schemas-microsoft-com:xml-analysis";
$.ig.XmlaNamespace.prototype.mdDataset = "urn:schemas-microsoft-com:xml-analysis:mddataset";
$.ig.XmlaNamespace.prototype.rowset = "urn:schemas-microsoft-com:xml-analysis:rowset";
$.ig.XmlaNamespace.prototype.empty = "urn:schemas-microsoft-com:xml-analysis:empty";
$.ig.XmlaNamespace.prototype.exception = "urn:schemas-microsoft-com:xml-analysis:exception";


$.ig.XmlaSoapMessageBuilder.prototype.envelopeConstant = "Envelope";
$.ig.XmlaSoapMessageBuilder.prototype.headerConstant = "Header";
$.ig.XmlaSoapMessageBuilder.prototype.bodyConstant = "Body";
$.ig.XmlaSoapMessageBuilder.prototype.soapPrefixConstant = "soap";
$.ig.XmlaSoapMessageBuilder.prototype.xmlnsEnvelope = "http://schemas.xmlsoap.org/soap/envelope/";


$.ig.XmlaSoapMethod.prototype.propertiesConstant = "Properties";
$.ig.XmlaSoapMethod.prototype.propertyListConstant = "PropertyList";


$.ig.XmlaSoapMethodDiscover.prototype.methodName = "Discover";
$.ig.XmlaSoapMethodDiscover.prototype.requestTypeConstant = "RequestType";
$.ig.XmlaSoapMethodDiscover.prototype.restrictionsConstant = "Restrictions";
$.ig.XmlaSoapMethodDiscover.prototype.restrictionListConstant = "RestrictionList";
$.ig.XmlaSoapMethodDiscover.prototype.sessionIdConstant = "SessionId";


$.ig.XmlaSoapMethodExecute.prototype.methodName = "Execute";
$.ig.XmlaSoapMethodExecute.prototype.commandConstant = "Command";
$.ig.XmlaSoapMethodExecute.prototype.statementConstant = "Statement";


$.ig.XmlaSoapWebClient.prototype._registeredPrefixes = null;
if ($.ig.XmlaSoapWebClient.prototype.staticInit && !$.ig.XmlaSoapWebClient.prototype.xmlaSoapWebClientStaticInitCalled) { $.ig.XmlaSoapWebClient.prototype.staticInit(); $.ig.XmlaSoapWebClient.prototype.xmlaSoapWebClientStaticInitCalled = true; }


$.ig.XmlaSoapWebClient.prototype._registeredPrefixes = null;
if ($.ig.XmlaSoapWebClient.prototype.staticInit && !$.ig.XmlaSoapWebClient.prototype.xmlaSoapWebClientStaticInitCalled) { $.ig.XmlaSoapWebClient.prototype.staticInit(); $.ig.XmlaSoapWebClient.prototype.xmlaSoapWebClientStaticInitCalled = true; }


$.ig.ArrayJsonSerializer.prototype._instance = new $.ig.ArrayJsonSerializer();


$.ig.AxisJsonTypeSeriazlier.prototype._instance = new $.ig.AxisJsonTypeSeriazlier();


$.ig.AxisMemberJsonTypeSeriazlier.prototype._instance = new $.ig.AxisMemberJsonTypeSeriazlier();


$.ig.CatalogJsonTypeSeriazlier.prototype._instance = new $.ig.CatalogJsonTypeSeriazlier();


$.ig.CellJsonTypeSeriazlier.prototype._instance = new $.ig.CellJsonTypeSeriazlier();


$.ig.CubeJsonTypeSeriazlier.prototype._instance = new $.ig.CubeJsonTypeSeriazlier();


$.ig.DimensionJsonTypeSeriazlier.prototype._instance = new $.ig.DimensionJsonTypeSeriazlier();


$.ig.HierarchyJsonTypeSeriazlier.prototype._instance = new $.ig.HierarchyJsonTypeSeriazlier();


$.ig.KpiJsonTypeSeriazlier.prototype._instance = new $.ig.KpiJsonTypeSeriazlier();


$.ig.LevelJsonTypeSeriazlier.prototype._instance = new $.ig.LevelJsonTypeSeriazlier();


$.ig.MeasureGroupDimensionJsonTypeSeriazlier.prototype._instance = new $.ig.MeasureGroupDimensionJsonTypeSeriazlier();


$.ig.MeasureGroupJsonTypeSeriazlier.prototype._instance = new $.ig.MeasureGroupJsonTypeSeriazlier();


$.ig.MeasureJsonTypeSeriazlier.prototype._instance = new $.ig.MeasureJsonTypeSeriazlier();


$.ig.MemberJsonTypeSeriazlier.prototype._instance = new $.ig.MemberJsonTypeSeriazlier();


$.ig.RemoteRequestJsonTypeSeriazlier.prototype._instance = new $.ig.RemoteRequestJsonTypeSeriazlier();


$.ig.ResultJsonTypeSeriazlier.prototype._instance = new $.ig.ResultJsonTypeSeriazlier();


$.ig.TupleJsonTypeSeriazlier.prototype._instance = new $.ig.TupleJsonTypeSeriazlier();


$.ig.XmlaDiscoverProperties.prototype.catalog = "Catalog";


$.ig.util.extCopy($.ig.TaskExtensions, [[[$.ig.Task, $.ig.Task$1], ['continueWithTask$1', 'continueWithTask$2']]]);
$.ig.util.extCopy($.ig.Queryable, [[[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.IEnumerable, $.ig.ICollection, $.ig.IList, $.ig.Array, $.ig.Dictionary, $.ig.XmlNodeList, $.ig.XmlNamedNodeMap, $.ig.XmlaPropertiesCollection], ['asQueryable']]]);
$.ig.util.extCopy($.ig.Enumerable, [[[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.XmlaPropertiesCollection], ['where$1', 'where$11', 'select$2', 'selectMany$2', 'last$1', 'first$1', 'firstOrDefault$1', 'orderBy$2', 'orderByDescending$2', 'toList$1', 'concat$1', 'max', 'max$1', 'min', 'min$1', 'count$1', 'reverse$1', 'take$1', 'skip$1', 'any$1', 'contains$1', 'union$1', 'toArray$1', 'elementAt$1', 'sum', 'sum$1']], [[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.IEnumerable, $.ig.ICollection, $.ig.IList, $.ig.Array, $.ig.Dictionary, $.ig.XmlNodeList, $.ig.XmlNamedNodeMap, $.ig.XmlaPropertiesCollection], ['ofType$1', 'cast$1']]]);

} (jQuery));


/*!@license
* Infragistics.Web.ClientUI infragistics.olapflatdatasource.js 14.1.20141.2249
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends:
*     jquery-1.4.4.js
*     jquery.ui.core.js
*     jquery.ui.widget.js
*     infragistics.util.js
*/

// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["AbstractEnumerable:a", 
"Object:b", 
"Type:c", 
"Boolean:d", 
"ValueType:e", 
"Void:f", 
"String:g", 
"IComparable:h", 
"Number:i", 
"Number:j", 
"Single:k", 
"Number:l", 
"String:m", 
"Array:n", 
"RegExp:o", 
"RuntimeTypeHandle:p", 
"MethodInfo:q", 
"MethodBase:r", 
"MemberInfo:s", 
"ParameterInfo:t", 
"TypeCode:u", 
"Enum:v", 
"ConstructorInfo:w", 
"IEnumerable:x", 
"IEnumerator:y", 
"Func$1:z", 
"MulticastDelegate:aa", 
"IntPtr:ab", 
"AbstractEnumerator:ac", 
"IEnumerable$1:ad", 
"IEnumerator$1:ae", 
"ICollection$1:af", 
"IList$1:ag", 
"IArrayList:ah", 
"Array:ai", 
"ICollection:aj", 
"CompareCallback:ak", 
"List$1:al", 
"IList:am", 
"IDisposable:an", 
"IArray:ao", 
"Script:ap", 
"Date:aq", 
"Date:ar", 
"Number:as", 
"Func$3:at", 
"Action$1:au", 
"IDictionary$2:aw", 
"Dictionary$2:ax", 
"IDictionary:ay", 
"Dictionary:az", 
"IEqualityComparer$1:a0", 
"KeyValuePair$2:a1", 
"NotImplementedException:a2", 
"Error:a3", 
"GenericEnumerable$1:a4", 
"GenericEnumerator$1:a5", 
"INotifyCollectionChanged:a6", 
"NotifyCollectionChangedEventHandler:a7", 
"NotifyCollectionChangedEventArgs:a8", 
"EventArgs:a9", 
"NotifyCollectionChangedAction:ba", 
"ObservableCollection$1:bd", 
"INotifyPropertyChanged:be", 
"PropertyChangedEventHandler:bf", 
"PropertyChangedEventArgs:bg", 
"Delegate:bh", 
"ReadOnlyCollection$1:bj", 
"NameValueCollection:bl", 
"IOrderedEnumerable$1:bu", 
"Enumerable:bz", 
"Func$2:b0", 
"SortedList$1:b1", 
"Math:b2", 
"Number:b3", 
"Number:b4", 
"Number:b5", 
"Number:b6", 
"Number:b7", 
"Number:b8", 
"Number:b9", 
"ArgumentNullException:ca", 
"AggregateException:cn", 
"ArgumentException:co", 
"AsyncCompletedEventArgs:cq", 
"ListSortDirection:cs", 
"Environment:cu", 
"InvalidOperationException:cv", 
"Debug:cw", 
"ICredentials:cz", 
"NetworkCredential:c0", 
"Uri:c1", 
"UploadStringCompletedEventHandler:c2", 
"UploadStringCompletedEventArgs:c3", 
"WebClient:c4", 
"Encoding:c5", 
"UTF8Encoding:c6", 
"UnicodeEncoding:c7", 
"WebHeaderCollection:c8", 
"Task$1:c9", 
"Task:da", 
"JQueryPromise:db", 
"Action:dc", 
"TaskStatus:dd", 
"TaskCompletionSource$1:de", 
"JQueryDeferred:df", 
"JQuery:dg", 
"JQueryObject:dh", 
"Element:di", 
"ElementAttributeCollection:dj", 
"ElementCollection:dk", 
"WebStyle:dl", 
"ElementNodeType:dm", 
"Document:dn", 
"EventListener:dp", 
"IElementEventHandler:dq", 
"ElementEventHandler:dr", 
"ElementAttribute:ds", 
"JQueryPosition:dt", 
"JQueryCallback:du", 
"JQueryEvent:dv", 
"JQueryUICallback:dw", 
"FaultCode:dx", 
"FaultException:dy", 
"FaultReason:dz", 
"FaultException$1:d0", 
"StringBuilder:d1", 
"TaskFactory:d4", 
"Tuple$2:d5", 
"JavaScriptSerializer:d6", 
"XObject:f9", 
"XmlNode:ga", 
"XmlNodeList:gb", 
"XmlNamedNodeMap:gc", 
"XmlNodeType:gd", 
"XmlDocument:ge", 
"XmlElement:gf", 
"XmlLinkedNode:gg", 
"XmlAttribute:gh", 
"XmlUtils:gi", 
"XAttribute:gj", 
"XNode:gk", 
"XContainer:gl", 
"XElement:gm", 
"XName:gn", 
"XNamespace:go", 
"XDocument:gp"]);












$.ig.util.defType('TaskStatus', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('TaskStatus', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('ListSortDirection', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('ListSortDirection', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('NotifyCollectionChangedAction', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('NotifyCollectionChangedAction', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('AbstractEnumerable', 'Object', {
	__inner: null
	, 
	init: function (inner) {



		$.ig.Object.prototype.init.call(this);
			this.__inner = inner;
	}

	, 
	getEnumerator: function () {
		return new $.ig.AbstractEnumerator(this.__inner().getEnumerator());
	}
	, 
	$type: new $.ig.Type('AbstractEnumerable', $.ig.Object.prototype.$type, [$.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('AbstractEnumerator', 'Object', {
	__inner: null
	, 
	init: function (inner) {



		$.ig.Object.prototype.init.call(this);
			this.__inner = inner;
	}

	, 
	current: function () {

			return this.__inner.current();
	}

	, 
	moveNext: function () {
		return this.__inner.moveNext();
	}

	, 
	reset: function () {
		this.__inner.reset();
	}
	, 
	$type: new $.ig.Type('AbstractEnumerator', $.ig.Object.prototype.$type, [$.ig.IEnumerator.prototype.$type])
}, true);

$.ig.util.defType('IEnumerable$1', 'Object', {
	$type: new $.ig.Type('IEnumerable$1', null, [$.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('ICollection$1', 'Object', {
	$type: new $.ig.Type('ICollection$1', null, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('IList$1', 'Object', {
	$type: new $.ig.Type('IList$1', null, [$.ig.ICollection$1.prototype.$type.specialize(0), $.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('IArrayList', 'Object', {
	$type: new $.ig.Type('IArrayList', null)
}, true);

$.ig.util.defType('List$1', 'Object', {
	$t: null, 
	__inner: null
	, 
	init: function ($t, initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}

		this.__syncRoot = {};

		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.__inner = new $.ig.Array();
	}
	, 
	init1: function ($t, initNumber, source) {


		this.__syncRoot = {};

		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.__inner = new $.ig.Array();
			if (this.tryArray(0, source)) {
				return;
			}

			var en = source.getEnumerator();
			while (en.moveNext()) {
				var item = en.current();
				this.add1(item);
			}

	}
	, 
	init2: function ($t, initNumber, capacity) {


		this.__syncRoot = {};

		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.__inner = new $.ig.Array();
	}

	, 
	setItem: function (index, newItem) {
		this.__inner[index] = newItem;
	}

	, 
	insertItem: function (index, newItem) {
		this.__inner.insert(index, newItem);
	}

	, 
	addItem: function (newItem) {
		this.__inner.add(newItem);
	}

	, 
	removeItem: function (index) {
		this.__inner.removeAt(index);
	}

	, 
	clearItems: function () {
		this.__inner.clear();
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			this.setItem(index, value);
			return value;
		} else {

			return this.__inner[index];
		}
	}

	, 
	indexOf: function (item) {
		return this.__inner.indexOf(item);
	}

	, 
	insert: function (index, item) {
		this.insertItem(index, item);
	}

	, 
	removeAt: function (index) {
		this.removeItem(index);
	}

	, 
	count: function () {

			return this.__inner.length;
	}

	, 
	isReadOnly: function () {

			return false;
	}

	, 
	add1: function (item) {
		this.addItem(item);
	}

	, 
	clear: function () {
		this.clearItems();
	}

	, 
	contains1: function (item) {
		return this.__inner.contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		for (var i = 0; i < this.__inner.length; i++) {
			array[arrayIndex + i] = this.__inner[i];
		}

	}

	, 
	remove1: function (item) {
		var indexOf = this.indexOf(item);
		if (indexOf < 0) {
			return false;
		}

		this.removeItem(indexOf);
		return true;
	}

	, 
	getEnumerator: function () {
		var $self = this;
		var $iter = function () { return function () { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.__inner.getEnumerator();
								this.$state = 4;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$current = this.$item;
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 5;
								}
								break;

							case 5:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } () };
		return new $.ig.GenericEnumerator$1(this.$t, $iter());
	}

	, 
	asArrayList: function () {
		return this.__inner;
	}

	, 
	tryArray: function (index, collection_) {
		var asArrayList = $.ig.util.cast($.ig.IArrayList.prototype.$type, collection_);
		if (asArrayList != null) {
			this.__inner.insertRange1(index, asArrayList.asArrayList());
			return true;
		}

		var asArray = $.ig.util.cast($.ig.IArray.prototype.$type, collection_);
		if (asArray != null) {
			this.__inner.insertRange(index, asArray.asArray());
			return true;
		}

		var asList = $.ig.util.cast($.ig.IList$1.prototype.$type.specialize(this.$t), collection_);
		if (asList != null) {
			for (var i = 0; i < asList.count(); i++) {
				this.__inner.insert(index + i, asList.item(i));
			}

			return true;
		}

		var arr = $.isArray(collection_) ? collection_ : null;;
		if (arr != null) {
			this.__inner.insertRange(index, arr);
			return true;
		}

		return false;
	}

	, 
	insertRange1: function (index, collection) {
		if (this.tryArray(index, collection)) {
			return;
		}

		var j = 0;
		var en = collection.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			this.__inner.insert(index + j, item);
			j++;
		}

	}

	, 
	insertRange: function (index, collection) {
		if (this.tryArray(index, collection)) {
			return;
		}

		var j = 0;
		var en = collection.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			this.__inner.insert(index + j, item);
			j++;
		}

	}

	, 
	removeRange: function (index, numToRemove) {
		this.__inner.splice(index, numToRemove);
	}

	, 
	copyTo1: function (array, index) {
		this.__inner.copyTo(array, index);
	}

	, 
	isFixedSize: function () {

			return false;
	}

	, 
	add: function (value) {
		this.addItem(value);
		return this.__inner.length - 1;
	}

	, 
	contains: function (value) {
		return this.__inner.contains(value);
	}

	, 
	indexOf1: function (value) {
		return this.__inner.indexOf(value);
	}

	, 
	insert1: function (index, value) {
		this.insertItem(index, value);
	}

	, 
	remove: function (value) {
		var indexOf = this.indexOf1(value);
		this.removeItem(indexOf);
	}

	, 
	sort: function () {
		var $self = this;
		var c = null;
		if ($self.$t == Number) {
			c = function (n1, n2) {
					var d1 = n1;
					var d2 = n2;
					if (d1 < d2) {
						return -1;
					}

					if (d1 == d2) {
						return 0;
					}

					return 1;
			};

		} else if ($self.$t == $.ig.Single.prototype.$type) {
			c = function (n1, n2) {
					var f1 = n1;
					var f2 = n2;
					if (f1 < f2) {
						return -1;
					}

					if (f1 == f2) {
						return 0;
					}

					return 1;
			};

		} else if ($self.$t == $.ig.Number.prototype.$type) {
			c = function (n1, n2) {
					var i1 = n1;
					var i2 = n2;
					if (i1 < i2) {
						return -1;
					}

					if (i1 == i2) {
						return 0;
					}

					return 1;
			};

		} else if ($self.$t == $.ig.Date.prototype.$type) {
			c = function (n1, n2) {
					var d1 = n1;
					var d2 = n2;
					if (d1.getTime() < d2.getTime()) {
						return -1;
					}

					if (d1.getTime() == d2.getTime()) {
						return 0;
					}

					return 1;
			};

		} else {
			c = function (n1, n2) {
					return (n1).compareTo(n2);
			};
		}




		$self.sortHelper(c);
	}

	, 
	sortHelper: function (compare) {
		this.__inner.sort(compare);
	}

	, 
	sort1: function (compare) {
		var $self = this;
		$self.__inner.sort(function (o1, o2) {
				var t1 = o1;
				var t2 = o2;
				return compare(t1, t2);
		});
	}

	, 
	_capacity: 0,
	capacity: function (value) {
		if (arguments.length === 1) {
			this._capacity = value;
			return value;
		} else {
			return this._capacity;
		}
	}

	, 
	addRange: function (values) {
		var en = values.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			this.__inner.add(item);
		}

	}

	, 
	toArray: function () {
		return  this.__inner.slice(0);
	}

	, 
	forEach: function (action) {
	}

	, 
	isSynchronized: function () {

			return true;
	}
	, 
	__syncRoot: null

	, 
	syncRoot: function () {

			return this.__syncRoot;
	}
	, 
	$type: new $.ig.Type('List$1', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(0), $.ig.IArrayList.prototype.$type, $.ig.IList.prototype.$type])
}, true);


$.ig.util.defType('KeyValuePair$2', 'ValueType', {
	$tKey: null, 
	$tValue: null, 
	init: function ($tKey, $tValue, initNumber) {
		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}
		this.$tKey = $tKey;
		this.$tValue = $tValue;
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);

		$.ig.ValueType.prototype.init.call(this);

	}, 
	__key: null
	, 
	__value: null
	, 
	init1: function ($tKey, $tValue, initNumber, key, value) {



		this.$tKey = $tKey
		this.$tValue = $tValue
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);
		$.ig.ValueType.prototype.init.call(this);
			this.__key = key;
			this.__value = value;
	}

	, 
	key: function () {

			return this.__key;
	}

	, 
	value: function () {

			return this.__value;
	}
	, 
	$type: new $.ig.Type('KeyValuePair$2', $.ig.ValueType.prototype.$type)
}, true);

$.ig.util.defType('IDictionary$2', 'Object', {
	$type: new $.ig.Type('IDictionary$2', null, [$.ig.ICollection$1.prototype.$type.specialize($.ig.KeyValuePair$2.prototype.$type.specialize(this.$tKey, this.$tValue)), $.ig.IEnumerable$1.prototype.$type.specialize($.ig.KeyValuePair$2.prototype.$type.specialize(this.$tKey, this.$tValue)), $.ig.IEnumerable.prototype.$type])
}, true);

$.ig.util.defType('Dictionary$2', 'Object', {
	$tKey: null, 
	$tValue: null, 
	__inner: null
	, 
	__keys: null
	, 
	init: function ($tKey, $tValue, initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}

		this.__comparer = null;
		this._useToString = false;
		this._checkedString = false;
		this._needsEnsure = false;

		this.$tKey = $tKey
		this.$tValue = $tValue
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);
		$.ig.Object.prototype.init.call(this);
			this.__inner = new $.ig.Dictionary(0);
			this.__keys = new $.ig.Dictionary(0);
	}
	, 
	init1: function ($tKey, $tValue, initNumber, capacity) {


		this.__comparer = null;
		this._useToString = false;
		this._checkedString = false;
		this._needsEnsure = false;

		this.$tKey = $tKey
		this.$tValue = $tValue
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);
		$.ig.Object.prototype.init.call(this);
			this.__inner = new $.ig.Dictionary(1, capacity);
			this.__keys = new $.ig.Dictionary(0);
	}
	, 
	__comparer: null
	, 
	init2: function ($tKey, $tValue, initNumber, comparer) {


		this.__comparer = null;
		this._useToString = false;
		this._checkedString = false;
		this._needsEnsure = false;

		this.$tKey = $tKey
		this.$tValue = $tValue
		this.$type = this.$type.specialize(this.$tKey, this.$tValue);
		$.ig.Object.prototype.init.call(this);
			this.__inner = new $.ig.Dictionary(0);
			this.__keys = new $.ig.Dictionary(0);
			this.__comparer = comparer;
	}

	, 
	count: function () {

			return this.__inner.count();
	}

	, 
	item: function (key, value) {
		if (arguments.length === 2) {

			this.__inner.item(this.hash(key), value);
			this.__keys.item(this.hash(key), key);
			return value;
		} else {

			return this.__inner.item(this.hash(key));
		}
	}

	, 
	length: function () {

			return this.__inner.length();
	}

	, 
	containsKey: function (key) {
		return this.__inner.containsKey(this.hash(key));
	}

	, 
	remove: function (key) {
		var hash = this.hash(key);
		if (!this.__keys.containsKey(hash)) {
			return false;
		}

		this.__inner.remove(hash);
		this.__keys.remove(hash);
		return true;
	}

	, 
	clear: function () {
		this.__inner.clear();
		this.__keys.clear();
	}
	, 
	_useToString: false
	, 
	_checkedString: false
	, 
	_needsEnsure: false

	, 
	ensureConfig: function (key_) {
		if (!this._checkedString) {
			this._checkedString = true;
			this._needsEnsure = (typeof key_ == 'object');;
			if (!this._needsEnsure) {
				this._useToString = !key_.getHashCode;;
			}

		}

	}

	, 
	hash: function (key_) {
		this.ensureConfig(key_);
		if (this._needsEnsure) {
			$.ig.util.ensureUniqueId(key_);;
		}

		if (this.__comparer != null) {
			return this.__comparer.getHashCode(key_).toString();
		}

		if (this._useToString) {
			return key_.toString();

		} else {
			return key_.getHashCode().toString();
		}

	}

	, 
	add: function (key, value) {
		this.__inner.item(this.hash(key), value);
		this.__keys.item(this.hash(key), key);
	}

	, 
	tryGetValue: function (key, value) {
		if (!this.__inner.containsKey(this.hash(key))) {
			value = null;
			return {
				ret: false, 
				value: value
			};
		}

		value = this.__inner.item(this.hash(key));
		return {
			ret: true, 
			value: value
		};
		return {
			value: value
		};
	}

	, 
	keys: function () {

			var $self = this;
			var $iter = function () { return function () { return {
				$state: 0,
				$this: $self,
				$current: null,
				$key : null,
				$en : null,
				getEnumerator: function() {
					if (this.$state === -1) {
						this.$state = 0;
					}
					return this;
				},
				current: function () {
					return this.$current;
				},
				moveNext: function() {
					do {
						switch (this.$state) {
							case 0:
									this.$state = 1;
									break;
								case 1:
									this.$en = this.$this.__keys.values().getEnumerator();
									this.$state = 4;
									break;
																case 2:
									this.$key = this.$en.current();
										this.$current = this.$key;
										this.$state = 3;
										return true;
									case 3:

									this.$state = 4;
									break;
case 4:
									if (this.$en.moveNext()) {
										this.$state = 2;
									}
									else {
										this.$state = 5;
									}
									break;

								case 5:

								this.$state = -2;
								break;
							case -2:
								return false;
						}
					} while (this.$state > 0);
				}
			}; } () };
			return new $.ig.GenericEnumerable$1(this.$tKey, $iter);
	}

	, 
	values: function () {

			var $self = this;
			var $iter = function () { return function () { return {
				$state: 0,
				$this: $self,
				$current: null,
				$value : null,
				$en : null,
				getEnumerator: function() {
					if (this.$state === -1) {
						this.$state = 0;
					}
					return this;
				},
				current: function () {
					return this.$current;
				},
				moveNext: function() {
					do {
						switch (this.$state) {
							case 0:
									this.$state = 1;
									break;
								case 1:
									this.$en = this.$this.__inner.values().getEnumerator();
									this.$state = 4;
									break;
																case 2:
									this.$value = this.$en.current();
										this.$current = this.$value;
										this.$state = 3;
										return true;
									case 3:

									this.$state = 4;
									break;
case 4:
									if (this.$en.moveNext()) {
										this.$state = 2;
									}
									else {
										this.$state = 5;
									}
									break;

								case 5:

								this.$state = -2;
								break;
							case -2:
								return false;
						}
					} while (this.$state > 0);
				}
			}; } () };
			return new $.ig.GenericEnumerable$1(this.$tValue, $iter);
	}

	, 
	isReadOnly: function () {

			return false;
	}

	, 
	add1: function (item) {
		this.add(item.key(), item.value());
	}

	, 
	contains: function (item) {
		return this.containsKey(item.key());
	}

	, 
	copyTo: function (array, arrayIndex) {
		throw new $.ig.NotImplementedException();
	}

	, 
	remove1: function (item) {
		this.remove(item.key());
		return true;
	}

	, 
	keyValueEnumerableGenerator: function () {
		var $self = this;
		var $iter = function () { return function () { return {
			$state: 0,
			$this: $self,
			$current: null,
			$key : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.__keys.values().getEnumerator();
								this.$state = 4;
								break;
														case 2:
								this.$key = this.$en.current();
									this.$current = new $.ig.KeyValuePair$2(this.$tKey, this.$tValue, 1, this.$key, this.$this.__inner.item(this.$this.hash(this.$key)));
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 5;
								}
								break;

							case 5:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } () };
		return new $.ig.GenericEnumerable$1($.ig.KeyValuePair$2.prototype.$type.specialize(this.$tKey, this.$tValue), $iter);
	}

	, 
	getEnumerator: function () {
		return this.keyValueEnumerableGenerator().getEnumerator();
	}
	, 
	$type: new $.ig.Type('Dictionary$2', $.ig.Object.prototype.$type, [$.ig.IDictionary$2.prototype.$type.specialize(0, 1), $.ig.IDictionary.prototype.$type])
}, true);

$.ig.util.defType('GenericEnumerable$1', 'Object', {
	$t: null, 
	__inner: null
	, 
	init: function ($t, inner) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.__inner = inner;
	}

	, 
	getEnumerator: function () {
		return new $.ig.GenericEnumerator$1(this.$t, this.__inner().getEnumerator());
	}
	, 
	$type: new $.ig.Type('GenericEnumerable$1', $.ig.Object.prototype.$type, [$.ig.IEnumerable$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('IEnumerator$1', 'Object', {
	$type: new $.ig.Type('IEnumerator$1', null, [$.ig.IEnumerator.prototype.$type])
}, true);

$.ig.util.defType('GenericEnumerator$1', 'Object', {
	$t: null, 
	__inner: null
	, 
	init: function ($t, inner) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.__inner = inner;
	}

	, 
	current: function () {

			return this.__inner.current();
	}

	, 
	moveNext: function () {
		return this.__inner.moveNext();
	}

	, 
	reset: function () {
		this.__inner.reset();
	}
	, 
	$type: new $.ig.Type('GenericEnumerator$1', $.ig.Object.prototype.$type, [$.ig.IEnumerator$1.prototype.$type.specialize(0)])
}, true);

$.ig.util.defType('INotifyCollectionChanged', 'Object', {
	$type: new $.ig.Type('INotifyCollectionChanged', null)
}, true);


$.ig.util.defType('NotifyCollectionChangedEventArgs', 'EventArgs', {
	init: function (initNumber, action) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.EventArgs.prototype.init.call(this);
			this.__action = action;
			this.__oldItems = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			this.__newItems = new $.ig.List$1($.ig.Object.prototype.$type, 0);
	}
	, 
	init1: function (initNumber, action, changedItem, index) {


		var $self = this;

		$.ig.EventArgs.prototype.init.call(this);
			this.__action = action;
			this.__oldItems = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			if (this.__action == $.ig.NotifyCollectionChangedAction.prototype.remove || this.__action == $.ig.NotifyCollectionChangedAction.prototype.replace) {
				this.__oldItems.add(changedItem);
				this.__oldStartingIndex = index;
			}

			if (this.__action != $.ig.NotifyCollectionChangedAction.prototype.remove) {
				this.__newItems = (function () { var $ret = new $.ig.List$1($.ig.Object.prototype.$type, 0);
				$ret.add(changedItem); return $ret;}());

			} else {
				this.__newItems = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			}

			this.__newStartingIndex = index;
	}
	, 
	init2: function (initNumber, action, newItem, oldItem, index) {


		var $self = this;

		$.ig.EventArgs.prototype.init.call(this);
			this.__action = action;
			this.__newStartingIndex = index;
			this.__oldStartingIndex = index;
			this.__newItems = (function () { var $ret = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			$ret.add(newItem); return $ret;}());
			this.__oldItems = (function () { var $ret = new $.ig.List$1($.ig.Object.prototype.$type, 0);
			$ret.add(oldItem); return $ret;}());
	}
	, 
	__action: null

	, 
	action: function () {

			return this.__action;
	}
	, 
	__newItems: null

	, 
	newItems: function () {

			return this.__newItems;
	}
	, 
	__newStartingIndex: 0

	, 
	newStartingIndex: function () {

			return this.__newStartingIndex;
	}
	, 
	__oldItems: null

	, 
	oldItems: function () {

			return this.__oldItems;
	}
	, 
	__oldStartingIndex: 0

	, 
	oldStartingIndex: function () {

			return this.__oldStartingIndex;
	}
	, 
	$type: new $.ig.Type('NotifyCollectionChangedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);



$.ig.util.defType('ObservableCollection$1', 'List$1', {
	$t: null, 
	init: function ($t, initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}


		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.List$1.prototype.init.call(this, this.$t);
	}
	, 
	init1: function ($t, initNumber, source) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.List$1.prototype.init1.call(this, this.$t, 1, source);
	}
	, 
	init2: function ($t, initNumber, capacity) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.List$1.prototype.init2.call(this, this.$t, 2, capacity);
	}

	, 
	setItem: function (index, newItem) {
		var oldItem = this.__inner[index];
		$.ig.List$1.prototype.setItem.call(this, index, newItem);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(2, $.ig.NotifyCollectionChangedAction.prototype.replace, newItem, oldItem, index);
			this.onCollectionChanged(args);
		}

	}

	, 
	clearItems: function () {
		$.ig.List$1.prototype.clearItems.call(this);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Count"));
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(0, $.ig.NotifyCollectionChangedAction.prototype.reset);
			this.onCollectionChanged(args);
		}

	}

	, 
	insertItem: function (index, newItem) {
		$.ig.List$1.prototype.insertItem.call(this, index, newItem);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Count"));
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, newItem, index);
			this.onCollectionChanged(args);
		}

	}

	, 
	addItem: function (newItem) {
		$.ig.List$1.prototype.addItem.call(this, newItem);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Count"));
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, newItem, this.count() - 1);
			this.onCollectionChanged(args);
		}

	}

	, 
	removeItem: function (index) {
		var oldItem = this.__inner[index];
		$.ig.List$1.prototype.removeItem.call(this, index);
		if (this.propertyChanged != null) {
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Count"));
			this.onPropertyChanged(new $.ig.PropertyChangedEventArgs("Item[]"));
		}

		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.remove, oldItem, index);
			this.onCollectionChanged(args);
		}

	}
	, 
	collectionChanged: null, 
	propertyChanged: null
	, 
	onPropertyChanged: function (args) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, args);
		}

	}

	, 
	onCollectionChanged: function (args) {
		if (this.collectionChanged != null) {
			this.collectionChanged(this, args);
		}

	}
	, 
	$type: new $.ig.Type('ObservableCollection$1', $.ig.List$1.prototype.$type.specialize(0), [$.ig.INotifyCollectionChanged.prototype.$type, $.ig.INotifyPropertyChanged.prototype.$type])
}, true);


$.ig.util.defType('ReadOnlyCollection$1', 'Object', {
	$t: null, 
	init: function ($t, initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}

		this.__syncRoot = {};

		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
	}
	, 
	init1: function ($t, initNumber, source) {


		this.__syncRoot = {};

		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.__inner = source;
	}
	, 
	__inner: null

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			this.__inner.item(index, value);
			return value;
		} else {

			return this.__inner.item(index);
		}
	}

	, 
	indexOf: function (item) {
		return this.__inner.indexOf(item);
	}

	, 
	insert: function (index, item) {
	}

	, 
	removeAt: function (index) {
	}

	, 
	count: function () {

			return this.__inner.count();
	}

	, 
	isReadOnly: function () {

			return true;
	}

	, 
	add1: function (item) {
	}

	, 
	clear: function () {
	}

	, 
	contains1: function (item) {
		return this.__inner.contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		this.__inner.copyTo(array, arrayIndex);
	}

	, 
	remove1: function (item) {
		return false;
	}

	, 
	getEnumerator: function () {
		return this.__inner.getEnumerator();
	}

	, 
	isFixedSize: function () {

			return true;
	}

	, 
	add: function (value) {
		return -1;
	}

	, 
	contains: function (value) {
		return this.__inner.contains(value);
	}

	, 
	indexOf1: function (value) {
		return this.__inner.indexOf(value);
	}

	, 
	insert1: function (index, value) {
	}

	, 
	remove: function (value) {
	}

	, 
	copyTo1: function (array, index) {
		this.__inner.copyTo(array, index);
	}

	, 
	items: function () {

			return this.__inner;
	}

	, 
	isSynchronized: function () {

			return true;
	}
	, 
	__syncRoot: null

	, 
	syncRoot: function () {

			return this.__syncRoot;
	}
	, 
	$type: new $.ig.Type('ReadOnlyCollection$1', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(0), $.ig.IList.prototype.$type])
}, true);


$.ig.util.defType('NameValueCollection', 'Object', {
	__dict: null
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__dict = new $.ig.Dictionary$2(String, String, 0);
	}

	, 
	item: function (name, value) {
		if (arguments.length === 2) {

			if (this.__dict.containsKey(name)) {
				this.__dict.item(name, value);

			} else {
				this.__dict.add(name, value);
			}

			return value;
		} else {

			if (this.__dict.containsKey(name)) {
				return this.__dict.item(name);

			} else {
				return null;
			}

		}
	}
	, 
	$type: new $.ig.Type('NameValueCollection', $.ig.Object.prototype.$type)
}, true);









$.ig.util.defType('IOrderedEnumerable$1', 'Object', {
	$type: new $.ig.Type('IOrderedEnumerable$1', null, [$.ig.IEnumerable$1.prototype.$type.specialize(0), $.ig.IEnumerable.prototype.$type])
}, true);


$.ig.util.defType('Enumerable', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	where$1: function ($tSource, predicate) {
		var $self = this;
		var $iter = function () { return function ($tSource, predicate) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 7;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$state = 3;
									break;
								case 3:
									if (predicate(this.$item)) {
										this.$state = 4;
									}
									else {
										this.$state = 6;
									}
									break;

								case 4:
		this.$current = this.$item;
		this.$state = 5;
		return true;
	case 5:

	this.$state = 6;
	break;

case 6:

								this.$state = 7;
								break;
case 7:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 8;
								}
								break;

							case 8:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, predicate) };
		return new $.ig.GenericEnumerable$1($tSource, $iter);
	}

	, 
	where$11: function ($tSource, predicate) {
		var $self = this;
		var $iter = function () { return function ($tSource, predicate) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$index : 0,
			$item : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$index = 0;
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 7;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$state = 3;
									break;
								case 3:
									if (predicate(this.$item, this.$index)) {
										this.$state = 4;
									}
									else {
										this.$state = 6;
									}
									break;

								case 4:
		this.$current = this.$item;
		this.$state = 5;
		return true;
	case 5:

	this.$state = 6;
	break;

case 6:

									this.$index++;
								this.$state = 7;
								break;
case 7:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 8;
								}
								break;

							case 8:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, predicate) };
		return new $.ig.GenericEnumerable$1($tSource, $iter);
	}

	, 
	select$2: function ($tSource, $tResult, selector) {
		var $self = this;
		var $iter = function () { return function ($tSource, $tResult, selector) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 4;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$current = selector(this.$item);
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 5;
								}
								break;

							case 5:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, $tResult, selector) };
		return new $.ig.GenericEnumerable$1($tResult, $iter);
	}

	, 
	selectMany$2: function ($tSource, $tResult, selector) {
		var $self = this;
		var $iter = function () { return function ($tSource, $tResult, selector) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			$item2 : null,
			$en1 : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 8;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$state = 3;
									break;
								case 3:
									this.$en1 = selector(this.$item).getEnumerator();
									this.$state = 6;
									break;
																case 4:
									this.$item2 = this.$en1.current();
										this.$current = this.$item2;
										this.$state = 5;
										return true;
									case 5:

									this.$state = 6;
									break;
case 6:
									if (this.$en1.moveNext()) {
										this.$state = 4;
									}
									else {
										this.$state = 7;
									}
									break;

								case 7:

								this.$state = 8;
								break;
case 8:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 9;
								}
								break;

							case 9:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, $tResult, selector) };
		return new $.ig.GenericEnumerable$1($tResult, $iter);
	}

	, 
	ofType$1: function ($tResult) {
		var $self = this;
		var $iter = function () { return function ($tResult) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 7;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$state = 3;
									break;
								case 3:
									if ($.ig.util.cast($tResult, this.$item) !== null) {
										this.$state = 4;
									}
									else {
										this.$state = 6;
									}
									break;

								case 4:
		this.$current = this.$item;
		this.$state = 5;
		return true;
	case 5:

	this.$state = 6;
	break;

case 6:

								this.$state = 7;
								break;
case 7:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 8;
								}
								break;

							case 8:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tResult) };
		return new $.ig.GenericEnumerable$1($tResult, $iter);
	}

	, 
	last$1: function ($tSource) {
		var ilist = $.ig.util.cast($.ig.IList$1.prototype.$type.specialize($tSource), this);
		if (ilist != null) {
			return ilist.item(ilist.count() - 1);
		}

		var current = null;
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			current = item;
		}

		return current;
	}

	, 
	first$1: function ($tSource) {
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			return item;
		}

		return null;
	}

	, 
	firstOrDefault$1: function ($tSource) {
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			return item;
		}

		return null;
	}

	, 
	orderBy$2: function ($tSource, $tKey, keySelector) {
		var $self = this;
		var buffer = new $.ig.SortedList$1($tSource, $self);
		buffer.sort1(function (o1, o2) {
			var t1 = o1;
			var t2 = o2;
			var k1 = keySelector(t1);
			var k2 = keySelector(t2);
			if ($.ig.util.cast($.ig.IComparable.prototype.$type, k1) !== null) {
				return ($.ig.util.cast($.ig.IComparable.prototype.$type, k1)).compareTo(k2);

			} else {
				return k1.toString().compareTo(k2.toString());
			}

		});
		return buffer;
	}

	, 
	orderByDescending$2: function ($tSource, $tKey, keySelector) {
		var $self = this;
		var buffer = new $.ig.SortedList$1($tSource, $self);
		buffer.sort1(function (o2, o1) {
			var t1 = o1;
			var t2 = o2;
			var k1 = keySelector(t1);
			var k2 = keySelector(t2);
			if ($.ig.util.cast($.ig.IComparable.prototype.$type, k1) !== null) {
				return ($.ig.util.cast($.ig.IComparable.prototype.$type, k1)).compareTo(k2);

			} else {
				return k1.toString().compareTo(k2.toString());
			}

		});
		return buffer;
	}

	, 
	toList$1: function ($tSource) {
		var list = new $.ig.List$1($tSource, 1, this);
		return list;
	}

	, 
	range: function (startValue, count) {
		var $self = this;
		var $iter = function () { return function (startValue, count) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$i : 0,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
																this.$i = startValue;
								this.$state = 5;
								break;
														case 2:
									this.$current = this.$i;
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								this.$i++;
								this.$state = 5;
								break;
							case 5:
								if (this.$i < count) {
									this.$state = 2;
								}
								else {
									this.$state = 6;
								}
								break;
							case 6:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } (startValue, count) };
		return new $.ig.GenericEnumerable$1($.ig.Number.prototype.$type, $iter);
	}

	, 
	concat$1: function ($tSource, source2) {
		var $self = this;
		var $iter = function () { return function ($tSource, source2) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			$item1 : null,
			$en1 : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 4;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$current = this.$item;
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 5;
								}
								break;

							case 5:

								this.$state = 6;
								break;
							case 6:
								this.$en1 = source2.getEnumerator();
								this.$state = 9;
								break;
														case 7:
								this.$item1 = this.$en1.current();
									this.$current = this.$item1;
									this.$state = 8;
									return true;
								case 8:

								this.$state = 9;
								break;
case 9:
								if (this.$en1.moveNext()) {
									this.$state = 7;
								}
								else {
									this.$state = 10;
								}
								break;

							case 10:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, source2) };
		return new $.ig.GenericEnumerable$1($tSource, $iter);
	}

	, 
	max: function () {
		var first = true;
		var max = 0;
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			if (first) {
				first = false;
				max = item;

			} else {
				max = Math.max(max, item);
			}

		}

		return max;
	}

	, 
	max$1: function ($tSource, selector) {
		return this.select$2($tSource, $.ig.Number.prototype.$type, selector).max();
	}

	, 
	min: function () {
		var first = true;
		var min = 0;
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			if (first) {
				first = false;
				min = item;

			} else {
				min = Math.min(min, item);
			}

		}

		return min;
	}

	, 
	min$1: function ($tSource, selector) {
		return this.select$2($tSource, $.ig.Number.prototype.$type, selector).max();
	}

	, 
	count$1: function ($tSource) {
		var count = 0;
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			count++;
		}

		return count;
	}

	, 
	reverse$1: function ($tSource) {
		var $self = this;
		var $iter = function () { return function ($tSource) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$list : null,
			$i : 0,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$list = new $.ig.List$1($tSource, 1, this.$this);
								this.$state = 1;
								break;
							case 1:
																this.$i = this.$list.count() - 1;
								this.$state = 5;
								break;
														case 2:
									this.$current = this.$list.__inner[this.$i];
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								this.$i--;
								this.$state = 5;
								break;
							case 5:
								if (this.$i > 0) {
									this.$state = 2;
								}
								else {
									this.$state = 6;
								}
								break;
							case 6:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource) };
		return new $.ig.GenericEnumerable$1($tSource, $iter);
	}

	, 
	cast$1: function ($tResult) {
		if (this == null) {
			throw new $.ig.ArgumentNullException("source");
		}

		var enumerable = $.ig.util.cast($.ig.IEnumerable$1.prototype.$type.specialize($tResult), this);
		if (enumerable != null) {
			return enumerable;
		}

		var list = new $.ig.List$1($tResult, 0);
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			if ($.ig.util.cast($tResult, item) !== null) {
				list.add1(item);

			} else {
				list.add1(null);
			}

		}

		return list;
	}

	, 
	take$1: function ($tSource, toTake) {
		var $self = this;
		var $iter = function () { return function ($tSource, toTake) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 9;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$state = 3;
									break;
								case 3:
									if (toTake > 0) {
										this.$state = 4;
									}
									else {
										this.$state = 6;
									}
									break;

								case 4:
		toTake--;
		this.$current = this.$item;
		this.$state = 5;
		return true;
	case 5:

	this.$state = 8;
	break;

case 6:

		this.$state = -2;
		return false;
	case 7:

	this.$state = 8;
	break;
case 8:

								this.$state = 9;
								break;
case 9:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 10;
								}
								break;

							case 10:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, toTake) };
		return new $.ig.GenericEnumerable$1($tSource, $iter);
	}

	, 
	skip$1: function ($tSource, toSkip) {
		var $self = this;
		var $iter = function () { return function ($tSource, toSkip) { return {
			$state: 0,
			$this: $self,
			$current: null,
			$item : null,
			$en : null,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
								this.$en = this.$this.getEnumerator();
								this.$state = 8;
								break;
														case 2:
								this.$item = this.$en.current();
									this.$state = 3;
									break;
								case 3:
									if (toSkip <= 0) {
										this.$state = 4;
									}
									else {
										this.$state = 6;
									}
									break;

								case 4:
		this.$current = this.$item;
		this.$state = 5;
		return true;
	case 5:

	this.$state = 7;
	break;

case 6:
		toSkip--;
	this.$state = 7;
	break;
case 7:

								this.$state = 8;
								break;
case 8:
								if (this.$en.moveNext()) {
									this.$state = 2;
								}
								else {
									this.$state = 9;
								}
								break;

							case 9:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } ($tSource, toSkip) };
		return new $.ig.GenericEnumerable$1($tSource, $iter);
	}

	, 
	any$1: function ($tSource) {
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			return true;
		}

		return false;
	}

	, 
	contains$1: function ($tSource, value_) {
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item_ = en.current();
			if (item_ === value_)
                {
                    return true;
                };
		}

		return false;
	}

	, 
	union$1: function ($tSource, second) {
		return null;
	}

	, 
	toArray$1: function ($tSource) {
		var arr = new $.ig.List$1($tSource, 1, this);
		return arr.asArrayList();
	}

	, 
	elementAt$1: function ($tSource, index) {
		var iList = $.ig.util.cast($.ig.IList$1.prototype.$type.specialize($tSource), this);
		if (iList != null) {
			return iList.item(index);
		}

		return this.skip$1($tSource, index).first$1($tSource);
	}

	, 
	sum: function () {
		var sum = 0;
		var en = this.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			sum += item;
		}

		return sum;
	}

	, 
	sum$1: function ($tSource, selector) {
		return this.select$2($tSource, Number, selector).sum();
	}
	, 
	$type: new $.ig.Type('Enumerable', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SortedList$1', 'List$1', {
	$tElement: null, 
	init: function ($tElement, source) {



		this.$tElement = $tElement
		this.$type = this.$type.specialize(this.$tElement);
		$.ig.List$1.prototype.init1.call(this, this.$tElement, 1, source);
	}

	, 
	getEnumerator: function () {
		return $.ig.List$1.prototype.getEnumerator.call(this);
	}
	, 
	$type: new $.ig.Type('SortedList$1', $.ig.List$1.prototype.$type.specialize(0), [$.ig.IOrderedEnumerable$1.prototype.$type.specialize(0)])
}, true);


$.ig.util.defType('IArray', 'Object', {
	$type: new $.ig.Type('IArray', null)
}, true);








$.ig.util.defType('AggregateException', 'Error', {
	init: function (initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.Error.prototype.init.call(this);
	}
	, 
	init1: function (initNumber, message) {



		$.ig.Error.prototype.init1.call(this, 1, message);
	}
	, 
	init2: function (initNumber, message, innerException) {



		$.ig.Error.prototype.init2.call(this, 2, message, innerException);
	}
	, 
	$type: new $.ig.Type('AggregateException', $.ig.Error.prototype.$type)
}, true);

$.ig.util.defType('ArgumentException', 'Error', {
	init: function (initNumber, message) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.Error.prototype.init1.call(this, 1, message);
	}
	, 
	init1: function (initNumber, errorMessage, paramName) {



		$.ig.Error.prototype.init1.call(this, 1, errorMessage);
	}
	, 
	$type: new $.ig.Type('ArgumentException', $.ig.Error.prototype.$type)
}, true);

$.ig.util.defType('ArgumentNullException', 'Error', {
	init: function (argumentName) {



		$.ig.Error.prototype.init1.call(this, 1, argumentName + " cannot be null.");
	}
	, 
	$type: new $.ig.Type('ArgumentNullException', $.ig.Error.prototype.$type)
}, true);


$.ig.util.defType('AsyncCompletedEventArgs', 'EventArgs', {
	__error: null
	, 
	__cancelled: false
	, 
	__userState: null
	, 
	init: function (error, cancelled, userState) {



		$.ig.EventArgs.prototype.init.call(this);
			this.__cancelled = cancelled;
			this.__error = error;
			this.__userState = userState;
	}

	, 
	error: function () {

			return this.__error;
	}

	, 
	cancelled: function () {

			return this.__cancelled;
	}

	, 
	userState: function () {

			return this.__userState;
	}

	, 
	raiseExceptionIfNecessary: function () {
		if (this.error() != null) {
			throw this.error();
		}

	}
	, 
	$type: new $.ig.Type('AsyncCompletedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);



$.ig.util.defType('Environment', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	newLine: function () {

			return "\n";
	}
	, 
	$type: new $.ig.Type('Environment', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('InvalidOperationException', 'Error', {
	init: function (initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.Error.prototype.init1.call(this, 1, "Invalid operation");
	}
	, 
	init1: function (initNumber, errorMessage) {



		$.ig.Error.prototype.init1.call(this, 1, errorMessage);
	}
	, 
	$type: new $.ig.Type('InvalidOperationException', $.ig.Error.prototype.$type)
}, true);

$.ig.util.defType('Debug', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	assert1: function (condition, text) {
	}

	, 
	writeLine: function (line) {
	}

	, 
	assert: function (value) {
	}
	, 
	$type: new $.ig.Type('Debug', $.ig.Object.prototype.$type)
}, true);



$.ig.util.defType('ICredentials', 'Object', {
	$type: new $.ig.Type('ICredentials', null)
}, true);

$.ig.util.defType('NetworkCredential', 'Object', {
	init: function (initNumber, userName, password) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.NetworkCredential.prototype.init1.call(this, 1, userName, password, String.empty());
	}
	, 
	init1: function (initNumber, userName, password, domain) {



		$.ig.Object.prototype.init.call(this);
			this.userName(userName);
			this.password(password);
			this.domain(domain);
	}

	, 
	getCredential: function (uri, authType) {
		return this;
	}

	, 
	_userName: null,
	userName: function (value) {
		if (arguments.length === 1) {
			this._userName = value;
			return value;
		} else {
			return this._userName;
		}
	}

	, 
	_password: null,
	password: function (value) {
		if (arguments.length === 1) {
			this._password = value;
			return value;
		} else {
			return this._password;
		}
	}

	, 
	_domain: null,
	domain: function (value) {
		if (arguments.length === 1) {
			this._domain = value;
			return value;
		} else {
			return this._domain;
		}
	}
	, 
	$type: new $.ig.Type('NetworkCredential', $.ig.Object.prototype.$type, [$.ig.ICredentials.prototype.$type])
}, true);


$.ig.util.defType('UploadStringCompletedEventArgs', 'AsyncCompletedEventArgs', {
	__result: null
	, 
	init: function (result, exception, cancelled, userToken) {



		$.ig.AsyncCompletedEventArgs.prototype.init.call(this, exception, cancelled, userToken);
			this.__result = result;
	}

	, 
	result: function () {

			this.raiseExceptionIfNecessary();
			return this.__result;
	}
	, 
	$type: new $.ig.Type('UploadStringCompletedEventArgs', $.ig.AsyncCompletedEventArgs.prototype.$type)
}, true);

$.ig.util.defType('WebClient', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.headers(new $.ig.WebHeaderCollection());
	}

	, 
	_encoding: null,
	encoding: function (value) {
		if (arguments.length === 1) {
			this._encoding = value;
			return value;
		} else {
			return this._encoding;
		}
	}

	, 
	_headers: null,
	headers: function (value) {
		if (arguments.length === 1) {
			this._headers = value;
			return value;
		} else {
			return this._headers;
		}
	}

	, 
	_credentials: null,
	credentials: function (value) {
		if (arguments.length === 1) {
			this._credentials = value;
			return value;
		} else {
			return this._credentials;
		}
	}
	, 
	uploadStringCompleted: null
	, 
	uploadStringAsync: function (address, method, data, userData) {
		var $self = this;
		$self.uploadStringTaskAsync(address, method, data).continueWith1(function (t) {
			if ($self.uploadStringCompleted != null) {
				var result = null;
				var exception = null;
				try {
						result = t.result();

				}
				catch (e_) {
						exception = e_;

				}
				$self.uploadStringCompleted($self, new $.ig.UploadStringCompletedEventArgs(result, exception, t.status() == $.ig.TaskStatus.prototype.canceled, userData));
			}

		});
	}

	, 
	uploadStringTaskAsync: function (address, method, data) {
		var url_ = address.value();
		var method_ = method;
		var data_ = data;
		var contentType_ = this.headers().item("Content-Type");
		var credentials_ = this.credentials();
		var promise = $.ig.util.ajax(url_, contentType_, data_, method_, credentials_);
		return new $.ig.Task$1(String, promise, null);
	}

	, 
	onSuccess: function (tcs, data, textStatus, jqXHR) {
		tcs.setResult(data);
	}

	, 
	onError: function (tcs, jqXHR, textStatus, errorThrown) {
		tcs.setException(new $.ig.Error(1, errorThrown));
	}
	, 
	$type: new $.ig.Type('WebClient', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('WebHeaderCollection', 'NameValueCollection', {
	init: function () {

		$.ig.NameValueCollection.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('WebHeaderCollection', $.ig.NameValueCollection.prototype.$type)
}, true);

$.ig.util.defType('FaultCode', 'Object', {
	init: function (name) {



		$.ig.Object.prototype.init.call(this);
			this.name(name);
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}
	, 
	$type: new $.ig.Type('FaultCode', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('FaultException', 'Error', {
	init: function (reason, code, action) {



		$.ig.Error.prototype.init.call(this);
			this.reason(reason);
			this.code(code);
			this.action(action);
	}

	, 
	_action: null,
	action: function (value) {
		if (arguments.length === 1) {
			this._action = value;
			return value;
		} else {
			return this._action;
		}
	}

	, 
	_code: null,
	code: function (value) {
		if (arguments.length === 1) {
			this._code = value;
			return value;
		} else {
			return this._code;
		}
	}

	, 
	_reason: null,
	reason: function (value) {
		if (arguments.length === 1) {
			this._reason = value;
			return value;
		} else {
			return this._reason;
		}
	}
	, 
	$type: new $.ig.Type('FaultException', $.ig.Error.prototype.$type)
}, true);

$.ig.util.defType('FaultException$1', 'FaultException', {
	$tDetail: null, 
	init: function ($tDetail, detail, reason, code, action) {



		this.$tDetail = $tDetail
		this.$type = this.$type.specialize(this.$tDetail);
		$.ig.FaultException.prototype.init.call(this, reason, code, action);
			this.detail(detail);
	}

	, 
	_detail: null,
	detail: function (value) {
		if (arguments.length === 1) {
			this._detail = value;
			return value;
		} else {
			return this._detail;
		}
	}
	, 
	$type: new $.ig.Type('FaultException$1', $.ig.FaultException.prototype.$type)
}, true);

$.ig.util.defType('FaultReason', 'Object', {
	__text: null
	, 
	init: function (text) {



		$.ig.Object.prototype.init.call(this);
			this.__text = text;
	}

	, 
	toString: function () {
		return this.__text;
	}
	, 
	$type: new $.ig.Type('FaultReason', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('StringBuilder', 'Object', {

	_internal: null,
	internal: function (value) {
		if (arguments.length === 1) {
			this._internal = value;
			return value;
		} else {
			return this._internal;
		}
	}
	, 
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this._internal = [];
	}

	, 
	append1: function (str_) {
		this._internal.push(str_);
		return this;
	}

	, 
	append2: function (builder) {
		var str_ = builder.toString();
		this._internal.push(str_);
		return this;
	}

	, 
	append: function (chr_) {
		this._internal.push(chr_);
		return this;
	}

	, 
	appendLine: function (str_) {
		this._internal.push(str_ + String.fromCharCode(10));
		return this;
	}

	, 
	insert: function (index_, chr_) {
		this._internal.splice(index_, 0, chr_);
		return this;
	}

	, 
	insert1: function (index_, str_) {
		this._internal.splice(index_, 0, str_);
		return this;
	}

	, 
	remove: function (startIndex_, length_) {
		this._internal.splice(startIndex_, length_);
		return this;
	}

	, 
	toString: function () {
		return this._internal.join('');
	}
	, 
	$type: new $.ig.Type('StringBuilder', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('NotImplementedException', 'Error', {
	init: function () {



		$.ig.Error.prototype.init1.call(this, 1, "not implemented");
	}
	, 
	$type: new $.ig.Type('NotImplementedException', $.ig.Error.prototype.$type)
}, true);


$.ig.util.defType('Encoding', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	uTF8: function () {

			if ($.ig.Encoding.prototype._utfEncoding == null) {
				$.ig.Encoding.prototype._utfEncoding = new $.ig.UTF8Encoding();
			}

			return $.ig.Encoding.prototype._utfEncoding;
	}

	, 
	unicode: function () {

			if ($.ig.Encoding.prototype._unicodeEncoding == null) {
				$.ig.Encoding.prototype._unicodeEncoding = new $.ig.UnicodeEncoding();
			}

			return $.ig.Encoding.prototype._unicodeEncoding;
	}

	, 
	getString: function (bytes, startIndex, length) {
		return "";
	}

	, 
	getBytes2: function (chars, charIndex, charCount, bytes, byteIndex) {
	}

	, 
	getBytes: function (chars, index, count) {
		var array = new Array(this.getByteCount(chars, index, count));
		this.getBytes2(chars, index, count, array, 0);
		return array;
	}

	, 
	getBytes1: function (input) {
		if (input == null) {
			throw new $.ig.ArgumentNullException("input");
		}

		var array = new Array(input.length);
		for (var i = 0; i < input.length; i++) {
			array[i] = input.charAt(i);
		}

		return this.getBytes(array, 0, array.length);
	}

	, 
	getByteCount: function (chars, index, count) {
	}
	, 
	$type: new $.ig.Type('Encoding', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('UnicodeEncoding', 'Encoding', {
	init: function () {

		$.ig.Encoding.prototype.init.call(this);

	}
	, 
	getString: function (bytes_, startIndex, length) {
		var ret = "";
		for (var i_ = startIndex; i_ < length; i_ = i_ + 2) {
			if (bytes_[i_] == 0) {
				break;
			}

			if (i_ + 1 >= length) {
				ret = ret + '�';

			} else {
				var bits0 = (bytes_[i_]).toString(16);
				var bits1 = (bytes_[i_ + 1]).toString(16);
				var code = $.ig.Number.prototype.parseInt(bits1 + bits0, 16);
				ret = ret + String.fromCharCode(code);
			}

		}

		return ret;
	}

	, 
	getByteCount: function (chars, index, count) {
		return 0;
	}

	, 
	getBytes2: function (chars, charIndex, charCount, bytes, byteIndex) {
		return 0;
	}

	, 
	getBytes: function (chars, index, count) {
		return $.ig.Encoding.prototype.getBytes.call(this, chars, index, count);
	}

	, 
	getBytes1: function (input_) {
		var bytes = new Array(input_.length * 2);
		for (var i_ = 0; i_ < input_.length; i_++) {
			var hex_ = input_.charCodeAt(i_).toString(16).padLeft(4, '0');
			bytes[2 * i_] = $.ig.Number.prototype.parseInt(hex_.substr(2), 16);
			bytes[2 * i_ + 1] = $.ig.Number.prototype.parseInt(hex_.substr(0, 2), 16);
		}

		return bytes;
	}
	, 
	$type: new $.ig.Type('UnicodeEncoding', $.ig.Encoding.prototype.$type)
}, true);

$.ig.util.defType('UTF8Encoding', 'Encoding', {
	init: function () {

		$.ig.Encoding.prototype.init.call(this);

	}
	, 
	getString: function (bytes_, startIndex, length) {
		var ret_ = "";
		for (var i_ = startIndex; i_ < length; i_++) {
			if (bytes_[i_] == 0) {
				break;
			}

			ret_ = ret_ + String.fromCharCode(bytes_[i_]);
		}

		ret_ = decodeURIComponent(escape(ret_));
		return ret_;
	}

	, 
	getByteCount: function (chars, index, count) {
		return 0;
	}

	, 
	getBytes2: function (chars, charIndex, charCount, bytes, byteIndex) {
		return 0;
	}

	, 
	getBytes: function (chars, index, count) {
		return $.ig.Encoding.prototype.getBytes.call(this, chars, index, count);
	}

	, 
	getBytes1: function (input_) {
		var bytes = new Array(input_.length);
		var inputUTF8_ = unescape(encodeURIComponent(input_));
		for (var i_ = 0; i_ < inputUTF8_.length; i_++) {
			bytes[i_] = inputUTF8_.charCodeAt(i_);
		}

		return bytes;
	}
	, 
	$type: new $.ig.Type('UTF8Encoding', $.ig.Encoding.prototype.$type)
}, true);

$.ig.util.defType('Task', 'Object', {

	_promise: null,
	promise: function (value) {
		if (arguments.length === 1) {
			this._promise = value;
			return value;
		} else {
			return this._promise;
		}
	}

	, 
	_isCanceled: false,
	isCanceled: function (value) {
		if (arguments.length === 1) {
			this._isCanceled = value;
			return value;
		} else {
			return this._isCanceled;
		}
	}

	, 
	_exception: null,
	exception: function (value) {
		if (arguments.length === 1) {
			this._exception = value;
			return value;
		} else {
			return this._exception;
		}
	}
	, 
	init: function (initNumber, promise) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.Task.prototype.init1.call(this, 1, promise, null);
	}
	, 
	init1: function (initNumber, promise, state) {


		var $self = this;

		$.ig.Object.prototype.init.call(this);
			var doneContinuation = function () {
			};
			var failContinuation = function (exception) {
				if (exception == null) {
					$self.isCanceled(true);

				} else {
					$self.exception(new $.ig.AggregateException(2, "Exception occurred during task execution", exception));
				}

			};
			this.promise(promise.done(doneContinuation).fail(failContinuation));
			this.asyncState(state);
	}

	, 
	status: function () {

			if (this.isCanceled()) {
			return $.ig.TaskStatus.prototype.canceled;
			}

			switch (this.promise().state()) {
				case "pending":
					return $.ig.TaskStatus.prototype.created;
				case "resolved":
					return $.ig.TaskStatus.prototype.ranToCompletion;
				case "rejected":
					return $.ig.TaskStatus.prototype.faulted;
				default:
					return $.ig.TaskStatus.prototype.created;
			}

	}

	, 
	_asyncState: null,
	asyncState: function (value) {
		if (arguments.length === 1) {
			this._asyncState = value;
			return value;
		} else {
			return this._asyncState;
		}
	}

	, 
	continueWith: function (continuationAction) {
		var $self = this;
		var doneContinuation = function () { return continuationAction($self); };
		var failContinuation = function (exception) { return continuationAction($self); };
		var continuationPromise = $self.promise().done(doneContinuation).fail(failContinuation);
		return new $.ig.Task(0, continuationPromise);
	}

	, 
	continueWith$1: function ($tNewResult, continuationFunction) {
		var $self = this;
		var tcs = new $.ig.TaskCompletionSource$1($tNewResult, 0);
		var continuation = function () {
			try {
					var newResult = continuationFunction($self);
					tcs.setResult(newResult);

			}
			catch (e_) {
					tcs.setException(e_);

			}
		};
		var doneContinuation = function (res) { return continuation(); };
		var failContinuation = function (exc) { return continuation(); };
		$self.promise().done(doneContinuation).fail(failContinuation);
		return tcs.task();
	}
	, 
	$type: new $.ig.Type('Task', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Task$1', 'Task', {
	$tResult: null, 
	init: function ($tResult, promise, state) {


		var $self = this;
		this.__resultReady = false;

		this.$tResult = $tResult
		this.$type = this.$type.specialize(this.$tResult);
		$.ig.Task.prototype.init1.call(this, 1, promise, state);
			var doneContinuation = function (res) {
				var result = res;
				$self.__result = result;
				$self.__resultReady = true;
			};
			var failContinuation = function (exc) {
				$self.__resultReady = true;
			};
			this.promise().done(doneContinuation).fail(failContinuation);
	}
	, 
	__resultReady: false
	, 
	__result: null

	, 
	result: function () {

			if (!this.__resultReady) {
				throw 'Result is not ready yet';
			}

			if (this.exception() != null) {
				throw this.exception();
			}

			return this.__result;
	}

	, 
	continueWith1: function (continuationAction) {
		var $self = this;
		return $.ig.Task.prototype.continueWith.call($self, function (t) { return continuationAction(t); });
	}

	, 
	continueWith$11: function ($tNewResult, continuationFunction) {
		var $self = this;
		var wrapperFunction = function (t) { return continuationFunction(t); };
		return $self.continueWithBase$1($.ig.Object.prototype.$type, wrapperFunction).continueWithBase$1($tNewResult, function (t) { return (t).result(); });
	}

	, 
	continueWithBase$1: function ($tNewResult, continuationFunction) {
		return $.ig.Task.prototype.continueWith$1.call(this, $tNewResult, continuationFunction);
	}
	, 
	$type: new $.ig.Type('Task$1', $.ig.Task.prototype.$type)
}, true);

$.ig.util.defType('TaskCompletionSource$1', 'Object', {
	$tResult: null
	, 
	_deferred: null,
	deferred: function (value) {
		if (arguments.length === 1) {
			this._deferred = value;
			return value;
		} else {
			return this._deferred;
		}
	}
	, 
	init: function ($tResult, initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		this.$tResult = $tResult
		this.$type = this.$type.specialize(this.$tResult);
		$.ig.TaskCompletionSource$1.prototype.init1.call(this, this.$tResult, 1, null);
	}
	, 
	init1: function ($tResult, initNumber, state) {



		this.$tResult = $tResult
		this.$type = this.$type.specialize(this.$tResult);
		$.ig.Object.prototype.init.call(this);
			this.deferred($.ig.util.deferred());
			this.task(new $.ig.Task$1(this.$tResult, this.deferred().promise(), state));
	}

	, 
	setCanceled: function () {
		this.deferred().reject(null);
	}

	, 
	setException: function (exception) {
		this.deferred().reject(exception);
	}

	, 
	setResult: function (result) {
		this.deferred().resolve(result);
	}

	, 
	_task: null,
	task: function (value) {
		if (arguments.length === 1) {
			this._task = value;
			return value;
		} else {
			return this._task;
		}
	}
	, 
	$type: new $.ig.Type('TaskCompletionSource$1', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TaskFactory', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	continueWhenAll: function (tasks, continuationAction) {
		var $self = this;
		return new $.ig.Task(0, $self.whenAll($self.getPromises(tasks)).always(function () { return continuationAction(tasks); }));
	}

	, 
	continueWhenAll$1: function ($tResult, tasks, continuationFunction) {
		var $self = this;
		var tcs = new $.ig.TaskCompletionSource$1($tResult, 0);
		$self.whenAll($self.getPromises(tasks)).always(function () {
			try {
					var result = continuationFunction(tasks);
					tcs.setResult(result);

			}
			catch (e_) {
					tcs.setException(e_);

			}
		});
		return tcs.task();
	}

	, 
	continueWhenAll$2: function ($tAntecedentResult, $tResult, tasks, continuationFunction) {
		var $self = this;
		var wrapperFunction = function (t) { return continuationFunction(t); };
		return $self.continueWhenAll$1($.ig.Object.prototype.$type, tasks, wrapperFunction).continueWith$1($tResult, function (t) { return t.result(); });
	}

	, 
	getPromises: function (tasks) {
		var promises = new Array(tasks.length);
		for (var i = 0; i < tasks.length; i++) {
			promises[i] = tasks[i].promise();
		}

		return promises;
	}

	, 
	whenAll: function (promises) {
		var promises_ = promises;
		var whenPromise = (function (p) {
    //can't use $.when as it rejects the master Deferred as soon as one of the Deferreds is rejected
    //and we need to wait for all to complete
    function whenAll() {
	    var whenDeffered = $.ig.util.deferred();

	    if (arguments.length === 0) {
		    whenDeffered.resolve();
		    return whenDeffered;
	    }
   
	    var count = arguments.length;
	    var resolve = true;
	
	    for (var i = 0; i < arguments.length; i++) {
		    arguments[i].done(
			    function () {
				    resolve = resolve && true;
			    }).fail(
			    function () {
				    resolve = resolve && false;
			    }
		    ).always(function () {
			    count--;
			    if (count <= 0) {
				    if (resolve) {
					    whenDeffered.resolve();
				    } else {
					    whenDeffered.reject();
				    }
			    }
		    });
	    }
	
	    return whenDeffered;
    }
	return whenAll.apply($, p);
})(promises_);;
		return whenPromise;
	}
	, 
	$type: new $.ig.Type('TaskFactory', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Tuple$2', 'Object', {
	$t1: null, 
	$t2: null
	, 
	_item1: null,
	item1: function (value) {
		if (arguments.length === 1) {
			this._item1 = value;
			return value;
		} else {
			return this._item1;
		}
	}

	, 
	_item2: null,
	item2: function (value) {
		if (arguments.length === 1) {
			this._item2 = value;
			return value;
		} else {
			return this._item2;
		}
	}
	, 
	init: function ($t1, $t2, item1, item2) {



		this.$t1 = $t1
		this.$t2 = $t2
		this.$type = this.$type.specialize(this.$t1, this.$t2);
		$.ig.Object.prototype.init.call(this);
			this.item1(item1);
			this.item2(item2);
	}
	, 
	$type: new $.ig.Type('Tuple$2', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Uri', 'Object', {
	init: function (uri) {



		$.ig.Object.prototype.init.call(this);
			this.value(uri);
	}

	, 
	_value: null,
	value: function (value) {
		if (arguments.length === 1) {
			this._value = value;
			return value;
		} else {
			return this._value;
		}
	}
	, 
	$type: new $.ig.Type('Uri', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('JavaScriptSerializer', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
	}

	, 
	deserializeObject: function (input) {
		var text_ = input;
		return JSON.parse(text_);
	}

	, 
	serialize: function (obj) {
		var value_ = obj;
		return JSON.stringify(value_);
	}
	, 
	$type: new $.ig.Type('JavaScriptSerializer', $.ig.Object.prototype.$type)
}, true);






































































$.ig.util.defType('XObject', 'Object', {
	init: function (node) {



		$.ig.Object.prototype.init.call(this);
			this.backingNode(node);
	}

	, 
	_backingNode: null,
	backingNode: function (value) {
		if (arguments.length === 1) {
			this._backingNode = value;
			return value;
		} else {
			return this._backingNode;
		}
	}

	, 
	nodeType: function () {

	}

	, 
	toString: function () {
		if (this.backingNode() != null) {
			return $.ig.XmlUtils.prototype.xmlNodeToString(this.backingNode());

		} else {
			return "";
		}

	}
	, 
	$type: new $.ig.Type('XObject', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XAttribute', 'XObject', {
	init: function (node) {



		$.ig.XObject.prototype.init.call(this, node);
	}

	, 
	attachToElement: function (element) {
		this.backingNode(this.backingNode().cloneNode(true));
		element.setAttributeNode(this.backingNode());
	}

	, 
	nodeType: function () {

			return $.ig.XmlNodeType.prototype.attribute;
	}

	, 
	value: function () {

			return $.ig.XmlUtils.prototype.getAttributeValue(this.backingNode());
	}
	, 
	$type: new $.ig.Type('XAttribute', $.ig.XObject.prototype.$type)
}, true);

$.ig.util.defType('XNode', 'XObject', {
	init: function (node) {



		$.ig.XObject.prototype.init.call(this, node);
	}
	, 
	$type: new $.ig.Type('XNode', $.ig.XObject.prototype.$type)
}, true);

$.ig.util.defType('XContainer', 'XNode', {
	init: function (node) {



		$.ig.XNode.prototype.init.call(this, node);
	}

	, 
	element: function (name) {
		var element = null;
		var backingNode = this.backingNode();
		var children = backingNode.childNodes;
		var childrenCount = children.length;
		var localName = name.localName();
		var namespaceName = name.namespaceName();
		for (var i = 0; i < childrenCount; i++) {
			var currNode = children.item(i);
			if (currNode.namespaceURI == namespaceName && currNode.nodeType == $.ig.XmlNodeType.prototype.element && $.ig.XmlUtils.prototype.getLocalName(currNode) == localName) {
				element = currNode;
			}

		}

		if (element == null) {
			return null;

		} else {
			return new $.ig.XElement(0, element);
		}

	}

	, 
	elements: function () {
		return this.elementsImpl(null);
	}

	, 
	elements1: function (name) {
		return this.elementsImpl(name);
	}

	, 
	elementsImpl: function (name) {
		var elements = new $.ig.List$1($.ig.XElement.prototype.$type, 0);
		for (var i = 0; i < this.backingNode().childNodes.length; i++) {
			var currNode = this.backingNode().childNodes.item(i);
			if (currNode.nodeType == $.ig.XmlNodeType.prototype.element) {
				var match = false;
				if (name != null) {
					if ($.ig.XmlUtils.prototype.getLocalName(currNode) == name.localName() && currNode.namespaceURI == name.namespaceName()) {
						match = true;
					}


				} else {
					match = true;
				}

				if (match) {
					elements.add1(new $.ig.XElement(0, currNode));
				}

			}

		}

		return elements;
	}

	, 
	add: function (content) {
		var node = this.backingNode();
		var doc;
		if ($.ig.util.cast($.ig.XDocument.prototype.$type, this) !== null) {
			doc = this.backingNode();

		} else {
			doc = this.backingNode().ownerDocument;
		}

		if ($.ig.util.cast($.ig.XAttribute.prototype.$type, content) !== null) {
			(content).attachToElement(node);

		} else if ($.ig.util.cast($.ig.XElement.prototype.$type, content) !== null) {
			(content).attachToNode(node, doc);
		}


	}
	, 
	$type: new $.ig.Type('XContainer', $.ig.XNode.prototype.$type)
}, true);

$.ig.util.defType('XDocument', 'XContainer', {
	init: function (initNumber, doc) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.XContainer.prototype.init.call(this, doc);
	}
	, 
	init1: function (initNumber) {



		$.ig.XContainer.prototype.init.call(this, $.ig.XmlUtils.prototype.createDocument());
	}

	, 
	nodeType: function () {

			return $.ig.XmlNodeType.prototype.document;
	}

	, 
	parse: function (text) {
		return new $.ig.XDocument(0, $.ig.XmlUtils.prototype.parseXml(text));
	}
	, 
	$type: new $.ig.Type('XDocument', $.ig.XContainer.prototype.$type)
}, true);

$.ig.util.defType('XElement', 'XContainer', {
	init: function (initNumber, element) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
				case 2:
					this.init2.apply(this, arguments);
					break;
			}
			return;
		}


		$.ig.XContainer.prototype.init.call(this, element);
	}
	, 
	init1: function (initNumber, name) {



		$.ig.XElement.prototype.init2.call(this, 2, name, null);
	}
	, 
	init2: function (initNumber, name, content) {



		$.ig.XContainer.prototype.init.call(this, $.ig.XmlUtils.prototype.createDetachedElement(name.localName(), name.namespaceName()));
			var value = content == null ? "" : content.toString();
			this.value(value);
	}

	, 
	value: function (value) {
		if (arguments.length === 1) {

			$.ig.XmlUtils.prototype.setInnerText(this.backingNode(), value);
			return value;
		} else {

			return $.ig.XmlUtils.prototype.getInnerText(this.backingNode());
		}
	}

	, 
	nodeType: function () {

			return $.ig.XmlNodeType.prototype.element;
	}

	, 
	name: function () {

			return $.ig.XName.prototype.get($.ig.XmlUtils.prototype.getLocalName(this.backingNode()), this.backingNode().namespaceURI);
	}

	, 
	attribute: function (name) {
		return new $.ig.XAttribute($.ig.XmlUtils.prototype.getAttributeNode(this.backingNode(), name.localName(), name.namespaceName()));
	}

	, 
	attachToNode: function (node, doc) {
		if (this.backingNode().ownerDocument != doc) {
			this.backingNode($.ig.XmlUtils.prototype.importNode(doc, this.backingNode()));
		}

		node.appendChild(this.backingNode());
	}
	, 
	$type: new $.ig.Type('XElement', $.ig.XContainer.prototype.$type)
}, true);

$.ig.util.defType('XmlUtils', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	isW3CDom: function () {
		return !!window.DOMParser;
	}

	, 
	parseW3CDom: function (text) {
		var text_ = text;
		return (new DOMParser()).parseFromString(text_, 'text/xml');
	}

	, 
	parseMSXmlDom: function (text) {
		var text_ = text;
		return (function (xml) {
    var xmlDoc = new ActiveXObject('Microsoft.XMLDOM');
    xmlDoc.async = false;
    xmlDoc.loadXML(xml);
    return xmlDoc;
})(text_);;
	}

	, 
	w3CDomNodeToString: function (node) {
		var node_ = node;
		return (new XMLSerializer()).serializeToString(node_);
	}

	, 
	mSXmlDomNodeToString: function (node) {
		var node_ = node;
		return node_.xml;
	}

	, 
	createMSXmlDom: function () {
		return new ActiveXObject('Microsoft.XMLDOM');
	}

	, 
	parseXml: function (text) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return $.ig.XmlUtils.prototype.parseW3CDom(text);

		} else {
			return $.ig.XmlUtils.prototype.parseMSXmlDom(text);
		}

	}

	, 
	xmlNodeToString: function (node) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return $.ig.XmlUtils.prototype.w3CDomNodeToString(node);

		} else {
			return $.ig.XmlUtils.prototype.mSXmlDomNodeToString(node);
		}

	}

	, 
	createDocument: function () {
		var doc;
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			doc = $.ig.XmlUtils.prototype.parseW3CDom("<dummy/>");
			doc.removeChild(doc.documentElement);

		} else {
			doc = $.ig.XmlUtils.prototype.createMSXmlDom();
		}

		return doc;
	}

	, 
	createDetachedElement: function (localName, namespaceName) {
		var doc_ = $.ig.XmlUtils.prototype.createDocument();
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return doc_.createElementNS(namespaceName, localName);

		} else {
			var name_ = localName;
			var namespaceURI_ = namespaceName;
			return doc_.createNode(1/*NODE_ELEMENT*/, name_, namespaceURI_);
		}

	}

	, 
	getInnerText: function (node) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return node.textContent;

		} else {
			var node_ = node;
			return node_.text;
		}

	}

	, 
	setInnerText: function (node, text) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			node.textContent = text;

		} else {
			var node_ = node;
			var text_ = text;
			node_.text = text_;
		}

	}

	, 
	importNode: function (doc, node) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return doc.importNode(node, true);

		} else {
			return node;
		}

	}

	, 
	getLocalName: function (node) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return node.localName;

		} else {
			var node_ = node;
			return node_.baseName;
		}

	}

	, 
	getAttributeNode: function (element, localName, namespaceName) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return element.getAttributeNodeNS(namespaceName, localName);

		} else {
			var elem_ = element;
			var ln_ = localName;
			var nn_ = namespaceName;
			return elem_.attributes.getQualifiedItem(ln_, nn_);
		}

	}

	, 
	getAttributeValue: function (attr) {
		if ($.ig.XmlUtils.prototype.isW3CDom()) {
			return attr.nodeValue;

		} else {
			var attr_ = attr;
			return attr_.value;
		}

	}
	, 
	$type: new $.ig.Type('XmlUtils', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XName', 'Object', {
	__localName: null
	, 
	__namespaceName: null
	, 
	init: function (localName, namespaceName) {



		$.ig.Object.prototype.init.call(this);
			this.__localName = localName;
			this.__namespaceName = namespaceName;
	}

	, 
	localName: function () {

			return this.__localName;
	}

	, 
	namespaceName: function () {

			return this.__namespaceName;
	}

	, 
	namespace: function () {

			return $.ig.XNamespace.prototype.get(this.__namespaceName);
	}

	, 
	get: function (localName, namespaceName) {
		return new $.ig.XName(localName, namespaceName);
	}
	, 
	$type: new $.ig.Type('XName', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('XNamespace', 'Object', {
	__namespaceName: null
	, 
	init: function (namespaceName) {



		$.ig.Object.prototype.init.call(this);
			this.__namespaceName = namespaceName;
	}

	, 
	get: function (namespaceName) {
		return new $.ig.XNamespace(namespaceName);
	}

	, 
	xmlns: function () {

			return $.ig.XNamespace.prototype.get("http://www.w3.org/2000/xmlns/");
	}

	, 
	namespaceName: function () {

			return this.__namespaceName;
	}
	, 
	$type: new $.ig.Type('XNamespace', $.ig.Object.prototype.$type)
}, true);













$.ig.TaskStatus.prototype.created = 0;
$.ig.TaskStatus.prototype.ranToCompletion = 5;
$.ig.TaskStatus.prototype.canceled = 6;
$.ig.TaskStatus.prototype.faulted = 7;


$.ig.ListSortDirection.prototype.ascending = 0;
$.ig.ListSortDirection.prototype.descending = 1;


$.ig.NotifyCollectionChangedAction.prototype.add = 0;
$.ig.NotifyCollectionChangedAction.prototype.remove = 1;
$.ig.NotifyCollectionChangedAction.prototype.replace = 2;
$.ig.NotifyCollectionChangedAction.prototype.reset = 4;




$.ig.Encoding.prototype._utfEncoding = null;
$.ig.Encoding.prototype._unicodeEncoding = null;



$.ig.util.extCopy($.ig.Queryable, [[[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.ICollection$1, $.ig.IEnumerable$1, $.ig.IList$1, $.ig.List$1, $.ig.IEnumerable, $.ig.ICollection, $.ig.IList, $.ig.Array, $.ig.Dictionary, $.ig.XmlNodeList, $.ig.XmlNamedNodeMap, $.ig.AbstractEnumerable, $.ig.IDictionary$2, $.ig.Dictionary$2, $.ig.GenericEnumerable$1, $.ig.ReadOnlyCollection$1, $.ig.Stack$1, $.ig.IOrderedEnumerable$1], ['asQueryable']]]);
$.ig.util.extCopy($.ig.Enumerable, [[[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.ICollection$1, $.ig.IEnumerable$1, $.ig.IList$1, $.ig.List$1, $.ig.IDictionary$2, $.ig.Dictionary$2, $.ig.GenericEnumerable$1, $.ig.ReadOnlyCollection$1, $.ig.Stack$1, $.ig.IOrderedEnumerable$1], ['where$1', 'where$11', 'select$2', 'selectMany$2', 'last$1', 'first$1', 'firstOrDefault$1', 'orderBy$2', 'orderByDescending$2', 'toList$1', 'concat$1', 'max', 'max$1', 'min', 'min$1', 'count$1', 'reverse$1', 'take$1', 'skip$1', 'any$1', 'contains$1', 'union$1', 'toArray$1', 'elementAt$1', 'sum', 'sum$1']], [[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.ICollection$1, $.ig.IEnumerable$1, $.ig.IList$1, $.ig.List$1, $.ig.IEnumerable, $.ig.ICollection, $.ig.IList, $.ig.Array, $.ig.Dictionary, $.ig.XmlNodeList, $.ig.XmlNamedNodeMap, $.ig.AbstractEnumerable, $.ig.IDictionary$2, $.ig.Dictionary$2, $.ig.GenericEnumerable$1, $.ig.ReadOnlyCollection$1, $.ig.Stack$1, $.ig.IOrderedEnumerable$1], ['ofType$1', 'cast$1']]]);

} (jQuery));


// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["ICoreOlapElement:a", 
"String:b", 
"Object:c", 
"Type:d", 
"Boolean:e", 
"ValueType:f", 
"Void:g", 
"RuntimeTypeHandle:h", 
"MethodInfo:i", 
"MethodBase:j", 
"MemberInfo:k", 
"ParameterInfo:l", 
"TypeCode:m", 
"Enum:n", 
"Number:o", 
"IComparable:p", 
"Number:q", 
"Single:r", 
"Number:s", 
"ConstructorInfo:t", 
"String:u", 
"Array:v", 
"RegExp:w", 
"Cube:x", 
"CubeType:y", 
"Date:z", 
"Date:aa", 
"Number:ab", 
"Catalog:ac", 
"Dimension:ad", 
"DimensionType:ae", 
"KpiDimension:af", 
"HierarchyOrigin:ai", 
"AggregatorType:aj", 
"CardinalityType:ak", 
"MemberType:al", 
"Hierarchy:am", 
"Kpi:an", 
"Level:ao", 
"Measure:ap", 
"KpiMeasure:aq", 
"MeasureGroup:ar", 
"MeasureGroupDimension:as", 
"Member:at", 
"Nullable$1:au", 
"OlapResult:av", 
"IList$1:aw", 
"ICollection$1:ax", 
"IEnumerable$1:ay", 
"IEnumerable:az", 
"IEnumerator:a0", 
"IEnumerator$1:a1", 
"OlapResultAxis:a2", 
"PositionResolver$2:a3", 
"List$1:a4", 
"IArrayList:a5", 
"Array:a6", 
"ICollection:a7", 
"CompareCallback:a8", 
"MulticastDelegate:a9", 
"IntPtr:ba", 
"IList:bb", 
"IDisposable:bc", 
"IArray:bd", 
"Script:be", 
"Func$3:bf", 
"Action$1:bg", 
"PositionItemInfo$2:bh", 
"Dictionary$2:bi", 
"IDictionary$2:bj", 
"IDictionary:bk", 
"Dictionary:bl", 
"IEqualityComparer$1:bm", 
"KeyValuePair$2:bn", 
"NotImplementedException:bo", 
"Error:bp", 
"IHierarchicalPositionItem$2:bq", 
"IPositionItem$2:br", 
"IPosition$2:bs", 
"Math:bt", 
"Number:bu", 
"Number:bv", 
"Number:bw", 
"Number:bx", 
"Number:by", 
"Number:bz", 
"Number:b0", 
"Enumerable:b1", 
"Func$2:b2", 
"IOrderedEnumerable$1:b3", 
"SortedList$1:b4", 
"ArgumentNullException:b5", 
"EventHandler$1:b6", 
"Delegate:b7", 
"ListSortDirection:b8", 
"OlapResultTuple:b9", 
"ReadOnlyCollection$1:ca", 
"OlapResultAxisMember:cb", 
"OlapResultCell:cc", 
"IConnection:cd", 
"IOlapDataProviderFactory:ce", 
"IOlapDiscoverDataProvider:cf", 
"Task$1:cg", 
"Task:ch", 
"JQueryPromise:ci", 
"Action:cj", 
"AggregateException:ck", 
"TaskStatus:cl", 
"TaskCompletionSource$1:cm", 
"JQueryDeferred:cn", 
"JQuery:co", 
"JQueryObject:cp", 
"Element:cq", 
"ElementAttributeCollection:cr", 
"ElementCollection:cs", 
"WebStyle:ct", 
"ElementNodeType:cu", 
"Document:cv", 
"EventListener:cw", 
"IElementEventHandler:cx", 
"ElementEventHandler:cy", 
"ElementAttribute:cz", 
"JQueryPosition:c0", 
"JQueryCallback:c1", 
"JQueryEvent:c2", 
"JQueryUICallback:c3", 
"IOlapExecuteCommandProvider:c4", 
"HeaderCellsLayoutOrientation:c5", 
"LevelSpanManager:c6", 
"SpanSource:c7", 
"ITableViewHeadersFactory:c8", 
"TableViewHeadersFactory:c9", 
"ArrayListCollection$1:da", 
"INotifyCollectionChanged:db", 
"NotifyCollectionChangedEventHandler:dc", 
"NotifyCollectionChangedEventArgs:dd", 
"EventArgs:de", 
"NotifyCollectionChangedAction:df", 
"TableViewHeaderCellSource:dg", 
"OlapTableViewHeaderCell:dh", 
"TableCompactViewHeadersFactory:di", 
"TableViewImpl:dj", 
"TableViewSettings:dk", 
"ResultHeaderSorter:dl", 
"ResultSorter$1:dm", 
"AxisTupleVisitor:dn", 
"LevelSortDirection:dp", 
"LevelSortBehavior:dq", 
"AxisHeaderSortingVisitor:dr", 
"TupleSortDirection:ds", 
"ResultColumnValueSorter:dt", 
"AxisValueSortingVisitor:du", 
"OlapTableViewResultCell:dv", 
"OlapResultView:dw", 
"InvalidOperationException:dx", 
"ResultViewHelper:dy", 
"IOlapDataSource:dz", 
"OlapMetadataTreeItem:d0", 
"OlapMetadataTreeItemType:d1", 
"MeasureListLocation:d2", 
"MeasureList:d3", 
"OlapDataSource:d4", 
"DataSourceBaseOptions:d5", 
"CubeMetaItemsCache:d6", 
"MeasureGroupMetaItemsCache:d7", 
"Tuple$2:d8", 
"NotSupportedException:d9", 
"PositionInfo:ea", 
"TaskExtensions:eb", 
"AxisElement:ec", 
"AxisDefinitionParser:ed", 
"Debug:ee", 
"TaskFactory:ef", 
"MetaTreeHelper:eg", 
"HierarchyItemPosition:eh", 
"CoreOlapElementParser:el", 
"KeyValueItem:eu", 
"HierarchyFilterView:ev", 
"FilterMember:ew", 
"INotifyPropertyChanged:ex", 
"PropertyChangedEventHandler:ey", 
"PropertyChangedEventArgs:ez", 
"FilterMemberStateChangedEventArgs:e0", 
"DataSourceBase:e1", 
"jQueryUtils:e2", 
"OlapUtilities:e3", 
"OlapTableView:e4", 
"AbstractEnumerable:e5", 
"Func$1:e6", 
"AbstractEnumerator:e7", 
"GenericEnumerable$1:e8", 
"GenericEnumerator$1:e9"]);

$.ig.util.defType('LevelSortBehavior', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('LevelSortBehavior', $.ig.Enum.prototype.$type)
}, true);





$.ig.util.defType('OlapMetadataTreeItemType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('OlapMetadataTreeItemType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('MeasureListLocation', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MeasureListLocation', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('HeaderCellsLayoutOrientation', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('HeaderCellsLayoutOrientation', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('MemberType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('MemberType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('CardinalityType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('CardinalityType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('AggregatorType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('AggregatorType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('HierarchyOrigin', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('HierarchyOrigin', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('DimensionType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('DimensionType', $.ig.Enum.prototype.$type)
}, true);


$.ig.util.defType('CubeType', 'Enum', {
	init: function () {

		$.ig.Enum.prototype.init.call(this);

	}, 
	$type: new $.ig.Type('CubeType', $.ig.Enum.prototype.$type)
}, true);

$.ig.util.defType('ICoreOlapElement', 'Object', {
	$type: new $.ig.Type('ICoreOlapElement', null)
}, true);

$.ig.util.defType('Cube', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_catalogName: null,
	catalogName: function (value) {
		if (arguments.length === 1) {
			this._catalogName = value;
			return value;
		} else {
			return this._catalogName;
		}
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_cubeType: null,
	cubeType: function (value) {
		if (arguments.length === 1) {
			this._cubeType = value;
			return value;
		} else {
			return this._cubeType;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_lastProcessed: null,
	lastProcessed: function (value) {
		if (arguments.length === 1) {
			this._lastProcessed = value;
			return value;
		} else {
			return this._lastProcessed;
		}
	}

	, 
	_lastUpdated: null,
	lastUpdated: function (value) {
		if (arguments.length === 1) {
			this._lastUpdated = value;
			return value;
		} else {
			return this._lastUpdated;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	uniqueName: function (value) {
		if (arguments.length === 1) {

			this.name(value);
			return value;
		} else {

			return this.name();
		}
	}
	, 
	$type: new $.ig.Type('Cube', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('Catalog', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}
	, 
	$type: new $.ig.Type('Catalog', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('Dimension', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_dimensionType: null,
	dimensionType: function (value) {
		if (arguments.length === 1) {
			this._dimensionType = value;
			return value;
		} else {
			return this._dimensionType;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_defaultHierarchy: null,
	defaultHierarchy: function (value) {
		if (arguments.length === 1) {
			this._defaultHierarchy = value;
			return value;
		} else {
			return this._defaultHierarchy;
		}
	}
	, 
	$type: new $.ig.Type('Dimension', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('KpiDimension', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}
	, 
	$type: new $.ig.Type('KpiDimension', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('Hierarchy', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_defaultHierarchy: null,
	defaultHierarchy: function (value) {
		if (arguments.length === 1) {
			this._defaultHierarchy = value;
			return value;
		} else {
			return this._defaultHierarchy;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_defaultMember: null,
	defaultMember: function (value) {
		if (arguments.length === 1) {
			this._defaultMember = value;
			return value;
		} else {
			return this._defaultMember;
		}
	}

	, 
	_allMember: null,
	allMember: function (value) {
		if (arguments.length === 1) {
			this._allMember = value;
			return value;
		} else {
			return this._allMember;
		}
	}

	, 
	_dimensionUniqueName: null,
	dimensionUniqueName: function (value) {
		if (arguments.length === 1) {
			this._dimensionUniqueName = value;
			return value;
		} else {
			return this._dimensionUniqueName;
		}
	}

	, 
	_hierarchyOrigin: null,
	hierarchyOrigin: function (value) {
		if (arguments.length === 1) {
			this._hierarchyOrigin = value;
			return value;
		} else {
			return this._hierarchyOrigin;
		}
	}

	, 
	_hierarchyDisplayFolder: null,
	hierarchyDisplayFolder: function (value) {
		if (arguments.length === 1) {
			this._hierarchyDisplayFolder = value;
			return value;
		} else {
			return this._hierarchyDisplayFolder;
		}
	}
	, 
	$type: new $.ig.Type('Hierarchy', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('Kpi', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_measureGroupName: null,
	measureGroupName: function (value) {
		if (arguments.length === 1) {
			this._measureGroupName = value;
			return value;
		} else {
			return this._measureGroupName;
		}
	}

	, 
	_kpiDisplayFolder: null,
	kpiDisplayFolder: function (value) {
		if (arguments.length === 1) {
			this._kpiDisplayFolder = value;
			return value;
		} else {
			return this._kpiDisplayFolder;
		}
	}

	, 
	_kpiValue: null,
	kpiValue: function (value) {
		if (arguments.length === 1) {
			this._kpiValue = value;
			return value;
		} else {
			return this._kpiValue;
		}
	}

	, 
	_kpiGoal: null,
	kpiGoal: function (value) {
		if (arguments.length === 1) {
			this._kpiGoal = value;
			return value;
		} else {
			return this._kpiGoal;
		}
	}

	, 
	_kpiStatus: null,
	kpiStatus: function (value) {
		if (arguments.length === 1) {
			this._kpiStatus = value;
			return value;
		} else {
			return this._kpiStatus;
		}
	}

	, 
	_kpiTrend: null,
	kpiTrend: function (value) {
		if (arguments.length === 1) {
			this._kpiTrend = value;
			return value;
		} else {
			return this._kpiTrend;
		}
	}

	, 
	_kpiStatusGraphic: null,
	kpiStatusGraphic: function (value) {
		if (arguments.length === 1) {
			this._kpiStatusGraphic = value;
			return value;
		} else {
			return this._kpiStatusGraphic;
		}
	}

	, 
	_kpiTrendGraphic: null,
	kpiTrendGraphic: function (value) {
		if (arguments.length === 1) {
			this._kpiTrendGraphic = value;
			return value;
		} else {
			return this._kpiTrendGraphic;
		}
	}

	, 
	_kpiWeight: null,
	kpiWeight: function (value) {
		if (arguments.length === 1) {
			this._kpiWeight = value;
			return value;
		} else {
			return this._kpiWeight;
		}
	}

	, 
	_parentKpiName: null,
	parentKpiName: function (value) {
		if (arguments.length === 1) {
			this._parentKpiName = value;
			return value;
		} else {
			return this._parentKpiName;
		}
	}

	, 
	_currentTimeMember: null,
	currentTimeMember: function (value) {
		if (arguments.length === 1) {
			this._currentTimeMember = value;
			return value;
		} else {
			return this._currentTimeMember;
		}
	}
	, 
	$type: new $.ig.Type('Kpi', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('Level', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_depth: 0,
	depth: function (value) {
		if (arguments.length === 1) {
			this._depth = value;
			return value;
		} else {
			return this._depth;
		}
	}

	, 
	_hierarchyUniqueName: null,
	hierarchyUniqueName: function (value) {
		if (arguments.length === 1) {
			this._hierarchyUniqueName = value;
			return value;
		} else {
			return this._hierarchyUniqueName;
		}
	}

	, 
	_dimensionUniqueName: null,
	dimensionUniqueName: function (value) {
		if (arguments.length === 1) {
			this._dimensionUniqueName = value;
			return value;
		} else {
			return this._dimensionUniqueName;
		}
	}

	, 
	_membersCount: 0,
	membersCount: function (value) {
		if (arguments.length === 1) {
			this._membersCount = value;
			return value;
		} else {
			return this._membersCount;
		}
	}

	, 
	_levelOrigin: 0,
	levelOrigin: function (value) {
		if (arguments.length === 1) {
			this._levelOrigin = value;
			return value;
		} else {
			return this._levelOrigin;
		}
	}

	, 
	_levelOrderingProperty: null,
	levelOrderingProperty: function (value) {
		if (arguments.length === 1) {
			this._levelOrderingProperty = value;
			return value;
		} else {
			return this._levelOrderingProperty;
		}
	}
	, 
	$type: new $.ig.Type('Level', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('Measure', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_measureGroupName: null,
	measureGroupName: function (value) {
		if (arguments.length === 1) {
			this._measureGroupName = value;
			return value;
		} else {
			return this._measureGroupName;
		}
	}

	, 
	_aggregatorType: null,
	aggregatorType: function (value) {
		if (arguments.length === 1) {
			this._aggregatorType = value;
			return value;
		} else {
			return this._aggregatorType;
		}
	}

	, 
	_defaultFormatString: null,
	defaultFormatString: function (value) {
		if (arguments.length === 1) {
			this._defaultFormatString = value;
			return value;
		} else {
			return this._defaultFormatString;
		}
	}

	, 
	_measureDisplayFolder: null,
	measureDisplayFolder: function (value) {
		if (arguments.length === 1) {
			this._measureDisplayFolder = value;
			return value;
		} else {
			return this._measureDisplayFolder;
		}
	}
	, 
	$type: new $.ig.Type('Measure', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('KpiMeasure', 'Measure', {
	init: function (uniqueName, caption) {



		$.ig.Measure.prototype.init.call(this);
			this.uniqueName(uniqueName);
			this.caption(caption);
	}

	, 
	_graphic: null,
	graphic: function (value) {
		if (arguments.length === 1) {
			this._graphic = value;
			return value;
		} else {
			return this._graphic;
		}
	}

	, 
	createKpiValueMeasure: function (kpi) {
		return new $.ig.KpiMeasure(kpi.kpiValue(), kpi.caption() + " Value");
	}

	, 
	createKpiGoalMeasure: function (kpi) {
		return new $.ig.KpiMeasure(kpi.kpiGoal(), kpi.caption() + " Goal");
	}

	, 
	createKpiWeightMeasure: function (kpi) {
		return new $.ig.KpiMeasure(kpi.kpiWeight(), kpi.caption() + " Weight");
	}

	, 
	createKpiStatusMeasure: function (kpi) {
		var measure = new $.ig.KpiMeasure(kpi.kpiStatus(), kpi.caption() + " Status");
		measure.graphic(kpi.kpiStatusGraphic());
		return measure;
	}

	, 
	createKpiTrendMeasure: function (kpi) {
		var measure = new $.ig.KpiMeasure(kpi.kpiTrend(), kpi.caption() + " Trend");
		measure.graphic(kpi.kpiTrendGraphic());
		return measure;
	}
	, 
	$type: new $.ig.Type('KpiMeasure', $.ig.Measure.prototype.$type)
}, true);

$.ig.util.defType('MeasureGroup', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_cubeName: null,
	cubeName: function (value) {
		if (arguments.length === 1) {
			this._cubeName = value;
			return value;
		} else {
			return this._cubeName;
		}
	}

	, 
	_catalogName: null,
	catalogName: function (value) {
		if (arguments.length === 1) {
			this._catalogName = value;
			return value;
		} else {
			return this._catalogName;
		}
	}

	, 
	uniqueName: function (value) {
		if (arguments.length === 1) {

			this.name(value);
			return value;
		} else {

			return this.name();
		}
	}
	, 
	$type: new $.ig.Type('MeasureGroup', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('MeasureGroupDimension', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_cubeName: null,
	cubeName: function (value) {
		if (arguments.length === 1) {
			this._cubeName = value;
			return value;
		} else {
			return this._cubeName;
		}
	}

	, 
	_catalogName: null,
	catalogName: function (value) {
		if (arguments.length === 1) {
			this._catalogName = value;
			return value;
		} else {
			return this._catalogName;
		}
	}

	, 
	_measureGroupName: null,
	measureGroupName: function (value) {
		if (arguments.length === 1) {
			this._measureGroupName = value;
			return value;
		} else {
			return this._measureGroupName;
		}
	}

	, 
	_dimensionUniqueName: null,
	dimensionUniqueName: function (value) {
		if (arguments.length === 1) {
			this._dimensionUniqueName = value;
			return value;
		} else {
			return this._dimensionUniqueName;
		}
	}

	, 
	_measureGroupCardinality: null,
	measureGroupCardinality: function (value) {
		if (arguments.length === 1) {
			this._measureGroupCardinality = value;
			return value;
		} else {
			return this._measureGroupCardinality;
		}
	}

	, 
	_dimensionCardinality: null,
	dimensionCardinality: function (value) {
		if (arguments.length === 1) {
			this._dimensionCardinality = value;
			return value;
		} else {
			return this._dimensionCardinality;
		}
	}

	, 
	_isDimensionVisible: false,
	isDimensionVisible: function (value) {
		if (arguments.length === 1) {
			this._isDimensionVisible = value;
			return value;
		} else {
			return this._isDimensionVisible;
		}
	}

	, 
	_isFactDimension: false,
	isFactDimension: function (value) {
		if (arguments.length === 1) {
			this._isFactDimension = value;
			return value;
		} else {
			return this._isFactDimension;
		}
	}

	, 
	_dimensionPath: null,
	dimensionPath: function (value) {
		if (arguments.length === 1) {
			this._dimensionPath = value;
			return value;
		} else {
			return this._dimensionPath;
		}
	}

	, 
	_dimensionGranularity: null,
	dimensionGranularity: function (value) {
		if (arguments.length === 1) {
			this._dimensionGranularity = value;
			return value;
		} else {
			return this._dimensionGranularity;
		}
	}
	, 
	$type: new $.ig.Type('MeasureGroupDimension', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('Member', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			var nullValue = $.ig.util.toNullable($.ig.Number.prototype.$type, null);
			this.scope(nullValue);
	}

	, 
	_cubeName: null,
	cubeName: function (value) {
		if (arguments.length === 1) {
			this._cubeName = value;
			return value;
		} else {
			return this._cubeName;
		}
	}

	, 
	_catalogName: null,
	catalogName: function (value) {
		if (arguments.length === 1) {
			this._catalogName = value;
			return value;
		} else {
			return this._catalogName;
		}
	}

	, 
	_dimensionUniqueName: null,
	dimensionUniqueName: function (value) {
		if (arguments.length === 1) {
			this._dimensionUniqueName = value;
			return value;
		} else {
			return this._dimensionUniqueName;
		}
	}

	, 
	_hierarchyUniqueName: null,
	hierarchyUniqueName: function (value) {
		if (arguments.length === 1) {
			this._hierarchyUniqueName = value;
			return value;
		} else {
			return this._hierarchyUniqueName;
		}
	}

	, 
	_levelUniqueName: null,
	levelUniqueName: function (value) {
		if (arguments.length === 1) {
			this._levelUniqueName = value;
			return value;
		} else {
			return this._levelUniqueName;
		}
	}

	, 
	_levelDepth: 0,
	levelDepth: function (value) {
		if (arguments.length === 1) {
			this._levelDepth = value;
			return value;
		} else {
			return this._levelDepth;
		}
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_memberType: null,
	memberType: function (value) {
		if (arguments.length === 1) {
			this._memberType = value;
			return value;
		} else {
			return this._memberType;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_childrenCardinality: 0,
	childrenCardinality: function (value) {
		if (arguments.length === 1) {
			this._childrenCardinality = value;
			return value;
		} else {
			return this._childrenCardinality;
		}
	}

	, 
	_parentLevel: 0,
	parentLevel: function (value) {
		if (arguments.length === 1) {
			this._parentLevel = value;
			return value;
		} else {
			return this._parentLevel;
		}
	}

	, 
	_parentUniqueName: null,
	parentUniqueName: function (value) {
		if (arguments.length === 1) {
			this._parentUniqueName = value;
			return value;
		} else {
			return this._parentUniqueName;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_scope: $.ig.util.toNullable($.ig.Number.prototype.$type, null),
	scope: function (value) {
		if (arguments.length === 1) {
			this._scope = value;
			return value;
		} else {
			return this._scope;
		}
	}
	, 
	$type: new $.ig.Type('Member', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('OlapResult', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_isEmpty: false,
	isEmpty: function (value) {
		if (arguments.length === 1) {
			this._isEmpty = value;
			return value;
		} else {
			return this._isEmpty;
		}
	}

	, 
	_axes: null,
	axes: function (value) {
		if (arguments.length === 1) {
			this._axes = value;
			return value;
		} else {
			return this._axes;
		}
	}

	, 
	_cells: null,
	cells: function (value) {
		if (arguments.length === 1) {
			this._cells = value;
			return value;
		} else {
			return this._cells;
		}
	}
	, 
	$type: new $.ig.Type('OlapResult', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapResultAxis', 'Object', {
	init: function (tuples, tupleSize) {



		$.ig.Object.prototype.init.call(this);
			this.tuples(tuples.toList$1($.ig.OlapResultTuple.prototype.$type));
			this.tupleSize(tupleSize);
			this.positionResolver(new $.ig.PositionResolver$2(String, $.ig.Object.prototype.$type, tuples, tupleSize));
	}

	, 
	_positionResolver: null,
	positionResolver: function (value) {
		if (arguments.length === 1) {
			this._positionResolver = value;
			return value;
		} else {
			return this._positionResolver;
		}
	}

	, 
	clone: function () {
		var $self = this;
		var tuples = new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 0);
		var en = $self.tuples().getEnumerator();
		while (en.moveNext()) {
			var tuple = en.current();
			tuples.add(tuple.clone());
		}

		return (function () { var $ret = new $.ig.OlapResultAxis(tuples, $self.tupleSize());
		$ret.name($self.name()); return $ret;}());
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_tupleSize: 0,
	tupleSize: function (value) {
		if (arguments.length === 1) {
			this._tupleSize = value;
			return value;
		} else {
			return this._tupleSize;
		}
	}

	, 
	_tuples: null,
	tuples: function (value) {
		if (arguments.length === 1) {
			this._tuples = value;
			return value;
		} else {
			return this._tuples;
		}
	}
	, 
	$type: new $.ig.Type('OlapResultAxis', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IPosition$2', 'Object', {
	$type: new $.ig.Type('IPosition$2', null)
}, true);

$.ig.util.defType('OlapResultTuple', 'Object', {
	init: function (members) {



		$.ig.Object.prototype.init.call(this);
			this.members(new $.ig.ReadOnlyCollection$1($.ig.OlapResultAxisMember.prototype.$type, 1, members));
	}

	, 
	_members: null,
	members: function (value) {
		if (arguments.length === 1) {
			this._members = value;
			return value;
		} else {
			return this._members;
		}
	}

	, 
	getItems: function () {
		return this.members();
	}

	, 
	itemsCount: function () {

			return this.members().count();
	}

	, 
	indexOf: function (positionItem) {
		return this.members().indexOf(positionItem);
	}

	, 
	item: function (itemIndex) {

			return this.members().item(itemIndex);
	}

	, 
	isEmpty: function () {

			return false;
	}

	, 
	clone: function () {
		var axisMembers = new $.ig.List$1($.ig.OlapResultAxisMember.prototype.$type, 0);
		var en = this.members().getEnumerator();
		while (en.moveNext()) {
			var axisMember = en.current();
			axisMembers.add(axisMember.clone());
		}

		var tuple = new $.ig.OlapResultTuple(axisMembers);
		var en1 = axisMembers.getEnumerator();
		while (en1.moveNext()) {
			var axisMember1 = en1.current();
			axisMember1.position(tuple);
		}

		return tuple;
	}
	, 
	$type: new $.ig.Type('OlapResultTuple', $.ig.Object.prototype.$type, [$.ig.IPosition$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)])
}, true);

$.ig.util.defType('IPositionItem$2', 'Object', {
	$type: new $.ig.Type('IPositionItem$2', null)
}, true);

$.ig.util.defType('IHierarchicalPositionItem$2', 'Object', {
	$type: new $.ig.Type('IHierarchicalPositionItem$2', null, [$.ig.IPositionItem$2.prototype.$type.specialize(0, 1)])
}, true);

$.ig.util.defType('OlapResultAxisMember', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.properties(new $.ig.Dictionary$2(String, String, 0));
			this.ordinal(-1);
	}

	, 
	_uniqueName: null,
	uniqueName: function (value) {
		if (arguments.length === 1) {
			this._uniqueName = value;
			return value;
		} else {
			return this._uniqueName;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_levelUniqueName: null,
	levelUniqueName: function (value) {
		if (arguments.length === 1) {
			this._levelUniqueName = value;
			return value;
		} else {
			return this._levelUniqueName;
		}
	}

	, 
	_hierarchyUniqueName: null,
	hierarchyUniqueName: function (value) {
		if (arguments.length === 1) {
			this._hierarchyUniqueName = value;
			return value;
		} else {
			return this._hierarchyUniqueName;
		}
	}

	, 
	_levelNumber: 0,
	levelNumber: function (value) {
		if (arguments.length === 1) {
			this._levelNumber = value;
			return value;
		} else {
			return this._levelNumber;
		}
	}

	, 
	_displayInfo: null,
	displayInfo: function (value) {
		if (arguments.length === 1) {
			this._displayInfo = value;
			return value;
		} else {
			return this._displayInfo;
		}
	}

	, 
	childCount: function () {

			return ((this.displayInfo() & ~65536) & ~131072);
	}

	, 
	drilledDown: function () {

			return (this.displayInfo() & 65536) == 65536;
	}

	, 
	parentSameAsPrev: function () {

			return (this.displayInfo() & 131072) == 131072;
	}

	, 
	_properties: null,
	properties: function (value) {
		if (arguments.length === 1) {
			this._properties = value;
			return value;
		} else {
			return this._properties;
		}
	}

	, 
	_position: null,
	position: function (value) {
		if (arguments.length === 1) {
			this._position = value;
			return value;
		} else {
			return this._position;
		}
	}

	, 
	key: function () {

			return this.uniqueName();
	}

	, 
	sortKey: function () {

			if (this.ordinal() > -1) {
				return this.ordinal();
			}

			var decimalValue = parseFloat(this.caption());
			if (!isNaN(decimalValue)) {
				return decimalValue;
			}

			return this.caption();
	}

	, 
	_ordinal: 0,
	ordinal: function (value) {
		if (arguments.length === 1) {
			this._ordinal = value;
			return value;
		} else {
			return this._ordinal;
		}
	}

	, 
	hierarchyKey: function () {

			return this.hierarchyUniqueName();
	}

	, 
	hierarchyLevelKey: function () {

			return this.levelUniqueName();
	}

	, 
	parentKey: function () {

			var $self = this;
			var parentKey;
			(function () { var $ret = $self.properties().tryGetValue("PARENT_UNIQUE_NAME", parentKey); parentKey = $ret.value; return $ret.ret; }());
			return parentKey;
	}

	, 
	depth: function () {

			return this.levelNumber();
	}

	, 
	isExpandable: function () {

			return this.childCount() > 0;
	}

	, 
	clone: function () {
		var axisMember = new $.ig.OlapResultAxisMember();
		axisMember.caption(this.caption());
		axisMember.displayInfo(this.displayInfo());
		axisMember.hierarchyUniqueName(this.hierarchyUniqueName());
		axisMember.levelNumber(this.levelNumber());
		axisMember.levelUniqueName(this.levelUniqueName());
		axisMember.ordinal(this.ordinal());
		var en = this.properties().getEnumerator();
		while (en.moveNext()) {
			var keyValuePair = en.current();
			axisMember.properties().add(keyValuePair.key(), keyValuePair.value());
		}

		axisMember.uniqueName(this.uniqueName());
		axisMember.position(this.position());
		return axisMember;
	}
	, 
	$type: new $.ig.Type('OlapResultAxisMember', $.ig.Object.prototype.$type, [$.ig.IHierarchicalPositionItem$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)])
}, true);

$.ig.util.defType('OlapResultCell', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.properties(new $.ig.Dictionary$2(String, $.ig.Object.prototype.$type, 0));
	}

	, 
	_cellOrdinal: 0,
	cellOrdinal: function (value) {
		if (arguments.length === 1) {
			this._cellOrdinal = value;
			return value;
		} else {
			return this._cellOrdinal;
		}
	}

	, 
	_properties: null,
	properties: function (value) {
		if (arguments.length === 1) {
			this._properties = value;
			return value;
		} else {
			return this._properties;
		}
	}

	, 
	clone: function () {
		var $self = this;
		var cell = (function () { var $ret = new $.ig.OlapResultCell();
		$ret.cellOrdinal($self.cellOrdinal()); return $ret;}());
		var en = $self.properties().getEnumerator();
		while (en.moveNext()) {
			var keyValuePair = en.current();
			cell.properties().add(keyValuePair.key(), keyValuePair.value());
		}

		return cell;
	}
	, 
	$type: new $.ig.Type('OlapResultCell', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('IConnection', 'Object', {
	$type: new $.ig.Type('IConnection', null)
}, true);

$.ig.util.defType('IOlapDataProviderFactory', 'Object', {
	$type: new $.ig.Type('IOlapDataProviderFactory', null)
}, true);

$.ig.util.defType('IOlapDiscoverDataProvider', 'Object', {
	$type: new $.ig.Type('IOlapDiscoverDataProvider', null)
}, true);

$.ig.util.defType('IOlapExecuteCommandProvider', 'Object', {
	$type: new $.ig.Type('IOlapExecuteCommandProvider', null)
}, true);

$.ig.util.defType('LevelSpanManager', 'Object', {
	__spanSourceTable: null
	, 
	init: function (positionSize) {



		$.ig.Object.prototype.init.call(this);
			this.positionSize(positionSize);
			this.__spanSourceTable = new Array(positionSize);
	}

	, 
	_positionSize: 0,
	positionSize: function (value) {
		if (arguments.length === 1) {
			this._positionSize = value;
			return value;
		} else {
			return this._positionSize;
		}
	}

	, 
	getSpanSource: function (positionItemIndex, positionItemDepth) {
		var $self = this;
		var positionIndexSpanSources = $self.__spanSourceTable[positionItemIndex];
		if (positionIndexSpanSources == null) {
			positionIndexSpanSources = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.SpanSource.prototype.$type, 0);
			$self.__spanSourceTable[positionItemIndex] = positionIndexSpanSources;
		}

		var positionSpanSource;
		if (!(function () { var $ret = positionIndexSpanSources.tryGetValue(positionItemDepth, positionSpanSource); positionSpanSource = $ret.value; return $ret.ret; }())) {
			positionSpanSource = new $.ig.SpanSource();
			if (positionItemDepth > 0) {
				var parentSpanSource;
				if ((function () { var $ret = positionIndexSpanSources.tryGetValue(positionItemDepth - 1, parentSpanSource); parentSpanSource = $ret.value; return $ret.ret; }())) {
					positionSpanSource.parent(parentSpanSource);
					parentSpanSource.increaseSpanForChildren();
				}

			}

			positionIndexSpanSources.add(positionItemDepth, positionSpanSource);
		}

		return positionSpanSource;
	}
	, 
	$type: new $.ig.Type('LevelSpanManager', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('SpanSource', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.__spanValue = 1;
	}

	, 
	_parent: null,
	parent: function (value) {
		if (arguments.length === 1) {
			this._parent = value;
			return value;
		} else {
			return this._parent;
		}
	}
	, 
	__spanValue: 0

	, 
	spanValue: function (value) {
		if (arguments.length === 1) {

			if (this.__spanValue != value) {
				var diff = value - this.__spanValue;
				if (this.parent() != null) {
					this.parent().spanValue(this.parent().spanValue() + diff);
				}

				this.__spanValue = value;
			}

			return value;
		} else {

			return this.__spanValue;
		}
	}
	, 
	__hasChildren: false

	, 
	increaseSpanForChildren: function () {
		if (!this.__hasChildren) {
			this.__hasChildren = true;
			this.spanValue(this.spanValue() + 1);
		}

	}
	, 
	$type: new $.ig.Type('SpanSource', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ITableViewHeadersFactory', 'Object', {
	$type: new $.ig.Type('ITableViewHeadersFactory', null)
}, true);

$.ig.util.defType('TableViewHeadersFactory', 'Object', {

	_sourceAxis: null,
	sourceAxis: function (value) {
		if (arguments.length === 1) {
			this._sourceAxis = value;
			return value;
		} else {
			return this._sourceAxis;
		}
	}

	, 
	_originalAxis: null,
	originalAxis: function (value) {
		if (arguments.length === 1) {
			this._originalAxis = value;
			return value;
		} else {
			return this._originalAxis;
		}
	}

	, 
	_layoutOrientation: null,
	layoutOrientation: function (value) {
		if (arguments.length === 1) {
			this._layoutOrientation = value;
			return value;
		} else {
			return this._layoutOrientation;
		}
	}

	, 
	_isParentInFront: false,
	isParentInFront: function (value) {
		if (arguments.length === 1) {
			this._isParentInFront = value;
			return value;
		} else {
			return this._isParentInFront;
		}
	}

	, 
	_orderedTuples: null,
	orderedTuples: function (value) {
		if (arguments.length === 1) {
			this._orderedTuples = value;
			return value;
		} else {
			return this._orderedTuples;
		}
	}
	, 
	init: function (sourceAxis, originalAxis, layoutOrientation, isParentInFront, orderedTuples) {



		$.ig.Object.prototype.init.call(this);
			this.sourceAxis(sourceAxis);
			this.originalAxis(originalAxis);
			this.layoutOrientation(layoutOrientation);
			this.isParentInFront(isParentInFront);
			this.orderedTuples(orderedTuples);
	}

	, 
	createHeaderCells: function () {
		var $self = this;
		if ($self.sourceAxis().positionResolver().hasUnregisterdPositions()) {
			$self.sourceAxis().positionResolver().completeRegisterPositions();
		}

		var rootPositionInfo = $self.sourceAxis().positionResolver().rootPositionInfo();
		var headerCellCollections = new $.ig.List$1($.ig.IList$1.prototype.$type.specialize($.ig.TableViewHeaderCellSource.prototype.$type), 0);
		for (var i = 0; i < rootPositionInfo.positionSize(); i++) {
			headerCellCollections.add(new $.ig.List$1($.ig.TableViewHeaderCellSource.prototype.$type, 0));
		}

		$.ig.TableViewHeadersFactory.prototype.createHeaderCells2(rootPositionInfo, rootPositionInfo.positionItemDepthMin(), headerCellCollections, $self.isParentInFront(), $self.orderedTuples());
		var result = new $.ig.ArrayListCollection$1($.ig.OlapTableViewHeaderCell.prototype.$type);
		var levelDepthOffset = 0;
		for (var i1 = 0; i1 < rootPositionInfo.positionSize(); i1++) {
			var headerCellsCollection = headerCellCollections.item(i1);
			var directionIndex = 0;
			var maxLevelDepth = 0;
			var en = headerCellsCollection.getEnumerator();
			while (en.moveNext()) {
				var cellSource = en.current();
				var columnIndex;
				var columnSpan;
				var rowIndex;
				var rowSpan;
				if ($self.layoutOrientation() == $.ig.HeaderCellsLayoutOrientation.prototype.horizontal) {
					columnIndex = directionIndex;
					columnSpan = cellSource.headerSpanSource().spanValue();
					rowIndex = cellSource.positionItemInfo().positionItemDepth() + levelDepthOffset;
					rowSpan = cellSource.levelSpanSource().spanValue();

				} else {
					rowIndex = directionIndex;
					rowSpan = cellSource.headerSpanSource().spanValue();
					columnIndex = cellSource.positionItemInfo().positionItemDepth() + levelDepthOffset;
					columnSpan = cellSource.levelSpanSource().spanValue();
				}

				var position = $self.sourceAxis().tuples().__inner[cellSource.positionItemInfo().positionIndex()];
				var positionItem = position.item(cellSource.positionItemInfo().positionItemIndex());
				var tuple = $self.sourceAxis().tuples().__inner[cellSource.tupleIndex()];
				if ($self.originalAxis().positionResolver().hasUnregisterdPositions()) {
					$self.originalAxis().positionResolver().completeRegisterPositions();
				}

				var originalIndex = $self.originalAxis().positionResolver().getPositionIndex(tuple);
				var headerCell = (function () { var $ret = new $.ig.OlapTableViewHeaderCell();
				$ret.axisName($self.sourceAxis().name());
				$ret.hierarchyNumber(cellSource.positionItemInfo().positionItemIndex());
				$ret.levelNumber(cellSource.positionItemInfo().positionItemDepth());
				$ret.caption(positionItem.caption());
				$ret.columnIndex(columnIndex);
				$ret.columnSpan(columnSpan);
				$ret.isExpanded(cellSource.isExpanded());
				$ret.isExpandable(cellSource.isExpandable());
				$ret.tupleIndex(originalIndex);
				$ret.memberIndex(cellSource.positionItemInfo().positionItemIndex());
				$ret.rowIndex(rowIndex);
				$ret.rowSpan(rowSpan); return $ret;}());
				if (!cellSource.isHeaderCellGroup()) {
					directionIndex = directionIndex + cellSource.headerSpanSource().spanValue();
				}

				maxLevelDepth = Math.max(maxLevelDepth, cellSource.positionItemInfo().positionItemDepth());
				result.add(headerCell);
			}

			levelDepthOffset += maxLevelDepth + 1;
		}

		return result;
	}

	, 
	createHeaderCells2: function (hostPositionItemInfo, topMostPositionItemDetph, headerCellsCollections, isParentInFront, orderedTuples) {
		var $self = this;
		var spanManager = new $.ig.LevelSpanManager(hostPositionItemInfo.positionSize());
		var en = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == topMostPositionItemDetph; }).getEnumerator();
		while (en.moveNext()) {
			var positionItemInfo = en.current();
			var tableViewHeaderCell;
			var headerCellSpan;
			(function () { var $ret = $.ig.TableViewHeadersFactory.prototype.createHeaderCells1(hostPositionItemInfo, positionItemInfo, headerCellsCollections, spanManager, isParentInFront, orderedTuples, tableViewHeaderCell, headerCellSpan); tableViewHeaderCell = $ret.headerCellSource; headerCellSpan = $ret.totalSpan; return $ret.ret; }());
		}

	}

	, 
	createHostedHeaderCells: function (positionItemInfo, headerCellCollections, spanManager, isParentInFront, headerCellSource, orderedTuples) {
		var $self = this;
		var hostedPosionsInfo = positionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == positionItemInfo.positionItemDepthMin(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (hostedPosionsInfo.count() > 0) {
			var en = hostedPosionsInfo.getEnumerator();
			while (en.moveNext()) {
				var hostedItemInfo = en.current();
				var hostedHeaderCell;
				var hostedCellSpan;
				(function () { var $ret = $.ig.TableViewHeadersFactory.prototype.createHeaderCells1(positionItemInfo, hostedItemInfo, headerCellCollections, spanManager, isParentInFront, orderedTuples, hostedHeaderCell, hostedCellSpan); hostedHeaderCell = $ret.headerCellSource; hostedCellSpan = $ret.totalSpan; return $ret.ret; }());
				headerCellSource.headerSpanSource().spanValue(headerCellSource.headerSpanSource().spanValue() + hostedCellSpan);
				if (hostedHeaderCell.isHeaderCellGroup()) {
					headerCellSource.headerSpanSource().spanValue(headerCellSource.headerSpanSource().spanValue() + 1);
				}

			}

			headerCellSource.headerSpanSource().spanValue(headerCellSource.headerSpanSource().spanValue() - 1);

		} else {
			orderedTuples.add(positionItemInfo.positionIndex());
		}

		headerCellSource.tupleIndex(positionItemInfo.positionIndex());
	}

	, 
	createHeaderCells1: function (hostPositionItemInfo, positionItemInfo, headerCellCollections, spanManager, isParentInFront, orderedTuples, headerCellSource, totalSpan) {
		var $self = this;
		var headerCellsTargetCollection = headerCellCollections.item(positionItemInfo.positionItemIndex());
		var levelSpanSource = spanManager.getSpanSource(positionItemInfo.positionItemIndex(), positionItemInfo.positionItemDepth());
		var grandTotalHeaderCellSource = (function () { var $ret = new $.ig.TableViewHeaderCellSource();
		$ret.levelSpanSource(levelSpanSource);
		$ret.positionItemInfo(positionItemInfo);
		$ret.isExpandable(positionItemInfo.isExpandable()); return $ret;}());
		headerCellSource = grandTotalHeaderCellSource;
		if (isParentInFront) {
			headerCellsTargetCollection.add(grandTotalHeaderCellSource);
			$.ig.TableViewHeadersFactory.prototype.createHostedHeaderCells(positionItemInfo, headerCellCollections, spanManager, true, grandTotalHeaderCellSource, orderedTuples);
		}

		var childrenPosionInfo = null;
		if (positionItemInfo.isExpanded()) {
			childrenPosionInfo = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.parentKey() == positionItemInfo.key(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		}

		if (childrenPosionInfo != null && childrenPosionInfo.count() > 0) {
			var headerGroupCellSource = (function () { var $ret = new $.ig.TableViewHeaderCellSource();
			$ret.isHeaderCellGroup(true);
			$ret.positionItemInfo(positionItemInfo);
			$ret.isExpandable(positionItemInfo.isExpandable()); return $ret;}());
			headerCellsTargetCollection.add(headerGroupCellSource);
			var en = childrenPosionInfo.getEnumerator();
			while (en.moveNext()) {
				var childItemInfo = en.current();
				var childHeaderCell;
				var childItemSpan;
				(function () { var $ret = $.ig.TableViewHeadersFactory.prototype.createHeaderCells1(hostPositionItemInfo, childItemInfo, headerCellCollections, spanManager, isParentInFront, orderedTuples, childHeaderCell, childItemSpan); childHeaderCell = $ret.headerCellSource; childItemSpan = $ret.totalSpan; return $ret.ret; }());
				headerGroupCellSource.headerSpanSource().spanValue(headerGroupCellSource.headerSpanSource().spanValue() + childItemSpan);
				if (childHeaderCell.isHeaderCellGroup()) {
					headerGroupCellSource.headerSpanSource().spanValue(headerGroupCellSource.headerSpanSource().spanValue() + 1);
				}

			}

			headerGroupCellSource.headerSpanSource().spanValue(headerGroupCellSource.headerSpanSource().spanValue() - 1);
			grandTotalHeaderCellSource.isExpanded(true);
			grandTotalHeaderCellSource.isExpandable(false);
			headerGroupCellSource.isExpanded(true);
			grandTotalHeaderCellSource.headerCellGroup(headerGroupCellSource);
			if (!isParentInFront) {
				headerCellsTargetCollection.add(grandTotalHeaderCellSource);
				$.ig.TableViewHeadersFactory.prototype.createHostedHeaderCells(positionItemInfo, headerCellCollections, spanManager, false, grandTotalHeaderCellSource, orderedTuples);
			}

			headerGroupCellSource.tupleIndex(grandTotalHeaderCellSource.tupleIndex());
			headerCellSource = headerGroupCellSource;
			totalSpan = grandTotalHeaderCellSource.headerSpanSource().spanValue() + headerGroupCellSource.headerSpanSource().spanValue() - 1;

		} else {
			if (positionItemInfo.isExpanded()) {
				grandTotalHeaderCellSource.isExpandable(false);
			}

			if (!isParentInFront) {
				headerCellsTargetCollection.add(grandTotalHeaderCellSource);
				$.ig.TableViewHeadersFactory.prototype.createHostedHeaderCells(positionItemInfo, headerCellCollections, spanManager, false, grandTotalHeaderCellSource, orderedTuples);
			}

			totalSpan = grandTotalHeaderCellSource.headerSpanSource().spanValue();
		}

		return {
			headerCellSource: headerCellSource, 
			totalSpan: totalSpan
		};
	}
	, 
	$type: new $.ig.Type('TableViewHeadersFactory', $.ig.Object.prototype.$type, [$.ig.ITableViewHeadersFactory.prototype.$type])
}, true);

$.ig.util.defType('TableCompactViewHeadersFactory', 'Object', {

	_sourceAxis: null,
	sourceAxis: function (value) {
		if (arguments.length === 1) {
			this._sourceAxis = value;
			return value;
		} else {
			return this._sourceAxis;
		}
	}

	, 
	_originalAxis: null,
	originalAxis: function (value) {
		if (arguments.length === 1) {
			this._originalAxis = value;
			return value;
		} else {
			return this._originalAxis;
		}
	}

	, 
	_layoutOrientation: null,
	layoutOrientation: function (value) {
		if (arguments.length === 1) {
			this._layoutOrientation = value;
			return value;
		} else {
			return this._layoutOrientation;
		}
	}

	, 
	_isParentInFront: false,
	isParentInFront: function (value) {
		if (arguments.length === 1) {
			this._isParentInFront = value;
			return value;
		} else {
			return this._isParentInFront;
		}
	}

	, 
	_orderedTuples: null,
	orderedTuples: function (value) {
		if (arguments.length === 1) {
			this._orderedTuples = value;
			return value;
		} else {
			return this._orderedTuples;
		}
	}
	, 
	init: function (sourceAxis, originalAxis, layoutOrientation, isParentInFront, orderedTuples) {



		$.ig.Object.prototype.init.call(this);
			this.sourceAxis(sourceAxis);
			this.originalAxis(originalAxis);
			this.layoutOrientation(layoutOrientation);
			this.isParentInFront(isParentInFront);
			this.orderedTuples(orderedTuples);
	}

	, 
	createHeaderCells: function () {
		var $self = this;
		if ($self.sourceAxis().positionResolver().hasUnregisterdPositions()) {
			$self.sourceAxis().positionResolver().completeRegisterPositions();
		}

		var rootPositionInfo = $self.sourceAxis().positionResolver().rootPositionInfo();
		var headerCellCollections = new $.ig.List$1($.ig.IList$1.prototype.$type.specialize($.ig.TableViewHeaderCellSource.prototype.$type), 0);
		for (var i = 0; i < rootPositionInfo.positionSize(); i++) {
			headerCellCollections.add(new $.ig.List$1($.ig.TableViewHeaderCellSource.prototype.$type, 0));
		}

		$.ig.TableCompactViewHeadersFactory.prototype.createHeaderCells2(rootPositionInfo, rootPositionInfo.positionItemDepthMin(), headerCellCollections, $self.isParentInFront(), $self.orderedTuples());
		var result = new $.ig.ArrayListCollection$1($.ig.OlapTableViewHeaderCell.prototype.$type);
		var levelDepthOffset = 0;
		for (var i1 = 0; i1 < rootPositionInfo.positionSize(); i1++) {
			var headerCellsCollection = headerCellCollections.item(i1);
			var directionIndex = 0;
			var maxLevelDepth = 0;
			var en = headerCellsCollection.getEnumerator();
			while (en.moveNext()) {
				var cellSource = en.current();
				var columnIndex;
				var columnSpan;
				var rowIndex;
				var rowSpan;
				if ($self.layoutOrientation() == $.ig.HeaderCellsLayoutOrientation.prototype.horizontal) {
					columnIndex = directionIndex;
					columnSpan = cellSource.headerSpanSource().spanValue();
					rowIndex = levelDepthOffset;
					rowSpan = 1;

				} else {
					rowIndex = directionIndex;
					rowSpan = cellSource.headerSpanSource().spanValue();
					columnIndex = levelDepthOffset;
					columnSpan = 1;
				}

				var position = $self.sourceAxis().tuples().__inner[cellSource.positionItemInfo().positionIndex()];
				var positionItem = position.item(cellSource.positionItemInfo().positionItemIndex());
				var tuple = $self.sourceAxis().tuples().__inner[cellSource.tupleIndex()];
				if ($self.originalAxis().positionResolver().hasUnregisterdPositions()) {
					$self.originalAxis().positionResolver().completeRegisterPositions();
				}

				var originalIndex = $self.originalAxis().positionResolver().getPositionIndex(tuple);
				var headerCell = (function () { var $ret = new $.ig.OlapTableViewHeaderCell();
				$ret.axisName($self.sourceAxis().name());
				$ret.hierarchyNumber(cellSource.positionItemInfo().positionItemIndex());
				$ret.levelNumber(cellSource.positionItemInfo().positionItemDepth());
				$ret.caption(positionItem.caption());
				$ret.columnIndex(columnIndex);
				$ret.columnSpan(columnSpan);
				$ret.isExpanded(cellSource.isExpanded());
				$ret.isExpandable(cellSource.isExpandable());
				$ret.tupleIndex(originalIndex);
				$ret.memberIndex(cellSource.positionItemInfo().positionItemIndex());
				$ret.rowIndex(rowIndex);
				$ret.rowSpan(rowSpan); return $ret;}());
				if (!cellSource.isHeaderCellGroup()) {
					directionIndex = directionIndex + cellSource.headerSpanSource().spanValue();
				}

				result.add(headerCell);
			}

			levelDepthOffset += maxLevelDepth + 1;
		}

		return result;
	}

	, 
	createHeaderCells2: function (hostPositionItemInfo, topMostPositionItemDetph, headerCellsCollections, isParentInFront, orderedTuples) {
		var $self = this;
		var spanManager = new $.ig.LevelSpanManager(hostPositionItemInfo.positionSize());
		var en = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == topMostPositionItemDetph; }).getEnumerator();
		while (en.moveNext()) {
			var positionItemInfo = en.current();
			var tableViewHeaderCell;
			var headerCellSpan;
			(function () { var $ret = $.ig.TableCompactViewHeadersFactory.prototype.createHeaderCells1(hostPositionItemInfo, positionItemInfo, headerCellsCollections, spanManager, isParentInFront, orderedTuples, tableViewHeaderCell, headerCellSpan); tableViewHeaderCell = $ret.headerCellSource; headerCellSpan = $ret.totalSpan; return $ret.ret; }());
		}

	}

	, 
	createHostedHeaderCells: function (positionItemInfo, headerCellCollections, spanManager, isParentInFront, headerCellSource, orderedTuples) {
		var $self = this;
		var hostedPosionsInfo = positionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == positionItemInfo.positionItemDepthMin(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (hostedPosionsInfo.count() > 0) {
			var en = hostedPosionsInfo.getEnumerator();
			while (en.moveNext()) {
				var hostedItemInfo = en.current();
				var hostedHeaderCell;
				var hostedCellSpan;
				(function () { var $ret = $.ig.TableCompactViewHeadersFactory.prototype.createHeaderCells1(positionItemInfo, hostedItemInfo, headerCellCollections, spanManager, isParentInFront, orderedTuples, hostedHeaderCell, hostedCellSpan); hostedHeaderCell = $ret.headerCellSource; hostedCellSpan = $ret.totalSpan; return $ret.ret; }());
				headerCellSource.headerSpanSource().spanValue(headerCellSource.headerSpanSource().spanValue() + hostedCellSpan);
				if (hostedHeaderCell.headerCellGroup() != null) {
					headerCellSource.headerSpanSource().spanValue(headerCellSource.headerSpanSource().spanValue() + 1);
				}

			}

			headerCellSource.headerSpanSource().spanValue(headerCellSource.headerSpanSource().spanValue() - 1);

		} else {
			orderedTuples.add(positionItemInfo.positionIndex());
		}

		headerCellSource.tupleIndex(positionItemInfo.positionIndex());
	}

	, 
	createHeaderCells1: function (hostPositionItemInfo, positionItemInfo, headerCellCollections, spanManager, isParentInFront, orderedTuples, headerCellSource, totalSpan) {
		var $self = this;
		var headerCellsTargetCollection = headerCellCollections.item(positionItemInfo.positionItemIndex());
		var levelSpanSource = spanManager.getSpanSource(positionItemInfo.positionItemIndex(), positionItemInfo.positionItemDepth());
		var grandTotalHeaderCellSource = (function () { var $ret = new $.ig.TableViewHeaderCellSource();
		$ret.levelSpanSource(levelSpanSource);
		$ret.positionItemInfo(positionItemInfo);
		$ret.isExpandable(positionItemInfo.isExpandable()); return $ret;}());
		headerCellSource = grandTotalHeaderCellSource;
		if (isParentInFront) {
			headerCellsTargetCollection.add(grandTotalHeaderCellSource);
			$.ig.TableCompactViewHeadersFactory.prototype.createHostedHeaderCells(positionItemInfo, headerCellCollections, spanManager, true, grandTotalHeaderCellSource, orderedTuples);
		}

		var childrenPosionInfo = null;
		if (positionItemInfo.isExpanded()) {
			childrenPosionInfo = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.parentKey() == positionItemInfo.key(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		}

		if (childrenPosionInfo != null && childrenPosionInfo.count() > 0) {
			var headerGroupCellSource = (function () { var $ret = new $.ig.TableViewHeaderCellSource();
			$ret.isHeaderCellGroup(true);
			$ret.positionItemInfo(positionItemInfo);
			$ret.isExpandable(positionItemInfo.isExpandable()); return $ret;}());
			var en = childrenPosionInfo.getEnumerator();
			while (en.moveNext()) {
				var childItemInfo = en.current();
				var childHeaderCell;
				var childItemSpan;
				(function () { var $ret = $.ig.TableCompactViewHeadersFactory.prototype.createHeaderCells1(hostPositionItemInfo, childItemInfo, headerCellCollections, spanManager, isParentInFront, orderedTuples, childHeaderCell, childItemSpan); childHeaderCell = $ret.headerCellSource; childItemSpan = $ret.totalSpan; return $ret.ret; }());
				headerGroupCellSource.headerSpanSource().spanValue(headerGroupCellSource.headerSpanSource().spanValue() + childItemSpan);
				if (childHeaderCell.headerCellGroup() != null) {
					headerGroupCellSource.headerSpanSource().spanValue(headerGroupCellSource.headerSpanSource().spanValue() + 1);
				}

			}

			headerGroupCellSource.headerSpanSource().spanValue(headerGroupCellSource.headerSpanSource().spanValue() - 1);
			grandTotalHeaderCellSource.isExpanded(true);
			grandTotalHeaderCellSource.isExpandable(true);
			grandTotalHeaderCellSource.headerCellGroup(headerGroupCellSource);
			if (!isParentInFront) {
				headerCellsTargetCollection.add(grandTotalHeaderCellSource);
				$.ig.TableCompactViewHeadersFactory.prototype.createHostedHeaderCells(positionItemInfo, headerCellCollections, spanManager, false, grandTotalHeaderCellSource, orderedTuples);
			}

			headerGroupCellSource.tupleIndex(grandTotalHeaderCellSource.tupleIndex());
			totalSpan = grandTotalHeaderCellSource.headerSpanSource().spanValue() + headerGroupCellSource.headerSpanSource().spanValue() - 1;

		} else {
			if (positionItemInfo.isExpanded()) {
				grandTotalHeaderCellSource.isExpandable(false);
			}

			if (!isParentInFront) {
				headerCellsTargetCollection.add(grandTotalHeaderCellSource);
				$.ig.TableCompactViewHeadersFactory.prototype.createHostedHeaderCells(positionItemInfo, headerCellCollections, spanManager, false, grandTotalHeaderCellSource, orderedTuples);
			}

			totalSpan = grandTotalHeaderCellSource.headerSpanSource().spanValue();
		}

		return {
			headerCellSource: headerCellSource, 
			totalSpan: totalSpan
		};
	}
	, 
	$type: new $.ig.Type('TableCompactViewHeadersFactory', $.ig.Object.prototype.$type, [$.ig.ITableViewHeadersFactory.prototype.$type])
}, true);

$.ig.util.defType('TableViewHeaderCellSource', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.headerSpanSource(new $.ig.SpanSource());
			this.levelSpanSource(new $.ig.SpanSource());
	}

	, 
	_isHeaderCellGroup: false,
	isHeaderCellGroup: function (value) {
		if (arguments.length === 1) {
			this._isHeaderCellGroup = value;
			return value;
		} else {
			return this._isHeaderCellGroup;
		}
	}

	, 
	_rowIndex: 0,
	rowIndex: function (value) {
		if (arguments.length === 1) {
			this._rowIndex = value;
			return value;
		} else {
			return this._rowIndex;
		}
	}

	, 
	_columnIndex: 0,
	columnIndex: function (value) {
		if (arguments.length === 1) {
			this._columnIndex = value;
			return value;
		} else {
			return this._columnIndex;
		}
	}

	, 
	_levelSpanSource: null,
	levelSpanSource: function (value) {
		if (arguments.length === 1) {
			this._levelSpanSource = value;
			return value;
		} else {
			return this._levelSpanSource;
		}
	}

	, 
	_headerSpanSource: null,
	headerSpanSource: function (value) {
		if (arguments.length === 1) {
			this._headerSpanSource = value;
			return value;
		} else {
			return this._headerSpanSource;
		}
	}

	, 
	_headerCellGroup: null,
	headerCellGroup: function (value) {
		if (arguments.length === 1) {
			this._headerCellGroup = value;
			return value;
		} else {
			return this._headerCellGroup;
		}
	}

	, 
	_positionItemInfo: null,
	positionItemInfo: function (value) {
		if (arguments.length === 1) {
			this._positionItemInfo = value;
			return value;
		} else {
			return this._positionItemInfo;
		}
	}

	, 
	_tupleIndex: 0,
	tupleIndex: function (value) {
		if (arguments.length === 1) {
			this._tupleIndex = value;
			return value;
		} else {
			return this._tupleIndex;
		}
	}

	, 
	_memberIndex: 0,
	memberIndex: function (value) {
		if (arguments.length === 1) {
			this._memberIndex = value;
			return value;
		} else {
			return this._memberIndex;
		}
	}

	, 
	_isExpanded: false,
	isExpanded: function (value) {
		if (arguments.length === 1) {
			this._isExpanded = value;
			return value;
		} else {
			return this._isExpanded;
		}
	}

	, 
	_isExpandable: false,
	isExpandable: function (value) {
		if (arguments.length === 1) {
			this._isExpandable = value;
			return value;
		} else {
			return this._isExpandable;
		}
	}
	, 
	$type: new $.ig.Type('TableViewHeaderCellSource', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TableViewImpl', 'Object', {
	init: function (result, hasColumns, hasRows, viewSettings) {


		var $self = this;

		$.ig.Object.prototype.init.call(this);
			if (result == null) {
				throw new $.ig.ArgumentNullException("result");
			}

			this.result(result);
			this.originalResult(result);
			if (viewSettings == null) {
				this.viewSettings(new $.ig.TableViewSettings());

			} else {
				this.viewSettings(viewSettings);
			}

			this.hasColumns(hasColumns);
			this.hasRows(hasRows);
			this.columnSortDirections(new $.ig.ArrayListCollection$1($.ig.TupleSortDirection.prototype.$type));
			(this.columnSortDirections()).collectionChanged = $.ig.Delegate.prototype.combine((this.columnSortDirections()).collectionChanged, function (sender, e) {
				$self.isModified(true);
			});
			this.levelSortDirections(new $.ig.ArrayListCollection$1($.ig.LevelSortDirection.prototype.$type));
			(this.levelSortDirections()).collectionChanged = $.ig.Delegate.prototype.combine((this.levelSortDirections()).collectionChanged, function (sender, e) {
				$self.isModified(true);
			});
			this.appliedColumnSortDirections(new $.ig.List$1($.ig.TupleSortDirection.prototype.$type, 0));
			this.appliedLevelSortDirections(new $.ig.List$1($.ig.LevelSortDirection.prototype.$type, 0));
			this.appliedSortDirectionsMap(new $.ig.Dictionary$2(String, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type)), 0));
	}

	, 
	_viewSettings: null,
	viewSettings: function (value) {
		if (arguments.length === 1) {
			this._viewSettings = value;
			return value;
		} else {
			return this._viewSettings;
		}
	}

	, 
	_result: null,
	result: function (value) {
		if (arguments.length === 1) {
			this._result = value;
			return value;
		} else {
			return this._result;
		}
	}

	, 
	_originalResult: null,
	originalResult: function (value) {
		if (arguments.length === 1) {
			this._originalResult = value;
			return value;
		} else {
			return this._originalResult;
		}
	}

	, 
	_hasRows: false,
	hasRows: function (value) {
		if (arguments.length === 1) {
			this._hasRows = value;
			return value;
		} else {
			return this._hasRows;
		}
	}

	, 
	_hasColumns: false,
	hasColumns: function (value) {
		if (arguments.length === 1) {
			this._hasColumns = value;
			return value;
		} else {
			return this._hasColumns;
		}
	}

	, 
	_rowHeadersFactory: null,
	rowHeadersFactory: function (value) {
		if (arguments.length === 1) {
			this._rowHeadersFactory = value;
			return value;
		} else {
			return this._rowHeadersFactory;
		}
	}

	, 
	_columnHeadersFactory: null,
	columnHeadersFactory: function (value) {
		if (arguments.length === 1) {
			this._columnHeadersFactory = value;
			return value;
		} else {
			return this._columnHeadersFactory;
		}
	}

	, 
	_isInitialized: false,
	isInitialized: function (value) {
		if (arguments.length === 1) {
			this._isInitialized = value;
			return value;
		} else {
			return this._isInitialized;
		}
	}

	, 
	_isModified: false,
	isModified: function (value) {
		if (arguments.length === 1) {
			this._isModified = value;
			return value;
		} else {
			return this._isModified;
		}
	}
	, 
	__rowHeaders: null
	, 
	__columnHeaders: null
	, 
	__resultCells: null

	, 
	rowHeaders: function (value) {
		if (arguments.length === 1) {

			this.__rowHeaders = value;
			return value;
		} else {

			if (!this.isInitialized() || this.isModified()) {
				this.initialize();
			}

			return this.__rowHeaders;
		}
	}

	, 
	columnHeaders: function (value) {
		if (arguments.length === 1) {

			this.__columnHeaders = value;
			return value;
		} else {

			if (!this.isInitialized() || this.isModified()) {
				this.initialize();
			}

			return this.__columnHeaders;
		}
	}

	, 
	resultCells: function (value) {
		if (arguments.length === 1) {

			this.__resultCells = value;
			return value;
		} else {

			if (!this.isInitialized() || this.isModified()) {
				this.initialize();
			}

			return this.__resultCells;
		}
	}

	, 
	_columnSortDirections: null,
	columnSortDirections: function (value) {
		if (arguments.length === 1) {
			this._columnSortDirections = value;
			return value;
		} else {
			return this._columnSortDirections;
		}
	}

	, 
	_levelSortDirections: null,
	levelSortDirections: function (value) {
		if (arguments.length === 1) {
			this._levelSortDirections = value;
			return value;
		} else {
			return this._levelSortDirections;
		}
	}

	, 
	_appliedColumnSortDirections: null,
	appliedColumnSortDirections: function (value) {
		if (arguments.length === 1) {
			this._appliedColumnSortDirections = value;
			return value;
		} else {
			return this._appliedColumnSortDirections;
		}
	}

	, 
	_appliedLevelSortDirections: null,
	appliedLevelSortDirections: function (value) {
		if (arguments.length === 1) {
			this._appliedLevelSortDirections = value;
			return value;
		} else {
			return this._appliedLevelSortDirections;
		}
	}

	, 
	_appliedSortDirectionsMap: null,
	appliedSortDirectionsMap: function (value) {
		if (arguments.length === 1) {
			this._appliedSortDirectionsMap = value;
			return value;
		} else {
			return this._appliedSortDirectionsMap;
		}
	}

	, 
	initialize: function () {
		var $self = this;
		$self.rowHeadersFactory(null);
		$self.columnHeadersFactory(null);
		$self.rowHeaders(null);
		$self.columnHeaders(null);
		$self.resultCells(null);
		$self.result($self.originalResult());
		if ($self.result().isEmpty()) {
			$self.isModified(false);
			$self.isInitialized(true);
			return;
		}

		if ($self.levelSortDirections().count() > 0) {
			var resultHeaderSorter = new $.ig.ResultHeaderSorter($self.result(), $self.hasRows(), $self.hasColumns(), $self.levelSortDirections());
			$self.result(resultHeaderSorter.sort());
			$self.appliedLevelSortDirections(resultHeaderSorter.appliedSortDirections());
			$self.appliedSortDirectionsMap(resultHeaderSorter.appliedSortDirectionsMap());

		} else {
			$self.appliedLevelSortDirections(new $.ig.List$1($.ig.LevelSortDirection.prototype.$type, 0));
			$self.appliedSortDirectionsMap(new $.ig.Dictionary$2(String, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type)), 0));
		}

		if ($self.hasRows() && $self.columnSortDirections().count() > 0) {
			if ($self.appliedLevelSortDirections().count() > 0) {
				if ($self.originalResult().axes().item(0).positionResolver().hasUnregisterdPositions()) {
					$self.originalResult().axes().item(0).positionResolver().completeRegisterPositions();
				}

				if ($self.result().axes().item(0).positionResolver().hasUnregisterdPositions()) {
					$self.result().axes().item(0).positionResolver().completeRegisterPositions();
				}

				var sortDirections = new $.ig.List$1($.ig.TupleSortDirection.prototype.$type, 2, $self.columnSortDirections().count());
				var tupleIndicesMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Number.prototype.$type, 1, $self.appliedColumnSortDirections().count());
				var en = $self.columnSortDirections().getEnumerator();
				while (en.moveNext()) {
					var sd = en.current();
					var tuple = $self.originalResult().axes().item(0).tuples().__inner[sd.tupleIndex()];
					var newTupleIndex = $self.result().axes().item(0).positionResolver().getPositionIndex(tuple);
					var newTupleSortDirection = new $.ig.TupleSortDirection();
					newTupleSortDirection.sortDirection(sd.sortDirection());
					newTupleSortDirection.tupleIndex(newTupleIndex);
					newTupleSortDirection.comparer(sd.comparer());
					sortDirections.add(newTupleSortDirection);
					tupleIndicesMap.item(newTupleIndex, sd.tupleIndex());
				}

				var resultColumnValueSorter = new $.ig.ResultColumnValueSorter($self.result(), $self.hasRows(), $self.hasColumns(), sortDirections);
				$self.result(resultColumnValueSorter.sort());
				var en1 = resultColumnValueSorter.appliedSortDirections().getEnumerator();
				while (en1.moveNext()) {
					var sd1 = en1.current();
					sd1.tupleIndex(tupleIndicesMap.item(sd1.tupleIndex()));
				}

				$self.appliedColumnSortDirections(resultColumnValueSorter.appliedSortDirections());

			} else {
				var resultColumnValueSorter1 = new $.ig.ResultColumnValueSorter($self.result(), $self.hasRows(), $self.hasColumns(), $self.columnSortDirections());
				$self.result(resultColumnValueSorter1.sort());
				$self.appliedColumnSortDirections(resultColumnValueSorter1.appliedSortDirections());
			}


		} else {
			$self.appliedColumnSortDirections(new $.ig.List$1($.ig.TupleSortDirection.prototype.$type, 0));
		}

		var axisIndex = 0;
		var columnIndexesMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Number.prototype.$type, 0);
		var columnsCount = 1;
		if ($self.hasColumns()) {
			var columnAxis = $self.result().axes().item(axisIndex);
			var originalColumnAxis = $self.originalResult().axes().item(axisIndex);
			var orderedColumnTuples = $self.initializeColumnHeaders(columnAxis, originalColumnAxis);
			for (var i = 0; i < orderedColumnTuples.count(); i++) {
				var index = orderedColumnTuples.item(i);
				columnIndexesMap.add(index, i);
			}

			axisIndex++;
			columnsCount = columnAxis.tuples().count();
		}

		var rowIndexesMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Number.prototype.$type, 0);
		if ($self.hasRows()) {
			var rowAxis = $self.result().axes().item(axisIndex);
			var originalRowAxis = $self.originalResult().axes().item(axisIndex);
			var orderedRowTuples = $self.initializeRowHeaders(rowAxis, originalRowAxis);
			for (var i1 = 0; i1 < orderedRowTuples.count(); i1++) {
				var index1 = orderedRowTuples.item(i1);
				rowIndexesMap.add(index1, i1);
			}

		}

		var resultCells = new $.ig.ArrayListCollection$1($.ig.OlapTableViewResultCell.prototype.$type);
		for (var i2 = 0; i2 < $self.result().cells().count(); i2++) {
			var cell = $self.result().cells().item(i2);
			var cellValue;
			(function () { var $ret = cell.properties().tryGetValue("Value", cellValue); cellValue = $ret.value; return $ret.ret; }());
			var formatedValue;
			(function () { var $ret = cell.properties().tryGetValue("FmtValue", formatedValue); formatedValue = $ret.value; return $ret.ret; }());
			var cellOrdinal = cell.cellOrdinal();
			if ($self.hasColumns()) {
				var columnIndex = cellOrdinal % columnsCount;
				var newIndex = columnIndexesMap.item(columnIndex);
				if (columnIndex != newIndex) {
					var rowIndex = $.ig.intDivide(cellOrdinal, columnsCount);
					cellOrdinal = rowIndex * columnsCount + newIndex;
				}

			}

			if ($self.hasRows()) {
				var rowIndex1 = $.ig.intDivide(cellOrdinal, columnsCount);
				var newIndex1 = rowIndexesMap.item(rowIndex1);
				if (rowIndex1 != newIndex1) {
					var columnIndex1 = cellOrdinal % columnsCount;
					cellOrdinal = newIndex1 * columnsCount + columnIndex1;
				}

			}

			resultCells.add((function () { var $ret = new $.ig.OlapTableViewResultCell();
			$ret.value(cellValue);
			$ret.formattedValue(formatedValue);
			$ret.cellOrdinal(cellOrdinal);
			$ret.resultCellIndex(i2); return $ret;}()));
			$self.resultCells(resultCells);
		}

		$self.isModified(false);
		$self.isInitialized(true);
	}

	, 
	initializeColumnHeaders: function (columnAxis, originalColumnAxis) {
		var orderedTuples = new $.ig.List$1($.ig.Number.prototype.$type, 0);
		if (this.viewSettings().compactColumnHeaders()) {
			this.columnHeadersFactory(new $.ig.TableCompactViewHeadersFactory(columnAxis, originalColumnAxis, $.ig.HeaderCellsLayoutOrientation.prototype.horizontal, this.viewSettings().isParentInFrontForColumns(), orderedTuples));

		} else {
			this.columnHeadersFactory(new $.ig.TableViewHeadersFactory(columnAxis, originalColumnAxis, $.ig.HeaderCellsLayoutOrientation.prototype.horizontal, this.viewSettings().isParentInFrontForColumns(), orderedTuples));
		}

		this.columnHeaders(this.columnHeadersFactory().createHeaderCells());
		return orderedTuples;
	}

	, 
	initializeRowHeaders: function (rowAxis, originalRowAxis) {
		var orderedTuples = new $.ig.List$1($.ig.Number.prototype.$type, 0);
		if (this.viewSettings().compactRowHeaders()) {
			this.rowHeadersFactory(new $.ig.TableCompactViewHeadersFactory(rowAxis, originalRowAxis, $.ig.HeaderCellsLayoutOrientation.prototype.vertical, this.viewSettings().isParentInFrontForRows(), orderedTuples));

		} else {
			this.rowHeadersFactory(new $.ig.TableViewHeadersFactory(rowAxis, originalRowAxis, $.ig.HeaderCellsLayoutOrientation.prototype.vertical, this.viewSettings().isParentInFrontForRows(), orderedTuples));
		}

		this.rowHeaders(this.rowHeadersFactory().createHeaderCells());
		return orderedTuples;
	}
	, 
	$type: new $.ig.Type('TableViewImpl', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TableViewSettings', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_isParentInFrontForColumns: false,
	isParentInFrontForColumns: function (value) {
		if (arguments.length === 1) {
			this._isParentInFrontForColumns = value;
			return value;
		} else {
			return this._isParentInFrontForColumns;
		}
	}

	, 
	_isParentInFrontForRows: false,
	isParentInFrontForRows: function (value) {
		if (arguments.length === 1) {
			this._isParentInFrontForRows = value;
			return value;
		} else {
			return this._isParentInFrontForRows;
		}
	}

	, 
	_compactRowHeaders: false,
	compactRowHeaders: function (value) {
		if (arguments.length === 1) {
			this._compactRowHeaders = value;
			return value;
		} else {
			return this._compactRowHeaders;
		}
	}

	, 
	_compactColumnHeaders: false,
	compactColumnHeaders: function (value) {
		if (arguments.length === 1) {
			this._compactColumnHeaders = value;
			return value;
		} else {
			return this._compactColumnHeaders;
		}
	}
	, 
	$type: new $.ig.Type('TableViewSettings', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapResultView', 'Object', {
	init: function (result, visibleResult, hasColumns, hasRows) {



		$.ig.Object.prototype.init.call(this);
			if (result == null) {
				throw new $.ig.ArgumentNullException("result");
			}

			this.result(result);
			this.visibleResult(visibleResult);
			this.hasColumns(hasColumns);
			this.hasRows(hasRows);
	}

	, 
	_result: null,
	result: function (value) {
		if (arguments.length === 1) {
			this._result = value;
			return value;
		} else {
			return this._result;
		}
	}

	, 
	_visibleResult: null,
	visibleResult: function (value) {
		if (arguments.length === 1) {
			this._visibleResult = value;
			return value;
		} else {
			return this._visibleResult;
		}
	}

	, 
	_hasRows: false,
	hasRows: function (value) {
		if (arguments.length === 1) {
			this._hasRows = value;
			return value;
		} else {
			return this._hasRows;
		}
	}

	, 
	_hasColumns: false,
	hasColumns: function (value) {
		if (arguments.length === 1) {
			this._hasColumns = value;
			return value;
		} else {
			return this._hasColumns;
		}
	}

	, 
	getSubResult: function (result, rowAxis, columnAxis, hasRows, hasColumns) {
		var $self = this;
		var axisIndex = 0;
		var fullColumnAxis = null;
		var fullColumnsCount = 1;
		if (hasColumns) {
			fullColumnAxis = result.axes().item(axisIndex);
			fullColumnsCount = fullColumnAxis.tuples().count();
			axisIndex++;
		}

		var fullRowAxis = null;
		var fullRowsCount = 1;
		if (hasRows) {
			fullRowAxis = result.axes().item(axisIndex);
			fullRowsCount = fullRowAxis.tuples().count();
		}

		var rowsCount = 1;
		if (rowAxis != null) {
			rowsCount = rowAxis.tuples().count();
		}

		var columnsCount = 1;
		if (columnAxis != null) {
			columnsCount = columnAxis.tuples().count();
		}

		var cells = new Array(rowsCount * columnsCount);
		if (result.cells().count() > 0) {
			var cellIndex = 0;
			var cell = result.cells().item(cellIndex);
			for (var i = 0; i < fullRowsCount; i++) {
				var cellRowIndex = $.ig.intDivide(cell.cellOrdinal(), fullColumnsCount);
				if (cellRowIndex != i) {
					continue;
				}

				var rowTupleIndex = 0;
				if (rowAxis != null && fullRowAxis != null) {
					var rowTuple = fullRowAxis.tuples().__inner[i];
					rowTupleIndex = rowAxis.positionResolver().getPositionIndex(rowTuple);
				}

				if (rowTupleIndex == -1) {
					while (cellRowIndex == i) {
						cellIndex++;
						if (cellIndex < result.cells().count()) {
							cell = result.cells().item(cellIndex);
							cellRowIndex = $.ig.intDivide(cell.cellOrdinal(), fullColumnsCount);

						} else {
							break;
						}


					}
					continue;
				}

				var cellColumnIndex = cell.cellOrdinal() % fullColumnsCount;
				for (var j = 0; j < fullColumnsCount; j++) {
					if (cellColumnIndex != j) {
						continue;
					}

					var columnTupleIndex = -1;
					if (columnAxis == null || fullColumnAxis == null) {
						columnTupleIndex = 0;

					} else {
						var columnTuple = fullColumnAxis.tuples().__inner[j];
						columnTupleIndex = columnAxis.positionResolver().getPositionIndex(columnTuple);
					}

					if (columnTupleIndex == -1) {
						cellIndex++;
						if (cellIndex < result.cells().count()) {
							cell = result.cells().item(cellIndex);
							cellRowIndex = $.ig.intDivide(cell.cellOrdinal(), fullColumnsCount);
							if (cellRowIndex > i) {
								break;
							}

							cellColumnIndex = cell.cellOrdinal() % fullColumnsCount;
						}

						continue;
					}

					var newCell = cell.clone();
					newCell.cellOrdinal(rowTupleIndex * columnsCount + columnTupleIndex);
					cells[newCell.cellOrdinal()] = newCell;
					cellIndex++;
					if (cellIndex < result.cells().count()) {
						cell = result.cells().item(cellIndex);
						cellRowIndex = $.ig.intDivide(cell.cellOrdinal(), fullColumnsCount);
						if (cellRowIndex > i) {
							break;
						}

						cellColumnIndex = cell.cellOrdinal() % fullColumnsCount;
					}

				}

			}

		}

		var resultCells = new $.ig.List$1($.ig.OlapResultCell.prototype.$type, 0);
		for (var i1 = 0; i1 < cells.length; i1++) {
			var cell1 = cells[i1];
			if (cell1 != null) {
				resultCells.add(cell1);
			}

		}

		var resultAxes = new $.ig.List$1($.ig.OlapResultAxis.prototype.$type, 0);
		if (hasColumns) {
			resultAxes.add(columnAxis);
		}

		if (hasRows) {
			resultAxes.add(rowAxis);
		}

		return (function () { var $ret = new $.ig.OlapResult();
		$ret.axes(resultAxes);
		$ret.cells(resultCells);
		$ret.isEmpty(!hasRows && !hasColumns && resultCells.count() == 0); return $ret;}());
	}

	, 
	createSubAxis: function (sourceAxis, indexes, inner) {
		var $self = this;
		var tuples = new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 0);
		if (inner) {
			for (var i = 0; i < indexes.count(); i++) {
				var index = indexes.item(i);
				tuples.add(sourceAxis.tuples().__inner[index].clone());
			}


		} else {
			var index1 = 0;
			var skipIndex = indexes.item(index1);
			for (var i1 = 0; i1 < sourceAxis.tuples().count(); i1++) {
				if (i1 == skipIndex) {
					index1++;
					if (index1 < indexes.count()) {
						skipIndex = indexes.item(index1);
					}


				} else {
					tuples.add(sourceAxis.tuples().__inner[i1].clone());
				}

			}

		}

		var subAxis = (function () { var $ret = new $.ig.OlapResultAxis(tuples, sourceAxis.tupleSize());
		$ret.name(sourceAxis.name()); return $ret;}());
		return subAxis;
	}

	, 
	expandTupleMember: function (axisName, tupleIndex, memberIndex) {
		var $self = this;
		var positionInfo = $self.getPositionItem(axisName, tupleIndex, memberIndex, $self.visibleResult());
		if (positionInfo == null) {
			return null;
		}

		if (!positionInfo.isExpandable()) {
			throw new $.ig.InvalidOperationException(1, "The position is not expandable.");
		}

		if (positionInfo.isExpanded()) {
			return $self;
		}

		var visibleAxis = $self.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var cellsAxis = $self.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var isRowAxis = (axisName == "Axis0" && !$self.hasColumns()) || (axisName == "Axis1" && $self.hasRows());
		var visibleTuple = visibleAxis.tuples().__inner[tupleIndex];
		var cachedTupleIndex = cellsAxis.positionResolver().getPositionIndex(visibleTuple);
		var childrenIndexes = $self.getChildrenPositionIndexes(axisName, cachedTupleIndex, memberIndex, $self.result());
		if (childrenIndexes.count() == 0) {
			return null;
		}

		var rowAxis = null;
		var columnAxis = null;
		if (isRowAxis) {
			rowAxis = $self.createSubAxis(cellsAxis, childrenIndexes, true);
			if ($self.hasColumns()) {
				columnAxis = $self.visibleResult().axes().item(0);
			}


		} else {
			columnAxis = $self.createSubAxis(cellsAxis, childrenIndexes, true);
			if ($self.hasRows()) {
				rowAxis = $self.visibleResult().axes().item(1);
			}

		}

		var subResult = $self.getSubResult($self.result(), rowAxis, columnAxis, $self.hasRows(), $self.hasColumns());
		var extendedResult = $self.extendResult($self.visibleResult(), subResult, cellsAxis.name());
		return new $.ig.OlapResultView($self.result(), extendedResult, $self.hasColumns(), $self.hasRows());
	}

	, 
	collapseTupleMember: function (axisName, tupleIndex, memberIndex) {
		var $self = this;
		var positionInfo = $self.getPositionItem(axisName, tupleIndex, memberIndex, $self.visibleResult());
		if (positionInfo == null) {
			return null;
		}

		if (!positionInfo.isExpandable()) {
			throw new $.ig.InvalidOperationException(1, "The position is not expandable.");
		}

		if (!positionInfo.isExpanded()) {
			return $self;
		}

		var childrenIndexes = $self.getChildrenPositionIndexes(axisName, tupleIndex, memberIndex, $self.visibleResult());
		if (childrenIndexes.count() == 0) {
			return null;
		}

		var cellsAxis = $self.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var isRowAxis = (axisName == "Axis0" && !$self.hasColumns()) || (axisName == "Axis1" && $self.hasRows());
		var rowAxis = null;
		var columnAxis = null;
		if (isRowAxis) {
			rowAxis = $self.createSubAxis(cellsAxis, childrenIndexes, false);
			if ($self.hasColumns()) {
				columnAxis = $self.visibleResult().axes().item(0);
			}


		} else {
			columnAxis = $self.createSubAxis(cellsAxis, childrenIndexes, false);
			if ($self.hasRows()) {
				rowAxis = $self.visibleResult().axes().item(1);
			}

		}

		var resultAxis = $self.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var position = resultAxis.tuples().__inner[tupleIndex];
		if (resultAxis.positionResolver().hasUnregisterdPositions()) {
			resultAxis.positionResolver().completeRegisterPositions();
		}

		var hostPosition = resultAxis.positionResolver().getHostPositionItemInfo(position, memberIndex);
		var itemPosition = hostPosition.item(position.item(memberIndex).key());
		itemPosition.isExpanded(false);
		var subResult = $self.getSubResult($self.visibleResult(), rowAxis, columnAxis, $self.hasRows(), $self.hasColumns());
		return new $.ig.OlapResultView($self.result(), subResult, $self.hasColumns(), $self.hasRows());
	}

	, 
	extend: function (partialResult, axisName) {
		var $self = this;
		var cellsAxis = $self.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var isRowAxis = (axisName == "Axis0" && !$self.hasColumns()) || (axisName == "Axis1" && $self.hasRows());
		var rowsVisibleAxis = null;
		var columnsVisibleAxis = null;
		var fullOpositeAxis = null;
		var resetCache = false;
		if (isRowAxis) {
			rowsVisibleAxis = cellsAxis;
			if ($self.hasColumns()) {
				columnsVisibleAxis = $self.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
				fullOpositeAxis = $self.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
				resetCache = columnsVisibleAxis.tuples().count() != fullOpositeAxis.tuples().count();
			}


		} else {
			columnsVisibleAxis = cellsAxis;
			if ($self.hasRows()) {
				rowsVisibleAxis = $self.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
				fullOpositeAxis = $self.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
				resetCache = rowsVisibleAxis.tuples().count() != fullOpositeAxis.tuples().count();
			}

		}

		var result = null;
		var visibleResult = null;
		if (fullOpositeAxis != null && resetCache) {
			var subResult = $self.getSubResult($self.result(), rowsVisibleAxis, columnsVisibleAxis, $self.hasRows(), $self.hasColumns());
			result = $self.extendResult(subResult, partialResult, axisName);
			visibleResult = $self.extendResult(subResult, partialResult, axisName);

		} else {
			result = $self.extendResult($self.result(), partialResult, axisName);
			visibleResult = $self.extendResult($self.visibleResult(), partialResult, axisName);
		}

		return new $.ig.OlapResultView(result, visibleResult, $self.hasColumns(), $self.hasRows());
	}

	, 
	extendResult: function (result, partialResult, axisName) {
		var $self = this;
		var axisToExtend = result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		if (axisToExtend == null) {
			return null;
		}

		var sourceAxis = partialResult.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var isRowAxis = (axisName == "Axis0" && !$self.hasColumns()) || (axisName == "Axis1" && $self.hasRows());
		var opositeAxisToExtend = null;
		var opositeSourceAxis = null;
		if (isRowAxis) {
			if ($self.hasColumns()) {
				opositeAxisToExtend = result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
				opositeSourceAxis = partialResult.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
			}


		} else {
			if ($self.hasRows()) {
				opositeAxisToExtend = result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
				opositeSourceAxis = partialResult.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() != axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
			}

		}

		var tuples = new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 0);
		var en = axisToExtend.tuples().getEnumerator();
		while (en.moveNext()) {
			var tuple = en.current();
			tuples.add(tuple.clone());
		}

		var en1 = sourceAxis.tuples().getEnumerator();
		while (en1.moveNext()) {
			var tuple1 = en1.current();
			tuples.add(tuple1);
		}

		var sourceAxisTuplesCount = sourceAxis.tuples().count();
		var opositeSourceAxisTuplesCount = opositeSourceAxis != null && opositeSourceAxis.tuples().count() > 0 ? opositeSourceAxis.tuples().count() : 1;
		var axisToExtendTuplesCount = axisToExtend.tuples().count() > 0 ? axisToExtend.tuples().count() : 1;
		var notChangedAxisTuplesCount = opositeAxisToExtend != null && opositeAxisToExtend.tuples().count() > 0 ? opositeAxisToExtend.tuples().count() : 1;
		var cellsArrayMaxSize = axisToExtendTuplesCount * notChangedAxisTuplesCount;
		var cells = new $.ig.List$1($.ig.OlapResultCell.prototype.$type, 0);
		if (isRowAxis) {
			var en2 = result.cells().getEnumerator();
			while (en2.moveNext()) {
				var cell = en2.current();
				cells.add(cell.clone());
			}

			var newCells = new Array(sourceAxisTuplesCount * notChangedAxisTuplesCount);
			var offset = axisToExtendTuplesCount * notChangedAxisTuplesCount;
			var en3 = partialResult.cells().getEnumerator();
			while (en3.moveNext()) {
				var cell1 = en3.current();
				var newCell = cell1.clone();
				var columnIndex = $self.getMappedCellColumnIndex(newCell.cellOrdinal(), opositeAxisToExtend, opositeSourceAxis);
				var currentRowIndex = $.ig.intDivide(newCell.cellOrdinal(), opositeSourceAxisTuplesCount);
				newCell.cellOrdinal(currentRowIndex * notChangedAxisTuplesCount + columnIndex);
				newCell.cellOrdinal(newCell.cellOrdinal() + cellsArrayMaxSize);
				newCells[newCell.cellOrdinal() - offset] = newCell;
			}

			for (var i = 0; i < newCells.length; i++) {
				var newCell1 = newCells[i];
				if (newCell1 != null) {
					cells.add(newCell1);
				}

			}


		} else {
			var cellsArray = new Array(notChangedAxisTuplesCount * (axisToExtendTuplesCount + sourceAxisTuplesCount));
			var en4 = result.cells().getEnumerator();
			while (en4.moveNext()) {
				var cell2 = en4.current();
				var newCell2 = cell2.clone();
				var rowIndex = $.ig.intDivide(newCell2.cellOrdinal(), axisToExtendTuplesCount);
				newCell2.cellOrdinal(newCell2.cellOrdinal() + rowIndex * sourceAxisTuplesCount);
				cellsArray[newCell2.cellOrdinal()] = newCell2;
			}

			var en5 = partialResult.cells().getEnumerator();
			while (en5.moveNext()) {
				var cell3 = en5.current();
				var newCell3 = cell3.clone();
				var rowIndex1 = $self.getMappedCellRowIndex(newCell3.cellOrdinal(), opositeAxisToExtend, opositeSourceAxis, sourceAxisTuplesCount);
				var currentRowIndex1 = $.ig.intDivide(cell3.cellOrdinal(), sourceAxisTuplesCount);
				if (rowIndex1 != currentRowIndex1) {
				}

				var currentColumnIndex = newCell3.cellOrdinal() % sourceAxisTuplesCount;
				newCell3.cellOrdinal(rowIndex1 * sourceAxisTuplesCount + currentColumnIndex);
				newCell3.cellOrdinal(newCell3.cellOrdinal() + (rowIndex1 + 1) * axisToExtendTuplesCount);
				cellsArray[newCell3.cellOrdinal()] = newCell3;
			}

			for (var i1 = 0; i1 < cellsArray.length; i1++) {
				var cell4 = cellsArray[i1];
				if (cell4 != null) {
					cells.add(cell4);
				}

			}

		}

		var combinedResult = new $.ig.OlapResult();
		combinedResult.axes(new $.ig.List$1($.ig.OlapResultAxis.prototype.$type, 0));
		var combinedAxis = (function () { var $ret = new $.ig.OlapResultAxis(tuples, axisToExtend.tupleSize());
		$ret.name(axisToExtend.name()); return $ret;}());
		if (isRowAxis) {
			if (opositeAxisToExtend != null) {
				combinedResult.axes().add(opositeAxisToExtend);
			}

			combinedResult.axes().add(combinedAxis);

		} else {
			combinedResult.axes().add(combinedAxis);
			if (opositeAxisToExtend != null) {
				combinedResult.axes().add(opositeAxisToExtend);
			}

		}

		combinedResult.cells(cells);
		combinedResult.isEmpty(!$self.hasColumns() && !$self.hasRows() && cells.count() == 0);
		return combinedResult;
	}

	, 
	getMappedCellColumnIndex: function (cellOrdinal, targetAxis, sourceAxis) {
		if (sourceAxis == null) {
			return 0;
		}

		var columnIndex = cellOrdinal % sourceAxis.tuples().count();
		var tuple = sourceAxis.tuples().__inner[columnIndex];
		var tupleIndex = targetAxis.positionResolver().getPositionIndex(tuple);
		return tupleIndex;
	}

	, 
	getMappedCellRowIndex: function (cellOrdinal, targetAxis, sourceAxis, columnsCount) {
		if (sourceAxis == null) {
			return 0;
		}

		var rowIndex = $.ig.intDivide(cellOrdinal, columnsCount);
		var tuple = sourceAxis.tuples().__inner[rowIndex];
		var tupleIndex = targetAxis.positionResolver().getPositionIndex(tuple);
		return tupleIndex;
	}

	, 
	getChildrenPositionIndexes: function (axisName, tupleIndex, memberIndex, result) {
		var $self = this;
		var cellAxis = result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var position = cellAxis.tuples().__inner[tupleIndex];
		var positionItem = position.item(memberIndex);
		if (cellAxis.positionResolver().hasUnregisterdPositions()) {
			cellAxis.positionResolver().completeRegisterPositions();
		}

		var indexList = cellAxis.positionResolver().getChildPositionsIndexes(positionItem, $.ig.ListSortDirection.prototype.ascending);
		if (indexList != null) {
			return indexList.toList$1($.ig.Number.prototype.$type);
		}

		return null;
	}

	, 
	getPositionItem: function (axisName, tupleIndex, memberIndex, result) {
		var $self = this;
		var cellAxis = result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var position = cellAxis.tuples().__inner[tupleIndex];
		var positionItem = position.item(memberIndex);
		if (cellAxis.positionResolver().hasUnregisterdPositions()) {
			cellAxis.positionResolver().completeRegisterPositions();
		}

		var hostPositionInfo = cellAxis.positionResolver().getHostPositionItemInfo(position, memberIndex);
		var positionInfo;
		(function () { var $ret = hostPositionInfo.tryGetValue(positionItem.key(), positionInfo); positionInfo = $ret.value; return $ret.ret; }());
		return positionInfo;
	}
	, 
	$type: new $.ig.Type('OlapResultView', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ResultViewHelper', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	setPositionIsExpaned2: function (axisName, tupleIndex, memberIndex, isExpanded, resultView) {
		$.ig.ResultViewHelper.prototype.setPositionIsExpaned1(axisName, tupleIndex, memberIndex, true, resultView.visibleResult());
		$.ig.ResultViewHelper.prototype.setPositionIsExpaned1(axisName, tupleIndex, memberIndex, true, resultView.result());
	}

	, 
	syncPositionExpansionState: function (axisName, sourceResultView, targetResultView) {
		var $self = this;
		var sourceVisibleAxis = sourceResultView.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (ax) { return ax.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var targetVisibleAxis = targetResultView.visibleResult().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (ax) { return ax.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		$.ig.ResultViewHelper.prototype.setExpansionStates1(sourceVisibleAxis.positionResolver(), targetVisibleAxis.positionResolver());
		var sourceAxis = sourceResultView.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (ax) { return ax.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		var targetAxis = targetResultView.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (ax) { return ax.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		$.ig.ResultViewHelper.prototype.setExpansionStates1(sourceAxis.positionResolver(), targetAxis.positionResolver());
	}

	, 
	setPositionIsExpaned1: function (axisName, tupleIndex, memberIndex, isExpanded, result) {
		var $self = this;
		var resultAxis = result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (a) { return a.name() == axisName; }).first$1($.ig.OlapResultAxis.prototype.$type);
		if (resultAxis.positionResolver().hasUnregisterdPositions()) {
			resultAxis.positionResolver().completeRegisterPositions();
		}

		$.ig.ResultViewHelper.prototype.setPositionIsExpaned(tupleIndex, memberIndex, isExpanded, resultAxis.positionResolver());
	}

	, 
	setPositionIsExpaned: function (tupleIndex, memberIndex, isExpanded, targetResolver) {
		if (targetResolver.hasUnregisterdPositions()) {
			targetResolver.completeRegisterPositions();
		}

		var position = targetResolver.positions().__inner[tupleIndex];
		var hostPosition = targetResolver.getHostPositionItemInfo(position, memberIndex);
		var itemPosition = hostPosition.item(position.item(memberIndex).key());
		itemPosition.isExpanded(isExpanded);
	}

	, 
	setExpansionStates1: function (source, target) {
		if (source.hasUnregisterdPositions()) {
			source.completeRegisterPositions();
		}

		if (target.hasUnregisterdPositions()) {
			target.completeRegisterPositions();
		}

		$.ig.ResultViewHelper.prototype.setExpansionStates(source.rootPositionInfo(), target.rootPositionInfo());
	}

	, 
	setExpansionStates: function (source, target) {
		var $self = this;
		var en = source.getEnumerator();
		while (en.moveNext()) {
			var sourcePositionInfo = en.current();
			var sourceItem = sourcePositionInfo.value();
			var targetItem;
			if ((function () { var $ret = target.tryGetValue(sourcePositionInfo.key(), targetItem); targetItem = $ret.value; return $ret.ret; }())) {
				if (sourceItem.isExpanded() != true) {
					targetItem.isExpanded(false);
				}

				if (targetItem.count() > 0) {
					$.ig.ResultViewHelper.prototype.setExpansionStates(sourceItem, targetItem);
				}

			}

		}

	}
	, 
	$type: new $.ig.Type('ResultViewHelper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapTableViewHeaderCell', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.columnSpan(1);
			this.rowSpan(1);
	}

	, 
	_id: null,
	id: function (value) {
		if (arguments.length === 1) {
			this._id = value;
			return value;
		} else {
			return this._id;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_isExpanded: false,
	isExpanded: function (value) {
		if (arguments.length === 1) {
			this._isExpanded = value;
			return value;
		} else {
			return this._isExpanded;
		}
	}

	, 
	_isExpandable: false,
	isExpandable: function (value) {
		if (arguments.length === 1) {
			this._isExpandable = value;
			return value;
		} else {
			return this._isExpandable;
		}
	}

	, 
	_rowIndex: 0,
	rowIndex: function (value) {
		if (arguments.length === 1) {
			this._rowIndex = value;
			return value;
		} else {
			return this._rowIndex;
		}
	}

	, 
	_rowSpan: 0,
	rowSpan: function (value) {
		if (arguments.length === 1) {
			this._rowSpan = value;
			return value;
		} else {
			return this._rowSpan;
		}
	}

	, 
	_columnIndex: 0,
	columnIndex: function (value) {
		if (arguments.length === 1) {
			this._columnIndex = value;
			return value;
		} else {
			return this._columnIndex;
		}
	}

	, 
	_columnSpan: 0,
	columnSpan: function (value) {
		if (arguments.length === 1) {
			this._columnSpan = value;
			return value;
		} else {
			return this._columnSpan;
		}
	}

	, 
	_axisName: null,
	axisName: function (value) {
		if (arguments.length === 1) {
			this._axisName = value;
			return value;
		} else {
			return this._axisName;
		}
	}

	, 
	_tupleIndex: 0,
	tupleIndex: function (value) {
		if (arguments.length === 1) {
			this._tupleIndex = value;
			return value;
		} else {
			return this._tupleIndex;
		}
	}

	, 
	_memberIndex: 0,
	memberIndex: function (value) {
		if (arguments.length === 1) {
			this._memberIndex = value;
			return value;
		} else {
			return this._memberIndex;
		}
	}

	, 
	_levelNumber: 0,
	levelNumber: function (value) {
		if (arguments.length === 1) {
			this._levelNumber = value;
			return value;
		} else {
			return this._levelNumber;
		}
	}

	, 
	_hierarchyNumber: 0,
	hierarchyNumber: function (value) {
		if (arguments.length === 1) {
			this._hierarchyNumber = value;
			return value;
		} else {
			return this._hierarchyNumber;
		}
	}

	, 
	toString: function () {
		return this.caption();
	}
	, 
	$type: new $.ig.Type('OlapTableViewHeaderCell', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapTableViewResultCell', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_value: null,
	value: function (value) {
		if (arguments.length === 1) {
			this._value = value;
			return value;
		} else {
			return this._value;
		}
	}

	, 
	_formattedValue: null,
	formattedValue: function (value) {
		if (arguments.length === 1) {
			this._formattedValue = value;
			return value;
		} else {
			return this._formattedValue;
		}
	}

	, 
	_cellOrdinal: 0,
	cellOrdinal: function (value) {
		if (arguments.length === 1) {
			this._cellOrdinal = value;
			return value;
		} else {
			return this._cellOrdinal;
		}
	}

	, 
	_resultCellIndex: 0,
	resultCellIndex: function (value) {
		if (arguments.length === 1) {
			this._resultCellIndex = value;
			return value;
		} else {
			return this._resultCellIndex;
		}
	}
	, 
	$type: new $.ig.Type('OlapTableViewResultCell', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ArrayListCollection$1', 'Object', {
	$t: null, 
	init: function ($t) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.inner(new $.ig.Array());
	}

	, 
	_inner: null,
	inner: function (value) {
		if (arguments.length === 1) {
			this._inner = value;
			return value;
		} else {
			return this._inner;
		}
	}
	, 
	collectionChanged: null
	, 
	indexOf: function (item) {
		return this.inner().indexOf(item);
	}

	, 
	insert: function (index, item) {
		this.inner().insert(index, item);
		this.triggerItemAdded(index, item);
	}

	, 
	removeAt: function (index) {
		var item = this.inner()[index];
		this.inner().removeAt(index);
		this.triggerItemRemoved(index, item);
	}

	, 
	item: function (index, value) {
		if (arguments.length === 2) {

			this.inner()[index] = value;
			return value;
		} else {

			return this.inner()[index];
		}
	}

	, 
	add: function (item) {
		this.inner().add(item);
		this.triggerItemAdded(this.inner().length - 1, item);
	}

	, 
	clear: function () {
		this.inner().clear();
		this.triggerClear();
	}

	, 
	contains: function (item) {
		return this.inner().contains(item);
	}

	, 
	copyTo: function (array, arrayIndex) {
		throw new $.ig.NotImplementedException();
	}

	, 
	count: function () {

			return this.inner().length;
	}

	, 
	isReadOnly: function () {

			return false;
	}

	, 
	remove: function (item) {
		var index = this.inner().indexOf(item);
		if (index >= 0) {
			this.inner().removeAt(index);
			this.triggerItemRemoved(index, item);
			return true;
		}

		return false;
	}

	, 
	enumerate: function () {
		var $self = this;
		var $iter = function () { return function () { return {
			$state: 0,
			$this: $self,
			$current: null,
			$i : 0,
			getEnumerator: function() {
				if (this.$state === -1) {
					this.$state = 0;
				}
				return this;
			},
			current: function () {
				return this.$current;
			},
			moveNext: function() {
				do {
					switch (this.$state) {
						case 0:
								this.$state = 1;
								break;
							case 1:
																this.$i = 0;
								this.$state = 5;
								break;
														case 2:
									this.$current = this.$this.inner()[this.$i];
									this.$state = 3;
									return true;
								case 3:

								this.$state = 4;
								break;
case 4:
								this.$i++;
								this.$state = 5;
								break;
							case 5:
								if (this.$i < this.$this.inner().length) {
									this.$state = 2;
								}
								else {
									this.$state = 6;
								}
								break;
							case 6:

							this.$state = -2;
							break;
						case -2:
							return false;
					}
				} while (this.$state > 0);
			}
		}; } () };
		return new $.ig.GenericEnumerable$1(this.$t, $iter);
	}

	, 
	getEnumerator: function () {
		return this.enumerate().getEnumerator();
	}

	, 
	triggerItemAdded: function (index, item) {
		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.add, item, index);
			this.collectionChanged(this, args);
		}

	}

	, 
	triggerItemRemoved: function (index, item) {
		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.remove, item, index);
			this.collectionChanged(this, args);
		}

	}

	, 
	triggerClear: function () {
		if (this.collectionChanged != null) {
			var args = new $.ig.NotifyCollectionChangedEventArgs(1, $.ig.NotifyCollectionChangedAction.prototype.reset, null, -1);
			this.collectionChanged(this, args);
		}

	}
	, 
	$type: new $.ig.Type('ArrayListCollection$1', $.ig.Object.prototype.$type, [$.ig.IList$1.prototype.$type.specialize(0), $.ig.INotifyCollectionChanged.prototype.$type])
}, true);

$.ig.util.defType('IOlapDataSource', 'Object', {
	$type: new $.ig.Type('IOlapDataSource', null)
}, true);

$.ig.util.defType('MeasureList', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	uniqueName: function (value) {
		if (arguments.length === 1) {

			this.name(value);
			return value;
		} else {

			return this.name();
		}
	}

	, 
	_measures: null,
	measures: function (value) {
		if (arguments.length === 1) {
			this._measures = value;
			return value;
		} else {
			return this._measures;
		}
	}
	, 
	$type: new $.ig.Type('MeasureList', $.ig.Object.prototype.$type, [$.ig.ICoreOlapElement.prototype.$type])
}, true);

$.ig.util.defType('OlapMetadataTreeItem', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_item: null,
	item: function (value) {
		if (arguments.length === 1) {
			this._item = value;
			return value;
		} else {
			return this._item;
		}
	}

	, 
	_type: null,
	type: function (value) {
		if (arguments.length === 1) {
			this._type = value;
			return value;
		} else {
			return this._type;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_children: null,
	children: function (value) {
		if (arguments.length === 1) {
			this._children = value;
			return value;
		} else {
			return this._children;
		}
	}

	, 
	addChild: function (metaItem) {
		if (this.children() == null) {
			this.children(new Array(1));
			this.children()[0] = metaItem;
			return;
		}

		var children = new Array(this.children().length + 1);
		$.ig.Array.prototype.copy(this.children(), 0, children, 0, this.children().length);
		children[this.children().length] = metaItem;
		this.children(children);
	}
	, 
	$type: new $.ig.Type('OlapMetadataTreeItem', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapDataSource', 'Object', {
	__positionsToExpand: null
	, 
	__positionsToCollapse: null
	, 
	__measureListIndex: 0
	, 
	__measureListLocation: null
	, 
	__dataProviderFactory: null
	, 
	init: function (options) {


		var $self = this;
		this.__positionsToExpand = new $.ig.List$1($.ig.PositionInfo.prototype.$type, 0);
		this.__positionsToCollapse = new $.ig.List$1($.ig.PositionInfo.prototype.$type, 0);
		this._membersSelectionChangedList = new $.ig.List$1(String, 0);

		$.ig.Object.prototype.init.call(this);
			this.columnFilters(new $.ig.List$1($.ig.AxisElement.prototype.$type, 0));
			this.rowFilters(new $.ig.List$1($.ig.AxisElement.prototype.$type, 0));
			this.filterFilters(new $.ig.List$1($.ig.AxisElement.prototype.$type, 0));
			this.isInitializing(false);
			this.initializeTask(null);
			this.isUpdating(false);
			this.updateTask(null);
			this.isInitialized(false);
			this.isColumnsAxisChanged(false);
			this.isRowsAxisChanged(false);
			this.isFiltersAxisChanged(false);
			this.isMeasuresAxisChanged(false);
			this.isMeasureListLocationChanged(false);
			this.isMeasureListIndexChanging(false);
			this.catalogs(new $.ig.ArrayListCollection$1($.ig.Catalog.prototype.$type));
			this.cubes(new $.ig.ArrayListCollection$1($.ig.Cube.prototype.$type));
			this.measureGroups(new $.ig.ArrayListCollection$1($.ig.MeasureGroup.prototype.$type));
			this.rowAxis(new $.ig.ArrayListCollection$1($.ig.ICoreOlapElement.prototype.$type));
			this.columnAxis(new $.ig.ArrayListCollection$1($.ig.ICoreOlapElement.prototype.$type));
			this.filters(new $.ig.ArrayListCollection$1($.ig.Hierarchy.prototype.$type));
			this.measures(new $.ig.ArrayListCollection$1($.ig.Measure.prototype.$type));
			this.measureListLocation($.ig.MeasureListLocation.prototype.columns);
			this.measureListIndex(-1);
			this.sourceOptions(options);
			this.result((function () { var $ret = new $.ig.OlapResult();
			$ret.isEmpty(true); return $ret;}()));
	}

	, 
	_isInitialized: false,
	isInitialized: function (value) {
		if (arguments.length === 1) {
			this._isInitialized = value;
			return value;
		} else {
			return this._isInitialized;
		}
	}

	, 
	_catalogs: null,
	catalogs: function (value) {
		if (arguments.length === 1) {
			this._catalogs = value;
			return value;
		} else {
			return this._catalogs;
		}
	}

	, 
	_cubes: null,
	cubes: function (value) {
		if (arguments.length === 1) {
			this._cubes = value;
			return value;
		} else {
			return this._cubes;
		}
	}

	, 
	_cube: null,
	cube: function (value) {
		if (arguments.length === 1) {
			this._cube = value;
			return value;
		} else {
			return this._cube;
		}
	}

	, 
	_measureGroup: null,
	measureGroup: function (value) {
		if (arguments.length === 1) {
			this._measureGroup = value;
			return value;
		} else {
			return this._measureGroup;
		}
	}

	, 
	_measureGroups: null,
	measureGroups: function (value) {
		if (arguments.length === 1) {
			this._measureGroups = value;
			return value;
		} else {
			return this._measureGroups;
		}
	}

	, 
	_sourceOptions: null,
	sourceOptions: function (value) {
		if (arguments.length === 1) {
			this._sourceOptions = value;
			return value;
		} else {
			return this._sourceOptions;
		}
	}

	, 
	dataProviderFactory: function (value) {
		if (arguments.length === 1) {

			this.__dataProviderFactory = value;
			return value;
		} else {

			if (this.__dataProviderFactory == null) {
				this.__dataProviderFactory = this.createOlapDataProviderFactory();
			}

			return this.__dataProviderFactory;
		}
	}

	, 
	_metadataTree: null,
	metadataTree: function (value) {
		if (arguments.length === 1) {
			this._metadataTree = value;
			return value;
		} else {
			return this._metadataTree;
		}
	}

	, 
	_rowAxis: null,
	rowAxis: function (value) {
		if (arguments.length === 1) {
			this._rowAxis = value;
			return value;
		} else {
			return this._rowAxis;
		}
	}

	, 
	_columnAxis: null,
	columnAxis: function (value) {
		if (arguments.length === 1) {
			this._columnAxis = value;
			return value;
		} else {
			return this._columnAxis;
		}
	}

	, 
	_filters: null,
	filters: function (value) {
		if (arguments.length === 1) {
			this._filters = value;
			return value;
		} else {
			return this._filters;
		}
	}

	, 
	_measures: null,
	measures: function (value) {
		if (arguments.length === 1) {
			this._measures = value;
			return value;
		} else {
			return this._measures;
		}
	}

	, 
	measureListIndex: function (value) {
		if (arguments.length === 1) {

			if (this.__measureListIndex != value) {
				this.isMeasureListIndexChanging(true);
				this.__measureListIndex = value;
				this.updateMeasureList();
				this.isMeasureListIndexChanging(false);
			}

			return value;
		} else {

			return this.__measureListIndex;
		}
	}

	, 
	measureListLocation: function (value) {
		if (arguments.length === 1) {

			if (this.__measureListLocation != value) {
				this.removeMeasureList();
				this.__measureListLocation = value;
				this.updateMeasureList();
			}

			return value;
		} else {

			return this.__measureListLocation;
		}
	}

	, 
	_result: null,
	result: function (value) {
		if (arguments.length === 1) {
			this._result = value;
			return value;
		} else {
			return this._result;
		}
	}

	, 
	_resultView: null,
	resultView: function (value) {
		if (arguments.length === 1) {
			this._resultView = value;
			return value;
		} else {
			return this._resultView;
		}
	}

	, 
	_cubeCache: null,
	cubeCache: function (value) {
		if (arguments.length === 1) {
			this._cubeCache = value;
			return value;
		} else {
			return this._cubeCache;
		}
	}

	, 
	_columnFilters: null,
	columnFilters: function (value) {
		if (arguments.length === 1) {
			this._columnFilters = value;
			return value;
		} else {
			return this._columnFilters;
		}
	}

	, 
	_rowFilters: null,
	rowFilters: function (value) {
		if (arguments.length === 1) {
			this._rowFilters = value;
			return value;
		} else {
			return this._rowFilters;
		}
	}

	, 
	_filterFilters: null,
	filterFilters: function (value) {
		if (arguments.length === 1) {
			this._filterFilters = value;
			return value;
		} else {
			return this._filterFilters;
		}
	}
	, 
	_membersSelectionChangedList: null

	, 
	_isInitializing: false,
	isInitializing: function (value) {
		if (arguments.length === 1) {
			this._isInitializing = value;
			return value;
		} else {
			return this._isInitializing;
		}
	}

	, 
	_initializeTask: null,
	initializeTask: function (value) {
		if (arguments.length === 1) {
			this._initializeTask = value;
			return value;
		} else {
			return this._initializeTask;
		}
	}

	, 
	_isUpdating: false,
	isUpdating: function (value) {
		if (arguments.length === 1) {
			this._isUpdating = value;
			return value;
		} else {
			return this._isUpdating;
		}
	}

	, 
	_updateTask: null,
	updateTask: function (value) {
		if (arguments.length === 1) {
			this._updateTask = value;
			return value;
		} else {
			return this._updateTask;
		}
	}

	, 
	_isColumnsAxisChanged: false,
	isColumnsAxisChanged: function (value) {
		if (arguments.length === 1) {
			this._isColumnsAxisChanged = value;
			return value;
		} else {
			return this._isColumnsAxisChanged;
		}
	}

	, 
	_isRowsAxisChanged: false,
	isRowsAxisChanged: function (value) {
		if (arguments.length === 1) {
			this._isRowsAxisChanged = value;
			return value;
		} else {
			return this._isRowsAxisChanged;
		}
	}

	, 
	_isFiltersAxisChanged: false,
	isFiltersAxisChanged: function (value) {
		if (arguments.length === 1) {
			this._isFiltersAxisChanged = value;
			return value;
		} else {
			return this._isFiltersAxisChanged;
		}
	}

	, 
	_isMeasuresAxisChanged: false,
	isMeasuresAxisChanged: function (value) {
		if (arguments.length === 1) {
			this._isMeasuresAxisChanged = value;
			return value;
		} else {
			return this._isMeasuresAxisChanged;
		}
	}

	, 
	_isMeasureListLocationChanged: false,
	isMeasureListLocationChanged: function (value) {
		if (arguments.length === 1) {
			this._isMeasureListLocationChanged = value;
			return value;
		} else {
			return this._isMeasureListLocationChanged;
		}
	}

	, 
	_isMeasureListIndexChanging: false,
	isMeasureListIndexChanging: function (value) {
		if (arguments.length === 1) {
			this._isMeasureListIndexChanging = value;
			return value;
		} else {
			return this._isMeasureListIndexChanging;
		}
	}

	, 
	getMembersOfLevel: function (levelUniqueName) {
	}

	, 
	getMembersOfHierarchy: function (hierarchyUniqueName) {
	}

	, 
	getMembersOfMember: function (memberUniqueName) {
	}

	, 
	setCube: function (cubeName) {
		if (!this.isInitialized()) {
			throw new $.ig.InvalidOperationException(1, "Data source is not initialized.");
		}

		return this.onSetCube(cubeName);
	}

	, 
	setMeasureGroup: function (measureGroupName) {
		if (!this.isInitialized()) {
			throw new $.ig.InvalidOperationException(1, "Data source is not initialized.");
		}

		return this.onSetMeasureGroup(measureGroupName);
	}

	, 
	getCoreElement: function (predicate, elementType) {
		if (elementType == $.ig.MeasureList.prototype.$type) {
			var measureListAxis;
			if (this.measureListLocation() == $.ig.MeasureListLocation.prototype.columns) {
				measureListAxis = this.columnAxis();

			} else {
				measureListAxis = this.rowAxis();
			}

			var measureList = null;
			var en = measureListAxis.getEnumerator();
			while (en.moveNext()) {
				var coreOlapElement = en.current();
				measureList = $.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement);
				if (measureList != null) {
					break;
				}

			}

			return measureList;

		} else {
			return this.getCoreElements(predicate, elementType).firstOrDefault$1($.ig.ICoreOlapElement.prototype.$type);
		}

	}

	, 
	getCoreElements: function (predicate, elementType) {
		var $self = this;
		if (elementType == $.ig.Dimension.prototype.$type) {
			return $self.toArrayListCollection$1($.ig.Dimension.prototype.$type, $self.cubeCache().dimensionItems().where$1($.ig.Dimension.prototype.$type, function (d) { return predicate(d); }));
		}

		if (elementType == $.ig.Hierarchy.prototype.$type) {
			return $self.toArrayListCollection$1($.ig.Hierarchy.prototype.$type, $self.cubeCache().hierarchyItems().where$1($.ig.Hierarchy.prototype.$type, function (d) { return predicate(d); }));
		}

		if (elementType == $.ig.Level.prototype.$type) {
			return $self.toArrayListCollection$1($.ig.Level.prototype.$type, $self.cubeCache().levelItems().where$1($.ig.Level.prototype.$type, function (d) { return predicate(d); }));
		}

		if (elementType == $.ig.Measure.prototype.$type) {
			return $self.toArrayListCollection$1($.ig.Measure.prototype.$type, $self.cubeCache().measures().where$1($.ig.Measure.prototype.$type, function (d) { return predicate(d); }));
		}

		if (elementType == $.ig.KpiMeasure.prototype.$type) {
			return $self.toArrayListCollection$1($.ig.KpiMeasure.prototype.$type, $self.cubeCache().kpiMeasures().where$1($.ig.KpiMeasure.prototype.$type, function (d) { return predicate(d); }));
		}

		if (elementType == $.ig.Kpi.prototype.$type) {
			return $self.toArrayListCollection$1($.ig.Kpi.prototype.$type, $self.cubeCache().kpis().where$1($.ig.Kpi.prototype.$type, function (d) { return predicate(d); }));
		}

		throw new $.ig.NotSupportedException(0, "Supported types are Dimension, Hierarchy, Level and Measure");
	}

	, 
	expandTupleMember: function (axisName, tupleIndex, memberIndex) {
		var $self = this;
		var resultAxis = $self.getResultAxis(axisName, $self.result());
		if (resultAxis == null) {
			throw new $.ig.InvalidOperationException(1, "No axis found for the specified index.");
		}

		var positionInfo = $self.__positionsToExpand.where$1($.ig.PositionInfo.prototype.$type, function (pi) { return pi.axisName() == axisName && pi.tupleIndex() == tupleIndex && pi.memberIndex() == memberIndex; }).firstOrDefault$1($.ig.PositionInfo.prototype.$type);
		if (positionInfo == null) {
			positionInfo = (function () { var $ret = new $.ig.PositionInfo();
			$ret.axisName(axisName);
			$ret.memberIndex(memberIndex);
			$ret.tupleIndex(tupleIndex); return $ret;}());
			$self.__positionsToExpand.add(positionInfo);

		} else {
			$self.__positionsToExpand.remove(positionInfo);
		}

	}

	, 
	collapseTupleMember: function (axisName, tupleIndex, memberIndex) {
		var $self = this;
		var resultAxis = $self.getResultAxis(axisName, $self.result());
		if (resultAxis == null) {
			throw new $.ig.InvalidOperationException(1, "No axis found for the specified index.");
		}

		var positionInfo = $self.__positionsToExpand.where$1($.ig.PositionInfo.prototype.$type, function (pi) { return pi.axisName() == axisName && pi.tupleIndex() == tupleIndex && pi.memberIndex() == memberIndex; }).firstOrDefault$1($.ig.PositionInfo.prototype.$type);
		if (positionInfo == null) {
			positionInfo = (function () { var $ret = new $.ig.PositionInfo();
			$ret.axisName(axisName);
			$ret.memberIndex(memberIndex);
			$ret.tupleIndex(tupleIndex); return $ret;}());
			$self.__positionsToCollapse.add(positionInfo);

		} else {
			$self.__positionsToExpand.remove(positionInfo);
		}

	}

	, 
	clearPendingChanges: function () {
		this.__positionsToCollapse.clear();
		this.__positionsToExpand.clear();
	}

	, 
	update: function () {
		var $self = this;
		if ($self.isUpdating()) {
			return $self.updateTask();
		}

		$self.isUpdating(true);
		if ($self.__positionsToExpand.count() > 0) {
			var loadExpandedMembers = $self.loadExpandedMemberSiblings($self.__positionsToExpand);
			$self.updateTask(loadExpandedMembers.continueWithTask$1($.ig.OlapResult.prototype.$type, function (t) { return $self.onUpdate(); }));

		} else {
			$self.updateTask($self.onUpdate());
		}

		var task = $self.updateTask();
		$self.updateTask().continueWith1(function (t) {
			$self.isUpdating(false);
			$self.updateTask(null);
		});
		return task;
	}

	, 
	initialize: function () {
		var $self = this;
		if ($self.isInitializing()) {
			return $self.initializeTask();
		}

		$self.isInitializing(true);
		$self.initializeTask($self.onInitialize());
		var task = $self.initializeTask();
		$self.initializeTask().continueWith1(function (t) {
			$self.isInitializing(false);
			$self.initializeTask(null);
		});
		return task;
	}

	, 
	addFilterMember: function (hierarchyUniqueName, memberUniqueName) {
		var $self = this;
		var axisElementsCollection;
		var axisElement = (function () { var $ret = $self.findAxisElement(hierarchyUniqueName, axisElementsCollection); axisElementsCollection = $ret.filtersCollection; return $ret.ret; }());
		if (axisElement == null) {
			axisElement = new $.ig.AxisElement(hierarchyUniqueName, (function () { var $ret = new $.ig.ArrayListCollection$1(String);
			$ret.add(memberUniqueName); return $ret;}()));
			axisElementsCollection.add(axisElement);

		} else {
			if (!axisElement.memberNames().contains(memberUniqueName)) {
				axisElement.memberNames().add(memberUniqueName);
				if ($self._membersSelectionChangedList.contains(memberUniqueName)) {
					$self._membersSelectionChangedList.remove(memberUniqueName);

				} else {
					$self._membersSelectionChangedList.add(memberUniqueName);
				}

			}

		}

	}

	, 
	getFilterMemberNames: function (hierarchyUniqueName) {
		var $self = this;
		var axisElementsCollection;
		var axisElement = (function () { var $ret = $self.findAxisElement(hierarchyUniqueName, axisElementsCollection); axisElementsCollection = $ret.filtersCollection; return $ret.ret; }());
		if (axisElement != null) {
			return $self.toArrayListCollection$1(String, axisElement.memberNames());
		}

		return new $.ig.ArrayListCollection$1(String);
	}

	, 
	removeFilterMember: function (hierarchyUniqueName, memberUniqueName) {
		var $self = this;
		var axisElementsCollection;
		var axisElement = (function () { var $ret = $self.findAxisElement(hierarchyUniqueName, axisElementsCollection); axisElementsCollection = $ret.filtersCollection; return $ret.ret; }());
		if (axisElement == null) {
			return;
		}

		if (axisElement.memberNames().remove(memberUniqueName)) {
			if ($self._membersSelectionChangedList.contains(memberUniqueName)) {
				$self._membersSelectionChangedList.remove(memberUniqueName);

			} else {
				$self._membersSelectionChangedList.add(memberUniqueName);
			}

		}

	}

	, 
	removeAllFilterMembers: function (hierarchyUniqueName) {
		var $self = this;
		var axisElementsCollection;
		var axisElement = (function () { var $ret = $self.findAxisElement(hierarchyUniqueName, axisElementsCollection); axisElementsCollection = $ret.filtersCollection; return $ret.ret; }());
		if (axisElement == null) {
			return;
		}

		for (var i = axisElement.memberNames().count() - 1; i >= 0; i--) {
			var memberName = axisElement.memberNames().item(i);
			axisElement.memberNames().removeAt(i);
			if ($self._membersSelectionChangedList.contains(memberName)) {
				$self._membersSelectionChangedList.remove(memberName);

			} else {
				$self._membersSelectionChangedList.add(memberName);
			}

		}

	}

	, 
	getProviderDefaultProperties: function () {
		var properties = new $.ig.List$1($.ig.KeyValueItem.prototype.$type, 0);
		return properties;
	}

	, 
	getProviderDefaultRestrictions: function () {
		var restrictions = new $.ig.List$1($.ig.KeyValueItem.prototype.$type, 0);
		return restrictions;
	}

	, 
	tryGetMember: function (memberUniqueName, member) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.cubeCache().tryGetMember1(memberUniqueName, member); member = $ret.member; return $ret.ret; }()), 
			member: member
		};
		return {
			member: member
		};
	}

	, 
	tryGetMembersForLevel: function (levelUniqueName, members) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.cubeCache().tryGetMembersForLevel(levelUniqueName, members); members = $ret.members; return $ret.ret; }()), 
			members: members
		};
		return {
			members: members
		};
	}

	, 
	onInitialize: function () {
	}

	, 
	onUpdate: function () {
	}

	, 
	createOlapDataProviderFactory: function () {
	}

	, 
	cacheCubeMetaItems: function () {
	}

	, 
	onSetCube: function (cubeName) {
		var $self = this;
		if (String.isNullOrEmpty(cubeName)) {
			if (cubeName == null) {
				throw new $.ig.ArgumentNullException("cubeName");
			}

			throw new $.ig.InvalidOperationException(1, "cubeName cannot be empty.");
		}

		var setCubeCompleted = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		if ($self.cube() != null) {
			if ($self.cube().name() == cubeName) {
				setCubeCompleted.setResult($self.metadataTree());
				return setCubeCompleted.task();
			}

			$self.clearCubeCache();
		}

		var en = $self.cubes().getEnumerator();
		while (en.moveNext()) {
			var cube = en.current();
			if (cube.name() == cubeName) {
				$self.cube(cube);
				break;
			}

		}

		var cacheCubeItemsTask = $self.cacheCubeMetaItems();
		if (!$self.isInitialized()) {
			var measureGroupName = $self.sourceOptions().measureGroup();
			if (!String.isNullOrEmpty(measureGroupName)) {
				return cacheCubeItemsTask.continueWithTask$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) { return $self.onSetMeasureGroup(measureGroupName); });
			}

		}

		return cacheCubeItemsTask.continueWithTask$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t1) { return $self.onSetMeasureGroup(null); });
	}

	, 
	initializeAxes: function () {
		var $self = this;
		var columnElements = null;
		var rowElements = null;
		var filterElements = null;
		var hierarchiesWithFilters = new $.ig.List$1($.ig.AxisElement.prototype.$type, 0);
		if (!String.isNullOrEmpty($self.sourceOptions().columns())) {
			var columnsParser = new $.ig.AxisDefinitionParser($self.sourceOptions().columns());
			columnElements = columnsParser.parse();
		}

		if (!String.isNullOrEmpty($self.sourceOptions().rows())) {
			var rowsParser = new $.ig.AxisDefinitionParser($self.sourceOptions().rows());
			rowElements = rowsParser.parse();
		}

		if (!String.isNullOrEmpty($self.sourceOptions().filters())) {
			var filtersParser = new $.ig.AxisDefinitionParser($self.sourceOptions().filters());
			filterElements = filtersParser.parse();
		}

		if (columnElements != null && columnElements.count() > 0) {
			var en = columnElements.getEnumerator();
			while (en.moveNext()) {
				var axisElement = en.current();
				$self.addCoreElementToAxis$1($.ig.ICoreOlapElement.prototype.$type, axisElement.name(), $self.columnAxis(), $.ig.Hierarchy.prototype.$type);
				$self.columnFilters().add(axisElement);
				if (axisElement.memberNames().count() > 0) {
					hierarchiesWithFilters.add(axisElement);
					var en1 = axisElement.memberNames().getEnumerator();
					while (en1.moveNext()) {
						var memberName = en1.current();
						$self._membersSelectionChangedList.add(memberName);
					}

				}

			}

		}

		if (rowElements != null && rowElements.count() > 0) {
			var en2 = rowElements.getEnumerator();
			while (en2.moveNext()) {
				var axisElement1 = en2.current();
				$self.addCoreElementToAxis$1($.ig.ICoreOlapElement.prototype.$type, axisElement1.name(), $self.rowAxis(), $.ig.Hierarchy.prototype.$type);
				$self.rowFilters().add(axisElement1);
				if (axisElement1.memberNames().count() > 0) {
					hierarchiesWithFilters.add(axisElement1);
					var en3 = axisElement1.memberNames().getEnumerator();
					while (en3.moveNext()) {
						var memberName1 = en3.current();
						$self._membersSelectionChangedList.add(memberName1);
					}

				}

			}

		}

		if (filterElements != null && filterElements.count() > 0) {
			var en4 = filterElements.getEnumerator();
			while (en4.moveNext()) {
				var axisElement2 = en4.current();
				$self.addCoreElementToAxis$1($.ig.Hierarchy.prototype.$type, axisElement2.name(), $self.filters(), $.ig.Hierarchy.prototype.$type);
				$self.filterFilters().add(axisElement2);
				if (axisElement2.memberNames().count() > 0) {
					hierarchiesWithFilters.add(axisElement2);
					var en5 = axisElement2.memberNames().getEnumerator();
					while (en5.moveNext()) {
						var memberName2 = en5.current();
						$self._membersSelectionChangedList.add(memberName2);
					}

				}

			}

		}

		var measureElements = null;
		if (!String.isNullOrEmpty($self.sourceOptions().measures())) {
			var measuresParser = new $.ig.AxisDefinitionParser($self.sourceOptions().measures());
			measureElements = measuresParser.parse();
		}

		if (measureElements != null && measureElements.count() > 0) {
			var en6 = measureElements.getEnumerator();
			while (en6.moveNext()) {
				var measureElement = en6.current();
				$self.addCoreElementToAxis$1($.ig.Measure.prototype.$type, measureElement.name(), $self.measures(), $.ig.Measure.prototype.$type);
			}

		}

		if ($self.isColumnsAxisChanged() || $self.isRowsAxisChanged() || $self.isFiltersAxisChanged() || $self.isMeasuresAxisChanged() || $self.isMeasureListIndexChanging()) {
			if (hierarchiesWithFilters.count() > 0) {
				var tasksToComplete = new Array(hierarchiesWithFilters.count());
				for (var i = 0; i < hierarchiesWithFilters.count(); i++) {
					var hierarchyName = hierarchiesWithFilters.item(i).name();
					tasksToComplete[i] = $self.getMembersOfHierarchy(hierarchyName);
				}

				var tcs1 = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
				var tf = new $.ig.TaskFactory();
				tf.continueWhenAll(tasksToComplete, function (t) {
					$self.onUpdate().continueWith1(function (t1) {
						$self.initializeCompleted();
						tcs1.setResult($self.metadataTree());
					});
				});
				return tcs1.task();
			}

			return $self.onUpdate().continueWithTask$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) {
				$self.initializeCompleted();
				var tcs1 = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
				tcs1.setResult($self.metadataTree());
				return tcs1.task();
			});
		}

		$self.initializeCompleted();
		var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		tcs.setResult($self.metadataTree());
		return tcs.task();
	}

	, 
	loadCubes: function (catalogName) {
		var $self = this;
		var provider = $self.dataProviderFactory().createDataProvider();
		var restrictions = $self.getProviderDefaultRestrictions();
		var properties = $self.getProviderDefaultProperties();
		var task = provider.discoverCubesAsync(properties, restrictions).continueWith$1($.ig.IList$1.prototype.$type.specialize($.ig.Cube.prototype.$type), function (t) {
			$self.cubes($self.toArrayListCollection$1($.ig.Cube.prototype.$type, t.result()));
			return $self.cubes();
		});
		return task;
	}

	, 
	loadMeasureGroups: function () {
		var $self = this;
		var provider = $self.dataProviderFactory().createDataProvider();
		var restrictions = $self.getProviderDefaultRestrictions();
		var properties = $self.getProviderDefaultProperties();
		var task = provider.discoverMeasureGroupsAsync(properties, restrictions).continueWith$1($.ig.IList$1.prototype.$type.specialize($.ig.MeasureGroup.prototype.$type), function (t) {
			$self.measureGroups($self.toArrayListCollection$1($.ig.MeasureGroup.prototype.$type, t.result()));
			return $self.measureGroups();
		});
		return task;
	}

	, 
	initializeCompleted: function () {
		this.isInitialized(true);
	}

	, 
	clearCubeCache: function () {
		this.cube(null);
		this.measureGroups(new $.ig.ArrayListCollection$1($.ig.MeasureGroup.prototype.$type));
		this.filters().clear();
		this.rowAxis().clear();
		this.columnAxis().clear();
		this.measures().clear();
		this.cubeCache(null);
		this.clearMeasureGroupCache();
	}

	, 
	clearMeasureGroupCache: function () {
		this.measureGroup(null);
		this.metadataTree(null);
	}

	, 
	onSetMeasureGroup: function (measureGroupName) {
		var $self = this;
		if ($self.cube() == null) {
			throw new $.ig.InvalidOperationException(1, "Data source has no Cube set.");
		}

		var setMeasueGroupCompleted = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		if ($self.measureGroup() != null) {
			if ($self.measureGroup().name() == measureGroupName) {
				setMeasueGroupCompleted.setResult($self.metadataTree());
				return setMeasueGroupCompleted.task();
			}

			$self.clearMeasureGroupCache();
		}

		if (!String.isNullOrEmpty(measureGroupName) && $self.measureGroups().count() == 0) {
			var setMeasureGroupTask = $self.loadMeasureGroups().continueWithTask$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) {
				if ($self.measureGroups().count() == 0) {
					return $self.onSetMeasureGroup(null);
				}

				return $self.onSetMeasureGroup(measureGroupName);
			});
			return setMeasureGroupTask;
		}

		var en = $self.measureGroups().getEnumerator();
		while (en.moveNext()) {
			var measureGroup = en.current();
			if (measureGroup.name() == measureGroupName) {
				$self.measureGroup(measureGroup);
				break;
			}

		}

		$self.metadataTree($self.createMetadataTree(measureGroupName));
		setMeasueGroupCompleted.setResult($self.metadataTree());
		return setMeasueGroupCompleted.task();
	}

	, 
	createMetadataTree: function (measureGroupName) {
		var $self = this;
		var cubeRoot = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
		$ret.type($.ig.OlapMetadataTreeItemType.prototype.cube);
		$ret.caption($self.cube().caption());
		$ret.item($self.cube()); return $ret;}());
		var dimensions;
		var measures;
		var kpis;
		var createMeasureGroupFolders = true;
		if (String.isNullOrEmpty(measureGroupName) || $self.measureGroups() == null) {
			dimensions = $self.cubeCache().dimensionItems();
			measures = $self.cubeCache().measures();
			kpis = $self.cubeCache().kpis();

		} else {
			createMeasureGroupFolders = false;
			dimensions = $self.cubeCache().measureGroupDimensionsCache().getMeasureGroupDimensions(measureGroupName);
			measures = $self.cubeCache().measureGroupDimensionsCache().getMeasureGroupMeasures(measureGroupName);
			kpis = $self.cubeCache().measureGroupDimensionsCache().getMeasureGroupKpis(measureGroupName);
		}

		var dimensionMetaItems = $.ig.MetaTreeHelper.prototype.getDimensionMetaItems(dimensions, measures, kpis, $self.cubeCache().hierarchyItems(), $self.cubeCache().levelItems(), createMeasureGroupFolders, $self.cubeCache());
		$.ig.MetaTreeHelper.prototype.setMetaItemChildren(cubeRoot, dimensionMetaItems);
		return cubeRoot;
	}

	, 
	getResultAxis: function (axisName, result) {
		var $self = this;
		if (result != null && result.axes().count() > 0) {
			return result.axes().where$1($.ig.OlapResultAxis.prototype.$type, function (ax) { return ax.name() == axisName; }).firstOrDefault$1($.ig.OlapResultAxis.prototype.$type);
		}

		return null;
	}

	, 
	updateAxisState: function (changedEventArgs, filters) {
		var $self = this;
		switch (changedEventArgs.action()) {
			case $.ig.NotifyCollectionChangedAction.prototype.add:
				var en = changedEventArgs.newItems().getEnumerator();
				while (en.moveNext()) {
					var newItem = en.current();
					var hierarchy = $.ig.util.cast($.ig.Hierarchy.prototype.$type, newItem);
					if (hierarchy != null) {
						if ($self.isInitialized()) {
							filters.add(new $.ig.AxisElement(hierarchy.uniqueName(), new $.ig.ArrayListCollection$1(String)));
						}

					}

				}

				break;
			case $.ig.NotifyCollectionChangedAction.prototype.remove:
				var en1 = changedEventArgs.oldItems().getEnumerator();
				while (en1.moveNext()) {
					var oldItem = en1.current();
					var hierarchy1 = $.ig.util.cast($.ig.Hierarchy.prototype.$type, oldItem);
					if (hierarchy1 != null) {
						var axisElement = filters.where$1($.ig.AxisElement.prototype.$type, function (ae) { return ae.name() == hierarchy1.uniqueName(); }).firstOrDefault$1($.ig.AxisElement.prototype.$type);
						if (axisElement != null) {
							var memberNames = new $.ig.List$1(String, 0);
							for (var i = 0; i < axisElement.memberNames().count(); i++) {
								memberNames.add(axisElement.memberNames().item(i));
							}

							for (var i1 = 0; i1 < memberNames.count(); i1++) {
								var memberName = memberNames.item(i1);
								$self.removeFilterMember(axisElement.name(), memberName);
							}

							filters.remove(axisElement);
						}


					} else {
						var measureList = $.ig.util.cast($.ig.MeasureList.prototype.$type, oldItem);
						if (measureList != null) {
							if (!$self.isMeasuresAxisChanged() && !$self.isMeasureListLocationChanged() && !$self.isMeasureListIndexChanging()) {
								$self.measures().clear();
							}

						}

					}

				}

				break;
		}

	}

	, 
	updateMeasureListIndex: function (changedEventArgs, filters) {
		var $self = this;
		switch (changedEventArgs.action()) {
			case $.ig.NotifyCollectionChangedAction.prototype.add:
				var en = changedEventArgs.newItems().getEnumerator();
				while (en.moveNext()) {
					var newItem = en.current();
					var hierarchy = $.ig.util.cast($.ig.Hierarchy.prototype.$type, newItem);
					if (hierarchy != null) {
						var measureList = $.ig.util.cast($.ig.MeasureList.prototype.$type, filters.where$1($.ig.ICoreOlapElement.prototype.$type, function (x) { return $.ig.util.cast($.ig.MeasureList.prototype.$type, x) !== null; }).firstOrDefault$1($.ig.ICoreOlapElement.prototype.$type));
						if (measureList != null && $self.measureListIndex() >= changedEventArgs.newStartingIndex()) {
							$self.measureListIndex($self.measureListIndex() + 1);
						}

					}

				}

				break;
			case $.ig.NotifyCollectionChangedAction.prototype.remove:
				var en1 = changedEventArgs.oldItems().getEnumerator();
				while (en1.moveNext()) {
					var oldItem = en1.current();
					var hierarchy1 = $.ig.util.cast($.ig.Hierarchy.prototype.$type, oldItem);
					if (hierarchy1 != null) {
						var measureList1 = $.ig.util.cast($.ig.MeasureList.prototype.$type, filters.where$1($.ig.ICoreOlapElement.prototype.$type, function (x) { return $.ig.util.cast($.ig.MeasureList.prototype.$type, x) !== null; }).firstOrDefault$1($.ig.ICoreOlapElement.prototype.$type));
						if (measureList1 != null && $self.measureListIndex() > changedEventArgs.oldStartingIndex()) {
							$self.measureListIndex($self.measureListIndex() - 1);
						}

					}

				}

				break;
		}

	}

	, 
	updateMeasureList: function () {
		var $self = this;
		var measureListAxis;
		if ($self.measureListLocation() == $.ig.MeasureListLocation.prototype.columns) {
			measureListAxis = $self.columnAxis();

		} else {
			measureListAxis = $self.rowAxis();
		}

		var measureList = null;
		var measureListIndex = 0;
		var en = measureListAxis.getEnumerator();
		while (en.moveNext()) {
			var coreOlapElement = en.current();
			measureList = $.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement);
			if (measureList != null) {
				break;
			}

			measureListIndex++;
		}

		if ($self.measures().count() > 1) {
			if (measureList == null) {
				measureList = (function () { var $ret = new $.ig.MeasureList();
				$ret.measures($self.measures()); return $ret;}());
				if ($self.measureListIndex() < 0 || $self.measureListIndex() > measureListAxis.count()) {
					$self.__measureListIndex = measureListAxis.count();
					measureListAxis.add(measureList);

				} else {
					measureListAxis.insert($self.measureListIndex(), measureList);
				}


			} else {
				if (measureListIndex != $self.measureListIndex()) {
					measureListAxis.removeAt(measureListIndex);
					if ($self.measureListIndex() > measureListAxis.count()) {
						$self.__measureListIndex = measureListAxis.count();
						measureListAxis.add(measureList);

					} else {
						measureListAxis.insert($self.measureListIndex(), measureList);
					}

				}

			}


		} else {
			if (measureList != null) {
				measureListAxis.removeAt(measureListIndex);
			}

		}

	}

	, 
	getPositionsToExpand: function () {
		return this.__positionsToExpand;
	}

	, 
	getPositionsToCollapse: function () {
		return this.__positionsToCollapse;
	}

	, 
	addCoreElementToAxis$1: function ($tItem, elementUniqueName, axisItems, elementType) {
		var $self = this;
		var predicate = function (ce) { return (ce).uniqueName() == elementUniqueName; };
		var coreElement = $self.getCoreElement(predicate, elementType);
		if (coreElement != null && !axisItems.contains($.ig.Object.prototype.$type, coreElement)) {
			axisItems.add(coreElement);
		}

	}

	, 
	loadExpandedMemberSiblings: function (positionsToExpand) {
		var $self = this;
		var levelNames = new $.ig.List$1(String, 0);
		var en = positionsToExpand.getEnumerator();
		while (en.moveNext()) {
			var positionInfo = en.current();
			var axisMember = $self.getResultAxis(positionInfo.axisName(), $self.result()).tuples().__inner[positionInfo.tupleIndex()].members().item(positionInfo.memberIndex());
			var nextLevel = $self.getCoreElement(function (l) { return (l).hierarchyUniqueName() == axisMember.hierarchyUniqueName() && (l).depth() == axisMember.levelNumber() + 1; }, $.ig.Level.prototype.$type);
			if (nextLevel != null && !$self.cubeCache().isLevelLoaded(nextLevel.uniqueName()) && !levelNames.contains(nextLevel.uniqueName())) {
				levelNames.add(nextLevel.uniqueName());
			}

		}

		if (levelNames.count() > 0) {
			var loadLevelTasks = new Array(levelNames.count());
			for (var i = 0; i < levelNames.count(); i++) {
				loadLevelTasks[i] = $self.getMembersOfLevel(levelNames.item(i));
			}

			return new $.ig.TaskFactory().continueWhenAll$1($.ig.Array.prototype.$type, loadLevelTasks, function (t) { return t; });
		}

		var tcs = new $.ig.TaskCompletionSource$1($.ig.Array.prototype.$type, 0);
		tcs.setResult(new Array(0));
		return tcs.task();
	}

	, 
	removeMeasureList: function () {
		var measureListAxis;
		if (this.measureListLocation() == $.ig.MeasureListLocation.prototype.columns) {
			measureListAxis = this.columnAxis();

		} else {
			measureListAxis = this.rowAxis();
		}

		if (measureListAxis == null) {
			return;
		}

		var measureList = null;
		var measureListIndex = 0;
		var en = measureListAxis.getEnumerator();
		while (en.moveNext()) {
			var coreOlapElement = en.current();
			measureList = $.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement);
			if (measureList != null) {
				break;
			}

			measureListIndex++;
		}

		if (measureList != null) {
			this.isMeasureListLocationChanged(true);
			measureListAxis.removeAt(measureListIndex);
		}

	}

	, 
	toArrayListCollection$1: function ($t, enumerable) {
		var res = new $.ig.ArrayListCollection$1($t);
		var en = enumerable.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			res.add(item);
		}

		return res;
	}

	, 
	findAxisElement: function (hierarchyUniqueName, filtersCollection) {
		var $self = this;
		var axisElement = $self.columnFilters().where$1($.ig.AxisElement.prototype.$type, function (ae) { return ae.name() == hierarchyUniqueName; }).firstOrDefault$1($.ig.AxisElement.prototype.$type);
		if (axisElement != null) {
			filtersCollection = $self.columnFilters();
			return {
				ret: axisElement, 
				filtersCollection: filtersCollection
			};
		}

		axisElement = $self.rowFilters().where$1($.ig.AxisElement.prototype.$type, function (ae) { return ae.name() == hierarchyUniqueName; }).firstOrDefault$1($.ig.AxisElement.prototype.$type);
		if (axisElement != null) {
			filtersCollection = $self.rowFilters();
			return {
				ret: axisElement, 
				filtersCollection: filtersCollection
			};
		}

		axisElement = $self.filterFilters().where$1($.ig.AxisElement.prototype.$type, function (ae) { return ae.name() == hierarchyUniqueName; }).firstOrDefault$1($.ig.AxisElement.prototype.$type);
		if (axisElement != null) {
			filtersCollection = $self.filterFilters();
			return {
				ret: axisElement, 
				filtersCollection: filtersCollection
			};
		}

		filtersCollection = null;
		return {
			ret: null, 
			filtersCollection: filtersCollection
		};
		return {
			filtersCollection: filtersCollection
		};
	}
	, 
	$type: new $.ig.Type('OlapDataSource', $.ig.Object.prototype.$type, [$.ig.IOlapDataSource.prototype.$type])
}, true);

$.ig.util.defType('PositionInfo', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_axisName: null,
	axisName: function (value) {
		if (arguments.length === 1) {
			this._axisName = value;
			return value;
		} else {
			return this._axisName;
		}
	}

	, 
	_tupleIndex: 0,
	tupleIndex: function (value) {
		if (arguments.length === 1) {
			this._tupleIndex = value;
			return value;
		} else {
			return this._tupleIndex;
		}
	}

	, 
	_memberIndex: 0,
	memberIndex: function (value) {
		if (arguments.length === 1) {
			this._memberIndex = value;
			return value;
		} else {
			return this._memberIndex;
		}
	}
	, 
	$type: new $.ig.Type('PositionInfo', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CubeMetaItemsCache', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

		this.__membersCache = new $.ig.Dictionary$2(String, $.ig.Tuple$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.Member.prototype.$type), 0);
		this.__membersIdCache = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Member.prototype.$type, 0);
		this.__membersForLevels = new $.ig.Dictionary$2(String, $.ig.IList$1.prototype.$type.specialize($.ig.Member.prototype.$type), 0);
		this.__membersForMember = new $.ig.Dictionary$2(String, $.ig.IList$1.prototype.$type.specialize($.ig.Member.prototype.$type), 0);
		this.__measuresCache = new $.ig.Dictionary$2(String, $.ig.Measure.prototype.$type, 0);
		this.__kpiMeasuresCache = new $.ig.Dictionary$2(String, $.ig.KpiMeasure.prototype.$type, 0);
		this.__loadedLevels = new $.ig.Dictionary$2(String, $.ig.Boolean.prototype.$type, 0);
		this.__loadedHierarchies = new $.ig.Dictionary$2(String, $.ig.Boolean.prototype.$type, 0);
	}, 
	__membersCache: null
	, 
	__membersIdCache: null
	, 
	__membersForLevels: null
	, 
	__membersForMember: null
	, 
	__measuresCache: null
	, 
	__kpiMeasuresCache: null
	, 
	__loadedLevels: null
	, 
	__loadedHierarchies: null

	, 
	_measures: null,
	measures: function (value) {
		if (arguments.length === 1) {
			this._measures = value;
			return value;
		} else {
			return this._measures;
		}
	}

	, 
	_kpiMeasures: null,
	kpiMeasures: function (value) {
		if (arguments.length === 1) {
			this._kpiMeasures = value;
			return value;
		} else {
			return this._kpiMeasures;
		}
	}

	, 
	_dimensionItems: null,
	dimensionItems: function (value) {
		if (arguments.length === 1) {
			this._dimensionItems = value;
			return value;
		} else {
			return this._dimensionItems;
		}
	}

	, 
	_hierarchyItems: null,
	hierarchyItems: function (value) {
		if (arguments.length === 1) {
			this._hierarchyItems = value;
			return value;
		} else {
			return this._hierarchyItems;
		}
	}

	, 
	_levelItems: null,
	levelItems: function (value) {
		if (arguments.length === 1) {
			this._levelItems = value;
			return value;
		} else {
			return this._levelItems;
		}
	}

	, 
	_kpis: null,
	kpis: function (value) {
		if (arguments.length === 1) {
			this._kpis = value;
			return value;
		} else {
			return this._kpis;
		}
	}

	, 
	_measureGroupDimensions: null,
	measureGroupDimensions: function (value) {
		if (arguments.length === 1) {
			this._measureGroupDimensions = value;
			return value;
		} else {
			return this._measureGroupDimensions;
		}
	}

	, 
	_measureGroupDimensionsCache: null,
	measureGroupDimensionsCache: function (value) {
		if (arguments.length === 1) {
			this._measureGroupDimensionsCache = value;
			return value;
		} else {
			return this._measureGroupDimensionsCache;
		}
	}

	, 
	isLevelLoaded: function (levelUniqueName) {
		var $self = this;
		var loaded;
		if (!(function () { var $ret = $self.__loadedLevels.tryGetValue(levelUniqueName, loaded); loaded = $ret.value; return $ret.ret; }())) {
			return false;
		}

		return loaded;
	}

	, 
	setIsLevelLoaded: function (levelUniqueName) {
		this.__loadedLevels.item(levelUniqueName, true);
	}

	, 
	isHierarchyLoaded: function (hierarchyUniqueName) {
		var $self = this;
		var loaded;
		if (!(function () { var $ret = $self.__loadedHierarchies.tryGetValue(hierarchyUniqueName, loaded); loaded = $ret.value; return $ret.ret; }())) {
			return false;
		}

		return loaded;
	}

	, 
	setIsHierarchyLoaded: function (hierarchyUniqueName) {
		var $self = this;
		$self.__loadedHierarchies.item(hierarchyUniqueName, true);
		var en = $self.levelItems().where$1($.ig.Level.prototype.$type, function (l) { return l.hierarchyUniqueName() == hierarchyUniqueName; }).getEnumerator();
		while (en.moveNext()) {
			var level = en.current();
			$self.setIsLevelLoaded(level.uniqueName());
		}

	}

	, 
	isMemberLoaded: function (levelUniqueName) {
		return this.__membersForMember.containsKey(levelUniqueName);
	}

	, 
	addMember: function (member) {
		var $self = this;
		var memberEntity;
		if (!(function () { var $ret = $self.__membersCache.tryGetValue(member.uniqueName(), memberEntity); memberEntity = $ret.value; return $ret.ret; }())) {
			var memberId = $self.__membersCache.count();
			memberEntity = new $.ig.Tuple$2($.ig.Number.prototype.$type, $.ig.Member.prototype.$type, memberId, member);
			$self.__membersCache.item(member.uniqueName(), memberEntity);
			$self.__membersIdCache.item(memberId, member);
			var membersForLevel;
			if (!(function () { var $ret = $self.__membersForLevels.tryGetValue(member.levelUniqueName(), membersForLevel); membersForLevel = $ret.value; return $ret.ret; }())) {
				membersForLevel = new $.ig.ArrayListCollection$1($.ig.Member.prototype.$type);
				$self.__membersForLevels.item(member.levelUniqueName(), membersForLevel);
			}

			if (!String.isNullOrEmpty(member.parentUniqueName())) {
				var membersForMember;
				if (!(function () { var $ret = $self.__membersForMember.tryGetValue(member.parentUniqueName(), membersForMember); membersForMember = $ret.value; return $ret.ret; }())) {
					membersForMember = new $.ig.List$1($.ig.Member.prototype.$type, 0);
					$self.__membersForMember.item(member.parentUniqueName(), membersForMember);
				}

				membersForMember.add(member);
			}

			membersForLevel.add(member);
		}

		return memberEntity.item1();
	}

	, 
	tryGetMemberOrdinal: function (memberUniqueName, memberOrdinal) {
		var $self = this;
		var memberEntity;
		if ((function () { var $ret = $self.__membersCache.tryGetValue(memberUniqueName, memberEntity); memberEntity = $ret.value; return $ret.ret; }())) {
			memberOrdinal = memberEntity.item1();
			return {
				ret: true, 
				memberOrdinal: memberOrdinal
			};
		}

		memberOrdinal = -1;
		return {
			ret: false, 
			memberOrdinal: memberOrdinal
		};
		return {
			memberOrdinal: memberOrdinal
		};
	}

	, 
	tryGetMember1: function (memberUniqueName, member) {
		var $self = this;
		var memberEntity;
		if ((function () { var $ret = $self.__membersCache.tryGetValue(memberUniqueName, memberEntity); memberEntity = $ret.value; return $ret.ret; }())) {
			member = memberEntity.item2();
			return {
				ret: true, 
				member: member
			};
		}

		member = null;
		return {
			ret: false, 
			member: member
		};
		return {
			member: member
		};
	}

	, 
	tryGetMember: function (memberId, member) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.__membersIdCache.tryGetValue(memberId, member); member = $ret.value; return $ret.ret; }()), 
			member: member
		};
		return {
			member: member
		};
	}

	, 
	tryGetMembersForMember: function (levelUniqueName, members) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.__membersForMember.tryGetValue(levelUniqueName, members); members = $ret.value; return $ret.ret; }()), 
			members: members
		};
		return {
			members: members
		};
	}

	, 
	tryGetMembersForLevel: function (levelUniqueName, members) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.__membersForLevels.tryGetValue(levelUniqueName, members); members = $ret.value; return $ret.ret; }()), 
			members: members
		};
		return {
			members: members
		};
	}

	, 
	tryGetMeasure: function (uniqueName, measure) {
		var $self = this;
		if (!(function () { var $ret = $self.__measuresCache.tryGetValue(uniqueName, measure); measure = $ret.value; return $ret.ret; }())) {
			measure = $self.measures().where$1($.ig.Measure.prototype.$type, function (m) { return m.uniqueName() == uniqueName; }).firstOrDefault$1($.ig.Measure.prototype.$type);
			if (measure == null) {
				return {
					ret: false, 
					measure: measure
				};
			}

			$self.__measuresCache.add(uniqueName, measure);
		}

		return {
			ret: true, 
			measure: measure
		};
		return {
			measure: measure
		};
	}

	, 
	tryGetKpiMeasure: function (uniqueName, measure) {
		var $self = this;
		if (!(function () { var $ret = $self.__kpiMeasuresCache.tryGetValue(uniqueName, measure); measure = $ret.value; return $ret.ret; }())) {
			measure = $self.kpiMeasures().where$1($.ig.KpiMeasure.prototype.$type, function (m) { return m.uniqueName() == uniqueName; }).firstOrDefault$1($.ig.KpiMeasure.prototype.$type);
			if (measure == null) {
				return {
					ret: false, 
					measure: measure
				};
			}

			$self.__kpiMeasuresCache.add(uniqueName, measure);
		}

		return {
			ret: true, 
			measure: measure
		};
		return {
			measure: measure
		};
	}
	, 
	$type: new $.ig.Type('CubeMetaItemsCache', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MetaTreeHelper', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	getDimensionMetaItems: function (dimensions, measures, kpis, hierarchies, levels, createMeasureGroupFolders, itemsCache) {
		var $self = this;
		var metaItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		var itemPosition = new $.ig.HierarchyItemPosition();
		itemPosition.hierarchyIndex(0);
		itemPosition.levelIndex(0);
		var hierarchiesList = new $.ig.List$1($.ig.Hierarchy.prototype.$type, 0);
		var en = hierarchies.getEnumerator();
		while (en.moveNext()) {
			var hierarchy = en.current();
			hierarchiesList.add(hierarchy);
		}

		var levelsList = new $.ig.List$1($.ig.Level.prototype.$type, 0);
		var en1 = levels.getEnumerator();
		while (en1.moveNext()) {
			var level = en1.current();
			levelsList.add(level);
		}

		var en2 = dimensions.getEnumerator();
		while (en2.moveNext()) {
			var dimension = en2.current();
			var hierarchiesMetaItems = $.ig.MetaTreeHelper.prototype.getHierarchyMetaItems(hierarchiesList, levelsList, dimension, itemPosition);
			if (dimension.dimensionType() != $.ig.DimensionType.prototype.measure) {
				var dimensionMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
				$ret.type($.ig.OlapMetadataTreeItemType.prototype.dimension);
				$ret.caption(dimension.caption());
				$ret.item(dimension); return $ret;}());
				$.ig.MetaTreeHelper.prototype.setMetaItemChildren(dimensionMetaItem, hierarchiesMetaItems);
				metaItems.add(dimensionMetaItem);

			} else {
				var measuresMetaItem = $.ig.MetaTreeHelper.prototype.getMeasureMetadataItem(measures, dimension);
				metaItems.insert(0, measuresMetaItem);
				if (kpis.count$1($.ig.Kpi.prototype.$type) > 0) {
					var kpiDimension = (function () { var $ret = new $.ig.KpiDimension();
					$ret.caption("Kpis"); return $ret;}());
					var kpisMetaItem = $.ig.MetaTreeHelper.prototype.getKpiMetadataItem(kpis, kpiDimension, itemsCache);
					kpisMetaItem.type($.ig.OlapMetadataTreeItemType.prototype.kpiRoot);
					metaItems.insert(1, kpisMetaItem);
				}

			}

		}

		return metaItems;
	}

	, 
	setMetaItemChildren: function (metaItem, children) {
		var $self = this;
		if (children.count() > 0) {
			var folders = children.where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() == $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).toArray$1($.ig.OlapMetadataTreeItem.prototype.$type);
			var items = children.where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() != $.ig.OlapMetadataTreeItemType.prototype.group; }).toArray$1($.ig.OlapMetadataTreeItem.prototype.$type);
			var childrenArray = new Array(folders.length + items.length);
			for (var i = 0; i < folders.length; i++) {
				childrenArray[i] = folders[i];
			}

			for (var i1 = 0; i1 < items.length; i1++) {
				childrenArray[folders.length + i1] = items[i1];
			}

			metaItem.children(childrenArray);
		}

	}

	, 
	getHierarchyMetaItems: function (hierarchiesList, levelsList, dimension, itemPosition) {
		var $self = this;
		var hierarchyFolders = new $.ig.Dictionary$2(String, $.ig.Tuple$2.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type)), 0);
		var hierarchiesMetaItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		var hierarchy = hierarchiesList.item(itemPosition.hierarchyIndex());
		while (hierarchy.dimensionUniqueName() != dimension.uniqueName()) {
			itemPosition.hierarchyIndex(itemPosition.hierarchyIndex() + 1);
			hierarchy = hierarchiesList.item(itemPosition.hierarchyIndex());

		}
		while (hierarchy.dimensionUniqueName() == dimension.uniqueName()) {
			var upperTuple = null;
			if (!String.isNullOrEmpty(hierarchy.hierarchyDisplayFolder())) {
				var folderNamePart = String.empty();
				var folderNames = $.ig.MetaTreeHelper.prototype.parseFolderPath(hierarchy.hierarchyDisplayFolder());
				for (var i = 0; i < folderNames.length; i++) {
					var folderName = folderNames[i];
					folderNamePart += folderName + "\\";
					var folderTuple;
					if (!(function () { var $ret = hierarchyFolders.tryGetValue(folderNamePart, folderTuple); folderTuple = $ret.value; return $ret.ret; }())) {
						var folderMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
						$ret.type($.ig.OlapMetadataTreeItemType.prototype.group);
						$ret.caption(folderName); return $ret;}());
						folderTuple = new $.ig.Tuple$2($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type), folderMetaItem, new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0));
						hierarchyFolders.add(folderNamePart, folderTuple);
						if (upperTuple != null) {
							upperTuple.item2().add(folderMetaItem);

						} else {
							hierarchiesMetaItems.add(folderMetaItem);
						}

					}

					upperTuple = folderTuple;
				}

			}

			var metadataItemType;
			switch (hierarchy.hierarchyOrigin()) {
				case $.ig.HierarchyOrigin.prototype.systemEnabled:
					metadataItemType = $.ig.OlapMetadataTreeItemType.prototype.systemEnabledHierarchy;
					break;
				case $.ig.HierarchyOrigin.prototype.userDefined:
					metadataItemType = $.ig.OlapMetadataTreeItemType.prototype.userDefinedHierarchy;
					break;
				default:
					metadataItemType = $.ig.OlapMetadataTreeItemType.prototype.parentChildHierarchy;
					break;
			}

			var levelMetaItems = $.ig.MetaTreeHelper.prototype.getLevelMetaItems(levelsList, hierarchy, itemPosition);
			var hierarchyMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
			$ret.type(metadataItemType);
			$ret.caption(hierarchy.caption());
			$ret.item(hierarchy); return $ret;}());
			$.ig.MetaTreeHelper.prototype.setMetaItemChildren(hierarchyMetaItem, levelMetaItems);
			if (upperTuple != null) {
				upperTuple.item2().add(hierarchyMetaItem);

			} else {
				hierarchiesMetaItems.add(hierarchyMetaItem);
			}

			if (itemPosition.hierarchyIndex() + 1 >= hierarchiesList.count()) {
				break;
			}

			itemPosition.hierarchyIndex(itemPosition.hierarchyIndex() + 1);
			hierarchy = hierarchiesList.item(itemPosition.hierarchyIndex());

		}
		var en = hierarchyFolders.values().getEnumerator();
		while (en.moveNext()) {
			var metaItemTuple = en.current();
			var metaItem = metaItemTuple.item1();
			$.ig.MetaTreeHelper.prototype.setMetaItemChildren(metaItem, metaItemTuple.item2());
		}

		return hierarchiesMetaItems;
	}

	, 
	getLevelMetaItems: function (levelsList, hierarchy, itemPosition) {
		var $self = this;
		var levelMetaItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		if (levelsList == null || levelsList.count() == 0) {
			return levelMetaItems;
		}

		var level = levelsList.item(itemPosition.levelIndex());
		while (level.hierarchyUniqueName() != hierarchy.uniqueName()) {
			itemPosition.levelIndex(itemPosition.levelIndex() + 1);
			level = levelsList.item(itemPosition.levelIndex());

		}
		while (level.hierarchyUniqueName() == hierarchy.uniqueName()) {
			var itemType;
			switch (level.depth()) {
				case 0:
				case 1:
					itemType = $.ig.OlapMetadataTreeItemType.prototype.level1;
					break;
				case 2:
					itemType = $.ig.OlapMetadataTreeItemType.prototype.level2;
					break;
				case 3:
					itemType = $.ig.OlapMetadataTreeItemType.prototype.level3;
					break;
				case 4:
					itemType = $.ig.OlapMetadataTreeItemType.prototype.level4;
					break;
				default:
					itemType = $.ig.OlapMetadataTreeItemType.prototype.level5;
					break;
			}

			var levelMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
			$ret.type(itemType);
			$ret.caption(level.caption());
			$ret.item(level); return $ret;}());
			levelMetaItems.add(levelMetaItem);
			if (itemPosition.levelIndex() + 1 >= levelsList.count()) {
				break;
			}

			itemPosition.levelIndex(itemPosition.levelIndex() + 1);
			level = levelsList.item(itemPosition.levelIndex());

		}
		return levelMetaItems;
	}

	, 
	getMeasureMetadataItem: function (measures, measureDimension) {
		var $self = this;
		var subFolders = new $.ig.Dictionary$2(String, $.ig.Tuple$2.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type)), 0);
		var measuresRoot = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
		$ret.type($.ig.OlapMetadataTreeItemType.prototype.measure);
		$ret.caption(measureDimension.caption());
		$ret.item(measureDimension); return $ret;}());
		var rootTuple = new $.ig.Tuple$2($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type), measuresRoot, new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0));
		var en = measures.getEnumerator();
		while (en.moveNext()) {
			var measure = en.current();
			if ($.ig.util.cast($.ig.KpiMeasure.prototype.$type, measure) !== null) {
				continue;
			}

			var measureGroupTuple = rootTuple;
			if (!String.isNullOrEmpty(measure.measureGroupName())) {
				if (!(function () { var $ret = subFolders.tryGetValue(measure.measureGroupName(), measureGroupTuple); measureGroupTuple = $ret.value; return $ret.ret; }())) {
					var groupMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
					$ret.type($.ig.OlapMetadataTreeItemType.prototype.group);
					$ret.caption(measure.measureGroupName()); return $ret;}());
					measureGroupTuple = new $.ig.Tuple$2($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type), groupMetaItem, new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0));
					subFolders.add(measure.measureGroupName(), measureGroupTuple);
					rootTuple.item2().add(measureGroupTuple.item1());
				}

			}

			var upperTuple = measureGroupTuple;
			if (!String.isNullOrEmpty(measure.measureDisplayFolder())) {
				var folderNamePart = measure.measureGroupName();
				var folderNames = $.ig.MetaTreeHelper.prototype.parseFolderPath(measure.measureDisplayFolder());
				for (var i = 0; i < folderNames.length; i++) {
					var folderName = folderNames[i];
					folderNamePart += "\\" + folderName;
					var folderTuple;
					if (!(function () { var $ret = subFolders.tryGetValue(folderNamePart, folderTuple); folderTuple = $ret.value; return $ret.ret; }())) {
						var folderMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
						$ret.type($.ig.OlapMetadataTreeItemType.prototype.group);
						$ret.caption(folderName); return $ret;}());
						folderTuple = new $.ig.Tuple$2($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type), folderMetaItem, new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0));
						subFolders.add(folderNamePart, folderTuple);
						upperTuple.item2().add(folderMetaItem);
					}

					upperTuple = folderTuple;
				}

			}

			var measureMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
			$ret.type($.ig.OlapMetadataTreeItemType.prototype.measure);
			$ret.caption(measure.caption());
			$ret.item(measure); return $ret;}());
			upperTuple.item2().add(measureMetaItem);
		}

		var measureItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		var en1 = rootTuple.item2().where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() == $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).getEnumerator();
		while (en1.moveNext()) {
			var item = en1.current();
			measureItems.add(item);
		}

		var en2 = rootTuple.item2().where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() != $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).getEnumerator();
		while (en2.moveNext()) {
			var item1 = en2.current();
			measureItems.add(item1);
		}

		$.ig.MetaTreeHelper.prototype.setMetaItemChildren(measuresRoot, measureItems);
		var en3 = subFolders.values().getEnumerator();
		while (en3.moveNext()) {
			var metaItemTuple = en3.current();
			var itemsList = metaItemTuple.item2();
			var groups = itemsList.where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() == $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).toList$1($.ig.OlapMetadataTreeItem.prototype.$type);
			var singleItems = itemsList.where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() != $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).toList$1($.ig.OlapMetadataTreeItem.prototype.$type);
			var childItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
			for (var i1 = 0; i1 < groups.count(); i1++) {
				childItems.add(groups.item(i1));
			}

			for (var j = 0; j < singleItems.count(); j++) {
				childItems.add(singleItems.item(j));
			}

			var metaItem = metaItemTuple.item1();
			$.ig.MetaTreeHelper.prototype.setMetaItemChildren(metaItem, childItems);
		}

		return measuresRoot;
	}

	, 
	getKpiMetadataItem: function (kpis, kpiDimension, itemsCache) {
		var $self = this;
		var subFolders = new $.ig.Dictionary$2(String, $.ig.Tuple$2.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type)), 0);
		var measures = itemsCache.measures().toList$1($.ig.Measure.prototype.$type);
		itemsCache.measures(measures);
		var kpiMeasures = new $.ig.List$1($.ig.KpiMeasure.prototype.$type, 0);
		itemsCache.kpiMeasures(kpiMeasures);
		var kpisRoot = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
		$ret.type($.ig.OlapMetadataTreeItemType.prototype.kpiRoot);
		$ret.caption(kpiDimension.caption());
		$ret.item(kpiDimension); return $ret;}());
		var rootTuple = new $.ig.Tuple$2($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type), kpisRoot, new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0));
		var en = kpis.getEnumerator();
		while (en.moveNext()) {
			var kpi = en.current();
			var upperTuple = rootTuple;
			if (!String.isNullOrEmpty(kpi.kpiDisplayFolder())) {
				var folderNamePart = String.empty();
				var folderNames = $.ig.MetaTreeHelper.prototype.parseFolderPath(kpi.kpiDisplayFolder());
				for (var i = 0; i < folderNames.length; i++) {
					var folderName = folderNames[i];
					folderNamePart += "\\" + folderName;
					var folderTuple;
					if (!(function () { var $ret = subFolders.tryGetValue(folderNamePart, folderTuple); folderTuple = $ret.value; return $ret.ret; }())) {
						var folderMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
						$ret.type($.ig.OlapMetadataTreeItemType.prototype.group);
						$ret.caption(folderName); return $ret;}());
						folderTuple = new $.ig.Tuple$2($.ig.OlapMetadataTreeItem.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.OlapMetadataTreeItem.prototype.$type), folderMetaItem, new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0));
						subFolders.add(folderNamePart, folderTuple);
						upperTuple.item2().add(folderMetaItem);
					}

					upperTuple = folderTuple;
				}

			}

			var kpiMetaItem = (function () { var $ret = new $.ig.OlapMetadataTreeItem();
			$ret.type($.ig.OlapMetadataTreeItemType.prototype.kpi);
			$ret.caption(kpi.caption());
			$ret.item(kpi); return $ret;}());
			if (!String.isNullOrEmpty(kpi.kpiValue())) {
				var measure = null;
				var itemType = $.ig.OlapMetadataTreeItemType.prototype.measure;
				var caption = "Value";
				if (!(function () { var $ret = itemsCache.tryGetMeasure(kpi.kpiValue(), measure); measure = $ret.measure; return $ret.ret; }())) {
					itemType = $.ig.OlapMetadataTreeItemType.prototype.kpiValue;
					measure = $.ig.KpiMeasure.prototype.createKpiValueMeasure(kpi);
					measures.add(measure);
					kpiMeasures.add(measure);

				} else {
					caption += " (" + measure.caption() + ")";
				}

				kpiMetaItem.addChild((function () { var $ret = new $.ig.OlapMetadataTreeItem();
				$ret.caption(caption);
				$ret.item(measure);
				$ret.type(itemType); return $ret;}()));
			}

			if (!String.isNullOrEmpty(kpi.kpiGoal())) {
				var measure1 = null;
				var itemType1 = $.ig.OlapMetadataTreeItemType.prototype.measure;
				var caption1 = "Goal";
				if (!(function () { var $ret = itemsCache.tryGetMeasure(kpi.kpiGoal(), measure1); measure1 = $ret.measure; return $ret.ret; }())) {
					itemType1 = $.ig.OlapMetadataTreeItemType.prototype.kpiGoal;
					measure1 = $.ig.KpiMeasure.prototype.createKpiGoalMeasure(kpi);
					measures.add(measure1);
					kpiMeasures.add(measure1);

				} else {
					caption1 += " (" + measure1.caption() + ")";
				}

				kpiMetaItem.addChild((function () { var $ret = new $.ig.OlapMetadataTreeItem();
				$ret.caption(caption1);
				$ret.item(measure1);
				$ret.type(itemType1); return $ret;}()));
			}

			if (!String.isNullOrEmpty(kpi.kpiStatus())) {
				var measure2 = $.ig.KpiMeasure.prototype.createKpiStatusMeasure(kpi);
				measures.add(measure2);
				kpiMeasures.add(measure2);
				kpiMetaItem.addChild((function () { var $ret = new $.ig.OlapMetadataTreeItem();
				$ret.caption("Status");
				$ret.item(measure2);
				$ret.type($.ig.OlapMetadataTreeItemType.prototype.kpiStatus); return $ret;}()));
			}

			if (!String.isNullOrEmpty(kpi.kpiTrend())) {
				var measure3 = $.ig.KpiMeasure.prototype.createKpiTrendMeasure(kpi);
				measures.add(measure3);
				kpiMeasures.add(measure3);
				kpiMetaItem.addChild((function () { var $ret = new $.ig.OlapMetadataTreeItem();
				$ret.caption("Trend");
				$ret.item(measure3);
				$ret.type($.ig.OlapMetadataTreeItemType.prototype.kpiTrend); return $ret;}()));
			}

			if (!String.isNullOrEmpty(kpi.kpiWeight())) {
				var measure4 = $.ig.KpiMeasure.prototype.createKpiWeightMeasure(kpi);
				measures.add(measure4);
				kpiMeasures.add(measure4);
				kpiMetaItem.addChild((function () { var $ret = new $.ig.OlapMetadataTreeItem();
				$ret.caption("Weight");
				$ret.item(measure4);
				$ret.type($.ig.OlapMetadataTreeItemType.prototype.kpiWeight); return $ret;}()));
			}

			upperTuple.item2().add(kpiMetaItem);
		}

		var kpiItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		var en1 = rootTuple.item2().where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() == $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).getEnumerator();
		while (en1.moveNext()) {
			var item = en1.current();
			kpiItems.add(item);
		}

		var en2 = rootTuple.item2().where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() != $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).getEnumerator();
		while (en2.moveNext()) {
			var item1 = en2.current();
			kpiItems.add(item1);
		}

		$.ig.MetaTreeHelper.prototype.setMetaItemChildren(kpisRoot, kpiItems);
		var en3 = subFolders.values().getEnumerator();
		while (en3.moveNext()) {
			var metaItemTuple = en3.current();
			var itemsList = metaItemTuple.item2();
			var groups = itemsList.where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() == $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).toList$1($.ig.OlapMetadataTreeItem.prototype.$type);
			var singleItems = itemsList.where$1($.ig.OlapMetadataTreeItem.prototype.$type, function (i) { return i.type() != $.ig.OlapMetadataTreeItemType.prototype.group; }).orderBy$2($.ig.OlapMetadataTreeItem.prototype.$type, String, function (i) { return i.caption(); }).toList$1($.ig.OlapMetadataTreeItem.prototype.$type);
			var childItems = new $.ig.List$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
			for (var i1 = 0; i1 < groups.count(); i1++) {
				childItems.add(groups.item(i1));
			}

			for (var j = 0; j < singleItems.count(); j++) {
				childItems.add(singleItems.item(j));
			}

			var metaItem = metaItemTuple.item1();
			$.ig.MetaTreeHelper.prototype.setMetaItemChildren(metaItem, childItems);
		}

		return kpisRoot;
	}

	, 
	parseFolderPath: function (folderPath) {
		var folders = folderPath.split('\\');
		return folders;
	}
	, 
	$type: new $.ig.Type('MetaTreeHelper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('HierarchyItemPosition', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_hierarchyIndex: 0,
	hierarchyIndex: function (value) {
		if (arguments.length === 1) {
			this._hierarchyIndex = value;
			return value;
		} else {
			return this._hierarchyIndex;
		}
	}

	, 
	_levelIndex: 0,
	levelIndex: function (value) {
		if (arguments.length === 1) {
			this._levelIndex = value;
			return value;
		} else {
			return this._levelIndex;
		}
	}
	, 
	$type: new $.ig.Type('HierarchyItemPosition', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DataSourceBaseOptions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_cube: null,
	cube: function (value) {
		if (arguments.length === 1) {
			this._cube = value;
			return value;
		} else {
			return this._cube;
		}
	}

	, 
	_measureGroup: null,
	measureGroup: function (value) {
		if (arguments.length === 1) {
			this._measureGroup = value;
			return value;
		} else {
			return this._measureGroup;
		}
	}

	, 
	_measures: null,
	measures: function (value) {
		if (arguments.length === 1) {
			this._measures = value;
			return value;
		} else {
			return this._measures;
		}
	}

	, 
	_filters: null,
	filters: function (value) {
		if (arguments.length === 1) {
			this._filters = value;
			return value;
		} else {
			return this._filters;
		}
	}

	, 
	_columns: null,
	columns: function (value) {
		if (arguments.length === 1) {
			this._columns = value;
			return value;
		} else {
			return this._columns;
		}
	}

	, 
	_rows: null,
	rows: function (value) {
		if (arguments.length === 1) {
			this._rows = value;
			return value;
		} else {
			return this._rows;
		}
	}
	, 
	$type: new $.ig.Type('DataSourceBaseOptions', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('AxisDefinitionParser', 'Object', {
	init: function (initString) {



		$.ig.Object.prototype.init.call(this);
			this.position(-1);
			this.initString(initString);
	}

	, 
	_isFilter: false,
	isFilter: function (value) {
		if (arguments.length === 1) {
			this._isFilter = value;
			return value;
		} else {
			return this._isFilter;
		}
	}

	, 
	_elementName: null,
	elementName: function (value) {
		if (arguments.length === 1) {
			this._elementName = value;
			return value;
		} else {
			return this._elementName;
		}
	}

	, 
	_position: 0,
	position: function (value) {
		if (arguments.length === 1) {
			this._position = value;
			return value;
		} else {
			return this._position;
		}
	}

	, 
	_initString: null,
	initString: function (value) {
		if (arguments.length === 1) {
			this._initString = value;
			return value;
		} else {
			return this._initString;
		}
	}

	, 
	readNextElement: function () {
		if (this.position() == this.initString().length - 1) {
			return false;
		}

		var elementBeginIndex = -1;
		var elementEndIndex = -1;
		var terminationElementFound = false;
		while (this.position() + 1 < this.initString().length) {
			this.position(this.position() + 1);
			var value = this.initString().substr(this.position(), 1);
			switch (value) {
				case $.ig.AxisDefinitionParser.prototype.elementBegin:
					if (elementBeginIndex == -1) {
						elementBeginIndex = this.position();
					}

					break;
				case $.ig.AxisDefinitionParser.prototype.elementEnd:
					elementEndIndex = this.position();
					while (this.position() + 1 < this.initString().length) {
						value = this.initString().substr(this.position() + 1, 1);
						switch (value) {
							case $.ig.AxisDefinitionParser.prototype.elementEnd:
								elementEndIndex = this.position() + 1;
								break;
							case $.ig.AxisDefinitionParser.prototype.elementSeparator:
								if ($.ig.AxisDefinitionParser.prototype.elementEnd == this.initString().substr(this.position(), 1)) {
									terminationElementFound = true;
								}

								break;
							case $.ig.AxisDefinitionParser.prototype.filterGroupBegin:
							case $.ig.AxisDefinitionParser.prototype.filterGroupEnd:
								terminationElementFound = true;
								break;
						}

						if (terminationElementFound) {
							break;
						}

						this.position(this.position() + 1);

					}
					terminationElementFound = true;
					break;
				case $.ig.AxisDefinitionParser.prototype.elementSeparator:
					terminationElementFound = true;
					break;
				case $.ig.AxisDefinitionParser.prototype.filterGroupBegin:
					this.isFilter(true);
					break;
				case $.ig.AxisDefinitionParser.prototype.filterGroupEnd:
					$.ig.Debug.prototype.assert(this.isFilter());
					terminationElementFound = true;
					this.isFilter(false);
					break;
			}

			if (terminationElementFound) {
				terminationElementFound = false;
				if (elementBeginIndex > -1 && elementEndIndex > -1) {
					break;
				}

			}


		}
		if (this.position() == this.initString().length - 1) {
			if (elementEndIndex == -1 || elementBeginIndex == -1) {
			return false;
			}

		}

		var elementValue = this.initString().substr(elementBeginIndex, elementEndIndex - elementBeginIndex + 1).trim();
		this.elementName(elementValue);
		return true;
	}

	, 
	parse: function () {
		var elementValues = new $.ig.List$1($.ig.AxisElement.prototype.$type, 0);
		var filterValues = null;
		while (this.readNextElement()) {
			if (!this.isFilter()) {
				filterValues = new $.ig.ArrayListCollection$1(String);
				var axisElement = new $.ig.AxisElement(this.elementName(), filterValues);
				elementValues.add(axisElement);

			} else if (filterValues != null) {
				filterValues.add(this.elementName());
			}



		}
		return elementValues;
	}
	, 
	$type: new $.ig.Type('AxisDefinitionParser', $.ig.Object.prototype.$type)
}, true);


$.ig.util.defType('CoreOlapElementParser', 'Object', {
	init: function (elementName) {



		$.ig.Object.prototype.init.call(this);
			this.position(-1);
			this.initString(elementName);
	}

	, 
	_elementName: null,
	elementName: function (value) {
		if (arguments.length === 1) {
			this._elementName = value;
			return value;
		} else {
			return this._elementName;
		}
	}

	, 
	_position: 0,
	position: function (value) {
		if (arguments.length === 1) {
			this._position = value;
			return value;
		} else {
			return this._position;
		}
	}

	, 
	_initString: null,
	initString: function (value) {
		if (arguments.length === 1) {
			this._initString = value;
			return value;
		} else {
			return this._initString;
		}
	}

	, 
	readNextElement: function () {
		if (this.position() == this.initString().length - 1) {
			return false;
		}

		var elementBeginIndex = -1;
		var elementEndIndex = -1;
		var terminationElementFound = false;
		while (this.position() + 1 < this.initString().length) {
			this.position(this.position() + 1);
			var value = this.initString().substr(this.position(), 1);
			switch (value) {
				case $.ig.CoreOlapElementParser.prototype.elementBegin:
					if (elementBeginIndex == -1) {
						elementBeginIndex = this.position();
					}

					break;
				case $.ig.CoreOlapElementParser.prototype.elementEnd:
					elementEndIndex = this.position();
					while (this.position() + 1 < this.initString().length) {
						value = this.initString().substr(this.position() + 1, 1);
						switch (value) {
							case $.ig.CoreOlapElementParser.prototype.elementEnd:
								elementEndIndex = this.position() + 1;
								break;
							case $.ig.CoreOlapElementParser.prototype.elementSeparator:
								terminationElementFound = true;
								break;
						}

						if (terminationElementFound) {
							break;
						}

						this.position(this.position() + 1);

					}
					break;
				case $.ig.CoreOlapElementParser.prototype.elementSeparator:
					terminationElementFound = true;
					break;
			}

			if (terminationElementFound) {
				terminationElementFound = false;
				if (elementBeginIndex > -1 && elementEndIndex > -1) {
					break;
				}

			}


		}
		if (this.position() == this.initString().length - 1) {
			if (elementEndIndex == -1 || elementBeginIndex == -1) {
			return false;
			}

		}

		var elementValue = this.initString().substr(elementBeginIndex, elementEndIndex - elementBeginIndex + 1).trim();
		this.elementName(elementValue);
		return true;
	}

	, 
	getPartNames: function () {
		var elementValues = new $.ig.List$1(String, 0);
		while (this.readNextElement()) {
			elementValues.add(this.elementName());

		}
		return elementValues;
	}
	, 
	$type: new $.ig.Type('CoreOlapElementParser', $.ig.Object.prototype.$type)
}, true);






$.ig.util.defType('KeyValueItem', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_key: null,
	key: function (value) {
		if (arguments.length === 1) {
			this._key = value;
			return value;
		} else {
			return this._key;
		}
	}

	, 
	_value: null,
	value: function (value) {
		if (arguments.length === 1) {
			this._value = value;
			return value;
		} else {
			return this._value;
		}
	}
	, 
	$type: new $.ig.Type('KeyValueItem', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('AxisElement', 'Object', {
	init: function (name, memberNames) {



		$.ig.Object.prototype.init.call(this);
			this.name(name);
			this.memberNames(memberNames);
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_memberNames: null,
	memberNames: function (value) {
		if (arguments.length === 1) {
			this._memberNames = value;
			return value;
		} else {
			return this._memberNames;
		}
	}
	, 
	$type: new $.ig.Type('AxisElement', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MeasureGroupMetaItemsCache', 'Object', {
	__measureGroupDimensions: null
	, 
	__measureGroupMeasures: null
	, 
	__measureGroupKpis: null
	, 
	__measureGroupDimensionsCollection: null
	, 
	__dimensions: null
	, 
	__measures: null
	, 
	__kpis: null
	, 
	init: function (dimensions, measures, kpis, measureGroupDimensions) {



		$.ig.Object.prototype.init.call(this);
			this.__measureGroupDimensions = new $.ig.Dictionary$2(String, $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Dimension.prototype.$type), 0);
			this.__measureGroupMeasures = new $.ig.Dictionary$2(String, $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Measure.prototype.$type), 0);
			this.__measureGroupKpis = new $.ig.Dictionary$2(String, $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Kpi.prototype.$type), 0);
			this.__measureGroupDimensionsCollection = measureGroupDimensions;
			this.__dimensions = dimensions;
			this.__measures = measures;
			this.__kpis = kpis;
	}

	, 
	getMeasureGroupDimensions: function (measureGroupName) {
		var $self = this;
		var measureGroupDimensions;
		if (!(function () { var $ret = $self.__measureGroupDimensions.tryGetValue(measureGroupName, measureGroupDimensions); measureGroupDimensions = $ret.value; return $ret.ret; }())) {
			var dimensionNames = new $.ig.List$1(String, 0);
			var en = $self.__measureGroupDimensionsCollection.getEnumerator();
			while (en.moveNext()) {
				var measureGroupDimension = en.current();
				if (measureGroupDimension.measureGroupName() == measureGroupName) {
					dimensionNames.add(measureGroupDimension.dimensionUniqueName());
				}

			}

			var dimensions = new $.ig.List$1($.ig.Dimension.prototype.$type, 0);
			var en1 = $self.__dimensions.getEnumerator();
			while (en1.moveNext()) {
				var dimension = en1.current();
				if (dimensionNames.contains(dimension.uniqueName()) || dimension.dimensionType() == $.ig.DimensionType.prototype.measure) {
					dimensions.add(dimension);
				}

			}

			$self.__measureGroupDimensions.add(measureGroupName, dimensions);
			measureGroupDimensions = dimensions;
		}

		return measureGroupDimensions;
	}

	, 
	getMeasureGroupMeasures: function (measureGroupName) {
		var $self = this;
		var measureGroupMeasures;
		if (!(function () { var $ret = $self.__measureGroupMeasures.tryGetValue(measureGroupName, measureGroupMeasures); measureGroupMeasures = $ret.value; return $ret.ret; }())) {
			var measures = new $.ig.List$1($.ig.Measure.prototype.$type, 0);
			var en = $self.__measures.getEnumerator();
			while (en.moveNext()) {
				var measure = en.current();
				if (measure.measureGroupName() == measureGroupName) {
					measures.add(measure);
				}

			}

			$self.__measureGroupMeasures.add(measureGroupName, measures);
			measureGroupMeasures = measures;
		}

		return measureGroupMeasures;
	}

	, 
	getMeasureGroupKpis: function (measureGroupName) {
		var $self = this;
		var measureGroupKpis;
		if (!(function () { var $ret = $self.__measureGroupKpis.tryGetValue(measureGroupName, measureGroupKpis); measureGroupKpis = $ret.value; return $ret.ret; }())) {
			var kpis = new $.ig.List$1($.ig.Kpi.prototype.$type, 0);
			var en = $self.__kpis.getEnumerator();
			while (en.moveNext()) {
				var kpi = en.current();
				if (kpi.measureGroupName() == measureGroupName) {
					kpis.add(kpi);
				}

			}

			$self.__measureGroupKpis.add(measureGroupName, kpis);
			measureGroupKpis = kpis;
		}

		return measureGroupKpis;
	}
	, 
	$type: new $.ig.Type('MeasureGroupMetaItemsCache', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('PositionItemInfo$2', 'Dictionary$2', {
	$tKey: null, 
	$tSortKey: null, 
	init: function ($tKey, $tSortKey, positionItem, positionIndex, positionItemIndex, positionSize) {


		this.__parentsToExpand = new $.ig.Dictionary$2(this.$tKey, $.ig.Object.prototype.$type, 0);

		this.$tKey = $tKey
		this.$tSortKey = $tSortKey
		this.$type = this.$type.specialize(this.$tKey, this.$tSortKey);
		$.ig.Dictionary$2.prototype.init.call(this, this.$tKey, $.ig.PositionItemInfo$2.prototype.$type.specialize(this.$tKey, this.$tSortKey));
			this.positionItem(positionItem);
			this.positionIndex(positionIndex);
			this.positionItemIndex(positionItemIndex);
			this.positionItemDepth(0);
			this.positionItemDepthMin(-1);
			this.positionItemDepthMax(Number.MAX_VALUE);
			this.positionSize(positionSize);
			if (positionItem != null) {
				this.positionItemDepth(this.positionItem().depth());
				this.key(this.positionItem().key());
				this.parentKey(this.positionItem().parentKey());
				this.hierarchyKey(this.positionItem().hierarchyKey());
				this.hierarchyLevelKey(this.positionItem().hierarchyLevelKey());
				this.sortKey(this.positionItem().sortKey());
				this.caption(this.positionItem().caption());
			}

	}

	, 
	createInstance: function (positionItem, index, memberIndex, positionSize) {
		return new $.ig.PositionItemInfo$2(this.$tKey, this.$tSortKey, positionItem, index, memberIndex, positionSize);
	}

	, 
	_positionItemDepthMin: 0,
	positionItemDepthMin: function (value) {
		if (arguments.length === 1) {
			this._positionItemDepthMin = value;
			return value;
		} else {
			return this._positionItemDepthMin;
		}
	}

	, 
	_positionItemDepthMax: 0,
	positionItemDepthMax: function (value) {
		if (arguments.length === 1) {
			this._positionItemDepthMax = value;
			return value;
		} else {
			return this._positionItemDepthMax;
		}
	}

	, 
	_positionItem: null,
	positionItem: function (value) {
		if (arguments.length === 1) {
			this._positionItem = value;
			return value;
		} else {
			return this._positionItem;
		}
	}

	, 
	_positionIndex: 0,
	positionIndex: function (value) {
		if (arguments.length === 1) {
			this._positionIndex = value;
			return value;
		} else {
			return this._positionIndex;
		}
	}

	, 
	_positionItemDepth: 0,
	positionItemDepth: function (value) {
		if (arguments.length === 1) {
			this._positionItemDepth = value;
			return value;
		} else {
			return this._positionItemDepth;
		}
	}

	, 
	_positionItemIndex: 0,
	positionItemIndex: function (value) {
		if (arguments.length === 1) {
			this._positionItemIndex = value;
			return value;
		} else {
			return this._positionItemIndex;
		}
	}

	, 
	_positionSize: 0,
	positionSize: function (value) {
		if (arguments.length === 1) {
			this._positionSize = value;
			return value;
		} else {
			return this._positionSize;
		}
	}

	, 
	_key: null,
	key: function (value) {
		if (arguments.length === 1) {
			this._key = value;
			return value;
		} else {
			return this._key;
		}
	}

	, 
	_parentKey: null,
	parentKey: function (value) {
		if (arguments.length === 1) {
			this._parentKey = value;
			return value;
		} else {
			return this._parentKey;
		}
	}

	, 
	_hierarchyKey: null,
	hierarchyKey: function (value) {
		if (arguments.length === 1) {
			this._hierarchyKey = value;
			return value;
		} else {
			return this._hierarchyKey;
		}
	}

	, 
	_hierarchyLevelKey: null,
	hierarchyLevelKey: function (value) {
		if (arguments.length === 1) {
			this._hierarchyLevelKey = value;
			return value;
		} else {
			return this._hierarchyLevelKey;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_sortKey: null,
	sortKey: function (value) {
		if (arguments.length === 1) {
			this._sortKey = value;
			return value;
		} else {
			return this._sortKey;
		}
	}

	, 
	_isExpandable: false,
	isExpandable: function (value) {
		if (arguments.length === 1) {
			this._isExpandable = value;
			return value;
		} else {
			return this._isExpandable;
		}
	}

	, 
	_isExpanded: false,
	isExpanded: function (value) {
		if (arguments.length === 1) {
			this._isExpanded = value;
			return value;
		} else {
			return this._isExpanded;
		}
	}

	, 
	addChildObject: function (position, index, lookupPosition) {
		var membersMatch = false;
		if (this.positionItemIndex() == -1) {
			membersMatch = true;

		} else {
			if (lookupPosition != null) {
				if (position.item(this.positionItemIndex()).key() != null) {
					var lookupPositionItem = lookupPosition.item(this.positionItemIndex());
					membersMatch = position.item(this.positionItemIndex()).key().equals(lookupPositionItem.key());
				}

			}

		}

		if (this.positionItemIndex() + 1 == this.positionSize()) {
			return membersMatch;
		}

		var childMemberMatch = this.addChildObject1(position, index, this.positionItemIndex() + 1, lookupPosition);
		return membersMatch && childMemberMatch;
	}

	, 
	onChildAdded: function (position, childItemInfo) {
	}
	, 
	__parentsToExpand: null

	, 
	addChildObject1: function (position, index, positionItemIndex, lookupPosition) {
		var $self = this;
		var membersMatch;
		var positionItem = position.item(positionItemIndex);
		if (!$self.containsKey(positionItem.key())) {
			var linkedNode = $self.createInstance(positionItem, index, positionItemIndex, $self.positionSize());
			linkedNode.isExpandable(positionItem.isExpandable());
			if ($self.__parentsToExpand.containsKey(linkedNode.key())) {
				$self.__parentsToExpand.remove(linkedNode.key());
				linkedNode.isExpanded(true);
			}

			if (positionItem.parentKey() != null) {
				var parentPositionInfo = null;
				if ((function () { var $ret = $self.tryGetValue(positionItem.parentKey(), parentPositionInfo); parentPositionInfo = $ret.value; return $ret.ret; }())) {
					parentPositionInfo.isExpanded(true);

				} else {
					if (!$self.__parentsToExpand.containsKey(positionItem.parentKey())) {
						$self.__parentsToExpand.add(positionItem.parentKey(), null);
					}

				}

			}

			membersMatch = linkedNode.addChildObject(position, index, lookupPosition);
			$self.add(positionItem.key(), linkedNode);
			if ($self.positionItemDepthMin() == -1) {
				$self.positionItemDepthMin(positionItem.depth());

			} else {
				$self.positionItemDepthMin(Math.min($self.positionItemDepthMin(), positionItem.depth()));
			}

			if ($self.positionItemDepthMax() == Number.MAX_VALUE) {
				$self.positionItemDepthMax(positionItem.depth());

			} else {
				$self.positionItemDepthMax(Math.max($self.positionItemDepthMax(), positionItem.depth()));
			}

			$self.onChildAdded(position, linkedNode);

		} else {
			var positionItemInfo = $self.item(positionItem.key());
			membersMatch = positionItemInfo.addChildObject(position, index, lookupPosition);
		}

		return membersMatch;
	}

	, 
	getIndex2: function (positionItems) {
		var keys = new Array(positionItems.count());
		for (var i = 0; i < keys.length; i++) {
			keys[i] = positionItems.item(i).key();
		}

		return this.getIndex(keys);
	}

	, 
	getIndex: function (keys) {
		return this.getIndex1(keys, keys.length);
	}

	, 
	getIndex1: function (keys, itemsCount) {
		var $self = this;
		if ($self.positionItemIndex() == itemsCount - 1) {
			return $self.positionIndex();
		}

		var positionItemInfo;
		if (!(function () { var $ret = $self.tryGetValue(keys[$self.positionItemIndex() + 1], positionItemInfo); positionItemInfo = $ret.value; return $ret.ret; }())) {
			return -1;
		}

		if (positionItemInfo.count() == 0) {
			return positionItemInfo.positionIndex();
		}

		return positionItemInfo.getIndex1(keys, itemsCount);
	}
	, 
	$type: new $.ig.Type('PositionItemInfo$2', $.ig.Dictionary$2.prototype.$type.specialize(0, 1))
}, true);

$.ig.util.defType('PositionResolver$2', 'Object', {
	$tKey: null, 
	$tSortKey: null, 
	__registeredPositionsCount: 0
	, 
	__rootPositionInfo: null
	, 
	__rootTupleInfoKey: null
	, 
	__rootTupleInfoParentKey: null
	, 
	init: function ($tKey, $tSortKey, positions, positionSize) {


		this.__registeredPositionsCount = 0;

		this.$tKey = $tKey
		this.$tSortKey = $tSortKey
		this.$type = this.$type.specialize(this.$tKey, this.$tSortKey);
		$.ig.Object.prototype.init.call(this);
			this.positions(positions.toList$1($.ig.IPosition$2.prototype.$type.specialize(this.$tKey, this.$tSortKey)));
			this.positionSize(positionSize);
	}
	, 
	getPositionIndexCompleted: null
	, 
	_positions: null,
	positions: function (value) {
		if (arguments.length === 1) {
			this._positions = value;
			return value;
		} else {
			return this._positions;
		}
	}

	, 
	_positionSize: 0,
	positionSize: function (value) {
		if (arguments.length === 1) {
			this._positionSize = value;
			return value;
		} else {
			return this._positionSize;
		}
	}

	, 
	rootPositionInfo: function () {

			if (this.__rootPositionInfo == null) {
				this.__rootPositionInfo = this.resolverRootPositionInfo(this.positionSize());
			}

			return this.__rootPositionInfo;
	}

	, 
	resolverRootPositionInfo: function (positionSize) {
		return new $.ig.PositionItemInfo$2(this.$tKey, this.$tSortKey, null, -1, -1, positionSize);
	}

	, 
	hasUnregisterdPositions: function () {

			return this.__registeredPositionsCount < this.positions().count();
	}

	, 
	completeRegisterPositions: function () {
		if (this.hasUnregisterdPositions()) {
			this.registerAndGetPositionIndex(null);
		}

	}

	, 
	resolveParentPositionItem: function (positionItem, parentPositionIndex) {
		parentPositionIndex = -1;
		var hierarchicalPosition = $.ig.util.cast($.ig.IHierarchicalPositionItem$2.prototype.$type.specialize(this.$tKey, this.$tSortKey), positionItem);
		if (hierarchicalPosition == null || hierarchicalPosition.parentKey() == null) {
			return {
				ret: null, 
				parentPositionIndex: parentPositionIndex
			};
		}

		var memberIndex = hierarchicalPosition.position().indexOf(hierarchicalPosition);
		var keys = new Array(hierarchicalPosition.position().itemsCount());
		for (var i = 0; i < hierarchicalPosition.position().itemsCount(); i++) {
			keys[i] = hierarchicalPosition.position().item(i).key();
		}

		keys[memberIndex] = hierarchicalPosition.parentKey();
		parentPositionIndex = this.rootPositionInfo().getIndex(keys);
		if (parentPositionIndex == -1) {
			return {
				ret: null, 
				parentPositionIndex: parentPositionIndex
			};
		}

		var parentPosition = this.positions().__inner[parentPositionIndex];
		var parentMember = parentPosition.item(memberIndex);
		return {
			ret: parentMember, 
			parentPositionIndex: parentPositionIndex
		};
		return {
			parentPositionIndex: parentPositionIndex
		};
	}

	, 
	getHostPositionItemInfo: function (position, positionItemIndex) {
		var $self = this;
		var indexInfo = $self.rootPositionInfo();
		var positionItem = position.item(positionItemIndex);
		for (var i = 0; i < positionItemIndex; i++) {
			var nextPositionItemInfo;
			if ((function () { var $ret = indexInfo.tryGetValue(position.item(i).key(), nextPositionItemInfo); nextPositionItemInfo = $ret.value; return $ret.ret; }())) {
				indexInfo = nextPositionItemInfo;

			} else {
				indexInfo = null;
				break;
			}

		}

		if (indexInfo == null) {
			return null;
		}

		if (!indexInfo.containsKey(positionItem.key())) {
			return null;
		}

		return indexInfo;
	}

	, 
	getChildPositionsIndexes: function (positionItem, sortDirection) {
		var $self = this;
		if ($self.rootPositionInfo().count() == 0) {
			return null;
		}

		var indexInfo = $self.rootPositionInfo();
		var index = positionItem.position().indexOf(positionItem);
		for (var i = 0; i < index; i++) {
			var nextPositionItemInfo;
			if ((function () { var $ret = indexInfo.tryGetValue(positionItem.position().item(i).key(), nextPositionItemInfo); nextPositionItemInfo = $ret.value; return $ret.ret; }())) {
				indexInfo = nextPositionItemInfo;

			} else {
				indexInfo = null;
				break;
			}

		}

		if (indexInfo == null) {
			return null;
		}

		if (!indexInfo.containsKey(positionItem.key())) {
			return null;
		}

		var resultList = new $.ig.List$1($.ig.Number.prototype.$type, 0);
		$self.getChildPositionsIndexes1(positionItem.key(), indexInfo, resultList);
		if (sortDirection == $.ig.ListSortDirection.prototype.descending) {
			resultList.sort1(function (x, y) {
				if (x == y) {
					return 0;
				}

				if (x > y) {
					return -1;
				}

				return 1;
			});
			return resultList;
		}

		resultList.sort1(function (x, y) {
			if (x == y) {
				return 0;
			}

			if (x > y) {
				return 1;
			}

			return -1;
		});
		return resultList;
	}

	, 
	getChildPositionsIndexes1: function (parentUniqueName, indexInfo, resultList) {
		var $self = this;
		var en = indexInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize($self.$tKey, $self.$tSortKey), function (tii) { return parentUniqueName.equals(tii.parentKey()); }).getEnumerator();
		while (en.moveNext()) {
			var positionInfo = en.current();
			if (positionInfo.count() == 0) {
				resultList.add(positionInfo.positionIndex());

			} else {
				$self.fillMemberTuplesIndexes(positionInfo, resultList);
			}

			if (!positionInfo.isExpanded()) {
				continue;
			}

			if (positionInfo.positionItemDepth() < indexInfo.positionItemDepthMax()) {
				$self.getChildPositionsIndexes1(positionInfo.key(), indexInfo, resultList);
			}

		}

	}

	, 
	fillMemberTuplesIndexes: function (indexInfo, resultList) {
		var $self = this;
		var en = indexInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize($self.$tKey, $self.$tSortKey), function (tii) { return tii.parentKey() == null; }).getEnumerator();
		while (en.moveNext()) {
			var positionItemInfo = en.current();
			if (positionItemInfo.count() == 0) {
				resultList.add(positionItemInfo.positionIndex());

			} else {
				$self.fillMemberTuplesIndexes(positionItemInfo, resultList);
			}

			if (!positionItemInfo.isExpanded()) {
				continue;
			}

			if (positionItemInfo.positionItemDepth() < indexInfo.positionItemDepthMax()) {
				$self.getChildPositionsIndexes1(positionItemInfo.key(), indexInfo, resultList);
			}

		}

	}

	, 
	getChildren: function (position, positionItemIndex) {
		var $self = this;
		if ($self.hasUnregisterdPositions()) {
			$self.completeRegisterPositions();
		}

		var indexInfo = $self.getHostPositionItemInfo(position, positionItemIndex);
		var positionItem = position.item(positionItemIndex);
		return indexInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize($self.$tKey, $self.$tSortKey), function (pi) { return positionItem.key().equals(pi.parentKey()); });
	}

	, 
	isMemberExpanded: function (positionItem) {
		var $self = this;
		if ($self.hasUnregisterdPositions()) {
			$self.completeRegisterPositions();
		}

		var positionIndex = $self.getPositionIndex(positionItem.position());
		if (positionIndex == -1 || $self.rootPositionInfo().count() == 0) {
			return $.ig.util.toNullable(Boolean, null);
		}

		var index = positionItem.position().indexOf(positionItem);
		var indexInfo = $self.rootPositionInfo();
		for (var i = 0; i < index; i++) {
			var nextPositionItemInfo;
			if ((function () { var $ret = indexInfo.tryGetValue(positionItem.position().item(i).key(), nextPositionItemInfo); nextPositionItemInfo = $ret.value; return $ret.ret; }())) {
				indexInfo = nextPositionItemInfo;

			} else {
				indexInfo = null;
				break;
			}

		}

		if (indexInfo == null) {
			return $.ig.util.toNullable(Boolean, null);
		}

		if (!indexInfo.containsKey(positionItem.key())) {
			return $.ig.util.toNullable(Boolean, null);
		}

		var childMember = null;
		var e = indexInfo.values().getEnumerator();
		while (e.moveNext()) {
			if (positionItem.key().equals(e.current().parentKey())) {
				childMember = e.current();
				break;
			}


		}
		return $.ig.util.toNullable(Boolean, childMember != null);
	}

	, 
	getPositionIndex: function (position) {
		if (position == null) {
			return -1;
		}

		if (position.itemsCount() != this.positionSize()) {
			return -1;
		}

		if (position.isEmpty() && this.positions().count() == 1 && this.positions().__inner[0].isEmpty()) {
			return 0;
		}

		if (this.__registeredPositionsCount > 0) {
			var positionIndex = this.getPositionIndexImpl(position);
			if (positionIndex > -1) {
				return positionIndex;
			}

			if (this.__registeredPositionsCount == this.positions().count()) {
				return -1;
			}

		}

		return this.registerAndGetPositionIndex(position);
	}

	, 
	getPositionIndexImpl: function (position) {
		if (position.isEmpty() && this.positions().count() == 1 && this.positions().__inner[0].isEmpty()) {
			return 0;
		}

		return this.rootPositionInfo().getIndex2(position.getItems().toList$1($.ig.IPositionItem$2.prototype.$type.specialize(this.$tKey, this.$tSortKey)));
	}

	, 
	registerAndGetPositionIndex: function (lookupPosition) {
		var registerAll = lookupPosition == null;
		var positionIndex = -1;
		for (var i = this.__registeredPositionsCount; i < this.positions().count(); i++) {
			var position = this.positions().__inner[i];
			var positionFound = this.rootPositionInfo().addChildObject(position, i, lookupPosition);
			this.__registeredPositionsCount++;
			if (positionIndex == -1 && positionFound) {
				positionIndex = i;
				if (!registerAll) {
					break;
				}

			}

		}

		return positionIndex;
	}
	, 
	$type: new $.ig.Type('PositionResolver$2', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LevelSortDirection', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.sortBehavior($.ig.LevelSortBehavior.prototype.system);
	}

	, 
	_levelUniqueName: null,
	levelUniqueName: function (value) {
		if (arguments.length === 1) {
			this._levelUniqueName = value;
			return value;
		} else {
			return this._levelUniqueName;
		}
	}

	, 
	_sortDirection: null,
	sortDirection: function (value) {
		if (arguments.length === 1) {
			this._sortDirection = value;
			return value;
		} else {
			return this._sortDirection;
		}
	}

	, 
	_sortBehavior: null,
	sortBehavior: function (value) {
		if (arguments.length === 1) {
			this._sortBehavior = value;
			return value;
		} else {
			return this._sortBehavior;
		}
	}
	, 
	$type: new $.ig.Type('LevelSortDirection', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TaskExtensions', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	continueWithTask$1: function ($tResult, continuationFunction) {
		var $self = this;
		var tcs = new $.ig.TaskCompletionSource$1($tResult, 0);
		$self.continueWith(function (t) {
			if (t.exception() == null) {
				try {
						continuationFunction(t).continueWith1(function (t1) {
							if (t1.exception() == null) {
								tcs.setResult(t1.result());
								return;
							}

							tcs.setException(t1.exception());
						});

				}
				catch (e_) {
						var exception;
						exception = e_;
						tcs.setException(exception);

				}

			} else {
				tcs.setException(t.exception());
			}

		});
		return tcs.task();
	}

	, 
	continueWithTask$2: function ($tResult1, $tResult2, continuationFunction) {
		var $self = this;
		return $self.continueWithTask$1($tResult2, function (t) { return continuationFunction(t); });
	}
	, 
	$type: new $.ig.Type('TaskExtensions', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('HierarchyFilterView', 'Object', {
	__filterItems: null
	, 
	__filterLevels: null
	, 
	__selectedFilterItems: null
	, 
	init: function (hierarchy) {


		this.__selectedFilterItems = new $.ig.Dictionary$2(String, $.ig.FilterMember.prototype.$type, 0);

		$.ig.Object.prototype.init.call(this);
			this.hierarchy(hierarchy);
			this.__filterLevels = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.FilterMember.prototype.$type), 0);
			this.__filterItems = new $.ig.Dictionary$2(String, $.ig.FilterMember.prototype.$type, 0);
	}
	, 
	filterMemberExpansionChanged: null, 
	filterMemberSelectionChanged: null
	, 
	_hierarchy: null,
	hierarchy: function (value) {
		if (arguments.length === 1) {
			this._hierarchy = value;
			return value;
		} else {
			return this._hierarchy;
		}
	}

	, 
	addFiltersForMembers: function (members) {
		var en = members.getEnumerator();
		while (en.moveNext()) {
			var member = en.current();
			this.addFilterForMember(member);
		}

	}

	, 
	addFilterForMember: function (member) {
		var $self = this;
		if (!$self.__filterItems.containsKey(member.uniqueName())) {
			var filterItem = new $.ig.FilterMember(member);
			filterItem.propertyChanged = $.ig.Delegate.prototype.combine(filterItem.propertyChanged, $self.filterItem_PropertyChanged.runOn($self));
			filterItem.selectionChanged = $.ig.Delegate.prototype.combine(filterItem.selectionChanged, $self.filterItem_SelectionChanged.runOn($self));
			var levelItems;
			if (!(function () { var $ret = $self.__filterLevels.tryGetValue(member.levelDepth(), levelItems); levelItems = $ret.value; return $ret.ret; }())) {
				levelItems = new $.ig.List$1($.ig.FilterMember.prototype.$type, 0);
				$self.__filterLevels.add(member.levelDepth(), levelItems);
			}

			$self.__filterItems.add(member.uniqueName(), filterItem);
			$self.__selectedFilterItems.add(member.uniqueName(), filterItem);
			levelItems.add(filterItem);
			$self.addChildren(filterItem);
			$self.attachToParent(filterItem);
		}

	}

	, 
	tryGetFilterMember: function (memberUniqueName, filterMember) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.__filterItems.tryGetValue(memberUniqueName, filterMember); filterMember = $ret.value; return $ret.ret; }()), 
			filterMember: filterMember
		};
		return {
			filterMember: filterMember
		};
	}

	, 
	getRootFilterMembers: function () {
		var minIndex = -1;
		var en = this.__filterLevels.keys().getEnumerator();
		while (en.moveNext()) {
			var key = en.current();
			if (minIndex == -1) {
				minIndex = key;

			} else {
				minIndex = Math.min(key, minIndex);
			}

		}

		if (minIndex == -1) {
			return null;
		}

		return this.__filterLevels.item(minIndex);
	}

	, 
	getSelectedFilterItems: function () {
		var rootLevelItems = this.getRootFilterMembers();
		var filterItems = new $.ig.List$1($.ig.FilterMember.prototype.$type, 0);
		var selectedRootLevelItemsCount = 0;
		var en = rootLevelItems.getEnumerator();
		while (en.moveNext()) {
			var rootLevelItem = en.current();
			if (rootLevelItem.isSelected().hasValue() == true && rootLevelItem.isSelected().value() == true) {
				selectedRootLevelItemsCount++;
			}

		}

		if (selectedRootLevelItemsCount == rootLevelItems.count()) {
			return filterItems;
		}

		var en1 = rootLevelItems.getEnumerator();
		while (en1.moveNext()) {
			var rootLevelItem1 = en1.current();
			if (rootLevelItem1.isSelected().hasValue() == false) {
				this.fillSelectedItems(rootLevelItem1, filterItems);

			} else if (rootLevelItem1.isSelected().hasValue() == true && rootLevelItem1.isSelected().value() == true) {
				filterItems.add(rootLevelItem1);
			}


		}

		return filterItems;
	}

	, 
	filterItem_SelectionChanged: function (sender, e) {
		if (this.filterMemberSelectionChanged != null) {
			this.filterMemberSelectionChanged(this, new $.ig.FilterMemberStateChangedEventArgs(sender));
		}

	}

	, 
	filterItem_PropertyChanged: function (sender, e) {
		if (e.propertyName() == "IsExpanded") {
			if (this.filterMemberExpansionChanged != null) {
				this.filterMemberExpansionChanged(this, new $.ig.FilterMemberStateChangedEventArgs(sender));
			}

		}

	}

	, 
	fillSelectedItems: function (filterItem, filterItems) {
		if (filterItem.isSelected().hasValue() == true && filterItem.isSelected().value() == true) {
			filterItems.add(filterItem);

		} else {
			if (filterItem.children() == null) {
				return;
			}

			var en = filterItem.children().getEnumerator();
			while (en.moveNext()) {
				var child = en.current();
				this.fillSelectedItems(child, filterItems);
			}

		}

	}

	, 
	attachToParent: function (filterItem) {
		var $self = this;
		var parentName = filterItem.member().parentUniqueName();
		if (String.isNullOrEmpty(parentName)) {
			return;
		}

		var parentItem;
		if ((function () { var $ret = $self.__filterItems.tryGetValue(parentName, parentItem); parentItem = $ret.value; return $ret.ret; }())) {
			parentItem.addChildItem(filterItem);
			if (parentItem.isSelected().hasValue() == true && parentItem.isSelected().value() == false) {
				filterItem.isSelected($.ig.util.toNullable($.ig.Boolean.prototype.$type, false));
			}

		}

	}

	, 
	addChildren: function (filterItem) {
		var $self = this;
		var levelIndex = filterItem.member().levelDepth();
		var nextLevelMembers;
		if ((function () { var $ret = $self.__filterLevels.tryGetValue(levelIndex + 1, nextLevelMembers); nextLevelMembers = $ret.value; return $ret.ret; }())) {
			var en = nextLevelMembers.getEnumerator();
			while (en.moveNext()) {
				var nextLevelMember = en.current();
				if (nextLevelMember.member().parentUniqueName() == filterItem.member().uniqueName()) {
					filterItem.addChildItem(nextLevelMember);
				}

			}

		}

	}
	, 
	$type: new $.ig.Type('HierarchyFilterView', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('FilterMember', 'Object', {
	__isSelected: $.ig.util.toNullable($.ig.Boolean.prototype.$type, null)
	, 
	__isExpanded: false
	, 
	__skipParentUpdate: false
	, 
	__skipChildrenUpdate: false
	, 
	init: function (member) {


		this.__skipParentUpdate = false;
		this.__skipChildrenUpdate = false;

		$.ig.Object.prototype.init.call(this);
			var trueValue = $.ig.util.toNullable($.ig.Boolean.prototype.$type, true);
			this.__isSelected = trueValue;
			this.member(member);
			this.unselectedChildrenCount(0);
			this.nullChildrenCount(0);
	}
	, 
	selectionChanged: null, 
	propertyChanged: null
	, 
	_parent: null,
	parent: function (value) {
		if (arguments.length === 1) {
			this._parent = value;
			return value;
		} else {
			return this._parent;
		}
	}

	, 
	_member: null,
	member: function (value) {
		if (arguments.length === 1) {
			this._member = value;
			return value;
		} else {
			return this._member;
		}
	}

	, 
	isExpandable: function () {

			return this.member().childrenCardinality() > 0;
	}

	, 
	isExpanded: function (value) {
		if (arguments.length === 1) {

			if (this.__isExpanded != value) {
				this.__isExpanded = value;
				this.onPropertyChanged("IsExpanded");
			}

			return value;
		} else {

			return this.__isExpanded;
		}
	}

	, 
	isSelected: function (value) {
		if (arguments.length === 1) {

			var newValue = value;
			var nullValue = $.ig.util.toNullable($.ig.Boolean.prototype.$type, null);
			if (($.ig.util.nullableEquals(this.__isSelected, newValue)) == false) {
				var oldValue = this.__isSelected;
				this.__isSelected = value;
				if (!this.__skipChildrenUpdate) {
					if (this.__isSelected.hasValue() == true) {
						if (this.children() != null) {
							var en = this.children().getEnumerator();
							while (en.moveNext()) {
								var filterItem = en.current();
								filterItem.__skipParentUpdate = true;
								filterItem.isSelected(this.__isSelected);
								filterItem.__skipParentUpdate = false;
							}

						}

					}

				}

				if (this.parent() != null) {
					if (oldValue.hasValue() == true && oldValue.value() == false) {
						if (this.__isSelected.hasValue() == false) {
							this.updateNullChildrenCount(true);
						}

						this.updateUnselectedChildrenCount(false);

					} else if (oldValue.hasValue() == false) {
						if (this.__isSelected.hasValue() == true && this.__isSelected.value() == false) {
							this.updateUnselectedChildrenCount(true);
						}

						this.updateNullChildrenCount(false);

					} else {
						if (this.__isSelected.hasValue() == true && this.__isSelected.value() == false) {
							this.updateUnselectedChildrenCount(true);

						} else if (this.__isSelected.hasValue() == false) {
							this.updateNullChildrenCount(true);
						}


					}


					if (!this.__skipParentUpdate) {
						this.parent().__skipChildrenUpdate = true;
						var unselected = this.parent().unselectedChildrenCount();
						var nullSelected = this.parent().nullChildrenCount();
						var total = this.parent().children().count();
						if (nullSelected == 0) {
							if (unselected == 0) {
								this.parent().isSelected($.ig.util.toNullable($.ig.Boolean.prototype.$type, true));

							} else if (unselected == total) {
								this.parent().isSelected($.ig.util.toNullable($.ig.Boolean.prototype.$type, false));

							} else {
								this.parent().isSelected(nullValue);
							}



						} else {
							this.parent().isSelected(nullValue);
						}

						this.parent().__skipChildrenUpdate = false;
					}

				}

				this.onPropertyChanged("IsSelected");
				if (!this.__skipParentUpdate && !this.__skipChildrenUpdate) {
					if (this.selectionChanged != null) {
						this.selectionChanged(this, $.ig.EventArgs.prototype.empty);
					}

				}

			}

			return value;
		} else {

			return this.__isSelected;
		}
	}

	, 
	updateUnselectedChildrenCount: function (increaseUnselected) {
		if (increaseUnselected) {
			this.parent().unselectedChildrenCount(this.parent().unselectedChildrenCount() + 1);

		} else {
			this.parent().unselectedChildrenCount(this.parent().unselectedChildrenCount() - 1);
		}

	}

	, 
	updateNullChildrenCount: function (increaseUnselected) {
		if (increaseUnselected) {
			this.parent().nullChildrenCount(this.parent().nullChildrenCount() + 1);

		} else {
			this.parent().nullChildrenCount(this.parent().nullChildrenCount() - 1);
		}

	}

	, 
	_children: null,
	children: function (value) {
		if (arguments.length === 1) {
			this._children = value;
			return value;
		} else {
			return this._children;
		}
	}

	, 
	addChildItem: function (filterItem) {
		if (this.children() == null) {
			this.children(new $.ig.List$1($.ig.FilterMember.prototype.$type, 0));
		}

		filterItem.parent(this);
		this.children().add(filterItem);
		this.onPropertyChanged("Children");
	}

	, 
	_unselectedChildrenCount: 0,
	unselectedChildrenCount: function (value) {
		if (arguments.length === 1) {
			this._unselectedChildrenCount = value;
			return value;
		} else {
			return this._unselectedChildrenCount;
		}
	}

	, 
	_nullChildrenCount: 0,
	nullChildrenCount: function (value) {
		if (arguments.length === 1) {
			this._nullChildrenCount = value;
			return value;
		} else {
			return this._nullChildrenCount;
		}
	}

	, 
	onPropertyChanged: function (propertyName) {
		if (this.propertyChanged != null) {
			this.propertyChanged(this, new $.ig.PropertyChangedEventArgs(propertyName));
		}

	}
	, 
	$type: new $.ig.Type('FilterMember', $.ig.Object.prototype.$type, [$.ig.INotifyPropertyChanged.prototype.$type])
}, true);

$.ig.util.defType('FilterMemberStateChangedEventArgs', 'EventArgs', {
	init: function (filterMember) {



		$.ig.EventArgs.prototype.init.call(this);
			this.filterMember(filterMember);
	}

	, 
	_filterMember: null,
	filterMember: function (value) {
		if (arguments.length === 1) {
			this._filterMember = value;
			return value;
		} else {
			return this._filterMember;
		}
	}
	, 
	$type: new $.ig.Type('FilterMemberStateChangedEventArgs', $.ig.EventArgs.prototype.$type)
}, true);

$.ig.util.defType('ResultSorter$1', 'Object', {
	$t: null
	, 
	_result: null,
	result: function (value) {
		if (arguments.length === 1) {
			this._result = value;
			return value;
		} else {
			return this._result;
		}
	}

	, 
	_hasRows: false,
	hasRows: function (value) {
		if (arguments.length === 1) {
			this._hasRows = value;
			return value;
		} else {
			return this._hasRows;
		}
	}

	, 
	_hasColumns: false,
	hasColumns: function (value) {
		if (arguments.length === 1) {
			this._hasColumns = value;
			return value;
		} else {
			return this._hasColumns;
		}
	}
	, 
	init: function ($t, result, hasRows, hasColumns) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.result(result);
			this.hasRows(hasRows);
			this.hasColumns(hasColumns);
	}

	, 
	sort: function () {
	}

	, 
	sortAxis: function (visitor, axis, indicesMap) {
		visitor.visitTuples();
		var tupleIndices = visitor.visitedTupleIndices();
		var tuples = new Array(tupleIndices.count());
		for (var i = 0; i < tupleIndices.count(); i++) {
			var index = tupleIndices.item(i);
			indicesMap.add(index, i);
		}

		for (var i1 = 0; i1 < tupleIndices.count(); i1++) {
			var index1 = tupleIndices.item(i1);
			var tuple = axis.tuples().__inner[index1];
			tuples[i1] = tuple;
		}

		return new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 1, tuples);
	}
	, 
	$type: new $.ig.Type('ResultSorter$1', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('ResultHeaderSorter', 'ResultSorter$1', {
	__sortDirections: null

	, 
	_appliedSortDirections: null,
	appliedSortDirections: function (value) {
		if (arguments.length === 1) {
			this._appliedSortDirections = value;
			return value;
		} else {
			return this._appliedSortDirections;
		}
	}

	, 
	_appliedSortDirectionsMap: null,
	appliedSortDirectionsMap: function (value) {
		if (arguments.length === 1) {
			this._appliedSortDirectionsMap = value;
			return value;
		} else {
			return this._appliedSortDirectionsMap;
		}
	}
	, 
	init: function (result, hasRows, hasColumns, sortDirections) {



		$.ig.ResultSorter$1.prototype.init.call(this, $.ig.AxisHeaderSortingVisitor.prototype.$type, result, hasRows, hasColumns);
			this.__sortDirections = new $.ig.Dictionary$2(String, $.ig.LevelSortDirection.prototype.$type, 1, sortDirections.count());
			var en = sortDirections.getEnumerator();
			while (en.moveNext()) {
				var levelSortDirection = en.current();
				this.__sortDirections.item(levelSortDirection.levelUniqueName(), levelSortDirection);
			}

	}

	, 
	sort: function () {
		var $self = this;
		$self.appliedSortDirections(new $.ig.List$1($.ig.LevelSortDirection.prototype.$type, 0));
		$self.appliedSortDirectionsMap(new $.ig.Dictionary$2(String, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type)), 0));
		if ($self.result().isEmpty()) {
			return $self.result();
		}

		var sortedAxes = new $.ig.List$1($.ig.OlapResultAxis.prototype.$type, 0);
		var axisIndex = 0;
		var columnsCount = 1;
		var columnIndicesMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Number.prototype.$type, 0);
		var rowIndecesMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Number.prototype.$type, 0);
		if ($self.hasColumns()) {
			var columnAxis = $self.result().axes().item(axisIndex);
			var columnSortDirectionsMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type), 0);
			var visitor = new $.ig.AxisHeaderSortingVisitor(columnAxis, $self.__sortDirections, $self.appliedSortDirections(), columnSortDirectionsMap);
			var sortedTuples = $self.sortAxis(visitor, columnAxis, columnIndicesMap);
			var sortedColumnAxis = (function () { var $ret = new $.ig.OlapResultAxis(sortedTuples, columnAxis.tupleSize());
			$ret.name(columnAxis.name()); return $ret;}());
			sortedAxes.add(sortedColumnAxis);
			$self.appliedSortDirectionsMap().item(columnAxis.name(), columnSortDirectionsMap);
			columnsCount = columnAxis.tuples().count();
			axisIndex++;
		}

		if ($self.hasRows()) {
			var rowAxis = $self.result().axes().item(axisIndex);
			var rowSortDirectionsMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type), 0);
			var visitor1 = new $.ig.AxisHeaderSortingVisitor(rowAxis, $self.__sortDirections, $self.appliedSortDirections(), rowSortDirectionsMap);
			var sortedTuples1 = $self.sortAxis(visitor1, rowAxis, rowIndecesMap);
			var sortedRowAxis = (function () { var $ret = new $.ig.OlapResultAxis(sortedTuples1, rowAxis.tupleSize());
			$ret.name(rowAxis.name()); return $ret;}());
			sortedAxes.add(sortedRowAxis);
			$self.appliedSortDirectionsMap().item(rowAxis.name(), rowSortDirectionsMap);
		}

		var sortedCells = new $.ig.List$1($.ig.OlapResultCell.prototype.$type, 2, $self.result().cells().count());
		var en = $self.result().cells().getEnumerator();
		while (en.moveNext()) {
			var c = en.current();
			var cell = c.clone();
			var cellOrdinal = cell.cellOrdinal();
			if ($self.hasColumns()) {
				var columnIndex = cellOrdinal % columnsCount;
				var newIndex = columnIndicesMap.item(columnIndex);
				if (columnIndex != newIndex) {
					var rowIndex = $.ig.intDivide(cellOrdinal, columnsCount);
					cellOrdinal = rowIndex * columnsCount + newIndex;
				}

			}

			if ($self.hasRows()) {
				var rowIndex1 = $.ig.intDivide(cellOrdinal, columnsCount);
				var newIndex1 = rowIndecesMap.item(rowIndex1);
				if (rowIndex1 != newIndex1) {
					var columnIndex1 = cellOrdinal % columnsCount;
					cellOrdinal = newIndex1 * columnsCount + columnIndex1;
				}

			}

			cell.cellOrdinal(cellOrdinal);
			sortedCells.add(cell);
		}

		var sortedResult = (function () { var $ret = new $.ig.OlapResult();
		$ret.isEmpty($self.result().isEmpty());
		$ret.axes(sortedAxes);
		$ret.cells(sortedCells); return $ret;}());
		return sortedResult;
	}
	, 
	$type: new $.ig.Type('ResultHeaderSorter', $.ig.ResultSorter$1.prototype.$type.specialize($.ig.AxisHeaderSortingVisitor.prototype.$type))
}, true);

$.ig.util.defType('AxisTupleVisitor', 'Object', {

	_axis: null,
	axis: function (value) {
		if (arguments.length === 1) {
			this._axis = value;
			return value;
		} else {
			return this._axis;
		}
	}

	, 
	_visitedTupleIndices: null,
	visitedTupleIndices: function (value) {
		if (arguments.length === 1) {
			this._visitedTupleIndices = value;
			return value;
		} else {
			return this._visitedTupleIndices;
		}
	}
	, 
	init: function (axis) {



		$.ig.Object.prototype.init.call(this);
			this.axis(axis);
	}

	, 
	visitTuples: function () {
		var $self = this;
		if ($self.axis().positionResolver().hasUnregisterdPositions()) {
			$self.axis().positionResolver().completeRegisterPositions();
		}

		$self.visitedTupleIndices(new $.ig.List$1($.ig.Number.prototype.$type, 2, $self.axis().tuples().count()));
		var rootItemPositionInfo = $self.axis().positionResolver().rootPositionInfo();
		var positionItemInfos = rootItemPositionInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == rootItemPositionInfo.positionItemDepthMin(); });
		var en = $self.sortPositions(rootItemPositionInfo, positionItemInfos).getEnumerator();
		while (en.moveNext()) {
			var positionItemInfo = en.current();
			$self.visitTuples1(rootItemPositionInfo, positionItemInfo);
		}

	}

	, 
	getChildPositions: function (hostPositionItemInfo, positionItemInfo) {
	}

	, 
	sortPositions: function (hostPositionItemInfo, positionItemInfos) {
	}

	, 
	visitTuples1: function (hostPositionItemInfo, positionItemInfo) {
		var $self = this;
		var hostedPosionsInfo = positionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == positionItemInfo.positionItemDepthMin(); });
		if (hostedPosionsInfo.count$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)) > 0) {
			var en = hostedPosionsInfo.getEnumerator();
			while (en.moveNext()) {
				var hostedItemInfo = en.current();
				$self.visitTuples1(positionItemInfo, hostedItemInfo);
			}


		} else {
			$self.visitedTupleIndices().add(positionItemInfo.positionIndex());
		}

		var childrenPosionInfo = $self.getChildPositions(hostPositionItemInfo, positionItemInfo);
		var en1 = childrenPosionInfo.getEnumerator();
		while (en1.moveNext()) {
			var childItemInfo = en1.current();
			$self.visitTuples1(hostPositionItemInfo, childItemInfo);
		}

	}
	, 
	$type: new $.ig.Type('AxisTupleVisitor', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('AxisHeaderSortingVisitor', 'AxisTupleVisitor', {
	__sortDirections: null
	, 
	__appliedSortDirections: null
	, 
	__appliedSortDirectionsMap: null
	, 
	init: function (axis, sortDirections, appliedSortDirections, appliedSortDirectionsMap) {



		$.ig.AxisTupleVisitor.prototype.init.call(this, axis);
			this.__sortDirections = sortDirections;
			this.__appliedSortDirections = appliedSortDirections;
			this.__appliedSortDirectionsMap = appliedSortDirectionsMap;
	}

	, 
	getChildPositions: function (hostPositionItemInfo, positionItemInfo) {
		var $self = this;
		var childPositions = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.parentKey() == positionItemInfo.key(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (childPositions.count() > 0) {
			var childPositionInfo = childPositions.item(0);
			var sortDirection;
			if ((function () { var $ret = $self.__sortDirections.tryGetValue(childPositionInfo.hierarchyLevelKey(), sortDirection); sortDirection = $ret.value; return $ret.ret; }())) {
				if (sortDirection.sortBehavior() == $.ig.LevelSortBehavior.prototype.system) {
					childPositions = sortDirection.sortDirection() == $.ig.ListSortDirection.prototype.ascending ? childPositions.orderBy$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), $.ig.Object.prototype.$type, function (pi) { return pi.sortKey(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)) : childPositions.orderByDescending$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), $.ig.Object.prototype.$type, function (pi) { return pi.sortKey(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));

				} else {
					childPositions = sortDirection.sortDirection() == $.ig.ListSortDirection.prototype.ascending ? childPositions.orderBy$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), String, function (pi) { return pi.caption(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)) : childPositions.orderByDescending$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), String, function (pi) { return pi.caption(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
				}

				if (!$self.__appliedSortDirections.select$2($.ig.LevelSortDirection.prototype.$type, String, function (x) { return x.levelUniqueName(); }).contains$1(String, sortDirection.levelUniqueName())) {
					$self.__appliedSortDirections.add(sortDirection);
				}

				var positions;
				if (!(function () { var $ret = $self.__appliedSortDirectionsMap.tryGetValue(childPositionInfo.positionItemIndex(), positions); positions = $ret.value; return $ret.ret; }())) {
					positions = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type, 0);
					$self.__appliedSortDirectionsMap.add(positionItemInfo.positionItemIndex(), positions);
				}

				positions.item(positionItemInfo.positionItemDepth(), sortDirection.sortDirection());
			}

		}

		return childPositions;
	}

	, 
	sortPositions: function (hostPositionItemInfo, positionItemInfos) {
		var $self = this;
		var positionItemInfosList = positionItemInfos.toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (positionItemInfosList.count() > 0) {
			var childPositionInfo = positionItemInfosList.item(0);
			var sortDirection;
			if (childPositionInfo.hierarchyLevelKey() != null && (function () { var $ret = $self.__sortDirections.tryGetValue(childPositionInfo.hierarchyLevelKey(), sortDirection); sortDirection = $ret.value; return $ret.ret; }())) {
				if (sortDirection.sortBehavior() == $.ig.LevelSortBehavior.prototype.system) {
					positionItemInfosList = sortDirection.sortDirection() == $.ig.ListSortDirection.prototype.ascending ? positionItemInfosList.orderBy$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), $.ig.Object.prototype.$type, function (pi) { return pi.sortKey(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)) : positionItemInfosList.orderByDescending$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), $.ig.Object.prototype.$type, function (pi) { return pi.sortKey(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));

				} else {
					positionItemInfosList = sortDirection.sortDirection() == $.ig.ListSortDirection.prototype.ascending ? positionItemInfosList.orderBy$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), String, function (pi) { return pi.caption(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type)) : positionItemInfosList.orderByDescending$2($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), String, function (pi) { return pi.caption(); }).toList$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
				}

				$self.__appliedSortDirections.add(sortDirection);
				var positions;
				if (!(function () { var $ret = $self.__appliedSortDirectionsMap.tryGetValue(childPositionInfo.positionItemIndex(), positions); positions = $ret.value; return $ret.ret; }())) {
					positions = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.ListSortDirection.prototype.$type, 0);
					$self.__appliedSortDirectionsMap.add(hostPositionItemInfo.positionItemIndex(), positions);
				}

				positions.item(hostPositionItemInfo.positionItemDepth(), sortDirection.sortDirection());
			}

		}

		return positionItemInfosList;
	}
	, 
	$type: new $.ig.Type('AxisHeaderSortingVisitor', $.ig.AxisTupleVisitor.prototype.$type)
}, true);

$.ig.util.defType('ResultColumnValueSorter', 'ResultSorter$1', {
	__tupleSortDirections: null

	, 
	_appliedSortDirections: null,
	appliedSortDirections: function (value) {
		if (arguments.length === 1) {
			this._appliedSortDirections = value;
			return value;
		} else {
			return this._appliedSortDirections;
		}
	}
	, 
	init: function (result, hasRows, hasColumns, tupleSortDirections) {



		$.ig.ResultSorter$1.prototype.init.call(this, $.ig.AxisValueSortingVisitor.prototype.$type, result, hasRows, hasColumns);
			this.__tupleSortDirections = tupleSortDirections;
	}

	, 
	sort: function () {
		var $self = this;
		$self.appliedSortDirections(new $.ig.List$1($.ig.TupleSortDirection.prototype.$type, 0));
		if (!$self.hasRows() || $self.result().isEmpty()) {
			return $self.result();
		}

		var sortedAxes = new $.ig.List$1($.ig.OlapResultAxis.prototype.$type, 0);
		var axisIndex = 0;
		var columnAxis = null;
		var columnsCount = 1;
		if ($self.hasColumns()) {
			columnAxis = $self.result().axes().item(axisIndex);
			columnsCount = columnAxis.tuples().count();
			sortedAxes.add(columnAxis.clone());
			axisIndex++;
		}

		var rowAxis = $self.result().axes().item(axisIndex);
		var rowsCount = $self.result().axes().item(axisIndex).tuples().count();
		var cellsMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Object.prototype.$type, 1, $self.result().cells().count());
		var en = $self.result().cells().getEnumerator();
		while (en.moveNext()) {
			var cell = en.current();
			var value = null;
			if ((function () { var $ret = cell.properties().tryGetValue("Value", value); value = $ret.value; return $ret.ret; }())) {
			cellsMap.item(cell.cellOrdinal(), value);

			} else {
				(function () { var $ret = cell.properties().tryGetValue("FmtValue", value); value = $ret.value; return $ret.ret; }());
				cellsMap.item(cell.cellOrdinal(), value);
			;
			}

		}

		var columnValuesToSort = new $.ig.List$1($.ig.KeyValuePair$2.prototype.$type.specialize($.ig.TupleSortDirection.prototype.$type, $.ig.Array.prototype.$type), 2, $self.__tupleSortDirections.count());
		var en1 = $self.__tupleSortDirections.getEnumerator();
		while (en1.moveNext()) {
			var tupleSortDirection = en1.current();
			var columnIndex;
			if (columnAxis != null && tupleSortDirection.memberNames() != null) {
				if (columnAxis.positionResolver().hasUnregisterdPositions()) {
					columnAxis.positionResolver().completeRegisterPositions();
				}

				columnIndex = columnAxis.positionResolver().rootPositionInfo().getIndex(tupleSortDirection.memberNames());
				tupleSortDirection.tupleIndex(columnIndex);

			} else {
				columnIndex = tupleSortDirection.tupleIndex();
			}

			if (columnIndex > -1 && columnIndex < columnsCount) {
				var column = new Array(rowsCount);
				for (var rowIndex = 0; rowIndex < rowsCount; rowIndex++) {
					var cell1 = null;
					(function () { var $ret = cellsMap.tryGetValue(rowIndex * columnsCount + columnIndex, cell1); cell1 = $ret.value; return $ret.ret; }());
					column[rowIndex] = cell1;
				}

				columnValuesToSort.add(new $.ig.KeyValuePair$2($.ig.TupleSortDirection.prototype.$type, $.ig.Array.prototype.$type, 1, tupleSortDirection, column));
				$self.appliedSortDirections().add(tupleSortDirection);
			}

		}

		var rowIndecesMap = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.Number.prototype.$type, 0);
		var visitor = new $.ig.AxisValueSortingVisitor(rowAxis, columnValuesToSort);
		var sortedTuples = $self.sortAxis(visitor, rowAxis, rowIndecesMap);
		var sortedRowAxis = (function () { var $ret = new $.ig.OlapResultAxis(sortedTuples, rowAxis.tupleSize());
		$ret.name(rowAxis.name()); return $ret;}());
		sortedAxes.add(sortedRowAxis);
		var sortedCells = new $.ig.List$1($.ig.OlapResultCell.prototype.$type, 2, $self.result().cells().count());
		var en2 = $self.result().cells().getEnumerator();
		while (en2.moveNext()) {
			var c = en2.current();
			var cell2 = c.clone();
			var cellOrdinal = cell2.cellOrdinal();
			var rowIndex1 = $.ig.intDivide(cellOrdinal, columnsCount);
			var newIndex = rowIndecesMap.item(rowIndex1);
			if (rowIndex1 != newIndex) {
				var columnIndex1 = cellOrdinal % columnsCount;
				cellOrdinal = newIndex * columnsCount + columnIndex1;
			}

			cell2.cellOrdinal(cellOrdinal);
			sortedCells.add(cell2);
		}

		var sortedResult = (function () { var $ret = new $.ig.OlapResult();
		$ret.isEmpty($self.result().isEmpty());
		$ret.axes(sortedAxes);
		$ret.cells(sortedCells); return $ret;}());
		return sortedResult;
	}
	, 
	$type: new $.ig.Type('ResultColumnValueSorter', $.ig.ResultSorter$1.prototype.$type.specialize($.ig.AxisValueSortingVisitor.prototype.$type))
}, true);

$.ig.util.defType('AxisValueSortingVisitor', 'AxisTupleVisitor', {
	__tupleSortDirections: null
	, 
	init: function (axis, tupleSortDirections) {



		$.ig.AxisTupleVisitor.prototype.init.call(this, axis);
			this.__tupleSortDirections = tupleSortDirections;
	}

	, 
	getChildPositions: function (hostPositionItemInfo, positionItemInfo) {
		var $self = this;
		var childPositions = hostPositionItemInfo.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.parentKey() == positionItemInfo.key(); });
		return $self.sortPositions(hostPositionItemInfo, childPositions);
	}

	, 
	sortPositions: function (hostPositionItemInfo, positionItemInfos) {
		var positionItemInfos_ = positionItemInfos.toArray$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type));
		if (positionItemInfos_.length > 0) {
			var tupleSortDirections_ = this.__tupleSortDirections.toArray$1($.ig.KeyValuePair$2.prototype.$type.specialize($.ig.TupleSortDirection.prototype.$type, $.ig.Array.prototype.$type));
			
var sortFunction = function (tupleSortDirections) {
    var compareCells = function (comparer, cell1, cell2) {
        var result = comparer(cell1, cell2);
        if (result < 0) {
            return -1;
        }
        if (result > 0) {
            return 1;
        }
        return (!isNaN(parseFloat(result)) && isFinite(result)) ? result : 0;
    };
    return function (o1, o2) {
        var i, length, tupleSortDirection, cells, direction,
            cell1, cell2, arr1 = [], arr2 = [];

        for (i=0;i<tupleSortDirections.length;i++) {
            tupleSortDirection = tupleSortDirections[i].key();
            cells = tupleSortDirections[i].value();

            if (tupleSortDirection.sortDirection() === $.ig.ListSortDirection.prototype.ascending) {
                direction = 1;
            } else {
                direction = -1;
            }

            comparer = tupleSortDirection.comparer();

            cell1 = cells[o1.positionIndex()];
            cell2 = cells[o2.positionIndex()];
            if (tupleSortDirections.length === 1) {
                arr1 = direction * compareCells(comparer, cell1, cell2);
                arr2 = direction * compareCells(comparer, cell2, cell1);
            } else {
                arr1.push(direction * compareCells(comparer, cell1, cell2));
                arr2.push(direction * compareCells(comparer, cell2, cell1));
            }
        }

        if (arr1 < arr2) {
            return -1;
        }
        if (arr1 > arr2) {
            return 1;
        }
        return 0;
    };
};

positionItemInfos_.sort(sortFunction(tupleSortDirections_));
;
		}

		return positionItemInfos_;
	}
	, 
	$type: new $.ig.Type('AxisValueSortingVisitor', $.ig.AxisTupleVisitor.prototype.$type)
}, true);

$.ig.util.defType('TupleSortDirection', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
	}

	, 
	_tupleIndex: 0,
	tupleIndex: function (value) {
		if (arguments.length === 1) {
			this._tupleIndex = value;
			return value;
		} else {
			return this._tupleIndex;
		}
	}

	, 
	_memberNames: null,
	memberNames: function (value) {
		if (arguments.length === 1) {
			this._memberNames = value;
			return value;
		} else {
			return this._memberNames;
		}
	}

	, 
	_sortDirection: null,
	sortDirection: function (value) {
		if (arguments.length === 1) {
			this._sortDirection = value;
			return value;
		} else {
			return this._sortDirection;
		}
	}

	, 
	_comparer: null,
	comparer: function (value) {
		if (arguments.length === 1) {
			this._comparer = value;
			return value;
		} else {
			return this._comparer;
		}
	}
	, 
	$type: new $.ig.Type('TupleSortDirection', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DataSourceBase', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_dataSource: null,
	dataSource: function (value) {
		if (arguments.length === 1) {
			this._dataSource = value;
			return value;
		} else {
			return this._dataSource;
		}
	}

	, 
	isInitialized: function () {

			if (this.dataSource() == null) {
				return false;
			}

			return this.dataSource().isInitialized();
	}

	, 
	_isModified: false,
	isModified: function (value) {
		if (arguments.length === 1) {
			this._isModified = value;
			return value;
		} else {
			return this._isModified;
		}
	}

	, 
	_isUpdating: false,
	isUpdating: function (value) {
		if (arguments.length === 1) {
			this._isUpdating = value;
			return value;
		} else {
			return this._isUpdating;
		}
	}

	, 
	initialize: function () {
		var promise_ = this.dataSource().initialize().promise();
		
var $this = this;
if (!this._isInitializedAttached) {
    this._isInitializedAttached = true;
    promise_.always(function (result) {
        var args = {
            error: null,
            metadataTreeRoot: null
        };

        if (this.state() === 'rejected') {
            args.error = result;
        } else {
            args.metadataTreeRoot = result;
        }

        $($this).trigger('initialized', args);
        $this._isInitializedAttached = false;
    });
}
;
		return promise_;
	}

	, 
	cubes: function () {

			return (this.dataSource().cubes()).inner();
	}

	, 
	cube: function () {

			return this.dataSource().cube();
	}

	, 
	setCube: function (cubeName) {
		var $self = this;
		return $self.dataSource().setCube(cubeName).continueWith$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) {
	return t.result();
}).promise();
	}

	, 
	metadataTree: function () {

			return this.dataSource().metadataTree();
	}

	, 
	addRowItem: function (rowItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, rowItem) !== null) {
			this.dataSource().rowAxis().add(rowItem);
			this.isModified(true);
		}

	}

	, 
	insertRowItem: function (index, rowItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, rowItem) !== null) {
			this.dataSource().rowAxis().insert(index, rowItem);
			this.isModified(true);
		}

	}

	, 
	removeRowItem: function (rowItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, rowItem) !== null || $.ig.util.cast($.ig.MeasureList.prototype.$type, rowItem) !== null) {
			this.dataSource().rowAxis().remove(rowItem);
			this.isModified(true);
		}

	}

	, 
	addColumnItem: function (columnItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, columnItem) !== null) {
			this.dataSource().columnAxis().add(columnItem);
			this.isModified(true);
		}

	}

	, 
	insertColumnItem: function (index, columnItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, columnItem) !== null) {
			this.dataSource().columnAxis().insert(index, columnItem);
			this.isModified(true);
		}

	}

	, 
	removeColumnItem: function (columnItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, columnItem) !== null || $.ig.util.cast($.ig.MeasureList.prototype.$type, columnItem) !== null) {
			this.dataSource().columnAxis().remove(columnItem);
			this.isModified(true);
		}

	}

	, 
	addFilterItem: function (filterItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, filterItem) !== null) {
			this.dataSource().filters().add(filterItem);
			this.isModified(true);
		}

	}

	, 
	insertFilterItem: function (index, filterItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, filterItem) !== null) {
			this.dataSource().filters().insert(index, filterItem);
			this.isModified(true);
		}

	}

	, 
	removeFilterItem: function (filterItem) {
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, filterItem) !== null) {
			this.dataSource().filters().remove(filterItem);
			this.isModified(true);
		}

	}

	, 
	addMeasureItem: function (measureItem) {
		if ($.ig.util.cast($.ig.Measure.prototype.$type, measureItem) !== null) {
			this.dataSource().measures().add(measureItem);
			this.isModified(true);
		}

	}

	, 
	insertMeasureItem: function (index, measureItem) {
		if ($.ig.util.cast($.ig.Measure.prototype.$type, measureItem) !== null) {
			this.dataSource().measures().insert(index, measureItem);
			this.isModified(true);
		}

	}

	, 
	removeMeasureItem: function (measureItem) {
		if ($.ig.util.cast($.ig.Measure.prototype.$type, measureItem) !== null) {
			this.dataSource().measures().remove(measureItem);
			this.isModified(true);
		}

	}

	, 
	setMeasureListIndex: function (index) {
		this.dataSource().measureListIndex(index);
		this.isModified(true);
	}

	, 
	setMeasureListLocation: function (location) {
		switch (location) {
			case "rows":
				this.dataSource().measureListLocation($.ig.MeasureListLocation.prototype.rows);
				break;
			case "columns":
				this.dataSource().measureListLocation($.ig.MeasureListLocation.prototype.columns);
				break;
			default:
				break;
		}

		this.isModified(true);
	}

	, 
	getMeasureListLocation: function () {
		switch (this.dataSource().measureListLocation()) {
			case $.ig.MeasureListLocation.prototype.rows:
				return "rows";
				break;
			case $.ig.MeasureListLocation.prototype.columns:
				return "columns";
				break;
			default:
				return null;
				break;
		}

	}

	, 
	expandTupleMember: function (axisName, tupleIndex, memberIndex) {
		this.dataSource().expandTupleMember(axisName, tupleIndex, memberIndex);
	}

	, 
	collapseTupleMember: function (axisName, tupleIndex, memberIndex) {
		this.dataSource().collapseTupleMember(axisName, tupleIndex, memberIndex);
	}

	, 
	rowAxis: function () {

			return (this.dataSource().rowAxis()).inner();
	}

	, 
	columnAxis: function () {

			return (this.dataSource().columnAxis()).inner();
	}

	, 
	filters: function () {

			return (this.dataSource().filters()).inner();
	}

	, 
	measures: function () {

			return (this.dataSource().measures()).inner();
	}

	, 
	result: function () {

			return this.dataSource().result();
	}

	, 
	bindCollectionChanged: function (options) {
		var options_ = options;
		var ds_ = this.dataSource();
		
var attachCollectionChanged = function(collection, handler) {
    collection.collectionChanged = $.ig.Delegate.prototype.combine(
        collection.collectionChanged,
        handler
    );
};

if ($.isFunction(options_['filters'])) {
    attachCollectionChanged(ds_._filters, options_['filters']);
}
if ($.isFunction(options_['rowAxis'])) {
    attachCollectionChanged(ds_._rowAxis, options_['rowAxis']);
}
if ($.isFunction(options_['columnAxis'])) {
    attachCollectionChanged(ds_._columnAxis, options_['columnAxis']);
}
if ($.isFunction(options_['measures'])) {
    attachCollectionChanged(ds_._measures, options_['measures']);
}
;
	}

	, 
	unbindCollectionChanged: function (options) {
		var options_ = options;
		var ds_ = this.dataSource();
		
unbindCollectionChanged = function(collection, handler) {
    collection.collectionChanged = $.ig.Delegate.prototype.remove(
        collection.collectionChanged,
        handler
    );
};

if ($.isFunction(options_['filters'])) {
    unbindCollectionChanged(ds_._filters, options_['filters']);
}
if ($.isFunction(options_['rowAxis'])) {
    unbindCollectionChanged(ds_._rowAxis, options_['rowAxis']);
}
if ($.isFunction(options_['columnAxis'])) {
    unbindCollectionChanged(ds_._columnAxis, options_['columnAxis']);
}
if ($.isFunction(options_['measures'])) {
    unbindCollectionChanged(ds_._measures, options_['measures']);
}
;
	}

	, 
	clearPendingChanges: function () {
		this.dataSource().clearPendingChanges();
	}

	, 
	update: function () {
		var promise_ = this.dataSource().update().promise();
		
var $this = this;
if (!this.isUpdating()) {
    this.isUpdating(true);
    promise_.always(function (result) {
        var args = {
            error: null,
            result: null
        };

        if (this.state() === 'rejected') {
            args.error = result;
        } else {
            args.result = result;
        }

        $this.isUpdating(false);
        $this.isModified(false);
        $($this).trigger('updated', args);
    });
}
;
		return promise_;
	}

	, 
	getCoreElement: function (predicate, elementType) {
		return this.dataSource().getCoreElement(predicate, elementType);
	}

	, 
	getCoreElements: function (predicate, elementType) {
		return (this.dataSource().getCoreElements(predicate, elementType)).inner();
	}

	, 
	getMembersOfHierarchy: function (hierarchyUniqueName) {
		return this.dataSource().getMembersOfHierarchy(hierarchyUniqueName).promise();
	}

	, 
	getMembersOfLevel: function (levelUniqueName) {
		return this.dataSource().getMembersOfLevel(levelUniqueName).promise();
	}

	, 
	tryGetMember: function (memberUniqueName) {
		var $self = this;
		var member;
		if ((function () { var $ret = $self.dataSource().tryGetMember(memberUniqueName, member); member = $ret.member; return $ret.ret; }())) {
			return member;
		}

		return null;
	}

	, 
	tryGetMembersForLevel: function (levelUniqueName) {
		var $self = this;
		var members = new $.ig.ArrayListCollection$1($.ig.Member.prototype.$type);
		var success = (function () { var $ret = $self.dataSource().tryGetMembersForLevel(levelUniqueName, members); members = $ret.members; return $ret.ret; }());
		return success ? (members).inner() : (new $.ig.ArrayListCollection$1($.ig.Member.prototype.$type)).inner();
	}

	, 
	getMembersOfMember: function (memberUniqueName) {
		return this.dataSource().getMembersOfMember(memberUniqueName).promise();
	}

	, 
	addFilterMember: function (hierarchyUniqueName, memberUniqueName) {
		this.dataSource().addFilterMember(hierarchyUniqueName, memberUniqueName);
		this.isModified(true);
	}

	, 
	removeAllFilterMembers: function (hierarchyUniqueName) {
		this.dataSource().removeAllFilterMembers(hierarchyUniqueName);
		this.isModified(true);
	}

	, 
	getFilterMemberNames: function (hierarchyUniqueName) {
		return (this.dataSource().getFilterMemberNames(hierarchyUniqueName)).inner();
	}

	, 
	getDimension: function (dimensionUniqueName) {
		var $self = this;
		return $self.dataSource().getCoreElement(function (d) { return d.uniqueName() == dimensionUniqueName; }, $.ig.Dimension.prototype.$type);
	}

	, 
	getHierarchy: function (hierarchyUniqueName) {
		var $self = this;
		return $self.dataSource().getCoreElement(function (h) { return h.uniqueName() == hierarchyUniqueName; }, $.ig.Hierarchy.prototype.$type);
	}

	, 
	getLevel: function (levelUniqueName) {
		var $self = this;
		return $self.dataSource().getCoreElement(function (l) { return l.uniqueName() == levelUniqueName; }, $.ig.Level.prototype.$type);
	}

	, 
	getMeasure: function (measurelUniqueName) {
		var $self = this;
		return $self.dataSource().getCoreElement(function (m) { return m.uniqueName() == measurelUniqueName; }, $.ig.Measure.prototype.$type);
	}

	, 
	getMeasureList: function () {
		return this.dataSource().getCoreElement(null, $.ig.MeasureList.prototype.$type);
	}
	, 
	$type: new $.ig.Type('DataSourceBase', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('jQueryUtils', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	javascriptObjectToDictionary$1: function ($t, jsObject) {
		if (jsObject == null) {
		return null;
		}

		var jsObject_ = jsObject;
		var dict_ = new $.ig.Dictionary$2(String, $t, 0);
		(function (obj, dict) {
                var tempDict = $.ig.Dictionary.prototype.getDictionary(obj);
                var keys = tempDict.keys();
                while (keys.moveNext()){
                    var key = keys.current();
                    var value = tempDict.item(key);
                    dict.add(key, value);
                }
            })(jsObject_, dict_);
		return dict_;
	}

	, 
	javascriptObjectFromDictionary$1: function ($t, dict) {
		if (dict == null) {
		return null;
		}

		var dict_ = dict;
		return dict_.__inner.proxy;
	}

	, 
	convertToObjectDictionary: function (jsObject) {
		return $.ig.jQueryUtils.prototype.javascriptObjectToDictionary$1($.ig.Object.prototype.$type, jsObject);
	}

	, 
	convertToStringDictionary: function (jsObject) {
		return $.ig.jQueryUtils.prototype.javascriptObjectToDictionary$1(String, jsObject);
	}

	, 
	convertFromObjectDictionary: function (dictionary) {
		return $.ig.jQueryUtils.prototype.javascriptObjectFromDictionary$1($.ig.Object.prototype.$type, dictionary);
	}

	, 
	convertFromStringDictionary: function (dictionary) {
		return $.ig.jQueryUtils.prototype.javascriptObjectFromDictionary$1(String, dictionary);
	}

	, 
	createJavascriptObject: function () {
		return {};
	}

	, 
	getJavascriptObjectProperty: function (jsObject, property) {
		var jsObject_ = jsObject;
		var property_ = property;
		return jsObject_[property_];
	}

	, 
	setJavascriptObjectProperty: function (jsObject, property, value) {
		var jsObject_ = jsObject;
		var property_ = property;
		var value_ = value;
		jsObject_[property_] = value_;
	}

	, 
	getJavascriptObjectMethodResult: function (jsObject, method, args) {
	args = Array.prototype.slice.call(arguments, 2);
		var jsObject_ = jsObject;
		var method_ = method;
		var args_ = args;
		return jsObject_[method_].call(jsObject_, args_);
	}
	, 
	$type: new $.ig.Type('jQueryUtils', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapUtilities', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	dateMemberProvider: function (datePart, datePropName, format, datePartFormat) {
		if (String.isNullOrEmpty(datePart) || String.isNullOrEmpty(datePropName)) {
			return null;
		}

		var propName_ = datePropName;
		var datePartFormat_ = datePartFormat;
		var format_ = format;
		var yearProvider_;
		var semesterProvider_;
		var quarterProvider_;
		var monthProvider_;
		datePart = datePart.toLowerCase();
		switch (datePart) {
			case "year":
				if (datePartFormat_ == null) {
					datePartFormat_ = "yyyy";
				}

				if (format_ == null) {
					return function (item) { return $.ig.formatter(new Date(item[propName_]), 'date', datePartFormat_); };
				}

				return function (item) { return format_.replace('{0}', $.ig.formatter(new Date(item[propName_]), 'date', datePartFormat_)); };
			case "semester":
				if (format_ == null) {
					format_ = "H{0}";
				}

				yearProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("year", datePropName, null, null);
				return function (item) {
                    var year = yearProvider_(item);
                    return format_.replace('{0}', Math.floor(new Date(item[propName_]).getMonth() / 6) + 1).replace('{1}', year); 
                };
			case "quarter":
				if (format_ == null) {
					format_ = "Q{0}";
				}

				yearProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("year", datePropName, null, null);
				semesterProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("semester", datePropName, null, null);
				return function (item) {
                    var year = yearProvider_(item);
                    var semester = semesterProvider_(item);
                    return format_.replace('{0}', Math.floor(new Date(item[propName_]).getMonth() / 3) + 1).replace('{1}', semester).replace('{2}', year); 
                };
			case "month":
				if (datePartFormat_ == null) {
					datePartFormat_ = "MMMM";
				}

				if (format_ == null) {
					return function (item) { return $.ig.formatter(new Date(item[propName_]), 'date', datePartFormat_); };
				}

				yearProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("year", datePropName, null, null);
				semesterProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("semester", datePropName, null, null);
				quarterProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("quarter", datePropName, null, null);
				return function (item) {
                    var year = yearProvider_(item);
                    var semester = semesterProvider_(item);
                    var quarter = quarterProvider_(item);
                    return format_.replace('{0}', $.ig.formatter(new Date(item[propName_]), 'date', datePartFormat_)).replace('{1}', quarter).replace('{2}', semester).replace('{3}', year); 
                };
			case "date":
				if (datePartFormat_ == null) {
					datePartFormat_ = "MM/dd/yyyy";
				}

				if (format_ == null) {
					return function (item) { return $.ig.formatter(new Date(item[propName_]), 'date', datePartFormat_); };
				}

				yearProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("year", datePropName, null, null);
				semesterProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("semester", datePropName, null, null);
				quarterProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("quarter", datePropName, null, null);
				monthProvider_ = $.ig.OlapUtilities.prototype.dateMemberProvider("month", datePropName, null, null);
				return function (item) {
                    var year = yearProvider_(item);
                    var semester = semesterProvider_(item);
                    var quarter = quarterProvider_(item);
                    var month = monthProvider_(item);
                    return format_.replace('{0}', $.ig.formatter(new Date(item[propName_]), 'date', datePartFormat_)).replace('{1}', month).replace('{2}', quarter).replace('{3}', semester).replace('{4}', year); 
                };
		}

		return null;
	}

	, 
	getDateHierarchy: function (datePropName, dateParts, name, caption, levelCaptions, rootCaption) {
		var $self = this;
		if (String.isNullOrEmpty(datePropName)) {
			return null;
		}

		if (dateParts == null || dateParts.length == 0) {
			dateParts = (function () { var $ret = new Array();
			$ret.add("year");
			$ret.add("quarter");
			$ret.add("month");
			$ret.add("date");return $ret;}());

		} else {
			for (var i = 0; i < dateParts.length; i++) {
				dateParts[i] = dateParts[i].toLowerCase();
			}

		}

		if (name == null) {
			name = "Dates";
		}

		if (caption == null) {
			caption = name;
		}

		var res_ = null;
		var name_ = name;
		var caption_ = caption;
		var rootCaption_ = rootCaption;
		var dateParts_ = dateParts;
		if (levelCaptions == null) {
			levelCaptions = new Array(dateParts.length);
			for (var i1 = 0; i1 < levelCaptions.length; i1++) {
				var datePart = dateParts[i1];
				levelCaptions[i1] = datePart.substr(0, 1).toUpperCase() + datePart.substr(1, datePart.length) + "s";
			}

		}

		var captions_ = levelCaptions;
		var memberProviders_ = new Array(dateParts.length);
		for (var i2 = 0; i2 < dateParts.length; i2++) {
			var datePart1 = dateParts[i2];
			memberProviders_[i2] = $.ig.OlapUtilities.prototype.dateMemberProvider(datePart1, datePropName, null, null);
		}

		
            var levelsMetadata = [];
            var levelOffset = 0;

            if (rootCaption_ != null && rootCaption_ != '') {
                levelOffset = 1;
                levelsMetadata[0] = { name: rootCaption_, caption: rootCaption_, memberProvider: function(item) { return rootCaption_;}};
            }

            for (var i = 0; i < memberProviders_.length; i++){
                levelsMetadata[i + levelOffset] = { name: dateParts_[i], caption: captions_[i], memberProvider: memberProviders_[i]};
            }

            res_ = { name: name_, caption: caption_, levels: levelsMetadata};
;
		return res_;
	}

	, 
	sumAggregator: function (propName, precision) {
		var propName_ = propName;
		var precision_ = precision;
		return function(items, cellMetadata) {
            var sum = 0, areAllNullOrUndefined = true, value;

            for (var i = 0; i < items.length; i++) {
                value = items[i][propName_];
                if (value !== null && value !== undefined) {
                    areAllNullOrUndefined = false;
                    sum += value;
                }
            }
            
            if (areAllNullOrUndefined)
                return null;
            if (precision_ != null) {
                return sum.toFixed(precision_);
            }
            return sum;            
        };
	}

	, 
	avgAggregator: function (propName, precision) {
		var propName_ = propName;
		var precision_ = precision;
		return function(items, cellMetadata) {
            if (precision_ == null) {
                precision_ = 2;
            }
            var sum = 0, count = 0, areAllNullOrUndefined = true, value;
            for (var i = 0; i < items.length; i++) {
                value = items[i][propName_];
                if (value !== null && value !== undefined) {
                    areAllNullOrUndefined = false;
                    sum += value;
                    count++;
                }
            }
                
            if (areAllNullOrUndefined)
                return null;

            return (sum/count).toFixed(precision_);
        };
	}

	, 
	minAggregator: function (propName) {
		var propName_ = propName;
		return function(items, cellMetadata) {
            var result = items[0][propName_];;                
            for (var i = 1; i < items.length; i++) {
                result = Math.min(result, items[i][propName_]);
            }
            return result;
        };
	}

	, 
	maxAggregator: function (propName) {
		var propName_ = propName;
		return function(items, cellMetadata) {
            var result = items[0][propName_];;                
            for (var i = 1; i < items.length; i++) {
                result = Math.max(result, items[i][propName_]);
            }
            return result;
        };
	}

	, 
	countAggregator: function () {
		return function(items, cellMetadata) {
            return items.length;
        };
	}
	, 
	$type: new $.ig.Type('OlapUtilities', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('OlapTableView', 'Object', {
	__tableViewImpl: null
	, 
	init: function (result, hasColumns, hasRows, viewSettings) {



		$.ig.Object.prototype.init.call(this);
			var settings = this.settingsFromJavascriptObject(viewSettings);
			this.__tableViewImpl = new $.ig.TableViewImpl(result, hasColumns, hasRows, settings);
	}

	, 
	rowHeaders: function () {

			if (this.__tableViewImpl.rowHeaders() == null) {
			return null;
			}

			return (this.__tableViewImpl.rowHeaders()).inner();
	}

	, 
	columnHeaders: function () {

			if (this.__tableViewImpl.columnHeaders() == null) {
			return null;
			}

			return (this.__tableViewImpl.columnHeaders()).inner();
	}

	, 
	resultCells: function () {

			if (this.__tableViewImpl.resultCells() == null) {
			return null;
			}

			return (this.__tableViewImpl.resultCells()).inner();
	}

	, 
	columnSortDirections: function (value) {
		if (arguments.length === 1) {

			this.__tableViewImpl.columnSortDirections().clear();
			var en = value.getEnumerator();
			while (en.moveNext()) {
				var obj = en.current();
				var tupleSortDirection = this.tupleSortDirectionFromJavascriptObject(obj);
				this.__tableViewImpl.columnSortDirections().add(tupleSortDirection);
			}

			return value;
		} else {

			var columnSortDirections = new $.ig.Array();
			var en = this.__tableViewImpl.columnSortDirections().getEnumerator();
			while (en.moveNext()) {
				var columnSortDirection = en.current();
				columnSortDirections.add(this.tupleSortDirectionToJavascriptObject(columnSortDirection));
			}

			return columnSortDirections;
		}
	}

	, 
	appliedColumnSortDirections: function () {

			var columnSortDirections = new $.ig.Array();
			var en = this.__tableViewImpl.appliedColumnSortDirections().getEnumerator();
			while (en.moveNext()) {
				var columnSortDirection = en.current();
				columnSortDirections.add(this.tupleSortDirectionToJavascriptObject(columnSortDirection));
			}

			return columnSortDirections;
	}

	, 
	levelSortDirections: function (value) {
		if (arguments.length === 1) {

			this.__tableViewImpl.levelSortDirections().clear();
			var en = value.getEnumerator();
			while (en.moveNext()) {
				var obj = en.current();
				var levelSortDirection = this.levelSortDirectionFromJavascriptObject(obj);
				this.__tableViewImpl.levelSortDirections().add(levelSortDirection);
			}

			return value;
		} else {

			var levelSortDirections = new $.ig.Array();
			var en = this.__tableViewImpl.levelSortDirections().getEnumerator();
			while (en.moveNext()) {
				var levelSortDirection = en.current();
				levelSortDirections.add(this.levelSortDirectionToJavascriptObject(levelSortDirection));
			}

			return levelSortDirections;
		}
	}

	, 
	appliedLevelSortDirections: function () {

			var levelSortDirections = new $.ig.Array();
			var en = this.__tableViewImpl.appliedLevelSortDirections().getEnumerator();
			while (en.moveNext()) {
				var levelSortDirection = en.current();
				levelSortDirections.add(this.levelSortDirectionToJavascriptObject(levelSortDirection));
			}

			return levelSortDirections;
	}

	, 
	appliedSortDirectionsMap: function () {

			var resultMap_ = $.ig.jQueryUtils.prototype.createJavascriptObject();
			var i_En = this.__tableViewImpl.appliedSortDirectionsMap().getEnumerator();
			while (i_En.moveNext()) {
				var i_ = i_En.current();
				var axisMap_ = $.ig.jQueryUtils.prototype.createJavascriptObject();
				var j_En = i_.value().getEnumerator();
				while (j_En.moveNext()) {
					var j_ = j_En.current();
					var hierarchyMap_ = $.ig.jQueryUtils.prototype.createJavascriptObject();
					var k_En = j_.value().getEnumerator();
					while (k_En.moveNext()) {
						var k_ = k_En.current();
						var sortDirection_ = k_.value() == $.ig.ListSortDirection.prototype.ascending ? "ascending" : "descending";
						hierarchyMap_[k_.key()] = sortDirection_;

					}
					axisMap_[j_.key()] = hierarchyMap_;

				}
				resultMap_[i_.key()] = axisMap_;

			}
			return resultMap_;
	}

	, 
	initialize: function () {
		this.__tableViewImpl.initialize();
	}

	, 
	settingsFromJavascriptObject: function (o) {
		var $self = this;
		var isParentInFrontForColumns = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "isParentInFrontForColumns");
		var isParentInFrontForRows = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "isParentInFrontForRows");
		var compactColumnHeaders = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "compactColumnHeaders");
		var compactRowHeaders = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "compactRowHeaders");
		return (function () { var $ret = new $.ig.TableViewSettings();
		$ret.isParentInFrontForColumns(isParentInFrontForColumns);
		$ret.isParentInFrontForRows(isParentInFrontForRows);
		$ret.compactColumnHeaders(compactColumnHeaders);
		$ret.compactRowHeaders(compactRowHeaders); return $ret;}());
	}

	, 
	tupleSortDirectionFromJavascriptObject: function (o_) {
		var $self = this;
		var memberNames = $.ig.util.cast($.ig.Array.prototype.$type, $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o_, "memberNames"));
		var index = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o_, "tupleIndex");
		var sortDirection = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o_, "sortDirection");
		var parsedSortDirection = $.ig.ListSortDirection.prototype.ascending;
		if (!String.isNullOrEmpty(sortDirection)) {
			sortDirection = sortDirection.toLowerCase();
			if (sortDirection == "descending") {
				parsedSortDirection = $.ig.ListSortDirection.prototype.descending;
			}

		}

		var comparer_ = null;
		
if ($.isFunction(o_.comparer)) {
    comparer_ = o_.comparer;
} else {
    comparer_ = function (o1, o2) {
        return parseFloat(o1 || -Infinity) - parseFloat(o2 || -Infinity);
    };
}
;
		return (function () { var $ret = new $.ig.TupleSortDirection();
		$ret.memberNames(memberNames);
		$ret.tupleIndex(index);
		$ret.sortDirection(parsedSortDirection);
		$ret.comparer(comparer_); return $ret;}());
	}

	, 
	tupleSortDirectionToJavascriptObject: function (tupleSortDirection) {
		var jsTupleSortDirection = $.ig.jQueryUtils.prototype.createJavascriptObject();
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(jsTupleSortDirection, "memberNames", tupleSortDirection.memberNames());
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(jsTupleSortDirection, "tupleIndex", tupleSortDirection.tupleIndex());
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(jsTupleSortDirection, "sortDirection", tupleSortDirection.sortDirection() == $.ig.ListSortDirection.prototype.ascending ? "ascending" : "descending");
		if (tupleSortDirection.comparer() != null) {
			$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(jsTupleSortDirection, "comparer", tupleSortDirection.comparer());
		}

		return jsTupleSortDirection;
	}

	, 
	levelSortDirectionFromJavascriptObject: function (o) {
		var levelUniqueName = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "levelUniqueName");
		var sortDirection = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "sortDirection");
		var sortBehavior = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(o, "sortBehavior");
		if (!String.isNullOrEmpty(levelUniqueName)) {
			var levelSortDirection = new $.ig.LevelSortDirection();
			levelSortDirection.sortDirection($.ig.ListSortDirection.prototype.ascending);
			levelSortDirection.sortBehavior($.ig.LevelSortBehavior.prototype.system);
			levelSortDirection.levelUniqueName(levelUniqueName);
			if (!String.isNullOrEmpty(sortDirection)) {
				sortDirection = sortDirection.toLowerCase();
				if (sortDirection == "descending") {
					levelSortDirection.sortDirection($.ig.ListSortDirection.prototype.descending);
				}

			}

			if (!String.isNullOrEmpty(sortBehavior)) {
				sortBehavior = sortBehavior.toLowerCase();
				if (sortBehavior == "alphabetical") {
					levelSortDirection.sortBehavior($.ig.LevelSortBehavior.prototype.alphabetical);
				}

			}

			return levelSortDirection;

		} else {
			return null;
		}

	}

	, 
	levelSortDirectionToJavascriptObject: function (levelSortDirection) {
		var jsLevelSortDirection = $.ig.jQueryUtils.prototype.createJavascriptObject();
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(jsLevelSortDirection, "levelUniqueName", levelSortDirection.levelUniqueName());
		$.ig.jQueryUtils.prototype.setJavascriptObjectProperty(jsLevelSortDirection, "sortDirection", levelSortDirection.sortDirection() == $.ig.ListSortDirection.prototype.ascending ? "ascending" : "descending");
		return jsLevelSortDirection;
	}
	, 
	$type: new $.ig.Type('OlapTableView', $.ig.Object.prototype.$type)
}, true);


$.ig.LevelSortBehavior.prototype.alphabetical = 0;
$.ig.LevelSortBehavior.prototype.system = 1;






$.ig.OlapMetadataTreeItemType.prototype.cube = 0;
$.ig.OlapMetadataTreeItemType.prototype.dimension = 1;
$.ig.OlapMetadataTreeItemType.prototype.group = 2;
$.ig.OlapMetadataTreeItemType.prototype.userDefinedHierarchy = 3;
$.ig.OlapMetadataTreeItemType.prototype.systemEnabledHierarchy = 4;
$.ig.OlapMetadataTreeItemType.prototype.parentChildHierarchy = 5;
$.ig.OlapMetadataTreeItemType.prototype.measure = 6;
$.ig.OlapMetadataTreeItemType.prototype.level1 = 7;
$.ig.OlapMetadataTreeItemType.prototype.level2 = 8;
$.ig.OlapMetadataTreeItemType.prototype.level3 = 9;
$.ig.OlapMetadataTreeItemType.prototype.level4 = 10;
$.ig.OlapMetadataTreeItemType.prototype.level5 = 11;
$.ig.OlapMetadataTreeItemType.prototype.kpiRoot = 12;
$.ig.OlapMetadataTreeItemType.prototype.kpi = 13;
$.ig.OlapMetadataTreeItemType.prototype.kpiValue = 14;
$.ig.OlapMetadataTreeItemType.prototype.kpiGoal = 15;
$.ig.OlapMetadataTreeItemType.prototype.kpiStatus = 16;
$.ig.OlapMetadataTreeItemType.prototype.kpiTrend = 17;
$.ig.OlapMetadataTreeItemType.prototype.kpiWeight = 18;


$.ig.MeasureListLocation.prototype.rows = 0;
$.ig.MeasureListLocation.prototype.columns = 1;


$.ig.HeaderCellsLayoutOrientation.prototype.horizontal = 0;
$.ig.HeaderCellsLayoutOrientation.prototype.vertical = 1;


$.ig.MemberType.prototype.unknown = 0;
$.ig.MemberType.prototype.regular = 1;
$.ig.MemberType.prototype.all = 2;
$.ig.MemberType.prototype.measure = 3;
$.ig.MemberType.prototype.formula = 4;


$.ig.CardinalityType.prototype.one = 0;
$.ig.CardinalityType.prototype.many = 1;


$.ig.AggregatorType.prototype.unknown = 0;
$.ig.AggregatorType.prototype.sum = 1;
$.ig.AggregatorType.prototype.count = 2;
$.ig.AggregatorType.prototype.min = 3;
$.ig.AggregatorType.prototype.max = 4;
$.ig.AggregatorType.prototype.average = 5;
$.ig.AggregatorType.prototype.variance = 6;
$.ig.AggregatorType.prototype.std = 7;
$.ig.AggregatorType.prototype.distinctCount = 8;
$.ig.AggregatorType.prototype.none = 9;
$.ig.AggregatorType.prototype.averageOfChildren = 10;
$.ig.AggregatorType.prototype.firstNonEmpty = 13;
$.ig.AggregatorType.prototype.lastNonEmpty = 14;
$.ig.AggregatorType.prototype.byAccount = 15;
$.ig.AggregatorType.prototype.calculated = 127;


$.ig.HierarchyOrigin.prototype.userDefined = 1;
$.ig.HierarchyOrigin.prototype.systemEnabled = 2;
$.ig.HierarchyOrigin.prototype.systemInternal = 4;



$.ig.DimensionType.prototype.unknown = 0;
$.ig.DimensionType.prototype.time = 1;
$.ig.DimensionType.prototype.measure = 2;
$.ig.DimensionType.prototype.other = 3;
$.ig.DimensionType.prototype.quantitative = 5;
$.ig.DimensionType.prototype.accounts = 6;
$.ig.DimensionType.prototype.customers = 7;
$.ig.DimensionType.prototype.products = 8;
$.ig.DimensionType.prototype.scenario = 9;
$.ig.DimensionType.prototype.utility = 10;
$.ig.DimensionType.prototype.currency = 11;
$.ig.DimensionType.prototype.rates = 12;
$.ig.DimensionType.prototype.channel = 13;
$.ig.DimensionType.prototype.promotion = 14;
$.ig.DimensionType.prototype.organization = 15;
$.ig.DimensionType.prototype.billOfMaterials = 16;
$.ig.DimensionType.prototype.geography = 17;



$.ig.CubeType.prototype.cube = 0;
$.ig.CubeType.prototype.dimension = 1;
$.ig.CubeType.prototype.unknown = 2;


$.ig.AxisDefinitionParser.prototype.elementBegin = "[";
$.ig.AxisDefinitionParser.prototype.elementEnd = "]";
$.ig.AxisDefinitionParser.prototype.filterGroupBegin = "{";
$.ig.AxisDefinitionParser.prototype.filterGroupEnd = "}";
$.ig.AxisDefinitionParser.prototype.elementSeparator = ",";


$.ig.CoreOlapElementParser.prototype.elementBegin = "[";
$.ig.CoreOlapElementParser.prototype.elementEnd = "]";
$.ig.CoreOlapElementParser.prototype.elementSeparator = ".";
$.ig.CoreOlapElementParser.prototype.memberNameStart = "&";


$.ig.util.extCopy($.ig.TaskExtensions, [[[$.ig.Task, $.ig.Task$1], ['continueWithTask$1', 'continueWithTask$2']]]);
$.ig.util.extCopy($.ig.Queryable, [[[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.ArrayListCollection$1], ['asQueryable']]]);
$.ig.util.extCopy($.ig.Enumerable, [[[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.ArrayListCollection$1], ['where$1', 'where$11', 'select$2', 'selectMany$2', 'last$1', 'first$1', 'firstOrDefault$1', 'orderBy$2', 'orderByDescending$2', 'toList$1', 'concat$1', 'max', 'max$1', 'min', 'min$1', 'count$1', 'reverse$1', 'take$1', 'skip$1', 'any$1', 'contains$1', 'union$1', 'toArray$1', 'elementAt$1', 'sum', 'sum$1']], [[$.ig.SortedList$1, $.ig.IGrouping$2, $.ig.ArrayListCollection$1], ['ofType$1', 'cast$1']]]);

} (jQuery));


// Declare empty types
$.ig = $.ig || {};
(function ($) {
var $$t = {}
$.ig.$currDefinitions = $$t;
$.ig.util.bulkDefine(["IFlatDataAxisProvider:a", 
"OlapResultAxis:b", 
"Object:c", 
"Type:d", 
"Boolean:e", 
"ValueType:f", 
"Void:g", 
"String:h", 
"IComparable:i", 
"Number:j", 
"Number:k", 
"Single:l", 
"Number:m", 
"String:n", 
"Array:o", 
"RegExp:p", 
"RuntimeTypeHandle:q", 
"MethodInfo:r", 
"MethodBase:s", 
"MemberInfo:t", 
"ParameterInfo:u", 
"TypeCode:v", 
"Enum:w", 
"ConstructorInfo:x", 
"PositionResolver$2:y", 
"List$1:z", 
"IList$1:aa", 
"ICollection$1:ab", 
"IEnumerable$1:ac", 
"IEnumerable:ad", 
"IEnumerator:ae", 
"IEnumerator$1:af", 
"IArrayList:ag", 
"Array:ah", 
"ICollection:ai", 
"CompareCallback:aj", 
"MulticastDelegate:ak", 
"IntPtr:al", 
"IList:am", 
"IDisposable:an", 
"IArray:ao", 
"Script:ap", 
"Date:aq", 
"Date:ar", 
"Number:as", 
"Func$3:at", 
"Action$1:au", 
"PositionItemInfo$2:av", 
"Dictionary$2:aw", 
"IDictionary$2:ax", 
"IDictionary:ay", 
"Dictionary:az", 
"IEqualityComparer$1:a0", 
"KeyValuePair$2:a1", 
"NotImplementedException:a2", 
"Error:a3", 
"IHierarchicalPositionItem$2:a4", 
"IPositionItem$2:a5", 
"IPosition$2:a6", 
"Math:a7", 
"Number:a8", 
"Number:a9", 
"Number:ba", 
"Number:bb", 
"Number:bc", 
"Number:bd", 
"Number:be", 
"Enumerable:bf", 
"Func$2:bg", 
"IOrderedEnumerable$1:bh", 
"SortedList$1:bi", 
"ArgumentNullException:bj", 
"EventHandler$1:bk", 
"Delegate:bl", 
"ListSortDirection:bm", 
"Nullable$1:bn", 
"OlapResultTuple:bo", 
"ReadOnlyCollection$1:bp", 
"OlapResultAxisMember:bq", 
"Task$1:br", 
"Task:bs", 
"JQueryPromise:bt", 
"Action:bu", 
"AggregateException:bv", 
"TaskStatus:bw", 
"TaskCompletionSource$1:bx", 
"JQueryDeferred:by", 
"JQuery:bz", 
"JQueryObject:b0", 
"Element:b1", 
"ElementAttributeCollection:b2", 
"ElementCollection:b3", 
"WebStyle:b4", 
"ElementNodeType:b5", 
"Document:b6", 
"EventListener:b7", 
"IElementEventHandler:b8", 
"ElementEventHandler:b9", 
"ElementAttribute:ca", 
"JQueryPosition:cb", 
"JQueryCallback:cc", 
"JQueryEvent:cd", 
"JQueryUICallback:ce", 
"FlatDataAxisProvider:cf", 
"FlatDataProvider:cg", 
"IFlatDataProvider:ch", 
"IOlapDiscoverDataProvider:ci", 
"TableMetadata:cj", 
"RowMetadata:ck", 
"DataSourceMetadata:cl", 
"CubeMetadata:cm", 
"MeasuresDimensionMetadata:cn", 
"ArrayListCollection$1:co", 
"INotifyCollectionChanged:cp", 
"NotifyCollectionChangedEventHandler:cq", 
"NotifyCollectionChangedEventArgs:cr", 
"EventArgs:cs", 
"NotifyCollectionChangedAction:ct", 
"KeyValueItem:cu", 
"Level:cv", 
"ICoreOlapElement:cw", 
"InvalidOperationException:cx", 
"Hierarchy:cy", 
"HierarchyOrigin:cz", 
"Member:c0", 
"MemberType:c1", 
"TaskFactory:c2", 
"OlapResult:c3", 
"AxisElement:c4", 
"DataMemberMetadata:c5", 
"Measure:c6", 
"AggregatorType:c7", 
"CellMetadata:c8", 
"OlapResultCell:c9", 
"KeyListPair$1:da", 
"Cube:db", 
"CubeType:dc", 
"MeasureMetadata:dd", 
"Dimension:de", 
"DimensionType:df", 
"DimensionMetadata:dg", 
"HierarchyMetadata:dh", 
"LevelMetadata:di", 
"FlatDataAxisProviderHelper:dj", 
"CubeMetaItemsCache:dk", 
"MeasureGroupMetaItemsCache:dl", 
"MeasureGroupDimension:dm", 
"CardinalityType:dn", 
"Kpi:dp", 
"Tuple$2:dq", 
"KpiMeasure:dr", 
"MeasureList:ds", 
"FlatDataPartialAxisProvider:dt", 
"FlatDataSourceImpl:du", 
"OlapDataSource:dv", 
"IOlapDataSource:dw", 
"OlapMetadataTreeItem:dx", 
"OlapMetadataTreeItemType:dy", 
"MeasureListLocation:dz", 
"MeasureGroup:d0", 
"DataSourceBaseOptions:d1", 
"IOlapDataProviderFactory:d2", 
"OlapResultView:d3", 
"NotSupportedException:d4", 
"PositionInfo:d5", 
"TaskExtensions:d6", 
"AxisDefinitionParser:d7", 
"Debug:d8", 
"MetaTreeHelper:d9", 
"HierarchyItemPosition:ea", 
"KpiDimension:eb", 
"FlatDataSourceOptions:ec", 
"IFlatDataProviderFactory:ed", 
"DefaultFlatDataProviderFactory:ee", 
"ResultViewHelper:ef", 
"CoreOlapElementParser:eg", 
"ArgumentException:eh", 
"OlapFlatDataSource:ei", 
"DataSourceBase:ej", 
"jQueryUtils:ek", 
"AbstractEnumerable:em", 
"Func$1:en", 
"AbstractEnumerator:eo", 
"GenericEnumerable$1:ep", 
"GenericEnumerator$1:eq"]);

$.ig.util.defType('IFlatDataAxisProvider', 'Object', {
	$type: new $.ig.Type('IFlatDataAxisProvider', null)
}, true);

$.ig.util.defType('FlatDataAxisProvider', 'Object', {
	__axisElements: null
	, 
	__providerHelper: null
	, 
	__cubeCache: null
	, 
	init: function (dataProvider, axisElements, cubeCache) {


		var $self = this;
		this.__resetAxisElements = null;
		this.__prevAxisState = null;
		this.__resetAxis = false;
		this.__resetMetadata = false;

		$.ig.Object.prototype.init.call(this);
			this.__cubeCache = cubeCache;
			this.dataProvider(dataProvider);
			this.__axisElements = axisElements.select$2($.ig.ICoreOlapElement.prototype.$type, $.ig.ICoreOlapElement.prototype.$type, function (i) { return i; }).toList$1($.ig.ICoreOlapElement.prototype.$type);
			this.__providerHelper = new $.ig.FlatDataAxisProviderHelper(dataProvider, axisElements.count(), cubeCache);
	}

	, 
	_dataProvider: null,
	dataProvider: function (value) {
		if (arguments.length === 1) {
			this._dataProvider = value;
			return value;
		} else {
			return this._dataProvider;
		}
	}

	, 
	_axis: null,
	axis: function (value) {
		if (arguments.length === 1) {
			this._axis = value;
			return value;
		} else {
			return this._axis;
		}
	}

	, 
	positionResolver: function () {

			return this.__providerHelper.positionResolver();
	}
	, 
	__resetAxisElements: null
	, 
	__prevAxisState: null
	, 
	__resetAxis: false
	, 
	__resetMetadata: false

	, 
	resetAxis: function (axisElements) {
		var $self = this;
		if ($self.axis() != null) {
			$self.__prevAxisState = $self.axis();
			$self.__resetAxisElements = axisElements.select$2($.ig.ICoreOlapElement.prototype.$type, $.ig.ICoreOlapElement.prototype.$type, function (i) { return i; }).toList$1($.ig.ICoreOlapElement.prototype.$type);
			$self.__resetAxis = true;

		} else {
			$self.__providerHelper = new $.ig.FlatDataAxisProviderHelper($self.dataProvider(), axisElements.count(), $self.__cubeCache);
			$self.__axisElements = axisElements;
		}

	}

	, 
	resetAxisMetadata: function () {
		if (this.axis() != null) {
			this.__resetMetadata = true;
		}

	}

	, 
	resetAxisImpl: function (axisName) {
		var $self = this;
		$self.__resetAxis = false;
		var axisElements = $self.__resetAxisElements;
		var prevAxisState = $self.__prevAxisState;
		var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResultAxis.prototype.$type, 0);
		var stateElements = new $.ig.List$1(String, 0);
		for (var i = 0; i < $self.__axisElements.count(); i++) {
			var coreOlapElement = $self.__axisElements.item(i);
			if ($.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement) !== null) {
				stateElements.add($self.dataProvider().sourceMetadata().cubeMetadata().measuresDimensionMetadata().name());
				continue;
			}

			stateElements.add(coreOlapElement.uniqueName());
		}

		$self.__axisElements = axisElements;
		var axisElementNames = new $.ig.List$1(String, 0);
		var axisElementLevels = new $.ig.List$1($.ig.KeyValuePair$2.prototype.$type.specialize(String, $.ig.Number.prototype.$type), 0);
		for (var i1 = 0; i1 < $self.__axisElements.count(); i1++) {
			var coreOlapElement1 = $self.__axisElements.item(i1);
			if ($.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement1) !== null) {
				axisElementNames.add($self.dataProvider().sourceMetadata().cubeMetadata().measuresDimensionMetadata().name());
				continue;
			}

			axisElementNames.add(coreOlapElement1.uniqueName());
			axisElementLevels.add(new $.ig.KeyValuePair$2(String, $.ig.Number.prototype.$type, 1, coreOlapElement1.uniqueName(), 0));
		}

		var coreElementsToLoad = new $.ig.List$1($.ig.KeyValuePair$2.prototype.$type.specialize(String, $.ig.Number.prototype.$type), 0);
		if (stateElements.count() > 0) {
			var validToIndex = -1;
			for (var i2 = 0; i2 < axisElementNames.count(); i2++) {
				if (i2 == stateElements.count() || stateElements.item(i2) != axisElementNames.item(i2)) {
					break;
				}

				validToIndex = i2;
			}

			if (validToIndex < axisElementLevels.count() - 1) {
				for (var i3 = validToIndex + 1; i3 < axisElementLevels.count(); i3++) {
					coreElementsToLoad.add(axisElementLevels.item(i3));
				}


			} else {
				coreElementsToLoad = axisElementLevels;
			}

			var tuplePrototype = new Array($self.__axisElements.count());
			var tuples = new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 0);
			$self.__providerHelper.getLevelMembers2(coreElementsToLoad).continueWith1(function (t) { return $self.resetAxisState(validToIndex, axisElements, tuplePrototype, t.result(), tuples, prevAxisState.name(), tcs, true); });
			return tcs.task();
		}

		return $self.generateAxis(axisName);
	}

	, 
	generateAxis: function (axisName) {
		var $self = this;
		if ($self.__resetMetadata || $self.__resetAxis) {
			var axisTask = null;
			if ($self.__resetMetadata) {
				axisTask = $self.resetAxisMetadataImpl(axisName);
			}

			if ($self.__resetAxis) {
				axisTask = $self.resetAxisImpl(axisName);
			}

			return axisTask;
		}

		var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResultAxis.prototype.$type, 0);
		if ($self.axis() != null) {
			tcs.setResult($self.axis());
			return tcs.task();
		}

		var tuplePrototype = new Array($self.__axisElements.count());
		var axisElementNames = new $.ig.List$1(String, 0);
		var tuples = new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 0);
		var axisElementLevels = new $.ig.List$1($.ig.KeyValuePair$2.prototype.$type.specialize(String, $.ig.Number.prototype.$type), 0);
		var axisElements = $self.__axisElements;
		for (var i = 0; i < $self.__axisElements.count(); i++) {
			var coreOlapElement = $self.__axisElements.item(i);
			if ($.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement) !== null) {
				axisElementNames.add($self.dataProvider().sourceMetadata().cubeMetadata().measuresDimensionMetadata().name());
				continue;
			}

			axisElementNames.add(coreOlapElement.uniqueName());
			axisElementLevels.add(new $.ig.KeyValuePair$2(String, $.ig.Number.prototype.$type, 1, coreOlapElement.uniqueName(), 0));
		}

		var coreElementsToLoad = new $.ig.List$1($.ig.KeyValuePair$2.prototype.$type.specialize(String, $.ig.Number.prototype.$type), 0);
		var validRowsMetadata = $self.dataProvider().tableMetadata().rowsMetadataList();
		coreElementsToLoad = axisElementLevels;
		var getLevelMembersTask = $self.__providerHelper.getLevelMembers2(coreElementsToLoad);
		getLevelMembersTask.continueWith1(function (t) {
			$self.__providerHelper.fillAxis1(axisElements, 0, tuplePrototype, t.result(), validRowsMetadata, null, tuples);
			$self.axis((function () { var $ret = new $.ig.OlapResultAxis(tuples, axisElements.count());
			$ret.name(axisName); return $ret;}()));
			tcs.setResult($self.axis());
		});
		return tcs.task();
	}

	, 
	resetAxisState: function (validToIndex, axisElements, tuplePrototype, levelMembers, tuples, axisName, tcs, resetHelper) {
		var $self = this;
		var positionResolver = $self.positionResolver();
		if (resetHelper) {
			$self.__providerHelper = new $.ig.FlatDataAxisProviderHelper($self.dataProvider(), axisElements.count(), $self.__cubeCache);
		}

		if (validToIndex > -1 && positionResolver.rootPositionInfo().count() > 0) {
			$self.__providerHelper.fillAxis2(axisElements, validToIndex, positionResolver.rootPositionInfo(), tuplePrototype, levelMembers, tuples);

		} else {
			var validRowsMetadata = $self.dataProvider().tableMetadata().rowsMetadataList().where$1($.ig.RowMetadata.prototype.$type, function (r) { return !r.isExcluded(); }).toList$1($.ig.RowMetadata.prototype.$type);
			$self.__providerHelper.fillAxis1(axisElements, 0, tuplePrototype, levelMembers, validRowsMetadata, null, tuples);
		}

		$self.axis((function () { var $ret = new $.ig.OlapResultAxis(tuples, axisElements.count());
		$ret.name(axisName); return $ret;}()));
		tcs.setResult($self.axis());
	}

	, 
	addTuples: function (tupleMetadataItems) {
		if (this.axis() == null) {
			throw new $.ig.InvalidOperationException(0);
		}

		var en = tupleMetadataItems.getEnumerator();
		while (en.moveNext()) {
			var kvp = en.current();
			this.__providerHelper.setTupleRowsMetadata(kvp.key(), kvp.value());
		}

	}

	, 
	extendWith: function (partialAxisProvider) {
		var tupleMetadataItems = new $.ig.List$1($.ig.KeyValuePair$2.prototype.$type.specialize($.ig.OlapResultTuple.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.RowMetadata.prototype.$type)), 0);
		var en = partialAxisProvider.getPositionsMetadata().getEnumerator();
		while (en.moveNext()) {
			var tuple1 = en.current();
			var metadataItems = partialAxisProvider.getTupleRowsMetadata(tuple1);
			tupleMetadataItems.add(new $.ig.KeyValuePair$2($.ig.OlapResultTuple.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.RowMetadata.prototype.$type), 1, tuple1, metadataItems));
		}

		this.addTuples(tupleMetadataItems);
	}

	, 
	resetAxisMetadataImpl: function (axisName) {
		var $self = this;
		$self.__resetMetadata = false;
		var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResultAxis.prototype.$type, 0);
		var tupleMetadataItems = new $.ig.List$1($.ig.KeyValuePair$2.prototype.$type.specialize($.ig.OlapResultTuple.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.RowMetadata.prototype.$type)), 0);
		var tuplesList = new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 0);
		for (var i = 0; i < $self.__providerHelper.positionResolver().positions().count(); i++) {
			var tuple = $self.__providerHelper.positionResolver().positions().__inner[i];
			var metadataItems = $self.dataProvider().getRowsMetadata(tuple.members().toArray$1($.ig.OlapResultAxisMember.prototype.$type), tuple.itemsCount()).where$1($.ig.RowMetadata.prototype.$type, function (rm) { return !rm.isExcluded(); }).toList$1($.ig.RowMetadata.prototype.$type);
			if (metadataItems.count() > 0) {
				tuplesList.add(tuple);
			}

			tupleMetadataItems.add(new $.ig.KeyValuePair$2($.ig.OlapResultTuple.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.RowMetadata.prototype.$type), 1, tuple, metadataItems));
		}

		if (tupleMetadataItems.count() > 0) {
			$self.addTuples(tupleMetadataItems);
		}

		var tuplePrototype = new Array($self.__axisElements.count());
		var coreElementsToLoad = new $.ig.List$1($.ig.KeyValuePair$2.prototype.$type.specialize(String, $.ig.Number.prototype.$type), 0);
		for (var i1 = 0; i1 < $self.__axisElements.count(); i1++) {
			var coreOlapElement = $self.__axisElements.item(i1);
			if ($.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement) !== null) {
				continue;
			}

			coreElementsToLoad.add(new $.ig.KeyValuePair$2(String, $.ig.Number.prototype.$type, 1, coreOlapElement.uniqueName(), 0));
		}

		$self.__providerHelper.getLevelMembers2(coreElementsToLoad).continueWith1(function (t) { return $self.resetAxisState($self.__axisElements.count() - 1, $self.__axisElements, tuplePrototype, t.result(), new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 0), axisName, tcs, false); });
		return tcs.task();
	}

	, 
	getTupleRowsMetadata: function (tuple) {
		return this.__providerHelper.getTupleRowsMetadata(tuple);
	}
	, 
	$type: new $.ig.Type('FlatDataAxisProvider', $.ig.Object.prototype.$type, [$.ig.IFlatDataAxisProvider.prototype.$type])
}, true);

$.ig.util.defType('FlatDataAxisProviderHelper', 'Object', {
	__cubeCache: null
	, 
	__tupleMetadataItems: null

	, 
	_positions: null,
	positions: function (value) {
		if (arguments.length === 1) {
			this._positions = value;
			return value;
		} else {
			return this._positions;
		}
	}
	, 
	init: function (dataProvider, axisTupleSize, cubeCache) {



		$.ig.Object.prototype.init.call(this);
			this.__cubeCache = cubeCache;
			this.dataProvider(dataProvider);
			this.__tupleMetadataItems = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.IList$1.prototype.$type.specialize($.ig.RowMetadata.prototype.$type), 0);
			this.positionResolver(new $.ig.PositionResolver$2(String, $.ig.Object.prototype.$type, new $.ig.List$1($.ig.IPosition$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), 0), axisTupleSize));
			this.positions(this.positionResolver().positions());
	}

	, 
	_dataProvider: null,
	dataProvider: function (value) {
		if (arguments.length === 1) {
			this._dataProvider = value;
			return value;
		} else {
			return this._dataProvider;
		}
	}

	, 
	_positionResolver: null,
	positionResolver: function (value) {
		if (arguments.length === 1) {
			this._positionResolver = value;
			return value;
		} else {
			return this._positionResolver;
		}
	}

	, 
	getTupleRowsMetadata: function (tuple) {
		var $self = this;
		var rowsMetadata = null;
		var tupleIndex = $self.positionResolver().getPositionIndex(tuple);
		if (tupleIndex > -1) {
			(function () { var $ret = $self.__tupleMetadataItems.tryGetValue(tupleIndex, rowsMetadata); rowsMetadata = $ret.value; return $ret.ret; }());
		}

		return rowsMetadata;
	}

	, 
	setTupleRowsMetadata: function (tuple, metadataItems) {
		var tupleIndex = this.positionResolver().getPositionIndex(tuple);
		if (tupleIndex == -1) {
			this.__tupleMetadataItems.add(this.positions().count(), metadataItems);
			this.positions().add(tuple);
			return true;
		}

		this.__tupleMetadataItems.item(tupleIndex, metadataItems);
		return false;
	}

	, 
	fillAxis2: function (axisElements, validToIndex, hostPositionItem, tuplePrototype, rootLevelMembers, tuples) {
		var $self = this;
		var depthMin = hostPositionItem.positionItemDepthMin();
		var en = hostPositionItem.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.positionItemDepth() == depthMin; }).getEnumerator();
		while (en.moveNext()) {
			var positionItemInfo = en.current();
			if (positionItemInfo.positionItemIndex() == validToIndex || positionItemInfo.count() == 0) {
				if (positionItemInfo.count() == 0) {
					validToIndex = positionItemInfo.positionItemIndex();
				}

				$self.fillAxis(hostPositionItem, positionItemInfo, tuplePrototype, axisElements, validToIndex, rootLevelMembers, tuples);

			} else {
				var originalAxisMember = positionItemInfo.positionItem();
				var axisMember = originalAxisMember.clone();
				var memberTuplePrototype = new Array(axisElements.count());
				$.ig.Array.prototype.copy(tuplePrototype, 0, memberTuplePrototype, 0, axisElements.count());
				memberTuplePrototype[positionItemInfo.positionItemIndex()] = axisMember;
				$self.fillAxis2(axisElements, validToIndex, positionItemInfo, memberTuplePrototype, rootLevelMembers, tuples);
			}

		}

	}

	, 
	fillAxis: function (hostPositionItem, positionItemInfo, tuplePrototype, axisElements, validToIndex, rootLevelMembers, tuples) {
		var $self = this;
		var originalAxisMember = positionItemInfo.positionItem();
		var axisMember = originalAxisMember.clone();
		var memberTuplePrototype = new Array(axisElements.count());
		$.ig.Array.prototype.copy(tuplePrototype, 0, memberTuplePrototype, 0, axisElements.count());
		memberTuplePrototype[positionItemInfo.positionItemIndex()] = axisMember;
		var tupleRowsMetadata = $self.dataProvider().getRowsMetadata(memberTuplePrototype, positionItemInfo.positionItemIndex() + 1).toList$1($.ig.RowMetadata.prototype.$type);
		if (tupleRowsMetadata.count() > 0) {
			if (validToIndex < axisElements.count() - 1) {
				$self.fillAxis1(axisElements, validToIndex + 1, memberTuplePrototype, rootLevelMembers, tupleRowsMetadata, null, tuples);

			} else {
				var tuple = new $.ig.OlapResultTuple(memberTuplePrototype);
				var selectedItems = tupleRowsMetadata.where$1($.ig.RowMetadata.prototype.$type, function (rm) { return !rm.isExcluded(); }).toList$1($.ig.RowMetadata.prototype.$type);
				var tupleIndex = $self.positionResolver().getPositionIndex(tuple);
				if (tupleIndex == -1) {
					$self.__tupleMetadataItems.add($self.positions().count(), selectedItems);
					$self.positions().add(tuple);

				} else {
					$self.positions().item(tupleIndex, tuple);
				}

				for (var i = 0; i < memberTuplePrototype.length; i++) {
					var member = memberTuplePrototype[i];
					member.position(tuple);
				}

				if (selectedItems.count() > 0) {
					tuples.add(tuple);
				}

			}

			if (positionItemInfo.isExpanded()) {
				var en = hostPositionItem.values().where$1($.ig.PositionItemInfo$2.prototype.$type.specialize(String, $.ig.Object.prototype.$type), function (pi) { return pi.parentKey() == positionItemInfo.key(); }).getEnumerator();
				while (en.moveNext()) {
					var childItemInfo = en.current();
					$self.fillAxis(hostPositionItem, childItemInfo, tuplePrototype, axisElements, validToIndex, rootLevelMembers, tuples);
				}

			}

		}

	}

	, 
	fillAxis1: function (axisElements, elementIndex, tuplePrototype, rootLevelMembers, rowsMetadata, parentUniqueName, tuples) {
		var $self = this;
		var coreOlapElement = axisElements.item(elementIndex);
		if ($.ig.util.cast($.ig.Hierarchy.prototype.$type, coreOlapElement) !== null) {
			var levelMembers = rootLevelMembers.item(coreOlapElement.uniqueName());
			if (parentUniqueName != null) {
				levelMembers = levelMembers.where$1($.ig.Member.prototype.$type, function (m) { return m.parentUniqueName() == parentUniqueName; });
			}

			var en = levelMembers.getEnumerator();
			while (en.moveNext()) {
				var levelMember = en.current();
				var memberId;
				(function () { var $ret = $self.dataProvider().tryGetMemberId(levelMember.uniqueName(), memberId); memberId = $ret.memberId; return $ret.ret; }());
				var metadataList = rowsMetadata.where$1($.ig.RowMetadata.prototype.$type, function (drm) { return drm.getMemberId(levelMember.levelUniqueName()) == memberId; }).toList$1($.ig.RowMetadata.prototype.$type);
				if (metadataList.count() > 0) {
					var memberTuplePrototype = new Array(axisElements.count());
					$.ig.Array.prototype.copy(tuplePrototype, 0, memberTuplePrototype, 0, axisElements.count());
					var axisMember = new $.ig.OlapResultAxisMember();
					axisMember.caption(levelMember.caption());
					axisMember.hierarchyUniqueName(levelMember.hierarchyUniqueName());
					axisMember.levelNumber(levelMember.levelDepth());
					axisMember.levelUniqueName(levelMember.levelUniqueName());
					axisMember.uniqueName(levelMember.uniqueName());
					axisMember.displayInfo(levelMember.childrenCardinality());
					axisMember.properties().add("PARENT_UNIQUE_NAME", levelMember.parentUniqueName());
					axisMember.properties().add("memberId", memberId.toString());
					memberTuplePrototype[elementIndex] = axisMember;
					if (elementIndex == axisElements.count() - 1) {
						var selectedItems = metadataList.where$1($.ig.RowMetadata.prototype.$type, function (rm) { return !rm.isExcluded(); }).toList$1($.ig.RowMetadata.prototype.$type);
						var tuple = new $.ig.OlapResultTuple(memberTuplePrototype);
						var tupleIndex = $self.positionResolver().getPositionIndex(tuple);
						if (tupleIndex == -1) {
							$self.__tupleMetadataItems.add($self.positions().count(), selectedItems);
							$self.positions().add(tuple);

						} else {
							$self.positions().item(tupleIndex, tuple);
						}

						for (var i = 0; i < memberTuplePrototype.length; i++) {
							var member = memberTuplePrototype[i];
							member.position(tuple);
						}

						if (selectedItems.count() > 0) {
							tuples.add(tuple);
						}


					} else {
						$self.fillAxis1(axisElements, elementIndex + 1, memberTuplePrototype, rootLevelMembers, metadataList, null, tuples);
					}

				}

			}


		} else if ($.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement) !== null) {
			var measureList = coreOlapElement;
			var en1 = measureList.measures().getEnumerator();
			while (en1.moveNext()) {
				var measure = en1.current();
				var memberTuplePrototype1 = new Array(axisElements.count());
				$.ig.Array.prototype.copy(tuplePrototype, 0, memberTuplePrototype1, 0, axisElements.count());
				var axisMember1 = new $.ig.OlapResultAxisMember();
				axisMember1.caption(measure.caption());
				var hierarchyUniqueName = $self.ensureNamePattern($self.dataProvider().sourceMetadata().cubeMetadata().measuresDimensionMetadata().name());
				axisMember1.hierarchyUniqueName(hierarchyUniqueName);
				axisMember1.levelNumber(0);
				axisMember1.uniqueName(measure.uniqueName());
				memberTuplePrototype1[elementIndex] = axisMember1;
				if (elementIndex == axisElements.count() - 1) {
					var tuple1 = new $.ig.OlapResultTuple(memberTuplePrototype1);
					var selectedItems1 = rowsMetadata.where$1($.ig.RowMetadata.prototype.$type, function (rm) { return !rm.isExcluded(); }).toList$1($.ig.RowMetadata.prototype.$type);
					var tupleIndex1 = $self.positionResolver().getPositionIndex(tuple1);
					if (tupleIndex1 == -1) {
						$self.__tupleMetadataItems.add($self.positions().count(), selectedItems1);
						$self.positions().add(tuple1);

					} else {
						$self.positions().item(tupleIndex1, tuple1);
					}

					for (var i1 = 0; i1 < memberTuplePrototype1.length; i1++) {
						var member1 = memberTuplePrototype1[i1];
						member1.position(tuple1);
					}

					if (selectedItems1.count() > 0) {
						tuples.add(tuple1);
					}


				} else {
					$self.fillAxis1(axisElements, elementIndex + 1, memberTuplePrototype1, rootLevelMembers, rowsMetadata, null, tuples);
				}

			}

		}


	}

	, 
	getLevelMembers2: function (axisElements) {
		var $self = this;
		var cubeCache = $self.__cubeCache;
		if (axisElements.count() == 0) {
			var tcs = new $.ig.TaskCompletionSource$1($.ig.IDictionary$2.prototype.$type.specialize(String, $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Member.prototype.$type)), 0);
			tcs.setResult(new $.ig.Dictionary$2(String, $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Member.prototype.$type), 0));
			return tcs.task();
		}

		var levels = new $.ig.Dictionary$2(String, $.ig.Level.prototype.$type, 0);
		for (var i = 0; i < axisElements.count(); i++) {
			var hierarchyName = axisElements.item(i).key();
			var levelDepth = axisElements.item(i).value();
			var level = cubeCache.levelItems().where$1($.ig.Level.prototype.$type, function (e) { return e.hierarchyUniqueName() == hierarchyName && e.depth() == levelDepth; }).firstOrDefault$1($.ig.Level.prototype.$type);
			if (!levels.containsKey(hierarchyName)) {
				levels.add(hierarchyName, level);
			}

		}

		return $self.getLevelMembers1(levels);
	}

	, 
	ensureNamePattern: function (name) {
		if (name.substr(0, 1) != "[") {
			name = "[" + name;
		}

		if (name.substr(name.length - 1, 1) != "]") {
			name += "]";
		}

		return name;
	}

	, 
	getLevelMembers1: function (hierarchyLevels) {
		var $self = this;
		var cubeCache = $self.__cubeCache;
		var existingMembers = new $.ig.Dictionary$2(String, $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Member.prototype.$type), 0);
		var hierarchyNames = new $.ig.List$1(String, 0);
		var en = hierarchyLevels.getEnumerator();
		while (en.moveNext()) {
			var hierarchyRootLevel = en.current();
			var levelName = hierarchyRootLevel.value().uniqueName();
			var levelMembers;
			if (cubeCache.isLevelLoaded(levelName) && (function () { var $ret = cubeCache.tryGetMembersForLevel(levelName, levelMembers); levelMembers = $ret.members; return $ret.ret; }())) {
				existingMembers.add(hierarchyRootLevel.key(), levelMembers);

			} else {
				hierarchyNames.add(hierarchyRootLevel.key());
			}

		}

		if (hierarchyNames.count() == 0) {
			var tcs = new $.ig.TaskCompletionSource$1($.ig.IDictionary$2.prototype.$type.specialize(String, $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Member.prototype.$type)), 0);
			tcs.setResult(existingMembers);
			return tcs.task();
		}

		var tasks = new Array(hierarchyNames.count());
		var index = 0;
		var en1 = hierarchyNames.getEnumerator();
		while (en1.moveNext()) {
			var hierarchyName = en1.current();
			var restrictions = new $.ig.List$1($.ig.KeyValueItem.prototype.$type, 0);
			restrictions.add((function () { var $ret = new $.ig.KeyValueItem();
			$ret.key("LEVEL_UNIQUE_NAME");
			$ret.value(hierarchyLevels.item(hierarchyName).uniqueName()); return $ret;}()));
			tasks[index] = $self.dataProvider().discoverMembersAsync(null, restrictions);
			index++;
		}

		var taskFactory = new $.ig.TaskFactory();
		var task = taskFactory.continueWhenAll$1($.ig.IDictionary$2.prototype.$type.specialize(String, $.ig.IEnumerable$1.prototype.$type.specialize($.ig.Member.prototype.$type)), tasks, function (t) { return $self.getLevelMembers(t, hierarchyNames, existingMembers); });
		return task;
	}

	, 
	getLevelMembers: function (tasks, hierarchyNames, existingMembers) {
		for (var i = 0; i < hierarchyNames.count(); i++) {
			var hierarchyName = hierarchyNames.__inner[i];
			if (!existingMembers.containsKey(hierarchyName)) {
				var members = (tasks[i]).result();
				var en = members.getEnumerator();
				while (en.moveNext()) {
					var member = en.current();
					this.__cubeCache.addMember(member);
				}

				existingMembers.add(hierarchyName, members);
			}

		}

		return existingMembers;
	}

	, 
	getHierarchyLevels: function (tasks, levelIndexes) {
		var $self = this;
		var rootLevels = new $.ig.Dictionary$2(String, $.ig.Level.prototype.$type, 0);
		for (var i = 0; i < levelIndexes.count(); i++) {
			var task = tasks[i];
			if (task.exception() != null || task.isCanceled()) {
				return null;
			}

			var levelIndex = levelIndexes.item(i);
			var level = task.result().where$1($.ig.Level.prototype.$type, function (l) { return l.depth() == levelIndex; }).firstOrDefault$1($.ig.Level.prototype.$type);
			if (level != null && !rootLevels.containsKey(level.hierarchyUniqueName())) {
				rootLevels.add(level.hierarchyUniqueName(), level);
			}

		}

		return rootLevels;
	}
	, 
	$type: new $.ig.Type('FlatDataAxisProviderHelper', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('FlatDataPartialAxisProvider', 'Object', {
	__providerHelper: null
	, 
	__axisElements: null
	, 
	__axisMember: null
	, 
	init: function (dataProvider, axisElements, axisMember, cubeCache) {



		$.ig.Object.prototype.init.call(this);
			this.dataProvider(dataProvider);
			this.__providerHelper = new $.ig.FlatDataAxisProviderHelper(dataProvider, axisElements.count(), cubeCache);
			this.__axisMember = axisMember;
			this.__axisElements = axisElements;
	}

	, 
	_dataProvider: null,
	dataProvider: function (value) {
		if (arguments.length === 1) {
			this._dataProvider = value;
			return value;
		} else {
			return this._dataProvider;
		}
	}

	, 
	_axis: null,
	axis: function (value) {
		if (arguments.length === 1) {
			this._axis = value;
			return value;
		} else {
			return this._axis;
		}
	}

	, 
	generateAxis: function (axisName) {
		var $self = this;
		var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResultAxis.prototype.$type, 0);
		if ($self.axis() != null) {
			tcs.setResult($self.axis());
			return tcs.task();
		}

		var tuplePrototype = new Array($self.__axisMember.position().itemsCount());
		var tuples = new $.ig.List$1($.ig.OlapResultTuple.prototype.$type, 0);
		var toIndex = $self.__axisMember.position().indexOf($self.__axisMember);
		var tuple = $self.__axisMember.position();
		var coreElementsToLoad = new $.ig.List$1($.ig.KeyValuePair$2.prototype.$type.specialize(String, $.ig.Number.prototype.$type), 0);
		for (var i = 0; i < $self.__axisMember.position().itemsCount(); i++) {
			if (i < toIndex) {
				tuplePrototype[i] = ($self.__axisMember.position()).members().item(i).clone();

			} else if (i == toIndex) {
				if ($.ig.util.cast($.ig.MeasureList.prototype.$type, $self.__axisElements.item(i)) !== null) {
					continue;
				}

				var axisMember = tuple.members().item(i);
				coreElementsToLoad.add(new $.ig.KeyValuePair$2(String, $.ig.Number.prototype.$type, 1, axisMember.hierarchyUniqueName(), axisMember.depth() + 1));

			} else {
				if ($.ig.util.cast($.ig.MeasureList.prototype.$type, $self.__axisElements.item(i)) !== null) {
					continue;
				}

				var axisMember1 = tuple.members().item(i);
				coreElementsToLoad.add(new $.ig.KeyValuePair$2(String, $.ig.Number.prototype.$type, 1, axisMember1.hierarchyUniqueName(), axisMember1.depth()));
			}


		}

		$self.__providerHelper.getLevelMembers2(coreElementsToLoad).continueWith1(function (t) {
			var validRowsMetadata = $self.dataProvider().getRowsMetadata(tuple.members().toArray$1($.ig.OlapResultAxisMember.prototype.$type), toIndex + 1).toList$1($.ig.RowMetadata.prototype.$type);
			$self.__providerHelper.fillAxis1($self.__axisElements, toIndex, tuplePrototype, t.result(), validRowsMetadata, $self.__axisMember.uniqueName(), tuples);
			$self.axis((function () { var $ret = new $.ig.OlapResultAxis(tuples, tuple.itemsCount());
			$ret.name(axisName); return $ret;}()));
			tcs.setResult($self.axis());
		});
		return tcs.task();
	}

	, 
	getTupleRowsMetadata: function (tuple) {
		return this.__providerHelper.getTupleRowsMetadata(tuple);
	}

	, 
	getPositionsMetadata: function () {
		return this.__providerHelper.positions();
	}
	, 
	$type: new $.ig.Type('FlatDataPartialAxisProvider', $.ig.Object.prototype.$type, [$.ig.IFlatDataAxisProvider.prototype.$type])
}, true);

$.ig.util.defType('IFlatDataProvider', 'Object', {
	$type: new $.ig.Type('IFlatDataProvider', null, [$.ig.IOlapDiscoverDataProvider.prototype.$type])
}, true);

$.ig.util.defType('FlatDataProvider', 'Object', {
	__cubes: null
	, 
	__dimensions: null
	, 
	__hierarchies: null
	, 
	__levels: null
	, 
	__hierarchyLevels: null
	, 
	__levelMemberProviders: null
	, 
	__memberIds: null
	, 
	__memberMetadata: null
	, 
	__selectedMemberMetadata: null
	, 
	__measures: null
	, 
	__measuresAggregators: null
	, 
	__levelMembers: null

	, 
	_tableMetadata: null,
	tableMetadata: function (value) {
		if (arguments.length === 1) {
			this._tableMetadata = value;
			return value;
		} else {
			return this._tableMetadata;
		}
	}
	, 
	init: function (itemsSource, sourceMetadata) {


		var $self = this;
		this.__memberIds = new $.ig.Dictionary$2(String, $.ig.Number.prototype.$type, 0);
		this.__memberMetadata = new $.ig.Dictionary$2(String, $.ig.DataMemberMetadata.prototype.$type, 0);
		this.__selectedMemberMetadata = new $.ig.Dictionary$2(String, $.ig.DataMemberMetadata.prototype.$type, 0);
		this.__excludedMembers = new $.ig.Dictionary$2(String, $.ig.IDictionary$2.prototype.$type.specialize(String, $.ig.DataMemberMetadata.prototype.$type), 0);

		$.ig.Object.prototype.init.call(this);
			this.itemsSource(itemsSource);
			this.sourceMetadata(sourceMetadata);
			this.tableMetadata(new $.ig.TableMetadata(itemsSource));
			if (sourceMetadata.cubeMetadata() != null) {
				if (sourceMetadata.cubeMetadata().measuresDimensionMetadata() == null) {
					sourceMetadata.cubeMetadata().measuresDimensionMetadata((function () { var $ret = new $.ig.MeasuresDimensionMetadata();
					$ret.caption("Measures");
					$ret.name("Measures"); return $ret;}()));

				} else {
					if (String.isNullOrEmpty(sourceMetadata.cubeMetadata().measuresDimensionMetadata().caption())) {
						sourceMetadata.cubeMetadata().measuresDimensionMetadata().caption("Measures");
					}

					if (String.isNullOrEmpty(sourceMetadata.cubeMetadata().measuresDimensionMetadata().name())) {
						sourceMetadata.cubeMetadata().measuresDimensionMetadata().name("Measures");
					}

				}

			}

	}

	, 
	_itemsSource: null,
	itemsSource: function (value) {
		if (arguments.length === 1) {
			this._itemsSource = value;
			return value;
		} else {
			return this._itemsSource;
		}
	}

	, 
	_sourceMetadata: null,
	sourceMetadata: function (value) {
		if (arguments.length === 1) {
			this._sourceMetadata = value;
			return value;
		} else {
			return this._sourceMetadata;
		}
	}

	, 
	discoverCatalogsAsync: function (properties, restrictions) {
		throw new $.ig.NotImplementedException();
	}

	, 
	discoverCubesAsync: function (properties, restrictions) {
		var tcs = new $.ig.TaskCompletionSource$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Cube.prototype.$type), 0);
		if (this.__cubes == null) {
			this.__cubes = this.buildCubes();
		}

		tcs.setResult(this.__cubes);
		return tcs.task();
	}

	, 
	discoverDimensionsAsync: function (properties, restrictions) {
		var tcs = new $.ig.TaskCompletionSource$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Dimension.prototype.$type), 0);
		if (this.__dimensions == null) {
			this.__dimensions = this.buildDimensions();
		}

		tcs.setResult(this.__dimensions);
		return tcs.task();
	}

	, 
	discoverHierarchiesAsync: function (properties, restrictions) {
		var tcs = new $.ig.TaskCompletionSource$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Hierarchy.prototype.$type), 0);
		if (this.__hierarchies == null) {
			this.__hierarchies = this.buildHierarchies();
		}

		tcs.setResult(this.__hierarchies);
		return tcs.task();
	}

	, 
	discoverLevelsAsync: function (properties, restrictions) {
		var tcs = new $.ig.TaskCompletionSource$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Level.prototype.$type), 0);
		var levels = this.discoverLevels(properties, restrictions);
		tcs.setResult(levels);
		return tcs.task();
	}

	, 
	discoverLevels: function (properties, restrictions) {
		var $self = this;
		if ($self.__levels == null) {
			$self.__hierarchyLevels = new $.ig.Dictionary$2(String, $.ig.IList$1.prototype.$type.specialize($.ig.Level.prototype.$type), 0);
			$self.__levels = $self.buildLevels();
		}

		var hierarchyRestriction = null;
		var levelRestriction = null;
		if (restrictions != null) {
			hierarchyRestriction = restrictions.where$1($.ig.KeyValueItem.prototype.$type, function (kvp) { return kvp.key() == "HIERARCHY_UNIQUE_NAME"; }).firstOrDefault$1($.ig.KeyValueItem.prototype.$type);
			levelRestriction = restrictions.where$1($.ig.KeyValueItem.prototype.$type, function (kvp) { return kvp.key() == "LEVEL_UNIQUE_NAME"; }).firstOrDefault$1($.ig.KeyValueItem.prototype.$type);
		}

		var levels;
		if (hierarchyRestriction != null) {
			levels = $self.__levels.where$1($.ig.Level.prototype.$type, function (l) { return l.hierarchyUniqueName() == hierarchyRestriction.value(); });

		} else {
			levels = $self.__levels.toList$1($.ig.Level.prototype.$type);
		}

		if (levelRestriction != null) {
			levels = levels.where$1($.ig.Level.prototype.$type, function (l) { return l.uniqueName() == levelRestriction.value(); });
		}

		return levels;
	}

	, 
	discoverMeasuresAsync: function (properties, restrictions) {
		var tcs = new $.ig.TaskCompletionSource$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Measure.prototype.$type), 0);
		if (this.__measures == null) {
			this.__measuresAggregators = new $.ig.Dictionary$2(String, $.ig.Func$3.prototype.$type.specialize($.ig.IEnumerable.prototype.$type, $.ig.CellMetadata.prototype.$type, $.ig.Object.prototype.$type), 0);
			this.__measures = this.buildMeasures(this.__measuresAggregators);
		}

		tcs.setResult(this.__measures);
		return tcs.task();
	}

	, 
	discoverMeasureGroupsAsync: function (properties, restrictions) {
		throw new $.ig.NotImplementedException();
	}

	, 
	discoverMeasureGroupDimensionsAsync: function (properties, restrictions) {
		throw new $.ig.NotImplementedException();
	}

	, 
	discoverMembersAsync: function (properties, restrictions) {
		var tcs = new $.ig.TaskCompletionSource$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Member.prototype.$type), 0);
		var members = this.discoverMembers(properties, restrictions);
		tcs.setResult(members);
		return tcs.task();
	}

	, 
	discoverKpisAsync: function (properties, restrictions) {
		var tcs = new $.ig.TaskCompletionSource$1($.ig.IEnumerable$1.prototype.$type.specialize($.ig.Kpi.prototype.$type), 0);
		tcs.setResult(new $.ig.List$1($.ig.Kpi.prototype.$type, 0));
		return tcs.task();
	}

	, 
	discoverMembers: function (properties, restrictions) {
		var $self = this;
		if ($self.__levelMembers == null) {
			$self.__levelMembers = new $.ig.Dictionary$2(String, $.ig.IDictionary$2.prototype.$type.specialize(String, $.ig.Member.prototype.$type), 0);
		}

		var hierarchyRestriction = restrictions.where$1($.ig.KeyValueItem.prototype.$type, function (kvp) { return kvp.key() == "HIERARCHY_UNIQUE_NAME"; }).firstOrDefault$1($.ig.KeyValueItem.prototype.$type);
		var levelRestriction = restrictions.where$1($.ig.KeyValueItem.prototype.$type, function (kvp) { return kvp.key() == "LEVEL_UNIQUE_NAME"; }).firstOrDefault$1($.ig.KeyValueItem.prototype.$type);
		var memberRestriction = restrictions.where$1($.ig.KeyValueItem.prototype.$type, function (kvp) { return kvp.key() == "MEMBER_UNIQUE_NAME"; }).firstOrDefault$1($.ig.KeyValueItem.prototype.$type);
		if ($self.__levels == null) {
			$self.__levels = $self.buildLevels();
		}

		var levelsToProcess = null;
		var levels = $self.__levels;
		if (hierarchyRestriction != null) {
			levels = levels.where$1($.ig.Level.prototype.$type, function (l) { return l.hierarchyUniqueName() == hierarchyRestriction.value(); }).toList$1($.ig.Level.prototype.$type);
		}

		if (levelRestriction != null) {
			var restrictionLevel = levels.where$1($.ig.Level.prototype.$type, function (l) { return l.uniqueName() == levelRestriction.value(); }).first$1($.ig.Level.prototype.$type);
			var hierarchyName = restrictionLevel.hierarchyUniqueName();
			var levelDepth = restrictionLevel.depth();
			var levelsDownOffset = 0;
			if (memberRestriction != null) {
				levelsDownOffset = 1;
			}

			levels = levels.where$1($.ig.Level.prototype.$type, function (l) { return l.hierarchyUniqueName() == hierarchyName && l.depth() <= levelDepth + levelsDownOffset; }).toList$1($.ig.Level.prototype.$type);

		} else if (memberRestriction != null) {
			throw new $.ig.InvalidOperationException(1, "LEVEL_UNIQUE_NAME restriction is required for MEMBER_UNIQUE_NAME restriction.");
		}


		levelsToProcess = new Array(levels.count());
		for (var i = 0; i < levels.count(); i++) {
			levelsToProcess[i] = levels.item(i);
		}

		var members = null;
		if (levelsToProcess.length > 0) {
			var level = levelsToProcess[0];
			var hierarchy = $self.__hierarchies.where$1($.ig.Hierarchy.prototype.$type, function (h) { return h.uniqueName() == level.hierarchyUniqueName(); }).first$1($.ig.Hierarchy.prototype.$type);
			var metadataItems = $self.tableMetadata().rowsMetadataList();
			$self.createMembersFromMembersMetadata(levelsToProcess, 0, ".", null, hierarchy, metadataItems);
			if (hierarchyRestriction != null && levelRestriction == null && memberRestriction == null) {
				var membersList = new $.ig.List$1($.ig.Member.prototype.$type, 0);
				for (var i1 = 0; i1 < levelsToProcess.length; i1++) {
					var currentLevel = levelsToProcess[i1];
					var levelMembers;
					if (!(function () { var $ret = $self.__levelMembers.tryGetValue(currentLevel.uniqueName(), levelMembers); levelMembers = $ret.value; return $ret.ret; }())) {
					}

					var en = levelMembers.values().getEnumerator();
					while (en.moveNext()) {
						var member = en.current();
						membersList.add(member);
					}

				}

				members = membersList;

			} else {
				level = levelsToProcess[levelsToProcess.length - 1];
				if (memberRestriction == null) {
					var levelMembers1;
					if (!(function () { var $ret = $self.__levelMembers.tryGetValue(level.uniqueName(), levelMembers1); levelMembers1 = $ret.value; return $ret.ret; }())) {
					}

					members = levelMembers1.values();

				} else {
					var levelMembers2;
					if (!(function () { var $ret = $self.__levelMembers.tryGetValue(level.uniqueName(), levelMembers2); levelMembers2 = $ret.value; return $ret.ret; }())) {
					}

					var membersList1 = new $.ig.List$1($.ig.Member.prototype.$type, 0);
					var en1 = levelMembers2.values().getEnumerator();
					while (en1.moveNext()) {
						var member1 = en1.current();
						if (member1.parentUniqueName() == memberRestriction.value()) {
							membersList1.add(member1);
						}

					}

					members = membersList1;
				}

			}


		} else {
			members = new $.ig.List$1($.ig.Member.prototype.$type, 0);
		}

		return members;
	}

	, 
	evaluateResult: function (columnsAxisProvider, rowsAxisProvider, measures) {
		var $self = this;
		var waitTasksList = new $.ig.List$1($.ig.Task.prototype.$type, 0);
		if (columnsAxisProvider != null) {
			waitTasksList.add(columnsAxisProvider.generateAxis("Axis0"));
		}

		if (rowsAxisProvider != null) {
			var rowsAxisName = columnsAxisProvider == null ? "Axis0" : "Axis1";
			waitTasksList.add(rowsAxisProvider.generateAxis(rowsAxisName));
		}

		if (waitTasksList.count() > 0) {
			var tasks = new Array(waitTasksList.count());
			for (var i = 0; i < waitTasksList.count(); i++) {
				tasks[i] = waitTasksList.item(i);
			}

			var taskFactory = new $.ig.TaskFactory();
			return taskFactory.continueWhenAll$1($.ig.OlapResult.prototype.$type, tasks, function (t) { return $self.evaluateResultImpl(columnsAxisProvider, rowsAxisProvider, measures); });
		}

		var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
		var result = $self.evaluateResultImpl(null, null, measures);
		tcs.setResult(result);
		return tcs.task();
	}

	, 
	updateSelection: function (axisElements) {
		var $self = this;
		var elementsMap = new $.ig.Dictionary$2(String, $.ig.IDictionary$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize(String, $.ig.DataMemberMetadata.prototype.$type)), 0);
		var en = axisElements.getEnumerator();
		while (en.moveNext()) {
			var axisElement = en.current();
			if (axisElement.memberNames().count() > 0) {
				for (var i = 0; i < axisElement.memberNames().count(); i++) {
					var memberName = axisElement.memberNames().item(i);
					var memberMetadata;
					if ((function () { var $ret = $self.__memberMetadata.tryGetValue(memberName, memberMetadata); memberMetadata = $ret.value; return $ret.ret; }())) {
						var hierarchyLevels;
						if (!(function () { var $ret = elementsMap.tryGetValue(axisElement.name(), hierarchyLevels); hierarchyLevels = $ret.value; return $ret.ret; }())) {
							hierarchyLevels = new $.ig.Dictionary$2($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize(String, $.ig.DataMemberMetadata.prototype.$type), 0);
							elementsMap.add(axisElement.name(), hierarchyLevels);
						}

						var levelMetadata;
						if (!(function () { var $ret = hierarchyLevels.tryGetValue(memberMetadata.member().levelDepth(), levelMetadata); levelMetadata = $ret.value; return $ret.ret; }())) {
							levelMetadata = new $.ig.Dictionary$2(String, $.ig.DataMemberMetadata.prototype.$type, 0);
							hierarchyLevels.add(memberMetadata.member().levelDepth(), levelMetadata);
						}

						if (!levelMetadata.containsKey(memberName)) {
							levelMetadata.add(memberName, memberMetadata);
						}

					}

				}

			}

		}

		var excludedMembers = new $.ig.Dictionary$2(String, $.ig.IDictionary$2.prototype.$type.specialize(String, $.ig.DataMemberMetadata.prototype.$type), 0);
		var en1 = elementsMap.getEnumerator();
		while (en1.moveNext()) {
			var hierarchyMap = en1.current();
			var hierarchyLevels1 = hierarchyMap.value();
			var levels = hierarchyLevels1.orderBy$2($.ig.KeyValuePair$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize(String, $.ig.DataMemberMetadata.prototype.$type)), $.ig.Number.prototype.$type, function (kvp) { return kvp.key(); }).select$2($.ig.KeyValuePair$2.prototype.$type.specialize($.ig.Number.prototype.$type, $.ig.IDictionary$2.prototype.$type.specialize(String, $.ig.DataMemberMetadata.prototype.$type)), $.ig.IDictionary$2.prototype.$type.specialize(String, $.ig.DataMemberMetadata.prototype.$type), function (kvp) { return kvp.value(); }).toList$1($.ig.IDictionary$2.prototype.$type.specialize(String, $.ig.DataMemberMetadata.prototype.$type));
			for (var i1 = levels.count() - 1; i1 >= 0; i1--) {
				var levelMetadata1 = levels.item(i1).select$2($.ig.KeyValuePair$2.prototype.$type.specialize(String, $.ig.DataMemberMetadata.prototype.$type), $.ig.DataMemberMetadata.prototype.$type, function (lm) { return lm.value(); }).toList$1($.ig.DataMemberMetadata.prototype.$type);
				for (var j = 0; j < levelMetadata1.count(); j++) {
					var memberMetadata1 = levelMetadata1.item(j);
					var levelDepth = memberMetadata1.member().levelDepth();
					if (levelDepth > 0) {
						var upperLevelMetadata;
						if (!(function () { var $ret = hierarchyLevels1.tryGetValue(levelDepth - 1, upperLevelMetadata); upperLevelMetadata = $ret.value; return $ret.ret; }()) || !upperLevelMetadata.containsKey(memberMetadata1.member().parentUniqueName())) {
							var selectedItems;
							if (!(function () { var $ret = excludedMembers.tryGetValue(memberMetadata1.member().parentUniqueName(), selectedItems); selectedItems = $ret.value; return $ret.ret; }())) {
								selectedItems = new $.ig.Dictionary$2(String, $.ig.DataMemberMetadata.prototype.$type, 0);
								excludedMembers.add(memberMetadata1.member().parentUniqueName(), selectedItems);
							}

							selectedItems.add(memberMetadata1.member().uniqueName(), memberMetadata1);
						}

					}

				}

			}

			var topMostLevel = levels.item(0);
			var sample = topMostLevel.values().first$1($.ig.DataMemberMetadata.prototype.$type);
			if (!String.isNullOrEmpty(sample.member().parentUniqueName())) {
				sample = $self.__memberMetadata.item(sample.member().parentUniqueName());
			}

			var restrictions = new $.ig.List$1($.ig.KeyValueItem.prototype.$type, 0);
			restrictions.add((function () { var $ret = new $.ig.KeyValueItem();
			$ret.key("LEVEL_UNIQUE_NAME");
			$ret.value(sample.member().levelUniqueName()); return $ret;}()));
			var topMostLevelMembers = $self.discoverMembers(null, restrictions).toList$1($.ig.Member.prototype.$type);
			for (var i2 = 0; i2 < topMostLevelMembers.count(); i2++) {
				var member = topMostLevelMembers.item(i2);
				if (!topMostLevel.containsKey(member.uniqueName()) && !excludedMembers.containsKey(member.uniqueName())) {
					excludedMembers.add(member.uniqueName(), new $.ig.Dictionary$2(String, $.ig.DataMemberMetadata.prototype.$type, 0));
				}

			}

		}

		var en2 = $self.__excludedMembers.keys().getEnumerator();
		while (en2.moveNext()) {
			var excludedMemberName = en2.current();
			var memberMetadata2;
			if ((function () { var $ret = $self.__memberMetadata.tryGetValue(excludedMemberName, memberMetadata2); memberMetadata2 = $ret.value; return $ret.ret; }())) {
				for (var i3 = 0; i3 < memberMetadata2.rowsMetadata().count(); i3++) {
					var rowMetadata = memberMetadata2.rowsMetadata().item(i3);
					if (rowMetadata.isExcluded()) {
						rowMetadata.removeFilterSource();
					}

				}

			}

		}

		$self.__excludedMembers = excludedMembers;
		var en3 = $self.__excludedMembers.keys().getEnumerator();
		while (en3.moveNext()) {
			var excludedMemberName1 = en3.current();
			var memberMetadata3;
			if ((function () { var $ret = $self.__memberMetadata.tryGetValue(excludedMemberName1, memberMetadata3); memberMetadata3 = $ret.value; return $ret.ret; }())) {
				if (!$self.excludedMembersContainsParentName(memberMetadata3)) {
					for (var i4 = 0; i4 < memberMetadata3.rowsMetadata().count(); i4++) {
						var rowMetadata1 = memberMetadata3.rowsMetadata().item(i4);
						rowMetadata1.addFilterSource();
					}

				}

			}

		}

		var en4 = $self.__excludedMembers.keys().getEnumerator();
		while (en4.moveNext()) {
			var excludedMemberName2 = en4.current();
			var excludedMetadata;
			if ((function () { var $ret = $self.__memberMetadata.tryGetValue(excludedMemberName2, excludedMetadata); excludedMetadata = $ret.value; return $ret.ret; }())) {
				var membersToInclude = $self.__excludedMembers.item(excludedMemberName2).values().toList$1($.ig.DataMemberMetadata.prototype.$type);
				for (var i5 = 0; i5 < membersToInclude.count(); i5++) {
					var memberMetadataToInclude = membersToInclude.item(i5);
					for (var j1 = 0; j1 < memberMetadataToInclude.rowsMetadata().count(); j1++) {
						var rowMetadata2 = memberMetadataToInclude.rowsMetadata().item(j1);
						if (rowMetadata2.isExcluded()) {
							rowMetadata2.removeFilterSource();
						}

					}

				}

			}

		}

	}

	, 
	excludedMembersContainsParentName: function (memberMetadata) {
		var $self = this;
		var parentName = memberMetadata.member().parentUniqueName();
		while (!String.isNullOrEmpty(parentName)) {
			if ($self.__excludedMembers.containsKey(parentName)) {
				return true;
			}

			var parentMemberMetadata;
			if ((function () { var $ret = $self.__memberMetadata.tryGetValue(parentName, parentMemberMetadata); parentMemberMetadata = $ret.value; return $ret.ret; }())) {
				parentName = parentMemberMetadata.member().parentUniqueName();

			} else {
				return false;
			}


		}
		return false;
	}
	, 
	__excludedMembers: null

	, 
	getRowsMetadata: function (membersArray, areaItemIndex) {
		var $self = this;
		var initDataRows = null;
		var initIndex = -1;
		for (var i = 0; i < areaItemIndex; i++) {
			var axisMember = membersArray[i];
			var memberDataRows = null;
			var dataMemberMetadata;
			if ((function () { var $ret = $self.tryGetDataMemberMetadata(axisMember.uniqueName(), dataMemberMetadata); dataMemberMetadata = $ret.memberMetadata; return $ret.ret; }())) {
				memberDataRows = dataMemberMetadata.rowsMetadata();
			}

			if (memberDataRows != null) {
				if (initDataRows == null || initDataRows.count() > memberDataRows.count()) {
					initIndex = i;
					initDataRows = memberDataRows;
				}

			}

		}

		if (initDataRows == null) {
			initDataRows = $self.tableMetadata().rowsMetadataList().toList$1($.ig.RowMetadata.prototype.$type);
		}

		var rowsMetadata = initDataRows;
		for (var i1 = 0; i1 < areaItemIndex; i1++) {
			if (i1 != initIndex) {
				var currentMember = membersArray[i1];
				var memberIdValue;
				if ((function () { var $ret = currentMember.properties().tryGetValue("memberId", memberIdValue); memberIdValue = $ret.value; return $ret.ret; }())) {
					var levelUniqueName = currentMember.levelUniqueName();
					var memberId = $.ig.Number.prototype.parseInt(memberIdValue);
					rowsMetadata = rowsMetadata.where$1($.ig.RowMetadata.prototype.$type, function (drm) { return drm.getMemberId(levelUniqueName) == memberId; });
				}

			}

		}

		return rowsMetadata;
	}

	, 
	tryGetMemberId: function (uniqueName, memberId) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.__memberIds.tryGetValue(uniqueName, memberId); memberId = $ret.value; return $ret.ret; }()), 
			memberId: memberId
		};
		return {
			memberId: memberId
		};
	}

	, 
	tryGetDataMemberMetadata: function (memberUniqueName, memberMetadata) {
		var $self = this;
		return {
			ret: (function () { var $ret = $self.__memberMetadata.tryGetValue(memberUniqueName, memberMetadata); memberMetadata = $ret.value; return $ret.ret; }()), 
			memberMetadata: memberMetadata
		};
		return {
			memberMetadata: memberMetadata
		};
	}

	, 
	toArrayListCollection$1: function ($t, enumerable) {
		var res = new $.ig.ArrayListCollection$1($t);
		var en = enumerable.getEnumerator();
		while (en.moveNext()) {
			var item = en.current();
			res.add(item);
		}

		return res;
	}

	, 
	evaluateResultImpl: function (columnsAxisProvider, rowsAxisProvider, measures) {
		var $self = this;
		var columnsAxis = null;
		if (columnsAxisProvider != null) {
			columnsAxis = columnsAxisProvider.axis();
		}

		var rowsAxis = null;
		if (rowsAxisProvider != null) {
			rowsAxis = rowsAxisProvider.axis();
		}

		var measureListInfo = $self.getMeasureListInfo(columnsAxis, rowsAxis, measures);
		var measureListLocation = measureListInfo[0];
		var measureListIndex = measureListInfo[1];
		var measureName = null;
		var measureIndex = -1;
		var aggregator = null;
		var measureIndexes = new $.ig.Dictionary$2(String, $.ig.Number.prototype.$type, 0);
		var measuresArray = new $.ig.Array();
		var rowTuplesArray = new $.ig.Array();
		var columnTuplesArray = new $.ig.Array();
		for (var i = 0; i < measures.count(); i++) {
			measureIndexes.add(measures.item(i).uniqueName(), i);
			measuresArray.add(measures.item(i));
		}

		if (measureListLocation == "none" && measures.count() > 0) {
			measureName = measures.item(0).uniqueName();
			measureIndex = measureIndexes.item(measureName);
			aggregator = $self.__measuresAggregators.item(measureName);
		}

		if (columnsAxis == null && rowsAxis == null) {
			var cells = new $.ig.List$1($.ig.OlapResultCell.prototype.$type, 0);
			if (aggregator != null) {
				var metadataItems = $self.tableMetadata().rowsMetadataList().where$1($.ig.RowMetadata.prototype.$type, function (rm) { return !rm.isExcluded(); });
				var cellItems = new $.ig.Array();
				var en = metadataItems.select$2($.ig.RowMetadata.prototype.$type, $.ig.Object.prototype.$type, function (drm) { return drm.dataItem(); }).getEnumerator();
				while (en.moveNext()) {
					var dataItem = en.current();
					cellItems.add(dataItem);
				}

				if (cellItems.length > 0) {
					var cellMetadata = new $.ig.CellMetadata(0, 0, 0, measureIndex, rowTuplesArray, columnTuplesArray, measuresArray);
					var cellValue = aggregator(cellItems, cellMetadata);
					if (cellValue != null) {
						var cell = new $.ig.OlapResultCell();
						cell.cellOrdinal(0);
						cell.properties().add("Value", cellValue);
						cell.properties().add("FmtValue", cellValue.toString());
						cells.add(cell);
					}

				}

			}

			return $self.createResult(null, null, cells);
		}

		if (rowsAxis != null) {
			var rowAxisTuples = rowsAxis.tuples();
			for (var i1 = 0; i1 < rowAxisTuples.count(); i1++) {
				rowTuplesArray.add(rowAxisTuples.__inner[i1]);
			}

		}

		if (columnsAxis != null) {
			var columnAxisTuples = columnsAxis.tuples();
			for (var i2 = 0; i2 < columnAxisTuples.count(); i2++) {
				columnTuplesArray.add(columnAxisTuples.__inner[i2]);
			}

		}

		var columnTuplesCount = 1;
		if (columnsAxis != null) {
			columnTuplesCount = columnsAxis.tuples().count();
		}

		var rowTuplesCount = 1;
		if (rowsAxis != null) {
			rowTuplesCount = rowsAxis.tuples().count();
		}

		var resultCells = new $.ig.List$1($.ig.OlapResultCell.prototype.$type, 0);
		for (var rowTupleIndex = 0; rowTupleIndex < rowTuplesCount; rowTupleIndex++) {
			var rowsList = null;
			var rowTuple = null;
			if (rowsAxis != null) {
				rowTuple = rowsAxis.tuples().__inner[rowTupleIndex];
				rowsList = rowsAxisProvider.getTupleRowsMetadata(rowTuple);
				if (measureListLocation == "rows") {
					measureName = rowTuple.members().item(measureListIndex).uniqueName();
					measureIndex = measureIndexes.item(measureName);
					aggregator = $self.__measuresAggregators.item(measureName);
				}

			}

			for (var columnTupleIndex = 0; columnTupleIndex < columnTuplesCount; columnTupleIndex++) {
				var itemsList = rowsList;
				var columnsList = null;
				var columnTuple = null;
				if (columnsAxis != null) {
					columnTuple = columnsAxis.tuples().__inner[columnTupleIndex];
					columnsList = columnsAxisProvider.getTupleRowsMetadata(columnTuple);
					if (measureListLocation == "columns") {
						measureName = columnTuple.members().item(measureListIndex).uniqueName();
						measureIndex = measureIndexes.item(measureName);
						aggregator = $self.__measuresAggregators.item(measureName);
					}

				}

				if (itemsList != null) {
					if (columnsList != null) {
						itemsList = $self.getIntersectionMetadata(itemsList, columnsList, rowTuple, columnTuple, measureListIndex);
					}


				} else {
					itemsList = columnsList;
				}

				if (aggregator != null) {
					var cellOrdinal = rowTupleIndex * columnTuplesCount + columnTupleIndex;
					var cellMetadata1 = new $.ig.CellMetadata(rowTupleIndex, columnTupleIndex, cellOrdinal, measureIndex, rowTuplesArray, columnTuplesArray, measuresArray);
					var cellItems1 = new $.ig.Array();
					var en1 = itemsList.select$2($.ig.RowMetadata.prototype.$type, $.ig.Object.prototype.$type, function (drm) { return drm.dataItem(); }).getEnumerator();
					while (en1.moveNext()) {
						var dataItem1 = en1.current();
						cellItems1.add(dataItem1);
					}

					if (cellItems1.length > 0) {
						var cellValue1 = aggregator(cellItems1, cellMetadata1);
						if (cellValue1 != null) {
							var cell1 = new $.ig.OlapResultCell();
							cell1.cellOrdinal(cellOrdinal);
							cell1.properties().add("Value", cellValue1.toString());
							cell1.properties().add("FmtValue", cellValue1.toString());
							resultCells.add(cell1);
						}

					}

				}

			}

		}

		var result = $self.createResult(columnsAxis, rowsAxis, resultCells);
		return result;
	}

	, 
	createResult: function (columnsAxis, rowsAxis, cells) {
		var $self = this;
		var result = (function () { var $ret = new $.ig.OlapResult();
		$ret.axes(new $.ig.List$1($.ig.OlapResultAxis.prototype.$type, 0)); return $ret;}());
		if (columnsAxis != null) {
			result.axes().add(columnsAxis);
		}

		if (rowsAxis != null) {
			result.axes().add(rowsAxis);
		}

		result.cells(cells);
		result.isEmpty(rowsAxis == null && columnsAxis == null && cells.count() == 0);
		return result;
	}

	, 
	getIntersectionMetadata: function (primaryList, secondaryList, primaryTuple, secondaryTuple, skipIndex) {
		var $self = this;
		if (secondaryList.count() < primaryList.count()) {
			primaryList = secondaryList;
			secondaryTuple = primaryTuple;
		}

		for (var i = 0; i < secondaryTuple.members().count(); i++) {
			if (i != skipIndex) {
				var axisMember = secondaryTuple.members().item(i);
				var memberIdValue;
				if ((function () { var $ret = axisMember.properties().tryGetValue("memberId", memberIdValue); memberIdValue = $ret.value; return $ret.ret; }())) {
					var memberId = $.ig.Number.prototype.parseInt(memberIdValue);
					primaryList = primaryList.where$1($.ig.RowMetadata.prototype.$type, function (rm) { return rm.getMemberId(axisMember.levelUniqueName()) == memberId; }).toList$1($.ig.RowMetadata.prototype.$type);
				}

			}

		}

		return primaryList;
	}

	, 
	getMeasureListInfo: function (columnsAxis, rowsAxis, measures) {
		var $self = this;
		var measuresHierarchyUniqueName = $self.ensureNamePattern($self.sourceMetadata().cubeMetadata().measuresDimensionMetadata().name());
		var measureListLocation = "none";
		var measureListIndex = -1;
		if (measures.count() > 0) {
			if (columnsAxis != null && columnsAxis.tuples().count() > 0) {
				var tuple = columnsAxis.tuples().__inner[0];
				for (var i = 0; i < tuple.members().count(); i++) {
					var axisMember = tuple.members().item(i);
					if (axisMember.hierarchyUniqueName() == measuresHierarchyUniqueName) {
						measureListLocation = "columns";
						measureListIndex = i;
						break;
					}

				}

			}

			if (measureListLocation == "none") {
				if (rowsAxis != null && rowsAxis.tuples().count() > 0) {
					var tuple1 = rowsAxis.tuples().__inner[0];
					for (var i1 = 0; i1 < tuple1.members().count(); i1++) {
						var axisMember1 = tuple1.members().item(i1);
						if (axisMember1.hierarchyUniqueName() == measuresHierarchyUniqueName) {
							measureListLocation = "rows";
							measureListIndex = i1;
							break;
						}

					}

				}

			}

		}

		return (function () { var $ret = new Array();
		$ret.add(measureListLocation);
		$ret.add(measureListIndex);return $ret;}());
	}

	, 
	createMembersFromMembersMetadata: function (levels, currentLevelIndex, parentNamePart, parentMember, parentHierarchy, metadataItems) {
		var $self = this;
		var level = levels[currentLevelIndex];
		var memberValueProvider = $self.__levelMemberProviders.item(level.uniqueName());
		var nextLevelDown = $self.__levels.where$1($.ig.Level.prototype.$type, function (l) { return l.hierarchyUniqueName() == parentHierarchy.uniqueName() && l.depth() == level.depth() + 1; }).firstOrDefault$1($.ig.Level.prototype.$type);
		var parentUniqueName = null;
		if (parentMember != null) {
			parentUniqueName = parentMember.uniqueName();
		}

		var levelMembers;
		if (!(function () { var $ret = $self.__levelMembers.tryGetValue(level.uniqueName(), levelMembers); levelMembers = $ret.value; return $ret.ret; }())) {
			levelMembers = new $.ig.Dictionary$2(String, $.ig.Member.prototype.$type, 0);
			$self.__levelMembers.add(level.uniqueName(), levelMembers);
		}

		var pairsList = new $.ig.List$1($.ig.KeyListPair$1.prototype.$type.specialize($.ig.RowMetadata.prototype.$type), 0);
		var memberGroups = new $.ig.Dictionary$2(String, $.ig.IList$1.prototype.$type.specialize($.ig.RowMetadata.prototype.$type), 0);
		var en = metadataItems.getEnumerator();
		while (en.moveNext()) {
			var rowMetadata = en.current();
			var memberValue = memberValueProvider(rowMetadata.dataItem());
			if (memberValue != null) {
				var memberItems;
				if (!(function () { var $ret = memberGroups.tryGetValue(memberValue, memberItems); memberItems = $ret.value; return $ret.ret; }())) {
					memberItems = new $.ig.List$1($.ig.RowMetadata.prototype.$type, 0);
					memberGroups.add(memberValue, memberItems);
					pairsList.add(new $.ig.KeyListPair$1($.ig.RowMetadata.prototype.$type, 1, memberValue, memberItems));
				}

				memberItems.add(rowMetadata);
			}

		}

		for (var j = 0; j < pairsList.count(); j++) {
			var memberValue1 = pairsList.item(j).key();
			var memberItems1 = pairsList.item(j).list();
			var memberUniqueNamePart = parentNamePart + "&" + $self.ensureNamePattern(memberValue1);
			var memberUniqueName = level.uniqueName() + memberUniqueNamePart;
			var member;
			var memberId;
			var dataMemberMetadata;
			if (!(function () { var $ret = levelMembers.tryGetValue(memberUniqueName, member); member = $ret.value; return $ret.ret; }())) {
				member = new $.ig.Member();
				member.caption(memberValue1);
				member.dimensionUniqueName(level.dimensionUniqueName());
				member.hierarchyUniqueName(level.hierarchyUniqueName());
				member.levelDepth(level.depth());
				member.levelUniqueName(level.uniqueName());
				member.name(memberValue1);
				member.parentLevel(level.depth() - 1);
				member.parentUniqueName(parentUniqueName);
				member.uniqueName(memberUniqueName);
				if (nextLevelDown != null) {
					member.childrenCardinality(1);
				}

				if (parentMember != null) {
					parentMember.childrenCardinality(parentMember.childrenCardinality() + 1);
				}

				levelMembers.add(memberUniqueName, member);
				memberId = $self.__memberIds.count();
				$self.__memberIds.add(member.uniqueName(), memberId);
				dataMemberMetadata = new $.ig.DataMemberMetadata(member, memberUniqueNamePart, memberId, levelMembers.count());
				$self.__memberMetadata.add(member.uniqueName(), dataMemberMetadata);
				$self.__selectedMemberMetadata.add(member.uniqueName(), dataMemberMetadata);
				for (var i = 0; i < memberItems1.count(); i++) {
					var rowMetadata1 = memberItems1.item(i);
					rowMetadata1.addMemberValue(level.uniqueName(), memberId);
					dataMemberMetadata.addDataRow(rowMetadata1);
				}

			}

			if (currentLevelIndex + 1 < levels.length) {
				$self.createMembersFromMembersMetadata(levels, currentLevelIndex + 1, memberUniqueNamePart, member, parentHierarchy, memberItems1);
			}

		}

		if (parentMember != null) {
			parentMember.childrenCardinality(pairsList.count());
		}

	}

	, 
	ensureNamePattern: function (name) {
		if (name.substr(0, 1) != "[") {
			name = "[" + name;
		}

		if (name.substr(name.length - 1, 1) != "]") {
			name += "]";
		}

		return name;
	}
	, 
	__dimensionsMetadata: null
	, 
	__dimensionHierarchies: null

	, 
	buildCubes: function () {
		var cubes = new $.ig.List$1($.ig.Cube.prototype.$type, 0);
		if (this.sourceMetadata() == null || this.sourceMetadata().cubeMetadata() == null) {
			return cubes;
		}

		var cube = new $.ig.Cube();
		cube.caption(this.sourceMetadata().cubeMetadata().caption());
		cube.name(this.sourceMetadata().cubeMetadata().name());
		cube.description(this.sourceMetadata().cubeMetadata().description());
		cubes.add(cube);
		return cubes;
	}

	, 
	buildMeasures: function (measuresAggregators) {
		var measures = new $.ig.List$1($.ig.Measure.prototype.$type, 0);
		if (this.sourceMetadata() == null || this.sourceMetadata().cubeMetadata() == null || this.sourceMetadata().cubeMetadata().measuresDimensionMetadata() == null || this.sourceMetadata().cubeMetadata().measuresDimensionMetadata().measuresMetadata() == null) {
			return measures;
		}

		var measuresDimensionName = this.sourceMetadata().cubeMetadata().measuresDimensionMetadata().name();
		var en = this.sourceMetadata().cubeMetadata().measuresDimensionMetadata().measuresMetadata().getEnumerator();
		while (en.moveNext()) {
			var measureMetadata = en.current();
			var measure = new $.ig.Measure();
			measure.caption(measureMetadata.measureCaption());
			measure.defaultFormatString(measureMetadata.displayFormat());
			measure.measureDisplayFolder(measureMetadata.displayFolder());
			measure.name(measureMetadata.measureName());
			measure.uniqueName(this.ensureNamePattern(measuresDimensionName) + "." + this.ensureNamePattern(measureMetadata.measureName()));
			measures.add(measure);
			measuresAggregators.item(measure.uniqueName(), measureMetadata.aggregator());
		}

		return measures;
	}

	, 
	buildDimensions: function () {
		if (this.__cubes == null) {
			this.__cubes = this.buildCubes();
		}

		var dimensions = new $.ig.List$1($.ig.Dimension.prototype.$type, 0);
		if (this.sourceMetadata() == null || this.sourceMetadata().cubeMetadata() == null) {
			return dimensions;
		}

		var measureDimension = new $.ig.Dimension();
		measureDimension.dimensionType($.ig.DimensionType.prototype.measure);
		measureDimension.caption(this.sourceMetadata().cubeMetadata().measuresDimensionMetadata().caption());
		measureDimension.uniqueName(this.ensureNamePattern(this.sourceMetadata().cubeMetadata().measuresDimensionMetadata().name()));
		dimensions.add(measureDimension);
		if (this.sourceMetadata().cubeMetadata().dimensionsMetadata() == null) {
			return dimensions;
		}

		this.__dimensionsMetadata = new $.ig.List$1($.ig.DimensionMetadata.prototype.$type, 0);
		var en = this.sourceMetadata().cubeMetadata().dimensionsMetadata().getEnumerator();
		while (en.moveNext()) {
			var dimensionMetadata = en.current();
			this.__dimensionsMetadata.add(dimensionMetadata);
			var dimension = new $.ig.Dimension();
			dimension.caption(dimensionMetadata.caption());
			dimension.defaultHierarchy(dimensionMetadata.defaultHierarchy());
			dimension.uniqueName(this.ensureNamePattern(dimensionMetadata.name()));
			dimension.name(dimensionMetadata.name());
			dimension.description(dimensionMetadata.description());
			dimensions.add(dimension);
		}

		return dimensions;
	}

	, 
	buildHierarchies: function () {
		var $self = this;
		if ($self.__dimensions == null) {
			$self.__dimensions = $self.buildDimensions();
		}

		var hierarchies = new $.ig.List$1($.ig.Hierarchy.prototype.$type, 0);
		if ($self.sourceMetadata() == null || $self.sourceMetadata().cubeMetadata() == null) {
			return hierarchies;
		}

		var measureHierarchy = new $.ig.Hierarchy();
		measureHierarchy.uniqueName($self.ensureNamePattern($self.sourceMetadata().cubeMetadata().measuresDimensionMetadata().name()));
		measureHierarchy.dimensionUniqueName($self.ensureNamePattern($self.sourceMetadata().cubeMetadata().measuresDimensionMetadata().name()));
		hierarchies.add(measureHierarchy);
		if ($self.sourceMetadata().cubeMetadata().dimensionsMetadata() == null) {
			return hierarchies;
		}

		$self.__dimensionHierarchies = new $.ig.Dictionary$2(String, $.ig.IList$1.prototype.$type.specialize($.ig.HierarchyMetadata.prototype.$type), 0);
		for (var i = 0; i < $self.__dimensionsMetadata.count(); i++) {
			var dimensionMetadata = $self.__dimensionsMetadata.item(i);
			if (dimensionMetadata.hierarchiesMetadata() != null) {
				var hierarchiesMetadata;
				if (!(function () { var $ret = $self.__dimensionHierarchies.tryGetValue(dimensionMetadata.name(), hierarchiesMetadata); hierarchiesMetadata = $ret.value; return $ret.ret; }())) {
					hierarchiesMetadata = new $.ig.List$1($.ig.HierarchyMetadata.prototype.$type, 0);
					$self.__dimensionHierarchies.add(dimensionMetadata.name(), hierarchiesMetadata);
				}

				var en = dimensionMetadata.hierarchiesMetadata().getEnumerator();
				while (en.moveNext()) {
					var hierarchyMetadata = en.current();
					hierarchiesMetadata.add(hierarchyMetadata);
					var hierarchy = new $.ig.Hierarchy();
					hierarchy.caption(hierarchyMetadata.caption());
					hierarchy.description(hierarchyMetadata.description());
					hierarchy.dimensionUniqueName($self.ensureNamePattern(dimensionMetadata.name()));
					hierarchy.hierarchyDisplayFolder(hierarchyMetadata.displayFolder());
					hierarchy.name(hierarchyMetadata.name());
					hierarchy.uniqueName(hierarchy.dimensionUniqueName() + "." + $self.ensureNamePattern(hierarchy.name()));
					hierarchies.add(hierarchy);
				}

			}

		}

		return hierarchies;
	}

	, 
	buildLevels: function () {
		var $self = this;
		if ($self.__hierarchies == null) {
			$self.__hierarchies = $self.buildHierarchies();
		}

		$self.__levelMemberProviders = new $.ig.Dictionary$2(String, $.ig.Func$2.prototype.$type.specialize($.ig.Object.prototype.$type, String), 0);
		var levels = new $.ig.List$1($.ig.Level.prototype.$type, 0);
		if ($self.sourceMetadata() == null || $self.sourceMetadata().cubeMetadata() == null) {
			return levels;
		}

		var measuresLevel = new $.ig.Level();
		measuresLevel.hierarchyUniqueName($self.ensureNamePattern($self.sourceMetadata().cubeMetadata().measuresDimensionMetadata().name()));
		measuresLevel.uniqueName(measuresLevel.hierarchyUniqueName() + ".[MeasuresLevel]");
		measuresLevel.depth(-1);
		levels.add(measuresLevel);
		if ($self.sourceMetadata().cubeMetadata().dimensionsMetadata() == null) {
			return levels;
		}

		var measuresDimensionMetadata = new $.ig.HierarchyMetadata();
		measuresDimensionMetadata.name($self.sourceMetadata().cubeMetadata().measuresDimensionMetadata().name());
		measuresDimensionMetadata.caption($self.sourceMetadata().cubeMetadata().measuresDimensionMetadata().caption());
		var hierarchiesMetadata = new $.ig.List$1($.ig.HierarchyMetadata.prototype.$type, 0);
		hierarchiesMetadata.add(measuresDimensionMetadata);
		for (var i = 0; i < $self.__dimensionsMetadata.count(); i++) {
			var dimensionMetadata = $self.__dimensionsMetadata.item(i);
			var dimensionHierarchies;
			if ((function () { var $ret = $self.__dimensionHierarchies.tryGetValue(dimensionMetadata.name(), dimensionHierarchies); dimensionHierarchies = $ret.value; return $ret.ret; }())) {
				for (var j = 0; j < dimensionHierarchies.count(); j++) {
					hierarchiesMetadata.add(dimensionHierarchies.item(j));
				}

			}

		}

		for (var i1 = 0; i1 < hierarchiesMetadata.count(); i1++) {
			var hierarchyMetadata = hierarchiesMetadata.item(i1);
			if (hierarchyMetadata.levelsMetadata() == null) {
				continue;
			}

			var hierarchy = $self.__hierarchies.item(i1);
			for (var j1 = 0; j1 < hierarchyMetadata.levelsMetadata().count(); j1++) {
				var levelMetadata = hierarchyMetadata.levelsMetadata().item(j1);
				var level = new $.ig.Level();
				level.caption(levelMetadata.caption());
				level.depth(j1);
				level.dimensionUniqueName(hierarchy.dimensionUniqueName());
				level.hierarchyUniqueName(hierarchy.uniqueName());
				level.name(levelMetadata.name());
				level.uniqueName(hierarchy.uniqueName() + "." + $self.ensureNamePattern(level.name()));
				levels.add(level);
				var hierarchyLevels;
				if (!(function () { var $ret = $self.__hierarchyLevels.tryGetValue(hierarchy.uniqueName(), hierarchyLevels); hierarchyLevels = $ret.value; return $ret.ret; }())) {
					hierarchyLevels = new $.ig.List$1($.ig.Level.prototype.$type, 0);
					$self.__hierarchyLevels.add(hierarchy.uniqueName(), hierarchyLevels);
				}

				hierarchyLevels.add(level);
				$self.__levelMemberProviders.item(level.uniqueName(), levelMetadata.memberProvider());
			}

		}

		return levels;
	}
	, 
	$type: new $.ig.Type('FlatDataProvider', $.ig.Object.prototype.$type, [$.ig.IFlatDataProvider.prototype.$type])
}, true);

$.ig.util.defType('KeyListPair$1', 'Object', {
	$t: null
	, 
	_key: null,
	key: function (value) {
		if (arguments.length === 1) {
			this._key = value;
			return value;
		} else {
			return this._key;
		}
	}

	, 
	_list: null,
	list: function (value) {
		if (arguments.length === 1) {
			this._list = value;
			return value;
		} else {
			return this._list;
		}
	}
	, 
	init: function ($t, initNumber) {

		if (initNumber > 0) {
			switch (initNumber) {
				case 1:
					this.init1.apply(this, arguments);
					break;
			}
			return;
		}


		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.key(String.empty());
			this.list(new $.ig.List$1(this.$t, 0));
	}
	, 
	init1: function ($t, initNumber, key, list) {



		this.$t = $t
		this.$type = this.$type.specialize(this.$t);
		$.ig.Object.prototype.init.call(this);
			this.key(key);
			this.list(list);
	}
	, 
	$type: new $.ig.Type('KeyListPair$1', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CellMetadata', 'Object', {
	init: function (rowIndex, columnIndex, cellOrdinal, measureIndex, rowTuples, columnTuples, measures) {



		$.ig.Object.prototype.init.call(this);
			this.rowIndex(rowIndex);
			this.columnIndex(columnIndex);
			this.cellOrdinal(cellOrdinal);
			this.measureIndex(measureIndex);
			this.rowTuples(rowTuples);
			this.columnTuples(columnTuples);
			this.measures(measures);
	}

	, 
	_rowIndex: 0,
	rowIndex: function (value) {
		if (arguments.length === 1) {
			this._rowIndex = value;
			return value;
		} else {
			return this._rowIndex;
		}
	}

	, 
	_columnIndex: 0,
	columnIndex: function (value) {
		if (arguments.length === 1) {
			this._columnIndex = value;
			return value;
		} else {
			return this._columnIndex;
		}
	}

	, 
	_cellOrdinal: 0,
	cellOrdinal: function (value) {
		if (arguments.length === 1) {
			this._cellOrdinal = value;
			return value;
		} else {
			return this._cellOrdinal;
		}
	}

	, 
	_measureIndex: 0,
	measureIndex: function (value) {
		if (arguments.length === 1) {
			this._measureIndex = value;
			return value;
		} else {
			return this._measureIndex;
		}
	}

	, 
	_rowTuples: null,
	rowTuples: function (value) {
		if (arguments.length === 1) {
			this._rowTuples = value;
			return value;
		} else {
			return this._rowTuples;
		}
	}

	, 
	_columnTuples: null,
	columnTuples: function (value) {
		if (arguments.length === 1) {
			this._columnTuples = value;
			return value;
		} else {
			return this._columnTuples;
		}
	}

	, 
	_measures: null,
	measures: function (value) {
		if (arguments.length === 1) {
			this._measures = value;
			return value;
		} else {
			return this._measures;
		}
	}
	, 
	$type: new $.ig.Type('CellMetadata', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('CubeMetadata', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.dimensionsMetadata(new $.ig.ArrayListCollection$1($.ig.DimensionMetadata.prototype.$type));
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_measuresDimensionMetadata: null,
	measuresDimensionMetadata: function (value) {
		if (arguments.length === 1) {
			this._measuresDimensionMetadata = value;
			return value;
		} else {
			return this._measuresDimensionMetadata;
		}
	}

	, 
	_dimensionsMetadata: null,
	dimensionsMetadata: function (value) {
		if (arguments.length === 1) {
			this._dimensionsMetadata = value;
			return value;
		} else {
			return this._dimensionsMetadata;
		}
	}
	, 
	$type: new $.ig.Type('CubeMetadata', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MeasuresDimensionMetadata', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_measuresMetadata: null,
	measuresMetadata: function (value) {
		if (arguments.length === 1) {
			this._measuresMetadata = value;
			return value;
		} else {
			return this._measuresMetadata;
		}
	}
	, 
	$type: new $.ig.Type('MeasuresDimensionMetadata', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DataMemberMetadata', 'Object', {
	init: function (member, memberUniqueNamePart, memberId, ordinal) {



		$.ig.Object.prototype.init.call(this);
			this.member(member);
			this.memberUniqueNamePart(memberUniqueNamePart);
			this.memberId(memberId);
			this.ordinal(ordinal);
			this.rowsMetadata(new $.ig.List$1($.ig.RowMetadata.prototype.$type, 0));
	}

	, 
	_memberId: 0,
	memberId: function (value) {
		if (arguments.length === 1) {
			this._memberId = value;
			return value;
		} else {
			return this._memberId;
		}
	}

	, 
	_member: null,
	member: function (value) {
		if (arguments.length === 1) {
			this._member = value;
			return value;
		} else {
			return this._member;
		}
	}

	, 
	_memberUniqueNamePart: null,
	memberUniqueNamePart: function (value) {
		if (arguments.length === 1) {
			this._memberUniqueNamePart = value;
			return value;
		} else {
			return this._memberUniqueNamePart;
		}
	}

	, 
	_ordinal: 0,
	ordinal: function (value) {
		if (arguments.length === 1) {
			this._ordinal = value;
			return value;
		} else {
			return this._ordinal;
		}
	}

	, 
	_rowsMetadata: null,
	rowsMetadata: function (value) {
		if (arguments.length === 1) {
			this._rowsMetadata = value;
			return value;
		} else {
			return this._rowsMetadata;
		}
	}

	, 
	relevantMetadataItems: function () {

			var $self = this;
			return $self.rowsMetadata().where$1($.ig.RowMetadata.prototype.$type, function (mi) { return mi.isExcluded() == false; }).toList$1($.ig.RowMetadata.prototype.$type);
	}

	, 
	addDataRow: function (rowMetadata) {
		this.rowsMetadata().add(rowMetadata);
	}

	, 
	removeDataRow: function (dataRowMetadata) {
		if (this.rowsMetadata().remove(dataRowMetadata)) {
			return true;
		}

		return false;
	}
	, 
	$type: new $.ig.Type('DataMemberMetadata', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DataSourceMetadata', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_cubeMetadata: null,
	cubeMetadata: function (value) {
		if (arguments.length === 1) {
			this._cubeMetadata = value;
			return value;
		} else {
			return this._cubeMetadata;
		}
	}
	, 
	$type: new $.ig.Type('DataSourceMetadata', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('DimensionMetadata', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
	}

	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_defaultHierarchy: null,
	defaultHierarchy: function (value) {
		if (arguments.length === 1) {
			this._defaultHierarchy = value;
			return value;
		} else {
			return this._defaultHierarchy;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_hierarchiesMetadata: null,
	hierarchiesMetadata: function (value) {
		if (arguments.length === 1) {
			this._hierarchiesMetadata = value;
			return value;
		} else {
			return this._hierarchiesMetadata;
		}
	}
	, 
	$type: new $.ig.Type('DimensionMetadata', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('HierarchyMetadata', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_description: null,
	description: function (value) {
		if (arguments.length === 1) {
			this._description = value;
			return value;
		} else {
			return this._description;
		}
	}

	, 
	_displayFolder: null,
	displayFolder: function (value) {
		if (arguments.length === 1) {
			this._displayFolder = value;
			return value;
		} else {
			return this._displayFolder;
		}
	}

	, 
	_levelsMetadata: null,
	levelsMetadata: function (value) {
		if (arguments.length === 1) {
			this._levelsMetadata = value;
			return value;
		} else {
			return this._levelsMetadata;
		}
	}
	, 
	$type: new $.ig.Type('HierarchyMetadata', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('LevelMetadata', 'Object', {
	init: function () {

		$.ig.Object.prototype.init.call(this);

	}
	, 
	_name: null,
	name: function (value) {
		if (arguments.length === 1) {
			this._name = value;
			return value;
		} else {
			return this._name;
		}
	}

	, 
	_caption: null,
	caption: function (value) {
		if (arguments.length === 1) {
			this._caption = value;
			return value;
		} else {
			return this._caption;
		}
	}

	, 
	_memberProvider: null,
	memberProvider: function (value) {
		if (arguments.length === 1) {
			this._memberProvider = value;
			return value;
		} else {
			return this._memberProvider;
		}
	}
	, 
	$type: new $.ig.Type('LevelMetadata', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('MeasureMetadata', 'Object', {
	init: function () {



		$.ig.Object.prototype.init.call(this);
			this.aggregatorType($.ig.AggregatorType.prototype.sum);
	}

	, 
	_aggregator: null,
	aggregator: function (value) {
		if (arguments.length === 1) {
			this._aggregator = value;
			return value;
		} else {
			return this._aggregator;
		}
	}

	, 
	_aggregatorType: null,
	aggregatorType: function (value) {
		if (arguments.length === 1) {
			this._aggregatorType = value;
			return value;
		} else {
			return this._aggregatorType;
		}
	}

	, 
	_displayFormat: null,
	displayFormat: function (value) {
		if (arguments.length === 1) {
			this._displayFormat = value;
			return value;
		} else {
			return this._displayFormat;
		}
	}

	, 
	_measureName: null,
	measureName: function (value) {
		if (arguments.length === 1) {
			this._measureName = value;
			return value;
		} else {
			return this._measureName;
		}
	}

	, 
	_measureCaption: null,
	measureCaption: function (value) {
		if (arguments.length === 1) {
			this._measureCaption = value;
			return value;
		} else {
			return this._measureCaption;
		}
	}

	, 
	_displayFolder: null,
	displayFolder: function (value) {
		if (arguments.length === 1) {
			this._displayFolder = value;
			return value;
		} else {
			return this._displayFolder;
		}
	}
	, 
	$type: new $.ig.Type('MeasureMetadata', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('RowMetadata', 'Object', {
	__levelKeyMemberValues: null
	, 
	__filterSourcesCount: 0
	, 
	init: function (dataItem) {



		$.ig.Object.prototype.init.call(this);
			this.__levelKeyMemberValues = new $.ig.Dictionary$2(String, $.ig.Number.prototype.$type, 0);
			this.__filterSourcesCount = 0;
			this.isExcluded(false);
			this.dataItem(dataItem);
	}

	, 
	addMemberValue: function (levelKey, memberId) {
		if (this.__levelKeyMemberValues.containsKey(levelKey)) {
			return;
		}

		this.__levelKeyMemberValues.item(levelKey, memberId);
	}

	, 
	getMemberId: function (levelKey) {
		var $self = this;
		var memberId;
		(function () { var $ret = $self.__levelKeyMemberValues.tryGetValue(levelKey, memberId); memberId = $ret.value; return $ret.ret; }());
		return memberId;
	}

	, 
	addFilterSource: function () {
		this.__filterSourcesCount++;
		this.isExcluded(true);
	}

	, 
	removeFilterSource: function () {
		this.__filterSourcesCount--;
		this.isExcluded(this.__filterSourcesCount > 0);
	}

	, 
	_dataItem: null,
	dataItem: function (value) {
		if (arguments.length === 1) {
			this._dataItem = value;
			return value;
		} else {
			return this._dataItem;
		}
	}

	, 
	_isExcluded: false,
	isExcluded: function (value) {
		if (arguments.length === 1) {
			this._isExcluded = value;
			return value;
		} else {
			return this._isExcluded;
		}
	}
	, 
	$type: new $.ig.Type('RowMetadata', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('TableMetadata', 'Object', {
	__levelKeys: null
	, 
	__dataRowsMetadata: null
	, 
	__dataRowsMetadataList: null
	, 
	__size: 0
	, 
	init: function (itemsSource) {



		$.ig.Object.prototype.init.call(this);
			var itemsCount = 0;
			var list = $.ig.util.cast($.ig.IList.prototype.$type, itemsSource);
			if (list != null) {
				itemsCount = list.count();

			} else {
				var en = itemsSource.getEnumerator();
				while (en.moveNext()) {
					var item = en.current();
					itemsCount++;
				}

			}

			this.__dataRowsMetadataList = new $.ig.List$1($.ig.RowMetadata.prototype.$type, 0);
			this.__dataRowsMetadata = new Array(itemsCount);
			var en1 = itemsSource.getEnumerator();
			while (en1.moveNext()) {
				var item1 = en1.current();
				var rowMetadata = new $.ig.RowMetadata(item1);
				this.addRowMetadata(rowMetadata);
				this.__dataRowsMetadataList.add(rowMetadata);
			}

			this.__levelKeys = new $.ig.List$1(String, 0);
	}

	, 
	rowsMetadataList: function () {

			return this.__dataRowsMetadataList;
	}

	, 
	rowsMetadata: function () {

			return this.__dataRowsMetadata;
	}

	, 
	rowsCount: function () {

			return this.__size;
	}

	, 
	addRowMetadata: function (rowMetadata) {
		if (this.__size == this.__dataRowsMetadata.length) {
			this.incereaseCapacity();
		}

		this.__dataRowsMetadata[this.__size++] = rowMetadata;
	}

	, 
	insert: function (index, rowMetadata) {
		if (this.__size == this.__dataRowsMetadata.length) {
			this.incereaseCapacity();
		}

		$.ig.Array.prototype.copy(this.__dataRowsMetadata, index, this.__dataRowsMetadata, index + 1, this.__size - index);
		this.__dataRowsMetadata[index] = rowMetadata;
		this.__size++;
	}

	, 
	removeAt: function (index) {
		var $self = this;
		$self.__size--;
		$.ig.Array.prototype.copy($self.__dataRowsMetadata, index + 1, $self.__dataRowsMetadata, index, $self.__size - index);
		(function () { var $ret = $.ig.Array.prototype.resize$1($.ig.RowMetadata.prototype.$type, $self.__dataRowsMetadata, $self.__size); $self.__dataRowsMetadata = $ret.array; return $ret.ret; }());
	}

	, 
	incereaseCapacity: function () {
		var newDataPropMetadata = new Array(this.__size + 1);
		$.ig.Array.prototype.copy(this.__dataRowsMetadata, 0, newDataPropMetadata, 0, this.__size);
		this.__dataRowsMetadata = newDataPropMetadata;
	}
	, 
	$type: new $.ig.Type('TableMetadata', $.ig.Object.prototype.$type)
}, true);

$.ig.util.defType('FlatDataSourceImpl', 'OlapDataSource', {
	__dataProvider: null

	, 
	dataProvider: function () {

			if (this.__dataProvider == null) {
				this.__dataProvider = this.dataProviderFactory().createDataProvider();
			}

			return this.__dataProvider;
	}
	, 
	init: function (options) {


		this.__axisProviders = new $.ig.List$1($.ig.FlatDataAxisProvider.prototype.$type, 0);

		$.ig.OlapDataSource.prototype.init.call(this, options);
			this.flatDataSourceOptions(options);
			this.dataProviderFactory(options.dataProviderFactory());
	}

	, 
	createOlapDataProviderFactory: function () {
		return new $.ig.DefaultFlatDataProviderFactory(this.flatDataSourceOptions().itemsSource(), this.flatDataSourceOptions().dataSourceMetadata());
	}

	, 
	_flatDataSourceOptions: null,
	flatDataSourceOptions: function (value) {
		if (arguments.length === 1) {
			this._flatDataSourceOptions = value;
			return value;
		} else {
			return this._flatDataSourceOptions;
		}
	}

	, 
	onInitialize: function () {
		var $self = this;
		var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		if ($self.isInitialized()) {
			tcs.setResult($self.metadataTree());
			return tcs.task();
		}

		($self.columnAxis()).collectionChanged = $.ig.Delegate.prototype.combine(($self.columnAxis()).collectionChanged, $self.columnsAxisChanged.runOn($self));
		($self.rowAxis()).collectionChanged = $.ig.Delegate.prototype.combine(($self.rowAxis()).collectionChanged, $self.rowsAxisChanged.runOn($self));
		($self.filters()).collectionChanged = $.ig.Delegate.prototype.combine(($self.filters()).collectionChanged, $self.filtersAxisChanged.runOn($self));
		($self.measures()).collectionChanged = $.ig.Delegate.prototype.combine(($self.measures()).collectionChanged, $self.measuresAxisChanged.runOn($self));
		return $self.loadCubes(null).continueWithTask$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) { return $self.onSetCube($self.cubes().first$1($.ig.Cube.prototype.$type).name()); }).continueWithTask$1($.ig.OlapMetadataTreeItem.prototype.$type, function (t) { return $self.initializeAxes(); });
	}

	, 
	cacheCubeMetaItems: function () {
		var $self = this;
		var provider = $self.dataProvider();
		var taskList = new $.ig.List$1($.ig.Task.prototype.$type, 0);
		taskList.add(provider.discoverDimensionsAsync(null, null));
		taskList.add(provider.discoverHierarchiesAsync(null, null));
		taskList.add(provider.discoverLevelsAsync(null, null));
		taskList.add(provider.discoverMeasuresAsync(null, null));
		taskList.add(provider.discoverKpisAsync(null, null));
		var tasks = new Array(taskList.count());
		taskList.copyTo(tasks, 0);
		var cubeCache = new $.ig.CubeMetaItemsCache();
		$self.cubeCache(cubeCache);
		var tf = new $.ig.TaskFactory();
		return tf.continueWhenAll(tasks, function (t) {
			var getDimensionsTask = t[0];
			var getHierarchiesTask = t[1];
			var getLevelsTask = t[2];
			var getMeasuresTask = t[3];
			var getKpiTask = t[4];
			cubeCache.measures(getMeasuresTask.result());
			cubeCache.dimensionItems(getDimensionsTask.result());
			cubeCache.hierarchyItems(getHierarchiesTask.result());
			cubeCache.levelItems(getLevelsTask.result());
			cubeCache.kpis(getKpiTask.result());
		});
	}

	, 
	updateAxisProvidersCache: function (hasColumns, hasRows) {
		var axisIndex = 0;
		var measureListIndex = this.measureListIndex();
		if (hasColumns) {
			var columnsAxisProvider = this.getAxisProvider1(axisIndex);
			if (columnsAxisProvider != null && this.measureListLocation() == $.ig.MeasureListLocation.prototype.columns) {
				if (measureListIndex > -1) {
					var rootPosition = columnsAxisProvider.positionResolver().rootPositionInfo();
					if (rootPosition != null) {
						this.removePositionsAtIndex(rootPosition, measureListIndex - 1);
					}

				}

			}

			axisIndex++;
		}

		if (hasRows) {
			var rowsAxisProvider = this.getAxisProvider1(axisIndex);
			if (rowsAxisProvider != null && this.measureListLocation() == $.ig.MeasureListLocation.prototype.rows) {
				if (measureListIndex > -1) {
					var rootPosition1 = rowsAxisProvider.positionResolver().rootPositionInfo();
					if (rootPosition1 != null) {
						this.removePositionsAtIndex(rootPosition1, measureListIndex - 1);
					}

				}

			}

		}

	}

	, 
	removePositionsAtIndex: function (hostPosition, maxValidIndex) {
		if (hostPosition.positionItemIndex() == maxValidIndex) {
			hostPosition.clear();

		} else {
			var en = hostPosition.values().getEnumerator();
			while (en.moveNext()) {
				var positionItemInfo = en.current();
				this.removePositionsAtIndex(positionItemInfo, maxValidIndex);
			}

		}

	}

	, 
	onUpdate: function () {
		var $self = this;
		var error = $self.verifyAreaItemsUniqueness();
		if (!String.isNullOrEmpty(error)) {
			var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
			tcs.setException(new $.ig.InvalidOperationException(1, error));
			return tcs.task();
		}

		var hasColumns = $self.columnAxis().count() > 0;
		var hasRows = $self.rowAxis().count() > 0;
		if (!hasRows && !hasColumns && $self.measures().count() == 0) {
			var result = (function () { var $ret = new $.ig.OlapResult();
			$ret.isEmpty(true); return $ret;}());
			var tcs1 = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
			tcs1.setResult(result);
			$self.resultView(new $.ig.OlapResultView(result, result, false, false));
			$self.result(result);
			$self.clearPendingChanges();
			return tcs1.task();
		}

		var hasColumnChanges = $self.isColumnsAxisChanged();
		var hasRowChanges = $self.isRowsAxisChanged();
		var hasMeasureChanges = $self.isMeasuresAxisChanged() || $self.isMeasureListIndexChanging();
		var hasFilterChanges = $self.isFiltersAxisChanged();
		var hasPositionsToExpand = $self.getPositionsToExpand().count() > 0;
		var hasPositionsToCollapse = $self.getPositionsToCollapse().count() > 0;
		var hasMembersSelectionChanged = $self._membersSelectionChangedList.count() > 0;
		if (!hasColumnChanges && !hasRowChanges && !hasMeasureChanges && !hasFilterChanges && !hasPositionsToExpand && !hasPositionsToCollapse && !hasMembersSelectionChanged) {
			var tcs2 = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
			tcs2.setResult($self.result());
			return tcs2.task();
		}

		if ($self.isMeasuresAxisChanged()) {
			$self.updateAxisProvidersCache(hasColumns, hasRows);
		}

		var columnAxisProvider = null;
		var rowAxisProvider = null;
		var axisIndex = 0;
		var axisName = "Axis0";
		var isColumnsAxisChanged = $self.isColumnsAxisChanged();
		if ($self.isMeasuresAxisChanged() && hasColumns && $self.measureListIndex() > -1 && $self.measureListLocation() == $.ig.MeasureListLocation.prototype.columns) {
			isColumnsAxisChanged = true;
		}

		columnAxisProvider = $self.getAxisProvider($self.columnAxis(), isColumnsAxisChanged, axisIndex);
		$self.isColumnsAxisChanged(false);
		if (columnAxisProvider != null) {
			axisIndex++;
			axisName = "Axis1";
		}

		var isRowsAxisChanged = $self.isRowsAxisChanged();
		if ($self.isMeasuresAxisChanged() && hasRows && $self.measureListIndex() > -1 && $self.measureListLocation() == $.ig.MeasureListLocation.prototype.rows) {
			isRowsAxisChanged = true;
		}

		rowAxisProvider = $self.getAxisProvider($self.rowAxis(), isRowsAxisChanged, axisIndex);
		$self.isRowsAxisChanged(false);
		if (rowAxisProvider != null) {
			if (rowAxisProvider.axis() != null) {
				rowAxisProvider.axis().name(axisName);
			}

			axisIndex++;
		}

		$self.isMeasuresAxisChanged(false);
		$self.isFiltersAxisChanged(false);
		var allAxisElements = new $.ig.List$1($.ig.AxisElement.prototype.$type, 0);
		var en = $self.columnFilters().getEnumerator();
		while (en.moveNext()) {
			var axisElement = en.current();
			allAxisElements.add(axisElement);
		}

		var en1 = $self.rowFilters().getEnumerator();
		while (en1.moveNext()) {
			var axisElement1 = en1.current();
			allAxisElements.add(axisElement1);
		}

		var en2 = $self.filterFilters().getEnumerator();
		while (en2.moveNext()) {
			var axisElement2 = en2.current();
			allAxisElements.add(axisElement2);
		}

		var resultTask = $self.getResult(allAxisElements, hasColumns, hasRows, hasPositionsToExpand, hasPositionsToCollapse, columnAxisProvider, rowAxisProvider);
		return resultTask;
	}

	, 
	getResult: function (axisElements, hasColumns, hasRows, hasPositionsToExpand, hasPositionsToCollapse, columnsProvider, rowsProvider) {
		var $self = this;
		if ($self._membersSelectionChangedList.count() > 0) {
			($self.dataProvider()).updateSelection(axisElements);
			var en = $self.__axisProviders.getEnumerator();
			while (en.moveNext()) {
				var axisProvider = en.current();
				axisProvider.resetAxisMetadata();
			}

			$self._membersSelectionChangedList.clear();
		}

		$self.expandTupleMembers(hasColumns, hasRows);
		$self.collapseTupleMembers(hasColumns, hasRows, true);
		if (hasPositionsToExpand || hasPositionsToCollapse) {
			var expandTask = null;
			if (hasColumns) {
				var positionsToExpand = $self.getPositionsToExpand();
				var columnPositions = positionsToExpand.where$1($.ig.PositionInfo.prototype.$type, function (pi) { return pi.axisName() == "Axis0"; }).toList$1($.ig.PositionInfo.prototype.$type);
				if (columnPositions.count() > 0) {
					var positionInfo = columnPositions.item(0);
					positionsToExpand.remove(positionInfo);
					var tuple = $self.result().axes().item(0).tuples().__inner[positionInfo.tupleIndex()];
					var axisMember = tuple.members().item(positionInfo.memberIndex());
					var partialColumnAxisProvider = new $.ig.FlatDataPartialAxisProvider($self.dataProvider(), $self.columnAxis(), axisMember, $self.cubeCache());
					var columnAxisTask = partialColumnAxisProvider.generateAxis("Axis0");
					expandTask = columnAxisTask.continueWithTask$1($.ig.OlapResult.prototype.$type, function (t) {
						var evaluateResult = ($self.dataProvider()).evaluateResult(partialColumnAxisProvider, rowsProvider, $self.measures());
						return evaluateResult;
					});
					expandTask = expandTask.continueWithTask$2($.ig.OlapResult.prototype.$type, $.ig.OlapResult.prototype.$type, function (t) {
						if ($self.getResultAxis("Axis0", t.result()).tuples().count() == 0) {
							axisMember.displayInfo(0);
						}

						var oldResultView = $self.resultView();
						$self.resultView($self.resultView().extend(t.result(), "Axis0"));
						$self.result($self.resultView().visibleResult());
						$.ig.ResultViewHelper.prototype.syncPositionExpansionState("Axis0", oldResultView, $self.resultView());
							$.ig.ResultViewHelper.prototype.setPositionIsExpaned2(positionInfo.axisName(), positionInfo.tupleIndex(), positionInfo.memberIndex(), true, $self.resultView());
						;
						columnsProvider.extendWith(partialColumnAxisProvider);
						columnsProvider.axis($self.getResultAxis("Axis0", $self.result()));
						var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
						tcs.setResult($self.resultView().visibleResult());
						$.ig.ResultViewHelper.prototype.setPositionIsExpaned(positionInfo.tupleIndex(), positionInfo.memberIndex(), true, columnsProvider.positionResolver());
						return tcs.task();
					});
				}

			}

			if (hasRows) {
				var expandAxisName = hasColumns ? "Axis1" : "Axis0";
				var positionsToExpand1 = $self.getPositionsToExpand();
				var rowPositions = positionsToExpand1.where$1($.ig.PositionInfo.prototype.$type, function (pi) { return pi.axisName() == expandAxisName; }).toList$1($.ig.PositionInfo.prototype.$type);
				if (hasPositionsToExpand && rowPositions.count() > 0) {
					var positionInfo1 = rowPositions.item(0);
					positionsToExpand1.remove(positionInfo1);
					var tuple1 = $self.result().axes().where$1($.ig.OlapResultAxis.prototype.$type, function (ax) { return ax.name() == expandAxisName; }).first$1($.ig.OlapResultAxis.prototype.$type).tuples().__inner[positionInfo1.tupleIndex()];
					var axisMember1 = tuple1.members().item(positionInfo1.memberIndex());
					var rowAxisTask;
					var partialRowAxisProvider = new $.ig.FlatDataPartialAxisProvider($self.dataProvider(), $self.rowAxis(), axisMember1, $self.cubeCache());
					if (expandTask != null) {
						rowAxisTask = expandTask.continueWithTask$1($.ig.OlapResultAxis.prototype.$type, function (t) { return partialRowAxisProvider.generateAxis(expandAxisName); });

					} else {
						rowAxisTask = partialRowAxisProvider.generateAxis(expandAxisName);
					}

					expandTask = rowAxisTask.continueWithTask$1($.ig.OlapResult.prototype.$type, function (t) {
						var evaluateResult = ($self.dataProvider()).evaluateResult(columnsProvider, partialRowAxisProvider, $self.measures());
						return evaluateResult;
					});
					expandTask = expandTask.continueWithTask$2($.ig.OlapResult.prototype.$type, $.ig.OlapResult.prototype.$type, function (t) {
						if ($self.resultView() == null) {
							$self.resultView(new $.ig.OlapResultView($self.result(), $self.result(), hasColumns, hasRows));
						}

						var axisName = $self.resultView().hasColumns() ? "Axis1" : "Axis0";
						if ($self.getResultAxis(axisName, t.result()).tuples().count() == 0) {
							axisMember1.displayInfo(0);
						}

						var oldResultView = $self.resultView();
						$self.resultView($self.resultView().extend(t.result(), axisName));
						$self.result($self.resultView().visibleResult());
						$.ig.ResultViewHelper.prototype.syncPositionExpansionState(axisName, oldResultView, $self.resultView());
							$.ig.ResultViewHelper.prototype.setPositionIsExpaned2(positionInfo1.axisName(), positionInfo1.tupleIndex(), positionInfo1.memberIndex(), true, $self.resultView());
						;
						var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
						tcs.setResult($self.resultView().visibleResult());
						rowsProvider.extendWith(partialRowAxisProvider);
						rowsProvider.axis($self.getResultAxis(axisName, $self.result()));
						$.ig.ResultViewHelper.prototype.setPositionIsExpaned(positionInfo1.tupleIndex(), positionInfo1.memberIndex(), true, rowsProvider.positionResolver());
						return tcs.task();
					});
				}

			}

			if (expandTask != null) {
				return expandTask;
			}

			var currentResultSource = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
			currentResultSource.setResult($self.result());
			return currentResultSource.task();

		} else {
			var tcs = new $.ig.TaskCompletionSource$1($.ig.OlapResult.prototype.$type, 0);
			if (columnsProvider == null && rowsProvider == null && $self.measures().count() == 0) {
				var result = (function () { var $ret = new $.ig.OlapResult();
				$ret.isEmpty(true); return $ret;}());
				$self.result(result);
				tcs.setResult($self.result());
				return tcs.task();
			}

			var evaluateResult = ($self.dataProvider()).evaluateResult(columnsProvider, rowsProvider, $self.measures());
			return evaluateResult.continueWithTask$2($.ig.OlapResult.prototype.$type, $.ig.OlapResult.prototype.$type, function (t) {
				$self.resultView(new $.ig.OlapResultView(t.result(), t.result(), hasColumns, hasRows));
				$self.result($self.resultView().visibleResult());
				$self.clearPendingChanges();
				tcs.setResult($self.result());
				return tcs.task();
			});
		}

	}

	, 
	verifyAreaItemsUniqueness: function () {
		var $self = this;
		var usedNames = new $.ig.Dictionary$2(String, String, 0);
		for (var i = 0; i < $self.columnAxis().count(); i++) {
			var coreOlapElement = $self.columnAxis().item(i);
			if ($.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement) !== null) {
				continue;
			}

			if (!usedNames.containsKey(coreOlapElement.uniqueName())) {
				usedNames.add(coreOlapElement.uniqueName(), "columns");

			} else {
				return "the " + coreOlapElement.uniqueName() + " hierarchy is used twice in columns";
			}

		}

		for (var i1 = 0; i1 < $self.rowAxis().count(); i1++) {
			var coreOlapElement1 = $self.rowAxis().item(i1);
			if ($.ig.util.cast($.ig.MeasureList.prototype.$type, coreOlapElement1) !== null) {
				continue;
			}

			if (!usedNames.containsKey(coreOlapElement1.uniqueName())) {
				usedNames.add(coreOlapElement1.uniqueName(), "rows");

			} else {
				return "the " + coreOlapElement1.uniqueName() + " hierarchy is used in rows and in columns";
			}

		}

		for (var i2 = 0; i2 < $self.filters().count(); i2++) {
			var coreOlapElement2 = $self.filters().item(i2);
			var area;
			if (!(function () { var $ret = usedNames.tryGetValue(coreOlapElement2.uniqueName(), area); area = $ret.value; return $ret.ret; }())) {
				usedNames.add(coreOlapElement2.uniqueName(), "filters");

			} else {
				return "the " + coreOlapElement2.uniqueName() + " hierarchy is used in filters and in " + area;
			}

		}

		for (var i3 = 0; i3 < $self.measures().count(); i3++) {
			var coreOlapElement3 = $self.measures().item(i3);
			var area1;
			if (!(function () { var $ret = usedNames.tryGetValue(coreOlapElement3.uniqueName(), area1); area1 = $ret.value; return $ret.ret; }())) {
				usedNames.add(coreOlapElement3.uniqueName(), "measures");

			} else {
				if (area1 == "measures") {
					return "the " + coreOlapElement3.uniqueName() + " measure is used twice in measures";
				}

				return "the " + coreOlapElement3.uniqueName() + " measure is used in measures and in " + area1;
			}

		}

		return null;
	}

	, 
	expandTupleMembers: function (hasColumns, hasRows) {
		var $self = this;
		var axisPositionsMap = new $.ig.Dictionary$2(String, $.ig.IList$1.prototype.$type.specialize($.ig.PositionInfo.prototype.$type), 0);
		var oldResultView = $self.resultView();
		var positionsToExpand = $self.getPositionsToExpand();
		for (var i = 0; i < positionsToExpand.count(); i++) {
			var positionInfo = positionsToExpand.item(i);
			var axisPositions;
			if (!(function () { var $ret = axisPositionsMap.tryGetValue(positionInfo.axisName(), axisPositions); axisPositions = $ret.value; return $ret.ret; }())) {
				axisPositions = new $.ig.List$1($.ig.PositionInfo.prototype.$type, 0);
				axisPositionsMap.add(positionInfo.axisName(), axisPositions);
			}

			if ($self.resultView() == null) {
				$self.resultView(new $.ig.OlapResultView($self.result(), $self.result(), hasColumns, hasRows));
			}

			var resolvedCache = $self.resultView().expandTupleMember(positionInfo.axisName(), positionInfo.tupleIndex(), positionInfo.memberIndex());
			if (resolvedCache != null) {
				axisPositions.add(positionInfo);
				$self.resultView(resolvedCache);
				$self.result($self.resultView().visibleResult());
			}

		}

		var en = axisPositionsMap.getEnumerator();
		while (en.moveNext()) {
			var keyValuePair = en.current();
			var en1 = keyValuePair.value().getEnumerator();
			while (en1.moveNext()) {
				var positionInfo1 = en1.current();
				positionsToExpand.remove(positionInfo1);
			}

		}

		var axisIndex = 0;
		var axisName = "Axis0";
		if (hasColumns) {
			var hasToExpandAxis0 = axisPositionsMap.keys().where$1(String, function (k) { return k == axisName; }).firstOrDefault$1(String) != null;
			var columnsAxisProvider = $self.getAxisProvider1(axisIndex);
			if (columnsAxisProvider != null && hasToExpandAxis0) {
				var columnPositions = axisPositionsMap.item(axisName);
				if (columnPositions.count() > 0) {
					$.ig.ResultViewHelper.prototype.syncPositionExpansionState(axisName, oldResultView, $self.resultView());
					var en2 = columnPositions.getEnumerator();
					while (en2.moveNext()) {
						var columnPositionInfo = en2.current();
						$.ig.ResultViewHelper.prototype.setPositionIsExpaned2(axisName, columnPositionInfo.tupleIndex(), columnPositionInfo.memberIndex(), true, $self.resultView());
						$.ig.ResultViewHelper.prototype.setPositionIsExpaned(columnPositionInfo.tupleIndex(), columnPositionInfo.memberIndex(), true, columnsAxisProvider.positionResolver());
					}

					var columnAxis = $self.getResultAxis(axisName, $self.result());
					columnsAxisProvider.axis(columnAxis);
					$.ig.ResultViewHelper.prototype.setExpansionStates1(columnAxis.positionResolver(), columnsAxisProvider.positionResolver());
				}

			}

			axisIndex++;
			axisName = "Axis1";
		}

		if (hasRows) {
			var hasToExpandAxis1 = axisPositionsMap.keys().where$1(String, function (k) { return k == axisName; }).firstOrDefault$1(String) != null;
			var rowsAxisProvider = $self.getAxisProvider1(axisIndex);
			if (rowsAxisProvider != null && hasToExpandAxis1) {
				var rowPositions = axisPositionsMap.item(axisName);
				if (rowPositions.count() > 0) {
					$.ig.ResultViewHelper.prototype.syncPositionExpansionState(axisName, oldResultView, $self.resultView());
					var en3 = rowPositions.getEnumerator();
					while (en3.moveNext()) {
						var rowPositionInfo = en3.current();
						$.ig.ResultViewHelper.prototype.setPositionIsExpaned2(axisName, rowPositionInfo.tupleIndex(), rowPositionInfo.memberIndex(), true, $self.resultView());
						$.ig.ResultViewHelper.prototype.setPositionIsExpaned(rowPositionInfo.tupleIndex(), rowPositionInfo.memberIndex(), true, rowsAxisProvider.positionResolver());
					}

					var rowAxis = $self.getResultAxis(axisName, $self.result());
					rowsAxisProvider.axis(rowAxis);
					$.ig.ResultViewHelper.prototype.setExpansionStates1(rowAxis.positionResolver(), rowsAxisProvider.positionResolver());
				}

			}

		}

		return positionsToExpand.count() > 0;
	}

	, 
	collapseTupleMembers: function (hasColumns, hasRows, useResultViewCahce) {
		var $self = this;
		if ($self.result() != null) {
			var positionsToCollapse = $self.getPositionsToCollapse();
			var axisPositionsMap = new $.ig.Dictionary$2(String, $.ig.IList$1.prototype.$type.specialize($.ig.PositionInfo.prototype.$type), 0);
			var oldResultView = $self.resultView();
			for (var i = 0; i < positionsToCollapse.count(); i++) {
				var positionInfo = positionsToCollapse.item(i);
				var axisPositions;
				if (!(function () { var $ret = axisPositionsMap.tryGetValue(positionInfo.axisName(), axisPositions); axisPositions = $ret.value; return $ret.ret; }())) {
					axisPositions = new $.ig.List$1($.ig.PositionInfo.prototype.$type, 0);
					axisPositionsMap.add(positionInfo.axisName(), axisPositions);
				}

				axisPositions.add(positionInfo);
				if (useResultViewCahce) {
					if ($self.resultView() == null) {
						$self.resultView(new $.ig.OlapResultView($self.result(), $self.result(), hasColumns, hasRows));

					} else {
						$self.resultView($self.resultView().collapseTupleMember(positionInfo.axisName(), positionInfo.tupleIndex(), positionInfo.memberIndex()));
						$self.result($self.resultView().visibleResult());
					}

				}

			}

			var axisIndex = 0;
			var axisName = "Axis0";
			if (hasColumns) {
				var hasToCollapseAxis0 = axisPositionsMap.keys().where$1(String, function (k) { return k == axisName; }).firstOrDefault$1(String) != null;
				var columnsAxisProvider = $self.getAxisProvider1(axisIndex);
				if (columnsAxisProvider != null && hasToCollapseAxis0) {
					var columnPositions = axisPositionsMap.item(axisName);
					if (columnPositions.count() > 0) {
						$.ig.ResultViewHelper.prototype.syncPositionExpansionState(axisName, oldResultView, $self.resultView());
						var en = columnPositions.getEnumerator();
						while (en.moveNext()) {
							var columnPositionInfo = en.current();
							$.ig.ResultViewHelper.prototype.setPositionIsExpaned(columnPositionInfo.tupleIndex(), columnPositionInfo.memberIndex(), false, columnsAxisProvider.positionResolver());
						}

						var columnAxis = $self.getResultAxis(axisName, $self.result());
						columnsAxisProvider.axis(columnAxis);
					}

				}

				axisIndex++;
				axisName = "Axis1";
			}

			if (hasRows) {
				var hasToCollpaseAxis1 = axisPositionsMap.keys().where$1(String, function (k) { return k == axisName; }).firstOrDefault$1(String) != null;
				var rowsAxisProvider = $self.getAxisProvider1(axisIndex);
				if (rowsAxisProvider != null && hasToCollpaseAxis1) {
					var rowPositions = axisPositionsMap.item(axisName);
					if (rowPositions.count() > 0) {
						$.ig.ResultViewHelper.prototype.syncPositionExpansionState(axisName, oldResultView, $self.resultView());
						var en1 = rowPositions.getEnumerator();
						while (en1.moveNext()) {
							var rowPositionInfo = en1.current();
							$.ig.ResultViewHelper.prototype.setPositionIsExpaned(rowPositionInfo.tupleIndex(), rowPositionInfo.memberIndex(), false, rowsAxisProvider.positionResolver());
						}

						var rowAxis = $self.getResultAxis(axisName, $self.result());
						rowsAxisProvider.axis(rowAxis);
					}

				}

			}

			positionsToCollapse.clear();
		}

	}

	, 
	getAxisProvider: function (axisToUpdate, axisChanged, axisIndex) {
		var axisProvider = null;
		if (axisToUpdate.count() > 0) {
			axisProvider = this.getAxisProvider1(axisIndex);
			if (axisChanged) {
				if (axisProvider != null) {
					axisProvider.resetAxis(axisToUpdate);

				} else {
					axisProvider = new $.ig.FlatDataAxisProvider(this.dataProvider(), axisToUpdate, this.cubeCache());
					this.setAxisProvider(axisIndex, axisProvider);
				}

			}

		}

		return axisProvider;
	}

	, 
	setAxisProvider: function (axisIndex, mdxAxis) {
		this.__axisProviders.item(axisIndex, mdxAxis);
	}

	, 
	getAxisProvider1: function (axisIndex) {
		if (axisIndex < this.__axisProviders.count()) {
			return this.__axisProviders.item(axisIndex);
		}

		return null;
	}

	, 
	getMembersOfLevel: function (levelUniqueName) {
		var $self = this;
		var restrictions = new $.ig.List$1($.ig.KeyValueItem.prototype.$type, 0);
		var levelName = levelUniqueName;
		restrictions.add((function () { var $ret = new $.ig.KeyValueItem();
		$ret.key("LEVEL_UNIQUE_NAME");
		$ret.value(levelUniqueName); return $ret;}()));
		var getMembersTask = $self.dataProvider().discoverMembersAsync(null, restrictions);
		getMembersTask.continueWith1(function (t) {
			var en = t.result().getEnumerator();
			while (en.moveNext()) {
				var member = en.current();
				$self.cubeCache().addMember(member);
			}

			$self.cubeCache().setIsLevelLoaded(levelName);
		});
		return getMembersTask;
	}

	, 
	getMembersOfHierarchy: function (hierarchyUniqueName) {
		var $self = this;
		var hierarchyName = hierarchyUniqueName;
		var nameParser = new $.ig.CoreOlapElementParser(hierarchyUniqueName);
		var nameParts = nameParser.getPartNames();
		if (nameParts.count() < 2) {
			throw new $.ig.ArgumentException(1, "Specified value: " + hierarchyUniqueName + " is not valid.", hierarchyUniqueName);
		}

		var restriction = new $.ig.KeyValueItem();
		restriction.key("HIERARCHY_UNIQUE_NAME");
		restriction.value(nameParts.item(0) + "." + nameParts.item(1));
		var restrictions = new $.ig.List$1($.ig.KeyValueItem.prototype.$type, 0);
		restrictions.add(restriction);
		var getMembersTask = $self.dataProvider().discoverMembersAsync(null, restrictions);
		getMembersTask.continueWith1(function (t) {
			var en = t.result().getEnumerator();
			while (en.moveNext()) {
				var member = en.current();
				$self.cubeCache().addMember(member);
			}

			$self.cubeCache().setIsHierarchyLoaded(hierarchyName);
		});
		return getMembersTask;
	}

	, 
	getMembersOfMember: function (memberUniqueName) {
		var $self = this;
		var nameParser = new $.ig.CoreOlapElementParser(memberUniqueName);
		var nameParts = nameParser.getPartNames();
		var restriction = new $.ig.KeyValueItem();
		if (nameParts.count() < 3) {
			throw new $.ig.ArgumentException(1, "Specified value: " + memberUniqueName + " is not valid.", memberUniqueName);
		}

		switch (nameParts.count()) {
			case 1:
				restriction.key("DIMENSION_UNIQUE_NAME");
				restriction.value(nameParts.item(0));
				break;
			case 2:
				restriction.key("HIERARCHY_UNIQUE_NAME");
				restriction.value(nameParts.item(0) + "." + nameParts.item(1));
				break;
			default:
				restriction.key("LEVEL_UNIQUE_NAME");
				restriction.value(nameParts.item(0) + "." + nameParts.item(1) + "." + nameParts.item(2));
				break;
		}

		var restrictions = new $.ig.List$1($.ig.KeyValueItem.prototype.$type, 0);
		restrictions.add(restriction);
		restrictions.add((function () { var $ret = new $.ig.KeyValueItem();
		$ret.key("MEMBER_UNIQUE_NAME");
		$ret.value(memberUniqueName); return $ret;}()));
		var getMembersTask = $self.dataProvider().discoverMembersAsync(null, restrictions);
		getMembersTask.continueWith1(function (t) {
			var en = t.result().getEnumerator();
			while (en.moveNext()) {
				var member = en.current();
				$self.cubeCache().addMember(member);
			}

		});
		return getMembersTask;
	}

	, 
	columnsAxisChanged: function (sender, e) {
		this.isColumnsAxisChanged(true);
		this.updateAxisProvidersList(0, this.columnAxis(), this.rowAxis());
		this.updateAxisState(e, this.columnFilters());
		this.updateMeasureListIndex(e, this.columnAxis());
		if (e.action() != $.ig.NotifyCollectionChangedAction.prototype.reset && this.columnAxis() != null) {
			var validToIndex = Math.max(e.newStartingIndex(), e.oldStartingIndex());
			this.updateExpandCollapseCache("Axis0", validToIndex);
		}

	}

	, 
	rowsAxisChanged: function (sender, e) {
		this.isRowsAxisChanged(true);
		this.updateAxisProvidersList(1, this.rowAxis(), this.columnAxis());
		this.updateAxisState(e, this.rowFilters());
		this.updateMeasureListIndex(e, this.rowAxis());
		if (e.action() != $.ig.NotifyCollectionChangedAction.prototype.reset && this.rowAxis() != null) {
			var axisName = this.columnAxis() == null ? "Axis0" : "Axis1";
			var validToIndex = Math.max(e.newStartingIndex(), e.oldStartingIndex());
			this.updateExpandCollapseCache(axisName, validToIndex);
		}

	}
	, 
	__axisProviders: null

	, 
	updateAxisProvidersList: function (mdxAxisIndex, axisToManage, opositeAxisToManage) {
		if (axisToManage.count() > 0) {
			if (opositeAxisToManage.count() > 0) {
				if (this.__axisProviders.count() < 2) {
					this.__axisProviders.insert(mdxAxisIndex, null);
				}


			} else {
				if (this.__axisProviders.count() == 0) {
					this.__axisProviders.insert(0, null);
				}

			}


		} else {
			if (this.__axisProviders.count() > 0) {
				if (this.__axisProviders.count() > 1) {
					this.__axisProviders.removeAt(mdxAxisIndex);

				} else {
					this.__axisProviders.removeAt(0);
				}

			}

		}

	}

	, 
	updateExpandCollapseCache: function (axisName, validToIndex) {
		var positionsToExpand = this.getPositionsToExpand();
		var positionsToCollapse = this.getPositionsToCollapse();
		for (var i = positionsToCollapse.count() - 1; i >= 0; i--) {
			var positionInfo = positionsToCollapse.item(i);
			if (positionInfo.axisName() == axisName && positionInfo.memberIndex() >= validToIndex) {
				positionsToCollapse.removeAt(i);
			}

		}

		for (var i1 = positionsToExpand.count() - 1; i1 >= 0; i1--) {
			var positionInfo1 = positionsToExpand.item(i1);
			if (positionInfo1.axisName() == axisName && positionInfo1.memberIndex() >= validToIndex) {
				positionsToExpand.removeAt(i1);
			}

		}

	}

	, 
	filtersAxisChanged: function (sender, e) {
		this.isFiltersAxisChanged(true);
		this.updateAxisState(e, this.filterFilters());
	}

	, 
	measuresAxisChanged: function (sender, e) {
		this.isMeasuresAxisChanged(true);
		this.updateMeasureList();
	}
	, 
	$type: new $.ig.Type('FlatDataSourceImpl', $.ig.OlapDataSource.prototype.$type)
}, true);

$.ig.util.defType('IFlatDataProviderFactory', 'Object', {
	$type: new $.ig.Type('IFlatDataProviderFactory', null, [$.ig.IOlapDataProviderFactory.prototype.$type])
}, true);

$.ig.util.defType('DefaultFlatDataProviderFactory', 'Object', {
	__itemsSource: null
	, 
	__sourceMetadata: null
	, 
	init: function (itemsSource, sourceMetadata) {



		$.ig.Object.prototype.init.call(this);
			this.__itemsSource = itemsSource;
			this.__sourceMetadata = sourceMetadata;
	}

	, 
	createDataProvider: function () {
		return new $.ig.FlatDataProvider(this.__itemsSource, this.__sourceMetadata);
	}
	, 
	$type: new $.ig.Type('DefaultFlatDataProviderFactory', $.ig.Object.prototype.$type, [$.ig.IFlatDataProviderFactory.prototype.$type])
}, true);

$.ig.util.defType('FlatDataSourceOptions', 'DataSourceBaseOptions', {
	init: function () {

		$.ig.DataSourceBaseOptions.prototype.init.call(this);

	}
	, 
	_itemsSource: null,
	itemsSource: function (value) {
		if (arguments.length === 1) {
			this._itemsSource = value;
			return value;
		} else {
			return this._itemsSource;
		}
	}

	, 
	_dataSourceMetadata: null,
	dataSourceMetadata: function (value) {
		if (arguments.length === 1) {
			this._dataSourceMetadata = value;
			return value;
		} else {
			return this._dataSourceMetadata;
		}
	}

	, 
	_dataProviderFactory: null,
	dataProviderFactory: function (value) {
		if (arguments.length === 1) {
			this._dataProviderFactory = value;
			return value;
		} else {
			return this._dataProviderFactory;
		}
	}
	, 
	$type: new $.ig.Type('FlatDataSourceOptions', $.ig.DataSourceBaseOptions.prototype.$type)
}, true);

$.ig.util.defType('OlapFlatDataSource', 'DataSourceBase', {
	__options: null
	, 
	init: function (options) {


		this.__options = null;
		this.__isInitPending = false;

		$.ig.DataSourceBase.prototype.init.call(this);
			if (options == null) {
				throw new $.ig.ArgumentNullException("options");
			}

			this.__options = options;
			this.dataBind(this.__options);
	}

	, 
	resolveDataSourceMetadata: function (options) {
		var metadataObject = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(options, "metadata");
		if (metadataObject == null) {
			throw new $.ig.InvalidOperationException(1, "metadata is null or undefined.");
		}

		var dataSourceMetadata = new $.ig.DataSourceMetadata();
		var cubeMetadata = this.resolveCubeMetadata(metadataObject);
		dataSourceMetadata.cubeMetadata(cubeMetadata);
		return dataSourceMetadata;
	}

	, 
	resolveCubeMetadata: function (metadata) {
		var cubeObject = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(metadata, "cube");
		if (cubeObject == null) {
			throw new $.ig.InvalidOperationException(1, "metadata.cube is null or undefined.");
		}

		var cubeMetadata = new $.ig.CubeMetadata();
		cubeMetadata.name($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(cubeObject, "name"));
		if (String.isNullOrEmpty(cubeMetadata.name())) {
			throw new $.ig.InvalidOperationException(1, "cube.name is null, empty or undefined");
		}

		cubeMetadata.caption($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(cubeObject, "caption"));
		if (String.isNullOrEmpty(cubeMetadata.caption())) {
			cubeMetadata.caption(cubeMetadata.name());
		}

		cubeMetadata.measuresDimensionMetadata(this.resolveMeasuresDimensionMetadata(cubeObject));
		cubeMetadata.description($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(cubeObject, "description"));
		cubeMetadata.dimensionsMetadata(this.resolveDimensionsMetadata(cubeObject));
		return cubeMetadata;
	}

	, 
	resolveMeasuresDimensionMetadata: function (cube) {
		var $self = this;
		var measuresDimensionObject = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(cube, "measuresDimension");
		if (measuresDimensionObject == null) {
			return null;
		}

		var measuresDimensionCaption = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(measuresDimensionObject, "caption");
		var measuresDimensionName = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(measuresDimensionObject, "name");
		var metadata = (function () { var $ret = new $.ig.MeasuresDimensionMetadata();
		$ret.caption(measuresDimensionCaption);
		$ret.name(measuresDimensionName); return $ret;}());
		metadata.measuresMetadata($self.resolveMeasuresMetadata(measuresDimensionObject));
		return metadata;
	}

	, 
	resolveDimensionsMetadata: function (cube) {
		var dimensionsArray = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(cube, "dimensions");
		if (dimensionsArray == null) {
			return null;
		}

		var dimensionsMetadata = new $.ig.ArrayListCollection$1($.ig.DimensionMetadata.prototype.$type);
		for (var i = 0; i < dimensionsArray.length; i++) {
			var dimensionMetadata = new $.ig.DimensionMetadata();
			dimensionsMetadata.add(dimensionMetadata);
			var dimensionObject = dimensionsArray[i];
			dimensionMetadata.name($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(dimensionObject, "name"));
			if (String.isNullOrEmpty(dimensionMetadata.name())) {
				throw new $.ig.InvalidOperationException(1, "dimension.name is null, empty or undefined");
			}

			dimensionMetadata.caption($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(dimensionObject, "caption"));
			if (String.isNullOrEmpty(dimensionMetadata.caption())) {
				dimensionMetadata.caption(dimensionMetadata.name());
			}

			dimensionMetadata.defaultHierarchy($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(dimensionObject, "defaultHierarchy"));
			dimensionMetadata.hierarchiesMetadata(this.resolveHierarchiesMetadata(dimensionObject));
			dimensionMetadata.description($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(dimensionObject, "description"));
		}

		return dimensionsMetadata;
	}

	, 
	resolveMeasuresMetadata: function (measuresDimension) {
		var measuresArray = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(measuresDimension, "measures");
		if (measuresArray == null) {
			return null;
		}

		var measuresMetadata = new $.ig.ArrayListCollection$1($.ig.MeasureMetadata.prototype.$type);
		for (var i = 0; i < measuresArray.length; i++) {
			var measureMetadata = new $.ig.MeasureMetadata();
			measuresMetadata.add(measureMetadata);
			var measureObject = measuresArray[i];
			measureMetadata.measureName($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(measureObject, "name"));
			if (String.isNullOrEmpty(measureMetadata.measureName())) {
				throw new $.ig.InvalidOperationException(1, "measure.name is null, empty or undefined");
			}

			measureMetadata.measureCaption($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(measureObject, "caption"));
			if (String.isNullOrEmpty(measureMetadata.measureCaption())) {
				measureMetadata.measureCaption(measureMetadata.measureName());
			}

			measureMetadata.displayFormat($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(measureObject, "displayFormat"));
			measureMetadata.displayFolder($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(measureObject, "displayFolder"));
			measureMetadata.aggregator($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(measureObject, "aggregator"));
			if (measureMetadata.aggregator() == null) {
				throw new $.ig.InvalidOperationException(1, "aggregator is null or undefined for measureMetadata: " + measureMetadata.measureName());
			}

		}

		return measuresMetadata;
	}

	, 
	resolveHierarchiesMetadata: function (dimension) {
		var hierarchiesArray = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(dimension, "hierarchies");
		if (hierarchiesArray == null) {
			return null;
		}

		var hierarchiesMetadata = new $.ig.ArrayListCollection$1($.ig.HierarchyMetadata.prototype.$type);
		for (var i = 0; i < hierarchiesArray.length; i++) {
			var hierarchyMetadata = new $.ig.HierarchyMetadata();
			hierarchiesMetadata.add(hierarchyMetadata);
			var hierarchyObject = hierarchiesArray[i];
			hierarchyMetadata.name($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(hierarchyObject, "name"));
			if (String.isNullOrEmpty(hierarchyMetadata.name())) {
				throw new $.ig.InvalidOperationException(1, "hierarchy.hierarchyName is null, empty or undefined");
			}

			hierarchyMetadata.caption($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(hierarchyObject, "caption"));
			if (String.isNullOrEmpty(hierarchyMetadata.caption())) {
				hierarchyMetadata.caption(hierarchyMetadata.name());
			}

			hierarchyMetadata.displayFolder($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(hierarchyObject, "displayFolder"));
			hierarchyMetadata.levelsMetadata(this.resolveLevelsMetadata(hierarchyObject));
			if (hierarchyMetadata.levelsMetadata() == null || hierarchyMetadata.levelsMetadata().count() == 0) {
				throw new $.ig.InvalidOperationException(1, "levelKeys is null, empty or undefined for hierarchyMetadata: " + hierarchyMetadata.name());
			}

		}

		return hierarchiesMetadata;
	}

	, 
	resolveLevelsMetadata: function (hierarchy) {
		var levelsArray = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty(hierarchy, "levels");
		if (levelsArray == null) {
			return null;
		}

		var levelsMetadata = new $.ig.ArrayListCollection$1($.ig.LevelMetadata.prototype.$type);
		for (var i = 0; i < levelsArray.length; i++) {
			var levelMetadata = new $.ig.LevelMetadata();
			levelsMetadata.add(levelMetadata);
			var levelObject = levelsArray[i];
			levelMetadata.name($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(levelObject, "name"));
			if (String.isNullOrEmpty(levelMetadata.name())) {
				throw new $.ig.InvalidOperationException(1, "level.name is null, empty or undefined");
			}

			levelMetadata.caption($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(levelObject, "caption"));
			if (String.isNullOrEmpty(levelMetadata.caption())) {
				levelMetadata.caption(levelMetadata.name());
			}

			levelMetadata.memberProvider($.ig.jQueryUtils.prototype.getJavascriptObjectProperty(levelObject, "memberProvider"));
			if (levelMetadata.memberProvider() == null) {
				throw new $.ig.InvalidOperationException(1, "levelMetadata.memberProvider is null or undefined");
			}

		}

		return levelsMetadata;
	}

	, 
	dataBind: function (options) {
		var options_ = options;
		var schema_ = this.initDataSourceSchema(options);
		
var dataSource = options_.dataSource;
if (!options_.dataSource && options_.dataSourceUrl) {
     options_.dataSource = options_.dataSourceUrl;
}

var dataOptions = {
    callback: this.dataSourceDataResolved,
    callee: this,
    dataSource: options_.dataSource,
    defaultChildrenDataProperty: options_.bindings.childDataProperty,
    responseDataType: options_.responseDataType,
    localSchemaTransform: options_.dataSourceType && options_.dataSourceType === 'xml' ? true : false,
    schema: schema_
}

if (options_.dataSourceType) {
	dataOptions.type = options_.dataSourceType;
}

// K.D. September 20th, 2012 Bug #121861 The responseDataKey needs to be set in the data source
if (options_.responseDataKey) {
	dataOptions.responseDataKey = options_.responseDataKey;
}

if (!(options_.dataSource instanceof $.ig.DataSource)) {
	options_.dataSource = new $.ig.DataSource(dataOptions);
}

options_.dataSource.dataBind(this.dataSourceDataResolved, this);
	}

	, 
	dataSourceDataResolved: function () {
		var $self = this;
		var dataSource = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty($self.__options, "dataSource");
		if (dataSource == null) {
			throw new $.ig.InvalidOperationException(1, "dataSource is null or undefined");
		}

		var dataSourceMetadata = $self.resolveDataSourceMetadata($self.__options);
		var measures = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty($self.__options, "measures");
		var filters = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty($self.__options, "filters");
		var columns = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty($self.__options, "columns");
		var rows = $.ig.jQueryUtils.prototype.getJavascriptObjectProperty($self.__options, "rows");
		var itemsSource = $.ig.jQueryUtils.prototype.getJavascriptObjectMethodResult(dataSource, "data");
		var dataSourceOptions = (function () { var $ret = new $.ig.FlatDataSourceOptions();
		$ret.measures(measures);
		$ret.filters(filters);
		$ret.columns(columns);
		$ret.rows(rows);
		$ret.itemsSource(itemsSource);
		$ret.dataSourceMetadata(dataSourceMetadata); return $ret;}());
		$self.dataSource(new $.ig.FlatDataSourceImpl(dataSourceOptions));
		$self.initDataSource();
	}

	, 
	initDataSource: function () {
		var $self = this;
		if ($self.__isInitPending) {
			$self.__isInitPending = false;
			var task = $self.dataSource().initialize();
			var promise_ = task.promise();
			task.continueWith1(function (t) { return $self.__dataSourceCreated.setResult(t.result()); });
			
var $this = this;
if (!this._isInitializedAttached) {
    this._isInitializedAttached = true;
    promise_.always(function (result) {
        var args = {
            error: null,
            metadataTreeRoot: null
        };

        if (this.state() === 'rejected') {
            args.error = result;
        } else {
            args.metadataTreeRoot = result;
        }

        $($this).trigger('initialized', args);
        $this._isInitializedAttached = false;
    });
}
;
		}

	}
	, 
	__isInitPending: false
	, 
	__dataSourceCreated: null

	, 
	initialize: function () {
		if (this.dataSource() != null) {
			return $.ig.DataSourceBase.prototype.initialize.call(this);
		}

		this.__isInitPending = true;
		this.__dataSourceCreated = new $.ig.TaskCompletionSource$1($.ig.OlapMetadataTreeItem.prototype.$type, 0);
		return this.__dataSourceCreated.deferred().promise();
	}

	, 
	initDataSourceSchema: function (options) {
		var options_ = options;
		var schema_ = null;
		
var schema = {}, opt = options_, bindings = options_.bindings;

if (bindings == null) {
	opt.bindings = {};
	schema.text = { name: 'Text', type: 'string' };
	opt.bindings.textKey = 'Text';
	schema.value = { name: 'Value', type: 'string' };
	opt.bindings.valueKey = 'Value';
	schema.imageUrl = { name: 'ImageUrl', type: 'string' };
	opt.bindings.imageUrlKey = 'ImageUrl';
	schema.navigateUrl = { name: 'NavigateUrl', type: 'string' };
	opt.bindings.navigateUrlKey = 'NavigateUrl';
	schema.childData = { name: 'Nodes', type: 'object' };
	opt.bindings.childDataProperty = 'Nodes';
	schema.target = { name: 'Target', type: 'string' };
	opt.bindings.targetKey = 'Target';
	bindings = opt.bindings;
} else if (opt.dataSourceType === 'xml') {
	if (bindings.searchFieldXPath) {
		schema.searchField = bindings.searchFieldXPath;
	}
}

schema.fields = [];
if (bindings.textKey) {
	schema.fields.push({ name: bindings.textKey, type: 'string', xpath: bindings.textXPath });
	schema.textKey = bindings.textKey;
}
if (bindings.valueKey) {
	schema.fields.push({ name: bindings.valueKey, type: 'string', xpath: bindings.valueXPath });
	schema.valueKey = bindings.valueKey;
}
if (bindings.navigateUrlKey) {
	schema.fields.push({ name: bindings.navigateUrlKey, type: 'string', xpath: bindings.navigateUrlXPath });
	schema.navigateUrlKey = bindings.navigateUrlKey;
}
if (bindings.imageUrlKey) {
	schema.fields.push({ name: bindings.imageUrlKey, type: 'string', xpath: bindings.imageUrlXPath });
	schema.imageUrlKey = bindings.imageUrlKey;
}
if (bindings.targetKey) {
	schema.fields.push({ name: bindings.targetKey, type: 'string' });
	schema.targetKey = bindings.targetKey;
}
if (bindings.expandedKey) {
	schema.fields.push({ name: 'Expanded', type: 'boolean' });
	schema.expandedKey = bindings.expandedKey;
}
if (bindings.primaryKey) {
	schema.fields.push({ name: bindings.primaryKey, type: 'string' });
	schema.primaryKey = bindings.primaryKey;
}
if (bindings.childDataProperty) {
	schema.fields.push({ name: bindings.childDataProperty, type: 'object', xpath: bindings.childDataXPath });
	schema.childDataProperty = bindings.childDataProperty;
}
// K.D. March 30th, 2012 Bug #106890 When the data source type is remoteUrl and responseDataKey is set, then searchField in the
// schema needs to be set to be the responseDataKey
if (!schema.searchField && opt.responseDataKey) {
	schema.searchField = opt.responseDataKey;
}
schema_ = schema;
		return schema_;
	}
	, 
	$type: new $.ig.Type('OlapFlatDataSource', $.ig.DataSourceBase.prototype.$type)
}, true);



$.ig.FlatDataProvider.prototype.defaultMeasureGroup = "(All)";


$.ig.util.extCopy($.ig.TaskExtensions, [[[$.ig.Task, $.ig.Task$1], ['continueWithTask$1', 'continueWithTask$2']]]);
$.ig.util.extCopy($.ig.Queryable, [[[$.ig.SortedList$1, $.ig.IGrouping$2], ['asQueryable']]]);
$.ig.util.extCopy($.ig.Enumerable, [[[$.ig.SortedList$1, $.ig.IGrouping$2], ['where$1', 'where$11', 'select$2', 'selectMany$2', 'last$1', 'first$1', 'firstOrDefault$1', 'orderBy$2', 'orderByDescending$2', 'toList$1', 'concat$1', 'max', 'max$1', 'min', 'min$1', 'count$1', 'reverse$1', 'take$1', 'skip$1', 'any$1', 'contains$1', 'union$1', 'toArray$1', 'elementAt$1', 'sum', 'sum$1']], [[$.ig.SortedList$1, $.ig.IGrouping$2], ['ofType$1', 'cast$1']]]);

} (jQuery));


/*!@license
* Infragistics.Web.ClientUI Pivot Shared 14.1.20141.2249
*
* Copyright (c) 2011-2012 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends on: 
*   jquery-1.4.4.js
*   jquery.ui.core.js
*   jquery.ui.widget.js
*   jquery.ui.draggable.js
*   jquery.ui.droppable.js
*   infragistics.util.js
*   infragistics.datasource.js
*   infragistics.olapxmladatasource.js
*   infragistics.olapflatdatasource.js
*   infragistics.templating.js
*   infragistics.ui.shared.js
*   infragistics.ui.scroll.js
*   infragistics.ui.tree.js
*/
/*global jQuery, Modernizr */
(function ($) {
    var _aNull = function (val) { return val === null || val === undefined; },
        _draggable = $.ui.draggable.prototype.widgetFullName || $.ui.draggable.prototype.widgetName,
        _tree = $.ui.igTree.prototype.widgetFullName || $.ui.igTree.prototype.widgetName;

    $.ig = $.ig || {};
    $.ig.Pivot = $.ig.Pivot || {};
    $.ig.Pivot._pivotShared = $.ig.Pivot._pivotShared || {
        _isInstance: function (object, typeName) {
            return (typeName !== undefined && !_aNull(object) && object.$type && object.$type.name === typeName);
        },
        _const: {
            index: 0,
            dragCursorAt: {
                top: -10,
                left: 10
            },
            dragHelperMarkup: "<div class='ui-widget ui-corner-all ui-igpivot-draghelper'><p><span></span><strong>{0}</strong></p></div>",
            touchEvents: {
                mousedown: "touchstart",
                mouseover: "mouseover",
                mouseout: "mouseover"
            },
            // N.A. - Fix for bug #134471 - Drag drop in pivot is not working correctly with IE8
            // Detect IE.
            ie: !!/msie [\w.]+/.exec(navigator.userAgent.toLowerCase())
        },
        _insertIndex: 0,
        _showLastLevelExpanders: true,
        _createDataSource: function (dataSource, dataSourceOptions) {
            var ds = null, dsOptions;
            if (!_aNull(dataSource) && (this._isInstance(dataSource, "OlapXmlaDataSource") || this._isInstance(dataSource, "OlapFlatDataSource"))) {
                ds = dataSource;
            } else if (!_aNull(dataSourceOptions)) {
                dsOptions = $.extend({}, dataSourceOptions);
                delete dsOptions.xmlaOptions;
                delete dsOptions.flatDataOptions;
                if (!_aNull(dataSourceOptions.xmlaOptions) && !_aNull(dataSourceOptions.xmlaOptions.serverUrl)) {
                    dsOptions = $.extend(dsOptions, dataSourceOptions.xmlaOptions);
                    ds = new $.ig.OlapXmlaDataSource(dsOptions);
                } else if (!_aNull(dataSourceOptions.flatDataOptions) && (!_aNull(dataSourceOptions.flatDataOptions.dataSource) || !_aNull(dataSourceOptions.flatDataOptions.dataSourceUrl))) {
                    dsOptions = $.extend(dsOptions, dataSourceOptions.flatDataOptions);
                    ds = new $.ig.OlapFlatDataSource(dsOptions);
                }
            }

            //if (_aNull(ds)) {
            //    throw new Error($.ig.PivotShared.locale.invalidDataSource);
            //}

            return ds;
        },
        _isTouch: function () {
            var isTouch = typeof window.Modernizr === "object" && window.Modernizr.touch === true;

            if (!isTouch || (navigator.appVersion.indexOf("Windows") !== -1)) {
                if( ((navigator.appVersion.indexOf("Windows") !== -1) && (navigator.appVersion.indexOf("Tablet") !== -1)) ) {
                    return true;
                } 
            }

            return false;
        },
        _addingKpiMetadataItems: function (dataSource, name) {
                var kpi, kpiMeasure, kpiValue, kpiGoal, kpiStatus, kpiTrend, kpiWeight, item;

                kpi = dataSource.getCoreElement(
                    function (el) { return el.uniqueName() === name; },
                    $.ig.Kpi.prototype.getType()
                );

                item = [];

                kpiValue = kpi.kpiValue();
                kpiGoal = kpi.kpiGoal();
                kpiStatus = kpi.kpiStatus();
                kpiTrend = kpi.kpiTrend();
                kpiWeight = kpi.kpiWeight();
                
                if (null !== kpiValue && "" !== kpiValue) {
                    kpiMeasure = dataSource.getCoreElement(
                        function (el) { return el.uniqueName() === kpiValue; },
                        $.ig.Measure.prototype.getType()
                    );

                    if(null === kpiMeasure) {
                        kpiMeasure = dataSource.getCoreElement(
                            function (el) { return el.uniqueName() === kpiValue; },
                            $.ig.KpiMeasure.prototype.getType()
                        );                        
                    }

                    item.push(kpiMeasure);
                }

                if (null !== kpiGoal && "" !== kpiGoal) {
                    kpiMeasure = dataSource.getCoreElement(
                        function (el) { return el.uniqueName() === kpiGoal; },
                        $.ig.Measure.prototype.getType()
                    );

                    if(null === kpiMeasure) {
                        kpiMeasure = dataSource.getCoreElement(
                            function (el) { return el.uniqueName() === kpiGoal; },
                            $.ig.KpiMeasure.prototype.getType()
                        );                        
                    }

                    item.push(kpiMeasure);
                }

                if (null !== kpiStatus && "" !== kpiStatus) {
                    kpiMeasure = dataSource.getCoreElement(
                        function (el) { return el.uniqueName() === kpiStatus; },
                        $.ig.KpiMeasure.prototype.getType()
                    );

                    item.push(kpiMeasure);
                }

                if (null !== kpiTrend && "" !== kpiTrend) {
                    kpiMeasure = dataSource.getCoreElement(
                        function (el) { return el.uniqueName() === kpiTrend; },
                        $.ig.KpiMeasure.prototype.getType()
                    );

                    item.push(kpiMeasure);
                }

                if (null !== kpiWeight && "" !== kpiWeight) {
                    kpiMeasure = dataSource.getCoreElement(
                        function (el) { return el.uniqueName() === kpiWeight; },
                        $.ig.KpiMeasure.prototype.getType()
                    );

                    item.push(kpiMeasure);
                }

                return item;
        },
        _getEvent: function (event) {
            if (this._isTouch()) {
                return this._const.touchEvents[event];
            }
            return event;
        },
        _makeDroppable: function (droppable) {
            // Make the current widget droppable,
            // so it deletes metadata items that are dropped on it.
            var $this = this;
            if (!this._isTouch()) {
                droppable.droppable({
                    tolerance: "pointer",
                    accept: function (draggable) {
                        // N.A. - Fix for bug #134999.
                        // If the dragged element has class ui-igpivot-dragover it will not be accepted -
                        // this class it toggled when the dragged element moves over a drop area.

                        // Note that if the dragged element is a tree node, the droppable should not accept it.
                        // The droppable should only accept metadata items in order to execute a remove action
                        // on them.
                        return draggable.hasClass("ui-igpivot-dragover") === false &&
                            draggable.closest("li.ui-igtree-node").length === 0 &&
                            (draggable.hasClass("ui-igpivot-metadataitem") ||
                                draggable.find(".ui-igpivot-metadataitem:first").length > 0);
                    },
                    over: function (event, ui) {
                        var isValid = true, markup = $(ui.helper.html()), element = ui.draggable, typeName, name;

                        if (!element.hasClass("ui-igpivot-metadataitem")) {
                            element = element.find(".ui-igpivot-metadataitem:first");
                        }
                        if (element.length > 0) {
                            typeName = element.attr("data-type");
                            name = element.attr("data-name");
                        } else {
                            return false;
                        }

                        // N.A. - Fix related to bugs #132380 and #132383.
                        // The user's validation will now be executed upon over and drop.
                        if ($.isFunction($this.options.customMoveValidation)) {
                            isValid = $this.options.customMoveValidation.call($this.element, $this.widgetName, typeName, name);
                        }
                        if (ui.helper.hasClass("ui-igpivot-draghelper")) {
                            if (isValid) {
                                markup.find("span").removeClass("ui-icon-plus ui-icon-cancel").addClass("ui-icon-close").siblings("strong");
                                ui.helper
                                    .removeClass($this.css.dropIndicator)
                                    .addClass($this.css.invalidDropIndicator)
                                    .html(markup);
                            } else {
                                markup.find("span").removeClass("ui-icon-plus ui-icon-close").addClass("ui-icon-cancel").siblings("strong");
                                ui.helper
                                    .removeClass($this.css.dropIndicator)
                                    .addClass($this.css.invalidDropIndicator)
                                    .html(markup);
                            }
                        }
                    },
                    out: function (event, ui) {
                        var markup = $(ui.helper.html());
                        if (ui.helper.hasClass("ui-igpivot-draghelper")) {
                            markup.find("span").removeClass("ui-icon-close ui-icon-plus").addClass("ui-icon-cancel").siblings("strong");
                            ui.helper
                                .removeClass($this.css.dropIndicator)
                                .addClass($this.css.invalidDropIndicator)
                                .html(markup);
                        }
                    },
                    drop: function (event, ui) {
                        var element = ui.draggable, isValid = true, typeName, type, name, item, noCancel, location, dataRole;

                        // Detach from the draggable events in a safe way.
                        ui.draggable.unbind("." + $this.widgetName);

                        if (!element.hasClass("ui-igpivot-metadataitem")) {
                            element = element.find(".ui-igpivot-metadataitem:first");
                        }
                        if (element.length > 0) {
                            typeName = element.attr("data-type");
                            name = element.attr("data-name");
                        } else {
                            return false;
                        }

                        // N.A. - Fix related to bugs #132380 and #132383.
                        // The user's validation will now be executed upon over and drop.
                        if ($.isFunction($this.options.customMoveValidation)) {
                            dataRole = $(this).attr("data-role");
                            location = dataRole === undefined ? $this.widgetName : dataRole;
                            isValid = $this.options.customMoveValidation.call($this.element, location, typeName, name);
                        }
                        if (!isValid) {
                            return false;
                        }

                        switch (typeName) {
                            case $.ig.Dimension.prototype.getType().typeName():
                                type = $.ig.Dimension.prototype.getType();
                                break;
                            case $.ig.Hierarchy.prototype.getType().typeName():
                                type = $.ig.Hierarchy.prototype.getType();
                                break;
                            case $.ig.Measure.prototype.getType().typeName():
                                type = $.ig.Measure.prototype.getType();
                                break;
                            case $.ig.MeasureList.prototype.getType().typeName():
                                type = $.ig.MeasureList.prototype.getType();
                                break;
                            case $.ig.Kpi.prototype.getType().typeName():
                                type = $.ig.Kpi.prototype.getType();
                                break; 
                            case $.ig.KpiMeasure.prototype.getType().typeName():
                                type = $.ig.KpiMeasure.prototype.getType();
                                break;
                            default:
                                return false;
                        }
                        item = $this._ds.getCoreElement(
                            function (el) { return el.uniqueName() === name; },
                            type
                        );

                        if (item) {
                            noCancel = $this._triggerMetadataRemoving(event, element, item);
                            if (noCancel) {
                                // Directly call the remove function
                                // rather than checking each collection -
                                // it's faster.
                                $this._ds.removeFilterItem(item);
                                $this._ds.removeRowItem(item);
                                $this._ds.removeColumnItem(item);
                                $this._ds.removeMeasureItem(item);
                                $this._triggerMetadataRemoved(event, item);
                                $this._updateDataSource();
                                return true;
                            }
                        }
                        return false;
                    }
                });
            }
        },
        _createDropAreaOptions: function () {
            var $this = this,
                dropAreaOptions = {
                    // Make the droppable greedy, so ti won't interfere with the droppable beneath it.
                    greedy: true,
                    tolerance: "pointer",
                    activeClass: this.css.activeDropArea,
                    accept: function (draggable) { return $this._accept($(this), draggable); },
                    over: function (event, ui) { $this._onDraggableOver(event, ui); },
                    out: function (event, ui) { $this._onDraggableOut(event, ui); },
                    drop: function (event, ui) {
                        var element = ui.draggable, type, name;
                        if (!element.hasClass("ui-igpivot-metadataitem")) {
                            element = element.find(".ui-igpivot-metadataitem:first");
                        }
                        if (element.length > 0) {
                            type = element.attr("data-type");
                            name = element.attr("data-name");

                            if(!name) {
                                name = "null";
                            }

                            return $this._onDrop(event, ui, $(this), element, type, name);
                        }
                        return false;
                    }
                };

            return dropAreaOptions;
        },
        _onDataSourceCollectionChanged: function (collection, collectionChangedArgs, dropArea, isDisabled) {
            var action, items, i, length, name, filter, startingIndex, previousItem, destroyDraggable;

            action = collectionChangedArgs.action();
            switch (action) {
                case $.ig.NotifyCollectionChangedAction.prototype.add:
                    items = collectionChangedArgs.newItems().__inner; //toArray();
                    startingIndex = collectionChangedArgs.newStartingIndex();
                    if (startingIndex === 0) {
                        this._createMetadataElement(items[0], isDisabled, "prependTo", dropArea);
                    } else {
                        previousItem = dropArea.find(".ui-igpivot-metadataitem")[startingIndex - 1];
                        this._createMetadataElement(items[0], isDisabled, "insertAfter", previousItem);
                    }
                    break;
                case $.ig.NotifyCollectionChangedAction.prototype.remove:
                    items = collectionChangedArgs.oldItems().__inner; //toArray();
                    filter = function (ind, itemElement) {
                        return $(itemElement).attr("data-name") === name;
                    };
                    destroyDraggable = function (ind, el) {
                        var draggable = $(el).data(_draggable);
                        if (draggable) {
                            draggable.destroy();
                        }
                    };
                    for (i = 0, length = items.length; i < length; i++) {
                        if (this._isInstance(items[i], "MeasureList")) {
                            dropArea
                            .find(".ui-igpivot-metadataitem[data-type=" + $.ig.MeasureList.prototype.getType().typeName() + "]")
                            .each(destroyDraggable)
                            .remove();
                        } else {
                            name = items[i].uniqueName();
                            dropArea
                            .find(".ui-igpivot-metadataitem")
                            .filter(filter)
                            .each(destroyDraggable)
                            .remove();
                        }
                    }
                    break;
                case $.ig.NotifyCollectionChangedAction.prototype.reset:
                    destroyDraggable = function (ind, el) {
                        var draggable = $(el).data(_draggable);
                        if (draggable) {
                            draggable.destroy();
                        }
                    };
                    dropArea
                    .find(".ui-igpivot-metadataitem")
                    .each(destroyDraggable)
                    .remove();
                    break;
            }
        },
        _createMetadataElement: function (item, isDisabled, appendFunc, target) {
            var $this = this, dragAndDropSettings = this.options.dragAndDropSettings,
                metadataElement, metadataElementMarkup;

            metadataElementMarkup = "<li ";
            if (this._isInstance(item, "MeasureList") && item.caption() === null) {
                item.caption($.ig.PivotShared.locale.measureList);
            } else {
                metadataElementMarkup += "data-name='" + item.uniqueName() + "' ";
            }
            metadataElementMarkup += "title='" + item.caption() + "' data-type='" + item.getType().typeName() + "'>";
            if (this._isInstance(item, "Hierarchy") && !isDisabled) {
                metadataElementMarkup += "<span style='display:block; float:left;' class='ui-icon " + this.css.filterIcon + "'></span>";
            }
			
			if(this.widget()[0].className.indexOf("ui-igpivotdataselector ui-droppable") !== -1 && target !== undefined) {
				metadataElementMarkup += "<div style='float:left; display:block; width: calc(100%";
				if ("Hierarchy" === item.getType().typeName()) {
					metadataElementMarkup += " - 28px";
				} else {
					metadataElementMarkup += " - 16px";
				}
				
				metadataElementMarkup += ");overflow-x:hidden !important; text-overflow:ellipsis !important;'>";
					metadataElementMarkup += "<span data-role='caption'>";
					metadataElementMarkup += item.caption();
					metadataElementMarkup += "</span>";
				metadataElementMarkup += "</div>";
			} 
			else {
				metadataElementMarkup += "<span data-role='caption'>" + item.caption() + "</span>";
			}
			
            if (!isDisabled) {
                metadataElementMarkup += "<span class='ui-icon ui-icon-close'></span>";
            }
            metadataElementMarkup += "</li>";

            metadataElement = $(metadataElementMarkup).addClass(this.css.metadataItem);
            // Append the element to the DOM before binding to events - IE8 issues.
            metadataElement[appendFunc](target);

            if (!isDisabled) {
                metadataElement.find("span.ui-icon-pivot-smallfilter").click(function (event) {
                    $this._createFilterDropDown(event, this, item);
                    return false;
                });
                metadataElement.find("span.ui-icon-close").click(function (event) {
                    var noCancel = $this._triggerMetadataRemoving(event, metadataElement, item);
                    if (noCancel) {
                        // Directly call the remove function
                        // rather than checking each collection -
                        // it's faster.
                        $this._ds.removeFilterItem(item);
                        $this._ds.removeRowItem(item);
                        $this._ds.removeColumnItem(item);
                        $this._ds.removeMeasureItem(item);
                        $this._triggerMetadataRemoved(event, item);
                        $this._updateDataSource();
                        return false;
                    }
                    return false;
                });
                if (!this._isTouch()) {
                    metadataElement.draggable({
                        appendTo: dragAndDropSettings.appendTo,
                        containment: dragAndDropSettings.containment,
                        opacity: dragAndDropSettings.dragOpacity,
                        zIndex: dragAndDropSettings.zIndex,
                        cursorAt: this._const.dragCursorAt,
                        revert: false,
                        cancel: ".ui-icon",
                        helper: function (event) {
                            var target = $(event.target).closest(".ui-igpivot-metadataitem").find("span[data-role='caption']"),
                                markup = $($this._const.dragHelperMarkup.replace("{0}", target.text()));
                            markup.addClass($this.css.invalidDropIndicator)
                                .find("span")
                                .addClass("ui-icon");
                            return markup;
                        },
                        start: function (event, ui) { return $this._triggerDragStart(event, ui, item); },
                        drag: function (event, ui) { return $this._triggerDrag(event, ui, item); },
                        over: function (event, ui) { $this._onDraggableOver(event, ui); },
                        out: function (event, ui) { $this._onDraggableOut(event, ui); },
                        stop: function (event, ui) { $this._triggerDragStop(event, ui); }
                    });
                }
                metadataElement.click(function (event) {
                    $this._createMetadataItemDropDown(event, this, item);
                });
            }

            return metadataElement;
        },
        _accept: function (targetElement, draggable) {
            var target, typeName, isValid = false, isMeasureDimension, dimension, dataSource = this._ds;
            if (!draggable.hasClass("ui-igpivot-metadataitem")) {
                draggable = draggable.find(".ui-igpivot-metadataitem:first");
            }
            typeName = draggable.attr("data-type");
            target = targetElement.attr("data-role");
            $(".ui-igpivot-overlaydroparea").css("display", "block");

            dimension = dataSource.getCoreElement(function (el) {
                return el.dimensionType() === $.ig.DimensionType.prototype.measure; 
            }, $.ig.Dimension.prototype.getType());

            isMeasureDimension = draggable.text() === dimension.name() || draggable.text() === dimension.caption();

            if (typeName) {
                switch (target) {
                    case "rows":
                    case "columns":
                        isValid = typeName === $.ig.Hierarchy.prototype.getType().typeName() ||
                        (typeName === $.ig.Dimension.prototype.getType().typeName() && !isMeasureDimension)||
                        typeName === $.ig.MeasureList.prototype.getType().typeName();
                        break;
                    case "filters":
                        isValid = typeName === $.ig.Hierarchy.prototype.getType().typeName() ||
                        (typeName === $.ig.Dimension.prototype.getType().typeName() && !isMeasureDimension);
                        break;
                    case "measures":
                        isValid = (typeName === $.ig.Measure.prototype.getType().typeName() ||
                            typeName === $.ig.Kpi.prototype.getType().typeName() ||     
                            typeName === $.ig.KpiMeasure.prototype.getType().typeName() ||                       
                            isMeasureDimension) &&
                            "MeasureList" !== draggable.attr("data-type");
                        break;
                }

                // N.A. - Fix related to bugs #132380 and #132383.
                // The user's validation will now be executed upon over and drop.
                //if (isValid && $.isFunction(this.options.customMoveValidation)) {
                //    isValid = this.options.customMoveValidation.call(targetElement, draggable);
                //}
            }

            return isValid;
        },
        _onDraggableOver: function (event, ui) {
            var $this = this, isValid = true, markup = $(ui.helper.html()), element = ui.draggable, typeName, name;

            // N.A. - Fix for bug #134999.
            // Add a special class to the dragged element so it won't be accepted
            // by the underlying drop area, which perdorms a remove.
            ui.draggable.addClass("ui-igpivot-dragover");
            $(".ui-igpivot-overlaydroparea").css("display", "none");

            if (!element.hasClass("ui-igpivot-metadataitem")) {
                element = element.find(".ui-igpivot-metadataitem:first");
            }
            if (element.length > 0) {
                typeName = element.attr("data-type");
                name = element.attr("data-name");
            } else {
                return false;
            }

            // N.A. - Fix related to bugs #132380 and #132383.
            // The user's validation will now be executed upon over and drop.
            if ($.isFunction(this.options.customMoveValidation)) {
                isValid = this.options.customMoveValidation.call(this.element, $(event.target).attr("data-role"), typeName, name);
            }
            if (ui.helper.hasClass("ui-igpivot-draghelper")) {
                if (isValid) {
                    markup.find("span").removeClass("ui-icon-cancel ui-icon-close").addClass("ui-icon-plus").siblings("strong");
                    ui.helper
                        .removeClass(this.css.invalidDropIndicator)
                        .addClass(this.css.dropIndicator)
                        .html(markup);
                } else {
                    markup.find("span").removeClass("ui-icon-plus ui-icon-close").addClass("ui-icon-cancel").siblings("strong");
                    ui.helper
                        .removeClass(this.css.dropIndicator)
                        .addClass(this.css.invalidDropIndicator)
                        .html(markup);
                }
            }
            if (!isValid) {
                return false;
            }

            // Attach to the events of the draggable.
            ui.draggable
                .bind("drag." + this.widgetName, function (event1, ui1) {
                    $this._onDraggableDrag(event1, ui1);
                });
        },
        _onDraggableDrag: function (event, ui) {
            var target = $(event.originalEvent.target),
                insertItem = "<li class='" + this.css.insertItem + "'></li>";

            if (target.hasClass("ui-igpivot-insertitem")) {
                // N.A. - Fix for bug #134471 - Drag drop in pivot is not working correctly with IE8
                // If the browser is IE8, continue.
                // For some reason if this method returns, IE8's event reports that
                // no mouse button is pressed and jQuery UI triggers mouse up.
                if (!this._const.ie || (this._const.ie && document.documentMode !== 8)) {
                    return;
                }
            }

            // Remove the old insert line indicator.
            $(document).find(".ui-igpivot-insertitem").remove();

            // Check if the target is an element from the cotnent
            // of a metadata element.
            if (target.is("span")) {
                // Locate its parent metadata element.
                target = target.closest(".ui-igpivot-metadataitem");
            }
            // Do not add the line indicator for elements comming from outside the drop areas
            if (!(target.parent().hasClass("ui-igpivot-droparea") || target.hasClass("ui-igpivot-droparea"))) {
                return;
            }
            if (target.is(".ui-igpivot-metadataitem")) {
                if (this._shouldAppendToTarget(target, ui)) {
                    // The dragged element will be inserted after the target.
                    this._insertIndex = target.index() + 1;
                    $(insertItem).insertAfter(target);
                } else {
                    if (target.index() === 0) {
                        // The dragged element will be inserted at the beginning.
                        this._insertIndex = 0;
                        $(insertItem).insertBefore(target);
                    } else {
                        // The dragged element will be inserted before the target.
                        this._insertIndex = target.index();
                        $(insertItem).insertBefore(target);
                    }
                }
            } else if (target.is(".ui-igpivot-droparea")) {
                target = target.find(".ui-igpivot-metadataitem:last");
                // The dragged element will be inserted after the last 
                // metadata element.
                this._insertIndex = target.index() + 1;
                $(insertItem).insertAfter(target);
            }
        },
        _onDraggableOut: function (event, ui) {
            var markup = $(ui.helper.html()), invalidIcon;

            // N.A. - Fix for bug #134999.
            // Remove the special class.
            ui.draggable.removeClass("ui-igpivot-dragover");

            // If the dragged element is a tree node, the helper will display the cancel icon.
            invalidIcon = ui.draggable.closest("li.ui-igtree-node").length === 0 ? "ui-icon-close" : "ui-icon-cancel";

            if (ui.helper.hasClass("ui-igpivot-draghelper")) {
                markup.find("span").removeClass("ui-icon-plus").addClass(invalidIcon).siblings("strong");
                ui.helper
                    .removeClass(this.css.dropIndicator)
                    .addClass(this.css.invalidDropIndicator)
                    .html(markup);
            }

            // Detach from the draggable events in a safe way.
            ui.draggable.unbind("drag." + this.widgetName);

            // Remove the old insert line indicator.
            $(document).find(".ui-igpivot-insertitem").remove();

            // Reset the drag helper.
            this._insertIndex = 0;
        },
        _getDefaultHierarchy: function (dimensionName, name, dataSource, typeName) {
			var i, firstHierarchy, returnValue;
            dimensionName = name.substr(1, name.length-2);
            if (null !== dataSource.getDimension(name) && 
                $.ig.DimensionType.prototype.measure === dataSource.getDimension(name).dimensionType()){
                for (i = dataSource.metadataTree().children().length - 1; i >= 0; i--) {
                    if (name === dataSource.metadataTree().children()[i].item().uniqueName()) {
                        firstHierarchy = dataSource.metadataTree().children()[i];
                        while (null !== firstHierarchy.children()) {
                            firstHierarchy = firstHierarchy.children()[0];
                        }

                        name = firstHierarchy.item().uniqueName();
                        returnValue = dataSource.getMeasure(name);
                    }
                }
            } else if (typeName === $.ig.Dimension.prototype.getType().typeName()) {
                for (i = dataSource.metadataTree().children().length - 1; i >= 0; i--) {
                    if (dimensionName === dataSource.metadataTree().children()[i].item().name() ||
                        dimensionName === dataSource.metadataTree().children()[i].item().name().replace(' ', '')) {
                        if (typeof dataSource.metadataTree().children()[i].item().defaultHierarchy === 'function' &&
                            dataSource.metadataTree().children()[i].item().defaultHierarchy()) {
                            name = dataSource.metadataTree().children()[i].item().defaultHierarchy();
                        }
                        else if (null !== dataSource.metadataTree().children()[i].children()[0].item()) {
                            name = dataSource.metadataTree().children()[i].children()[0].item().uniqueName();
                        } else {
                            firstHierarchy = dataSource.metadataTree().children()[i].children()[0];
                            while(null === firstHierarchy.item()) {
                                firstHierarchy = firstHierarchy.children()[0];
                            }

                            name = firstHierarchy.item().uniqueName();
                        }
                        break;
                    }
                }

                returnValue = dataSource.getHierarchy(name);
            } else {
                returnValue = null;
            }
			
			return returnValue;
        },
        _onDrop: function (event, ui, targetElement, draggedElement, typeName, name) {
            var dataSource = this._ds, isValid = true, targetRole = $(targetElement).attr("data-role"), targetIndex = this._insertIndex,
                item, type, sourceRole, sourceIndex, filterMembers, i,
                noCancel, firstHierarchy, dimensionName;

            // Detach from the draggable events in a safe way.
            ui.draggable.unbind("." + this.widgetName);
            // If the drop is canceled, the insert line indicator
            // will not be removed in the onDraggableOut method.
            // Remove the old insert line indicator.
            $(document).find(".ui-igpivot-insertitem").remove();

            // N.A. - Fix related to bugs #132380 and #132383.
            // The user's validation will now be executed upon over and drop.
            if ($.isFunction(this.options.customMoveValidation)) {
                isValid = this.options.customMoveValidation.call(this.element, $(event.target).attr("data-role"), typeName, name);
            }
            if (!isValid) {
                return false;
            }

            switch (typeName) {
                case $.ig.Dimension.prototype.getType().typeName():
                    type = $.ig.Dimension.prototype.getType();
                    break;
                case $.ig.Hierarchy.prototype.getType().typeName():
                    type = $.ig.Hierarchy.prototype.getType();
                    break;
                case $.ig.Measure.prototype.getType().typeName():
                    type = $.ig.Measure.prototype.getType();
                    break;
                case $.ig.Kpi.prototype.getType().typeName():
                    type = $.ig.Kpi.prototype.getType();
                    break;
                case $.ig.KpiMeasure.prototype.getType().typeName():
                    type = $.ig.KpiMeasure.prototype.getType();
                    break;
                case $.ig.MeasureList.prototype.getType().typeName():
                    type = $.ig.MeasureList.prototype.getType();
                    break;
                default:
                    return false;
            }
            item = this._getDefaultHierarchy(dimensionName, name, dataSource, typeName);
            if (null === item) {
                item = dataSource.getCoreElement(
                    function (el) { return el.uniqueName() === name; },
                    type
                );
            }

            if (!item) {
                return false;
            }

            noCancel = this._triggerMetadataDropping(event, ui, targetElement, draggedElement, item, targetIndex);
            if (noCancel) {
                if ((sourceIndex = $.inArray(item, dataSource.filters())) > -1) {
                    sourceRole = "filters";
                } else if ((sourceIndex = $.inArray(item, dataSource.rowAxis())) > -1) {
                    sourceRole = "rows";
                } else if ((sourceIndex = $.inArray(item, dataSource.columnAxis())) > -1) {
                    sourceRole = "columns";
                } else if ((sourceIndex = $.inArray(item, dataSource.measures())) > -1 || item instanceof Array) {
                    sourceRole = "measures";
                } else {
                    sourceRole = null;
                }

                if (sourceRole !== null && sourceRole === targetRole && sourceIndex < targetIndex) {
                    targetIndex--;
                }

                // Create the new item element and update the data source.
                if (this._isInstance(item, "MeasureList")) {
                    // The drop are role should be 'rows' or 'columns'
                    // Move from rows to columns and from columns to rows.
                    dataSource.setMeasureListLocation(targetRole);
                    dataSource.setMeasureListIndex(targetIndex);
                } else {
                    if (this._isInstance(item, "Hierarchy")) {
                        // N.A. - Fix for bug #129528.
                        // Cache the filter bembers before the hierarchy is removed.
                        filterMembers = dataSource.getFilterMemberNames(name);
                    }

                    switch (sourceRole) {
                        case "filters":
                            dataSource.removeFilterItem(item);
                            break;
                        case "rows":
                            dataSource.removeRowItem(item);
                            break;
                        case "columns":
                            dataSource.removeColumnItem(item);
                            break;
                        case "measures":
                            if (item instanceof Array) {
                                for (i = 0; i < item.length; i++) {
                                    dataSource.removeMeasureItem(item[i]);
                                }
                            } else {
                            dataSource.removeMeasureItem(item);
                            }
                            
                            break;
                    }

                    switch (targetRole) {
                        case "filters":
                            dataSource.insertFilterItem(targetIndex, item);
                            break;
                        case "rows":
                            dataSource.insertRowItem(targetIndex, item);
                            break;
                        case "columns":
                            dataSource.insertColumnItem(targetIndex, item);
                            break;
                        case "measures":
                            if (item instanceof Array) {
                                for (i = 0; i < item.length; i++) {
                                    dataSource.addMeasureItem(item[i]);
                                }
                            } else if (item instanceof $.ig.Kpi) {
                                item = this._addingKpiMetadataItems(dataSource, item.name());

                                for(i = 0; i< item.length; i++) {
                                    dataSource.removeMeasureItem(item[i]);
                                    dataSource.addMeasureItem(item[i]);
                                }
                            } else {
                                dataSource.insertMeasureItem(targetIndex, item);
                            }

                            break;
                    }

                    if (this._isInstance(item, "Hierarchy")) {
                        // N.A. - Fix for bug #129528.
                        // Add the cached filter members.
                        for (i = 0; i < filterMembers.length; i++) {
                            dataSource.addFilterMember(name, filterMembers[i]);
                        }
                    }
                }

                // N.A. - Fix for bugs #132343 and #130174.
                // The bug is related to ticket #4239 for jQuery UI, which is fixed
                // for draggable, but not for its plugins.
                // Ticket: http://bugs.jqueryui.com/ticket/4239
                if (this.widgetName === "igPivotGrid" && ui.draggable.data(_draggable)) {
                    // Remove all "stop" handlers.
                    delete ui.draggable.data(_draggable).plugins.stop;
                }

                // Update the data source.
                this._updateDataSource();

                this._triggerMetadataDropped(event, ui, targetElement, draggedElement, item, targetIndex);
                return true;
            }

            return false;
        },
        _createMetadataItemDropDown: function (event, targetElement, metadataItem) {
            var $this = this, options = this.options, dataSource = this._ds, closestDropArea, dropDownParent, dropDownElement, menu,
                addMeasureList, addHierarchy, items, item, customValidation, dimensionName, defaultHierarchy, defaultHierarchyElement, i;

            // Determine if the metadata item is in a drop area.
            closestDropArea = $(targetElement).closest(".ui-igpivot-droparea").attr("data-role");

            if ($.isFunction(this.options.customMoveValidation)) {
                customValidation = function (location) {
                    return $this.options.customMoveValidation.call($this.element, location, metadataItem.getType().name, metadataItem.uniqueName() || undefined);
                };
            } else {
                customValidation = function () {
                    return true;
                };
            }

            dropDownParent = $(this.options.dropDownParent).first();

            dropDownElement = $("<div class='" + this.css.metadataItemDropDown + "'></div>");
            dropDownElement.data("efh", "1");
            dropDownElement
                .appendTo(dropDownParent)
                .bind(this._getEvent("mousedown"), function (event1) {
                    // Prevent the drop down from closing.
                    event1.stopPropagation();
                });

            // Add buttons to the drop down depending on the type and the
            // location of the metadata item.
            menu = $("<ul class='ui-widget'></ul>").appendTo(dropDownElement);

            defaultHierarchy = this._getDefaultHierarchy(dimensionName, metadataItem.uniqueName(), dataSource, metadataItem.getType().typeName());
            if (defaultHierarchy) {
                metadataItem = defaultHierarchy;
            }

            defaultHierarchyElement = $("li[data-name='" + metadataItem.uniqueName() + "']");
            if (0 < defaultHierarchyElement.length) {
                closestDropArea = defaultHierarchyElement.parent().attr("data-role");
            }

            if (this._isInstance(metadataItem, "Measure") || this._isInstance(metadataItem, "Kpi")) {
                if (!options.disableMeasuresDropArea && closestDropArea !== "measures" && customValidation("measures")) {
                    $("<li><span class='ui-icon ui-icon-pivot-measures'></span>" + $.ig.PivotShared.locale.addToMeasures + "</li>").appendTo(menu).click(function () {
                        if ($this._isInstance(metadataItem, "Kpi")) {
                            item = $this._addingKpiMetadataItems($this._ds, $(targetElement).attr('data-name'));

                            for(i = 0; i< item.length; i++) {
                                $this._ds.removeMeasureItem(item[i]);
                                $this._ds.addMeasureItem(item[i]);
                            }

                            dropDownElement.remove();
                            $this._updateDataSource();    
                        } else {
                        $this._ds.removeMeasureItem(metadataItem);
                        $this._ds.addMeasureItem(metadataItem);
                        dropDownElement.remove();
                        $this._updateDataSource();
                        }
                        
                    });
                }
            } else if (this._isInstance(metadataItem, "MeasureList")) {
                addMeasureList = function (location, index) {
                    $this._ds.setMeasureListLocation(location);
                    $this._ds.setMeasureListIndex(index);
                    dropDownElement.remove();
                    $this._updateDataSource();
                };
                if (!options.disableColumnsDropArea && closestDropArea !== "columns" && customValidation("columns")) {
                    $("<li><span class='ui-icon ui-icon-pivot-clumns'></span>" + $.ig.PivotShared.locale.addToColumns + "</li>").appendTo(menu).click(function () {
                        addMeasureList("columns", $this._ds.columnAxis().length);
                    });
                }
                if (!options.disableRowsDropArea && closestDropArea !== "rows" && customValidation("rows")) {
                    $("<li><span class='ui-icon ui-icon-pivot-rows'></span>" + $.ig.PivotShared.locale.addToRows + "</li>").appendTo(menu).click(function () {
                        addMeasureList("rows", $this._ds.rowAxis().length);
                    });
                }
            } else {
                addHierarchy = function (addMethod) {
                    var i, name = metadataItem.uniqueName(),
                    // N.A. - Fix for bug #129528.
                    // Cache the filter bembers before the hierarchy is removed.
                        filterMembers = $this._ds.getFilterMemberNames(name);

                    $this._ds.removeFilterItem(metadataItem);
                    $this._ds.removeColumnItem(metadataItem);
                    $this._ds.removeRowItem(metadataItem);

                    $this._ds[addMethod](metadataItem);

                    // N.A. - Fix for bug #129528.
                    // Add the cached filter members.
                    for (i = 0; i < filterMembers.length; i++) {
                        $this._ds.addFilterMember(name, filterMembers[i]);
                    }

                    dropDownElement.remove();
                    $this._updateDataSource();
                };

                if (!options.disableFiltersDropArea && closestDropArea !== "filters" && customValidation("filters")) {
                    $("<li><span class='ui-icon ui-icon-pivot-filters'></span>" + $.ig.PivotShared.locale.addToFilters + "</li>").appendTo(menu).click(function () {
                        addHierarchy("addFilterItem");
                    });
                }
                if (!options.disableColumnsDropArea && closestDropArea !== "columns" && customValidation("columns")) {
                    $("<li><span class='ui-icon ui-icon-pivot-columns'></span>" + $.ig.PivotShared.locale.addToColumns + "</li>").appendTo(menu).click(function () {
                        addHierarchy("addColumnItem");
                    });
                }
                if (!options.disableRowsDropArea && closestDropArea !== "rows" && customValidation("rows")) {
                    $("<li><span class='ui-icon ui-icon-pivot-rows'></span>" + $.ig.PivotShared.locale.addToRows + "</li>").appendTo(menu).click(function () {
                        addHierarchy("addRowItem");
                    });
                }
            }

            items = dropDownElement.find("li");
            if (items.length === 0) {
                dropDownElement.remove();
                return;
            }

            dropDownElement
                .css("position", "absolute")
                .position({
                    of: targetElement,
                    my: "left top",
                    at: "left bottom"
                });

            items
                .bind(this._getEvent("mouseover"), function () { $(this).addClass("ui-state-hover"); })
                .bind(this._getEvent("mouseout"), function () { $(this).removeClass("ui-state-hover"); });

            $(document).bind(this._getEvent("mousedown") + "." + this.widgetName, function () {
                dropDownElement.remove();
                $(document).unbind("." + $this.widgetName);
            });
        },
        _createFilterDropDown: function (event, targetElement, hierarchy) {
            var $this = this, hierarchyName, hierarchyFilterView, dropDownParent, dropDownElement,
                filterMembersTree, buttonContainer, removeFilterDropDown, noCancel;

            noCancel = this._triggerFilterDropDownOpening(event, hierarchy);
            if (noCancel) {
                hierarchyName = hierarchy.uniqueName();
                // Create an instance of the HierarchyFilterView
                hierarchyFilterView = new $.ig.HierarchyFilterView(hierarchy);

                dropDownParent = $(this.options.dropDownParent).first();

                dropDownElement = $("<div class='" + this.css.filterDropDown + "'></div>");
                dropDownElement.data("efh", "1");
                dropDownElement
                    .css("position", "absolute")
                    .attr("data-hierarchy", hierarchyName)
                    .appendTo(dropDownParent)
                    .position({
                        of: targetElement,
                        my: "left top",
                        at: "left bottom"
                    }).bind(this._getEvent("mousedown"), function (event1) {
                        // Prevent the drop down from closing.
                        event1.stopPropagation();
                    });
                // Create the element for the tree.
                filterMembersTree = $("<div class='" + this.css.filterMembers + "'></div>").appendTo(dropDownElement);
                // Append the container for the OK and Cancel buttons.
                buttonContainer = $("<div class='ui-igpivot-filterdropdown-buttoncontainer'></div>").appendTo(dropDownElement);
                // Prepare a function, which will remove the drop down.
                removeFilterDropDown = function (event1) { $this._removeFilterDropDown(event1, dropDownElement, hierarchy); };
                // OK button.
                $("<button></button>")
                    .attr("data-role", "ok")
                    .text($.ig.PivotShared.locale.ok)
                    .appendTo(buttonContainer).igButton().igButton("disable") // Disable the OK button.
                    .click(function (event1) {
                        $this._onFilterOk(event1, dropDownElement, hierarchyFilterView, hierarchy);
                    });
                // Cancel button.
                $("<button></button>")
                    .attr("data-role", "cancel")
                    .text($.ig.PivotShared.locale.cancel)
                    .appendTo(buttonContainer).igButton()
                    .click(removeFilterDropDown);

                $(document).bind(this._getEvent("mousedown") + "." + this.widgetName, removeFilterDropDown);

                this._loadFilterMembers(hierarchyFilterView, hierarchy, removeFilterDropDown);
                this._triggerFilterDropDownOpened(event, dropDownElement, hierarchy);
            }
        },
        _loadFilterMembers: function (hierarchyFilterView, hierarchy, removeFilterDropDown) {
            var $this = this, dataSource, hierarchyName, rootFilterMembers, filterMembers, filterMember, member, members, maxLevel, levels, levelMembers, rootLevel, i;

            dataSource = this._ds;
            hierarchyName = hierarchy.uniqueName();
            filterMembers = dataSource.getFilterMemberNames(hierarchyName);

            if (filterMembers.length > 0) {
                members = [];
                maxLevel = 0;
                // Get the member objects from the data source.
                for (i = 0; i < filterMembers.length; i++) {
                    member = dataSource.tryGetMember(filterMembers[i]);
                    if (member) {
                        members.push(member);
                        if (member.levelDepth() > maxLevel) {
                            // Find the deepest level that has filter members.
                            maxLevel = member.levelDepth();
                        }
                    }
                }
                // Get all levels above the deepest level.
                levels = dataSource.getCoreElements(function (el) {
                    return el.hierarchyUniqueName() === hierarchyName && el.depth() <= maxLevel;
                }, $.ig.Level.prototype.getType());
                // Enumerate the levels and add their members to the filter view.
                for (i = 0; i < levels.length; i++) {
                    levelMembers = dataSource.tryGetMembersForLevel(levels[i].uniqueName());
                    hierarchyFilterView.addFiltersForMembers(levelMembers);
                }
                // Get the root level members from the filter view and uncheck them.
                rootFilterMembers = hierarchyFilterView.getRootFilterMembers();
                rootFilterMembers = rootFilterMembers ? rootFilterMembers.__inner : [];
                for (i = 0; i < rootFilterMembers.length; i++) {
                    rootFilterMembers[i].isSelected($.ig.util.toNullable($.ig.Boolean.prototype.$type, false));
                }
                // Check the filter members.
                for (i = 0; i < members.length; i++) {
                    filterMember = hierarchyFilterView.tryGetFilterMember(members[i].uniqueName()).filterMember;
                    if (filterMember) {
                        filterMember.isSelected($.ig.util.toNullable($.ig.Boolean.prototype.$type, true));
                    }
                }
            }

            // Get the root level.
            rootLevel = dataSource.getCoreElement(function (el) {
                return el.depth() === 0 && el.hierarchyUniqueName() === hierarchyName;
            }, $.ig.Level.prototype.getType());
            // Initiate a load of the root filter members.
            this._ds.getMembersOfLevel(rootLevel.uniqueName())
                .done(function (m) { $this._onFilterMembersLoaded(hierarchyFilterView, m, hierarchy); })
                .fail(removeFilterDropDown);
        },
        _onFilterMembersLoaded: function (hierarchyFilterView, members, hierarchy) {
            var hierarchyName, dropDownElement, filterMembersTree;

            hierarchyName = hierarchy.uniqueName();
            // Add the members in the filter view.
            hierarchyFilterView.addFiltersForMembers(members);
            // Parse the filter members to objects suitable for the igTree.

            dropDownElement = $(".ui-igpivot-filterdropdown").filter(function () {
                // The hierarchy name contains characters, which cannot be
                // used in the selector [data-hierarchy=...].
                return $(this).attr("data-hierarchy") === hierarchyName;
            });
            // Make sure that the drop down exists.
            // If the user has closed it before the data has loaded
            // the drop down will not exist.
            if (dropDownElement.length > 0) {
                filterMembersTree = $(dropDownElement[0]).find(".ui-igpivot-filtermembers");
                // Initialize the tree.
                this._initTree(filterMembersTree, hierarchyFilterView);
            }
        },
        _getScrollBarWidth: function () {
            var el = $('<div style="width: 100px; height: 100px; position: absolute; top: -10000px; left: -10000px; overflow: scroll"></div>').appendTo($(document.body)), scrollWidth;
            scrollWidth = el[0].offsetWidth - el[0].clientWidth;
            el.remove();
            return scrollWidth;
        },
        _getElementSize: function (element) {
            var el = $('<div style="width: 5000px; height: 5000px; position: absolute; top: -10000px; left: -10000px;"></div>').appendTo($(document.body)), result, position, float;
            position = element.css('position');
            float = element.css('float');
            element.css({ 'position': 'relative', 'float': 'left' });
            element.appendTo(el);
            result = [element.width(), element.height()];
            element.css('position', position);
            element.css('float', float);
            element.detach();
            el.remove();
            return result;
        },
        _arrangeDropDown: function (onExpand) {
            var $this = this, fdd, fm, fmHeight, bcHeight,
                    ddTop, bTop, bHeight, bBottom, fmBottom, fmMaxHeight,
                    ddLeft, bLeft, bWidth, bRight, fmRight, fddMaxWidth,
                    windowHeight, windowInnerHeight,
                    parentOffset, elementSize, fddWidth, scrollTop, dropDownOffsetBottom;

            dropDownOffsetBottom = 30;
            // PP 4/2/2013 set max-width for '.ui-igpivot-filterdropdown' and 
            // calculate heigh and max-height for '.ui-igpivot-filterdropdown .ui-igpivot-filtermembers'
            fdd = $('.ui-igpivot-filterdropdown');
            fm = $('.ui-igpivot-filterdropdown .ui-igpivot-filtermembers');

            // calculate max-height
            fmHeight = fm.height();
            bcHeight = $('.ui-igpivot-filterdropdown-buttoncontainer').innerHeight();

            ddTop = parseInt(fdd.css('top').replace('px', ''), 10);
            bTop = $(document).scrollTop();

            windowHeight = $(window).height();
            windowInnerHeight = window.innerHeight;
            bHeight = windowHeight > windowInnerHeight ? windowHeight : windowInnerHeight;
            bBottom = bTop + bHeight;
            fmBottom = bBottom - bcHeight - dropDownOffsetBottom;
            fmMaxHeight = Math.floor(fmBottom - ddTop);

            // calculate max-width
            ddLeft = parseInt(fdd.css('left').replace('px', ''), 10);
            bLeft = $('body').css('left');
            if (bLeft === 'auto') {
                bLeft = 0;
            } else {
                bLeft = parseInt(bLeft.replace('px', ''), 10);
            }

            bWidth = $('body').width();
            bRight = bLeft + bWidth;
            fmRight = bRight;
            fddMaxWidth = Math.floor(fmRight - ddLeft);

            // set max-width and max-height
            fm.css('max-height', fmMaxHeight);
            fdd.css('max-width', fddMaxWidth);

            // ensure the parent drop down div has enough width space to host its tree content
            parentOffset = parseInt(fdd.css('padding-left').replace('px', ''), 10) +
                        parseInt(fdd.css('padding-right').replace('px', ''), 10) +
                        parseInt(fdd.css('border-left-width').replace('px', ''), 10) +
                        parseInt(fdd.css('border-right-width').replace('px', ''), 10);

            // measure the actual tree size
            scrollTop = fm[0].scrollTop;
            fm.detach();
            elementSize = $this._getElementSize(fm);
            fdd.prepend(fm);
            fm[0].scrollTop = scrollTop;

            // ensure we have the width to meet at least min-width value
            fddWidth = elementSize[0] + $this._getScrollBarWidth() + parseInt(fm.css('padding-right').replace('px', ''), 10) + parentOffset;
            fddWidth = Math.max(fddWidth, parseInt(fdd.css('min-width').replace('px', ''), 10));
            fdd.css('width', fddWidth);

            // the vertical scroll bar has appeared
            if (fmHeight > fmMaxHeight || onExpand === false) {
                if (fddWidth <= fddMaxWidth) {
                    fm.css('overflow-x', 'hidden');
                } else {
                    fm.css('overflow-x', 'auto');
                }
            }
        },
        _initTree: function (filterMembersTree, hierarchyFilterView) {
            var $this = this, dataSource = this._ds, checkChildNodes, parsedFilterMembers;

            $(filterMembersTree)
                .siblings(".ui-igpivot-filterdropdown-buttoncontainer")
                .children(".ui-igbutton[data-role=ok]")
                .igButton("enable");

            checkChildNodes = function (nodeElement, filterMembers) {
                var isSelected, state, i, filterMember;
                for (i = 0; i < filterMembers.length; i++) {
                    filterMember = filterMembers[i].filterMember;

                    isSelected = filterMember.isSelected();
                    if (isSelected.hasValue()) {
                        if (isSelected.value()) {
                            state = "on";
                        } else {
                            state = "off";
                        }
                    } else {
                        state = "partial";
                    }

                    $(nodeElement).find(".ui-igtree-node[data-value='" + filterMembers[i].uniqueName + "']")
                        .children("[data-role=checkbox]").attr("data-chk", state).children("span")
                        .removeClass("ui-state-disabled ui-igcheckbox-normal-on ui-igcheckbox-normal-partial ui-igcheckbox-normal-off")
                        .addClass("ui-igcheckbox-normal-" + state + (state === "partial" ? " ui-igcheckbox-normal-on ui-state-disabled" : ""));
                }
            };

            parsedFilterMembers = this._parseFilterMembers(hierarchyFilterView.getRootFilterMembers());
            // Create the filters tree.
            filterMembersTree.igTree({
                dataSource: parsedFilterMembers,
                loadOnDemand: true,
                checkboxMode: "triState",
                bindings: {
                    textKey: "caption",
                    valueKey: "uniqueName",
                    childDataProperty: "children"
                },

                nodeCollapsed: function (event, ui) {
                    $this._arrangeDropDown(false);
                },

                nodeCheckstateChanged: function (event, ui) {
                    var okButton, isSelected;

                    okButton = $(this)
                        .siblings(".ui-igpivot-filterdropdown-buttoncontainer")
                        .children(".ui-igbutton[data-role=ok]");
                    if (ui.newCheckedNodes && ui.newCheckedNodes.length > 0) {
                        okButton.igButton("enable");
                    } else {
                        okButton.igButton("disable");
                    }

                    isSelected = $(ui.node.element).children("[data-role=checkbox]").attr("data-chk");
                    isSelected = isSelected === "partial" ? null : (isSelected === "on" ? true : false);
                    ui.node.data.filterMember.isSelected($.ig.util.toNullable($.ig.Boolean.prototype.$type, isSelected));
                    //ui.node.data.filterMember.isSelected(isSelected);
                },

                nodeExpanded: function(ect, ui) {
					$this._arrangeDropDown(true);
                    var i, collection, element;

                    if (!$.ig.Pivot._pivotShared._showLastLevelExpanders) {

                        element = ui.node.element;
                        collection = ui.node.data.children;

                        if (collection !== null && 0 < collection.length) {
                            for (i = 0; i < collection.length; i++) {
                                if (null !== collection[i].children && 0 === collection[i].children.length) {
                                    element
                                    .find(".ui-igtree-node")
                                    .eq(i)
                                    .find('span:first')
                                    .css('display', 'none');
                                }
                            }
                        }
                    }
                }
            })
            .css('overflow-x', 'hidden')
            .data(_tree)._executeUrlRequest = function (node, binding, path, key) {
                var $$this = this, nodeData = this.nodeDataFor(node.attr("data-path")), ul, indicator, levels;

                ul = node.children("ul");
                // Create loading indicator space
                $("<li style='width:20px; height:20px;' data-role='loading'>&nbsp;</li>").appendTo(ul);
                ul.show();
                // K.D. December 19th, 2011 Bug #98217 Adding flag pointing that the loading indicator is instantiated by the tree
                indicator = ul.children("li").igLoading({ includeVerticalOffset: true, cssClass: "ui-igpivotgrid-tree-blockarea" }).data("igLoading").indicator();
                indicator.show();

                this._populatingNode = {
                    ul: ul,
                    node: node,
                    indicator: indicator
                };

                levels = dataSource.getCoreElements(function(el) {
                        return el.hierarchyUniqueName() === nodeData.member.hierarchyUniqueName();
                }, $.ig.Level.prototype.$type);
                
                $.ig.Pivot._pivotShared._showLastLevelExpanders = true;
                dataSource.getMembersOfMember(nodeData.member.uniqueName()).done(function (members) {
                    var parsedFilterMembers1;

                    if (members.item(0) && levels.length - 1 === members.item(0).levelDepth()) {
                        $.ig.Pivot._pivotShared._showLastLevelExpanders = false;
                    }

                    hierarchyFilterView.addFiltersForMembers(members);
                    parsedFilterMembers1 = $this._parseFilterMembers(nodeData.filterMember.children());
                    $$this._populateNodeData(true, "", {
                        // Create a dummy object with a data method to simulate igDataSource.
                        data: function () { return parsedFilterMembers1; }
                    });
                    // Update or remove the expansion idicator of the parent node.
                    $$this._updateParentState(node);
                    checkChildNodes(node, nodeData.children);
                    $this._triggerFilterMembersLoaded(node, parsedFilterMembers, parsedFilterMembers1);
                });
            };
            // Check the root nodes.
            checkChildNodes(filterMembersTree, parsedFilterMembers);

            this._triggerFilterMembersLoaded(filterMembersTree, parsedFilterMembers, parsedFilterMembers);
        },
        _parseFilterMembers: function (filterMembers) {
            var parsedFilterMembers, parsedFilterMember, filterMember, member, i;

            if (filterMembers === null) {
                return [];
            }

            filterMembers = filterMembers.__inner; //toArray();
            parsedFilterMembers = [];
            for (i = 0; i < filterMembers.length; i++) {
                filterMember = filterMembers[i];
                member = filterMember.member();

                parsedFilterMember = {};
                parsedFilterMember.filterMember = filterMember;
                parsedFilterMember.member = member;
                parsedFilterMember.caption = member.caption();
                parsedFilterMember.uniqueName = member.uniqueName();
                parsedFilterMember.children = [];

                parsedFilterMembers.push(parsedFilterMember);
            }

            return parsedFilterMembers;
        },
        _onFilterOk: function (event, dropDownElement, hierarchyFilterView, hierarchy) {
            var dataSource = this._ds, hierarchyName = hierarchy.uniqueName(),
                filterMembers, checkedFilterMembers, i, noCancel;

            filterMembers = hierarchyFilterView.getSelectedFilterItems().__inner; //toArray();

            checkedFilterMembers = [];
            for (i = 0; i < filterMembers.length; i++) {
                checkedFilterMembers.push(filterMembers[i].member().uniqueName());
            }

            noCancel = this._triggerFilterDropDownOk(event, dropDownElement, hierarchy, checkedFilterMembers);
            if (noCancel) {
                dataSource.removeAllFilterMembers(hierarchyName);
                for (i = 0; i < checkedFilterMembers.length; i++) {
                    dataSource.addFilterMember(hierarchyName, checkedFilterMembers[i]);
                }

                this._updateDataSource();
                this._removeFilterDropDown(event, dropDownElement, hierarchy);
            }
        },
        _removeFilterDropDown: function (event, dropDownElement, hierarchy) {
            var noCancel;

            noCancel = this._triggerFilterDropDownClosing(event, dropDownElement, hierarchy);
            if (noCancel) {
                dropDownElement.find(".ui-igtree").igTree("destroy");
                dropDownElement.find(".ui-button").igButton("destroy");
                dropDownElement.remove();
                // Detach from the document events in a safe way.
                $(document).unbind("." + this.widgetName);

                // Remove the overlay.
                // $("." + this.css.filterDropDownOverlay).remove();

                this._triggerFilterDropDownClosed(event, hierarchy);
            }
        },
        _triggerDataSourceInitialized: function (evt, args) {
            this._trigger("dataSourceInitialized", evt, args);
        },
        _triggerDataSourceUpdated: function (evt, args) {
            this._trigger("dataSourceUpdated", evt, args);
        },
        _triggerDragStart: function (event, ui, item) {
            var args = {
                helper: ui.helper,
                offset: ui.offset,
                originalPosition: ui.originalPosition,
                position: ui.position,
                metadata: item
            };

            // Make the overlay drop areas available only while dragging
            $(".ui-igpivot-overlaydroparea").css("display", "block");
            return this._trigger("dragStart", event, args);
        },
        _triggerDrag: function (event, ui, item) {
            var args = {
                helper: ui.helper,
                offset: ui.offset,
                originalPosition: ui.originalPosition,
                position: ui.position,
                metadata: item
            };

            return this._trigger("drag", event, args);
        },
        _triggerDragStop: function (event, ui) {
            $(".ui-igpivot-overlaydroparea").css("display", "none");
            this._trigger("dragStop", event, ui);
        },
        _triggerMetadataDropping: function (event, ui, targetElement, item, itemIndex) {
            var args = {
                helper: ui.helper,
                offset: ui.offset,
                position: ui.position,
                targetElement: targetElement,
                metadata: item,
                metadataIndex: itemIndex
            };

            return this._trigger("metadataDropping", event, args);
        },
        _triggerMetadataDropped: function (event, ui, targetElement, draggedElement, item, itemIndex) {

            var args = {
                helper: ui.helper,
                offset: ui.offset,
                position: ui.position,
                targetElement: targetElement,
                draggedElement: draggedElement,
                metadata: item,
                metadataIndex: itemIndex
            };

            this._trigger("metadataDropped", event, args);
        },
        _triggerMetadataRemoving: function (event, targetElement, item) {
            var args = {
                targetElement: targetElement,
                metadata: item
            };

            return this._trigger("metadataRemoving", event, args);
        },
        _triggerMetadataRemoved: function (event, item) {
            var args = {
                metadata: item
            };

            this._trigger("metadataRemoved", event, args);
        },
        _triggerFilterDropDownOpening: function (event, hierarchy) {
            var args = {
                hierarchy: hierarchy
            };

            return this._trigger("filterDropDownOpening", event, args);
        },
        _triggerFilterDropDownOpened: function (event, dropDownElement, hierarchy) {
            var args = {
                dropDownElement: dropDownElement,
                hierarchy: hierarchy
            };

            this._trigger("filterDropDownOpened", event, args);
        },
        _triggerFilterMembersLoaded: function (parent, rootFilterMembers, filterMembers) {
            var args = {
                parent: parent,
                rootFilterMembers: rootFilterMembers,
                filterMembers: filterMembers
            };

            this._trigger("filterMembersLoaded", null, args);
        },
        _triggerFilterDropDownOk: function (event, dropDownElement, hierarchy, filterMembers) {
            var args = {
                dropDownElement: dropDownElement,
                hierarchy: hierarchy,
                filterMembers: filterMembers
            };

            return this._trigger("filterDropDownOk", event, args);
        },
        _triggerFilterDropDownClosing: function (event, dropDownElement, hierarchy) {
            var args = {
                dropDownElement: dropDownElement,
                hierarchy: hierarchy
            };

            return this._trigger("filterDropDownClosing", event, args);
        },
        _triggerFilterDropDownClosed: function (event, hierarchy) {
            var args = {
                hierarchy: hierarchy
            };

            this._trigger("filterDropDownClosed", event, args);
        }
    };

    $.widget("ui.igOlapDataSourceWidget", {
        _create: function () {
            this._ds = $.ig.Pivot._pivotShared._createDataSource(null, this.options.dataSourceOptions);
        },
        dataSource: function () {
            /* Returns the associated data source of the OLAP data source widget. The data source will be an instance of $.ig.OlapXmlaDataSource or $.ig.OlapFlatDataSource, or null.
            returnType="object"
            */
            return this._ds;
        }
    });
} (jQuery));

/*!@license
* Infragistics.Web.ClientUI Pivot Data Selector 14.1.20141.2249
*
* Copyright (c) 2011-2012 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends on: 
*	jquery-1.4.4.js
*	jquery.ui.core.js
*	jquery.ui.widget.js
*	jquery.ui.draggable.js
*	jquery.ui.droppable.js
*	infragistics.util.js
*	infragistics.datasource.js
*	infragistics.olapxmladatasource.js
*	infragistics.olapflatdatasource.js
*	infragistics.templating.js
*	infragistics.ui.shared.js
*   infragistics.ui.scroll.js
*	infragistics.ui.combo.js
*	infragistics.ui.tree.js
*	infragistics.ui.pivot.shared.js
*/
/*global jQuery, Modernizr */

(function ($) {
    var _droppable = $.ui.droppable.prototype.widgetFullName || $.ui.droppable.prototype.widgetName;

    $.widget("ui.igPivotDataSelector", {
        css: {
            /* Class applied to the the data selector element. */
            dataSelector: "ui-igpivotdataselector",
            /* Class applied to the root container for the data selector. */
            dataSelectorRoot: "ui-igpivotdataselector-root",
            /* Class applied to the catalog combo. */
            catalog: "ui-igpivotdataselector-catalog",
            /* Class applied to the cube combo. */
            cube: "ui-igpivotdataselector-cube",
            /* Class applied to the measure group combo. */
            measureGroup: "ui-igpivotdataselector-measuregroup",
            /* Classes applied to the metadata tree. */
            metadata: "ui-igpivotdataselector-metadata ui-widget-content",
            /* Classes applied to the elements representing metadata items - in the metadata tree and the drop areas. */
            metadataItem: "ui-igpivot-metadataitem ui-widget ui-corner-all ui-state-default",
            /* Class applied to the table with the drop areas. */
            dropAreasTable: "ui-igpivotdataselector-dropareas",
            /* Classes applied to the drop areas. */
            dropArea: "ui-igpivot-droparea ui-widget-content",
            /* Class applied to the drop areas, which can accept a drop. */
            activeDropArea: "active",
            /* Classes applied to the filters drop area icon. */
            filtersIcon: "ui-icon ui-icon-pivot-filters",
            /* Classes applied to the columns drop area icon. */
            columnsIcon: "ui-icon ui-icon-pivot-columns",
            /* Classes applied to the rows drop area icon. */
            rowsIcon: "ui-icon ui-icon-pivot-rows",
            /* Classes applied to the measures drop area icon. */
            measuresIcon: "ui-icon ui-icon-pivot-measures",
            /* Class applied to the update layout button. */
            updateLayout: "ui-igpivotdataselector-updatelayout",
            /* Class applied to the valid drop element. */
            dropIndicator: "ui-state-highlight",
            /* Class applied to the invalid drop element. */
            invalidDropIndicator: "ui-state-error",
            /* Classes applied to the insert item indicator in the drop areas. */
            insertItem: "ui-igpivot-insertitem ui-state-highlight ui-corner-all",
            /* Classes applied to the metadata item drop down element. */
            metadataItemDropDown: "ui-igpivot-metadatadropdown ui-widget ui-widget-content",
            /* Classes applied to the filter icon in the metadata items. */
            filterIcon: "ui-icon ui-icon-pivot-smallfilter",
            /* Classes applied to the filters drop down element. */
            filterDropDown: "ui-igpivot-filterdropdown ui-widget ui-widget-content",
            /* Class applied to the tree containing the filter members. */
            filterMembers: "ui-igpivot-filtermembers"
            ///* Class applied to the overlay element, which is over the data selector when a filter drop down is open. */
            //filterDropDownOverlay: "ui-igpivot-overlay"
        },
        options: {
            /* type="string|number|null"
				string The widget width can be set in pixels (px) and percentage (%). The recommended width is 250px.
				number The widget width can be set as a number.
				null type="object" will stretch to fit data, if no other widths are defined.
			*/
            width: 250,
            /* type="string|number|null" This is the total height of the grid, including all UI elements - scroll container with data rows, header, footer, filter row -  (if any), etc.  
				string The widget height can be set in pixels (px) and percentage (%).
				number The widget height can be set as a number.
				null type="object" will stretch vertically to fit data, if no other heights are defined.
			*/
            height: null,
            /* type="object" An instance of $.ig.OlapXmlaDataSource or $.ig.OlapFlatDataSource.
            */
            dataSource: null,
            /* type="object" An object that will be used to create an instance of $.ig.OlapXmlaDataSource or $.ig.OlapFlatDataSource.
                The provided value must contain an object with settings for one of the data source types - xmlaOptions or flatDataOptions.
            */
            dataSourceOptions: {
                /* type="object" Settings for creating an instance of $.ig.OlapXmlaDataSource.
                */
                xmlaOptions: {
                    /* type="string" optional="false" The URL of the XMLA server.
                    */
                    serverUrl: null,
                    /* type="string" The catalog name.
                    */
                    catalog: null,
                    /* type="string" The name of the cube in the data source.
                    */
                    cube: null,
                    /* type="string" The name of the measure group in the data source.
                    */
                    measureGroup: null,
                    /* type="object" An object containing information about how the request to the XMLA server should be processed.
                    */
                    requestOptions: {
                        /* type="bool" The value is applied to XmlHttpRequest.withCredentials if supported by the user agent.
                            Setting this property to true will allow IE8/IE9 to make authenticated cross-origin requests to tusted domains through XmlHttpRequest instead of XDomainRequest
                            and will prompt the user for credentials.
                        */
                        withCredentials: false,
                        /* type="function" A callback to be invoked right before the request is send to the server. Extends beforeSend callback of jQuery.ajax’s options object.
                        */
                        beforeSend: null
                    },
                    /* type="bool" Enables/disables caching of the XMLA result object.
                    */
                    enableResultCache: true,
                    /* type="object" Additional properties sent with every discover request.
                        The object is treated as a key/value store where each property name is used as the key and the property value as the value.
                    */
                    discoverProperties: null,
                    /* type="object" Additional properties sent with every execute request.
                        The object is treated as a key/value store where each property name is used as the key and the property value as the value.
                    */
                    executeProperties: null,
                    /* type="object" optional="true" a javascript object containing information about how the request to the xmla server should be processed 
                    */
                    mdxSettings: {
                        /* type="bool" optional="true" a value indicating whether a NON EMPTY clause is present on ROWS axis. Default value is true 
                        */
                        nonEmptyOnRows: true,
                        /* type="bool" optional="true" a value indicating whether a NON EMPTY clause is present on COLUMNS axis. Default value is true 
                        */
                        nonEmptyOnColumns: true,
                        /* type="bool" optional="true" a value indicating whether a members' set expressions on ROWS axis should be wrapped with AddCalculatedMembers MDX method. Default value is true 
                        */
                        addCalculatedMembersOnRows: true,
                        /* type="bool" optional="true" a value indicating whether a members' set expressions on COLUMNS axis should be wrapped with AddCalculatedMembers MDX method. Default value is true 
                        */
                        addCalculatedMembersOnColumns: true,
                        /* type="array" optional="true" a string array with the names of intrinsic non-context sensitive member properties applied on ROWS axis. By defult CHILDREN_CARDINALITY and PARENT_UNIQUE_NAME properties are always added to DIMENSION PROPERTIES 
                        */
                        dimensionPropertiesOnRows: [],
                        /* type="array" optional="true" a string array with the names of intrinsic non-context sensitive member properties applied on COLUMNS axis. By defult CHILDREN_CARDINALITY and PARENT_UNIQUE_NAME properties are always added to DIMENSION PROPERTIES
                        */
                        dimensionPropertiesOnColumns: []
                    }
                },
                /* type="object" Settings for creating an instance of $.ig.OlapFlatDataSource.
                */
                flatDataOptions: {
                    /* type="object" Specifies any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself.
                    */
                    dataSource: null,
                    /* type="string" Specifies a remote URL accepted by $.ig.DataSource in order to request data from it.
                    */
                    dataSourceUrl: null,
                    /* type="string" Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property. 
                    */
                    dataSourceType: null,
                    /* type="string" see $.ig.DataSource. 
                        string Specifies the name of the property in which data records are held if the response is wrapped. 
                        null Option is ignored.
                    */
                    responseDataKey: null,
                    /* type="string" 
                        string Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property.
                        null Option is ignored.
                    */
                    responseDataType: null,
                    /* type="object" optional="false" An object containing processing instructions for the $.ig.DataSource data.
                    */
                    metadata: {
                        /* type="object" optional="false" Metadata used for the creation of the cube.
                        */
                        cube: {
                            /* type="string" optional="false" A unique name for the cube.
                            */
                            name: null,
                            /* type="string" A caption for the cube.
                            */
                            caption: null,
                            /* type="object" An object providing information about the measures' root node.
                            */
                            measuresDimension: {
                                /* type="string" A unique name for the measures dimension.
                                    The default value is "Measures". This name is used to create the names of dimensions using the following pattern:
                                    [<measuresDimensionMetadata.name>].[<measureMetadata.name>]
                                */
                                name: null,
                                /* type="string" A caption for the measures dimension.
                                    The default value is "Measures".
                                */
                                caption: null,
                                /* type="array" An array of measure metadata objects.
                                */
                                measures: [{
                                    /* type="string" optional="false" A unique name for the measure.
                                    */
                                    name: null,
                                    /* type="string" A caption for the measure.
                                    */
                                    caption: null,
                                    /* type="function" optional="false" An aggregator function called when each cell is evaluated.
                                        Returns a value for the cell. If the returned value is null, no cell will be created in for the data source result.
                                    */
                                    aggregator: null,
                                    /* type="string" The path used when displaying the measure in the user interface. Nested folders are indicated by a backslash (\).
                                    */
                                    displayFolder: null
                                }]
                            },
                            /* type="array" An array of dimension metadata objects.
                            */
                            dimensions: [{
                                /* type="string" optional="false" A unique name for the dimension.
                                */
                                name: null,
                                /* type="string" A caption for the dimension.
                                */
                                caption: null,
                                /* type="array" An array of hierarchy metadata objects.
                                */
                                hierarchies: [{
                                    /* type="string" optional="false" A name for the hierarchy.
                                        The unique name of the hierarchy is formed using the following pattern:
                                        [<parentDimension.name>].[<hierarchyMetadata.name>]
                                    */
                                    name: null,
                                    /* type="string" A caption for the hierarchy.
                                    */
                                    caption: null,
                                    /* type="string" The path to be used when displaying the hierarchy in the user interface. 
                                        Nested folders are indicated by a backslash (\). 
                                        The folder hierarchy will appear under parent dimension node.
                                    */
                                    displayFolder: null,
                                    /* type="array" An array of level metadata objects.
                                    */
                                    levels: [{
                                        /* type="string" optional="false" A name for the level.
                                            The unique name of the level is formed using the following pattern:
                                            {<hierarchy.uniqueName>}.[<levelMetadata.name>]
                                        */
                                        name: null,
                                        /* type="string" A caption for the level.
                                        */
                                        caption: null,
                                        /* type="function" A function called for each item of the data source array when level members are created.
                                            Based on the item parameter the function should return a value that will form the $.ig.Member’s name and caption.
                                        */
                                        memberProvider: null
                                    }]
                                }]
                            }]
                        }
                    }
                },
                /* type="string" A list of measure names separated by comma (,). These will be the measures of the data source.
                */
                measures: null,
                /* type="string" A list of hierarchy names separated by comma (,). These will be hierarchies in the filters of the data source.
                */
                filters: null,
                /* type="string" A list of hierarchy names separated by comma (,). These will be the hierarchies in the rows of the data source.
                */
                rows: null,
                /* type="string" A list of hierarchy names separated by comma (,). These will be the hierarchies in the columns of the data source.
                */
                columns: null
            },
            /* type="bool" Setting deferUpdate to true will not apply changes to the data source until the update method is called or the update layout button is clicked.
            */
            deferUpdate: false,
            /* type="object" Settings for the drag and drop functionality of the igPivotDataSelector.
            */
            dragAndDropSettings: {
                /* type="parent|selector|element" Which element the draggable helper should be appended to while dragging.
                */
                appendTo: "body",
                /* type="boolean|selector|element|string|array" Specifies the containment for the drag helper. The area inside of which the 
                                    helper is contained would be scrollable while dragging.
                */
                containment: false,
                /* type="number" Specifies z-index that would be set for the drag helper. 
                */
                zIndex: 10
            },
            /* type="jQuery|element|selector" Specifies the parent for the drop downs.
            */
            dropDownParent: "body",
            /* type="bool" Disable the drag and drop for the rows drop area and the ability to use filtering and remove items from it.
            */
            disableRowsDropArea: false,
            /* type="bool" Disable the drag and drop for the columns drop area and the ability to use filtering and remove items from it.
            */
            disableColumnsDropArea: false,
            /* type="bool" Disable the drag and drop for the measures drop area and the ability to use filtering and remove items from it.
            */
            disableMeasuresDropArea: false,
            /* type="bool" Disable the drag and drop for the filters drop area and the ability to use filtering and remove items from it.
            */
            disableFiltersDropArea: false,
            /* type="function" A function that will be called to determine if an item can be moved in or dropped on an area of the data selector.
                paramType="string" The location where the item will be moved - igPivotGrid, igPivotDataSelector, filters, rows, columns or measures.
                paramType="string" The type of the item - Hierarchy, Measure or MeasureList.
                paramType="string" The unique name of the item.
                returnType="bool"  The function must return true if the item should be accepted.
			*/
            customMoveValidation: null
        },
        events: {
            /* cancel="false" Fired after the data selector is rendered. Changing the data source instance will re-render the data selector.
                Function takes arguments evt and ui.
                Use ui.owner to get a reference to the data selector.
            */
            dataSelectorRendered: null,
            /* cancel="false" Fired after the data source has initialized.
                Function takes arguments evt and ui.
                Use ui.owner to get a reference to the data selector.
                Use ui.dataSource to get a reference to the data source.
                Use ui.error to see if an error has occured during initialization.
                Use ui.metadataTreeRoot to get a reference to the root of the data source metatadata root item.
            */
            dataSourceInitialized: null,
            /* cancel="false" Fired after the data source has updated.
                Function takes arguments evt and ui.
                Use ui.owner to get a reference to the data selector.
                Use ui.dataSource to get a reference to the data source.
                Use ui.error to see if an error has occured during update.
                Use ui.result to get the result of the update operation.
            */
            dataSourceUpdated: null,
            /* cancel="false" Fired when the defer update checkbox changes.
                Function takes arguments evt and ui.
                Use ui.owner to get a reference to the data selector.
                Use ui.deferUpdate to get the defer update value.
            */
            deferUpdateChanged: null,
            /* cancel="true" Fired on drag start. Return false to cancel the drag.
				Use ui.metadata	to get a reference to the data.
				Use ui.helper to get a reference to the helper.
				Use ui.offset to get a reference to the offset.
				Use ui.originalPosition to get a reference to the original position of the draggable element.
				Use ui.position to get a reference to the current position of the draggable element.
            */
            dragStart: null,
            /* cancel="true" Fired on drag. Return false to cancel the dragging.
				Use ui.metadata	to get a reference to the data.
				Use ui.helper to get a reference to the helper.
				Use ui.offset to get a reference to the offset.
				Use ui.originalPosition to get a reference to the original position of the draggable element.
				Use ui.position to get a reference to the current position of the draggable element.
            */
            drag: null,
            /* cancel="false" Fired on drag stop.
				Use ui.helper to get a reference to the helper.
				Use ui.offset to get a reference to the offset.
				Use ui.originalPosition to get a reference to the original position of the draggable element.
				Use ui.position to get a reference to the current position of the draggable element.
            */
            dragStop: null,
            /* cancel="true" Fired before a metadata item drop. Return false to cancel the drop.
                Use ui.targetElement for a reference to the drop target.
                Use ui.draggedElement for a reference to the dragged element.
				Use ui.metadata	to get a reference to the data.
                Use ui.metadataIndex to get the index at which the metadata will be inserted.
				Use ui.helper to get a reference to the helper.
				Use ui.offset to get a reference to the offset.
				Use ui.position to get a reference to the current position of the draggable element.
            */
            metadataDropping: null,
            /* cancel="false" Fired after a metadata item drop.
                Use ui.targetElement for a reference to the drop target.
                Use ui.draggedElement for a reference to the dragged element.
				Use ui.metadata	to get a reference to the data.
                Use ui.metadataIndex to get the index at which the metadata is inserted.
				Use ui.helper to get a reference to the helper.
				Use ui.offset to get a reference to the offset.
				Use ui.position to get a reference to the current position of the draggable element.
            */
            metadataDropped: null,
            /* cancel="true" Fired before a metadata item is removed when the user clicks the close icon. Return false to cancel the removing.
                Use ui.targetElement for a reference to the dragged element.
                Use ui.metadata	to get a reference to the data.
            */
            metadataRemoving: null,
            /* cancel="false" Fired after a metadata item is removed when the user clicks the close icon.
                Use ui.metadata	to get a reference to the data.
            */
            metadataRemoved: null,
            /* cancel="true" Fired before the filter members drop down opens. Return false to cancel the opening.
                Use ui.hierarchy for a reference to the hierarchy.
            */
            filterDropDownOpening: null,
            /* cancel="false" Fired after the filter members drop down opens.
                Use ui.hierarchy for a reference to the hierarchy.
                Use ui.dropDownElement for a reference to the drop down.
            */
            filterDropDownOpened: null,
            /* cancel="false" Fired after the filter members are loaded.
                Use ui.parent to get the parent node or the igTree instance in the initial load.
                Use ui.rootFilterMembers for a collection with the root filter members (deprecated).
                Use ui.filterMembers for a collection with the newly loaded filter members.
            */
            filterMembersLoaded: null,
            /* cancel="true" Fired after the OK button in the filter members drop down is clicked. Return false to cancel the applying of the filters.
                Use ui.hierarchy for a reference to the hierarchy.
                Use ui.filterMembers for a collection with the selected filter members. If all filter members are selected the collection will be empty.
                Use ui.dropDownElement for a reference to the drop down.
            */
            filterDropDownOk: null,
            /* cancel="true" Fired before the filter members drop down closes. Return false to cancel the closing.
                Use ui.hierarchy for a reference to the hierarchy.
                Use ui.dropDownElement for a reference to the drop down.
            */
            filterDropDownClosing: null,
            /* cancel="false" Fired after the filter members drop down closes.
                Use ui.hierarchy for a reference to the hierarchy.
            */
            filterDropDownClosed: null
        },
        _deferUpdate: false,
        _create: function () {
            var $this = this,
                elementName = this.element[0].nodeName.toUpperCase();
            if (elementName !== "DIV") {
                throw new Error(elementName + $.ig.PivotDataSelector.locale.invalidBaseElement);
            }

            this.element.addClass(this.css.dataSelector);

            // Create funcitons, which will act as handlers to the
            // collectionChanged events of the data source.
            // These handlers can be detached from the events in a safe way
            // (unlike if anonymous functions were used).
            this._onFiltersChanged = function (collection, collectionChangedArgs) {
                var dropArea = $this.element.find(".ui-igpivot-droparea[data-role=filters]");
                $this._onDataSourceCollectionChanged(collection, collectionChangedArgs, dropArea, $this.options.disableFiltersDropArea);
            };
            this._onRowAxisChanged = function (collection, collectionChangedArgs) {
                var dropArea = $this.element.find(".ui-igpivot-droparea[data-role=rows]");
                $this._onDataSourceCollectionChanged(collection, collectionChangedArgs, dropArea, $this.options.disableRowsDropArea);
            };
            this._onColumnAxisChanged = function (collection, collectionChangedArgs) {
                var dropArea = $this.element.find(".ui-igpivot-droparea[data-role=columns]");
                $this._onDataSourceCollectionChanged(collection, collectionChangedArgs, dropArea, $this.options.disableColumnsDropArea);
            };
            this._onMeasuresChanged = function (collection, collectionChangedArgs) {
                var dropArea = $this.element.find(".ui-igpivot-droparea[data-role=measures]");
                $this._onDataSourceCollectionChanged(collection, collectionChangedArgs, dropArea, $this.options.disableMeasuresDropArea);
            };
            this._setDataSource();

            this._makeDroppable(this.element);
        },
        _setOption: function (key, value) {
            var dropArea, droppable;

            switch (key) {
            case "dataSource":
                this._clearDataSource();
                this.options.dataSourceOptions = null;
                this.options.dataSource = this._createDataSource(value, null);
                this._setDataSource();
                break;
            case "dataSourceOptions":
                this._clearDataSource();
                this.options.dataSourceOptions = value;
                this.options.dataSource = this._createDataSource(null, value);
                this._setDataSource();
                break;
            case "deferUpdate":
                $.Widget.prototype._setOption.apply(this, arguments);
                this._deferUpdate = value;
                this.element.find(".ui-igpivotdataselector-deferupdate").attr("checked", value);
                this.element.find(".ui-igpivotdataselector-updatelayout").igButton(value ? "enable" : "disable");
                break;
            case "width":
                $.Widget.prototype._setOption.apply(this, arguments);
                this.element.width(value);
                this.element.find(".ui-igpivotdataselector-catalog, .ui-igpivotdataselector-cube, .ui-igpivotdataselector-measuregroup")
                    .igCombo("option", "width", this.element.children(".ui-igpivotdataselector-root").width());
                break;
            case "height":
                $.Widget.prototype._setOption.apply(this, arguments);
                this.element.height(value);
                break;
            case "dragAndDropSettings":
                $.Widget.prototype._setOption.apply(this, arguments);
                this.element.find(":ui-draggable").each(function (ind, el) {
                    var draggable = $(el);
                    draggable.draggable("option", "appendTo", value.appendTo);
                    draggable.draggable("option", "containment", value.containment);
                    draggable.draggable("option", "zIndex", value.zIndex);
                });
                break;
            case "disableRowsDropArea":
                $.Widget.prototype._setOption.apply(this, arguments);
                dropArea = this.element.find(".ui-igpivot-droparea[data-role=rows]");
                if (value) {
                    droppable = dropArea.data(_droppable);
                    if (droppable) {
                        droppable.destroy();
                    }
                } else if (!this._isTouch()) {
                    dropArea.droppable(this._createDropAreaOptions());
                }
                this._fillDropArea(dropArea, this._ds.rowAxis(), this.options.disableRowsDropArea);
                break;
            case "disableColumnsDropArea":
                $.Widget.prototype._setOption.apply(this, arguments);
                dropArea = this.element.find(".ui-igpivot-droparea[data-role=columns]");
                if (value) {
                    droppable = dropArea.data(_droppable);
                    if (droppable) {
                        droppable.destroy();
                    }
                } else if (!this._isTouch()) {
                    dropArea.droppable(this._createDropAreaOptions());
                }
                this._fillDropArea(dropArea, this._ds.columnAxis(), this.options.disableColumnsDropArea);
                break;
            case "disableMeasuresDropArea":
                $.Widget.prototype._setOption.apply(this, arguments);
                dropArea = this.element.find(".ui-igpivot-droparea[data-role=measures]");
                if (value) {
                    droppable = dropArea.data(_droppable);
                    if (droppable) {
                        droppable.destroy();
                    }
                } else if (!this._isTouch()) {
                    dropArea.droppable(this._createDropAreaOptions());
                }
                this._fillDropArea(dropArea, this._ds.measures(), this.options.disableMeasuresDropArea);
                break;
            case "disableFiltersDropArea":
                $.Widget.prototype._setOption.apply(this, arguments);
                dropArea = this.element.find(".ui-igpivot-droparea[data-role=filters]");
                if (value) {
                    droppable = dropArea.data(_droppable);
                    if (droppable) {
                        droppable.destroy();
                    }
                } else if (!this._isTouch()) {
                    dropArea.droppable(this._createDropAreaOptions());
                }
                this._fillDropArea(dropArea, this._ds.filters(), this.options.disableFiltersDropArea);
                break;
            }
        },
        _initUI: function () {
            var $this = this, dataSource = this._ds,
                rootDiv, comboOptions, droppableOptions, dropAreasTable, tableRow, tableHeader,
                tableColumn, dropArea, deferUpdateCheck, deferUpdateLabel;

            if (this.options.width) {
                this.element.width(this.options.width);
            }
            if (this.options.height) {
                this.element.height(this.options.height);
            }

            rootDiv = $("<div class='ui-widget " + this.css.dataSelectorRoot + "'></div>").appendTo(this.element);

            if (this._isInstance(dataSource, "OlapXmlaDataSource")) {
                // Add catalog, cube and measure group combos
                // if the data source supports these properties.
                // Flat data does not support them.
                comboOptions = {
                    textKey: "_caption",
                    valueKey: "_name",
                    mode: "dropdown",
                    enableClearButton: false,
                    width: rootDiv.width()
                };
                // Catalog
                $("<input class='" + this.css.catalog + "' />").appendTo(rootDiv)
                    .igCombo($.extend({
                        nullText: $.ig.PivotDataSelector.locale.catalog,
                        selectionChanged: function (evt, ui) {
                            $this._onCatalogSelected(ui.items[0].value);
                        }
                    }, comboOptions));
                // Cube
                $("<input class='" + this.css.cube + "' />").appendTo(rootDiv)
                    .igCombo($.extend({
                        nullText: $.ig.PivotDataSelector.locale.cube,
                        selectionChanged: function (evt, ui) {
                            $this._onCubeSelected(ui.items[0].value);
                        }
                    }, comboOptions));
                // Measure Group
                $("<input class='" + this.css.measureGroup + "' />").appendTo(rootDiv)
                    .igCombo($.extend({
                        nullText: $.ig.PivotDataSelector.locale.measureGroup,
                        selectionChanged: function (evt, ui) {
                            $this._onMeasureGroupSelected(ui.items[0].value);
                        }
                    }, comboOptions));
            }

            // Metadata
            $("<div class='" + this.css.metadata + "'></div>").appendTo(rootDiv).addClass().igTree({
                initialExpandDepth: 0,
                bindings: {
                    nodeContentTemplate: "<span class='ui-igpivot-metadataitem' data-name='${name}' data-type='${type}'><span class='${image}'/>${caption}</span>",
                    childDataProperty: "children"
                },
                rendered: function(evt, ui) {
                    ui.owner.element.removeAttr('data-scroll');
                }
            });

            // Drop Areas
            droppableOptions = this._createDropAreaOptions();

            dropAreasTable = $("<table class='" + this.css.dropAreasTable + "'></table>").appendTo(rootDiv);

            tableRow = $("<tr></tr>").appendTo(dropAreasTable);
            tableHeader = $("<th></th>").appendTo(tableRow);
            $("<span class='" + this.css.filtersIcon  + "'></span>").appendTo(tableHeader);
            $("<span></span>").text($.ig.PivotDataSelector.locale.filters).appendTo(tableHeader);
            tableHeader = $("<th></th>").appendTo(tableRow);
            $("<span class='" + this.css.columnsIcon + "'></span>").appendTo(tableHeader);
            $("<span></span>").text($.ig.PivotDataSelector.locale.columns).appendTo(tableHeader);

            tableRow = $("<tr></tr>").appendTo(dropAreasTable);
            tableColumn = $("<td></td>").appendTo(tableRow);
            dropArea = $("<ul class='" + this.css.dropArea + "' data-role='filters'></ul>").appendTo(tableColumn);
            if (!this.options.disableFiltersDropArea && !this._isTouch()) {
                dropArea.droppable(droppableOptions);
            }
            tableColumn = $("<td></td>").appendTo(tableRow);
            dropArea = $("<ul class='" + this.css.dropArea + "' data-role='columns'></ul>").appendTo(tableColumn);
            if (!this.options.disableColumnsDropArea && !this._isTouch()) {
                dropArea.droppable(droppableOptions);
            }

            tableRow = $("<tr></tr>").appendTo(dropAreasTable);
            tableHeader = $("<th></th>").appendTo(tableRow);
            $("<span class='" + this.css.rowsIcon + "'></span>").appendTo(tableHeader);
            $("<span></span>").text($.ig.PivotDataSelector.locale.rows).appendTo(tableHeader);
            tableHeader = $("<th></th>").appendTo(tableRow);
            $("<span class='" + this.css.measuresIcon + "'></span>").appendTo(tableHeader);
            $("<span></span>").text($.ig.PivotDataSelector.locale.measures).appendTo(tableHeader);

            tableRow = $("<tr></tr>").appendTo(dropAreasTable);
            tableColumn = $("<td></td>").appendTo(tableRow);
            dropArea = $("<ul class='" + this.css.dropArea + "' data-role='rows'></ul>").appendTo(tableColumn);
            if (!this.options.disableRowsDropArea && !this._isTouch()) {
                dropArea.droppable(droppableOptions);
            }
            tableColumn = $("<td></td>").appendTo(tableRow);
            dropArea = $("<ul class='" + this.css.dropArea + "' data-role='measures'></ul>").appendTo(tableColumn);
            if (!this.options.disableMeasuresDropArea && !this._isTouch()) {
                dropArea.droppable(droppableOptions);
            }

            if (this._isTouch()) {
                dropAreasTable.find(".ui-igpivot-droparea").igScroll();
            }

            // Defer Update
            this._deferUpdate = this.options.deferUpdate;
            deferUpdateLabel = $("<label></label>").appendTo(rootDiv).text($.ig.PivotDataSelector.locale.deferUpdate);
            deferUpdateCheck = $("<input class='ui-igpivotdataselector-deferupdate' type='checkbox' />").prependTo(deferUpdateLabel).change(function (event) {
                $this._deferUpdate = $(event.target).is(":checked");
                if ($this._deferUpdate) {
                    $this.element.find(".ui-igpivotdataselector-updatelayout").igButton("enable");
                } else {
                    $this.element.find(".ui-igpivotdataselector-updatelayout").igButton("disable");
                    // Trigger an update after defer update is unchecked.
                    $this._updateDataSource();
                }
                $this._triggerDeferUpdateChanged($this._deferUpdate);
            });
            $("<button class='" + this.css.updateLayout + "'></button>").attr("title", $.ig.PivotDataSelector.locale.updateLayout)
                .appendTo(rootDiv).igButton({
                    text: false,
                    icons: {
                        primary: "ui-icon-refresh"
                    }
                }).igButton(this._deferUpdate ? "enable" : "disable").click(function () {
                    $this._updateDataSource(true);
                });

            this._triggerDataSelectorRendered();
        },
        _clearUI: function () {
            this.element.find(".ui-igpivotdataselector-catalog, .ui-igpivotdataselector-cube, .ui-igpivotdataselector-measuregroup").igCombo("destroy");
            this.element.find(".ui-igpivotdataselector-metadata").igTree("destroy");
            this.element.find(".ui-igpivot-droparea .ui-igpivot-metadataitem.ui-draggable").draggable("destroy").remove();
            this.element.empty();
        },
        _setDataSource: function () {
            var $this = this, dataSource;

            this._ds = dataSource = this._createDataSource(
                this.options.dataSource,
                this.options.dataSourceOptions
            );

            this._initUI();

            if (!dataSource) {
                return;
            }

            this.timestamp = new Date().getTime();
            $(dataSource).bind("initialized.dataselector" + this.timestamp, function (evt, args) {
                $this._onDataSourceInitialized(evt, args);
            });
            $(dataSource).bind("updated.dataselector" + this.timestamp, function (evt, args) {
                $this._onDataSourceUpdated(evt, args);
            });

            if (dataSource.isInitialized()) {
                if (this._isInstance(dataSource, "OlapXmlaDataSource")) {
                    this._onCatalogSelected(this._getItemName(dataSource.catalog()), true);
                } else {
                    this._fillMetadata(dataSource.metadataTree());
                    // this._updateDataSource();
                }

                dataSource.bindCollectionChanged({
                    filters: this._onFiltersChanged,
                    rowAxis: this._onRowAxisChanged,
                    columnAxis: this._onColumnAxisChanged,
                    measures: this._onMeasuresChanged
                });
            } else {
                dataSource.initialize();
            }
        },
        _clearDataSource: function () {
            if (this._ds) {
                $(this._ds).unbind("updated.dataselector");

                this._ds.unbindCollectionChanged({
                    filters: this._onFiltersChanged,
                    rowAxis: this._onRowAxisChanged,
                    columnAxis: this._onColumnAxisChanged,
                    measures: this._onMeasuresChanged
                });
            }

            // Clear the filter members cache.
            this._filterMembersCache = [];

            this._clearUI();
        },
        _onDataSourceInitialized: function (evt, evtArgs) {
            var dataSource = this._ds,
                args = $.extend({
                    owner: this,
                    dataSource: dataSource
                }, evtArgs);

            dataSource.bindCollectionChanged({
                filters: this._onFiltersChanged,
                rowAxis: this._onRowAxisChanged,
                columnAxis: this._onColumnAxisChanged,
                measures: this._onMeasuresChanged
            });

            this._triggerDataSourceInitialized(evt, args);

            if (!evtArgs.error) {
                if (this._isInstance(dataSource, "OlapXmlaDataSource")) {
                    this._onCatalogSelected(this._getItemName(dataSource.catalog()), true);
                } else {
                    this._fillMetadata(dataSource.metadataTree());
                    // this._updateDataSource();
                }
            }
        },
        _updateDataSource: function (deferUpdateOverride) {
            var dataSource = this._ds,
                shouldUpdate = deferUpdateOverride || this._deferUpdate === false;

            if (shouldUpdate && dataSource.cube() !== null) {
                dataSource.update();
            }
        },
        _onDataSourceUpdated: function (evt, evtArgs) {
            var dataSource = this._ds,
                args = $.extend({
                    owner: this,
                    dataSource: dataSource
                }, evtArgs);

            this._triggerDataSourceUpdated(evt, args);
        },
        _getItemName: function (item) {
            return item && item.name();
        },
        _fillCombo: function (comboSelector, items, selectedItem) {
            var t = typeof selectedItem,
                selected = null;

            if (t === "number") {
                selected = [{ index: selectedItem }];
            } else if (t === "object" && selectedItem !== null && $.isFunction(selectedItem.name)) {
                selected = [{ value: selectedItem.name() }];
            }

            this.element.find(comboSelector)
                .igCombo("option", "dataSource", items)
                .igCombo("option", "selectedItems", selected);
        },
        _clearCombo: function (comboSelector) {
            this.element.find(comboSelector)
                .igCombo("option", "dataSource", []);
        },
        _fillMetadata: function (metadata) {
            var $this = this,
                parseMetadata = function (m) {
                    var metadataItem = {}, hasItem = true, item, imgClass, children, i;
                    switch (m.type()) {
                    case $.ig.OlapMetadataTreeItemType.prototype.cube:
                        imgClass = "cube";
                        break;
                    case $.ig.OlapMetadataTreeItemType.prototype.dimension:
                        imgClass = "dimension";
                        break;
                    case $.ig.OlapMetadataTreeItemType.prototype.group:
                        imgClass = "folder";
                        hasItem = false;
                        break;
                    case $.ig.OlapMetadataTreeItemType.prototype.userDefinedHierarchy:
                        imgClass = "hierarchymultiple";
                        break;
                    case $.ig.OlapMetadataTreeItemType.prototype.systemEnabledHierarchy:
                        imgClass = "hierarchysingle";
                        break;
                    case $.ig.OlapMetadataTreeItemType.prototype.parentChildHierarchy:
                        imgClass = "hierarchydirect";
                        break;
                    case $.ig.OlapMetadataTreeItemType.prototype.measure:
                        imgClass = "measure";
                        break;
                    case $.ig.OlapMetadataTreeItemType.prototype.level1:
                        imgClass = "level1";
                        break;
                    case $.ig.OlapMetadataTreeItemType.prototype.level2:
                        imgClass = "level2";
                        break;
                    case $.ig.OlapMetadataTreeItemType.prototype.level3:
                        imgClass = "level3";
                        break;
                    case $.ig.OlapMetadataTreeItemType.prototype.level4:
                        imgClass = "level4";
                        break;
                    case $.ig.OlapMetadataTreeItemType.prototype.level5:
                        imgClass = "level5";
                        break;
					case $.ig.OlapMetadataTreeItemType.prototype.kpiRoot:
						case $.ig.OlapMetadataTreeItemType.prototype.kpi:
							imgClass = "kpi";
							break;
						case $.ig.OlapMetadataTreeItemType.prototype.kpiValue:
							imgClass = "kpi value";
							break;
						case $.ig.OlapMetadataTreeItemType.prototype.kpiGoal:
							imgClass = "kpi goal";
							break;
						case $.ig.OlapMetadataTreeItemType.prototype.kpiStatus:
							imgClass = "kpi status";
							break;
						case $.ig.OlapMetadataTreeItemType.prototype.kpiTrend:
							imgClass = "kpi trend";
							break;
					case $.ig.OlapMetadataTreeItemType.prototype.kpiWeight:
						imgClass = "kpi weight";
						break;
                    default:
                        imgClass = "folder";
                        break;
                    }

                    metadataItem.caption = m.caption();
                    metadataItem.image = imgClass;
                    if (hasItem) {
                        item = m.item();
                        metadataItem.name = item.uniqueName();
                        metadataItem.type = item.getType().typeName();
                    }

                    children = m.children();
                    if (children) {
                        metadataItem.children = [];
                        for (i = 0; i < children.length; i++) {
                            metadataItem.children[i] = parseMetadata(children[i]);
                        }
                    }

                    return metadataItem;
                },
                parsedMetadata = metadata === null ? [] : [parseMetadata(metadata)],
                dragAndDropSettings = this.options.dragAndDropSettings,
				tree,
				items;

            tree = this.element.find(".ui-igpivotdataselector-metadata").igTree("option", "dataSource", parsedMetadata);
			items = tree.find(".ui-igpivot-metadataitem[data-type='Kpi'],.ui-igpivot-metadataitem[data-type='Measure'],.ui-igpivot-metadataitem[data-type='Dimension'],.ui-igpivot-metadataitem[data-type='Hierarchy'],.ui-igpivot-metadataitem[data-type='KpiMeasure']");
            if (!this._isTouch()) {
                items.draggable({
                    appendTo: dragAndDropSettings.appendTo,
                    containment: dragAndDropSettings.containment,
                    zIndex: dragAndDropSettings.zIndex,
                    cursorAt: this._const.dragCursorAt,
                    revert: false,
                    helper: function (event) {
                        var markup;
                        markup = $($this._const.dragHelperMarkup.replace("{0}", $(this).text()));
                        markup.addClass($this.css.invalidDropIndicator)
                            .find("span")
                            .addClass("ui-icon  ui-icon-cancel");
                        return markup;
                    },
                    start: function (event, ui) { return $this._triggerDragStart(event, ui, tree.igTree("nodeDataFor", $(this).attr("data-path"))); },
                    drag: function (event, ui) { return $this._triggerDrag(event, ui, tree.igTree("nodeDataFor", $(this).attr("data-path"))); },
                    over: function (event, ui) { $this._onDraggableOver(event, ui); },
                    out: function (event, ui) { $this._onDraggableOut(event, ui); },
                    stop: function (event, ui) { $this._triggerDragStop(event, ui); }
                });
            }
            items.click(function (event) {
                var item = tree.igTree("nodeDataFor", $(this).closest("li").attr("data-path")),
                    name = item.name,
                    type = $.ig[item.type].prototype.getType(),
                    metadataItem;
                metadataItem = $this._ds.getCoreElement(
                    function (el) { return el.uniqueName() === name; },
                    type
                );

                if (metadataItem) {
                    $this._createMetadataItemDropDown(event, this, metadataItem);
                }
            });

            this._fillDropArea(".ui-igpivot-droparea[data-role=filters]", this._ds.filters(), this.options.disableFiltersDropArea);
            this._fillDropArea(".ui-igpivot-droparea[data-role=rows]", this._ds.rowAxis(), this.options.disableRowsDropArea);
            this._fillDropArea(".ui-igpivot-droparea[data-role=columns]", this._ds.columnAxis(), this.options.disableColumnsDropArea);
            this._fillDropArea(".ui-igpivot-droparea[data-role=measures]", this._ds.measures(), this.options.disableMeasuresDropArea);
        },
        _fillDropArea: function (dropArea, items, isDisabled) {
            var i, length;
            dropArea = dropArea.jquery ? dropArea : this.element.find(dropArea);
            dropArea.empty();
            for (i = 0, length = items.length; i < length; i++) {
                this._createMetadataElement(items[i], isDisabled, "appendTo", dropArea);
            }
        },
        _clearMetadata: function () {
            this.element.find(".ui-igpivotdataselector-metadata").igTree("option", "dataSource", []);
        },
        _onCatalogSelected: function (catalog, isInit) {
            var $this = this,
                dataSource = this._ds,
                callback = function () {
                    $this._fillCombo(".ui-igpivotdataselector-catalog", dataSource.catalogs(), dataSource.catalog());
                    $this._fillCombo(".ui-igpivotdataselector-cube", dataSource.cubes(), dataSource.cube());
                    $this._onCubeSelected($this._getItemName(dataSource.cube()), isInit);
                };

            this._clearCombo(".ui-igpivotdataselector-cube");

            if (catalog === null) {
                callback();
            } else {
                dataSource.setCatalog(catalog).done(callback);
            }
        },
        _onCubeSelected: function (cube, isInit) {
            var $this = this,
                dataSource = this._ds,
                callback = function () {
                    var measureGroup = dataSource.cube() && (dataSource.measureGroup() || 0),
                        measureGroups = dataSource.measureGroups().slice();

                    // Add the (All) measure group.
                    measureGroups.splice(0, 0, { _caption: $.ig.PivotDataSelector.locale.measureGroupAll, _name: null });

                    $this._fillCombo(".ui-igpivotdataselector-measuregroup", measureGroups, measureGroup);
                    $this._onMeasureGroupSelected($this._getItemName(dataSource.measureGroup()), isInit);
                };

            this._clearCombo(".ui-igpivotdataselector-measuregroup");
            if (cube === null) {
                callback();
            } else {
                dataSource.setCube(cube).done(callback);
            }
        },
        _onMeasureGroupSelected: function (measureGroup, isInit) {
            var $this = this,
                dataSource = this._ds,
                callback = function () {
                    $this._fillMetadata(dataSource.metadataTree());
                    if (!isInit) {
                        $this._updateDataSource();
                    }
                };

            this._clearMetadata();

            if (measureGroup === null) {
                callback();
            } else {
                dataSource.setMeasureGroup(measureGroup).done(callback);
            }
        },
        _shouldAppendToTarget: function (target, dragged) {
            // Calculate the top of the dragged element and the drop target.
            return target.offset().top + target.height() / 2 < dragged.offset.top + this._const.dragCursorAt.top;
        },
        update: function () {
            /* Updates the data source.
            */
            this._ds.update();
        },
        destroy: function () {
            /* destroy is part of the jQuery UI widget API and does the following:
                1. Remove custom CSS classes that were added.
                2. Unwrap any wrapping elements such as scrolling divs and other containers.
                3. Unbind all events that were bound.
            */
            this._clearDataSource();
            this.element.removeClass(this.css.dataSelector);
            $(this._ds).unbind('updated.dataselector' + this.timestamp);
            $(this._ds).unbind('initialized.dataselector' + this.timestamp);
            $.Widget.prototype.destroy.apply(this);
            return this;
        },
        _triggerDataSelectorRendered: function () {
            var args = {
                owner: this
            };
            this._trigger("dataSelectorRendered", null, args);
        },
        _triggerDeferUpdateChanged: function (deferUpdate) {
            var args = {
                owner: this,
                deferUpdate: deferUpdate
            };
            this._trigger("deferUpdateChanged", null, args);
        }
    });
    $.extend(true, $.ui.igPivotDataSelector.prototype, $.ig.Pivot._pivotShared);
    $.extend($.ui.igPivotDataSelector, { version: "14.1.20141.2249" });
}(jQuery));
/*!@license
* Infragistics.Web.ClientUI Pivot Grid 14.1.20141.2249
*
* Copyright (c) 2011-2012 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends on: 
*	jquery-1.4.4.js
*	jquery.ui.core.js
*	jquery.ui.widget.js
*	jquery.ui.draggable.js
*	jquery.ui.droppable.js
*	infragistics.util.js
*	infragistics.datasource.js
*	infragistics.olapxmladatasource.js
*	infragistics.olapflatdatasource.js
*	infragistics.ui.shared.js
*   infragistics.ui.scroll.js
*	infragistics.ui.tree.js
*	infragistics.ui.grid.framework.js
*	infragistics.ui.grid.multicolumnheaders.js
*	infragistics.ui.pivot.shared.js
*/
/*global jQuery, Modernizr */
(function ($) {
    function Matrix() {
        this[0] = [];
    }
    Matrix.prototype = [];
    Matrix.prototype.set = function (row, column, value) {
        if (this.length < row + 1) {
            this.setRowCount(row + 1);
        }
        if (this[0].length < column + 1) {
            this.setColumnCount(column + 1);
        }
        this[row][column] = value;
    };
    Matrix.prototype.setRowCount = function (rowCount) {
        var i, oldRowCount = this.length;
        this.length = rowCount;
        for (i = oldRowCount; i < rowCount; i++) {
            this[i] = [];
            this[i].length = this[0].length;
        }
    };
    Matrix.prototype.setColumnCount = function (columnCount) {
        var i;
        for (i = 0; i < this.length; i++) {
            this[i].length = columnCount;
        }
    };

    var _aNull = function (val) { return val === null || val === undefined; },
        _igGrid = $.ui.igGrid.prototype.widgetFullName || $.ui.igGrid.prototype.widgetName;

    $.widget("ui.igPivotGrid", {
        css: {
            /* Class applied to the container of the pivot grid. */
            pivotGrid: "ui-igpivotgrid",
            /* Class applied to the header cells in the pivot grid. */
            pivotGridHeader: "ui-igpivotgrid-header",
            /* Classes applied to the elements, which expand the pivot headers. */
            expandButton: "ui-iggrid-headerbutton ui-icon ui-icon-plus",
            /* Classes applied to the elements, which collapse the pivot headers. */
            collapseButton: "ui-iggrid-headerbutton ui-iggrid-headerbuttonexpanded ui-icon ui-icon-minus",
            /* Classes applied to the indicator for ascending value sorting. */
            rowsAscending: "ui-iggrid-sortindicator ui-icon ui-icon-triangle-1-n",
            /* Classes applied to the indicator for descending value sorting. */
            rowsDescending: "ui-iggrid-sortindicator ui-icon ui-icon-triangle-1-s",
            /* Classes applied to the indicator for ascending header sorting in the rows. */
            headerRowsAscending: "ui-iggrid-sortindicator ui-icon ui-icon-triangle-1-n",
            /* Classes applied to the indicator for descending header sorting in the rows. */
            headerRowsDescending: "ui-iggrid-sortindicator ui-icon ui-icon-triangle-1-s",
            /* Classes applied to the indicator for ascending header sorting in the columns. */
            headerColumnsAscending: "ui-iggrid-sortindicator ui-icon ui-icon-triangle-1-n",
            /* Classes applied to the indicator for descending header sorting in the columns. */
            headerColumnsDescending: "ui-iggrid-sortindicator ui-icon ui-icon-triangle-1-s",
            /* Classes applied to the overlay, which shows when the pivot grid is loading. */
            blockArea: "ui-igpivotgrid-blockarea",
            /* Classes applied to the elements representing metadata items - in the metadata tree and the drop areas. */
            metadataItem: "ui-igpivot-metadataitem ui-widget ui-corner-all ui-state-default",
            /* Classes applied to the drop area headers. */
            dropAreaHeader: "ui-igpivot-dropareaheader ui-iggrid-header ui-widget-header",
            /* Class applied to the scroll buttons added when the hierarchies and the measures overflow the drop area. */
            scrollButton: "ui-iggrid-headerbutton",
            /* Classes applied to the scroll left button. */
            scrollLeft: "ui-icon ui-icon-triangle-1-w",
            /* Classes applied to the scroll right button. */
            scrollRight: "ui-icon ui-icon-triangle-1-e",
            /* Class applied to the drop areas. */
            dropArea: "ui-igpivot-droparea",
            /* Class applied to the drop areas, which are over the column and row headers and the data cells. */
            overlayDropArea: "ui-igpivot-overlaydroparea",
            /* Class applied to the drop areas, which can accept a drop. */
            activeDropArea: "active",
            /* Classes applied to the valid drop element. */
            dropIndicator: "ui-state-highlight",
            /* Classes applied to the invalid drop element. */
            invalidDropIndicator: "ui-state-error",
            /* Classes applied to the insert item indicator in the drop areas. */
            insertItem: "ui-igpivot-insertitem ui-state-highlight ui-corner-all",
            /* Classes applied to the metadata item drop down element. */
            metadataItemDropDown: "ui-igpivot-metadatadropdown ui-widget ui-widget-content",
            /* Classes applied to the filter icon in the metadata items. */
            filterIcon: "ui-icon ui-icon-pivot-smallfilter",
            /* Class applied to the filters drop down element. */
            filterDropDown: "ui-igpivot-filterdropdown ui-widget ui-widget-content",
            /* Class applied to the tree containing the filter members. */
            filterMembers: "ui-igpivot-filtermembers"
            ///* Class applied to the overlay element, which is over the pivot grid when a filter drop down is open. */
            //filterDropDownOverlay: "ui-igpivot-overlay"
        },
        options: {
            /* type="string|number|null"
            string The widget width can be set in pixels (px) and percentage (%).
            number The widget width can be set as a number
            null type="object" Will stretch to fit the data, if no other widths are defined.
            */
            width: null,
            /* type="string|number|null" This is the total height of the grid.
            string The widget height can be set in pixels (px) and percentage (%).
            number The widget height can be set as a number
            null type="object" Will stretch vertically to fit data, if no other heights are defined
            */
            height: null,
            /* type="object" An instance of $.ig.OlapXmlaDataSource or $.ig.OlapFlatDataSource.
            */
            dataSource: null,
            /* type="object" An object that will be used to create an instance of $.ig.OlapXmlaDataSource or $.ig.OlapFlatDataSource.
            The provided value must contain an object with settings for one of the data source types - xmlaOptions or flatDataOptions.
            */
            dataSourceOptions: {
                /* type="object" Settings for creating an instance of $.ig.OlapXmlaDataSource.
                */
                xmlaOptions: {
                    /* type="string" optional="false" The URL of the XMLA server.
                    */
                    serverUrl: null,
                    /* type="string" The catalog name.
                    */
                    catalog: null,
                    /* type="string" The name of the cube in the data source.
                    */
                    cube: null,
                    /* type="string" The name of the measure group in the data source.
                    */
                    measureGroup: null,
                    /* type="object" An object containing information about how the request to the XMLA server should be processed.
                    */
                    requestOptions: {
                        /* type="bool" The value is applied to XmlHttpRequest.withCredentials if supported by the user agent.
                        Setting this property to true will allow IE8/IE9 to make authenticated cross-origin requests to tusted domains through XmlHttpRequest instead of XDomainRequest
                        and will prompt the user for credentials.
                        */
                        withCredentials: false,
                        /* type="function" A callback to be invoked right before the request is send to the server. Extends beforeSend callback of jQuery.ajax’s options object.
                        */
                        beforeSend: null
                    },
                    /* type="bool" Enables/disables caching of the XMLA result object.
                    */
                    enableResultCache: true,
                    /* type="object" Additional properties sent with every discover request.
                    The object is treated as a key/value store where each property name is used as the key and the property value as the value.
                    */
                    discoverProperties: null,
                    /* type="object" Additional properties sent with every execute request.
                    The object is treated as a key/value store where each property name is used as the key and the property value as the value.
                    */
                    executeProperties: null,
                    /* type="object" optional="true" a javascript object containing information about how the request to the xmla server should be processed 
                    */
                    mdxSettings: {
                        /* type="bool" optional="true" a value indicating whether a NON EMPTY clause is present on ROWS axis. Default value is true 
                        */
                        nonEmptyOnRows: true,
                        /* type="bool" optional="true" a value indicating whether a NON EMPTY clause is present on COLUMNS axis. Default value is true 
                        */
                        nonEmptyOnColumns: true,
                        /* type="bool" optional="true" a value indicating whether a members' set expressions on ROWS axis should be wrapped with AddCalculatedMembers MDX method. Default value is true 
                        */
                        addCalculatedMembersOnRows: true,
                        /* type="bool" optional="true" a value indicating whether a members' set expressions on COLUMNS axis should be wrapped with AddCalculatedMembers MDX method. Default value is true 
                        */
                        addCalculatedMembersOnColumns: true,
                        /* type="array" optional="true" a string array with the names of intrinsic non-context sensitive member properties applied on ROWS axis. By defult CHILDREN_CARDINALITY and PARENT_UNIQUE_NAME properties are always added to DIMENSION PROPERTIES 
                        */
                        dimensionPropertiesOnRows: [],
                        /* type="array" optional="true" a string array with the names of intrinsic non-context sensitive member properties applied on COLUMNS axis. By defult CHILDREN_CARDINALITY and PARENT_UNIQUE_NAME properties are always added to DIMENSION PROPERTIES
                        */
                        dimensionPropertiesOnColumns: []
                    }
                },
                /* type="object" Settings for creating an instance of $.ig.OlapFlatDataSource.
                */
                flatDataOptions: {
                    /* type="object" Specifies any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself.
                    */
                    dataSource: null,
                    /* type="string" Specifies a remote URL accepted by $.ig.DataSource in order to request data from it.
                    */
                    dataSourceUrl: null,
                    /* type="string" Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property. 
                    */
                    dataSourceType: null,
                    /* type="string" see $.ig.DataSource. 
                    string Specifies the name of the property in which data records are held if the response is wrapped. 
                    null Option is ignored.
                    */
                    responseDataKey: null,
                    /* type="string" 
                    string Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property.
                    null Option is ignored.
                    */
                    responseDataType: null,
                    /* type="object" optional="false" An object containing processing instructions for the $.ig.DataSource data.
                    */
                    metadata: {
                        /* type="object" optional="false" Metadata used for the creation of the cube.
                        */
                        cube: {
                            /* type="string" optional="false" A unique name for the cube.
                            */
                            name: null,
                            /* type="string" A caption for the cube.
                            */
                            caption: null,
                            /* type="object" An object providing information about the measures' root node.
                            */
                            measuresDimension: {
                                /* type="string" A unique name for the measures dimension.
                                The default value is "Measures". This name is used to create the names of dimensions using the following pattern:
                                [<measuresDimensionMetadata.name>].[<measureMetadata.name>]
                                */
                                name: null,
                                /* type="string" A caption for the measures dimension.
                                The default value is "Measures".
                                */
                                caption: null,
                                /* type="array" An array of measure metadata objects.
                                */
                                measures: [{
                                    /* type="string" optional="false" A unique name for the measure.
                                    */
                                    name: null,
                                    /* type="string" A caption for the measure.
                                    */
                                    caption: null,
                                    /* type="function" optional="false" An aggregator function called when each cell is evaluated.
                                    Returns a value for the cell. If the returned value is null, no cell will be created in for the data source result.
                                    */
                                    aggregator: null,
                                    /* type="string" The path used when displaying the measure in the user interface. Nested folders are indicated by a backslash (\).
                                    */
                                    displayFolder: null
                                }]
                            },
                            /* type="array" An array of dimension metadata objects.
                            */
                            dimensions: [{
                                /* type="string" optional="false" A unique name for the dimension.
                                */
                                name: null,
                                /* type="string" A caption for the dimension.
                                */
                                caption: null,
                                /* type="array" An array of hierarchy metadata objects.
                                */
                                hierarchies: [{
                                    /* type="string" optional="false" A name for the hierarchy.
                                    The unique name of the hierarchy is formed using the following pattern:
                                    [<parentDimension.name>].[<hierarchyMetadata.name>]
                                    */
                                    name: null,
                                    /* type="string" A caption for the hierarchy.
                                    */
                                    caption: null,
                                    /* type="string" The path to be used when displaying the hierarchy in the user interface. 
                                    Nested folders are indicated by a backslash (\). 
                                    The folder hierarchy will appear under parent dimension node.
                                    */
                                    displayFolder: null,
                                    /* type="array" An array of level metadata objects.
                                    */
                                    levels: [{
                                        /* type="string" optional="false" A name for the level.
                                        The unique name of the level is formed using the following pattern:
                                        {<hierarchy.uniqueName>}.[<levelMetadata.name>]
                                        */
                                        name: null,
                                        /* type="string" A caption for the level.
                                        */
                                        caption: null,
                                        /* type="function" A function called for each item of the data source array when level members are created.
                                        Based on the item parameter the function should return a value that will form the $.ig.Member’s name and caption.
                                        */
                                        memberProvider: null
                                    }]
                                }]
                            }]
                        }
                    }
                },
                /* type="string" A list of measure names separated by comma (,). These will be the measures of the data source.
                */
                measures: null,
                /* type="string" A list of hierarchy names separated by comma (,). These will be hierarchies in the filters of the data source.
                */
                filters: null,
                /* type="string" A list of hierarchy names separated by comma (,). These will be the hierarchies in the rows of the data source.
                */
                rows: null,
                /* type="string" A list of hierarchy names separated by comma (,). These will be the hierarchies in the columns of the data source.
                */
                columns: null
            },
            /* type="bool" Setting deferUpdate to true will not apply changes to the data source until the updateGrid method is called.
            */
            deferUpdate: false,
            /* type="bool" A boolean value indicating whether a parent in the columns is in front of its children.
            If set to true, the query set sorts members in a level in their natural order - child members immediately follow their parent members.
            If set to false the query set sorts the members in a level using a post-natural order. In other words, child members precede their parents.
            */
            isParentInFrontForColumns: false,
            /* type="bool" A boolean value indicating whether a parent in the rows is in front of its children.
            If set to true, the query set sorts members in a level in their natural order - child members immediately follow their parent members.
            If set to false the query set sorts the members in a level using a post-natural order. In other words, child members precede their parents.
            */
            isParentInFrontForRows: true,
            /* type="bool" A boolean value indicating wheter the column headers should be arranged for compact header layout – each hieararchy is in a single row.
            */
            compactColumnHeaders: false,
            /* type="bool" A boolean value indicating wheter the row headers should be arranged for compact header layout – each hieararchy is in a single column.
            */
            compactRowHeaders: true,
            /* type="number" The indentation for every level column when the compactColumnHeaders is set to true.
            */
            compactColumnHeaderIndentation: 30, // default indentation for every level when columns are rendered in a "tree"-view structure in a compact way
            /* type="number" The indentation for every level row when the compactRowHeaders is set to true.
            */
            compactRowHeaderIndentation: 20, // default indentation for every level when rows are rendered in a "tree"-view structure in a compact way
            /* type="number" Specifies the width of the row headers.
            */
            defaultRowHeaderWidth: 200,
            /* type="bool" Enables sorting of the value cells in columns.
            */
            allowSorting: false,
            /* type="ascending|descending" Spefies the default sort direction for the rows.
            */
            firstSortDirection: "ascending",
            /* type="bool" Enables sorting of the header cells in rows.
            */
            allowHeaderRowsSorting: false,
            /* type="bool" Enables sorting of the header cells in columns.
            */
            allowHeaderColumnsSorting: false,
            /* type="array" An array of level sort direction items, which predefine the sorted header cells.
            */
            levelSortDirections: [{
                /* type="string" Specifies the unique name of the level, which will be sorted.
                */
                levelUniqueName: null,
                /* type="ascending|descending" optional="true" Specifies the sort direction. If no direction is specified,
                the level is going to be sorted in the direction specified by the firstLevelSortDirection option.
                */
                sortDirection: null
                // Not supported in 13.1
                ///* type="system|alphabetical" optional="true" Spefies what type of sorting will be applied to the header cells. If no behavior
                //                    is specified, the level is going to be sorted with the behavior specified in the defaultLevelSortBehavior option.
                //                    system type="string" Sorts the headers by a specified sort key.
                //                    alphabetical type="string" Sorts alphabetically the header captions.
                //*/
                //sortBehavior: null
            }],
            // Not supported in 13.1
            ///* type="system|alphabetical" Spefies the default sort behavior for the levels if no sort behavior is specified in an item from the levelSortDirections option.
            //                    system type="string" Sorts the headers by a specified sort key.
            //                    alphabetical type="string" Sorts alphabetically the header captions.
            //*/
            //defaultLevelSortBehavior: "alphabetical",
            /* type="ascending|descending" Spefies the default sort direction for the levels if no sort direction is specified in an item from the levelSortDirections option.
            */
            firstLevelSortDirection: "ascending",
            /* type="object" Options specific to the igGrid that will render the pivot grid view.
            */
            gridOptions: {
                /* type="string|number" Default column width that will be set for all columns.
                string The default column width can be set in pixels (px).
                number The default column width can be set as a number.
                */
                defaultColumnWidth: null,
                /* type="bool" Headers will be fixed if this option is set to true, and only the grid data will be scrollable.
                */
                fixedHeaders: true,
                /* type="string" Caption text that will be shown above the pivot grid header.
                */
                caption: null,
                /* type="object" A list of grid features definitions. The supported features are Resizing and Tooltips. Each feature goes with its separate options that are documented for the feature accordingly. 
                */
                features: [],
                /* type="number" Initial tabIndex attribute that will be set on the container element.
                */
                tabIndex: 0,
                /* type="bool" Enables/disables rendering of alternating row styles (odd and even rows receive different styling). Note that if a custom jQuery template is set, this has no effect and CSS for the row should be adjusted manually in the template contents.
                */
                alternateRowStyles: true,
                /* type="bool"  Enables/disables rendering of ui-state-hover classes when the mouse is over a record. This can be useful in templating scenarios, for example, where we don't want to apply hover styling to templated content.
                */
                enableHoverStyles: false
            },
            /* type="object" Settings for the drag and drop functionality of the igPivotGrid.
            */
            dragAndDropSettings: {
                /* type="parent|selector|element" Which element the draggable helper should be appended to while dragging. */
                appendTo: "body",
                /* type="boolean|selector|element|string|array" Specifies the containment for the drag helper. The area inside of which the 
                helper is contained would be scrollable while dragging.
                */
                containment: false,
                /* type="number" Specifies z-index that would be set for the drag helper. 
                */
                zIndex: 10
            },
            /* type="jQuery|element|selector" Specifies the parent for the drop downs.
            */
            dropDownParent: "body",
            /* type="bool" Disable the drag and drop for the rows drop area and the ability to use filtering and remove items from it.
            */
            disableRowsDropArea: false,
            /* type="bool" Disable the drag and drop for the columns drop area and the ability to use filtering and remove items from it.
            */
            disableColumnsDropArea: false,
            /* type="bool" Disable the drag and drop for the measures drop area and the ability to use filtering and remove items from it.
            */
            disableMeasuresDropArea: false,
            /* type="bool" Disable the drag and drop for the filters drop area and the ability to use filtering and remove items from it.
            */
            disableFiltersDropArea: false,
            /* type="bool" Hide the rows drop area.
            */
            hideRowsDropArea: false,
            /* type="bool" Hide the columns drop area.
            */
            hideColumnsDropArea: false,
            /* type="bool" Hide the measures drop area.
            */
            hideMeasuresDropArea: false,
            /* type="bool" Hide the filters drop area.
            */
            hideFiltersDropArea: false,
            /* type="function" A function that will be called to determine if an item can be moved in or dropped on an area of the pivot grid.
            paramType="string" The location where the item will be moved - igPivotGrid, igPivotDataSelector, filters, rows, columns or measures.
            paramType="string" The type of the item - Hierarchy, Measure or MeasureList.
            paramType="string" The unique name of the item.
            returnType="bool"  The function must return true if the item should be accepted.
            */
            customMoveValidation: null
        },
        events: {
            /* cancel="false" Fired after the data source has initialized.
            Function takes arguments evt and ui.
            Use ui.owner to get a reference to the pivot grid.
            Use ui.dataSource to get a reference to the data source.
            Use ui.error to see if an error has occured during initialization.
            Use ui.metadataTreeRoot to get a reference to the root of the data source metatadata root item.
            */
            dataSourceInitialized: null,
            /* cancel="false" Fired after the data source has updated.
            Function takes arguments evt and ui.
            Use ui.owner to get a reference to the pivot grid.
            Use ui.dataSource to get a reference to the data source.
            Use ui.error to see if an error has occured during update.
            Use ui.result to get the result of the update operation.
            */
            dataSourceUpdated: null,
            /* cancel="false" Event fired after the headers have been rendered.
            Function takes arguments evt and ui.
            Use ui.owner to get a reference to the pivot grid.
            Use ui.grid to get a reference to the igGrid widget, which holds the headers.
            Use ui.table to get a reference to the headers table DOM element.
            */
            pivotGridHeadersRendered: null,
            /* cancel="false" Event fired after the whole grid widget has been rendered (including headers, footers, etc.).
            Function takes arguments evt and ui.
            Use ui.owner to get a reference to the pivot grid.
            Use ui.grid to get reference to the igGrid widget, which represents the data.
            */
            pivotGridRendered: null,
            /* cancel="true" Fired before the expand of the tuple member.
            Function takes arguments evt and ui. Return false to cancel the expanding.
            Use ui.owner to get a reference to the pivot grid.
            Use ui.dataSource to get a reference to the data source.
            Use ui.axisName to get the name of axis, which holds the member and the tuple.
            Use ui.tupleIndex to get the index of the tuple in the axis.
            Use ui.memberIndex to get the index of the member in the tuple.
            */
            tupleMemberExpanding: null,
            /* cancel="false" Fired after the expand of the tuple member.
            Function takes arguments evt and ui.
            Use ui.owner to get a reference to the pivot grid.
            Use ui.dataSource to get a reference to the data source.
            Use ui.axisName to get the name of axis, which holds the member and the tuple.
            Use ui.tupleIndex to get the index of the tuple in the axis.
            Use ui.memberIndex to get the index of the member in the tuple.
            */
            tupleMemberExpanded: null,
            /* cancel="true" Fired before the collapse of the tuple member.
            Function takes arguments evt and ui. Return false to cancel the collapsing.
            Use ui.owner to get a reference to the pivot grid.
            Use ui.dataSource to get a reference to the data source.
            Use ui.axisName to get the name of axis, which holds the member and the tuple.
            Use ui.tupleIndex to get the index of the tuple in the axis.
            Use ui.memberIndex to get the index of the member in the tuple.
            */
            tupleMemberCollapsing: null,
            /* cancel="false" Fired after the collapse of the tuple member.
            Function takes arguments evt and ui.
            Use ui.owner to get a reference to the pivot grid.
            Use ui.dataSource to get a reference to the data source.
            Use ui.axisName to get the name of axis, which holds the member and the tuple.
            Use ui.tupleIndex to get the index of the tuple in the axis.
            Use ui.memberIndex to get the index of the member in the tuple.
            */
            tupleMemberCollapsed: null,
            /* cancel="true" Fired before the sorting of the columns.
            Function takes arguments evt and ui. Return false to cancel the sorting.
            Use ui.owner to get a reference to the pivot grid.
            Use ui.sortDirections to get an array of the tuple indices and sort directions that will be used.
            */
            sorting: null,
            /* cancel="false" Fired after the sorting of the columns.
            Function takes arguments evt and ui.
            Use ui.owner to get a reference to the pivot grid.
            Use ui.sortDirections to get an array of the tuple indices and sort directions that were passed to the table view.
            Use ui.appliedSortDirections to get an array of the tuple indices and sort directions that were actually applied to the table view.
            */
            sorted: null,
            /* cancel="true" Fired before the sorting of the headers.
            Function takes arguments evt and ui. Return false to cancel the sorting.
            Use ui.owner to get a reference to the pivot grid.
            Use ui.levelSortDirections to get an array of the level names and sort directions that will be used.
            */
            headersSorting: null,
            /* cancel="false" Fired after the sorting of the headers.
            Function takes arguments evt and ui.
            Use ui.owner to get a reference to the pivot grid.
            Use ui.levelSortDirections to get an array of the level names and sort directions that were used.
            Use ui.appliedLevelSortDirections to get an array of the level names and sort directions that were actually applied to the table view.
            */
            headersSorted: null,
            /* cancel="true" Fired on drag start. Return false to cancel the dragging.
            Use ui.metadata	to get a reference to the data.
            Use ui.helper to get a reference to the helper.
            Use ui.offset to get a reference to the offset.
            Use ui.originalPosition to get a reference to the original position of the draggable element.
            Use ui.position to get a reference to the current position of the draggable element.
            */
            dragStart: null,
            /* cancel="true" Fired on drag. Return false to cancel the drag.
            Use ui.metadata	to get a reference to the data.
            Use ui.helper to get a reference to the helper.
            Use ui.offset to get a reference to the offset.
            Use ui.originalPosition to get a reference to the original position of the draggable element.
            Use ui.position to get a reference to the current position of the draggable element.
            */
            drag: null,
            /* cancel="false" Fired on drag stop.
            Use ui.helper to get a reference to the helper.
            Use ui.offset to get a reference to the offset.
            Use ui.originalPosition to get a reference to the original position of the draggable element.
            Use ui.position to get a reference to the current position of the draggable element.
            */
            dragStop: null,
            /* cancel="true" Fired before a metadata item drop. Return false to cancel the drop.
            Use ui.targetElement for a reference to the drop target.
            Use ui.draggedElement for a reference to the metadata item element.
            Use ui.metadata	to get a reference to the data.
            Use ui.metadataIndex to get the index at which the metadata will be inserted.
            Use ui.helper to get a reference to the helper.
            Use ui.offset to get a reference to the offset.
            Use ui.position to get a reference to the current position of the draggable element.
            */
            metadataDropping: null,
            /* cancel="false" Fired after a metadata item drop.
            Use ui.targetElement for a reference to the drop target.
            Use ui.draggedElement for a reference to the dragged element.
            Use ui.metadata	to get a reference to the data.
            Use ui.metadataIndex to get the index at which the metadata is inserted.
            Use ui.helper to get a reference to the helper.
            Use ui.offset to get a reference to the offset.
            Use ui.position to get a reference to the current position of the draggable element.
            */
            metadataDropped: null,
            /* cancel="true" Fired before a metadata item is removed when the user clicks the close icon. Return false to cancel the removing.
            Use ui.targetElement for a reference to the dragged element.
            Use ui.metadata	to get a reference to the data.
            */
            metadataRemoving: null,
            /* cancel="false" Fired after a metadata item is removed when the user clicks the close icon.
            Use ui.metadata	to get a reference to the data.
            */
            metadataRemoved: null,
            /* cancel="true" Fired before the filter members drop down opens. Return false to cancel the opening.
            Use ui.hierarchy for a reference to the hierarchy.
            */
            filterDropDownOpening: null,
            /* cancel="false" Fired after the filter members drop down opens.
            Use ui.hierarchy for a reference to the hierarchy.
            Use ui.dropDownElement for a reference to the drop down.
            */
            filterDropDownOpened: null,
            /* cancel="false" Fired after the filter members are loaded.
            Use ui.parent to get the parent node or the igTree instance in the initial load.
            Use ui.rootFilterMembers for a collection with the root filter members (deprecated).
            Use ui.filterMembers for a collection with the newly loaded filter members.
            */
            filterMembersLoaded: null,
            /* cancel="true" Fired after the OK button in the filter members drop down is clicked. Return false to cancel the applying of the filters.
            Use ui.hierarchy for a reference to the hierarchy.
            Use ui.filterMembers for a collection with the selected filter members. If all filter members are selected the collection will be empty.
            Use ui.dropDownElement for a reference to the drop down.
            */
            filterDropDownOk: null,
            /* cancel="true" Fired before the filter members drop down closes. Return false to cancel the closing.
            Use ui.hierarchy for a reference to the hierarchy.
            Use ui.dropDownElement for a reference to the drop down.
            */
            filterDropDownClosing: null,
            /* cancel="false" Fired after the filter members drop down closes.
            Use ui.hierarchy for a reference to the hierarchy.
            */
            filterDropDownClosed: null
        },
        _const: {
            emptyCell: {
                headerText: "&nbsp;",
                key: "empty_cell",
                axisName: "empty_axis",
                memberIndex: 0,
                // Setting tuple index to 0 will enable sorting.
                tupleIndex: 0
            },
            hoverScrollOffset: 5,
            hoverScrollInterval: 50
        },
        _headerScrollOffsets: {},
        _gridScrollOffsets: {
            top: 0,
            left: 0
        },
        _create: function () {
            var $this = this;

            this._onFiltersChanged = function (collection, collectionChangedArgs) {
                var dropArea = $("#" + $this.element.attr("id") + "_filters .ui-igpivot-droparea");
                $this._onDataSourceCollectionChanged(collection, collectionChangedArgs, dropArea, $this.options.disableFiltersDropArea);
				$this._updateDropArea(dropArea, $this._ds.filters(), $this.options.disableFiltersDropArea, $this.options.disableFiltersDropArea ?
						$.ig.PivotGrid.locale.disabledFiltersHeader :
						$.ig.PivotGrid.locale.filtersHeader);
                // Flag for future use.
                // $this._filtersChanged = true;
            };
            this._onRowAxisChanged = function (collection, collectionChangedArgs) {
                var dropArea = $("#" + $this.element.attr("id") + "_rows .ui-igpivot-droparea");
                $this._onDataSourceCollectionChanged(collection, collectionChangedArgs, dropArea, $this.options.disableRowsDropArea);
				$this._updateDropArea(dropArea, $this._ds.rowAxis(), $this.options.disableRowsDropArea, $this.options.disableRowsDropArea ?
						$.ig.PivotGrid.locale.disabledRowsHeader :
						$.ig.PivotGrid.locale.rowsHeader);
                // Flag for future use.
                // $this._rowsChanged = true;
            };
            this._onColumnAxisChanged = function (collection, collectionChangedArgs) {
                var dropArea = $("#" + $this.element.attr("id") + "_columns .ui-igpivot-droparea");
                $this._onDataSourceCollectionChanged(collection, collectionChangedArgs, dropArea, $this.options.disableColumnsDropArea);
				$this._updateDropArea(dropArea, $this._ds.columnAxis(), $this.options.disableColumnsDropArea, $this.options.disableColumnsDropArea ?
						$.ig.PivotGrid.locale.disabledColumnsHeader :
						$.ig.PivotGrid.locale.columnsHeader);
                $this._columnsChanged = true;
            };
            this._onMeasuresChanged = function (collection, collectionChangedArgs) {
                var dropArea = $("#" + $this.element.attr("id") + "_measures .ui-igpivot-droparea");
                $this._onDataSourceCollectionChanged(collection, collectionChangedArgs, dropArea, $this.options.disableMeasuresDropArea);
				$this._updateDropArea(dropArea, $this._ds.measures(), $this.options.disableMeasuresDropArea, $this.options.disableMeasuresDropArea ?
						$.ig.PivotGrid.locale.disabledMeasuresHeader :
						$.ig.PivotGrid.locale.measuresHeader);
                // Flag for future use.
                // $this._measuresChanged = true;
            };

            this.element.addClass(this.css.pivotGrid);

            this._setDataSource();
        },
        _setOption: function (key, value) {
            var grid;

            switch (key) {
                case "dataSource":
                    this._clearDataSource();
                    this.options.dataSourceOptions = null;
                    this.options.dataSource = this._createDataSource(value, null);
                    this._setDataSource();
                    break;
                case "dataSourceOptions":
                    this._clearDataSource();
                    this.options.dataSourceOptions = value;
                    this.options.dataSource = this._createDataSource(null, value);
                    this._setDataSource();
                    break;
                case "deferUpdate":
                    $.Widget.prototype._setOption.apply(this, arguments);
                    if (value === false) {
                        this.updateGrid();
                    }
                    break;
                case "width":
                case "height":
                    $.Widget.prototype._setOption.apply(this, arguments);
                    grid = this.grid();
                    if (grid) {
                        grid.option(key, value);
                    }
                    break;
                case "levelSortDirections":
                case "isParentInFrontForColumns":
                case "isParentInFrontForRows":
                case "compactColumnHeaders":
                case "compactRowHeaders":
                    $.Widget.prototype._setOption.apply(this, arguments);
                    this._createTableView(this._ds);
                    this._onGridUpdated();
                    break;
                case "dragAndDropSettings":
                    $.Widget.prototype._setOption.apply(this, arguments);
                    this.element.find(":ui-draggable").each(function (ind, el) {
                        var draggable = $(el);
                        draggable.draggable("option", "appendTo", value.appendTo);
                        draggable.draggable("option", "containment", value.containment);
                        draggable.draggable("option", "zIndex", value.zIndex);
                    });
                    break;
                default:
                    $.Widget.prototype._setOption.apply(this, arguments);
                    this._onGridUpdated();
                    break;
            }
        },
        _setDataSource: function () {
            var $this = this, dataSource;

            this._renderEmptyGrid();

            this._ds = dataSource = this._createDataSource(
                this.options.dataSource,
                this.options.dataSourceOptions
            );

            if (!dataSource) {
                return;
            }

            this.timestamp = new Date().getTime();
            $(dataSource).bind("initialized.pivotgrid" + this.timestamp, function (evt, evtArgs) {
                var args = $.extend({
                    owner: $this,
                    dataSource: $this._ds
                }, evtArgs);

                $this._triggerDataSourceInitialized(evt, args);
                $this._onGridUpdated();
            });
            $(dataSource).bind("updated.pivotgrid" + this.timestamp, function (evt, evtArgs) {
                var args = $.extend({
                    owner: $this,
                    dataSource: $this._ds
                }, evtArgs);

                $this._triggerDataSourceUpdated(evt, args);
                $this._onGridUpdated();
            });

            if (dataSource.isInitialized()) {
                dataSource.bindCollectionChanged({
                    filters: this._onFiltersChanged,
                    rowAxis: this._onRowAxisChanged,
                    columnAxis: this._onColumnAxisChanged,
                    measures: this._onMeasuresChanged
                });

                this._onGridUpdated();
            } else {
                this._updateGrid(true).always(function () {
                    dataSource.bindCollectionChanged({
                        filters: $this._onFiltersChanged,
                        rowAxis: $this._onRowAxisChanged,
                        columnAxis: $this._onColumnAxisChanged,
                        measures: $this._onMeasuresChanged
                    });
                });
            }
        },
        _updateDropArea: function (dropArea, items, isDisabled, emptyMessage) {
            if (!this._ds.isUpdating() && !this._isTouch()) {
                dropArea.empty().css({
                    "display": "",
                    "overflow": "",
                    "margin": "",
                    "padding": ""
                }).siblings().remove();
                this._fillDropArea(dropArea, items, isDisabled, emptyMessage);
                this._measureDropArea(dropArea);
            }
        },
        _clearDataSource: function () {
            var grid = this.grid();

            if (this._ds) {
                $(this._ds).unbind("updated.pivotgrid");

                this._ds.unbindCollectionChanged({
                    filters: this._onFiltersChanged,
                    rowAxis: this._onRowAxisChanged,
                    columnAxis: this._onColumnAxisChanged,
                    measures: this._onMeasuresChanged
                });
            }

            if (grid) {
                grid.destroy();
                this.element.empty();
            }
        },
        _createTableView: function (dataSource) {
            var viewSettings, hasColumns, hasRows,
                map, appliedColumnSortDirections, appliedLevelSortDirections, userLevelSortDirections, mergedLevelSortDirections;

            // Prepare the column sort directions.
            // Clear the sorting if the hierarchies in the columns have changed.
            appliedColumnSortDirections = this._columnsChanged ? [] : this.appliedColumnSortDirections();

            // Prepare the level sort directions.
            map = function (array) {
                var i, m = {};
                if ($.isArray(array)) {
                    for (i = 0; i < array.length; i++) {
                        if (!_aNull(array[i].levelUniqueName)) {
                            m[array[i].levelUniqueName] = array[i];
                        }
                    }
                }
                return m;
            };
            appliedLevelSortDirections = map(this.appliedLevelSortDirections());
            userLevelSortDirections = map(this.options.levelSortDirections);
            // Merge the level sort directions from the UI to the ones that
            // are specified in the view settings.
            mergedLevelSortDirections = $.extend(userLevelSortDirections, appliedLevelSortDirections);
            mergedLevelSortDirections = $.map(mergedLevelSortDirections, function (sd) {
                return sd;
            });

            viewSettings = {
                isParentInFrontForColumns: this.options.isParentInFrontForColumns,
                isParentInFrontForRows: this.options.isParentInFrontForRows,
                compactRowHeaders: this.options.compactRowHeaders,
                compactColumnHeaders: this.options.compactColumnHeaders
            };
            hasColumns = dataSource.columnAxis().length > 0;
            hasRows = dataSource.rowAxis().length > 0;

            // We use the OlapTableView in order to populate an $.ig.DataSource.
            this._tableView = new $.ig.OlapTableView(dataSource.result(), hasColumns, hasRows, viewSettings);
            this._tableView.columnSortDirections(appliedColumnSortDirections);
            this._tableView.levelSortDirections(mergedLevelSortDirections);
            this._tableView.initialize();

            this._columnsChanged = false;
        },
        _configureOptions: function (dataSource) {
            var $this = this, cols, dataCols, data, settings, gridDataSource, options;

            this._rowsMatrix = new Matrix();
            this._fillMatrixWithHeaderCells(this._rowsMatrix, this._tableView.rowHeaders());
            this._maxMemberIndex = dataSource.columnAxis().length - 1;

            cols = this._generateAllGridColumns(this._tableView.columnHeaders());
            // rowHeaders = this._generateRowHeaders(tableView.rowHeaders());
            dataCols = this._generateDataColumns(this._tableView.columnHeaders());

            data = this._transformGridData(this._tableView.resultCells(), dataCols, dataCols.length, this._rowsMatrix.length);
            settings = { dataSource: data };
            gridDataSource = new $.ig.DataSource(settings);
            options = {
                // dataSource: gridDataSource,
                // columns: dataCols,
                // columns: cols, // multi-column headers; 
                // features: [{ 
                //      name: "MultiColumnHeaders" // multi-column headers is a requirement of the pivot grid 
                // }]
                headerRendered: function (event, ui) {
                    if ($this._ds) {
                        $this._onGridHeadersRendered(event, ui);
                    }
                },
                dataRendered: function (event, ui) {
                    if ($this._ds) {
                        $this._onDataRendered(event, ui);
                    }
                }
            };

            // Deep merge with the options.gridOptions.
            $.extend(true, options, this.options.gridOptions);

            // The data source and the columns are set now (i.e. later, after the merge)
            // in order to ensure we are overwriting anything that the developer has set.
            // The pivot grid doesn't allow any initial columns or data sources
            // to be set in its options.gridOptions.
            options.dataSource = gridDataSource;
            options.columns = cols;
            // Disable the options, which are not suppoerted by igPivotGrid.
            options.autoGenerateColumns = false;
            options.virtualization = false;
            options.fixedFooters = false;
            options.autoFormat = false;
            options.renderCheckBoxes = false;
            options.autoFitLastColumn = false;
            options.autoAdjustHeight = true;
            // For width and height use igPivotGrid's options.
            options.width = this.options.width;
            options.height = this.options.height;

            // Merge the features. the PivotGrid requires multi-column headers
            $.merge(options.features, [{ name: "MultiColumnHeaders"}]);

            return options;
        },
        _fillMatrixWithHeaderCells: function (matrix, headerCells) {
            var expandIcon, collapseIcon, allowHeaderRowsSorting, sortHeaderRowsAscendingIcon, sortHeaderRowsDescendingIcon,
                headerCell, levelSortDirectionsMap, headerMarkup, text, rowSpan, columnSpan, rowIndex, columnIndex,
				axisName, tupleIndex, memberIndex, sortDirection, isExpandable, isExpanded, expandButtonMarkup, indent, i, css;
            if (!headerCells || headerCells.length === 0) {
                // Render an empty header cell.
                matrix.set(0, 0, "<th class='ui-iggrid-header ui-widget-header'></th>");
                return;
            }

            allowHeaderRowsSorting = this.options.allowHeaderRowsSorting;

            expandIcon = "<span data-expand='true' class='" + this.css.expandButton + "' style='margin-left: $$margin$$px;'></span>";
            collapseIcon = "<span data-expand='false' class='" + this.css.collapseButton + "' style='margin-left: $$margin$$px;'></span>";
            sortHeaderRowsAscendingIcon = "<span data-sortheader='asc' class='" + this.css.headerRowsAscending + "'></span>";
            sortHeaderRowsDescendingIcon = "<span data-sortheader='desc' class='" + this.css.headerRowsDescending + "'></span>";

            levelSortDirectionsMap = this._tableView.appliedSortDirectionsMap();

            for (i = 0; i < headerCells.length; i++) {
                headerCell = headerCells[i];

                text = headerCell.caption();
                rowSpan = headerCell.rowSpan();
                columnSpan = headerCell.columnSpan();
                rowIndex = headerCell.rowIndex();
                columnIndex = headerCell.columnIndex();
                axisName = headerCell.axisName();
                tupleIndex = headerCell.tupleIndex();
                memberIndex = headerCell.memberIndex();
                isExpandable = headerCell.isExpandable();
                isExpanded = headerCell.isExpanded();

                css = "ui-iggrid-header ui-widget-header " + this.css.pivotGridHeader;

                headerMarkup = "<th $$data-sortheader$$ " +
                    "class='" + css + "' " +
                    "title='" + text + "' " +
                    "data-skip='true' " + // A.T. important for features 
                    "rowspan='" + rowSpan + "' " +
                    "colspan='" + columnSpan + "' " +
                    "data-axis='" + axisName + "' " +
                    "data-tuple='" + tupleIndex + "' " +
                    "data-member='" + memberIndex + "'>";

                if (isExpandable) {
                    indent = this.options.compactRowHeaders ? this.options.compactRowHeaderIndentation * headerCell.levelNumber() : 0;
                    expandButtonMarkup = isExpanded ? collapseIcon : expandIcon;
                    expandButtonMarkup = expandButtonMarkup.replace("$$margin$$", indent);
                    headerMarkup += expandButtonMarkup;
                    headerMarkup += "<span class='ui-iggrid-headertext'>" + text + "</span>";
                    // Get the current sort state.
                    if (isExpanded) {
                        sortDirection = levelSortDirectionsMap[headerCell.axisName()];
                        if (sortDirection) {
                            sortDirection = sortDirection[headerCell.hierarchyNumber()];
                            if (sortDirection) {
                                sortDirection = sortDirection[headerCell.levelNumber()];
                            }
                        }
                        if (sortDirection === "ascending") {
                            headerMarkup = headerMarkup.replace("$$data-sortheader$$", "data-sortheader='ascending'");
                            headerMarkup += sortHeaderRowsAscendingIcon;
                        } else if (sortDirection === "descending") {
                            headerMarkup = headerMarkup.replace("$$data-sortheader$$", "data-sortheader='descending'");
                            headerMarkup += sortHeaderRowsDescendingIcon;
                        } else if (allowHeaderRowsSorting) {
                            headerMarkup = headerMarkup.replace("$$data-sortheader$$", "data-sortheader=''");
                        }
                    } else {
                        headerMarkup = headerMarkup.replace("$$data-sortheader$$", "");
                    }
                } else {
                    indent = this.options.compactRowHeaders ? this.options.compactRowHeaderIndentation * (headerCell.levelNumber() + 1) : 0;
                    text = "<span class='ui-iggrid-headertext' style='margin-left:" + indent + "px;'>" + text + "</span>";
                    headerMarkup += text;
                }

                headerMarkup += "</th>";

                matrix.set(rowIndex + rowSpan - 1, columnIndex + columnSpan - 1, undefined);
                matrix.set(rowIndex, columnIndex, headerMarkup);
            }
        },
        _generateAllGridColumns: function (headers) {
            // A.T. the headers collection contains a list of all headers
            // some of which are multicolumn headers
            // so whenever we reach a column with a larger 
            var cols, levels = [], i;
            if (!headers || headers.length === 0) {
                // Render an empty header cell.
                return [this._const.emptyCell];
            }

            for (i = 0; i < headers.length; i++) {
                if (!levels[headers[i].rowIndex()]) {
                    levels[headers[i].rowIndex()] = [];
                }
                levels[headers[i].rowIndex()].push(headers[i]);
            }
            this._maxLevel = levels.length;
            cols = this._processHeadersTree(levels);
            // this._processMultiColumnHeadersRecursive(cols, headers, 0, headers.length);
            return cols;
        },
        _generateDataColumns: function (headers) {
            var cols = [], i;
            if (!headers || headers.length === 0) {
                // Render an empty header cell.
                return [this._const.emptyCell];
            }

            for (i = 0; i < headers.length; i++) {
                if (headers[i].memberIndex() !== this._maxMemberIndex) {
                    // A.T. skip headers who aren't on the last level - that's the case when we have more than 1 hierarchies for the columns
                    continue;
                }
                if (headers[i].columnSpan() === 1 && (headers[i].isExpandable() === false || !headers[i].isExpanded())) {
                    cols.push({
                        headerText: headers[i].caption(),
                        key:
                            headers[i].axisName() + "_" +
                            headers[i].tupleIndex() + "_" +
                            headers[i].memberIndex() + "_" +
                            headers[i].isExpandable()
                    });
                } else if (this.options.compactColumnHeaders) {
                    cols.push({
                        headerText: headers[i].caption(),
                        key:
                            headers[i].axisName() + "_" +
                            headers[i].tupleIndex() + "_" +
                            headers[i].memberIndex() + "_" +
                            headers[i].isExpandable()
                    });
                }
            }
            return cols;
        },
        _transformGridData: function (cells, columns, columnsCount, maxRowCount) {
            // PP TFS #130374
            // pass maxRowCount as it's calculated for rowsMatrix
            var data = [], cellOrdinal, i, colIndex;
            if (!cells || cells.length === 0) {
                // PP TFS #130374
                // we still can have rows even there we have no cells generated
                if (maxRowCount > 0) {
                    for (i = 0; i < maxRowCount; i++) {
                        data.push({});
                    }
                    return data;
                }

                // Render an empty header cell.
                return [{}];
            }

            for (i = 0; i < maxRowCount; i++) {
                data.push({});
            }

            // Set the data
            for (i = 0; i < cells.length; i++) {
                cellOrdinal = cells[i].cellOrdinal();
                colIndex = cellOrdinal % columnsCount;
                // data[Math.floor(cellOrdinal / columnsCount)][columns[colIndex].key] = cells[i].value();
                // A.T. should we use formatted value or the data value, in  the data source?
                data[Math.floor(cellOrdinal / columnsCount)][columns[colIndex].key] = cells[i].formattedValue();
            }
            return data;
        },
        _processHeadersTree: function (tree) {
            var cols = [], i, j, parent, parents;
            for (i = 0; tree.length >= 1 && i < tree[0].length; i++) {
                // Push root items.
                this._createHeader(cols, tree[0][i]);
            }
            // Fill all children items, by finding their parent .
            for (i = 1; i < tree.length; i++) {
                // Process levels.
                // Insert the tree[i] items into their respective places in cols.
                parents = this._parentsForLevel(i, cols);
                for (j = 0; j < tree[i].length; j++) { // process individual header cells 
                    // Find the item's parent.
                    parent = this._findParent(parents, tree[i][j]);
                    if (parent) {
                        this._createHeader(parent, tree[i][j]);
                    } else {
                        // Go one level up.
                        if (i - 1 >= 1) {
                            this._findAndCreateUp(i - 1, i, cols, tree, tree[i][j]);
                        }
                    }
                }
            }
            return cols;
        },
        _findAndCreateUp: function (level, itemsLevel, cols, tree, item) {
            var parents, j, currentItem, parent;

            // Insert the tree[i] items into their respective places in cols.
            parents = this._parentsForLevel(level, cols);

            for (j = 0; j < tree[itemsLevel].length; j++) {
                // Process individual header cells. 
                // Find the item's parent 
                // itemsLevel - level is optional - this is the rowSpan of the potential parent,
                // in case it's not 1
                currentItem = tree[itemsLevel][j];
				if (currentItem.axisName() === item.axisName() && currentItem.columnIndex() === item.columnIndex() &&
						currentItem.memberIndex() === item.memberIndex() && currentItem.tupleIndex() === item.tupleIndex() &&
						currentItem.caption() === item.caption()) {
                    parent = this._findParent(parents, currentItem, itemsLevel - level + 1);
                    if (parent) {
                        this._createHeader(parent, currentItem);
                    } else {
                        // Go one level up
                        if (level - 1 >= 1) {
                            this._findAndCreateUp(level - 1, itemsLevel, cols, tree, item);
                        }
                    }
                }
            }
        },
        _parentsForLevel: function (level, root) {
            var parents = [], i;
            for (i = 0; i < root.length; i++) {
                this._parentsForLevelRecursive(parents, root[i], 1, level);
            }
            return parents;
        },
        _parentsForLevelRecursive: function (parents, currentParent, currentLevel, level) {
            var extraLevel = currentParent.rowspan > 1 ? currentParent.rowspan - 1 : 0, i;
            if (currentLevel === level) {
                // for (i = 0; currentParent.group && i < currentParent.group.length; i++) {
                //  if (currentParent.group[i]) {
                parents.push(currentParent);
                //      parents.push(currentParent);
                //	}
                // }
            } else if (currentLevel < level && currentParent.group !== null && currentParent.group !== undefined) {
                for (i = 0; i < currentParent.group.length; i++) {
                    this._parentsForLevelRecursive(parents, currentParent.group[i], currentLevel + 1 + extraLevel, level);
                }
            }
        },
        _createHeader: function (parent, col) {
            var column = {
                headerText: col.caption(),
                key: col.axisName() + "_" + col.tupleIndex() + "_" + col.memberIndex() + "_" + col.isExpandable(),
                rowspan: col.rowSpan(),
                colSpan: col.columnSpan(),
                colIndex: col.columnIndex(),
                axisName: col.axisName(),
                tupleIndex: col.tupleIndex(),
                memberIndex: col.memberIndex(),
                expandable: col.isExpandable(),
                expanded: col.isExpanded(),
                hierarchyNumber: col.hierarchyNumber(),
                levelNumber: col.levelNumber()
            };
            // There is a case where a header can have colSpan of 1, but still have children.
            if (!this.options.compactColumnHeaders && (col.columnSpan() > 1 || (col.columnSpan() === 1 && col.isExpanded() && col.isExpandable()))) {
                // multi
                column.group = [];
            }
            parent.push(column);
        },
        _findParent: function (cols, header, rowSpan) {
            // Process cols recursively, until the level maches, and the header also matches the parent.
            // Traverse cols.
            var i;
            if (!cols || cols.length === undefined || cols.length === null) {
                return null;
            }
            for (i = 0; i < cols.length; i++) {
                if (rowSpan === undefined || (rowSpan !== undefined && cols[i].rowspan === rowSpan)) {
                    // if (cols[i].colSpan  >= header.columnSpan() && header.columnIndex() >= cols[i].colIndex) {
                    if (cols[i].colSpan + cols[i].colIndex >= header.columnSpan() + header.columnIndex() && cols[i].colIndex <= header.columnIndex()) {
                        // return cols[i];
                        if (!cols[i].group) {
                            cols[i].group = [];
                        }
                        return cols[i].group;
                    }
                }
            }
            return null;
        },
        grid: function () {
            /* Returns the igGrid instance used to render the OLAP data.
            returnType="object"
            */
            return this.element.data(_igGrid);
        },
        updateGrid: function () {
            /* Triggers an update on the data source and the igPivotGrid.  
            */
            this._updateGrid(false, true);
        },
        _updateGrid: function (init, deferUpdateOverride) {
            var dataSource = this._ds, container,
                shouldUpdate = deferUpdateOverride || this.options.deferUpdate === false,
                promise;

            if (!init && !shouldUpdate) {
                return;
            }

            // Show a progress indicator - that's the case when the grid has already been created
            // and we've started expanding/collapsing.
            if (this.element.data(_igGrid)) {
                container = this.grid().container();
                $("#" + this.grid().element.attr("id") + "_columns_overlay").css("display", "none");
                $("#" + this.grid().element.attr("id") + "_measures_overlay").css("display", "none");
                container.css("position", "relative");
                // Create the block area.
                $("<div class='" + this.css.blockArea + "'></div>")
                    .appendTo(container)
                // Set the "excludeFromHeight" attribute.
                // See infragistics.ui.grid.framework.js.
                    .data("efh", "1");
            }

            if (init) {
                promise = dataSource.initialize();
            } else {
                promise = dataSource.update();
            }

            return promise;
        },
        _onGridUpdated: function () {
            var dataSource = this._ds, options;

            this._createTableView(dataSource);
            options = this._configureOptions(dataSource);
            this._renderGrid(options);
        },
        _renderEmptyGrid: function () {
            var options;
            options = $.extend(true, {}, this.options.gridOptions);
            options.width = this.options.width;
            options.height = this.options.height;
            this.element.igGrid(options);
        },
        _renderGrid: function (options) {
            var id = this.element.attr("id"), grid, container;

            grid = this.grid();
            if (grid) {
                this._gridScrollOffsets.top = grid.scrollContainer().scrollTop();
                this._gridScrollOffsets.left = $("#" + id + "_hscroller").scrollLeft();
                // Clear the widget. 
                this.element.igGrid("destroy");
                this.element.empty();
            }

            // Reinitialize the widget.
            this.element.igGrid(options);

            // Make the Grid container droppable.
            container = this.grid().container();
            container.addClass(this.css.pivotGrid);
            this._makeDroppable(container);
        },
        _onGridHeadersRendered: function (event, ui) {
            // Iterate through all column headers.
            // var headers = sender.owner.options.columns, table = sender.table;
            var $this = this, headers = ui.owner._oldCols, table = ui.table, id = this.element.attr("id"),
                appliedColumnSortDirectionsMap,
                first, firstParent, rowsCellColSpan, rowsCellRowSpan, columnsCellColSpan, filtersCellColSpan, row,
                droppableOptions, dropArea, header, dataSource = this._ds,
                extraColsCount, colgroup, col, i, length, sortableHeaders;

            table.addClass(this.css.pivotGrid);

            // We need to render the extra THs for every row.
            // For that reason we need the row's string before it's passed to the grid for rendering
            // Override the renderRecord functionality.
            ui.owner._renderRecord = function (data, rowIndex) {
                return $this._renderPivotRecord.call(this, $this._rowsMatrix, data, rowIndex);
            };

            if (headers === null || headers === undefined) {
                headers = ui.owner.options.columns;
            }

            // Prepare the column sort directions map.
            appliedColumnSortDirectionsMap = {};
            $.each(this._tableView.appliedColumnSortDirections(), function (ind, csd) {
                appliedColumnSortDirectionsMap[csd.tupleIndex] = csd.sortDirection;
            });

            // Traverse the headers.
            this._processHeaderMarkupRecursive(
                this.grid().element[0].id,
                headers,
                appliedColumnSortDirectionsMap,
                this._tableView.appliedSortDirectionsMap()
			);

            // Prepare for the extra cells.
            first = table.find("tr").first();
            firstParent = first.parent();
            // Calculate the row and column spans.
            rowsCellColSpan = this._rowsMatrix.length > 0 ? this._rowsMatrix[0].length : 1;
            rowsCellRowSpan = this._maxLevel;
            columnsCellColSpan = ui.owner.options.columns.length;
            filtersCellColSpan = rowsCellColSpan + columnsCellColSpan;
            if (table.find(".ui-igpivot-droparea[data-role=rows], .ui-igpivot-droparea[data-role=columns], .ui-igpivot-droparea[data-role=measures], .ui-igpivot-droparea[data-role=filters]").length === 0) {
                droppableOptions = this._createDropAreaOptions();
                // Rows
                if (!this.options.hideRowsDropArea) {
                    header = $("<th id='" + id + "_rows' rowSpan='" + rowsCellRowSpan + "' colSpan='" + rowsCellColSpan + "' data-skip='true' class='" + this.css.dropAreaHeader + "'></th>").prependTo(first);

                    // N.A. - Fix for bug #130370.
                    // The following line sets the height of the header explicitly
                    // so all its children with height 100% will resize to fit the
                    // available height.
                    header.height(header.height());

                    dropArea = $("<ul data-role='rows' class='" + this.css.dropArea + "'></ul>").appendTo(header);
                    if (!this.options.disableRowsDropArea && !this._isTouch()) {
                        dropArea.droppable(droppableOptions);
                    }
                } else {
                    $("<th rowSpan='" + rowsCellRowSpan + "' colSpan='" + rowsCellColSpan + "' data-skip='true' class='ui-iggrid-header ui-widget-header'></th>").prependTo(first);
                }

                if (!this.options.hideColumnsDropArea || !this.options.hideMeasuresDropArea) {
                    row = $("<tr></tr>").prependTo(firstParent);
                }
                // Columns
                if (!this.options.hideColumnsDropArea) {
                    header = $("<th id='" + id + "_columns' rowSpan='1' colSpan='" + columnsCellColSpan + "' data-skip='true' class='" + this.css.dropAreaHeader + "'></th>").prependTo(row);
                    dropArea = $("<ul data-role='columns' class='" + this.css.dropArea + "'></ul>").appendTo(header);
                    if (!this.options.disableColumnsDropArea && !this._isTouch()) {
                        dropArea.droppable(droppableOptions);
                        if ($("#" + id + "_columns_overlay").length < 1) {
                            $("<div id='" + id + "_columns_overlay' data-role='columns' class='" + this.css.overlayDropArea + " ui-igpivot-droparea ui-droppable'></div>")
								.appendTo(this.element)
								.droppable(droppableOptions);
                        }
                    }
                } else if (!this.options.hideMeasuresDropArea) {
                    $("<th rowSpan='1' colSpan='" + columnsCellColSpan + "' data-skip='true' class='ui-iggrid-header ui-widget-header'></th>").prependTo(row);
                }
                // Measures
                if (!this.options.hideMeasuresDropArea) {
                    header = $("<th id='" + id + "_measures' rowSpan='1' colSpan='" + rowsCellColSpan + "' data-skip='true' class='" + this.css.dropAreaHeader + "'></th>").prependTo(row);
                    dropArea = $("<ul data-role='measures' class='" + this.css.dropArea + "'></ul>").appendTo(header);
                    if (!this.options.disableMeasuresDropArea && !this._isTouch()) {
                        dropArea.droppable(droppableOptions);
                    }
                } else if (!this.options.hideColumnsDropArea) {
                    $("<th rowSpan='1' colSpan='" + rowsCellColSpan + "' data-skip='true' class='ui-iggrid-header ui-widget-header'></th>").prependTo(row);
                }

                // Filters
                if (!this.options.hideFiltersDropArea) {
                    row = $("<tr></tr>").prependTo(firstParent);
                    header = $("<th id='" + id + "_filters' rowSpan='1' colSpan='" + filtersCellColSpan + "' data-skip='true' class='" + this.css.dropAreaHeader + "'></th>").prependTo(row);
                    dropArea = $("<ul data-role='filters' class='" + this.css.dropArea + "'></ul>").appendTo(header);
                    if (!this.options.disableFiltersDropArea && !this._isTouch()) {
                        dropArea.droppable(droppableOptions);
                    }
                }
            } else {
                // Rows
                $("#" + id + "_rows").attr("rowSpan", rowsCellRowSpan).attr("colSpan", rowsCellColSpan);
                // Columns
                $("#" + id + "_columns").attr("rowSpan", 1).attr("colSpan", columnsCellColSpan);
                // Measures
                $("#" + id + "_measures").attr("rowSpan", 1).attr("colSpan", rowsCellColSpan);
                // Filters
                $("#" + id + "_fiters").attr("rowSpan", 1).attr("colSpan", filtersCellColSpan);
            }

            // Find the COLGROUPs
            colgroup = table.find("colgroup");
            // If the grid is rendered using one table element, there will be no COLGROUP element.
            if (colgroup.length === 0) {
                // Add COL elements if the grid was rendered without them.

                // Determine the number of COL elements that need to be added.
                if (this.grid()._isMultiColumnGrid) {
                    // If the grid has multi column headers (there is an actual hierarchy in the headers),
                    // count all leaf headers - they have the attribute 'data-isheadercell'.
                    length = table.find("th[data-isheadercell]").length;
                } else {
                    // Even if the grid has the multi column headers feature enabled,
                    // if the specified columns don't have an actual hierarchy,
                    // the grid will have _isMultiColumnHeader set to false and
                    // there will be no leaf headers with 'data-isheadercell'.
                    // In this case the headers are a flat list.
                    length = headers.length;
                }

                // Create the COLGROUP and fill it with COL elements.
                colgroup = "<colgroup>";
                for (i = 0; i < length; i++) {
                    colgroup += "<col></col>";
                }
                colgroup += "</colgroup>";
                // Add the COLGROUP to the headers table.
                colgroup = $(colgroup).prependTo(table);
            }
            // Add extra col elements.
            // Set the extra COL elements to the grid's table, based on the value of rowsMatrix.length
            extraColsCount = this._rowsMatrix.length > 0 ? this._rowsMatrix[0].length : 1;
            for (i = 0; i < extraColsCount; i++) {
                // PP TFS 142541; 142542
                // because of bug in jQuery 2.0.0 keep setting attribute value separate from tag creation
                col = $("<col></col>").prependTo(colgroup).attr('data-skip', 'true');
            }

            // Moved this event binding to the _onDataRendered function - bug 138842.
            //table.find("span[data-expand]").bind("click", function (evt) {
            //    $this._onToggleTupleMember(evt);
            //    return false;
            //});
            if (this.options.allowSorting) {
                sortableHeaders = table.find(".ui-igpivotgrid-header[data-sort]");
                sortableHeaders.children(".ui-iggrid-headertext,.ui-iggrid-sortindicator").bind("click", function (evt) {
                    $this._onSort(evt);
                });
                sortableHeaders.filter("[data-axis='empty_axis']").bind("click", function (evt) {
                    $this._onSort(evt);
                });
            }
            if (this.options.allowHeaderColumnsSorting) {
                table.find(".ui-igpivotgrid-header[data-sortheader]").children(".ui-iggrid-headertext,.ui-iggrid-sortindicator").bind("click", function (evt) {
                    $this._onSortHeader(evt);
                });
            }

            // Fill the drop areas with metadata elements.
            if (!this.options.hideFiltersDropArea) {
                this._fillDropArea("#" + id + "_filters .ui-igpivot-droparea", dataSource.filters(),
					this.options.disableFiltersDropArea, this.options.disableFiltersDropArea ?
						$.ig.PivotGrid.locale.disabledFiltersHeader :
						$.ig.PivotGrid.locale.filtersHeader);
            }
            if (!this.options.hideRowsDropArea) {
                this._fillDropArea("#" + id + "_rows .ui-igpivot-droparea", dataSource.rowAxis(),
					this.options.disableRowsDropArea, this.options.disableRowsDropArea ?
						$.ig.PivotGrid.locale.disabledRowsHeader :
						$.ig.PivotGrid.locale.rowsHeader);
            }
            if (!this.options.hideColumnsDropArea) {
                this._fillDropArea("#" + id + "_columns .ui-igpivot-droparea", dataSource.columnAxis(),
					this.options.disableColumnsDropArea, this.options.disableColumnsDropArea ?
						$.ig.PivotGrid.locale.disabledColumnsHeader :
						$.ig.PivotGrid.locale.columnsHeader);
            }
            if (!this.options.hideMeasuresDropArea) {
                this._fillDropArea("#" + id + "_measures .ui-igpivot-droparea", dataSource.measures(),
					this.options.disableMeasuresDropArea, this.options.disableMeasuresDropArea ?
						$.ig.PivotGrid.locale.disabledMeasuresHeader :
						$.ig.PivotGrid.locale.measuresHeader);
            }

            this._measureHeaders(headers);

            // Attach to events in the headers table
            table.find("thead span.ui-iggrid-headerbutton.ui-icon").bind("click", function (evt) {
                $this._onToggleTupleMember(evt);
                return false;
            });
            
            this._triggerPivotGridHeadersRendered(event, ui);
        },
        _renderPivotRecord: function (matrix, data, rowIndex) {
            // Generate a TR and append it to the table.
            var i, key = this.options.primaryKey, ar = this.options.accessibilityRendering,
				grid = this, dstr = "", cols = this.options.columns, noVisibleColumns, str = "";

            // Take into account any offset.
            // A.T. TODO: refactor this so that the pivot grid doesn't know about paging.
            // There are visualization (misalignment issues with this, so commenting for now)
            // rowIndex += grid.dataSource.pageIndex() * grid.dataSource.pageSize();

            dstr += "<tr";
            if (rowIndex % 2 !== 0 && this.options.alternateRowStyles) {
                dstr += " class='" + grid.css.recordAltClass + "'";
            }
            if (!_aNull(key)) {
                dstr += " data-id='" + this._kval_from_key(key, data) + "'";
            } else if (!_aNull(data.ig_pk)) {
                dstr += " data-id='" + data.ig_pk + "'";
            }
            // Data index to which the row is bound.
            if (this.options.virtualization && this.options.virtualizationMode === "continuous") {
                dstr += " data-row-idx='" + rowIndex + "'";
            }
            if (ar) {
                dstr += " role='row'>";
            } else {
                dstr += ">";
            }
            // var str = "", matrix = $this.element.data("igPivotGrid")._rowsMatrix;
            for (i = 0; i < matrix[rowIndex].length; i++) {
                if (matrix[rowIndex][i]) {
                    str += matrix[rowIndex][i];
                }
            }
            if (str !== "") {
                dstr += str;
            }
			noVisibleColumns = true;
			$(cols).each(function (colIndex) {
		        if (cols[colIndex].hidden || cols[colIndex].fixed === true) {
		            return;
		        }
		        noVisibleColumns = false;
		        if (ar) {
		            dstr += '<td role="gridcell" aria-describedby="' + this.key + '"';
		        } else {
		            dstr += '<td';
		        }
		        if (cols[colIndex].template && cols[colIndex].template.length) {
		            temp = grid._renderTemplatedCell(data, this);
		            if (temp.indexOf("<td") === 0) {
		                dstr += temp.substring(3);
		            } else {
		                dstr += '>' + temp;
		            }
		            dstr = grid._editCellStyle(dstr, data, this.key);
		        } else {
		            dstr += grid._addCellStyle(data, this.key ? this.key : colIndex) + '>' + grid._renderCell(data[this.key ? this.key : colIndex], this, data);
		        }
		        dstr += '</td>';
		    });
			if (noVisibleColumns) {
				dstr += "<td role='gridcell'></td>";
			}
            dstr += "</tr>";
            return dstr;
        },
        _processHeaderMarkupRecursive: function (tableId, headers, columnSortDirectionsMap, levelSortDirectionsMap) {
            var i, headerCell, expanded, expandable, sortDirection,
                expandIcon, collapseIcon,
                allowSorting, allowHeaderColumnsSorting,
                sortRowsAscendingIcon, sortRowsDescendingIcon,
                sortHeaderColumnsAscendingIcon, sortHeaderColumnsDescendingIcon;

            allowSorting = this.options.allowSorting;
            allowHeaderColumnsSorting = this.options.allowHeaderColumnsSorting;

            expandIcon = "<span data-expand='true' class='" + this.css.expandButton + "'/>";
            collapseIcon = "<span data-expand='false' class='" + this.css.collapseButton + "'/>";
            sortRowsAscendingIcon = "<span data-sort='asc' class='" + this.css.rowsAscending + "'/>";
            sortRowsDescendingIcon = "<span data-sort='desc' class='" + this.css.rowsDescending + "'/>";
            sortHeaderColumnsAscendingIcon = "<span data-sortheader='asc' class='" + this.css.headerColumnsAscending + "'></span>";
            sortHeaderColumnsDescendingIcon = "<span data-sortheader='desc' class='" + this.css.headerColumnsDescending + "'></span>";

            for (i = 0; i < headers.length; i++) {
                headerCell = $("#" + tableId + "_" + headers[i].key);
                headerCell
                    .addClass(this.css.pivotGridHeader)
                    .attr("data-axis", headers[i].axisName)
                    .attr("data-member", headers[i].memberIndex)
                    .attr("data-tuple", headers[i].tupleIndex);

                if (headers[i].axisName !== this._const.emptyCell.axisName) {
                    headerCell.attr("title", headers[i].headerText);
                }

                // if (headerCell.find("span[data-expand], span[data-sortheader]").length > 0) {
                //     headerCell.find("span[data-expand], span[data-sortheader]").remove();
                // }

                if (this.options.compactColumnHeaders && headers[i].levelNumber > 0) {
                    headerCell.css("padding-top", this.options.compactColumnHeaderIndentation * headers[i].levelNumber);
                }

                expandable = headers[i].expandable;
                expanded = headers[i].expanded;

                if (expandable && !expanded) {
                    $(expandIcon).insertBefore(headerCell.children(".ui-iggrid-headertext"));
                } else if (expandable && expanded) {
                    $(collapseIcon).insertBefore(headerCell.children(".ui-iggrid-headertext"));

                    sortDirection = levelSortDirectionsMap[headers[i].axisName];
                    if (sortDirection) {
                        sortDirection = sortDirection[headers[i].hierarchyNumber];
                        if (sortDirection) {
                            sortDirection = sortDirection[headers[i].levelNumber];
                        }
                    }
                    if (sortDirection === "ascending") {
                        headerCell.attr("data-sortheader", "ascending");
                        $(sortHeaderColumnsAscendingIcon).appendTo(headerCell);
                    } else if (sortDirection === "descending") {
                        headerCell.attr("data-sortheader", "descending");
                        $(sortHeaderColumnsDescendingIcon).appendTo(headerCell);
                    } else if (allowHeaderColumnsSorting) {
                        headerCell.attr("data-sortheader", "");
                    }
                }

                if (!expandable || (expandable && !expanded)) {
                    sortDirection = columnSortDirectionsMap[headers[i].tupleIndex];
                    if (sortDirection === "ascending") {
                        headerCell.attr("data-sort", "ascending");
                        $(sortRowsAscendingIcon).appendTo(headerCell);
                    } else if (sortDirection === "descending") {
                        headerCell.attr("data-sort", "descending");
                        $(sortRowsDescendingIcon).appendTo(headerCell);
                    } else if (allowSorting) {
                        headerCell.attr("data-sort", "");
                    }
                }

                // Process the header's children.
                if (headers[i].group) {
                    this._processHeaderMarkupRecursive(tableId, headers[i].group, columnSortDirectionsMap, levelSortDirectionsMap);
                }
            }
        },
        _fillDropArea: function (dropAreaSelector, items, isDisabled, emptyMessage) {
            var dropArea = $(dropAreaSelector), i, length;

            // Remove old items.
            dropArea.empty();

            if (items.length > 0) {
                // Fill the drop are with items.
                for (i = 0, length = items.length; i < length; i++) {
                    this._createMetadataElement(items[i], isDisabled, "appendTo", dropArea);
                }
            } else {
                dropArea.text(emptyMessage);
            }
        },
        _measureHeaders: function (headers) {
            var $this = this, id = this.element.attr("id"), grid = this.grid(), table = grid.headersTable(),
                extraColsCount, extraColsWidth, maxWidth, header, measureTh, colsWidth;

            extraColsCount = this._rowsMatrix.length > 0 ? this._rowsMatrix[0].length : 1;

            if (this.options.defaultRowHeaderWidth) {
                // Set the user's row header width to all extra columns.
                table.find("col:lt(" + extraColsCount + ")").width(this.options.defaultRowHeaderWidth);
                // Measure all drop areas and see if they need scrolls.
                if (!this._isTouch()) {
                    table.find(".ui-igpivot-droparea[data-role=rows], .ui-igpivot-droparea[data-role=columns], .ui-igpivot-droparea[data-role=measures], .ui-igpivot-droparea[data-role=filters]")
                        .each(function (ind, el) { $this._measureDropArea($(this)); });
                } else {
                    table.find(".ui-igpivot-droparea[data-role=rows], .ui-igpivot-droparea[data-role=columns], .ui-igpivot-droparea[data-role=measures], .ui-igpivot-droparea[data-role=filters]").each(function (ind, el) {
                        // Wrap the drop area with a DIV and make it an igScroll.
                        $(el).wrap($("<div style='overflow: hidden;'></div>")).parent("div").igScroll();
                    });
                }
                extraColsWidth = this.options.defaultRowHeaderWidth * extraColsCount;
            } else {
                // Find the greater width between the filters and rows drop areas.
                maxWidth = 0;
                table.find("#" + id + "_measures, #" + id + "_rows").each(function (ind, el) {
                    var clone, parent;
                    clone = $(el).clone(false);
                    clone.children(".ui-igpivot-droparea").append("<li class='" + $this.css.insertItem + "'></li>");
                    parent = $("<div class='ui-widget ui-widget-header ui-iggrid ui-igpivotgrid'></div>").append(clone).css({
                        "position": "absolute",
                        "visibility": "hidden",
                        "height": "auto",
                        "width": "auto",
                        "overflow": "visible",
                        "text-overflow": "clip",
                        "left": "-1000px",
                        "top": "-1000px"
                    }).appendTo(document.body);
                    maxWidth = Math.max(maxWidth, parent.outerWidth(true));
                    parent.remove();
                });
                // Distribute the width between the extra columns.
                table.find("col:lt(" + extraColsCount + ")").width(Math.ceil(maxWidth / extraColsCount));
                extraColsWidth = maxWidth;
            }

            // Measure the grid's headers if the grid is rendered using several tables.
            if (grid.options.defaultColumnWidth) {
                table.find("col:gt(" + extraColsCount + ")").width(grid.options.defaultColumnWidth);
            } else {
                // Get a header from the grid's table and use it to create an element,
                // which will be used to measure the leaf headers.
                header = table.find("th:not(.ui-igpivot-dropareaheader):first");
                // Prepare the measuring element.
                measureTh = $("<th class='" + header.attr("class") + "' style='position:absolute;visibility:hidden;height:auto;width:auto;overflow:visible;text-overflow:clip;left:-1000px;top:-1000px;'></th>")
                    .css({
                        "font-family": header.css("fontFamily"),
                        "font-size": header.css("fontSize"),
                        "font-size-adjust": header.css("fontSizeAdjust"),
                        "font-stretch": header.css("fontStretch"),
                        "font-style": header.css("fontStyle"),
                        "font-variant": header.css("fontVariant"),
                        "font-weight": header.css("fontWeight")
                    }).appendTo(document.body);
                // Traverse and measure the headers.
                colsWidth = this._measureHeadersRecursive(
                    this.grid().element[0].id,
                    headers,
                // Reuse the measure element for performance reasons.
                    measureTh,
                    extraColsCount
                );
                // Remove the measuring element from the DOM.
                measureTh.remove();
            }

            if (table.find("col").length - extraColsCount === 1 || (extraColsWidth + colsWidth) < table.width()) {
                // Set the width of the last column to auto so it can stretch to fill the remaining space.
                table.find("col:last").width("auto");
            }
        },
        _measureHeadersRecursive: function (tableId, headers, measureTh, extraColsCount) {
            var i, headerCell, totalWidth, width;
            totalWidth = 0;
            // Enumerate all headers.
            for (i = 0; i < headers.length; i++) {
                if (headers[i].axisName === this._const.emptyCell.axisName) {
                    // N.A. - Fix for bug #135880.
                    break;
                }

                headerCell = $("#" + tableId + "_" + headers[i].key);
                // Process the header's children.
                if (headers[i].group) {
                    // Accumulate the widths of the child headers.
                    totalWidth += this._measureHeadersRecursive(tableId, headers[i].group, measureTh, extraColsCount);
                } else {
                    // This header has no children - measure its desired width.
                    // N.A. - Add 10 to prevent ellipsis when the sort indicator appears. Not sure why the ellipsis appears.
                    width = measureTh.html(headerCell[0].innerHTML)[0].offsetWidth + 10;
                    totalWidth += width;
                    // Assign the desired width of the header to its corresponding col element.
                    this.grid().headersTable()
                        .find("col:eq(" + (headerCell.data("columnIndex") + extraColsCount) + ")")
                        .width(width);
                    // Assign width to igGrid's column so that resizing works properly.
                    // If there is no width set, a horizontal scroll will not appear when
                    // the user resizes a column.
                    headers[i].width = width;
                }
            }
            return totalWidth;
        },
        _measureDropArea: function (dropArea) {
            var $this = this, id, parent, parentClone, parentContainer, parentWidth,
                left, minLeft, maxLeft, scrollLeft, scrollRight,
                scrollToLeft, timer,
                mouseover, mouseout;

            parent = dropArea.parent("th");
            id = parent.attr("id");

            // N.A. - Fix for bug #134655.
            parentClone = $(parent).clone(false);
            parentClone.children(".ui-igpivot-droparea").append("<li class='" + $this.css.insertItem + "'></li>");
            parentContainer = $("<div class='ui-widget ui-widget-header ui-iggrid ui-igpivotgrid'></div>").append(parentClone).css({
                "position": "absolute",
                "visibility": "hidden",
                "height": "auto",
                "width": "auto",
                "overflow": "visible",
                "text-overflow": "clip",
                "left": "-1000px",
                "top": "-1000px"
            }).appendTo(document.body);

            // Determine if the drop are has items, which are not visible.
            parentWidth = parent.width();
            if (parentContainer.find(".ui-igpivot-droparea").outerWidth(true) > parentWidth) {
                dropArea.css({
                    "display": "inline-block",
                    "overflow": "hidden",
                    "margin": 0,
                    "padding": 0
                });
                // Add the left scroll button.
                scrollLeft = $("<span class='" + this.css.scrollButton + "'><a class='" + this.css.scrollLeft + "' /></span>")
                    .insertBefore(dropArea);
                // Add the right scroll button.
                scrollRight = $("<span class='" + this.css.scrollButton + "'><a class='" + this.css.scrollRight + "' /></span>")
                    .insertAfter(dropArea);
                
                if(0 === parentWidth) {
                    dropArea.width("auto");
                } else {
                    dropArea.width(parentWidth - scrollLeft.outerWidth(true) - scrollRight.outerWidth(true));
                }

                // Prepare the scroll bounds.
                left = this._headerScrollOffsets[id] || 0;
                minLeft = 0;
                maxLeft = dropArea[0].scrollWidth;
                // Prepare a scroll function, which will be called to move the drop area.
                scrollToLeft = function () {
                    // Normalize left offset for the scrolling.
                    if (left < minLeft) {
                        left = minLeft;
                    }
                    if (left > maxLeft) {
                        left = maxLeft;
                    }
                    // Move the drop area.
                    // dropArea.css("left", left);
                    dropArea.scrollLeft(left);
                    $this._headerScrollOffsets[id] = left;
                };
                scrollToLeft();
                // Handle the mouseover events of the scroll buttons.
                // setInterval is used to call the scrollToLeft function and perform smooth scrolling.
                mouseover = this._getEvent("mouseover");
                mouseout = this._getEvent("mouseout");
                scrollLeft.bind(mouseover, function () {
                    timer = setInterval(function () {
                        left -= $this._const.hoverScrollOffset;
                        scrollToLeft();
                    }, $this._const.hoverScrollInterval);
                }).bind(mouseout, function () { clearInterval(timer); });
                scrollRight.bind(mouseover, function () {
                    timer = setInterval(function () {
                        left += $this._const.hoverScrollOffset;
                        scrollToLeft();
                    }, $this._const.hoverScrollInterval);
                }).bind(mouseout, function () { clearInterval(timer); });
            } else {
                // Remove the cached scroll offset for this drop area.
                delete this._headerScrollOffsets[id];
            }

            parentContainer.remove();
        },
		_getKPIs: function (dataSource) {
			var measures, kpi, kpiObject, KPIs = [], i;

			measures =  dataSource.measures();
			for (i = measures.length - 1; i >= 0; i--) {
				kpiObject = {};

                if("KpiMeasure" === measures[i].getType().typeName()) {
                    kpi = dataSource.getCoreElements(function(el) {
                        return el.uniqueName() === measures[i].uniqueName();
                    }, $.ig.KpiMeasure.prototype.getType());
                }

				if (undefined !== kpi && 1 === kpi.length) {
					if (null !== kpi[0].graphic()) {
						kpiObject.name = kpi[0].caption();
						kpiObject.graphic = kpi[0].graphic();
						KPIs.push(kpiObject);
					}
				}
			}

			return KPIs;
		},
		_getKPICells: function (KPIs, dataSource) {
			var headers, allColumns, columnIndexes, rowCells, allRows, i, j, k, m,
			rowspan, colspan, colspanValue, colspanOffset, rows;

			if (0 !== KPIs.length) {
				if (1 === dataSource.measures().length) {
					KPIs[0].cells = $("." + this.css.pivotGrid + " td");
				} else {
					for (m = KPIs.length - 1; m >= 0; m--) {
						KPIs[m].cells = $();
						headers = $();
						headers = headers.add("th.ui-igpivotgrid-header[title='" + KPIs[m].name + "']");

						switch (dataSource.getMeasureListLocation()) {
							case "rows":
								for (k = 0; k < headers.length; k++) {
									rowspan = parseInt(headers.eq(k).attr("rowspan"), 10);
									rows = headers.eq(k).parent();

									for (i = 0; i < rowspan; i++) {
										for (j = 0; j < rows.find('td').length; j++) {
											KPIs[m].cells = KPIs[m].cells.add(rows.find('td').eq(j)[0]);
										}

										rows = rows.next();
									}
								}
								
								break;
							case "columns":
								colspanOffset = 0;
								columnIndexes = [];
								allColumns = headers.parent().find("th[data-skip!=true]");
								
								for (i = 0, j = 0; i < allColumns.length; i++) {
									colspanValue = parseInt(allColumns.eq(i).attr("colspan"), 10);
									colspan = isNaN(colspanValue) ? 1 : colspanValue;

									if (allColumns.eq(i)[0] === headers.eq(j)[0]) {
										for (k = 0; k < colspan; k++) {
											columnIndexes.push(i + k + colspanOffset);
										}
										
										j++;
									}

									colspanOffset += colspan > 1 ? colspan - 1 : 0;
								}

								allRows = $("." + this.css.pivotGrid + " tbody tr");
								rowCells = allRows.find('td');
								for (i = 0; i < allRows.length; i++) {
									for (j = 0, k = 0; j < rowCells.length; j++) {
										if (j === columnIndexes[k]) {
											KPIs[m].cells = KPIs[m].cells.add(allRows.eq(i).find('td').eq(j)[0]);
											k++;
										}
									}
								}

								break;
						}
					}
				}

				return KPIs;
			}

			return [];
		},
		_addKPIImages: function (KPIs, dataSource) {
			var i, j, imgString, currentCell, val, x, y;

			for (i = 0; i < KPIs.length; i++) {
				for (j = 0; j < KPIs[i].cells.length; j++) {
					currentCell = KPIs[i].cells.eq(j);
					//Cylinder, Faces, Gauge, None, ReversedGauge, ReversedStatusArrow, RoadSigns, Shapes
					//StandartdArrow, StatusArrow, Thermometer, ThreeStateImages, TrafficLight, VarianceArrow
					if (!isNaN(currentCell.text())) {
						imgString = "<div class='ui-igpivotgrid-kpis'";
						imgString += " title='" + currentCell.text() + "'";
						imgString += " style='background-position: ";

						val = parseFloat(currentCell.text());
						if (0 < val) {
							x = 0;
						} else if (0 > val) {
							x = 32;
						} else {
							x = 16;
						}

						switch (KPIs[i].graphic.toLowerCase()) {
							case "road signs":
								y = 0;
								break;
							case "traffic light":
								y = 16;
								break;
							case "variance arrow":
								y = 32;
								break;
							case "standart arrow":
								y = 48;
								break;
							case "status arrow - ascending":
								y = 64;
								break;
							case "status arrow - descending":
								y = 80;
								break;
							case "faces":
								y = 96;
								break;
							case "shapes":
								y = 112;
								break;
							case "cylinder":
								y = 128;
								break;
							case "gauge - ascending":
								y = 144;
								break;
							case "gauge - descending":
								y = 160;
								break;
							case "thermometer":
								y = 176;
								break;
						}

						imgString += "-" + x + "px -" + y + "px";
						imgString += "'></div>";
						KPIs[i].cells.eq(j)[0].innerHTML = imgString;
					}
				}
			}
		},
        _onDataRendered: function (event, ui) {
            var $this = this, id = this.element.attr("id"), table = ui.owner.element, grid = this.grid(),
				overlayDropAreaOptions = this._createDropAreaOptions(), dataSource = this._ds,
				headersCols, colgroup, i, j, colAttributes, KPIs;

            if ("OlapXmlaDataSource" === dataSource.getType().typeName()) {
                KPIs = this._getKPIs(dataSource);
                KPIs = this._getKPICells(KPIs, dataSource);

                this._addKPIImages(KPIs, dataSource);
            }
			
            table.addClass(this.css.pivotGrid);

            // Attach to events in the data table.
            table.find("tbody th > span[data-expand]").bind("click", function (evt) {
                $this._onToggleTupleMember(evt);
                return false;
            });            
            
            if (this.options.allowHeaderRowsSorting) {
                table.find("tbody th.ui-igpivotgrid-header[data-sortheader]").children(".ui-iggrid-headertext,.ui-iggrid-sortindicator").bind("click", function (evt) {
                    $this._onSortHeader(evt);
                });
            }

            // fixedHeaders will be true if the grid is rendered
            // using two table elements.
            if (grid.options.fixedHeaders) {
                // Find the COLGROUPs
                // MS TFS 143250
                headersCols = grid.headersTable().find("colgroup").find('col');
                colgroup = table.find("colgroup");
                
                colgroup.empty(); 
                for(i = 0; i < headersCols.length; i++) {
                    colgroup.append($("<col></col>"));
                    colAttributes = headersCols.eq(i)[0].attributes;
                    for(j = 0; j < colAttributes.length; j++) {
                        colgroup.find('col').eq(i).attr(colAttributes.item(j).name, colAttributes.item(j).value);
                    }
                }

                // Update the horizontal scrollbar for the grid.
                grid._setGridContentWidth(grid.headersTable().width());
                // Scroll to the previous positions.
                grid.scrollContainer().scrollTop(this._gridScrollOffsets.top);
                $("#" + id + "_hscroller").scrollLeft(this._gridScrollOffsets.left);
            }

            if (!this.options.disableRowsDropArea && !this._isTouch()) {
                if ($("#" + id + "_rows_overlay").length < 1) {
                    $("<div id='" + id + "_rows_overlay' data-role='rows' class='" + this.css.overlayDropArea + " ui-igpivot-droparea ui-droppable'></div>")
                    .appendTo(this.element)
                    .droppable(overlayDropAreaOptions);
                }
            }
            if (!this.options.disableMeasuresDropArea && !this._isTouch()) {
                if ($("#" + id + "_measures_overlay").length < 1) {
                    $("<div id='" + id + "_measures_overlay' data-role='measures' class='" + this.css.overlayDropArea + " ui-igpivot-droparea ui-droppable'></div>")
                    .appendTo(this.element)
                    .droppable(overlayDropAreaOptions);
                }
            }

            this._positionOverlayDropAreas();
            this._triggerPivotGridRendered(event, ui);
        },
        _positionOverlayDropAreas: function () {
            var id = this.element.attr("id"),
                headersTable = this.grid().headersTable().find("thead"),
                dataTable = this.grid().element.find("tbody"),
                firstColumnHeaderPosition,
                firstRowHeaderPosition,
                columnHeadersHeight,
                rowHeadersWidth,
                measuresArea,
                container,
                containerParent,
                containerPosition,
                columnsOverlayTop,
                columnsOverlayLeft,
                columnHeadersWidth,
                measuresHeadersWidth,
                dataTableHeight,
                rowsOverlayTop,
                rowsOverlayLeft,
                containerId,
                rowHeight,
                ht,
                rowsProps,
                columnsProps,
                measuresProps,
                absoluteOffset;

            // Get the position of the first column header.
            firstColumnHeaderPosition = headersTable.find("th[data-axis]:first").position();

            // Calculate the height of the column header rows.
            columnHeadersHeight = 0;
            if ($.ig.util.isFF) {
                columnHeadersHeight = headersTable.find("tr[data-header-row], tr[data-mch-level]")[0].scrollHeight;
            } else {
                headersTable.find("tr[data-header-row], tr[data-mch-level]").each(function (ind, el) {
                    columnHeadersHeight += el.scrollHeight;
                });
            }

            // Position the columns overlay drop area.          
            if ((this.options.height !== null) || (this.options.width !== null)) {
                containerId = this.element.attr('id');
                container = $("#" + containerId + "_container").length === 1 ? $("#" + containerId + "_container") : $("#" + containerId + "_table_container");
                containerParent = container.parent();
                containerPosition = container.position();
            }

            if (this.options.height !== null) {
                firstRowHeaderPosition = {
                    "top": this.grid().headersTable().height() + containerPosition.top,
                    "left": containerPosition.left
                };

            } else if (this.options.width !== null) {
                rowHeight = this.grid().headersTable().find("tr").eq(0).height();
                if (this.grid().headersTable().find("tr[data-mch-level]").length === 0) {
                    firstRowHeaderPosition = {
                        "top": (3 * rowHeight) + containerPosition.top,
                        "left": containerPosition.left
                    };
                } else {
                    firstRowHeaderPosition = {
                        "top": (2 * rowHeight) + (this.grid().headersTable().find("tr[data-mch-level]").length * this.grid().headersTable().find("tr[data-mch-level]").eq(0).height()) + containerPosition.top,
                        "left": containerPosition.left
                    };
                }
            }

            if ((this.options.height !== null) || (this.options.width !== null)) {
                columnsOverlayTop = firstColumnHeaderPosition.top + containerPosition.top + (2 * parseInt(containerParent.css("paddingTop")[0].replace("px", ""), 10));
                columnsOverlayLeft = firstColumnHeaderPosition.left + containerPosition.left;
                rowsOverlayTop = firstRowHeaderPosition.top + (2 * parseInt(containerParent.css("paddingTop")[0].replace("px", ""), 10));
                rowsOverlayLeft = firstRowHeaderPosition.left;

            } else {
                firstRowHeaderPosition = this.grid().headersTable().find("tbody tr:first").position();
                columnsOverlayTop = firstColumnHeaderPosition.top + headersTable.parent().parent().position().top; 
                columnsOverlayLeft = firstColumnHeaderPosition.left + headersTable.parent().parent().position().left;
                rowsOverlayTop = firstRowHeaderPosition.top + headersTable.parent().parent().position().top;
                rowsOverlayLeft = firstRowHeaderPosition.left + headersTable.parent().parent().position().left;
            }
 
            ht = headersTable.find("tr").eq(1).find("th").eq(1);
            if (headersTable[0].scrollWidth <= this.element.width()) {
                columnHeadersWidth = ht.width() + (2 * (parseInt(ht.css("paddingLeft")[0].substr(0), 10) + parseInt(ht.css("borderLeftWidth")[0].substr(0), 10)));
            } else {
                columnHeadersWidth = ht.width() + (2 * (parseInt(ht.css("paddingLeft")[0].substr(0), 10) + parseInt(ht.css("borderLeftWidth")[0].substr(0), 10))) - (headersTable[0].scrollWidth - this.element.width());
            }

            // Get the width of the row headers.
            measuresArea = headersTable.find("tr").eq(1).find("th:first");
            dataTableHeight = this.element.height() - rowsOverlayTop > dataTable[0].scrollHeight ? dataTable[0].scrollHeight : this.element.height() - headersTable.height();
            rowHeadersWidth = measuresArea.width() + (2 * (parseInt(measuresArea.css("paddingLeft")[0].replace("px", ""), 10) + parseInt(measuresArea.css("borderLeftWidth")[0].replace("px", ""), 10)));
            if (headersTable[0].scrollWidth <= this.element.width()) {
                measuresHeadersWidth = dataTable[0].scrollWidth - rowHeadersWidth;
            } else {
                measuresHeadersWidth = dataTable[0].scrollWidth - rowHeadersWidth - (headersTable[0].scrollWidth - this.element.width());
            }

            absoluteOffset = this._calculateOffset(this.element);
            rowsProps = {
                "top": rowsOverlayTop + absoluteOffset.top,
                "left": absoluteOffset.left,
                "width": rowHeadersWidth,
                "height": dataTableHeight
            };

            columnsProps = {
                "top": columnsOverlayTop + absoluteOffset.top,
                "left": rowHeadersWidth + absoluteOffset.left,
                "width": columnHeadersWidth,
                "height": columnHeadersHeight
            };

            measuresProps = {
                "top": rowsOverlayTop + absoluteOffset.top,
                "left": rowHeadersWidth + absoluteOffset.left,
                "width": measuresHeadersWidth,
                "height": dataTableHeight
            };

            $("#" + id + "_rows_overlay").css(rowsProps);
            $("#" + id + "_columns_overlay").css(columnsProps);
            $("#" + id + "_measures_overlay").css(measuresProps);

            headersTable.parent().parent().on(
                "scroll",
                { 
                    table: headersTable, 
                    id: id,
                    rowHeadersWidth: rowHeadersWidth,
                    columnHeadersWidth: columnHeadersWidth,
                    rowsOverlayLeft: rowsOverlayLeft,
                    measuresHeadersWidth: measuresHeadersWidth,
                    columnsOverlayLeft: columnsOverlayLeft,
                },
                this._handlePivotGridScrolling
            );
        },
        _calculateOffset: function(jQueryObj) {
            var el = jQueryObj, offset = { top: 0, left: el.offset().left };

            while (!el[0].tagName && el.scrollParent()[0].firstChild.name !== "html") {
                offset.top += el.scrollParent().scrollTop();
                offset.left += el.scrollParent().scrollLeft();

                el = el.scrollParent();
            }

            return offset;
        },
        _handlePivotGridScrolling: function(evt, ui) {
            var scrollTable = evt.data.table.parent().parent(), 
                id = evt.data.id, 
                offset = scrollTable.scrollLeft(),
                rowHeadersWidth = evt.data.rowHeadersWidth,
                columnHeadersWidth = evt.data.columnHeadersWidth,
                rowsOverlayLeft = evt.data.rowsOverlayLeft,
                measuresHeadersWidth = evt.data.measuresHeadersWidth,
                columnsOverlayLeft = evt.data.columnsOverlayLeft;

            $("#" + id + "_columns_overlay").css({
                "left": columnsOverlayLeft - (rowHeadersWidth > offset ? offset : rowHeadersWidth),
                "width": rowHeadersWidth > offset ? columnHeadersWidth + offset : scrollTable.width(),
            });

            $("#" + id + "_rows_overlay").css({
                "width": rowHeadersWidth - offset,
            });

            $("#" + id + "_measures_overlay").css({
                "left": rowsOverlayLeft + rowHeadersWidth - (rowHeadersWidth > offset ? offset : rowHeadersWidth),
                "width": rowHeadersWidth > offset ? measuresHeadersWidth + offset : scrollTable.width(),
            });
        },
        _updateDataSource: function (deferUpdateOverride) {
            this._updateGrid(false, deferUpdateOverride);
        },
        _shouldAppendToTarget: function (target, dragged) {
            // Calculate the top of the dragged element and the drop target.
            return target.offset().left + target.width() / 2 < dragged.offset.left + this._const.dragCursorAt.left;
        },
        _onToggleTupleMember: function (evt) {
            var $this = this, target = $(evt.target), header = target.closest("th"),
                axisName, memberIndex, tupleIndex, expand,
                noCancel;

            // N.A. - Fix for bug #130737 - Control hangs on double click over expand/collapse button
            if (this._performsToggle || this._ds.isModified()) {
                return;
            }

            axisName = header.attr("data-axis");
            memberIndex = parseInt(header.attr("data-member"), 10);
            tupleIndex = parseInt(header.attr("data-tuple"), 10);
            expand = target.attr("data-expand") === "true";

            if (expand) {
                noCancel = this._triggerTupleMemberExpanding(evt, axisName, memberIndex, tupleIndex);
                if (noCancel) {
                    this._ds.expandTupleMember(axisName, tupleIndex, memberIndex);
                    // Set a flag for the toggle operation.
                    this._performsToggle = true;
                    this._updateGrid(false, true).done(function () {
                        $this._triggerTupleMemberExpanded(null, axisName, memberIndex, tupleIndex);
                    }).always(function () {
                        // Reset the flag.
                        $this._performsToggle = false;
                    });
                }
            } else {
                noCancel = this._triggerTupleMemberCollapsing(evt, axisName, memberIndex, tupleIndex);
                if (noCancel) {
                    this._ds.collapseTupleMember(axisName, tupleIndex, memberIndex);
                    // Set a flag for the toggle operation.
                    this._performsToggle = true;
                    this._updateGrid(false, true).done(function () {
                        $this._triggerTupleMemberCollapsed(evt, axisName, memberIndex, tupleIndex);
                    }).always(function () {
                        // Reset the flag.
                        $this._performsToggle = false;
                    });
                }
            }
        },
        _onSort: function (evt) {
            var $this = this, header = $(evt.target).closest("th"), axisName, tupleIndex, tupleIdentifier,
                axis, axes, tuple, memberNames,
                columnSortDirections, columnSortDirection, levelSortDirections,
                options, i, noCancel, en;

            if (this._ds.isModified()) {
                return;
            }

            axisName = header.attr("data-axis");
            tupleIndex = parseInt(header.attr("data-tuple"), 10);

            if (axisName !== this._const.emptyCell.axisName) {
                axes = this._ds.result().axes().__inner; //toArray();
                for (i = 0; i < axes.length; i++) {
                    if (axisName === axes[i].name()) {
                        axis = axes[i];
                        break;
                    }
                }
                // Return if no such axis exists.
                if (!axis) {
                    return;
                }
                // Get the member names in the tuple.
                tuple = axis.tuples().item(tupleIndex);
                memberNames = [];

                en = tuple.members().getEnumerator();
                while (en.moveNext()) {
                    memberNames.push(en.current().uniqueName());
                }

                // Join the names for easier comparison.
                tupleIdentifier = memberNames.join("|");
            } else {
                memberNames = null;
                tupleIdentifier = "";
            }

            columnSortDirections = this._tableView.columnSortDirections();
            for (i = 0; i < columnSortDirections.length; i++) {
                // Find existing sort directions.
                if ((columnSortDirections[i].memberNames && columnSortDirections[i].memberNames.join("|") === tupleIdentifier) ||
						(columnSortDirections[i].tupleIndex === tupleIndex)) {
                    columnSortDirection = columnSortDirections[i];
                    break;
                }
            }

            if (!evt.ctrlKey) {
                columnSortDirections = [];
            }

            if (columnSortDirection) {
                // Alternate the existing level sort direction.
				columnSortDirection.sortDirection = columnSortDirection.sortDirection === "ascending" ?
					"descending" : "ascending";
                if (!evt.ctrlKey) {
                    columnSortDirections.push(columnSortDirection);
                }
            } else {
                // Create a new column sort direction.
                columnSortDirection = {
                    memberNames: memberNames,
                    tupleIndex: tupleIndex,
                    sortDirection: this.options.firstSortDirection
                };
                columnSortDirections.push(columnSortDirection);
            }

            noCancel = this._triggerSorting(evt, columnSortDirections);
            if (noCancel) {
                // Remove all level sort directions, which are in the row axis.
                levelSortDirections = $.grep(this._tableView.levelSortDirections(), function (sortDirection) {
                    var level, hierarchyName;

                    level = $this._ds.getCoreElement(function (l) {
                        return l.uniqueName() === sortDirection.levelUniqueName;
                    }, $.ig.Level.prototype.getType());

                    if (level) {
                        hierarchyName = level.hierarchyUniqueName();
                        return $.grep($this._ds.rowAxis(), function (h) { return h.uniqueName() === hierarchyName; }).length === 0;
                    }

                    return false;
                });
                this._tableView.levelSortDirections(levelSortDirections);

                this._tableView.columnSortDirections(columnSortDirections);
                this._tableView.initialize();

                options = this._configureOptions(this._ds);
                this._renderGrid(options);

                this._triggerSorted(evt, columnSortDirections, this._tableView.appliedColumnSortDirections());
            }
        },
        _onSortHeader: function (evt) {
            var header = $(evt.target).closest("th"), axisName, tupleIndex, memberIndex,
                axis, axes, tuple, member, level,
                levelName, hierarchyName, levelSortDirections, levelSortDirection, options, i,
                noCancel;

            if (this._ds.isModified()) {
                return;
            }

            axisName = header.attr("data-axis");
            tupleIndex = parseInt(header.attr("data-tuple"), 10);
            memberIndex = parseInt(header.attr("data-member"), 10);

            axes = this._ds.result().axes().__inner; //toArray();
            for (i = 0; i < axes.length; i++) {
                if (axisName === axes[i].name()) {
                    axis = axes[i];
                    break;
                }
            }
            // Return if no such axis exists.
            if (!axis) {
                return;
            }

            tuple = axis.tuples().item(tupleIndex);
            member = tuple.members().item(memberIndex);
            level = this._ds.getCoreElement(function (l) {
                return l.hierarchyUniqueName() === member.hierarchyUniqueName() && l.depth() === member.depth() + 1;
            }, $.ig.Level.prototype.getType());
            // Return if no such level exists.
            if (!level) {
                return;
            }

            levelName = level.uniqueName();

            levelSortDirections = this._tableView.appliedLevelSortDirections();
            for (i = 0; i < levelSortDirections.length; i++) {
                if (levelSortDirections[i].levelUniqueName === levelName) {
                    levelSortDirection = levelSortDirections[i];
                    break;
                }
            }
            if (levelSortDirection) {
                // Alternate the existing level sort direction.
				levelSortDirection.sortDirection = levelSortDirection.sortDirection === "ascending" ?
					"descending" : "ascending";
            } else {
                // Create a new level sort direction.
                levelSortDirection = {
                    levelUniqueName: levelName,
                    // Not supported in 13.1
                    // sortBehavior: this.options.defaultLevelSortBehavior,
                    sortDirection: this.options.firstLevelSortDirection
                };
                levelSortDirections.push(levelSortDirection);
            }

            noCancel = this._triggerHeadersSorting(evt, levelSortDirections);
            if (noCancel) {
                // If the hierarchy of the level is on the row axis,
                // clear all column sort directions.
                hierarchyName = level.hierarchyUniqueName();
                if ($.grep(this._ds.rowAxis(), function (h) { return h.uniqueName() === hierarchyName; }).length > 0) {
                    this._tableView.columnSortDirections([]);
                }

                this._tableView.levelSortDirections(levelSortDirections);
                this._tableView.initialize();

                options = this._configureOptions(this._ds);
                this._renderGrid(options);

                this._triggerHeadersSorted(evt, levelSortDirections, this._tableView.appliedLevelSortDirections());
            }
        },
        expandTupleMember: function (tupleLocation, tupleIndex, memberIndex, shouldUpdate) {
            /* Expands a member from the data source and returns true if the expand succeeds. If the data source has a pending update, the method will return false. Note that igPivotGrid to will display the expanded result after the data source is updated.
            type="string" The name of the parent axis - 'columnAxis' or 'rowAxis'.
            type="number" The index of the containing tuple. This index should correspond to the position of the tuple in the original unsorted result of the data source.
            type="number" The index of the member in the tuple. This index should correspond to the position of the member in the original unsorted result of the data source.
            type="bool" optional="true" A flag indicating whether the data source should be updated after the expand.
            returnType="bool"
            */
            var dataSource = this._ds, hasColumns, hasRows, axisName;
            hasColumns = dataSource.columnAxis().length > 0;
            hasRows = dataSource.rowAxis().length > 0;

            if (this._ds.isModified()) {
                return false;
            }

            if (tupleLocation === "columnAxis" && hasColumns) {
                if (hasColumns) {
                    axisName = "Axis0";
                }
            } else if (tupleLocation === "rowAxis" && hasRows) {
                if (hasColumns) {
                    axisName = "Axis1";
                } else {
                    axisName = "Axis0";
                }
            }

            if (!axisName) {
                throw new Error($.ig.PivotGrid.locale.noSuchAxis);
            }

            this._ds.expandTupleMember(axisName, tupleIndex, memberIndex);
            if (shouldUpdate) {
                this._updateGrid(null, true);
            }
        },
        collapseTupleMember: function (tupleLocation, tupleIndex, memberIndex, shouldUpdate) {
            /* Collapses a member from the data source and returns true if the collapse succeeds. If the data source has a pending update, the method will return false. Note that igPivotGrid to will display the expanded result after the data source is updated.
            type="string" The name of the parent axis - 'columnAxis' or 'rowAxis'.
            type="number" The index of the containing tuple. This index should correspond to the position of the tuple in the original unsorted result of the data source.
            type="number" The index of the member in the tuple. This index should correspond to the position of the member in the original unsorted result of the data source.
            type="bool" optional="true" A flag indicating whether the data source should be updated after the expand.
            returnType="bool"
            */
            var dataSource = this._ds, hasColumns, hasRows, axisName;
            hasColumns = dataSource.columnAxis().length > 0;
            hasRows = dataSource.rowAxis().length > 0;

            if (this._ds.isModified()) {
                return false;
            }

            if (tupleLocation === "columnAxis" && hasColumns) {
                if (hasColumns) {
                    axisName = "Axis0";
                }
            } else if (tupleLocation === "rowAxis" && hasRows) {
                if (hasColumns) {
                    axisName = "Axis1";
                } else {
                    axisName = "Axis0";
                }
            }

            if (!axisName) {
                throw new Error($.ig.PivotGrid.locale.noSuchAxis);
            }

            this._ds.collapseTupleMember(axisName, tupleIndex, memberIndex);
            if (shouldUpdate) {
                this._updateGrid();
            }
        },
        appliedColumnSortDirections: function () {
            /* Returns an array with the applied sort directions on the igPivotGrid's columns. The returned array contains objects with the following properties:
            memberNames: The names of the members in the tuple.
            tupleIndex: The index of the tuple on the column axis in the original unsorted result.
            sortDirection: The direction of the sort - ascending or descending.
            returnType="array"
            */
            return this._tableView ? this._tableView.appliedColumnSortDirections() : [];
        },
        appliedLevelSortDirections: function () {
            /* Returns an array with the applied level sort direction items, which were used for the sorting of the header cells. The returned array contains objects with the following properties:
            levelUniqueName: Specifies the unique name of the level, which was sorted.
            sortDirection: The direction of the header sort - ascending or descending.
            returnType="array"
            */
            return this._tableView ? this._tableView.appliedLevelSortDirections() : [];
        },
        destroy: function () {
            /* destroy is part of the jQuery UI widget API and does the following:
            1. Remove custom CSS classes that were added.
            2. Unwrap any wrapping elements such as scrolling divs and other containers.
            3. Unbind all events that were bound.
            */
            var grid = this.grid();
            if (grid) {
                grid.destroy();
            }
            $("#" + this.element.attr("id") + "_container_block").remove();
            this.element.removeClass(this.css.pivotGrid);
            $(this._ds).unbind('initialized.pivotgrid' + this.timestamp);
            $(this._ds).unbind('updated.pivotgrid' + this.timestamp);
            $.Widget.prototype.destroy.call(this);
        },
        _triggerPivotGridHeadersRendered: function (evt, ui) {
            var args = {
                owner: this,
                grid: ui.owner,
                table: ui.table
            };

            this._trigger("pivotGridHeadersRendered", evt, args);
        },
        _triggerPivotGridRendered: function (evt, ui) {
            var args = {
                owner: this,
                grid: ui.owner
            };

            this._trigger("pivotGridRendered", evt, args);
        },
        _triggerTupleMemberExpanding: function (evt, axisName, memberIndex, tupleIndex) {
            var args = {
                owner: this,
                dataSource: this._ds,
                axisName: axisName,
                memberIndex: memberIndex,
                tupleIndex: tupleIndex
            };

            return this._trigger("tupleMemberExpanding", evt, args);
        },
        _triggerTupleMemberExpanded: function (evt, axisName, memberIndex, tupleIndex) {
            var args = {
                owner: this,
                dataSource: this._ds,
                axisName: axisName,
                memberIndex: memberIndex,
                tupleIndex: tupleIndex
            };

            this._trigger("tupleMemberExpanded", evt, args);
        },
        _triggerTupleMemberCollapsing: function (evt, axisName, memberIndex, tupleIndex) {
            var args = {
                owner: this,
                dataSource: this._ds,
                axisName: axisName,
                memberIndex: memberIndex,
                tupleIndex: tupleIndex
            };

            return this._trigger("tupleMemberCollapsing", evt, args);
        },
        _triggerTupleMemberCollapsed: function (evt, axisName, memberIndex, tupleIndex) {
            var args = {
                owner: this,
                dataSource: this._ds,
                axisName: axisName,
                memberIndex: memberIndex,
                tupleIndex: tupleIndex
            };

            this._trigger("tupleMemberCollapsed", evt, args);
        },
        _triggerSorting: function (evt, columnSortDirections) {
            var args = {
                owner: this,
                sortDirections: columnSortDirections
            };

            return this._trigger("sorting", evt, args);
        },
        _triggerSorted: function (evt, columnSortDirections, appliedColumnSortDirections) {
            var args = {
                owner: this,
                sortDirections: columnSortDirections,
                appliedSortDirections: appliedColumnSortDirections
            };

            this._trigger("sorted", evt, args);
        },
        _triggerHeadersSorting: function (evt, levelSortDirections) {
            var args = {
                owner: this,
                levelSortDirections: levelSortDirections
            };

            return this._trigger("headersSorting", evt, args);
        },
        _triggerHeadersSorted: function (evt, levelSortDirections, appliedLevelSortDirections) {
            var args = {
                owner: this,
                levelSortDirections: levelSortDirections,
                appliedLevelSortDirections: appliedLevelSortDirections
            };

            this._trigger("headersSorted", evt, args);
        }
        /* _processMultiColumnHeadersRecursive: function (parent, headers, start, end) {
        var i, multiHeaderGroup = [], multiHeader;
        for (i = start; i < end; i++) {
        if (headers[i].columnSpan() > 1) {
        // multiHeaderGroup = [];
        // currentHeader = headers[i];
        multiHeader = {
        headerText: headers[i].caption(),
        // rowSpan: headers[i].rowSpan(),
        // colSpan: headers[i].columnSpan(),
        group: multiHeaderGroup,
        key: headers[i].axisName() + "_" + headers[i].tupleIndex() + "_" + headers[i].memberIndex(),
        expandable: headers[i].isExpandable(),
        expanded: headers[i].isExpanded(),
        axisName: headers[i].axisName(),
        tupleIndex: headers[i].tupleIndex(),
        memberIndex: headers[i].memberIndex()
        };
        parent.push(multiHeader);
        // parent = multiHeaderGroup;
        this._processMultiColumnHeadersRecursive(multiHeaderGroup, headers, ++i, i + headers[i - 1].columnSpan());
        i += headers[i - 1].columnSpan() - 1;
        } else {
        parent.push({
        headerText: headers[i].caption(),
        key: headers[i].axisName() + "_" + headers[i].tupleIndex() + "_" + headers[i].memberIndex(),
        expandable: headers[i].isExpandable(),
        expanded: headers[i].isExpanded(),
        axisName: headers[i].axisName(),
        tupleIndex: headers[i].tupleIndex(),
        memberIndex: headers[i].memberIndex()
        });
        }
        }
        } */
    });
    $.extend(true, $.ui.igPivotGrid.prototype, $.ig.Pivot._pivotShared);
    $.extend($.ui.igPivotGrid, { version: "14.1.20141.2249" });
} (jQuery));
/*!@license
* Infragistics.Web.ClientUI Pivot View 14.1.20141.2249
*
* Copyright (c) 2011-2012 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends on: 
*	jquery-1.4.4.js
*	jquery.ui.core.js
*	jquery.ui.widget.js
*	jquery.ui.draggable.js
*	jquery.ui.droppable.js
*	infragistics.util.js
*	infragistics.datasource.js
*	infragistics.olapxmladatasource.js
*	infragistics.olapflatdatasource.js
*	infragistics.ui.shared.js
*	infragistics.ui.scroll.js
*	infragistics.ui.splitter.js
*	infragistics.ui.tree.js
*	infragistics.ui.grid.framework.js
*	infragistics.ui.grid.multicolumnheaders.js
*	infragistics.ui.pivot.shared.js
*	infragistics.ui.pivotdataselector.js
*	infragistics.ui.pivotgrid.js
*/
/*global jQuery, Modernizr */
(function ($) {
	var _igPivotGrid = $.ui.igPivotGrid.prototype.widgetFullName || $.ui.igPivotGrid.prototype.widgetName,
		_igPivotDataSelector = $.ui.igPivotDataSelector.prototype.widgetFullName || $.ui.igPivotDataSelector.prototype.widgetName,
		_igSplitter = $.ui.igSplitter.prototype.widgetFullName || $.ui.igSplitter.prototype.widgetName;

	$.widget("ui.igPivotView", {
		options: {
			/* type="string|number|null"
				string The widget width can be set in pixels (px) and percentage (%).
				number The widget width can be set as a number.
				null type="object" will stretch to fit the parent, if no other widths are defined.
			*/
			width: null,
			/* type="string|number|null"
				string The widget height can be set in pixels (px) and percentage (%).
				number The widget height can be set as a number.
				null type="object" will stretch vertically to fit the parent, if no other heights are defined.
			*/
			height: null,
			/* type="object" An instance of $.ig.OlapXmlaDataSource or $.ig.OlapFlatDataSource.
			*/
			dataSource: null,
			/* type="object" An object that will be used to create an instance of $.ig.OlapXmlaDataSource or $.ig.OlapFlatDataSource.
				The provided value must contain an object with settings for one of the data source types - xmlaOptions or flatDataOptions.
			*/
			dataSourceOptions: {
				/* type="object" Settings for creating an instance of $.ig.OlapXmlaDataSource.
				*/
				xmlaOptions: {
					/* type="string" optional="false" The URL of the XMLA server.
					*/
					serverUrl: null,
					/* type="string" The catalog name.
					*/
					catalog: null,
					/* type="string" The name of the cube in the data source.
					*/
					cube: null,
					/* type="string" The name of the measure group in the data source.
					*/
					measureGroup: null,
					/* type="object" An object containing information about how the request to the XMLA server should be processed.
					*/
					requestOptions: {
						/* type="bool" The value is applied to XmlHttpRequest.withCredentials if supported by the user agent.
							Setting this property to true will allow IE8/IE9 to make authenticated cross-origin requests to tusted domains through XmlHttpRequest instead of XDomainRequest
							and will prompt the user for credentials.
						*/
						withCredentials: false,
						/* type="function" A callback to be invoked right before the request is send to the server. Extends beforeSend callback of jQuery.ajax’s options object.
						*/
						beforeSend: null
					},
					/* type="bool" Enables/disables caching of the XMLA result object.
					*/
					enableResultCache: true,
					/* type="object" Additional properties sent with every discover request.
						The object is treated as a key/value store where each property name is used as the key and the property value as the value.
					*/
					discoverProperties: null,
					/* type="object" Additional properties sent with every execute request.
						The object is treated as a key/value store where each property name is used as the key and the property value as the value.
					*/
					executeProperties: null,
					/* type="object" optional="true" a javascript object containing information about how the request to the xmla server should be processed 
					*/
					mdxSettings: {
						/* type="bool" optional="true" a value indicating whether a NON EMPTY clause is present on ROWS axis. Default value is true 
						*/
						nonEmptyOnRows: true,
						/* type="bool" optional="true" a value indicating whether a NON EMPTY clause is present on COLUMNS axis. Default value is true 
						*/
						nonEmptyOnColumns: true,
						/* type="bool" optional="true" a value indicating whether a members' set expressions on ROWS axis should be wrapped with AddCalculatedMembers MDX method. Default value is true 
						*/
						addCalculatedMembersOnRows: true,
						/* type="bool" optional="true" a value indicating whether a members' set expressions on COLUMNS axis should be wrapped with AddCalculatedMembers MDX method. Default value is true 
						*/
						addCalculatedMembersOnColumns: true,
						/* type="array" optional="true" a string array with the names of intrinsic non-context sensitive member properties applied on ROWS axis. By defult CHILDREN_CARDINALITY and PARENT_UNIQUE_NAME properties are always added to DIMENSION PROPERTIES 
						*/
						dimensionPropertiesOnRows: [],
						/* type="array" optional="true" a string array with the names of intrinsic non-context sensitive member properties applied on COLUMNS axis. By defult CHILDREN_CARDINALITY and PARENT_UNIQUE_NAME properties are always added to DIMENSION PROPERTIES
						*/
						dimensionPropertiesOnColumns: []
					}
				},
				/* type="object" Settings for creating an instance of $.ig.OlapFlatDataSource.
				*/
				flatDataOptions: {
					/* type="object" Specifies any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself.
					*/
					dataSource: null,
					/* type="string" Specifies a remote URL accepted by $.ig.DataSource in order to request data from it.
					*/
					dataSourceUrl: null,
					/* type="string" Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property. 
					*/
					dataSourceType: null,
					/* type="string" see $.ig.DataSource. 
						string Specifies the name of the property in which data records are held if the response is wrapped. 
						null Option is ignored.
					*/
					responseDataKey: null,
					/* type="string" 
						string Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property.
						null Option is ignored.
					*/
					responseDataType: null,
					/* type="object" optional="false" An object containing processing instructions for the $.ig.DataSource data.
					*/
					metadata: {
						/* type="object" optional="false" Metadata used for the creation of the cube.
						*/
						cube: {
							/* type="string" optional="false" A unique name for the cube.
							*/
							name: null,
							/* type="string" A caption for the cube.
							*/
							caption: null,
							/* type="object" An object providing information about the measures' root node.
							*/
							measuresDimension: {
								/* type="string" A unique name for the measures dimension.
									The default value is "Measures". This name is used to create the names of dimensions using the following pattern:
									[<measuresDimensionMetadata.name>].[<measureMetadata.name>]
								*/
								name: null,
								/* type="string" A caption for the measures dimension.
									The default value is "Measures".
								*/
								caption: null,
								/* type="array" An array of measure metadata objects.
								*/
								measures: [{
									/* type="string" optional="false" A unique name for the measure.
									*/
									name: null,
									/* type="string" A caption for the measure.
									*/
									caption: null,
									/* type="function" optional="false" An aggregator function called when each cell is evaluated.
										Returns a value for the cell. If the returned value is null, no cell will be created in for the data source result.
									*/
									aggregator: null,
									/* type="string" The path used when displaying the measure in the user interface. Nested folders are indicated by a backslash (\).
									*/
									displayFolder: null
								}]
							},
							/* type="array" An array of dimension metadata objects.
							*/
							dimensions: [{
								/* type="string" optional="false" A unique name for the dimension.
								*/
								name: null,
								/* type="string" A caption for the dimension.
								*/
								caption: null,
								/* type="array" An array of hierarchy metadata objects.
								*/
								hierarchies: [{
									/* type="string" optional="false" A name for the hierarchy.
										The unique name of the hierarchy is formed using the following pattern:
										[<parentDimension.name>].[<hierarchyMetadata.name>]
									*/
									name: null,
									/* type="string" A caption for the hierarchy.
									*/
									caption: null,
									/* type="string" The path to be used when displaying the hierarchy in the user interface. 
										Nested folders are indicated by a backslash (\). 
										The folder hierarchy will appear under parent dimension node.
									*/
									displayFolder: null,
									/* type="array" An array of level metadata objects.
									*/
									levels: [{
										/* type="string" optional="false" A name for the level.
											The unique name of the level is formed using the following pattern:
											{<hierarchy.uniqueName>}.[<levelMetadata.name>]
										*/
										name: null,
										/* type="string" A caption for the level.
										*/
										caption: null,
										/* type="function" A function called for each item of the data source array when level members are created.
											Based on the item parameter the function should return a value that will form the $.ig.Member’s name and caption.
										*/
										memberProvider: null
									}]
								}]
							}]
						}
					}
				},
				/* type="string" A list of measure names separated by comma (,). These will be the measures of the data source.
				*/
				measures: null,
				/* type="string" A list of hierarchy names separated by comma (,). These will be hierarchies in the filters of the data source.
				*/
				filters: null,
				/* type="string" A list of hierarchy names separated by comma (,). These will be the hierarchies in the rows of the data source.
				*/
				rows: null,
				/* type="string" A list of hierarchy names separated by comma (,). These will be the hierarchies in the columns of the data source.
				*/
				columns: null
			},
			/* type="object" Configuration settings that will be assigned to the igPivotGrid widget.
			*/
			pivotGridOptions: {
				/* type="bool" A boolean value indicating whether a parent in the columns is in front of its children.
								If set to true, the query set sorts members in a level in their natural order - child members immediately follow their parent members.
								If set to false the query set sorts the members in a level using a post-natural order. In other words, child members precede their parents.
				*/
				isParentInFrontForColumns: false,
				/* type="bool" A boolean value indicating whether a parent in the rows is in front of its children.
									If set to true, the query set sorts members in a level in their natural order - child members immediately follow their parent members.
									If set to false the query set sorts the members in a level using a post-natural order. In other words, child members precede their parents.
				*/
				isParentInFrontForRows: true,
				/* type="bool" A boolean value indicating wheter the column headers should be arranged for compact header layout – each hieararchy is in a single row.
				*/
				compactColumnHeaders: false,
				/* type="bool" A boolean value indicating wheter the row headers should be arranged for compact header layout – each hieararchy is in a single column.
				*/
				compactRowHeaders: true,
				/* type="number" The indentation for every level column when the compactColumnHeaders is set to true.
				*/
				compactColumnHeaderIndentation: 30, // default indentation for every level when columns are rendered in a "tree"-view structure in a compact way
				/* type="number" The indentation for every level row when the compactRowHeaders is set to true.
				*/
				compactRowHeaderIndentation: 20, // default indentation for every level when rows are rendered in a "tree"-view structure in a compact way
				/* typle="number" Specifies the width of the row headers.
				*/
				defaultRowHeaderWidth: 200,
				/* type="bool" Enables sorting of the value cells in columns.
				*/
				allowSorting: false,
				/* type="ascending|descending" Spefies the default sort direction for the rows.
				*/
				firstSortDirection: "ascending",
				/* type="bool" Enables sorting of the header cells in rows.
				*/
				allowHeaderRowsSorting: false,
				/* type="bool" Enables sorting of the header cells in columns.
				*/
				allowHeaderColumnsSorting: false,
				/* type="array" An array of level sort direction items, which predefine the sorted header cells.
				*/
				levelSortDirections: [{
					/* type="string" Specifies the unique name of the level, which will be sorted.
					*/
					levelUniqueName: null,
					/* type="ascending|descending" optional="true" Specifies the sort direction. If no direction is specified,
										the level is going to be sorted in the direction specified by the firstLevelSortDirection option.
					*/
					sortDirection: null
				}],
				/* type="ascending|descending" Spefies the default sort direction for the levels if no sort direction is specified in an item from the levelSortDirections option.
				*/
				firstLevelSortDirection: "ascending",
				/* type="object" Options specific to the igGrid that will render the pivot grid view.
				*/
				gridOptions: {
					/* type="string|number" Default column width that will be set for all columns.
						string The default column width can be set in pixels (px).
						number The default column width can be set as a number.
					*/
					defaultColumnWidth: null,
					/* type="bool" Headers will be fixed if this option is set to true, and only the grid data will be scrollable.
					*/
					fixedHeaders: true,
					/* type="string" Caption text that will be shown above the pivot grid header.
					*/
					caption: null,
					/* type="object" A list of grid features definitions. The supported features are Resizing and Tooltips. Each feature goes with its separate options that are documented for the feature accordingly. 
					*/
					features: [],
					/* type="number" Initial tabIndex attribute that will be set on the container element.
					*/
					tabIndex: 0,
					/* type="bool" Enables/disables rendering of alternating row styles (odd and even rows receive different styling). Note that if a custom jQuery template is set, this has no effect and CSS for the row should be adjusted manually in the template contents.
					*/
					alternateRowStyles: true,
					/* type="bool"  Enables/disables rendering of ui-state-hover classes when the mouse is over a record. This can be useful in templating scenarios, for example, where we don't want to apply hover styling to templated content.
					*/
					enableHoverStyles: false
				},
				/* type="object" Settings for the drag and drop functionality of the igPivotDataSelector.
				*/
				dragAndDropSettings: {
					/* type="parent|selector|element" Which element the draggable helper should be appended to while dragging. */
					appendTo: "body",
					/* type="boolean|selector|element|string|array" Specifies the containment for the drag helper. The area inside of which the 
										helper is contained would be scrollable while dragging.
					*/
					containment: false,
					/* type="number" Specifies z-index that would be set for the drag helper. 
					*/
					zIndex: 10
				},
				/* type="jQuery|element|selector" Specifies the parent for the drop downs.
				*/
				dropDownParent: "body",
				/* type="bool" Disable the drag and drop for the rows drop area and the ability to use filtering and remove items from it.
				*/
				disableRowsDropArea: false,
				/* type="bool" Disable the drag and drop for the columns drop area and the ability to use filtering and remove items from it.
				*/
				disableColumnsDropArea: false,
				/* type="bool" Disable the drag and drop for the measures drop area and the ability to use filtering and remove items from it.
				*/
				disableMeasuresDropArea: false,
				/* type="bool" Disable the drag and drop for the filters drop area and the ability to use filtering and remove items from it.
				*/
				disableFiltersDropArea: false,
				/* type="bool" Hide the rows drop area.
				*/
				hideRowsDropArea: false,
				/* type="bool" Hide the columns drop area.
				*/
				hideColumnsDropArea: false,
				/* type="bool" Hide the measures drop area.
				*/
				hideMeasuresDropArea: false,
				/* type="bool" Hide the filters drop area.
				*/
				hideFiltersDropArea: false,
				/* type="function" A function that will be called to determine if an item can be moved in or dropped on an area of the pivot grid.
					paramType="string" The location where the item will be moved - igPivotGrid, igPivotDataSelector, filters, rows, columns or measures.
					paramType="string" The type of the item - Hierarchy, Measure or MeasureList.
					paramType="string" The unique name of the item.
					returnType="bool"  The function must return true if the item should be accepted.
				*/
				customMoveValidation: null
			},
			/* type="object" Configuration settings that will be assigned to the igPivotDataSelector widget.
			*/
			dataSelectorOptions: {
				/* type="object" Settings for the drag and drop functionality of the igPivotDataSelector.
				*/
				dragAndDropSettings: {
					/* type="parent|selector|element" Which element the draggable helper should be appended to while dragging.
					*/
					appendTo: "body",
					/* type="boolean|selector|element|string|array" Specifies the containment for the drag helper. The area inside of which the 
										helper is contained would be scrollable while dragging.
					*/
					containment: false,
					/* type="number" Specifies z-index that would be set for the drag helper. 
					*/
					zIndex: 10
				},
				/* type="jQuery|element|selector" Specifies the parent for the drop downs.
				*/
				dropDownParent: "body",
				/* type="function" A function that will be called to determine if an item can be moved in or dropped on an area of the data selector.
					paramType="string" The location where the item will be moved - igPivotGrid, igPivotDataSelector, filters, rows, columns or measures.
					paramType="string" The type of the item - Hierarchy, Measure or MeasureList.
					paramType="string" The unique name of the item.
					returnType="bool"  The function must return true if the item should be accepted.
				*/
				customMoveValidation: null
			},
			/* type="object" Configuration settings for the panel containing the igPivotGrid.
			*/
			pivotGridPanel: {
				/* type="bool" Determines if the panel containing the igPivotGrid will be resizable.
				*/
				resizable: true,
				/* type="bool" Determines if the panel containing the igPivotGrid will be collapsible.
				*/
				collapsible: false,
				/* type="bool" Determines if the panel containing the igPivotGrid will initially collapsed.
				*/
				collapsed: false,
				/* type="string|number|null" Determines the size of the igPivotGrid panel.
					string The panel size can be set in pixels (px).
					number The size can be set as a number.
					null type="object" will automatically size the panel.
				*/
				size: null
			},
			/* type="object" Configuration settings for the panel containing the igPivotDataSelector.
			*/
			dataSelectorPanel: {
				/* type="left|right" Determines the position of the data selector panel inside the igPivotView widget.
				*/
				location: "right",
				/* type="bool" Determines if the panel containing the igPivotDataSelector will be resizable.
				*/
				resizable: true,
				/* type="bool" Determines if the panel containing the igPivotDataSelector will be collapsible.
				*/
				collapsible: true,
				/* type="bool" Determines if the panel containing the igPivotDataSelector will initially collapsed.
				*/
				collapsed: false,
				/* type="string|number|null" Determines the size of the igPivotDataSelector  panel. The recommended value is 250px.
					string The panel size can be set in pixels (px).
					number The size can be set as a number.
					null type="object" will automatically size the panel.
				*/
				size: 250
			}
		},
		_create: function () {
			var $this = this, elementName, splitter, panel, pivotGrid, dataSelector,
				panels, dataSelectorLocation, dataSource;

			elementName = this.element[0].nodeName.toUpperCase();
			if (elementName !== "DIV") {
				throw new Error(elementName + $.ig.PivotDataSelector.locale.invalidBaseElement);
			}

			this.element.addClass("ui-igpivotview");

			if (this.options.width) {
				this.element.width(this.options.width);
			}

			if (this.options.height) {
				this.element.height(this.options.height);
			}

			dataSelectorLocation = this.options.dataSelectorPanel.location;

			// Create the layout for the PivotView.
			splitter = $("<div></div>").appendTo(this.element);
			// Append the panel for the PivotGrid.
			panel = $("<div></div>").appendTo(splitter);
			// Add the placeholder for the PivotGrid.
			pivotGrid = $("<table></table>").attr("id", this.element.attr("id") + "_pivotGrid").appendTo(panel);
			// Depending on the DataSelector location, prepend or append the DataSelector panel.
			panel = $("<div></div>")[dataSelectorLocation === "right" ? "appendTo" : "prependTo"](splitter);
			// Add the placeholder for the DataSelector.
			dataSelector = $("<div></div>").attr("id", this.element.attr("id") + "_dataSelector").appendTo(panel);

			panels = [this.options.pivotGridPanel, this.options.dataSelectorPanel];
			if (dataSelectorLocation !== "right") {
				panels.reverse();
			}

			// Prepare the data source.
			dataSource = $.ig.Pivot._pivotShared._createDataSource(
				this.options.dataSource,
				this.options.dataSourceOptions
			);

			// N.A. - Fix for bug #134667.
			// First render the data selector and then the splitter to
			// ensure that the splitter's panels will contain dom elements
			// when it calculates the panels.
			// 1. Create the data selector.
			dataSelector.igPivotDataSelector($.extend(true, this.options.dataSelectorOptions, {
				dataSource: dataSource
				//width: (dataSelectorLocation === "right" ? splitter.igSplitter("secondPanel") : splitter.igSplitter("firstPanel")).width(),
				//height: splitter.igSplitter("option", "height")
			}));
			// 2. Create the splitter.
			splitter.igSplitter({
				width: this.options.width || this.element.width(),
				height: this.options.height || this.element.height(),
				panels: panels
			}).bind("igsplitterresizeended igsplitterexpanded igsplittercollapsed", function (evt, ui) {
				$this._setSize();
			}).bind("igsplitterresizestarted", function () {
				$(".ui-igpivot-metadatadropdown,.ui-igpivot-filterdropdown").remove();
			});

			if ($.ui.igSplitter.prototype.css.verticalPanel) {
				$($.ui.igSplitter.prototype.css.verticalPanel.replace(/ui-/g, ".ui-").replace(/ /g, "")).css("overflow", "hidden");
			}

			// 3. Create the pivot grid.
			pivotGrid.igPivotGrid($.extend(true, this.options.pivotGridOptions, {
				dataSource: dataSource,
				width: (dataSelectorLocation === "right" ? splitter.igSplitter("firstPanel") : splitter.igSplitter("secondPanel")).width(),
				height: splitter.igSplitter("option", "height")
			}));

			// Refresh the layout of the splitter panels.
			splitter.igSplitter("refreshLayout");
			// Set the sizes of the pivot grid and the data selector.
			this._setSize();

			// Bind the defer update of the data selector to the pivot grid.
			dataSelector.bind("igpivotdataselectordeferupdatechanged", function (evt, ui) {
				pivotGrid.igPivotGrid("option", "deferUpdate", ui.deferUpdate);
			});
		},
		_setOption: function (key, value) {
			switch (key) {
			case "dataSource":
				this.options.dataSourceOptions = null;
				this.options.dataSource = $.ig.Pivot._pivotShared._createDataSource(value, null);
				this.dataSelector().option("dataSource", this.options.dataSource);
				this.pivotGrid().option("dataSource", this.options.dataSource);
				break;
			case "dataSourceOptions":
				this.options.dataSourceOptions = value;
				this.options.dataSource = $.ig.Pivot._pivotShared._createDataSource(null, value);
				this.dataSelector().option("dataSource", this.options.dataSource);
				this.pivotGrid().option("dataSource", this.options.dataSource);
				break;
			case "width":
			case "height":
				$.Widget.prototype._setOption.call(this, arguments);
				// Currently igSplitter does not support resizing.
				this.splitter().element[key](value);
				this._setSize();
				break;
			}
		},
		_setSize: function () {
			// Resize the PivotGrid when the splitter is resized.
			var splitter = this.splitter(), pivotGrid = this.pivotGrid(), dataSelector = this.dataSelector(),
				height = this.element.height(),
				dataSelectorLocation, pivotGridPanelWidth, dataSelectorPanelWidth;

			dataSelectorLocation = this.options.dataSelectorPanel.location;
			if (dataSelectorLocation === "right") {
				pivotGridPanelWidth = splitter.firstPanel().width();
				dataSelectorPanelWidth = splitter.secondPanel().width();
			} else {
				pivotGridPanelWidth = splitter.secondPanel().width();
				dataSelectorPanelWidth = splitter.firstPanel().width();
			}

			// Resize the grid.
			pivotGrid.option("width", pivotGridPanelWidth);
			pivotGrid.option("height", height);

			// Resize the data selector.
			dataSelector.option("width", dataSelectorPanelWidth);
			dataSelector.option("height", height);
		},
		pivotGrid: function () {
			/* Returns the igPivotGrid instance of the pivot view.
				returnType="object"
			*/
			try {
				return this.element.find(":ui-igPivotGrid").data(_igPivotGrid);
			} catch(e) {
				if (e === "Syntax error, unrecognized expression: Syntax error, unrecognized expression: ui-igPivotGrid" || 
					e.message === "Syntax error, unrecognized expression: ui-igPivotGrid") {
					return this.element.find(":ui-igpivotgrid").data(_igPivotGrid);
				}

				throw e;
			}
			
		},
		dataSelector: function () {
			/* Returns the igPivotDataSelector instance of the pivot view.
				returnType="object"
			*/
			try {
				return this.element.find(":ui-igPivotDataSelector").data(_igPivotDataSelector);    
			} catch(e) {
				if (e === "Syntax error, unrecognized expression: Syntax error, unrecognized expression: ui-igPivotDataSelector" || 
					e.message === "Syntax error, unrecognized expression: ui-igPivotDataSelector") {
					return this.element.find(":ui-igpivotdataselector").data(_igPivotDataSelector);
				}
					
				throw e;
			}
			
		},
		splitter: function () {
			/* Returns the igSplitter instance used to separate the pivot grid and the data selector.
				returnType="object"
			*/
			try {
				return this.element.find(":ui-igSplitter").data(_igSplitter);
			} catch(e) {
				if (e === "Syntax error, unrecognized expression: Syntax error, unrecognized expression: ui-igSplitter" || 
					e.message === "Syntax error, unrecognized expression: ui-igSplitter") {
					return this.element.find(":ui-igsplitter").data(_igSplitter);
				}
				
				throw e;
			}
			
		},
		destroy: function () {
			/* destroy is part of the jQuery UI widget API and does the following:
				1. Remove custom CSS classes that were added.
				2. Unwrap any wrapping elements such as scrolling divs and other containers.
				3. Unbind all events that were bound.
			*/
			this.element.removeClass("ui-igpivotview");
			try {
				this.element.find(":ui-igPivotGrid").igPivotGrid("destroy");
				this.element.find(":ui-igPivotDataSelector").igPivotDataSelector("destroy");
				this.element.find(":ui-igSplitter").igSplitter("destroy").remove();
			} catch(e) {
				if (typeof e === "string") { 
					if (e.indexOf("unrecognized expression: ui-ig") !== -1) { 
						this.element.find(":ui-igpivotgrid").igPivotGrid("destroy");
						this.element.find(":ui-igpivotdataselector").igPivotDataSelector("destroy");
						this.element.find(":ui-igsplitter").igSplitter("destroy").remove();

						$.Widget.prototype.destroy.call(this);
						return;
					}
				} else {
					if (e.message.indexOf("unrecognized expression: ui-ig") !== -1) { 
						this.element.find(":ui-igpivotgrid").igPivotGrid("destroy");
						this.element.find(":ui-igpivotdataselector").igPivotDataSelector("destroy");
						this.element.find(":ui-igsplitter").igSplitter("destroy").remove();

						$.Widget.prototype.destroy.call(this);
						return;
					}
				}

				throw e;
			}
		}
	});
	$.extend($.ui.igPivotView, { version: "14.1.20141.2249" });
}(jQuery));
/*!@license
* Infragistics.Web.ClientUI Editors 14.1.20141.2249
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
*
* Depends on:
* jquery-1.4.4.js
* jquery.ui.core.js
* jquery.ui.widget.js
*
* Example to use:
*	<script type="text/javascript">
*	$(function () {
*		$('#rating1').igRating({ voteCount:3, value:0.5, vertical:true });
*	});
*	</script>
*	<div id="rating1"></div>
*/
/*global jQuery, document, setTimeout */
(function ($) {
	var _aNull = function (v) {
		return v === null || v === undefined || (typeof v === 'number' && isNaN(v));
	};
	/*
		igRating is a widget based on jQuery UI that provides functionality to edit numeric value by mouse, which appears as a row or a column of vote/star images.
	*/
	$.widget('ui.igRating', {
		options: {
			/* type="bool" Gets or sets vertical or horizontal orientation of votes.
				Change of that option is not supported after igRating was created. */
			vertical: false,
			/* type="number" Gets or sets value (selected votes or percent).  */
			value: null,
			/* type="number" Gets or sets value-hover (hovered votes or percent of hovered votes). Default is same as value. */
			valueHover: null,
			/* type="number" Gets or sets number of votes.*/
			voteCount: 5,
			/* type="number" Gets or sets custom width of a vote in pixels. In case of 0 the run time style value is used. */
			voteWidth: 0,
			/* type="number" Gets or sets custom height of a vote in pixels. In case of 0 the run time style value is used. */
			voteHeight: 0,
			/* type="bool" Gets or sets direction of selected and hovered votes. Change of that option is not supported after igRating was created.
				Value true: from left to right or from top to bottom.
				Value false: from right to left or from bottom to left.
			*/
			swapDirection: false,
			/* type="bool" Gets or sets percent or vote number to measure value and value-hover.
				Value true: value is measured as percent (from 0 to 1).
				Value false: value is measured in number of voted (from 0 to voteCount) */
			valueAsPercent: true,
			/* type="bool" Gets sets ability to get focus. Change of that option is not supported after igRating was created.
				Value true: can get focus and process key events.
				Value false: cannot get focus. */
			focusable: true,
			/* type="exact|half|whole" Gets or sets precision. Precision of value and valueHover.
				exact type="string" Value corresponds location of mouse.
				half type="string" Value is rounded to the half of vote.
				whole type="string" Value is rounded to the number of votes. */
			precision: 'whole',
			/* type="number" Gets or sets part of vote-size, which is considered as zero value.
				It has effect only when precision is set to "half" or "whole".
				If user clicks between edge of the first vote and (sizeOfVote * precisionZeroVote), then value is set to 0.
				Same is applied for mouseover as well.*/
			precisionZeroVote: 0.25,
			/* type="number" Gets or sets number of decimal places used to round value and value-hover.
				Negative value will disable that option and value will not be rounded.
				Notes:
				If precision is "whole" or "half" and roundedDecimalPlaces is set in range of 0..2, then 3 is used.
				If valueAsPercent is enabled and roundedDecimalPlaces is set to 0, then 1 is used.
				If it is larger than 15, then 15 is used.
				*/
			roundedDecimalPlaces: 3,
			/* type="string" Gets or sets selector for css classes.
				That option allows replacing all default css styles by custom values.
				Application should provide css classes for all members defined in the css options with "theme" selector. */
			theme: null,
			/* type="object" Gets or sets object which contains options supported by igValidator.
				That option is not supported if the "focusable" option is set to false.
				Example:
				$('#rating1').igRating({ validatorOptions: { min: 0.2, max: 0.7 } }); */
			validatorOptions: null,
			/* type="object" Gets or sets custom css votes.
				That object should be 2-dimentional array or object with indexes, where every item of first level represents settings for a vote at that index.
				Second level of an item is settings for a vote and it should contain classes for a specific state of vote.
				Item at index [0] on second level is used for css class of vote in normal state.
				Item at index [1] on second level is used for css class of vote in selected state.
				Item at index [2] on second level is used for css class of vote in hover state.
				Examples:
				{ 1: { 0: "normalCss", 1: "selectedCss", 2: "hoverCss"} }
				will customize only second vote with normalCss for normal state, hoverCss for hover state and selectedCss for selected state.
				[[null, 's1', 'h1'], [null, 's2', 'h2'], [null, 's3', 'h3']]
				will customize selected and hover states for first 3 votes with classes h# and s#. */
			cssVotes: null
		},
		css: {
			/* Classes applied to the DIV container element. Default value is 'ui-igrating ui-state-default ui-widget-content' */
			normal: 'ui-igrating ui-state-default ui-widget-content',
			/* Class applied to the DIV container element when igRating has focus. Default value is 'ui-igrating-active' */
			active: 'ui-igrating-active',
			/* Classes applied to the container of hover votes. Default value is 'ui-igrating-selected ui-state-highlight' */
			selected: 'ui-igrating-selected ui-state-highlight',
			/* Classes applied to the container of hover votes. Default value is 'ui-igrating-hover ui-state-hover' */
			hover: 'ui-igrating-hover ui-state-hover',
			/* Classes applied to the SPAN element of a vote. Default value is 'ui-igrating-vote ui-icon ui-icon-star' */
			vote: 'ui-igrating-vote ui-icon ui-icon-star',
			/* Class applied to the SPAN element of a vote in selected state. Default value is 'ui-igrating-voteselected' */
			voteSelected: 'ui-igrating-voteselected',
			/* Classes applied to the SPAN element of a vote in disabled state. Default value is 'ui-igrating-votedisabled ui-state-disabled' */
			voteDisabled: 'ui-igrating-votedisabled ui-state-disabled',
			/* Class applied to the SPAN element of a vote in hover state. Default value is 'ui-igrating-votehover' */
			voteHover: 'ui-igrating-votehover',
			/* Classes applied to the SPAN element of a vote in selected state when igRating is disabled. Default value is 'ui-igrating-votedisabledselected ui-state-disabled' */
			voteDisabledSelected: 'ui-igrating-votedisabledselected ui-state-disabled'
		},
		events: {
			/* cancel="true" Event which is raised before hover value is changed.
				If application returns false, then action is canceled and hover value stays unchanged.
				Function takes arguments evt and ui.
				Use ui.value to get new value.
				Use ui.oldValue to get old value. */
			hoverChange: null,
			/* cancel="true" Event which is raised before (selected) value is changed.
				If application returns false, then action is canceled and value stays unchanged.
				Function takes arguments evt and ui.
				Use ui.value to get new value.
				Use ui.oldValue to get old value. */
			valueChange: null
		},
		_create: function () {
			var inp, cont, elem,
				sto = {fontSize: '1px', width: '100%', height: '100%', position: 'relative', overflow: 'hidden'},
				o = this.options,
				elem0 = this.element,
				me = this,
				css = this.css,
				count = this._count(o),
				v = elem0[0].style,
				id = o.inputName;
			me._old = { width: v.width, height: v.height, html: elem0[0].innerHTML };
			if (!id) {
				elem0[0].innerHTML = '';
			}
			if (o.theme) {
				elem0.addClass(o.theme);
			}
			me._swap = o.swapDirection;
			me._rtl = elem0.css('direction') === 'rtl';
			if (me._rtl) {
				me._swap = !me._swap;
				elem0.css('direction', 'ltr');
			}
			// flag if control should use hover-css. Bit 1-has mouse, Bit 2-has focus.
			me._hasHov = 0;
			elem = me._elem = $('<div/>').css(sto).addClass(css.normal).appendTo(elem0).bind(me._evts = {
				mousedown: function (e) { me._doEvt(e, 1); },
				mousemove: function (e) { me._doEvt(e, 2); },
				mouseleave: function (e) { me._doEvt(e, 3); }
			});
			cont = $('<div/>').css(sto).appendTo(elem);
			if (o.focusable) {
				v = { left: '5px', top: '5px', opacity: 0.1, position: 'absolute', width: '1px', height: '1px', padding: '0px', zIndex: -1, border: '0px', outline: 0 };
				me._foc = $('<input type="button"/>').css(v).appendTo(cont).focus(function (evt) {
					if (o.disabled || me._fcs) {
						return;
					}
					me._fcs = 1;
					// flag if control should use hover-css. Bit 1-has mouse, Bit 2-has focus.
					// set focus bit
					if (me._hasHov < 2) {
						me._hasHov += 2;
					}
					if (me._hov) {
						me._doVal(me._valH, 1, evt);
						me._hov.css('visibility', 'visible');
					}
					me._elem.addClass(css.active);
				}).blur(function () {
					if (o.disabled || !me._fcs) {
						return;
					}
					me._fcs = null;
					// flag if control should use hover-css. Bit 1-has mouse, Bit 2-has focus.
					// remove focus bit
					me._hasHov %= 2;
					if (me._hov && me._hasHov === 0) {
						me._hov.css('visibility', 'hidden');
					}
					me._elem.removeClass(css.active);
				}).keydown(function (evt) {
					var old, arrow = 0, k = evt.keyCode, kc = $.ui.keyCode, val = me._valH, swap = me._swap ? -1 : 1, vertical = o.vertical, d = 1 / me._count(o);
					if (o.disabled) {
						return;
					}
					old = val;
					// exact=4, half=2, whole=1
					d /= me._prec(o);
					if (k === kc.SPACE || k === kc.ENTER) {
						me._doVal(val, false, evt);
						return;
					}
					if (k === kc.HOME) {
						val = 0;
					} else if (k === kc.END) {
						val = 1;
					} else if (k === kc.PAGE_DOWN) {
						val += d * 4;
					} else if (k === kc.PAGE_UP) {
						val -= d * 4;
					} else if (k === kc.UP && vertical) {
						val += (arrow = -d * swap);
					} else if (k === kc.DOWN && vertical) {
						val += (arrow = d * swap);
					} else if (k === kc.LEFT && !vertical) {
						val += (arrow = -d * swap);
					} else if (k === kc.RIGHT && !vertical) {
						val += (arrow = d * swap);
					}
					if (k > 32 && k < 41) {
						try {
							evt.preventDefault();
							evt.stopPropagation();
						} catch (ex) { }
					}
					// if roundedValue is too small (like 0), then requested increment/decrement by arrow can fail
					for (k = 0; k < 3; k++) {
						// _doVal returns 1, if new and old values are the same
						if (old !== (val = Math.max(Math.min(val, 1), 0)) && me._doVal(val, 1, evt) && arrow) {
							val += arrow;
						} else {
							break;
						}
					}
				});
			}
			me._doVotes(o, cont);
			// implement back-button of browser
			if (id) {
				inp = $('input[name="' + id + '"]');
				if (inp.length <= 0) {
					inp = $('#' + id);
				}
				v = inp[0] ? inp[0].value : null;
				if (v) {
					o.value = me._toNum(v, o);
				}
			}
			// selected value: it will be always in range of 0..1
			me._val = me._toNum(o.value, o);
			v = o.valueHover;
			// hover value: it will be always in range of 0..1
			me._valH = _aNull(v) ? me._val : me._toNum(v, o);
			if (!o.valueAsPercent) {
				me._val /= count;
				me._valH /= count;
			}
			me.validator();
			me._set = true;
			// 2-flag to adjust inputName.value (used by Mvc model)
			me._doVal(me._val, null, inp ? 2 : inp);
			me._doVal(me._valH, 1);
			delete me._set;
		},
		_toNum: function (v, o) {
			if (!v) {
				return 0;
			}
			o = o._vsFormat;
			if (typeof v === 'string') {
				v = parseFloat(o ? v.replace(o, '_').replace(/[`,\. \':]/g, '').replace('_', '.') : v);
			}
			return (isNaN(v) || v < 0) ? 0 : v;
		},
		_count: function (o) {
			o = parseInt(o.voteCount, 10);
			return isNaN(o) ? 5 : Math.max(o, 1);
		},
		_doVotes: function (o, cont) {
			var hov, sel, cssV, height, width, div, span, cssi, val = cont,
				count = this._count(o),
				sto = {width: '100%', height: '100%'},
				abs = {left: '0px', top: '0px', position: 'absolute', overflow: 'hidden', border: 'none', background: 'none'},
				i = -1,
				me = this,
				css = this.css,
				elem = this._elem,
				elem0 = this.element,
				touch = { touchstart: function (e) { e.preventDefault(); $(this).trigger('mousedown'); } };
			if (!cont) {
				cont = me._div.parent();
				me._div.remove();
				me._hov.remove();
				me._sel.remove();
				me._selSwap = me._hovSwap = null;
			}
			div = me._div = $('<div/>').addClass(css.vote).css(abs).appendTo(cont);
			if (!o.vertical) {
				div.css('whiteSpace', 'nowrap');
			}
			// validate width and height
			height = parseInt(o.voteHeight, 10);
			width = parseInt(o.voteWidth, 10);
			if (isNaN(height) || height < 2) {
				height = div.css('height');
				height = (!height || height.indexOf('px') < 1) ? 16 : parseInt(height, 10);
			}
			if (isNaN(width) || width < 2) {
				width = div.css('width');
				width = (!width || width.indexOf('px') < 1) ? 16 : parseInt(width, 10);
			}
			div.removeClass(css.vote);
			// selected div
			sel = me._sel = $('<div/>').addClass(css.selected).css(sto).css(abs).appendTo(cont);
			if (!o.vertical) {
				sel.css('whiteSpace', 'nowrap');
			}
			// hover div
			hov = me._hov = $('<div/>').addClass(css.hover).css(sto).css(abs).css('visibility', 'hidden').appendTo(cont);
			if (!o.vertical) {
				hov.css('whiteSpace', 'nowrap');
			}
			if (me._swap && !o.vertical) {
				me._hovSwap = hov = $('<div/>').css(sto).appendTo(me._hov);
				me._selSwap = sel = $('<div/>').css(sto).appendTo(me._sel);
			}
			cssV = { display: o.vertical ? 'block' : 'inline-block', width: width, height: height, textIndent: '0px', overflow: 'visible' };
			while (++i < count) {
				span = $('<span />').addClass(css.vote).css(cssV).appendTo(div).bind(touch);
				if (o.disabled) {
					span.addClass(css.voteDisabled);
				}
				cssi = o.cssVotes ? o.cssVotes[i] : null;
				if (cssi && cssi[0]) {
					span.addClass(cssi[0]);
				}
				span[0]._i = i;
				span = $('<span />').addClass(css.vote).addClass(css.voteSelected).css(cssV).appendTo(sel).bind(touch);
				if (o.disabled) {
					span.addClass(css.voteDisabledSelected);
				}
				if (cssi && cssi[1]) {
					span.addClass(cssi[1]);
				}
				span[0]._i = i;
				if (me._swap && !me._selSwap) {
					me._selSwap = span;
				}
				span = $('<span />').addClass(css.vote).addClass(css.voteHover).css(cssV).appendTo(hov).bind(touch);
				if (cssi && cssi[2]) {
					span.addClass(cssi[2]);
				}
				span[0]._i = i;
				if (me._swap && !me._hovSwap) {
					me._hovSwap = span;
				}
			}
			if (o.vertical) {
				me._size = height;
				height *= count;
			} else {
				me._size = width;
				width *= count;
			}
			// moving this line above try{}, seems to get around bugs in jquery-1.4.4. But keep try{} in case of bugs in future jquerys
			elem.css({height: height + 'px', width: width + 'px'});
			// get around bugs in jquery-1.4.4 (exception in Opera or huge elem.innerHeight in IE)
			try {
				height += ((i = Math.max(elem.outerHeight() - elem.innerHeight(), 0)) > 10) ? 2 : i;
				width += ((i = Math.max(elem.outerWidth() - elem.innerWidth(), 0)) > 10) ? 2 : i;
			} catch (ex) { }
			elem0.css({height: height + 'px', width: width + 'px'});
			div.css(sto);
			if (!val) {
				me.value(me.value());
			}
		},
		validator: function (destroy) {
			/* Gets reference to igValidator used by igRating.
				paramType="bool" optional="true" Request to destroy validator.
				returnType="object" Returns reference to igValidator or null.
			*/
			var o = this.options.validatorOptions, foc = this._foc, v = this._validator;
			if (v && (destroy || !o)) {
				v.destroy();
				delete this._validator;
			} else if (!v && !destroy && o && foc && foc.igValidator) {
				o.element = this.element.find(':first-child');
				this._validator = foc.igValidator(o).data('igValidator');
			}
			return this._validator;
		},
		validate: function () {
			/* Trigger validation.
				returnType="number|object" Possible values:
				1 - application canceled error message.
				2 - error message is displayed.
				Any other value or undefined means that target is valid or validation is not enabled.
			*/
			return this._validator ? this._validator.validate() : null;
		},
		_doEvt: function (evt, type) {
			var val, me = this, o = this.options;
			if (o.disabled) {
				return;
			}
			// mouseleave
			if (type === 3) {
				// flag if control should use hover-css. Bit 1-has mouse, Bit 2-has focus.
				// remove mouse bit
				me._hasHov -= me._hasHov % 2;
				if (me._hov && me._hasHov === 0) {
					me._hov[0].style.visibility = 'hidden';
				}
				return;
			}
			val = me._valFromEvt(evt);
			if (val < 0) {
				return;
			}
			// mousedown
			if (type === 1) {
				if (!me._sel) {
					return;
				}
				val = me._lastHov || val;
				me._doVal(val, false, evt);
				me._doVal(val, 1, evt);
				// get around bugs in IE9
				if (me._foc && document.hasFocus && !document.hasFocus()) {
					return setTimeout(function () { me.focus(); }, 0);
				}
				me.focus();
			}
			// mousemove
			if (type === 2) {
				me._lastHov = val;
				if (!me._hov) {
					return;
				}
				// flag if control should use hover-css. Bit 1-has mouse, Bit 2-has focus.
				// set mouse bit
				if (me._hasHov % 2 === 0) {
					me._hasHov++;
				}
				me._hov[0].style.visibility = 'visible';
				me._doVal(val, 1, evt);
			}
			evt.preventDefault();
		},
		_setOption: function (key, val) {
			var spans, count, css, o = this.options;
			if (o[key] === val || key === 'swapDirection' || key === 'vertical' || key === 'focusable') {
				return this;
			}
			count = this._count(o);
			if (key === 'disabled') {
				spans = $('SPAN', this._div);
				css = this.css.voteDisabled;
				if (spans.length !== count) {
					return this;
				}
				if (val) {
					spans.addClass(css);
				} else {
					spans.removeClass(css);
				}
				spans = $('SPAN', this._sel);
				css = this.css.voteDisabledSelected;
				if (spans.length !== count && this._selSwap) {
					spans = $('SPAN', this._selSwap);
				}
				if (spans.length === count) {
					if (val) {
						spans.addClass(css);
					} else {
						spans.removeClass(css);
					}
				}
			}
			if (key === 'theme') {
				if (o.theme) {
					this.element.removeClass(o.theme);
				}
				if (val) {
					this.element.addClass(val);
				}
			}
			o[key] = val;
			if (typeof val === 'function') {
				return this;
			}
			this._set = true;
			if (key === 'precision' || key === 'valueAsPercent') {
				this._doVal(this._val, false, 1);
				this._doVal(this._valH, 1, 1);
			}
			if (key.indexOf('vote') === 0 || key === 'theme' || key === 'cssVotes') {
				this._doVotes(o);
			}
			if (key.indexOf('value') >= 0) {
				this._doVal(val, key.length > 6, 1, 1);
			}
			if (key === 'validatorOptions') {
				this.validator();
			}
			delete this._set;
			return this;
		},
		_evtOffset: function (evt, xy) {
			var val,
				oEvt = evt.originalEvent || evt,
				offset = 'offset' + xy;
			if (_aNull(val = evt[offset])) {
				if (_aNull(val = oEvt[offset])) {
					if (_aNull(val = evt[offset = 'layer' + xy])) {
						val = oEvt[offset];
					}
				}
			}
			return val || 1;
		},
		_valFromEvt: function (evt) {
			var plus, fix, val, offset, i, o = this.options, targ = evt ? evt.target : null;
			i = (targ && targ.nodeName === 'SPAN') ? targ._i : null;
			if (_aNull(i)) {
				return -1;
			}
			if (!targ.unselectable) {
				targ.unselectable = 'on';
			}
			offset = this._evtOffset(evt, o.vertical ? 'Y' : 'X');
			plus = this._size;
			// fix for Firefox
			fix = -(o.vertical ? targ.offsetTop : targ.offsetLeft);
			if (this._swap && $.ig.util.isFF && fix < plus) {
				offset += fix;
			}
			plus *= i;
			if (plus > offset) {
				offset += plus;
			}
			val = offset / this._count(o) / this._size;
			if (this._swap) {
				val = 1 - val;
			}
			return Math.max(Math.min(val, 1), 0);
		},
		// val: value
		// hov: flag for valueHover
		// evt: event of browser, 1-flag to adjust _val/_valH, 2-init flag to adjust only inputName, or undefined
		// v0: flag that public value() or option-value was called
		// returns 1 if evt is on and new and old values after "_fixVal" are the same (used by arrow keys)
		_doVal: function (val, hov, evt, v0) {
			var id, inp, v1, count, o = this.options, style = hov ? this._hov : this._sel, size = this._size, swap = this._swap ? (hov ? this._hovSwap : this._selSwap) : null;
			if (style) {
				style = style[0];
				if (style) {
					style = style.style;
				}
			}
			if (!style) {
				return;
			}
			count = this._count(o);
			if (v0) {
				val = parseFloat(val);
			}
			if (isNaN(val)) {
				val = -1;
			} else if (v0 && !o.valueAsPercent) {
				val /= count;
			}
			if (evt && evt.type && val >= 0) {
				v0 = this._fixVal(hov ? this._valH : this._val, 1);
				v1 = this._fixVal(val, 1);
				if (v0 === v1) {
					return 1;
				}
				if (!this._trigger(hov ? 'hoverChange' : 'valueChange', evt, {value: v1, oldValue: v0})) {
					return;
				}
			}
			if (val < 0 && hov) {
				val = this._val;
			}
			val = this._fixVal(val);
			if (evt) {
				v0 = this._round(o.valueAsPercent ? val : val * count, o);
				if (hov) {
					this._valH = val;
					o.valueHover = v0;
				} else {
					if (evt !== 2) {
						this._val = val;
						o.value = v0;
					}
					id = o.inputName;
					if (id) {
						inp = $('input[name="' + id + '"]');
						if (inp.length === 0) {
							inp = $('<input type="hidden" name="' + id + '" />').appendTo(this.element.parent());
						}
						v1 = o._vsFormat;
						inp.val(v1 ? v0.toString().replace('.', v1) : v0);
					}
				}
			}
			if (!hov && this._foc) {
				this._foc.val(this._fixVal(val, 1));
			}
			if (swap) {
				val = 1 - val;
			}
			val = Math.floor(val * size * count + 0.3);
			val += 'px';
			if (swap) {
				swap = swap[0];
				if (swap) {
					swap = swap.style;
				}
			}
			if (o.vertical) {
				if (swap) {
					style.top = val;
					swap.marginTop = '-' + val;
				} else {
					style.height = val;
				}
			} else {
				if (swap) {
					style.left = val;
					swap.marginLeft = '-' + val;
				} else {
					style.width = val;
				}
			}
		},
		_prec: function (o) {
			o = this._set ? null : o.precision;
			if (o) {
				o = o.toLowerCase();
			}
			return (o === 'half') ? 2 : ((o === 'whole') ? 1 : 4);
		},
		// val-value in range 0..1
		// full-return value according to valueAsPercent
		_fixVal: function (val, full, prec) {
			var fix, count, o = this.options;
			prec = prec || this._prec(o);
			count = this._count(o);
			val = Math.max(Math.min(val, 1), 0);
			// half (2) or whole (1)
			if (prec < 4) {
				fix = count * prec;
				val *= fix;
				val = (val < o.precisionZeroVote) ? 0 : Math.floor(Math.floor(val + 0.99) + 0.499 * prec) / fix;
			}
			if (!full) {
				return val;
			}
			if (!o.valueAsPercent) {
				val *= count;
				// half (2) or exact (4)
				val = (prec > 1) ? val : Math.floor(val + 0.1);
			}
			return this._round(val, o);
		},
		_round: function (val, o) {
			var pow = 1, fix = parseInt(o.roundedDecimalPlaces, 10);
			if (isNaN(fix) || fix < 0) {
				return val;
			}
			fix = Math.min(15, Math.max(fix, (this._prec(o) < 4) ? 3 : (o.valueAsPercent ? 1 : 0)));
			while (fix-- > 0) {
				pow *= 10;
			}
			return Math.round(val * pow) / pow;
		},
		value: function (val) {
			/* Gets sets (selected) value.
				paramType="number" New value which is rendered with selected css.
				returnType="number|object" If parameter is not 'number', then exact value rendered with selected css is returned. Otherwise, reference to igRating is returned.
			*/
			if (typeof val !== 'number') {
				return this._fixVal(this._val, 1, 4);
			}
			this._set = true;
			this._doVal(val, false, 1, 1);
			delete this._set;
			return this;
		},
		valueHover: function (val) {
			/* Gets sets hover value.
				paramType="number" optional="true" New value which will be rendered with hover css when rating gets mouse.
				returnType="number|object" If parameter is not "number", then last value which was rendered with hover css is returned. Otherwise, reference to igRating is returned.
			*/
			if (typeof val !== 'number') {
				return this._fixVal(this._valH, 1, 4);
			}
			this._set = true;
			this._doVal(val, 1, 1, 1);
			delete this._set;
			return this;
		},
		hasFocus: function () {
			/* Checks if igRating has focus.
				returnType="bool" Returns true if igRating has focus.
			*/
			return this._fcs === 1;
		},
		focus: function () {
			/* Sets focus to igRating. That has effect only when options.focusable is enabled.
				returnType="object" Returns reference to this igRating.
			*/
			if (this._foc) {
				try {
					this._foc[0].focus();
				} catch (ex) {}
			}
			return this;
		},
		destroy: function () {
			/* Destroys igRating.
				returnType="object" Returns reference to this igRating.
			*/
			var o = this.options, old = this._old, e = this.element;
			if (!this._elem) {
				return this;
			}
			this.validator(1);
			if (this._foc) {
				this._foc.unbind().remove();
			}
			this._elem.remove();
			if (o.theme) {
				e.removeClass(o.theme);
			}
			e[0].style.width = old.width;
			e[0].style.height = old.height;
			if (!o.inputName) {
				e[0].innerHTML = old.html;
			}
			if (this._rtl) {
				e.css('direction', 'rtl');
			}
			$.Widget.prototype.destroy.apply(this, arguments);
			this._elem = this._hov = this._sel = this._selSwap = this._hovSwap = this._foc = this._evts = null;
			return this;
		}
	});
	$.extend($.ui.igRating, { version: '14.1.20141.2249' });
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI ToolbarButton 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *	jquery-1.9.1.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.util.js
 *	infragistics.ui.shared.js
 */

/*global jQuery, window, document, Class, $ */
(function ($) {
    /*
		The igToolbarButton is a jQuery based widget which allow you to create a toolbar button.
	*/
	$.widget("ui.igToolbarButton", $.ui.igButton, {
	    options: {
	        /* type="boolean" Enable/Disable the "Toggling" of a button. */
	        allowToggling: true,
	        /* type="boolean" Enable/Disable the "Selecting" of a button. */
			isSelected: false
	    },
	    css: {
	        toolbarButtonWidget: "ui-igtoolbarbutton"
	    },
	    events: {
	        /* cancel="true" Event fired before the toolbar button is activated.
                Function takes arguments evt and ui.
                Use ui.owner to get a reference to the toolbar button performing the activation.
            */
	        activating: "activating",
	        /* Event fired after the toolbar button is activated.
                Function takes arguments evt and ui.
                Use ui.owner to get reference to the toolbar button performing the activation.
            */
	        activated: "activated",
	        /* cancel="true" Event fired before the toolbar button is deactivated.
                Function takes arguments evt and ui.
                Use ui.owner to get a reference to the toolbar button performing the deactivation.
            */
	        deactivating: "deactivating",
	        /* Event fired after the toolbar button is deactivated.
                Function takes arguments evt and ui.
                Use ui.owner to get reference to the toolbar button performing the deactivation.
            */
            deactivated: "deactivated"
	    },
		_setOption: function (option, value) {
		    if (this.options[option] === value) {
		        return;
		    }

			$.ui.igButton.prototype._setOption.apply(this, arguments);
		},
		_create: function () {
			$.ui.igButton.prototype._create.apply(this);

			this._setupElement();
			this._attachToolbarBtnEvents();
		},
		_setupElement: function () {
		    this.element
                .addClass(this.css.toolbarButtonWidget)
                .attr("tabindex", "1");
		},
        // Overrides igButton's _onBlur
		_onBlur: function (event) {
		    var noCancel,
                o = this.options;

		    if (!o.disabled) {
		        noCancel = this._trigger('blur', event);
		        if (noCancel) {
		            this.element.removeClass(o.css.buttonFocusClasses);
		            if (!o.allowToggling) {
		                this.element.removeClass(o.css.buttonActiveClasses);
		            }
		        }
		    }
		},
	    // Overrides igButton's _onMouseDown
		_onMouseDown: function (event) {
		    var noCancel,
                e = this.element,
                o = this.options;

		    if (!o.disabled) {
		        noCancel = this._trigger('mousedown', event);
		        if (noCancel) {
		            e.removeClass(o.css.buttonHoverClasses);
		            if (!o.allowToggling) {
		                e.addClass(o.css.buttonActiveClasses);
		            }
		        }
		    }
		},
        // Overrides igButton's _onMouseUp
		_onMouseUp: function (event) {
		    var noCancel,
                o = this.options;

		    if (!o.disabled) {
		        noCancel = this._trigger('mouseup', event);
		        if (noCancel) {
		            this.element.removeClass(o.css.buttonHoverClasses);
		            if (!o.allowToggling) {
		                this.element.removeClass(o.css.buttonActiveClasses);
		            }
		        }
		    }
		},
		_onEnterKey: function (e) {
		    if (e.keyCode !== $.ui.keyCode.ENTER) {
		        return;
		    }

		    this.element.mousedown();
		},
		_triggerActivating: function (event) {
		    var args = {
		        owner: this
		    };

		    return this._trigger(this.events.activating, event, args);
		},
		_triggerActivated: function (event) {
		    var args = {
		        owner: this
		    };

		    return this._trigger(this.events.activated, event, args);
		},
		_triggerDeactivating: function (event) {
		    var args = {
                owner: this
		    };

		    return this._trigger(this.events.deactivating, event, args);
		},
		_triggerDeactivated: function (event) {
		    var args = {
		        owner: this
		    };

		    return this._trigger(this.events.deactivated, event, args);
		},
		_attachToolbarBtnEvents: function () {
		    var noCancel,
                o = this.options,
                self = this;

            // Toggle element state on click
		    this.element.click(function (e) {
		        if (o.allowToggling) {
		            if (o.isSelected) {
		                noCancel = self._triggerDeactivating(e);
		                if (noCancel) {
		                    self.deactivate(e);
		                    self.element.addClass(o.css.buttonHoverClasses);
		                }
		            } else {
		                noCancel = self._triggerActivating(e);
		                if (noCancel) {
		                    self.activate(e);
		                }
		            }
		        }
		    });

		    this.element.on("keypress", $.proxy(this._onEnterKey, this));
		},
		toggle: function () {
		    /*
                Toggle toolbar button
            */
		    var o = this.options;

			if (o.disabled === true || o.allowToggling === false) {
				return;
			}

			o.isSelected = !o.isSelected;
			this.element.toggleClass(o.css.buttonActiveClasses);
		},
		activate: function (event) {
		    /*
                Activate toolbar button
            */
		    var o = this.options;

		    if (o.disabled === true || o.allowToggling === false) {
		        return;
		    }

		    o.isSelected = true;
		    this.element.addClass(o.css.buttonActiveClasses);

		    if (event) {
		        this._triggerActivated(event);
		    }
		},
		deactivate: function (event) {
		    /*
                Deactivate toolbar button
            */
		    var o = this.options;

		    if (o.disabled === true || o.allowToggling === false) {
		        return;
		    }

		    o.isSelected = false;
		    this.element
                .removeClass(o.css.buttonActiveClasses)
		        .removeClass(o.css.buttonFocusClasses);

		    if (event) {
		        this._triggerDeactivated(event);
		    }
		},
		widget: function () {
		    /* Returns the element that represents this widget.
               returnType="object" Returns the element that represents this widget.
            */
		    return this.element;
		},
		destroy: function () {
		    /*
                Destroy the widget.
            */
			$.ui.igButton.prototype.destroy.call(this);
		    this.element.off()
                .removeClass("");
		}
	});

	$.extend($.ui.igToolbarButton, { version: '14.1.20141.2249' });
}(jQuery));
/*!@license
 * Infragistics.Web.ClientUI ColorPicker 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 * <Licensing info>
 *
 * http://www.infragistics.com/
 * 
 * Depends on: 
 *   jquery-1.9.1.js
 *   jquery.ui.core.js
 *   jquery.ui.widget.js
 *   infragistics.util.js
 *   infragistics.ui.shared.js
 */

/*global jQuery, window, document, Class, $ */
if (typeof jQuery !== "function") {
    throw new Error("jQuery is undefined");
}

(function ($) {
    /*
		The igColorPicker is a jQuery based widget which allow you to pick a color.
	*/
    $.widget("ui.igColorPicker", {
        options: {
            /* type="array" Default colors. */
            colors: [
				["#ffffff", "#000000", "#EEECE1", "#1F497D", "#4F81BD", "#C0504D", "#9BBB59", "#8064A2", "#4BACC6", "#F79646"],
				["#F2F2F2", "#7F7F7F", "#DDD9C3", "#C6D9F0", "#DBE5F1", "#F2DCDB", "#EBF1DD", "#E5E0EC", "#DBEEF3", "#FDEADA"],
				["#D8D8D8", "#595959", "#C4BD97", "#8DB3E2", "#B8CCE4", "#E5B9B7", "#D7E3BC", "#CCC1D9", "#B7DDE8", "#FAC08F"],
				["#BFBFBF", "#3F3F3F", "#938953", "#548DD4", "#95B3D7", "#D99694", "#C3D69B", "#B2A1C7", "#92CDDC", "#FAC08F"],
				["#A5A5A5", "#262626", "#494429", "#17365D", "#366092", "#953734", "#76923C", "#5F497A", "#31859B", "#E36C09"],
				["#7F7F7F", "#0C0C0C", "#1D1B10", "#0F243E", "#244061", "#632423", "#4F6128", "#3F3151", "#205867", "#974806"]
            ],
            /* type="array" Standard colors. */
            standardColors: ["#C00000", "#FF0000", "#FFC000", "#FFFF00", "#92D050", "#00B050", "#00B0F0", "#0070C0", "#002060", "#7030A0"]
        },
        events: {
            /* cancel="false" Event fired after the color is selected. */
            colorSelected: "colorSelected"
        },
        css: {
            /* The row class css. */
            standardColorsRow: "ui-colorpicker-standardcolors",
            /* The widget base class css. */
            baseClass: "ui-igColorPicker"
        },
        _create: function () {
            var i, j, row, cols, rows, color,
                allColors = $.extend(true, [], this.options.colors),
				colorTableHtml = '<ul class="color-table">';

            allColors.push(this.options.standardColors);
            rows = allColors.length;

            for (i = 0; i < rows; i++) {
                colorTableHtml += '<li><ul>';
                cols = allColors[i].length;
                for (j = 0; j < cols; j++) {
                    colorTableHtml += '<li class="color-item"><a href="#"><span class="color" style="background-color: ' +
                        allColors[i][j] +
                   ';"></span></a></li>';
                }
                colorTableHtml += '</ul></li>';
            }

            colorTableHtml += '</ul>';
            this._colorTable = $(colorTableHtml).appendTo(this.element);
            $(".color-table > li:last ul").addClass(this.css.standardColorsRow);
        },
        _getColor: function ($element) {
            return $element.css("background-color");
        },
        _init: function () {
            this.element.addClass(this.css.baseClass);
            this._colorTable.children().first().addClass("color-table-first-row");
            this._bindEvents();
        },
        _bindEvents: function () {
            var self = this;
            this._colorTable.delegate("a", "click", function (e) {
                var target = $(e.target);
                e.preventDefault();

                self._changeSelectedColor(target);
                self._trigger(self.events.colorSelected, e, { color: self._getColor(target) });
            });
        },
        _changeSelectedColor: function (target) {
            this._colorTable.find("span.selected-color").removeClass("selected-color");
            if (target.is("a")) {
                target = target.children();
            }
            target.addClass("selected-color");
        }
    });

    $.extend($.ui.igColorPicker, { version: '14.1.20141.2249' });
}(jQuery));
/*!@license
 * Infragistics.Web.ClientUI ColorPickerSplitButton 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 * <Licensing info>
 *
 * http://www.infragistics.com/
 * 
 * Depends on: 
 *   jquery-1.9.1.js
 *   jquery.ui.core.js
 *   jquery.ui.widget.js
 *   infragistics.util.js
 *   infragistics.ui.shared.js
 *   infragistics.ui.popover.js
 *   infragistics.ui.toolbarbutton.js
 *   infragistics.ui.splitbutton.js
 *   infragistics.ui.colorpicker.js
 */

/*global jQuery, window, document, Class, $ */
if (typeof jQuery !== "function") {
    throw new Error("jQuery is undefined");
}

(function ($) {
    /*
       The igColorPickerSplitButton is a jQuery based widget.
   */
    $.widget("ui.igColorPickerSplitButton", $.ui.igSplitButton, {
        options: {
            /* type="array" Button items. */
            items: [],
            /* type="string" Default color. */
            defaultColor: "#000",
            /* type="boolean" With or withour icon. */
            hasDefaultIcon: true
        },
        _create: function () {
            $.ui.igSplitButton.prototype._create.call(this);
            this._setButtonColorIndicator(this.options.defaultColor);
        },
        _createItemsList: function () {
            var popoverCont,
                popoverOptions;
            this._options.popover = $('<div id="' + this._id("_popover") + '"></div>')
                .appendTo(this.element);
            if ($.ig.util.isTouchDevice()) {
                popoverOptions = {
				    direction: "bottom",
				    closeOnBlur: false,
				    width: 480,
                    height: 360,
                    maxWidth: 480,
				    maxHeight: 360,
				    defaultMaxWidth: null
				};
            } else {
                 popoverOptions = {
				    direction: "bottom",
				    closeOnBlur: false,
				    width: 220,
				    defaultMaxWidth: null
				};
            }
            this._options.popover.igPopover(popoverOptions);
            popoverCont = this._options.popover.igPopover("container");
            this._options.itemsList = popoverCont.igColorPicker();
        },
        _attachEvents: function () {
            $.ui.igSplitButton.prototype._attachEvents.call(this);
            this._options.itemsList.on("igcolorpickercolorselected", $.proxy(this._onColorSelect, this));
            this._options.defaultButton.on("igtoolbarbuttonclick", $.proxy(this._onDefaultButtonClick, this));
            this._options.itemsList.parent().parent().on("mousedown", $.proxy(this._preventCollapsing, this));
        },
        collapse: function (e) {
            /* Collapse the widget. */
            var _opt = this._options;

            _opt.popover.igPopover("hide");
            this.element.removeClass(this.css.active);
            _opt.expandButton.removeClass(this.css.focus);
            _opt.isExpanded = false;

            if (e) {
                this._triggerCollapsed(e);
            }
        },
        expand: function (e) {
            /* Expands the widget. */
            var _opt = this._options;

            _opt.popover.igPopover("show", this.element);
            this.element.addClass(this.css.active);
            _opt.isExpanded = true;

            if (e) {
                this._triggerExpanded(e);
            }
        },
        _onItemClick: function (e) {
            return false;
        },
        _onColorSelect: function (e, ui) {
            this._setButtonColorIndicator(ui.color);
            this.options.defaultColor = ui.color;
            this._trigger("colorSelected", e, { value: ui.color, item: this.element });
            this.collapse();
        },
        setColor: function (color) {
            /*Sets the color of the split button*/
            this._setButtonColorIndicator(color);
            this.options.defaultColor = color;
            this.collapse();
        },
        _onDefaultButtonClick: function (e, ui) {
            e.stopPropagation();
            this._trigger("colorSelected", e, { value: this.options.defaultColor, item: this.element });
        },
        _setButtonColorIndicator: function (color) {
            this._options.defaultButton.children(":first").css("border-bottom-color", color);
            if(!this.options.hasDefaultIcon){
                this._options.defaultButton.children(":first").css("background-color", color);
                this._options.defaultButton.children(":first").css("background-image", "none");
            }
        },
        _preventCollapsing: function (e) {
            return false;
        },
        destroy: function () {
            /* Destroys the widget. */
            $.ui.igSplitButton.prototype.destroy.apply(this, arguments);
        }
    });

    $.extend($.ui.igColorPickerSplitButton, { version: '14.1.20141.2249' });
}(jQuery));
/*!@license
 * Infragistics.Web.ClientUI Toolbar 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 * <Licensing info>
 *
 * http://www.infragistics.com/
 * 
 * Depends on: 
 *   jquery-1.9.1.js
 *   jquery.ui.core.js
 *   jquery.ui.widget.js
 *   infragistics.util.js
 *   infragistics.ui.shared.js
 *   infragistics.ui.popover.js
 *   infragistics.ui.toolbarbutton.js
 *   infragistics.ui.splitbutton.js
 *   infragistics.ui.colorpicker.js
 *   infragistics.ui.colorpickersplitbutton.js
 *   infragistics.ui.combo.js
 */

/*global jQuery, window, document, Class, $ */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {
    $.ig = $.ig || {};

    $.ig.igToolbarItemBaseDescriptor = Class.extend({
        settings: {
            width: null,
            height: null,
            props: {
                scope: {
                    value: null
                }
            }
        },
        _updatedProperties: [],
        init: function (item) {
            this.settings = $.extend(true, {}, this.settings, item);
            this.name = item.name;
            this.type = item.type;
            if (this.settings.scope) {
                this.settings.props.scope = this.settings.scope;
            }
        },
        updateProperty: function (name, value) {
            this.settings.props[name].value = value;
            this._updatedProperties.push(this.settings.props[name]);
        },
        getProperty: function (name) {
            return this.settings.props[name];
        },
        getUpdatedProperties: function () {
            return this._updatedProperties;
        },
        getProperties: function () {
            return this.settings.props;
        },
        callbackRenderer: function () {
            if (this.settings.callbackRenderer && $.isFunction(this.settings.callbackRenderer)) {
                return this.settings.callbackRenderer();
            }
        },
        handler: function () {
            return this.settings.handler;
        }
    });

    $.ig.igToolbarButtonDescriptor = $.ig.igToolbarItemBaseDescriptor.extend({
        settings: {
            props: {
                onlyIcons: {
                    value: true
                },
                labelText: {
                    value: "&nbsp;"
                }
            }
        },
        init: function (item) {
            this._super(item);
        }
    });

    $.ig.igToolbarSplitButtonDescriptor = $.ig.igToolbarItemBaseDescriptor.extend({
        settings: {
            props: {
                items: []
            }
        },
        init: function (item) {
            this._super(item);
        }
    });

    $.ig.igToolbarComboDescriptor = $.ig.igToolbarItemBaseDescriptor.extend({
        settings: {
            props: {
                valueKey: {
                    value: 'text'
                },
                textKey: {
                    value: 'value'
                },
                enableCheckboxes: {
                    value: false
                },
                dropDownOnFocus: {
                    value: true
                },
                selectedItems: {
                    value: [{ index: 0 }]
                },
                enableClearButton: {
                    value: false
                },
                dataSource: {
                    value: null
                },
                mode: {
                    value: "dropdown"
                },
                dropDownAsChild: {
                    value: true
                },
                focusOnSelect: {
                    value: false
                }
            }
        },
        init: function (item) {
            this._super(item);
            if (this.settings.dataSource) {
                this.settings.props.dataSource.value = this.settings.dataSource;
            }
        }
    });

    /*
		The igToolbar is a jQuery based widget that support a set from toolbar buttons, 
        split buttons, color picker split buttons, and combos.
	*/
	$.widget("ui.igToolbar", {
	    options: {
	            /* type="numeric" Set or get the widget height.*/
	            height: null,
	            /* type="numeric" Set or get the widget width.*/
	            width: null,
                /* type="boolean" Set or get allowCollapsing property*/
	            allowCollapsing: true,
	            /* type="string" The css class that will be applied to collapseButtonIcon.*/
	            collapseButtonIcon: "ui-igbutton-collapsed",
	            /* type="string" The css class that will be applied to expandButtonIcon.*/
	            expandButtonIcon: "ui-igbutton-expanded",
	            /* type="string" Formal name of the widget. */
	            name: '',
	            /* type="string" Display Name of the widget. */
	            displayName: '',
	            /* type="array" get or set Toolbar's items. */
	            items: [],
	            /* type="boolean" get or set widget's isExpanded property. */
				isExpanded: true
			},
			events: {
                /*cance="false" Event fired after a click on any toolbar button*/
			    toolbarButtonClick: "toolbarButtonClick",
                /*cancel="true" Event fired before fully opened toolbar combo*/
			    toolbarComboOpening: "toolbarComboOpening",
			    /*cancel="false" Event fired after toolbar combo is selected*/
			    toolbarComboSelected: "toolbarComboSelected",
			    /*cancel="false" Event fired on mouse down*/
			    toolbarMouseDown: "toolbarMouseDown",
			    /*cancel="false" Event fired after a click on custom item*/
			    toolbarCustomItemClick: "toolbarCustomItemClick",
			    /*cancel="false" Event fired after item is removed*/
			    itemRemoved: "itemRemoved",
			    /*cancel="false" Event fired after item is added*/
			    itemAdded: "itemAdded",
			    /*cancel="true" Event fired before item finish collapsing*/
			    collapsing: "collapsing",
			    /*cancel="false Event fired after item is collapsed"*/
			    collapsed: "collapsed",
			    /*cancel="true" Event fired before item is expanded*/
			    expanding: "expanding",
			    /*cancel="false" Event fired after item is expanded*/
			    expanded: "expanded",
			    /*cancel="false" Fired after item is dissabled*/
			    itemDisable: "itemDisable",
			    /*cancel="false" Fired after item is enabled*/
				itemEnabled: "itemEnabled",
				/*cance="false" Fired after the window is resized*/
				windowResized: "windowResized"
			},
			css: {
			    /* The widget base class css. */
			    toolbarWidget: "ui-widget ui-widget-content ui-igtoolbar ui-corner-all",
			    /* The widget wrapper class css. */
			    toolbarWrapperConteiner: "ui-widget ui-widget-content ui-igtoolbar ui-corner-all",
			    /* The widget collapse button class css. */
				toolbarCollapsedButton: "ui-state-default ui-igbutton-all-caps",
			    /* The widget toolbar separator class css. */
				igToolbarSeparator: "ig-toolbar-separator ui-widget-content",
				/* The widget toolbar button holder css class. */
				igToolbarButtonsHolder: "ig-toolbar-buttons-holder"
			},
			_id: function (id) {
				return this.element[0].id + id;
			},
			widget: function () {
			    /*
                    Returns the element on which the widget was instantiated
                */
				return this.element;
			},
			_create: function () {
			    var toolbar = this.options;

			    this._tbHash = {};

			    for (j = 0; j < toolbar.items.length; j++) {
			        if (!toolbar.items[j].type) {
			            toolbar.items[j].type = "custom";
			        }

			        itemDescriptor = toolbar.items[j] = this._getToolbarItemDescriptor(toolbar.items[j]);
			        
			        this._tbHash = { "toolbarOpts": toolbar };
			        this._tbHash.isExpanded = false;


			        for (property in itemDescriptor.getProperties()) {
			            if (itemDescriptor.getProperties().hasOwnProperty(property)) {
			                if (this._tbHash === undefined) {
			                    this._tbHash = {};
			                }
			                this._tbHash[property] = itemDescriptor;
			            }
			        }
			    }

				this._render();
				this._createItems();
			},
			getToolbarHash: function () {
			    /*
                    Returns the toolbar hash
                */
			    return this._tbHash;
			},
			_getToolbarItemDescriptor: function (item) {
			    return new this._toolbarItemsDescriptors[item.type](item);
			},
			_toolbarItemsDescriptors: {
			    button: $.ig.igToolbarButtonDescriptor,
			    "0": $.ig.igToolbarButtonDescriptor,
			    combo: $.ig.igToolbarComboDescriptor,
			    "1": $.ig.igToolbarComboDescriptor,
			    splitButton: $.ig.igToolbarSplitButtonDescriptor,
			    "2": $.ig.igToolbarSplitButtonDescriptor,
			    splitButtonColor: $.ig.igToolbarSplitButtonDescriptor,
			    "3": $.ig.igToolbarSplitButtonDescriptor,
			    custom: $.ig.igToolbarItemBaseDescriptor
			},
			_init: function () {
				this._attachEvents();
				if (!this.options.isExpanded) {
					this.buttonsList.hide();
					this.collapseBtn.igToolbarButton("toggle")
						.children(":first")
						.switchClass(this.options.collapseButtonIcon, this.options.expandButtonIcon);
				}

				this._width = this.collapseBtn.outerWidth(true) + this.buttonsList.width();
				this._height = this.element.height();
			},
			_render: function () {
				var o = this.options;

				this.element.addClass(this.css.toolbarWidget);
				this.element
					.width(this.options.width)
					.height(this.options.height);

				this.collapseBtn = $('<div tabIndex="0" id="' + this._id('_collapseButton') + '"></div>')
					.appendTo(this.element).igToolbarButton({
						"onlyIcons": true,
						"labelText": "&nbsp;",
						"title": $.ig.Toolbar.locale.collapseButtonTitle + ' ' + this.options.displayName,
						"icons": {
							"primary": o.collapseButtonIcon
						}
					});

				this.toolbarBody = this.element.find('#' + this._id('_toolbar'));
                //D.U. 30.04.2014 changing type from span to div and adding a class instead of inline css
				this.buttonsList = $('<div id="' + this._id('_toolbar_buttons') + '" class="'+ this.css.igToolbarButtonsHolder +'"></div>')
					.appendTo(this.element);
			},
			_onCollapse: function (e) {
				var noCancel, event, cancelableEvent,
					options = this.options, width,
					self = this,
					visibility,
					opacity;

				if (!options.allowCollapsing) {
					return;
				}
				if (options.isExpanded) {
					event = "collapsed";
					cancelableEvent = "collapsing";
					options.isExpanded = false;
					width = this.element.height();
					this.collapseBtn.attr('title', $.ig.Toolbar.locale.expandButtonTitle + ' ' + this.options.displayName)
                        .children(":first").switchClass(this.options.collapseButtonIcon, this.options.expandButtonIcon);
					visibility = "hidden";
					opacity = "0.0";
				} else {
					event = "expanded";
					cancelableEvent = "expanding";
					options.isExpanded = true;
					width = this._width;
					this.buttonsList.show();
					this.collapseBtn.attr('title', $.ig.Toolbar.locale.collapseButtonTitle + ' ' + this.options.displayName)
                        .children(":first").switchClass(this.options.expandButtonIcon, this.options.collapseButtonIcon);
					visibility = "visible";
					opacity = "1";
				}

				e.stopPropagation();

				noCancel = this._trigger(this.events[cancelableEvent], e, {owner: this, toolbarElement: this.element, toolbar: {}});
				if (noCancel) {
					this.element.css({overflow: "hidden"});
					this.element.animate({width: width}, 300, null, function () {
					    if (!options.isExpanded) {
							self.buttonsList.hide();
						}

						self._trigger(self.events[event], e, {owner: self, toolbarElement: self.element, toolbar: {}});
					});
				}
			},
			_setOption: function (name, value) {
				$.Widget.prototype._setOption.apply(this, arguments);

				switch (name) {
				case 'allowCollapsing':
					this.options.allowCollapsing = value;
					break;
				case 'items':
					this._updateItems(value);
					break;
				}
			},
			_isSelectedAction: function (el, props, itemOptionObj) {
				if (props.value) {
					el.addClass("ui-state-active");
				}
			},
			_createItems: function () {
				var o = this.options,
					i,
					self = this,
					itemProps = {},
					newItem,
					tbItemsHash = {
						button: "igToolbarButton",
						combo: "igCombo",
						splitButton: "igSplitButton",
						splitButtonColor: "igColorPickerSplitButton"
					},
					tbItemsPropsTraversing = function (key, property) {
						var scope = o.items[i].scope || self;
						if (property.action !== undefined && $.isFunction(scope[property.action])) {
							scope[property.action](newItem, property, itemProps);
							return;
						}
						itemProps[key] = property.value;
					};
				this.buttonsList.empty();
				for (i = 0; i < o.items.length; i++) {
					itemProps = {};
					newItem = (o.items[i].callbackRenderer() || $('<div tabIndex="0"></div>'))
						.attr("id", this._id("_item_" + o.items[i].name)).appendTo(this.buttonsList);

					$.each(o.items[i].getProperties(), tbItemsPropsTraversing);

					if (tbItemsHash.hasOwnProperty(o.items[i].type)) {
						newItem[tbItemsHash[o.items[i].type]](itemProps);
						continue;
					}
				}
			},
			_updateItems: function (items) {
			    var options = this.options,
					updProps,
					i,
					j,
					scope,
					el,
					key;

				for (i = 0; i < items.length; i++) {
					updProps = items[i].getUpdatedProperties();
					el = this.getItem(items[i].name);
					scope = options.items[i].scope || this;
					for (j = 0; j < updProps.length; j++) {
						if (updProps[j].action !== undefined && $.isFunction(scope[updProps[j].action])) {
							scope[updProps[j].action](el, updProps[j]);
							continue;
						}
						if (items[i] instanceof $.ig.igToolbarButtonDescriptor) {
							el.igToolbarButton("option", key, updProps[j]);
						}

						if (options.items[i] instanceof $.ig.igToolbarComboDescriptor) {
							el.igCombo("option", key, updProps[j]);
						}
					}
				}
			},
			_tooltipAction: function (el, props, itemOptionObj) {
			    if (itemOptionObj !== undefined) {
			        itemOptionObj.title = props.value;
			    } else {
			        el.igToolbarButton("option", "title", props.value);
			    }
			},
			_buttonIconAction: function (el, props, itemOptionObj) {
			    if (itemOptionObj !== undefined) {
			        itemOptionObj.icons = { primary: props.value };
			    } else {
			        el.igToolbarButton("option", "icons", { primary: props.value });
			    }
			},
			_comboDataSourceAction: function (el, props, itemOptionObj) {
			    if (itemOptionObj !== undefined) {
			        itemOptionObj.dataSource = props.value;
			    } else {
			        el.igCombo("option", "dataSource", props.value);
			    }
			},
			_comboWidthAction: function (el, props, itemOptionObj) {
			    if (itemOptionObj !== undefined) {
			        itemOptionObj.width = props.value;
			    } else {
			        el.igCombo("option", "width", props.value);
			    }
			},
			_comboHeightAction: function (el, props, itemOptionObj) {
			    if (itemOptionObj !== undefined) {
			        itemOptionObj.height = props.value;
			    } else {
			        el.igCombo("option", "height", props.value);
			    }
			},
			_spltBtnTooltipAction: function (el, props, itemOptionObj) {

			},
			_comboSelectedItem: function (el, props, itemOptionObj) {
			    if (itemOptionObj !== undefined) {
			        itemOptionObj.selectedItems = [{ value: props.value }];
			    } else {
			        el.igCombo("option", "selectedItems", [{ value: props.value }]);
			    }
			},
			_spltButtonColorAction: function (el, props, itemOptionObj) {
			    if (itemOptionObj !== undefined) {
			        itemOptionObj.defaultColor = props.value;
			    } else {
			        el.igColorPickerSplitButton("option", "defaultColor", props.value);
			    }
			},
			_comboDropDownListWidth: function (el, props, itemOptionObj) {
			    if (itemOptionObj !== undefined) {
			        itemOptionObj.dropDownWidth = props.value;
			    } else {
			        el.igCombo("option", "dropDownWidth", props.value);
			    }
			},
			_getWidgetType: function (el) {
				var data, i;
				if (el === undefined) {
					return;
				}
				data = el.data();
				for (i in data) {
					if (data.hasOwnProperty(i) && data[i].widgetName) {
						return data[i].widgetName;
					}
				}
			},
			_isWidgetSupported: function (name) {
				var i;
				for (i = 0; i < this.supportedWidgets.length; i++) {
					if (this.supportedWidgets[i].name === name) {
						return true;
					}
				}
			},
			_attachEvents: function () {
			    var toolbarItemsEvents = "igtoolbarbuttonclick igsplitbuttonclick igcolorpickersplitbuttoncolorselected";

				this.element.delegate(".ui-widget", toolbarItemsEvents, $.proxy(this._onToolbarItemInteraction, this));
				//Here we bind to igCombo items on click.
				//D.A. 3 Sep. 2013 Bug#150671 Custom combo handler is not called when clicked on the list item.
				//Bound to igcomboselectionchanged event instead of click, because
				//click	was not fired when cliking on the list item's text node.
				this.element.delegate(":ui-igCombo", "igcomboselectionchanged", $.proxy(this._onComboListItemClick, this));
				this.collapseBtn.bind("igtoolbarbuttonclick", $.proxy(this._onCollapse, this));
				//D.U. 30.04.2014 Implementing resizing functionality on window resize
				$(window).on('resize', $.proxy(this._onResize, this));
			},
			_onToolbarItemInteraction: function (e, ui) {
			    var selectedItemValue,
                    targetWidget = $(e.target).parentsUntil(":ui-igToolbar").eq(-2),
					selectedItemIndex,
					triggeredEvent,
					o = this.options;
				// B.C. 5/22/2012. Bug #112445. Fixes the difference between e.target in the different versions of jQuery.
				if (targetWidget.length === 0) {
					targetWidget = $(e.target);
				}
				selectedItemIndex = this.buttonsList.children().index(targetWidget);
				switch (e.type) {
				case 'igtoolbarbuttonclick':
					triggeredEvent = this.events.toolbarButtonClick;
					break;
				default:
					triggeredEvent = this.events.toolbarCustomItemClick;
					selectedItemValue = ui.value;
					break;
				}

				this._trigger(triggeredEvent, e, {
					name: ui.name || o.items[selectedItemIndex].name,
					value: selectedItemValue,
					handler: o.items[selectedItemIndex].handler(),
					scope: o.items[selectedItemIndex].getProperty("scope"),
					itemProperties: o.items[selectedItemIndex].getProperties(),
					toolbarItem: targetWidget,
					toolbarName: o.name
				});
			},
			//D.A. 3 Sep. 2013 Bug#150671 Custom combo handler is not called when clicked on the list item.
			//Bound to igcomboselectionchanged event instead of click, because
			//click	was not fired when cliking on the list item's text node.
			_onComboListItemClick: function (e, data) {
				var toolbarItemIndex, toolbarItem;
				toolbarItemIndex = this.buttonsList.children().index($(e.currentTarget));
				toolbarItem = this.options.items[toolbarItemIndex];
				this._trigger(this.events.toolbarComboSelected, e, {
					name: toolbarItem.name,
					value: data.items[0].value,
					handler: toolbarItem.handler(),
					scope: toolbarItem.getProperty("scope"),
					itemProperties: toolbarItem.getProperties(),
					toolbarItem: data.owner,
					toolbarName: this.options.name
				});
			},
			//D.U. 30.04.2014 Implement funtionality for resizing on window resize
			_onResize: function(e, data){
				var thereAreHiddedButtons;

				while(this.element.parent().width() <= this.element.width()){
					this._hideButtonFromToolbar();
				}

				thereAreHiddedButtons = this._hiddenButtons != undefined && this._hiddenButtons.length > 0;

				while(thereAreHiddedButtons && this.element.parent().width() > this.element.width() + this._hiddenButtons[this._hiddenButtons.length-1].width()){
					this._showHiddenButtonFromToolbar();
					thereAreHiddedButtons = this._hiddenButtons != undefined && this._hiddenButtons.length > 0;
				}		


				this._trigger(this.events.windowResized);
			},
			//D.U. 30.04.2014 Implement funtionality for resizing on window resize
			_hideButtonFromToolbar: function(){
				var buttonToHide,
					lastPossibleButtonIndex, 
					buttons = this.element.find('.' + this.css.igToolbarButtonsHolder).children();

				if(this._hiddenButtons == undefined) {
					this._hiddenButtons = [];
				}

				lastPossibleButtonIndex = buttons.length-1-this._hiddenButtons.length;	
						
				buttonToHide = $(buttons[lastPossibleButtonIndex]);	

				while(!buttonToHide.is(":visible")){
					buttonToHide = buttons[lastPossibleButtonIndex];
					lastPossibleButtonIndex = buttons.length-1-this._hiddenButtons.length;
				}

				buttonToHide.hide();

				this._hiddenButtons.push(buttonToHide);
			},
			//D.U. 30.04.2014 Implement funtionality for resizing on window resize
			_showHiddenButtonFromToolbar: function(){
				this._hiddenButtons[this._hiddenButtons.length-1].show();
				this._hiddenButtons.pop();
			},
			getItem: function (index) {
			    /*
                    Gets the item with provided index.
                    paramType="string|numerical" optional="false". The index of the item.
                    returnType="object" item with the provided index.
                */
				var result;
				if (!isNaN(parseInt(index, 10))) {
				    return this.buttonsList.children().eq(index);
				}
				if (typeof index === "string") {
					result = this.buttonsList.find('#' + this._id("_item_" + index));
					if (result.length) {
						return result;
					}
				}
			},
			addItem: function (item) {
			/*
                Add item to widget item array
                paramType="object" optional="false". The item to be added.
            */
				if (this._isWidgetSupported(item.type)) {
					this.options.items.push(item);
					this._createItems();
					this._trigger(this.events.itemAdded);
				}
			},
			removeItem: function (index) {
			    /*
                    Remove the item matching provided index.
                    paramType="string|numerical" optional="false". The index of the item.
                    returnType="object" item with the provided index.
                */
				this.buttonsList.eq(index).remove();
				this._trigger(this.events.itemremoved);
			},
			disableItem: function (index, disabled) {
			    /*
                    Disable item matching provided index.
                    paramType="string|numerical" optional="false". The index of the item.
                    paramType="string|numerical" optional="false". The disabled property value.
                */
				var item = this.getItem(index),
					widgetType = this._getWidgetType(item);
				if (widgetType) {
					item[this._getWidgetType(item)]("option", "disabled", disabled);
					this._trigger(this.events.itemDisable, {isDisabled: disabled});
				}
			},
			activateItem: function (index, activated) {
			    /*
                    Activate item matching provided index.
                    paramType="string|numerical" optional="false". The index of the item.
                    paramType="string|numerical" optional="false". The activate property value.
                */
				var item = this.getItem(index),
					action = activated ? item.addClass : item.removeClass;

				action.call(this, "ui-state-active");
				item.igToolbarButton("options", "isSelected", activated);
				this._trigger(this.events.itemActivated, {isActivated: activated});
			},
			deactivateAll: function () {
			    /*
                    Deactivate all buttons.
                */
				this.buttonsList
					.find(".ui-igbutton.ui-state-active")
					.removeClass("ui-state-active")
					.igToolbarButton("option", "isSelected", false);
			},
			_setCollapseExpandButtonIcon: function () {
				if (this.options.collapseButtonIcon) {
					this.collapseBtn.switchClass('ui-icon-triangle-1-w', this.options.collapseButtonIcon);
				}
			},
			destroy: function () {
			    /*
                    Destroy the widget.
                */
				$.Widget.prototype.destroy.apply(this, arguments);

				this.element.undelegate();
				this.element.unbind();
				delete this.buttonsList;
				delete this.collapseBtn;
				delete this.toolbarBody;

				this.element.remove();
			}
	});

	$.extend($.ui.igToolbar, { version: '14.1.20141.2249' });
}(jQuery));
/*!@license
 * Infragistics.Web.ClientUI Tile Manager 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *  jquery-1.8.0.js
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	infragistics.templating.js
 *	infragistics.dataSource.js
 *	infragistics.util.js
 *  infragistics.ui.splitter.js
 *	infragistics.ui.layoutmanager.js
 *	infragistics.ui.tilemanager-en.js
 */

/*global jQuery, Modernizr, window*/
(function ($) {
    /*
		igTileManager is a widget based on jQuery UI that instantiates itself on existing markup or on any $.ig.DataSource supported data source
		type. The igTileManager control provides the functionality of wrapping content in a tile view and displaying them in a fully responsive
		grid layout.
	*/
    $.widget("ui.igTileManager", {
        css: {
            /* classes applied to the top container element */
            container: 'ui-widget ui-igtilemanager ui-widget-content',
            /* classes applied to the left panel */
            leftPanel: 'ui-igtilemanager-left',
            /* classes applied to the right panel */
            rightPanel: 'ui-igtilemanager-right',
            /* classes applied to the tile header element */
            header: 'ui-widget-header ui-igtile-header',
            /* classes applied to the tile content element */
            content: 'ui-widget-content ui-igtile',
            /* classes applied to the tile content inner container element */
            innerContainer: 'ui-igtile-inner-container',
            /* classes applied to the tiles in minimized state */
            minimized: 'ui-igtile-minimized',
            /* classes applied to the tiles in maximized state */
            maximized: 'ui-igtile-maximized',
            /* classes applied to the minimize button when a tile is in maximized state */
            minimizeButton: 'ig-button ig-tile-minimize-button',
            /* classes applied to the tile minimize button icon element in the header */
            minimizeIcon: 'ui-icon ig-tile-minimize-icon',
            /* class applied to the tile button elements when hovered */
            hoverClass: 'ui-state-hover',
            /* class applied to hide elements */
            hidden: 'ui-helper-hidden',
            /* class applied to hide scrollbars */
            overflowHidden: 'ui-helper-overflow-hidden',
            /* class applied to show overflowing elements */
            overflowVisible: 'ui-helper-overflow-visible',
            /* class applied set element visibility to hidden */
            visibilityHidden: 'ui-helper-visibility-hidden',
            /* class applied to right panel disabling the scroll while width is zero */
            splitterNoScroll: 'ui-igsplitter-no-scroll'
        },
        options: {
            /* type="string|number|null Gets sets the width of the container."
                string The container width can be set in pixels (px) and percentage (%).
                number The container width can be set as a number in pixels.
                null The default container width will be used.
            */
            width: null,
            /* type="string|number|null" Gets sets the height of the container.
                string The height width can be set in pixels (px) and percentage (%).
                number The height width can be set as a number in pixels.
                null The default container height will be used.
            */
            height: null,
            /* type="string|number|null" Gets sets the width of each column in the container.
                string The column width can be set in pixels (px) or percentage (%).
                number The column width can be set as a number representing value in pixels.
                null The column width will be calculated based on the container width and the other options.
            */
            columnWidth: null,
            /* type="string|number|null" The height of each column in the container.
                string The column height can be set in pixels (px) or percentage (%).
                number The column height can be set as a number representing value in pixels.
                null The column height will be calculated based on the container height and the other options.
            */
            columnHeight: null,
            /* type="number|null" Gets sets the columns count in the container.
                number The column count can be set as a number.
                null The column count will be automatically calculated.
            */
            cols: null,
            /* type="number|null" Gets sets the rows count in the container.
                number The row count can be set as a number.
                null The row count will be automatically calculated.
            */
            rows: null,
            /* type="number" Gets sets the horizontal spacing between tiles.
                number The horizontal spacing between tiles can be set as a number.
            */
            marginLeft: 0,
            /* type="number" Gets sets the vertical spacing between tiles.
                number The vertical spacing between tiles can be set as a number.
            */
            marginTop: 0,
            /* type="boolean" Gets sets whether the items will rearrange when the container is resized. */
            rearrangeItems: true,
            /* type="array|null" Gets sets the tiles configurations. Every tile is described by rowSpan, colSpan, rowIndex and colIndex.
                array An array with colSpan, rowSpan, colIndex, rowIndex configurations for each tile.
                null Default tile configurations of rowSpan: 1 and colSpan: 1 will be used.
            */
            items: null,
            /* type="object" Specifies any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself. */
            dataSource: null,
            /* type="string|null" Gets sets the content of the tiles in minimized state.
                string When initializing on html markup provide jQuery selector specifying what content of the tile to be shown in minimized state. When initializing on data source provide igTemplate that will be rendered for the minimized state.
                null The whole content of the tile will be visible in minimized state.
            */
            minimizedState: null,
            /* type="string|null" Gets sets the content of the tiles in maximized state.
                string When initializing on html markup provide jQuery selector specifying which elements of the tile to be shown in maximized state. When initializing on data source provide igTemplate that will be rendered for the maximized state.
                null The whole content of the tile will be visible in maximized state.
            */
            maximizedState: null,
            /* type="number|null" Gets sets the index of which items configuration will be used for positioning and sizing of the maximized tile.
                number The maximizedTileindex can be set as a number.
                null Option is ignored.
            */
            maximizedTileIndex: null,
            // TODO: Implement custom tile selector
            /* type="string" Selector that specifies which elements to be considered as tiles when initializing from html markup. */
            //tileSelector: null,
            /* type="number|null" Gets sets how many columns to be displayed in the right panel when the tiles are minimized.
                number Set the number of right panel columns as a number. The minimum value is 1.
                null Default of 1 column will be used.
            */
            rightPanelCols: 1,
            /* type="number|null" Gets sets the width of the minimized tiles in the right panel.
                number Set the width of the minimized tiles as a number.
                null Default value equal to the column width will be used.
            */
            rightPanelTilesWidth: null,
            /* type="number|null" Gets sets the height of the minimized tiles in the right panel.
                number Set the height of the minimized tiles as a number.
                null Default value equal to the column height will be used.
            */
            rightPanelTilesHeight: null,
            /* type="boolean" Gets sets whether the right panel should show scrollbar when tiles are overflowing. */
            showRightPanelScroll: true,
            /* type="boolean" Gets sets whether the splitter should be shown. */
            showSplitter: true,
            /* type="string" Gets sets JQuery selector that specifies which elements will not trigger maximizing when clicked on. */
            preventMaximizingSelector: 'a, input',
            /* type="number" Gets sets the duration of the animations in the tile manager. */
            animationDuration: 500,
            /* type="string" Specifies a remote URL accepted by $.ig.DataSource in order to request data from it. */
            dataSourceUrl: null,
            /* type="string|null" see $.ig.DataSource.
				string Specifies the name of the property in which data records are held if the response is wrapped. 
				null Option is ignored.
			*/
            responseDataKey: null,
            /* type="string"
				string Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property.
				null Option is ignored.
			*/
            responseDataType: null,
            /* type="string" Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property. */
            dataSourceType: null,
            /* type="string" specifies the HTTP verb to be used to issue the request. */
            requestType: "GET",
            /* type="string" content type of the response. See http://api.jquery.com/jQuery.ajax/ => contentType. */
            responseContentType: null
        },
        events: {
            /* cancel="true" fired before databinding is performed 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tile manager performing databinding.
				Use ui.dataSource to get a reference to the $.ig.DataSource the tile manager is to be databound to.
			*/
            dataBinding: 'dataBinding',
            /* cancel="false" fired after databinding is complete 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tile manager performing databinding.
				Use ui.dataView to get a reference to the data the tile manager is databound to.
				Use ui.success to get see if the databinding was performed correctly.
				Use ui.errorMessage to get the error message if the databinding failed.
			*/
            dataBound: 'dataBound',
            /* cancel="true" fired before rendering of the tile manager begins.
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tile manager performing rendering.
				Use ui.tiles to get a reference to the tiles the tile manager is going to render. If using data source this referes to the data provided.
				Use ui.items to get a reference to the item configurations the tile manager has.
			*/
            rendering: 'rendering',
            /* cancel="false" fired after rendering of the tile manager completes. 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tile manager performing rendering.
			*/
            rendered: 'rendered',
            /* cancel="true" Event fired before a tile is rendered in the container
                Function takes arguments evt and ui.
                Use ui.owner to get a reference to the tile manager performing rendering.
                Use ui.tile to get a reference to the tile being rendered
            */
            tileRendering: "tileRendering",
            /* Event fired after a tile has been rendered in the container
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tile manager performing rendering.
				Use ui.tile to get a reference to the rendered tile
			*/
            tileRendered: "tileRendered",
            /* cancel="true" fired before a tile in the tile manager is maximized.
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tile manager performing the maximizing the tile belongs to.
				Use ui.tile to get the jQuery element of the tile being maximized
                Use ui.minimizingTile to get reference to the tile that is minimizing simultaneously or null if no tile is minimizing.
			*/
            tileMaximizing: 'tileMaximizing',
            /* cancel="false" fired after a tile in the tile manager is maximized. 
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tile manager the maximized tile belongs to.
				Use ui.tile to get the jQuery element of the maximized tile
			*/
            tileMaximized: 'tileMaximized',
            /* cancel="true" fired before a tile in the tile manager is minimized.
                Function takes arguments evt and ui.
                Use ui.owner to get a reference to the tile manager performing the minimizing the tile belongs to.
                Use ui.tile to get the jQuery element of the tile being minimized
                Use ui.maximizingTile to get reference to the tile that is maximizing simultaneously or null if no tile is maximizing.
            */
            tileMinimizing: 'tileMinimizing',
            /* cancel="false" fired after a tile in the tile manager is minimized.
				Function takes arguments evt and ui.
				Use ui.owner to get a reference to the tile manager the minimized tile belongs to.
				Use ui.tile to get the jQuery element of the minimized tile
			*/
            tileMinimized: 'tileMinimized'
        },
        // Selectors
        _selectors: {
            tileSelector: '.ui-igtile',
            minimizedTileSelector: '.ui-igtile-minimized',
            minimizeBtnSelector: '.ig-tile-minimize-button',
            minimizeIconSelector: '.ig-tile-minimize-icon',
            leftPanelSelector: '.ui-igtilemanager-left',
            rightPanelSelector: '.ui-igtilemanager-right',
            splitbarSelector: '.ui-igsplitter-splitbar-vertical',
            innerContainerSelector: '.ui-igtile-inner-container'
        },
        _createWidget: function (options, element) {
            $.Widget.prototype._createWidget.apply(this, arguments);
        },
        _create: function () {
            var opt = this.options;

            this._options = {
                $tiles: null,
                $maximizedTile: null,
                $leftPanel: null,
                $rightPanel: null,
                $layoutManagerElement: null, // The element on which the layout manager was instantiated
                fromMarkup: false,
                animating: false,
                useMaximizedTileIndex: false,
                rightPanelWidth: 0,
                gridLayout: null, // Reference to the internal layout manger's gridLayout options
                elementHandlers: {},
                windowHandlers: {}
            };

            this.element.addClass(this.css.container);

            if (opt.width) {
                this.element.css('width', opt.width);
            }

            if (opt.height) {
                this.element.css('height', opt.height);
            }

            // Set the default tile selector if such was not given
            this.options.tileSelector = this.options.tileSelector ||
                this._selectors.tileSelector;

            if (opt.dataSource !== null) {
                this.dataBind();
            } else {
                this._options.fromMarkup = true;
                this._initFromMarkup();
            }

            this._attachEvents();
        },
        _setOption: function (option, value) {
            if (this.options[option] === value) {
                return;
            }

            var self = this,
                _opt = this._options,
                i, len, items, sortedItems, glOption;

            $.Widget.prototype._setOption.apply(this, arguments);
            switch (option) {
            case 'dataSource':
                this.dataBind();
                break;
            case 'dataSourceUrl':
                this.dataBind();
                break;
            case 'width':
                if (!_opt.useMaximizedTileIndex) {
                    this.minimize(0);
                }
                this.element.width(this.options.width);
                this.reflow(true, 0);
                break;
            case 'height':
                if (!_opt.useMaximizedTileIndex) {
                    this.minimize(0);
                }
                this.element.height(this.options.height);
                this.reflow(true, 0);
                break;
            case 'columnWidth':
            case 'columnHeight':
            case 'cols':
            case 'rows':
            case 'marginLeft':
            case 'marginTop':
            case 'rearrangeItems':
                // D.A. 9th July 2014, Bug #174952 Setting the 'cols' 
                // option while a tile is maximized breaks the control.
                if (!_opt.useMaximizedTileIndex) {
                    this.minimize(0);
                }

                glOption = {};
                glOption[option] = value;

                _opt.$layoutManagerElement.igLayoutManager(
                    'option', 'gridLayout', glOption);

                // Update the reference to the Layout Manager's internal gridLayout options
                _opt.gridLayout = this.layoutManager()._opt.gridLayout;
                break;
            case 'items':
                // TODO: Implement setting items number different than the number of tiles
                if (value.length !== _opt.$tiles.length) {
                    throw new Error($.ig.TileManager.locale.setOptionItemsLengthError);
                }

                if (_opt.useMaximizedTileIndex) {

                    // Preserve the items order
                    // When setting new items configuration with maximizedTileIndex option
                    // The configuration will be applied according to the tiles current position
                    // This is necessary when the maximziedTileIndex is used because the tiles can swap places.
                    // E.g. the first item configuration will be applied to the tile that is
                    // in the first position at the moment when set option is called.
                    items = $.extend(true, [], this._options.gridLayout.items);
                    sortedItems = $.extend(true, [], this._options.gridLayout.sortedItems);
                } else {
                    this.minimize(0);
                }

                _opt.$layoutManagerElement.igLayoutManager('option', 'items', this.options.items);
                _opt.gridLayout = this.layoutManager()._opt.gridLayout;

                if (_opt.useMaximizedTileIndex) {
                    len = _opt.gridLayout.items.length;

                    // Update the item configuration links to preserve the items order
                    for (i = 0; i < len; i++) {
                        _opt.gridLayout.items[i].item = items[i].item;
                        _opt.gridLayout.sortedItems[i].item = $.extend(true, {}, sortedItems[i].item);
                        _opt.gridLayout.initialSortedItems[i].item = $.extend(true, {}, sortedItems[i].item);
                    }
                }

                this.reflow(true, 0);
                break;
            case 'minimizedState':
                _opt.$tiles.not(_opt.$maximizedTile).each(function () {
                    self._toMinimizedState($(this));
                });
                break;
            case 'maximizedState':
                if (_opt.$maximizedTile) {
                    this._toMaximizedState(_opt.$maximizedTile);
                }
                break;
            case 'maximizedTileIndex':
                this._toMinimizedState(_opt.$maximizedTile);
                _opt.$maximizedTile = _opt.$tiles.filter(
                    '[data-index=' + this.options.maximizedTileIndex + ']');
                this._toMaximizedState(_opt.$maximizedTile);
                break;
            case 'rightPanelCols':
                if (_opt.$maximizedTile && !_opt.useMaximizedTileIndex) {
                    this._setRightPanelSize();
                    this._positionRightPanelTiles(_opt.$tiles.not(_opt.$maximizedTile),
                        parseInt(_opt.$maximizedTile.attr('data-index'), 10), false, false, null);
                }
                break;
            case 'rightPanelTilesWidth':
                if (_opt.$maximizedTile && !_opt.useMaximizedTileIndex) {
                    this._setRightPanelSize();
                    this._positionRightPanelTiles(_opt.$tiles.not(_opt.$maximizedTile),
                        parseInt(_opt.$maximizedTile.attr('data-index'), 10), false, true, null);
                }
                break;
            case 'rightPanelTilesHeight':
                if (_opt.$maximizedTile && !_opt.useMaximizedTileIndex) {
                    this._setRightPanelSize();
                    this._positionRightPanelTiles(_opt.$tiles.not(_opt.$maximizedTile),
                        parseInt(_opt.$maximizedTile.attr('data-index'), 10), false, true, null);
                }
                break;
            case 'showRightPanelScroll':
                if (!_opt.useMaximizedTileIndex) {
                    if (value) {
                        _opt.$rightPanel.removeClass(this.css.overflowHidden);
                    } else {
                        _opt.$rightPanel.addClass(this.css.overflowHidden);
                    }

                    if (_opt.$maximizedTile) {
                        this._setRightPanelSize();
                    }
                }
                break;
            case 'showSplitter':
                if (this.options.showSplitter) {
                    this.element
                        .children(this._selectors.splitbarSelector)
                            .removeClass(this.css.visibilityHidden);
                } else {
                    this.element
                        .children(this._selectors.splitbarSelector)
                            .addClass(this.css.visibilityHidden);
                }
                break;
            case 'animationDuration':
                // Update the animation duration in the layout manager
                this.layoutManager().options.gridLayout.animationDuration = value;
                break;
            default:
                break;
            }
        },
        _initFromMarkup: function () {
            var $tiles,
                $children = this.element.children(),
                $filtered = $children.filter(this.options.tileSelector);

            // Tiles are rendered for elements matching the tile selector.
            if ($filtered.length) {
                $tiles = $filtered;
                $children
                    .not($tiles)
                        .addClass(this.css.hidden);
            } else {

                // Tiles are rendered for all elements when no match is found.
                $tiles = this.element.children();
            }

            // Wrap all tiles with div elements.
            // The Layout manager uses them for its initialization.
            $tiles.wrap("<div>");
            this._initLayoutManager($tiles);
        },
        _renderData: function (success, msg, data) {
            var _opt = this._options;

            this._triggerDataBound(success, msg, data._data);

            if (success) {

                // Destroy layout manager and splitter in case of rebinding
                if (_opt.$layoutManagerElement) {
                    _opt.$layoutManagerElement.igLayoutManager('destroy');
                    if (!_opt.useMaximizedTileIndex) {
                        this.element.igSplitter('destroy');
                    }
                    this._resetInternalOptions();
                }
                this.element.empty();
                this._initLayoutManager(data._data);
            } else {
                throw new Error($.ig.TileManager.locale.renderDataError);
            }
        },
        _resetInternalOptions: function () {
            var _opt = this._options;

            _opt.gridLayout = null;
            _opt.$layoutManagerElement = null;
            _opt.$leftPanel = null;
            _opt.$rightPanel = null;
            _opt.$maximizedTile = null;
            _opt.$tiles = null;
            _opt.animating = false;
        },
        _initDataSource: function () {
            var opt = this.options,
                dataOpt;

            if (!opt.dataSource && opt.dataSourceUrl) {
                opt.dataSource = opt.dataSourceUrl;
            }

            if (!(opt.dataSource instanceof $.ig.DataSource)) {
                dataOpt = {
                    callback: this._renderData,
                    callee: this,
                    dataSource: opt.dataSource,
                    requestType: opt.requestType,
                    responseContentType: opt.responseContentType,
                    responseDataType: opt.responseDataType,
                    localSchemaTransform: false
                };

                if (opt.responseDataKey) {
                    dataOpt.responseDataKey = opt.responseDataKey;
                }

                if (opt.dataSourceType) {
                    dataOpt.dataSourceType = opt.dataSourceType;
                }

                opt.dataSource = new $.ig.DataSource(dataOpt);
            }
        },
        _tileRendered: function (event, ui) {
            var _opt = this._options,
                $tile = ui.item,
                renderMaximizedState = _opt.useMaximizedTileIndex &&
                    this.options.maximizedTileIndex === ui.index,
                $innerContainer;

            if (_opt.fromMarkup) {
                $innerContainer = $tile.children();

                if (!_opt.useMaximizedTileIndex) {
                    $innerContainer
                        .prepend(this._renderMinimizeButton());
                }

                if (renderMaximizedState) {
                    if (this.options.maximizedState) {

                        // Hide all but maximized state markup
                        $innerContainer
                            .children()
                                .not(this.options.maximizedState)
                                    .addClass(this.css.hidden);
                    }
                } else if (this.options.minimizedState) {

                    // Hide all but minimized state markup
                    $innerContainer
                        .children()
                            .not(this.options.minimizedState)
                                .addClass(this.css.hidden);
                }
            } else {

                // Render the inner container when from data source
                $innerContainer = $('<div/>').appendTo($tile);

                if (renderMaximizedState) {
                    $innerContainer
                        .html(this._renderMaximizedState(ui.index));
                } else {
                    $innerContainer
                        .html(this._renderMinimizedState(ui.index));
                }
            }

            $innerContainer.addClass(this.css.innerContainer);
            $tile
                .addClass(this.css.content)
                .addClass(renderMaximizedState ? this.css.maximized : this.css.minimized);

            this._triggerTileRendered(event, ui);
        },
        _initLayoutManager: function ($tiles) {
            var self = this,
                opt = this.options,
                _opt = this._options,
                items = [],
                lengthDiff, noCancel, i;

            if (opt.items) {
                $.extend(items, opt.items);
            }

            // Equalize the length of the tiles and items
            if ($tiles.length > items.length) {
                lengthDiff = $tiles.length - items.length;

                for (i = 0; i < lengthDiff; i++) {

                    // Add item for each tile to be rendered.
                    // The Layout manager expects item config for each tile.
                    items.push({});
                }
            } else {

                // When the tiles are less than the tile configurations 
                // remove the not used configurations
                items.splice($tiles.length);
            }

            noCancel = this._triggerRendering($tiles, items);
            if (noCancel) {
                if (!(typeof opt.maximizedTileIndex === 'number' &&
                        $tiles.length >= opt.maximizedTileIndex)) {

                    // Add panels and render the splitter
                    this._addPanels();

                    // Set overflow hidden before the tiles are rendered.
                    // Scrollbars could be caused by the initial markup in the element.
                    _opt.$leftPanel.addClass(this.css.overflowHidden);

                    this._renderSplitter();

                    // Store the layout manager element
                    _opt.$layoutManagerElement = _opt.$leftPanel;

                    // Initialize the layoutManager on the leftPanel
                    _opt.$leftPanel.igLayoutManager($.extend(true, {}, {
                        layoutMode: 'grid',
                        items: items,
                        gridLayout: {
                            columnWidth: opt.columnWidth,
                            columnHeight: opt.columnHeight,
                            cols: opt.cols,
                            rows: opt.rows,
                            marginLeft: opt.marginLeft,
                            marginTop: opt.marginTop,
                            rearrangeItems: opt.rearrangeItems,
                            animationDuration: opt.animationDuration,
                            overrideConfigOnSetOption: false,
                            useOffset: false
                        },
                        itemRendered: function (event, ui) {
                            noCancel = self._triggerTileRendering(event, ui);
                            if (noCancel) {
                                self._tileRendered(event, ui);
                            }
                        },
                        rendered: function (event, ui) {

                            // Remove the overflow hidden when the tiles are rendered
                            // and before the layout manager reflow is called.
                            _opt.$leftPanel.removeClass(self.css.overflowHidden);

                            // Store the rendered by the layout manager tiles in _opt.$tiles
                            _opt.$tiles = $(this).data('igLayoutManager')._opt.gridLayout.elements;
                            self._triggerRendered();
                        },
                        internalResizing: function (event, ui) {

                            // Cancel the event when maximized tile is present
                            if (_opt.$maximizedTile) {
                                return false;
                            }
                        },
                        internalResized: function (event, ui) {

                            // When the internalResized was triggered by the minimize method call.
                            // Reset the maximized tile and trigger the tile minimized event.
                            if (_opt.$maximizedTile) {
                                _opt.animating = false;
                                if (event) {
                                    self._triggerTileMinimized(event, _opt.$maximizedTile);
                                }
                                _opt.$maximizedTile = null;
                            }
                        }
                    }));
                } else {
                    _opt.useMaximizedTileIndex = true;

                    // Set overflow hidden before the tiles are rendered.
                    // Scrollbars could be caused by the initial markup in the element.
                    this.element.addClass(this.css.overflowHidden);

                    // Store the layout manager element
                    _opt.$layoutManagerElement = this.element;

                    // Initialize the layoutManager on the element
                    this.element.igLayoutManager($.extend(true, {}, {
                        layoutMode: 'grid',
                        items: items,
                        gridLayout: {
                            columnWidth: opt.columnWidth,
                            columnHeight: opt.columnHeight,
                            cols: opt.cols,
                            rows: opt.rows,
                            marginLeft: opt.marginLeft,
                            marginTop: opt.marginTop,
                            rearrangeItems: opt.rearrangeItems,
                            animationDuration: opt.animationDuration,
                            overrideConfigOnSetOption: false,
                            useOffset: false
                        },
                        itemRendered: function (event, ui) {
                            noCancel = self._triggerTileRendering(event, ui);
                            if (noCancel) {
                                self._tileRendered(event, ui);
                            }
                        },
                        rendered: function (event, ui) {

                            // Remove the overflow hidden when the tiles are rendered
                            // and before the layout manager reflow is called.
                            self.element.removeClass(self.css.overflowHidden);

                            // Store the rendered by the layout manager tiles in _opt.$tiles
                            _opt.$tiles = $(this).data('igLayoutManager')._opt.gridLayout.elements;
                            self._triggerRendered();
                        }
                    }));

                    _opt.$maximizedTile = _opt.$tiles.filter(
                        '[data-index=' + opt.maximizedTileIndex + ']');
                }

                // Save reference to the Layout Manager's internal gridLayout options
                _opt.gridLayout = this.layoutManager()._opt.gridLayout;
            }
        },
        _toMaximizedState: function ($tile) {
            var $innerContChildren,
                $innerContainer = $tile.children(this._selectors.innerContainerSelector);

            $tile
                .removeClass(this.css.minimized)
                .addClass(this.css.maximized);

            if (!this._options.fromMarkup) {

                // Render the maximized template if from data source
                $innerContainer
                    .html((this._options.useMaximizedTileIndex ? "" : this._renderMinimizeButton()) +
                        this._renderMaximizedState($tile.attr('data-index')));
            } else {
                $innerContChildren = $innerContainer.children();

                if (this.options.maximizedState) {

                    // Hide all elements
                    $innerContChildren
                        .not(this.options.maximizedState)
                            .addClass(this.css.hidden);

                    // Show only maximized state markup and the minimize button
                    $innerContChildren
                        .filter(this.options.maximizedState +
                            ', ' + this._selectors.minimizeBtnSelector)
                            .removeClass(this.css.hidden);
                } else {

                    // Show all elements when the maximizedState option is not used
                    $innerContChildren.removeClass(this.css.hidden);
                }
            }
        },
        _toMinimizedState: function ($tile) {
            var $innerContainer = $tile.children(this._selectors.innerContainerSelector),
                $minimizedState,
                $children;

            $tile
                .removeClass(this.css.maximized)
                .addClass(this.css.minimized);

            if (!this._options.fromMarkup) {

                // Render the minimized template if from data source
                $innerContainer
                    .html(this._renderMinimizedState($tile.attr('data-index')));
            } else {
                $children = $innerContainer.children();

                if (this.options.minimizedState) {
                    $minimizedState = $children.filter(this.options.minimizedState);

                    // Hide all elements
                    $children
                        .not($minimizedState)
                            .addClass(this.css.hidden);

                    // Show only minimized state markup
                    $minimizedState.removeClass(this.css.hidden);
                } else {

                    // Show all elements when no minimized state is given
                    $children.removeClass(this.css.hidden);
                }
            }
        },
        _renderMaximizedState: function (index) {
            return this.options.maximizedState ?
                $.ig.tmpl(this.options.maximizedState, this.options.dataSource.data()[index]) :
                this._renderMinimizedState(index);
        },
        _renderMinimizedState: function (index) {
            return this.options.minimizedState ?
                $.ig.tmpl(this.options.minimizedState, this.options.dataSource.data()[index]) :
                "";
        },
        _renderMinimizeButton: function () {
            return '<span class="' + this.css.minimizeButton + '">' +
                '<span class="' + this.css.minimizeIcon + '"></span></span>';
        },
        _addPanels: function () {
            var _opt = this._options,
                markup = this.element.children(),
                $leftPanel = $('<div/>').addClass(this.css.leftPanel),
                $rightPanel = $('<div/>').addClass(
                    this.css.rightPanel + ' ' + this.css.hidden);

            $leftPanel.appendTo(this.element);
            $rightPanel.appendTo(this.element);

            _opt.$leftPanel = $leftPanel;
            _opt.$rightPanel = $rightPanel;

            if (!this.options.showRightPanelScroll) {
                _opt.$rightPanel.addClass(this.css.overflowHidden);
            }

            // Move the markup to the left panel
            markup.appendTo(_opt.$leftPanel);
        },
        // Removes the panels
        // Appends the initial markup back to the main container
        _removePanels: function () {
            this.element
                .children(this._selectors.leftPanelSelector)
                    .children()
                        .appendTo(this.element);

            this.element
                .children(this._selectors.leftPanelSelector + ', ' +
                    this._selectors.rightPanelSelector)
                    .remove();

            this._options.$leftPanel = null;
            this._options.$rightPanel = null;
        },
        _renderSplitter: function () {
            var self = this,
                _opt = this._options;

            this.element.igSplitter({
                panels: [{ size: '100%' }],
                // D.A. 29th April 2014, Bug #164471 Maximizing a tile causes all tile manager's on the same page to resize their containers.
                resizeOtherSplitters: false,
                layoutRefreshing: function () {

                    // D.A. 10th July 2013. Bug#146523 Cancel the splitter layoutRefreshing
                    // event which caused panels resizing. That would lead to scrollbars and
                    // incorrect sizing of the tiles when the layout manager reflow is called
                    return false;
                },
                resizeStarted: function () {
                    _opt.rightPanelWidth = _opt.$rightPanel.width();
                },
                resizeEnded: function () {
                    var gl = _opt.gridLayout,
                        rightPanelWidth = _opt.$rightPanel.width(),
                        rightPanelTilesWidth = self._getRightPanelTilesWidth(),
                        rightPanelTilesHeight = self._getRightPanelTilesHeight(),
                        $tiles = _opt.$tiles.not(_opt.$maximizedTile),
                        rightPanelCols, oldRightPanelCols, rightPanelHasScroll;

                    if (_opt.rightPanelWidth > rightPanelWidth) {

                        // Round down cols when user reduces the width
                        rightPanelCols = Math.floor(rightPanelWidth /
                            (rightPanelTilesWidth + gl.marginLeft));
                    } else {

                        // Round up cols when user increases the width
                        rightPanelCols = Math.ceil(rightPanelWidth /
                            (rightPanelTilesWidth + gl.marginLeft));
                    }

                    // Detect whether the right panel will have scroll after the animation
                    rightPanelHasScroll = self.options.showRightPanelScroll &&
                        (Math.ceil($tiles.length / rightPanelCols) *
                        (rightPanelTilesHeight + gl.marginTop)) >
                        _opt.$rightPanel.height();

                    // Recalculate the cols when the panel has scroll
                    if (rightPanelHasScroll) {
                        if (_opt.rightPanelWidth > rightPanelWidth) {

                            // Round down cols when user reduces the width
                            rightPanelCols = Math.floor((rightPanelWidth -
                                $.ig.util.getScrollWidth()) /
                                (rightPanelTilesWidth + gl.marginLeft));
                        } else {

                            // Round up cols when user increases the width
                            rightPanelCols = Math.ceil((rightPanelWidth -
                                $.ig.util.getScrollWidth()) /
                                (rightPanelTilesWidth + gl.marginLeft));
                        }
                    }

                    oldRightPanelCols = self.options.rightPanelCols;
                    self.options.rightPanelCols = rightPanelCols;
                    self._setRightPanelSize();

                    // Resize only if the new size wasn't changed by _setRightPanelSize
                    if (oldRightPanelCols !== self.options.rightPanelCols) {
                        self._positionRightPanelTiles($tiles, parseInt(
                            _opt.$maximizedTile.attr('data-index'), 10), false, false, null);
                    }

                    _opt.rightPanelWidth = rightPanelWidth;
                }
            });

            // Hide the splitter on init
            this._hideSplitterElements();
        },
        _attachEvents: function () {
            var self = this,
                _opt = this._options,
                minimizeBtnSelector = this._selectors.minimizeBtnSelector,
                minimizedTileSelector = this._selectors.minimizedTileSelector,
                splitter = this.splitter(),
                elHandlers = _opt.elementHandlers,
                noCancel;

            // Event handler for click on the minimized tiles
            elHandlers.minimizedTileClick = function (event) {
                var $target = $(event.target),
                    $tileToMaximize = $(this);

                self._stopEventPropagation(event);

                // Prevent maximizing when the event target matches the preventMaximizingSelector
                if ($target.is(self.options.preventMaximizingSelector)) {
                    return;
                }

                // Trigger maximize event
                if (!_opt.animating) {
                    _opt.animating = true;
                    $tileToMaximize.removeClass(self.css.hoverClass);
                    noCancel = self._triggerTileMaximizing(event, $tileToMaximize);

                    if (_opt.$maximizedTile) {

                        // Trigger minimizing when another maximized tile is present.
                        self._triggerTileMinimizing(
                            event, _opt.$maximizedTile, $tileToMaximize);
                    }

                    if (noCancel) {
                        self.maximize($tileToMaximize, event);
                    } else {
                        _opt.animating = false;
                    }
                }
            };

            // Event handler for mouse over the minimized tiles
            elHandlers.miminimizedTileMouseOver = function (event) {
                self._stopEventPropagation(event);

                // D.A Bug #145029 Do not add the hover effect when the
                // animation is in progress or the splitter is dragged
                if (!(_opt.animating || (splitter && splitter._isDrag))) {
                    $(this).addClass(self.css.hoverClass);
                }
            };

            // Event handler for mouse out of the minimized tiles
            elHandlers.minimizedTileMouseOut = function (event) {
                self._stopEventPropagation(event);
                $(this).removeClass(self.css.hoverClass);
            };

            // Event handler for click on the minimize button
            elHandlers.minimizeBtnClick = function (event) {

                // Stop minimize button click propagation. If the animation duration is set to 0 and
                // the event is not stopped, then minimize followed by maximize is triggered.
                self._stopEventPropagation(event);

                if (!_opt.animating) {
                    _opt.animating = true;
                    noCancel = self._triggerTileMinimizing(event, _opt.$maximizedTile);

                    if (noCancel) {
                        self.minimize(null, event);
                    } else {
                        _opt.animating = false;
                    }
                }
            };

            // Event handler for mouse over the minimize button
            elHandlers.minimizeBtnMouseOver = function (event) {
                self._stopEventPropagation(event);

                // D.A Bug #145029 Do not add the hover effect when the
                // animation is in progress or the splitter is dragged
                if (!(_opt.animating || (splitter && splitter._isDrag))) {
                    $(this)
                        .children(self._selectors.minimizeIconSelector)
                            .addClass(self.css.hoverClass);
                }
            };

            // Event handler for mouse out of the minimize button
            elHandlers.minimizeBtnMouseOut = function (event) {
                self._stopEventPropagation(event);
                $(this)
                    .children(self._selectors.minimizeIconSelector)
                        .removeClass(self.css.hoverClass);
            };

            // Attach events to the tiles in minimized state
            this.element
                .on('click', minimizedTileSelector, elHandlers.minimizedTileClick)
                .on('mouseover', minimizedTileSelector, elHandlers.miminimizedTileMouseOver)
                .on('mouseout', minimizedTileSelector, elHandlers.minimizedTileMouseOut)
                .on('click', minimizeBtnSelector, elHandlers.minimizeBtnClick)
                .on('mouseover', minimizeBtnSelector, elHandlers.minimizeBtnMouseOver)
                .on('mouseout', minimizeBtnSelector, elHandlers.minimizeBtnMouseOut);

            // Resize the leftPanel, not the right when the container is resized with maximizedTile.
            // TODO: This functionality should be added in the splitter as an option to resize
            // the leftPanel instead of the right when container's size is changed
            _opt.windowHandlers.resize = function () {
                if (_opt.$maximizedTile && !_opt.useMaximizedTileIndex) {
                    self._setRightPanelSize();
                }
            };

            $(window).on('resize', _opt.windowHandlers.resize);
        },
        // Stops the event propagation. In case of nested tile managers the event
        // will be caught only once by the innermost tile manager.
        _stopEventPropagation: function (event) {
            if (event.stopPropagation) {
                event.stopPropagation();
            }

            if (event.cancelBubble !== null || event.cancelBubble !== undefined) {
                event.cancelBubble = true;
            }
        },
        _getRightPanelTilesWidth: function () {

            // D.A. 29th April 2014, Bug #170433 Added rigtPanelTiles width/height support for string values
            return parseInt(this.options.rightPanelTilesWidth, 10) ||
                this._options.gridLayout.columnWidth;
        },
        _getRightPanelTilesHeight: function () {
            return parseInt(this.options.rightPanelTilesHeight, 10) ||
                this._options.gridLayout.columnHeight;
        },
        _setRightPanelSize: function () {
            var self = this,
                opt = this.options,
                _opt = this._options,
                gl = _opt.gridLayout,
                // The minimum width that the maximized tile should have
                minMaximizedTileWidth = gl.columnWidth + 2 * gl.marginLeft,
                rightTilesTotalWidth = this._getRightPanelTilesWidth() + gl.marginLeft,
                rightTilesTotalHeight = this._getRightPanelTilesHeight() + gl.marginTop,
                rightPanelHeight = _opt.$rightPanel.height(),
                splitterWidth = this.element.children(this._selectors.splitbarSelector).outerWidth(true),
                scrollWidth = $.ig.util.getScrollWidth(),
                maxCols, minWidth, rightPanelWidth, leftPanelWidth,
                rightPanelHasScroll = function () {

                    // Detect whether the right panel will have scroll after the animation
                    return self.options.showRightPanelScroll &&
                        (Math.ceil((_opt.$tiles.length - 1) / self.options.rightPanelCols) *
                        rightTilesTotalHeight) > rightPanelHeight;
                };

            if (opt.rightPanelCols < 1) {

                // Right panel cols cannot be less than 1
                opt.rightPanelCols = 1;
            }

            // Calculate the maximum number of columns that can be shown in the right panel.
            maxCols = Math.max(Math.floor((this.element.width() - minMaximizedTileWidth - splitterWidth -
                (rightPanelHasScroll() ? scrollWidth : 0)) / rightTilesTotalWidth), 1);

            if (opt.rightPanelCols > maxCols) {
                opt.rightPanelCols = maxCols;
            }

            rightPanelWidth = opt.rightPanelCols * rightTilesTotalWidth +
                (rightPanelHasScroll() ? scrollWidth : 0);

            // D.A. 14th October 2013 Bug #151452 Added min width to the container when a tile is maximized.
            // This should prevent issues when the container is too small to show the maximized tile and the right column.
            minWidth = rightPanelWidth + minMaximizedTileWidth + splitterWidth;
            this.element.css('min-width', minWidth);
            leftPanelWidth = this.element.width() - rightPanelWidth - 2 * gl.marginLeft - splitterWidth;

            // Call the splitter set size method.
            this.element.igSplitter('setFirstPanelSize', leftPanelWidth);
        },
        // tiles - the tiles to be positioned.
        // maximizingTileIndex - the index of the tile that is simultaneously maximizing. 
        // In case of setOption, this is the index of the tile that is already maximized.
        // containerSwap - if the tiles should swap containers.
        // animateSize - if the tiles width/height to be animated too.
        // callback - function to be executed when the animation ends.
        _positionRightPanelTiles: function (
            $tiles, maximizingTileIndex, containerSwap, animateSize, callback) {
            var opt = this.options,
                _opt = this._options,
                gl = _opt.gridLayout,
                rightPanelTilesWidth = this._getRightPanelTilesWidth(),
                rightPanelTilesHeight = this._getRightPanelTilesHeight(),
                leftAdjustment = containerSwap ?
                    _opt.$rightPanel.position().left - gl.marginLeft : 0,
                topAdjustment = containerSwap ?
                    _opt.$rightPanel.scrollTop() : 0,
                rightPanelCols = opt.rightPanelCols;

            $tiles.each(function (index, element) {
                var $tile = $(this),
                    tileIndex = parseInt($tile.attr('data-index'), 10),
                    tileLeft, tileTop, newDim;

                // The maximizing tile position should not be empty.
                // Each tile positioned after the maximizing tile should be adjusted with one position.
                if (tileIndex > maximizingTileIndex) {
                    tileTop = Math.floor((tileIndex - 1) / rightPanelCols) *
                        (rightPanelTilesHeight + gl.marginTop) + gl.marginTop;
                    tileLeft = ((tileIndex - 1) % rightPanelCols) *
                        (rightPanelTilesWidth + gl.marginLeft) + gl.marginLeft / 2;
                } else {
                    tileTop = Math.floor(tileIndex / rightPanelCols) *
                        (rightPanelTilesHeight + gl.marginTop) + gl.marginTop;
                    tileLeft = (tileIndex % rightPanelCols) *
                        (rightPanelTilesWidth + gl.marginLeft) + gl.marginLeft / 2;
                }

                newDim = {
                    top: tileTop - topAdjustment,
                    left: tileLeft + leftAdjustment
                };

                if (animateSize) {
                    newDim.width = rightPanelTilesWidth;
                    newDim.height = rightPanelTilesHeight;
                }

                $tile.animate(newDim, opt.animationDuration, function () {
                    if (containerSwap) {

                        // Move the tile to the right panel
                        // Adjust its left/top so that the panel change does not affect the position on the screen
                        $tile
                            .css({
                                left: tileLeft,
                                top: tileTop
                            })
                            .appendTo(_opt.$rightPanel);
                    }

                    if (callback) {
                        callback.apply(this);
                    }
                });
            });
        },
        _hideSplitterElements: function () {
            var _opt = this._options,
                $splitBar = this.element
                    .children(this._selectors.splitbarSelector);

            _opt.$rightPanel
                .addClass(this.css.hidden)
                .addClass(this.css.splitterNoScroll);
            $splitBar.addClass(this.css.hidden);
            _opt.$leftPanel.width('100%');

            if (!this.options.showSplitter) {

                // Use visibility:hidden to hide the splitter.
                // There is a problem with the resize calculations if the splitter is hidden with display:none.
                $splitBar.addClass(this.css.visibilityHidden);
            }
        },
        _showSplitterElements: function () {
            this._options.$rightPanel
                .removeClass(this.css.hidden + ' ' + this.css.splitterNoScroll);

            this.element
                .children(this._selectors.splitbarSelector)
                    .removeClass(this.css.hidden);
        },
        _toMaximizedView: function ($tileToMaximize, event) {
            var _opt = this._options,
                marginLeft = _opt.gridLayout.marginLeft;

            // Adjust tiles left position
            _opt.$tiles.css({
                left: '-=' + marginLeft
            });

            // Set margins on the left panel
            // The maximized tile will transition to width: 100% to resize when the splitter is moved
            _opt.$leftPanel.css({
                marginLeft: marginLeft,
                marginRight: marginLeft
            });

            this._setRightPanelSize();

            // TODO: Show the splitter when the first tile is animated to the right panel
            this._showSplitterElements();

            // Move and animate tiles to the right panel
            this._positionRightPanelTiles(_opt.$tiles.not($tileToMaximize),
                parseInt($tileToMaximize.attr('data-index'), 10), true, true, null);

            // Animate the maximizing tile
            this._maximizeTile($tileToMaximize, event);
        },
        _maximizedTileSwap: function ($tileToMaximize, event) {
            var self = this,
                _opt = this._options,
                gl = _opt.gridLayout,
                minimizedTiles = _opt.$tiles.not(_opt.$maximizedTile),
                $tileToMinimize = _opt.$maximizedTile,
                tileToMinimizeIndex = parseInt($tileToMinimize.attr('data-index'), 10),
                tileToMaximizeIndex = parseInt($tileToMaximize.attr('data-index'), 10),
                rightPanelOffset = _opt.$rightPanel.position().left - gl.marginLeft;

            this._toMinimizedState($tileToMinimize);

            // Reposition the minimizing tile with container swap
            this._positionRightPanelTiles(
                $tileToMinimize, tileToMaximizeIndex, true, true, function () {
                    var prevIndex = tileToMinimizeIndex - 1,
                        prevTile;

                    if (prevIndex === tileToMaximizeIndex) {
                        prevIndex -= 1;
                    }

                    prevTile = _opt.$tiles.filter('[data-index=' + prevIndex + ']');

                    if (prevTile.length > 0) {

                        // Insert the minimizing tile after the first minimized tile with lower index in the right panel
                        $tileToMinimize.insertAfter(prevTile);
                    } else {

                        // When no such tile is present insert at the top of the right panel
                        $tileToMinimize.prependTo(_opt.$rightPanel);
                    }

                    if (event) {
                        self._triggerTileMinimized(event, $tileToMinimize);
                    }
                });

            // Reposition the rest of the tiles
            this._positionRightPanelTiles(minimizedTiles.not($tileToMaximize),
                tileToMaximizeIndex, false, false, null);

            // Move the maximizing tile to the left panel
            // Adjust its left/top so that the panel change does not affect the position on the screen
            $tileToMaximize
                .css({
                    left: '+=' + rightPanelOffset,
                    top: '-=' + _opt.$rightPanel.scrollTop()
                })
                .appendTo(_opt.$leftPanel);

            // Animate the tile
            this._maximizeTile($tileToMaximize, event);
        },
        _maximizeTile: function ($tileToMaximize, event) {
            var self = this,
                _opt = this._options,
                mt = _opt.gridLayout.marginTop,
                innerContainer = $tileToMaximize
                    .children(this._selectors.innerContainerSelector);

            // Switch to maximized content
            this._toMaximizedState($tileToMaximize);

            // Hide inner container scrolls during the animation
            innerContainer.addClass(this.css.overflowHidden);

            $tileToMaximize.animate({
                width: '100%',
                height: this.element.height() - 2 * mt,
                top: mt,
                left: 0
            },
            this.options.animationDuration,
            function () {

                // Remove the overflow visible when the animation ends
                _opt.$leftPanel.removeClass(self.css.overflowVisible);
                innerContainer.removeClass(self.css.overflowHidden);

                // Update the maximized tile
                _opt.$maximizedTile = $tileToMaximize;
                _opt.animating = false;

                if (event) {
                    self._triggerTileMaximized(event, $tileToMaximize);
                }
            });
        },
        // Maximizes tile when maximizedTileIndex option is given
        _maximizeTileWithCustomIndex: function ($tileToMaximize, event) {
            var itemData, i,
                self = this,
                _opt = this._options,
                animDuration = this.options.animationDuration,
                $tileToMinimize = _opt.$maximizedTile,
                tileToMinimizeNewDim = {
                    width: $tileToMaximize.outerWidth(),
                    height: $tileToMaximize.outerHeight(),
                    top: $tileToMaximize.css('top'),
                    left: $tileToMaximize.css('left')
                },
                tileToMaximizeNewDim = {
                    width: $tileToMinimize.outerWidth(),
                    height: $tileToMinimize.outerHeight(),
                    top: $tileToMinimize.css('top'),
                    left: $tileToMinimize.css('left')
                },
                swapTilesInConfig = function (itemsConfig) {

                    // Swap the tiles in the grid layout items configuration array
                    for (i = 0; i < itemsConfig.length; i++) {
                        itemData = itemsConfig[i];
                        if (itemData.item.is($tileToMinimize)) {
                            itemData.item = $tileToMaximize;
                        } else if (itemData.item.is($tileToMaximize)) {
                            itemData.item = $tileToMinimize;
                        }
                    }
                };

            this._toMaximizedState($tileToMaximize);
            this._toMinimizedState($tileToMinimize);

            // Animate the minimized tile to the position of the maximized
            $tileToMinimize.animate(tileToMinimizeNewDim, animDuration, function () {
                if (event) {
                    self._triggerTileMinimized(event, $tileToMinimize);
                }
            });

            // Animate the maximized tile to the position of the minimized
            $tileToMaximize.animate(tileToMaximizeNewDim, animDuration, function () {
                var lmGridLayout = self.layoutManager()._opt.gridLayout;

                // Update the tiles linked to the associated item configurations
                swapTilesInConfig(lmGridLayout.items);
                swapTilesInConfig(lmGridLayout.sortedItems);

                // Update the maximized tile
                _opt.$maximizedTile = $tileToMaximize;
                _opt.animating = false;

                if (event) {
                    self._triggerTileMaximized(event, $tileToMaximize);
                }
            });
        },
        maximize: function ($tileToMaximize, event) {
            /* Maximizes a given tile.
               paramType="object" optional="false" Specifies the jQuery object of the tile element to be maximized.
               paramType="object" optional="true" Indicates the browser even which triggered this action (not API).
            */
            var _opt = this._options;

            if (!$tileToMaximize) {

                // Tile to maximize not provided
                return;
            }

            if (_opt.$maximizedTile && _opt.$maximizedTile.attr('data-index') ===
                    $tileToMaximize.attr('data-index')) {

                // The tile is already maximized
                return;
            }

            if (!_opt.useMaximizedTileIndex) {

                // Set overflow visible before the animation start
                _opt.$leftPanel
                    .addClass(this.css.overflowVisible)
                    .removeClass(this.css.overflowHidden);

                if (!_opt.$maximizedTile) {

                    // Maximize the selected tile. Move the rest to the right panel.
                    this._toMaximizedView($tileToMaximize, event);
                } else {

                    // Maximize the selected tile. Minimized the currently maximized. Rearrange the rest.
                    this._maximizedTileSwap($tileToMaximize, event);
                }
            } else {

                // Maximize the selected tile. Minimize the currently maximized. Swap these tiles positions.
                this._maximizeTileWithCustomIndex($tileToMaximize, event);
            }
        },
        minimize: function (animationDuration, event) {
            /* Minimizes the maximized tile. Has no effect if no maximized tile is present.
               paramType="number" optional="true" Specifies the animation duration for this minimize.
               paramType="object" optional="true" Indicates the browser even which triggered this action (not API).
            */
            var _opt = this._options,
                $tileToMinimize = _opt.$maximizedTile,
                gl = _opt.gridLayout,
                rightTilesOffset = _opt.$rightPanel.position().left,
                tileToMinimizeIndex;

            if (!$tileToMinimize) {
                return;
            }

            // D.A. 14th October 2013 Bug #151452 Remove the min-width when minimizing a tile.
            this.element.css('min-width', 0);
            tileToMinimizeIndex = parseInt($tileToMinimize.attr('data-index'), 10);

            // Revert the left panel to no margins. Keep its current widhth and height.
            _opt.$leftPanel
                .width(_opt.$leftPanel.outerWidth(true))
                .height(_opt.$leftPanel.outerHeight(true))
                .css({ margin: 0 });

            // Switch to minimized state
            this._toMinimizedState($tileToMinimize);

            // Adjust the tile to minimize's left/top position so that
            // the panel change does not affect its position on the screen
            $tileToMinimize.css({
                width: $tileToMinimize.outerWidth(),
                height: $tileToMinimize.outerHeight(),
                top: gl.marginTop,
                left: gl.marginLeft
            });

            // Adjust the rest tile's left/top position so that the panel change
            // does not affect its position on the screen
            _opt.$tiles
                .not($tileToMinimize)
                    .each(function (index, element) {
                        var $tile = $(this);

                        $tile.css({
                            left: '+=' + rightTilesOffset,
                            top: '-=' + _opt.$rightPanel.scrollTop()
                        });

                        // Move the tile to the left panel
                        if (parseInt($tile.attr('data-index'), 10) > tileToMinimizeIndex) {
                            $tile.appendTo(_opt.$leftPanel);
                        } else {
                            $tile.insertBefore($tileToMinimize);
                        }
                    });

            // Hide splitter and right panel
            this._hideSplitterElements();

            // Reflow the tiles to their normal positions
            this.reflow(true, animationDuration, event);
        },
        maximizedTile: function () {
            /* Returns the maximized tile or null if such is not present.
               returnType="object|null" Returns the maximized tile or null if such is not present.
            */
            return this._options.$maximizedTile || null;
        },
        minimizedTiles: function () {
            /* Returns an array with the tiles in minimized state or null if such are not present.
               returnType="object|null" Returns an array with the tiles in minimized state or null if such are not present.
            */
            var minimizedTiles = this._options.$tiles.not(this._options.$maximizedTile);
            return minimizedTiles.length > 0 ? minimizedTiles : null;
        },
        splitter: function () {
            /* Returns the splitter associated with this tile manager or
               null if the tile manager was instantiated with maximizedTileIndex.
               returnType="object|null" Returns the splitter associated with this tile manager or
               null if the tile manager was instantiated with maximizedTileIndex.
            */
            return this._options.useMaximizedTileIndex ? null : this.element.data('igSplitter');
        },
        layoutManager: function () {
            /* Returns the layout manager associated with this tile manager.
               returnType="object" Returns the layout manager associated with this tile manager.
            */
            return this._options.$layoutManagerElement.data('igLayoutManager');
        },
        reflow: function (forceReflow, animationDuration, event) {
            /* Reflow the tile manager. Rearranging the tiles to fit in the container
               paramType="boolean" optional="true" Indicates whether the reflow should be forced. Useful in cases where the items size and position was changed manually.
               paramType="number" optional="true" The animation duration to be used for this reflow only.
               paramType="object" optional="true" Indicates the browser even which triggered this action (not API).
            */
            this.layoutManager().reflow(forceReflow, animationDuration, event);
        },
        widget: function () {
            /* Returns the element that represents this widget.
               returnType="object" Returns the element that represents this widget.
            */
            return this.element;
        },
        _triggerDataBinding: function () {
            var args = {
                owner: this,
                dataSource: this.options.dataSource
            };
            return this._trigger(this.events.dataBinding, null, args);
        },
        _triggerDataBound: function (success, msg, dataView) {
            var args = {
                owner: this,
                success: success,
                errorMessage: msg,
                dataView: dataView
            };
            this._trigger(this.events.dataBound, null, args);
        },
        _triggerRendering: function (tiles, items) {
            var args = {
                owner: this,
                tiles: tiles,
                items: items
            };

            return this._trigger(this.events.rendering, null, args);
        },
        _triggerRendered: function () {
            this._trigger(this.events.rendered, null, { owner: this });
        },
        _triggerTileRendering: function (event, ui) {
            var args = {
                owner: this,
                tile: ui.item
            };

            return this._trigger(this.events.tileRendering, event, args);
        },
        _triggerTileRendered: function (event, ui) {
            var args = {
                owner: this,
                tile: ui.item
            };

            return this._trigger(this.events.tileRendered, event, args);
        },
        _triggerTileMaximizing: function (event, tile) {
            var args = {
                owner: this,
                tile: tile,
                minimizingTile: this._options.$maximizedTile || null
            };

            return this._trigger(this.events.tileMaximizing, event, args);
        },
        _triggerTileMaximized: function (event, tile) {
            var args = {
                owner: this,
                tile: tile
            };

            this._trigger(this.events.tileMaximized, event, args);
        },
        _triggerTileMinimizing: function (event, tile, maximizingTile) {
            var args = {
                owner: this,
                tile: tile,
                maximizingTile: maximizingTile || null
            };

            return this._trigger(this.events.tileMinimizing, event, args);
        },
        _triggerTileMinimized: function (event, tile) {
            var args = {
                owner: this,
                tile: tile
            };

            this._trigger(this.events.tileMinimized, event, args);
        },
        dataBind: function () {
            /* Performs databinding on the tile manager */
            var noCancel;

            this._initDataSource();

            noCancel = this._triggerDataBinding();
            if (noCancel) {
                this.options.dataSource.dataBind(this._renderData, this);
            }
        },
        // Returns the markup (if such) to its initial state. Destroys the layout manager and splitter widgets.
        // Destroys the rendered ui-igtiles. Removes the classes from the tiles.
        _destroyTiles: function () {
            var self = this,
                _opt = this._options;

            // Destroy the other widgets
            _opt.$layoutManagerElement.igLayoutManager('destroy');

            if (!_opt.useMaximizedTileIndex) {
                this.element.igSplitter('destroy');
            }

            // Remove the rendered content
            if (_opt.fromMarkup) {
                if (_opt.useMaximizedTileIndex) {

                    // When no splitter is used remove all classes from the tiles and the rendered content.
                    _opt.$tiles.each(function (index) {
                        var $tile = $(this);

                        $tile
                            .children()
                                .removeClass(self.css.innerContainer)
                                .appendTo(self.element)
                                .children('.' + self.css.hidden)
                                    .removeClass(self.css.hidden);

                        $tile.remove();
                    });
                } else {

                    // The destroy of the splitter returns all the markup as it was
                    // before all classes were applied and any other content was rendered.
                    // Only the tiles should be moved back to the original container and
                    // the panels should be removed.
                    this._removePanels();

                    // Unwrap the original markup from the added <div> tags
                    this.element
                        .children()
                            .children()
                                .unwrap();
                }
            } else {

                // When data source is used empty the container
                this.element.empty();
            }
        },
        // Remove the attached event handlers
        _removeEventHandlers: function () {
            var _opt = this._options,
                elHandlers = _opt.elementHandlers,
                minimizeBtnSelector = this._selectors.minimizeBtnSelector,
                minimizedTileSelector = this._selectors.minimizedTileSelector;

            this.element
                .off('click', minimizedTileSelector, elHandlers.minimizedTileClick)
                .off('mouseover', minimizedTileSelector, elHandlers.miminimizedTileMouseOver)
                .off('mouseout', minimizedTileSelector, elHandlers.minimizedTileMouseOut)
                .off('click', minimizeBtnSelector, elHandlers.minimizeBtnClick)
                .off('mouseover', minimizeBtnSelector, elHandlers.minimizeBtnMouseOver)
                .off('mouseout', minimizeBtnSelector, elHandlers.minimizeBtnMouseOut);

            $(window).off('resize', _opt.windowHandlers.resize);
        },
        destroy: function () {
            /* Destructor */
            $.Widget.prototype.destroy.apply(this, arguments);
            this.element.removeClass(this.css.container);
            this._destroyTiles();
            this._removeEventHandlers();
            return this;
        }
    });
    $.extend($.ui.igTileManager, { version: '14.1.20141.2249' });
}(jQuery));
/*!@license
	* Infragistics.Web.ClientUI jQuery File Upload 14.1.20141.2249
	*
	* Copyright (c) 2011-2014 Infragistics Inc.
	*
	* http://www.infragistics.com/
	*
	* Depends on:
	*  jquery-1.4.2.js
	*	jquery.ui.core.js
	*	jquery.ui.widget.js
	*  infragistics.util.js
	*  infragistics.ui.shared.js
	*/

/*global jQuery */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {

	$.widget("ui.igBrowseButton", $.ui.igButton, {
		// this class should be general for igBrowseButton - to work properly widget do not change it
		_const: {
			filePickerWidth: '220px',
			filePickerHeight: '30px'
		},
		css: {
			"filePickerClass": "ui-igbrowsebutton-filepicker"
		},
		options: {
			autoselect: true,
			multipleFiles: false,
			// M.H. 13 Feb 2014 Fix for bug #164347: Move input type="file" from document body to the upload container
			container: null
		},
		_id: function (id) {
			return this.element[0].id + id;
		},
		_create: function () {
			var filepickerId = this._id('_fp'), self = this;
			$.extend($.ui.igBrowseButton.prototype.options, $.ui.igButton.prototype.options);
			$.extend($.ui.igBrowseButton.prototype.css, $.ui.igButton.prototype.css);
			//$.extend($.ui.igBrowseButton.prototype, $.ui.igButton.prototype);
			$.ui.igButton.prototype._create.apply(this);

			this._createFilePicker(filepickerId);

			this._attachBrowseButtonEvents();
			if (this.options.disabled === true) {
				this._enableFilePicker(true);
			} else {
				this.element.bind({
					// M.H. 27 Jul 2011 - fix bug 77323
					click: function (e) {
						e.preventDefault();
					},
					drop: function (e) {
						var files = e.originalEvent.dataTransfer.files;
						e.stopPropagation();
						e.preventDefault();

						if (files === null || files === undefined) {
							// TO DO throw error
							return false;
						}
						if (!self._trigger('fileselect', e, { files: files, multiple: true})) {
							return;
						}
						return false;
					}
				});
			}
		},
		_createFilePicker: function (filepickerId) {
			// M.H. 1 Nov. 2011 Fix for bug #83439 - when the control is in UpdatePanel filePicker is attached to body and on async postback it is not removed 
			// each time when it is added filepicker it should be checked whether such DOM element with this ID exist and if so - to remove it.
			$('#' + filepickerId).remove();
			var multiple = '', container = this.options.container;
			if (this.options.multipleFiles === true) {
				multiple = ' multiple=""';
			}
			// M.H. 13 Feb 2014 Fix for bug #164347: Move input type="file" from document body to the upload container
			if (!container) {
				container = $(document.body);
			}
			this.filePicker = $('<input type="file" id="' + filepickerId + '"' + multiple + '/>').appendTo(container);
			this.filePicker.css({
				'position' : 'absolute',
				'margin': '-5px 0 0 -175px',
				'padding': '0',
				'width': '1px',
				'height': '1px',
				'fontSize': '14px',
				'opacity': '0',
				'cursor': 'pointer',
				'display': 'block',
				// M.H. 30 March 2012 Fix for bug #104044
				'zIndex':  '1000000',
				'filter': 'alpha(opacity=0)'
			});
			// M.H. 12 May 2011 - fix bug 74763
			this._setTitle(this.options.title);
		},

		_setTitle: function (title) {
			// M.H. 12 May 2011 - fix bug 74763: add method which adds/remove attribute to file picker
			var filePicker = $('#' + this._id('_fp'));

			if (title === false) {
				filePicker.removeAttr('title');
			} else {
				filePicker.attr('title', title);
			}
		},

		_attachBrowseButtonEvents: function () {
			var self = this;

			this.mouseMoveEvent = {
				mousemove: function (event) {
					self._mousemove(event);
				}
			};
			this._internalEvents = {
				mouseover: function (event) {
					// M.H. 18 Mar 2013 Fix for bug #136457: "Upload File" button should be tapped twice to open the browse dialog in IE10 on Windows 8 touch device and it doesn't work if the browser is zoomed.
					self._mousemove(event);
					self._attachMouseMove(true);
				}
			};
			self.element.bind(this._internalEvents);
			//attach onchange property to input type="file" element
			self._filePickerBindChange();
		},

		//event fired when autoselect option is true attach onchange event in input
		_filePickerBindChange: function () {
			var self = this, filePath,
				filePicker = $('#' + this._id('_fp'));
			self.tempClicked = false;
			self._filePickerEvents = {
				change: function (event) {
					var files = null, multiple = false;

					filePath = self._fileFromPath(filePicker.val());
					if (filePicker[0].files) {
						files = filePicker[0].files;
						multiple = true;
					}
					// M.H. 18 Mar 2013 Fix for bug #136457: "Upload File" button should be tapped twice to open the browse dialog in IE10 on Windows 8 touch device and it doesn't work if the browser is zoomed.
					self._mousemove(event);
					// M.H. 17 Dec 2012 Fix for bug #129478
					if (!self._trigger('fileselect', event, { filePath: filePath, files: files, multiple: multiple})) {
						return;
					}
				},
				click: function (event) {
					if (!self._trigger('click', event)) {
						// M.H. 11 May 2011 - fix bug 74553 - allow to cancel file selecting
						return false;
					}
				}
			};
			filePicker.bind(self._filePickerEvents);
		},

		attachFilePicker: function (e, isHidden) {
			var self = this, right, bottom, t, l, relativeOffset,
				fileUploadButton = self.element,
				filePicker = this.filePicker,
				offset = fileUploadButton.offset(),
				left = parseInt(offset.left, 10),
				top = parseInt(offset.top, 10),
				filePickerDOM = filePicker[0];
			right = parseInt(left + fileUploadButton[0].offsetWidth, 10);
			bottom = parseInt(top + fileUploadButton[0].offsetHeight, 10);
			//$('#status2').text(e.pageX);
			if (e.pageX >= left && e.pageX <= right &&
						e.pageY >= top && e.pageY <= bottom) {
				// M.H. 13 Feb 2014 Fix for bug #164347: Move input type="file" from document body to the upload container
				relativeOffset = $.ig.util.getRelativeOffset(filePicker);
				t = e.pageY;
				l = e.pageX;
				t -= relativeOffset.top;
				l -= relativeOffset.left;
				filePickerDOM.style.top = t + 'px';
				filePickerDOM.style.left = l + 'px';
				//if (!self.isVisibleFilePicker) {
				if (isHidden === true) {
					filePicker.css({
						width: '1px',
						height: '1px'
					});
				} else {
					self.isVisibleFilePicker = true;
					filePicker.css({
						width: self._const.filePickerWidth,
						height: self._const.filePickerHeight
					});
				}

				//}
				filePickerDOM.style.display = 'block';
				//filePickerDOM.style.visibility = 'visible';
				//we should call prototype mousein event because when moving cursor it has attached another DOM element and mousein is not called
				self._onMouseOver(e);
			}
		},
		getFilePicker: function () {
			var filepickerId = this._id('_fp'),
				filePicker = $('#' + filepickerId);

			filePicker.attr('id', '').css({ 'display': 'none' });
			this._createFilePicker(filepickerId);
			this._filePickerBindChange();
			return filePicker;
		},

		_mousemove: function (e) {
			//attach//dettach <input type="file"> to the cursor
			var self = this, right, bottom, t, l,
				fileUploadButton = self.element,
				filePicker = this.filePicker,
				relativeOffset,
				// L.A. 03 December 2012 - Fixing bug #115868 
				// The "choose file to upload" dialog window is not visible when the window is zoomed in on a touchscreen
				left = $.ig.util.offset(fileUploadButton).left,
				top = $.ig.util.offset(fileUploadButton).top,
				filePickerDOM = filePicker[0];
			right = parseInt(left + fileUploadButton[0].offsetWidth, 10);
			bottom = parseInt(top + fileUploadButton[0].offsetHeight, 10);
			//$('#status2').text(e.pageX);
			if (e.pageX >= left && e.pageX <= right &&
						e.pageY >= top && e.pageY <= bottom) {
				// M.H. 13 Feb 2014 Fix for bug #164347: Move input type="file" from document body to the upload container
				relativeOffset = $.ig.util.getRelativeOffset(filePicker);
				t = e.pageY;
				l = e.pageX;
				t -= relativeOffset.top;
				l -= relativeOffset.left;
				filePickerDOM.style.top = t + 'px';
				filePickerDOM.style.left = l + 'px';
				if (!self.isVisibleFilePicker) {
					filePicker.css({
						width: self._const.filePickerWidth,
						height: self._const.filePickerHeight
					});
					self.isVisibleFilePicker = true;
				}
				filePickerDOM.style.display = 'block';
				//filePickerDOM.style.visibility = 'visible';
				//we should call prototype mousein event because when moving cursor it has attached another DOM element and mousein is not called
				self._onMouseOver(e);
			} else {
				if (self.isVisibleFilePicker) {
					filePicker.css({
						width: '1px',
						height: '1px'
					});
					self.isVisibleFilePicker = false;
				}
				self._attachMouseMove(false);
				//filePickerDOM.style.display = 'none';
				//filePickerDOM.style.visibility = 'hidden';
				self._onMouseOut(e);
			}
		},
		_attachMouseMove: function (isToAttach) {
			if (isToAttach) {
				$(document).bind(this.mouseMoveEvent);
			} else {
				$(document).unbind(this.mouseMoveEvent);
			}
		},
		_setOption: function (key, value) {
			$.ui.igButton.prototype._setOption.apply(this, arguments);
			$.Widget.prototype._setOption.apply(this, arguments);

			switch (key) {
			case "disabled":
				this._enableFilePicker(value);
				$.ui.igButton.prototype._setOption.apply(this, arguments);
				break;
			// M.H. 12 May 2011 - fix bug 74763
			case "title":
				this._setTitle(value);
				break;
			default:
				break;
			}
		},
		_enableFilePicker: function (isDisabled) {
			var filePicker = $('#' + this._id('_fp'));

			if (isDisabled === false) {
				this.isVisibleFilePicker = false;
				//filePicker.removeAttr('disabled');
				this._attachMouseMove(true);
				// IE9 fix - unbind mouse over event
				this.element.bind(this._internalEvents).mouseover();
			} else {
				//filePicker.attr('disabled', 'true');
				this._attachMouseMove(false);
				filePicker.css({
					width: '1px',
					height: '1px'
				});
				this.element.unbind(this._internalEvents);
			}
		},

		destroy: function () {
			this.element.unbind(this._internalEvents);
			this.element.unbind(this.mouseMoveEvent);
			$.Widget.prototype.destroy.apply(this, arguments);
			// M.H. 10 May 2011 - fix bug 75039: remove unnecessary comment and unnecessary line of code
			$.ui.igButton.prototype.destroy.apply(this);

			// M.H. 12 May 2011 - fix bug 74966
			$('#' + this._id('_fp')).remove();
		},

		/*************** HELPER FUNCTION ********************/
		_fileFromPath: function (file) {
			return file.replace(/(\/|\\)$/, "");
		}
		/*************** //HELPER FUNCTION ********************/
	});
	$.extend($.ui.igBrowseButton, { version: '14.1.20141.2249' });

	$.widget("ui.igUpload", {
		_const: {
			fileNameLimit: 100,
			AjaxQueueName: 'uploadrequestsqueue',
			debug: true,
			isProgressBarAnimationEnabled: true,
			isProgressBarRange: false,
			timeoutGetFileSize: 1000,
			status: {
				NotStarted: 0, // only used in Client UI
				Started: 1,
				Finished: 2,
				NoSuchFile: 3, // when client tries to request file information wiht key which does not exist in the server
				Canceled: 4 // only used in Client UI                
			},
			// M.H. 11 May 2011 - fix bug 74621: Add error codes for most common errors
			errorCode: {
				MimeTypeValidation: 1,
				FileSizeExceeded: 2
			},
			clientSideErrorCode: {
				maxAllowedUploadingFiles: 1,
				extensionValidation: 2,
				startUpload: 3,
				ajaxErrorGetFileStatus: 4,
				ajaxErrorCancelUpload: 5,
				removeFileUpload: 6,
				ajaxErrorRequestFileSize: 7,
				checkCanUpload: 8
			},
			fileStatusNoError: -1,
			progressUpdateInterval: 800,
			animateProgressBarInterval: 10,
			showHideDetailsAnimationTimeout: 500,
			doubleCheckRequestInterval: 1000,
			removeSingleUploadAnimationTimeout: 300,
			maxUploadFilesDefault: -1
		},
		// M.H. 27 Jul 2011 - fix bug 77162 - set default file extension icons array
		defaultFileExtensionIcons: [
			// good practice is to set at the beginning of array default classes
			{
				/* type="string" Array of string for file extensions */
				ext: [],
				/* type="string" Css classes which sets icon. */
				css: 'ui-icon ui-icon-document ui-igupload-progressbar-icon ui-igupload-progressbar-icon-default',
				/* type="bool" Default icons when the file extension is not found. It is taken only the first item which have def set to true, other are ignored. */
				def: true
			},
			{
				ext: ['exe', 'app'],
				css: 'ui-icon ui-icon-gear ui-igupload-progressbar-icon ui-igupload-progressbar-icon-exe',
				def: false
			},
			{
				ext: ['gif', 'jpg', 'jpeg', 'png', 'bmp', 'yuv', 'tif', 'thm', 'psd'],
				css: 'ui-icon ui-icon-image ui-igupload-progressbar-icon ui-igupload-progressbar-icon-images',
				def: false
			},
			{
				ext: ['mp3', 'wav', 'mp4', 'aac', 'mid', 'wma', 'ra', 'iff', 'aif', 'm3u', 'mpa'],
				css: 'ui-icon ui-icon-volume-on ui-icon ui-icon-image ui-igupload-progressbar-icon ui-igupload-progressbar-icon-music',
				def: false
			},
			{
				ext: ['doc', 'docx', 'xls', 'xlsx', 'txt', 'ppt', 'pptx', 'pdf'],
				css: 'ui-icon ui-icon-document ui-igupload-progressbar-icon ui-igupload-progressbar-icon-docs',
				def: false
			},
			{
				ext: ['3gp', 'asf', 'asx', 'avi', 'flv', 'mov', 'mp4', 'mpg', 'rm', 'swf', 'vob', 'wmv'],
				css: 'ui-icon ui-icon-video ui-igupload-progressbar-icon ui-igupload-progressbar-icon-video',
				def: false
			}
		],
		css: {
			/* Helper classes */
			/* clear class */
			"clearClass": "ui-helper-clearfix",
			/* hide element */
			"hiddenClass": "ui-helper-hidden",
			/* // Helper classes */
			/* class for IE6 */
			"baseClassIE6": "ui-ie6",
			/* class for IE7 */
			"baseClassIE7": "ui-ie7",
			/* class for FF */
			"baseClassMoz": "ui-moz",
			/* class for Opera */
			"baseClassOpera": "ui-opera",
			// M.H. 29 May 2011 - fix bug 80546: add class for webkit
			/* class for Webkit powered browsers */
			"baseClassWebkit": "ui-webkit",
			/* class for startup browse button */
			"startupBrowseButtonClasses": "ui-igstartupbrowsebutton",
			/* css class for the container */
			"baseClass": "ui-widget ui-widget ui-widget-content ui-corner-all ui-igupload",
			/* css classes applied to main container in single/multiple mode */
			"baseMainContainerClass": "ui-igupload-basemaincontainer",
			/* css classes applied to main container when multiple file upload mode is selected */
			"multipleDialogClasses": "ui-iguploadmultiple",
			/* css classes applied to main container when multiple file upload mode is selected */
			"singleDialogClass" : "ui-iguploadsingle",
			/* css classes applied on browse button - button in main container */
			"browseButtonClass": "ui-igupload-browsebutton",
			/*css classes applied to DOM element containing all file upload progress bars */
			"containerClass": "ui-igupload-container ui-widget-content",
			/* div containing separate individual file upload */
			"uploadProgressClass": "ui-igupload-uploadprogress",
			/* css class applied on div which contains add button, clear button and progress details of the files */
			"fileInfoMainContainer": "ui-igupload-fimaincontainer",
			/* css class container for each file */
			"progressContainer": "ui-helper-clearfix",
			/* css class applied on single progressbar */
			"progressBarUploadClass": "ui-igupload-progressbar-upload ui-igupload-progressbar-upload-single ui-helper-clearfix",
			/* css classes applied to file name DOM element in the summary progress bar */
			"progressBarFileNameClass": "ui-igupload-progressbar-filename",
			/* css classes applied to file size DOM element in the summary progress bar */
			"progressBarFileSizeClass": "ui-igupload-progressbar-filesize",
			/* css classes of the container of the filename DOM element and file size DOM element inside each of the progressbar */
			"progressBarInnerHTMLContainerClass": "ui-igupload-progressbar-container ui-helper-clearfix",
			/* css classes for container of the cancel/done button near the progress bar */
			"containerButtonCancelClass": "ui-container-button-cancel-class  ui-helper-clearfix",
			/* css classes applied to summary progressbar */
			"summaryProgressBarClass": "ui-igupload-summaryprogressbar",
			/* css classes applied to container of summary progress bar */
			"summaryProgressContainerClass": "ui-igupload-summaryprogresscontainer",
			/* css classes of label of the summary progress bar */
			"summaryProgressbarLabelClass": "ui-igupload-summaryprogress-label",
			/* css classes of container in summary progress area - contains label for summary progress and show/hide details button */
			"summaryInformationContainerClass": "ui-igupload-summaryinformation-container ui-helper-clearfix",
			/* css classes applied to DOM element showing status of summary progress */
			"summaryUploadedFilesLabelClass": "ui-igupload-summaryuploadedfiles-label",
			/* css classes of show/hide details button in summary progress area */
			"summaryShowHideDetailsButtonClass": "ui-igupload-showhidedetails-button",
			/* css classes which are set to the cancel button */
			"summaryButtonClass": "ui-igupload-summary-button",
			/* css classes set inside progress div */
			"summaryProgressBarInnerProgress": "ui-igupload-summaryprogres_summpbar_progress",
			/* css class for the second label in summary progress bar */
			"summaryProgressBarSecondaryLabel": "ui-igupload-summaryprogress-label ui-igupload-summaryprogress-secondary-label",
			/* Css class for container of each individual file - including progress bar, file info, cancel button, etc. */
			"containerFUS": "ui-widget-content ui-igupload-progress-container ui-corner-all ui-helper-clearfix"
		},
		options: {
			/* type="number" Get or set width of the main container of the file upload control. Main container contains all buttons, progressbar, etc.*/
			width: '',
			/* type="number" Get or set height of the main container of the file upload control. Main container contains all buttons, progressbar, etc. */
			height: '',
			/* type="bool" Get or set whether the file start upload automatically when it is selected. Default is false. */
			autostartupload: false,

			/* type="string" Get or set label for the first shown browse button. When file is selected for the first time this button is hidden. */
			labelUploadButton: $.ig.Upload.locale.labelUploadButton,
			/* type="string" Get or set label for browse button in main container. */
			labelAddButton: $.ig.Upload.locale.labelAddButton,
			/* type="string" Get or set label for summary Clear all button. It will be shown only in multiple upload mode. */
			labelClearAllButton: $.ig.Upload.locale.labelClearAllButton,
			/* type="string" Get or set template for showing summary template. {0} is count of uploaded files. {1} is total count of file to be uploaded. */
			labelSummaryTemplate: $.ig.Upload.locale.labelSummaryTemplate,
			// M.H. 13 May 2011 - fix bug 75042
			/* type="string" Get or set template for showing uploading information in summary progress bar. It will be shown only in multiple upload mode. {0} uploaded filesize. {1} - total file size. */
			labelSummaryProgressBarTemplate: $.ig.Upload.locale.labelSummaryProgressBarTemplate,
			/* type="string" Get or set label for show/hide details button when main container is hidden. */
			labelShowDetails: $.ig.Upload.locale.labelShowDetails,
			/* type="string" Get or set label for show/hide details button when main container is shown. */
			labelHideDetails: $.ig.Upload.locale.labelHideDetails,
			/* type="string" Get or set label for button cancelling all files. Shown only in multiple upload mode. */
			labelSummaryProgressButtonCancel: $.ig.Upload.locale.labelSummaryProgressButtonCancel,
			/* type="string" Get or set label for start upload batch files. Shown only in multiple upload mode and autostartupload is false. */
			labelSummaryProgressButtonContinue: $.ig.Upload.locale.labelSummaryProgressButtonContinue,
			/* type="string" Get or set label when upload is finished. Shown only in multiple upload mode. */
			labelSummaryProgressButtonDone: $.ig.Upload.locale.labelSummaryProgressButtonDone,
			/* type="string" Get or set filename when it could not be shown the whole file name and should be shorten. */
			labelProgressBarFileNameContinue:  $.ig.Upload.locale.labelProgressBarFileNameContinue,
			// Error Messages
			// M.H. 11 May 2011 - fix bug 74621: remove unused property errorMessageMaxFileSizeExceeded
			/* type="string" Get or set message shown when max file size of the uploaded file exceeds the limit. */
			errorMessageMaxFileSizeExceeded: $.ig.Upload.locale.errorMessageFileSizeExceeded,
			/* type="string" Get or set error message when ajax call to get file status throws error. */
			errorMessageGetFileStatus: $.ig.Upload.locale.errorMessageGetFileStatus,
			/* type="string" Get or set error message when ajax call to send cancel upload command. */
			errorMessageCancelUpload: $.ig.Upload.locale.errorMessageCancelUpload,
			/* type="string" Get or set error message when file is not found. */
			errorMessageNoSuchFile: $.ig.Upload.locale.errorMessageNoSuchFile,
			/* type="string" Get or set error message different from the other messages. */
			errorMessageOther: $.ig.Upload.locale.errorMessageOther,
			/* type="string" Get or set error message when file extension validation failed. */
			errorMessageValidatingFileExtension: $.ig.Upload.locale.errorMessageValidatingFileExtension,
			/* type="string" Get or set error message when AJAX Request to get file size throws error. */
			errorMessageAJAXRequestFileSize: $.ig.Upload.locale.errorMessageAJAXRequestFileSize,
			/* type="string" Get or set error message when trying to remove non existing file. */
			errorMessageTryToRemoveNonExistingFile: $.ig.Upload.locale.errorMessageTryToRemoveNonExistingFile,
			/* type="string" Get or set error message when trying to start non existing file. */
			errorMessageTryToStartNonExistingFile: $.ig.Upload.locale.errorMessageTryToStartNonExistingFile,
			/* type="string" Get or set error message when maximum allowed files exceeded. */
			errorMessageMaxUploadedFiles: $.ig.Upload.locale.errorMessageMaxUploadedFiles,
			/* type="string" Get or set error message when maximum simultaneous files is less or equal to 0. */
			errorMessageMaxSimultaneousFiles: $.ig.Upload.locale.errorMessageMaxSimultaneousFiles,

			/* type="string" Get or set URL for uploading. */
			uploadUrl: "ig_fua34sf345sdf13sdf3454erdsf2345asd3425df5235d54df345.aspx",
			/* type="string" Get or set URL of HTTPHandler to get information about file upload, current size and also to get commands */
			progressUrl: "IGUploadStatusHandler.ashx",

			/* type="string" Get or set file allowed file extensions. When this array is empty - it is not made such validation. Example ["gif", "jpg", "bmp"]. */
			allowedExtensions: [],
			/* type="bool" Get or set whether to show File Extension icon */
			showFileExtensionIcon: true,
			/* Get or set control specific CSS options. For example you can override specific control classes with custom ones. */
			css: null,

			/* Set icon css classes for specified file extension */
			// M.H. 27 Jul 2011 - fix bug 77162
			fileExtensionIcons: [
				// good practice is to set at the beginning of array default classes
				{
					/* type="string" Array of string for file extensions */
					ext: [],
					/* type="string" Css classes which sets icon. */
					css: '',
					/* type="bool" Default icons when the file extension is not found. It is taken only the first item which have def set to true, other are ignored. */
					def: false
				}
			],
			/* type="single|multiple" Get or set multiple or single file upload. In single upload it is possible to upload only one file at the same time. */
			mode: 'single',
			/* type="bool" Get or set a bool setting that allows user to select(for upload) more than 1 file from the browse dialog at once. HTML 5+ - it is supported by Chrome, MOzilla FF, Safar, Opera latest versions and IE10+ */
			multipleFiles: false,
			/* type="number" Get or set the maximum number of allowed files to upload. */
			maxUploadedFiles: -1,
			/* type="number" Get or set count of files that could be uploaded at the same time. */
			maxSimultaneousFilesUploads: 1, // Fix bug 77030 M.H. 27 May 2011         
			/* type="bytes|kbytes|mbytes|gbytes|auto" Get or set file size metrics how to be shown files size. */
			fileSizeMetric: 'auto',
			// multiUploadView: $.ig.Constants.Upload.MultipleViewLayout.Block,
			/* type="string" UniqueId of the control - should not be changed by developer. Set from server-side wrapper. */
			controlId: '',
			/* type="int" The number of digits after the decimal point. */
			fileSizeDecimalDisplay: 2
		},
		events: {
			/* cancel="true" Defines the name of the file upload selecting event. Fired when browse button is pressed. 
			Return false in order to cancel selecting file.
			Function takes argument evt.
			*/
			fileSelecting: 'fileSelecting',
			/* Defines the name of the file upload selected event. Fired when file is selected from browse dialog. 
			Return false in order to cancel uploading file.
			Function takes arguments evt and ui.
			Use ui.fileId to get unique identifier of the file
			Use ui.filePath to get the name of the uploaded file
			*/
			fileSelected: 'fileSelected',
			/* cancel="true" Defines the name of the file uploading event. Fired every time when fileuploader get status for the upload. 
			Return false in order to cancel uploading file.
			Function takes arguments evt and ui.
			Use ui.fileId to get unique identifier of the file
			Use ui.filePath to get the name of the uploaded file
			Use ui.totalSize to get the file size of the uploaded file
			Use ui.uploadedBytes to get uploaded bytes
			Use ui.fileStatus to get current file status
			*/
			fileUploading: 'fileUploading',
			/* Defines the name of the uploaded event. Fired when the file is uploaded 
			Function takes arguments evt and ui.
			Use ui.fileId to get unique identifier of the file
			Use ui.filePath to get the name of the uploaded file
			Use ui.totalSize to get the file size of the uploaded file
			*/
			fileUploaded: 'fileUploaded',
			/* Defines the name of the file upload cancel event. Fired when the server responses that the file is canceled.
			Function takes arguments evt and ui.
			Use ui.fileId to get unique identifier of the file
			Use ui.filePath to get the name of the uploaded file
			Use ui.totalSize to get the file size of the uploaded file
			Use ui.uploadedBytes to get uploaded bytes
			Use ui.fileStatus to get current file status
			*/
			fileUploadAborted: 'fileUploadAborted',
			/* Defines the name of the cancel all button event click. Fired when cancel all button in summary is clicked. Fired only in multiple upload mode. 
			Function takes argument evt
			*/
			cancelAllClicked: 'cancelAllClicked',
			/* Defines the name of the file upload error event. Fired when error is occurred. 
			Function takes arguments evt and ui.
			Use ui.errorCode to get current errorCode
			Use ui.errorMessage to get detailed error description
			Use ui.errorType to get error type - it could be clientside or serverside
			Use ui.serverMessage to get specific server message returned by server - if errorType is serverside
			*/
			onError: 'onError',
			/* cancel="true" It is fired when validating file extensions
			Function takes arguments evt and ui.
			Use ui.fileName to get the full file name
			Use ui.fileExtension to get file extension 
			*/
			fileExtensionsValidating: 'fileExtensionsValidating'
		},
		summaryButtonModes: {
			cancel: 1,
			startupload: 2,
			done: 3
		},
		container: function () {
			// M.H. 25 Jul 2011 - fix bug 78056: add description about this function
			/*
			Return jquery object of fileupload container - html DOM element
			*/
            // M.H. 7 Feb 2014 Fix for bug #163735: WebIDE requires the outer element of igUpload to be with the same ID as the element(on which control is initialized) ID
            if (this._isDivElement) {
                return this.element;
            }
			return $('#' + this.element[0].id + "_wrprinit");
		},
		widget: function () {
			/*
			Returns the current widget element
			*/
			return this.element;
		},

		_id: function (suffix, formNumber) {
			var id = this.element[0].id;

			if (formNumber !== undefined) {
				return id + '_' + formNumber + '_' + suffix;
			}

			return id + suffix;
		},

		_create: function () {
			/* create file upload element */
			var data = {
					formNumber: 0, //current form number - we use it to generate form ids
					iframe: {ids: []},
					pendingQueueIDs: [], // maxSimultaneousFilesUploads feature - keep IDs
					uploadingIDs: [], // maxSimultaneousFilesUploads feature 
					batch: [], // maxSimultaneousFilesUploads feature 
					lastId: -1,

					//////////////////////////////////////////////////////////////
					filesInfo: [],// Format fileInfo: {path:"", key: "", sizeBytes: "", uploadedBytes: "", status: self._const.status.NotStarted, checksNoSuchFile: 0}
					countUploadingFiles: 0,
					countTotalFiles: 0,
					fileSizeUploaded: 0,
					fileSizeTotal: 0
				};
			this.allCancelled = false;
			this.fileInfoData = data;
			this._renderStartupBrowseButton();
			this.container()
				.bind("drop", $.proxy(this._dropFiles, this))
				.width(this.options.width)
				.height(this.options.height);
			this._attachFakeIframe();
			// M.H. 27 Jul 2011 - fix bug 77162 - analyze file extension icons array
			this._analyzeFileExtensionIcons();
			// M.H. 12 Dec 2012 Fix for bug #129351
			$(document).bind("dragenter." + this.element[0].id, $.proxy(this._docEnter, this));
			$(document).bind("dragover." + this.element[0].id, $.proxy(this._docOver, this));
			$(document).bind("dragleave." + this.element[0].id, $.proxy(this._docLeave, this));
		},
		_dropFiles: function (e) {
			var isInit = $('#' + this._id('_ibb')).is(':visible'),
				data = {files: e.originalEvent.dataTransfer.files, multiple: true};

			e.preventDefault();
			if (isInit) {
				this._initBrowserFileSelect(e, data);
			} else {
				this._onBrowseButtonFileSelected(e, false, data);
			}
			return false;
		},
		_docEnter: function (e) {
			e.preventDefault();
			return false;
		},
		_docOver: function (e) {
			e.preventDefault();
			return false;
		},
		_docLeave: function (e) {
			e.preventDefault();
			return false;
		},
		// M.H. 27 Jul 2011 - fix bug 77162
		_analyzeFileExtensionIcons: function () {
			// analyze file extension icons array
			// check extensions as each object in array has different and unique values for ext array
			// This method is created because jQuery widget factory extends default array
			var i, j,
				arrIconExtensions = this.options.fileExtensionIcons,
				lengthIconExtensions,
				defIconExtensions = $.extend(true, [], this.defaultFileExtensionIcons),
				lengthDefaultIconExtensions = defIconExtensions.length,
				resArr = [], isDefaultDefined = false;

			if (arrIconExtensions === undefined || arrIconExtensions === null) {
				// M.H. 1 Aug 2011 - fix bug 83355
				this.options.fileExtensionIcons = defIconExtensions;
				return;
			}

			lengthIconExtensions = arrIconExtensions.length;
			if (lengthIconExtensions === 1 && arrIconExtensions[0].css === '') {
				this.options.fileExtensionIcons = defIconExtensions;
				return;
			}

			for (j = 0; j < lengthIconExtensions; j++) {
				for (i = 0; i < lengthDefaultIconExtensions; i++) {
					defIconExtensions[i].ext = this._removeCommonElementsInArrays(defIconExtensions[i].ext, arrIconExtensions[j].ext);
				}
				// M.H. 8 Nov. 2011 Fix for bug #77162
				if (arrIconExtensions[j].def === true) {
					isDefaultDefined = true;
				}

				resArr.push(arrIconExtensions[j]);
			}

			for (i = 0; i < lengthDefaultIconExtensions; i++) {
				// M.H. 8 Nov. 2011 Fix for bug #77162
				if (defIconExtensions[i].ext.length > 0 ||
						(isDefaultDefined === false && defIconExtensions[i].def === true)) {
					resArr.push(defIconExtensions[i]);
				}
			}

			this.options.fileExtensionIcons = resArr;
		},
		_removeCommonElementsInArrays: function (arr1, arr2) {
			// remove from arr1 all common elements with arr2
			return $.grep(arr1, function (n) {
				return $.inArray(n, arr2) === -1;
			});
		},

		_attachFakeIframe: function () {
			var idTempIframe = this._id('_tempIframe');

			// fix bug with status toolbar in IE as adding blank iframe
			if ($.ig.util.isIE7 || $.ig.util.isIE8 || $.ig.util.isIEQuircks) {
				$('#' + idTempIframe).remove();
				setTimeout($('<iframe src="javascript:false;" id="' + idTempIframe + '" style="display: none;"></iframe>').appendTo($('#' + this._id('_fu'))), 300);
			}
		},
		_renderStartupBrowseButton: function () {
			/* render the button at the startup */
			var self = this, attr, i,
				css = self.css,
				e = self.element,
				o = self.options,
				bbId = this._id('_ibb'),
				isMultipleFiles = (o.mode === 'multiple' && o.multipleFiles),
				wrapperElementId = this._id('_wrprinit'),
				containerDiv,
				//divElement = e,
				button;

			// M.H. 7 Feb 2014 Fix for bug #163735: WebIDE requires the outer element of igUpload to be with the same ID as the element(on which control is initialized) ID
			if (this.element.is('div')) {
				this._isDivElement = true;
				this.originalElement = e;
				containerDiv = e;
				this._initialAttributes = [];
				attr = this.element[0].attributes;
				for (i = 0; i < attr.length; i++) {
					if (attr[i].name !== 'id') {
						this._initialAttributes.push({ name: attr[i].name, value: attr[i].value});
					}
				}
				this._initialHTML = this.element.html();
				this.element.empty();
			} else {
				this.originalElement = e;
				// M.H. 10 May 2011 - fix bug 75039: remove unnecessary comment and unnecessary spacing
				// K.D. May 18, 2011 Bug #75049 The ID of the elements concatenates twice as this._id is called
				// above in the definition of the variables
				containerDiv = '<div id="' + wrapperElementId + '" class="ig-upload-container"></div>';
				e.wrap(containerDiv);
				e.hide();
				e  = $('#' + wrapperElementId);
			}
			// we should re-initialize the id of browse button
			bbId = this._id('_ibb');
			// M.H. 10 May 2011 - fix bug 75039: remove unnecessary comment and unnecessary spacing

			if ($.ig.util.isIE7) {
				e.addClass(css.baseClassIE7);
			} else if ($.ig.util.isOpera) {
				e.addClass(css.baseClassOpera);
			} else if ($.ig.util.isOpera) {
				e.addClass(css.baseClassMoz);
			} else if ($.ig.util.isOpera) {
				// M.H. 29 May 2011 - fix bug 80546: add check for webkit browser
				e.addClass(css.baseClassWebkit);
			}
			button = $('<button></button>').appendTo(e).attr('id', bbId).addClass(css.startupBrowseButtonClasses);
			button.igBrowseButton({
				multipleFiles: isMultipleFiles,
				labelText: o.labelUploadButton,
				// M.H. 13 Feb 2014 Fix for bug #164347: Move input type="file" from document body to the upload container
				container: this.container(),
				// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
				// Fix bug #76995 M.H. 25 May 2011
				title: $.ig.Upload.locale.titleUploadFileButtonInit,
				fileselect: function (event, data) {
					self._initBrowserFileSelect(event, data);
				},
				// M.H. 26 Jul 2011 - fix bug 82062 - set disabled of the init browse button
				disabled: o.disabled,
				click: function (event) {
					// M.H. 11 May 2011 - fix bug 74553 - allow to cancel file selecting
					var isCancelEvent = false;
					if (self._trigger(self.events.fileSelecting, event) === false) {
						isCancelEvent = true;
					}

					return !isCancelEvent;
				}
			});
		},
		_initBrowserFileSelect: function (event, data) {
			// M.H. 17 Dec 2012 Fix for bug #129469
			var countFiles = 1, filePicker;

//			if (data && data.files && data.files.length >= 1) {
//				countFiles = data.files.length;
//                tmpCountFiles = countFiles;
//				for (i = 0; i < countFiles; i ++) {
//					if (this._validateFileExtension(data.files[i].name, true) === false) {
//                        tmpCountFiles--;
//						continue;
//					}
//				}
//                countFiles = tmpCountFiles;
//			} else {
			if (!data || !data.files || data.files.length === 0) {
				filePicker = $('#' + this._id('_ibb_fp'));
				if (this._validateFileExtension(filePicker[0].value, true) === false) {
					return;
				}
			}

			// M.H. 17 Dec 2012 Fix for bug #129469
			if (this._checkMaxUploadingFilesCount(countFiles, true) === true) {
				$('#' + this._id('_ibb')).css({'display': 'none'});
				this._HTMLUpload();
				this._onBrowseButtonFileSelected(event, true, data);
			}
			//$(this).remove();//fix for IE7 because when set css to be with display none the css is not updated
		},
		_HTMLUpload: function () {
			/* render html at the beginning for the main container  */
			var uploaderId = this._id('_fu'),
				baseMainContainerId = this._id('_bmncntr'),
				o = this.options,
				e = this.container(),
				self = this,
				css = self.css,
				fileContainerId = this._id('_fc'),
				browseButtonId = this._id('_bb'),
				clearAllButtonId = this._id('_clrabtn'),
				uploaderContainerId = this._id('_fi_main_cntnr'),
				clearAllButton,
				html = '';

			if (o.mode === 'single') {
				html += '<div  class="' + css.singleDialogClass + '" id="$baseMainContainerId">';
				html += '   <div id="$uploaderId$" class="$baseMainContainerClass">';
				html += '       <div id="$fileContainerId$"></div>';
				html += '       <button id="$browseButtonId$" class="$browseButtonClass$"></button>';
				html += '   </div>';
				html += '</div>';
			} else if (o.mode === 'multiple') {
				html =  '<div class="' + css.multipleDialogClasses + '" id="$baseMainContainerId">';
				html +=  '   <div  id="$uploaderId$" class="$baseMainContainerClass">';
				html += '       <div id="$uploaderFilesContainer" class="$fuMainContainerClass">';
				html += '           <button id="$browseButtonId$" class="$browseButtonClass$"></button>';
				html += '           <button id="$clearAllButtonId$"></button>';
				html += '           <div id="$fileContainerId$"></div>';
				html += '       </div>';
				html += '   </div>';
				html += '</div>';
			}
			html = html.replace('$uploaderId$', uploaderId).replace("$browseButtonId$", browseButtonId).replace("$baseMainContainerId", baseMainContainerId).replace("$browseButtonClass$", css.browseButtonClass).replace("$fileContainerId$", fileContainerId).replace("$clearAllButtonId$", clearAllButtonId).replace("$uploaderFilesContainer", uploaderContainerId).replace("$fuMainContainerClass", css.fileInfoMainContainer).replace("$baseMainContainerClass", css.baseMainContainerClass);

			$(html).appendTo(e).css({width: o.width, height: o.height}).addClass(css.baseClass);
			// Fix bug 77116 M.H. remove draggable feature
			// Draggable feature
			//$('#' + baseMainContainerId).draggable({ cancel: '#' + uploaderContainerId});
			// End of draggable feature
			clearAllButton = $('#' + clearAllButtonId);
			if (clearAllButton.length > 0) {
				clearAllButton.igButton({
					// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
					title: $.ig.Upload.locale.titleClearAllButton,
					labelText: o.labelClearAllButton,
					disabled: true,
					click: function (event) {
						event.preventDefault();
						self.clearAll();
					},
					css: {
						"buttonClasses"                         : "ui-igbutton ui-igupload-button-clear-all",
						"buttonHoverClasses"                    : "",
						"buttonActiveClasses"                   : "", // when button is clicked 
						"buttonFocusClasses"                    : "", // when button get focus
						"buttonLabelClass"                      : ""
					}
				});
			}

			$('#' + browseButtonId).igBrowseButton({
				multipleFiles: (o.mode === 'multiple' && o.multipleFiles),
				labelText: this.options.labelAddButton,
				// M.H. 13 Feb 2014 Fix for bug #164347: Move input type="file" from document body to the upload container
				container: this.container(),
				// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
				title: $.ig.Upload.locale.titleAddFileButton,
				//icons: {primary: "ui-icon-plusthick"}
				fileselect: function (event, data) {
					self._onBrowseButtonFileSelected(event, false, data);
				},
				click: function (event) {
					// M.H. 11 May 2011 - fix bug 74553 - allow to cancel file selecting
					var isCancelEvent = false;

					if (self._trigger(self.events.fileSelecting, event) === false) {
						isCancelEvent = true;
					}
					return !isCancelEvent;
				}
			});

			$('#' + fileContainerId).addClass(css.containerClass);

			if (o.mode === 'multiple') {
				self._spbRenderInit();
			}
		},

		_disableBrowseButton: function (isToDisable) {
			$('#' + this._id('_bb')).igBrowseButton('option', 'disabled', isToDisable);
			$('#' + this._id('_ibb')).igBrowseButton('option', 'disabled', isToDisable);
		},
		_checkMaxUploadingFilesCount: function (count, callEvent) {
			if (count === null || count === undefined) {
				count = 1;
			}
			var o = this.options,
				allowUpload = true,
				totalFiles = this.fileInfoData.countTotalFiles + count;
			//totalFiles= (beforeUpload === true)? totalFiles + 1: totalFiles;
			if (o.maxUploadedFiles !== this._const.maxUploadFilesDefault && o.maxUploadedFiles !== null && totalFiles > o.maxUploadedFiles) {
				allowUpload = false;
				// M.H. 17 Dec 2012 Fix for bug #129469
				if (callEvent === true) {
					this._setError(o.errorMessageMaxUploadedFiles, this._const.clientSideErrorCode.maxAllowedUploadingFiles, 'clientside');
				}
			}

			return allowUpload;
		},
		_onBrowseButtonFileSelected: function (event, isInitBrowseButton, data) {
			// Event handler when file is selected
			// event - event object of click
			// isInitBrowseButton - bool parameter indicates whether the method is called by browsebutton in main container or at the startup
			var self = this, fileData = this.fileInfoData,
				o = self.options,
				countFiles = 1;

			if (data && data.files && data.files.length >= 1) {
				countFiles = data.files.length;
			}
			// check maximum allowed uploading files
			if (self._checkMaxUploadingFilesCount(countFiles, true) === false) {
				// M.H. 17 Dec 2012 Fix for bug #129478
				if (data.multiple === true) {
					return;
				}
				self._disableBrowseButton(true);
				return;
			}
			if (o.maxUploadedFiles !== null && o.maxUploadedFiles !== this._const.maxUploadFilesDefault && o.maxUploadedFiles === (fileData.countTotalFiles + countFiles)) {
				self._disableBrowseButton(true);
			}
			if (o.mode === 'single') {
				// check if previous file(if exists) is uploaded                
				if (fileData.iframe.ids.length === 0) {
					self._removeSingleUpload(fileData.lastId);
					if (self._attachIframe(event, isInitBrowseButton, fileData.files) === true) {
						self._disableBrowseButton(true);
					}
				}
			} else if (o.mode === 'multiple') {
				// attach Iframe
				// M.H. 2 June 2011 - fix bug 77157
				if (self._attachIframe(event, isInitBrowseButton, data) === false) {
					self._disableBrowseButton(false); // enable browse button if could not attach iframe - e.g. validation is not correct
				}
			}
		},

		clearAll: function () {
			/*
			Hide finished files
			*/
			var e = this.container(), arr = e.data('finishedIDs'), id, l;

			if (arr === undefined) {
				return;
			}
			l = arr.length;
			for (id = 0; id < l; id++) {
				this._removeSingleUpload(arr[id]);
			}

			arr = [];
			e.data('finishedIDs', arr);
			this._disableClearAllButton();
		},
		_enableClearAllButton: function () {
			$('#' + this._id('_clrabtn')).igButton({disabled: false});
		},
		_disableClearAllButton: function () {
			$('#' + this._id('_clrabtn')).igButton('option', 'disabled', true);
		},
		_attachIframe: function (event, isInitBrowseButton, data) {
			var res, files, filePicker,
				browse = $('#' + this._id('_bb'));

			if (data && data.files) {
				files = data.files;
			}
			if (isInitBrowseButton === true) {
				filePicker = $('#' + this._id('_ibb')).igBrowseButton('getFilePicker');
			} else {
				filePicker = browse.igBrowseButton('getFilePicker');
			}
			if (filePicker[0].files && (files === null || files === undefined)) {
				files = filePicker[0].files;
			}
			if (files && files.length >= 1) {
				res = this._uploadMultiple(files);
				filePicker.remove();
			} else {
				res = this._createForm(filePicker);
			}
			return res;
		},
		_uploadMultiple: function (files) {
			var	res, i,
				filesLength = files.length,
				data = this.fileInfoData,
				fileId = data.formNumber;

			for (i = 0; i < filesLength; i++) {
				res = this._html5createForm(files[i], i, fileId);
			}
			return res;
		},
		_html5upload: function (fileId) {
			var xhr = new XMLHttpRequest(),
				formData = new FormData(),
				o = this.options,
				self = this,
				file = this.fileInfoData.filesInfo[fileId].file,
				key = this.fileInfoData.filesInfo[fileId].key,
				cid = o.controlId,
				upload = xhr.upload,
				uploadUrl = o.uploadUrl + '?key=' + key + '&cid=' + cid + '&multiple=true';
				//start_time = new Date().getTime(),
				//max_file_size = 1048576 * opts.maxfilesize;

			xhr.open("POST", uploadUrl);
			xhr.withCredentials = "true";
			formData.append(this._id('_frm', fileId) + '_if', file);
			upload.addEventListener("progress", function (e) {
				self._html5progress(e, fileId);
			}, false);

			upload.addEventListener("error", function (e) {
				//self._removeUploadSetError(fileId, 'server side error', 'error', 'serverside', '');
				self._getFileStatus(fileId, true);
			}, false);

			this.fileInfoData.filesInfo[fileId].xhr = xhr;
			xhr.onload = function (e) {
				var response, error;
				if (xhr.status >= 200 && xhr.status <= 299) {
					response = xhr.responseText;
					if (response) {
						error = response.substring(response.indexOf('<error>'), response.indexOf('</error>'))
                                .replace('<error>', '');
						if (error !== '') {
							error = parseInt(error, 10);
							if (!isNaN(error)) {
								self._getFileStatus(fileId, true);
								return;
							}
						}
						//var now = new Date().getTime();//timeDiff = now - start_time;
						self._html5progress(e, fileId, true);
					}
				} else {
					self._getFileStatus(fileId, true);
				}
			};
			xhr.send(formData);
		},
		_html5progress: function (e, formNumber, isFinish) {
			var self = this, singleFileData, data = {};

			if (e.lengthComputable || isFinish) {
				data.bytesUploaded = e.loaded;
				if (isNaN(data.bytesUploaded)) {
					data.bytesUploaded = 0;
				}
				if (isNaN(e.total)) {
					e.total = 0;
				}
				singleFileData = this._getFileInfo(formNumber);
				// M.H. 15 May 2014 Fix for bug #170990: If file uploading was canceled on the way at client side and using Chrome, the canceled files except for the first canceled one persist to appear on the display.
				if (singleFileData && singleFileData.innerStatus === self._const.status.Canceled) {
					return;
				}
				if (isFinish) {
					data.total = data.bytesUploaded = singleFileData.sizeBytes;
					data.status = self._const.status.Finished;
				} else {
					data.status = self._const.status.Started;
				}
				data.size = e.total;
				self._setFileStatus(formNumber, true, data);
			} else {
				//TODO throw an error
				self.cancelUpload(formNumber);
			}
		},
		_html5createForm: function (fileInfo, ind, formNumber) {
			var self = this, o = self.options,
				//fileInfo = $filePicker[0].files[ind],
				fileName = fileInfo.name,
				fileSize = fileInfo.size,
				data = this.fileInfoData,
				fileId = data.formNumber++,
				key = self._randomString(30),
				status = self._const.status.Started;
			if (self._validateFileExtension(fileInfo.name, true) === false) {
				// when validation failed it should be shown properly summary progress bar information
				if (o.mode === 'multiple') {
					self._spbRenderProgress();
				}
				// M.H. Fix bug 77157 - when validation failed check count of max uploaded files is greater or equal than current files count - if so enable browse button
				if (o.maxUploadedFiles !== null && o.maxUploadedFiles >= (data.countTotalFiles + 1)) {
					self._disableBrowseButton(false);
				}

				return false;
			}
			if (isNaN(fileSize)) {
				fileSize = 0;
			}
			// _spb feature
			// checksNoSuchFile - count of requests to the handler if it returns no such file status
			data.filesInfo[fileId] = {
				path: fileName,
				key: key,
				sizeBytes: fileSize,
				uploadedBytes: 0,
				status: self._const.status.NotStarted,
				checksNoSuchFile: 0,
				innerStatus: self._const.status.NotStarted,
				multipleFiles: true,
				file: fileInfo,
				formNumber: formNumber
			};

			data.countTotalFiles++;
			self._spbRenderProgress();
			self._HTMLSingleUpload(fileId);
			this._saveFileSize(fileSize, fileId);
			if (o.autostartupload === true) {
				// in multiple upload mode - if we can upload - check the number for maxSimultaneousFilesUploads
				if (self._checkCanUpload() === true) {
					self.startUpload(fileId);
					// M.H. 27 Jul 2011 - fix bug 77339
					//self._addUploadingID(fileId);
				} else {
					self._addPendingId(fileId);
					status = self._const.status.NotStarted;
					// if could not start upload because maxSimultaneousFilesUploads then get file size
				}
			} else {
				// M.H. 23 Jan 2013 Fix for bug #130729
				if (o.mode === 'single') {
					self._showSingleUploadStartUpload(true, fileId);
				} else {
					// autostartupload is false - then add to pending IDs
					self._addIDBatch(fileId);
					status = self._const.status.NotStarted;
				}
			}

			data.iframe.ids[data.iframe.ids.fileId] = {id: fileId, status: status};
			if (o.mode === 'multiple') {
				self._spbCheckModeButton();
			}
			self._trigger(self.events.fileSelected, null, {fileId: fileId, filePath: self._getOnlyFileName(fileName)});
			return true;
		},
		_createForm: function (filePicker) {
			var self = this, o = self.options,
				data = this.fileInfoData,
				fileId = data.formNumber++,
				iframeId = this._id('_ifrm', fileId),
				formId = this._id('_frm', fileId),
				form,
				key = self._randomString(30),
				status = self._const.status.Started,
				cid = o.controlId,
				uploadUrl = o.uploadUrl + '?key=' + key + '&cid=' + cid;

			if (self._validateFileExtension(filePicker[0].value, true) === false) {
				// we need to remove DOM element( <input type=file />) because we don't need of it anymore
				filePicker.remove();
				// when validation failed it should be shown properly summary progress bar information
				if (o.mode === 'multiple') {
					self._spbRenderProgress();
				}
				// M.H. Fix bug 77157 - when validation failed check count of max uploaded files is greater or equal than current files count - if so enable browse button
				if (o.maxUploadedFiles !== null && o.maxUploadedFiles >= (data.countTotalFiles + 1)) {
					self._disableBrowseButton(false);
				}

				return false;
			}
			// _spb feature
			// checksNoSuchFile - count of requests to the handler if it returns no such file status
			data.filesInfo[fileId] = {path: filePicker.val(), key: key, sizeBytes: 0, uploadedBytes: 0, status: self._const.status.NotStarted, checksNoSuchFile: 0, innerStatus: self._const.status.NotStarted};

			data.countTotalFiles++;
			self._spbRenderProgress();
			// //end of _spb feature

			// DO NOT set id and name as attribute because in IE7 does not work properly - on start upload opens new browser
			$('<iframe src="javascript:false;" id="' + iframeId + '" name="' + iframeId + '"></iframe>').appendTo($(document.body)).css({'display': 'none'});
			form = $('<form method="post" enctype="multipart/form-data"></form>').attr('id', formId).attr('target', iframeId).attr("action", uploadUrl).appendTo($(document.body));

			filePicker.attr('name', formId + '_if').attr('id', formId + '_if').appendTo(form);
			self._HTMLSingleUpload(fileId);
//            if (o.mode === 'single') {
//                self.startUpload(fileId);
//            } else {
			if (o.autostartupload === true) {
				// in multiple upload mode - if we can upload - check the number for maxSimultaneousFilesUploads
				if (self._checkCanUpload() === true) {
					self.startUpload(fileId);
					// M.H. 27 Jul 2011 - fix bug 77339
					//self._addUploadingID(fileId);
				} else {
					self._addPendingId(fileId);
					status = self._const.status.NotStarted;
					// if could not start upload because maxSimultaneousFilesUploads then get file size
					self._getFileSize(fileId, key);
				}
			} else {
				if (o.mode === 'single') {
					self._showSingleUploadStartUpload(true, fileId);
					self._getFileSize(fileId, key);
				} else {
					// autostartupload is false - then add to pending IDs
					self._addIDBatch(fileId);
					status = self._const.status.NotStarted;
					self._getFileSize(fileId, key);
				}
				// _spb feature batch
			}

			data.iframe.ids[data.iframe.ids.fileId] = {id: fileId, status: status};
			if (o.mode === 'multiple') {
				self._spbCheckModeButton();
			}

			self._trigger(self.events.fileSelected, event, {fileId: fileId, filePath: self._getOnlyFileName(filePicker.val())});
			return true;
		},

		_showSingleUploadStartUpload: function () {
			// check if exists such button
			// if not exists add to markup
			var self = this,
				o = self.options,
				startUploadButtonId = '_strtuplbtn',
				startUploadButton = $('#' + this._id(startUploadButtonId)),
				browseButton = $('#' + this._id('_bb'));

			if (startUploadButton.length === 0) {
				// add the button to markup
				$('<button id="' + self._id(startUploadButtonId) + '"></button>').appendTo($('#' + self._id('_fu'))).igButton({
					labelText: o.labelSummaryProgressButtonContinue,
					// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
					title: $.ig.Upload.locale.titleSingleUploadButtonContinue,
					click: function (e) {
						e.preventDefault();
						self.startUpload((self.fileInfoData.formNumber - 1), e);
						// M.H. 27 Jul 2011 - fix bug 77339
						// it should be called because bug 72252
						browseButton.igBrowseButton('attachFilePicker', e, true);
					}
				});
				startUploadButton = $('#' + this._id(startUploadButtonId));
			}
			browseButton.hide();
			startUploadButton.show();
		},

		_removeIframe: function (iframeNumber) {
			var self = this,
				data = this.fileInfoData,
				iframeId = this._id('_ifrm', iframeNumber),
				formId = this._id('_frm', iframeNumber),
				browseButton = $('#' + self._id('_bb'));

			$('#' + iframeId).remove();
			$('#' + formId).remove();
			data.iframe.ids = self._removeElementArrayById(data.iframe.ids, iframeNumber);
			if (self.options.mode === 'single') {
				browseButton.igBrowseButton('option', 'disabled', false);
				data.lastId = iframeNumber;
			}
			this._attachFakeIframe();
		},
		_HTMLSingleUpload: function (formNumber) {
			var self = this,
				o = this.options,
				css = self.css,
				fileContainerId = self._id('_fc'),
				fileUploadStatusId =  self._id('_fus', formNumber),
				singleProgressBarId =  self._id('_snglpbar', formNumber),
				iconId =  self._id('_icn', formNumber),
				cancelButtonId = self._id('_cbtn', formNumber),
				fileContainer = $('#' + fileContainerId),
				fileName = this.fileInfoData.filesInfo[formNumber].path,
				html,
				progressBarFileNameId = self._id('_pbrflnm', formNumber),
				progressBarFileSizeId = self._id('_pbrflsz', formNumber),
				progressBarFileName,
				singleProgressBar,
				iconClass = self._getFileExtensionIconPath(self._getFileExtension(fileName));// progressbar inner html

			html =      '<div id="' + fileUploadStatusId + '">';
			html +=     '   <div class="' + css.containerFUS + '">';
			html +=     '       <div class="' + css.containerButtonCancelClass + '">';
			html +=     '           <button id="' + cancelButtonId + '"></button>';
			html +=     '       </div>';
			html +=     '       <div class="' + css.progressContainer + '">';
			// M.H. 8 Nov. 2011 Fix for bug #77166
			html +=     '           <div class="' + css.progressBarInnerHTMLContainerClass + '" title="' + fileName + '">';
			html +=     '               <span id="' + iconId + '" class="' + iconClass + '"></span>';
			html +=     '               <span class="' + css.progressBarFileNameClass + '" id="' + progressBarFileNameId + '"></span>';
			html +=     '               <span class="' + css.progressBarFileSizeClass + '" id="' + progressBarFileSizeId + '"></span>';
			html +=     '           </div>';
			html +=     '           <div id="' + singleProgressBarId + '" class="' + css.progressBarUploadClass + '"></div>';
			html +=     '       </div>';
			html +=     '   </div>';
			html +=     '</div>';


			$(html).appendTo(fileContainer);
			$('#' + fileUploadStatusId).addClass(css.uploadProgressClass + ' ' + css.clearClass);
			singleProgressBar = $('#' + singleProgressBarId);
			$('#' + cancelButtonId).igButton({
				onlyIcons: true,
				icons: {primary: 'ui-icon-closethick'},
				// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
				title: $.ig.Upload.locale.titleCancelUploadButton,
				click: function (event) {
					// M.H. 11 May 2011 - fix bug 75137 - prevent default
					event.preventDefault();
					self.cancelUpload(formNumber);
					$('#' + cancelButtonId).igButton('option', 'disabled', true).igButton('option', 'icons', {primary: 'ui-icon-check', secondary: null});
				},
				css: {
					"buttonClasses"                         : "ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only ui-igbutton ui-igupload-cancel-button",
					"buttonHoverClasses"                    : "ui-state-hover",
					"buttonActiveClasses"                   : "ui-state-active", // when button is clicked 
					"buttonFocusClasses"                    : "ui-state-focus", // when button get focus
					"buttonLabelClass"                      : "ui-button-text",
					"buttonDisabledClass"                   : "ui-state-disabled",
					"buttonPrimaryIconClass"                : "ui-button-icon-primary ui-icon",
					"buttonMainElementPrimaryIconClass"     : " ui-button-text-icon-primary",
					"buttonMainElementSecondaryIconClass"   : " ui-button-text-icon-secondary",
					"buttonSecondaryIconClass"              : "ui-button-icon-secondary ui-icon",
					"buttonIconsOnly"                       : "ui-button-icons-only",
					"buttonIconOnly"                        : "ui-button-icon-only",
					"buttonIcons"                           : "ui-button-text-icons",
					"buttonTextOnlyClass"                   : "ui-button-text-only"
				}
			});

			singleProgressBar.igProgressBar({
				animate: self._const.isProgressBarAnimationEnabled,
				animateTimeout: self._const.animateProgressBarInterval,
				range: self._const.isProgressBarRange,
				value: 0,
				queue: false
			});
            if (!o.showFileExtensionIcon) {
				$('#' + iconId).css('display', 'none');
			}
            progressBarFileName = $('#' + progressBarFileNameId);
			fileName = self._getOnlyFileName(fileName);
			singleProgressBar.data('originalFileName', fileName);
			if (fileName.length > self._const.fileNameLimit) {
				fileName = fileName.substr(0, self._const.fileNameLimit);
			}
			progressBarFileName.text(self._formatFilePath(fileName));
			// M.H. 10 May 2011 - fix bug 74272
			self._renderFileName(formNumber, 0, fileName);
		},

		// M.H. 10 May 2011 - fix bug 74272: add method to render FileName properly in file upload info
		_renderFileName: function (formNumber, fileSize, fn) {
			var self = this,
				o = self.options,
				fileName = fn,
				previousFileName = '',
				originalFileSize,
				progressBarFileName = $('#' + self._id('_pbrflnm', formNumber)),
				progressBarFileSize = $('#' + self._id('_pbrflsz', formNumber)),
				singleProgressBarWidth = $('#' + self._id('_snglpbar', formNumber)).width(),
				singleProgressBar = $('#' + self._id('_snglpbar', formNumber)),
				progressBarFileSizeWidth = progressBarFileSize.width();

			// M.H. 22 Aug 2012 Fix for bug #119469
			if (progressBarFileName.length === 0) {
				return;
			}
			if (fileName === undefined || fileName === null) {
				fileName = singleProgressBar.data('fileName');
			}
			// autotrim - check for the size
			if (singleProgressBarWidth <= 0) {
				fileName = o.labelProgressBarFileNameContinue;
				progressBarFileName.text(fileName);
			} else {
				if (fileSize !== 0 && fileSize !== undefined && fileSize !== null) {
					originalFileSize = progressBarFileSize.text();
					progressBarFileSizeWidth = progressBarFileSize.text(self._formatFileSize(fileSize) + '/' + self._formatFileSize(fileSize)).width();
					progressBarFileSize.text(originalFileSize);
				}

				while (progressBarFileName.position().left + progressBarFileName.width() + progressBarFileSizeWidth >= singleProgressBarWidth && (previousFileName !== fileName)) {
					previousFileName = fileName;
					fileName = fileName.substr(0, fileName.length / 2);
					if (previousFileName === fileName && fileName.length - 1 > 1) {
						fileName = fileName.substr(0, (fileName.length - 1) / 2);
					}
					progressBarFileName.text(fileName + o.labelProgressBarFileNameContinue);
				}

				if (progressBarFileName.position().left + progressBarFileName.width() + progressBarFileSize.width() >= singleProgressBarWidth) {
					fileName = o.labelProgressBarFileNameContinue;
				}
			}
			singleProgressBar.data('fileName', fileName);
		},

		_removeSingleUpload: function (formNumber) {
			var self = this,
				fileUploadStatusId =  self._id('_fus', formNumber),
				fileUploadStatusTmpId = fileUploadStatusId + '_' + self._randomString(20);
			if (self.options.mode === 'multiple') {
				$('#' + fileUploadStatusId).attr('id', fileUploadStatusTmpId);
				self._renderAnimatedRemovingUpload(fileUploadStatusTmpId);
			} else if (self.options.mode === 'single') {
				$('#' + fileUploadStatusId).hide().remove();
				//self._renderAnimatedRemovingUpload(fileUploadStatusId);
			}
		},

		_renderAnimatedRemovingUpload: function (id) {
			$('#' + id).slideUp(this._const.removeSingleUploadAnimationTimeout, function () {
				$(this).remove();
			});
		},

		startUpload: function (formNumber) {
			/* Start uploading file as submitting form with the specified formNumber.
				paramType="number" id of the upload form
				*/
			var self = this,
				formId = self._id('_frm', formNumber),
				fileData = this.fileInfoData,
				isHTML5 = false;

			if (formNumber === null || fileData.filesInfo[formNumber] === null || fileData.filesInfo[formNumber] === undefined) {
				self._setError(self.options.errorMessageTryToStartNonExistingFile.replace('{0}', formNumber), self._const.clientSideErrorCode.startUpload, 'clientside');
				return;
			}

			// M.H. 10 May 2011 - fix bug 74258: check file is with status NotStarted
			if (fileData.filesInfo[formNumber].status !== self._const.status.NotStarted) {
				return;
			}
			isHTML5 = fileData.filesInfo[formNumber].multipleFiles;
			if (isHTML5 !== true) {
				$('#' + formId).submit();
			} else {
				this._html5upload(formNumber);
			}
			// M.H. 27 Jul 2011 - fix bug 77339
			self._addUploadingID(formNumber);
			self._removeIDBatch(formNumber);
			self._spbCheckModeButton();
			// summary progress bar
			fileData.filesInfo[formNumber].status = self._const.status.Started;
			fileData.filesInfo[formNumber].innerStatus = self._const.status.Started;
			self._spbRenderProgress();
			// M.H. 27 Jul 2011 - fix bug 77339
			if (this.options.mode === 'single') {
				$('#' + self._id('_strtuplbtn')).hide();
				$('#' + self._id('_bb')).igBrowseButton('option', 'disabled', true).show();
			}
			if (isHTML5 === true) {
				return;
			}
			setTimeout(
				function () {
					self._getFileStatus(formNumber, true);
				},
				self._const.progressUpdateInterval
			);
		},
		_setFileStatus: function (formNumber, isNewFile, data) {
			var self = this, o = self.options,
				isFinishUpload = false,
				status = '', bytesUploaded = 0, fileSize = 0,
				singleFileData = this._getFileInfo(formNumber),
				fileData = this.fileInfoData,
				key = self._getKey(formNumber),
				fileDetails = fileData.filesInfo[formNumber],
				fileName = fileDetails.path,
				error, isError,
				serverMessage = '';

			if (key === null || key  === undefined) {
				return false;
			}

			bytesUploaded = parseInt(data.bytesUploaded, 10);
			status = parseInt(data.status, 10);
			fileSize = parseInt(data.size, 10);
			serverMessage = data.serverMessage;
			isFinishUpload = (status === self._const.status.Finished);
			error = parseInt(data.error, 10);
			isError = (!isNaN(error) && error !== self._const.fileStatusNoError);
			// _spb feature

			if (fileDetails.innerStatus === self._const.status.Canceled && isError) {
				self._setError(o.errorMessageOther.replace("{0}", error), error, 'serverside', serverMessage);
				return false;
			}
			if (isError === true && status !== self._const.status.NoSuchFile) {
				self._removeUploadSetError(formNumber, o.errorMessageOther.replace("{0}", error), error, 'serverside', serverMessage);
				return false;
			}

			if (singleFileData !== null && singleFileData.status !== self._const.status.Canceled) {
				fileData.fileSizeUploaded -= singleFileData.uploadedBytes;

				if (singleFileData.sizeBytes === 0 || singleFileData.sizeBytes === null) {
					singleFileData.sizeBytes = fileSize;
					fileData.fileSizeTotal += fileSize;
				} else if (singleFileData.sizeBytes !== fileSize) {
					// show in the right way file size when file size is taken first from getFileSize and then file is started
					// it is used the value taken from server from getFileSize
					fileSize = singleFileData.sizeBytes;
				}
				if (isFinishUpload) {
					fileData.countUploadingFiles++;
				}
				// M.H. 7 Jan 2013 Fix for bug #129538
				if (bytesUploaded === 0 && singleFileData.uploadedBytes > 0) {
					bytesUploaded = singleFileData.uploadedBytes;
				}
				singleFileData.uploadedBytes = bytesUploaded;
				singleFileData.status = status;
				fileData.fileSizeUploaded += singleFileData.uploadedBytes;
				self._spbRenderProgress();
				// M.H. 11 May 2011 - fix bug 74553: enable to cancel upload through event handler of fileUploading
				if (self._trigger(self.events.fileUploading, null, {fileId: formNumber, filePath: self._getOnlyFileName(fileName), totalSize: fileSize, uploadedBytes: bytesUploaded, fileStatus: status}) === false) {
					self.cancelUpload(formNumber);
				}
			}
			// // end of _spb feature
			if (isFinishUpload || status === self._const.status.Started) {
				if (isFinishUpload) {
					// SimultaneousFilesUploads feature
					self._removeUploadingID(formNumber);
					if (o.mode === 'multiple') {
						self._spbCheckModeButton();
						self._submitNextPendingId();
					}
				}
				self._renderStatus(formNumber, bytesUploaded, fileSize, isFinishUpload, isNewFile);
				if (!isFinishUpload) {
					return true;
				}
			} else if (status === self._const.status.NoSuchFile) {
				// double check - if it is not found file with such key send again request to the server
				if (fileDetails !== null && fileDetails !== undefined && fileDetails.checksNoSuchFile === 0) {
					fileDetails.checksNoSuchFile++;
					return true;
				}
				self._removeUploadSetError(formNumber, o.errorMessageNoSuchFile, 'nosuchfilekeyid', 'serverside', serverMessage);
			}
			return false;
		},
		_getFileStatus: function (formNumber, isNewFile) {
			var self = this, o = self.options,
				key = self._getKey(formNumber);

			if (key === null || key  === undefined) {
				return;
			}
			key = key.replace('-$#', '').replace('#$-', '');
			$.ajaxQueue('uploadrequestsqueue', {
				url: self._formatURL(o.progressUrl, $.param({'key': key, 'command': 'status'})),
				dataType: 'json',
				cache: false,
				success: function (data) {
					if (self._setFileStatus(formNumber, isNewFile, data) === true) {
						setTimeout(function () {
							self._getFileStatus(formNumber, false);
						}, self._const.progressUpdateInterval);
					}
				},
				error: function () {
					self._setError(o.errorMessageGetFileStatus, self._const.clientSideErrorCode.ajaxErrorGetFileStatus, 'clientside');
					// self._removeUploadSetError(formNumber, o.errorMessageGetFileStatus);
				}
			});
		},

		_removeUploadSetError: function (formNumber, errorMessage, errorCode, errorType, serverMessage) {
			var self = this, o = this.options;

			self._removeIframe(formNumber);
			self._removeFileUpload(formNumber);
			self._setError(errorMessage, errorCode, errorType, serverMessage);
			if (o.mode === 'multiple') {
				self._spbCheckModeButton();
				self._submitNextPendingId();
			}
		},

		cancelUpload: function (formNumber) {
			/* Cancel upload for the specified file id
				formNumber - id of the file to be canceled
				paramType="number" id of the form which should be cancelled
				*/
			var self = this,
				o = self.options,
				singleProgressBarId =  self._id('_snglpbar', formNumber),
				singleProgressBar = $('#' + singleProgressBarId),
				filePicker = $('#' + self._id('_frm', formNumber) + '_if'),
				fileName = filePicker.val(),
				totalSize = 0,
				bytesUploaded = 0,
				key = this._getKey(formNumber),
				singleFileInfo = this._getFileInfo(formNumber);

			totalSize = singleProgressBar.data('totalSize');
			bytesUploaded = singleProgressBar.data('bytesUploaded');
			if (totalSize === undefined) {
				totalSize = 0;
			}
			if (bytesUploaded === undefined) {
				bytesUploaded = 0;
			}

			//self._trigger(self.events.fileUploadCancelClick, null, {fileId: formNumber, filePath: self._getOnlyFileName(fileName), uploadedBytes: bytesUploaded, totalSize: totalSize});
			// _spb feature
			if (singleFileInfo !== null) {
				if (singleFileInfo.status === self._const.status.Started) {
					singleFileInfo.innerStatus = self._const.status.Canceled;
					if (singleFileInfo.multipleFiles === true) {
						singleFileInfo.xhr.abort();
						self._onCancelUpload(formNumber);
					} else {
						$.ajaxQueue('uploadrequestsqueue', {
							url: self._formatURL(o.progressUrl, $.param({'key': key, 'command': 'cancel'})),
							dataType: 'json',
							cache: false,
							success: function () {
								self._onCancelUpload(formNumber);
							},
							error: function () {
								self._setError(o.errorMessageCancelUpload, self._const.clientSideErrorCode.ajaxErrorCancelUpload, 'clientside');
								self._removeFileUpload(formNumber);
							}
						});
					}
					// end of _spb feature                
				} else if (singleFileInfo.status === self._const.status.NotStarted) {
					if (o.mode === 'single') {
						$('#' + this._id('_strtuplbtn')).hide();
						$('#' + this._id('_bb')).igBrowseButton('option', 'disabled', 'false').show();
					}
					self._trigger(self.events.fileUploadAborted, null, {fileId: formNumber, filePath: self._getOnlyFileName(fileName), uploadedBytes: 0, totalSize: totalSize, status: self._const.status.NotStarted });
					self._removeFileUpload(formNumber);
				}

				// M.H. 27 Jul 2011 - fix bug77257: check whether to disable browse button when countTotalFiles is updated - remove check for disabling browse button
			}
		},
		_onCancelUpload: function (formNumber) {
			var self = this,
				o = self.options,
				continueButton = null,
				totalSize = 0,
				bytesUploaded = 0,
				allIds = null,
				singleFileInfo = this._getFileInfo(formNumber),
				fileName = singleFileInfo.path;

			if (o.autostartupload === false && o.mode === 'multiple') {
				continueButton = $('#' + self._id('_spbtncncl'));
				allIds = continueButton.data('ids');
				allIds = self._removeElementFromArray(allIds, formNumber);
				continueButton.data('ids', allIds);
			}
			self._trigger(self.events.fileUploadAborted, null, {fileId: formNumber, filePath: self._getOnlyFileName(fileName), uploadedBytes: bytesUploaded, totalSize: totalSize, status: self._const.status.Canceled });
			self._removeFileUpload(formNumber);
		},
		_removeFileUpload: function (formNumber) {
			var self = this,
				o = self.options,
				cancelButtonId = self._id('_cbtn', formNumber),
				singleProgressBarId =  self._id('_snglpbar', formNumber),
				singleProgressBar = $('#' + singleProgressBarId),
				totalSize = 0,
				bytesUploaded = 0,
				fileData = this.fileInfoData,
				singleFileInfo = this._getFileInfo(formNumber);

			if (singleFileInfo === null) {
				self._setError(o.errorMessageTryToRemoveNonExistingFile.replace('{0}', formNumber), self._const.clientSideErrorCode.removeFileUpload, 'clientside');
				return;
			}

			totalSize = singleProgressBar.data('totalSize');
			bytesUploaded = singleProgressBar.data('bytesUploaded');
			if (totalSize === undefined) {
				totalSize = 0;
			}
			if (bytesUploaded === undefined) {
				bytesUploaded = 0;
			}

			// show summary progress
			fileData.countTotalFiles--;
			// if the file is started but not finished
			singleFileInfo.status = self._const.status.Canceled;
			fileData.fileSizeUploaded -= singleFileInfo.uploadedBytes;

			fileData.fileSizeTotal -= singleFileInfo.sizeBytes;
			self._spbRenderProgress();

			if (o.mode === 'multiple') {
				// maxSimultaneousFilesUploads feature
				self._removeUploadingID(formNumber);
				self._removePendingId(formNumber);
				self._removeIDBatch(formNumber);

				if (this.allCancelled === false) {
					self._submitNextPendingId();
				}
				self._spbCheckModeButton();
			}

			$('#' + cancelButtonId).remove();
			self._removeIframe(formNumber);
			self._removeSingleUpload(formNumber);

			// M.H. 27 Jul 2011 - fix bug77257: check whether to disable browse button when countTotalFiles is updated
			// check maximum allowed uploading files
			self._disableBrowseButton(!self._checkMaxUploadingFilesCount());
		},

		_getKey: function (formNumber) {
			var a = this.fileInfoData.filesInfo[formNumber];
			if (a !== null && a !== undefined) {
				return a.key;
			}
			return null;
		},

		_singleFileUploadFinished: function (formNumber) {
			var e = this.container(), self = this, arr;

			$('#' + self._id('_cbtn', formNumber)).igButton('option', 'disabled', true).igButton('option', 'icons', {primary: 'ui-icon-check', secondary: null});

			self._removeIframe(formNumber);

			if (self.options.mode === 'multiple') {
				self._enableClearAllButton();
				arr = e.data('finishedIDs');
				if (arr === undefined) {
					arr = [];
				}
				arr.push(formNumber);
				e.data('finishedIDs', arr);
			}
		},

		_renderStatus: function (formNumber, bytesUploaded, fileSize, isFinished) {
			var self = this,
				originalFileName,
				statusLabel = $('#' + self._id('_pbrflsz', formNumber)),
				singleProgressBarId =  self._id('_snglpbar', formNumber),
				singleProgressBar = $('#' + singleProgressBarId),
				percentUploaded = 0,
				fileNameRendered;

			if (isFinished) {
				bytesUploaded = fileSize;
				self._singleFileUploadFinished(formNumber);
			}
			if (fileSize !== 0 && isNaN(bytesUploaded) === false && isNaN(fileSize) === false) {
				percentUploaded = (bytesUploaded / fileSize) * 100;
			}

			singleProgressBar.data('totalSize', fileSize);
			singleProgressBar.data('bytesUploaded', bytesUploaded);
			// M.H. 10 May 2011 - fix bug 74272
			fileNameRendered = singleProgressBar.data('isFileNameRendered');
			//fileName = singleProgressBar.data('fileName');
			originalFileName = singleProgressBar.data('originalFileName');
			singleProgressBar.igProgressBar('option', 'value', percentUploaded);
			statusLabel.text(self._formatFileSize(bytesUploaded) + '/' + self._formatFileSize(fileSize)); // + ' (' + percentUploaded.toFixed(3) + '%)'

			// M.H. 10 May 2011 - fix bug 74272            
			if (fileNameRendered !== true) {
				singleProgressBar.data('isFileNameRendered', true);
				self._renderFileName(formNumber, fileSize);
			}

			if (isFinished) {
				self._trigger(self.events.fileUploaded, null, {fileId: formNumber, filePath: originalFileName, totalSize: bytesUploaded});
				if (self._checkMaxUploadingFilesCount() === false) {
					// check maximum allowed uploading files
					self._disableBrowseButton(true);
					return;
				}
			}
		},

		_formatURL: function (url, args) {
			// check if url contains ? - if not add, else add
			if (url.indexOf('?') === -1) {
				url += '?';
			}

			url += args;
			return url;
		},

		_showHideIcons: function (properties) {
			var files = this.fileInfoData.filesInfo, i;

			for (i in files) {
				if (files[i] !== undefined) {
					$('#' + this._id('_icn', i)).css(properties);
				}
			}
		},

		_setWidthHeightAllUploads: function (value, isHeight) {
			var files = this.fileInfoData.filesInfo,
				option = (isHeight ? 'height' : 'width'),
				i;

			for (i in files) {
				if (files[i] !== undefined) {
					$('#' + this._id('_snglpbar', i)).igProgressBar('option', option, value);
				}
			}
		},

		_setOption: function (key, value) {
			var originalMode = this.options.mode,
				originalAutoStartUpload = this.options.autostartupload;

			$.Widget.prototype._setOption.apply(this, arguments);
			switch (key) {
			case "width":
				this.container().width(value);
				$('#' + this._id('_bmncntr')).width(value);
				// Fix bug #75939 M.H. 27 May 2011
				this._reRenderFileSizeMetrics();

				// Fix bug #77383 M.H. 27 Jul 2011
				this._reRenderFileNames();
				break;
			case "height":
				this.container().height(value);
				$('#' + this._id('_bmncntr')).height(value);
				break;
			case "labelUploadButton":
				$('#' + this._id('_ibb')).igBrowseButton('option', 'labelText', value);
				break;
			case "labelAddButton":
				$('#' + this._id('_bb')).igBrowseButton('option', 'labelText', value);
				break;
			case "labelClearAllButton":
				$('#' + this._id('_clrabtn')).igButton('option', 'labelText', value);
				break;
			case "labelSummaryTemplate":
			case "labelSummaryProgressBarTemplate":
				// it is set option and it should be refreshed template for summary progress
				this._spbRenderProgress();
				break;
			case "labelShowDetails":
			case "labelHideDetails":
				this._setShowHideDetailsButtonText($('#' + this._id('_shdbtn')).is('hidden'));
				$('#' + this._id('_shdbtn')).text(value);
				break;
			case "labelSummaryProgressButtonCancel":
				if (this.spbButtonMode === this.summaryButtonModes.cancel) {
					$('#' + this._id('_spbtncncl')).igButton('option', 'labelText', value);
				}
				break;
			case "labelSummaryProgressButtonContinue":
				if (this.spbButtonMode === this.summaryButtonModes.startupload) {
					$('#' + this._id('_spbtncncl')).igButton('option', 'labelText', value);
				}
				break;
			case "labelSummaryProgressButtonDone":
				if (this.spbButtonMode === this.summaryButtonModes.done) {
					$('#' + this._id('_spbtncncl')).igButton('option', 'labelText', value);
				}
				break;
			case "showFileExtensionIcon":
				this._showHideIcons({'display': ((!value) ? 'none' : 'block')});
				break;
			// M.H. 10 May 2011 - fix bug 74174: change fileSize Metric for all items that are displayed
			case "fileSizeMetric":
				this._reRenderFileSizeMetrics();
				break;
			// M.H. 10 May 2011 - fix bug 74172: change add in setOption case for fileSizeDecimalDisplay
			case "fileSizeDecimalDisplay":
				this._reRenderFileSizeMetrics();
				break;
			// M.H. 11 May 2011 - fix bug 74305:
			case "maxUploadedFiles":
				this._disableBrowseButton(!this._checkMaxUploadingFilesCount());
				break;
			// M.H. 11 May 2011 - fix bug 77331: add option for mode. When changing mode re-create widget(first destroy it) 
			case "mode":
				if (originalMode !== value) {
					// M.H. 28 Jul 2011 - fix bug 77183 - remove html markup - it should not be used destroy method
					this._destroyMarkup();
					this._create();
				}
				break;
			// M.H. 26 Jul 2011 - fix bug 82062 - set disabled of the init browse button
			case "disabled":
				this._disableBrowseButton(value);
				break;
			// M.H. 9 Nov. 2011 - fix bug 77279 - when value is set to true then all pending files are submitted
			case "autostartupload":
				if (value === true && value !== originalAutoStartUpload) {
					this._spbSubmitAllButton();
				}
				break;
			}
		},

		// M.H. 10 May 2011 - fix bug 74174: change fileSize Metric for all items that are displayed, add method
		_reRenderFileSizeMetrics: function () {
			var data = this.fileInfoData.filesInfo,
				l = data.length,
				i,
				// M.H. 1 June 2011 Fix bug #77180
				bytesUploaded = 0,
				self = this,
				fileSize,
				statusLabel,
				singleProgressBar;

			for (i = 0; i < l; i++) {
				// check if exist summary progress bar as DOM element
				// Fix bug #76775 M.H. 26 May 2011
				// M.H. 1 June 2011 Fix bug #77180
				statusLabel = $('#' + self._id('_pbrflsz', i));
				if (statusLabel.length === 0) {
					continue;
				}
				fileSize = data[i].sizeBytes;
				bytesUploaded = data[i].uploadedBytes;
				singleProgressBar = $('#' + self._id('_snglpbar', i));
//				if (fileSize !== 0 && isNaN(bytesUploaded) === false && isNaN(fileSize) === false) {
//					percentUploaded = (bytesUploaded / fileSize) * 100;
//				}
				//fileName = singleProgressBar.data('fileName');
				//originalFileName = singleProgressBar.data('originalFileName');
				statusLabel.text(self._formatFileSize(bytesUploaded) + '/' + self._formatFileSize(fileSize)); // + ' (' + percentUploaded.toFixed(3) + '%)'
				singleProgressBar.data('isFileNameRendered', true);
				self._renderFileName(i, fileSize);
				$('#' + self._id('_summpbrlbl_1')).width($('#' + this._id('_summpbar')).width());
			}

			this._spbRenderProgress();
		},

		_destroyMarkup: function () {
			// M.H. 28 Jul 2011 - fix bug 77183 - set logic for removing html markup into separate function
			/* 
			Destroy the widget
			*/
			// M.H. 12 May 2011 - fix bug 74966
			var i, attr, startupButton = $('#' + this._id('_ibb')),
				browseButton = $('#' + this._id('_bb')),
				baseMainContainer = $('#' + this._id('_bmncntr'));
            
            if (!this._isDivElement) {
                this.originalElement.show().unwrap();
            }
			this.originalElement.show().unwrap();
			// M.H. 12 May 2011 - fix bug 74966
			startupButton.igBrowseButton('destroy');
			browseButton.igBrowseButton('destroy');

			startupButton.remove();
			baseMainContainer.remove();
			//  this.container() = this.originalElement;
			// M.H. 7 Feb 2014 Fix for bug #163735: WebIDE requires the outer element of igUpload to be with the same ID as the element(on which control is initialized) ID
            if (!this._isDivElement) {
                this.container().remove();
            } else {
                this.element.empty();
                attr = this.element[0].attributes;
                for (i = 0; i < attr.length; i++) {
                    if (attr[i].name !== 'id') {
                        this.element.removeAttr(attr[i].name);
                    }
                }
                for (i = 0; i < this._initialAttributes.length; i++) {
                    if (this._initialAttributes[i].name !== 'id') {
                        this.element.attr(this._initialAttributes[i].name, this._initialAttributes[i].value);
                    }
                }
                this.element.html(this._initialHTML);
            }
		},

		destroy: function () {
			/*
				Destroy the widget
			*/
			// M.H. 28 Jul 2011 - fix bug 77183 - set logic for removing html markup into separate function
			this._destroyMarkup();
			$.Widget.prototype.destroy.apply(this, arguments);
		},

		/* Get file Size Before Start Upload */
		_getFileSize: function (formNumber, key) {
			// adds iframe and submits form with specific query string and the server should return the size of fileupload
			// this method is called only when option autostartupload = false
			var self = this,
				o = this.options,
				formId =  this._id('_fszfrm', formNumber),
				filePicker = $('#' + self._id('_frm', formNumber) + '_if'),
				iframeId = this._id('_fszifrm', formNumber),
				form,
				url = self._formatURL(o.uploadUrl, $.param({'key': key, 'command': 'fileSize'}));

			$('<iframe src="javascript:false;" id="' + iframeId + '" name="' + iframeId + '"></iframe>').appendTo($(document.body)).css({'display': 'none'});
			$('<form method="post" id="' + formId + '" target="' + iframeId + '" enctype="multipart/form-data"></form>').appendTo($(document.body)).css({'display': 'none'}).attr('action', url);
			form = $('#' + formId);
			filePicker.appendTo(form);
			form.submit();
			form.remove();

			$('#' + iframeId).ready(function () {
				setTimeout(function () {self._sendRequestFileSize(formNumber, key); }, self._const.timeoutGetFileSize);
			});

			filePicker.appendTo($('#' + self._id('_frm', formNumber)));
		},

		_removeGetFileSizeHTML: function (formNumber) {
			var iframeGetFileSize = $('#' + this._id('_fszifrm', formNumber)),
				formGetFileSize =  $('#' + this._id('_fszfrm', formNumber));

			iframeGetFileSize.remove();
			formGetFileSize.remove();
		},

		_sendRequestFileSize: function (formNumber, key) {
			// called only in multiple upload mode when autostartupload is false
			var self = this,
				o = this.options,
				singleFileData = this._getFileInfo(formNumber);

			// check singleFileData is initialized - this means that it is sent request to server            
			if (singleFileData.sizeBytes !== 0) {
				return;
			}
			$.ajaxQueue('uploadrequestsqueue', {
				url: self._formatURL(o.progressUrl, $.param({'key': key, 'command': 'fileSize'})),
				dataType: 'json',
				cache: false,
				success: function (data) {
					var fileSize = parseInt(data.fileSize, 10);
					self._saveFileSize(fileSize, formNumber);
					self._removeGetFileSizeHTML(formNumber);
				},
				error: function () {
					self._setError(o.errorMessageAJAXRequestFileSize, self._const.clientSideErrorCode.ajaxErrorRequestFileSize, 'clientside');
					self._removeGetFileSizeHTML(formNumber);
				}
			});
		},
		_saveFileSize: function (fileSize, formNumber) {
			var self = this,
				singleProgressBarId =  self._id('_snglpbar', formNumber),
				singleProgressBar = $('#' + singleProgressBarId),
				fileData = this.fileInfoData,
				singleFileData = this._getFileInfo(formNumber);

			if (isNaN(fileSize) === true) {
				return;
			}
			singleProgressBar.data('totalSize', fileSize);
			// _spb feature
			if (singleFileData !== null) {
				singleFileData.sizeBytes = fileSize;
				fileData.fileSizeTotal += fileSize;
				self._spbRenderProgress();
			}
			// end of _spb feature                    
			self._renderStatus(formNumber, 0, fileSize, false, false);
		},
		/* END OF Get file Size Before Start Upload */

		_onShowHideDetailsClick: function () {
			var self = this,
				fileContainer = $('#' + self._id('_fc')),
				marginTop = fileContainer.css('margin-top'),
				marginBottom = fileContainer.css('margin-bottom');

			// Fix bug #73126 M.H. 27 May 2011
			if ($.ig.util.isIE7 || $.ig.util.isIEQuircks) {
				self._setShowHideDetailsButtonText(fileContainer.is(':hidden'));
				if (fileContainer.is(':hidden')) {
					fileContainer.show();
					// M.H. 23 March 2012 Fix for bug #103089
					self._reRenderFileNames();
				} else {
					fileContainer.hide();
				}
				// M.H. 26 March 2012 Fix for bug #103086
				self._setShowHideDetailsButtonText(fileContainer.is(':hidden'));
			} else {
				// M.H. 11 May 2011 - fix bug 74559: When it is set height which is near the height of the whole widget - there is flicker effect because it is shown scrollbar
				// Fix it as remove margin-top, bottom - if set
				fileContainer.css({'margin-top': 0, 'margin-bottom': 0});
				fileContainer.slideToggle(
					self._const.showHideDetailsAnimationTimeout,
					function () {
						// M.H. 11 May 2011 - fix bug 74559: When it is set height which is near the height of the whole widget - there is flicker effect because it is shown scrollbar
						// Fix it as remove margin-top, bottom - if set and when slideToggle finishes rollback original values                    
						fileContainer.css({'margin-top': marginTop, 'margin-bottom': marginBottom});
						self._setShowHideDetailsButtonText(fileContainer.is(':hidden'));

						// M.H. 27 Jul 2011 - fix bug 74266 - reRender FileNames when show details is clicked
						if (fileContainer.is(':hidden') === false) {
							self._reRenderFileNames();
						}
					}
				);
			}
		},

		// M.H. 27 Jul 2011 - fix bug 74266 - reRender FileNames
		_reRenderFileNames: function () {
			var data = this.fileInfoData.filesInfo,
				l = data.length,
				i,
				originalFileName;

			for (i = 0; i < l; i++) {
				originalFileName = $('#' + this._id('_snglpbar', i)).data('originalFileName');
				// first it should be set the original filename
				$('#' + this._id('_pbrflnm', i)).text(originalFileName);
				this._renderFileName(i, 0, originalFileName);
			}
		},


		_setShowHideDetailsButtonText: function (isHidden) {
			var o = this.options,
				showHideDetailsButton = $('#' + this._id('_shdbtn'));

			if (isHidden) {
				showHideDetailsButton.text(o.labelShowDetails);
				// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
				showHideDetailsButton.attr('title', $.ig.Upload.locale.titleShowDetailsButton);
			} else {
				showHideDetailsButton.text(o.labelHideDetails);
				// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
				showHideDetailsButton.attr('title', $.ig.Upload.locale.titleHideDetailsButton);
			}
		},

		getFileInfoData: function () {
			/*
			Returns the information about uploading files - all files uploaded/uploading/pending
			returnType="object" Returns the information about uploading files
			*/
			return this.fileInfoData;
		},

		cancelAll: function () {
			/* Cancel all uploading and pending files
			*/
			var i, data = this.fileInfoData,
				uploadingIDs = data.uploadingIDs,
				luploadingIDs = uploadingIDs.length,
				pendingIDs = data.pendingQueueIDs,
				lpendingIDs = pendingIDs.length,
				batch = data.batch,
				lbatch = batch.length;

			this.allCancelled = true;
			for (i = 0; i < luploadingIDs; i++) {
				if (uploadingIDs[i] !== undefined) {
					this.cancelUpload(uploadingIDs[i]);
				}
			}

			for (i = 0; i < lpendingIDs; i++) {
				if (pendingIDs[i] !== undefined) {
					this.cancelUpload(pendingIDs[i]);
				}
			}

			for (i = 0; i < lbatch; i++) {
				if (batch[i] !== undefined) {
					this.cancelUpload(batch[i]);
				}
			}

			uploadingIDs = [];
			pendingIDs = [];
			batch = [];
			$('#' + this._id('_spbtncncl')).data('ids', []);

			this.allCancelled = false;
		},

		_submitAllFormsUpload: function () {
			var self = this, i, id,
				idsToSubmit = this.fileInfoData.batch,
				l = idsToSubmit.length, pendingIDs = [];

			for (i = 0; i < l; i++) {
				id = idsToSubmit[i];
				if (self._checkCanUpload()) {
					// M.H. 27 Jul 2011 - fix bug 77339
					//self._addUploadingID(id);
					self.startUpload(id);
					//submittedIDs.push(id);
				} else {
					self._addPendingId(id);
					pendingIDs.push(id);
				}
			}
			this.fileInfoData.batch = [];
			//self._trigger(self.events.batchFileStartUpload, null, {submittedIDs: submittedIDs, pendingIDs: pendingIDs});
			// we should clear ids array once we have submitted forms            
		},


		// summaryProgressBar Initialization
		_spbRenderInit: function () {
			var self = this, o = this.options,
				css = self.css,
				uploaderId = this._id('_fu'), labelSummaryButton = o.labelSummaryProgressButtonContinue,
				summaryProgressContainerId = this._id('_spbcntr'),
				summaryProgressBarLabelId = this._id('_summpbrlbl'),
				summaryProgressBarId = this._id('_summpbar'),
				summaryProgressLabelId = this._id('_summplbl'),
				showHideDetailsId = this._id('_shdbtn'),
				summaryProgressButtonCancelId = this._id('_spbtncncl'),
				summaryProgressDetailsButtonId = this._id('_spdtlbtn'),
				summaryProgressBar,
				html = '',
				data,
				progressData = 'progressData',
				// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
				titleSummaryButton = $.ig.Upload.locale.titleSummaryProgressButtonContinue;

			html +=     '<div id="$summaryProgressContainerId$">';
			html +=     '   <div  class="' + css.summaryInformationContainerClass + '">';
			html +=     '       <span id="$summaryProgressLabelId$" class="' + css.summaryUploadedFilesLabelClass + '"></span><a href="javascript:void(0);" id="$showHideDetailsId$" class="' + css.summaryShowHideDetailsButtonClass + '">$labelShowHideDetails$</a>';
			html +=     '   </div>';
			html +=     '   <div class="' + css.clearClass + '">';
			html +=     '       <button id="$summaryProgressButtonCancelId$"></button>';
			html +=     '       <div id="$summaryProgressBarId$"></div>';
			html +=     '   </div>';
			html +=     '</div>';
			html = html.replace('$summaryProgressContainerId$', summaryProgressContainerId).replace('$summaryProgressLabelId$', summaryProgressLabelId).replace('$summaryProgressDetailsButtonId$', summaryProgressDetailsButtonId).replace('$summaryProgressBarId$', summaryProgressBarId).replace('$showHideDetailsId$', showHideDetailsId).replace('$labelShowHideDetails$', o.labelHideDetails).replace('$labelSummaryProgressButtonCancel$', o.labelSummaryProgressButtonCancel).replace('$summaryProgressButtonCancelId$', summaryProgressButtonCancelId);
			$(html).appendTo($('#' + uploaderId));

			// data which keeps IDs of forms
			data = {IDs: {}, CurrentUploadedFiles: 0, CurrentUploadedSize: 0, TotalFileSize: 0, TotalFiles: 0, UploadingFiles: 0};

			$('#' + summaryProgressContainerId).data(progressData, data).addClass(css.summaryProgressContainerClass + ' ' + css.clearClass);
			summaryProgressBar = $('#' + summaryProgressBarId);
			$('<span id="' + summaryProgressBarLabelId + '"></span>').addClass(css.summaryProgressbarLabelClass).appendTo(
				summaryProgressBar.igProgressBar({
					animate: self._const.isProgressBarAnimationEnabled,
					animateTimeout: self._const.animateProgressBarInterval,
					range: self._const.isProgressBarRange,
					value: 0,
					queue: false
				}).addClass(css.summaryProgressBarClass)
			);
			// Add second span so when progress is over the label text to show specific color and those part of the labe to be in other color
			$('<div id="' + summaryProgressBarLabelId + '_1"></div>').width(summaryProgressBar.width()).addClass(css.summaryProgressBarSecondaryLabel).appendTo($('#' + this._id('_summpbar_progress')).addClass(css.summaryProgressBarInnerProgress));

			$('#' + showHideDetailsId).bind({
				click: function (event) {
					event.preventDefault();
					self._onShowHideDetailsClick();
				}
			});
			// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
			if ($.ig.Upload.locale.titleHideDetailsButton !== false) {
				$('#' + showHideDetailsId).attr('title', $.ig.Upload.locale.titleHideDetailsButton);
			}
			// if autostartupload is false then bind onclick to submit all forms otherwise to cancel all upload forms

			if (o.autostartupload) {
				labelSummaryButton = o.labelSummaryProgressButtonCancel;
				// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
				titleSummaryButton = $.ig.Upload.locale.titleSummaryProgressButtonCancel;
				this.spbButtonMode = this.summaryButtonModes.cancel;
			}

			$('#' + summaryProgressButtonCancelId).igButton({
				labelText: labelSummaryButton,
				// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
				title: titleSummaryButton,
				disabled: false,
				click: function (event) {
					event.preventDefault();
					self._spbOnClickButton(event);
				}
			}).addClass(css.summaryButtonClass);
		},

		_spbRenderProgress: function () {
			var o = this.options,
				summaryProgressBar = $('#' + this._id('_summpbar')),
				summaryProgressLabel = $('#' + this._id('_summplbl')),
				summaryProgressBarLabel = $('#' + this._id('_summpbrlbl')),
				summaryProgressBarLabel_1 = $('#' + this._id('_summpbrlbl_1')),
				textSummaryProgressBarLabel = "",
				value = 0,
				data = this.fileInfoData,
				fileSizeTotal = data.fileSizeTotal,
				fileSizeUploaded = data.fileSizeUploaded;

			if (fileSizeTotal !== 0 && isNaN(fileSizeTotal) === false) {
				value = (fileSizeUploaded / fileSizeTotal) * 100;
			} else if (fileSizeTotal === 0) {
				value = 0;
			}

			if (data.countUploadingFiles === data.countTotalFiles) {
				if (data.countTotalFiles === 0) {
					value = 0;
				} else {
					value = 100;
				}
				// M.H. 7 Jan 2013 Fix for bug #129538
				data.fileSizeUploaded = fileSizeTotal;
				fileSizeUploaded = fileSizeTotal;
			}
			summaryProgressBar.igProgressBar('option', 'value', value);
			// M.H. 13 May 2011 - fix bug 75042
			textSummaryProgressBarLabel = o.labelSummaryProgressBarTemplate.replace('{0}', this._formatFileSize(fileSizeUploaded)).replace('{1}', this._formatFileSize(fileSizeTotal)).replace('{2}', value);
			summaryProgressLabel.html(o.labelSummaryTemplate.replace('{0}', data.countUploadingFiles).replace('{1}', data.countTotalFiles));
			summaryProgressBarLabel.text(textSummaryProgressBarLabel);
			summaryProgressBarLabel_1.text(textSummaryProgressBarLabel);
		},

		_spbOnClickButton: function (event) {
			var modes = this.summaryButtonModes, m = this.spbButtonMode;
			event.preventDefault();
			if (m === modes.cancel) {
				this._trigger(this.events.cancelAllClicked, event);
				this.cancelAll();
			} else if (m === modes.startupload) {
				this._spbSubmitAllButton();
			}
		},

		_spbSubmitAllButton: function () {
			this._submitAllFormsUpload();
			// then bind to button cancel action
			this._spbCheckModeButton();
			//this._spbSetCancelButton();
		},

		_spbCheckModeButton: function () {
			var fileData = this.fileInfoData;

			if (this.options.autostartupload) {
				if (fileData.pendingQueueIDs.length > 0 || fileData.uploadingIDs.length > 0) {
					this._spbSetCancelButton();
				} else {
					this._spbSetButtonDone();
				}
			} else {
				if (fileData.pendingQueueIDs.length === 0 && fileData.uploadingIDs.length === 0) {
					if (fileData.batch.length > 0) {
						this._spbSetContinueButton();
					} else {
						this._spbSetButtonDone();
					}
				} else {
					this._spbSetCancelButton();
				}
			}
		},

		// Set different Modes for the Summary Button - Cancel, Done, Submit
		_spbSetButtonDone: function () {
			// submit all forms and enable cancel action
			var o = this.options,
				button = $('#' + this._id('_spbtncncl'));
			this.spbButtonMode = this.summaryButtonModes.done;
			// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
			button.igButton('option', 'labelText', o.labelSummaryProgressButtonDone).igButton('option', 'title', $.ig.Upload.locale.titleSummaryProgressButtonDone).igButton('option', 'disabled', true);
		},

		_spbSetContinueButton: function () {
			// submit all forms and enable cancel action
			var o = this.options,
				button = $('#' + this._id('_spbtncncl'));
			this.spbButtonMode = this.summaryButtonModes.startupload;
			button.igButton({
				// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
				title: $.ig.Upload.locale.titleSummaryProgressButtonContinue,
				labelText: o.labelSummaryProgressButtonContinue,
				disabled: false
			});
		},

		_spbSetCancelButton: function () {
			var cancelButton = $('#' + this._id('_spbtncncl'));

			this.spbButtonMode = this.summaryButtonModes.cancel;
			// M.H. 12 May 2011 - fix bug 74763: add title to all buttons
			cancelButton.igButton('option', 'labelText', this.options.labelSummaryProgressButtonCancel).igButton('option', 'title', $.ig.Upload.locale.titleSummaryProgressButtonCancel).igButton('option', 'disabled', false);
		},

		/* // End of Summary Functions */
		/*************** HELPER FUNCTION ********************/

		/**************** FILE INFO ********************/
		_getFileInfo: function (length) {
			var fid = this.fileInfoData.filesInfo[length];
			if (fid === undefined || fid === null) {
				return null;
			}

			return fid;
		},

		/**************** // FILE INFO ********************/

		_formatFilePath: function (file) {
			var ind = file.lastIndexOf('/');

			file = file.replace(/(\/|\\)$/, "");
			if (ind === -1) {
				ind = file.lastIndexOf('\\');
			}
			return file.substring(ind + 1);
		},

		// async Simultaneously upload
		_checkCanUpload: function () {
			var o = this.options,
				data = this.fileInfoData,
				canUpload = true,
				maxSimultaneousFilesUploads = o.maxSimultaneousFilesUploads;

			if (o.mode === 'multiple' && maxSimultaneousFilesUploads !== null && data.uploadingIDs.length >= maxSimultaneousFilesUploads) {
				canUpload = false;
				if (maxSimultaneousFilesUploads <= 0) {
					this._setError(o.errorMessageMaxSimultaneousFiles, this._const.clientSideErrorCode.checkCanUpload, 'clientside');
				}
			}

			return canUpload;
		},

		_addPendingId: function (id) {
			this.fileInfoData.pendingQueueIDs.push(id);
		},

		_removePendingId: function (formNumber) {
			var pendingIDs = this.fileInfoData.pendingQueueIDs, id;

			if (formNumber !== undefined && formNumber !== null) {
				id = formNumber;
				this.fileInfoData.pendingQueueIDs = this._removeElementFromArray(pendingIDs, id);
			} else {
				id = pendingIDs.shift();
				if (id === undefined) {
					id = null;
				}
			}
			return id;
		},

		_addUploadingID: function (id) {
			this.fileInfoData.uploadingIDs.push(id);
		},

		_removeUploadingID: function (id) {
			this.fileInfoData.uploadingIDs = this._removeElementFromArray(this.fileInfoData.uploadingIDs, id);
		},

		_addIDBatch: function (id) {
			this.fileInfoData.batch.push(id);
		},
		_removeIDBatch: function (id) {
			this.fileInfoData.batch = this._removeElementFromArray(this.fileInfoData.batch, id);
		},

		_submitNextPendingId: function () {
			var self = this, nextFormToSubmitId;

			if (self._checkCanUpload() === true) {
				nextFormToSubmitId = self._removePendingId();
				if (nextFormToSubmitId !== null) {
					// M.H. 27 Jul 2011 - fix bug 77339
					//self._addUploadingID(nextFormToSubmitId);
					self.startUpload(nextFormToSubmitId);
				}
			}
		},
		// End of async Simultaneously upload
		_randomString: function (string_length) {
			var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz", randomstring = '', i, rnum;
			for (i = 0; i < string_length; i++) {
				rnum = Math.floor(Math.random() * chars.length);
				randomstring += chars.substring(rnum, rnum + 1);
			}
			return randomstring;
		},
		_cutFilePath: function (fileName, length) {
			var fileNameSize = fileName.length;
			if (fileNameSize <= length) {
				return fileName;
			}
		},

		_getOnlyFileName: function (fileName) {
			var delimeter = '';

			if (fileName === null || fileName === undefined) {
				return '';
			}

			if (fileName.indexOf('/') !== -1) {
				delimeter = '/';
			} else if (fileName.indexOf('\\') !== -1) {
				delimeter = '\\';
			}

			if (delimeter !== '') {
				fileName = fileName.substr(fileName.lastIndexOf(delimeter) + 1);
			}

			return fileName;
		},

		_getFileExtension: function (fileName) {
			return fileName.substring(fileName.lastIndexOf('.') + 1);
		},

		_validateFileExtension: function (fileName, callEvent) {
			var ext = '', arrE = this.options.allowedExtensions, res, noCancel;
			// if the array with extension is empty than validation always returns true
			if (arrE.length === 0) {
				return true;
			}
			ext = fileName.substring(fileName.lastIndexOf('.') + 1);
			// M.H. 2 June 2014 Fix for bug #172983: Client side validation for file extension is case sensitive for igUpload
			noCancel = this._trigger(this.events.fileExtensionsValidating, this, {fileName: fileName, fileExtension: ext});
			res = $.inArray(ext, arrE) >= 0;
			if ((callEvent === true && res === false) || !noCancel) {
				res = false;
				this._setError(this.options.errorMessageValidatingFileExtension, this._const.clientSideErrorCode.extensionValidation, 'clientside');
			}
			return res;
		},

		_getFileExtensionIconPath: function (ext) {
			// search array for the specified extension, if could not find search for default
			// even if ext is empty the function will return again default icon(if specified)            
			var arrIE = this.options.fileExtensionIcons, i, icon = '', l = arrIE.length;

			ext = String(ext).toLowerCase();
			for (i = 0; i < l; i++) {
				if (arrIE[i].ext !== undefined && (arrIE[i].ext === ext || $.inArray(ext, arrIE[i].ext) !== -1)) {
					icon = arrIE[i].css;
					break;
				}
                if (icon === '' && (arrIE[i].def === true || ($.isArray(arrIE[i].ext) && arrIE[i].ext.length === 0))) {
					// M.H. 27 Jul 2011 - fix bug 77162 - Default icon could be those which has property def true OR ext.length is 0
					icon = arrIE[i].css;
				}
			}
			return icon;
		},

		_setError: function (message, errorCode, errorType, serverMessage) {
			// error handling
			// error message, errorCode - type int, errorType - serverside|clientside            
			var o = this.options,
				errC = this._const.errorCode;

			if (serverMessage === undefined) {
				serverMessage = '';
			}

			if (errorType === 'serverside') {
				// M.H. 11 May 2011 - fix bug 74621: Add messages for most common errors
				switch (errorCode) {
				case errC.MimeTypeValidation:
					message = o.errorMessageValidatingFileExtension;
					break;
				case errC.FileSizeExceeded:
					message = o.errorMessageMaxFileSizeExceeded;
					break;
				}
			}
			// M.H. 12 Feb 2013 Fix for bug #129469
			this._spbCheckModeButton();
			this._trigger(this.events.onError, null, {errorCode: errorCode, errorMessage: message, errorType: errorType, serverMessage: serverMessage });
		},

		/* convert functions */
		_formatFileSize: function (val) {
			// val in bytes
			var fsm = this.options.fileSizeMetric, res = val;

			switch (fsm) {
			case 'bytes':
				res = val + 'B';
				break;
			case 'kbytes':
				res = this._convertToKBytes(val);
				break;
			case 'mbytes':
				res = this._convertToMBytes(val);
				break;
			case 'gbytes':
				res = this._convertToGBytes(val);
				break;
			case 'auto':
				if (val < 1024) {
					res = val + 'B';
				} else if (val < 1024 * 1024) { //1MB
					res = this._convertToKBytes(val);
				} else if (val < 1024 * 1024 * 1024) { //1GB
					res = this._convertToMBytes(val);
				} else {
					res = this._convertToGBytes(val);
				}
				break;
			default:
				break;
			}

			return res;
		},

		_convertToKBytes: function (val) {
			var res = val / 1024;
			return res.toFixed(this.options.fileSizeDecimalDisplay) + 'KB';
		},

		_convertToMBytes: function (val) {
			var res = val / (1024 * 1024);

			return res.toFixed(this.options.fileSizeDecimalDisplay) + 'MB';
		},

		_convertToGBytes: function (val) {
			var res = val / (1024 * 1024 * 1024);

			return res.toFixed(this.options.fileSizeDecimalDisplay) + 'GB';
		},

		/* end of convert functions */

		// Array Functions
		_removeElementArrayById: function (array, keyValue) {
			if (array === undefined || array === null) {
				return [];
			}

			return $.grep(array, function (n) {
				return (n.id !== keyValue);
			});
		},

		_removeElementFromArray: function (array, keyValue) {
			if (array === undefined || array === null) {
				return [];
			}
			return $.grep(array, function (n) {
				return (n !== keyValue);
			});
		}

		/*************** // HELPER FUNCTION ********************/
	});
	$.extend($.ui.igUpload, { version: '14.1.20141.2249' });
}(jQuery));

/*!@license
* Infragistics.Web.ClientUI Editors 14.1.20141.2249
*
* Copyright (c) 2011-2014 Infragistics Inc.
*
* http://www.infragistics.com/
* Depends on:
* jquery-1.4.4.js
* jquery.ui.core.js
* jquery.ui.widget.js

* Example to use:
*	<script type="text/javascript">
*	$(function () {
*		$('#text1').igValidator({ minLength: 3 });
*	});
*	</script>
*	<input id="text1" type="text" />
*/
/*global jQuery, setTimeout, MSApp*/
(function ($) {
	// _id: backup id if target does not have one
	// _cur: igValidator which opened error-message with ongoing animation
	// _submit: collection of objects, each of them if defined by id of form
	//   each subobject for a form contains references to controls which should be validated on submit events
	var _id = '=id', _cur = null, _submit = {}, _stop = function (e) {
		try {
			e.preventDefault();
			e.stopPropagation();
		} catch (ignore) { }
	}, _fid = function (form, fid) {
		var id = form.id;
		if (!id && fid) {
			form._fid = fid;
		}
		return id || form._fid;
	};
	/*
		igValidator is a widget based on jQuery UI that provides functionality to validate value in target.
		It can be attached to a INPUT, TEXTAREA, SELECT html element in order to validate its value and show appropriate error message.
		It also can be used as internal member within igEditor, igCombo and igRating.
		Validation can be triggered on various events like onchange, onblur, onsubmit and when form.submit() was used by application explicitly.
		Every igValidator may have its own rules and enable/disable specific trigger-validation events. If validation failed, then focus can be set back to target element once, always or do not interact with focus.
		If target element is INPUT type=radio, then all elements with attribute name of that target are validated.
		If validator is enabled for igEditor, then any specific failure like not filled required positions in igMaskEditor or invalid day of month in igDateEditor, etc, will trigger validation and show corresponding message.
		In order to customize error strings globally, the $.ig.Validator.locale object can be used.

		In order to customize some of default options globally for all widgets, the "$.ui.igValidator.defaults" object can be used.
		Example:
		$.ui.igValidator.defaults.showAllErrorsOnSubmit = true;
	*/
	$.widget('ui.igValidator', {
		options: {
			/* type="bool" Gets or sets visibility of icon on error message.
				Default value comes from corresponding member in $.ui.igValidator.defaults object, which is true. */
			showIcon: null,
			/* type="number" Gets or sets duration of show animation in milliseconds.
				Default value comes from corresponding member in $.ui.igValidator.defaults object, which is 300. */
			animationShow: null,
			/* type="number" Gets or sets duration of hide animation in milliseconds.
				Default value comes from corresponding member in $.ui.igValidator.defaults object, which is 300. */
			animationHide: null,
			/* type="bool" Gets or sets ability to apply error css to target element.
				Default value comes from corresponding member in $.ui.igValidator.defaults object, which is true. */
			enableTargetErrorCss: null,
			/* type="string" Gets or sets location of error label relative to target element.
				Supported value: "bottom", "left" and "right".
				Default value comes from corresponding member in $.ui.igValidator.defaults object, which is "bottom". */
			alignment: null,
			/* type="never|0|once|1|always|2" Gets or sets option to set focus back to editor when validation failed. Default value comes from corresponding member in $.ui.igValidator.defaults object, which is undefined. 
				never type="string"
				0 type="number"
				once type="string"
				1 type="number"
				always type="string"
				2 type="number" */
			keepFocus: null,
			/* type="bool" Gets or sets triggering validation when value in editor was changed.
				Default value comes from corresponding member in $.ui.igValidator.defaults object, which is true. */
			onchange: null,
			/* type="bool" Gets or sets triggering validation when editor lost focus.
				Default value comes from corresponding member in $.ui.igValidator.defaults object, which is true. */
			onblur: null,
			/* type="bool" Gets or sets triggering validation when application called form.submit().
				Default value comes from corresponding member in $.ui.igValidator.defaults object, which is false. */
			formSubmit: null,
			/* type="bool" Gets or sets triggering validation when form gets onsubmit event.
				Default value comes from corresponding member in $.ui.igValidator.defaults object, which is true. */
			onsubmit: null,
			/* type="bool" Gets or sets parent/location of error message.
				Value true: use the document.body as parent for error-message.
				Value false: insert error-message in parent of target element.
			*/
			bodyAsParent: true,
			/* type="bool" Gets or sets option to validate if value was entered (not empty text, selected item, etc.)*/
			required: false,
			/* type="number" Gets or sets minimum length of text or minimum number of selected items.*/
			minLength: -1,
			/* type="number" Gets or sets maximum length of text or maximum number of selected items.*/
			maxLength: -1,
			/* type="number" Gets or sets validation for minimum number.*/
			min: null,
			/* type="number" Gets or sets validation for maximum number.*/
			max: null,
			/* type="string|object" Gets or sets regular expression which is used to validate value in text editor.
				string type="string" A string containing regular expression
				object type="RegExp" A RegExp object
			*/
			regExp: null,
			/* type="bool" Gets or sets option to use the name attribute of checkboxes in order to validate ranges.
				That option has effect only when the target is checkbox. The value of true will use the "name" attribute of target to validate all checkboxes with that name.
				In this case the "required" option will be used to check if at least one checkboxes is checked and the "min/maxLength" options will be used for range validations.
			*/
			checkboxesName: false,
			/* type="object" Gets or sets object that contains custom settings. */
			locale: null,
			/* type="dom" Gets or sets custom jquery element, which innerHTML will be used to show error message. That can be SPAN, LABEL or DIV. */
			errorLabel: null,
			/* type="dom" Gets or sets reference to html element, which is used to process mousedown and mouseup events in order to trigger validation.*/
			element: null,
			/* type="string" Gets or sets selector for css classes.
				That option allows replacing all default css styles of validator by custom values.
				Application should provide css classes for all members defined in the css options with "theme" selector.
			*/
			theme: null,
			/* type="string" Gets or sets text for error-message which overrides all possible specific error-messages.*/
			errorMessage: null
		},
		css: {
			/* Classes applied to the SPAN element of error-label which shows message. Default value is 'ui-igvalidator ui-widget ui-state-error ui-corner-all' */
			label: 'ui-igvalidator ui-widget ui-state-error ui-corner-all',
			/* Classes applied to the SPAN on error-label which contains image. Default value is 'ui-igvalidator-icon ui-icon ui-icon-alert' */
			icon: 'ui-igvalidator-icon ui-icon ui-icon-alert',
			/* Class applied to the target element when validation failed. Default value is 'ui-igvalidator-target' */
			target: 'ui-igvalidator-target'
		},
		locale: {
			/* Message used when validator is not able to identify specific reason for failure */
			defaultMessage: 'Please fix this field',
			/* Message used when user should select a value (in drop-down list, radio buttons or similar) */
			selectMessage: 'Please select a value',
			/* Message for range selection */
			rangeSelectMessage: 'Please select no more than {0} and not less than {1} items',
			/* Message for minimum number of selected items */
			minSelectMessage: 'Please select at least {0} items',
			/* Message for maximum number of selected items */
			maxSelectMessage: 'Please select no more than {0} items',
			/* Message for range of text length */
			rangeLengthMessage: 'Please enter a value between {0} and {1} characters long',
			/* Message for minimum length of text */
			minLengthMessage: 'Please enter at least {0} characters',
			/* Message for maximum length of text */
			maxLengthMessage: 'Please enter no more than {0} characters',
			/* Message for required entry */
			requiredMessage: 'This field is required',
			/* Message regular expression (regExp option) */
			regExpMessage: 'Please fix pattern of this field',
			/* Message for igMaskEditor when required positions are missing */
			maskMessage: 'Please fill all required positions',
			/* Message for igDateEditor when date fields are missing */
			dateFieldsMessage: 'Please enter values in date fields',
			/* Message for igDateEditor when day of month is invalid */
			invalidDayMessage: 'Invalid day of month. Please enter correct day',
			/* Message for igDateEditor when date is invalid (zero day, month or similar) */
			dateMessage: 'Please enter a valid date',
			/* Message for igNumericEditor when string can not be converted to a number (no digits) */
			numberMessage: 'Please enter a valid number',
			/* Message for igDateEditor and igNumericEditor when range validation of editor failed */
			rangeMessage: 'Please enter a value between {0} and {1}',
			/* Message for igDateEditor and igNumericEditor when minValue of editor is set and editor has larger value */
			minMessage: 'Please enter a value greater than or equal to {0}',
			/* Message for igDateEditor and igNumericEditor when maxValue of editor is set and editor has smaller value */
			maxMessage: 'Please enter a value less than or equal to {0}'
		},
		events: {
			/* cancel="true" Event which is raised on validation before default validation logic is applied.
				Return false in order to consider value as invalid and to display error message with ui.message.
				Function takes arguments evt and ui.
				Use ui.message to get text of message.
				Use ui.value to get current value in target. */
			checkValue: null,
			/* cancel="true" Event which is raised after value was validated but before any action takes effect.
				Return false to keep possible old/current error message unchanged, and possible new error message is not displayed.
				Function takes arguments evt and ui.
				Use ui.message to get text of message.
				Use ui.invalid to get state, where true is invalid and false is valid. */
			validation: null,
			/* cancel="true" Event which is raised before error message is displayed.
				Return false in order to prevent error message display.
				Function takes arguments evt and ui.
				Use ui.message to get text of message. */
			errorShowing: null,
			/* cancel="true" Event which is raised before error message is hidden.
				Return false in order to keep error message displayed.
				Function takes arguments evt and ui.
				Use ui.message to get text of message. */
			errorHiding: null,
			/* Event which is raised after error message was displayed.
				Function takes arguments evt and ui.
				Use ui.message to get text of message. */
			errorShown: null,
			/* Event which is raised after error message was hidden.
				Function takes arguments evt and ui.
				Use ui.message to get text of message. */
			errorHidden: null
		},
		_create: function () {
			var v, t, elem, o = this.options, me = this, def = $.ui.igValidator.defaults;
			for (v in o) {
				if (o.hasOwnProperty(v) && o[v] === null && def[v] !== undefined) {
					o[v] = def[v];
				}
			}
			elem = me.element;
			// 1: valid, 2: animation hide error message, 3/4: no error message, 6: invalid, 7: animation show error message, 8/9: error
			me._state = 3;
			me._focTime = 0;
			me._init0();
			t = elem[0].nodeName;
			if (t === 'SELECT') {
				t = 5;
			} else {
				t = elem[0].type;
				if (t === 'checkbox') {
					t = o.checkboxesName ? 6 : 4;
				} else if (t === 'radio') {
					t = 6;
				} else {
					t = 0;
				}
			}
			me._elem = (t !== 6) ? elem : $('[name=' + elem[0].name + ']').map(function () {
				return (this.form === elem[0].form) ? this : null;
			});
			// 0 - text element (INPUT, TEXTAREA) with val()
			// 1..3 - not used for now
			// 4 - single INPUT type=checkbox
			// 5 - SELECT
			// 6 - INPUT type=radio or INPUT type=checkbox with name (multiple checkboxes/radio buttons)
			me._t = t;
			if (!o.ctl && !o.combo) {
				me._evts = {
					keydown: function (e) {
						v = e.keyCode;
						if (v < 15 || v > 20) {
							me._evt(e, (v === 9) ? null : me, v === 9);
						}
					},
					change: function (e) { me._evt(e, me); },
					cut: function (e) { me._evt(e, me); },
					paste: function (e) { me._evt(e, me); },
					beforecut: function (e) { me._evt(e, me); },
					drop: function (e) { me._evt(e, me); },
					dragend: function (e) { me._evt(e, me); },
					blur: function (e) { me._evt(e, me, 1); }
				};
				me._elem.bind(me._evts);
				if (o.element) {
					me._evtsE = {
						mousedown: function (e) { me._evt(e, me); },
						mouseup: function (e) { me._evt(e); }
					};
					o.element.bind(me._evtsE);
				}
			}
		},
		_evt: function (e, me, blur) {
			var o = this.options;
			if ((blur && !o.onblur) || (!blur && !o.onchange) || ($.ig && $.ig.util && $.ig.util.evtButton(e))) {
				return;
			}
			if (me) {
				setTimeout(function () {
					me.validate(e);
				}, 20);
			} else {
				this.validate(e);
			}
		},
		_loc: function (key, m) {
			key += (m ? '' : 'Message');
			var o = this.options,
				v = o.errorMessage || o[key] || (o.locale ? o.locale[key] : null);
			v = v || ($.ig && $.ig.Validator && $.ig.Validator.locale ? $.ig.Validator.locale[key] : null);
			return v || this.locale[key];
		},
		// returns: 2-keep focus, 1-keep focus once, null-do not keep focus
		_foc1: function (o) {
			o = o.keepFocus;
			return (o && this._t !== 6 && !(o.indexOf && o.indexOf('n') === 0)) ? ((o === 'once' || o === 1) ? 1 : 2) : null;
		},
		// returns 1 if tab-key event was canceled
		_onTab: function (e) {
			// suppress tab key
			if (e && e.keyCode === 9 && this._foc1(this.options) === 2) {
				_stop(e);
				return 1;
			}
		},
		_init0: function (end) {
			var form, fid, obj, id = this._id, o = this.options;
			// coming from igEditor
			if (end) {
				this._doError();
			} else {
				if (o.ctl) {
					o.ctl._validator = this;
				}
			}
			form = this.element[0].form;
			if (!form) {
				return;
			}
			fid = _fid(form, 'fid');
			// build faked unique id (like igRating)
			if (!id) {
				id = this.element[0].id;
				if (!id) {
					_id += _id.length;
					id = _id;
				}
				this._id = id;
			}
			obj = _submit[fid];
			if (!end && (o.onsubmit || o.formSubmit)) {
				if (!form._ig_onsubmit && o.onsubmit) {
					form._ig_onsubmit = 1;
					$(form).submit(function (e) {
						var f = _submit[_fid(this)];
						if (f) {
							f.validate(e);
						}
					});
				}
				if (!form._ig_formsubmit && o.formSubmit) {
					form._ig_formsubmit = form.submit;
					form.submit = function () {
						var f = _submit[_fid(this)];
						if (f && f.validate()) {
							return;
						}
						if (this._ig_formsubmit) {
							this._ig_formsubmit();
						}
					};
				}
				if (!obj) {
					obj = _submit[fid] = { ctls: {}, validate: function (e) {
						// 1: show error label
						var i, inv = false, lbl = 1, ctls = this.ctls;
						for (i in ctls) {
							if (ctls.hasOwnProperty(i) && ctls[i].validate(e, lbl)) {
								inv = true;
								if (!$.ui.igValidator.defaults.showAllErrorsOnSubmit) {
									// 2: do not show error label
									lbl = 2;
								}
							}
						}
						if (e && inv) {
							_stop(e);
						}
						return inv;
					}};
				}
				obj.ctls[id] = this;
			} else if (obj && obj.ctls && obj.ctls[id]) {
				delete obj.ctls[id];
			}
			/*
			if (obj && obj.ctls) {
				for (o in obj.ctls) {
					if (obj.ctls.hasOwnProperty(o) && typeof o === 'string' && o.length > 0) {
						return;
					}
				}
				alert('clear _submit');
			}
			*/
		},
		getLocaleOption: function (name) {
			/* Gets calculated value of locale option used by validator.
				paramType="string" Name of locale option such as "requiredMessage", "minMessage", etc.
				returnType="string" Returns value of locale option.
			*/
			return this._loc(name, 1);
		},
		isMessageDisplayed: function () {
			/* Checks if message is displayed.
				returnType="bool" Returns true if message is displayed, false if message is not displayed.
			*/
			return this._state > 6;
		},
		isValidState: function () {
			/* Checks if target element in valid state.
				returnType="bool" Returns true if target in valid state, false if target invalid.
			*/
			return !(this._state >= 6 || this.validate(null, null, 1));
		},
		hide: function (keepCss) {
			/* Hide possible error message.
				paramType="bool" optional="true" True: keep error-css applied to target, false: remove error-css from target.
			*/
			this._doError(null, null, keepCss ? 5 : 6);
		},
		// return: 1/2 - invalid
		validate: function (e, submit, check) {
			/* Trigger validation.
				paramType="object" optional="true" Reference to browser event.
				paramType="number" optional="true" Value 1 is used when validation was triggered by submit.
				paramType="bool" optional="true" Internal use only: check if value is valid and do not show any error message or styles.
				returnType="number|object" Possible values:
				1 - application canceled error message.
				2 - error message is displayed
				Any other value or undefined means that target is valid.
			*/
			var v, v2, val, txt = null, mes = 'Length', t = this._t, len = -1, o = this.options, el = this.element;
			// method can be called by setTimeout and igValidator can be already destroyed
			// L.A. 14 December 2012 - Fixing bug #129459 Required fields validation cause the inability to sumbit after entering and exiting edit mode for row adding.
			// Validation is fired on invalid/unused/hidden/inactive element and that can be identified by the parent nodes
			if (!el || el.closest("body").length === 0) {
				return;
			}
			// 4 - single INPUT type=checkbox
			// 5 - SELECT
			// 6 - INPUT type=radio or INPUT type=checkbox with name (multiple checkboxes/radio buttons)
			if (t > 3) {
				mes = 'Select';
				len = val = (t === 5) ? (el[0].multiple ? $('option:selected', el[0]).length : el[0].selectedIndex) : this._elem.filter(':checked').length;
			} else {
				val = el.hasClass('ui-igcombo-nulltext') ? '' : el.val();
				len = val.length;
			}
			if (o.ctl) {
				// reset flag in igEditor for external validation
				delete o.ctl._invPlus;
			}
			v2 = { owner: this, message: this._loc('default'), value: o.ctl ? o.ctl.value() : val };
			if (!this._trigger('checkValue', e, v2)) {
				// application did its own validation
				if (o.ctl && !check) {
					// set flag in igEditor about external validation
					o.ctl._invPlus = v2.message;
				}
				return check ? 2 : this._doError(v2.message, e, submit);
			}
			if (len === 0) {
				if (check) {
					if (o.required) {
						return 2;
					}
				} else if (!o.required) {
					return this._doError(null, e, submit);
				}
			}
			// do validations not supported by igEditor
			v = o.regExp;
			if (v && len > 0) {
				if (!v.test) {
					v = new RegExp(v.toString());
				}
				txt = v.test(val) ? null : this._loc('regExp');
				if (o.ctl) {
					// set flag in igEditor about external validation
					o.ctl._invPlus = txt;
				}
			}
			if (!txt && o.required && (len === 0 || !val)) {
				// 0 - text element (INPUT, TEXTAREA) with val()
				// 4 - single INPUT type=checkbox
				// 5 - SELECT
				// 6 - INPUT type=radio or INPUT type=checkbox with name (multiple checkboxes/radio buttons)
				txt = this._loc((t > 4) ? 'select' : 'required');
			}
			if (!txt) {
				v = o.minLength;
				v2 = o.maxLength;
				if (len >= 0 && (v > len || (v2 > 0 && v2 < len))) {
					if (v > 0 && v2 > 0) {
						txt = this._loc('range' + mes).replace('{0}', v2).replace('{1}', v);
					} else {
						txt = this._loc(((v > 0) ? 'min' : 'max') + mes).replace('{0}', (v > 0) ? v : v2);
					}
					if (o.ctl) {
						// set flag in igEditor for external validation
						o.ctl._invPlus = txt;
					}
				}
			}
			if (txt) {
				return check ? txt : this._doError(txt, e, submit);
			}
			if (o.ctl) {
				v = o.ctl._doInvalid(null, 9);
				v = v ? v.message : null;
				return check ? v : this._doError(v, e, submit);
			}
			// process only string (no bool or number)
			// 0 - text element (INPUT, TEXTAREA) with val()
			v = ((typeof o.min === 'number') ? 1 : 0) + ((typeof o.max === 'number') ? 2 : 0);
			if (!txt && t < 2 && len > 0 && v > 0) {
				val = parseFloat(val);
				if (isNaN(val)) {
					txt = this._loc('number');
				} else if (v === 3 && (val < o.min || val > o.max)) {
					txt = this._loc('range').replace('{0}', o.min).replace('{1}', o.max);
				} else if (v === 1 && val < o.min) {
					txt = this._loc('min').replace('{0}', o.min);
				} else if (v === 2 && val > o.max) {
					txt = this._loc('max').replace('{0}', o.max);
				}
			}
			return check ? txt : this._doError(txt, e, submit);
		},
		// adjust label on move
		_xyCheck: function (stop) {
			// this._xy members:
			// x/y: original "left/top" of element
			// x0/y0: shifts of "left/top" from original position
			// e: element to measure e.offset()
			// xDD/yDD: "left/top" of drop-down label
			// i: setInterval id
			var shift, xyE, xy = this._xy;
			if (!xy) {
				return;
			}
			// ensure that target is still visible (like parent dialog was closed)
			if (this._elem && this._elem[0].offsetWidth) {
				xyE = xy.e.offset();
				shift = xyE.left - xy.x;
				if (shift !== xy.x0) {
					xy.x0 = shift;
					this._dd.css('left', (xy.xDD + shift) + 'px');
				}
				shift = xyE.top - xy.y;
				if (shift !== xy.y0) {
					xy.y0 = shift;
					this._dd.css('top', (xy.yDD + shift) + 'px');
				}
			}
			if (stop || !xyE) {
				delete this._xy;
				clearInterval(xy.i);
			}
			// target was hidden
			if (!xyE) {
				this._doError();
			}
		},
		// show/hide drop-down validator error label
		// return: 2 - error message was displayed, 1 - application canceled error message
		// submit=5: unconditionally hide error label, submit=6: unconditionally hide error label and error-css
		_doError: function (txt, e, submit) {
			var marg, elem0, end, xy0, xy, arg, elem, val, ctl, align, same, aLbl, x0, y0, el,
				zi = 1,
				me = this,
				css = me.css,
				x = 'left',
				y = 'top',
				state = me._state,
				show = txt,
				dd = me._lbl,
				o = me.options;
			if (!submit) {
				submit = 0;
			}
			ctl = o.ctl;
			// align: 0-bottom, -1-left, 1-right
			align = (o.alignment === 'bottom') ? 0 : (o.alignment === 'left') ? -1 : 1;
			// text for current error message (while hide)
			if (!txt && dd) {
				txt = dd[0]._txt;
			}
			// state: 1: valid, 2: animation hide error message, 3/4: no error message, 6: invalid, 7: animation show error message, 8/9: error
			if (state < 6 && !show) {
				return;
			}
			same = dd && dd[0]._txt === txt && !me._changed;
			this._changed = null;
			// suppress tab key
			if (show && me._onTab(e) && same) {
				return 2;
			}
			if (show && same) {
				if (state > 5) {
					if (_cur === me) {
						me._focus(o, submit, e);
					}
					return 2;
				}
			}
			// do not allow focus to another validator if previous validator attempts to set focus back to itself
			if (!submit && show && _cur && new Date().getTime() - _cur._focTime < 100) {
				return 2;
			}
			arg = { owner: me, message: txt, invalid: !!show };
			// submit=5: unconditionally hide error label, submit=6: unconditionally hide error label and error-css
			if (submit < 5 && !me._trigger('validation', e, arg)) {
				// application canceled validation
				return;
			}
			// 1: valid, 2: animation hide error message, 3/4: no error message, 6: invalid, 7: animation show error message, 8/9: error
			me._state = show ? 6 : 1;
			elem = o.element || me.element;
			elem0 = ctl ? ctl._element : elem;
			// adjust appearance of target editor
			if (o.enableTargetErrorCss) {
				if (show) {
					elem0.addClass(css.target);
				// submit=5: unconditionally hide error label
				} else if (submit !== 5) {
					elem0.removeClass(css.target);
				}
			}
			// 2: flag which set while submit: error message should not be displayed
			if (submit === 2) {
				return 2;
			}
			if (!me._trigger(show ? 'errorShowing' : 'errorHiding', e, arg)) {
				// 1: flag that application canceled error message
				return 1;
			}
			if (!show && !dd) {
				return;
			}
			txt = arg.message;
			// 1: valid, 2: animation hide error message, 3/4: no error message, 6: invalid, 7: animation show error message, 8/9: error
			// increment to 2 or 7 (previous state was 1 or 6)
			me._state++;
			// true: insert error element in front of editor and use marginLeft/Top
			// false: append to body and use left/top
			marg = !o.bodyAsParent;
			if (marg) {
				x = 'marginLeft';
				y = 'marginTop';
			}
			// check for permanent custom error label
			aLbl = o.errorLabel;
			// check for mvc
			if (typeof aLbl === 'string') {
				aLbl = $('body').find('[data-valmsg-for="' + aLbl + '"]').removeClass('field-validation-valid').addClass('field-validation-error');
			}
			if (aLbl && (!aLbl.length || !aLbl.find)) {
				aLbl = null;
			}
			if (aLbl) {
				dd = aLbl;
			} else if (!dd) {
				dd = me.element[0].id;
				if (dd) {
					dd = ' for="' + dd + '"';
				}
				dd = $('<label' + dd + '/>').addClass(css.label).css({ position: 'absolute', visibility: 'hidden' });
				dd[0].unselectable = 'on';
				dd.html(txt);
				// _id: 98:drop-down error label
				dd[0]._id = 98;
				me._dd = o.theme ? $('<span/>').addClass(o.theme).css('position', 'absolute').append(dd) : dd;
				if (marg) {
					MSApp.execUnsafeLocalFunction(function () {
						me._dd.prependTo(elem0.parent());
					});
				} else {
					MSApp.execUnsafeLocalFunction(function () {
						me._dd.appendTo($('body'));
					});
				}
			}
			me._lbl = dd;
			if (show) {
				dd[0]._txt = txt;
				if (aLbl) {
					dd.html(txt).show();
				} else {
					me._dd.css(x, '0px').css(y, '0px');
					if (o.showIcon) {
						if (txt === ' ' || txt === '&nbsp;') {
							txt = '';
						}
						txt = '<span class="' + css.icon + '"></span><span style="display:inline-block;width:18px;"></span>' + txt;
					}
					dd.html(txt);
					dd.css('width', 'auto').css('height', 'auto');
					dd[0]._width0 = dd[0].offsetWidth;
					dd[0]._height0 = dd[0].offsetHeight;
					me._width = Math.max(dd.width(), 5);
					me._height = Math.max(dd.height(), 10);
					if (o.showIcon) {
						me._height = Math.max(dd.children()[0].offsetHeight, me._height);
					}
				}
				try {
					elem0.parentsUntil(document.body).add(elem0).add(elem).add(dd).each(function () {
						val = this.style ? this.style.zIndex : 0;
						val = val ? parseInt(val, 10) : null;
						if (val && !isNaN(val) && val > zi) {
							zi = val;
						}
					});
				} catch (ignore) { }
				dd.css('zIndex', zi);
				me._focTime = 0;
				_cur = me;
			}
			// action on end animation
			end = function () {
				if (show) {
					dd.css('filter', '');
				} else {
					if (aLbl) {
						aLbl.html(' ').hide();
					} else {
						me._dd.remove();
					}
					me._dd = me._lbl = _cur = null;
				}
				// 1: valid, 2: animation hide error message, 3/4: no error message, 6: invalid, 7: animation show error message, 8/9: error
				// increment to 3 or 8 (previous state was 2 or 7)
				me._state++;
			};
			// show error label
			if (show) {
				me._focus(o, submit, e);
				val = o.animationShow;
				if (val < 5) {
					val = null;
				}
				if (aLbl) {
					dd.css('opacity', 0).show();
				} else {
					dd.css({ opacity: val ? 0 : 1, height: (val ? 0 : me._height) + 'px', width: Math.floor(me._width / ((val && align >= 0) ? 2 : 1)) + 'px', display: '', visibility: 'visible' });
					// if element was swapped, then under Firefox offset() returns wrong values: use original element
					el = (ctl && ctl._swap) ? me.element : elem;
					xy = el.offset();
					if (!marg) {
						x0 = xy.left;
						y0 = xy.top;
					}
					xy.top += align ? 0 : el.outerHeight();
					if (ctl && ctl._swap) {
						xy.left -= ctl._leftShift();
					}
					if (align) {
						xy.left += (align < 0) ? -dd[0].offsetWidth : elem0[0].offsetWidth;
					}
					if (marg) {
						xy0 = dd.offset();
						xy.left -= xy0.left;
						xy.top -= xy0.top;
					} else {
						me._xy = { x0: 0, y0: 0, x: x0, y: y0, e: el, xDD: xy.left, yDD: xy.top, i: setInterval(function () {
							me._xyCheck();
						}, 300)};
					}
					me._dd.css(x, xy.left + 'px').css(y, xy.top + 'px');
				}
				if (val) {
					dd.animate(aLbl ? { opacity: 1 } : { opacity: 1, height: me._height, width: me._width }, val, null, end);
				} else {
					end();
				}
				me._trigger('errorShown', e, arg);
				// 2: flag error message was displayed
				return 2;
			}
			me._xyCheck(true);
			// hide error label
			val = o.animationHide;
			if (val < 5) {
				val = null;
			}
			if (val) {
				if (aLbl) {
					dd.animate({ opacity: 0 }, val, null, end);
				} else {
					dd.animate({ opacity: 0.6 }, Math.floor(val * 0.34)).animate({ opacity: 0, height: 0, width: Math.floor(me._width / ((align < 0) ? 1 : 2)) }, Math.floor(val * 0.66), null, end);
				}
			} else {
				end();
			}
			me._trigger('errorHidden', e, arg);
		},
		_focus: function (o, submit, e) {
			var el = (!submit && this._foc1(o)) ? this.element : null;
			e = (e && e.keyCode !== 9) ? e.type : '';
			// unknown INPUT or igEditor without focus
			if (el && !(o.ctl && o.ctl._fcs) && (this._foc1(o) !== 1 || !this._focTime) && e.indexOf('key') < 0 && e.indexOf('mouse') < 0) {
				$.ui.igValidator._keepFoc = o.ctl;
				e = $.ui.igValidator._dd;
				if (e) {
					e._doDrop();
				}
				this._focTime = new Date().getTime();
				setTimeout(function () {
					try {
						el.focus();
					} catch (ignore) { }
				}, 0);
			}
		},
		_setOption: function (key, val) {
			if (this.options[key] === val) {
				return this;
			}
			$.Widget.prototype._setOption.apply(this, arguments);
			if (typeof val !== 'function' && key !== 'locale') {
				this._init0();
			}
			return this;
		},
		destroy: function () {
			/* Destroys igValidator.
				returnType="object" Returns reference to this igValidator.
			*/
			if (!this._elem) {
				return this;
			}
			var o = this.options;
			if (!o.ctl) {
				this._elem.unbind(this._evts);
				if (this._evtsE) {
					o.element.unbind(this._evtsE);
				}
			}
			this._init0(1);
			o.element = o.ctl = this._evts = this._evtsE = this._elem = null;
			$.Widget.prototype.destroy.apply(this, arguments);
			return this;
		}
	});
	// editor: igEditor or igCombo
	// act: 'drop'-show dropdown, 'hide'-hide dropdown, true-focus, undefined/false-blur/remove
	// return: true-cancel action
	$.ui.igValidator._act = function (editor, act) {
		var d, f, v = $.ui.igValidator;
		if (!v) {
			return;
		}
		// dropped igEditor or igCombo
		d = v._dd;
		if (d && (!d._ddOn || !(d._field || d.mainElem))) {
			d = null;
			delete v._dd;
		}
		// focused igEditor
		f = v._keepFoc;
		if (f && !f._field) {
			f = null;
			delete v._keepFoc;
		}
		if (act === 'drop') {
			if (f && f !== editor && !f.validate()) {
				return true;
			}
			v._dd = editor;
			return;
		}
		if (act === 'hide') {
			if (d === editor) {
				delete v._dd;
			}
			return;
		}
		if (!act && f === editor) {
			delete v._keepFoc;
		}
		return f && f !== editor;
	};
	$.extend($.ui.igValidator, { version: '14.1.20141.2249' });
	/* Defaults used by igValidator. If appication change them, then all igValidators created after that will pickup new defaults. */
	$.ui.igValidator.defaults = {
		/* type="bool" Gets or sets ability to show all error labels on submit.
			Value false will show only error message for first failed target.
			Default value is false. */
		showAllErrorsOnSubmit: false,
		/* type="bool" Gets or sets visibility of icon on error message. Default value is true. */
		showIcon: true,
		/* type="number" Gets or sets duration of show animation in milliseconds. Default value is 300. */
		animationShow: 300,
		/* type="number" Gets or sets duration of hide animation in milliseconds. Default value is 300. */
		animationHide: 300,
		/* type="bool" Gets or sets ability to apply error css to target element. Default value is true. */
		enableTargetErrorCss: true,
		/* type="string" Gets or sets location of error label relative to target element.
			Supported values: "bottom", "left" and "right".
			Default value is "bottom". */
		alignment: 'bottom',
		/* type="object" Gets or sets option to set focus back to editor when validation failed.
			Supported values:
			'never' or 0 or null - focus is not set back to editor.
			'once' or 1 - focus is set back to editor only once.
			'always' or 2 - focus is set back to editor every time validation fails.
			Default value is null. */
		keepFocus: null,
		/* type="bool" Gets or sets triggering validation when value in editor was changed. Default value is true. */
		onchange: true,
		/* type="bool" Gets or sets triggering validation when editor lost focus.
			Default value comes from corresponding member in $.ui.igValidator.defaults object, which is true. */
		onblur: true,
		/* type="bool" Gets or sets triggering validation when application called form.submit(). Default value is false. */
		formSubmit: false,
		/* type="bool" Gets or sets triggering validation when form gets onsubmit event. Default value is true. */
		onsubmit: true
	};
}(jQuery));

/*!@license
 * Infragistics.Web.ClientUI HtmlEditor 14.1.20141.2249
 *
 * Copyright (c) 2011-2014 Infragistics Inc.
 * <Licensing info>
 *
 * http://www.infragistics.com/
 *
 * Depends on:
 *   jquery-1.9.1.js
 *   jquery.ui.core.js
 *   jquery.ui.widget.js
 *   infragistics.util.js
 *   infragistics.ui.shared.js
 *   infragistics.ui.toolbarbutton.js
 *   infragistics.ui.toolbar.js   
 *   infragistics.ui.popover.js
 *   infragistics.ui.splitbutton.js
 *   infragistics.ui.colorpicker.js
 *   infragistics.ui.colorpickersplitbutton.js
 *   infragistics.dataSource.js
 *   infragistics.ui.combo.js
 *   infragistics.ui.dialog.js
 *   infragistics.ui.htmleditor-en.js
 *   infragistics.ui.toolbar-en.js
 */

/*global jQuery, window, document, Class, $ */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {

	/*
		The igHtmlEditor is a jQuery based widget which allow you to convert a simple html element into a rich text area.
	*/
	$.widget("ui.igHtmlEditor", {
		options: {
            /* type="boolean" Shows/hides the "Formatting" toolbar. */
			showFormattingToolbar: true,
			/* type="boolean" Shows/hides the "Text" toolbar. */
			showTextToolbar: true,
			/* type="boolean" Shows/hides the "Insert Object" toolbar. */
			showInsertObjectToolbar: true,
			/* type="boolean" Shows/hides the "Copy Paste" toolbar. */
			showCopyPasteToolbar: true,
			/* type="numeric" Set or get the widget width.*/
			width: 725,
			/* type="numeric" Set or get the widget height.*/
			height: 350,
			/* type="array" The html editor toolbars list. */
			toolbarSettings: [],
			/* type="array" The html editor custom toolbars list. */
			customToolbars: [],
			/* type="string" The name attribute of the html editor source view. */
			inputName: "source",
		    /* type="string" Used to render inside the html editor as initial content */
			value: ""
		},
		events: {
			/* cancel="false" Event fired after the whole html editor widget has been rendered. */
			rendered: "rendered",
			/* cancel="false" Event fired before the html editor widget has been rendered. */
			rendering: "rendering",
			/* cancel="true" Event fired before a toolbar item is clicked. */
			actionExecuting: "actionExecuting",
			/* cancel="false" Event fired after a toolbar item is clicked. */
			actionExecuted: "actionExecuted",
			/* cancel="true" Event fired before a toolbar is collapsed. */
			toolbarCollapsing: "toolbarCollapsing",
			/* cancel="false" Event fired after a toolbar is collapsed. */
			toolbarCollapsed: "toolbarCollapsed",
			/* cancel="true" Event fired before a toolbar is expanded. */
			toolbarExpanding: "toolbarExpanding",
			/* cancel="false" Event fired after a toolbar is expanded. */
			toolbarExpanded: "toolbarExpanded",
			/* cancel="false" Event is fired on keyboard cut action. */
			cut: "cut",
			/* cancel="false" Event is fired on keyboard copy action. */
			copy: "copy",
			/* cancel="false" Event is fired on keyboard paste action. */
			paste: "paste",
			/* cancel="false" Event is fired on keyboard undo action. */
			undo: "undo",
			/* cancel="false" Event is fired on keyboard redo action. */
			redo: "redo",
			/* cancel = "false" Event is fired after reziing of workspace*/
			workspaceResized: "workspaceResized"
		},
		css: {
			/* The widget base class css. */
			htmlEditor: "ui-widget ui-widget-content ui-corner-all ui-ightmleditor ui-helper-clearfix",
			/* The html editor content styles. */
			htmlEditorContent: "ui-ightmleditor-content",
			/* The html editor toolbars style. */
			toolbarsContainer: "ui-igtoolbars-holder",
			/* The html editor dom navigation toolbar css. */
			pathFinder: "ui-igPathFinder",
			/* The workspace css. */
			workspaceIframe: "ui-widget-content"
		},
        defaultToolbars: [{
		    name: "textToolbar",
		    displayName: $.ig.HtmlEditor.locale.defaultToolbars.textToolbar,
		    isExpanded: true,
		    collapseButtonIcon: "ui-igbutton-collapse",
		    expandButtonIcon: "ui-igbutton-expand",
            items: [{
			    name: "Bold",
			    type: "button",
			    scope: null,
			    props: {
				    allowToggling: {
				        value: true
				    },
				    isBold: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    boldButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.boldButtonTitle,
					    action: '_tooltipAction'
				    },
				    boldButtonIcon: {
					    value: "ui-igbutton-bold",
					    action: '_buttonIconAction'
				    }
			    }
            }, {
			    name: "Italic",
			    type: "button",
			    props: {
				    isItalic: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    italicButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.italicButtonTitle,
					    action: '_tooltipAction'
				    },
				    italicButtonIcon: {
					    value: "ui-igbutton-italic",
					    action: '_buttonIconAction'
				    }
			    }
            }, {
			    name: "Underline",
			    type: "button",
			    props: {
				    isUnderline: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    underlineButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.underlineButtonTitle,
					    action: '_tooltipAction'
				    },
				    underlineButtonIcon: {
					    value: "ui-igbutton-underline",
					    action: '_buttonIconAction'
				    }
			    }
            }, {
			    name: "Strikethrough",
			    type: "button",
			    props: {
				    isStrikethrough: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    strikethroughButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.strikethroughButtonTitle,
					    action: '_tooltipAction'
				    },
				    strikethroughButtonIcon: {
					    value: "ui-igbutton-strikethrough",
					    action: '_buttonIconAction'
				    }
			    }
            }, {
			    name: "fontFamily",
			    type: "combo",
			    scope: null,
			    handler: "_fontNamePlg",
			    props: {
				    fontFamilyComboWidth: {
					    value: 135,
					    action: "_comboWidthAction"
				    },
				    fontFamilyComboHeight: {
					    value: "",
					    action: "_comboHeightAction"
				    },
				    fontFamilies: {
					    value: $.ig.HtmlEditor.locale.fontNames[/^win/gi.test(navigator.platform) ? 'win' : 'mac'],
					    action: "_comboDataSourceAction"
				    },
				    selectedFontFamily: {
					    value: "Times New Roman",
					    action: "_comboSelectedItem"
				    }
			    }
            }, {
			    type: "combo",
			    name: "fontSize",
			    scope: null,
			    handler: "_fontSizePlg",
			    props: {
				    fontSizeComboWidth: {
					    value: 75,
					    action: "_comboWidthAction"
				    },
				    fontSizeComboHeight: {
					    value: "",
					    action: "_comboHeightAction"
				    },
				    fontSizes: {
					    value: $.ig.HtmlEditor.locale.fontSizes,
					    action: "_comboDataSourceAction"
				    },
				    selectedFontSize: {
					    value: "1",
					    action: "_comboSelectedItem"
				    },
				    fontSizeItemsListWidth: {
					    value: 100,
					    action: "_comboDropDownListWidth"
				    }
			    }
            }, {
			    type: "combo",
			    name: "formatsList",
			    scope: null,
			    handler: "_formatsListPlg",
			    props: {
				    formatsListComboWidth: {
					    value: 125,
					    action: "_comboWidthAction"
				    },
				    formatsListComboHeight: {
					    value: "",
					    action: "_comboHeightAction"
				    },
				    formatsList: {
					    value: $.ig.HtmlEditor.locale.formatsList,
					    action: "_comboDataSourceAction"
				    },
				    selectedFormat: {
					    value: "p",
					    action: "_comboSelectedItem"
				    }
			    }
            }]
        }, {
		    name: "formattingToolbar",
		    displayName: $.ig.HtmlEditor.locale.defaultToolbars.formattingToolbar,
		    isExpanded: true,
		    collapseButtonIcon: "ui-igbutton-collapse",
		    expandButtonIcon: "ui-igbutton-expand",
            items: [{
			    name: "justifyleft",
			    type: "button",
			    props: {
				    isJustifyleft: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    justifyleftButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.alignTextLeftButtonTitle,
					    action: '_tooltipAction'
				    },
				    justifyleftButtonIcon: {
					    value: "ui-igbutton-justifyleft",
					    action: '_buttonIconAction'
				    }
			    }
            }, {
				name: "justifycenter",
				type: "button",
				props: {
					isJustifycenter: {
						value: false,
						action: '_isSelectedAction'
					},
					justifycenterButtonTooltip: {
						value: $.ig.HtmlEditor.locale.alignTextCenterButtonTitle,
						action: '_tooltipAction'
					},
					justifycenterButtonIcon: {
						value: "ui-igbutton-justifycenter",
						action: '_buttonIconAction'
					}
				}
            }, {
				name: "justifyright",
				type: "button",
				props: {
					isJustifyright: {
						value: false,
						action: '_isSelectedAction'
					},
					justifyrightButtonTooltip: {
						value: $.ig.HtmlEditor.locale.alignTextRightButtonTitle,
						action: '_tooltipAction'
					},
					justifyrightButtonIcon: {
						value: "ui-igbutton-justifyright",
						action: '_buttonIconAction'
					}
				}
            }, {
				name: "justifyfull",
				type: "button",
				props: {
					isJustifyfull: {
						value: false,
						action: '_isSelectedAction'
					},
					justifyfullButtonTooltip: {
						value: $.ig.HtmlEditor.locale.justifyButtonTitle,
						action: '_tooltipAction'
					},
					justifyfullButtonIcon: {
						value: "ui-igbutton-justifyfull",
						action: '_buttonIconAction'
					}
				}
            }, {
                name: "InsertUnorderedList",
                type: "button",
                props: {
                    isUnorderedList: {
                        value: false,
                        action: '_isSelectedAction'
                    },
                    insertUnorderedListTooltip: {
                        value: $.ig.HtmlEditor.locale.bulletsButtonTitle,
                        action: '_tooltipAction'
                    },
                    insertUnorderedListButtonIcon: {
                        value: "ui-igbutton-unorderedlist",
                        action: '_buttonIconAction'
                    }
                }
            }, {
                name: "InsertOrderedList",
                type: "button",
                props: {
                    isOrderedList: {
                        value: false,
                        action: '_isSelectedAction'
                    },
                    insertOrderedListTooltip: {
                        value: $.ig.HtmlEditor.locale.numbersButtonTitle,
                        action: '_tooltipAction'
                    },
                    insertOrderedListButtonIcon: {
                        value: "ui-igbutton-orderedlist",
                        action: '_buttonIconAction'
                    }
                }
            }, {
                name: "outdent",
                type: "button",
                props: {
                    outdentButtonTooltip: {
                        value: $.ig.HtmlEditor.locale.decreaseIndentButtonTitle,
                        action: '_tooltipAction'
                    },
                    outdentButtonIcon: {
                        value: "ui-igbutton-removeindent",
                        action: '_buttonIconAction'
                    }
                }
            }, {
                name: "indent",
                type: "button",
                props: {
                    indentTooltip: {
                        value: $.ig.HtmlEditor.locale.increaseIndentButtonTitle,
                        action: '_tooltipAction'
                    },
                    indentButtonIcon: {
                        value: "ui-igbutton-indent",
                        action: '_buttonIconAction'
                    }
                }
            }, {
				name: "textColor",
				type: "splitButtonColor",
				handler: "_fontColorPlg",
				props: {
					items: {
						value: [
							{
								name: "textColor",
								label: $.ig.HtmlEditor.locale.fontColorButtonTitle,
								iconClass: "ui-igbutton-forecolor"
							}
						]
					},
					defaultItemName: {
						value: "textColor"
					},
					selectedTextColor: {
						value: "red",
						action: "_spltButtonColorAction"
					}
				}
            }, {
				name: "backgroundTextColor",
				type: "splitButtonColor",
				handler: "_fontBackgroundColorPlg",
				props: {
					items: {
						value: [
							{
								name: "backgroundTextColor",
								label: $.ig.HtmlEditor.locale.textHighlightButtonTitle,
								iconClass: "ui-igbutton-backcolor"
							}
						]
					},
					defaultItemName: {
						value: "backgroundTextColor"
					},
					selectedTextBackgroundColor: {
						value: "",
						action: "_spltButtonColorAction"
					}
				}
            }]
        }, {
		    name: "insertObjectToolbar",
		    displayName: $.ig.HtmlEditor.locale.defaultToolbars.insertObjectToolbar,
		    isExpanded: true,
		    collapseButtonIcon: "ui-igbutton-collapse",
		    expandButtonIcon: "ui-igbutton-expand",
            items: [{
			    name: "image",
			    type: "button",
			    handler: "_insertImageDialogPlg",
			    props: {
				    isImage: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    imageButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.insertPictureButtonTitle,
					    action: '_tooltipAction'
				    },
				    imageButtonIcon: {
					    value: "ui-igbutton-addimage",
					    action: '_buttonIconAction'
				    }
			    }
            }, {
			    name: "link",
			    type: "button",
			    handler: "_insertLinkPlg",
			    props: {
				    isLink: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    linkButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.insertLinkButtonTitle,
					    action: '_tooltipAction'
				    },
				    linkButtonIcon: {
					    value: "ui-igbutton-addlink",
					    action: '_buttonIconAction'
				    }
			    }
            }, {
			    name: "table",
			    type: "button",
			    handler: "_insertTablePlg",
			    props: {
				    isTable: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    tableButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.insertTableButtonTitle,
					    action: '_tooltipAction'
				    },
				    tableButtonIcon: {
					    value: "ui-igbutton-table",
					    action: '_buttonIconAction'
				    }
			    }
            }, {
			    name: "addRow",
			    type: "button",
			    handler: "_addTableRowPlg",
			    props: {
				    allowToggling: {
					    value: false
				    },
				    isAddRow: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    addRowButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.addRowButtonTitle,
					    action: '_tooltipAction'
				    },
				    addRowButtonIcon: {
					    value: "ui-igbutton-addrow",
					    action: '_buttonIconAction'
				    }
			    }
            }, {
			    name: "addColumn",
			    type: "button",
			    handler: "_addTableColumnPlg",
			    props: {
				    allowToggling: {
					    value: false
				    },
				    isAddColumn: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    addColumnButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.addColumnButtonTitle,
					    action: '_tooltipAction'
				    },
				    addColumnButtonIcon: {
					    value: "ui-igbutton-addcolumn",
					    action: '_buttonIconAction'
				    }
			    }
            }, {
			    name: "removeRow",
			    type: "button",
			    handler: "_removeTableRowPlg",
			    props: {
				    allowToggling: {
					    value: false
				    },
				    isRemoveRow: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    removeRowButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.removeRowButtonTitle,
					    action: '_tooltipAction'
				    },
				    removeRowButtonIcon: {
					    value: "ui-igbutton-removerow",
					    action: '_buttonIconAction'
				    }
			    }
            }, {
			    name: "removeColumn",
			    type: "button",
			    handler: "_removeTableColumnPlg",
			    props: {
				    allowToggling: {
					    value: false
				    },
				    isRemoveColumn: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    removeColumnButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.removeColumnButtonTitle,
					    action: '_tooltipAction'
				    },
				    removeColumnButtonIcon: {
					    value: "ui-igbutton-removecolumn",
					    action: '_buttonIconAction'
				    }
			    }
            }]
        }, {
			name: "copyPasteToolbar",
			displayName: $.ig.HtmlEditor.locale.defaultToolbars.copyPasteToolbar,
			isExpanded: true,
			collapseButtonIcon: "ui-igbutton-collapse",
			expandButtonIcon: "ui-igbutton-expand",
            items: [{
				name: "copy",
				type: "button",
				scope: null,
				props: {
					isCopy: {
						value: false,
						action: '_isSelectedAction'
					},
					copyButtonTooltip: {
						value: $.ig.HtmlEditor.locale.copyButtonTitle,
						action: '_tooltipAction'
					},
					copyButtonIcon: {
						value: "ui-igbutton-copy",
						action: '_buttonIconAction'
					}
				}
            }, {
				name: "cut",
				type: "button",
				scope: null,
				props: {
					isCut: {
						value: false,
						action: '_isSelectedAction'
					},
					cutButtonTooltip: {
						value: $.ig.HtmlEditor.locale.cutButtonTitle,
						action: '_tooltipAction'
					},
					cutButtonIcon: {
						value: "ui-igbutton-cut",
						action: '_buttonIconAction'
					}
				}
            }, {
				name: "paste",
				type: "button",
				scope: null,
				props: {
					isPaste: {
						value: false,
						action: '_isSelectedAction'
					},
					pasteButtonTooltip: {
						value: $.ig.HtmlEditor.locale.pasteButtonTitle,
						action: '_tooltipAction'
					},
					pasteButtonIcon: {
						value: "ui-igbutton-paste",
						action: '_buttonIconAction'
					}
				}
            }, {
			    name: "undo",
			    type: "button",
			    scope: null,
			    props: {
				    allowToggling: {
					    value: false
				    },
				    isUndo: {
					    value: false,
					    action: '_isSelectedAction'
				    },
				    undoButtonTooltip: {
					    value: $.ig.HtmlEditor.locale.undoButtonTitle,
					    action: '_tooltipAction'
				    },
				    undoButtonIcon: {
					    value: "ui-igbutton-undo",
					    action: '_buttonIconAction'
				    }
			    }
            }, {
				name: "redo",
				type: "button",
				scope: null,
				props: {
					allowToggling: {
						value: false
					},
					isRedo: {
						value: false,
						action: '_isSelectedAction'
					},
					redoButtonTooltip: {
						value: $.ig.HtmlEditor.locale.redoButtonTitle,
						action: '_tooltipAction'
					},
					redoButtonIcon: {
						value: "ui-igbutton-redo",
						action: '_buttonIconAction'
					}
				}
            }]
        }],
		NODE: new $.ig.XmlNodeType(),
		//This is property is populated by initToolabrs method in the following format.
		// The state of the toolbars (visible/hidden) is set by _setActiveToolbars method.
		_toolbarsActiveState: {
			// show[ToolbarName]: {name: '[ToolbarName]', value: true},
		},
		_isDirty: false,
		_createWidget: function () {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			this._allToolbars = [];
			$.Widget.prototype._createWidget.apply(this, arguments);
		},
		_id: function (id) {
			return this.element[0].id + id;
		},
		widget: function () {
		/*
			Returns the element on which the widget was instantiated
		*/
			return this.element;
		},
		_render: function () {
			var html = "",
				inputName = this.options.inputName;
			// K.D. July 16th, 2012 Bug #101208 Removing the code that initially creates a paragraph
			this.element.addClass(this.css.htmlEditor);
			html += '<div id="' + this._id('_toolbars') + '" class="' + this.css.toolbarsContainer + '"></div>';
			html += '<div id="' + this._id("_content") + '" class="' + this.css.htmlEditorContent + '">';
			html += '<iframe class="' + this.css.workspaceIframe + '" id="' + this._id("_editor") + '"></iframe>';
			html += '<textarea name="' + inputName + '" id="' + this._id("_source") + '"></textarea>';
			html += '</div>';

			$(html).appendTo(this.element);
		    // D.A. Bug #144045 September 17th, 2013 Hide the _source element upon initialization.
		    //The css of the textarea is changed to display:block to override the browsers 
            //default display:inline-block of the textarea. Needed for the jQuery's show/hide
			//methods to toggle between display:block and display:none.
			$('#' + this._id('_source')).hide();
			// K.D. July 26th, 2012 Bug #113717 The height is applied to the iframe and not to the element. Now the height is correctly
			// calculated relatively to the total height.
			this.element.height(this.options.height);
			this.element.width(this.options.width);
		},
		_createWorkspace: function (content) {
		    // D.A. Feb 24th, 2014 Bug #164304 Vertical scrollbar always visible in IE10+. Changed doctype to html5.
            var iFrameContent = '<' + '!' + 'DOCTYPE html' + '>' +
				'<html>' +
				'<head>' +
				'<title>igHtmlEditor<\/title>' +
				'<\/head>' +
				// K.D. September 12th, 2012 Bug #120892 adding spellcheck="false" to disable firefox spellchecker
				'<body contentEditable="true" spellcheck="false" style="-webkit-tap-highlight-color: rgba(255, 255, 255, 0);">' +
				'<p>';

			if (!document.all) {
				iFrameContent += '<br \/>';
			}

            iFrameContent += '<\/p><\/body>' +
				'<\/html>';

			this.workspace = this.element.find("#" + this._id("_editor"))[0];

			this.workspace.contentWindow.document.open("text/html", "replace");
			this.workspace.contentWindow.document.write(iFrameContent);
			this.workspace.contentWindow.document.close();

		    // S.T. March 20, 2014 Bug #164898 and it's related to #113728 Extracting any initial content and rendering it as content in the iframe workspace
			if (content && content.length > 0) {
			    $(this.workspace).contents().find('body').html(content);
			}

			if ($.ig.util.isWebKit) {
				this.workspace.contentWindow.document.body.contentEditable = true;
			}
			if (!document.all) {
                var showUI = false,
                    comandValue = true;
                this.workspace.contentWindow.document.execCommand('styleWithCSS', showUI, comandValue);
			}
		},
		_getToolbar: function (index) {
			if (!isNaN(parseInt(index, 10))) {
				return this._toolbars.eq(index);
			}
			if (typeof index === "string") {
				return this._toolbars.find('#' + this._id('_toolbars_' + index));
			}
		},
		_getToolbarSettings: function (name) {
			return $.map(this.options.toolbarSettings, function(item) {
				if (item.name === name) {
					return item;
				}
			})[0];
		},
		_getFirefoxVersion: function () {
			if ($.ig.util.isFF) {
				return parseInt(window.navigator.userAgent.match(/\bFirefox\/[0-9\.]+\b/)[0].split("/").reverse()[0], 10);
			}
		},
		_create: function () {
            var noCancel = this._trigger(this.events.rendering, null, {
                owner: this
            }),
				content = this.options.value || this.element.html();

			// K.D. July 17th, 2012 Bug #113728 Extracting any initial content and rendering it as content in the iframe workspace
			this.element.empty();

            if (noCancel) {
                this._render();

			    this._allToolbars = $.extend(true, [], this.defaultToolbars.concat(this.options.customToolbars));

                this._toolbars = this.element.find("#" + this._id('_toolbars'));

                this._initToolbars(this.options, this._toolbars, this._allToolbars);

                // K.D. July 17th, 2012 Bug #113728 Extracting any initial content and rendering it as content in the iframe workspace
				this._createWorkspace(content);
				this._domPathToolbar();

				// K.D. July 26th, 2012 Bug #113717 The height is applied to the iframe and not to the element. Now the height is correctly
				// calculated relatively to the total height.
				this._resizeWorkspace();
                this._trigger(this.events.rendered, null, {
                    owner: this
                });
			}
		},
		_resizeWorkspace: function () {
			// K.D. July 26th, 2012 Bug #113717 The height is applied to the iframe and not to the element. Now the height is correctly
			// calculated relatively to the total height.
		    var height = this.element.height(),
		        $editor = $('#' + this._id('_editor'));

			height -= $('#' + this._id('_toolbars')).outerHeight(true);
			height -= $('.ui-igbutton-viewsource').outerHeight(true);
            // D.A. 31st March 2014, Take into account the editor borders and paddings
			height -= $editor.outerHeight(true) - $editor.height();

			$editor.height(height);
			$('#' + this._id('_source')).height(height);
		},
		_resizeWorkspaceHandler: function(){
            var args = {
                owner: this
            };
            this._resizeWorkspace();
            return this._trigger(this.events.workspaceResized, null, args);
		},
		_init: function () {
			this._bindToToolbarEvents();
			this._bindWorkspaceEvents();
			this.sourceWindow = this.element.find("#" + this._id('_source'));
			//TODO: the new content is not wrap in <p> on enter.
			// $(this.workspace).contents().find('body').html(this.sourceWindow.val());
			this._initFontsCombos();
			this._initFormatsListCombo();
			this._initFontSizeCombo();
			//TODO: the new content is not wrap in <p> on enter.
			// this.setContent(this.options.value, "html");
			this._analyser = new $.ig.ToolbarHelper(this.workspace.contentWindow, this._toolbars.children());

			var self = this;
			this._onSelectionChange(function () {
				self._initialWorkspaceFormatting();
			});
		},
		_initFontsCombos: function () {
			var fontFamiliesCombo = this._getToolbar("textToolbar")
				.igToolbar("getItem", "fontFamily")
				.addClass("ui-combo-fontfamily");

			fontFamiliesCombo.igCombo("option", {
				// K.D. July 24th, 2012 Bug #111689 Combo items with item template cannot be selected under IE7/IE8
				// Combo bug #113720
				itemTemplate: '<span style="font-family: ${value}" unselectable="on">${text}</span>'
			});
		},
		_initFormatsListCombo: function () {
			var formatsListCombo = this._getToolbar("textToolbar").igToolbar("getItem", "formatsList");
			// K.D. July 24th, 2012 Bug #111689 Combo items with item template cannot be selected under IE7/IE8
			// Combo bug #113720
			formatsListCombo.igCombo("option", "itemTemplate", '<${text} unselectable="on">${value}</${text}>');
		},
		_initFontSizeCombo: function () {
			var fontSizesCombo = this._getToolbar("textToolbar").igToolbar("getItem", "fontSize");

			fontSizesCombo.igCombo("option", {
				// K.D. July 24th, 2012 Bug #111689 Combo items with item template cannot be selected under IE7/IE8
				// Combo bug #113720
			    itemTemplate: '<span unselectable="on">${value}</span>'
			});
		},
		_setOption: function (name, value) {
			var self = this,
				updatedItems = [];

			if (name === undefined || value === undefined) {
				return;
			}
			if (name === "toolbarSettings") {
				$.each(value, function (index, toolbar) {
					$.each(toolbar, function (tbPropName, tbPropVal) {
						if (tbPropName !== "name") {
							self._tbHash[toolbar.name][tbPropName].updateProperty(tbPropName, tbPropVal);
							updatedItems.push(self._tbHash[toolbar.name][tbPropName]);
						}
					});
					self._getToolbar(self._allToolbars[index].name).igToolbar("option", "items", updatedItems);
				});
			} else if (this._toolbarsActiveState[name]) {
				this._showToolbar(this._toolbarsActiveState[name].name, value);
			} else if (name === "width") {
				this.element.width(value);
			} else if (name === "height") {
				this.element.find("#" + this._id("_editor")).height(value);
				//D.U. 09/05/2014 Bug 171139 [HtmlEditor] Option value cannot be changed with set value
			} else if (name === "value") {
				this.setContent(value, "text");
			}

			$.Widget.prototype._setOption.apply(this, arguments);

		},
		_showToolbar: function (name, show) {
			if (show) {
				this._getToolbar(name).removeClass('hidden').show();
			} else {
				this._getToolbar(name).addClass('hidden').hide();
			}
		},
        _initToolbars: function (options, toolbarsHolder, allToolbars) {
            var toolbar,
				i,
				toolbarName,
				showToolbar,
				property,
				settings;

            this._tbHash = [];

            for (i = 0; i < allToolbars.length; i++) {

                // Create toolbars
                settings = this._getToolbarSettings(allToolbars[i].name);
                $.extend(allToolbars[i], settings);

                toolbar = $('<span id="' + this._id('_toolbars') + '_' + allToolbars[i].name + '"></span>')
					.appendTo(toolbarsHolder)
					.igToolbar(allToolbars[i]);

                this._tbHash[allToolbars[i].name] = toolbar.igToolbar('getToolbarHash');

                showToolbar = $.camelCase("show-" + allToolbars[i].name);
                // S.T. April 17th, 2014 Bug #170258: The default value should be get from HTMLEditor options
                this._toolbarsActiveState[showToolbar] = {
                    name: allToolbars[i].name,
                    // D. A. 28th April 2014, Bug #170420 Custom toolbar is not previewed.
                    // Default value should be true when the show option is missing.
                    value: options[showToolbar] === undefined ? true : options[showToolbar]
                };

                // Create toolbars
                if (!this._isToolbarActive(allToolbars[i].name)) {
                    toolbar.hide().addClass('hidden');
				}
			}

            for (i = 0; i < options.toolbarSettings.length; i++) {
                for (property in options.toolbarSettings[i]) {
                    if (options.toolbarSettings[i].hasOwnProperty(property)) {
                        toolbarName = options.toolbarSettings[i].name;
						if (this._tbHash[toolbarName].toolbarOpts[property] !== undefined && property !== "name") {
                            this._tbHash[toolbarName].toolbarOpts[property] = options.toolbarSettings[i][property];
							continue;
						}
						if (this._tbHash[toolbarName][property] === undefined || this._tbHash[toolbarName] === undefined) {
							continue;
						}

                        this._tbHash[toolbarName][property].getProperty(property).value = options.toolbarSettings[i][property];
					}
				}
			}
		},
		_initialWorkspaceFormatting: function () {
            var options = this.options, i, toolbar, property,
				commands = {
					isBold: "bold",
					isItalic: "italic",
					isUnderline: "underline",
					isStrikethrough: "strikethrough"
				};

            for (i = 0; i < options.toolbarSettings.length; i++) {
                toolbar = options.toolbarSettings[i];
				for (property in toolbar) {
					if (toolbar.hasOwnProperty(property) && commands.hasOwnProperty(property)) {
						this._execCommand(commands[property]);
					}
				}
			}
		},
		_isToolbarActive: function (tbName) {
			var key;
            for (key in this._toolbarsActiveState) {
				if (this._toolbarsActiveState.hasOwnProperty(key)) {
					if (this._toolbarsActiveState[key].name === tbName) {
						return this._toolbarsActiveState[key].value;
					}
				}
			}
		},
		_execCommand: function (name, args) {
			this._selectionWrapperSaved.focus();
			if($.ig.util.isFF) {
				this._selectionWrapperSaved.execCommand(name.toLowerCase(), false, args);
			} else {
			    this._selectionWrapperSaved.execCommand(name.toLowerCase(), args);
			}
			this._onSelectionChange();
		},
		_hideDialogs: function () {
		    this.element.find(":ui-igLinkPropertiesDialog").igLinkPropertiesDialog("hide");
		    this.element.find(":ui-igTablePropertiesDialog").igTablePropertiesDialog("hide");
		    this.element.find(":ui-igImagePropertiesDialog").igImagePropertiesDialog("hide");
		},
		_bindToToolbarEvents: function () {
			var self = this,
				events = "igtoolbartoolbarbuttonclick igtoolbartoolbarcomboselected igtoolbartoolbarcustomitemclick " +
			        "igtoolbarcollapsing igtoolbarcollapsed igtoolbarexpanding igtoolbarexpanded",
                splitBtnArrowSelector = ".ui-splitbutton-arrow",
				toolbarEvents = {
					igtoolbarcollapsing: this.events.toolbarCollapsing,
					igtoolbarcollapsed: this.events.toolbarCollapsed,
					igtoolbarexpanding: this.events.toolbarExpanding,
					igtoolbarexpanded: this.events.toolbarExpanded
				};

            this._toolbars.delegate(":ui-igToolbar", events,
                function _onToolbarItemClick(e, ui) {
					var scope = ui.scope,
						handler = ui.handler,
                        $eTarget = $(e.originalEvent.currentTarget),
						noCancel;

					delete ui.scope;
					delete ui.handler;

					self._hideDialogs();

                    // Skip action executing when clicking on the split button arrows
					if ($eTarget.is(splitBtnArrowSelector)) {
					    // IE is closing the split button when propagation is not stopped
					    e.stopImmediatePropagation();
					    return;
                    }

					if (toolbarEvents.hasOwnProperty(e.type)) {
						self._resizeWorkspace();
						self._trigger(toolbarEvents[e.type], e, ui);
						return;
					}

					ui.selectedItem = self._selectionWrapperSaved && self._selectionWrapperSaved.getSelectedItem();
					noCancel = self._trigger(self.events.actionExecuting, e, {
						owner: self,
						toolbar: ui.toolbarName,
						actionName: ui.name
					});

					if (noCancel) {
						if (!handler && !scope) {
							self._execCommand(ui.name, ui.value);
						} else if (handler && !scope) {
							self[handler](self.workspace.contentWindow.document, ui);
						} else if (handler && scope) {
							handler.call(ui.scope, self.workspace.contentWindow.document, ui);
						}
						self._trigger(self.events.actionExecuted, e, {
							// K.D. July 17th, 2012 Bug #113736 ui.owner needs to be the HTML editor itself
							owner: self,
							toolbar: ui.toolbarName,
							actionName: ui.name
						});
						e.stopImmediatePropagation();
					}
                });
		},
		_bindWorkspaceEvents: function () {
			var self = this,
				// K.D. November 1st, 2012 Bug #104207 As we're no longer using keypress but keydown instead both codes are the same.
				KEYS = {
					webKitIE: {
						CTRLZ: 90,
						CTRLY: 89
					},
					moz: {
						CTRLZ: 90,
						CTRLY: 89
					}
				};

			$(this.workspace.contentWindow.document).find("html").bind("click", function (e) {
				var target = $(e.target);

				if (target.is("html")) {
					self.workspace.contentWindow.document.body.focus();
				}
				self._isDirty = true;
				self._hideDialogs();
				e.stopPropagation();
			}).bind("mouseup", function (e) {
				self._onSelectionChange();
			});

			// K.D. July 17th, 2012 Bug #112076 Need to bind on keydown not keypress in order for it to work in IE/Webkit
			$(this.workspace.contentWindow.document).bind("keydown", function (e) {
				self._isDirty = true;

				if (e.ctrlKey && (e.which === KEYS.webKitIE.CTRLZ || e.which === KEYS.moz.CTRLZ)) {
                    self._trigger(self.events.undo, e, { owner: self });
				}

				if (e.ctrlKey && (e.which === KEYS.webKitIE.CTRLY || e.which === KEYS.moz.CTRLY)) {
                    self._trigger(self.events.redo, e, { owner: self });
				}
				self._onSelectionChange();
			});

			$(this.workspace.contentWindow.document).bind("cut copy paste", function (e) {
                self._trigger(e.type, e, { owner: self });
			});

			this.element.bind("ightmleditoractionexecuted", function (e, ui) {
				if (ui.actionName.toLowerCase() === self.events.undo || ui.actionName.toLowerCase() === self.events.redo) {
                    self._trigger(ui.actionName.toLowerCase(), e, { owner: self });
					e.stopImmediatePropagation();
				}
			});

			$(document).click(function (e) {
			    var $tarParents = $(e.target).parents();

			    // Hide all popovers except when clicking on one of them
			    if (!$tarParents.is('.ui-igpopover') && !$tarParents.is('.ui-igcombo-list')) {
			        self._hideDialogs();
			    }
			});

			$(window).on("resize", $.proxy(this._resizeWorkspaceHandler, this));
		},
		_viewSource: function () {
			var workspace = $(this.workspace),
				workSpaceBody = workspace.contents().find('body');

			if (workspace.is(':visible')) {
				workSpaceBody.attr("contentEditable", false);
			    // K.D. October 3rd, 2012 Bug #123366 Encoding the content before setting the value
			    // D.A. November 4th, 2013 Bug #155847 Viewsource cannot be switched when there are leading whitespaces
				this.sourceWindow.val($.trim(workSpaceBody.html()));
				workspace.hide();
				this.sourceWindow.show();
			} else {
			    workSpaceBody.attr("contentEditable", true);
				workSpaceBody.html($.trim(this.sourceWindow.val()));
				workspace.show();
				this.sourceWindow.hide();
				this.sourceWindow.val(encodeURI(this.sourceWindow.val()));
			}
		},
		_viewSourcePlg: function (ui) {
			this._viewSource();
		},
		_insertImageDialogPlg: function (workspace, plgUI) {
			var image = $("<img>", this.workspace.contentWindow.document),
				self = this;

			if (plgUI.selectedItem.is("img")) {
				image = plgUI.selectedItem;
			}
			this._imageDialog = $("#" + this._id('_imageDialog'));

			if (!this._imageDialog.length) {
				this._imageDialog = $('<div id="' + this._id('_imageDialog') + '"></div>')
					.appendTo(this.element)
					.igImagePropertiesDialog({
						item: image,
						target: plgUI.toolbarItem,
						applyform: function (e, ui) {
							self._selectionWrapperSaved.focus();
							self._selectionWrapperSaved.replaceNode(ui.image);
						}
					});
			} else {
				if (this._imageDialog.igImagePropertiesDialog("option", 'isHidden')) {
					this._imageDialog.igImagePropertiesDialog("show", image);
				} else {
					this._imageDialog.igImagePropertiesDialog("hide", image);
				}
			}
		},
		_insertLinkPlg: function (workspace, ui) {
			// K.D. July 29th, 2013 Bug #146086 The subsequent Hyperlink added replaces the previous Hyperlink
			var self = this,
				selectedItem = this._selectionWrapperSaved.getSelectedItem(),
				selectedItemNodeType = selectedItem[0].nodeType,
				anchor = $("<a></a>", this.workspace.contentWindow.document);

			if (selectedItem.parent().is("a")) {
				anchor = selectedItem.parent();
			} else if ((selectedItemNodeType === this.NODE._Text) || (selectedItemNodeType === this.NODE._Element)) {
				anchor.html(this._selectionWrapperSaved.getSelectionAsText());
			}

			if (!this._insertLinkDialog) {
				this._insertLinkDialog = $('<div id="' + this._id('_linkDialog') + '"></div>')
					.appendTo(this.element)
					.igLinkPropertiesDialog({
						item: anchor,
						target: ui.toolbarItem,
						applyform: function (e, ui) {
							self._selectionWrapperSaved.focus();
							self._selectionWrapperSaved.replaceNode(ui.anchor);
						}
					});
			} else {
				if (this._insertLinkDialog.igLinkPropertiesDialog("option", 'isHidden')) {
					this._insertLinkDialog.igLinkPropertiesDialog("show", anchor);
				} else {
					this._insertLinkDialog.igLinkPropertiesDialog("hide", anchor);
				}
			}
		},
		_fontNamePlg: function (workspace, ui) {
			this._execCommand("fontname", ui.value);
		},
		_fontSizePlg: function (workspace, ui) {
			this._execCommand("fontsize", ui.value);
		},
		_formatsListPlg: function (workspace, ui) {
			this._execCommand("formatBlock", "<" + ui.value + ">");
		},
		_insertTablePlg: function (workspace, plgUI) {
			var table = $("<table></table>", this.workspace.contentWindow.document),
				self = this;
			if (plgUI.selectedItem.is("table")) {
				table = plgUI.selectedItem;
			}
			if (!this.insertTableDialog) {
				this.insertTableDialog = $("<div id='" + this._id('_tableDialog') + "'</div>")
					.appendTo(this.element)
					.igTablePropertiesDialog({
					    item: table,  //$(this.workspace.contentWindow.document).find('body p'),Should be changed with that or something else
						target: plgUI.toolbarItem,
						applyform: function (e, ui) {
							self._selectionWrapperSaved.insertTable(ui.table);
						}
					});
				return;
			}
			if (this.insertTableDialog.igTablePropertiesDialog("option", "isHidden")) {
				this.insertTableDialog.igTablePropertiesDialog("show", table);
				return;
			}
			if (!this.insertTableDialog.igTablePropertiesDialog("option", "isHidden")) {
				this.insertTableDialog.igTablePropertiesDialog("hide");
			}
		},
		_addTableRowPlg: function () {
			var selectedItem = this._selectionWrapperSaved.getSelectedItem();
			if (selectedItem.is("table")) {
				selectedItem.tableManipulator("addRow");
			} else if (selectedItem.is("td")) {
				selectedItem.parents("table").first().tableManipulator("addRow", selectedItem.parent().index());
			}
		},
		_removeTableRowPlg: function () {
			var selectedItem = this._selectionWrapperSaved.getSelectedItem();
			if (selectedItem.is("table")) {
				selectedItem.tableManipulator("removeRow");
			} else if (selectedItem.is("td")) {
				selectedItem.parents("table").first().tableManipulator("removeRow", selectedItem.parent().index());
			}
		},
		_addTableColumnPlg: function () {
			var selectedItem = this._selectionWrapperSaved.getSelectedItem();
			if (selectedItem.is("table")) {
				selectedItem.tableManipulator("addColumn");
			} else if (selectedItem.is("td")) {
				selectedItem.parents("table").first().tableManipulator("addColumn", selectedItem.index());
			}
		},
		_removeTableColumnPlg: function () {
			var selectedItem = this._selectionWrapperSaved.getSelectedItem();
			if (selectedItem.is("table")) {
				selectedItem.tableManipulator("removeColumn");
			} else if (selectedItem.is("td")) {
			    selectedItem.parents("table").first().tableManipulator("removeColumn", selectedItem.index());
			}
		},
		_fontColorPlg: function (workspace, ui) {
			this._execCommand("forecolor", ui.value);
		},
		_fontBackgroundColorPlg: function (workspace, ui) {
			var command = this._getFirefoxVersion() ? "hilitecolor" : "backcolor";
			this._execCommand(command, ui.value);
		},
		_domPathToolbar: function () {
		    var self = this,
                tableItemPref = "#" + this._id("_toolbars_insertObjectToolbar_item_"),
                tableItemAddRowID = tableItemPref + "addRow",
                tableItemAddColID = tableItemPref + "addColumn",
                tableItemRemRowID = tableItemPref + "removeRow",
                tableItemRemColID = tableItemPref + "removeColumn",
		        doNotEnableToolbarButtonsSelector = tableItemAddRowID + ", " +
                    tableItemAddColID + ", " +
                    tableItemRemRowID + ", " +
                    tableItemRemColID;

            this._viewSourceBtn = $('<div class="ui-igbutton-viewsource"></div>')
                .appendTo(this.element)
				.igButton({
					labelText: '&nbsp;',
					title: $.ig.HtmlEditor.locale.viewSourceButtonTitle,
					icons: {
						primary: "ui-igbutton-viewsource-icon"
					},
					onlyIcons: true,
					click: function () {
						self._viewSourcePlg();
						if (self._domPathToolbar.igPathFinder("option", "disabled")) {
						    self._domPathToolbar.igPathFinder("option", "disabled", false);
						    // D.A. January 31st 2014, Bug #130480 Add/remove table items become active after clicking the view source button
						    self._toolbars
                                .find(":ui-igToolbarButton")
                                    .not(doNotEnableToolbarButtonsSelector)
                                        .igToolbarButton("option", "disabled", false)
                                    .end()
                                .end()
							    .find(":ui-igCombo")
                                    .igCombo("enable");
							// K.D. July 17th, 2012 Bug #113713 In Chrome Cut/Copy/Paste buttons are enabled after switching between design view and source view
						    self._analyser._disableUnsupportedItems();
						    // D.A. March 20th, 2014 Bug #167806 Deleted DOM elements are still available in the DOM path toolbar after deleting them in the source code
						    self._onSelectionChange();
						} else {
							self._domPathToolbar.igPathFinder("option", "disabled", true);
				            self._toolbars
                                .find(":ui-igToolbarButton")
                                    .igToolbarButton("option", "disabled", true)
                                .end()
								.find(":ui-igCombo").igCombo("disable");
						}
					}
				});

            this._domPathToolbar = $('<div id="' + this._id('_domPathToolbar') + '"></div>')
				.appendTo(this.element)
				.igPathFinder({
					click: function (e, ui) {
						var selectionWrapper = self._selectionWrapperSaved;
						self.workspace.contentWindow.document.body.focus();
						if (self._domPathToolbar.igPathFinder("option", "disabled")) {
							return;
						}
						e.preventDefault();
						if (ui.item.is("html")) {
							selectionWrapper.select(ui.item.children("body"));
						} else if (ui.item.is("body")) {
							selectionWrapper.select(ui.item);
						} else {
							selectionWrapper.select(ui.item);
						}
					}
				});
		},
		_cutPlg: function () {
			this._execCommand("cut");
		},
		_copyPlg: function () {
			this._execCommand("copy");
		},
		_pastePlg: function () {
			this._execCommand("paste");
		},
		_onSelectionChange: function (callback) {
			var self = this,
				selectionWrapper,
                workSpaceBody = $(this.workspace).contents().find('body'),
				selectionCallback = callback || function () {
					var selectedItem = this.getSelectedItem();
					// K.D. September 12th, 2012 Bug #120891 We need to return the span/font from the selection
					// wrapper in order to correctly analyze the styles
					if (selectedItem && (selectedItem.is('p') || selectedItem.is(':header')) && selectedItem.children('span').length > 0) {
						selectedItem = selectedItem.children('span').first();
					} else if (selectedItem && (selectedItem.is('p') || selectedItem.is(':header')) && selectedItem.children('font').length > 0) {
						selectedItem = selectedItem.children('font').first();
					}
					if (selectedItem[0].nodeType === self.NODE._Text) {
						selectedItem = selectedItem.parent();
					}

					self._analyser.analyse(selectedItem);

					if (selectedItem.length) {
						self._domPathToolbar.igPathFinder("option", "items", $.merge(selectedItem, selectedItem.parents()));
					}
				};

			selectionWrapper = new $.ig.SelectionWrapper(this.workspace.contentWindow, function () {
			    self._selectionWrapperSaved = this;
			    // D.A. 18th September 2013 Bug# 151506 The TextArea value should
			    // be updated after the selection wrapper is initialized.
			    // K.D. October 3rd, 2012 Bug #123366 Encoding the content before setting the value
			    self.sourceWindow.val(encodeURI(workSpaceBody.html()));
				selectionCallback.call(this);
			});
		},
		_destroyPopovers: function () {
		    var el = this.element[0];
		    $(':data("igPopover")').each(function () {
		        if ($.contains(el, this)) {
		            $(this).igPopover('destroy');
		        }
		    });
		},
		getContent: function (format) {
			/*
				Gets the content of the html editor.
				paramType="string" optional="false" Returns the content as html or plain text. Values can be "text" or "html".
				returnType="string" The editor content.
			*/
			if (format === "text") {
				return $(this.workspace).contents().find('body').text();
			}
			if (format === "html") {
				return $(this.workspace).contents().find('body').html();
			}
		},
		setContent: function (content, format) {
		/* 
			Sets the content of the html editor.
			paramType="string" optional="false" The content which will be set.
			paramType="string" The content type: "text" or "html".
		*/
			if (format === "text") {
				$(this.workspace).contents().find('body').text(content);
			} else if (format === "html") {
				$(this.workspace).contents().find('body').html(content);
			}
			// K.D. October 2nd, 2012 Bug #123366 Encoding the content before setting the value
			this.sourceWindow.val(encodeURI(content));
		},
		destroy: function () {
		/* Destroys the widget. */
			$.Widget.prototype.destroy.apply(this, arguments);
			$(this.workspace.contentWindow).undelegate();
			this._destroyPopovers();
			this._viewSourceBtn.igButton("destroy");
			this.element.removeClass(this.css.htmlEditor)
				.find("#" + this._id("_content")).removeClass(this.css.htmlEditorContent).end()
				.find("#" + this._id("_domPathToolbar")).removeClass(this.css.pathFinder).end()
				.find("#" + this._id("_toolbars")).removeClass(this.css.toolbarsContainer).end()
				.find(":ui-igToolbar").igToolbar("destroy").end()
				.empty();
		},
		executeAction: function (actionName, args) {
		/*
			Executes htmleditor commands.
			paramType="string" optional="false" The command name.
			paramType="object" optional="true" Additional parameter for the command.
		*/
		    // D.A. 25th November 2013, Bug #158403 ExecuteAction method ignores the current selection.
		    // The select() call resets the selection.
			//this._selectionWrapperSaved.focus();
			//this._selectionWrapperSaved.select();
			this._selectionWrapperSaved.execCommand(actionName.toLowerCase(), args);
			this._onSelectionChange();
		},
		isDirty: function () {
		/*
			Returns true/false if the editor contents were modified or not.
			returnType="boolean" Returns true if contents were modified and false otherwise.
		*/
			return this._isDirty;
		},
		contentWindow: function () {
		    /*
                Returns the window object associated with the Html Editor's content editable area
                returnType="object" The window object associated with the Html Editor's content editable area
            */

		    return this.workspace.contentWindow;
		},
		contentDocument: function () {
		    /*
                Returns the document object associated with the Html Editor's content editable area
                returnType="object" The document object associated with the Html Editor's content editable area
            */

		    return this.contentWindow().document;
		},
		contentEditable: function () {
		/*
            Returns the content editable associated with this Html Editor
            returnType="object" The content editable associated with this Html Editor
        */

		    return this.contentDocument().body;
		},
		selection: function () {
		/*
            Returns Selection object that represent the current selection in the content editable
            returnType="object" Returns Selection object that represent the current selection in the content editable
        */
		    return this._selectionWrapperSaved._getSelection();
		},
		range: function () {
		    /*
                Returns Range object that represent the current range in the content editable
                returnType="object" Returns Range object that represent the current range in the content editable
            */
		    return this._selectionWrapperSaved._getRange();
		},
		insertAtCaret: function (element) {
		    /* Inserts the provided content at the position of the caret.
               paramType="string|object" optional="false" Accepts html string, DOM element or a jQuery object.
            */

		    var el,
                range;

		    if ($.ig.util.isDomElement(element)) {
                // Convert Dom element to jQuery object
		        element = $(element);
		    }

		    if (element instanceof $) {
		        // Get the html of an jQuery object
		        element = $('<div />').append(element).html();
		    } else if (typeof element !== "string") {
                // Process only Dom objects, jQuery objects or strings
		        return;
		    }

            // Creates an element with the iframe document as owner document
		    el = $(element, this._selectionWrapperSaved._document)[0];
		    range = this.range();

		    if (this._selectionWrapperSaved._isIeOld) {
		        range.pasteHTML(element);
		    } else {
		        range.insertNode(el);
		    }
		}
	});

    /************************************
		igPathFinder
	************************************/
	$.widget("ui.igPathFinder", {
		options: {
			items: null
		},
		css: {
			button: "ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only ui-igbutton ui-widget-content",
            buttonLabel: "ui-button-text",
            stateDefault: "ui-state-default",
            firstButton: "ui-first-button",
            overflowMarker: "ui-igpathfinder-overflowMarker"
		},
		_create: function () {
			this._addStyles();
		},
		_addStyles: function () {
			this.element.addClass('ui-igPathFinder');
		},
		_setOption: function (name, value) {
			$.Widget.prototype._setOption.apply(this, arguments);
			switch (name) {
			case "items":
				this._updateToolbar();
				break;
			case "disabled":
				// K.D. July 13th, 2012 Bug #114609 The buttons in the path finder submit the page if the path finder is disabled
				this.element.find('button').attr('disabled', value).attr('aria-disabled', value);
				break;
			default:
				break;
			}
		},
        _addOverflowMarker: function () {
            var overflowMarker = $("<div>...</div>")
                .addClass(this.css.overflowMarker)
                .addClass(this.css.stateDefault);
            
            overflowMarker.prependTo(this.element);
        },
		_updateToolbar: function () {

		    var i,
                parents,
                btn,
                buttonsList,
                self = this,
				o = this.options,
				path = [],
                html = "",
                viewSrcBtn = $('.ui-igbutton-viewsource'),
                overflowMarkerWidth = 20,
                maxWidth = viewSrcBtn.parent().width() - viewSrcBtn.outerWidth(true) - overflowMarkerWidth,
                maxWidthReached = false;

			if (o.items.length) {
				o.items.each(function (index, element) {
				    html = '<div aria-disabled="false" style="z-index:' + index + '" class="' + self.css.button + '">' +
						        '<span class="' + self.css.buttonLabel + '">' +
						            element.nodeName +
						        '</span>' +
						    '</div>';
					path.push(html);
				});

				this.element.empty();
				parents = $(o.items.toArray().reverse());
				buttonsList = $(path.reverse().join(""));

			    // Add all buttons to the path until the max width is reached
				for (i = buttonsList.length - 1; i >= 0 && !maxWidthReached; i--) {

                    // Clear previously added first button classes
				    buttonsList.removeClass(this.css.firstButton);
				    btn = buttonsList.eq(i)
                        .addClass(this.css.firstButton)
                        .prependTo(this.element);

                    // Adjust the max width to consider the width of the overflow marker
				    if (i === 0) {
				        maxWidth += overflowMarkerWidth;
				    }
                    
				    // When the maximum width is reached, remove the last added button.
				    // Then add the overflow marker.
				    if (this.element.outerWidth(true) > maxWidth) {
				        // Remove the overflowing button
				        btn.remove();
				        // Set first-button class on the previous button
				        buttonsList.eq(i + 1).addClass(this.css.firstButton);
				        this._addOverflowMarker();
				        maxWidthReached = true;
				    }
				}

                buttonsList
					.attr('disabled', o.disabled)
                    .attr('aria-disabled', o.disabled)
					.mouseover(function (e) {
						if (!o.disabled) {
							$(this).addClass("ui-state-hover");
						}
					})
					.mouseleave(function (e) {
						if (!o.disabled) {
							$(this).removeClass("ui-state-hover");
						}
					})
					.click(function (e) {
						if (!o.disabled) {
							$(this).siblings(".ui-state-active").removeClass('ui-state-active');
							$(this).addClass("ui-state-active");

					            self._trigger("click", e, { item: parents.eq(buttonsList.index(this)) });
						}
					});
			}
		}
	});

    // End HTML Editor Core

    /************************************ 
        HTML Editor Subcomponents
    ************************************/

    // Dialogs

    /************************************
       igHtmlEditorPopover
   ************************************/
	$.widget("ui.igHtmlEditorPopover", {
		options: {
			item: null,
			target: null,
			isHidden: true
		},
		css: {
			igHtmlEditorPropertiesDialog: "ui-ightmleditor-dialog",
			igHtmlEditorPropertiesDialogContainer: "ui-ightmleditor-dialog-container"
		},
		events: {
			apply: "applyform",
			cancel: "cancelform",
			show: "show",
			hide: "hide"
		},
		_id: function (id) {
			return this.element[0].id + id;
		},
		_create: function () {
			this.element.igPopover({
				closeOnBlur: false,
				position: "balanced",
				direction: "bottom",
				renderCloseButton: false,
                // T.G,  28 Jan 2014 - 162527 - removing the target from the igPopover
                //target: this.options.target,
				showOn: null
			});
			this.poContent = this.element.igPopover("container");
			this._createForm();
		},
		_init: function () {
            this._item = this.options.item;
			this.poContent.addClass(this.css.igHtmlEditorPropertiesDialog);
			this.element.addClass(this.css.igHtmlEditorPropertiesDialogContainer);

			this._attachFormEvents();
			this.show(this._item);
		},
        _createForm: function () { },
        _attachFormEvents: function () { },
        _dataBind: function (item) { },
		show: function (item) {
			this._item = item;
			this._dataBind(item);
			this.options.isHidden = false;
            // T.G 16 Jan 2014 - Fix bug 161249 - Target option is not needed because the user expects it to be the element on which the popover is initialized
            this.element.igPopover("show", this.options.target);
			this._trigger(this.events.show);
		},
		hide: function () {
			this.options.isHidden = true;
			if (this.options.target.igToolbarButton('option', 'isSelected')) {
				this.options.target.igToolbarButton("toggle");
			}
			this.element.igPopover("hide");
			this._trigger(this.events.hide);
		}
	});

    /************************************
      igLinkPropertiesDialog
   ************************************/
	$.widget("ui.igLinkPropertiesDialog", $.ui.igHtmlEditorPopover, {
		_txtUrl: "",
		_cbTarget: "",
		_attachFormEvents: function () {
			var self = this;

			this.poContent.find("#" + this._id('_cmbOpenIn')).igCombo({
                selectedItems: [{
                    index: 0
                }],
				enableClearButton: false,
				width: 155
			});
			this.poContent.find("#" + this._id('_btnCancel')).igButton({
				click: function () {
					self.hide();
				}
			});
			this.poContent.find("#" + this._id('_btnApply')).igButton({
				click: function (e) {
					e.stopImmediatePropagation();
					// K.D. September 13th, 2012 Bug #120906 Applying the href as text if no text is specified.
					self._item.attr({
					    href: self._txtUrl.val(),
					    // S.T. April 17th, 2014 Bug #170227: Getting value with JQuery val will return null instead _blank. Use igCombo value method to get the target.
					    target: self._cbTarget.igCombo("value")
					}).html(self._displayText.val().length > 0 ? self._displayText.val() : self._txtUrl.val());
                    self._trigger(self.events.apply, e, {
                        anchor: self._item
                    });
					self.hide();
				}
			});
			this.poContent.bind("keypress", function (e) {
				if (e.keyCode === $.ui.keyCode.ESCAPE) {
					self.hide();
				}
			});
            this.element.bind("igpopovershown", function (e) {
				self.poContent.find("#" + self._id('_linkHref')).focus();
			});
		},
		_createForm: function () {
			var html = '';

            html += '<div>' +
			    '<ol class="layoutList">' +
			        '<li>' +
			            '<label for="' + this._id('_linkHref') + '">' + $.ig.HtmlEditor.locale.linkNavigateToUrlDialogText + '</label>' +
			            '<input autocomplete="off" id="' + this._id('_linkHref') + '" name="href" type="text" value="" />' +
			        '</li>' +
			        '<li>' +
			            '<label for="' + this._id('_linkDisplayText') + '">' + $.ig.HtmlEditor.locale.linkDisplayTextDialogText + '</label>' +
			            '<input autocomplete="off" id="' + this._id('_linkDisplayText') + '" name="href" type="text" value="" />' +
			        '</li>' +
			        '<li>' +
			            '<label for="' + this._id('_cmbOpenIn') + '">' + $.ig.HtmlEditor.locale.linkOpenInDialogText + '</label>' +
			            '<select id="' + this._id('_cmbOpenIn') + '" name="target">' +
			                '<option value="_blank">' + $.ig.HtmlEditor.locale.linkTargetNewWindowDialogText + '</option>' +
			                '<option value="_self">' + $.ig.HtmlEditor.locale.linkTargetSameWindowDialogText + '</option>' +
			                '<option value="_parent">' + $.ig.HtmlEditor.locale.linkTargetParentWindowDialogText + '</option>' +
			                '<option value="_top">' + $.ig.HtmlEditor.locale.linkTargetTopmostWindowDialogText + '</option>' +
			            '</select>' +
			        '</li>' +
			        '<li style="text-align:right">' +
			            '<button aria-disabled="false" id="' + this._id('_btnApply') + '" name="insertLink" role="button" title="' +
                            $.ig.HtmlEditor.locale.applyButtonTitle + '" type="button">' + $.ig.HtmlEditor.locale.applyButtonTitle + '</button>' +
			            '<button aria-disabled="false" id="' + this._id('_btnCancel') + '" role="button" title="' +
                            $.ig.HtmlEditor.locale.cancelButtonTitle + '" type="button">' + $.ig.HtmlEditor.locale.cancelButtonTitle + '</button>' +
			        '</li>' +
			    '</ol>' +
			'</div>';

			$(html).appendTo(this.poContent);
		},
		_dataBind: function (anchor) {
			this._txtUrl = this.poContent.find("#" + this._id('_linkHref')).val(anchor.attr("href"));
			this._cbTarget = this.poContent.find("#" + this._id('_cmbOpenIn')).val(anchor.attr("target"));
			this._displayText = this.poContent.find("#" + this._id('_linkDisplayText')).val(anchor.html());
		}
	});

    /************************************
        igTablePropertiesDialog
    ************************************/
	$.widget("ui.igTablePropertiesDialog", $.ui.igHtmlEditorPopover, {
		_init: function () {
			this.rowsNumField = this.element.find('#' + this._id('_tableRows'));
			this.columnsNumField = this.element.find('#' + this._id('_tableColumns'));

			$.ui.igHtmlEditorPopover.prototype._init.apply(this, arguments);
		},
		_createForm: function () {
            var html = '<div>' +
				    '<ol class="layoutList">' +
				        '<li>' +
				        '</li>' +
				        '<li>' +
				            '<div class="ui-igtablepropertiesdialog-cols-rows-num">' +
				                '<input type="hidden" id="' + this._id('_tableRows') + '" name="tableRows" readonly="readonly" value="">' +
				                '<input type="hidden" id="' + this._id('_tableColumns') + '" name="tableColumns" readonly="readonly" value="">' +
				            '</div>' +
				        '</li>' +
				    '</ol>' +
				'</div>';

			$(html).appendTo(this.poContent);

			this._sampleTable = $('<table "' + this._id('_tableModel') + '" class="ui-igtablepropertiesdialog-sample-table"></table>')
				.tableManipulator({ rows: 8, columns: 6 })
				.appendTo(this.poContent.find(".layoutList li:first"));
		},
		_attachFormEvents: function () {
			var tablePreview = this.poContent.find("table"),
				cells = tablePreview.find("td").addClass("ui-state-default"),
				rows = tablePreview.find("tr"),
				self = this;

            tablePreview.delegate("td", "mouseover", function (e) {
				var target = $(e.target),
					currentRowNumber = target.parent().index() + 1,
					currentColumnNumber = $(this).index() + 1,
					i;

					cells.removeClass("ui-state-hover");
					for (i = 0; i < currentRowNumber; i++) {
						$(rows.get(i)).find("td:lt(" + currentColumnNumber + ")").addClass("ui-state-hover");
					}

					self.rowsNumField.val(currentRowNumber);
					self.columnsNumField.val(currentColumnNumber);
            });

            tablePreview.delegate("td", "click", function (e) {
                var target = $(e.target),
					currentRowNumber = target.parent().index() + 1,
					currentColumnNumber = $(this).index() + 1;

                self._item.tableManipulator({ rows: currentRowNumber, columns: currentColumnNumber, addSpacingChar: true });


                self._trigger(self.events.apply, e, {
                    table: self._item.attr("border", 1)
                });

					self.hide();
			});

			tablePreview.bind('mouseout', function () {
				cells.removeClass("ui-state-hover");
				self.rowsNumField.val(null);
				self.columnsNumField.val(null);
			});
		},
		_dataBind: function (table) {
			this.rowsNumField.val();
			this.columnsNumField.val();
		}
	});

    /************************************ 
        igImagePropertiesDialog
    ************************************/
	$.widget("ui.igImagePropertiesDialog", $.ui.igHtmlEditorPopover, {
		_init: function () {
			this._imgSrcFld = this.poContent.find("#" + this._id('_imgSrc'));
			this._imgAltFld = this.poContent.find("#" + this._id('_imgAlt'));

			$.ui.igHtmlEditorPopover.prototype._init.apply(this, arguments);
		},
		_createForm: function () {
			var html = '';

			html += '<div class="' + this.css.igImagePropertiesDialogContent + '">';
			html += '	<div>';
			html += '		<ol class="layoutList">';
			html += '			<li>';
			html += '				<label for="' + this._id('_imgSrc') + '">' + $.ig.HtmlEditor.locale.imageUrlDialogText + '</label>';
			html += '				<input autocomplete="off" id="' + this._id('_imgSrc') + '" name="src" type="text" value="" />';
			html += '			</li>';
			html += '			<li>';
			html += '				<label for="' + this._id('_imgAlt') + '">' + $.ig.HtmlEditor.locale.imageAlternativeTextDialogText + '</label>';
			html += '				<input autocomplete="off" id="' + this._id('_imgAlt') + '" name="altText" type="text" value="" />';
			html += '			</li>';
			html += '			<li style="text-align:right">';
			html += '				<button aria-disabled="false" id="' + this._id('_btnApply') + '" name="insertLink" role="button" title="' + $.ig.HtmlEditor.locale.applyButtonTitle + '" type="button">' + $.ig.HtmlEditor.locale.applyButtonTitle + '</button>';
			html += '				<button aria-disabled="false" id="' + this._id('_btnCancel') + '" role="button" title="' + $.ig.HtmlEditor.locale.cancelButtonTitle + '" type="button">' + $.ig.HtmlEditor.locale.cancelButtonTitle + '</button>';
			html += '			</li>';
			html += '		</ol>';
			html += '	</div>';
			html += '</div>';

			this.poContent.append(html);
		},
		_attachFormEvents: function () {
			var self = this;

			this.poContent.find("#" + this._id('_btnApply')).igButton({
				click: function (e) {
					self._item.attr({
						src: self._imgSrcFld.val(),
						alt: self._imgAltFld.val()
                    });

                    self._trigger(self.events.apply, e, {
                        image: self._item
					});

					self.hide();
				}
			}).end()
				.find("#" + this._id('_btnCancel')).igButton({
					click: function (e) {
						self._trigger(self.events.cancel, e);
						self.hide();
					}
				});
		},
		_dataBind: function (image) {
			this._imgSrcFld.val(image.attr("src"));
			this._imgAltFld.val(image.attr("alt"));
				}
			});

    // End Dialogs

    /************************************ 
        End HTML Editor subcomponents
    ************************************/

    /************************************ 
        HTML Editor Utilities
    ************************************/
	//tableManipulator plugin
	var table,
		tableNumRows = 0,
		tableNumCols = 0,
		settings = {
			document: document,
			rows: 0,
			columns: 0,
			addSpacingChar: false
		},
		spacingChar = "",
		methods = {
			init: function (options) {
			    // var self = this;

			    return this.each(function () {
			        var tRows;
					$.extend(settings, options);

					if (this.nodeName.toLowerCase() !== "table") {
						return;
					}

					if (settings.addSpacingChar) {
						spacingChar = "&nbsp;";
					}

					table = $(this);
					tRows = methods.getTableRows();

					if (settings.rows && settings.rows > 0) {
						tableNumRows = settings.rows;
					} else {
					    tableNumRows = tRows.length;
					}
					if (settings.columns && settings.columns > 0) {
						tableNumCols = settings.columns;
					} else if (tRows[0]) {
					    tableNumCols = tRows[0].cells.length;
					}
					if (!table.children().length) {
						methods.create();
					}
				});
			},
			create: function () {
				var newRow,
					i,
					j;
				table.empty();
				for (i = 0; i < tableNumRows; i++) {
					newRow = $("<tr></tr>", settings.document).appendTo(table);
					for (j = 0; j < tableNumCols; j++) {
						$("<td>" + spacingChar + "</td>", settings.document).appendTo(newRow);
					}
				}
			},
			addRow: function (position) {
				var newRow = $("<tr></tr>", settings.document),
					j;
				if (position) {
				    newRow.insertAfter(methods.getTableRows().eq(position));
				} else {
					newRow.appendTo(table);
				}

				for (j = 0; j < methods.getColumnsNum() ; j++) {
					$("<td>" + spacingChar + "</td>", settings.document).appendTo(newRow);
				}
				return newRow;
			},
			removeRow: function (position) {
			    var rows = methods.getTableRows(),
					removedRow;
				if (position) {
					removedRow = rows.eq(position).remove();
				} else {
					removedRow = rows.last().remove();
				}
				return removedRow;
			},
			addColumn: function (position) {
			    var columnCellsArr = [];

			    methods.getTableRows().each(function (idx, el) {
					var row = $(el),
						columns = row.children('td'),
						newColumn = $('<td>' + spacingChar + '</td>', settings.document);
					if (position && columns.length) {
						columnCellsArr.push(newColumn.insertAfter(columns.eq(position))[0]);
						return true;
					}
					columnCellsArr.push(newColumn.appendTo(row)[0]);
				});
				return $([]).pushStack(columnCellsArr);
			},
			removeColumn: function (position) {
				var removedRowsArr = [];

				methods.getTableRows().each(function (idx, el) {
					var row = $(el);
					if (position) {
						removedRowsArr.push(row.children("td").eq(position).remove());
						return true;
					}
					removedRowsArr.push(row.children("td:last").remove());
				});
				return $([]).pushStack(removedRowsArr);
			},
			getRowsNum: function () {
			    return methods.getTableRows().length;
			},
			getColumnsNum: function () {
			    return methods.getTableCols().length;
			},
            // D.A. October 4th 2013, Bug #155868 Nested tables not working correctly
			getTableRows: function () {
			    return table.children('tbody').children('tr');
			},
			getTableCols: function () {
			    return table.children('tbody').children('tr').first().children('td');
			}
		};
	$.fn.tableManipulator = function (method) {
		if (methods[method]) {
			if (this !== table[0]) {
				table = $(this);
			}
			return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
		}
		if (typeof method === 'object' || !method) {
			return methods.init.apply(this, arguments);
		}
        $.error('Method ' + method + ' does not exist on jQuery.tableManipulator');
	};

    // TODO: Remove IE7 support

    /************************************
        igSelectionWrapper
    ************************************/
	$.ig.SelectionWrapper = $.ig.SelectionWrapper || Class.extend({
		_selection: null,
		_range: null,
		_isIeOld: false,
		_document: null,
		_commands: {
            insertunorderedlist: { name: "_insertList", browsers: null, args: ["insertunorderedlist"] },
            insertorderedlist: { name: "_insertList", browsers: null, args: ["insertorderedlist"] }
        },
        _css: {
            larger: "ui-ightmleditor-larger",
            smaller: "ui-ightmleditor-smaller"
		},
		NODE: new $.ig.XmlNodeType(),
		init: function (window, callback) {
			var self = this;
			this._window = window;
			this._document = this._window.document;

			if (!this._document.getSelection) {
				this._isIeOld = true;
			}
			if (this._isIeOld) {
				// K.D. July 18th, 2012 If we don't focus the selection with IE <= 8, then executing an action on the window
				// will incorrectly fire on the top-most parent window.
				this.focus();
				this._selection = this._document.selection;
				this._window.setTimeout(function () {
					self._range = self._selection.createRange();
					if ($.isFunction(callback)) {
						callback.call(self);
					}
				}, 50);
			} else {
				this._selection = this._window.getSelection();
				this._window.setTimeout(function () {
					self._range = (self._getSelection().rangeCount === 0) ? self._document.createRange() : self._selection.getRangeAt(0);
					if ($.isFunction(callback)) {
						callback.call(self);
					}
				}, 50);
			}
		},
		_getSelection: function () {
			return this._selection;
		},
		_getRange: function () {
			return this._range;
		},
		_isCommandSupportedByBrowser: function (command) {
			var supportedBrowsers, i;
			if (command === null || !this._commands.hasOwnProperty(command.toLowerCase())) {
				return;
			}
			if (this._commands[command].browsers === null) {
				return;
			}
			supportedBrowsers = this._commands[command].browsers;
			for (i = 0; i < supportedBrowsers.length; i++) {
				if ($.browser && $.browser.hasOwnProperty(supportedBrowsers[i])) {
					return true;
				}
				if (!$.browser) {
				    if ($.ig.util.isIE || $.ig.util.isSafari || $.ig.util.isChrome) {
						return true;
					}
				}
			}
		},
		surroundContents: function (wrapEl) {
			var range = this._getRange();
			if (this._isIeOld) {
				range.pasteHTML(wrapEl.html(range.text).get(0).outerHTML);
			} else {
				this._surroundContents($(range.commonAncestorContainer), $(range.startContainer), $(range.endContainer), wrapEl);
			}

			return wrapEl;
		},
		getSelectedItem: function () {
			var range = this._getRange(),
				rangeParent = $(range.commonAncestorContainer);

			if (!this._isIeOld) {
				if (range.collapsed && (range.endContainer.nodeType === this.NODE._Text)) {
					if (rangeParent.parent().is("img") || rangeParent.parent().is("td")) {
						return rangeParent.parent();
					}
					return $(range.startContainer);
				}
				if (range.collapsed) {
					return $(range.commonAncestorContainer);
				}
				if (range.collapsed && (range.endContainer.nodeType === this.NODE._Element)) {
					return $(range.commonAncestorContainer.childNodes[range.endOffset - range.startOffset]);
				}
				return $(range.commonAncestorContainer);
			}
			// K.D. July 18th, 2012 Bug #117375 Exception is thrown when trying to edit the content in Editing Content demo in IE7 or IE8
			if (range.parentElement !== undefined) {
				return $(range.parentElement());
			}
			if (range.commonParentElement !== undefined) {
				return $(range.commonParentElement());
			}
		},
		getSelectionAsText: function () {
			if (this._getRange().text !== undefined) {
				return this._getRange().text;
			}
			return this._getRange().toString();
		},
		select: function (element) {
			var selectedItem = element || this.getSelectedItem(),
				newRange;

			if (!this._isIeOld) {
				this._range.selectNodeContents(selectedItem[0]);
				this._selection.removeAllRanges();
				this._selection.addRange(this._range);
			} else {
				newRange = this._document.body.createTextRange();
				if (selectedItem.length === 1) {
					newRange.moveToElementText(selectedItem[0]);
				}
				newRange.select();
			}
		},
		insertElement: function (element) {
			if (!this._isIeOld) {
				this._getRange().insertNode(element.get(0));
			} else {
				this._getRange().pasteHTML(element.get(0).outerHTML);
			}
		},
		applyStyle: function () {

		},
		execCommand: function (name, args) {
			var range = this._getRange(),
				customCommand = this._commands[name] ? this[this._commands[name].name] : null,
				customCommandArgs = this._commands[name] ? this._commands[name].args : null,
				browser = this._commands[name] ? this._commands[name].browsers : null,
				startEl,
				endEl,
				p,
				isCommandSupported = this._isCommandSupportedByBrowser(name),
				shouldExit = false;

			if (this._isIeOld) {
				range.select();
				range.execCommand(name, false, args);
			} else {
				p = $('<p><br /></p>', this._document);

				if (this._selection.isCollapsed && range.collapsed) {
					if ($(range.startContainer).is("body")) {
					    startEl = $(range.startContainer).find(":first");
                        // D. A. March 17th 2014, Bug #167125, Fixed the case when the body has no elements
					    if (!startEl.length) {
					        startEl = $(range.startContainer);
					    }
						range.selectNodeContents(startEl[0]);
					} else if (range.startContainer.nodeType === this.NODE._Document) {
					    startEl = $(range.startContainer.body).find(":first");
					    // D. A. March 17th 2014, Bug #167125, Fixed the case when the body has no elements
					    if (!startEl.length) {
					        startEl = $(range.startContainer.body);
					    }
						range.selectNodeContents(startEl[0]);
						//D.U. 14.04.2014 Bug #1680801 
					} else if (range.startContainer.nodeType === this.NODE._Text || range.startContainer.nodeType === this.NODE._Element && $.ig.util.isFF) {
						this._updateSelection(range);
						this._document.execCommand(name, false, args);
						shouldExit = true;
					} else {
						startEl = $(range.startContainer);
						range.selectNodeContents(startEl[0]);
					}
					if (shouldExit) {
						return;
					}

					if (startEl && startEl.is("br") && endEl && endEl.is("br")) {
						startEl.replaceWith(p);
						range.selectNodeContents(p[0]);
						this._updateSelection(range);
					}
				}

				// K.D. October 9th, 2012 Bug #115567 The browser version should be checked against >= 9 not === 9
				if (($.ig.util.isIE && $.ig.util.browserVersion >= 9) || $.ig.util.isOpera) {
					this._updateSelection(range);
				}

				if ($.isFunction(customCommand) && browser === null) {
					customCommand.call(this, name, args);
				} else if ($.isFunction(customCommand) && isCommandSupported) {
					customCommand.apply(this, customCommandArgs);
				} else {
					this._document.execCommand(name, false, args);
				}
			}
		},
		_insertList: function (listType, args) {
			var self = this,
				textNodes;
			this._document.execCommand(listType, false, args);

			//queryCommandState returnes true if the command is executed on the object
			// and false if the command is not executed on the object.
			if (!this._document.queryCommandState(listType)) {
				if (this._selection.anchorNode && this._selection.anchorNode.nodeType === this.NODE._Text && $(this._selection.focusNode).is("body")) {
					textNodes = $(this._selection.focusNode).contents().filter(function () {
						if ($(this).is("br")) {
							$(this).remove();
							return false;
						}
						return this.nodeType === self.NODE._Text;
					});
					// K.D. July 16th, 2012 Bug #101208 Removing the code that initially creates a paragraph
					// wrappedEl = textNodes.wrap(p[0]);
					// this._range.selectNodeContents(wrappedEl[0]);
					// this._updateSelection(this._range);
				}
			}
			// K.D. July 16th, 2012 Bug #101208 Removing the code that initially creates a paragraph
			// if ($(this._selection.anchorNode).is("body")) { //Only in FF
				// wrappedEl = $(this._selection.anchorNode).children().eq(this._selection.anchorOffset).wrap(p[0]).parent();
				// this._range.selectNodeContents(wrappedEl[0]);
				// this._updateSelection(this._range);
			// }
		},
		_getTextNodesOnlyCallback: function () {
			return this.nodeType === this.NODE._Text;
		},
		//Returns a text node.
		_wrapPartialString: function (string, start, end, wrapElName) {
			var stack = [];
			stack.push(this._document.createTextNode(string.slice(0, start)));
			stack.push(wrapElName.text(string.substring(start, end))[0]);
			stack.push(this._document.createTextNode(string.slice(end)));
			return $(stack);
		},
		_updateSelection: function (range) {
			this._selection.removeAllRanges();
			this._selection.addRange(range);
		},
		_surroundContents: function (commonParrent, startEl, endEl, wrapEl, wholeElement) {
			var self = this, startOffset, endOffset,
				rangeStart, rangeEnd, startElPar, endElPar,
				selection = this._getSelection(),
				range = this._getRange(),
				startElSiblings;

			if (startEl[0] === endEl[0]) {
				range.surroundContents(wrapEl.get(0));
				return wrapEl;
			}

			startOffset = range.startOffset;
			endOffset = range.endOffset;
			rangeStart = this._document.createRange();

			rangeStart.setStart(startEl.get(0), startOffset);
			rangeStart.setEnd(startEl.get(0), startEl.text().length);
			rangeStart.surroundContents(wrapEl.clone().get(0));
			selection.addRange(rangeStart);

			startElPar = this._getLastParentUntil(startEl, commonParrent);
			endElPar = this._getLastParentUntil(endEl, commonParrent);

			startElSiblings = startElPar.siblings();

			startElPar.siblings().each(function (i, el) {
				if (startElPar[0] === endElPar[0]) {
					return;
				}

				var rangeClone = self._document.createRange();
				rangeClone.setStartBefore(el);
				rangeClone.setEndAfter(el);
				rangeClone.surroundContents(wrapEl.clone().get(0));
				selection.addRange(rangeClone);
			});

			rangeEnd = this._document.createRange();
			rangeEnd.setStart(endEl.get(0), 0);
			rangeEnd.setEnd(endEl.get(0), endOffset);
			rangeEnd.surroundContents(wrapEl.clone().get(0));
			selection.addRange(rangeEnd);

		},
		_getLastParentUntil: function (root, target) {
			while (root.parent().length) {
				if (root.parent()[0] === target[0]) {
					return root;
				}
				root = root.parent();
			}
		},
		replaceNode: function (newNode) {
			var range = this._getRange();
			if (range.startOffset !== range.endOffset) {
				range.deleteContents();
			}
			if (range.insertNode !== undefined) {
			    range.insertNode(newNode[0]);
			} else if (range.pasteHTML !== undefined) {
				range.pasteHTML(newNode[0].outerHTML);
			}
		},
		insertTable: function (table) {
			var selItem = this.getSelectedItem(),
				br = $('<br>', this._document);
			if (selItem[0].nodeType === this.NODE._Document) {
				this._range.selectNodeContents(selItem.find("body > p:first")[0]);
				this._range.insertNode(table[0]);
			} else if (selItem.is("td")) {
				table.appendTo(selItem);
			} else if (selItem.is("table")) {
				selItem.replaceWith(table);
			} else if (selItem.is("br")) {
				selItem.replaceWith(table);
			} else {
				// K.D. July 19th, 2012 Bug #117424 Exception is thrown when inserting a table in IE7 or IE8
				if (this._range.insertNode !== undefined) {
					this._range.insertNode(table[0]);
				} else if (this._range.pasteHTML !== undefined) {
					// This case is IE7/IE8
					this._range.select();
					this._range.pasteHTML(table[0].outerHTML);
				}
			}
			if (this._range.selectNodeContents !== undefined) {
				this._range.selectNodeContents(br.insertAfter(table)[0]);
			}
		},
		focus: function () {
			var focusTarget = $(this._document.body).find(":not(br):first");
			if (this._isIeOld) {
				this._document.body.focus();
				return;
			}
			if (this._range.startContainer.nodeType !== this.NODE._Document && !$(this._range.startContainer).is("body")) {
				return;
			}
			if (this._range.startContainer.nodeType === this.NODE._Text) {
				this._document.body.focus();
				return;
			}
			if (focusTarget.length === 0) {
				return;
			}
			this._range.setStart(focusTarget[0], 0);
			this._range.setEnd(focusTarget[0], 0);
			this._document.body.focus();
		}
	});

    /************************************
        End HTML Editor Utilities
    ************************************/

    /************************************
        HTML Editor Toolbars
    ************************************/

	$.ig.ToolbarHelper = $.ig.ToolbarHelper || Class.extend({
		_toolbarsItemsLocation: {
			textToolbar: {
				name: "textToolbar",
                bold: { name: "bold" },
                italic: { name: "Italic" },
                underline: { name: "Underline" },
                strikethrough: { name: "Strikethrough" },
                fontFamily: { name: "fontFamily" },
                fontSize: { name: "fontSize" },
                formatsList: { name: "formatsList" }
			},
			formattingToolbar: {
				name: "formattingToolbar",
                justifyleft: { name: "justifyleft" },
                justifycenter: { name: "justifycenter" },
                justifyright: { name: "justifyright" },
                justifyfull: { name: "justifyfull" },
                bullets: { name: "bullets" },
                indent: { name: "indent" },
                outdent: { name: "outdent" },
                textColor: { name: "textColor" },
                backgroundTextColor: { name: "backgroundTextColor" }
			},
			insertObjectToolbar: {
				name: "insertObjectToolbar",
                image: { name: "image" },
                link: { name: "link" },
                table: { name: "table" },
                addRow: { name: "addRow" },
                addColumn: { name: "addColumn" },
                removeRow: { name: "removeRow" },
                removeColumn: { name: "removeColumn" }
			},
			copyPasteToolbar: {
				name: "copyPasteToolbar",
                copy: { name: "copy" },
                cut: { name: "cut" },
                paste: { name: "paste" },
                undo: { name: "undo" },
                redo: { name: "redo" }
			}
		},
		init: function (window, toolbars) {
			this._toolbars = {};
			this._w = window;
			this._d = window.document;
			var self = this;

			toolbars.each(function (idx, el) {
				var igToolbarName = $(el).igToolbar("option", "name");
				self._toolbars[igToolbarName] = $(el);
			});

			this._initAlignButtons(toolbars);
			this._disableUnsupportedItems();
			this._disableTableControls(true);
		},
		_initAlignButtons: function (toolbars) {
			var alignButtonsToolbar = this._toolbars.formattingToolbar,
				alignButtons = {
				    justifyleft: alignButtonsToolbar.igToolbar("getItem", "justifyleft"),
					justifycenter: alignButtonsToolbar.igToolbar("getItem", "justifycenter"),
					justifyright: alignButtonsToolbar.igToolbar("getItem", "justifyright"),
				    justifyfull: alignButtonsToolbar.igToolbar("getItem", "justifyfull")
				};

			toolbars.bind("igtoolbartoolbarbuttonclick", function (e, ui) {
				if (alignButtons.hasOwnProperty(ui.name)) {
					$.each(alignButtons, function (buttonName, button) {
						if (buttonName !== ui.name && button.igToolbarButton("option", "isSelected")) {
							button.igToolbarButton("toggle");
							return;
						}
					});
				}
			});
		},
		_disableUnsupportedItems: function () {
			var copyPasteToolbar = this._toolbars.copyPasteToolbar;
			if (!$.ig.util.isIE) {
				copyPasteToolbar.igToolbar('disableItem', 'cut', true);
				copyPasteToolbar.igToolbar('disableItem', 'copy', true);
				copyPasteToolbar.igToolbar('disableItem', 'paste', true);
			}
		},
		_disableTableControls: function (toDisable) {
			var insertObjectToolbar = this._toolbars.insertObjectToolbar;
			if (!toDisable && this._isTableControlsDisabled) {
				insertObjectToolbar.igToolbar('disableItem', 'addColumn', false);
				insertObjectToolbar.igToolbar('disableItem', 'removeColumn', false);
				insertObjectToolbar.igToolbar('disableItem', 'addRow', false);
				insertObjectToolbar.igToolbar('disableItem', 'removeRow', false);
				this._isTableControlsDisabled = false;
			} else if (toDisable && !this._isTableControlsDisabled) {
				insertObjectToolbar.igToolbar('disableItem', 'addColumn', true);
				insertObjectToolbar.igToolbar('disableItem', 'removeColumn', true);
				insertObjectToolbar.igToolbar('disableItem', 'addRow', true);
				insertObjectToolbar.igToolbar('disableItem', 'removeRow', true);
				this._isTableControlsDisabled = true;
			}
		},
		_callbackMap: {
			_isBold: "_onBold",
			_isItalic: "_onItalic",
			_isUnderlined: "_onUnderlined",
			_isLineThrough: "_onLineThrough",
			// _isAligned: "_onAlign",
			_isJustifyCenter: "_onAlign",
			_isJustifyFull: "_onAlign",
			_isJustifyLeft: "_onAlign",
			_isJustifyRight: "_onAlign",
			_isOrderedList: "_onList",
			_isUnorderedList: "_onList",
			_hasFontName: "_onFontName",
			_hasFontSize: "_onFontSize",
			_isTable: "_onTable"
		},
		analyse: function (el) {
			var self = this;
			this._resetToolbars();

			if (el[0].nodeType === 9) {
				this._computedStyles = (this._w.getComputedStyle && this._w.getComputedStyle(this._d.body)) || this._d.body.currentStyle;
			} else {
				this._computedStyles = (this._w.getComputedStyle && this._w.getComputedStyle(el[0])) || el[0].currentStyle;
			}
			// K.D. November 19th, 2012 Bug #127274 Heading elements never get analyzed by tag name
			if (el.is(':header')) {
				this._onHeader(el);
			}
			$.each(this._callbackMap, function (isTrueFunc, callback) {
				var isTrueRes = self[isTrueFunc](el);
				if ($.isFunction(self[isTrueFunc]) && isTrueRes && $.isFunction(self[callback])) {
					self[callback](el, isTrueRes);
				}
			});
			if (!el.is("table") && !el.is("td")) {
				this._disableTableControls(true);
			}
		},
		_isBold: function () {
			return this._d.queryCommandState("bold") || this._computedStyles.fontWeight >= 700;
		},
		_isItalic: function () {
			return this._d.queryCommandState("italic") || this._computedStyles.fontStyle.toLowerCase() === "italic";
		},
		_isUnderlined: function () {
			return this._d.queryCommandState("underline") || (this._computedStyles.textDecoration.toLowerCase().indexOf("underline") !== -1);
		},
		_isLineThrough: function () {
			return this._d.queryCommandState("strikethrough") || (this._computedStyles.textDecoration.toLowerCase().indexOf("line-through") !== -1);
		},
		_isJustifyCenter: function () {
			if (this._d.queryCommandState("justifycenter")) {
				return "justifycenter";
			}
		},
		_isJustifyFull: function () {
			if (this._d.queryCommandState("justifyfull")) {
				return "justifyfull";
			}
		},
		_isJustifyLeft: function () {
			if (this._d.queryCommandState("justifyleft")) {
				return "justifyleft";
			}
		},
		_isJustifyRight: function () {
			if (this._d.queryCommandState("justifyright")) {
				return "justifyright";
			}
		},
		_isOrderedList: function () {
			if (this._d.queryCommandState("insertorderedlist")) {
				return "InsertOrderedList";
			}
		},
		_isUnorderedList: function () {
			if (this._d.queryCommandState("insertunorderedlist")) {
				return "InsertUnorderedList";
			}
		},
		_isTable: function (el) {
			if (el.is("table") || el.is("td")) {
				return true;
			}
		},
		_checkParents: function (el, wanted) {
			while (el.parent()) {
				if (el.parent().is(wanted)) {
					return true;
				}
				if (el.is("body")) {
					return;
				}
				el = el.parent();
			}
		},
		_hasFontName: function () {
			var fontName = this._getFontFamily();
			if (fontName === "serif") {
				fontName = "Times New Roman";
			}
			return fontName;
		},
		_getFontFamily: function () {
			return this._computedStyles.fontFamily;
		},
		_hasFontSize: function () {
			return this._computedStyles.fontSize;
		},
		_onBold: function (el) {
			this._toolbars.textToolbar.igToolbar("getItem", "Bold").igToolbarButton("toggle");
		},
		_onItalic: function (el) {
			this._toolbars.textToolbar.igToolbar("getItem", "Italic").igToolbarButton("toggle");
		},
		_onUnderlined: function (el) {
			this._toolbars.textToolbar.igToolbar("getItem", "Underline").igToolbarButton("toggle");
		},
		_onLineThrough: function (el) {
			this._toolbars.textToolbar.igToolbar("getItem", "Strikethrough").igToolbarButton("toggle");
		},
		_onAlign: function (el, dir) {
			this._toolbars.formattingToolbar.igToolbar("getItem", dir).igToolbarButton("toggle");
		},
		_onList: function (el, listType) {
		    this._toolbars.formattingToolbar.igToolbar("getItem", listType).igToolbarButton("toggle");
			//this._toolbars.formattingToolbar.each(function (i, tb) {
			//	var bulletsSpltBttn = $(tb).igToolbar("getItem", "bullets");

			//	if (bulletsSpltBttn.data("igSplitButton") !== undefined) {
			//		bulletsSpltBttn.igSplitButton("switchToButton", listType);
			//		return;
			//	}
			//});
		},
		_onFontName: function (el, fontName) {
			var combo = this._toolbars.textToolbar.igToolbar("getItem", "fontFamily");
			// K.D. November 1st, 2012 Bug #125724 The combo values do not contain ' or " so they need to be removed before sending the value
			fontName = fontName.replace(/'|"/g, '');
			this._setComboValue(combo, $.ig.HtmlEditor.locale.fontNames[/^win/gi.test(navigator.platform) ? 'win' : 'mac'], fontName);
		},
		_onFontSize: function (el) {
			var pxTbl = {
					"11px": 1,
					"13px": 3,
					"16px": 4,
					"19px": 5,
					"18px": 7,
					"24px": 7
				},
				fontSizeUnits = this._d.queryCommandValue("fontsize") || pxTbl[this._computedStyles.fontSize],
				fontSizeUnitsStr = fontSizeUnits ? fontSizeUnits.toString() : "",
				combo = this._toolbars.textToolbar.igToolbar("getItem", "fontSize");
			this._setComboValue(combo, $.ig.HtmlEditor.locale.fontSizes, fontSizeUnitsStr);
		},
		_onHeader: function (element) {
			// K.D. November 19th, 2012 Bug #127274 Heading elements never get analyzed by tag name.
			var combo = this._toolbars.textToolbar.igToolbar("getItem", "formatsList");
			this._setComboValue(combo, $.ig.HtmlEditor.locale.formatsList, element[0].nodeName.toLowerCase());
		},
		_onTable: function () {
			this._disableTableControls(false);
		},
		_setComboValue: function (combo, values, newValue, valueKey) {
			var i,
				dsValueKey = valueKey || "text",
				currentValue = values[combo.igCombo("selectedIndex")][dsValueKey],
				dataSourceValue;

			if (newValue === currentValue) {
				return;
			}
			for (i = 0; i < values.length; i++) {
				dataSourceValue = values[i][dsValueKey];
				if (newValue === dataSourceValue) {
					combo.igCombo("selectedIndex", i);
					break;
				}
			}
		},
		_resetToolbars: function () {
			$.each(this._toolbars, function (idx, el) {
				$(el).igToolbar("deactivateAll");
			});
		}
	});
    /************************************
        End HTML Editor Toolbars
    ************************************/

    $.extend($.ui.igHtmlEditor, { version: '14.1.20141.2249' });
}(jQuery));
/*!@license
	* Infragistics.Web.ClientUI jQuery HTML5 Video Player 14.1.20141.2249
	*
	* Copyright (c) 2011-2014 Infragistics Inc.
	*
	* http://www.infragistics.com/
	*
	* Depends on:
	*  jquery-1.4.2.js
	*	jquery.ui.core.js
	*	jquery.ui.widget.js
	*	modernizr.js
	*  infragistics.util.js
	*  infragistics.ui.shared.js
	*/

/*global jQuery, window, Modernizr */
if (typeof jQuery !== "function") {
	throw new Error("jQuery is undefined");
}

(function ($) {

	$.widget("ui.igVideoPlayer", {
		_const: {
			VOLUME_MAX: 1.0,
			VOLUME_MIN: 0.0,
			VIDEO_STATE_TIMEOUT: 200,
			SCROLL_TIMEOUT: 100,
			COMMERCIAL_SEEK_DELTA: 2,
			SLIDE_SEEK_TIMEOUT: 500,
			HREF: '#'
		},

		_id: function (id) {
			return this.element[0].id + id;
		},

		options: {
			/* type="string" Get or set a list of video sources to choose from. Best coded/format is automatically detected by the control. Supported types are depending on the browser and could be one of the following mov, mp4, webm, ogg. */
			sources: [],
			/* type="number" Get or set the width of the control. By default null will stretch the control to fit data, if no other widths are defined. */
			width: null,
			/* type="number" Get or set the height of the control. By default null will stretch the control to fit data, if no other heights are defined. */
			height: null,
			/* type="string" Get or set a URL to an image to show, when no video data is available. */
			posterUrl: '',
			/* type="bool" Get or set whether to preload load initial data for duration of video. If true it may start buffering the video, but this highly depends on the specific browser implementation. */
			preload: false,
			/* type="bool" Get or set whether the video should start playing immediately after the control is loaded. */
			autoplay: false,
			/* type="bool" Get or set whether player controls will auto hide when video is not hovered. This is applicable only when Infragistics playback controls are used. */
			autohide: true,
			/* type="number" Get or set volume slider auto hide delay. This is applicable only when Infragistics playback controls are used. */
			volumeAutohideDelay: 1000,
			/* type="number" Get or set the center big button hide delay. */
			centerButtonHideDelay: 1200,
			/* type="bool" Get or set whether the video to start again after it has ended. */
			loop: false,
			/* type="bool" Get or set whether if you want to use the built in browser controls. By default player uses Infragistics playback controls. Note that you may have different look and feel across different browsers if you use the built in browser controls. */
			browserControls: false,
			/* type="bool" Get or set whether the video player to be in full screen or not. This is not a pure full screen, because browsers do not allow that. It just sets 100% width and height to the control. */
			fullscreen: false,
			/* type="number" Get or set the video volume. It can be between 0.0 and 1.0. */
			volume: 0.5,
			/* type="bool" Get or set whether the video volume is muted. */
			muted: false,
			/* type="string" Get or set video title. */
			title: '',
			/* type="bool" Get or set whether the control seek tool tip will be shown when hovering the video progress bar. */
			showSeekTime: true,
			/* type="string" Get or set the format of the video progress label. You should use ${currentTime} to represent current playback position and ${duration} to represent video duration. */
			progressLabelFormat: "${currentTime} / ${duration}",
			/* Get or set an array of bookmarks that will be displayed in the video player control. */
			bookmarks: [{
				/* type="number" Get or set where the bookmark will be positioned. Should be between 0 and movie duration in seconds. */
				time: 0,
				/* type="string" Get or set bookmark title. It is shown as tooltip on hover. */
				title: '',
				/* type="bool" Get or set whether the bookmark is disabled or not. */
				disabled: false
			}],
			/* Get or set an array of related videos that will be displayed when video playback has ended. */
			relatedVideos: [{
				/* type="string" Get or set the URL of the related video image. */
				imageUrl: '',
				/* type="string" Get or set the title of the video. */
				title: '',
				/* type="number" Get or set the width of the related video image. */
				width: null,
				/* type="number" Get or set the height of the related video image. */
				height: null,
				/* type="string" Get or set a link to a page that will play the related video. It will be opened in a new window. If there are sources also, the link property has a priority. */
				link: '',
				/* type="string" Get or set the sources of the related video. */
				sources: [],
				/* type="string" Get or set custom CSS class to be applied on the related video element. */
				css: null
			}],
			/* Get or set an array of banner objects that will show the banners when the video clip is played. */
			banners: [{
				/* type="string" Get or set the banner image url. */
				imageUrl: '',
				/* type="number" Get or set an array of numbers. Each number specifies on which second in the movie the banner will pop. */
				times: [],
				/* type="bool" Get or set whether the user will be able to close the banner or not. */
				closeBanner: true,
				/* type="bool" Get or set whether to apply animation effects when showing or hiding the banner. If set to true, the animation is played for banner.duration in milliseconds. */
				animate: true,
				/* type="bool" Get or set whether the banner is visible or not. */
				visible: true,
				/* type="number" Get or set the banner animation duration. */
				duration: 1000,
				/* type="bool" Get or set whether to automatically hide the banner. If set to true, the banner is hidden after banner.hidedelay in milliseconds. */
				autohide: false,
				/* type="number" Get or set the banner autohide delay in milliseconds. It is taken into account only if the banner.autohide option is set to true. */
				hidedelay: 10000,
				/* type="string" Get or set the banner link that will open in new window. */
				link: null,
				/* type="number" Get or set the banner width */
				width: null,
				/* type="number" Get or set the banner height */
				height: null,
				/* type="string" Get or set the banner specific css class, that will be applied on the banner grid. */
				css: null
			}],
			/* Get or set an array of commercials objects that will be displayed when the video is playing. */
			commercials: {
				/* Get or set an array of linked commercial objects. A linked commercial is a separate video file that will be played in the specified position of the original movie clip by the startTime property. This feature is useful if you have frequently changing outside commercial sources. */
				linkedCommercials: [{
					/* type="string" Get or set the sources of the linked commercial video. */
					sources: [],
					/* type="number" Get or set the second in the video at which the linked commercial should play. */
					startTime: 10,
					/* type="string" Get or set the link to open on linked commercial click. */
					link: '',
					/* type="string" Get or set the tooltip for the linked commercial bookmark. */
					title: ''
				}],
				/* Get or set an array of embedded commercials objects. An embedded commercial is an ad that is contained in the original video file. It is suitable when you want to mark some sections of the video as commercials. */
				embeddedCommercials: [{
					/* type="number" Get or set the start second of the embedded commercial. */
					startTime: 20,
					/* type="number" Get or set the end second of the embedded commercial. */
					endTime: 30,
					/* type="string" Get or set the sponsored link of the embedded commercial. */
					link: '',
					/* type="string" Get or set the tooltip for the bookmark of the embedded commercial. */
					title: ''
				}],
				/* type="bool" Get or set whether the commercials will play againg during the repetitive video plays. */
				alwaysPlayCommercials: false,
				/* type="bool" Get or set whether to show commercial locations or not. */
				showBookmarks: true,
				/* Customizes the ad message settings of the commercial. Ad message shows the duration of the commercial and pops up when the commercial starts playing.  */
				adMessage: {
					/* type="bool" Get or set whether to apply an animation effect when showing or hiding the ad message. If set to true, the animation is played for commercial.adMessage.animationDuration in milliseconds. */
					animate: true,
					/* type="bool" Get or set the ad message auto hide of the commercial. */
					autoHide: true,
					/* type="number" Get or set the ad message hide delay. */
					hideDelay: 20000,
					/* type="number" Get or set the ad message animation duration of the commercial. */
					animationDuration: 1000
				}
			}
		},

		events: {
			/* Occurs when video has ended.
			Function takes arguments evt and ui.
			Use ui.source to get the url of the playing video.
			Use ui.duration to get the video duration in seconds.
			*/
			ended: "ended",
			/* cancel="false" Occurs when video gets playing.
			Function takes arguments evt and ui.
			Use ui.source to get the url of the playing video.
			Use ui.duration to get the video duration in seconds.
			*/
			playing: "playing",
			/* Occurs when video is paused.
			Function takes arguments evt and ui.
			Use ui.source to get the url of the playing video.
			Use ui.duration to get the video duration in seconds.
			*/
			paused: "paused",
			/* cancel="false" Occurs when a chunk of data is buffered.
			Function takes arguments evt and ui.
			Use ui.source to get the url of the playing video.
			Use ui.buffered to get buffered percentage.
			*/
			buffering: "buffering",
			/* Occurs when video has advanced the playback position.
			Function takes arguments evt and ui.
			Use ui.source to get the url of the playing video.
			Use ui.currentTime to get current position in the video at which the event was fired.
			Use ui.duration to get the video duration in seconds.
			*/
			progress: "progress",
			/* cancel="false" Occurs when igVideoPlayer is waiting for data from the server.
			Function takes arguments evt and ui.
			Use ui.source to get the url of the playing video.
			Use ui.currentTime to get current position in the video at which the event was fired.
			Use ui.duration to get the video duration in seconds.
			*/
			waiting: "waiting",
			/* Occurs when the bookmark is hit.
			Function takes arguments evt and ui.
			Use ui.source to get the url of the playing video.
			Use ui.bookmark to get the bookmark object from the bookmarks array.
			Use ui.bookmarkElement to get the html element in the DOM.
			*/
			bookmarkHit: "bookmarkHit",
			/* Occurs when the bookmark is clicked.
			Function takes arguments evt and ui.
			Use ui.bookmark to get the bookmark object from the bookmarks array.
			Use ui.bookmarkElement to get the html element in the DOM.
			*/
			bookmarkClick: "bookmarkClick",
			/* cancel="true" Occurs when igVideoPlayer enters full screen mode.
			Function takes arguments evt and ui.
			Use ui.source to get the url of the playing video.
			*/
			enterFullScreen: "enterFullScreen",
			/* cancel="true" Occurs when igVideoPlayer exits full screen mode.
			Function takes arguments evt and ui.
			Use ui.source to get the url of the playing video.
			*/
			exitFullScreen: "exitFullScreen",
			/* cancel="true" Occurs when related video is clicked.
			Function takes arguments evt and ui.
			Use ui.relatedVideo to get the relatedVideo object from the relatedVideos array.
			Use ui.relatedVideoElement to get the relatedVideo html element in the DOM.
			*/
			relatedVideoClick: "relatedVideoClick",
			/* Defines the name of the player banner visible event. Fired when the banner has been displayed.
			Function takes arguments evt and ui.
			Use ui.index to get the banner index in the banners array.
			Use ui.banner to get the banner object from the banners array.
			Use ui.bannerElement to get the banner html element in the DOM.
			*/
			bannerVisible: "bannerVisible",
			/* Occurs when the banner is hidden.
			Function takes arguments evt and ui.
			Use ui.index to get the banner index in the banners array.
			Use ui.banner to get the banner object from the banners array.
			Use ui.bannerElement to get the banner html element in the DOM.
			*/
			bannerHidden: "bannerHidden",
			/* Occurs when the banner is clicked.
			Function takes arguments evt and ui.
			Use ui.bannerElement to get the banner html element in the DOM.
			*/
			bannerClick: "bannerClick",
			/* Occurs when browser does not support HTML 5 video. */
			browserNotSupported: "browserNotSupported"
		},

		css: {
			/* Get or set the widget base CSS classes. */
			"baseClasses" : "ui-widget ui-igplayer",
			/* Get or set the player controls CSS classes. */
			"controlsClass" : "ui-widget-header ui-igplayer-controls ui-igplayer-grid ui-igplayer-autohide ui-corner-all",
			/* Get or set the controls hide CSS class. Applied on controls auto hide. */
			"controlsHideClass": "ui-igplayer-controls-hide",
			/* Get or set the class applied on main video element. */
			"videoClass" : "ui-igplayer-video",
			/* Get or set the class applied on a span element, shown when the player is opened in a non HTML5 compatible browser. */
			"unsupportedBrowserClass": "ui-html5-non-html5-supported-message ui-helper-clearfix",
			/* Get or set the css class applied on the main video when the control is activated. */
			"activeVideoClass" : "ui-igplayer-active-video",
			/* Get or set the css class applied on the play button of the playback controls. */
			"playButtonClass" : "ui-igplayer-playbutton",
			/* Get or set the css class applied on the slider widget of the playback controls. */
			"progressBarClass" : "ui-igplayer-progressbar ui-corner-all",
			/* Get or set the css class applied on the full screen button of the playback controls. */
			"fullScreenClass" : "ui-igplayer-fullscreen-button",
			/* Get or set the css class applied on the full screen button icon. */
			"fullScreenIconClass": "ui-icon ui-igbutton-icon ui-icon-arrow-4-diag",
			/* Get or set the css class applied on the volume control button of the playback controls. */
			"volumeControlClass" : "ui-igplayer-volumecontrol",
			/* Get or set the css class applied on the volume slider of the playback controls. */
			"volumeSliderClass" : "ui-igplayer-volumeslider",
			/* Get or set the css class applied on the progress label of the playback controls. */
			"progressLabelClass" : "ui-igplayer-progresslabel",
			/* Get or set the css class applied on the bookmark container DIV. */
			"bookmarkContainerClass" : "ui-widget ui-igplayer-bookmark-container",
			/* Get or set the css class applied on the bookmark header container. */
			"bookmarkContainerHeaderClass" : "ui-widget-header ui-igplayer-bookmark-header",
			/* Get or set the css class applied on the bookmark list in the bookmark area. */
			"bookmarkListClass" : "ui-widget-content ui-igplayer-bookmark-list",
			/* Get or set the css class applied on the bookmark list item when the item in the bookmark area is disabled. */
			"bookmarkItemDisabledClass" : "ui-igplayer-bookmark-item-disabled",
			/* Get or set the css class applied on the bookmark list item showing the time in the bookmark area. */
			"bookmarkItemTimeClass" : "ui-igplayer-bookmark-item-time",
			/* Get or set the css class applied on the bookmark list item showing the title in the bookmark area. */
			"bookmarkItemTitleClass" : "ui-igplayer-bookmark-item-title",
			/* Get or set the css class showing the active bookmark item in the bookmark area. */
			"bookmarkActiveItemClass" : "ui-igplayer-bookmark-active-item",
			/* Get or set the css class applied on the related videos container class. */
			"relatedVideosContainerClass" : "ui-igplayer-related-video-container",
			/* Get or set the css class applied on the related videos outer most container. */
			"relatedVideosOuterContainerClass": "ui-igplayer-related-video-outer-container",
			/* Get or set the css class applied on a related video element. */
			"relatedVideoClass" : "ui-igplayer-related-video",
			/* Get or set the css class applied on the first related video element. */
			"relatedVideoFirstClass" : "ui-igplayer-related-video-first",
			/* Get or set the css class applied on the last related video element. */
			"relatedVideoLastClass" : "ui-igplayer-related-video-last",
			/* Get or set the css class applied on a related video hover. */
			"relatedVideoHoverClass" : "ui-igplayer-related-video-hover",
			/* Get or set the css class applied on the left scroll button. */
			"relatedVideoScrollLeftClass": "ui-igplayer-related-scroller-left",
			/* Get or set the class applied on the left scroll button icon. */
			"relatedVideoScrollLeftIconClass": "ui-icon-triangle-1-w",
			/* Get or set the css class applied on the right scroll button of the related videos. */
			"relatedVideoScrollRightClass": "ui-igplayer-related-scroller-right",
			/* Get or set the css class applied on the right icon of the scroll button. */
			"relatedVideoScrollRightIconClass": "ui-icon-triangle-1-e",
			/* Get or set the css class applied on the related videos list. */
			"relatedVideoScrollListClass": "ui-igplayer-related-list",
			/* Get or set the css class applied on the related videos header area. */
			"relatedVideosHeaderClass": "ui-igplayer-related-video-header",
			/* Get or set the css class applied on the related videos bottom area containing the replay and fullscreen buttons. */
			"relatedVideoBarClass": "ui-igplayer-related-video-bar",
			/* Get or set the css class applied on the replay button in the related videos area. */
			"relatedVideoReplayClass": "ui-igplayer-related-video-replay",
			/* Get or set the css class applied on the replay button icon. */
			"relatedVideoReplayIconClass": "ui-icon-arrowrefresh-1-s",
			/* Get or set the css class applied on the banner container div. */
			"bannerContainerClass": "ui-igplayer-banner-container",
			/* Get or set the css class applied on the banner container div. */
			"bannerClass": "ui-igplayer-banner ui-corner-all",
			/* Get or set the css class applied on the banner close button. */
			"bannerCloseClass": "ui-igplayer-banner-close",
			/* Get or set the css class applied on the banner close icon. */
			"bannerCloseIconClass": "ui-icon-close",
			/* Get or set the css class applied on the resume video message container. */
			"adMsgContainerClass": "ui-igplayer-ad-msg-container",
			/* Get or set the css class applied on the resume video message span. */
			"adMsgClass": "ui-igplayer-ad-msg",
			/* Get or set the css class applied on the resume video message close button. */
			"adMsgCloseClass": "ui-igplayer-ad-msg-close",
			/* Get or set the css class applied on the resume video message close button icon. */
			"adMsgCloseIconClass": "ui-icon-close",
			/* Get or set the css class applied on the linked commercial bookmark. */
			"linkedBookmarkClass": "ui-igplayer-linked-bookmark",
			/* Get or set the css class applied on an embedded commercial bookmark. */
			"adBookmarkClass": "ui-igplayer-ad-bookmark",
			/* Get or set the css class applied on the anchor element shown when video sources are unsupported. */
			"unsupportedVideoSourceClass": "ui-igplayer-not-supported-video-source",
			/* Get or set the css class applied on the anchor element showing the unsupported video source icon. */
			"unsupportedVideoSourceIconClass": "ui-igplayer-not-supported-video-source-icon",
			/* Get or set the css class applied on the center play button. */
			"centerPlayButtonClass": "ui-igplayer-centerplaybutton-play",
			/* Get or set the css class applied on the center pause button. */
			"centerPauseButtonClass": "ui-igplayer-centerplaybutton-pause",
			/* Get or set the css class applied on the center play button icon. */
			"centerPlayButtonIconClass": "ui-igplayer-centerplaybutton-icon",
			/* Get or set the css class applied on the buffering indicator. */
			"waitingIndicatorClass": "ui-igplayer-waiting",
			/* Get or set the css class applied on the buffering indicator icon. */
			"waitingIndicatorIconClass": "ui-igplayer-waiting-icon",
			/* Get or set the css class applied on the seek tooltip. */
			"seekTooltipClass": "ui-igplayer-seektooltip"
		},

		widget: function () {
			/*
			Returns the element on which the widget was instantiated
			*/
			return this.element;
		},

		_createWidget: function () {
			/* !Strip dummy objects from options, because they are defined for documentation purposes only! */
			var o = this.options;
			o.bookmarks = [];
			o.relatedVideos = [];
			o.banners = [];
			o.commercials.linkedCommercials = [];
			o.commercials.embeddedCommercials = [];
			$.Widget.prototype._createWidget.apply(this, arguments);
		},

		_create: function () {
			/* create the video element */
			this.supportsVideo = this.supports_video();
			// Under mobile devices always browser controls are rendered, except when Modernizr is undefined
			if (typeof Modernizr === "object" && Modernizr.touch) {
				this.options.browserControls = true;
			}

			if (this.element.is('div')) {
				this.container = this.element;
			} else if (this.element.is('video')) {
				this.container = $('<div></div>').attr('id', this._id('_container')).insertBefore(this.element);
				this.element.appendTo(this.container);
			} else {
				throw new Error($.ig.VideoPlayer.locale.nonDivException);
			}

			this._oldWidth = this.element.css('width');
			this._oldHeight = this.element.css('height');

			this._renderControl();
		},

		_renderControl: function () {
			var o = this.options,
				video,
				css = this.css;

			this._prevReadyState = 0;
			this._bookmarksRendered = false;

			if (this.supportsVideo) {
				this._renderBanners();
			}

			this.currentVideo = video = this._createMainVideoElement().addClass(css.videoClass);

			if (o.disabled) {
				this.container.addClass('ui-state-disabled');
			}

			if (o.width) {
				video.css('width', o.width);
				this.container.css('width', o.width);
			}

			if (o.height) {
				video.css('height', o.height);
				this.container.css('height', o.height);
			}

			if (this.supportsVideo) {
				this._baseZIndex = parseInt(this.container.css('z-index'), 10) || 0;
				this._attachEvents(video);
				this._renderSources(o.sources, video);
				this._analyzeSource(video);
				setTimeout($.proxy(this._onVideoStateChange, this), this._const.VIDEO_STATE_TIMEOUT);

				this._createBigPlayButton();
				this._createWaitingIndicator();
				this._renderEmbeddedCommercials();
				this._renderCommercials();
				video[0].muted = o.muted;
				if (o.muted && $.ig.util.isWebKit) {
					video[0].volume = 0;
				} else if (o.volume >= this._const.VOLUME_MIN && o.volume <= this._const.VOLUME_MAX) {
					video[0].volume = o.volume;
				}

				if (!o.browserControls) {
					this._renderControls();
				}
				this._lastPausedState = video[0].paused;

				if (o.fullscreen) {
					this._setOption('fullscreen', true, true);
				}

				this._renderRelatedVideos();
			} else {
				this.currentVideo.hide();
				//this._renderUnsupportedBrowser();
				$.ig.util._renderUnsupportedBrowser(this, $.ig.VideoPlayer.locale);
			}
			/* if rendered, move it to be always last element in the widget */
			// K.D. June 8th, 2011 Bug #78401 Preventing default action on click
			$("#" + this._id('_detectError')).appendTo(this.container).bind({
				click: function (event) {
					event.preventDefault();
				}
			});

			this.container.addClass(css.baseClasses);
		},

		_createVideoElement: function (id) {
			var video = $('<video></video>').attr('id', id);
			return video;
		},

		_saveExistingVideoProperties: function (video) {
			this._oldAutoPlay = video.attr('autoplay');
			this._oldPreload = video.attr('preload');
			this._oldLoop = video.attr('loop');
			this._oldPoster = video.attr('poster');
			this._oldControls = video.attr('controls');
			this._oldSrc = video.attr('src');
			this._oldMuted = video[0].muted;
			this._oldVolume = video[0].volume;
			video.removeAttr('autoplay');
			video.removeAttr('preload');
			video.removeAttr('loop');
			video.removeAttr('poster');
			video.removeAttr('controls');
			video.removeAttr('src');
		},

		_restoreExistingVideoProperties: function (video) {
			video.attr('autoplay', this._oldAutoPlay);
			video.attr('preload', this._oldPreload);
			video.attr('loop', this._oldLoop);
			video.attr('poster', this._oldPoster);
			video.attr('controls', this._oldControls);
			video.attr('src', this._oldSrc);
			video[0].muted = this._oldMuted;
			video[0].volume = this._oldVolume;
		},

		_createMainVideoElement: function () {
			var o = this.options,
				isVideoExisting = this.element.is('video'),
				video = (isVideoExisting ? this.element : this._createVideoElement(this._id('_video')));

			if (isVideoExisting) {
				this._saveExistingVideoProperties(video);
			}

			if (o.autoplay) {
				video.attr('autoplay', true);
			}

			video.attr('preload', 'metadata');
			if (o.preload) {
				video.attr('preload', 'auto');
			}

			if (o.browserControls) {
				video.attr('controls', true);
			}

			if (o.loop) {
				video.attr('loop', true);
			}

			if (o.posterUrl.length > 0) {
				video.attr('poster', o.posterUrl);
			}
			return video.appendTo(this.container);
		},

		_renderUnsupportedBrowser: function () {
			if (this._trigger(this.events.browserNotSupported)) {
				var container = $('<div></div>').addClass(this.css.unsupportedBrowserClass).appendTo(this.container), ul, browserUnsupported;
				// K.D. June 7th, 2011 Bug #76981 Currently only the version is shown and as this is important for
				// IE showing the name of the browser before the version as well
				if ($.ig.util.isIE) {
					browserUnsupported = 'Internet Explorer ' + $.ig.util.browserVersion;
				} else if ($.ig.util.isOpera) {
					browserUnsupported = 'Opera ' + $.ig.util.browserVersion;
				} else if ($.ig.util.isWebKit) {
					browserUnsupported = 'Webkit ' + $.ig.util.browserVersion;
				} else if ($.ig.util.isFF) {
					browserUnsupported = 'Mozilla Firefox ' + $.ig.util.browserVersion;
				} else {
					browserUnsupported = $.ig.util.browserVersion;
				}

				$('<div></div>').addClass('ui-igvideoplayer-current-browser-label').html($.ig.VideoPlayer.locale.currentBrowser.replace('{0}', browserUnsupported)).appendTo(container);
				$('<div></div>').addClass('ui-igvideoplayer-non-html5-text').html($.ig.VideoPlayer.locale.unsupportedBrowser).appendTo(container);
				ul = $('<ul></ul>').addClass('ui-igplayer-browsers-list').appendTo(container);
				$('<a></a>').attr('href', $.ig.VideoPlayer.locale.chromeDownload).attr('target', '_blank').addClass('ui-igplayer-chrome-icon').html($.ig.VideoPlayer.locale.chrome8).appendTo($('<li></li>').addClass('ui-corner-all').appendTo(ul));
				$('<a></a>').attr('href', $.ig.VideoPlayer.locale.firefoxDownload).attr('target', '_blank').addClass('ui-igplayer-firefox-icon').html($.ig.VideoPlayer.locale.firefox36).appendTo($('<li></li>').addClass('ui-corner-all').appendTo(ul));
				$('<a></a>').attr('href', $.ig.VideoPlayer.locale.operaDownload).attr('target', '_blank').addClass('ui-igplayer-Opera-icon').html($.ig.VideoPlayer.locale.opera11).appendTo($('<li></li>').addClass('ui-corner-all').appendTo(ul));
				$('<a></a>').attr('href', $.ig.VideoPlayer.locale.safariDownload).attr('target', '_blank').addClass('ui-igplayer-safari-icon').html($.ig.VideoPlayer.locale.safari5).appendTo($('<li></li>').addClass('ui-corner-all').appendTo(ul));
				$('<a></a>').attr('href', $.ig.VideoPlayer.locale.ieDownload).attr('target', '_blank').addClass('ui-igplayer-ie-icon').html($.ig.VideoPlayer.locale.ie9).appendTo($('<li></li>').addClass('ui-corner-all').appendTo(ul));
				this.container.addClass('ui-igvideoplayer-non-html5');
			}
		},

		_renderRelatedVideoBar: function (container) {
			var css = this.css,
				control = this,
				relatedVideoBar = $('<div></div>').attr('id', this._id('_rv_bar')).addClass(css.relatedVideoBarClass).appendTo(container);
			/* render related video full screen button */
			$('<a></a>').attr('id', this._id('_rv_bar_fs')).appendTo(
				$('<div></div>').css({
					'position': 'absolute',
					'top': 0,
					'left': 0,
					'text-align': 'right',
					'width': '100%',
					'height': '100%'
				}).appendTo(relatedVideoBar)
			).igButton({
				link: { href: this._const.HREF },
				css: { buttonLabelClass: css.fullScreenIconClass }
			}).attr('title', $.ig.VideoPlayer.locale.enterFullscreen).addClass(css.fullScreenClass).bind({
				click: function (event) {
					event.preventDefault();
					control._setOption("fullscreen", !control.options.fullscreen);
				}
			});
			/* render related video replay button */
			$('<a></a>').attr('id', this._id('_rv_bar_replay')).appendTo(relatedVideoBar).igButton({
				onlyIcons: false,
				labelText: $.ig.VideoPlayer.locale.replayButton,
				icons: { primary: css.relatedVideoReplayIconClass },
				link: { href: this._const.HREF }
			}).attr('title', $.ig.VideoPlayer.locale.replayTooltip).bind({
				click: function (event) {
					event.preventDefault();
					if (!$(this).igButton('option', 'disabled')) {
						control.togglePlay();
					}
				}
			}).addClass(css.relatedVideoReplayClass);
		},

		_renderScrollButtons: function (container) {
			var css = this.css,
				ul;
			$('<a></a>').attr('id', this._id('_rv_left')).appendTo(container).igButton({
				onlyIcons: true,
				icons: { primary: css.relatedVideoScrollLeftIconClass },
				link: { href: this._const.HREF }
			}).addClass(css.relatedVideoScrollLeftClass).css('position', 'absolute').hide();

			ul = $('<ul></ul>').addClass(css.relatedVideoScrollListClass).appendTo(container);

			$('<a></a>').attr('id', this._id('_rv_right')).appendTo(container).igButton({
				onlyIcons: true,
				icons: { primary: css.relatedVideoScrollRightIconClass },
				link: { href: this._const.HREF }
			}).addClass(css.relatedVideoScrollRightClass).css('position', 'absolute');

			return ul;
		},

		_renderRelatedVideos: function () {
			var o = this.options,
				related = o.relatedVideos || [],
				len = related.length,
				i = 0,
				css = this.css,
				container,
				scrollContainer,
				ulContainer,
				ulContainerWidth = 10, // In order to fully display the last related video, there is 10px margin from the parent element.
				currentVideo,
				control = this;

			if (len > 0) {
				container = $('<div></div>').attr('id',  this._id('_rvcc')).addClass(css.relatedVideosOuterContainerClass).appendTo(this.container).hide();
				/* render header div */
				$('<div><div>').html($.ig.VideoPlayer.locale.relatedVideos)
					.addClass(css.relatedVideosHeaderClass).appendTo(container);
				/* render scroll container with buttons and ul */
				scrollContainer = $('<div></div>').attr('id', this._id('_rvc')).appendTo(container).addClass(css.relatedVideosContainerClass);
				ulContainer = this._renderScrollButtons(scrollContainer);
				this._renderRelatedVideoBar(container);

				this._rvUlWidth = 0;
				this._rvImagesToLoad = 0;
				this._rvImagesLoaded = 0;

				for (i; i < len; i++) {
					if (related[i].imageUrl && related[i].imageUrl !== '') {
						currentVideo = this._renderRelatedVideo(related[i], ulContainer, i === 0, i === len - 1);
						this._rvImagesToLoad++;
						ulContainerWidth += currentVideo.outerWidth(true);
					}
				}

				// N.A. 10/31/2013 Bug #156185: Set width of the related videos in order to show all of them.
				if (ulContainerWidth > container.width() && ulContainerWidth > ulContainer.width()) {
					ulContainer.width(ulContainerWidth);
				}

				this.relatedScrollers = $('a', scrollContainer).bind({
					mouseover: function () {
						if (!control._isScrolling) {
							control._isScrolling = true;
							control._leftDirection = $(this).hasClass(control.css.relatedVideoScrollLeftClass);
							control._rvDoScroll();
						}
					},
					mouseout: function () {
						control._rvStopScroll();
					}
				});

				this.relatedVideoElements = $('.' + this.css.relatedVideoClass.split(' ')[0], ulContainer).each(function (i) {
					$(this).data("related-index", i);
				}).bind({
					mouseover: function () {
						$(this).addClass(control.css.relatedVideoHoverClass).children().filter('div').show();
					},
					mouseout: function () {
						$(this).removeClass(control.css.relatedVideoHoverClass).children().filter('div').hide();
					},
					click: function (event) {
						var relatedVideo = control.options.relatedVideos[$(this).data("related-index")];
						if (control._relatedVideoClick(relatedVideo, $(this), event)) {
							if (relatedVideo.link && relatedVideo.link.length > 0) {
								window.open(relatedVideo.link, '_blank');
							} else if (relatedVideo.sources) {
								control._renderSources(relatedVideo.sources, control.currentVideo);
								control._analyzeSource(control.currentVideo, true);
								control.play();
							}
						}
					}
				});
			}
		},

		_rvScrollOnce: function () {
			var container = $('#' + this._id('_rvc')),
				ul = $('ul', container),
				currentLeftStr = ul[0].style.left,
				currentLeft = parseInt((currentLeftStr === "" || currentLeftStr === "auto" ? "0px" : currentLeftStr), 10),
				pixelsToScroll = 10,
				newLeft = this._leftDirection ? currentLeft + pixelsToScroll : currentLeft - pixelsToScroll,
				left = $('#' + this._id('_rv_left')),
				right = $('#' + this._id('_rv_right')),
				ulWidth = ul.width(),
				scrollContainerWidth = container.width(),
				continueScrolling = true;
			ul[0].style.left = newLeft + 'px';

			if (currentLeft === 0 && newLeft < 0) {
				left.show();
			}

			if (newLeft >= 0 && currentLeft !== 0 && left[0].style.display !== "none") {
				left.hide();
				continueScrolling = false;
			}

			if (scrollContainerWidth - newLeft >= ulWidth && right[0].style.display !== "none") {
				// hide the right button
				continueScrolling = false;
				right.hide();
			} else if (right[0].style.display === "none") {
				// show the right button
				right.show();
			}
			return continueScrolling;
		},

		_rvDoScroll: function () {
			var continueScrolling = this._isScrolling && this._rvScrollOnce();
			if (continueScrolling) {
				this._scrollingTimoutId = setTimeout($.proxy(this._rvDoScroll, this), this._const.SCROLL_TIMEOUT);
			} else {
				this._rvStopScroll();
			}
		},

		_rvStopScroll: function () {
			if (this._isScrolling) {
				clearTimeout(this._scrollingTimoutId);
				this._isScrolling = false;
			}
		},

		_relatedVideoClick: function (relatedVideo, relatedElement, event) {
			var args = {
				relatedVideo: relatedVideo,
				relatedVideoElement: relatedElement
			};
			return this._trigger(this.events.relatedVideoClick, event, args);
		},

		_renderRelatedVideo: function (related, container, isFirst, isLast) {
			var rv = $('<li></li>').appendTo(container).addClass(this.css.relatedVideoClass),
				relatedImg = $('<img/>').appendTo(rv),
				self = this;

			if (isFirst || isLast) {
				rv.addClass(isFirst ? this.css.relatedVideoFirstClass : this.css.relatedVideoLastClass);
			}

			if (related.imageUrl && related.imageUrl !== '') {
				relatedImg.attr('src', related.imageUrl);
			}

			if (related.title && related.title !== '') {
				relatedImg.attr('title', related.title);
			}

			if (related.css && related.css !== '') {
				relatedImg.addClass(related.css);
			}

			if (related.width && related.width !== '') {
				relatedImg.css('width', related.width);
			}

			if (related.height && related.height !== '') {
				relatedImg.css('height', related.height);
			}

			$('<div></div>').appendTo(relatedImg.parent()).css('position', 'absolute').hide();

			relatedImg.bind({
				load: function () {
					self._imageLoaded(this);
				},
				error: function () {
					self._rvImagesLoaded++;
					self._onImagesLoaded();
				},
				readystatechange: function () {
					self._imageLoaded(this);
				}
			});
			return rv;
		},

		_imageLoaded: function (img) {
			var rs = img.readyState,
				width = parseInt(img.style.width, 10),
				height = parseInt(img.style.height, 10),
				spanSize;
			if (!rs || (new RegExp('loaded|complete')).test(rs)) {
				this._rvUlWidth += (width + parseInt($(img).parent().css('marginRight'), 10) + parseInt($(img).parent().css('marginLeft'), 10));
				this._rvImagesLoaded++;
				// calculate the best play icon to be put over the image.
				if (width > 24 && height > 24) {
					if (width > 50 && height > 50) {
						spanSize = 48;
					} else if (width > 34 && height > 34) {
						spanSize = 32;
					} else {
						spanSize = 24;
					}
					$(img).parent().children().filter('div')
						.addClass('ui-igplayer-related-video-hover-x' + spanSize)
						.css({'width': spanSize,
								'height': spanSize,
								'top': (height / 2) - (spanSize / 2),
								'left': (width / 2) - (spanSize / 2) });
				}
			}
			this._onImagesLoaded();
		},

		_onImagesLoaded: function () {
			if (this._rvImagesLoaded === this._rvImagesToLoad) {
				var container = $('#' + this._id('_rvc'));
				$('ul', container).css('width', this._rvUlWidth + 4);
				container.parent().show();
				if (this._rvUlWidth < container.width()) {
					this.relatedScrollers.hide();
				} else {
					$(this.relatedScrollers[1]).show();
				}
				container.parent().hide();
				delete this._rvUlWidth;
				delete this._rvImagesLoaded;
				delete this._rvImagesToLoad;
			}
		},

		_renderEmbeddedCommercials: function () {
			var ec = this.options.commercials.embeddedCommercials || [],
				i = 0,
				len = ec.length,
				filtered = [],
				val;

			/* filter only the ranges that are good. */
			for (i; i < len; i++) {
				val = ec[i];
				if (val && val.startTime && val.endTime && val.startTime < val.endTime) {
					filtered.push(val);
				}
			}

			ec = filtered;
			len = ec.length;

			if (ec && len > 0) {
				this._embeddedCommercialsShow = $.extend(true, [], ec);
				this._embeddedCommercialIndex = 0;
				this._renderAdMessage();
			}
		},

		_renderCommercials: function () {
			var o = this.options,
				com = o.commercials.linkedCommercials || [],
				control = this;
			if (com.length > 0) {
				this._createVideoElement(this._id('_com_video')).attr('preload', 'auto').appendTo(this.container).addClass(this.css.videoClass).bind({
					ended: function () {
						var slider = $('#' + control._id('_ctrls_s')),
							bookmarks = slider.data('igSlider').bookmarks;
						control._hideWaitingIndicator();
						control._commercialIndex++;
						control._commercialsShow.shift();
						control._commercialPlaying = false;
						control.currentVideo = control._getMainVideo();
						control.currentVideo.show();
						$(this).hide();
						slider.igSlider('option', 'disabled', false);
						if (bookmarks) {
							bookmarks.show();
						}
						control.currentVideo[0].muted = this.muted;
						control.currentVideo[0].play();
						control.currentVideo.addClass(control.css.videoClass);
						control.controls[control._activeControlsIndex].css('z-index', '');
						$('#' + control._id('_seek_tooltip')).css('z-index', '');
						$('#' + control._id('_play')).css('z-index', '');
					},
					waiting: function (event) {
						control._onVideoWaiting(event);
						control._waiting(this.currentSrc, this.currentTime, this.duration, event);
					},
					timeupdate: function (event) {
						control._changeCurrentTime(event);
					},
					playing: function (event) {
						control._hideWaitingIndicator();
						$('span', $('#' + control._id('_ctrls_play'))).addClass('ui-icon-pause').removeClass('ui-icon-play');
						control._playing(this.currentSrc, this.duration, event);
					},
					pause: function (event) {
						$('span', $('#' + control._id('_ctrls_play'))).addClass('ui-icon-play').removeClass('ui-icon-pause');
						control._paused(this.currentSrc, this.duration, event);
					},
					click: function (event) {
						event.preventDefault();
						var link = control.options.commercials.linkedCommercials[control._commercialIndex].link;
						if (link && link.length > 0) {
							window.open(link, '_blank');
						}
					}
				}).hide();
				this._buildCommercialsShow();
				this._renderAdMessage();
			}
		},

		_renderAdClose: function (container) {
			var control = this;

			$('<a></a>').attr('id', this._id('_ad_msg_close')).appendTo(container).igButton({
				onlyIcons: true,
				icons: { primary: this.css.adMsgCloseIconClass },
				link: { href: this._const.HREF }
			}).addClass(this.css.adMsgCloseClass).bind('click', function (event) {
				event.preventDefault();
				event.stopPropagation();
				control.hideAdMessage();
			});
		},

		_renderAdMessage: function () {
			if ($('#' + this._id('_ad_msg_c')).length === 0) {
				var css = this.css,
					container;

				container = $('<div></div>').attr('id', this._id('_ad_msg_c'))
					.addClass(css.adMsgContainerClass).prependTo(this.container).bind({
						mouseover: function () {
							$(this).addClass('ui-state-hover');
						},
						mouseout: function () {
							$(this).removeClass('ui-state-hover');
						}
					}).hide();

				$('<span></span>').attr('id', this._id('_ad_msg')).appendTo(container)
					.addClass(css.adMsgClass).html($.ig.VideoPlayer.locale.adMessage);

				this._renderAdClose(container);
			}
		},

		_showAdMessage: function (seconds) {
			var adMsgContainer = $('#' + this._id('_ad_msg_c')),
				msgOpt = this.options.commercials.adMessage;

			this._updateAdMessage(seconds, true);
			adMsgContainer.css('width', this.container.css('width'));

			if (msgOpt.animate) {
				adMsgContainer.slideToggle(msgOpt.animationDuration);
			} else {
				adMsgContainer.show();
			}

			if (msgOpt.autoHide) {
				this._adHideTimeout = setTimeout($.proxy(this.hideAdMessage, this), msgOpt.hideDelay);
			}
		},

		_updateAdMessage: function (seconds, force) {
			var msg = $('#' + this._id('_ad_msg'));
			if (msg.is(':visible') || force) {
				if (isNaN(seconds)) {
					msg.html($.ig.VideoPlayer.locale.adMessageNoDuration);
				} else {
					seconds = parseInt(seconds, 10);
					if (seconds > 60) {
						msg.html($.ig.VideoPlayer.locale.adMessageLong.replace('$duration$', this._toTimeString(seconds)));
					} else {
						msg.html($.ig.VideoPlayer.locale.adMessage.replace('$duration$', seconds));
					}
				}
				this._isHiddenAdMessage = false;
			} else if (!this._isHiddenAdMessage) {
				this._showAdMessage(seconds);
			}
		},

		hideAdMessage: function () {
			/* Hide the add message if shown. */
			clearTimeout(this._adHideTimeout);
			var msg = $('#' + this._id('_ad_msg_c')),
				msgOpt = this.options.commercials.adMessage;
			if (msg.is(':visible')) {
				if (msgOpt.animate) {
					msg.slideToggle(msgOpt.animationDuration);
				} else {
					msg.hide();
				}
				this._isHiddenAdMessage = true;
			}
		},

		_buildCommercialsShow: function () {
			var com = this.options.commercials.linkedCommercials || [],
				len = com.length,
				i = 0;
			this._commercialsShow = [];
			this._commercialIndex = 0;
			for (i; i < len; i++) {
				this._commercialsShow.push(com[i].startTime);
			}
			this._commercialsShow = $.extend(true, [], this._commercialsShow);
		},

		playCommercial: function (commercial) {
			/* Play a linked commercial for this video.
				paramType="object" Specify the linked commercial to play.
			*/
			if (!commercial || !commercial.sources) {
				return;
			}

			var comVideo = $('#' + this._id('_com_video')),
				videoOffset = this.currentVideo.offset(),
				slider = $('#' + this._id('_ctrls_s')),
				bookmarks = slider.data('igSlider').bookmarks,
				bookmarkTitle = $('#' + this._id('_ctrls_s_tooltip'));

			this._commercialPlaying = true;
			$('source', comVideo).remove();
			this._renderSources(commercial.sources, comVideo);
			this._analyzeSource(comVideo);
			this.currentVideo[0].pause();
			this.currentVideo.removeClass(this.css.videoClass);
			this.controls[this._activeControlsIndex].css('z-index', this._baseZIndex + 5000);
			$('#' + this._id('_seek_tooltip')).css('z-index', this._baseZIndex + 5000);
			$('#' + this._id('_play')).css('z-index', this._baseZIndex + 5000);

			slider.igSlider('option', 'disabled', true);
			if (bookmarks && bookmarkTitle) {
				bookmarks.hide();
				bookmarkTitle.hide();
			}

			comVideo[0].muted = this.currentVideo[0].muted;
			comVideo[0].play();

			if (commercial.link && commercial.link.length > 0) {
				comVideo.attr('title', $.ig.VideoPlayer.locale.adNewWindowTip);
			} else {
				comVideo.removeAttr('title');
			}

			comVideo.css('top', videoOffset.top)
				.css('left', videoOffset.left)
				.css('width', this.currentVideo.css('width'))
				.css('height', this.currentVideo.css('height')).show();
			this.currentVideo.hide();
			this.currentVideo = comVideo;
		},

		_renderBanners: function () {
			var banners = this.options.banners || [],
				len = banners.length,
				i = 0,
				parent = $('<div></div>').appendTo(this.container).addClass(this.css.bannerContainerClass),
				banner;

			this._bannerShow = [];

			for (i; i < len; i++) {
				banner = banners[i];
				if (banner.imageUrl && banner.imageUrl.length > 0) {
					this._renderBannerContainer(banner, this._id('_banner_grid' + i), parent).data('banner-index', i);
				}
				this._bannerShow.push($.extend(true, [], banner.times));
			}
		},

		_buildBannersShow: function () {
			var banners = this.options.banners || [],
				len = banners.length,
				i = 0;

			if (len > 0) {
				this._bannerShow = [];
			}

			for (i; i < len; i++) {
				this._bannerShow.push($.extend(true, [], banners[i].times));
			}
		},

		_renderBannerClose: function (container, id) {
			var css = this.css,
				control = this;

			$('<a></a>').attr('id', id + '_banner_close').appendTo(
				$('<div></div>').css({  'position': 'absolute',
										'top': 0,
										'left': 0,
										'text-align': 'right',
										'width': '100%',
										'height': '100%' }).appendTo(container)
			).addClass(css.bannerCloseClass).igButton({
				onlyIcons: true,
				icons: { primary: css.bannerCloseIconClass },
				link: { href: this._const.HREF }
			}).bind('click', function (event) {
				event.preventDefault();
				event.stopPropagation();
				control.hideBanner($(this).parent().parent().data('banner-index'));
			});
		},

		_renderBannerContainer: function (banner, id, parent) {
			var css = this.css,
				control = this,
				container = $('<div></div>').attr('id', id).appendTo(parent),
				img = $('<img></img>').attr('id', id + '_img').attr('src', banner.imageUrl).appendTo(container);

			this.banner = container.addClass(css.bannerClass);

			if (!banner.visible) {
				container.hide();
			}

			if (banner.closeBanner) {
				this._renderBannerClose(container, id);
			}

			if (banner.width) {
				container.css('width', banner.width);
				img.attr('width', parseInt(banner.width, 10));
			}

			if (banner.height) {
				container.css('height', banner.height);
				img.attr('height', parseInt(banner.height, 10));
			}

			if (banner.css) {
				container.addClass(banner.css);
			}

			container.bind('click', function (event) {
				var noCancel = true,
					args = {
						// K.D. June 3rd, 2011 Bug #77526 The banner option is no longer available and thus
						// removing the obsolete value from the click event arguments
						// S.S. January 3rd, 2012 Bug #97226 The best way to return the banner is by using the event's target. With
						// the previous code the bannerElement always returned the last banner regardless of the one clicked.
						bannerElement: $(event.currentTarget)
					};

				noCancel = control._trigger(control.events.bannerClick, event, args);

				if (banner.link && banner.link.length > 0 && noCancel) {
					window.open(banner.link, '_blank');
				}
			});
			return container;
		},

		showBanner: function (index) {
			/* Shows the ad banner, if there is such. 
				paramType="number" Specify the index of the banner from the banners array.
			*/
			if (this.options.banners && index >= 0 && index < this.options.banners.length) {
				var banner = this.options.banners[index],
					id = this._id('_banner_grid' + index),
					container = $('#' + id);
				if (banner.animate) {
					container.fadeIn(banner.duration);
				} else {
					container.show();
				}
				this._bannerVisible(index, container);

				if (banner.autohide) {
					this._bannerHideTimeout = setTimeout(this._createDelegate(this, this.hideBanner, [index]), banner.hidedelay);
				}
			}
		},

		_createDelegate: function (instance, method, args) {
			return function () {
				return method.apply(instance, args);
			};
		},

		hideBanner: function (index) {
			/* Hide the ad banner, if there is such. 
				paramType="number" Specify the index of the banner from the banners array.
			*/
			if (this.options.banners && index >= 0 && index < this.options.banners.length) {
				// Hides the ad banner, if there is such.
				clearTimeout(this._bannerHideTimeout);
				var banner = this.options.banners[index],
					container = $('#' + this._id('_banner_grid' + index));
				if (banner.animate) {
					container.fadeOut(banner.duration);
				} else {
					container.hide();
				}
				this._bannerHidden(index, container);
			}
		},

		_renderSources: function (sources, video) {
			var control = this;
			$(sources).each(function () {
				control._renderSource(this, video);
			});
		},

		_renderSource: function (source, video) {
			var qmIndex = source.indexOf('?'),
				extStartIndex = source.lastIndexOf('.') + 1,
				extEndIndex = qmIndex > -1 ? qmIndex : source.length,
				extension = source.substring(extStartIndex, extEndIndex);
			$('<source></source>').attr('src', source)
				.attr('type', ('video/' + source.substring(source.lastIndexOf('.') + 1, source.length)).replace('/ogv', '/ogg'))
				.appendTo(video);
			video.data(extension, source);
		},

		_getMainVideo: function () {
			return this.element.is('video') ? this.element : $('#' + this._id('_video'));
		},

		_setOption: function (key, value, force) {
			var video = this.currentVideo,
				videoElem = video[0],
				mainVideo = this._getMainVideo(),
				videoOffset = video.offset(),
				options = this.options,
				noCancel = true,
				fsVideoH = 0;

			if (this.options[key] === value) {
				return;
			}

			switch (key) {
			case 'disabled':
				if (value) {
					this.container.addClass('ui-state-disabled');
				} else {
					this.container.removeClass('ui-state-disabled');
				}
				break;
			case 'sources':
				$('source', mainVideo).remove();
				this._renderSources(value, mainVideo);
				this._analyzeSource(mainVideo);
				break;
			case 'width':
				if (value !== options.width) {
					video.css('width', value);
					this.container.css('width', value);
					if (!options.browserControls) {
						$('#' + this._id('_ctrls')).parent().css('width', value);
						$('#' + this._id('_title_ctrls')).parent().css('width', value);
					}
					options.width = value;
				}
				break;
			case 'height':
				if (value !== options.height) {
					video.css('height', value);
					this.container.css('height', value);
					options.height = value;
				}
				break;
			case 'posterUrl':
				if (value !== options.posterUrl) {
					video.attr('poster', value);
					options.posterUrl = value;
				}
				break;
			case 'loop':
				if (value !== options.loop) {
					videoElem.loop = value;
					options.loop = value;
				}
				break;
			case 'browserControls':
				// Under mobile devices always browser controls are rendered
				if (typeof Modernizr === "object" && Modernizr.touch) {
					return;
				}
				if (value !== options.browserControls) {
					if (!value) {
						videoElem.controls = false;
						// S.S. June 24th, 2011 Bug #74601 Before rendering our controls we need to be sure the correct
						// volume is set for the widget to display in the volume slider.
						this._ensureVolume();
						this._renderControls();
						// K.D. November 22nd, 2011 Bug #80594 The buffered area is rendered with a large delay when 
						// switching from browser to our controls, so forcing the rendering
						this._detectBuffered();
					} else {
						videoElem.controls = true;
						this._destroyControls();
					}
					options.browserControls = value;
				}
				break;
			case 'autohide':
				if (!options.browserControls) {
					if (value) {
						this._onControlMouseOut(); // hide the controls.
					} else {
						this._onControlMouseOver(); // show the controls.
					}
				}
				options.autohide = value;
				break;
			case 'fullscreen':
				if (value !== options.fullscreen || force) {
					if (value) {
						noCancel = this._enterFullScreen(videoElem.currentSrc);
						if (noCancel) {
							this.container.data('style.position', this.container.css('position'));
							this.container.data('document.scrollTop', $(document).scrollTop());
							this.container.data('document.scrollLeft', $(document).scrollLeft());
							this.container.data('style.left', this.container.css('left'));
							this.container.data('style.top', this.container.css('top'));
							this.container.css('z-index', this._baseZIndex + 10000);
							$(document).scrollTop(0);
							$(document).scrollLeft(0);
							this.container.css('position', 'fixed')
								.css('height', '100%')
								.css('width', '100%')
								.css('left', '0px')
								.css('top', '0px');
							$('#' + this._id('_ctrls')).parent().css('width', '100%');

							if (this._commercialPlaying) {
								video.css('top', 0).css('left', 0);
								mainVideo.css('height', '100%').css('width', '100%');
							}
							video.css('height', '100%').css('width', '100%');
							if (!options.browserControls) {
								$('span', $('#' + this._id('_ctrls_fs_btn'))).removeClass('ui-icon-arrow-4-diag').addClass('ui-icon-closethick');
							}

							if ($('#' + this._id('_rv_bar_fs')).is(':visible')) {
								$('span', $('#' + this._id('_rv_bar_fs'))).removeClass('ui-icon-arrow-4-diag').addClass('ui-icon-closethick');
							}

							if (options.bookmarks && options.bookmarks.length > 0) {
								$('#' + this._id('_bookmarks')).hide();
							}
						}
					} else {
						noCancel = this._exitFullScreen(videoElem.currentSrc);
						if (noCancel) {
							this.container.css('position', this.container.data('style.position'))
								.css('left', this.container.data('style.left'))
								.css('top', this.container.data('style.top'));
							this.container.css('z-index', this._baseZIndex);
							$(document).scrollTop(this.container.data('document.scrollTop'));
							$(document).scrollLeft(this.container.data('document.scrollLeft'));
							if (options.height) {
								if (options.bookmarks && options.bookmarks.length > 0) {
									fsVideoH = parseInt(options.height, 10) - parseInt($('#' + this._id('_bookmarks')).css('height'), 10);
									if (this._commercialPlaying) {
										mainVideo.css('height', fsVideoH);
									}
									video.css('height', fsVideoH);
								} else {
									if (this._commercialPlaying) {
										mainVideo.css('height', options.height);
									}
									video.css('height', options.height);
								}
								this.container.css('height', options.height);
							} else {
								if (this._commercialPlaying) {
									mainVideo.css('height', '');
								}
								video.css('height', '');
								this.container.css('height', '');
							}

							if (options.width) {
								if (this._commercialPlaying) {
									mainVideo.css('width', options.width);
								}
								video.css('width', options.width);
								$('#' + this._id('_ctrls')).parent().css('width', options.width);
								this.container.css('width', options.width);
							} else {
								if (this._commercialPlaying) {
									mainVideo.css('width', '');
								}
								video.css('width', '');
								$('#' + this._id('_ctrls')).parent().css('width', '');
								this.container.css('width', '');
							}

							if (this._commercialPlaying) {
								video.css('top', videoOffset.top).css('left', videoOffset.left);
							}

							if (!options.browserControls) {
								$('span', $('#' + this._id('_ctrls_fs_btn'))).removeClass('ui-icon-closethick').addClass('ui-icon-arrow-4-diag');
							}

							if ($('#' + this._id('_rv_bar_fs')).is(':visible')) {
								$('span', $('#' + this._id('_rv_bar_fs'))).removeClass('ui-icon-closethick').addClass('ui-icon-arrow-4-diag');
							}

							if (options.bookmarks && options.bookmarks.length > 0) {
								$('#' + this._id('_bookmarks')).show();
							}
						}
					}

					if (!noCancel) {
						return; /* event was cancelled! */
					}

					if ($("#" + this._id('_waiting')).is(':visible')) {
						// recalculate the position of waiting indicator.
						this._showWaitingIndicator();
					}

					if ($("#" + this._id('_play')).is(':visible')) {
						this._showCenterPlayButton();
					}

					if ($("#" + this._id('_ad_msg_c')).is(':visible')) {
						$("#" + this._id('_ad_msg_c')).css('width', this.container.css('width'));
					}

					if ($('#' + this._id('_ctrls_vs')).is(':visible')) {
						this._hideVolumeSlider();
					}

					if ($("#" + this._id('_detectError')).is(':visible')) {
						this._showUnsupportedVideoSourceMsg();
					}

					$("body").toggleClass("ui-igplayer-full-screen-mode");

					if (!options.browserControls) {
						$('#' + this._id('_ctrls_fs_btn')).attr('title', value ? $.ig.VideoPlayer.locale.exitFullscreen : $.ig.VideoPlayer.locale.enterFullscreen);
					}
					if ($('#' + this._id('_rv_bar_fs')).is(':visible')) {
						$('#' + this._id('_rv_bar_fs')).attr('title', value ? $.ig.VideoPlayer.locale.exitFullscreen : $.ig.VideoPlayer.locale.enterFullscreen);
					}
					options.fullscreen = value;
				}
				break;
			case 'volume':
				if (value !== options.volume && value >= this._const.VOLUME_MIN && value <= this._const.VOLUME_MAX) {
					options.volume = videoElem.volume = value;

					if (value > 0 && videoElem.muted) {
						options.muted = videoElem.muted = false;
					} else if (value === 0 && !videoElem.muted) {
						options.muted = videoElem.muted = true;
					}

					if (!options.browserControls) {
						this._adjustVolumeButton(value);
						$('#' + this._id('_ctrls_vs')).igSlider('option', 'value', value * 100);
					}
				}
				break;
			case 'muted':
				if (value !== options.muted) {
					options.muted = videoElem.muted = value;
					$('#' + this._id('_ctrls_vs')).igSlider('option', 'value', (value ? 0 : (options.volume !== 0 ? options.volume : 0.3) * 100));
					if (options.volume === 0) {
						options.volume = 0.3;
					}
					if (!value && videoElem.volume === 0) {
						videoElem.volume = options.volume;
					}
					if (!options.browserControls) {
						this._adjustVolumeButton($('#' + this._id('_ctrls_vs')).igSlider("option", "value"));
					}
				}
				break;
			case 'title':
				$('#' + this._id('_title_ctrls_t')).html(value);
				break;
			case 'progressLabelFormat':
				options.progressLabelFormat = value;
				this._updateProgressLabel();
				break;
			case 'alwaysPlayCommercials':
				if (value !== options.commercials.alwaysPlayCommercials) {
					options.commercials.alwaysPlayCommercials = value;
					if (value) {
						this.resetCommercialsShow();
					}
				}
				break;
			case 'bookmarks':
				this._destroyBookmarks();
				options.bookmarks = value;
				this._renderBookmarks();
				break;
			case 'relatedVideos':
				this._destroyRelatedVideos();
				options.relatedVideos = value;
				this._renderRelatedVideos();
				break;
			default:
				break;
			}
			$.Widget.prototype._setOption.apply(this, arguments);
		},

		_onVideoStateChange: function () {
			var video = this.currentVideo,
				videoElem = video[0],
				o = this.options,
				prevReadyState = this._prevReadyState,
				readyState = videoElem.readyState;

			/*if (prevReadyState === videoElem.HAVE_NOTHING &&
				readyState === videoElem.HAVE_METADATA) {
				loaded metadata
			} else if (prevReadyState === videoElem.HAVE_METADATA &&
						readyState >= videoElem.HAVE_CURRENT_DATA) {
				loaded data
			} else */
			if (prevReadyState >= videoElem.HAVE_FUTURE_DATA && readyState <= videoElem.HAVE_CURRENT_DATA) {
				/* waiting for data */
				if (!videoElem.ended) {
					this._showWaitingIndicator();
				}
			} else if (prevReadyState <= videoElem.HAVE_CURRENT_DATA && readyState === videoElem.HAVE_FUTURE_DATA) {
				/* can continue play(canplay) */
				this._hideWaitingIndicator();
			} else if (readyState === videoElem.HAVE_ENOUGH_DATA) {
				if (prevReadyState <= videoElem.HAVE_CURRENT_DATA) {
					/* canplay for first time. */
					this._hideWaitingIndicator();
				} else {
					// K.D. April 5th, 2012 Bug #108111 In Webkit the state changed continues firing after the video ends
					// The result is that the related videos are rendered and then removed immediately.
					return;
				}
			}

			this._prevReadyState = readyState;

			this._detectBuffered();

			/* if (videoElem.controls !== this._lastControlsState) {
				this._setOption('browserControls', videoElem.controls); TODO - react to video context menu!
			}*/
			/* Handle the case when play is invoked by browser context menu! */
			if (this._lastPausedState !== videoElem.paused) {
				if (this._lastPausedState) {
					this._showCenterPlayButton().removeClass(this.css.centerPauseButtonClass).addClass(this.css.centerPlayButtonClass);
				} else {
					this._showCenterPlayButton().removeClass(this.css.centerPlayButtonClass).addClass(this.css.centerPauseButtonClass);
				}
				setTimeout($.proxy(this._hideCenterPlayButton, this), o.centerButtonHideDelay);
				this._prepareForPlay();
				this._lastPausedState = videoElem.paused;
			}

			this._setOption('muted', videoElem.muted);

			this._refreshDuration();

			this._onVideoStateChangeId = setTimeout($.proxy(this._onVideoStateChange, this), this._const.VIDEO_STATE_TIMEOUT);
		},

		_updateTitleControlsTimeString: function (timeString, title) {
			if (this._activeControlsIndex === 1 && timeString) {
				/* if we are in inital mode update the duration */
				if (!title) {
					title = timeString;
				}
				$('span.ui-igplayer-playbutton-text', $('#' + this._id('_title_ctrls'))).attr('title', title).html(timeString);
			}
		},

		_analyzeSource: function (video, doNotShowError) {
			var detected = false;

			if (this.supports_h264_baseline_video() && video.data('mp4') !== undefined) {
				video.attr('src', video.data('mp4'));
				detected = true;
			// N.A. Aug 22th, 2013 Bug #145499 VideoPlayer is not playing WebM format
			} else if (this.supports_webm_video() && video.data('webm') !== undefined) {
				video.attr('src', video.data('webm'));
				detected = true;
			} else if (this.supports_ogg_theora_video()) {
				if (video.data('ogv') !== undefined) {
					video.attr('src', video.data('ogv'));
					detected = true;
				} else if (video.data('ogg') !== undefined) {
					video.attr('src', video.data('ogg'));
					detected = true;
				}
			}

			video.data('sourceDetected', detected);

			if (!detected && !doNotShowError) {
				this._showUnsupportedVideoSourceMsg();
				if (!this.options.browserControls) {
					/* disable controls that invoke play */
					if (this._activeControlsIndex === 0) {
						$('#' + this._id('_ctrls_play')).igButton('option', 'disabled', true);
					}/* else if (this.container.data('activeControlsIndex') === 1) {
						title controls
						
					}*/
				}
			} else {
				this._hideUnsupportedVideoSourceMsg();
				/* enable controls that invoke play */
				if (!this.options.browserControls) {
					if (this._activeControlsIndex === 0) {
						/* normal controls */
						$('#' + this._id('_ctrls_play')).igButton('option', 'disabled', false);
					}/* else if (this.container.data('activeControlsIndex') === 1) {
						title controls
						
					}*/
				}
			}
		},

		resetCommercialsShow: function () {
			/* Resets the commercials, to be shown again. */
			this._buildCommercialsShow();
			this._embeddedCommercialsShow = $.extend(true, [], this.options.commercials.embeddedCommercials);
			this._embeddedCommercialIndex = 0;
		},

		_attachVideoEvents: function (video) {
			var control = this;
			this._videoEvents = {
				error: function (event) {
					control._onVideoError(event);
				},
				progress: function (event) {
					control._onVideoLoading(event);
				},
				waiting: function (event) {
					control._onVideoWaiting(event);
					control._waiting(this.currentSrc, this.currentTime, this.duration, event);
				},
				seeking: function (event) {
					control._showWaitingIndicator();
				},
				seeked: function (event) {
					control._hideWaitingIndicator();
				},
				timeupdate: function (event) {
					control._changeCurrentTime(event);
				},
				ended: function (event) {
					/* Display big play button in the center when ended. */
					control._showCenterPlayButton().removeClass("ui-igplayer-centerplaybutton-pause").addClass("ui-igplayer-centerplaybutton-play");
					control._hideWaitingIndicator();
					/* Update controls play button. */
					if (!control.options.browserControls) {
						$('span', $('#' + control._id('_ctrls_play'))).addClass('ui-icon-play').removeClass('ui-icon-pause');
					}
					$('#' + control._id('_ctrls_pb')).igProgressBar('option', 'value', 0);
					if (control.options.relatedVideos.length > 0) {
						control._onControlMouseOut(null);
						$('#' + control._id('_rvcc')).show();
					}
					control._buildBannersShow();
					if (control.options.commercials.alwaysPlayCommercials) {
						control.resetCommercialsShow();
					}
					control._ended(this.currentSrc, this.duration, event);
				},
				playing: function (event) {
					control._hideWaitingIndicator();
					$('span', $('#' + control._id('_ctrls_play'))).addClass('ui-icon-pause').removeClass('ui-icon-play');
					control._playing(this.currentSrc, this.duration, event);
				},
				pause: function (event) {
					$('span', $('#' + control._id('_ctrls_play'))).addClass('ui-icon-play').removeClass('ui-icon-pause');
					control._paused(this.currentSrc, this.duration, event);
				},
				click: function (event) {
					var o = control.options;
					if (!o.browserControls) {
						event.preventDefault();
					}
					if (event.button === 0 && !o.disabled) {
						/* 18-FEB-2011 66594 Limitation: Do not toggle video when browser controls are used.
							* The problem is that clicking on play button of the browser controls fires click for the video
							* and we cannot determine the actual target of the click. This causes the state of the video to not change.
							*/
						control._onVideoClick(!o.browserControls);
					}
				},
				dblclick: function (event) {
					event.preventDefault();
					if (event.button === 0 && !control.options.disabled) {
						control._onVideoDblClick();
					}
				},
				selectstart: function () {
					return false;
				},
				// N.A. July 18th, 2013 Bug #140860 In Chrome meta data loading is slower, that's we ensure it's loaded before requesting video duration property.
				loadedmetadata: function (event) {
					control._refreshDuration();
				}
			};
			video.bind(this._videoEvents);
		},

		_onVideoClick: function (allowPlay) {
			if (this._embeddedCommercialPlaying) {
				var link = this.options.commercials.embeddedCommercials[this._embeddedCommercialIndex].link;
				if (link && link.length > 0) {
					window.open(link, '_blank');
				}
			} else if (allowPlay) {
				this.togglePlay();
			}
		},

		_onVideoDblClick: function () {
			var o = this.options;
			this._setOption("fullscreen", !o.fullscreen);
			if (!o.browserControls) {
				this._toggleCenterPlayButton();
			}
		},

		_attachEvents: function (video) {
			var control = this;

			this._attachVideoEvents(video);

			this._generalEvts = {
				keydown: function (event) {
					if (event.keyCode === $.ui.keyCode.ESCAPE) {
						if (control.options.fullscreen) {
							control._setOption('fullscreen', false);
							event.preventDefault();
							event.stopPropagation();
						}
					} else if (event.keyCode === $.ui.keyCode.SPACE) {
						event.preventDefault();
						event.stopPropagation();
						control.togglePlay();
					}
				}
			};

			this._documentEvts = {
				contextmenu: function (e) {
					if ($(e.target).is('video') && control.options.disabled) {
						e.preventDefault();
						e.stopPropagation();
					}
				}
			};

			$(document).bind(this._documentEvts);

			if (!this.options.browserControls) {
				this._controlsEvts = {
					mouseover: function (event) {
						control._onControlMouseOver(event);
					},
					mouseout: function (event) {
						control._onControlMouseOut(event);
					}
				};
				this.container.bind(this._controlsEvts);
			}
			this.container.bind(this._generalEvts);
		},

		_handleKbNavigation: function (event) {
			if (event.keyCode === $.ui.keyCode.HOME) {
				$(this.controlButtons[0]).focus();
				event.stopPropagation();
				event.preventDefault();
			} else if (event.keyCode === $.ui.keyCode.END) {
				$(this.controlButtons[this.controlButtons.length - 1]).focus();
				event.stopPropagation();
				event.preventDefault();
			}
		},

		_handleBlurKb: function () {
			this.currentVideo.removeClass(this.css.activeVideoClass);
		},

		_handleFocusKb: function () {
			this.currentVideo.addClass(this.css.activeVideoClass);
		},

		_onVideoLoading: function (event) {
			this._detectBuffered(event);
		},

		_detectBuffered: function (event) {
			var videoElem = this.currentVideo[0],
				buffered = videoElem.buffered,
				duration = parseInt(videoElem.duration, 10),
				len = buffered ? buffered.length : 0,
				firstBuffered = len > 0 ? parseInt(buffered.start(len - 1), 10) : 0,
				lastBuffered = len > 0 ? parseInt(buffered.end(len - 1), 10) : 0,
				bufferSize = (lastBuffered / duration) * 100;

			// K.D. May 31st, 2011 Bug #77359 Buffered is fired constantly because the previously buffered value
			// is never kept and checked against
			if (len > 0 && this._previouslyBuffered !== bufferSize) {
				// S.S. November 24th, 2011 Bug #75937 When the video starts again with loop the new buffered area is before the last one 
				// so if the value is not reset the old one is not refreshed
				if (this._previousBuffer && lastBuffered < parseInt(this._previousBuffer.end(0), 10)) {
					$('#' + this._id('_ctrls_pb')).igProgressBar('option', 'value', firstBuffered);
				}
				$('#' + this._id('_ctrls_pb')).igProgressBar('option', 'endValue', (lastBuffered / duration) * 100);
				this._buffering(videoElem.currentSrc, bufferSize, event);
				this._previouslyBuffered = bufferSize;
				this._previousBuffer = buffered;
			}
		},

		_getActiveControls: function () {
			var ai = this._activeControlsIndex;
			if (ai !== undefined && this.controls && ai >= 0 && ai < this.controls.length) {
				return this.controls[ai].parent();
			}
			return null;
		},

		_onControlMouseOver: function () {
			var controlsDiv = this._getActiveControls(),
				o = this.options;
			if (controlsDiv && !o.browserControls && o.autohide && !$('#' + this._id('_rvcc')).is(':visible')) {
				controlsDiv.show().removeClass(this.css.controlsHideClass);
			}
		},

		_onControlMouseOut: function () {
			var o = this.options,
				controlsDiv = this._getActiveControls();
			if (controlsDiv && !o.browserControls && o.autohide) {
				controlsDiv.addClass(this.css.controlsHideClass).hide();
			}
		},

		_onVideoError: function (e) {
			var error = e.target.error;
			switch (error.code) {
			case error.MEDIA_ERR_ABORTED:
				/* user aborted the plying. */
				break;
			case error.MEDIA_ERR_NETWORK:
				/* try again to play the video. */
				this.play();
				break;
			case error.MEDIA_ERR_DECODE:
			case error.MEDIA_ERR_SRC_NOT_SUPPORTED:
				/* run the analyze algorithm again. */
				this._showUnsupportedVideoSourceMsg();
				break;
			default:
				break;
			}
		},

		_changeCurrentTime: function (event) {
			var videoElem = this.currentVideo[0],
				rawDuration = videoElem.duration,
				currentTime;

			if (rawDuration === Infinity) {
				/* live stream */
				this._updateProgressLabel();
			} else if (!isNaN(rawDuration)) {
				currentTime = parseInt(videoElem.currentTime, 10);
				if (!this._userSliding) {
					$('#' + this._id('_ctrls_s')).igSlider('option', 'value', (currentTime / rawDuration) * 100);
				}
				this._updateProgressLabel();

				if (this._embeddedCommercialPlaying) {
					this._updateAdMessage(this.options.commercials.embeddedCommercials[this._embeddedCommercialIndex].endTime - currentTime);
					this._checkEmbeddedCommercialShow(currentTime);
				} else if (!this._commercialPlaying) {
					this._checkBannerShow(currentTime);
					this._checkCommercialsShow(currentTime);
					this._checkEmbeddedCommercialShow(currentTime);
				} else {
					this._updateAdMessage(rawDuration - currentTime);
				}
			}
			this._progress(videoElem.currentSrc, currentTime, rawDuration, event);
		},

		_checkBannerShow: function (currentTime) {
			var show = this._bannerShow || [],
				len = show.length,
				i = 0;
			for (i; i < len; i++) {
				if (show[i].length > 0 && currentTime >= show[i][0]) {
					show[i].shift();
					this.showBanner(i);
				}
			}
		},

		_checkCommercialsShow: function (currentTime) {
			if (this._commercialsShow && this._commercialsShow.length > 0 && currentTime >= this._commercialsShow[0] && !this._commercialPlaying) {
				this._commercialPlaying = true;
				if (currentTime - this._commercialsShow[0] > this._const.COMMERCIAL_SEEK_DELTA) {
					this.currentTime(this._commercialsShow[0]);
				}
				this.playCommercial(this.options.commercials.linkedCommercials[this._commercialIndex]);
			}
		},

		_checkEmbeddedCommercialShow: function (currentTime) {
			if (this._embeddedCommercialsShow && this._embeddedCommercialsShow.length > 0 && !this.currentVideo[0].seeking) {
				var currentCommercial = this._embeddedCommercialsShow[0];
				if (currentTime >= currentCommercial.startTime && !this._embeddedCommercialPlaying) {
					this._embeddedCommercialPlaying = true;
					if (currentTime - currentCommercial.startTime > this._const.COMMERCIAL_SEEK_DELTA) {
						this.currentTime(currentCommercial.startTime);
					}
					$('#' + this._id('_ctrls_s')).igSlider('option', 'disabled', true);
					this._showAdMessage(currentCommercial.endTime - currentCommercial.startTime);
					if (currentCommercial.link && currentCommercial.link.length > 0) {
						this.currentVideo.attr('title', $.ig.VideoPlayer.locale.adNewWindowTip);
					}
				} else if (currentTime >= currentCommercial.endTime && this._embeddedCommercialPlaying) {
					this._embeddedCommercialsShow.shift();
					this._embeddedCommercialIndex++;
					this._embeddedCommercialPlaying = false;
					this.hideAdMessage();
					$('#' + this._id('_ctrls_s')).igSlider('option', 'disabled', false);
					if (currentCommercial.link && currentCommercial.link.length > 0) {
						this.currentVideo.removeAttr('title');
					}
				}
			}
		},

		_updateProgressLabel: function () {
			var videoElem = this.currentVideo[0],
				progressLabel = $('#' + this._id('_ctrls_pl')),
				rawDuration = videoElem.duration,
				duration = parseInt(rawDuration, 10),
				currentTime = parseInt(videoElem.currentTime, 10),
				progressString = this.options.progressLabelFormat;
			progressString = progressString.replace("${currentTime}", this._toTimeString(currentTime)).replace("${duration}", (rawDuration === Infinity ? $.ig.VideoPlayer.locale.liveStream : this._toTimeString(duration)));
			progressLabel.html(progressString);
		},

		_toTimeString: function (val) {
			/* val is assumed to be always seconds, because video.currentTime is always in seconds. */
			if (typeof val === "number") {
				var secs = parseInt(val % 60, 10),
					mins = parseInt(val / 60, 10),
					hours = parseInt(mins / 60, 10),
					days = parseInt(hours / 24, 10),
					timeFormat = "{0}d {1}:{2}:{3}";
				mins = parseInt(mins % 60, 10);
				hours = parseInt(hours % 60, 10);
				timeFormat = timeFormat.replace("{3}", (secs < 10 ? "0" + secs : secs)).replace("{2}", mins);
				if (hours > 0) {
					timeFormat = timeFormat.replace("{1}", hours);
					if (days > 0) {
						timeFormat = timeFormat.replace("{0}", days);
					} else {
						timeFormat = timeFormat.replace('{0}d ', '');
					}
				} else {
					timeFormat = timeFormat.replace('{0}d {1}:', '');
				}
				return timeFormat;
			}
			return "NaN";
		},

		_onVideoWaiting: function () {
			this._showWaitingIndicator();
		},

		_createUnsupportedVideoSourceMsg: function () {
			var css = this.css;
			return this._createButton(this._id('_detectError'),
										css.unsupportedVideoSourceClass,
										css.unsupportedVideoSourceIconClass,
										$.ig.VideoPlayer.locale.missingVideoSource).attr('title', $.ig.VideoPlayer.locale.unsupportedVideoSource);
		},

		_showUnsupportedVideoSourceMsg: function () {
			var error = $("#" + this._id('_detectError'));

			if (error.length === 0) {
				error = this._createUnsupportedVideoSourceMsg();
			}

			return error.show();
		},

		_hideUnsupportedVideoSourceMsg: function () {
			$("#" + this._id('_detectError')).hide();
		},

		_createBigPlayButton: function () {
			var control = this, css = this.css;

			this._createButton(this._id('_play'),
								css.centerPlayButtonClass,
								css.centerPlayButtonIconClass,
								'').bind({
				click: function (event) {
					event.preventDefault();
					if (event.button === 0) {
						control._onVideoClick(true);
					}
				},
				dblclick: function (event) {
					event.preventDefault();
					if (event.button === 0) {
						control._onVideoDblClick();
					}
				}
			});
		},

		_createButton: function (buttonId, buttonClass, spanClass, text) {
			$('<span></span>').html(text).addClass(spanClass)
				.appendTo($('<a></a>').attr('id', buttonId)
					.attr('href', this._const.HREF).attr('tabIndex', -1)
					.addClass('ui-state-default').addClass(buttonClass)
					.appendTo(this.container));
			return $('#' + buttonId).bind({
				mouseover: function () {
					$(this).addClass("ui-state-hover");
				},
				mouseout: function () {
					$(this).removeClass("ui-state-hover");
				}
			}).hide();
		},

		_showCenterPlayButton: function () {
			var video = this.currentVideo,
				button = $("#" + this._id('_play')),
				// K.D. May 31st, 2011 Bug #74395 The center play button is absolutely positioned inside the video container
				// and thus when positioning it we shouldn't include the video offset in the calculation
				videoCenterTop  = Math.floor(video.height() / 2),
				videoCenterLeft = Math.floor(video.width() / 2),
				top = videoCenterTop - Math.floor(button.innerHeight() / 2),
				left = videoCenterLeft - Math.floor(button.innerWidth() / 2);
			button.css('position', 'absolute').css('left', left).css('top', top);
			return button.show();
		},

		_toggleCenterPlayButton: function () {
			var videoElem = this.currentVideo[0],
				o = this.options,
				css = this.css;
			if (videoElem.paused || videoElem.ended) {
				/* from paused state to playing state. */
				this._showCenterPlayButton().removeClass(css.centerPauseButtonClass).addClass(css.centerPlayButtonClass);
			} else {
				/* from playing state to paused state. */
				this._showCenterPlayButton().removeClass(css.centerPlayButtonClass).addClass(css.centerPauseButtonClass);
			}
			setTimeout($.proxy(this._hideCenterPlayButton, this), o.centerButtonHideDelay);
		},

		_hideCenterPlayButton: function () {
			return $("#" + this._id('_play')).hide();
		},

		_createWaitingIndicator: function () {
			var css = this.css;
			this._createButton(this._id('_waiting'),
								css.waitingIndicatorClass,
								css.waitingIndicatorIconClass,
								$.ig.VideoPlayer.locale.buffering);
		},

		_createSeekTimeToolTip: function () {
			$('<div></div>').attr('id', this._id('_seek_tooltip')).hide().igTooltip({
				text: '00:00',
				arrowLocation: 'bottom'
			}).appendTo(this.container).addClass(this.css.seekTooltipClass);
		},

		_showSeekTimeToolTip: function (x, y, seconds) {
			var toolTip = $('#' + this._id('_seek_tooltip'));

			toolTip.css('top', (y - toolTip.outerHeight()))
				.css('left', (x - (toolTip.width() / 2)))
				.igTooltip('option', 'text', this._toTimeString(seconds))
				.show();
		},

		_showWaitingIndicator: function () {
			if ($("#" + this._id('_detectError')).is(':visible')) {
				return;
			}
			var video = this.currentVideo,
				button = $("#" + this._id('_waiting')),
				// K.D. May 31st, 2011 Bug #74395 The waiting indicator is absolutely positioned inside the video container
				// and thus when positioning it we shouldn't include the video offset in the calculation (same as big central button)
				videoCenterTop  = Math.floor(video.height() / 2),
				videoCenterLeft = Math.floor(video.width() / 2),
				top = videoCenterTop - Math.floor(button.innerHeight() / 2),
				left = videoCenterLeft - Math.floor(button.innerWidth() / 2);
			button.css('position', 'absolute').css('left', left).css('top', top).show();
		},

		_hideWaitingIndicator: function () {
			$("#" + this._id('_waiting')).hide();
		},

		_renderTitleControls: function () {
			var title = this.options.title,
				control = this,
				controlsDiv,
				html = '<div id="' + this._id('_title_ctrls') + '" class="ui-widget-header ui-igplayer-controls ui-igplayer-grid ui-igplayer-title-controls ui-corner-all">';
			html += '<div class="ui-igplayer-row">';
			html += '<div class="ui-igplayer-container ui-igplayer-cell ui-igplayer-playback-alone">';
			html += '		<a id="' + this._id('_title_ctrls_play') + '" class="ui-button ui-igplayer-playbutton ui-igplayer-playback-with-time ui-state-default ui-corner-all ui-priority-primary" href="' + this._const.HREF + '">';
			html += '			<span title="' + $.ig.VideoPlayer.locale.play + '" class="ui-icon ui-icon-play ui-igplayer-playbutton-icon"></span>';
			html += '			<span title="00:00" class="ui-button-text ui-igplayer-playbutton-text">00:00</span>';
			html += '		</a>';
			html += '</div>';
			html += '<div id="' + this._id('_title_ctrls_t') + '" class="ui-igplayer-container ui-igplayer-cell ui-igplayer-video-title">';
			if (title && title.length > 0) {
				html += title;
			}
			html += '</div></div></div>';

			controlsDiv = $(html).appendTo(this.container).wrap('<div style="position:absolute; width: 100%;"></div>');
			if (this.options.width) {
				controlsDiv.parent().css('width', this.options.width);
			}

			$('#' + this._id('_title_ctrls_play')).bind({
				click: function (event) {
					event.preventDefault();
					if (event.button === 0 && !control.options.disabled) {
						control.togglePlay();
					}
				}
			});

			return controlsDiv;
		},

		_hideTitleControls: function () {
			if (this._activeControlsIndex !== 0) {
				this._activeControlsIndex = 0;
				$('#' + this._id('_title_ctrls')).addClass(this.css.controlsHideClass).parent().remove();
				$('#' + this._id('_ctrls')).parent().show();
			}
		},

		_convertBookmarks: function (prop, bookmarks, duration, css) {
			/* Converts the list of bookmarks to slider bookmarks. */
			var len = bookmarks.length,
				newBookmarks = [],
				i = 0,
				mark,
				newMark,
				value;
			for (i; i < len; i++) {
				mark = bookmarks[i];
				if (mark[prop] > 0 && mark[prop] < duration) {
					value = parseInt((mark[prop] / duration) * 100, 10);
					newMark = {
						value: value,
						secondsValue: mark[prop],
						displayTime: this._toTimeString(mark[prop]),
						index: i,
						title: mark.title,
						disabled: mark.disabled
					};

					if (css && css.length > 0) {
						newMark.css = css;
					}

					newBookmarks.push(newMark);
				}
			}
			return newBookmarks;
		},

		_renderBookmarks: function () {
			var o = this.options,
				bookmarks = o.bookmarks || [],
				com = o.commercials,
				ads = com.linkedCommercials || [],
				eads = com.embeddedCommercials || [],
				duration = this.currentVideo[0].duration,
				newBookmarks = [],
				newAdBookmarks = [],
				newEAdBookmarks = [];

			if (com.showBookmarks) {
				if (ads.length > 0) {
					newAdBookmarks = this._convertBookmarks('startTime', ads, duration, this.css.linkedBookmarkClass);
				}

				if (eads.length > 0) {
					newEAdBookmarks = this._convertBookmarks('startTime', eads, duration, this.css.adBookmarkClass);
				}
			}

			if (bookmarks.length > 0) {
				/* transform the video bookmarks value to slider value in range 0 to 100. */
				newBookmarks = this._convertBookmarks('time', bookmarks, duration);

				if (newBookmarks.length > 0) {
					this._renderBookmarkArea(newBookmarks);
				}
			}

			/* newBookmarks is destroyed to contain the merge result! */
			if (newAdBookmarks.length > 0) {
				$.merge(newBookmarks, newAdBookmarks);
			}
			if (newEAdBookmarks.length > 0) {
				$.merge(newBookmarks, newEAdBookmarks);
			}

			if (newBookmarks.length > 0) {
				$('#' + this._id('_ctrls_s')).igSlider('option', 'bookmarks', newBookmarks);
			}

			this._bookmarksRendered = true;
		},

		_renderBookmarkArea: function (bookmarks) {
			if (bookmarks && bookmarks.length > 0) {
				var css = this.css,
					bookmarkStr = '<li class="ui-corner-all $class$"><span class="' + css.bookmarkItemTimeClass + '">$time$</span><span class="' + css.bookmarkItemTitleClass + '" title="$titleAttr$">$title$</span></li>',
					bookmarkAreaStr = '<div id="$id$" class="$bookmarkContainerClass$"><div class="$headerClass$">$headerText$</div><ul class="$bookmarkListClass$">$list$</ul></div>',
					bookmarkList = '',
					bookmarkArea,
					mark,
					i = 0,
					len = bookmarks.length,
					control = this;

				for (i; i < len; i++) {
					mark = bookmarks[i];
					bookmarkList += bookmarkStr.replace('$time$', mark.displayTime)
						.replace('$titleAttr$', mark.title)
						.replace('$title$', mark.title)
						.replace('$class$', mark.disabled ? css.bookmarkItemDisabledClass : '');
				}

				bookmarkAreaStr = bookmarkAreaStr.replace("$id$", this._id('_bookmarks'))
					.replace('$bookmarkContainerClass$', css.bookmarkContainerClass)
					.replace('$headerClass$', css.bookmarkContainerHeaderClass)
					.replace('$bookmarkListClass$', css.bookmarkListClass)
					.replace('$headerText$', $.ig.VideoPlayer.locale.skipTo)
					.replace('$list$', bookmarkList);

				bookmarkArea = $(bookmarkAreaStr).appendTo(this.container);

				this.bookmarkElements = $('li', $('#' + this._id('_bookmarks')));

				this.bookmarkElements.each(function (i) {
					$(this).data("bookmark-index", bookmarks[i].index); /* the index according to options.bookmarks. */
					$(this).data("bookmark-sec-value", bookmarks[i].secondsValue);
				});

				this.bookmarkElements.bind({
					click: function (event) {
						var index = $(this).data('bookmark-index'),
							mark = control.options.bookmarks[index];
						event.stopPropagation();
						event.preventDefault();
						if (!mark.disabled) {
							if (control.paused()) {
								control.togglePlay();
							}
							control.currentTime($(this).data('bookmark-sec-value'));
							control._changeActiveBookmark(index);
							// K.D. June 1st, 2011 Bookmark use should be unified and not referred from the slider
							// because in the case of browser controls the slider doesn't exist and the bookmark
							// pins are not available as object.
							control._bookmarkClick(mark, bookmarks[index], event);
						}
					}
				});
				if (this.options.height) {
					this.currentVideo.css('height', this.container.height() - bookmarkArea.height());
					this._resizeBookmarkAreaTimeoutId = setTimeout($.proxy(this._onPlayerResize, this), 500);
				}
			}
		},

		_onPlayerResize: function () {
			var o = this.options,
				containerH = this.container.height(),
				containerW = this.container.width(),
				bookmarkArea = $('#' + this._id('_bookmarks'));
			if ((o.height || o.width) && (this._oldContainerHeight !== containerH || this._oldContainerWidth !== containerW)) {
				// control has been resized, we have to resize the bookmark are and video container.
				this.currentVideo.css('height', containerH - bookmarkArea.height());
				this._oldContainerHeight = containerH;
				this._oldContainerWidth = containerW;
			}
			this._resizeBookmarkAreaTimeoutId = setTimeout($.proxy(this._onPlayerResize, this), 250);
		},

		// S.S. June 24th, 2011 Bug #74601 Before rendering our controls we need to be sure the correct
		// volume is set for the widget to display in the volume slider.
		_ensureVolume: function () {
			this.options.volume = this.currentVideo[0].volume;
		},

		_renderControls: function () {
			$("body").addClass("ui-igplayer-normal-screen-mode");

			if (this.options.showSeekTime) {
				this._createSeekTimeToolTip();
			}

			var videoElem = this.currentVideo[0],
				control = this,
				controlsDiv,
				controlsArray = [],
				autoPlay = this.options.autoplay,
				href = this._const.HREF,
				html = '<div id="' + this._id('_ctrls') + '" class="$controlsClass$">',
				cachedTime;
			html += '			<div class="ui-igplayer-row">';
			html += '				<div class="ui-igplayer-container ui-igplayer-cell ui-igplayer-playback">';
			html += '					<a id="$playButtonId$" class="$playButtonClass$" href="' + href + '"></a>';
			html += '				</div>';

			html += '				<div class="ui-igplayer-container ui-igplayer-cell ui-igplayer-progress-bar">';
			html += '					<div id="$progressBarId$" class="$progressBarClass$"></div>';
			html += '				</div>';

			html += '				<div class="ui-igplayer-container ui-igplayer-extra">';
			html += '					<div class="ui-igplayer-grid">';
			html += '						<div class="ui-igplayer-row">';
			html += '							<div class="ui-igplayer-cell">';
			html += '								<a id="$progressLabelId$" class="$progressLabelClass$" href="' + href + '"></a>';
			html += '							</div>';

			html += '							<div class="ui-igplayer-cell">';
			html += '                               <div>';
			html += '                                   <div id="$volumeSliderId$" class="$volumeSliderClass$"></div>';
			html += '									<div>';
			html += '										<a id="$volumeControlId$" class="$volumeControlClass$" href="' + href + '"></a>';
			html += '									</div>';
			html += '                               </div>';
			html += '							</div>';
			html += '							<div class="ui-igplayer-cell">';
			html += '								<a id="$fullScreenId$" class="$fullScreenClass$" href="' + href + '"></a>';
			html += '							</div>';
			html += '						</div>';
			html += '					</div>';
			html += '				</div>';
			html += '			</div>';
			html += '		</div>';

			html = html.replace("$playButtonClass$", this.css.playButtonClass).replace("$progressBarClass$", this.css.progressBarClass).replace("$fullScreenClass$", this.css.fullScreenClass).replace("$controlsClass$", this.css.controlsClass).replace("$volumeControlClass$", this.css.volumeControlClass).replace("$volumeSliderClass$", this.css.volumeSliderClass).replace("$progressLabelClass$", this.css.progressLabelClass);

			html = html.replace("$playButtonId$", this._id('_ctrls_play')).replace("$progressBarId$", this._id('_ctrls_s')).replace("$fullScreenId$", this._id('_ctrls_fs_btn')).replace("$volumeControlId$", this._id('_ctrls_vc_btn')).replace("$volumeSliderId$", this._id('_ctrls_vs')).replace("$progressLabelId$", this._id('_ctrls_pl'));

			controlsDiv = $(html).appendTo(this.container).wrap('<div style="position:absolute; width: 100%;"></div>');
			if (this.options.width) {
				controlsDiv.parent().css('width', this.options.width);
			}

			controlsArray.push(controlsDiv);

			if (!autoPlay && videoElem.currentTime === 0) {
				controlsDiv.parent().hide();
				this._activeControlsIndex = 1;
				controlsArray.push(this._renderTitleControls());
			} else {
				this._activeControlsIndex = 0;
			}

			this.controls = $(controlsArray);

			/* bind events */
			$('#' + this._id('_ctrls_play')).bind({
				click: function (event) {
					event.preventDefault();
					if (!$(this).igButton('option', 'disabled')) {
						control.togglePlay();
					}
				}
			}).igButton({ link: { href: this._const.HREF },
							css: { buttonLabelClass: 'ui-icon ' + (autoPlay ? 'ui-icon-pause ' : 'ui-icon-play ') + 'ui-igplayer-playbutton-icon ' }
						}).addClass('ui-priority-primary')
				.attr('title', (autoPlay ? $.ig.VideoPlayer.locale.playing : $.ig.VideoPlayer.locale.paused));

			$('#' + this._id('_ctrls_fs_btn')).bind({
				click: function (event) {
					event.preventDefault();
					control._setOption("fullscreen", !control.options.fullscreen);
				}
			}).igButton({ link: { href: this._const.HREF },
							css: { buttonLabelClass: this.css.fullScreenIconClass }
						}).attr('title', $.ig.VideoPlayer.locale.enterFullscreen);

			$('<div id="' + this._id('_ctrls_pb') + '"></div>').appendTo(
				$('#' + this._id('_ctrls_s')).igSlider({
					slide: function (event, ui) {
						if (event.originalEvent === undefined) {
							return false;
						}
						clearTimeout(control._slideTimeout);
						control._slideTimeout = setTimeout(control._createDelegate(control, control._slide, [ui]), control._const.SLIDE_SEEK_TIMEOUT);
					},
					start: function () {
						control._userSliding = true;
					},
					stop: function () {
						control._userSliding = false;
					},
					bookmarkhit: function (event, ui) {
						var index = ui.bookmark.index,
							elems = control.bookmarkElements;
						if (elems && elems.length > 0) {
							control._changeActiveBookmark(index);
							control._bookmarkHit(control.currentVideo[0].currentSrc,
													control.options.bookmarks[index],
													elems[index], event);
						}
					},
					bookmarkclick: function (event, ui) {
						var mark;
						if ($(ui.bookmarkElement).hasClass('ui-igplayer-linked-bookmark')) {
							mark = control.options.commercials.linkedCommercials[ui.bookmark.index];
						} else if ($(ui.bookmarkElement).hasClass('ui-igplayer-ad-bookmark')) {
							mark = control.options.commercials.embeddedCommercials[ui.bookmark.index];
						} else {
							mark = control.options.bookmarks[ui.bookmark.index];
							control._changeActiveBookmark(ui.bookmark.index);
						}
						if (mark.time) {
							cachedTime = mark.time;
						} else {
							cachedTime = mark.startTime;
						}
						control.currentTime(cachedTime);
						control._bookmarkClick(mark, ui.bookmarkElement, event);
						return false;
					},
					min: 0,
					max: 100,
					animate: true
				}).css('display', 'block')
			).igProgressBar({
				range: true,
				endValue: 0
			});

			$('#' + this._id('_ctrls_pb')).bind({
				mousemove: function (e) {
					if (control.options.showSeekTime && this.offsetWidth > 0) {
						var relativeX = e.pageX - this.offsetLeft - $(this).offset().left,
							percentLocation = parseInt((relativeX / this.offsetWidth) * 100, 10),
							duration = videoElem.duration,
							seconds,
							controlOffset = control.container.offset();
						if (!isNaN(duration) && duration !== Infinity && !control._commercialPlaying) {
							seconds = parseInt((percentLocation * duration) / 100, 10);
							control._showSeekTimeToolTip(e.pageX - controlOffset.left, e.pageY - controlOffset.top, seconds);
						}
					}
				},
				mouseout: function () {
					$('#' + control._id('_seek_tooltip')).hide();
				}
			});

			$('#' + this._id('_ctrls_pl')).bind({
				click: function (event) {
					event.preventDefault();
				}
			});

			$('#' + this._id('_ctrls_vc_btn')).bind({
				mouseover: function () {
					control._showVolumeSlider();
				},
				mouseout: function (event) {
					if (!jQuery.contains(event.currentTarget, event.relatedTarget) && event.currentTarget !== event.relatedTarget) {
						control._volumeSliderTimeoutId = setTimeout($.proxy(control._hideVolumeSlider, control), control.options.volumeAutohideDelay);
					}
				},
				click: function (event) {
					event.preventDefault();
					control._setOption("muted", !control.options.muted);
				}
			}).igButton({ link: { href: this._const.HREF },
							css: { buttonLabelClass: 'ui-icon ' + (this.options.muted ? 'ui-icon-volume-off ' : 'ui-icon-volume-on ') + 'ui-igbutton-icon' }
						}).attr('title', $.ig.VideoPlayer.locale.volume);

			$('#' + this._id('_ctrls_vs')).hide().bind({
				mouseover: function () {
					control._volumeSliderMouseOut = false;
					clearTimeout(control._volumeSliderTimeoutId);
				},
				mouseout: function () {
					if (!control._userSlidingVolume) {
						control._volumeSliderTimeoutId = setTimeout($.proxy(control._hideVolumeSlider, control), control.options.volumeAutohideDelay);
					}
					control._volumeSliderMouseOut = true;
				}
			}).igSlider({
				slide: function (event, ui) {
					if (event.originalEvent === undefined) {
						return; /* event was triggered programatically by changing slider.value. */
					}
					control._setOption("volume", parseFloat(parseInt(ui.value, 10) / 100));
				},
				start: function () {
					control._userSlidingVolume = true;
				},
				stop: function () {
					control._userSlidingVolume = false;
				},
				min: 0,
				max: 100,
				step: 10,
				orientation: 'vertical',
				value: (this.options.muted ? 0 : this.options.volume * 100)
			});
			$('#' + this._id('_ctrls_vs')).data('igSlider').handle.attr('tabIndex', -1).bind({
				blur: function () {
					control._volumeSliderTimeoutId = setTimeout($.proxy(control._hideVolumeSlider, control), control.options.volumeAutohideDelay);
				}
			});

			this.controlButtons = $([document.getElementById(this._id('_ctrls_play')),
										$("a.ui-state-default", $('#' + this._id('_ctrls_s')))[0],
										document.getElementById(this._id('_ctrls_vc_btn')),
										document.getElementById(this._id('_ctrls_fs_btn'))
									]);
			this.controlButtons.each(function (i) {
				$(this).data("index.control-button", i);
			});
			this.controlButtons.bind({
				keydown: function (event) {
					control._handleKbNavigation(event);
				},
				focus: function (event) {
					control._handleFocusKb(event);
				},
				blur: function (event) {
					control._handleBlurKb(event);
				}
			});
			$('#' + this._id('_ctrls_vc_btn')).bind({
				focus: function () {
					control._showVolumeSlider();
				},
				blur: function () {
					if (!control._transferFocusFromVolumeButtonToVolumeSlider) {
						control._hideVolumeSlider();
					}
					control._transferFocusFromVolumeButtonToVolumeSlider = false;
				},
				keydown: function (event) {
					if (event.keyCode === $.ui.keyCode.TAB) {
						event.preventDefault();
						event.stopPropagation();
						control._transferFocusFromVolumeButtonToVolumeSlider = true;
						$('#' + control._id('_ctrls_vs')).data('igSlider').handle.focus();
					}
				}
			});
			$('#' + control._id('_ctrls_vs')).data('igSlider').handle.bind({
				keydown: function (event) {
					if (event.keyCode === $.ui.keyCode.TAB) {
						event.preventDefault();
						event.stopPropagation();
						$('#' + control._id('_ctrls_fs_btn')).focus();
					}
				}
			});
		},

		_slide: function (ui) {
			var value = ui.value,
				rawDuration = this.currentVideo[0].duration,
				currentTime = rawDuration * (value / 100);
			if (!isNaN(rawDuration) && rawDuration !== Infinity) {
				this.currentTime(currentTime);
			}
			this._userSliding = false;
		},

		_changeActiveBookmark: function (index) {
			var activeBookmarkIndex = this._activeBookmarkIndex,
				bkElems = this.bookmarkElements;

			if (bkElems && bkElems.length > 0 && index !== activeBookmarkIndex) {
				if (activeBookmarkIndex >= 0 && activeBookmarkIndex < bkElems.length) {
					$(bkElems[activeBookmarkIndex]).removeClass(this.css.bookmarkActiveItemClass);
				}
				if (index >= 0 && index < bkElems.length) {
					$(bkElems[index]).addClass(this.css.bookmarkActiveItemClass);
					this._activeBookmarkIndex = index;
				}
			}
		},

		_adjustVolumeButton: function (value) {
			var volumeButton = $('#' + this._id('_ctrls_vc_btn'));
			if (value === 0) {
				$('span', volumeButton).removeClass('ui-icon-volume-on').addClass('ui-icon-volume-off');
			} else {
				$('span', volumeButton).removeClass('ui-icon-volume-off').addClass('ui-icon-volume-on');
			}
		},

		_hideVolumeSlider: function () {
			var slider = $('#' + this._id('_ctrls_vs'));
			slider.data('igSlider').handle.attr('tabIndex', -1);
			slider.hide();
		},

		_showVolumeSlider: function () {
			clearTimeout(this._volumeSliderTimeoutId);
			var slider = $('#' + this._id('_ctrls_vs'));
			slider.data('igSlider').handle.removeAttr('tabIndex');
			slider.show();
		},

		_ended: function (source, duration, event) {
			/* fired when a video source has ended */
			var args = {
					source: source,
					duration: duration
				};
			return this._trigger(this.events.ended, event, args);
		},

		_playing: function (source, duration, event) {
			/* fired when a video source has resumed playing (after a pause) */
			var args = {
					source: source,
					duration: duration,
					currentTime: this.currentVideo[0].currentTime
				};
			return this._trigger(this.events.playing, event, args);
		},

		_paused: function (source, duration, event) {
			/* fired when video source has been paused. */
			var args = {
					source: source,
					duration: duration,
					currentTime: this.currentVideo[0].currentTime
				};
			return this._trigger(this.events.paused, event, args);
		},

		_buffering: function (source, bufferedPercent, event) {
			/* fired when a video source has more buffered data. */
			var args = {
					source: source,
					buffered: bufferedPercent
				};
			return this._trigger(this.events.buffering, event, args);
		},

		_progress: function (source, currentTime, duration, event) {
			/* fired when video source has changed to a new position. */
			var args = {
					source: source,
					currentTime: currentTime,
					duration: duration
				};
			return this._trigger(this.events.progress, event, args);
		},

		_waiting: function (source, currentTime, duration, event) {
			/* fired when the video source is waiting for data, to be download from the server. */
			var args = {
					source: source,
					currentTime: currentTime,
					duration: duration
				};
			return this._trigger(this.events.waiting, event, args);
		},

		_bookmarkHit: function (source, bookmark, bookmarkElement, event) {
			/* fired when a bookmark was hit by the playback. */
			var args = {
					source: source,
					bookmark: bookmark,
					bookmarkElement: bookmarkElement
				};
			return this._trigger(this.events.bookmarkHit, event, args);
		},

		_bookmarkClick: function (bookmark, bookmarkElement, event) {
			/* fired when a bookmark has been clicked by the user. */
			var args = {
					bookmark: bookmark,
					bookmarkElement: bookmarkElement
				};
			return this._trigger(this.events.bookmarkClick, event, args);
		},

		_enterFullScreen: function (source) {
			/* fired when the control is entering full screen */
			var args = {
					source: source
				};
			return this._trigger(this.events.enterFullScreen, null, args);
		},

		_exitFullScreen: function (source) {
			/* fired when the control is exitting full screen */
			var args = {
					source: source
				};
			return this._trigger(this.events.exitFullScreen, null, args);
		},

		_bannerVisible: function (index, element) {
			/* fired when the control banner is shown */
			var args = {
					index: index,
					banner: this.options.banners[index],
					bannerElement: element
				};
			return this._trigger(this.events.bannerVisible, null, args);
		},

		_bannerHidden: function (index, element) {
			/* fired when the control banner is hidden */
			var args = {
					index: index,
					banner: this.options.banners[index],
					bannerElement: element
				};
			return this._trigger(this.events.bannerHidden, null, args);
		},

		_prepareForPlay: function () {
			var o = this.options,
				video = this.currentVideo;
			if ($('source', video).length === 0) {
				this._renderSources(o.sources, video);
			}
			if (!video.data('sourceDetected')) {
				this._analyzeSource(video);
			}
			this._hideTitleControls();
			if (o.relatedVideos && o.relatedVideos.length > 0) {
				$('#' + this._id('_rvcc')).hide();
			}
		},

		togglePlay: function () {
			/* Toggle control play state. If video is playing it will pause, if video is paused it will play. */
			var videoElem = this.currentVideo[0];

			this._prepareForPlay();
			this._toggleCenterPlayButton();

			if (videoElem.paused || videoElem.ended) {
				// K.D. June 3rd, 2011 Bug #75771 The title of the play/pause button has to be updated
				if (!this.options.browserControls) {
					$('#' + this._id('_ctrls_play')).attr('title', $.ig.VideoPlayer.locale.playing);
				}
				videoElem.play();
			} else {
				// K.D. June 3rd, 2011 Bug #75771 The title of the play/pause button has to be updated
				if (!this.options.browserControls) {
					$('#' + this._id('_ctrls_play')).attr('title', $.ig.VideoPlayer.locale.paused);
				}
				videoElem.pause();
			}
		},

		play: function () {
			/* Start playing current loaded video if any. */
			var videoElem = this.currentVideo[0];
			if (videoElem.paused || videoElem.ended) {
				this._prepareForPlay();
				this._toggleCenterPlayButton();
				// K.D. June 3rd, 2011 Bug #75771 The title of the play/pause button has to be updated
				if (!this.options.browserControls) {
					$('#' + this._id('_ctrls_play')).attr('title', $.ig.VideoPlayer.locale.playing);
				}
				videoElem.play();
			}
		},

		pause: function () {
			/* Pause the currently playing video if any. */
			var videoElem = this.currentVideo[0];
			if (!videoElem.paused) {
				this._toggleCenterPlayButton();
				// K.D. June 3rd, 2011 Bug #75771 The title of the play/pause button has to be updated
				if (!this.options.browserControls) {
					$('#' + this._id('_ctrls_play')).attr('title', $.ig.VideoPlayer.locale.paused);
				}
				videoElem.pause();
			}
		},

		currentTime: function (val) {
			/* Get or set the current time of the playing video.
				paramType="number" Specify the playback position in seconds to navigate to.
				returnType="number" Returns the current playback position.
			*/
			var videoElem = this.currentVideo[0],
				rawDuration = videoElem.duration;
			if (val !== null && val !== undefined) {
				try {
					videoElem.currentTime = val;
					$('#' + this._id('_ctrls_pb')).igProgressBar('option', 'value', (val / rawDuration).toFixed(2) * 100);
					this._checkCommercialsShow(val);
					this._checkEmbeddedCommercialShow(val);
				} catch (ex) {}

				if (videoElem.paused && !isNaN(rawDuration)) {
					/* adjust slider position because, timeupdate will not fire. */
					$('#' + this._id('_ctrls_s'))
						.igSlider('option', 'value', (val / rawDuration).toFixed(2) * 100);
				}
			}
			return parseInt(videoElem.currentTime, 10);
		},

		screenshot: function (scaleFactor) {
			/* Get a screenshot of the current video frame. It returns a canvas object that you can position and show on the page. This depends on the browser support for canvas.
				paramType="number" min="0.0" max="1.0" optional="true" Specify scale factor between 0 and 1.
				returnType="canvasType" Returns HTML5 canvas element that represents the captured screenshot. */
			if (!scaleFactor || $.type(scaleFactor) !== 'number') {
				scaleFactor = 1;
			}
			var videoElem = this.currentVideo[0],
				w = videoElem.videoWidth * scaleFactor,
				h = videoElem.videoHeight * scaleFactor,
				canvas = document.createElement('canvas'),
				ctx;
			if (canvas.getContext) {
				canvas.width  = w;
				canvas.height = h;
				ctx = canvas.getContext('2d');
				ctx.drawImage(videoElem, 0, 0, w, h);
			}
			return canvas;
		},

		supports_video: function () {
			/* Get whether the current browser supports video tag.
				returnType="bool" */
			return !!document.createElement('video').canPlayType;
		},

		supports_h264_baseline_video: function () {
			/* Get whether the current browser supports H.264 codec.
				returnType="bool" */
			if (!this.supports_video()) {
				return false;
			}
			var v = document.createElement("video");
			return v.canPlayType('video/mp4; codecs="avc1.42E01E, mp4a.40.2"') !== '';
		},

		supports_ogg_theora_video: function () {
			/* Get whether the current browser supports Theora codec.
				returnType="bool" */
			if (!this.supports_video()) {
				return false;
			}
			var v = document.createElement("video");
			return v.canPlayType('video/ogg; codecs="theora, vorbis"') !== '';
		},

		supports_webm_video: function () {
			/* Get whether the current browser supports WEBM codec. 
				returnType="bool" */
			if (!this.supports_video()) {
				return false;
			}
			var v = document.createElement("video");
			return v.canPlayType('video/webm; codecs="vp8, vorbis"') !== '';
		},

		paused: function () {
			/* Get whether the current played video is paused.
				returnType="bool" */
			return this.currentVideo[0].paused;
		},

		ended: function () {
			/* Get whether the current played video has ended.
				returnType="bool" */
			return this._getMainVideo()[0].ended;
		},

		duration: function () {
			/* Get the current duration of the played video. It may be NaN if duration is still not loaded or the video is a live stream. 
			returnType="number" */
			this._refreshDuration();
			return this._duration;
		},

		_refreshDuration: function () {
			var duration = this.currentVideo[0].duration;
			if (duration !== this._duration) {
				this._duration = duration;
				if (duration === Infinity) {
					this._updateTitleControlsTimeString($.ig.VideoPlayer.locale.live,
														$.ig.VideoPlayer.locale.liveStream);
					$('#' + this._id('_ctrls_s')).data('igSlider').handle.hide();
					$('#' + this._id('_ctrls_s')).igSlider('option', 'disabled', true);
				} else if (!isNaN(duration)) {
					if (this._commercialPlaying) {
						this._showAdMessage(parseInt(duration, 10));
					} else {
						this._updateTitleControlsTimeString(this._toTimeString(duration));
						// K.D. October 27th, 2011 Bug #83033 There is an issue with Firefox 3.6 with the duration
						// being 0 and updated later to the duration of the video so adding a check for duration
						// being greater than 0
						if (!this._bookmarksRendered && duration > 0) {
							this._renderBookmarks();
						}
					}
				}
			}
		},

		seeking: function () {
			/* Get whether the player is seeking to find the new playback position specified. 
			returnType="bool"  */
			return this.currentVideo[0].seeking;
		},

		destroy: function () {
			/* Destroys the widget. */
			var css = this.css;
			/* Clear any player specific settings from the element. */
			clearTimeout(this._scrollingTimoutId);
			clearTimeout(this._volumeSliderTimeoutId);
			clearTimeout(this._onVideoStateChangeId);
			clearTimeout(this._resizeBookmarkAreaTimeoutId);

			if (this._oldWidth) {
				this.element.css('width', this._oldWidth);
			}
			if (this._oldHeight) {
				this.element.css('height', this._oldHeight);
			}
			this.container.unbind(this._generalEvts);
			$(document).unbind(this._documentEvts);
			if (this._controlsEvts) {
				this.container.unbind(this._controlsEvts);
			}
			this.container.removeClass(css.baseClasses);

			$('#' + this._id('_ctrls_s')).igSlider('destroy');
			$('#' + this._id('_ctrls_pb')).igProgressBar('destroy');
			$('#' + this._id('_ctrls_vs')).igSlider('destroy');
			$('#' + this._id('_seek_tooltip')).igTooltip('destroy');

			if (this._commercialsShow) {
				delete this._commercialsShow;
				delete this._commercialIndex;
				delete this._commercialPlaying;
			}

			if (this._embeddedCommercialsShow) {
				delete this._embeddedCommercialPlaying;
				delete this._embeddedCommercialIndex;
				delete this._embeddedCommercialsShow;
			}

			delete this.bookmarkElements;
			delete this.relatedVideoElements;
			delete this.controlButtons;
			delete this._bannerShow;
			delete this.banner;

			// Will recursively call, unbind(), removeData() and remove() on all children!
			if (this.element.is('video')) {
				this.element.unbind(this._videoEvents);
				this.element.removeClass(css.videoClass);
				this._restoreExistingVideoProperties(this.element);
				$(':not(video)', this.container).remove();
				this.element.unwrap();
			} else {
				this.container.children().remove();
			}

			$.Widget.prototype.destroy.apply(this, arguments);
		},

		_destroyBookmarks: function () {
			if (this.bookmarkElements && this.bookmarkElements.length > 0) {
				this.bookmarkElements.unbind();
				this.bookmarkElements.removeData();
				delete this.bookmarkElements;
				$('#' + this._id('_bookmarks')).remove();
				$('#' + this._id('_ctrls_s')).igSlider('clearBookmarks');
				this._bookmarksRendered = false;
			}
		},

		_destroyRelatedVideos: function () {
			var related = this.options.relatedVideos;
			if (related && related.length > 0) {
				$('#' + this._id('_rvcc')).remove();
				delete this.relatedVideoElements;
				related = [];
			}
		},

		_destroyControls: function () {
			var controls = this.options.browserControls;
			if (!controls) {
				/* destroy child widgets */
				$('#' + this._id('_ctrls_play')).igButton('destroy');
				$('#' + this._id('_ctrls_vc_btn')).igButton('destroy');
				$('#' + this._id('_ctrls_fs_btn')).igButton('destroy');
				$('#' + this._id('_ctrls_pb')).igProgressBar('destroy');
				$('#' + this._id('_ctrls_s')).igSlider('destroy');
				$('#' + this._id('_ctrls_vs')).igSlider('destroy');
				/* destroy controls, calls unbind and removeData on all children recursively. */
				this.controls.each(function () {
					$(this).parent().remove();
				});
				delete this.controls;
				delete this.controlButtons;
				delete this._activeControlsIndex;
			}
		}
	});
	$.extend($.ui.igVideoPlayer, {version: '14.1.20141.2249'});
}(jQuery));


